(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     80749,       2594]
NotebookOptionsPosition[     64197,       2062]
NotebookOutlinePosition[     68068,       2172]
CellTagsIndexPosition[     67151,       2147]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PwM`Chap09Strings`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic",
  FontVariations->{"Underline"->True}]
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Name", ":", " ", "PwM`Chap09Strings`"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Book", ":", " ", 
    RowBox[{"Programming", " ", "with", " ", 
     RowBox[{"Mathematica", ":", " ", 
      RowBox[{"An", " ", "Introduction"}]}]}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "contains", " ", "the", " ", "functions", 
      " ", "defined", " ", "in", " ", "Chapter", " ", "9"}]}]}], ",", " ", 
   RowBox[{"Strings", "."}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "PwM`Chap09Strings`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Copyright", ":", " ", 
     RowBox[{"Copyright", " ", "2012"}]}]}], ",", " ", 
   RowBox[{"Cambridge", " ", "University", " ", "Press"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "checksum"}]}], ",", " ", "hash", ",", " ", 
   "anagram", ",", " ", "blanagram", ",", " ", "subsequence", ",", " ", 
   RowBox[{"gc", " ", "ratio"}], ",", " ", "palindrome", ",", " ", 
   RowBox[{"random", " ", "strings"}], ",", " ", 
   RowBox[{"padding", " ", "strings"}], ",", " ", 
   RowBox[{"DNA", " ", "sequence", " ", "table"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Chap09Strings", ".", "nb"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", 
     RowBox[{"8.0", ".4"}]}]}]}], " ", "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", "FindSubsequence", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<PwM`Chap09Strings`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AdlerChecksum", "::", "usage"}], "=", "\"\<AdlerChecksum[\!\(\*
StyleBox[\"expr\", \"TI\"]\)] returns the integer hash code for the \
expression \!\(\*
StyleBox[\"expr\", \"TI\"]\) using the Adler checksum algorithm.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Anagrams", "::", "usage"}], "=", "\"\<Anagrams[\!\(\*
StyleBox[\"word\", \"TI\"]\)] finds all anagrams of the string \!\(\*
StyleBox[\"word\", \"TI\"]\) in the dictionary.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Blanagrams", "::", "usage"}], "=", "\"\<Blanagrams[\!\(\*
StyleBox[\"word\", \"TI\"]\)] returns all blanagrams of \!\(\*
StyleBox[\"word\", \"TI\"]\) in the built-in dictionary.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BlockSize", "::", "usage"}], "=", 
   "\"\<BlockSize is an option to SequenceTable that specifies the size of \
the strings in each block.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FilterText", "::", "usage"}], "=", "\"\<FilterText[\!\(\*
StyleBox[\"str\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"lis\", \"TI\"]\)] removes all stops words given in the list \!\(\*
StyleBox[\"lis\", \"TI\"]\) from the string \!\(\*
StyleBox[\"str\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindSubsequence", "::", "usage"}], "=", "\"\<FindSubsequence[\!\(\*
StyleBox[\"num\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"subseq\", \"TI\"]\)] returns the starting and ending positions of \
the subsequence \!\(\*
StyleBox[\"subseq\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)in the number \!\(\*
StyleBox[\"num\", \"TI\"]\)\!\(\*
StyleBox[\".\", \"TI\"]\)\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindWordsContaining", "::", "usage"}], "=", 
   "\"\<FindWordsContaining[\!\(\*
StyleBox[\"str\", \"TI\"]\)] finds all words in the built-in dictionary that \
contain the string \!\(\*
StyleBox[\"str\", \"TI\"]\). The option WordPosition\[Rule]\!\(\*
StyleBox[\"pos\", \"TI\"]\) can be used to specify the position of \!\(\*
StyleBox[\"str\", \"TI\"]\). \!\(\*
StyleBox[\"pos\", \"TI\"]\) can be either \\\"Start\\\", \\\"Middle\\\", \
\\\"End\\\", or \\\"Anywhere\\\".\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GCRatio", "::", "usage"}], "=", "\"\<GCRatio[\!\(\*
StyleBox[\"str\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"blocksize\", \"TI\"]\)] computes the GC ratio in the string \!\(\*
StyleBox[\"str\", \"TI\"]\) for substrings of size \!\(\*
StyleBox[\"blocksize\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeVarList", "::", "usage"}], "=", "\"\<MakeVarList[\!\(\*
StyleBox[\"sym\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"n\", \"TI\"]\)] generates a list of \!\(\*
StyleBox[\"n\", \"TI\"]\) indexed symbols.\\nMakeVarList[\!\(\*
StyleBox[\"sym\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"{\", \"TI\"]\)\!\(\*
StyleBox[\"n\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\"m\", \"TI\"]\)\!\(\*
StyleBox[\"}\", \"TI\"]\)] generates a list of indexed symbols from \
\!\(\*SubscriptBox[
StyleBox[
StyleBox[\"sym\", \"TI\"],
FontWeight->\"Plain\"], 
StyleBox[\"n\", \"TI\"]]\) to \!\(\*SubscriptBox[
StyleBox[\"sym\", \"TI\"], 
StyleBox[\"m\", \"TI\"]]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrderedWordQ", "::", "usage"}], "=", "\"\<OrderedWordQ[\!\(\*
StyleBox[\"word\", \"TI\"]\)] returns True if the characters in \!\(\*
StyleBox[\"word\", \"TI\"]\) are ordered in the sense of their character \
codes.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PalindromeQ", "::", "usage"}], "=", "\"\<Palindrome[\!\(\*
StyleBox[\"expr\", \"TI\"]\)] returns True of \!\(\*
StyleBox[\"expr\", \"TI\"]\) is palindromic. The expression \!\(\*
StyleBox[\"expr\", \"TI\"]\) can be either a string or a number.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Palindromes", "::", "usage"}], "=", "\"\<Palindromes[[\!\(\*
StyleBox[\"n\", \"TI\"]\)] finds all palindromic words of length \!\(\*
StyleBox[\"n\", \"TI\"]\) in the built-in dictionary.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomString", "::", "usage"}], "=", "\"\<RandomString[\!\(\*
StyleBox[\"{\", \"TI\"]\)\!\(\*SubscriptBox[
StyleBox[\"c\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"c\", \"TI\"], \"2\"]\),\[Ellipsis],\!\(\*SubscriptBox[
StyleBox[\"c\", \"TI\"], \"n\"]\)}] generates a random string of length \
\!\(\*
StyleBox[\"n\", \"TI\"]\) from among the characters \!\(\*SubscriptBox[
StyleBox[\"c\", \"TI\"], \"i\"]\) chosen at random. The option Weights can be \
used to give weighted choices of the characters.\\nRandomString[\!\(\*
StyleBox[\"{\", \"TI\"]\)\!\(\*
StyleBox[\"list\", \"TI\"]\),{\!\(\*SubscriptBox[
StyleBox[\"n\", \"TI\"], 
StyleBox[\"1\", \"TR\"]]\),\!\(\*SubscriptBox[
StyleBox[\"n\", \"TI\"], 
StyleBox[\"2\", \"TR\"]]\),\!\(\*
StyleBox[\"\[Ellipsis]\", \"TR\"]\)}] generates an \!\(\*SubscriptBox[
StyleBox[\"n\", \"TI\"], 
StyleBox[\"1\", \"TR\"]]\)\[Times]\!\(\*SubscriptBox[
StyleBox[\"n\", \"TI\"], 
StyleBox[\"2\", \"TR\"]]\)\[Times]\[Ellipsis] array of random strings.\>\""}],
   ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomString", "::", "badwt"}], "=", 
   "\"\<The length of the list of weights must be the same as the length of \
the list of characters.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SequenceTable", "::", "usage"}], "=", "\"\<SequenceTable[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] returns a formatted table suitable for \
displaying gene sequences. SequenceTable inherits options from Grid.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPad", "::", "usage"}], "=", "\"\<StringPad[\!\(\*
StyleBox[\"str\", \"TI\"]\),\!\(\*
StyleBox[\"n\", \"TI\"]\)] pads string \!\(\*
StyleBox[\"str\", \"TI\"]\) out to length \!\(\*
StyleBox[\"n\", \"TI\"]\) with whitespace.\\nStringPad[\!\(\*
StyleBox[\"str\", \"TI\"]\),{\!\(\*
StyleBox[\"n\", \"TI\"]\)}] appends \!\(\*
StyleBox[\"n\", \"TI\"]\) whitespace characters to the end of \!\(\*
StyleBox[\"str\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPad", "::", "badlen"}], "=", 
   "\"\<Pad length `1` must be greater than the length of string `2`.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPartition", "::", "usage"}], "=", 
   "\"\<StringPartition[[\!\(\*
StyleBox[\"list\", \"TI\"]\),\!\(\*
StyleBox[\"n\", \"TI\"]\)] partitions \!\(\*
StyleBox[\"list\", \"TI\"]\) into non-overlapping sublists of strings of \
length \!\(\*
StyleBox[\"n\", \"TI\"]\). StringPartition has the same argument structure as \
Partition.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"stringRotateLeft", "::", "usage"}], "=", 
   "\"\<stringRotateLeft[\!\(\*
StyleBox[\"str\", \"TI\"]\)] rotates the string one character to the \
left.\\nstringRotateLeft[\!\(\*
StyleBox[\"str\", \"TI\"]\), \!\(\*
StyleBox[\"n\", \"TI\"]\)] rotates the string \!\(\*
StyleBox[\"str\", \"TI\"]\) \!\(\*
StyleBox[\"n\", \"TI\"]\) characters to the left.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UcLc", "::", "usage"}], "=", "\"\<UcLc[\!\(\*
StyleBox[\"str\", \"TI\"]\)] converts the first character in the string \
\!\(\*
StyleBox[\"str\", \"TI\"]\) to uppercase.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UniqueCharacters", "::", "usage"}], "=", 
   "\"\<UniqueCharacters[\!\(\*
StyleBox[\"str\", \"TI\"]\)] returns a list of unique characters in the \
string \!\(\*
StyleBox[\"str\", \"TI\"]\), deleting duplicates.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WordPosition", "::", "usage"}], "=", 
   "\"\<WordPosition is an option to FindWordsContaining that determines \
where the target string occurs. Possible values are \\\"Start\\\", \\\"Middle\
\\\", \\\"End\\\", or \\\"Anywhere\\\".\>\""}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "FindWordsContaining", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"WordPosition", "\[Rule]", "\"\<Start\>\""}], "}"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RandomString", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Weights", "\[Rule]", 
     RowBox[{"{", "}"}]}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SequenceTable", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"BlockSize", "\[Rule]", "10"}], "}"}], ",", 
     RowBox[{"Options", "[", "Grid", "]"}]}], "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdlerChecksum", "[", "str_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"codes", ",", "n", ",", "m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"codes", "=", 
      RowBox[{"ToCharacterCode", "[", "str", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"m", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Accumulate", "[", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "1", "}"}], ",", "codes"}], "]"}], "]"}], ",", 
        "65521"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"n", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Accumulate", "[", 
         RowBox[{"Rest", "[", "m", "]"}], "]"}], ",", "65521"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Last", "[", "m", "]"}], "+", 
      RowBox[{
       RowBox[{"Last", "[", "n", "]"}], " ", "65536"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "word", "]"}]}], ",", "words"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"\"\<\\\\w{\>\"", "<>", 
         RowBox[{"ToString", "[", "len", "]"}], "<>", "\"\<}\>\""}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{"words", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "#", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "word", "]"}], "]"}]}], "&"}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Blanagrams", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "blana", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"blana", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StringReplacePart", "[", 
            RowBox[{"word", ",", "ch", ",", 
             RowBox[{"{", 
              RowBox[{"#", ",", "#"}], "}"}]}], "]"}], "&"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"StringLength", "[", "word", "]"}], "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"ch", ",", 
          RowBox[{"CharacterRange", "[", 
           RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicates", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Map", "[", 
        RowBox[{"Anagrams", ",", "blana", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FilterText", "[", 
   RowBox[{"str_String", ",", "stopwords_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tmp", "=", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"str", ",", 
        RowBox[{
         RowBox[{"Characters", "[", "\"\<:,;.!? \>\"", "]"}], ".."}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "@", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"tmp", ",", 
        RowBox[{"WordBoundary", "~~", 
         RowBox[{"Apply", "[", 
          RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
         "WordBoundary"}], ",", 
        RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{
    RowBox[{"num_", "?", "NumberQ"}], ",", 
    RowBox[{"subseq_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"ToString", "[", "num", "]"}]}], ",", 
      RowBox[{"s", "=", 
       RowBox[{"ToString", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"StringPosition", "[", 
     RowBox[{
      RowBox[{"Part", "[", 
       RowBox[{
        RowBox[{"StringSplit", "[", 
         RowBox[{"n", ",", "\"\<.\>\""}], "]"}], ",", "2"}], "]"}], ",", 
      "s"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindWordsContaining", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wp", "=", 
      RowBox[{"OptionValue", "[", "WordPosition", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wp", "==", "\"\<Start\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<Middle\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.+\>\"", ",", "str", ",", "\"\<.+\\\\b\>\""}], 
         "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<End\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "\[Equal]", "\"\<Anywhere\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], 
         "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcRatio", "[", "ls_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"gc", ",", "at"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gc", "=", 
      RowBox[{"StringCount", "[", 
       RowBox[{"ls", ",", 
        RowBox[{"\"\<G\>\"", "|", "\"\<C\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"at", "=", 
      RowBox[{"StringCount", "[", 
       RowBox[{"ls", ",", 
        RowBox[{"\"\<A\>\"", "|", "\"\<T\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"N", "[", 
      RowBox[{"gc", "/", 
       RowBox[{"(", 
        RowBox[{"gc", "+", "at"}], ")"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GCRatio", "[", 
   RowBox[{"str_String", ",", "blocksize_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis", ",", "blocks"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lis", "=", 
      RowBox[{"StringPartition", "[", 
       RowBox[{"str", ",", "blocksize"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"blocks", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"i", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"StringLength", "[", "str", "]"}], ",", "blocksize"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"blocks", ",", 
        RowBox[{"Map", "[", 
         RowBox[{"gcRatio", ",", "lis"}], "]"}]}], "}"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GCRatio", "[", 
   RowBox[{
    RowBox[{"{", "str_String", "}"}], ",", "blocksize_Integer"}], "]"}], ":=", 
  RowBox[{"GCRatio", "[", 
   RowBox[{"str", ",", "blocksize"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeVarList", "[", 
   RowBox[{"x_Symbol", ",", "n_Integer"}], "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", 
       RowBox[{"ToString", "[", "#", "]"}]}], "&"}], ",", 
     RowBox[{"Range", "[", "n", "]"}]}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeVarList", "[", 
   RowBox[{"x_Symbol", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n_Integer", "?", "Positive"}], ",", 
      RowBox[{"m_Integer", "?", "Positive"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", 
       RowBox[{"ToString", "[", "#", "]"}]}], "&"}], ",", 
     RowBox[{"Range", "[", 
      RowBox[{"n", ",", "m"}], "]"}]}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrderedWordQ", "[", "word_String", "]"}], ":=", 
  RowBox[{"OrderedQ", "[", 
   RowBox[{"ToCharacterCode", "[", "word", "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "str_String", "]"}], ":=", 
  RowBox[{
   RowBox[{"StringReverse", "[", "str", "]"}], "==", "str"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "num_Integer", "]"}], ":=", 
  RowBox[{"PalindromeQ", "[", 
   RowBox[{"ToString", "[", "num", "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "len_Integer", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"w", "==", 
       RowBox[{"StringReverse", "[", "w", "]"}]}], " ", "&&", " ", 
      RowBox[{
       RowBox[{"StringLength", "[", "w", "]"}], "\[Equal]", "len"}]}], 
     ")"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{"w", "==", 
      RowBox[{"StringReverse", "[", "w", "]"}]}], " ", ")"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"n_Integer:", "1"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"{", "c", "}"}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"wts", "\[Rule]", 
          RowBox[{"{", "c", "}"}]}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "len_Integer"}], "}"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"{", "c", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"wts", "\[Rule]", 
           RowBox[{"{", "c", "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.524665480351028*^9, 3.524665487450761*^9}, {
  3.524665582184537*^9, 3.524665740698756*^9}, {3.524665864068852*^9, 
  3.524665869803155*^9}, {3.524665943400193*^9, 3.5246659563119383`*^9}, {
  3.524666140682979*^9, 3.524666145392123*^9}, {3.524666187071706*^9, 
  3.524666188487198*^9}, {3.524666285132325*^9, 3.524666325461466*^9}, {
  3.524666502948704*^9, 3.524666507196312*^9}, {3.524666741932231*^9, 
  3.524666747124289*^9}, {3.524700956720539*^9, 3.52470096084039*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SequenceTable", "[", 
   RowBox[{"lis_String", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"OptionValue", "[", "BlockSize", "]"}]}], ",", 
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "lis", "]"}]}], ",", 
      RowBox[{"rowlength", "=", "5"}], ",", "str", ",", "blocks", ",", 
      "ind"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"str", "=", 
      RowBox[{"StringPartition", "[", 
       RowBox[{"lis", ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"blocks", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"str", ",", "5", ",", "5", ",", "1", ",", "\"\< \>\""}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ind", "=", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Range", "[", "len", "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"#", ",", 
            RowBox[{"rowlength", "*", "n"}]}], "]"}], "\[Equal]", "1"}], 
         "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"blocks", ",", "ind"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", " ", 
         RowBox[{"Options", "[", "Grid", "]"}]}], "]"}], ",", 
       RowBox[{"Alignment", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Right", ",", 
            RowBox[{"{", "Left", "}"}]}], "}"}], ",", "Automatic"}], "}"}]}], 
       ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Dividers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"True", ",", "False"}], "}"}], ",", "All"}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{"StringLength", "[", "str", "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"len", ">", "n"}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ",", "n", ",",
         "str"}], "]"}], ",", 
      RowBox[{"StringPad", "[", 
       RowBox[{"str", ",", 
        RowBox[{"{", 
         RowBox[{"n", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}], ",", "str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "m", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPartition", "[", 
   RowBox[{"str_String", ",", "seq__"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "seq"}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPartition", "[", 
   RowBox[{"str_String", ",", "blocksize_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "blocksize", ",", 
      "blocksize", ",", "1", ",", 
      RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringRotateLeft", "[", 
   RowBox[{"str_", ",", 
    RowBox[{"n_:", "1"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"RotateLeft", "[", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], ",", "n"}], "]"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UcLc", "[", "word_String", "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"word", ",", 
    RowBox[{
     RowBox[{"RegularExpression", "[", "\"\<(.)([a-z]+)\>\"", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"ToUpperCase", "[", "\"\<$1\>\"", "]"}], "~~", 
      "\"\<$2\>\""}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UniqueCharacters", "[", "str_String", "]"}], ":=", 
  RowBox[{"DeleteDuplicates", "[", 
   RowBox[{"Characters", "[", "str", "]"}], "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End Private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell[BoxData["Quit"], "Input"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "PWM`Chap09Strings`"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AdlerChecksum"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"AdlerChecksum[\\!\\(\\*\\nStyleBox[\\\"expr\\\", \
\\\"TI\\\"]\\)] returns the integer hash code for the expression \
\\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) using the Adler checksum \
algorithm.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706972-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Anagrams"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Anagrams[\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\)] \
finds all anagrams of the string \\!\\(\\*\\nStyleBox[\\\"word\\\", \
\\\"TI\\\"]\\) in the dictionary.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706975-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Blanagrams"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Blanagrams[\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\)] \
returns all blanagrams of \\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\) \
in the built-in dictionary.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706978-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlockSize"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"BlockSize is an option to SequenceTable that specifies the \
size of the strings in each block.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707101-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FilterText"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FilterText[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\
\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"lis\\\", \\\"TI\\\"]\\)] removes all \
stops words given in the list \\!\\(\\*\\nStyleBox[\\\"lis\\\", \
\\\"TI\\\"]\\) from the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707107-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FindSubsequence"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FindSubsequence[\\!\\(\\*\\nStyleBox[\\\"num\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"subseq\\\", \\\"TI\\\"]\\)] returns \
the starting and ending positions of the subsequence \
\\!\\(\\*\\nStyleBox[\\\"subseq\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \
\\\", \\\"TI\\\"]\\)in the number \\!\\(\\*\\nStyleBox[\\\"num\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\".\\\", \\\"TI\\\"]\\)\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707110-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FindWordsContaining"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FindWordsContaining[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\
\"]\\)] finds all words in the built-in dictionary that contain the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\). The option WordPosition\
\[Rule]\\!\\(\\*\\nStyleBox[\\\"pos\\\", \\\"TI\\\"]\\) can be used to \
specify the position of \\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\). \\!\
\\(\\*\\nStyleBox[\\\"pos\\\", \\\"TI\\\"]\\) can be either \\\"Start\\\", \\\
\"Middle\\\", \\\"End\\\", or \\\"Anywhere\\\".\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707113-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GCRatio"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"GCRatio[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)\\!\\(\
\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"blocksize\\\", \\\"TI\\\"]\\)] \
computes the GC ratio in the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\) for substrings of size \\!\\(\\*\\nStyleBox[\\\"blocksize\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707120-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MakeVarList"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"MakeVarList[\\!\\(\\*\\nStyleBox[\\\"sym\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] generates a \
list of \\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) indexed \
symbols.\\nMakeVarList[\\!\\(\\*\\nStyleBox[\\\"sym\\\", \\\"TI\\\"]\\)\\!\\(\
\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"{\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"m\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"}\\\", \\\"TI\\\"]\\)] generates a \
list of indexed symbols from \\!\\(\\*SubscriptBox[\\nStyleBox[\\nStyleBox[\\\
\"sym\\\", \\\"TI\\\"],\\nFontWeight->\\\"Plain\\\"], \\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]]\\) to \\!\\(\\*SubscriptBox[\\nStyleBox[\\\"sym\\\", \
\\\"TI\\\"], \\nStyleBox[\\\"m\\\", \\\"TI\\\"]]\\).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707126-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "OrderedWordQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"OrderedWordQ[\\!\\(\\*\\nStyleBox[\\\"word\\\", \
\\\"TI\\\"]\\)] returns True if the characters in \
\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\) are ordered in the sense of \
their character codes.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707129-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PalindromeQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Palindrome[\\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True of \\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is \
palindromic. The expression \\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) \
can be either a string or a number.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707132-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Palindromes"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Palindromes[[\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] \
finds all palindromic words of length \\!\\(\\*\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]\\) in the built-in dictionary.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707136-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RandomString"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"RandomString[\\!\\(\\*\\nStyleBox[\\\"{\\\", \\\"TI\\\"]\\)\\!\
\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \
\\(2\\)]\\),\[Ellipsis],\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\
\"], \\(n\\)]\\)}] generates a random string of length \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) from among the characters \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \\(i\\)]\\) chosen \
at random. The option Weights can be used to give weighted choices of the \
characters.\\nRandomString[\\!\\(\\*\\nStyleBox[\\\"{\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"list\\\", \
\\\"TI\\\"]\\),{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \
\\nStyleBox[\\\"1\\\", \
\\\"TR\\\"]]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \
\\nStyleBox[\\\"2\\\", \\\"TR\\\"]]\\),\\!\\(\\*\\nStyleBox[\\\"\[Ellipsis]\\\
\", \\\"TR\\\"]\\)}] generates an \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \\nStyleBox[\\\"1\\\
\", \\\"TR\\\"]]\\)\[Times]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"], \\nStyleBox[\\\"2\\\", \\\"TR\\\"]]\\)\[Times]\[Ellipsis] array \
of random strings.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707139-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SequenceTable"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"SequenceTable[\\!\\(\\*\\nStyleBox[\\\"lis\\\", \
\\\"TI\\\"]\\)] returns a formatted table suitable for displaying gene \
sequences. SequenceTable inherits options from Grid.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707143-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StringPad"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StringPad[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\),\\!\
\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] pads string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\) out to length \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) with \
whitespace.\\nStringPad[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\),{\\!\
\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)}] appends \\!\\(\\*\\nStyleBox[\\\
\"n\\\", \\\"TI\\\"]\\) whitespace characters to the end of \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707145-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StringPartition"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StringPartition[[\\!\\(\\*\\nStyleBox[\\\"list\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] partitions \\!\
\\(\\*\\nStyleBox[\\\"list\\\", \\\"TI\\\"]\\) into non-overlapping sublists \
of strings of length \\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\). \
StringPartition has the same argument structure as Partition.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707148-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "stringRotateLeft"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StringRotateLeft[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\
\\)] rotates the string one character to the \
left.\\nStringRotateLeft[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] rotates the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\) \\!\\(\\*\\nStyleBox[\\\"n\\\
\", \\\"TI\\\"]\\) characters to the left.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563708525-8207676"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "UcLc"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"UcLc[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)] \
converts the first character in the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\) to uppercase.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707151-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "UniqueCharacters"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"UniqueCharacters[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\
\\)] returns a list of unique characters in the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\), deleting duplicates.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707154-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "WordPosition"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"WordPosition is an option to FindWordsContaining that \
determines where the target string occurs. Possible values are \\\"Start\\\", \
\\\"Middle\\\", \\\"End\\\", or \\\"Anywhere\\\".\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707264-2531470"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["AdlerChecksum", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AdlerChecksum", "[", "\"\<Mathematica\>\"", "]"}]], "Input"],

Cell[BoxData["434111583"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Hash", "[", 
  RowBox[{"\"\<Mathematica\>\"", ",", "\"\<Adler32\>\""}], "]"}]], "Input"],

Cell[BoxData["434111583"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Anagrams", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Anagrams", "[", "\"\<parsley\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"parleys\"\>", ",", "\<\"parsley\"\>", ",", "\<\"players\"\>", 
   ",", "\<\"replays\"\>", ",", "\<\"sparely\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Blanagrams", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Blanagrams", "[", "\"\<zydeco\>\"", "]"}], "//", 
  "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.632435000000001`", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"zydeco\"\>", ",", "\<\"cloyed\"\>", ",", "\<\"comedy\"\>", 
     ",", "\<\"decoys\"\>"}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["BlockSize", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", 
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\"\<C\>\"", ",", "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<G\>\""}], 
     "}"}], ",", "178"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"\
GCAAGCTTGGGCCAGGTGCACCGTTAAACTCTTACGAATGTAGAAGCCTGACTTCGGTCGGGCATGCGACCTTCTAGT\
GATACACTGCTTATGATGAATCACATTCCGTCCGTGCGACCCCCGGAACGCGAGGGAGCGAACATTGCTCTGGCTAAT\
CTTTAGGGGGCGTCACGCGGGA\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", 
  RowBox[{"str", ",", 
   RowBox[{"BlockSize", "\[Rule]", "12"}], ",", 
   RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"FontSize", "\[Rule]", "8"}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"GCAAGCTTGGGC\"\>", "\<\"CAGGTGCACCGT\"\>", "\<\"TAAACTCTTACG\"\
\>", "\<\"AATGTAGAAGCC\"\>", "\<\"TGACTTCGGTCG\"\>"},
    {"61", "\<\"GGCATGCGACCT\"\>", "\<\"TCTAGTGATACA\"\>", \
"\<\"CTGCTTATGATG\"\>", "\<\"AATCACATTCCG\"\>", "\<\"TCCGTGCGACCC\"\>"},
    {"121", "\<\"CCGGAACGCGAG\"\>", "\<\"GGAGCGAACATT\"\>", "\<\"GCTCTGGCTAAT\
\"\>", "\<\"CTTTAGGGGGCG\"\>", "\<\"TCACGCGGGA\"\>"}
   },
   AutoDelete->False,
   BaseStyle->Directive[FontSize -> 8],
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FilterText", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$BaseDirectory", ",", "\"\<Applications\>\"", ",", "\"\<PwM\>\"", ",", 
     "\"\<Data\>\"", ",", "\"\<StopWords.dat\>\""}], "}"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"/Library/Mathematica/Applications/PwM/Data/StopWords.dat\"\>\
"], "Output"]
}, Closed]],

Cell[BoxData[
 RowBox[{"stopwords", "=", 
  RowBox[{"Rest", "@", 
   RowBox[{"Import", "[", 
    RowBox[{"file", ",", "\"\<List\>\""}], "]"}]}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterText", "[", 
  RowBox[{"\"\<What is the meaning of life?\>\"", ",", "stopwords"}], 
  "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"meaning\"\>", ",", "\<\"life\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FindSubsequence", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pidigs", "=", 
   RowBox[{"N", "[", 
    RowBox[{"\[Pi]", ",", 
     SuperscriptBox["10", "7"]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"pidigs", ",", "314159"}], "]"}], "//", "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.315388999999996`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"176451", ",", "176456"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1259351", ",", "1259356"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1761051", ",", "1761056"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6467324", ",", "6467329"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6518294", ",", "6518299"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9753731", ",", "9753736"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9973760", ",", "9973765"}], "}"}]}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FindWordsContaining", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<Anywhere\>\""}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"cited\"\>", ",", "\<\"cites\"\>", ",", "\<\"elicited\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"excited\"\>", ",", "\<\"excitedly\"\>", 
   ",", "\<\"excitement\"\>", ",", "\<\"excitements\"\>", 
   ",", "\<\"exciter\"\>", ",", "\<\"exciters\"\>", ",", "\<\"excites\"\>", 
   ",", "\<\"incite\"\>", ",", "\<\"incited\"\>", ",", "\<\"incitement\"\>", 
   ",", "\<\"incitements\"\>", ",", "\<\"inciter\"\>", 
   ",", "\<\"inciters\"\>", ",", "\<\"incites\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"Lucites\"\>", ",", "\<\"overexcite\"\>", 
   ",", "\<\"overexcited\"\>", ",", "\<\"overexcites\"\>", 
   ",", "\<\"plebiscite\"\>", ",", "\<\"plebiscites\"\>", 
   ",", "\<\"recite\"\>", ",", "\<\"recited\"\>", ",", "\<\"reciter\"\>", 
   ",", "\<\"reciters\"\>", ",", "\<\"recites\"\>", ",", "\<\"solicited\"\>", 
   ",", "\<\"unexcited\"\>", ",", "\<\"unsolicited\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GCRatio", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hsMito", "=", 
   RowBox[{"Import", "[", "\"\<ExampleData/mitochondrion.fa.gz\>\"", "]"}]}], 
  ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GCRatio", "[", 
  RowBox[{"hsMito", ",", "1000"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0.46`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1001", ",", "0.441`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2001", ",", "0.43`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3001", ",", "0.478`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4001", ",", "0.427`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5001", ",", "0.439`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6001", ",", "0.474`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7001", ",", "0.438`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8001", ",", "0.434`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9001", ",", "0.461`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10001", ",", "0.396`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11001", ",", "0.448`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12001", ",", "0.429`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13001", ",", "0.471`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14001", ",", "0.435`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15001", ",", "0.446`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"16001", ",", "0.46409807355516636`"}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MakeVarList", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeVarList", "[", 
  RowBox[{"tmp", ",", "6"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6"}], 
  "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeVarList", "[", 
  RowBox[{"tmp", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "8"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"tmp4", ",", "tmp5", ",", "tmp6", ",", "tmp7", ",", "tmp8"}], 
  "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OrderedWordQ", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OrderedWordQ", "[", "\"\<best\>\"", "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PalindromeQ", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<mood\>\"", "]"}]], "Input"],

Cell[BoxData["False"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<kayak\>\"", "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Select", "[", 
  RowBox[{"words", ",", "PalindromeQ"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aha\"\>", ",", "\<\"aka\"\>", 
   ",", "\<\"bib\"\>", ",", "\<\"bob\"\>", ",", "\<\"boob\"\>", 
   ",", "\<\"bub\"\>", ",", "\<\"CFC\"\>", ",", "\<\"civic\"\>", 
   ",", "\<\"dad\"\>", ",", "\<\"deed\"\>", ",", "\<\"deified\"\>", 
   ",", "\<\"did\"\>", ",", "\<\"dud\"\>", ",", "\<\"DVD\"\>", 
   ",", "\<\"eke\"\>", ",", "\<\"ere\"\>", ",", "\<\"eve\"\>", 
   ",", "\<\"ewe\"\>", ",", "\<\"eye\"\>", ",", "\<\"gag\"\>", 
   ",", "\<\"gig\"\>", ",", "\<\"huh\"\>", ",", "\<\"I\"\>", 
   ",", "\<\"kayak\"\>", ",", "\<\"kook\"\>", ",", "\<\"level\"\>", 
   ",", "\<\"ma'am\"\>", ",", "\<\"madam\"\>", ",", "\<\"mam\"\>", 
   ",", "\<\"MGM\"\>", ",", "\<\"minim\"\>", ",", "\<\"mom\"\>", 
   ",", "\<\"mum\"\>", ",", "\<\"nan\"\>", ",", "\<\"non\"\>", 
   ",", "\<\"noon\"\>", ",", "\<\"nun\"\>", ",", "\<\"oho\"\>", 
   ",", "\<\"pap\"\>", ",", "\<\"peep\"\>", ",", "\<\"pep\"\>", 
   ",", "\<\"pip\"\>", ",", "\<\"poop\"\>", ",", "\<\"pop\"\>", 
   ",", "\<\"pup\"\>", ",", "\<\"radar\"\>", ",", "\<\"redder\"\>", 
   ",", "\<\"refer\"\>", ",", "\<\"repaper\"\>", ",", "\<\"reviver\"\>", 
   ",", "\<\"rotor\"\>", ",", "\<\"sagas\"\>", ",", "\<\"sees\"\>", 
   ",", "\<\"seres\"\>", ",", "\<\"sexes\"\>", ",", "\<\"shahs\"\>", 
   ",", "\<\"sis\"\>", ",", "\<\"solos\"\>", ",", "\<\"SOS\"\>", 
   ",", "\<\"stats\"\>", ",", "\<\"stets\"\>", ",", "\<\"tat\"\>", 
   ",", "\<\"tenet\"\>", ",", "\<\"TNT\"\>", ",", "\<\"toot\"\>", 
   ",", "\<\"tot\"\>", ",", "\<\"tut\"\>", ",", "\<\"wow\"\>", 
   ",", "\<\"WWW\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Palindromes", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Palindromes", "[", "7", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomString", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], 
  "]"}]], "Input"],

Cell[BoxData["\<\"C\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   "10"}], "]"}]], "Input"],

Cell[BoxData["\<\"TCTTACACAT\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AATATATTCC\"\>", ",", "\<\"AAACAACCCT\"\>", 
   ",", "\<\"CCATAACCTA\"\>", ",", "\<\"TCCCATCCTT\"\>"}], "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7", ",", ".1"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TCAACCACCT\"\>", ",", "\<\"TCCCTTCCCA\"\>", 
   ",", "\<\"CTAAATCCCC\"\>", ",", "\<\"CCATCCCCAT\"\>"}], "}"}]], "Output"]
}, Closed]],

Cell[RawData["Cell[\"Check bad input:\", \"Text\"]"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"RandomString", "::", "badwt"}], "MessageName"], ":", 
  " ", "\<\"The length of the list of weights must be the same as the length \
of the list of characters.\"\>"}]], "Message", "MSG"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SequenceTable", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", 
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\"\<C\>\"", ",", "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<G\>\""}], 
     "}"}], ",", "178"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"\
TGGCGGGGGACTCCTCTCTGCGAGATAAATCGAGTCGCCATCTGGGAGGAGAGATAGGCTCTGCTTCCGGACGCGGTT\
TCGTACTCCAACGGGTGTAACTACGGGCGTGAATGGCAGGTCGCCAAACGCATTTCTGGCGAGCTAACTGGAATCGCG\
TTTGCATGCCACGCCTTCCAAC\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", "str", "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"TGGCGGGGGA\"\>", "\<\"CTCCTCTCTG\"\>", "\<\"CGAGATAAAT\"\>", "\
\<\"CGAGTCGCCA\"\>", "\<\"TCTGGGAGGA\"\>"},
    {"51", "\<\"GAGATAGGCT\"\>", "\<\"CTGCTTCCGG\"\>", "\<\"ACGCGGTTTC\"\>", \
"\<\"GTACTCCAAC\"\>", "\<\"GGGTGTAACT\"\>"},
    {"101", "\<\"ACGGGCGTGA\"\>", "\<\"ATGGCAGGTC\"\>", "\<\"GCCAAACGCA\"\>", \
"\<\"TTTCTGGCGA\"\>", "\<\"GCTAACTGGA\"\>"},
    {"151", "\<\"ATCGCGTTTG\"\>", "\<\"CATGCCACGC\"\>", "\<\"CTTCCAAC\"\>", "\
\<\" \"\>", "\<\" \"\>"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", 
  RowBox[{"str", ",", 
   RowBox[{"BlockSize", "\[Rule]", "12"}], ",", 
   RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"FontSize", "\[Rule]", "8"}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"TGGCGGGGGACT\"\>", "\<\"CCTCTCTGCGAG\"\>", "\<\"ATAAATCGAGTC\"\
\>", "\<\"GCCATCTGGGAG\"\>", "\<\"GAGAGATAGGCT\"\>"},
    {"61", "\<\"CTGCTTCCGGAC\"\>", "\<\"GCGGTTTCGTAC\"\>", \
"\<\"TCCAACGGGTGT\"\>", "\<\"AACTACGGGCGT\"\>", "\<\"GAATGGCAGGTC\"\>"},
    {"121", "\<\"GCCAAACGCATT\"\>", "\<\"TCTGGCGAGCTA\"\>", "\<\"ACTGGAATCGCG\
\"\>", "\<\"TTTGCATGCCAC\"\>", "\<\"GCCTTCCAAC\"\>"}
   },
   AutoDelete->False,
   BaseStyle->Directive[FontSize -> 8],
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["StringPad", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "8"}], "]"}], "//", "FullForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<ciao    \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "5", ",", "5"}], "]"}], "//", 
  "FullForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<     ciao     \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "3"}], "]"}], "//", "FullForm"}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ":", 
  " ", "\<\"Pad length \[NoBreak]\\!\\(3\\)\[NoBreak] must be greater than \
the length of string \[NoBreak]\\!\\(\\\"ciao\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG"],

Cell[BoxData[
 TagBox[
  StyleBox["Null",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["StringPartition", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", 
   RowBox[{"GenomeData", "[", "\"\<IGHVII671\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"StringPartition", "[", 
  RowBox[{"str", ",", "12"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ATGTCCTATTCA\"\>", ",", "\<\"GGAGCAGCTACA\"\>", 
   ",", "\<\"GCAGTCATGCCT\"\>", ",", "\<\"AGGTGTGAAGAT\"\>", 
   ",", "\<\"CACACACTGACC\"\>", ",", "\<\"TCACCCATGCTG\"\>", 
   ",", "\<\"TCTCTGGCCACT\"\>", ",", "\<\"TCATCACAACCA\"\>", 
   ",", "\<\"ATGCTTAATATT\"\>", ",", "\<\"GGACGTGGATCT\"\>", 
   ",", "\<\"GCCAGTCCCCGG\"\>", ",", "\<\"GGAATGGGTTGA\"\>", 
   ",", "\<\"ATGGAT\"\>"}], "}"}]], "Output"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomString", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\""}], 
      "}"}], ",", 
     SuperscriptBox["10", "2"]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringPartition", "[", 
  RowBox[{"data", ",", "10"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"CCCCTCCAGT\"\>", ",", "\<\"GTCATAGCAC\"\>", 
   ",", "\<\"AGGGATCCGG\"\>", ",", "\<\"CCACAGGCCC\"\>", 
   ",", "\<\"TGCGGGGCTA\"\>", ",", "\<\"GCTGCAGGAA\"\>", 
   ",", "\<\"TTCTACAAAA\"\>", ",", "\<\"TGGGCTCTAG\"\>", 
   ",", "\<\"CACAGGGCTG\"\>", ",", "\<\"TTGCACCATG\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["stringRotateLeft", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringRotateLeft", "[", 
  RowBox[{"\"\<three quarks for Muster Mark \>\"", ",", "12"}], 
  "]"}]], "Input"],

Cell[BoxData["\<\" for Muster Mark three quarks\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["UcLc", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UcLc", "[", "\"\<ciao\>\"", "]"}]], "Input"],

Cell[BoxData["\<\"Ciao\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["UniqueCharacters", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UniqueCharacters", "[", "\"\<Mississippi\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"M\"\>", ",", "\<\"i\"\>", ",", "\<\"s\"\>", ",", "\<\"p\"\>"}],
   "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["WordPosition", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<End\>\""}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"incite\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"overexcite\"\>", ",", "\<\"plebiscite\"\>", 
   ",", "\<\"recite\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{935, 929},
WindowMargins->{{Automatic, 436}, {Automatic, 17}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3563706972-2531470"->{
  Cell[32672, 1025, 309, 5, 118, "Print",
   CellTags->"Info3563706972-2531470"]},
 "Info3563706975-2531470"->{
  Cell[33072, 1038, 269, 4, 118, "Print",
   CellTags->"Info3563706975-2531470"]},
 "Info3563706978-2531470"->{
  Cell[33434, 1050, 273, 4, 118, "Print",
   CellTags->"Info3563706978-2531470"]},
 "Info3563707101-2531470"->{
  Cell[33799, 1062, 199, 3, 118, "Print",
   CellTags->"Info3563707101-2531470"]},
 "Info3563707107-2531470"->{
  Cell[34091, 1073, 471, 7, 118, "Print",
   CellTags->"Info3563707107-2531470"]},
 "Info3563707110-2531470"->{
  Cell[34660, 1088, 596, 10, 118, "Print",
   CellTags->"Info3563707110-2531470"]},
 "Info3563707113-2531470"->{
  Cell[35358, 1106, 600, 9, 218, "Print",
   CellTags->"Info3563707113-2531470"]},
 "Info3563707120-2531470"->{
  Cell[36048, 1123, 481, 7, 118, "Print",
   CellTags->"Info3563707120-2531470"]},
 "Info3563707126-2531470"->{
  Cell[36623, 1138, 1090, 18, 175, "Print",
   CellTags->"Info3563707126-2531470"]},
 "Info3563707129-2531470"->{
  Cell[37808, 1164, 308, 5, 118, "Print",
   CellTags->"Info3563707129-2531470"]},
 "Info3563707132-2531470"->{
  Cell[38210, 1177, 354, 5, 118, "Print",
   CellTags->"Info3563707132-2531470"]},
 "Info3563707136-2531470"->{
  Cell[38658, 1190, 283, 5, 118, "Print",
   CellTags->"Info3563707136-2531470"]},
 "Info3563707139-2531470"->{
  Cell[39036, 1203, 1317, 20, 222, "Print",
   CellTags->"Info3563707139-2531470"]},
 "Info3563707143-2531470"->{
  Cell[40449, 1231, 281, 5, 168, "Print",
   CellTags->"Info3563707143-2531470"]},
 "Info3563707145-2531470"->{
  Cell[40822, 1244, 617, 10, 168, "Print",
   CellTags->"Info3563707145-2531470"]},
 "Info3563707148-2531470"->{
  Cell[41537, 1262, 451, 7, 168, "Print",
   CellTags->"Info3563707148-2531470"]},
 "Info3563708525-8207676"->{
  Cell[42087, 1277, 484, 8, 168, "Print",
   CellTags->"Info3563708525-8207676"]},
 "Info3563707151-2531470"->{
  Cell[42658, 1293, 268, 4, 118, "Print",
   CellTags->"Info3563707151-2531470"]},
 "Info3563707154-2531470"->{
  Cell[43025, 1305, 298, 5, 118, "Print",
   CellTags->"Info3563707154-2531470"]},
 "Info3563707264-2531470"->{
  Cell[43418, 1318, 291, 5, 168, "Print",
   CellTags->"Info3563707264-2531470"]},
 "9.4 Solutions"->{
  Cell[47286, 1460, 184, 5, 78, "Input",
   CellTags->"9.4 Solutions"],
  Cell[47495, 1469, 160, 4, 78, "Input",
   CellTags->"9.4 Solutions"],
  Cell[47658, 1475, 126, 3, 78, "Output",
   CellTags->"9.4 Solutions"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3563706972-2531470", 64673, 2077},
 {"Info3563706975-2531470", 64785, 2080},
 {"Info3563706978-2531470", 64897, 2083},
 {"Info3563707101-2531470", 65009, 2086},
 {"Info3563707107-2531470", 65121, 2089},
 {"Info3563707110-2531470", 65233, 2092},
 {"Info3563707113-2531470", 65346, 2095},
 {"Info3563707120-2531470", 65458, 2098},
 {"Info3563707126-2531470", 65570, 2101},
 {"Info3563707129-2531470", 65684, 2104},
 {"Info3563707132-2531470", 65796, 2107},
 {"Info3563707136-2531470", 65908, 2110},
 {"Info3563707139-2531470", 66020, 2113},
 {"Info3563707143-2531470", 66134, 2116},
 {"Info3563707145-2531470", 66246, 2119},
 {"Info3563707148-2531470", 66359, 2122},
 {"Info3563708525-8207676", 66471, 2125},
 {"Info3563707151-2531470", 66583, 2128},
 {"Info3563707154-2531470", 66695, 2131},
 {"Info3563707264-2531470", 66807, 2134},
 {"9.4 Solutions", 66910, 2137}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 65, 1, 100, "Section",
 InitializationGroup->True],
Cell[490, 18, 398, 13, 37, "Text"],
Cell[CellGroupData[{
Cell[913, 35, 30, 0, 54, "Subsection"],
Cell[946, 37, 128, 3, 51, "Input"],
Cell[1077, 42, 239, 6, 51, "Input"],
Cell[1319, 50, 146, 4, 51, "Input"],
Cell[1468, 56, 317, 8, 82, "Input"],
Cell[1788, 66, 134, 4, 51, "Input"],
Cell[1925, 72, 147, 4, 51, "Input"],
Cell[2075, 78, 241, 7, 51, "Input"],
Cell[2319, 87, 256, 8, 51, "Input"],
Cell[2578, 97, 459, 9, 112, "Input"],
Cell[3040, 108, 151, 4, 51, "Input"],
Cell[3194, 114, 173, 5, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3404, 124, 34, 0, 43, "Subsection"],
Cell[3441, 126, 73, 1, 78, "Input"],
Cell[3517, 129, 90, 1, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3644, 135, 36, 0, 43, "Subsection"],
Cell[3683, 137, 291, 7, 78, "Input"],
Cell[3977, 146, 243, 5, 57, "Input"],
Cell[4223, 153, 252, 6, 57, "Input"],
Cell[4478, 161, 210, 5, 78, "Input"],
Cell[4691, 168, 385, 9, 78, "Input"],
Cell[5079, 179, 482, 12, 78, "Input"],
Cell[5564, 193, 541, 11, 120, "Input"],
Cell[6108, 206, 392, 9, 78, "Input"],
Cell[6503, 217, 831, 23, 79, "Input"],
Cell[7337, 242, 286, 6, 78, "Input"],
Cell[7626, 250, 318, 7, 78, "Input"],
Cell[7947, 259, 258, 5, 78, "Input"],
Cell[8208, 266, 1068, 23, 141, "Input"],
Cell[9279, 291, 211, 5, 78, "Input"],
Cell[9493, 298, 277, 6, 78, "Input"],
Cell[9773, 306, 496, 11, 99, "Input"],
Cell[10272, 319, 180, 5, 57, "Input"],
Cell[10455, 326, 405, 10, 99, "Input"],
Cell[10863, 338, 422, 10, 99, "Input"],
Cell[11288, 350, 240, 6, 57, "Input"],
Cell[11531, 358, 283, 7, 78, "Input"],
Cell[11817, 367, 303, 6, 99, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12157, 378, 29, 0, 54, "Subsection"],
Cell[12189, 380, 201, 6, 78, "Input"],
Cell[12393, 388, 195, 6, 78, "Input"],
Cell[12591, 396, 279, 8, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[12907, 409, 43, 0, 43, "Subsection"],
Cell[12953, 411, 92, 2, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[13082, 418, 42, 0, 43, "Subsection"],
Cell[13127, 420, 1025, 29, 176, "Input"],
Cell[14155, 451, 924, 25, 123, "Input"],
Cell[15082, 478, 1144, 30, 176, "Input"],
Cell[16229, 510, 829, 22, 150, "Input"],
Cell[17061, 534, 708, 21, 123, "Input"],
Cell[17772, 557, 1638, 37, 333, "Input"],
Cell[19413, 596, 749, 22, 152, "Input"],
Cell[20165, 620, 905, 24, 150, "Input"],
Cell[21073, 646, 226, 6, 45, "Input"],
Cell[21302, 654, 386, 11, 71, "Input"],
Cell[21691, 667, 540, 16, 71, "Input"],
Cell[22234, 685, 180, 4, 45, "Input"],
Cell[22417, 691, 166, 4, 45, "Input"],
Cell[22586, 697, 174, 4, 45, "Input"],
Cell[22763, 703, 389, 11, 71, "Input"],
Cell[23155, 716, 258, 8, 45, "Input"],
Cell[23416, 726, 1248, 34, 202, "Input"],
Cell[24667, 762, 1984, 48, 228, "Input"],
Cell[26654, 812, 2249, 62, 281, "Input"],
Cell[28906, 876, 303, 9, 45, "Input"],
Cell[29212, 887, 669, 21, 97, "Input"],
Cell[29884, 910, 394, 11, 45, "Input"],
Cell[30281, 923, 305, 9, 71, "Input"],
Cell[30589, 934, 379, 10, 71, "Input"],
Cell[30971, 946, 288, 9, 45, "Input"],
Cell[31262, 957, 361, 10, 71, "Input"],
Cell[31626, 969, 185, 4, 45, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[31848, 978, 41, 0, 43, "Subsection"],
Cell[31892, 980, 69, 2, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[31998, 987, 32, 0, 43, "Subsection"],
Cell[32033, 989, 58, 1, 78, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32140, 996, 27, 0, 100, "Section"],
Cell[CellGroupData[{
Cell[32192, 1000, 34, 0, 67, "Subsection"],
Cell[32229, 1002, 30, 0, 78, "Input"],
Cell[32262, 1004, 183, 6, 77, "Text"],
Cell[32448, 1012, 62, 1, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[32547, 1018, 41, 0, 53, "Subsection"],
Cell[CellGroupData[{
Cell[32613, 1022, 56, 1, 43, "Input"],
Cell[32672, 1025, 309, 5, 118, "Print",
 CellTags->"Info3563706972-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[33018, 1035, 51, 1, 35, "Input"],
Cell[33072, 1038, 269, 4, 118, "Print",
 CellTags->"Info3563706975-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[33378, 1047, 53, 1, 35, "Input"],
Cell[33434, 1050, 273, 4, 118, "Print",
 CellTags->"Info3563706978-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[33744, 1059, 52, 1, 33, "Input"],
Cell[33799, 1062, 199, 3, 118, "Print",
 CellTags->"Info3563707101-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[34035, 1070, 53, 1, 33, "Input"],
Cell[34091, 1073, 471, 7, 118, "Print",
 CellTags->"Info3563707107-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[34599, 1085, 58, 1, 33, "Input"],
Cell[34660, 1088, 596, 10, 118, "Print",
 CellTags->"Info3563707110-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[35293, 1103, 62, 1, 35, "Input"],
Cell[35358, 1106, 600, 9, 218, "Print",
 CellTags->"Info3563707113-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[35995, 1120, 50, 1, 33, "Input"],
Cell[36048, 1123, 481, 7, 118, "Print",
 CellTags->"Info3563707120-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[36566, 1135, 54, 1, 33, "Input"],
Cell[36623, 1138, 1090, 18, 175, "Print",
 CellTags->"Info3563707126-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[37750, 1161, 55, 1, 33, "Input"],
Cell[37808, 1164, 308, 5, 118, "Print",
 CellTags->"Info3563707129-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[38153, 1174, 54, 1, 33, "Input"],
Cell[38210, 1177, 354, 5, 118, "Print",
 CellTags->"Info3563707132-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[38601, 1187, 54, 1, 33, "Input"],
Cell[38658, 1190, 283, 5, 118, "Print",
 CellTags->"Info3563707136-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[38978, 1200, 55, 1, 35, "Input"],
Cell[39036, 1203, 1317, 20, 222, "Print",
 CellTags->"Info3563707139-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[40390, 1228, 56, 1, 33, "Input"],
Cell[40449, 1231, 281, 5, 168, "Print",
 CellTags->"Info3563707143-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[40767, 1241, 52, 1, 35, "Input"],
Cell[40822, 1244, 617, 10, 168, "Print",
 CellTags->"Info3563707145-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[41476, 1259, 58, 1, 35, "Input"],
Cell[41537, 1262, 451, 7, 168, "Print",
 CellTags->"Info3563707148-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[42025, 1274, 59, 1, 35, "Input"],
Cell[42087, 1277, 484, 8, 168, "Print",
 CellTags->"Info3563708525-8207676"]
}, Closed]],
Cell[CellGroupData[{
Cell[42608, 1290, 47, 1, 33, "Input"],
Cell[42658, 1293, 268, 4, 118, "Print",
 CellTags->"Info3563707151-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[42963, 1302, 59, 1, 33, "Input"],
Cell[43025, 1305, 298, 5, 118, "Print",
 CellTags->"Info3563707154-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[43360, 1315, 55, 1, 33, "Input"],
Cell[43418, 1318, 291, 5, 168, "Print",
 CellTags->"Info3563707264-2531470"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[43758, 1329, 56, 0, 67, "Subsection"],
Cell[CellGroupData[{
Cell[43839, 1333, 38, 0, 53, "Subsubsection"],
Cell[CellGroupData[{
Cell[43902, 1337, 84, 1, 78, "Input"],
Cell[43989, 1340, 36, 0, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[44062, 1345, 112, 2, 78, "Input"],
Cell[44177, 1349, 36, 0, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[44262, 1355, 33, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[44320, 1359, 75, 1, 78, "Input"],
Cell[44398, 1362, 177, 3, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[44624, 1371, 35, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[44684, 1375, 108, 3, 78, "Input"],
Cell[44795, 1380, 217, 5, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[45061, 1391, 34, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[45120, 1395, 231, 7, 78, "Input"],
Cell[45354, 1404, 219, 3, 175, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[45610, 1412, 314, 7, 127, "Input"],
Cell[45927, 1421, 885, 17, 157, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[46861, 1444, 35, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[46921, 1448, 254, 6, 78, "Input"],
Cell[47178, 1456, 93, 1, 78, "Output"]
}, Closed]],
Cell[47286, 1460, 184, 5, 78, "Input",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[47495, 1469, 160, 4, 78, "Input",
 CellTags->"9.4 Solutions"],
Cell[47658, 1475, 126, 3, 78, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[47833, 1484, 40, 0, 42, "Subsubsection"],
Cell[47876, 1486, 158, 5, 97, "Input"],
Cell[CellGroupData[{
Cell[48059, 1495, 131, 3, 78, "Input"],
Cell[48193, 1500, 642, 18, 127, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[48884, 1524, 44, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[48953, 1528, 162, 3, 78, "Input"],
Cell[49118, 1533, 1007, 15, 266, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[50174, 1554, 32, 0, 42, "Subsubsection"],
Cell[50209, 1556, 147, 4, 78, "Input"],
Cell[CellGroupData[{
Cell[50381, 1564, 91, 2, 78, "Input"],
Cell[50475, 1568, 1208, 36, 220, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[51732, 1610, 36, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[51793, 1614, 89, 2, 78, "Input"],
Cell[51885, 1618, 137, 4, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[52059, 1627, 138, 4, 78, "Input"],
Cell[52200, 1633, 121, 3, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[52370, 1642, 37, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[52432, 1646, 76, 1, 78, "Input"],
Cell[52511, 1649, 31, 0, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[52591, 1655, 36, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[52652, 1659, 75, 1, 78, "Input"],
Cell[52730, 1662, 32, 0, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[52799, 1667, 76, 1, 78, "Input"],
Cell[52878, 1670, 31, 0, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[52946, 1675, 209, 5, 127, "Input"],
Cell[53158, 1682, 1598, 25, 266, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54805, 1713, 36, 0, 42, "Subsubsection"],
Cell[54844, 1715, 64, 1, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[54945, 1721, 37, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[55007, 1725, 149, 4, 78, "Input"],
Cell[55159, 1731, 36, 0, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[55232, 1736, 176, 5, 78, "Input"],
Cell[55411, 1743, 45, 0, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[55493, 1748, 221, 6, 78, "Input"],
Cell[55717, 1756, 165, 3, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[55919, 1764, 331, 9, 78, "Input"],
Cell[56253, 1775, 165, 3, 78, "Output"]
}, Closed]],
Cell[56433, 1781, 61, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[56519, 1785, 320, 9, 78, "Input"],
Cell[56842, 1796, 234, 5, 62, "Message"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[57125, 1807, 38, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[57188, 1811, 231, 7, 78, "Input"],
Cell[57422, 1820, 219, 3, 175, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[57678, 1828, 68, 1, 78, "Input"],
Cell[57749, 1831, 850, 16, 258, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[58636, 1852, 314, 7, 127, "Input"],
Cell[58953, 1861, 885, 17, 157, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[59887, 1884, 34, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[59946, 1888, 128, 3, 78, "Input"],
Cell[60077, 1893, 164, 6, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[60278, 1904, 141, 4, 78, "Input"],
Cell[60422, 1910, 170, 6, 78, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[60629, 1921, 128, 3, 78, "Input"],
Cell[60760, 1926, 269, 6, 62, "Message"],
Cell[61032, 1934, 152, 6, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61233, 1946, 40, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[61298, 1950, 223, 6, 127, "Input"],
Cell[61524, 1958, 448, 8, 175, "Output"]
}, Closed]],
Cell[61987, 1969, 282, 9, 97, "Input"],
Cell[CellGroupData[{
Cell[62294, 1982, 95, 2, 78, "Input"],
Cell[62392, 1986, 339, 6, 127, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[62780, 1998, 41, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[62846, 2002, 132, 3, 45, "Input"],
Cell[62981, 2007, 64, 0, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[63094, 2013, 29, 0, 53, "Subsubsection"],
Cell[CellGroupData[{
Cell[63148, 2017, 68, 1, 78, "Input"],
Cell[63219, 2020, 39, 0, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[63307, 2026, 41, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[63373, 2030, 87, 1, 78, "Input"],
Cell[63463, 2033, 128, 3, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[63640, 2042, 37, 0, 42, "Subsubsection"],
Cell[CellGroupData[{
Cell[63702, 2046, 157, 3, 78, "Input"],
Cell[63862, 2051, 283, 5, 78, "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

