(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    254703,       5451]
NotebookOptionsPosition[    245236,       5145]
NotebookOutlinePosition[    245747,       5165]
CellTagsIndexPosition[    245704,       5162]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PwM`Chap10Visualization`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic",
  FontVariations->{"Underline"->True}]
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Name", ":", " ", "PwM`Chap10Visualization`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Book", ":", " ", 
    RowBox[{"Programming", " ", "with", " ", 
     RowBox[{"Mathematica", ":", " ", 
      RowBox[{"An", " ", "Introduction"}]}]}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "contains", " ", "the", " ", "functions", 
      " ", "defined", " ", "in", " ", "Chapter", " ", "10"}]}]}], ",", " ", 
   RowBox[{"Graphics", " ", "and", " ", 
    RowBox[{"visualization", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "PwM`Chap10Visualization`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Copyright", ":", " ", 
     RowBox[{"Copyright", " ", "2012"}]}]}], ",", " ", 
   RowBox[{"Cambridge", " ", "University", " ", "Press"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"Brownian", " ", "music"}]}]}], ",", " ", 
   RowBox[{"space", "-", 
    RowBox[{"filling", " ", "plots"}]}], ",", " ", 
   RowBox[{"color", " ", "wheel"}], ",", " ", 
   RowBox[{"plotting", " ", "complex", " ", "numbers"}], ",", " ", 
   RowBox[{"convex", " ", "hull"}], ",", " ", 
   RowBox[{"3", "D", " ", "lattice"}], ",", " ", 
   RowBox[{"plotting", " ", "paths"}], ",", " ", 
   RowBox[{"point", " ", "in", " ", "polygon"}], ",", " ", 
   RowBox[{"protein", " ", "dot", " ", "plot"}], ",", " ", 
   RowBox[{"simple", " ", "closed", " ", "paths"}], ",", " ", 
   RowBox[{"standard", " ", "deviation"}], ",", " ", 
   RowBox[{"trend", " ", "plots"}], ",", " ", 
   RowBox[{"triangle", " ", "area"}], ","}], "  ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Chap10Visualization", ".", "nb"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", 
     RowBox[{"8.0", ".4"}]}]}]}], " ", "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"TriangleArea", ",", "PathPlot"}], "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BeginPackage", "[", 
  RowBox[{"\"\<PwM`Chap10Visualization`\>\"", ",", 
   RowBox[{"{", "\"\<ComputationalGeometry`\>\"", "}"}]}], "]"}]], "Input"],

Cell[BoxData["\<\"PwM`Chap10Visualization`\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BrownianCompose", "::", "usage"}], "=", "\"\<BrownianCompose[\!\(\*
StyleBox[\"n\", \"TI\"]\)] generates an \!\(\*
StyleBox[\"n\", \"TI\"]\)-step (notes) random sound composition with, \
essentially a weighted random walk on the C major scale.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ChemicalSpaceFillingPlot", "::", "usage"}], "=", 
   "\"\<ChemicalSpaceFillingPlot[\!\(\*
StyleBox[\"chem\", \"TI\"]\)] generates a molecular space-filling plot for \
the chemical \!\(\*
StyleBox[\"chem\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"colorWheel", "::", "usage"}], "=", "\"\<colorWheel[\!\(\*
StyleBox[\"n\", \"TI\"]\)] displays a color wheel with \!\(\*
StyleBox[\"n\", \"TI\"]\) sectors.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ComplexListPlot", "::", "usage"}], "=", "\"\<ComplexListPlot[\!\(\*
StyleBox[\"pts\", \"TI\"]\)] plots the complex points \!\(\*
StyleBox[\"pts\", \"TI\"]\) in the complex plane. ComplexListPlot inherits \
all the options of ListPlot.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ComplexRootPlot", "::", "usage"}], "=", "\"\<ComplexRootPlot[\!\(\*
StyleBox[\"poly\", \"TI\"]\), \!\(\*
StyleBox[\"var\", \"TI\"]\)] plots the complex root of the polynomial \!\(\*
StyleBox[\"poly\", \"TI\"]\) in the complex plane.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvexHullPlot", "::", "usage"}], "=", "\"\<ConvexHullPlot[\!\(\*
StyleBox[\"pts\", \"TI\"]\)] plots the convex hull of the set of points \
\!\(\*
StyleBox[\"pts\", \"TI\"]\). ConvexHullPlot inherits options from Graphics.\>\
\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hypocycloid", "::", "usage"}], "=", "\"\<Hypocycloid[{\!\(\*
StyleBox[\"R\", \"TI\"]\), \!\(\*
StyleBox[\"r\", \"TI\"]\)}, \[Theta]] generates a hypocycloid curve with the \
radius of the fixed outside circle given by \!\(\*
StyleBox[\"R\", \"TI\"]\) and the radius of the rotating inner circle given \
by \!\(\*
StyleBox[\"r\", \"TI\"]\). The angle of rotation is given by the paramter \
\[Theta].\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lattice3D", "::", "usage"}], "=", "\"\<Lattice3D[{\!\(\*
StyleBox[\"xmin\", \"TI\"]\), \!\(\*
StyleBox[\"xmax\", \"TI\"]\)}, {\!\(\*
StyleBox[\"ymin\", \"TI\"]\), \!\(\*
StyleBox[\"ymax\", \"TI\"]\)}, {\!\(\*
StyleBox[\"zmin\", \"TI\"]\), \!\(\*
StyleBox[\"zmax\", \"TI\"]\)}] displays a three-dimensional lattice in space.\
\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListLinePlot3D", "::", "usage"}], "=", "\"\<ListLinePlot3D[\!\(\*
StyleBox[\"lis\", \"TI\",
FontSlant->\"Italic\"]\)] creates a three-dimensional graphic of lines \
connecting the points given in \!\(\*
StyleBox[\"lis\", \"TI\",
FontSlant->\"Italic\"]\) which are assumed to be lists consisting of three \
coordinates.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PathPlot", "::", "usage"}], "=", 
   "\"\<functionName[x] computes the\[Ellipsis]\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PointInPolygonQ", "::", "usage"}], "=", "\"\<PointInPolygonQ[\!\(\*
StyleBox[\"poly\", \"TI\"]\), \!\(\*
StyleBox[\"pt\", \"TI\"]\)] returns True if the point \!\(\*
StyleBox[\"pt\", \"TI\"]\) is inside the polygon specified by the set of \
vertices \!\(\*
StyleBox[\"poly\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProteinSpaceFillingPlot", "::", "usage"}], "=", 
   "\"\<ProteinSpaceFillingPlot[\!\(\*
StyleBox[\"protein\", \"TI\"]\)] generates a molecular space-filling plot for \
the protein \!\(\*
StyleBox[\"protein\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProteinDotPlot", "::", "usage"}], "=", 
   "\"\<ProteinDotPlot[\!\(\*SubscriptBox[
StyleBox[\"protein\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"protein\", \"TI\"], \"2\"]\), {\!\(\*SubscriptBox[
StyleBox[\"name\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"name\", \"TI\"], \"2\"]\)}] generates a protein dot plot comparing \
the two proteins \!\(\*SubscriptBox[
StyleBox[\"protein\", \"TI\"], \"1\"]\) and \!\(\*SubscriptBox[
StyleBox[\"protein\", \"TI\"], \"2\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomCompose", "::", "usage"}], "=", "\"\<RandomCompose[\!\(\*
StyleBox[\"n\", \"TI\"]\), \!\(\*
StyleBox[\"instr\", \"TI\"]\)] generates an uncorrelated set of  \!\(\*
StyleBox[\"n\", \"TI\"]\) tones using the MIDI instrument \!\(\*
StyleBox[\"instr\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomWalkPi", "::", "usage"}], "=", "\"\<RandomWalkPi[\!\(\*
StyleBox[\"n\", \"TI\"]\), \!\(\*
StyleBox[\"b\", \"TI\"]\)] generates \!\(\*
StyleBox[\"n\", \"TI\"]\) steps of a random walk on the base \!\(\*
StyleBox[\"b\", \"TI\"]\) digits of \[Pi].\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RootPlot", "::", "usage"}], "=", "\"\<RootPlot[\!\(\*
StyleBox[\"fun\", \"TI\"]\), {\!\(\*
StyleBox[\"x\", \"TI\"]\), \!\(\*
StyleBox[\"xmin\", \"TI\"]\), \!\(\*
StyleBox[\"xmax\", \"TI\"]\)}] plots the function \!\(\*
StyleBox[\"fun\", \"TI\"]\) together with its roots over the interval from \!\
\(\*
StyleBox[\"xmin\", \"TI\"]\) to \!\(\*
StyleBox[\"xmax\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimpleClosedPath", "::", "usage"}], "=", 
   "\"\<SimpleClosedPath[\!\(\*
StyleBox[\"lis\", \"TI\"]\)] finds a simple closed path through the \
two-dimensional points, \!\(\*
StyleBox[\"lis\", \"TI\"]\).\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardDeviationPlot", "::", "usage"}], "=", 
   "\"\<StandardDeviationPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\), \!\(\*
StyleBox[\"sd\", \"TI\"]\)] plots \!\(\*
StyleBox[\"data\", \"TI\"]\) where points within one standard deviation are \
colored differently than those more than one standard deviation from the \
mean. The second argument, sd, is 1 by default and can set to any standard \
deviation value.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrendPlot", "::", "usage"}], "=", "\"\<TrendPlot[\!\(\*
StyleBox[\"data\", \"TI\"]\),{\!\(\*SubscriptBox[
StyleBox[\"r\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"r\", \"TI\"], \"2\"]\),\[Ellipsis]}] plots \!\(\*
StyleBox[\"data\", \"TI\"]\) with trend lines showing growth rates over time.\
\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrendlineStyle", "::", "usage"}], "=", 
   "\"\<TrendlineStyle is an option for TrendPlot that specifies the style of \
the trend lines.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TriangleArea", "::", "usage"}], "=", 
   "\"\<TriangleArea[{\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"2\"]\),\!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"3\"]\)}] computes the area of the triangle given \
by the three vertices \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"1\"]\), \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"2\"]\), and \!\(\*SubscriptBox[
StyleBox[\"v\", \"TI\"], \"3\"]\).\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "BrownianCompose", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Weights", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ComplexListPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ListLinePlot3D", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Mesh", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
       RowBox[{"MeshStyle", "\[Rule]", "Automatic"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{
         RowBox[{"ColorData", "[", "1", "]"}], "[", "1", "]"}]}]}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "PathPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ClosedPath", "\[Rule]", "True"}], "}"}], ",", 
     RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RootPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Options", "[", "NSolve", "]"}], ",", 
     RowBox[{"Options", "[", "Plot", "]"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TrendPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TrendlineStyle", "\[Rule]", "Automatic"}], "}"}], ",", 
     RowBox[{"Options", "[", "DateListPlot", "]"}]}], "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListLinePlot3D", "::", "badmesh"}], "=", 
   "\"\<The value of the Mesh option should be either None or All\>\""}], 
  ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"steps_Integer", ",", 
    RowBox[{"instr_:", "\"\<Vibraphone\>\""}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"walk", ",", "durs", ",", "weights"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"weights", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "Weights", "]"}], "===", "Automatic"}], 
        ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"1", "/", "9"}], ",", 
          RowBox[{"{", "9", "}"}]}], "]"}], ",", 
        RowBox[{"OptionValue", "[", "Weights", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"walk", "[", "n_", "]"}], ":=", 
      RowBox[{"Accumulate", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"weights", "\[Rule]", 
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "4"}], ",", "4"}], "]"}]}], ",", "n"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"durs", "=", 
      RowBox[{"RandomChoice", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"1", "/", "16"}], ",", "1", ",", 
          RowBox[{"1", "/", "16"}]}], "]"}], ",", 
        RowBox[{"{", "steps", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Sound", "@", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SoundNote", "[", 
          RowBox[{"#1", ",", "#2", ",", "instr"}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"walk", "[", "steps", "]"}], ",", "durs"}], "}"}]}], 
       "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ChemicalSpaceFillingPlot", "[", "chem_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"elements", ",", "pos", ",", "radii"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"elements", "=", 
      RowBox[{"ChemicalData", "[", 
       RowBox[{"chem", ",", "\"\<VertexTypes\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"ChemicalData", "[", 
       RowBox[{"chem", ",", "\"\<AtomPositions\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"radii", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ElementData", "[", 
          RowBox[{"#", ",", "\"\<VanDerWaalsRadius\>\""}], "]"}], "&"}], ",", 
        "elements"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Graphics3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Specularity", "[", 
          RowBox[{"White", ",", "50"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ColorData", "[", 
               RowBox[{"\"\<Atoms\>\"", ",", "#1"}], "]"}], ",", 
              RowBox[{"Sphere", "[", 
               RowBox[{"#2", ",", "#3"}], "]"}]}], "}"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"elements", ",", "pos", ",", "radii"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], ",", 
       RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"colorWheel", "[", "n_", "]"}], ":=", 
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", 
         RowBox[{"Rescale", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "]"}], ",", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "1", ",", 
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{"#", "+", " ", "n"}]}], "}"}]}], "]"}]}], "}"}], "&"}], 
     ")"}], "/@", 
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", 
      RowBox[{"2", " ", "\[Pi]"}], ",", "n"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{"points_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Re", "[", "#", "]"}], ",", 
         RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], ",", "points"}], 
     "]"}], ",", "opts", ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<Re\>\"", ",", "\"\<Im\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "\"\<Menu\>\"", "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexRootPlot", "[", 
   RowBox[{"poly_", ",", "z_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{
    RowBox[{"z", "/.", 
     RowBox[{"NSolve", "[", 
      RowBox[{
       RowBox[{"poly", "==", "0"}], ",", "z"}], "]"}]}], ",", "opts", ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConvexHullPlot", "[", 
   RowBox[{"pts_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ch", ",", 
      RowBox[{"ran", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"Length", "[", "pts", "]"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ch", "=", 
      RowBox[{"ComputationalGeometry`ConvexHull", "[", "pts", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
         RowBox[{"pts", ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"ch", "/.", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
               RowBox[{"{", 
                RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
            RowBox[{"Point", "[", "ran", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"StringForm", "[", 
                  RowBox[{"\"\<`1`\>\"", ",", "#"}], "]"}], ",", 
                 RowBox[{"pts", "[", 
                  RowBox[{"[", "#", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "1.25"}], ",", 
                   RowBox[{"-", "1.25"}]}], "}"}]}], "]"}], "&"}], ",", 
              "ran"}], "]"}]}], "\[IndentingNewLine]", "}"}]}], 
         "\[IndentingNewLine]", "]"}], "}"}], ",", "opts"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hypocycloid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_"}], "}"}], ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", "b"}], ")"}], 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
     RowBox[{"b", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", " ", 
        FractionBox[
         RowBox[{"a", "-", "b"}], "b"]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "-", "b"}], ")"}], 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
     RowBox[{"b", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", " ", 
        FractionBox[
         RowBox[{"a", "-", "b"}], "b"]}], "]"}]}]}]}], "}"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Lattice3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ymin_", ",", "ymax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"zmin_", ",", "zmax_"}], "}"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics3D", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"gridX", ",", "gridY", ",", "gridZ"}], "}"}], ",", 
    RowBox[{
     RowBox[{"gridX", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"xmin", ",", "y", ",", "z"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xmax", ",", "y", ",", "z"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gridY", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "ymin", ",", "z"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "ymax", ",", "z"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gridZ", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "zmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "zmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics3D", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridX"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridY"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Map", "[", 
          RowBox[{"Line", ",", "gridZ"}], "]"}]}], "\[IndentingNewLine]", 
        "}"}], ",", "opts", ",", 
       RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLinePlot3D", "[", 
   RowBox[{
    RowBox[{"lis", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"plotStyle", ",", "mesh", ",", "meshStyle", ",", "gr3DOpts"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"mesh", "=", 
      RowBox[{"OptionValue", "[", "Mesh", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"plotStyle", "=", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "PlotStyle", "]"}], "===", "Automatic"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ColorData", "[", "1", "]"}], "[", "1", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"OptionValue", "[", "PlotStyle", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"meshStyle", "=", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "MeshStyle", "]"}], "===", "Automatic"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
          RowBox[{
           RowBox[{"ColorData", "[", "1", "]"}], "[", "1", "]"}]}], "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"OptionValue", "[", "MeshStyle", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gr3DOpts", "=", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", 
        RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"mesh", "===", "All"}], ",", 
       RowBox[{"Graphics3D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Flatten", "@", 
            RowBox[{"{", 
             RowBox[{"plotStyle", ",", 
              RowBox[{"Line", "[", "lis", "]"}]}], "}"}]}], ",", 
           RowBox[{"Flatten", "@", 
            RowBox[{"{", 
             RowBox[{"meshStyle", ",", 
              RowBox[{"Point", "[", "lis", "]"}]}], "}"}]}]}], "}"}], ",", 
         "gr3DOpts"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"mesh", "===", "None"}], ",", 
       RowBox[{"Graphics3D", "[", 
        RowBox[{
         RowBox[{"Flatten", "@", 
          RowBox[{"{", 
           RowBox[{"plotStyle", ",", 
            RowBox[{"Line", "[", "lis", "]"}]}], "}"}]}], ",", "gr3DOpts"}], 
        "]"}], ",", "\[IndentingNewLine]", "True", ",", 
       RowBox[{"Message", "[", 
        RowBox[{"ListLinePlot3D", "::", "badmesh"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLinePlot3D", "[", 
   RowBox[{"lis_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"colors", "=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "1", "]"}], "[", "#", "]"}], "&"}], "/@", 
       RowBox[{"Range", "[", 
        RowBox[{"Length", "[", "lis", "]"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{
      RowBox[{"Thread", "[", 
       RowBox[{"{", 
        RowBox[{"colors", ",", 
         RowBox[{"Line", "/@", "lis"}]}], "}"}], "]"}], ",", "opts"}], 
     "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PathPlot", "[", 
   RowBox[{"lis_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"coords", "=", "lis"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"OptionValue", "[", "ClosedPath", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"coords", "=", 
        RowBox[{"coords", "/.", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Line", "[", "coords", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PointSize", "[", ".02", "]"}], ",", "Red", ",", 
         RowBox[{"Point", "[", "coords", "]"}]}], "\[IndentingNewLine]", 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], "]"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PointInPolygonQ", "[", 
   RowBox[{
    RowBox[{"poly", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"pt", ":", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"edges", ",", "e2", ",", "e3", ",", "e4"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"edges", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"poly", "/.", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], ",", "2", ",", "1"}],
        "]"}]}], ";", 
     RowBox[{"e2", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{"edges", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x1_", ",", "y1_"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x2_", ",", "y2_"}], "}"}]}], "}"}], "/;", 
         RowBox[{"y1", "\[Equal]", "y2"}]}]}], "]"}]}], ";", 
     RowBox[{"e3", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{"e2", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x1_", ",", "y1_"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x2_", ",", "y2_"}], "}"}]}], "}"}], "/;", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Min", "[", 
             RowBox[{"y1", ",", "y2"}], "]"}], "\[GreaterEqual]", "y"}], "||", 
           RowBox[{
            RowBox[{"Max", "[", 
             RowBox[{"y1", ",", "y2"}], "]"}], "<", "y"}]}], ")"}]}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"e4", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Reverse", "@", 
          RowBox[{"SortBy", "[", 
           RowBox[{"#", ",", "Last"}], "]"}]}], "&"}], ",", "e3"}], "]"}]}], 
     ";", 
     RowBox[{"OddQ", "[", 
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"TriangleArea", "[", 
           RowBox[{"Join", "[", 
            RowBox[{"#", ",", 
             RowBox[{"{", "pt", "}"}]}], "]"}], "]"}], "&"}], "/@", "e4"}], 
        ",", 
        RowBox[{"_", "?", "Positive"}]}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProteinDotPlot", "[", 
   RowBox[{"p1_", ",", "p2_", ",", 
    RowBox[{"{", 
     RowBox[{"name1_String", ",", "name2_String"}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ArrayPlot", "[", 
   RowBox[{
    RowBox[{"Outer", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Boole", "[", 
        RowBox[{"#1", "==", "#2"}], "]"}], "&"}], ",", 
      RowBox[{"Characters", "[", "p1", "]"}], ",", 
      RowBox[{"Characters", "[", "p2", "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"name1", ",", "name2"}], "}"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProteinSpaceFillingPlot", "[", 
   RowBox[{"prot_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics3D", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"atoms", ",", "pos", ",", "radii"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"atoms", "=", 
      RowBox[{"ProteinData", "[", 
       RowBox[{"prot", ",", "\"\<AtomTypes\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"ProteinData", "[", 
       RowBox[{"prot", ",", "\"\<AtomPositions\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"{", 
           RowBox[{"atoms", ",", "pos"}], "}"}], "]"}], ",", "_Missing"}], 
        "]"}], ",", 
       RowBox[{"Missing", "[", "\"\<NotAvailable\>\"", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"radii", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ElementData", "[", 
             RowBox[{"#", ",", "\"\<VanDerWaalsRadius\>\""}], "]"}], "&"}], 
           ",", "atoms"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Graphics3D", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Specularity", "[", 
             RowBox[{"White", ",", "50"}], "]"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"MapThread", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"ColorData", "[", 
                  RowBox[{"\"\<Atoms\>\"", ",", "#1"}], "]"}], ",", 
                 RowBox[{"Sphere", "[", 
                  RowBox[{"#2", ",", "#3"}], "]"}]}], "}"}], "&"}], ",", 
              RowBox[{"{", 
               RowBox[{"atoms", ",", "pos", ",", "radii"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "opts", ",", 
          RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomCompose", "[", 
   RowBox[{"n_Integer", ",", 
    RowBox[{"instrument_:", "\"\<Piano\>\""}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"notes", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", "None", "}"}], ",", 
         RowBox[{"Range", "[", 
          RowBox[{"0", ",", "11"}], "]"}]}], "]"}]}], ",", 
      RowBox[{"durations", "=", 
       RowBox[{"Range", "[", 
        RowBox[{
         RowBox[{"1", "/", "8"}], ",", "1", ",", 
         RowBox[{"1", "/", "8"}]}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Sound", "[", 
     RowBox[{"{", 
      RowBox[{"instrument", ",", "\[IndentingNewLine]", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SoundNote", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RandomChoice", "[", 
            RowBox[{"notes", ",", "n"}], "]"}], ",", 
           RowBox[{"RandomChoice", "[", 
            RowBox[{"durations", ",", "n"}], "]"}]}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomWalkPi", "[", 
   RowBox[{"d_", ",", 
    RowBox[{"base_", "/;", 
     RowBox[{"base", ">", "2"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digits", ",", "angles", ",", "rules"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"digits", "=", 
      RowBox[{"First", "[", 
       RowBox[{"RealDigits", "[", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"\[Pi]", ",", "d"}], "]"}], ",", "base"}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"angles", "=", 
      RowBox[{"Rest", "@", 
       RowBox[{"Range", "[", 
        RowBox[{"0.", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"2", 
          RowBox[{"\[Pi]", "/", 
           RowBox[{"(", "base", ")"}]}]}]}], "]"}]}]}], ";", 
     RowBox[{"rules", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", "#2"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"base", "-", "1"}]}], "]"}], ",", "angles"}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Accumulate", "[", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", "#", "]"}], ",", 
           RowBox[{"Sin", "[", "#", "]"}]}], "}"}], "&"}], ",", 
        RowBox[{"digits", "/.", "rules"}]}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RootPlot", "[", 
   RowBox[{"fun_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "varmin_", ",", "varmax_"}], "}"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"f", "=", "fun"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Plot", "[", 
     RowBox[{"f", ",", 
      RowBox[{"{", 
       RowBox[{"var", ",", "varmin", ",", "varmax"}], "}"}], ",", 
      "\[IndentingNewLine]", "opts", ",", "\[IndentingNewLine]", 
      RowBox[{"Mesh", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", "0", "}"}], "}"}]}], ",", 
      RowBox[{"MeshFunctions", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"f", "/.", 
          RowBox[{"var", "\[Rule]", "#"}]}], "&"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"MeshStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimpleClosedPath", "[", "lis_List", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"base", ",", "angle", ",", "sorted"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"base", "=", 
      RowBox[{"First", "[", 
       RowBox[{"SortBy", "[", 
        RowBox[{"lis", ",", "Last"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angle", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
      RowBox[{"ArcTan", "@@", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sorted", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"lis", ",", 
          RowBox[{"{", "base", "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#1"}], "]"}], "\[LessEqual]", 
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#2"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "base", "}"}], ",", "sorted", ",", 
       RowBox[{"{", "base", "}"}]}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StandardDeviationPlot", "[", 
   RowBox[{
    RowBox[{"data_", "?", "VectorQ"}], ",", 
    RowBox[{"n_:", "1"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "ListPlot", "]"}]}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"in", ",", "out", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "data", "]"}]}], ",", "lenrange", ",", 
      RowBox[{"\[Mu]", "=", 
       RowBox[{"Mean", "[", "data", "]"}]}], ",", 
      RowBox[{"\[Sigma]", "=", 
       RowBox[{"StandardDeviation", "[", "data", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lenrange", "=", 
      RowBox[{"Range", "[", 
       RowBox[{"Length", "[", "data", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"in", "=", 
      RowBox[{"Pick", "[", 
       RowBox[{"lenrange", ",", 
        RowBox[{"Thread", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"data", "-", "\[Mu]"}], ")"}], "/", "\[Sigma]"}], "]"}], 
          "<", "n"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"out", "=", 
      RowBox[{"Complement", "[", 
       RowBox[{"lenrange", ",", "in"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"in", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "in", "]"}], "===", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{"Missing", "[", "]"}], "}"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"in", ",", 
           RowBox[{"data", "[", 
            RowBox[{"[", "in", "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"out", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "out", "]"}], "===", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{"Missing", "[", "]"}], "}"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"out", ",", 
           RowBox[{"data", "[", 
            RowBox[{"[", "out", "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"in", ",", "out"}], "}"}], ",", "\[IndentingNewLine]", "opts",
        ",", "\[IndentingNewLine]", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", "Pink"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Dashed", ",", "\[IndentingNewLine]", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"\[Mu]", "+", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"len", ",", 
               RowBox[{"\[Mu]", "+", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}]}], "}"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"\[Mu]", "-", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"len", ",", 
               RowBox[{"\[Mu]", "-", 
                RowBox[{"n", " ", "\[Sigma]"}]}]}], "}"}]}], "}"}], "]"}]}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TrendPlot", "[", 
   RowBox[{"data_", ",", "rates_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "min", ",", "max", ",", "tlStyle", ",", "tLine", ",", "rtTicks", ",", 
      RowBox[{"init", "=", 
       RowBox[{"data", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", "minR", ",", "maxR"}], 
     "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", "max"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"Max", "[", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"minR", ",", "maxR"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", "rates", "]"}], ",", 
        RowBox[{"Max", "[", "rates", "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tlStyle", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "TrendlineStyle", "]"}], "===", 
         "Automatic"}], ",", 
        RowBox[{"{", 
         RowBox[{"Dashed", ",", "Gray"}], "}"}], ",", 
        RowBox[{"OptionValue", "[", "TrendlineStyle", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tLine", "[", "r_", "]"}], ":=", 
      RowBox[{"Flatten", "@", 
       RowBox[{"{", 
        RowBox[{"tlStyle", ",", "\[IndentingNewLine]", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"First", "[", "data", "]"}], ",", 
            RowBox[{
             RowBox[{"Last", "[", "data", "]"}], "/.", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"d_List", ",", 
                RowBox[{"val_", "?", "NumberQ"}]}], "}"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"d", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "+", "r"}], " ", ")"}], "init"}]}], 
               "}"}]}]}]}], "}"}], "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"rtTicks", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "+", "#"}], ")"}], "init"}], ",", 
           RowBox[{"StringForm", "[", 
            RowBox[{"\"\< `1`%\>\"", ",", "#2"}], "]"}]}], "}"}], "&"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"rates", ",", 
          RowBox[{"100", "rates"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"DateListPlot", "[", 
      RowBox[{"data", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "DateListPlot", "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Epilog", "\[RuleDelayed]", 
        RowBox[{"Map", "[", 
         RowBox[{"tLine", ",", "rates"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1.05", "+", "minR"}], ")"}], "min"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{".95", "+", "maxR"}], ")"}], "max"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "rtTicks"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleArea", "[", 
   RowBox[{"tri", ":", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Det", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"PadRight", "[", 
        RowBox[{"#", ",", "3", ",", "1"}], "]"}], "&"}], ",", "tri"}], "]"}], 
    "]"}], "/", "2"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"],

Cell[BoxData["\<\"PwM`Chap10Visualization`Private`\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "PWM`Chap10Visualization`"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BrownianCompose"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"BrownianCompose[\!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\)] \
generates an \!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\)-step (notes) random \
sound composition with, essentially a weighted random walk on the C major \
scale.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ChemicalSpaceFillingPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ChemicalSpaceFillingPlot[\\!\\(\\*\\nStyleBox[\\\"chem\\\", \\\
\"TI\\\"]\\)] generates a molecular space-filling plot for the chemical \
\\!\\(\\*\\nStyleBox[\\\"chem\\\", \\\"TI\\\"]\\).\"\>", "MSG"]], "Print", \
"PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "colorWheel"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"colorWheel[\!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\)] \
displays a color wheel with \!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\) \
sectors.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ComplexListPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ComplexListPlot[\!\(\*\\nStyleBox[\\\"pts\\\", \\\"TI\\\"]\)] \
plots the complex points \!\(\*\\nStyleBox[\\\"pts\\\", \\\"TI\\\"]\) in the \
complex plane. ComplexListPlot inherits all the options of ListPlot.\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ComplexRootPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ComplexRootPlot[\!\(\*\\nStyleBox[\\\"poly\\\", \\\"TI\\\"]\), \
\!\(\*\\nStyleBox[\\\"var\\\", \\\"TI\\\"]\)] plots the complex root of the \
polynomial \!\(\*\\nStyleBox[\\\"poly\\\", \\\"TI\\\"]\) in the complex \
plane.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ConvexHullPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ConvexHullPlot[\!\(\*\\nStyleBox[\\\"pts\\\", \\\"TI\\\"]\)] \
plots the convex hull of the set of points \!\(\*\\nStyleBox[\\\"pts\\\", \
\\\"TI\\\"]\). ConvexHullPlot inherits options from Graphics.\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Hypocycloid"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Hypocycloid[{\\!\\(\\*\\nStyleBox[\\\"R\\\", \\\"TI\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"r\\\", \\\"TI\\\"]\\)}, \[Theta]] generates a \
hypocycloid curve with the radius of the fixed outside circle given by \\!\\(\
\\*\\nStyleBox[\\\"R\\\", \\\"TI\\\"]\\) and the radius of the rotating inner \
circle given by \\!\\(\\*\\nStyleBox[\\\"r\\\", \\\"TI\\\"]\\). The angle of \
rotation is given by the paramter \[Theta].\"\>", "MSG"]], "Print", \
"PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Lattice3D"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Lattice3D[{\!\(\*\\nStyleBox[\\\"xmin\\\", \\\"TI\\\"]\), \!\(\
\*\\nStyleBox[\\\"xmax\\\", \\\"TI\\\"]\)}, {\!\(\*\\nStyleBox[\\\"ymin\\\", \
\\\"TI\\\"]\), \!\(\*\\nStyleBox[\\\"ymax\\\", \\\"TI\\\"]\)}, \
{\!\(\*\\nStyleBox[\\\"zmin\\\", \\\"TI\\\"]\), \
\!\(\*\\nStyleBox[\\\"zmax\\\", \\\"TI\\\"]\)}] displays a three-dimensional \
lattice in space.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ListLinePlot3D"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ListLinePlot3D[\\!\\(\\*\\nStyleBox[\\\"lis\\\", \
\\\"TI\\\",\\nFontSlant->\\\"Italic\\\"]\\)] creates a three-dimensional \
graphic of lines connecting the points given in \
\\!\\(\\*\\nStyleBox[\\\"lis\\\", \\\"TI\\\",\\nFontSlant->\\\"Italic\\\"]\\) \
which are assumed to be lists consisting of three coordinates.\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PointInPolygonQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"PointInPolygonQ[\!\(\*\\nStyleBox[\\\"poly\\\", \\\"TI\\\"]\), \
\!\(\*\\nStyleBox[\\\"pt\\\", \\\"TI\\\"]\)] returns True if the point \!\(\*\
\\nStyleBox[\\\"pt\\\", \\\"TI\\\"]\) is inside the polygon specified by the \
set of vertices \!\(\*\\nStyleBox[\\\"poly\\\", \\\"TI\\\"]\).\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ProteinSpaceFillingPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ProteinSpaceFillingPlot[\\!\\(\\*\\nStyleBox[\\\"protein\\\", \
\\\"TI\\\"]\\)] generates a molecular space-filling plot for the protein \
\\!\\(\\*\\nStyleBox[\\\"protein\\\", \\\"TI\\\"]\\).\"\>", "MSG"]], "Print", \
"PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ProteinDotPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"ProteinDotPlot[\!\(\*SubscriptBox[\\nStyleBox[\\\"protein\\\", \
\\\"TI\\\"], \(1\)]\), \!\(\*SubscriptBox[\\nStyleBox[\\\"protein\\\", \\\"TI\
\\\"], \(2\)]\), {\!\(\*SubscriptBox[\\nStyleBox[\\\"name\\\", \\\"TI\\\"], \
\(1\)]\), \!\(\*SubscriptBox[\\nStyleBox[\\\"name\\\", \\\"TI\\\"], \
\(2\)]\)}] generates a protein dot plot comparing the two proteins \
\!\(\*SubscriptBox[\\nStyleBox[\\\"protein\\\", \\\"TI\\\"], \(1\)]\) and \
\!\(\*SubscriptBox[\\nStyleBox[\\\"protein\\\", \\\"TI\\\"], \(2\)]\).\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RandomCompose"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"RandomCompose[\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"instr\\\", \\\"TI\\\"]\\)] generates an uncorrelated \
set of  \\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) tones using the MIDI \
instrument \\!\\(\\*\\nStyleBox[\\\"instr\\\", \\\"TI\\\"]\\).\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RandomWalkPi"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"RandomWalkPi[\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"b\\\", \\\"TI\\\"]\\)] generates \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) steps of a random walk on the \
base \\!\\(\\*\\nStyleBox[\\\"b\\\", \\\"TI\\\"]\\) digits of \[Pi].\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RootPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"RootPlot[\!\(\*\\nStyleBox[\\\"fun\\\", \\\"TI\\\"]\), {\!\(\*\
\\nStyleBox[\\\"x\\\", \\\"TI\\\"]\), \!\(\*\\nStyleBox[\\\"xmin\\\", \
\\\"TI\\\"]\), \!\(\*\\nStyleBox[\\\"xmax\\\", \\\"TI\\\"]\)}] plots the \
function \!\(\*\\nStyleBox[\\\"fun\\\", \\\"TI\\\"]\) together with its roots \
over the interval from \!\(\*\\nStyleBox[\\\"xmin\\\", \\\"TI\\\"]\) to \
\!\(\*\\nStyleBox[\\\"xmax\\\", \\\"TI\\\"]\).\"\>", "MSG"]], "Print", \
"PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SimpleClosedPath"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"SimpleClosedPath[\\!\\(\\*\\nStyleBox[\\\"lis\\\", \\\"TI\\\"]\
\\)] finds a simple closed path through the two-dimensional points, \\!\\(\\*\
\\nStyleBox[\\\"lis\\\", \\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StandardDeviationPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StandardDeviationPlot[\!\(\*\\nStyleBox[\\\"data\\\", \\\"TI\\\
\"]\), \!\(\*\\nStyleBox[\\\"sd\\\", \\\"TI\\\"]\)] plots \
\!\(\*\\nStyleBox[\\\"data\\\", \\\"TI\\\"]\) where points within one \
standard deviation are colored differently than those more than one standard \
deviation from the mean. The second argument, sd, is 1 by default and can set \
to any standard deviation value.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TrendPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"TrendPlot[data,{r1,r2,\[Ellipsis]}] plots data with trend \
lines showing growth rates over time.\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["BrownianCompose", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"18", ",", "\"\<Marimba\>\""}], "]"}], "//", 
  "EmitSound"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"18", ",", "\"\<Marimba\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"Weights", "\[Rule]", 
     RowBox[{"Abs", "@", 
      RowBox[{"RandomVariate", "[", 
       RowBox[{
        RowBox[{"NormalDistribution", "[", 
         RowBox[{"0", ",", "4"}], "]"}], ",", "9"}], "]"}]}]}]}], "]"}], "//",
   "EmitSound"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ChemicalSpaceFillingPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ChemicalSpaceFillingPlot", "[", "\"\<LTryptophan\>\"", 
  "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["colorWheel", "Subsubsection"],

Cell[BoxData[
 RowBox[{"colorWheel", "[", 
  FractionBox["\[Pi]", "256"], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ComplexListPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ComplexListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "I"}], ",", 
     RowBox[{"2", "+", "I"}], ",", 
     RowBox[{"1", "-", 
      RowBox[{"2", "I"}]}], ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", 
      RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ComplexRootPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ComplexRootPlot", "[", 
  RowBox[{
   RowBox[{"Cyclotomic", "[", 
    RowBox[{"17", ",", "z"}], "]"}], ",", "z", ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ConvexHullPlot", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"30", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ConvexHullPlot", "[", 
  RowBox[{"pts", ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hypocycloid", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ParametricPlot", "[", 
    RowBox[{
     RowBox[{"Hypocycloid", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "1"}], "}"}], ",", "\[Theta]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "0", ",", 
       RowBox[{"2", " ", 
        RowBox[{"Denominator", "[", "R", "]"}], " ", "\[Pi]"}]}], "}"}], ",", 
     
     RowBox[{"Axes", "\[Rule]", "None"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Tiny"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"R", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"7", "/", "2"}], ",", 
       RowBox[{"13", "/", "5"}], ",", "4", ",", 
       RowBox[{"21", "/", "13"}]}], "}"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxd2Wk0VV/YAPDruoZMSTIlZCiaiELCPmRolpKhFJX8JUWDkiQhCslYkoyR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       "]]}},
    Axes->None,
    AxesOrigin->{0, 0},
    ImageSize->Tiny,
    PlotRange->{{-1.499998886908152, 3.}, {-2.5980742846991958`, 
     2.598073890356724}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw0m3k41c/7/885HOccFJLILkqWVJIkzIuUrcUaLVSKSoWEhIpWtFjflSwJ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       "]]}},
    Axes->None,
    AxesOrigin->{0, 0},
    ImageSize->Tiny,
    PlotRange->{{-3.1533904832991038`, 3.5}, {-3.4122464485371427`, 
     3.4122461087628593`}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwsl3k8lO/3/2erEBJKSYtKVEiKkDq38i5bCJVQkbKUSpGkTStpsxZR0SJJ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       "]]}},
    Axes->None,
    AxesOrigin->{0, 0},
    ImageSize->Tiny,
    PlotRange->{{-2.5244486051499915`, 2.6}, {-2.5810187902809885`, 
     2.581012837140131}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxdm3c81e///4+9D6FSqWQlIeOdhM71IkTDSsjKyk6SXdlCtihJki0SMpNz
vWSUkYzM7L33nt/X6XP7/fPrH91vz+d1vc65Xue6no/H6/Z8nTF9qHmfHIfD
PaLA4Uh///ePBfl//6NfCtBYPWDG2Pju0W9GhPiP55Va/jHvGcZv4YSBAaH+
VyT2nnSKn88iKLHMHVMkMaKDDJQTCWnPN7b+7mM8eJtfh6KJwK574KlP4qQY
ecX5boKT6UBW1R4pXmYa/GqUkHg9/gk7iUUN4fnyeYK0h97arV2MuURSogfX
CNdPOnI47GBMKyqvSL5PMDqtP+6xTYr30eptUgBHgRJj+y2M3Yi+i7N0wOWN
WvD1TYxL19SWPViAb9BhU+YNjGPcBI7FsoPZrEKh26uk6y33G5aeAmm2kjyt
yxjLHmaRsuMGkqhk2+UljFs3ehn6+UDv2VKbqjmMe2Sp9/eEQVbBKd2xGYz7
aaJ/6IsBuS9N9ItTpPljBCdXJUDCcNAvOIZxx8bxxInLwC6rcNR/BOM4G9lJ
pStgj/rBb/EhjO2t17dcEHBd3e2CSi/GTvdO3Y1QACnCitHGLaT17osR+KQK
5rKYKuyaMF5+/rWxRR0Mt6sMmDQwI94NFAUfzDVB5J2tUzQ1WHxc/sZK2x3Q
YPadj1CCxZkl7o3PGgKnipS06C/MCIrLGtXjNAZic2nXmz9jLJcFB9RNgJJA
zUmaTGz8R6STb8IM8C/NpJq9xsab2C4btloDKnM5OvKXGAdOX5h2sQXfslnr
g8Mx1syL6BZ6AG4WfPa6E4DNRz7SxWXpANBDvXH9jzB+kDRg4eYE6MM/LxCV
SN9v9Y+Ltycg/qLzdkeYkaSzf8aWab1BE0fEsePSWL7I5rd7Xd7gHP+Jt0zC
zIhxY1FiTYgv0Mw0U4aHmBEE9SkruPYcJL2lfny3A4+gL6g1Nc9HAFMi3ZZH
Ex6JdJm/u3gxEpyKOW7rV4tHkhQNS+73RAIq2RlNlWI8kvf00k28aDSomI3f
/BiDR7zLg56WM8eCgcdkzn9u4hHjQlt2n+y3QGkxLcruKh4Z/GNbGxOTANAP
srmzl/EIbv0iX6LvO8DLnCuexo/FdS3nKh+8B0s1ub5b+0zI4pk/N36hHwAl
W0Aqko2x0Kz2iFY6mAoZF+hbZkSUZ/xW3rfmASHi1dgHE4xI6Z7yMXGJfKDU
S2M785cRWeQOpuGPzQcsuYkfPlczIt4UCroyhgWAMtbX2iAWy3dG0dv7X8Cc
NJ/UXQlGhIs1/vVCQAk4kKaSdjJlQDIZS4Y+l0Cw+tGMp0eLAdH1fP/iEC8K
LmY1cIteY0AcmHhnOR6goDNHBM05z4CINotwxZBVgp8CFWQzK/SI28P7YRr/
fQedbEHqkT70CFdxYV5IZTV4U3pMUCCaDnHS6CPL8KoHiHByI6MfHYJ6vXHf
G6wHPbLPWcce0yHIo4yPwlcbQLyT2ZTDHTpEXW769En6RuBbR2m/eRSLV76X
UEz+BXLmaPV642mRICbBTUbPZmDecLo/PY4GGbaAiLjQHzBkT4cTDaJBhNKL
Jnts/gDuJpfJz640SGRG4v5a1h/wXs3KKUabBvHu4uzzO9cO7meHqq2w0SCe
QScpyUQ6wI8HxyZOhVEjubYXlaNvdoHww1fqxtypkISHmkv3BnsB0/llOZwl
FZKruJJK9l8f6BBT/86mRYUUHzqheT6oD0Q4XjflF6FC0rMk7x8R7wc7zP3d
e0OUCAvP+2yV0AEg//ZBwEtlSmThZ0YprfAQ8BA+MajMSoEYkr3Q5RQeBbIp
hx7U7pMj/pdxWhr3RkFQg7ii3Aw5spQ5sPMjahQImuUZXagmRwyM+VrdN0ZB
Pa/izKIzOcI8LLs+UzMGzBcubvB3kyHd2XpPp+0nAFWDsJLKexwS0/T1xPnF
aSC8xkSNC8Mh+rYFgxb8M4D8v5f0pR44RFvUh7vTYAZUed65IaSNQwSlcyy0
6mdAjrprmAATDjnmxd/1LWMWzCb4zzFt7INY3ts1x+3mganE2YVTRbtg/FNl
RiPjEvhV40UlH7UL9JwI7GTnl8Cg0XN6+we74PXyKdObKktg/GZk6hDfLpA3
yOM9+3wJ1B/8tZV9vQP8vxjVTeGWQcHY2L3pJ9ug4ZnG4PPtZUBc7WJ0UN0E
Tr05o8J7q0AqpP650LlNsBaYdaaCaw20Pb6svU2xCX7rDLKZKqwBvPt8a33Z
BlCpv60xG7IGpE2xc59/A9Teg3m7J9aB7t8qit/k68A9PphhEGwA9+5e1fcN
KyDzjZK/dOwWGLjsazCbuQIo4g/nHS/fArU+yqc0nq8AwlvnZrqhLWA+7O5s
KrcC/kM4qNiFt8GzySHTrNJl8JvQ0NBSsw16OXLS5rOXQG7uew/i1g44c7vX
fPHmAki9MUzItd4Hf5QaT8kxL4Dbwg37IHIfaFqPaNS1zIO4dtrSruJ9oJTz
85yPzjxIUlPiOkV5AMQD/NJi78+BpQZPiuXEA9AqcSU7MHQGZH6zKK+ywSF3
zimkHqOZBGfP7EVoJ5Mh9le/gIbmCYCXEmFpLSJDGq+FCpXHT4BiZSe2W3Vk
CGG2PVX7wgRYojLjklskQ1bYosK99ccBmaF3xUkCOVKY1/mzEo4Co8BYidBu
cuS10Jp2f+kQoGmI2L2Dp0R6/OdPl4YNAaneRAEpLkqkL3TQt8F0CLip+Koe
EadELNTCNd8zDQE9afETtXcokZP5aW937w+CN+Gs6GICJWJ05QS56NV+kBf4
zlVPkArZbkRG6YK7gZyh5HIlQo0gMfN71+S6gSRTfdu8BjWS8Om/1u2tLpBQ
GXeL3YwacQz4EEa06wLSD8oTlQOoEekCesUKnU4g66VVf7uOGiFSCcaFXG0H
qH/RZq8aDYLf/N7b9KgFBEqLU5Nr0yIfX368mifRAvBv0kutLGmReaGP146u
NwNNudCO7260yOQIu7Lz02aQde96q/pbWqQ6nsGj/dRvcFFoX7Z5AIt3rnJR
JzSA31ys5YgFHfLzjLLJZ50a8FdzKJnBih6Z3PMv/LlTDfwocNzJrvTIrMXH
D91J1cCayYZbIJAeQbXF2QbmqoCAhZooeTo9Eqr07LLJy++gfKtdaWYYO0ev
cpd6M6Bgt+XosutdBgTnGVHJdbsEdNn7iRRLMSKbfa9O7vcVg3c6fKU8ioxI
F8Wqwx2bYuD3q7rbS4MR0b3InGwTWASmPEyiKGwYEePhb/3brV9AJO98uGQ8
I+JgpO5AmZsHfCJdaS5vMCJSQjoU79TywH+n9b2ekzMh6pde7nCNfQYJBhW3
KpmYEJbOR+0HbrlgbTvlwz4PE2Ic3mITimaD8G/iR16pMSHIOtcr3oZ0EPVs
55hACpZvL2dVfCkdlHYoXpP/hDHU4CpLTwNvrlZlKJdgvMh2/iAkFSQ0DVcc
a8C4QqWU6XEyCM7/atGwxISgdfJfrxq9AwvGibpGMniEK+yonIhPAti0NNuU
UMDqtnZLpHnmW/DKr/jnKlZ3caVyfmEU8UBahQFeMsIjyAW8WMXMK/D0sIxF
pRcecfhKeazDIwo8vB0q1knEI4tFra+HByPB34GnvhJYnUfYvaqdr0eCdPmc
XY9fWN2/nXiGVT0cJDQUyjb8xVjU/VDS0RfAOME4+eEGVrdHbyze7vEFPImF
QkRBTFdIc5/ZZPIF+n3Pin+IYjrl+vkW62s+YFO5p7RcEtMlj8vMf7zyAs/J
pw5M5Um66CZhSNADlH62Dvmki40vL5N7Ch6B6dbcT4I+WPwCix/NLQdA3j5p
14npIlyqRhbvD3tQMWV81P4FFsf9urh1xxZUOGYy3yXpqq35+CXZ+4BefxTl
TcXyjzQE5vSbgfOn7zFyYboMFZ6R/xphCtLvM9JT5WBxiYc8zqeMwc3u/8hD
MV2Hgxz1I3U6IPOo9uWwSmy+Xln5twt3QJfYjlV7NcZiqnZhIlpgc5HyBM1P
LB+oZliuqYNLOjxL/CRdacbHNbqhCm5TUzIcJunOa/fLN8RugudeQ9GzbRir
Pth5f/YaoNH70a3TjbFV+przoAK4vvQjYuYvxixUtr9QeXCrpeiDVT/GNtcT
90evANP1iZ+nSLp3veOqqK800GvQ6NAh6WLziadGZpeA2LHVCx4TGJ+bZ08Z
FwOOvxrLPEi62rPe+XuKCJh+DZ56k3S3wePbxQfnQClHl5PtAsYeYoxMPXyg
9k3rexmSTu+pfJ53nhtc23i/tUjS8Sxqxax/TwKbzDHPEJLOF+D/tSfKAaJ/
PBNiWMc4KCL53kU84Dh6eK2M5BOkrN+y8tKAyfnf9FMkH4F7eNNPkQw8j9Qi
7JF8hoPfE5ftTULqZ/+wdZIPEUhv9zFcIlTXuaz/IfkUhzMqxuvjhDFBF9c4
ko9BL15gseklfF4iZ5Yj+R4uoT8LdM0ETrbW8iYSe7vhzn+AhBTDX0/l/vkq
Mg1y2izC3ydsGm/+ceT5xt1gwqf1jUsd/2M+pkZ1wowkhdjmP/Y2MPLFEX2f
L8sc/GOFXA0WRyLLoVLdmX9c3MnzMZ7IPuoR+I3EqLykzYVCou/8q5+OJE56
aSWaVEucPkjgxP+Ltxz20W8nsv7Q9A//59NeEjjoholHmgtwq6Tvk3RU9bjQ
LPHAZzaaQOKuLXKz6lXi8AlzWXvS9y+91BakvEd0yy/Y9yWtj+iC8tc5Cih+
Nv3vU9L6LSZdZtCnh53Ccu36pPVtDjqkTXkIvrxSPneatP4xuIuBwYdhZKT3
2TrS/am+16zWcBzSnhQP0FnDOLf71rItF+wJT6NrWCGNp2H41s8DXyFjJTyk
++3UK3Ky5iw89p/oS5NFjOMF/IX4hWAM/Xai/zzJN5az3JGWgM1NA9oe0xh/
RZ6clpKEUr+m6G9Nkn5Pn10tfS5D/2+qB5TjGBtrLij5IvC/TKVyXpJPE28e
mjx6Hf4ZFKHn7cC4ZbP58PpNmMs1pHKGtD/ezDnRUarDR9ZuKxTNGAuy8xIs
b0OBE9sJ7nXY/tsQUFp8oQ8f15whO1uOxcuvlX8ZMoQsNyyV1DGfhtN+NPpR
yBhqLZ0UuoftZ2+Pddk7naYw33R7QzibtD6dCt2U1tBj0t4l8g0Wt/nc6vfB
Bu5LH1GUisXi7UJUzmp2cP1krk5dJBY/MRoeNvgQ3ophs8wIxOJHl0MSFx/D
IYYeBi0n0nn0ZWKI1hl+F+HsUHqI5Rsn+gucd4GUlru8PDZYXOt42YNwN5h8
p+px3D0s3sJH+erPM+jnOt3mooKdR2YKdAVyXjChNgotvorFMw0jDht6Q39z
6qeDV7DzEHcnf2HcB+7fuRy4JMaMcFHIij2RD4DNYRx4hmNY/p6iuvb5MPjG
PEmDbwQ7v++xVOYrhcOZTMBL04ud144FBfTWEXCbec657Q8eYSGoqvsNRcLa
w89+nMfOe1w9Z42I5Us4HBrh25uBjZ8aCScTfANNbeJrVCwxdmwJr55MgXE9
ldTFHUxI3nelw2+fpkJCsniCaCPmyyyv+fzHlgYn1v7QxVQyIbhLeFirnA45
zsxWHs7BeFP5gKojE0ZvF+xSe2P55xoKKp7lwhTk6NgXrH6Kjh35pId8hlnB
TZK1R5kQB63NBlqKPBhXLl3znYEJsZIen3T4lQfbkpk3PFaweq9YOnvTuQAa
jLxUm67E6nnT/UkDtmJ4ndzZsEcPq/8yITNp4cXw2cLm9NtbWNzj43wyQwk8
WhApr4JgeuD5Kfx3+lIYzRBWasnHiGS2uV1vO/kVjm/nphTPYz5OarSO7w0R
NjMbMBQ+Y0C+vWnZv+FeDV2uiFUuhtEjQdKWZEGt1bCx915dlic9wiFAY1Qo
VAM1rWzLNR9iHBUjMjRSAwUnrX87qdMjf+ziO98b/oCl7N29u4foEX/Kuqpb
XvXwRPcnJknMBy4WuJcPwGaoSp4ReDKIFhm/V9TNt9sMpazJFhhdaRFWhpjs
OakWuDq5ur9wnxb5bmoqS1HYAtfJf8ZGXaVFDEbJvW/ktUL/v9l4pX0a5Gfi
lphr5R/IyR/RF/GIBsk86f6X+1o3PL5y5GagOjWiIOZYURreDb9K88ZbAGpk
/1ZtwfeObjjrJ55JEKFGdDt0J8WtemDHuV/23QzUiKkGVZF/5F8Y9zcw8lst
FbIqUYnOrPdBinMUL9RlqJC5smsGV8KGYE9MNr8tpn/HPuC+y5cOQe/GD1qv
MH28XoYa+IwMQUk5sncVuxSIXbLCYpb0MJz7HDOJ66ZArOpqM9JnhuFL6gl9
wygKZJQ8WOaK7ih8RdMsHkBGgRzl0jgrpT8BNS5sj94YJEM0BG84uUZNwGWX
/0bSGsmQ43SfjNZ/TMB1czWZg1IyhC6tSr/g4iT80P/AKy+KDHkXQLd3kn0K
jrDm4w5dJUNYApaC3/ROQ53WA9qJNBzSc0SmNCN+Hvqdu+Af370PXEfqxFy7
5qHA39v0aQX7ABZr63kdWYCsh90fFYfsg4kV5yyplwtwRJV3YP7KPvh5s7Az
5doiVL595XBF8h7Y0J5XaFRegvmytApU9rtAe8vf3dloBf4XFhs4x7gNptdT
/HU9VyDjO5VHjVNbwGFYlEw9cQX+JsePldRugRsv3lY86V+BpiyqPEXeW4D9
cRb4fm8VevxS3721tglqlDr8p++vwRd2915yDW0ASgqrU7FeG/BgUrrTo3oN
KLt/byj/sAF3R8Y6kJQ1AJczVpeqNmDzuNIPDt81IOR6jDGUdhPeuSVx7ACs
gcEvxSGO0ZvQ+3JwU9a3VZAaempvKHMLsgxHCbwpWwF3vlU+oR/YgS+UCAWD
35fAkXeSbrVUu/Bx1sHndx+WQKH1nb9hQruweh1hdfZeArtfSnqveOzCQxPJ
GY8JS4B49cXyiSN7cGG7zL2wfBF0RdWsx6ntwxdCjPq/XBbAoRbV4EkzHLod
/dWK7cMMaKYQ7ie64lCGs5WnSu7PAMbdlvZXITjUI8j1YZzgDDhzmY7/xhcc
asEe9pO9aBrgX8PoSnIytPtvs+924xQY8Rf4/OMDGVplk9SUSTsJjlAVfFca
IEcvcyxm9uaNgtrC/YSCZXJUhmit5+c5CjT1P/WfoKZAl50/LNrcHAXRzuGs
40IU6ISRouLe5AjwU/7+8o4HBaq9Y/JVjG8EfKwKzvRjp0T5f1ZlLGYNAePo
N/uiilRoMeuAV1Z9H7Dnf1hPq0uFJmkN/xfs0gd2Er41dNtQoc0KdOYL3H2g
uqRk0iKSCnUi07qn9qwXjHLsDZ/7S4XOElTLjKT+An76nA8XH1KjX2vb7lf8
6AIvmopOPI2kQePduK5cufEHaHnzEuk+0KCOcdKXLRj/gBO5qYNh+TRol/mt
TfKmNlCcDWXdW2lQ1fFGpdeabaDwyCGnbjZaNFE76c1Zk1bwLrD3eFYMLbpZ
LUr542UzqHx3+ndLGB1aqu4OQt7Wg6AjrE57CXRoF29Yvoh0PXDS6bfizKFD
q3l3ez911wHOpuUBiXo6NGEt6/aVE3VgJMDubi0VPep0/+5KVOYPsL4fbWzu
QY8ufkrKipmpBs7BL9YGdBlQxlaDkkw8CvheDpdZWjKgpakcF3X8IHiReJyn
z5kBnRyqTRCbIQLJ1VtOkdEMaNfVzmcGaAVQkJ2gO9LAgLJEnU/S9C4HnpWJ
YgFSjOgisBBY1CoBMN72QY8iIyrQwRZ3vbMY4NR23524zYg2r47R6OoXA65f
Ei4mDxhR75Grv32tioBywlupzSRGVP18Ieh89QWIrsiIyFIyoc1pt9gs5PJA
mknjjAILE+r9xu1+dvlnMK7rxirFibFNcETKRi7m22Ku9EkwoYuFSSfr3T4B
qrBBfy5TJjQv6p2n0fuPQD+bUtT1KxOaxBW3su2WBurYl7yb7+JRNHp8Dm8f
DwYjnouamOLRwc/c7nbv34CE6vK6Xhs8ylWdZLXxJw5oXknzjHmCxSvcUx/c
fA28EjNMKBPwKBJzOPm7bQwY+ZW3292FR5PWeI1v1YaDgnO5ZayDWP5WXotk
WhhQUZAMvDiBR3Gin+IlQkKBHHM29+U1PGpck1nHavcCCJ4i0l9iYUYRBaVV
dq/nIJI2OY5Cnhn1ns3MLsv1Ai8l3k10XmNG0c5o9ylpT2DdY/ky9hYziqN1
rwprfQqs9ondjboY26nh/Xg8gPz8NXZBe2z8npaS4jVnMP/cV0b5MRZfNQog
CDqBQ27CTmpu2PV6NCmUjz4GT9tZNjh8sfklRnM78Y9AVrWp7usYLN/mrsxi
nw2QOW1yei8Omw9gGkrGGhwK1iy+8Q6LU+18M8+yBPqDSpIpaRh/nLz+ptQc
BOAai6WLsHxqNodY4XtgZCvpv/FSLB7O7ms+aQAM8UvXPb5hcWL0Cj2qB/jG
lAQMqrB4UFfo5ndtQL0RSkbdjDGTdhsZhToQKnlyeKIV44chkREit0DHcXuv
/HaMWfqbzfyuA5WELnnyvxjP8t4xyVEE2c12L4P6MFYae/vj2VVwY1JWYHMA
Yy9VxUVnOdBxywb/chRj/inzvSwZIGDNpkscx5hRmf+KoxSIYY3saJ3EWIhe
ZPrpRUB8TDAvmcV4Zc3ngaooiMqbtQucxzjn+RmL00LgwkvLd8gixpxHloJY
BICburGN/QrGw7fXlATOAFq5ULKRVYzdDtodAjmBHH6oCFnHmCvOqNf+KMDb
Hw4I3MB40tAheYcVvDejflCyiXGpRye/Ih70XC2xbd7C2KHGezePBrwo0/Bq
3SZdn4bFhJccnK3jS6/YwVj9i3/PoR2CyZ+s/qhd0vW4BB5GrhBuv/M4q7aH
sffZbo0LMwQLFX2vNRKjyax6a0OEGbOLY/77GA9adDqLdxC0Bjl090iMcGTV
U9YRJDllO40OSPnMLB1vSwmDgzsmWST23s9/YZ5CKDX/u9FLYtxp+dwVPwJy
0z9u6x9nllStKBO+f6y9evCP0ZwXzAcVpeRvtub+cb9usNMD4pgix9eaf/MN
XKGyjCXi2wMDnpMYOeTZdDyP6OqlYSBK4qSoVx/2K4kUvlSgivT58lQvDa40
E6mf64kAEnsvc6287iXWvRc+n0r6flyB20Fq40T0pq/kMmk9vN9mijxcJFo/
8tU49299hMuPntsgjmh7PlMhrd/mwGdd3wOiSOZsuSZpfR3Y1UfaKCH3Qxu8
4r/1fyx0bIQeMh4qd+Ei3Z+Y3ztvyA9BMpHkyOg10u+xq7xl7hi0OO6ldI50
v40ZrusbnYbB5eXHs5YxbmpHX3znhozczwXMFzDuuXB+lEUQfn0eavl+DmOF
EAU6HRFo1Dbyu2oGY7JaTCCKQZ2Y4+d+TmAsntrLuSoJA0+ncmWOYUytpF1M
Lw09C1pVH41g7Li4zXv/CmzhO2IE+zEWKEq75SYP5b1Vyq7/If3+Gfm/dd6A
izmiEpItpN8XxzRTpyoM4GWgpGnC9uNtXd0yKg1YZTRQpfsD41HK8ithWtDs
l45bBbZ/vTmUhFTIDKEvX4X5n0KMz+BUqx/cg24fZgea8zDO7r83smcMfUcc
kj0yMX5kPD8LzeB+V4Nc9CvSevd/kOSygSzyf0I7orA4xa2unElb2GXyKBsX
hsVTOJrv1jyATxITg6n9sPPIZ6jqeb8DdIkwHOx+gOVX9vQM6zrD0lo7zUwC
Mzr49EVyxVVveG9tu0xVihlNsnDUsmTzgVrFfal/xZhRrvwvO41TPpAz0fJS
Fi823khJ62K2H0yuRSvY6bD8xCMM2n6BsD/xrsnlX3g0T+lwXJlaJPwiiGqr
1mDnuYxJtO9KJPQ9lp13vQKPsjzPOO/6Ngpm3Jhu3srB8nNenj68GQ0LZA0C
JEKw81ziSabnWCzsNOex5rmK1YdIscOFbxNgeO9JLV1pjM96eFC7vYNncwwr
3MSwehBzrjpZNxE+P0lz7elpPOpdYuP+kC0J3r3QNhqxzYQO5lU7Su5+gB4z
O3wbOUwoEsrPvC2TDo+87bs5k4zVs7VH2++b0uETrsfLDXFYvTw1e6HQLAOm
USjua/pj4zeyKC/HZsJx+0sH7npMKEvezybhI9kwwPG7nAwFExrp+DmpQiUP
JjjkJhxsMKKZdk/S/TLyoOqC16v8WUaUVu/Ys2TqfOh2d7+gv50R5bpg/mr5
Zz6UPbX08V4GI/rzh2YEm9EXeEL6fTPTNUYUF0BBQd1YDE8JWll+dGdAaYME
QwyriNCGXbL5nC0Dapz0djpPH8IHbHWfXhlgeiJ21713DcKrvhKXLwMGdLUX
vzf0GoW2BSNFqRQM6KBnMyVVXyWMvKP4RySYHrUjV75OHVsNUQ9DgeFAOnR3
8u5wXWU9lE2wfqfiSofGBEd48ws3QNqVGLVkCzpU1DzhePCbBvjbT2XmrCId
qh6t9NXUuRF2CAoHBJJheumgSdHtchMM6ftaUOhKixZyxBS3bTXD6Xb/oFw9
GvTIi7K21GPt8FRkk0qrMg26WEM1OGLUDgt4Nn7PSNKgOTLBHRmp7fBbSlwO
jo0GjdsSWSCKdUDLvpcXi+qp0cXgFGchzU64+/jsSQspapT/GcvxwzndMC7N
vOYXExUa5DYoo1bdD49R++VMbVOi1AfXfl49PgAPvLZdDiYoUaKyTlWFA+ZE
X0vJHPtOiTYdGetMYh6EnExi/HQulGgwi63e1cpBeCevpGCjlwKlZfP1XhMd
hsHHJpo3M8jR5R/ffJ/KjcEikz/TA7HkqL+nMP2lR2OQIG6hVuNHjlqduix6
7sMYrEz2NAu5R45WMH0Z/0I2Dt0FTVNojpKjYmcfVN2rGYfbRc31nQFk6NK8
1cs17UloHLCnE4H5g+v1+IlTyTMw0jDz0GMNHHqhtLYgpGsG/lc6b6QLcGjB
fLz3eeZZqDxTcVzgBA4V8pOxoXg2CyPU71RVpB3A7vKOm8z6c3AsICvNK2Af
lmct3bTjWoBtwr7D2yq70LBnqMfMcgm6tNM6v+DZhbuaJzr5gzCuiafh29uB
q0wP2ymyluDOE+pTT/N2oOx8gRTDzBL0tnuaUHp0B67nU5y74bAMC6/MRSZO
bsGX3rGHbb1W4KviZ2R5sRtw1E/fZC13DZZ+25RlebQBb9JsnUxrXYNBgtkv
fW9uwHi9Q/LW62uw1TLkfiLFBpz1nN8UJqxDx6xBtVLHdYi7wPw2pWkdurn4
7XzQWoMNsXdjWFc2YJUFt0uKwApk8C2zD1LehgPar2unaFcg1eywc4/tNjw7
cOm04tQydJusvS8VsQ0nrQqdZT4uw4D1t/JHO7YhdWmvr6DwMmRMPVSub74D
vdnk0y9cWoKlTRSO7b670N/95S/rsnlYmD4kKl67Dx9seIISr3nIiWPMT57e
hyxnmWMklebhccdrYxzMB/D6pf7yhrY5eDWBM/6w7gE8vZtce2dpFo48afS6
Pn0Ah0S9ttglZyB+15DjayAOrbuoXOE3MQHlth6VZX4iQ6WYhejsiiYgYTfo
Sg4kQ52saj4H+01APdrPyp9byND1jJLo+1wTcFYpNfTLGhnqSO0ulWIwDtNa
V1bzr5CjJmRnvdQHRuFrpzLPh7/I0VjftzPn8MPwqGIGs+QMBXpC/9nUyvAQ
XH8g2LexS4HurrmarpcMwY+v56eL8JRo331fyjTTIYiEPjPkF6dEBxLYP3z8
Oghx4cZf292wfTJw6Wb1dD8U/EEjqkNFha4KaFu6ne+B+dS3hIWOU6Ojb1pU
/+vrhnXUuw3FQtTorvJjDdeIbvjisRvnZUCNfhxUw+p3F0zlvnyL15waVb03
tM75sxN68CooR32iRrVxLrZOz9vhx7P8rzIJNKinz2SSs2ULzJ0ftxrXpUW5
79jrzp5rgfS8PCpnbWhRh9Ee7/HZZjhDrlal/4QWrd3eUDF3aoZSK1eo37+j
xXxQzfA+62/oc2xCLWSIFhVSYavbet0APY/qPB3Azq1FacYfJ41roF1xR3Oi
BT2qfFt7Z4m+BqqbhdPhnelRWcoYs/jialjLacv30I8eRafaFe+zVENJE9VM
6iR69D8zVo6WX9/hULbejaAuelTIrNTb6iEKjSxlWiqVMJ8nQ7BpjyyFfwOb
6x2OYj7MRv9OHUcpVI/01V/kwXxYjLHrxeQS6GvSQnNPFPN1ftb6D8uKoTjM
N6ZTYUSt+MjKLm0VwvHjhM4Id6wOKFr3eH3Lh8l2vKqandh8yW8P1wRlwszr
Pzr4A5hQLutms5ThDFimaa0FIplQXDG3uCnIgJP0JUJyb5lQ0TuGF2zJ0mH8
09evcPlYnRMkUuAzUuALrfIt279YHQsYUr0wkQhfyXwfHD6P1cn874rZS+9g
3aHOy4EXMZ9W2oUXJXsHWWk/prMBrM4uoFs8F97CwMWDh6MaWH6jm4JJzWu4
aNj21cwFj0bSZJHfb46CLSL0r+u+Ypyc0vOJLwq+l+T8Mv4dj6qH1nVJeUXC
6s7z9dP12HwPoj5XPQuHBjJZWRk9mG/05LQW7A+G6kcynyxvkj6PbAtdfRCU
7OktV8Qxo8Zfvpq8qwjE9lP/Uy8aTNfonrnsWh4AXQbGrqUfxnTHcnMpI7Mv
NNkhPIGiWL6EwGbqRR8Y4Fp5WfES5suq3nw5YeYNEUFrhvwrGCfQhTikPoNF
n08USV/HdJFsoZ3Friv0HV7/wW6K6ZrabkuvPw9gvfxwdXcodj2K4u96rHZw
TuOMtDVJZ9G7tAub2kClh16uQ7EYv//qdVPSEpqwxZ4PTcTyDZIoDNJN4M1v
Q5l1udj1INFj3NoYtgaXhyUWYPkG3DJ4dyPotP0TZ1CM5bteMxQ5oQeHdkNd
IytIOrLuik+WJjxqx7TTX4/lp7cpvGbSgEoK5Skbv7B4BJUpDbsa5Bcd+rhJ
8nXhj4cHolRgeEQV/NJB8qWl7+fZrsHCS55VD7oxxrPc/YkqwHDHT4dYejFu
iZVaj0Egh5nQE6Yhku51vJzjeAXaLVaHWZF0L6sjToxKGha0mnVnk3RxcrpZ
3o4E7FHBM85MYaz6uuzbXTHYGJQ7M07S1QqcZ8xmhOGit+daPUl3h2qVDhfz
QQ/TJI8bSyQdz2YbTeCGyfVtCxMk3c65mxSmdQq2rG/52pF0vdYpT/ZJDlgw
YCvWTdL9BrkKjefZodDlnE1hko/jrWKrZWOBra6WHTYkn6DsP8gtQAc32x//
jCD5CFH1Gjc5Cmio29KYQPIZpSG3VUt2ieGtWUNRJB8S+Q0NrlglDk6rUz0k
+RQu1c43DbPEw6cUJP8j+ZrmH1/ccSPEnO+Cj4f++bqo1pnHncRKho6vLiQf
lPSITMiknpjDIMe4SmLU9rJPXxlRsjjS4u4/3+VL7auYSnQcZqtL/8f5aaEJ
/sSrN69K/M/HZXIY5SgTvWIrU//n47zpRQMoCV+V9E/+z8cdF3J84EAo+039
bvafb/Ohj7V6TQgMHOX5/i9uxcj5JJ8gmEMo8CLx4MlqPqcqApVpsDIfiR02
WuiVWwm9BaYTBaTPh5v5qvCzn+AeGh0h8M+H7mrx700Qdoj08s9J36+r95tV
xhKhbnv8oIG0Hj/JY+17Nwl8TXb1Wzv/nmt8J47jgE0yQwoziTkCKS/eoQbz
pQYhTKT1lVKY8mlhBAFneQJWSPcDZ9wQl3UEqD2eK3Ql+fCgx40dmSfAyVO2
x06S7mdeMijN5gKaPD4B2SQf7zDD2uZ6Fkz0qnn6kXz+C634HtfzYK3kDssv
0nOA69+2yccvgPwL4YUHpOcE0W1iEYcugtPZXYCL9Pv7qaP/Yf8SSE+1FcaT
fJz5Q5E1YRkwySEhPUZ6DrHsJ610QQ5Yp9CgqoMkX3j9DBS8DuZXK2eYSfsj
7ITG7ZabQCBxHLnWhvF4Weu5VDVg8N/jDktsP3nXJb1mm9YEXXISHeak/Se5
fY5aXg8IZGaVqpL2Z2Ct0+e7BkDWwzCpuQyLq+ob7YUaAftk8RUZbD8jLx8z
J6eaAKbfdstN2P73XmytbTxsCVj2I2gnsPPBW4pz/PsbK8CFFG0VxpOem5ys
UhCxAaojvC/sMF/nvevyVvHFA2CvANPiMB+HvqHZbwtxBLdLaOLHPLD5l/kz
C2Meg4+hH7TJXDDGnVgUz3AC1MIUi9SPMHa5Gl0w5QJeNcX3/LbAxs/rPDKe
egIYJ0N97mpgcf+57earz4AU15/DNTcwnl85JpblCSbrYn4dV8J8npJy3Jd6
byC6Hf7LXxrzhdoihBO7fqDCK+WMFjcWD9OQzA8IAcb1lWem5jDfhTzUUckO
BayS3J7m43h0MIz5oK0rDBRmcUzV9uNRh+FBfTb+SJDMWssv9xuP6fi3v+Qb
ooGA0KsFxs9YPVC1tNmdiAOfVd1rmW2w8VQZb2XQNyBTJs6FwgSrRydfyUu/
iweJlVB6QAfjfeuKtPsJAIoNK6kpYvNLCT1FOZKA+xMXezbM93H1y18rv5cK
CjjpwmWbsHpH4bEQs5oKHE1Drn6twji47LNgaBrI+wCQM2VM6GLsoRdJVenA
qILcNDuFCXVoTLZU1coCTWPxLwtcmVDvgyQZI7LP4MhH1XfvT2D19m1hyLp2
MYhyiKeJuc2I6uaW503VFYNGs4821zDf5v241vM2oQQc3LcMmJJmRCez669F
ny8FRxcOX9w+w4iiS7ac80e/gj11wzq1BQY0k672IPEyEXyMVHva/5wBFeJJ
jcZ3VIHsUjDO+5EebXaJng8VqAZJqfl23W/p0c1s/oqBJ9WA0pTDySsMiwe8
UKPiqwFGYNs8yYEepQyp4TL1qQW6kuz2UpL0KFdjruy0aR2wQ9t0Ooh06OzC
AoHs128w4RJ/2bWWFj11X5p4kbsZsLpYTFwsokWvtzU8e2TUDI4Oh0pPpNCi
1AynO551NYPaFss73D606LpXteZiawuQy6Mn25emRZ9+6/ezGWoDt982B1vl
0KDhhomrv+93Ac49ycDN59SosiX6vqCgCygXDN++5USNGrCrxnLhukGAAQvd
GxNq9IgzRVBiQjdoP5RfeliWGlV6dKDC09sD6GeEyDIXqVA8m/QPdec+IJmD
LKnqUqGTUTnPVgOHwFEynNw7bkr04IcWn1TxEFD4eOBpz0yJfkoSpSKODgFl
QruUDKZ/F4ydOCPlh8Fl/YO0H+0U6EFjjdINshHArVjHnBdEgZoIlKzQhIwC
rQ1qs945cpQ5rGqppmkCaNzaPRRaTIba/+qeO041CcjfLJszpZCh+0m/+XJl
JoGvqbZeeAQZCnn1X4dnTYJbdw9/jrAiQ9vEw9zFg6aAksr7yJfHyVDe6czY
v+ozILHxXMg3TxwqWL69cAm/AORlLM6NR+5D2lpzm7prC6BU67LhmN0+ZMw/
RxXiswDgm7ft08r7cMRVrPLd2gJAXh/WpyPbh/zFZxL3Hi6ChjU2nvhHezD0
1OPZfKMlcFM1OuSi1i4kh+Qc72+ugFLuhvAUrm2YeDaGR9RuBQhcS79Qt7cF
7T+V6LWHrIBrv1zodnq2oOXCHlG/YQVkvOTn9I/dgpoche5aN1ZBx1HzD6IM
W/CmXkNDu+oa4E+5VHhsawMyZBnRMZltgJun+iO0B9dgpcrBw6LADcDz41ZX
xLc1GPnxzuDDnA3QfF6/tC9uDcqv7NAcX98A4hwJVKUaa1BgRi34yotNMDqp
LmpXvQpnXycKRRVtAfIW6YzdTysw9OWD7t4ju0DcQ7x9N3oJHrfr2r17ZRdw
auTd5XFcgtmqQ7hhs12Abb9D5hpLkFG2oPhQ/i7wt28o+o9lCWaWBZ+ZurEH
2tR42I5GLEJim8orOb994I3fzyTjXYBBwVvW9k9wiMGFCFyJ3gw8K7/k9jsM
h5Ryy9nv88zAxPvdTWJJOATn0z/tMTcNXcPyR7aqcYibkXQtm880vFVk/i0G
T4YYeDX11H2cgk5e4gZ9H8iQ+/riwI52EqonZo1t/SBHtuimVaLmRiFbrFWn
ag85EiSjaPujYhSeukv9/sMsOcKqkyJwKXwUhvbVA+QQBTJz6MxQ1YVRWHx6
rshIjwLhy1BniHUegcrWQX9pZimQsP2HuoKMw3Cj9Uy1IiMV0up4ck2+oR9q
bDML1JykQuJvcHjuPOmHz7RLD4MLVNjnlR/iF+6HW7qHeLk1qRAlgr5NR2Qf
HB+y5U9+TYVEvv5R9MawFyrfGIhzPEONUNoic8WMPfBi1fvBhAs0SMEUeQih
sh3eSf9jII3QIJuqIZra3u0wWef68d/qNIhAKbXDIGiHfqIFS32PaJDio3c0
bqB/4K33r+TCv9AgvOTt8261bdCDL/+A+yItkvPCiPL4ZAsM87hxxE6UDknY
y4n6u98IPzG6qzPJ0SFdqlcu+Uc2wgzFvOAkDTqEt/G9gQhPIyzWvf4swZEO
ccs06/G/0QBb+c3oJ77QIcaDrZPnMuvgbAX+UI4EPeKfXsFdE1kL9Qbkg/jO
MiA5I86b4scr4SNGYcPGiwwIbplmp7QehZ2n/bxNFBgQWcWnFQJPUZhXHndV
24QBoVUJyfSrgrCu6L+vFvEMCMujoQWvhxWwJznzBwMdI9KVrqnDzVkG58z6
zud1MiIOvSzm+mX5kElF4gPnCCNiRT+V36mTD8Odu4dd5hkR0Sjzks8beVCb
k9JrlZIJ0a2g2LGRyYPLcaWMrGJMiLqsk2pO2ieod8HHvjaACYmkPlg098qE
Lhvsu9SRGFcXn54Zy4BDvpck/otnQrjeZemPq2bAjtWsu1q5TAiLeESgoEA6
ZBkqzc1qZ0KShtck7TdS4Ocvz07Fc+GRJCsJxlXKJPjHxdD73Tk8gqiwFFqc
eQ8VRCyCQsXxiPfttGDClUSolRenKqyAR7j2Mnn/+CTA+QeP2N0s8AguoeFt
6JU3UOBGxB5fBjZf+Tp7hctLSF5Bvd6bi0cc1NrQW7+jYce96gLPYjwi2pfO
nnA+Gt4YNVT0rcHGn596prIQCeW+jNsFDWPXn7esfX01DBrriAs+52BGkp6r
VM1pBcCzBgsl708zI8aSVC9c9fyh596JoXf8zAjqRGFSbOkHX6V+qL/2HzMy
WN/o3xfnA2diWazVVbG4pQv+XNpTKH7NFoRpMSO4Cslidr4nMJm/DcnVw+L8
HRQRBe4Q/2guMsECi7+UTyGsucCcYB7ac8+wOM9M8TSrIxx+wNcZ4IuxbZHb
p00HaFnk/rCW1Af1LopD/M9DyH899fdyFKmv7eLWVJ8tdHAa59lIZUa8Pwxl
k62aQ41weOhRFhbn/br42s4MGpdzuDR9wuYb8rFI3jSB+gH6zySKsfguI14u
2ghq8/+NTCO9f7P70e7E0zvwpHitjHQdxqf/C+cPvg37HTyPFTRiLDfuLVek
AaXeUqrfIPWNlX/gtPh1EzZ1fY+3I/WVpRz5fvKPCsxlvbDrQOqz9N1Zozt0
DXqfeDXFPYBx9PvUMD55qPffA+tmUl+aumq91jKAwXsfJ4xHMS5Of824LgNp
ab/WCZLeR8q5UX5AfhFOht/hMSf1Vaop/pKlFIf37WYt/vVVeke6bKSIwMOL
KvEmpD5KkYyIxQA+eDu43oef1GcXGpJn/O0MlHX+Kt9E6qOkFKB81skJr8xH
deuS+vQmjXTIOI5CBT2aq7Wk96t69bakBFmh/W3mp0dIfX7GnGwcuwxQOK/X
R4XUB2j8uQClpoLZLwY17pH6BDnOOVlk7hMTrtVP6fzro7zlZBG0RryfEHhN
4t/7YDFSFD2zxLgYBeslEi+KbZqdHyb+fmV7K5rUp4iro8mnaSeOW6UtH/7X
97ixThFcQ3wu0a3z9N/7aW5fc88XEFkDhJ7W/OMwnfPBscTJ2xT3lv7lzyIX
g+8T///33/4PQT9+NA==
       "]]}},
    Axes->None,
    AxesOrigin->{0, 0},
    ImageSize->Tiny,
    PlotRange->{{-3.9999985976222385`, 4.}, {-3.9999983113746937`, 
     3.999998539294041}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwsl3k81N/3x4VEIpUkIYRU2lD5aDktSCWVUkiyk61SSiWJFiRJWZItRUi2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       "]]}},
    Axes->None,
    AxesOrigin->{0, 0},
    ImageSize->Tiny,
    PlotRange->{{-1.5973369454014317`, 
     1.6153846153846154`}, {-1.6108555279077268`, 1.6108177620144217`}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lattice3D", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Lattice3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ListLinePlot3D", "Subsubsection"],

Cell[BoxData[
 RowBox[{"<<", "PwM`RandomWalks`"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk", "=", 
   RowBox[{"RandomWalk", "[", 
    RowBox[{"1500", ",", 
     RowBox[{"Dimension", "\[Rule]", "3"}], ",", 
     RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}]}], ";", 
  RowBox[{"ListLinePlot3D", "[", "walk", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"ListLinePlot3D", "[", 
  RowBox[{"walk", ",", 
   RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
   RowBox[{"MeshStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"PointSize", "[", "Small", "]"}], ",", "Gray"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", 
      RowBox[{"Thickness", "[", ".005", "]"}]}], "}"}]}], ",", 
   RowBox[{"FaceGrids", "\[Rule]", "All"}]}], "]"}]], "Input"],

Cell["Multiple datasets:", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "15", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"ListLinePlot3D", "[", "data", "]"}]}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["PointInPolygonQ", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"poly", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.5"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.", ",", 
       RowBox[{"-", "1.1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.5", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7500", ",", "2"}], "}"}]}], "]"}]}], ";"}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gbPts", "=", 
   RowBox[{"GatherBy", "[", 
    RowBox[{"pts", ",", 
     RowBox[{
      RowBox[{"PointInPolygonQ", "[", 
       RowBox[{"poly", ",", "#"}], "]"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"PointSize", "[", "Small", "]"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"PointInPolygonQ", "[", 
          RowBox[{"poly", ",", 
           RowBox[{"gbPts", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}], ",", "gbPts", 
         ",", 
         RowBox[{"Reverse", "[", "gbPts", "]"}]}], "]"}], "/.", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"in_List", ",", "out_List"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Blue", ",", 
            RowBox[{"Point", "@", "in"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Pink", ",", 
            RowBox[{"Point", "@", "out"}]}], "}"}]}], "}"}]}]}]}], "}"}], ",",
     "Thick", ",", 
    RowBox[{"Line", "[", 
     RowBox[{"poly", "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PointSize", "[", "Large", "]"}], ",", 
    RowBox[{"Point", "[", "poly", "]"}]}], "\[IndentingNewLine]", "}"}], 
  "]"}]}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ProteinDotPlot", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"seq1", "=", 
   RowBox[{"ProteinData", "[", "\"\<SCNN1A\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"seq2", "=", 
   RowBox[{"ProteinData", "[", "\"\<SCNN1G\>\"", "]"}]}], ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{"ProteinDotPlot", "[", 
  RowBox[{"seq1", ",", "seq2", ",", "\[IndentingNewLine]", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<SCNN1A\>\"", ",", "\"\<SCNN1G\>\""}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"LabelStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "11"}], 
     "}"}]}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ProteinSpaceFillingPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{"ProteinSpaceFillingPlot", "[", "\"\<PAK1\>\"", "]"}]], "Input"],

Cell["Test for missing data:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProteinSpaceFillingPlot", "[", "\"\<ACR\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"Missing", "[", "\<\"NotAvailable\"\>", "]"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomCompose", "Subsubsection"],

Cell[BoxData[
 RowBox[{"RandomCompose", "[", 
  RowBox[{"20", ",", "\"\<Vibraphone\>\""}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomWalkPi", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"walk", "=", 
   RowBox[{"RandomWalkPi", "[", 
    RowBox[{"10000", ",", "5"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "walk", "]"}]}], ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"walk", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", ".2", "]"}], ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Range", "[", "len", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["RootPlot", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RootPlot", "[", 
  RowBox[{
   RowBox[{"Sinc", "[", "z", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw1d3dcze//flradU57nXMaigYVRYr7zigRJVRoaEqIIkLy1hItKaESDU3t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   "], {{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1wf4jnUbxvE/svdWIqNssqKpra1SGkZDaUcpGkJR0V4aZGbvTYhCaWjv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       "]]}}, {
     {RGBColor[1, 0, 0], PointSize[Medium], 
      PointBox[{780, 781, 782, 783, 784, 785}]}, {}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-10, 10}, {-0.21723362469079935`, 0.9999996050945518}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RootPlot", "[", 
  RowBox[{
   RowBox[{"z", " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"z", "+", 
      RowBox[{
       SqrtBox["2"], 
       RowBox[{"Sin", "[", "z", "]"}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "20"}], ",", "20"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"MeshStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{
      RowBox[{"Opacity", "[", "0.5", "]"}], ",", 
      RowBox[{"PointSize", "[", "Medium", "]"}]}], "]"}]}], ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw0l/dfjo/799tbe8+rXVfrGg2KzqNCEskqklWJBlJEKCTpTUNGIVIhDVK0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   "], {{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl2AXYFtXaxfGXRkC6uwQp6ZDuVLqluxFQEFBSbErAViQVlBCQRkAFFRAk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       "]]}}, {
     {PointSize[Medium], Opacity[0.5], 
      PointBox[{1903, 1904, 1905, 1906, 1907, 1908, 1909, 1910, 1911, 1912, 
       1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920, 1921, 1922, 1923, 1924,
        1925, 1926}]}, {}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  GridLines->Automatic,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SimpleClosedPath", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"PathPlot", "[", 
  RowBox[{"SimpleClosedPath", "[", "pts", "]"}], "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["StandardDeviationPlot", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"5", ",", "8"}], "]"}], ",", 
     RowBox[{"{", "600", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"StandardDeviationPlot", "[", 
  RowBox[{"data", ",", "2"}], "]"}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"5", ",", "8"}], "]"}], ",", 
     RowBox[{"{", "600", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"StandardDeviationPlot", "[", 
  RowBox[{"data", ",", "1.5", ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PointSize", "@", "Medium"}], ",", "Black"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PointSize", "@", "Medium"}], ",", "Gray"}], "}"}]}], 
     "}"}]}]}], "]"}]}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["TrendPlot", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"FinancialData", "[", 
    RowBox[{"\"\<^DJI\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<August 30 2011\>\"", ",", "\"\<December 30 2011\>\""}], 
      "}"}]}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rates", "=", 
   RowBox[{"{", 
    RowBox[{"0.05", ",", "0.12", ",", 
     RowBox[{"-", "0.05"}], ",", 
     RowBox[{"-", "0.12"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"TrendPlot", "[", 
  RowBox[{"data", ",", "rates", ",", "\[IndentingNewLine]", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", "Blue"}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"TrendlineStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", "Dashed", ",", 
      RowBox[{"Lighter", "@", "Gray"}]}], "}"}]}]}], "]"}]}], "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{976, 1128},
WindowMargins->{{Automatic, 420}, {0, Automatic}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 71, 1, 83, "Section",
 InitializationGroup->True],
Cell[653, 25, 398, 13, 34, "Text"],
Cell[CellGroupData[{
Cell[1076, 42, 30, 0, 42, "Subsection"],
Cell[1109, 44, 137, 4, 33, "Input"],
Cell[1249, 50, 239, 6, 33, "Input"],
Cell[1491, 58, 146, 4, 33, "Input"],
Cell[1640, 64, 368, 9, 53, "Input"],
Cell[2011, 75, 140, 4, 33, "Input"],
Cell[2154, 81, 147, 4, 33, "Input"],
Cell[2304, 87, 241, 7, 33, "Input"],
Cell[2548, 96, 256, 8, 33, "Input"],
Cell[2807, 106, 846, 18, 91, "Input"],
Cell[3656, 126, 157, 4, 33, "Input"],
Cell[3816, 132, 173, 5, 33, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4026, 142, 34, 0, 31, "Subsection"],
Cell[4063, 144, 100, 2, 78, "Input"],
Cell[CellGroupData[{
Cell[4188, 150, 172, 3, 78, "Input"],
Cell[4363, 155, 59, 0, 97, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[4471, 161, 57, 0, 31, "Subsection"],
Cell[4531, 163, 318, 7, 72, "Input"],
Cell[4852, 172, 288, 7, 72, "Input"],
Cell[5143, 181, 226, 5, 33, "Input"],
Cell[5372, 188, 306, 6, 72, "Input"],
Cell[5681, 196, 304, 6, 72, "Input"],
Cell[5988, 204, 296, 7, 72, "Input"],
Cell[6287, 213, 470, 10, 91, "Input"],
Cell[6760, 225, 397, 10, 72, "Input"],
Cell[7160, 237, 390, 9, 72, "Input"],
Cell[7553, 248, 153, 4, 33, "Input"],
Cell[7709, 254, 358, 8, 72, "Input"],
Cell[8070, 264, 291, 7, 72, "Input"],
Cell[8364, 273, 557, 11, 72, "Input"],
Cell[8924, 286, 337, 7, 72, "Input"],
Cell[9264, 295, 322, 7, 53, "Input"],
Cell[9589, 304, 443, 11, 72, "Input"],
Cell[10035, 317, 275, 7, 53, "Input"],
Cell[10313, 326, 480, 10, 110, "Input"],
Cell[10796, 338, 373, 8, 53, "Input"],
Cell[11172, 348, 208, 5, 53, "Input"],
Cell[11383, 355, 528, 11, 72, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[11948, 371, 29, 0, 31, "Subsection"],
Cell[11980, 373, 185, 5, 63, "Input"],
Cell[12168, 380, 158, 4, 63, "Input"],
Cell[12329, 386, 620, 15, 251, "Input"],
Cell[12952, 403, 281, 8, 63, "Input"],
Cell[13236, 413, 248, 7, 63, "Input"],
Cell[13487, 422, 295, 8, 63, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[13819, 435, 30, 0, 31, "Subsection"],
Cell[13852, 437, 182, 5, 53, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[14071, 447, 37, 0, 31, "Subsection"],
Cell[14111, 449, 74, 1, 63, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[14222, 455, 63, 0, 31, "Subsection"],
Cell[14288, 457, 1829, 51, 260, "Input"],
Cell[16120, 510, 1647, 43, 260, "Input"],
Cell[17770, 555, 803, 25, 112, "Input"],
Cell[18576, 582, 867, 25, 141, "Input"],
Cell[19446, 609, 447, 12, 82, "Input"],
Cell[19896, 623, 1963, 50, 350, "Input"],
Cell[21862, 675, 808, 27, 120, "Input"],
Cell[22673, 704, 2587, 71, 378, "Input"],
Cell[25263, 777, 2987, 77, 646, "Input"],
Cell[28253, 856, 745, 23, 112, "Input"],
Cell[29001, 881, 1327, 36, 290, "Input"],
Cell[30331, 919, 2512, 77, 260, "Input"],
Cell[32846, 998, 710, 20, 112, "Input"],
Cell[33559, 1020, 2236, 59, 350, "Input"],
Cell[35798, 1081, 1287, 37, 231, "Input"],
Cell[37088, 1120, 1574, 47, 201, "Input"],
Cell[38665, 1169, 1072, 30, 201, "Input"],
Cell[39740, 1201, 1233, 35, 171, "Input"],
Cell[40976, 1238, 3745, 100, 527, "Input"],
Cell[44724, 1340, 4229, 115, 616, "Input"],
Cell[48956, 1457, 402, 13, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[49395, 1475, 41, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[49461, 1479, 51, 1, 63, "Input"],
Cell[49515, 1482, 67, 0, 63, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[49631, 1488, 32, 0, 31, "Subsection"],
Cell[49666, 1490, 58, 1, 63, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49773, 1497, 27, 0, 83, "Section"],
Cell[CellGroupData[{
Cell[49825, 1501, 34, 0, 42, "Subsection"],
Cell[49862, 1503, 37, 0, 96, "Text"],
Cell[49902, 1505, 30, 0, 97, "Input"],
Cell[49935, 1507, 183, 6, 96, "Text"],
Cell[50121, 1515, 68, 1, 97, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[50226, 1521, 41, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[50292, 1525, 58, 1, 63, "Input"],
Cell[50353, 1528, 289, 4, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[50679, 1537, 67, 1, 63, "Input"],
Cell[50749, 1540, 257, 4, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[51043, 1549, 53, 1, 63, "Input"],
Cell[51099, 1552, 205, 3, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[51341, 1560, 58, 1, 63, "Input"],
Cell[51402, 1563, 281, 4, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[51720, 1572, 58, 1, 63, "Input"],
Cell[51781, 1575, 290, 4, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[52108, 1584, 57, 1, 63, "Input"],
Cell[52168, 1587, 270, 4, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[52475, 1596, 54, 1, 63, "Input"],
Cell[52532, 1599, 486, 7, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[53055, 1611, 52, 1, 63, "Input"],
Cell[53110, 1614, 421, 6, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[53568, 1625, 57, 1, 63, "Input"],
Cell[53628, 1628, 388, 6, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[54053, 1639, 58, 1, 63, "Input"],
Cell[54114, 1642, 355, 5, 135, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[54506, 1652, 66, 1, 63, "Input"],
Cell[54575, 1655, 261, 4, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[54873, 1664, 57, 1, 63, "Input"],
Cell[54933, 1667, 577, 8, 141, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[55547, 1680, 56, 1, 63, "Input"],
Cell[55606, 1683, 354, 5, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[55997, 1693, 55, 1, 63, "Input"],
Cell[56055, 1696, 340, 5, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[56432, 1706, 51, 1, 63, "Input"],
Cell[56486, 1709, 480, 7, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[57003, 1721, 59, 1, 63, "Input"],
Cell[57065, 1724, 250, 3, 95, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[57352, 1732, 64, 1, 63, "Input"],
Cell[57419, 1735, 454, 6, 175, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[57910, 1746, 52, 1, 63, "Input"],
Cell[57965, 1749, 164, 2, 95, "Print"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[58178, 1757, 56, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[58259, 1761, 40, 0, 30, "Subsubsection"],
Cell[58302, 1763, 142, 4, 51, "Input"],
Cell[58447, 1769, 393, 10, 82, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[58877, 1784, 49, 0, 21, "Subsubsection"],
Cell[58929, 1786, 98, 2, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[59064, 1793, 35, 0, 21, "Subsubsection"],
Cell[59102, 1795, 90, 2, 83, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[59229, 1802, 40, 0, 21, "Subsubsection"],
Cell[59272, 1804, 428, 13, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[59737, 1822, 40, 0, 21, "Subsubsection"],
Cell[59780, 1824, 211, 5, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[60028, 1834, 39, 0, 21, "Subsubsection"],
Cell[60070, 1836, 325, 10, 82, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[60432, 1851, 36, 0, 21, "Subsubsection"],
Cell[CellGroupData[{
Cell[60493, 1855, 812, 23, 141, "Input"],
Cell[61308, 1880, 108439, 1813, 226, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[169796, 3699, 34, 0, 21, "Subsubsection"],
Cell[169833, 3701, 294, 9, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[170164, 3715, 39, 0, 21, "Subsubsection"],
Cell[170206, 3717, 60, 1, 51, "Input"],
Cell[170269, 3720, 281, 7, 82, "Input"],
Cell[170553, 3729, 469, 12, 82, "Input"],
Cell[171025, 3743, 34, 0, 50, "Text"],
Cell[171062, 3745, 253, 7, 82, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[171352, 3757, 40, 0, 21, "Subsubsection"],
Cell[171395, 3759, 957, 33, 112, "Input"],
Cell[172355, 3794, 1598, 47, 260, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[173990, 3846, 39, 0, 21, "Subsubsection"],
Cell[174032, 3848, 250, 7, 82, "Input"],
Cell[174285, 3857, 433, 11, 112, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[174755, 3873, 48, 0, 21, "Subsubsection"],
Cell[174806, 3875, 87, 1, 51, "Input"],
Cell[174896, 3878, 38, 0, 50, "Text"],
Cell[CellGroupData[{
Cell[174959, 3882, 86, 1, 51, "Input"],
Cell[175048, 3885, 80, 1, 51, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[175177, 3892, 38, 0, 21, "Subsubsection"],
Cell[175218, 3894, 107, 2, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[175362, 3901, 37, 0, 21, "Subsubsection"],
Cell[175402, 3903, 248, 7, 82, "Input"],
Cell[175653, 3912, 382, 10, 82, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[176072, 3927, 33, 0, 21, "Subsubsection"],
Cell[CellGroupData[{
Cell[176130, 3931, 198, 6, 51, "Input"],
Cell[176331, 3939, 19093, 319, 462, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[195461, 4263, 648, 18, 153, "Input"],
Cell[196112, 4283, 46687, 771, 462, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[242848, 5060, 41, 0, 21, "Subsubsection"],
Cell[242892, 5062, 186, 6, 51, "Input"],
Cell[243081, 5070, 106, 2, 51, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[243224, 5077, 46, 0, 21, "Subsubsection"],
Cell[243273, 5079, 342, 9, 82, "Input"],
Cell[243618, 5090, 650, 19, 112, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[244305, 5114, 34, 0, 21, "Subsubsection"],
Cell[244342, 5116, 251, 7, 51, "Input"],
Cell[244596, 5125, 600, 15, 141, "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
