(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     92247,       1969]
NotebookOptionsPosition[     87873,       1819]
NotebookOutlinePosition[     88978,       1857]
CellTagsIndexPosition[     88774,       1849]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PwM`Chap11Dynamic`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic",
  FontVariations->{"Underline"->True}]
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Name", ":", " ", "PwM`Chap11Dynamic`"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Book", ":", " ", 
    RowBox[{"Programming", " ", "with", " ", 
     RowBox[{"Mathematica", ":", " ", 
      RowBox[{"An", " ", "Introduction"}]}]}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "contains", " ", "the", " ", "functions", 
      " ", "defined", " ", "in", " ", "Chapter", " ", "11"}]}]}], ",", " ", 
   RowBox[{"Dynamic", " ", 
    RowBox[{"expressions", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "PwM`Chap11Dynamic`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Copyright", ":", " ", 
     RowBox[{"Copyright", " ", "2012"}]}]}], ",", " ", 
   RowBox[{"Cambridge", " ", "University", " ", "Press"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"Amino", " ", "acid", " ", "plot"}]}]}], ",", " ", "epicycloid", 
   ",", " ", "hypocycloid"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Chap11Dynamic", ".", "nb"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", 
     RowBox[{"8.0", ".4"}]}]}]}], " ", "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"AminoAcidPlot", ",", "HypocycloidPlot"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<PwM`Chap11Dynamic`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AminoAcidPlot", "::", "usage"}], "=", "\"\<AminoAcidPlot[\!\(\*
StyleBox[\"aa\", \"TI\"]\)] plots the amino acid \!\(\*
StyleBox[\"aa\", \"TI\"]\) as a colored structure diagram. A second argument \
can be given to specify a different visualization, including \
\\\"StructureDiagram\\\", \\\"CHColorStructureDiagram\\\", \
\\\"CHStructureDiagram\\\", \\\"ColorStructureDiagram\\\", \\\"MoleculePlot\\\
\", \\\"SpaceFillingMoleculePlot\\\".\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EpicycloidPlot", "::", "usage"}], "=", "\"\<EpicycloidPlot[\!\(\*
StyleBox[\"R\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"r\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"\[Theta]\", \"TI\"]\)] displays a plot of a epicycloid generated \
by rolling a circle of radius \!\(\*
StyleBox[\"r\", \"TI\"]\) outside of a fixed circle of radius \!\(\*
StyleBox[\"R\", \"TI\"]\). The angle \[Theta] is the parameter that \
determines how far along the curve to sketch.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HypocycloidPlot", "::", "usage"}], "=", "\"\<HypocycloidPlot[\!\(\*
StyleBox[\"R\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"r\", \"TI\"]\)\!\(\*
StyleBox[\",\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)\!\(\*
StyleBox[\"\[Theta]\", \"TI\"]\)] displays a plot of a hypocycloid generated \
by rolling a circle of radius \!\(\*
StyleBox[\"r\", \"TI\"]\) inside of a fixed circle of radius \!\(\*
StyleBox[\"R\", \"TI\"]\). The angle \[Theta] is the parameter that \
determines how far along the curve to sketch.\>\""}], ";"}]], "Input"]
}, Closed]],

Cell["Options", "Subsection"],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AminoAcidPlot", "[", 
   RowBox[{"aa_String", ",", 
    RowBox[{"diagram_:", "\"\<ColorStructureDiagram\>\""}]}], "]"}], ":=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Framed", "[", 
     RowBox[{
      RowBox[{"ChemicalData", "[", 
       RowBox[{"aa", ",", "diagram"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "All"}]}], "]"}], ",", 
    RowBox[{"ChemicalData", "[", 
     RowBox[{"aa", ",", "\"\<Name\>\""}], "]"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"\"\<Menu\>\"", ",", "9"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EpicycloidPlot", "[", 
   RowBox[{"R_", ",", "r_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"epicycloid", ",", "center"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"epicycloid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_"}], "}"}], ",", "t_"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Cos", "[", "t", "]"}]}], "-", 
         RowBox[{"b", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Sin", "[", "t", "]"}]}], "+", 
         RowBox[{"b", " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}]}], "}"}]}], ";", 
     RowBox[{
      RowBox[{"center", "[", 
       RowBox[{"th_", ",", "R1_", ",", "r2_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"R1", "+", "r2"}], ")"}], 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "th", "]"}], ",", 
         RowBox[{"Sin", "[", "th", "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"epicycloid", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"R", ",", "r"}], "}"}], ",", "t"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "\[Theta]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Thick", ",", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "R"}], "]"}]}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Circle", "[", 
              RowBox[{
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", "r"}], 
              "]"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], "]"}]}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"center", "[", 
                  RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", 
                 RowBox[{"epicycloid", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], 
                  "]"}]}], "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"epicycloid", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], "]"}], 
               "]"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "}"}],
        ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"1.5", 
         RowBox[{"(", 
          RowBox[{"R", "+", "r"}], ")"}]}]}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HypocycloidPlot", "[", 
   RowBox[{"R_", ",", "r_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"hypocycloid", ",", "center"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"hypocycloid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_"}], "}"}], ",", "t_"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "-", "b"}], ")"}], " ", 
          RowBox[{"Cos", "[", "t", "]"}]}], "+", 
         RowBox[{"b", " ", 
          RowBox[{"Cos", "[", 
           FractionBox[
            RowBox[{"t", " ", 
             RowBox[{"(", 
              RowBox[{"a", "-", "b"}], ")"}]}], "b"], "]"}]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "-", "b"}], ")"}], " ", 
          RowBox[{"Sin", "[", "t", "]"}]}], "-", 
         RowBox[{"b", " ", 
          RowBox[{"Sin", "[", 
           FractionBox[
            RowBox[{"t", " ", 
             RowBox[{"(", 
              RowBox[{"a", "-", "b"}], ")"}]}], "b"], "]"}]}]}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"center", "[", 
       RowBox[{"th_", ",", "R1_", ",", "r2_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"R1", "-", "r2"}], ")"}], " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "th", "]"}], ",", 
         RowBox[{"Sin", "[", "th", "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"hypocycloid", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"R", ",", "r"}], "}"}], ",", "t"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "\[Theta]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Thick", ",", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "R"}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"Circle", "[", 
              RowBox[{
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", "r"}], 
              "]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", ".02", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], "]"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"center", "[", 
                  RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", 
                 RowBox[{"hypocycloid", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], 
                  "]"}]}], "}"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"PointSize", "[", ".02", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"hypocycloid", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], "]"}], 
               "]"}]}], "}"}]}], "}"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "PwM`Chap11Dynamic`"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AminoAcidPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"AminoAcidPlot[\!\(\*\\nStyleBox[\\\"aa\\\", \\\"TI\\\"]\)] \
plots the amino acid \!\(\*\\nStyleBox[\\\"aa\\\", \\\"TI\\\"]\) as a colored \
structure diagram. A second argument can be given to specify a different \
visualization, including \\\"StructureDiagram\\\", \
\\\"CHColorStructureDiagram\\\", \\\"CHStructureDiagram\\\", \
\\\"ColorStructureDiagram\\\", \\\"MoleculePlot\\\", \
\\\"SpaceFillingMoleculePlot\\\".\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563773686-4331758"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "EpicycloidPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"EpicycloidPlot[\!\(\*\\nStyleBox[\\\"R\\\", \
\\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\" \
\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\"r\\\", \
\\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\" \
\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\"\[Theta]\\\", \\\"TI\\\"]\)] \
displays a plot of a epicycloid generated by rolling a circle of radius \
\!\(\*\\nStyleBox[\\\"r\\\", \\\"TI\\\"]\) outside of a fixed circle of \
radius \!\(\*\\nStyleBox[\\\"R\\\", \\\"TI\\\"]\). The angle \[Theta] is the \
parameter that determines how far along the curve to sketch.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563775057-5557000"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "HypocycloidPlot"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"HypocycloidPlot[\!\(\*\\nStyleBox[\\\"R\\\", \\\"TI\\\"]\)\!\(\
\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\"r\\\", \
\\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\" \
\\\", \\\"TI\\\"]\)\!\(\*\\nStyleBox[\\\"\[Theta]\\\", \\\"TI\\\"]\)] \
displays a plot of a hypocycloid generated by rolling a circle of radius \!\(\
\*\\nStyleBox[\\\"r\\\", \\\"TI\\\"]\) inside of a fixed circle of radius \
\!\(\*\\nStyleBox[\\\"R\\\", \\\"TI\\\"]\). The angle \[Theta] is the \
parameter that determines how far along the curve to sketch.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563773829-1283229"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["AminoAcidPlot", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChemicalData", "[", "\"\<AminoAcids\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Glycine\"\>", ",", "\<\"LAlanine\"\>", ",", "\<\"LSerine\"\>", 
   ",", "\<\"LProline\"\>", ",", "\<\"LValine\"\>", ",", "\<\"LThreonine\"\>",
    ",", "\<\"LCysteine\"\>", ",", "\<\"LIsoleucine\"\>", 
   ",", "\<\"LLeucine\"\>", ",", "\<\"LAsparagine\"\>", 
   ",", "\<\"LAsparticAcid\"\>", ",", "\<\"LGlutamine\"\>", 
   ",", "\<\"LLysine\"\>", ",", "\<\"LGlutamicAcid\"\>", 
   ",", "\<\"LMethionine\"\>", ",", "\<\"LHistidine\"\>", 
   ",", "\<\"LPhenylalanine\"\>", ",", "\<\"LArginine\"\>", 
   ",", "\<\"LTyrosine\"\>", ",", "\<\"LTryptophan\"\>"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"AminoAcidPlot", "[", "\"\<Glycine\>\"", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AminoAcidPlot", "[", 
  RowBox[{"\"\<LTryptophan\>\"", ",", "\"\<MoleculePlot\>\""}], 
  "]"}]], "Input"],

Cell[BoxData[
 TemplateBox[{FrameBox[
    Graphics3DBox[{
      AbsoluteThickness[3], 
      EdgeForm[None], 
      Specularity[
       GrayLevel[1], 100], 
      GraphicsComplex3DBox[CompressedData["
1:eJwlkw9ME2cYxivbGHHDmYY5Np1S6AwEBMwmU0nXt6uI1E3WzrbUtsCVlkKF
ltICpeNPgDiNaIA4EWUKDocwRV39M4ekvk501bmGIZkr4CozS9hQRPw3BGTf
3V3y5XJf7t7veX7PczydRWYI4HA4MWS9RJapx74ntM8CbfN6XuGuE+OaM55i
d0k+aup+ehLpLQLeqcKchoOJcHzJFn3inB5fD4jevuiZDXLC8xxOnhysi4Pv
rPgsBcmuz2vLgfExXBPRLwNF9ZWRGycnLnankC9SVcBtbW/sSgoH/Q3tRs/7
UiwXrkrvlmdCk5lbg38ls3OTjLj+3KPZgSM6SPSn7t7nTodKWmDHFqAu34w2
lK6F3o+7cv88rIS73zb3ho1qYarVePrfR7H43cP+T3XxkRBTPlr9XBGMsvNL
t41V6fB3xb24Cy3J+DhPUX5iXIzLto1Jzydko+dVQbNcGIUl7pZ34rooZHzu
t2CnqbpjGoMwJXaON+veBDV4/XDSoVwIogEos+HtlxULVrwwwD0pOeA3B8y/
1VYgSKdgpyruy8LqEGB4xpQBqsNED5tFEFi1V1wbamLnb7VC+/z17xUp5Mj4
67Ujf99cfUWNBFbSB+xS4cTRqxs/FJjxB12lT7BSjJl/94UP+dIhig7EnguX
iJxzdRSOOENOJF/LQsb/MTFaCMbr940Yd5sfWJW/GdoJnlMBepgkWBY6bMhw
DMtACQ16eSbr4w87y22HBKaF26cmXeFgXJdrmQhWYsMbzoRjXCWrX0PBuyR+
f20+Ms8dBliYRpoymAVfEBkjXgfrx6tG+mZ2mdhcvQXIoa9hM55tL/05alIJ
G2jh0TbMabhfJpTa8ZskEngeBXRc0l0G+MqwI0vrSYOizatEAwYJuGLNbfMe
y4HTUDG9Nl7NctqgYd/X6NHTdKGx/oEAz6ie/DjYoUA9LYSXDTeJ7bQhHdvb
TgpmOolRfTF8NOo7/nxcDRCfXOe/mIBMj2Yd0HeaDDAJwed99vndWiPb584C
cLzGj6z4bxMyc9CKJL2AA08VQNfmtluGLwYc/yy/ZMIlNM/+t5AbIrw6LFAD
ocCt+UAPO0UkwSAdNtYToN+r8GlgRtMnv4qR4XB5K/qu3YksPSqG1TR4lxre
JDidskLk/CLZI5tZDfzK+InhsyKQDi4uo7opzCxOXboI5UBOcx08qQPmf+kx
4aEHpDj+DBiaqjD1jGcBve2IKEa6DntLtEjH5MwzwJUwUsSIQmwl8vkJRjzi
dy/4epkGmN7NWpH+/Vv8VpwJtd3iZmvhf3do+1w=
       "], {{
         RGBColor[0.65, 0.7, 0.7], 
         SphereBox[11, 24.], 
         SphereBox[13, 24.], 
         SphereBox[14, 24.], 
         SphereBox[15, 24.], 
         SphereBox[16, 24.], 
         SphereBox[17, 24.], 
         SphereBox[18, 24.], 
         SphereBox[19, 24.], 
         SphereBox[22, 24.], 
         SphereBox[23, 24.], 
         SphereBox[24, 24.], 
         SphereBox[27, 24.]}, {
         RGBColor[0.4, 0.4, 0.4], 
         SphereBox[1, 34.], 
         SphereBox[2, 34.], 
         SphereBox[3, 34.], 
         SphereBox[4, 34.], 
         SphereBox[5, 34.], 
         SphereBox[6, 34.], 
         SphereBox[8, 34.], 
         SphereBox[9, 34.], 
         SphereBox[10, 34.], 
         SphereBox[12, 34.], 
         SphereBox[21, 34.]}, {
         RGBColor[0.291989, 0.437977, 0.888609], 
         SphereBox[7, 32.], 
         SphereBox[20, 32.]}, {
         RGBColor[0.800498, 0.201504, 0.192061], 
         SphereBox[25, 31.], 
         SphereBox[26, 31.]}, {
         RGBColor[0.65, 0.7, 0.7], 
         CylinderBox[{30, 11}, 15.], 
         CylinderBox[{31, 13}, 15.], 
         CylinderBox[{32, 14}, 15.], 
         CylinderBox[{33, 15}, 15.], 
         CylinderBox[{34, 16}, 15.], 
         CylinderBox[{35, 17}, 15.], 
         CylinderBox[{36, 18}, 15.], 
         CylinderBox[{37, 19}, 15.], 
         CylinderBox[{39, 22}, 15.], 
         CylinderBox[{40, 23}, 15.], 
         CylinderBox[{41, 24}, 15.], 
         CylinderBox[{44, 27}, 15.]}, {
         RGBColor[0.4, 0.4, 0.4], 
         CylinderBox[{1, 2}, 15.], 
         CylinderBox[{2, 3}, 15.], 
         CylinderBox[{3, 4}, 15.], 
         CylinderBox[{4, 5}, 15.], 
         CylinderBox[{5, 6}, 15.], 
         CylinderBox[{6, 1}, 15.], 
         CylinderBox[{4, 28}, 15.], 
         CylinderBox[{29, 8}, 15.], 
         CylinderBox[{8, 9}, 15.], 
         CylinderBox[{9, 5}, 15.], 
         CylinderBox[{9, 10}, 15.], 
         CylinderBox[{10, 30}, 15.], 
         CylinderBox[{10, 12}, 15.], 
         CylinderBox[{3, 32}, 15.], 
         CylinderBox[{2, 33}, 15.], 
         CylinderBox[{1, 34}, 15.], 
         CylinderBox[{6, 35}, 15.], 
         CylinderBox[{8, 36}, 15.], 
         CylinderBox[{10, 37}, 15.], 
         CylinderBox[{12, 38}, 15.], 
         CylinderBox[{12, 21}, 15.], 
         CylinderBox[{12, 39}, 15.], 
         CylinderBox[{21, 42}, 15.], 
         CylinderBox[{21, 43}, 15.]}, {
         RGBColor[0.291989, 0.437977, 0.888609], 
         CylinderBox[{28, 7}, 15.], 
         CylinderBox[{7, 29}, 15.], 
         CylinderBox[{7, 31}, 15.], 
         CylinderBox[{38, 20}, 15.], 
         CylinderBox[{20, 40}, 15.], 
         CylinderBox[{20, 41}, 15.]}, {
         RGBColor[0.800498, 0.201504, 0.192061], 
         CylinderBox[{42, 25}, 15.], 
         CylinderBox[{43, 26}, 15.], 
         CylinderBox[{26, 44}, 15.]}}]}, Boxed -> False, ImageSize -> 
     293.20586296774445`, Lighting -> "Neutral", 
     ViewPoint -> {1.3, -2.4, -2.}], ImageSize -> All, StripOnInput -> False],
   "\"L-tryptophan\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, BaseStyle -> Directive["Menu", 9], DefaultBaseStyle -> 
       "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 1}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", #2, ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
           RowBox[{"\"Menu\"", ",", "9"}], "]"}]}]}], "]"}]& )]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EpicycloidPlot", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "=", "15"}], ",", 
     RowBox[{"r", "=", "11"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"EpicycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJw0l3k4lG/Ux+17su/7boYxC7PY5gyRpKhkS1LZKhGpVBJKi7JLSlEqUYo2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      "]]}}, {
    {RGBColor[0, 0, 1], Thickness[Large], CircleBox[{0, 0}, 15]}, 
    CircleBox[{26, 0}, 11], 
    {PointSize[0.015], PointBox[{26, 0}]}, 
    {Thickness[Large], LineBox[{{26, 0}, {15, 0}}]}, 
    {RGBColor[1, 0, 0], PointSize[0.015], PointBox[{15, 0}]}}},
  Axes->None,
  AxesOrigin->{0, 0},
  GridLines->Automatic,
  PlotRange->39.,
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["HypocycloidPlot", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "=", "3"}], ",", 
     RowBox[{"r", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"HypocycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxd2Wk0VV/YAPDruoZMSTIlZCiaiELCPmRolpKhFJX8JUWDkiQhCslYkoyR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      "]]}}, {
    {RGBColor[0, 0, 1], Thickness[Large], CircleBox[{0, 0}, 3]}, 
    CircleBox[{2, 0}], 
    {PointSize[0.02], PointBox[{2, 0}]}, 
    {Thickness[Large], LineBox[{{2, 0}, {3, 0}}]}, 
    {RGBColor[1, 0, 0], PointSize[0.02], PointBox[{3, 0}]}}},
  Axes->None,
  AxesOrigin->{0, 0},
  GridLines->Automatic,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"HypocycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", "\[Theta]"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{"0", "+", "0.01"}], ",", 
     RowBox[{"2", "\[Pi]", " ", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"R", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8"}], "}"}], 
     ",", "Setter"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     "Setter"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{740, 867},
WindowMargins->{{533, Automatic}, {Automatic, 37}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "11.1 Solutions"->{
  Cell[6235, 212, 4236, 114, 417, "Input",
   CellTags->"11.1 Solutions"]},
 "Info3563773686-4331758"->{
  Cell[15538, 493, 524, 8, 137, "Print",
   CellTags->"Info3563773686-4331758"]},
 "Info3563775057-5557000"->{
  Cell[16159, 509, 722, 11, 112, "Print",
   CellTags->"Info3563775057-5557000"]},
 "Info3563773829-1283229"->{
  Cell[16979, 528, 723, 11, 112, "Print",
   CellTags->"Info3563773829-1283229"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"11.1 Solutions", 88340, 1834},
 {"Info3563773686-4331758", 88445, 1837},
 {"Info3563775057-5557000", 88556, 1840},
 {"Info3563773829-1283229", 88668, 1843}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 65, 1, 83, "Section",
 InitializationGroup->True],
Cell[490, 18, 398, 13, 34, "Text"],
Cell[CellGroupData[{
Cell[913, 35, 30, 0, 42, "Subsection"],
Cell[946, 37, 128, 3, 33, "Input"],
Cell[1077, 42, 239, 6, 33, "Input"],
Cell[1319, 50, 146, 4, 33, "Input"],
Cell[1468, 56, 353, 9, 72, "Input"],
Cell[1824, 67, 134, 4, 33, "Input"],
Cell[1961, 73, 147, 4, 33, "Input"],
Cell[2111, 79, 241, 7, 53, "Input"],
Cell[2355, 88, 256, 8, 33, "Input"],
Cell[2614, 98, 229, 6, 53, "Input"],
Cell[2846, 106, 151, 4, 33, "Input"],
Cell[3000, 112, 173, 5, 33, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3210, 122, 34, 0, 31, "Subsection"],
Cell[3247, 124, 108, 2, 41, "Input"],
Cell[3358, 128, 90, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3485, 134, 57, 0, 31, "Subsection"],
Cell[3545, 136, 511, 9, 148, "Input"],
Cell[4059, 147, 629, 14, 129, "Input"],
Cell[4691, 163, 631, 14, 129, "Input"]
}, Closed]],
Cell[5337, 180, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[5391, 184, 37, 0, 31, "Subsection"],
Cell[5431, 186, 74, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5542, 192, 63, 0, 31, "Subsection"],
Cell[5608, 194, 624, 16, 90, "Input"],
Cell[6235, 212, 4236, 114, 417, "Input",
 CellTags->"11.1 Solutions"],
Cell[10474, 328, 4181, 112, 513, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[14692, 445, 41, 0, 31, "Subsection"],
Cell[14736, 447, 51, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[14824, 453, 32, 0, 31, "Subsection"],
Cell[14859, 455, 58, 1, 41, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14966, 462, 27, 0, 83, "Section"],
Cell[CellGroupData[{
Cell[15018, 466, 34, 0, 42, "Subsection"],
Cell[15055, 468, 37, 0, 40, "Text"],
Cell[15095, 470, 30, 0, 41, "Input"],
Cell[15128, 472, 183, 6, 40, "Text"],
Cell[15314, 480, 62, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[15413, 486, 41, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[15479, 490, 56, 1, 41, "Input"],
Cell[15538, 493, 524, 8, 137, "Print",
 CellTags->"Info3563773686-4331758"]
}, Closed]],
Cell[CellGroupData[{
Cell[16099, 506, 57, 1, 41, "Input"],
Cell[16159, 509, 722, 11, 112, "Print",
 CellTags->"Info3563775057-5557000"]
}, Closed]],
Cell[CellGroupData[{
Cell[16918, 525, 58, 1, 41, "Input"],
Cell[16979, 528, 723, 11, 112, "Print",
 CellTags->"Info3563773829-1283229"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[17751, 545, 56, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[17832, 549, 38, 0, 30, "Subsubsection"],
Cell[CellGroupData[{
Cell[17895, 553, 82, 1, 41, "Input"],
Cell[17980, 556, 618, 10, 113, "Output"]
}, Open  ]],
Cell[18613, 569, 80, 1, 41, "Input"],
Cell[CellGroupData[{
Cell[18718, 574, 129, 3, 41, "Input"],
Cell[18850, 579, 5389, 132, 483, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[24288, 717, 39, 0, 21, "Subsubsection"],
Cell[CellGroupData[{
Cell[24352, 721, 473, 14, 90, "Input"],
Cell[24828, 737, 50542, 836, 585, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[75419, 1579, 40, 0, 21, "Subsubsection"],
Cell[CellGroupData[{
Cell[75484, 1583, 472, 14, 90, "Input"],
Cell[75959, 1599, 10913, 187, 585, "Output"]
}, Open  ]],
Cell[86887, 1789, 946, 25, 161, "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

