(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      9570,        354]
NotebookOptionsPosition[      5799,        241]
NotebookOutlinePosition[      8662,        330]
CellTagsIndexPosition[      8619,        327]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Errata for ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic"]
}], "PrefaceSection"],

Cell[TextData[{
 StyleBox["Edition",
  FontWeight->"Bold"],
 ": First printing",
 StyleBox["\nAuthor",
  FontWeight->"Bold"],
 ": Paul R. Wellin\n",
 StyleBox["Copyright",
  FontWeight->"Bold"],
 ": ",
 StyleBox["\[Copyright]",
  FontSlant->"Plain"],
 " 2013 Cambridge University Press\n"
}], "AuthorInfo"],

Cell["Page 133, line 10", "Item"],

Cell[TextData[{
 "Replace ",
 StyleBox["{a_,b_}", "MR",
  FontSize->10],
 " with ",
 StyleBox["{a_,b__}", "MR",
  FontSize->10]
}], "TextFirst"],

Cell["\<\
Corrected in sources: Tue 29 Jan 2013 10:44:26\
\>", "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 152",
 StyleBox[", lines ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "12"}], TraditionalForm]],
  FontWeight->"Plain"],
 StyleBox[" through ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "15"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell["Wrong error message; should be:", "TextFirst"],

Cell[TextData[Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Part", "::", "partw"}], "MessageName"], ":", 
  " ", "\<\"Part \[NoBreak]\\!\\(6\\)\[NoBreak] of \[NoBreak]\\!\\({\\(\\({7, \
4, 0, 2, 6}\\)\\), \\(\\({7, 9, 8, 3, 9}\\)\\), \\(\\({8, 5, 2, 6, 2}\\)\\), \
\\(\\({6, 2, 0, 4, 1}\\)\\), \\(\\({7, 6, 8, 3, 6}\\)\\)}\\)\[NoBreak] does \
not exist. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\
\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/partw\\\", ButtonNote -> \
\\\"Part::partw\\\"]\\)\"\>"}]], "Message", "MSG",
 FontSize->9]], "TextFirst"],

Cell[TextData[{
 "Corrected in sources: ",
 StyleBox["Tue 15 Jan 2013 08:55:58",
  FontWeight->"Plain"]
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 159",
 StyleBox[", lines ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "9"}], TraditionalForm]],
  FontWeight->"Plain"],
 StyleBox[" through ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "11"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell[TextData[{
 StyleBox["Out[45]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 " does not match ",
 StyleBox["Out[44]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 ". ",
 StyleBox["Out[45]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 " should be:"
}], "TextFirst"],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{
    "\"\<ListCorrelate\>\"", ",", "\"\<DoubleLeftArrow\>\"", ",", 
     "\"\<NotebookClose\>\"", ",", "\"\<FileDate\>\"", ",", 
     "\"\<CylinderBox\>\"", ",", "\"\<SortBy\>\"", ",", 
     "\"\<PrecedesSlantEqual\>\"", ",", "\"\<Ordering\>\"", ",", 
     "\"\<Socket\>\"", ",", "\"\<PlotRangePadding\>\""}], "]"}],
   FontSize->10]]]
}], "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Tue 15 Jan 2013 08:42:07",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 336",
 StyleBox[",  line ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "13"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell["\<\
\[OpenCurlyDoubleQuote]\[Ellipsis]an author a work.\" \[Rule] \"\[Ellipsis]an \
author of a work.\"\
\>", "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Sat 12 Jan 2013 11:16:32",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 513",
 StyleBox[", line ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "11"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell["Change \[OpenCurlyDoubleQuote]covert\[CloseCurlyDoubleQuote] to \
\[OpenCurlyDoubleQuote]convert\[CloseCurlyDoubleQuote]", "TextFirst"],

Cell[TextData[{
 "Corrected in sources: ",
 StyleBox["Tue 15 Jan 2013 13:51:43",
  FontWeight->"Plain"]
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 597",
 StyleBox[", line ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "2"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell[TextData[{
 "Code for ",
 Cell[BoxData[
  StyleBox["PerfectSearchParallel",
   FontSize->10]]],
 ": change ",
 Cell[BoxData[
  StyleBox["Distribute",
   FontSize->10]]],
 " to ",
 Cell[BoxData[
  StyleBox["DistributeDefinitions",
   FontSize->10]]],
 "."
}], "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Wed 5 Dec 2012 08:59:34",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell["Page 676\[Dash]677", "Item"],

Cell[TextData[{
 "Solutions to exercises ",
 StyleBox["2", "OsF"],
 " and ",
 StyleBox["3", "OsF"],
 " of Section ",
 StyleBox["12.2", "OsF"],
 " are out of order: exercise ",
 StyleBox["2", "OsF"],
 " should be numbered exercise 3 and vice versa."
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Mon 21 Jan 2013 14:43:30"
}], "TextFirst",
 FontColor->GrayLevel[0.5]]
}, Open  ]]
},
ScreenStyleEnvironment->"Printout",
WindowSize->{
  Scaled[0.5], 
  Scaled[0.8]},
WindowMargins->{{97, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
  None, None, 
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {None, None, None}},
PageHeaderLines->{False, False},
PageFooterLines->{False, False},
PrintingOptions->{"FacingPages"->True,
"FirstPageFace"->Right,
"FirstPageFooter"->True,
"FirstPageHeader"->False,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->54},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"PWM"}, "PWM.nb", CharacterEncoding -> "UTF-8"]]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["TextFirst"]], 
      Cell[
       StyleData["TextFirst", "Printout"], CellMargins -> {{22, 0}, {2, 0}}, 
       FontFamily -> "DTL Albertina TOT", FontSize -> 10]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["AuthorInfo"], MenuSortingValue -> 10000], 
      Cell[
       StyleData["AuthorInfo", "Printout"], 
       CellMargins -> {{12, Inherited}, {0, Inherited}}, MenuSortingValue -> 
       10000, FontFamily -> "DTL Albertina TOT", FontSize -> 10]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["PrefaceSection"]], 
      Cell[
       StyleData["PrefaceSection", "Printout"], 
       CellFrame -> {{0, 0}, {0, 0.5}}, CellMargins -> {{12, 0}, {2, 5}}, 
       CellFrameStyle -> Directive[
         GrayLevel[0.5]], FontFamily -> "DTL Albertina TOT", FontSize -> 14, 
       FontWeight -> "Plain"]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["Item"]], 
      Cell[
       StyleData["Item", "Printout"], CellMargins -> {{22, 4}, {4, 8}}, 
       FontFamily -> "DTL Albertina TOT Italic", FontSize -> 11]}, Closed]]}, 
  WindowSize -> {609, 474}, 
  WindowMargins -> {{Automatic, 218}, {Automatic, 36}}, Visible -> False, 
  FrontEndVersion -> 
  "9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, 2012)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 288, 8, 48, "PrefaceSection"],
Cell[870, 32, 306, 13, 83, "AuthorInfo"],
Cell[1179, 47, 33, 0, 38, "Item"],
Cell[1215, 49, 144, 7, 21, "TextFirst"],
Cell[1362, 58, 103, 3, 21, "TextFirst"],
Cell[1468, 63, 318, 14, 38, "Item"],
Cell[1789, 79, 52, 0, 21, "TextFirst"],
Cell[1844, 81, 600, 11, 37, "TextFirst"],
Cell[2447, 94, 148, 5, 21, "TextFirst"],
Cell[2598, 101, 317, 14, 38, "Item"],
Cell[2918, 117, 303, 13, 21, "TextFirst"],
Cell[3224, 132, 439, 12, 59, "TextFirst"],
Cell[3666, 146, 137, 2, 21, "TextFirst"],
Cell[3806, 150, 178, 8, 38, "Item"],
Cell[3987, 160, 128, 3, 21, "TextFirst"],
Cell[4118, 165, 137, 2, 21, "TextFirst"],
Cell[4258, 169, 177, 8, 38, "Item"],
Cell[4438, 179, 141, 1, 21, "TextFirst"],
Cell[4582, 182, 148, 5, 21, "TextFirst"],
Cell[4733, 189, 176, 8, 38, "Item"],
Cell[4912, 199, 276, 14, 21, "TextFirst"],
Cell[5191, 215, 136, 2, 21, "TextFirst"],
Cell[5330, 219, 34, 0, 38, "Item"],
Cell[5367, 221, 265, 10, 42, "TextFirst"],
Cell[5635, 233, 148, 5, 21, "TextFirst"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
