(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[  12223610,     265083]
NotebookOptionsPosition[  11575024,     247184]
NotebookOutlinePosition[  11921363,     255748]
CellTagsIndexPosition[  11913361,     255517]
WindowTitle->None
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "Programming with ",
 StyleBox["Mathematica\n",
  FontSlant->"Italic"],
 "An Introduction"
}], "Title"],

Cell["Solutions to exercises", "Subtitle"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["2", "ChapterN",
 CounterAssignments->{{"Chapter", 1}},
 CellTags->"Chapter.Number"],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " language"
}], "ChapterTitle"],

Cell[CellGroupData[{

Cell["Expressions", "ExerciseSubsection"],

Cell[TextData[{
 "Give the full (internal) form of the expression ",
 Cell[BoxData[
  RowBox[{"a", " ", 
   RowBox[{"(", 
    RowBox[{"b", "+", "c"}], ")"}]}]], "ExLink"],
 "."
}], "ExerciseItem",
 CellTags->"2.1 Exercises"],

Cell[TextData[{
 "What is the traditional representation of ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Power", "[", 
      RowBox[{
       RowBox[{"Plus", "[", 
        RowBox[{"b", ",", "c"}], "]"}], ",", 
       RowBox[{"-", "1"}]}], "]"}]}], "]"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"2.1 Exercises"],

Cell[TextData[{
 "What is the part specification of the ",
 StyleBox["b", "ExerciseMR"],
 " in the expression ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"a", " ", 
     SuperscriptBox["x", "2"]}], "+", 
    RowBox[{"b", " ", "x"}], "+", "c"}], "ExLink"]]],
 "?"
}], "ExerciseItem",
 CellTags->"2.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "What do you expect to be the result of the following operations? Use the ",
 Cell[BoxData[
  ButtonBox["FullForm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FullForm"]]],
 " of the expressions to understand what is going on."
}], "ExerciseItem",
 CellTags->"2.1 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["x", "2"], "+", "y"}], ")"}], " ", 
      RowBox[{"z", "/", "w"}]}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"2", ",", "1", ",", "2"}], "]"}], "]"}], "ExLink"], 
  StyleBox[".", "TR"]}]], "ExerciseSubItem",
 CellTags->"2.1 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "/", "b"}], ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"2", ",", "2"}], "]"}], "]"}], "ExLink"], 
  StyleBox[".", "TR"]}]], "ExerciseSubItem",
 CellTags->"2.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[TextData[{
 "The expression ",
 Cell[BoxData[
  RowBox[{"a", " ", 
   RowBox[{"(", 
    RowBox[{"b", "+", "c"}], ")"}]}]]],
 " is given in full form as ",
 Cell[BoxData[
  RowBox[{"Times", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Plus", "[", 
     RowBox[{"b", ",", "c"}], "]"}]}], "]"}]]],
 "."
}], "SolutionItem",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[TextData[{
 "This is simply ",
 Cell[BoxData[
  FormBox[
   FractionBox["a", 
    RowBox[{"b", "+", "c"}]], TraditionalForm]]],
 " as can be seen by evaluating the full form expression."
}], "SolutionItem",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Times", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Power", "[", 
     RowBox[{
      RowBox[{"Plus", "[", 
       RowBox[{"b", ",", "c"}], "]"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}],
  FullForm]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 FractionBox["a", 
  RowBox[{"b", "+", "c"}]]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "There are three elements in the expression, with the term ",
 Cell[BoxData[
  RowBox[{"b", " ", "x"}]]],
 " being the second. "
}], "SolutionItem",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"expr", "=", 
   RowBox[{
    RowBox[{"a", " ", 
     SuperscriptBox["x", "2"]}], "+", 
    RowBox[{"b", " ", "x"}], "+", "c"}]}], ";"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "expr", "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Plus", "[", 
    RowBox[{"c", ",", 
     RowBox[{"Times", "[", 
      RowBox[{"b", ",", "x"}], "]"}], ",", 
     RowBox[{"Times", "[", 
      RowBox[{"a", ",", 
       RowBox[{"Power", "[", 
        RowBox[{"x", ",", "2"}], "]"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "The first element of ",
 Cell[BoxData[
  RowBox[{"Times", "[", 
   RowBox[{"b", ",", "x"}], "]"}]]],
 " is ",
 Cell[BoxData["b"]],
 ", so the part specification is ",
 Cell[BoxData[
  RowBox[{"2", ",", "1"}]]],
 "."
}], "SolutionText",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "[", 
  RowBox[{"[", "2", "]"}], "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 RowBox[{"b", " ", "x"}]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "1"}], "]"}], "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData["b"], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Looking at the internal representation of this expression with ",
 Cell[BoxData[
  ButtonBox["FullForm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FullForm"]], "InlineFormula"],
 " helps to unwind the part specification."
}], "SolutionItem",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["x", "2"], "+", "y"}], ")"}], " ", "z"}], "w"], 
  "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{
     RowBox[{"Power", "[", 
      RowBox[{"w", ",", 
       RowBox[{"-", "1"}]}], "]"}], ",", 
     RowBox[{"Plus", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"x", ",", "2"}], "]"}], ",", "y"}], "]"}], ",", "z"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["x", "2"], "+", "y"}], ")"}], " ", "z"}], "w"], " ", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", " ", "1", ",", " ", "2"}], "]"}], "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData["2"], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "From the ",
 Cell[BoxData[
  ButtonBox["FullForm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FullForm"]], "InlineFormula"],
 " of ",
 Cell[BoxData[
  RowBox[{"a", "/", "b"}]]],
 ", you can see that the second part is ",
 Cell[BoxData[
  RowBox[{"Power", "[", 
   RowBox[{"b", ",", 
    RowBox[{"-", "1"}]}], "]"}]]],
 " and the second part of that is ",
 Cell[BoxData[
  RowBox[{"-", "1"}]]],
 ". Note the need for parentheses here as the ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " function has higher precedence than ",
 Cell[BoxData[
  ButtonBox["Power",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Power"]], "InlineFormula"],
 ". For more information on operator precedence, see ",
 ButtonBox["Operator Input Forms (WMDC)",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://reference.wolfram.com/mathematica/tutorial/OperatorInputForms.\
html"], None},
  ButtonNote->
   "http://reference.wolfram.com/mathematica/tutorial/OperatorInputForms.\
html"],
 "."
}], "SolutionText",
 CellTags->"2.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"a", "/", "b"}], "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Power", "[", 
      RowBox[{"b", ",", 
       RowBox[{"-", "1"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "/", "b"}], ")"}], "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "2"}], "]"}], "]"}]], "Input",
 CellTags->"2.1 Solutions"],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "What rules are created by each of the following functions? Check your \
predictions by evaluating them and then querying ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " with ",
 StyleBox["?", "MR", "ExLink"],
 StyleBox["function", "ExerciseTI"],
 StyleBox["_name", "ExerciseTI"],
 "."
}], "ExerciseItem",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"randLis1", "[", "n_", "]"}], ":=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "n", "}"}]}], "]"}]}], "ExLink"]], "ExerciseSubItem",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"randLis2", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", "=", 
      RowBox[{"RandomReal", "[", "]"}]}], ";", 
     RowBox[{"Table", "[", 
      RowBox[{"x", ",", 
       RowBox[{"{", "n", "}"}]}], "]"}]}], ")"}]}], 
  "ExLink"]], "ExerciseSubItem",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"randLis3", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", ":=", 
      RowBox[{"RandomReal", "[", "]"}]}], ";", 
     RowBox[{"Table", "[", 
      RowBox[{"x", ",", 
       RowBox[{"{", "n", "}"}]}], "]"}]}], ")"}]}], 
  "ExLink"]], "ExerciseSubItem",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"randLis4", "[", "n_", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"RandomReal", "[", "]"}], ",", 
     RowBox[{"{", "n", "}"}]}], "]"}]}], "ExLink"]], "ExerciseSubItem",
 CellTags->"2.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Consider two functions ",
 StyleBox["f", "MR", "ExLink"],
 " and ",
 StyleBox["g", "MR", "ExLink"],
 ", which are identical except that one is written using an immediate \
assignment and the other using a delayed assignment."
}], "ExerciseItem",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "n_", "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "x"}], ")"}], "j"], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "n_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", "x"}], ")"}], "j"], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"2.2 Exercises"],

Cell[TextData[{
 "Explain why the outputs of these two functions ",
 StyleBox["look",
  FontSlant->"Italic"],
 " so different. Are they in fact different?"
}], "ExerciseText",
 CellTags->"2.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "2", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", "x"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "x"}], ")"}], "2"]}], ")"}]}], 
  "x"]], "ExerciseOutput", "ExerciseMR",
 CellTags->"2.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", "2", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"2.2 Exercises"],

Cell[BoxData[
 RowBox[{"1", "+", "x", "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"1", "+", "x"}], ")"}], "2"]}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"2.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Write rules for a function ",
 StyleBox["log", "MR", "ExLink"],
 " (note lowercase) that encapsulate the following identities:"
}], "ExerciseItem",
 CellTags->"2.2 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       RowBox[{"log", 
        RowBox[{"(", 
         RowBox[{"a", " ", "b"}], ")"}]}], "=", 
       RowBox[{
        RowBox[{"log", 
         RowBox[{"(", "a", ")"}]}], "+", 
        RowBox[{"log", "(", "b", ")"}]}]}], ";"}]},
    {
     RowBox[{
      RowBox[{
       RowBox[{"log", 
        RowBox[{"(", 
         FractionBox["a", "b"], ")"}]}], "=", 
       RowBox[{
        RowBox[{"log", 
         RowBox[{"(", "a", ")"}]}], "-", 
        RowBox[{"log", "(", "b", ")"}]}]}], ";"}]},
    {
     RowBox[{
      RowBox[{"log", 
       RowBox[{"(", 
        SuperscriptBox["a", "n"], ")"}]}], "=", 
      RowBox[{"n", " ", 
       RowBox[{
        RowBox[{"log", "(", "a", ")"}], "."}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{"="}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}], TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"2.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a piecewise-defined function ",
 Cell[BoxData[
  FormBox[
   RowBox[{"g", "(", "x", ")"}], TraditionalForm]]],
 " based on the following and then plot the function from ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"\[Dash]", "2"}], "OsF"], TraditionalForm]]],
 " to ",
 StyleBox["0", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"i:30", "2.2 Exercises"}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"g", 
    RowBox[{"(", "x", ")"}]}], "=", 
   RowBox[{"\[Piecewise]", GridBox[{
      {
       RowBox[{"-", 
        SqrtBox[
         RowBox[{
          StyleBox["1", "OsF"], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "+", 
             StyleBox["2", "OsF"]}], ")"}], "2"]}]]}], 
       RowBox[{
        RowBox[{"-", 
         StyleBox["2", "OsF"]}], "\[LessEqual]", "x", "\[LessEqual]", 
        StyleBox[
         RowBox[{"-", "1"}], "OsF"]}]},
      {
       SqrtBox[
        RowBox[{
         StyleBox["1", "OsF"], "-", 
         SuperscriptBox["x", "2"]}]], 
       RowBox[{"x", "<", 
        StyleBox["0", "OsF"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}]}]}], \
$CellContext`DefaultTraditionalFormatType]], "ExerciseDisplayFormula",
 CellTags->"2.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
This exercise focuses on the difference between immediate and delayed \
assignments.\
\>", "SolutionItem",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[TextData[{
 "This will generate a list of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " random numbers."
}], "SolutionSubItem",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"randLis1", "[", "n_", "]"}], ":=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "n", "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randLis1", "[", "3", "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.9889908012841708`", ",", "0.21366273758699972`", ",", 
   "0.4759223636633134`"}], "}"}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Since the definition for ",
 Cell[BoxData["x"]],
 " is an immediate assignment, its value does not change in the body of ",
 Cell[BoxData["randLis2"]],
 ". But each time ",
 Cell[BoxData["randLis2"]],
 " is called, a new value is assigned to ",
 Cell[BoxData["x"]],
 "."
}], "SolutionSubItem",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"randLis2", "[", "n_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", "=", 
     RowBox[{"RandomReal", "[", "]"}]}], ";", 
    RowBox[{"Table", "[", 
     RowBox[{"x", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], ")"}]}]], "InputOnly",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randLis2", "[", "3", "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.7592672933117017`", ",", "0.7592672933117017`", ",", 
   "0.7592672933117017`"}], "}"}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randLis2", "[", "3", "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.9793816411956477`", ",", "0.9793816411956477`", ",", 
   "0.9793816411956477`"}], "}"}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Because the definition for ",
 Cell[BoxData["x"]],
 " is a delayed assignment, the definition for ",
 Cell[BoxData["randLis3"]],
 " is functionally equivalent to ",
 Cell[BoxData["randLis1"]],
 "."
}], "SolutionSubItem",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"randLis3", "[", "n_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", ":=", 
     RowBox[{"RandomReal", "[", "]"}]}], ";", 
    RowBox[{"Table", "[", 
     RowBox[{"x", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], ")"}]}]], "InputOnly",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randLis3", "[", "3", "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.7940999086366414`", ",", "0.7360735601494632`", ",", 
   "0.25435090336413313`"}], "}"}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "In an immediate assignment, the right-hand side of the definition is \
evaluated first. But in this case, ",
 Cell[BoxData["n"]],
 " does not have a value, so ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " is not able to evaluate properly."
}], "SolutionSubItem",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"randLis4", "[", "n_", "]"}], "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"RandomReal", "[", "]"}], ",", 
    RowBox[{"{", "n", "}"}]}], "]"}]}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Table", "::", "iterb"}], "MessageName"], ":", 
  " ", "\<\"Iterator \[NoBreak]\\!\\({n}\\)\[NoBreak] does not have \
appropriate bounds. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/iterb\\\", ButtonNote -> \
\\\"Table::iterb\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"RandomReal", "[", "]"}], ",", 
   RowBox[{"{", "n", "}"}]}], "]"}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{"Clear", "[", "x", "]"}]], "Input",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The definition for ",
 Cell[BoxData["f"]],
 " given in the exercise evaluates the sum first (immediate assignment), \
giving a symbolic expression for the general sum from ",
 StyleBox["1", "OsF"],
 " to ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ". When ",
 Cell[BoxData[
  RowBox[{"f", "[", "2", "]"}]]],
 " is evaluated, the argument ",
 StyleBox["2", "OsF"],
 " is then substituted into this expression for ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ". In the case of ",
 Cell[BoxData["g"]],
 ", the value of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is substituted and then the sum is evaluated. Although the resulting \
expressions output by these two functions look different at first, expanding \
them gives the same result."
}], "SolutionItem",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], "=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", "x"}], ")"}], "j"], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", "x"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "x"}], ")"}], "n"]}], ")"}]}], "x"]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "n_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", "x"}], ")"}], "j"], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"f", "[", "2", "]"}], "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"2", "+", 
  RowBox[{"3", " ", "x"}], "+", 
  SuperscriptBox["x", "2"]}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"g", "[", "2", "]"}], "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{"2", "+", 
  RowBox[{"3", " ", "x"}], "+", 
  SuperscriptBox["x", "2"]}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The rules for the logarithm function are as follows. Note, there is no need \
to program the division rule separately. Do you see why? (Look at ",
 Cell[BoxData[
  RowBox[{"FullForm", "[", 
   RowBox[{"x", "/", "y"}], "]"}]]],
 ".)"
}], "SolutionItem",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"log", "[", 
   RowBox[{"a_", "*", "b_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"log", "[", "a", "]"}], "+", 
   RowBox[{"log", "[", "b", "]"}]}]}]], "InputOnly",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"log", "[", 
   SuperscriptBox["a_", "n_"], "]"}], ":=", 
  RowBox[{"n", " ", 
   RowBox[{"log", "[", "a", "]"}]}]}]], "InputOnly",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"log", "[", 
  RowBox[{"x", " ", 
   SuperscriptBox["y", "2"], " ", 
   SuperscriptBox["z", "3"]}], "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"log", "[", "x", "]"}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"log", "[", "y", "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"log", "[", "z", "]"}]}]}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"log", "[", 
  RowBox[{"x", "/", "y"}], "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"log", "[", "x", "]"}], "-", 
  RowBox[{"log", "[", "y", "]"}]}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Piecewise",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Piecewise"]], "InlineFormula"],
 ", we have:"
}], "SolutionItem",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "x_", "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "+", "2"}], ")"}], "2"]}]]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], "\[LessEqual]", "x", "\[LessEqual]", 
        RowBox[{"-", "1"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["x", "2"]}]], ",", 
       RowBox[{"x", "<", "0"}]}], "}"}]}], "}"}], "]"}]}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "0"}], "}"}]}], "]"}]], "Input",
 CellTags->"2.2 Solutions"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Ak0VVsYB3BFyfA0l5RQmpRmkVIS4VVE1KNQMpWSROQlNBpSiRSF8gyV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      "]], LineBox[CompressedData["
1:eJwV0gk01VsXAHAJET16r0+DREKSBhkz7eRREhoUTZJESiVJE9eUboYkRKQy
pDJlrFDZSOFm6F4lU+Yh7nCU+Qrf/521zjrrt87Za+3hrHa8sO+UoICAQDG1
/ztBs5H+iU/wt5auz6mdyWAi1zRdNkWwRdcppXk6Bew4IlWfRglWePCUyhnp
4FakFf2ZEPyUVhMpvSwH/G45OXwZIrhzTfwVcM6D+/uj1L71EaSZpJ2evlgA
6fLlk82dBDPmxbvHWb6GEu5wRXsrQaY6sMyECoFVLHevp5Egf69C4PlHRTBA
tzr2k0nlE2S+y3zVW5BSyBz7VUnQ4sHq1SF970GRtJSNlxM8M6MToaSOsPWd
WPj0e4J+d+n/puuUguNBF2XhAoKSubNFd53KwGtNzG+xbIID+4/6+Y6UQehw
Rclf6dT98GY/MVo5FIQo2C5LJGg4WPLoOP0DiOAP+vowgjNFbPMWj4+wIkzC
ZjOdYNWqOk9m/0fYdEhfXiuAYI2Fvcoxu09gN/Kg0OgqQZeJWz6oWQlpa20G
9zoRvHA6P733WxVEHnTxH7InGLf0cZ3u9mq4HnR9eeAh6n3J55LczGrY3ZNo
XmBFkPt7sdpZbwYMP+amSW8l+HxYd8E/YjWgLU0/07qIoGN+f5lMbx3ImcYL
eooS5Cg/Tr+lVw+inlnxEvMJ+vaJbxi/Ww/NzAaG4SQPJdrZ/8xb+QW878iv
T+zmoePc9cPVJV+gXKiY7fSGh+n942I/fjEhQ6M2cCaXhwmN+RP50iyIduyU
icnkYelK+UV6+iw4VSqyuzKJhwdlmxSPBLJA1Ht/5rowHg5MqR1bLdUAViMc
N54DD2+va1WVlP0KrV1yvCsLeTjqgeLpEo1w9ObQsJswD6vdNhv9rdIIbcqv
Rk4I8NBpbcFqGxPKZ3dNWYxzselakYrLtUZoH/MUku/m4kWrkMKmnkboFmOs
qCriohUqGNnkfYchdc8dy1y5WBMcgL66zcD3r0osrOSgY2SWZDi/FaxvXblg
XM5BxloLQYHFbfA0RNmI8Y6Dbuxw5pG1bWAZdbO1NZeDPrTA78z9bZD4dJv0
3EMO7olYs+h9RhuYVRaGmrpz0HlB2kSR7Q+IkkjzYi3jYP6Yhti1pHZQiw3e
zXFl42WpowMN/p0QYG/zLNyJjZrZrK6ikE5oUpITUD/Oxu5vX+ziojrhZkFB
/mUbNt7XFOn/N7UT2pgdK+aM2Php4Gi8dVUnhEloDy5ewsYUZ5cJ/UVdwPHv
DtIpGULTuHc52ZFdkOmmjwF/D6F2yfjF13e6YbkKo0OD9RP1+Oe/OW3phTi7
i1PfvQZQxEFWe115H4hcGCuN2dKP9jGZPQ8kBqDM9Ix14WgvWonuOTZ/00+I
uDfRWPOwB1UaTJ2+mg+CxYcTEn8OdaNPSccZYZ0hWH6mV2/VTCfGbSwxUV/F
hhdc+sbX5zvQWdEzidvBhnd0lctjpA2vxfOX14VwYFycn7VCvwWj1N7Y2Wzm
gtjRoO2XC77jAzOG15EiLpjEGFe/mviKwqI3BLr1ebBib8ePtztYuNVZI60o
nQda2YmfCwxZGNEhUqGTyYM9ixyLsjRYmHOYxi/I4kFQdW/0EzkWvtdtL87M
4cGw8ZBF4AQTfwvPht17zYNPW8aKdj1n4vY+i6jN5TzwWCIe0yzCRIOrFgs+
NvEgOvtcAi+0Hgf8tTSt5hOQGfF/vsmrHpdM3HicLUQgWTsmz92hHr0NlIWl
RAhkvy+p+q1Zj2GWm6tqRQkwPkuOjf+ow62GLSqGfxGYG8i1nNtUh5xzKz3Y
ywickR+flfxagx5ZpQvpGwgY36OdUF/JwDIHY6Wy/QSUU9yX9i5g4LMLGZfq
bQhIvHKsjRmpxi0ng/rbDhBobDLb+odRjWoOXVvHbAm4yUsurrxWjZmjT+Jk
jhJ4kP2k9Oj3Kky2VNoDTgSGa0vlbkdWYoR3kFrPJSq+I++bHq0SI/fobGn0
JPD219NQrmslCs+N2lddJnDrf8ET+4wrkch2b0i/QmDlsb31ssOfcPRCcsrJ
GwR2crpo+ZafcNWCS3NZAQQSF85vbxf9iDlakvzECAIhKk6lE6MVqJTiXuV5
j8Bls4/JUl0VKG8aVLUjksCuALrL9qIKfFQgas+OIjAyJf4r1bUCH+zT7VSJ
JWA2uEToHOMDui8VtPZ5RIBbqaw6HVqOtvtGt4WlEWjqo0ssuVqOIr7FJ83S
CZTPH+SpOZVj1vWlxXOUYyAj396gHAs6a+e5ZxLY9maTYTmnDJ/X5MyaZROI
fqa7J9iyDP/k6BfXFRDQC9rltVSyFJvHnaNNkQDb5rrU3G/EIVlO5whlxyfH
NesrEaPj0SiplMBeTVXvCxcR5aLDN06VEdhoj+I5FSWo99Sj81EFgYHcQVX1
s+/xDejHF1cTOHzIyFWjsBgrjYKrjBsIMFPW3Jl/pxhZv8oPsyjv5InmNpwo
xjK2qIDjVwI6gQ2Tl8SLUaGEHUj7RmBJ1unbBfZFmODm7JH5nUCtQNRzLeFC
PLvw9WhrK1Xfi4E+nX2v0Pj63fbgHqrfd28fZ697hdFP+43GKKd7rWt+PO8V
atspso73EvjH9GyNcG4BVp29dG9LH4H+Ll5eg2QBDhkZetb1EwiTGfe9UJuH
bwI0mB2DBMoEY6cUUvPw6unok0ZDBMYHdS41eudhLc9mXQLl44XXnA3V8jB5
Wsr6AJvAlgMzu8VDc1HUR1uohEPNK1xoxfOdOZg1+5eMKyGwyCs16rB8Dp7/
3/3+YsqBxWErVg5no8Tm3j7xYQIHbaXmDVll44IXY74ZlP9ELK0LkniJpzFU
oesX1S8h5dPv6RmoFBWgrDxKII/lckRRJwNtTazVz1KWSUqzCu1PR/86I/ds
yjzDDVqHTNPxdV18iNYYNf8rmoJjgmkoSWeq644T6BzanqBGe4Y9/cetlk4S
cLXeTTQUn2EY9K48SPl3/oHt+oxUDMl9y42iLORz+qe5dCraVV6PkZgioCIZ
runyMgWvMb8K/aaceymWft4mBZ3y7vSr8Kn/1ZTYcpmfjKaSHxn2lHcn5fvd
NEvG2vUf4ispu2s01yS1JyJrV+ChO9MEpmK75dJuJqKixBvrd5QD/rA9clQT
UaY0fOcQZZXQGXUa9zEa8fW2m/yh4rN3MgplEzDg1OSBQcoBV4+4V7o+RLpk
yQmpGape4/PSja/icZf+DndtyoUNUY4jlnGYJpd335fy3EQ7fwMtBn1UdwiK
zBKQKvuVaMC4j9IxtxSVKCuECO2wkL6PDzemmJtQNlupGnX6ZRQKzNASvCnb
9RlsvcKPRNdAE0Ys5TMvrTuCzCKR+Z3wcymHb7u8PqU9ArWCxU71UE4Uu83M
VY3Aj9dvPOZTdkrVIn7ccPQ+2d4iNUcgs9qP/lY2DI2MfY/qUf5y5FlD06sQ
FJMsS7KkPMr9LDduGYw+QdODxykb/L20cDPtFqLMiUB/yg5PDYSspIMw1u7u
1wjKN7Ud95x9GYhqV9+pPKH8ooqecNssAB3qBn0zKdcczvqZ2u6HSbHLWgop
dzanut7i0nBo0lyngvLa2eF5ZbLe+HGOFltH+byCQfy05TU0Ty7kf6f82oy+
RZvmhbI44dBJefYMi+H+8hJ6yRoyBiib3ZU9mdHujsvPBWvzKMu4MMc/y7rh
EbMfqSOU07Nd1hrTnFFedeuyScp6kzO2r9sdsN3/0Z1pypH+KottaQfx4ZOF
IrOUTyql9wbQzJD93s9/jvKuUz+ZpYOnSibn/lsE/g+Fb3/9
      
      "]]}, {}}, {{}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-2, 0}, {-0.9999999999999991, 0.9999999999999991}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Predicates and Boolean operations", "ExerciseSubsection"],

Cell[TextData[{
 "Create a predicate function that returns a value of ",
 StyleBox["True", "MR", "ExLink"],
 " if its argument is between ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Dash]", "1"}], TraditionalForm]], "OsF"],
 " and ",
 StyleBox["1", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->"2.3 Exercises"],

Cell[TextData[{
 "Define a predicate function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["CharacterQ", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["str", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that returns true if its argument ",
 StyleBox["str",
  FontSlant->"Italic"],
 " is a single string character, and returns false otherwise."
}], "ExerciseItem",
 CellTags->"2.3 Exercises"],

Cell[TextData[{
 "Write a predicate function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["NaturalQ", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that returns a value of ",
 StyleBox["True", "MR", "ExLink"],
 " if ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]],
  FontSlant->"Italic"],
 " is a natural number and ",
 StyleBox["False", "MR", "ExLink"],
 " otherwise, that is, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["NaturalQ", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " is ",
 StyleBox["True", "MR", "ExLink"],
 " if ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is among ",
 StyleBox["0, 1, 2, 3,", "OsF"],
 " \[Ellipsis]."
}], "ExerciseItem",
 CellTags->{"i:47", "2.3 Exercises"}],

Cell[TextData[{
 "Create a predicate function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["SubsetQ", "ExLink"], "[", 
   RowBox[{
    StyleBox[
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], 
      StyleBox["1", "OsF",
       FontSize->7]], "ExLink"], ",", 
    StyleBox[
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], 
      StyleBox["2", "OsF",
       FontSize->7]], "ExLink"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that returns a value of ",
 StyleBox["True", "MR", "ExLink"],
 " if ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox[
     StyleBox["lis", "ExerciseTI"], 
     StyleBox["1",
      FontFamily->"DTL Albertina TOT Caps",
      FontSize->7,
      FontSlant->"Plain"]], "ExLink"], TraditionalForm]]],
 " is a subset of ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox[
     StyleBox["lis", "ExerciseTI"], 
     StyleBox["2", "OsF",
      FontFamily->"DTL Albertina TOT Caps",
      FontSize->7,
      FontSlant->"Plain"]], "ExLink"], TraditionalForm]]],
 ". Remember, the empty set, ",
 Cell[BoxData[
  RowBox[{"{", "}"}]]],
 ", is a subset of every set."
}], "ExerciseItem",
 CellTags->"2.3 Exercises"],

Cell[TextData[{
 "Create a predicate function ",
 Cell[BoxData[
  StyleBox["CompositeQ", "ExLink"]]],
 " that tests whether its argument is a nonprime integer."
}], "ExerciseItem",
 CellTags->{"i:48", "2.3 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
There are several ways to define this function, either using the relational \
operator for less than, or with the absolute value function.\
\>", "SolutionItem",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "1"}], "<", "x", "<", "1"}]}]], "InputOnly",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Abs", "[", "x", "]"}], "<", "1"}]}]], "InputOnly",
 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "4", "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"-", "0.35"}], "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The requirements here are that the argument be both a string (",
 Cell[BoxData[
  ButtonBox["StringQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringQ"]], "InlineFormula"],
 ") and have length (",
 Cell[BoxData[
  ButtonBox["StringLength",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringLength"]], "InlineFormula"],
 ") one."
}], "SolutionItem",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CharacterQ", "[", "ch_", "]"}], ":=", 
  RowBox[{
   RowBox[{"StringQ", "[", "ch", "]"}], "&&", 
   RowBox[{
    RowBox[{"StringLength", "[", "ch", "]"}], "\[Equal]", "1"}]}]}]], "Input",\

 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CharacterQ", "[", "\"\<v\>\"", "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CharacterQ", "[", "\"\<vi\>\"", "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CharacterQ", "[", "vi", "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A number ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " can be considered a natural number if it is both an integer and greater \
than or equal to zero. There is some disagreement in the mathematics \
community about ",
 StyleBox["0", "OsF"],
 ", but for our purposes, we will adopt the convention that ",
 StyleBox["0", "OsF"],
 " is a natural number."
}], "SolutionItem",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NaturalQ", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
   RowBox[{"n", "\[GreaterEqual]", "0"}]}]}]], "InputOnly",
 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NaturalQ", "[", "0", "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NaturalQ", "[", 
  RowBox[{"-", "4"}], "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The empty set is a subset of every set. So first we need a definition to \
cover this case.\
\>", "SolutionItem",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubsetQ", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "lis2_"}], "]"}], ":=", "True"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[TextData[{
 "The intersection of ",
 Cell[BoxData["lis1"]],
 " and ",
 Cell[BoxData["lis2"]],
 " will be identical to ",
 Cell[BoxData["lis1"]],
 " whenever ",
 Cell[BoxData["lis1"]],
 " is a subset of ",
 Cell[BoxData["lis2"]],
 "."
}], "SolutionText",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubsetQ", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Intersection", "[", 
    RowBox[{"lis1", ",", "lis2"}], "]"}], "==", "lis1"}]}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubsetQ", "[", 
  RowBox[{"A", ",", "B"}], "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "We can also give a definition in terms of the subset character ",
 StyleBox["\[Subset]", "ExerciseMR"],
 " which can be entered by typing \[EscapeKey]-",
 Cell[BoxData["sub"]],
 "-\[EscapeKey] or by using one of the palettes."
}], "SolutionText",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"lis1_", "\[Subset]", "lis2_"}], ":=", 
  RowBox[{
   RowBox[{"Intersection", "[", 
    RowBox[{"lis1", ",", "lis2"}], "]"}], "==", "lis1"}]}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A", "\[Subset]", "B"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "There are three tests that have to be satisfied: integer, greater than ",
 StyleBox["1", "OsF"],
 ", not prime."
}], "SolutionItem",
 CellTags->"2.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CompositeQ", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
   RowBox[{"n", ">", "1"}], "&&", 
   RowBox[{"Not", "[", 
    RowBox[{"PrimeQ", "[", "n", "]"}], "]"}]}]}]], "InputOnly",
 CellTags->"2.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CompositeQ", "[", 
  RowBox[{
   SuperscriptBox["2", "31"], "-", "1"}], "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CompositeQ", "[", 
  RowBox[{
   SuperscriptBox["2", "31"], "+", "1"}], "]"}]], "Input",
 CellTags->"2.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "This is more neatly done using conditional pattern matching. See, for \
example, ",
 "Section",
 " ",
 StyleBox["4.1", "OsF"],
 " on patterns."
}], "SolutionText",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Attributes", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Ordinarily, when you define a function, it has no attributes. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " evaluates the arguments before passing them up to the calling function. \
So, in the following case, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"2", "+", "3"}], "ExLink"]]],
 " is evaluated before it is passed to ",
 Cell[BoxData[
  StyleBox["f", "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"2.4 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"x_", "+", "y_"}], "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "+", 
   SuperscriptBox["y", "2"]}]}]], "Input", "ExerciseMR",
 CellTags->"2.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"2", "+", "3"}], "]"}]], "Input", "ExerciseMR",
 CellTags->"2.4 Exercises"],

Cell[BoxData[
 RowBox[{"f", "[", "5", "]"}]], "Output", "ExerciseMR",
 CellTags->"2.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "Use one of the ",
 Cell[BoxData[
  ButtonBox["Hold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hold"]]],
 " attributes to give ",
 Cell[BoxData[
  StyleBox["f", "ExLink"]]],
 " the property that its argument is not evaluated first. The resulting \
output should look like this:"
}], "ExerciseText",
 CellTags->"2.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"2", "+", "3"}], "]"}]], "ExerciseInput", "ExerciseMR",
 Editable->False,
 CellTags->"2.4 Exercises"],

Cell[BoxData["13"], "ExerciseOutput", "ExerciseMR",
 CellTags->"2.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Define a function that takes each number in a vector of numbers and returns \
that number if it is within a certain interval, say ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox[
     RowBox[{"-", "0.5"}], "OsF"], "<", "x", "<", 
    StyleBox["0.5", "OsF"]}], TraditionalForm]]],
 ", and returns ",
 Cell[BoxData[
  FormBox[
   SqrtBox["x"], TraditionalForm]]],
 " otherwise. Then make your function listable so that it can operate on \
vectors (lists) directly."
}], "ExerciseItem",
 CellTags->{"i:62", "2.4 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "First clear any definitions and attributes that might be associated with ",
 Cell[BoxData["f"]],
 "."
}], "SolutionItem",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "f", "]"}]], "InputOnly",
 CellTags->"2.4 Solutions"],

Cell[TextData[{
 "Then set the ",
 Cell[BoxData[
  ButtonBox["HoldAll",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/HoldAll"]], "InlineFormula"],
 " attribute to prevent initial evaluation of the argument of this function."
}], "SolutionText",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"f", ",", "HoldAll"}], "]"}]], "InputOnly",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"x_", "+", "y_"}], "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "+", 
   SuperscriptBox["y", "2"]}]}]], "InputOnly",
 CellTags->"2.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"a", "+", "b"}], "]"}]], "Input",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "2"], "+", 
  SuperscriptBox["b", "2"]}]], "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"2", "+", "3"}], "]"}]], "Input",
 CellTags->"2.4 Solutions"],

Cell[BoxData["13"], "Output",
 CellTags->"2.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is a small list of random numbers to use.", "SolutionItem",
 CellTags->"2.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vec", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "10"}], "]"}]}]], "Input",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.06065756638430653`"}], ",", 
   RowBox[{"-", "0.2454913686669311`"}], ",", "0.6121181611432345`", ",", 
   "0.9042411569260453`", ",", 
   RowBox[{"-", "0.5988838692442466`"}], ",", "0.5461083412566383`", ",", 
   "0.1459785959111235`", ",", 
   RowBox[{"-", "0.4912070954388845`"}], ",", "0.32769897093241207`", ",", 
   "0.8109522171026073`"}], "}"}]], "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],

Cell["\<\
The function could be set up to take two arguments, the number and the bound.\
\
\>", "SolutionText",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fun", "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", "bound_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "bound"}], "<", "x", "<", "bound"}], ",", "x", ",", 
    SqrtBox["x"]}], "]"}]}]], "InputOnly",
 CellTags->"2.4 Solutions"],

Cell[TextData[{
 "Make ",
 Cell[BoxData["fun"]],
 " listable."
}], "SolutionText",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"fun", ",", "Listable"}], "]"}]], "InputOnly",
 CellTags->"2.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fun", "[", 
  RowBox[{"vec", ",", "0.5"}], "]"}]], "Input",
 CellTags->"2.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.06065756638430653`"}], ",", 
   RowBox[{"-", "0.2454913686669311`"}], ",", "0.7823798061959641`", ",", 
   "0.9509159568153462`", ",", 
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.773875874571786`", " ", "\[ImaginaryI]"}]}], ",", 
   "0.7389914351713681`", ",", "0.1459785959111235`", ",", 
   RowBox[{"-", "0.4912070954388845`"}], ",", "0.32769897093241207`", ",", 
   "0.9005288541199595`"}], "}"}]], "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],

Cell[BoxData[" "], "Input"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["3", "ChapterN"],

Cell[CellGroupData[{

Cell["Lists", "ChapterTitle",
 CellTags->"c:1"],

Cell[CellGroupData[{

Cell["Creating and displaying lists", "ExerciseSubsection"],

Cell[TextData[{
 "Generate the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "6", ",", "8"}], "}"}]}], "}"}], 
   "ExLink"]]],
 " in two different ways using the ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " function."
}], "ExerciseItem",
 CellTags->"3.1 Exercises"],

Cell[TextData[{
 "A table containing ten random ",
 StyleBox["1", "OsF"],
 "s and ",
 StyleBox["0", "OsF"],
 "s can be created using ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "10", "}"}]}], "]"}], "ExLink"]]],
 ". Create a ten-element list of random ",
 StyleBox["1", "OsF"],
 "s, ",
 StyleBox["0", "OsF"],
 "s and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"-", "1"}], "OsF"], TraditionalForm]]],
 "s."
}], "ExerciseItem",
 CellTags->"3.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a ten-element list of random ",
 StyleBox["1", "OsF"],
 "s and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"-", "1"}], "OsF"], TraditionalForm]]],
 "s. This list can be viewed as the steps taken in a random walk along the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 "-axis, where a step can be taken in either the positive ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " direction (corresponding to ",
 StyleBox["1", "OsF"],
 ") or the negative ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " direction (corresponding to ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"-", "1"}], "OsF"], TraditionalForm]]],
 ") with equal likelihood. "
}], "ExerciseItem",
 CellTags->{"Ex.Ten element list", "3.1 Exercises", "i:21"}],

Cell["\<\
The random walk in one, two, three (and even higher) dimensions is used in \
science and engineering to represent phenomena that are probabilistic in \
nature. We will use a variety of random walk models throughout this book to \
illustrate many different programming concepts. \
\>", "ExerciseText",
 ParagraphIndent->12,
 CellTags->"3.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generate both of the following arrays using the ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " function."
}], "ExerciseItem",
 CellTags->"3.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"f", ",", "5"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"3.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", "1", "]"}], ",", 
   RowBox[{"f", "[", "2", "]"}], ",", 
   RowBox[{"f", "[", "3", "]"}], ",", 
   RowBox[{"f", "[", "4", "]"}], ",", 
   RowBox[{"f", "[", "5", "]"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"3.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"3.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"1", ",", "1"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"1", ",", "2"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"1", ",", "3"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"1", ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"2", ",", "1"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"2", ",", "2"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"2", ",", "3"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"2", ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"3", ",", "1"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"3", ",", "2"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"3", ",", "3"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"3", ",", "4"}], "]"}]}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"3.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Construct an integer lattice graphic like the one below. Start by creating \
pairs of coordinate points to connect with lines \[Dash] here we have written \
the coordinates explicitly but you should generate them programmatically. \
Once you have your coordinate pairs, you can display the graphic as follows:\
\>", "ExerciseItem",
 CellTags->{"3.1 Exercises", "i:22"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{"Line", "[", "coords", "]"}], "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"3.1 Exercises"],

Cell[BoxData[
 GraphicsBox[
  LineBox[{{{-2, -1}, {2, -1}}, {{-2, 0}, {2, 0}}, {{-2, 1}, {2, 
   1}}, {{-2, -1}, {-2, 1}}, {{-1, -1}, {-1, 1}}, {{0, -1}, {0, 1}}, {{
   1, -1}, {1, 1}}, {{2, -1}, {2, 1}}}],
  ImageSize->{168.35288065843562`, Automatic}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"3.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Import six images, resize them to the same dimensions, then display them \
inside a ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"3", "\[Cross]", "2"}], "OsF"], TraditionalForm]]],
 " grid using options for ",
 Cell[BoxData[
  ButtonBox["Grid",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Grid"]]],
 " to format the output."
}], "ExerciseItem",
 CellTags->"3.1 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "You can take every other element in the iterator list, or encode that in \
the expression ",
 Cell[BoxData[
  RowBox[{"2", " ", "j"}]]],
 "."
}], "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{"j", ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", "8", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", "i", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4", ",", "6", ",", "8"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"2", " ", "j"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "4", ",", "6", ",", "8"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is probably the simplest way to generate random ",
 StyleBox["-1", "OsF"],
 "s, ",
 StyleBox["0", "OsF"],
 "s, and ",
 StyleBox["1", "OsF"],
 "s."
}], "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomInteger", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Or use ",
 Cell[BoxData[
  ButtonBox["RandomChoice",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RandomChoice"]], "InlineFormula"],
 ":"
}], "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomChoice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here are three ways to generate the list.", "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "10", "}"}]}], "]"}]}], "-", "1"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"-", "1"}], ")"}], 
  RowBox[{"RandomInteger", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "10", "}"}]}], "]"}]]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "The most direct way to do this is to use ",
 Cell[BoxData[
  ButtonBox["RandomChoice",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RandomChoice"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomChoice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "These lists can be generated with ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 ", using two iterators for the second example."
}], "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"f", "[", "i", "]"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"i", ",", "j"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"i", ",", "j"}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Some thought is needed to get the iterators right using ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"xmin", "=", 
   RowBox[{"-", "2"}]}], ";", 
  RowBox[{"xmax", "=", "2"}], ";", 
  RowBox[{"ymin", "=", 
   RowBox[{"-", "1"}]}], ";", 
  RowBox[{"ymax", "=", "1"}], ";"}], "\n", 
 RowBox[{"hlines", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xmin", ",", "y"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"xmax", ",", "y"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}]}], "]"}]}]}], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vlines", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "ymin"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "ymax"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell["\<\
Join the two sets of lines and then flatten to remove one set of braces.\
\>", "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pairs", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"hlines", ",", "vlines"}], "}"}], ",", "1"}], "]"}]}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Line", "[", "pairs", "]"}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 GraphicsBox[
  LineBox[{{{-2, -1}, {2, -1}}, {{-2, 0}, {2, 0}}, {{-2, 1}, {2, 
   1}}, {{-2, -1}, {-2, 1}}, {{-1, -1}, {-1, 1}}, {{0, -1}, {0, 1}}, {{
   1, -1}, {1, 1}}, {{2, -1}, {2, 1}}}]]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell["Here is a function that puts all this together:", "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Lattice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ymin_", ",", "ymax_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"hlines", ",", "vlines", ",", "coords"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hlines", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"xmin", ",", "y"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xmax", ",", "y"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vlines", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "ymin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "ymax"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"coords", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"hlines", ",", "vlines"}], "}"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"Line", "[", "coords", "]"}], "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Lattice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 GraphicsBox[
  LineBox[{{{-3, -2}, {3, -2}}, {{-3, -1}, {3, -1}}, {{-3, 0}, {3, 0}}, {{-3, 
   1}, {3, 1}}, {{-3, 2}, {3, 2}}, {{-3, -2}, {-3, 2}}, {{-2, -2}, {-2, 
   2}}, {{-1, -2}, {-1, 2}}, {{0, -2}, {0, 2}}, {{1, -2}, {1, 2}}, {{2, -2}, {
   2, 2}}, {{3, -2}, {3, 2}}}]]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here are some sample images to work with.", "SolutionItem",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomSample", "[", 
  RowBox[{
   RowBox[{"ExampleData", "[", "\"\<TestImage\>\"", "]"}], ",", "6"}], 
  "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Peppers\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Clock\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Airplane\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Numbers\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Lena\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"TestImage\"\>", ",", "\<\"Ruler\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"images", "=", 
   RowBox[{"Map", "[", 
    RowBox[{"ExampleData", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Girl2\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Peppers\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Aerial\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Moon\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Tank2\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<TestImage\>\"", ",", "\"\<Ruler\>\""}], "}"}]}], "}"}]}],
     "]"}]}], ";"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell["Get their dimensions.", "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"ImageDimensions", ",", "images"}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"256", ",", "256"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"512", ",", "512"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"256", ",", "256"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"256", ",", "256"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"512", ",", "512"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"512", ",", "512"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],

Cell["Resize the larger images.", "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"img1", "=", 
   RowBox[{"images", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"img2", "=", 
   RowBox[{"ImageResize", "[", 
    RowBox[{
     RowBox[{"images", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", "256"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"img3", "=", 
   RowBox[{"images", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"img4", "=", 
   RowBox[{"images", "[", 
    RowBox[{"[", "4", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"img5", "=", 
   RowBox[{"ImageResize", "[", 
    RowBox[{
     RowBox[{"images", "[", 
      RowBox[{"[", "5", "]"}], "]"}], ",", "256"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"img6", "=", 
   RowBox[{"ImageResize", "[", 
    RowBox[{
     RowBox[{"images", "[", 
      RowBox[{"[", "6", "]"}], "]"}], ",", "256"}], "]"}]}], ";"}]}], "Input",\

 CellTags->"3.1 Solutions"],

Cell["Finally, put in a grid with some formatting.", "SolutionText",
 CellTags->"3.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"img1", ",", "img2", ",", "img3"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"img4", ",", "img5", ",", "img6"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"Frame", "\[Rule]", "All"}], ",", 
   RowBox[{"Spacings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], ",", 
   RowBox[{"ItemSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"3.1 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJyUvee3HdWVPdovfHj/xvv4Pr3R3XY3NjlIgIRA5GQQGINJxjbYBGPANrYb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        "], {{0, 256}, {256, 0}}, {0, 
        255},
        ColorFunction->RGBColor],
       BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}], 
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJwku2dQW1ua7n/O9Nz/9MSe7p6OxwblLBCIHBzJCiiQDdjYxoFggo3BZDA5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        "], {{0, 256}, {256, 
        0}}, {0, 255},
        ColorFunction->RGBColor],
       BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}], 
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJwku+d2I2eWrtkza37MbcylzPl5prqUmSThvfc2gEDAe+8RCHjvvSE8QAAk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        "], {{0, 256}, {256, 0}}, {0, 255},
        ColorFunction->GrayLevel],
       BoxForm`ImageTag[
       "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}]},
    {
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJzkvPmbXVd95uukO0lnepIQHjp0uukEQiDEmIAxlrGNJ8nGAzbYxjMeZMmS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        "], {{0, 256}, {256, 0}}, {0, 255},
        ColorFunction->GrayLevel],
       BoxForm`ImageTag[
       "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}], 
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJwkvFeX5FZ6rqmZNRfzA+ZSY3Q0klrd7Fa3WHTl09vwBgHvPbA3vLfh01QV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        "], {{0, 256}, {256, 0}}, {0,
         255},
        ColorFunction->GrayLevel],
       BoxForm`ImageTag[
       "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}], 
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJztXW1wE8cZpmmZpkxn+hECScAOaZt0+rO/0g7JkDCF0GSwmQBTks60E2ib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        "], {{0, 
        256}, {256, 0}}, {0, 255},
        ColorFunction->GrayLevel],
       BoxForm`ImageTag[
       "Byte", ColorSpace -> "Grayscale", Interleaving -> None],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSizeRaw->{256, 256},
      PlotRange->{{0, 256}, {0, 256}}]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{3}}, "Rows" -> {{3}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["The structure of lists", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Given a list of integers such as the following, count the number of ",
 StyleBox["0", "OsF"],
 "s. Find a way to count all those elements of the list which are not ",
 StyleBox["1", "OsF"],
 "s."
}], "ExerciseItem",
 CellTags->"3.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ints", " ", "=", " ", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", " ", "5"}], "}"}], ",", " ", "30"}], 
   "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"3.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "2"}], ",", "2", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "5"}], ",", "3", ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "3"}], ",", "4", ",", 
   RowBox[{"-", "3"}], ",", "4", ",", "2", ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "3"}], ",", "1", ",", "2", ",", "3", ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "4"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "5", ",", 
   RowBox[{"-", "2"}], ",", "0", ",", "3"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"3.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Given the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "a"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "b"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "c"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"4", ",", "d"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "e"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"6", ",", "f"}], "}"}]}], "}"}]}], "}"}], "ExLink"]]],
 ", determine its dimensions. Use the ",
 Cell[BoxData[
  ButtonBox["Dimensions",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dimensions"]]],
 " function to check your answer."
}], "ExerciseItem",
 CellTags->"3.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Find the positions of the ",
 StyleBox["9", "OsF"],
 "s in the following list. Confirm using ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "10", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "1", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "1", ",", "6"}], "}"}]}], "}"}]], "ExerciseInput", \
"ExerciseMR",
 Evaluatable->False,
 CellTags->"3.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["Here is the list of integers to use.", "SolutionItem",
 CellTags->"3.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ints", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", "30"}], "]"}]}]], "Input",
 CellTags->"3.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "3"}], ",", "0", ",", 
   RowBox[{"-", "4"}], ",", "5", ",", 
   RowBox[{"-", "5"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "5"}], ",", "0", ",", 
   RowBox[{"-", "3"}], ",", "5", ",", "4", ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "5"}], ",", "1", ",", 
   RowBox[{"-", "4"}], ",", "4", ",", "3", ",", "2", ",", "3", ",", 
   RowBox[{"-", "2"}], ",", "5", ",", "4", ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "2", ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "3"}]}], "}"}]], "Output",
 CellTags->"3.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Count all elements that match ",
 StyleBox["0", "OsF"],
 "."
}], "SolutionText",
 CellTags->"3.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"ints", ",", "0"}], "]"}]], "Input",
 CellTags->"3.2 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"3.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Count all integers in ",
 Cell[BoxData["ints"]],
 " that do not match ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"3.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"ints", ",", 
   RowBox[{"Except", "[", "1", "]"}]}], "]"}]], "Input",
 CellTags->"3.2 Solutions"],

Cell[BoxData["29"], "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
From the top level, there are two lists, each consisting of three sublists, \
each sublist consisting of two elements.\
\>", "SolutionItem",
 CellTags->"3.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "a"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "b"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "c"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"4", ",", "d"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5", ",", "e"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6", ",", "f"}], "}"}]}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"3.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "3", ",", "2"}], "}"}]], "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]], "InlineFormula"],
 " function tells us that the ",
 StyleBox["9", "OsF"],
 "s are located in the second sublist, first position, and in the fourth \
sublist, third position."
}], "SolutionItem",
 CellTags->"3.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "5", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "10", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "1", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "1", ",", "6"}], "}"}]}], "}"}], ",", "9"}], 
  "]"}]], "Input",
 CellTags->"3.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Operations on lists", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Given a list of data points, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["{", "ExerciseMR"], 
   RowBox[{
    RowBox[{
     StyleBox["{", "ExerciseMR"], 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "ExerciseMR"], "1"], 
      StyleBox[",", "ExerciseMR"], 
      SubscriptBox[
       StyleBox["y", "ExerciseMR"], "1"]}], 
     StyleBox["}", "ExerciseMR"]}], 
    StyleBox[",", "ExerciseMR"], 
    RowBox[{
     StyleBox["{", "ExerciseMR"], 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "ExerciseMR"], "2"], 
      StyleBox[",", "ExerciseMR"], 
      SubscriptBox[
       StyleBox["y", "ExerciseMR"], "2"]}], 
     StyleBox["}", "ExerciseMR"]}], 
    StyleBox[",", "ExerciseMR"], 
    RowBox[{
     StyleBox["{", "ExerciseMR"], 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "ExerciseMR"], "3"], 
      StyleBox[",", "ExerciseMR"], 
      SubscriptBox[
       StyleBox["y", "ExerciseMR"], "3"]}], 
     StyleBox["}", "ExerciseMR"]}], 
    StyleBox[",", "ExerciseMR"], 
    RowBox[{
     StyleBox["{", "ExerciseMR"], 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "ExerciseMR"], "4"], 
      StyleBox[",", "ExerciseMR"], 
      SubscriptBox[
       StyleBox["y", "ExerciseMR"], "4"]}], 
     StyleBox["}", "ExerciseMR"]}], 
    StyleBox[",", "ExerciseMR"], 
    RowBox[{
     StyleBox["{", "ExerciseMR"], 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "ExerciseMR"], "5"], 
      StyleBox[",", "ExerciseMR"], 
      SubscriptBox[
       StyleBox["y", "ExerciseMR"], "5"]}], 
     StyleBox["}", "ExerciseMR"]}]}], 
   StyleBox["}", "ExerciseMR"]}]]],
 ", separate the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 " components to get:"
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[BoxData[
 StyleBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["x", "3"], ",", 
      SubscriptBox["x", "4"], ",", 
      SubscriptBox["x", "5"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["y", "1"], ",", 
      SubscriptBox["y", "2"], ",", 
      SubscriptBox["y", "3"], ",", 
      SubscriptBox["y", "4"], ",", 
      SubscriptBox["y", "5"]}], "}"}]}], "}"}], "ExerciseMR"]], "Output",
 CellChangeTimes->{3.552933266543161*^9},
 CellTags->"3.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "Consider a two-dimensional random walk on a square lattice. (A square \
lattice can be envisioned as a two-dimensional grid, just like the lines on \
graph paper.) Each step can be in one of the four directions: ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], "ExLink"]]],
 ", corresponding to steps in the compass directions east, north, west and \
south, respectively. Use the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}], "ExLink"]]],
 " to create a list of the steps of a ten-step random walk."
}], "ExerciseItem",
 CellTags->{"i:57", "3.3 Exercises"}],

Cell[TextData[{
 "Extract elements in the even-numbered locations in the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell["\<\
Given a matrix, use list component assignment to swap any two rows.\
\>", "ExerciseItem",
 CellTags->{"Ex.Row swapping", "i:61", "3.3 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["AddColumn", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["mat", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["col", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["pos", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that inserts a column vector ",
 StyleBox["col",
  FontSlant->"Italic"],
 " into the matrix ",
 StyleBox["mat",
  FontSlant->"Italic"],
 " at the column position given by ",
 StyleBox["pos",
  FontSlant->"Italic"],
 ". For example:"
}], "ExerciseItem",
 CellTags->{"i:58", "3.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"3.3 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "0", "9", "1"},
     {"0", "0", "0", "5"},
     {"9", "6", "2", "5"},
     {"1", "2", "2", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"3.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AddColumn", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "3"}], "]"}], "//",
   "MatrixForm"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"3.3 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "0", "a", "9", "1"},
     {"0", "0", "b", "0", "5"},
     {"9", "6", "c", "2", "5"},
     {"1", "2", "d", "2", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Suppose you are given a list ",
 StyleBox["S", "MR", "ExLink"],
 " of length ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", and a list ",
 StyleBox["P", "MR", "ExLink"],
 " containing ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " different numbers between ",
 StyleBox["1", "OsF"],
 " and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", that is, ",
 StyleBox["P", "MR", "ExLink"],
 " is a permutation of ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Range", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 ". Compute the list ",
 StyleBox["T", "MR", "ExLink"],
 " such that for all ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " between ",
 StyleBox["1", "OsF"],
 " and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"T", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], "=", 
    
    RowBox[{"S", "\[LeftDoubleBracket]", 
     RowBox[{"P", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
     "\[RightDoubleBracket]"}]}], "ExLink"]]],
 ". For example, if ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"S", "=", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "ExerciseMR"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"P", "=", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}]}], "ExerciseMR"]]],
 ", then ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"T", "=", 
    RowBox[{"{", 
     RowBox[{"c", ",", "b", ",", "d", ",", "a"}], "}"}]}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[TextData[{
 "Given the lists ",
 StyleBox["S", "MR", "ExLink"],
 " and ",
 StyleBox["P", "MR", "ExLink"],
 " in the previous exercise, compute the list ",
 StyleBox["U", "MR", "ExLink"],
 " such that for all ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " between 1 and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"U", "\[LeftDoubleBracket]", 
     RowBox[{"P", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
     "\[RightDoubleBracket]"}], "=", 
    RowBox[{"S", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
   "ExerciseMR"]], "ExLink"],
 ", that is, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"S", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
   "ExLink"]]],
 " takes the value from position ",
 Cell[BoxData[
  RowBox[{
   StyleBox["P", "ExLink"], 
   StyleBox["\[LeftDoubleBracket]", "ExLink"], 
   StyleBox["i", "TI"], 
   StyleBox["\[RightDoubleBracket]", "ExLink"]}]]],
 " in ",
 StyleBox["U", "MR", "ExLink"],
 ". Thus, for ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"S", "=", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"P", "=", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}]}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"U", "=", 
    RowBox[{"{", 
     RowBox[{"d", ",", "b", ",", "a", ",", "c"}], "}"}]}], "ExLink"]]],
 ". Think of it as moving ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"S", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
   "ExLink"]]],
 " to position ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"P", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
   "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"S", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "ExLink"]]],
 " to position ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"P", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "ExLink"]]],
 ", and so on. Hint: start by pairing the elements of ",
 StyleBox["P", "MR", "ExLink"],
 " with the elements of ",
 StyleBox["S", "MR", "ExLink"],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[TextData[{
 "How would you perform the same task as ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Prepend", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    RowBox[{
     StyleBox["{", "ExLink"], 
     RowBox[{
      StyleBox["x", "ExerciseTI"], 
      StyleBox[",", "ExLink"], 
      StyleBox["y", "ExerciseTI"]}], 
     StyleBox["}", "ExLink"]}], 
    StyleBox[",", "ExLink"], 
    StyleBox["z", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " using the ",
 Cell[BoxData[
  ButtonBox["Join",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Join"]]],
 " function?"
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[TextData[{
 "Starting with the lists ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "ExLink"]]],
 ", create the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"2", ",", "4", ",", "b", ",", "d"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[TextData[{
 "Starting with the lists ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "ExLink"]]],
 ", create the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
    "1", ",", "a", ",", "2", ",", "b", ",", "3", ",", "c", ",", "4", ",", 
     "d"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[TextData[{
 "Given two lists, find all those elements that are not common to the two \
lists. For example, starting with the lists, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "ExLink"]]],
 ", your answer would return the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"c", ",", "d", ",", "e", ",", "f"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "One of the tasks in computational linguistics involves statistical analysis \
of text using what are called ",
 StyleBox["n",
  FontSlant->"Italic"],
 "-grams. These are sequences of ",
 StyleBox["n",
  FontSlant->"Italic"],
 " adjacent letters or words and their frequency distribution in a body of \
text can be used to predict word usage based on the previous history or \
usage. Import a file consisting of some text and find the twenty most \
frequently occurring word combinations. Pairs of words that are grouped like \
this are called ",
 StyleBox["bigram",
  FontSlant->"Italic"],
 "s, that is, ",
 StyleBox["n",
  FontSlant->"Italic"],
 "-grams for ",
 Cell[BoxData[
  RowBox[{
   StyleBox["n", "ExerciseTI"], "=", 
   StyleBox["2", "OsF"]}]]],
 ". "
}], "ExerciseItem",
 CellTags->{"i:59", "3.3 Exercises"}],

Cell[TextData[{
 "Use the following ",
 Cell[BoxData[
  ButtonBox["StringSplit",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringSplit"]], "InlineFormula"],
 " code to split long strings into a list of words that can then be operated \
on with the list manipulation functions. Regular expressions are discussed in \
detail in Section",
 StyleBox["\[NonBreakingSpace]",
  FontFamily->"Syntax LT Std"],
 StyleBox["9.4", "OsF"],
 "."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->{"i:60", "3.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"words", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{"\"\<Use StringSplit to split long strings into words.\>\"", ",", 
    RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], 
   "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"3.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Use\"\>", ",", "\<\"StringSplit\"\>", ",", "\<\"to\"\>", 
   ",", "\<\"split\"\>", ",", "\<\"long\"\>", ",", "\<\"strings\"\>", 
   ",", "\<\"into\"\>", ",", "\<\"words\"\>"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Based on the previous exercise, create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["NGrams", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a string of text and returns a list of ",
 StyleBox["n",
  FontSlant->"Italic"],
 "-grams, that is a list of the ",
 StyleBox["n",
  FontSlant->"Italic"],
 " adjacent words. For example:"
}], "ExerciseItem",
 CellTags->"3.3 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "text", "=", "\"\<Use StringSplit to split long strings into words.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NGrams", "[", 
  RowBox[{"text", ",", "3"}], "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"3.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Use\"\>", ",", "\<\"StringSplit\"\>", ",", "\<\"to\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"StringSplit\"\>", ",", "\<\"to\"\>", ",", "\<\"split\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"to\"\>", ",", "\<\"split\"\>", ",", "\<\"long\"\>"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"\<\"split\"\>", ",", "\<\"long\"\>", ",", "\<\"strings\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"long\"\>", ",", "\<\"strings\"\>", ",", "\<\"into\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"strings\"\>", ",", "\<\"into\"\>", ",", "\<\"words\"\>"}], 
    "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a straightforward use of the ",
 Cell[BoxData[
  ButtonBox["Transpose",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Transpose"]], "InlineFormula"],
 " function."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["y", "1"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["y", "2"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "3"], ",", 
      SubscriptBox["y", "3"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "4"], ",", 
      SubscriptBox["y", "4"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "5"], ",", 
      SubscriptBox["y", "5"]}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["x", "3"], ",", 
     SubscriptBox["x", "4"], ",", 
     SubscriptBox["x", "5"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["y", "1"], ",", 
     SubscriptBox["y", "2"], ",", 
     SubscriptBox["y", "3"], ",", 
     SubscriptBox["y", "4"], ",", 
     SubscriptBox["y", "5"]}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here is one way to do it. First create a list representing the directions.\
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NSEW", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["RandomChoice",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RandomChoice"]], "InlineFormula"],
 " chooses with replacement."
}], "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomChoice", "[", 
  RowBox[{"NSEW", ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Start by dropping the first element in the list, then create a nested list of \
every other element in the remaining list, and finally unnest the resulting \
list.\
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Rest", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}], 
   "}"}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}], 
  "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{"%", ",", "1", ",", "2"}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "b", "}"}], ",", 
   RowBox[{"{", "d", "}"}], ",", 
   RowBox[{"{", "f", "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", "%", "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "d", ",", "f"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "This can also be done directly in one step using ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " with ",
 Cell[BoxData[
  ButtonBox["Span",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Span"]], "InlineFormula"],
 ". The expression ",
 Cell[BoxData[
  RowBox[{"2", ";;", 
   RowBox[{"-", "1"}], ";;", "2"}]]],
 " indicates the range from the second element to the last element in \
increments of ",
 StyleBox["2", "OsF"],
 "."
}], "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Part", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}],
     "}"}], ",", 
   RowBox[{"2", ";;", 
    RowBox[{"-", "1"}], ";;", "2"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "d", ",", "f"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The standard procedural approach is to use a temporary variable to do the \
swapping.\
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "8", "6", "9"},
     {"4", "8", "4", "1"},
     {"2", "9", "7", "5"},
     {"6", "3", "0", "7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"mat", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mat", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "=", 
   RowBox[{"mat", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mat", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "=", "temp"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"4", "8", "4", "1"},
     {"1", "8", "6", "9"},
     {"2", "9", "7", "5"},
     {"6", "3", "0", "7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["\<\
But you can use parallel assignments to avoid the temporary variable.\
\>", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "9", "8", "7"},
     {"8", "8", "8", "4"},
     {"2", "4", "7", "7"},
     {"7", "4", "7", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"mat", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"mat", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"mat", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"mat", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"8", "8", "8", "4"},
     {"2", "9", "8", "7"},
     {"2", "4", "7", "7"},
     {"7", "4", "7", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["In fact you can make this a bit more compact.", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "7", "2", "6"},
     {"2", "0", "3", "6"},
     {"4", "2", "4", "8"},
     {"5", "8", "2", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"mat", "[", 
    RowBox[{"[", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], "]"}], "]"}], "=", 
   RowBox[{"mat", "[", 
    RowBox[{"[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "0", "3", "6"},
     {"5", "7", "2", "6"},
     {"4", "2", "4", "8"},
     {"5", "8", "2", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "A key point to notice is that in this exercise, the matrix ",
 Cell[BoxData["mat"]],
 " was overwritten in each case; in other words, these were destructive \
operations. Section ",
 StyleBox["5.5", "OsF"],
 " discusses how to handle row and column swapping properly so that the \
original matrix remains untouched."
}], "SolutionText",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
You need to first transpose the matrix to operate on the columns as rows. \
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"7", "0", "8", "8"},
     {"8", "3", "3", "8"},
     {"3", "0", "8", "4"},
     {"7", "5", "0", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", "mat", "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"7", ",", "8", ",", "3", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "3", ",", "8", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "8", ",", "4", ",", "6"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["\<\
Now insert the column vector at the desired position. Then transpose back.\
\>", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Insert", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", "mat", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "3"}], "]"}], "//",
   "MatrixForm"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"7", "8", "3", "7"},
     {"0", "3", "0", "5"},
     {"a", "b", "c", "d"},
     {"8", "3", "8", "0"},
     {"8", "8", "4", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "@", 
   RowBox[{"Insert", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", "mat", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "3"}], "]"}]}],
   "//", "MatrixForm"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"7", "0", "a", "8", "8"},
     {"8", "3", "b", "3", "8"},
     {"3", "0", "c", "8", "4"},
     {"7", "5", "d", "0", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["\<\
Here then is the function, with some basic argument checking to make sure the \
number of elements in the column vector is the same as the number of rows of \
the matrix. \
\>", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddColumn", "[", 
    RowBox[{"mat_", ",", "col_", ",", "pos_"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "col", "]"}], "\[Equal]", 
    RowBox[{"Length", "[", "mat", "]"}]}]}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Insert", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", "mat", "]"}], ",", "col", ",", "pos"}], "]"}], 
   "]"}]}]], "Input",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We want those elements in ",
 Cell[BoxData["S"]],
 " given by the positions in ",
 Cell[BoxData["P"]],
 "."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"S", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}]}], ";"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S", "[", 
  RowBox[{"[", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], "]"}], "]"}]], "Input",\

 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"c", ",", "b", ",", "d", ",", "a"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["Or, more compactly:", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S", "\[LeftDoubleBracket]", "P", "\[RightDoubleBracket]"}]], "Input",\

 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"c", ",", "b", ",", "d", ",", "a"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Without resorting to a functional approach as discussed in ",
 "Chapter",
 " ",
 StyleBox["5", "OsF"],
 ", this requires several steps."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"S", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}]}], ";"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", 
  RowBox[{"{", 
   RowBox[{"P", ",", "S"}], "}"}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "b"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "d"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sort", "[", "%", "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "d"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "b"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "c"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", "%", "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "b", ",", "a", ",", "c"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], "Input",\

 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"d", ",", "b", ",", "a", ",", "c"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Map",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Map"]], "InlineFormula"],
 ", this can be done in one step."
}], "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Last", ",", 
   RowBox[{"Sort", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"P", ",", "S"}], "}"}], "]"}], "]"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"d", ",", "b", ",", "a", ",", "c"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Join",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Join"]], "InlineFormula"],
 " expects lists as arguments."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Join", "[", 
  RowBox[{
   RowBox[{"{", "z", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"z", ",", "x", ",", "y"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Joining the two lists and then using ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " with ",
 Cell[BoxData[
  ButtonBox["Span",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Span"]], "InlineFormula"],
 " is the most direct way to do this."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "a", ",", "b", ",", "c", ",", "d"}],
   "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "[", 
  RowBox[{"[", 
   RowBox[{"2", ";;", 
    RowBox[{"-", "1"}], ";;", "2"}], "]"}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "4", ",", "b", ",", "d"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  ButtonBox["Riffle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Riffle"]], "InlineFormula"],
 " is designed for this task."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riffle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "a", ",", "2", ",", "b", ",", "3", ",", "c", ",", "4", ",", "d"}],
   "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["\<\
This can also be done in two steps by first transposing the two lists and \
then flattening.\
\>", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "}"}], 
  "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "b"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "d"}], "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", "%", "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "a", ",", "2", ",", "b", ",", "3", ",", "c", ",", "4", ",", "d"}],
   "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This is another way of asking for all those elements that are in the union \
but not the intersection of the two sets.\
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}]}], ";"}]}], "InputOnly",\

 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{"A", "\[Union]", "B"}], ",", 
   RowBox[{"A", "\[Intersection]", "B"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"c", ",", "d", ",", "e", ",", "f"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ",", 
   RowBox[{"Intersection", "[", 
    RowBox[{"A", ",", "B"}], "]"}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"c", ",", "d", ",", "e", ",", "f"}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We will use Darwin\[CloseCurlyQuote]s ",
 StyleBox["On the Origin of Species",
  FontSlant->"Italic"],
 " text, built into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " via ",
 Cell[BoxData[
  ButtonBox["ExampleData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ExampleData"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"darwin", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<OriginOfSpecies\>\""}], "}"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{"words", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{"darwin", ",", 
    RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], 
   "]"}]}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   PanelBox[GridBox[{
      {
       StyleBox[
        StyleBox[
         DynamicBox[ToBoxes[
           FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
           StandardForm],
          ImageSizeCache->{420., {3., 12.}}],
         StripOnInput->False,
         DynamicUpdating->True], "Panel",
        StripOnInput->False,
        Background->None]},
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          
          RowBox[{"\<\"INTRODUCTION\"\>", ",", "\<\"When\"\>", 
           ",", "\<\"on\"\>", ",", "\<\"board\"\>", ",", "\<\"H\"\>", 
           ",", "\<\"M\"\>", ",", "\<\"S\"\>", ",", 
           RowBox[{"\[LeftSkeleton]", "151191", "\[RightSkeleton]"}], 
           ",", "\<\"wonderful\"\>", ",", "\<\"have\"\>", ",", "\<\"been\"\>",
            ",", "\<\"and\"\>", ",", "\<\"are\"\>", ",", "\<\"being\"\>", 
           ",", "\<\"evolved\"\>"}], "}"}],
         Short[#, 5]& ],
        Background->GrayLevel[1],
        BaseStyle->{Deployed -> False},
        Frame->True,
        FrameStyle->GrayLevel[0, 0.2],
        StripOnInput->False]},
      {
       RowBox[{
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
             StandardForm],
            ImageSizeCache->{75., {1., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 50, 23355723620043267302, 5/2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
             StandardForm],
            ImageSizeCache->{80., {1., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 50, 23355723620043267302, 5 2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
             StandardForm],
            ImageSizeCache->{125., {3., 12.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 50, 23355723620043267302, Infinity],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
             StandardForm],
            ImageSizeCache->{111., {1., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>FrontEndExecute[{
            FrontEnd`SetOptions[
            FrontEnd`$FrontEnd, 
             FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
            FrontEnd`FrontEndToken["PreferencesDialog"]}],
         Evaluator->None,
         Method->"Preemptive"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[1.2]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    DefaultBaseStyle->{},
    FrameMargins->5],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[50]]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["\<\
First, partition the list of words into pairs with overlap one. Then tally \
them and sort by the frequency count, the last element in each sublist. \
Finally, take the last twenty expressions, those bigrams occurring the most \
frequently.\
\>", "SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tally", "=", 
   RowBox[{"SortBy", "[", 
    RowBox[{
     RowBox[{"Tally", "[", 
      RowBox[{"Partition", "[", 
       RowBox[{"words", ",", "2", ",", "1"}], "]"}], "]"}], ",", "Last"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Take", "[", 
  RowBox[{"tally", ",", 
   RowBox[{"-", "20"}]}], "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"has\"\>", ",", "\<\"been\"\>"}], "}"}], ",", "190"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"each\"\>", ",", "\<\"other\"\>"}], "}"}], ",", "195"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"species\"\>", ",", "\<\"of\"\>"}], "}"}], ",", "202"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"of\"\>", ",", "\<\"life\"\>"}], "}"}], ",", "229"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"with\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "230"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"natural\"\>", ",", "\<\"selection\"\>"}], "}"}], ",", 
     "236"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"it\"\>", ",", "\<\"is\"\>"}], "}"}], ",", "238"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"and\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "240"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"by\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "243"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"from\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "256"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", "\<\"a\"\>"}], "}"}], ",", "256"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"to\"\>", ",", "\<\"be\"\>"}], "}"}], ",", "267"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"of\"\>", ",", "\<\"a\"\>"}], "}"}], ",", "268"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"have\"\>", ",", "\<\"been\"\>"}], "}"}], ",", "432"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"that\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "438"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"on\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "501"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"to\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "582"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"the\"\>", ",", "\<\"same\"\>"}], "}"}], ",", "716"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"in\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "1028"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"of\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "1995"}], 
    "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],

Cell["Here are the next twenty most frequently occurring bigrams.", \
"SolutionText",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Take", "[", 
  RowBox[{"tally", ",", 
   RowBox[{
    RowBox[{"-", "40"}], ";;", 
    RowBox[{"-", "20"}]}]}], "]"}]], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"to\"\>", ",", "\<\"have\"\>"}], "}"}], ",", "120"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"which\"\>", ",", "\<\"are\"\>"}], "}"}], ",", "121"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"conditions\"\>", ",", "\<\"of\"\>"}], "}"}], ",", "124"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"between\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "125"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"do\"\>", ",", "\<\"not\"\>"}], "}"}], ",", "128"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"and\"\>", ",", "\<\"in\"\>"}], "}"}], ",", "132"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"the\"\>", ",", "\<\"case\"\>"}], "}"}], ",", "133"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"can\"\>", ",", "\<\"be\"\>"}], "}"}], ",", "137"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"will\"\>", ",", "\<\"be\"\>"}], "}"}], ",", "138"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"as\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "141"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"would\"\>", ",", "\<\"be\"\>"}], "}"}], ",", "142"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"number\"\>", ",", "\<\"of\"\>"}], "}"}], ",", "144"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"all\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "150"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"at\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "157"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"the\"\>", ",", "\<\"most\"\>"}], "}"}], ",", "160"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"the\"\>", ",", "\<\"other\"\>"}], "}"}], ",", "167"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"for\"\>", ",", "\<\"the\"\>"}], "}"}], ",", "171"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"the\"\>", ",", "\<\"species\"\>"}], "}"}], ",", "172"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"have\"\>"}], "}"}], ",", "187"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"may\"\>", ",", "\<\"be\"\>"}], "}"}], ",", "189"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"has\"\>", ",", "\<\"been\"\>"}], "}"}], ",", "190"}], 
    "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This is a straightforward extension of the previous exercise.\
\>", "SolutionItem",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NGrams", "[", 
   RowBox[{"text_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Partition", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StringSplit", "[", 
     RowBox[{"text", ",", 
      RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], "]"}], ",",
     "n", ",", "1"}], "]"}]}]], "InputOnly",
 CellTags->"3.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "sentence", "=", 
   "\"\<Use StringSplit to split long strings into words.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NGrams", "[", 
  RowBox[{"sentence", ",", "3"}], "]"}]}], "Input",
 CellTags->"3.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Use\"\>", ",", "\<\"StringSplit\"\>", ",", "\<\"to\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"StringSplit\"\>", ",", "\<\"to\"\>", ",", "\<\"split\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"to\"\>", ",", "\<\"split\"\>", ",", "\<\"long\"\>"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"\<\"split\"\>", ",", "\<\"long\"\>", ",", "\<\"strings\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"long\"\>", ",", "\<\"strings\"\>", ",", "\<\"into\"\>"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"strings\"\>", ",", "\<\"into\"\>", ",", "\<\"words\"\>"}], 
    "}"}]}], "}"}]], "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["4", "ChapterN"],

Cell[CellGroupData[{

Cell["Patterns and rules", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Patterns", "ExerciseSubsection"],

Cell[TextData[{
 "Use conditional patterns to find all those numbers in a list of integers \
that are divisible by ",
 StyleBox["2", "OsF"],
 " or ",
 StyleBox["3", "OsF"],
 " or ",
 StyleBox["5", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->"4.1 Exercises"],

Cell[TextData[{
 "Write down five conditional patterns that match the expression ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"4.1 Exercises"],

Cell[TextData[{
 "Write a function ",
 StyleBox["Collatz", "MR", "ExLink"],
 " that takes an integer ",
 StyleBox["n",
  FontSlant->"Italic"],
 " as an argument and returns ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     StyleBox["3", "OsF"], 
     StyleBox["\[ThinSpace]", "OsF"], "n"}], "+", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " if ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is an odd integer and returns ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 " if ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is even."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->{"i:27", "4.1 Exercises"}],

Cell[TextData[{
 "Write the ",
 StyleBox["Collatz", "MR", "ExLink"],
 " function from the above exercise, but this time you should also check that \
the argument to ",
 StyleBox["Collatz", "MR", "ExLink"],
 " is positive."
}], "ExerciseItem",
 CellTags->"4.1 Exercises"],

Cell[TextData[{
 "Use alternatives to write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["abs", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["x", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that returns ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " if ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "\[GreaterEqual]", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "x"}], TraditionalForm]]],
 " if ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "<", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", whenever ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " is an integer or a rational number. Whenever ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " is complex, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["abs", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["x", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " should return ",
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"re", "(", "x", ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"im", "(", "x", ")"}], "2"]}]], TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->"4.1 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["swapTwo", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that returns ",
 StyleBox["lis", "ExerciseTI"],
 " with only its first two elements interchanged; for example, the input ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"swapTwo", "[", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
   "ExerciseMR"]]],
 " should return ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"b", ",", "a", ",", "c", ",", "d", ",", "e"}], "}"}], 
   "ExerciseMR"]]],
 ". If ",
 StyleBox["lis", "ExerciseTI"],
 " has fewer than two elements, ",
 StyleBox["swapTwo", "ExerciseMR", "ExLink"],
 " just returns ",
 StyleBox["lis",
  FontSlant->"Italic"],
 ". Write ",
 StyleBox["swapTwo", "MR", "ExLink"],
 " using three clauses: one for the empty list, one for one-element lists, \
and one for all other lists. Then write it using two clauses: one for lists \
of length ",
 StyleBox["0", "OsF"],
 " or ",
 StyleBox["1", "OsF"],
 " and another for all longer lists."
}], "ExerciseItem",
 CellTags->"4.1 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["Start by creating a list of integers with which to work.", \
"SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lis", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{"1000", ",", 
    RowBox[{"{", "20", "}"}]}], "]"}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "480", ",", "430", ",", "509", ",", "848", ",", "842", ",", "760", ",", 
   "785", ",", "769", ",", "579", ",", "96", ",", "754", ",", "241", ",", 
   "840", ",", "180", ",", "849", ",", "707", ",", "347", ",", "333", ",", 
   "613", ",", "67"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["IntegerQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/IntegerQ"]], "InlineFormula"],
 " is a predicate; it returns ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/True"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["False",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/False"]], "InlineFormula"],
 ", so we need to use the logical OR to separate clauses here."
}], "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{"lis", ",", 
   RowBox[{"n_", "/;", 
    RowBox[{
     RowBox[{"IntegerQ", "[", 
      RowBox[{"n", "/", "2"}], "]"}], "||", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"n", "/", "3"}], "]"}], "||", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"n", "/", "5"}], "]"}]}]}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "480", ",", "430", ",", "848", ",", "842", ",", "760", ",", "785", ",", 
   "579", ",", "96", ",", "754", ",", "840", ",", "180", ",", "849", ",", 
   "333"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell["This is a bit more compact and direct.", "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{"lis", ",", 
   RowBox[{"n_", "/;", 
    RowBox[{
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"n", ",", "2"}], "]"}], "\[Equal]", "0"}], "||", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"n", ",", "3"}], "]"}], "\[Equal]", "0"}], "||", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"n", ",", "5"}], "]"}], "\[Equal]", "0"}]}]}]}], 
  "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "480", ",", "430", ",", "848", ",", "842", ",", "760", ",", "785", ",", 
   "579", ",", "96", ",", "754", ",", "840", ",", "180", ",", "849", ",", 
   "333"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Once you are familiar with pure functions (",
 "Section",
 " ",
 StyleBox["5.6", "OsF"],
 "), you can also do this with ",
 Cell[BoxData[
  ButtonBox["Select",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Select"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{"lis", ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"#", ",", "2"}], "]"}], "\[Equal]", "0"}], "||", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"#", ",", "3"}], "]"}], "\[Equal]", "0"}], "||", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"#", ",", "5"}], "]"}], "\[Equal]", "0"}]}], "&"}]}], 
  "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "480", ",", "430", ",", "848", ",", "842", ",", "760", ",", "785", ",", 
   "579", ",", "96", ",", "754", ",", "840", ",", "180", ",", "849", ",", 
   "333"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["FullForm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FullForm"]], "InlineFormula"],
 " should help to guide you."
}], "SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"{", 
   RowBox[{"4", ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], 
  "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{"4", ",", 
     RowBox[{"List", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", "\"\<g\>\""}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], ",", 
   RowBox[{"x_List", "/;", 
    RowBox[{
     RowBox[{"Length", "[", "x", "]"}], "==", "3"}]}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "y_", ",", "_"}], "}"}], "/;", 
    RowBox[{
     RowBox[{"y", "\[LeftDoubleBracket]", "0", "\[RightDoubleBracket]"}], "==",
      "List"}]}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], "/;", 
    RowBox[{"AtomQ", "[", "z", "]"}]}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "\"\<g\>\""}], "}"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "_", ",", "_"}], "}"}], "/;", 
    RowBox[{"EvenQ", "[", "x", "]"}]}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The Collatz function has a direct implementation based on its definition. \
There is no need to check explicitly that the argument is an integer since ",
 Cell[BoxData[
  ButtonBox["OddQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/OddQ"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["EvenQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EvenQ"]], "InlineFormula"],
 " handle that."
}], "SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"3", "n"}], "+", "1"}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  FractionBox["n", "2"]}]], "InputOnly",
 CellTags->"4.1 Solutions"],

Cell[TextData[{
 "Here we iterate the Collatz function fifteen times starting with an initial \
value of ",
 StyleBox["23", "OsF"],
 "."
}], "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{"Collatz", ",", "23", ",", "15"}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "23", ",", "70", ",", "35", ",", "106", ",", "53", ",", "160", ",", "80", 
   ",", "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", "4", 
   ",", "2", ",", "1"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell["Check for arguments that do not match the patterns above.", \
"SolutionText",
 CellChangeTimes->{{3.529261340001153*^9, 3.529261362543969*^9}},
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collatz", "[", "24.0", "]"}]], "Input",
 CellChangeTimes->{{3.529261365367992*^9, 3.529261373063712*^9}},
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"Collatz", "[", "24.`", "]"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here again is the Collatz function, but this time using a condition on the \
right-hand side of the definition.\
\>", "SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "Collatz", "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"3", "n"}], "+", "1"}], "/;", 
   RowBox[{
    RowBox[{"OddQ", "[", "n", "]"}], "&&", 
    RowBox[{"Positive", "[", "n", "]"}]}]}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", "n_", "]"}], ":=", 
  RowBox[{
   FractionBox["n", "2"], "/;", 
   RowBox[{
    RowBox[{"EvenQ", "[", "n", "]"}], "&&", 
    RowBox[{"Positive", "[", "n", "]"}]}]}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collatz", "[", "4.3", "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"Collatz", "[", "4.3`", "]"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collatz", "[", 
  RowBox[{"-", "3"}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"Collatz", "[", 
  RowBox[{"-", "3"}], "]"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{"Collatz", ",", "22", ",", "15"}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "22", ",", "11", ",", "34", ",", "17", ",", "52", ",", "26", ",", "13", ",",
    "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", "4", ",", 
   "2", ",", "1"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell["\<\
You could also put the conditions inside the pattern on the left-hand side if \
you prefer.\
\>", "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "Collatz", "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", 
   RowBox[{"n_", "/;", 
    RowBox[{
     RowBox[{"OddQ", "[", "n", "]"}], "&&", 
     RowBox[{"Positive", "[", "n", "]"}]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"3", "n"}], "+", "1"}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collatz", "[", 
   RowBox[{"n_", "/;", 
    RowBox[{
     RowBox[{"EvenQ", "[", "n", "]"}], "&&", 
     RowBox[{"Positive", "[", "n", "]"}]}]}], "]"}], ":=", 
  FractionBox["n", "2"]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{"Collatz", ",", "22", ",", "15"}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "22", ",", "11", ",", "34", ",", "17", ",", "52", ",", "26", ",", "13", ",",
    "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", "4", ",", 
   "2", ",", "1"}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Using alternatives, this gives the definition for real, integer, or rational \
arguments.\
\>", "SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"abs", "[", 
   RowBox[{"x_Real", "|", "x_Integer", "|", "x_Rational"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"x", "\[GreaterEqual]", "0"}], ",", "x", ",", 
    RowBox[{"-", "x"}]}], "]"}]}]], "InputOnly",
 CellTags->"4.1 Solutions"],

Cell["Here is the definition for complex arguments.", "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"abs", "[", "x_Complex", "]"}], ":=", 
  SqrtBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"Re", "[", "x", "]"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"Im", "[", "x", "]"}], "2"]}]]}]], "InputOnly",
 CellTags->"4.1 Solutions"],

Cell["\<\
Note that these rules are not invoked for symbolic arguments.\
\>", "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"abs", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "3"}], ",", 
     RowBox[{"3", "+", 
      RowBox[{"4", "I"}]}], ",", 
     FractionBox[
      RowBox[{"-", "4"}], "5"], ",", "a"}], "}"}]}], "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "5", ",", 
   FractionBox["4", "5"], ",", 
   RowBox[{"abs", "[", "a", "]"}]}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We first have to consider the base cases. Given a list with no elements, ",
 Cell[BoxData["swapTwo"]],
 " should return the empty list. And, given a list with one element, swapping \
should give that one element back."
}], "SolutionItem",
 CellTags->"4.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"swapTwo", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"swapTwo", "[", 
   RowBox[{"{", "x_", "}"}], "]"}], ":=", 
  RowBox[{"{", "x", "}"}]}]}], "Input",
 CellTags->"4.1 Solutions"],

Cell[TextData[{
 "Now, we use the triple-blank to indicate that ",
 Cell[BoxData["r"]],
 " could be a sequence of zero or more elements. "
}], "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"swapTwo", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"y", ",", "x", ",", "r"}], "}"}]}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"swapTwo", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "a", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "a", ",", "c", ",", "d"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Notice in this second definition for ",
 Cell[BoxData["swapTwo"]],
 " that the second clause covers both the situation where the argument is the \
empty list and when it contains only one element."
}], "SolutionText",
 CellTags->"4.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"swapTwo2", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"y", ",", "x", ",", "r"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"swapTwo2", "[", "x_", "]"}], ":=", "x"}]}], "Input",
 CellTags->"4.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"swapTwo2", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellTags->"4.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "a", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "a", ",", "c", ",", "d"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Transformation rules", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell["\<\
Here is a rule designed to switch the order of each pair of expressions in a \
list. It works fine on the first example, but fails on the second.\
\>", "ExerciseItem",
 CellTags->"4.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"e", ",", "f"}], "}"}]}], "}"}], "/.", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"y", ",", "x"}], "}"}]}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"b", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"f", ",", "e"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}]}], "}"}], "/.", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"y", ",", "x"}], "}"}]}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"c", ",", "d"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Explain what has gone wrong and rewrite this rule to correct the situation, \
that is, so that the second example returns ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", ",", "a"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "c"}], "}"}]}], "}"}], "ExLink"]]],
 "."
}], "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The following compound expression returns a value of ",
 StyleBox["14.", "OsF"],
 " Describe the evaluation sequence that was followed. Use the ",
 Cell[BoxData[
  ButtonBox["Trace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Trace"]]],
 " function to check your answer. "
}], "ExerciseItem",
 CellTags->"4.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"z", "=", "11"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"z", "+", "3"}], "/.", "\[InvisibleSpace]", 
  RowBox[{"z", "\[Rule]", "a"}]}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData["14"], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Then use the ",
 Cell[BoxData[
  ButtonBox["Hold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hold"]]],
 " function in the compound expression to obtain a value of ",
 StyleBox["12.", "OsF"]
}], "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create a function to compute the area of any triangle, given its three \
vertices. The area of a triangle is one-half the base times the altitude. For \
arbitrary points, the altitude requires a bit of computation that does not \
generalize. The magnitude of the cross product of two vectors gives the area \
of the parallelogram that they determine. The cross product is only defined \
for three-dimensional vectors, so to compute the area of a two-dimensional \
triangle using the cross product you will need to embed the edges (vectors) \
in three-dimensional space, say, in the plane ",
 Cell[BoxData[
  FormBox[
   RowBox[{"z", "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ". Try a second implementation using determinants instead of cross \
products."
}], "ExerciseItem",
 CellTags->{"i:40", "4.2 Exercises"}],

Cell[CellGroupData[{

Cell["\<\
Use pattern matching to extract all negative solutions of the following \
polynomial:\
\>", "ExerciseItem",
 CellTags->"4.2 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   SuperscriptBox["x", "9"], "+", 
   RowBox[{
    StyleBox["3.4", "OsF"], 
    SuperscriptBox["x", "6"]}], "-", 
   RowBox[{
    StyleBox["25", "OsF"], 
    SuperscriptBox["x", "5"]}], "-", 
   RowBox[{
    StyleBox["213", "OsF"], 
    SuperscriptBox["x", "4"]}], "-", 
   RowBox[{
    StyleBox["477", "OsF"], 
    SuperscriptBox["x", "3"]}], "+", 
   RowBox[{
    StyleBox["1012", "OsF"], 
    SuperscriptBox["x", "2"]}], "+", 
   RowBox[{
    StyleBox["111", "OsF"], "x"}], "-", 
   StyleBox["123", "OsF"]}], TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"4.2 Exercises"],

Cell["\<\
Then extract all real solutions, that is, those which are not complex.\
\>", "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Create a rewrite rule that uses a repeated replacement to \
\[OpenCurlyDoubleQuote]unnest\[CloseCurlyDoubleQuote] the nested lists within \
a list.\
\>", "ExerciseItem",
 CellTags->"4.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"unNest", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Alpha]", ",", "\[Alpha]", ",", "\[Alpha]"}], "}"}], ",", 
    RowBox[{"{", "\[Alpha]", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\[Beta]", ",", "\[Beta]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\[Beta]"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]", ",", "\[Alpha]"}], "}"}]}], "}"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[Alpha]", ",", "\[Alpha]", ",", "\[Alpha]", ",", "\[Alpha]", ",", 
   "\[Beta]", ",", "\[Beta]", ",", "\[Beta]", ",", "\[Beta]", ",", "\[Beta]", 
   ",", "\[Alpha]", ",", "\[Alpha]"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],

Cell["\<\
Define a function using pattern matching and repeated replacement to sum the \
elements of a list.\
\>", "ExerciseItem",
 CellTags->"4.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Using the built-in function ",
 Cell[BoxData[
  ButtonBox["ReplaceList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ReplaceList"]]],
 ", write a function ",
 StyleBox["cartesianProduct", "MR", "ExLink"],
 " that takes two lists as input and returns the Cartesian product of these \
lists."
}], "ExerciseItem",
 CellTags->{"i:41", "4.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cartesianProduct", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["x", "3"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["y", "1"], ",", 
     SubscriptBox["y", "2"]}], "}"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["y", "1"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["y", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["y", "1"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["y", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "3"], ",", 
     SubscriptBox["y", "1"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "3"], ",", 
     SubscriptBox["y", "2"]}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Write a function to count the total number of multiplications in any \
polynomial expression. For example, given a power, your function should \
return one less than the exponent.\
\>", "ExerciseItem",
 CellTags->{"Ex.MultiplyCount", "i:42", "4.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  SuperscriptBox["t", "5"], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData["4"], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyCount[a x y t]", "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData["3"], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{"a", " ", "x", " ", "y", " ", 
    SuperscriptBox["t", "4"]}], "+", 
   RowBox[{"w", " ", "t"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData["7"], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create six graphical objects, one each to represent the faces of a standard \
six-sided die. ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Dice", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " should display the face of the appropriate die, as below."
}], "ExerciseItem",
 CellTags->{"Ex.Dice", "i:43", "4.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Dice", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "6"}], "}"}]}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {555, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->{Automatic, 99}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->36,
    PlotRangePadding->{6, 5}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell["\<\
One way to approach this problem is to think of a die face as a grid of nine \
elements, some of which are turned on (white) and some turned off (blue \
above). Then create one set of rules for each die face. Once your rules are \
defined, you could use something like the following graphics code (a bit \
incomplete as written here) to create your images.\
\>", "ExerciseText",
 CellTags->"4.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dice", "[", "n_", "]"}], ":=", 
  RowBox[{"GraphicsGrid", "[", "\n", "  ", 
   RowBox[{"Map", "[", 
    RowBox[{"Graphics", ",", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}], "/.", 
      RowBox[{"rules", "[", 
       RowBox[{"[", "n", "]"}], "]"}]}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}]], "ExerciseInput", "ExerciseMR",
 Evaluatable->False,
 CellTags->"4.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The problem here is that the pattern is too general and has been matched by \
the entire expression, which has the form ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{"x_", ",", "y_"}], "}"}]]],
 ", where ",
 Cell[BoxData["x"]],
 " is matched by ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{"a", ",", "b"}], "}"}]]],
 " and ",
 Cell[BoxData["y"]],
 " is matched by ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{"c", ",", "d"}], "}"}]]],
 ". To fix this, use patterns to restrict the expressions that match."
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}]}], "}"}], "/.", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x_Symbol", ",", "y_Symbol"}], "}"}], "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"y", ",", "x"}], "}"}]}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"b", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "c"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"e", ",", "f"}], "}"}]}], "}"}], "/.", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x_Symbol", ",", "y_Symbol"}], "}"}], "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"y", ",", "x"}], "}"}]}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"b", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"f", ",", "e"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The evaluation sequence can be seen directly from the ",
 Cell[BoxData[
  ButtonBox["Trace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Trace"]], "InlineFormula"],
 " of this compound expression."
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"z", "=", "11"}], ";", "\[IndentingNewLine]", 
   RowBox[{"a", "=", "9"}], ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"z", "+", "3"}], "/.", 
    RowBox[{"z", "\[Rule]", "a"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",\

 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{
     RowBox[{"z", "=", "11"}], ";", 
     RowBox[{"a", "=", "9"}], ";", 
     RowBox[{
      RowBox[{"z", "+", "3"}], "/.", "\[VeryThinSpace]", 
      RowBox[{"z", "\[Rule]", "a"}]}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"z", "=", "11"}],
      HoldForm], ",", 
     TagBox["11",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"a", "=", "9"}],
      HoldForm], ",", 
     TagBox["9",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         TagBox["z",
          HoldForm], ",", 
         TagBox["11",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"11", "+", "3"}],
        HoldForm], ",", 
       TagBox["14",
        HoldForm]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         TagBox["z",
          HoldForm], ",", 
         TagBox["11",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox["a",
          HoldForm], ",", 
         TagBox["9",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"11", "\[Rule]", "9"}],
        HoldForm], ",", 
       TagBox[
        RowBox[{"11", "\[Rule]", "9"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"14", "/.", "\[VeryThinSpace]", 
       RowBox[{"11", "\[Rule]", "9"}]}],
      HoldForm], ",", 
     TagBox["14",
      HoldForm]}], "}"}], ",", 
   TagBox["14",
    HoldForm]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "First make sure that ",
 Cell[BoxData["a"]],
 " and ",
 Cell[BoxData["z"]],
 " have no values associated with them."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"a", ",", "z"}], "]"}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Hold", "[", 
   RowBox[{"z", "=", "11"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"z", "+", "3"}], "/.", "\[InvisibleSpace]", 
  RowBox[{"z", "\[Rule]", "a"}]}]}], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["12"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{"Clear", "[", "a", "]"}]], "InputOnly",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The cross product is only defined for three dimensions, so first we need to \
embed the two-dimensional vectors in ",
 StyleBox["3", "OsF"],
 "-space; in this case, in the plane ",
 Cell[BoxData[
  FormBox[
   RowBox[{"z", "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ". "
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["x", "1"], ",", 
    SubscriptBox["y", "1"]}], "}"}], "/.", "\[InvisibleSpace]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "0"}], "}"}]}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["x", "1"], ",", 
   SubscriptBox["y", "1"], ",", "0"}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell["\<\
We need to compute the cross product of two vectors that span the triangle.\
\>", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cross", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "2"], ",", 
       SubscriptBox["y", "2"]}], "}"}], "-", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       SubscriptBox["y", "1"]}], "}"}]}], "/.", "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "0"}], "}"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "3"], ",", 
       SubscriptBox["y", "3"]}], "}"}], "-", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       SubscriptBox["y", "1"]}], "}"}]}], "/.", "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "0"}], "}"}]}]}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["x", "2"]}], " ", 
     SubscriptBox["y", "1"]}], "+", 
    RowBox[{
     SubscriptBox["x", "3"], " ", 
     SubscriptBox["y", "1"]}], "+", 
    RowBox[{
     SubscriptBox["x", "1"], " ", 
     SubscriptBox["y", "2"]}], "-", 
    RowBox[{
     SubscriptBox["x", "3"], " ", 
     SubscriptBox["y", "2"]}], "-", 
    RowBox[{
     SubscriptBox["x", "1"], " ", 
     SubscriptBox["y", "3"]}], "+", 
    RowBox[{
     SubscriptBox["x", "2"], " ", 
     SubscriptBox["y", "3"]}]}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell["Here are the coordinates for a triangle.", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"b", "=", 
   RowBox[{"{", 
    RowBox[{"5", ",", "0"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}]}], ";"}]}], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell["And here is the computation for the cross product.", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cross", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"b", "-", "a"}], "/.", "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "0"}], "}"}]}]}], ",", 
   RowBox[{
    RowBox[{"c", "-", "a"}], "/.", "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "0"}], "}"}]}]}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "10"}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell["\<\
So the given area is then just half the magnitude of the cross product.\
\>", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{"Norm", "[", "%", "]"}], "2"]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["5"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "This is done more simply using determinants. Note the change here: each \
vector (edge of triangle) is embedded in the plane ",
 Cell[BoxData[
  FormBox[
   RowBox[{"z", "=", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 "."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleArea", "[", 
   RowBox[{"tri", ":", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Det", "[", 
    RowBox[{"tri", "/.", "\[InvisibleSpace]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "1"}], "}"}]}]}], "]"}]}]}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TriangleArea", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b", ",", "c"}], "}"}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["5"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}]], "InputOnly",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["First, get the solutions to this polynomial.", "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"soln", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "9"], "+", 
      RowBox[{"3.4", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"25", " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"213", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"477", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"1012", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"111", " ", "x"}], "-", "123"}], "\[Equal]", "0"}], ",", "x"}], 
   "]"}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "2.8096051508133706`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "1.8518573502068414`"}], "-", 
      RowBox[{"2.150822067543234`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "1.8518573502068414`"}], "+", 
      RowBox[{"2.150822067543234`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "0.3764533414983019`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0.3230726331960352`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"1.0610268999611594`", "\[VeryThinSpace]", "-", 
      RowBox[{"3.127091090937977`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"1.0610268999611594`", "\[VeryThinSpace]", "+", 
      RowBox[{"3.127091090937977`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "1.3053325124466664`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "3.139314247160334`"}], "}"}]}], "}"}]], "Output",\

 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "The pattern needs to match an expression consisting of a list with a rule \
inside where the value on the right-hand side of the rule should pass the ",
 Cell[BoxData[
  ButtonBox["Negative",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Negative"]], "InlineFormula"],
 " test."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{"soln", ",", 
   RowBox[{"{", 
    RowBox[{"x_", "\[Rule]", 
     RowBox[{"_", "?", "Negative"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "2.8096051508133706`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "0.3764533414983019`"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell["Here are two solutions for the noncomplex roots.", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{"soln", ",", 
   RowBox[{"{", 
    RowBox[{"_", "\[Rule]", "_Real"}], "}"}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "2.8096051508133706`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "0.3764533414983019`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0.3230726331960352`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "1.3053325124466664`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "3.139314247160334`"}], "}"}]}], "}"}]], "Output",\

 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DeleteCases", "[", 
  RowBox[{"soln", ",", 
   RowBox[{"{", 
    RowBox[{"_", "\[Rule]", "_Complex"}], "}"}]}], "]"}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "2.8096051508133706`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "0.3764533414983019`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0.3230726331960352`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "1.3053325124466664`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "3.139314247160334`"}], "}"}]}], "}"}]], "Output",\

 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["The transformation rule unnests lists within a list.", "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"unNest", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"#", "//.", "\[InvisibleSpace]", 
       RowBox[{
        RowBox[{"{", "x__", "}"}], "\[RuleDelayed]", "x"}]}], "&"}], ")"}], 
    ",", "lis"}], "]"}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"unNest", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "a", ",", "a"}], "}"}], ",", 
    RowBox[{"{", "a", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"b", ",", "b", ",", "b"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"b", ",", "b"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "a"}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "a", ",", "a", ",", "a", ",", "a", ",", "b", ",", "b", ",", "b", ",", "b", 
   ",", "b", ",", "a", ",", "a"}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Note the need to put ",
 Cell[BoxData["y"]],
 " in a list on the right-hand side of the rule. Also, an immediate rule is \
required here."
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sumList", "[", "lis_", "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"lis", "//.", "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y___"}], "}"}], "\[Rule]", 
     RowBox[{"x", "+", 
      RowBox[{"{", "y", "}"}]}]}]}], "]"}]}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumList", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "5", ",", "8", ",", "3", ",", "9", ",", "3"}], "}"}], 
  "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["29"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The triple blank is required both before and after the variables ",
 Cell[BoxData["x"]],
 " and ",
 Cell[BoxData["y"]],
 "."
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cartesianProduct", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"ReplaceList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis1", ",", "lis2"}], "}"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"___", ",", "x_", ",", "___"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"___", ",", "y_", ",", "___"}], "}"}]}], "}"}], 
     "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellChangeTimes->{{3.529264952914214*^9, 3.529264953901391*^9}},
 CellTags->"4.2 Solutions"],

Cell["We should also have a rule for the base case.", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cartesianProduct", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"x", ",", "y", ",", "z", ",", "a", ",", "b", ",", "c"}], 
  "]"}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cartesianProduct", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "z"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cartesianProduct", "[", 
  RowBox[{"{", "}"}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "For an expression of the form ",
 Cell[BoxData[
  RowBox[{"Power", "[", 
   RowBox[{
    StyleBox["a", "ExerciseTI"], ",", 
    StyleBox["b", "ExerciseTI"]}], "]"}]]],
 ", the number of multiplies is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", "-", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 "."
}], "SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "^", "4"}], "}"}], ",", 
   RowBox[{
    RowBox[{"Power", "[", 
     RowBox[{"_", ",", "exp_"}], "]"}], "\[RuleDelayed]", 
    RowBox[{"exp", "-", "1"}]}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", "3", "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "For an expression of the form ",
 Cell[BoxData[
  RowBox[{"Times", "[", 
   RowBox[{
    StyleBox["a", "ExerciseTI"], ",", 
    StyleBox["b", "ExerciseTI"], ",", 
    StyleBox["c", "ExerciseTI"], ",", "\[Ellipsis]"}], "]"}]]],
 ", the number of multiplications is given by one less then the number of \
arguments."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", " ", "b", " ", "c", " ", "d", " ", "e"}], "}"}], ",", 
   RowBox[{"fac_Times", "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"Length", "[", "fac", "]"}], "-", "1"}]}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", "4", "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "For a mix of terms of these two cases, we will need to total up the counts \
from the respective terms. Here is a function that puts this all together. \
Use ",
 Cell[BoxData[
  ButtonBox["Infinity",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Infinity"]], "InlineFormula"],
 " as a third argument to ",
 Cell[BoxData[
  ButtonBox["Cases",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Cases"]], "InlineFormula"],
 " to make sure the search goes all the way down the expression tree."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyCount", "[", 
   RowBox[{"expr_", "?", "PolynomialQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"_", ",", "exp_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"exp", "-", "1"}]}], ",", "Infinity"}], "]"}]}], "+", 
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{"fac_Times", "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"Length", "[", "fac", "]"}], "-", "1"}]}], ",", "Infinity"}], 
     "]"}]}]}]}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{"a", " ", 
   SuperscriptBox["b", "2"], "c", " ", 
   SuperscriptBox["d", "5"]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["8"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"poly", "=", 
  RowBox[{"Expand", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"x", "+", "y", "-", "z"}], ")"}], "3"], "]"}]}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["x", "3"], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["x", "2"], " ", "y"}], "+", 
  RowBox[{"3", " ", "x", " ", 
   SuperscriptBox["y", "2"]}], "+", 
  SuperscriptBox["y", "3"], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["x", "2"], " ", "z"}], "-", 
  RowBox[{"6", " ", "x", " ", "y", " ", "z"}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["y", "2"], " ", "z"}], "+", 
  RowBox[{"3", " ", "x", " ", 
   SuperscriptBox["z", "2"]}], "+", 
  RowBox[{"3", " ", "y", " ", 
   SuperscriptBox["z", "2"]}], "-", 
  SuperscriptBox["z", "3"]}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", "poly", "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData["28"], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First, we create a grid of the nine locations on the die.", \
"SolutionItem",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"lis", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", "lis", "]"}]}], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "2", "3"},
    {"4", "5", "6"},
    {"7", "8", "9"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell["\<\
Next, use graphics primitives to indicate if a location on the grid is \
colored (on) or not (off).\
\>", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"off", "=", 
   RowBox[{"{", 
    RowBox[{"Red", ",", 
     RowBox[{"Disk", "[", "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"on", "=", 
   RowBox[{"{", 
    RowBox[{"White", ",", 
     RowBox[{"Disk", "[", "]"}]}], "}"}]}], ";"}]}], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell["Here are the rules for a five.", "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{"Graphics", ",", "\[IndentingNewLine]", 
     RowBox[{"lis", "/.", "\[VeryThinSpace]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", "on"}], ",", 
        RowBox[{"2", "\[Rule]", "off"}], ",", 
        RowBox[{"3", "\[Rule]", "on"}], ",", 
        RowBox[{"4", "\[Rule]", "off"}], ",", 
        RowBox[{"5", "\[Rule]", "on"}], ",", 
        RowBox[{"6", "\[Rule]", "off"}], ",", 
        RowBox[{"7", "\[Rule]", "on"}], ",", 
        RowBox[{"8", "\[Rule]", "off"}], ",", 
        RowBox[{"9", "\[Rule]", "on"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "2", "}"}]}], "]"}], ",", 
   RowBox[{"Background", "\[Rule]", "Red"}], ",", 
   RowBox[{"Spacings", "\[Rule]", "10"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "50"}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 GraphicsBox[{{{
     {RGBColor[1, 0, 0], RectangleBox[{740, -740.}, {1110, -1110.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, -740.}, {740, -1110.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, -740.}, {370, -1110.}]}}, {
     {RGBColor[1, 0, 0], RectangleBox[{740, -370.}, {1110, -740.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, -370.}, {740, -740.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, -370.}, {370, -740.}]}}, {
     {RGBColor[1, 0, 0], RectangleBox[{740, 0}, {1110, -370.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, 0}, {740, -370.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {555, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {185, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {925, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {555, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
  ContentSelectable->True,
  ImageSize->50,
  PlotRangePadding->{6, 5}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "The five other rules are straightforward. Here then is a function that \
wraps up the code. Note the use of the ",
 Cell[BoxData[
  ButtonBox["Background",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Background"]], "InlineFormula"],
 " option to ",
 Cell[BoxData[
  ButtonBox["GraphicsGrid",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsGrid"]], "InlineFormula"],
 " to pick up the color from the value of ",
 Cell[BoxData["off"]],
 "."
}], "SolutionText",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dice", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", ",", 
      RowBox[{"off", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Darker", "@", "Blue"}], ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}], ",", 
      RowBox[{"on", "=", 
       RowBox[{"{", 
        RowBox[{"White", ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rules", "=", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "off"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "off"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]",
         "\[VeryThinSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "on"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "on"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}]}], "\[IndentingNewLine]", 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Graphics", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", 
        RowBox[{"First", "[", "off", "]"}]}], ",", 
       RowBox[{"Spacings", "\[Rule]", "10"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "40"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"4.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Dice", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellTags->"4.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], 
        {555, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}]}], "}"}]], "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The function ",
 StyleBox["FindSubsequence", "MR", "ExLink"],
 " defined in this section suffers from the limitation that the arguments ",
 StyleBox["digits", "MR", "ExLink"],
 " and ",
 StyleBox["subseq", "MR", "ExLink"],
 " must both be lists of numbers. Write another definition of ",
 StyleBox["FindSubsequence", "MR", "ExLink"],
 " that takes two integers as arguments. So, for example, the following \
should work:"
}], "ExerciseItem",
 CellTags->{"i:51", "4.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"n", "=", 
  RowBox[{"RandomInteger", "[", 
   SuperscriptBox["10", "200"], "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.3 Exercises"],

Cell[BoxData[\
"99886364225785890637248382678171952235146647070036321273192078968865572610676\
045767583093169497891617017225261830124007777401603464795137556513541607966794\
013354513861062656302896471480157720676043512"], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"4.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindSubsequence", "[", 
  RowBox[{"n", ",", "22"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"4.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"9", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"35", ",", "36"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"105", ",", "106"}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"4.3 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Plot the function ",
 Cell[BoxData[
  FormBox[
   RowBox[{"sin", "(", "x", ")"}], TraditionalForm]]],
 " over the interval [\[Dash]",
 StyleBox["2 \[Pi]", "OsF"],
 ", ",
 StyleBox["2 \[Pi]", "OsF"],
 "] and then reverse the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 "- and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 "-coordinates of each point by means of a transformation rule to display a \
reflection in the line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"y", "=", "x"}], TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->"4.3 Exercises"],

Cell[CellGroupData[{

Cell["Given a two-column array of data,", "ExerciseItem",
 CellTags->"4.3 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "2"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"data", ",", 
   RowBox[{"TableAlignments", "\[Rule]", "\"\<.\>\""}]}], 
  "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"4.3 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2.7570347287961265`", "8.36575458851324`"},
     {"7.991973621082931`", "4.867561954969501`"},
     {"1.909273087893741`", "5.598352620514106`"},
     {"7.760509623401411`", "2.294429686896155`"},
     {"3.8719183516097786`", "8.11462995641461`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{"."}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableAlignments -> "."]]]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"4.3 Exercises"]
}, Closed]],

Cell["\<\
create a new array that consists of three columns where the first two columns \
are identical to the original, but the third column consists of the norm of \
the two numbers from the first two columns.\
\>", "ExerciseText",
 CellTags->"4.3 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2.7570347287961265`", "8.36575458851324`", "8.808353440400667`"},
     {"7.991973621082931`", "4.867561954969501`", "9.357606624856162`"},
     {"1.909273087893741`", "5.598352620514106`", "5.914970480718602`"},
     {"7.760509623401411`", "2.294429686896155`", "8.092584086867205`"},
     {"3.8719183516097786`", "8.11462995641461`", "8.991049496642423`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{"."}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableAlignments -> "."]]]], "ExerciseOutput", \
"ExerciseMR",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellTags->"4.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Occasionally, when collecting data from an instrument, the collector fails \
or returns a bad value. In analyzing the data, the analyst has to make a \
decision about what to use to replace these bad values. One approach is to \
replace them with a column mean. Given an array of numbers such as the \
following, create a function to replace each ",
 Cell[BoxData[
  StyleBox["\"\<NAN\>\"", "ExLink"]]],
 " with the mean of the numbers that appear in that column."
}], "ExerciseItem",
 CellTags->{"i:52", "4.3 Exercises"}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"data", "=", 
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0.9034", "\"\<NAN\>\"", "0.7163", "0.8588"},
       {"0.3031", "0.5827", "0.2699", "0.8063"},
       {"0.0418", "0.8426", "\"\<NAN\>\"", "0.8634"},
       {"\"\<NAN\>\"", "0.8913", "0.0662", "0.8432"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}], ";"}], 
  TraditionalForm]], "Input", "ExerciseMR",
 CellTags->"4.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the function ",
 Cell[BoxData["FindSubsequence"]],
 " as given in the text. "
}], "SolutionItem",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"lis_List", ",", "subseq_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"lis", ",", "len", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"p", ",", "subseq"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"num_", "?", "IntegerQ"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"num", ",", 
         RowBox[{"num", "+", "len", "-", "1"}]}], "}"}]}]}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[TextData[{
 "This creates another rule associated with ",
 Cell[BoxData["FindSubsequence"]],
 " that simply takes each integer argument, converts it to a list of integer \
digits, and then passes that off to the rule above."
}], "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"n_Integer", ",", "subseq_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"nlist", "=", 
       RowBox[{"IntegerDigits", "[", "n", "]"}]}], ",", 
      RowBox[{"sublist", "=", 
       RowBox[{"IntegerDigits", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FindSubsequence", "[", 
     RowBox[{"nlist", ",", "sublist"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[TextData[{
 "Create the list of the first ",
 Cell[BoxData[
  StyleBox["100000", "OsF"]]],
 " digits of \[Pi]."
}], "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pi", "=", 
   RowBox[{"FromDigits", "[", 
    RowBox[{
     RowBox[{"RealDigits", "[", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Pi", ",", 
         SuperscriptBox["10", "5"]}], "]"}], "-", "3"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[TextData[{
 "The subsequence ",
 StyleBox["1415", "OsF"],
 " occurs seven times at the following locations in this digit expansion of \
\[Pi]."
}], "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindSubsequence", "[", 
  RowBox[{"pi", ",", "1415"}], "]"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6955", ",", "6958"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"29136", ",", "29139"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"45234", ",", "45237"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"79687", ",", "79690"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"85880", ",", "85883"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"88009", ",", "88012"}], "}"}]}], "}"}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the plot of the sine function.", "SolutionItem",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"splot", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "\[Pi]"}], ",", 
      RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtmnk0Vd/7x02VIXHvNVNKkaQ5DZJ9CGWmhIqPJopEpTQoZciUypQ5IpKh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->
   NCache[{{(-2) Pi, 2 Pi}, {-0.9999996658276197, 
     0.9999993650500513}}, {{-6.283185307179586, 
    6.283185307179586}, {-0.9999996658276197, 0.9999993650500513}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["\<\
This replacement rule interchanges each ordered pair of numbers. Note the \
need to modify the plot range here.\
\>", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"splot", "/.", "\[VeryThinSpace]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x_", "?", "NumberQ"}], ",", 
       RowBox[{"y_", "?", "NumberQ"}]}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"y", ",", "x"}], "}"}]}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]"}], ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}]}]}], "]"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtmnk01N//x22VNWbGTilFkva0SO6bUHZKqPgolTZRlBalLNlS2bJHRLKU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->NCache[{(-2) Pi, 2 Pi}, {-6.283185307179586, 6.283185307179586}],
  
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Although this particular example may have worked without the argument \
checking (",
 Cell[BoxData[
  RowBox[{"_", "?", "NumberQ"}]]],
 "), it is a good idea to include it so that pairs of arbitrary expressions \
are not pattern matched here. We only want to interchange pairs of numbers, \
not pairs of options or other expressions that might be present in the \
underlying expression representing the graphic."
}], "SolutionText",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
We are embedding the two-dimensional data into a three-dimensional array. The \
embedding function is written directly as a transformation rule.\
\>", "SolutionItem",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"8", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.43068517175137644`", ",", "0.7208114594728106`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.2582064229873684`", ",", "0.14308733845621457`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.41836997156538147`", ",", "0.1803684926431015`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.03880704049109429`", ",", "0.860367035923217`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7598722524921491`", ",", "0.5321750770039486`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.40432600053306045`", ",", "0.7694678180860364`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.5306041667754908`", ",", "0.795416508324432`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.34551608313021065`", ",", "0.03401489709543393`"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "/.", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], "]"}]}], "}"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.43068517175137644`", "0.7208114594728106`", "0.839677841361695`"},
     {"0.2582064229873684`", "0.14308733845621457`", "0.2952025462261718`"},
     {"0.41836997156538147`", "0.1803684926431015`", "0.45559436590673796`"},
     {"0.03880704049109429`", "0.860367035923217`", "0.8612417911916372`"},
     {"0.7598722524921491`", "0.5321750770039486`", "0.9276939973351401`"},
     {"0.40432600053306045`", "0.7694678180860364`", "0.8692296806812029`"},
     {"0.5306041667754908`", "0.795416508324432`", "0.9561528138924992`"},
     {"0.34551608313021065`", "0.03401489709543393`", "0.3471863720338913`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First, here is the data with which we will work.", "SolutionItem",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"array", "=", 
    TagBox[
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0.9034000000000001`", "\"\<NAN\>\"", "0.7163`", "0.8588`", 
         "0.1228`"},
        {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", 
         "0.8063`", "\"\<NAN\>\""},
        {"0.041800000000000004`", "0.8426`", "\"\<NAN\>\"", 
         "0.8634000000000001`", "0.9682000000000001`"},
        {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
         "0.8432000000000001`", "0.054700000000000006`"},
        {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
         "0.5589000000000001`", "0.8993`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
     Function[BoxForm`e$, 
      MatrixForm[BoxForm`e$]]]}], ";"}],
  NumberMarks->False]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell["Get only the numeric values from the second column.", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"col2", "=", 
   RowBox[{"array", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cases", "[", 
  RowBox[{"col2", ",", 
   RowBox[{"_", "?", "NumberQ"}]}], "]"}]}], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.5827`", ",", "0.8426`", ",", "0.8913000000000001`", ",", "0.6905`"}], 
  "}"}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["Compute the mean of the second column.", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mean", "[", 
  RowBox[{"Cases", "[", 
   RowBox[{"col2", ",", 
    RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData["0.7517750000000001`"], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["Replace the string with the column mean.", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"col2", "/.", 
   RowBox[{"\"\<NAN\>\"", "\[Rule]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Cases", "[", 
      RowBox[{"col2", ",", 
       RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0.7517750000000001`"},
      {"0.5827`"},
      {"0.8426`"},
      {"0.8913000000000001`"},
      {"0.6905`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["Turn it into a function.", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fixcolumn", "[", "col_", "]"}], ":=", 
  RowBox[{
   RowBox[{"array", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "col"}], "]"}], "]"}], "/.", 
   RowBox[{"\"\<NAN\>\"", "\[RuleDelayed]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"array", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "col"}], "]"}], "]"}], ",", 
       RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[TextData[{
 "Try this function out on column ",
 StyleBox["1", "OsF"],
 " of our matrix."
}], "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fixcolumn", "[", "2", "]"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.7517750000000001`", ",", "0.5827`", ",", "0.8426`", ",", 
   "0.8913000000000001`", ",", "0.6905`"}], "}"}]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["Map this function across all the columns. ", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{"fixcolumn", ",", 
    RowBox[{"Range", "[", 
     RowBox[{"Length", "[", 
      RowBox[{"First", "[", "array", "]"}], "]"}], "]"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9034000000000001`", "0.30310000000000004`", "0.041800000000000004`", 
      "0.9163`", "0.7937000000000001`"},
     {"0.7517750000000001`", "0.5827`", "0.8426`", "0.8913000000000001`", 
      "0.6905`"},
     {"0.7163`", "0.26990000000000003`", "0.490725`", "0.06620000000000001`", 
      "0.9105000000000001`"},
     {"0.8588`", "0.8063`", "0.8634000000000001`", "0.8432000000000001`", 
      "0.5589000000000001`"},
     {"0.1228`", "0.51125`", "0.9682000000000001`", "0.054700000000000006`", 
      "0.8993`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell["\<\
This operated on the columns, so the array is a list of the transformed \
column vectors. Transpose it back to put things right.\
\>", "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", "%", "]"}], "]"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9034000000000001`", "0.7517750000000001`", "0.7163`", "0.8588`", 
      "0.1228`"},
     {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", "0.8063`", 
      "0.51125`"},
     {"0.041800000000000004`", "0.8426`", "0.490725`", "0.8634000000000001`", 
      "0.9682000000000001`"},
     {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
      "0.8432000000000001`", "0.054700000000000006`"},
     {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
      "0.5589000000000001`", "0.8993`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Next, turn this into a reusable function, ",
 Cell[BoxData["FixArray"]],
 "."
}], "SolutionText",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "fixcolumn", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fixcolumn", "[", "col_", "]"}], ":=", 
      RowBox[{
       RowBox[{"mat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "col"}], "]"}], "]"}], "/.", 
       RowBox[{"\"\<NAN\>\"", "\[RuleDelayed]", 
        RowBox[{"Mean", "[", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"mat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "col"}], "]"}], "]"}], ",", 
           RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"fixcolumn", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "mat", "]"}], "]"}], "]"}]}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"4.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "array", "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"4.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9034000000000001`", "0.7517750000000001`", "0.7163`", "0.8588`", 
      "0.1228`"},
     {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", "0.8063`", 
      "0.51125`"},
     {"0.041800000000000004`", "0.8426`", "0.490725`", "0.8634000000000001`", 
      "0.9682000000000001`"},
     {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
      "0.8432000000000001`", "0.054700000000000006`"},
     {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
      "0.5589000000000001`", "0.8993`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["5", "ChapterN"],

Cell[CellGroupData[{

Cell["Functional programming", "ChapterTitle",
 CellTags->"c:1"],

Cell[CellGroupData[{

Cell["Functions for manipulating expressions", "ExerciseSubsection",
 CounterAssignments->{{"Section", 1}, {"ExerciseItem", 0}}],

Cell[TextData[{
 "Rewrite the definition of ",
 StyleBox["SquareMatrixQ", "MR", "ExLink"],
 " given in Section ",
 StyleBox["4.1", "OsF"],
 " to use ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]], "InlineFormula"],
 "."
}], "ExerciseItem",
 CellTags->{"i:24", "5.2 Exercises"}],

Cell[TextData[{
 "Given a set of points in the plane (or ",
 StyleBox["3", "OsF"],
 "-space), find the maximum distance between any pair of these points. This \
is often called the ",
 StyleBox["diameter",
  FontSlant->"Italic"],
 " of the pointset."
}], "ExerciseItem",
 CellTags->{"Ex.Pointset diameter", "i:139", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "An adjacency matrix can be thought of as representing a graph of vertices \
and edges where a value of ",
 StyleBox["1", "OsF"],
 " in position ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", 
    StyleBox["ij",
     FontSlant->"Italic"]], TraditionalForm]]],
 " indicates an edge between vertex ",
 StyleBox["i",
  FontSlant->"Italic"],
 " and vertex ",
 StyleBox["j",
  FontSlant->"Italic"],
 ", whereas ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", 
     StyleBox["ij",
      FontSlant->"Italic"]], "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 " indicates no such edge between vertices ",
 StyleBox["i",
  FontSlant->"Italic"],
 " and ",
 StyleBox["j",
  FontSlant->"Italic"],
 "."
}], "ExerciseItem",
 CellTags->{"i:25", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "1", "1"},
     {"0", "0", "1", "1", "0"},
     {"1", "1", "1", "0", "1"},
     {"0", "1", "1", "0", "0"},
     {"0", "0", "0", "1", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AdjacencyGraph", "[", 
  RowBox[{"mat", ",", 
   RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->{"i:26", "5.2 Exercises"}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5}, {
      SparseArray[
       Automatic, {5, 5}, 0, {
        1, {{0, 2, 4, 8, 10, 12}, {{4}, {5}, {3}, {4}, {1}, {2}, {3}, {5}, {
          2}, {3}, {4}, {5}}}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}}], 
       Null}, {ImagePadding -> 11, ImageSize -> 154, VertexLabels -> {"Name"},
        VertexLabelStyle -> {
         Directive["Menu", 8]}}]], Typeset`boxes, Typeset`boxes$s2d = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         TagBox[
          DiskBox[{1.890993028321949, 0.}, 0.021740250148725965`], 
          "DynamicName", BoxID -> "VertexID$1"], 
         InsetBox[
          FormBox[
           StyleBox["1", 
            Directive["Menu", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$1", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$1"], 
       TagBox[{
         TagBox[
          DiskBox[{0., 0.39910616146831024`}, 0.021740250148725965`], 
          "DynamicName", BoxID -> "VertexID$2"], 
         InsetBox[
          FormBox[
           StyleBox["2", 
            Directive["Menu", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$2", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$2"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.0122640756835612`, 0.7566971419135613}, 
           0.021740250148725965`], "DynamicName", BoxID -> "VertexID$3"], 
         InsetBox[
          FormBox[
           StyleBox["3", 
            Directive["Menu", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$3", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$3"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.0119968130988797`, 0.04145181838024142}, 
           0.021740250148725965`], "DynamicName", BoxID -> "VertexID$4"], 
         InsetBox[
          FormBox[
           StyleBox["4", 
            Directive["Menu", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$4", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$4"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.8933564685658377`, 0.7967794744346999}, 
           0.021740250148725965`], "DynamicName", BoxID -> "VertexID$5"], 
         InsetBox[
          FormBox[
           StyleBox["5", 
            Directive["Menu", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$5", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$5"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       Arrowheads[{{0.03450176403520888, 0.7}}], {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$2", Automatic, Center], {
          0.09369108906414242, 0.47429113261586625`}, {0.11783572437374745`, 
          0.4927300026696583}, {0.1428389400521915, 0.5099867274119627}, {
          0.16864290821066436`, 0.5260213951781177}, {0.19518794896555744`, 
          0.540796920698908}, {0.22241266846717642`, 0.5542791308720444}, {
          0.25025410089254574`, 0.5664368437983331}, {0.27864785407390114`, 
          0.577241940899735}, {0.6835534843473253, 0.7202783330778354}, {
          0.7124338886994827, 0.7297058241306209}, {0.7417341491016403, 
          0.7377339050632107}, {0.7713864993823409, 0.744344008385027}, {
          0.8013223590502973, 0.7495208461297203}, {0.8314724919085904, 
          0.7532524452134546}, {0.861767166185397, 0.7555301751264718}, {
          0.8921363158108899, 0.7563487678938905}, 
          DynamicLocation["VertexID$3", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$2", Automatic, Center], {
          0.12010187535552566`, 0.3987412161059748}, {0.15046437996216952`, 
          0.39791859110105526`}, {0.18075222304313004`, 0.3956371530917496}, {
          0.21089535432789347`, 0.39190217862909166`}, {0.24082405823800201`, 
          0.38672230602947655`}, {0.270469115126503, 0.38010951539580806`}, {
          0.299761961370398, 0.37207910090969865`}, {0.3286348479458291, 
          0.36264963545881107`}, {0.7334335731853806, 0.21958789822358366`}, {
          0.761819722358796, 0.20878119044592075`}, {0.7896534821316984, 
          0.19662223429041303`}, {0.8168704780817725, 0.18313915121046292`}, {
          0.8434077622492125, 0.16836312512413892`}, {0.8692039587238996, 
          0.15232833029144677`}, {0.8941994055967158, 0.13507185227548385`}, {
          0.918336292946685, 0.11663360217027885`}, 
          DynamicLocation["VertexID$4", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], {
          0.918572986619419, 0.6815121707660055}, {0.8944283513098139, 
          0.6630733007122134}, {0.8694251356313698, 0.6458165759699089}, {
          0.843621167472897, 0.6297819082037539}, {0.8170761267180039, 
          0.6150063826829638}, {0.789851407216385, 0.6015241725098274}, {
          0.7620099747910156, 0.5893664595835385}, {0.7336162216096602, 
          0.5785613624821367}, {0.328710591336236, 0.43552497030403636`}, {
          0.2998301869840787, 0.42609747925125097`}, {0.2705299265819211, 
          0.4180693983186611}, {0.24087757630122048`, 0.41145929499684486`}, {
          0.21094171663326416`, 0.4062824572521515}, {0.180791583774971, 
          0.40255085816841707`}, {0.1504969094981645, 0.40027312825539996`}, {
          0.12012775987267144`, 0.3994545354879814}, 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {{
         Arrowheads[0.03450176403520888], 
         ArrowBox[{
           DynamicLocation["VertexID$3", Automatic, Center], {
           0.9629773934604172, 0.7568940866175875}, {0.8975189771346856, 
           0.7659759985922409}, {0.8367952621533852, 0.7920511943126554}, {
           0.7851330913634169, 0.8332616966422352}, {0.7462136310802281, 
           0.8866710685188397}, {0.7228100711256769, 0.9484736475462708}, {
           0.7165900223501959, 1.014265716872435}, {0.727996691720945, 
           1.0793592901869684`}, {0.7562173017952238, 1.1391161522199071`}, {
           0.7992410048363168, 1.1892783528257416`}, {0.8540021649257387, 
           1.2262716054354927`}, {0.9165987985650504, 1.2474599713473302`}, {
           0.9825706088737706, 1.2513336824334085`}, {1.0472168021731965`, 
           1.2376167190347043`}, {1.1059310410687346`, 1.2072864776260737`}, {
           1.1545296670893141`, 1.1625041268403007`}, {1.1895498055173532`, 
           1.1064606143034412`}, {1.2084961110746273`, 1.0431492969998302`}, {
           1.2100185727036614`, 0.9770813962947504}, {1.1940087080395134`, 
           0.9129645527478024}, {1.161607293275195, 0.8553673851589464}, {
           1.1151230776324177`, 0.8083939555517321}, {1.0578682744039565`, 
           0.7753913359548223}, 
           DynamicLocation["VertexID$3", Automatic, Center]}]}}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], {
          0.8918949377433543, 0.04181676374257681}, {0.8615324331367102, 
          0.0426393887474964}, {0.8312445900557497, 0.04492082675680198}, {
          0.8011014587709863, 0.048655801219460004`}, {0.7711727548608778, 
          0.05383567381907506}, {0.7415276979723768, 0.060448464452743655`}, {
          0.7122348517284818, 0.06847887893885296}, {0.6833619651530507, 
          0.07790834438974059}, {0.27856323991349907`, 
          0.22097008162496812`}, {0.25017709074008376`, 
          0.23177678940263102`}, {0.22234333096718148`, 
          0.24393574555813868`}, {0.19512633501710733`, 
          0.25741882863808885`}, {0.16858905084966733`, 
          0.27219485472441285`}, {0.1427928543749802, 0.28822964955710506`}, {
          0.11779740750216397`, 0.3054861275730679}, {0.09366052015219478, 
          0.323924377678273}, 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}]}, {
        Arrowheads[0.03450176403520888], 
        ArrowBox[{
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}]}, {{
         Arrowheads[0.03450176403520888], 
         ArrowBox[{
           DynamicLocation["VertexID$5", Automatic, Center], {
           1.890564271104925, 0.7995409096434154}, {1.8477820316378133`, 
           0.8559525481318406}, {1.822531289881862, 0.922096278080675}, {
           1.8168374427630947`, 0.9926666194129808}, {1.8311572016353026`, 
           1.0620030274293462`}, {1.8643419588305814`, 1.124543932928551}, {
           1.913729919069261, 1.1752728433666104`}, {1.9753596057413951`, 
           1.2101207226631274`}, {2.044287616425623, 1.2262923742140666`}, {
           2.114985140035679, 1.2224906474780077`}, {2.1817814304057186`, 
           1.1990204842154433`}, {2.2393186646847214`, 1.1577644586883375`}, {
           2.2829817017189384`, 1.102031773774378}, {2.309268268908037, 
           1.0362928252264811`}, {2.3160698843351253`, 0.9658206250454733}, {
           2.3028409810180075`, 0.896267845893261}, {2.2706426675915155`, 
           0.8332134123991803}, {2.22205761531606, 0.781715007898057}, {
           2.160982898443181, 0.745903390653541}, {2.0923174044989414`, 
           0.7286510600236314}, {2.0215688877387503`, 0.7313418493135942}, {
           1.9544121845595626`, 0.7537599265922673}, {1.8962340270223859`, 
           0.7941071068698226}, 
           DynamicLocation["VertexID$5", Automatic, Center]}]}}}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{17.22069330901009, 
       213.2393066909899}, {-60.239306690989906`, 50.05054998314651}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImagePadding->11,
  ImageSize->154]], "ExerciseOutput", "ExerciseMR",
 CellTags->{"i:26", "5.2 Exercises"}]
}, Closed]],

Cell["\<\
Compute the total number of edges for each vertex in both the adjacency \
matrix and graph representations. For example, you should get the following \
edge counts for the five vertices represented in the above adjacency matrix. \
Note: self-loops count as two edges each.\
\>", "ExerciseText",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "4", ",", "7", ",", "5", ",", "5"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 Editable->False,
 Deletable->False,
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["ToGraph", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a list of pairs of elements and transforms it into a list of \
graph (directed) edges. For example:"
}], "ExerciseItem",
 CellTags->{"Ex.ToGraph", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lis", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{"9", ",", 
    RowBox[{"{", 
     RowBox[{"12", ",", "2"}], "}"}]}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToGraph", "[", "lis", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"4", "\[DirectedEdge]", "3"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "4"}], ",", 
   RowBox[{"0", "\[DirectedEdge]", "1"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "0"}], ",", 
   RowBox[{"5", "\[DirectedEdge]", "2"}], ",", 
   RowBox[{"4", "\[DirectedEdge]", "7"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "4"}], ",", 
   RowBox[{"7", "\[DirectedEdge]", "1"}], ",", 
   RowBox[{"7", "\[DirectedEdge]", "6"}], ",", 
   RowBox[{"7", "\[DirectedEdge]", "8"}], ",", 
   RowBox[{"4", "\[DirectedEdge]", "0"}], ",", 
   RowBox[{"3", "\[DirectedEdge]", "4"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell["\<\
Make sure that your function also works in the case where its argument is a \
single list of a pair of elements.\
\>", "ExerciseText",
 CellTags->"5.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToGraph", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "6"}], "}"}], "]"}]], "Input", "ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"3", "\[DirectedEdge]", "6"}]], "Output", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"RandomColor", "[", "]"}], "ExLink"]]],
 " that generates a random RGB color. Add a rule for ",
 Cell[BoxData[
  RowBox[{
   StyleBox["RandomColor", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " to create a list of ",
 StyleBox["n", "ExerciseTI"],
 " random colors."
}], "ExerciseItem",
 CellTags->{"i:30", "5.2 Exercises"}],

Cell[TextData[{
 "Create a graphic that consists of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " circles in the plane with random centers and random radii. Consider using ",
 Cell[BoxData[
  ButtonBox["Thread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Thread"]]],
 " or ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]]],
 " to thread ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"Circle", "[", "\[Ellipsis]", "]"}], "ExLink"]]],
 " across the lists of centers and radii. Use ",
 Cell[BoxData[
  StyleBox["RandomColor", "ExLink"]]],
 " from the previous exercise to give each circle a random color."
}], "ExerciseItem",
 CellTags->"5.2 Exercises"],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]]],
 " to mirror the behavior of ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]]],
 "."
}], "ExerciseItem",
 CellTags->"5.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "While matrices can easily be added using ",
 Cell[BoxData[
  ButtonBox["Plus",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Plus"]]],
 ", matrix multiplication is a bit more involved. The ",
 Cell[BoxData[
  ButtonBox["Dot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dot"]]],
 " function, written as a single period, is used."
}], "ExerciseItem",
 CellTags->{"i:31", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ".", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y"}], "}"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "+", 
    RowBox[{"2", " ", "y"}]}], ",", 
   RowBox[{
    RowBox[{"3", " ", "x"}], "+", 
    RowBox[{"4", " ", "y"}]}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Perform matrix multiplication on ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "ExLink"]]],
 " without using ",
 Cell[BoxData[
  ButtonBox["Dot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dot"]]],
 "."
}], "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{
   StyleBox["FactorInteger", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " returns a nested list of prime factors and their exponents for the number ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:32", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", "3628800", "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]]],
 " to reconstruct the original number from this nested list."
}], "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Repeat the above exercise but instead use ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]]],
 " to reconstruct the original number ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " from the factorization given by ",
 Cell[BoxData[
  RowBox[{
   StyleBox["FactorInteger", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 "."
}], "ExerciseItem",
 CellTags->"5.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["PrimeFactorForm", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that formats its argument ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " in prime factorization form. For example:"
}], "ExerciseItem",
 CellTags->"5.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeFactorForm", "[", "12", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.2 Exercises"],

Cell[BoxData[
 RowBox[{
  TemplateBox[{"2","2"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"3","1"},
   "Superscript"]}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "You will need to use ",
 Cell[BoxData[
  ButtonBox["Superscript",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Superscript"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["CenterDot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/CenterDot"]]],
 " to format the factored integer."
}], "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The Vandermonde matrix arises in Lagrange interpolation and in \
reconstructing statistical distributions from their moments. Construct the \
Vandermonde matrix of order ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", which should look like the following:"
}], "ExerciseItem",
 CellTags->{"i:155", "5.2 Exercises"}],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      SubscriptBox["x", "1"], 
      SubsuperscriptBox["x", "1", "2"], "\[CenterEllipsis]", 
      SubsuperscriptBox["x", "1", 
       RowBox[{"n", "-", "1"}]]},
     {"1", 
      SubscriptBox["x", "2"], 
      SubsuperscriptBox["x", "2", "2"], "\[CenterEllipsis]", 
      SubsuperscriptBox["x", "2", 
       RowBox[{"n", "-", "1"}]]},
     {"\[VerticalEllipsis]", "\[VerticalEllipsis]", "\[VerticalEllipsis]", 
      "\[DescendingEllipsis]", "\[VerticalEllipsis]"},
     {"1", 
      SubscriptBox["x", "n"], 
      SubsuperscriptBox["x", "n", "2"], "\[CenterEllipsis]", 
      SubsuperscriptBox["x", "n", 
       RowBox[{"n", "-", "1"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "ExerciseDisplayFormula",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]]],
 ", write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["div", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["vecs", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["vars", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that computes the divergence of an ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "-dimensional vector field, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["vecs", "ExerciseTI"], 
   StyleBox["=", "ExLink"], 
   RowBox[{
    StyleBox["{", "ExLink"], 
    RowBox[{
     StyleBox[
      SubscriptBox[
       StyleBox["e", "ExerciseTI"], "1"], "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox[
      SubscriptBox[
       StyleBox["e", "ExerciseTI"], "2"], "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox["\[Ellipsis]", "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox[
      SubscriptBox[
       StyleBox["e", "TI"], 
       StyleBox["n", "TI",
        FontSize->8]], "ExerciseTI"]}], 
    StyleBox["}", "ExLink"]}]}]]],
 " dependent upon ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " variables, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["vars", "ExerciseTI"], 
   StyleBox["=", "ExLink"], 
   RowBox[{
    StyleBox["{", "ExLink"], 
    RowBox[{
     StyleBox[
      SubscriptBox[
       StyleBox["v", "ExerciseTI"], "1"], "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox[
      SubscriptBox[
       StyleBox["v", "ExerciseTI"], "2"], "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox["\[Ellipsis]", "ExLink"], 
     StyleBox[",", "ExLink"], 
     StyleBox[
      SubscriptBox["v", "n"], "ExerciseTI"]}], 
    StyleBox["}", "ExLink"]}]}]]],
 ". The divergence is given by the sum of the pairwise partial derivatives."
}], "ExerciseItem",
 CellTags->{"i:33", "5.2 Exercises"}],

Cell[BoxData[
 FormBox[
  RowBox[{
   FractionBox[
    RowBox[{"\[PartialD]", 
     SubscriptBox["e", "1"]}], 
    RowBox[{"\[PartialD]", 
     SubscriptBox["v", "1"]}]], "+", 
   FractionBox[
    RowBox[{"\[PartialD]", 
     SubscriptBox["e", "2"]}], 
    RowBox[{"\[PartialD]", 
     SubscriptBox["v", "2"]}]], "+", "\[CenterEllipsis]", "+", 
   FractionBox[
    RowBox[{"\[PartialD]", 
     SubscriptBox["e", "n"]}], 
    RowBox[{"\[PartialD]", 
     SubscriptBox["v", 
      "n"]}]]}], $CellContext`DefaultTraditionalFormatType]], \
"ExerciseDisplayFormula",
 CellTags->"5.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "The example in the section on ",
 Cell[BoxData[
  ButtonBox["Select",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Select"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Pick",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Pick"]], "InlineFormula"],
 " found those Mersenne numbers ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox[
     StyleBox["2", "OsF"], "n"], "-", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " that are prime doing the computation for all exponents ",
 StyleBox["n",
  FontSlant->"Italic"],
 " from ",
 StyleBox["1", "OsF"],
 " to ",
 StyleBox["100", "OsF"],
 ". Modify that example to only use prime exponents (since a basic theorem in \
number theory states that a Mersenne number with composite exponent must be \
composite)."
}], "ExerciseItem",
 CellTags->{"i:34", "5.2 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "First, here is the definition given in ",
 "Section",
 " ",
 StyleBox["4.1", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SquareMatrixQ", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"Dimensions", "[", "mat", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"Dimensions", "[", "mat", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[TextData[{
 "For a matrix, ",
 Cell[BoxData[
  ButtonBox["Dimensions",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dimensions"]], "InlineFormula"],
 " returns a list of two integers. Applying ",
 Cell[BoxData[
  ButtonBox["Equal",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Equal"]], "InlineFormula"],
 " to the list will return ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/True"]], "InlineFormula"],
 " if the two dimensions are identical, that is, if the matrix is square."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SquareMatrixQ", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Equal", ",", 
    RowBox[{"Dimensions", "[", "mat", "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["First create a set of points with which to work.", "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"points", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell["The set of all two-element subsets is given by:", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pairs", "=", 
   RowBox[{"Subsets", "[", 
    RowBox[{"points", ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[TextData[{
 "Apply the distance function to ",
 Cell[BoxData["pairs"]],
 ". Note the need to apply ",
 Cell[BoxData[
  ButtonBox["EuclideanDistance",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EuclideanDistance"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Apply", "[", 
   RowBox[{"EuclideanDistance", ",", "pairs", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], ";"}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[TextData[{
 "The maximum distance (diameter) is given by ",
 Cell[BoxData[
  ButtonBox["Max",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Max"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Max", "[", "%", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["1.22117000322911`"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["Here is a function that puts it all together.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PointsetDiameter", "[", "pts_List", "]"}], ":=", 
  RowBox[{"Max", "[", 
   RowBox[{"Apply", "[", 
    RowBox[{"EuclideanDistance", ",", 
     RowBox[{"Subsets", "[", 
      RowBox[{"pts", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointsetDiameter", "[", "points", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["1.22117000322911`"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "In fact, this function works on ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "-dimensional point sets."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"points3D", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.9090708484037138`", ",", "0.9030872297117309`", ",", 
     "0.2994820490975909`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.6966147898103239`", ",", "0.3171252005495182`", ",", 
     "0.391343469646519`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.5447753361314276`", ",", "0.46573852495129153`", ",", 
     "0.8478477841067167`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.368606422128245`", ",", "0.9284984657513671`", ",", 
     "0.7719904892911909`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.5827947741478661`", ",", "0.9934366699357804`", ",", 
     "0.7400496509943613`"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointsetDiameter", "[", "points3D", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["0.7913652205128826`"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is a test matrix.", "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0"},
     {"0", "1", "1", "0", "0"},
     {"0", "1", "0", "0", "1"},
     {"1", "1", "0", "1", "0"},
     {"1", "0", "1", "1", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "A bit of thought should convince you that adding the matrix to its \
transpose and then totaling all the ",
 StyleBox["1", "OsF"],
 "s in each row will give the correct count."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Total", ",", 
   RowBox[{"mat", "+", 
    RowBox[{"Transpose", "[", "mat", "]"}]}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "5", ",", "4", ",", "5", ",", "6"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["Using graphs you can accomplish the same thing.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr", "=", 
  RowBox[{"AdjacencyGraph", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5}, {
      SparseArray[
       Automatic, {5, 5}, 0, {
        1, {{0, 1, 3, 5, 8, 12}, {{1}, {2}, {3}, {2}, {5}, {1}, {2}, {4}, {
          1}, {3}, {4}, {5}}}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}}], 
       Null}, {VertexLabels -> {"Name"}}]], Typeset`boxes, Typeset`boxes$s2d =
     GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         TagBox[
          DiskBox[{0., 0.4831424999520772}, 0.02204457837472809], 
          "DynamicName", BoxID -> "VertexID$1"], 
         InsetBox[
          FormBox["1", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$1", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$1"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.9302841607003374`, 0.9665281165201192}, 
           0.02204457837472809], "DynamicName", BoxID -> "VertexID$2"], 
         InsetBox[
          FormBox["2", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$2", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$2"], 
       TagBox[{
         TagBox[
          DiskBox[{1.930443591965695, 0.}, 0.02204457837472809], 
          "DynamicName", BoxID -> "VertexID$3"], 
         InsetBox[
          FormBox["3", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$3", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$3"], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.8565072722280613, 0.9306875892462292}, 
           0.02204457837472809], "DynamicName", BoxID -> "VertexID$4"], 
         InsetBox[
          FormBox["4", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$4", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$4"], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.8567031393436244, 0.0357274973976861}, 
           0.02204457837472809], "DynamicName", BoxID -> "VertexID$5"], 
         InsetBox[
          FormBox["5", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$5", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$5"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       Arrowheads[{{0.03426997801292018, 0.7}}], {{
         Arrowheads[0.03426997801292018], 
         ArrowBox[{
           DynamicLocation[
           "VertexID$1", Automatic, Center], {-0.00006126529326885843, 
           0.4792159063091721}, {-0.011179247498715489`, 
           0.40929464028481133`}, {-0.041454609524427116`, 
           0.34529467602714814`}, {-0.08845892270190053, 
           0.29234953920152396`}, {-0.14842190604930827`, 
           0.25470603247262635`}, {-0.21653384572454468`, 
           0.23538359358808034`}, {-0.28733138882585973`, 
           0.2359321020998722}, {-0.3551357664856567, 
           0.25630756138151006`}, {-0.41450829577689974`, 
           0.2948756276582959}, {-0.46068662399411325`, 
           0.3485427029823096}, {-0.4899667235517312, 
           0.41300407700323816`}, {-0.49999999716057963`, 
           0.48308921374035274`}, {-0.4899816620652955, 
           0.5531764874260132}, {-0.4607153027824041, 
           0.6176441008849801}, {-0.4145484144746365, 
           0.6713210176625687}, {-0.355184107116597, 
           0.7099017380118607}, {-0.2873840739211254, 
           0.7302916489842759}, {-0.21658664933976438`, 
           0.7308552476150075}, {-0.14847059273346103`, 
           0.7115473268782493}, {-0.08849958722870135, 
           0.67391660180527}, {-0.041483990135929405`, 
           0.6209814849093928}, {-0.01119498753542783, 
           0.5569879751428789}, {-0.0000621022250732739, 
           0.48706908044740677`}, 
           DynamicLocation["VertexID$1", Automatic, Center]}]}}, {{
         Arrowheads[0.03426997801292018], 
         ArrowBox[{
           DynamicLocation["VertexID$2", Automatic, Center], {
           1.9275043672899121`, 0.9693020378722879}, {1.8849753792465487`, 
           1.0259048482864142`}, {1.8600213294566894`, 1.0921610809732738`}, {
           1.8546438167733386`, 1.1627562318556854`}, {1.8692741789276321`, 
           1.2320277662259032`}, {1.9027388943327466`, 1.2944193184876058`}, {
           1.95235371187373, 1.3449263759265913`}, {2.014138958402603, 
           1.379497697598411}, {2.0831387538267077`, 1.3953602699686736`}, {
           2.1538185291064904`, 1.3912417341645955`}, {2.22050896169423, 
           1.367472443640262}, {2.2778607197380603`, 1.325958966069092}, {
           2.321273539389627, 1.2700311549133654`}, {2.347265218330989, 
           1.204175057271771}, {2.3537509280395312`, 1.1336730818359964`}, {
           2.3402104407677387`, 1.064180289582321}, {2.3077298577304677`, 
           1.0012707935079683`}, {2.2589144914240773`, 0.9499906513168334}, {
           2.197679889907127, 0.9144531141507559}, {2.1289377652741512`, 
           0.897508697025504}, {2.0582020184341068`, 0.9005165350781931}, {
           1.9911464614909895`, 0.9232353654578238}, {1.9331497134262945`, 
           0.9638428793523028}, 
           DynamicLocation["VertexID$2", Automatic, Center]}]}}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$2", Automatic, Center], {
          1.9660286696762026`, 0.8644549505300702}, {1.9744450429473601`, 
          0.8384309623632364}, {1.9816005057461858`, 0.8120324273417325}, {
          1.987478508789082, 0.7853204004741461}, {1.992065457324447, 
          0.7583566618186691}, {1.995350742574862, 0.7312035735970625}, {
          1.997326766273264, 0.7039239359621835}, {1.9979889582363535`, 
          0.6765808417526582}, {1.9980527307424965`, 0.2899695951446108}, {
          1.9973995594407414`, 0.2626262839625773}, {1.9954325355405256`, 
          0.23534599591199162`}, {1.9921562084102522`, 
          0.20819182533577282`}, {1.9875781555984826`, 0.1812265748900677}, {
          1.9817089653084454`, 0.1545126102931329}, {1.9745622119094486`, 
          0.1281117160847756}, {1.9661544245418316`, 0.1020849527299538}, 
          DynamicLocation["VertexID$3", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], {
          1.8946990829898307`, 0.10207316599004918`}, {1.8862827097186727`, 
          0.12809715415688278`}, {1.879127246919847, 0.15449568917838677`}, {
          1.8732492438769508`, 0.18120771604597316`}, {1.8686622953415863`, 
          0.20817145470145018`}, {1.865377010091171, 0.23532454292305685`}, {
          1.8634009863927687`, 0.26260418055793583`}, {1.8627387944296794`, 
          0.289947274767461}, {1.8626750219235364`, 0.6765585213755084}, {
          1.8633281932252914`, 0.7039018325575419}, {1.865295217125507, 
          0.7311821206081277}, {1.8685715442557806`, 0.7583362911843464}, {
          1.8731495970675502`, 0.7853015416300516}, {1.8790187873575874`, 
          0.8120155062269864}, {1.8861655407565843`, 0.8384164004353437}, {
          1.894573328124201, 0.8644431637901654}, 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], {
          1.8157207258949801`, -0.035917440443947846`}, {
          1.786497529131182, -0.04430061031388988}, {
          1.7569050814549554`, -0.05126909699994653}, {
          1.7270118248137618`, -0.05680678366025094}, {
          1.696886896871471, -0.06090086263307759}, {
          1.666599971105521, -0.06354186505863402}, {
          1.6362210956648429`, -0.06472368277881069}, {
          1.605820531361236, -0.06444358246423909}, {
          1.1763243503124077`, -0.050152583505164716`}, {
          1.1459724081200653`, -0.04841121297691153}, {
          1.1157392865590836`, -0.04521259970818581}, {
          1.0856949093390564`, -0.04056414150952625}, {
          1.0559087636382574`, -0.03447658941901166}, {
          1.0264497393924377`, -0.026964022837065782`}, {
          0.9973859699649398, -0.018043816963365655`}, {
          0.9687846745666229, -0.0077366026111659325`}, 
          DynamicLocation["VertexID$5", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {{
         Arrowheads[0.03426997801292018], 
         ArrowBox[{
           DynamicLocation["VertexID$4", Automatic, Center], {
           0.8229832506813769, 0.9265591931250614}, {0.7551796005807777, 
           0.9275178093116088}, {0.6901518729555849, 0.9467440557435396}, {
           0.6327282593095476, 0.982810418296315}, {0.5871723593968875, 
           1.0330390345932554`}, {0.5568666166296167, 1.093700520457695}, {
           0.5440611777541677, 1.1602908699624448`}, {0.5497068235134354, 
           1.2278658697472653`}, {0.5733843748912745, 1.2914081979443606`}, {
           0.6133358163984928, 1.3461999512787166`}, {0.6665948255524796, 
           1.3881729408778996`}, {0.72920701697201, 1.4142107479591746`}, {
           0.7965235483603742, 1.4223801123039057`}, {0.8635462886620865, 
           1.4120744733423065`}, {0.9252989202800155, 1.3840590061818618`}, {
           0.9771964216825717, 1.3404138087355306`}, {1.015385496983701, 
           1.2843794582030021`}, {1.0370306762133052`, 1.2201164040577477`}, {
           1.0405248438489745`, 1.1523960621766596`}, {1.025608564245218, 
           1.0862465458160682`}, {0.9933893442622713, 1.0265793372702676`}, {
           0.9462594028790243, 0.9778246191686387}, {0.8877180532480196, 
           0.9436023414049063}, 
           DynamicLocation["VertexID$4", Automatic, Center]}]}}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$5", Automatic, Center], {
          0.9714260054143398, 0.07164493784163395}, {1.000649202178138, 
          0.08002810771157598}, {1.0302416498543645`, 0.08699659439763263}, {
          1.0601349064955579`, 0.09253428105793704}, {1.090259834437849, 
          0.0966283600307637}, {1.1205467602037988`, 0.09926936245632012}, {
          1.150925635644477, 0.10045118017649679`}, {1.181326199948084, 
          0.1001710798619252}, {1.6108223809969122`, 0.08588008090285082}, {
          1.6411743231892546`, 0.08413871037459764}, {1.6714074447502363`, 
          0.08094009710587191}, {1.7014518219702635`, 0.07629163890721236}, {
          1.7312379676710625`, 0.07020408681669776}, {1.7606969919168822`, 
          0.06269152023475189}, {1.7897607613443804`, 0.05377131436105176}, {
          1.818362056742697, 0.043464100008852036`}, 
          DynamicLocation["VertexID$3", Automatic, Center]}]}, {
        Arrowheads[0.03426997801292018], 
        ArrowBox[{
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}]}, {{
         Arrowheads[0.03426997801292018], 
         ArrowBox[{
           DynamicLocation["VertexID$5", Automatic, Center], {
           0.8879255343816975, 0.022812142130564983`}, {
           0.946469865849269, -0.011402695516907896`}, {
           0.9936048802321094, -0.060150867599122804`}, {
           1.025830988697424, -0.11981301468929705`}, {
           1.0407555298492992`, -0.18595945778062117`}, {
           1.0372704153963972`, -0.2536790844739069}, {
           1.0156344013352965`, -0.3179439796949812}, {
           0.9774538763387451, -0.37398272854981846`}, {
           0.9255635937351906, -0.41763467505339436`}, {
           0.8638162022594993, -0.44565883441947585`}, {
           0.7967962020861572, -0.45597452339273525`}, {
           0.7294795637808148, -0.44781584277050823`}, {
           0.66686428211995, -0.421788542396509}, {
           0.6135992946997808, -0.3798250466251003}, {
           0.5736393166635031, -0.3250409794379336}, {
           0.549951218706406, -0.26150384165692586`}, {
           0.5442937486334115, -0.19393101505775964`}, {
           0.5570869512742195, -0.12733951538686294`}, {
           0.5873809818121121, -0.06667349873835504}, {
           0.6329266280137025, -0.01643717747268772}, {0.6903423053623319, 
           0.019639599778417782`}, {0.7553651263653904, 
           0.038878274655654715`}, {0.82316740313016, 0.039850451461266506`}, 
           
           DynamicLocation["VertexID$5", Automatic, Center]}]}}}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{0.7606933090100947, 
       228.2393066909899}, {-82.2393066909899, 70.2393066909899}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImageSize->154]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VertexDegree", "[", "gr", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "5", ",", "4", ",", "5", ",", "6"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Applying ",
 Cell[BoxData[
  ButtonBox["DirectedEdge",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DirectedEdge"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 " will do the trick."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToGraph", "[", 
   RowBox[{"lis", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"DirectedEdge", ",", "lis", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"lis", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ToGraph", "[", "lis", "]"}]}], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"3", "\[DirectedEdge]", "8"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "9"}], ",", 
   RowBox[{"9", "\[DirectedEdge]", "8"}], ",", 
   RowBox[{"2", "\[DirectedEdge]", "7"}], ",", 
   RowBox[{"0", "\[DirectedEdge]", "7"}], ",", 
   RowBox[{"1", "\[DirectedEdge]", "0"}], ",", 
   RowBox[{"2", "\[DirectedEdge]", "5"}], ",", 
   RowBox[{"1", "\[DirectedEdge]", "0"}], ",", 
   RowBox[{"8", "\[DirectedEdge]", "6"}], ",", 
   RowBox[{"2", "\[DirectedEdge]", "6"}], ",", 
   RowBox[{"7", "\[DirectedEdge]", "7"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "0"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["\<\
This rule fails for the case when the argument is a single flat list of a \
pair of elements.\
\>", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToGraph", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "6"}], "}"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"ToGraph", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "6"}], "}"}], "]"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["A second rule is needed for this case.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToGraph", "[", 
   RowBox[{"lis", ":", 
    RowBox[{"{", 
     RowBox[{"_", ",", "_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"DirectedEdge", ",", "lis"}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToGraph", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "6"}], "}"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"3", "\[DirectedEdge]", "6"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["RGBColor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RGBColor"]], "InlineFormula"],
 " takes a sequence of three values between ",
 StyleBox["0", "OsF"],
 " and ",
 StyleBox["1", "OsF"],
 ". So you only need to apply ",
 Cell[BoxData[
  ButtonBox["RGBColor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RGBColor"]], "InlineFormula"],
 " to this list."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomColor", "[", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"RGBColor", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "3", "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[TextData[{
 "A second rule uses pattern matching to make sure the argument, ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", to ",
 Cell[BoxData["RandomColor"]],
 " is a positive integer; then create a list of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " triples of random reals before applying ",
 Cell[BoxData[
  ButtonBox["RGBColor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RGBColor"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomColor", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"RGBColor", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "3"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["First, create the random centers and radii.", "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"centers", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "2"}], "}"}]}], "]"}]}]}], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5401772263308535`"}], ",", 
     RowBox[{"-", "0.9589609898705462`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7433305400538921`", ",", "0.43258138938567825`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5190671496072587`"}], ",", "0.5318159670134186`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.16085350060917092`", ",", "0.5629112081750565`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.6679609674489155`", ",", 
     RowBox[{"-", "0.8999625363973736`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5852356657920059`"}], ",", 
     RowBox[{"-", "0.9191249210431791`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5035569932510717`", ",", 
     RowBox[{"-", "0.9977635124960154`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.925991366063228`"}], ",", "0.8331651480404632`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"0.5017193599627885`", ",", 
     RowBox[{"-", "0.19757578349884275`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.07271443098348485`"}], ",", "0.30125793519744715`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2906100759717236`", ",", 
     RowBox[{"-", "0.8681382886401803`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.021677092373261875`", ",", 
     RowBox[{"-", "0.9405019047007093`"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"radii", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "n", "}"}]}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.2290856026939989`", ",", "0.05039678899218303`", ",", 
   "0.046396357891907325`", ",", "0.020312940520235134`", ",", 
   "0.4146789012622434`", ",", "0.6444068731506605`", ",", 
   "0.08355091785689961`", ",", "0.4296817630179026`", ",", 
   "0.8188742590585825`", ",", "0.2971016199024128`", ",", 
   "0.9147014733857968`", ",", "0.41796413358522244`"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]], "InlineFormula"],
 " is perfect for the task of grabbing one center, one radii, and wrapping ",
 Cell[BoxData[
  ButtonBox["Circle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Circle"]], "InlineFormula"],
 " around them."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"circles", "=", 
    RowBox[{"MapThread", "[", 
     RowBox[{"Circle", ",", 
      RowBox[{"{", 
       RowBox[{"centers", ",", "radii"}], "}"}]}], "]"}]}], ")"}], "//", 
  "Short"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Circle", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"\[LeftSkeleton]", "19", "\[RightSkeleton]"}]}], ",", 
        RowBox[{"-", 
         RowBox[{"\[LeftSkeleton]", "19", "\[RightSkeleton]"}]}]}], "}"}], 
      ",", 
      RowBox[{"\[LeftSkeleton]", "19", "\[RightSkeleton]"}]}], "]"}], ",", 
    RowBox[{"\[LeftSkeleton]", "10", "\[RightSkeleton]"}], ",", 
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], "}"}],
  Short]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "circles", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   CircleBox[{-0.5401772263308535, -0.9589609898705462}, 0.2290856026939989], 
   CircleBox[{0.7433305400538921, 0.43258138938567825`}, 0.05039678899218303],
    CircleBox[{-0.5190671496072587, 0.5318159670134186}, 
    0.046396357891907325`], 
   CircleBox[{0.16085350060917092`, 0.5629112081750565}, 
    0.020312940520235134`], 
   CircleBox[{0.6679609674489155, -0.8999625363973736}, 0.4146789012622434], 
   CircleBox[{-0.5852356657920059, -0.9191249210431791}, 0.6444068731506605], 
   CircleBox[{0.5035569932510717, -0.9977635124960154}, 0.08355091785689961], 
   CircleBox[{-0.925991366063228, 0.8331651480404632}, 0.4296817630179026], 
   CircleBox[{0.5017193599627885, -0.19757578349884275`}, 0.8188742590585825],
    CircleBox[{-0.07271443098348485, 0.30125793519744715`}, 
    0.2971016199024128], 
   CircleBox[{0.2906100759717236, -0.8681382886401803}, 0.9147014733857968], 
   CircleBox[{0.021677092373261875`, -0.9405019047007093}, 
    0.41796413358522244`]}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "And here is a rule to transform each circle into a scoped list that \
includes ",
 Cell[BoxData[
  ButtonBox["Thick",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Thick"]], "InlineFormula"],
 " and ",
 Cell[BoxData["RandomColor"]],
 ". Note the need for the delayed rule (",
 "\[RuleDelayed]",
 ")."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"circles", "/.", 
   RowBox[{
    RowBox[{"Circle", "[", "x__", "]"}], "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", 
      RowBox[{"RandomColor", "[", "]"}], ",", 
      RowBox[{"Circle", "[", "x", "]"}]}], "}"}]}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[
    0.9441469877176334, 0.0011376347264580033`, 0.14370427077839532`], 
    Thickness[Large], 
    CircleBox[{-0.5401772263308535, -0.9589609898705462}, 
     0.2290856026939989]}, 
   {RGBColor[0.09402526393590649, 0.4005893299900074, 0.498847767119045], 
    Thickness[Large], 
    CircleBox[{0.7433305400538921, 0.43258138938567825`}, 
     0.05039678899218303]}, 
   {RGBColor[0.7096316534160876, 0.5289011730850237, 0.9786712904385295], 
    Thickness[Large], 
    CircleBox[{-0.5190671496072587, 0.5318159670134186}, 
     0.046396357891907325`]}, 
   {RGBColor[0.7743497910677402, 0.8110933615265508, 0.4037568108871308], 
    Thickness[Large], 
    CircleBox[{0.16085350060917092`, 0.5629112081750565}, 
     0.020312940520235134`]}, 
   {RGBColor[0.4592204075488653, 0.8435991466997634, 0.5757543667567122], 
    Thickness[Large], 
    CircleBox[{0.6679609674489155, -0.8999625363973736}, 0.4146789012622434]}, 
   {RGBColor[0.11994941885737909`, 0.6459600031312744, 0.644412814333748], 
    Thickness[Large], 
    CircleBox[{-0.5852356657920059, -0.9191249210431791}, 
     0.6444068731506605]}, 
   {RGBColor[0.5125685983563879, 0.4278022176204872, 0.11137557463881986`], 
    Thickness[Large], 
    CircleBox[{0.5035569932510717, -0.9977635124960154}, 
     0.08355091785689961]}, 
   {RGBColor[0.7575577018119317, 0.4747025073429034, 0.17983698506060541`], 
    Thickness[Large], 
    CircleBox[{-0.925991366063228, 0.8331651480404632}, 
     0.4296817630179026]}, 
   {RGBColor[
    0.42233178557328555`, 0.11771718482898463`, 0.28512531366199667`], 
    Thickness[Large], 
    CircleBox[{0.5017193599627885, -0.19757578349884275`}, 
     0.8188742590585825]}, 
   {RGBColor[0.25637064326677894`, 0.8314241546921866, 0.8448601722275888], 
    Thickness[Large], 
    CircleBox[{-0.07271443098348485, 0.30125793519744715`}, 
     0.2971016199024128]}, 
   {RGBColor[0.8605718564036788, 0.6407543296612501, 0.37897448379757015`], 
    Thickness[Large], 
    CircleBox[{0.2906100759717236, -0.8681382886401803}, 0.9147014733857968]}, 
   {RGBColor[0.5237343463853785, 0.012852144025822243`, 0.7526155660737215], 
    Thickness[Large], 
    CircleBox[{0.021677092373261875`, -0.9405019047007093}, 
     0.41796413358522244`]}}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]], "InlineFormula"],
 " example from the text."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Inner", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", "g"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"a", ",", "d"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"b", ",", "e"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"c", ",", "f"}], "]"}]}], "]"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]], "InlineFormula"],
 ", we zip together the two lists and wrap ",
 Cell[BoxData["f"]],
 " around each pair. Then apply ",
 Cell[BoxData["g"]],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapThread", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "e", ",", "f"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"a", ",", "d"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"b", ",", "e"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"c", ",", "f"}], "]"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"g", ",", "%"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"a", ",", "d"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"b", ",", "e"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"c", ",", "f"}], "]"}]}], "]"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This can be done either in two steps, or by using the ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]], "InlineFormula"],
 " function."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "]"}], " ", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y"}], "}"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"3", " ", "x"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"2", " ", "y"}], ",", 
     RowBox[{"4", " ", "y"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Total", "[", "%", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "+", 
    RowBox[{"2", " ", "y"}]}], ",", 
   RowBox[{
    RowBox[{"3", " ", "x"}], "+", 
    RowBox[{"4", " ", "y"}]}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Inner", "[", 
  RowBox[{"Times", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], ",", "Plus"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "+", 
    RowBox[{"2", " ", "y"}]}], ",", 
   RowBox[{
    RowBox[{"3", " ", "x"}], "+", 
    RowBox[{"4", " ", "y"}]}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "To get down to the level of the nested lists, you have to use a second \
argument to ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"facs", "=", 
  RowBox[{"FactorInteger", "[", "3628800", "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Power", ",", "facs", ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"256", ",", "81", ",", "25", ",", "7"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "One more use of ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]], "InlineFormula"],
 " is needed to multiply these terms."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Times", ",", "%"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["3628800"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["Here is a function that puts this all together.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpandFactors", "[", "lis_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Times", ",", 
    RowBox[{"Apply", "[", 
     RowBox[{"Power", ",", "lis", ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", "295232799039604140847618609643520000000", 
  "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "32"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"19", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"23", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"29", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"31", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandFactors", "[", "%", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["295232799039604140847618609643520000000"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here is a factorization we can use to work through this problem.\
\>", "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"facs", "=", 
  RowBox[{"FactorInteger", "[", "3628800", "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Another approach uses ",
 Cell[BoxData[
  ButtonBox["Transpose",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Transpose"]], "InlineFormula"],
 " to separate the bases from their exponents, then uses ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]], "InlineFormula"],
 " to put things back together."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"base", ",", "exponents"}], "}"}], "=", 
  RowBox[{"Transpose", "[", "facs", "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "4", ",", "2", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Inner", "[", 
  RowBox[{"Power", ",", "base", ",", "exponents", ",", "Times"}], 
  "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["3628800"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Since ",
 Cell[BoxData[
  ButtonBox["Tranpose",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Tranpose"]], "InlineFormula"],
 " returns a list of two lists in this example, we need to strip the outer \
list. This is done by applying ",
 Cell[BoxData[
  ButtonBox["Sequence",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Sequence"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpandFactors2", "[", "lis_", "]"}], ":=", 
  RowBox[{"Inner", "[", 
   RowBox[{"Power", ",", 
    RowBox[{"Sequence", "@@", 
     RowBox[{"Transpose", "[", "lis", "]"}]}], ",", "Times"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExpandFactors2", "[", "facs", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["3628800"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First, here is the prime factorization of a test integer:", \
"SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lis", "=", 
  RowBox[{"FactorInteger", "[", 
   RowBox[{"10", "!"}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Apply ",
 Cell[BoxData[
  ButtonBox["Superscript",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Superscript"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 " to each of the sublists:"
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Superscript", ",", "lis", ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TemplateBox[{"2","8"},
    "Superscript"], ",", 
   TemplateBox[{"3","4"},
    "Superscript"], ",", 
   TemplateBox[{"5","2"},
    "Superscript"], ",", 
   TemplateBox[{"7","1"},
    "Superscript"]}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Finally, apply ",
 Cell[BoxData[
  ButtonBox["CenterDot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/CenterDot"]], "InlineFormula"],
 " to this list."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"CenterDot", ",", "%"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  TemplateBox[{"2","8"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"3","4"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"5","2"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"7","1"},
   "Superscript"]}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Put it all together (using shorthand notation for ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]], "InlineFormula"],
 ") and ",
 Cell[BoxData[
  ButtonBox["Apply",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Apply"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PrimeFactorForm", "[", "p_", "]"}], ":=", 
  RowBox[{"CenterDot", "@@", 
   RowBox[{"(", 
    RowBox[{"Superscript", "@@@", 
     RowBox[{"FactorInteger", "[", "p", "]"}]}], ")"}]}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeFactorForm", "[", 
  RowBox[{"20", "!"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  TemplateBox[{"2","18"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"3","8"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"5","4"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"7","2"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"11","1"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"13","1"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"17","1"},
   "Superscript"], "\[CenterDot]", 
  TemplateBox[{"19","1"},
   "Superscript"]}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["\<\
Unfortunately, this rule fails for numbers that have only one prime factor.\
\>", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeFactorForm", "[", "9", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"CenterDot", "[", 
  TemplateBox[{"3","2"},
   "Superscript"], "]"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["A second rule is needed for this special case.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PrimeFactorForm", "[", 
   RowBox[{"p_", "?", "PrimePowerQ"}], "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"Superscript", "@@@", 
    RowBox[{"FactorInteger", "[", "p", "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeFactorForm", "[", "9", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 TemplateBox[{"3","2"},
  "Superscript"]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "A subtle point is that ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " has automatically ordered these two rules, putting the one involving prime \
powers first."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PrimeFactorForm"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell["Global`PrimeFactorForm", "Print", "PrintUsage",
 CellTags->{"5.2 Solutions", "Info3563802280-1903310"}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"PrimeFactorForm", "[", 
          RowBox[{"p_", "?", "PrimePowerQ"}], "]"}], ":=", 
         RowBox[{"First", "[", 
          RowBox[{"Apply", "[", 
           RowBox[{"\<\"Superscript\"\>", ",", 
            RowBox[{"FactorInteger", "[", "p", "]"}], ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrimeFactorForm", "[", "p_", "]"}], ":=", 
         RowBox[{"CenterDot", "@@", 
          RowBox[{"Apply", "[", 
           RowBox[{"\<\"Superscript\"\>", ",", 
            RowBox[{"FactorInteger", "[", "p", "]"}], ",", 
            RowBox[{"{", "1", "}"}]}], "]"}]}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`PrimeFactorForm],
  Editable->False]], "Print",
 CellTags->{"5.2 Solutions", "Info3563802280-1903310"}]
}, Closed]],

Cell["\<\
This reordering (we evaluated the rules in a different order) is essential \
for this function to work properly. If the general rule was checked first, it \
would apply to arguments that happen to be prime powers and it would give \
wrong answers.\
\>", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[TextData[{
 "One final point: the expressions returned by ",
 Cell[BoxData["PrimeFactorForm"]],
 " will not evaluate like ordinary expressions due to the use of ",
 Cell[BoxData[
  ButtonBox["CenterDot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/CenterDot"]], "InlineFormula"],
 " which has no evaluation rules associated with it. You could add an \
\[OpenCurlyDoubleQuote]interpretation\[CloseCurlyDoubleQuote] to such \
expressions by using ",
 Cell[BoxData[
  RowBox[{"Interpretation", "[", 
   RowBox[{
    StyleBox["disp", "ExerciseTI"], ",", 
    StyleBox["expr", "ExerciseTI"]}], "]"}]]],
 " as follows."
}], "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PrimeFactorForm", "[", "p_Integer", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fp", "=", 
      RowBox[{"FactorInteger", "[", "p", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Interpretation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CenterDot", "@@", 
       RowBox[{"(", 
        RowBox[{"Superscript", "@@@", "fp"}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Times", "@@", 
       RowBox[{"(", 
        RowBox[{"Power", "@@@", "fp"}], ")"}]}]}], "]"}]}], "]"}]}]], "Input",\

 CellTags->"5.2 Solutions"],

Cell["\<\
Now the output of the following expression can be evaluated directly to get \
an interpreted result.\
\>", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeFactorForm", "[", 
  RowBox[{"12", "!"}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TemplateBox[{"2","10"},
    "Superscript"], "\[CenterDot]", 
   TemplateBox[{"3","5"},
    "Superscript"], "\[CenterDot]", 
   TemplateBox[{"5","2"},
    "Superscript"], "\[CenterDot]", 
   TemplateBox[{"7","1"},
    "Superscript"], "\[CenterDot]", 
   TemplateBox[{"11","1"},
    "Superscript"]}],
  Apply[Times, 
   Apply[Power, {{2, 10}, {3, 5}, {5, 2}, {7, 1}, {11, 1}}, {1}]]]], "Output",\

 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a straightforward application of the ",
 Cell[BoxData[
  ButtonBox["Outer",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Outer"]], "InlineFormula"],
 " function."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VandermondeMatrix", "[", 
   RowBox[{"n_", ",", "x_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Outer", "[", 
   RowBox[{"Power", ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      SubscriptBox["x", "i"], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", 
      RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"VandermondeMatrix", "[", 
   RowBox[{"4", ",", "x"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      SubscriptBox["x", "1"], 
      SubsuperscriptBox["x", "1", "2"], 
      SubsuperscriptBox["x", "1", "3"]},
     {"1", 
      SubscriptBox["x", "2"], 
      SubsuperscriptBox["x", "2", "2"], 
      SubsuperscriptBox["x", "2", "3"]},
     {"1", 
      SubscriptBox["x", "3"], 
      SubsuperscriptBox["x", "3", "2"], 
      SubsuperscriptBox["x", "3", "3"]},
     {"1", 
      SubscriptBox["x", "4"], 
      SubsuperscriptBox["x", "4", "2"], 
      SubsuperscriptBox["x", "4", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "If we first look at a symbolic result, we should be able to see how to \
construct our function. For three vectors and three variables, here is the \
divergence (think of ",
 Cell[BoxData["d"]],
 " as the derivative operator)."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Inner", "[", 
  RowBox[{
   StyleBox["d", "Color2"], ",", 
   RowBox[{"{", 
    RowBox[{"e1", ",", "e2", ",", "e3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"v1", ",", "v2", ",", "v3"}], "}"}], ",", "Plus"}], 
  "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "[", 
   RowBox[{"e1", ",", "v1"}], "]"}], "+", 
  RowBox[{"d", "[", 
   RowBox[{"e2", ",", "v2"}], "]"}], "+", 
  RowBox[{"d", "[", 
   RowBox[{"e3", ",", "v3"}], "]"}]}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["So for arbitrary-length vectors and variables, we have:", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"div", "[", 
   RowBox[{"vecs_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Inner", "[", 
   RowBox[{"D", ",", "vecs", ",", "vars", ",", "Plus"}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell["\<\
As a check, we can compute the divergence of the standard gravitational or \
electric force field, which should be zero.\
\>", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"div", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], "/", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["x", "2"], "+", 
       SuperscriptBox["y", "2"], "+", 
       SuperscriptBox["z", "2"]}], ")"}], 
     RowBox[{"3", "/", "2"}]]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox["x", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["x", "2"], "+", 
       SuperscriptBox["y", "2"], "+", 
       SuperscriptBox["z", "2"]}], ")"}], 
     RowBox[{"5", "/", "2"}]]]}], "-", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["y", "2"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["x", "2"], "+", 
      SuperscriptBox["y", "2"], "+", 
      SuperscriptBox["z", "2"]}], ")"}], 
    RowBox[{"5", "/", "2"}]]], "-", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["z", "2"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["x", "2"], "+", 
      SuperscriptBox["y", "2"], "+", 
      SuperscriptBox["z", "2"]}], ")"}], 
    RowBox[{"5", "/", "2"}]]], "+", 
  FractionBox["3", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["x", "2"], "+", 
      SuperscriptBox["y", "2"], "+", 
      SuperscriptBox["z", "2"]}], ")"}], 
    RowBox[{"3", "/", "2"}]]]}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "%", "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData["0"], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Finally, we should note that this definition of divergence is a bit \
delicate as we are doing no argument checking at this point. For example, it \
would be sensible to insure that the length of the vector list is the same as \
the length of the variable list before starting the computation. Refer to ",
 "Chapter",
 " ",
 StyleBox["4", "OsF"],
 " for a discussion of how to use pattern matching to deal with this issue."
}], "SolutionText",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First create a table of primes and then use that list for values of ",
 Cell[BoxData["p"]],
 " in the second table."
}], "SolutionItem",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"primes", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Prime", "[", "n", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1", ",", "50"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "5", ",", "7", ",", "11", ",", "13", ",", "17", ",", 
   "19", ",", "23", ",", "29", ",", "31", ",", "37", ",", "41", ",", "43", 
   ",", "47", ",", "53", ",", "59", ",", "61", ",", "67", ",", "71", ",", 
   "73", ",", "79", ",", "83", ",", "89", ",", "97", ",", "101", ",", "103", 
   ",", "107", ",", "109", ",", "113", ",", "127", ",", "131", ",", "137", 
   ",", "139", ",", "149", ",", "151", ",", "157", ",", "163", ",", "167", 
   ",", "173", ",", "179", ",", "181", ",", "191", ",", "193", ",", "197", 
   ",", "199", ",", "211", ",", "223", ",", "227", ",", "229"}], 
  "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["2", "p"], "-", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "primes"}], "}"}]}], "]"}], ",", "PrimeQ"}], 
  "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "7", ",", "31", ",", "127", ",", "8191", ",", "131071", ",", 
   "524287", ",", "2147483647", ",", "2305843009213693951", ",", 
   "618970019642690137449562111", ",", "162259276829213363391578010288127", 
   ",", "170141183460469231731687303715884105727"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],

Cell["Or you could do the same thing more directly.", "SolutionText",
 CellTags->"5.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"Prime", "[", "n", "]"}]], "-", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", "50"}], "}"}]}], "]"}], ",", "PrimeQ"}], 
  "]"}]], "Input",
 CellTags->"5.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "7", ",", "31", ",", "127", ",", "8191", ",", "131071", ",", 
   "524287", ",", "2147483647", ",", "2305843009213693951", ",", 
   "618970019642690137449562111", ",", "162259276829213363391578010288127", 
   ",", "170141183460469231731687303715884105727"}], "}"}]], "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Iterating functions", "ExerciseSubsection",
 CellTags->"Sec.Iterating functions"],

Cell[TextData[{
 "Determine the locations after each step of a ten-step one-dimensional \
random walk. (Recall that you have already generated the step ",
 StyleBox["directions",
  FontSlant->"Italic"],
 " in Exercise ",
 StyleBox["3", "OsF"],
 " at the end of Section ",
 StyleBox["3.1", "OsF"],
 ".)"
}], "ExerciseItem",
 CellTags->{"i:44", "5.3 Exercises"}],

Cell["\<\
Create a list of the step locations of a ten-step random walk on a square \
lattice.\
\>", "ExerciseItem",
 CellTags->{"i:45", "5.3 Exercises"}],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]]],
 ", create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["fac", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that takes an integer ",
 StyleBox["n",
  FontSlant->"Italic"],
 " as argument and returns the factorial of ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", that is, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"n", "(", 
     RowBox[{"n", "-", 
      StyleBox["1", "OsF"]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"n", "-", 
      StyleBox["2", "OsF"]}], ")"}], 
    RowBox[{
     StyleBox[
      RowBox[{"\[CenterEllipsis]", 
       StyleBox["3", "OsF"]}]], "\[CenterDot]", 
     StyleBox["2", "OsF"], "\[CenterDot]", 
     StyleBox["1", "OsF"]}]}], TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->"5.3 Exercises"],

Cell[CellGroupData[{

Cell["\<\
The Sierpinski triangle is a classic iteration example. It is constructed by \
starting with an equilateral triangle (other objects can be used) and \
removing the inner triangle formed by connecting the midpoints of each side \
of the original triangle.\
\>", "ExerciseItem",
 CellTags->{"i:150", "5.3 Exercises"}],

Cell[TextData[{
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 0.}}]},
   ImageSize->{66.00172132058589, Automatic}]]],
 StyleBox["\[LongRightArrow]",
  StripOnInput->False,
  FontSize->12],
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    GeometricTransformationBox[
     GeometricTransformationBox[
      PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 0.}}], {{{0.5, 
       0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 0.4330127018922193}}, {{0.5, 
     0.}}, {{0., 0.}}}]},
   ImageSize->{66., Automatic}]]]
}], "ExerciseDisplayFormula",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellTags->"5.3 Exercises"],

Cell["\<\
The process is iterated by repeating the same computation on each of the \
resulting smaller triangles. \
\>", "ExerciseText",
 CellTags->"5.3 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 0.}}]},
   ImageSize->{66.66666666666673, Automatic}]]],
 StyleBox["\[LongRightArrow]",
  StripOnInput->False,
  FontSize->12],
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    {RGBColor[0, 0, 1], 
     GeometricTransformationBox[
      GeometricTransformationBox[
       PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 0.}}], {{{0.5, 
        0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 0.4330127018922193}}, {{0.5, 
      0.}}, {{0., 0.}}}]}},
   ImageSize->{66.00000000000017, Automatic}]]],
 StyleBox["\[LongRightArrow]",
  StripOnInput->False,
  FontSize->12],
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    {RGBColor[0, 0, 1], 
     GeometricTransformationBox[GeometricTransformationBox[
       {RGBColor[0, 0, 1], 
        GeometricTransformationBox[
         GeometricTransformationBox[
          PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 0.}}], {{{0.5,
            0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 0.4330127018922193}}, {{0.5,
          0.}}, {{0., 0.}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 
      0.4330127018922193}}, {{0.5, 0.}}, {{0., 0.}}}]}},
   ImageSize->{66.66666666666586, Automatic}]]],
 "\[CenterEllipsis] ",
 StyleBox[" \[LongRightArrow] ",
  StripOnInput->False,
  FontSize->12],
 " \[CenterEllipsis]",
 Cell[BoxData[
  GraphicsBox[
   {RGBColor[0, 0, 1], 
    {RGBColor[0, 0, 1], 
     GeometricTransformationBox[GeometricTransformationBox[
       {RGBColor[0, 0, 1], 
        GeometricTransformationBox[GeometricTransformationBox[
          {RGBColor[0, 0, 1], 
           GeometricTransformationBox[GeometricTransformationBox[
             {RGBColor[0, 0, 1], 
              GeometricTransformationBox[GeometricTransformationBox[
                {RGBColor[0, 0, 1], 
                 GeometricTransformationBox[GeometricTransformationBox[
                   {RGBColor[0, 0, 1], 
                    GeometricTransformationBox[
                    GeometricTransformationBox[
                    PolygonBox[{{0., 0.}, {0.5, 0.8660254037844386}, {1., 
                    0.}}], {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 
                    0.4330127018922193}}, {{0.5, 0.}}, {{0., 0.}}}]}, {{{0.5, 
                    0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 
                  0.4330127018922193}}, {{0.5, 0.}}, {{0., 0.}}}]}, {{{0.5, 
                 0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 
               0.4330127018922193}}, {{0.5, 0.}}, {{0., 0.}}}]}, {{{0.5, 
              0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 0.4330127018922193}}, {{
            0.5, 0.}}, {{0., 0.}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{
         0.25, 0.4330127018922193}}, {{0.5, 0.}}, {{0., 0.}}}]}, {{{0.5, 
        0.}, {0., 0.5}}, {0., 0.}}], {{{0.25, 0.4330127018922193}}, {{0.5, 
      0.}}, {{0., 0.}}}]}},
   ImageSize->{66.66666666666558, Automatic}]]]
}], "ExerciseDisplayFormula",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellTags->"5.3 Exercises"],

Cell[TextData[{
 "One approach is to take the starting equilateral triangle and, at each \
iteration, perform the appropriate transformations using ",
 Cell[BoxData[
  ButtonBox["Scale",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Scale"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Translate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Translate"]], "InlineFormula"],
 ", then iterate. Implement this algorithm, but be careful about nesting \
large graphical structures too deeply."
}], "ExerciseText",
 CellTags->"5.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["First generate the step directions.", "SolutionItem",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{"Random", "[", "Integer", "]"}]], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell["Or the following also works.", "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"steps", "=", 
  RowBox[{
   RowBox[{"2", 
    RowBox[{"RandomInteger", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "10", "}"}]}], "]"}]}], "-", "1"}]}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Then, starting at ",
 StyleBox["0", "OsF"],
 ", the fold operation generates the locations."
}], "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{"Plus", ",", "0", ",", "steps"}], "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", "0"}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Use the method of generating a list of step locations that was shown in an \
earlier exercise.\
\>", "SolutionItem",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"steps", "=", 
  RowBox[{"RandomChoice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", "10", "}"}]}], "]"}]}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{"Plus", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", "steps"}], "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Starting with ",
 StyleBox["1", "OsF"],
 ", fold the ",
 Cell[BoxData[
  ButtonBox["Times",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Times"]], "InlineFormula"],
 " function across the first ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " integers."
}], "SolutionItem",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fac", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"Times", ",", "1", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fac", "[", "10", "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData["3628800"], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First create the vertices of the triangle. Wrapping them in ",
 Cell[BoxData[
  RowBox[{"N", "[", "\[Ellipsis]", "]"}]]],
 " helps to keep the graphical structures small (see ",
 "Section",
 " ",
 StyleBox["10.2", "OsF"],
 " for more on this)."
}], "SolutionItem",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vertices", "=", 
   RowBox[{"N", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "/", "2"}], ",", "1"}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell["This gives the three different translation vectors.", "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"translateVecs", "=", 
  RowBox[{"0.5", "vertices"}]}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25`", ",", "0.5`"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is the set of transformations of the triangle described by ",
 Cell[BoxData["vertices"]],
 ", scaled by ",
 StyleBox["0.5", "OsF"],
 ", and translated according to the translation vectors."
}], "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tri", "=", 
   RowBox[{"Polygon", "[", "vertices", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{"Blue", ",", 
    RowBox[{"Translate", "[", 
     RowBox[{
      RowBox[{"Scale", "[", 
       RowBox[{"tri", ",", "0.5", ",", 
        RowBox[{"{", 
         RowBox[{"0.", ",", "0."}], "}"}]}], "]"}], ",", "translateVecs"}], 
     "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0, 0, 1], 
   GeometricTransformationBox[
    GeometricTransformationBox[
     PolygonBox[{{0., 0.}, {1., 0.}, {0.5, 1.}}], {{{0.5, 0.}, {0., 0.5}}, {
      0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]},
  ImageSize->100]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Finally, iterate the transformations by wrapping them in ",
 Cell[BoxData[
  ButtonBox["Nest",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Nest"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{"Blue", ",", 
    RowBox[{"Nest", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"Translate", "[", 
          RowBox[{
           RowBox[{"Scale", "[", 
            RowBox[{"#", ",", "0.5", ",", 
             RowBox[{"{", 
              RowBox[{"0.", ",", "0."}], "}"}]}], "]"}], ",", 
           "translateVecs"}], "]"}]}], "}"}], "&"}], ",", 
      RowBox[{"Polygon", "[", "vertices", "]"}], ",", "3"}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0, 0, 1], 
   {RGBColor[0, 0, 1], GeometricTransformationBox[GeometricTransformationBox[
      {RGBColor[0, 0, 1], 
       GeometricTransformationBox[GeometricTransformationBox[
         {RGBColor[0, 0, 1], 
          GeometricTransformationBox[
           GeometricTransformationBox[
            PolygonBox[{{0., 0.}, {1., 0.}, {0.5, 1.}}], {{{0.5, 0.}, {0., 
             0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 
           0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 
        0.}}, {{0.25, 0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0., 
     0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]}},
  ImageSize->100]], "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],

Cell["\<\
Once you have been through the rest of this chapter, you should be able to \
turn this into a reusable function, scoping local variables, using pure \
functions, and adding options.\
\>", "SolutionText",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SierpinskiTriangle", "[", 
   RowBox[{"iter_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vertices", ",", "vecs"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vertices", "=", 
      RowBox[{"N", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "/", "2"}], ",", "1"}], "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vecs", "=", 
      RowBox[{"0.5", "vertices"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"Nest", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", 
              RowBox[{"Translate", "[", 
               RowBox[{
                RowBox[{"Scale", "[", 
                 RowBox[{"#", ",", "0.5", ",", 
                  RowBox[{"{", 
                   RowBox[{"0.", ",", "0."}], "}"}]}], "]"}], ",", "vecs"}], 
               "]"}]}], "}"}], "&"}], ",", 
           RowBox[{"Polygon", "[", "vertices", "]"}], ",", "iter"}], "]"}]}], 
        "}"}], ",", "opts"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SierpinskiTriangle", "[", 
  RowBox[{"8", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]], "Input",
 CellTags->"5.3 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0, 0, 1], 
   {RGBColor[0, 0, 1], GeometricTransformationBox[GeometricTransformationBox[
      {RGBColor[0, 0, 1], 
       GeometricTransformationBox[GeometricTransformationBox[
         {RGBColor[0, 0, 1], 
          GeometricTransformationBox[GeometricTransformationBox[
            {RGBColor[0, 0, 1], 
             GeometricTransformationBox[GeometricTransformationBox[
               {RGBColor[0, 0, 1], 
                GeometricTransformationBox[GeometricTransformationBox[
                  {RGBColor[0, 0, 1], 
                   GeometricTransformationBox[GeometricTransformationBox[
                    {RGBColor[0, 0, 1], 
                    GeometricTransformationBox[GeometricTransformationBox[
                    {RGBColor[0, 0, 1], 
                    GeometricTransformationBox[
                    GeometricTransformationBox[
                    PolygonBox[{{0., 0.}, {1., 0.}, {0.5, 1.}}], {{{0.5, 
                    0.}, {0., 0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{
                    0.25, 0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{
                    0., 0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]}, {{{0.5, 0.}, {0.,
                     0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 
                    0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0., 
                 0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]}, {{{0.5, 0.}, {0., 
                0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 
              0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 0.}}], {{{0., 0.}}, {{
           0.5, 0.}}, {{0.25, 0.5}}}]}, {{{0.5, 0.}, {0., 0.5}}, {0., 
          0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]}, {{{0.5, 0.}, {0.,
        0.5}}, {0., 0.}}], {{{0., 0.}}, {{0.5, 0.}}, {{0.25, 0.5}}}]}},
  ImageSize->Small]], "Output",
 CellTags->"5.3 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Programs as functions", "ExerciseSubsection"],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Total",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Total"]], "InlineFormula"],
 ", create a function to sum the first ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " positive integers."
}], "ExerciseItem",
 CellTags->{"Exercise.Total ints", "5.4 Exercises"}],

Cell[TextData[{
 "Rewrite the ",
 StyleBox["listEvenQ", "MR", "ExLink"],
 " function from this section using ",
 Cell[BoxData[
  ButtonBox["MemberQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MemberQ"]]],
 "."
}], "ExerciseItem",
 CellTags->"5.4 Exercises"],

Cell[TextData[{
 "Using the ",
 Cell[BoxData[
  StyleBox["shuffle", "ExerciseMR"]]],
 " function developed in this section, how many shuffles of a deck of cards \
(or any list, for that matter) are needed to return the deck to its original \
order?"
}], "ExerciseItem",
 CellTags->"5.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Many lotteries include games that require you to pick several numbers and \
match them against the \[OpenCurlyDoubleQuote]house.\[CloseCurlyDoubleQuote] \
The numbers are independent, so this is essentially random sampling with \
replacement. The built-in ",
 Cell[BoxData[
  ButtonBox["RandomChoice",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RandomChoice"]]],
 " does this. For example, here are five random samples from the integers ",
 StyleBox["0", "OsF"],
 " through ",
 StyleBox["9", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"i:54", "5.4 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomChoice", "[", 
  RowBox[{
   RowBox[{"Range", "[", 
    RowBox[{"0", ",", "9"}], "]"}], ",", "5"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "1", ",", "8", ",", "7", ",", "4"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "Write your own function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["randomChoice", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that performs a random sampling with replacement, where ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is the number of elements being chosen from the list ",
 StyleBox["lis",
  FontSlant->"Italic"],
 ". Here is a typical result using a list of symbols."
}], "ExerciseText",
 CellTags->"5.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randomChoice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
     "h"}], "}"}], ",", "12"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "g", ",", "c", ",", "a", ",", "a", ",", "d", ",", "h", ",", "c", ",", "a", 
   ",", "c", ",", "f", ",", "c", ",", "a"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["Trace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Trace"]]],
 " on the rule-based ",
 StyleBox["maxima", "MR", "ExLink"],
 " from Section ",
 StyleBox["4.2", "OsF"],
 " and ",
 StyleBox["maxima", "MR", "ExLink"],
 " developed in this section to explain why the functional version is much \
faster than the pattern matching version."
}], "ExerciseItem",
 CellTags->"5.4 Exercises"],

Cell[TextData[{
 "Write your own user-defined functions using the ",
 Cell[BoxData[
  ButtonBox["Characters",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Characters"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["StringJoin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringJoin"]]],
 " functions to perform the same operations as ",
 Cell[BoxData[
  ButtonBox["StringInsert",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringInsert"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["StringDrop",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringDrop"]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:55", "5.4 Exercises"}],

Cell[TextData[{
 "Write a function ",
 StyleBox["interleave", "MR", "ExLink"],
 " that interleaves the elements of two lists of unequal length. (You have \
already seen how to interleave lists of equal length using ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]]],
 " earlier in this section with the ",
 Cell[BoxData[
  StyleBox["shuffle", "MR", "ExLink"]]],
 " function.) Your function should take the lists ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], "ExLink"]]],
 " as inputs and return ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "1", ",", "b", ",", "2", ",", "c", ",", "3", ",", "d"}],
     "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->{"Ex.interleave", "5.4 Exercises"}],

Cell[TextData[{
 "Write nested function calls using ",
 Cell[BoxData[
  ButtonBox["ToCharacterCode",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ToCharacterCode"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["FromCharacterCode",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FromCharacterCode"]]],
 " to perform the same operations as the built-in ",
 Cell[BoxData[
  ButtonBox["StringJoin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringJoin"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["StringReverse",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringReverse"]]],
 " functions."
}], "ExerciseItem",
 CellTags->{"i:56", "5.4 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Generate the list of integers ",
 StyleBox["1", "OsF"],
 " through ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", then total that list."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sumInts", "[", "n_", "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"Range", "[", "n", "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumInts", "[", "100", "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["5050"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumInts", "[", "1000", "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["500500"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "We have not been careful to check that the arguments are positive integers \
here. See ",
 "Section",
 " ",
 StyleBox["5.6", "OsF"],
 " for a proper definition to check arguments."
}], "SolutionText",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["MemberQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MemberQ"]], "InlineFormula"],
 " to check if any elements of the list pass the ",
 Cell[BoxData[
  ButtonBox["OddQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/OddQ"]], "InlineFormula"],
 " test. If they do, ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/True"]], "InlineFormula"],
 " is returned and so we take the Boolean negation of that. In other words, \
if the list contains an odd number, ",
 Cell[BoxData[
  ButtonBox["False",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/False"]], "InlineFormula"],
 " is returned, indicating that the list does not consist of even numbers \
exclusively."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"listEvenQ2", "[", "lis_", "]"}], ":=", 
  RowBox[{"Not", "[", 
   RowBox[{"MemberQ", "[", 
    RowBox[{"lis", ",", 
     RowBox[{"_", "?", "OddQ"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"listEvenQ2", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "4", ",", "6", ",", "4", ",", "8"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"listEvenQ2", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "4", ",", "6", ",", "5", ",", "8"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Alternatively, you could have ",
 Cell[BoxData[
  ButtonBox["FreeQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FreeQ"]], "InlineFormula"],
 " check to see if the list is free of numbers that are equal to ",
 StyleBox["1", "OsF"],
 " mod ",
 StyleBox["2", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"listEvenQ3", "[", "lis_", "]"}], ":=", 
  RowBox[{"FreeQ", "[", 
   RowBox[{"lis", ",", 
    RowBox[{"p_", "/;", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"p", ",", "2"}], "]"}], "\[Equal]", "1"}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"listEvenQ3", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "4", ",", "6", ",", "4", ",", "8"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"listEvenQ3", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "4", ",", "6", ",", "5", ",", "8"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Some simple experiments iterating the ",
 Cell[BoxData[
  StyleBox["shuffle", "ExerciseMR"]]],
 " function shows that the number of shuffles to return the deck to its \
original state is dependent upon the number of cards in the deck. For a deck \
of ",
 StyleBox["52", "OsF"],
 " cards, eight such perfect (Faro) shuffles will return the deck to its \
original state."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"shuffle", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{"Ceiling", "[", 
       RowBox[{
        RowBox[{"Length", "[", "lis", "]"}], "/", "2"}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Apply", "[", 
     RowBox[{"Riffle", ",", 
      RowBox[{"Partition", "[", 
       RowBox[{"lis", ",", "len", ",", "len", ",", "1", ",", 
        RowBox[{"{", "}"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Nest", "[", 
  RowBox[{"shuffle", ",", 
   RowBox[{"Range", "[", "52", "]"}], ",", "8"}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
   ",", "9", ",", "10", ",", "11", ",", "12", ",", "13", ",", "14", ",", "15",
    ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", "21", ",", 
   "22", ",", "23", ",", "24", ",", "25", ",", "26", ",", "27", ",", "28", 
   ",", "29", ",", "30", ",", "31", ",", "32", ",", "33", ",", "34", ",", 
   "35", ",", "36", ",", "37", ",", "38", ",", "39", ",", "40", ",", "41", 
   ",", "42", ",", "43", ",", "44", ",", "45", ",", "46", ",", "47", ",", 
   "48", ",", "49", ",", "50", ",", "51", ",", "52"}], "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The obvious way to do this is to take the list and simply pick out elements \
at random locations. The right-most location in the list is given by ",
 Cell[BoxData[
  RowBox[{"Length", "[", "lis", "]"}]]],
 ", using ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["RandomInteger",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RandomInteger"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"randomChoice", "[", 
   RowBox[{"lis_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"lis", "\[LeftDoubleBracket]", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"Length", "[", "lis", "]"}]}], "}"}], ",", 
     RowBox[{"{", "n", "}"}]}], "]"}], 
   "\[RightDoubleBracket]"}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"randomChoice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
     "h"}], "}"}], ",", "12"}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "h", ",", "b", ",", "c", ",", "f", ",", "c", ",", "f", ",", "b", ",", "g", 
   ",", "h", ",", "e", ",", "e", ",", "b"}], "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The pattern matched function is slower because it repeatedly applies \
transformation rules.\
\>", "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"maxima", "[", "lis_List", "]"}], ":=", 
  RowBox[{"lis", "//.", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", "b_", ",", "c___", ",", "d_", ",", "e___"}], "}"}],
      "/;", 
     RowBox[{"d", "\[LessEqual]", "b"}]}], "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}]}]}]}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"maximaF", "[", "lis_", "]"}], ":=", 
  RowBox[{"Rest", "[", 
   RowBox[{"DeleteDuplicates", "[", 
    RowBox[{"FoldList", "[", 
     RowBox[{"Max", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "lis"}], "]"}], "]"}], 
   "]"}]}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"maxima", "[", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", "9",
      ",", "7"}], "}"}], "]"}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"maxima", "[", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", 
       "9", ",", "7"}], "}"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", 
       "9", ",", "7"}], "}"}], "//.", "\[VeryThinSpace]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a___", ",", "b_", ",", "c___", ",", "d_", ",", "e___"}], 
        "}"}], "/;", 
       RowBox[{"d", "\[LessEqual]", "b"}]}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}]}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a___", ",", "b_", ",", "c___", ",", "d_", ",", "e___"}], 
         "}"}], "/;", 
        RowBox[{"d", "\[LessEqual]", "b"}]}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}]}],
      HoldForm], ",", 
     TagBox[
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a___", ",", "b_", ",", "c___", ",", "d_", ",", "e___"}], 
         "}"}], "/;", 
        RowBox[{"d", "\[LessEqual]", "b"}]}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}]}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", 
       "9", ",", "7"}], "}"}], "//.", "\[VeryThinSpace]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a___", ",", "b_", ",", "c___", ",", "d_", ",", "e___"}], 
        "}"}], "/;", 
       RowBox[{"d", "\[LessEqual]", "b"}]}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}]}]}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"5", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"2", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"5", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"1", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"5", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"4", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"7", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"4", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"5", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"7", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"7", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "6"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "6"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"7", "\[LessEqual]", "6"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "8"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"7", "\[LessEqual]", "8"}],
      HoldForm], ",", 
     TagBox["True",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"5", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "3"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"6", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "5"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"8", "\[LessEqual]", "6"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "6"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"9", "\[LessEqual]", "8"}],
      HoldForm], ",", 
     TagBox["False",
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"{", 
     RowBox[{"3", ",", "5", ",", "6", ",", "8", ",", "9"}], "}"}],
    HoldForm]}], "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Trace", "[", 
  RowBox[{"maximaF", "[", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", "9",
      ",", "7"}], "}"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{3.529263686423513*^9},
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"maximaF", "[", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",", 
       "9", ",", "7"}], "}"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"Rest", "[", 
     RowBox[{"DeleteDuplicates", "[", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Max", ",", 
        RowBox[{"-", "\[Infinity]"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", ",",
           "9", ",", "7"}], "}"}]}], "]"}], "]"}], "]"}],
    HoldForm], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           TagBox["\[Infinity]",
            HoldForm], ",", 
           TagBox["\[Infinity]",
            HoldForm]}], "}"}], ",", 
         TagBox[
          RowBox[{"-", "\[Infinity]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"-", "\[Infinity]"}],
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"FoldList", "[", 
         RowBox[{"Max", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "3", ",", "5", ",", "2", ",", "6", ",", "1", ",", "8", ",", "4", 
            ",", "9", ",", "7"}], "}"}]}], "]"}],
        HoldForm], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"-", "\[Infinity]"}], ",", "3"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"3", ",", 
            RowBox[{"-", "\[Infinity]"}]}], "]"}],
          HoldForm], ",", 
         TagBox["3",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"3", ",", "5"}], "]"}],
          HoldForm], ",", 
         TagBox["5",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"5", ",", "2"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"2", ",", "5"}], "]"}],
          HoldForm], ",", 
         TagBox["5",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"5", ",", "6"}], "]"}],
          HoldForm], ",", 
         TagBox["6",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"6", ",", "1"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"1", ",", "6"}], "]"}],
          HoldForm], ",", 
         TagBox["6",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"6", ",", "8"}], "]"}],
          HoldForm], ",", 
         TagBox["8",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"8", ",", "4"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"4", ",", "8"}], "]"}],
          HoldForm], ",", 
         TagBox["8",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"8", ",", "9"}], "]"}],
          HoldForm], ",", 
         TagBox["9",
          HoldForm]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"9", ",", "7"}], "]"}],
          HoldForm], ",", 
         TagBox[
          RowBox[{"Max", "[", 
           RowBox[{"7", ",", "9"}], "]"}],
          HoldForm], ",", 
         TagBox["9",
          HoldForm]}], "}"}], ",", 
       TagBox[
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "\[Infinity]"}], ",", "3", ",", "5", ",", "5", ",", 
          "6", ",", "6", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}],
        HoldForm]}], "}"}], ",", 
     TagBox[
      RowBox[{"DeleteDuplicates", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], ",", "3", ",", "5", ",", "5", ",", "6",
          ",", "6", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}], "]"}],
      HoldForm], ",", 
     TagBox[
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], ",", "3", ",", "5", ",", "6", ",", "8", 
        ",", "9"}], "}"}],
      HoldForm]}], "}"}], ",", 
   TagBox[
    RowBox[{"Rest", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], ",", "3", ",", "5", ",", "6", ",", "8", 
       ",", "9"}], "}"}], "]"}],
    HoldForm], ",", 
   TagBox[
    RowBox[{"{", 
     RowBox[{"3", ",", "5", ",", "6", ",", "8", ",", "9"}], "}"}],
    HoldForm]}], "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is our user-defined ",
 Cell[BoxData["stringInsert"]],
 "."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringInsert", "[", 
   RowBox[{"str1_", ",", "str2_", ",", "pos_"}], "]"}], ":=", 
  RowBox[{"StringJoin", "@", 
   RowBox[{"Join", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{"Characters", "[", "str1", "]"}], ",", 
       RowBox[{"pos", "-", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Characters", "[", "str2", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Drop", "[", 
      RowBox[{
       RowBox[{"Characters", "[", "str1", "]"}], ",", 
       RowBox[{"pos", "-", "1"}]}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringInsert", "[", 
  RowBox[{"\"\<Joy world\>\"", ",", "\"\<to the \>\"", ",", "5"}], 
  "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["\<\"Joy to the world\"\>"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringDrop", "[", 
   RowBox[{"str_", ",", "pos_"}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], ",", "pos"}], "]"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringDrop", "[", 
  RowBox[{"\"\<ABCDEF\>\"", ",", 
   RowBox[{"-", "2"}]}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["\<\"ABCD\"\>"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "The idea in these two examples is to convert a string to a list of \
characters, operate on that list using list manipulation functions like ",
 Cell[BoxData[
  ButtonBox["Join",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Join"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Take",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Take"]], "InlineFormula"],
 ", and ",
 Cell[BoxData[
  ButtonBox["Drop",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Drop"]], "InlineFormula"],
 ", then convert back to a string. More efficient approaches use string \
manipulation functions directly (see ",
 "Chapter",
 " ",
 StyleBox["9", "OsF"],
 ")."
}], "SolutionText",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We assume that ",
 Cell[BoxData["lis1"]],
 " is longer than ",
 Cell[BoxData["lis2"]],
 " and pair off the corresponding elements in the lists and then tack on the \
leftover elements from ",
 Cell[BoxData["lis1"]],
 "."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"interleave", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Take", "[", 
         RowBox[{"lis1", ",", 
          RowBox[{"Length", "[", "lis2", "]"}]}], "]"}], ",", "lis2"}], "}"}],
       "]"}], ",", 
     RowBox[{"Take", "[", 
      RowBox[{"lis1", ",", 
       RowBox[{
        RowBox[{"Length", "[", "lis2", "]"}], "-", 
        RowBox[{"Length", "[", "lis1", "]"}]}]}], "]"}]}], "]"}], 
   "]"}]}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"interleave", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "1", ",", "b", ",", "2", ",", "c", ",", "3", ",", "d"}], 
  "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Compare with the built-in ",
 Cell[BoxData[
  ButtonBox["Riffle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Riffle"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riffle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "1", ",", "b", ",", "2", ",", "c", ",", "3", ",", "d"}], 
  "}"}]], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, here is how we might write our own ",
 Cell[BoxData["StringJoin"]],
 "."
}], "SolutionItem",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromCharacterCode", "[", 
  RowBox[{"Join", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ToCharacterCode", "[", "\"\<To be, \>\"", "]"}], ",", 
    RowBox[{"ToCharacterCode", "[", "\"\<or not to be\>\"", "]"}]}], 
   "\[IndentingNewLine]", "]"}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["\<\"To be, or not to be\"\>"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "And here is a how we might implement a ",
 Cell[BoxData["StringReverse"]],
 "."
}], "SolutionText",
 CellTags->"5.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromCharacterCode", "[", 
  RowBox[{"Reverse", "[", 
   RowBox[{"ToCharacterCode", "[", "%", "]"}], "]"}], "]"}]], "Input",
 CellTags->"5.4 Solutions"],

Cell[BoxData["\<\"eb ot ton ro ,eb oT\"\>"], "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Scoping constructs", "ExerciseSubsection",
 CellTags->"Sec.Scoping constructs"],

Cell[TextData[{
 "Write a compound function definition for the location of steps taken in an ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "-step random walk on a square lattice. The step directions can be taken to \
be the compass directions with north represented by ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "ExLink"]]],
 ", south by ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], "ExLink"]]],
 ", and so on. Hint: consider using the ",
 Cell[BoxData[
  ButtonBox["Accumulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Accumulate"]]],
 " function."
}], "ExerciseItem",
 CellTags->{"i:70", "5.5 Exercises"}],

Cell[TextData[{
 "The ",
 StyleBox["PerfectSearch", "MR", "ExLink"],
 " function defined in Section ",
 StyleBox["1.1", "OsF"],
 " is impractical for checking large numbers because it has to check all \
numbers from ",
 StyleBox["1", "OsF"],
 " through ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ". If you already know the perfect numbers below ",
 StyleBox["500", "OsF"],
 ", say, it is inefficient to check all numbers from ",
 StyleBox["1", "OsF"],
 " to ",
 Cell[BoxData[
  StyleBox["1000", "OsF"]]],
 " if you are only looking for perfect numbers in the range ",
 StyleBox["500", "OsF"],
 " to ",
 Cell[BoxData[
  StyleBox["1000", "OsF"]]],
 ". Modify ",
 StyleBox["PerfectSearch", "MR", "ExLink"],
 " so that it accepts two numbers as input and finds all perfect numbers \
between the inputs. For example, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["PerfectSearch", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["a", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["b", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " will produce a list of all perfect numbers in the range from ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"Ex.Perfect numbers", "i:71", "5.5 Exercises"}],

Cell[TextData[{
 "A number, ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", is ",
 StyleBox["k",
  FontSlant->"Italic"],
 "-perfect if the sum of its proper divisors equals ",
 Cell[BoxData[
  FormBox[
   RowBox[{"k", " ", "n"}], TraditionalForm]]],
 ". Redefine ",
 StyleBox["PerfectSearch", "MR", "ExLink"],
 " from the previous exercise so that it accepts as input two numbers ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ", a positive integer ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 ", and computes all ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 "-perfect numbers in the range from ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ". Use your rule to find the only three ",
 StyleBox["4", "OsF"],
 "-perfect numbers less than ",
 Cell[BoxData[
  StyleBox["2200000", "OsF"]]],
 "."
}], "ExerciseItem",
 CellTags->"5.5 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Often in processing files you are presented with expressions that need to \
be converted into a format that can be more easily manipulated inside ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". For example, a file may contain dates in the form ",
 StyleBox["20120515", "OsF"],
 " to represent May ",
 StyleBox["15", "OsF"],
 ", ",
 StyleBox["2012.", "OsF"],
 " ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " represents its dates as a list in the form ",
 Cell[BoxData[
  RowBox[{
   StyleBox["{", "ExLink"], 
   RowBox[{
    StyleBox["year", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["month", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["day", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["hour", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["minutes", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["seconds", "ExerciseTI"]}], 
   StyleBox["}", "ExLink"]}]]],
 ". Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["convertToDate", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " to convert a number consisting of eight digits such as ",
 StyleBox["20120515", "MR", "ExLink"],
 " into a list of the form ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"2012", ",", "5", ",", "15"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:72", "5.5 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convertToDate", "[", "20120515", "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.5 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.5 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"zeroColumns", "[", 
    RowBox[{
     StyleBox["mat", "ExerciseTI"], ",", 
     RowBox[{
      StyleBox["m", "ExerciseTI"], ";;", 
      StyleBox["n", "ExerciseTI"]}]}], "]"}], "ExerciseMR"]]],
 " that zeros out columns ",
 StyleBox["m",
  FontSlant->"Italic"],
 " through ",
 StyleBox["n",
  FontSlant->"Italic"],
 " in matrix ",
 StyleBox["mat", "ExerciseTI"],
 ". Include rules to handle the cases of zeroing out one column or a list of \
nonconsecutive columns."
}], "ExerciseItem",
 CellTags->"5.5 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "In the first definition, we only use one auxiliary function inside the ",
 Cell[BoxData[
  ButtonBox["Module",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Module"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"latticeWalk2D", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"NSEW", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"Accumulate", "[", 
     RowBox[{"RandomChoice", "[", 
      RowBox[{"NSEW", ",", "n"}], "]"}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"latticeWalk2D", "[", "10", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "4"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The following function creates a local function ",
 Cell[BoxData["perfectQ"]],
 " using the ",
 Cell[BoxData[
  ButtonBox["Module",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Module"]], "InlineFormula"],
 " construct. It then checks every other number between ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " by using a third argument to the ",
 Cell[BoxData[
  ButtonBox["Range",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Range"]], "InlineFormula"],
 " function."
}], "SolutionItem",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"Total", "[", 
        RowBox[{"Divisors", "[", "j", "]"}], "]"}], "\[Equal]", 
       RowBox[{"2", " ", "j"}]}]}], ";", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"n", ",", "m", ",", "2"}], "]"}], ",", "perfectQ"}], 
      "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"2", ",", "10000"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", "28", ",", "496", ",", "8128"}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "This function does not guard against the user supplying \
\[OpenCurlyDoubleQuote]bad\[CloseCurlyDoubleQuote] inputs. For example, if \
the user starts with an odd number, then this version of ",
 Cell[BoxData["PerfectSearch"]],
 " will check every other odd number, and, since it is known that there are \
no odd perfect numbers below at least ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SuperscriptBox["10", "300"], "OsF"], TraditionalForm]]],
 ", none is reported."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"1", ",", "10000"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "You can fix this situation by using the (as yet unproved) assumption that \
there are ",
 StyleBox["no",
  FontSlant->"Italic"],
 " odd perfect numbers. This next version first checks that the first \
argument is an even number."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "PerfectSearch", "]"}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{
    RowBox[{"n_", "?", "EvenQ"}], ",", "m_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"Total", "[", 
        RowBox[{"Divisors", "[", "j", "]"}], "]"}], "\[Equal]", 
       RowBox[{"2", " ", "j"}]}]}], ";", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"n", ",", "m", ",", "2"}], "]"}], ",", "perfectQ"}], 
      "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell["Now, the function only works if the first argument is even.", \
"SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"2", ",", "10000"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", "28", ",", "496", ",", "8128"}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"1", ",", "1000"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"PerfectSearch", "[", 
  RowBox[{"1", ",", "1000"}], "]"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["This function requires a third argument.", "SolutionItem",
 CellTags->"5.5 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "PerfectSearch", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{"n_", ",", "m_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"Total", "[", 
        RowBox[{"Divisors", "[", "j", "]"}], "]"}], "\[Equal]", 
       RowBox[{"k", " ", "j"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"n", ",", "m"}], "]"}], ",", "perfectQ"}], "]"}]}]}], 
   "]"}]}]}], "Input",
 CellTags->"5.5 Solutions"],

Cell[TextData[{
 "The following computation can be quite time consuming and requires a fair \
amount of memory to run to completion. If your computer\[CloseCurlyQuote]s \
resources are limited, you should split up the search intervals into smaller \
units or try running this in parallel. See ",
 "Section",
 " ",
 StyleBox["12.3", "OsF"],
 " for a discussion on how to set up parallel computation."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearch", "[", 
   RowBox[{"1", ",", "2200000", ",", "4"}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"30.77527`7.939746865302272", ",", 
   RowBox[{"{", 
    RowBox[{"30240", ",", "32760", ",", "2178540"}], "}"}]}], "}"}]], "Output",\

 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "We also give a speed boost by using ",
 Cell[BoxData[
  RowBox[{"DivisorSigma", "[", 
   RowBox[{"1", ",", 
    StyleBox["j", "TI"]}], "]"}]]],
 " which gives the sum of the divisors of",
 StyleBox[" j",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearchParallel", "[", 
   RowBox[{"n_", ",", "m_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "perfectQ", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
      RowBox[{
       RowBox[{"DivisorSigma", "[", 
        RowBox[{"1", ",", "j"}], "]"}], "\[Equal]", 
       RowBox[{"k", " ", "j"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DistributeDefinitions", "[", "perfectQ", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallelize", "[", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"n", ",", "m", ",", "2"}], "]"}], ",", "perfectQ"}], "]"}], 
      "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"PerfectSearchParallel", "[", 
   RowBox[{"2", ",", "2200000", ",", "4"}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5.698599`7.207313091035786", ",", 
   RowBox[{"{", 
    RowBox[{"30240", ",", "32760", ",", "2178540"}], "}"}]}], "}"}]], "Output",\

 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Many implementations are possible for ",
 Cell[BoxData["convertToDate"]],
 ". The task is made easier by observing that ",
 Cell[BoxData[
  ButtonBox["DateList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DateList"]], "InlineFormula"],
 " handles this task directly if its argument is a string."
}], "SolutionItem",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateList", "[", "\"\<20120515\>\"", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15", ",", "0", ",", "0", ",", "0.`"}], 
  "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "The string is necessary otherwise ",
 Cell[BoxData[
  ButtonBox["DateList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DateList"]], "InlineFormula"],
 " will interpret the integer as an absolute time (from Jan ",
 StyleBox["1 1900", "OsF"],
 ")."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateList", "[", "20120515", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1900", ",", "8", ",", "21", ",", "21", ",", "1", ",", "55.`"}], 
  "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell["So we need to convert the integer to a string first,", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateList", "[", 
  RowBox[{"ToString", "[", "20120515", "]"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15", ",", "0", ",", "0", ",", "0.`"}], 
  "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell["and then take the first three elements.", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Take", "[", 
  RowBox[{"%", ",", "3"}], "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15"}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell["Here is the function that puts these steps together.", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"convertToDate", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"Take", "[", 
   RowBox[{
    RowBox[{"DateList", "[", 
     RowBox[{"ToString", "[", "n", "]"}], "]"}], ",", "3"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convertToDate", "[", "20120515", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15"}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "With a bit more manual work, you could also do this with ",
 Cell[BoxData[
  ButtonBox["StringTake",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringTake"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"convertToDate2", "[", 
   RowBox[{"n_Integer", "/;", 
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{"IntegerDigits", "[", "n", "]"}], "]"}], "\[Equal]", "8"}]}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"str", "=", 
      RowBox[{"ToString", "[", "n", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"StringTake", "[", 
       RowBox[{"str", ",", "4"}], "]"}], ",", 
      RowBox[{"StringTake", "[", 
       RowBox[{"str", ",", 
        RowBox[{"{", 
         RowBox[{"5", ",", "6"}], "}"}]}], "]"}], ",", 
      RowBox[{"StringTake", "[", 
       RowBox[{"str", ",", 
        RowBox[{"-", "2"}]}], "]"}]}], "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convertToDate2", "[", "20120515", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"2012\"\>", ",", "\<\"05\"\>", ",", "\<\"15\"\>"}], 
  "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "You could avoid working with strings by making use of ",
 Cell[BoxData[
  ButtonBox["FromDigits",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FromDigits"]], "InlineFormula"],
 ". This uses ",
 Cell[BoxData[
  ButtonBox["With",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/With"]], "InlineFormula"],
 " to create a local constant ",
 StyleBox["d", "ExerciseMR"],
 ", as this expression never changes throughout the body of the function."
}], "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"convertToDate3", "[", "num_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"d", "=", 
      RowBox[{"IntegerDigits", "[", "num", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"FromDigits", "[", 
       RowBox[{"Take", "[", 
        RowBox[{"d", ",", "4"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"FromDigits", "[", 
       RowBox[{"Take", "[", 
        RowBox[{"d", ",", 
         RowBox[{"{", 
          RowBox[{"5", ",", "6"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FromDigits", "[", 
       RowBox[{"Take", "[", 
        RowBox[{"d", ",", 
         RowBox[{"{", 
          RowBox[{"7", ",", "8"}], "}"}]}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convertToDate3", "[", "20120515", "]"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2012", ",", "5", ",", "15"}], "}"}]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The computation of zeroing out one or more columns of a matrix can be handled \
with list component assignment. We need to use a local variable here to avoid \
changing the original matrix.\
\>", "SolutionItem",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.45106170938074963`", "0.8919825645043529`", "0.18489664034301168`", 
      "0.14423153274541112`", "0.5686677014331887`"},
     {"0.5751338672485151`", "0.11646568372290544`", "0.19485728441536043`", 
      "0.7153493189690525`", "0.018644665057482523`"},
     {"0.8139322169544576`", "0.05609974180544208`", "0.13638989542802693`", 
      "0.001834245279757285`", "0.4509734368381644`"},
     {"0.1659994544279746`", "0.5853733355456339`", "0.30283828757600273`", 
      "0.06884751188686988`", "0.8048790001298913`"},
     {"0.6395735643141489`", "0.21523850398034505`", "0.14730645078906646`", 
      "0.011669314280793985`", "0.6775637674016868`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell["Here is a rule for zeroing out one column:", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat_", ",", "n_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lmat", "=", "mat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"lmat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "n"}], "]"}], "]"}], "=", "0"}], ";", 
     "\[IndentingNewLine]", "lmat"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell["This next rule is for zeroing out a range of columns:", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat_", ",", 
    RowBox[{"Span", "[", 
     RowBox[{"m_", ",", "n_"}], "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lmat", "=", "mat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"lmat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         RowBox[{"m", ";;", "n"}]}], "]"}], "]"}], "=", "0"}], ";", 
     "\[IndentingNewLine]", "lmat"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell["\<\
We also need a final rule for zeroing out a discrete set of columns whose \
positions are given by a list.\
\>", "SolutionText",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat_", ",", 
    RowBox[{"lis", ":", 
     RowBox[{"{", "__", "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lmat", "=", "mat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"lmat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "lis"}], "]"}], "]"}], "=", "0"}], ";", 
     "\[IndentingNewLine]", "lmat"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat", ",", "3"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.45106170938074963`", "0.8919825645043529`", "0", 
      "0.14423153274541112`", "0.5686677014331887`"},
     {"0.5751338672485151`", "0.11646568372290544`", "0", 
      "0.7153493189690525`", "0.018644665057482523`"},
     {"0.8139322169544576`", "0.05609974180544208`", "0", 
      "0.001834245279757285`", "0.4509734368381644`"},
     {"0.1659994544279746`", "0.5853733355456339`", "0", 
      "0.06884751188686988`", "0.8048790001298913`"},
     {"0.6395735643141489`", "0.21523850398034505`", "0", 
      "0.011669314280793985`", "0.6775637674016868`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"1", ";;", "2"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0.18489664034301168`", "0.14423153274541112`", 
      "0.5686677014331887`"},
     {"0", "0", "0.19485728441536043`", "0.7153493189690525`", 
      "0.018644665057482523`"},
     {"0", "0", "0.13638989542802693`", "0.001834245279757285`", 
      "0.4509734368381644`"},
     {"0", "0", "0.30283828757600273`", "0.06884751188686988`", 
      "0.8048790001298913`"},
     {"0", "0", "0.14730645078906646`", "0.011669314280793985`", 
      "0.6775637674016868`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"zeroColumns", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "5"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"5.5 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0.8919825645043529`", "0", "0.14423153274541112`", "0"},
     {"0", "0.11646568372290544`", "0", "0.7153493189690525`", "0"},
     {"0", "0.05609974180544208`", "0", "0.001834245279757285`", "0"},
     {"0", "0.5853733355456339`", "0", "0.06884751188686988`", "0"},
     {"0", "0.21523850398034505`", "0", "0.011669314280793985`", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pure functions", "ExerciseSubsection"],

Cell["\<\
Write a function to sum the squares of the elements of a numeric list.\
\>", "ExerciseItem",
 CellTags->"5.6 Exercises"],

Cell[TextData[{
 "In Exercise ",
 StyleBox[
 CounterBox["ExerciseItem", "Ex.Pointset diameter"], "OsF"],
 " from Section ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 
 CounterBox["ExerciseItem", "Ex.Pointset diameter"],
 StyleBox[" ", "OsF"],
 "you were asked to create a function to compute the diameter of a set of \
points in ",
 StyleBox["n",
  FontSlant->"Italic"],
 "-dimensional space. Modify that solution by instead using the ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " function and pure functions to find the diameter."
}], "ExerciseItem",
 CellTags->{"i:85", "5.6 Exercises"}],

Cell[TextData[{
 "Rewrite the code from Section ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.Iterating functions"], "OsF"],
 " for finding the next prime after a given integer so that it uses pure \
functions instead of relying upon auxiliary definitions ",
 Cell[BoxData[
  StyleBox["addOne", "ExerciseMR"]]],
 " and ",
 Cell[BoxData[
  StyleBox["CompositeQ", "ExerciseMR"]]],
 "."
}], "ExerciseItem",
 CellTags->"5.6 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["RepUnit", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that generates integers of length ",
 StyleBox["n",
  FontSlant->"Italic"],
 " consisting entirely of ones. For example ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"RepUnit", "[", "7", "]"}], "ExLink"]]],
 " should produce ",
 StyleBox["1111111", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"i:87", "5.6 Exercises", "Ex.Repunit"}],

Cell[CellGroupData[{

Cell["\<\
Given a set of numerical data, extract all those data points that are within \
one standard deviation of the mean of the data.\
\>", "ExerciseItem",
 CellTags->{"i:86", "5.6 Exercises"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", "2500", "}"}]}], "]"}]}], ";"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[TextData[{
 "Write a pure function that moves a random walker from one location on a \
square lattice to one of the four adjoining locations with equal probability. \
For example, starting at ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], "ExLink"]]],
 ", the function should return ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], "ExLink"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "ExLink"]]],
 ", or ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], "ExLink"]]],
 " with equal likelihood. Now, use this pure function with ",
 Cell[BoxData[
  ButtonBox["NestList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestList"]]],
 " to generate the list of step locations for an ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "-step random walk starting at ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->{"5.6 Exercises", "i:156"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Find all words in the dictionary that start with the letter ",
 StyleBox["q",
  FontSlant->"Italic"],
 " and are of length five. Here is the list of words in the dictionary that \
comes with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "."
}], "ExerciseItem",
 CellTags->{"i:89", "5.6 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"RandomSample", "[", 
  RowBox[{"words", ",", "24"}], "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"leafage\"\>", ",", "\<\"uncorrupted\"\>", ",", "\<\"cocci\"\>",
    ",", "\<\"disadvantaged\"\>", ",", "\<\"inflicter\"\>", 
   ",", "\<\"Moira\"\>", ",", "\<\"interpolates\"\>", ",", "\<\"squander\"\>",
    ",", "\<\"archer\"\>", ",", "\<\"tricking\"\>", 
   ",", "\<\"lithosphere\"\>", ",", "\<\"deforested\"\>", 
   ",", "\<\"throb\"\>", ",", "\<\"soapboxes\"\>", ",", "\<\"monopolies\"\>", 
   ",", "\<\"advisedly\"\>", ",", "\<\"silencer\"\>", ",", "\<\"tames\"\>", 
   ",", "\<\"satanists\"\>", ",", "\<\"individuals\"\>", 
   ",", "\<\"snorter\"\>", ",", "\<\"huh\"\>", ",", "\<\"noised\"\>", 
   ",", "\<\"WWW\"\>"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A naive approach to polynomial arithmetic would require three additions and \
six multiplications to carry out the arithmetic in the expression ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"a", " ", 
     SuperscriptBox["x", "3"]}], "+", 
    RowBox[{"b", " ", 
     SuperscriptBox["x", "2"]}], "+", 
    RowBox[{"c", " ", "x"}], "+", "d"}], TraditionalForm]]],
 ". Using Horner\[CloseCurlyQuote]s method for fast polynomial \
multiplication, this expression can be represented as ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "+", 
    RowBox[{"x", "(", 
     RowBox[{"c", "+", 
      RowBox[{"x", "(", 
       RowBox[{"b", "+", 
        RowBox[{"a", " ", "x"}]}], ")"}]}], ")"}]}], TraditionalForm]]],
 ", where there are now half as many multiplications. You can see this using \
the ",
 Cell[BoxData[
  StyleBox["MultiplyCount", "ExLink"]]],
 " function developed in Exercise ",
 StyleBox["8", "OsF"],
 " of Section ",
 StyleBox["4.2", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"i:90", "5.6 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{"a", " ", 
    SuperscriptBox["x", "3"]}], "+", " ", 
   RowBox[{"b", " ", 
    SuperscriptBox["x", "2"]}], "+", 
   RowBox[{"c", " ", "x"}], "+", "d"}], "]"}]], "ExerciseInput", "ExerciseMR",
 
 CellTags->"5.6 Exercises"],

Cell[BoxData["6"], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{"d", "+", 
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"x", " ", 
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"a", " ", "x"}]}], ")"}]}]}], ")"}]}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.6 Exercises"],

Cell[BoxData["3"], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[TextData[{
 "In general, the number of multiplications in an ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "-degree polynomial is given by:"
}], "ExerciseText",
 CellTags->"5.6 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Binomial", "[", 
  RowBox[{
   RowBox[{"n", "+", "1"}], ",", "2"}], "]"}]], "ExerciseInput", "ExerciseMR",
 
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", "n", " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "n"}], ")"}]}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[TextData[{
 "This, of course, grows quadratically with ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", whereas Horner\[CloseCurlyQuote]s method grows linearly. Create a \
function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Horner", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["var", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that gives a representation of a polynomial in Horner form. Here is some \
sample output that your function should generate."
}], "ExerciseText",
 CellTags->"5.6 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Horner", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "x"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{"d", "+", 
  RowBox[{"x", " ", 
   RowBox[{"(", 
    RowBox[{"c", "+", 
     RowBox[{"x", " ", 
      RowBox[{"(", 
       RowBox[{"b", "+", 
        RowBox[{"a", " ", "x"}]}], ")"}]}]}], ")"}]}]}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{"d", "+", 
  RowBox[{"c", " ", "x"}], "+", 
  RowBox[{"b", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"a", " ", 
   SuperscriptBox["x", "3"]}]}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.6 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Graphs that are not too dense are often represented using ",
 StyleBox["adjacency structures",
  FontSlant->"Italic"],
 " which consist of a list for each vertex ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", "i"], TraditionalForm]]],
 " that includes those other vertices that ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", "i"], TraditionalForm]]],
 " is connected to. Create an adjacency structure for any graph, directed or \
undirected. For example, consider the graph ",
 Cell[BoxData[
  StyleBox["gr", "ExLink"]]],
 " below."
}], "ExerciseItem",
 CellTags->{"i:91", "5.6 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr", "=", 
  RowBox[{"RandomGraph", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"8", ",", "12"}], "}"}], ",", 
    RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}]], "Input", \
"ExerciseMR",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8}, {
      Null, {{1, 2}, {1, 6}, {2, 4}, {2, 5}, {3, 7}, {3, 8}, {4, 8}, {5, 3}, {
       6, 5}, {7, 8}, {7, 4}, {8, 5}}}, {
      ImagePadding -> 9, ImageSize -> 121, VertexLabels -> {"Name"}, 
       VertexLabelStyle -> {
         Directive["SR", 8]}}]], Typeset`boxes, Typeset`boxes$s2d = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         TagBox[
          DiskBox[{0., 1.0039609090197665`}, 0.03094077291970046], 
          "DynamicName", BoxID -> "VertexID$1"], 
         InsetBox[
          FormBox[
           StyleBox["1", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$1", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$1"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.0767758380397638`, 1.2299484715469915`}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$2"], 
         InsetBox[
          FormBox[
           StyleBox["2", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$2", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$2"], 
       TagBox[{
         TagBox[
          DiskBox[{2.598381835077717, 0.}, 0.03094077291970046], 
          "DynamicName", BoxID -> "VertexID$3"], 
         InsetBox[
          FormBox[
           StyleBox["3", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$3", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$3"], 
       TagBox[{
         TagBox[
          
          DiskBox[{2.24089690602754, 1.4517131634092493`}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$4"], 
         InsetBox[
          FormBox[
           StyleBox["4", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$4", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$4"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.4766201155216478`, 0.26988412305725706`}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$5"], 
         InsetBox[
          FormBox[
           StyleBox["5", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$5", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$5"], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.3035359141817604, 0.13768106741222552`}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$6"], 
         InsetBox[
          FormBox[
           StyleBox["6", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$6", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$6"], 
       TagBox[{
         TagBox[
          
          DiskBox[{3.098362034142044, 0.8625295971176757}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$7"], 
         InsetBox[
          FormBox[
           StyleBox["7", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$7", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$7"], 
       TagBox[{
         TagBox[
          
          DiskBox[{2.399928973501302, 0.6438346702308033}, 
           0.03094077291970046], "DynamicName", BoxID -> "VertexID$8"], 
         InsetBox[
          FormBox[
           StyleBox["8", 
            Directive["SR", 8], StripOnInput -> False], TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$8", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$8"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}}]}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{16.16, 204.04332525203017`}, {-63.18972525203042, 
       38.15531622883709}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImagePadding->9,
  ImageSize->{140., Automatic}]], "Output",
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[TextData[{
 "Start by creating an adjacency list for any given vertex; that is, a list \
of those vertices to which the given vertex is connected. For example, the \
adjacency list for vertex ",
 StyleBox["8", "OsF"],
 " in the above graph would be:"
}], "ExerciseText",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "4", ",", "5", ",", "7"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 Editable->False,
 Deletable->False,
 CellTags->"5.6 Exercises"],

Cell[TextData[{
 "The adjacency structure is then the list of adjacency lists for every \
vertex in that graph. It is common to prepend each adjacency list with its \
vertex; typically the adjacency structure takes the following form where this \
syntax indicates that vertex ",
 StyleBox["1", "OsF"],
 " is connected to vertices ",
 StyleBox["2", "OsF"],
 " and ",
 StyleBox["6", "OsF"],
 "; vertex ",
 StyleBox["2", "OsF"],
 " is connected to vertices ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["4", "OsF"],
 ", and ",
 StyleBox["5", "OsF"],
 "; and so on."
}], "ExerciseText",
 CellTags->"5.6 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "6", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "7"}], "}"}]}], "}"}]}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 Editable->False,
 Deletable->False,
 CellTags->"5.6 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]]],
 " to compute an exponential moving average of a list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["x", "3"]}], "}"}], "ExLink"]]],
 ". You can check your result against the built-in ",
 Cell[BoxData[
  ButtonBox["ExponentialMovingAverage",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ExponentialMovingAverage"]]],
 "."
}], "ExerciseItem",
 CellTags->"5.6 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExponentialMovingAverage", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["x", "3"]}], "}"}], ",", "\[Alpha]"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->{"i:92", "5.6 Exercises"}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["x", "1"], ",", 
   RowBox[{
    SubscriptBox["x", "1"], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "+", 
       SubscriptBox["x", "2"]}], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox["x", "1"], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "+", 
       SubscriptBox["x", "2"]}], ")"}]}], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SubscriptBox["x", "1"]}], "+", 
          SubscriptBox["x", "2"]}], ")"}]}], "+", 
       SubscriptBox["x", "3"]}], ")"}]}]}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->{"i:92", "5.6 Exercises"}]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "A well-known programming exercise in many languages is to generate Hamming \
numbers, sometimes referred to as ",
 StyleBox["regular numbers",
  FontSlant->"Italic"],
 ". These are numbers that divide powers of ",
 StyleBox["60", "OsF"],
 " (the choice of that number goes back to the Babylonians who used ",
 StyleBox["60", "OsF"],
 " as a number base).",
 " ",
 "Generate a sorted sequence of all Hamming numbers less than ",
 StyleBox["1000", "OsF"],
 ". The key observation is that these numbers have only ",
 StyleBox["2", "OsF"],
 ", ",
 StyleBox["3", "OsF"],
 ", and ",
 StyleBox["5", "OsF"],
 " as prime factors."
}], "ExerciseItem",
 CellTags->{"i:93", "5.6 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["This function adds the squares of the elements in a list.", \
"SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"elementsSquared", "[", "lis_", "]"}], ":=", 
  RowBox[{"Total", "[", 
   SuperscriptBox["lis", "2"], "]"}]}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"elementsSquared", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3", ",", "5", ",", "7", ",", "9"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["165"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["Using a pure function, this becomes:", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Function", "[", 
   RowBox[{"lis", ",", 
    RowBox[{"Total", "[", 
     SuperscriptBox["lis", "2"], "]"}]}], "]"}], "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3", ",", "5", ",", "7", ",", "9"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["165"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["or simply,", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Total", "[", 
    SuperscriptBox["#", "2"], "]"}], "&"}], "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3", ",", "5", ",", "7", ",", "9"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["165"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "To compute the distance between two points, use either ",
 Cell[BoxData[
  ButtonBox["EuclideanDistance",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EuclideanDistance"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9287130764536822`", ",", "0.6057991768286937`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.47909511346163436`", ",", "0.7587710613352299`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.8609381598201837`", ",", "0.23958821235894345`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.5394152707602535`", ",", "0.19719983279804554`"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Norm", "[", 
  RowBox[{
   RowBox[{"pts", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "-", 
   RowBox[{"pts", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.4749281104489389`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EuclideanDistance", "[", 
  RowBox[{
   RowBox[{"pts", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"pts", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.4749281104489389`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["\<\
Now we need the distance between every pair of points. So we first create the \
set of pairs.\
\>", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pairs", "=", 
  RowBox[{"Subsets", "[", 
   RowBox[{"pts", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.9287130764536822`", ",", "0.6057991768286937`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47909511346163436`", ",", "0.7587710613352299`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.9287130764536822`", ",", "0.6057991768286937`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8609381598201837`", ",", "0.23958821235894345`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.9287130764536822`", ",", "0.6057991768286937`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5394152707602535`", ",", "0.19719983279804554`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.47909511346163436`", ",", "0.7587710613352299`"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"0.8609381598201837`", ",", "0.23958821235894345`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.47909511346163436`", ",", "0.7587710613352299`"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"0.5394152707602535`", ",", "0.19719983279804554`"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.8609381598201837`", ",", "0.23958821235894345`"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"0.5394152707602535`", ",", "0.19719983279804554`"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Then we compute the distance between each pair and take the ",
 Cell[BoxData[
  ButtonBox["Max",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Max"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Norm", "[", 
     RowBox[{"#1", "-", "#2"}], "]"}], "&"}], ",", "pairs", ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.4749281104489389`", ",", "0.37242973810175567`", ",", 
   "0.564363540158287`", ",", "0.6444803664375748`", ",", 
   "0.5648015280585673`", ",", "0.32430501524219907`"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Max", "[", "%", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.6444803664375748`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Or, use ",
 Cell[BoxData[
  ButtonBox["Outer",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Outer"]], "InlineFormula"],
 " on the set of points directly, but not the need to get the level correct."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Max", "@", 
  RowBox[{"Outer", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{"#1", "-", "#2"}], "]"}], "&"}], ",", "pts", ",", "pts", ",", 
    "1"}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.6444803664375748`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Now put it all together using a pure function in place of the distance \
function. The ",
 Cell[BoxData["diameter"]],
 " function operates on lists of pairs of numbers, so we need to specify them \
in our pure function as ",
 Cell[BoxData["#1"]],
 " and ",
 Cell[BoxData["#2"]],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"diameter", "[", "lis_", "]"}], ":=", 
  RowBox[{"Max", "[", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Norm", "[", 
       RowBox[{"#1", "-", "#2"}], "]"}], "&"}], ",", 
     RowBox[{"Subsets", "[", 
      RowBox[{"lis", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"diameter", "[", "pts", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.6444803664375748`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["EuclideanDistance",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EuclideanDistance"]], "InlineFormula"],
 " is a bit faster here, but for large datasets, the difference is more \
pronounced."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Max", "[", 
  RowBox[{"Apply", "[", 
   RowBox[{"EuclideanDistance", ",", 
    RowBox[{"Subsets", "[", 
     RowBox[{"pts", ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.6444803664375748`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"1500", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Max", "[", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Norm", "[", 
       RowBox[{"#1", "-", "#2"}], "]"}], "&"}], ",", 
     RowBox[{"Subsets", "[", 
      RowBox[{"pts", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "//", "Timing"}]}], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.860214000000006`", ",", "1.386347116168856`"}], "}"}]], "Output",\

 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Max", "[", 
   RowBox[{"Apply", "[", 
    RowBox[{"EuclideanDistance", ",", 
     RowBox[{"Subsets", "[", 
      RowBox[{"pts", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.6733400000000103`", ",", "1.386347116168856`"}], "}"}]], "Output",\

 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Pure functions are needed to replace both ",
 Cell[BoxData["addOne"]],
 " and ",
 Cell[BoxData["CompositeQ"]],
 ":"
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nextPrime", "[", 
   RowBox[{"n_Integer", "/;", 
    RowBox[{"n", ">", "1"}]}], "]"}], ":=", 
  RowBox[{"NestWhile", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "+", "1"}], "&"}], ",", "n", ",", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"PrimeQ", "[", "#", "]"}], "]"}], "&"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell["Here is a quick check for correctness.", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"nextPrime", "[", 
   SuperscriptBox["2", "123"], "]"}], "\[Equal]", 
  RowBox[{"NextPrime", "[", 
   SuperscriptBox["2", "123"], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["Compare timing with the built-in function.", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"nextPrime", "[", 
    SuperscriptBox["2", "2500"], "]"}], ";"}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.34296799999999905`", ",", "Null"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"NextPrime", "[", 
    SuperscriptBox["2", "2500"], "]"}], ";"}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3214229999999958`", ",", "Null"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["This function is ideally written as an iteration.", "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RepUnit", "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"10", " ", "#"}], "+", "1"}], ")"}], "&"}], ",", "1", ",", 
    RowBox[{"n", "-", "1"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RepUnit", "[", "7", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["1111111"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"RepUnit", "[", "#", "]"}], "&"}], ",", 
   RowBox[{"Range", "[", "12", "]"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "11", ",", "111", ",", "1111", ",", "11111", ",", "111111", ",", 
   "1111111", ",", "11111111", ",", "111111111", ",", "1111111111", ",", 
   "11111111111", ",", "111111111111"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here are some sample data taken from a normal distribution.", \
"SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", "500", "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell["\<\
Quickly visualize the data together with dashed lines drawn one standard \
deviation from the mean.\
\>", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mean", "=", 
   RowBox[{"Mean", "[", "data", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sd", "=", 
   RowBox[{"StandardDeviation", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "data", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"data", ",", "\[IndentingNewLine]", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Dashed", ",", "Red", ",", "\[IndentingNewLine]", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"mean", "+", "sd"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"len", ",", 
           RowBox[{"mean", "+", "sd"}]}], "}"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"mean", "-", "sd"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"len", ",", 
           RowBox[{"mean", "-", "sd"}]}], "}"}]}], "}"}], "]"}]}], "}"}]}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WXlczOv3HyHuFUaLi0pjT6GpbIV6F5W1pj0J075rqmmmpm1wEdcSokQM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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Epilog->{
    Dashing[{Small, Small}], 
    RGBColor[1, 0, 0], 
    LineBox[{{0, 0.9754973003355532}, {500, 0.9754973003355532}}], 
    LineBox[{{0, -0.9610303309219732}, {500, -0.9610303309219732}}]},
  PlotRange->{{0., 500.}, {-3.203762075844196, 2.520808414042038}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["\<\
Select those data elements whose distance to the mean is less than one \
standard deviation.\
\>", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"filtered", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"data", ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"(", 
          RowBox[{"#", "-", "mean"}], ")"}], "]"}], "<", "sd"}], "&"}], 
      ")"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[TextData[{
 "Here is a quick check that we get about the value we might expect (we would \
expect about ",
 StyleBox["68%", "OsF"],
 " for normally distributed data)."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  FractionBox[
   RowBox[{"Length", "[", "filtered", "]"}], 
   RowBox[{"Length", "[", "data", "]"}]], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["0.674`"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"filtered", ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Dashed", ",", "Red", ",", "\[IndentingNewLine]", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"mean", "+", "sd"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"len", ",", 
           RowBox[{"mean", "+", "sd"}]}], "}"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"mean", "-", "sd"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"len", ",", 
           RowBox[{"mean", "-", "sd"}]}], "}"}]}], "}"}], "]"}]}], "}"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WHlczekXvrLOCFlqUHSFtNBUKC3qSbv2tGnRba9bt+7tXqKZdBsTmbFk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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Epilog->{
    Dashing[{Small, Small}], 
    RGBColor[1, 0, 0], 
    LineBox[{{0, 0.9754973003355532}, {500, 0.9754973003355532}}], 
    LineBox[{{0, -0.9610303309219732}, {500, -0.9610303309219732}}]},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Using the list of step increments in the north, south, east, and west \
directions, this ten-step walk starts at the origin. \
\>", "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "0", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#1", "+", 
     RowBox[{"RandomChoice", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}], "]"}]}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", "10"}], "]"}]}], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Except for the initial value, you can get the same result with ",
 Cell[BoxData[
  ButtonBox["Accumulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Accumulate"]], "InlineFormula"],
 " which generates cumulative sums."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "0", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Accumulate", "[", 
  RowBox[{"RandomChoice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", "10"}], "]"}], 
  "]"}]}], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here are the words from the built-in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " dictionary."
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[TextData[{
 "Here are those words that start with the letter ",
 StyleBox["q",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"\"\<q\>\"", "~~", "__"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"RandomSample", "[", 
  RowBox[{"%", ",", "20"}], "]"}]}], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"quadruples\"\>", ",", "\<\"quaffs\"\>", ",", "\<\"quark\"\>", 
   ",", "\<\"quarantining\"\>", ",", "\<\"quahogs\"\>", ",", "\<\"quaff\"\>", 
   ",", "\<\"quickie\"\>", ",", "\<\"quadrupled\"\>", ",", "\<\"quires\"\>", 
   ",", "\<\"quit\"\>", ",", "\<\"quell\"\>", ",", "\<\"quints\"\>", 
   ",", "\<\"quizzes\"\>", ",", "\<\"quadriplegia\"\>", 
   ",", "\<\"quotation\"\>", ",", "\<\"quacking\"\>", ",", "\<\"quilter\"\>", 
   ",", "\<\"queered\"\>", ",", "\<\"quintuple\"\>", 
   ",", "\<\"quarterfinals\"\>"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "And here are those words that start with the letter ",
 StyleBox["q",
  FontSlant->"Italic"],
 " and are of length ",
 StyleBox["5", "OsF"],
 ". Note the need for ",
 Cell[BoxData[
  ButtonBox["StringLength",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringLength"]], "InlineFormula"],
 ", not ",
 Cell[BoxData[
  ButtonBox["Length",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Length"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"DictionaryLookup", "[", 
    RowBox[{"\"\<q\>\"", "~~", "__"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"StringLength", "[", "#", "]"}], "\[Equal]", "5"}], "&"}]}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"quack\"\>", ",", "\<\"quads\"\>", ",", "\<\"quaff\"\>", 
   ",", "\<\"quail\"\>", ",", "\<\"quake\"\>", ",", "\<\"quaky\"\>", 
   ",", "\<\"qualm\"\>", ",", "\<\"quark\"\>", ",", "\<\"quart\"\>", 
   ",", "\<\"quash\"\>", ",", "\<\"quasi\"\>", ",", "\<\"quays\"\>", 
   ",", "\<\"queen\"\>", ",", "\<\"queer\"\>", ",", "\<\"quell\"\>", 
   ",", "\<\"quern\"\>", ",", "\<\"query\"\>", ",", "\<\"quest\"\>", 
   ",", "\<\"queue\"\>", ",", "\<\"quick\"\>", ",", "\<\"quids\"\>", 
   ",", "\<\"quiet\"\>", ",", "\<\"quiff\"\>", ",", "\<\"quill\"\>", 
   ",", "\<\"quilt\"\>", ",", "\<\"quins\"\>", ",", "\<\"quint\"\>", 
   ",", "\<\"quips\"\>", ",", "\<\"quire\"\>", ",", "\<\"quirk\"\>", 
   ",", "\<\"quirt\"\>", ",", "\<\"quite\"\>", ",", "\<\"quits\"\>", 
   ",", "\<\"quoin\"\>", ",", "\<\"quoit\"\>", ",", "\<\"quota\"\>", 
   ",", "\<\"quote\"\>", ",", "\<\"quoth\"\>"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]], "InlineFormula"],
 ", this pure function requires two arguments. The key is to start with an \
initial value of ",
 StyleBox["0", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Horner", "[", 
   RowBox[{"list_List", ",", "var_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"var", " ", "#1"}], "+", "#2"}], "&"}], ",", "0", ",", "list"}],
    "]"}]}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Horner", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", "x"}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"e", "+", 
  RowBox[{"x", " ", 
   RowBox[{"(", 
    RowBox[{"d", "+", 
     RowBox[{"x", " ", 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"x", " ", 
         RowBox[{"(", 
          RowBox[{"b", "+", 
           RowBox[{"a", " ", "x"}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"e", "+", 
  RowBox[{"d", " ", "x"}], "+", 
  RowBox[{"c", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"b", " ", 
   SuperscriptBox["x", "3"]}], "+", 
  RowBox[{"a", " ", 
   SuperscriptBox["x", "4"]}]}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the prototype graph we will work with:", "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "16", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "=", 
  RowBox[{"RandomGraph", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"10", ",", "15"}], "}"}], ",", 
    RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}]}], "Input",\

 CellTags->"5.6 Solutions"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}, {
      Null, {{2, 10}, {2, 3}, {3, 5}, {4, 5}, {4, 1}, {4, 7}, {4, 3}, {5, 
       7}, {5, 8}, {6, 5}, {9, 8}, {9, 6}, {10, 9}, {10, 8}, {10, 4}}}, {
      VertexLabels -> {"Name"}}]], Typeset`boxes, Typeset`boxes$s2d = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         TagBox[
          
          DiskBox[{3.425766382958615, 0.8616061628114692}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$1"], 
         InsetBox[
          FormBox["1", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$1", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$1"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.5246734576259806`, 2.443383919127916}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$2"], 
         InsetBox[
          FormBox["2", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$2", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$2"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.9480154311828861`, 1.6093324781658502`}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$3"], 
         InsetBox[
          FormBox["3", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$3", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$3"], 
       TagBox[{
         TagBox[
          
          DiskBox[{2.231722910700096, 0.9192802922018217}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$4"], 
         InsetBox[
          FormBox["4", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$4", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$4"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.4170516751875386`, 0.5706183816828192}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$5"], 
         InsetBox[
          FormBox["5", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$5", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$5"], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.31069129891061786`, 0.15649560399398854`}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$6"], 
         InsetBox[
          FormBox["6", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$6", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$6"], 
       TagBox[{
         TagBox[
          DiskBox[{2.204511816857064, 0.}, 0.033216905142992845`], 
          "DynamicName", BoxID -> "VertexID$7"], 
         InsetBox[
          FormBox["7", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$7", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$7"], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.5913323090972973, 1.0086777003886587`}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$8"], 
         InsetBox[
          FormBox["8", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$8", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$8"], 
       TagBox[{
         TagBox[
          DiskBox[{0., 1.043245588955872}, 0.033216905142992845`], 
          "DynamicName", BoxID -> "VertexID$9"], 
         InsetBox[
          FormBox["9", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$9", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$9"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.0560939911918834`, 1.5623737545357783`}, 
           0.033216905142992845`], "DynamicName", BoxID -> "VertexID$10"], 
         InsetBox[
          FormBox["10", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$10", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$10"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$9", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}}]}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{9.780000000000001, 
       539.4855579798892}, {-209.9167579798897, 181.22899415958128`}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["And here are its edges and its vertices:", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EdgeList", "[", "gr", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"2", "\[UndirectedEdge]", "10"}], ",", 
   RowBox[{"2", "\[UndirectedEdge]", "3"}], ",", 
   RowBox[{"3", "\[UndirectedEdge]", "5"}], ",", 
   RowBox[{"4", "\[UndirectedEdge]", "5"}], ",", 
   RowBox[{"4", "\[UndirectedEdge]", "1"}], ",", 
   RowBox[{"4", "\[UndirectedEdge]", "7"}], ",", 
   RowBox[{"4", "\[UndirectedEdge]", "3"}], ",", 
   RowBox[{"5", "\[UndirectedEdge]", "7"}], ",", 
   RowBox[{"5", "\[UndirectedEdge]", "8"}], ",", 
   RowBox[{"6", "\[UndirectedEdge]", "5"}], ",", 
   RowBox[{"9", "\[UndirectedEdge]", "8"}], ",", 
   RowBox[{"9", "\[UndirectedEdge]", "6"}], ",", 
   RowBox[{"10", "\[UndirectedEdge]", "9"}], ",", 
   RowBox[{"10", "\[UndirectedEdge]", "8"}], ",", 
   RowBox[{"10", "\[UndirectedEdge]", "4"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VertexList", "[", "gr", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
   ",", "9", ",", "10"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Below are those edges from vertex ",
 StyleBox["3", "OsF"],
 " to any other vertex. In other words, this gives the adjacency list for \
vertex ",
 StyleBox["3", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"u", "=", "3"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"VertexList", "[", "gr", "]"}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"EdgeQ", "[", 
        RowBox[{"gr", ",", 
         RowBox[{"UndirectedEdge", "[", 
          RowBox[{"u", ",", "#"}], "]"}]}], "]"}], "&"}], ")"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "4", ",", "5"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "The case for directed graphs is similar. Here then is a function that \
returns the adjacency list for a given vertex ",
 Cell[BoxData["u"]],
 " in graph ",
 Cell[BoxData["gr"]],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"adjacencyList", "[", 
   RowBox[{"gr_", ",", "u_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"DirectedGraphQ", "[", "gr", "]"}], ",", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"VertexList", "[", "gr", "]"}], ",", 
      RowBox[{
       RowBox[{"EdgeQ", "[", 
        RowBox[{"gr", ",", 
         RowBox[{"DirectedEdge", "[", 
          RowBox[{"u", ",", "#"}], "]"}]}], "]"}], "&"}]}], "]"}], ",", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"VertexList", "[", "gr", "]"}], ",", 
      RowBox[{
       RowBox[{"EdgeQ", "[", 
        RowBox[{"gr", ",", 
         RowBox[{"UndirectedEdge", "[", 
          RowBox[{"u", ",", "#"}], "]"}]}], "]"}], "&"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell["\<\
The adjacency structure is then given by mapping the above function across \
the vertex list.\
\>", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdjacencyStructure", "[", "gr_Graph", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"adjacencyList", "[", 
        RowBox[{"gr", ",", "#"}], "]"}]}], "}"}], "&"}], ",", 
    RowBox[{"VertexList", "[", "gr", "]"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AdjacencyStructure", "[", "gr", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", "4", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "10"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "7", ",", "10"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "9", ",", "10"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "10"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8", ",", "9"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["Check that it works for a directed graph also.", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr2", "=", 
  RowBox[{"Graph", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "\[DirectedEdge]", "2"}], ",", 
      RowBox[{"2", "\[DirectedEdge]", "1"}], ",", 
      RowBox[{"3", "\[DirectedEdge]", "1"}], ",", 
      RowBox[{"3", "\[DirectedEdge]", "2"}], ",", 
      RowBox[{"4", "\[DirectedEdge]", "1"}], ",", 
      RowBox[{"4", "\[DirectedEdge]", "2"}], ",", 
      RowBox[{"4", "\[DirectedEdge]", "4"}]}], "}"}], ",", 
    RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 
      4}, {{{1, 2}, {2, 1}, {3, 1}, {3, 2}, {4, 1}, {4, 2}, {4, 4}}, Null}, {
      VertexLabels -> {"Name"}}]], Typeset`boxes, Typeset`boxes$s2d = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         TagBox[
          
          DiskBox[{0.9533983897463674, 0.8877204662905944}, 
           0.021850666999072288`], "DynamicName", BoxID -> "VertexID$1"], 
         InsetBox[
          FormBox["1", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$1", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$1"], 
       TagBox[{
         TagBox[
          DiskBox[{0.953711093251963, 0.}, 0.021850666999072288`], 
          "DynamicName", BoxID -> "VertexID$2"], 
         InsetBox[
          FormBox["2", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$2", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$2"], 
       TagBox[{
         TagBox[
          DiskBox[{0., 0.4441516790275224}, 0.021850666999072288`], 
          "DynamicName", BoxID -> "VertexID$3"], 
         InsetBox[
          FormBox["3", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$3", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$3"], 
       TagBox[{
         TagBox[
          
          DiskBox[{1.9067921163937833`, 0.4442973209701048}, 
           0.021850666999072288`], "DynamicName", BoxID -> "VertexID$4"], 
         InsetBox[
          FormBox["4", TraditionalForm], 
          Offset[{2, 2}, 
           DynamicLocation["VertexID$4", Automatic, {Right, Top}]], 
          ImageScaled[{0, 0}], BaseStyle -> "Graphics"]}, "DynamicName", 
        BoxID -> "VertexLabelID$4"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       Arrowheads[{{0.03441734055646053, 0.7}}], {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$1", Automatic, Center], {
          0.9862459649982531, 0.7939761701268301}, {0.9939805709161343, 
          0.7700755428983579}, {1.0005571414170036`, 0.745830691257929}, {
          1.0059604660898254`, 0.7212976891363096}, {1.0101780480277054`, 
          0.6965332769039029}, {1.0132001327309634`, 0.671594730140596}, {
          1.0150197306675148`, 0.6465397271677642}, {1.0156326334383878`, 
          0.6214262156488076}, {1.015757714840626, 0.26633802913257004`}, {
          1.0151625049132225`, 0.24122409205051082`}, {1.0133605588998125`, 
          0.21616781337262123`}, {1.0103560443736814`, 0.1912271437127749}, {
          1.0061559102302904`, 0.1664597663022207}, {1.0007698706157462`, 
          0.14192296357876327`}, {0.9942103824597478, 0.11767348470290644`}, {
          0.9864926166649746, 0.0937674143073701}, 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$2", Automatic, Center], {
          0.9208635180000773, 0.0937442961637645}, {0.9131289120821962, 
          0.11764492339223666`}, {0.9065523415813269, 0.1418897750326655}, {
          0.9011490169085051, 0.16642277715428502`}, {0.8969314349706251, 
          0.19118718938669174`}, {0.8939093502673671, 0.2161257361499986}, {
          0.8920897523308157, 0.24118073912283036`}, {0.8914768495599427, 
          0.26629425064178697`}, {0.8913517681577047, 0.6213824371580244}, {
          0.8919469780851083, 0.6464963742400837}, {0.8937489240985182, 
          0.6715526529179733}, {0.8967534386246493, 0.6964933225778196}, {
          0.9009535727680402, 0.7212606999883737}, {0.9063396123825844, 
          0.7457975027118313}, {0.9128991005385829, 0.7700469815876881}, {
          0.9206168663333563, 0.7939530519832244}, 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$1", Automatic, Center]}]}, {
        Arrowheads[0.03441734055646053], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {{
         Arrowheads[0.03441734055646053], 
         ArrowBox[{
           DynamicLocation["VertexID$4", Automatic, Center], {
           1.9068520740455712`, 0.44822393479790273`}, {1.9179467703856041`, 
           0.5181488994664138}, {1.9482008174013454`, 0.5821589425060758}, {
           1.995187496130727, 0.6351197298185011}, {2.055137940075397, 
           0.6727832033918062}, {2.123243441196089, 0.6921283239101557}, {
           2.19404116303642, 0.6916033924963401}, {2.261852322391889, 
           0.6712505146252078}, {2.3212376923662696`, 0.6327022227852832}, {
           2.367433890285129, 0.5790505287895513}, {2.396735455209412, 
           0.5145989092307064}, {2.406792068083192, 0.44451711767058005`}, {
           2.396797074076379, 0.3744265115555389}, {2.367552185484505, 
           0.30994915535959255`}, {2.3214031752764734`, 0.2562568670158364}, {
           2.2620517193997776`, 0.21765637924577458`}, {2.194258480232161, 
           0.1972438905701521}, {2.123461247266794, 0.19665671494258186`}, {
           2.0553387644948398`, 0.21594195053240123`}, {1.9953552304944204`, 
           0.2535527019153577}, {1.9483220075039474`, 0.30647215869543565`}, {
           1.9180116954013406`, 0.37045557803992424`}, {1.9068555262491185`, 
           0.44037076137385417`}, 
           DynamicLocation["VertexID$4", Automatic, Center]}]}}}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{7.540693309010091, 
       531.2393066909899}, {-125.2340656287425, 97.0342961528912}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AdjacencyStructure", "[", "gr2", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", "2", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The key to solving this problem is thinking carefully about the initial \
value for ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#1", "+", 
     RowBox[{"\[Alpha]", 
      RowBox[{"(", 
       RowBox[{"#2", "-", "#1"}], ")"}]}]}], "&"}], ",", 
   SubscriptBox["x", "1"], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["x", "3"]}], "}"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["x", "1"], ",", 
   RowBox[{
    SubscriptBox["x", "1"], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "+", 
       SubscriptBox["x", "2"]}], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox["x", "1"], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "+", 
       SubscriptBox["x", "2"]}], ")"}]}], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["x", "1"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SubscriptBox["x", "1"]}], "+", 
          SubscriptBox["x", "2"]}], ")"}]}], "+", 
       SubscriptBox["x", "3"]}], ")"}]}]}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "If you were defining your own function, you would need to extract the first \
element of the (data) list as the initial value of ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"expMovingAverage", "[", 
   RowBox[{"lis_", ",", "\[Alpha]_"}], "]"}], ":=", 
  RowBox[{"FoldList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "+", 
      RowBox[{"\[Alpha]", 
       RowBox[{"(", 
        RowBox[{"#2", "-", "#1"}], ")"}]}]}], "&"}], ",", 
    RowBox[{"First", "[", "lis", "]"}], ",", 
    RowBox[{"Rest", "[", "lis", "]"}]}], "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expMovingAverage", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", "\[Alpha]"}], 
  "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", 
   RowBox[{"a", "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "a"}], "+", "b"}], ")"}], " ", "\[Alpha]"}]}], ",", 
   RowBox[{"a", "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "a"}], "+", "b"}], ")"}], " ", "\[Alpha]"}], "+", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "a"}], "+", "c", "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "a"}], "+", "b"}], ")"}], " ", "\[Alpha]"}]}], 
      ")"}]}]}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A first, naive implementation will use the fact that the factors are all \
less than ",
 StyleBox["6", "OsF"],
 ". Here are the factors for a single integer."
}], "SolutionItem",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"facs", "=", 
  RowBox[{"FactorInteger", "[", "126", "]"}]}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["This extracts only the prime factors.", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"First", ",", "facs"}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "3", ",", "7"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "In this case, they are not all less than ",
 StyleBox["6", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Max", "[", "%", "]"}], "<", "6"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Putting these pieces together, here are the Hamming numbers less than ",
 StyleBox["1000.", "OsF"]
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", "1000", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Max", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"First", ",", 
        RowBox[{"FactorInteger", "[", "#", "]"}]}], "]"}], "]"}], "<", "6"}], 
    "&"}]}], "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "8", ",", "9", 
   ",", "10", ",", "12", ",", "15", ",", "16", ",", "18", ",", "20", ",", 
   "24", ",", "25", ",", "27", ",", "30", ",", "32", ",", "36", ",", "40", 
   ",", "45", ",", "48", ",", "50", ",", "54", ",", "60", ",", "64", ",", 
   "72", ",", "75", ",", "80", ",", "81", ",", "90", ",", "96", ",", "100", 
   ",", "108", ",", "120", ",", "125", ",", "128", ",", "135", ",", "144", 
   ",", "150", ",", "160", ",", "162", ",", "180", ",", "192", ",", "200", 
   ",", "216", ",", "225", ",", "240", ",", "243", ",", "250", ",", "256", 
   ",", "270", ",", "288", ",", "300", ",", "320", ",", "324", ",", "360", 
   ",", "375", ",", "384", ",", "400", ",", "405", ",", "432", ",", "450", 
   ",", "480", ",", "486", ",", "500", ",", "512", ",", "540", ",", "576", 
   ",", "600", ",", "625", ",", "640", ",", "648", ",", "675", ",", "720", 
   ",", "729", ",", "750", ",", "768", ",", "800", ",", "810", ",", "864", 
   ",", "900", ",", "960", ",", "972", ",", "1000"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "Factoring is slow for large integers and so this implementation does not \
scale well. This finds the ",
 StyleBox["507", "OsF"],
 " Hamming numbers less than ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SuperscriptBox["10", "6"], "OsF"], TraditionalForm]]],
 "."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       SuperscriptBox["10", "6"]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Range", "[", "n", "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"Map", "[", 
           RowBox[{"First", ",", 
            RowBox[{"FactorInteger", "[", "#", "]"}]}], "]"}], "]"}], "<", 
         "6"}], "&"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";"}], "//", 
  "Timing"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.809723000000005`", ",", "Null"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[TextData[{
 "See ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Dijkstra (1981)\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Dijkstra\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Edsger\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"W\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"1981.\", \"OsF\"]\) Hamming's exercise \
in SASL. Report EWD792,\n`1`.", 
         Hyperlink[
         "http://www.cs.utexas.edu/users/EWD/ewd07xx/EWD792.PDF", 
          "http://www.cs.utexas.edu/users/EWD/ewd07xx/EWD792.PDF"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 " for a different implementation that starts with ",
 Cell[BoxData[
  RowBox[{
   StyleBox["h", "ExerciseTI"], "=", 
   RowBox[{"{", "1", "}"}]}]]],
 ", then builds lists ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["2", "OsF"], "h"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["3", "OsF"], "h"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["5", "OsF"], "h"}], TraditionalForm]]],
 ", merges these lists, and iterates."
}], "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingNumberList", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "lim", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lim", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"n", "<", "100"}], ",", 
        RowBox[{"Ceiling", "[", 
         RowBox[{"Log2", "[", "n", "]"}], "]"}], ",", 
        RowBox[{"Ceiling", "[", 
         RowBox[{
          RowBox[{"Log2", "[", 
           FractionBox["n", 
            RowBox[{"2", " ", "3", " ", "5"}]], "]"}], " ", 
          RowBox[{"Log2", "[", "n", "]"}]}], "]"}]}], "]"}]}], ";", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"Take", "[", 
        RowBox[{
         RowBox[{"Union", "@@", 
          RowBox[{"NestList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Union", "@@", 
              RowBox[{"Outer", "[", 
               RowBox[{"Times", ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "3", ",", "5"}], "}"}], ",", "#"}], 
               "]"}]}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "3", ",", "5"}], "}"}], ",", "lim"}], "]"}]}], 
         ",", 
         RowBox[{"n", "-", "1"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}],
    "]"}]}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingNumber", "[", "n_", "]"}], ":=", 
  RowBox[{"Part", "[", 
   RowBox[{
    RowBox[{"HammingNumberList", "[", "n", "]"}], ",", "n"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HammingNumberList", "[", "20", "]"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "8", ",", "9", 
   ",", "10", ",", "12", ",", "15", ",", "16", ",", "18", ",", "20", ",", 
   "24", ",", "25", ",", "27", ",", "30", ",", "32", ",", "36"}], 
  "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingNumber", "[", "1691", "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.12057500000000232`", ",", "2125764000"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],

Cell["This gives the one-millionth Hamming number.", "SolutionText",
 CellTags->"5.6 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingNumber", "[", 
   SuperscriptBox["10", "6"], "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.6 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "15.173410000000004`", ",", 
   "51931278044838873608958984375000000000000000000000000000000000000000000000\
0000000000"}], "}"}]], "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Options and messages", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "In Section ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.Scoping constructs"], "OsF"],
 " we developed a function ",
 Cell[BoxData["switchRows"]],
 " that interchanged two rows in a matrix. Create a message for this function \
that is issued whenever a row index greater than the size of the matrix is \
used as an argument. For example,"
}], "ExerciseItem",
 CellTags->{"Ex.SwitchRows", "5.7 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"5.7 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "5", "1", "8"},
     {"5", "9", "7", "4"},
     {"5", "0", "7", "1"},
     {"4", "2", "3", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.7 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"switchRows", "[", 
  RowBox[{"mat", ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.7 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"switchRows", "::", "badargs"}], "MessageName"], ":", 
  " ", "\<\"The absolute value of the row indices \[NoBreak]\\!\\(5\\)\
\[NoBreak] and \[NoBreak]\\!\\(2\\)\[NoBreak] in \
switchRows[\\!\\(\\*\\nStyleBox[\\\"mat\\\", \
\\\"TI\\\"]\\),{\[NoBreak]\\!\\(5\\)\[NoBreak],\[NoBreak]\\!\\(2\\)\[NoBreak]}\
] must be between 1 and \[NoBreak]\\!\\(4\\)\[NoBreak], the size of the \
matrix.\"\>"}]], "Message", "MSG",
 CellTags->"5.7 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5", ",", "1", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "9", ",", "7", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "0", ",", "7", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2", ",", "3", ",", "0"}], "}"}]}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.7 Exercises"]
}, Closed]],

Cell[TextData[{
 "You should also trap for a row index of ",
 StyleBox["0", "OsF"],
 "."
}], "ExerciseText",
 CellTags->"5.7 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"switchRows", "[", 
  RowBox[{"mat", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.7 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"switchRows", "::", "badargs"}], "MessageName"], ":", 
  " ", "\<\"The absolute value of the row indices \[NoBreak]\\!\\(0\\)\
\[NoBreak] and \[NoBreak]\\!\\(2\\)\[NoBreak] in \
switchRows[\\!\\(\\*\\nStyleBox[\\\"mat\\\", \
\\\"TI\\\"]\\),{\[NoBreak]\\!\\(0\\)\[NoBreak],\[NoBreak]\\!\\(2\\)\[NoBreak]}\
] must be between 1 and \[NoBreak]\\!\\(4\\)\[NoBreak], the size of the \
matrix.\"\>"}]], "Message", "MSG",
 CellTags->"5.7 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5", ",", "1", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "9", ",", "7", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "0", ",", "7", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2", ",", "3", ",", "0"}], "}"}]}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.7 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create an error message for ",
 StyleBox["StemPlot", "ExerciseMR"],
 ", developed in this section, so that an appropriate message is issued if \
the argument is not a list of numbers."
}], "ExerciseItem",
 CellTags->"5.7 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The message will slot in the values of the row indices being passed to the \
function ",
 Cell[BoxData["switchRows"]],
 ", as well as the length of the matrix, that is, the number of matrix rows."
}], "SolutionItem",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"switchRows", "::", "badargs"}], "=", 
   "\"\<The absolute value of the row indices `1` and `2` in \
switchRows[mat,`1`,`2`] must be between 1 and `3`, the size of the \
matrix.\>\""}], ";"}]], "InputOnly",
 CellTags->"5.7 Solutions"],

Cell[TextData[{
 "The message is issued if either of the row indices have absolute value \
greater than the length of the matrix or if either of these indices is equal \
to ",
 StyleBox["0", "OsF"],
 "."
}], "SolutionText",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"switchRows", "[", 
   RowBox[{"mat_", ",", 
    RowBox[{"{", 
     RowBox[{"r1_Integer", ",", "r2_Integer"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"lmat", "=", "mat"}], ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "mat", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", "r1", "]"}], ">", "len"}], "||", 
        RowBox[{
         RowBox[{"Abs", "[", "r2", "]"}], ">", "len"}], "||", 
        RowBox[{
         RowBox[{"r1", " ", "r2"}], "\[Equal]", "0"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"switchRows", "::", "badargs"}], ",", "r1", ",", "r2", ",", 
         "len"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lmat", "[", 
         RowBox[{"[", 
          RowBox[{"{", 
           RowBox[{"r1", ",", "r2"}], "}"}], "]"}], "]"}], "=", 
        RowBox[{"lmat", "[", 
         RowBox[{"[", 
          RowBox[{"{", 
           RowBox[{"r2", ",", "r1"}], "}"}], "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "lmat"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.7 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "8", "5"},
     {"4", "6", "9", "9"},
     {"0", "0", "0", "3"},
     {"2", "7", "0", "8"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"switchRows", "[", 
  RowBox[{"mat", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"switchRows", "::", "badargs"}], "MessageName"], ":", 
  " ", "\<\"The absolute value of the row indices \[NoBreak]\\!\\(0\\)\
\[NoBreak] and \[NoBreak]\\!\\(4\\)\[NoBreak] in switchRows[mat,\[NoBreak]\\!\
\\(0\\)\[NoBreak],\[NoBreak]\\!\\(4\\)\[NoBreak]] must be between 1 and \
\[NoBreak]\\!\\(4\\)\[NoBreak], the size of the matrix.\"\>"}]], "Message", \
"MSG",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "8", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "6", ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "7", ",", "0", ",", "8"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"switchRows", "[", 
  RowBox[{"mat", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"switchRows", "::", "badargs"}], "MessageName"], ":", 
  " ", "\<\"The absolute value of the row indices \[NoBreak]\\!\\(2\\)\
\[NoBreak] and \[NoBreak]\\!\\(8\\)\[NoBreak] in switchRows[mat,\[NoBreak]\\!\
\\(2\\)\[NoBreak],\[NoBreak]\\!\\(8\\)\[NoBreak]] must be between 1 and \
\[NoBreak]\\!\\(4\\)\[NoBreak], the size of the matrix.\"\>"}]], "Message", \
"MSG",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "8", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "6", ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "7", ",", "0", ",", "8"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.7 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
If the first argument is not a list containing numbers, then issue a message.\
\
\>", "SolutionItem",
 CellTags->"5.7 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "a"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"__", "?", "NumericQ"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],

Cell["Here is the message:", "SolutionText",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StemPlot", "::", "badarg"}], "=", 
   "\"\<The first argument to StemPlot must be a list of numbers.\>\""}], 
  ";"}]], "InputOnly",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "StemPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StemPlot", "[", 
   RowBox[{"lis_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"lis", ",", 
      RowBox[{"{", 
       RowBox[{"__", "?", "NumericQ"}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"lis", ",", "opts", ",", 
      RowBox[{"Filling", "\[Rule]", "Axis"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Message", "[", 
     RowBox[{"StemPlot", "::", "badarg"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "InputOnly",
 CellTags->"5.7 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StemPlot", "[", "4", "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StemPlot", "::", "badarg"}], "MessageName"], ":", 
  " ", "\<\"The first argument to StemPlot must be a list of \
numbers.\"\>"}]], "Message", "MSG",
 CellTags->"5.7 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StemPlot", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "c"}], "}"}], "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StemPlot", "::", "badarg"}], "MessageName"], ":", 
  " ", "\<\"The first argument to StemPlot must be a list of \
numbers.\"\>"}]], "Message", "MSG",
 CellTags->"5.7 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StemPlot", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
  "]"}]], "Input",
 CellTags->"5.7 Solutions"],

Cell[BoxData[
 GraphicsBox[
  GraphicsComplexBox[{{1., 1.}, {2., 2.}, {3., 3.}, {4., 4.}, {5., 5.}, {1., 
   0.}, {2., 0.}, {3., 0.}, {4., 0.}, {5., 0.}, {1., 1.}, {2., 2.}, {3., 
   3.}, {4., 4.}, {5., 5.}}, {{{}, {}, {}, {}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], LineBox[{6, 1}], LineBox[{7, 2}], 
      LineBox[{8, 3}], LineBox[{9, 4}], LineBox[{10, 5}]}}, {{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[{11, 12, 13, 14, 15}]}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0, 5.}, {0, 5.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"5.7 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[TextData[{
 "Write a version of the function that computes Hamming distance by using ",
 Cell[BoxData[
  ButtonBox["Count",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Count"]], "InlineFormula"],
 " to find the number of nonidentical pairs of corresponding numbers in two \
binary signals."
}], "ExerciseItem",
 CellTags->{"i:133", "5.8 Exercises"}],

Cell[TextData[{
 "Write an implementation of Hamming distance using the ",
 Cell[BoxData[
  ButtonBox["Total",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Total"]]],
 " function and then compare running times with the other versions discussed \
in this chapter."
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[TextData[{
 "Extend the survivor function developed in this section to a function of two \
arguments, so that ",
 Cell[BoxData[
  RowBox[{
   StyleBox["survivor", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["n", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["m", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " returns the survivor starting from a list of ",
 StyleBox["n",
  FontSlant->"Italic"],
 " people and executing every ",
 StyleBox["m",
  FontSlant->"Italic"],
 "th person."
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["median", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that computes the median of a one-dimensional list. Create one rule for \
the case when ",
 StyleBox["lis",
  FontSlant->"Italic"],
 " has an odd number of elements and another rule for the case when the \
length of ",
 StyleBox["lis",
  FontSlant->"Italic"],
 " is even. In the latter case, the median is given by the average of the \
middle two elements of ",
 StyleBox["lis",
  FontSlant->"Italic"],
 "."
}], "ExerciseItem",
 CellTags->{"5.8 Exercises", "i:154"}],

Cell[CellGroupData[{

Cell["\<\
One of the best ways to learn how to write programs is to practice reading \
code. We list below a number of one-liner function definitions along with a \
very brief explanation of what these user-defined functions do and a typical \
input and output. Deconstruct these programs to see what they do and then \
reconstruct them as compound functions without any pure functions.\
\>", "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell["\<\
Tally the frequencies with which distinct elements appear in a list.\
\>", "ExerciseSubItem",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tally", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"Count", "[", 
         RowBox[{"lis", ",", "#"}], "]"}]}], "}"}], ")"}], "&"}], ",", 
    RowBox[{"Union", "[", "lis", "]"}]}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tally", "[", 
  RowBox[{"{", 
   RowBox[{
   "a", ",", "a", ",", "b", ",", "b", ",", "b", ",", "a", ",", "c", ",", 
    "c"}], "}"}], "]"}]], "ExerciseInput",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "2"}], "}"}]}], "}"}]], "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tally", "[", 
  RowBox[{"{", 
   RowBox[{
   "a", ",", "a", ",", "b", ",", "b", ",", "b", ",", "a", ",", "c", ",", 
    "c"}], "}"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "2"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Divide up a list such that the length of each part is given by the second \
argument.\
\>", "ExerciseSubItem",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"split1", "[", 
   RowBox[{"lis_", ",", "parts_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Inner", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Take", "[", 
         RowBox[{"lis", ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}]}], "]"}], "&"}], ",", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#1", ",", 
          RowBox[{"-", "1"}]}], "]"}], "+", "1"}], ",", 
       RowBox[{"Rest", "[", "#1", "]"}], ",", "List"}], "]"}], "&"}], ")"}], 
   "[", 
   RowBox[{"FoldList", "[", 
    RowBox[{"Plus", ",", "0", ",", "parts"}], "]"}], "]"}]}]], "ExerciseInput",\
 "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"split1", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5", ",", "0", ",", "3"}], "}"}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "9", ",", "10"}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell["\<\
This is the same as the previous program, done in a different way.\
\>", "ExerciseText",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"split2", "[", 
   RowBox[{"lis_", ",", "parts_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Take", "[", 
      RowBox[{"lis", ",", 
       RowBox[{"#1", "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]}], "]"}], "&"}], ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "0", ",", "parts"}], "]"}], ",", "2", ",", "1"}], 
     "]"}]}], "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "In Section ",
 StyleBox["4.2", "OsF"],
 " we created a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["CountChange", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that took a list of coins and, using transformation rules, returned the \
monetary value of that list of coins. Rewrite ",
 Cell[BoxData[
  StyleBox["CountChange", "ExerciseMR"]]],
 " to use a purely functional approach. Consider using ",
 Cell[BoxData[
  ButtonBox["Dot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dot"]], "InlineFormula"],
 ", or ",
 Cell[BoxData[
  ButtonBox["Inner",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Inner"]], "InlineFormula"],
 ", or ",
 Cell[BoxData[
  ButtonBox["Tally",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Tally"]], "InlineFormula"],
 "."
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[TextData[{
 "Write a function that generates a one-dimensional off-lattice, random walk, \
that is, a walk with step positions any real number between ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "1"}], TraditionalForm]], "OsF"],
 " and ",
 StyleBox["1", "OsF"],
 ". Then do the same for two- and three-dimensional off-lattice walks."
}], "ExerciseItem",
 CellTags->{"i:135", "5.8 Exercises"}],

Cell[TextData[{
 "Extend the range of ",
 Cell[BoxData[
  StyleBox["ReplaceElement", "ExLink"]]],
 " developed in this section to accept a list of strings considered as \
nonnumeric matrix entries, each of which should be replaced by a column \
mean."
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Extend the visualization of PPI networks from this section by coloring \
vertices according to the biological process in which they are involved. The \
built-in ",
 Cell[BoxData[
  ButtonBox["ProteinData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ProteinData"]], "InlineFormula"],
 " contains this information, for example:"
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProteinData", "[", 
  RowBox[{"\"\<KLKB1\>\"", ",", "\"\<BiologicalProcesses\>\""}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"BloodCoagulation\"\>", ",", "\<\"Fibrinolysis\"\>", 
   ",", "\<\"InflammatoryResponse\"\>", ",", "\<\"Proteolysis\"\>"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["TruthTable", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["expr", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["vars", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a logical expression such as ",
 StyleBox["A",
  FontSlant->"Italic"],
 "\[And]",
 StyleBox["B",
  FontSlant->"Italic"],
 " and outputs a truth table similar to those in Section ",
 StyleBox["2.3", "OsF"],
 ". You can create a list of truth values using ",
 Cell[BoxData[
  ButtonBox["Tuples",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Tuples"]]],
 ". For example,"
}], "ExerciseItem",
 CellTags->{"Ex.TruthTable", "i:136", "5.8 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tuples", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"True", ",", "False"}], "}"}], ",", "2"}], "]"}]], "ExerciseInput",\
 "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False"}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[TextData[{
 "You will also find it helpful to consider threading rules over the tuples \
using ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]]],
 " or ",
 Cell[BoxData[
  ButtonBox["Thread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Thread"]]],
 "."
}], "ExerciseText",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Given a list of expressions, ",
 StyleBox["lis",
  FontSlant->"Italic"],
 ", create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["NearTo", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["elem", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that returns all elements of ",
 StyleBox["lis",
  FontSlant->"Italic"],
 " that are exactly ",
 StyleBox["n",
  FontSlant->"Italic"],
 " positions away from ",
 StyleBox["elem",
  FontSlant->"Italic"],
 ". For example:"
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"chars", "=", 
  RowBox[{"CharacterRange", "[", 
   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"b\"\>", ",", "\<\"c\"\>", ",", "\<\"d\"\>", 
   ",", "\<\"e\"\>", ",", "\<\"f\"\>", ",", "\<\"g\"\>", ",", "\<\"h\"\>", 
   ",", "\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"k\"\>", ",", "\<\"l\"\>", 
   ",", "\<\"m\"\>", ",", "\<\"n\"\>", ",", "\<\"o\"\>", ",", "\<\"p\"\>", 
   ",", "\<\"q\"\>", ",", "\<\"r\"\>", ",", "\<\"s\"\>", ",", "\<\"t\"\>", 
   ",", "\<\"u\"\>", ",", "\<\"v\"\>", ",", "\<\"w\"\>", ",", "\<\"x\"\>", 
   ",", "\<\"y\"\>", ",", "\<\"z\"\>"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", "3"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "\<\"n\"\>", "}"}], ",", 
   RowBox[{"{", "\<\"t\"\>", "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[TextData[{
 "Write a second rule, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["NearTo", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["elem", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    RowBox[{
     StyleBox["{", "ExLink"], 
     StyleBox["n", "ExerciseTI"], 
     StyleBox["}", "ExLink"]}]}], 
   StyleBox["]", "ExLink"]}]]],
 " that returns all elements in ",
 StyleBox["lis",
  FontSlant->"Italic"],
 " that are within ",
 StyleBox["n",
  FontSlant->"Italic"],
 " positions of ",
 StyleBox["elem",
  FontSlant->"Italic"],
 ". "
}], "ExerciseText",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", 
   RowBox[{"{", "4", "}"}]}], "]"}]], "Input", "ExerciseMR",
 CellTags->"5.8 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"\<\"m\"\>", ",", "\<\"n\"\>", ",", "\<\"o\"\>", ",", "\<\"p\"\>", 
    ",", "\<\"q\"\>", ",", "\<\"r\"\>", ",", "\<\"s\"\>", ",", "\<\"t\"\>", 
    ",", "\<\"u\"\>"}], "}"}], "}"}]], "Output",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[TextData[{
 "Finally, create you own distance function (",
 Cell[BoxData[
  ButtonBox["DistanceFunction",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DistanceFunction"]], "InlineFormula"],
 ") and use it with the built-in ",
 Cell[BoxData[
  ButtonBox["Nearest",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Nearest"]], "InlineFormula"],
 " to do the same computation."
}], "ExerciseText",
 CellTags->{"i:137", "5.8 Exercises"}],

Cell[TextData[{
 "Two useful functions for these tasks are ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Extract",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Extract"]], "InlineFormula"],
 ". ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Extract", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["expr", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["pos", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " returns elements from ",
 StyleBox["expr",
  FontSlant->"Italic"],
 " whose positions ",
 StyleBox["pos",
  FontSlant->"Italic"],
 " are given by ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]], "InlineFormula"],
 "."
}], "ExerciseText",
 CellTags->"5.8 Exercises"]
}, Closed]],

Cell[TextData[{
 "A ",
 StyleBox["Smith number",
  FontSlant->"Italic"],
 " is a composite number such that the sum of its digits is equal to the sum \
of the digits of its prime factors. For example, the prime factorization of \
",
 StyleBox["852", "OsF"],
 " is ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     SuperscriptBox["2", "2"], "\[CenterDot]", 
     SuperscriptBox["3", "1"], "\[CenterDot]", 
     SuperscriptBox["71", "1"]}], "OsF"], TraditionalForm]]],
 ", and so the sum of the digits of its prime factors is ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"2", "+", "2", "+", "3", "+", "7", "+", "1"}], "=", "15"}], 
    "OsF"], TraditionalForm]]],
 " which is equal to the sum of its digits, ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"8", "+", "5", "+", "2"}], "=", "15"}], "OsF"], 
   TraditionalForm]]],
 ". Write a program to find all Smith numbers less than ",
 Cell[BoxData[
  FormBox[
   StyleBox["10000", "OsF"], TraditionalForm]]],
 ". "
}], "ExerciseItem",
 CellTags->"5.8 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["Here are two sample lists.", "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l2", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"5.8 Solutions"],

Cell["First, pair them.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ll", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"l1", ",", "l2"}], "}"}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is the conditional pattern that matches any pair where the two \
elements are ",
 StyleBox["not",
  FontSlant->"Italic"],
 " identical. The Hamming distance is the number of such nonidentical pairs."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"ll", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p_", ",", "q_"}], "}"}], "/;", 
    RowBox[{"p", "\[NotEqual]", "q"}]}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Finally, here is a function that puts this all together.", \
"SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance3", "[", 
   RowBox[{"lis1_List", ",", "lis2_List"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"lis1", ",", "lis2"}], "}"}], "]"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p_", ",", "q_"}], "}"}], "/;", 
     RowBox[{"p", "\[NotEqual]", "q"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HammingDistance3", "[", 
  RowBox[{"l1", ",", "l2"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "The running times of this version of ",
 Cell[BoxData["HammingDistance"]],
 " are quite a bit slower than those where we used bit operators. This is due \
to additional computation (",
 Cell[BoxData[
  ButtonBox["Transpose",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Transpose"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Length",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Length"]], "InlineFormula"],
 ") and the use of pattern matching and comparisons at every step."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance2", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"BitXor", "[", 
    RowBox[{"lis1", ",", "lis2"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"HammingDistance2", "[", 
   RowBox[{"data1", ",", "data2"}], "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.011923999999993384`", ",", "501049"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"HammingDistance3", "[", 
   RowBox[{"data1", ",", "data2"}], "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.718987999999996`", ",", "501049"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["Total",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Total"]], "InlineFormula"],
 ", which simply gives the sum of the elements in a list, Hamming distance \
can be computed as follows:"
}], "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance4", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"lis1", "+", "lis2"}], ",", "2"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[TextData[{
 "Timing tests show that the implementation with ",
 Cell[BoxData[
  ButtonBox["Total",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Total"]], "InlineFormula"],
 " is quite a bit more efficient than the previous versions, although still \
slower than the version that uses bit operators."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance1", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"MapThread", "[", 
     RowBox[{"SameQ", ",", 
      RowBox[{"{", 
       RowBox[{"lis1", ",", "lis2"}], "}"}]}], "]"}], ",", "False"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"Timing", "[", 
        RowBox[{"#", "[", 
         RowBox[{"sig1", ",", "sig2"}], "]"}], "]"}]}], "}"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{
     "HammingDistance1", ",", "HammingDistance2", ",", "HammingDistance3", 
      ",", "HammingDistance4"}], "}"}]}], "]"}], "//", "Grid"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"HammingDistance1", 
     RowBox[{"{", 
      RowBox[{"0.5009409999999974`", ",", "499991"}], "}"}]},
    {"HammingDistance2", 
     RowBox[{"{", 
      RowBox[{"0.0072040000000015425`", ",", "499991"}], "}"}]},
    {"HammingDistance3", 
     RowBox[{"{", 
      RowBox[{"0.6957769999999925`", ",", "499991"}], "}"}]},
    {"HammingDistance4", 
     RowBox[{"{", 
      RowBox[{"0.022210000000001173`", ",", "499991"}], "}"}]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Just one change is needed here: add a second argument to ",
 Cell[BoxData[
  ButtonBox["RotateLeft",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RotateLeft"]], "InlineFormula"],
 " that specifies the number of positions to rotate. We have used ",
 Cell[BoxData[
  ButtonBox["NestList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestList"]], "InlineFormula"],
 " to display the intermediate steps."
}], "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"survivor", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Rest", "[", 
      RowBox[{"RotateLeft", "[", 
       RowBox[{"#", ",", 
        RowBox[{"m", "-", "1"}]}], "]"}], "]"}], "&"}], ",", 
    RowBox[{"Range", "[", "n", "]"}], ",", 
    RowBox[{"n", "-", "1"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"survivor", "[", 
  RowBox[{"11", ",", "3"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", "10", ",", 
     "11", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "7", ",", "8", ",", "9", ",", "10", ",", "11", ",", "1", ",", "2", ",", 
     "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "10", ",", "11", ",", "1", ",", "2", ",", "4", ",", "5", ",", "7", ",", 
     "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2", ",", "4", ",", "5", ",", "7", ",", "8", ",", "10", ",", "11"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8", ",", "10", ",", "11", ",", "2", ",", "4"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "2", ",", "4", ",", "7", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8", ",", "11", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "7", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "7"}], "}"}], ",", 
   RowBox[{"{", "7", "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The median of a list containing an odd number of elements is the middle \
element of the sorted list.\
\>", "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", 
   RowBox[{"lis_List", "/;", 
    RowBox[{"OddQ", "[", 
     RowBox[{"Length", "[", "lis", "]"}], "]"}]}], "]"}], ":=", 
  RowBox[{"Part", "[", 
   RowBox[{
    RowBox[{"Sort", "[", "lis", "]"}], ",", 
    RowBox[{"Ceiling", "[", 
     RowBox[{
      RowBox[{"Length", "[", "lis", "]"}], "/", "2"}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell["\<\
When the list has an even number of elements, take the mean of the middle two.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", 
   RowBox[{"lis_List", "/;", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "lis", "]"}], "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{
       RowBox[{"Length", "[", "lis", "]"}], "/", "2"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Part", "[", 
      RowBox[{
       RowBox[{"Sort", "[", "lis", "]"}], ",", 
       RowBox[{"len", ";;", 
        RowBox[{"len", "+", "1"}]}]}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[TextData[{
 "Check the two cases \[Dash] an even number of elements, and an odd number \
of elements. Then compare with the built-in ",
 Cell[BoxData[
  ButtonBox["Median",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Median"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataE", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"10000", ",", "100000"}], "]"}]}], ";"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataO", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"10000", ",", "100001"}], "]"}]}], ";"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", "dataE", "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019612999999992553`", ",", "4977"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Median", "[", "dataE", "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01871700000000942`", ",", "4977"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", "dataO", "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01951600000001008`", ",", "4962"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Median", "[", "dataO", "]"}], "//", "Timing"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019463000000001784`", ",", "4962"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
The two rules given here should be more careful about the input, using \
pattern matching to insure that these rules only apply to one-dimensional \
lists. The following modifications handle that more robustly.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "median", "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", 
   RowBox[{
    RowBox[{"lis", ":", 
     RowBox[{"{", "__", "}"}]}], "/;", 
    RowBox[{"OddQ", "[", 
     RowBox[{"Length", "[", "lis", "]"}], "]"}]}], "]"}], ":=", 
  RowBox[{"Part", "[", 
   RowBox[{
    RowBox[{"Sort", "[", "lis", "]"}], ",", 
    RowBox[{"Ceiling", "[", 
     RowBox[{
      RowBox[{"Length", "[", "lis", "]"}], "/", "2"}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"median", "[", 
   RowBox[{
    RowBox[{"lis", ":", 
     RowBox[{"{", "__", "}"}]}], "/;", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "lis", "]"}], "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{
       RowBox[{"Length", "[", "lis", "]"}], "/", "2"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Part", "[", 
      RowBox[{
       RowBox[{"Sort", "[", "lis", "]"}], ",", 
       RowBox[{"len", ";;", 
        RowBox[{"len", "+", "1"}]}]}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["", "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[TextData[{
 "The pure function ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"#", ",", 
     RowBox[{"Count", "[", 
      RowBox[{"lis", ",", "#"}], "]"}]}], "}"}], "&"}]]],
 " is replaced with the function ",
 Cell[BoxData["pair"]],
 " below."
}], "SolutionSubItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"frequencies", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "pair", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"pair", "[", "x_", "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"Count", "[", 
         RowBox[{"lis", ",", "x"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Map", "[", 
      RowBox[{"pair", ",", 
       RowBox[{"Union", "[", "lis", "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"frequencies", "[", 
  RowBox[{"{", 
   RowBox[{
   "a", ",", "a", ",", "b", ",", "b", ",", "b", ",", "a", ",", "c", ",", 
    "c"}], "}"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["",
 FontSlant->"Italic"]], "SolutionSubItem",
 CounterAssignments->{{"SolutionSubItem", 1}},
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"split1", "[", 
   RowBox[{"lis_", ",", "parts_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis1", ",", "lis2"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"lis1", "[", 
       RowBox[{"y_", ",", "z_"}], "]"}], ":=", 
      RowBox[{"Take", "[", 
       RowBox[{"lis", ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "z"}], "}"}]}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"lis2", "[", "x_", "]"}], ":=", 
      RowBox[{"Inner", "[", 
       RowBox[{"lis1", ",", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{"x", ",", 
           RowBox[{"-", "1"}]}], "]"}], "+", "1"}], ",", 
        RowBox[{"Rest", "[", "x", "]"}], ",", "List"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"lis2", "[", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "0", ",", "parts"}], "]"}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"split1", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"split2", "[", 
   RowBox[{"lis_", ",", "parts_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "lis1", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"lis1", "[", "x_", "]"}], ":=", 
      RowBox[{"Take", "[", 
       RowBox[{"lis", ",", 
        RowBox[{"x", "+", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}]}], "]"}]}], ";", 
     RowBox[{"Map", "[", 
      RowBox[{"lis1", ",", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"FoldList", "[", 
          RowBox[{"Plus", ",", "0", ",", "parts"}], "]"}], ",", "2", ",", 
         "1"}], "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"split2", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["",
 FontSlant->"Italic"]], "SolutionSubItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"lotto1", "[", 
   RowBox[{"lis_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis1", ",", "lis2", ",", "lis3"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"lis1", "[", "x_", "]"}], ":=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Rest", "[", 
        RowBox[{"MapThread", "[", 
         RowBox[{"Complement", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RotateRight", "[", "x", "]"}], ",", "x"}], "}"}], ",", 
          "1"}], "]"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"lis2", "[", "y_", "]"}], ":=", 
      RowBox[{"Delete", "[", 
       RowBox[{"y", ",", 
        RowBox[{"RandomInteger", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"Length", "[", "y", "]"}]}], "}"}], "]"}]}], "]"}]}], ";", 
     
     RowBox[{
      RowBox[{"lis3", "[", "z_", "]"}], ":=", 
      RowBox[{"NestList", "[", 
       RowBox[{"lis2", ",", "z", ",", "n"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"lis1", "[", 
      RowBox[{"lis3", "[", "lis", "]"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lotto1", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", "5"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "3", ",", "6", ",", "8", ",", "9"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"lotto2", "[", 
   RowBox[{"lis_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Take", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"Sort", "[", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RandomReal", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "lis", "]"}], "}"}]}], "]"}], ",", 
          "lis"}], "}"}], "]"}], "]"}], "]"}], "\[LeftDoubleBracket]", "2", 
     "\[RightDoubleBracket]"}], ",", "n"}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lotto2", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", "5"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "5", ",", "4", ",", "7", ",", "10"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is a list of coins (modify for other currencies).", "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"coins", "=", 
   RowBox[{"{", 
    RowBox[{
    "p", ",", "p", ",", "q", ",", "n", ",", "d", ",", "d", ",", "p", ",", "q",
      ",", "q", ",", "p"}], "}"}]}], ";"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell["First count the occurrences of each.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Count", "[", 
     RowBox[{"coins", ",", "#"}], "]"}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "n", ",", "d", ",", "q"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
Then a dot product of this count vector with a value vector does the trick.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", ".", 
  RowBox[{"{", 
   RowBox[{".01", ",", ".05", ",", ".10", ",", ".25"}], "}"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["1.04`"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CountChange", "[", "lis_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Dot", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Count", "[", 
        RowBox[{"lis", ",", "#"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "n", ",", "d", ",", "q"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{".01", ",", ".05", ",", ".10", ",", ".25"}], "}"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CountChange", "[", "coins", "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["1.04`"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CountChange2", "[", "lis_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Inner", "[", 
   RowBox[{"Times", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Count", "[", 
        RowBox[{"lis", ",", "#"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"p", ",", "n", ",", "d", ",", "q"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{".01", ",", ".05", ",", ".10", ",", ".25"}], "}"}], ",", 
    "Plus"}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CountChange2", "[", "coins", "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["1.04`"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["And here is a rule-based approach.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Tally", "[", "coins", "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"d", "\[Rule]", ".10"}], ",", 
    RowBox[{"n", "\[Rule]", ".05"}], ",", 
    RowBox[{"p", "\[Rule]", ".01"}], ",", 
    RowBox[{"q", "\[Rule]", ".25"}]}], "}"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.01`", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25`", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.05`", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{"Apply", "[", 
   RowBox[{"Times", ",", "%", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["1.04`"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CountChange3", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "freq", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"freq", "=", 
      RowBox[{
       RowBox[{"Tally", "[", "lis", "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p", "\[Rule]", ".01"}], ",", 
         RowBox[{"n", "\[Rule]", ".05"}], ",", 
         RowBox[{"d", "\[Rule]", ".10"}], ",", 
         RowBox[{"q", "\[Rule]", ".25"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Total", "[", 
      RowBox[{"Apply", "[", 
       RowBox[{"Times", ",", "freq", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CountChange3", "[", "coins", "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["1.04`"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The two-dimensional implementation insures steps of unit length by mapping \
the pure function ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Cos", "[", "#", "]"}], ",", 
     RowBox[{"Sin", "[", "#", "]"}]}], "}"}], "&"}]]],
 " over the angles."
}], "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk1DOffLattice", "[", "steps_", "]"}], ":=", 
  RowBox[{"Accumulate", "[", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "steps"}], "]"}], 
   "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk2DOffLattice", "[", "steps_", "]"}], ":=", 
  RowBox[{"Accumulate", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cos", "[", "#", "]"}], ",", 
        RowBox[{"Sin", "[", "#", "]"}]}], "}"}], "&"}], ",", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", "steps"}], "]"}]}], "]"}],
    "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[TextData[{
 "The three-dimensional walk requires two angles, \[Theta] in the interval ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"[", 
    StyleBox[
     RowBox[{"0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "OsF"]}], ")"}]]],
 " and \[Phi] in the interval [",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"-", "1"}], ",", "1"}], "OsF"]]],
 "]. See ",
 "Section",
 " ",
 StyleBox["13.1", "OsF"],
 " for a discussion of the three-dimensional off-lattice walk."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk3DOffLattice", "[", "t_", "]"}], ":=", 
  RowBox[{"Accumulate", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "\[Phi]"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["\[Phi]", "2"]}]]}], ",", 
          RowBox[{
           RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["\[Phi]", "2"]}]]}], ",", "\[Phi]"}], "}"}]}], 
       "]"}], "@@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RandomReal", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"2", " ", "\[Pi]"}]}], "}"}], "]"}], ",", 
        RowBox[{"RandomReal", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"{", "t", "}"}]}], "]"}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell["\<\
With the one-dimensional walk, the vertical axis gives displacement from the \
origin and the horizontal axis shows the number of steps.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{"walk1DOffLattice", "[", "1000", "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw9WnlcjN/bHpUkUQhtGCSRJbKE4pKQbEOLEIb2RaZ9r2mfqZkKSbKUvayh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{197.49999999999807`, Automatic},
  PlotRange->{{0., 1000.}, {-12.54771765136286, 9.952081296682618}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{"walk2DOffLattice", "[", "5000", "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUWnk8lN8Xtu/7vmc39hkzY9dcQkXZVUpKpFLZUqQkRUVlKfoiIVIK2bfI
e1AoEUJIZc2+7/tvfn/N537uvO+595znPM9zPp9X5oy33Vk6GhqaB/w0NP//
Xe2+nRQkP4tdUJqZnPJqxkSeJA8Eiu1ghWbn522wYUyWd6VRf30eozl0QOVp
jxclSKzwaLcqDczn2b3eM/4Le3X05vNT2ttYawVpQP7yAMWPvUDmCusu5sP/
eqPrQx8WRRqqPGi6gLX2f9BxzKqjBOoz4Z3HaODOf+fXU6a6KS7fr/9lurKL
PWPLxNI0h7AphlAHmwJmiNRitrOy78eu665q9/TvYt38+AhL8hhWNYbLFHNf
wNTOnVq6t9aExd1ID97HuYnlaHCcF1+cw9y/Fzww66GF25VhrbHDTZgfm+vM
Yu8ixpArp6c8UYTtvZ6gPr9FA5NZzm/NIwawHO618Euti5iw2bYrpj2H1d54
eebE8W2MYXjJyoh7G1ML4V/74DeJCWrrayilr2MPYvnkm3+2YjJn1dqrKPTg
/t3yYuGRASxfx8arXGYVczr9S4ns1onxJW3x67rTQ8W570cKDy1hiXShfduG
TNDTfuNl3Tgt/LejfNFXlQUY/JP2JdCzwqRRJEHpJgMo2oozix2jg48ZuYft
eWmAiUu0deYWDXCkM7hM9DBD3rfZGKmxRQz3N32PDTV+/KmRNwaptGDIHzK6
u0oDzlV3hdI8WOD3pQzJ+zqMINScOmd5nga6DctaKJGMIM9Aph8UXsF49Bia
5Ui7WNihyHHpc+uY16UnZg2XmcGaJ9ODxnMIu8re7aG/yQJH7h790Mj+k0LI
WRr5NMsE5+QJobHly5SxgrAr/C5MUMW/eby7vpfStN9DvySFHrr55BQP+w9T
vMoyysLSV7F1/PEgzOEHxbhphpwtP4D1ro5Jnp9eoJzYFvs8ID+HnYnOTArv
7aAkDL/zbzizhtHEnBuMG1ygKBHPDFs40QBMqtom4zopfq5+b3ZM1rCvzK4p
E1dmKPh3EU/eedABD2ZSbPW9iHI7pCZ2iWUbY3p9ibcOjVP+PTlvOdQ0jyl6
M1yu2fuXQlPieN3A6hNmJ2QRQ/d9laLqNDzZnF6P6b7M6Ob9TY86jixd2Pu5
DaOndbP+7+Q6ZcNO85rT4CfKO6HVk9vFw5TuvgfmDy36KRLbmVWXszsoNELs
e11XfmEPIIDDX2aE8qMu3smfcwVjqPcbft+yQPn1LWRNZJAWXo9kXgx/v0qx
6KCsj9xbwtzyFjsCCrYpYVeJgjtNXVjz0amZUJ1pSuv+hjs/3f/DSt3rrjpf
6qAcb35IF00/TpHOtk65oPaVcqf1k1yDxxblh4XToEPlIGY3UNXkJU6PGKL9
ywXfNVMKf4ras5YzI/ZKgXvxVfMUj+rZgL8x7EirrfdSzH/jlKlxK93lJXpk
WmzuXiNXi/W+GN+KNaFF3C+X+hajarAV3rQvGuELlP5n7dWT4Z2UlDPY6acl
bZR9jxe7hr37sXst54eP0bViBlKqE31Hf2HeNU1q++YXMY6w5xdrOVawpWTz
SDSyhg2bCqqpemxgTXePf1vdGcRKjQVZ3ZQZofXNbSF98X8YG/FV6Xl5Triq
+7ee7cgYln9hhq7VjAt0HtAcmqTdwkr+tS2HOzJBYF9hteXWNjYgcWVzbJwR
YpHgqzH6Kez0exnGlUNswHNuL82W0CvsMZ750yItL5i+rTcYufIDy0izvvXB
kg+sijK2gG4JM1+7e7BtWhA6d938rqZPYG24z8mnTQUhsH372NXCOorY7Wp2
vgUB2Al9sMp5YYFC2GtDrnLlBf1U1S8sueuUO2x2pyNWBWBrvdj7v7gFilZS
VHEcoxA0PmthLVL7QuEf74iK3hWFyWgWf/uwH5TPElc5nE8LQaqy1fDMkVHK
0ArP3Ky3IGxNcjiu6W5SLiZ8s9uvJwpHH0Y+zMTTIGa6hCtZf8RBNfDRu/uu
SxT/j2dkrKwlQf/bmE9Oayel+I130x0uaeAQ3p7x6/yJGZ3LLy6QkIb3nRHl
MnzDlIzS28jJXgJK6Lq8/Nt7KDrPRR63aIqCa+Lq3rhTcxRPq91Szn8S8EhO
3C6ofZgi7XAhTv2uBNCx6d8XPbJBiczREtCpEQHJehoGyfZdiuXSWu+ddAnw
7qy7lDyzSRmp8ndzz5UEpTelH+/lM6KxPd84GbtEYdclI/n9JDN6nh56PY9R
Ahj+mF97qUuLwg5YVT8likJebsGEiOgqxaaPEjKoKwho1Ds/MXCZ4qTPdNz9
hiAQ5c78XS+jQ4/UPZOcOwRBe9xb1yCfDZ1NEPvkxCUIaydLiga76BAq/Xzf
TIsP5BN57/4I3qB0fPx4e0eYG3oFtEWv0E1TeDD7PnE1ZrhtslsuHTFGKTJU
v9v6kBNqs+6RJ2aXKSX1FTNswAXlslJWL/vpUNDTjvoXW2ywn/XOwz+zrCg6
9ZP9pC4P8Mw5B90VYkCF8XcfLfuyAIfgKC+mxoByfhZ2Py9nhbki9ajpx2uU
hPiHl8Q9uCGzdXAwP2aCEpobyR/XzAtputcy6f7GYTdN+XNLxgRg0u5p9O6d
IUqNisa3Pz9FoFT41ZPpa78oRM3FiYPW4qB4ODU8erIL89rmw12NEAEVCcYi
wX3z2J3tazP2VQKw3Genz7Z3BStUDErU4ReCr66uhK9ZdPDJRzh7kcIH8/8a
PvHZ0cDfHyNmGQcEIJ7bueARmRkOLnio72EShtJexeCnrrTwriDzo/y6KFQe
znzA/4UJfrjZzp0rEINDR03DM99wwSt5tmjjPEno+8XdHLPJCzRHte0fzuyB
6ynRawPHOKHp5MdUNtk98GxIrlDuDiO4p9rA+Tsy4M5DTnFOpofpOb+s8FA5
CBA83vpbgAHaZOrZ3nTJwA+LEI+yEBZwePq1zapRDlT/3Hko6soG0jY1Cmde
ykKUK/Pt3S56mGu6YcGRJg+slVoMbZ4MIKn1rQfvKwcHgx5+4p7dxBz9bFly
W2Wh2xxLOBDDCCGBygsX26VhhBInbTXKAGd+NIjz78oA7m9FodqvLex5sl7D
wJAssOiery+OZwSVphDSPVkZYL5XpygGtJB/n8T3bq8sWODP/2s8xwK+H/Qv
pm3Kwq08l3TiT27weDjyrn6Nep6wX/dDj/JAoy7rGZogBYiMexlxXFsAGhwv
74sOkoPHPdxHlTyodarxa73wQR48zmkdjjbnBYOQ4Qj0WhEUNumGWFR44D9L
43ETfRw41/ry0nqyQ61v8IsULyVwZhG+GH6aF1jD5SRcHZTBzHvtoewrPrC2
1tc8aISDfyZKlak7gnDOWHNWPkcJrgVd2pPSIQoc1kjbN1cBbOgijG9KisFY
v69TD6sSiBebKXaxS8Km9df6wzNKMD3d1HcpQBRehMtJBy8qguKF9RPySxJg
2DfOGP1FEUam9MacAqXhqvKK9cUPODjw6Oyt++t7wPq37NQFFyVQ+P5pzYuN
ykMx/mlX4hWgIURb91C3FMSdXqlgq5CDghMS9cVK0lDD0JPEtFceEj32WkT5
SYCX2TvCJSMFaGJgyOGe2ANNx486/CxThCgpjSfjh2XA8PFNSvAJHPTck/B8
hpMGWbOulWPdinDc1o6Tq0gS2qPusbV+xVExxlq4kCwFRoFObyJtlECs5cKl
vglxaHkp/MCWAQc+DM3vuNVEIDOnOlmOTxl2uDbvNH0WgMTWyooiDlWYlPqW
u4wXgIr5OfZeDmVwURjFlx8UAI8aF3Y1OlU4Ky4e+fY6PyTNjzWZHVEF8Ri5
UbgoDOKEU8yrV5ShXKf5kLiAEKRZb4SuFeKg8WFFd8YpPphs+PvuzIoi6B3w
C79/QgC0rApd46j5i/SLIH0zEAJbV/t0UUdlCCounuXgEAPvZMFOtxRl6NW4
EpEgJAQ2Omcuk74qwR8elt49gQKgZpNVyuGjCBsyAvUvwnmh7n418y17BeBb
Fgv61y0AVk0ejI8bFaElLoU/SpwPvrxo3KyLVoAHqQYdxQOc8EqGd6aWqARb
3uzZofq80Jpjy1BwQQliFANHzt1mA+8b5quETwqQof87lYudG/55CZ3ZOKQE
JPc4+6PjrBBnprZUWISDyZuP3TNTuMHV5YBM47IyLPeSh196sIIzuxvXLL0K
dPbu/zJVyANFGxOp88zKYEAIKOPxZoPSUxlCOBIVf1gRLkKDGQqT5wQlzijA
Idcdrwd/6IHmYuzk67NysHJz+A7TdwZIoa2q9UiVBzbH95p+MuwQVDby+t22
LNQM6N5PqeEG2o9dxlmq8kBnF5lULs4Ps+e5CIV6clDj//wnLl0IeJeKzDX2
y8DunoezqQ+FAV3DEtf69sDQYvIbv2cCYDBRsPdNjDREWAkdVG3igS2ngyf3
JcvAC3M7z+Of2OBndujFS1T+KNS48YvkSQ9dVtq/hl5Lwrlq58p/Y3QQGxDh
X8kvBTtjgYm048vY9+DEY4eNxOCRqGyBzqUNbPdVeA2WLA75229mSioYYH8L
vdNLkiTwdW7P6PNwQP8hiVVasig0nipU6NjPASuZ3IcedojBm0+l+1jWGODT
inaEMKsIvGc6pvg2eAe7jp2yDwoRgw/nR9pbBuaxl3nVK42+4lBscjiKp6AW
K95pNcuaEYZ31iur6VtD2Jdj0eq+58VB6HzXn8gEwPYy09KgcGE4Zha5T+PU
T0xXnO7YYaqfyY+tec0hvIAJHLPxwORE4MNS0rONik1Mlt6YIeixCNx1a6j+
mDqKjfE/E5NKEwC85wVy3cMBLKxzbexzjzB8hcar2YYLWCh/atUbPXFIfnr4
y7jFECZ34Le5b7MwCCXHJGlMz2OTfbG1b8TEwW09XDn1ywDWHbR9ujdVGJLX
DllHs+djDnskRizixEG79rFBAbEJ+1riH2PcIgnz+92M7AvmsK9fpSmTbaKg
/cFtyvX9DBYqinv9MkwSJP9zv2zus4yp8HrPK+dLglcId8z4906ssmJtWlZL
Au54TTAZU+eqk7FSLj+NRSAsQ8rvVeg8xmTIcUpqVggCtT3164zrML8DFmzv
Z0XApsr5h7LJHHaZ7wxRL1UCaILMpzKvr2B/TOiv8C7ugXu3Np5jx3cxz0dF
y//8JOFL0rbjz98LmL7j3g9LKeIw6Pi2STmyHZu5ZtZxo1YY9vb9ldNNG8Be
rr2iDwgRAhrBa3UbO6sYx+KJwMoMPrgtJy1zWWcLc2xjrx57zwmcFl/qXFJo
4J4i00SvNy98dTv6vK6YCerG7uwsxLLDP4lG4z2+1Hny77Hq1iJeqOIrPXuY
mxGel96yygvlh8YOSaRA5AAG1hOR+sbcsFg8MJdAYQP392km48nsMEX+pROZ
xwNPKjV5DD7Sw9A9OfncJW7wm2q33JPFCj/36YXefMIGBQMHXqcPMIJD/Opz
9lYeiLDP6JdR4AS8820TlWA+cPnKPJxexQP3fvOK2fYKwosu7Qtu1/lgySkq
a57qO27dWI5e2BAAN43i6Ox9XEAWc7gUsCMANxwNs97vY4J+0ZuvzuwKgIMl
ye89df/T7XuTar58gA+unZOVYAFPZ6dkhiRe6JIq2XNxhhumi6JSbvzHD936
HdcHtllgJ2nj3IdAPkCHhTTbrWnh7KvDBwaf8oOPgOGR1V0WqoJX5sVZ8cCt
uKDshSROECEreeQX8cPp4J6LGxM8oHUlWi3SlxeM7r7Mfm7ADjkOLJ1sBRxQ
mxCIplWZwPOze1YOGzeU/ho5EsexjX0vzRVX8eeHb46vjZ/JbGBTflVdBmUC
kEZhCIodGcFe+gdgkd081L5NT3RJ+oW9sLI4gKh5tVgS2jHyHqDI0Whyjnmx
QsyTibu0b15idldE/abZOOD7Jt9F9+Oz2IjunRFiPg/kJJPPTiRuYp+lu064
UnlZpuMI7f2Li1iKjV/HvCgLvOBcCb14lBYs3maU+6vRwBP9Y7p5pjTw70bP
1TI+FhjHm5Ux0O1grWJ6Fx7fpgHZQFvvN11r2NrBHH+z/iXMmwYN4lumMJcT
E/0Llwaw0szQx8Rva5h3M7H2zs1F7L3mGq53dhzr+BqgG5VFC0z7xnZvWoxg
KmFm4l3G29gWVr0W8bqVEhC+xGIUP405VBbMrLt/xsI4VkVCQqepvHBMKzln
ATsdZETyY3xGcU79T1gQJjCeNXfFouhmyqWHUrRjuFqKqWSU0MHNVkpKu0zU
tM8kZnHeuGyY7Sd2+4VhldanIowu7MePuNplLHo0xH9kpAR7t+WrXbefDrpS
3FpCu9opBP/Wha+CbNA2aN/6w7efInR+9tqTbha4Yfh3Koh5jaKWNPegvJUe
sM2xg/KGdOh3OE5F4Ts7pL1n8rr2iA5djqv66UbF9/C3nJje4xsUu2zuvcG3
GEF+WPE/VlVG1FeXNp+ZsYU1MR7qES9hQVHaQ/ceCe5iwqLbe5SbaZBajbYL
c8o2xnNYUyLiEwsS1DyzrBhFBzG6700ZimjRh96F+C++y5iZ8VaGkT09smMt
qGh+tI65PHvSnaK5SlEQm1E4dG0Ga2eSl0meGKFEHHl8Yp17FzO1TOe3PTBA
+W/STDGDlRnojO0VVZymKAmiuvWVj6jzher5su/78jHSz5NTCpHMIKYv/7Lz
9hwm3Hb6VtBXRoiJfCh7/mYO9uBdg6HRKXawNWHrcVcYoXxsKmb//IYHYDIE
7/P3DsZIU9WZRBKAdLEeyXr+P9h6fY+p9n4eGPIlsbyYacMIPmc7YzP54OYV
4z7H0/NYZM34id4hPmDyztI/nUMD34pPq79c4oT3Znz2G0foIPXu64tKW6zQ
NhLbwft1BROSPuN/XoQOXhpXtYn4rGO3Mj6kMrWzAveAb1tOwjZ2d545MpCd
B6JKxIQMshYxJ8FjsUvuvHBSU/MSizMt2F1KuSxiIAjlmj/fP0+lh7U7E2ar
psJgJ946wnNjHQsxqIh6eJMfmMs++yu938HaDXT+/k7ngeZdeeL8IgP0BA+d
TGMWgKdtJ7pby2gg/tTQpz0LwtA4LWtg5UQHhdU4R5EBMZA6FefJ3L6OPafw
xR8TloSeNMF79zbGMH5PeS7LYVGobpiqzBRewfzsjcfbjcVh41ic0HPtPmwV
e/f9eLswOBR+zjgdQq3j8TQPiU4xMA9dKDnTuI4Zu08w5R4WAW8Ff+9hIXog
BOpc3/glBLezhek4TFax1kJph7JHQsA2sDp9VO83ppjzcEE5UAz8f/Tc2h/Q
ijWYxwmpMEtCao6U+IGT/ZQLNS70AiOSYLVPQ/Rw8ypF5fKr0Go7aVhkK3YV
LaFFuAfDlYQIaQhjZ5C7+ZYV3UguVyun3wM4rtD9Ms10yP9I7GVzGqqPju9U
rHjMhoYVRoscz0uBAAf/6Po8DwrchN1SZhkIVxwkmb3kQgNTtEuT36VBULHn
dEAuExofYlUspsaXxb5HbHymR2zm8yW9q2IQNbIYkafLimycHFavfZGEquab
czUjXMifsvKZS18MbIKxg7KIHXGPRuVU3BYCvt2E7bsOLMhgNPhCeCUf5K3t
lt6iYUe2MutHCjcF4Rip2EvgKBOae9xEOaIqABcr+yrOBnKiJ8pF2UefCgMd
/nVVtTkremakOfmCWwx6FsiDHg+5kUj7/NnXSBzGbAr9T48xo19uitPOOSKg
el7cjraJFtUeHH4/PSsAo1t3/ZJeM6CInl4czXM+eGKVPy97eItSLuYfxHlI
CAZnsolSBrTo3B67OJlKUajrKWT1c2RE7iH9pv8+CkJDtX/a7CQjorukH6zQ
JwxxRgqlFmY7FK24ODqRMTFoWHlVpT26SMlLZ+Pl/ycFxsPF8eL/Fiiyss/z
Ag6KQy/FxOZa/TrFzH9iNLdMDGJeDaaf6h+i1IZW6QT8FYKkkKP5BSVTFJ0o
g8Pcf8XA/XY+G9f3ScrPWIWs8nZJ0HB9dryyaI1i9PzSa8YKaUiaNo05MzFP
WTAdszyZJgk+/ur+p3JWKLvMV/+JtYvCGGpVvpK4SWnR/tpxZVoQDlh4BFSb
7VIcf0x6P3Lgh7MvhLTOlzOiK6pG/gkqAmAzNmhxqGmT4jUmdOoI9X53kmgJ
gys06POxqv2aWmIwvSXGmHiVmSptC69++YqA55X/GGxNaRD+qPyfXl8x0Dhs
+GqOwIwsJlwq0waE4N9vfMXxDjb0T0Dq2HcufuinZXm0rc6JSjDLtW2qXzh2
HWus3MeILmV7yDzwFgJ/yRj2snNMqCFN6F2LqBDEhX98de80F+ISXo8fei0K
w4RTls+YeRFWPxbE/k4QuqJn9SeP8iItDxMVsRRR+OVU9qF3kRc97fT3C56W
AM4Qo7KxC9zITfsxj/f1PdDekuqf9JUPBV1ND9B6IQO9bFlRR9UEkAFtet2T
KVkQ8sUrPVfkRfPdCWHxxfKgxmQ7t/2WC8lpne63s1MEOYMTC1r5vCi2jObA
C2d5uH/6ref0EA8yLqmXrXFVABXRxsFyBwGEv+wt3BgpB+a3rBQE6/hQVEGE
wDUrBSh/bpcx0M+DXh2p4SUty8GYlwD3tR52VJca6MIcJw+/Y9luBe9lQHb8
wYdE4mXhWdCBRfcP9OjUJ3rLrSh5kMthTVm+RYf6ruQyKePkoFR84Y903Drl
+JYFvkdWASiTs8+S+zcpp3atxQK2FKDx0BZRQoMRdUa/LHnQrACp1vwN1y5v
UGqZkGC/kxLcO3jB1HA/HXJ4UZtDGsdBlbxA4WbkBsX4xjmSL1kJ6hXz85/I
L1Buef3HofNWAW4avFEpNN+i+PS8er8kpwB+4lGLFW/GKU6c1fe/4+VA82S4
4ZzbHOVp3X6lTDd5eH/x0/q01jaFVbvoBheDAogDQf8w3RSl/uAPVzo1BUh+
qHvo7dI2RROGNg4wKsIXkWse9bpMSN+rIYA2QwkunHQVODjLhuxqThhfMlUG
Lu2yEUosN2o9eYrpNnU+N3E+KG6M8aLV3YmWrZOq4FElzROYyo4e+J6Zu7yq
DPIPS/ffG2dExcyHk223lMAmdtRR9TsDCpDWkAvKUwa2a7c4LZhY0UbxIZvO
fCXQPdV8HT1nReq3N9eSWxSo88C/A/ctOdBKHFmE0qIE3dEtc0yJHMi6afnW
nWZlEBlQNu5l4kSPAxdzIypVwZZbd3+xNDf6OZc8oySgCvI1GZ6GscxoWUtN
+7muMryWuBVpn8SAbnRU8/bvVYLZON/9HT2MiOvmCHMfRQHoC7KUa44xoW6/
xRqdJwqwUBrTJriXC1UVVUVdz5AHdX4J/GgWH6JbbDKcapcH2zMi4iGvhJBe
0/iuLnV+1iOXy7b95Ed5x/ufX3FRgEKnMpFOAj8S1tw3rVYsB6dq8rPYLwgi
wY7JW3lxssDXVM7qWi6CDrbwe5Qclwdu29Htglgx1EM3ZpbyQQ44kmPXWD8L
oX1qVx8sCMiCS9ybQ7q3BdCjMIsB6XA50GiPnPy2XxhtmZgKMD6QgTpTT6nr
xcJos1qjjhgqAxdCcvtdi8VRt0/FpdcH5YB4uTndPEwSBYsbV2xJKMCPeZYT
OwPiyJmro0TTSQFku30Ehnv3oObwomqreEXgtuynEG/LoMrGrw4PkuThh7dk
C+6LDDJzOUfzREcR1JmPTiYkSSOuCj/FxEUlqM6/MHs3UQZZVnHlfi5RhvLh
viuej2VRRME5oRNHlSG+JyImPUwe2W3QDZZ/UQGjqU/Oiv8UkITda49uf1XA
v4vsLW5UQtYO4rJu3mow1H2sm8CmiNpcfogV86nDaC5T5Zy8PKpdeL11454q
jEVnKelcUEDc7SmmglQ8xXFc3XfupTwq78LxqgyogFLdJOdPA0UUUf+RpllT
DdIS+0ScMCXEdYfZ1UlVA3pt3arL6HDoiv8OZzETHu4Yfxw0ysMhv2Q51dPb
eKjVuP8br6uMevn2PqnVwMN2talosIcK+vw5kVJzSgPmLr3gL9ZWQXklFlFv
49RA56O1KauDMjoc6Rh8IE4D1Mm6vx2RMhqUF39xgLrv9KbAkM1YGaU/n7Bc
8dOA8Ucn2pwe4lCNiS7eJFcdFNlVKriLFFGa9oPHVT1qEKWuyvmtXx7tDYzJ
VRxTgS9p6J6XkwK6pOO3Wl+qCkHxZ1U2wuTQcwka0wnqfbObS8rtimSQzBWK
zyyfKmz5D/23li+HLKpubWkuqYH2t89vPpySR44WTtm9NGowJ+QYR3khi74u
PIhU5FUDmtHLqtvJ8sj8gEnaYwYNMP+i6vGbUwEVkNLVBNvUYSHY48xVHjm0
4PKWvl1YE+zPut42vSeD+tjjJMuV8VDz3DDN8N8e5Dr44MFBQQIkXuWTOeko
hZojf52UFNQCdaUjifWaUujaS2evudMEwGzs9Z7flUaHzEa2Mt7iwTOy7IyL
oRRS8S9d4zlGgDcc+6wW4qTRJXqT4yevEGCYVdC8UlMSTfbD4wQzLTAbUza7
OCqGCF3W+1LvEOBi582nXdYiiJgelsZ6hgDtMimYyjEBtN/0xtsCVy2Q/3tE
UkZOACUx3vrwxpUIEykqqsskAUTIvmPWQN0XNzPswQsKoHgbyV6/Q0R41d5V
sHGDD43hI4O8DpDAkwO3nI3nR3/wNx5Hk8jgOvpTRr9KANEfWfnkcJoEMvk3
9v1eE0IR3housdFEsHTbqYk4KIpWDiYxWT4jgpTH5AHNg5Lowo/R6i59Iixs
33JvuSONCq3XOWv1SdDJ8bUhO1oapdk1CrB+IILiqjuvkYUsyjQP2ZqhJ8GF
moeuviR5RHNXTfeQBRHOVLF9po1XQK91pxV4RInA7Eo/4PdQCW2+n5W8uEkE
4Tqb+OdBOCTtLjn+oI4EI/6eNycqlFELQ92Fj0wk+CRcHil9GoecbZK3+5uJ
IDTucP2IvQpamknA0VqTYHc89oo3pxpSj6atX7Amgq5Td9OdAVXElv9Z5TsL
CXTuPPSxC1FBRUaikdMRJAjitjqp8xmHSmlG0iKPkOG4lGD6+JoyWrP9L6GR
nQx5XZ0nEwZVkWfXo91PvWQwTGHYsS5RQVZcN5RPv9IGMSua/3rmVNHWatgJ
524y4M195mUU1VFdFiTy/qLGw5Vxn/dRRwGSZmWTX8lA08Vi7/tRDdEyKJe1
J5LhejhH8EK9Cvr6j1EyxlEbfsXoGf/xVEbbN2QLHznqwLG+rhYRH2X0pUFK
kMtZGz6fEAz4MqiMDIf0Xl5PJsOCnw5RIxqHnPpOmrgYaYM059C1S5IqiKAc
7CoRrA3L74ITH6nj0JPPdo5swTog6FPuE6OHQ6avSnfos7UBT359p1VACXlP
XZbRziPDjSrHbRlfJfTG6q9cNY82jEiIDoZZKKPWqYbtF4gMNQMa+e7SOJRY
vqNhdoQE+oXKIdZ2SuiZ3Y2SlTIiTHEFQu4wDhkpCSbHnyBCLFZooVGrggqz
21YOUfGb9OhLMmetGupj2PbwViRB/PZR+0IWDVTAx2rqSSaC/eGrk6YlGiht
5cCGqJ0WaJ2Sr6xL00RaRvbf9u7RgpmugJz9TXikY2QdcFKNAMbSLpmng/Co
rc24VaMZD24O4XVXRTVRKG91vHGTJrxMPMYoRdFAmc8cck2a1CHX8aEQ2VgD
ffDp3uDv0oD5n906+BVNFKLtN6BpiIcOgwSzuRYNtER/3yB1Cw/Xz0YHmgWr
oz8V33kfd+IhrXl51ixAE/25we/w3w8CxL26tsmqq4nEuVoShb5pwTSvbd92
lQYyeWr04Ja9FjCwJLafWFdDMS97Uj5YEeGQZ0h/3gl1NIITJBdS8Xt+Q9Bo
v4gmsm5mNHpgSIJG2aWuf354ZPo4Vd/aiwQu+iaOT2c1UNaPnysrVPymJDfe
OSeqjrKNl1ONA4mQzJGuynlFFf3e7LzMbEmCG+zZGa/i1ZD9uec2V1jJ8NEu
r8qHooq4XzG3ve8kgeXepWcM1HqemPlx7P1ZEvA6juWnBCuho6J1ld/PEeFn
F61ysYESEgwP778hT4SxX3VzucpUPC48srnOTAJn6Q7rOUMc8vFiKLveRgLh
I/9CrwUoo+FZpSfyWtR4K39Lo2xV0dv5gU+DVtT+Pfn+kpmRGnp03LWBfJwI
6d2i679/qCFeswSvD8+1QGNO4Mqssgb6rI50/dIIkLP3Uapwozo65Rvl+y8D
D0X/Tu4381dHPx3YmRsjNGF5uMIm31sDCXxXHXpVowFX9pVOXEpQQwLt1Wdc
f6lBYk8rrlRXHYngR8s85tRBKvT9lOWoBproijxQE6sOw6avgg298ShHKtqw
I4GqbwNSnVx7NJF93FvBUzEa0CCdq111QxNpNNT/qBFSh4n01izME4/s8RtZ
GJ0G9Knb084eJiBmHwF+k98a8MT3EMdFDzw6maVbXGKlDsp5lxMuP9REeRFj
znTx6pBAI79hHqOO7rSMMZ/Q0IQopTDzj85qiOFIq8tTTTyY+5D+HKtRQeVH
m1VETTVhd/RW4fZFNWQX4pnDO6gOAbu/GyQ3VNDETL5uym9NcJOrvgylKuhp
Ps8FFntN+GU2ov37Cw5FN94YPUbAw4vx0w39wkro0xdHjWw8AcJlpgNSFxSR
v9qmsSszAVKGKdcnJ3FoaMsrMEuKAC0C5de/jVPjF8y4ZGxR9w+fR3UTysi8
L6/32oYWjEalyWhkKaPC7TNiZ+O0wHqoazy9XQmxnBqtr9bXggklus9ciwrI
VMVJ7HMqATSlT+w8OCGPnkQ5v1sJ0QJv46xrxXYKaKbfx5mZiq/G4eEGCU1F
9Ew+bFH5LBECCmIPi2ri0C+elgXzt0SoPd7757GxIhoZ47FapOrHTY2aFmcq
34DshbRbBkSot/tzqc1FGSVjqcacAiRw23e17tNhHArY8HC7yUsGnpDGtKuM
OPSBR5nDiLr/UerDjyM2ONTwmZ+tkofKt+nMDH83lVCAEEW/h0sb9IKPJv37
qITcjH7Z/vYhw4aXfSqTqiLyoXNXf2RBBt2QFkkTBRzKelEzbtpIgpr/XNfu
XlJEO4oJPybCyZBLPP3A65MSEj4YeegFlW/P2Dj0Cu9TQjxHygNb08gg2L/J
skNRRKMteOmqEjIE4onp+/fiUIleGu0BfW34/lNPBD1QRHKK7snPL5OhaG7l
5ZdKJcT66TDvsz8koKTJl3i5K6OfEvH4UCEStG41Lf3IUKHiO1CVanJgcG8c
zTK7MnoUG3F8eR8ZFkfdCyLzVNChEy2Toh9JENDi/urjGTW0W8uQEzRNgu79
C0dXL6qg/HI3+R/2JLD/9+eVXzsOsU9rdsAsEXz7r/VrbiqiaKK3Fn0XCXC5
Vc5e4oqIxtaXkz2P2v/7XvZeE8Sh0dePzO2o+sVy8sbyryEcyvZhJtxNJIG8
oH2pQCsOXT4mkD6eSYQjl/6+fauFQ8pzXp2Dz0jAJJExcOsvDimwDN8wuECC
PL3EhoM/VZBdAXdD53sSRPjv2DydwCHzvdvaMaHU+1uNhIYOqqCyV+0Plm+S
wfex/5OuUBX0rMqeGNlBgl82s0p7aZSRNNN2329bMjwlvpcsqFZB+242ykxT
8+lum9dVX4NDJzp+afnlkoCoK+Cn7aOEyiekXlTmEeG/U7nxt4qVUCQ56onT
URIo3Vm3vqmjjBSDa3UKvhChbrSQk+GxErKf97vPdZB6nwdXjPP2K6P4tX3B
sge1YHKG+JjDgKrPZmtMHUFacCxJs+SLqRI6GAChBsHUfmrl92jcUUQrPv1H
e48S4HCOEs6MQQEdk1jhImYTYHPj7xEVaTk0ziR0uvguAVodM55aKsqg45YH
bWep/HfJSIQxQV0a3SV1hL+p1ASOs92Vae2SyNzhICXyNx62Gr5/kaSXQr3K
ioNp16n/31K5sNQtjUKOWvboaGrCq2KW01xte5DQaQH7jWdUfZukCcVH7EHS
FmRhC3s8iCQp3DtVKIPkvr+W0ArQhKwKy7EWKznk+71iypkGD6fPBfGmucog
Y/43HimsGtBY8Yr0gk4GWT9yuiIxqQnu82MRJfkyiIOZgfWFL9VPl/RdzR/Y
g3QZ3/K+LtCEDybCTLw5ElQ9T6cL6VcHjflH7htHpVCcETe/s4E6PJsxvpvG
I4PSXesfEeJUQa6s81ovXhbZ668POF9Vg8H3O9pMZ6XRvbMUDV9GVfjK3Owj
SJ3nPiZNl8owqEMIM4dIwbQM+hZy6/OQjQawLet/jz0vjUK/UsVQGg8cM0vZ
6z/3IImyqc9SmRoQI3/5P19xGfT88tQ5VR9NWPyS8O7qvCwiOk9ZyUeqQ5xl
V/HVJ3LoNSufXkqGKkTRM3ksEeSRAgfTzhFHVTiZ2Wi/riOL2uYrGkZfq8H3
u5vdM+VyiEmlWbXGVBUIoS1r+SoKSC53rj1rTQVMltayT+Pl0HbmzZ6oWTWo
9Smvuhkjh9wbp6SOqKjChZULurm35NHalYDq6KvKcNjCsbsjQgE5mqcIiKQq
QYtiaUIHJo8qhgTlPqgoApu0c73hHkX0U17sOmOrItwUdbZtp8chBoPIIqxV
Hl64XP8UMaZEnYfkNN/Ty8G7t85puAYcyqwe7usvlYPv4XZB9a9V0OFNm/Br
LTKwHFBp7opU0es/m35Cb/eA0NaDo8XzKqjJbUHj8HNp+FGyKPX4ixpq5Jis
KjklBTRH+InqWhqISOfEaK8tDaWCx/wbxzXR5pe2WNFUSXDbDTa/n41HjS3p
iz9zpKHu3jd9dRYC2pu7SZjwlIUC7PnfrnACYrx544y+phy0sJSJm/tpoagq
lYtdRfIQaW9+NaGJgDp2z0hf75SFh0OVFr2KWuh72G7TQXF5+KrhTTrtSkAj
XFijm5gi3B92ZYvwIaCujNpnL8KUYDRUiSu5Eo8+zCw/ecCNg4e95BzaQgLa
Zdfyv86JgzaIkKct1EIX9MefiNQpwp6HJeleMwSU8ikuN+T/32OM+Hs15BKQ
UGRgDwWnBIQHx5j92AiIVu9m/IkmHAz6/W06G4BHJbgnYTIMOKiWet2r60aN
v8Vs4/pXEcK6i0QoZC20J7Fvb5aoAtgadE71ZWshhW2s7aqKHFyweV06NqWF
VvKTPvGrysCjHwuOx/q10N4iE/8DEnLQNp/92keSiK5VcXFFzMrAXfDuSJki
Inz9tYLlLBnofJugrz5BQvqvO64/d5QG0rJJ8J+3ZDR+O2h7ZF0GnLWspt8J
k5H3qTrZSVU58CHezhobJqMNQ+OmCVUFEJyU3rKjrkMlcF7XBZUg6LhroHMi
GcWYOxWHcivDoUq8nSOQ0WRQ2uHDXKpwcUvwzGAbGW3amB4WeqgKJviIhKQe
Eprf++P08l11yKAdfcmSR0LJ53m7bmyowp6cDo9OOzKyUD//m1VRBY4ZxiLc
BzLKY3bzs41QhqWxiVHfehI6lHfkl7iTKky8Yxcf1iIjFB1sGxeiCu5PH518
QSShr11SBIZoZXhb3Lait0xEAfsPW1juUwU71yW7vd5EpN2u/Ibvtip8IpDL
OX210GL3mRRLXXXI3jBy+byohcT7bVi2PmvAVvafFNp4IjIioYQdenVIj/xm
Kc1NQuKcmZ9eqGuAXOf4M6+/JLTFKWD1j0L1U0KdjollZLQk+0o68QIeXGmy
bGwctdFG4eunRxgI8PAYMfdUBBktKHGddl7Dg4NA1phwhDbicjQt++uEhz3v
LN7K2ukgLib5KqNuDWiR6ovjLNBBeuOrbPeD1KGdIXGHb0Ub7c25XGPloQkr
3nvuWxnpoEcjqTfTUtXhL0toKU2RDuo7EjAh668Ou5lvY6eLtJF3iG3NnJ8m
4ApzD3l+1kaxJT4MTnYaQIr8SLs8T0ZVeowdI4XqYFJhPqs3oo1eG7ZCW5Eq
3HtocTBuSRuNTBxeKHVSga9GOxX61PMwuPYcPmWmCn9f/6HcjtNFjzhvDaQ5
qMCZZInRmEId5Plzhn80VRWStG8HnJrVRjeTT3gtJ6mD3rfbw318OshpsJNP
wlAN3NDDl57HtFFSeO/V/Ah1iLLckiA/I6M3+GtPRodUQenfSWcHJW2Ecw//
F56nDuWvPhbdLyWjv4XY0u08Dfi7Iurd3k1Cfy7Wq3bMqcGVB2EPFxzJaJaY
33txVgOScnKCN0zIqO2ew+YfZXXwkfZ8WFtBRikK8i+Jmapw6oLMD0l+MnJu
00x6waQGirNNxT5c2uh02qEct/fqELi0Yiieoo3we18cMcWpgcuwpei/fTqI
z2fRMU9LBTI+q+3fH6CDUmm++ydR9cfQI+27KV4Xxe/b9N0bqgZB2Wn56LAO
elybvTIcpAGMHaLh3Ao6qM4/zQc/pAaXk0sTSJHa6KeAwszsI3XgfCKhk5dA
Rhq951Yu56lCRRnXirUhGenfDrTJG1aD1Qyzi0dYtNHCj2EegWENSOnwJTYJ
aKPJKuv1D4fwYKGUFvs3URs5ujFwrQbiwdFYuJnxmQ66ab3CVaqoCS6Ztvg2
eR30rs5L+4AXHvzZWRmk07TRc8qMoh4Vn6UltqkvW8mI0L/4N6wOD73Y0I15
an5ZRQ+pBPTjQVC2sCG+l4jenzyuU3SHAN58x7mjBIho5+6lB+ENBJC3GPST
YSehy3LzlKVWPBCMO602rUmoa82Yd6hQEwyvOUklcZHQszEkeeGXBvC6G98+
rUhEWpz5XS6eeIjdpJBjrIlobuSU+qIcAbo1Xf8b3SWimevJi5efE+CIRD6P
zSAJZX9dS6ChruXN2HE2g0RU/LVE3b0ID2ZfBQNPUuPJOhv2aL4lQCW92sGp
ZyTk9cTLfZ+CFrhSDGy7r5HR8RTLLzrKBLgYce8WowUZMQ+v/Dv5Cw9DFVJn
FY6QUPttE/m2agJc4mI0eNlEvf8Lv77hDQL87eG80NBOREwnRTbjqPNNC6ue
mudfIqrMfx27naoFJltDsT0tJMTbn0xn40iE3jc5RrJiJCSarXna3ZwI1yaN
MmPFiChacUf37DktEBr7tX4ogYgydeUidclasBh/nt30hRaqPqtW2XmVALoG
CgF7FwlozjpXqNpECxSbEy2LHmkhubpW5ZuPtEAg6pxfTygRjfT5jn6g+smh
Pp6G4kgtNJPCY/bJngDigs/wH/ZpoU210K1ntVQ8zNOuxwlR43ER7enzCeDe
ox5md42IvniIWPBIa0Es7UCmQowW8m3x+d7SrAXuMiv7ZTsIiLO8hsb6hRY8
V1H3C/muhaasYlfYbxDhuoJtpje1XlnMy/rlO1oQ+YOLR1eThM78d5b4MZO6
rvDT1aAQ0cHfS9oie4ngY+bkP8ZBQqvhrQNTRBJ4FZo/CfxMRHm6wt+0Bcjw
SO+l0CAiITrXEJ/FJKq/j3G3OipLRj9eT0haJJFBjvbJiUVuMpLTn+P6TPXj
cXd0R3ZzSegzm4vtk34SsJmx3BvLIiNpk0aLs2NE+K0lIl82SkYSsUwKwvtI
8O6NWI3tGglZbgevlrsSwZqwmzB0i4QYl8JjCIlaoCn6xY5JioyiOeJfJNYQ
4LyVyQQP9X3Tfu8+yZZoQaFxvfz6ChnhfqSdy/tAgGQ/06fLNWR0NvjxqZ8f
8JDzb0uYkcov7QJaAXYceKgk33Kx8ddGLP9FnVKoxwP3IffWs9T+m5O9lTbW
hIffv7IuXpPXRnyCntXBfARQHqz974wGGYmuH9P8fY7qx2WOjkZ4k9CXnv4d
GkMC4NJNyjt2SKgi+wf9PYQH6YdzV+aoeOv2sNtjKq0JTDLrPwMfUPU79tLV
8Wg8qJyHzM5gar5OHZ0ciyaAffJgxN9bZMQvHZ7a0o2HNatXM40EbbRPfhI3
bIEH3rvcQj1MOohxtG6PC5VfncfKJ2uP6KAHp/amJe5Vh4POkfGqmdqowSFO
f0VEDfKijgQNXtNBuPmzHfUXVOB8jXzIzyltdOansNuv+zgIX5JvsaTy5a9s
yxOUk1R9qJ3JjHxL5c97XFrvT+FgJ0va9kWMDtrirZw546ICak2dlc3pOuhW
TZK19EMVOLlKudiYoY3GhFLe1LIqw2rEF2fHQzpo3vP8oSfvleHyzdD7y07a
iGHRrulCpRLsZ/F5tymtjZ7dG43quqkE4tvJK/+o+LleXnzwsqUy/Bfm05Aa
Q0Yrmo8PL1kqgXBOwTRtONU/eN5/tEugPp/Ql5Ubpo2srJpGtjWV4Vn1hDur
lzZSpcjdS/ykBP8pCV49LauDPmUcyF97pAR7NXZu9Unrolk1i8CtC4rQPIyL
DFnURcJXkve4CimCVHf8X+45PYTeM0l+VFSAipgRfYt2fZQQp1z/Q0cRbhS/
hOp1PSTx6JetoKM8lH37WeX3Sg9F0xWXJ0zLA06TNudHgj7i/fHnnW6bIpDZ
Szd+T+mjwu7372NUcCBylCX+91sDxDXUtRBP9ffHb+VLPHljgIbGTLD7W0pw
526R4VUjA1Qb8F+XX68yuPEIaB5KNEA6mnFHjYZU4GI3PRehWh996BSdr5hR
hRaPQ/2jQ3pIar97Xe6cMpC9sj8YbeghBevE2KlaZfh2pzxMZ10fyWXJ/vB3
VgGueEjynjZAYczH8RdacVCc7mBAsDRAe3mcmtOtlGEl7i67iL0+Ulk9qLdq
oQJZwgqPj/rroe9n5fbKjlP9YXP7YOdvXZRWoc88JqECeVuWsVmXdVEp22Kh
7j4cJARZp/1o0UX2fNp3rgurQJTKorSLth4K/9P00pJBDZpN+n4tzemiDluZ
35d31YHDPbq8ulkXBf70vA/p6pCbQlQM+6KHbLsU79eUq0FhlYuvTq4+OmLr
CcX1KpApQhP+21cfqV09TWh8rQyBafmT6il6KMbAJdv9Ew5y9tMeb7qrj0Q/
xq8L8qqA1ZUCpTPmBshc+HZTx3Xq+e9bcnFsUfMdd8DYOpHqT3/+m7zkYIjS
02QyGvKUAM6kLnqyGiLdWZNB8QIFILaI/dtcMUBrZVu/+TvloP+5+ISRoyHK
uPuY8eyyDKgcv+ZQuWmAnudK9pyul4XUx5vKzHwGaJLj7W0WBRm4OOfoWBms
j3z33mhnDZOGu1z46LJIPWRRYNp5V1sGss9HjGYF6aMgNkbW2GppSG0t44u4
YoBsIlpoXj+XBP9e3Z6YAgPUzvxP/zW9OLwtmT32fkYfvReQFehsFoOgqtp6
+xkD5NUl+faejjAUuJ27lnjKEO39b7ClNEUYmNq3OEdPG6CqR9b44peicMdb
VSqdmp8vMemp1xzEgHa7xjvmvh560jj95FKGJOgSmA/6Ceuj6hDmZFpGMSCd
bjzv+k4PDTVYiAQ7CcE3zJ4j2lQPNdx5xtG/I0qdtz/f7c7VQ+3DbvvhnziY
CnurT0Xpo69nj9u/YZSEqiwTh+wwA5SjWWBmeVQa9n0p++MiaYAUsyrvfM+W
hqvrCxMD0vqIqWsZXqpJAaGINk7jIxXfZ6wSRmX2gJ/oIav0T3poP6/1uRZV
SeDtyDkQPqKL1vNqbeYMRIGseULEpFwXqX5xaFg6KASe6k1xQWf1UGjxzfy1
OCHws83PVvHQRWsObUQHT0FA5vYZrCf00KCei0hxjSD4dHtnrp3QRWZ/HE57
OAiA+7nLT6Ut9RAtTQkhWF8EhA0/MBwP00N3G7UVvtILQ0zf6u0Dgfrob4Kx
ntR7McA9/lz55Y8+svb8Xs3uKAl7MFoJhT36aG/Md4U4RUlIEQtLHJAyQH5a
T4RV9PZApt35353rBsjE/9a0rpk4kJcdye/aDVDfuXIFbUUpGCNfTpmRNkCH
TvrPi9iLwUC0M8dapz4aznQ3cMmSAP53jTlMTPro+WBXR8B1MZDo2ycQrqmH
xMoKfmcnCEGhTQhnC7W/PtZEWH55JQrKEmWe6xa6yDdV882qmyScuXFN8eg8
1U+a/P584oIo9DsWKz1l10WJrF37ta4Lgns45lHxRwfduCl16kMxL+y8MHhR
8kAHvVwSEr16lQfK70nXLdzQRe1CZve6RvmhdkB/rntbF0k+WzSTfskP3JeY
Qgy39dAH63/Cn98JwNROizgNkx4qEWfY+uvLC76GmL6tly5iMfCQcaE+31Z1
YtPjlQ5acrePQNsC8I2DtaIpSRcVb7g/uPiNHzqy3CLx0XpILfXiNS5PHpgw
Jk2UUd9nV3/DILGSF57OzH1gEtRFUj7E+X92HCBMd68s+6UOOgNDhS6yzPC1
+2FWiLsuMjW5u7mTxgaX39WSGi2o9XyVNO9nwQqi6S6ebla66MxSUqt5Oy3o
/U7nKV3QQT72Yn/ZwxnARz7nYimtDpq8UGUUU00D+WaTPy4M6SDZx+pSnioL
2LQ2l7+Qui6qsA55fvL4NqZdvBbMS9XX4gcuzhYPmIDzeqZ5oZkOWjkm0dDd
xwHF43ZjeoM6CAnd9pTd5QK9j0XnFrt1kefVAlZyBDdIkSUPuXTroSPCJlFO
WbyQWp9EqFrRRYfK+It0fXjB0ycs22lFD01fZpQYd+AEPf/S6HYjPZQgL1Xf
0M0Nd+QJac3UervY41i/ZPNDWluVtuUrXcQ6EW2pzMcDKxz2o2UkXcTw5wz2
L4YHeHiffc/T1kEDoUD14PxgLVJAMzytg8TyWSc8uHhhzUj+oRqmi7wqerRp
BPhgKV9yNLdUD2nPL3bK8AtCp2PrkhinHqrNLi+X4ReFNpanX35zUOvvdlPc
LVkEHlQ+eSvHro+Yw4IXGTxFYO3YimMHmwG6oiWcXW4rAVfbZpRNTQzQ8reD
QVHnRGCZZc/HnmsGCL9EKzAWKQDX35dVPqgwQDTnjsQffMYDH/tjzif8pfJH
zVy/9ElOsI1MuxKyo4/Sr78tWsjmherD5495Oegj18ijGn1VHJDB37nBQOUP
wh8ffF8VA4zvBbf1Oj301FxQ/PMrDjjvP1GxZ5LKXzHVGd2DzCB+aqp2tlwf
pd18nBe1nxX0aEJu91TpIestdq2a5zzAaCdW1NmnhxZTzp/4GS8AYwFnM6zW
9BC/wV2/Y2ECEDt/ns9sTR8FfH2Rom8lBCy5T83RbwNUbzgFkUxCoL+EeAd+
6yN5+i+SQol8UMt2ubnb1QB5+7i2pcgJgOu9UbKglSG6K1RfrcjHD1q/Xs03
mhoh3rlZJfpAPqCbcn1btN8QZQU5OsUI8IDP1eEkTkEj9F5hKeFUFxtMfAvb
t0TVJyUtM5rNT9xw0yn3kfsjA7T/5vb7N6u8gH/ldHPJwxDx6uweHHDiAmWL
rJ3UPAOU7nvy2NIJJsA/y16RrzRASYFpJvH+dHDwyaP4hCRD5H5rxTkjnx5y
Brny3r4wQJdGL/jfv8EOl8k3P310M0CL64o1T6PpwfKXlf71+wZIPvsWaSeK
HVZVFryePTZAznb7w1p7eeCBd1qfOcEQReK23zhl8YDqkNqtZwQDlDt33NVP
kx+KW5e8NS7qo9tJS+58qfwgwiSwWXxJD8V9KczUoecF9sKoksx3uqhINjDE
pogf2HgMlbipeDW8kTir/JEb/AMrpb0ydJB8MnnuETcb/FxgrK47qosirqlv
jJ9lgmmMNVPVXwet5fHHE24zgSm5iqLor4uOc3Tlvurcxfhvza8VU/vzJ+Vs
zjp+A4tynkzELWoje5emBI+Dy9j/KDTzeCi/L47bIvu+7/u+z4yZMcuZRSmS
ZKssReFLlnZLsoVEKCESShFFSJHIlRJpo6xJEaVChLKl3/P783nd597n3nM+
95zPe17za9Obi1H/8MDy4Lnay55viQ391Z/EiYfbVcXdCn5TLaNeyS6uC3j4
pD0cIVu/1GJrkjy03xLjCz5eucG/Ey1bLvRpqNTjoVHBoMv/xVjL2pw7+UAD
Dp407+63MV1skQk6fgkwHs8Qwu/h7p5q4fnIecVd0xJkSDnPHLPXWs48cKZK
5VuC4XbqjFAaNxKm8eNl9+Dg0s928ULvPy2Tnz2VjxviwOP3UFxx9FJL+jZx
KRkjSyCvFLmX5o62UCGoY8TTElJu8H0ve7rUUsh+YfM9yBJqn47q7ur43pL3
Z8vbIVWMz/x7PuGCh1tO6HKmbRbEA1H76pAI/Q79fn3JafwkHjoJdz6kRLa1
/GuSqXIaI8C1Hd1TPTBOj5R8O/6YRQDfuDj58Lpf9G3Xzx59r2gFw7qdY1XV
T+kNvgfdhDQxXmGbtDzh/0EXpSTcefPRCqpNTR+pfG+hH2mmWlibYH49uLkk
cWiObhNcqe0oZAUFcDv52aFlenrHa6VbWL6F5ruWHLvn6Hk/rzwtwsa9lj+3
DNkO0U3WObRSXAkQEC5wot1ikT69SGzpnMGDIommsvf6Mv1xA0ViGOPJ/QIx
WVex/ZrNtgV5NOLAqUc47VLkMt3QiePs5sM40NmPvC8f4gJqbHb380eWUFP1
NOHMD14Qpt5XKvxuATIXI9eZ9iIw9Ie9eGmbJch27UlrXuSDlbRi6dffLOG6
XNFunlIusAzbdo9WjoNTiVsct33khBdPPH8eqbAEd7dwOucfLghXYXEP3bYA
rmf73ukf/U2Pp1XfGwmyAGa3y2atmU/0N++OqWpMWsAtkfFg2q/P9P3X/d/b
fDOH4ZKe1r17n7QIJOZPVJyxAG/dDxFDD8fpYo6h9q9ULcExuS9qWaSrJX8k
cMdogQUIvTl1Km3zfMvdfUns9w8soDKCpyxjcK4lDr1V622wBJ73g97H1dZb
To6FhlRIWYJWudHPVzyzLRVT1QaTly0gYKQi0uf3v5Zs8TjNQ0kWUGrp6uag
tQEV7xw8KrLVEnLcTcvfHxBEQ93PpmIqLCAk8Ine+3Rh1DGaCVx15nDxEu9N
vTYJJPIp0s+jyxyenpulnq2SQlyqsdOLtywgI8380GljaWT5aFB1rdwSJCp+
KXpQ5VD2wOuc+w44+NWtkOh9WhpJJaz7G2RZwsB4la/aQTmU0OH/RY2Fgy1i
tb+9++VQ0uUNJxoYePC+fD9Y7okSipbOq9I/god9PY9L8tzV0MTaeTvl6xiv
dyzN1z5UR78Nhduqf+DgdZWjqetPzJ9fEf/+Xx8ebNVJh65v0kD08LsQLYeH
5TGa34SuFsr+xdup1IqDPO+SfzwJ2uhHneIWO4zXa1ur65XndVBi53yxtSkB
6NZvlJ506SA+i3+dEZieVxSB9V5dBz0SwH/5o0oEOUHKVR0FPbTx4BlFK3si
WMaZSL3Zro/Uvhhqusdawbinj7TpXX30MGjL7wjMb5HMXSVfiuqjyq3DpbIh
JGDzPa6nOhugRvEDwRo4MqzzlTFJzkbI4Zf6JI2A8U/F01v9N42Qu4ef9hMS
CfrFkvhMnI3R/FTS1SRbIpStjjwxoRijWdfeyzRbEnxfDpHXPGeEMjkOxnUT
ydC0hhd6hfGSbn7FQKmYNVR8sUqvJBqhBusvpyzWreFq20Py2ScYv5kNxJ8r
psCM959WZroJMnfWbxxIpcKdlzpqT/VN0QdKXstsLgXS1FM6wsyNkX/BJa2u
IApYnd/l0MdphBa3Z0vOkKjwWziCvh/jweETKY6zalQQ0+vNIvqZorvl7mbO
gRS4cX0oXfqOGeJ9fO7GOWy9xSxHysRWc2Rwmley0ocKfZzBjP5tZkgkeZvr
gjUVJuUqnupsMkW7IrlCK1eowLaJxDnizBA7rWHXB10q5G0SwZmqmqHd7t/Q
Xx0a/Gu4+nd/hhl63nS2fRyoENtSbrrD1xzN4Gy74t5QgcfKXEogwhyJXfyq
HdJNAYvgHNy0vjlKWnkq+Rvr79/juvstDMyQXvnc0cffrMF/F8HJs9wE+fr9
7UrysIYdgoRG8VxjtOncjg2ep8nQ7GgRdKbKBNF9WyM/7LYG2Vd18XNipqjC
wSRe1pUCpMEPhBeBJijjUO8/ii0VhH981cc/NUWfPg0FN6ZSQOjOmYDnPWYo
ffKCuo4lBXo2h1GEm0xR+4qvvt4pCjQJpN8WOGCGwl9Eh910o8IvDm3uwToz
5JZ2P/PLVhr8Rz5WcaDYDOn2OXA32FEhjVYssDfPDMXGTt96Y0cBgv2KtE6u
KcKpVLlIjFOgZeMrCQElM/S0YcewXD8VCmJOvs8RMUcRljc41/RosL63W3p2
1ByZZmouhT2gwby96zabbnPU2j06NdFAB9ur77K7DlugsJ09nK10gB/GNeff
B1iiXR6mKFQJ4O1IJcp2wSFXy9N1B/vpwNBC/HHKeDTp68ebZEWHFt3oi6qu
ePSrzDQ5Vw7gQPzBHeXjOLShM+/QXTvs/dsiZQLpODSS9nTZXgXgl3d2yvdJ
HCp0jZ/9nQ0gfPJbiXkgDtXtESS26AAQogk3d6jhEO3XRbNtVwEEXuOYhu9w
KJ/iwEHYBJCt+DuG8AyPPHM4Cjix9WRMvxKLUghI1MSj4Wg2HVjN8fj+jwSU
3pDKCywA0/S4zGBrAtJJCnLY9JgOh8tc7CPlrFDhH16+u+oA+2dfFhu9tUJ2
CcE2myMAzu6rxdcOE5D32KXYGleA9N/RBpYrePTB8sVpfkUADruS1LwVHGJn
SAeYaQA8Mk32/PcIh/7mKE/fKgQwzv39kBSJQ+qmTsf3agKIz99pfmGOR0sG
XOTckwDaPhVBgptwSN5PoenuVoB76b2f6BE4lCQ4l67cga0v/u3JgiweHTRR
9K7yBbjvOewTeACHOrbQv/ziAzi1tOPcG2c8Uut8zkG4R4flN+sKWos4pPlp
+IrzDoD4v428/1g4tPbmjuXgNzpoaSe/32SExZ/H8Ib3UYC1CffrcQuW6Ee0
eoH9HMCYxWhsPT8OiUUZ/nofxoCd4lQ9lZ841DBdC7fLGeD69Xj7mh8eWe3i
l21XYEK4QpZjqx4BxYYEdR4MYYKSCBLjfUdAD/bNRWW8ZMINnm+JVeUE1OoQ
8dJpOxMeBPJHHvqIx/xjLmuAgwls/ecOfB8ISDw/z8lHggnPZeps13SskMPR
NrXpNCbwttSs2llZoebtpakVQiyQD7JvqJMhItcDS1YGdixw5BkSV64loqvc
xKjRahbscvt0saSQhGI/GB4bHGVBSl5JemcUGdHYHnjvqywo/nHeW2WIhJZm
z1EKedhQrDY4F9NARvVh4kO8bDbGLw+FZn+R0fGRoaobiA3udhFm3b1k9Ct5
yTuSwQafiYwQWVcyMjllmBpQzYYlo1474nMS2p8bp3hF0QaObObuDG4mobId
Bvztl9mQ8VN0erKPiFr31HQeessGdvkdw4EiEvrouLZB4zQb5iS1jyyqkxGu
o3LR8xcbpI7fP3vbjoSWna40uNxmQw+R9/ULeyKaP2DStrOBDbPk5sygf1bo
+FRwoiONDbZvw1x3DhPReGuX0NW/LDjj+FVl1pyIlsxEOvQ82dB28dpM6ToR
ZREbnbeJsSH8BP+NgDMkpL9+KN/sJBv0u7R4fPpJ6JJstd+vRTaIR0Z9cegg
I8P0yNlbz9mwOyGqX2qchKb8j4lWZ7LhxmcZUvMwCXki57PN2Hq8F1xWPYVJ
6O/x0dSuPdj69QnGhzNIiKh4WV8Am//R5L5l+yUiur4TDF+WseGl9PSFF+dI
qHGl7cSDeDac9o0i18eQkXHpdPuQOxu2k/t27ooloVJzhsjQPjYMUohq0w5k
NKJJ3wYybDiwbKCIf0NGd0cna56WsWDS9HWXiAAZ+fsG8ncvseCXw5lKjSEy
+iC4KxiqWLDz3PY8ugwZhaU+We/fwwIpvXc7hEkk1J0+ah+gyILHjSHi+SZk
RNDPi8f/YUKmw9AYroOEFkScP43HYXr9/OVEQiUJ8ReeYVpwskCkjMNq+0si
cn/n1ftfGxPi3NMDHJWJiEiQ5vJSY4EoXdL8mK4VOnve+7YAmwXdfsdr9ToJ
qD37yiMB7D5c3jre1ziI6T9Mi7O5iAn8V2pkb2QQ0BVZe1Rpw4Qd6tH59vcJ
6Oa51kPazxiw952VPVeBFVJ5PWBxI50BYXYpbmU8RLTfROTjW3kGLL2q/Je4
REQHuxMl2oAB+o9HPq5JEFEC43dyWAQDHIu3JtRkWaGeyl/+pyYZYHTC9bBW
DBG90IpVeoTdX+7Vrz5Oj7DxWJ+u1HYGbOgPtOnKJqJrn013lgsyYSp74dEH
LF/BBT2TbEMmkNtLaiCNjEJZu2QKSUx4anyjeIaB3Y80q9cKdUwQjBHeYlZO
Rlfsu2St9VnwpyR1ZHeONVqr8VIQXMbmPzoTJS9kjWTeF1U7nmNCa9qTpefx
1ohed+HNg3UmjIUExTmskJFgkgiVJ4gFM5QXun6jZDS9a39d0Q8mLATFWl4Z
tkZpeMmevz1YfRmuGt/SS0FeY+Kyudj3Jfra5+W0KejP2Nb4I+Is8OLirGMd
oqBEz9lzZaks4FMbiUuToCDPH8HdTVIsuNv6Y0hCmIJ6Nlk7PrnIhKvh56m7
/lJQ02z5u5+ICSY16hwl76moeFppz2FMD/vkH+hnjlJQ1F6/MDE/JjxjZv61
NKYik/GG4F2fsHiSvbh0Qynojd+X1tyzTKh+fX3/cp01GtpXtN5kwYT/vKuz
zz7C9OjFc15CjAnGoZOvyM/JaChWoxmXyQCnT6M7MmbISE5vm+w3ESaoMSRP
FGwgo61K4frrLCbE2wckf+4ho9Q4IbOITCYENXerjr+2RrGOtXKc15ngwzXW
K/iFjFbnIrNlB5jAkPKzHAsho6u1N833bWFBjKuCadIaCVGjd5wY7mPCu+PK
F693kVCtpO8eq11MKOEf5d/xhoS8BcO7KYMMcN+8fUKIg4Rm9upNvcT01/Pz
0aFFN0wfZUL57j8ZMHGL8rfb1wpdNiMffC/NhM78dr2oBAJKFXznbzHAgB13
b/nUXcajV3XP1lOx80RkbCtu+IVDuW4172qxfnG6XztHYd4SPTgT8KLmGBPW
ixb17IpwaG7It/+/d0w4EXKfePwYHsm4THw+o8AC4pZ+6UvHcEiyRlK3VIUF
aJgV1LIHjySX6tbyvmDxOkg22R2GQ6uc5Aff5Fig+S3mpGsODm3D8xxzzmdC
bQblosCAJVLebXD3HpsJB4rbCsQHLVDZe90ewPScOji1wb7MEg28ndAJnGbA
ipZpa+JVrD+/abt1eCMTjieK7vi8hkOBHvvu8sQyIc36IVWzAfse2+54Aw8T
cr5Ngj2yxPqnwdgzLSYc/m76ffABDkkkcp6hYPMNNb14nJctkTwPfW++B3Ze
Mu4nGYvHz2rbmls07Nnz08+DfTik1Cc78K2ZCdozjnMx1njU+SGwLsGSBczl
3N23SXjU6v0z5fRdTH+e+8aY6nh0M8SF8NOCBdLbNn76dA6PNlhPvedtYUKA
d2rKeU8CytZVIZofZUK7wvnvRwLwSCH5PDcb68ewV8ZPIhqHJnBiCpcwfYcl
ZW03x+IroL21uIyTCS6Ns8MSGng0K/pmVmQvEwLrQrT9xPGoQ3Pjns6PTMhw
rbmdJI5Dt6OSxFrfM0GPrOrbcsAS9SqEDt0ks+BkYzuN6InFZ/Jb4YQ8C6bv
ST8+6Y5Hpkxk6IfV01fPIo4MOhOQzZrM5Qnsfp9JI9SNDuPRj/26IT2RTPhm
2n2G3kJAG0faJ/LuM0F68tCAiBABFe0x0ueRYMEJ3uOtIa14FPN0wT4rlwnN
7vWv9yICun/8P+JSKnZe1rnTiy1WSLWsNGZrFhM+ag9PKupbISTqSr23wgRW
winLuzpEdLYi9bjZNyYIO0nvdau0Qp+eiUWP72LBw83vfY0SrFABjvOL1gAL
9peFX0tMJiDDHUm9pYgFq9/rPuHm8Shg44UYJ3cWsAXTey9hflBhSfFlJ4kF
FT+/Nm7B/KL/0sDWWCx/NNVBDvuvBKT11/zJqC8LtsTa/np/xwp9nDDvdMHq
kX28ou3lYCtUcfhL4HIGFq+IYILFQwI6oUNvMcaxIORye/QtbgKy26BQMTvE
BGeaqswBbHxk9X6GJDbe1EscOrGRgMwl2L2F2Pxo82mX4O94pHXJNLRJhA0e
R1/lpwEe7TTPND8VwoaQr31v/kzh0NlOzcG4RRaEC94Mj5nC9CN7rIWJ+Qm/
qILZvP/7v2esP77fWLAg0rNLyAWPlkvZpSNHWLB1R0CUAJa/sXuRpYQYFlhA
vGlPOx6F6V4aWsbeD4rdcfRKJw7rFxOvlPux+ttR5lvdiEcRE/pHhG6zQPkF
l0KIGh4pimrts5Rgw1RyZOQhJQJqA9PRu3psEHoRvnLakYCiBdSbeEvZ4Mbk
Wz7+hoDiLE7VjkvZwO1Yv7Q/PXjksbOWu0XHBhbt+LVisfqzoaHo2aEEG0ge
1/35NNYK8avV7H4dZgPCn7lLj7oS0VNXm3X7ehsQuLCYP+BMQp8/HKi9+tQG
nAN+FrzbTkZWp17aDozYwLnuIR1RrP99ZptsfpZqA6lRLM3leSKKr4ouN9W2
gXB+hdWDWL1882nusvI4G0p8viV+SCWhTmrwlTBvG2CJygUc/kBEoj8e/nnE
aQN/Ki6bV/WREF9ZMc+qig1cnGt0sMkgIxd7fsKtEzZQZq9/XCKLhIqe3DO5
cQ7zk/XGbsyjZDTp/p9Vm6MNmE8Fbc++SUKZO+7zELlt4KQ/I3UyCfMz7URb
xXgbGBtwSTsYQ0Id02tb9LlswGzlcFbMDhJ6eatwnIL5Td3QB9JUYTJK4P47
bmXMhiueTTKrL0koYTCG36yGBTcCE7eaviOiS22rJIuXLKhjuGm/6rVCL66+
8Ml6z4I7v6oVn+QTEdnpzF43bP7vKULk8BMrVHtq/lX5ETasoqhGGubnyZ/j
MrWobOgNK6/ZRbNCcm+9arPusiGoIilTHuMDbY84pY16NoDnERVS+oxHYsmD
bwfW2OB5dJ83TgaP8C+6arO22EArlyfTuQvTX35cgdFrbDy1Iy7lCcaTNdmS
6tttIGPUwC/2gyWyS7moyEqyARPl/fetNC3RZdN/NcdNbKBc9prUjSAL5LtR
uKwyGYuXkGDvXJ8F2qi0IWR81QaOEmY57HgtUbQcVeZOxCZgkbcHh/6xROYE
7rmy65tAzCRxnq8Xh3pbbztk7t8EDpNzV/uxZ8rAOa3M8U1gPOleFLsdh2xH
hiLzT2yCQ3c31mdx4BGP/OSAvuImULG2TM3bi0PPXQo4KJjeVpqIAneFMZ5b
Pe084449V+1/e9IKh94zGMM8RTaQ+YYYcemTJfoss1mvENMz74P6q7mfcMj+
UoDEEqa3WpPaMtN4PBLaHkyrecwG7Q8XdkpbEdAFzg+aqgFs2GVPuCBnhUfJ
W5/hDvzHhpWDo1s5WjCe5rRtCR1iQ+EGVduXGXhE/5Jw7pSWDSjXTXsZnCMg
GZEmzW6CDTCvEFYbb+PRpgyPKNoyG5T+lNycjsTua8SXxOooNpxoFnZ0z8ej
5h9cfQ0rbLD0i7RO2oLxsOrnKnYcG8b+6QXzY3wfL2nTp2TAhuvplvtSAvEo
klwgKI3Vg6qGN5zbK/BozMdJUCWYBUWWlQf2uxGQn15zXnAXCzQe8Bb7Y7x4
tGul2MiJBW2/jx4woROQ6sr6lWvtGM91KbnvwOrXEXVLz5xGFlzumZTbfgWP
/jxtK3VmseDDQFlUKxWPFp7ueHfxBRMqyvcKWtrgUe6j+OUke6zfyEec2HAQ
j0IFX81zvmLCdbUja5cFCSjm34NtU/8xQcen+u8bPit04XBq8tJOJmx3WXxM
wZ5dj8gcXnrLhMUv02+EBAhoJkvLU6gV81/huGUvTM9bHnnaRYiyID3rBe2L
jxU6fTomX/sG5u822dhYrVqh9CylIF6MX7lks+/yMqyQgdLwlY9Y/c8Kal62
vE1AyaVu1ze8YIGl9OUqEYx/lQNfBeVS2FC1V600A1vfLa7aCNpY0Kv4NuIc
dt/ela6OvvzJgnfzv2s+mxKR35fsrXlRLBjwWufZYURC0iozLVv8WNBnGrZ8
/iERfaYOv/WaZ4LClXuh8qVE1H9gwfvHYRb8rEEpu86TEIP/ynG/G1j9p+7I
4pMiof5OYhW3NBsqOL/dCZAjoaeztWPrF9lg/sJPKe0WEaHAPwRtdYyXSx98
b6u2QiH7Nf6F8LEh+kCNEKGEiLY16fK7jrCgq2nbePcBjB+WdG8aYf67jce5
9kwBEXF2X16XprDgv2RXsczLJHSzIs37lxkLNn4krBY0E9FsuWfUwzAWZD6l
eGQQicjgUeTiXm4WGPmr6x8mYu8nkr+k/8P8gGBDk0wACV1tVQhzimbB7PCM
5AzGqyb5cn/Fp7F+mUH2y2kiodBe43PhQWxQPTgj3WRMRu9iYbgU40WdpcMD
IZgflgqhH2Ucx/h06+LpLGw/oRy/7J7+YwF3lceARAIJbfHY/N4khg3Oxnwn
HUeIaKPP2CmdUSwedc36utJE9Kri+fnV82y4etrkd3KUFfpRZWqTa8iGw6P3
/GlBRFRzcnvpaYxvQwROfXMMtUL132ZkmKFsyBHUObT4xgol7uCi/8T2U3mj
MedQP+ZvjvtHOwxj8ZrxvnG0H+vHfoL/zn7AeDc65YPdBgJ6MBdYWODNgmyC
dt9XrF66CXumL2Lx81ySDJfjxKPh8vNBp6pZwHFrZ6tkLQ5xWzgef0RgQd6Z
Hpf5Gzh00CGqMu8+xke4OwUbZywRcTVLNdMT8wvqJJKBqCWSOP4lNBvz14ck
dlWdxlmgYoL6OOcwEzR/50qozZijRdobvrn/+8GCV4zNDeboU2aKwqvPDPj+
mqpF7zNHdm+nXk75MKGnvGmDsaIF+lmrUGoxwoTdccfP/q0yR7EJnOFmgUy4
ZdtVm9pshtR7lnuv05mQwru4aTbRFDVFm6kMYTyS3yV6rUbGBF1nF6QKYH73
hdtBMblGY7SkKjalg2fCh4R37KIiE3TDqUSp6TEDPE5bJda6GaP/jqSIhu5l
QM3ZtlWPt8aoSsQVSOMAJmq/Hl4IMEWibW8cVrMBmgcEd6XYmaLjR7+eb5dm
ACvOQPFyObY+8cX1em8G9BmK44NPGaEnr2L+9v8BYIb+G9h+yxDF2cc1HD3I
gLeVlFI7UUMUlKbv7vWFAV3uvAft1Q2RhmXc5cN+DLAIuKMeEGCI5H4eF8RP
MEDA6UQ0R6A+qn+QeETpPQP8TJR+kNt0EfOzy+x2TYwvPCzd7IV10JVU/pp/
nzCez657anZOG8X38q2LH2DA/X8lcSatWkjZ4nrWrZ8Aj0I//00+r4WOBtZ0
kcIAjsSU4C5WaqDdgmytQ5sAuoSa3pb/VUf9zRrc4QV0GM3eTrf9pYmKGtrZ
2j102HH0lrFqhCZ60KU9HXoAYB9O2v5cmwZy2v/MKuE9HWgFVvav6Foocujf
sXAWAF9WuPackQ4i54DmBPb+71cxd/uGtZHTXO/2uVd0YEcF9lxs0EZu1D++
Ov4Ah2xfM0n3dNGdQsrrBHcAnuJ3OxXHtBFoNzgragG47f4oPvZXG2ldDzbK
taXDbGxEuF2mLhrJK84c+UKHWLWLLvvldFCAdKKM21aA9yc4aO4Seigw1ejY
gieAvFr/zf0xOiir2Ft/6jbA0XKXJkNsfa575WtNOgw4lHHr+TZNXXTqVNVd
wTaAlBPuHrQ+XfRzulxcxQ5ALxM3ONqhix7vbZ2U6AKY0zv/bLRDH5Wfv7B9
7jnAhdQbamlvdVFSn97YfDVA6jfr6QllHVR84dCLxBCANcFfuxTNdFD8l2Hx
QzMAQhSfr+vHtZFEaPFt+RMAbUdOKcxnaKLhlNdni7cDULJDRh+GaKBsEVE7
rhd02JcjEjSM1JDRhlGVFEMAo7fT0Yey1ZFHn5m+SQgdDF8MHXfG8vNY6m1X
fysdBG25rfb3aqJHtIt9vV4AvntNZJ490Eb5KmGznngAx0t18sPyukhsaf2C
/QWA+hvaK48v6qJVKfdrAjIAVaQHV3GVukj95rt/3kZ0SMp8m7PhjjbKVfa3
+MHA4i8j20m/ooOC9RXjmBLYfdmZ4hy9roW8Zm42B6Vj+SgawD3fqYX8SN9l
PtMBsqsaSCcuaaBblrLMun902LCsGYMvUkOeBxM606UApMxXUgtIKqh26a9q
SgBAzoVkDg83NfTmi+r+s9wAciyjH9H5yuiuYlA23QUwv3Uz052tguakP5VG
vAXYff7y6RJJdZT49Fmc+T2Ak8nM0webVJB5ybl/tw4DuPdbJ533V0LGF8+2
lwtg7zu/atHWV0Vl8gcOB2P6Ew74O92gr4i0P7q71gcBXCLeXBKPVUQKL/dc
Zf7A9Dgk/mSaUwVp8KcMJiUDdEh4KG+ZVELlxxREc7kYcNE+fGplswIqMIYq
gWsA7OuF3WHBCsh8EdeyoM6A1oqHkT/iFJB9zYL96lWAzB+5/969UkD4W3uG
3TQApE1+yW5+LI+MilH5jW108CvWzzGtUUQ7X4VmjWL5OGjuFHIvQxkJX8Mp
hdrRgeq7Fzcsq4YOTBPWbc7SQLCg4b8sGQ1UUft6QSecBmx1g6Z3r9TRaaXa
jMpIKjw9Yk0IqddAHRoJHk1eNFC4xfmLtaCGgor3BNZNUMGoSDfz7IAqEkn+
yyHcSgON3eH1mR/VUY3mi/feZ2gwSDx5elxJHWW2PxjJu0yFqB1rHgeENNHW
bIKI1h4qBM82xm3C3k/IomSYGtDA56OicPRFNZTom8Lq9KPCj6iKgVmWMmpS
lucONqKCvUfNxIZT8mghLIQjtJ8CK6e3y7cOKiEVqSNXPO0pkD+3uvuOhBra
lbySEf6BAno4JyNZN2W0dTTvFLcuBdKUt9QfS1BG4lHSggxda1hjvJ/py1VB
9gS990iZAvuuXP+m/lUBCTWZ2yXHUiBdV6+C64cMetMorW0TSAF9eOy5zJRC
JRF6AxX6VCjOiPm22CuG0lyjVE7foABb4mPT4bv8SFjM4HROBgUOtTWSxBdE
0TZVw/Sxn9bw4t2t7I0rkoh9b9sXjllrcMj5mRrNJ4YWHIp0StqtYbeN3Yz7
Aj8KcGIaKB+kAN4smBG3mxepj8u133ekwuQxX+LraT4keCEs/K4dDbLf5ZjX
hG9Eh0bqXLbaU2GkQCvd6iMvOjMwIKy6mQbtspRo5RkelPXM3/IEnQ6tiuUp
4a8F0EOJ3n0C03R4lsEyJJQLomecPr3RMzQoRcfl4z5wI/y7y++47tEg9/zR
jhsTvOiksscBxQ4qvFqZV6DdWm8x9b1vVXiUCuduZc1SsP0VvlekPFymwNvm
qdTWnSIo5IyNjbQIFThCPcIKDIVQ0qPK3HweGvTxDRSRWDzozKcAYv8HKjxy
+C8m7et6i9jHL1pbxamA83202X5ppaXavrYmmJ8GnUcztgvc4kLOG5cEgjdR
wdPDgVa870+LfeK/RfNOCnDMHtE0Ehtp6Zf+/X77dwp8Wr/KJT3xil7FWxe4
rZAKEufllc0iv9B/WDof1nhIgaabT4o6T4/RrfM+ihg+oMLC6pcY7o+DLSea
BXxlz1Jhb4NrmeTCG3ryR+WBgS4KXLrXsrd+15cWn/xLv0+LYfEPbhg6Y7ja
En79mCC3ABWe3cyll5Wutby6luqtJEiB7+rOt+JFOdDcskkAzwYsH/2BD6/+
4ETfPt97xrFOBbqUplxy6EJLs/XeaF0Wdj4O10FH+T8tU5+3W2dj+RHacvf7
6dcjLXFOImM/lrH4G95f6zT90/LBM+prAJkOCtHv5ssDVlqWjJMUshUAPoeh
7v113MiYW9nCAuuXgTIk/sJt/1oONo4/qcTyu7Qmvq9edrbFUGVEiVlIh0LZ
M9d9BAZa6g3FvU9bYPMP/SMUlX9uGY6X0Th0kA4HOjQ2WBJmW+TWS/3ysX5R
Pf6Rd162ouWV25WyEAeAbYk3jp1fnqQ37R5o3M4H8HNvxwCxf57OfwV/lmlI
h9BD1nVV0Qv0KNaKRZI0gCwOKvQlZ+mOJeek1nHY93E5J7PZ/+grCbNSDeM0
cNeY28++xwW2H3JbvZeosHaD4qi9YSNcup+89LyeBt8m7M4N+wqDUIfKGf4V
KjA+LNxxXeaFh8rPjqnto8KT8522Z7uFgfPHgW9lWD2au3eavnpPCL7kVamo
TlKAvpvgreQmAbuzPqW876YAhXhFOzxKGI5qPYvR9cHuV2DFw/wECTA2KKKY
1GP1Q8OhYl1aBl7N/w0NNKBCh9TO440d8jCmreA13EEBW1uTrgv8ikBQVvdY
eojt556j9yxSgYzWm40VCjSwo/ZcuValBluvezTfc6eCynAtlTSvDDdPD625
vKXAmu7DsdkyNSh7OH6i2JYCO8dTW2/7qsDTgsOyg3nWYCJ6divHHwWwp1l8
1FShwE+39CKWlxzsDaNe+2+PNfAU1HJeXpAB3U2D6t+CyPCnTpeasCgB8bMP
9DT3kYE/3vTbvj4xGJLoVNYnW4OTx3A6U1gSKqJfNO8WpcCTfeygd4GiwDV7
6fK3yxQIFIGuzZPisMjhKvT0EBXw8y+PtF6Shhcfv85WvaNCvRPttZOILNQJ
uNgItNGgoOKg6SY5KdAgfrwzI0ODxagUlahKaViITNzwzpAKtZ8Z3me3SkLy
51ef93lR4GvH6cZ2I1mQ1xUYUlSngKnR3KK+gxR82pWXfxSLx862GfUX3WKg
IFgZOO5CAT70tsdvRRIOxion9zRYg1b+VWfcvCz8M960ptJvDVFByuNVogqA
F0hC6dUUEN5vy3omKgOn9EV9hOoowJ/WX3dxWgKsQ4YYs1IUOCJ4Pc7ggzCM
Phn4xVSjQHUepbYxRQJmhsXMhbD6XD7k3tJfIwLC5bJbyxasYf5GkJ5PgwjI
ypxZKF2gQK2qZJPWFyHwC/j41nvVGghk0qvdk2LwfDg7xfkpBRiHFJMXLgnB
FU/thE3cFEjcNS1ubCIO+xnx6z3YfgpaBAdhrwC4WZUbFD6hQMDN4SPejaLA
9Do868ZLgcaJr4eeD0tCAC7Wg/zPGhS4XfrvDstCb3vpUg4Xpke/FcWeBjmQ
JqrO5q9RQLzyaWpWmBKwPwsliGD9069APuKgrypsqWqoEdhIg7vHeNrL4tUh
KZJC7yugwuKg8ZTlUQ1wKOPuUcbqH5+CeH5Bgho4q7c0d5zEnuufLEw8UYc/
atYcx+9Zw+KjD2Ebz6qCqc6TlsU71hBbyQxUS1WDk+/XV3kKKPD+ITWk96wG
UKIuxXlkYfFuOjzBmaUBUwKZus5ZVHByF8HNszSB22azYXoCDTJToo7IULSB
u/ss5YMrDaJ6VMJWnTXBY8n1CBe237/k3S83u6jDsEM7sUWMBtuidRJW9qqC
/9BsXs41GqRGtSG1NTVIPLnemfaRCiVPNeP35KlD/M5pLZO3NLh461jYDmF1
OK77RyWoE/O7od5bVPLVQNhF/ezqaxrQr6XxAFUDDmwvjeH2pQOXLcnNxlMD
3Mv3P0/wpcHn+/T6+zJaoKJox2E5QYMu0hhnyi1NMPs+wJX8kQ6XJsojJ7H5
+96Tl3dgfjZGintz/F8N0B6XER0WwvjuynqsT7ImHKr2zlU/AzBDP3Xia6o6
qKmtdcjnAXyXa/f98EwVCiSNyW47AGofDhTQmGoQ4HAwTuc1wBjRXRAvpAHZ
Guu07xgvTk9vCx3eqgYXvB+QMjCecS8XGnhVrAQuuML8dhsAW4+R9i8K8jD6
UMFXnx9A4fWVqZf60vBOszL5FcYzJ1QcnW5fEof7ee82uBgD8Dupt/CfFAH5
R+rtNal0ODyYfJhWzQ/5B1mDLx7RYFpHvvH5PgG4HNil2NdMB+f5keFlaR64
E+uTPobN/xZxcFPBtyX6zjHJKR+s3r+J/Fl9aOovPU2q/k+pIh3alz6I45VW
6Xafm2Wuq9IAzzMWusVxiW4jkPTtoiYVoq/UKN0V+k03unJsp54OBf6O9VCG
grjAkEeX+8oTa7Dn8OHU4N0Ifzb+tvskbA1Hv1no/A4TgIi5bd8mOSkwI2lX
y68tDFXIImPwFwXq7UyTC89KQLpbhlOOBBWWSIGMFS1sXH1kwzdsvNr1bmqc
khh8eXSQbInpZVHLIh+WxcHbIcS6BLs/znrx25JChIAZJ1Dt5UwFIb5Ldax0
fljsDNc6eYAC2h7fVaJfcsJqx+Le/OsUsKJfNrTu4INi+mWPMyvWIPtzo6rX
Qz7wMUkrS1khw457Re5DdCF44qpV/+alNSylPDY6GyIOolmn2G89KfBnQ734
cUspyBUr3JYuQwXeLmGa+xEZMHNs86B8pwJb7lPg1DkZKMxzt9X5jul/R3YZ
spCD8m/ppDNv6XBT7twLaX8ZOHLRndKO+bOhs6+jh1XlIOPjmPJALx12+pP2
i/nKgBr9UynjJw1qDiupC32Qh7KoMtePwXRwnWtX/jGgDDZ8/hsmXelw5F4T
Z4ydGly30zyQVkCDySPda6E7VUHjwdjn8nLsfkWkyDqUqkGtjBbX2nMK2Elu
PMlxTw0GDkdyy3ZZw6kj+JiP6mqwj80y/NxLBsGU+NETG1QhIuY97vwYCXhM
Lu2XyFEBnuvibKFRMrh+tNN7YasOW9UuPNPoJEPgk+5jf3zVQfR+iHJMJwnC
csyDkrapwrbflOWpzWTgk9AKVEtUgvbOzrCNmSQQ41x5OieqClg443yfE0Ha
/6Kctqoi7L39K/BQIRHspbcYdjOVoUEgdr9GuxVwLSqVf9RUgGWGmganjhVc
/MX/wKtVCbS9R1/e+2oFRaf0iL9k5SHLIlvtoQMRBKaFzIaQDFzszT7trkKC
Ht7vDdVvpWAobiHj7joJSuv9Eg0ZcpCC8ptuxpMhv3fQOvicFMR19fE1qJNB
+DPuwniaBIxI907LsklQrUeSnv4jDcIJCfxi2Pnmcj2EZ0ckQBIHuI1Yv+7e
nSo35ywGN/5ZchNvkMCs/EzM7u1C8DiSUPw3igxCgW9PmKWKwJ3AFmWjJBIE
c8RsnlGQBN/YV7z2r0lwWO9JJOmSCKgqj9V/iyWBfNjM7cDDgrBjp2pbRjYR
XnjlvrwZLQzhBUUdIoVW4CFky73oLwFcfJluIwQruNPFlLluJwat9x2znMWI
sPuI+cu4E2LwWZnWlClmBRTc5MXhAhF4u/OLcfoGIjDJnNyCkhIwNLTHwuMR
ES6cN3rSay8G1/YcWfsxYAWdAtmaBgrikL1p9++Gt0Q4WHr2QP1DMdjkhc+/
2kOCfANnffl6KRAaf33avZEEZFzpQ0W2HISf65uOxOI1xBnn8v2UHGSWDj4R
YZPBoqdQe8ukFEjXKorOY/P9d19e/ykjC5uycRwx5WTI7jr6vHdYATa8LnOO
dibDYycx9c+t8nBkQuVl4lZrKL+4wONfrwy/8R+kxUIxvitKFD+WqQDxRm2s
CiEKxJ6Sf9x/WBZCSoJ88JUUMHIaKOFVkAFxL2ajXpM1fL9f/Dw4TAL8nUJL
KC7WYHjxwadMEwlQXut2feJCBg0Vl7qISCkIPN016IXx40kDaymeeFlwFnTY
ioslw+2QdJ8SARkoPqoQwXuBBJFJ8T67puTBb4uo9jssf6MvFb2/jsnBpLvH
nOQzMhTZSfe1WitBLtKP+Uomg0rvyXvsNiU4TfMc06WSQLwp3/EYWQX4eb84
L2J6DedZlVM9owS+D6L+dhJIcFDHI1JSSB7cV/0qTtVh+ljeLZBYJg/+fbIm
yTVkkJgxKUwaxupD5VGb5wHWcKfwlewKrxT0PzYYDMN4N/Pw/PG4LzJAuDV6
3jnIGvZa28c/qZGFxku5pQfDyCBfVfEmOksRnhWO/iNUkSE6P4mjolEZXvRt
CTzeRwLJL86buLxU4PDtMprpWzIk9yWZO/Apwcp3wbKRa9bwNqVIZjufHPRy
75lIKbGGD592uvn8VAR25LhR0kFrCHBXq4u1VIQ/848fjGDf67rbdX1bjDwc
7uH3j3K3hvXKhEBFLQV4qmcgqY35w2anF69cbBSggPg3g8uFCuWPxHPr/mL1
lNfl7InHGL+LvZa4cVUKrlQ2GZicp4I+Ye6lWpEsVC0hRaI1DV6u0OmnMH97
QYb35oIsHbz05t48vC0OfQ07D+VvpQO38rz4/e1S8K9e7Vv6BoCcstV1IWdp
aOgvJCZLYn6gdRo3TpGHxKnl4IotWD/VpnmbRyvC5rzECyLHaWBy9KPA9mhZ
ENEYycIdpgG7KqRKJEoRuq+baVH3YXz9oLboHFUZ/Lle/nKLosJHPi7Vmitq
oDvZe+dfKhX29E5/TkhWBgHmxefDU1Sw/e+wbD7GF9MZfAaqGF/fXLibuy9P
DXjqHf0zTCgQkWesetBaGWTjE1muwhS4VZTaQxxVha9ulo/ILylgg3dx75xT
hPP3y97KrFLgdTdNaMslVRB+Ffu71ZcKF/a56E0hRTDd9ffjbiUq3K+1z5+g
KYPE/Ztyvdj6o8/tru49geXzxx/1ZktrKP4u/sArUREG+CHvpBEF7p9NtIy9
qgQCT6UYoRpUoK0ZLopSlKDwsOikkToNbufZ6XPaykGjRkOeni0NHrw++16X
Uwa01ilPryvQISc8JXgtTRpovb8/2ClhPGhGrFVrkIWWvsv7/5unwcDG9/4v
H0qC/tmyI1L8dIAzK99+XpQBwb9FR11caFC9Y3Hxcqss2Dw0ui2E5W9Lpk5Q
5TdZKNnTSZ3WAtB5JMxj9ksSvm8ZOnxMCuPRqDZh+QlZWHjv0i/CASD0iXc6
4ZwCuE7zD933xvxWkfr21NMqsN33Xl9hGACbM6rGxEUJ7r1cv+WP6WG4vbwk
57EC1BZnj8tFAXy4/4Jfq1oFYJN3i20WgFqEwUo2QQm21eTxDfwBSCtSdy8k
y8HvN7G25twMyP7nay/jIgVpAQf2K6oxoMDsikShtRQ4lZkyxIsZ0DC78dZF
HQmQj85r2CPMhNdd/guGSZIgf+p0u2Y2A/zecsY9JIpBlGCm/w97BoTwWf2q
PSgCz/LU7ot2A5zo52pbMZKEOSUxzs4WAM4gLkv5fhEoLfGxb8T298ljjtxi
zw9Oh9/l7LcCoBfj1gNe8oGDWvox9XsAbT9PEa27RMFsF9GDfAfg7X86XgMq
4mAXXcP9/99/uUnV3GWhAhCrg7dhyQOMxhTvrTUTB7V6EbqbHgBPR9DVRm8p
kLyy/PDuPTp4/AhUZ8vIwaZuv4PHBADee8Z9dT4uBapc2/jKb9JB7SrNfNNx
Ofi3bcbV+xYdLtTnO1N4ZOFMScrfW000sHd04PO7KwUl+R+W/M/RIUK+oZpr
SgzuaUwbnyDRgYrbSuTUkwL9jNhpmTd0cKggFKlskgXm1DcVKhEg/Ez3Py7M
Ty0OHB3yOEEHWeb3H2K6suDy65EfAzv/kgcKEjghDzzv3v6pLQKQyEn2GDTE
9FcqtyNzIwM6iixz2eEKkFv8fO+SIwPzDdNjf3wUIcM/SDLzJQNyT0bd/9ur
AmkPDv5sSWOA1iMx4Z+CSnBI6uft//8fUj8o0zN+GquPB26712UwgKi1/s+R
qgaFE3HddzYwoSjPQbxkQh2c6tc2iTxiwPuWUKWzLzXgv+Y1w1k7BkhyTDhV
9mqCksPbvVtGAE4ixxtQog0Pi0bvVEoz4EvuHQ0XC1243VLyLvopQDXX9tiy
Jh3gLkyT/mEL0N62it8TrAPHM8SqvZ8BHCWfnLpcpQV3S/9Gfd3AgK0vtBhS
R3SgLTzSjOM5wCOP5l0/j2iBqnyTa/5jLF9NUZOqPJpwwCbi0A1FBjgcSiEZ
C6hDToxfJ9uUAZXrB04IRKjAI2OPnYV+DDjR8nDuIk0NVqvfrYotYfdHX9M7
mqAOu7w07CQwPioOFx988lgDqC+F8KqD2H2RcNvKd1QdXBzFlpZJ2HlatF61
ZKsDW/F9T+0D7L5sqx7zuKgJI49YvFuqGfBD9IrZ4GZtMDUIUs6bZ4Dd031L
+3p0QF9CvdPYhgnHK8z3xDRrgw9VpS1+kAEpAqgdF6sLa/c8TnQUMODK9PuH
Rzn0gCal++auHBb/FtuhSWMdCKCX7AnexgSdy/seyaXowmmzkA+7fjIg+GLr
s8c5enDFdS5Hz4MJ4bu3rrwo0oFqFEonsJmwoip8ycNaGwIOx12XL2ZCdep+
D1qwFmyuumA9Y8AE85n1e5eWtMDtEreJfCkTyh/4RQ+4aoGgQolHmRETkrjm
t53/TwNO9bwIm3dgghdOduQ1xqeKHyyl1l4xIOfFhq+ykxrQ+fOdG3krE458
aFrXLlWH/vz+mtZKbL8V3Qd2FmmC7P00ZvZjJrh7bbTXidCAUdPYX927mBDK
3SB44YsGOJ2z5Hg2zIDrt9W/jpZpAdszbtm/iAFk7YWet8d0YOTr5GR+HwMM
1c3aX7N0YUObv8xzOyY0iTcZzOvqwISX5lbWKAPqOcwKcv21wFTiWY64KhPm
J2sK/lprQrGYZtuHJCZcKHi8sTVZCy4rBI/umWTC9e1Fd9Mx3r+1//ihxw4s
iJBWpX04rA7B0qXftSJZIBddLtpxVgNUcFsIThMs+FOZhyuK1wL9JuqS1BoL
DOJX2nyva0Oud1fXuQss8Nv/d0vdYS34+ktnZcSQBbPutwP5HHUg/PkdtfN/
mVC4i9tA30IPMCLwuqHHgpD7crNPW/QhM6jYjHOACdEKWTPM7YaQEfJjdC6Z
CfyWTRXfBvXhd8C2/N1mTBD2Cr25Y1kf5saeOVzC9JZ/bDMu85EhePD7LIgc
Y8A12ezNzyWMIM+QneyI6U/4+njqcXUDOIg+bGwWZ0Ktj1fbTS09aPm7sPcY
NxPyzP6MIB9daHQ7yljH6sMra9Uvjzr1oFZirwQTqw/V2UpatooGcCDhGj/3
GQaExW3IHlXXg6KorvdJRxhgVt2dlD+iCwK0o6vXFgDcho90e6npA+UY5Zyl
O1Zv+Je2xOrpAnULXnoqhAHLou+PMU7pQs9/1RbK09h9GlC2LffTh90L974k
SjLh5o2Dgd5O+hB2wa6kKAurT3w1r1Y09CFtQMfJSIoBG/guHEod1wWZbJE6
/3AGXAjkvMdrpwt/hkY2nP6F7b8Nccft0wN6jDdMezJhd3rjPsJdXVjI+L7l
wgQD6rJG/y1u0YcTs+yT73IZ0Jv2LN7ypx50REqlvpRmwr36L+4RIwaQm94w
BwQmiMlInW4eMgSfy7+jS24wgTgVES8/YQCokpPzlzQLPhBGwoidBjARQijU
yGHCKjEnLZ1pCK8NvAyiJVggkKh48463IShPSsnaYvpQ5dq51NVnAGJcW/BF
wmw4Vvqpgh5rBCH2Znv+a2fB48SZUH0/E8BfUKZKFrLgzVTTdUkLM5i9XnS3
BZtPNrNNqJoyg8u+Kr9VrDE95iqZvjtsDq/vCykqvGLCfw/Wlq87W8BCpcpu
PwEWnL6wZt1dbwHPBrVK/GNZ8PpaSvksrwXoDlj0jWhi66XE3ZvjNcfW6eO/
pIXtd0Z1aPMecxB0Ues5fIUFn7m/PLe1tYDgzpX7osEsODGUyhF42ALmtxhF
v5phwse3MSu52eYgql+fkGnKglP6P+eErpoDiZnvXnOHCc1WonNa42aA+lWZ
UrwsMPX8rVLQaQqeks7dbFEWeHXv79zsZgKl/9XQbvqzAL/Rguk1aQIJ8qnB
X6eYkNpVO+yhaAY8OpUxf1KZIO/SbeFUZAY777e9KF1mwvuRWz3Ru81AYPcS
bvYoC6aZHZvveJtBhKLJ/O8FJuzi9Q93UjMFnXtPVb/TWcBzYJbS52MGp8xv
/7l65v///ziR+XzBBD5NNW7658SCBLeCUokRY2huduMv/soEtvE9rjMEI6gr
CftUV8SEXNlu0/5dBtBcOL+6HsaESqPjX4jahlDp1KGfvMoAzUO8NWdOGgIl
44+GfzQDrHE9P7+t68MnX8+iph4GSPh+9dLINISdv8/sIyYwYE+ptqneMWPg
0FozI+5mAD7G52PaEVMQr7hnK4P1cw1t+xu79pqAlfEzos44wMR76xztduw8
ER1+uVi/YslOUiLqTMFA5cl0xUaAez53svkajcHkiI/9gx90WJ+OwTk3msCY
0mCuoggdy19lq9h2M4jhPXbTqZEG+zbpMquYZhCSyTe1oZEOvmMDN5u1TME1
roQ3kIMOjesFagfOm8HcxNeYZhk6fNjaLtzhZgZLaWsaMtj3nB3k1jMUzaGC
GmlkHUQHmV37E7+ew/J9/WOBtRqAi72LVs5Wc6hK/t58OIsO30mFf5/LWwCp
nKt4HPO7WVeqh1+eNAeVU5JHL3jTIWhPdf17ogXMXDj/+hovQGnwBL1NwBKO
WrFPPYikg9/V7scrKZaQpS/tfaGABseMFncQT+JgJdKBq30LDeIpnoob9HCw
cUESJVvT4WPZ+szIKA5iq+9fjkilQZlEToiyGw7mb9ZxF/jQQf5mqxcHNl+e
nvB58wEaOP72UxDbj4eHkpF/vLppcONu9ddT4Tiw8ozK0gmmQX+Qq1vOERzA
zptFFsFUWNMoLNQNxcPu/YbEqwVU0G5Tdfd0wEPXBUGB5kIKJL3OwKVvIYDN
Itqm9oYCL48ZVoqaWYFmP72zdS8F0O97CTEmRNj5b1dBPJsC566cebCDTQTJ
wdNyF1lUMGPEV5huI4Ly98dPD7JoEMq7vO0LiwjRK3qTudj48p7wHwqLVtCy
ISZwgyMFHjbOm8y3EMGFyllrPkUB0hnawN4IEggKbm+pwfZnukNLafoKNh6h
eP6jHMafR9qy9Eut4M+nqnvHBiiQ/22mot2OCJlUCWO6NAV6K5PL1lOw8YyO
1DNNFKj6MS62vdgKHDsuKmU8pILUo6svgjsImH/9OKNjQ4MzG9z7E/ZawdmX
3MZSGI8GsL7wwyABVN8qJD4k0eDN52P/vEfxkHQyxbk+ggaUkWX3J4F4CIMD
NwdzqHDrnEGzKzcB2C9+9wbup4HhVU6rK614cL88cfrfQSocdXyqNfeIAM5m
QWRFWypQPGVN6u5YQRZxRE9hjgJXn+1fzztmBZbD41+DvlNh7A+u4cYRImQY
BMqs89PgFyng5EwzEcYE6btX1mmw98CmdIVwEugfZ5mxttNgU9fvp5m+ZJCr
SvnaeJcGSaEpfGH7SVC9av68v4MGDmZ7zfpKSGCZdsZmBNFhZp6zY+kcGb5X
O9S776JDorfwP/10EpQwLbyCt9PhUUxL4UdfEiyr8IYvaANsNrQsWKOTQMR9
UTTMgQ7/tB8rud8igkS/bXqIKIAUWapZKpME13Z3079h/lh1UZG7+jIRfjbj
Il9pANS7V9U4WpJgOOeXy2wKAOXUs5WSWhKcSkqbXcX8bMCxk03Hzclg1Lpl
q1EAA/R4V3maxK1h269nTkcMGFBUonH/5aA1SLPTrzpEMoD1Teqg2fD/KDrv
eCrfN46bIXvvvTk405m4jIaorGQkiiRKSSQUomFEZGYk0RBFSRTOLZGkKZGS
Xb6VFVkZv+f35+N5nvvc47o+n/fn9cJhwtBuJ8r2ZYy3jlwSH7vHgsryu/Hr
Vpi+qcpIHXrIhBubKeuTHlZQcaRg39gsEz60kr3efLKCqA02bsrCTHj0gssr
ANPH2Z+W7xEvC3obbX4PNVqB/sWDpbFWLFixCZ6iM6yhwHD+LNHEDJom9h9Z
DbSGR0x5EScjc7ij9Xw4wdMabt9/Hv4mwwyCNFnqV5oxv+JlHrVUNIOYWq1a
XwdraM77YfPmLAv2TVUkpf2H8eRXT4WZYiZYZ2cS32lbQ8fzvT9SmEwoX7v/
bkuVFSzJ/hWOKWKAWPqFuj2YX+d/dr5EoDBhQux8bXe0NThsXT5lS2HAPu9r
+3xOYX56rNr0HY4JTZu/+D92s4a5yXPCB5cZIPle9C3lkzU4+zWXiIswIFOk
/UcAnw3IlVf7PdlOh6AdcqemH2D+aZL+dDaXBh44fuEMzN+bNC7nTmD1ed8h
QTej1xpqRhS3h++hQpWKaN1lb2sYKMy7/6SdCnOXVQOv/LKClsVjpH3RNNBa
ixPwvWwFrUXhRwVGqND6ull2eN4KVPOp/kIHaTDrSx81TbSCV7RrMh+GqXCY
QyPoPXa/r3PfPx99GqirNhW0RVnBDZvTOFF1OqT+7DilVWAF9WfUx1adaLBU
zzdIcLCCTNq33fkpVDjdshRgt24J2oq0unxs/BRyVTlXI8aXFz06N/vTYVPW
jvLF+5awT+KG3OBOOljXpS9GmljBcCOXP/s5Ddi49PP8zy1hO8/+icwPVMi2
PRt+/qoloNWbQerHaEC+NDxQQrEEpWR8Wb8PDfpZb9IDHllCro/+CadQKrgO
G/CoY3yWXHogKieBCnutuLw/+VmB4a4i7mQPKrgI3Qu88t0SNuwWW/YIMIX3
27pPyWPzy+gcM2hzoMLAoHPSsQuWMF9WbBF3hwq9j2VeeotagtXwAVYDUMFc
x/da1lUAswyW7QkrKuQ+ObMnWwHzy71f/BpVaXCQRzTlRI0FDI+yRg4X0ID/
9RPywEdzSI7Y0ZgiRAe9PKPEp5NmUFXwM/TYJB14Q0tiNoebgYDsxy1pWxiw
QZ0+bXueBY9WBpI31zIg6fvEb0XMH/7LUQwrbqKD3a7ha/OVZiBtMSk3XciA
RJH68A68GRD67qmSiujg6H+ATtU2A56xpEILXToc1/6QfgHrm5TA1f7OKUxv
Tm+nHr7BBKH9mQ3KKnRIumDDYWvKgrd6YbZh5XQw81Hy9RUyg+kq87Xo2wyY
jVz+XYXpPzd+iSGO6ZNbkdAI9ZcZWAm2JHwMYIJn7krMz4NYH6bQ3q5hz5Pt
bA8Ei5uD8h4rva1eTJBMTMu752kGn63u8yn/ZoK8GW4n8wILaibwezn+MCCn
5NGhUsxvOkU8s3uuM8G5w6UoOxt7L9CFxfzChITq0nwFbJ3dwt1NyXlMSGro
zr6YyQSRDpXKs2YsqOYMn518y4AVnh1nS8yYUG8o7vZfDwOU3RvvC99mgmYq
KaEJMWHkSWi40wwDZvh9N5zAdObmw3/hJVIMiP8QwVebzIDKvJuXDtTRocVz
9fmPAjrI1eBbOg4yYGioV2TfbgbUfj+Wk67NgN12aS9lfehgP5b8mLSVAS1s
/W3H99NgA1/4ouQYA5JVGmS0c7G+VMJbPyExYIlHKe3CgClYXktteavBAIOS
1A6ZQQpojvFIL6sxoTKd/OgM5ku+bo82fmExISX6XiRPCxkW7uwdmbrAAN92
W/aYMBlQ0ZnO62l0uGze7nb1LQmqpNtlObNoYH0P1x6cT4IP3gG/1q5ifhXd
Le7tRwJpDh/PP6lU+JAXcUzGjwwHj6kcMG0whaMDF44f+0sGjp7ddZzYPETn
s9KHjpNhhDCbLTVDhuLs+YY5GTKcaSwMO2pNhk0xAamiXWR4d8Pqy29rEmzw
9m4eGSbDzZ0j70uNMH66ohL2dYQE1u+3q7jhScCt+uht7wgZjtLaLktbEqEg
l0h7dZEMG6bfrolakoArNar9xDkycL0Nmj36AuN//FXhOn8KJPpnujUeIEHC
eg3fuIkpnD7e5VpwmggHjYLF51soMMb5VU0nnATaekI5jpym0AohIdobMf66
8kSE/MEUxPJNRJeFSJAXWH/YrAK7PqumaOlMBMVc/nyhFQrI++h0irkT4GL9
Q2NboimY5POXz4ph17t6zX/pUuH458pY5woC6HfJ0cL3mMJVC6ud/u5EOIVq
HsrKUyFyuKRK1J4EqRk6c2WBGCdFLplt2UGEw5nECj5bKojf2zXeJkmCS131
8jo3TWFhQfppzgUidJRyTXpEU0Gdt3W+6ggJGN03CZd/U8HY07px3IYExVFb
rOz+o8Eb4nfBT/ZEGEqLyIjTo0Oi7G5ZDezzOE0jR8OZdPjpkeLau5UMweqJ
fZcl6HDuKj5WFkeGBpGoJBMpGgik7lfBYeeRbKNz6Z4hDTIdk5WOk4lQC4I3
ZaeooNL78FNzJRGKtful7whTYX/bpl/yWiSIiV7RuG1gCkpzQR6+V4ggmJH2
Jmo3Bda2cftlfyGCb8q+o7LbTeGg9Kza9lskINjjpNTHTaHB8rT/f1FkeFl3
kJXobgrrsN+umIsCnXPVrnQSFRR8pzn3xFCg+L58/wsJGnw9+nj6p5Up+B7i
TFx5TIPfWXG9/o4UmPHiVJf3pUEg8XW30g5TuBmIf8aRQoM1d61drtpU+L3W
HlwkQ4fypX739xdMgSva9lTQIB2cdhhzMARMoankFPdkE9aH8c1n0x9RoADn
PDZQxYT+z/4yXt1kCA3tdd+J+bTgNkvH1l1keLGty8xCkgX1UTXOVq4kaBvy
MBbWZIHSPVJPFyLCoSbOFrwzEzzqlBxf7SFBifFUCUGFBdGNFfePzpFAy/1I
6XFMD2++sHgb/hVbP99xYoGbGYz7/+OfHCDB1xtLs8XGZiBq7xjruYUE07sj
h0T3sUDB2dTz5XkSHHitdEDK3QwM8Btn1w+Qoc3eIufpFxbc+jtOOepPApvU
nEMfOlngUUPfl+WJ9c2z0ANS8Sz4wZtOYmL1k5qzS6VSmwWzSi4qNTvIcJX1
4MaxCiYc3/W27ro5BXbDn4ePMW769jrFgF1Fgeu7lfYM/mRBar7xcFw1GWp+
WZno9bBgz5nizmv7KVDTiWwdsfUp6ZwJ/JJNhtPuFzPd45lQN4YUWjEd4ijO
V94XwwJDrZcTnZ3Yer5aLv1jssB35vukx2MyPIgSehDYzYQ2GW8/l8cUCF8T
aO98z4TJS+nIF7sv9uNz3u4eJogm9awE1JCh/QZr4x5MnwWCKiMdpCnwQf/3
g4CfdBgcmkq5julRyEvmlYVzDLjWtqbzCijQlSk4NLWdCYobxIx5pU3hghmr
Xb6fCcHZz8V+UU2B2jG4+qiPBcpJHDu9lakQeyHgI/4QCyYbrvk+1sXyxPXP
HIxqFoidWtONcDIFVy1Fnw81TCi9d2vTLczPD88kxay6MmFzSLrjBxkavETl
PuwOBoxuF/o4I0uFAza33F49wPTfXzuncQjr6+iNzDzMJ3agmLfm36jwbceV
983DdLDScv/W2E+DaTO1njd/6GD4dKwwGqtbWW4tVaMlGszjkdrEPB3+bHj6
WeAMDQ595f7o8Z0BB4s3zx3RpMHG8M/8TSpMeMC8f0hLmQ4P4gUHN+MZUIWE
6HwI4yz9vEPWjXSI8+hpbSilw8xhd5aPIgNML8QKldfSQGe/yru9dzD/VmTf
HMzHuN5cyt93JwNyGSMKXJ9p0LF96EqwFx08j63IluDo0Nb+XmSPEwPYZ3pL
9IZpcElB1uvuIazP8kujRuzpoHpOj35ZnA71KnpfLMwYYHuXGjSO8dp2B//l
ORvsOe8ygRWMV5buq9/WTaADg+Vry2HBhOrFqjM+L+hw3uHR7SbMZ5839PzN
eYbliLLN6YlNTKhqWbgTIsAAo5emERd4mLBmckAi1Z0OgRcnJ/LDsXN4LD/j
c4IGobxicnP7mMAnzFFkiuWwtPt2UJvBgAGjofpYQRpsZ5xajkzB8sfnpr49
XVR48+rq8UMpLFBT1lIKeU0FkYP9h11GWSDTUKs8gOW0uP5zF850mMF2R8ln
M0Z08NYnlr2fZsFH9219lTV0uBiiOF+91wzi+HjMw17ToJLq3WWQawZ6uDLl
NWz81jAHHp/bLAjd1vzMPZIKoddf/9tlYAYbjL+/G3elgU218fvhQhYMbhaT
ncH29/Bi8A3edBZQbmgNWxvR4IGfaJ8upkvTp3brXbtFg3LhM0PTnkyINduY
451Hh2PF6io4rI/8pF/iPkdiudHpoisT65MYE/2NIR4MODCxt/5GJBPKjjt9
9cmigy0Xx0eVamxfP5vIW2GcYf8iyccM23ejAdsYj3wG7Mj9cP5dOANEx45e
vL0L4524z3PPsPqhB/g0tZQy4AxM4D9h+7D38FqF8Hs6GOTPHnDG8l/7zXIn
hQqMh8wV7x98SoPSnTfFKqcYcHk07qDaJBU0OO9sf+zKgD2kdlupSRrk9n8+
esOTAfzCun97sD6ePdJJNE1gwJfQxqdXER1a97ofqbtAh8Wypo6bDxlwzMVK
2YlKh+VToW3jDXTQOpfwLymKDvMgu/HlOA36vP01GL9pUHxOVE0Mu28wnFBa
7kmD7tbI3s0bGHDvXP74bX8qJD8dMioNoQPXr3RrWSoNCsvPmS210kBbaXsU
x18afHzyKc6tgwrhJ/y1RrGfG24fF7yiT4W4uYQQpUv//3+dP9c0r5kC69LA
dKgfxtnFS/Lxp0xhiJ6vWoHVnd4B/IaSVQpQM631SuMY0Ee1cvr9xhQyDO/G
iElj/oKsUh4FmwKEX3trx8UCNCh1rSGUAnouAg7tZBbEVB/hGeYwhfn4nwEU
byb8MO+0jcX8sfq/u5YRVky42kzTlE+nwIuY6dtfjzBga38kdUuCKWTy6UT2
KzNAFxe2p4JsCh0yoRE4LHdfKc0km1pQ4NLMeNw3dyaoNHYFG5MoMH1yq0K2
OwsyY/Cx4EUGyuCeruVOJpSgC19y3CgQUag0t6eACd4b8plcT8kweSVkvOAD
A9qmbRPlLbH3a8ZO3Mf847xu4Ap7HNNvs6Z5nWAWvN767SRbmAKVcfOPsv5j
gpPYiO2/82QIGprLNmvB/IR02OmLLBmEpWSmC7HcT1UIfKT/jgQvJfNOen/A
/KrF4Z+PAhmOTSR998L0mq74Nt8P440UH74cGy0WwOY88WoNMpyd+3bp9QYW
eL7ldnO4RIYlWi5NDNNBu4cjq6e9KJBzPGZZIpEBIbu2bFb1NIXkLbMCTv4M
4JG0uqxRT4GOT4FZl7Cc/fr8xXVfdVMYNvpxqMmKAefCla2fEUzBU4bsSMP2
W/2AMtuokQI+c5JGO/Yy4EbGixD0nAwblxIexahhz5dyDrWqUGBEO11TR4wJ
qlmF171UyVCxpaC3YY0B8xq2xBsvyNAslcdbzmbCxz2ub5eGSCCg4nz+8g4m
rIsFri69IoOevGWbby3mn++K+UMxPoi7lJfzC8txZadiaF37yaD8JYp4u5sO
vyyOHRqOI0HT2droQUynw8pjc8MwP9/T0Gy8/IgODlGtjNg1MpD+HOFXXsHq
O/5P81I+Beal2MJbiDRwdtoQHY3lV5PX0XTrThpc9vLiTxWkwv2TfAa/NtBg
/cGsZtQyFXwXGoV7sXwSrl57PGYC47AGGWcPjMeoO4PNDhrTwG4m5CdHABW8
eN+nURqp8N/nrBDfs6bQpzm5LbmQBu2OawGifKbwyvXeqGcEDVxKa8PbBCiw
eV3Ta28EpsvfFwIv8VFAh0nlyj9vCk9utn7a+5AMNz7Wra4EU2FrUhf/0has
Tipkfq8E00BB3YvnKna96Vj84yMrVAj82DeciKOA3ZRs5NgQFYpHpP/qGZoC
rk9oqGkEO78iDb7jQqZALkvYcuY7BZbP3Pkj8IMCWzkaNVyw+rCXt1zAs01B
V7fWf1M+GayOlNyiy5nCpHh9+eQ5CijvLnzzvZoCe8/u1bOxo4D0ET+2zF1T
EO4yc4prJsPqgPqVr2epsLv8Z/CBeDKcb8nLOptkCsESD0oXzpGgMs260NEf
ywOGjv+kekgQfJrsfxbr824Bzyo2xttZEydT4rH1XuvQc5LGePySdo/cHoyj
tpOPx15cJ4PrlK6G8AZsP5728L6booBQlh6+vpIE7vLtVnfSTEH0wCndljEi
8ASazY/cpMDrwDZ+RwcSKIrTCPex94MvlZifTMVyRGSQtigHGXZxP9jlUECE
hFBJyRKsfif4rHfuBBJUOP+Xw4Xx9tvEwk9vpkgQyZsXJyZqCuXso57BGMdV
su5orW7Gzkm3vbtekwz3X23J4/9JgeSUHxMy/2H57/wR83huU/gdlXPhPba/
DZuM3mb9MIV2uqRRCrZeJ68ulUrs5x6lDhw+kRTYViur9lGcAv3mAsqKWH3w
tr0h3f9LgRL/IwaHMihAogiOzCyQQSTUVsKzBstvqb4zzwzJYFCwbVMbxvmx
cZ3KZwwpcHfvf+cErU1BOySiZ9EeW6/3ynLEc6wP/6vSeIntZ66K+Ya4NjIQ
U/axcQIYT9ok4NfasRzSCZGMWDLcnt25fc93IvxI52g59Y0E4yrHO6ZUiTDt
dB8nwCbDAO3WOE8ZARrPXC5ewfTmYsU7hlQfHh4fz+bdjyNBEp9Yh2cWHs4/
ciEpdJEgLSK3wOimCeQKpS1SOkhg9fuu9dQHPLzobn90HsvJhWuy1R+uEOCF
SfiThgtk2J3Y7T6TQQS+TwclfO6Q4D/z7lhZKSw3Phl+5H4N6/fDjpV8nkSI
2myvvyueAqeINRuyvhNg60T8jTtY3fw5drlw2IEAjz6sr02XU+Bk0MiEBjb+
xIN9xFMdZLBmSv8RkiOArsenwIOOZBD9sel1wRIBMr+fr87A9i/Fu72pMpQA
Ny4q1v5wwPbJwSE7bRIPldFlDt8dML/ZNPFi5Dce1stfNsruxvS/4kzbFy0C
+PKib2LzJBDOk938TJwIy8StiWOTWK43TaPldRNgwH+xLFmIDFESYUUm24mg
75Pz6iOWrwmTAWpbsFwcfFObdPIlCXapfZxw20CCbuTVobcJu7/zeV8cpovQ
6Tk09osIj9x7OELek6HxLj1l5zQBrlrRWp5zUDC+MZpUwvKl/AW978+vksH8
w74MKtYXXu/1pM/yk0H3/vbt2hQyeOTlJV0xIcG9gYdoAZvPdpuJGjaRCDEJ
zg2aPBRweP20/0AYET7w9Ni6/yPDiuiWhJQwAhTaVX28LUWG9Vf0zMRRLNc3
l0XPXyTBhxNDltwiBGDWWJUfPkMGlZ6Xdo6teOiZP/Vnz2EKGCfoXOj3x8Ni
rSTftacUeL5LJsbWgwBsGY7kpnUKVEHFqQRfPAg6H5212GoKbro7Bte/GIPZ
xpUFMVssb6mV/NR8aAwco4tOJOw+3wMLA/FEY2iyk74XhuWPtw/9wiITcRAQ
b3cnzIkKbHpusCx2TV2s+db7gQrU/WHOQjbGsPhzNTzckwpStkmno3jwQHp/
wN2TTgOp9UcHdBLwEFG9y+Ev9v7d/TIGaVJ4+GorXRfgbAqvBcXrmjTx8C/o
l6TODHb+q5ITGmIEyFG72/prhgy+cU5eNit4qNrG6nlWRQa7gbR3D7Dxt+m+
11Sow/phRi3nsiUewr78lrV5RYKa+Qs1vUCAROp35WGsP6HobXS+MhHWxtya
UQAJfn76hgu9QwCnTssDaZhfar0kRbHm8eBVlS12RZUE70+PLsws4gEJieYu
ehDBgEwQWHHBQ55B52bSKwJEcB3/3qlHgD0PNFMVsT4QUlVlWwsQIURvVNPa
jgiWrz/7VfcQYKdaymCALQleOGaGHJ0nwI5YPq7dTSRwVgxlPJQgwKbryldm
sPmjjWodzRJ4+Bm7cSHOkwTHwlofynESII0a0W6H5WnzUyFuVdj8TubKz/zE
9EIp4rLplAweKhgP1VWw+5eT7j54id23/VwHhEgS3OHaTBMIIcDF9eNHh7Ux
nX0qtrt5PxFWYkkzp3SJ0Gtk7m0VQwTJxNuCA9j8VcVuyHdvJMEfpUC7I1id
0XL5CaJcZPj0YGfTEV8CzH7kcsgSI4FW5L7hRGwcjSRJWct/RGD7jXvjDhLh
48jHj3b/CPDTuU9Qj0CEbSkvdlz8SwReBRu/5GYi2PhUZkxg+nf3y3raNh5M
70KmXdvfY/rzn3jEDk4yVCVM3H+2SIR/Gz88CJIigVOm5eMHOdi453p2/jhJ
Ak7fQ5fe3yXAc4Udf2Yx32E5n6iK+YyHyKN/D57nJsJzy8QEkf146Mx9uyl9
K+ZLRsQh6R5jMLit3TFLxPRwY+fwWqkJPLtRmroV67unCbdF1LYbw+uneiWS
/iTQ22ZV8XfZGMiT+yY2ipCg4da9+f4jeLC4UydQ94YIgY3bVMp+GYPS9dSm
S9j8nhHP2Iqt4yBaIljR4jnmr5e2+ISGGsPf9Vcz9u1ECCCkBlTLGcPQI5rL
6lsCnNHoatMpMAJ3iytV+5oIwLG42cSr0BD8Fl9iW0OAycMKlUzsfr1A6KpP
JR6KX1mUlhQZwfPMkmtJDnjwLapXPN2MPV+c92TrbTys/Dv9/VSJEXCfG9al
XCeAesppngkDI6jxq1XaPUkAY8FbK4+tDKHPY/p000YC1AxeeqBihAP7tI86
/qN4MEmf4XLTNYZt2ktK1sN4cCtcqbsjiQc+7h33BAoJYGSodb3hGR5suq8o
XdckANf51aHaZyYwRo8vG1onQB2nik5zozG0nSAZdBwhwiubS/W7p3DwL+2w
a3owATyQ9DOGrBH0PrFg6ipgdTEkNpuD7S/PPmZkswgR3h8Mf3XO1xiu2A3v
5sXGr2885zyQj603YNXp3goBtPd8Pu+RioMCHblMDVECnN4lnUrfbgTqTHtV
pxsEKM/4taH+riHMjiRf08B8wzyUgo5IG4GkpdNq3lcC5C9YBpM9cbCXJTYz
PYYHM4GQvYYfDCFZeXFg/TkBTt3gefz7kwGExgyMGr3C9nPdT0/xoAFMvP50
ktZGgNtRH6X8XhlAIuNxyP5rBAi6sSzn+F4POu6e5ekrx0Ntb2vEpwB9MBM8
e9xLnQB0+8B3nDd04d2waG3SRiLIsFH2vbc6kG3Z7dUrRABHQlgJRUoXvr93
VfoihOl0yXfcedH//x7PLTU3sjEkHtoTkHxYBzZv/Qs75fGQrF4+lpitA5ln
HPhtjfEwlkAussrVgq/Bcr8ljAmgtnfmSFi8FvA7RqfbJhJg8Fqx5Zd9OmCl
ciTodDoeEtI0xmyHtGHNdySc/xAelmY9Oep/aIKcFvXz5gME6Ps5ObHrsiYQ
7/64q5+L1flQ5vklLw3YnTzdPHkc090wvKCkizqc2qmKq8Q45HPMix0/bTVh
/s0TfofrRNA0ucESuq0J9tEy8dOvCbDPcaRxpF0Lcm75Cc89JMLLIE/dW3e0
gXMbq9kV44wvvc7r0vc04VZ8z4WrgiQofvGTC/dLHRpWplaPMkmwxZvy0Wdc
FU42RvSYHSDBleQ1Xsf/f39sf1/0V4xnY2Oe9S4Pq2L1m+k6h/VjpI6u6UUZ
ZXCk646vMkhw47CwCj5cHkY4WHfXthFBRCspM7VPAXQ3OVnKDRBghvOD5F+6
LAScyU/w+EQEUtgrNytrOSjoEc3bykWCte/S78XJSsDMb3D4vUICfNRiWKGv
Inz+E5/9Esufo7rSeEERFSClchh9qsN4dOvIV+5QZeB9mlnG1UWGAIrMm7n7
isBU3XRAQYIMpVPn5l+IyINzi9k2sUNY3sr6Ru4UVYKSqQN7XEax+n8T/sU/
ShVotayDLpjPS16/+elytCoYc/fUl/UR4V5So2SLrRqM1VJGHmA8FySoRr/1
Tw3Wz72RqlImwYOjF5P4wjRga18CZYMoxj94USFWhzq8GLCFBREKhOBKtuG6
1eHrxHr3D0FT4AwoYSloaUBwxmGBriYKLJnOjX5lqoHM1RO9971MwShyX7zH
a3Ugz+7O6ek2hZOCni9BQA3CjZ9k9X6jQJMeL8WRVxUU5xeuVydivJ6a8vea
hSL8+igiqPiGDOekyCbvzsvB1UoH4x1WFCiNyunwmZeC94ablvux+bxQ5lC0
FhSHIsqt3WRsvtrGN5rfWYiDYJHL3s33SDC8NrumKCcIZvsvZ8ucxvwqwt3e
xpwbaH/eK53EePrd/Zw+goQA3AjdohQ5QgJc3Fo+8SAnDG2LjuL5TYSe1F1D
L0K54V9rdW/JZxIww0t+Np3igO/V9wVWd5DgXwOtlh47a2Hpj0MG6UTwiaMI
/bwwZJGS2dEObALAzUbXndp5bG57fWJQLRHwrq5mLoQ3Fj8/9ZvskyOCrpiA
z6k90xYPPvG75GBc5X89VMxZ/p/F1k3SkrRpPOxHS1ZOsv9Z9OqOUw5iPn6h
nluczvxgMVedaZNtbwwOssL9mVxP2Olvvkie5zKBLYoX1D9lTrN1+stFnmDc
NlnCKHyyNMyeLH1wJzsY093I0Kh3PH0WA4UCv8Yxzo/0lTqxr2CY3bqy+4E1
1QRqG36cW2zpYfOMnLewlcS4jfCxtf3NV4vXyk9NtESN4HC2S3HWvzmL4uYX
BTn5ODDfUKTGl9Vt8f1kH+X2DQOYxT2rfXl80KLW0UMmfw8O08XQbyKe0xay
gwS9Z304aO8+mPXi67qFS/FOMeGTxmAbsznBwGfeQtDLhXvS0gi+hBlnfTcb
sfA7of4gWtAEUisFBa5caLGQPz84HnYW8y/VsWbi72i2vkOs7VcrjNu9vCM6
d42xVxw/a9D5CXAtOmyNw3yZ/XF0MFd8Ox7KWL0uHplcqEy5Wr9ahwDC1ckb
8p+usJ3LmBQzdSKoGHziqjm+xL6lV97d0E8A3pJ/Bxz4Rtl+p0tXvmcQoONf
JeuhdrfFgbUEqm43HsT272tb3DBtobF53e32RwLEbRKTeMw7Y9EeONGh/QkP
54ZHW7/mTloo9IsptKvh4RMlRuTxhncWUsNJ9HONGIdda9n4wHaIfUxsfX4l
gQAOATuv6OvXWtzRuj9akYgHnvc34h2uPmEfyYCyyHETcDEMOWRw+7sF5fr+
NP1feDhWo7NqozBlEaL2vHMf5qOwRCEPbEljuy13JZh3mYCW6cjrq/FDbMmf
UsL6u01gqUHrc/WWRbaVa8IDMhiDymV6m8lnLvRkbz/fSAXm858iJDLPbkTJ
dF3JwS046NoTFrFVVQx9tymdsXhjAIf/tUmk92xE7+JFly7excHhptmnnxqE
0deWixUDbAMAZT4710VRVJg7+vRNkwGsHuML3r3Ih9rtZEaenMXqIcKlgPBT
FAUHVVFMXA0AWb9oMZ2RRPS+Vxm6XAawwqrQcxmRRVLOULLsoA8hdc+txEoV
0Ymaw+k3ufThk+FWWZUqWWQnZyJnRzEAQ9yasXS0FPrudfQFjoQDkUst2/hU
pZDKsPX5D9pGANyCbU9KZRFXbskPZUND+Jk5avdZXBY99X2249M2AxjW+7nV
p1wBmbXkrB1oxbinLu9sl6cyYn4+LHHumRFMH9xlZtWujM7ryOk2uZvA4uWb
5FMKaihxli7KYY2HE7HuPfELSuj68Hlc0ZAxbLz/+5EIqCLOw8/yvu7Ew/ep
QSG7fDW0nL5nosgG43di9R03gjpqV+fsuhxHAKvXZSyNWBXUnGNZKHiaCOlH
h3Y8tlBFNoHXdqXtIELBWplLo4Mi4mhnDhobEAHM/2xz36yKrAZuBoRhvKwe
9uO/6TE1pLXNc07amAjHJy7dFPVQRaI33489E8D0S31PkY29MkravClFCdMn
gb2CvcdC5NEEoSknT48EfC4FbmeipdGrwyU5n3XJkD/UPvy+QxqJ3j+1RNuG
5dah8Ff2HZKIOXPx2GwJlv/j4ntbBcTQ9KaOz/sEySDkpjj1oJUfmaubqKQ9
wT4v1fzDKWMx9C3/xOwRTRJI3fWsXguQRB09BRNbsPd/F2bVyw2IIu4abpJF
CRmk4vP+3G0URQqNuar4pyRQJlAJNTniKCe7840B5ofShgahd5LE0acDzzfv
iSNDYfc7K9o2QTTCPiGydoMMNgfEfgh6caPmJqWlvlskSMlL5Ytm86Dht6Vt
9Cki/Anrfpd3aI2dMaR60gzz97Vt00XOVbzIsEcg7MkpErQ0+myyvCeMxH+8
0/OIJAJHyLU8LTMRFHg3hWjPSwSm5PfaVlU+pBaA5whYIEJZ7qMSVr0AOvz0
6qULq0ToL8hwdP4qhhKNOzTbVzH9qQ0pbxMQR8o/LWauVxHgwu0qL8M+KTR7
q82u+D4BHkbb+xn1iaFnKSZH9t8ngmFQxI7qSjF0vu9Kd4cXEUah0GZbhBR6
LPNiT4Ajlkcyh13KzCRR98mJxF0hRFj6vEv8C04aZd/6XqNrQgSia+s2oY3y
aPLP3bu1d4lQojxsWH5RCZkPHPqUlU6CHMdr2z3sVJAuS6xuzY8MFvsEFIYF
lJD0kFfZvDoFUpxvRojtlkd/Vay6F1rJEEF8V3IyXxqlHU2zr8DyrcymE9Jn
nksh/46yb4lYjrolEvHtaJE0OpW4bMP5C1tPwYbv9zxlkTbLUyaohAixys57
RXQUUHtaq4hCNglOOtt+tPwthwaXd1FbD2F+nCqSt6NCBuXukrzjNk4CEaXt
AW9pkqjwS/toMZbXvjWOM+f8xJF0xuDOymkSVBY9iNgyI4GIkf98CNxkWMg8
MZY7KYPOSOmXH1Mkg2SVmz9pVgKFbdk+NOVGBj+p+2LeGiLoosBH2V96GE+o
Ploz8xdHJ8/tdDbC+EKpnmpvoSOMmjaIXL/6jQysgG2nuKuEUOyF22dTsHo0
n5iTM/iPB9Uuf/awWCPDph1tXpv2CaH3El/E6ySw8fjqDT2NJNDa1cdpvjvI
wMswGgmgiaLcXzo9ixhPbkk/sR5jK45EnbZvVNhMhvLCnXnbsfU9WF11gqtY
Hu15usHJUgwJ+vc2XDchgWFVT9HWUUkk89vi2RZJMgxoNo5U1kmjmvXLfDis
fwzV97f0KsqiiJX4VF91Mvzl5E4k3pBB0gdO5iQnkOBz4NMNo6ck0XPXYwvo
FRGCn9/XoT8SQy6n0/9AMJb3neY8/zAFESHsxQuPsyRYpNh9entVHL31dklb
PEuENjfNU53O4kj43sCXa7FYHmb80Vf7Jo4sZ3i/P0gjAVHlkZ37V2m0J7t0
qsKcDA/scB+HpiVQUPafBu8rZHBauX5QYZcI8h2ov+4YRwGXDDa/fakYCkmq
cDpoZwquB6LxHt5CiNfIpV+llQJdTLVNZ7D+9qn417V9lQx9Z3vrkbEI2tWb
oGoXRgHDZ4vhZcp8SPzDuT9LIabgosI7YO3Pjz4Q7y59MDWF4sBPS0GyYuiu
z8jUPgoVhqOmDd7uEkW7jYN7oiRogNduv3FuuyD686Fsx4IZDfw57bq2BHEj
mbJU0fpIGhTDvlfZdgvs0W2HcEFjVJjdufT4Qe4o+2m7Y9CdMzT42uJz+LDy
ArvZ48ybmLNU6G+aeTDgMcfmsFcM5BmiAiM8vEFupptdd/u4p/YVGgzH5wuw
NvRaPBlVouO+0uC/Pm7BuNvDbN8EbtWcBSq8WzLQF+doZh/t6/WMdqWB3EkP
bvLKNJvVeTvm9E0aoDM9be+yGthFwe41B2VpUKrbXU2b/26hejsytOwQNt+4
5e+4va/ZZw5WCv03SoMWr+AP1dUz7FxBo9BMTRrgNvnwFBqvsK0t3s6GGlIh
s1yle4coBzrt2WqhyaIC6i1RndvIj842dMfctKVC9hNzzrfCHOiKqw9rdisV
WP1qgq+F+dGmKkpWIbZ/mWPeem7/hJDZyoYs3fPYenWtGlq7xVGd6O3WXzo0
4OPp2Hj3jxTiMfrSGZBEg4JF7Z1GJXLotV+45969dKA7i52d9pVBrvV3cP0u
DPD/+0Y6bqc06l3l9ToYS4f5UJPM1iTMj00d9KinGdA7f+LNnf9kUFSixSzN
hwHWCueDAKuv8zKey9uCGfCCt8WgBut3c5vbGavlDEBDP03i3iugtfZzL20f
MqDQP/D4wjsVdIUwJy3XRoeijXxFjTuV0UScyNrgYwbEjnMqWK8rIiuN5N/r
pkzgdv3tGnxeDrW9ZF43n/n/37Em/ftno4j+WZR5nJlhgI47X9InWUW04npI
7/UZJmTwq+fVHFFBaS8cXn9oYUBC8abo9Ew1VGVoeEk7hQnrcVZhnl3qKPdD
w9rpaBbcHAHcrXgNtHTxYPflB0zgb7n9fG+TJhLgathPucmCwgCDmnOeWqgj
XHDfn1AWjNm/bI0+oIF6aLxWj7uZEG1JPLW0oIn287nrV9xlgnX9X+LEmjoa
qj5xzbqWCXniHxai1zRRtqh5je4SE8rEU089/K2NVCodhdymWNCrkrtZ5pQO
GnB49NHzLgv2TUg+j0jWQomFN33OGbGgVXxHhJutDjp/ZZPE8Qgm4F9I3dz0
UBcZ48u+Pb7FhDHxpaeSDdrI7+OmzZO3GPB0vFySdksbZUalqwSXMMGx4Z3m
LTNtRJSo+aPZzoRXd5o3i9N00QgRE2cvFkxFDx0YztFGPK5Lgft+MGHkZkrI
/r26yIM3quwSmwVad99kqtjroMTQf080xMxgw8qe49r+Wmjcs2Q7lsrguVni
c3kvHaSTe+R2eRgLaheL5G9n66KaIJMjy6FmkKy0wWLWUxfF9VvTFqNYkE3n
j+Ht10Gf7MRjBQgsgJGJH7ltekh9/dy31+dYoLHXdqz2jgFSnd3kNL7EghH1
/Cd8x3HoQ5HWDrn/zKDtiLxk8lNDlGoPk09TzeD1xa67MV/1UU1/2cf2N9h+
hjoff5Koh8LgBmO93Qzsv9A9//3VQxu9l3RfFpiBUvfr9opVHVRms9vsqIo5
7O5bHNJ7rIcWTGnj4pfNQFHv/J/rwrpoS3rie9kMFkzcyL47sF0XSdU2v3gp
xQLuZNoB/zRttMnrUDZBhQmrVzXJo7za6NqIz9T/v+c5tYbj9LKNJjpyraOP
HMGCkjf3owi2Gkio40Sk6woL9CS49tSvayJQ8FQe52WBSxlEC4VpomZv3stl
AUz4sOt198YhdfTZI/7JhgAWxnPH+wMb1dGSKX8o/hAT6KLtTgaT6ujk8ttz
Pz8xgeep8ld2A/Z5E572H2VZQGWKZUW9xur7SLlbrywTrjzUaOt4oY4GpbkK
xARZsKzIi0s+qIEG0z+e+buFBZr4BDALV0M9SmWmRCkz+N31K0smXgWFdr/N
faJhBrVuU78egzpy8O7LdZ1jwZLamVnfDBXEu1gaLjnAgpq56HsTWQrIKjSD
clSCBecvisjhVpVQx1sd/iY3rJ4agwS2shRQvetxO2IaEySOLOEfO8ug5uh3
7UkHmXDwzpS+5xYFtHmGebayhwENX0ba3RZlEOkS7lsY1q/hWQ3X976WR5K3
bjR5JbDAIWfZ6WOnArqfxD13uowJ1ab3Wvi75dDBi9fwNBEmPAu6KDB1FeOt
ExXsZ6IMeEx7qKEuKIP63F5PbnZkgNjQA1smxgNycrskpo/TYcOIzI5XelLI
rPNqoeo/GmxdC+Ouq5ZFA+93CD8vpkPsl+S386VSyCinQ8VYgAEWse/ucq2J
oS1l+012nGNAlkmtQM5pKaTU9eCb5Q8G1C1b/Sg3kUNP3GMuJw8zQXy0WpY1
K4cKTDXu7nfCrh35L/CVSSPSiWa12G9M2Dqw1MtrL4GUtYPvumHvRxa5qRlY
iqPujsAjc1h/S3d4+pibCaPXXuereyoxfZyq+O/PjAiyApzvL14G4MczPyiO
86N5jX+CXzfQ4f6myqywHAHEmCkJHHtHg9+KfxLqasSQ36bNJFsiDdqCQ/WH
1QWRy4mIz1cZVIiu9jYVUBJAe8tm/FLyTCHSEFc56yyKlo5G4q8uUsCPEBS5
rU0CUbbun5dcIsP76utp93kkkbLJwAOaCxl0nB/FpWD50CDH6/hXRwosElYX
OWPF0Pb0ysDzKRRYGJM1f+YnhfjEI/HBu0xB67jQZpWf4siu6fXNewkUcCAG
JA0ypJDO2cGpmv/IoDekt/jrkCx6XvZOuyuCDHwDr1TWORRRzwZ+4cv6ZHjZ
8SvdgYSdjwFLmMOVBHbs4JZGzN+2PT8mutucBPPFIc9VF8RQRlZVzyk2CeS+
CxTaBUmhgVv3G35+wni7eD7EU1YGVXTs+0bG8kEie/mzkagC4vj9yy/HnAiR
XOMv22xlUeNzN7+QBCKY659au35MEu1MnWterCbA6R+F9WmPpZHS1Sprxl88
5NfECrdwS6KMfxfcV7QJ4HMryZvbSARliH15MnAFD4Exbffc8/lQrNzReYss
PAQ7Pjz7zHSdPf5C5XOAuQlcFJEwmXnHic7f7zPtDjOCc4yif7VHeZFM8rmM
aroxmLsOzU53CSFnYQcNx0gTsJiJyablbEANgeyVD6XGIHY0T+bcjTX2pm/l
d4PkjeH8v1Kri9GT7M9NM7sZH42Bv/5+4XfNNXaCglEjwxkP7aZZSrt8uFB4
Qphe6QtjuDc0/aqIwosadR/H0w4bQ9PTSH+xymW2L79S+jtLI7jC5h9wcv/F
bsKXfXE+Zgy7M7pzIWuZ7cxzyicxCQd8F2rN/pass7ed/a66qG4MIwryMs13
eNClI8QpCqcRnNJ76CqtvMK+TOQL+ihtCFyJE4+Gt3Og5IavyZLcOGjm1q5j
+/EhURKEh380gosSFKPEJxtRpJP787MIB5sWmb2hq9wITZ5XyNc0BGJD2L6/
CWvsqydxe5U0jeC58Mv1wXer7EKVk9se+BvCuzMZPRPf/rKXOR91Ju0yhD3C
34x+JvSwl74TfTbkGcKBzqqjkvMjFlUX1PjyDhnC5ZHPVQdf97B5VWoDxr0M
4d43vcytf/6yc4xS0/X368P9ZxIdu0dm2TZUpZ2T//TgfHxus13PO/aeFany
+wR9sEjvvSx58IdF0Z5+NfoRfShZcNJ5+OwdW683Kj72rD7M51HfaxjNsXsC
rXKT43VBddL+8kvdWbZ9+tCd/Yr6YHAsJ0F4YZhdl+LjcHTGACrwBbY8Ki/Z
02cs7HlW9ID209v1fexntuPrKdH3Zrog55daLZn42KI75aHAjrfacFwkr8zW
9j+Ly19uapFKtWBw3SBr/1QWu/K6s1Tmbm0QbBvktrk9yd6jb3LtK5cOqPVd
O3Sd/zJ72SNJ0v6cDiTMiQ8eDZm00M5J1HJM0ANzft/I1vDfFjPG5yyc0vUg
90rqo/vkBnbZaCi/cJ4+/A19+h9lbpK9+d3e1i8LBoCzwLeaZr1h364Su3ro
gQFoJKS3r4qMWxh2fKuhDhlAruOEtdv8P4uc3mD1DWRDEASX7kS3cYuvIc8e
l0fpgwSzxDdo4zuLybjh0I2lBnDpR7r/K4lhdsLht1sTW/RArPXA9jbZTvbC
55omXiM9cIhbd115/Yf9Svj2xllxA1BT1vm+aXqBffZkT0Y2Jw4SZidkw2f/
sbNzV9R+7cLBHXho+MZ1nH2LUu9lOY4D/9UNnYmx/9jBXNKjMzNGQDAwOuV3
8xd7xhTXyfkQBz+lKJFBu5fZDrFh4t4hhsChLrnF8AA3ktsR4QdVBuA4FXly
aHGBvX4nt763Xw+kdr2rNfGeYb+gnG5ZtNHF6ls9P5bjH3t/3SN7S2l9KCar
j+QMcCC55q6WsmYD6Hhks5FgyYuyb7i7PIgyBP/QxG7CIyFklxIQ+HBcH4bc
nEvoH8RQuPG+tcoeA3CeEJdjpG9EIJHm/bBHD45PiuLab2xEfZNk2ZdgAP3F
xwM+LPCgl5lK/jMOhqAQ51Rhtn+F3frqVePvYgOoswm+1Pn4J3voROqhm+dw
AHcVjOsODbIjovKKr5TjQOps1LtRzgGLhDsqO28nGsNK5c+WuY6fFn3kI7o5
WiaQy97e/epWI9vUxGBEzskIFEiHJMzHBtlRH26UHCo1BJ+LS6WzuMsWDO69
EZQrBhBVwaVVmf7LQox/1WlQ0AC0Hspe0aeuWnzpMiZeZOhD4Jeqj/sZExax
LRZKQe91AZ3VZPLgOiwEJ/8TYDzRg+8Vew21/o6xlbxxi66NOmDfNkBTi/qP
HfWdR60daUHRsyXU1TbGvvBbedy+RgdkFI7VyJztZ4ul6hW9ZOtA55G3T097
L7D7RJIv8hfpQnY0n2DTKBc6VLHts3iBPrCVz4VM5XCj939eqebd1QVF1zO2
Pjc4UQJV3ubgXX2YeVc8/uULJ+oi+G1Zl9eD53VcVSZdG9Br+kX+tM964I47
KRxiLoJmyI9tCE8MILXS9r0q5ndKxZypMwYG4COz85+AkwC62hr1WElbH15r
S16RPc6F5CyDRjItdaGjN2NPjCQvMvNbXhFT1AHGq9tBqEgQ9Uvy2uP9tODJ
E9X1M42iyLKpc3fBWQ3IEfw9Hs4QR2l7HE098Jrg5W7vUbMqhbiE/8sXMNaG
QAfi12MFUshGV1Fa4LIm7C5v3PXXUgLZxgmPblTWhPg5R22zOiE0JTlV4ZCt
Ds3mf0a/zoihcf9FrWN3VSG/9qLHZX4RtLe39G+AFnb/wBN9sqAEeqQbbgEr
auCXkpwsxC+Dss2aWoQWVEBtdZbD108S2WgsV27cogzXmzZqzF0QRRVVYeWT
MfIQaDgTliQljpJGz4qfeCYDpyml2y6uSaIz5qsgQ1GANGfB+Qe8MsiMP4VD
tFkG9u+9avofhxTaLKNyOQYU4JZLskD5jDQqfdV5autvGUhoUxyaqZdEI3xq
l48+VoCii7v23V6TQnL1YcHK3iogJ9rTW7wX899Tk941R5TgZ9bV9Yf9Msjl
j9A+f6IiPJI8knhCVBJdlnDtlpuUA/Zh4zkdTxnkd3A8pGCjNFhzHd+lYieL
ep79LjyqLA4XLgoFXRaRQ+BNX0uTkIB461cyrjiML+SOtxRYiWM8nX+wwlIM
pd4d9tS9LgWOrYU/rhySQC2bnT2PbZcFK79pVW9fabQj+en9mhB5yKz9FBHP
JYGUgkTO7wQ56OVsb/qvSxolxx35GESVg55Vvm8DXfJIOuUb8/WwIlyhsmwi
gxRR8bny+o94eThOLDVR81FBh+5deO+9SxHuKdlHHRxUQ1JGgVweNqqQ/Z4n
9mi8Gkp+ofXnipM60An+swnDKqii1GqwTk4DLh+v2OJlq46OvYno103RhF+v
dq8139FAZejBtTQxLbhw3K0I91QNafi/iu5U0YDhePVjm6zVUKNffvdakRp8
owm/bR9URkn+c1oIqw9WhsTzgm9qaCNcOlAfowEKOU0qyrs1EAucvfckq8Fw
pJL/lZ/qaNW4mmAUrgEZLpqGLtEa6G/AJ7s7WD1/sN6sFRWthk7y1m1KjNMC
guSbWweL1NCmGHc2eVoL8F2dktszNBCn565eK1st0DSJitx6Tw1xzg5ve0/W
htnT2Zw+b5XR08H+xrhBHeB7diddjxObf6vQf2lO2lDz+HEB5xlldEU8dywn
WRNmMmQEKp1VUcl3q67gGG3Al0fua5HDnqc8O7Qwow350nFvXwpqoBRLQmfr
SV1Ijdx9r2m3JuKQPxvDO6ID4R27ee9YaiNtgozegQBdOLotfpOrsyZKaCw1
8ufRh5rSp357NTXQ9e2XE5SW9GHq3xUphTFN9EPhhttcsyEkLUlSplY1kKn0
yegQpiHIbxDx/SWqjnjCJjxXR3Ggc122ogingRzOlWfmPTSCa8W6XVKcWqh9
5JeY8G9DYI67zr38qYVqrmh6ZaoZAHkksf9+pzYS20Z5pHDWAELkT6g5tOii
5O+NOva1erBF8YT0hVI9FLlDYL5eUg/a/nn+5mXroK917znW/+pDedr3j7KS
Oog3JeJGZIg+vD19MbmMUw8RqLRKEXdDGPN9s3+kUA+dNXzceOCQPlh50RkZ
ynro5HqHq6qoAXz9/VaBi8sAiYV3vi08ow9RA49sCROGyFK1t+4S0oNVeFab
326E+gJbWgRvYXr6Ojrn8Lohij0ckXp6jyHsrxPh2vvXAE1d7iTKIgMokTcS
GfuKQ3Gj3+jvlHBA/fjrfZuzMRJcH6zR9TSCeC5P57ZnOIT2n5t+l2UMHp79
n+66GqPzHbPpY1k4+KHpui97uzGqPobiWGUG8OJP3Iull8Zo+6gBXb7IAPJe
eids6MChltmCkcgU7Lxm3d68iDRGfHhX0CzVhxv0ez+UzfAo6mbjh7piQ8hb
1j+aq4pHHPsYWQ10jMf3j202FTRBC3u36iZ14+DMK/sbStJGKPuseWjNJwP4
pfvrRfYfHHJzir7Bv6wPO56Y/81BxqhvpDA+pE0f/P3cjq7txSM5hz53y1E9
WLyAEm7bENCynqWewC0DaNEJWbV5hUe+iTH8erf0QNq0MrO2FY9+T5kq27N1
Qb+iTmbqmQlavMl3PRXzD5vZ+9HFn/GIkqcvVv1NDwSLT53rOUZAwz+PnOi8
bgA8s8WPmxfw6JPmv/2JxgZQeeLRn1srJkhl1aD+pbYB4BdypJ+uGKFLc/22
dZcMQfHjMLE/wAQ11G3/vnXdEGaSrisWhRkhywvFg5JYPajsja8ecTdBd4QD
l+u5cPA67S/Xu3AjFKtU7bWGnZ/oBZnt8rwmKPoQx98rhTjoTWzbZopMUKbv
2r53YwZwpOvIY84nxmgo80XSxgIDmA/KWHHxwKNIPheVV2dxYFrhKz61EY+Y
I8evydgZwglupdj7Mcao1q/AaUTFECTlLkmPmOPRDqIEq+oKDnawBOu7VExQ
9s2im3etDGFTZNxR30Ij5GdS/SVMEQfZP5+/SHltiDyF3rfmSBhDROU944pg
Q8S0MZKovGcCh/92p18swqEoGppwr8HDq3orBf0CQ+S+/15E3BM8cNltXdlR
oI8M++px1tJ46Kh+l7VH0xB9KNmmOSqDB7O6OZa3pj6qEjcYVbEzhq9DXr3E
N/qo2fduV5g2HmrufT0Y/1UfiRGV047IE2DFUOlNyUkD9Mtngj9GmQBVGT6e
D0/qoR+VOwePuRDglNn93udBBoid0H3AX4IIVaOLxCQpfRT46A330QYimC3x
Bm27YoCOj+39Lf2bCF98q7XNCvTQto5pquMEAQZc8mMlA/WQwANhz9kpPDzU
SvvSpaaHckcTCoOE8XBvbnHWhaiLMt/IPCeuG8NJOafzWV/10M2T+0jBh4xA
9lH7umupLmqpOBMdzGsEV0s4gXRPGwVOv1o14zCBqGXDlP/mtZHuzcUtrDYT
iE/Ye7FJRQtdzSgu7P+Kh5wJw0VymhYquYVO34jGg/0CTqy5RgMtbGFOspUI
cI2/OxO01ZHjhwbWLzIeVIzErknbq6HKdteSPE88HPxBXf99Qwl5jV+1q/tm
DAE/44uD5RVR40T8m/lTxtA5kVMawKuKajri0lQWTEDr95BaWq8a0nX8JmG8
gM1/q/Ldo5gfIs19apOW2PmWvqTaHNRArn8FFjLuGkGkc8ztpiJNVOvZHGiV
YQItIoN/msy0kCt+8oXNT2y8+s4Br00aSOxv/bwIlwnwWAXECZ9WQ67d3kNP
Y/BQoJlseqZKDUW8oBZeiDcB5zk+04d8Gmhwp/0NAjcebDLawmowP0lzGePV
DsfDZdGz9SbD6qi24PFHUSoByHpPtyKiJnI+f2TjBn0iPDq4uvtisga6GSr9
wyOWANv1UbL3RnVU0Gf5NTUBD/+EFIjLlWqo68yOnYIF/6PovOOp/r84bhQS
Gdnb5XL3sGf3JCEUGQ27lDIqKyNpoQgNyayU0fhGKEqp7hFKQlZKVDJSSFRS
Qr/7+/M+Pp/7ueec9zmv83zdx308LguUtFP3dtwk4Fvx3Kx9ZizYU1kmrZ2k
jZSH5XZLclhQXB35omqbDrb/d5cpdIQJIv5ryUcidfHFMIe/7TAvvwMetCOR
RLzYnRN1P4kOjPlEKcITIurfHdv6cDkNovtk6p/t1sbNT/Lzl4nToVa0Wkvz
FgHt74QVeovz/Lry04r9SMCoC79eSx4nA6vjTOQ1UW288lEw4cYjXeDIe2pU
fNfGhhK1zjR/HWi9y7H9G6yDGfqzBu+sdEA+8F+x0B5tFBCdqM0w1IX/Ng4N
vWbq4FDwapNPUyTI2L58oopJxDUvtg1q65Nholq3RMBAC4Uv6PokRpDBkDD3
SNqE1z8vXz0by9KFoxl30ok/NHGmhZt/9yIRDLdGbee7rImqx19ZP2BpQ0P1
TdVvJhqo0v1oOH0VAUT6i6XVyjXwzExMXk2HBoTkJy/ZLEfAIweizeORABM/
WY3ieQTU6Kkvs4vThmcPLo7+y9HEqo7OgfFzBHh7xfreF0MC/vTMSQ9yJsD4
3V9xYWxtfC4YpVs7qwVrVKOPRGwk4tDeLdLhz4mgZq63maGjg0VLRT7MfiQC
13/pWDaRhARd5xVyQ1rQc3iP9jNBEn5033P75yAR/Foc1N0kSJh6Jzbszk4i
eGzKDWr8R0ZCByn/HFkHvNb4une+oaLH21C515t14UXH0smVPP2VTRh+zr+F
CAt+xr7EBDrK5HXvb+Zd17pzb9vSDDoWyJTlzMvw+CXotWXeEhpq7zVeItSj
C8eFlP0vrqCiqeXXc95OJAgKN0vXV+U1oXh2hfBNEsTu1lodS9RF0Z6L9k0B
ZOjqLotr4yejw4GXRZ9UqGA97HcSRSlYq1f0fLUCHXLGp+VOOVEw6mrjx3pZ
JhR4pHkoqVJQV4Sd1MSbl4BbLiqSZJ4eLTclXchlwQ7dloA6CzL+OzTJbuXp
3zmP2cOCeRQkmq04vbqOBVFH8uaCLWg4Ot7W33SWDWu38DsE76Tja8czqjeq
WTBzMHxByI+GP8t/pArNsqB/Lj/jXygFC4Xc7kcsZYNl7T07ZigNx2+2FwRN
sSDFWe7EWBgFTS4+WtmwmqdXo4QtVp+puJ04H1kpwJu/1IJb97IpOKu6od7j
ExtkRIw7z5bx6v/F4LHAdj242z7QObCHitox77O737NhV6tMVRqRjrv8B5np
LDbMxG6rOX+BgV44ZXEygQXeZf5Dc7x9tnn1rQFNbV4+o/dS3pgx8CAVg988
YoGUfs1tm24menzeKdm4ggUeRdWHvhSz8Ob4nS+dxxkQqXcjJwjY+Oj+ysBv
H+lAUH+ttWIDC483Vll3nKVDfF/qy0/2bPS1PXZrQIwGaobeh4J473fvbP5L
Ok2HjH07ZZp+M3Gko+GqcjITXA7tr6vVYWGz7GPByUkmOMiNPx/ZzMAhc70N
Lrz6HdEhvKi34cVPsn9U6cqGH2+WzK4OpGHSS0Wxf0Q2sMIUGXG8+g3J/7fh
jQ4LrlhGL9fKp+DjR8Nl5WpMqIgOftlrTMPhoOomiy0s0H/146cejx++xl4k
/HZng93DWWWD+3SkCPU24g/e522oG1mawcS8G+Z0pYNsyNr+QLRigI7yH87G
HhhmwcS+AYquNQ0bbgmeau1hQSXxu2DIGgauFWq1DWxhwsGimaxN3xk4LxV6
68sIC2JtljZ2iDJxOLaj2Og4G7qKS9kC61nYYLU9o1ObDccJCqMJPB7T2EHM
3ZLJgo4fInXZ+izkiGj7BiiywN7T677CVQbO7s0N35nOhIjrz2rS6mi4XFp+
zr6NDg9VbBtFaulYc/+kfACXCV0xHmtDgY7ZpLzgKC4dNHt3qCbZ0fHL/dyw
xmdUuP1O5fW1CRo+ufypkuBMgY2n+36esePx4NcRL2k1MqyQLnmleouGdnkX
H9nbUsB5aGHQWJyKe/UTWqe8yfDmSYvWj24aGt7a/PlUqy6kTNbzScsw0HZT
yFWjIDI8urv0wvwwrz61D93Uxymwa+dxhvc5Ko5tfvT8XS4F2s1XLB1Io+Pf
e7YHSKMkiKtb+drnEA0/WQ9b+vN4rSX7M6F9NR3nyM7t01ZkOCnBl2o7QcXA
P/8of8IoECd8Kv48b541/O5+8Jnh+Zd3d8y2XqLizFKChcZbGuwQv/fHvpvH
J5ETwhMiVFDy/jIQvkjCLZtWxnWnU4DJHsje+42CtKoZjvIPEhQ10Ds0NGlY
S3AdK3lLAU265aPGRCrWmfc7Jg+RwAUNPdqIVLxcGK791YcCXopT2/+1kvH3
da+Nb6Ip8KrESmIHj+dq57nXDxwngfH0hUNfbWjof6jiqcRxCvj7PnJcrUfD
I4nWm1lAgzB7m5/iLCr2X7jZHyFIhXcetolNF8n43Kmkw/koFb72vco/VKaL
bfuVs77yeHPZiZuq6yqIaLtiWuVjDQU6D2ja9DVqYdSXu5n1qTQQafY+zJ+j
jc3b3u0qEqJCDjkqDhy0cI/QusuHRcigrLzlRIm6Fp6qeBZ6ZzcZtl4JEDwh
R8SYr9TLI3EkcDubmpnprIUH98c8IvHOL0Rao2RnqiZa0YaNwzeS4K1ReWzw
Y3XkEoWPftygCx+F1t1Xz9XEx4t7M7M6iSDlc9/FyUoDHzvstm7t0wL9t7//
mNWr49i7/SNeuwhgjR2E76CJHr0345SOaYFJcfYZFk0dK0QOmc+KEuHvgW9N
e3h+nSy+7/itGR1w+HtfdzOPvw7/NJMy/6MD+V5l+VU5KogUr6ZX/TpQrkdd
aZengKFq21VrDvL2+fr9CSuTeded3XyziERwbAsOlTyjiJv1K9zaCUTQpKqu
kzkjixpUZ/LhZCIoHHTjO1AshSKTsZeU9+hCm36+2udJaaR/CtZNmNGFq5HV
XSPP5bAN6OrxL3XBaO5Dzf0WaeRjbvUu1dGB6PqDqhtEZNHmrPAR59+8ehxT
tDzusxKzZ1lxRC4ZFooMqa7JUijw5zT39SkqhNaGeNiUSmB3oMPVktc0+PXl
6qaAk8tw6R+Ga0IPA9btfzhLFliGPkTDh6/38Xjo6SUtkh8/KgSEtJyPpsPp
sKWp5XP/uGVrL766kkaD2GjhnSH109x6+1Of+yboMCGXNF+f94b7M2znPU0J
BuQlzaofVf3FPZ9s8K9lGR3qFgZco+4OcAflFyztD1NBAhNGRU995/598aJc
UpDHW9bWBn1GA1yZvUsNPg0w4P323OCvH59wT/u7LDX15u3PO81XThZ84T4m
zDUOuzLAYA+lVfLVHNd7Q7W0HI0O76sLztxJHedShQImw1oY0BXd63dNdpab
GHbf78g4DeCvg+fLnGmu8NGYSPtaOmxasvoHWYUPh7iKLXcaqAB5N7LOUxa4
L5uG19Q60UBO1Dpvs50Q1n1JK+z3p4GkML/xE5sVKK03O5P1jwKXleYcP50Q
wcNm3pysaCokN8617tGVRNq5fd2z0WS4kjDl922DJFa41N4lbKbAh6LtCyc/
r0TVRM/oV14kEPrJf5vtvBL33XN4/OiUDoxqVB03yZbCg3bWxmfNieBAVg3a
kCWDjS40d8zVhuLln/s6ting8kTB7ydydeCN+4Dz8zUKuC49a79Umi5sE4+J
nH0kg2ktsSb14yTgHmV5kK7K494zhbZfO3RBzaQnxspJBv+GHzvuw/Pz+7qt
cxNnZHHbHs783qz/f79O7zLn9ZPevF2fFz8NGIcHydemFVBk5K4A25IGG8Vv
i9/8LYNZddfPVJygg96Jr32ZY1JIareQscplwCXLkyW6jrIYeUh80M6eDjcv
nr6U5aKAzW5nPyXw/Ebvd5N2RwlFnEvc2hE5RIeB4qgpYW05vGr/p1nxOg1O
Jb6MeGSviPpdV2DGgwq2fMlBrm4quLVW/QEjnAzTI7nRQVrKqLnbQ4CxlAoi
B4+vEs1XReXBZ67E61SIydv7yKFdEc+lZh4+/YACkVnX4309VdHFd/kpbQov
X+Wjx473quNTpmn/qD5Pb5g/y26UaaJWuqfJsnkdOEqHgHx5DcykuZeOyhJh
cGdXZs9XNXzPLHvCWasF8iu2iT3lqGL7h5HsrTaaQA+dyB46pop12WIpl3nX
j7Mb6u3uq2K8xkG7KKI2SPSprVO/oYFREScfWrcQoaMv1XzguSYqfX7xqJLH
q1euPcmdLlbH3flBW8XNdCCAVhASXaKMnb2q51yrtWFj99IbnzlqeOG90YWh
u1og3PNKxKpfA1dfTxzIKCbAt+PZB4c2q6HRwS/RxvKawBEv+t25VwPXXctV
uWmkBoSNm2Iv83heOsPznLuoKiye+ZW0Lk0Vk6Mjij5LKYKBzI/pWQlVPB29
dFXySRX4SNiW1i6mjozzY7u/BytD4C/VkO9hmjgUFtHIrZGHaxCse8iAgLQP
dSL2rsow7Fq5UCmthWnJO0lDq9TB0z+23D9GCzM3hFancZQhbNhHvvWkFl4S
tFexLVeCfyFapZVJRGy53babXacA8P1Fo46NLq4+MrxIH5KBTZ8cYLZJF++R
3pxp2CsLIsFD9Y9biXjS/0RRvZocjE4k6nm/0sILjbr3u9JlILdj9cmDpUQc
eSzpRF4iB5elNO+KpfB43GaUnZGjAFSmKeMJvw5KGKkmjLjIgTWFG0y4pos2
g3xJp/NlYIfv7fGL+8nYX7babPHJSgieYy1fFkTFLPL5A1c0JOHShJ21diYF
v5WJfglxlADzDAWb9mwSuv3IrAs1WwnHGr+8iDhIRpUkctAPtiQccd7y7CaD
hMs+Uhbzv0nD1CtB6fNFZIzbNVUb+lwavqnP/TUtoiLJMSaveFAcXhPSrj2Q
peJykQXtD23LwLqcz3lVG49npiovdyWLQaxBGA5PUHCg5Cb/+MklEKg49/7J
Kwpm7rshqLNrkTNTevXbpAsNxX2flk91/+ZsWvK8eliPx6efKbuYhZ84Nqy1
x19r0FFV0vRVwfNPnF2Du/h7NJj45hHBb8TnLvfPtkfqDl/pWDhBUI69OMGR
j76aucyJgZ/LL2WJCz3gEo6lxuRoMNCtKnnk2Ksxrsw3o+cHn9Lw9/Ylj/Zo
NHANSN6kNZYM3MI6uKbu9Ajn/NWbccs9mPhzULn9sGgX97MJOaqli4kG7200
9P+Mcv8aTY8vijJwz8ElCc3/prgPncnTDdo0VMjfcDJv8i7XacebHSb5NJRf
X3PXR3OEc0G/ZHaSF9/g1r5Sl99fOfv3lWr08dPQis+nPFq0g5Om5F83mkTB
VpMVpAXDUc5jQmhFvSMNpanv4tM3fOPckfxxQNmCge26fy2rtLs47YQKl493
mJgpLU6rPzDFqbgFKSGbGBik829jijwfFG0N2RHxk477HtotPpURgr/iprmC
V2gYI79j73ZhcZCeHD/D5J3fJqmyqaQ6KSD5+H+jvKRhnm+gjmStGCxbK7ul
/T0dPyeftK0fFgLuWcGllUdoqLH0s+CJjYJAKs/aU2PPwH+q5rfy235x4kN2
aq7mY+DW67r6AexFjm6owprQp0z8/fxlAP+dpZBi70TfWsLAAPXrsgMhfzl+
L5OW1ZxgYKKK88PkPAGI6h3anf6dhkIvVjpoB4qC4VvJqaZjNGSk7YqofSoI
7UsO6QxfpiPhsbl4bMcyuNhsN7J+Iw1NTq0NP58hABY2YdLWMVQsoZp86lT9
zXkiZeC9n5cvWWVYdPz0GOex1G2HhyQq8vVUG+Sf2sjJZTi1StvS0GBcWoHA
bOKGbSy9GuBMwaLA5RdyXca4BjWrNA/3U1H2UIDb6fxJ7hGb1bcHX9NRrNDN
PNDuH5c/3yVe/jsdpZdt1NigPs899Cedypinorn5ihcJIl+4WTPJPoapVNxS
+PKTE3eKm3JrMnwvj0dzei5vLHb/yE2XNv2YMKSLU6fmdHKyR7nN0jcDA74S
cZGb9/cQdZjrkX5GY9OUFrYnWnxbsOrjCq/pH9X6q4nxpVttLtB+cN9SNmk7
gxYG/LA//k9pgfvPrGTocYc25owx9yz7McsVjDx5fO9dHdTyne06Zj3E3bGr
oeJJBxEv/5v56RI3yzW1uHvAnne/18V6qyMp37kDYSknPMYIuPYPd6e0xSJX
6cPPg8Lpmti9O6DmWA0fEmcN+oqOaaG1VSkheHSaKyiQl7JHRAtVms5lpV5+
w93R/NOrvVQTdzw68kJEs4vDuBxeSDXWQKGFnAH7r93cTSOFL+OfamII0XzU
tv8H19Mr9bLyrAYSnMk0Df0+bv+yHVHv1AhoulazhOY1yHGLf1K4aikBE4c3
bLOb/sB5LJHiUSqkgT8ZLeKfQ99zaRsY+tdJ6qj93x7Rd8IDHD6m5epQAQ1s
K2BN+WcNc0QtK06ZLGhiY13JAb7cYU5i8HONsDl17JQyyTTa28G9vX4vObtZ
A8/s3TLzH/Erl+C3tV72qBo6n4hQPJB+lyPx9k62eoUaRhcVEPFNN1cqc4g1
vpy3z1w/bY2SGOEQj7EU77spoVqaPyElYI4zYCW88VKnInbi3U7qpAD8XC/5
Uu+iCs50UBi3OXMcb9PaR6Xe6pi7NkmUHjHGSfOJUeK80cALES8vLu1p5Eq2
Wh0qrtTA0J8JL2SInznb2Bz5ZZGa2NNyaNtr51HOuX1ketBnNeyJfvOm98Ug
Jy1mqrfsuxKyXNjPl41Vc8KqBkb37lbDgil7Tsf8E+7rwrn1vYlKaKCalOoQ
3cc1K6qXKvFUQ/fTDSt/E4e5f5JfKu4LVULbF5HdieN9XKlV3Lz6BDlU0TXP
PH+ohrO+df2bD58UUUFGr/beSeT6R9v5q/DLYRa/7cMa9yHOVHnToti6lehz
Jm3/vojvnJS16+IcBiVQ79lJvat2fPD59KZL9mpiGDT8oCkshx/+eQ+LCJgt
QdqO+EmjA8JAF+y0uZe/wHVOLf0ifpYPZpYHCW1Jm+Gq73dZlRj5jyM65hM5
8EAA9/rt6aC3/uZkvqv4VvP5F1d7OGV0pYsAvH/Ypzryig+3NlZlOv/3k8Np
ye8p2MmHZ6aWGndUdnLkx6zVQ7X4cPGsNx7IGuRkZZ1fz24RRsCsm5Ml7RzP
ZMrhBV8JzLqQ+eaqdg9XmNSqEvVeGnd8/be+jjXM0RXMNla+vxK/NXhbdJ8d
4FTlPrpz4rY8Vq2znfdQ6ufGWd5wGOxTwOLf7B1faSPcO97vJM7PyODWtAj5
GNIsV7yE7q+8Tx6h16buuZYAyneHmBKJspgRm/JuE/9f7sOZe6U1g1LoOVkn
khy3BKWFhg886JfAg+nPDmpH/eGeZhbsSR0Ux7avUU1TS3g+4e6LowqsZXi9
tFlFcKqZE7p/o/1duihWqXe+Y5xp5vT1M4Teyknh55aSd6cPjnJ/1z63FQiV
xpi4RbOYpnaOleXZ/xyfS+Pw62PthuyfnP010dd7efmOr2igqvwc4ZQV7kpP
0JfAUPNNE/m6RdzA4qeqlV7SGGkof/zj5kmOVXmnydNyKbz8Oz3p/dIWzinX
tmHnT+LY3sNv75fVwaF1+kyempbG0kbRZsbVaY5VyBXPTUxZnOo/LLdpzR/O
9xAV67v/SaGL6n4z8RtznNrr12+0XJXF2QefvspHCULn9vUh2SYK2ETXFtj2
RAhERatOXjsng1M1U11tR1eATpHlk7TMlUj/WWcnuFQYCH+q30xQpXEthZs2
HMUPMbcmjJvFZFGmf9OVpn2LnMudNZvmDKVw/fy3giMJ0xzHLWrvHp1difJO
I8sjPg9wnkeNeja+k8O7jz/cbwn+zQlTl43QuCCHb+5P3zrCN8zxKNrhEzYg
g9fqjR4413dxVGekHny8qYABfJ7dbjUfueHX7N34biuhmJOd3M/4Ds5DGiUx
d1oFv0uYrMtv/cG5krqGwB1Uxmtt7aYZjfwg7pYSKkRVxho86FvsswyuXewt
zghWwTGxxrUGRgLgbF4rZ1uohHHZ18aT/fjhycjT2++uyWE409DdjykCBwdi
NsifksHqY+4brGMkYF1vVfFGQzk0uXMgxPaWGJSGCOisnFHExT8T1SlLpcBR
Jn8Vc0EObcVKuqa8ZeBo6INNrS9k8JNr0iMZH0l4vOHBPuyXwaq2kNeZbjKw
Qcl6IXujDB7RJCk9uyALNFMRzXPKCliw9hMtNEkRCvWuH2RbyWP9RhX+m+nK
QNo67a1fpYRK46sfH0xUh8tvUs39qUpY06AoenRYBc6tHNtXoyOPMfmbDzg/
UoJEPpG/95KUkNTYtW+NgxrctXtnIV2hgAMPdBtuCWvCquM7J3SXKeHqKpkH
FDlNmDl4mp8roob931V3HuhWgyrJlP9O9Cjj6UBrwo8xFXjIr/NEzVUBly1W
Zwr+VoRcNf3WX0LKuGnk8MGJfarQ075uWnypKkpti/kzJKIOyucDno9v1sDL
Gz04F8XVgMYfu87ajoDTQytOnI5Th9ksbmWkjjbupd86X9ikDmqKFkN8RB0U
Iyec/VuiAs4OaRXftuvigLB+xJIoFQh+ltfhu52M66LcolZWKUDOn/m2USkK
ar9pSpk7ogIBSU9FCiopuHrA+eXWXcqQ862/0LuRhNOLfcoSW9Rhsi6iOVGV
jB3Es7s/LiiD792MZ0whEvq3b/q0VUUNzHdERIfWkPF1qGLLEg1VCGq9d/Pq
dSr2JP+yGy9XhTK471ZbRkaRPM+907lKcGu6z//oDwoS+hzkis8rwJ3zz0O2
mpIxXM999c/zMvA2MFOxgkbGh9te15xYqQCTo90FD3UomM7/4qSnhCx0CRCN
BaOpuL7mbN8XPWmY9NR6ZsDLR1NLwNW/dCU03DM2X2NIwvPvdr0nL1kJSWsG
gjYwKHizSmBXwkdZED4u0fSriYSRw+F738nKQ4LOycQHAzrY4vl39dK/MrA8
O8RqK52IH57mhUock4LlhyodTJjamHj0j5D3yuXQO9agnLFHG33enFe/HigF
TyPunrs4oY2uLdOxe6SkQU01/GHyDwLq9ClZTd2QhcJJs6vdXVr4Pmzys8tT
KTj7MHo41UEbfUdWlSktyMDOB2WxXCUt9Fv5LD7RUxYu65pSzyoQ8Xa2d8I+
T0V4CeWLctJEpAUtSWXbqsAtfhnLoX06KLdM9iOrVw1mMgg/Mke10ZYjc+mH
kDI8rf0qbeGsjW+0Cu9mD6uBeNOiH3ZpY2zu7fLeD+oQ5asQp9iggyd0H/03
46kCqlRbmWcviehnNnLHjaYB17vPyNdcJSLbTZfjGaIKFh4JL4zWaWP2+4kB
4ceKkC2zJSxLiohCl2eSjlyXA3PyrXdXNuvgxt3GkrQURchz6PZaU6uLzuds
HKsmlaFwQzOD5c47/28l/1mfV4FtgsbP+L100T5iSshbQQMOeEWNgykJZT68
mivqUQWlQvdNAa/JWH98LafyjQaUCLRVpG0g4/N7phLRzQQYThEpqOgh4QXd
OatNldpwkLU5So3nJyfuJjbfNdMGD6c+edYuKrruED+2op0A5ULjbxoWyGh8
zun6+yvakGw+bruaTEbXoxcGJ1frAFvHOK3YlYJanR+cDOZ0wDDiZuuP/SR8
7eey+skwCTxzRE678PjXuujLlftPKTBd+XVE8QwJ22pZBidvU0HIora66LkO
Mi4VDT8fI8Mq56NXXQeIaGVUfPn0DjKsGZSRs/iuhdIn75/L2E6Ba43Xl1YY
EtDzY0XVoCkNukqE6NULBPTOSG6vXUcH49iqSz0Omjit42b+NZsOsWQJj4oi
NSTvyoud2sWEdVj17e13FZxaot60upsBtPXBp/7z18DGD64p8cJ0CPBy+/Ba
RB0Vl+ecbFGhw09q+78Hy5RRzbL89MYQGjTlGI/F2cmj8NHCC01JVJh/sfkm
6e5K/H79hpGNNx22drVO/NSRRlvbZtJWbyr0uml89jaRxslrnsWdh8jwJNxt
htEiiXIGpBvBRyjQRP+xQnu1DPYrXs05vYkG8hrdt2/0yKLXu4En50SoMNZ/
YqT1vQKepZ57E6xNBRf9M7/WvVNB/rWfA6W+0KD1uI9rb60azsedJbF4+aYS
enfs5mhiUorV2bW5NOhQjfEVmCdg2/CPl+10BjgXiIb0GGrzePpK1b0GJhR+
32WRF0JE4uGgnEJhJvSktTe+OKOF5W/So7pL6DB5ZM18FY/Xzam3yuWvMKFW
I1dSbwcBv1ET6T72LLhbILjqGE9P5/o2H5L4jwVfmdyqAgcCToQtrfziwYSx
bxvFHl8iIIV7QsJhHQMu8nt9n/+qgV1FelJflrFg7+UhLYaoBq7N/3yuksgA
RxvPeTKv/hXKwoXqujRQOHN4vJyX39t3olvVVRjQ5Gh+quOUOqZbNgi2irGg
aPJzixtZHWvtL9DdnRmQ1PnQZeEAz2+osA6H67BgC1viI3I00HPR6flyURac
5GsW6E5SwbctVm2X3jFhY9MSJQHQQHGH3O5UCSbkdf9ZWtCjgmWv3vwcMWOA
evNaUTV9RewOC7siKMwCyYhXr116lDAhZ7Izqp8FSdkfKdeXq2LIxcCYtY28
+hzqyyaOq+LPxc+Dhrz7hym9DJcpDTy1jXIhNZgFQsXHjp/VU0NT0RKfk7vZ
cFfE2pXvpRoefW9U881DD662K21mivH6MbRjVa6MHhyyo7078FsTnfI2710w
ZUNQfsz8ZwEt9EUlw40v2fDf8XWGTYXauMe9YJoayIaCC69+rW8lYHPV/Xm5
Fhb8eNe/fampJm7OnsxrIPDqLSivtDRcHV/m/i69soEFV1JnDEIrNXF3J2dx
mzULwquiM277q+OFgdPnY+lsOMO6Lrj+oSqeqy5e9kZUD/If9XbmPVbHVVXu
ybsl2PDukq274qIaEuYtF3/NsiDZRfJNgIAyRlcHlRKXsuBR4H+Voo8VUfFJ
B+2rKQMU9kmLPFyhgCKOewr8fGnwrtVvgnJaEUWtticu1FAg4Vqrzj5HeVy+
eNa96wMZnFbsv6pcthKV13dukK+mAP9Xb0ExZ3nsMBFdKA+lgeYkWXO7kyK+
jOucvpJGAU+lvSrV/ApoVq+UMqBJg4vEqvr0CCVMbnd7QWZQIYhP7jffNzme
pC/skL1EhlehX3/x7VXEqNarazfd1wXl+LiIontKuNPYKvbEIyIkH1um/95A
CbdnfTxLjdYFgQ3B5DaGAq6MPJRiEE2EV00ZL7sICqiif6TWbgkRuk4/Xn5H
RAXtdJJO37TVgS/fxdRfTiogiCcMXf6kC9Km+knXbJRxoMtiWccuHeDfJQHX
Lyng8KNNfwUXtWFbQ/gNwwhl/B762/TEZR2YVZUVcyUqYts+GcLZ7bogVt7C
mHqjguZH1HsCmDow8s3WR4Hnl5vhvlR9OxFWVbMereX54ZyRjalXorThemNz
ZFqUFlpdtjq7eZ8OVFDbY6I0tHDbh+81KXZECHuXsuptvCaGvnhb/fEfEaJS
Xmy+wFHH/i95o8b/dMHGaOr3keXqmJeZEvJxgAwnzPYH+ulroOUXqd+m7hS4
Q1aJ+UskoNOZ5eocGxr8MJMYnrhMwGGz/l37CqmwieFwtKdWA3/PffR5dp4O
p1MW99+x5/nxIZp543kmBJu+9Ly8XgP33Fevmy5kwYSt2kP+KDUMXa+YPHiF
DcWvxRanFNRwac+9yUCevlh99K1foa6OAh71mdVb2GDTsiwhWUiT16+1fqL2
vHkQEbrPXaGGxXzRjb5r2eB777CsvbAm6vOtMDmkpwctqux9G2w0cNOKv2K2
B/XAn33FUKpGBdn9SwbnffXhcXt6+N9UNUyWWC4pKasPscWvHDKYmrjtdepC
3koD0ODE5y35o4Ed5QYqGuP60AaPjcYXVbGoxYZOf20Adt3P15qkquPTnOi6
SKIB+HPkuhn/qeCs6DoNF3VDEO1evbg0RRX1C3eNZxUawhfLHRuGFZWwr2dw
4n2sEUxWy/XxWaugn4G4/rbdRqB59LBmm4YGXnBnl3nsNIaxjUf5S4rV8eBh
ry/uYsYgUPF81ue2Jh51dPxTJm8Ege8YmxTWEZDsvXHdGSNDyI6aN1/vrokx
oQG/au8YwqffD1Z8XcnbpwcaS5/uNwLtNmu5mUZNpCkc+XB7vzGUng6y9L2v
iXKyJjU6S43hxuASD8E+dSwL+Oo0ImgCxO9Owzq8eI7+jqg+MWoCQ7Ee7i3B
aijp6nhkpNUUyKIXt1LLVLCmdmda3B0z2BXjGEj6rIS9ij7U1jumcPvSl2yO
sjKa56tcNa4yAcPEm+9z3JWRnnxq6841JnB35FBE84QaOkpLRN6WMoGYINXk
ayGaeNalRiai0QQKK+4dUuTj7Qu91RsK7pmA9ctLZI9/mlhXa3Egjm0K7ym7
KwvqtFC8rY+/U9kMMttVtY/weLJeobBDQdUUVDaZXt37/987yfFnRNFN4ITE
5qenI7WwavCRltsfY2C2fp7vDiRiblvs2WkFEyA93OWOe3j8qfOz7JmiMXzW
j2xQytbCGUkFz1FdI9h3NsRrxzcCjtyL0t/9nxEcWi7lN2akiTXdrSZfMoxh
Qn/JuhI/DQxsH/d+/90Y+mRLJDaaE/CR6MCch7sxCNK84quuaeAWmaeq87zz
+OLzR4ToqY4rtmTNnu01hHN5KdeHrDQxcett1cJWI1g1J8b2ua6BEQPrXXqv
G8P6ns9lLyp4++GjXZrJThNQC7Y4cnS5Fk4l7667dNgY1nT9MZYgE5C4/NHo
g/NG4L2729zwDwGb3nc/WFVqCHdXOF3j6BJw63ztv8v+RvCsXHL4UJoWNnVJ
ftjvbww9fi8tpQq08MWd/+7obTcBGbfmS3YhWnj1WYxWhY0pmP7awGS4aqM0
f42gjZQpbD/V4vLFVgf95DpDwg6YgD93T37+iC6uXpV644u7KZTFOFkKvddB
4xs1n1S7TWHumte7uHwSMuxcA992mAHRT/Fu8AcS1p+otfMaMQWJyQyFyCIy
PqntVW4vMoUHchefb8+gYu/kuoRzMqaQ56T4S3iMjNnR+52j1pjCziVe4z4f
qejQ69tQV2AKfUmyRa2CFHQ4CtPko2ZwH4q6En9RMHi0jV59xAyaU7ZdSvxF
w+E387Hb3Mxgw+M9EbBIwSvGmwxIZ8wgmyD3cJcYGf+8bJzO+2cGkg6pm2M4
umjq/3nskLAZdAw6Xcp/pItph4z94oXN4Zjq+C21Ol2s6N3d98TUDMQztKe7
pkn49uvPoExHU1jygDlx5DYZ++rO/+fLizePL+/Oq9u6uFZ1tVu6qBk8aTD8
e+Anzz9m+ceKlPHm56HHF8IRCrpVXNJ8LWQOI2/hfY4vDTt9UxNyasyh+vdb
R7F2OsYqvzftI5lDBt3/a000Ew2KjX/6RJvDGZNZuePlLGzovn++rMAMDsdL
mRcRWbgsEAKiAs3BbjD/JluSieuK+ywefTWH/XcK3Wz8WahWGK4w9NUMal9k
rTznwUJq3TKvCwXmIKAxVNAtzUYl4oiFhJ45yMRBeiSVhdpOJ1+3C5qDfFi4
i7svAymFt2nbeM+/7Nflc12JhZUX3v26Ec+rr/r3pef2MPEpMzz4ZrYpHFK/
Fmqoy0IRxi+1DIYp/B46PlQkycZW0IwvZpiA2IlX2zJF2fjPIXdhw5gx+Of2
xdrz62GZWEF+fKQJLL8Vv/nFGz3s8X35h1pqAl/8ZDdOvGej2Ag5fH0Ar99s
nk+QmWwMCJuPFQ8zhVeOk6pTDD0kvT1i4RNvCsVBIv/Medd7zZ/xRRzj6U8E
9ULcPAvzJt9aB4uYwCGPubBQZRZWxCQKzGcaw1mlxcjBPQxcq1sQolhrDOyP
oluyI2goeFKyS5E330KM66vTDlPQsb/H0ZFlAuo/3CYNQmnodGAbCi+awO2j
LTdHL9Ox6N23N38STKGx7WW8mTsTFaRyEmQFzeBNedv67mQWMkdYw/ripvBj
RXOqfDsLpW4nuJ75ZgrWy9V/J21hIYQ/GhAdN4Obk7LxIbz77XWWNFFp5sC3
p0CH7wgbW7xD/P3OmYPnQeNX98+z0Ke0YV5c1QJK6guM0vewMavuqvX7neZA
rrSqu/+AhUGiDsYZx81B0CC7/XINGw9uS/crXzQHbdmLrqd6WNiunD30rtYC
Liq6fRNKYOPiW5K/5DdzCCwIyi1Q0cN1SsPLLhRYwKW31n8t/NkYt04+JL7D
HIa6Mj8GvmDh/IyrPSPPHBRv9Yv7NLIxV3/BG3jxK8r+srI9oocNz/XWhYea
gTA//95Pfvp45rAeMfSZGRx/3GlOCNXDi+t3SLk9M4cbJ1sDLkfr4XzlD8Pb
GRYQlfaLqbZSH9dUMOIywQLu9EcYlWjoob3q7rU2e8whdqOVPaVSD+3G9u7J
/GQOtre7b+dm6GPTAVLu4QQLEOpJ3vveywCLAuz3hCabg02GuEAHxQClRhrO
7oy3gOve5xtCB/Qx5tXV88w2c5C2alF6QdTH0zsPWrpu5+Vv2E76JW6A8TfO
i80kmYF6766xVWcMUEa3wTfhhCmAYOIGyUgD3CbFXdxHMIPYxEq1dxxDzJsy
VfJXNIdIl7CgnfMGeDtAqVqBV2+HHfyS21MMEL6MH+3ize+sg4b3Fn9DnDy5
w/iWmAVMPElYIn3OANOuhP3y2GkBj/RPGo0X6qO7MXu6P8scnmWK/s5dro8j
yRWnFsgWsP7qwnHFd/poFqAlUWZqAaMt625kvtPDoduGz9f2WED0k25pyZV6
OBdczqnXtoSPjj17dqiz8WPCTrXzKZbw8sZhxSpRPdwtwHYiB6yCH1uTep8m
s7GnJGPVgSerQGLnhCtfHgsFninEiXVawrjlv9nxaRZiS8AtThfvPMYefCb3
svDYDdfCjlZLOJFgqntBnI0zuLBwtcMCvs1XSnFNef30zOXBw0sWcNncu+OK
gR7Pn8Q0zJ+2BOOpau4Cb56PfBRs9xewhL/OvjvuLWOjGwrUpQxawoOfqvrb
k9h473hdc+YXC4hcOye+tI6Nb40d/rqetYSjJdR/hf9Y+G/s4a28ZxZw89fA
6tUX2bgh4K0gycsCfF/IO1xM0kONiRvxeqIWUDqX9V4rRh+/KZ2X9Ko2h5SZ
rcdLAw1QWGB7wJ9O3j5wq3+s810f+y44t3H+mkKUn+LD+TgDVBaMNd9sbQqn
ZpyPDTTpow3fBDw2MYOoTlrlClkD1Hn1iNW+yxReW97jqh/VxxNKfitKwk2g
yEmGE26sjxLuh5XO3TOGsOGlOQaf9HFJoFWcazZPP+o5OzsD9XFHqNpPn7W8
fWEitFrulh4GPXq38a2uGVAczunv4fWj/Sq32F55c+BWLIomHdLHFVfciu7J
W8A2u23bHaL00Scnb3I/ywKYh5ebHOLNT/+IwGaNaXNY2TA+mbxPH7t1yj6E
8JtDad8d86uy+hh64G3h0iCeXkvrbDKx1UPB5jGGUJApfJFp1rC208PPYiF/
yt+ZwLng9/2kcDYGEu5JO/Be//mOU6RwFqazfEfvjBiDpGynryybhcnuvy13
D5vAfvfLIV7yLPRvGllz9r0JJCz74uMgz8a0hj8PpOxM4HqOirOBHQtHtANX
fo8zht7EgJeBnkycl9k8qkDj8Vijy4/hUTraTfoef6tiAoTub77zn5g4XPBg
vP2WCZQV9bz1smLgd9veYY0KY3jqGtd7fgUDvbceSm8zMoF3vXfj+J8w8dVg
WoC3twlQriqqyb5n4Y2Ziu254cbwynDrnX/RLOwt+9cw5mIMOg+PCX/7wcDb
y6mvIk8Zg2javMUffjryrfvFNyJiDMN00gJ9PRXdDrXP5rsZwVo5o2dlH8m4
ti5DwcLNGGxnvL55LfD4IXDum/8rI6haOl55BUi4y5/4u0LLGGoe3tBWIFFQ
uzfduk7TGA5YJQ0rk0g4dj/84mMdIyh47vcsoV4XZ9o1fhB4PO68CtJU6kho
GvBi00+KEYz6fnjxrYWMU3py61QbDEGpNPiz5G9dZA8UP/pQawhCh3bNt8yS
UUrFe03WDSPYlbXpeE81Bclyk35fjvD8g1NH89hlMiaYrAkpcDaB8ZMZgXot
FHRODxXdGWQM3ZmVz2VKebwllPOkPcYIlpeF+B92p+EE2zxoNtwI2iLX07zd
GbhBlfjvtoUxnNL62HvuDBM9NGkiK3l+4ohcsSL/ExY+r5ltuZpqBJ4vowYG
efvLcn28gM43Q2h88PJXrBYbJeSSuHY2hrD+ackxKR5/PH//oKnG0QBOTBkN
LKGwUEbzr+F9R324J7xn+zTvdZ+7dLRArT5o1O879uoEA/fyqXyPvWEALtGH
V62wYmJugSPfuTJ96Dc/Jt7+iYExj/Xz7980gK7KwmZLbR7v6BfezznJ81/v
zl9xJzFQQW612pNkI7iysVhRbpyOCama7F/xRqAy7x93ZYyJ1mEiH5JijWED
fb/7nVQmfqhf7yzM82PqYmThLel0XHbzv6l0NRN4urZqdxqNhstyPQrshUxB
sNujSVWIjsJ1p04q9JiAZ/iBU2slqCjotfbU8xljuPrYniQkREP69v642q88
P6Ol9SE8iYauMx8nxiVM4W9PXnX/EQaKVAc1/mg3gYPDX6uzz9DwlK2L4892
Y9jV7rupJIOGUm3HomLYxrApysdYW4CKMTtUih+gMRgkHf7avpWMa/q6jAdz
efx+MY3/124K6ri5fFdtNYaIxVSpUkMyChz1i775xwj29MSIOW6ioNaw0cl9
wrz8ZUJdJ/9SsHL7tqa+c0YwdcqsstuJx68icy/fJRtD8kFNg8BaEtJuJBdr
B5vAr4oquff/kVF8/oN+9CxvHs97Py1c1MUDBapRW8J5+ndbm9DCJWNijMPJ
PJ4/2EfKmW8GCsb8Gc5v4efx4EYN74wfVOz3zCq++ZWnN63LKs49oGF70Ov7
zGWmUKEWa334Ch3ThwRFX5SZwJG/M9kW9VQc/fCZcoLfBGpVXW/+saSj6iH4
4Mzzc4OCRUZ3LZkocDlQOfiLMby0Xs+6s4rO658lu614evNvmPZK05+K3kWC
TzJ5fsZgsKz/xkUqihVl2s/y9EE5dcvGCB7fNQ5xzsIKE6hcX5Q5mkZBkajD
E8+kef1uFVDSNEHB0if7vRZ4ehG9Y2g8qJ83H12JanPuRtDkdDt3zykazj3W
+/SjyhAeyhxI3a/CQMVnvupWoYaw3YTf4vUSFubEm++6pWgEESK/3XtTGBgn
7is1xuX586udFheEebze6xuUn28Etn+F/HfKMHDrH6+u9GxjCFbSz9fex8BV
J3rOrObxco3f1LYEIRZ6Phj+b5bBi8cw9+AgTx9zR9cZlJsbwZuD1I+Jtky8
budoNU0wBseTgYITwQxs+1WSbOfK05+iq1KE/TS8dpE/c9MPY9g96J14coSC
2yV//yvgPT+8KFu34DUNI5fM/Zg5ZAw3rXqsGLz6OU2lG8WWGMOZxT9z/IFk
XDKmLCLF0xvyaqe5g4/J2Fgz4wlbjKAncm7PzTe6eDx8o0uGghEIRKQ71n8m
Yu1Yk9M/dUMI2HJVbPNeIm48Mnn9cpMhmDM5yqpftfDAvAUrSdAIvp8ZvrDt
AxFXXH340NPDEP7c6iyR89VG1eIdMht4zw8TEBjyUdPG1uap6tl/htDdkE+c
WCTilln2YvGCEeyUUnJUekDE+PWPy1P4jCA65tyLzXuI+KrDVYjqbQiSwnM2
ybM6qENcUnzlmSF4BT0nk56TMGx8te5Tnr//sj640qmajNNlNQrXqg1hIHPb
rmJNMuYoPcnpvWoE9i+KuSatZBTk//7EKZ63f2ReirwcpuDr0fa0lkZjOFcR
YF7/h4RfH4g5nfQwBoncGdHrzTx/uiKR7z8PI1AcTXh/7i0FzRUHxAWaDeGK
TccpvqM0FB5Z5Dz5fz/8KmRlTlNRdZ36dD3BCD5fy9pD8qbgB8MguouDESx5
MVNY4E9CP1D73W5vDM+mDqvHryFh84OPnclPjGHK0un+xCEd3GQfcn/R0wQi
jz17VatAwvcjFx1reHo/9HN7RfYeXeQLME+dLuP127+lC8HPSGhRmusqDMbg
1K049iGYgpkJ2dIjSibgZP7fNfvtZCwxPlTpV2MMAUcfu/ebUfGSj8c3d978
NVTpSF9yIKPLltAFlSETGIpsdVmrQkGX6V7WlxhTiMyLPbAynoRGy86EFo+Z
wJ2rRIdaHQoeDSgMfPjFFMbS3sw/3cjbj6euBgvOmMAn18gIqc8UjP+9apXg
Rh4//VJZbxhGw65qwW9PefvWbYTf/oEiDc1XsM+lHzcCn017u+TX0ZGfGkNL
b+b1W/V8zB0jJp5as2o4KoHXD7+tfO3OstAmRjEJeef5it6ee53MxrOEmzrL
cwzB9dLtHf48f7tNhX7j//+ndOgj0WAvnYkz9K1vJbv0Qb0j93BFAxOTL7kk
W77WA+L1Zqa/JAttQxoLb77Qh3LlyMIDXiz8wxYtKFnQA0Pr1yr7frLwrWb2
bNRSPXhwzXXyajULb+YcvR4RpgfVwOmWzWfig/vRC/8N6sH7lh25xDssTEpW
Lpt7pQ/TjL39abz9+FhR9emxUgMwDIH4B+VMbF738YmkuSE8efBT/UgpC+8Y
7Skr4+lJvjONIc/gxS8gdU1SyRB28HWjkAYv3zo/rY5bBsDaO0rX4elHW2Oo
6tQ6A/Cx+b2mn8DC7r5XJwa1DEG2Lz5R05SJhoceXwxoNABV+v62+JMsXJmb
WPpbwQBWP3cnpuYx0S+wM4hfVx9c5EMT3vOeP5d+p+6Urh6oCYe4l/L473Fn
0BX3o3owfY1kFqTJxhuBlLTD2WzoTtTWvZDCxs2L9xxvtrGghSQS8XaMhf2f
RuKdPFjgJTR2+mMbz88b21aWhbEg0eXJzMtWPXxtmKjVI8KGEltdKYN/bHw2
XLFH6R8bir5QGu3us1FhCd+nD6FssFVdKbJ3mIU6117LOR1kQbn4YvDTHBa+
kt2X8GcJC8TePzlmFcfGnQqnhh2bWaDTr3N/q5oe7qfOG1y/wYTEneffCezS
w9mXW23MtFngd/vz9cIINq5S+29tpBsT/OPspyvd9HDSs7+7K4sFqXdu+Ex9
Z+Pg2R8iFCEW5A3/F058qof3hONyFf+woP5nhF7gfl7814J29cix4HBG/+C1
BTa+WPiUVxbPhMvxrVtWTOqhY/s2q18ODFCf8V0RWKuP8ebVBadMGbDga31n
Va0B+utdPRUizACL2z4FsQ/10VVjSEFYiwGJnR0blB7y/OhImcEohQb5xCVj
vqcNsDji2NhpKwp8aVg459BvgG/8sy6eDSNBlIDjH+0wA+T78IXYIUqBfCel
tDlRQ1RWqtysJ02Cs5ertq8zMkT2kwyxJcO68Jg6tnqVoREKuR5qWhwhwaHa
sxK+0saoffrCX5s6CqwSt3p/NswYb5kM/513p4LejnOE/INGqP5+X/7yTiqo
7r/IZ5FoiH+uWWsxtOkgZhzQEGVthK/mwzyJU3RIH9+Xcm2rIS7zvE6/aMqE
RuasxQVVI/xKWbwF6SzYJV4Y9rDRELOE+rrgBQsIlSeSPFt5+Ujsy926kwUL
hrFhCYP6KLwv4LrvGBO6/EttC5sMsOHn+9W2vPO5MRVgUcpvgEO7/rYV/mbC
k17lGv02nv//tlRN1JIBDZYMy2UbDFE1r/tX9VcaeD6a/ZCZZoAfmqq3+DXT
QCwvreB3qiFKllwr8/lHB4ULi/sVthhh4vYycfNsBtBPtOw452iMLy+Y7End
wAR66qehPHMTLHngZLHbgwl+XilxpebGKJfkv+lWNh2qhy8vt3hihGP64ea3
i3n1aTVuz/prhOJz9WQbIwrIbTRs9b9ljP+ljo/VPyfBJ4613sU5I1w9Nr6T
u5QEogcLrdVWGOEq1VTyLWEdOK3n7zUya4hOYaXFh5S0wd/rjsB1CyN0T1h7
4fEPbXDUH7d442aI8wEbT3v2a0PiZf9iFXcD3BZRyNhsrw0/7bJsH/vqY4t7
lQ/LUgcOlF1olNfRx4cy1lhhRgJXUR+rV2I8/5uh6OXzkQR4xZH9TEkPI9Vu
D/63oAObN6vy9T5lY9G+gPNfAnVhsnRzkUSdHp46d0bm6iwJxu39et6q8/zj
1fMyElW6EJ9rfmrVJz281DsUYQlkeO3z2V/WWg9l9aIFCnUokM6L5g5JH6dD
n19/0UCFRh/Dv4ZcffxbFn3mTCcNkrcV9F0e0UM8/ajgmz7vfMayzpny5g/9
Ng9qptChjUXkeOizcfT42rMje+lwYv0rnSX6evjKYjTm43kqPPY7H7ysg+c/
476H2lwkw/2xquzyEja+Xqc5I3eSCt9SQmPW+LExaTSiSzGcDhfagp07pdno
UfX8bE4FDXSOiiq8JLJwR2RV7OlpCpgQxMovFLKw+FPEQ50mGrx4Z/k3WpiN
RgY/4pupdLjfXTLrJcbCTcc2v0uzpMJt1aNyYueYeEtsu6v2BxrcNZjeU+LN
4u3f+//dukWHd9s9BFaNMjAlPN44p40GjqcsMweV6LjPQbpjVRkVHqYnBByM
pOIBwUlzfTkKXHwypiN5k+cfhp/GHv5FhrQ1m67J/MfA9CZvtYfxZFhbur/u
eA0N7R6VN06d1YWkpLc20zZ0tEgYPJERpgt/Jpny42uZOLk99PsuCzI4dZRb
PNjOwKFT60IU1lNgjaPQ2PZKGh7M0wjYuo0KU53hUk48vxG5qNIxt0AGP0Ld
w5qzZNxVyVW4xyJB5SDf0W/7KHgiQmunFZMC4kWBGh7rKPhWbNuKiGdUWGZL
+mUrw+NFgcnd+dYUKBed7Sj3p6DyYo3RpQ4q1P6q/b1wlYrD1z9nZrykQ4yu
fObaWCpqJ9On1e8z4OXzuJvFlWS84z2yR+sfDRTEjK7ol5MwWDFp41EBKozf
YMifjyRhTot7ze96GnwWZQRvO6yLI72GvRL1DOiw8CcMXdTFwND+rXo36OAU
FCW/cR0ZW22u3WcuocPJm7aNhTt0UXr61/1TXlSQIiyLYySSsO3xQsDEdjIc
+2b3tFKfhJGHyl45WJCA29pYOnNGB0sYaQf4dumAwI6LnTe9dXF2460vIQpE
6BQbIph/JOFN8t+U2LfaoO1pR1wc1sFiybsGRm91ILtw47bz3Tr4SUy9fTWV
CBalf7doIRFbfrw4myGpC463sz/yqRJRYK+X8UVFEjTfkNw9HaCFc3f65R+m
68IrS+2O4AOauFpmQLtfkwyWoobPxEEDyVs2PHDrpoBdYUXE1AZNrEtJuiP0
iQTb34DD4ecamKr5/Ofb1WQoz3YYY9cRcOjY9456Ck9f2tcuDdurjd5nSuX8
CBT4SXQ6SJDWRpH/MgzUtUig2xMv9pSuja6nem5G15IBCaviPv8moI3NzYwA
AwpMsGJbg8e0UeVH+O/LHRR4vmrk8q0OHQwcN8kJOUoBP9tl4V4vSLhiTpR0
iU0BN7lb/kqNFFQsMNfbkEMFcTUtuyg9Gl66JXDGnkaD8E9bLjnbUZBd3Fre
1ECBFamF7Po+Eh4RfXhBaY6nFzarhlLf6yBxH0xeEaXBtokdigunefxe+WyL
VRUF3swczCsToyBQvKsaePpa4Jt92kGFhHlLCP+r4MyjqXq/MG6e53l2zVzT
vbjX3HlFkyIi85AkVDKEFBlTKuErJHMlFZIkYzq7UgmVFEXIkClzlJnf/f15
1l7rPe/ZZ7/P83nOuuvWW0+oo2KWD35lGmpQePEcexc7Ed343GYUEq4Kv5r2
OcU5E9GxOOYUShAR3ka6NAe3qqIWnyKmIG01eP/fETlWb1W004otd9NQBVpJ
2szuF5XRoauH3ppfVIaN20O2aQeVUXeTU9bWJUXw+yD3xumoCup/0um81i0P
Hr4j5uyRSojbXSmQO1QBNnVrYmdp+imcOh26b1kBivl3J1WNqCKmjpaaynx5
cPtae2Enhxp69m/1pEmeIly1fZ3r00dEbQbqwoEtCnA8OW4enVdDf7NKxMsc
5KHXNs1IJ1wNxXw6oP/YgQDjxjW7FzpVkczzuLq/xvJwxnEi2PiLMvpkmhSn
ZSUPSdaeOsH5ysjnTW8vow0BRtd2GpYlqqA3rz+YneSVBqf+pe7LoWqo9KvZ
fkURGcjVjKOXPaSKvneeGmmqJECL9dKXzihlpLfwBxNskQXzdR9Fp1FF9MhU
zofXTRpuBV2tLOxRQl9OV9/aDiRAyNP47ONCKkjgUdDmB0Z5SN5k/W3yRhUl
+1/j3i+sANRS6xRRKxWUF5ikNlcvB8MLxx9G2CuhOeNIukPecrDC7e8a4KiA
Zpr5PprlyIEs+aWUqYU8Mg44tsRoqQD+hdxnb/XIIxN0QGLfETngGhKPFJsk
oOTBVYkD/XJg0iV+sFKGgO7XFEvTsxIgfkJ/sbtPGjlpW9u+vyMHE0+LTWUP
EFCMh7HfZw0CCI3bUbdvSaEXyTN7X1sSaH79M9J0nzia4tdM0vWXg4ePSNER
B8SQg97DGFdnBRC1/Npr4iyJPs5ClBCPPJxky5Nk+CyDXC/NC2LcCvCVT+zY
ob1y6IHI8cAsF3kIV3e3bb8jgwa079ClN8hD++NNb2K3BAJ+68JgCXn4smT2
QOawKAo9OMviwa8Ay+0SufrvhVDUtc1ACm0efrf89/P6MwEU3vI1tWhMHgQ8
GGsDM7lRqgCBSyBGHiLsbzMwr7IiGY9kOeZpBUiRPHaYNYQJnUhawdNqlUDY
kGcPZ+4WptN1KPU1pgLSTab7bJ8zo+mqtzpKQaqgbUX2I1hyo8Nvc2v+e0eb
9zeJDhPFAqiTYjB194UKdFxi18uP40en3z1lbvtCy/Prs34+AXxoN33hmQ5Q
gRdzIdq8S2xoIjBtYZNPFQQ4Q5lePWJE9hZxBRw0/RTnGz889IcVVdL3Vwj8
VITPjx/ZTtmxoL74RO8nk/Kwjyf001wCE3Iy4HTw6lOEocNOnFUXuNDDEwf3
BVUrQvrFRFV7nBetjVh4SCQpg8drpfwQKQGk4Wt78gltvZV8B7HKG0LI2Dxb
51uIMrxqlrEXdRJFv/3T+5J/qQB9gmPufiEx9G+hgePrDzUI5H9pLmgjjEaE
eqZYT6jC8fmrT8ggiASeqD85YkaESWOZd0skUaTGfrGZYqIG5yP0bfc8EUXT
BQ8vaxioA5/03VkSbT4a2P5jvk7Ly0J9dWeWpaXQfaNX50zbicAvfHQyw0QM
3T1xVSR2rzpQXzMG1E0KI8uijTxsUgOEZkbo5Lf4UTaHvdnlBA2ISK6Q1drL
h/YlTn2urSYCtW4/75AuL5rzPuGDHmnA60EVqQ8qvIipalx6xyMtmHSU/uo+
zIoqPDv+4PG0vLp4dH2fCwcymokxHK4mweM0XbndW3xo9OjBals/EpxmU93v
tyGAvoctOVnuJoMDxUKshkMY4U81a0fkdIAxuPG/9DphFKDgbJqrRIarRa4s
H3IE0H6O5nypRBK8NC1eEg3gRpd/K2lN76PlTz1U20/iRAoriLMBI8P1ZuOX
j6JY0EZcdMX9IBJE5wxQJE9vYbW9SXtcf5Bg0V+ep/PPOjYx9aNs4rk2rHQu
mIf8N4W9j01+En+YBHWKV9L3f1jHfkzVZc90kIDX5OEnzoh1zKPkTubybW1I
/sDJdVF8HHN97cF/rEsbDnVZzBCVlrG9W/hv0VxaPu+xrhF5voGJnHXXCnHQ
hsf5i7ujNqawc2mVVk08tDyu9CblZ+53jK7pzUkNTy24kbcRTPVdwlqxKuQX
rgmHer6dG3q/ih2b7RLam6EOunvN/wRYL2O7Cq6yROaoQcljz9j9MwzI4ftN
O7s3qkDZe3cw2ZMOMa+ISV0tJQJf45UHQovL2EGqEkZx0ADWYb+bp8WXsJ27
eN4gHyIcy9B11TjbgVlX9r34GUWEo+VjF3mmFrE0d0rAFQ0i1Dw0i7oiRY8a
PhOlxvjVoZz57LMyi3WMlGc702ahBmeaei247ccx8Xc/SjefqUFdSPvHZZtX
uB0r3dHESiKUke7s/7j0BJf4NlYy/EQVuPDfOT+df+PnH7Pa3mIgwhHZ1ZAa
x2YswDT0x9IdNWiwkv3W2TaG+w76vqUWEMFlOYQ/bs8yzp3W/FLurzrwBlT3
9NnN4xJdVp/WVYiAfZh84k/exnOcg885jxIhsC6A28tjDu8T6rE181YHJCzm
LTocj2XwsuoaiqtDafj1W5+OjuIpVW+LS4rUIN2/QvK511eM+b6l5t1FNWgu
9p5aqhvEvh9ou3FiSwX6BUzr58+NYgNS7erPV9Qgw//gWvvtTry7mPDUN0AN
9E7EWfiU/sR1fCXPykeoQFrY8QG54Tbcvql8RjVZCYpPhmU9px/BN/17c14+
UYAa6967gl7fsB3S51/77lSEgWOV55VU/mJvS7JZHL8pgmLoxBmh+wvY11fX
JedblUFirxsvl8IWtk0stX12VQlO2ByYTHNgQjuaak3nOFVA8XCy+SbLOuZ7
YuSzuKgqtMrXFc8/nMLOc3IUXPmrDNtnNWrVWTcwv4QkYXd2ZajvFhN3l6ND
x4r8/suRVIRWiwvRG3qr2GPZaTVOG3lwYj01NpzJiDYvmEht7FOAHdwsTJwH
6VCUUQAHP40H7+OKL1wtt7CwgLYX8fIK8PlXpJ1g5jT2Izn7uJWKApA+Vxtm
PWzAG2dLGtkZFID1dNHQD+l53NxCRaq/XwEE2lTv8vR8x/28ptOXA5XgHnp0
j699Fh9qsStXE1SBDFVBr9WBFpyYoSPJ4KoK28HJC3jXOPZgEhshlKkAW4mA
ntD+WrxFbvdFSrMqzMvQl25ofcYsGuQDAseUodxHgX2T8BWLlXQ9sDamCIzv
rz26+mMaO62ZvscrURnSGd2/c6R3YVp/HsT2DCiCy3vqnsL0GawgwbHRCykA
Iaeifv7XLDZg5TCxgCmBE4eIaHbPFKb7mPdEoakK0K2GCHtWLWLy/T8FlCXV
YHN+5v7lN7+wmRyfmjfnVaAyvoT803sF4+M0yDsWogphxR7IM44ePY1a5Qhb
pPnDR/9aFzNm9MCGEEPSVgLdZbPkvDIupDFbcMBjTgnyBmvj3zeyI6mYgaWC
NhXozYytPrufCQ1EzyaLm6vBcO3xzPppVkSHGbm4capDglRL0J5sOpQ25Epn
vIMIKrcjy4bu0KOL80WHsnaqgt7dzF2ydqzoqAjb55ulasD1TPGpjQoHYtzz
dKOMtv4QFsPZfIoTXQxku6rZqQTRE4LayTn86C52OvHFXmXIPBy/oVrPh7hY
t+RJJqoQvefcqFEwJ1Kt6pxPSlGDpNRwZs0ERiRgeTuV2KkGB4x9lZ9UsyHc
zMi77oAqmDkeuUJ3hB3JaI02JVgrQ8dpji5SJj2aXnqwmtmrBNa3JVb4ZpjR
nP1z/dQkFfCYz+e/S9PvHuv1S5IcarB26KPzWDQ/ujBg7ng+Ug1YRlR4DTa4
0TYvh803DnXQEBdCnzYF0LuUS4ZntohASuA+rT8lhAK6LgqK4Rqw9PLcL6di
QWR+sUBtqIcIVWK+TcIpoohDejma10IdEqU655/ZCCFW63MPXYM04FO5mlj4
MQEkKI+H+TwmAp2SlOyrIR5EyDkltcymAXL7zstXRnEiNHArKeO7JqwGX9/9
6Co/imie79rW14RTt5W5tWj3Y1pxj9e7qA4bqf2pWYeEkX2IGE+LvSbIBAcV
zjOLI5G6psOn0jUA+1lCS19SaFG+WWaRpleHeBnfFNVKojLvFhEvT03QaOg4
nikig6I4Zm6/WNeCKOtC7bSbMqj303Zi57YG7DqhuZnvLovE16POXWBXh+Mp
l5ZtVgiIr/pQbl6cGsySB7z3lcqgQs6lmlzaedqrlspauCiJdkouWbz7oga9
uHoWa4Ukkv923ji7Ux3qJ8nvDSokkEkn+/KXYTV496dM2+OONBKx1LgrYqIO
0xeGGsOspNDG243nQzKa0FyiHBk/Ko7yTeMNx2q14OV7m50cD0UQg8qjE2tX
NaGb8/Iz+i0BFFvycljTUQuUVAaFQzZEUG27eXTQGS2Q/4vFTDIKoutxTCr1
FC0wuMxgTH+FB8Xm3lt7Fa8J8Y4b754PsaPQgt/ClsPq4EbhPfBMlwE9GxU6
+iRYA5QPR1Q80eVAHH8SVbPPaAC/pOWDWUcGZH2+0LpaUAMWPnwuj3q+hGne
Y9C+OqUOrmjQ7YTnBPYxPCjyjRERGFYEhhNyO7ChsskbV2j+8npF87ZU9Uds
qfa9U9BfTbAQkjiSF9mLu/s1+U1GaMNAVKAF2jOPd6hqBj4d1AQt9p7zWYdn
8Batr3riA9owQd/CRZmvxMTmLOtqY7Qh9q5eKdWkF/dsDl5bLyIBz9EbFydh
ATfhiOIfcSSD9GhLnlvlFl7qb++fMksGmcir32aMmcBNwf2wRr0OZDTNPeSN
XMH59Fv5uR/rQPJeqzbGli38X9PED/ccXahsnGlkKKGDg4kfV5PzdcDhXqXx
X1tGKG9quYaVk8EwiCVDuZMBiC/Z9+HlJDhz4qzptDw7jPNuB+TyksANK/zn
aMkAT//dG+PJIEGF2ZcjlszsYH5yJLCUnQQRaQVtqj8YQfjCBmabrEXzR8K+
o4osIHLgfVrpbQ2g73i17lHHDimEWt3Gb0TwbC2Q/hLFBOzKa5PMrhrwsfvv
qfzuTZxtmHjRf4qmTzP83XFTtP15W9lzR2pAOLWh+yCiBx6rB0b17log8ao1
S5OdFb6zSptzb2iAGvMxFyU3VrgpS3x4mzb/Bcl8I1H36aElcVV7J5kEDyMN
k2Qr1nEjaaqypQAZnjewfmxCa/gu95CTBwVJQPfw9Y5F1jHcZkBs+/RVbSAw
Lh3yKlnBk3Zou2vtJ4ELn6t2ufMQ3mnASe0wIYH7OJ/+GPqHn+B5N9h+QhsY
7neXaB4bx98Q86+I/tYEuonUpyp71vGLVD3j/jBNKKUbuG9hzQh5k+2/w7g0
4LphzsJHhk28+vpCMFeJJrgcx4fO49N4sETZ2s5vGuCXEcw6vbWGe52L65ji
14Lwij83+G3H8MDOrepaFy24Yrh+oiHjO17mYrh1lkCCuSEu9PnZNyy/cvef
+XktKPPiPO1aNo55Xdj75///H3uK/Jf0b88aVmmZPchqqAGhacWzucQ5LOv9
+SGr50TQ+xPc7HuwA7s7lsUqRtCAbNld9toXJ7DCifsFgn5EmDZqOEad/oDf
TxeaEPUiwrUzzA2TtLpFZOx4gScR3pLk+wTC1jGvvZc7a7aJULegdrfbgw79
lXZ+HCilBs+dBnxGJOgQg79HooqUOrTvqY943seIWK+UF2kMakBFRlqFoRAT
CtBE8Rs/teArS/i/DuNtrKYtByIsSHDqdEztWB4r8kkN/htM6//zyNk7X6/S
oYF8eOV+RRtOtwdyLnEzofvcl3qcmjRBcZ9Qy+tzDEiFaNB14p06FAiJy6oy
bWDPNzffVsoQIUbVSUs1awUrtMbO3CSqQhXvS+Vw5XHsl9FvkyI6FXDQ7aLr
NljHwu4ZZ97PVAa6BIKWbPYipp98YqLeURV6ZFu13T9OYb3bI2OUc8rQMi6/
azLmNxYgn1rQEqEKaM20hn/uDc6Oy0b6X1EFi9a/Q03EAdzI9f67rSLaerbK
+q4Rj/GrRz7dXf+gCO06a8fPqc/jxOToC60ailD5aY+13KUivOpfv/XHVwoQ
NCxEF3R3Eh9KMHBW4lCCicbOwbnjLbiRspjeg1AF6Lf+Pamz3IE3XNWYEQyX
g0jF98WuvH2YxtTA+PyQPMCrOrcPokP4vEE496YTLd+XhtwZezSKWw7bDjy1
U4KhrMaKxc9ruLho9KkTRkowO7rCHDK0gR8Oql9WpqrA0teLn6JGV3C2vltU
FmU1+PHir8Xg5gS+q+jyg8hhFbAcdJKxOr6Bvz1hZu9fqgI6LoPp9PZT+Jp0
TNnUsDJ0t8r47WT5jZOyKT3RwzS/v8OeRrfYh3vF7r22jhNB+lZHcbfTEl6T
5DYWO6oOJjJydvjpLdyfM710NUQTtmxYP1Z/YIZ3rYfFEjK14FB+4FP2qm38
bZySlvOUNvBvjqgGOrFABB2bWhnQ9GdzonYqnA6mP26/SPXRhIObLVm7A5dx
pX9LheX02nCEZ3SMjnkJn6YKsM+fJ4FsvclhD7txnOCh833HYTK0JnWfoBz7
hf/3Resl0V4Hqmv7k3dS2zCfxJ/eYj90oMDq0YneM2M4x8XtsM6duhD+bzz9
n/U8rrdW4i1kowPoSUXXk4Q8/PBiROddLR0Q8n3F+erJG4x3khpdrkuGGOk4
7ojzzzAh3GA5T48E9T/If/kZF7CFufX7HrS8Ky/r2Wq6cxVzbulb3xDXhpgM
j/XCwjVsuCfzca+kJgSkdk6QGTYxxo83xW/I0fjGfubHsYBFbHS1MebSZTU4
R2vbcvgSFqY+vT+Hxks+4XOnqSH06PlM3L0/PjQeTo2w6z3ChqxPBPR7H1eB
WrfuALNb9MiShWc7y0EZzhsT7ufS8mKsfJldxEFVYCS5l1+b4UBLn7cfnrVT
BS3pOwEpC4wosy7aTdFKDQqbNqobg9exTI0MDqZUIqR5Xre63syIbl5cv2E/
oA7fMefT0vV0SIdBcqK9VhOshFhknccWsBqeZ22wQxP2a6Wz53IvYHlNSwER
mDp8Hcrd5cS8jeVO57K82EUEzV667oJ4VlSxdua29z4iGKjis3PP6NHooCuJ
t1QdBlVXroSKsiKZujhmbW0i2DzIO7dPlgcND0tGRSqow7cdjr3W63zouvqb
XW5H1UDeslri/W5+FFtQ+gm8VSAmNCQzarcwer0rSuCoowoIvZ8xXd/Dj+Sf
Hs1sMFYBef6uvNNvhdAzg5dx4TuVIeRvUsIELoaERHNrXrEpQ/ylzof+XZKo
9cG1pKevFKGeY91KrlwW2bLJCLTq0PIaSBiLZ0ojXYkDu0yi5eEml+bcMkUG
vQnaWzd4VhFKygJ4K9MlkeTdG1vr/+RhXlvNc/qyLPJgfSbIaqYAsaWFIzTh
Qq/SdQNuUZQAN54aeichiVRTlfTCxJThCrfiV5sr4qgt9NKdEDNF2LwP37yc
JFCfk8LwAFUZDszSpTRQZZCBxfcU7npl8AneePj4lQxq5GvL/NGkCKzRxUQO
YTlk8SQwsrmVpi/Rsn6d+nKIO/lBReZ7FTB7zPParVQWTYL0t/1OyhB7MCLu
abos6vn3u+u0kyJw5virh0gQ0EXWd8dGPeQhJfq/vQbTUuiDoVZnipEcdCLr
/7jpxVFj8Fmdj18I0MndkvqVWxjJ64QuaSQQwLdCTDZ3QQzV5jQntnESINFe
UbggUgJxN3blBxyXgv5+pRRXXhmUZR7aqpEnAad+qv2Y+CKB/ntg0nxyWQoe
bE7vIWaKIddvIcxhCgRoqLuG6UWKoXjuIqsde6RA8vu/pFspQujGsbTE4VhJ
8Pm1SyZ2kA9Z/4tdUxOQBjmt+/STh7kRtD/wmdQlgLNcpVV7KjO6KDkR2FJO
AP6cKl2DQ+vY7aikmSQ3AowuWlO4i8extfeXbC0aZSHMm13j5o95LOiZdnn2
azkwGGiVS43dwii7latJdQSIjY8kv7FaxNLIdK7bGTJg0us6Z9JMh9oO8Xfk
6xEg7IOSgB9lEbuhXN5QIyYHGvWhRzNQF/aEtUEqSUQevJSFz0aeGcINUx6M
qXApQNV0CT9jyhfM7e/4NzlxRVjRdxM7fXwBuyuowbjbSQniOUWP3qT5446T
N9+/aFKCkLX85UuRbOiExu3AVzFKsHj1ez0S4EGRovWXJWaVoTjgxvefr/lR
u0nawpFjqhDncbFu6ig/au7WbX50XBkG3m0rWnkKI3GtF0cq/1MGmXmlG3Yl
Aug/hzClVjZV+OFRnxt7TwSxuQhm2UmrwpmEt0FnXggirgdVOGuTMhiMu+4O
aOJD2OOZfgleVcjMTpx1eSuA9Asya6xpejN3jn2fmQsf8hz7IPlyRgVc3S68
wE8IIpsG7sZOqhq4XTz12UdTGA2kXbp8g0EdzE/kDR/hEkd2Nm3D1xLUwalA
ZHqGKomuKDKJELrUgGx76cLbeSkUOuMfwnCXpj+PzkzE7yEgXRv/+EMXNEBc
yteJY0EGOXYF5ebbaoFNw263S4oyaGrg8ckSBRKsJRXNOtRLoMMbHfeiTLVB
3+FSVBRFCvn6jm+HJNP4Q3tfaPBJMbR121QrxIgErepzNuslQuhRFJt1b4s2
JHj9oLe3FUURHIKEg3dp/tJ45WZxiwQaMvWVFFUgA2e283pWmwha8jMPjKGS
wSHqVbaMhyB6kv8sL6yBDPvDv/8wXedH3J472exaSeAo1lV2slsYbVwz6LK8
RIJPd9p3Gh8QQMspaDtukwTb+efNIhL5kdUpyRt3V8ig8XavOo8SH7IovbK6
m40MHHznm+nIgohe1EpXtYIMe2VGeeOPCyPBGj7pjAQd6OvA3YsKBFGCoQm7
cwEZDtG1M+vuFECJC9diCh+RoPbv6TdPP3Cjaxf+YX7yJICUzNO1jwTQcWqd
en04Cbx3Dd5ZFBFGbCmb3ps7yXCytM7NxIsfZdnfMq+9Q4avD+RtVZn40Sex
vcv3b+uA5Py8l/lFIeSuzF/XrKQDBhapF4sr+dDevadlbYN04IyNqKf+ZUH0
y1r5wnQjGcIV9bbzNfhQ/CNJj5MkMtxq5XrdrsSBdvcueRI7ybB7ViLV+Q4b
ku3/r/d9NwlGE0qjT/2gQ4wcz+fe5JBg7E+slvRnJnTma8ka9RwZIvWCH788
wI5i9Pz/22GlA0YhD+k+anGjxW+iXKcCaPmg9+wOigutn7J+RQ+UdYDi28tp
YSJA41VykyNBF6Q1tM+s5tDyfELepysKOrAl76W4e5gfcc2qvvwtrwuX8u0r
PG4KooPtkbL+xjpgTOF/2hktjBQjVgOvSekCNYKb4VmsAMoi6TT7vtUFPfGj
7jn+PMg992ajr6Me0LNXFH5QZ0Oskop05rW6UNHuXli+mx4NhE9pCRvqgcqh
8o7uYka0TZ1MuW6hS+Oj6Di+hmWMS5xFRipWF7Idz4Y2j6xiDx6+vv7qgh4Y
if2uDFZYxDRvZRf2+lAgJ9gtv1mEHpk8bBqJ4qEAiej46CQnO7osx6V3XI0C
fR9zNFd9uJFcb5yTOh0VtnTv6p1p5Ue3rgnQPXenwNcvV95TW4WR20sZNlMn
Cjje1i387E6b92GmNwnmVHgvHCVnmCGIjui+CdVaoIBB0THDy1v86MaiZ4lx
HxVUn20iBxVeJCz9QI38QB96kgmkwgRB9G3mTDZXpD6INUnc29gjhApH8n60
x1CB7WGsyv0BAVRy01X3cKA+JHnbunEDNxJxeLGdGaUPthz3l06O8qP9cSXP
279SQbshsij6Pj8q6QqutOiigLUbz/p4jwDiUvgvcntQD+LPVTCnn+ZDxFH1
n/3lFKD6j4SfIgqioU89bRsLetDkHuTNziuK6rFg1K5BgTY5g/i+DnHUxSrf
b3dGD67GFO8/ZSeKCh/urntkTIG3bORde8uEUbjnkbdlh/RAcXmDdK+BH+Xv
7PLqidaDjNfricNGtPNc92N/TxQFwvzl9FZe8yHnsodVGbR6YOPlL/e3+FB0
fp0/XYwuBFoFWHttCSF69e2g+Yu68CIvX4mPIoCqn+b+tvigA0ytIqxxPVzI
d0pMZPucDlwdeGHbI8CJ1PCpk0djySA2mZh45hITerlxP9V+hgQ+QgyLf6+s
YbL6L81VnclQ7sAwyWnMjPoZu2wdQ8ig9LJrLaOYHTV6smm259H0ajlSfnKQ
AXHYj7ufVyLD9d6q8corDOgA59mJHbTzunfz8fifYgZEmYqrsaDVtbaeer1a
YkAGK6+jw5VoeVv+RbjNHDPKkanLbQrUgu87vU/eXV3HeF994+OgaIEJH33g
eeffmF5RBn6JxvfZDtfa/wRtYBoDB3a946Tp8cMTgkz0M1j87YopOVZtqLx6
tT9u+RFm8XOQ7SAnCfzvjNKlk19jYY2bWSYcZNC76nxTLek7VuVNUVNn1IGx
RveXg0p/sZ73sUU5rjqQRnjEzmQ5g7m9iEyoDiYDH8v3/4oWvmHjUYHTa3tp
vB4+ck7Esg3fn7DUpCGmC+jugoRU5DCWzGRyKyxSBxRqBRmLXg9jjuOTrGci
dSFhljrjObWC3Ywp/JpWpwskk882320msSMXLtyTENIFpVoFy5Efa1gR1x17
9QIdqNk2YmxyYUZ/WnTDlF7qwPe8gw92ff3/99pPnNmgCxS/9mTXVWaU2vsu
x+i1DjAX5ol+xznRruAB4pFQXRh9J5jiMcqKjG7sTq2z14NkvWOrc3dYUGbI
iNllWwoc3UORCS9jRSe2PQ3K7Wjz/efqw5NbPOjsudOMj6d1wY8z9lUbPwei
0z7uEFSjBwJ5TINvPzEj/9sqfcRUCnzSumk0/pMN7bIM53oYSYXr+wliSUP0
qC3OJN11mwIZHTE2NxfXMLG56SauLipwaX9Ii6X7g81zH6kye6gPXewKh8/r
rmLpf3w87jRT4Ym9U+uZulHMesfeN1J2VCgONa/XZvqKqwXmznwnUwFnYy94
mDWCPWIgj2jdoMLk85JS+Svz2BiLkSBTGQW2CqUvH+BdwdRNs3IXkqnQs3Ju
0PbALCZiWnHvPy99+BvA1MZJ3MDCjc0TytqpsLM7JmNHwjIWjvzIDd8ocLLK
rRsjMaBy//Mi8Rjt/Bu9ffbBZg27vRbAnspCheEGJf38jnHMVsBGZTCMCrZz
1c1DHj+xUNmz2+cC9GH6U67JSflOLEWbd4ThDBU+Tjm1j0YtYbwXVPa7XKKC
275Btt/5PVip3Hmb7m0qPNTtufakqh9Tvuk6a7OtD5hS3thMRT9+WZgu8YOH
AXw3XA+rifuGS4ok3cp1NwSh5cNnMzymcOZJTlUeUyMY+vF95qXPX/wDYVPm
tZshiEdY8763/4uXi/5LeeVmBD9D+Avnz/3FjxXW9uFuxiAQn9d2za8bJwZd
GasxMQa3G8Jk//fDmC1+2XYr0xi+15NcWlq78HmNzhZnqjFQr9iRXct/YZaL
G2MXuIzhV9vTT651fzBylY/dlTFjMDiY6tVziB6d6rk5tLBlDCb9d7+S9Jaw
Qx0f9n9IM4aJvk/5npd7Mb/2Gn5vMROYarRTP5/9DzNWPndPmNUEcg683fCI
7MPMBXr7pPeaQIREeOJb6b/YxMXP2hrNJpA92FZexbGN+ZtQzI+uG4Pse6HD
i+r0iH+lqvIXnTFEBqil5zvSIwlvn6xFOiO4++F2Oqc4HTpG8TjIz2QIVA+z
KXLtIqbYTpc04G0AI2rR1Fcn6JGvP8tufj4D6J2y31jYw4bSBDkH0pP1wYLJ
1fVzHjO6/0xX2SSXCnOxpwpZ4xlRHzG0DhVToLFdrPR24BbGK1gzo95O0+eo
uMuVC3QoYM3yom6nLuTcuqNStMCGGAm70jQ7dKHqKh+fYDMDonqTHiRp6kLZ
g5S5mlRGpBGR+tNcQw9MXBz8KnZtYYpf6I2T6Ckg8fCSUukHJvT+Z1+Ofg0F
VJn+rZfEcSDBU9/fvfCnQmR0W1TTE5r+2xZ0mU9T4XDzb2e5S+zo8Gm5655N
VEga3ro3DXxIewjf+v2BCjmPrT+3n+JHo3dPmexr1QfVbZ4Y7Lkg2v+fqqn1
KhWkVSwfF9wTRhbVZ1NPi1HhraqpmPc/ftTL8DBIOIoKX05OX+Go4kaPWrrM
q6X0gU44xiU0iQftNnE4KSVDhSEnZXr54wJo2qv25UQ0BdAl8S+f9okgyvl7
O542UID4seRb+SkB1BZkd2R2gwJP2o6craD5zynVJ5NJ9FQwbWcLPvmRHT0N
sDq6Z5bW7wqlqa1cTsQYvi+5f4kC2Yzyp+L2MyHdfdyd192oEL7+S+EU/Sr2
bNOQ83IWFaLb0mX0WEawom67fwUOVFD8k9jT+7EZ50A7hDwe097X1COrn1O/
sDHfAVcDGl+A/Jqf6PIdXHbYa41wlQK/FJ1cXnRMYQKfh3Mc/lGAK48+9Wkd
4BvdpDnNPxQY3t6IR0U4Xvkte6/GHyoYnCgYcdw3ielmxxtou+gD29lHr1Ys
a3C6af++gz+p8N9noQMrR35jbfZnhVdp+qDtWOgY8GwZmz9U+6+fStMHg8C+
vxkL2AHrB2QvS5qeuHet5vr8wm7ljThY+FJgPus7r2PjF9xnT90EnxAFno8/
nUuwGsXmTwv++P/veVUr1oJefW/HM7VbIgxfUeBdUc3XQ2v9OP+qeWRyA+19
S8hKGF+fxve/K9l81EmBF9KPzuwIXMd9Ko41cppRIH3U82NjETOYlF+2odLu
9yuooU8ikBuEgi1sjQopIGvsd/JhAD+8fq37lHFED6T4Vqg8plzArLZk0BVC
gRYfzl4PLg6IJr/kyo/Sg+Pj7cfPUPkgy3vys7YoBcLnLeVemfLA6s/5wkkC
jYd2Fm0qO/JDggLzm59/9cDBgFek5gcnfGm05kmJpECo1Ngs6zg/COC9r3lv
0fZzT2rQI50PtC+IFBbf1wMeozcEyzUB4O0/+JPwQxe6BU5b6JqIQPLBx/Mp
u3VhtuNw+v39AhBTYceEJHThEKsoQ3K1MAw9HYv1zdCBYY73cHONH8Q9qoKc
9XWAfXqvtc9jfmg4dvsohwEZXtTsGbf35ITGfm8TNR0yLBf0sbwz5IOZIEan
xWUybFd77tpw4wAhzn/eLDQ/jrecrP58gwsm7mSlsDwgg+BHVey4EAdM9C9G
GOXqgIBtpMuNfEZYD7NJ8WXSgQ6WpG5pnVVcU8LQxSZGB/6TslXJOj6Jb5gp
s536SQamgITYiDcv8VDeiqPL0mQoqq69IfxfD/6tu/FmhzIJmILmO/85LOAr
8/5+Zt+1IIHu7Fu0OopXBY5TnBg0gSVgYkOdbRGfuR71fvK5FsybOCHPX634
3nWOsUuHtUBR27GUktiMGy/I+qg5aECUQuIsw+FR3OI+2fMxrxaoeq57EX0X
8cLGo3teHdUAV22/+tin9OBwKkjOxEMD3O5nkSL86KG3ckDul7sWJJ3p/sBU
wAJhUV8Dzg1rwxHTWhU8nQuMw75aK9P476uh/TO2DCawqYrOMbxHgv1a2ice
zDDCW8mPG0eKycBT8dEo04wdLKVdJ5y8dWCiK1qFo4APbrWFZ9y00YGLwb4c
JinsEKb/q+YTmw64G+/8mbSXD2L6n7y4eJ0MVvbVN0fOCsJvv22vY6o6QMz6
JM3IxwviPzceK6+T4c67iJ3H2DjBvz+G3eq7DmjFHniWc4EfuErf8lg16sA6
q7jOezVOuGJc9YAxUQdc2bnF62T4Iea4tU8Rtw4kl9S4rMQJgoaaNJcpIoOy
DXF+mXadSvz/NQkIe7u/JIeKwvbddudZERIYfkXVm16SUJjJxXtmDwlqzqK0
s/2isD+kOdb2JQlWdp4PSfIRhZqqzeAUnAxsquvalx1FgGedTzemRgcCm521
JXFhaGZJl7n3VBdKe57j162FYOoK93Z7sw70jJVGm/DyA89Go4mdNo1Hdb1m
DJ/wgY/0aXo/Wp4dfiTeJVvJAYcpExzhz2l5OYIqZ9PICmwxKsqOpTQeHBIL
8P/DAwlC5Rm/aXya9s5FNzNXAMjyz2f7aPx/2v5cbJm8EHyeEv9lQetvdwvd
HlMdQcB6cj9LXdKB89xbT9ONBeHW+xIxiUu6MKlP/1JNRQSW9YlPOSl6oNU7
J+HLKA7Ed/us6Sb0AOWwWTyOFAFzwuSzOjk9iLiwu6gxRhBGq+jrSTS/TP3G
qEn3VwSMY9REfxygwNX9ud19fYJwfK/N8aJSPVjIXlqWWhAAT92iP/hdCtTm
Hvsv9JkIVH61du9dpeXLf5xyXsfEoHxXVJfQMBVC/2ZIDJWIABpbzMxs0Yel
rWu96wclQLnc7LMXjffiTxmOJntIg01Nue/u51QojRa27D0uC7EBsgrN2fpg
lcu5u0xKDs4Xf8S1rA0g6ngxw7gIAc4lKa6TiYZQ4PwlCtshBTWrZ51GHA2B
hefp3Oq6ODznsJZXUzeCxxw6A6lKEpA9WsK/SDQGLpYmO3YxGeDeP5xwnt4Y
qpH446pqAhyQGD9xjsZDi66tjGfNCGB9doVx4ooJqGdgF2XTpSC3d+3st2cm
8MXE+Gbebin4fXOTXemZKWAuy3bbnVKQjlZMGqp2wLGZv9nndhKAS2N2x1Ob
HRBinCjH1CkDyxu/N8MMMJBo35Fwl1bn/EMRbqLVFWR3zv5xJoC3XhjhnA0G
1afdHvwLkoGtj6S5Dn4Epp9ivovxysEBLtY5IwsEZd++iny9JQM66q4JunEI
mKq9LBy5ZeGuHb3bUTozKP9FsW8RIwB/Us9GdSKCowpNJrHn5SDnCeu6mhoC
oVJJtkNEAiw8yDiw4z8MFrUvGbr+kYLLR5ruNbFhECNa5c4dRADW0nnBPtp+
a8qujR+YkILxNFmKtjMGp+kxuotGEvDUYbJFIHcHpC22W1h6ikHdMag8WGcK
p+7yOO8bE4W0Y7E/JBpMgPcgY2jAoBhsf7ENda4yhcX2qeuXTkqA3MU7chpv
TcD33kTujnJxuODKXf6o1RjSVxwfF5dKQQdH1stRgjGYSd1wJAjLQlRd9r9+
eyPgknlx8my7LIQxfligczaEW7w/KCfPyMHBSwupyWuGIMql/OaLjTwIueYq
1gsaQqJvTZXHRwIcmlTovddoCK17LywWTsvAp95CB74tA1AO26XFd5DWnzbe
XrcjhrBUkxE4eF8G/iZbJsuYGkLaG984Qr8kcDYaG7YnGkD7vo/tu0VkILvG
cCLPxRD4vgmxp9kQYFhlgIoIRvDusxRf1S8CYNKXXK2EjYHD0LE4UEAGwl2a
8sxCjeEWd5GVu48k3BhgV72sYwL+hEMuC7ZSMCN2SCvU0BiMsoXuHVUgwPb1
4XSipzGIDR9v/dAmBwrSx4VcZ42B1VWspeSmLPTuk9i1OWUM3fSXuetoddMi
7MsrGu83Xg6Tvv2HAG7GxcGTW0awMvV6/0iNPNgHGbSMXzKCV/lXdeYMFcFg
4F/KBS1jqLlj9680VB7edRtYBNUaAdbAVB+TIQdTLs15ez4bgovP8n0/b1kw
zdY+GKdsBD/O7cgSOyUHZ/neLx25bwTXA4jLvUoKwGZHr9Cmagy1FbM3ly8o
wJjgTa9VRRPgCSjQSbouB4PZ8lv2tP19x/cE7nGVA47JfQH/jRuBzV2+yNht
AhRqSC6eHDEGG7b6fYeUZcDXsr7pkZoJ3HuhaH9+Uwpmq9Tel+kZw58GM3//
aAIcH6m2T1Q3BknyaLHODVn4HR3CxmRiBGev5XrmuBDgyKSRScxuQ6CY6UXP
zRCA+PiCvp2tAcyFfH1juUMGTpl05neM6INzvbsMZEhA53RYSF+UPrATrsbK
vRIDo+Yw8Y1sKlguyRaP3RCGktfC002bFBAnp8ljN8ThijjfkV+0vJlkd1pP
kU8C0g6/F1ln0ofoXQecAgqkYeiRXmBjKhUc7+Zf00kiAHN7wekH3FQg5i3+
ViXJw3S8+zU5Go8bia33ZDkSQFHiZ9i9QQr47iwTUJaQB9cdHeGmLlSQ+XnD
TK1OAd7cTvErek2Bg54RVeNuimBYZ0NkrKFCloU2t5CAMtiz15wzN9aHZxi5
jL1ACTy8naRy9Awg5h+j95CxMpzdPikvYKYPVV6agwcnFMH/1IeJUjoDcCtw
/54bpAw7Fg8SNO4ZAPnEzM5ZUIICRZEXNdX6kJqXa2nZpAJyrde4SV/0IT/z
ZujXIRXYVhpW/faFCo2ZjKU7jVThRmmb+dYnfbh9c3HX+W1lmA0WLBFl0YfQ
jqxjHc9VwSimv/DdZdrzXKvTfyenCgf87Nzab1DAynzLveOJGtw+VGLLvKQH
9wWCvD48UQeOytBJyz96EPpQxqukXg2IDvxmCzIUuKVlGTT6QB3c3EbWfnlS
gCdl9uUFNQ0oJI0YVjpS4X9FtOaa
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{184.9999999999988, Automatic},
  PlotRange->{{-29.857955940461743`, 
   30.759677801897702`}, {-34.003001690528684`, 45.78564888883599}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"5.8 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Line", "[", 
   RowBox[{"walk3DOffLattice", "[", "5000", "]"}], "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 Graphics3DBox[Line3DBox[CompressedData["
1:eJwMV2VUVV0QpaW781GP7s676S4VFD8JESkVkxADEUFCEBULDATEQkWwEd6j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   "]],
  ImageSize->{151.7499999999982, Automatic}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Column ",
 StyleBox["4", "OsF"],
 " of this matrix contains several different nonnumeric values."
}], "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0.796495", ",", "\"\<N/A\>\"", ",", "0.070125", ",", "\"\<nan\>\"", 
       ",", "0.806554"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<nn\>\"", ",", 
       RowBox[{"-", "0.100365"}], ",", "0.992736", ",", 
       RowBox[{"-", "0.320560"}], ",", 
       RowBox[{"-", "0.0805351"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0.473571", ",", "0.460741", ",", "0.030060", ",", 
       RowBox[{"-", "0.412400"}], ",", "0.788522"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.614974", ",", 
       RowBox[{"-", "0.503201"}], ",", "0.615744", ",", "0.966053", ",", 
       RowBox[{"-", "0.011776"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.828415"}], ",", "0.035514", ",", "0.8911617", ",", 
       "\"\<N/A\>\"", ",", 
       RowBox[{"-", "0.453926"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"col4", "=", 
   RowBox[{"mat3", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "4"}], "]"}], "]"}]}], "]"}]}], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"\<\"nan\"\>"},
      {
       RowBox[{"-", "0.32056`"}]},
      {
       RowBox[{"-", "0.4124`"}]},
      {"0.966053`"},
      {"\<\"N/A\"\>"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "To pattern match on either ",
 Cell[BoxData["\"\<N/A\>\""]],
 " or ",
 Cell[BoxData["\"\<nan\>\""]],
 ", use ",
 Cell[BoxData[
  ButtonBox["Alternatives",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Alternatives"]], "InlineFormula"],
 " (",
 Cell[BoxData[
  ButtonBox["|",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Alternatives"]], "MR"],
 ")."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"col4", "/.", 
   RowBox[{
    RowBox[{"\"\<N/A\>\"", "|", "\"\<nan\>\""}], "\[Rule]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"mat3", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "4"}], "]"}], "]"}], ",", 
       RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0.07769766666666666`"},
      {
       RowBox[{"-", "0.32056`"}]},
      {
       RowBox[{"-", "0.4124`"}]},
      {"0.966053`"},
      {"0.07769766666666666`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Convert the list of strings to a set of alternatives.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Alternatives", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<N/A\>\"", ",", "\"\<nan\>\"", ",", "\"\<nn\>\""}], "}"}]}], 
  "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"\<\"N/A\"\>", "|", "\<\"nan\"\>", "|", "\<\"nn\"\>"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is a third set of definitions, including a new rule for ",
 Cell[BoxData["ReplaceElement"]],
 " where the second argument is a list of strings. And another rule for ",
 Cell[BoxData["ReplaceElement"]],
 " accommodates the new argument structure of ",
 Cell[BoxData["colMean"]],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"colMean", "[", 
   RowBox[{"col_", ",", 
    RowBox[{"{", "strings___String", "}"}]}], "]"}], ":=", 
  RowBox[{"col", "/.", 
   RowBox[{
    RowBox[{"Apply", "[", 
     RowBox[{"Alternatives", ",", 
      RowBox[{"{", "strings", "}"}]}], "]"}], "\[Rule]", 
    RowBox[{"Mean", "[", 
     RowBox[{"Cases", "[", 
      RowBox[{"col", ",", 
       RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceElement", "[", 
   RowBox[{"mat_", ",", 
    RowBox[{"{", "strings__", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"colMean", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", "strings", "}"}]}], "]"}], "&"}], ",", 
     RowBox[{"Transpose", "[", "mat", "]"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceElement", "[", 
   RowBox[{"mat3", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<N/A\>\"", ",", "\"\<nan\>\"", ",", "\"\<nn\>\""}], "}"}]}], 
   "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.796495`", 
      RowBox[{"-", "0.026827749999999997`"}], "0.070125`", 
      "0.07769766666666666`", "0.806554`"},
     {"0.26415625`", 
      RowBox[{"-", "0.100365`"}], "0.992736`", 
      RowBox[{"-", "0.32056`"}], 
      RowBox[{"-", "0.0805351`"}]},
     {"0.473571`", "0.460741`", "0.03006`", 
      RowBox[{"-", "0.4124`"}], "0.788522`"},
     {"0.614974`", 
      RowBox[{"-", "0.503201`"}], "0.615744`", "0.966053`", 
      RowBox[{"-", "0.011776`"}]},
     {
      RowBox[{"-", "0.828415`"}], "0.035514`", "0.8911617`", 
      "0.07769766666666666`", 
      RowBox[{"-", "0.453926`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Start with a prototype logical expression.", "SolutionItem",
 CounterAssignments->{{"SolutionItem", 8}},
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"A", ",", "B"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"expr", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "||", "B"}], ")"}], "\[Implies]", "C"}]}], ";"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vars", "=", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], ";"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell["\<\
List all the possible truth value assignments for the variables.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tuples", "=", 
  RowBox[{"Tuples", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"True", ",", "False"}], "}"}], ",", 
    RowBox[{"Length", "[", "vars", "]"}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "False"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
Next, create a list of rules, associating each of the triples of truth values \
with a triple of variables.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rules", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Thread", "[", 
      RowBox[{"vars", "\[Rule]", "#"}], "]"}], "&"}], ",", "tuples"}], 
   "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "True"}], ",", 
     RowBox[{"B", "\[Rule]", "True"}], ",", 
     RowBox[{"C", "\[Rule]", "True"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "True"}], ",", 
     RowBox[{"B", "\[Rule]", "True"}], ",", 
     RowBox[{"C", "\[Rule]", "False"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "True"}], ",", 
     RowBox[{"B", "\[Rule]", "False"}], ",", 
     RowBox[{"C", "\[Rule]", "True"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "True"}], ",", 
     RowBox[{"B", "\[Rule]", "False"}], ",", 
     RowBox[{"C", "\[Rule]", "False"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "False"}], ",", 
     RowBox[{"B", "\[Rule]", "True"}], ",", 
     RowBox[{"C", "\[Rule]", "True"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "False"}], ",", 
     RowBox[{"B", "\[Rule]", "True"}], ",", 
     RowBox[{"C", "\[Rule]", "False"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "False"}], ",", 
     RowBox[{"B", "\[Rule]", "False"}], ",", 
     RowBox[{"C", "\[Rule]", "True"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"A", "\[Rule]", "False"}], ",", 
     RowBox[{"B", "\[Rule]", "False"}], ",", 
     RowBox[{"C", "\[Rule]", "False"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Replace the logical expression with each set of rules.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "/.", "rules"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "False", ",", "True", ",", "False", ",", "True", ",", "False", 
   ",", "True", ",", "True"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
Put these last values at the end of each \[OpenCurlyDoubleQuote]row\
\[CloseCurlyDoubleQuote] of the tuples.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"table", "=", 
  RowBox[{"Transpose", "@", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", "tuples", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"expr", "/.", "rules"}], "}"}]}], "]"}]}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "False", ",", "True"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Create a header for ",
 Cell[BoxData["table"]],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"head", "=", 
  RowBox[{"Append", "[", 
   RowBox[{"vars", ",", 
    RowBox[{"TraditionalForm", "[", "expr", "]"}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"A", ",", "B", ",", "C", ",", 
   TagBox[
    FormBox[
     RowBox[{
      RowBox[{"A", "\[Or]", "B"}], "\[Implies]", "C"}],
     TraditionalForm],
    TraditionalForm,
    Editable->True]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Prepend ",
 Cell[BoxData["head"]],
 " to ",
 Cell[BoxData["table"]],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Prepend", "[", 
  RowBox[{"table", ",", "head"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", 
     TagBox[
      FormBox[
       RowBox[{
        RowBox[{"A", "\[Or]", "B"}], "\[Implies]", "C"}],
       TraditionalForm],
      TraditionalForm,
      Editable->True]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "True", ",", "False", ",", "False"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "True", ",", "True"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "False", ",", "False", ",", "True"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Pour into a grid.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"Prepend", "[", 
   RowBox[{"table", ",", "head"}], "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"A", "B", "C", 
     TagBox[
      FormBox[
       RowBox[{
        RowBox[{"A", "\[Or]", "B"}], "\[Implies]", "C"}],
       TraditionalForm],
      TraditionalForm,
      Editable->True]},
    {"True", "True", "True", "True"},
    {"True", "True", "False", "False"},
    {"True", "False", "True", "True"},
    {"True", "False", "False", "False"},
    {"False", "True", "True", "True"},
    {"False", "True", "False", "False"},
    {"False", "False", "True", "True"},
    {"False", "False", "False", "True"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Replace ",
 Cell[BoxData["True"]],
 " with ",
 Cell[BoxData["\"\<T\>\""]],
 " and ",
 Cell[BoxData["False"]],
 " with ",
 Cell[BoxData["\"\<F\>\""]],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"Prepend", "[", 
   RowBox[{
    RowBox[{"table", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
       RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", "head"}], 
   "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"A", "B", "C", 
     TagBox[
      FormBox[
       RowBox[{
        RowBox[{"A", "\[Or]", "B"}], "\[Implies]", "C"}],
       TraditionalForm],
      TraditionalForm,
      Editable->True]},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "Add formatting via options to ",
 Cell[BoxData[
  ButtonBox["Grid",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Grid"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{"Prepend", "[", 
    RowBox[{
     RowBox[{"table", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
        RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", "head"}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Dividers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", "Black"}], ",", 
        RowBox[{
         RowBox[{"-", "1"}], "\[Rule]", "Black"}], ",", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Rule]", "LightGray"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", "Black"}], ",", 
        RowBox[{"2", "\[Rule]", "LightGray"}], ",", 
        RowBox[{
         RowBox[{"-", "1"}], "\[Rule]", "Black"}]}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"A", "B", "C", 
     TagBox[
      FormBox[
       RowBox[{
        RowBox[{"A", "\[Or]", "B"}], "\[Implies]", "C"}],
       TraditionalForm],
      TraditionalForm,
      Editable->True]},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>"}
   },
   AutoDelete->False,
   BaseStyle->{FontFamily -> "Times"},
   GridBoxDividers->{
    "ColumnsIndexed" -> {
      1 -> GrayLevel[0], -1 -> GrayLevel[0], -2 -> GrayLevel[0.85]}, 
     "RowsIndexed" -> {
      1 -> GrayLevel[0], 2 -> GrayLevel[0.85], -1 -> GrayLevel[0]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Put the pieces together.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "vars", "]"}]}], ",", "tuples", ",", "rules", 
      ",", "table", ",", "head"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tuples", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"True", ",", "False"}], "}"}], ",", "len"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rules", "=", "\[VeryThinSpace]", 
      RowBox[{
       RowBox[{
        RowBox[{"Thread", "[", 
         RowBox[{"vars", "\[Rule]", "#1"}], "]"}], "&"}], "/@", "tuples"}]}], 
     ";", 
     RowBox[{"table", "=", 
      RowBox[{"Transpose", "@", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "tuples", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"expr", "/.", "rules"}], "}"}]}], "]"}]}]}], ";", 
     RowBox[{"head", "=", 
      RowBox[{"Append", "[", 
       RowBox[{"vars", ",", 
        RowBox[{"TraditionalForm", "[", "expr", "]"}]}], "]"}]}], ";", 
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"table", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
            RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", 
         "head"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dividers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "2"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "LightGray"}], "}"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"2", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "LightGray"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}]}], "}"}]}], "}"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], "}"}]}]}], 
      "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TruthTable", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"A", "\[And]", "B"}], "\[Implies]", 
    RowBox[{"\[Not]", "C"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C"}], "}"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"A", "B", "C", 
     TagBox[
      FormBox[
       RowBox[{
        RowBox[{"A", "\[And]", "B"}], "\[Implies]", 
        RowBox[{"\[Not]", "C"}]}],
       TraditionalForm],
      TraditionalForm,
      Editable->True]},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"F\"\>"},
    {"\<\"T\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"T\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"T\"\>", "\<\"F\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>", "\<\"T\"\>"},
    {"\<\"F\"\>", "\<\"F\"\>", "\<\"F\"\>", "\<\"T\"\>"}
   },
   AutoDelete->False,
   BaseStyle->{FontFamily -> "Times"},
   GridBoxDividers->{"ColumnsIndexed" -> {1 -> {
         Thickness[Tiny], 
         GrayLevel[0]}, -1 -> {
         Thickness[Tiny], 
         GrayLevel[0]}, -2 -> {
         Thickness[Tiny], 
         GrayLevel[0.85]}}, "RowsIndexed" -> {1 -> {
         Thickness[Tiny], 
         GrayLevel[0]}, 2 -> {
         Thickness[Tiny], 
         GrayLevel[0.85]}, -1 -> {
         Thickness[Tiny], 
         GrayLevel[0]}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"Position", "[", 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], ",", 
    StyleBox["elem", "ExerciseTI"]}], "]"}]]],
 " returns a list of positions at which ",
 StyleBox["elem",
  FontSlant->"Italic"],
 " occurs in ",
 StyleBox["lis",
  FontSlant->"Italic"],
 ". ",
 Cell[BoxData[
  RowBox[{"Extract", "[", 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], ",", 
    StyleBox["pos", "ExerciseTI"]}], "]"}]]],
 " returns those elements whose positions are specified by ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearTo", "[", 
   RowBox[{"lis_List", ",", "elem_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pos", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"lis", ",", "elem"}], "]"}]}], "}"}], ",", 
    RowBox[{"Extract", "[", 
     RowBox[{"lis", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"pos", "-", "n"}], ",", 
        RowBox[{"pos", "+", "n"}]}], "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearTo", "[", 
   RowBox[{"lis_List", ",", "elem_", ",", 
    RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pos", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"lis", ",", "elem"}], "]"}]}], "}"}], ",", 
    RowBox[{"Extract", "[", 
     RowBox[{"lis", ",", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"pos", "-", "n"}], ",", 
        RowBox[{"pos", "+", "n"}]}], "]"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"chars", "=", 
   RowBox[{"CharacterRange", "[", 
    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", "3"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "\<\"n\"\>", "}"}], ",", 
   RowBox[{"{", "\<\"t\"\>", "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NearTo", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", 
   RowBox[{"{", "4", "}"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"\<\"m\"\>", ",", "\<\"n\"\>", ",", "\<\"o\"\>", ",", "\<\"p\"\>", 
    ",", "\<\"q\"\>", ",", "\<\"r\"\>", ",", "\<\"s\"\>", ",", "\<\"t\"\>", 
    ",", "\<\"u\"\>"}], "}"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "The key to writing the distance function is to observe that it must be a \
function of two variables and return a numeric value (the distance metric). \
We are finding the difference of the positions of a target element in the \
list with the element in question, ",
 Cell[BoxData["y"]],
 " and ",
 Cell[BoxData["x"]],
 ", respectively in the pure function. The use of ",
 Cell[BoxData[
  RowBox[{"[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}]]],
 " is to strip off extra braces returned by ",
 Cell[BoxData[
  ButtonBox["Position",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Position"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NearToN", "[", 
   RowBox[{"lis_", ",", "elem_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Nearest", "[", 
   RowBox[{"lis", ",", "elem", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "n"}], "+", "1"}], ",", "n"}], "}"}], ",", 
    RowBox[{"DistanceFunction", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", 
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"lis", ",", "y"}], "]"}], "-", 
           RowBox[{"Position", "[", 
            RowBox[{"lis", ",", "x"}], "]"}]}], ")"}], "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
      "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NearToN", "[", 
  RowBox[{"chars", ",", "\"\<q\>\"", ",", "4"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"q\"\>", ",", "\<\"p\"\>", ",", "\<\"r\"\>", ",", "\<\"o\"\>", 
   ",", "\<\"s\"\>", ",", "\<\"n\"\>", ",", "\<\"t\"\>", ",", "\<\"m\"\>", 
   ",", "\<\"u\"\>"}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Rather than try to incorporate all the conditions into one rule, it is \
cleaner and more efficient to write separate rules for the cases where the \
input is prime or less than or equal to one.\
\>", "SolutionItem",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", 
   RowBox[{"n_", "/;", 
    RowBox[{"n", "\[LessEqual]", "1"}]}], "]"}], ":=", "False"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", 
   RowBox[{"n_", "?", "PrimeQ"}], "]"}], ":=", "False"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[TextData[{
 "Given the factorization of a number, separate the prime bases from their \
exponents using ",
 Cell[BoxData[
  ButtonBox["Transpose",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Transpose"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lis", "=", 
  RowBox[{"FactorInteger", "[", "852", "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"71", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Transpose", "[", "lis", "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "71"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
This multiplies the integer digits of each base by its multiplicity.\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapThread", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IntegerDigits", "[", "#1", "]"}], "#2"}], "&"}], ",", "%"}], 
  "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["Here is the sum.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{"Flatten", "[", "%", "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["15"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["\<\
Check that it equals the sum of the digits of the original number:\
\>", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{"IntegerDigits", "[", "852", "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["15"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell["This puts the pieces together for the general rule.", "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SmithNumberQ", "[", "n_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis", "=", 
      RowBox[{"FactorInteger", "[", "n", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"IntegerDigits", "[", "#1", "]"}], "#2"}], "&"}], ",", 
         RowBox[{"Transpose", "[", "lis", "]"}]}], "]"}], "]"}], "]"}], 
     "\[Equal]", 
     RowBox[{"Total", "[", 
      RowBox[{"IntegerDigits", "[", "n", "]"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[TextData[{
 "Here are the Smith numbers less than ",
 StyleBox["100.", "OsF"]
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", "100", "]"}], ",", "SmithNumberQ"}], "]"}]], "Input",\

 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "22", ",", "27", ",", "58", ",", "85", ",", "94"}], 
  "}"}]], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "There are ",
 StyleBox["376", "OsF"],
 " Smith numbers less than ",
 StyleBox["10000.", "OsF"]
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     SuperscriptBox["10", "4"], "]"}], ",", "SmithNumberQ"}], "]"}], "//", 
  "Length"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["376"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[TextData[{
 "As an interesting aside, you can also generate Smith numbers using rep \
units (see Exercise ",
 StyleBox["5", "OsF"],
 " in Section ",
 StyleBox["5.6", "OsF"],
 "). For example, multiply any prime repunit by a suitable factor, e.g., \
1540. For details of the relationship between repunits and Smith numbers, see \
",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Hoffman\\!\\(\\*\\nStyleBox[\\\" \\\", \\\"SmallCaps\\\"]\\)\
\\!\\(\\*\\nStyleBox[\\\"(\\\", \\\"SmallCaps\\\"]\\)1999)\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Hoffman\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Paul\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1998\", \"SmallCaps\"]\). \!\(\*\n\
StyleBox[\"The\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Man\",\nFontSlant->\"Italic\"]\)\!\
\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Who\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Loved\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Only\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Numbers\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\":\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"The\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Story\",\nFontSlant->\"Italic\"]\)\
\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"of\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Paul\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Erd\",\nFontSlant->\"Italic\"]\)\!\
\(\*\nStyleBox[\"\[ODoubleDot]\",\nFontFamily->\"DTL Albertina TOT \
Italic\"]\)\!\(\*\nStyleBox[\"s\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\
\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"and\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"the\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Search\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"for\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Mathematical\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Truth\",\nFontSlant->\"Italic\"]\). Hyperion."], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "."
}], "SolutionText",
 CellTags->"5.8 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RepUnit", "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"10", " ", "#"}], "+", "1"}], ")"}], "&"}], ",", "1", ",", 
    RowBox[{"n", "-", "1"}]}], "]"}]}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimeQ", "[", 
  RowBox[{"RepUnit", "[", "19", "]"}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SmithNumberQ", "[", 
  RowBox[{"1540", 
   RowBox[{"RepUnit", "[", "23", "]"}]}], "]"}]], "Input",
 CellTags->"5.8 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["6", "ChapterN"],

Cell[CellGroupData[{

Cell["Procedural programming", "ChapterTitle",
 CellTags->"c:1"],

Cell[CellGroupData[{

Cell["Loops and iteration", "ExerciseSubsection"],

Cell[TextData[{
 "Compare the use of a ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop with using the function ",
 Cell[BoxData[
  ButtonBox["Nest",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Nest"]], "InlineFormula"],
 " (see Section ",
 StyleBox["5.3", "OsF"],
 "). In particular, compute the square root of ",
 StyleBox["2", "OsF"],
 " using ",
 Cell[BoxData[
  ButtonBox["Nest",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Nest"]], "InlineFormula"],
 "."
}], "ExerciseItem",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " is closely related to ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 ", the main difference being that ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " does not return any value, whereas ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " does. Use ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " instead of ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " to rewrite one of the ",
 StyleBox["findRoot", "ExerciseMR"],
 " functions given in this section. Compare the efficiency of the two \
approaches."
}], "ExerciseItem",
 CellTags->{"6.1 Exercises", "Ex.Do and Table", "i:14"}],

Cell[TextData[{
 "Compute Fibonacci numbers iteratively. Fibonacci numbers consist of the \
sequence ",
 StyleBox["1, 1, 2, 3, 5, 8, 13", "OsF"],
 ", \[Ellipsis], where, after the first two ",
 StyleBox["1", "OsF"],
 "s, each Fibonacci number is the sum of the previous two numbers in the \
sequence. You will need to have two variables, say ",
 StyleBox["this", "MR", "ExLink"],
 " and ",
 StyleBox["prev", "MR", "ExLink"],
 ", giving the two most recent Fibonacci numbers, so that after the ",
 StyleBox["i",
  FontSlant->"Italic"],
 "th iteration, ",
 StyleBox["this", "MR", "ExLink"],
 " and ",
 StyleBox["prev", "MR", "ExLink"],
 " have the values ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "i"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", 
    RowBox[{"i", "-", "1"}]], TraditionalForm]]],
 ", respectively."
}], "ExerciseItem",
 CellTags->{"6.1 Exercises", "Ex.Fibonacci", "i:15"}],

Cell[TextData[{
 "One additional improvement can be made to the ",
 StyleBox["findRoot", "MR", "ExLink"],
 " program developed in this section. Notice that the derivative of the \
function ",
 StyleBox["fun", "MR", "ExLink"],
 " is recomputed each time through the loop. This is quite inefficient. \
Rewrite ",
 StyleBox["findRoot", "MR", "ExLink"],
 " so that the derivative is computed only once and that result is used in \
the body of the loop."
}], "ExerciseItem",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 "Another termination criterion for root-finding is to stop when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"|", 
    RowBox[{
     SubscriptBox["x", "i"], "-", 
     SubscriptBox["x", 
      RowBox[{"i", "+", "1"}]]}], "|", 
    RowBox[{"<", "\[Epsilon]"}]}], TraditionalForm]]],
 "\[VeryThinSpace], that is, when two successive estimates are very close. \
The idea is that if you are not getting much improvement, you must be very \
near the root. The difficulty in programming this is that you need to \
remember the ",
 StyleBox["two",
  FontSlant->"Italic"],
 " most recent estimates computed. (It is similar to computing Fibonacci \
numbers iteratively, as in Exercise ",
 StyleBox[
 CounterBox["ExerciseItem", "Ex.Fibonacci"], "OsF"],
 ".) Program ",
 StyleBox["findRoot", "MR", "ExLink"],
 " this way."
}], "ExerciseItem",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "The built-in ",
 Cell[BoxData[
  ButtonBox["FindRoot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FindRoot"]], "InlineFormula"],
 " function is set up so that you can monitor intermediate computations using \
the option ",
 Cell[BoxData[
  ButtonBox["EvaluationMonitor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EvaluationMonitor"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Reap",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Reap"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Sow",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Sow"]], "InlineFormula"],
 ". For example, the following sows the values of ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "(", "x", ")"}], TraditionalForm]]],
 " and when ",
 Cell[BoxData[
  ButtonBox["FindRoot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FindRoot"]], "InlineFormula"],
 " is done, ",
 Cell[BoxData[
  ButtonBox["Reap",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Reap"]], "InlineFormula"],
 " displays the sown expressions."
}], "ExerciseItem",
 CellTags->{"Ex.findRoot", "6.1 Exercises", "i:48"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "2"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Reap", "[", "\[IndentingNewLine]", 
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{"f", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1"}], "}"}], ",", 
    RowBox[{"EvaluationMonitor", "\[RuleDelayed]", 
     RowBox[{"Sow", "[", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"f", "[", "x", "]"}]}], "}"}], "]"}]}]}], "]"}], 
  "\[IndentingNewLine]", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "1.4142135623730951`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1.`", ",", 
        RowBox[{"-", "1.`"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1.5`", ",", "0.25`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1.4166666666666667`", ",", "0.006944444444444642`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"1.4142156862745099`", ",", "6.007304882871267`*^-6"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"1.4142135623746899`", ",", "4.510614104447086`*^-12"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{"1.4142135623730951`", ",", "4.440892098500626`*^-16"}], 
       "}"}]}], "}"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Modify each of the versions of ",
 StyleBox["findRoot", "MR", "ExLink"],
 " presented in the text that uses a ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["While",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/While"]], "InlineFormula"],
 " loop to produce a similar output to that above."
}], "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "To guard against starting with a poor choice of initial value, modify your \
solution to the previous exercise to take, as an argument, a ",
 StyleBox["list",
  FontSlant->"Italic"],
 " of initial values, and simultaneously compute approximations for each \
until one converges; then return that one."
}], "ExerciseItem",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 StyleBox["bisection method", "TermDefinition"],
 " is quite useful for finding roots of functions. If a continuous function \
",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "(", "x", ")"}], TraditionalForm]]],
 " is such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"f", "(", "a", ")"}], "<", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"f", "(", "b", ")"}], ">", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 " for two real numbers ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ", then, as a consequence of the Intermediate Value Theorem of calculus, a \
root of ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 " must occur between ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ". If ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 " is now evaluated at the midpoint of ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ", and if ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"f", "(", 
      RowBox[{"a", "+", "b"}], ")"}], "/", 
     StyleBox["2", "OsF"]}], "<", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", then the root must occur between ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "+", "b"}], ")"}], "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 "; if not, then it occurs between ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "+", "b"}], ")"}], "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 ". This bisection can be repeated until a root is found to a specified \
tolerance."
}], "ExerciseItem",
 CellTags->{"6.1 Exercises", "i:16"}],

Cell[TextData[{
 "Define ",
 Cell[BoxData[
  RowBox[{
   StyleBox["bisect", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["f", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    RowBox[{
     StyleBox["{", "ExLink"], 
     RowBox[{
      StyleBox["x", "ExerciseTI"], 
      StyleBox[",", "ExLink"], 
      StyleBox["a", "ExerciseTI"], 
      StyleBox[",", "ExLink"], 
      StyleBox["b", "ExerciseTI"]}], 
     StyleBox["}", "ExLink"]}], 
    StyleBox[",", "ExLink"], 
    StyleBox["\[Epsilon]",
     FontSize->9.800003051757812,
     FontSlant->"Italic"]}], 
   StyleBox["]", "ExLink"]}]]],
 " to compute a root of ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 ", within \[Epsilon], using the bisection method. You should give it two \
initial values ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 " and assume that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"f", "(", "a", ")"}], "\[CenterDot]", 
     RowBox[{"f", "(", "b", ")"}]}], "<", "0"}], TraditionalForm]]],
 ", that is, ",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "(", "a", ")"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "(", "b", ")"}], TraditionalForm]]],
 " differ in sign."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Using a ",
 Cell[BoxData[
  ButtonBox["While",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/While"]], "InlineFormula"],
 " loop, write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["gcd", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["m", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that computes the greatest common divisor (gcd) of ",
 StyleBox["m",
  FontSlant->"Italic"],
 " and ",
 StyleBox["n",
  FontSlant->"Italic"],
 ". The Euclidean algorithm for computing the gcd of two positive integers ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", sets ",
 Cell[BoxData[
  FormBox[
   RowBox[{"m", "=", "n"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    RowBox[{"m", " ", "mod", " ", "n"}]}], TraditionalForm]]],
 ". It iterates this process until ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", at which point the gcd of ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is left in the value of ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"Ex.GCD", "6.1 Exercises", "i:18"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a procedural definition for each of the following functions. For \
each function, create a definition using a ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop and another using ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 ". "
}], "ExerciseItem",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 "For example, the following function first creates an array consisting of ",
 StyleBox["0", "OsF"],
 "s of the same dimension as ",
 StyleBox["mat", "MR", "ExLink"],
 ". Then inside the ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop it assigns the element in position ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"j", ",", "i"}], "}"}], "ExLink"]]],
 " in ",
 StyleBox["mat", "MR", "ExLink"],
 " to position ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"i", ",", "j"}], "}"}], "ExLink"]]],
 " in ",
 StyleBox["matA", "MR", "ExLink"],
 ", effectively performing a transpose operation. Finally, it returns ",
 StyleBox["matA", "MR", "ExLink"],
 ", since the ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop itself does not return a value."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"transposeDo", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"matA", ",", 
      RowBox[{"rows", "=", 
       RowBox[{"Length", "[", "mat", "]"}]}], ",", 
      RowBox[{"cols", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"mat", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", "i", ",", "j"}], "}"}],
     ",", 
    RowBox[{
     RowBox[{"matA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", 
         RowBox[{"rows", ",", "cols"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"matA", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], "=", 
        RowBox[{"mat", "\[LeftDoubleBracket]", 
         RowBox[{"j", ",", "i"}], "\[RightDoubleBracket]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "rows"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "cols"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "matA"}]}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "h", ",", "i"}], "}"}]}], "}"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", "mat1", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "b", "c"},
     {"d", "e", "f"},
     {"g", "h", "i"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"transposeDo", "[", "mat1", "]"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "d", "g"},
     {"b", "e", "h"},
     {"c", "f", "i"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "This same computation could be performed with a ",
 StyleBox["structured iteration",
  FontSlant->"Italic"],
 " using ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 "."
}], "ExerciseText",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"transposeTable", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"matA", ",", "rows", ",", "cols"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rows", ",", "cols"}], "}"}], "=", 
      RowBox[{"Dimensions", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"matA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", 
         RowBox[{"rows", ",", "cols"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"matA", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], "=", 
        RowBox[{"mat", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "i"}], "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "rows"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "cols"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]",
    "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"transposeTable", "[", "mat1", "]"}], "//", 
  "MatrixForm"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "d", "g"},
     {"b", "e", "h"},
     {"c", "f", "i"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create the function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["reverse", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["vec", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that reverses the elements in the list ",
 StyleBox["vec",
  FontSlant->"Italic"],
 "."
}], "ExerciseSubItem",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["rotateRight", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["vec", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 ", where ",
 Cell[BoxData[
  FormBox[
   StyleBox["vec",
    FontSlant->"Italic"], TraditionalForm]]],
 " is a vector and ",
 StyleBox["n",
  FontSlant->"Italic"],
 " is a (positive or negative) integer."
}], "ExerciseSubItem",
 CellTags->"6.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a procedural implementation of ",
 Cell[BoxData[
  StyleBox["rotateRows", "ExLink"]]],
 ", which could be defined in this functional way:"
}], "ExerciseSubItem",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rotateRows", "[", "mat_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"rotateRight", "[", 
      RowBox[{
       RowBox[{"mat", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
       ",", 
       RowBox[{"#", "-", "1"}]}], "]"}], "&"}], ",", 
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Length", "[", "mat", "]"}]}], "]"}]}], 
   "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 "That is, it rotates the ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "th row of ",
 StyleBox["mat", "MR", "ExLink"],
 " by ",
 Cell[BoxData[
  FormBox[
   RowBox[{"i", "-", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " places to the right."
}], "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a procedural function ",
 Cell[BoxData[
  StyleBox["rotateRowsByS", "ExLink"]]],
 ", which could be defined in this functional way:"
}], "ExerciseSubItem",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"rotateRowsByS", "[", 
    RowBox[{"mat_", ",", "S_"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "mat", "]"}], "==", 
    RowBox[{"Length", "[", "S", "]"}]}]}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rotateRight", "[", 
       RowBox[{
        RowBox[{
        "mat", "\[LeftDoubleBracket]", "#1", "\[RightDoubleBracket]"}], ",", 
        RowBox[{
        "S", "\[LeftDoubleBracket]", "#1", "\[RightDoubleBracket]"}]}], "]"}],
       "&"}], ")"}], ",", 
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Length", "[", "mat", "]"}]}], "]"}]}], 
   "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.1 Exercises"],

Cell[TextData[{
 "That is, it rotates the ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "th row of ",
 StyleBox["matA", "MR", "ExLink"],
 " by the amount ",
 Cell[BoxData[
  RowBox[{
   StyleBox["S", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["[", "ExerciseMR"], 
    StyleBox["i", "ExerciseTI"], 
    StyleBox["]", "ExerciseMR"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 "."
}], "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["pick", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    SubscriptBox[
     StyleBox["lis", "ExerciseTI"], 
     StyleBox["a", "ExerciseTI",
      FontSize->9]], 
    StyleBox[",", "ExLink"], 
    SubscriptBox[
     StyleBox["lis", "ExerciseTI"], 
     StyleBox["b", "ExerciseTI",
      FontSize->9]]}], 
   StyleBox["]", "ExLink"]}]]],
 ", where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["lis",
     FontSlant->"Italic"], 
    StyleBox["a",
     FontFamily->"DTL Albertina TOT Italic",
     FontSize->8,
     FontSlant->"Plain"]], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["lis",
     FontSlant->"Italic"], 
    StyleBox["b",
     FontFamily->"DTL Albertina TOT Italic",
     FontSize->8,
     FontSlant->"Plain"]], TraditionalForm]]],
 " are lists of equal length, and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["lis",
     FontSlant->"Italic"], 
    StyleBox["b",
     FontFamily->"DTL Albertina TOT Italic",
     FontSize->8,
     FontSlant->"Plain"]], TraditionalForm]]],
 " contains only Boolean values (",
 Cell[BoxData[
  StyleBox["False", "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox["True", "ExLink"]]],
 "). This function selects those elements from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["lis",
     FontSlant->"Italic"], 
    StyleBox["a",
     FontFamily->"DTL Albertina TOT Italic",
     FontSize->8,
     FontSlant->"Plain"]], TraditionalForm]]],
 " corresponding to ",
 Cell[BoxData[
  StyleBox["True", "ExLink"]]],
 " in ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["lis",
     FontSlant->"Italic"], 
    StyleBox["b",
     FontFamily->"DTL Albertina TOT Italic",
     FontSize->8,
     FontSlant->"Plain"]], TraditionalForm]]],
 ". For example, the result of the following should be ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "e"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseSubItem",
 CellTags->"6.1 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"pick", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "False", ",", "False", ",", "True"}], 
      "}"}]}], "]"}], "ExLink"], " "}]], "ExerciseInput",
 Evaluatable->False,
 CellTags->"6.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "To compute the square root of a number ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 ", iterate the following expression."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fun", "[", "x_", "]"}], ":=", 
   RowBox[{
    SuperscriptBox["x", "2"], "-", "r"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"x", "-", 
   FractionBox[
    RowBox[{"fun", "[", "x", "]"}], 
    RowBox[{
     RowBox[{"fun", "'"}], "[", "x", "]"}]]}], "]"}]}], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 FractionBox[
  RowBox[{"r", "+", 
   SuperscriptBox["x", "2"]}], 
  RowBox[{"2", " ", "x"}]]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "This can be written as a pure function, with a second argument giving the \
initial guess. Here we iterate ten times, starting with a high-precision \
initial value, ",
 StyleBox["2.0", "OsF"],
 " to ",
 StyleBox["30", "OsF"],
 "-digit precision."
}], "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nestSqrt", "[", 
   RowBox[{"r_", ",", "init_"}], "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"r", "+", 
       SuperscriptBox["#", "2"]}], 
      RowBox[{"2", "#"}]], "&"}], ",", "init", ",", "10"}], 
   "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nestSqrt", "[", 
  RowBox[{"2", ",", 
   RowBox[{"N", "[", 
    RowBox[{"2", ",", "30"}], "]"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData["1.4142135623730950488016887242096980785696718753769480731765`26.\
909787624896055"], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is a first basic attempt to replace the ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop with ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "2"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", "2"}], ";"}], "\n", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"a", "=", 
    RowBox[{"N", "[", 
     RowBox[{"a", "-", 
      FractionBox[
       RowBox[{"f", "[", "a", "]"}], 
       RowBox[{
        SuperscriptBox["f", "\[Prime]",
         MultilineFunction->None], "[", "a", "]"}]]}], "]"}]}], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]}], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.5`", ",", "1.4166666666666667`", ",", "1.4142156862745099`", ",", 
   "1.4142135623746899`", ",", "1.4142135623730951`", ",", 
   "1.414213562373095`", ",", "1.4142135623730951`", ",", 
   "1.414213562373095`", ",", "1.4142135623730951`", ",", 
   "1.414213562373095`"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRoot", "[", 
   RowBox[{"fun_Symbol", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "init_"}], "}"}], ",", 
    RowBox[{"iter_", ":", "10"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xi", "=", "init"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"xi", "=", 
        RowBox[{"N", "[", 
         RowBox[{"xi", "-", 
          FractionBox[
           RowBox[{"fun", "[", "xi", "]"}], 
           RowBox[{
            SuperscriptBox["fun", "\[Prime]",
             MultilineFunction->None], "[", "xi", "]"}]]}], "]"}]}], ",", 
       RowBox[{"{", "iter", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"var", "\[Rule]", "xi"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "1.414213562373095`"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell["This runs the iteration only three times.", "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "2"}], "}"}], ",", "3"}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "1.4142156862745099`"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Note that this version of the Fibonacci function is much more efficient \
than the simple recursive version given in ",
 "Chapter",
 " ",
 StyleBox["7", "OsF"],
 ", and is closer to the version there that uses dynamic programming."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fib", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"prev", "=", "0"}], ",", 
      RowBox[{"this", "=", "1"}], ",", "next"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"next", "=", 
         RowBox[{"prev", "+", "this"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"prev", "=", "this"}], ";", "\[IndentingNewLine]", 
        RowBox[{"this", "=", "next"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", "n", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "prev"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"fib", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell["\<\
Actually, this code can be simplified a bit by using parallel assignments.\
\>", "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fib2", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"f1", "=", "0"}], ",", 
      RowBox[{"f2", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"f1", ",", "f2"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{"f2", ",", 
          RowBox[{"f1", "+", "f2"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"n", "-", "1"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "f2"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"fib2", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell["\<\
Both of these implementations are quite fast and avoid the deep recursion of \
the classical definition. \
\>", "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Timing", "[", 
    RowBox[{
     RowBox[{"fib", "[", "100000", "]"}], ";"}], "]"}], ",", 
   RowBox[{"Timing", "[", 
    RowBox[{
     RowBox[{"fib2", "[", "100000", "]"}], ";"}], "]"}]}], "}"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.22523000000001048`", ",", "Null"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.18366499999999064`", ",", "Null"}], "}"}]}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We compute the derivative ",
 Cell[BoxData["df"]],
 " inside the ",
 Cell[BoxData[
  ButtonBox["Module",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Module"]], "InlineFormula"],
 " and then use that throughout the body of the function."
}], "SolutionItem",
 CellTags->{"6.1 Solutions", "Sol.findRoot"}],

Cell[BoxData[
 RowBox[{"Clear", "[", "findRoot", "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRoot", "[", 
   RowBox[{"fun_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "init_"}], "}"}], ",", "\[Epsilon]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xi", "=", "init"}], ",", 
      RowBox[{"funxi", "=", 
       RowBox[{"fun", "[", "init", "]"}]}], ",", 
      RowBox[{"df", "=", 
       RowBox[{"fun", "'"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", "funxi", "]"}], ">", "\[Epsilon]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"xi", "=", 
         RowBox[{"N", "[", 
          RowBox[{"xi", "-", 
           FractionBox["funxi", 
            RowBox[{"df", "[", "xi", "]"}]]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"funxi", "=", 
         RowBox[{"fun", "[", "xi", "]"}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"var", "\[Rule]", "xi"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"x", "^", "2"}], "-", "2"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "10"}], "}"}], ",", "0.0001"}], "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The variable ",
 Cell[BoxData["b"]],
 " is the current approximation, and the variable ",
 Cell[BoxData["a"]],
 " is the previous approximation."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRoot", "[", 
   RowBox[{"fun_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "init_"}], "}"}], ",", "\[Epsilon]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "=", "init"}], ",", 
      RowBox[{"b", "=", 
       RowBox[{"fun", "[", "init", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"b", "-", "a"}], "]"}], ">", "\[Epsilon]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "=", "b"}], ";", "\[IndentingNewLine]", 
        RowBox[{"b", "=", 
         RowBox[{"N", "[", 
          RowBox[{"b", "-", 
           FractionBox[
            RowBox[{"fun", "[", "b", "]"}], 
            RowBox[{
             SuperscriptBox["fun", "\[Prime]",
              MultilineFunction->None], "[", "b", "]"}]]}], "]"}]}]}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"var", "\[Rule]", "b"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "50"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "10"}], "}"}], ",", "0.0001"}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "7.071067811865477`"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This solution is based on the solution to Exercise ",
 StyleBox[
 CounterBox["SolutionItem", "Sol.findRoot"], "OsF"],
 " above."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRootList", "[", 
   RowBox[{"fun_", ",", "init_", ",", "\[Epsilon]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "=", "init"}], ",", "b", ",", 
      RowBox[{"solns", "=", 
       RowBox[{"{", "init", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"b", "=", 
      RowBox[{"N", "[", 
       RowBox[{"a", "-", 
        FractionBox[
         RowBox[{"fun", "[", "a", "]"}], 
         RowBox[{
          SuperscriptBox["fun", "\[Prime]",
           MultilineFunction->None], "[", "a", "]"}]]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"b", "-", "a"}], "]"}], ">", "\[Epsilon]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "=", "b"}], ";", "\[IndentingNewLine]", 
        RowBox[{"b", "=", 
         RowBox[{"b", "-", 
          FractionBox[
           RowBox[{"fun", "[", "b", "]"}], 
           RowBox[{
            SuperscriptBox["fun", "\[Prime]",
             MultilineFunction->None], "[", "b", "]"}]]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"solns", ",", "b"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "solns"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "2"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"findRootList", "[", 
  RowBox[{"f", ",", "1", ",", 
   SuperscriptBox["10", 
    RowBox[{"-", "6"}]]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[TextData[{
 "There is a numerical issue here that may not be apparent at first. If you \
were to provide a value for \[Epsilon] that is smaller than ",
 Cell[BoxData[
  RowBox[{"1", "/", "MachinePrecision"}]]],
 ", this function will have trouble satisfying the test. In fact, this is \
true for all of the implementations of Newton\[CloseCurlyQuote]s method in \
this chapter. These issues are explored and resolved in ",
 "Section",
 " ",
 StyleBox["8.4", "OsF"],
 "."
}], "SolutionText",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Based on a previous version of ",
 Cell[BoxData["findRoot"]],
 ", the following adds multiple initial values."
}], "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRootList", "[", 
   RowBox[{"fun_", ",", "inits_List", ",", "\[Epsilon]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", "=", "inits"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"Abs", "[", 
          RowBox[{"Map", "[", 
           RowBox[{"fun", ",", "a"}], "]"}], "]"}], "]"}], ">", 
        "\[Epsilon]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"a", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"N", "[", 
            RowBox[{"#", "-", 
             FractionBox[
              RowBox[{"fun", "[", "#", "]"}], 
              RowBox[{
               SuperscriptBox["fun", "\[Prime]",
                MultilineFunction->None], "[", "#", "]"}]]}], "]"}], "&"}], 
          ",", "a"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{"a", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Min", "[", 
          RowBox[{"Abs", "[", 
           RowBox[{"Map", "[", 
            RowBox[{"fun", ",", "a"}], "]"}], "]"}], "]"}], "==", 
         RowBox[{"Abs", "[", 
          RowBox[{"fun", "[", "#", "]"}], "]"}]}], "&"}]}], "]"}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRootList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["#", "2"], "-", "50"}], ")"}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "10"}], ",", "1", ",", "10"}], "}"}], ",", ".001"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "7.071078431372549`"}], ",", "7.071078431372549`"}], 
  "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
A bit of variable swapping is needed here depending on whether or not a sign \
change occurs.\
\>", "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bisect", "[", 
   RowBox[{"f_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", "a_", ",", "b_"}], "}"}], ",", "\[Epsilon]_"}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"midpt", "=", 
       RowBox[{"N", "[", 
        FractionBox[
         RowBox[{"a", "+", "b"}], "2"], "]"}]}], ",", 
      RowBox[{"low", "=", "a"}], ",", 
      RowBox[{"high", "=", "b"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"f", "[", "midpt", "]"}], "]"}], ">", "\[Epsilon]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Sign", "[", 
            RowBox[{"f", "[", "low", "]"}], "]"}], "\[Equal]", 
           RowBox[{"Sign", "[", 
            RowBox[{"f", "[", "midpt", "]"}], "]"}]}], ",", 
          RowBox[{"low", "=", "midpt"}], ",", 
          RowBox[{"high", "=", "midpt"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"midpt", "=", 
         FractionBox[
          RowBox[{"low", "+", "high"}], "2"]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"var", "\[Rule]", "midpt"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "2"}]}], "\[IndentingNewLine]", 
 RowBox[{"bisect", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", ".0001"}], "]"}]}], "Input",\

 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "1.4141845703125`"}], "}"}]], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["This is a direct implementation of the Euclidean algorithm. ", \
"SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcd", "[", 
   RowBox[{"m_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "=", "m"}], ",", 
      RowBox[{"b", "=", "n"}], ",", "tmpa"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"b", ">", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"tmpa", "=", "a"}], ";", "\[IndentingNewLine]", 
        RowBox[{"a", "=", "b"}], ";", "\[IndentingNewLine]", 
        RowBox[{"b", "=", 
         RowBox[{"Mod", "[", 
          RowBox[{"tmpa", ",", "b"}], "]"}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "a"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "=", "12782"}], ",", 
     RowBox[{"n", "=", "5531207"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"gcd", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData["11"], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "You can avoid the need for the temporary variable ",
 Cell[BoxData["tmpa"]],
 " by performing a parallel assignment as in the following function. In \
addition, some argument checking insures that ",
 StyleBox["m",
  FontSlant->"Italic"],
 " and ",
 StyleBox["n",
  FontSlant->"Italic"],
 " are integers."
}], "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcd", "[", 
   RowBox[{"m_Integer", ",", "n_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "=", "m"}], ",", 
      RowBox[{"b", "=", "n"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"b", ">", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{"b", ",", 
          RowBox[{"Mod", "[", 
           RowBox[{"a", ",", "b"}], "]"}]}], "}"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "a"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "=", "12782"}], ",", 
     RowBox[{"n", "=", "5531207"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"gcd", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData["11"], "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Each solution mirrors that of the transpose example in the exercise.\
\>", "SolutionItem",
 CellTags->"6.1 Solutions"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a list ",
 Cell[BoxData["vecA"]],
 " of zeros, then use a ",
 Cell[BoxData[
  ButtonBox["Do",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Do"]], "InlineFormula"],
 " loop to set ",
 Cell[BoxData[
  RowBox[{"vecA", "\[LeftDoubleBracket]", 
   StyleBox["i", "ExerciseTI"], "\[RightDoubleBracket]"}]]],
 " to ",
 Cell[BoxData[
  RowBox[{"vec", "\[LeftDoubleBracket]", 
   StyleBox[
    RowBox[{"n", "-", "i"}], "ExerciseTI"], "\[RightDoubleBracket]"}]]],
 ", where ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is the length of ",
 Cell[BoxData["vec"]],
 "."
}], "SolutionSubItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"reverse", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"reverse", "[", "vec_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vecA", ",", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "vec", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vecA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "n", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
        "vecA", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "=", 
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"n", "-", "i", "+", "1"}], "\[RightDoubleBracket]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "vecA"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"reverse", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"reverseStruc", "[", "vec_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vecA", ",", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "vec", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vecA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "n", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"vecA", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "=", 
        RowBox[{"vec", "[", 
         RowBox[{"[", 
          RowBox[{"n", "-", "i", "+", "1"}], "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"reverseStruc", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The key to this problem is to use the ",
 Cell[BoxData[
  ButtonBox["Mod",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Mod"]], "InlineFormula"],
 " operator to compute the target address for any item from ",
 Cell[BoxData["vec"]],
 ". That is, the element ",
 Cell[BoxData[
  RowBox[{"vec", "[", "i", "]"}]]],
 " must move to, roughly speaking, position ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "+", "i"}], TraditionalForm]]],
 " mod ",
 Cell[BoxData[
  RowBox[{"Length", "[", "vec", "]"}]]],
 ". The \[OpenCurlyDoubleQuote]roughly speaking\[CloseCurlyDoubleQuote] is \
due to the fact that the ",
 Cell[BoxData[
  ButtonBox["Mod",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Mod"]], "InlineFormula"],
 " operator returns values in the range ",
 StyleBox["0", "OsF"],
 " to ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"Length", "[", "vec", "]"}], "-", "1"}]]],
 ", whereas vectors are indexed by values ",
 StyleBox["1", "OsF"],
 " up to ",
 Cell[BoxData[
  RowBox[{"Length", "[", "vec", "]"}]]],
 ".",
 " ",
 "This causes a little trickiness in this problem."
}], "SolutionSubItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rotateRight", "[", 
   RowBox[{"vec_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vecA", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "vec", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vecA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "len", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"vecA", "\[LeftDoubleBracket]", 
         RowBox[{"1", "+", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"n", "+", "i", "-", "1"}], ",", "len"}], "]"}]}], 
         "\[RightDoubleBracket]"}], "=", 
        RowBox[{
        "vec", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], ",", 
       
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "len"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "vecA"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"rotateRight", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", "2"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rotateRightStruc", "[", 
   RowBox[{"vec_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vecA", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "vec", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vecA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "len", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"vecA", "\[LeftDoubleBracket]", 
         RowBox[{"1", "+", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"n", "+", "i", "-", "1"}], ",", "len"}], "]"}]}], 
         "\[RightDoubleBracket]"}], "=", 
        RowBox[{
        "vec", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], ",", 
       
       RowBox[{"{", 
        RowBox[{"i", ",", "len"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]",
      "vecA"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"rotateRightStruc", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", "3"}], 
  "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Iterate over the rows of ",
 Cell[BoxData["mat"]],
 ", setting row ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " to the result of calling ",
 Cell[BoxData["rotateRight"]],
 "."
}], "SolutionSubItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rotateRows", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"matA", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "mat", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"matA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "len", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
        "matA", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "=", 
        RowBox[{"rotateRight", "[", 
         RowBox[{
          RowBox[{
          "mat", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], ",", 
          "i"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "len"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "matA"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"rotateRows", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "h", ",", "k"}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Similar construction to the previous exercise.", "SolutionSubItem",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rotateRowsByS", "[", 
   RowBox[{"mat_", ",", "S_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"matA", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "mat", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"matA", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "len", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
        "matA", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "=", 
        RowBox[{"rotateRight", "[", 
         RowBox[{
          RowBox[{
          "mat", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], ",", 
          
          RowBox[{
          "S", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "len"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "matA"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"rotateRowsByS", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "e", ",", "f"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "h", ",", "k"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a list ",
 Cell[BoxData["lisC"]],
 " of correct length, then iterate over ",
 Cell[BoxData["lisA"]],
 " and ",
 Cell[BoxData["lisB"]],
 ", moving ",
 Cell[BoxData[
  RowBox[{"lisA", "\[LeftDoubleBracket]", 
   StyleBox["i", "ExerciseTI"], "\[RightDoubleBracket]"}]]],
 " to ",
 Cell[BoxData["lisC"]],
 " whenever ",
 Cell[BoxData[
  RowBox[{"lisB", "\[LeftDoubleBracket]", 
   StyleBox["i", "ExerciseTI"], "\[RightDoubleBracket]"}]]],
 " is ",
 Cell[BoxData["True"]],
 ". The position in ",
 Cell[BoxData["lisC"]],
 " that receives this value is not necessarily ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "; we use the variable ",
 Cell[BoxData["last"]],
 " to keep track of the next position in ",
 Cell[BoxData["lisC"]],
 " that will receive a value from ",
 Cell[BoxData["lisA"]],
 "."
}], "SolutionSubItem",
 CounterAssignments->{{"SolutionItem", 1}},
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pick", "[", 
   RowBox[{"lisA_", ",", "lisB_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"lisC", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"Count", "[", 
           RowBox[{"lisB", ",", "True"}], "]"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"last", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
         "lisB", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "lisC", "\[LeftDoubleBracket]", "last", "\[RightDoubleBracket]"}], 
           "=", 
           RowBox[{
           "lisA", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], 
          ";", 
          RowBox[{"last", "=", 
           RowBox[{"last", "+", "1"}]}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "lisB", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "lisC"}]}], "]"}]}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"pick", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False", ",", "False", ",", "True"}], 
    "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"],

Cell[TextData[{
 "This is doing the same computation as the built-in ",
 Cell[BoxData[
  ButtonBox["Pick",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Pick"]], "InlineFormula"],
 " function."
}], "SolutionText",
 CellTags->"6.1 Solutions"],

Cell[BoxData[
 RowBox[{"Pick", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False", ",", "False", ",", "True"}], 
    "}"}]}], "]"}]], "Input",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Flow control", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["UpperTriangularMatrix", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["{", "ExLink"], 
    RowBox[{
     StyleBox["m", "ExerciseTI"], 
     StyleBox[",", "ExLink"], 
     StyleBox["n", "ExerciseTI"]}], 
    StyleBox["}", "ExLink"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that generates an ",
 Cell[BoxData[
  FormBox[
   RowBox[{"m", "\[Cross]", "n"}], TraditionalForm]]],
 " upper triangular matrix, that is, a matrix containing ",
 StyleBox["1", "OsF"],
 "s on and above the diagonal and ",
 StyleBox["0", "OsF"],
 "s below the diagonal. Create an alternative rule that defaults to ",
 StyleBox["1", "OsF"],
 " for the upper values, but allows the user to specify a nondefault upper \
value."
}], "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:32"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UpperTriangularMatrix", "[", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], "]"}], "//", 
  "MatrixForm"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.2 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1"},
     {"0", "1", "1"},
     {"0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UpperTriangularMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "4"}], "}"}], ",", "\[Zeta]"}], "]"}], "//", 
  "MatrixForm"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.2 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Zeta]", "\[Zeta]", "\[Zeta]", "\[Zeta]"},
     {"0", "\[Zeta]", "\[Zeta]", "\[Zeta]"},
     {"0", "0", "\[Zeta]", "\[Zeta]"},
     {"0", "0", "0", "\[Zeta]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["signum", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["x", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " which, when applied to an integer ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 ", returns ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"-", "1"}], "OsF"], TraditionalForm]]],
 ", ",
 StyleBox["0", "OsF"],
 ", or ",
 StyleBox["1", "OsF"],
 ", if ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " is less than, equal to, or greater than ",
 StyleBox["0", "OsF"],
 ", respectively. Write it in four ways: using three clauses, using a single \
clause with ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]]],
 ", using a single clause with ",
 Cell[BoxData[
  ButtonBox["Which",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Which"]]],
 ", and using ",
 Cell[BoxData[
  ButtonBox["Piecewise",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Piecewise"]], "InlineFormula"],
 "."
}], "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:31"}],

Cell[CellGroupData[{

Cell["\<\
The definition of the absolute value function in this section does not handle \
complex numbers properly. \
\>", "ExerciseItem",
 CellTags->{"6.2 Exercises", "Ex.Absolute value"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"3", "+", 
   RowBox[{"4", "I"}]}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"6.2 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"GreaterEqual", "::", "nord"}], "MessageName"], ":", 
  " ", "\<\"Invalid comparison with \[NoBreak]\\!\\(3 + \\(\\(4\\\\ \
\[ImaginaryI]\\)\\)\\)\[NoBreak] attempted. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/nord\\\", ButtonNote -> \
\\\"GreaterEqual::nord\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"6.2 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Less", "::", "nord"}], "MessageName"], ":", 
  " ", "\<\"Invalid comparison with \[NoBreak]\\!\\(3 + \\(\\(4\\\\ \
\[ImaginaryI]\\)\\)\\)\[NoBreak] attempted. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/nord\\\", ButtonNote -> \
\\\"Less::nord\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"6.2 Exercises"],

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"3", " ", "+", " ", 
   RowBox[{"4", " ", "I"}]}], "]"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Correct this problem by rewriting ",
 Cell[BoxData[
  StyleBox["abs", "ExerciseMR"]]],
 " to include a specific rule for the case where its argument is complex."
}], "ExerciseText",
 CellTags->"6.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]]],
 " in conjunction with ",
 Cell[BoxData[
  ButtonBox["Map",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Map"]]],
 " or ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]]],
 " to define the following functions:"
}], "ExerciseItem",
 CellTags->"6.2 Exercises"],

Cell["\<\
In a list of numbers, double all the positive numbers, but leave the negative \
numbers alone.\
\>", "ExerciseSubItem",
 CellTags->"6.2 Exercises"],

Cell[TextData[{
 StyleBox["remove3Repetitions", "ExerciseMR"],
 " alters three or more consecutive occurrences in a list, changing them to \
two occurrences; if there are only two occurrences to begin with, they are \
left alone. For example, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"remove3Repetitions", "[", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2", ",", "1"}], "}"}],
     "]"}], "ExerciseMR"]]],
 " will return ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "2", ",", "2", ",", "1"}], "}"}], 
   "ExerciseMR"]]],
 "."
}], "ExerciseSubItem",
 CellTags->"6.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Add the elements of a list in consecutive order, but never let the sum go \
below ",
 StyleBox["0", "OsF"],
 "."
}], "ExerciseSubItem",
 CellTags->"6.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"positiveSum", "[", 
  RowBox[{"{", 
   RowBox[{"5", ",", "3", ",", 
    RowBox[{"-", "13"}], ",", "7", ",", 
    RowBox[{"-", "3"}], ",", "2"}], "}"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"6.2 Exercises"],

Cell[BoxData["6"], "ExerciseOutput", "ExerciseMR",
 CellTags->"6.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Since the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Dash]", "13"}], TraditionalForm]], "OsF"],
 " caused the sum to go below ",
 StyleBox["0", "OsF"],
 ", it was instead put back to ",
 StyleBox["0", "OsF"],
 " and the summation continued from there."
}], "ExerciseText",
 CellTags->"6.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Rewrite the ",
 StyleBox["median", "ExerciseMR"],
 " function from Exercise ",
 StyleBox["4", "OsF"],
 " in Section ",
 StyleBox["5.8", "OsF"],
 " using an ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 " control structure."
}], "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:51"}],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["NestWhileList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestWhileList"]]],
 ", write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["CollatzSequence", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that produces the Collatz sequence for any positive integer ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ". The Collatz sequence is generated as follows: starting with a number ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", if it is even, then output ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 "; if ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is odd, then output ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     StyleBox["3", "OsF"], "n"}], "+", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 ". Iterate this process while ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "\[NotEqual]", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 "."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->{"6.2 Exercises", "Ex.Collatz", "i:33"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "If, for element ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", 
    RowBox[{"i", "\[VeryThinSpace]", "j"}]], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " is bigger than ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 ", then we are below the diagonal and should insert a ",
 StyleBox["0", "OsF"],
 ", otherwise insert a ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UpperTriangularMatrix", "[", 
   RowBox[{"{", 
    RowBox[{"m_", ",", "n_"}], "}"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"i", "\[GreaterEqual]", "j"}], ",", "0", ",", "1"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "m"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell["\<\
A default value can be given for an optional argument that specifies the \
elements above the diagonal. \
\>", "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UpperTriangularMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m_", ",", "n_"}], "}"}], ",", 
    RowBox[{"val_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"i", "\[GreaterEqual]", "j"}], ",", "0", ",", "val"}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "m"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UpperTriangularMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"5", ",", "5"}], "}"}], ",", "\[Alpha]"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "\[Alpha]", "\[Alpha]", "\[Alpha]", "\[Alpha]"},
     {"0", "0", "\[Alpha]", "\[Alpha]", "\[Alpha]"},
     {"0", "0", "0", "\[Alpha]", "\[Alpha]"},
     {"0", "0", "0", "0", "\[Alpha]"},
     {"0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here are the conditional definitions.", "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"signum", "[", 
   RowBox[{"x_", "/;", 
    RowBox[{"x", "<", "0"}]}], "]"}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{"signum", "[", 
   RowBox[{"x_", "/;", 
    RowBox[{"x", ">", "0"}]}], "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"signum", "[", "0", "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"signum", "[", "0.0", "]"}], ":=", "0"}]}], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"signum", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[TextData[{
 "Here is the signum function defined using ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"signumIf", "[", "x_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"x", "<", "0"}], ",", 
    RowBox[{"-", "1"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"x", "==", "0"}], ",", "0", ",", "1"}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"signumIf", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[TextData[{
 "Here is the signum function defined using ",
 Cell[BoxData[
  ButtonBox["Which",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Which"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"signumWhich", "[", "x_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"x", "<", "0"}], ",", 
    RowBox[{"-", "1"}], ",", 
    RowBox[{"x", ">", "0"}], ",", "1", ",", "True", ",", "0"}], 
   "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"signumWhich", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[TextData[{
 "Finally, here is the signum function defined using ",
 Cell[BoxData[
  ButtonBox["Piecewise",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Piecewise"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"Piecewise", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"x", "<", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"x", ">", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"x", "==", "0"}]}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The test as the first argument of ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 " on the right-hand side checks to see if ",
 StyleBox["x",
  FontSlant->"Italic"],
 " is an element of the domain of complex numbers and, if it is, then ",
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"re", "(", "x", ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"im", "(", "x", ")"}], "2"]}]], TraditionalForm]]],
 " is computed. If ",
 StyleBox["x",
  FontSlant->"Italic"],
 " is not complex, nothing is done, but then the other definitions for ",
 Cell[BoxData["abs"]],
 " will be checked."
}], "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "abs", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"abs", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Re", "[", "x", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Im", "[", "x", "]"}], "2"]}], "]"}], "/;", 
    RowBox[{"x", "\[Element]", "Complexes"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"abs", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "/;", 
   RowBox[{"x", "\[GreaterEqual]", "0"}]}]}], "\n", 
 RowBox[{
  RowBox[{"abs", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "x"}], "/;", 
   RowBox[{"x", "<", "0"}]}]}]}], "InputOnly",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"3", "+", 
   RowBox[{"4", "I"}]}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData["5"], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"-", "3"}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "The condition itself can appear on the left-hand side of the function \
definition, as part of the pattern match. Here is a slight variation on the \
",
 Cell[BoxData["abs"]],
 " definition."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[{
 RowBox[{"Clear", "[", "abs", "]"}], "\n", 
 RowBox[{
  RowBox[{"abs", "[", "x_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"x", "\[GreaterEqual]", "0"}], ",", "x", ",", 
    RowBox[{"-", "x"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"abs", "[", 
   RowBox[{"x_", "/;", 
    RowBox[{"x", "\[Element]", "Complexes"}]}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"Re", "[", "x", "]"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"Im", "[", "x", "]"}], "2"]}], "]"}]}]}], "InputOnly",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"3", "+", 
   RowBox[{"4", "I"}]}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData["5"], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "[", 
  RowBox[{"-", "3"}], "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["",
 FontSlant->"Italic"]], "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell["\<\
The pure function doubles its argument if it is greater than zero.\
\>", "SolutionSubItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"doublePos", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"#", ">", "0"}], ",", 
       RowBox[{"2", " ", "#"}], ",", "#"}], "]"}], "&"}], ",", "lis"}], 
   "]"}]}]], "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["", "SolutionSubItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"remove3Repetitions", "[", "lis_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "#1", "]"}], ">", "2"}], "&&", 
        RowBox[{"#2", "==", 
         RowBox[{"#1", "\[LeftDoubleBracket]", 
          RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "==", 
         RowBox[{"#1", "\[LeftDoubleBracket]", 
          RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], ",", "#1", ",", 
       RowBox[{"Join", "[", 
        RowBox[{"#1", ",", 
         RowBox[{"{", "#2", "}"}]}], "]"}]}], "]"}], "&"}], ",", 
    RowBox[{"{", "}"}], ",", "lis"}], "]"}]}]], "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["", "SolutionSubItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"positiveSum", "[", "L_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "+", "#2"}], "<", "0"}], ",", "0", ",", 
       RowBox[{"#1", "+", "#2"}]}], "]"}], "&"}], ",", "0", ",", "L"}], 
   "]"}]}]], "Input",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a straightforward conversion from the two rules given in Exercise \
",
 StyleBox["4", "OsF"],
 " in Section ",
 StyleBox["5.8", "OsF"],
 " to an ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 " statement."
}], "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"medianP", "[", 
   RowBox[{"lis", ":", 
    RowBox[{"{", "__", "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{"Length", "[", "lis", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"OddQ", "[", "len", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Part", "[", 
       RowBox[{
        RowBox[{"Sort", "[", "lis", "]"}], ",", 
        RowBox[{"Ceiling", "[", 
         RowBox[{"len", "/", "2"}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Mean", "@", 
       RowBox[{"Part", "[", 
        RowBox[{
         RowBox[{"Sort", "[", "lis", "]"}], ",", 
         RowBox[{
          RowBox[{"len", "/", "2"}], ";;", 
          RowBox[{
           RowBox[{"len", "/", "2"}], "+", "1"}]}]}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dataO", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"10000", ",", "100001"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dataE", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"10000", ",", "100000"}], "]"}]}], ";"}]}], "Input",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"medianP", "[", "dataO", "]"}], "//", "Timing"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019350000000002865`", ",", "5005"}], "}"}]], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Median", "[", "dataO", "]"}], "//", "Timing"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.018673000000006823`", ",", "5005"}], "}"}]], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"medianP", "[", "dataE", "]"}], "//", "Timing"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019162000000022772`", ",", 
   FractionBox["10019", "2"]}], "}"}]], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Median", "[", "dataE", "]"}], "//", "Timing"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019867000000004964`", ",", 
   FractionBox["10019", "2"]}], "}"}]], "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
First, define the auxiliary function using conditional statements.\
\>", "SolutionItem",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", "n_", "]"}], ":=", 
  RowBox[{
   FractionBox["n", "2"], "/;", 
   RowBox[{"EvenQ", "[", "n", "]"}]}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"3", "n"}], "+", "1"}], "/;", 
   RowBox[{"OddQ", "[", "n", "]"}]}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[TextData[{
 "Alternatively, use ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"EvenQ", "[", "n", "]"}], ",", 
    RowBox[{"n", "/", "2"}], ",", 
    RowBox[{
     RowBox[{"3", "n"}], "+", "1"}]}], "]"}]}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[TextData[{
 "Then iterate ",
 Cell[BoxData["Collatz"]],
 ", starting with ",
 Cell[BoxData["n"]],
 ", and continue while ",
 Cell[BoxData["n"]],
 " is not equal to ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CollatzSequence", "[", "n_", "]"}], ":=", 
  RowBox[{"NestWhileList", "[", 
   RowBox[{"collatz", ",", "n", ",", 
    RowBox[{
     RowBox[{"#", "\[NotEqual]", "1"}], "&"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", "17", "]"}]], "Input",
 CellTags->"6.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "17", ",", "52", ",", "26", ",", "13", ",", "40", ",", "20", ",", "10", ",",
    "5", ",", "16", ",", "8", ",", "4", ",", "2", ",", "1"}], "}"}]], "Output",\

 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[TextData[{
 "Using an ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]]],
 " function, write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["gcd", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["m", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that implements the Euclidean algorithm (see Exercise ",
 StyleBox[
 CounterBox["ExerciseItem", "Ex.GCD"], "OsF"],
 " of Section ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Ex.GCD"], "OsF"],
 ") for finding the greatest common divisor of ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"6.3 Exercises", "i:43"}],

Cell[TextData[{
 "The ",
 StyleBox["digit sum",
  FontSlant->"Italic"],
 " of a number is given by adding the digits of that number. For example, the \
digit sum of ",
 StyleBox["7763", "OsF"],
 " is ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"7", "+", "7", "+", "6", "+", "3"}], "=", "23"}], "OsF"], 
   TraditionalForm]]],
 ". If you iterate the digit sum until the resulting number has only one \
digit, this is called the ",
 StyleBox["digit root",
  FontSlant->"Italic"],
 " of the original number. So the digit root of ",
 StyleBox["7763", "OsF"],
 " is ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"7763", "\[Rule]", 
      RowBox[{"7", "+", "7", "+", "6", "+", "3"}]}], "=", 
     RowBox[{
      RowBox[{"23", "\[Rule]", 
       RowBox[{"2", "+", "3"}]}], "=", "5."}]}], "OsF"], TraditionalForm]]],
 " Create a function to compute the digit root of any positive integer."
}], "ExerciseItem",
 CellTags->{"i:46", "6.3 Exercises"}],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["Piecewise",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Piecewise"]]],
 " to define the ",
 StyleBox["quadrant", "MR", "ExLink"],
 " function given in this section."
}], "ExerciseItem",
 CellTags->"6.3 Exercises"],

Cell[TextData[{
 "In the version of ",
 Cell[BoxData[
  StyleBox["quadrant", "ExLink"]]],
 " using ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["Which",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Which"]]],
 " developed in this section, the point ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0.0", ",", "0.0"}], "}"}], "ExLink"]]],
 " is not handled properly because of how ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " treats the real number ",
 StyleBox["0.0", "OsF"],
 " compared with the integer ",
 StyleBox["0", "OsF"],
 ". Write another version of ",
 Cell[BoxData[
  StyleBox["quadrant", "ExLink"]]],
 " using alternatives (discussed in Section ",
 StyleBox["4.1", "OsF"],
 ") to handle this situation and correctly return the ",
 StyleBox["0", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"Ex.pointLoc alternatives", "6.3 Exercises"}],

Cell[TextData[{
 "Extend ",
 StyleBox["quadrant", "MR", "ExLink"],
 " to three dimensions, following this rule: for point (",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]]],
 "), if ",
 Cell[BoxData[
  FormBox[
   RowBox[{"z", "\[GreaterEqual]", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", then give the same classification as (",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 "), with the exception that ",
 StyleBox["0", "OsF"],
 " is treated as a positive number (so the only classifications are ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["2", "OsF"],
 ", ",
 StyleBox["3", "OsF"],
 ", and ",
 StyleBox["4", "OsF"],
 "); if ",
 Cell[BoxData[
  FormBox[
   RowBox[{"z", "<", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 ", add ",
 StyleBox["4", "OsF"],
 " to the classification of (",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 ") (with the same exception). For example, ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     StyleBox["1", "OsF"], ",", " ", 
     StyleBox["0", "OsF"], ",", " ", 
     StyleBox["1", "OsF"]}], ")"}], TraditionalForm]]],
 " is in octant ",
 StyleBox["1", "OsF"],
 ", and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     StyleBox["0", "OsF"], ",", 
     StyleBox[
      RowBox[{"-", "3"}], "OsF"], ",", 
     StyleBox[
      RowBox[{"-", "3"}], "OsF"]}], ")"}], TraditionalForm]]],
 " is in octant ",
 StyleBox["8", "OsF"],
 ". ",
 StyleBox["quadrant", "MR", "ExLink"],
 " should work for points in two or three dimensions."
}], "ExerciseItem",
 CellTags->"6.3 Exercises"],

Cell[TextData[{
 "Consider a sequence of numbers generated by the following iterative \
process: starting with the list of odd integers ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["3", "OsF"],
 ", ",
 StyleBox["5", "OsF"],
 ", ",
 StyleBox["7", "OsF"],
 ", \[Ellipsis], the first odd number greater than ",
 StyleBox["1", "OsF"],
 " is ",
 StyleBox["3", "OsF"],
 ", so delete every third number from the list; from the list of remaining \
numbers, the next number is ",
 StyleBox["7", "OsF"],
 ", so delete every seventh number; and so on. The numbers that remain after \
this process has been carried out completely are referred to as ",
 StyleBox["lucky numbers",
  FontSlant->"Italic"],
 " (",
 ButtonBox["Weisstein, Lucky Number",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mathworld.wolfram.com/LuckyNumber.html"], None},
  ButtonNote->"http://mathworld.wolfram.com/LuckyNumber.html"],
 "). Use a sieving method to find all lucky numbers less than ",
 Cell[BoxData[
  FormBox["1000", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:47", "6.3 Exercises"}],

Cell[CellGroupData[{

Cell["\<\
Create an animation for bubble sort similar to the animation in the text for \
selection sort. \
\>", "ExerciseItem",
 CellTags->{"i:44", "6.3 Exercises"}],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WXtczOn3H2kpfFdrQwiDXCIZtCSVtzYKyUikdJnu0+gy1XSbpjESQrW5
F62dzWXl1hDKJSabUMlEQtpMSnKfVWys+PZ7/c7z9Y/X6XzOc55ze59znhkT
EOUWrMfhcDp7cTj/9////9PNUx49Xf9dwpV59Aco5l0fGbTwCdEGOHvbS2Cd
10y0ERx9ZyRVdD8k2hip8UHXF/NaiDbB2QGZuoKTrUSbok9ZeO8Lw58TzYVt
7c9NN5Y8JnosOt+1D+vr1kC0GZSLi26NPnOR6Akw2e3RV1asJXoSgs798++s
QiY/GdlXdvucMm8n2gKCdYIdn+R/EW2J9i6fnK8rXhDNwwELr5a4D+y86Thb
sC10e8tLomfgYpBp94DSp0TPRE5zRP2WbY+ItkLGvcjdVatrif4JxlWGr3YU
M//MQqpg8pek6ndEz4ZC4N9n9dQbRFsj3itw1xET5q85UCfsyE3f8hvRNuAc
5Jrw0pn/5+J7gzOrthax723R78GjKdF7mT12uNnlkHF8I4uHPcpvLy/efvoB
0fMgvJV0PLauiWjAZELw4lUu9L0CsO07vXjde+b/+eCPOPnKcyzJK+ZjSIfN
T7EmzD4HVAsMGq//+5b4DkjXX3GroZ75+2dIczouzK19Rvyf8T671z7fBuZP
Rxza/tZXeI/yQeGI7HW3zt34g8VvAThV1U9EFUriL4BLieux+mEsfxbCfml5
iteGNuIvxKb41vD5tUzeCZxzHkvzVtcT3wk3j1woPzfiHvGd0cn7nqu4TfYq
nMF5e7i4dUIJ8RdB6HNi/GVLygfFIkwY5ylMzmb5vBgfn9Wt/7Gb8kexGK7F
9d/i9rL7LcGQ8pwmJ+M3xF8Cjlf7UsGwLcR3AWfe6NwHWxnfBWpNhducP48R
fykkRzzm7x9N9iiWwqQmNXSnUyPxXSFOba/ZWnia+K4QWj3PW7mlgvjLIEt9
mtoqfU38ZfAdd8D/j+FEc/jIt740lVNE9oGPa3mX+qY+YvbwMcQ5vyB/E91P
zUead1tNSPN9kl8OdbPdiX4zyF9Yjmr5rQZLT8pHxXLIpBWH7kyl+Kh7vl99
zLLuE+ULxw3cFcsT7P3IHrjBYNpXyZSNTN4NN+/PFLzZTfmndkNe0LFt+q6s
PldA2Tvs+MOucyS/Ag4rvvZr2cn8tQK6gjx50WCyR70CWyN9B5pvZvXojrz7
izMUzUTDHa8P92ovvcrk3WFgPj+vkeGD2h3cnI377727TvIrYX3gTOYpx1ck
vxKaja/chx2/RPIroa9WPG9WET6oV6K8RmTz9X/6V4Hz+9nbIzX7SX4VBj0T
RlzPpPxSrIL4QPHoW7wikl+F4Xqueqdbmf0eMM57MjpphobkPeD+5PdkvwCK
j8IDnR+LuOGzKP/VHliodLH2EzG8Ww3OkfXHAgMpH7Eaav4g66KoEyS/GueN
Hhk+ryB96tXQrBE9npvE9HtCNML8joMtyx9P7Dpl7ziimuGBJ0oefQp/k8ji
54m6nBTv1H6UDxyvnvuGB5s2s/h7YUjpqLZbM5n/vdB+rfZVqpLwQ+2FJhm6
3vZm+LcGAf/u/ZrL6h9rgPUjDx66x+phDUw7THw4RvS9eg0Us699Orid1bc3
LOzTpvzdn/jwhrzvd79P4zL/e4M/bF313qmEj2pviMsGNG39WkryPhBLMkMe
u94keR/MyPhHaPyI5a8P0v7D+zXMjun3geR9U3rVLIYPvhDf+3nLpV+Y/b7Q
FMcebq9leOQL/ZvRCRGuhFdqXzgU5XTMyGTyfjgqtBp2ZQjzvx8uZo0YtEfL
8NQPGSurUqSNhLdqPzw8ZuaCOXdJXgBn+ztt3oeovrkCGB0J32CsIn9DgMmu
LQ89GF8ggLbY8J/aZafofAH0S/w7SrPofKUAO4omtTl8R/5TC8BdZbWa10D9
SyuAxDjr/uBprF/640CFwO+lO/mH649r71TzgvJJHv5oTw3vn5FP3wv80bVv
3oHr4Qzv/aHncv9B5T6qP6U/vPlK/eMDWL74wyq/WfDud/Kn1h9XvJvtRDnM
fwF4e9S19P54kucGAOoXF+LWVpP+AGjfXxk++zvq94IAKJIO9S91Z/gYAFmQ
6mqcA91fGQBO+MPTpnPjSX8AJjW4yGMEdaS/R97Mtqp3/0rSHwgbfpC11XTK
d24g+JdmDul+Sf0TgbCvG3lioJzySRCI9k3vvGvSKH6KQHDPDHB1HnuH9Afi
mKuhuMKKvlcHQuRnvL9gPp2vDYRA/8ibrd+z/A/CUTuLgka726Q/CMN72a3Q
v8/qKQg3HfeXN0lpXhEEwXbHFc/QJwxfgnB3g/7p0+XM/iBIPhzsUyhg8Q8C
r3FC+pwm8qc2CEaLNWs2XmDzUzA0nwQG9fXkT24wDlz76CiaxvA4GLbzuV9z
LhOeCIKh4M4/n1+4l/QHQ6IuKE99TfOIMhhf3t9b7BfG+lUwJiQorm0rJX9o
g7Hvyoy5dzIp3pwQbPqolyWyon7IDcGJ4fcPXkyhfEYIhKa7+0S9pvsIQmAS
+qKP5XDSpwjBx5pLd7QpVH/KEFxZU7fh3h46Tx0ChaEEJb2pvrUhUJm98Qkp
vUD6Q8Gx2nXLafIt0h8K5WfhkuLgfNIfis4FU7OPfGD5FwrBhwbjyanHSX8o
3so9ZnkaUnyVoXi//83Wmy4s/qEIeWHx7YUp+UMbClmTk9+xpcx+ISp+fT5r
VwzdnyuEbqLT04HeNE9DCLPc2xklF5j/hdizPOpouQebV4RwLhymdLhN+aAU
IvxafrhLLsN7Ifjjut/mnj5P+oVI2z5+uvNC1v/DkJ4RYmfpx/T30PY3D7sX
kj8QBnGb5Q29PVTPgjDoDkqmqlqqSH8YVseYV/WNqSH9YbDlDLNfbU7+VoeB
U398sHQE1bs2DEH+iTX3Oln/EUEzPm2L8ADJc0VwtplRetuGxV+Ecnn35+0D
Gf6JILFdFfJxPbNfBJ6fTVXBDRXpF0H5NDNsSQ71f7UIqRl3D0dZUz1oReCm
WSyc18rmx7UY4G9XbvuG/MFdC4nld8N0o5j/10LvQ+6ruh9Y/q2FsLIxrVc/
hu9roTANn100h9m/Fpu2RhTVfmP9Zi24z/Qi76TTvKJdi5cP9537YzKbj8MR
1GeT7BWrH244xJujFnYNJfsQjoCh9uLUseQPQTiEdZ9b0xZRPSvC8Tk/ZdTS
SKpfZTgaGnZx6v+Xf+HIu3lmx4Rp1L+04RBM23zkbhebXyNwaHzkHuUbVv8R
yOneWcbvR/FFBPTmDZFVOLL8i8DRRWG1WU/KSX8E8jc923jZlPjKCHT5hsSI
0sh/6gh02px0m1RM/tBGwCI01WD3Gjb/REL84px0jILmR24kpK+K0i4eovMQ
ibToyT+4thAeCyKha08r7c9h800kOK6u/XbbUzyVkdjVlfAfZynDv0gIOMvv
mv/C8C8SytaT9R1baB7jRMH6wdlfe/kRnnOj4JBv/mqoiPADUbhZaeXgvpvi
K4iCt6Lzp1NXCQ8UUYi8+su22kGUz8oo6E6WzHaeSP5R9/AjZl2b9ZnqSxuF
AT/OMu2yZvuPGPLFLUtldeQPIzFcFs4YEbyAzQNiuDW7Nyw4S/I8MTIk9aOt
C0geYiQusjXsW0j9jC9G199T/phwlPq9QIzP2xN7Gdyn/BGL8TR40YeW7ax/
iqHK9FRHyqk/Z4vBeV3fkNdF85tSjFHpU5xTSul7lRibDjaXrW9i/hVDmlA7
Ua1H9mvEqB7ZLUx2Z/1ejM5JTwYPzCK+TgxNr0/TXn5H+cWJxqSyv83rGf4b
RUN4cGnKAAuqF240nCdPd55aRv2PFw2xY/6Y/TuoXyIajXUZo9pbyF5+NLqm
Kta3Cqk+BdGwjT7P8RNT/YqjUZ23cNzsTJY/0eDOchUtKiE6Oxoqz6d3O0vJ
v8po5Pvki863EF6res7fGPpl+FnW33q+t/EMn64jezXR4BTaluvGMryNBnwD
c6tSqN/oolHnfs48rZ3mEU4M8paNbqvdTu8BRjHIWZL3zOYx2cONwdgZm92m
mtP9eDFYaLxTtNiOzWcxeFlmOHt8It2HHwNs+FBxTE34L4jBqAc5vsNy6f7i
GJiI7//hcp3hdwy6+puJQpdSfmTHIP/n9Xkn7Mh/yhgIJotHxKr+JPtjoM59
vn99APV/dQxUUZ/zXtwmPNPEwKvPlNU2J1m999gzPsI79T35XxcD25qFjwap
2XtRLIw9Kr98vkV4ZBSLWcbl3qbuhF/cWBg9e2iYXknzPy8WbT5Df52/nPIR
sT141rFzC4fep/ix+FJZZDHBgvWrWGjdOrouDab4iGPhLSoVOV1n+3gsOBav
BF+jC8j+WNxdULXVz4DNs7HQ3Y5dm1BI+aeKBbf+4dnT39P7gDoW6X+mbyy+
Q/HRxMJ2ScGIxNWEJ9pYqJ4mTF/hRv1UF4vqbsWQ7Bds/pIg8aB0+Na/SZ+R
BJI7FuPEdtTPuRK0/hjhtCGWxV8CzWtB1b9JbD+QQLDsiq17BNUrv4c+ynPp
s5nNixJs3Ttnemt/8qdYgmpzn82zTrL9RgLO8d28aWZbyX4JarjeIrPJDM8k
WJVl12X3hPBHJQHv3eK2ScaEp2oJ0sPjfnMcRfHWSOBdMOBRrjXFV9tzfmWW
pL8Z0TpJz/y1L1J8hu3vccCXigsbbS+T/XGovzbxQNpV0s+Nw6rffA/kraH7
8+LgNuSxHbxY/OPg1bbJRNFB/uDHIcN3bGbsXjYvxMG97PLlZb+SfnEcvtRG
Dfkrl+2HcTAL/dsz5AzVY3Yc1IMcNP/8h/BFGQdN0mCV6jX5VxWHpjmXjy3a
QPFSx6Grb/Veh6OkTxOHl35ZpoXs/VPbc768fO5eK9qfdHHIWbappXof9QdO
PNxnnnt8Zi7Vh1E8jEcW/XDRmOqbGw/HqwH1/2pIHy8eXr2ntu3dTPMC4qH4
fKgjUF9N9sejdW5FVVkesz8eJu07frHPoniJ49H225Oqv5zYe1qP/IQG11dR
28j+eBiZtV/qfkfzkzIeF29PcRnURvdRxcNy9Drff2dQPqrjEf9R0Fq/kuF/
PJSR/Z7U8whftPFAsFN0kyPVg66HFhX+sD2Z7stJgPOXiWmBZbS/GyXAotZ1
t42M8IubgBLxqDLDJoo3LwFejWaWGR9Z/ifg5WtJkTCM8IqfAIV89NCdanp/
EyTA4bDzNINjLP97+M0//Bh1iu3PCdAOmFZ2OIj0ZydA6RVX+cKK5gNlAtz1
khYpEwmfVAk4M+ar4YU+bL9NgOn7t212m+h8TQK4+rxbh7rofUKbAPHdCov6
FrJHl4AdmiXdBVvY+18icsKKH8mmUH4YJaIifv5BhYDO5ybibKzXKV4D6/+J
8Lbec9vtLOEDEsEZO+/dq9A9ZH8iMl4GnZn9mM2riRC4hzT7bDpM9idCrV+b
eGsm6VMkouuvFxGGJrS/ZvfwXZJKM0ceJfsT8bC60/+5I9WHKhEi3War8z+x
97hErHprpW5/SffVJGJSwE/tC5LpPG0iLPX1vO/VM/xPhInpnNQJP7D36SRw
znHGdjbS+5pREnQ+31umDqF64ybBpHO6yf4KwkteEiIfl5X1k1F9IQmVFy4P
zUwi//OToJ44qp/rLepXgiRkj9te6etA73PiJJTcwQlZNtsfk4BXJ1vM+5wl
+5NgO7PYOqKA4qXskR9y/rkz+/1AlQSxxzmvJsczZH8S+MdkoX0/0veaJDRF
R++cvZ3tO0kQbjb+684Nup+uR39dqdJmBev/UvAHxgoUqTQvGEnR+WZ4f34E
e4+RQmMYnepVUUb2S6Fq7S7N7KTvIUXj2P0vPHVkH1+KnJKAoqESio9AivSN
R7OfsPlfLEVi5ZYuZV+2P0mR/biovO9dOj9bCt57PB4xk+3zUhhduX7o+iSy
VyVFSHF+SkAF2y+k4DQVDXy7t5jsl8Klw8v+5DlmvxR5pc26rQK6n04K4eUL
Tt3j2PtrMoLaPBZtSWXzTzJOnFh++qI59SduMurS/AM2DqbzeMkosazL7DRh
+2Ey1P3kmlX3mf098vflbuNLWf9Phqz31Z+O2bP5LxnWL4b1OfKF+o8iGek7
ax7/ZkXxy06GtiHXxGgv+UOZDIOrERumTiJ9qmRU64/51Kam+6iTocmddrzD
k/qtJhn5AQmCrhOkX5uMz8ovI2tkLP+TYbYnkn9/IPs9SQYNb/0uz+k0vxjJ
UNPkNb5/FtvHZZjlmf3Xo0LKd54MnDHRL9siyF+QoXL4Q/PuxcTnyyDWmzKz
cQH5TyDDCYfE193fWP7LULIjrVL6nv0eI4Pi8i8LdrN8y5ZBf92G8lwLtk/K
8DDSc/n819SvVDIYDO7l8WE6zTNqGbKLK3rvU5E/NDKIHgz8eQ2b97QyWJ9o
d0p3IzzWyTCoYuavl0ey/TcFZ0bYhW6bQvqNUnr2D/E/A8ax+TcFh+ZLZvsZ
Ur3wUmD5YUOXPIz1vxRU2IdE7M4meX4Kduwq4Pt9Yu91KZghaV3leo/hfwrE
tRCeT6fvFT363Obb/vmZ5vPsFCj8VYPen8oi+3v4y05+a5RR/1KlQNaxLnvw
Ptb/UmCgOb4p5xT5V5OCyLosM+cO1v9TkPqp+oybIenT9ZwXaLkvK6SQ7Jcj
8p9Jg/5eTvVoJEf6mE8T939j848cirErVm5op3jz5CjJX/Btt4Ttf3JgTI3f
kwN0f74cw8cY7fztPPUXgRwcp/cfd/rSvC6Ww8R6dqK/Hpt/5MjOlPk/82Lz
vxxftJ1FPAfiK+VQlxfqDNOpHlRyqBqvf23Ssd+T5OD5S+f4qamfaOTo/NdH
+aCI6kkrR6NLhU2uHflL1yPfMObo6LnkL846iPdkCC+LWP9bhyD3jaX2zpSf
3HWIjzxlYM3mO946ZOgCv090ZvvPOqjO3Zj0aW7tvP8C8zwVAQ==
          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {194.4, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WXlczPn/H2kp7GptCGGQI5JBS1J5aqOQJJHSMd3T6JhquqcxEkK14y5a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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {583.2, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw1mHtczPn3xz/SIuxqbQhhkEskg5ak8tJGIUkipcune40uU033aYyEUG3u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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {972., -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw1mHtczPn3xz9oKXxXa0Pug1wiGbSEyksbhSSJlC6f7jW6TDXdpmmMhFBt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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {1360.8000000000002`, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.4922359499621}]}, {
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw92HtcjPn7P/AbLcJntTaEMM4iGbQklZc2CslIpHS4O+gwOkw1nacxEkK1
ORetnc1h5dQQyiEmm5ySiYS0mZTkPKvYWPGd32Ov988/Hs+97ut93dd77vfB
jvCPdF3VleO49i4c9//+/u+PbjYX9vCk6ay42fQfwHm2LuIHbSL3BHdo7ZGA
AGYjKARzzuYX7iYbg/v99O2hmr1kE6jjt+Wmb/qNbAruVuUTcYWSLIDyc8jC
4lX55JFQaypcZ/55hDwa/Ic64wmpR8ljoRb1syqKPEYeD22x4T/Vi0+QJ0Do
a32r4JqKbA5JamvV5sKTZAtg7dD9B+4xCyHZVzz8hrCIPAXKbqFHH3acIU+F
aFTn29yTZ8nTwBscerP5+xKyJbi3B4ubxzL/BHWj7bFeU5mnQzHjyqf9W5ln
QDX6jXdQ6TmyFZQLim4MP3WePBPKp5mhC3MukK2hWf/KbdBR5lmQlPVp2Py1
lGwD5eGTtd/FXyLbQvCsa8Sd9KtkOwhy1u+99455NkIsn+ct21RBBhS8X/cV
k679ZwVw3WFveUMSmZsDiTQz6LHLdYrPAWe544bjhBsUt8fh+aHVWU/KKW6P
dLvrB90KWfxnKEbb3OrW+ybFf0ZO5/YyUa9bFHeAbr90kqqJrHCA5MWZpBEK
Nv9zEVLzuTltfiXF5wLqF+diV5O5eRDWj02f2cDi83DY1ryg3vY2xR2hMA2b
UTSziuKO4Lkld81+YflOWBFtdqtHNIs7QTMmbVPIPjI3H4JTfVycRt6h+Hxc
v2lp77aTxRfAOO/J8MSpGoovgNQ4637/ydUUXwjd8ZIZTuPY/CxExr2InbdW
sLgzWlPDemfkkxXOMFArnjeqWHwRHh4Z7YyZdym+CFYPTv/axZfMuaB1wzuv
qjQWd0HCfBvDHoU039xiXD90rvzMkHsUX4y866e2jZ1M5kTo8+N00w4rMkQw
uB4VH+7CnheBe11bl9dB60UtQoa0drhVActfgvF1zvJovobyl8Dtye/Jvv73
KX8JnAoHKe1vk9VLYLPtkkfwEzLnCk2XT5Nffke/P1yR5tVSFdTI8l0Rsn9R
Sh9z+n7VrnCaMMVpUhn7PpdC4pA/Yu82+r2xFO0fiwRh02spfym4M+6L8laQ
1UuhbD5e27aJzLlBNOT4K4+RDyjfDSWPPoW9SSAr3KDyeHq3vZT6Vbvh+v1p
/JudFOeWIexKfphzLstfhvLbS4q3nmT5y8AV2pTrRtL+oV4G+ATk3kph6385
atzOmKW1svlbDtGgNZW7Jz2k/OUwGbtqwXJnsno5rnfYZxxdT+bc4eAzNbGi
kwx3aN9fGjzju0eU7w6s+1BxRE3vo3ZHTmN47aYtFOdWwERy/w/nq2z+V8Bo
gWbl+nMsfwW8FO0/nbhMVq8AP0EyJEb1J+V7QJ37fO9af9r/4YH2uZOyD31g
+Xq/ax3Uw7WO8j1QObQzJNmNzHlClemhjpCT4QnL/Eb+3e9khSfahd8LFLdZ
vieMnj00TL/J+l8JTXHMwdZqlr8S/OS27Zs42k8VK6Gy9gibomP5K6F1beu4
0J/V94JNjynFa96zfC9w5q/4r1EFlO8FqcV3g3TDHlO+F3S3Y1bHF7LvzxuC
2oenT35P5xW8YVP9c8O1hfS8Qu+FBUMSVtD6VHtD9TR+ylJXtj/6oLJTMSD7
Bc0XfKAb5/i0rxfL94H0jvkoiS1bPz7o8AmKFqdRnPNF4Jl//p1eSIYv+MWX
bNzCab0q9D4sdO6+kd5X7QubqnmP+qlZPo9KM++N049T/wIe3NGdwsmjN9N4
PBSGUpR0q//PPA8bbpDdCjOygofw3YKW8ca0nyp5mFSlBm93pLiah1dBn0e5
VlRPqx//Zpa092hW309/Hu6JkJyi9S3wA75UnFtvc5Hq+0GwdEm8nS+r7wfJ
vZ83XfiF1feDsfvNL59vkJV++v0nbJVpI6vvp/8eNh6620HW6uNlFy8u/pXV
9we/ht/2Sf4X1ffH6OC/PYJOsfXoD3U/e80//6P9hfeHJrG/SvWaza8/0g2W
3qirpXylP9KiJvzg0kRW+0N0YdqAzpdkrX58efms3ZZsfw9AzuINTZV76HwQ
BCBv8fCW6q0NVD8AITcSj8bUkPkAKGZfHRo47wnVDwC3X2AiTCcr9fHPB9oC
DNRUPwAdf0/8Y+xhimsDYNK67Re7LHb+BUKw3HKFsI7igkAoxta5vIrcQvUD
YTS69ULnO7p/8IHIWZj3zPoxqx+I+pqMYa1NrH4gdAV58qL+WqofCGVErye1
QtpftIHAKseoBgd2fq0CxIU/bE2m9xWsgtOXcWkBZXTfwCqYV7vstJbR/sWv
Qov3wF/nLKHxFaugSDzQu9SNrFwF1wGPbeHJ6uvj8uEDt6vpvqPVjxec2nPn
SopzQVA0/vBj5Am6PwqCoO0zuexgIKsfBKVn7M0XlnRe8EFw65o4X5nAvr8g
zFM6W/mKWf0gfM5PGbYogtUPgsBAeONAB93XtEGQ3K0wr21i50cwnq6a/6Fp
Kz0vCEZOaPEj2UT6PhAMk53uPWTFFOeDMSx9olNKKes/GF5Wu267nqb9QRkM
buTsd6+Cd1H9YMgXNC2S1dDz2mDwbkGN3hsOUv0QqA2qE25Mo3qCEHT89SLc
0ITuO9DHnRNLM4cepvoheFjZ7vfcgdaHIgRi3UbLsz+x/kOg+cT3rK1l/Ydg
vP9PrXOTaTxtCK7kXeiR+ojNfyhMTGemjv2Brb9Q/XnNjWyvp/s4QqHz/t4i
dQCtN17/fPsUk70V7HwJRYlkWJlhA6sfigNjInYp37D6oVCPG9bL5QadV9pQ
ZI/aetPHnu5rnBj7zD2bYj+w+RcDr443mXU/TfXFsJlWbBVewL4/MXqazcmr
Z88rxJC4n/FscDhF9cUQHZEF9/jIzlsxPj6rWftjJ5t/MQa0Wf8UY9JI9Vej
pKZUab2U5lOwGqK+Mbwile4LWA2T4BfdLQbT8/xqaAyjUj0ryqj+aqiaO0sz
2+l55WrUj9z7wkNH/alXI6fEv2iglNVfjfT1h7Of/P/7Xxg8u01q2b2RxheE
IftxUXmPuzQ+wiB8j8dDprH6YTC6dPXA1fHUryIMJXdwTJZNcWUYuIaivm93
F1P9MJy+7clb5VFcG4a80kbdZp7NfziMbxm+2lbM6ocjsMV9/qZUtv+F49ix
JSfPm9H5xIdDqi4oT31Nzyv0z3ffIHvFrAyHupdcs/w+6z8cJRY1me0mT6l+
OPwH2klSR5K5CFi9GNT90Bd2/kQgfXvV498s2X0uAtq6XBOj3TQffAR6Xg5f
N2k85Ssi4GQ9tfS2NVkZAU3u5KNtHuy8jUBH79Hi4EWsfgSODb6//3wKqx+J
0bsiRPf7sv03Ehrh2h0eU+j+gkgYlPi1lWbR83wkzgeadvYpZfUjwY2IetkS
TvOljMTnrQldet6nuDoSkq4Tp9XPpfnTRuKYfcLrzm9s/iUo2ZZ2M+k97W9G
ErzP7rLHp47yBRIYrFlXnmtO349QgocRHkvmvKbzChL07N/F/cMUus+IJMhY
dislqZ69rwQNMnS87db0nyUSWB1rdUx3pf1YIYG5XdrEv3tTPFsC0zYTb86I
rJTo//0h+afPKJoflQQH5khn+BrSelFLYPFhXYc8lH5/jQRxngE7DplQvlaC
9LDY3xyGkXUSnBpiG7xlIpmLQmpc4NUFQrJRFDjXOTZ/fqb7uSAKCj9Vv/cn
sqh/fXzx8W/1Mjq/EIW0/wl/DbWlfFEUemqObsg5QfPLR0EWqLoca8/619f7
VHnK1ZCs0I8XYLEnK6iQ+o/Cvgre96Ub6z8K7W8G9xaFk1X69xm5dNm6Vvq9
1VEoyZ/7baeU1rMmChhR5ftkH72/Vv/8xV/m7mT5On09x/cft/uw/18TDUk1
Qs6ms/6jkZ0p83vmyX7/aFTYBYXvzKa4MBrq8kKdYTrbH6Lh2X3iCuvjrP9o
CP2SZvqq6Tzho9H+r7fyQRGtJ0k0vu95avnmItZ/NFR1Iw4Pn0Xzla1/n10Z
IRfFlK+MRqDb+lI7J/o+VfrxrI+7ji+mfHU07q4zOHmynKzRj3fm2vhPsyhf
G40Nm8OLqr+x/qOxrWh8i/13zdR/DIyHFv1w3phsFAN5j+9+nywgC2KQmnH3
YKQVWRiDecbbxQtsyYgB5+LSa6cdWRSDDF3A9wlOZD4G0g/7uxfyZEkMdnTE
/88piayIQb9nIeFXM8nZMRg7yiMkOZusjMGVd6rZgflkVQxO98nUFRwnq2Ow
YX9j2doGsiYGgjTzebObydoYnL890blfC1kXg1Mjvhqe6/6M+pfCS6Q0ONqH
bCTFl5tF5mPNyQIpKuLm7FfwZKEUmtf8rX8TyZBC0mJxresuskiK1ivVr1KV
ZF6KfP94vuMYWSKF0aGwdcYqskKKY/flrmNKydlSJOW0nZtVTVZKsfytpbr1
JVklRVzEiZ5WbWS1FJ4tG0wUzBq960dbZHwka/XjxVePU3dtof6lqMlJ8Urt
ReZiEXH5ly3V/chGsagSeIlHTyALYiFLqjhwZxJZGIu4j3xz7TIyYtGxZ/a+
q2FkUSzsFpWneK4j87Hw/3f311xmSSzaxz/p3zeLrIhF7ZVx+9Iuk7NjMbiL
7VKD+2RlLFT1V7826MiqWAT6JVTdayerY5E+4tO4vd/ImliE3KxP69LrOfUf
i5o0P//1/cm6WDiXuBypHUTm4tC9LKzbucFkozhwtUf7Jw0hC+Igfd+Qfms6
WRiH/J/X5h2zJSMOHZMUa5tDyKI4vHwtLQoJJfNxsC/KaZuaSZbEoSEqavuM
rWRFHFyKa7/F7iZnx+GSV6OtOIesjEN2cUW3PSqyKg7ObZ52x8+Q1XGoNBjx
qUVN1sThwNa3PiH3WP9xOJ81pN8uLes/Dm/l7tM9DFup/3j0q5j268WhZKN4
SA+5z9k7nCyIR/alnd4nzMjCeLz0zTItZIbeD/ec+WMCWRQPa1GgleUUMh+P
AaXDWm5MI0viIfY13lswh6yIx83BD806F5Cz4xHxuKysl4ysjIf90q+9mraT
Vfr3WXPjzLU/yOp4TPfI/utRIVkTj9cHu7SWXiZr46GK/Jz34jZZF48Ncc1h
c6pZ/wmIqMka7dTG+k+AidWMBL+uL6j/BGzePXNKc2+yMAFHXAwlFZZkJOCL
tr1IaE8WJeD93jebrzuT+QTU1e3gapklCWjt8M75upSsSMB043IvUzdydgIq
5TfqLDzIygQs/81nX95KsioBN89dHJiZSFYnwK5m6LG+crImAT0nf5VOXE/W
JsD0/dsW2w1kXQJ6PXg0MWo3mUvEl+rIAX/lko0SYX/QaXLPI6z/RIyNV1zZ
Usr6T0RQcX6KfwXrPxEhG43/unON9Z+IqdLm5S73WP96Z/wTYvyI9Z+IbTsK
RL6fWP+JOBxiOejSgJfUv34872NjLlqQlYkQDzG7Y29DViWi5bcnt/5yJKsT
kRd4ZIuBC1mTiPSMIFsLX7I2ERW/Pp++I5qsS4RmpfjxrEQyl4SPVRfuaFPI
RkmoavAc0zuLLEhCvtWFSVwRWZgE10a3urmnyUjCWaNHhs8ryKIknI7xPCGs
I/NJWJ5l22H7hCzRxwu2BG9tIiuSMLirS9eTzaz/JESET78y/TPrPwl3597a
7NvzFfWfhLeHXUrvjyGrk2C171TmCQeyJgmyBkffI4vI2iQ0zLx4ZP46si4J
ey5NnXUnk8wlY9iDHJ9BuWSjZHR1vv/g5h6yIBkOl/1r/9WQhcnI984Xn20i
IxkJ+5MGb/6bLEqGz6h9fn8Mfk39J2PDx65ZYkuyJBnjy/42q2VWJMM+3+zV
QDE5Oxmy1KepzUlkZTK2aRZ2Fmwiq5JxaWXNunu7yOpkDB5htP23s2RNMrzE
pWLHq2St/v1ubupQ9nhD/SejXN75eWtfMifDgPKcBkdjspEMko2R8zoGkgUy
BL0w//bClCyUwXne1CGr5pIhQ8Q/4/v9vYQskmHXksjD5e5kXoYv7+8t8A0l
S2R4WWY4Y0wCWSGD1GZ50Me15Gz9+zjlF+RvICtl4GYPz32wmaySIcNnZGbM
brJahuZZFbfK8sgaGSa4ND10P0DWyuBkd6fFi1mn/8dIj8rd9odZ/ynoWB/8
ZfBp1n8KdK1ppb25t9R/CvI3PFt/0ZQsTMHIqRtdJ5mRkQKL4Wt8/p1KFqWg
3rnCOteWzKeg6+wBsgoHsiQFaVvHTHGaR1akoPnHcMd1MeTsFFTmzRs1I5Os
TIGsbU12/z1kVQqSXhWlnT9AVqdAMN1FPL+ErEnB6NzbGSXnyNoU2MwRfM25
SNalYMcJO4chlWROjvQ/09cX3yEbydHHz7bc5g3rXw71iiMWNZ9Y/3JU8j3r
r/7L+pej64fcVzU/vKP+5Qi5eM6xcxSZl2PflY8O4slkiRxu0848PjWLrJBD
1u3yT0fsyNly2ESd5XwlZKUcn5VfhlbJyCo5Nkf49DXbSFbLUV4ltv7KrJEj
e8DZ506VZK0cqfyEL4nMOjksDLp63aslc2uQ8TLw1IzHZKM1yLu/IEPRSBas
QYjpzu6Rr8nCNRA/6PvzyvdkrEHOmHCvVL3/DzSIFQE=
          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {194.4, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tcTIn7B/AjLcKu1oYQBrlEMmhJKh9tCMlIpHQ5XVRGl6mmmmoaR0Ko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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {583.2, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tYTIn/B/CDlsKu1oYQBrlEMmhJKm9tFJKRSOlyutfoMtV0n8aREKrN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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {972., -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tcTIn/BvAjLYXvam0IYZBLJIOWpPJoUUhGIqXL6V6jy1TTfRpHQqg2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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {1360.8000000000002`, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.4922359499621}]}}, {}},
  
  ContentSelectable->True,
  ImageSize->{475.072540314237, Automatic},
  PlotRangePadding->{6, 5}]], "Figure",
 Deletable->False,
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the ",
 Cell[BoxData["gcd"]],
 " function implemented using an ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 " structure."
}], "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "gcd", "]"}]], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcd", "[", 
   RowBox[{"m_Integer", ",", "n_Integer"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"m", ">", "0"}], ",", 
    RowBox[{"gcd", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"n", ",", "m"}], "]"}], ",", "m"}], "]"}], ",", 
    RowBox[{
     RowBox[{"gcd", "[", 
      RowBox[{"m", ",", "n"}], "]"}], "=", "n"}]}], "]"}]}]], "InputOnly",
 AspectRatioFixed->True,
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "=", "12782"}], ",", 
     RowBox[{"n", "=", "5531207"}]}], "}"}], ",", "\n", 
   RowBox[{"gcd", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData["11"], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Given an integer, this totals the list of its digits.", "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{"IntegerDigits", "[", "7763", "]"}], "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData["23"], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "To repeat this process until the resulting integer has only one digit, use ",
 Cell[BoxData[
  ButtonBox["While",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/While"]], "InlineFormula"],
 ". "
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"digitRoot", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"locn", "=", "n"}], ",", "lis"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"lis", "=", 
          RowBox[{"IntegerDigits", "@", "locn"}]}], "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"locn", "=", 
        RowBox[{"Total", "[", "lis", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "locn"}]}], "]"}]}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"digitRoot", "[", "7763", "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData["5"], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell["This can also be accomplished without iteration as follows:", \
"SolutionText",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"digitRoot2", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"n", ",", "9"}], "]"}], "\[Equal]", "0"}], ",", "9", ",", 
    RowBox[{"Mod", "[", 
     RowBox[{"n", ",", "9"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"digitRoot2", "[", 
  RowBox[{"1000", "!"}], "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData["9"], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a direct implementation using ",
 Cell[BoxData[
  ButtonBox["Piecewise",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Piecewise"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"Piecewise", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"x", "\[Equal]", "0"}], "&&", 
        RowBox[{"y", "\[Equal]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"y", "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{
        RowBox[{"x", ">", "0"}], "&&", 
        RowBox[{"y", ">", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{
        RowBox[{"x", "<", "0"}], "&&", 
        RowBox[{"y", ">", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{
        RowBox[{"x", "<", "0"}], "&&", 
        RowBox[{"y", "<", "0"}]}]}], "}"}]}], "}"}], ",", "4"}], 
  "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"quadrantPW", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{
         RowBox[{"x", "\[Equal]", "0"}], "&&", 
         RowBox[{"y", "\[Equal]", "0"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"y", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2"}], ",", 
        RowBox[{"x", "\[Equal]", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         RowBox[{"x", ">", "0"}], "&&", 
         RowBox[{"y", ">", "0"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{
         RowBox[{"x", "<", "0"}], "&&", 
         RowBox[{"y", ">", "0"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{
         RowBox[{"x", "<", "0"}], "&&", 
         RowBox[{"y", "<", "0"}]}]}], "}"}]}], "}"}], ",", "4"}], 
   "]"}]}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"quadrantPW", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "4"}]}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The alternatives we need to check for are ",
 Cell[BoxData[
  RowBox[{"0", "|", "0.0"}]]],
 " for both ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and y."
}], "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "|", "0.0"}], ",", 
     RowBox[{"0", "|", "0.0"}]}], "}"}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", 
     RowBox[{"0", "|", "0.0"}]}], "}"}], "]"}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "|", "0.0"}], ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"-", "2"}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "2", ",", "1"}], "]"}], "/;", 
   RowBox[{"y", ">", "0"}]}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"x", "<", "0"}], ",", "3", ",", "4"}], "]"}]}]}], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"quadrant", "[", 
  RowBox[{"{", 
   RowBox[{"0.0", ",", "0"}], "}"}], "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData["0"], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"quadrant", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0"}], "}"}], "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
These rules are basic extensions of the two-dimensional cases.\
\>", "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "0"}], "}"}], "]"}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"-", "2"}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "2", ",", "1"}], "]"}], "/;", 
   RowBox[{"y", ">", "0"}]}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"x", "<", "0"}], ",", "3", ",", "4"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "2", ",", "1"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"y", "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{"z", "\[GreaterEqual]", "0"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "3", ",", "4"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"y", "<", "0"}], "&&", 
    RowBox[{"z", "\[GreaterEqual]", "0"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "6", ",", "5"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"y", "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{"z", "<", "0"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"quadrant", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<", "0"}], ",", "7", ",", "8"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"y", "<", "0"}], "&&", 
    RowBox[{"z", "<", "0"}]}]}]}]}], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"quadrant", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "3", ",", 
       RowBox[{"-", "4"}]}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Start with a small list of odd numbers.", "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ints", "=", 
  RowBox[{"Range", "[", 
   RowBox[{"1", ",", "100", ",", "2"}], "]"}]}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "5", ",", "7", ",", "9", ",", "11", ",", "13", ",", 
   "15", ",", "17", ",", "19", ",", "21", ",", "23", ",", "25", ",", "27", 
   ",", "29", ",", "31", ",", "33", ",", "35", ",", "37", ",", "39", ",", 
   "41", ",", "43", ",", "45", ",", "47", ",", "49", ",", "51", ",", "53", 
   ",", "55", ",", "57", ",", "59", ",", "61", ",", "63", ",", "65", ",", 
   "67", ",", "69", ",", "71", ",", "73", ",", "75", ",", "77", ",", "79", 
   ",", "81", ",", "83", ",", "85", ",", "87", ",", "89", ",", "91", ",", 
   "93", ",", "95", ",", "97", ",", "99"}], "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "On the first iteration, drop every third number, that is, drop ",
 StyleBox["5", "OsF"],
 ", ",
 StyleBox["11", "OsF"],
 ", ",
 StyleBox["17", "OsF"],
 ", and so on."
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{"ints", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ints", "=", 
  RowBox[{"Drop", "[", 
   RowBox[{"ints", ",", 
    RowBox[{"p", ";;", 
     RowBox[{"-", "1"}], ";;", "p"}]}], "]"}]}]}], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "7", ",", "9", ",", "13", ",", "15", ",", "19", ",", 
   "21", ",", "25", ",", "27", ",", "31", ",", "33", ",", "37", ",", "39", 
   ",", "43", ",", "45", ",", "49", ",", "51", ",", "55", ",", "57", ",", 
   "61", ",", "63", ",", "67", ",", "69", ",", "73", ",", "75", ",", "79", 
   ",", "81", ",", "85", ",", "87", ",", "91", ",", "93", ",", "97", ",", 
   "99"}], "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Get the next number, ",
 StyleBox["7", "OsF"],
 ", in the list ",
 Cell[BoxData["ints"]],
 "; then drop every seventh number."
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{"ints", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ints", "=", 
  RowBox[{"Drop", "[", 
   RowBox[{"ints", ",", 
    RowBox[{"p", ";;", 
     RowBox[{"-", "1"}], ";;", "p"}]}], "]"}]}]}], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "7", ",", "9", ",", "13", ",", "15", ",", "21", ",", 
   "25", ",", "27", ",", "31", ",", "33", ",", "37", ",", "43", ",", "45", 
   ",", "49", ",", "51", ",", "55", ",", "57", ",", "63", ",", "67", ",", 
   "69", ",", "73", ",", "75", ",", "79", ",", "85", ",", "87", ",", "91", 
   ",", "93", ",", "97", ",", "99"}], "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Iterate. You will need to be careful about the upper limit of the iterator ",
 Cell[BoxData["i"]],
 "."
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ints", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "1000", ",", "2"}], "]"}]}], ";"}], "\n", 
 RowBox[{"Do", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"p", "=", 
     RowBox[{"ints", "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ints", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"ints", ",", 
       RowBox[{"p", ";;", 
        RowBox[{"-", "1"}], ";;", "p"}]}], "]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"i", ",", "2", ",", "32"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", "ints"}], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "7", ",", "9", ",", "13", ",", "15", ",", "21", ",", 
   "25", ",", "31", ",", "33", ",", "37", ",", "43", ",", "49", ",", "51", 
   ",", "63", ",", "67", ",", "69", ",", "73", ",", "75", ",", "79", ",", 
   "87", ",", "93", ",", "99", ",", "105", ",", "111", ",", "115", ",", "127",
    ",", "129", ",", "133", ",", "135", ",", "141", ",", "151", ",", "159", 
   ",", "163", ",", "169", ",", "171", ",", "189", ",", "193", ",", "195", 
   ",", "201", ",", "205", ",", "211", ",", "219", ",", "223", ",", "231", 
   ",", "235", ",", "237", ",", "241", ",", "259", ",", "261", ",", "267", 
   ",", "273", ",", "283", ",", "285", ",", "289", ",", "297", ",", "303", 
   ",", "307", ",", "319", ",", "321", ",", "327", ",", "331", ",", "339", 
   ",", "349", ",", "357", ",", "361", ",", "367", ",", "385", ",", "391", 
   ",", "393", ",", "399", ",", "409", ",", "415", ",", "421", ",", "427", 
   ",", "429", ",", "433", ",", "451", ",", "463", ",", "475", ",", "477", 
   ",", "483", ",", "487", ",", "489", ",", "495", ",", "511", ",", "517", 
   ",", "519", ",", "529", ",", "535", ",", "537", ",", "541", ",", "553", 
   ",", "559", ",", "577", ",", "579", ",", "583", ",", "591", ",", "601", 
   ",", "613", ",", "615", ",", "619", ",", "621", ",", "631", ",", "639", 
   ",", "643", ",", "645", ",", "651", ",", "655", ",", "673", ",", "679", 
   ",", "685", ",", "693", ",", "699", ",", "717", ",", "723", ",", "727", 
   ",", "729", ",", "735", ",", "739", ",", "741", ",", "745", ",", "769", 
   ",", "777", ",", "781", ",", "787", ",", "801", ",", "805", ",", "819", 
   ",", "823", ",", "831", ",", "841", ",", "855", ",", "867", ",", "873", 
   ",", "883", ",", "885", ",", "895", ",", "897", ",", "903", ",", "925", 
   ",", "927", ",", "931", ",", "933", ",", "937", ",", "957", ",", "961", 
   ",", "975", ",", "979", ",", "981", ",", "991", ",", "993", ",", "997"}], 
  "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "It would be more efficient if you did not need to manually determine the \
upper limit of the iteration. A ",
 Cell[BoxData[
  ButtonBox["While",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/While"]], "InlineFormula"],
 " loop is better for this task. The test checks that the value of the \
iterator has not gone past the length of the successively shortened lists."
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LuckyNumbers", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", 
      RowBox[{"i", "=", "2"}], ",", 
      RowBox[{"ints", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"1", ",", "n", ",", "2"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ints", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "<", 
        RowBox[{"Length", "[", "ints", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"p", "=", 
         RowBox[{"ints", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ints", "=", 
         RowBox[{"Drop", "[", 
          RowBox[{"ints", ",", 
           RowBox[{"p", ";;", 
            RowBox[{"-", "1"}], ";;", "p"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"i", "++"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "ints"}]}], "]"}]}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LuckyNumbers", "[", "1000", "]"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "7", ",", "9", ",", "13", ",", "15", ",", "21", ",", 
   "25", ",", "31", ",", "33", ",", "37", ",", "43", ",", "49", ",", "51", 
   ",", "63", ",", "67", ",", "69", ",", "73", ",", "75", ",", "79", ",", 
   "87", ",", "93", ",", "99", ",", "105", ",", "111", ",", "115", ",", "127",
    ",", "129", ",", "133", ",", "135", ",", "141", ",", "151", ",", "159", 
   ",", "163", ",", "169", ",", "171", ",", "189", ",", "193", ",", "195", 
   ",", "201", ",", "205", ",", "211", ",", "219", ",", "223", ",", "231", 
   ",", "235", ",", "237", ",", "241", ",", "259", ",", "261", ",", "267", 
   ",", "273", ",", "283", ",", "285", ",", "289", ",", "297", ",", "303", 
   ",", "307", ",", "319", ",", "321", ",", "327", ",", "331", ",", "339", 
   ",", "349", ",", "357", ",", "361", ",", "367", ",", "385", ",", "391", 
   ",", "393", ",", "399", ",", "409", ",", "415", ",", "421", ",", "427", 
   ",", "429", ",", "433", ",", "451", ",", "463", ",", "475", ",", "477", 
   ",", "483", ",", "487", ",", "489", ",", "495", ",", "511", ",", "517", 
   ",", "519", ",", "529", ",", "535", ",", "537", ",", "541", ",", "553", 
   ",", "559", ",", "577", ",", "579", ",", "583", ",", "591", ",", "601", 
   ",", "613", ",", "615", ",", "619", ",", "621", ",", "631", ",", "639", 
   ",", "643", ",", "645", ",", "651", ",", "655", ",", "673", ",", "679", 
   ",", "685", ",", "693", ",", "699", ",", "717", ",", "723", ",", "727", 
   ",", "729", ",", "735", ",", "739", ",", "741", ",", "745", ",", "769", 
   ",", "777", ",", "781", ",", "787", ",", "801", ",", "805", ",", "819", 
   ",", "823", ",", "831", ",", "841", ",", "855", ",", "867", ",", "873", 
   ",", "883", ",", "885", ",", "895", ",", "897", ",", "903", ",", "925", 
   ",", "927", ",", "931", ",", "933", ",", "937", ",", "957", ",", "961", 
   ",", "975", ",", "979", ",", "981", ",", "991", ",", "993", ",", "997"}], 
  "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "This latter approach is also reasonably fast. Here is the time it takes to \
compute all lucky numbers less than one million; there are ",
 Cell[BoxData[
  FormBox["71918", TraditionalForm]]],
 " of them."
}], "SolutionText",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Length", "[", 
   RowBox[{"LuckyNumbers", "[", 
    SuperscriptBox["10", "6"], "]"}], "]"}], "//", "Timing"}]], "Input",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3137569999999812`", ",", "71918"}], "}"}]], "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Use the same constructs as were used in the text for selection sort.\
\>", "SolutionItem",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bubbleSortList", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"slist", "=", "lis"}], ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "lis", "]"}]}], ",", 
      RowBox[{"tmp", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "len"}], ",", 
       RowBox[{"i", ">", "0"}], ",", 
       RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"tmp", ",", "slist"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "2"}], ",", 
          RowBox[{"j", "\[LessEqual]", "i"}], ",", 
          RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"slist", "\[LeftDoubleBracket]", 
              RowBox[{"j", "-", "1"}], "\[RightDoubleBracket]"}], ">", 
             RowBox[{
             "slist", "\[LeftDoubleBracket]", "j", 
              "\[RightDoubleBracket]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"slist", "\[LeftDoubleBracket]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"j", "-", "1"}], ",", "j"}], "}"}], 
              "\[RightDoubleBracket]"}], "=", 
             RowBox[{"slist", "\[LeftDoubleBracket]", 
              RowBox[{"{", 
               RowBox[{"j", ",", 
                RowBox[{"j", "-", "1"}]}], "}"}], 
              "\[RightDoubleBracket]"}]}]}], "]"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "tmp"}]}], "]"}]}]], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", "500"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sort", "=", 
   RowBox[{"bubbleSortList", "[", "data", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ListAnimate", "[", 
   RowBox[{"ListPlot", "/@", "sort"}], "]"}], ";"}]}], "InputOnly",
 CellTags->"6.3 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WXtczOn3H2kpfFdrQwiDXCIZtCSVtzYKyUikdJnu0+gy1XSbpjESQrW5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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {194.4, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9WXlczPn/H2kp7GptCGGQI5JBS1J5aqOQJJHSMd3T6JhquqcxEkK14y5a
O5tj5WoIuWKyCZVMJKTNpCT3rGJzxHd+j329f/3T49nr83q/7uP9blRgtHuI
HofD6ezB4fzf7/9+tHNUidvyMjf9Pof+AE5V9WNhhYKwAThvDpa0jjtH2AiK
hcU3R566QNgYisMn679LvEzYBBzv9sX8IZsIm0LGD+i1cvJ1wlyo1BXus/46
Qng0su5G7axaWUvYDDcOnS8/M+wu4XEQpbfXbC46SXgCBFbP8pdvqiA8EZwz
novzV9YTtoDbsOMvvUbfJ2yJ8ltLS7aeZJgHk3EhC1e4PCA8FTe6HLKOrmd4
GjJ82mpCm+8Rng5Vs92xPtOY/VZw9JuWXNHNvv8Zuc2R9Zu2PCQ8A51v24f0
dm8gPBOdvB+4slsMW8O299SSNe8YnoUb96bzX+9k+tnAtvaXpuuLHhGeDUXP
8KMPus4QtkXwmX8/zyhidDuY1KSHbXdqJGwP7rKlifb+DM8Bfw1/20fp34SB
TP1lNxvqCcsAwc3ko3F1TUSfC27u+r13314j+lzI5lwbHjz/MdEdoF7/0mPI
0YtEd4C+SvasWcni9ws4+7kmvEz6XqbDf5y+NVy9l+iO0BbmS4sHaojuCNG+
kpE3ecVEnweTnZ69JSWMPg/G+Y9HJk9TE30+PB7/keofSPGRzUfnh2JuxAwW
fyfMV7hY+wsZvxM4h9YeCQpi+egMldsA6+LoY0R3xtX8i73TH9L3nAXYZ+Hd
Ev+e8S+Agfnc/EaGOQvx4Wnd2p+6GX0hzj38GPE6icVvEQZ12PwcZ9JM9EU6
fSNCTJtZPFxw+pY33zqf0V1gXGX4clsJYc5iXAg27e5X+oToi/FO3mOPXwNh
jiuwdvj+A3epHmSuaJKg603PFqIvgWzm1Y/7t1K+ypbAwj5j0j99Gd0Nph0m
vhwjwnCD25A11bsnUz7L3CAq69e0+Wvpf1ilw+Ls0EeuN4h/KRK8g3YcMmH8
S5GeEHxtIY+wbCkyvuf9Fm5HWLUUoru/bLr4K7PfHeqSuIPttZT/cIf+jZjE
SFeqd5k7fjA4tWJzMeN3h7T3d39M4bYS/zIMeCqIvJZNGMuQtbwqLaWR+WsZ
Hhwxc8GsO8S/DOPGeAlS5YzfA6f7ZWsLjzN+D7RfrX2ZrnhK/B7QlBj+W7vk
BPF7QP9cQEdpDvP/cmwrntDm8B3jXw7uCquVvAaW78shNs65N3AK1YNqOfZV
8P1feDD/r8DVt8o5wQWMfwXa0yP6ZhXQ97IVMDoUsc5YSfqoViAlt+P87FrC
HE/4uCn0j/YjDE9YFTTz3/5B/pR5oi43zSe9Txvxe0KSUnHg9mTCnJWA6vn5
+NXVxL8SmneXh878jvqXbCVkyQf6lnpQfqtWQhKsvBLvwPT3AifiwUnT2QnE
74UJDS7SWH4d8XtBZmZb1bNvJfF7oWvPnH3XIph8b7hdnD6o+wX1H3jDfnF5
mvc6osu80b7hrU9NBoufN7in+rk6j75N/KsQ+Hn31zz2PVbB5Zzrkfohz4h/
Ffj6h15v/oHyX7UKh+0sChvtbhG/D4b2sFumf4/x++CG497yphSaTzIf2G67
7BX2mPqLygd31umfPFnO7PeF+P3+XkV8Fj9f8BrHZc5qIn/KfGG0UL1q/Xny
p8oX6o98g/p61j/80Kssouf5oaQv/CB+15RZNYPp7wcZd+7ZgqLdxK+jqwrL
01+x/uAPh+LcjmnZjN8friX13+J3M35/XPZpthPmElb548DWN36Cu4Q5fBwb
em//hTTKZy4fF3KGDdilYefxYRL2vJflUJLH50N8yHPu3pHtdD4f8ss7fU+Y
E1bwITMU41xPqm8VH0qz176hpef/wxo+OFY7bjpNvEnyA6D4JFhUElJA8gPQ
OW+y/NB78hcCwH/fYDwx/SjJD8AbqecML0MmPwA2bsHWVlOZ/AAMKh3RdnM6
YVUAhP7GewvnEtYEwGHZ1z4t2wlzAqEd7/Skvw/NT24g5Gtunrn+J9ERiFcH
e7SXXiHMD4Rz0RCFwy02bwIRcbUgwiWP+r0iEG5jut/knTxL8gOxIaE1Ym4t
kx+II66Gogqr5yQ/CJn2Nw56FJE/uEEQtVle19vF6jkI2v3iycqWKpIfhJWx
5lW9Y2tIfhBsOUPsV5qTvxVB4NQfHZgyjMU7CMEBSTV3Oym/NUFQj83YJNhH
/JxgONtMK71lw+IfjHd7X2++4UL6IRjtXb65X5cR5geD529TVXhdSfKDoXiS
Hb4ol+a/IhjpWXcORltTPaiCwc2wmD+nlbAmGNXSmw2WXsz+EIgtvxuiHcH8
HwL7uuHH+kuZ/BAIKhszevQhe/ghkJlGzCyexewPwYbNkcW136geFSHgPtWL
up1J+4oqBC8e7Dnz50Tm/xAE99ogefn/9RMKgylfxZPWkzxuKAIH24vSR5M/
EApB3afWjAVUz/xQfCpIG7E4is37UDQ07ODUM38pQpF/49S2cVNofqlCwZ+y
8dCdLoqPJhQHxkbtUrxm9R+G3O7tZW59KL7cMPS5/3BSzG5mfxgOLwivzXlc
TvLDMC5RdnVLKdFlYejyC40VZpD/FGHotDnuPqGEzcswWISlG+xcRfI0YRA9
P5MySsb2RwGmZf0rMH7I7BcgI2bij64trB8LcFhgNeTyoBckXwCOq2ufnfYU
T5kAO7oSv3dOIawQgM9Zesf8V/KXSgBF6/H6jk20j2kEsL5/+rce/tTPOeEQ
+B4be8mSzueG40allYPHToovwuEj6/z5xBXqB/xwRF35dUvtADYfwqE9fm6m
83jyjyIcwmHmtx1s6TxVOPr9NMO0y5rioQmHdGHLYkkd878Q+cFHtui7MvlC
ZGaF2ln6E4YQWeL6kdaFxM8XImmBrWHvIppnMiG6/pn057jDNO8VQnzamtTD
4B7lj0qIJyEL3rdsZf4XQpntpYqSsn1/NTiv6hvyu2h/467GiMxJzmml9D1W
Y8P+5rK1TeRf/mqkJNaOV+kx+1ejeni3INWDzlOsRueExwP757B5vxrqHh+n
vPiO8kuzGhW/PZuxI5bs40RAsH9xWj8LqhduBJwnTnWeXEbzDxEQORaM2ruN
5iU/Ao11WSPaW9h+E4GuybK1rQKqT0UE1KuEj2YnM/9H4EPNxduaNMKaCBRY
X5zMKWbyI6H0enKns5T8y42Ee7NHw7zTzP+ROGv00PBZBcs/3fc2XhFTtWy/
iQSnyLZcO5r6rSIS8AvKq0qjeaOKRJ3HGfOMdtpHNJHIXzKyrXYru99EIXdR
/lObR2QPNwqnC7eEbW1h8qMw33i7cKEd838Uhuq56p1sJbosClj3vuKIivX/
KERFzrg64xOzPwomont/ulxj/o9CV18zYdhitj9Go+CXtfnH7Mh/3GjwJ4qG
xSn/IvnRUOU927s2kOY/PxrK6E/5z2+x+RcN716TVtocZ/0vGm8Ou5beG/uS
5EfDtmb+wwEq6g+aaBh7Vn75dJPt3yLMMC73MfWg+jcSwejpA8PMStr/uSK0
+Q7+be5SykeeSNfPOrZv4tB9HyJ8qSy2GGdB88pNBI17R9fFgRQfvgjW+05l
n3AkfUQicCxe8r/GFJL+ItyZV7XZ34DochG0t+JWJxZR/ilE4NY/OH3yB3of
UIogaXLyP7KY2SeC7aLCYUkrqZ+oRVA+SZy6zJ3mqUaE6m7ZIPlz6h9aEfZc
njb7djbxc2Igvm0xRmRH89woBiPu5/oNySM6NwbqV/yqz8lkHy8G/CWXbT0i
qV6hw4d5Lr02kr5uMdi8e9bU1r5sXsag2tx344zj5A9RDDhHd/KmmG0m+2NQ
w/URmk2kepXHYEWOXZfdY8ofRQx4bxe2TTCmfqqMQWZE/O+OI1h/j4FPYb+H
edYUX7Xu/MoccV8zFu8Y3f61J0p0iupbGwN8qTi/3vYS2R+L+qvj92VcIflG
sVjxu9++/FVsHsTCfdAjO3iz+MfCu22DiayD7Sex0HO5d79yD/nLLRYeZZcu
LfmN5PNj8aU2etDfeXSeKBZmYf94hZ5i94NYqAY4qP/9nvqLPBbq5IFK5Svy
ryIWTbMuHVmwjs5XxqLAt0B4toXFPxYv/HNMi9j+qdadLy2fvduK7k+aWOQu
2dBSvYfmgzYWSftThm7+h8U/DsbDi3+8YEz1bRQHxyuB9Z/VLP5x8O45uW33
RtoXeHGQfTrQEaSvIvvj4DdmX8CfQ1+R/XEwad/2q30O2xfi0Pb746q/nSie
Ih3/uAbXl9FbyP44GJm1X+x+S/uTPA4Xbk1yGdDG5mkcNnzQyxFa0fnKOCR8
4LfWL2f9PQ6KqD6P63nUX9RxQIhTTJMj1YNGh4VFP25NJX21cXD+Mj4jqIzd
38WwqHXdaSOh/mWk291FI8oMmyjeXDG8G80ssz6w/BfjxStxsSCc3Q/EkElH
Dt6uovc3NzEcDjpPMTjC8l9Hb/7xp+gTdH8WiaHpN6XsYDDJl4mh8I6vfG5F
+4FcDA+95AWKJLbPinFq1FfD871IvlIM03dv2uw20PkqMbj6vJsHuuh9Qi2G
6E6FRX0L2aMRY0LZP+b1zH9aMXLDSx5KJrH3qXhUJMzdL+PT+UbxOB3nfYLX
wPaBePhY77rlfpr6Ay8enNFz3r4M20X2x8OhwPzlYCGLfzz4HqHNvhsOkv3x
UOnXJt2cTvJE8ej6+3mkoQndX2U6uktyafbww2R/PB5UdwY8c6T6UMRDqN1o
dfZniocyHiveWKnaX7D3gHhMCPy5fV4qnaeOhyT9SXprCumjiYeJ6az0cT/S
PqfV6X+GM7qzkb2vJUDr+4Nl+iCqN6MEmHRONdlbQf2Sm4CoR2VlfSRUX7wE
VJ6/NDg7me2nCVCNH9HH9SbNK7cEyMdsrfRzoPc5fgLO3cYxiZzqR5QAvDze
Yt7rNNmfANvpJdaRhRQveQK2qRd1F24i/RUJEHme8W5yPEX2J8DtiCSs9wf6
XpWAppiY7TO3Uj6qEyDYaPz37eukn0Ynv65UYbOM/KnV8feP48vSaV/gJKLz
9dC+bpHUT40SoTaMSfeuKCP7E6Fs7S7N7qTveYloHL33uZeW7EMics8FFg8W
U3zcEpG5/rD8Mdv/+Ym4vKpu3d1dZI8oEfJHxeW979D5skTw3uHRsOnkH3ki
jC5fO3BtAtmrSERoSUFaYAXZo0wEp6m4/5vdJWR/Ilw6vO2Pn2H2JyK/tFm7
mU/6aRLhIywVOl1j+Z+I4DbPBZvS2f6ThGPHlp68YE7zySgJdRkBgesHsn0k
Cecs67I7TWhf4SVB1UeqXnGP2a/jvyd1H1vK5n8Skio3dSl6vyb7k2D9fEiv
Q19o/oiSkLm95tHvVhQ/WRI0DXkmRrvJH/IkGFyJXDd5AslTJKFaf9THNhXp
o0yCOm/K0Q4vmreqJBQEJvK7jpF8dRLKpd2ftvYn+ZokmO2KcrvXn/Y7rY6f
t3aH11T2/4pk1DR5j+2bQ/VulIwZXvK/HxZRvnOTwRkV86ItkvzFS0bl0Afm
3QvZ+0AyRHqTpjfOI/+5JeOYQ9Kr7m8s/5NxbltGZco76m+iZMgu/TpvJ8s3
WTL016wrz7Og/JEn40GU19K5r9h9JhkGA3t4vp9K+4wyGfKSip57lOx+n4xB
5blNTsZkrzoZ1sfanTLdqR9rkjGgYvpvl4aTvtpknBpmF7ZlEnu/StHdP0T/
9htD/jFKwYG54pn+hlQv3BRYvl/XJQ1n8y8FFfahkTvl7L03Bdt2FLr5f6T8
dEvBNHHrCte7rP+nQFQLwdlM+l6kk+c+1/avT7Sfy1IgC1AOeHcih+zX0Zcc
/9Yoofml0PFvjJ7fNZjsU6bAQH10Q+4J8q8qBVF1OWbOHWz+pyD9Y/Upd0OS
p9GdF2S5Jye0iOxPQehzi2/PTek8TioyR30cv/cb239SIRu9bPm6doo3NxXn
CuZ92ymmeualAqNq/B/vI/2RiqGjjLb/fpb1/1RwnN592O7H9vVUmFjPTArQ
Y/tPKuTZkoCn3ux9OhVfNJ3FPAeiy1OhKi/SGmZSPShSoWy89rVJS/opU8EL
SJnlr2Lvyano/OyruF9M9aROhcv8acNC5rH81/E3jDo8cjb5S5sK0a4swSUh
m38SBHusL7V3pvw0kiAh6oSBNdvvuBJkaYN+SHKmfYQngfLM9QkfZxM/JIj6
d8KAf5aSPDcJdi2NPlzuyepfgi/v7i70DycskuBFmeHMsUmEZRKIbVeEflhL
WC7BIOeCwoINhBUScOaMzLu/mcVfp4/f6Oy43YRVErTOrqgqy2f5L8FE15YH
ngeY/RI4299u82FYK0FX7+rdDodZ/NPQtT7sy9DThI3SoG3PKO3LeUP2p6Fg
w9P1l0wJ89IwetpG98nmhJEGy5Fr/D5PI+yWhkaXCps8O8L8NOjNGSSpcCQs
SkPG1rFTnecTlqWh9adIp3VxhOVpqM6fP2ZmNmFFGiQda+QD9xBWpiHlZXHG
hQOEVWngznAVLjhHWJ0Gs7xbWefOE9akwXYu92vuJcLaNOw4Ye84rJowR4rM
vzLXl9wmbCRFvwC7ctvXzH4pVCuPWNZ9ZPZLUc03aLz2mdkvhd77vJd1P74l
+6UQXDrv1D2GMF+KfVc/OAqnEBZJ4TH9zKNTswnLpJD0vPLzEXvCcilsY85y
/EWEFVJ8UnwZXiMhrJRic5Rff/ONhFVSlNcIbb4yrJZCPujsM+dqwhop0vkT
vyQzrJXCUl/P5249Yc4aZL0IPjXzEWGjNci/tzBL1kyYuwYC0529ol8R5q2B
8H7/X1a9I4w1yB0b6ZOuw/8DxmQVAQ==
          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {583.2, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw1mHtczPn3xz/SIuxqbQhhkEskg5ak8tJGIUkipcune40uU033aYyEUG3u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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {972., -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw1mHtczPn3xz9oKXxXa0Pug1wiGbSEyksbhSSJlC6f7jW6TDXdpmmMhFBt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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {1360.8000000000002`, -118.66252583997979`}, 
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.4922359499621}]}, {
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw92HtcjPn7P/AbLcJntTaEMM4iGbQklZc2CslIpHS4O+gwOkw1nacxEkK1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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {194.4, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tcTIn7B/AjLcKu1oYQBrlEMmhJKh9tCMlIpHQ5XVRGl6mmmmoaR0Ko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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {583.2, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499621}], 
     InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tYTIn/B/CDlsKu1oYQBrlEMmhJKm9tFJKRSOlyutfoMtV0n8aREKrN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          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {972., -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{}, 
        {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw113tcTIn/BvAjLYXvam0IYZBLJIOWpPJoUUhGIqXL6V6jy1TTfRpHQqg2
96K1s7ms3BpCbjHZhEomEtJmUpL7rGJjxW9+r/2c/un17tNznvO8+mca5R/l
GqTHMExnD4b5/+//fWnnMOEPT5nOjp9DPwDj2b6EHbKZbADm8LqjAQG8jcAc
2yWcYraFbAxuXIPLq6itZBNwfsoB709mk03BjJ7z7lXIbrIAjOP7jzt89pBH
Q5X3fN86f95m4ARzzxUU8R4H5vczt4er95EnQJWwPS9j82/kiWCqqp+IKxRk
Cyg+hy4uCSogW4J1C2723niILITKOak0a/gR8lQwFq/Yr9GF5GkQ1D88c+r7
o+TpUKkrXGf9ydsK7IcG44lpx8g/QSUaYF0cdZw8A5oSw39ql54kzwTX/MOP
USd5W4MJsNybHVxEngWhr01V4Q0l2QZa7+8t0wadIs8Gu/SKrVsEb1tI0tpr
thTxtgPWDT9w8B5ve6iTBiqVr3nPAfO6viG/izdgdOX6wesTTv9nDpC4n/Vs
mkdm5kKyv2TkLWEx3eeCOcuM7mwkMw7AqxMt5r3O0N0Bkhdnk0dxZ+n+MxQ9
w4497CJzP4Mpsi3Xjj5H93kQ9Y9luTQyp/OY7rd5p/j7fChbu0uzOvn7fDBN
xf3f7imh+wKw+offbPn+PN0XgHl7qKR1HJlxhKrZ7nifafzdEdzMa58ObOPv
ToBPQF5V6gW66zyqxvfJfjKzEEqzN97Bpfx9IRjXubZ/fubvi8BO6dixmblI
90VQC9ft9JhKZhZDsaj41sjT/F3np1lhi3Mv0d0Z6g2v3IYcI3POMDJrv9T9
jr8vAb5UXNhge5nuSyDQF9462FVKdxdIyvo1bflK5lygOHKq/ruEK3RfCu7z
wY4AfRXdlwLioh+2pZAZEVTlRVrDjLL/DBE0DXkmRnvInAhqw+g0zwqySoSc
x8Xlve+SmWVgJ0qGxSr/pPwyqMaP6ONyi8wtg/bE+ZlO48spvwy5Sze2VO8l
M644sjCsNvsJGa54GOmxbO5rMueK0ANLUvtZXKe8KwTP9CLvZJCZ5bq/z95I
yWkylkOQu2HfvXdkbjmsXwzpdfgLn9f5eLtjhmsF5d0QavU8f8VmMtzAyUcO
3qEiczqzfr1WTb5BeTeo86Yc6/AgMytwc96+8qZkMlaAPSJ07rWJzK2A9nbs
moQiPr8CThOnOk0u4/MrIZFmBT92uUn5ldD0m1J2KJDMrYTTl/HpAWVk1Uow
VjtvOU68RXl3GAzs4f5hKhnuUD5NmLrclcy5I8P+5iG3IrLKHZyZbVXPvpWU
X4XEhbaGvYvIWAV1j09TXn5XRflVyO3eUSbqQ1atgiKyz5N6IZnxgInk/h/O
18nwgPaAdLKyhc97QPhuUdsE42rKeyC07nNr+kIy4wmoXlyIW0OGJ0zat/9i
n03mPMEyy+6a/8LnPSFsHJcxq4nPr4ZqgIP6n//dpvxqHLGzKGy0I3OrIZlX
MGrfdrJqNTjT8JnFs2oo74VVMeZVvWPI8MLNSisHt11kzgvqsembQ/eTVV7o
+utFhKHJHcp7Q3C6n4vTaDK8McH/p/b5KWTOG8b5T0YmTVNT3hvKhlFHRs4m
Mz7IGbOt0seBDB/klzZrt7BkzgcG6mMbc0/yeR+o+sjVK+/zeV80jt73wkPL
531x3CHxdfc3Pu+L3LCSR7JJtZT3hdQ4+/7AKWSGhUq/NvHWdLKAhZm8fPYe
KzJYKM/emPBpNpllkXkvclfVKjLHQrI7M/SymKxg0Z4W3jezgO9joa/injcr
yRoWQr/kWb4qvt8PD4+aOWPWXer3A4Ico5vmkeEH28WFwxJXkVk/WD8482sP
XzLnB2bpiW+NMrLCD+0b33nVpJNVfrh5+EL52WH3qN8P+TdPbx83hcz4I2PD
kZwnvAX+6PfjDNMuazL8oX8zOiHChcz643zB/G+7pGTOH5nS+pHWhWSFP5Qe
T+92lpJV/jg4VzrT17CO+v3xsLrT7/k8MhOA83WlCpvlZEEAJjQ4y2NYMgJg
FvK3R/BpMhuAOrez5untZC4A0jsWYyR296k/AG5Pfk/x9SerAuBlvfu26xmy
JgBORUMUDrfJTCBst1/xCHlCFgQi3autJriZjEAoPOMqX1jVU38gOj8WC8Jn
kLlABLptKLV3IisCdZ8P3JfkryKrdPnWE/Udm8maQJzfnl6Z/J7MBEE07MQr
j9EPqD8IGTtqHv9mRUYQzj/6FP4mkcwGwaLWZZeNjMwF4eb96eybXWRFEMKv
FYQ755FVQbCdXmIdUUjWBKH89rKSbafITDA6//VWPCjm+4OB9R8qjqr4/mBI
7lZY1Lfw/cEQHZWF9P7I9+s8ZG31nskPqT8YJuOCFq10JquCcbPLIfPYBrIm
GEbPHhpmVJKZEMzzmZZU0U0WhEDz/srQmd89ov4Q5DZH1G/eSmZDYLRIvXrD
BTIXAi+u86eTV8mKEJh0TjXZV0FWhaC6mxuU84KsCUHn/Mk5hz+QmVBoXDu6
Lg1soP5QHD++7NRFczJCIdGbNL1xPpkNRee79iG9XclcKKqHd4emuJEVoVBm
eagi5WRVKKwKmtl3v5M1ut8399404wSZCUOn8HsBd5vvD4O6JPZQey3fHwal
jUf4VC3fHwbb3lNL1r7n+8MgtfxuiHbEY+oPA1OZLe1rRlaFwauw36M8a7JG
l6/9uenGYjIjhna849P+XmSBGF0+wTHidDLEcCu7fHnpr2RWjMCz//w7o4jM
iWFbs+DRABXfLwZnKMX5no3Ur7szQ+xXmZM1YpjUpIXscCQzayBYvizB3pcs
WAM3vaSFikQy1kBy7+fNl34hs2tg7F755fMtMqf7/SfhQabNZMUa3efRTYfv
dvH9a2BiOitt3A9/Ub/uvpbd/klOZsKRob/8VkM9WRCO9OiJP7i0kBEO0aXp
g7pfktlwMKOiX7ZFNFF/OALb3BduTiMrwpG/dGRb7TayKhyht5KOxdaRNeHg
Ri9fsb6dzETAbHek6H7/J9Qfofv/RPJPvzFkRICbc3144AIyq7sfEJgIM8hc
BLr+nvTHuCNkRQQEK61WCRvIqgjkLs5/ZvOYrIlAY13miPYWMhMJbWG+vHig
hvojob92fXmeBRmREGs3WZ37icxGos178K9zl5G5SHBJB/uWupEVkXAd9NgO
nmRVJCxC0gx2rSZrIrFA4WztKyYzUfhckDpiSSTfH4Xc8/7Fg6V8fxSeBi38
0LKN74+CyS733rISvj8KIzImOaWW8v1RkC9qWSKr4/ujoP7EGtTX8/1RuJZ/
qXfaI75fgvOSEWWGTWQjCQ6OjdyteMO/jwT7LTxb4j6QhRIYmM/Nb+QNCT4+
q1v3YzdZJMGgDpufYk2a6X0lMAl50ctyKFkigfA9Hg+bTuYksPywvkseRs6R
wLPn5LY9m8gK3fvdwXFZDlkpwZnbnqx1PlklgXGV4avtJWS1BFJVYXnaa7JG
gsBeG2WveGt1z7Osy+o0eUr7o+E/2F6SNppsFA2DqxHrJ08gC6LhZDOt9LYN
WRiNrr5m4pAlZEQjJ0vm98yTLIrG8aH3D1xMJbPR0D/v11GaTZZE42KgaXe/
UjIXjc/bEnsY3CfnRON9To+9Pg1kRTQyV1SlJjeSldFokqHrbc8W2h+NtE/V
p10NyepoWNinT/q7L1kTDdMOE2/GiKyNRrxnwM7DJmQmBhnhcb/NG0E2isHp
YXYhWyeRBTFIiw+8vkhIFsYg/X/CX8PsyIiBLFB5Nc6BLIrB/grW96UbmY1B
55uhfUURZEkMuMu/zN/Fm4uBpBah5zLIOTGosA+O2JVDVsTAs9ekVTYnyMoY
fG9weuWWYn6/7vk2J1wnlPD7Y3B3vf6pU+X8/hhs3BJRXPuN3x+D7cUT2hy+
a6X9sTAeXvzDRWOyUSzkvb/7fYqALIhFWubdQ1HWZGEsFhjvEC+yIyMWjItL
n132ZFEsMrUB3yc6kdlYSD8c6FXEkiWx2NmV8D+nZDIXiwHPQiOuZ5FzYjFu
jEdoSg5ZEYtr75RzAgvIylic6ZelLTxBVsVi44HmsnVNZHUsBOkWC+a0kjWx
uHh7kvOANrI2FqdHfTW80OsZ7ZfCS6TQP9aPbCTFl8pii3EWZIEUFfFzD3As
WSiF+jVb9W8SGVJI2ixv6O0mi6Rov1b7Kk1BZqUo8E9gu46TJVIYHQ5fb6wk
c1Icvy93HVtKzpEiObfjwuxaskKKlW+tVO0vyUop4iNPGlh3kFVSeLZtNOF4
q3VuNLPM/EjW6J6XUDtepddG+6Woy031SutDZuIQefWXrbUDyEZxqBF4ic0m
kgVxkCVXHLwzmSyMQ/xHtrV+BRlx6No7Z//1cLIoDvZLylM915PZOPj/u+dr
Hm9JHDonPBnYP5vMxaH+2vj96VfJOXEY2sNuuf59siIOysbrX5u0ZGUcAv0S
a+51klVxyBj1afy+b2R1HEIrG9N79HlO++NQl+7nv2EgWRsH5/MuR+uHkJl4
9CoL73lhKNkoHkz9sYHJw8iCeEjfN2VUzSAL41Hw87r843ZkxKNrMreuNZQs
isfL19Li0DAyGw+H4tyOaVlkSTyaoqN3zNxG5uLhUlL/LW4POSceV7ya7cS5
ZEU8ckoqeu5VkpXxcO7wtD9xlqyKR7X+qE9tKrI6Hge3vfUJvcfvj8fF7GED
dmv4/fF4K3ef4WHYTvsTMKBi+q+Xh5ONEiA97D5330iyIAE5V3Z5nzQnCxPw
0jfbtIg3dH649+wfE8miBNiIAq2tppLZBAwqHdF2azpZkgCxr/G+wrlkLgGV
Qx+ady8i5yQg8nFZWR8ZWZEAh+Vf+7TsICt177P21tkbf5BVCZjhkfPXoyKy
OgGvD/VoL71K1iRAGfU5/8VtsjYBG+Nbw+fW8vsTEVmXbebUwe9PhIn1zEQ/
vRe0PxFb9sya2tqXLEzEURdDSYUVGYn4ouksFjqQRYl4v+/NlpvOZDYRDQ07
mXrekkS0d3nnfl1O5hIxw7jcy9SNnJOIavmtBksPsiIRK3/z2Z+/mqxMROWF
y4OzksiqRNjXDT/eX05WJ8JgylfppA1kTSJM379ts9tI1iaiz4NHk6L3kJkk
fKmNGvRXHtkoCQ6HnKYYHOX3J2FcAndtaym/PwnBJQWp/hX8/iSEbjL+684N
fn8SpklbV7rc4/frnPlPqPEjfn8Stu8sFPl+4vcn4Uio1ZArg17Sft3zvI+P
vWxJViRBPMz8joMtWZmEtt+eVP3lSFYlIT/w6FZ9F7I6CRmZwXaWvmRNEip+
fT5jZwxZmwT1avHj2UlkJhkfay7d0aSSjZJR0+Q5tm82WZCMAutLk5lisjAZ
rs1uDfPPkJGMc0aPDJ9XkEXJOBPreVLYQGaTsTLbrsvuCVmiuxduDdnWQuaS
MVTPRe9UK78/GZERM67N+MzvT8bd+VVbfA1e0f5kvD3iUnp/LFmVDOv9p7NO
ziOrkyFrcvQ9uoSsSUbTrMtHF64na5Ox98q02XeyyEwKRjzI9RmSRzZKgZ7z
/QeVe8mCFMy76l//r5osTEGBd4H4XAsZKUg8kDx0y99kUQp8xuz3+2Poa9qf
go0f9bLFVmRJCiaU/W1ez5tLgUOB+avBYnJOCmRpT9Nak8mKFGxXL+4u3ExW
puDK6rr193aTVSkYOspox2/nyOoUeIlLxY7XyRrd+1Vu7lL0fkP7U1Au7/68
rT+ZkWFQeW6TozHZSAbJpqgFXYPJAhmCX1h8e2FKFsrgvGDasKD5ZMgQ+c+E
AX8vI4tk2L0s6ki5O5mV4cv7e4t8w8gSGV6WGc4cm0jmZJDargz+uI6co3sf
p4LCgo1khQzMnJF5D7aQlTJk+ozOit1DVsnQOruiqiyfrJZhokvLQ/eDZI0M
TvZ32rx4a3UfnntX73E4wu9PRdeGkC9Dz/D7U6FtTy/ty7yl/ako2Phsw2VT
sjAVo6dtcp1sTkYqLEeu9fl3GlmUikbnCps8OzKbCr05g2QV88iSVKRvGzvV
aQGZS0XrjxGO62PJOamozl8wZmYWWZEKWcfanIF7ycpUJL8qTr94kKxKhWCG
i3jhebI6FWZ5tzPPXyBrUmE7V/A19zJZm4qdJ+3nDasmM3Jk/JmxoeQO2UiO
fn525bZv+P1yqFYdtaz7xO+Xo5o1aLz+L79fDr0Pea/qfnhH++UIvXzBsXsM
mZVj/7WP88RTyBI53KaffXx6NpmTQ9bz6k9H7ck5cthGn2N8JWSFHJ8VX4bX
yMhKObZE+vQ330RWyVFeI7b5ylstR86gc8+dqskaOdLYiV+SeGvlsNTX87pX
T2bWIvNl4OmZj8lGa5F/f1Em10wWrEWo6a5eUa/JwrUQP+j/8+r3ZKxF7tgI
rzSd/w8xHhUB
          "]]}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesOrigin->{0, 0},
       PlotRange->{{0., 500.}, {0., 0.998353176613068}},
       PlotRangeClipping->True,
       PlotRangePadding->{
         Scaled[0.02], 
         Scaled[0.02]}], {1360.8000000000002`, -355.98757751993935`}, 
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.4922359499621}]}}, {}},
  
  ContentSelectable->True,
  ImageSize->{469.072540314237, Automatic},
  PlotRangePadding->{6, 5}]], "Figure",
 Deletable->False,
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["7", "ChapterN"],

Cell[CellGroupData[{

Cell["Recursion", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Fibonacci numbers", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "For each of the following sequences of numbers, see if you can deduce the \
pattern and write a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function to compute the general term."
}], "ExerciseItem",
 CellTags->"7.1 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     StyleBox[
      RowBox[{"2", ","}], "OsF"], 
     StyleBox[
      RowBox[{"3", ","}], "OsF"], 
     StyleBox[
      RowBox[{"6", ","}], "OsF"], 
     StyleBox[
      RowBox[{"18", ","}], "OsF"], 
     StyleBox[
      RowBox[{"108", ","}], "OsF"], 
     StyleBox[
      RowBox[{"1944", ","}], "OsF"], 
     StyleBox[
      RowBox[{"209952", ","}], "OsF"], "\[Ellipsis]"},
    {
     SubscriptBox["A", "1"], 
     SubscriptBox["A", "2"], 
     SubscriptBox["A", "3"], 
     SubscriptBox["A", "4"], 
     SubscriptBox["A", "5"], 
     SubscriptBox["A", "6"], 
     SubscriptBox["A", "7"], "\[Ellipsis]"}
   }], TraditionalForm]]]], "ExerciseSubItem",
 CellTags->"7.1 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     StyleBox[
      RowBox[{"0", ","}], "OsF"], 
     StyleBox[
      RowBox[{"1", ","}], "OsF"], 
     StyleBox[
      RowBox[{
       RowBox[{"-", "1"}], ","}], "OsF"], 
     StyleBox[
      RowBox[{"2", ","}], "OsF"], 
     StyleBox[
      RowBox[{
       RowBox[{"-", "3"}], ","}], "OsF"], 
     StyleBox[
      RowBox[{"5", ","}], "OsF"], 
     StyleBox[
      RowBox[{
       RowBox[{"-", "8"}], ","}], "OsF"], 
     StyleBox[
      RowBox[{"13", ","}], "OsF"], 
     StyleBox[
      RowBox[{
       RowBox[{"-", "21"}], ","}], "OsF"], "\[Ellipsis]"},
    {
     SubscriptBox["B", "1"], 
     SubscriptBox["B", "2"], 
     SubscriptBox["B", "3"], 
     SubscriptBox["B", "4"], 
     SubscriptBox["B", "5"], 
     SubscriptBox["B", "6"], 
     SubscriptBox["B", "7"], 
     SubscriptBox["B", "8"], 
     SubscriptBox["B", "9"], "\[Ellipsis]"}
   }], TraditionalForm]]]], "ExerciseSubItem",
 CellTags->"7.1 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     StyleBox[
      RowBox[{"0", ","}], "OsF"], 
     StyleBox[
      RowBox[{"1", ","}], "OsF"], 
     StyleBox[
      RowBox[{"2", ","}], "OsF"], 
     StyleBox[
      RowBox[{"3", ","}], "OsF"], 
     StyleBox[
      RowBox[{"6", ","}], "OsF"], 
     StyleBox[
      RowBox[{"11", ","}], "OsF"], 
     StyleBox[
      RowBox[{"20", ","}], "OsF"], 
     StyleBox[
      RowBox[{"37", ","}], "OsF"], 
     StyleBox[
      RowBox[{"68", ","}], "OsF"], 
     StyleBox["\[Ellipsis]", "OsF"]},
    {
     SubscriptBox["C", "1"], 
     SubscriptBox["C", "2"], 
     SubscriptBox["C", "3"], 
     SubscriptBox["C", "4"], 
     SubscriptBox["C", "5"], 
     SubscriptBox["C", "6"], 
     SubscriptBox["C", "7"], 
     SubscriptBox["C", "8"], 
     SubscriptBox["C", "9"], "\[Ellipsis]"}
   }], TraditionalForm]]]], "ExerciseSubItem",
 CellTags->"7.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The numbers ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["FA",
     FontSlant->"Italic"], "n"], TraditionalForm]]],
 " represent the number of additions that are done in the course of \
evaluating the Fibonacci function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["F", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " defined in this section."
}], "ExerciseItem",
 CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      StyleBox["0", "OsF"], 
      StyleBox["0", "OsF"], 
      StyleBox["1", "OsF"], 
      StyleBox["2", "OsF"], 
      StyleBox["4", "OsF"], 
      StyleBox["7", "OsF"], 
      StyleBox["12", "OsF"], 
      StyleBox["20", "OsF"], 
      StyleBox["33", "OsF"], 
      StyleBox["\[Ellipsis]", "OsF"]},
     {
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "1"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "2"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "3"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "4"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "5"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "6"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "7"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "8"], 
      SubscriptBox[
       StyleBox["FA", "ExerciseTI"], "9"], "\[Ellipsis]"}
    }], TraditionalForm]]]
}], "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  StyleBox["FA", "ExLink"]]],
 " such that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    StyleBox["FA", "ExLink"], 
    StyleBox["[", "ExLink"], 
    StyleBox["n", "ExerciseTI"], 
    StyleBox["]", "ExLink"]}], 
   StyleBox["=", "ExLink"], 
   StyleBox[
    SubscriptBox[
     StyleBox["FA", "ExerciseTI"], 
     StyleBox["n", "TI",
      FontFamily->"DTL Albertina TOT Italic",
      FontSize->9]], "ExLink"]}]]],
 "."
}], "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A faster approach to computing Fibonacci numbers uses various identities \
associated with these numbers (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"The Fibonacci Sequence 2011\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"HaskellWiki\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"The\",\nFontSlant->\"Italic\"]\)\!\(\*\n\
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Fibonacci\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"sequence\",\nFontSlant->\"Italic\"]\). The Haskell Programming \
Language. See `1`", 
         Hyperlink[
         "http://www.haskell.org/haskellwiki/The_Fibonacci_sequence", 
          "http://www.haskell.org/haskellwiki/The_Fibonacci_sequence"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "). We start the base case at ",
 StyleBox["0", "OsF"],
 " instead of ",
 StyleBox["1", "OsF"],
 " here. The notation ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftFloor]", 
    StyleBox["number", "ExerciseTI"], "\[RightFloor]"}], TraditionalForm]]],
 " represents the floor of ",
 StyleBox["number",
  FontSlant->"Italic"],
 ". You can use ",
 Cell[BoxData[
  ButtonBox["IntegerPart",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/IntegerPart"]]],
 "."
}], "ExerciseItem",
 CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     RowBox[{
      SubscriptBox["f", "0"], "=", 
      StyleBox["0", "OsF"]}]},
    {
     RowBox[{
      SubscriptBox["f", "1"], "=", 
      StyleBox["1", "OsF"]}]}
   }], TraditionalForm]]]], "ExerciseDisplayFormula",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{"="}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}}},
 CellTags->"7.1 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox["f", "n"], "=", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           RowBox[{"f", "[", "k", "]"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", "[", "k", "]"}], "+", 
             RowBox[{
              StyleBox["2", "OsF"], 
              RowBox[{"f", "[", 
               RowBox[{"k", "-", 
                StyleBox["1", "OsF"]}], "]"}]}]}]}]}], 
          RowBox[{
           RowBox[{"n", " ", "even"}], ",", " ", 
           RowBox[{"k", "=", 
            RowBox[{"\[LeftFloor]", 
             RowBox[{"n", "/", 
              StyleBox["2", "OsF"]}], "\[RightFloor]"}]}]}]},
         {
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               StyleBox["2", "OsF"], 
               RowBox[{"f", "[", "k", "]"}]}], "+", 
              RowBox[{"f", "[", 
               RowBox[{"k", "-", 
                StyleBox["1", "OsF"]}], "]"}]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               StyleBox["2", "OsF"], 
               RowBox[{"f", "[", "k", "]"}]}], "-", 
              RowBox[{"f", "[", 
               RowBox[{"k", "-", 
                StyleBox["1", "OsF"]}], "]"}]}], ")"}]}], "+", 
           StyleBox["2", "OsF"]}], 
          RowBox[{
           RowBox[{
            RowBox[{"n", " ", "mod", " ", 
             StyleBox["4", "OsF"]}], "=", 
            StyleBox["1", "OsF"]}], ",", " ", 
           RowBox[{"k", "=", 
            RowBox[{"\[LeftFloor]", 
             RowBox[{
              StyleBox["n", "TR"], 
              StyleBox["/", "OsF"], 
              StyleBox["2", "OsF"]}], 
             StyleBox["\[RightFloor]", "OsF"]}]}]}]},
         {
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               StyleBox["2", "OsF"], 
               RowBox[{"f", "[", "k", "]"}]}], "+", 
              RowBox[{"f", "[", 
               RowBox[{"k", "-", 
                StyleBox["1", "OsF"]}], "]"}]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               StyleBox["2", "OsF"], 
               RowBox[{"f", "[", "k", "]"}]}], "-", 
              RowBox[{"f", "[", 
               RowBox[{"k", "-", 
                StyleBox["1", "OsF"]}], "]"}]}], ")"}]}], "-", 
           StyleBox["2", "OsF"]}], "otherwise"}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], TraditionalForm]]]], "ExerciseDisplayFormula",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{"="}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}}},
 CellTags->"7.1 Exercises"],

Cell[TextData[{
 "Implement this algorithm. Consider using ",
 Cell[BoxData[
  ButtonBox["Which",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Which"]]],
 " for the different conditions."
}], "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The Fibonacci sequence can also be defined for negative integers using the \
following formula (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Graham, Knuth, and Patashnik 1994\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Graham\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Ronald\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\)\
\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Donald\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"E\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Knuth\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\) \
and \!\(\*\nStyleBox[\"Oren\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Patashnik\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1994.\", \"OsF\"]\) \!\(\*\n\
StyleBox[\"Concrete\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Mathematics\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\":\",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"A\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Foundation\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\
\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"for\",\nFontSlant->\"Italic\"]\)\
\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\n\
StyleBox[\"Computer\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Science\",\nFontSlant->\"Italic\"]\
\), second edition. Addison-Wesley."], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "):"
}], "ExerciseItem",
 CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["F", 
     RowBox[{"-", "n"}]], "=", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", 
        StyleBox["1", "OsF"]}], ")"}], 
      RowBox[{"n", "-", "1"}]], 
     SubscriptBox["F", "n"]}]}], TraditionalForm]]]
}], "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],

Cell["The first few terms are ", "ExerciseText",
 CellTags->"7.1 Exercises"],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      StyleBox["0", "OsF"], 
      StyleBox["1", "OsF"], 
      StyleBox[
       RowBox[{"-", "1"}], "OsF"], 
      StyleBox["2", "OsF"], 
      StyleBox[
       RowBox[{"-", "3"}], "OsF"], 
      StyleBox["5", "OsF"], 
      StyleBox[
       RowBox[{"-", "8"}], "OsF"], 
      StyleBox["13", "OsF"], 
      StyleBox[
       RowBox[{"-", "21"}], "OsF"], "\[Ellipsis]"},
     {
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], "0"], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "1"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "2"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "3"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "4"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "5"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "6"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "7"}]], 
      SubscriptBox[
       StyleBox["F",
        FontSlant->"Italic"], 
       RowBox[{"-", "8"}]], "\[Ellipsis]"}
    }], TraditionalForm]]]
}], "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],

Cell["\<\
Write the definitions for Fibonacci numbers with negative integer arguments.\
\>", "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
The key here is to get the stopping conditions right in each case.\
\>", "SolutionItem",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell["\<\
This is a straightforward recursion, multiplying the previous two values to \
get the next.\
\>", "SolutionSubItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "[", "1", "]"}], ":=", "2"}], "\n", 
 RowBox[{
  RowBox[{"a", "[", "2", "]"}], ":=", "3"}], "\n", 
 RowBox[{
  RowBox[{"a", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"i", "-", "1"}], "]"}], " ", 
   RowBox[{"a", "[", 
    RowBox[{"i", "-", "2"}], "]"}]}]}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"a", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "6", ",", "18", ",", "108", ",", "1944", ",", "209952", 
   ",", "408146688"}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The sequence is obtained by taking the difference of the previous two values.\
\
\>", "SolutionSubItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "1", "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"b", "[", "2", "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"b", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"b", "[", 
    RowBox[{"i", "-", "2"}], "]"}], "-", 
   RowBox[{"b", "[", 
    RowBox[{"i", "-", "1"}], "]"}]}]}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"b", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "2", ",", 
   RowBox[{"-", "3"}], ",", "5", ",", 
   RowBox[{"-", "8"}], ",", "13", ",", 
   RowBox[{"-", "21"}]}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here we add the previous three values.", "SolutionSubItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"c", "[", "1", "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "2", "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "3", "]"}], ":=", "2"}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"i", "-", "3"}], "]"}], "+", 
   RowBox[{"c", "[", 
    RowBox[{"i", "-", "2"}], "]"}], "+", 
   RowBox[{"c", "[", 
    RowBox[{"i", "-", "1"}], "]"}]}]}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"c", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "2", ",", "3", ",", "6", ",", "11", ",", "20", ",", 
   "37", ",", "68"}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["It is important to get the two base cases right here.", "SolutionItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FA", "[", "1", "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"FA", "[", "2", "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"FA", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"FA", "[", 
    RowBox[{"i", "-", "2"}], "]"}], "+", 
   RowBox[{"FA", "[", 
    RowBox[{"i", "-", "1"}], "]"}], "+", "1"}]}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"FA", ",", 
   RowBox[{"Range", "[", "9", "]"}]}], "]"}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "2", ",", "4", ",", "7", ",", "12", ",", "20",
    ",", "33"}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "It is interesting to note that the number of additions needed to compute \
the ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th Fibonacci number is one less than the ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th Fibonacci number itself. As the Fibonacci numbers grow, so too does the \
computation!"
}], "SolutionText",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fibonacci", "/@", 
  RowBox[{"Range", "[", "9", "]"}]}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34"}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This is a direct implementation of the traditional mathematical notation \
given in the exercise. Avoiding the double recursion of the naive \
implementation reduces the memory required and speeds things up \
significantly, although it is still too slow for large numbers.\
\>", "SolutionItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"fib", ",", "f"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "0", "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "1", "]"}], "=", "1"}], ";"}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fib", "[", 
   RowBox[{"n_Integer", "?", "Positive"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k", "=", 
      RowBox[{"IntegerPart", "[", 
       RowBox[{"n", "/", "2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"EvenQ", "[", "n", "]"}], ",", 
      RowBox[{
       RowBox[{"fib", "[", "k", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"fib", "[", "k", "]"}], "+", 
         RowBox[{"2", 
          RowBox[{"fib", "[", 
           RowBox[{"k", "-", "1"}], "]"}]}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"n", ",", "4"}], "]"}], "\[Equal]", "1"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"fib", "[", "k", "]"}]}], "+", 
          RowBox[{"fib", "[", 
           RowBox[{"k", "-", "1"}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"fib", "[", "k", "]"}]}], "-", 
          RowBox[{"fib", "[", 
           RowBox[{"k", "-", "1"}], "]"}]}], ")"}]}], "+", "2"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"fib", "[", "k", "]"}]}], "+", 
          RowBox[{"fib", "[", 
           RowBox[{"k", "-", "1"}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"fib", "[", "k", "]"}]}], "-", 
          RowBox[{"fib", "[", 
           RowBox[{"k", "-", "1"}], "]"}]}], ")"}]}], "-", "2"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "@", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"fib", "[", "i", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "40"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.023411000000000293`", ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", 
     "21", ",", "34", ",", "55", ",", "89", ",", "144", ",", "233", ",", 
     "377", ",", "610", ",", "987", ",", "1597", ",", "2584", ",", "4181", 
     ",", "6765", ",", "10946", ",", "17711", ",", "28657", ",", "46368", ",",
      "75025", ",", "121393", ",", "196418", ",", "317811", ",", "514229", 
     ",", "832040", ",", "1346269", ",", "2178309", ",", "3524578", ",", 
     "5702887", ",", "9227465", ",", "14930352", ",", "24157817", ",", 
     "39088169", ",", "63245986", ",", "102334155"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "You can use your earlier definition of the Fibonacci numbers, or use the \
built-in ",
 Cell[BoxData[
  ButtonBox["Fibonacci",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fibonacci"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"n_Integer", "?", "NonPositive"}], "]"}], ":=", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{"n", "-", "1"}]], 
   RowBox[{"Fibonacci", "[", 
    RowBox[{"-", "n"}], "]"}]}]}]], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "0", "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"-", "1"}], "]"}], "=", "1"}], ";"}]}], "InputOnly",
 CellTags->"7.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"-", "8"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"7.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "2", ",", 
   RowBox[{"-", "3"}], ",", "5", ",", 
   RowBox[{"-", "8"}], ",", "13", ",", 
   RowBox[{"-", "21"}]}], "}"}]], "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Thinking recursively", "ExerciseSubsection"],

Cell["\<\
Create a recursive function to reverse the elements in a flat list.\
\>", "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell["\<\
Create a recursive function to transpose the elements of two lists. Write an \
additional rule to transpose the elements of three lists.\
\>", "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[TextData[{
 "Write a recursive function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["sumOddElements", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that adds up only the elements of the list ",
 Cell[BoxData[
  FormBox[
   StyleBox["lis", "ExerciseTI"], TraditionalForm]]],
 " that are odd integers. ",
 Cell[BoxData[
  FormBox[
   StyleBox["lis", "ExerciseTI"], TraditionalForm]]],
 " may contain even integers and nonintegers."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[TextData[{
 "Write a recursive function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["sumEveryOtherElement", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that adds up ",
 Cell[BoxData[
  RowBox[{
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["[", "ExLink"], 
   StyleBox[
    RowBox[{"[", "1", "]"}], "ExLink"], 
   StyleBox["]", "ExLink"]}]]],
 ", ",
 Cell[BoxData[
  RowBox[{
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["[", "ExLink"], 
   StyleBox[
    RowBox[{"[", "3", "]"}], "ExLink"], 
   StyleBox["]", "ExLink"]}]]],
 ", ",
 Cell[BoxData[
  RowBox[{
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["[", "ExLink"], 
   StyleBox[
    RowBox[{"[", "5", "]"}], "ExLink"], 
   StyleBox["]", "ExLink"]}]]],
 ", etc. Each of these elements is a number. ",
 Cell[BoxData[
  FormBox[
   StyleBox["lis", "ExerciseTI"], TraditionalForm]]],
 " may have any number of elements."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"addTriples", "[", 
    RowBox[{
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "1"], ",", 
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "2"], ",", 
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "3"]}], "]"}], "ExLink"]]],
 " that is like ",
 Cell[BoxData[
  StyleBox["addPairs", "ExLink"]]],
 " in that it adds up the corresponding elements of the three equal-length \
lists of numbers."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["multAllPairs", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["lis", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that multiplies every consecutive pair of integers in the numerical list \
",
 Cell[BoxData[
  FormBox[
   StyleBox["lis", "ExerciseTI"], TraditionalForm]]],
 ". Add a rule that issues an appropriate warning message if the user \
supplies a list with an odd number of elements."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"multAllPairs", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "9", ",", "17", ",", "2", ",", "6", ",", "60"}], "}"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"7.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"27", ",", "153", ",", "34", ",", "12", ",", "360"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"7.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Write the function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"maxPairs", "[", 
    RowBox[{
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "1"], ",", 
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "2"]}], "]"}], "ExLink"]]],
 " which, for numerical lists of equal length, returns a list of the larger \
value in each corresponding pair."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"riffle", "[", 
    RowBox[{
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "1"], ",", 
     SubscriptBox[
      StyleBox["lis", "ExerciseTI"], "2"]}], "]"}], "ExLink"]]],
 ", which merges two lists of equal length, can be defined as follows:"
}], "ExerciseItem",
 CellTags->{"7.2 Exercises", "i:5"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"riffle", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"lis1", ",", "lis2"}], "}"}], "]"}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"7.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riffle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"7.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "x", ",", "b", ",", "y", ",", "c", ",", "z"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"7.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Rewrite ",
 StyleBox["riffle", "MR", "ExLink"],
 " using recursion."
}], "ExerciseText",
 CellTags->"7.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["maxima", "MR", "ExLink"],
 " can also be computed more efficiently with an auxiliary function."
}], "ExerciseItem",
 CellTags->"7.2 Exercises"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"maxima", "[", 
   RowBox[{"x", ",", 
    RowBox[{"{", "r", "}"}]}], "]"}]}]}], "ExerciseInput", "ExerciseMR",
 Evaluatable->False,
 CellTags->"7.2 Exercises"],

Cell[TextData[{
 "The two-argument version has this meaning: ",
 Cell[BoxData[
  RowBox[{
   StyleBox["maxima", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["lis", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " gives the maxima of the list ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Join", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    RowBox[{
     StyleBox["{", "ExLink"], 
     StyleBox["x", "ExerciseTI"], 
     StyleBox["}", "ExLink"]}], 
    StyleBox[",", "ExLink"], 
    StyleBox["lis", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 ". Define it. (Hint: the key point about this is that ",
 Cell[BoxData[
  RowBox[{
   StyleBox["maxima", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["lis", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " is equal to ",
 Cell[BoxData[
  RowBox[{
   StyleBox["maxima", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    RowBox[{
     StyleBox["Rest", "ExLink"], 
     StyleBox["[", "ExLink"], 
     StyleBox["lis", "ExerciseTI"], 
     StyleBox["]", "ExLink"]}]}], 
   StyleBox["]", "ExLink"]}]]],
 "if ",
 Cell[BoxData[
  RowBox[{
   StyleBox["x", "ExerciseTI"], 
   StyleBox["\[GreaterEqual]", "ExLink"], 
   RowBox[{
    StyleBox["First", "ExLink"], 
    StyleBox["[", "ExLink"], 
    StyleBox["lis", "ExerciseTI"], 
    StyleBox["]", "ExLink"]}]}]]],
 ".) Compare its efficiency with the version in the text."
}], "ExerciseText",
 CellTags->"7.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Write recursive definitions for ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]]],
 ", ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]]],
 ", and ",
 Cell[BoxData[
  ButtonBox["NestList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestList"]]],
 "."
}], "ExerciseItem",
 CellTags->{"7.2 Exercises", "i:6"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "This is similar to the ",
 Cell[BoxData["length"]],
 " function in the text \[Dash] recursion is on the tail. The base case is a \
list consisting of a single element."
}], "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"reverse", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y__"}], "}"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"reverse", "[", 
     RowBox[{"{", "y", "}"}], "]"}], ",", 
    RowBox[{"{", "x", "}"}]}], "]"}]}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"reverse", "[", 
   RowBox[{"{", "x_", "}"}], "]"}], ":=", 
  RowBox[{"{", "x", "}"}]}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"reverse", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "\[Beta]", ",", 
    RowBox[{"3", "/", "4"}], ",", "\"\<practice makes perfect\>\""}], "}"}], 
  "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"practice makes perfect\"\>", ",", 
   FractionBox["3", "4"], ",", "\[Beta]", ",", "1"}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Recursion is on the tails of the two lists, here denoted ",
 Cell[BoxData["r1"]],
 " and ",
 Cell[BoxData["r2"]],
 "."
}], "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"transpose", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1_", ",", "r1__"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x2_", ",", "r2__"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}], "}"}], ",", 
    RowBox[{"transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "r1", "}"}], ",", 
       RowBox[{"{", "r2", "}"}]}], "}"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"transpose", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "x_", "}"}], ",", 
     RowBox[{"{", "y_", "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "}"}]}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"transpose", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["x", "2"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["y", "1"], ",", 
      SubscriptBox["y", "2"]}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["y", "1"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["y", "2"]}], "}"}]}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"transpose", "[", "%", "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["y", "1"], ",", 
     SubscriptBox["y", "2"]}], "}"}]}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recursion is on the tail.", "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sumOddElements", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"sumOddElements", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"x", "+", 
    RowBox[{"sumOddElements", "[", 
     RowBox[{"{", "r", "}"}], "]"}]}], "/;", 
   RowBox[{"OddQ", "[", "x", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"sumOddElements", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"sumOddElements", "[", 
   RowBox[{"{", "r", "}"}], "]"}]}]}], "InputOnly",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumOddElements", "[", 
  RowBox[{"{", 
   RowBox[{
   "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", "12", ",", 
    "13"}], "}"}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData["37"], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Again, recursion is on the tail.", "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sumEveryOtherElement", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{"sumEveryOtherElement", "[", 
   RowBox[{"{", "x_", "}"}], "]"}], ":=", "x"}], "\n", 
 RowBox[{
  RowBox[{"sumEveryOtherElement", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"x", "+", 
   RowBox[{"sumEveryOtherElement", "[", 
    RowBox[{"{", "r", "}"}], "]"}]}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumEveryOtherElement", "[", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
    ",", "9"}], "}"}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData["25"], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a direct extension of the ",
 Cell[BoxData["addPairs"]],
 " function discussed in this section."
}], "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"addTriples", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"addTriples", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1_", ",", "y1___"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x2_", ",", "y2___"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x3_", ",", "y3___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", "+", "x2", "+", "x3"}], "}"}], ",", 
    RowBox[{"addTriples", "[", 
     RowBox[{
      RowBox[{"{", "y1", "}"}], ",", 
      RowBox[{"{", "y2", "}"}], ",", 
      RowBox[{"{", "y3", "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"addTriples", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["w", "1"], ",", 
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["y", "1"], ",", 
     SubscriptBox["z", "1"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["w", "2"], ",", 
     SubscriptBox["x", "2"], ",", 
     SubscriptBox["y", "2"], ",", 
     SubscriptBox["z", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["w", "3"], ",", 
     SubscriptBox["x", "3"], ",", 
     SubscriptBox["y", "3"], ",", 
     SubscriptBox["z", "3"]}], "}"}]}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["w", "1"], "+", 
    SubscriptBox["w", "2"], "+", 
    SubscriptBox["w", "3"]}], ",", 
   RowBox[{
    SubscriptBox["x", "1"], "+", 
    SubscriptBox["x", "2"], "+", 
    SubscriptBox["x", "3"]}], ",", 
   RowBox[{
    SubscriptBox["y", "1"], "+", 
    SubscriptBox["y", "2"], "+", 
    SubscriptBox["y", "3"]}], ",", 
   RowBox[{
    SubscriptBox["z", "1"], "+", 
    SubscriptBox["z", "2"], "+", 
    SubscriptBox["z", "3"]}]}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Multiply successive pairs with one element overlap.", "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"multAllPairs", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"multAllPairs", "[", 
   RowBox[{"{", "_", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"multAllPairs", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", " ", "y"}], "}"}], ",", 
    RowBox[{"multAllPairs", "[", 
     RowBox[{"{", 
      RowBox[{"y", ",", "r"}], "}"}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"multAllPairs", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "9", ",", "17", ",", "2", ",", "6", ",", "60"}], "}"}], 
  "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"27", ",", "153", ",", "34", ",", "12", ",", "360"}], 
  "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Recursion is on the tails of each of the two lists.", "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxPairs", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"maxPairs", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "r___"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y_", ",", "s___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Max", "[", 
      RowBox[{"x", ",", "y"}], "]"}], "}"}], ",", 
    RowBox[{"maxPairs", "[", 
     RowBox[{
      RowBox[{"{", "r", "}"}], ",", 
      RowBox[{"{", "s", "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"maxPairs", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "7", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "7", ",", "4"}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Again, we do recursion on the tails of the two lists.", "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"riffle", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"riffle", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "r___"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y_", ",", "s___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], ",", 
    RowBox[{"riffle", "[", 
     RowBox[{
      RowBox[{"{", "r", "}"}], ",", 
      RowBox[{"{", "s", "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riffle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "x", ",", "b", ",", "y", ",", "c", ",", "z"}], 
  "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],

Cell["Here is the built-in function that does this.", "SolutionText",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riffle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "x", ",", "b", ",", "y", ",", "c", ",", "z"}], 
  "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is ",
 Cell[BoxData["maxima"]],
 " using an auxiliary function."
}], "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"maxima", "[", 
   RowBox[{"x", ",", 
    RowBox[{"{", "r", "}"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"x_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "x", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"x_", ",", 
    RowBox[{"{", 
     RowBox[{"y_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"maxima", "[", 
    RowBox[{"x", ",", 
     RowBox[{"{", "r", "}"}]}], "]"}], "/;", 
   RowBox[{"x", "\[GreaterEqual]", "y"}]}]}], "\n", 
 RowBox[{
  RowBox[{"maxima", "[", 
   RowBox[{"x_", ",", 
    RowBox[{"{", 
     RowBox[{"y_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{"maxima", "[", 
     RowBox[{"y", ",", 
      RowBox[{"{", "r", "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, here is the definition for our user-defined ",
 Cell[BoxData["fold"]],
 "."
}], "SolutionItem",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fold", "[", 
   RowBox[{"f_", ",", "x_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "x"}], "\n", 
 RowBox[{
  RowBox[{"fold", "[", 
   RowBox[{"f_", ",", "x_", ",", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"fold", "[", 
   RowBox[{"f", ",", 
    RowBox[{"f", "[", 
     RowBox[{"x", ",", "a"}], "]"}], ",", 
    RowBox[{"{", "r", "}"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fold", "[", 
  RowBox[{"Plus", ",", "0", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}]}], 
  "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"a", "+", "b", "+", "c", "+", "d", "+", "e"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"foldList", "[", 
   RowBox[{"f_", ",", "x_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", "x", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"foldList", "[", 
   RowBox[{"f_", ",", "x_", ",", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{"foldList", "[", 
     RowBox[{"f", ",", 
      RowBox[{"f", "[", 
       RowBox[{"x", ",", "a"}], "]"}], ",", 
      RowBox[{"{", "r", "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"foldList", "[", 
  RowBox[{"Times", ",", "1", ",", 
   RowBox[{"Range", "[", "6", "]"}]}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "6", ",", "24", ",", "120", ",", "720"}], 
  "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "And here is ",
 Cell[BoxData["nestList"]],
 "."
}], "SolutionText",
 CellTags->"7.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nestList", "[", 
   RowBox[{"f_", ",", "x_", ",", "0"}], "]"}], ":=", 
  RowBox[{"{", "x", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"nestList", "[", 
   RowBox[{"f_", ",", "x_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{"nestList", "[", 
     RowBox[{"f", ",", 
      RowBox[{"f", "[", "x", "]"}], ",", 
      RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}]}], "Input",
 CellTags->"7.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nestList", "[", 
  RowBox[{"Sin", ",", "\[Theta]", ",", "3"}], "]"}]], "Input",
 CellTags->"7.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\[Theta]", ",", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"Sin", "[", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], "]"}], ",", 
   RowBox[{"Sin", "[", 
    RowBox[{"Sin", "[", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}], "]"}], "]"}]}], "}"}]], "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dynamic programming", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "An Eulerian number, denoted ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    TagBox[GridBox[{
       {
        TagBox[
         FormBox["n",
          TraditionalForm],
         TraditionalForm,
         Editable->True]},
       {
        TagBox[
         FormBox["k",
          TraditionalForm],
         TraditionalForm,
         Editable->True]}
      },
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"], "\[RightAngleBracket]"}], TraditionalForm]]],
 ", gives the number of permutations with ",
 StyleBox["k", "ExerciseTI"],
 " increasing runs of elements. For example, for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", "3"}], TraditionalForm]]],
 " the permutations of {",
 StyleBox["1,2,3", "OsF"],
 "} contain four increasing runs of length ",
 StyleBox["1", "OsF"],
 ", namely {",
 StyleBox["1,3,2", "OsF"],
 "}, {",
 StyleBox["2,1,3", "OsF"],
 "}, ",
 StyleBox["{2,3,1}", "OsF"],
 ", and {",
 StyleBox["3,1,2", "OsF"],
 "}. Hence, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     TagBox[GridBox[{
        {
         TagBox[
          FormBox[
           StyleBox["3", "OsF"],
           TraditionalForm],
          TraditionalForm,
          Editable->True]},
        {
         TagBox[
          FormBox[
           StyleBox["1", "OsF"],
           TraditionalForm],
          TraditionalForm,
          Editable->True]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"], "\[RightAngleBracket]"}], "=", 
    StyleBox["4", "OsF"]}], TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:9", "7.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Permutations", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"7.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"7.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "This can be programmed using the following recursive definition (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Graham, Knuth, and Patashnik 1994\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Graham\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Ronald\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\)\
\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Donald\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"E\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Knuth\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\) \
and \!\(\*\nStyleBox[\"Oren\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Patashnik\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1994.\", \"OsF\"]\) \!\(\*\n\
StyleBox[\"Concrete\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Mathematics\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\":\",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"A\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Foundation\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\
\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"for\",\nFontSlant->\"Italic\"]\)\
\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\n\
StyleBox[\"Computer\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Science\",\nFontSlant->\"Italic\"]\
\), second edition. Addison-Wesley."], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "), where ",
 StyleBox["n", "ExerciseTI"],
 " and ",
 StyleBox["k", "ExerciseTI"],
 " are assumed to be integers:"
}], "ExerciseText",
 CellTags->"7.3 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      TagBox[GridBox[{
         {
          TagBox[
           FormBox["n",
            TraditionalForm],
           TraditionalForm,
           Editable->True]},
         {
          TagBox[
           FormBox["k",
            TraditionalForm],
           TraditionalForm,
           Editable->True]}
        },
        GridBoxAlignment->{"Columns" -> {{Left}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Column"], "\[RightAngleBracket]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"k", "+", "1"}], ")"}], 
       RowBox[{"\[LeftAngleBracket]", 
        TagBox[GridBox[{
           {
            TagBox[
             FormBox[
              RowBox[{"n", "-", "1"}],
              TraditionalForm],
             TraditionalForm,
             Editable->True]},
           {
            TagBox[
             FormBox["k",
              TraditionalForm],
             TraditionalForm,
             Editable->True]}
          },
          GridBoxAlignment->{"Columns" -> {{Center}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"], "\[RightAngleBracket]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "-", "k"}], ")"}], 
       RowBox[{"\[LeftAngleBracket]", 
        TagBox[GridBox[{
           {
            TagBox[
             FormBox[
              RowBox[{"n", "-", 
               StyleBox["1", "OsF"]}],
              TraditionalForm],
             TraditionalForm,
             Editable->True]},
           {
            TagBox[
             FormBox[
              RowBox[{"k", "-", 
               StyleBox["1", "OsF"]}],
              TraditionalForm],
             TraditionalForm,
             Editable->True]}
          },
          GridBoxAlignment->{"Columns" -> {{Center}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"], "\[RightAngleBracket]"}]}]}]}], ",", " ", 
    RowBox[{
     RowBox[{"for", " ", "n"}], ">", 
     StyleBox["0", "OsF"]}]}], TraditionalForm]]],
 ","
}], "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"\[LeftAngleBracket]", 
    TagBox[GridBox[{
       {
        TagBox[
         FormBox[
          StyleBox["0", "OsF"],
          TraditionalForm],
         TraditionalForm,
         Editable->True]},
       {
        TagBox[
         FormBox["k",
          TraditionalForm],
         TraditionalForm,
         Editable->True]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"], "\[RightAngleBracket]"}], "=", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          StyleBox["1", "OsF"], 
          RowBox[{"k", "=", 
           StyleBox["0", "OsF"]}]},
         {
          StyleBox["0", "OsF"], 
          RowBox[{"k", "\[NotEqual]", 
           StyleBox["0.", "OsF"]}]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["EulerianNumber", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["n", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["k", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 ". You can check your work against Table ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["NumberedTable", "Table.Eulerian numbers"], "OsF"],
 " which displays the first few Eulerian numbers."
}], "ExerciseText",
 CellTags->"7.3 Exercises"],

Cell[CellGroupData[{

Cell["Eulerian number triangle", "NumberedTable",
 CellTags->{"Table.Eulerian numbers", "7.3 Exercises"}],

Cell[BoxData[
 StyleBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["0", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["1", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["2", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["3", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["4", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["5", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["6", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["7", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm], 
       TagBox[
        RowBox[{"\[LeftAngleBracket]", 
         TagBox[GridBox[{
            {"n"},
            {
             StyleBox["8", "OsF"]}
           },
           GridBoxAlignment->{"Columns" -> {{Left}}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
          "Column"], "\[RightAngleBracket]"}],
        HoldForm]},
      {
       TagBox[
        StyleBox["0", "OsF"],
        HoldForm], 
       StyleBox["1", 
        "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["1",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", 
        "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["2",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", 
        "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>"},
      {
       StyleBox[
        TagBox["3",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["4", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", 
        "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["4",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["11", "OsF"], 
       StyleBox["11", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["5",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["26", "OsF"], 
       StyleBox["66", "OsF"], 
       StyleBox["26", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", "OsF"], "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["6",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["57", "OsF"], 
       StyleBox["302", "OsF"], 
       StyleBox["302", "OsF"], 
       StyleBox["57", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", "OsF"], "\<\"\"\>", "\<\"\"\>"},
      {
       StyleBox[
        TagBox["7",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["120", "OsF"], 
       StyleBox["1191", "OsF"], 
       StyleBox["2416", "OsF"], 
       StyleBox["1191", "OsF"], 
       StyleBox["120", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", "OsF"], "\<\"\"\>"},
      {
       StyleBox[
        TagBox["8",
         HoldForm], "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["247", "OsF"], 
       StyleBox["4293", "OsF"], 
       StyleBox["15619", "OsF"], 
       StyleBox["15619", "OsF"], 
       StyleBox["4293", "OsF"], 
       StyleBox["247", "OsF"], 
       StyleBox["1", "OsF"], 
       StyleBox["0", "OsF"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Bottom}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.5]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$, TableHeadings -> {{0, 1, 2, 3, 4, 5, 6, 7, 8}, {
        $CellContext`e[$CellContext`n, 0], 
        $CellContext`e[$CellContext`n, 1], 
        $CellContext`e[$CellContext`n, 2], 
        $CellContext`e[$CellContext`n, 3], 
        $CellContext`e[$CellContext`n, 4], 
        $CellContext`e[$CellContext`n, 5], 
        $CellContext`e[$CellContext`n, 6], 
        $CellContext`e[$CellContext`n, 7], 
        $CellContext`e[$CellContext`n, 8]}}, 
     TableAlignments -> {Center, Bottom}, TableSpacing -> {1.25, 1}]]], 
  "ExerciseText",
  StripOnInput->False,
  SingleLetterItalics->True]], "DisplayTable",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"7.3 Exercises"]
}, Closed]],

Cell["\<\
Because of the triple recursion, you will find it necessary to use a dynamic \
programming implementation to compute any Eulerian numbers of even modest \
size. \
\>", "ExerciseText",
 CellTags->"7.3 Exercises"],

Cell["\<\
Hint: Although the above formulas will compute it, you can add the following \
rule to simplify some of the computation:\
\>", "ExerciseText",
 CellTags->"7.3 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     TagBox[GridBox[{
        {
         TagBox[
          FormBox["n",
           TraditionalForm],
          TraditionalForm,
          Editable->True]},
        {
         TagBox[
          FormBox["k",
           TraditionalForm],
          TraditionalForm,
          Editable->True]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"], "\[RightAngleBracket]"}], "=", 
    StyleBox["0", "OsF"]}], ",", " ", 
   RowBox[{
    RowBox[{"for", " ", "k"}], "\[GreaterEqual]", "n"}]}], 
  TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Using dynamic programming is one way to speed up the computation of the \
Fibonacci numbers, but another is to use a different algorithm. A much more \
efficient algorithm is based on the following identities.\
\>", "ExerciseItem",
 CellTags->"7.3 Exercises"],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{
       SubscriptBox["F", "1"], "=", 
       StyleBox["1", "OsF"]}]},
     {
      RowBox[{
       SubscriptBox["F", "2"], "=", 
       StyleBox["1", "OsF"]}]},
     {
      RowBox[{
       RowBox[{
        SubscriptBox["F", 
         RowBox[{"2", "n"}]], "=", 
        RowBox[{
         RowBox[{
          StyleBox["2", "OsF"], 
          SubscriptBox["F", 
           RowBox[{"n", "-", "1"}]], 
          SubscriptBox["F", "n"]}], "+", 
         SubsuperscriptBox["F", "n", "2"]}]}], ",", "  ", 
       RowBox[{
        RowBox[{"for", " \[MediumSpace]\[MediumSpace]", "n"}], 
        "\[GreaterEqual]", 
        StyleBox["1", "OsF"]}]}]},
     {
      RowBox[{
       RowBox[{
        SubscriptBox["F", 
         RowBox[{
          RowBox[{"2", "n"}], "+", "1"}]], "=", 
        RowBox[{
         SubsuperscriptBox["F", 
          RowBox[{"n", "+", "1"}], "2"], "+", 
         SubsuperscriptBox["F", "n", "2"]}]}], ",", "          ", 
       RowBox[{
        RowBox[{"for", "  \[MediumSpace]\[MediumSpace]", "n"}], 
        "\[GreaterEqual]", 
        StyleBox["1", "OsF"]}]}]}
    }], TraditionalForm]]]
}], "ExerciseDisplayFormula",
 ZeroWidthTimes->True,
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{"="}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}}},
 CellTags->"7.3 Exercises"],

Cell["\<\
Program a Fibonacci number generating function using these identities.\
\>", "ExerciseText",
 CellTags->"7.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "You can still speed up the code for generating Fibonacci numbers in the \
previous exercise by using dynamic programming. Do so, and construct tables \
like those in this section, giving the number of additions performed for \
various ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " by the two programs you have just written."
}], "ExerciseItem",
 CellTags->"7.3 Exercises"],

Cell[TextData[{
 "Calculation of the Collatz numbers, as described in Exercise ",
 StyleBox["6", "OsF"],
 " from Section ",
 StyleBox["6.2", "OsF"],
 ", can be implemented using recursion and sped up by using dynamic \
programming. Using recursion and dynamic programming, create the function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["collatz", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["n", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["i", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 ", which computes the ",
 StyleBox["i",
  FontSlant->"Italic"],
 "th iterate of the Collatz sequence starting with integer ",
 StyleBox["n",
  FontSlant->"Italic"],
 ". Compare its speed with that of your original solution."
}], "ExerciseItem",
 CellTags->{"7.3 Exercises", "Ex.Collatz", "i:16"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
Here are the rules translated directly from the formulas given in the \
exercise.\
\>", "SolutionItem",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EulerianNumber", "[", 
    RowBox[{"0", ",", "k_"}], "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EulerianNumber", "[", 
    RowBox[{"n_Integer", ",", "0"}], "]"}], "=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EulerianNumber", "[", 
     RowBox[{"n_Integer", ",", "k_Integer"}], "]"}], "/;", 
    RowBox[{"k", "\[GreaterEqual]", "n"}]}], "=", "0"}], ";"}]}], "InputOnly",\

 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EulerianNumber", "[", 
   RowBox[{"n_Integer", ",", "k_Integer"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "+", "1"}], ")"}], 
    RowBox[{"EulerianNumber", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "k"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"n", "-", "k"}], ")"}], 
    RowBox[{"EulerianNumber", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", 
      RowBox[{"k", "-", "1"}]}], "]"}]}]}]}]], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"EulerianNumber", "[", 
     RowBox[{"n", ",", "k"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "7"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0", ",", "7"}], "}"}]}], "]"}], "//", 
  "TableForm"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "1", "0", "0", "0", "0", "0", "0"},
    {"1", "4", "1", "0", "0", "0", "0", "0"},
    {"1", "11", "11", "1", "0", "0", "0", "0"},
    {"1", "26", "66", "26", "1", "0", "0", "0"},
    {"1", "57", "302", "302", "57", "1", "0", "0"},
    {"1", "120", "1191", "2416", "1191", "120", "1", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell["\<\
Because of the triple recursion, computing larger values is not only time and \
memory intensive but also bumps up against the built-in recursion limit.\
\>", "SolutionText",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"EulerianNumber", "[", 
   RowBox[{"25", ",", "15"}], "]"}], "//", "Timing"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"18.458478`", ",", "531714261368950897339996"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "This is a good candidate for dynamic programming. In the following \
implementation we have temporarily reset the value of ",
 Cell[BoxData[
  ButtonBox["$RecursionLimit",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/$RecursionLimit"]], "InlineFormula"],
 " using ",
 Cell[BoxData[
  ButtonBox["Block",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Block"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "EulerianNumber", "]"}], ";"}]], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EulerianNumber", "[", 
    RowBox[{"0", ",", "k_"}], "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EulerianNumber", "[", 
    RowBox[{"n_Integer", ",", "0"}], "]"}], "=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EulerianNumber", "[", 
     RowBox[{"n_Integer", ",", "k_Integer"}], "]"}], "/;", 
    RowBox[{"k", "\[GreaterEqual]", "n"}]}], "=", "0"}], ";"}]}], "InputOnly",\

 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EulerianNumber", "[", 
   RowBox[{"n_Integer", ",", "k_Integer"}], "]"}], ":=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"$RecursionLimit", "=", "Infinity"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EulerianNumber", "[", 
      RowBox[{"n", ",", "k"}], "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"k", "+", "1"}], ")"}], 
       RowBox[{"EulerianNumber", "[", 
        RowBox[{
         RowBox[{"n", "-", "1"}], ",", "k"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "-", "k"}], ")"}], 
       RowBox[{"EulerianNumber", "[", 
        RowBox[{
         RowBox[{"n", "-", "1"}], ",", 
         RowBox[{"k", "-", "1"}]}], "]"}]}]}]}]}], "]"}]}]], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"EulerianNumber", "[", 
   RowBox[{"25", ",", "15"}], "]"}], "//", "Timing"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.002529999999993038`", ",", "531714261368950897339996"}], 
  "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EulerianNumber", "[", 
    RowBox[{"600", ",", "65"}], "]"}], ";"}], "//", "Timing"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3851319999999987`", ",", "Null"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"EulerianNumber", "[", 
   RowBox[{"600", ",", "65"}], "]"}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData["4.99814710204916063085997018086950402091392578524497`15.\
954589770191005*^1091"], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This implementation uses the identities given in the exercise together with \
some pattern matching for the even and odd cases.\
\>", "SolutionItem",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"F", "[", "1", "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"F", "[", "2", "]"}], ":=", "1"}]}], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"F", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"F", "[", 
     RowBox[{
      FractionBox["n", "2"], "-", "1"}], "]"}], " ", 
    RowBox[{"F", "[", 
     FractionBox["n", "2"], "]"}]}], "+", 
   SuperscriptBox[
    RowBox[{"F", "[", 
     FractionBox["n", "2"], "]"}], "2"]}]}], "\n", 
 RowBox[{
  RowBox[{"F", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"F", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"n", "-", "1"}], "2"], "+", "1"}], "]"}], "2"], "+", 
   SuperscriptBox[
    RowBox[{"F", "[", 
     FractionBox[
      RowBox[{"n", "-", "1"}], "2"], "]"}], "2"]}]}]}], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"F", ",", 
   RowBox[{"Range", "[", "10", "]"}]}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"F", "[", 
    SuperscriptBox["10", "4"], "]"}], ";"}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.43854000000000326`", ",", "Null"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The use of dynamic programming speeds up the computation by several orders of \
magnitude.\
\>", "SolutionItem",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FF", "[", "1", "]"}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{"FF", "[", "2", "]"}], ":=", "1"}]}], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FF", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"FF", "[", "n", "]"}], "=", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"FF", "[", 
      RowBox[{
       FractionBox["n", "2"], "-", "1"}], "]"}], " ", 
     RowBox[{"FF", "[", 
      FractionBox["n", "2"], "]"}]}], "+", 
    SuperscriptBox[
     RowBox[{"FF", "[", 
      FractionBox["n", "2"], "]"}], "2"]}]}]}], "\n", 
 RowBox[{
  RowBox[{"FF", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"FF", "[", "n", "]"}], "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"FF", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"n", "-", "1"}], "2"], "+", "1"}], "]"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"FF", "[", 
      FractionBox[
       RowBox[{"n", "-", "1"}], "2"], "]"}], "2"]}]}]}]}], "InputOnly",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"FF", ",", 
   RowBox[{"Range", "[", "10", "]"}]}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"FF", "[", 
    SuperscriptBox["10", "5"], "]"}], ";"}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.001024000000001024`", ",", "Null"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "This is fairly fast, even compared with the built-in ",
 Cell[BoxData[
  ButtonBox["Fibonacci",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fibonacci"]], "InlineFormula"],
 " which uses a method based on the binary digits of ",
 StyleBox["n",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Fibonacci", "[", 
    SuperscriptBox["10", "5"], "]"}], ";"}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0002750000000020236`", ",", "Null"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Recursion is on the tail of the iterator ",
 StyleBox["i", "TI"],
 "."
}], "SolutionItem",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", ",", "0"}], "]"}], ":=", "n"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", ",", "i_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"collatz", "[", 
      RowBox[{"n", ",", "i"}], "]"}], "=", 
     FractionBox[
      RowBox[{"collatz", "[", 
       RowBox[{"n", ",", 
        RowBox[{"i", "-", "1"}]}], "]"}], "2"]}], ")"}], "/;", 
   RowBox[{"EvenQ", "[", 
    RowBox[{"collatz", "[", 
     RowBox[{"n", ",", 
      RowBox[{"i", "-", "1"}]}], "]"}], "]"}]}]}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", ",", "i_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"collatz", "[", 
      RowBox[{"n", ",", "i"}], "]"}], "=", 
     RowBox[{
      RowBox[{"3", 
       RowBox[{"collatz", "[", 
        RowBox[{"n", ",", 
         RowBox[{"i", "-", "1"}]}], "]"}]}], "+", "1"}]}], ")"}], "/;", 
   RowBox[{"OddQ", "[", 
    RowBox[{"collatz", "[", 
     RowBox[{"n", ",", 
      RowBox[{"i", "-", "1"}]}], "]"}], "]"}]}]}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[TextData[{
 "Here is the fifth iterate of the Collatz sequence for ",
 StyleBox["27", "OsF"],
 "."
}], "SolutionText",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"collatz", "[", 
  RowBox[{"27", ",", "5"}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData["31"], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is the Collatz sequence for ",
 StyleBox["27", "OsF"],
 ". This sequence takes a while to settle down to the cycle ",
 StyleBox["4", "OsF"],
 ", ",
 StyleBox["2", "OsF"],
 ", ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"7.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"collatz", "[", 
    RowBox[{"27", ",", "i"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", "114"}], "}"}]}], "]"}]], "Input",
 CellTags->"7.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "27", ",", "82", ",", "41", ",", "124", ",", "62", ",", "31", ",", "94", 
   ",", "47", ",", "142", ",", "71", ",", "214", ",", "107", ",", "322", ",", 
   "161", ",", "484", ",", "242", ",", "121", ",", "364", ",", "182", ",", 
   "91", ",", "274", ",", "137", ",", "412", ",", "206", ",", "103", ",", 
   "310", ",", "155", ",", "466", ",", "233", ",", "700", ",", "350", ",", 
   "175", ",", "526", ",", "263", ",", "790", ",", "395", ",", "1186", ",", 
   "593", ",", "1780", ",", "890", ",", "445", ",", "1336", ",", "668", ",", 
   "334", ",", "167", ",", "502", ",", "251", ",", "754", ",", "377", ",", 
   "1132", ",", "566", ",", "283", ",", "850", ",", "425", ",", "1276", ",", 
   "638", ",", "319", ",", "958", ",", "479", ",", "1438", ",", "719", ",", 
   "2158", ",", "1079", ",", "3238", ",", "1619", ",", "4858", ",", "2429", 
   ",", "7288", ",", "3644", ",", "1822", ",", "911", ",", "2734", ",", 
   "1367", ",", "4102", ",", "2051", ",", "6154", ",", "3077", ",", "9232", 
   ",", "4616", ",", "2308", ",", "1154", ",", "577", ",", "1732", ",", "866",
    ",", "433", ",", "1300", ",", "650", ",", "325", ",", "976", ",", "488", 
   ",", "244", ",", "122", ",", "61", ",", "184", ",", "92", ",", "46", ",", 
   "23", ",", "70", ",", "35", ",", "106", ",", "53", ",", "160", ",", "80", 
   ",", "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", "4", 
   ",", "2", ",", "1", ",", "4", ",", "2", ",", "1"}], "}"}]], "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Classical examples", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Modify one of the ",
 Cell[BoxData[
  StyleBox["runEncode", "ExLink"]]],
 " functions so that it produces output in the same form as the built-in ",
 Cell[BoxData[
  ButtonBox["Split",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Split"]]],
 " function."
}], "ExerciseItem",
 CellTags->"7.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Split", "[", 
  RowBox[{"{", 
   RowBox[{
   "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "4", ",", "3", ",", "3", 
    ",", "3", ",", "3", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",",
     "5"}], "}"}], "]"}]], "ExerciseInput",
 CellTags->"7.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"9", ",", "9", ",", "9", ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5"}], "}"}]}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"7.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A slightly more efficient version of ",
 Cell[BoxData[
  StyleBox["runEncode", "ExLink"]]],
 " uses a three-argument auxiliary function."
}], "ExerciseItem",
 CellTags->"7.4 Exercises"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", " ", "r___"}], "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"runEncode", "[", 
   RowBox[{"x", ",", " ", "1", ",", " ", 
    RowBox[{"{", "r", "}"}]}], "]"}]}]}], "ExerciseInput", "ExerciseMR",
 Evaluatable->False,
 CellTags->"7.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{
   StyleBox["runEncode", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["k", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    RowBox[{
     StyleBox["{", "ExLink"], 
     StyleBox["r", "ExerciseTI"], 
     StyleBox["}", "ExLink"]}]}], 
   StyleBox["]", "ExLink"]}]]],
 " computes the compressed version of ",
 Cell[BoxData[
  RowBox[{
   StyleBox["{", "ExLink"], 
   RowBox[{
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["\[Ellipsis]", "ExLink"], 
    StyleBox[",", "ExLink"], 
    StyleBox["x", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["r", "ExerciseTI"]}], 
   StyleBox["}", "ExLink"]}]]],
 ", where the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 "s are given ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " times. Define this three-argument function. Using the ",
 Cell[BoxData[
  ButtonBox["Timing",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Timing"]]],
 " function, compare the efficiency of this version with our earlier version; \
be sure to try a variety of examples, including lists that have many short \
runs and ones that have fewer, but longer runs. Use ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]]],
 " to generate lists long enough to see any difference in speed."
}], "ExerciseText",
 CellTags->"7.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Write the function ",
 Cell[BoxData[
  StyleBox["runDecode", "ExLink"]]],
 ", which takes an encoded list produced by ",
 Cell[BoxData[
  StyleBox["runEncode", "ExLink"]]],
 " and returns its unencoded form."
}], "ExerciseItem",
 CellTags->"7.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"runDecode", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"9", ",", "5"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "6"}], "}"}]}], "}"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"7.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "4", ",", "3", ",", "3", 
   ",", "3", ",", "3", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", 
   "5"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"7.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  StyleBox["MergeSort", "ExLink"]]],
 " function defined in this section becomes quite slow for moderately sized \
lists. Perform some experiments to determine if the bottleneck is caused \
mostly by the auxiliary ",
 Cell[BoxData[
  StyleBox["merge", "ExLink"]]],
 " function or the double recursion inside ",
 Cell[BoxData[
  StyleBox["MergeSort", "ExLink"]]],
 " itself. Once you have identified the cause of the problem, try to rewrite ",
 Cell[BoxData[
  StyleBox["MergeSort", "ExLink"]]],
 " to overcome the bottleneck issues."
}], "ExerciseItem",
 CellTags->"7.4 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Perhaps the most straightforward way to do this is to write an auxiliary \
function that takes the output from ",
 Cell[BoxData["runEncode"]],
 " and produces output such as ",
 Cell[BoxData[
  ButtonBox["Split",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Split"]], "InlineFormula"],
 " would generate."
}], "SolutionItem",
 CellTags->"7.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", "x_", "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"x", ",", " ", "1"}], "}"}], "}"}]}]}], "InputOnly",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "res___"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"R", "=", 
       RowBox[{"runEncode", "[", 
        RowBox[{"{", "res", "}"}], "]"}]}], ",", "p"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"First", "[", "R", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"x", "\[Equal]", 
        RowBox[{"First", "[", "p", "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{
             RowBox[{
             "p", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "+",
              "1"}]}], "}"}], "}"}], ",", 
         RowBox[{"Rest", "[", "R", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"x", ",", "1"}], "}"}], "}"}], ",", "R"}], "]"}]}], 
      "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"7.4 Solutions"],

Cell[TextData[{
 "Then our ",
 Cell[BoxData["split"]],
 " simply operates on the output of ",
 Cell[BoxData["runEncode"]],
 ". The iterator for the ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " is the second element in each sublist, that is, the frequency."
}], "SolutionText",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sp", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "}"}]}], "]"}], "&"}], ",", "lis"}], 
   "]"}]}]], "InputOnly",
 CellTags->"7.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sp", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "5"}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"7.4 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"split", "[", "lis_", "]"}], ":=", 
  RowBox[{"sp", "[", 
   RowBox[{"runEncode", "[", "lis", "]"}], "]"}]}]], "InputOnly",
 CellTags->"7.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"split", "[", 
  RowBox[{"{", 
   RowBox[{
   "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "4", ",", "3", ",", "3", 
    ",", "3", ",", "3", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",",
     "5"}], "}"}], "]"}]], "Input",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"9", ",", "9", ",", "9", ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"7.4 Solutions"]
}, Closed]],

Cell["Check against the built-in function.", "SolutionText",
 CellTags->"7.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Split", "[", 
  RowBox[{"{", 
   RowBox[{
   "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "4", ",", "3", ",", "3", 
    ",", "3", ",", "3", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",",
     "5"}], "}"}], "]"}]], "Input",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"9", ",", "9", ",", "9", ",", "9", ",", "9"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"7.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The order of this list of rules is the order in which the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " evaluator will search for a pattern match."
}], "SolutionItem",
 CellTags->"7.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"runEncode", "[", 
   RowBox[{"x", ",", "1", ",", 
    RowBox[{"{", "r", "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"x_", ",", "k_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"x", ",", "k"}], "}"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"x_", ",", "k_", ",", 
    RowBox[{"{", 
     RowBox[{"x_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"runEncode", "[", 
   RowBox[{"x", ",", 
    RowBox[{"k", "+", "1"}], ",", 
    RowBox[{"{", "r", "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"runEncode", "[", 
   RowBox[{"x_", ",", "k_", ",", 
    RowBox[{"{", 
     RowBox[{"y_", ",", "r___"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"x", ",", "k"}], "}"}], "}"}], ",", 
    RowBox[{"runEncode", "[", 
     RowBox[{"y", ",", "1", ",", 
      RowBox[{"{", "r", "}"}]}], "]"}]}], "]"}]}]}], "InputOnly",
 CellTags->"7.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Recursion is on the tail.", "SolutionItem",
 CellTags->"7.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"runDecode", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}], "\n", 
 RowBox[{
  RowBox[{"runDecode", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "k_"}], "}"}], ",", "r___"}], "}"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"x", ",", 
      RowBox[{"{", "k", "}"}]}], "]"}], ",", 
    RowBox[{"runDecode", "[", 
     RowBox[{"{", "r", "}"}], "]"}]}], "]"}]}]}], "InputOnly",
 CellTags->"7.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"runDecode", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"9", ",", "5"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "6"}], "}"}]}], "}"}], "]"}]], "Input",
 CellTags->"7.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "9", ",", "9", ",", "9", ",", "9", ",", "9", ",", "4", ",", "3", ",", "3", 
   ",", "3", ",", "3", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", 
   "5"}], "}"}]], "Output",
 CellTags->"7.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["8", "ChapterN"],

Cell[CellGroupData[{

Cell["Numerics", "ChapterTitle"],

Cell[CellGroupData[{

Cell[TextData[{
 "Numbers in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"]
}], "ExerciseSubsection"],

Cell[TextData[{
 "Define a function ",
 Cell[BoxData[
  StyleBox["complexToPolar", "ExLink"]]],
 " that converts complex numbers to their polar representations. Then, \
convert the numbers ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["3", "OsF"], "+", 
    RowBox[{
     StyleBox["3", "OsF"], "\[ImaginaryI]"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[Pi]\[ImaginaryI]", "/", "3"}]], TraditionalForm]]],
 " to polar form."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->{"8.1 Exercises", "i:32"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Using the built-in ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]]],
 " function, write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["convert", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["b", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that accepts a list of digits in any base ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 " (less than ",
 StyleBox["20", "OsF"],
 ") and converts it to a base ",
 StyleBox["10", "OsF"],
 " number. For example, ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["1101", "2"], "OsF"], TraditionalForm]]],
 " is ",
 StyleBox["13", "OsF"],
 " in base ",
 StyleBox["10", "OsF"],
 ", so your function should handle this as follows:"
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:33", "Ex.Convert"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convert", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", "2"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.1 Exercises"],

Cell[BoxData["13"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create a function to compute the sum of the digits of any integer. Write an \
additional rule to give the sum of the base-",
 StyleBox["b",
  FontSlant->"Italic"],
 " digits of an integer. Then use your function to compute the ",
 StyleBox["Hamming weight",
  FontSlant->"Italic"],
 " of any integer: the Hamming weight of an integer is given by the number of \
",
 StyleBox["1", "OsF"],
 "s in the binary representation of that number."
}], "ExerciseItem",
 CellTags->{"i:119", "8.1 Exercises"}],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["sumsOfCubes", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a positive integer argument ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " and computes the sums of cubes of the digits of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Hayes 1992\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Hayes\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Allan\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"1992.\", \"OsF\"]\) Sum of cubes of digits, driven to abstraction. \
\!\(\*\nStyleBox[\"Mathematica\",\nFontSlant->\"Italic\"]\)\!\(\*\n\
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"in\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Education\",\nFontSlant->\"Italic\"]\), \!\(\*\n\
StyleBox[\"1\", \"OsF\",\nFontWeight->\"Bold\"]\)\!\(\*\nStyleBox[\"(\", \
\"OsF\"]\)\!\(\*\nStyleBox[\"4\", \"OsF\"]\)\!\(\*\nStyleBox[\")\", \
\"OsF\"]\)\!\(\*\nStyleBox[\",\", \"OsF\"]\)\!\(\*\nStyleBox[\" \", \
\"OsF\"]\)\!\(\*\nStyleBox[\"3\", \"OsF\"]\)\!\(\*\nStyleBox[\"\[Dash]\", \
\"OsF\"]\)\!\(\*\nStyleBox[\"11.\", \"OsF\"]\)"], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 ")."
}], "ExerciseItem",
 CellTags->"8.1 Exercises"],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["NestList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestList"]]],
 " to iterate the process of summing cubes of digits, that is, generate a \
list starting with an initial integer of the successive sums of cubes of \
digits. For example, starting with ",
 StyleBox["4", "OsF"],
 ", the list should look like: ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
    "4", ",", "64", ",", "280", ",", "520", ",", "133", ",", "\[Ellipsis]"}], 
    "}"}], "ExLink"]]],
 ". Note,",
 StyleBox[" ", "OsF"],
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"64", "=", 
     SuperscriptBox["4", "3"]}], "OsF"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["280", "OsF"], "=", 
    RowBox[{
     StyleBox[
      SuperscriptBox["6", "3"], "OsF"], "+", 
     StyleBox[
      SuperscriptBox["4", "3"], "OsF"]}]}], TraditionalForm]]],
 ", etc. Extend the list for at least ",
 StyleBox["15", "OsF"],
 " values and make an observation about any patterns you notice. Experiment \
with other starting values."
}], "ExerciseItem",
 CellTags->"8.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Binary shifts arise in the study of computer algorithms because they often \
allow you to speed up calculations by operating in base ",
 StyleBox["2", "OsF"],
 " or in bases that are powers of ",
 StyleBox["2.", "OsF"],
 " Try to discover what a binary shift does by performing the following shift \
on ",
 StyleBox["24", "OsF"],
 " (base ",
 StyleBox["10", "OsF"],
 "). First get the integer digits of ",
 StyleBox["24", "OsF"],
 " in base ",
 StyleBox["2.", "OsF"]
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:34"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IntegerDigits", "[", 
  RowBox[{"24", ",", "2"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell["Then, do a binary shift, one place to the right.", "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RotateRight", "[", "%", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Finally, construct an integer from these binary digits and convert back to \
base ",
 StyleBox["10.", "OsF"]
}], "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromDigits", "[", 
  RowBox[{"%", ",", "2"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.1 Exercises"],

Cell[BoxData["12"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell["\<\
Experiment with other numbers (including both odd and even integers) and make \
some conjectures.\
\>", "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  RowBox[{
   StyleBox["survivor", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " function from Section ",
 StyleBox["5.8", "OsF"],
 " can be programmed using binary shifts. This can be done by rotating the \
base ",
 StyleBox["2", "OsF"],
 " digits of the number ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " by one unit to the left and then converting this rotated list back to base \
",
 StyleBox["10.", "OsF"],
 " For example, if ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["10", "OsF"]}], TraditionalForm]]],
 ", the base ",
 StyleBox["2", "OsF"],
 " representation is ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["1010", "OsF"], "2"], TraditionalForm]]],
 "; the binary shift gives ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["0101", "OsF"], "2"], TraditionalForm]]],
 "; converting this number back to base ",
 StyleBox["10", "OsF"],
 " gives ",
 StyleBox["5", "OsF"],
 ", which is the output to ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"survivor", "[", "5", "]"}], "ExLink"]]],
 ". Program a new ",
 Cell[BoxData[
  StyleBox["survivor", "ExLink"]]],
 " function using the binary shift."
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:35"}],

Cell[TextData[{
 "Using the ",
 Cell[BoxData[
  StyleBox["Dice", "ExerciseMR"]]],
 " function from Exercise ",
 StyleBox["9", "OsF"],
 " in Section ",
 StyleBox["4.2", "OsF"],
 ", create a function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"RollDice", "[", "]"}], "ExerciseMR"]]],
 " that \[OpenCurlyDoubleQuote]rolls\[CloseCurlyDoubleQuote] two dice and \
displays them side-by-side. Then create an additional rule, ",
 Cell[BoxData[
  RowBox[{
   StyleBox["RollDice", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 ", that rolls a pair of dice ",
 StyleBox["n",
  FontSlant->"Italic"],
 " times and displays the result in a list or row."
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:36"}],

Cell[TextData[{
 "Create functions ",
 Cell[BoxData[
  StyleBox["walk2D", "ExLink"]]],
 " and ",
 Cell[BoxData[
  StyleBox["walk3D", "ExLink"]]],
 " that generate two-dimensional and three-dimensional lattice walks, \
respectively. For example, the two-dimensional case can use compass \
directions north, south, east, west that are represented by the list ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], "ExLink"]]],
 ". "
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:37"}],

Cell[CellGroupData[{

Cell[TextData[{
 "A surprisingly simple pseudorandom number algorithm is the ",
 StyleBox["linear congruential ", "TermDefinition"],
 StyleBox["method", "TermDefinition",
  FontSlant->"Plain"],
 ". It is quite easy to implement and has been studied extensively. Sequences \
of random numbers are generated by a formula such as the following:"
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:38"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", 
     RowBox[{"n", "+", "1"}]], "=", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "n"], "b"}], "+", 
     RowBox[{
      StyleBox["1", "OsF"], " ", 
      RowBox[{"(", 
       RowBox[{"mod", " ", "m"}], ")"}]}]}]}], TraditionalForm]]],
 "."
}], "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[TextData[{
 "The starting value ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " is the ",
 StyleBox["seed", "TermDefinition"],
 ", ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 " is the ",
 StyleBox["multiplier", "TermDefinition"],
 ", and ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " is the ",
 StyleBox["modulus", "TermDefinition"],
 ". Recall that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["7", "OsF"], " ", "mod", " ", 
    StyleBox["5", "OsF"]}], TraditionalForm]]],
 " is the remainder upon dividing ",
 StyleBox["7", "OsF"],
 " by ",
 StyleBox["5.", "OsF"]
}], "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{"7", ",", "5"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.1 Exercises"],

Cell[BoxData["2"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Implement the linear congruential method and test it with a variety of \
numbers ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ". If you find that the generator gets in a loop easily, try a large value \
for the modulus ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 ". See ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Knuth (1997)\"\>", "TR",
    StripOnInput->False],
   Appearance->None,
   BaseStyle->"Hyperlink",
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Knuth\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Donald\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"\[ThinSpace]\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"E\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1997.\", \"OsF\"]\) \!\(\*\nStyleBox[\"The\
\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Art\",\nFontSlant->\"Italic\"]\)\!\
\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"of\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Computer\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Programming\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Volume\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\n StyleBox[\"2\", \"SmallCaps\"],\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\":\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Seminumerical\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Algorithms\",\nFontSlant->\"Italic\"]\), third edition. \
Addison-Wesley. See `1`", 
         Hyperlink[
         "http://www-cs-faculty.stanford.edu/~uno/taocp.html", 
          "http://www-cs-faculty.stanford.edu/~uno/taocp.html"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 " for a full treatment of random number generating algorithms."
}], "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Implement a ",
 StyleBox["quadratic congruential", "TermDefinition"],
 StyleBox[" random number generator", "TermDefinition",
  FontSlant->"Plain"],
 ". The iteration is given by the following, where ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox["c", TraditionalForm]]],
 " are the parameters, ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]]],
 " is the modulus, and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " is the starting value:"
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:39"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", 
     RowBox[{"n", "+", "1"}]], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"a", " ", 
        SubsuperscriptBox["x", "n", "2"]}], "+", 
       RowBox[{"b", " ", 
        SubscriptBox["x", "n"]}], "+", "c"}], ")"}], " ", "mod", " ", "m"}]}],
    TraditionalForm]]]
}], "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "John von Neumann, considered by many to be the \
\[OpenCurlyDoubleQuote]father of computer science,\[CloseCurlyDoubleQuote] \
suggested a random number generator known as the ",
 StyleBox["middle-square", "TermDefinition"],
 " method. Starting with a ten-digit integer, square the initial integer and \
then extract its middle ten digits to get the next number in the sequence. \
For example, starting with ",
 StyleBox["1234567890", "OsF"],
 ", squaring it produces ",
 StyleBox["1524157875019052100.", "OsF"],
 " The middle digits are ",
 StyleBox["1578750190", "OsF"],
 ", so the sequence starts out ",
 StyleBox["1234567890", "OsF"],
 ", ",
 StyleBox["1578750190", "OsF"],
 ", ",
 StyleBox["4521624250", "OsF"],
 ", \[Ellipsis]. Implement a middle square random number generator and then \
test it on a ",
 Cell[BoxData[
  FormBox[
   StyleBox["1000", "OsF"], TraditionalForm]]],
 "-number sequence. Was the \[OpenCurlyDoubleQuote]father of computer science\
\[CloseCurlyDoubleQuote] a good random number generator?"
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:40"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Information theory, as conceived by Claude Shannon in the ",
 StyleBox["1940", "OsF"],
 "s and ",
 StyleBox["1950", "OsF"],
 "s, was originally interested in maximizing the amount of data that can be \
stored and retrieved over some channel such as a telephone line. Shannon \
devised a measure, now called the ",
 StyleBox["entropy",
  FontSlant->"Italic"],
 ", that gives the theoretical maxima for such a signal. Entropy can be \
thought of as the average uncertainty of a single random variable and is \
computed by the following, where ",
 Cell[BoxData[
  FormBox[
   RowBox[{"p", "(", "x", ")"}], TraditionalForm]]],
 " is the probability of event ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " over a domain ",
 Cell[BoxData[
  FormBox["X", TraditionalForm]]],
 ":"
}], "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:41"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"H", "(", "X", ")"}], "=", 
    RowBox[{"-", 
     RowBox[{
      UnderscriptBox["\[Sum]", 
       RowBox[{"\[ThinSpace]", 
        RowBox[{"x", "\[Element]", "X"}]}]], 
      RowBox[{
       RowBox[{"p", "(", "x", ")"}], " ", 
       SubscriptBox["log", "2"], 
       RowBox[{"p", "(", "x", ")"}]}]}]}]}], TraditionalForm]]]
}], "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[TextData[{
 "Generate a plot of the entropy (built into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " as ",
 Cell[BoxData[
  ButtonBox["Entropy",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Entropy"]], "InlineFormula"],
 ") as a function of success probability. You can simulate ",
 StyleBox["n",
  FontSlant->"Italic"],
 " trials of a coin toss with probability ",
 StyleBox["p",
  FontSlant->"Italic"],
 " using:"
}], "ExerciseText",
 CellTags->"8.1 Exercises"],

Cell[BoxData[
 RowBox[{"RandomVariate", "[", 
  RowBox[{
   RowBox[{"BernoulliDistribution", "[", 
    StyleBox["p", "ExerciseTI"], "]"}], ",", " ", 
   StyleBox["n", "ExerciseTI"]}], "]"}]], "ExerciseInput", "ExerciseMR",
 Evaluatable->False,
 CellTags->"8.1 Exercises"],

Cell[TextData[{
 "See (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"\\!\\(\\*\\nStyleBox[\\\"Manning\\\", \\\"SmallCaps\\\"]\\) \
and \\!\\(\\*\\nStyleBox[\\\"Sch\[UDoubleDot]tze\\\", \
\\\"SmallCaps\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"SmallCaps\\\"]\\)1999\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Manning\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Christopher\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"\[ThinSpace]\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"D\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\) and \!\(\*\n\
StyleBox[\"Hinrich\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Sch\[UDoubleDot]tze\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"1999.\", \"OsF\"]\) \!\(\*\n\
StyleBox[\"Foundations\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"of\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Statistical\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \
\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Natural\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Language\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Processing\",\nFontSlant->\"Italic\
\"]\). The MIT Press. See `1`", 
         Hyperlink[
         "http://mitpress.mit.edu/books/foundations-statistical-natural-\
language-processing", 
          "http://mitpress.mit.edu/books/foundations-statistical-natural-\
language-processing"]], {FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 ") for a discussion of entropy in the context of information theory \
generally and in natural language processing in particular. Also, see Claude \
Shannon\[CloseCurlyQuote]s very readable original paper on the mathematical \
theory of communication (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Shannon 1948\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "Shannon, Claude E. 1948. A mathematical theory of computation. \
\!\(\*\nStyleBox[\"Bell\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"System\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Technical\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Journal\",\nFontSlant->\"Italic\"]\
\), 27, 379\[Dash]423 and 623\[Dash]656. Reprint available online at:\n`1`.", 
         
         Hyperlink[
         "http://cm.bell-labs.com/cm/ms/what/shannonday/shannon1948.pdf", 
          "http://cm.bell-labs.com/cm/ms/what/shannonday/shannon1948.pdf"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False],
 ")."
}], "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
This function gives the polar form as a list consisting of the magnitude and \
the polar angle.\
\>", "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"complexToPolar", "[", "z_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Abs", "[", "z", "]"}], ",", 
    RowBox[{"Arg", "[", "z", "]"}]}], "}"}]}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"complexToPolar", "[", 
  RowBox[{"3", "+", 
   RowBox[{"3", " ", "\[ImaginaryI]"}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"3", " ", 
    SqrtBox["2"]}], ",", 
   FractionBox["\[Pi]", "4"]}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"complexToPolar", "[", 
  SuperscriptBox["\[ExponentialE]", 
   FractionBox[
    RowBox[{"\[Pi]", " ", "\[ImaginaryI]"}], "3"]], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", 
   FractionBox["\[Pi]", "3"]}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This function uses a default value of ",
 StyleBox["2", "OsF"],
 " for the base. (Try replacing ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]], "InlineFormula"],
 " with ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]], "InlineFormula"],
 " to see more clearly what this function is doing.)"
}], "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"convert", "[", 
   RowBox[{"digits_List", ",", 
    RowBox[{"base_", ":", "2"}]}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"base", " ", "#1"}], "+", "#2"}], ")"}], "&"}], ",", "0", ",", 
    "digits"}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "Here are the digits for ",
 StyleBox["9", "OsF"],
 " in base ",
 StyleBox["2", "OsF"],
 ":"
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IntegerDigits", "[", 
  RowBox[{"9", ",", "2"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "This converts them back to the base ",
 StyleBox["10", "OsF"],
 " representation."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convert", "[", "%", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData["9"], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Note, this functionality is built into the function ",
 Cell[BoxData[
  RowBox[{"FromDigits", "[", 
   RowBox[{
    StyleBox["lis", "ExerciseTI"], ",", 
    StyleBox["base", "ExerciseTI"]}], "]"}]]],
 "."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromDigits", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "2"}], 
  "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData["9"], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell["\<\
This function is essentially an implementation of Horner\[CloseCurlyQuote]s \
method for fast polynomial multiplication.\
\>", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"convert", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], ",", "x"}], 
  "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"e", "+", 
  RowBox[{"x", " ", 
   RowBox[{"(", 
    RowBox[{"d", "+", 
     RowBox[{"x", " ", 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"x", " ", 
         RowBox[{"(", 
          RowBox[{"b", "+", 
           RowBox[{"a", " ", "x"}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "%", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"e", "+", 
  RowBox[{"d", " ", "x"}], "+", 
  RowBox[{"c", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"b", " ", 
   SuperscriptBox["x", "3"]}], "+", 
  RowBox[{"a", " ", 
   SuperscriptBox["x", "4"]}]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "One rule can cover both parts of this exercise, using a default value of ",
 StyleBox["10", "OsF"],
 " for the base."
}], "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DigitSum", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"base_:", "10"}]}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"IntegerDigits", "[", 
    RowBox[{"n", ",", "base"}], "]"}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DigitSum", "[", 
  RowBox[{"10", "!"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData["27"], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "The Hamming weight of a number is the number of ",
 StyleBox["1", "OsF"],
 "s in its binary representation."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DigitSum", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["2", "31"], "-", "1"}], ",", "2"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData["31"], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell["Here is a comparison with a built-in function:", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DigitCount", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["2", "31"], "-", "1"}], ",", "2", ",", "1"}], 
  "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData["31"], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the ",
 Cell[BoxData["sumsOfCubes"]],
 " function."
}], "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sumsOfCubes", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"Total", "[", 
   SuperscriptBox[
    RowBox[{"IntegerDigits", "[", "n", "]"}], "3"], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the function that performs the iteration.", "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sumsOfSums", "[", 
   RowBox[{"n_Integer", ",", "iter_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{"sumsOfCubes", ",", "n", ",", "iter"}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "We see that the number ",
 StyleBox["4", "OsF"],
 " enters into a cycle."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"sumsOfSums", "[", 
  RowBox[{"4", ",", "12"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell["In fact, it appears as if many initial values enter cycles.", \
"SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"sumsOfSums", "[", 
  RowBox[{"32", ",", "12"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"sumsOfSums", "[", 
  RowBox[{"7", ",", "12"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"sumsOfSums", "[", 
  RowBox[{"372", ",", "12"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using the number ",
 StyleBox["100", "OsF"],
 " as an example, first get the base two digits."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 6}},
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"IntegerDigits", "[", 
  RowBox[{"100", ",", "2"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "Perform a binary shift of one unit (actually, the ",
 StyleBox["1", "OsF"],
 " in ",
 Cell[BoxData[
  ButtonBox["RotateLeft",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RotateLeft"]], "InlineFormula"],
 " is not needed here as this is the default value to shift by)."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"l", "=", 
  RowBox[{"RotateLeft", "[", 
   RowBox[{
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"100", ",", "2"}], "]"}], ",", "1"}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "This converts back from base ",
 StyleBox["2", "OsF"],
 " to base ",
 StyleBox["10", "OsF"],
 " (using the ",
 Cell[BoxData["convert"]],
 " function from Exercise 2)."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"convert", "[", 
  RowBox[{"l", ",", "2"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "Now we can put all this code together to make the ",
 Cell[BoxData["survivor"]],
 " function."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"survivor", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "p", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"RotateLeft", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"n", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], ",", "0", ",", 
       "p"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"survivor", "[", "100", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "You could of course do the same thing without the symbol ",
 Cell[BoxData["p"]],
 ", but it is just a bit less readable."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"survivor2", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], ",", "0", ",", 
    RowBox[{"RotateLeft", "[", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"survivor2", "[", "100", "]"}]], "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Mapping ",
 Cell[BoxData["Dice"]],
 " (from Exercise ",
 StyleBox["9", "OsF"],
 " in Section ",
 StyleBox["4.2", "OsF"],
 ") over a list of two random integers between ",
 StyleBox["1", "OsF"],
 " and ",
 StyleBox["6", "OsF"],
 " simulates a roll of a pair of dice."
}], "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Dice", ",", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "6"}], "}"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {185, -185.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -185.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {185, -555.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -555.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {185, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {185, -185.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -185.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {185, -555.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -555.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {185, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
         ImageSize->100], {555, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}],
        InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]},
         ImageSize->100], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}]}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell["Here is a function to do that.", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RollDice", "[", "]"}], ":=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"Map", "[", 
    RowBox[{"Dice", ",", 
     RowBox[{"RandomInteger", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "6"}], "}"}], ",", 
       RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollDice", "[", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, -740.}, {1110, -1110.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, -740.}, {740, -1110.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, -740.}, {370, -1110.}]}}, {
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, -370.}, {1110, -740.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, -370.}, {740, -740.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, -370.}, {370, -740.}]}}, {
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, 0}, {1110, -370.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, 0}, {740, -370.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {185, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {555, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {925, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {185, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {555, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {925, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {185, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {555, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {925, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
      ContentSelectable->True,
      ImageSize->40,
      PlotRangePadding->{6, 5}], {21.333333333333332`, -21.}, 
     ImageScaled[{0.5, 0.5}], {40, 40.}], InsetBox[
     GraphicsBox[{{{
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, -740.}, {1110, -1110.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, -740.}, {740, -1110.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, -740.}, {370, -1110.}]}}, {
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, -370.}, {1110, -740.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, -370.}, {740, -740.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, -370.}, {370, -740.}]}}, {
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{740, 0}, {1110, -370.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{370, 0}, {740, -370.}]}, 
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], 
          RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {185, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {555, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {925, -185.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {185, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {555, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {925, -555.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {185, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
           ImageSize->100], {555, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
          GraphicsBox[
           {GrayLevel[1], DiskBox[{0, 0}]},
           ImageSize->100], {925, -925.}, 
          ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
      ContentSelectable->True,
      ImageSize->40,
      PlotRangePadding->{6, 5}], {64., -21.}, 
     ImageScaled[{0.5, 0.5}], {40, 40.}]}, {}},
  ContentSelectable->True,
  ImageSize->{97.33333333333333, 54.},
  PlotRangePadding->{6, 5}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "And here is the rule for rolling the pair of dice ",
 StyleBox["n", "ExerciseTI"],
 " times."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RollDice", "[", "n_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"RollDice", "[", "]"}], ",", 
    RowBox[{"{", "n", "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollDice", "[", "4", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {21.333333333333332`, -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}], InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {64., -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}]}, {}},
    ContentSelectable->True,
    ImageSize->{97.33333333333333, 54.},
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{}, {InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {21.333333333333332`, -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}], InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {64., -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}]}, {}},
    ContentSelectable->True,
    ImageSize->{97.33333333333333, 54.},
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{}, {InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {21.333333333333332`, -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}], InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {64., -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}]}, {}},
    ContentSelectable->True,
    ImageSize->{97.33333333333333, 54.},
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{}, {InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {21.333333333333332`, -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}], InsetBox[
       GraphicsBox[{{{
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -740.}, {1110, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -740.}, {740, -1110.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -740.}, {370, -1110.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, -370.}, {1110, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, -370.}, {740, -740.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, -370.}, {370, -740.}]}}, {
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{740, 0}, {1110, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{370, 0}, {740, -370.}]}, 
           {RGBColor[0, 0, 
             NCache[
              Rational[2, 3], 0.6666666666666666]], 
            RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -185.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {GrayLevel[1], DiskBox[{0, 0}]},
             ImageSize->100], {555, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -555.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {185, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {555, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
            GraphicsBox[
             {RGBColor[0, 0, 
               NCache[
                Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]},
             ImageSize->100], {925, -925.}, 
            ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
        ContentSelectable->True,
        ImageSize->40,
        PlotRangePadding->{6, 5}], {64., -21.}, 
       ImageScaled[{0.5, 0.5}], {40, 40.}]}, {}},
    ContentSelectable->True,
    ImageSize->{97.33333333333333, 54.},
    PlotRangePadding->{6, 5}]}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Using the hint in the exercise, here are the directions for the two- and \
three-dimensional cases.\
\>", "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NSEW", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], ";"}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NSEW3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell["\<\
The walk functions follow directly from the one-dimensional case given in the \
text.\
\>", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk2D", "[", "t_", "]"}], ":=", 
  RowBox[{"Accumulate", "[", 
   RowBox[{"RandomChoice", "[", 
    RowBox[{"NSEW", ",", "t"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"walk3D", "[", "t_", "]"}], ":=", 
  RowBox[{"Accumulate", "[", 
   RowBox[{"RandomChoice", "[", 
    RowBox[{"NSEW3", ",", "t"}], "]"}], "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell["Exercise the functions and visualize.", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"walk2D", "[", "1500", "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJy9nEtuI1cSRRMGGuCQAw000EAtCAQhCAQliv+/yu4F9BIMeNxb4M6qFuJF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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{-33., 7.}, {-44., 4.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Line", "[", 
   RowBox[{"walk3D", "[", "2500", "]"}], "]"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[Line3DBox[CompressedData["
1:eJyd3HmS21h2xWHM4JCZkmp2l//xlrwEL8DepNfiLs1KcSYxuBGNY/50dB+Z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   "]],
  ImageSize->100]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "For a more complete discussion of these functions, see ",
 "Section",
 " ",
 StyleBox["13.1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the linear congruential generator.", "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"linearCongruential", "[", 
   RowBox[{"x_", ",", "mod_", ",", "mult_", ",", "incr_"}], "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"mult", " ", "x"}], "+", "incr"}], ",", "mod"}], 
   "]"}]}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "With modulus ",
 StyleBox["100", "OsF"],
 " and multiplier ",
 StyleBox["15", "OsF"],
 ", this generator quickly gets into a cycle."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"linearCongruential", "[", 
     RowBox[{"#", ",", "100", ",", "15", ",", "1"}], "]"}], "&"}], ",", "5", 
   ",", "10"}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5", ",", "76", ",", "41", ",", "16", ",", "41", ",", "16", ",", "41", ",", 
   "16", ",", "41", ",", "16", ",", "41"}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell["\<\
With a larger modulus and multiplier, it appears as if this generator is \
doing better.\
\>", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "Here are the first ",
 StyleBox["60", "OsF"],
 " terms starting with a seed of ",
 StyleBox["0", "OsF"],
 "."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"linearCongruential", "[", 
       RowBox[{"#", ",", "381", ",", "15", ",", "1"}], "]"}], "&"}], ",", "0",
      ",", "5000"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Take", "[", 
  RowBox[{"data", ",", "60"}], "]"}]}], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "16", ",", "241", ",", "187", ",", "139", ",", "181", 
   ",", "49", ",", "355", ",", "373", ",", "262", ",", "121", ",", "292", ",",
    "190", ",", "184", ",", "94", ",", "268", ",", "211", ",", "118", ",", 
   "247", ",", "277", ",", "346", ",", "238", ",", "142", ",", "226", ",", 
   "343", ",", "193", ",", "229", ",", "7", ",", "106", ",", "67", ",", "244",
    ",", "232", ",", "52", ",", "19", ",", "286", ",", "100", ",", "358", ",",
    "37", ",", "175", ",", "340", ",", "148", ",", "316", ",", "169", ",", 
   "250", ",", "322", ",", "259", ",", "76", ",", "379", ",", "352", ",", 
   "328", ",", "349", ",", "283", ",", "55", ",", "64", ",", "199", ",", 
   "319", ",", "214", ",", "163", ",", "160"}], "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Sometimes it is hard to see if your generator is doing a poor job. \
Graphical analysis can help by allowing you to see patterns over larger \
domains. Here is a ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]], "InlineFormula"],
 " of this sequence taken out to ",
 Cell[BoxData[
  FormBox[
   StyleBox["5000", "OsF"], TraditionalForm]]],
 " terms."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", ".005", "]"}]}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointSize[0.005], PointBox[CompressedData["
1:eJxd3X98lm9d//9FRIuIFhItIppE7xYRTUSciDgn4kTEiYgTEedEnIg4EXEi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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0., 5001.}, {0., 379.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell["\<\
It appears as if certain numbers are repeating. Looking at the plot of the \
Fourier data shows peaks at certain frequencies, indicating a periodic nature \
to the data.\
\>", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fourier", "[", "data", "]"}], "]"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", ".005", "]"}]}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointSize[0.005], PointBox[CompressedData["
1:eJw8nHlcTd/3/0MISRFSIQmZkrGoeEkokiSVpEkaKG7zrNt8m++tO5UQQgiR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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0., 5001.}, {0., 55.14158946678208}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Using a much larger modulus and multiplier and an increment of zero \
(actually, these are the default values for ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "\[CloseCurlyQuote]s built-in ",
 Cell[BoxData["\"\<Congruential\>\""]],
 " method for ",
 Cell[BoxData[
  ButtonBox["SeedRandom",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/SeedRandom"]], "InlineFormula"],
 "), you can keep your generator from getting in such short loops."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"data", "=", 
    RowBox[{"NestList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"linearCongruential", "[", 
        RowBox[{
        "#1", ",", "2305843009213693951", ",", "1283839219676404755", ",", 
         "0"}], "]"}], "&"}], ",", "1", ",", "5000"}], "]"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", ".005", "]"}]}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointSize[0.005], PointBox[CompressedData["
1:eJxUvHlYzN/7Px6FkJcQipA9JEkI4REhCaFUtvYUpX1Ppn2bamaappkRQhSF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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0., 5001.}, {0., 2.3056891410739955`*^18}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fourier", "[", "data", "]"}], "]"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", ".005", "]"}]}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointSize[0.005], PointBox[CompressedData["
1:eJw8fXlczc/3P6mEpBJCVETZExKiZ4lCiJIQKqVUtO/bbb/t995udW9KZUkR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     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0., 5001.}, {0., 1.7399228588559567`*^18}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is a simple implementation of the middle square method. It assumes a \
ten-digit seed. To work with arbitrary-length seeds, modify the number of \
middle digits that are extracted with the ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " function."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 11}},
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"middleSquareGenerator", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"seed_:", "1234567890"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"tmp", "=", 
       RowBox[{"{", "seed", "}"}]}], ",", "s2", ",", "len", ",", 
      RowBox[{"s", "=", "seed"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"s2", "=", 
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"s", "^", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"len", "=", 
         RowBox[{"Length", "[", "s2", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"s", "=", 
         RowBox[{"FromDigits", "[", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"len", "<", "20"}], ",", 
             RowBox[{"PadLeft", "[", 
              RowBox[{"s2", ",", "20", ",", "0"}], "]"}], ",", "s2"}], "]"}], 
           "[", 
           RowBox[{"[", 
            RowBox[{"6", ";;", "15"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"tmp", ",", "s"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", "n", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "tmp"}]}], "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"middleSquareGenerator", "[", "3", "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1234567890", ",", "1578750190", ",", "4521624250", ",", "858581880"}], 
  "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"middleSquareGenerator", "[", "1000", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Take", "[", 
  RowBox[{"data", ",", "12"}], "]"}]}], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1234567890", ",", "1578750190", ",", "4521624250", ",", "858581880", ",", 
   "1628446643", ",", "8384690979", ",", "428133239", ",", "2980703366", ",", 
   "5925560837", ",", "2712329881", ",", "7333833654", ",", "1160645429"}], 
  "}"}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Run ",
 Cell[BoxData[
  FormBox[
   StyleBox["10000", "OsF"], TraditionalForm]]],
 " trials with a range of probabilities from ",
 StyleBox["0", "OsF"],
 " to ",
 StyleBox["1", "OsF"],
 " in increments of ",
 StyleBox[".001", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"8.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"incr", "=", "0.001"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trials", "=", "10000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lis", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"RandomVariate", "[", 
      RowBox[{
       RowBox[{"BernoulliDistribution", "[", "p", "]"}], ",", "trials"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "1", ",", "incr"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellTags->"8.1 Solutions"],

Cell[TextData[{
 "Pair up the probabilities with the entropies (in base ",
 StyleBox["2", "OsF"],
 ") for each trial."
}], "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"info", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "1", ",", "incr"}], "]"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Entropy", "[", 
          RowBox[{"2", ",", "#"}], "]"}], "&"}], ",", "lis"}], "]"}]}], "}"}],
     "]"}]}], ";"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell["Make a plot.", "SolutionText",
 CellTags->"8.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"info", ",", 
   RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "Small", "]"}]}]}], "]"}]], "Input",
 CellTags->"8.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointSize[Small], PointBox[CompressedData["
1:eJxd23VYFN/bBnBFv9YPuwsbW8FG0dsWCwsM7FZsbEQUbEVFUMRGbGxFMQDp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     "]]}, {}},
  AspectRatio->1,
  Axes->True,
  AxesOrigin->{0, 0},
  GridLines->Automatic,
  ImageSize->140,
  PlotRange->{{0., 1.}, {0., 0.999999971146099}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical computation", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Explain why ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " is unable to produce a number with ",
 StyleBox["100", "OsF"],
 " digits of precision in the following example."
}], "ExerciseItem",
 CellTags->"8.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"1.23", ",", "100"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.2 Exercises"],

Cell[BoxData["1.23`"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precision", "[", "%", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.2 Exercises"],

Cell[BoxData["MachinePrecision"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Determine what level of precision is necessary when computing ",
 Cell[BoxData[
  StyleBox[
   SuperscriptBox[
    RowBox[{"N", "[", 
     RowBox[{
      SqrtBox["2"], ",", 
      StyleBox["prec", "ExerciseTI"]}], "]"}], "200"], "ExLink"]]],
 " to produce accuracy in the output of at least ",
 StyleBox["100", "OsF"],
 " digits."
}], "ExerciseItem",
 CellTags->"8.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Explain why the following computation produces an unexpected result (that \
is, why the value ",
 StyleBox["0.000000000001", "OsF"],
 " is not returned)."
}], "ExerciseItem",
 CellTags->"8.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1.0", "-", "0.999999999999"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.2 Exercises"],

Cell[BoxData["9.999778782798785`*^-13"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "How close is the number ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[Pi]", 
     SqrtBox[
      StyleBox["163", "OsF"]]}]], TraditionalForm]]],
 " to an integer? Use ",
 Cell[BoxData[
  ButtonBox["N",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/N"]], "InlineFormula"],
 ", but mind the precision of your computations."
}], "ExerciseItem",
 CellTags->"8.2 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The number ",
 StyleBox["1.23", "OsF"],
 " has machine precision."
}], "SolutionItem",
 CellTags->"8.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precision", "[", "1.23", "]"}]], "Input",
 CellTags->"8.2 Solutions"],

Cell[BoxData["MachinePrecision"], "Output",
 CellTags->"8.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Asking ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " to generate ",
 StyleBox["100", "OsF"],
 " digits of precision from a number that only contains about ",
 StyleBox["16", "OsF"],
 " digits of precision would require it to produce ",
 StyleBox["84", "OsF"],
 " digits without any information about where those digits should come from."
}], "SolutionText",
 CellTags->"8.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This generates a table showing the number of digits of precision needed in \
the input compared with the accuracy of the result.\
\>", "SolutionItem",
 CellTags->"8.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"Accuracy", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"N", "[", 
          RowBox[{
           SqrtBox["2"], ",", "x"}], "]"}], "200"], "-", 
        SuperscriptBox[
         RowBox[{"(", 
          SqrtBox["2"], ")"}], "200"]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "100", ",", "140", ",", "5"}], "}"}]}], "]"}], "//", 
  "TableForm"}]], "Input",
 CellTags->"8.2 Solutions"],

Cell[BoxData[
 TagBox[GridBox[{
    {"100", "67.59597043793791`"},
    {"105", "72.59597043793792`"},
    {"110", "77.59597043793791`"},
    {"115", "82.59597043793792`"},
    {"120", "87.59597043793791`"},
    {"125", "92.59597043793791`"},
    {"130", "97.59597043793792`"},
    {"135", "102.59597043793791`"},
    {"140", "107.59597043793794`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellTags->"8.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Arrays of numbers", "ExerciseSubsection"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["RandomSparseArray", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that generates an ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "\[Cross]", "n"}], TraditionalForm]]],
 " sparse array with random numbers along the diagonal."
}], "ExerciseItem",
 CellTags->{"8.3 Exercises", "i:85"}],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["TridiagonalMatrix", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["n", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["p", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["q", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that creates an ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "\[Cross]", "n"}], TraditionalForm]]],
 " matrix with the integer ",
 Cell[BoxData[
  FormBox["p", TraditionalForm]]],
 " on the diagonal, the integer ",
 Cell[BoxData[
  FormBox["q", TraditionalForm]]],
 " on the upper and lower subdiagonals, and ",
 StyleBox["0", "OsF"],
 "s everywhere else."
}], "ExerciseItem",
 CellTags->{"8.3 Exercises", "i:86"}],

Cell[TextData[{
 "Create a vector ",
 Cell[BoxData[
  StyleBox["vec", "ExLink"]]],
 " consisting of ",
 Cell[BoxData[
  StyleBox["100000", "OsF"]]],
 " random real numbers between ",
 StyleBox["0", "OsF"],
 " and ",
 StyleBox["1", "OsF"],
 ". Check that it is indeed a packed array by using ",
 StyleBox["Developer`PackedArrayQ", "MR", "ExLink"],
 ". Then replace one element in ",
 StyleBox["vec", "MR", "ExLink"],
 " with an integer. Check that this new vector is not a packed array. \
Finally, perform some memory and timing tests on these two vectors, using \
functions such as ",
 Cell[BoxData[
  ButtonBox["Max",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Max"]]],
 ", ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]]],
 ", ",
 Cell[BoxData[
  ButtonBox["RootMeanSquare",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RootMeanSquare"]]],
 "."
}], "ExerciseItem",
 CellTags->"8.3 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "An interesting computation of the Fibonacci numbers can be obtained using \
the determinant of a certain tri-diagonal matrix: ",
 StyleBox["1", "OsF"],
 "s on the diagonal and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[ImaginaryI]", "=", 
    SqrtBox[
     RowBox[{"-", 
      StyleBox["1", "OsF"]}]]}], TraditionalForm]]],
 " running along each subdiagonal. For example, the following ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"4", "\[Cross]", "4"}], "OsF"], TraditionalForm]]],
 " matrix has determinant equal to the fifth Fibonacci number."
}], "ExerciseItem",
 CellTags->{"i:120", "8.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[
  TemplateBox[{RowBox[{"(", "\[NoBreak]", 
      GridBox[{{"1", "\[ImaginaryI]", "0", "0"}, {
        "\[ImaginaryI]", "1", "\[ImaginaryI]", "0"}, {
        "0", "\[ImaginaryI]", "1", "\[ImaginaryI]"}, {
        "0", "0", "\[ImaginaryI]", "1"}}, 
       GridBoxAlignment -> {
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}, 
       GridBoxSpacings -> {"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
   "Det"], TraditionalForm]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.3 Exercises"],

Cell[BoxData["5"], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create a function that computes the ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th Fibonacci number using a sparse array implementation of this \
tri-diagonal matrix. You will need special rules for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 "."
}], "ExerciseText",
 CellTags->"8.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
An efficient approach to computing large Fibonacci numbers relies upon the \
observation that a certain matrix has its characteristic polynomial equal to \
the characteristic equation for the Fibonacci numbers.\
\>", "ExerciseItem",
 CellTags->{"i:121", "8.3 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   FormBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "1"},
       {"1", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    TraditionalForm]}], ";"}], "\n", 
 RowBox[{"poly", "=", 
  RowBox[{"CharacteristicPolynomial", "[", 
   RowBox[{"mat", ",", "x"}], "]"}]}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"8.3 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "-", "x", "+", 
  SuperscriptBox["x", "2"]}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"poly", "\[Equal]", "0"}], ",", "x"}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"8.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SqrtBox["5"]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SqrtBox["5"]}], ")"}]}]}], "}"}]}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"8.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "The Fibonacci numbers ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "n"], TraditionalForm]]],
 " can be generated from successive powers of this matrix."
}], "ExerciseText",
 CellTags->"8.3 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        StyleBox["1", "OsF"], 
        StyleBox["1", "OsF"]},
       {
        StyleBox["1", "OsF"], 
        StyleBox["0", "OsF"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], "n"], "=", 
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       SubscriptBox["F", 
        RowBox[{"n", "+", "1"}]], 
       SubscriptBox["F", "n"]},
      {
       SubscriptBox["F", "n"], 
       SubscriptBox["F", 
        RowBox[{"n", "-", "1"}]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}], 
  TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"8.3 Exercises"],

Cell[TextData[{
 "Use these facts to implement an algorithm for computing the Fibonacci \
numbers using the built-in ",
 Cell[BoxData[
  ButtonBox["MatrixPower",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MatrixPower"]], "InlineFormula"],
 " function with sparse arrays."
}], "ExerciseText",
 CellTags->"8.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["Note the need for a delayed rule in this function.", "SolutionItem",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomSparseArray", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Band", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"RandomReal", "[", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Normal", "[", 
   RowBox[{"RandomSparseArray", "[", "5", "]"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.7783926907255472`", "0", "0", "0", "0"},
     {"0", "0.6856136446546395`", "0", "0", "0"},
     {"0", "0", "0.6399948890834839`", "0", "0"},
     {"0", "0", "0", "0.7910100383428742`", "0"},
     {"0", "0", "0", "0", "0.4275440033800453`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the definition of ",
 Cell[BoxData["TridiagonalMatrix"]],
 "."
}], "SolutionItem",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TridiagonalMatrix", "[", 
   RowBox[{"n_", ",", "p_", ",", "q_"}], "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Band", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", "p"}], ",", 
      RowBox[{
       RowBox[{"Band", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", "q"}], ",", 
      RowBox[{
       RowBox[{"Band", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[Rule]", "q"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TridiagonalMatrix", "[", 
  RowBox[{"5", ",", "\[Alpha]", ",", "\[Beta]"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"SparseArray", "[", 
   RowBox[{
    InterpretationBox[
     RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "13", 
      "\[InvisibleSpace]", "\<\">\"\>"}],
     SequenceForm["<", 13, ">"],
     Editable->False], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "5"}], "}"}]}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Normal", "[", "%", "]"}], "//", "MatrixForm"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Alpha]", "\[Beta]", "0", "0", "0"},
     {"\[Beta]", "\[Alpha]", "\[Beta]", "0", "0"},
     {"0", "\[Beta]", "\[Alpha]", "\[Beta]", "0"},
     {"0", "0", "\[Beta]", "\[Alpha]", "\[Beta]"},
     {"0", "0", "0", "\[Beta]", "\[Alpha]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First we create the packed array vector. ", "SolutionItem",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"1", ",", "3"}], "]"}], ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "5"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Developer`PackedArrayQ", "[", "vec", "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Replacing the first element in ",
 Cell[BoxData["vec"]],
 " with a ",
 StyleBox["1", "OsF"],
 " gives an expression that is not packed."
}], "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"newvec", "=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{"vec", ",", "1", ",", "1"}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Developer`PackedArrayQ", "[", "newvec", "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell["\<\
The size of the unpacked object is about four times larger than the packed \
array.\
\>", "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"ByteCount", ",", 
   RowBox[{"{", 
    RowBox[{"vec", ",", "newvec"}], "}"}]}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"800168", ",", "3200040"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell["\<\
Sorting the packed object is about three times faster than sorting the \
unpacked object.\
\>", "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Sort", "[", "vec", "]"}], ",", 
    RowBox[{"{", "5", "}"}]}], "]"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.09471200000000124`", ",", "Null"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Sort", "[", "newvec", "]"}], ",", 
    RowBox[{"{", "5", "}"}]}], "]"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2434690000000046`", ",", "Null"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell["\<\
Finding the minimum element is about one order of magnitude faster with the \
packed array.\
\>", "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Min", "[", "vec", "]"}], ";"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.00021300000001645003`", ",", "Null"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Min", "[", "newvec", "]"}], ";"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0020760000000024093`", ",", "Null"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Since the definition involving determinants only makes sense for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", ">", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 ", we include a condition on the left-hand side of that definition and also \
specific rules for the cases ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"n", "=", 
     StyleBox["1", "OsF"]}], ",", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 "."
}], "SolutionItem",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fibMat", "[", 
   RowBox[{"n_", "/;", 
    RowBox[{"n", ">", "2"}]}], "]"}], ":=", 
  RowBox[{"Det", "@", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Band", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", "1"}], ",", 
       RowBox[{
        RowBox[{"Band", "[", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[Rule]", "\[ImaginaryI]"}],
        ",", 
       RowBox[{
        RowBox[{"Band", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", 
        "\[ImaginaryI]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "-", "1"}], ",", 
       RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]}]], "InputOnly",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fibMat", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"fibMat", "[", "2", "]"}], "=", "1"}]}], ";"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"fibMat", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55", ",", "89", ",", "144", ",", "233", ",", "377", ",", 
   "610", ",", "987", ",", "1597", ",", "2584", ",", "4181", ",", "6765"}], 
  "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "The computation of determinants using decomposition methods is on the order \
of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"O", "(", 
    SuperscriptBox["n", "3"], ")"}], TraditionalForm]]],
 " computational complexity. So this computation tends to slow down \
considerably for large ",
 StyleBox["n",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"fibMat", "[", 
   SuperscriptBox["10", "3"], "]"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6.766299000000004`", ",", 
   "43466557686937456435688527675040625802564660517371780402481729089536555417\
949051890403879840079255169295922593080322634775209689623239873322471161642996\
440906533187938298969649928516003704476137795166849228875"}], "}"}]], "Output",\

 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Fibonacci", "[", 
   SuperscriptBox["10", "3"], "]"}], "\[Equal]", 
  RowBox[{"fibMat", "[", 
   SuperscriptBox["10", "3"], "]"}]}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The sparse array needs only one rule ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]]],
 " together with a third argument that specifies the default values should be \
set to ",
 StyleBox["1", "OsF"],
 ". Then pick off the ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th Fibonacci number in the first row, second column."
}], "SolutionItem",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fibMat2", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "mat", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"mat", "=", 
      RowBox[{"SparseArray", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MatrixPower", "[", 
       RowBox[{"mat", ",", "n"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellTags->"8.3 Solutions"],

Cell["Quick check of the first few numbers.", "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"fibMat2", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],

Cell["The time to compute a large number is quite fast.", "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"fibMat2", "[", 
   SuperscriptBox["10", "3"], "]"}], "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.0002159999999946649`", ",", 
   "43466557686937456435688527675040625802564660517371780402481729089536555417\
949051890403879840079255169295922593080322634775209689623239873322471161642996\
440906533187938298969649928516003704476137795166849228875"}], "}"}]], "Output",\

 CellTags->"8.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "Check correctness against the built-in function, using a large random \
integer ",
 StyleBox["n",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"8.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", 
     RowBox[{"RandomInteger", "[", 
      SuperscriptBox["10", "6"], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fibMat2", "[", "n", "]"}], "\[Equal]", 
    RowBox[{"Fibonacci", "[", "n", "]"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellTags->"8.3 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[TextData[{
 "Write a functional implementation of the secant method. Your function \
should accept as arguments the name of a function and two initial guesses. It \
should maintain the precision of the inputs and it should output the root at \
the precision of the initial guess, and the number of iterations required to \
compute the root. Consider using the built-in functions ",
 Cell[BoxData[
  ButtonBox["FixedPoint",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FixedPoint"]]],
 " or ",
 Cell[BoxData[
  ButtonBox["Nest",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Nest"]]],
 "."
}], "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:113"}],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  StyleBox["findRoot", "ExLink"]]],
 " function developed in this section suffers from several inefficiencies. \
One of them is that if the precision goal is no more than machine precision, \
all intermediate computations should be done at the more efficient machine \
precision as well. Modify ",
 Cell[BoxData[
  StyleBox["findRoot", "ExLink"]]],
 " so that it will operate at machine precision if the precision goal is at \
most machine precision."
}], "ExerciseItem",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 "In the ",
 Cell[BoxData[
  StyleBox["findRoot", "ExLink"]]],
 " program, we added ",
 Cell[BoxData[
  RowBox[{
   StyleBox["SetPrecision", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["result", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["precisionGoal", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " at the very end to return the final result at the precision goal, but we \
have done no test to insure that the result meets the required precision. Add \
a test to the end of the ",
 Cell[BoxData[
  StyleBox["findRoot", "ExLink"]]],
 " function so that, if this condition is not met, an error message is \
generated and the current result is output."
}], "ExerciseItem",
 CellTags->"8.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Some functions tend to cause root-finding methods to converge rather \
slowly. For example, the function ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"f", "(", "x", ")"}], "=", 
    RowBox[{
     RowBox[{"sin", "(", "x", ")"}], "-", "x"}]}], TraditionalForm]]],
 " requires over ten iterations of Newton\[CloseCurlyQuote]s method with an \
initial guess of ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "0"], "=", 
    StyleBox["0.1", "OsF"]}], TraditionalForm]]],
 " to get three-place accuracy. "
}], "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:112"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], "-", "x"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0.1"}], "}"}], ",", 
    RowBox[{"MaxIterations", "\[Rule]", "12"}], ",", 
    RowBox[{"EvaluationMonitor", "\[RuleDelayed]", 
     RowBox[{"Sow", "[", "x", "]"}]}]}], "]"}], "//", 
  "Reap"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.4 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"FindRoot", "::", "cvmit"}], "MessageName"], ":", 
  " ", "\<\"Failed to converge to the requested accuracy or precision within \
\[NoBreak]\\!\\(12\\)\[NoBreak] iterations. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/FindRoot/cvmit\\\", ButtonNote -> \
\\\"FindRoot::cvmit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"8.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0.0007705034630768697`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
     "0.1`", ",", "0.06665555158597818`", ",", "0.04443374333377395`", ",", 
      "0.02962152073048174`", ",", "0.019747391689668346`", ",", 
      "0.013164842228784033`", ",", "0.008776536134155952`", ",", 
      "0.005851016577913853`", ",", "0.003900675492964155`", ",", 
      "0.002600449669201494`", ",", "0.0017336329173554652`", ",", 
      "0.0011557552203097592`", ",", "0.0007705034630768697`"}], "}"}], 
    "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "Implement the following acceleration of Newton\[CloseCurlyQuote]s method \
and determine how many iterations of the function ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"f", "(", "x", ")"}], "=", 
    RowBox[{
     RowBox[{"sin", "(", "x", ")"}], "-", "x"}]}], TraditionalForm]]],
 ", starting with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "0"], "=", 
    StyleBox["0.1", "OsF"]}], TraditionalForm]]],
 ", are necessary for six-place accuracy."
}], "ExerciseText",
 CellTags->"8.4 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"accelNewton", "(", "x", ")"}], "=", 
   StyleBox[
    FractionBox[
     RowBox[{
      RowBox[{"f", "(", "x", ")"}], " ", 
      RowBox[{
       SuperscriptBox["f", "\[Prime]"], "(", "x", ")"}]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"[", 
        RowBox[{
         SuperscriptBox["f", "\[Prime]"], "(", "x", ")"}], "]"}], "2"], "-", 
      RowBox[{
       RowBox[{"f", "(", "x", ")"}], 
       RowBox[{
        SuperscriptBox["f", "\[Prime]\[Prime]"], "(", "x", ")"}]}]}]],
    FontSize->12]}], TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],

Cell["\<\
This accelerated method is particularly useful for functions with multiple \
roots.\
\>", "ExerciseText",
 CellTags->"8.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "The ",
 StyleBox["norm", "TermDefinition"],
 " of a matrix gives some measure of the size of that matrix. The norm of a \
matrix ",
 Cell[BoxData[
  FormBox["A", TraditionalForm]]],
 " is indicated by ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}],
    TraditionalForm]]],
 ". There are numerous matrix norms, but all share certain properties. For ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "\[Times]", "n"}], TraditionalForm]]],
 " matrices ",
 Cell[BoxData[
  FormBox["A", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["B", TraditionalForm]]],
 ":"
}], "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:114"}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
    "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], 
    "\[GreaterEqual]", "0"}], TraditionalForm]]],
 ";"
}], "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
    "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], "=", 
    "0"}], TraditionalForm]]],
 " if and only if ",
 Cell[BoxData[
  FormBox["A", TraditionalForm]]],
 " is the zero matrix;"
}], "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[LeftDoubleBracketingBar]", 
     RowBox[{"c", "\[ThinSpace]", "A"}], "\[RightDoubleBracketingBar]"}], "=", 
    RowBox[{"|", "c", "|", " ", 
     RowBox[{
     "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}]}]}], 
   TraditionalForm]]],
 " for any scalar ",
 Cell[BoxData[
  FormBox["c", TraditionalForm]]],
 ";"
}], "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[LeftDoubleBracketingBar]", 
     RowBox[{"A", "+", "B"}], "\[RightDoubleBracketingBar]"}], "=", 
    RowBox[{
     RowBox[{
     "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], "+", 
     
     RowBox[{
     "\[LeftDoubleBracketingBar]", "B", "\[RightDoubleBracketingBar]"}]}]}], 
   TraditionalForm]]],
 ";"
}], "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[LeftDoubleBracketingBar]", 
     RowBox[{"A", " ", "B"}], "\[RightDoubleBracketingBar]"}], "\[LessEqual]", 
    RowBox[{
     RowBox[{
     "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], " ", 
     
     RowBox[{
     "\[LeftDoubleBracketingBar]", "B", "\[RightDoubleBracketingBar]"}]}]}], 
   TraditionalForm]]],
 "."
}], "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 "One particularly useful norm is the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "\[Infinity]"], TraditionalForm]]],
 " norm, sometimes referred to as the ",
 StyleBox["max norm", "TermDefinition"],
 ". For a vector, this is defined as"
}], "ExerciseText",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{"\[LeftDoubleBracketingBar]", 
      OverscriptBox["x", "\[RightVector]"], "\[RightDoubleBracketingBar]"}], 
     "\[Infinity]"], "=", 
    RowBox[{
     UnderscriptBox["max", 
      RowBox[{"1", "\[LessEqual]", "i", "\[LessEqual]", "n"}]], "|", 
     SubscriptBox["x", "i"], "|", Cell[""]}]}], TraditionalForm]]],
 "."
}], "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 "The corresponding matrix norm is defined similarly. Hence, for a matrix ",
 Cell[BoxData[
  FormBox[
   RowBox[{"A", "=", 
    SubscriptBox["a", 
     RowBox[{"i", "\[VeryThinSpace]", "j"}]]}], TraditionalForm]]],
 ", we have"
}], "ExerciseText",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{
     "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], 
     "\[Infinity]"], "=", 
    RowBox[{
     RowBox[{
      UnderscriptBox["max", 
       RowBox[{"1", "\[LessEqual]", "i", "\[LessEqual]", "n"}]], 
      SubsuperscriptBox["\[Sum]", 
       RowBox[{"j", "=", "1"}], "n"]}], "|", 
     SubscriptBox["a", 
      RowBox[{"i", "\[VeryThinSpace]", "j"}]], "|", Cell[""]}]}], 
   TraditionalForm]]],
 "."
}], "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 "This computes the sum of the absolute values of the elements in each row, \
and then takes the maximum of these sums, that is, the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "\[Infinity]"], TraditionalForm]]],
 " matrix norm is the max of the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "\[Infinity]"], TraditionalForm]]],
 " norms of the rows."
}], "ExerciseText",
 CellTags->"8.4 Exercises"],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["norm", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["mat", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["\[Infinity]", "ExLink"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a square matrix as an argument and outputs its ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    RowBox[{
    "\[LeftDoubleBracketingBar]", "\[CenterDot]", 
     "\[RightDoubleBracketingBar]"}], "\[Infinity]"], TraditionalForm]]],
 " norm. Compare your function with the built-in ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " function. Include rules for the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "2"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "1"], TraditionalForm]]],
 " norms."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->"8.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "If a matrix ",
 Cell[BoxData[
  FormBox["A", TraditionalForm]]],
 " is nonsingular (invertible), then its ",
 StyleBox["condition number", "TermDefinition"],
 " is defined as ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
    "\[LeftDoubleBracketingBar]", "A", "\[RightDoubleBracketingBar]"}], 
    "\[CenterDot]", 
    RowBox[{"\[LeftDoubleBracketingBar]", 
     SuperscriptBox["A", 
      RowBox[{"-", "1"}]], "\[RightDoubleBracketingBar]"}]}], 
   TraditionalForm]]],
 ". A matrix is called ",
 StyleBox["well-conditioned", "TermDefinition"],
 " if its condition number is close to ",
 StyleBox["1", "OsF"],
 ", the condition number of the identity matrix. A matrix is called ",
 StyleBox["ill-conditioned", "TermDefinition"],
 " if its condition number is significantly larger than ",
 StyleBox["1", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:115"}],

Cell[TextData[{
 "Write a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["conditionNumber", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["mat", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that uses ",
 Cell[BoxData[
  StyleBox["norm", "ExLink"]]],
 " defined in the previous exercise or the built-in ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " function and outputs the condition number of ",
 StyleBox["mat",
  FontSlant->"Italic"],
 ". Use ",
 Cell[BoxData[
  StyleBox["conditionNumber", "ExerciseMR"]]],
 " to compute the condition number of the first ten Hilbert matrices."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->"8.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["LagPlot", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["data", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["lag", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that plots ",
 StyleBox["data",
  FontSlant->"Italic"],
 " (a one-dimensional vector) against the data lagged by a displacement, ",
 StyleBox["lag",
  FontSlant->"Italic"],
 ". For example, if ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["lag", "ExerciseTI"], "=", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 ", then ",
 Cell[BoxData[
  StyleBox["LagPlot", "ExLink"]]],
 " would display values ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", 
      RowBox[{"i", "-", "1"}]], ",", 
     SubscriptBox["x", "i"]}]}], TraditionalForm]]],
 "}. Use NIST\[CloseCurlyQuote]s lew.dat which consists of ",
 StyleBox["200", "OsF"],
 " observations of beam deflection data and whose lag plot indicates a lack \
of randomness in the sequence of numbers. You can import and post-process the \
data using the following:"
}], "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:116"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<http://itl.nist.gov/div898/education/eda/lew.dat\>\"", ",", 
     "\"\<Data\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "[", 
  RowBox[{"lewdata", "=", 
   RowBox[{"Cases", "[", 
    RowBox[{"data", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", "?", "NumberQ"}], "}"}], "\[RuleDelayed]", "x"}]}], 
    "]"}]}], "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"8.4 Exercises"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "213"}], ",", 
    RowBox[{"-", "564"}], ",", 
    RowBox[{"-", "35"}], ",", 
    RowBox[{"-", "15"}], ",", "141", ",", 
    RowBox[{"\[LeftSkeleton]", "190", "\[RightSkeleton]"}], ",", 
    RowBox[{"-", "385"}], ",", "198", ",", 
    RowBox[{"-", "218"}], ",", 
    RowBox[{"-", "536"}], ",", "96"}], "}"}],
  Short]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.4 Exercises"]
}, Closed]],

Cell["\<\
Or, if you have the files associated with this book, use something like the \
following:\
\>", "ExerciseText",
 CellTags->"8.4 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"lewdata", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Data\>\"", ",", 
        "\"\<lew.dat\>\""}], "}"}], "]"}], ",", "\"\<List\>\""}], "]"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Modify the ",
 Cell[BoxData[
  StyleBox["Correlogram", "ExLink"]]],
 " function developed in this section to provide for an option, ",
 Cell[BoxData[
  StyleBox["Coefficient", "ExLink"]]],
 ", that sets the range of values for the dashed lines within which the ",
 "autocorrelation",
 " coefficients are hoped to lie. In addition, set things up so ",
 Cell[BoxData[
  StyleBox["Correlogram", "ExLink"]]],
 " inherits all the options of ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]]],
 "."
}], "ExerciseItem",
 CellTags->{"Ex.Autocorrelation", "8.4 Exercises"}],

Cell["\<\
Then use your function to look at some time-series data, such as that below; \
the plot here shows a high degree of autocorrelation for small time lags, but \
less so for larger lags, suggesting a serial dependence in the data. In \
finance, autocorrelation analysis (usually referred to as serial correlation) \
is used to predict how price movements may be affected by each other.\
\>", "ExerciseText",
 ParagraphIndent->12,
 CellTags->{"8.4 Exercises", "i:117"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"FinancialData", "[", 
    RowBox[{"\"\<^DJI\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2011", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2011", ",", "12", ",", "31"}], "}"}]}], "}"}], ",", 
     "\"\<Value\>\""}], "]"}]}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Correlogram", "[", 
  RowBox[{"data", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "150"}], "}"}], ",", 
   RowBox[{"Coefficient", "\[Rule]", "0.5"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", 
    RowBox[{"Style", "[", 
     RowBox[{"\"\<Dow Jones 2011: autocorrelation plot\>\"", ",", "10"}], 
     "]"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<Autocorrelation\>\"", ",", "None"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Lag\>\"", ",", "None"}], "}"}]}], "}"}]}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"8.4 Exercises"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJzt2GlQFAceBfCJCdGgrijjLllRIcUaQVFERMEgDxA88OA+Ro5hVIyiEowS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   "], {{{}, {}, {}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], LineBox[{201, 51}], 
      LineBox[{202, 52}], LineBox[{203, 53}], LineBox[{204, 54}], 
      LineBox[{205, 55}], LineBox[{206, 56}], LineBox[{207, 57}], 
      LineBox[{208, 58}], LineBox[{209, 59}], LineBox[{210, 60}], 
      LineBox[{211, 61}], LineBox[{212, 62}], LineBox[{213, 63}], 
      LineBox[{214, 64}], LineBox[{215, 65}], LineBox[{216, 66}], 
      LineBox[{217, 67}], LineBox[{218, 68}], LineBox[{219, 69}], 
      LineBox[{220, 70}], LineBox[{221, 71}], LineBox[{222, 72}], 
      LineBox[{223, 73}], LineBox[{224, 74}], LineBox[{225, 75}], 
      LineBox[{226, 76}], LineBox[{227, 77}], LineBox[{228, 78}], 
      LineBox[{229, 79}], LineBox[{230, 80}], LineBox[{231, 81}], 
      LineBox[{232, 82}], LineBox[{233, 83}], LineBox[{234, 84}], 
      LineBox[{235, 85}], LineBox[{236, 86}], LineBox[{237, 87}], 
      LineBox[{238, 88}], LineBox[{239, 89}], LineBox[{240, 90}], 
      LineBox[{241, 91}], LineBox[{242, 92}], LineBox[{243, 93}], 
      LineBox[{244, 94}], LineBox[{245, 95}], LineBox[{246, 96}], 
      LineBox[{247, 97}], LineBox[{248, 98}], LineBox[{249, 99}], 
      LineBox[{250, 100}], LineBox[{251, 101}], LineBox[{252, 102}], 
      LineBox[{253, 103}], LineBox[{254, 104}], LineBox[{255, 105}], 
      LineBox[{256, 106}], LineBox[{257, 107}], LineBox[{258, 108}], 
      LineBox[{259, 109}], LineBox[{260, 110}], LineBox[{261, 111}], 
      LineBox[{262, 112}], LineBox[{263, 113}], LineBox[{264, 114}], 
      LineBox[{265, 115}], LineBox[{266, 116}], LineBox[{267, 117}], 
      LineBox[{268, 118}], LineBox[{269, 119}], LineBox[{270, 120}], 
      LineBox[{271, 121}], LineBox[{272, 122}], LineBox[{273, 123}], 
      LineBox[{274, 124}], LineBox[{275, 125}], LineBox[{276, 126}], 
      LineBox[{277, 127}], LineBox[{278, 128}], LineBox[{279, 129}], 
      LineBox[{280, 130}], LineBox[{281, 131}], LineBox[{282, 132}], 
      LineBox[{283, 133}], LineBox[{284, 134}], LineBox[{285, 135}]}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], LineBox[{151, 1}], LineBox[{152, 2}],
       LineBox[{153, 3}], LineBox[{154, 4}], LineBox[{155, 5}], 
      LineBox[{156, 6}], LineBox[{157, 7}], LineBox[{158, 8}], 
      LineBox[{159, 9}], LineBox[{160, 10}], LineBox[{161, 11}], 
      LineBox[{162, 12}], LineBox[{163, 13}], LineBox[{164, 14}], 
      LineBox[{165, 15}], LineBox[{166, 16}], LineBox[{167, 17}], 
      LineBox[{168, 18}], LineBox[{169, 19}], LineBox[{170, 20}], 
      LineBox[{171, 21}], LineBox[{172, 22}], LineBox[{173, 23}], 
      LineBox[{174, 24}], LineBox[{175, 25}], LineBox[{176, 26}], 
      LineBox[{177, 27}], LineBox[{178, 28}], LineBox[{179, 29}], 
      LineBox[{180, 30}], LineBox[{181, 31}], LineBox[{182, 32}], 
      LineBox[{183, 33}], LineBox[{184, 34}], LineBox[{185, 35}], 
      LineBox[{186, 36}], LineBox[{187, 37}], LineBox[{188, 38}], 
      LineBox[{189, 39}], LineBox[{190, 40}], LineBox[{191, 41}], 
      LineBox[{192, 42}], LineBox[{193, 43}], LineBox[{194, 44}], 
      LineBox[{195, 45}], LineBox[{196, 46}], LineBox[{197, 47}], 
      LineBox[{198, 48}], LineBox[{199, 49}], LineBox[{200, 50}], 
      LineBox[{286, 136}], LineBox[{287, 137}], LineBox[{288, 138}], 
      LineBox[{289, 139}], LineBox[{290, 140}], LineBox[{291, 141}], 
      LineBox[{292, 142}], LineBox[{293, 143}], LineBox[{294, 144}], 
      LineBox[{295, 145}], LineBox[{296, 146}], LineBox[{297, 147}], 
      LineBox[{298, 148}], LineBox[{299, 149}], LineBox[{300, 150}]}}, {{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwV0Nc6FgAAgOHfpbgAKpGUPSqkZCWErIaZFZmhUpkZhSIVIQlJSpSurNfB
+zzf8RdcVp9VFxQIBKYJEaGc4CSnCOM04URwhkjOEsU5zhNNDLHEEU8CiSSR
TAoXuMglUkkjnctkcIWrZHKNLLLJIZc8rpPPDQoopIibFFNCKbcoo5wKKqni
Nne4yz2qqaGW4xn1NHCfRppopoVWHtBGOw/poJMuuumhl0f00c8Aj3nCUwZ5
xnNeMMQwI4wyxjgvmWCSKaZ5xWtmmGWON7xlngXesch7PvCRJZb5xAqrrPGZ
db6wwVc22WKbb+zwnV1+sMdPfrHPbw445A9/OeIf/wGWEEjl
       "]]}, {}}}],
  AspectRatio->0.4,
  AxesOrigin->{0, 0},
  Epilog->{
    Thickness[Tiny], 
    Dashing[{Small, Small}], 
    LineBox[{{0, 0.5}, {150, 0.5}}], 
    LineBox[{{0, -0.5}, {150, -0.5}}]},
  Frame->True,
  FrameLabel->{{
     FormBox["\"Autocorrelation\"", TraditionalForm], None}, {
     FormBox["\"Lag\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, False}, {Automatic, False}},
  PlotLabel->FormBox[
    StyleBox[
    "\"Dow Jones 2011: autocorrelation plot\"", 10, StripOnInput -> False], 
    TraditionalForm],
  PlotRange->{{1., 150.}, {-1, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"8.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create random walks on the binary digits of \[Pi]. For a one-dimensional \
walk, use ",
 Cell[BoxData[
  RowBox[{
   StyleBox["RealDigits", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["num", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["2", "ExerciseMR"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " to get the base ",
 StyleBox["2", "OsF"],
 " digits and then convert each ",
 StyleBox["0", "OsF"],
 " to \[Dash]",
 StyleBox["1", "OsF"],
 " so that you have a vector of ",
 StyleBox["\[PlusMinus]1", "OsF"],
 "s for the step directions; then use ",
 Cell[BoxData[
  ButtonBox["Accumulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Accumulate"]], "InlineFormula"],
 ". For the two-dimensional walk, use ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]], "InlineFormula"],
 " to pair up digits and then use an appropriate transformation to have the \
four pairs, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], "ExerciseMR"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "ExerciseMR"]]],
 ", ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "ExerciseMR"]]],
 ", and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], "ExerciseMR"]]],
 " map to the compass directions; then use ",
 Cell[BoxData[
  ButtonBox["Accumulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Accumulate"]], "InlineFormula"],
 ". See ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Bailey et al. (2012)\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Bailey\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"David\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"H\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Jonathan\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\
\)\!\(\*\nStyleBox[\"M\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\
\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Borwein\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Cristian\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"S\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Calude\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"et\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"al\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"2012.\", \"OsF\"]\) Normality and the \
digits of \[Pi],\n`1`", 
         Hyperlink[
         "http://www.davidhbailey.com/dhbpapers/normality-digits-pi.pdf", 
          "http://www.davidhbailey.com/dhbpapers/normality-digits-pi.pdf"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 " for more on visualizing digits of \[Pi]."
}], "ExerciseItem",
 CellTags->{"Ex.Walk pi", "i:118", "8.4 Exercises"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "We will overload ",
 Cell[BoxData["findRoot"]],
 " to invoke the secant method when given a list of two numbers as the second \
argument."
}], "SolutionItem",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "findRoot", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MaxIterations", "\[RuleDelayed]", "$RecursionLimit"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"WorkingPrecision", "\[Rule]", "Automatic"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findRoot", "[", 
   RowBox[{"fun_", ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", 
      RowBox[{"x1_", "?", "NumericQ"}], ",", 
      RowBox[{"x2_", "?", "NumericQ"}]}], "}"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "maxIterations", ",", "precisionGoal", ",", "workingPrecision", ",", 
      "initx", ",", "df", ",", "next", ",", "result"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "maxIterations", ",", "precisionGoal", ",", "workingPrecision"}], 
       "}"}], "=", 
      RowBox[{"OptionValue", "[", 
       RowBox[{"{", 
        RowBox[{
        "MaxIterations", ",", "PrecisionGoal", ",", "WorkingPrecision"}], 
        "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"precisionGoal", "===", "Automatic"}], ",", 
       RowBox[{"precisionGoal", "=", 
        RowBox[{"Min", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Precision", "[", "x1", "]"}], ",", 
           RowBox[{"Precision", "[", "x2", "]"}]}], "}"}], "]"}]}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"workingPrecision", "===", "Automatic"}], ",", 
       RowBox[{"workingPrecision", "=", 
        RowBox[{"precisionGoal", "+", "10"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"initx", "=", 
      RowBox[{"SetPrecision", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x1", ",", "x2"}], "}"}], ",", "workingPrecision"}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"df", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"fun", "[", "b", "]"}], "-", 
         RowBox[{"fun", "[", "a", "]"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"next", "[", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "b_"}], "}"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{"a", ",", 
        RowBox[{"b", "-", 
         FractionBox[
          RowBox[{"fun", "[", "b", "]"}], 
          RowBox[{"df", "[", 
           RowBox[{"a", ",", "b"}], "]"}]]}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"result", "=", 
      RowBox[{"SetPrecision", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FixedPoint", "[", 
          RowBox[{"next", ",", "initx", ",", "maxIterations"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "precisionGoal"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"var", "\[Rule]", "result"}], "}"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   SuperscriptBox["x", "2"], "-", "2"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "1.", ",", "2."}], "}"}]}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "1.4142135623730951`"}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"findRoot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "1.0`60", ",", "2.0`50"}], "}"}]}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "x", "\[Rule]", 
   "1.414213562373095048801688724209698078569674094695309735317437116756188103\
03474`50."}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Precision", "[", "%", "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["50.`"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is a three-dimensional vector.", "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "3"}], ",", "2"}], "}"}]}], ";"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[TextData[{
 "This computes the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "\[Infinity]"], TraditionalForm]]],
 " norm of the vector."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"norm", "[", 
   RowBox[{
    RowBox[{"v_", "?", "VectorQ"}], ",", 
    RowBox[{"l_:", "Infinity"}]}], "]"}], ":=", 
  RowBox[{"Max", "[", 
   RowBox[{"Abs", "[", "v", "]"}], "]"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"norm", "[", "vec", "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Compare this with the built-in ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " function."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Norm", "[", 
  RowBox[{"vec", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["3"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is a ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"3", "\[Times]", "3"}], "OsF"], TraditionalForm]]],
 " matrix."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "3"}], ",", "2"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell["Here, then, is the matrix norm.", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"norm", "[", 
   RowBox[{
    RowBox[{"m_", "?", "MatrixQ"}], ",", 
    RowBox[{"l_:", "Infinity"}]}], "]"}], ":=", 
  RowBox[{"norm", "[", 
   RowBox[{
    RowBox[{"Total", "[", 
     RowBox[{"Abs", "[", 
      RowBox[{"Transpose", "[", "m", "]"}], "]"}], "]"}], ",", "Infinity"}], 
   "]"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"norm", "[", "mat", "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["7"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Again, here is a comparison with the built-in ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " function."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Norm", "[", 
  RowBox[{"mat", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["7"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Notice how we ",
 StyleBox["overloaded", "TermDefinition"],
 " the definition of the function ",
 Cell[BoxData["norm"]],
 " so that it would act differently depending upon what type of argument it \
was given. This is a particularly powerful feature of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". The expression ",
 Cell[BoxData[
  RowBox[{"_", "?", "MatrixQ"}]]],
 " on the left-hand side of the definition causes the function ",
 Cell[BoxData["norm"]],
 " to use the definition on the right-hand side ",
 StyleBox["only if",
  FontSlant->"Italic"],
 " the argument is in fact a matrix (if it passes the ",
 Cell[BoxData[
  ButtonBox["MatrixQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MatrixQ"]], "InlineFormula"],
 " test). If that argument is a vector (if it passes the ",
 Cell[BoxData[
  ButtonBox["VectorQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/VectorQ"]], "InlineFormula"],
 " test), then the previous definition is used. "
}], "SolutionText",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the function to compute the condition number of a matrix (using the \
",
 Cell[BoxData[
  FormBox[
   SubscriptBox["l", "2"], TraditionalForm]]],
 " norm)."
}], "SolutionItem",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"conditionNumber", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Norm", "[", 
    RowBox[{"m", ",", "2"}], "]"}], " ", 
   RowBox[{"Norm", "[", 
    RowBox[{
     RowBox[{"Inverse", "[", "m", "]"}], ",", "2"}], "]"}]}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"conditionNumber", "[", 
   RowBox[{"HilbertMatrix", "[", "3", "]"}], "]"}], "//", "N"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["524.0567775860608`"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell["Compare this with the condition number of a random matrix.", \
"SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"5", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"conditionNumber", "[", "mat", "]"}], "//", "N"}]}], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["2.317090948337979`"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell["\<\
An alternative definition for the condition number of a matrix is the ratio \
of largest to smallest singular value.\
\>", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "@", 
  RowBox[{"SingularValueList", "[", "mat", "]"}]}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6.3723077896039815`", ",", "4.222613300243169`", ",", 
   "2.7501327879144144`"}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"First", "[", "%", "]"}], "/", 
  RowBox[{"Last", "[", "%", "]"}]}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["2.3170909483379796`"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"conditionNumber2", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sv", "=", 
      RowBox[{"SingularValueList", "[", "mat", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"First", "[", "sv", "]"}], "/", 
     RowBox[{"Last", "[", "sv", "]"}]}]}], "]"}]}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"conditionNumber2", "[", "mat", "]"}], "//", "N"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData["2.317090948337979`"], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Pairing up values with preceding values is accomplished by transposing the \
appropriate lists.\
\>", "SolutionItem",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"Transpose", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Drop", "[", 
     RowBox[{
      StyleBox["data", "ExerciseTI"], ",", 
      StyleBox["lag", "ExerciseTI"]}], "]"}], ",", 
    RowBox[{"Drop", "[", 
     RowBox[{
      StyleBox["data", "ExerciseTI"], ",", 
      RowBox[{"-", 
       StyleBox["lag", "ExerciseTI"]}]}], "]"}]}], "}"}], "]"}]], "Program",
 Evaluatable->False,
 CellTags->"8.4 Solutions"],

Cell[TextData[{
 "Here then is the code for ",
 Cell[BoxData["LagPlot"]],
 "."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LagPlot", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"lag_", ":", "1"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "ListPlot", "]"}]}]}], "]"}], ":=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{"data", ",", "lag"}], "]"}], ",", 
       RowBox[{"Drop", "[", 
        RowBox[{"data", ",", 
         RowBox[{"-", "lag"}]}], "]"}]}], "}"}], "]"}], ",", "opts"}], 
   "]"}]}]], "Input",
 CellTags->"8.4 Solutions"],

Cell["\<\
Trying it out on a sequence of \[OpenCurlyDoubleQuote]random\
\[CloseCurlyDoubleQuote] numbers generated using a linear congruential \
generator shows patterns that indicate a very low likelihood of randomness in \
the sequence.\
\>", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"BlockRandom", "[", 
    RowBox[{
     RowBox[{"SeedRandom", "[", 
      RowBox[{"1", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Congruential\>\"", ",", 
          RowBox[{"\"\<Multiplier\>\"", "\[Rule]", "11"}], ",", 
          RowBox[{"\"\<Increment\>\"", "\[Rule]", "0"}], ",", 
          RowBox[{"\"\<Modulus\>\"", "\[Rule]", "17"}]}], "}"}]}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"RandomReal", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", "1000", "}"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"LagPlot", "[", 
    RowBox[{"data", ",", "i", ",", 
     RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJztz7GJQlEQhtGL24dgH8LrwdBQMDa1EsvYSFNDQwMFAwMRWVYREe1A3h3e
NOGZ5IcvGc5gMhtNe6WU608p7fbrrZvVsr2/Zr+r13Q9dps99pI99pR9UW+T
PfaZPfaQfVjvkT32P/u83i37uN4x+/vV3jl77D17/PnN3jm7zs/Pz8/Pz8/P
z8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/P
z8/Pz8/P/63+D5LkJkg=
       "]]}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesOrigin->{0, 0},
    ImageSize->{126.24999999999824`, Automatic},
    PlotRange->{{0., 0.9411764705882353}, {0., 0.9411764705882353}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJztz0EKgUEcxuGJeyj3UN8dLC2Vta2TOIYVW0tLC8rCQpIkSdxA34z5X8Lz
bqZmfk09/fF0OOmklG7dlNpzv8trVst216aXt/2d66a8X5ralftTdPO8TXTl
/hVdeT9EN8h7Rlfub9HN8u7RjfKO0X3e7c7RlfdHdOXfRXTVVbvqqh0/Pz8/
Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/
Pz8/Pz8/Pz8/P/+/+L+LTSAN
       "]]}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesOrigin->{0, 0},
    ImageSize->{124.999999999999, Automatic},
    PlotRange->{{0., 0.9411764705882353}, {0., 0.9411764705882353}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJztz7GJQkEUhtFB+xDsQ5geDA2FjU2txDKMNDU0NFDYwEBEVBYR2e1A3oxz
i1jOn1x4w/fgDKez8VcvpXTrp9TdQdkur1fdrvmw73bJ9fvmc0+f7/u8KNvm
1tX7iq6+f0c3KntGV+89unnZT3STsmN0f7/dztHV90d09T/L6Jqjdc3RuuZo
HT8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/
Pz8/Pz8/Pz8/Pz8/Pz8//3/1vwGDrhg9
       "]]}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesOrigin->{0, 0},
    ImageSize->{126.24999999999935`, Automatic},
    PlotRange->{{0., 0.9411764705882353}, {0., 0.9411764705882353}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}], ",", 
   GraphicsBox[{{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJztzzFqQkEUBdBB9yG4D2H2YGkpWKd1JVmGlbYpU6ZQsLAIIhJCCKI7kD8z
bxYh5zYP/pt/eWe6fJuvRiml6zilYR72Qy55tx1yzZOS7zY/8nvJZ67v9u37
rc2vtj/m6JmV/Peeuv/pPeuS396zKDn1nsd9yLn31P1f76n/bXpP3B09cXf0
xN3RE3dHDz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/
Pz8/Pz8/Pz8/Pz8/Pz8/Pz8/Pz8//6v4n0OeEG0=
       "]]}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesOrigin->{0, 0},
    ImageSize->{126.2499999999998, Automatic},
    PlotRange->{{0., 0.9411764705882353}, {0., 0.9411764705882353}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], 
      Scaled[0.02]}]}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell["\<\
NIST describes the data in lew.dat as originating \[OpenCurlyDoubleQuote]from \
an underlying single-cycle sinusoidal model.\[CloseCurlyDoubleQuote]\
\>", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"lewdata", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Data\>\"", ",", 
        "\"\<lew.dat\>\""}], "}"}], "]"}], ",", "\"\<List\>\""}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LagPlot", "[", 
  RowBox[{"lewdata", ",", "1", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJx91r9PU1EUwPETJ0ZGxro4OBAcHIwO1wWJUyVEUTDcQktbUCkoUEpLz+tf
wOjY0ZGR8WyuHR3f6NjR0R/c85LvHbxJc5NPmryX8/Pd3z1ab90Tke9/fn/v
f2da2N19cHfrc4PLcuaNALftAA8Dup4ZPHbptVP6fEAPHboe0hc08z162KH3
C7q8octj+tIk85cGt80A/6X0skUPTfr1kD49pWuXbieZjzJvZv6OXhZ0qRl9
I8B/auYf6LpP9zy7x3N6rUvXj/SvSvfnusvTAK/qNLlsGzxG+s2Ybkf0skPv
fabPrzJv0OUFvaqf5Pra6Ol/7jqiex+4hy59fkyfjei1Fl126FbQ5VHma+G/
XkaDV/WdvBzQ44CuLbqu0xcmdHlocO9T9xulx090nxvuK2f0xRFd9+hhI/MJ
XeoGjz4v3YeZ9+m1Dt069JnSdYsuq/QqTsllyeBaD/BQ0LVJrzXpNsz8lD7t
0q+PMx/TLdLlGV0mdH1vcM+Le/2SPjunS5fue8S9zPaLzx13eRDgVX8kF4+T
x7VFLy/oepF5m+57y73M91kweFVnye2KvviF7nlxjz2658XdGnTboM8Lup95
Pl/S+ZG5pj3lXmvQ62P6tEe3Nr3Xp8cLejUfPN5t+lpB97y7+xxyr/ovua4Z
3N4G+JJmfkz3PeluJwE+HdN9z7nrqsF9TrlLylM117x+kpdD+vUZ3d/DPR7Q
6wVdAl3XA/yb0mP6LnCPbXo4p08v6bZPj7v0m4IuT+jyKsBvla5pr9xm+8Z9
nn/XDunWontfu8/yfl+mi8cv+Urmlup2JZtH7prt5cU+3Tr0cEg3pctm5b8B
/8gvZw==
     "]]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->Small,
  PlotRange->{{-579., 300.}, {-579., 300.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, set the options for ",
 Cell[BoxData["Correlogram"]],
 ", giving a default value for ",
 Cell[BoxData["Coefficient"]],
 " of ",
 StyleBox["0.05", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Correlogram", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Coefficient", "\[Rule]", "0.05"}], "}"}], ",", 
     RowBox[{"Options", "[", "ListPlot", "]"}]}], "]"}]}], ";"}]], "InputOnly",\

 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Correlogram", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"{", 
     RowBox[{"lagmin_", ",", "lagmax_", ",", 
      RowBox[{"incr_:", "1"}]}], "}"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rh", ",", "corrs"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rh", "=", 
      RowBox[{"OptionValue", "[", "Coefficient", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"corrs", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"lag", ",", 
          RowBox[{"AutoCorrelation", "[", 
           RowBox[{"data", ",", "lag"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"lag", ",", "lagmin", ",", "lagmax", ",", "incr"}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"corrs", ",", "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "ListPlot", "]"}]}], "]"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", ".4"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "False"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "False"}], "}"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thin", ",", "Dashed", ",", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "rh"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lagmax", "-", "lagmin", "+", "1"}], ")"}], "/", 
                "incr"}], ",", "rh"}], "}"}]}], "}"}], "]"}], ",", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"-", "rh"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"lagmax", "-", "lagmin", "+", "1"}], ")"}], "/", 
                "incr"}], ",", 
               RowBox[{"-", "rh"}]}], "}"}]}], "}"}], "]"}]}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AutoCorrelation", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"lag_:", "1"}]}], "]"}], ":=", 
  RowBox[{"Correlation", "[", 
   RowBox[{
    RowBox[{"Drop", "[", 
     RowBox[{"data", ",", "lag"}], "]"}], ",", 
    RowBox[{"Drop", "[", 
     RowBox[{"data", ",", 
      RowBox[{"-", "lag"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell["\<\
Try out the function on some sinusoidal data with some noise added.\
\>", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"RandomReal", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "2"}], "}"}], "]"}], 
      RowBox[{"Sin", "[", 
       RowBox[{"x", "+", 
        RowBox[{"RandomReal", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", ".25"}], ",", ".25"}], "}"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"10", "\[Pi]"}], ",", ".05"}], "}"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"8.4 Solutions"],

Cell["Exercise some of the options.", "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Correlogram", "[", 
  RowBox[{"data", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "100"}], "}"}], ",", 
   RowBox[{"Coefficient", "\[Rule]", "0.1"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.2"}], ",", "0.2"}], "}"}]}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<Auto-correlation coeff.\>\"", ",", "None"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Lags\>\"", ",", "None"}], "}"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJzt1+tTVHUYB/CDTl7SGUBBEJkJGQQ0QG7eYIHvqqAr110uu2lQEWRSiqKR
CcrxAoZclEBULqZQXlBwQaUUk9VUBgNSc9JGQZvUdCaTBNGxCTvNPufFeV71
B7BvmA/f85zfOWf3zHd+k5PTdanDBEHwsBCE//6aP70hhrnXu0dsqAyhf2D8
hsH+pPzyVjNH4aabn+uguJdshSaxtffKm8fpeBsUW8Rs9xX2k+1h77n07NKG
E2RHrD73HEtufE12wqXvjaGG0/L5nXG4SR3oObme7IJS6/pvb866QMe74lLw
orrehE/J7jj2sOSsqS+Xjp+Gv9ckuqgKV1HugbS7k6wvux2l3AuaTi+ftzce
IXvDtfSjbwoa6+h4HyTXtFW2d1eQffFd84QxmtB9dLwf2ut2/pSEKrI/+u8v
qy86sZU8AwNtww2jUuTnMxO+8cZjmdk15FkwrBAe6Ou30/lnY31GXtaul4co
n4O88Nj8e02HyQFovnMlNTL/Szo+EImTe5tT23aQVfig5JcVEfoKOj4II73j
bjgEG8nBeL8ydOrEOnn9EGQVpd1yCpafL9D3yOJh654C8/lEINAtt7Po3EbK
1ci27bC+aFlrtqiGprFAVRwl0vpzETD2Z590h3zKJT+6ZVE0fCXl8/DjH8aC
ngL6vsV50Kg/efZ6QBnl8+Hf0BBS5FJM8/PhWdx+K/LVNlo/FE7rW1W99+h+
xVD0bJ76YqLdHpoPw9Xhh6OLPL+g+TBs3bC5tGzTbppfgJxlm/ovXt5E+QKE
lldn/eVfSvlCVHUM1Hf27KPzL8TTq2Nge/EzyjUo1qWvKZ9A34eowQ63xTXz
jXS9wiI80DlHVrx2kuYXYYmp8OGa5Aa6vnBk1DxNF+1bKA/Hbk1Lrja6juYj
MHjyYNKToHzKI3BN96uN+wH5+URibeUTh1bnasojEZQu7FSXNFEehYqwwZzH
++h9E6MQG9Q50up3+X2MRkO4eGJEWCPl0WhOsl4b6CpfXwzWF6afyok5bzZi
kGDraP3x6Gq63xgs/0orHlKLZptiMKwkwEPIplzQIirC0HHDl74faFFmu/LA
lOWbaT0tTh2xNTbdKTXbpMWZtXbnbl+T338dcsL1v20ZvcN8PujQdbqj1cGO
no+ogyo7aN3LtBKa16EhsKZbmCi/r7E4f/eMwe+oPB8L956kjgs/pNJ8LNrb
FvqnnNlJ1x+LkVX2tS0Z9DyFOPRVC5+/eF5C83Eoz0x2tEwrpOuPQ5u7+GF9
VR7NxyHo1asuh2z59xWPblXG3Lyt9HtCPMrup9n1XG2k9eOxzdT1uCZzBV1/
PPLfqFy9/89dtH4CFte+e22KN71fSMC4VWOfTd17kNZPwCRtyvPZ7+ym+QQ4
C9MTr1wvp3k9stZZOhxPiaTnr8e4f+r040eX0fp6bNFOybQyyPN6OCUNJKaG
FdL1G2Dj1ZU88JTWgwGe01vv1Fpm0rwBB99Lcs82HqD7N6DlXqZ6Wr98/29h
SWJPX8/txeReuTfkD5QcxWzFbMNsz+zI7MTszOzC7MrszjyN2YPZi9mb2YfZ
l9mP2Z95BvNM5lnMs5nnMAcwBzKrmIOYg5lDmKG0yCz1hzJnlvpDmTNL/aHM
maX+UObMUn8oc2apP5Q5s9QfypxZ6g9lziz1hzJnlvpDmTNL/aHMmaX+UObM
Un8oc2apP5Q5s9QfypxZ6g8FwSwym5il/lDOM4vMJmapP5TzzCKziVnqD+U8
s8hsYpb6QznPLDKbmKX+UM4zi8wmZqk/lPPMIrOJWeoP5TyzyGxilvpDOc8s
MpuYpf5Qemj/MbT/GNp/DO0/hvYf5vmh/cf/3X/8C/tXBfU=
   "], {{{}, {}, {}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], LineBox[{102, 2}], LineBox[{103, 3}],
       LineBox[{108, 8}], LineBox[{109, 9}], LineBox[{112, 12}], 
      LineBox[{114, 14}], LineBox[{115, 15}], LineBox[{118, 18}], 
      LineBox[{119, 19}], LineBox[{120, 20}], LineBox[{121, 21}], 
      LineBox[{122, 22}], LineBox[{124, 24}], LineBox[{125, 25}], 
      LineBox[{128, 28}], LineBox[{129, 29}], LineBox[{130, 30}], 
      LineBox[{131, 31}], LineBox[{133, 33}], LineBox[{134, 34}], 
      LineBox[{136, 36}], LineBox[{140, 40}], LineBox[{141, 41}], 
      LineBox[{144, 44}], LineBox[{145, 45}], LineBox[{146, 46}], 
      LineBox[{147, 47}], LineBox[{149, 49}], LineBox[{150, 50}], 
      LineBox[{151, 51}], LineBox[{155, 55}], LineBox[{165, 65}], 
      LineBox[{166, 66}], LineBox[{167, 67}], LineBox[{172, 72}], 
      LineBox[{173, 73}], LineBox[{176, 76}], LineBox[{177, 77}], 
      LineBox[{178, 78}], LineBox[{180, 80}], LineBox[{182, 82}], 
      LineBox[{183, 83}], LineBox[{184, 84}], LineBox[{185, 85}], 
      LineBox[{188, 88}], LineBox[{193, 93}], LineBox[{195, 95}], 
      LineBox[{197, 97}], LineBox[{198, 98}], LineBox[{199, 99}], 
      LineBox[{200, 100}]}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], LineBox[{101, 1}], LineBox[{104, 4}],
       LineBox[{105, 5}], LineBox[{106, 6}], LineBox[{107, 7}], 
      LineBox[{110, 10}], LineBox[{111, 11}], LineBox[{113, 13}], 
      LineBox[{116, 16}], LineBox[{117, 17}], LineBox[{123, 23}], 
      LineBox[{126, 26}], LineBox[{127, 27}], LineBox[{132, 32}], 
      LineBox[{135, 35}], LineBox[{137, 37}], LineBox[{138, 38}], 
      LineBox[{139, 39}], LineBox[{142, 42}], LineBox[{143, 43}], 
      LineBox[{148, 48}], LineBox[{152, 52}], LineBox[{153, 53}], 
      LineBox[{154, 54}], LineBox[{156, 56}], LineBox[{157, 57}], 
      LineBox[{158, 58}], LineBox[{159, 59}], LineBox[{160, 60}], 
      LineBox[{161, 61}], LineBox[{162, 62}], LineBox[{163, 63}], 
      LineBox[{164, 64}], LineBox[{168, 68}], LineBox[{169, 69}], 
      LineBox[{170, 70}], LineBox[{171, 71}], LineBox[{174, 74}], 
      LineBox[{175, 75}], LineBox[{179, 79}], LineBox[{181, 81}], 
      LineBox[{186, 86}], LineBox[{187, 87}], LineBox[{189, 89}], 
      LineBox[{190, 90}], LineBox[{191, 91}], LineBox[{192, 92}], 
      LineBox[{194, 94}], LineBox[{196, 96}]}}, {{}, 
     {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwNz9c6ggEAANA/OyuRGepHKJ7GI/hc85xZ2ZS9Ze+9zsV5gBNOzkxMR4Ig
mCLPLHPMs8AiBZZYZoVV1lhng022KFJimx122WOfAw454pgTTjnjnAvKXHLF
NTfccsc9DzzyxDMvvPLGOx988sU3P/zyRyAZoYJKqqimhlrqiFJPA4000UyM
FuK00kaCdjropItuekjSSx/9pEgTMsAgQ2QYZoRRsuQYY5x/YMU3Hw==
       "]]}, {}}}],
  AspectRatio->0.4,
  AxesOrigin->{0, 0},
  Epilog->{
    Thickness[Tiny], 
    Dashing[{Small, Small}], 
    LineBox[{{0, 0.1}, {100, 0.1}}], 
    LineBox[{{0, -0.1}, {100, -0.1}}]},
  Frame->True,
  FrameLabel->{{
     FormBox["\"Auto-correlation coeff.\"", TraditionalForm], None}, {
     FormBox["\"Lags\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, False}, {Automatic, False}},
  ImageSize->{238.74999999999636`, Automatic},
  PlotRange->{{1., 100.}, {-0.2, 0.2}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here are the binary digits of \[Pi]. ",
 Cell[BoxData[
  ButtonBox["First",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/First"]], "InlineFormula"],
 " is used to get only the digits from ",
 Cell[BoxData[
  ButtonBox["RealDigits",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RealDigits"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"First", "[", 
  RowBox[{"RealDigits", "[", 
   RowBox[{
    RowBox[{"N", "[", 
     RowBox[{"Pi", ",", "12"}], "]"}], ",", "2"}], "]"}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0"}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Convert ",
 StyleBox["0", "OsF"],
 "s to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "1"}], TraditionalForm]]],
 "s."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "%"}], "-", "1"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "1", ",", 
   RowBox[{"-", "1"}]}], "}"}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell["Here then is a plot for the first fifty thousand digits.", \
"SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", "\[IndentingNewLine]", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digits", "=", "50000"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Accumulate", "[", 
     RowBox[{
      RowBox[{"2", 
       RowBox[{"First", "[", 
        RowBox[{"RealDigits", "[", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"Pi", ",", "digits"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
      "-", "1"}], "]"}]}], "\[IndentingNewLine]", "]"}], "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Thickness[Tiny], LineBox[CompressedData["
1:eJxc3X941mXZP/BFZMvIlhEtI5tEtIhoIuJExImIExEnIk5EnYS4EHEi4kTE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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{203.3333333333335, Automatic},
  PlotRange->{{0., 166096.}, {-121., 407.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "For the two-dimensional case, use ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]], "InlineFormula"],
 " to pair up the binary digits, then a transformation rule to convert them \
to compass directions."
}], "SolutionText",
 CellTags->"8.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"digs", "=", 
     RowBox[{"First", "[", 
      RowBox[{"RealDigits", "[", 
       RowBox[{
        RowBox[{"N", "[", 
         RowBox[{"Pi", ",", "50000"}], "]"}], ",", "2"}], "]"}], "]"}]}], 
    "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ListLinePlot", "[", 
    RowBox[{
     RowBox[{"Accumulate", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"digs", ",", "2", ",", "2"}], "]"}], "/.", "\[VeryThinSpace]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}], 
  "]"}]], "Input",
 CellTags->"8.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Thickness[Tiny], LineBox[CompressedData["
1:eJzMvcuOI1e2hhf2iEMOOOCAA5ogCIIgCF7yfo3KqpLUUpXUrZbUp8/xyIAB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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{119.99999999999712`, Automatic},
  PlotRange->{{-93., 136.}, {-368., 44.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["9", "ChapterN"],

Cell[CellGroupData[{

Cell["Strings", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Structure and syntax", "ExerciseSubsection",
 CellTags->"Sec.Structure"],

Cell["\<\
Convert the first character in a string (which you may assume to be a \
lowercase letter) to uppercase.\
\>", "ExerciseItem",
 CellTags->"9.1 Exercises"],

Cell[TextData[{
 "Given a string of digits of arbitrary length, convert it to its integer \
value. (Hint: you may find that the ",
 Cell[BoxData[
  ButtonBox["Dot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dot"]], "InlineFormula"],
 " function is helpful.)"
}], "ExerciseItem",
 CellTags->"9.1 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["UniqueCharacters", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["str", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that takes a string as its argument and returns a list of the unique \
characters in that string. For example, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"UniqueCharacters", "[", "\"\<Mississippi\>\"", "]"}], 
   "ExLink"]]],
 " should return ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{"M", ",", "i", ",", "s", ",", "p"}], "}"}], "ExLink"]]],
 "."
}], "ExerciseItem",
 CellTags->"9.1 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["Here is a test string we will use for this exercise.", "SolutionItem",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", "\"\<this is a test string\>\""}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"this is a test string\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "This extracts the first character from ",
 Cell[BoxData["str"]],
 "."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringTake", "[", 
  RowBox[{"str", ",", "1"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"t\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["Here is its character code.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCharacterCode", "[", "%", "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", "116", "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "For each lowercase letter of the English alphabet, subtracting ",
 StyleBox["32", "OsF"],
 " gives the corresponding uppercase character."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "-", "32"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", "84", "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["Convert back to a character.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromCharacterCode", "[", "%", "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"T\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["Take the original string minus its first character.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringDrop", "[", 
  RowBox[{"str", ",", "1"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"his is a test string\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Finally, join the previous string with the capital ",
 StyleBox["T",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringJoin", "[", 
  RowBox[{"%%", ",", "%"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"This is a test string\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "You can do this more efficiently using ",
 Cell[BoxData[
  ButtonBox["ToUpperCase",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ToUpperCase"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["StringTake",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringTake"]], "InlineFormula"],
 ". This approach is more general in that it does not assume that the first \
character in your string is lower case."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToUpperCase", "[", 
  RowBox[{"StringTake", "[", 
   RowBox[{"str", ",", "1"}], "]"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"T\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringTake", "[", 
  RowBox[{"str", ",", 
   RowBox[{"2", ";;", 
    RowBox[{"-", "1"}]}]}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"his is a test string\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToUpperCase", "[", 
   RowBox[{"StringTake", "[", 
    RowBox[{"str", ",", "1"}], "]"}], "]"}], "<>", 
  RowBox[{"StringTake", "[", 
   RowBox[{"str", ",", 
    RowBox[{"2", ";;", 
     RowBox[{"-", "1"}]}]}], "]"}]}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"This is a test string\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["One approach converts the string to character codes.", "SolutionItem",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"ToCharacterCode", "[", "\"\<10495\>\"", "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"%", "-", "48"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   SuperscriptBox["10", "j"], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "4", ",", "0", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"%", ".", "%%"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[TextData[{
 "This is a good place to use ",
 Cell[BoxData[
  ButtonBox["Fold",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Fold"]], "InlineFormula"],
 ". Using ",
 Cell[BoxData[
  ButtonBox["FoldList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FoldList"]], "InlineFormula"],
 ", you can see how the expression is built up."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#2", "+", 
     RowBox[{"10", " ", "#1"}]}], "&"}], ",", "0", ",", 
   RowBox[{
    RowBox[{"ToCharacterCode", "[", "\"\<10495\>\"", "]"}], "-", "48"}]}], 
  "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[TextData[{
 "Much more directly, use ",
 Cell[BoxData[
  ButtonBox["ToExpression",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ToExpression"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"ToExpression", "[", "\"\<10495\>\"", "]"}]], "Input",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Start by extracting the individual characters in a string.", \
"SolutionItem",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Mississippi\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Characters", "[", "str", "]"}]}], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"M\"\>", ",", "\<\"i\"\>", ",", "\<\"s\"\>", ",", "\<\"s\"\>", 
   ",", "\<\"i\"\>", ",", "\<\"s\"\>", ",", "\<\"s\"\>", ",", "\<\"i\"\>", 
   ",", "\<\"p\"\>", ",", "\<\"p\"\>", ",", "\<\"i\"\>"}], "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["This gives the set of unique characters in this string.", "SolutionText",
 CellChangeTimes->{{3.524663029895256*^9, 3.524663030779982*^9}},
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Union", "[", 
  RowBox[{"Characters", "[", "str", "]"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"i\"\>", ",", "\<\"M\"\>", ",", "\<\"p\"\>", ",", "\<\"s\"\>"}],
   "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Union",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Union"]], "InlineFormula"],
 " sorts the list whereas ",
 Cell[BoxData[
  ButtonBox["DeleteDuplicates",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DeleteDuplicates"]], "InlineFormula"],
 " does not."
}], "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DeleteDuplicates", "[", 
  RowBox[{"Characters", "[", "str", "]"}], "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"M\"\>", ",", "\<\"i\"\>", ",", "\<\"s\"\>", ",", "\<\"p\"\>"}],
   "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["Here then is the function.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UniqueCharacters", "[", "str_String", "]"}], ":=", 
  RowBox[{"DeleteDuplicates", "[", 
   RowBox[{"Characters", "[", "str", "]"}], "]"}]}]], "InputOnly",
 CellTags->"9.1 Solutions"],

Cell["Try it out on a more interesting example.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"protein", "=", 
  RowBox[{"ProteinData", "[", "\"\<PP2672\>\"", "]"}]}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData["\<\"\
MKSSEELQCLKQMEEELLFLKAGQGSQRARLTPPLPRALQGNFGAPALCGIWFAEHLHPAVGMPPNYNSSMLSLSPER\
TILSGGWSGKQTQQPVPPLRTLLLRSPFSLHKSSQPGSPKASQRIHPLFHSIPRSQLHSVLLGLPLLFIQTRPSPPAQ\
YGAQMPLRYICFGPNIFWGSKKPQKE\"\>"], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UniqueCharacters", "[", "protein", "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"M\"\>", ",", "\<\"K\"\>", ",", "\<\"S\"\>", ",", "\<\"E\"\>", 
   ",", "\<\"L\"\>", ",", "\<\"Q\"\>", ",", "\<\"C\"\>", ",", "\<\"F\"\>", 
   ",", "\<\"A\"\>", ",", "\<\"G\"\>", ",", "\<\"R\"\>", ",", "\<\"T\"\>", 
   ",", "\<\"P\"\>", ",", "\<\"N\"\>", ",", "\<\"I\"\>", ",", "\<\"W\"\>", 
   ",", "\<\"H\"\>", ",", "\<\"V\"\>", ",", "\<\"Y\"\>"}], "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],

Cell["It even works in the degenerate case.", "SolutionText",
 CellTags->"9.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UniqueCharacters", "[", "\"\<\>\"", "]"}]], "Input",
 CellTags->"9.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellTags->"9.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Operations on strings", "ExerciseSubsection",
 CellTags->"Sec.Operations"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["PalindromeQ", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["str", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that returns a value of ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/True"]], "InlineFormula"],
 " if its argument ",
 StyleBox["str",
  FontSlant->"Italic"],
 " is a palindrome, that is, if the string ",
 StyleBox["str",
  FontSlant->"Italic"],
 " is the same forward and backward. For example, ",
 StyleBox["refer",
  FontSlant->"Italic"],
 " is a palindrome."
}], "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:41"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["StringRotateLeft", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that takes a string ",
 StyleBox["str",
  FontSlant->"Italic"],
 ", and returns a string with the characters rotated to the left ",
 StyleBox["n",
  FontSlant->"Italic"],
 " places. For example:"
}], "ExerciseItem",
 CellTags->"9.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringRotateLeft", "[", 
  RowBox[{"\"\<a quark for Muster Mark \>\"", ",", "8"}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.2 Exercises"],

Cell[BoxData["\<\"for Muster Mark a quark \"\>"], "ExerciseOutput", "ExerciseMR",
 CellTags->"9.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "In creating the function ",
 Cell[BoxData[
  StyleBox["MakeVarList", "ExLink"]]],
 " in this section, we were not careful about the arguments that might be \
passed. Correct this problem using pattern matching on the arguments to this \
function to insure that the indices are positive integers only."
}], "ExerciseItem",
 CellTags->"9.2 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["StringPad", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    RowBox[{
     StyleBox["{", "ExLink"], 
     StyleBox["n", "ExerciseTI"], 
     StyleBox["}", "ExLink"]}]}], 
   StyleBox["]", "ExLink"]}]]],
 " that pads the end of a string with ",
 StyleBox["n",
  FontSlant->"Italic"],
 " whitespace characters. Then create a second rule ",
 Cell[BoxData[
  RowBox[{
   StyleBox["StringPad", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that pads the string out to length ",
 StyleBox["n",
  FontSlant->"Italic"],
 ". If the input string has length greater than ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", issue a warning message. Finally, mirroring the argument structure for \
the built-in ",
 Cell[BoxData[
  ButtonBox["PadLeft",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/PadLeft"]]],
 ", create a third rule ",
 Cell[BoxData[
  RowBox[{
   StyleBox["StringPad", "ExLink"], 
   StyleBox["[", "ExLink"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["n", "ExerciseTI"], 
    StyleBox[",", "ExLink"], 
    StyleBox["m", "ExerciseTI"]}], 
   StyleBox["]", "ExLink"]}]]],
 " that pads with ",
 StyleBox["n",
  FontSlant->"Italic"],
 " whitespaces at the front and ",
 StyleBox["m",
  FontSlant->"Italic"],
 " whitespaces at the end of the string."
}], "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:42"}],

Cell["\<\
Modify the Caesar cipher so that it encodes by shifting five places to the \
right. Include the space character in the alphabet.\
\>", "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:43"}],

Cell[CellGroupData[{

Cell[TextData[{
 "A mixed-alphabet cipher is created by first writing a keyword followed by \
the remaining letters of the alphabet and then using this as the substitution \
(or cipher) text. For example, if the keyword is ",
 StyleBox["django",
  FontSlant->"Italic"],
 ", the cipher text alphabet would be:"
}], "ExerciseItem",
 CellTags->"9.2 Exercises"],

Cell[BoxData["\<\"djangobcefhiklmpqrstuvwxyz\"\>"], "ExerciseOutput", "ExerciseMR",
 Deletable->False,
 CellTags->"9.2 Exercises"],

Cell[TextData[{
 "So, ",
 StyleBox["a",
  FontSlant->"Italic"],
 " is replaced with ",
 StyleBox["d",
  FontSlant->"Italic"],
 ", ",
 StyleBox["b",
  FontSlant->"Italic"],
 " is replaced with ",
 StyleBox["j",
  FontSlant->"Italic"],
 ", ",
 StyleBox["c",
  FontSlant->"Italic"],
 " is replaced with ",
 StyleBox["a",
  FontSlant->"Italic"],
 ", and so on. As an example, the piece of text"
}], "ExerciseText",
 CellTags->"9.2 Exercises"],

Cell[TextData[{
 " \t",
 StyleBox["the sheik of araby",
  FontSlant->"Italic"],
 " "
}], "ExerciseText",
 CellTags->"9.2 Exercises"],

Cell["would then be encoded as", "ExerciseText",
 CellTags->"9.2 Exercises"],

Cell[TextData[{
 "\t",
 StyleBox["tcg scgeh mo drdjy",
  FontSlant->"Italic"]
}], "ExerciseText",
 CellTags->"9.2 Exercises"],

Cell["\<\
Implement this cipher and go one step further to output the cipher text in \
blocks of length five, omitting spaces and punctuation. \
\>", "ExerciseText",
 CellTags->"9.2 Exercises"]
}, Closed]],

Cell[TextData[{
 "Modify the alphabet permutation cipher so that instead of being based on \
single letters, it is instead based on adjacent pairs of letters. The single \
letter cipher will have ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox[
     RowBox[{"26", "!"}], "OsF"], " ", "=", 
    FormBox[
     StyleBox["403291461126605635584000000", "OsF"],
     TraditionalForm]}], TraditionalForm]]],
 " permutations; the adjacent pairs cipher will have ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SuperscriptBox[
      StyleBox["26", "OsF"], 
      StyleBox["2", "OsF"]], "!"}], "\[ThinSpace]", "=", 
    FormBox[
     RowBox[{
      StyleBox["1.883707684133810", "OsF"], "\[Times]", 
      SuperscriptBox[
       StyleBox["10", "OsF"], 
       StyleBox["1621", "OsF"]]}],
     TraditionalForm]}], TraditionalForm]]],
 " permutations."
}], "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:44"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
Here is the function that checks if a string is a palindrome.\
\>", "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "str_String", "]"}], ":=", 
  RowBox[{
   RowBox[{"StringReverse", "[", "str", "]"}], "==", "str"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<mood\>\"", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["False"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<PoP\>\"", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["\<\
An argument that is a number is converted to a string and then the previous \
rule is called.\
\>", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "num_Integer", "]"}], ":=", 
  RowBox[{"PalindromeQ", "[", 
   RowBox[{"ToString", "[", "num", "]"}], "]"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "12522521", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Get all words in the dictionary that comes with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.52466318116742*^9, 3.524663184901231*^9}},
 CellTags->"9.2 Solutions"],

Cell[TextData[{
 "Select those that pass the ",
 Cell[BoxData["PalindromeQ"]],
 " test."
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{"words", ",", "PalindromeQ"}], "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aha\"\>", ",", "\<\"aka\"\>", 
   ",", "\<\"bib\"\>", ",", "\<\"bob\"\>", ",", "\<\"boob\"\>", 
   ",", "\<\"bub\"\>", ",", "\<\"CFC\"\>", ",", "\<\"civic\"\>", 
   ",", "\<\"dad\"\>", ",", "\<\"deed\"\>", ",", "\<\"deified\"\>", 
   ",", "\<\"did\"\>", ",", "\<\"dud\"\>", ",", "\<\"DVD\"\>", 
   ",", "\<\"eke\"\>", ",", "\<\"ere\"\>", ",", "\<\"eve\"\>", 
   ",", "\<\"ewe\"\>", ",", "\<\"eye\"\>", ",", "\<\"gag\"\>", 
   ",", "\<\"gig\"\>", ",", "\<\"huh\"\>", ",", "\<\"I\"\>", 
   ",", "\<\"kayak\"\>", ",", "\<\"kook\"\>", ",", "\<\"level\"\>", 
   ",", "\<\"ma'am\"\>", ",", "\<\"madam\"\>", ",", "\<\"mam\"\>", 
   ",", "\<\"MGM\"\>", ",", "\<\"minim\"\>", ",", "\<\"mom\"\>", 
   ",", "\<\"mum\"\>", ",", "\<\"nan\"\>", ",", "\<\"non\"\>", 
   ",", "\<\"noon\"\>", ",", "\<\"nun\"\>", ",", "\<\"oho\"\>", 
   ",", "\<\"pap\"\>", ",", "\<\"peep\"\>", ",", "\<\"pep\"\>", 
   ",", "\<\"pip\"\>", ",", "\<\"poop\"\>", ",", "\<\"pop\"\>", 
   ",", "\<\"pup\"\>", ",", "\<\"radar\"\>", ",", "\<\"redder\"\>", 
   ",", "\<\"refer\"\>", ",", "\<\"repaper\"\>", ",", "\<\"reviver\"\>", 
   ",", "\<\"rotor\"\>", ",", "\<\"sagas\"\>", ",", "\<\"sees\"\>", 
   ",", "\<\"seres\"\>", ",", "\<\"sexes\"\>", ",", "\<\"shahs\"\>", 
   ",", "\<\"sis\"\>", ",", "\<\"solos\"\>", ",", "\<\"SOS\"\>", 
   ",", "\<\"stats\"\>", ",", "\<\"stets\"\>", ",", "\<\"tat\"\>", 
   ",", "\<\"tenet\"\>", ",", "\<\"TNT\"\>", ",", "\<\"toot\"\>", 
   ",", "\<\"tot\"\>", ",", "\<\"tut\"\>", ",", "\<\"wow\"\>", 
   ",", "\<\"WWW\"\>"}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Use the argument structure of ",
 Cell[BoxData[
  ButtonBox["RotateLeft",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/RotateLeft"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringRotateLeft", "[", 
   RowBox[{"str_", ",", 
    RowBox[{"n_:", "1"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"RotateLeft", "[", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], ",", "n"}], "]"}], 
   "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringRotateLeft", "[", 
  RowBox[{"\"\<squeamish ossifrage\>\"", ",", "5"}], "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"mish ossifragesquea\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using a negative index is a problem when the string is converted using ",
 Cell[BoxData[
  ButtonBox["ToExpression",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ToExpression"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToString", "[", "x", "]"}], "<>", 
   RowBox[{"ToString", "[", 
    RowBox[{"-", "2"}], "]"}]}], "//", "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToExpression", "[", "%", "]"}], "//", "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell["\<\
Argument checking with a different pattern corrects this problem.\
\>", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "MakeVarList", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeVarList", "[", 
   RowBox[{"x_Symbol", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n_Integer", "?", "Positive"}], ",", 
      RowBox[{"m_Integer", "?", "Positive"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", 
       RowBox[{"ToString", "[", "#", "]"}]}], "&"}], ",", 
     RowBox[{"Range", "[", 
      RowBox[{"n", ",", "m"}], "]"}]}], "]"}], "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"MakeVarList", "[", 
  RowBox[{"tmp", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, using ",
 Cell[BoxData[
  ButtonBox["StringJoin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringJoin"]], "InlineFormula"],
 ", put ",
 StyleBox["n",
  FontSlant->"Italic"],
 " spaces at the end of the string."
}], "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", 
    RowBox[{"{", "5", "}"}]}], "]"}], "//", "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<ciao     \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "For the second rule, first create a message that will be issued if the \
string is longer than ",
 StyleBox["n",
  FontSlant->"Italic"],
 "."
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPad", "::", "badlen"}], "=", 
   "\"\<Pad length `1` must be greater than the length of string `2`.\>\""}], 
  ";"}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{"StringLength", "[", "str", "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"len", ">", "n"}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ",", "n", ",",
         "str"}], "]"}], ",", 
      RowBox[{"StringPad", "[", 
       RowBox[{"str", ",", 
        RowBox[{"{", 
         RowBox[{"n", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "8"}], "]"}], "//", "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<ciao    \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringPad", "[", 
  RowBox[{"\"\<ciao\>\"", ",", "3"}], "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ":", 
  " ", "\<\"Pad length \[NoBreak]\\!\\(3\\)\[NoBreak] must be greater than \
the length of string \[NoBreak]\\!\\(\\\"ciao\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["\<\
Finally, here is a rule for padding at the beginning and end of the string.\
\>", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}], ",", "str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "m", "}"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "3", ",", "8"}], "]"}], "//", 
  "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<   ciao        \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Note, ",
 Cell[BoxData[
  ButtonBox["StringInsert",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringInsert"]], "InlineFormula"],
 " could also be used."
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringInsert", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "\"\< \>\"", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "//", "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\< ciao \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad2", "[", 
   RowBox[{"str_String", ",", "n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"StringInsert", "[", 
   RowBox[{"str", ",", "\"\< \>\"", ",", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", "n", "}"}]}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"{", "m", "}"}]}], "]"}]}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad2", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "3", ",", "8"}], "]"}], "//", 
  "FullForm"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<   ciao        \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This is a simple modification of the code given in the text. But first we add \
the space character to the alphabet.\
\>", "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCharacterCode", "[", "\"\< \>\"", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", "32", "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"alphabet", " ", "=", " ", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"FromCharacterCode", "[", "32", "]"}], "}"}], ",", 
    RowBox[{"CharacterRange", "[", 
     RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\" \"\>", ",", "\<\"a\"\>", ",", "\<\"b\"\>", ",", "\<\"c\"\>", 
   ",", "\<\"d\"\>", ",", "\<\"e\"\>", ",", "\<\"f\"\>", ",", "\<\"g\"\>", 
   ",", "\<\"h\"\>", ",", "\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"k\"\>", 
   ",", "\<\"l\"\>", ",", "\<\"m\"\>", ",", "\<\"n\"\>", ",", "\<\"o\"\>", 
   ",", "\<\"p\"\>", ",", "\<\"q\"\>", ",", "\<\"r\"\>", ",", "\<\"s\"\>", 
   ",", "\<\"t\"\>", ",", "\<\"u\"\>", ",", "\<\"v\"\>", ",", "\<\"w\"\>", 
   ",", "\<\"x\"\>", ",", "\<\"y\"\>", ",", "\<\"z\"\>"}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"coderules", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{"alphabet", "\[Rule]", 
    RowBox[{"RotateRight", "[", 
     RowBox[{"alphabet", ",", "5"}], "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\" \"\>", "\[Rule]", "\<\"v\"\>"}], ",", 
   RowBox[{"\<\"a\"\>", "\[Rule]", "\<\"w\"\>"}], ",", 
   RowBox[{"\<\"b\"\>", "\[Rule]", "\<\"x\"\>"}], ",", 
   RowBox[{"\<\"c\"\>", "\[Rule]", "\<\"y\"\>"}], ",", 
   RowBox[{"\<\"d\"\>", "\[Rule]", "\<\"z\"\>"}], ",", 
   RowBox[{"\<\"e\"\>", "\[Rule]", "\<\" \"\>"}], ",", 
   RowBox[{"\<\"f\"\>", "\[Rule]", "\<\"a\"\>"}], ",", 
   RowBox[{"\<\"g\"\>", "\[Rule]", "\<\"b\"\>"}], ",", 
   RowBox[{"\<\"h\"\>", "\[Rule]", "\<\"c\"\>"}], ",", 
   RowBox[{"\<\"i\"\>", "\[Rule]", "\<\"d\"\>"}], ",", 
   RowBox[{"\<\"j\"\>", "\[Rule]", "\<\"e\"\>"}], ",", 
   RowBox[{"\<\"k\"\>", "\[Rule]", "\<\"f\"\>"}], ",", 
   RowBox[{"\<\"l\"\>", "\[Rule]", "\<\"g\"\>"}], ",", 
   RowBox[{"\<\"m\"\>", "\[Rule]", "\<\"h\"\>"}], ",", 
   RowBox[{"\<\"n\"\>", "\[Rule]", "\<\"i\"\>"}], ",", 
   RowBox[{"\<\"o\"\>", "\[Rule]", "\<\"j\"\>"}], ",", 
   RowBox[{"\<\"p\"\>", "\[Rule]", "\<\"k\"\>"}], ",", 
   RowBox[{"\<\"q\"\>", "\[Rule]", "\<\"l\"\>"}], ",", 
   RowBox[{"\<\"r\"\>", "\[Rule]", "\<\"m\"\>"}], ",", 
   RowBox[{"\<\"s\"\>", "\[Rule]", "\<\"n\"\>"}], ",", 
   RowBox[{"\<\"t\"\>", "\[Rule]", "\<\"o\"\>"}], ",", 
   RowBox[{"\<\"u\"\>", "\[Rule]", "\<\"p\"\>"}], ",", 
   RowBox[{"\<\"v\"\>", "\[Rule]", "\<\"q\"\>"}], ",", 
   RowBox[{"\<\"w\"\>", "\[Rule]", "\<\"r\"\>"}], ",", 
   RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"s\"\>"}], ",", 
   RowBox[{"\<\"y\"\>", "\[Rule]", "\<\"t\"\>"}], ",", 
   RowBox[{"\<\"z\"\>", "\[Rule]", "\<\"u\"\>"}]}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"decoderules", "=", 
  RowBox[{"Map", "[", 
   RowBox[{"Reverse", ",", "coderules"}], "]"}]}]], "Input",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"v\"\>", "\[Rule]", "\<\" \"\>"}], ",", 
   RowBox[{"\<\"w\"\>", "\[Rule]", "\<\"a\"\>"}], ",", 
   RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"b\"\>"}], ",", 
   RowBox[{"\<\"y\"\>", "\[Rule]", "\<\"c\"\>"}], ",", 
   RowBox[{"\<\"z\"\>", "\[Rule]", "\<\"d\"\>"}], ",", 
   RowBox[{"\<\" \"\>", "\[Rule]", "\<\"e\"\>"}], ",", 
   RowBox[{"\<\"a\"\>", "\[Rule]", "\<\"f\"\>"}], ",", 
   RowBox[{"\<\"b\"\>", "\[Rule]", "\<\"g\"\>"}], ",", 
   RowBox[{"\<\"c\"\>", "\[Rule]", "\<\"h\"\>"}], ",", 
   RowBox[{"\<\"d\"\>", "\[Rule]", "\<\"i\"\>"}], ",", 
   RowBox[{"\<\"e\"\>", "\[Rule]", "\<\"j\"\>"}], ",", 
   RowBox[{"\<\"f\"\>", "\[Rule]", "\<\"k\"\>"}], ",", 
   RowBox[{"\<\"g\"\>", "\[Rule]", "\<\"l\"\>"}], ",", 
   RowBox[{"\<\"h\"\>", "\[Rule]", "\<\"m\"\>"}], ",", 
   RowBox[{"\<\"i\"\>", "\[Rule]", "\<\"n\"\>"}], ",", 
   RowBox[{"\<\"j\"\>", "\[Rule]", "\<\"o\"\>"}], ",", 
   RowBox[{"\<\"k\"\>", "\[Rule]", "\<\"p\"\>"}], ",", 
   RowBox[{"\<\"l\"\>", "\[Rule]", "\<\"q\"\>"}], ",", 
   RowBox[{"\<\"m\"\>", "\[Rule]", "\<\"r\"\>"}], ",", 
   RowBox[{"\<\"n\"\>", "\[Rule]", "\<\"s\"\>"}], ",", 
   RowBox[{"\<\"o\"\>", "\[Rule]", "\<\"t\"\>"}], ",", 
   RowBox[{"\<\"p\"\>", "\[Rule]", "\<\"u\"\>"}], ",", 
   RowBox[{"\<\"q\"\>", "\[Rule]", "\<\"v\"\>"}], ",", 
   RowBox[{"\<\"r\"\>", "\[Rule]", "\<\"w\"\>"}], ",", 
   RowBox[{"\<\"s\"\>", "\[Rule]", "\<\"x\"\>"}], ",", 
   RowBox[{"\<\"t\"\>", "\[Rule]", "\<\"y\"\>"}], ",", 
   RowBox[{"\<\"u\"\>", "\[Rule]", "\<\"z\"\>"}]}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"code", "[", "str_String", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], "/.", "coderules"}]}], 
   "]"}]}]], "InputOnly",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"decode", "[", "str_String", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], "/.", "decoderules"}]}], 
   "]"}]}]], "InputOnly",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"code", "[", "\"\<squeamish ossifrage\>\"", "]"}]], "Input",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"nlp whdncvjnndamwb \"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"decode", "[", "%", "]"}]], "Input",
 AspectRatioFixed->True,
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"squeamish ossifrage\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
First, here is the list of characters from the plaintext alphabet.\
\>", "SolutionItem",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlainAlphabet", "=", 
  RowBox[{"CharacterRange", "[", 
   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"b\"\>", ",", "\<\"c\"\>", ",", "\<\"d\"\>", 
   ",", "\<\"e\"\>", ",", "\<\"f\"\>", ",", "\<\"g\"\>", ",", "\<\"h\"\>", 
   ",", "\<\"i\"\>", ",", "\<\"j\"\>", ",", "\<\"k\"\>", ",", "\<\"l\"\>", 
   ",", "\<\"m\"\>", ",", "\<\"n\"\>", ",", "\<\"o\"\>", ",", "\<\"p\"\>", 
   ",", "\<\"q\"\>", ",", "\<\"r\"\>", ",", "\<\"s\"\>", ",", "\<\"t\"\>", 
   ",", "\<\"u\"\>", ",", "\<\"v\"\>", ",", "\<\"w\"\>", ",", "\<\"x\"\>", 
   ",", "\<\"y\"\>", ",", "\<\"z\"\>"}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here is our key, ",
 StyleBox["django",
  FontSlant->"Italic"],
 ":"
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"key", "=", "\"\<django\>\""}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"django\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["And here is the cipher text alphabet, prepending the key:", \
"SolutionText",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringJoin", "[", 
  RowBox[{
   RowBox[{"Characters", "@", "key"}], ",", 
   RowBox[{"Complement", "[", 
    RowBox[{"PlainAlphabet", ",", 
     RowBox[{"Characters", "@", "key"}]}], "]"}]}], "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"djangobcefhiklmpqrstuvwxyz\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["Make a reusable function.", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CipherAlphabet", "[", "key_String", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k", "=", 
      RowBox[{"Characters", "[", "key", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"StringJoin", "[", 
     RowBox[{"k", ",", 
      RowBox[{"Complement", "[", 
       RowBox[{
        RowBox[{"CharacterRange", "[", 
         RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", "k"}], "]"}]}], 
     "]"}]}], "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell["Generate the coding rules:", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"codeRules", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{"PlainAlphabet", "\[Rule]", 
    RowBox[{"Characters", "@", 
     RowBox[{"CipherAlphabet", "[", "\"\<django\>\"", "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"a\"\>", "\[Rule]", "\<\"d\"\>"}], ",", 
   RowBox[{"\<\"b\"\>", "\[Rule]", "\<\"j\"\>"}], ",", 
   RowBox[{"\<\"c\"\>", "\[Rule]", "\<\"a\"\>"}], ",", 
   RowBox[{"\<\"d\"\>", "\[Rule]", "\<\"n\"\>"}], ",", 
   RowBox[{"\<\"e\"\>", "\[Rule]", "\<\"g\"\>"}], ",", 
   RowBox[{"\<\"f\"\>", "\[Rule]", "\<\"o\"\>"}], ",", 
   RowBox[{"\<\"g\"\>", "\[Rule]", "\<\"b\"\>"}], ",", 
   RowBox[{"\<\"h\"\>", "\[Rule]", "\<\"c\"\>"}], ",", 
   RowBox[{"\<\"i\"\>", "\[Rule]", "\<\"e\"\>"}], ",", 
   RowBox[{"\<\"j\"\>", "\[Rule]", "\<\"f\"\>"}], ",", 
   RowBox[{"\<\"k\"\>", "\[Rule]", "\<\"h\"\>"}], ",", 
   RowBox[{"\<\"l\"\>", "\[Rule]", "\<\"i\"\>"}], ",", 
   RowBox[{"\<\"m\"\>", "\[Rule]", "\<\"k\"\>"}], ",", 
   RowBox[{"\<\"n\"\>", "\[Rule]", "\<\"l\"\>"}], ",", 
   RowBox[{"\<\"o\"\>", "\[Rule]", "\<\"m\"\>"}], ",", 
   RowBox[{"\<\"p\"\>", "\[Rule]", "\<\"p\"\>"}], ",", 
   RowBox[{"\<\"q\"\>", "\[Rule]", "\<\"q\"\>"}], ",", 
   RowBox[{"\<\"r\"\>", "\[Rule]", "\<\"r\"\>"}], ",", 
   RowBox[{"\<\"s\"\>", "\[Rule]", "\<\"s\"\>"}], ",", 
   RowBox[{"\<\"t\"\>", "\[Rule]", "\<\"t\"\>"}], ",", 
   RowBox[{"\<\"u\"\>", "\[Rule]", "\<\"u\"\>"}], ",", 
   RowBox[{"\<\"v\"\>", "\[Rule]", "\<\"v\"\>"}], ",", 
   RowBox[{"\<\"w\"\>", "\[Rule]", "\<\"w\"\>"}], ",", 
   RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"x\"\>"}], ",", 
   RowBox[{"\<\"y\"\>", "\[Rule]", "\<\"y\"\>"}], ",", 
   RowBox[{"\<\"z\"\>", "\[Rule]", "\<\"z\"\>"}]}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["\<\
The encoding function follows that in the text of this section.\
\>", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"encode", "[", "str_String", "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"Characters", "[", "str", "]"}], "/.", "codeRules"}], 
   "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"encode", "[", "\"\<the sheik of araby\>\"", "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"tcg scgeh mo drdjy\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Omit spaces and punctuation and output in blocks of length ",
 StyleBox["5", "OsF"],
 " (using ",
 Cell[BoxData["StringPartition"]],
 " from Section ",
 StyleBox["9.5", "OsF"],
 ")."
}], "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPartition", "[", 
   RowBox[{"str_String", ",", "seq__"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "seq"}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringSplit", "[", 
  RowBox[{
   RowBox[{"encode", "[", "\"\<the sheik of araby\>\"", "]"}], ",", 
   RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], 
  "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"tcg\"\>", ",", "\<\"scgeh\"\>", ",", "\<\"mo\"\>", 
   ",", "\<\"drdjy\"\>"}], "}"}]], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringJoin", "[", 
  RowBox[{"Riffle", "[", 
   RowBox[{
    RowBox[{"StringPartition", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", "%", "]"}], ",", "5", ",", "5", ",", "1", 
      ",", "\"\<\>\""}], "]"}], ",", "\"\< \>\""}], "]"}], "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"tcgsc gehmo drdjy\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],

Cell["Finally, this puts all these pieces together.", "SolutionText",
 CellTags->"9.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "encode", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"encode", "[", 
   RowBox[{"str_String", ",", "key_String", ",", 
    RowBox[{"blocksize_:", "5"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "CipherAlphabet", ",", "codeRules", ",", "s1", ",", "s2", ",", "s3"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"CipherAlphabet", "[", "k_", "]"}], ":=", "\[IndentingNewLine]", 
      RowBox[{"StringJoin", "[", 
       RowBox[{
        RowBox[{"Characters", "[", "k", "]"}], ",", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"CharacterRange", "[", 
           RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
          RowBox[{"Characters", "[", "k", "]"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"codeRules", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"CharacterRange", "[", 
         RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], "\[Rule]", 
        RowBox[{"Characters", "@", 
         RowBox[{"CipherAlphabet", "[", "key", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"s1", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{
        RowBox[{"Characters", "[", "str", "]"}], "/.", "codeRules"}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"s2", "=", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"s1", ",", 
        RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"s3", "=", 
      RowBox[{"StringPartition", "[", 
       RowBox[{
        RowBox[{"StringJoin", "[", "s2", "]"}], ",", "blocksize", ",", 
        "blocksize", ",", "1", ",", "\"\<\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"Riffle", "[", 
       RowBox[{"s3", ",", "\"\< \>\""}], "]"}], "]"}]}]}], "]"}]}]}], "Input",\

 CellTags->"9.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"encode", "[", 
  RowBox[{"\"\<the sheik of araby\>\"", ",", "\"\<django\>\"", ",", "3"}], 
  "]"}]], "Input",
 CellTags->"9.2 Solutions"],

Cell[BoxData["\<\"tcg scg ehm odr djy\"\>"], "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["String patterns", "ExerciseSubsection",
 CellTags->"Sec.String patterns"],

Cell[TextData[{
 "At the end of Section ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.Structure"], "OsF"],
 " we created a predicate ",
 Cell[BoxData[
  StyleBox["OrderedWordQ", "ExLink"]]],
 " to find all words in a dictionary whose letters are in alphabetic order. \
This predicate used character codes and returned incorrect results for words \
that started with a capital letter. Correct this error by only selecting \
words from the dictionary that start with a lowercase letter. Consider using \
a conditional string pattern involving the built-in function ",
 Cell[BoxData[
  ButtonBox["LowerCaseQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/LowerCaseQ"]]],
 "."
}], "ExerciseItem",
 CellTags->"9.3 Exercises"],

Cell["\<\
Given a list of words, some of which start with uppercase characters, convert \
them all to words in which the first character is lowercase. You can use the \
words in the dictionary as a good sample set.\
\>", "ExerciseItem",
 CellTags->"9.3 Exercises"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Palindromes", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that finds all palindromic words of length ",
 StyleBox["n", "IT"],
 " in the dictionary. For example, ",
 StyleBox["kayak",
  FontSlant->"Italic"],
 " is a five-letter palindrome."
}], "ExerciseItem",
 CellTags->{"9.3 Exercises", "i:57"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Find the number of unique words in a body of text such as ",
 StyleBox["Alice in Wonderland",
  FontSlant->"Italic"],
 "."
}], "ExerciseItem",
 CellTags->"9.3 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<AliceInWonderland\>\""}], "}"}], 
    "]"}]}], ";"}]], "Input",
 CellTags->"9.3 Exercises"],

Cell[TextData[{
 "After splitting the text into words, convert all uppercase characters to \
lowercase so that you count words such as ",
 StyleBox["hare",
  FontSlant->"Italic"],
 " and ",
 StyleBox["Hare",
  FontSlant->"Italic"],
 " as the same word."
}], "ExerciseText",
 CellTags->"9.3 Exercises"],

Cell[TextData[{
 "Such computations are important in information retrieval systems, for \
example, in building term-document incidence matrices used to compare the \
occurrence of certain terms across a set of documents (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Manning, Raghavan, and \\!\\(\\*\\nStyleBox[\\(Sch\\*\\n \
StyleBox[\\\"\[UDoubleDot]\\\", \\\"SmallCaps\\\"]tze\\)]\\) 2008\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Manning\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Christopher\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"\[ThinSpace]\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"D\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Prabhakar\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Raghavan\", \"SmallCaps\"]\
\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\) and \!\(\*\nStyleBox[\"Hinrich\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Sch\[UDoubleDot]tze\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"2008.\", \"OsF\"]\) \!\(\*\nStyleBox[\"Introduction\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"to\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Information\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Retrieval\",\nFontSlant->\"Italic\"]\). Cambridge University \
Press. See\n`1`", 
         Hyperlink[
         "http://www.cambridge.org/us/knowledge/isbn/item1173871/", 
          "http://www.cambridge.org/us/knowledge/isbn/item1173871/"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 ")."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->{"i:94", "9.3 Exercises"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "First, recall the predicate created in ",
 "Section",
 " ",
 StyleBox["9.1", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrderedWordQ", "[", "word_String", "]"}], ":=", 
  RowBox[{"OrderedQ", "[", 
   RowBox[{"ToCharacterCode", "[", "word", "]"}], "]"}]}]], "Input",
 CellTags->"9.3 Solutions"],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["DictionaryLookup",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DictionaryLookup"]], "InlineFormula"],
 " can be given a pattern as its argument and it will return only those words \
that match the pattern. Using ",
 Cell[BoxData[
  ButtonBox["StringJoin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringJoin"]], "InlineFormula"],
 ", test the first character with ",
 Cell[BoxData[
  ButtonBox["LowerCaseQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/LowerCaseQ"]], "InlineFormula"],
 "; the remainder of the word (zero or more characters) has no conditions."
}], "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", 
    RowBox[{
     RowBox[{"f_", "?", "LowerCaseQ"}], "~~", "r___"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "[", 
  RowBox[{"words", ",", "4"}], "]"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{"\<\"a\"\>", ",", "\<\"aah\"\>", ",", "\<\"aardvark\"\>", 
    ",", "\<\"aardvarks\"\>", ",", "\<\"abaci\"\>", ",", "\<\"aback\"\>", 
    ",", "\<\"abacus\"\>", ",", 
    RowBox[{"\[LeftSkeleton]", "81804", "\[RightSkeleton]"}], 
    ",", "\<\"zwieback\"\>", ",", "\<\"zydeco\"\>", ",", "\<\"zygote\"\>", 
    ",", "\<\"zygotes\"\>", ",", "\<\"zygotic\"\>", ",", "\<\"zymurgy\"\>"}], 
   "}"}],
  Short[#, 4]& ]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Select", "[", 
   RowBox[{"words", ",", "OrderedWordQ"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RandomSample", "[", 
  RowBox[{"%", ",", "20"}], "]"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"now\"\>", ",", "\<\"coop\"\>", ",", "\<\"ills\"\>", 
   ",", "\<\"firs\"\>", ",", "\<\"chops\"\>", ",", "\<\"ass\"\>", 
   ",", "\<\"chin\"\>", ",", "\<\"ells\"\>", ",", "\<\"go\"\>", 
   ",", "\<\"clops\"\>", ",", "\<\"lox\"\>", ",", "\<\"sty\"\>", 
   ",", "\<\"beep\"\>", ",", "\<\"alp\"\>", ",", "\<\"dims\"\>", 
   ",", "\<\"befit\"\>", ",", "\<\"any\"\>", ",", "\<\"accost\"\>", 
   ",", "\<\"aims\"\>", ",", "\<\"amp\"\>"}], "}"}]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
We will work with a small sample of words from the dictionary.\
\>", "SolutionItem",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sample", "=", 
  RowBox[{"RandomSample", "[", 
   RowBox[{"words", ",", "12"}], "]"}]}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"habitually\"\>", ",", "\<\"aborting\"\>", 
   ",", "\<\"remote\"\>", ",", "\<\"bean\"\>", ",", "\<\"dinned\"\>", 
   ",", "\<\"clothes\"\>", ",", "\<\"sine\"\>", ",", "\<\"quail\"\>", 
   ",", "\<\"resolutely\"\>", ",", "\<\"hiya\"\>", ",", "\<\"dreamers\"\>", 
   ",", "\<\"hearings\"\>"}], "}"}]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["StringReplace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringReplace"]], "InlineFormula"],
 " operates on any words that match the pattern and leave those that do not \
match unchanged."
}], "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{"sample", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"f_", "?", "UpperCaseQ"}], "~~", "r___"}], "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"ToLowerCase", "[", "f", "]"}], "~~", "r"}]}]}], "]"}]], "Input",\

 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"habitually\"\>", ",", "\<\"aborting\"\>", 
   ",", "\<\"remote\"\>", ",", "\<\"bean\"\>", ",", "\<\"dinned\"\>", 
   ",", "\<\"clothes\"\>", ",", "\<\"sine\"\>", ",", "\<\"quail\"\>", 
   ",", "\<\"resolutely\"\>", ",", "\<\"hiya\"\>", ",", "\<\"dreamers\"\>", 
   ",", "\<\"hearings\"\>"}], "}"}]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "You can do a dictionary lookup with a pattern that tests whether the word \
is palindromic. Then find all palindromic words of a given length. Note the \
need for ",
 Cell[BoxData[
  ButtonBox["BlankSequence",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/BlankSequence"]], "InlineFormula"],
 " (",
 Cell[BoxData["__"]],
 ") as the simple pattern ",
 Cell[BoxData["_"]],
 " would only find words consisting of one character."
}], "SolutionItem",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "len_Integer", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"w", "==", 
       RowBox[{"StringReverse", "[", "w", "]"}]}], " ", "&&", " ", 
      RowBox[{
       RowBox[{"StringLength", "[", "w", "]"}], "\[Equal]", "len"}]}], 
     ")"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5246635215775347`*^9, 3.524663528847484*^9}},
 CellTags->"9.3 Solutions"],

Cell["We also add a rule to return all palindromes of any length.", \
"SolutionText",
 CellChangeTimes->{{3.524663462987876*^9, 3.52466347447256*^9}},
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{"w", "==", 
      RowBox[{"StringReverse", "[", "w", "]"}]}], " ", ")"}]}], 
   "]"}]}]], "InputOnly",
 CellChangeTimes->{{3.5246634396272097`*^9, 3.524663449129085*^9}, {
  3.524663533080288*^9, 3.5246635363442173`*^9}},
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Palindromes", "[", "7", "]"}]], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"deified\"\>", ",", "\<\"repaper\"\>", ",", "\<\"reviver\"\>"}],
   "}"}]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Palindromes", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5246634800032263`*^9, 3.5246634818937674`*^9}},
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aha\"\>", ",", "\<\"aka\"\>", 
   ",", "\<\"bib\"\>", ",", "\<\"bob\"\>", ",", "\<\"boob\"\>", 
   ",", "\<\"bub\"\>", ",", "\<\"CFC\"\>", ",", "\<\"civic\"\>", 
   ",", "\<\"dad\"\>", ",", "\<\"deed\"\>", ",", "\<\"deified\"\>", 
   ",", "\<\"did\"\>", ",", "\<\"dud\"\>", ",", "\<\"DVD\"\>", 
   ",", "\<\"eke\"\>", ",", "\<\"ere\"\>", ",", "\<\"eve\"\>", 
   ",", "\<\"ewe\"\>", ",", "\<\"eye\"\>", ",", "\<\"gag\"\>", 
   ",", "\<\"gig\"\>", ",", "\<\"huh\"\>", ",", "\<\"I\"\>", 
   ",", "\<\"kayak\"\>", ",", "\<\"kook\"\>", ",", "\<\"level\"\>", 
   ",", "\<\"ma'am\"\>", ",", "\<\"madam\"\>", ",", "\<\"mam\"\>", 
   ",", "\<\"MGM\"\>", ",", "\<\"minim\"\>", ",", "\<\"mom\"\>", 
   ",", "\<\"mum\"\>", ",", "\<\"nan\"\>", ",", "\<\"non\"\>", 
   ",", "\<\"noon\"\>", ",", "\<\"nun\"\>", ",", "\<\"oho\"\>", 
   ",", "\<\"pap\"\>", ",", "\<\"peep\"\>", ",", "\<\"pep\"\>", 
   ",", "\<\"pip\"\>", ",", "\<\"poop\"\>", ",", "\<\"pop\"\>", 
   ",", "\<\"pup\"\>", ",", "\<\"radar\"\>", ",", "\<\"redder\"\>", 
   ",", "\<\"refer\"\>", ",", "\<\"repaper\"\>", ",", "\<\"reviver\"\>", 
   ",", "\<\"rotor\"\>", ",", "\<\"sagas\"\>", ",", "\<\"sees\"\>", 
   ",", "\<\"seres\"\>", ",", "\<\"sexes\"\>", ",", "\<\"shahs\"\>", 
   ",", "\<\"sis\"\>", ",", "\<\"solos\"\>", ",", "\<\"SOS\"\>", 
   ",", "\<\"stats\"\>", ",", "\<\"stets\"\>", ",", "\<\"tat\"\>", 
   ",", "\<\"tenet\"\>", ",", "\<\"TNT\"\>", ",", "\<\"toot\"\>", 
   ",", "\<\"tot\"\>", ",", "\<\"tut\"\>", ",", "\<\"wow\"\>", 
   ",", "\<\"WWW\"\>"}], "}"}]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First import some sample text.", "SolutionItem",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<AliceInWonderland\>\""}], "}"}], 
    "]"}]}], ";"}]], "Input",
 CellTags->"9.3 Solutions"],

Cell["\<\
To split into words, use a similar construction to that in this section.\
\>", "SolutionText",
 FontWeight->"Plain",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{"text", ",", 
     RowBox[{
      RowBox[{"Characters", "[", "\"\<:;\\\"',.?/\\-` *\>\"", "]"}], ".."}]}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "[", 
  RowBox[{"words", ",", "4"}], "]"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{"\<\"I\"\>", ",", "\<\"DOWN\"\>", ",", "\<\"THE\"\>", 
    ",", "\<\"RABBIT\"\>", ",", "\<\"HOLE\"\>", ",", "\<\"Alice\"\>", 
    ",", "\<\"was\"\>", ",", "\<\"beginning\"\>", ",", 
    RowBox[{"\[LeftSkeleton]", "9955", "\[RightSkeleton]"}], 
    ",", "\<\"might\"\>", ",", "\<\"what\"\>", ",", "\<\"a\"\>", 
    ",", "\<\"wonderful\"\>", ",", "\<\"dream\"\>", ",", "\<\"it\"\>", 
    ",", "\<\"had\"\>", ",", "\<\"been\"\>"}], "}"}],
  Short[#, 4]& ]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell["Get the total number of (nonunique) words.", "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "words", "]"}]], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData["9971"], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell["Convert uppercase to lowercase.", "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"lcwords", "=", 
   RowBox[{"ToLowerCase", "[", "words", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "[", 
  RowBox[{"lcwords", ",", "4"}], "]"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{"\<\"i\"\>", ",", "\<\"down\"\>", ",", "\<\"the\"\>", 
    ",", "\<\"rabbit\"\>", ",", "\<\"hole\"\>", ",", "\<\"alice\"\>", 
    ",", "\<\"was\"\>", ",", "\<\"beginning\"\>", ",", 
    RowBox[{"\[LeftSkeleton]", "9955", "\[RightSkeleton]"}], 
    ",", "\<\"might\"\>", ",", "\<\"what\"\>", ",", "\<\"a\"\>", 
    ",", "\<\"wonderful\"\>", ",", "\<\"dream\"\>", ",", "\<\"it\"\>", 
    ",", "\<\"had\"\>", ",", "\<\"been\"\>"}], "}"}],
  Short[#, 4]& ]], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell["Finally, count the number of unique words.", "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteDuplicates", "[", "lcwords", "]"}], "//", 
  "Length"}]], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData["1643"], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "In fact, splitting words using a list of characters as we have done here is \
not terribly robust. A better approach uses regular expressions (introduced \
in ",
 "Section",
 " ",
 StyleBox["9.4", "OsF"],
 "):"
}], "SolutionText",
 CellTags->"9.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{"text", ",", 
     RowBox[{"RegularExpression", "[", "\"\<\\\\W+\>\"", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "words", "]"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData["9970"], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"lcwords", "=", 
   RowBox[{"StringReplace", "[", 
    RowBox[{"words", ",", 
     RowBox[{
      RowBox[{"RegularExpression", "[", "\"\<([A-Z])\>\"", "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"ToLowerCase", "[", "\"\<$1\>\"", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeleteDuplicates", "[", "lcwords", "]"}], "//", 
  "Length"}]}], "Input",
 CellTags->"9.3 Solutions"],

Cell[BoxData["1528"], "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Regular expressions", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Rewrite the genomic example in ",
 "Section",
 " ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.String patterns"], "OsF"],
 " to use regular expressions instead of string patterns to find all \
occurrences of the sequence ",
 StyleBox["AA", "ExerciseMR"],
 StyleBox["anything", "ExerciseTI"],
 StyleBox["T", "ExerciseMR"],
 ". Here is the example using general string patterns."
}], "ExerciseItem",
 CellTags->"9.4 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gene", "=", 
   RowBox[{"GenomeData", "[", "\"\<IGHV357\>\"", "]"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringCases", "[", 
  RowBox[{"gene", ",", 
   RowBox[{"\"\<AA\>\"", "~~", "_", "~~", "\"\<T\>\""}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AAGT\"\>", ",", "\<\"AAGT\"\>", ",", "\<\"AAAT\"\>", 
   ",", "\<\"AAGT\"\>", ",", "\<\"AAAT\"\>", ",", "\<\"AAAT\"\>"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"9.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Rewrite the web page example in ",
 "Section",
 " ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.String patterns"], "OsF"],
 " to use regular expressions to find all phone numbers on the page; that is, \
expressions of the form ",
 StyleBox["nnn",
  FontSlant->"Italic"],
 "\[Dash]",
 StyleBox["nnn",
  FontSlant->"Italic"],
 "\[Dash]",
 StyleBox["nnnn",
  FontSlant->"Italic"],
 ". Modify accordingly for other web pages and phone numbers formatted for \
other regions."
}], "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:65"}],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["UcLc", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["word", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that takes its argument ",
 StyleBox["word",
  FontSlant->"Italic"],
 " and returns the word with the first letter uppercase and the rest of the \
letters lowercase."
}], "ExerciseItem",
 CellTags->"9.4 Exercises"],

Cell[TextData[{
 "Use a regular expression to find all words given by ",
 Cell[BoxData[
  ButtonBox["DictionaryLookup",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DictionaryLookup"]], "InlineFormula"],
 " that consist only of the letters ",
 StyleBox["a",
  FontSlant->"Italic"],
 ", ",
 StyleBox["e",
  FontSlant->"Italic"],
 ", ",
 StyleBox["i",
  FontSlant->"Italic"],
 ", ",
 StyleBox["o",
  FontSlant->"Italic"],
 ", ",
 StyleBox["u",
  FontSlant->"Italic"],
 ", and ",
 StyleBox["y",
  FontSlant->"Italic"],
 " in any order with any number of repetitions of the letters."
}], "ExerciseItem",
 CellTags->"9.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "The basic rules for pluralizing words in the English language are roughly, \
as follows: if a noun ends in ",
 StyleBox["ch",
  FontSlant->"Italic"],
 ", ",
 StyleBox["s",
  FontSlant->"Italic"],
 ", ",
 StyleBox["sh",
  FontSlant->"Italic"],
 ", ",
 StyleBox["j",
  FontSlant->"Italic"],
 ", ",
 StyleBox["x",
  FontSlant->"Italic"],
 ", or ",
 StyleBox["z",
  FontSlant->"Italic"],
 ", it is made plural by adding ",
 StyleBox["es",
  FontSlant->"Italic"],
 " to the end. If the noun ends in ",
 StyleBox["y",
  FontSlant->"Italic"],
 " and is preceded by a consonant, replace the ",
 StyleBox["y",
  FontSlant->"Italic"],
 " with ",
 StyleBox["ies",
  FontSlant->"Italic"],
 ". If the word ends in ",
 StyleBox["ium",
  FontSlant->"Italic"],
 ", replace with ",
 StyleBox["ia ",
  FontSlant->"Italic"],
 "(",
 Cell[BoxData[
  ButtonBox[
   StyleBox[
    RowBox[{"Chicago", " ", "Manual", " ", "of", " ", "Style", " ", "2010"}], 
    "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.5]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"University\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"of\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Chicago\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Press\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"2010.\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"The\",\nFontSlant->\"Italic\"]\)\!\
\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Chicago\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Manual\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"of\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Style\",\nFontSlant->\"Italic\"]\), sixteenth edition. \
University of Chicago Press. See\n`1`", 
         Hyperlink[
         "http://press.uchicago.edu/ucp/books/book/chicago/C/bo8540260.html", 
          "http://press.uchicago.edu/ucp/books/book/chicago/C/bo8540260.html"]\
], "TR", 16], "Text"], WindowSize -> {500, 140}, WindowOpacity -> 0.9]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 "). Of course, there are many more rules and even more exceptions, but you \
can implement a basic set of rules to convert singular words to plural based \
on these rules and then try them out on the following list of words."
}], "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:66"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<building\>\"", ",", "\"\<finch\>\"", ",", "\"\<fix\>\"", ",", 
     "\"\<ratio\>\"", ",", "\"\<envy\>\"", ",", "\"\<boy\>\"", ",", 
     "\"\<baby\>\"", ",", "\"\<faculty\>\"", ",", "\"\<honorarium\>\""}], 
    "}"}]}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A common task in transcribing audio is cleaning up text, removing certain \
phrases such as ",
 StyleBox["um",
  FontSlant->"Italic"],
 ", ",
 StyleBox["er",
  FontSlant->"Italic"],
 ", and so on, and other tags that are used to make a note of some sort. For \
example, the following transcription of a lecture from the University of \
Warwick, Centre for Applied Linguistics (",
 ButtonBox["BASE Corpus",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www2.warwick.ac.uk/fac/soc/al/research/collect/base/"], None},
  
  ButtonNote->"http://www2.warwick.ac.uk/fac/soc/al/research/collect/base/"],
 "), contains quite a few fragments that should be removed, including newline \
characters, parenthetical remarks, and nonwords. Use ",
 Cell[BoxData[
  ButtonBox["StringReplace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringReplace"]]],
 " with the appropriate rules to \[OpenCurlyDoubleQuote]clean\
\[CloseCurlyDoubleQuote] this text and then apply your code to a larger \
corpus."
}], "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:68"}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "text", "=", 
   "\"\<okay well er today we're er going to be carrying on with the er \
French \\nRevolution you may have noticed i was sort of getting rather er \
enthusiastic \\nand carried away at the end of the last one i was sort of \
almost er like i sort \\nof started at the beginning about someone standing \
on a coffee table and s-, \\nshouting to arms citizens as if i was going to \
sort of leap up on the desk and \\nsay to arms let's storm the Rootes Social \
Building [laughter] or er let's go \\nout arm in arm singing the Marseillaise \
or something er like that\>\""}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "Find the distribution of sentence lengths for any given piece of text. ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"ExampleData", "[", "\"\<Text\>\"", "]"}], "ExLink"]]],
 " contains several well-known books and documents that you can use. You will \
need to think about and identify sentence delimiters carefully. Take care to \
deal properly with words such as ",
 StyleBox["Mr",
  FontSlant->"Italic"],
 "., ",
 StyleBox["Dr.",
  FontSlant->"Italic"],
 ", and so on that might incorrectly trigger a sentence-ending detector."
}], "ExerciseItem",
 CellTags->{"i:69", "9.4 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "In web searches and certain problems in natural language processing (NLP), \
it is often useful to filter out certain words prior to performing the search \
or processing of the text to help with the performance of the algorithms. \
Words such as ",
 StyleBox["the",
  FontSlant->"Italic"],
 ", ",
 StyleBox["and",
  FontSlant->"Italic"],
 ", ",
 StyleBox["is",
  FontSlant->"Italic"],
 ", and so on are commonly referred to as ",
 StyleBox["stop words",
  FontSlant->"Italic"],
 " for this purpose. Lists of stop words are almost always created manually \
based on the constraints of a particular application. We will assume you can \
import a list of stop words as they are commonly available across the \
internet. For our purposes here, we will use one such list that comes with \
the materials for this book."
}], "ExerciseItem",
 CellTags->{"i:70", "9.4 Exercises"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stopwords", "=", 
   RowBox[{"Rest", "@", 
    RowBox[{"Import", "[", 
     RowBox[{"\"\<StopWords.dat\>\"", ",", "\"\<List\>\""}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RandomSample", "[", 
  RowBox[{"stopwords", ",", "12"}], "]"}]}], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"what\"\>", ",", "\<\"look\"\>", ",", "\<\"taken\"\>", 
   ",", "\<\"specify\"\>", ",", "\<\"wants\"\>", ",", "\<\"thorough\"\>", 
   ",", "\<\"they\"\>", ",", "\<\"hello\"\>", ",", "\<\"whose\"\>", 
   ",", "\<\"them\"\>", ",", "\<\"mightn't\"\>", ",", "\<\"particular\"\>"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"9.4 Exercises"]
}, Closed]],

Cell["\<\
Using the above list of stop words, or any other that you are interested in, \
first filter some sample \[OpenCurlyDoubleQuote]search phrases\
\[CloseCurlyDoubleQuote] and then remove all stop words from a larger piece \
of text.\
\>", "ExerciseText",
 CellTags->"9.4 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"searchPhrases", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Find my favorite phone\>\"", ",", "\"\<How deep is the ocean?\>\"", 
     ",", "\"\<What is the meaning of life?\>\""}], "}"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.4 Exercises"]
}, Closed]],

Cell["\<\
Modify the previous exercise so that the user can supply a list of \
punctuation in addition to the list of stop words to be used to filter the \
text.\
\>", "ExerciseItem",
 CellTags->"9.4 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The pattern used earlier in the chapter was ",
 Cell[BoxData[
  RowBox[{"\"\<AA\>\"", "~~", "_", "~~", "\"\<T\>\""}]]],
 ". In a regular expression, we want the character ",
 StyleBox["A",
  FontSlant->"Italic"],
 " repeated exactly once. Use the expression ",
 Cell[BoxData["\"\<A{2,2}\>\""]],
 " for this. The regular expression ",
 Cell[BoxData["\"\<.\>\""]],
 " stands for any character. "
}], "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gene", "=", 
   RowBox[{"GenomeData", "[", "\"\<IGHV357\>\"", "]"}]}], ";"}]], "InputOnly",\

 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringCases", "[", 
  RowBox[{"gene", ",", 
   RowBox[{"RegularExpression", "[", "\"\<A{2,2}.T\>\"", "]"}]}], 
  "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AAGT\"\>", ",", "\<\"AAGT\"\>", ",", "\<\"AAAT\"\>", 
   ",", "\<\"AAGT\"\>", ",", "\<\"AAAT\"\>", ",", "\<\"AAAT\"\>"}], 
  "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First, read in the web page.", "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"webpage", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<http://www.wolfram.com/company/contact.cgi\>\"", ",", 
     "\"\<HTML\>\""}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[TextData[{
 "In the original example in ",
 "Section",
 " ",
 StyleBox["9.3", "OsF"],
 ", we used the pattern ",
 Cell[BoxData[
  ButtonBox["NumberString",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NumberString"]], "InlineFormula"],
 ", to represent arbitrary strings of numbers. The regular expression ",
 Cell[BoxData["\"\<\\\\d+\>\""]],
 " accomplishes a similar thing but it will also match strings of numbers \
that may not be in a phone number format (try it!). Instead, use ",
 Cell[BoxData["\"\<\\\\d{3}\>\""]],
 " to match a list of exactly three digits, and so on."
}], "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringCases", "[", 
   RowBox[{"webpage", ",", "\[IndentingNewLine]", 
    RowBox[{
    "RegularExpression", "[", "\"\<\\\\d{3}.\\\\d{3}.\\\\d{4}\>\"", "]"}]}], 
   "]"}], "//", "DeleteDuplicates"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"217-398-0700\"\>", ",", "\<\"217-398-0747\"\>", 
   ",", "\<\"617-764-0094\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, here is the function using regular expressions. ",
 Cell[BoxData[
  RowBox[{"(", ".", ")"}]]],
 " will be matched by any single character; the parentheses are used to refer \
to this expression on the right-hand side of the rule as ",
 Cell[BoxData["\"\<$1\>\""]],
 ".",
 " ",
 "Similarly, parentheses surround ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"[", 
    RowBox[{"a", "-", "z"}], "]"}], "+"}]]],
 " which is matched by any sequence of lowercase characters; this expression \
is referred to on the right as ",
 Cell[BoxData["\"\<$2\>\""]],
 "."
}], "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UcLc", "[", "word_String", "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"word", ",", 
    RowBox[{
     RowBox[{"RegularExpression", "[", "\"\<(.)([a-z]+)\>\"", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"ToUpperCase", "[", "\"\<$1\>\"", "]"}], "~~", 
      "\"\<$2\>\""}]}]}], "]"}]}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UcLc", "[", "\"\<hello\>\"", "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData["\<\"Hello\"\>"], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["You can also do this with string patterns.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UcLc", "[", "word_String", "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"word", ",", 
    RowBox[{
     RowBox[{"WordBoundary", "~~", "x_", "~~", "y__"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"ToUpperCase", "[", "x", "]"}], "~~", 
      RowBox[{"ToLowerCase", "[", "y", "]"}]}]}]}], "]"}]}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UcLc", "[", "\"\<ciao\>\"", "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData["\<\"Ciao\"\>"], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The first solution uses regular expressions. The second uses string patterns \
and alternatives.\
\>", "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DictionaryLookup", "[", 
  RowBox[{
   RowBox[{"RegularExpression", "[", "\"\<[aeiouy]+\>\"", "]"}], ",", 
   RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aye\"\>", ",", "\<\"eye\"\>", 
   ",", "\<\"I\"\>", ",", "\<\"IOU\"\>", ",", "\<\"oi\"\>", ",", "\<\"ya\"\>",
    ",", "\<\"ye\"\>", ",", "\<\"yea\"\>", ",", "\<\"yo\"\>", 
   ",", "\<\"you\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DictionaryLookup", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
     "\"\<a\>\"", "|", "\"\<e\>\"", "|", "\"\<i\>\"", "|", "\"\<o\>\"", "|", 
      "\"\<u\>\"", "|", "\"\<y\>\""}], ")"}], ".."}], ",", 
   RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aye\"\>", ",", "\<\"eye\"\>", 
   ",", "\<\"I\"\>", ",", "\<\"IOU\"\>", ",", "\<\"oi\"\>", ",", "\<\"ya\"\>",
    ",", "\<\"ye\"\>", ",", "\<\"yea\"\>", ",", "\<\"yo\"\>", 
   ",", "\<\"you\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the short list of words with which we will work.", \
"SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<building\>\"", ",", "\"\<finch\>\"", ",", "\"\<fix\>\"", ",", 
     "\"\<ratio\>\"", ",", "\"\<envy\>\"", ",", "\"\<boy\>\"", ",", 
     "\"\<baby\>\"", ",", "\"\<faculty\>\"", ",", "\"\<honorarium\>\""}], 
    "}"}]}], ";"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["\<\
Using regular expressions, these rules encapsulate those given in the \
exercise.\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rules", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RegularExpression", "[", "\"\<(\\\\w+)x\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"\"\<$1\>\"", "~~", "\"\<x\>\"", "~~", "\"\<es\>\""}]}], ")"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RegularExpression", "[", "\"\<(\\\\w+)(ch)\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"\"\<$1\>\"", "~~", "\"\<$2\>\"", "~~", "\"\<es\>\""}]}], 
      ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "RegularExpression", "[", "\"\<(\\\\w+)([aeiou])(y)\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{
       "\"\<$1\>\"", "~~", "\"\<$2\>\"", "~~", "\"\<$3\>\"", "~~", 
        "\"\<s\>\""}]}], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RegularExpression", "[", "\"\<(\\\\w+)(y)\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"\"\<$1\>\"", "~~", "\"\<ies\>\""}]}], ")"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RegularExpression", "[", "\"\<(\\\\w+)(i)um\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"\"\<$1\>\"", "~~", "\"\<$2\>\"", "~~", "\"\<a\>\""}]}], ")"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RegularExpression", "[", "\"\<(\\\\w+)(.)\>\"", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"\"\<$1\>\"", "~~", "\"\<$2\>\"", "~~", "\"\<s\>\""}]}], 
      ")"}]}], "\[IndentingNewLine]", "}"}]}], ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{"words", ",", "rules"}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"buildings\"\>", ",", "\<\"finches\"\>", ",", "\<\"fixes\"\>", 
   ",", "\<\"ratios\"\>", ",", "\<\"envies\"\>", ",", "\<\"boys\"\>", 
   ",", "\<\"babies\"\>", ",", "\<\"faculties\"\>", 
   ",", "\<\"honoraria\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["Of course, lots of exceptions exist:", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<man\>\"", ",", "\"\<cattle\>\""}], "}"}], ",", "rules"}], 
  "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"mans\"\>", ",", "\<\"cattles\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We use a combination of string patterns and regular expressions to remove \
the various fragments. The regular expression ",
 Cell[BoxData["\"\<\\[.+\\] \>\""]],
 " matches strings that start with ",
 Cell[BoxData["["]],
 ", followed by an arbitrary number of characters, followed by ",
 Cell[BoxData["]"]],
 ", followed by a space. Because brackets are used in regular expressions to \
denote sequences of characters, you need to escape them to refer to the \
explicit characters ",
 Cell[BoxData["["]],
 " or ",
 Cell[BoxData["]"]],
 "."
}], "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "text", "=", 
   "\"\<okay well er today we're er going to be carrying on with the er \
French \\nRevolution you may have noticed i was sort of getting rather er \
enthusiastic \\nand carried away at the end of the last one i was sort of \
almost er like i sort \\nof started at the beginning about someone standing \
on a coffee table and s-, \\nshouting to arms citizens as if i was going to \
sort of leap up on the desk and \\nsay to arms let's storm the Rootes Social \
Building [laughter] or er let's go \\nout arm in arm singing the Marseillaise \
or something er like that\>\""}], ";"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{"text", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<\\n\>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"\"\< er\>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"\"\< s-\>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{
      RowBox[{"RegularExpression", "[", "\"\<\\[.+\\] \>\"", "]"}], 
      "\[Rule]", "\"\<\>\""}]}], "}"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Start by importing a somewhat lengthy text, Charles \
Darwin\[CloseCurlyQuote]s ",
 StyleBox["On the Origin of Species",
  FontSlant->"Italic"],
 "."
}], "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<OriginOfSpecies\>\""}], "}"}], "]"}]}],
   ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[TextData[{
 "There are numerous instances of \[OpenCurlyDoubleQuote]Mr.\
\[CloseCurlyDoubleQuote] and \[OpenCurlyDoubleQuote]Dr.\
\[CloseCurlyDoubleQuote], words that end in a period that would trigger a \
sentence-ending detector such as ",
 Cell[BoxData[
  ButtonBox["StringSplit",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringSplit"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringCount", "[", 
  RowBox[{"text", ",", 
   RowBox[{"\"\<Mr.\>\"", "|", "\"\<Dr.\>\""}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData["119"], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["\<\
To keep our sentence count accurate, we will replace such words (and a few \
others in this particular text) with words that will not cause errors in our \
sentence count. This step of cleaning text based on identified issues is a \
common one in textual analysis.\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cleanText", "=", 
   RowBox[{"StringReplace", "[", 
    RowBox[{"text", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<Mr.\>\"", "\[Rule]", "\"\<Mr\>\""}], ",", 
       RowBox[{"\"\<Dr.\>\"", "\[Rule]", "\"\<Dr\>\""}], ",", 
       RowBox[{"\"\<H.M.S.\>\"", "\[Rule]", "\"\<HMS\>\""}]}], "}"}]}], 
    "]"}]}], ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"t", "=", 
  RowBox[{"StringTake", "[", 
   RowBox[{"cleanText", ",", "200"}], "]"}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData["\<\"INTRODUCTION. When on board HMS 'Beagle,' as naturalist, I \
was much struck with certain facts in the distribution of the inhabitants of \
South America, and in the geological relations of the present to\"\>"], \
"Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["Now split on a small set of delimiters.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{"cleanText", ",", 
     RowBox[{
      RowBox[{"Characters", "[", "\"\<.!?\>\"", "]"}], ".."}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "[", 
  RowBox[{"s", ",", "5"}], "]"}]}], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{"\<\"INTRODUCTION\"\>", ",", 
    RowBox[{"\[LeftSkeleton]", "4225", "\[RightSkeleton]"}], ",", 
    RowBox[{"\<\" There is grandeur in this view of life, with its several \
powers, hav\"\>", 
     "\[Ellipsis]", "\<\"s most beautiful and most wonderful have been, and \
are being, evolved\"\>"}]}], "}"}],
  Short[#, 5]& ]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["\<\
The same thing can be accomplished with a regular expression.\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{"cleanText", ",", 
     RowBox[{"RegularExpression", "[", "\"\<[.!?]+\>\"", "]"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell["\<\
Using a regular expression, this counts the number of words in each sentence.\
\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sentenceLens", "=", 
   RowBox[{"StringCount", "[", 
    RowBox[{"s", ",", 
     RowBox[{"RegularExpression", "[", "\"\<\\\\w+\>\"", "]"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell["\<\
Finally, here is a histogram displaying the distribution of sentence lengths.\
\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Histogram", "[", "sentenceLens", "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.7]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0., 0.}, {5., 159.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{26.750000000000004`, 34.66581996681972}, {
         18.68999999999999, 74.24999999999999}}],
       StatusArea[#, 159.]& ,
       TagBoxNote->"159."],
      StyleBox["159.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[159., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{5., 0.}, {10., 197.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{33.16581996681972, 41.08163993363943}, {
         5.769999999999996, 74.24999999999999}}],
       StatusArea[#, 197.]& ,
       TagBoxNote->"197."],
      StyleBox["197.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[197., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{10., 0.}, {15., 282.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{39.58163993363943, 
         47.49745990045915}, {-23.13000000000001, 74.24999999999999}}],
       StatusArea[#, 282.]& ,
       TagBoxNote->"282."],
      StyleBox["282.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[282., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{15., 0.}, {20., 340.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{45.99745990045915, 
         53.91327986727886}, {-42.85000000000001, 74.24999999999999}}],
       StatusArea[#, 340.]& ,
       TagBoxNote->"340."],
      StyleBox["340.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[340., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{20., 0.}, {25., 446.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{52.41327986727886, 60.32909983409857}, {-78.89, 
         74.24999999999999}}],
       StatusArea[#, 446.]& ,
       TagBoxNote->"446."],
      StyleBox["446.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[446., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{25., 0.}, {30., 449.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{58.82909983409857, 
         66.74491980091828}, {-79.91000000000001, 74.24999999999999}}],
       StatusArea[#, 449.]& ,
       TagBoxNote->"449."],
      StyleBox["449.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[449., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{30., 0.}, {35., 438.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{65.24491980091828, 73.160739767738}, {-76.17, 
         74.24999999999999}}],
       StatusArea[#, 438.]& ,
       TagBoxNote->"438."],
      StyleBox["438.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[438., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{35., 0.}, {40., 355.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{71.660739767738, 79.5765597345577}, {-47.95, 
         74.24999999999999}}],
       StatusArea[#, 355.]& ,
       TagBoxNote->"355."],
      StyleBox["355.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[355., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{40., 0.}, {45., 325.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{78.0765597345577, 85.99237970137743}, {-37.75, 
         74.24999999999999}}],
       StatusArea[#, 325.]& ,
       TagBoxNote->"325."],
      StyleBox["325.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[325., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{45., 0.}, {50., 276.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{84.49237970137743, 
         92.40819966819714}, {-21.090000000000003`, 74.24999999999999}}],
       StatusArea[#, 276.]& ,
       TagBoxNote->"276."],
      StyleBox["276.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[276., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{50., 0.}, {55., 235.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{90.90819966819714, 
         98.82401963501685}, {-7.150000000000006, 74.24999999999999}}],
       StatusArea[#, 235.]& ,
       TagBoxNote->"235."],
      StyleBox["235.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[235., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{55., 0.}, {60., 184.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{97.32401963501685, 105.23983960183656`}, {
         10.189999999999984`, 74.24999999999999}}],
       StatusArea[#, 184.]& ,
       TagBoxNote->"184."],
      StyleBox["184.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[184., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{60., 0.}, {65., 130.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{103.73983960183656`, 111.65565956865628`}, {
         28.54999999999999, 74.24999999999999}}],
       StatusArea[#, 130.]& ,
       TagBoxNote->"130."],
      StyleBox["130.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[130., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{65., 0.}, {70., 96.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{110.15565956865628`, 118.07147953547599`}, {
         40.109999999999985`, 74.24999999999999}}],
       StatusArea[#, 96.]& ,
       TagBoxNote->"96."],
      StyleBox["96.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[96., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{70., 0.}, {75., 73.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{116.57147953547599`, 124.4872995022957}, {
         47.92999999999999, 74.24999999999999}}],
       StatusArea[#, 73.]& ,
       TagBoxNote->"73."],
      StyleBox["73.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[73., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{75., 0.}, {80., 72.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{122.9872995022957, 130.9031194691154}, {
         48.26999999999999, 74.24999999999999}}],
       StatusArea[#, 72.]& ,
       TagBoxNote->"72."],
      StyleBox["72.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[72., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{80., 0.}, {85., 47.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{129.4031194691154, 137.31893943593514`}, {
         56.76999999999999, 74.24999999999999}}],
       StatusArea[#, 47.]& ,
       TagBoxNote->"47."],
      StyleBox["47.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[47., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{85., 0.}, {90., 31.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{135.81893943593514`, 143.73475940275486`}, {
         62.20999999999999, 74.24999999999999}}],
       StatusArea[#, 31.]& ,
       TagBoxNote->"31."],
      StyleBox["31.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[31., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{90., 0.}, {95., 20.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{142.23475940275486`, 150.15057936957456`}, {
         65.94999999999999, 74.24999999999999}}],
       StatusArea[#, 20.]& ,
       TagBoxNote->"20."],
      StyleBox["20.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[20., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{95., 0.}, {100., 17.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{148.65057936957456`, 156.56639933639428`}, {
         66.96999999999998, 74.24999999999999}}],
       StatusArea[#, 17.]& ,
       TagBoxNote->"17."],
      StyleBox["17.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[17., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{100., 0.}, {105., 14.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{155.06639933639428`, 162.98221930321398`}, {
         67.98999999999998, 74.24999999999999}}],
       StatusArea[#, 14.]& ,
       TagBoxNote->"14."],
      StyleBox["14.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[14., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{105., 0.}, {110., 6.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{161.48221930321398`, 169.3980392700337}, {
         70.70999999999998, 74.24999999999999}}],
       StatusArea[#, 6.]& ,
       TagBoxNote->"6."],
      StyleBox["6.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[6., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{110., 0.}, {115., 10.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{167.8980392700337, 175.8138592368534}, {
         69.34999999999998, 74.24999999999999}}],
       StatusArea[#, 10.]& ,
       TagBoxNote->"10."],
      StyleBox["10.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[10., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{115., 0.}, {120., 9.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{174.3138592368534, 182.22967920367313`}, {
         69.68999999999998, 74.24999999999999}}],
       StatusArea[#, 9.]& ,
       TagBoxNote->"9."],
      StyleBox["9.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[9., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{120., 0.}, {125., 2.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{180.72967920367313`, 188.64549917049283`}, {
         72.06999999999998, 74.24999999999999}}],
       StatusArea[#, 2.]& ,
       TagBoxNote->"2."],
      StyleBox["2.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{125., 0.}, {130., 2.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{187.14549917049283`, 195.06131913731255`}, {
         72.06999999999998, 74.24999999999999}}],
       StatusArea[#, 2.]& ,
       TagBoxNote->"2."],
      StyleBox["2.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{130., 0.}, {135., 3.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{193.56131913731255`, 201.47713910413228`}, {
         71.72999999999999, 74.24999999999999}}],
       StatusArea[#, 3.]& ,
       TagBoxNote->"3."],
      StyleBox["3.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[3., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{135., 0.}, {140., 4.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{199.97713910413228`, 207.89295907095197`}, {
         71.38999999999999, 74.24999999999999}}],
       StatusArea[#, 4.]& ,
       TagBoxNote->"4."],
      StyleBox["4.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[4., {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{140., 0.}, {145., 2.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{206.39295907095197`, 214.3087790377717}, {
         72.06999999999998, 74.24999999999999}}],
       StatusArea[#, 2.]& ,
       TagBoxNote->"2."],
      StyleBox["2.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[2., {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{150., 0.}, {155., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{219.2245990045914, 227.14041897141112`}, {
         72.40999999999998, 74.24999999999999}}],
       StatusArea[#, 1.]& ,
       TagBoxNote->"1."],
      StyleBox["1.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1., {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{175., 0.}, {180., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{251.30369883868997`, 259.2195188055097}, {
         72.40999999999998, 74.24999999999999}}],
       StatusArea[#, 1.]& ,
       TagBoxNote->"1."],
      StyleBox["1.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1., {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{205., 0.}, {210., 1.}, "RoundingRadius" -> 0]},
        ImageSizeCache->{{289.79861863960826`, 297.71443860642796`}, {
         72.40999999999998, 74.24999999999999}}],
       StatusArea[#, 1.]& ,
       TagBoxNote->"1."],
      StyleBox["1.`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[1., {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesOrigin->{0., 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  ImageSize->{Automatic, 132},
  PlotRange->{{0., 210.}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell["It looks like there are some very long sentences!", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{"s", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"StringCount", "[", 
      RowBox[{"#", ",", 
       RowBox[{"RegularExpression", "[", "\"\<\\\\w+\>\"", "]"}]}], "]"}], 
     ">", "200"}], "&"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", "\<\" I have attempted to show that the geological record is \
extremely imperfect; that only a small portion of the globe has been \
geologically explored with care; that only certain classes of organic beings \
have been largely preserved in a fossil state; that the number both of \
specimens and of species, preserved in our museums, is absolutely as nothing \
compared with the incalculable number of generations which must have passed \
away even during a single formation; that, owing to subsidence being \
necessary for the accumulation of fossiliferous deposits thick enough to \
resist future degradation, enormous intervals of time have elapsed between \
the successive formations; that there has probably been more extinction \
during the periods of subsidence, and more variation during the periods of \
elevation, and during the latter the record will have been least perfectly \
kept; that each single formation has not been continuously deposited; that \
the duration of each formation is, perhaps, short compared with the average \
duration of specific forms; that migration has played an important part in \
the first appearance of new forms in any one area and formation; that widely \
ranging species are those which have varied most, and have oftenest given \
rise to new species; and that varieties have at first often been local\"\>", 
  "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First read in some sample phrases.", "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"searchPhrases", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Find my favorite phone\>\"", ",", "\"\<How deep is the ocean?\>\"", 
     ",", "\"\<What is the meaning of life?\>\""}], "}"}]}], ";"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["\<\
There are several ways to approach this problem. We will break it up into two \
steps: first eliminating punctuation, then a sample set of stop words.\
\>", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{"\"\<How deep is the ocean?\>\"", ",", 
    RowBox[{
     RowBox[{"Characters", "[", "\"\<:,;.!? \>\"", "]"}], ".."}]}], 
   "]"}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"How\"\>", ",", "\<\"deep\"\>", ",", "\<\"is\"\>", 
   ",", "\<\"the\"\>", ",", "\<\"ocean\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"stopwords", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<how\>\"", ",", "\"\<the\>\"", ",", "\"\<is\>\"", ",", "\"\<an\>\""}],
     "}"}]}], ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Alternatives", ",", "stopwords"}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"\<\"how\"\>", "|", "\<\"the\"\>", "|", "\<\"is\"\>", 
  "|", "\<\"an\"\>"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Note the need for ",
 Cell[BoxData[
  ButtonBox["WordBoundary",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/WordBoundary"]], "InlineFormula"],
 " in what follows; otherwise, ",
 StyleBox["ocean",
  FontSlant->"Italic"],
 " would be split leaving ",
 StyleBox["oce",
  FontSlant->"Italic"],
 " because ",
 StyleBox["an",
  FontSlant->"Italic"],
 " is a stop word."
}], "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringSplit", "[", 
   RowBox[{"tmp", ",", 
    RowBox[{"WordBoundary", "~~", 
     RowBox[{"Apply", "[", 
      RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
     "WordBoundary"}], ",", 
    RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}], "//", 
  "Flatten"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"deep\"\>", ",", "\<\"ocean\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"FilterText", "[", 
   RowBox[{"str_String", ",", "stopwords_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tmp", "=", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"str", ",", 
        RowBox[{
         RowBox[{"Characters", "[", "\"\<:,;.!? \>\"", "]"}], ".."}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "@", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"tmp", ",", 
        RowBox[{"WordBoundary", "~~", 
         RowBox[{"Apply", "[", 
          RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
         "WordBoundary"}], ",", 
        RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stopwords", "=", 
   RowBox[{"Rest", "@", 
    RowBox[{"Import", "[", 
     RowBox[{"\"\<StopWords.dat\>\"", ",", "\"\<List\>\""}], "]"}]}]}], 
  ";"}]], "InputOnly",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterText", "[", 
  RowBox[{"\"\<What is the meaning of life?\>\"", ",", "stopwords"}], 
  "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"meaning\"\>", ",", "\<\"life\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
A slight modification is needed to accept a list of punctuation.\
\>", "SolutionItem",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Characters", "@", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<.\>\"", ",", "\"\<?\>\""}], "}"}], "]"}]}], "//", 
  "FullForm"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["First remove the punctuation.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{"\"\<What is the meaning of life?\>\"", ",", 
    RowBox[{
     RowBox[{"Characters", "@", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<.\>\"", ",", "\"\<?\>\""}], "}"}], "]"}]}], ".."}]}], 
   "]"}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["Split into words.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"First", "@", 
  RowBox[{"StringCases", "[", 
   RowBox[{"tmp", ",", 
    RowBox[{"RegularExpression", "[", "\"\<\\\\w+\>\"", "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["Remove stop words.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"StringSplit", "[", 
  RowBox[{"%", ",", 
   RowBox[{"WordBoundary", "~~", 
    RowBox[{"Apply", "[", 
     RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
    "WordBoundary"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["Put these pieces together in a reusable function.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FilterText", "[", 
   RowBox[{"str_String", ",", "stopwords_List", ",", "punctuation_List"}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tmp", "=", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"str", ",", 
        RowBox[{
         RowBox[{"Characters", "@", 
          RowBox[{"StringJoin", "[", "punctuation", "]"}]}], ".."}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "@", 
      RowBox[{"StringSplit", "[", 
       RowBox[{
        RowBox[{"First", "@", 
         RowBox[{"StringCases", "[", 
          RowBox[{"tmp", ",", 
           RowBox[{"RegularExpression", "[", "\"\<\\\\w+\>\"", "]"}]}], 
          "]"}]}], ",", 
        RowBox[{"WordBoundary", "~~", 
         RowBox[{"Apply", "[", 
          RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
         "WordBoundary"}], ",", 
        RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"FilterText", "[", 
  RowBox[{"\"\<What is the meaning of life?\>\"", ",", "stopwords", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<.\>\"", ",", "\"\<?\>\""}], "}"}]}], "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell["Try it out on a list of phrases.", "SolutionText",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"FilterText", "[", 
      RowBox[{"#", ",", "stopwords", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<.\>\"", ",", "\"\<?\>\""}], "}"}]}], "]"}], "&"}], ",", 
    "searchPhrases"}], "]"}]}]], "Input",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalize the ",
 StyleBox["RandomString", "MR", "ExLink"],
 " function to allow for a ",
 StyleBox["Weights", "MR", "ExLink"],
 " option so that you can provide a weight for each character in the \
generated string. Include a rule to generate a message if the number of \
weights does not match the number of characters. For example:"
}], "ExerciseItem",
 CellTags->{"9.5 Exercises", "i:90"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\""}], 
    "}"}], ",", "30", ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".1", ",", ".2", ",", ".3", ",", ".4"}], "}"}]}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.5 Exercises"],

Cell[BoxData["\<\"GCGTCGTCGGGTCAGGTCCTCGTGTGGGCG\"\>"], "ExerciseOutput", "ExerciseMR",
 CellTags->"9.5 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\""}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".1", ",", ".4", ",", ".4", ",", ".1"}], "}"}]}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"9.5 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TTCACTTCCC\"\>", ",", "\<\"ACAACTGGCC\"\>", 
   ",", "\<\"GATTCTTTTC\"\>", ",", "\<\"TGTCCTTTGA\"\>", 
   ",", "\<\"TTCCTGCTGT\"\>"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"9.5 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\""}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".1", ",", ".4"}], "}"}]}]}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"9.5 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"RandomString", "::", "badwt"}], "MessageName"], ":", 
  " ", "\<\"The length of the list of weights must be the same as the length \
of the list of characters.\"\>"}]], "Message", "MSG",
 CellTags->"9.5 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Write the function ",
 StyleBox["Anagrams", "MR", "ExLink"],
 " developed in ",
 "Section",
 " ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["Section", "Sec.Operations"], "OsF"],
 " without resorting to the use of ",
 Cell[BoxData[
  ButtonBox["Permutations",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Permutations"]]],
 ". Consider using the ",
 Cell[BoxData[
  ButtonBox["Sort",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Sort"]]],
 " function to sort the characters. Note the difference in speed of the two \
approaches: one involving string functions and the other list functions that \
operate on lists of characters. Increase the efficiency of your search by \
only searching for words of the same length as your source word."
}], "ExerciseItem",
 CellTags->{"9.5 Exercises", "Ex.Anagrams", "i:91"}],

Cell[TextData[{
 "Rewrite the function ",
 Cell[BoxData[
  StyleBox["FindWordsContaining", "ExLink"]]],
 " using regular expressions instead of the patterns used in this section. "
}], "ExerciseItem",
 CellTags->"9.5 Exercises"],

Cell[TextData[{
 "Using the text from several different sources, compute and then compare the \
number of punctuation characters per ",
 StyleBox["1000", "OsF"],
 " characters of text. ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"ExampleData", "[", "\"\<Text\>\"", "]"}], "ExLink"]]],
 " gives a listing of many different texts that you can use."
}], "ExerciseItem",
 CellTags->{"i:92", "9.5 Exercises"}],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  StyleBox["StringPartition", "ExLink"]]],
 " was developed specifically to deal with genomic data where one often needs \
uniformly-sized blocks to work with. Generalize ",
 Cell[BoxData[
  StyleBox["StringPartition", "ExLink"]]],
 " to fully accept the same argument structure as the built-in ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]]],
 ". "
}], "ExerciseItem",
 CellTags->"9.5 Exercises"],

Cell[TextData[{
 "Rewrite the text encoding example from ",
 "Section",
 " ",
 StyleBox["9.2", "OsF"],
 " using ",
 Cell[BoxData[
  ButtonBox["StringReplace",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringReplace"]], "InlineFormula"],
 " and regular expressions. First create an auxiliary function to encode a \
single character based on a key list of the form ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox[
        StyleBox["pt", "ExerciseTI"], "1"], ",", 
       SubscriptBox[
        StyleBox["ct", "ExerciseTI"], "1"]}], "}"}], ",", "\[Ellipsis]"}], 
    "}"}], "ExerciseMR"]]],
 " where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["pt",
     FontSlant->"Italic"], "i"], TraditionalForm]]],
 " is a plaintext character and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["ct",
     FontSlant->"Italic"], "i"], TraditionalForm]]],
 " is its ciphertext encoding. For example, the pair ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     StyleBox["z", "ExerciseTI"], ",", 
     StyleBox["a", "ExerciseTI"]}], "}"}], "ExerciseMR"]]],
 " would indicate the character ",
 StyleBox["z",
  FontSlant->"Italic"],
 " in the plaintext will be encoded as an ",
 StyleBox["a",
  FontSlant->"Italic"],
 " in the ciphertext. Then create an encoding function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["encode", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   RowBox[{
    StyleBox["str", "ExerciseTI"], 
    StyleBox[",", "ExerciseMR"], 
    StyleBox["key", "ExerciseTI"]}], 
   StyleBox["]", "ExerciseMR"]}]]],
 " using regular expressions to encode any string ",
 StyleBox["str",
  FontSlant->"Italic"],
 " using the ",
 StyleBox["key",
  FontSlant->"Italic"],
 " consisting of the plaintext/ciphertext character pairs."
}], "ExerciseItem",
 CellTags->"9.5 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
One rule is needed for one-dimensional output and another for \
multi-dimensional output.\
\>", "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "RandomString", "]"}]], "InputOnly",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RandomString", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Weights", "\[Rule]", 
     RowBox[{"{", "}"}]}], "}"}]}], ";"}]], "InputOnly",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomString", "::", "badwt"}], "=", 
   "\"\<The length of the list of weights must be the same as the length of \
the list of characters.\>\""}], ";"}]], "InputOnly",
 CellChangeTimes->{{3.524667168321303*^9, 3.524667169091877*^9}},
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"n_Integer:", "1"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"{", "c", "}"}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"wts", "\[Rule]", 
          RowBox[{"{", "c", "}"}]}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "InputOnly",
 CellChangeTimes->{{3.524665480351028*^9, 3.524665487450761*^9}, {
  3.524665582184537*^9, 3.524665740698756*^9}, {3.524665864068852*^9, 
  3.524665869803155*^9}, {3.524665943400193*^9, 3.5246659563119383`*^9}, {
  3.524666140682979*^9, 3.524666145392123*^9}, {3.524666187071706*^9, 
  3.524666188487198*^9}, {3.5247009510282288`*^9, 3.524700954719837*^9}},
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "len_Integer"}], "}"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"{", "c", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"wts", "\[Rule]", 
           RowBox[{"{", "c", "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "InputOnly",
 CellChangeTimes->{{3.524665480351028*^9, 3.524665487450761*^9}, {
  3.524665582184537*^9, 3.524665740698756*^9}, {3.524665864068852*^9, 
  3.524665869803155*^9}, {3.524665943400193*^9, 3.5246659563119383`*^9}, {
  3.524666140682979*^9, 3.524666145392123*^9}, {3.524666187071706*^9, 
  3.524666188487198*^9}, {3.524666285132325*^9, 3.524666325461466*^9}, {
  3.524666502948704*^9, 3.524666507196312*^9}, {3.524666741932231*^9, 
  3.524666747124289*^9}, {3.524700956720539*^9, 3.52470096084039*^9}},
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{3.524666685204392*^9},
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"A\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   "10"}], "]"}]], "Input",
 CellChangeTimes->{{3.524666685204392*^9, 3.524666690924117*^9}, 
   3.524700828027565*^9},
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"TCCTCACCCC\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.524666685204392*^9, 3.524666709289818*^9}, 
   3.5247007918150682`*^9, 3.5247008327399178`*^9},
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ACATCTCATC\"\>", ",", "\<\"TCCCACTATC\"\>", 
   ",", "\<\"AAACCCTCTC\"\>", ",", "\<\"CAATATAATC\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7", ",", ".1"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.52466575173214*^9, 3.524665805202302*^9}, {
   3.524665837208754*^9, 3.524665840704852*^9}, {3.5246662112971992`*^9, 
   3.52466622182463*^9}, {3.5246663338978863`*^9, 3.524666361376094*^9}, 
   3.524666516502392*^9, 3.524700837115616*^9, 3.52470086969014*^9},
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"CAAAACCCCC\"\>", ",", "\<\"CCCCACCCTC\"\>", 
   ",", "\<\"CACCCCCACC\"\>", ",", "\<\"CAACCCCCCT\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"RandomString", "::", "badwt"}], "MessageName"], ":", 
  " ", "\<\"The length of the list of weights must be the same as the length \
of the list of characters.\"\>"}]], "Message", "MSG",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Two words are anagrams if they contain the same letters but in a different \
order. This function is fairly slow as it sorts and compares every word in \
the dictionary with the sorted characters of the input word.\
\>", "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams2", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"chars", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{"Characters", "[", "word", "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"DictionaryLookup", "[", 
     RowBox[{"x__", "/;", 
      RowBox[{
       RowBox[{"Sort", "[", 
        RowBox[{"Characters", "[", "x", "]"}], "]"}], "\[Equal]", "chars"}]}],
      "]"}]}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams2", "[", "\"\<parsley\>\"", "]"}], "//", 
  "Timing"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.1534979999999955`", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"parleys\"\>", ",", "\<\"parsley\"\>", ",", "\<\"players\"\>",
      ",", "\<\"replays\"\>", ",", "\<\"sparely\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell["\<\
You can speed things up a bit by only working with those words in the \
dictionary of the same length as the source word.\
\>", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams3", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "word", "]"}]}], ",", "words"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"w__", "/;", 
        RowBox[{
         RowBox[{"StringLength", "[", "w", "]"}], "\[Equal]", "len"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{"words", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "#", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "word", "]"}], "]"}]}], "&"}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams3", "[", "\"\<parsley\>\"", "]"}], "//", 
  "Timing"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.8901609999999991`", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"parleys\"\>", ",", "\<\"parsley\"\>", ",", "\<\"players\"\>",
      ",", "\<\"replays\"\>", ",", "\<\"sparely\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell["\<\
In fact, you can speed this up a bit further by using regular expressions \
even though the construction of the regular expression in this case is a bit \
clumsy looking. The lesson here is that conditional string patterns tend to \
be slower.\
\>", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams4", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "word", "]"}]}], ",", "words"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"\"\<\\\\w{\>\"", "<>", 
         RowBox[{"ToString", "[", "len", "]"}], "<>", "\"\<}\>\""}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{"words", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "#", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "word", "]"}], "]"}]}], "&"}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams4", "[", "\"\<parsley\>\"", "]"}], "//", 
  "Timing"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.09840799999999916`", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"parleys\"\>", ",", "\<\"parsley\"\>", ",", "\<\"players\"\>",
      ",", "\<\"replays\"\>", ",", "\<\"sparely\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The pattern ",
 Cell[BoxData["\"\<\\\\bcite.*\\\\b\>\""]],
 " matches any string starting with a word boundary followed by the string ",
 StyleBox["cite",
  FontSlant->"Italic"],
 ", followed by characters repeated one or more times, followed by a word \
boundary."
}], "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DictionaryLookup", "[", 
  RowBox[{"RegularExpression", "[", "\"\<\\\\bcite.*\\\\b\>\"", "]"}], 
  "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"cite\"\>", ",", "\<\"cited\"\>", ",", "\<\"cites\"\>"}], 
  "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "With suitable modifications to the above for the target string occurring in \
the middle, end, or anywhere, here is the rewritten function. Note the need \
for ",
 Cell[BoxData[
  ButtonBox["StringJoin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/StringJoin"]], "InlineFormula"],
 " here to properly pass the argument ",
 Cell[BoxData["str"]],
 ", as a string, into the body of the regular expression."
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "FindWordsContaining", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"WordPosition", "\[Rule]", "\"\<Start\>\""}], "}"}]}], 
  ";"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindWordsContaining", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wp", "=", 
      RowBox[{"OptionValue", "[", "WordPosition", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wp", "==", "\"\<Start\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<Middle\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.+\>\"", ",", "str", ",", "\"\<.+\\\\b\>\""}], 
         "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<End\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "\[Equal]", "\"\<Anywhere\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], 
         "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", "\"\<cite\>\"", "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"cite\"\>", ",", "\<\"cited\"\>", ",", "\<\"cites\"\>"}], 
  "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<End\>\""}]}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"incite\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"overexcite\"\>", ",", "\<\"plebiscite\"\>", 
   ",", "\<\"recite\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<Middle\>\""}]}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"elicited\"\>", ",", "\<\"excited\"\>", 
   ",", "\<\"excitedly\"\>", ",", "\<\"excitement\"\>", 
   ",", "\<\"excitements\"\>", ",", "\<\"exciter\"\>", 
   ",", "\<\"exciters\"\>", ",", "\<\"excites\"\>", ",", "\<\"incited\"\>", 
   ",", "\<\"incitement\"\>", ",", "\<\"incitements\"\>", 
   ",", "\<\"inciter\"\>", ",", "\<\"inciters\"\>", ",", "\<\"incites\"\>", 
   ",", "\<\"Lucites\"\>", ",", "\<\"overexcited\"\>", 
   ",", "\<\"overexcites\"\>", ",", "\<\"plebiscites\"\>", 
   ",", "\<\"recited\"\>", ",", "\<\"reciter\"\>", ",", "\<\"reciters\"\>", 
   ",", "\<\"recites\"\>", ",", "\<\"solicited\"\>", ",", "\<\"unexcited\"\>",
    ",", "\<\"unsolicited\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<Anywhere\>\""}]}], "]"}]], "Input",\

 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"cited\"\>", ",", "\<\"cites\"\>", ",", "\<\"elicited\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"excited\"\>", ",", "\<\"excitedly\"\>", 
   ",", "\<\"excitement\"\>", ",", "\<\"excitements\"\>", 
   ",", "\<\"exciter\"\>", ",", "\<\"exciters\"\>", ",", "\<\"excites\"\>", 
   ",", "\<\"incite\"\>", ",", "\<\"incited\"\>", ",", "\<\"incitement\"\>", 
   ",", "\<\"incitements\"\>", ",", "\<\"inciter\"\>", 
   ",", "\<\"inciters\"\>", ",", "\<\"incites\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"Lucites\"\>", ",", "\<\"overexcite\"\>", 
   ",", "\<\"overexcited\"\>", ",", "\<\"overexcites\"\>", 
   ",", "\<\"plebiscite\"\>", ",", "\<\"plebiscites\"\>", 
   ",", "\<\"recite\"\>", ",", "\<\"recited\"\>", ",", "\<\"reciter\"\>", 
   ",", "\<\"reciters\"\>", ",", "\<\"recites\"\>", ",", "\<\"solicited\"\>", 
   ",", "\<\"unexcited\"\>", ",", "\<\"unsolicited\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First read in a sample piece of text.", "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<PrideAndPrejudice\>\""}], "}"}], 
    "]"}]}], ";"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[TextData[{
 "Check the length. Then partition into blocks consisting of ",
 StyleBox["1000", "OsF"],
 " characters each."
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"StringLength", "[", "text", "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"blocks", "=", 
   RowBox[{"StringPartition", "[", 
    RowBox[{"text", ",", "1000"}], "]"}]}], ";"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[TextData[{
 "Using regular expressions, we extract all characters from the first block \
that are not amongst ",
 StyleBox["A",
  FontSlant->"Italic"],
 " through ",
 StyleBox["z",
  FontSlant->"Italic"],
 " or ",
 StyleBox["0", "OsF"],
 " through ",
 StyleBox["9", "OsF"],
 " or whitespace."
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"StringCases", "[", 
  RowBox[{
   RowBox[{"blocks", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"RegularExpression", "[", "\"\<[^A-z|0-9|\\\\s]\>\"", "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Tally", "[", "%", "]"}], "//", "InputForm"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell["\<\
Now perform the same computation over all blocks and then compute the mean.\
\>", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"counts", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"StringCount", "[", 
       RowBox[{"#", ",", 
        RowBox[{"RegularExpression", "[", "\"\<[^A-z|0-9|\\\\s]\>\"", "]"}]}],
        "]"}], "&"}], ",", "blocks"}], "]"}]}], ";"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"Mean", "[", "counts", "]"}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell["Finally, perform the same computations on a different text.", \
"SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<OriginOfSpecies\>\""}], "}"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"blocks", "=", 
   RowBox[{"StringPartition", "[", 
    RowBox[{"text", ",", "1000"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"counts", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"StringCount", "[", 
       RowBox[{"#", ",", 
        RowBox[{"RegularExpression", "[", "\"\<[^A-z|0-9|\\\\s]\>\"", "]"}]}],
        "]"}], "&"}], ",", "blocks"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Mean", "[", "counts", "]"}], "]"}]}], "Input",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is the function as developed in the text.", "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPartition", "[", 
   RowBox[{"str_String", ",", "blocksize_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "blocksize", ",", 
      "blocksize", ",", "1", ",", 
      RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[TextData[{
 "This passes the argument structure directly to ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "StringPartition", "]"}]], "InputOnly",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPartition", "[", 
   RowBox[{"str_String", ",", "seq__"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "seq"}], "]"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", 
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\"", ",", "\"\<T\>\""}], 
     "}"}], ",", "20"}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"ATCTGTTCCAAGGTACGATT\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "Try out some of the argument structures commonly used with ",
 Cell[BoxData[
  ButtonBox["Partition",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Partition"]], "InlineFormula"],
 ". For example, this partitions the string into blocks of length ",
 StyleBox["3", "OsF"],
 " with offset ",
 StyleBox["1", "OsF"],
 ", with no padding"
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringPartition", "[", 
  RowBox[{"str", ",", "3", ",", "3", ",", "1", ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ATC\"\>", ",", "\<\"TGT\"\>", ",", "\<\"TCC\"\>", 
   ",", "\<\"AAG\"\>", ",", "\<\"GTA\"\>", ",", "\<\"CGA\"\>", 
   ",", "\<\"TT\"\>"}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Start by creating a substitution cipher by simply shifting the alphabet three \
characters to the left.\
\>", "SolutionItem",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"keyRL3", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CharacterRange", "[", 
      RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
     RowBox[{"RotateLeft", "[", 
      RowBox[{
       RowBox[{"CharacterRange", "[", 
        RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", "3"}], "]"}]}], 
    "}"}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"a\"\>", ",", "\<\"d\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"b\"\>", ",", "\<\"e\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"c\"\>", ",", "\<\"f\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"d\"\>", ",", "\<\"g\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"e\"\>", ",", "\<\"h\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"f\"\>", ",", "\<\"i\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"g\"\>", ",", "\<\"j\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"h\"\>", ",", "\<\"k\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"i\"\>", ",", "\<\"l\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"j\"\>", ",", "\<\"m\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"k\"\>", ",", "\<\"n\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"l\"\>", ",", "\<\"o\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"m\"\>", ",", "\<\"p\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"n\"\>", ",", "\<\"q\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"o\"\>", ",", "\<\"r\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"p\"\>", ",", "\<\"s\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"q\"\>", ",", "\<\"t\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"r\"\>", ",", "\<\"u\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"s\"\>", ",", "\<\"v\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"t\"\>", ",", "\<\"w\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"u\"\>", ",", "\<\"x\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"v\"\>", ",", "\<\"y\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"w\"\>", ",", "\<\"z\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"x\"\>", ",", "\<\"a\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"y\"\>", ",", "\<\"b\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"z\"\>", ",", "\<\"c\"\>"}], "}"}]}], "}"}]], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell["Next, encode a single character using a designated key.", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"encodeChar", "[", 
   RowBox[{"char_String", ",", "key_List"}], "]"}], ":=", 
  RowBox[{"First", "@", 
   RowBox[{"Cases", "[", 
    RowBox[{"key", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"char", ",", "next_"}], "}"}], "\[RuleDelayed]", "next"}]}], 
    "]"}]}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"encodeChar", "[", 
  RowBox[{"\"\<z\>\"", ",", "keyRL3"}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"c\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[TextData[{
 "Finally, here is the encoding function. Recall the ",
 Cell[BoxData["\"\<$1\>\""]],
 " on the right-hand side of the rule refers to the first (and only in this \
case) regular expression on the left that is enclosed in parentheses."
}], "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"encode", "[", 
   RowBox[{"str_String", ",", "key_List"}], "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"str", ",", 
    RowBox[{
     RowBox[{"RegularExpression", "[", "\"\<([a-z])\>\"", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"encodeChar", "[", 
      RowBox[{"\"\<$1\>\"", ",", "key"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell["The decoding uses the same key, but reverses the pairs.", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"decode", "[", 
   RowBox[{"str_String", ",", "key_List"}], "]"}], ":=", 
  RowBox[{"encode", "[", 
   RowBox[{"str", ",", 
    RowBox[{"Map", "[", 
     RowBox[{"Reverse", ",", "key"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"encode", "[", 
  RowBox[{"\"\<squeamish ossifrage\>\"", ",", "keyRL3"}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"vtxhdplvk rvvliudjh\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"decode", "[", 
  RowBox[{"%", ",", "keyRL3"}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"squeamish ossifrage\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],

Cell["\<\
You might want to modify the encoding rule to deal with uppercase letters. \
One solution is simply to convert them to lowercase.\
\>", "SolutionText",
 CellTags->"9.5 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"encode", "[", 
   RowBox[{"str_String", ",", "key_List"}], "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"ToLowerCase", "[", "str", "]"}], ",", 
    RowBox[{
     RowBox[{"RegularExpression", "[", "\"\<([a-z])\>\"", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"encodeChar", "[", 
      RowBox[{"\"\<$1\>\"", ",", "key"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"encode", "[", 
  RowBox[{"\"\<Squeamish Ossifrage\>\"", ",", "keyRL3"}], "]"}]], "Input",
 CellTags->"9.5 Solutions"],

Cell[BoxData["\<\"vtxhdplvk rvvliudjh\"\>"], "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["10", "ChapterN"],

Cell[CellGroupData[{

Cell["Graphics and visualization", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Structure of graphics", "ExerciseSubsection"],

Cell[TextData[{
 "Create a primitive color wheel by coloring successive sectors of a disk \
according to the ",
 Cell[BoxData[
  ButtonBox["Hue",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hue"]]],
 " directive."
}], "ExerciseItem",
 CellTags->{"10.1 Exercises", "i:38"}],

Cell["\<\
Create a graphic that contains a circle, a triangle, and a rectangle. Your \
graphic should include an identifying label for each object.\
\>", "ExerciseItem",
 CellTags->"10.1 Exercises"],

Cell[TextData[{
 "Create a three-dimensional graphic containing six ",
 Cell[BoxData[
  ButtonBox["Cuboid",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Cuboid"]]],
 " graphics primitives, randomly placed in the unit cube. Add an opacity \
directive to make them transparent."
}], "ExerciseItem",
 CellTags->"10.1 Exercises"],

Cell[TextData[{
 "Create a graphic consisting of a unit cube together with a rotation of ",
 StyleBox["45\[Degree]", "OsF"],
 " about the vertical axis through the center of that cube. Then create a \
dynamically rotating cube using ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]]],
 "."
}], "ExerciseItem",
 CellTags->"10.1 Exercises"],

Cell[TextData[{
 "Create a graphic that consists of ",
 StyleBox["500", "OsF"],
 " points randomly distributed about the origin with standard deviation ",
 StyleBox["1", "OsF"],
 ". Then, set the points to have random-size radii between ",
 StyleBox["0.01", "OsF"],
 " and ",
 StyleBox["0.1", "OsF"],
 " units and are colored randomly according to a ",
 Cell[BoxData[
  ButtonBox["Hue",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hue"]]],
 " function."
}], "ExerciseItem",
 CellTags->"10.1 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a graphic that represents the solution to the following algebraic \
problem that appeared in the Calculus&",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " courseware",
 StyleBox[" ",
  FontSlant->"Italic"],
 "(",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Porta, Davis, and Uhl 1994\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "Porta, Horacio, William Davis, and Jerry Uhl. 1994. \
Calculus&Mathematica. Addison-Wesley.\n`1`", 
         Hyperlink[
         "http://www-cm.math.uiuc.edu/WhatIsCM", 
          "http://www-cm.math.uiuc.edu/WhatIsCM"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "). Find the positive numbers ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 " such that the following system has exactly one solution in ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->"10.1 Exercises"],

Cell[TextData[Cell[BoxData[
 FormBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", 
          StyleBox["1", "OsF"]}], ")"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"y", "-", 
          StyleBox["1", "OsF"]}], ")"}], "2"]}], "=", 
      StyleBox["2", "OsF"]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "+", 
          StyleBox["3", "OsF"]}], ")"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"y", "-", 
          StyleBox["4", "OsF"]}], ")"}], "2"]}], "=", 
      SuperscriptBox["r", "2"]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{"="}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}], TraditionalForm]]]], "ExerciseDisplayFormula",
 CellTags->"10.1 Exercises"],

Cell[TextData[{
 "Once you have found the right number ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 ", then plot the resulting circles in true scale on the same axes, plotting \
the first circle with solid lines and the two solutions with dashed lines \
together in one graphic."
}], "ExerciseText",
 CellTags->"10.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create a graphic of the sine function over the interval (",
 StyleBox["0, ", "OsF"],
 StyleBox[Cell[BoxData[
  FormBox[
   RowBox[{"2", "\[Pi]"}], TraditionalForm]], "OsF"], "OsF"],
 ") that displays vertical lines at each point calculated by the ",
 Cell[BoxData[
  ButtonBox["Plot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Plot"]]],
 " function to produce its plot."
}], "ExerciseItem",
 CellTags->{"Sinplot exercise", "10.1 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Using options to the ",
 Cell[BoxData[
  ButtonBox["Plot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Plot"]]],
 " function, create a plot showing the probability density function (pdf) of \
a normal distribution together with vertical lines at the first and second \
standard deviations. Your plot should look something like the following for a \
normal distribution with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Mu]", "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Sigma]", "=", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 ":"
}], "ExerciseItem",
 CellTags->{"Ex.StandardDeviation", "i:39", "10.1 Exercises"}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw1eXk0Vd/7P9d03cu9UkolJBRRRArxbFKRIWSeGwxRokJSppAh8TaFUOZZ
REhyTqZkznTvNU+VFCkqQ/HzW+v7OX+cs5619nr22vvs17T23ovXDe0JTExM
0puv//89BNtnNzao+JODPzOSwveCV1fQNcc6Cl652n1U74QM9PWRZ99e4MZD
XK79lG9RhT349W3HBLjwi0+8t+uDNrx0aWSjjpDwe+tZd5JOmYLdQ9kFRiAn
/uuCVNClE5dhOcYnFAMibrxV1bopxA0yKaM7EyfY8etzTdMVZj6Qclb2Rm8Y
Gy7GdIv5WGswBF69cFtCixVXippnLXGMBh+WAq8bcwRcWyIueG40ES74d4kO
5DHjHQ2Gt/aMpkP8m4+JKc5MuDKVw8N8PA9qxg5wFYmsY25FSYn9RmWwjwep
G6WtYdQv3RfD2KrghWSo8+TUMjbDgt27cKsOxprKhBUUfmPWumyqjj4N8FEq
/ghWuYi5vK6Ntfn8Drb45iscYv6Bje3avviCowOkFL5LZS9+w3TIRTJzS91w
X2Ou+9Xtz1iX7OSDzMBe4DMqiTbfMYmFqWr2fazvhxe/m6gtooNYGHNbOvc9
GmQPfYz8EtSJ6WglS/F/oIO1gUDF0KUKrCZ+kTXmJgNekXz66z3KIb2Gv+6K
BwOOTjILBph1Qbkmi5LMOzrsW3i9olTPgFMZgq9rI2iglcno0DObhOj2KLnO
/H44pcvL8uvlZ3gtpC0p69gLUbY0f5mqb6C8fMF+assHeKe3h1uf9wfcPXXi
e+Gndpjby+fbk7wIfN/P29J3tYDHrYMXorb/BpZEpUVSWQPQhnkMHVqWQdXs
7VGW5jqw8z7xmUNnDYTyamW0+6qg4eCx8Aa2dXBUyJTijy4Dcc7amSxNJrT/
svqlr6/zYU+tyym2UGakvSBFkQ3MAKZVQv6NSQJykDwuoiaTBH8M3tg0ibEi
sdCZJ6L7/oMhedvdYkFs6KeJiBJhKRjcTHm2iAyzI435q1JnHvnAzrhpM9Y9
RMQd+ldX294dSiyf5S7e5kSJgoYm7Q8vg6mKn2bLGxJSYZLHzX3NoMzmmojS
XzJSVtW89P2dDiyTTrK8MuZGfBLvFP/dBDD8oKywJ5GCCF8EVUXdZeH/8ID+
hwfDBx2FcrZU/BoLUS92YT+IG7YUbuOh4NqPFVbw6wpwu1XF728dF65iYjfO
FaEBX/h2cWfeJeNR6luD9g8bAOnv6p2lwyR8C543mt9uA0VRJrU6E0TczlP5
odWPK9DZLfWhMJoDL+teUJIz8YBnRRzNL4+y47give+CYQBEWWp5+H5hxYUM
6//+/hAO61Vsy7pPWPAYQvNK9qk4mH97Qk9Um4A/unTu9NfPqbCWNmjzipMZ
37JxPcxXLBtuSK+m/fTZwK67yBkJ3C6GeS/5/f7jf7EYs7lGZ84KcN5z2WS3
2ip2R1RK8UhsDei0d5Rytkxjxtjc39jiPnA991/iG4kxTIddiDW+eADUb1i5
pJX3YRHm9kuCynSQJKyWu1g2YvFbHxcIKzDAv+9A3+4GayxYbau7eigD3pfb
apSFNcL6yR0bhfIMeOpm06hS1QeX2tfMi5XoYPGk6uxVxTG4As2dYwUDcGbZ
Y2Yvx0dIyJApJcT2gUBhjsAx0ipsIS519Um8hpieV9Uf8/7Ce80UOBBaAcSn
tOIQ7Q3Y+UmHS0iiBDImt+4wnmFCBDVFM+J0NlAsj/1RPkpAyjmjtVzZafBX
bJxFIIgF5QTKyNjR4uDKSYrKrz5WtH+RIPPrQQSINx9L2CfDjqwvCvKt3QyA
Ro9V+di7HKigiXhyz28PmPZSZ/rbSkTpDjqCo/3OENhOXbbeTULF79kK2fts
gVXP8yizNRl58pKHG/sMoU+eHrOSx4WSI52EusxPgZgrJvD1Nzdq4HGfqfA9
BogoEU3RoSJfLS//vf0HAE39aE16TsVPVBOfbg8Uhc7oHC5VRwrebHSd6rRL
DnK6suRtebjxhzZiATltasDytZHnWjsZ35rJ8Sv2+DkYL7fFA0JIuAaz37Wh
Ngtgp2iYbD3CiafgRzKF5x1gSrav6OgMB878x7b1SdsNyBj5+T0ngh0nShKe
B3b6wvbzbxbzFNlwNJ5SdE02FFCMXLXyTxa8KbdNqQLFQMXFxYvaKQSc8JaZ
VVH7CZRQ+9+eMWfGk64l1E3fzIT9zrJLZ7cx4TlWlTP+Owuhr7BkZ0LAP0xs
IuH5yZwX0LzdsL3q+yqGXrGudL6tBqfQEfyC8CfsW12AqM+uPvh0z+eQwMA4
tu2fj7mj8gDckf9PRe4qDUPGXG9Gx2kwM//9maTbe4xD5NwtDyIDni9d3Tcz
mIX1+JwuYAQyQFxxz/MYjTooXdWzqLNgwEjpcwlMtgei2d+2OAXToa5JMaP3
3jC4zDunpAvRoKVjv2X18ylIeVwaYbW3H1YbLKv0rqyAl/nLEMXvtbAittbl
uboGfJKWobn7KsHBnkMgO28dspvS84O1SmH61+eNu4lMSHIbiqnEcyEhwiDt
2Sgz+m30Ov7P4DNYj3I3OSPHgsxeqCxxzSdAaetHXet7rEgrgzt4O/YI/O+1
mYkOsqEuypMi58f3IdmBLdNCigPNE98130i7DevBsVJMt4hIgfHi8el4V+Df
Ru860MqJ3B4v80vtvAglTat1l7nJqIlwukDM1xjq32cMJhlyofBpw5LsLk14
dIKZxzCHGzmK1WvFyyvD+6tHpvh+UtC0rubOOQ9puHww/2EHhYrfe/4nmPT5
INzbOnv2azU3Pv+Cjb9dVwnONg28T7rGheen/Vv1Lj4DXeg6J0OKjDOKJNy3
OBrBUY2Eo44MTnztamHxkcILYLjlikhINBGXU64SU9W7BtXXg3/tVeTAv6d6
cLtL34Y0H4GUxjE2PKAwO+az+30gXu7/fT6JFR9jrXs6/jwSakdox+w0WPBg
HXNrJ+8EOLA3RPHfCjNef2Ih/ZXlM9A8NL4mWcOE846nF6ws5gBP5sE+9dxh
LL9o65NFfhqQSvcnca59wJi3t1FMIuhAlyQ+Mo+sw7rrv0pNmTPA0VHSoXI9
A4o9DvI032fARquM7M4f78FYstvRgYUBF2S4bWtP0MA8c1je6DMNCui54DS/
AdyXpd+WThSCXRcckj7OjFJTJNC4aBY8kNyjT4sgoIKq1KbOziew+lqvbKGP
Bb1+Gx06+CUGRGoVpCKl2NDu9dks2yeh0EbJ6hUJYUcGG3N2MSQ/mA/63tzW
zoFiD5vxh0bdhPdXfvT+2cuJyDTLUIkAR/gWdEY49ioJ7S2Vf+X8wxIsBn4U
phaRUW++/9Rlb3349JRb23yDC0nnjXAeMFWH2qf3JILOUFD1V7YoU3V5qMoU
UuHIoSJVw6e/hadF4diWoMF2GhXfFVc/dXNZBERK+d70xFBwsnFWg0eqLKgY
mkXxKHLjHCwCDx9GIog2TuY1XCLjzSyfhyhSutBK5b3UUkbCc+JesKqvmoFc
h1KmpwUn/nXQLfNRhD24TuYmr27d9HsH3Xgnn7mDiOdM0NNKdjxzy4IlhXgP
GHp/jtRdYMO/p9Euf/4dAhf8zia+2MOK76/6c3FC7z/gL9ebG20k4CNhVm7S
1GQgahouUgKY8RHSUf7E7AwYjY1ovglM+Puw70h/OR/eNX3l3dvzD5vXE91m
vlYGt7ZqcbCfWcPm1D2C2SeqwNPhY0tk+ydMU3w1UKCrF9Zn4sZqPCewZIrG
wS8b/ZAQX5hzr4WOmdavnRcupcHpj847wlfbsLo7sQorc3SoaOtpOvehBHv2
jzzsdpcBC3t16iVHquFEovqj+1cY8FffbHhjvhsOJfWxueXSYWFwVZdDeAhM
Gw2FO0xoEFrtH8fCOgUyTi3ZVg794KRfGTTIvwJRUvGOXvQ3UNT1xBIy1+CV
yGcTo5VKiNMUOi9vug54lix/wmwpBG8YLEW7MSGFil3lbjV5MJg5+sOwnBn5
B/zan1WQDhsaNRvDJBZUeW64L4ozEYweGZj8Z8CK7J4JNUqciIZD5nw1os/Z
Ns8LR7pmXRCwjZEsVFk50E6eN23c3HeAi7tWPVCTiEoyIz4p6bvB1LFa5Ufp
nCgl/R3TutYlCGR+cz/hIwmRhzz3dP80AaVtoetX9nMhvV+uJ71qzkLDvoww
Nl9uNF1rB+zqKkARqnq4s4mC6vVnUy8RZcDSXDmF6RgV1yx6LVTIkICeI+Zr
ftPcuE7PqZD7Osdh4ky4qHYCF24hv4tZlHoarAo1yHVGZLyUmOxXueM8CD/T
pBezkvAbRclWr/3swK/b9vqXaiIuEGS8nSfOBU4Km099usyBt40YqLVWeYLQ
Nl7ZNyR23Fljku+8ZSC021IVrrxlxcv2V935d/whjLTO76BdZ8HDLIcUfM3j
IcJ9oiFahIA//hPUIK31FDIcrKV/TjDh6bJ616icOQDeNgr+MyOYf2xnidj0
AIhvUScYmfZizIJQGniZDm1kPxWuD28xpdKOZTUtBjQIhz1I5YkBKRkJGnrA
gMvQomSv8g7Ojfu1uOzZ9EfdL7f8W+kH2quiWgovHRivMc8/KRsQefH8tChz
MTAz8kXUeJjREdLS9j6mbGhVL8gMsyOg3ycMTFqObPo7t8cWIUUsiHd0i3Ta
UCw0+2XIv2ViQ2JjI5efE8Ph9uyc/D5LdtSxbjuk5+kP5v+W7j3P4kD9em/F
FmtuwcDCzlnv30R0ldOShy54BaryDj5cPklCQafm+0l91nCYt8KtK4iMvuYe
3TmYagDWsz9dJfq4kOtJ9ncrrSdhIUQw85gQBRVJF6xp9ByFv8ZZn0jeVNT2
9Oc91CIOWi9tXzs8oOLv/UMj3CXE4Y77Mat8ZQouvda7U+SlPFB1fzCKP3Ph
e1gjH78QOgme/t8poVlkvLyhL9WsXB9+mRbvUbYk4XIr3tO8tVZg0+vZN0Md
wNyTh7HjVDqELd+SbPvYjP3yyWUKFmbAeWUKgfl9PKZwgD22NYQBhw780f3X
/xYUY35ICm3+D0bY8dUjR8lo69/xeikhI9D2e1P5/h4X0j4RSHVmOwMWxnYJ
aZ3caKX17KyvliIE1RQr8gpR0afeCL/P3AdhlypvevLtVxjiuXh6w5EBV1Wj
iYK/igC7zCzUe48BySZJ+zuy2kFITygv6xMdbvxIjmXppSKlGCuPXrF9cOSA
7sVPX6l45wPb4IOqItAOunypeRR8oy8GHnyRgdCtL05c0eXGS3nqVrO+AQyQ
gmM1iFz4LvKfhR5ZHcBVXCpc3pFw5dshpVcEzKBVqlIrz5UT7+6kqD2ZuAzl
Nf9tGZEg4sS23VPtW9zhovqlrt3t7PjLlbb1SOm7UKMT19PiwYZrZNDRsE0I
/PxlTHSVY8V9EupdVhjRcNby7osDDALO6FP8lOiRBPLTPA9/xjHjDzgkqghq
GVCTV32YaMyEuyx1zxx2yQfcMDzKYfUfNnZ/6Wd4bhm0/9coWnxjDbv0TtIx
7UYV3DX+0p4p8hkrNhVZZc7vhfC0vcdJ7yawH1Zz+x5P9INo8/GhDE8Gtu27
rc94Ag087fJ6XkEHpt8z0tQ3RoeUocA2tU9lmKJ3MZf+bQYYJUy1eUpUQrht
WEfPdQaQ04uOPtPtht/BS4lJVXQItx/at9d9EIwMToVEum/6Q2lpWYmSSRCg
ZQRqhvbDs4RLLs8WluFEzQ7rCr06CBG9mp7ptQYd6lUPxR2qQEqpcN7n0DqQ
S/YatpwoAxPWB/PJVkzIOfIDv7xSPvw9nL27KJUZkZB9uQtfBvg/tenL/U1A
T53txu89SQRxtwcWhcqsSO7hw+/GJdHAeqZmNiuJDX3Mdi1BpsGg9CTyqMwC
O5LgL/Y+23YHYvS7dRuOEBGN5974O7obtGiV/ECRnIg/Mlhhx5dLcFVI0OH5
BxLar9aal/3SFDxf3eHp2cKF3PoGbGtrtcHm8Y3TY1e4EU/awA5dE1WQue19
4UkJBWk/lc5VfCUDJm6soru0qXjP3YrDteMH4G599Pmzq9y4R+WIb7X5MZDi
nP6QWcCFlx6WlfqidQoy7A4/LHUi4+nYi/AQL0Pg60yXMNhFwi2ORxsVTtjC
dpkhvt0dRFym6L0HHXOG0GV1i/d3OPCjn7/cimD1BLvxhz6Kwpt5NZXSfag/
AEqsi/pv9rPin3L2sT+4HwGuaqsPYoJZ8AjupTq+zjio3UkNG1Qg4Gd71FYX
EtKgkyDQ3P+LCfd4ysywTsgGk2mvz4Jho1jbqknTtvcDUKHWpeDN1od9C7/K
KqJPh9WQ2mXl7Q2Youydf0yIAT6xp1td5P3BgoH18GzmzYSVWIiYagLjmGwu
ewkGRAuTXFLN+qHnoNfpDHE6uBVr88KtDdCYXIqixhVDz8iogPZfJiTzvogn
yD0bvnW6dUyeJaA8+6+nds+mwt025cMGiSwIuyn2QsksDhIv0I8PzbKiBW/N
QWJzOJyjx9hnnmJHbS8Vah8s+sOjV17m6dEc6CA/6XbwZp63lj/0q2aciG4I
iBnv/nMFUmr2qBceJqH5Gd8BjW4b2CXDd37GjYyWtvx5vKBgCIlRH/3/q+NC
IyZuN2ceaUD46rztFjIFVb7RburKUgDB5w6vH16korl0IsPx/X7QaD9w0v8J
Fd+zfHrqm4EYiDJfr7hpQMGHV4d5vk7JgQVF+wH7Xy487ZzWEv3Gpj88Ohh1
p5qMy3KgtjwxfZgNZr8+6kbCs0hubRy4JXxjYeWk1A1gwdF8p82XaVB988XH
VckWbGV97UzbNgaY8d7KcsKeYm7P/sjuDWaA3WS94b67OJwJGMzVMmRAY27S
sPZeMpr1ErFkazfaxFtpi6wTFxo7SOaL/3QGllpkzt+u4UYt+jIm40pKkLPV
jRJHpKLE8ln3VmUp8JaP3LFKqMUO+oWKqV9gwKyh9bHZlVzoPuQfvDuAAe08
9lKLZ9vg1VshX6tfdIg7a+0UXEtFU809y1eZROHI+NOl3QP5WPOEmfiSHwMi
iiuqR6NfgyGNGn73IgNSotUChyNwzD8lc3bSgAEtf+Yl2DhSYNDuWmTP5nqe
tOhjR7IfYMy8oSX9m/pde+axpPJ8JeZ79Tb3LlcGLMdNfDuwXArmHNU757wZ
oJ9Irwv4QkWjw06i6+dFoLRcVnzxFxXf7uRnHzW1FzI4rqgFllPwb/IujTti
ZODQkk1svCk3vrda0EjWHOCO/WqvCi8XLv1OmJZapQ01fTusVXpIeMqQaf2+
UlOIH14UeHubE+f98bf5yqPLMJDDrtspT8Qrnv7719LmBoF5z5YYA+x4rave
Hdd6HyhsuyjS6ceGM/ieD+3ZFgJKZZa4tiorfumQ6KD/s2i4eHhrvO4UAa9y
Kir6JJEEZ4+4mU2nMeMPmR6YWVAz4IDcucs9tkz4WcWZWh+xfFBJYuiGUdax
yqUxFW7fMljWDyz3D13DuA/x+n1RrgIm3a+dJbqfMYEK461D8b2gv+I4Lft9
Ans0+l7jbE8/uNj4ebzsYGA3v5F0OcNpQBE8U2ow2YGxX+S6Fkanw92ELowi
Vo4tVKUVsHoyIET/eXdKVwXEXc0zfXljM8/HFDeOr3TBgWJpCy+MDgMFbZSS
nYMwwPbySpUvDRKd7m8o35+EOcePmvxJ/VCrWGNzf3gZfnsw5SmG18GinlFj
/4U1WOgfj6WkVsHyEfdaoV3rwFxVe1vHoQzqQtK/PjVkQiHWxuwf7uQDl2do
KT2GGSl7v9Z+pJ0BeHupauQ3AmpxTUZBHxOBciHDqlqGFfH4NKk4zUTDwhsu
lo+P2NBqw1H+/dnBYLyit0/iEzsizzWfPizlAyY3LHqn9hMRZSZcNUzQHV4b
5ursus+JPkofvWWldBkulujRXr8joWkZqovaTjPYxnVrJzsHF9ozceadnJoO
HPwwKNpuy42OyQo4LU6pwtusQW2rTAr6keumpblNFvrWZj6LG1PxLVuNnsQ6
HgCD8CK/w2wUfDwyipw7pQA9X6IPdFdw4ZZx9xVefNGA06+z2vNvkHHxvbUb
qhKGwGOv1yMiRsKZiipk+ExsYWKM/4scjYh7Va0f/mjqDIXTVfE1wRx4PKHP
qLHIA/xPtz77I8mOO0zo+drEBkDa8B0x7zFWvJhCVT0pGQGVfzfALZoFt5Ub
DfALi4P+uWyXDUTAE4XL6RyQBtP6PjHvNpjwKYKzZIV1NkwmsSJXxij26fF4
+sXXA7DG4PsQYdWHHbEiF1ecokOMhuVAb3UD1pZjXy6qzICBH4FPeZadIKOO
x1Vlk+9LB1bU0hSagBb7akzwMAMSNSsez3H0g9cT9Ltahg4ncraMT9puAH+2
m7/haDEo2a3s1P/JhDTJkk4RBdnwb5vRJpsSkNeOoptCZ9KgdjkySeERC/L0
dn7t8zgO/A0XlWbGWBHz9ev6LuIRoHTu470pJXa0sAqc5nIBkL9D8UxyCAfy
SXHT68r2AGGT6jtD/USUJeqwr8DeGaIatqcGiZHQlPelfFkDW6BipxqXHMgo
MfbNAgo2BIXJ0bCmci5UQChU917UADN5U9V1JgoqPRJk3stzDJ4PvcvWNaWi
u3ZS27/pHoB6U26OyGwqbsaZys3zRRRWWsLHzawoeAbvZ41jvnLA9P3PyBF2
bpxQcjk8UlAd7KLPdd+sJ+M2HUuGk/g5+ChQvqPUh4SfZ9Y8taJhCXIpZzOF
+WiYpGC0xvNvNNCXNWiI6WjBvA9w9ZZTGDDv26ukZ52B+Q/+J7MliAGLvgYF
V9MwsD53sjnZhAGvFFp1zXaQ0bLKCS1nUWMQ9cr/YG/NhTgTH70VsNCEt4Qk
WftSbuT35QwUVSrBcfRh2egfBZmLW6Tp0KQg73lrj4TmG4zJPmkox5oBB0Ya
9PTvZsNth5KwoEAGfJprPcSe1gpcf96d9PpLB3GvOsPTZVREGXQQF3QXhUVj
xZGX54swI/IhhdO+DKhz9H/DeqwG1omP1rY7MEBeb9z21qG3WGln9L0cXQac
5qo1+0B+DPqrBXdSN/NC97khmY6OaKzFYmn20ibff63v++gsV415nmz/K+yy
mScqJH5U3XgOQwcX2xZ9GDDRqJivPkpFDVyjkf2vReC1sALtVm4p1jntJXzr
zma+cy662isZDhT+hae1m/0GxNV65RuTsbGOkHzOzfkKW34LBXkVgK7WYVLE
pj65ObNzBZrlYhz76rLubOpbzo/oewIBz2BaU3jr+OZ+H5zqV0yw9sFWeUqH
hDbPO+bi1YcvUdHCvYQp9fm9cH1lX+jKKhUva9l9cLxyLzz86klbqqbgotw8
L9cdZCDg8su6Qitu/HzBcN9lHoB23qO3lHZw4efkpb2VfLThuLCrbA6NhJeR
yx/l3jGFOxUxIR33OPHcfl1vNfvL8Fng7expJSKeo0Y23Z/vBjGWwKE4zI4/
vHDpsH2kD4iSz7Z2B7HhczJLT6jfg2H0kU1KzUlW/O4+h05CUDS4Jtmw280Q
8EYVPdJ51iQwYTxVHclkxh8Z/fEr+Z0ONreTfY/ZM+FBWcP2dEI+3D3BXJzM
v47tOXO90OlKGTySmbjjHLuG8bsr00qEq6Be89s5+UufMYpsv5Xaw154IR5R
c4plEhOkZa8mt/bDo4KMetUVBraP0EqIvk+Dwbvbn6bKdWJ9dfEP+vvo8G3x
l6JHYzkmuysCum8x4Jk0X+9zkQpQadTU59usD9WY/pDJ74LK2TAns4ZNfeo4
GbQ0xwBS5L881WAaLASXODRdmwTFU+W+nun9cDbCnn6rZxnwkL9f+PLqQPJy
S/+8yRqUveHRz6iuApvDRpk/qOtgqlJvI+FTBj/fHXLO0GVChQnhfnpP8mHb
ztVV10hmVKxknNLlkAF2U4xFv88E5Cbxr6ONlASBjOcjqgdZUYJOx9Yytv/A
YeUoNTiMDUVIXP/m0R4MF/MOJ4tNsKMPq01Z26x94Ph9oe23RIiIndNl/b2a
O8jT9q2y+3Ii5qj4ftdLl2H41ydqfT0JNe5/UJ6qbQYXXy7secbMhSpPuAdo
BukA7zwlrt6CG3Ek79EpPAhAUia/rU2lIPZPL7bdVZeFWLUhLWkLKh5pU/Cv
8+ABOOFaw5dBouAHWNSlrucrgJjF5/OfXnHh+9STKqVrNDb1eexqjhcZd9Xb
ERhJMITI0qycCEkSXj4+kbNriy00V1UZomEi3r5M7rwp6gy1Fjfk5CI48Gn5
x8g4wAOiV5zKTWTY8aHq9YGmGwGwXeBih880K57CV6a7/i8cLAYJAmPxLPif
zAxVH8c4mDT9MbzlNAE3fsiyxW5rGiz8KbiNszLjdMbd8XC1bMhbOvstnnkM
a6oNU/WrGABBcUVBvtA+jHbLnOGK6GCTKdkkRGrEXlWaZeceZ4AUdcSZTVoD
amLSJzU28XeiSaph/3gjELubOb7KbvpJK86S+LE+ePPV71bVUTpkZCw1Vxhv
wKF/8Q9zWUrANT0k0XCOCf0yoIsqv8sG9uqmomwlArJ2OTmy7JEGVtQqPYkw
FnSF5u9hXhUHS61Mta6DrEgm9P1+smkElIZTwu8fZd/003z9UecDoLJ5Z11C
AAdiTS1I7O/wAILjvTcu3UTU3NAtFpXqDETN2LPuwiSkbjmA2cTYQjj76N/V
C2TklGUiO1xkCMERlo9sS7hQR4nYHhfxU6BqEFG8tMaNJr2/f3lw5hgsuy/v
KjGgIssZfsbh/w5AQOqGU2wBFZ+42e9s+lIUposSPdsuUPA/P86kbNWRg/O2
epxaZG788N4rXXNLavBCJdzN7R0Zr1LF/bzunoOLTpzf+ANIuMi87wspoiWY
zFxbyEc0rKwtp6PtEw0EooVfjAq+xwYlKX5JZAZ0Kgof3p2SicWmv7C+c58B
XFZVRX4/6sD2IsvJF2abfO57McSGl4zY/C0mBQyM4aaw+MCGKReaOP06+lmc
JuQJdTyzLORG4zu7kq1+KYH/ALPryz8U1Hrp2YHj4tKArl0pfTv7Bkt8Xktt
tWSApoiXxX2VLDD8wKoiuTnfjeF/z6POtEKJjZXO0gYdXLm/v8sppCIXKd1c
owJR6OMJ+RAYU4xVjtM87O4xgKbxCdsR/gocjX4y9zoygKn4uR7u9xYLyqWd
8NZmQFCCiNuxR3Fwv/vo7qVN/o9purXTUTsW29C2kxXY1IdA/5sNhIFq7GvZ
haPxVxiguzL8d1auBNYvfb8wc5cBkpbOgpl0KhJPxkhRCyIg5WtlMHS6DDuT
ts7kuJk/1n29nzw9HAzD+XJFXzf7PU4ZfN2plop9+aZmm7yZZ1q5Cw5WHc8H
D2YdBTN/BhiInWc69zgPk/6laFS7WYdfC+V9GpQGBo9z1Gw2x/OP7Jlfzw/E
/jizVG9s9iMS8rT2fqeiq1q+GSPCIrBwbv/P6zc8Yaf7la1Sm3jgbgw5HSCY
jmGd8iJpm3rFEWis5hKWBJouc79ObK5XsOJ+tMOzh5j1rCuWvtmPxWRMhUM8
CriGD5bc36y3leXOJp9OxG4NavBc3xwvzuX2+JCjO5ac4bRTYbO/Z/9pW7tV
KsJ3cGZJ1e793/08zvR/z//u6/9X/z9Dan4P
   "], {{{}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], EdgeForm[None], 
      GraphicsGroupBox[PolygonBox[CompressedData["
1:eJwl1WWcFVUYwOFl6ZZOgaVbSqTEABRFGqRBke6WULpDBaW7W1JQ6RCkUUJB
WrqlpASfAx+e33n/Z+buvTszdzeqcftq7SIjIiKikS/y5Zo38uVcyJzHut5m
FmtN62rSmR84VtG8hGR6ur5AKT2ZSHt19B0+0AtIbK+v3sGr+gv+pqCexnlK
6klEc25t/Q/l9XwS2eujfyG97sU5Cuip/E0JPTH8Es6tZbnN+3oeCe311ttJ
p3tyltf0FM5RXE/gOR/rW7xnnksCr/9SbyOt7sEZ8uvJnKWYHs8zauov2Eoa
3Z3T5NOTOMMbehz/UUP3Ygup9eecIq+eyGmK6rE8pbruyWZS6W6cJI+ewCle
19/xhGq6B5tIqbtygtx6PCcpor/lMVV1dzaSQnfhL3LpcZygsB7DI6roz9lA
ct2Z4+TUY/mLQno0D6msu7GeZLoTx8ihv+M4BfU3/Esl3ZV1JNUd+ZPs+luO
UUB/zQMq6i78TBLdgT/Ipj+iMz/xir32HCWrrkAnfiSxvXYcCd8BnZkoMpGR
DHxIR9aSyHltOcyr4dmnA2tIaK8Nh0ivx/Anr+mvuE953Z4fSKBb83v4zun7
4XObF5PUszha/0F+PYp7vK9vUs48h/jOa6crm78nhV6t45tb8RtpdQ3rqjA7
fi/87uaM5grWRSQxfxOupTnKXDVcd+tyayrrUcdyWteE3zv8/QjX0jrSepf3
HM+t15kzW6uF+2xdYU1tveF4LutancFaNtwn62xrPGvbcK/MmcyVrEtJbl4V
rlW4nuZ41pYcJI396taVYXbsbrhP5oW8or/WVczLSKmP6LzmEdyhnL5OGfMs
4jqnjV5JXN2CA+Gz6684TB49nH8oq6/xrnkmcby+tV5BHN2c/eHa6VEcCtdH
D+M2ZXQrlhNbN2Nf+KzhZ9KSZcSy15S94d6G7134LoXvR3jmw7PNO7Tge2I6
rwl7SKzfpjlLiWHvM3aTSL9FM5YQ3V5jdpFQj+T3cM/0UG5RWjdlMZH6U34l
gR7Bb+EZ0UO4yZu6CYuIpj9hZ3hm9XAOkkMP5gal9GcsjIh48Y+qETvC8yGH
cYDsehDXKakbs4DnNLT3S7iX5qHsJ5seyDVK6E+ZzzMa2Nse7p15CPvIqgdw
leL6E+bxH/XtbSO2eTB7yaL7c4ViuhFzeUo9e1uJZR7EHjLrflzmDX013D/z
jPBzPUMN9RyeUNfeFmKaB7KbKN2XSxTVV8I9Nk8P7+P1DfRsHlPH3mZimAew
i0y6Dxd5XV8Oz4F5Wngfr6+vZ/GI2vY2Ed3cn1/JqHtzgSL6EqXNU8P7eH09
PZOH1LK3MdqLf9UR/dhJBv0l5ymsL/KmeUp4HyfW1TP4l4/tbeB/ZNMGWw==

        "]]]}, {}, {}}, {{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1mW4VFUYgNGLgDQIKN2tSDdSUtISCijdIQIS0lLSoXSHdEkK0t3dSEpI
g4SUAuLajz8W+3v3nGGGmX3uJW3jdtXbRoqIiMj6VkREWDf5oybPzTP5ksge
m2qvKDd0Hv4w9yIVe3RfXBaxWdfihfkn6hDFA9PsFeOmzst183ekZq/uF16H
Lbo2f5tnUZeonj/dXnFu6XzcMPcmDft0//A6bNVf8I95NvV42/Nn2CvBbZ2f
m+Y+pGW//j68Dtv0l7w0z6E+0Tx/pr2PuaMLcMvcl3Qc0APC67Bd1+GVeS4N
KMhte/1Iz0E9MPy97NB1eW2eR0MKccdefzJwSA8iOjt1Pf41z6cRhblr73sy
clgPJga7dH3emBfQmI+4Z28AmTiihxCT3bpBOAgstDShCPf1QDJzVA8lFnt0
QyKxSDelKH/qQWThmB5GbPbqRrzFYt2MYjzQg3mf43o4cdinGxOZJbo5xYnL
fntNiMLPugUliMcBe02JylLdko95h/gkICHv8h4HXdeMt1mmW1GSRByy15xo
LNetKcVDPYQPOKFHkJjDugXRWaG/Ct+dM/STLsldXZpH5qFk5aQeSRKO6JbE
YKVuE75Lz5+lS3FPl+GxeRgfciq8V9csM1flh/Bv1QvNFfhLJ9UrzTVIqo9a
WxGTFB5bbV0VPhPzz+Yq4f4yr7N+Hc6HeXY4Y9bS4d63/hq+M+v98N6tK8IZ
sVYP94Z1Q/h8rGU9/pd5eDjTOps1pXVNOCPW0+Gzsy4PZ9JaLdyb1vXWH8N3
Zl5krhh+ZpjXWp/YT2ZeZf6MZPqYtTWx+CV8tx5fav6UtuHM6jnmMvypP+GJ
eQTZOaNHhfPhusW6Ek91co6bvyI2q3U7yvFUjyQHv+nRpOCEbkMc1uj2lCcl
J8NnSlx+1d9QgVSkJg1pSUd6ToX3TzzW6g5UJAOn7bXjHdbpjlQiI2fstSc+
63UnKvMsnBFyclaPIRO/6W9IwAbdmSo8D98DuTinx5KZs7oDCdmov+VTXuhR
5Oa8HkcWzumOvMsm3YWq/K1Hk4cLejzvc1534j02665U4x89hrxc1BP4gAu6
M4nYortRnZd6LPm4pCeSlYv6WxKzVXenBq/0OPLzu57Eh1zSXUjCNt2Dz3it
x1OAy3oy2fhddw33G9t1Tz7nXz2BglzRU8jOZd0tnGV26F7Edhbn6rI80DV5
Y55IIa7qqeTgiu5Ocnbq74jj+fP0JzzUtQi/rCfpwlyT08jJVd0j/Dxgl+5N
XNfO1+V4pGsTyd5k/RF/6Onk4pruGe5tdus+xHPtAl2ex/qL8PL2pugiXNcz
SGhvia7Ms3DP6V/Mn5PevDHS//9Pye2x/wBKOAX6
       "]]}}}],
  AspectRatio->0.4,
  Axes->True,
  AxesOrigin->{-4, 0},
  Epilog->{
    GrayLevel[1], 
    Thickness[0.0035], 
    LineBox[{{{1, 0}, {1, 0.23697072451914336`}}, {{-1, 
       0}, {-1, 0.23697072451914336`}}}], 
    LineBox[{{{2, 0}, {2, 0.048990966513188065`}}, {{-2, 
       0}, {-2, 0.048990966513188065`}}}]},
  ImagePadding->{{16, 0}, {10, 0}},
  LabelStyle->{},
  Method->{"AxesInFront" -> True},
  PlotLabel->FormBox[
    StyleBox[
     InterpretationBox[
     "\"Normal distribution: \[Mu]=\\!\\(TraditionalForm\\`0\\), \[Sigma]=\\!\
\\(TraditionalForm\\`1\\)\\!\\(\\*Cell[\\\"\\\"]\\)\\!\\(\\*Cell[\\\"\\\"]\\)\
\"", 
      StringForm[
      "Normal distribution: \[Mu]=`1`, \
\[Sigma]=`2`\!\(\*Cell[\"\"]\)\!\(\*Cell[\"\"]\)", 0, 1], Editable -> False], 
     9, StripOnInput -> False], TraditionalForm],
  PlotRange->{{-4, 4}, {0., 0.39894220478008047`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{-2, 
      FormBox["\"-2\[Sigma]\"", TraditionalForm]}, {-1, 
      FormBox["\"-\[Sigma]\"", TraditionalForm]}, {0, 
      FormBox["\"\[Mu]\"", TraditionalForm]}, {1, 
      FormBox["\"\[Sigma]\"", TraditionalForm]}, {2, 
      FormBox["\"2\[Sigma]\"", TraditionalForm]}}, Automatic},
  TicksStyle->Directive["SR", 8.5]]], "Figure",
 CellTags->"10.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Modify ",
 StyleBox["ProteinDotPlot", "MR", "ExLink"],
 " from the introduction to this chapter to accept options from ",
 Cell[BoxData[
  ButtonBox["ArrayPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ArrayPlot"]], "InlineFormula"],
 "."
}], "ExerciseItem",
 CellTags->{"i:41", "10.1 Exercises"}],

Cell[TextData[{
 "Modify the ",
 StyleBox["Hypocycloid", "MR", "ExLink"],
 " code to create ",
 StyleBox["epicycloids",
  FontSlant->"Italic"],
 ", which are like hypocycloids except the smaller circle rotates on the ",
 StyleBox["outside",
  FontSlant->"Italic"],
 " of the larger circle. Then create an animation showing the epicycloid \
being sketched out as the smaller circle rotates around the larger circle. If \
your animation includes a way to select different radii for the circles, you \
will need to deal with the plot range as the size of the smaller circle \
changes."
}], "ExerciseItem",
 CellTags->{"10.1 Exercises", "i:40"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The color wheel can be generated by mapping the ",
 Cell[BoxData[
  ButtonBox["Hue",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hue"]], "InlineFormula"],
 " directive over successive sectors of a disk. Note that the argument to ",
 Cell[BoxData[
  ButtonBox["Hue",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hue"]], "InlineFormula"],
 " must be scaled so that it falls within the range ",
 StyleBox["0", "OsF"],
 " to ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"colorWheel", "[", "n_", "]"}], ":=", 
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", 
         RowBox[{"Rescale", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "]"}], ",", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "1", ",", 
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{"#", "+", " ", "n"}]}], "}"}]}], "]"}]}], "}"}], "&"}], 
     ")"}], "/@", 
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", 
      RowBox[{"2", " ", "\[Pi]"}], ",", "n"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[TextData[{
 "Here is a color wheel created from ",
 StyleBox["256", "OsF"],
 " separate sectors (hues)."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"colorWheel", "[", 
  FractionBox["\[Pi]", "256"], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0], 
    DiskBox[{0, 0}, 1, 
     NCache[{0, Rational[1, 256] Pi}, {0, 0.01227184630308513}]]}, 
   {Hue[
     NCache[
      Rational[1, 512], 0.001953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 256] Pi, Rational[1, 128] Pi}, {0.01227184630308513, 
      0.02454369260617026}]]}, 
   {Hue[
     NCache[
      Rational[1, 256], 0.00390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 128] Pi, Rational[3, 256] Pi}, {0.02454369260617026, 
      0.03681553890925539}]]}, 
   {Hue[
     NCache[
      Rational[3, 512], 0.005859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 256] Pi, Rational[1, 64] Pi}, {0.03681553890925539, 
      0.04908738521234052}]]}, 
   {Hue[
     NCache[
      Rational[1, 128], 0.0078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 64] Pi, Rational[5, 256] Pi}, {0.04908738521234052, 
      0.06135923151542565}]]}, 
   {Hue[
     NCache[
      Rational[5, 512], 0.009765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 256] Pi, Rational[3, 128] Pi}, {0.06135923151542565, 
      0.07363107781851078}]]}, 
   {Hue[
     NCache[
      Rational[3, 256], 0.01171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 128] Pi, Rational[7, 256] Pi}, {0.07363107781851078, 
      0.0859029241215959}]]}, 
   {Hue[
     NCache[
      Rational[7, 512], 0.013671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 256] Pi, Rational[1, 32] Pi}, {0.0859029241215959, 
      0.09817477042468103}]]}, 
   {Hue[
     NCache[
      Rational[1, 64], 0.015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 32] Pi, Rational[9, 256] Pi}, {0.09817477042468103, 
      0.11044661672776616`}]]}, 
   {Hue[
     NCache[
      Rational[9, 512], 0.017578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 256] Pi, Rational[5, 128] Pi}, {0.11044661672776616`,
       0.1227184630308513}]]}, 
   {Hue[
     NCache[
      Rational[5, 256], 0.01953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 128] Pi, Rational[11, 256] Pi}, {0.1227184630308513, 
      0.1349903093339364}]]}, 
   {Hue[
     NCache[
      Rational[11, 512], 0.021484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 256] Pi, Rational[3, 64] Pi}, {0.1349903093339364, 
      0.14726215563702155`}]]}, 
   {Hue[
     NCache[
      Rational[3, 128], 0.0234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 64] Pi, Rational[13, 256] Pi}, {0.14726215563702155`,
       0.1595340019401067}]]}, 
   {Hue[
     NCache[
      Rational[13, 512], 0.025390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 256] Pi, Rational[7, 128] Pi}, {0.1595340019401067, 
      0.1718058482431918}]]}, 
   {Hue[
     NCache[
      Rational[7, 256], 0.02734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 128] Pi, Rational[15, 256] Pi}, {0.1718058482431918, 
      0.18407769454627693`}]]}, 
   {Hue[
     NCache[
      Rational[15, 512], 0.029296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 256] Pi, Rational[1, 16] Pi}, {0.18407769454627693`,
       0.19634954084936207`}]]}, 
   {Hue[
     NCache[
      Rational[1, 32], 0.03125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 16] Pi, Rational[17, 256] Pi}, {0.19634954084936207`,
       0.2086213871524472}]]}, 
   {Hue[
     NCache[
      Rational[17, 512], 0.033203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[17, 256] Pi, Rational[9, 128] Pi}, {0.2086213871524472, 
      0.22089323345553233`}]]}, 
   {Hue[
     NCache[
      Rational[9, 256], 0.03515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 128] Pi, Rational[19, 256] Pi}, {
      0.22089323345553233`, 0.23316507975861744`}]]}, 
   {Hue[
     NCache[
      Rational[19, 512], 0.037109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[19, 256] Pi, Rational[5, 64] Pi}, {0.23316507975861744`,
       0.2454369260617026}]]}, 
   {Hue[
     NCache[
      Rational[5, 128], 0.0390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 64] Pi, Rational[21, 256] Pi}, {0.2454369260617026, 
      0.25770877236478773`}]]}, 
   {Hue[
     NCache[
      Rational[21, 512], 0.041015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[21, 256] Pi, Rational[11, 128] Pi}, {
      0.25770877236478773`, 0.2699806186678728}]]}, 
   {Hue[
     NCache[
      Rational[11, 256], 0.04296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 128] Pi, Rational[23, 256] Pi}, {0.2699806186678728,
       0.28225246497095796`}]]}, 
   {Hue[
     NCache[
      Rational[23, 512], 0.044921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[23, 256] Pi, Rational[3, 32] Pi}, {0.28225246497095796`,
       0.2945243112740431}]]}, 
   {Hue[
     NCache[
      Rational[3, 64], 0.046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 32] Pi, Rational[25, 256] Pi}, {0.2945243112740431, 
      0.30679615757712825`}]]}, 
   {Hue[
     NCache[
      Rational[25, 512], 0.048828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[25, 256] Pi, Rational[13, 128] Pi}, {
      0.30679615757712825`, 0.3190680038802134}]]}, 
   {Hue[
     NCache[
      Rational[13, 256], 0.05078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 128] Pi, Rational[27, 256] Pi}, {0.3190680038802134,
       0.3313398501832985}]]}, 
   {Hue[
     NCache[
      Rational[27, 512], 0.052734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[27, 256] Pi, Rational[7, 64] Pi}, {0.3313398501832985, 
      0.3436116964863836}]]}, 
   {Hue[
     NCache[
      Rational[7, 128], 0.0546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 64] Pi, Rational[29, 256] Pi}, {0.3436116964863836, 
      0.35588354278946877`}]]}, 
   {Hue[
     NCache[
      Rational[29, 512], 0.056640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[29, 256] Pi, Rational[15, 128] Pi}, {
      0.35588354278946877`, 0.36815538909255385`}]]}, 
   {Hue[
     NCache[
      Rational[15, 256], 0.05859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 128] Pi, Rational[31, 256] Pi}, {
      0.36815538909255385`, 0.380427235395639}]]}, 
   {Hue[
     NCache[
      Rational[31, 512], 0.060546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[31, 256] Pi, Rational[1, 8] Pi}, {0.380427235395639, 
      0.39269908169872414`}]]}, 
   {Hue[
     NCache[
      Rational[1, 16], 0.0625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 8] Pi, Rational[33, 256] Pi}, {0.39269908169872414`, 
      0.4049709280018093}]]}, 
   {Hue[
     NCache[
      Rational[33, 512], 0.064453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[33, 256] Pi, Rational[17, 128] Pi}, {0.4049709280018093,
       0.4172427743048944}]]}, 
   {Hue[
     NCache[
      Rational[17, 256], 0.06640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[17, 128] Pi, Rational[35, 256] Pi}, {0.4172427743048944,
       0.4295146206079795}]]}, 
   {Hue[
     NCache[
      Rational[35, 512], 0.068359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[35, 256] Pi, Rational[9, 64] Pi}, {0.4295146206079795, 
      0.44178646691106466`}]]}, 
   {Hue[
     NCache[
      Rational[9, 128], 0.0703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 64] Pi, Rational[37, 256] Pi}, {0.44178646691106466`,
       0.4540583132141498}]]}, 
   {Hue[
     NCache[
      Rational[37, 512], 0.072265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[37, 256] Pi, Rational[19, 128] Pi}, {0.4540583132141498,
       0.4663301595172349}]]}, 
   {Hue[
     NCache[
      Rational[19, 256], 0.07421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[19, 128] Pi, Rational[39, 256] Pi}, {0.4663301595172349,
       0.47860200582032003`}]]}, 
   {Hue[
     NCache[
      Rational[39, 512], 0.076171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[39, 256] Pi, Rational[5, 32] Pi}, {0.47860200582032003`,
       0.4908738521234052}]]}, 
   {Hue[
     NCache[
      Rational[5, 64], 0.078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 32] Pi, Rational[41, 256] Pi}, {0.4908738521234052, 
      0.5031456984264903}]]}, 
   {Hue[
     NCache[
      Rational[41, 512], 0.080078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[41, 256] Pi, Rational[21, 128] Pi}, {0.5031456984264903,
       0.5154175447295755}]]}, 
   {Hue[
     NCache[
      Rational[21, 256], 0.08203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[21, 128] Pi, Rational[43, 256] Pi}, {0.5154175447295755,
       0.5276893910326605}]]}, 
   {Hue[
     NCache[
      Rational[43, 512], 0.083984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[43, 256] Pi, Rational[11, 64] Pi}, {0.5276893910326605, 
      0.5399612373357456}]]}, 
   {Hue[
     NCache[
      Rational[11, 128], 0.0859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 64] Pi, Rational[45, 256] Pi}, {0.5399612373357456, 
      0.5522330836388308}]]}, 
   {Hue[
     NCache[
      Rational[45, 512], 0.087890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[45, 256] Pi, Rational[23, 128] Pi}, {0.5522330836388308,
       0.5645049299419159}]]}, 
   {Hue[
     NCache[
      Rational[23, 256], 0.08984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[23, 128] Pi, Rational[47, 256] Pi}, {0.5645049299419159,
       0.5767767762450011}]]}, 
   {Hue[
     NCache[
      Rational[47, 512], 0.091796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[47, 256] Pi, Rational[3, 16] Pi}, {0.5767767762450011, 
      0.5890486225480862}]]}, 
   {Hue[
     NCache[
      Rational[3, 32], 0.09375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 16] Pi, Rational[49, 256] Pi}, {0.5890486225480862, 
      0.6013204688511713}]]}, 
   {Hue[
     NCache[
      Rational[49, 512], 0.095703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[49, 256] Pi, Rational[25, 128] Pi}, {0.6013204688511713,
       0.6135923151542565}]]}, 
   {Hue[
     NCache[
      Rational[25, 256], 0.09765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[25, 128] Pi, Rational[51, 256] Pi}, {0.6135923151542565,
       0.6258641614573416}]]}, 
   {Hue[
     NCache[
      Rational[51, 512], 0.099609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[51, 256] Pi, Rational[13, 64] Pi}, {0.6258641614573416, 
      0.6381360077604268}]]}, 
   {Hue[
     NCache[
      Rational[13, 128], 0.1015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 64] Pi, Rational[53, 256] Pi}, {0.6381360077604268, 
      0.6504078540635119}]]}, 
   {Hue[
     NCache[
      Rational[53, 512], 0.103515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[53, 256] Pi, Rational[27, 128] Pi}, {0.6504078540635119,
       0.662679700366597}]]}, 
   {Hue[
     NCache[
      Rational[27, 256], 0.10546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[27, 128] Pi, Rational[55, 256] Pi}, {0.662679700366597, 
      0.6749515466696822}]]}, 
   {Hue[
     NCache[
      Rational[55, 512], 0.107421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[55, 256] Pi, Rational[7, 32] Pi}, {0.6749515466696822, 
      0.6872233929727672}]]}, 
   {Hue[
     NCache[
      Rational[7, 64], 0.109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 32] Pi, Rational[57, 256] Pi}, {0.6872233929727672, 
      0.6994952392758523}]]}, 
   {Hue[
     NCache[
      Rational[57, 512], 0.111328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[57, 256] Pi, Rational[29, 128] Pi}, {0.6994952392758523,
       0.7117670855789375}]]}, 
   {Hue[
     NCache[
      Rational[29, 256], 0.11328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[29, 128] Pi, Rational[59, 256] Pi}, {0.7117670855789375,
       0.7240389318820226}]]}, 
   {Hue[
     NCache[
      Rational[59, 512], 0.115234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[59, 256] Pi, Rational[15, 64] Pi}, {0.7240389318820226, 
      0.7363107781851077}]]}, 
   {Hue[
     NCache[
      Rational[15, 128], 0.1171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 64] Pi, Rational[61, 256] Pi}, {0.7363107781851077, 
      0.7485826244881929}]]}, 
   {Hue[
     NCache[
      Rational[61, 512], 0.119140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[61, 256] Pi, Rational[31, 128] Pi}, {0.7485826244881929,
       0.760854470791278}]]}, 
   {Hue[
     NCache[
      Rational[31, 256], 0.12109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[31, 128] Pi, Rational[63, 256] Pi}, {0.760854470791278, 
      0.7731263170943632}]]}, 
   {Hue[
     NCache[
      Rational[63, 512], 0.123046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[63, 256] Pi, Rational[1, 4] Pi}, {0.7731263170943632, 
      0.7853981633974483}]]}, 
   {Hue[
     NCache[
      Rational[1, 8], 0.125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 4] Pi, Rational[65, 256] Pi}, {0.7853981633974483, 
      0.7976700097005334}]]}, 
   {Hue[
     NCache[
      Rational[65, 512], 0.126953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[65, 256] Pi, Rational[33, 128] Pi}, {0.7976700097005334,
       0.8099418560036186}]]}, 
   {Hue[
     NCache[
      Rational[33, 256], 0.12890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[33, 128] Pi, Rational[67, 256] Pi}, {0.8099418560036186,
       0.8222137023067037}]]}, 
   {Hue[
     NCache[
      Rational[67, 512], 0.130859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[67, 256] Pi, Rational[17, 64] Pi}, {0.8222137023067037, 
      0.8344855486097889}]]}, 
   {Hue[
     NCache[
      Rational[17, 128], 0.1328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[17, 64] Pi, Rational[69, 256] Pi}, {0.8344855486097889, 
      0.8467573949128739}]]}, 
   {Hue[
     NCache[
      Rational[69, 512], 0.134765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[69, 256] Pi, Rational[35, 128] Pi}, {0.8467573949128739,
       0.859029241215959}]]}, 
   {Hue[
     NCache[
      Rational[35, 256], 0.13671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[35, 128] Pi, Rational[71, 256] Pi}, {0.859029241215959, 
      0.8713010875190442}]]}, 
   {Hue[
     NCache[
      Rational[71, 512], 0.138671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[71, 256] Pi, Rational[9, 32] Pi}, {0.8713010875190442, 
      0.8835729338221293}]]}, 
   {Hue[
     NCache[
      Rational[9, 64], 0.140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 32] Pi, Rational[73, 256] Pi}, {0.8835729338221293, 
      0.8958447801252144}]]}, 
   {Hue[
     NCache[
      Rational[73, 512], 0.142578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[73, 256] Pi, Rational[37, 128] Pi}, {0.8958447801252144,
       0.9081166264282996}]]}, 
   {Hue[
     NCache[
      Rational[37, 256], 0.14453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[37, 128] Pi, Rational[75, 256] Pi}, {0.9081166264282996,
       0.9203884727313847}]]}, 
   {Hue[
     NCache[
      Rational[75, 512], 0.146484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[75, 256] Pi, Rational[19, 64] Pi}, {0.9203884727313847, 
      0.9326603190344698}]]}, 
   {Hue[
     NCache[
      Rational[19, 128], 0.1484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[19, 64] Pi, Rational[77, 256] Pi}, {0.9326603190344698, 
      0.944932165337555}]]}, 
   {Hue[
     NCache[
      Rational[77, 512], 0.150390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[77, 256] Pi, Rational[39, 128] Pi}, {0.944932165337555, 
      0.9572040116406401}]]}, 
   {Hue[
     NCache[
      Rational[39, 256], 0.15234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[39, 128] Pi, Rational[79, 256] Pi}, {0.9572040116406401,
       0.9694758579437253}]]}, 
   {Hue[
     NCache[
      Rational[79, 512], 0.154296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[79, 256] Pi, Rational[5, 16] Pi}, {0.9694758579437253, 
      0.9817477042468103}]]}, 
   {Hue[
     NCache[
      Rational[5, 32], 0.15625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 16] Pi, Rational[81, 256] Pi}, {0.9817477042468103, 
      0.9940195505498954}]]}, 
   {Hue[
     NCache[
      Rational[81, 512], 0.158203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[81, 256] Pi, Rational[41, 128] Pi}, {0.9940195505498954,
       1.0062913968529805`}]]}, 
   {Hue[
     NCache[
      Rational[41, 256], 0.16015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[41, 128] Pi, Rational[83, 256] Pi}, {
      1.0062913968529805`, 1.0185632431560658`}]]}, 
   {Hue[
     NCache[
      Rational[83, 512], 0.162109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[83, 256] Pi, Rational[21, 64] Pi}, {1.0185632431560658`,
       1.030835089459151}]]}, 
   {Hue[
     NCache[
      Rational[21, 128], 0.1640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[21, 64] Pi, Rational[85, 256] Pi}, {1.030835089459151, 
      1.043106935762236}]]}, 
   {Hue[
     NCache[
      Rational[85, 512], 0.166015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[85, 256] Pi, Rational[43, 128] Pi}, {1.043106935762236, 
      1.055378782065321}]]}, 
   {Hue[
     NCache[
      Rational[43, 256], 0.16796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[43, 128] Pi, Rational[87, 256] Pi}, {1.055378782065321, 
      1.0676506283684062`}]]}, 
   {Hue[
     NCache[
      Rational[87, 512], 0.169921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[87, 256] Pi, Rational[11, 32] Pi}, {1.0676506283684062`,
       1.0799224746714913`}]]}, 
   {Hue[
     NCache[
      Rational[11, 64], 0.171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 32] Pi, Rational[89, 256] Pi}, {1.0799224746714913`,
       1.0921943209745766`}]]}, 
   {Hue[
     NCache[
      Rational[89, 512], 0.173828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[89, 256] Pi, Rational[45, 128] Pi}, {
      1.0921943209745766`, 1.1044661672776617`}]]}, 
   {Hue[
     NCache[
      Rational[45, 256], 0.17578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[45, 128] Pi, Rational[91, 256] Pi}, {
      1.1044661672776617`, 1.1167380135807468`}]]}, 
   {Hue[
     NCache[
      Rational[91, 512], 0.177734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[91, 256] Pi, Rational[23, 64] Pi}, {1.1167380135807468`,
       1.1290098598838318`}]]}, 
   {Hue[
     NCache[
      Rational[23, 128], 0.1796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[23, 64] Pi, Rational[93, 256] Pi}, {1.1290098598838318`,
       1.141281706186917}]]}, 
   {Hue[
     NCache[
      Rational[93, 512], 0.181640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[93, 256] Pi, Rational[47, 128] Pi}, {1.141281706186917, 
      1.1535535524900022`}]]}, 
   {Hue[
     NCache[
      Rational[47, 256], 0.18359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[47, 128] Pi, Rational[95, 256] Pi}, {
      1.1535535524900022`, 1.1658253987930873`}]]}, 
   {Hue[
     NCache[
      Rational[95, 512], 0.185546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[95, 256] Pi, Rational[3, 8] Pi}, {1.1658253987930873`, 
      1.1780972450961724`}]]}, 
   {Hue[
     NCache[
      Rational[3, 16], 0.1875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 8] Pi, Rational[97, 256] Pi}, {1.1780972450961724`, 
      1.1903690913992575`}]]}, 
   {Hue[
     NCache[
      Rational[97, 512], 0.189453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[97, 256] Pi, Rational[49, 128] Pi}, {
      1.1903690913992575`, 1.2026409377023426`}]]}, 
   {Hue[
     NCache[
      Rational[49, 256], 0.19140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[49, 128] Pi, Rational[99, 256] Pi}, {
      1.2026409377023426`, 1.214912784005428}]]}, 
   {Hue[
     NCache[
      Rational[99, 512], 0.193359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[99, 256] Pi, Rational[25, 64] Pi}, {1.214912784005428, 
      1.227184630308513}]]}, 
   {Hue[
     NCache[
      Rational[25, 128], 0.1953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[25, 64] Pi, Rational[101, 256] Pi}, {1.227184630308513, 
      1.239456476611598}]]}, 
   {Hue[
     NCache[
      Rational[101, 512], 0.197265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[101, 256] Pi, Rational[51, 128] Pi}, {1.239456476611598,
       1.2517283229146832`}]]}, 
   {Hue[
     NCache[
      Rational[51, 256], 0.19921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[51, 128] Pi, Rational[103, 256] Pi}, {
      1.2517283229146832`, 1.2640001692177683`}]]}, 
   {Hue[
     NCache[
      Rational[103, 512], 0.201171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[103, 256] Pi, Rational[13, 32] Pi}, {
      1.2640001692177683`, 1.2762720155208536`}]]}, 
   {Hue[
     NCache[
      Rational[13, 64], 0.203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 32] Pi, Rational[105, 256] Pi}, {
      1.2762720155208536`, 1.2885438618239387`}]]}, 
   {Hue[
     NCache[
      Rational[105, 512], 0.205078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[105, 256] Pi, Rational[53, 128] Pi}, {
      1.2885438618239387`, 1.3008157081270237`}]]}, 
   {Hue[
     NCache[
      Rational[53, 256], 0.20703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[53, 128] Pi, Rational[107, 256] Pi}, {
      1.3008157081270237`, 1.3130875544301088`}]]}, 
   {Hue[
     NCache[
      Rational[107, 512], 0.208984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[107, 256] Pi, Rational[27, 64] Pi}, {
      1.3130875544301088`, 1.325359400733194}]]}, 
   {Hue[
     NCache[
      Rational[27, 128], 0.2109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[27, 64] Pi, Rational[109, 256] Pi}, {1.325359400733194, 
      1.337631247036279}]]}, 
   {Hue[
     NCache[
      Rational[109, 512], 0.212890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[109, 256] Pi, Rational[55, 128] Pi}, {1.337631247036279,
       1.3499030933393643`}]]}, 
   {Hue[
     NCache[
      Rational[55, 256], 0.21484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[55, 128] Pi, Rational[111, 256] Pi}, {
      1.3499030933393643`, 1.3621749396424494`}]]}, 
   {Hue[
     NCache[
      Rational[111, 512], 0.216796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[111, 256] Pi, Rational[7, 16] Pi}, {1.3621749396424494`,
       1.3744467859455345`}]]}, 
   {Hue[
     NCache[
      Rational[7, 32], 0.21875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 16] Pi, Rational[113, 256] Pi}, {1.3744467859455345`,
       1.3867186322486196`}]]}, 
   {Hue[
     NCache[
      Rational[113, 512], 0.220703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[113, 256] Pi, Rational[57, 128] Pi}, {
      1.3867186322486196`, 1.3989904785517047`}]]}, 
   {Hue[
     NCache[
      Rational[57, 256], 0.22265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[57, 128] Pi, Rational[115, 256] Pi}, {
      1.3989904785517047`, 1.41126232485479}]]}, 
   {Hue[
     NCache[
      Rational[115, 512], 0.224609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[115, 256] Pi, Rational[29, 64] Pi}, {1.41126232485479, 
      1.423534171157875}]]}, 
   {Hue[
     NCache[
      Rational[29, 128], 0.2265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[29, 64] Pi, Rational[117, 256] Pi}, {1.423534171157875, 
      1.4358060174609601`}]]}, 
   {Hue[
     NCache[
      Rational[117, 512], 0.228515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[117, 256] Pi, Rational[59, 128] Pi}, {
      1.4358060174609601`, 1.4480778637640452`}]]}, 
   {Hue[
     NCache[
      Rational[59, 256], 0.23046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[59, 128] Pi, Rational[119, 256] Pi}, {
      1.4480778637640452`, 1.4603497100671303`}]]}, 
   {Hue[
     NCache[
      Rational[119, 512], 0.232421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[119, 256] Pi, Rational[15, 32] Pi}, {
      1.4603497100671303`, 1.4726215563702154`}]]}, 
   {Hue[
     NCache[
      Rational[15, 64], 0.234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 32] Pi, Rational[121, 256] Pi}, {
      1.4726215563702154`, 1.4848934026733007`}]]}, 
   {Hue[
     NCache[
      Rational[121, 512], 0.236328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[121, 256] Pi, Rational[61, 128] Pi}, {
      1.4848934026733007`, 1.4971652489763858`}]]}, 
   {Hue[
     NCache[
      Rational[61, 256], 0.23828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[61, 128] Pi, Rational[123, 256] Pi}, {
      1.4971652489763858`, 1.509437095279471}]]}, 
   {Hue[
     NCache[
      Rational[123, 512], 0.240234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[123, 256] Pi, Rational[31, 64] Pi}, {1.509437095279471, 
      1.521708941582556}]]}, 
   {Hue[
     NCache[
      Rational[31, 128], 0.2421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[31, 64] Pi, Rational[125, 256] Pi}, {1.521708941582556, 
      1.533980787885641}]]}, 
   {Hue[
     NCache[
      Rational[125, 512], 0.244140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[125, 256] Pi, Rational[63, 128] Pi}, {1.533980787885641,
       1.5462526341887264`}]]}, 
   {Hue[
     NCache[
      Rational[63, 256], 0.24609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[63, 128] Pi, Rational[127, 256] Pi}, {
      1.5462526341887264`, 1.5585244804918115`}]]}, 
   {Hue[
     NCache[
      Rational[127, 512], 0.248046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[127, 256] Pi, Rational[1, 2] Pi}, {1.5585244804918115`, 
      1.5707963267948966`}]]}, 
   {Hue[
     NCache[
      Rational[1, 4], 0.25]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[1, 2] Pi, Rational[129, 256] Pi}, {1.5707963267948966`, 
      1.5830681730979816`}]]}, 
   {Hue[
     NCache[
      Rational[129, 512], 0.251953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[129, 256] Pi, Rational[65, 128] Pi}, {
      1.5830681730979816`, 1.5953400194010667`}]]}, 
   {Hue[
     NCache[
      Rational[65, 256], 0.25390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[65, 128] Pi, Rational[131, 256] Pi}, {
      1.5953400194010667`, 1.607611865704152}]]}, 
   {Hue[
     NCache[
      Rational[131, 512], 0.255859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[131, 256] Pi, Rational[33, 64] Pi}, {1.607611865704152, 
      1.6198837120072371`}]]}, 
   {Hue[
     NCache[
      Rational[33, 128], 0.2578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[33, 64] Pi, Rational[133, 256] Pi}, {
      1.6198837120072371`, 1.6321555583103222`}]]}, 
   {Hue[
     NCache[
      Rational[133, 512], 0.259765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[133, 256] Pi, Rational[67, 128] Pi}, {
      1.6321555583103222`, 1.6444274046134073`}]]}, 
   {Hue[
     NCache[
      Rational[67, 256], 0.26171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[67, 128] Pi, Rational[135, 256] Pi}, {
      1.6444274046134073`, 1.6566992509164924`}]]}, 
   {Hue[
     NCache[
      Rational[135, 512], 0.263671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[135, 256] Pi, Rational[17, 32] Pi}, {
      1.6566992509164924`, 1.6689710972195777`}]]}, 
   {Hue[
     NCache[
      Rational[17, 64], 0.265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[17, 32] Pi, Rational[137, 256] Pi}, {
      1.6689710972195777`, 1.6812429435226628`}]]}, 
   {Hue[
     NCache[
      Rational[137, 512], 0.267578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[137, 256] Pi, Rational[69, 128] Pi}, {
      1.6812429435226628`, 1.6935147898257479`}]]}, 
   {Hue[
     NCache[
      Rational[69, 256], 0.26953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[69, 128] Pi, Rational[139, 256] Pi}, {
      1.6935147898257479`, 1.705786636128833}]]}, 
   {Hue[
     NCache[
      Rational[139, 512], 0.271484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[139, 256] Pi, Rational[35, 64] Pi}, {1.705786636128833, 
      1.718058482431918}]]}, 
   {Hue[
     NCache[
      Rational[35, 128], 0.2734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[35, 64] Pi, Rational[141, 256] Pi}, {1.718058482431918, 
      1.7303303287350031`}]]}, 
   {Hue[
     NCache[
      Rational[141, 512], 0.275390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[141, 256] Pi, Rational[71, 128] Pi}, {
      1.7303303287350031`, 1.7426021750380885`}]]}, 
   {Hue[
     NCache[
      Rational[71, 256], 0.27734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[71, 128] Pi, Rational[143, 256] Pi}, {
      1.7426021750380885`, 1.7548740213411735`}]]}, 
   {Hue[
     NCache[
      Rational[143, 512], 0.279296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[143, 256] Pi, Rational[9, 16] Pi}, {1.7548740213411735`,
       1.7671458676442586`}]]}, 
   {Hue[
     NCache[
      Rational[9, 32], 0.28125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 16] Pi, Rational[145, 256] Pi}, {1.7671458676442586`,
       1.7794177139473437`}]]}, 
   {Hue[
     NCache[
      Rational[145, 512], 0.283203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[145, 256] Pi, Rational[73, 128] Pi}, {
      1.7794177139473437`, 1.7916895602504288`}]]}, 
   {Hue[
     NCache[
      Rational[73, 256], 0.28515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[73, 128] Pi, Rational[147, 256] Pi}, {
      1.7916895602504288`, 1.8039614065535141`}]]}, 
   {Hue[
     NCache[
      Rational[147, 512], 0.287109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[147, 256] Pi, Rational[37, 64] Pi}, {
      1.8039614065535141`, 1.8162332528565992`}]]}, 
   {Hue[
     NCache[
      Rational[37, 128], 0.2890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[37, 64] Pi, Rational[149, 256] Pi}, {
      1.8162332528565992`, 1.8285050991596843`}]]}, 
   {Hue[
     NCache[
      Rational[149, 512], 0.291015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[149, 256] Pi, Rational[75, 128] Pi}, {
      1.8285050991596843`, 1.8407769454627694`}]]}, 
   {Hue[
     NCache[
      Rational[75, 256], 0.29296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[75, 128] Pi, Rational[151, 256] Pi}, {
      1.8407769454627694`, 1.8530487917658545`}]]}, 
   {Hue[
     NCache[
      Rational[151, 512], 0.294921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[151, 256] Pi, Rational[19, 32] Pi}, {
      1.8530487917658545`, 1.8653206380689396`}]]}, 
   {Hue[
     NCache[
      Rational[19, 64], 0.296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[19, 32] Pi, Rational[153, 256] Pi}, {
      1.8653206380689396`, 1.8775924843720249`}]]}, 
   {Hue[
     NCache[
      Rational[153, 512], 0.298828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[153, 256] Pi, Rational[77, 128] Pi}, {
      1.8775924843720249`, 1.88986433067511}]]}, 
   {Hue[
     NCache[
      Rational[77, 256], 0.30078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[77, 128] Pi, Rational[155, 256] Pi}, {1.88986433067511, 
      1.902136176978195}]]}, 
   {Hue[
     NCache[
      Rational[155, 512], 0.302734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[155, 256] Pi, Rational[39, 64] Pi}, {1.902136176978195, 
      1.9144080232812801`}]]}, 
   {Hue[
     NCache[
      Rational[39, 128], 0.3046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[39, 64] Pi, Rational[157, 256] Pi}, {
      1.9144080232812801`, 1.9266798695843652`}]]}, 
   {Hue[
     NCache[
      Rational[157, 512], 0.306640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[157, 256] Pi, Rational[79, 128] Pi}, {
      1.9266798695843652`, 1.9389517158874505`}]]}, 
   {Hue[
     NCache[
      Rational[79, 256], 0.30859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[79, 128] Pi, Rational[159, 256] Pi}, {
      1.9389517158874505`, 1.9512235621905356`}]]}, 
   {Hue[
     NCache[
      Rational[159, 512], 0.310546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[159, 256] Pi, Rational[5, 8] Pi}, {1.9512235621905356`, 
      1.9634954084936207`}]]}, 
   {Hue[
     NCache[
      Rational[5, 16], 0.3125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 8] Pi, Rational[161, 256] Pi}, {1.9634954084936207`, 
      1.9757672547967058`}]]}, 
   {Hue[
     NCache[
      Rational[161, 512], 0.314453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[161, 256] Pi, Rational[81, 128] Pi}, {
      1.9757672547967058`, 1.9880391010997909`}]]}, 
   {Hue[
     NCache[
      Rational[81, 256], 0.31640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[81, 128] Pi, Rational[163, 256] Pi}, {
      1.9880391010997909`, 2.000310947402876}]]}, 
   {Hue[
     NCache[
      Rational[163, 512], 0.318359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[163, 256] Pi, Rational[41, 64] Pi}, {2.000310947402876, 
      2.012582793705961}]]}, 
   {Hue[
     NCache[
      Rational[41, 128], 0.3203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[41, 64] Pi, Rational[165, 256] Pi}, {2.012582793705961, 
      2.024854640009046}]]}, 
   {Hue[
     NCache[
      Rational[165, 512], 0.322265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[165, 256] Pi, Rational[83, 128] Pi}, {2.024854640009046,
       2.0371264863121317`}]]}, 
   {Hue[
     NCache[
      Rational[83, 256], 0.32421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[83, 128] Pi, Rational[167, 256] Pi}, {
      2.0371264863121317`, 2.0493983326152168`}]]}, 
   {Hue[
     NCache[
      Rational[167, 512], 0.326171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[167, 256] Pi, Rational[21, 32] Pi}, {
      2.0493983326152168`, 2.061670178918302}]]}, 
   {Hue[
     NCache[
      Rational[21, 64], 0.328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[21, 32] Pi, Rational[169, 256] Pi}, {2.061670178918302, 
      2.073942025221387}]]}, 
   {Hue[
     NCache[
      Rational[169, 512], 0.330078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[169, 256] Pi, Rational[85, 128] Pi}, {2.073942025221387,
       2.086213871524472}]]}, 
   {Hue[
     NCache[
      Rational[85, 256], 0.33203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[85, 128] Pi, Rational[171, 256] Pi}, {2.086213871524472,
       2.098485717827557}]]}, 
   {Hue[
     NCache[
      Rational[171, 512], 0.333984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[171, 256] Pi, Rational[43, 64] Pi}, {2.098485717827557, 
      2.110757564130642}]]}, 
   {Hue[
     NCache[
      Rational[43, 128], 0.3359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[43, 64] Pi, Rational[173, 256] Pi}, {2.110757564130642, 
      2.1230294104337273`}]]}, 
   {Hue[
     NCache[
      Rational[173, 512], 0.337890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[173, 256] Pi, Rational[87, 128] Pi}, {
      2.1230294104337273`, 2.1353012567368124`}]]}, 
   {Hue[
     NCache[
      Rational[87, 256], 0.33984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[87, 128] Pi, Rational[175, 256] Pi}, {
      2.1353012567368124`, 2.1475731030398975`}]]}, 
   {Hue[
     NCache[
      Rational[175, 512], 0.341796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[175, 256] Pi, Rational[11, 16] Pi}, {
      2.1475731030398975`, 2.1598449493429825`}]]}, 
   {Hue[
     NCache[
      Rational[11, 32], 0.34375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 16] Pi, Rational[177, 256] Pi}, {
      2.1598449493429825`, 2.172116795646068}]]}, 
   {Hue[
     NCache[
      Rational[177, 512], 0.345703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[177, 256] Pi, Rational[89, 128] Pi}, {2.172116795646068,
       2.184388641949153}]]}, 
   {Hue[
     NCache[
      Rational[89, 256], 0.34765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[89, 128] Pi, Rational[179, 256] Pi}, {2.184388641949153,
       2.1966604882522383`}]]}, 
   {Hue[
     NCache[
      Rational[179, 512], 0.349609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[179, 256] Pi, Rational[45, 64] Pi}, {
      2.1966604882522383`, 2.2089323345553233`}]]}, 
   {Hue[
     NCache[
      Rational[45, 128], 0.3515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[45, 64] Pi, Rational[181, 256] Pi}, {
      2.2089323345553233`, 2.2212041808584084`}]]}, 
   {Hue[
     NCache[
      Rational[181, 512], 0.353515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[181, 256] Pi, Rational[91, 128] Pi}, {
      2.2212041808584084`, 2.2334760271614935`}]]}, 
   {Hue[
     NCache[
      Rational[91, 256], 0.35546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[91, 128] Pi, Rational[183, 256] Pi}, {
      2.2334760271614935`, 2.2457478734645786`}]]}, 
   {Hue[
     NCache[
      Rational[183, 512], 0.357421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[183, 256] Pi, Rational[23, 32] Pi}, {
      2.2457478734645786`, 2.2580197197676637`}]]}, 
   {Hue[
     NCache[
      Rational[23, 64], 0.359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[23, 32] Pi, Rational[185, 256] Pi}, {
      2.2580197197676637`, 2.270291566070749}]]}, 
   {Hue[
     NCache[
      Rational[185, 512], 0.361328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[185, 256] Pi, Rational[93, 128] Pi}, {2.270291566070749,
       2.282563412373834}]]}, 
   {Hue[
     NCache[
      Rational[93, 256], 0.36328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[93, 128] Pi, Rational[187, 256] Pi}, {2.282563412373834,
       2.2948352586769194`}]]}, 
   {Hue[
     NCache[
      Rational[187, 512], 0.365234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[187, 256] Pi, Rational[47, 64] Pi}, {
      2.2948352586769194`, 2.3071071049800045`}]]}, 
   {Hue[
     NCache[
      Rational[47, 128], 0.3671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[47, 64] Pi, Rational[189, 256] Pi}, {
      2.3071071049800045`, 2.3193789512830896`}]]}, 
   {Hue[
     NCache[
      Rational[189, 512], 0.369140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[189, 256] Pi, Rational[95, 128] Pi}, {
      2.3193789512830896`, 2.3316507975861747`}]]}, 
   {Hue[
     NCache[
      Rational[95, 256], 0.37109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[95, 128] Pi, Rational[191, 256] Pi}, {
      2.3316507975861747`, 2.3439226438892597`}]]}, 
   {Hue[
     NCache[
      Rational[191, 512], 0.373046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[191, 256] Pi, Rational[3, 4] Pi}, {2.3439226438892597`, 
      2.356194490192345}]]}, 
   {Hue[
     NCache[
      Rational[3, 8], 0.375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 4] Pi, Rational[193, 256] Pi}, {2.356194490192345, 
      2.36846633649543}]]}, 
   {Hue[
     NCache[
      Rational[193, 512], 0.376953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[193, 256] Pi, Rational[97, 128] Pi}, {2.36846633649543, 
      2.380738182798515}]]}, 
   {Hue[
     NCache[
      Rational[97, 256], 0.37890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[97, 128] Pi, Rational[195, 256] Pi}, {2.380738182798515,
       2.3930100291016}]]}, 
   {Hue[
     NCache[
      Rational[195, 512], 0.380859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[195, 256] Pi, Rational[49, 64] Pi}, {2.3930100291016, 
      2.405281875404685}]]}, 
   {Hue[
     NCache[
      Rational[49, 128], 0.3828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[49, 64] Pi, Rational[197, 256] Pi}, {2.405281875404685, 
      2.4175537217077703`}]]}, 
   {Hue[
     NCache[
      Rational[197, 512], 0.384765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[197, 256] Pi, Rational[99, 128] Pi}, {
      2.4175537217077703`, 2.429825568010856}]]}, 
   {Hue[
     NCache[
      Rational[99, 256], 0.38671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[99, 128] Pi, Rational[199, 256] Pi}, {2.429825568010856,
       2.442097414313941}]]}, 
   {Hue[
     NCache[
      Rational[199, 512], 0.388671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[199, 256] Pi, Rational[25, 32] Pi}, {2.442097414313941, 
      2.454369260617026}]]}, 
   {Hue[
     NCache[
      Rational[25, 64], 0.390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[25, 32] Pi, Rational[201, 256] Pi}, {2.454369260617026, 
      2.466641106920111}]]}, 
   {Hue[
     NCache[
      Rational[201, 512], 0.392578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[201, 256] Pi, Rational[101, 128] Pi}, {
      2.466641106920111, 2.478912953223196}]]}, 
   {Hue[
     NCache[
      Rational[101, 256], 0.39453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[101, 128] Pi, Rational[203, 256] Pi}, {
      2.478912953223196, 2.4911847995262812`}]]}, 
   {Hue[
     NCache[
      Rational[203, 512], 0.396484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[203, 256] Pi, Rational[51, 64] Pi}, {
      2.4911847995262812`, 2.5034566458293663`}]]}, 
   {Hue[
     NCache[
      Rational[51, 128], 0.3984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[51, 64] Pi, Rational[205, 256] Pi}, {
      2.5034566458293663`, 2.5157284921324514`}]]}, 
   {Hue[
     NCache[
      Rational[205, 512], 0.400390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[205, 256] Pi, Rational[103, 128] Pi}, {
      2.5157284921324514`, 2.5280003384355365`}]]}, 
   {Hue[
     NCache[
      Rational[103, 256], 0.40234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[103, 128] Pi, Rational[207, 256] Pi}, {
      2.5280003384355365`, 2.5402721847386216`}]]}, 
   {Hue[
     NCache[
      Rational[207, 512], 0.404296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[207, 256] Pi, Rational[13, 16] Pi}, {
      2.5402721847386216`, 2.552544031041707}]]}, 
   {Hue[
     NCache[
      Rational[13, 32], 0.40625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 16] Pi, Rational[209, 256] Pi}, {2.552544031041707, 
      2.564815877344792}]]}, 
   {Hue[
     NCache[
      Rational[209, 512], 0.408203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[209, 256] Pi, Rational[105, 128] Pi}, {
      2.564815877344792, 2.5770877236478773`}]]}, 
   {Hue[
     NCache[
      Rational[105, 256], 0.41015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[105, 128] Pi, Rational[211, 256] Pi}, {
      2.5770877236478773`, 2.5893595699509624`}]]}, 
   {Hue[
     NCache[
      Rational[211, 512], 0.412109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[211, 256] Pi, Rational[53, 64] Pi}, {
      2.5893595699509624`, 2.6016314162540475`}]]}, 
   {Hue[
     NCache[
      Rational[53, 128], 0.4140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[53, 64] Pi, Rational[213, 256] Pi}, {
      2.6016314162540475`, 2.6139032625571326`}]]}, 
   {Hue[
     NCache[
      Rational[213, 512], 0.416015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[213, 256] Pi, Rational[107, 128] Pi}, {
      2.6139032625571326`, 2.6261751088602177`}]]}, 
   {Hue[
     NCache[
      Rational[107, 256], 0.41796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[107, 128] Pi, Rational[215, 256] Pi}, {
      2.6261751088602177`, 2.6384469551633027`}]]}, 
   {Hue[
     NCache[
      Rational[215, 512], 0.419921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[215, 256] Pi, Rational[27, 32] Pi}, {
      2.6384469551633027`, 2.650718801466388}]]}, 
   {Hue[
     NCache[
      Rational[27, 64], 0.421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[27, 32] Pi, Rational[217, 256] Pi}, {2.650718801466388, 
      2.662990647769473}]]}, 
   {Hue[
     NCache[
      Rational[217, 512], 0.423828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[217, 256] Pi, Rational[109, 128] Pi}, {
      2.662990647769473, 2.675262494072558}]]}, 
   {Hue[
     NCache[
      Rational[109, 256], 0.42578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[109, 128] Pi, Rational[219, 256] Pi}, {
      2.675262494072558, 2.6875343403756435`}]]}, 
   {Hue[
     NCache[
      Rational[219, 512], 0.427734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[219, 256] Pi, Rational[55, 64] Pi}, {
      2.6875343403756435`, 2.6998061866787286`}]]}, 
   {Hue[
     NCache[
      Rational[55, 128], 0.4296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[55, 64] Pi, Rational[221, 256] Pi}, {
      2.6998061866787286`, 2.7120780329818137`}]]}, 
   {Hue[
     NCache[
      Rational[221, 512], 0.431640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[221, 256] Pi, Rational[111, 128] Pi}, {
      2.7120780329818137`, 2.724349879284899}]]}, 
   {Hue[
     NCache[
      Rational[111, 256], 0.43359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[111, 128] Pi, Rational[223, 256] Pi}, {
      2.724349879284899, 2.736621725587984}]]}, 
   {Hue[
     NCache[
      Rational[223, 512], 0.435546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[223, 256] Pi, Rational[7, 8] Pi}, {2.736621725587984, 
      2.748893571891069}]]}, 
   {Hue[
     NCache[
      Rational[7, 16], 0.4375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 8] Pi, Rational[225, 256] Pi}, {2.748893571891069, 
      2.761165418194154}]]}, 
   {Hue[
     NCache[
      Rational[225, 512], 0.439453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[225, 256] Pi, Rational[113, 128] Pi}, {
      2.761165418194154, 2.773437264497239}]]}, 
   {Hue[
     NCache[
      Rational[113, 256], 0.44140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[113, 128] Pi, Rational[227, 256] Pi}, {
      2.773437264497239, 2.7857091108003242`}]]}, 
   {Hue[
     NCache[
      Rational[227, 512], 0.443359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[227, 256] Pi, Rational[57, 64] Pi}, {
      2.7857091108003242`, 2.7979809571034093`}]]}, 
   {Hue[
     NCache[
      Rational[57, 128], 0.4453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[57, 64] Pi, Rational[229, 256] Pi}, {
      2.7979809571034093`, 2.8102528034064944`}]]}, 
   {Hue[
     NCache[
      Rational[229, 512], 0.447265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[229, 256] Pi, Rational[115, 128] Pi}, {
      2.8102528034064944`, 2.82252464970958}]]}, 
   {Hue[
     NCache[
      Rational[115, 256], 0.44921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[115, 128] Pi, Rational[231, 256] Pi}, {2.82252464970958,
       2.834796496012665}]]}, 
   {Hue[
     NCache[
      Rational[231, 512], 0.451171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[231, 256] Pi, Rational[29, 32] Pi}, {2.834796496012665, 
      2.84706834231575}]]}, 
   {Hue[
     NCache[
      Rational[29, 64], 0.453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[29, 32] Pi, Rational[233, 256] Pi}, {2.84706834231575, 
      2.859340188618835}]]}, 
   {Hue[
     NCache[
      Rational[233, 512], 0.455078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[233, 256] Pi, Rational[117, 128] Pi}, {
      2.859340188618835, 2.8716120349219203`}]]}, 
   {Hue[
     NCache[
      Rational[117, 256], 0.45703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[117, 128] Pi, Rational[235, 256] Pi}, {
      2.8716120349219203`, 2.8838838812250054`}]]}, 
   {Hue[
     NCache[
      Rational[235, 512], 0.458984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[235, 256] Pi, Rational[59, 64] Pi}, {
      2.8838838812250054`, 2.8961557275280905`}]]}, 
   {Hue[
     NCache[
      Rational[59, 128], 0.4609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[59, 64] Pi, Rational[237, 256] Pi}, {
      2.8961557275280905`, 2.9084275738311756`}]]}, 
   {Hue[
     NCache[
      Rational[237, 512], 0.462890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[237, 256] Pi, Rational[119, 128] Pi}, {
      2.9084275738311756`, 2.9206994201342606`}]]}, 
   {Hue[
     NCache[
      Rational[119, 256], 0.46484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[119, 128] Pi, Rational[239, 256] Pi}, {
      2.9206994201342606`, 2.9329712664373457`}]]}, 
   {Hue[
     NCache[
      Rational[239, 512], 0.466796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[239, 256] Pi, Rational[15, 16] Pi}, {
      2.9329712664373457`, 2.945243112740431}]]}, 
   {Hue[
     NCache[
      Rational[15, 32], 0.46875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 16] Pi, Rational[241, 256] Pi}, {2.945243112740431, 
      2.9575149590435164`}]]}, 
   {Hue[
     NCache[
      Rational[241, 512], 0.470703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[241, 256] Pi, Rational[121, 128] Pi}, {
      2.9575149590435164`, 2.9697868053466014`}]]}, 
   {Hue[
     NCache[
      Rational[121, 256], 0.47265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[121, 128] Pi, Rational[243, 256] Pi}, {
      2.9697868053466014`, 2.9820586516496865`}]]}, 
   {Hue[
     NCache[
      Rational[243, 512], 0.474609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[243, 256] Pi, Rational[61, 64] Pi}, {
      2.9820586516496865`, 2.9943304979527716`}]]}, 
   {Hue[
     NCache[
      Rational[61, 128], 0.4765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[61, 64] Pi, Rational[245, 256] Pi}, {
      2.9943304979527716`, 3.0066023442558567`}]]}, 
   {Hue[
     NCache[
      Rational[245, 512], 0.478515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[245, 256] Pi, Rational[123, 128] Pi}, {
      3.0066023442558567`, 3.018874190558942}]]}, 
   {Hue[
     NCache[
      Rational[123, 256], 0.48046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[123, 128] Pi, Rational[247, 256] Pi}, {
      3.018874190558942, 3.031146036862027}]]}, 
   {Hue[
     NCache[
      Rational[247, 512], 0.482421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[247, 256] Pi, Rational[31, 32] Pi}, {3.031146036862027, 
      3.043417883165112}]]}, 
   {Hue[
     NCache[
      Rational[31, 64], 0.484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[31, 32] Pi, Rational[249, 256] Pi}, {3.043417883165112, 
      3.055689729468197}]]}, 
   {Hue[
     NCache[
      Rational[249, 512], 0.486328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[249, 256] Pi, Rational[125, 128] Pi}, {
      3.055689729468197, 3.067961575771282}]]}, 
   {Hue[
     NCache[
      Rational[125, 256], 0.48828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[125, 128] Pi, Rational[251, 256] Pi}, {
      3.067961575771282, 3.0802334220743677`}]]}, 
   {Hue[
     NCache[
      Rational[251, 512], 0.490234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[251, 256] Pi, Rational[63, 64] Pi}, {
      3.0802334220743677`, 3.0925052683774528`}]]}, 
   {Hue[
     NCache[
      Rational[63, 128], 0.4921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[63, 64] Pi, Rational[253, 256] Pi}, {
      3.0925052683774528`, 3.104777114680538}]]}, 
   {Hue[
     NCache[
      Rational[253, 512], 0.494140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[253, 256] Pi, Rational[127, 128] Pi}, {
      3.104777114680538, 3.117048960983623}]]}, 
   {Hue[
     NCache[
      Rational[127, 256], 0.49609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[127, 128] Pi, Rational[255, 256] Pi}, {
      3.117048960983623, 3.129320807286708}]]}, 
   {Hue[
     NCache[
      Rational[255, 512], 0.498046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[255, 256] Pi, Pi}, {3.129320807286708, 
      3.141592653589793}]]}, 
   {Hue[
     NCache[
      Rational[1, 2], 0.5]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Pi, Rational[257, 256] Pi}, {3.141592653589793, 
      3.153864499892878}]]}, 
   {Hue[
     NCache[
      Rational[257, 512], 0.501953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[257, 256] Pi, Rational[129, 128] Pi}, {
      3.153864499892878, 3.1661363461959633`}]]}, 
   {Hue[
     NCache[
      Rational[129, 256], 0.50390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[129, 128] Pi, Rational[259, 256] Pi}, {
      3.1661363461959633`, 3.1784081924990484`}]]}, 
   {Hue[
     NCache[
      Rational[259, 512], 0.505859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[259, 256] Pi, Rational[65, 64] Pi}, {
      3.1784081924990484`, 3.1906800388021335`}]]}, 
   {Hue[
     NCache[
      Rational[65, 128], 0.5078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[65, 64] Pi, Rational[261, 256] Pi}, {
      3.1906800388021335`, 3.2029518851052186`}]]}, 
   {Hue[
     NCache[
      Rational[261, 512], 0.509765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[261, 256] Pi, Rational[131, 128] Pi}, {
      3.2029518851052186`, 3.215223731408304}]]}, 
   {Hue[
     NCache[
      Rational[131, 256], 0.51171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[131, 128] Pi, Rational[263, 256] Pi}, {
      3.215223731408304, 3.227495577711389}]]}, 
   {Hue[
     NCache[
      Rational[263, 512], 0.513671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[263, 256] Pi, Rational[33, 32] Pi}, {3.227495577711389, 
      3.2397674240144743`}]]}, 
   {Hue[
     NCache[
      Rational[33, 64], 0.515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[33, 32] Pi, Rational[265, 256] Pi}, {
      3.2397674240144743`, 3.2520392703175593`}]]}, 
   {Hue[
     NCache[
      Rational[265, 512], 0.517578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[265, 256] Pi, Rational[133, 128] Pi}, {
      3.2520392703175593`, 3.2643111166206444`}]]}, 
   {Hue[
     NCache[
      Rational[133, 256], 0.51953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[133, 128] Pi, Rational[267, 256] Pi}, {
      3.2643111166206444`, 3.2765829629237295`}]]}, 
   {Hue[
     NCache[
      Rational[267, 512], 0.521484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[267, 256] Pi, Rational[67, 64] Pi}, {
      3.2765829629237295`, 3.2888548092268146`}]]}, 
   {Hue[
     NCache[
      Rational[67, 128], 0.5234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[67, 64] Pi, Rational[269, 256] Pi}, {
      3.2888548092268146`, 3.3011266555298997`}]]}, 
   {Hue[
     NCache[
      Rational[269, 512], 0.525390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[269, 256] Pi, Rational[135, 128] Pi}, {
      3.3011266555298997`, 3.313398501832985}]]}, 
   {Hue[
     NCache[
      Rational[135, 256], 0.52734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[135, 128] Pi, Rational[271, 256] Pi}, {
      3.313398501832985, 3.32567034813607}]]}, 
   {Hue[
     NCache[
      Rational[271, 512], 0.529296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[271, 256] Pi, Rational[17, 16] Pi}, {3.32567034813607, 
      3.3379421944391554`}]]}, 
   {Hue[
     NCache[
      Rational[17, 32], 0.53125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[17, 16] Pi, Rational[273, 256] Pi}, {
      3.3379421944391554`, 3.3502140407422405`}]]}, 
   {Hue[
     NCache[
      Rational[273, 512], 0.533203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[273, 256] Pi, Rational[137, 128] Pi}, {
      3.3502140407422405`, 3.3624858870453256`}]]}, 
   {Hue[
     NCache[
      Rational[137, 256], 0.53515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[137, 128] Pi, Rational[275, 256] Pi}, {
      3.3624858870453256`, 3.3747577333484107`}]]}, 
   {Hue[
     NCache[
      Rational[275, 512], 0.537109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[275, 256] Pi, Rational[69, 64] Pi}, {
      3.3747577333484107`, 3.3870295796514958`}]]}, 
   {Hue[
     NCache[
      Rational[69, 128], 0.5390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[69, 64] Pi, Rational[277, 256] Pi}, {
      3.3870295796514958`, 3.399301425954581}]]}, 
   {Hue[
     NCache[
      Rational[277, 512], 0.541015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[277, 256] Pi, Rational[139, 128] Pi}, {
      3.399301425954581, 3.411573272257666}]]}, 
   {Hue[
     NCache[
      Rational[139, 256], 0.54296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[139, 128] Pi, Rational[279, 256] Pi}, {
      3.411573272257666, 3.423845118560751}]]}, 
   {Hue[
     NCache[
      Rational[279, 512], 0.544921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[279, 256] Pi, Rational[35, 32] Pi}, {3.423845118560751, 
      3.436116964863836}]]}, 
   {Hue[
     NCache[
      Rational[35, 64], 0.546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[35, 32] Pi, Rational[281, 256] Pi}, {3.436116964863836, 
      3.448388811166921}]]}, 
   {Hue[
     NCache[
      Rational[281, 512], 0.548828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[281, 256] Pi, Rational[141, 128] Pi}, {
      3.448388811166921, 3.4606606574700063`}]]}, 
   {Hue[
     NCache[
      Rational[141, 256], 0.55078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[141, 128] Pi, Rational[283, 256] Pi}, {
      3.4606606574700063`, 3.472932503773092}]]}, 
   {Hue[
     NCache[
      Rational[283, 512], 0.552734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[283, 256] Pi, Rational[71, 64] Pi}, {3.472932503773092, 
      3.485204350076177}]]}, 
   {Hue[
     NCache[
      Rational[71, 128], 0.5546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[71, 64] Pi, Rational[285, 256] Pi}, {3.485204350076177, 
      3.497476196379262}]]}, 
   {Hue[
     NCache[
      Rational[285, 512], 0.556640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[285, 256] Pi, Rational[143, 128] Pi}, {
      3.497476196379262, 3.509748042682347}]]}, 
   {Hue[
     NCache[
      Rational[143, 256], 0.55859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[143, 128] Pi, Rational[287, 256] Pi}, {
      3.509748042682347, 3.522019888985432}]]}, 
   {Hue[
     NCache[
      Rational[287, 512], 0.560546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[287, 256] Pi, Rational[9, 8] Pi}, {3.522019888985432, 
      3.5342917352885173`}]]}, 
   {Hue[
     NCache[
      Rational[9, 16], 0.5625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[9, 8] Pi, Rational[289, 256] Pi}, {3.5342917352885173`, 
      3.5465635815916023`}]]}, 
   {Hue[
     NCache[
      Rational[289, 512], 0.564453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[289, 256] Pi, Rational[145, 128] Pi}, {
      3.5465635815916023`, 3.5588354278946874`}]]}, 
   {Hue[
     NCache[
      Rational[145, 256], 0.56640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[145, 128] Pi, Rational[291, 256] Pi}, {
      3.5588354278946874`, 3.5711072741977725`}]]}, 
   {Hue[
     NCache[
      Rational[291, 512], 0.568359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[291, 256] Pi, Rational[73, 64] Pi}, {
      3.5711072741977725`, 3.5833791205008576`}]]}, 
   {Hue[
     NCache[
      Rational[73, 128], 0.5703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[73, 64] Pi, Rational[293, 256] Pi}, {
      3.5833791205008576`, 3.5956509668039427`}]]}, 
   {Hue[
     NCache[
      Rational[293, 512], 0.572265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[293, 256] Pi, Rational[147, 128] Pi}, {
      3.5956509668039427`, 3.6079228131070282`}]]}, 
   {Hue[
     NCache[
      Rational[147, 256], 0.57421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[147, 128] Pi, Rational[295, 256] Pi}, {
      3.6079228131070282`, 3.6201946594101133`}]]}, 
   {Hue[
     NCache[
      Rational[295, 512], 0.576171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[295, 256] Pi, Rational[37, 32] Pi}, {
      3.6201946594101133`, 3.6324665057131984`}]]}, 
   {Hue[
     NCache[
      Rational[37, 64], 0.578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[37, 32] Pi, Rational[297, 256] Pi}, {
      3.6324665057131984`, 3.6447383520162835`}]]}, 
   {Hue[
     NCache[
      Rational[297, 512], 0.580078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[297, 256] Pi, Rational[149, 128] Pi}, {
      3.6447383520162835`, 3.6570101983193686`}]]}, 
   {Hue[
     NCache[
      Rational[149, 256], 0.58203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[149, 128] Pi, Rational[299, 256] Pi}, {
      3.6570101983193686`, 3.6692820446224537`}]]}, 
   {Hue[
     NCache[
      Rational[299, 512], 0.583984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[299, 256] Pi, Rational[75, 64] Pi}, {
      3.6692820446224537`, 3.6815538909255388`}]]}, 
   {Hue[
     NCache[
      Rational[75, 128], 0.5859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[75, 64] Pi, Rational[301, 256] Pi}, {
      3.6815538909255388`, 3.693825737228624}]]}, 
   {Hue[
     NCache[
      Rational[301, 512], 0.587890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[301, 256] Pi, Rational[151, 128] Pi}, {
      3.693825737228624, 3.706097583531709}]]}, 
   {Hue[
     NCache[
      Rational[151, 256], 0.58984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[151, 128] Pi, Rational[303, 256] Pi}, {
      3.706097583531709, 3.718369429834794}]]}, 
   {Hue[
     NCache[
      Rational[303, 512], 0.591796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[303, 256] Pi, Rational[19, 16] Pi}, {3.718369429834794, 
      3.730641276137879}]]}, 
   {Hue[
     NCache[
      Rational[19, 32], 0.59375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[19, 16] Pi, Rational[305, 256] Pi}, {3.730641276137879, 
      3.7429131224409646`}]]}, 
   {Hue[
     NCache[
      Rational[305, 512], 0.595703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[305, 256] Pi, Rational[153, 128] Pi}, {
      3.7429131224409646`, 3.7551849687440497`}]]}, 
   {Hue[
     NCache[
      Rational[153, 256], 0.59765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[153, 128] Pi, Rational[307, 256] Pi}, {
      3.7551849687440497`, 3.767456815047135}]]}, 
   {Hue[
     NCache[
      Rational[307, 512], 0.599609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[307, 256] Pi, Rational[77, 64] Pi}, {3.767456815047135, 
      3.77972866135022}]]}, 
   {Hue[
     NCache[
      Rational[77, 128], 0.6015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[77, 64] Pi, Rational[309, 256] Pi}, {3.77972866135022, 
      3.792000507653305}]]}, 
   {Hue[
     NCache[
      Rational[309, 512], 0.603515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[309, 256] Pi, Rational[155, 128] Pi}, {
      3.792000507653305, 3.80427235395639}]]}, 
   {Hue[
     NCache[
      Rational[155, 256], 0.60546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[155, 128] Pi, Rational[311, 256] Pi}, {3.80427235395639,
       3.816544200259475}]]}, 
   {Hue[
     NCache[
      Rational[311, 512], 0.607421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[311, 256] Pi, Rational[39, 32] Pi}, {3.816544200259475, 
      3.8288160465625602`}]]}, 
   {Hue[
     NCache[
      Rational[39, 64], 0.609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[39, 32] Pi, Rational[313, 256] Pi}, {
      3.8288160465625602`, 3.8410878928656453`}]]}, 
   {Hue[
     NCache[
      Rational[313, 512], 0.611328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[313, 256] Pi, Rational[157, 128] Pi}, {
      3.8410878928656453`, 3.8533597391687304`}]]}, 
   {Hue[
     NCache[
      Rational[157, 256], 0.61328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[157, 128] Pi, Rational[315, 256] Pi}, {
      3.8533597391687304`, 3.865631585471816}]]}, 
   {Hue[
     NCache[
      Rational[315, 512], 0.615234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[315, 256] Pi, Rational[79, 64] Pi}, {3.865631585471816, 
      3.877903431774901}]]}, 
   {Hue[
     NCache[
      Rational[79, 128], 0.6171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[79, 64] Pi, Rational[317, 256] Pi}, {3.877903431774901, 
      3.890175278077986}]]}, 
   {Hue[
     NCache[
      Rational[317, 512], 0.619140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[317, 256] Pi, Rational[159, 128] Pi}, {
      3.890175278077986, 3.902447124381071}]]}, 
   {Hue[
     NCache[
      Rational[159, 256], 0.62109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[159, 128] Pi, Rational[319, 256] Pi}, {
      3.902447124381071, 3.9147189706841563`}]]}, 
   {Hue[
     NCache[
      Rational[319, 512], 0.623046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[319, 256] Pi, Rational[5, 4] Pi}, {3.9147189706841563`, 
      3.9269908169872414`}]]}, 
   {Hue[
     NCache[
      Rational[5, 8], 0.625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[5, 4] Pi, Rational[321, 256] Pi}, {3.9269908169872414`, 
      3.9392626632903265`}]]}, 
   {Hue[
     NCache[
      Rational[321, 512], 0.626953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[321, 256] Pi, Rational[161, 128] Pi}, {
      3.9392626632903265`, 3.9515345095934116`}]]}, 
   {Hue[
     NCache[
      Rational[161, 256], 0.62890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[161, 128] Pi, Rational[323, 256] Pi}, {
      3.9515345095934116`, 3.9638063558964967`}]]}, 
   {Hue[
     NCache[
      Rational[323, 512], 0.630859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[323, 256] Pi, Rational[81, 64] Pi}, {
      3.9638063558964967`, 3.9760782021995817`}]]}, 
   {Hue[
     NCache[
      Rational[81, 128], 0.6328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[81, 64] Pi, Rational[325, 256] Pi}, {
      3.9760782021995817`, 3.988350048502667}]]}, 
   {Hue[
     NCache[
      Rational[325, 512], 0.634765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[325, 256] Pi, Rational[163, 128] Pi}, {
      3.988350048502667, 4.000621894805752}]]}, 
   {Hue[
     NCache[
      Rational[163, 256], 0.63671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[163, 128] Pi, Rational[327, 256] Pi}, {
      4.000621894805752, 4.0128937411088375`}]]}, 
   {Hue[
     NCache[
      Rational[327, 512], 0.638671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[327, 256] Pi, Rational[41, 32] Pi}, {
      4.0128937411088375`, 4.025165587411922}]]}, 
   {Hue[
     NCache[
      Rational[41, 64], 0.640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[41, 32] Pi, Rational[329, 256] Pi}, {4.025165587411922, 
      4.037437433715008}]]}, 
   {Hue[
     NCache[
      Rational[329, 512], 0.642578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[329, 256] Pi, Rational[165, 128] Pi}, {
      4.037437433715008, 4.049709280018092}]]}, 
   {Hue[
     NCache[
      Rational[165, 256], 0.64453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[165, 128] Pi, Rational[331, 256] Pi}, {
      4.049709280018092, 4.061981126321178}]]}, 
   {Hue[
     NCache[
      Rational[331, 512], 0.646484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[331, 256] Pi, Rational[83, 64] Pi}, {4.061981126321178, 
      4.074252972624263}]]}, 
   {Hue[
     NCache[
      Rational[83, 128], 0.6484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[83, 64] Pi, Rational[333, 256] Pi}, {4.074252972624263, 
      4.086524818927348}]]}, 
   {Hue[
     NCache[
      Rational[333, 512], 0.650390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[333, 256] Pi, Rational[167, 128] Pi}, {
      4.086524818927348, 4.0987966652304335`}]]}, 
   {Hue[
     NCache[
      Rational[167, 256], 0.65234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[167, 128] Pi, Rational[335, 256] Pi}, {
      4.0987966652304335`, 4.111068511533518}]]}, 
   {Hue[
     NCache[
      Rational[335, 512], 0.654296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[335, 256] Pi, Rational[21, 16] Pi}, {4.111068511533518, 
      4.123340357836604}]]}, 
   {Hue[
     NCache[
      Rational[21, 32], 0.65625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[21, 16] Pi, Rational[337, 256] Pi}, {4.123340357836604, 
      4.135612204139688}]]}, 
   {Hue[
     NCache[
      Rational[337, 512], 0.658203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[337, 256] Pi, Rational[169, 128] Pi}, {
      4.135612204139688, 4.147884050442774}]]}, 
   {Hue[
     NCache[
      Rational[169, 256], 0.66015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[169, 128] Pi, Rational[339, 256] Pi}, {
      4.147884050442774, 4.1601558967458585`}]]}, 
   {Hue[
     NCache[
      Rational[339, 512], 0.662109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[339, 256] Pi, Rational[85, 64] Pi}, {
      4.1601558967458585`, 4.172427743048944}]]}, 
   {Hue[
     NCache[
      Rational[85, 128], 0.6640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[85, 64] Pi, Rational[341, 256] Pi}, {4.172427743048944, 
      4.184699589352029}]]}, 
   {Hue[
     NCache[
      Rational[341, 512], 0.666015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[341, 256] Pi, Rational[171, 128] Pi}, {
      4.184699589352029, 4.196971435655114}]]}, 
   {Hue[
     NCache[
      Rational[171, 256], 0.66796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[171, 128] Pi, Rational[343, 256] Pi}, {
      4.196971435655114, 4.2092432819582}]]}, 
   {Hue[
     NCache[
      Rational[343, 512], 0.669921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[343, 256] Pi, Rational[43, 32] Pi}, {4.2092432819582, 
      4.221515128261284}]]}, 
   {Hue[
     NCache[
      Rational[43, 64], 0.671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[43, 32] Pi, Rational[345, 256] Pi}, {4.221515128261284, 
      4.23378697456437}]]}, 
   {Hue[
     NCache[
      Rational[345, 512], 0.673828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[345, 256] Pi, Rational[173, 128] Pi}, {4.23378697456437,
       4.246058820867455}]]}, 
   {Hue[
     NCache[
      Rational[173, 256], 0.67578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[173, 128] Pi, Rational[347, 256] Pi}, {
      4.246058820867455, 4.25833066717054}]]}, 
   {Hue[
     NCache[
      Rational[347, 512], 0.677734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[347, 256] Pi, Rational[87, 64] Pi}, {4.25833066717054, 
      4.270602513473625}]]}, 
   {Hue[
     NCache[
      Rational[87, 128], 0.6796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[87, 64] Pi, Rational[349, 256] Pi}, {4.270602513473625, 
      4.28287435977671}]]}, 
   {Hue[
     NCache[
      Rational[349, 512], 0.681640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[349, 256] Pi, Rational[175, 128] Pi}, {4.28287435977671,
       4.295146206079795}]]}, 
   {Hue[
     NCache[
      Rational[175, 256], 0.68359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[175, 128] Pi, Rational[351, 256] Pi}, {
      4.295146206079795, 4.3074180523828804`}]]}, 
   {Hue[
     NCache[
      Rational[351, 512], 0.685546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[351, 256] Pi, Rational[11, 8] Pi}, {4.3074180523828804`,
       4.319689898685965}]]}, 
   {Hue[
     NCache[
      Rational[11, 16], 0.6875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[11, 8] Pi, Rational[353, 256] Pi}, {4.319689898685965, 
      4.331961744989051}]]}, 
   {Hue[
     NCache[
      Rational[353, 512], 0.689453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[353, 256] Pi, Rational[177, 128] Pi}, {
      4.331961744989051, 4.344233591292136}]]}, 
   {Hue[
     NCache[
      Rational[177, 256], 0.69140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[177, 128] Pi, Rational[355, 256] Pi}, {
      4.344233591292136, 4.356505437595221}]]}, 
   {Hue[
     NCache[
      Rational[355, 512], 0.693359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[355, 256] Pi, Rational[89, 64] Pi}, {4.356505437595221, 
      4.368777283898306}]]}, 
   {Hue[
     NCache[
      Rational[89, 128], 0.6953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[89, 64] Pi, Rational[357, 256] Pi}, {4.368777283898306, 
      4.381049130201391}]]}, 
   {Hue[
     NCache[
      Rational[357, 512], 0.697265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[357, 256] Pi, Rational[179, 128] Pi}, {
      4.381049130201391, 4.3933209765044765`}]]}, 
   {Hue[
     NCache[
      Rational[179, 256], 0.69921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[179, 128] Pi, Rational[359, 256] Pi}, {
      4.3933209765044765`, 4.405592822807561}]]}, 
   {Hue[
     NCache[
      Rational[359, 512], 0.701171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[359, 256] Pi, Rational[45, 32] Pi}, {4.405592822807561, 
      4.417864669110647}]]}, 
   {Hue[
     NCache[
      Rational[45, 64], 0.703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[45, 32] Pi, Rational[361, 256] Pi}, {4.417864669110647, 
      4.430136515413731}]]}, 
   {Hue[
     NCache[
      Rational[361, 512], 0.705078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[361, 256] Pi, Rational[181, 128] Pi}, {
      4.430136515413731, 4.442408361716817}]]}, 
   {Hue[
     NCache[
      Rational[181, 256], 0.70703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[181, 128] Pi, Rational[363, 256] Pi}, {
      4.442408361716817, 4.454680208019902}]]}, 
   {Hue[
     NCache[
      Rational[363, 512], 0.708984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[363, 256] Pi, Rational[91, 64] Pi}, {4.454680208019902, 
      4.466952054322987}]]}, 
   {Hue[
     NCache[
      Rational[91, 128], 0.7109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[91, 64] Pi, Rational[365, 256] Pi}, {4.466952054322987, 
      4.479223900626073}]]}, 
   {Hue[
     NCache[
      Rational[365, 512], 0.712890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[365, 256] Pi, Rational[183, 128] Pi}, {
      4.479223900626073, 4.491495746929157}]]}, 
   {Hue[
     NCache[
      Rational[183, 256], 0.71484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[183, 128] Pi, Rational[367, 256] Pi}, {
      4.491495746929157, 4.503767593232243}]]}, 
   {Hue[
     NCache[
      Rational[367, 512], 0.716796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[367, 256] Pi, Rational[23, 16] Pi}, {4.503767593232243, 
      4.516039439535327}]]}, 
   {Hue[
     NCache[
      Rational[23, 32], 0.71875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[23, 16] Pi, Rational[369, 256] Pi}, {4.516039439535327, 
      4.528311285838413}]]}, 
   {Hue[
     NCache[
      Rational[369, 512], 0.720703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[369, 256] Pi, Rational[185, 128] Pi}, {
      4.528311285838413, 4.540583132141498}]]}, 
   {Hue[
     NCache[
      Rational[185, 256], 0.72265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[185, 128] Pi, Rational[371, 256] Pi}, {
      4.540583132141498, 4.552854978444583}]]}, 
   {Hue[
     NCache[
      Rational[371, 512], 0.724609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[371, 256] Pi, Rational[93, 64] Pi}, {4.552854978444583, 
      4.565126824747668}]]}, 
   {Hue[
     NCache[
      Rational[93, 128], 0.7265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[93, 64] Pi, Rational[373, 256] Pi}, {4.565126824747668, 
      4.577398671050753}]]}, 
   {Hue[
     NCache[
      Rational[373, 512], 0.728515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[373, 256] Pi, Rational[187, 128] Pi}, {
      4.577398671050753, 4.589670517353839}]]}, 
   {Hue[
     NCache[
      Rational[187, 256], 0.73046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[187, 128] Pi, Rational[375, 256] Pi}, {
      4.589670517353839, 4.601942363656923}]]}, 
   {Hue[
     NCache[
      Rational[375, 512], 0.732421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[375, 256] Pi, Rational[47, 32] Pi}, {4.601942363656923, 
      4.614214209960009}]]}, 
   {Hue[
     NCache[
      Rational[47, 64], 0.734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[47, 32] Pi, Rational[377, 256] Pi}, {4.614214209960009, 
      4.626486056263094}]]}, 
   {Hue[
     NCache[
      Rational[377, 512], 0.736328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[377, 256] Pi, Rational[189, 128] Pi}, {
      4.626486056263094, 4.638757902566179}]]}, 
   {Hue[
     NCache[
      Rational[189, 256], 0.73828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[189, 128] Pi, Rational[379, 256] Pi}, {
      4.638757902566179, 4.651029748869264}]]}, 
   {Hue[
     NCache[
      Rational[379, 512], 0.740234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[379, 256] Pi, Rational[95, 64] Pi}, {4.651029748869264, 
      4.663301595172349}]]}, 
   {Hue[
     NCache[
      Rational[95, 128], 0.7421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[95, 64] Pi, Rational[381, 256] Pi}, {4.663301595172349, 
      4.675573441475434}]]}, 
   {Hue[
     NCache[
      Rational[381, 512], 0.744140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[381, 256] Pi, Rational[191, 128] Pi}, {
      4.675573441475434, 4.6878452877785195`}]]}, 
   {Hue[
     NCache[
      Rational[191, 256], 0.74609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[191, 128] Pi, Rational[383, 256] Pi}, {
      4.6878452877785195`, 4.700117134081604}]]}, 
   {Hue[
     NCache[
      Rational[383, 512], 0.748046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[383, 256] Pi, Rational[3, 2] Pi}, {4.700117134081604, 
      4.71238898038469}]]}, 
   {Hue[
     NCache[
      Rational[3, 4], 0.75]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[3, 2] Pi, Rational[385, 256] Pi}, {4.71238898038469, 
      4.724660826687775}]]}, 
   {Hue[
     NCache[
      Rational[385, 512], 0.751953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[385, 256] Pi, Rational[193, 128] Pi}, {
      4.724660826687775, 4.73693267299086}]]}, 
   {Hue[
     NCache[
      Rational[193, 256], 0.75390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[193, 128] Pi, Rational[387, 256] Pi}, {4.73693267299086,
       4.749204519293945}]]}, 
   {Hue[
     NCache[
      Rational[387, 512], 0.755859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[387, 256] Pi, Rational[97, 64] Pi}, {4.749204519293945, 
      4.76147636559703}]]}, 
   {Hue[
     NCache[
      Rational[97, 128], 0.7578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[97, 64] Pi, Rational[389, 256] Pi}, {4.76147636559703, 
      4.773748211900116}]]}, 
   {Hue[
     NCache[
      Rational[389, 512], 0.759765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[389, 256] Pi, Rational[195, 128] Pi}, {
      4.773748211900116, 4.7860200582032}]]}, 
   {Hue[
     NCache[
      Rational[195, 256], 0.76171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[195, 128] Pi, Rational[391, 256] Pi}, {4.7860200582032, 
      4.798291904506286}]]}, 
   {Hue[
     NCache[
      Rational[391, 512], 0.763671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[391, 256] Pi, Rational[49, 32] Pi}, {4.798291904506286, 
      4.81056375080937}]]}, 
   {Hue[
     NCache[
      Rational[49, 64], 0.765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[49, 32] Pi, Rational[393, 256] Pi}, {4.81056375080937, 
      4.822835597112456}]]}, 
   {Hue[
     NCache[
      Rational[393, 512], 0.767578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[393, 256] Pi, Rational[197, 128] Pi}, {
      4.822835597112456, 4.8351074434155406`}]]}, 
   {Hue[
     NCache[
      Rational[197, 256], 0.76953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[197, 128] Pi, Rational[395, 256] Pi}, {
      4.8351074434155406`, 4.847379289718626}]]}, 
   {Hue[
     NCache[
      Rational[395, 512], 0.771484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[395, 256] Pi, Rational[99, 64] Pi}, {4.847379289718626, 
      4.859651136021712}]]}, 
   {Hue[
     NCache[
      Rational[99, 128], 0.7734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[99, 64] Pi, Rational[397, 256] Pi}, {4.859651136021712, 
      4.871922982324796}]]}, 
   {Hue[
     NCache[
      Rational[397, 512], 0.775390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[397, 256] Pi, Rational[199, 128] Pi}, {
      4.871922982324796, 4.884194828627882}]]}, 
   {Hue[
     NCache[
      Rational[199, 256], 0.77734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[199, 128] Pi, Rational[399, 256] Pi}, {
      4.884194828627882, 4.896466674930966}]]}, 
   {Hue[
     NCache[
      Rational[399, 512], 0.779296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[399, 256] Pi, Rational[25, 16] Pi}, {4.896466674930966, 
      4.908738521234052}]]}, 
   {Hue[
     NCache[
      Rational[25, 32], 0.78125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[25, 16] Pi, Rational[401, 256] Pi}, {4.908738521234052, 
      4.921010367537137}]]}, 
   {Hue[
     NCache[
      Rational[401, 512], 0.783203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[401, 256] Pi, Rational[201, 128] Pi}, {
      4.921010367537137, 4.933282213840222}]]}, 
   {Hue[
     NCache[
      Rational[201, 256], 0.78515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[201, 128] Pi, Rational[403, 256] Pi}, {
      4.933282213840222, 4.945554060143307}]]}, 
   {Hue[
     NCache[
      Rational[403, 512], 0.787109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[403, 256] Pi, Rational[101, 64] Pi}, {4.945554060143307,
       4.957825906446392}]]}, 
   {Hue[
     NCache[
      Rational[101, 128], 0.7890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[101, 64] Pi, Rational[405, 256] Pi}, {4.957825906446392,
       4.970097752749477}]]}, 
   {Hue[
     NCache[
      Rational[405, 512], 0.791015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[405, 256] Pi, Rational[203, 128] Pi}, {
      4.970097752749477, 4.9823695990525625`}]]}, 
   {Hue[
     NCache[
      Rational[203, 256], 0.79296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[203, 128] Pi, Rational[407, 256] Pi}, {
      4.9823695990525625`, 4.994641445355648}]]}, 
   {Hue[
     NCache[
      Rational[407, 512], 0.794921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[407, 256] Pi, Rational[51, 32] Pi}, {4.994641445355648, 
      5.006913291658733}]]}, 
   {Hue[
     NCache[
      Rational[51, 64], 0.796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[51, 32] Pi, Rational[409, 256] Pi}, {5.006913291658733, 
      5.019185137961818}]]}, 
   {Hue[
     NCache[
      Rational[409, 512], 0.798828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[409, 256] Pi, Rational[205, 128] Pi}, {
      5.019185137961818, 5.031456984264903}]]}, 
   {Hue[
     NCache[
      Rational[205, 256], 0.80078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[205, 128] Pi, Rational[411, 256] Pi}, {
      5.031456984264903, 5.043728830567988}]]}, 
   {Hue[
     NCache[
      Rational[411, 512], 0.802734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[411, 256] Pi, Rational[103, 64] Pi}, {5.043728830567988,
       5.056000676871073}]]}, 
   {Hue[
     NCache[
      Rational[103, 128], 0.8046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[103, 64] Pi, Rational[413, 256] Pi}, {5.056000676871073,
       5.0682725231741586`}]]}, 
   {Hue[
     NCache[
      Rational[413, 512], 0.806640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[413, 256] Pi, Rational[207, 128] Pi}, {
      5.0682725231741586`, 5.080544369477243}]]}, 
   {Hue[
     NCache[
      Rational[207, 256], 0.80859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[207, 128] Pi, Rational[415, 256] Pi}, {
      5.080544369477243, 5.092816215780329}]]}, 
   {Hue[
     NCache[
      Rational[415, 512], 0.810546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[415, 256] Pi, Rational[13, 8] Pi}, {5.092816215780329, 
      5.105088062083414}]]}, 
   {Hue[
     NCache[
      Rational[13, 16], 0.8125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[13, 8] Pi, Rational[417, 256] Pi}, {5.105088062083414, 
      5.117359908386499}]]}, 
   {Hue[
     NCache[
      Rational[417, 512], 0.814453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[417, 256] Pi, Rational[209, 128] Pi}, {
      5.117359908386499, 5.129631754689584}]]}, 
   {Hue[
     NCache[
      Rational[209, 256], 0.81640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[209, 128] Pi, Rational[419, 256] Pi}, {
      5.129631754689584, 5.141903600992669}]]}, 
   {Hue[
     NCache[
      Rational[419, 512], 0.818359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[419, 256] Pi, Rational[105, 64] Pi}, {5.141903600992669,
       5.154175447295755}]]}, 
   {Hue[
     NCache[
      Rational[105, 128], 0.8203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[105, 64] Pi, Rational[421, 256] Pi}, {5.154175447295755,
       5.166447293598839}]]}, 
   {Hue[
     NCache[
      Rational[421, 512], 0.822265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[421, 256] Pi, Rational[211, 128] Pi}, {
      5.166447293598839, 5.178719139901925}]]}, 
   {Hue[
     NCache[
      Rational[211, 256], 0.82421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[211, 128] Pi, Rational[423, 256] Pi}, {
      5.178719139901925, 5.190990986205009}]]}, 
   {Hue[
     NCache[
      Rational[423, 512], 0.826171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[423, 256] Pi, Rational[53, 32] Pi}, {5.190990986205009, 
      5.203262832508095}]]}, 
   {Hue[
     NCache[
      Rational[53, 64], 0.828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[53, 32] Pi, Rational[425, 256] Pi}, {5.203262832508095, 
      5.21553467881118}]]}, 
   {Hue[
     NCache[
      Rational[425, 512], 0.830078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[425, 256] Pi, Rational[213, 128] Pi}, {5.21553467881118,
       5.227806525114265}]]}, 
   {Hue[
     NCache[
      Rational[213, 256], 0.83203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[213, 128] Pi, Rational[427, 256] Pi}, {
      5.227806525114265, 5.240078371417351}]]}, 
   {Hue[
     NCache[
      Rational[427, 512], 0.833984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[427, 256] Pi, Rational[107, 64] Pi}, {5.240078371417351,
       5.252350217720435}]]}, 
   {Hue[
     NCache[
      Rational[107, 128], 0.8359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[107, 64] Pi, Rational[429, 256] Pi}, {5.252350217720435,
       5.264622064023521}]]}, 
   {Hue[
     NCache[
      Rational[429, 512], 0.837890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[429, 256] Pi, Rational[215, 128] Pi}, {
      5.264622064023521, 5.2768939103266055`}]]}, 
   {Hue[
     NCache[
      Rational[215, 256], 0.83984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[215, 128] Pi, Rational[431, 256] Pi}, {
      5.2768939103266055`, 5.289165756629691}]]}, 
   {Hue[
     NCache[
      Rational[431, 512], 0.841796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[431, 256] Pi, Rational[27, 16] Pi}, {5.289165756629691, 
      5.301437602932776}]]}, 
   {Hue[
     NCache[
      Rational[27, 32], 0.84375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[27, 16] Pi, Rational[433, 256] Pi}, {5.301437602932776, 
      5.313709449235861}]]}, 
   {Hue[
     NCache[
      Rational[433, 512], 0.845703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[433, 256] Pi, Rational[217, 128] Pi}, {
      5.313709449235861, 5.325981295538946}]]}, 
   {Hue[
     NCache[
      Rational[217, 256], 0.84765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[217, 128] Pi, Rational[435, 256] Pi}, {
      5.325981295538946, 5.338253141842031}]]}, 
   {Hue[
     NCache[
      Rational[435, 512], 0.849609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[435, 256] Pi, Rational[109, 64] Pi}, {5.338253141842031,
       5.350524988145116}]]}, 
   {Hue[
     NCache[
      Rational[109, 128], 0.8515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[109, 64] Pi, Rational[437, 256] Pi}, {5.350524988145116,
       5.3627968344482015`}]]}, 
   {Hue[
     NCache[
      Rational[437, 512], 0.853515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[437, 256] Pi, Rational[219, 128] Pi}, {
      5.3627968344482015`, 5.375068680751287}]]}, 
   {Hue[
     NCache[
      Rational[219, 256], 0.85546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[219, 128] Pi, Rational[439, 256] Pi}, {
      5.375068680751287, 5.387340527054372}]]}, 
   {Hue[
     NCache[
      Rational[439, 512], 0.857421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[439, 256] Pi, Rational[55, 32] Pi}, {5.387340527054372, 
      5.399612373357457}]]}, 
   {Hue[
     NCache[
      Rational[55, 64], 0.859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[55, 32] Pi, Rational[441, 256] Pi}, {5.399612373357457, 
      5.411884219660542}]]}, 
   {Hue[
     NCache[
      Rational[441, 512], 0.861328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[441, 256] Pi, Rational[221, 128] Pi}, {
      5.411884219660542, 5.424156065963627}]]}, 
   {Hue[
     NCache[
      Rational[221, 256], 0.86328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[221, 128] Pi, Rational[443, 256] Pi}, {
      5.424156065963627, 5.436427912266712}]]}, 
   {Hue[
     NCache[
      Rational[443, 512], 0.865234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[443, 256] Pi, Rational[111, 64] Pi}, {5.436427912266712,
       5.448699758569798}]]}, 
   {Hue[
     NCache[
      Rational[111, 128], 0.8671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[111, 64] Pi, Rational[445, 256] Pi}, {5.448699758569798,
       5.460971604872882}]]}, 
   {Hue[
     NCache[
      Rational[445, 512], 0.869140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[445, 256] Pi, Rational[223, 128] Pi}, {
      5.460971604872882, 5.473243451175968}]]}, 
   {Hue[
     NCache[
      Rational[223, 256], 0.87109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[223, 128] Pi, Rational[447, 256] Pi}, {
      5.473243451175968, 5.485515297479052}]]}, 
   {Hue[
     NCache[
      Rational[447, 512], 0.873046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[447, 256] Pi, Rational[7, 4] Pi}, {5.485515297479052, 
      5.497787143782138}]]}, 
   {Hue[
     NCache[
      Rational[7, 8], 0.875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[7, 4] Pi, Rational[449, 256] Pi}, {5.497787143782138, 
      5.5100589900852235`}]]}, 
   {Hue[
     NCache[
      Rational[449, 512], 0.876953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[449, 256] Pi, Rational[225, 128] Pi}, {
      5.5100589900852235`, 5.522330836388308}]]}, 
   {Hue[
     NCache[
      Rational[225, 256], 0.87890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[225, 128] Pi, Rational[451, 256] Pi}, {
      5.522330836388308, 5.534602682691394}]]}, 
   {Hue[
     NCache[
      Rational[451, 512], 0.880859375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[451, 256] Pi, Rational[113, 64] Pi}, {5.534602682691394,
       5.546874528994478}]]}, 
   {Hue[
     NCache[
      Rational[113, 128], 0.8828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[113, 64] Pi, Rational[453, 256] Pi}, {5.546874528994478,
       5.559146375297564}]]}, 
   {Hue[
     NCache[
      Rational[453, 512], 0.884765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[453, 256] Pi, Rational[227, 128] Pi}, {
      5.559146375297564, 5.5714182216006485`}]]}, 
   {Hue[
     NCache[
      Rational[227, 256], 0.88671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[227, 128] Pi, Rational[455, 256] Pi}, {
      5.5714182216006485`, 5.583690067903734}]]}, 
   {Hue[
     NCache[
      Rational[455, 512], 0.888671875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[455, 256] Pi, Rational[57, 32] Pi}, {5.583690067903734, 
      5.595961914206819}]]}, 
   {Hue[
     NCache[
      Rational[57, 64], 0.890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[57, 32] Pi, Rational[457, 256] Pi}, {5.595961914206819, 
      5.608233760509904}]]}, 
   {Hue[
     NCache[
      Rational[457, 512], 0.892578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[457, 256] Pi, Rational[229, 128] Pi}, {
      5.608233760509904, 5.620505606812989}]]}, 
   {Hue[
     NCache[
      Rational[229, 256], 0.89453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[229, 128] Pi, Rational[459, 256] Pi}, {
      5.620505606812989, 5.632777453116074}]]}, 
   {Hue[
     NCache[
      Rational[459, 512], 0.896484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[459, 256] Pi, Rational[115, 64] Pi}, {5.632777453116074,
       5.64504929941916}]]}, 
   {Hue[
     NCache[
      Rational[115, 128], 0.8984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[115, 64] Pi, Rational[461, 256] Pi}, {5.64504929941916, 
      5.6573211457222445`}]]}, 
   {Hue[
     NCache[
      Rational[461, 512], 0.900390625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[461, 256] Pi, Rational[231, 128] Pi}, {
      5.6573211457222445`, 5.66959299202533}]]}, 
   {Hue[
     NCache[
      Rational[231, 256], 0.90234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[231, 128] Pi, Rational[463, 256] Pi}, {5.66959299202533,
       5.681864838328415}]]}, 
   {Hue[
     NCache[
      Rational[463, 512], 0.904296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[463, 256] Pi, Rational[29, 16] Pi}, {5.681864838328415, 
      5.6941366846315}]]}, 
   {Hue[
     NCache[
      Rational[29, 32], 0.90625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[29, 16] Pi, Rational[465, 256] Pi}, {5.6941366846315, 
      5.706408530934585}]]}, 
   {Hue[
     NCache[
      Rational[465, 512], 0.908203125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[465, 256] Pi, Rational[233, 128] Pi}, {
      5.706408530934585, 5.71868037723767}]]}, 
   {Hue[
     NCache[
      Rational[233, 256], 0.91015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[233, 128] Pi, Rational[467, 256] Pi}, {5.71868037723767,
       5.730952223540755}]]}, 
   {Hue[
     NCache[
      Rational[467, 512], 0.912109375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[467, 256] Pi, Rational[117, 64] Pi}, {5.730952223540755,
       5.743224069843841}]]}, 
   {Hue[
     NCache[
      Rational[117, 128], 0.9140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[117, 64] Pi, Rational[469, 256] Pi}, {5.743224069843841,
       5.755495916146925}]]}, 
   {Hue[
     NCache[
      Rational[469, 512], 0.916015625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[469, 256] Pi, Rational[235, 128] Pi}, {
      5.755495916146925, 5.767767762450011}]]}, 
   {Hue[
     NCache[
      Rational[235, 256], 0.91796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[235, 128] Pi, Rational[471, 256] Pi}, {
      5.767767762450011, 5.780039608753096}]]}, 
   {Hue[
     NCache[
      Rational[471, 512], 0.919921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[471, 256] Pi, Rational[59, 32] Pi}, {5.780039608753096, 
      5.792311455056181}]]}, 
   {Hue[
     NCache[
      Rational[59, 64], 0.921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[59, 32] Pi, Rational[473, 256] Pi}, {5.792311455056181, 
      5.8045833013592665`}]]}, 
   {Hue[
     NCache[
      Rational[473, 512], 0.923828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[473, 256] Pi, Rational[237, 128] Pi}, {
      5.8045833013592665`, 5.816855147662351}]]}, 
   {Hue[
     NCache[
      Rational[237, 256], 0.92578125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[237, 128] Pi, Rational[475, 256] Pi}, {
      5.816855147662351, 5.829126993965437}]]}, 
   {Hue[
     NCache[
      Rational[475, 512], 0.927734375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[475, 256] Pi, Rational[119, 64] Pi}, {5.829126993965437,
       5.841398840268521}]]}, 
   {Hue[
     NCache[
      Rational[119, 128], 0.9296875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[119, 64] Pi, Rational[477, 256] Pi}, {5.841398840268521,
       5.853670686571607}]]}, 
   {Hue[
     NCache[
      Rational[477, 512], 0.931640625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[477, 256] Pi, Rational[239, 128] Pi}, {
      5.853670686571607, 5.8659425328746915`}]]}, 
   {Hue[
     NCache[
      Rational[239, 256], 0.93359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[239, 128] Pi, Rational[479, 256] Pi}, {
      5.8659425328746915`, 5.878214379177777}]]}, 
   {Hue[
     NCache[
      Rational[479, 512], 0.935546875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[479, 256] Pi, Rational[15, 8] Pi}, {5.878214379177777, 
      5.890486225480862}]]}, 
   {Hue[
     NCache[
      Rational[15, 16], 0.9375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[15, 8] Pi, Rational[481, 256] Pi}, {5.890486225480862, 
      5.902758071783947}]]}, 
   {Hue[
     NCache[
      Rational[481, 512], 0.939453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[481, 256] Pi, Rational[241, 128] Pi}, {
      5.902758071783947, 5.915029918087033}]]}, 
   {Hue[
     NCache[
      Rational[241, 256], 0.94140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[241, 128] Pi, Rational[483, 256] Pi}, {
      5.915029918087033, 5.927301764390117}]]}, 
   {Hue[
     NCache[
      Rational[483, 512], 0.943359375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[483, 256] Pi, Rational[121, 64] Pi}, {5.927301764390117,
       5.939573610693203}]]}, 
   {Hue[
     NCache[
      Rational[121, 128], 0.9453125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[121, 64] Pi, Rational[485, 256] Pi}, {5.939573610693203,
       5.9518454569962875`}]]}, 
   {Hue[
     NCache[
      Rational[485, 512], 0.947265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[485, 256] Pi, Rational[243, 128] Pi}, {
      5.9518454569962875`, 5.964117303299373}]]}, 
   {Hue[
     NCache[
      Rational[243, 256], 0.94921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[243, 128] Pi, Rational[487, 256] Pi}, {
      5.964117303299373, 5.976389149602458}]]}, 
   {Hue[
     NCache[
      Rational[487, 512], 0.951171875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[487, 256] Pi, Rational[61, 32] Pi}, {5.976389149602458, 
      5.988660995905543}]]}, 
   {Hue[
     NCache[
      Rational[61, 64], 0.953125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[61, 32] Pi, Rational[489, 256] Pi}, {5.988660995905543, 
      6.000932842208628}]]}, 
   {Hue[
     NCache[
      Rational[489, 512], 0.955078125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[489, 256] Pi, Rational[245, 128] Pi}, {
      6.000932842208628, 6.013204688511713}]]}, 
   {Hue[
     NCache[
      Rational[245, 256], 0.95703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[245, 128] Pi, Rational[491, 256] Pi}, {
      6.013204688511713, 6.025476534814799}]]}, 
   {Hue[
     NCache[
      Rational[491, 512], 0.958984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[491, 256] Pi, Rational[123, 64] Pi}, {6.025476534814799,
       6.037748381117884}]]}, 
   {Hue[
     NCache[
      Rational[123, 128], 0.9609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[123, 64] Pi, Rational[493, 256] Pi}, {6.037748381117884,
       6.050020227420969}]]}, 
   {Hue[
     NCache[
      Rational[493, 512], 0.962890625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[493, 256] Pi, Rational[247, 128] Pi}, {
      6.050020227420969, 6.062292073724054}]]}, 
   {Hue[
     NCache[
      Rational[247, 256], 0.96484375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[247, 128] Pi, Rational[495, 256] Pi}, {
      6.062292073724054, 6.074563920027139}]]}, 
   {Hue[
     NCache[
      Rational[495, 512], 0.966796875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[495, 256] Pi, Rational[31, 16] Pi}, {6.074563920027139, 
      6.086835766330224}]]}, 
   {Hue[
     NCache[
      Rational[31, 32], 0.96875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[31, 16] Pi, Rational[497, 256] Pi}, {6.086835766330224, 
      6.0991076126333095`}]]}, 
   {Hue[
     NCache[
      Rational[497, 512], 0.970703125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[497, 256] Pi, Rational[249, 128] Pi}, {
      6.0991076126333095`, 6.111379458936394}]]}, 
   {Hue[
     NCache[
      Rational[249, 256], 0.97265625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[249, 128] Pi, Rational[499, 256] Pi}, {
      6.111379458936394, 6.12365130523948}]]}, 
   {Hue[
     NCache[
      Rational[499, 512], 0.974609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[499, 256] Pi, Rational[125, 64] Pi}, {6.12365130523948, 
      6.135923151542564}]]}, 
   {Hue[
     NCache[
      Rational[125, 128], 0.9765625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[125, 64] Pi, Rational[501, 256] Pi}, {6.135923151542564,
       6.14819499784565}]]}, 
   {Hue[
     NCache[
      Rational[501, 512], 0.978515625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[501, 256] Pi, Rational[251, 128] Pi}, {6.14819499784565,
       6.160466844148735}]]}, 
   {Hue[
     NCache[
      Rational[251, 256], 0.98046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[251, 128] Pi, Rational[503, 256] Pi}, {
      6.160466844148735, 6.17273869045182}]]}, 
   {Hue[
     NCache[
      Rational[503, 512], 0.982421875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[503, 256] Pi, Rational[63, 32] Pi}, {6.17273869045182, 
      6.1850105367549055`}]]}, 
   {Hue[
     NCache[
      Rational[63, 64], 0.984375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[63, 32] Pi, Rational[505, 256] Pi}, {
      6.1850105367549055`, 6.19728238305799}]]}, 
   {Hue[
     NCache[
      Rational[505, 512], 0.986328125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[505, 256] Pi, Rational[253, 128] Pi}, {6.19728238305799,
       6.209554229361076}]]}, 
   {Hue[
     NCache[
      Rational[253, 256], 0.98828125]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[253, 128] Pi, Rational[507, 256] Pi}, {
      6.209554229361076, 6.22182607566416}]]}, 
   {Hue[
     NCache[
      Rational[507, 512], 0.990234375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[507, 256] Pi, Rational[127, 64] Pi}, {6.22182607566416, 
      6.234097921967246}]]}, 
   {Hue[
     NCache[
      Rational[127, 128], 0.9921875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[127, 64] Pi, Rational[509, 256] Pi}, {6.234097921967246,
       6.2463697682703305`}]]}, 
   {Hue[
     NCache[
      Rational[509, 512], 0.994140625]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[509, 256] Pi, Rational[255, 128] Pi}, {
      6.2463697682703305`, 6.258641614573416}]]}, 
   {Hue[
     NCache[
      Rational[255, 256], 0.99609375]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[255, 128] Pi, Rational[511, 256] Pi}, {
      6.258641614573416, 6.270913460876501}]]}, 
   {Hue[
     NCache[
      Rational[511, 512], 0.998046875]], 
    DiskBox[{0, 0}, 1, 
     NCache[{Rational[511, 256] Pi, 2 Pi}, {6.270913460876501, 
      6.283185307179586}]]}, 
   {Hue[1], 
    DiskBox[{0, 0}, 1, 
     NCache[{2 Pi, Rational[513, 256] Pi}, {6.283185307179586, 
      6.295457153482672}]]}},
  ImageSize->{63.74999999999893, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here is the circle graphic primitive together with a text label.\
\>", "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"circ", "=", 
   RowBox[{"Circle", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}]}], ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ctext", "=", 
   RowBox[{"Text", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Circle\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
       RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
       RowBox[{"Sin", "[", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell["\<\
This generates the graphics primitive for the triangle and its text label.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tri", "=", 
   RowBox[{"Line", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ttext", "=", 
   RowBox[{"Text", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Triangle\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
       RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"0", "+", ".15"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell["Here is the rectangle and label.", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rect", "=", 
   RowBox[{"Line", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "}"}], "]"}]}], ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rtext", "=", 
   RowBox[{"Text", "[", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Rectangle\>\"", ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
       RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35", ",", 
       RowBox[{
        RowBox[{"-", "1"}], "+", ".15"}]}], "}"}]}], "]"}]}], ";"}]], "Input",\

 CellTags->"10.1 Solutions"],

Cell["\<\
Finally, this displays each of these graphics elements all together. \
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{
   "circ", ",", "tri", ",", "rect", ",", "ctext", ",", "ttext", ",", 
    "rtext"}], "}"}], "]"}]], "Input",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Cuboid",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Cuboid"]], "InlineFormula"],
 " takes a list of three numbers as the coordinates of its lower-left corner. \
This maps the object across two such lists."
}], "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Cuboid", ",", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Cuboid", "[", 
    RowBox[{"{", 
     RowBox[{
     "0.989388953261926`", ",", "0.26212102993264885`", ",", 
      "0.4466540702379995`"}], "}"}], "]"}], ",", 
   RowBox[{"Cuboid", "[", 
    RowBox[{"{", 
     RowBox[{
     "0.7123459843050184`", ",", "0.9108756151608239`", ",", 
      "0.3295478161829475`"}], "}"}], "]"}]}], "}"}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Below is a list of six cuboids and the resulting graphic. Notice the large \
amount of overlap of the cubes. You can reduce the large overlap by \
specifying minimum ",
 StyleBox["and",
  FontSlant->"Italic"],
 " maximum values of the cuboid."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cubes", "=", 
   RowBox[{"Map", "[", 
    RowBox[{"Cuboid", ",", 
     RowBox[{"RandomReal", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"6", ",", "3"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Opacity", "[", ".5", "]"}], ",", "cubes"}], "}"}], 
  "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[
  {Opacity[0.5], 
   CuboidBox[{0.1134063282784119, 0.9016760029158724, 0.17339564775692362`}], 
   CuboidBox[{0.6464261220083465, 0.7764081290992346, 0.7592289503531553}], 
   CuboidBox[{0.6777474869634845, 0.029213653709336818`, 0.5509480306986725}],
    CuboidBox[{0.05557627264779641, 0.6294622907826624, 0.9981831750013277}], 
   CuboidBox[{0.8003836246911005, 0.15493011742725904`, 
    0.43954808382245636`}], 
   CuboidBox[{0.9011246762283935, 0.02183632256986301, 0.5334595348861799}]},
  ImageSize->{81.24999999999952, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Start by creating a unit cube centered on the origin. An opacity directive \
adds transparency.\
\>", "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Opacity", "[", ".25", "]"}], ",", 
     RowBox[{"Cuboid", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.5"}], ",", 
        RowBox[{"-", "0.5"}], ",", 
        RowBox[{"-", "0.5"}]}], "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[
  {Opacity[0.25], CuboidBox[{-0.5, -0.5, -0.5}]},
  Axes->Automatic,
  Boxed->False,
  ImageSize->{87.49999999999963, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Next rotate ",
 StyleBox["45\[Degree]", "OsF"],
 ". Note the third argument of ",
 Cell[BoxData[
  ButtonBox["Rotate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Rotate"]], "InlineFormula"],
 " used to specify the axis about which the rotation should occur."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Opacity", "[", ".25", "]"}], ",", 
    RowBox[{"Cuboid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", ".5"}], ",", 
       RowBox[{"-", ".5"}], ",", 
       RowBox[{"-", ".5"}]}], "}"}], "]"}], ",", 
    RowBox[{"Rotate", "[", 
     RowBox[{
      RowBox[{"Cuboid", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".5"}], ",", 
         RowBox[{"-", ".5"}], ",", 
         RowBox[{"-", ".5"}]}], "}"}], "]"}], ",", 
      RowBox[{"45", " ", "\[Degree]"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[
  {Opacity[0.25], CuboidBox[{-0.5, -0.5, -0.5}], 
   GeometricTransformation3DBox[CuboidBox[{-0.5, -0.5, -0.5}], 
    NCache[{{2^Rational[-1, 2], -2^Rational[-1, 2], 0}, {
      2^Rational[-1, 2], 2^Rational[-1, 2], 0}, {0, 0, 1}}, {{
      0.7071067811865475, -0.7071067811865475, 0}, {
      0.7071067811865475, 0.7071067811865475, 0}, {0, 0, 1}}]]},
  ImageSize->{92.4999999999998, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell["\<\
Here is the dynamic version. The angle \[Theta] is the parameter that is \
manipulated here.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics3D", "[", 
    RowBox[{
     RowBox[{"Rotate", "[", 
      RowBox[{
       RowBox[{"Cuboid", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", ".5"}], ",", 
          RowBox[{"-", ".5"}], ",", 
          RowBox[{"-", ".5"}]}], "}"}], "]"}], ",", "\[Theta]", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "1"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", 
     RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`\[Theta]$$ = 0., Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`\[Theta]$$], 0, 2 Pi}}, Typeset`size$$ = {
    108., {53., 64.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`\[Theta]$561550$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`\[Theta]$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`\[Theta]$$, $CellContext`\[Theta]$561550$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Graphics3D[
        Rotate[
         Cuboid[{-0.5, -0.5, -0.5}], $CellContext`\[Theta]$$, {0, 0, 1}], 
        PlotRange -> 1, ImageSize -> {Automatic, 78}], 
      "Specifications" :> {{$CellContext`\[Theta]$$, 0, 2 Pi}}, 
      "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{367., {118., 126.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First we create the ",
 Cell[BoxData[
  ButtonBox["Point",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Point"]], "InlineFormula"],
 " graphics primitives using a normal distribution with mean ",
 StyleBox["0", "OsF"],
 " and standard deviation ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"randomcoords", ":=", 
  RowBox[{"Point", "[", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell["\<\
This creates the point sizes according to the specification given in the \
statement of the problem.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"randomsize", ":=", 
  RowBox[{"PointSize", "[", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{".01", ",", ".1"}], "}"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[TextData[{
 "This will assign a random color to each primitive. The four-argument form \
of ",
 Cell[BoxData[
  ButtonBox["Hue",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Hue"]], "InlineFormula"],
 " specifies hue, saturation, brightness, opacity."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"randomcolor", ":=", 
  RowBox[{"Hue", "[", 
   RowBox[{
    RowBox[{"RandomReal", "[", "]"}], ",", "1", ",", "1", ",", ".4"}], 
   "]"}]}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[TextData[{
 "Here then are ",
 StyleBox["500", "OsF"],
 " points. (You may find it instructive to look at just one of these \
points.)"
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"randomcolor", ",", "randomsize", ",", "randomcoords"}], "}"}], 
     ",", 
     RowBox[{"{", "500", "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell["And here is the graphic.", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "pts", "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.45627345918570184`, 1, 1], PointSize[0.01399215878810424], Opacity[
    0.4], PointBox[{{1.3665544503741598`, 0.40811090676357326`}}]}, 
   {Hue[0.6819651666160613, 1, 1], PointSize[0.07084288260888572], Opacity[
    0.4], PointBox[{{1.583229064019008, -0.7837703143103137}}]}, 
   {Hue[0.3670675427949299, 1, 1], PointSize[0.09591223736779714], Opacity[
    0.4], PointBox[{{0.639391123361363, 0.2374696531250444}}]}, 
   {Hue[0.5300115821026781, 1, 1], PointSize[0.06140977790882288], Opacity[
    0.4], PointBox[{{-1.2951556639101383`, 0.3770238302814304}}]}, 
   {Hue[0.5327059600509387, 1, 1], PointSize[0.09629839703754559], Opacity[
    0.4], PointBox[{{0.6445443861171192, -0.4806446906640838}}]}, 
   {Hue[0.13605959288666258`, 1, 1], PointSize[0.03900734613567382], Opacity[
    0.4], PointBox[{{-1.280232907718857, -1.54996691189794}}]}, 
   {Hue[0.329370934452647, 1, 1], PointSize[0.09462331331504886], Opacity[
    0.4], PointBox[{{-0.7022440412444894, 1.0143202754562195`}}]}, 
   {Hue[0.4909552863059097, 1, 1], PointSize[0.060947656241284315`], Opacity[
    0.4], PointBox[{{0.6857448145308084, 1.4879238917032067`}}]}, 
   {Hue[0.26767362284348484`, 1, 1], PointSize[0.012735365681437738`], 
    Opacity[0.4], PointBox[{{-0.19900764738432486`, -0.10890772335465694`}}]}, 
   {Hue[0.780276351319148, 1, 1], PointSize[0.06181323611084541], Opacity[
    0.4], PointBox[{{-0.0106770847061015, 0.29369315558256887`}}]}, 
   {Hue[0.19323620599997504`, 1, 1], PointSize[0.057615613189938214`], 
    Opacity[0.4], PointBox[{{0.278088541755619, -0.8658033964419917}}]}, 
   {Hue[0.05737850602278405, 1, 1], PointSize[0.02774951352763788], Opacity[
    0.4], PointBox[{{0.08157400756009321, -0.32415375304528227`}}]}, 
   {Hue[0.38225564918988986`, 1, 1], PointSize[0.08270434933751211], Opacity[
    0.4], PointBox[{{-0.5100008632262261, -2.978799431013076}}]}, 
   {Hue[0.9939677314663378, 1, 1], PointSize[0.03123706823724777], Opacity[
    0.4], PointBox[{{0.48759309071415047`, 0.05060876801272513}}]}, 
   {Hue[0.28916871569217095`, 1, 1], PointSize[0.06559802930158351], Opacity[
    0.4], PointBox[{{0.8699564749723183, 1.5126644728116476`}}]}, 
   {Hue[0.34817112140352546`, 1, 1], PointSize[0.05422551825664518], Opacity[
    0.4], PointBox[{{0.15096274189892595`, -1.4258339811993077`}}]}, 
   {Hue[0.6660788469081258, 1, 1], PointSize[0.07724335334532587], Opacity[
    0.4], PointBox[{{1.955149604100117, -0.1947550677026131}}]}, 
   {Hue[0.3325428588925723, 1, 1], PointSize[0.07967814500378231], Opacity[
    0.4], PointBox[{{0.5591241305380671, -0.942450244655679}}]}, 
   {Hue[0.6347308449328064, 1, 1], PointSize[0.028493433459124015`], Opacity[
    0.4], PointBox[{{-0.6234512981227383, -0.021313317527092278`}}]}, 
   {Hue[0.13958896922619535`, 1, 1], PointSize[0.030450487088176423`], 
    Opacity[0.4], PointBox[{{0.03225820749179172, 1.1538931346050092`}}]}, 
   {Hue[0.7823299623172275, 1, 1], PointSize[0.05152628221198002], Opacity[
    0.4], PointBox[{{0.17245984970144648`, -1.2530824949356871`}}]}, 
   {Hue[0.9391914133165862, 1, 1], PointSize[0.04402731873997649], Opacity[
    0.4], PointBox[{{1.971777496431606, 0.6050778810608148}}]}, 
   {Hue[0.590659391499631, 1, 1], PointSize[0.0327830315632522], Opacity[0.4],
     PointBox[{{-1.4417552335353279`, -0.5331595610247588}}]}, 
   {Hue[0.8500426474796268, 1, 1], PointSize[0.08031168006391964], Opacity[
    0.4], PointBox[{{1.348482505961968, -1.7938470325526539`}}]}, 
   {Hue[0.22198103959092363`, 1, 1], PointSize[0.03095206164536886], Opacity[
    0.4], PointBox[{{0.24737100608211812`, -1.422638692594366}}]}, 
   {Hue[0.8216096231115324, 1, 1], PointSize[0.05173864851609827], Opacity[
    0.4], PointBox[{{0.7843005430256432, -0.1495609147988741}}]}, 
   {Hue[0.5112158632171806, 1, 1], PointSize[0.0547745561180307], Opacity[
    0.4], PointBox[{{-0.27596750473963044`, -1.268692955700303}}]}, 
   {Hue[0.6577634033497648, 1, 1], PointSize[0.0723094102510734], Opacity[
    0.4], PointBox[{{-0.07236136046836718, -1.7641167956465822`}}]}, 
   {Hue[0.35726016940390704`, 1, 1], PointSize[0.03872411188697637], Opacity[
    0.4], PointBox[{{-1.2300015723632864`, 0.9922494088883839}}]}, 
   {Hue[0.7330950551450892, 1, 1], PointSize[0.030976155433489486`], Opacity[
    0.4], PointBox[{{1.1974949831218995`, -1.5953561361011985`}}]}, 
   {Hue[0.5059848980475137, 1, 1], PointSize[0.05419929545095825], Opacity[
    0.4], PointBox[{{-0.6917754218601135, 0.4758546522517169}}]}, 
   {Hue[0.684544610193289, 1, 1], PointSize[0.06215883924227214], Opacity[
    0.4], PointBox[{{0.5325773164419182, 0.41601571189818176`}}]}, 
   {Hue[0.6421167166761721, 1, 1], PointSize[0.03976929247486155], Opacity[
    0.4], PointBox[{{0.8318950840855753, -0.9874410643986367}}]}, 
   {Hue[0.5546790074505654, 1, 1], PointSize[0.0775617146888806], Opacity[
    0.4], PointBox[{{1.283696181347212, -1.8039862081054197`}}]}, 
   {Hue[0.5445369996531, 1, 1], PointSize[0.08182263156274946], Opacity[0.4], 
    PointBox[{{-0.7789044258365659, 1.4859325562046588`}}]}, 
   {Hue[0.9254310185779835, 1, 1], PointSize[0.08866109061321228], Opacity[
    0.4], PointBox[{{0.5155680588792744, 0.9490413652569871}}]}, 
   {Hue[0.384597251878964, 1, 1], PointSize[0.0696673726739932], Opacity[0.4],
     PointBox[{{1.8837325935946214`, -0.5993211094508097}}]}, 
   {Hue[0.20891344945531287`, 1, 1], PointSize[0.07947136778898528], Opacity[
    0.4], PointBox[{{-0.7522318384815809, -0.5057614954703742}}]}, 
   {Hue[0.27345634058169255`, 1, 1], PointSize[0.04046268296797781], Opacity[
    0.4], PointBox[{{0.5518267920942084, -0.810600428409004}}]}, 
   {Hue[0.8693571654203005, 1, 1], PointSize[0.06635854932636026], Opacity[
    0.4], PointBox[{{-1.7953719490853193`, 1.2385758287767559`}}]}, 
   {Hue[0.22093544390296027`, 1, 1], PointSize[0.06799155107562077], Opacity[
    0.4], PointBox[{{-0.8181689892558777, 0.06903687895949763}}]}, 
   {Hue[0.11723235472522542`, 1, 1], PointSize[0.040116393576827225`], 
    Opacity[0.4], PointBox[{{-0.6395755504759347, 0.8243613576636707}}]}, 
   {Hue[0.5885355591997921, 1, 1], PointSize[0.0314955462429712], Opacity[
    0.4], PointBox[{{-0.2949306881808185, -1.9810209746755458`}}]}, 
   {Hue[0.577785206854746, 1, 1], PointSize[0.09527151766462869], Opacity[
    0.4], PointBox[{{-0.33673137426136796`, 1.0749274011942629`}}]}, 
   {Hue[0.8655545357345102, 1, 1], PointSize[0.023237230563701333`], Opacity[
    0.4], PointBox[{{1.5058433292468751`, -0.20422078749707442`}}]}, 
   {Hue[0.4120728885774465, 1, 1], PointSize[0.022198101020454192`], Opacity[
    0.4], PointBox[{{-1.6711108884525436`, -0.5178874658150621}}]}, 
   {Hue[0.047883330169389504`, 1, 1], PointSize[0.048848594831904874`], 
    Opacity[0.4], PointBox[{{-1.0082606802000058`, -0.07476641381567913}}]}, 
   {Hue[0.899794027730771, 1, 1], PointSize[0.02777682601703979], Opacity[
    0.4], PointBox[{{0.4924842477343518, -1.1828136187976366`}}]}, 
   {Hue[0.23817659071250485`, 1, 1], PointSize[0.07460106276054523], Opacity[
    0.4], PointBox[{{1.209405789389263, -0.49709573353539965`}}]}, 
   {Hue[0.5951871371257265, 1, 1], PointSize[0.018111266990344987`], Opacity[
    0.4], PointBox[{{-0.8186698728015814, 0.091013698677338}}]}, 
   {Hue[0.4064073964512347, 1, 1], PointSize[0.03276875523784242], Opacity[
    0.4], PointBox[{{0.7404512699154786, 0.36689991532608757`}}]}, 
   {Hue[0.16487095123431295`, 1, 1], PointSize[0.08686724988573372], Opacity[
    0.4], PointBox[{{0.3182886396712614, 0.6259204016724386}}]}, 
   {Hue[0.7995805380529744, 1, 1], PointSize[0.034985910470464746`], Opacity[
    0.4], PointBox[{{-0.36185217570683104`, 0.3876626577306396}}]}, 
   {Hue[0.7078409086904951, 1, 1], PointSize[0.05813870239425267], Opacity[
    0.4], PointBox[{{1.5163480103832918`, 0.3602660015136856}}]}, 
   {Hue[0.07041809390413478, 1, 1], PointSize[0.07080874373129703], Opacity[
    0.4], PointBox[{{-1.4023088273860553`, -0.15944061546762864`}}]}, 
   {Hue[0.7351497042526423, 1, 1], PointSize[0.09120710060320311], Opacity[
    0.4], PointBox[{{-0.4550235708823925, -0.25455110613690873`}}]}, 
   {Hue[0.5855415737753866, 1, 1], PointSize[0.03244436389471944], Opacity[
    0.4], PointBox[{{-0.666760262697337, 0.2636687856254675}}]}, 
   {Hue[0.9830888947431164, 1, 1], PointSize[0.07451929766502693], Opacity[
    0.4], PointBox[{{-0.03194358867881139, 2.515714401113412}}]}, 
   {Hue[0.8408334503987487, 1, 1], PointSize[0.06306298556534928], Opacity[
    0.4], PointBox[{{-0.7214493271324758, -0.8225109519361897}}]}, 
   {Hue[0.12339773751850291`, 1, 1], PointSize[0.03465865138989731], Opacity[
    0.4], PointBox[{{0.8779042684107143, -0.04805181822234944}}]}, 
   {Hue[0.5365181853090015, 1, 1], PointSize[0.09148041094137738], Opacity[
    0.4], PointBox[{{0.7084024442011577, 2.6200682090262024`}}]}, 
   {Hue[0.5428506103813882, 1, 1], PointSize[0.03483747231135849], Opacity[
    0.4], PointBox[{{0.08532188183359796, 0.4304319977039334}}]}, 
   {Hue[0.013019905139698196`, 1, 1], PointSize[0.05784996088091485], Opacity[
    0.4], PointBox[{{0.639293097017183, 2.613940240754755}}]}, 
   {Hue[0.9299945356543073, 1, 1], PointSize[0.06200822357340538], Opacity[
    0.4], PointBox[{{0.20366824140282577`, 0.06785407422296608}}]}, 
   {Hue[0.11038760886608778`, 1, 1], PointSize[0.08701146707545884], Opacity[
    0.4], PointBox[{{-0.05247333179094517, -1.48115551989333}}]}, 
   {Hue[0.7113500191503632, 1, 1], PointSize[0.09503746949691705], Opacity[
    0.4], PointBox[{{-2.2986925263259135`, 0.6698011891905395}}]}, 
   {Hue[0.6113846500230125, 1, 1], PointSize[0.09117306382389054], Opacity[
    0.4], PointBox[{{-0.008656114995947168, 1.0261168317304068`}}]}, 
   {Hue[0.6888301159133399, 1, 1], PointSize[0.09987139957293037], Opacity[
    0.4], PointBox[{{0.07975395823151119, -0.559471397781552}}]}, 
   {Hue[0.15392475819282003`, 1, 1], PointSize[0.058635216085215186`], 
    Opacity[0.4], PointBox[{{-0.24728940461872095`, -0.24471452773973407`}}]}, 
   {Hue[0.5880126363569094, 1, 1], PointSize[0.08731694965396872], Opacity[
    0.4], PointBox[{{2.3541438674490527`, -0.2951484383035536}}]}, 
   {Hue[0.09213982513342489, 1, 1], PointSize[0.03305940157965108], Opacity[
    0.4], PointBox[{{-0.051986287787580805`, -0.8812902527973457}}]}, 
   {Hue[0.9747887523382062, 1, 1], PointSize[0.04755038139123194], Opacity[
    0.4], PointBox[{{-0.6720852998003568, 0.7155662467943843}}]}, 
   {Hue[0.23417907161732598`, 1, 1], PointSize[0.060285481432370114`], 
    Opacity[0.4], PointBox[{{0.7164897643963012, -1.3956531921277335`}}]}, 
   {Hue[0.524426394074134, 1, 1], PointSize[0.03899939177454055], Opacity[
    0.4], PointBox[{{0.28465042245940353`, 0.5325521341768442}}]}, 
   {Hue[0.6113640263742157, 1, 1], PointSize[0.0954214567112408], Opacity[
    0.4], PointBox[{{-0.03988793781669766, 0.4833390214949557}}]}, 
   {Hue[0.3314578076538617, 1, 1], PointSize[0.09476683755324183], Opacity[
    0.4], PointBox[{{-0.35567280933315, 0.24785403549566754`}}]}, 
   {Hue[0.7707138898701316, 1, 1], PointSize[0.03262587549413287], Opacity[
    0.4], PointBox[{{-0.14953250839892812`, 0.009091693126237853}}]}, 
   {Hue[0.6034515785178802, 1, 1], PointSize[0.07838333739101644], Opacity[
    0.4], PointBox[{{-1.2648731342272084`, -0.19285598234180482`}}]}, 
   {Hue[0.553923422576404, 1, 1], PointSize[0.045720873751441765`], Opacity[
    0.4], PointBox[{{0.28394281847252245`, -1.5120410908986175`}}]}, 
   {Hue[0.7270546246880107, 1, 1], PointSize[0.08664399891936245], Opacity[
    0.4], PointBox[{{0.9813853791045527, -0.10692166552380893`}}]}, 
   {Hue[0.7940151432670102, 1, 1], PointSize[0.03309061948855614], Opacity[
    0.4], PointBox[{{-0.811095797374402, -0.27943087510251885`}}]}, 
   {Hue[0.4997984436606422, 1, 1], PointSize[0.03930730885308013], Opacity[
    0.4], PointBox[{{-0.7624327761626601, -0.31952152854152793`}}]}, 
   {Hue[0.9755592427341446, 1, 1], PointSize[0.05257972207835429], Opacity[
    0.4], PointBox[{{0.28019813434520463`, 0.8726495816599926}}]}, 
   {Hue[0.7666786889524937, 1, 1], PointSize[0.050459553500346366`], Opacity[
    0.4], PointBox[{{0.7283928982158786, 1.6966813734122654`}}]}, 
   {Hue[0.4658869503786711, 1, 1], PointSize[0.09141867583372887], Opacity[
    0.4], PointBox[{{-0.8459878239850077, 0.09348817358877125}}]}, 
   {Hue[0.5083240019673212, 1, 1], PointSize[0.0341591741884725], Opacity[
    0.4], PointBox[{{0.4109698449196632, 0.8879946578545928}}]}, 
   {Hue[0.23057775744221476`, 1, 1], PointSize[0.04968117402820596], Opacity[
    0.4], PointBox[{{-0.5476817892125948, 1.236591963375903}}]}, 
   {Hue[0.14277269221545508`, 1, 1], PointSize[0.08052156135615121], Opacity[
    0.4], PointBox[{{-0.3793784967085854, -1.256603815520867}}]}, 
   {Hue[0.7034097563780162, 1, 1], PointSize[0.046755048686747486`], Opacity[
    0.4], PointBox[{{-1.4144569428137845`, 0.1349250583508149}}]}, 
   {Hue[0.8896217256696604, 1, 1], PointSize[0.07714554548867078], Opacity[
    0.4], PointBox[{{0.6556504257103501, 0.8675814330423965}}]}, 
   {Hue[0.9148032289309096, 1, 1], PointSize[0.05651694182836922], Opacity[
    0.4], PointBox[{{-1.7179913441356467`, 1.6757666804669593`}}]}, 
   {Hue[0.4301979159719922, 1, 1], PointSize[0.0766681804661127], Opacity[
    0.4], PointBox[{{-1.407527713428509, 0.5815192085872875}}]}, 
   {Hue[0.5065624930543549, 1, 1], PointSize[0.053454837045225745`], Opacity[
    0.4], PointBox[{{1.947289043481071, 0.35990910351566263`}}]}, 
   {Hue[0.34377878238445025`, 1, 1], PointSize[0.049016529321237956`], 
    Opacity[0.4], PointBox[{{-2.118639171658532, -0.21587920087505288`}}]}, 
   {Hue[0.3474405291881757, 1, 1], PointSize[0.06460136787802584], Opacity[
    0.4], PointBox[{{-1.5727058346218654`, -0.9668870930310016}}]}, 
   {Hue[0.17024103601326912`, 1, 1], PointSize[0.07827180326005284], Opacity[
    0.4], PointBox[{{-0.3046329719915802, 0.27761159075894226`}}]}, 
   {Hue[0.5415666249007343, 1, 1], PointSize[0.022849660446396913`], Opacity[
    0.4], PointBox[{{1.973970875878419, -2.6722253452025457`}}]}, 
   {Hue[0.7518581416316679, 1, 1], PointSize[0.0437491790430221], Opacity[
    0.4], PointBox[{{0.33112162032704595`, 1.033778524120649}}]}, 
   {Hue[0.12170322748746165`, 1, 1], PointSize[0.03694074163684179], Opacity[
    0.4], PointBox[{{-0.6646253759932336, -0.007723766346106491}}]}, 
   {Hue[0.0778772134721144, 1, 1], PointSize[0.059337652827589155`], Opacity[
    0.4], PointBox[{{0.9433643261832212, -0.3907598290228866}}]}, 
   {Hue[0.16004072198942998`, 1, 1], PointSize[0.09026092279099504], Opacity[
    0.4], PointBox[{{0.4659500139313148, -1.3648321328978543`}}]}, 
   {Hue[0.14749866650850407`, 1, 1], PointSize[0.08288810457113693], Opacity[
    0.4], PointBox[{{-0.7063145588641611, 0.7788486464541847}}]}, 
   {Hue[0.5244262776598188, 1, 1], PointSize[0.09458071577706931], Opacity[
    0.4], PointBox[{{-0.1409014682043853, -0.9751934437925471}}]}, 
   {Hue[0.46817970281874954`, 1, 1], PointSize[0.025935066562015816`], 
    Opacity[0.4], PointBox[{{-0.017400451095255915`, -1.14062768683689}}]}, 
   {Hue[0.5068233743369006, 1, 1], PointSize[0.09330277534302003], Opacity[
    0.4], PointBox[{{-0.1368477020219135, 0.572526980725136}}]}, 
   {Hue[0.6635521796496382, 1, 1], PointSize[0.013866622986293237`], Opacity[
    0.4], PointBox[{{1.0050539048849474`, 0.12053599744421784`}}]}, 
   {Hue[0.8143682907877312, 1, 1], PointSize[0.01698005530841555], Opacity[
    0.4], PointBox[{{0.6485851012488832, -1.3806714741498913`}}]}, 
   {Hue[0.6855766430696777, 1, 1], PointSize[0.016222555228421184`], Opacity[
    0.4], PointBox[{{0.39924508641363204`, -1.0225051860446919`}}]}, 
   {Hue[0.7146325407526342, 1, 1], PointSize[0.0623881374916726], Opacity[
    0.4], PointBox[{{1.0242732020735017`, 0.8888586364422821}}]}, 
   {Hue[0.03016705727809632, 1, 1], PointSize[0.038646811550344065`], Opacity[
    0.4], PointBox[{{-0.8698677120422251, 0.2697528636893735}}]}, 
   {Hue[0.29216425650431743`, 1, 1], PointSize[0.030941756549715177`], 
    Opacity[0.4], PointBox[{{2.997864416552019, 0.060491641038763734`}}]}, 
   {Hue[0.9519251447563648, 1, 1], PointSize[0.024110573254948753`], Opacity[
    0.4], PointBox[{{0.055167060280565845`, 0.07547518108738921}}]}, 
   {Hue[0.2505586544560827, 1, 1], PointSize[0.05320948249881646], Opacity[
    0.4], PointBox[{{0.1399192444184339, -0.3739277684430627}}]}, 
   {Hue[0.9025102475610858, 1, 1], PointSize[0.07248764836578728], Opacity[
    0.4], PointBox[{{-0.3460764804691562, -0.5537539247145227}}]}, 
   {Hue[0.21878896414289017`, 1, 1], PointSize[0.03437002762913703], Opacity[
    0.4], PointBox[{{-0.8919705733477962, -1.6263471513638768`}}]}, 
   {Hue[0.8852821932421893, 1, 1], PointSize[0.07201650797780682], Opacity[
    0.4], PointBox[{{1.4511995874305608`, 1.3072776336739431`}}]}, 
   {Hue[0.6272528821345045, 1, 1], PointSize[0.033174024915255354`], Opacity[
    0.4], PointBox[{{1.0475340555785624`, 0.4907639564300241}}]}, 
   {Hue[0.32845374280792194`, 1, 1], PointSize[0.06397396475354075], Opacity[
    0.4], PointBox[{{-0.3504268729927218, 1.231496874507316}}]}, 
   {Hue[0.23987517361842836`, 1, 1], PointSize[0.01479272584807885], Opacity[
    0.4], PointBox[{{0.15502017756180492`, 1.4554354166496581`}}]}, 
   {Hue[0.35630587017043513`, 1, 1], PointSize[0.08187287279774591], Opacity[
    0.4], PointBox[{{-1.2665232114633982`, 1.2556302317037582`}}]}, 
   {Hue[0.9952524510436291, 1, 1], PointSize[0.04767405552481607], Opacity[
    0.4], PointBox[{{0.2526757269280924, 0.47171847141929785`}}]}, 
   {Hue[0.13772384270190097`, 1, 1], PointSize[0.07284372077961196], Opacity[
    0.4], PointBox[{{-0.26768169164109007`, -0.4348994895550914}}]}, 
   {Hue[0.6925135973559495, 1, 1], PointSize[0.056479859032851076`], Opacity[
    0.4], PointBox[{{1.3009874758129798`, 0.0708720448910307}}]}, 
   {Hue[0.4121006190511385, 1, 1], PointSize[0.05267508500689458], Opacity[
    0.4], PointBox[{{1.3797609039223273`, -0.42225013476687256`}}]}, 
   {Hue[0.4534956837456263, 1, 1], PointSize[0.0221807294685539], Opacity[
    0.4], PointBox[{{-1.0654868390586054`, 0.6000914652299811}}]}, 
   {Hue[0.7100410996074193, 1, 1], PointSize[0.04402154174170894], Opacity[
    0.4], PointBox[{{0.19949035700972823`, -0.07779120469417498}}]}, 
   {Hue[0.09584564050295574, 1, 1], PointSize[0.0849318377624943], Opacity[
    0.4], PointBox[{{0.9545272246074977, -0.059752900841813616`}}]}, 
   {Hue[0.20078444564949005`, 1, 1], PointSize[0.025944768588764988`], 
    Opacity[0.4], PointBox[{{-0.5496304941186061, -0.7133490532064568}}]}, 
   {Hue[0.22047334354717463`, 1, 1], PointSize[0.08168134054578924], Opacity[
    0.4], PointBox[{{0.23680137501807824`, 0.339693949388892}}]}, 
   {Hue[0.6696922114996129, 1, 1], PointSize[0.03134249219404908], Opacity[
    0.4], PointBox[{{-0.3888232743021222, 0.23852393149869228`}}]}, 
   {Hue[0.18738348886462441`, 1, 1], PointSize[0.064508874522194], Opacity[
    0.4], PointBox[{{0.6136198507152802, 0.8274421041653035}}]}, 
   {Hue[0.676733806628067, 1, 1], PointSize[0.037931600540826435`], Opacity[
    0.4], PointBox[{{1.6356711632471381`, -2.627463588105211}}]}, 
   {Hue[0.9211589596904117, 1, 1], PointSize[0.0166919726919718], Opacity[
    0.4], PointBox[{{-0.38683828161920664`, 0.930173761310268}}]}, 
   {Hue[0.9106160245257491, 1, 1], PointSize[0.030851646366098537`], Opacity[
    0.4], PointBox[{{-0.277883833640882, -0.693908648531871}}]}, 
   {Hue[0.7765635518699039, 1, 1], PointSize[0.05237194130464892], Opacity[
    0.4], PointBox[{{-1.8746875055738232`, 0.25424637695185376`}}]}, 
   {Hue[0.5808238187591597, 1, 1], PointSize[0.03132618830764562], Opacity[
    0.4], PointBox[{{0.28892335748986575`, 0.9072125658778901}}]}, 
   {Hue[0.8498271994233815, 1, 1], PointSize[0.02476886167095671], Opacity[
    0.4], PointBox[{{1.0078303635749464`, -0.4014044914299663}}]}, 
   {Hue[0.8083829469421089, 1, 1], PointSize[0.08815619123149868], Opacity[
    0.4], PointBox[{{-0.9218871312750854, 0.213445253174625}}]}, 
   {Hue[0.4748238225201642, 1, 1], PointSize[0.026371756404095753`], Opacity[
    0.4], PointBox[{{1.7031475832810323`, -0.37717164160797156`}}]}, 
   {Hue[0.07227090243987644, 1, 1], PointSize[0.058818456660719165`], Opacity[
    0.4], PointBox[{{-0.6856638384725205, -1.0461379697551532`}}]}, 
   {Hue[0.65426475210996, 1, 1], PointSize[0.05718754818841856], Opacity[0.4],
     PointBox[{{-1.7137200003682105`, 0.2755881199740108}}]}, 
   {Hue[0.004695887778688457, 1, 1], PointSize[0.05519227140243568], Opacity[
    0.4], PointBox[{{0.3816123841998279, -0.650337384234452}}]}, 
   {Hue[0.056172488259315756`, 1, 1], PointSize[0.030482739943832993`], 
    Opacity[0.4], PointBox[{{0.6821863260995366, -0.15616477560577194`}}]}, 
   {Hue[0.3423950424807709, 1, 1], PointSize[0.07314276126449862], Opacity[
    0.4], PointBox[{{-1.6463778101517148`, 1.3664643870077864`}}]}, 
   {Hue[0.4558466905936085, 1, 1], PointSize[0.08124061580030642], Opacity[
    0.4], PointBox[{{0.14673968745524035`, 0.9740041959098842}}]}, 
   {Hue[0.6472119486464849, 1, 1], PointSize[0.0802237662541081], Opacity[
    0.4], PointBox[{{1.9208984192401384`, -0.09292726914516451}}]}, 
   {Hue[0.7416919485968698, 1, 1], PointSize[0.05474487203247411], Opacity[
    0.4], PointBox[{{-1.9806154486165424`, 0.5700168135363688}}]}, 
   {Hue[0.25177216078189457`, 1, 1], PointSize[0.05448265645878356], Opacity[
    0.4], PointBox[{{-0.7891686315155316, 0.012065533454298259`}}]}, 
   {Hue[0.5025278534560049, 1, 1], PointSize[0.0831907434026663], Opacity[
    0.4], PointBox[{{1.846548614251835, 0.6154537807692626}}]}, 
   {Hue[0.5635911638641387, 1, 1], PointSize[0.04425256067030861], Opacity[
    0.4], PointBox[{{0.47135287294117006`, -0.5276404970363145}}]}, 
   {Hue[0.1759703228787728, 1, 1], PointSize[0.07200856505443393], Opacity[
    0.4], PointBox[{{1.2364150182177023`, 0.01999236624882987}}]}, 
   {Hue[0.399366771597899, 1, 1], PointSize[0.023697515012034723`], Opacity[
    0.4], PointBox[{{-0.5463418794493164, 0.11999030703554693`}}]}, 
   {Hue[0.06548027274454227, 1, 1], PointSize[0.0899994820813107], Opacity[
    0.4], PointBox[{{1.190306197554333, 1.2820715115375776`}}]}, 
   {Hue[0.24447065401032586`, 1, 1], PointSize[0.06883340535737753], Opacity[
    0.4], PointBox[{{1.2480171965086575`, 1.215371180250515}}]}, 
   {Hue[0.39904784724742526`, 1, 1], PointSize[0.04598733476758807], Opacity[
    0.4], PointBox[{{0.11111429572141684`, -0.9799724721399168}}]}, 
   {Hue[0.9347106174289059, 1, 1], PointSize[0.019006200652738545`], Opacity[
    0.4], PointBox[{{-0.2049811970993832, -0.7832873711004734}}]}, 
   {Hue[0.7876121964474394, 1, 1], PointSize[0.027096280718390542`], Opacity[
    0.4], PointBox[{{-0.37721859098004257`, -1.1350226493126558`}}]}, 
   {Hue[0.45564923705218785`, 1, 1], PointSize[0.05365113965592952], Opacity[
    0.4], PointBox[{{-0.14426617007223494`, -0.21797212361208174`}}]}, 
   {Hue[0.6859932274270069, 1, 1], PointSize[0.06483371910036276], Opacity[
    0.4], PointBox[{{1.3427481102736523`, -0.4493781779714962}}]}, 
   {Hue[0.45163814114061074`, 1, 1], PointSize[0.0343928365556392], Opacity[
    0.4], PointBox[{{-2.454959276888785, -0.09838942167378596}}]}, 
   {Hue[0.6851593620760124, 1, 1], PointSize[0.07579551589011374], Opacity[
    0.4], PointBox[{{1.5968087385495124`, 1.0665809633304046`}}]}, 
   {Hue[0.04207321917590723, 1, 1], PointSize[0.01801471905575286], Opacity[
    0.4], PointBox[{{0.1489605090119105, -2.237569069582632}}]}, 
   {Hue[0.030729081370018507`, 1, 1], PointSize[0.03767379300929859], Opacity[
    0.4], PointBox[{{-1.7397509049950473`, 0.024090854282692253`}}]}, 
   {Hue[0.7213641487799454, 1, 1], PointSize[0.07510838019335925], Opacity[
    0.4], PointBox[{{0.7323933147310219, 0.2738200192037755}}]}, 
   {Hue[0.624676593597965, 1, 1], PointSize[0.09544443023723431], Opacity[
    0.4], PointBox[{{-0.39628283449905227`, -0.32024444856044676`}}]}, 
   {Hue[0.6261950417986373, 1, 1], PointSize[0.07208501147682655], Opacity[
    0.4], PointBox[{{-0.7864503805502612, 0.16261192582514425`}}]}, 
   {Hue[0.35124105159929186`, 1, 1], PointSize[0.06100754634484626], Opacity[
    0.4], PointBox[{{-2.2152874521448487`, 0.43105516584570225`}}]}, 
   {Hue[0.25104538525496367`, 1, 1], PointSize[0.040213175295391354`], 
    Opacity[0.4], PointBox[{{0.21013284038438163`, 0.05313270868069139}}]}, 
   {Hue[0.7546742450232564, 1, 1], PointSize[0.0682955277996403], Opacity[
    0.4], PointBox[{{-1.147319763860759, -2.381077352318596}}]}, 
   {Hue[0.0816519484854894, 1, 1], PointSize[0.01900472925794261], Opacity[
    0.4], PointBox[{{0.8692370210674727, -1.5079355500336387`}}]}, 
   {Hue[0.25904612121873116`, 1, 1], PointSize[0.08071062954480077], Opacity[
    0.4], PointBox[{{-0.7487983624281267, -0.2956626914890744}}]}, 
   {Hue[0.661779615545949, 1, 1], PointSize[0.09870747489084641], Opacity[
    0.4], PointBox[{{-1.3478338470112277`, -1.7509885168604054`}}]}, 
   {Hue[0.40735403816167204`, 1, 1], PointSize[0.03762360814275002], Opacity[
    0.4], PointBox[{{-0.10706790626230933`, -0.12438359971475986`}}]}, 
   {Hue[0.37643459683689895`, 1, 1], PointSize[0.02743180435133276], Opacity[
    0.4], PointBox[{{-0.9834728825074068, -0.6433032580378929}}]}, 
   {Hue[0.24546399214707781`, 1, 1], PointSize[0.016383467235840277`], 
    Opacity[0.4], PointBox[{{-1.6692845836513375`, 1.525722992356183}}]}, 
   {Hue[0.7612172413335068, 1, 1], PointSize[0.08582267135512525], Opacity[
    0.4], PointBox[{{-0.4018972346065635, -1.0147003741899157`}}]}, 
   {Hue[0.7067461337283629, 1, 1], PointSize[0.015391488265555975`], Opacity[
    0.4], PointBox[{{1.5362741730158096`, 1.4991975364196894`}}]}, 
   {Hue[0.7409229365948864, 1, 1], PointSize[0.02482123833489311], Opacity[
    0.4], PointBox[{{-0.2865499336985392, -0.47768816816599563`}}]}, 
   {Hue[0.6059160312892136, 1, 1], PointSize[0.03712487045107443], Opacity[
    0.4], PointBox[{{-0.49094687154379585`, -0.04527089323349952}}]}, 
   {Hue[0.852107715337002, 1, 1], PointSize[0.0379211918901821], Opacity[0.4],
     PointBox[{{-0.6618241855043434, -1.8462055130377717`}}]}, 
   {Hue[0.9062331448892378, 1, 1], PointSize[0.08166819291527785], Opacity[
    0.4], PointBox[{{-0.029112777056819555`, 0.7258990886808385}}]}, 
   {Hue[0.6337263263664645, 1, 1], PointSize[0.029148391773583332`], Opacity[
    0.4], PointBox[{{0.9260209285357687, 0.8431679070089843}}]}, 
   {Hue[0.9497969921165561, 1, 1], PointSize[0.035840121926543456`], Opacity[
    0.4], PointBox[{{-1.5955383812507218`, -0.8593188620577266}}]}, 
   {Hue[0.4649554320593494, 1, 1], PointSize[0.08686062559651261], Opacity[
    0.4], PointBox[{{0.48500316019104583`, -0.17605004295316537`}}]}, 
   {Hue[0.5836915774495821, 1, 1], PointSize[0.02061598617261265], Opacity[
    0.4], PointBox[{{0.4848665886904282, -0.9670451136357342}}]}, 
   {Hue[0.35998929799727764`, 1, 1], PointSize[0.02885514981327035], Opacity[
    0.4], PointBox[{{-0.7090520766954117, 0.15054090082846716`}}]}, 
   {Hue[0.3233688307726972, 1, 1], PointSize[0.021163143501324103`], Opacity[
    0.4], PointBox[{{2.3037968255093544`, -0.08400918944475153}}]}, 
   {Hue[0.9511443845206575, 1, 1], PointSize[0.025743541641104817`], Opacity[
    0.4], PointBox[{{-0.8413671549944189, -1.5817261401561817`}}]}, 
   {Hue[0.5023730220364897, 1, 1], PointSize[0.043655886111087144`], Opacity[
    0.4], PointBox[{{0.49501958746928204`, 0.05873478797912847}}]}, 
   {Hue[0.44911363842119156`, 1, 1], PointSize[0.020762270798594065`], 
    Opacity[0.4], PointBox[{{0.008058386645550744, 0.1525896761738837}}]}, 
   {Hue[0.2368179307834506, 1, 1], PointSize[0.04181637277677952], Opacity[
    0.4], PointBox[{{-0.726211463593265, -1.7497498850208666`}}]}, 
   {Hue[0.13155952428556605`, 1, 1], PointSize[0.02116549048325897], Opacity[
    0.4], PointBox[{{-0.11176374139998332`, 0.20106379438255076`}}]}, 
   {Hue[0.2381179349226068, 1, 1], PointSize[0.021317296771231606`], Opacity[
    0.4], PointBox[{{-0.3925072129825214, -0.14804931878331015`}}]}, 
   {Hue[0.0694436646400951, 1, 1], PointSize[0.030301740840489158`], Opacity[
    0.4], PointBox[{{-0.37143055037750494`, 1.3801028340737234`}}]}, 
   {Hue[0.6467707207872162, 1, 1], PointSize[0.02283102337814065], Opacity[
    0.4], PointBox[{{0.05333637446481732, -1.2448933334934855`}}]}, 
   {Hue[0.7488903268068057, 1, 1], PointSize[0.07000525991999393], Opacity[
    0.4], PointBox[{{-0.738434404428376, 0.39302284566306034`}}]}, 
   {Hue[0.10315471676037902`, 1, 1], PointSize[0.09456867146814629], Opacity[
    0.4], PointBox[{{-0.45652501767847714`, 0.7925110482648129}}]}, 
   {Hue[0.4047060997380161, 1, 1], PointSize[0.039843312870561115`], Opacity[
    0.4], PointBox[{{0.16476260966514641`, 2.031382769974053}}]}, 
   {Hue[0.4982415844607526, 1, 1], PointSize[0.08323556712227648], Opacity[
    0.4], PointBox[{{0.5895368328492836, -1.5981790931027917`}}]}, 
   {Hue[0.5627495465748256, 1, 1], PointSize[0.017838396894872696`], Opacity[
    0.4], PointBox[{{0.09975782849134769, 0.29016238492973245`}}]}, 
   {Hue[0.6495935822845647, 1, 1], PointSize[0.036841612212735006`], Opacity[
    0.4], PointBox[{{-0.5593632547041694, 0.020115470597145482`}}]}, 
   {Hue[0.9236280110016433, 1, 1], PointSize[0.09817575179351926], Opacity[
    0.4], PointBox[{{-0.0876941585486801, 0.8627856316065684}}]}, 
   {Hue[0.9858671861651154, 1, 1], PointSize[0.026201410850454174`], Opacity[
    0.4], PointBox[{{-0.06845917057459444, -0.31763568286111027`}}]}, 
   {Hue[0.2366508290316489, 1, 1], PointSize[0.07462243234296423], Opacity[
    0.4], PointBox[{{0.2096499746624292, -1.457309761571983}}]}, 
   {Hue[0.8192088493494354, 1, 1], PointSize[0.08053656997863687], Opacity[
    0.4], PointBox[{{-1.2900285780131098`, 0.1602021472671184}}]}, 
   {Hue[0.36808379445538897`, 1, 1], PointSize[0.06861161532262372], Opacity[
    0.4], PointBox[{{-0.6512888595879195, -0.21493165681097387`}}]}, 
   {Hue[0.2950208077049845, 1, 1], PointSize[0.025959441492943935`], Opacity[
    0.4], PointBox[{{-0.05750008220022632, -1.3036348038632082`}}]}, 
   {Hue[0.8536288682696145, 1, 1], PointSize[0.04620984855060198], Opacity[
    0.4], PointBox[{{0.45216745558956084`, -0.8337050215810988}}]}, 
   {Hue[0.9031474386066181, 1, 1], PointSize[0.07450791457287168], Opacity[
    0.4], PointBox[{{0.9849974387192854, 0.19487086187171276`}}]}, 
   {Hue[0.27137103910093874`, 1, 1], PointSize[0.03383929478629741], Opacity[
    0.4], PointBox[{{0.0025524221669780047`, -0.34195732088920316`}}]}, 
   {Hue[0.8861983798499635, 1, 1], PointSize[0.07969234365029387], Opacity[
    0.4], PointBox[{{0.07385415394089176, -0.6627337829499192}}]}, 
   {Hue[0.5103927680698579, 1, 1], PointSize[0.030834893784744716`], Opacity[
    0.4], PointBox[{{-1.3569485026216697`, 1.1770102520823726`}}]}, 
   {Hue[0.11113235756666562`, 1, 1], PointSize[0.06821665476839617], Opacity[
    0.4], PointBox[{{-0.6151072459385863, -1.5541668399981614`}}]}, 
   {Hue[0.8161033012534789, 1, 1], PointSize[0.0739137716892421], Opacity[
    0.4], PointBox[{{-0.42450621448447384`, 0.880595155264051}}]}, 
   {Hue[0.5436684846890196, 1, 1], PointSize[0.041552249591692944`], Opacity[
    0.4], PointBox[{{-0.5731253535118569, 0.3506581359349025}}]}, 
   {Hue[0.5917569091839865, 1, 1], PointSize[0.023885734815375745`], Opacity[
    0.4], PointBox[{{0.22538632677536288`, -0.6192341836102447}}]}, 
   {Hue[0.37155600246047005`, 1, 1], PointSize[0.07229269047377904], Opacity[
    0.4], PointBox[{{-0.5290273207899006, -0.4115509049405828}}]}, 
   {Hue[0.4065494730753254, 1, 1], PointSize[0.02934398220109173], Opacity[
    0.4], PointBox[{{0.625941756815847, 0.5402570471135335}}]}, 
   {Hue[0.25188986896643195`, 1, 1], PointSize[0.09856914663873817], Opacity[
    0.4], PointBox[{{-0.04646347819199538, -1.1025838082110102`}}]}, 
   {Hue[0.3967223003018019, 1, 1], PointSize[0.03072942880368139], Opacity[
    0.4], PointBox[{{-0.6775983357025254, 3.265854223888756}}]}, 
   {Hue[0.7451651586287626, 1, 1], PointSize[0.01822763124103921], Opacity[
    0.4], PointBox[{{1.788993858354063, -0.5824450418234821}}]}, 
   {Hue[0.5888130069174986, 1, 1], PointSize[0.0959124530844471], Opacity[
    0.4], PointBox[{{1.2148255805547032`, 0.28468811264286437`}}]}, 
   {Hue[0.6030716468564374, 1, 1], PointSize[0.038342474082876374`], Opacity[
    0.4], PointBox[{{0.13129524728128658`, 1.3271809007268454`}}]}, 
   {Hue[0.7380211265537131, 1, 1], PointSize[0.06213231346370404], Opacity[
    0.4], PointBox[{{1.715298624187499, -0.7431168985768494}}]}, 
   {Hue[0.6780605423871786, 1, 1], PointSize[0.055287648650910876`], Opacity[
    0.4], PointBox[{{-0.36924526087525483`, -2.494712110252018}}]}, 
   {Hue[0.5343596242202375, 1, 1], PointSize[0.032343838422507196`], Opacity[
    0.4], PointBox[{{-0.6788131921071741, -0.6101203675925064}}]}, 
   {Hue[0.07126598482479007, 1, 1], PointSize[0.096718593900041], Opacity[
    0.4], PointBox[{{0.38962974411872575`, 1.3929009312353886`}}]}, 
   {Hue[0.3648877767307699, 1, 1], PointSize[0.09564086939755001], Opacity[
    0.4], PointBox[{{0.3627231859107766, -0.9802953928896407}}]}, 
   {Hue[0.6211645416328462, 1, 1], PointSize[0.06663451398686152], Opacity[
    0.4], PointBox[{{0.49699869324716955`, 0.8386013557809283}}]}, 
   {Hue[0.44891027301525743`, 1, 1], PointSize[0.034299398609660275`], 
    Opacity[0.4], PointBox[{{-1.2455396584984901`, -0.7207625151322545}}]}, 
   {Hue[0.2530604329347872, 1, 1], PointSize[0.02855975398184972], Opacity[
    0.4], PointBox[{{0.6111179970831282, -0.462837152565122}}]}, 
   {Hue[0.14842415077117121`, 1, 1], PointSize[0.03729849892314138], Opacity[
    0.4], PointBox[{{2.249245163140216, 1.8577760692098484`}}]}, 
   {Hue[0.19420161991563223`, 1, 1], PointSize[0.022320632516564923`], 
    Opacity[0.4], PointBox[{{-1.619437613532529, 1.0330574366119332`}}]}, 
   {Hue[0.7280619166676345, 1, 1], PointSize[0.04405913600660365], Opacity[
    0.4], PointBox[{{1.1852245293758576`, 0.006041843166925036}}]}, 
   {Hue[0.2490700698155497, 1, 1], PointSize[0.02740568410620943], Opacity[
    0.4], PointBox[{{1.2246217527806118`, 0.9014657029738191}}]}, 
   {Hue[0.7691330450636096, 1, 1], PointSize[0.026369813752207302`], Opacity[
    0.4], PointBox[{{-0.12538992733230372`, 0.46590120330109713`}}]}, 
   {Hue[0.7821342844764325, 1, 1], PointSize[0.06920567783683662], Opacity[
    0.4], PointBox[{{0.2985106193761967, -1.0490025898810695`}}]}, 
   {Hue[0.9164631487700268, 1, 1], PointSize[0.04269001468046095], Opacity[
    0.4], PointBox[{{0.7494621715467774, -1.8895335507914266`}}]}, 
   {Hue[0.9751461010147287, 1, 1], PointSize[0.06126016637181042], Opacity[
    0.4], PointBox[{{-0.8927961398565254, 0.15470773332585405`}}]}, 
   {Hue[0.741505069490398, 1, 1], PointSize[0.07178556820212079], Opacity[
    0.4], PointBox[{{0.023611174032317515`, -0.7786811110724671}}]}, 
   {Hue[0.5816878076589393, 1, 1], PointSize[0.028865165833785608`], Opacity[
    0.4], PointBox[{{0.8538944534333693, 0.29136539376946413`}}]}, 
   {Hue[0.9503870155852232, 1, 1], PointSize[0.05966250501686199], Opacity[
    0.4], PointBox[{{1.096337621423809, 1.4333940612476048`}}]}, 
   {Hue[0.6594656431878532, 1, 1], PointSize[0.051637944721828144`], Opacity[
    0.4], PointBox[{{-0.47173166313520754`, -0.0256222305182989}}]}, 
   {Hue[0.43359302816022494`, 1, 1], PointSize[0.0590103610666291], Opacity[
    0.4], PointBox[{{1.7373170541924232`, -1.126487552062224}}]}, 
   {Hue[0.8143265242425788, 1, 1], PointSize[0.017298855732203716`], Opacity[
    0.4], PointBox[{{0.43887825080977033`, -0.829419405350208}}]}, 
   {Hue[0.8573593968977047, 1, 1], PointSize[0.04056142767384614], Opacity[
    0.4], PointBox[{{-1.201509890462112, 0.8113632466411915}}]}, 
   {Hue[0.8441751935599913, 1, 1], PointSize[0.06546873124914795], Opacity[
    0.4], PointBox[{{-0.09424673727599865, 0.44540965995326504`}}]}, 
   {Hue[0.9928029982678328, 1, 1], PointSize[0.08267012979600863], Opacity[
    0.4], PointBox[{{-0.22864599251239856`, 1.848989270011348}}]}, 
   {Hue[0.1309913478894318, 1, 1], PointSize[0.08905423562924128], Opacity[
    0.4], PointBox[{{3.1403945821587618`, 0.8404072299152933}}]}, 
   {Hue[0.4646985686898355, 1, 1], PointSize[0.04090596642448466], Opacity[
    0.4], PointBox[{{-0.06740203609931882, -0.3489884506289988}}]}, 
   {Hue[0.7622105258539202, 1, 1], PointSize[0.08223663386364619], Opacity[
    0.4], PointBox[{{0.15887293158785434`, 0.2527163049059809}}]}, 
   {Hue[0.33932425007896105`, 1, 1], PointSize[0.08664260853633896], Opacity[
    0.4], PointBox[{{1.721717946848822, 0.9898796707759631}}]}, 
   {Hue[0.6788550013769432, 1, 1], PointSize[0.025597643235576006`], Opacity[
    0.4], PointBox[{{-0.8641973531397148, -0.39066820916708017`}}]}, 
   {Hue[0.3389980092202285, 1, 1], PointSize[0.05667357996704794], Opacity[
    0.4], PointBox[{{1.3666861898733242`, 0.5935500187006107}}]}, 
   {Hue[0.693915145169568, 1, 1], PointSize[0.06511518254268484], Opacity[
    0.4], PointBox[{{-0.7409043803472873, 0.7012900789605518}}]}, 
   {Hue[0.4944655946700336, 1, 1], PointSize[0.06023568868634299], Opacity[
    0.4], PointBox[{{0.23336683297894842`, 0.1932013236381463}}]}, 
   {Hue[0.14742632143370038`, 1, 1], PointSize[0.028493750778044405`], 
    Opacity[0.4], PointBox[{{0.9697548065156881, -1.177701141435239}}]}, 
   {Hue[0.8438185795068815, 1, 1], PointSize[0.07287223054905756], Opacity[
    0.4], PointBox[{{1.2078841013626114`, 0.02043413389735741}}]}, 
   {Hue[0.6532294805213641, 1, 1], PointSize[0.05056247697754174], Opacity[
    0.4], PointBox[{{0.9016622765186821, 0.05660804885462615}}]}, 
   {Hue[0.3123440691882826, 1, 1], PointSize[0.09991958674967635], Opacity[
    0.4], PointBox[{{0.19855162118527234`, 2.3254763948878048`}}]}, 
   {Hue[0.7367095336419609, 1, 1], PointSize[0.055957762323015275`], Opacity[
    0.4], PointBox[{{1.2191585297295344`, -1.2735385349877462`}}]}, 
   {Hue[0.7000584700954704, 1, 1], PointSize[0.06572543022989819], Opacity[
    0.4], PointBox[{{0.833541244428464, 1.364059187029819}}]}, 
   {Hue[0.5787741700586475, 1, 1], PointSize[0.07240077723277391], Opacity[
    0.4], PointBox[{{-0.5114655247219798, -0.46866498218537755`}}]}, 
   {Hue[0.49848371896631005`, 1, 1], PointSize[0.055959887382420886`], 
    Opacity[0.4], PointBox[{{-0.5879501449964148, 0.4377646655747699}}]}, 
   {Hue[0.34585616158319366`, 1, 1], PointSize[0.07643380894032875], Opacity[
    0.4], PointBox[{{-0.8667181537392533, -0.25763296389248624`}}]}, 
   {Hue[0.016947256477441552`, 1, 1], PointSize[0.09521193932476604], Opacity[
    0.4], PointBox[{{0.3431080356875577, -0.7504908491709181}}]}, 
   {Hue[0.7179230106171466, 1, 1], PointSize[0.03319962568646874], Opacity[
    0.4], PointBox[{{-0.6680530016777181, -0.4940094588060051}}]}, 
   {Hue[0.5129026723390904, 1, 1], PointSize[0.06695962911533226], Opacity[
    0.4], PointBox[{{0.1352958276836651, 0.6186054260968188}}]}, 
   {Hue[0.8025326221386913, 1, 1], PointSize[0.06064010575606932], Opacity[
    0.4], PointBox[{{-0.31916061216908026`, -1.003499799624001}}]}, 
   {Hue[0.7372314526029096, 1, 1], PointSize[0.015293160936081199`], Opacity[
    0.4], PointBox[{{-0.13404714147100957`, -0.03536919922987838}}]}, 
   {Hue[0.01805301064671494, 1, 1], PointSize[0.03768360867144745], Opacity[
    0.4], PointBox[{{1.602126871015966, 1.2047059311779662`}}]}, 
   {Hue[0.06738772201961463, 1, 1], PointSize[0.048257525763456516`], Opacity[
    0.4], PointBox[{{-0.9272716155042361, -0.2752882952697368}}]}, 
   {Hue[0.18888649030717275`, 1, 1], PointSize[0.023081813213788105`], 
    Opacity[0.4], PointBox[{{0.3527894820959354, 0.15374194961137805`}}]}, 
   {Hue[0.9345996459514583, 1, 1], PointSize[0.07810203045488565], Opacity[
    0.4], PointBox[{{1.5927674422692275`, -0.39404350276983174`}}]}, 
   {Hue[0.16094271809862248`, 1, 1], PointSize[0.05657607391307634], Opacity[
    0.4], PointBox[{{-0.2643187522285519, -0.8570029273167244}}]}, 
   {Hue[0.7533518648943702, 1, 1], PointSize[0.07898444279329261], Opacity[
    0.4], PointBox[{{0.7342228518969691, 1.3290332915111212`}}]}, 
   {Hue[0.11370509967594744`, 1, 1], PointSize[0.04165282491041106], Opacity[
    0.4], PointBox[{{0.6766663548453069, -1.6557426773690826`}}]}, 
   {Hue[0.4957207586618251, 1, 1], PointSize[0.03508649858967813], Opacity[
    0.4], PointBox[{{1.425050442241228, -1.0488736138754942`}}]}, 
   {Hue[0.5641865868506455, 1, 1], PointSize[0.011925429736947518`], Opacity[
    0.4], PointBox[{{1.1982200433448402`, -0.08836756982686485}}]}, 
   {Hue[0.7333403930286233, 1, 1], PointSize[0.09854223983680593], Opacity[
    0.4], PointBox[{{-0.034783869817775946`, -2.181363300935552}}]}, 
   {Hue[0.8684647387961266, 1, 1], PointSize[0.05604153800174361], Opacity[
    0.4], PointBox[{{-0.5446316658543437, 0.2158021436182234}}]}, 
   {Hue[0.6827772878818616, 1, 1], PointSize[0.040493202282464905`], Opacity[
    0.4], PointBox[{{-0.9163608123343285, -0.9776522129375647}}]}, 
   {Hue[0.8771331884456024, 1, 1], PointSize[0.09670040639255317], Opacity[
    0.4], PointBox[{{-1.8425164375499488`, 0.27688340330888284`}}]}, 
   {Hue[0.2611512183870621, 1, 1], PointSize[0.019898860423441106`], Opacity[
    0.4], PointBox[{{0.45677035758386203`, -0.5657626000221055}}]}, 
   {Hue[0.3476258846579816, 1, 1], PointSize[0.08526826184515462], Opacity[
    0.4], PointBox[{{-2.0191724417076604`, -0.5609516333983192}}]}, 
   {Hue[0.865853828256282, 1, 1], PointSize[0.038724191730392335`], Opacity[
    0.4], PointBox[{{0.15890442383057754`, -0.4706046825822793}}]}, 
   {Hue[0.28599248988057946`, 1, 1], PointSize[0.09371140755375443], Opacity[
    0.4], PointBox[{{0.557054045017291, 0.5599121091464212}}]}, 
   {Hue[0.6821179799772152, 1, 1], PointSize[0.08880761050590502], Opacity[
    0.4], PointBox[{{-0.6254691927016188, -0.6504126872668954}}]}, 
   {Hue[0.5261833178370174, 1, 1], PointSize[0.05393795970142201], Opacity[
    0.4], PointBox[{{-0.14611181630809672`, -2.1571107880151463`}}]}, 
   {Hue[0.1477635387163132, 1, 1], PointSize[0.08002015612606622], Opacity[
    0.4], PointBox[{{-0.33255010046542505`, -2.241119689705026}}]}, 
   {Hue[0.011491890362654411`, 1, 1], PointSize[0.044874718461745886`], 
    Opacity[0.4], PointBox[{{1.7575866835103848`, -0.03273434657299873}}]}, 
   {Hue[0.9852616648745078, 1, 1], PointSize[0.09325927924400937], Opacity[
    0.4], PointBox[{{0.1967873165332638, 0.3766946053281073}}]}, 
   {Hue[0.9386223666003692, 1, 1], PointSize[0.08237713021690973], Opacity[
    0.4], PointBox[{{-0.025393424176115252`, 0.2932952388523273}}]}, 
   {Hue[0.12316119233725087`, 1, 1], PointSize[0.08075209944432721], Opacity[
    0.4], PointBox[{{-1.4953866865435002`, -0.0014201243964789287`}}]}, 
   {Hue[0.24343454799712672`, 1, 1], PointSize[0.023353965445029642`], 
    Opacity[0.4], PointBox[{{0.11719783227089713`, -0.5805522538795908}}]}, 
   {Hue[0.49337084768663453`, 1, 1], PointSize[0.08146420034411439], Opacity[
    0.4], PointBox[{{-0.7750655088682458, 1.0183927851236219`}}]}, 
   {Hue[0.25224257908329006`, 1, 1], PointSize[0.04660747761653297], Opacity[
    0.4], PointBox[{{1.8568151967886073`, 0.01135839011168706}}]}, 
   {Hue[0.4513859577815853, 1, 1], PointSize[0.06304004465914656], Opacity[
    0.4], PointBox[{{0.5529995484130256, 1.8935483525142394`}}]}, 
   {Hue[0.5623567373166474, 1, 1], PointSize[0.0889830236411294], Opacity[
    0.4], PointBox[{{0.9840771687054628, -2.295079077282175}}]}, 
   {Hue[0.25725284720825803`, 1, 1], PointSize[0.08757768162789037], Opacity[
    0.4], PointBox[{{-0.27467752905151416`, 0.6223296525034707}}]}, 
   {Hue[0.28690115690340856`, 1, 1], PointSize[0.038368545377126764`], 
    Opacity[0.4], PointBox[{{-1.3116051901923746`, 0.9240026599159633}}]}, 
   {Hue[0.9542313416299559, 1, 1], PointSize[0.050495467111911496`], Opacity[
    0.4], PointBox[{{1.4874590323667383`, 0.5031262373831508}}]}, 
   {Hue[0.585450673521523, 1, 1], PointSize[0.05981175936025521], Opacity[
    0.4], PointBox[{{-2.5415144277879174`, -0.4170213821582056}}]}, 
   {Hue[0.4479672691656942, 1, 1], PointSize[0.07333211314857746], Opacity[
    0.4], PointBox[{{-0.8439681450060763, -0.6955045097192928}}]}, 
   {Hue[0.8287191722738945, 1, 1], PointSize[0.08910969382347808], Opacity[
    0.4], PointBox[{{0.11682078521361962`, 0.17102526963348835`}}]}, 
   {Hue[0.6866390771659321, 1, 1], PointSize[0.06811747765183704], Opacity[
    0.4], PointBox[{{-1.65635969734933, -0.7014412932275557}}]}, 
   {Hue[0.8733101886453758, 1, 1], PointSize[0.09130737509445083], Opacity[
    0.4], PointBox[{{0.7829843302440697, -0.9579828195151578}}]}, 
   {Hue[0.4518217520061736, 1, 1], PointSize[0.017715253525287425`], Opacity[
    0.4], PointBox[{{0.6578220449289867, 0.15238330251826362`}}]}, 
   {Hue[0.1545468844190725, 1, 1], PointSize[0.09885448607234001], Opacity[
    0.4], PointBox[{{-0.000877476971524499, 0.8247802013576228}}]}, 
   {Hue[0.7515794651218193, 1, 1], PointSize[0.06582903579187402], Opacity[
    0.4], PointBox[{{-0.06401572413892193, 0.8613513157136912}}]}, 
   {Hue[0.20070100934388946`, 1, 1], PointSize[0.05938550222306116], Opacity[
    0.4], PointBox[{{-1.372274504189105, 0.28800226262380196`}}]}, 
   {Hue[0.03705385726683463, 1, 1], PointSize[0.030049084638304233`], Opacity[
    0.4], PointBox[{{0.5587157350230166, -0.5101030181284538}}]}, 
   {Hue[0.2452913624314197, 1, 1], PointSize[0.034603615306127475`], Opacity[
    0.4], PointBox[{{0.9606117856549453, 0.9515492581328289}}]}, 
   {Hue[0.7078787256027892, 1, 1], PointSize[0.020504953085250868`], Opacity[
    0.4], PointBox[{{0.08664969826398682, 0.6838474336041347}}]}, 
   {Hue[0.8846912036885164, 1, 1], PointSize[0.09588832391017515], Opacity[
    0.4], PointBox[{{0.270401812831372, 1.6443467300785533`}}]}, 
   {Hue[0.5801206883792722, 1, 1], PointSize[0.06059014824151529], Opacity[
    0.4], PointBox[{{-0.7906715910392684, -0.16619060080941267`}}]}, 
   {Hue[0.29289777194226607`, 1, 1], PointSize[0.08021088662298662], Opacity[
    0.4], PointBox[{{0.9094819298799234, -0.31096791278940167`}}]}, 
   {Hue[0.8537170837966586, 1, 1], PointSize[0.06750397887663889], Opacity[
    0.4], PointBox[{{-0.4819766523582697, -1.874912263955966}}]}, 
   {Hue[0.9521802961060031, 1, 1], PointSize[0.015824268901968433`], Opacity[
    0.4], PointBox[{{-0.6546684685013398, 1.4251133195542536`}}]}, 
   {Hue[0.1362817529878999, 1, 1], PointSize[0.08307114449169481], Opacity[
    0.4], PointBox[{{-0.5723394753121657, 1.9131620387591406`}}]}, 
   {Hue[0.08145297992878309, 1, 1], PointSize[0.08102152492830925], Opacity[
    0.4], PointBox[{{1.430729354435809, 1.2893227583623075`}}]}, 
   {Hue[0.5710790753054893, 1, 1], PointSize[0.020572965758791806`], Opacity[
    0.4], PointBox[{{1.3465098652355498`, -2.3772734577713783`}}]}, 
   {Hue[0.3156233405326767, 1, 1], PointSize[0.06505546587856084], Opacity[
    0.4], PointBox[{{0.7125471838254296, 0.9000479602167492}}]}, 
   {Hue[0.5248128684985616, 1, 1], PointSize[0.09532807652719269], Opacity[
    0.4], PointBox[{{-0.09132401443361599, 1.5711202565230995`}}]}, 
   {Hue[0.3534865232497839, 1, 1], PointSize[0.08643321155765682], Opacity[
    0.4], PointBox[{{2.8201424227616627`, -0.9753216279884146}}]}, 
   {Hue[0.7219422400901576, 1, 1], PointSize[0.08172027339739865], Opacity[
    0.4], PointBox[{{0.8067956727005292, -0.14199639353902288`}}]}, 
   {Hue[0.7342732730980652, 1, 1], PointSize[0.04300571241921296], Opacity[
    0.4], PointBox[{{-0.46131002541838784`, -0.367373135839407}}]}, 
   {Hue[0.22220742925050962`, 1, 1], PointSize[0.048193995874452555`], 
    Opacity[0.4], PointBox[{{0.48507977285701354`, -0.9841381026180561}}]}, 
   {Hue[0.8867250209864708, 1, 1], PointSize[0.09394399916023033], Opacity[
    0.4], PointBox[{{-0.7682766471770821, -0.4464556025404563}}]}, 
   {Hue[0.012307352373513103`, 1, 1], PointSize[0.06129679090601389], Opacity[
    0.4], PointBox[{{-0.9958025730299161, -1.6457144722209176`}}]}, 
   {Hue[0.021858506457901994`, 1, 1], PointSize[0.08956120277337734], Opacity[
    0.4], PointBox[{{1.5507686634929212`, 0.8359636414479785}}]}, 
   {Hue[0.8618521469262168, 1, 1], PointSize[0.06919911092383854], Opacity[
    0.4], PointBox[{{-0.21061332695171744`, 0.8771937211598662}}]}, 
   {Hue[0.16300237281045504`, 1, 1], PointSize[0.04966278415317038], Opacity[
    0.4], PointBox[{{0.016342974721040314`, -0.7350407914904613}}]}, 
   {Hue[0.7926334119224072, 1, 1], PointSize[0.08281454725066856], Opacity[
    0.4], PointBox[{{-0.2154314367739129, -1.1125131307957203`}}]}, 
   {Hue[0.30664097516781696`, 1, 1], PointSize[0.02965776679481842], Opacity[
    0.4], PointBox[{{1.2065979569834446`, -0.31106390497516845`}}]}, 
   {Hue[0.5287668639470064, 1, 1], PointSize[0.052217927681961596`], Opacity[
    0.4], PointBox[{{2.348126369549135, -0.43285918901005355`}}]}, 
   {Hue[0.45179961081487274`, 1, 1], PointSize[0.028290915674874517`], 
    Opacity[0.4], PointBox[{{-0.1436379861438332, -1.7289575554335903`}}]}, 
   {Hue[0.06028146747642782, 1, 1], PointSize[0.04060326833581282], Opacity[
    0.4], PointBox[{{-1.711806027999948, 1.4120932916084863`}}]}, 
   {Hue[0.8442642220504144, 1, 1], PointSize[0.011208960805378393`], Opacity[
    0.4], PointBox[{{-0.9711264588513102, 0.07051827334057835}}]}, 
   {Hue[0.30543574760746783`, 1, 1], PointSize[0.049898903686601354`], 
    Opacity[0.4], PointBox[{{1.2852505237312633`, -0.9460935798089588}}]}, 
   {Hue[0.5771199893628893, 1, 1], PointSize[0.016088079869589628`], Opacity[
    0.4], PointBox[{{-0.7343048410931403, 0.611506532818159}}]}, 
   {Hue[0.4159892330876134, 1, 1], PointSize[0.033518107391357854`], Opacity[
    0.4], PointBox[{{1.749304032665773, -0.5115414339506492}}]}, 
   {Hue[0.18147464050514373`, 1, 1], PointSize[0.052058718329880516`], 
    Opacity[0.4], 
    PointBox[{{-1.9767285730478563`, -0.28372289866969264`}}]}, 
   {Hue[0.4324463629724016, 1, 1], PointSize[0.03502321263038756], Opacity[
    0.4], PointBox[{{0.09687730246243625, 1.7714580985546036`}}]}, 
   {Hue[0.14343413774192038`, 1, 1], PointSize[0.021419832954418183`], 
    Opacity[0.4], PointBox[{{0.35029993746683147`, -0.2645000260702577}}]}, 
   {Hue[0.2179422389789678, 1, 1], PointSize[0.07385817752347074], Opacity[
    0.4], PointBox[{{-0.5016477781280144, 0.4749471029539055}}]}, 
   {Hue[0.9844113283310025, 1, 1], PointSize[0.0561640567720022], Opacity[
    0.4], PointBox[{{-0.4483798863061959, 0.30981984065723484`}}]}, 
   {Hue[0.0011885422873842977`, 1, 1], PointSize[0.08442252117762147], 
    Opacity[0.4], PointBox[{{1.4224888391542916`, 0.736661066377951}}]}, 
   {Hue[0.2596497311519401, 1, 1], PointSize[0.08214622599650642], Opacity[
    0.4], PointBox[{{0.06398039885228095, 0.9318481789007244}}]}, 
   {Hue[0.46910694177793966`, 1, 1], PointSize[0.08834457418653796], Opacity[
    0.4], PointBox[{{-1.3089864503073767`, -1.5099037125111732`}}]}, 
   {Hue[0.5629060493159825, 1, 1], PointSize[0.03680802077512209], Opacity[
    0.4], PointBox[{{1.022437993264551, 0.9692105227836152}}]}, 
   {Hue[0.775414772850737, 1, 1], PointSize[0.050273182324132026`], Opacity[
    0.4], PointBox[{{-1.3062276813821647`, -0.13876007715422797`}}]}, 
   {Hue[0.4220441322983406, 1, 1], PointSize[0.036159326391111066`], Opacity[
    0.4], PointBox[{{-1.161008756366112, 0.041092127923280215`}}]}, 
   {Hue[0.21359248485038584`, 1, 1], PointSize[0.06768250211490937], Opacity[
    0.4], PointBox[{{0.8392028021417023, 0.07806384857639727}}]}, 
   {Hue[0.45814438151235604`, 1, 1], PointSize[0.08887582161152646], Opacity[
    0.4], PointBox[{{0.508935391350927, -0.06050966881678514}}]}, 
   {Hue[0.35004932703506886`, 1, 1], PointSize[0.0836484570626072], Opacity[
    0.4], PointBox[{{-0.464848383436644, 0.8598397052230276}}]}, 
   {Hue[0.07209595715589034, 1, 1], PointSize[0.035284812108984626`], Opacity[
    0.4], PointBox[{{1.1117877994687868`, 0.5766235256912361}}]}, 
   {Hue[0.3137819052755344, 1, 1], PointSize[0.031420670789183994`], Opacity[
    0.4], PointBox[{{0.5330612209225759, 1.233430205321172}}]}, 
   {Hue[0.010568317786652903`, 1, 1], PointSize[0.07263306631482527], Opacity[
    0.4], PointBox[{{2.25236868408446, 0.5381000479742968}}]}, 
   {Hue[0.544127832833619, 1, 1], PointSize[0.023621790156614822`], Opacity[
    0.4], PointBox[{{0.8218533088093117, -0.1240465292762435}}]}, 
   {Hue[0.22982965181545212`, 1, 1], PointSize[0.06771324527882192], Opacity[
    0.4], PointBox[{{-0.9157831289848217, -1.435867077131908}}]}, 
   {Hue[0.8567244592745007, 1, 1], PointSize[0.08404639966242869], Opacity[
    0.4], PointBox[{{0.9915532632803534, -0.4697398583469626}}]}, 
   {Hue[0.7968075628412068, 1, 1], PointSize[0.015578065337430197`], Opacity[
    0.4], PointBox[{{0.4297449825480591, -0.8533296602906489}}]}, 
   {Hue[0.7360081959516647, 1, 1], PointSize[0.045276296650753], Opacity[0.4],
     PointBox[{{0.3832187786329566, 0.573147282355348}}]}, 
   {Hue[0.7143777242156708, 1, 1], PointSize[0.07994455538628678], Opacity[
    0.4], PointBox[{{1.5956505199524709`, -0.19659886802065643`}}]}, 
   {Hue[0.441190417326067, 1, 1], PointSize[0.06179139304436812], Opacity[
    0.4], PointBox[{{0.6480005077412622, 1.6459032694447218`}}]}, 
   {Hue[0.5463526733428858, 1, 1], PointSize[0.0332304476129089], Opacity[
    0.4], PointBox[{{-1.445471156489078, -0.4116742448897253}}]}, 
   {Hue[0.6328232141312866, 1, 1], PointSize[0.020526615248981098`], Opacity[
    0.4], PointBox[{{1.1171573947057127`, -1.8471886331890381`}}]}, 
   {Hue[0.15371540922668014`, 1, 1], PointSize[0.07015132433451685], Opacity[
    0.4], PointBox[{{-0.0874704385470292, -0.6552977292241118}}]}, 
   {Hue[0.7342135685137827, 1, 1], PointSize[0.02864782317948071], Opacity[
    0.4], PointBox[{{1.715183133324813, 1.5732567615485817`}}]}, 
   {Hue[0.9560173250114736, 1, 1], PointSize[0.01468399402216708], Opacity[
    0.4], PointBox[{{1.6626385818496, 1.7191625189544517`}}]}, 
   {Hue[0.5543854924991187, 1, 1], PointSize[0.028389964760788478`], Opacity[
    0.4], PointBox[{{-0.07799251465859704, 0.49706775749089005`}}]}, 
   {Hue[0.5193003380066881, 1, 1], PointSize[0.047057454651146496`], Opacity[
    0.4], PointBox[{{0.2112984929226338, -0.18069279533501814`}}]}, 
   {Hue[0.11105061581977127`, 1, 1], PointSize[0.08414174556798559], Opacity[
    0.4], PointBox[{{-1.3929434418768551`, -1.3359622237315485`}}]}, 
   {Hue[0.3407720990808438, 1, 1], PointSize[0.052397282969625175`], Opacity[
    0.4], PointBox[{{0.9941828525707079, -0.11862580282107994`}}]}, 
   {Hue[0.23922264030275153`, 1, 1], PointSize[0.09133206217140963], Opacity[
    0.4], PointBox[{{-0.22641109518834077`, 0.33910697070349977`}}]}, 
   {Hue[0.3722823849688819, 1, 1], PointSize[0.016327246863164904`], Opacity[
    0.4], PointBox[{{-0.72222268775975, 1.5496297614723629`}}]}, 
   {Hue[0.049850420165583165`, 1, 1], PointSize[0.073889052132834], Opacity[
    0.4], PointBox[{{1.247809525967635, -2.0782630246887277`}}]}, 
   {Hue[0.39811243687697484`, 1, 1], PointSize[0.09077561100464165], Opacity[
    0.4], PointBox[{{-1.367194981095675, -1.3530282692506492`}}]}, 
   {Hue[0.7580781678685324, 1, 1], PointSize[0.036053294886812776`], Opacity[
    0.4], PointBox[{{0.9711769854397299, -0.633255857661007}}]}, 
   {Hue[0.2382061748819677, 1, 1], PointSize[0.04805704792877463], Opacity[
    0.4], PointBox[{{-1.4227071766993578`, -1.098582604750759}}]}, 
   {Hue[0.055214332622617324`, 1, 1], PointSize[0.08847037500509675], Opacity[
    0.4], PointBox[{{0.25449365066361457`, 0.5990115179259393}}]}, 
   {Hue[0.045455286191103506`, 1, 1], PointSize[0.09164942173241622], Opacity[
    0.4], PointBox[{{0.8759417008077565, -1.1398387435416086`}}]}, 
   {Hue[0.8546712557531473, 1, 1], PointSize[0.06657280934141427], Opacity[
    0.4], PointBox[{{-0.3496665280213816, 1.1463715852698322`}}]}, 
   {Hue[0.47479217672240814`, 1, 1], PointSize[0.05911617041647538], Opacity[
    0.4], PointBox[{{0.7232857870135453, -0.44411469628224537`}}]}, 
   {Hue[0.909853855109299, 1, 1], PointSize[0.025706973718436735`], Opacity[
    0.4], PointBox[{{1.108481081511204, -0.9520663046342132}}]}, 
   {Hue[0.982177929240144, 1, 1], PointSize[0.031472493796187356`], Opacity[
    0.4], PointBox[{{1.9638241492208601`, -1.4904751012745912`}}]}, 
   {Hue[0.23990598390372098`, 1, 1], PointSize[0.049167344871158314`], 
    Opacity[0.4], PointBox[{{-2.312691580748934, -1.091295008612276}}]}, 
   {Hue[0.6163412656001148, 1, 1], PointSize[0.09874543633508273], Opacity[
    0.4], PointBox[{{0.49294687494293266`, 1.9593608862437406`}}]}, 
   {Hue[0.3603651003215895, 1, 1], PointSize[0.05659696595255939], Opacity[
    0.4], PointBox[{{0.9706427844804205, -0.9950185760689427}}]}, 
   {Hue[0.28639992965301886`, 1, 1], PointSize[0.050632438200458985`], 
    Opacity[0.4], PointBox[{{0.25467164897164735`, -1.302761244013107}}]}, 
   {Hue[0.18435962000810924`, 1, 1], PointSize[0.03835540655104887], Opacity[
    0.4], PointBox[{{-0.2862058726382244, 0.0294317427309401}}]}, 
   {Hue[0.9967598779086102, 1, 1], PointSize[0.057244897321106214`], Opacity[
    0.4], PointBox[{{0.8717385036947083, 1.2474500934034702`}}]}, 
   {Hue[0.7481340601489024, 1, 1], PointSize[0.055068618689000925`], Opacity[
    0.4], PointBox[{{1.3917875139146823`, 1.16554803769599}}]}, 
   {Hue[0.840752871332701, 1, 1], PointSize[0.09644706883066531], Opacity[
    0.4], PointBox[{{1.4667356160739573`, 0.26111069162888667`}}]}, 
   {Hue[0.32612651170280205`, 1, 1], PointSize[0.07277214854873046], Opacity[
    0.4], PointBox[{{0.667676759944486, -0.7093761702001761}}]}, 
   {Hue[0.024826708923121554`, 1, 1], PointSize[0.04329362534386401], Opacity[
    0.4], PointBox[{{0.13635792743298994`, 2.303036371899562}}]}, 
   {Hue[0.542735486240955, 1, 1], PointSize[0.01052466013824628], Opacity[
    0.4], PointBox[{{2.307232820730109, -1.257487813765419}}]}, 
   {Hue[0.9465417106434859, 1, 1], PointSize[0.022259457148614478`], Opacity[
    0.4], PointBox[{{-1.4883537020448998`, -1.301464668452633}}]}, 
   {Hue[0.5900907353811071, 1, 1], PointSize[0.06024271731469394], Opacity[
    0.4], PointBox[{{1.2632049430204617`, 0.1144637940908975}}]}, 
   {Hue[0.05411549099088786, 1, 1], PointSize[0.02101056985621988], Opacity[
    0.4], PointBox[{{0.25572141380904634`, -1.0191399302763793`}}]}, 
   {Hue[0.417039624250114, 1, 1], PointSize[0.0804305243708853], Opacity[0.4],
     PointBox[{{0.8466361885031747, -0.36924071443131845`}}]}, 
   {Hue[0.23485037075568194`, 1, 1], PointSize[0.058677076807768486`], 
    Opacity[0.4], PointBox[{{0.5027657854922835, -1.1646157809581268`}}]}, 
   {Hue[0.3037132538897036, 1, 1], PointSize[0.06298257321246112], Opacity[
    0.4], PointBox[{{1.2633602857037423`, -0.1613170684780861}}]}, 
   {Hue[0.9621665367356955, 1, 1], PointSize[0.05672654949089043], Opacity[
    0.4], PointBox[{{1.1412389916409815`, 0.0518266459409209}}]}, 
   {Hue[0.7432861947660772, 1, 1], PointSize[0.05832015453033204], Opacity[
    0.4], PointBox[{{0.9954756267686445, -0.49663279762218576`}}]}, 
   {Hue[0.5839153942441007, 1, 1], PointSize[0.03017716245441872], Opacity[
    0.4], PointBox[{{0.3712665698467902, -0.3535620026241931}}]}, 
   {Hue[0.15678676939446, 1, 1], PointSize[0.03919776491482363], Opacity[0.4],
     PointBox[{{0.24494584979733264`, 0.19752581390475119`}}]}, 
   {Hue[0.2979445817980939, 1, 1], PointSize[0.027950702988388643`], Opacity[
    0.4], PointBox[{{0.8617017858797529, -0.13448769172867278`}}]}, 
   {Hue[0.7625662038963359, 1, 1], PointSize[0.06359642604665505], Opacity[
    0.4], PointBox[{{-2.3342504521117804`, 1.2224917202299228`}}]}, 
   {Hue[0.12208183019158714`, 1, 1], PointSize[0.04486108647125854], Opacity[
    0.4], PointBox[{{-0.06396668568810215, 1.47532691946919}}]}, 
   {Hue[0.5742161480378338, 1, 1], PointSize[0.05682891284824765], Opacity[
    0.4], PointBox[{{-1.2223609353440652`, 0.17110978712241648`}}]}, 
   {Hue[0.8381945857800697, 1, 1], PointSize[0.04221704331659476], Opacity[
    0.4], PointBox[{{0.1858278633602676, -0.13160709222829606`}}]}, 
   {Hue[0.09365921189648696, 1, 1], PointSize[0.0768182441465059], Opacity[
    0.4], PointBox[{{-0.31831739394007197`, -0.564468565647715}}]}, 
   {Hue[0.27225759199956046`, 1, 1], PointSize[0.05849592041569493], Opacity[
    0.4], PointBox[{{-0.04711314246428917, 1.496431118632478}}]}, 
   {Hue[0.6990179089255941, 1, 1], PointSize[0.07880638903169737], Opacity[
    0.4], PointBox[{{-0.11409869589927608`, 0.1143119884060728}}]}, 
   {Hue[0.8914851167730011, 1, 1], PointSize[0.08050507850793776], Opacity[
    0.4], PointBox[{{-1.2111010287760888`, 0.4765164328101445}}]}, 
   {Hue[0.6022229423827754, 1, 1], PointSize[0.01567603951912039], Opacity[
    0.4], PointBox[{{0.725107020607229, 0.854963156541325}}]}, 
   {Hue[0.5919178384617996, 1, 1], PointSize[0.05957577020900545], Opacity[
    0.4], PointBox[{{0.7047122704799196, -0.7771777272512436}}]}, 
   {Hue[0.4773315154721909, 1, 1], PointSize[0.037386104083141455`], Opacity[
    0.4], PointBox[{{1.1043154809584925`, -0.40368684265365196`}}]}, 
   {Hue[0.6154098173092575, 1, 1], PointSize[0.07710394339767793], Opacity[
    0.4], PointBox[{{0.1283197772460175, -0.21822341573477586`}}]}, 
   {Hue[0.7737630311243151, 1, 1], PointSize[0.013576266489318811`], Opacity[
    0.4], PointBox[{{0.6418552860842635, 0.3147398130042158}}]}, 
   {Hue[0.8759767241311589, 1, 1], PointSize[0.020181529385551164`], Opacity[
    0.4], PointBox[{{0.19748636589283036`, -0.9073914471984559}}]}, 
   {Hue[0.6547152397543161, 1, 1], PointSize[0.018098377204160895`], Opacity[
    0.4], PointBox[{{0.33850557182702024`, 0.13797102987848697`}}]}, 
   {Hue[0.7750861630615098, 1, 1], PointSize[0.04051813908327884], Opacity[
    0.4], PointBox[{{-0.1093303741995154, 0.3793231833210986}}]}, 
   {Hue[0.2066099282079612, 1, 1], PointSize[0.05525086273294055], Opacity[
    0.4], PointBox[{{0.051682935484194614`, -0.7407351959902241}}]}, 
   {Hue[0.6016638705043575, 1, 1], PointSize[0.0649881483316816], Opacity[
    0.4], PointBox[{{1.342434369910042, -0.7781658438538752}}]}, 
   {Hue[0.8062403662559625, 1, 1], PointSize[0.05122344688622732], Opacity[
    0.4], PointBox[{{-1.0810276256341318`, 0.4707891483947131}}]}, 
   {Hue[0.8958248191813021, 1, 1], PointSize[0.05338451537357025], Opacity[
    0.4], PointBox[{{0.09213962555932706, 1.0072676343216385`}}]}, 
   {Hue[0.10833709726041651`, 1, 1], PointSize[0.06258366783146593], Opacity[
    0.4], PointBox[{{-0.02320586947794533, -2.433729198365973}}]}, 
   {Hue[0.030027327770031365`, 1, 1], PointSize[0.06652985202919198], Opacity[
    0.4], PointBox[{{-0.083158440746234, 0.9231981278565974}}]}, 
   {Hue[0.15073244119848384`, 1, 1], PointSize[0.07964029268734701], Opacity[
    0.4], PointBox[{{-0.13962805500353012`, 0.6041136673556332}}]}, 
   {Hue[0.6948475449141447, 1, 1], PointSize[0.0703931361870341], Opacity[
    0.4], PointBox[{{1.2932998351749434`, -0.5830411620949207}}]}, 
   {Hue[0.8340516229252435, 1, 1], PointSize[0.01948788919028728], Opacity[
    0.4], PointBox[{{0.43989148769388076`, 0.15128625525501277`}}]}, 
   {Hue[0.40250532347204726`, 1, 1], PointSize[0.028978188798132493`], 
    Opacity[0.4], PointBox[{{-0.5085546974343256, 0.7883841466755848}}]}, 
   {Hue[0.7261612132739372, 1, 1], PointSize[0.07272298648021941], Opacity[
    0.4], PointBox[{{0.3235344600128313, -0.6242195825951474}}]}, 
   {Hue[0.16693976386645315`, 1, 1], PointSize[0.022194283738844328`], 
    Opacity[0.4], PointBox[{{1.3856786321992394`, -2.1638478104584307`}}]}, 
   {Hue[0.2325595947973076, 1, 1], PointSize[0.07504601764876548], Opacity[
    0.4], PointBox[{{2.8974496450326708`, 0.7545299664884476}}]}, 
   {Hue[0.49488850067839407`, 1, 1], PointSize[0.07110887006244324], Opacity[
    0.4], PointBox[{{0.35264657029545116`, -0.023234163009086286`}}]}, 
   {Hue[0.1607218366203773, 1, 1], PointSize[0.047681483345550724`], Opacity[
    0.4], PointBox[{{0.5234344024874296, 1.631483130514469}}]}, 
   {Hue[0.2960375942801199, 1, 1], PointSize[0.02782393338821461], Opacity[
    0.4], PointBox[{{0.6509481207112976, -0.4442305631730127}}]}, 
   {Hue[0.4334510446620303, 1, 1], PointSize[0.02192669618982454], Opacity[
    0.4], PointBox[{{0.8684094208853658, -0.7587413739522221}}]}, 
   {Hue[0.44815176077163765`, 1, 1], PointSize[0.053310485139996866`], 
    Opacity[0.4], PointBox[{{0.6249616810529859, 0.6886657978953493}}]}, 
   {Hue[0.9650055913058286, 1, 1], PointSize[0.023567830857456923`], Opacity[
    0.4], PointBox[{{-0.7573045805653907, -1.1650534812738287`}}]}, 
   {Hue[0.07552129016576137, 1, 1], PointSize[0.02393760545570907], Opacity[
    0.4], PointBox[{{0.7449024921043951, -0.7743773218432517}}]}, 
   {Hue[0.6877524989561241, 1, 1], PointSize[0.03468863587489082], Opacity[
    0.4], PointBox[{{-0.4112771546377947, 0.47366391624654397`}}]}, 
   {Hue[0.9706136935015155, 1, 1], PointSize[0.09365669546237215], Opacity[
    0.4], PointBox[{{-1.0425865978546163`, 0.6148586213679237}}]}, 
   {Hue[0.5636877226035142, 1, 1], PointSize[0.05895611567265813], Opacity[
    0.4], PointBox[{{0.4325379641633568, 1.0375145057130561`}}]}, 
   {Hue[0.5990786363611504, 1, 1], PointSize[0.06793370082088507], Opacity[
    0.4], PointBox[{{0.6320416266658411, 0.6088528823994257}}]}, 
   {Hue[0.4535081543984014, 1, 1], PointSize[0.062129463975984206`], Opacity[
    0.4], PointBox[{{-0.39743396256812835`, -1.8719951106391615`}}]}, 
   {Hue[0.3265721508343755, 1, 1], PointSize[0.03977407739443284], Opacity[
    0.4], PointBox[{{1.0788292632559264`, 0.2563411632768486}}]}, 
   {Hue[0.5319679852276735, 1, 1], PointSize[0.02080446192765764], Opacity[
    0.4], PointBox[{{-0.5882348114939788, 0.8479567700881999}}]}, 
   {Hue[0.15379892619511537`, 1, 1], PointSize[0.07773021988816894], Opacity[
    0.4], PointBox[{{-1.7382252725012897`, 0.050434215050965986`}}]}, 
   {Hue[0.3569801227768046, 1, 1], PointSize[0.02875692877629299], Opacity[
    0.4], PointBox[{{1.3046356988199452`, 0.4078902365520028}}]}, 
   {Hue[0.6346277058497389, 1, 1], PointSize[0.06166781897001378], Opacity[
    0.4], PointBox[{{0.36728177535075096`, -0.11480040247410202`}}]}, 
   {Hue[0.9875919248623972, 1, 1], PointSize[0.09863609278313618], Opacity[
    0.4], PointBox[{{-0.8113757717578313, -0.3593370053363902}}]}, 
   {Hue[0.9821399222082834, 1, 1], PointSize[0.09067517093848035], Opacity[
    0.4], PointBox[{{0.3864548896740569, -1.005202265433303}}]}, 
   {Hue[0.25577206505142147`, 1, 1], PointSize[0.03589456223208842], Opacity[
    0.4], PointBox[{{-1.9277839026330768`, -0.8701480236764649}}]}, 
   {Hue[0.694289270965684, 1, 1], PointSize[0.07617944746316846], Opacity[
    0.4], PointBox[{{-0.6248481527621709, 0.3321304638903849}}]}, 
   {Hue[0.4825533360866141, 1, 1], PointSize[0.07215315082038706], Opacity[
    0.4], PointBox[{{-1.6736969266431339`, 1.2847620589651405`}}]}, 
   {Hue[0.9174352964337273, 1, 1], PointSize[0.06520081248339299], Opacity[
    0.4], PointBox[{{0.7733023548142445, 1.6399956114286742`}}]}, 
   {Hue[0.9378862482263097, 1, 1], PointSize[0.07650325368903194], Opacity[
    0.4], PointBox[{{1.2485113763168254`, -0.47115239665367875`}}]}, 
   {Hue[0.48124409043838656`, 1, 1], PointSize[0.08802492026439104], Opacity[
    0.4], PointBox[{{0.19319023797150103`, -0.016437022323233342`}}]}, 
   {Hue[0.05579904283614501, 1, 1], PointSize[0.048536589662966895`], Opacity[
    0.4], PointBox[{{1.7822213561482003`, -0.5887502798858636}}]}, 
   {Hue[0.27177207264082637`, 1, 1], PointSize[0.07344503547021475], Opacity[
    0.4], PointBox[{{-0.6297979992909826, 0.7965583554370479}}]}, 
   {Hue[0.26166802177780735`, 1, 1], PointSize[0.06424732240814032], Opacity[
    0.4], PointBox[{{0.8374241719780228, -1.9307805793829897`}}]}, 
   {Hue[0.05898644584429813, 1, 1], PointSize[0.09290268318720063], Opacity[
    0.4], PointBox[{{0.25430987064036487`, -0.729068093485347}}]}, 
   {Hue[0.6618949536585732, 1, 1], PointSize[0.06006665515727849], Opacity[
    0.4], PointBox[{{0.867825532935772, 1.1419379413720467`}}]}, 
   {Hue[0.40089292046232794`, 1, 1], PointSize[0.047444301708262554`], 
    Opacity[0.4], PointBox[{{-0.615387472978106, 0.24513425799230895`}}]}, 
   {Hue[0.6492963265979423, 1, 1], PointSize[0.06545832124417794], Opacity[
    0.4], PointBox[{{-0.5631594216778011, -0.045526682915862544`}}]}, 
   {Hue[0.8763228730892068, 1, 1], PointSize[0.04409404013821737], Opacity[
    0.4], PointBox[{{-0.15760569296978277`, 0.5499722087624997}}]}, 
   {Hue[0.0162619179494643, 1, 1], PointSize[0.04808585725786249], Opacity[
    0.4], PointBox[{{-0.23034741550763746`, 0.642960495282872}}]}, 
   {Hue[0.8115401727418217, 1, 1], PointSize[0.0967941641646391], Opacity[
    0.4], PointBox[{{1.1712227448455563`, 0.24916021555441628`}}]}, 
   {Hue[0.16222689417021607`, 1, 1], PointSize[0.02315929258398161], Opacity[
    0.4], PointBox[{{-0.17652565160275813`, 1.273747667481155}}]}, 
   {Hue[0.23655857150155346`, 1, 1], PointSize[0.05924060777551507], Opacity[
    0.4], PointBox[{{-0.7495422682054544, 1.482546669632756}}]}, 
   {Hue[0.5192668507700828, 1, 1], PointSize[0.08113660819123866], Opacity[
    0.4], PointBox[{{0.41396386377821703`, 1.6388227028082767`}}]}, 
   {Hue[0.21441274612704353`, 1, 1], PointSize[0.07402041732085687], Opacity[
    0.4], PointBox[{{-0.6684679883790466, 0.07410276902780165}}]}, 
   {Hue[0.4382987830017264, 1, 1], PointSize[0.04433616169700064], Opacity[
    0.4], PointBox[{{-1.1430498552607176`, 1.5231085026706692`}}]}, 
   {Hue[0.9544934172991895, 1, 1], PointSize[0.03569472454304476], Opacity[
    0.4], PointBox[{{-2.398845572512996, -0.4939745571977711}}]}, 
   {Hue[0.6840482066815852, 1, 1], PointSize[0.02237748550795518], Opacity[
    0.4], PointBox[{{-0.3810511715578781, -0.8331384213278504}}]}, 
   {Hue[0.5670861437832613, 1, 1], PointSize[0.09094242197885924], Opacity[
    0.4], PointBox[{{1.2979511988578682`, -0.8129985350269482}}]}, 
   {Hue[0.8564601217648027, 1, 1], PointSize[0.09360425314184784], Opacity[
    0.4], PointBox[{{1.3862031884032058`, -0.5700667269283876}}]}, 
   {Hue[0.48042926728706803`, 1, 1], PointSize[0.08969003444680679], Opacity[
    0.4], PointBox[{{0.46525337795067684`, -0.15408631462713382`}}]}, 
   {Hue[0.8962845013320473, 1, 1], PointSize[0.041029678879565185`], Opacity[
    0.4], PointBox[{{3.329331485863889, 0.8156525280716083}}]}, 
   {Hue[0.9954602099479608, 1, 1], PointSize[0.040827277307949855`], Opacity[
    0.4], PointBox[{{-0.32152979597337766`, -0.35426684507457146`}}]}, 
   {Hue[0.8257825632954099, 1, 1], PointSize[0.0871889108944088], Opacity[
    0.4], PointBox[{{1.1804186313817981`, -0.8054828506049497}}]}, 
   {Hue[0.3469092725549048, 1, 1], PointSize[0.025334347645515634`], Opacity[
    0.4], PointBox[{{0.3669796435322823, 0.41288956462127974`}}]}, 
   {Hue[0.856814220538034, 1, 1], PointSize[0.03752617384236455], Opacity[
    0.4], PointBox[{{-0.8027921861342495, 0.02197348461047116}}]}, 
   {Hue[0.2147062531508297, 1, 1], PointSize[0.060421870974828096`], Opacity[
    0.4], PointBox[{{0.8095348871440969, 1.2630219914139165`}}]}, 
   {Hue[0.6789645200135677, 1, 1], PointSize[0.05763010868089094], Opacity[
    0.4], PointBox[{{0.22714139906349068`, -1.8341748030465828`}}]}, 
   {Hue[0.17369815252507492`, 1, 1], PointSize[0.09178737210706714], Opacity[
    0.4], PointBox[{{0.5915885383181925, 2.112056058345884}}]}, 
   {Hue[0.4466728505783042, 1, 1], PointSize[0.04005180892974511], Opacity[
    0.4], PointBox[{{-0.4324716813985074, 0.1609126840078212}}]}, 
   {Hue[0.44056093127866713`, 1, 1], PointSize[0.06600706902090944], Opacity[
    0.4], PointBox[{{-0.594862956455528, 0.7451149631984461}}]}, 
   {Hue[0.5310771448729281, 1, 1], PointSize[0.08369794644747228], Opacity[
    0.4], PointBox[{{-0.7608227705232832, -1.0699053738538271`}}]}, 
   {Hue[0.8911431368437495, 1, 1], PointSize[0.08848578295919479], Opacity[
    0.4], PointBox[{{0.05798944833453484, 0.017214707702375414`}}]}, 
   {Hue[0.4255905965979465, 1, 1], PointSize[0.0810762050553222], Opacity[
    0.4], PointBox[{{0.13209006395339193`, 1.5392096633467902`}}]}, 
   {Hue[0.24970101510111453`, 1, 1], PointSize[0.07914992729988488], Opacity[
    0.4], PointBox[{{0.7932938764772078, 0.7651349096732689}}]}, 
   {Hue[0.12354482239723197`, 1, 1], PointSize[0.07669331359084663], Opacity[
    0.4], PointBox[{{-2.038003316853743, -0.6314813141652257}}]}, 
   {Hue[0.17604487685140469`, 1, 1], PointSize[0.010837061578775523`], 
    Opacity[0.4], PointBox[{{-0.2503735436811663, 0.35705181646404605`}}]}, 
   {Hue[0.6930054451442074, 1, 1], PointSize[0.0497171597864374], Opacity[
    0.4], PointBox[{{1.6340751110452916`, -0.4077903476447145}}]}},
  ImageSize->100]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The algebraic solution is given by the following steps. First solve the \
equations for ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 "."
}], "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"x", ",", "y", ",", "r"}], "]"}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"soln", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"x", "-", "1"}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"y", "-", "1"}], ")"}], "2"]}], "\[Equal]", "2"}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"x", "+", "3"}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"y", "-", "4"}], ")"}], "2"]}], "\[Equal]", 
       SuperscriptBox["r", "2"]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      RowBox[{
       FractionBox["1", "50"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "58"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["r", "2"]}], "-", 
         RowBox[{"3", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"-", "529"}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["r", "2"]}], "-", 
            SuperscriptBox["r", "4"]}]]}]}], ")"}]}]}], ",", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{
       FractionBox["1", "50"], " ", 
       RowBox[{"(", 
        RowBox[{"131", "-", 
         RowBox[{"3", " ", 
          SuperscriptBox["r", "2"]}], "-", 
         RowBox[{"4", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"-", "529"}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["r", "2"]}], "-", 
            SuperscriptBox["r", "4"]}]]}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      RowBox[{
       FractionBox["1", "50"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "58"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"3", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"-", "529"}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["r", "2"]}], "-", 
            SuperscriptBox["r", "4"]}]]}]}], ")"}]}]}], ",", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{
       FractionBox["1", "50"], " ", 
       RowBox[{"(", 
        RowBox[{"131", "-", 
         RowBox[{"3", " ", 
          SuperscriptBox["r", "2"]}], "+", 
         RowBox[{"4", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"-", "529"}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["r", "2"]}], "-", 
            SuperscriptBox["r", "4"]}]]}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Then find those values of ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 " for which the ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 " coordinates are identical."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"x", "/.", "\[VeryThinSpace]", 
        RowBox[{
        "soln", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       ")"}], "\[Equal]", 
      RowBox[{"(", 
       RowBox[{"x", "/.", "\[VeryThinSpace]", 
        RowBox[{
        "soln", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       ")"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"y", "/.", "\[VeryThinSpace]", 
        RowBox[{
        "soln", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       ")"}], "\[Equal]", 
      RowBox[{"(", 
       RowBox[{"y", "/.", "\[VeryThinSpace]", 
        RowBox[{
        "soln", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       ")"}]}]}], "}"}], ",", "\[IndentingNewLine]", "r"}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "5"}], "-", 
      SqrtBox["2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{"5", "-", 
      SqrtBox["2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "5"}], "+", 
      SqrtBox["2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{"5", "+", 
      SqrtBox["2"]}]}], "}"}]}], "}"}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here then are those values of ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]]],
 " that are positive."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cases", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{"_", "?", "Positive"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{"5", "-", 
      SqrtBox["2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{"5", "+", 
      SqrtBox["2"]}]}], "}"}]}], "}"}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "To display the solution, we will plot the first circle with solid lines and \
the two solutions with dashed lines together in one graphic. Here is the \
first circle centered at (",
 StyleBox["1, 1", "OsF"],
 ")."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"circ", "=", 
   RowBox[{"Circle", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     SqrtBox["2"]}], "]"}]}], ";"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell["\<\
Here are the circles that represent the solution to the problem.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"r1", "=", 
   RowBox[{"5", "-", 
    SqrtBox["2"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r2", "=", 
   RowBox[{"5", "+", 
    SqrtBox["2"]}]}], ";"}]}], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"circ", ",", 
     RowBox[{"Circle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", "r1"}], "]"}], ",", 
     RowBox[{"Circle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", "r2"}], "]"}]}], "}"}], 
   ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   CircleBox[{1, 1}, NCache[2^Rational[1, 2], 1.4142135623730951`]], 
   CircleBox[{-3, 4}, NCache[5 - 2^Rational[1, 2], 3.585786437626905]], 
   CircleBox[{-3, 4}, NCache[5 + 2^Rational[1, 2], 6.414213562373095]]},
  Axes->Automatic,
  ImageSize->100]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "We wanted to display the solutions (two circles) using dashed lines. The \
graphics directive ",
 Cell[BoxData[
  RowBox[{"Dashing", "[", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], "]"}]]],
 " directs all subsequent lines to be plotted as dashed, alternating the dash \
",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " units and the space ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 " units. We use it as a graphics directive on the two circles ",
 Cell[BoxData["c1"]],
 " and ",
 Cell[BoxData["c2"]],
 ". The circles inherit only those directives in whose scope they appear."
}], "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dashc1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dashing", "[", 
      RowBox[{"{", 
       RowBox[{".025", ",", ".025"}], "}"}], "]"}], ",", 
     RowBox[{"Circle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", "r1"}], "]"}]}], "}"}]}],
   ";"}], "\n", 
 RowBox[{
  RowBox[{"dashc2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dashing", "[", 
      RowBox[{"{", 
       RowBox[{".05", ",", ".05"}], "}"}], "]"}], ",", 
     RowBox[{"Circle", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", "r2"}], "]"}]}], "}"}]}],
   ";"}]}], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"circ", ",", "dashc1", ",", "dashc2"}], "}"}], ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   CircleBox[{1, 1}, NCache[2^Rational[1, 2], 1.4142135623730951`]], 
   {Dashing[{0.025, 0.025}], 
    CircleBox[{-3, 4}, NCache[5 - 2^Rational[1, 2], 3.585786437626905]]}, 
   {Dashing[{0.05, 0.05}], 
    CircleBox[{-3, 4}, NCache[5 + 2^Rational[1, 2], 6.414213562373095]]}},
  Axes->Automatic,
  ImageSize->100]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Here is a plot of the sine function.", "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sinplot", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwlmXk4lN/7x61ZEjPPjJAU7SsppYXuUwlFSokWIWkhSURIKpWQZK9kS4X4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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998592131705, 0.9999998782112116}}, {{
     0, 6.283185307179586}, {-0.9999998592131705, 0.9999998782112116}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell["Using pattern matching, here are the coordinates.", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"coords", "=", 
    RowBox[{"Cases", "[", 
     RowBox[{"sinplot", ",", 
      RowBox[{
       RowBox[{"Line", "[", 
        RowBox[{"{", "x__", "}"}], "]"}], "\[RuleDelayed]", "x"}], ",", 
      "Infinity"}], "]"}]}], ",", "2"}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.2822827157509358`*^-7", ",", "1.2822827157509324`*^-7"}], 
     "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "429", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "}"}]}], "}"}],
  Short[#, 2]& ]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell["Create vertical lines from each coordinate.", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"lines", "=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Line", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}], ",", "#"}], 
         "}"}], "]"}], "&"}], ",", "coords"}], "]"}]}], ",", "2"}], 
  "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Line", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1.2822827157509358`*^-7", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[LeftSkeleton]", "23", "\[RightSkeleton]"}], ",", 
         RowBox[{"\[LeftSkeleton]", "23", "\[RightSkeleton]"}]}], "}"}]}], 
      "}"}], "]"}], ",", 
    RowBox[{"\[LeftSkeleton]", "430", "\[RightSkeleton]"}]}], "}"}],
  Short[#, 2]& ]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell["Here then is the final graphic.", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"sinplot", ",", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Thickness", "[", ".001", "]"}], ",", "lines"}], "}"}], "]"}]}],
   "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwlmXk4lN/7x61ZEjPPjJAU7SsppYXuUwlFSokWIWkhSURIKpWQZK9kS4X4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      "]]}}, 
   {Thickness[0.001], 
    LineBox[{{1.2822827157509358`*^-7, 0}, {1.2822827157509358`*^-7, 
      1.2822827157509324`*^-7}}], 
    LineBox[{{0.0019271655319089223`, 0}, {0.0019271655319089223`, 
      0.001927164339004283}}], 
    LineBox[{{0.0038542028355462695`, 0}, {0.0038542028355462695`, 
      0.00385419329326691}}], 
    LineBox[{{0.007708277442820964, 0}, {0.007708277442820964, 
      0.007708201108565738}}], 
    LineBox[{{0.015416426657370353`, 0}, {0.015416426657370353`, 
      0.015415816004008815`}}], 
    LineBox[{{0.030832725086469132`, 0}, {0.030832725086469132`, 
      0.030827840094677948`}}], 
    LineBox[{{0.06166532194466669, 0}, {0.06166532194466669, 
      0.061626247826437476`}}], 
    LineBox[{{0.1233305156610618, 0}, {0.1233305156610618, 
      0.12301810194283724`}}], 
    LineBox[{{0.2570347881802097, 0}, {0.2570347881802097, 
      0.2542138749185557}}], 
    LineBox[{{0.3818787050494512, 0}, {0.3818787050494512, 
      0.3726645007390021}}], 
    LineBox[{{0.504273679847541, 0}, {0.504273679847541, 
      0.4831716559080398}}], 
    LineBox[{{0.6370425397319885, 0}, {0.6370425397319885, 
      0.5948206667810294}}], 
    LineBox[{{0.7609510439665297, 0}, {0.7609510439665297, 
      0.6896104843619676}}], 
    LineBox[{{0.8952334332874284, 0}, {0.8952334332874284, 
      0.7803550768254573}}], 
    LineBox[{{0.8972933309007058, 0}, {0.8972933309007058, 
      0.7816415498416075}}], 
    LineBox[{{0.8993532285139831, 0}, {0.8993532285139831, 
      0.7829247062145637}}], 
    LineBox[{{0.9034730237405377, 0}, {0.9034730237405377, 
      0.7854810472663536}}], 
    LineBox[{{0.9117126141936469, 0}, {0.9117126141936469, 
      0.7905536910323365}}], 
    LineBox[{{0.9281917950998653, 0}, {0.9281917950998653, 
      0.8005376246467046}}], 
    LineBox[{{0.961150156912302, 0}, {0.961150156912302, 
      0.8198506642936907}}], 
    LineBox[{{1.0270668805371757`, 0}, {1.0270668805371757`, 
      0.8557852784294558}}], 
    LineBox[{{1.0289883350934232`, 0}, {1.0289883350934232`, 
      0.8567777264106478}}], 
    LineBox[{{1.0309097896496706`, 0}, {1.0309097896496706`, 
      0.8577670111800606}}], 
    LineBox[{{1.0347526987621656`, 0}, {1.0347526987621656`, 
      0.8597360764855386}}], 
    LineBox[{{1.0424385169871557`, 0}, {1.0424385169871557`, 
      0.8636360886325238}}], 
    LineBox[{{1.0578101534371358`, 0}, {1.0578101534371358`, 
      0.871282836694368}}], 
    LineBox[{{1.088553426337096, 0}, {1.088553426337096, 
      0.8859569678649591}}], 
    LineBox[{{1.0904748808933435`, 0}, {1.0904748808933435`, 
      0.886846439932971}}], 
    LineBox[{{1.092396335449591, 0}, {1.092396335449591, 
      0.8877326377759202}}], 
    LineBox[{{1.0962392445620859`, 0}, {1.0962392445620859`, 
      0.8894951977114104}}], 
    LineBox[{{1.103925062787076, 0}, {1.103925062787076, 
      0.8929808837325072}}], 
    LineBox[{{1.119296699237056, 0}, {1.119296699237056, 
      0.8997938037956826}}], 
    LineBox[{{1.1500399721370163`, 0}, {1.1500399721370163`, 
      0.9127802676472789}}], 
    LineBox[{{1.152123518647738, 0}, {1.152123518647738, 
      0.9136293123298869}}], 
    LineBox[{{1.15420706515846, 0}, {1.15420706515846, 0.9144743907973655}}], 
    LineBox[{{1.1583741581799036`, 0}, {1.1583741581799036`, 
      0.9161526344296698}}], 
    LineBox[{{1.166708344222791, 0}, {1.166708344222791, 
      0.9194613668487993}}], 
    LineBox[{{1.1833767163085658`, 0}, {1.1833767163085658`, 
      0.9258870137580502}}], 
    LineBox[{{1.2167134604801153`, 0}, {1.2167134604801153`, 
      0.9379648812640387}}], 
    LineBox[{{1.2187970069908372`, 0}, {1.2187970069908372`, 
      0.9386852734597927}}], 
    LineBox[{{1.220880553501559, 0}, {1.220880553501559, 
      0.9394015906683686}}], 
    LineBox[{{1.2250476465230027`, 0}, {1.2250476465230027`, 
      0.9408219877030862}}], 
    LineBox[{{1.23338183256589, 0}, {1.23338183256589, 0.9436137462886434}}], 
    LineBox[{{1.2500502046516648`, 0}, {1.2500502046516648`, 
      0.9490004488089845}}], 
    LineBox[{{1.2833869488232146`, 0}, {1.2833869488232146`, 
      0.9589814532774429}}], 
    LineBox[{{1.2853320522769067`, 0}, {1.2853320522769067`, 
      0.9595310149939811}}], 
    LineBox[{{1.2872771557305986`, 0}, {1.2872771557305986`, 
      0.9600769463956869}}], 
    LineBox[{{1.291167362637983, 0}, {1.291167362637983, 
      0.9611579100063794}}], 
    LineBox[{{1.298947776452751, 0}, {1.298947776452751, 
      0.9632761834893663}}], 
    LineBox[{{1.3145086040822878`, 0}, {1.3145086040822878`, 
      0.9673376713325591}}], 
    LineBox[{{1.3164537075359797`, 0}, {1.3164537075359797`, 
      0.9678289078627277}}], 
    LineBox[{{1.3183988109896718`, 0}, {1.3183988109896718`, 
      0.9683164826835982}}], 
    LineBox[{{1.3222890178970559`, 0}, {1.3222890178970559`, 
      0.9692806398324919}}], 
    LineBox[{{1.3300694317118242`, 0}, {1.3300694317118242`, 
      0.9711649333808123}}], 
    LineBox[{{1.3456302593413607`, 0}, {1.3456302593413607`, 
      0.9747570429220562}}], 
    LineBox[{{1.3475753627950526`, 0}, {1.3475753627950526`, 
      0.9751894785134673}}], 
    LineBox[{{1.3495204662487448`, 0}, {1.3495204662487448`, 
      0.9756182245474039}}], 
    LineBox[{{1.3534106731561288`, 0}, {1.3534106731561288`, 
      0.9764646414683034}}], 
    LineBox[{{1.3611910869708972`, 0}, {1.3611910869708972`, 
      0.9781131301827487}}], 
    LineBox[{{1.3767519146004337`, 0}, {1.3767519146004337`, 
      0.9812323825384774}}], 
    LineBox[{{1.3786970180541256`, 0}, {1.3786970180541256`, 
      0.9816055983862323}}], 
    LineBox[{{1.3806421215078177`, 0}, {1.3806421215078177`, 
      0.9819751004015963}}], 
    LineBox[{{1.3845323284152018`, 0}, {1.3845323284152018`, 
      0.982702957357274}}], 
    LineBox[{{1.3923127422299701`, 0}, {1.3923127422299701`, 
      0.9841140447107248}}], 
    LineBox[{{1.4078735698595066`, 0}, {1.4078735698595066`, 
      0.9867574189497462}}], 
    LineBox[{{1.409780408593337, 0}, {1.409780408593337, 
      0.9870649196839719}}], 
    LineBox[{{1.4116872473271673`, 0}, {1.4116872473271673`, 
      0.9873688314177196}}], 
    LineBox[{{1.415500924794828, 0}, {1.415500924794828, 
      0.9879658834767021}}], 
    LineBox[{{1.4231282797301492`, 0}, {1.4231282797301492`, 
      0.9891168718422977}}], 
    LineBox[{{1.4250351184639793`, 0}, {1.4250351184639793`, 
      0.989395630363058}}], 
    LineBox[{{1.4269419571978097`, 0}, {1.4269419571978097`, 
      0.9896707914087998}}], 
    LineBox[{{1.4307556346654704`, 0}, {1.4307556346654704`, 
      0.9902103170863328}}], 
    LineBox[{{1.4383829896007918`, 0}, {1.4383829896007918`, 
      0.9912461555962515}}], 
    LineBox[{{1.4402898283346222`, 0}, {1.4402898283346222`, 
      0.9914961070359759}}], 
    LineBox[{{1.4421966670684525`, 0}, {1.4421966670684525`, 
      0.9917424533632795}}], 
    LineBox[{{1.446010344536113, 0}, {1.446010344536113, 0.992224327110842}}],
     LineBox[{{1.4536376994714342`, 0}, {1.4536376994714342`, 
      0.9931447747237425}}], 
    LineBox[{{1.4688924093420768`, 0}, {1.4688924093420768`, 
      0.9948122874129468}}], 
    LineBox[{{1.470799248075907, 0}, {1.470799248075907, 
      0.9950044569152444}}], 
    LineBox[{{1.4727060868097372`, 0}, {1.4727060868097372`, 
      0.9951930085486457}}], 
    LineBox[{{1.476519764277398, 0}, {1.476519764277398, 
      0.9955592554795967}}], 
    LineBox[{{1.4841471192127194`, 0}, {1.4841471192127194`, 
      0.9962483056308926}}], 
    LineBox[{{1.4860539579465497`, 0}, {1.4860539579465497`, 
      0.9964115137227522}}], 
    LineBox[{{1.48796079668038, 0}, {1.48796079668038, 0.9965710988296106}}], 
    LineBox[{{1.4917744741480405`, 0}, {1.4917744741480405`, 
      0.9968793977804729}}], 
    LineBox[{{1.4994018290833617`, 0}, {1.4994018290833617`, 
      0.9974524952137558}}], 
    LineBox[{{1.501308667817192, 0}, {1.501308667817192, 
      0.9975867039163834}}], 
    LineBox[{{1.5032155065510224`, 0}, {1.5032155065510224`, 
      0.9977172853609797}}], 
    LineBox[{{1.5070291840186831`, 0}, {1.5070291840186831`, 
      0.9979675645900754}}], 
    LineBox[{{1.5089360227525135`, 0}, {1.5089360227525135`, 
      0.9980872614645513}}], 
    LineBox[{{1.5108428614863438`, 0}, {1.5108428614863438`, 
      0.9982033292609522}}], 
    LineBox[{{1.5146565389540043`, 0}, {1.5146565389540043`, 
      0.998424575944621}}], 
    LineBox[{{1.5165633776878344`, 0}, {1.5165633776878344`, 
      0.9985297540274285}}], 
    LineBox[{{1.5184702164216648`, 0}, {1.5184702164216648`, 
      0.9986313014232436}}], 
    LineBox[{{1.5222838938893255`, 0}, {1.5222838938893255`, 
      0.9988235026901806}}], 
    LineBox[{{1.5241907326231559`, 0}, {1.5241907326231559`, 
      0.9989141558624522}}], 
    LineBox[{{1.5260975713569862`, 0}, {1.5260975713569862`, 
      0.9990011769500338}}], 
    LineBox[{{1.529911248824647, 0}, {1.529911248824647, 
      0.9991643216186877}}], 
    LineBox[{{1.5319801795129515`, 0}, {1.5319801795129515`, 
      0.9992467479388707}}], 
    LineBox[{{1.5340491102012561`, 0}, {1.5340491102012561`, 
      0.9993248970106624}}], 
    LineBox[{{1.5361180408895607`, 0}, {1.5361180408895607`, 
      0.9993987684995479}}], 
    LineBox[{{1.5381869715778655`, 0}, {1.5381869715778655`, 
      0.9994683620893222}}], 
    LineBox[{{1.5402559022661704`, 0}, {1.5402559022661704`, 
      0.999533677482092}}], 
    LineBox[{{1.542324832954475, 0}, {1.542324832954475, 
      0.9995947143982763}}], 
    LineBox[{{1.5464626943310842`, 0}, {1.5464626943310842`, 
      0.9997039517741367}}], 
    LineBox[{{1.5485316250193888`, 0}, {1.5485316250193888`, 
      0.9997521517662251}}], 
    LineBox[{{1.5506005557076934`, 0}, {1.5506005557076934`, 
      0.9997960723465549}}], 
    LineBox[{{1.552669486395998, 0}, {1.552669486395998, 
      0.9998357133271253}}], 
    LineBox[{{1.5547384170843028`, 0}, {1.5547384170843028`, 
      0.9998710745382542}}], 
    LineBox[{{1.5568073477726077`, 0}, {1.5568073477726077`, 
      0.9999021558285789}}], 
    LineBox[{{1.5588762784609123`, 0}, {1.5588762784609123`, 
      0.9999289570650568}}], 
    LineBox[{{1.5609452091492169`, 0}, {1.5609452091492169`, 
      0.9999514781329658}}], 
    LineBox[{{1.5630141398375215`, 0}, {1.5630141398375215`, 
      0.9999697189359052}}], 
    LineBox[{{1.565083070525826, 0}, {1.565083070525826, 
      0.9999836793957958}}], 
    LineBox[{{1.5671520012141307`, 0}, {1.5671520012141307`, 
      0.9999933594528801}}], 
    LineBox[{{1.5692209319024353`, 0}, {1.5692209319024353`, 
      0.9999987590657231}}], 
    LineBox[{{1.57128986259074, 0}, {1.57128986259074, 0.9999998782112116}}], 
    LineBox[{{1.573358793279045, 0}, {1.573358793279045, 
      0.9999967168845553}}], 
    LineBox[{{1.5754277239673495`, 0}, {1.5754277239673495`, 
      0.9999892750992861}}], 
    LineBox[{{1.5774966546556541`, 0}, {1.5774966546556541`, 
      0.9999775528872585}}], 
    LineBox[{{1.5795655853439587`, 0}, {1.5795655853439587`, 
      0.999961550298649}}], 
    LineBox[{{1.5816345160322633`, 0}, {1.5816345160322633`, 
      0.9999412674019562}}], 
    LineBox[{{1.583703446720568, 0}, {1.583703446720568, 
      0.9999167042840006}}], 
    LineBox[{{1.5857723774088726`, 0}, {1.5857723774088726`, 
      0.9998878610499239}}], 
    LineBox[{{1.5878413080971774`, 0}, {1.5878413080971774`, 
      0.9998547378231887}}], 
    LineBox[{{1.5899102387854822`, 0}, {1.5899102387854822`, 
      0.9998173347455782}}], 
    LineBox[{{1.5919791694737868`, 0}, {1.5919791694737868`, 
      0.9997756519771952}}], 
    LineBox[{{1.5940481001620914`, 0}, {1.5940481001620914`, 
      0.9997296896964616}}], 
    LineBox[{{1.596117030850396, 0}, {1.596117030850396, 
      0.9996794481001177}}], 
    LineBox[{{1.5981859615387006`, 0}, {1.5981859615387006`, 
      0.9996249274032214}}], 
    LineBox[{{1.6002548922270052`, 0}, {1.6002548922270052`, 
      0.9995661278391469}}], 
    LineBox[{{1.6023238229153098`, 0}, {1.6023238229153098`, 
      0.9995030496595841}}], 
    LineBox[{{1.6043927536036147`, 0}, {1.6043927536036147`, 
      0.9994356931345377}}], 
    LineBox[{{1.6064616842919195`, 0}, {1.6064616842919195`, 
      0.9993640585523252}}], 
    LineBox[{{1.608530614980224, 0}, {1.608530614980224, 
      0.9992881462195765}}], 
    LineBox[{{1.6126684763568333`, 0}, {1.6126684763568333`, 
      0.9991234896205428}}], 
    LineBox[{{1.614737407045138, 0}, {1.614737407045138, 
      0.9990347460590658}}], 
    LineBox[{{1.6168063377334425`, 0}, {1.6168063377334425`, 
      0.9989417261566658}}], 
    LineBox[{{1.620944199110052, 0}, {1.620944199110052, 
      0.9987428589400763}}], 
    LineBox[{{1.6292199218632706`, 0}, {1.6292199218632706`, 
      0.9982938271614664}}], 
    LineBox[{{1.6312888525515752`, 0}, {1.6312888525515752`, 
      0.9981708850461833}}], 
    LineBox[{{1.6333577832398798`, 0}, {1.6333577832398798`, 
      0.9980436702877108}}], 
    LineBox[{{1.6374956446164892`, 0}, {1.6374956446164892`, 
      0.9977764250376405}}], 
    LineBox[{{1.6457713673697079`, 0}, {1.6457713673697079`, 
      0.9971906880040196}}], 
    LineBox[{{1.6478402980580125`, 0}, {1.6478402980580125`, 
      0.9970335810141968}}], 
    LineBox[{{1.649909228746317, 0}, {1.649909228746317, 
      0.9968722062493834}}], 
    LineBox[{{1.6540470901229263`, 0}, {1.6540470901229263`, 
      0.9965366561760906}}], 
    LineBox[{{1.662322812876145, 0}, {1.662322812876145, 
      0.9958143743466595}}], 
    LineBox[{{1.6642533005074198`, 0}, {1.6642533005074198`, 
      0.9956360747050302}}], 
    LineBox[{{1.6661837881386945`, 0}, {1.6661837881386945`, 
      0.995454064545459}}], 
    LineBox[{{1.6700447634012443`, 0}, {1.6700447634012443`, 
      0.9950789153995656}}], 
    LineBox[{{1.677766713926344, 0}, {1.677766713926344, 
      0.9942841216643886}}], 
    LineBox[{{1.6796972015576188`, 0}, {1.6796972015576188`, 
      0.9940761576460222}}], 
    LineBox[{{1.6816276891888937`, 0}, {1.6816276891888937`, 
      0.9938644889231839}}], 
    LineBox[{{1.6854886644514433`, 0}, {1.6854886644514433`, 
      0.9934300405332672}}], 
    LineBox[{{1.6932106149765427`, 0}, {1.6932106149765427`, 
      0.9925167229335421}}], 
    LineBox[{{1.6951411026078176`, 0}, {1.6951411026078176`, 
      0.9922791441397993}}], 
    LineBox[{{1.6970715902390925`, 0}, {1.6970715902390925`, 
      0.992037867338661}}], 
    LineBox[{{1.7009325655016423`, 0}, {1.7009325655016423`, 
      0.9915442233247193}}], 
    LineBox[{{1.7086545160267417`, 0}, {1.7086545160267417`, 
      0.990512599695223}}], 
    LineBox[{{1.7240984170769407`, 0}, {1.7240984170769407`, 
      0.9882722299515398}}], 
    LineBox[{{1.7260289047082156`, 0}, {1.7260289047082156`, 
      0.9879755986512128}}], 
    LineBox[{{1.7279593923394905`, 0}, {1.7279593923394905`, 
      0.987675285381863}}], 
    LineBox[{{1.7318203676020403`, 0}, {1.7318203676020403`, 
      0.9870636174266212}}], 
    LineBox[{{1.7395423181271397`, 0}, {1.7395423181271397`, 
      0.9857961480515994}}], 
    LineBox[{{1.7549862191773387`, 0}, {1.7549862191773387`, 
      0.9830849445640588}}], 
    LineBox[{{1.7858740212777366`, 0}, {1.7858740212777366`, 
      0.9769598153400458}}], 
    LineBox[{{1.7879666008634858`, 0}, {1.7879666008634858`, 
      0.9765110713568594}}], 
    LineBox[{{1.790059180449235, 0}, {1.790059180449235, 
      0.9760580513413295}}], 
    LineBox[{{1.7942443396207335`, 0}, {1.7942443396207335`, 
      0.9751391911668498}}], 
    LineBox[{{1.8026146579637303`, 0}, {1.8026146579637303`, 
      0.9732502469670653}}], 
    LineBox[{{1.819355294649724, 0}, {1.819355294649724, 
      0.9692679326365597}}], 
    LineBox[{{1.8528365680217114`, 0}, {1.8528365680217114`, 
      0.9604896062780456}}], 
    LineBox[{{1.8549291476074605`, 0}, {1.8549291476074605`, 
      0.9599051056843635}}], 
    LineBox[{{1.8570217271932097`, 0}, {1.8570217271932097`, 
      0.959316401773997}}], 
    LineBox[{{1.8612068863647082`, 0}, {1.8612068863647082`, 
      0.9581263943330792}}], 
    LineBox[{{1.869577204707705, 0}, {1.869577204707705, 
      0.9556960543090358}}], 
    LineBox[{{1.8863178413936987`, 0}, {1.8863178413936987`, 
      0.9506346758110857}}], 
    LineBox[{{1.9197991147656859`, 0}, {1.9197991147656859`, 
      0.9397141875380657}}], 
    LineBox[{{1.9218534296315735`, 0}, {1.9218534296315735`, 
      0.9390097098112606}}], 
    LineBox[{{1.9239077444974608`, 0}, {1.9239077444974608`, 
      0.9383012692680873}}], 
    LineBox[{{1.9280163742292356`, 0}, {1.9280163742292356`, 
      0.936872511708413}}], 
    LineBox[{{1.9362336336927854`, 0}, {1.9362336336927854`, 
      0.9339675754613147}}], 
    LineBox[{{1.9526681526198852`, 0}, {1.9526681526198852`, 
      0.9279687105727975}}], 
    LineBox[{{1.9855371904740848`, 0}, {1.9855371904740848`, 
      0.9152207709228335}}], 
    LineBox[{{2.0512752661824836`, 0}, {2.0512752661824836`, 
      0.8867736568214569}}], 
    LineBox[{{2.053191137991341, 0}, {2.053191137991341, 
      0.8858865063862249}}], 
    LineBox[{{2.055107009800199, 0}, {2.055107009800199, 
      0.8849961042481709}}], 
    LineBox[{{2.058938753417914, 0}, {2.058938753417914, 0.883205557948632}}],
     LineBox[{{2.066602240653345, 0}, {2.066602240653345, 
      0.8795855895181172}}], 
    LineBox[{{2.081929215124206, 0}, {2.081929215124206, 
      0.8721908974026384}}], 
    LineBox[{{2.112583164065929, 0}, {2.112583164065929, 
      0.8567886352600307}}], 
    LineBox[{{2.1738910619493748`, 0}, {2.1738910619493748`, 
      0.8235842465112402}}], 
    LineBox[{{2.175969025712707, 0}, {2.175969025712707, 
      0.8224038607722788}}], 
    LineBox[{{2.178046989476039, 0}, {2.178046989476039, 
      0.8212199239494951}}], 
    LineBox[{{2.182202917002703, 0}, {2.182202917002703, 
      0.8188414175164062}}], 
    LineBox[{{2.190514772056031, 0}, {2.190514772056031, 
      0.8140420176039472}}], 
    LineBox[{{2.207138482162687, 0}, {2.207138482162687, 
      0.8042748352072091}}], 
    LineBox[{{2.2403859023759995`, 0}, {2.2403859023759995`, 
      0.7840764676698918}}], 
    LineBox[{{2.306880742802624, 0}, {2.306880742802624, 
      0.7411031219178128}}], 
    LineBox[{{2.4310100680059663`, 0}, {2.4310100680059663`, 
      0.6522754710746894}}], 
    LineBox[{{2.5655132782956667`, 0}, {2.5655132782956667`, 
      0.5447402771484026}}], 
    LineBox[{{2.697567546514215, 0}, {2.697567546514215, 
      0.42957772713203446`}}], 
    LineBox[{{2.820761459082857, 0}, {2.820761459082857, 
      0.3153554511260218}}], 
    LineBox[{{2.954329256737857, 0}, {2.954329256737857, 
      0.18617083526814407`}}], 
    LineBox[{{3.0790366987429505`, 0}, {3.0790366987429505`, 
      0.06251516334017572}}], 
    LineBox[{{3.2012951986768923`, 0}, {
      3.2012951986768923`, -0.05966708417636863}}], 
    LineBox[{{3.3339275836971916`, 0}, {
      3.3339275836971916`, -0.19115128932767658`}}], 
    LineBox[{{3.4576996130675846`, 0}, {
      3.4576996130675846`, -0.3108687742575189}}], 
    LineBox[{{3.5918455275243355`, 0}, {
      3.5918455275243355`, -0.43519321980343784`}}], 
    LineBox[{{3.7235424999099345`, 0}, {
      3.7235424999099345`, -0.549653867612323}}], 
    LineBox[{{3.846379116645627, 0}, {
      3.846379116645627, -0.6478711825589065}}], 
    LineBox[{{3.9795896184676773`, 0}, {
      3.9795896184676773`, -0.7433046755726647}}], 
    LineBox[{{3.981532589501617, 0}, {
      3.981532589501617, -0.7446030280816351}}], 
    LineBox[{{3.983475560535557, 0}, {
      3.983475560535557, -0.7458985696134666}}], 
    LineBox[{{3.987361502603436, 0}, {
      3.987361502603436, -0.748481200192963}}], 
    LineBox[{{3.9951333867391954`, 0}, {
      3.9951333867391954`, -0.7536125151423854}}], 
    LineBox[{{4.010677155010713, 0}, {
      4.010677155010713, -0.7637382790138112}}], 
    LineBox[{{4.041764691553749, 0}, {
      4.041764691553749, -0.7834338385481846}}], 
    LineBox[{{4.103939764639821, 0}, {
      4.103939764639821, -0.8205354257281963}}], 
    LineBox[{{4.105844470953899, 0}, {
      4.105844470953899, -0.8216226585479436}}], 
    LineBox[{{4.107749177267976, 0}, {
      4.107749177267976, -0.8227069105987015}}], 
    LineBox[{{4.111558589896132, 0}, {
      4.111558589896132, -0.8248664566698257}}], 
    LineBox[{{4.1191774151524445`, 0}, {
      4.1191774151524445`, -0.8291496072337002}}], 
    LineBox[{{4.134415065665069, 0}, {
      4.134415065665069, -0.8375712755391325}}], 
    LineBox[{{4.164890366690317, 0}, {
      4.164890366690317, -0.8538292962794404}}], 
    LineBox[{{4.166795073004395, 0}, {
      4.166795073004395, -0.8548192476558022}}], 
    LineBox[{{4.168699779318473, 0}, {
      4.168699779318473, -0.855806097829102}}], 
    LineBox[{{4.172509191946629, 0}, {
      4.172509191946629, -0.8577704802569843}}], 
    LineBox[{{4.180128017202941, 0}, {
      4.180128017202941, -0.861661873902663}}], 
    LineBox[{{4.195365667715565, 0}, {
      4.195365667715565, -0.8692943895789487}}], 
    LineBox[{{4.225840968740814, 0}, {
      4.225840968740814, -0.8839521934370734}}], 
    LineBox[{{4.227907767009366, 0}, {
      4.227907767009366, -0.884916692708362}}], 
    LineBox[{{4.229974565277918, 0}, {
      4.229974565277918, -0.8858774119221076}}], 
    LineBox[{{4.234108161815023, 0}, {
      4.234108161815023, -0.8877874937776966}}], 
    LineBox[{{4.242375354889233, 0}, {
      4.242375354889233, -0.8915621173125434}}], 
    LineBox[{{4.258909741037652, 0}, {
      4.258909741037652, -0.8989283062064903}}], 
    LineBox[{{4.291978513334489, 0}, {
      4.291978513334489, -0.9129214911665804}}], 
    LineBox[{{4.294045311603041, 0}, {
      4.294045311603041, -0.9137630738725799}}], 
    LineBox[{{4.2961121098715935`, 0}, {
      4.2961121098715935`, -0.9146007532992904}}], 
    LineBox[{{4.300245706408699, 0}, {
      4.300245706408699, -0.9162643880184258}}], 
    LineBox[{{4.308512899482908, 0}, {
      4.308512899482908, -0.9195446617800588}}], 
    LineBox[{{4.325047285631326, 0}, {
      4.325047285631326, -0.9259164475524849}}], 
    LineBox[{{4.358116057928164, 0}, {
      4.358116057928164, -0.9378989661064421}}], 
    LineBox[{{4.360044413139687, 0}, {
      4.360044413139687, -0.9385661847535481}}], 
    LineBox[{{4.36197276835121, 0}, {4.36197276835121, -0.9392299132928624}}],
     LineBox[{{4.365829478774255, 0}, {
      4.365829478774255, -0.9405468901886643}}], 
    LineBox[{{4.373542899620345, 0}, {
      4.373542899620345, -0.9431388549606081}}], 
    LineBox[{{4.3889697413125255`, 0}, {
      4.3889697413125255`, -0.948154293060208}}], 
    LineBox[{{4.419823424696887, 0}, {
      4.419823424696887, -0.9575070963446649}}], 
    LineBox[{{4.421751779908409, 0}, {
      4.421751779908409, -0.9580614720957839}}], 
    LineBox[{{4.423680135119932, 0}, {
      4.423680135119932, -0.9586122852448583}}], 
    LineBox[{{4.427536845542977, 0}, {
      4.427536845542977, -0.9597032155572174}}], 
    LineBox[{{4.435250266389067, 0}, {
      4.435250266389067, -0.9618422357239117}}], 
    LineBox[{{4.450677108081248, 0}, {
      4.450677108081248, -0.9659484732670754}}], 
    LineBox[{{4.481530791465609, 0}, {
      4.481530791465609, -0.9734703886979993}}], 
    LineBox[{{4.483621238631606, 0}, {
      4.483621238631606, -0.9739465828809345}}], 
    LineBox[{{4.485711685797603, 0}, {
      4.485711685797603, -0.9744185209487001}}], 
    LineBox[{{4.489892580129597, 0}, {
      4.489892580129597, -0.9753496205079142}}], 
    LineBox[{{4.498254368793584, 0}, {
      4.498254368793584, -0.9771606567479661}}], 
    LineBox[{{4.51497794612156, 0}, {4.51497794612156, -0.9805776407913966}}],
     LineBox[{{4.517068393287556, 0}, {
      4.517068393287556, -0.9809855000855563}}], 
    LineBox[{{4.519158840453553, 0}, {
      4.519158840453553, -0.9813890725047052}}], 
    LineBox[{{4.523339734785547, 0}, {
      4.523339734785547, -0.982183349682318}}], 
    LineBox[{{4.531701523449534, 0}, {
      4.531701523449534, -0.9837203851951678}}], 
    LineBox[{{4.54842510077751, 0}, {4.54842510077751, -0.9865880110231746}}],
     LineBox[{{4.550515547943506, 0}, {
      4.550515547943506, -0.9869270791939445}}], 
    LineBox[{{4.552605995109504, 0}, {
      4.552605995109504, -0.9872618345251946}}], 
    LineBox[{{4.556786889441497, 0}, {
      4.556786889441497, -0.987918400836508}}], 
    LineBox[{{4.565148678105485, 0}, {
      4.565148678105485, -0.9891797162821415}}], 
    LineBox[{{4.567239125271482, 0}, {
      4.567239125271482, -0.989484241832617}}], 
    LineBox[{{4.5693295724374785`, 0}, {
      4.5693295724374785`, -0.9897844433688542}}], 
    LineBox[{{4.573510466769473, 0}, {
      4.573510466769473, -0.9903718691700315}}], 
    LineBox[{{4.58187225543346, 0}, {4.58187225543346, -0.9914947761459183}}],
     LineBox[{{4.583962702599457, 0}, {
      4.583962702599457, -0.9917646739089758}}], 
    LineBox[{{4.586053149765454, 0}, {
      4.586053149765454, -0.9920302376923803}}], 
    LineBox[{{4.590234044097448, 0}, {
      4.590234044097448, -0.9925483586971543}}], 
    LineBox[{{4.598595832761435, 0}, {
      4.598595832761435, -0.9935325431581933}}], 
    LineBox[{{4.615319410089411, 0}, {
      4.615319410089411, -0.9952924474135678}}], 
    LineBox[{{4.6172714141983775`, 0}, {
      4.6172714141983775`, -0.9954797338799681}}], 
    LineBox[{{4.619223418307345, 0}, {
      4.619223418307345, -0.995663227251192}}], 
    LineBox[{{4.623127426525279, 0}, {
      4.623127426525279, -0.9960188319258931}}], 
    LineBox[{{4.630935442961148, 0}, {
      4.630935442961148, -0.9966844943384429}}], 
    LineBox[{{4.6328874470701145`, 0}, {
      4.6328874470701145`, -0.9968414172764121}}], 
    LineBox[{{4.634839451179082, 0}, {
      4.634839451179082, -0.9969945419307571}}], 
    LineBox[{{4.638743459397016, 0}, {
      4.638743459397016, -0.9972893940692339}}], 
    LineBox[{{4.646551475832885, 0}, {
      4.646551475832885, -0.9978334942406683}}], 
    LineBox[{{4.648503479941851, 0}, {
      4.648503479941851, -0.9979600153836806}}], 
    LineBox[{{4.650455484050819, 0}, {
      4.650455484050819, -0.9980827339808533}}], 
    LineBox[{{4.654359492268753, 0}, {
      4.654359492268753, -0.9983167616817821}}], 
    LineBox[{{4.65631149637772, 0}, {4.65631149637772, -0.998428069893818}}], 
    LineBox[{{4.6582635004866875`, 0}, {
      4.6582635004866875`, -0.9985355737765774}}], 
    LineBox[{{4.662167508704622, 0}, {
      4.662167508704622, -0.9987391669302672}}], 
    LineBox[{{4.664119512813588, 0}, {
      4.664119512813588, -0.9988352554254427}}], 
    LineBox[{{4.666071516922556, 0}, {
      4.666071516922556, -0.9989275380398349}}], 
    LineBox[{{4.66997552514049, 0}, {4.66997552514049, -0.9991006842342673}}],
     LineBox[{{4.671927529249457, 0}, {
      4.671927529249457, -0.9991815471545655}}], 
    LineBox[{{4.673879533358424, 0}, {
      4.673879533358424, -0.9992586028745983}}], 
    LineBox[{{4.677783541576359, 0}, {
      4.677783541576359, -0.9994012915539486}}], 
    LineBox[{{4.679735545685325, 0}, {
      4.679735545685325, -0.9994669239695767}}], 
    LineBox[{{4.681687549794293, 0}, {
      4.681687549794293, -0.9995287480975628}}], 
    LineBox[{{4.6836395539032605`, 0}, {
      4.6836395539032605`, -0.9995867637023375}}], 
    LineBox[{{4.685591558012227, 0}, {
      4.685591558012227, -0.9996409705628425}}], 
    LineBox[{{4.687543562121194, 0}, {
      4.687543562121194, -0.9996913684725326}}], 
    LineBox[{{4.689495566230161, 0}, {
      4.689495566230161, -0.9997379572393758}}], 
    LineBox[{{4.691447570339129, 0}, {
      4.691447570339129, -0.9997807366858539}}], 
    LineBox[{{4.693399574448096, 0}, {
      4.693399574448096, -0.9998197066489635}}], 
    LineBox[{{4.695351578557062, 0}, {
      4.695351578557062, -0.9998548669802167}}], 
    LineBox[{{4.69730358266603, 0}, {4.69730358266603, -0.9998862175456416}}],
     LineBox[{{4.699255586774997, 0}, {
      4.699255586774997, -0.9999137582257822}}], 
    LineBox[{{4.701207590883964, 0}, {4.701207590883964, -0.9999374889157}}], 
    LineBox[{{4.703159594992931, 0}, {
      4.703159594992931, -0.9999574095249734}}], 
    LineBox[{{4.705111599101898, 0}, {
      4.705111599101898, -0.9999735199776986}}], 
    LineBox[{{4.707063603210866, 0}, {
      4.707063603210866, -0.9999858202124895}}], 
    LineBox[{{4.709015607319833, 0}, {
      4.709015607319833, -0.9999943101824783}}], 
    LineBox[{{4.710967611428799, 0}, {
      4.710967611428799, -0.9999989898553157}}], 
    LineBox[{{4.712919615537767, 0}, {
      4.712919615537767, -0.9999998592131705}}], 
    LineBox[{{4.714871619646734, 0}, {
      4.714871619646734, -0.9999969182527302}}], 
    LineBox[{{4.716823623755701, 0}, {
      4.716823623755701, -0.9999901669852007}}], 
    LineBox[{{4.718775627864668, 0}, {
      4.718775627864668, -0.9999796054363067}}], 
    LineBox[{{4.720727631973635, 0}, {
      4.720727631973635, -0.9999652336462909}}], 
    LineBox[{{4.722679636082603, 0}, {
      4.722679636082603, -0.9999470516699144}}], 
    LineBox[{{4.72463164019157, 0}, {4.72463164019157, -0.9999250595764564}}],
     LineBox[{{4.726583644300536, 0}, {
      4.726583644300536, -0.9998992574497138}}], 
    LineBox[{{4.728535648409504, 0}, {
      4.728535648409504, -0.9998696453880008}}], 
    LineBox[{{4.730487652518471, 0}, {
      4.730487652518471, -0.9998362235041489}}], 
    LineBox[{{4.732439656627438, 0}, {
      4.732439656627438, -0.9997989919255063}}], 
    LineBox[{{4.734391660736405, 0}, {
      4.734391660736405, -0.9997579507939368}}], 
    LineBox[{{4.736343664845372, 0}, {
      4.736343664845372, -0.9997131002658205}}], 
    LineBox[{{4.7402476730633065`, 0}, {
      4.7402476730633065`, -0.9996119717180407}}], 
    LineBox[{{4.742161412452412, 0}, {
      4.742161412452412, -0.9995568338809567}}], 
    LineBox[{{4.744075151841518, 0}, {
      4.744075151841518, -0.9994980352695916}}], 
    LineBox[{{4.747902630619728, 0}, {
      4.747902630619728, -0.9993694565987994}}], 
    LineBox[{{4.749816370008833, 0}, {
      4.749816370008833, -0.9992996770102786}}], 
    LineBox[{{4.751730109397938, 0}, {
      4.751730109397938, -0.9992262375892872}}], 
    LineBox[{{4.755557588176149, 0}, {
      4.755557588176149, -0.9990683803391527}}], 
    LineBox[{{4.757471327565255, 0}, {
      4.757471327565255, -0.9989839630881456}}], 
    LineBox[{{4.75938506695436, 0}, {4.75938506695436, -0.9988958871609377}}],
     LineBox[{{4.763212545732571, 0}, {
      4.763212545732571, -0.9987087605815942}}], 
    LineBox[{{4.770867503288993, 0}, {
      4.770867503288993, -0.9982906183991543}}], 
    LineBox[{{4.772781242678098, 0}, {
      4.772781242678098, -0.9981769415206926}}], 
    LineBox[{{4.774694982067203, 0}, {
      4.774694982067203, -0.9980596089216637}}], 
    LineBox[{{4.778522460845414, 0}, {
      4.778522460845414, -0.9978139782941661}}], 
    LineBox[{{4.786177418401836, 0}, {
      4.786177418401836, -0.9972788681968285}}], 
    LineBox[{{4.788091157790942, 0}, {
      4.788091157790942, -0.9971359583355132}}], 
    LineBox[{{4.790004897180047, 0}, {
      4.790004897180047, -0.9969893965661247}}], 
    LineBox[{{4.7938323759582575`, 0}, {
      4.7938323759582575`, -0.9966853194635711}}], 
    LineBox[{{4.801487333514679, 0}, {
      4.801487333514679, -0.9960333668752152}}], 
    LineBox[{{4.803401072903784, 0}, {
      4.803401072903784, -0.9958612575275346}}], 
    LineBox[{{4.80531481229289, 0}, {4.80531481229289, -0.9956855009402419}}],
     LineBox[{{4.8091422910711, 0}, {4.8091422910711, -0.9953230486349366}}], 
    LineBox[{{4.8167972486275215`, 0}, {
      4.8167972486275215`, -0.9945544063660269}}], 
    LineBox[{{4.818710988016627, 0}, {
      4.818710988016627, -0.9943531378725057}}], 
    LineBox[{{4.820624727405733, 0}, {
      4.820624727405733, -0.9941482276627056}}], 
    LineBox[{{4.824452206183943, 0}, {
      4.824452206183943, -0.9937274851094541}}], 
    LineBox[{{4.832107163740364, 0}, {
      4.832107163740364, -0.9928423333212237}}], 
    LineBox[{{4.83402090312947, 0}, {4.83402090312947, -0.9926119528569672}}],
     LineBox[{{4.835934642518575, 0}, {
      4.835934642518575, -0.9923779370533432}}], 
    LineBox[{{4.839762121296785, 0}, {
      4.839762121296785, -0.991899002869539}}], 
    LineBox[{{4.847417078853207, 0}, {
      4.847417078853207, -0.9908975490317617}}], 
    LineBox[{{4.86272699396605, 0}, {4.86272699396605, -0.988720509333535}}], 
    LineBox[{{4.86480282530963, 0}, {4.86480282530963, -0.988407477199899}}], 
    LineBox[{{4.86687865665321, 0}, {4.86687865665321, -0.9880901859450845}}],
     LineBox[{{4.871030319340369, 0}, {
      4.871030319340369, -0.9874428315591933}}], 
    LineBox[{{4.879333644714688, 0}, {
      4.879333644714688, -0.9860970747203687}}], 
    LineBox[{{4.895940295463326, 0}, {
      4.895940295463326, -0.9832016996684034}}], 
    LineBox[{{4.8980161268069065`, 0}, {
      4.8980161268069065`, -0.9828206959267954}}], 
    LineBox[{{4.900091958150486, 0}, {
      4.900091958150486, -0.9824354571378642}}], 
    LineBox[{{4.904243620837645, 0}, {
      4.904243620837645, -0.9816522810763635}}], 
    LineBox[{{4.912546946211964, 0}, {
      4.912546946211964, -0.9800351826482793}}], 
    LineBox[{{4.929153596960601, 0}, {
      4.929153596960601, -0.9765983969046794}}], 
    LineBox[{{4.9312294283041815`, 0}, {
      4.9312294283041815`, -0.9761498418106058}}], 
    LineBox[{{4.933305259647761, 0}, {
      4.933305259647761, -0.9756970804144146}}], 
    LineBox[{{4.9374569223349205`, 0}, {
      4.9374569223349205`, -0.9747789465377251}}], 
    LineBox[{{4.945760247709239, 0}, {
      4.945760247709239, -0.9728922902155126}}], 
    LineBox[{{4.962366898457876, 0}, {
      4.962366898457876, -0.9689178846305395}}], 
    LineBox[{{4.9955801999551515`, 0}, {
      4.9955801999551515`, -0.9601686346199421}}], 
    LineBox[{{4.997517588241701, 0}, {
      4.997517588241701, -0.9596254856638143}}], 
    LineBox[{{4.999454976528251, 0}, {
      4.999454976528251, -0.9590787347801046}}], 
    LineBox[{{5.003329753101351, 0}, {
      5.003329753101351, -0.9579744354523093}}], 
    LineBox[{{5.0110793062475505`, 0}, {
      5.0110793062475505`, -0.9557227048680352}}], 
    LineBox[{{5.02657841253995, 0}, {5.02657841253995, -0.9510471938096906}}],
     LineBox[{{5.057576625124749, 0}, {
      5.057576625124749, -0.9410119752114029}}], 
    LineBox[{{5.059514013411299, 0}, {
      5.059514013411299, -0.9403546492016023}}], 
    LineBox[{{5.061451401697849, 0}, {
      5.061451401697849, -0.9396937935967685}}], 
    LineBox[{{5.065326178270949, 0}, {
      5.065326178270949, -0.9383615035372543}}], 
    LineBox[{{5.073075731417148, 0}, {
      5.073075731417148, -0.9356546783064531}}], 
    LineBox[{{5.088574837709547, 0}, {
      5.088574837709547, -0.9300726207859755}}], 
    LineBox[{{5.119573050294346, 0}, {
      5.119573050294346, -0.9182396411990768}}], 
    LineBox[{{5.1216725305353705`, 0}, {
      5.1216725305353705`, -0.9174061710059187}}], 
    LineBox[{{5.1237720107763955`, 0}, {
      5.1237720107763955`, -0.9165686570554701}}], 
    LineBox[{{5.127970971258444, 0}, {
      5.127970971258444, -0.9148815126669392}}], 
    LineBox[{{5.13636889222254, 0}, {5.13636889222254, -0.9114588624253163}}],
     LineBox[{{5.153164734150735, 0}, {
      5.153164734150735, -0.9044209668719675}}], 
    LineBox[{{5.186756418007123, 0}, {
      5.186756418007123, -0.8895818387807382}}], 
    LineBox[{{5.253939785719899, 0}, {
      5.253939785719899, -0.8569103254512629}}], 
    LineBox[{{5.256001001241062, 0}, {
      5.256001001241062, -0.8558460203515068}}], 
    LineBox[{{5.258062216762224, 0}, {
      5.258062216762224, -0.8547780790975703}}], 
    LineBox[{{5.262184647804549, 0}, {
      5.262184647804549, -0.8526313062916386}}], 
    LineBox[{{5.270429509889199, 0}, {
      5.270429509889199, -0.8482943275018867}}], 
    LineBox[{{5.286919234058499, 0}, {
      5.286919234058499, -0.8394476742174765}}], 
    LineBox[{{5.319898682397099, 0}, {
      5.319898682397099, -0.821072085497253}}], 
    LineBox[{{5.3858575790743, 0}, {5.3858575790743, -0.7816630038752191}}], 
    LineBox[{{5.508915016778795, 0}, {
      5.508915016778795, -0.6991945692154065}}], 
    LineBox[{{5.642346339569648, 0}, {
      5.642346339569648, -0.5978681634714186}}], 
    LineBox[{{5.766917306710594, 0}, {
      5.766917306710594, -0.49363798436551354`}}], 
    LineBox[{{5.889039331780388, 0}, {
      5.889039331780388, -0.3840197868001835}}], 
    LineBox[{{6.02153524193654, 0}, {6.02153524193654, -0.2586748077041959}}],
     LineBox[{{6.145170796442786, 0}, {
      6.145170796442786, -0.13757677765618304`}}], 
    LineBox[{{6.147327271169481, 0}, {
      6.147327271169481, -0.13544049038322992`}}], 
    LineBox[{{6.149483745896177, 0}, {
      6.149483745896177, -0.13330357326033349`}}], 
    LineBox[{{6.153796695349569, 0}, {
      6.153796695349569, -0.1290278892175115}}], 
    LineBox[{{6.162422594256352, 0}, {
      6.162422594256352, -0.12046940037221723`}}], 
    LineBox[{{6.179674392069918, 0}, {
      6.179674392069918, -0.10332616932911103`}}], 
    LineBox[{{6.214177987697051, 0}, {
      6.214177987697051, -0.06895256359568983}}], 
    LineBox[{{6.216334462423746, 0}, {
      6.216334462423746, -0.06680106274856792}}], 
    LineBox[{{6.218490937150442, 0}, {
      6.218490937150442, -0.06464925125102332}}], 
    LineBox[{{6.222803886603834, 0}, {
      6.222803886603834, -0.06034473633304029}}], 
    LineBox[{{6.231429785510617, 0}, {
      6.231429785510617, -0.05173241907981701}}], 
    LineBox[{{6.248681583324183, 0}, {
      6.248681583324183, -0.03449687810901284}}], 
    LineBox[{{6.250838058050879, 0}, {
      6.250838058050879, -0.03234160836264792}}], 
    LineBox[{{6.252994532777574, 0}, {
      6.252994532777574, -0.030186188215467574`}}], 
    LineBox[{{6.257307482230966, 0}, {
      6.257307482230966, -0.025874936813415964`}}], 
    LineBox[{{6.265933381137749, 0}, {
      6.265933381137749, -0.01725107027579387}}], 
    LineBox[{{6.268089855864445, 0}, {
      6.268089855864445, -0.015094878014923548`}}], 
    LineBox[{{6.2702463305911404`, 0}, {
      6.2702463305911404`, -0.012938615557112596`}}], 
    LineBox[{{6.274559280044532, 0}, {
      6.274559280044532, -0.008625920160720307}}], 
    LineBox[{{6.276715754771227, 0}, {
      6.276715754771227, -0.006469507277817619}}], 
    LineBox[{{6.278872229497923, 0}, {
      6.278872229497923, -0.004313064309238329}}], 
    LineBox[{{6.281028704224619, 0}, {
      6.281028704224619, -0.002156601283263917}}], 
    LineBox[{{6.283185178951315, 0}, {
      6.283185178951315, -1.2822827180138103`*^-7}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998592131705, 0.9999998782112116}}, {{
     0, 6.283185307179586}, {-0.9999998592131705, 0.9999998782112116}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
First set the distribution and compute the mean and standard deviation.\
\>", "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[ScriptCapitalD]", "=", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]", "=", 
   RowBox[{"StandardDeviation", "[", "\[ScriptCapitalD]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Mu]", "=", 
   RowBox[{"Mean", "[", "\[ScriptCapitalD]", "]"}]}], ";"}]}], "Input",
 CellTags->"10.1 Solutions"],

Cell["\<\
Next we manually construct four vertical lines at the standard deviations \
going from the horizontal axis to the pdf curve.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"\[ScriptCapitalD]", ",", "x"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"White", ",", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "+", "\[Sigma]"}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "+", "\[Sigma]"}], ",", 
             RowBox[{"PDF", "[", 
              RowBox[{"\[ScriptCapitalD]", ",", 
               RowBox[{"\[Mu]", "+", "\[Sigma]"}]}], "]"}]}], "}"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "-", "\[Sigma]"}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "-", "\[Sigma]"}], ",", 
             RowBox[{"PDF", "[", 
              RowBox[{"\[ScriptCapitalD]", ",", 
               RowBox[{"\[Mu]", "-", "\[Sigma]"}]}], "]"}]}], "}"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "+", 
              RowBox[{"2", " ", "\[Sigma]"}]}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "+", 
              RowBox[{"2", " ", "\[Sigma]"}]}], ",", 
             RowBox[{"PDF", "[", 
              RowBox[{"\[ScriptCapitalD]", ",", 
               RowBox[{"\[Mu]", "+", 
                RowBox[{"2", " ", "\[Sigma]"}]}]}], "]"}]}], "}"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "-", 
              RowBox[{"2", " ", "\[Sigma]"}]}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Mu]", "-", 
              RowBox[{"2", " ", "\[Sigma]"}]}], ",", 
             RowBox[{"PDF", "[", 
              RowBox[{"\[ScriptCapitalD]", ",", 
               RowBox[{"\[Mu]", "-", 
                RowBox[{"2", " ", "\[Sigma]"}]}]}], "]"}]}], "}"}]}], "}"}]}],
         "}"}], "]"}]}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "4"}], ",", "0"}], "}"}]}], ",", 
   RowBox[{"Ticks", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[Sigma]"}], ",", "\"\<-2\[Sigma]\>\""}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "\[Sigma]"}], ",", "\"\<-\[Sigma]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Mu]", ",", "\"\<\[Mu]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "\"\<\[Sigma]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", " ", "\[Sigma]"}], ",", "\"\<2\[Sigma]\>\""}], "}"}]}],
        "}"}], ",", "Automatic"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "0.4"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", 
    RowBox[{"StringForm", "[", 
     RowBox[{
     "\"\<Normal distribution: \[Mu]=`1`, \
\[Sigma]=`2`\!\(\*Cell[\"\"]\)\!\(\*Cell[\"\"]\)\>\"", ",", "\[Mu]", ",", 
      "\[Sigma]"}], "]"}]}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw1eXk0Vd/7P9d03cu9UkolJBRRRArxbFKRIWSeGwxRokJSppAh8TaFUOZZ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   "], {{{}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], EdgeForm[None], 
      GraphicsGroupBox[PolygonBox[CompressedData["
1:eJwl1WWcFVUYwOFl6ZZOgaVbSqTEABRFGqRBke6WULpDBaW7W1JQ6RCkUUJB
WrqlpASfAx+e33n/Z+buvTszdzeqcftq7SIjIiKikS/y5Zo38uVcyJzHut5m
FmtN62rSmR84VtG8hGR6ur5AKT2ZSHt19B0+0AtIbK+v3sGr+gv+pqCexnlK
6klEc25t/Q/l9XwS2eujfyG97sU5Cuip/E0JPTH8Es6tZbnN+3oeCe311ttJ
p3tyltf0FM5RXE/gOR/rW7xnnksCr/9SbyOt7sEZ8uvJnKWYHs8zauov2Eoa
3Z3T5NOTOMMbehz/UUP3Ygup9eecIq+eyGmK6rE8pbruyWZS6W6cJI+ewCle
19/xhGq6B5tIqbtygtx6PCcpor/lMVV1dzaSQnfhL3LpcZygsB7DI6roz9lA
ct2Z4+TUY/mLQno0D6msu7GeZLoTx8ihv+M4BfU3/Esl3ZV1JNUd+ZPs+luO
UUB/zQMq6i78TBLdgT/Ipj+iMz/xir32HCWrrkAnfiSxvXYcCd8BnZkoMpGR
DHxIR9aSyHltOcyr4dmnA2tIaK8Nh0ivx/Anr+mvuE953Z4fSKBb83v4zun7
4XObF5PUszha/0F+PYp7vK9vUs48h/jOa6crm78nhV6t45tb8RtpdQ3rqjA7
fi/87uaM5grWRSQxfxOupTnKXDVcd+tyayrrUcdyWteE3zv8/QjX0jrSepf3
HM+t15kzW6uF+2xdYU1tveF4LutancFaNtwn62xrPGvbcK/MmcyVrEtJbl4V
rlW4nuZ41pYcJI396taVYXbsbrhP5oW8or/WVczLSKmP6LzmEdyhnL5OGfMs
4jqnjV5JXN2CA+Gz6684TB49nH8oq6/xrnkmcby+tV5BHN2c/eHa6VEcCtdH
D+M2ZXQrlhNbN2Nf+KzhZ9KSZcSy15S94d6G7134LoXvR3jmw7PNO7Tge2I6
rwl7SKzfpjlLiWHvM3aTSL9FM5YQ3V5jdpFQj+T3cM/0UG5RWjdlMZH6U34l
gR7Bb+EZ0UO4yZu6CYuIpj9hZ3hm9XAOkkMP5gal9GcsjIh48Y+qETvC8yGH
cYDsehDXKakbs4DnNLT3S7iX5qHsJ5seyDVK6E+ZzzMa2Nse7p15CPvIqgdw
leL6E+bxH/XtbSO2eTB7yaL7c4ViuhFzeUo9e1uJZR7EHjLrflzmDX013D/z
jPBzPUMN9RyeUNfeFmKaB7KbKN2XSxTVV8I9Nk8P7+P1DfRsHlPH3mZimAew
i0y6Dxd5XV8Oz4F5Wngfr6+vZ/GI2vY2Ed3cn1/JqHtzgSL6EqXNU8P7eH09
PZOH1LK3MdqLf9UR/dhJBv0l5ymsL/KmeUp4HyfW1TP4l4/tbeB/ZNMGWw==

        "]]]}, {}, {}}, {{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1mW4VFUYgNGLgDQIKN2tSDdSUtISCijdIQIS0lLSoXSHdEkK0t3dSEpI
g4SUAuLajz8W+3v3nGGGmX3uJW3jdtXbRoqIiMj6VkREWDf5oybPzTP5ksge
m2qvKDd0Hv4w9yIVe3RfXBaxWdfihfkn6hDFA9PsFeOmzst183ekZq/uF16H
Lbo2f5tnUZeonj/dXnFu6XzcMPcmDft0//A6bNVf8I95NvV42/Nn2CvBbZ2f
m+Y+pGW//j68Dtv0l7w0z6E+0Tx/pr2PuaMLcMvcl3Qc0APC67Bd1+GVeS4N
KMhte/1Iz0E9MPy97NB1eW2eR0MKccdefzJwSA8iOjt1Pf41z6cRhblr73sy
clgPJga7dH3emBfQmI+4Z28AmTiihxCT3bpBOAgstDShCPf1QDJzVA8lFnt0
QyKxSDelKH/qQWThmB5GbPbqRrzFYt2MYjzQg3mf43o4cdinGxOZJbo5xYnL
fntNiMLPugUliMcBe02JylLdko95h/gkICHv8h4HXdeMt1mmW1GSRByy15xo
LNetKcVDPYQPOKFHkJjDugXRWaG/Ct+dM/STLsldXZpH5qFk5aQeSRKO6JbE
YKVuE75Lz5+lS3FPl+GxeRgfciq8V9csM1flh/Bv1QvNFfhLJ9UrzTVIqo9a
WxGTFB5bbV0VPhPzz+Yq4f4yr7N+Hc6HeXY4Y9bS4d63/hq+M+v98N6tK8IZ
sVYP94Z1Q/h8rGU9/pd5eDjTOps1pXVNOCPW0+Gzsy4PZ9JaLdyb1vXWH8N3
Zl5krhh+ZpjXWp/YT2ZeZf6MZPqYtTWx+CV8tx5fav6UtuHM6jnmMvypP+GJ
eQTZOaNHhfPhusW6Ek91co6bvyI2q3U7yvFUjyQHv+nRpOCEbkMc1uj2lCcl
J8NnSlx+1d9QgVSkJg1pSUd6ToX3TzzW6g5UJAOn7bXjHdbpjlQiI2fstSc+
63UnKvMsnBFyclaPIRO/6W9IwAbdmSo8D98DuTinx5KZs7oDCdmov+VTXuhR
5Oa8HkcWzumOvMsm3YWq/K1Hk4cLejzvc1534j02665U4x89hrxc1BP4gAu6
M4nYortRnZd6LPm4pCeSlYv6WxKzVXenBq/0OPLzu57Eh1zSXUjCNt2Dz3it
x1OAy3oy2fhddw33G9t1Tz7nXz2BglzRU8jOZd0tnGV26F7Edhbn6rI80DV5
Y55IIa7qqeTgiu5Ocnbq74jj+fP0JzzUtQi/rCfpwlyT08jJVd0j/Dxgl+5N
XNfO1+V4pGsTyd5k/RF/6Onk4pruGe5tdus+xHPtAl2ex/qL8PL2pugiXNcz
SGhvia7Ms3DP6V/Mn5PevDHS//9Pye2x/wBKOAX6
       "]]}}}],
  AspectRatio->0.4,
  Axes->True,
  AxesOrigin->{-4, 0},
  Epilog->{
    GrayLevel[1], 
    LineBox[
     NCache[{{{1, 0}, {1, ((2 E) Pi)^Rational[-1, 2]}}, {{-1, 
        0}, {-1, ((2 E) Pi)^Rational[-1, 2]}}, {{2, 0}, {
        2, E^(-2) (2 Pi)^Rational[-1, 2]}}, {{-2, 
        0}, {-2, E^(-2) (2 Pi)^Rational[-1, 2]}}}, {{{1, 0}, {
        1, 0.24197072451914337`}}, {{-1, 0}, {-1, 0.24197072451914337`}}, {{2,
         0}, {2, 0.05399096651318806}}, {{-2, 
        0}, {-2, 0.05399096651318806}}}]]},
  ImageSize->140,
  Method->{"AxesInFront" -> True},
  PlotLabel->FormBox[
    StyleBox[
     InterpretationBox[
     "\"Normal distribution: \[Mu]=\\!\\(TraditionalForm\\`0\\), \[Sigma]=\\!\
\\(TraditionalForm\\`1\\)\\!\\(\\*Cell[\\\"\\\"]\\)\\!\\(\\*Cell[\\\"\\\"]\\)\
\"", 
      StringForm[
      "Normal distribution: \[Mu]=`1`, \
\[Sigma]=`2`\!\(\*Cell[\"\"]\)\!\(\*Cell[\"\"]\)", 0, 1], Editable -> False], 
     "Menu", 8, StripOnInput -> False], TraditionalForm],
  PlotRange->{{-4, 4}, {0., 0.39894220478008047`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{-2, 
      FormBox["\"-2\[Sigma]\"", TraditionalForm]}, {-1, 
      FormBox["\"-\[Sigma]\"", TraditionalForm]}, {0, 
      FormBox["\"\[Mu]\"", TraditionalForm]}, {1, 
      FormBox["\"\[Sigma]\"", TraditionalForm]}, {2, 
      FormBox["\"2\[Sigma]\"", TraditionalForm]}}, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],

Cell["\<\
And here is a little utility function to make the code a bit more readable \
and easier to use.\
\>", "SolutionText",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sdLine", "[", 
   RowBox[{"\[ScriptCapitalD]_", ",", "\[Mu]_", ",", "\[Sigma]_"}], "]"}], ":=", 
  RowBox[{"Line", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Mu]", "+", "\[Sigma]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Sigma]", "+", "\[Mu]"}], ",", 
         RowBox[{"PDF", "[", 
          RowBox[{"\[ScriptCapitalD]", ",", 
           RowBox[{"\[Mu]", "+", "\[Sigma]"}]}], "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Mu]", "-", "\[Sigma]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Sigma]"}], "+", "\[Mu]"}], ",", 
         RowBox[{"PDF", "[", 
          RowBox[{"\[ScriptCapitalD]", ",", 
           RowBox[{"\[Mu]", "-", "\[Sigma]"}]}], "]"}]}], "}"}]}], "}"}]}], 
    "}"}], "]"}]}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"\[ScriptCapitalD]", ",", "x"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"White", ",", 
      RowBox[{"Thickness", "[", ".0035", "]"}], ",", 
      RowBox[{"sdLine", "[", 
       RowBox[{"\[ScriptCapitalD]", ",", "\[Mu]", ",", "\[Sigma]"}], "]"}], 
      ",", 
      RowBox[{"sdLine", "[", 
       RowBox[{"\[ScriptCapitalD]", ",", "\[Mu]", ",", 
        RowBox[{"2", " ", "\[Sigma]"}]}], "]"}]}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "4"}], ",", "0"}], "}"}]}], ",", 
   RowBox[{"Ticks", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[Sigma]"}], ",", "\"\<-2\[Sigma]\>\""}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "\[Sigma]"}], ",", "\"\<-\[Sigma]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Mu]", ",", "\"\<\[Mu]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "\"\<\[Sigma]\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", " ", "\[Sigma]"}], ",", "\"\<2\[Sigma]\>\""}], "}"}]}],
        "}"}], ",", "Automatic"}], "}"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "0.4"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", 
    RowBox[{"StringForm", "[", 
     RowBox[{
     "\"\<Normal distribution: \[Mu]=`1`, \
\[Sigma]=`2`\!\(\*Cell[\"\"]\)\!\(\*Cell[\"\"]\)\>\"", ",", "\[Mu]", ",", 
      "\[Sigma]"}], "]"}]}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJw1eXk0Vd/7P9d03cu9UkolJBRRRArxbFKRIWSeGwxRokJSppAh8TaFUOZZ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   "], {{{}, 
     {Hue[0.67, 0.6, 0.6], Opacity[0.2], EdgeForm[None], 
      GraphicsGroupBox[PolygonBox[CompressedData["
1:eJwl1WWcFVUYwOFl6ZZOgaVbSqTEABRFGqRBke6WULpDBaW7W1JQ6RCkUUJB
WrqlpASfAx+e33n/Z+buvTszdzeqcftq7SIjIiKikS/y5Zo38uVcyJzHut5m
FmtN62rSmR84VtG8hGR6ur5AKT2ZSHt19B0+0AtIbK+v3sGr+gv+pqCexnlK
6klEc25t/Q/l9XwS2eujfyG97sU5Cuip/E0JPTH8Es6tZbnN+3oeCe311ttJ
p3tyltf0FM5RXE/gOR/rW7xnnksCr/9SbyOt7sEZ8uvJnKWYHs8zauov2Eoa
3Z3T5NOTOMMbehz/UUP3Ygup9eecIq+eyGmK6rE8pbruyWZS6W6cJI+ewCle
19/xhGq6B5tIqbtygtx6PCcpor/lMVV1dzaSQnfhL3LpcZygsB7DI6roz9lA
ct2Z4+TUY/mLQno0D6msu7GeZLoTx8ihv+M4BfU3/Esl3ZV1JNUd+ZPs+luO
UUB/zQMq6i78TBLdgT/Ipj+iMz/xir32HCWrrkAnfiSxvXYcCd8BnZkoMpGR
DHxIR9aSyHltOcyr4dmnA2tIaK8Nh0ivx/Anr+mvuE953Z4fSKBb83v4zun7
4XObF5PUszha/0F+PYp7vK9vUs48h/jOa6crm78nhV6t45tb8RtpdQ3rqjA7
fi/87uaM5grWRSQxfxOupTnKXDVcd+tyayrrUcdyWteE3zv8/QjX0jrSepf3
HM+t15kzW6uF+2xdYU1tveF4LutancFaNtwn62xrPGvbcK/MmcyVrEtJbl4V
rlW4nuZ41pYcJI396taVYXbsbrhP5oW8or/WVczLSKmP6LzmEdyhnL5OGfMs
4jqnjV5JXN2CA+Gz6684TB49nH8oq6/xrnkmcby+tV5BHN2c/eHa6VEcCtdH
D+M2ZXQrlhNbN2Nf+KzhZ9KSZcSy15S94d6G7134LoXvR3jmw7PNO7Tge2I6
rwl7SKzfpjlLiWHvM3aTSL9FM5YQ3V5jdpFQj+T3cM/0UG5RWjdlMZH6U34l
gR7Bb+EZ0UO4yZu6CYuIpj9hZ3hm9XAOkkMP5gal9GcsjIh48Y+qETvC8yGH
cYDsehDXKakbs4DnNLT3S7iX5qHsJ5seyDVK6E+ZzzMa2Nse7p15CPvIqgdw
leL6E+bxH/XtbSO2eTB7yaL7c4ViuhFzeUo9e1uJZR7EHjLrflzmDX013D/z
jPBzPUMN9RyeUNfeFmKaB7KbKN2XSxTVV8I9Nk8P7+P1DfRsHlPH3mZimAew
i0y6Dxd5XV8Oz4F5Wngfr6+vZ/GI2vY2Ed3cn1/JqHtzgSL6EqXNU8P7eH09
PZOH1LK3MdqLf9UR/dhJBv0l5ymsL/KmeUp4HyfW1TP4l4/tbeB/ZNMGWw==

        "]]]}, {}, {}}, {{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1mW4VFUYgNGLgDQIKN2tSDdSUtISCijdIQIS0lLSoXSHdEkK0t3dSEpI
g4SUAuLajz8W+3v3nGGGmX3uJW3jdtXbRoqIiMj6VkREWDf5oybPzTP5ksge
m2qvKDd0Hv4w9yIVe3RfXBaxWdfihfkn6hDFA9PsFeOmzst183ekZq/uF16H
Lbo2f5tnUZeonj/dXnFu6XzcMPcmDft0//A6bNVf8I95NvV42/Nn2CvBbZ2f
m+Y+pGW//j68Dtv0l7w0z6E+0Tx/pr2PuaMLcMvcl3Qc0APC67Bd1+GVeS4N
KMhte/1Iz0E9MPy97NB1eW2eR0MKccdefzJwSA8iOjt1Pf41z6cRhblr73sy
clgPJga7dH3emBfQmI+4Z28AmTiihxCT3bpBOAgstDShCPf1QDJzVA8lFnt0
QyKxSDelKH/qQWThmB5GbPbqRrzFYt2MYjzQg3mf43o4cdinGxOZJbo5xYnL
fntNiMLPugUliMcBe02JylLdko95h/gkICHv8h4HXdeMt1mmW1GSRByy15xo
LNetKcVDPYQPOKFHkJjDugXRWaG/Ct+dM/STLsldXZpH5qFk5aQeSRKO6JbE
YKVuE75Lz5+lS3FPl+GxeRgfciq8V9csM1flh/Bv1QvNFfhLJ9UrzTVIqo9a
WxGTFB5bbV0VPhPzz+Yq4f4yr7N+Hc6HeXY4Y9bS4d63/hq+M+v98N6tK8IZ
sVYP94Z1Q/h8rGU9/pd5eDjTOps1pXVNOCPW0+Gzsy4PZ9JaLdyb1vXWH8N3
Zl5krhh+ZpjXWp/YT2ZeZf6MZPqYtTWx+CV8tx5fav6UtuHM6jnmMvypP+GJ
eQTZOaNHhfPhusW6Ek91co6bvyI2q3U7yvFUjyQHv+nRpOCEbkMc1uj2lCcl
J8NnSlx+1d9QgVSkJg1pSUd6ToX3TzzW6g5UJAOn7bXjHdbpjlQiI2fstSc+
63UnKvMsnBFyclaPIRO/6W9IwAbdmSo8D98DuTinx5KZs7oDCdmov+VTXuhR
5Oa8HkcWzumOvMsm3YWq/K1Hk4cLejzvc1534j02665U4x89hrxc1BP4gAu6
M4nYortRnZd6LPm4pCeSlYv6WxKzVXenBq/0OPLzu57Eh1zSXUjCNt2Dz3it
x1OAy3oy2fhddw33G9t1Tz7nXz2BglzRU8jOZd0tnGV26F7Edhbn6rI80DV5
Y55IIa7qqeTgiu5Ocnbq74jj+fP0JzzUtQi/rCfpwlyT08jJVd0j/Dxgl+5N
XNfO1+V4pGsTyd5k/RF/6Onk4pruGe5tdus+xHPtAl2ex/qL8PL2pugiXNcz
SGhvia7Ms3DP6V/Mn5PevDHS//9Pye2x/wBKOAX6
       "]]}}}],
  AspectRatio->0.4,
  Axes->True,
  AxesOrigin->{-4, 0},
  Epilog->{
    GrayLevel[1], 
    Thickness[0.0035], 
    LineBox[
     NCache[{{{1, 0}, {1, ((2 E) Pi)^Rational[-1, 2]}}, {{-1, 
        0}, {-1, ((2 E) Pi)^Rational[-1, 2]}}}, {{{1, 0}, {
        1, 0.24197072451914337`}}, {{-1, 0}, {-1, 0.24197072451914337`}}}]], 
    LineBox[
     NCache[{{{2, 0}, {2, E^(-2) (2 Pi)^Rational[-1, 2]}}, {{-2, 
        0}, {-2, E^(-2) (2 Pi)^Rational[-1, 2]}}}, {{{2, 0}, {
        2, 0.05399096651318806}}, {{-2, 0}, {-2, 0.05399096651318806}}}]]},
  ImageSize->140,
  Method->{"AxesInFront" -> True},
  PlotLabel->FormBox[
    StyleBox[
     InterpretationBox[
     "\"Normal distribution: \[Mu]=\\!\\(TraditionalForm\\`0\\), \[Sigma]=\\!\
\\(TraditionalForm\\`1\\)\\!\\(\\*Cell[\\\"\\\"]\\)\\!\\(\\*Cell[\\\"\\\"]\\)\
\"", 
      StringForm[
      "Normal distribution: \[Mu]=`1`, \
\[Sigma]=`2`\!\(\*Cell[\"\"]\)\!\(\*Cell[\"\"]\)", 0, 1], Editable -> False], 
     "Menu", 8, StripOnInput -> False], TraditionalForm],
  PlotRange->{{-4, 4}, {0., 0.39894220478008047`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{-2, 
      FormBox["\"-2\[Sigma]\"", TraditionalForm]}, {-1, 
      FormBox["\"-\[Sigma]\"", TraditionalForm]}, {0, 
      FormBox["\"\[Mu]\"", TraditionalForm]}, {1, 
      FormBox["\"\[Sigma]\"", TraditionalForm]}, {2, 
      FormBox["\"2\[Sigma]\"", TraditionalForm]}}, Automatic}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Following the discussion of options in ",
 "Section",
 " ",
 StyleBox["5.7", "OsF"],
 ", we use ",
 Cell[BoxData[
  ButtonBox["OptionsPattern",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/OptionsPattern"]], "InlineFormula"],
 " to inherit options from ",
 Cell[BoxData[
  ButtonBox["ArrayPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ArrayPlot"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProteinDotPlot", "[", 
   RowBox[{"p1_", ",", "p2_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "ArrayPlot", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ArrayPlot", "[", 
   RowBox[{
    RowBox[{"Outer", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Boole", "[", 
        RowBox[{"#1", "==", "#2"}], "]"}], "&"}], ",", 
      RowBox[{"Characters", "[", "p1", "]"}], ",", 
      RowBox[{"Characters", "[", "p2", "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", "opts", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}]], "InputOnly",
 CellTags->"10.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"seq1", "=", 
   RowBox[{"ProteinData", "[", "\"\<SCNN1A\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"seq2", "=", 
   RowBox[{"ProteinData", "[", "\"\<SCNN1G\>\"", "]"}]}], ";"}]}], "InputOnly",\

 CellTags->"10.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProteinDotPlot", "[", 
  RowBox[{"seq1", ",", "seq2", ",", "\[IndentingNewLine]", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<SCNN1A\>\"", ",", "\"\<SCNN1G\>\""}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"LabelStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", "11"}], 
     "}"}]}]}], "]"}]], "Input",
 CellTags->"10.1 Solutions"],

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJztXYuZ6zhvpdNJWkoJaSB1pIj0mv12xjZJ4AAHICk/Bkj+vWMSL5HAASRL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   "], {{0, 0}, {649, 669}}, {0, 1}],
  Frame->True,
  FrameLabel->{
    FormBox["\"SCNN1G\"", TraditionalForm], 
    FormBox["\"SCNN1A\"", TraditionalForm]},
  FrameTicks->{{None, None}, {None, None}},
  ImagePadding->{{18, 2}, {16, 2}},
  ImageSize->{Automatic, 110},
  LabelStyle->{FontFamily -> "Times", 11}]], "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Efficient structures", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell["Create a hexagonal grid of polygons like the one below.", "ExerciseItem",
 CellTags->{"10.2 Exercises", "i:50"}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnWtTm0eWx7OXF/s19v1+id2PMPsJZqp2327V7FRNTSWZXNYz48RO7DiJ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    "], {{0, 157}, {300, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{192.30769230769295`, Automatic},
  ImageSizeRaw->{300, 157},
  PlotRange->{{0, 300}, {0, 157}}]], "Picture",
 CellTags->"10.2 Exercises"],

Cell[TextData[{
 "First create the grid by performing appropriate translations using either \
",
 Cell[BoxData[
  ButtonBox["Translate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Translate"]]],
 " or the geometric transformation ",
 Cell[BoxData[
  ButtonBox["TranslationTransform",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/TranslationTransform"]]],
 ". Compare this approach with a multi-polygon approach."
}], "ExerciseText",
 CellTags->{"10.2 Exercises", "i:51"}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a graphic consisting of a three-dimensional lattice, that is, lines \
on the integer coordinates in ",
 StyleBox["3", "OsF"],
 "-space. Compare approaches that use multi-lines as opposed to those that do \
not."
}], "ExerciseItem",
 CellTags->{"10.2 Exercises", "i:52"}],

Cell[BoxData[
 Graphics3DBox[
  {RGBColor[
    NCache[
     Rational[1, 3], 0.3333333333333333], 
    NCache[
     Rational[1, 3], 0.3333333333333333], 1], AbsoluteThickness[
   0.1], {Line3DBox[{{{0, 0, 0}, {3, 0, 0}}, {{0, 0, 1}, {3, 0, 1}}, {{0, 0, 
     2}, {3, 0, 2}}, {{0, 0, 3}, {3, 0, 3}}}], 
    Line3DBox[{{{0, 1, 0}, {3, 1, 0}}, {{0, 1, 1}, {3, 1, 1}}, {{0, 1, 2}, {3,
      1, 2}}, {{0, 1, 3}, {3, 1, 3}}}], 
    Line3DBox[{{{0, 2, 0}, {3, 2, 0}}, {{0, 2, 1}, {3, 2, 1}}, {{0, 2, 2}, {3,
      2, 2}}, {{0, 2, 3}, {3, 2, 3}}}], 
    Line3DBox[{{{0, 3, 0}, {3, 3, 0}}, {{0, 3, 1}, {3, 3, 1}}, {{0, 3, 2}, {3,
      3, 2}}, {{0, 3, 3}, {3, 3, 3}}}]}, {
    Line3DBox[{{{0, 0, 0}, {0, 3, 0}}, {{0, 0, 1}, {0, 3, 1}}, {{0, 0, 2}, {0,
      3, 2}}, {{0, 0, 3}, {0, 3, 3}}}], 
    Line3DBox[{{{1, 0, 0}, {1, 3, 0}}, {{1, 0, 1}, {1, 3, 1}}, {{1, 0, 2}, {1,
      3, 2}}, {{1, 0, 3}, {1, 3, 3}}}], 
    Line3DBox[{{{2, 0, 0}, {2, 3, 0}}, {{2, 0, 1}, {2, 3, 1}}, {{2, 0, 2}, {2,
      3, 2}}, {{2, 0, 3}, {2, 3, 3}}}], 
    Line3DBox[{{{3, 0, 0}, {3, 3, 0}}, {{3, 0, 1}, {3, 3, 1}}, {{3, 0, 2}, {3,
      3, 2}}, {{3, 0, 3}, {3, 3, 3}}}]}, {
    Line3DBox[{{{0, 0, 0}, {0, 0, 3}}, {{0, 1, 0}, {0, 1, 3}}, {{0, 2, 0}, {0,
      2, 3}}, {{0, 3, 0}, {0, 3, 3}}}], 
    Line3DBox[{{{1, 0, 0}, {1, 0, 3}}, {{1, 1, 0}, {1, 1, 3}}, {{1, 2, 0}, {1,
      2, 3}}, {{1, 3, 0}, {1, 3, 3}}}], 
    Line3DBox[{{{2, 0, 0}, {2, 0, 3}}, {{2, 1, 0}, {2, 1, 3}}, {{2, 2, 0}, {2,
      2, 3}}, {{2, 3, 0}, {2, 3, 3}}}], 
    Line3DBox[{{{3, 0, 0}, {3, 0, 3}}, {{3, 1, 0}, {3, 1, 3}}, {{3, 2, 0}, {3,
      2, 3}}, {{3, 3, 0}, {3, 3, 3}}}]}},
  Boxed->False,
  ImageSize->{149.76726878333437`, Automatic},
  ViewPoint->{1.2644728452800351`, -2.7002539786212365`, 1.5999177711650043`},
  
  ViewVertical->{0.010985338143551517`, -0.14973658145389457`, 
   0.988664896979949}]], "Picture",
 CellTags->"10.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A common problem in computational geometry is finding the boundary of a \
given set of points. One way to think about this is to imagine the points as \
nails in a board and then to stretch a rubber band around all the nails. The \
stretched rubber band lies on a convex polygon commonly called the ",
 StyleBox["convex hull",
  FontSlant->"Italic"],
 " of the point set. The problem of determining the convex hull of a set of \
points has application in computer vision, pattern recognition, image \
processing, and many other areas. Using the ",
 Cell[BoxData[
  ButtonBox["ConvexHull",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ComputationalGeometry/ref/ConvexHull"]], 
  "InlineFormula"],
 " function defined in the ",
 ButtonBox["Computational Geometry package",
  BaseStyle->"ExLink",
  ButtonData->"paclet:ComputationalGeometry/tutorial/ComputationalGeometry"],
 ", create a function ",
 StyleBox["ConvexHullPlot", "MR", "ExLink"],
 " for visualizing the convex hull together with its point set. The resulting \
graphic should include the points labeled with text as well as the convex \
polygon drawn as a line around the point set."
}], "ExerciseItem",
 CellTags->{"10.2 Exercises", "Ex.Convex hull", "i:53"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", " ", "=", " ", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", " ", 
     RowBox[{"{", 
      RowBox[{"20", ",", " ", "2"}], "}"}]}], "]"}]}], ";"}]], "ExerciseInput",\
 "ExerciseMR",
 CellTags->"10.2 Exercises"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ComputationalGeometry`\>\"", 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"10.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ConvexHull", "[", "pts", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"10.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "12", ",", "19", ",", "2", ",", "1", ",", "9", ",", "6", ",", "4", ",", 
   "10", ",", "7", ",", "8"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"10.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ConvexHullPlot", "[", "pts", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"10.2 Exercises"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJwBUQGu/iFib1JlAgAAABQAAAACAAAAYA7mmYAq3T8IxMSUWUrvP5TMvnnQ
Lu4/LPamrnjK7j9QXnoCq1nTPzg1VJeN3t0/gKRhpA6Prz+MxpBJZq7YP6jd
7/Z4gts/NlJMenjr6D8g1/Po3OCoP0D+PCTDGuQ/FFsxworK0T+wlLzYgBi3
P4zmzJ7/DOw/kJ1Jc3Huuz9gxKG6LALRP3RBVtc/Ze0/CEUth86/xT8AmE9j
+X25P9iRiKm5F94/0CMkyq3O2T90KAweOhfvP1wVFVHLJ9Q/6BGcj40ZwD94
UfWCtWzRP0JdY8FIYuM/GsVMrRV/5T9os9Hh/gbPP8CLTPixed8/mOCTVqED
4j/EeX89A5PhP6gzJK2w0t4//qPE3b2d5D+4SkeOJ7naP2bh/wlxi+Y/vJjb
NDrD7j/UanOC/evsP+CtTggX2+s/aPfhhZE25D/MNKin
   
   "], {LineBox[{12, 19, 2, 1, 9, 6, 4, 10, 7, 8, 12}], 
    {PointSize[0.015], 
     PointBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
      19, 20}], {InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`1\\)\"\>",
        StringForm["`1`", 1],
        Editable->
         False], {0.4557191374699183, 0.9778259187352214}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`2\\)\"\>",
        StringForm["`1`", 2],
        Editable->
         False], {0.9432146432722157, 0.9622157488990459}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`3\\)\"\>",
        StringForm["`1`", 3],
        Editable->
         False], {0.3023479007910952, 0.4667085626432086}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`4\\)\"\>",
        StringForm["`1`", 4],
        Editable->
         False], {0.06163831478699766, 0.3856445043958068}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`5\\)\"\>",
        StringForm["`1`", 5],
        Editable->
         False], {0.4298384105199724, 0.7787439716945019}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`6\\)\"\>",
        StringForm["`1`", 6],
        Editable->
         False], {0.0485905680051657, 0.6282668788698587}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`7\\)\"\>",
        StringForm["`1`", 7],
        Editable->
         False], {0.27798718418255075`, 0.09021764079496353}, {-1.25, -1.25}],
       InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`8\\)\"\>",
        StringForm["`1`", 8],
        Editable->
         False], {0.8765867330141233, 0.10910710396421153`}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`9\\)\"\>",
        StringForm["`1`", 9],
        Editable->
         False], {0.2657577345444846, 0.9186095433997665}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`10\\)\"\>",
        StringForm["`1`", 10],
        Editable->
         False], {0.16991597748214127`, 0.09957846331198539}, {-1.25, -1.25}],
       InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`11\\)\"\>",
        StringForm["`1`", 11],
        Editable->
         False], {0.4701980739212366, 0.4032396768603208}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`12\\)\"\>",
        StringForm["`1`", 12],
        Editable->
         False], {0.9715853297104915, 0.31492884557913725`}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`13\\)\"\>",
        StringForm["`1`", 13],
        Editable->
         False], {0.12577981483640532`, 0.27226007260221463`}, \
{-1.25, -1.25}], InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`14\\)\"\>",
        StringForm["`1`", 14],
        Editable->
         False], {0.6057475831138748, 0.6717632660640078}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`15\\)\"\>",
        StringForm["`1`", 15],
        Editable->
         False], {0.24240098978352909`, 0.49180268524122184`}, \
{-1.25, -1.25}], InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`16\\)\"\>",
        StringForm["`1`", 16],
        Editable->
         False], {0.5629431429834026, 0.5491958809978361}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`17\\)\"\>",
        StringForm["`1`", 17],
        Editable->
         False], {0.4816095057329286, 0.644255574360727}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`18\\)\"\>",
        StringForm["`1`", 18],
        Editable->
         False], {0.41755093473799887`, 0.7045216746619587}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`19\\)\"\>",
        StringForm["`1`", 19],
        Editable->
         False], {0.9613314659479992, 0.9038074062221662}, {-1.25, -1.25}], 
      InsetBox[
       InterpretationBox["\<\"\\!\\(TraditionalForm\\`20\\)\"\>",
        StringForm["`1`", 20],
        Editable->
         False], {0.8704943811657664, 0.6316611876388665}, {-1.25, -1.25}]}}}],
  BaseStyle->Directive["Menu", 8],
  ImageSize->{122.91617425895552`, Automatic}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"10.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Extend Exercise ",
 StyleBox["9", "OsF"],
 " from Section ",
 StyleBox["8.4", "OsF"],
 " to random walks on the base ",
 StyleBox["n",
  FontSlant->"Italic"],
 " digits of \[Pi]. For example, in base ",
 StyleBox["3", "OsF"],
 ", a ",
 StyleBox["1", "OsF"],
 " corresponds to an angle of ",
 StyleBox["120\[Degree]", "OsF"],
 " from the current position, ",
 StyleBox["2", "OsF"],
 " corresponds to ",
 StyleBox["240\[Degree]", "OsF"],
 ", and ",
 StyleBox["0", "OsF"],
 " to ",
 StyleBox["360\[Degree]", "OsF"],
 ". In base ",
 StyleBox["4", "OsF"],
 " the step angles will be multiples of ",
 StyleBox["90\[Degree]", "OsF"],
 " and in general, for base ",
 StyleBox["n",
  FontSlant->"Italic"],
 ", the step angles will be multiples of ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"360", " ", "\[Degree]"}], "n"], TraditionalForm]]],
 ". Use ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " to visualize the walks. Include a color function that depends upon the \
length of the walk. For more on random walks on digits of \[Pi] in various \
bases, see ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Bailey et al. (2012)\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.5]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Bailey\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"David\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"H\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Jonathan\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\
\)\!\(\*\nStyleBox[\"M\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\
\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Borwein\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Cristian\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"S\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Calude\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"et\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"al\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"2012.\", \"OsF\"]\) Normality and the \
digits of \[Pi],\n`1`", 
         Hyperlink[
         "http://www.davidhbailey.com/dhbpapers/normality-digits-pi.pdf", 
          "http://www.davidhbailey.com/dhbpapers/normality-digits-pi.pdf"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "."
}], "ExerciseItem",
 CellTags->{"i:54", "10.2 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the implementation using ",
 Cell[BoxData[
  ButtonBox["TranslationTransform",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/TranslationTransform"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"vertices", "[", "n_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Cos", "[", 
       FractionBox[
        RowBox[{"2", " ", "\[Pi]", " ", "\[Alpha]"}], "n"], "]"}], ",", 
      RowBox[{"Sin", "[", 
       FractionBox[
        RowBox[{"2", " ", "\[Pi]", " ", "\[Alpha]"}], "n"], "]"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]", ",", "0", ",", "n"}], "}"}]}], "]"}]}]], "InputOnly",\

 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"hexagon", "=", 
   RowBox[{"Polygon", "[", 
    RowBox[{"vertices", "[", "6", "]"}], "]"}]}], ";", 
  RowBox[{"Graphics", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", "LightGray", ",", 
     "hexagon"}], "}"}], "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {GrayLevel[0.85], EdgeForm[GrayLevel[0.5]], 
   PolygonBox[
    NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
      Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
      Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
      Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
      0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
      0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 0}}]]},
  
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", "LightGray", ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"GeometricTransformation", "[", 
       RowBox[{"hexagon", ",", 
        RowBox[{"TranslationTransform", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"3", " ", "i"}], "+", 
            RowBox[{
             FractionBox["3", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], "j"], "+", "1"}], ")"}]}]}], ",", 
           
           FractionBox[
            RowBox[{
             SqrtBox["3"], " ", "j"}], "2"]}], "}"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "8"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
   "}"}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {GrayLevel[0.85], EdgeForm[GrayLevel[
   0.5]], {GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       3, Rational[1, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       3, 0.8660254037844386}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[9, 2], 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {4.5, 
       1.7320508075688772`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       3, Rational[3, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       3, 2.598076211353316}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[9, 2], 2 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {4.5, 
       3.4641016151377544`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       3, Rational[5, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       3, 4.330127018922193}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[9, 2], 3 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {4.5, 
       5.196152422706632}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       3, Rational[7, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       3, 6.06217782649107}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[9, 2], 4 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {4.5, 
       6.928203230275509}}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       6, Rational[1, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       6, 0.8660254037844386}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[15, 2], 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {7.5, 
       1.7320508075688772`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       6, Rational[3, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       6, 2.598076211353316}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[15, 2], 2 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {7.5, 
       3.4641016151377544`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       6, Rational[5, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       6, 4.330127018922193}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[15, 2], 3 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {7.5, 
       5.196152422706632}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       6, Rational[7, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       6, 6.06217782649107}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[15, 2], 4 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {7.5, 
       6.928203230275509}}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       9, Rational[1, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       9, 0.8660254037844386}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[21, 2], 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {10.5, 
       1.7320508075688772`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       9, Rational[3, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       9, 2.598076211353316}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[21, 2], 2 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {10.5, 
       3.4641016151377544`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       9, Rational[5, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       9, 4.330127018922193}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[21, 2], 3 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {10.5, 
       5.196152422706632}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       9, Rational[7, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       9, 6.06217782649107}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[21, 2], 4 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {10.5, 
       6.928203230275509}}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       12, Rational[1, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       12, 0.8660254037844386}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[27, 2], 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {13.5, 
       1.7320508075688772`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       12, Rational[3, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       12, 2.598076211353316}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[27, 2], 2 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {13.5, 
       3.4641016151377544`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       12, Rational[5, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       12, 4.330127018922193}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[27, 2], 3 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {13.5, 
       5.196152422706632}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       12, Rational[7, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       12, 6.06217782649107}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[27, 2], 4 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {13.5, 
       6.928203230275509}}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       15, Rational[1, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       15, 0.8660254037844386}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[33, 2], 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {16.5, 
       1.7320508075688772`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       15, Rational[3, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       15, 2.598076211353316}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[33, 2], 2 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {16.5, 
       3.4641016151377544`}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       15, Rational[5, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       15, 4.330127018922193}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[33, 2], 3 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {16.5, 
       5.196152422706632}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       15, Rational[7, 2] 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {
       15, 6.06217782649107}}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{{{1, 0}, {0, 1}}, {
       Rational[33, 2], 4 3^Rational[1, 2]}}, {{{1, 0}, {0, 1}}, {16.5, 
       6.928203230275509}}]]}},
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Or use ",
 Cell[BoxData[
  ButtonBox["Translate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Translate"]], "InlineFormula"],
 " directly."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr1", "=", 
  RowBox[{"Graphics", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", "LightGray", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Translate", "[", 
        RowBox[{"hexagon", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"3", " ", "i"}], "+", 
            RowBox[{
             FractionBox["3", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], "j"], "+", "1"}], ")"}]}]}], ",", 
           
           FractionBox[
            RowBox[{
             SqrtBox["3"], " ", "j"}], "2"]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "8"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  {GrayLevel[0.85], EdgeForm[GrayLevel[
   0.5]], {GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{3, Rational[1, 2] 3^Rational[1, 2]}, {
      3, 0.8660254037844386}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[9, 2], 3^Rational[1, 2]}, {4.5, 
      1.7320508075688772`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{3, Rational[3, 2] 3^Rational[1, 2]}, {
      3, 2.598076211353316}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[9, 2], 2 3^Rational[1, 2]}, {4.5, 
      3.4641016151377544`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{3, Rational[5, 2] 3^Rational[1, 2]}, {
      3, 4.330127018922193}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[9, 2], 3 3^Rational[1, 2]}, {4.5, 
      5.196152422706632}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{3, Rational[7, 2] 3^Rational[1, 2]}, {
      3, 6.06217782649107}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[9, 2], 4 3^Rational[1, 2]}, {4.5, 
      6.928203230275509}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{6, Rational[1, 2] 3^Rational[1, 2]}, {
      6, 0.8660254037844386}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[15, 2], 3^Rational[1, 2]}, {7.5, 
      1.7320508075688772`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{6, Rational[3, 2] 3^Rational[1, 2]}, {
      6, 2.598076211353316}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[15, 2], 2 3^Rational[1, 2]}, {7.5, 
      3.4641016151377544`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{6, Rational[5, 2] 3^Rational[1, 2]}, {
      6, 4.330127018922193}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[15, 2], 3 3^Rational[1, 2]}, {7.5, 
      5.196152422706632}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{6, Rational[7, 2] 3^Rational[1, 2]}, {
      6, 6.06217782649107}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[15, 2], 4 3^Rational[1, 2]}, {7.5, 
      6.928203230275509}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{9, Rational[1, 2] 3^Rational[1, 2]}, {
      9, 0.8660254037844386}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[21, 2], 3^Rational[1, 2]}, {10.5, 
      1.7320508075688772`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], 
     NCache[{9, Rational[3, 2] 3^Rational[1, 2]}, {9, 2.598076211353316}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[21, 2], 2 3^Rational[1, 2]}, {10.5, 
      3.4641016151377544`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{9, Rational[5, 2] 3^Rational[1, 2]}, {
      9, 4.330127018922193}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[21, 2], 3 3^Rational[1, 2]}, {10.5, 
      5.196152422706632}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{9, Rational[7, 2] 3^Rational[1, 2]}, {
      9, 6.06217782649107}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[21, 2], 4 3^Rational[1, 2]}, {10.5, 
      6.928203230275509}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{12, Rational[1, 2] 3^Rational[1, 2]}, {
      12, 0.8660254037844386}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[27, 2], 3^Rational[1, 2]}, {13.5, 
      1.7320508075688772`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{12, Rational[3, 2] 3^Rational[1, 2]}, {
      12, 2.598076211353316}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[27, 2], 2 3^Rational[1, 2]}, {13.5, 
      3.4641016151377544`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{12, Rational[5, 2] 3^Rational[1, 2]}, {
      12, 4.330127018922193}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[27, 2], 3 3^Rational[1, 2]}, {13.5, 
      5.196152422706632}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{12, Rational[7, 2] 3^Rational[1, 2]}, {
      12, 6.06217782649107}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[27, 2], 4 3^Rational[1, 2]}, {13.5, 
      6.928203230275509}]]}, {
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{15, Rational[1, 2] 3^Rational[1, 2]}, {
      15, 0.8660254037844386}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], 
     NCache[{Rational[33, 2], 3^Rational[1, 2]}, {16.5, 
      1.7320508075688772`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{15, Rational[3, 2] 3^Rational[1, 2]}, {
      15, 2.598076211353316}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[33, 2], 2 3^Rational[1, 2]}, {16.5, 
      3.4641016151377544`}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{15, Rational[5, 2] 3^Rational[1, 2]}, {
      15, 4.330127018922193}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[33, 2], 3 3^Rational[1, 2]}, {16.5, 
      5.196152422706632}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{15, Rational[7, 2] 3^Rational[1, 2]}, {
      15, 6.06217782649107}]], 
    GeometricTransformationBox[
     PolygonBox[
      NCache[{{1, 0}, {Rational[1, 2], Rational[1, 2] 3^Rational[1, 2]}, {
        Rational[-1, 2], Rational[1, 2] 3^Rational[1, 2]}, {-1, 0}, {
        Rational[-1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {
        Rational[1, 2], Rational[-1, 2] 3^Rational[1, 2]}, {1, 0}}, {{1, 0}, {
        0.5, 0.8660254037844386}, {-0.5, 0.8660254037844386}, {-1, 
        0}, {-0.5, -0.8660254037844386}, {0.5, -0.8660254037844386}, {1, 
        0}}]], NCache[{Rational[33, 2], 4 3^Rational[1, 2]}, {16.5, 
      6.928203230275509}]]}},
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "This implementation contains one ",
 Cell[BoxData[
  ButtonBox["Polygon",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Polygon"]], "InlineFormula"],
 " per hexagon."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"gr1", ",", "_Polygon", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData["40"], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Now use multi-polygons. The following version of ",
 Cell[BoxData["hexagon"]],
 " is defined so that it can take a pair of translation coordinates. Note \
also the need to flatten the table of vertices so that ",
 Cell[BoxData[
  ButtonBox["Polygon",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Polygon"]], "InlineFormula"],
 " can be applied to the correct list structure."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "hexagon", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hexagon", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        FractionBox[
         RowBox[{"2", " ", "\[Pi]", " ", "i"}], "6"], "]"}], "+", "x"}], ",", 
      
      RowBox[{
       RowBox[{"Sin", "[", 
        FractionBox[
         RowBox[{"2", " ", "\[Pi]", " ", "i"}], "6"], "]"}], "+", "y"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "6"}], "}"}]}], "]"}]}]}], "InputOnly",
 CellTags->"10.2 Solutions",
 CellID->141910737],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr2", "=", 
  RowBox[{"Graphics", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", "LightGray", ",", 
     RowBox[{"Polygon", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"hexagon", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"3", " ", "i"}], "+", 
              RowBox[{
               FractionBox["3", "4"], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"-", "1"}], ")"}], "j"], "+", "1"}], ")"}]}]}], 
             ",", 
             FractionBox[
              RowBox[{
               SqrtBox["3"], " ", "j"}], "2"]}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "5"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "8"}], "}"}]}], "]"}], ",", "1"}], "]"}], 
      "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}]], "Input",
 CellTags->"10.2 Solutions",
 CellID->16518451],

Cell[BoxData[
 GraphicsBox[
  {GrayLevel[0.85], EdgeForm[GrayLevel[0.5]], 
   PolygonBox[
    NCache[{{{Rational[7, 2], 3^Rational[1, 2]}, {
       Rational[5, 2], 3^Rational[1, 2]}, {
       2, Rational[1, 2] 3^Rational[1, 2]}, {Rational[5, 2], 0}, {
       Rational[7, 2], 0}, {4, Rational[1, 2] 3^Rational[1, 2]}}, {{
       5, Rational[3, 2] 3^Rational[1, 2]}, {
       4, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[7, 2], 3^Rational[1, 2]}, {
       4, Rational[1, 2] 3^Rational[1, 2]}, {
       5, Rational[1, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 3^Rational[1, 2]}}, {{
       Rational[7, 2], 2 3^Rational[1, 2]}, {
       Rational[5, 2], 2 3^Rational[1, 2]}, {
       2, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[5, 2], 3^Rational[1, 2]}, {
       Rational[7, 2], 3^Rational[1, 2]}, {
       4, Rational[3, 2] 3^Rational[1, 2]}}, {{
       5, Rational[5, 2] 3^Rational[1, 2]}, {
       4, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[7, 2], 2 3^Rational[1, 2]}, {
       4, Rational[3, 2] 3^Rational[1, 2]}, {
       5, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 2 3^Rational[1, 2]}}, {{
       Rational[7, 2], 3 3^Rational[1, 2]}, {
       Rational[5, 2], 3 3^Rational[1, 2]}, {
       2, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[5, 2], 2 3^Rational[1, 2]}, {
       Rational[7, 2], 2 3^Rational[1, 2]}, {
       4, Rational[5, 2] 3^Rational[1, 2]}}, {{
       5, Rational[7, 2] 3^Rational[1, 2]}, {
       4, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[7, 2], 3 3^Rational[1, 2]}, {
       4, Rational[5, 2] 3^Rational[1, 2]}, {
       5, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 3 3^Rational[1, 2]}}, {{
       Rational[7, 2], 4 3^Rational[1, 2]}, {
       Rational[5, 2], 4 3^Rational[1, 2]}, {
       2, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[5, 2], 3 3^Rational[1, 2]}, {
       Rational[7, 2], 3 3^Rational[1, 2]}, {
       4, Rational[7, 2] 3^Rational[1, 2]}}, {{
       5, Rational[9, 2] 3^Rational[1, 2]}, {
       4, Rational[9, 2] 3^Rational[1, 2]}, {
       Rational[7, 2], 4 3^Rational[1, 2]}, {
       4, Rational[7, 2] 3^Rational[1, 2]}, {
       5, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 4 3^Rational[1, 2]}}, {{
       Rational[13, 2], 3^Rational[1, 2]}, {
       Rational[11, 2], 3^Rational[1, 2]}, {
       5, Rational[1, 2] 3^Rational[1, 2]}, {Rational[11, 2], 0}, {
       Rational[13, 2], 0}, {7, Rational[1, 2] 3^Rational[1, 2]}}, {{
       8, Rational[3, 2] 3^Rational[1, 2]}, {
       7, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[13, 2], 3^Rational[1, 2]}, {
       7, Rational[1, 2] 3^Rational[1, 2]}, {
       8, Rational[1, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 3^Rational[1, 2]}}, {{
       Rational[13, 2], 2 3^Rational[1, 2]}, {
       Rational[11, 2], 2 3^Rational[1, 2]}, {
       5, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 3^Rational[1, 2]}, {
       Rational[13, 2], 3^Rational[1, 2]}, {
       7, Rational[3, 2] 3^Rational[1, 2]}}, {{
       8, Rational[5, 2] 3^Rational[1, 2]}, {
       7, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[13, 2], 2 3^Rational[1, 2]}, {
       7, Rational[3, 2] 3^Rational[1, 2]}, {
       8, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 2 3^Rational[1, 2]}}, {{
       Rational[13, 2], 3 3^Rational[1, 2]}, {
       Rational[11, 2], 3 3^Rational[1, 2]}, {
       5, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 2 3^Rational[1, 2]}, {
       Rational[13, 2], 2 3^Rational[1, 2]}, {
       7, Rational[5, 2] 3^Rational[1, 2]}}, {{
       8, Rational[7, 2] 3^Rational[1, 2]}, {
       7, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[13, 2], 3 3^Rational[1, 2]}, {
       7, Rational[5, 2] 3^Rational[1, 2]}, {
       8, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 3 3^Rational[1, 2]}}, {{
       Rational[13, 2], 4 3^Rational[1, 2]}, {
       Rational[11, 2], 4 3^Rational[1, 2]}, {
       5, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[11, 2], 3 3^Rational[1, 2]}, {
       Rational[13, 2], 3 3^Rational[1, 2]}, {
       7, Rational[7, 2] 3^Rational[1, 2]}}, {{
       8, Rational[9, 2] 3^Rational[1, 2]}, {
       7, Rational[9, 2] 3^Rational[1, 2]}, {
       Rational[13, 2], 4 3^Rational[1, 2]}, {
       7, Rational[7, 2] 3^Rational[1, 2]}, {
       8, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 4 3^Rational[1, 2]}}, {{
       Rational[19, 2], 3^Rational[1, 2]}, {
       Rational[17, 2], 3^Rational[1, 2]}, {
       8, Rational[1, 2] 3^Rational[1, 2]}, {Rational[17, 2], 0}, {
       Rational[19, 2], 0}, {10, Rational[1, 2] 3^Rational[1, 2]}}, {{
       11, Rational[3, 2] 3^Rational[1, 2]}, {
       10, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[19, 2], 3^Rational[1, 2]}, {
       10, Rational[1, 2] 3^Rational[1, 2]}, {
       11, Rational[1, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 3^Rational[1, 2]}}, {{
       Rational[19, 2], 2 3^Rational[1, 2]}, {
       Rational[17, 2], 2 3^Rational[1, 2]}, {
       8, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 3^Rational[1, 2]}, {
       Rational[19, 2], 3^Rational[1, 2]}, {
       10, Rational[3, 2] 3^Rational[1, 2]}}, {{
       11, Rational[5, 2] 3^Rational[1, 2]}, {
       10, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[19, 2], 2 3^Rational[1, 2]}, {
       10, Rational[3, 2] 3^Rational[1, 2]}, {
       11, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 2 3^Rational[1, 2]}}, {{
       Rational[19, 2], 3 3^Rational[1, 2]}, {
       Rational[17, 2], 3 3^Rational[1, 2]}, {
       8, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 2 3^Rational[1, 2]}, {
       Rational[19, 2], 2 3^Rational[1, 2]}, {
       10, Rational[5, 2] 3^Rational[1, 2]}}, {{
       11, Rational[7, 2] 3^Rational[1, 2]}, {
       10, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[19, 2], 3 3^Rational[1, 2]}, {
       10, Rational[5, 2] 3^Rational[1, 2]}, {
       11, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 3 3^Rational[1, 2]}}, {{
       Rational[19, 2], 4 3^Rational[1, 2]}, {
       Rational[17, 2], 4 3^Rational[1, 2]}, {
       8, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[17, 2], 3 3^Rational[1, 2]}, {
       Rational[19, 2], 3 3^Rational[1, 2]}, {
       10, Rational[7, 2] 3^Rational[1, 2]}}, {{
       11, Rational[9, 2] 3^Rational[1, 2]}, {
       10, Rational[9, 2] 3^Rational[1, 2]}, {
       Rational[19, 2], 4 3^Rational[1, 2]}, {
       10, Rational[7, 2] 3^Rational[1, 2]}, {
       11, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 4 3^Rational[1, 2]}}, {{
       Rational[25, 2], 3^Rational[1, 2]}, {
       Rational[23, 2], 3^Rational[1, 2]}, {
       11, Rational[1, 2] 3^Rational[1, 2]}, {Rational[23, 2], 0}, {
       Rational[25, 2], 0}, {13, Rational[1, 2] 3^Rational[1, 2]}}, {{
       14, Rational[3, 2] 3^Rational[1, 2]}, {
       13, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[25, 2], 3^Rational[1, 2]}, {
       13, Rational[1, 2] 3^Rational[1, 2]}, {
       14, Rational[1, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 3^Rational[1, 2]}}, {{
       Rational[25, 2], 2 3^Rational[1, 2]}, {
       Rational[23, 2], 2 3^Rational[1, 2]}, {
       11, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 3^Rational[1, 2]}, {
       Rational[25, 2], 3^Rational[1, 2]}, {
       13, Rational[3, 2] 3^Rational[1, 2]}}, {{
       14, Rational[5, 2] 3^Rational[1, 2]}, {
       13, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[25, 2], 2 3^Rational[1, 2]}, {
       13, Rational[3, 2] 3^Rational[1, 2]}, {
       14, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 2 3^Rational[1, 2]}}, {{
       Rational[25, 2], 3 3^Rational[1, 2]}, {
       Rational[23, 2], 3 3^Rational[1, 2]}, {
       11, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 2 3^Rational[1, 2]}, {
       Rational[25, 2], 2 3^Rational[1, 2]}, {
       13, Rational[5, 2] 3^Rational[1, 2]}}, {{
       14, Rational[7, 2] 3^Rational[1, 2]}, {
       13, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[25, 2], 3 3^Rational[1, 2]}, {
       13, Rational[5, 2] 3^Rational[1, 2]}, {
       14, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 3 3^Rational[1, 2]}}, {{
       Rational[25, 2], 4 3^Rational[1, 2]}, {
       Rational[23, 2], 4 3^Rational[1, 2]}, {
       11, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[23, 2], 3 3^Rational[1, 2]}, {
       Rational[25, 2], 3 3^Rational[1, 2]}, {
       13, Rational[7, 2] 3^Rational[1, 2]}}, {{
       14, Rational[9, 2] 3^Rational[1, 2]}, {
       13, Rational[9, 2] 3^Rational[1, 2]}, {
       Rational[25, 2], 4 3^Rational[1, 2]}, {
       13, Rational[7, 2] 3^Rational[1, 2]}, {
       14, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 4 3^Rational[1, 2]}}, {{
       Rational[31, 2], 3^Rational[1, 2]}, {
       Rational[29, 2], 3^Rational[1, 2]}, {
       14, Rational[1, 2] 3^Rational[1, 2]}, {Rational[29, 2], 0}, {
       Rational[31, 2], 0}, {16, Rational[1, 2] 3^Rational[1, 2]}}, {{
       17, Rational[3, 2] 3^Rational[1, 2]}, {
       16, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[31, 2], 3^Rational[1, 2]}, {
       16, Rational[1, 2] 3^Rational[1, 2]}, {
       17, Rational[1, 2] 3^Rational[1, 2]}, {
       Rational[35, 2], 3^Rational[1, 2]}}, {{
       Rational[31, 2], 2 3^Rational[1, 2]}, {
       Rational[29, 2], 2 3^Rational[1, 2]}, {
       14, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 3^Rational[1, 2]}, {
       Rational[31, 2], 3^Rational[1, 2]}, {
       16, Rational[3, 2] 3^Rational[1, 2]}}, {{
       17, Rational[5, 2] 3^Rational[1, 2]}, {
       16, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[31, 2], 2 3^Rational[1, 2]}, {
       16, Rational[3, 2] 3^Rational[1, 2]}, {
       17, Rational[3, 2] 3^Rational[1, 2]}, {
       Rational[35, 2], 2 3^Rational[1, 2]}}, {{
       Rational[31, 2], 3 3^Rational[1, 2]}, {
       Rational[29, 2], 3 3^Rational[1, 2]}, {
       14, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 2 3^Rational[1, 2]}, {
       Rational[31, 2], 2 3^Rational[1, 2]}, {
       16, Rational[5, 2] 3^Rational[1, 2]}}, {{
       17, Rational[7, 2] 3^Rational[1, 2]}, {
       16, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[31, 2], 3 3^Rational[1, 2]}, {
       16, Rational[5, 2] 3^Rational[1, 2]}, {
       17, Rational[5, 2] 3^Rational[1, 2]}, {
       Rational[35, 2], 3 3^Rational[1, 2]}}, {{
       Rational[31, 2], 4 3^Rational[1, 2]}, {
       Rational[29, 2], 4 3^Rational[1, 2]}, {
       14, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[29, 2], 3 3^Rational[1, 2]}, {
       Rational[31, 2], 3 3^Rational[1, 2]}, {
       16, Rational[7, 2] 3^Rational[1, 2]}}, {{
       17, Rational[9, 2] 3^Rational[1, 2]}, {
       16, Rational[9, 2] 3^Rational[1, 2]}, {
       Rational[31, 2], 4 3^Rational[1, 2]}, {
       16, Rational[7, 2] 3^Rational[1, 2]}, {
       17, Rational[7, 2] 3^Rational[1, 2]}, {
       Rational[35, 2], 4 3^Rational[1, 2]}}}, {{{3.5, 1.7320508075688772`}, {
       2.5, 1.7320508075688772`}, {2, 0.8660254037844386}, {2.5, 0}, {
       3.5, 0}, {4, 0.8660254037844386}}, {{5, 2.598076211353316}, {
       4, 2.598076211353316}, {3.5, 1.7320508075688772`}, {
       4, 0.8660254037844386}, {5, 0.8660254037844386}, {5.5, 
       1.7320508075688772`}}, {{3.5, 3.4641016151377544`}, {2.5, 
       3.4641016151377544`}, {2, 2.598076211353316}, {2.5, 
       1.7320508075688772`}, {3.5, 1.7320508075688772`}, {
       4, 2.598076211353316}}, {{5, 4.330127018922193}, {
       4, 4.330127018922193}, {3.5, 3.4641016151377544`}, {
       4, 2.598076211353316}, {5, 2.598076211353316}, {5.5, 
       3.4641016151377544`}}, {{3.5, 5.196152422706632}, {2.5, 
       5.196152422706632}, {2, 4.330127018922193}, {2.5, 
       3.4641016151377544`}, {3.5, 3.4641016151377544`}, {
       4, 4.330127018922193}}, {{5, 6.06217782649107}, {
       4, 6.06217782649107}, {3.5, 5.196152422706632}, {
       4, 4.330127018922193}, {5, 4.330127018922193}, {5.5, 
       5.196152422706632}}, {{3.5, 6.928203230275509}, {2.5, 
       6.928203230275509}, {2, 6.06217782649107}, {2.5, 5.196152422706632}, {
       3.5, 5.196152422706632}, {4, 6.06217782649107}}, {{
       5, 7.794228634059947}, {4, 7.794228634059947}, {3.5, 
       6.928203230275509}, {4, 6.06217782649107}, {5, 6.06217782649107}, {5.5,
        6.928203230275509}}, {{6.5, 1.7320508075688772`}, {5.5, 
       1.7320508075688772`}, {5, 0.8660254037844386}, {5.5, 0}, {6.5, 0}, {
       7, 0.8660254037844386}}, {{8, 2.598076211353316}, {
       7, 2.598076211353316}, {6.5, 1.7320508075688772`}, {
       7, 0.8660254037844386}, {8, 0.8660254037844386}, {8.5, 
       1.7320508075688772`}}, {{6.5, 3.4641016151377544`}, {5.5, 
       3.4641016151377544`}, {5, 2.598076211353316}, {5.5, 
       1.7320508075688772`}, {6.5, 1.7320508075688772`}, {
       7, 2.598076211353316}}, {{8, 4.330127018922193}, {
       7, 4.330127018922193}, {6.5, 3.4641016151377544`}, {
       7, 2.598076211353316}, {8, 2.598076211353316}, {8.5, 
       3.4641016151377544`}}, {{6.5, 5.196152422706632}, {5.5, 
       5.196152422706632}, {5, 4.330127018922193}, {5.5, 
       3.4641016151377544`}, {6.5, 3.4641016151377544`}, {
       7, 4.330127018922193}}, {{8, 6.06217782649107}, {
       7, 6.06217782649107}, {6.5, 5.196152422706632}, {
       7, 4.330127018922193}, {8, 4.330127018922193}, {8.5, 
       5.196152422706632}}, {{6.5, 6.928203230275509}, {5.5, 
       6.928203230275509}, {5, 6.06217782649107}, {5.5, 5.196152422706632}, {
       6.5, 5.196152422706632}, {7, 6.06217782649107}}, {{
       8, 7.794228634059947}, {7, 7.794228634059947}, {6.5, 
       6.928203230275509}, {7, 6.06217782649107}, {8, 6.06217782649107}, {8.5,
        6.928203230275509}}, {{9.5, 1.7320508075688772`}, {8.5, 
       1.7320508075688772`}, {8, 0.8660254037844386}, {8.5, 0}, {9.5, 0}, {
       10, 0.8660254037844386}}, {{11, 2.598076211353316}, {
       10, 2.598076211353316}, {9.5, 1.7320508075688772`}, {
       10, 0.8660254037844386}, {11, 0.8660254037844386}, {11.5, 
       1.7320508075688772`}}, {{9.5, 3.4641016151377544`}, {8.5, 
       3.4641016151377544`}, {8, 2.598076211353316}, {8.5, 
       1.7320508075688772`}, {9.5, 1.7320508075688772`}, {
       10, 2.598076211353316}}, {{11, 4.330127018922193}, {
       10, 4.330127018922193}, {9.5, 3.4641016151377544`}, {
       10, 2.598076211353316}, {11, 2.598076211353316}, {11.5, 
       3.4641016151377544`}}, {{9.5, 5.196152422706632}, {8.5, 
       5.196152422706632}, {8, 4.330127018922193}, {8.5, 
       3.4641016151377544`}, {9.5, 3.4641016151377544`}, {
       10, 4.330127018922193}}, {{11, 6.06217782649107}, {
       10, 6.06217782649107}, {9.5, 5.196152422706632}, {
       10, 4.330127018922193}, {11, 4.330127018922193}, {11.5, 
       5.196152422706632}}, {{9.5, 6.928203230275509}, {8.5, 
       6.928203230275509}, {8, 6.06217782649107}, {8.5, 5.196152422706632}, {
       9.5, 5.196152422706632}, {10, 6.06217782649107}}, {{
       11, 7.794228634059947}, {10, 7.794228634059947}, {9.5, 
       6.928203230275509}, {10, 6.06217782649107}, {11, 6.06217782649107}, {
       11.5, 6.928203230275509}}, {{12.5, 1.7320508075688772`}, {11.5, 
       1.7320508075688772`}, {11, 0.8660254037844386}, {11.5, 0}, {12.5, 0}, {
       13, 0.8660254037844386}}, {{14, 2.598076211353316}, {
       13, 2.598076211353316}, {12.5, 1.7320508075688772`}, {
       13, 0.8660254037844386}, {14, 0.8660254037844386}, {14.5, 
       1.7320508075688772`}}, {{12.5, 3.4641016151377544`}, {11.5, 
       3.4641016151377544`}, {11, 2.598076211353316}, {11.5, 
       1.7320508075688772`}, {12.5, 1.7320508075688772`}, {
       13, 2.598076211353316}}, {{14, 4.330127018922193}, {
       13, 4.330127018922193}, {12.5, 3.4641016151377544`}, {
       13, 2.598076211353316}, {14, 2.598076211353316}, {14.5, 
       3.4641016151377544`}}, {{12.5, 5.196152422706632}, {11.5, 
       5.196152422706632}, {11, 4.330127018922193}, {11.5, 
       3.4641016151377544`}, {12.5, 3.4641016151377544`}, {
       13, 4.330127018922193}}, {{14, 6.06217782649107}, {
       13, 6.06217782649107}, {12.5, 5.196152422706632}, {
       13, 4.330127018922193}, {14, 4.330127018922193}, {14.5, 
       5.196152422706632}}, {{12.5, 6.928203230275509}, {11.5, 
       6.928203230275509}, {11, 6.06217782649107}, {11.5, 
       5.196152422706632}, {12.5, 5.196152422706632}, {
       13, 6.06217782649107}}, {{14, 7.794228634059947}, {
       13, 7.794228634059947}, {12.5, 6.928203230275509}, {
       13, 6.06217782649107}, {14, 6.06217782649107}, {14.5, 
       6.928203230275509}}, {{15.5, 1.7320508075688772`}, {14.5, 
       1.7320508075688772`}, {14, 0.8660254037844386}, {14.5, 0}, {15.5, 0}, {
       16, 0.8660254037844386}}, {{17, 2.598076211353316}, {
       16, 2.598076211353316}, {15.5, 1.7320508075688772`}, {
       16, 0.8660254037844386}, {17, 0.8660254037844386}, {17.5, 
       1.7320508075688772`}}, {{15.5, 3.4641016151377544`}, {14.5, 
       3.4641016151377544`}, {14, 2.598076211353316}, {14.5, 
       1.7320508075688772`}, {15.5, 1.7320508075688772`}, {
       16, 2.598076211353316}}, {{17, 4.330127018922193}, {
       16, 4.330127018922193}, {15.5, 3.4641016151377544`}, {
       16, 2.598076211353316}, {17, 2.598076211353316}, {17.5, 
       3.4641016151377544`}}, {{15.5, 5.196152422706632}, {14.5, 
       5.196152422706632}, {14, 4.330127018922193}, {14.5, 
       3.4641016151377544`}, {15.5, 3.4641016151377544`}, {
       16, 4.330127018922193}}, {{17, 6.06217782649107}, {
       16, 6.06217782649107}, {15.5, 5.196152422706632}, {
       16, 4.330127018922193}, {17, 4.330127018922193}, {17.5, 
       5.196152422706632}}, {{15.5, 6.928203230275509}, {14.5, 
       6.928203230275509}, {14, 6.06217782649107}, {14.5, 
       5.196152422706632}, {15.5, 5.196152422706632}, {
       16, 6.06217782649107}}, {{17, 7.794228634059947}, {
       16, 7.794228634059947}, {15.5, 6.928203230275509}, {
       16, 6.06217782649107}, {17, 6.06217782649107}, {17.5, 
       6.928203230275509}}}]]},
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"gr2", ",", "_Polygon", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData["1"], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "One approach to creating the lattice is to manually specify the coordinates \
for the lines and then map the ",
 Cell[BoxData[
  ButtonBox["Line",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Line"]], "InlineFormula"],
 " primitive across these coordinates. We will work with a small lattice."
}], "SolutionItem",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"xmin", "=", "0"}], ";", 
  RowBox[{"xmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymin", "=", "0"}], ";", 
  RowBox[{"ymax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zmin", "=", "0"}], ";", 
  RowBox[{"zmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "ymin", ",", "zmin"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "ymax", ",", "zmin"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}]}], "]"}]}], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "0"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell["Here are the three grids.", "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gridX", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xmin", ",", "y", ",", "z"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"xmax", ",", "y", ",", "z"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gridY", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "ymin", ",", "z"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "ymax", ",", "z"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"z", ",", "zmin", ",", "zmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gridZ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "zmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "zmax"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "ymin", ",", "ymax"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellTags->"10.2 Solutions"],

Cell[TextData[{
 "Finally, map ",
 Cell[BoxData[
  ButtonBox["Line",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Line"]], "InlineFormula"],
 " across these grids and display as a ",
 Cell[BoxData[
  ButtonBox["Graphics3D",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graphics3D"]], "InlineFormula"],
 " object."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr1", "=", 
  RowBox[{"Graphics3D", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridX", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridY", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridZ", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
    RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 Graphics3DBox[{{{Line3DBox[{{0, 0, 0}, {3, 0, 0}}], 
     Line3DBox[{{0, 0, 1}, {3, 0, 1}}], Line3DBox[{{0, 0, 2}, {3, 0, 2}}], 
     Line3DBox[{{0, 0, 3}, {3, 0, 3}}]}, {Line3DBox[{{0, 1, 0}, {3, 1, 0}}], 
     Line3DBox[{{0, 1, 1}, {3, 1, 1}}], Line3DBox[{{0, 1, 2}, {3, 1, 2}}], 
     Line3DBox[{{0, 1, 3}, {3, 1, 3}}]}, {Line3DBox[{{0, 2, 0}, {3, 2, 0}}], 
     Line3DBox[{{0, 2, 1}, {3, 2, 1}}], Line3DBox[{{0, 2, 2}, {3, 2, 2}}], 
     Line3DBox[{{0, 2, 3}, {3, 2, 3}}]}, {Line3DBox[{{0, 3, 0}, {3, 3, 0}}], 
     Line3DBox[{{0, 3, 1}, {3, 3, 1}}], Line3DBox[{{0, 3, 2}, {3, 3, 2}}], 
     Line3DBox[{{0, 3, 3}, {3, 3, 3}}]}}, {{Line3DBox[{{0, 0, 0}, {0, 3, 0}}],
      Line3DBox[{{0, 0, 1}, {0, 3, 1}}], Line3DBox[{{0, 0, 2}, {0, 3, 2}}], 
     Line3DBox[{{0, 0, 3}, {0, 3, 3}}]}, {Line3DBox[{{1, 0, 0}, {1, 3, 0}}], 
     Line3DBox[{{1, 0, 1}, {1, 3, 1}}], Line3DBox[{{1, 0, 2}, {1, 3, 2}}], 
     Line3DBox[{{1, 0, 3}, {1, 3, 3}}]}, {Line3DBox[{{2, 0, 0}, {2, 3, 0}}], 
     Line3DBox[{{2, 0, 1}, {2, 3, 1}}], Line3DBox[{{2, 0, 2}, {2, 3, 2}}], 
     Line3DBox[{{2, 0, 3}, {2, 3, 3}}]}, {Line3DBox[{{3, 0, 0}, {3, 3, 0}}], 
     Line3DBox[{{3, 0, 1}, {3, 3, 1}}], Line3DBox[{{3, 0, 2}, {3, 3, 2}}], 
     Line3DBox[{{3, 0, 3}, {3, 3, 3}}]}}, {{Line3DBox[{{0, 0, 0}, {0, 0, 3}}],
      Line3DBox[{{0, 1, 0}, {0, 1, 3}}], Line3DBox[{{0, 2, 0}, {0, 2, 3}}], 
     Line3DBox[{{0, 3, 0}, {0, 3, 3}}]}, {Line3DBox[{{1, 0, 0}, {1, 0, 3}}], 
     Line3DBox[{{1, 1, 0}, {1, 1, 3}}], Line3DBox[{{1, 2, 0}, {1, 2, 3}}], 
     Line3DBox[{{1, 3, 0}, {1, 3, 3}}]}, {Line3DBox[{{2, 0, 0}, {2, 0, 3}}], 
     Line3DBox[{{2, 1, 0}, {2, 1, 3}}], Line3DBox[{{2, 2, 0}, {2, 2, 3}}], 
     Line3DBox[{{2, 3, 0}, {2, 3, 3}}]}, {Line3DBox[{{3, 0, 0}, {3, 0, 3}}], 
     Line3DBox[{{3, 1, 0}, {3, 1, 3}}], Line3DBox[{{3, 2, 0}, {3, 2, 3}}], 
     Line3DBox[{{3, 3, 0}, {3, 3, 3}}]}}},
  Boxed->False,
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"gr1", ",", "_Line", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData["48"], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Using multi-lines reduces the number of ",
 Cell[BoxData[
  ButtonBox["Line",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Line"]], "InlineFormula"],
 " objects substantially."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gr2", "=", 
  RowBox[{"Graphics3D", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridX"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridY"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Line", ",", "gridZ"}], "]"}]}], "\[IndentingNewLine]", "}"}], 
    ",", 
    RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 Graphics3DBox[{{
    Line3DBox[{{{0, 0, 0}, {3, 0, 0}}, {{0, 0, 1}, {3, 0, 1}}, {{0, 0, 2}, {3,
      0, 2}}, {{0, 0, 3}, {3, 0, 3}}}], 
    Line3DBox[{{{0, 1, 0}, {3, 1, 0}}, {{0, 1, 1}, {3, 1, 1}}, {{0, 1, 2}, {3,
      1, 2}}, {{0, 1, 3}, {3, 1, 3}}}], 
    Line3DBox[{{{0, 2, 0}, {3, 2, 0}}, {{0, 2, 1}, {3, 2, 1}}, {{0, 2, 2}, {3,
      2, 2}}, {{0, 2, 3}, {3, 2, 3}}}], 
    Line3DBox[{{{0, 3, 0}, {3, 3, 0}}, {{0, 3, 1}, {3, 3, 1}}, {{0, 3, 2}, {3,
      3, 2}}, {{0, 3, 3}, {3, 3, 3}}}]}, {
    Line3DBox[{{{0, 0, 0}, {0, 3, 0}}, {{0, 0, 1}, {0, 3, 1}}, {{0, 0, 2}, {0,
      3, 2}}, {{0, 0, 3}, {0, 3, 3}}}], 
    Line3DBox[{{{1, 0, 0}, {1, 3, 0}}, {{1, 0, 1}, {1, 3, 1}}, {{1, 0, 2}, {1,
      3, 2}}, {{1, 0, 3}, {1, 3, 3}}}], 
    Line3DBox[{{{2, 0, 0}, {2, 3, 0}}, {{2, 0, 1}, {2, 3, 1}}, {{2, 0, 2}, {2,
      3, 2}}, {{2, 0, 3}, {2, 3, 3}}}], 
    Line3DBox[{{{3, 0, 0}, {3, 3, 0}}, {{3, 0, 1}, {3, 3, 1}}, {{3, 0, 2}, {3,
      3, 2}}, {{3, 0, 3}, {3, 3, 3}}}]}, {
    Line3DBox[{{{0, 0, 0}, {0, 0, 3}}, {{0, 1, 0}, {0, 1, 3}}, {{0, 2, 0}, {0,
      2, 3}}, {{0, 3, 0}, {0, 3, 3}}}], 
    Line3DBox[{{{1, 0, 0}, {1, 0, 3}}, {{1, 1, 0}, {1, 1, 3}}, {{1, 2, 0}, {1,
      2, 3}}, {{1, 3, 0}, {1, 3, 3}}}], 
    Line3DBox[{{{2, 0, 0}, {2, 0, 3}}, {{2, 1, 0}, {2, 1, 3}}, {{2, 2, 0}, {2,
      2, 3}}, {{2, 3, 0}, {2, 3, 3}}}], 
    Line3DBox[{{{3, 0, 0}, {3, 0, 3}}, {{3, 1, 0}, {3, 1, 3}}, {{3, 2, 0}, {3,
      2, 3}}, {{3, 3, 0}, {3, 3, 3}}}]}},
  Boxed->False,
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{"gr2", ",", "_Line", ",", "Infinity"}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData["12"], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 ButtonBox["Computational Geometry package",
  BaseStyle->"ExLink",
  ButtonData->"paclet:ComputationalGeometry/tutorial/ComputationalGeometry"],
 " contains a function for computing the convex hull. ",
 Cell[BoxData[
  RowBox[{"ConvexHull", "[", 
   StyleBox["pts", "ExerciseTI"], "]"}]]],
 " returns a list of the indices of the points on the convex hull. "
}], "SolutionItem",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ComputationalGeometry`\>\"", "]"}]], "InputOnly",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ch", "=", 
  RowBox[{"ConvexHull", "[", "pts", "]"}]}]}], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"10", ",", "1", ",", "2", ",", "9", ",", "11", ",", "7", ",", "8"}],
   "}"}]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Use those indices as the positions in ",
 Cell[BoxData["pts"]],
 " through which we wish to pass a line. Note the need to close up the \
polygon, connecting the last point with the first."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"GraphicsComplex", "[", 
   RowBox[{"pts", ",", 
    RowBox[{"Line", "[", 
     RowBox[{"ch", "/.", "\[VeryThinSpace]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}]}], "]"}], 
  "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  GraphicsComplexBox[{{0.43330383337221456`, 0.6477081348934226}, {
   0.39114142510192207`, 0.7795658470120388}, {0.7945748271343736, 
   0.7311119910641111}, {0.21519081070791013`, 0.09722200144948379}, {
   0.9488448799745846, 0.6976907571872724}, {0.9914906369598719, 
   0.48019118325426224`}, {0.7443063822825546, 0.13893472069007728`}, {
   0.22523021709477842`, 0.26482964889452965`}, {0.33112339620869147`, 
   0.5936149697488944}, {0.04428498633898181, 0.0256162278021006}, {
   0.41356350134205067`, 0.6042434627627353}, {0.5670527869897306, 
   0.8529907204467406}}, LineBox[{6, 5, 12, 2, 10, 7, 6}]],
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell["Now add the text.", "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ran", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"Length", "[", "pts", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{"Graphics", "[", 
  RowBox[{"GraphicsComplex", "[", 
   RowBox[{"pts", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Line", "[", 
       RowBox[{"ch", "/.", "\[VeryThinSpace]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"PointSize", "[", ".015", "]"}], ",", 
      RowBox[{"Point", "[", "ran", "]"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"StringForm", "[", 
            RowBox[{"\"\<`1`\>\"", ",", "#"}], "]"}], ",", 
           RowBox[{"pts", "[", 
            RowBox[{"[", "#", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.25"}], ",", 
             RowBox[{"-", "1.25"}]}], "}"}]}], "]"}], "&"}], ",", "ran"}], 
       "]"}]}], "}"}]}], "]"}], "]"}]}], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  GraphicsComplexBox[{{0.43330383337221456`, 0.6477081348934226}, {
   0.39114142510192207`, 0.7795658470120388}, {0.7945748271343736, 
   0.7311119910641111}, {0.21519081070791013`, 0.09722200144948379}, {
   0.9488448799745846, 0.6976907571872724}, {0.9914906369598719, 
   0.48019118325426224`}, {0.7443063822825546, 0.13893472069007728`}, {
   0.22523021709477842`, 0.26482964889452965`}, {0.33112339620869147`, 
   0.5936149697488944}, {0.04428498633898181, 0.0256162278021006}, {
   0.41356350134205067`, 0.6042434627627353}, {0.5670527869897306, 
   0.8529907204467406}}, {LineBox[{6, 5, 12, 2, 10, 7, 6}], 
    {PointSize[Medium], 
     PointBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}], {InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`1\\)\"\>",
         StringForm["`1`", 1],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.43330383337221456`, 0.6477081348934226}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`2\\)\"\>",
         StringForm["`1`", 2],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.39114142510192207`, 0.7795658470120388}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`3\\)\"\>",
         StringForm["`1`", 3],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.7945748271343736, 0.7311119910641111}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`4\\)\"\>",
         StringForm["`1`", 4],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.21519081070791013`, 0.09722200144948379}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`5\\)\"\>",
         StringForm["`1`", 5],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.9488448799745846, 0.6976907571872724}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`6\\)\"\>",
         StringForm["`1`", 6],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.9914906369598719, 0.48019118325426224`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`7\\)\"\>",
         StringForm["`1`", 7],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.7443063822825546, 0.13893472069007728`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`8\\)\"\>",
         StringForm["`1`", 8],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.22523021709477842`, 0.26482964889452965`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`9\\)\"\>",
         StringForm["`1`", 9],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.33112339620869147`, 0.5936149697488944}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`10\\)\"\>",
         StringForm["`1`", 10],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.04428498633898181, 0.0256162278021006}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`11\\)\"\>",
         StringForm["`1`", 11],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.41356350134205067`, 0.6042434627627353}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`12\\)\"\>",
         StringForm["`1`", 12],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.5670527869897306, 0.8529907204467406}, {-1.25, -1.25}]}}}],
  ImageSize->{137.58333333333314`, Automatic}]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "Putting everything together, note that because ",
 Cell[BoxData[
  ButtonBox["Module",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Module"]], "InlineFormula"],
 " is a scoping construct, you need to give full context names for any \
function that is defined in a package loaded inside ",
 Cell[BoxData[
  ButtonBox["Module",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Module"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{"Clear", "[", "ConvexHullPlot", "]"}]], "InputOnly",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConvexHullPlot", "[", 
   RowBox[{"pts_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "Graphics", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ch", ",", 
      RowBox[{"ran", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"Length", "[", "pts", "]"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Needs", "[", "\"\<ComputationalGeometry`\>\"", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ch", "=", 
      RowBox[{"ComputationalGeometry`ConvexHull", "[", "pts", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
         RowBox[{"pts", ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"ch", "/.", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
               RowBox[{"{", 
                RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"PointSize", "[", ".015", "]"}], ",", 
            RowBox[{"Point", "[", "ran", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Text", "[", 
                RowBox[{
                 RowBox[{"StringForm", "[", 
                  RowBox[{"\"\<`1`\>\"", ",", "#"}], "]"}], ",", 
                 RowBox[{"pts", "[", 
                  RowBox[{"[", "#", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "1.25"}], ",", 
                   RowBox[{"-", "1.25"}]}], "}"}]}], "]"}], "&"}], ",", 
              "ran"}], "]"}]}], "\[IndentingNewLine]", "}"}]}], 
         "\[IndentingNewLine]", "]"}], "}"}], ",", "opts"}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ConvexHullPlot", "[", "pts", "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[
  GraphicsComplexBox[{{0.43330383337221456`, 0.6477081348934226}, {
   0.39114142510192207`, 0.7795658470120388}, {0.7945748271343736, 
   0.7311119910641111}, {0.21519081070791013`, 0.09722200144948379}, {
   0.9488448799745846, 0.6976907571872724}, {0.9914906369598719, 
   0.48019118325426224`}, {0.7443063822825546, 0.13893472069007728`}, {
   0.22523021709477842`, 0.26482964889452965`}, {0.33112339620869147`, 
   0.5936149697488944}, {0.04428498633898181, 0.0256162278021006}, {
   0.41356350134205067`, 0.6042434627627353}, {0.5670527869897306, 
   0.8529907204467406}}, {LineBox[{6, 5, 12, 2, 10, 7, 6}], 
    {PointSize[Medium], 
     PointBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}], {InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`1\\)\"\>",
         StringForm["`1`", 1],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.43330383337221456`, 0.6477081348934226}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`2\\)\"\>",
         StringForm["`1`", 2],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.39114142510192207`, 0.7795658470120388}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`3\\)\"\>",
         StringForm["`1`", 3],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.7945748271343736, 0.7311119910641111}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`4\\)\"\>",
         StringForm["`1`", 4],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.21519081070791013`, 0.09722200144948379}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`5\\)\"\>",
         StringForm["`1`", 5],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.9488448799745846, 0.6976907571872724}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`6\\)\"\>",
         StringForm["`1`", 6],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.9914906369598719, 0.48019118325426224`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`7\\)\"\>",
         StringForm["`1`", 7],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.7443063822825546, 0.13893472069007728`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`8\\)\"\>",
         StringForm["`1`", 8],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.22523021709477842`, 0.26482964889452965`}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`9\\)\"\>",
         StringForm["`1`", 9],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.33112339620869147`, 0.5936149697488944}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`10\\)\"\>",
         StringForm["`1`", 10],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.04428498633898181, 0.0256162278021006}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`11\\)\"\>",
         StringForm["`1`", 11],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.41356350134205067`, 0.6042434627627353}, {-1.25, -1.25}], 
      InsetBox[
       StyleBox[
        InterpretationBox["\<\"\\!\\(TraditionalForm\\`12\\)\"\>",
         StringForm["`1`", 12],
         Editable->False], "SR",
        StripOnInput->False,
        FontSize->
         8], {0.5670527869897306, 0.8529907204467406}, {-1.25, -1.25}]}}}],
  ImageSize->{137.58333333333314`, Automatic}]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here is the random walk on the digits of \[Pi] in bases given by the second \
argument.\
\>", "SolutionItem",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomWalkPi", "[", 
   RowBox[{"d_", ",", 
    RowBox[{"base_", "/;", 
     RowBox[{"base", ">", "2"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digits", ",", "angles", ",", "rules"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"digits", "=", 
      RowBox[{"First", "[", 
       RowBox[{"RealDigits", "[", 
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"\[Pi]", ",", "d"}], "]"}], ",", "base"}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"angles", "=", 
      RowBox[{"Rest", "@", 
       RowBox[{"Range", "[", 
        RowBox[{"0.", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"2", 
          RowBox[{"\[Pi]", "/", 
           RowBox[{"(", "base", ")"}]}]}]}], "]"}]}]}], ";", 
     RowBox[{"rules", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", "#2"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"base", "-", "1"}]}], "]"}], ",", "angles"}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Accumulate", "[", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", "#", "]"}], ",", 
           RowBox[{"Sin", "[", "#", "]"}]}], "}"}], "&"}], ",", 
        RowBox[{"digits", "/.", "rules"}]}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]], "InlineFormula"],
 ", here is a quick visualization on base ",
 StyleBox["5", "OsF"],
 " digits:"
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"RandomWalkPi", "[", 
    RowBox[{"10000", ",", "5"}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJysfXd4VcW3dggBQie9h/Sc9B5SOUNCE5DeREQERJpKJypNQDpIkyYiICpV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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{-135.74515828561826`, 
   21.753288904374088`}, {-24.278441447094412`, 118.55632848012907`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.2 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzlnXmY3UWV9++ku7Ozg47jODrjOOqMtuM2zuOIbRBRUYiAiEAEEYiACM0m
tIhLXOOCtjpjIECzNVuAELawBSRsYYlAA4YlaADDErQZ40iLrdZ7PqfOt27d
TucmOu/zvH+8v+e5vfzub6k6dZbvWapqp/2OPujAT+939MH77/eK9x65X+9B
B+9/1Ct2OPxIO9XxV41GY8g+N7+i0Wl/J/uz+jGU7Gg0FvmvDk6lOBp/l79a
GF/94Q9/zOfteEX+42L/NTGtWfM/6ZqrH9bXae43fpxGRkb/rr6qI50zeE/6
2Kzz0yc+vqAxwR/TkXaZeWb6+L4L+Ng5fnakL3z+2vTccyN+14vzI86NR6TR
kTQ8PJxGRpNdzrkp6f77nk7937059Wx7kn+2e9d8b8S73qn/T7Y77S/7+bOf
/ap0Lx59ajx6ZOVgElGcDo2p9rMvrRzN169eNs+/nzl7duq233MWrUiPPPJL
Hp+fPiVdeulP/ZKHHnw27b3neenUU+5MF114X/r2t5Z6S849557GS/JbT/Nf
L02rlszxW+YsWJQWLViQFthn7qzu1LtoVRpduSB/t2S1t2Ak/n/jjFPUsfSf
P7wt7fSB051mGrvnn/+9d/SFF/6QdnzfgF97/nn3BsE6nGB/+tOf/L+tc3MG
/NdWaeWi3tSYNZhGRKU0nIaGHkuL+yDMnLS6nB9JAzPt3KuOSNva47974k1+
9o7bn0gnfucmJ19nMMfhh13mTfj0oYts7J5PJ590e/rc8Ve/KL/5+xpZe+KS
/r7U29fX6Ep99rMj9fb2pxW5KX5FamyWlvfPSI2ZA2lt1cJ5M6wlM+a1nPvW
f9i5abumt9ubb77p52nFT58JAkysmdyP5557njGaEEwCA9Hgq69+uLFOK0fT
0OLBNDA4aK0ctJ8daWBgUVrd0srJft3ivu7U6FucnH/WLk8zYa6Z3srckK50
wXHvsIe/Ob3x7Sel3XY5Kz344JrcSGdAjddHPjwo5m6ojfN+tEwCqTE8w39t
aYRcnmbYu3oX22iNrkgHNjJ1nhv9Y/TX2nbCu+yOd/iLefzvfjfq3MpvqGO/
9Xa46aDZC/29nfH2Qz+1KD3z9G+CaSox+ps0unZNGm6yT3r66afS0W+3Fux9
rr13bdrhlfb3m76azln4QFyxNu3zRju32Ud9rN7/3tPSrh86K80+4KJ04P4X
eWuuveaR9Nhjz6Xf/OaF9M25N6ZPzr64I9pD4z9zzJXpqafWwtNb143ZLI0M
9afu3iW509b9fT92UnrFNHvZlnum7510a3r9S2HrbdP8yx9KTzz+33bV6jQb
cr3sCBud3FcaAMsatQsD/fGPf0p77nFuOr7vah+ZvT56blq79ncvan17SmvS
XDTG3EXpqquuTf/4klf707Z+5fF+17ZvPcT/f+vOp7sGHV7W7/+/Zbv58fZO
///ggxamK694kDdMSMtue8z460f/tcxFn8d84P0D3gAa9PnPXZP++79HYkxO
i+aOrF6aersbUm9p+otnpbe946TMS5PTCQcfmTXbrJn++ytXrPSHoVO2325+
R9WUPT5yTnrggWfSjT/+2eQ4zVU05SfLV6df/vK3W+RXDwT3/P73f0g7f+A/
U0/PD0MJT3ZOf/ihZ41R11q/M7ugjy6+6H6UhDNZtg8T0/33P52+9IXrvKPn
DN6NCk3vefcpE6uXwxUwqQ3KZq0v/+Wzv02z9jqPThTBmdFzsj/s9IG7QkN1
ONcfesiiuCI3kt4ODT3lT4ba3AOzPf74czxzUtEVJ6ezzvwJL2/E20+Ppy65
buU6Ysvbzfz5FRKwJ574b2fQr8xZEtd10WK/l1acaLrVxL08g1a8b4dT/T81
Y4/dB9OjK39VGM9ufKsUUmUyu+Lc6NphO+fqsvGvY66z80b3da/btCLWBecP
MWKNLapRPv/8e9PAaXcF505KexvhfZTj6D38MpdBE96iR+geFDz2mCvN2uau
f3DH073r754xn5HGZKhLrw+1uWrJvDRzRrff3j1zVpq3ZFVDKnUcM13EFhuz
eC5MPiP1zub3rLRk1Uh3fD26alERkUajO3V3z0qLVgxv4G7R5bhjF6cjey+H
6aK9Hem3v30hzfnSEpRaI7PsNt6//fe7sHzo6513PpF+9avf+t+wyEdNzDT8
/IYOcBl6iP/ft8Np6Z67n0xf/cr1aeHF9zckooI80M4AyOaZbN0azRUD/sR5
QyNBks3WizEGwu4OzaOjM9PysK3LML+GilbZ3a/XM0y99PX2pQXLVmVNu2ap
G7uBobUbfMZUf8YkF2Idi698yHux8wfPgIKNTfyaTky46yW+MwHJvD/NiXPM
0Ve6HuQrrAaEwkiJoEHMkKFN03vfc2oaPPtuP48O4cCcnnfuvT4oEPfoo65A
JtO3zOJ8/Ws3mAp/qIWgm6W1Q5nX+pcPR9NH14+UQFVmjTEv3XOXFulPw0ud
T/sWr268KXh4eb/xdrchhQ1cP9nPTUtPrv61iyW2ESKBuADV9I6eXnftI2hs
rguCZzHeYftTXTdOCXHcxewutvdDO58ZLNWVjjEqCFm3UrEzzdzpDLPND/tz
Dv7kQokgig/syYFeB0eFRfr7ePvqpQOG7voc53UG2uvr7UWS1c/1UHh8tOfn
uuemnw1lFp89uKJJsZGMvWb0L2/8Q3l6e7TZNWYkntzAcyfHuVtuXlV0vgAE
/GfWxk1ER1wHgIijPM/sduo77iq/a4ug8Ac/cHpN/WwVuyQBrjt5/PK7fmHQ
q4XCwyuWGDIddIzaGUh1cGAgLR5aU1F48roUHh+pLp07w2X4+tvmhQ5Zuw4h
uvsWVwRuD5TlHKTh5RmadPenx4fKs8d7tIwSUAn5Np+v2L+DZl+cnnnmf6qe
Zfv7i1/8unpdR7rQvDGNz6Zxr5RmbaeleOtzhx92qRswDN9LNqAITHB7G2PZ
dDQtmRNUXKrrx6difu4U86ENIa1emZYMznVIzz29C1baGLW/f1Kcu/vu1aUb
ncGUdBf7wPmP73NBevjhZ4NknY60ADve2tE/6tHoiq98eYk/YLOgxo7vO20j
qDbJXnWy66BDDrrE8RgHsADFvs0GqGi0c9XZQsW1ad7MLOxr1ixxVThz3lBF
haE0K4Ty9YUd4jmuurIE9Q4sy47ZBp4hpjNkm264/tFw9Pk5Pe1nKlYBhZUr
f+lURWAvXfTT9F//eZt8Ev9+7z3PFb99eNeznUqf7buqBQi1Um6iCzZgAeph
Cn/4/VvTAftf9KJWosmot9igXjo7O60YFdFWpzmwT9+S0rnuviWlwwI+9ox4
bmc4IzNNX6wyO5TG0mZ9t0vQgMnQxzpglMqdxFB/7rNXw4HR8c507rn3pGef
dcFNp516p2gE+U4wX2b33c4el0YdQSPgwA03PFpkGABmpkcq4MknC98IQ74u
FJoswOxZM0rjBYpGVuYO9S3OVlyO2YJVAYoGZjkKXBYkr2x+0A9QaM5fd3fq
7R9I8+bNS/1z5xpAWr2h+4XQ77rrFx4ba3Y2GxKdmxritf12ORb0qYMvcfCC
YYFXjReLATrs04tEoHIOywFgao5FK4Enx9UgzJGRzEfY9GM/szhQf4hXp1Ny
aMmAK5+5y4Y7gsBrBMTDq5xbQHpAadeF3WnWzMysRozsikxPqyMo1vw4WFzf
bVnbTU5Llqz0eJeYAT+ToBPQx/oqklX6Pq025LTokgec3MdZ10Qebv1qaDyR
B3KF0c3XuS6ZXD31Y3uf77oNK4GjyjkbjNLtO+94wpEA3/O5996nwGudBAzt
Bc8885vCrX+VafyGosJGU4xCsW+V+1wcu5HhNXZumPhdOICT0vDKlWlN0QSp
5Zqp0TKilLSeSBkHLbXWT65M5I4ZXhcXFccaCee7L33xOkhoULTVpMJdXeNw
Vz63ZdrVyMw5U2sOxwnj4ucIsi+MINGqnw+720xkzoCmu8z8/+HdzmbEZX+I
fqxd+zvvU6Z542tBBLwrQ0np17/OIsxlDIUp1sbmMczIhBjjPe+er6ea6i4N
nzZOZzaJc4ggvGRqrjhk9SPtbz3yy+ZWKAIbDf12jCAabM4XPeBhYGrdt704
zsHYcKQNQSjdxrdC8mAtbA99PWneMjzBoPhED6/VcP6AT7gXOjGeipP+gR0H
WvpVv/0lcQ7SiVWjA9+JDhAL+MH3b2nRNsIbuQ2ZNBpjPid+56bNxnmbztUI
TY/EiioAGv2/l5tDcKZFa+p8xtSNPDfl/9G9G/s8KQA4CDVjlAwlNaUmn38I
a0F9eB8hb147nkRiY9qD4SnjnJN9OvzTl65z7/yT78iNtmPS/z9DQzD0pHm3
p8MOXRTknrzO0GQFekH6n/95AYkfT0+Ksug6RtK0UsHxYx+HIpg0zjPkrB91
5BXE3lxNGTqbgAoEvI02s3oxQG8cp2PbjnNOWA/tTHya/14c54hZA15Rhp1h
IpH4Tx1yiVrrngYq2zBN8NUmLuoEbjDMXC/R32H7jHPUMwKe/DajFb2eXGuZ
0OGnEHtwZWWqIoeRGsf5r4k+PNzxxS9cW6JPRoytomv4POTxiHgbAlcfzjpz
uVugnkg0hrkhFBLGYboHjvjewGv6xtduSA888LRH9BwN7XSGywlhlUNsJPb9
2AXSvft/4sJ1xAf7gWHE54z2H+u/Jntg+t57niy9hSLf+uaNrhiN/baKgbju
ukfWYScGxtw+POlizpfd9phjl913G3RvA5QzLTp9xeUrSkAneMXBpg18cQIg
BB3a66PnFhZlANQ8MhTGdna98fuYCEjWCI2j/NckJ72+XrFijYN8uBY0IeBP
qAreIBAA3iX6bE2cHqOHZSCFjCu2w/anZtmaajJwuT+VDtEoErYcvJEYLDkt
G7VJ0X6iijVDPffc80XCoYGwhs7xGBpSK1RCteGGNDav+znNLaU5gR7QgOyY
cwL7YPwrTJ4ITPZ/7xaPmEuKcQZpCkHKxx57TrqUUeYRTQM7NX3ywIsdIMHk
u3940Dsqd1S/+467SoE+pO2QgxemfWad7zB31w+dVZgDaSUkqs8jj/wye9Jd
Qe+njXAoFy605nskwZpFXui3v/29XxT+19HReSAQiWsGl04Rd7xv6ClvFYTx
YTIi2HeFbxGiww691NOk0sjnn3fvGOM0ifilizeySx4RfkcsUEaKSyBZpDHI
etrz0vHmmDLehNNlIBF0YqtN3djhQJK8kN2n5PDRwbeIhFhF6IYwrAmwvRZh
m+Sp5lPm3+EQj2AUIsJ4G/cVgwI/k2S79ppHws+b6KTSs5XTt99SS0RjUPCm
Tpxy2B8wvFGs9IZgD+GKhnstqUCIpyORu03NnblUQl7jpPhJNo5Ihzx2/oaQ
uE5qPR6jBmRaIfZ8F0V4gbAcgkKU35ggBKXLmwe1CN/ffNMqSgoK1zOI+AVo
g0apPjkqmA8TxhAjABdfdH9X8AINu+3Wx6TY09KlP3dxonGzDyRe+Jsyqnwf
+YMSrjBXt2goSThmTZ1TCGMv8w8uv+ynzi027GJWXo/laTQbnBll0/SNr//Y
jN9t/mi6zRN5227hDv3wB7e6AeRA+6N7Dz/sMhkF+opPm1LT8aPwgltNL5YO
IALqgOK4UF6JkmxXTy1UJo/OCCF+xlvSYI8++iuZ/cbL645s6eSFU4EwuI+Q
hygZKROejpHhwLOFyzlPJyUd1BUYCyrIhvkSdcX4OCxHHXF5+sIJOUuDYbjl
5lUyO1QatRrNLhcCtJQOEqsaLMpych88tNDSn00U3vX20qdbblnldlapXML7
NOAnP8lxVbxHFf9Q3UQo6qalXmzib2GUpMwM6cTI5E4xCn3HLU63meHF7Trt
1DvVKZREAJyWjLAqsDiW3viz4mWiEDCE0bHgtiPjadxFfCOlZtidhooN0Hxo
UaOwRAfmI1jLOFGxBSLjcmRz+fJfwCmRopjYkuOFflgw0xtqG2SBpCg101Dq
DjxMsAGIFc1Wuw8PVsXJp3IKggJ+Fy58INo/ySEnapQ4Ydg9h1tN92aSKyJM
KwdWI0M2h5SNraPxnFd4iwMFZyq5Ix7x/f5bvBmgNYEZzKnxcQsQkJRFwdth
8dVll67QbQ0VW0h16iAGdPuyx12DvO+9p3UEDkZjkjmWnAKtgGWgFA6yzbIz
0JKU3dZB29AN5bhwwX3x+imubj5/wjWuGyjaopiAJvJsJNiUZIF04/Ts0/FV
VW/XEIBA/5191t3++oHT7vKxUCybV9RxN8bu6qseVqt2+uDpbsJIgcH8qsBi
uIglmP4vvYNdiS7rMI1fAEJlJQuEpmfIbUqpXc8ODs76qakz9C3GGdyG2Tnz
jOXpa1+9oRTlqDojmlgn+sZCbQQLuNBThTPo1cydz6zAWg4fUtOFWSDp7JDZ
DAuSJgcBvwL9XXoyoVJhB/qv7BZctfghV+aMCLgHTxOyGcYXBQKmVm3o8G5F
H0qOA22tKgU+H8rt9lQzsI2+iBwG4VT8YX6voyq4nUfAE1dd9RA6JuRz07R9
5R3g3jFQDCyFWNhqjAP3cr4nBxORlDZyt1989WPTbjQ04z37qegXj7OBLLwD
X5gFVLZV4Bo1Z6wkNwYfjvIzHDTGxDRiiWKhDbAUHPbaOpeL9DcDoNMQQzeQ
lF/60SzMcQ2JpQfDGahqp1w+4b+6nEw0tCc8XTxQ9RODwGtgBpHP9LICnZLE
D+18RtO37fK+oMGxWPCZSV5LEnv2gV5YYSQl1tvlKp3DDYjx07Zv3T/HJbxy
9qj0wG9GnW7jVc5ymIPWuf5+7h9fAbjHljuhMHFYyXJIzj++7wUFwknS0Iyf
yNxbnFKQkg6e/d0Tby50g1Z1XPJzx1+NIugIjn3b63f2lr7itYek1732k+mf
7fPWV748vWWX09MTt52Vc0aXPOqPrgpputbfyQPiKyRWjZc44hFlsTqzqJPK
oza8ngUVJvjOt5eWj0pkGOUbrl8JJxekULsR9iyJ4r/987tT40X7eylv/vq7
aeedfpS+tico6Qvp2DlLouFVMUtKbUbvwPhKRYo9xSXO6hP9gdxYJ7eKvu3y
oTM9HN28dIr7kz3bNu0GUo1m40Ac9/OycevVeASSLX3zK1+dGlvtm95R9W7H
l1sv3vjVNGM7yW+ziGRNFdtq07XK3SvwEk17xunL3WJ84+s3ZJv1YocvFVJ1
LKxIGBqU6Cx8SfewfURqxZ+KUaBCgULgLTA36dFmlo9g/Y/S61/20tR42WHp
nbzn7cenl4NyX3ag95wiWg5VcixbG730To7pG85aa99ydVCYAvN88yjBY0CJ
wbN/4mEtA4pFIL9nGAEgaSqznKO+Bd2YUorUepfbCQAxrMJ4Gw3jeoPL/3F8
2tw68bevm5tmvHNOehUd2mIfHzaEsy6qsA5txKgRcEGhm7Q1mq7afKnJyK90
eWCdAwt2771Pkm8pvUBSeXsT4XQ4TI4K6vAqt/T3kIT58VV3pXe846Qq+dKf
Xr2V9eQlh9hQ9acemNEYdDtjXnB/S5HDRohZpzvGHKR9zOJryGbufMYYdTHR
0QV+GSYH/x1Nb3BM6lFaBzWItjBPIazRNo6UoQuuAbgVz5Dj3BOPS9NeeoTX
gSGAu+3y/Vxmvdkeaefdzihl1vt8+jJn6aoeodFGOR4UbIJHKWeFSACg3yRo
SrQ4UuL+wYIDhZWVZWRpEaO+4IIhz67h4prwNATyGRVZfsKzRCrxO6y3ARg7
Xfh4Fv6CuZcqFDj8sLPTP1jDt/77Q9Jb3nRcS4U34Ovdb/+0/7/HV/L0iKqQ
oF3HD46Owz/EBXzITOxp4c47nTEpRhLhAxMq4kKoceHF908N2ZEq/OqXr3dZ
VD0ko4phlJ3AszbEm9szpaBPPqBRwBSWHj217duOSX87TVU0U9ImL9knvecD
Z5SI1NH7H57G5vwnbrift97ymONuFPElCx9w026jpRoE6sI5aAmdsUGM4q1J
jpkJl+BmwpZ0FK/dcExQeLLjmTrmodYisuZHZQmemn70g2vTylXPOrDiUaB/
8Bqg8U/P/1q5dhfuGnkfHK8ZHW165wpfE0joycH5iTFq/d+7uVxKADmCn3nU
Jhcdwejcc/fqchmHcaSoiVcaUYkCGKISECVQ7BdvIgdn5B03YRUjcXh89Wnj
EZWYKDBHyAS38Yqc4nHZUW5YUYfMOsk9KDym2mYDK3lmPQ9r6Y3FRW0WpTfp
V+JybZoKaVFW1FarqYgocUUd1133SGkqPrxMj8IIVRLC9SBhEZjww7udXQLF
FNMSNlRBrfA0scst1t/M3uCKE799Uws19jVKIrggfdOFchhgNpzi7CrkFiMS
IyM+sSGItIUTPM9USY4GFKREJ/J48mlks9Dw8Id4HYVGT0wWIg2xQeISz++p
HGkSZWE4CnsRIGmFd5Nd1I623smJp7ckMMEPFwGmuXW6G0a8Y4Lu4HvTXB4V
53JoHJjf/bU//OGPCmBCqGUG/zkQbNPmG+7QRDdV+Cj68IgSeexyEeHFiBDT
TLIPltEPNoFQCR/DL4qWig8C0qh9pOS4Q+PdTFp1eIAlbGZJlI7T5uPjAhDh
R/c4p8TICNSj769fsjKdfdZPnNCqP2TMRXDsJXqxx4Nig268QIzAE2ALKRX1
AnVDKQno0NSL17XWyu34aCYJBWVyclc38TCJJAjgQcKBQ04/76eiVLMWMMxd
FfUYfeCAPeOl66fG14KwsksEZkgeWc+LPwglhnLyqPG3G3rUxBLOpTwWTIPm
sQYrkKV4BgyLAaBU9WUbbiDk4VZSlUyGJdspIKahyREJ0+dtnvd1/9VZQnzg
kQP2v0ieOD5CcETc0eYp2bNsldAO91JQDCiDl48d8d64EQtDSAJAu3V0EUOk
LDs6EZVe52ggwbXXPsJYvHz9TeuNDnIlBIvE1NZxx3Gm0igIy0VxPeHcu18A
CiqAAknTkzeJc/VkpzY2pLcM2QtltIFLiy55IM9UmODsNcUD/QA5wqSEfhQc
gAhkD8mAM7H5bvuJSwu7p5RKfi2XNPvUl7YzlNqApEPjK/A6msvcXnsUP7sK
W5HoxOWklnubaAAuHCXDpIZBRQAKmk12xK4XZ6Is9MZMsWlpdAUtnJGGIjDe
ZpJQOxh7iP+a6BFdnDwO/gYglHmFHQ6AmBecknKQXf4/KkuHdbxRJ6qzh5Kd
5+ef/320YnOj7QKvts2fgdTfN8tbNntOf1qwrM085g0GNP4lmJaMAhkVROHE
79w0AXEPt/LJnLJr/FuMAKPFCGFQGA3UPzq4J+fdZFdRMxHWb/x1NAB1Ti0h
qroz/FIKMEmMLrvtcddYqF7l8YfmxuSA3tlptvHVrJm5qrl75sw0d9HytnNm
SrijDgT8SzSEgCwKzTyBAgQABpFYKUBADamZHztAR8DiMtE0nOQN/20Z/MEs
eplLFUya9ResJQ0S2LBYTcyetFo2Apu651xiq8PL0kxiAjETuYWjx5vh0rFu
XGR8Pnh1NFpoVQYQLGJIWUyNG0PfwW56GmMvKzU5qAeAwgvHsTRoMz34n7Ap
UB60Q+rH9FAUUHR5H3HM9Nl/vwsjXN/pcJAhA7+Z4hY7gSSB8U1ybeUcCxPT
ATh3eNlc697cxNiMDGVy+Yy9Dcxl2QC9/sl/ZaiNikIlKRRFK4nDSBcRW1BZ
rOYnYe4x7xgLZvOgkTMFluXqFbB6ttn4hmRSMW1m4ktx8+WXrSgOPqgSB9iG
b9MYAoXvEVEzAlOjMSCUSMIH200qU3V10CEQFCAv03VLNxUgKgIkHMvmdKfu
/iFTmgNNmm5oZktbVSQWZATpE+AaSEPS5OqrH9YM5iOPuNz7tnDh/elzn73K
LycIiedhMFC1GRAXT7j2jiH6PXc/GSZrmk8tloTD1VQmcS1cS5BCkmv0iXnC
Xa6+wWzYWAp7qCcSbTGlURsQ2GKah1OJ60M7kC89AlHi5TDwFAFEYCpovZmr
hiyATLZAzc9OzZmmbSfCtDNcIrAmouoDk31wx9Nrw0VJUjOh3OH4GhBgpiGo
N90TX3g5VEtwfZ4QuNxbTo/l8hO/MeAo9QkybUn3WZOB4fgpGHO9WqhOrl7t
s+EqqHOqCIQnwC49JUQ+0Z/Vd+xVXhfDM4jDz9r7PNEZyxW+s8+YytUTs8qM
3jYTZjZM5w53BQPKGArN0RgQn8LgNezkN0oU/WvaT04aIJlWkoA2uk6MEcRS
4/ZiL/gbF9vIL/LgqIXFKSTT/DhrUDkHZuLl99//dECUDufLSKe0zK0TJqO0
l9lPqp1CC9VHnuQyw/Wnhne8OTNtoOFr4iutsNKzbbNAGw7B8cPpUkABxIQW
+NQhl5SRF5LVgWthzVbP0Xj4ys1JDR0l7JuKHdvawS8IWrlivHbUNNWEqtUk
Fb2bffBgGF60J0kDyqG4h0w/BmzFT595UfQMmBELAkTIr9OVDvE5kpv2kf0e
WVtWHalm8jWnyKwTtxP1oBRmgQSqqIc8kHipGYP4cbiyxfEkdkqJcfO6zbyr
xBOEEFTGIUqjQCmXruFOLCMRJqvTSSOnxN47wR2NTTwITPWGe9ZfvNb5j9FA
k4CwgQwK4IOyDD4UyEQ5LNQlHShSovcRJkLDJh5twlma11vjPCWpZQ2aLuam
rioVc0W/ofMUk2D8yRkHPnKLyf+GK5WIreaX+HpCEUrI4zrJ3WskntOUuCIA
0ILMvMAELqRa2hk/UX3YGaIO35p7Yx3ZWrXqOVMgmiiT60NpFAyNgVXOnFf8
TXQcL4VOmCtcUs6oCi1e1SYu9Q8hPQRC0SQ6fDKAMQwe2y7NegoGCJgMFqQV
TOuBl8xklAoxyK2FeYiosxiH1CNDAKG49/zz7pV8kLrjlMHNMpo6V7M55Tyt
o97pKlXrVJQ1sLI/CZPM+dJ1Re9cGHqcuXCK9BC0jxaVgkUYI8rlNky7SU7m
XJdwsQen1RoiwhMCjRFbqOcFwBWgOgq9ejzDkWc7c44IBudyHXau0EOFmtQp
lUwMAk5gThjGg4JGdEKZ/RcFj1CAlARGRJPoGLtWt2layeqQzKWpu4TwIj6M
JYxNKG2H7U+JMP/kwvhAXX7zfionKWo3qPHX8QLUDyxzo3GYNVVh8GrSQjsa
vzK+ipWfKrCQH4EUmXkODpnqHoYOWADFBV9jPw6IKpXjPrNYhfj0C+nSsBxh
fSGoR5AeM0C4uvewS6WOr4615Zr8N91HXyEyoC6jN2SYm6pCNBKtBEse+qlL
0tFHXq43I9dQ68smZGh0admenKVxaHrvPU/KcyLnFFPds3GYAA9IcdBctasN
MbUmA2gu8gHF/sJkEFMBEgBhNWMB3lX8gBFFP+BCybgQgzVdIV8ZSBoBrTJc
ZGU5T7HA5JA38uygrrFeLHwLThIO/HCuqRS+YZiIJ2He8GYxmfoONr3bnDOc
OgS+TvfUMFSUJWIcgfJSBccAYJMonSKWKIm0AcvRgtp+vzyfILowqRR2g0Oi
QtP/Z6qAtD8qnvPgkFKoPcWDZ/jMeJYcOCwcdASTRfHhpELLU6ROCi7AqGKE
DUO0gEiJTSbQNMctFILA53SM+KXcVbkAM3c6s5oyNd3zZqvN+dFUF5j+1Pl3
ypn372VGrWtyBYjY3J2Th2XdJhRrWJoSGkURCHhLvcAaIL4wYn4fyhrVZK9p
gxFy/e5klz5ceTeXphTpJESl2s6kUwYE4HHaqXf6xzCY8m2OFMNUAc1I2cMr
Zu6MvMyF6ain1ZZ2owNAlw+uWOOWALxNWQQyasNWT01WTa6gwrpFQ1NcWyNo
aHy+UwEukkTCnRK4CZ5q7ShleLXUQUKElr7Ws6xBrSRy4DgUo4lKxtBdHqqn
FyA41MIeu59THkfB7U9zVXmJtpAmJ1C0Ae3zivgqJuW28C7Ou3zMelopqZm6
uI5lG6ghr6vOoQw8DQ4xqmh6vcqzgLCMOAqPsCW4U0luRIgeoUsQCXoLUYng
VA42qBzJOLYUwXY6t3BgwG2YVSiGHwFXoJkQKBV1R+d8suPE4E98b/gSg6ss
I9oLXW86QjlBYm9aq6MnAg9qWZ33bpPJE+mvyS5CC+lRywS18ssyg9Ayve64
yOwaGpRYw9JEhYsxMnpQVYoWJwFsvD0lviRpQTZbgIKOyIqi4FlVbULoBwCj
Vl0TLUAOytuRmVW2E8lCu5gcqjaGwACQFcmyYVA5hZ4oWUWns14iMg1aoIUG
l8TMhHi0+lFXNf6wTzMB3lFQg3FeISXXoTIIxb9kw6MBVlSdswYUHwSLhjUZ
u3Ap3Hn//U957lXFxBO89LDDJx0EICsJcCl/MKQmdZ7wuaudniYFml3YTImM
+GBTV6FeMlSQebddz4ombuEEFZRFkxBeR7VCYDwRmq/5DqRYOLQASsz30LoV
pvNrDcBgk+SUW4AlHKsjefMleTmGhqIrpAfrOZ5EFm1c9Ggt98PFcujboCNi
2arC0yOQfhw7w7Whn/IUOoZPKWbCDDgjcIRae0gsh1I/a10tP97aT51lZSNS
v/a9sAkMtuce53idMVrmzjsed3QLCs4cs5V7c1WqN/UFPgWS8T+P5MBcM0SS
SFRuzLpKPze/nRILDQbGImYcN1SydpD9X5fywgKQzjRYuQ8g2QpBOspKwQ88
8Eyw2lTXkAzkZ46+0qNnSDtHKBpHTNY2h201/NKwIf4x47mQmnQWjjNReJkV
5J/nmU0opMbFwdQY1Cc4pdshAx4sk7u1IpDZgIJspfvoDkgIQbv4ovs7Q5dC
TayQqGOj1lDykEuxOjooH9FC0sRne7bNc9NxpjgAyVwP6zfrJrLKERAUdSnt
QbOBUQQY0b+afKV1auqp1BwXxaJkYNc7bn9CAHkcURGWQwT0lVZHJKYB78CD
X/rCdUKdQD6t4UegLVZE8yFDcWnmLlPZBOWrtb0cqdr9peOwHgDl3TNOLpEH
BbU1Sb85zzaHDtAvjKX8fMxAiEFZGweACFFpF8FyJLPMwcilkEAnHWQG3AY1
5RgcYnJfarGPOSoDERIRxj0yKoqPNbFjRx2BKVVyvO3rObfRsnwrUJ8p7KVs
bWS4LKcjY7aRZQgaOkQf+IOWtr9VzAA6l0mUxKBFiElAogo0AyZwztCDKCBi
ZjBEc+mXTmUvXOjMqmaJ2MoDVqB1eOrRR3/pcxf5G8xNC+D+SNQ53WKZWUdY
uB8zwr6/t3J/qmrLGI6pDpKVatOwIC3oDwaffJnpWLVWfMphwid/WKMHNJd3
SBCWgCEjgwybNtwknoKC5UV8rENC2vQP/4i+cFdTJ00tE02bx0ha2k8ZQXea
PTvnPBetXPsXVnNMC02ABaAVQDrGFBEkOcESnRp/smbyzkRZsBrG/pZb1OJp
zvy4JYgfBlM4mDgMnrcMpY1AqWpUPjTT7xrXeUweodonS8B0537Nl+VAb1EJ
zAxQ0ghAzgvOv9fb/d0Tb5pY8RnhfYD9ww8VgAe/SJ7kQsA/oQgYQc3frzJZ
/mGqxBc+f01693bzi2Kt5uAVvKjVoFNSYmKyR+QYUi3xAfjTmgNllfNN0/JY
o3ZpLMm2csFsz3CxhG2b8pc2yS0tUAAjY0PJBQl2AO20eFFO+U/11B4jgFWh
wT0ROcezAYkitqZEJR9V3Q4zJ0QW4XxzP22s+dlRTzktWgvzGk5MqZPWnGlG
g6AG9ggyU4NofCgzx2k1Xsa9rjITq+IT4AWjLAVKqKHUdYqLUqIYs+BLFB1F
C2BISauDdLqVAaZj4ArK7GrGlqpVG5W31uqOc5Y+uaHSn3Y1DBpKBC+UTjH6
dRXatCAkpgP1gkOJWmNmC4gUYbYhVf0+owvK4lDRtF0iuiDGONFYSRkRRFDl
M5HQslONnEKl7n33Dw+Wpn00lr+gKqwzeK0OuvJReIPsOiEJzemD44xjtSg3
II2E/Pvfd1okOU8uhdVY81hWrZT+EE6n7dgf6QVCdCtv+FFObC5dU8Zo9eK8
Amf/DRtXptR+jGBiGLte6IoiG5Qtzl2GUBOdMzF9mukEBLWeKQHFzBkhYQ7U
h8ETjU1Va1QSwvhx3FIDdd5QpUs9p0h5gAl1C5Rs9Us607e/eaMbRTjnEx9f
oLoJRgWGIzSjHN4Bsdw1rzZWEXxBSjSjULFmOEqzZWa89aNOxiMv/Jkg2PJ5
uViu//obNqpAqq4X00I06B5lxaXt8JyICJtHUshfLbjhH+rWZ+50hkaM/qO2
DJ0anfjZoXxs9ehcCwjuA0LzMcwTEYAupx2VRtAXxYqHq8UpVY1U5V8LGASJ
QVDmrW0Tmoqm1mkkjRnnTexksbkND6PZxC2Li7nPR76U/r0RZXrzFqQF/bNz
HUX3nLRqZIM1Vm1YX7SHAaOSp0B5WkNaDW8QU3jzTT9vaJEkom3qUFVgTD/R
WobEG01dNF+LMZYCa0KPMY+jIB7o3ErPidVs4+bU8W9988aJ1es43ayVmFLC
4cR+lebC/gFpweqGgoovRDPEcbkLm6dTT7nMbYHXpAwu8IWvFyxelrJx/9/U
XqlAT/mGaLkvoy7HQz0CI5mhlGai8Win5vBMauEpTEGdN6wTK4iHPiwL9Kp4
JgHEVnvaVZ7JPFTe2cwndJSZJ2abizcGxHvowTW+Hs7m0T0KCYAS1Ivxsb/L
M+Yec4xTZsacJY2W/W7WX2y1QZjU6a4G7gFpH2uxMn+k46iPRHhlXLiE8zRK
u5BoLySUhpfl5ttBeWCGK694sPHaeBO+AFofkajmSn5wx4Ey9akOGbXKc6dX
tODUotHMb5oWp4FpSANxaYOymZCbeoxea45yXJmXtPIBImKjBYqGBnudOrPm
+brUKnT4CwurJodQ4g7SAswVaIB4/P6fuHDsrIQazwBEIkBRpFrzJeCkKSHV
IHwGhtqJnhyPJfqoNbfxIgPGl0eTaDskL6AUkp6XXECJfjyvFS3C1wt5SI/g
3sCLxEpxVxhq4/8tgmXJ9VT5LGLuwZ7T0vCKxbEBzsw0Z97ishzun1lvlb+a
6vEMsCBpsZ4I78EmMCGsQbjOtJ18dvQABgOdYQpS1hi1ETNs/S24e3fc/oQg
NaIt769OXiHWQEJthkICgKerLL45J6PDo2AIFZOXJe7VCrANTaHlXjldjAaW
evNgAc/DHnixlyrIYn95ThHptWtWpeXLhtLw6EaWXSm6rvkMqCvIEKvfjccB
svbgOKyQtktpppi7SoICk8Ej2YZlQuy58MILow6bDpq9sJABr0PD+4bQYtoR
RBVbMCXINyLO4mPCaIJWMpq8luaZpBV+p/rge9+9ydGarB1enl67SbwWkKLZ
TeJerB0Ju9///g+q2xyHIcUrRAUoUmqKy1T/H3eLtABRE42vPA48AWPSenb/
WBSq9ZQxudbhelFjOAbZLZC5Q9MLK4pOcpRdz4YjwLxiRQ6R6j6YWoUAMqHI
xn/+8FYnQd9xi+XrMbBcSn0wCDInLUy/2neURNV757B+nPbhqZczEIMhtCQ6
iLW3IbGyXGgbMvcMtA3SxJAf3oh6BKyrSpQOaeXqxVc+VHY2wprUq4/UvMJz
GCXOiTCw3uq8tUvs0jTF/TNylyIoquaOO55wDUBMEF4r+ta0fmtkvtPzURIt
Gz9BdNzEMEXBVJu64iAMAB5x/GbGEUkikKMpqBiYmBbo+SyDO1IMxNYiMV5a
hJBSswNVtlw/zfUIkEqrfZriqIRH41+jPsgaSahoAeuPTo07SKZTZUC04qEH
nxUXzWhWD2jSZ8scamnYNwYT1/TmQ5UB9XknHH91Ca7CYbwGkGvPEHypwmcN
FS5BO4ZVj8NyIhckfzkAtNxH7YlRQK4/bmRkEws9kWmqg2htm8IM0VMpmOYj
crISxqHjDBcmA4OFK2OvmxY6hcidDr4iC2YSJLai2+Qayc7bk8TBeCNoNhug
sqpwtaFQKJqp0l1um6qawqiCyNudVTWG69qGvLKIuq1gB3EYeR2q0UBIwWjY
g4B2LtcmZKJ0FSMpj4dEmoS0EZQmqL1PuGLyoegYXMvSqNODFQnZ6EBRA2mb
anZ+SXkYKhNNoUkE/8pmHXAe7BPGT5eua+qzu0Uas+4cj4Shm7TrcmdRwSEM
m0GAEnslGYMMEnqSr4QCJAtRsycGUARyotU4QEvHkrNqbtU6f8tgifdXOSg+
UJNixFhlU0ZIMq3dZwnKABBZB1PN0BrkqRimvCiiFqmrnaOxVmJdVss6lHQk
UdyDD1o4oZ5RUNXmFTgEVEFV1dsQ3nXnL9wSc04BMhiE4Ym1fTuqpsIH9Qo0
QBDOXb9kZTvjpcEhf/OpXDpcBpGwHTU4po8LGt+nmgdU1nCcWPJ6+sQyRaI9
ZZQ6CATXeVJYgqFCLb85WkNwQYsV16ulapUvgQD8BVQ7KUozOordELomHMcU
A1pjQLl0FLQCamkO4URXkFHP5NfD7WULyewiRra3oRIDzJ46i/aHTtRFU0XU
xm5pxMabGoLxP6BZJ+bzMiYwCI2OUipDiZQ6j4wqxzHni9cpMlLnbXoCJ4Kk
6TgQ5QpzdOtsP1k8GvWmaJpy3E1O6HTOYI4SOMbwidxsRArJz1TPhCEGpzoK
ak1wuhhy1hmeGD3FyNMcxogPACtTZuI6a4MgSsbqG4K4HVG/pXlqqEYMO68x
iZc2rfkU/bTPx85vAV+AIQhCyQOLYmrZkDotibDSYm2ayHcyu9KhVTK6UUup
JnfqXOX4F8ug9djZf1RCosXsa92JSYx2FZeJIoSe8Df5TR2zIW5NnF+vx5q3
3sarsRaWjHtsZ1VkgkSKydLYcplc1oqrlaelxD4wuODypcjecNjXhQtI7cKY
2Fr8KCBfpulkP4+/AdaAoWFU2ap3vbOY+apOo1EHbom8YFpikk3J2Mc+Py36
Wya+p3hG0+viPT/Q1zBxvTh0TwTQzOvdCPLW+0ypmkS71qJTf55TNl4JovJ9
AyIFlaPpIBSwYUbPSQJd8mn1IfphZJfmwhMC9tQeP5orqkNigtMWLfUmoEjZ
SvI96Axaj6mntEO5Yljsmmt8EQuPBiggxfVHRERWbEhVE/Ip/ERVFLaVCSgT
/Oc0X6/kyJjBKc6SuAJ8tIy72c+izHEulBisuZJsKotDTIglIrQ8UkrNauf1
RhozOTC16iqPxJYQl8aXIf6fp+3fk04//a6SPmU2KCS3+0rYkXthJ8oPDAUo
J+Nzas1u4BIb3H9NEI9EeX2gH9AjTNMSWCBdfFw2P8WCoQuQE2WSQI3GG7K/
4nFsKM4DtZ21uhEdpEZw0pkKuPMHs9mJSUUT0EOiM16aVkuqtwGMyVjFR42d
sf0K97ZriKfYLpaCYkDiNl/8wrWqWwBG5DqIEa+DYGBwIODFhRc/4PjomKO9
pLAs6EYwF3lFkuTO0FbzhEqUjKCB+vya4AoGkUFF/fMergExowRxvjSvDV48
79x7fATtmUJA5DVga7qLmx7r1UpT9do4R1ylAGiMRr02NnOsJoAi7LvvxJS2
WGg2vWf7Zogen27A2IlwvEYRF3FsxSr3hhte4hzrTVjk2Yuqn9Oyy8pdwzTU
Tmg2EkCY6w3HlHjv9/tvLkSCCkw2//Y3l0oXBfRvaSEgNeqwYxw6S60b+nuv
Pc/Vqth0GvZFDcBOsABDzWJpRx95uapWKEzDE2W6FBFmDCC3MbdchftIA5pG
B+gROmmvFCbrTeBMo7Ucod5kQuc0/e4I86vq5d30N6vhikXqdWO3n/E968qd
RPL/zJIwFTswJHAUa99Vbg4GGLCKNkAN5yLk3PB6/xhNOq6nFsqXHDXxJ0yk
OuR6NWswMurjn6OFsRNZRYzc0TokwpT3ahM2KpmChi3ZGbQ0TTCVWVd57Nui
4Celr5j2rSeTYfOIluRSlnwNfuCNl1+Y9npVIzVetWva6/1vN9LtTFnWX7rK
jhaDQMhhxqhxl0KvcvRoccmldgJq9jUDNxIjXPHauI7/VVA9OevaKkrCYBID
bmKUyf5kUgyAMt6AU4PdxqIYA3R4FrDDc9+tS3ZnNxZJRoFIdaNWQVhm24LS
m7tDMzr6dOonMTJ7QRJWzaVPOY/3l5U+SR2BOPFtcDE3jTaiOWkxYjxrr/M9
C8fELA4kn31VhCvRujEzrawVgKMiR1EcWdeg80H8qyXj0PfyHDDguFnygrFn
vJbdGSZUIxiV2gXKYxdU76uUHzZC80zM3VAmgoS1y1psyDtrcGUpSFqzpC8m
/W9gp/DUtthFBCZ1JP5TjQji/D3Tawf4OlGZm+rZHT3b5pkJOBeko6u5UbXR
zwo7p38U2OaDGjXFLmgyFqLirxfST/KoEKaWSigu1UaPZBLregtEoDltN/sr
6rMi8JgOvDoabd5DbvRfe90L+BqS7xVbNRKF0b4bhayzczBqzfLB2EuZTUXb
byeuWoC60kW0Bw2FN15oD5cRtv3G128oHEZ3ld7QdXBO7FwVOmKS52brmv6Y
G0RkuTiqTGmoZuCjyoM8k11bqM8gZ8yBxn2/jy8Qd+6+29ktA2YefLFHlAGP
nfdBoCY29mvoGREg9y6Eag9BMcS3dkXq684rT+VlQmakwaHh/+WqS5tHJzH8
FEcS9cer1BZxMMGhn1okM1nvcgnSYK1OjQdsCPL84I4DDVXi1babD3UAxuiv
iT6BhagZ3SOgwa6xMCAciT6CzNYKhW5QW+gURstw6qTg39gBxQXP7HgT+rQG
OiPkomJwTV4FchA9ZqsME98JXs2brS0uA6hGtfKoP15GOoQn8lIzFFq0OI2u
Sv0zm7vrzl4QMej/3UJPGiKIhUcJL2p+NnLCYYhGUg+y22P3c1rEoq5HkIKp
hxKnxX2JX/5WAAWuHztpqN6HQ2OCPSX8E8se1vtfzT/59ljEjUs3cwUaLfM6
GA6S7AgU5hhdprlbKB0t7H7oIYsKfertm3OzXuzW8L77nnINK0XFu/Is0dG0
qDfGY2BpWjW0IKMWt7sbLFjamHGpNw9i1YOecH2xYOb+ahV+5Utq+Ps+GwMk
DgMYc1pd/REn+6d4M8Mdi/0X3UEgO2xHi3sDg95/39NF70ARGVfBaaQcijGY
is+ZWtPXiCBxZKUoIhYkOsAlCngryILtIUJHOaKH7ZvQ7oUXns06v2/JhJD5
5f0zguJ/aWWTigKJgeK528faws9cmFOX4pIUs4a8qNJRH9l9kCRIQYSAYrrF
bURXyPUAjCGOIZy8YMO0oqP0wU2EjljZ2OnNK02MAkVgUBCKZ4qCOOUEl0iQ
CGdduGDIx8k8Mk0iJTFW7x+i12IF8Xg7g/tQX3AaH+2ehSODGbEmdgQmzZNe
R9IgvD1naVB0JC2YnQ04A9CmJmojRoOG0Lh6Xd7xVs6qqhZKBdKsvc/ztMml
ix5wcx0rdqj/bLKoJfCZU8G+psrtYKRIsmNO7XydtRTi+vsYQZwFRhEdQswJ
BmWwcU2gOj3A8ppFKq2lB0BZ8kEiAtEW0gOEBxXqR5qYtnGC+Ww2XLKJvEI5
EE1/RjUiZZhcDpYn0tJyKlkaWbXU66q6Z85Os2bkNcGWrCprIa+3vKoOEglP
oWqjCKVM+iNWqnEUhAaQElnApqB6cWM+a2QkwoNcHN93lemz631Cm/rHiIRg
FJIxPUXP1ooypDM0UYSDuAEW1oaoUUNaLZ0vFR5LeBYHk7IX7Z1Y767UylBd
btAU/KekLa9lkSWG2ATcdNddT3gopCcidRjE5557Xo7J2tjNfbSS3XXqr9pZ
hmxDY3XzQh0MVJiC4tkeaPxLrIxFeFVZh6NJUkeGUikPEIC4BE76vE9uzuYE
M08+FEpqIzGQAosLZDS8jZuTapajixt4CscA6kMZGVHEWdaN39odjPu1DgjO
xaZBdbihhhU4xRq5amZtUQ9gh9iYqtEmGZAZeWrZAF0axNfyMWZDyxK5jY2L
aqqi15mJqkEFvbVOselswf3G8yJmveqpdnjAgTWfuhQNQWi0B1YH10OBV9LC
hBYNV5ZIgXbT69m2rhkYu9xGhxbRjMblez8ZiZPa3oOTtf9tmzSf5gVoWQwe
QwYFIu66y1kTyLnZMwlnEy04OKcqREMwPp3JPJlfgiy3KvUu1xmEq/BS0XcY
gVof5M1JUhBuuhOOZ6B+gX0AfVqk5XLuvy8jEGChfTepohe4x8S2uBgSf0Xk
QAQ2xCqg/swxpSrGP3jo8DrFyqt+PtyG7bJh28SxABSTD5nXMWwuL6eNGJUt
wWMQ/VhTTiuJTI8WjQUSGDvuJQVsdqGuHVHl2L9GK4kNt5J+sgut8Af1s0yN
hwZ7G/nKnia5Oihks1QyQnVGDr+Kg7m/gDs9Dh101JGXq0XMFBSNNDdnvXTb
tJhThfgYKFWC5C2Gsh1ArEEv0GnPPc5Rg+u6o+kxFLhwYF8NBXXCHFq5gHNe
9Gwk5RUApTeGJPEK7YNq5q9e3E36FJjNBAE1QdsbN3X11LKlMlKAxcRNhQsA
CuhRArjmeYpmdcqkDc0UJWWWj+LkRyk83+UP5ysGCkDOWnnSIf/1w2ZhjCZR
EOBG1SFamLj7Sna6q17T0nUSswjfEq/nemhMatXEUSxGpOWKWFiRD7o89qCH
Hs3Cz+Y6EFpJIKqfnMSnnXanvAyo+J53N1EtnPn002t9xZcaw2wSjQY7nJDL
T8RLxYow8Iwi04rk8GJNIzdcMpdMIiAx3lwDostTk/gECsefcfryxluDlOB/
RlnhBeEETW3i7y9HdbEh0M2ixyTL4TPE3AgkXsI1e+KJrAnarNmhxs79enP7
3S3jyfXmnNaJDEAmOcxV3gTnEV1Cu/bb94JSkoBeZVYSfYFjebT5Pf/uX0+r
Z8eUJD18hnruieAjsMn6FLMTu8oukwqzsFq2bBP7H6LOWTZjI1Zd0DSInhKy
2MQRKpE68Em9USW/wSgYe+3RQY9g44w1NnMKYB5Rn/z+zW9+V3AJzwXf0N3V
v8jFtqga7AL1wG/3Z0x1q3dTqNtcFje/JUqI7BsnbCOwQdLwiV9vqMdylkBz
Mf+qoaIEYpw6VM5TpKsrffHz15ZJpIwLdnsCjG6yBgHqAz9UO/zxGia1K8cD
8cAp2imIceY6I0LjHdE8iAt7s8iboJMSJju859SGYhpH9l7mywASbm2zPpDG
WVNamuOcE/233/64ozJrsnpLNuP884dc8LBwx35mcUvFF6YKx4RhIgsiZVB7
l4qqwvgcshL2f2M7b1KnVxxpSRJDfArYa2XVGnCBhXg081/adFZDDKMI6E8P
2qNbVZBB7JdcDVEyKh8UC/jB929Nl11W6oldRX1lzhJ18Njm+islLslrsNmE
FtRKk6kZ0UetXcTXBqrqOS9jQaUkjYKjdbasqScGqgZXi5PxMNCyFtrCDJJi
NUTS0D6tjCW+c2BMt0y8EFOC/Cjb1IwgdLZkoBYufKDsshtENEZtzMjtzBsC
SAGi/E2TCYdJgpvoJ1dGxh6Q7URWbjTJLmKrZjOL11/vvGy9qqFbjlmcUhDy
ESYq2FGgy4lmxqmr6BpnJNRxrVTAx1CUcjUXRpo/Vlno8dOTXeAhPd4fthJT
wQyZeKNexOqq+36stXq6XrdUzlqdUy/zkez/4bW56GAjfF+v2Z95ZstC6nU/
xYVAG3n0spUskn7A/rk0sK7kEj323vO8vI9MXhaeU5SyvNNfPSWs2d0l6g3w
xPxCs6+YLqBCVEzA+fe/99SKIvbNO+amI/fYw+PEOdM9pw6+jJcAl51Nw0Oe
pGnMyHGb7t5Bwsht8uNbxJ2CpnwQCpSSObMviXYSWFYUWCOnsKDxRPS9ww39
2Dk/1aKOyJpkXauaNB/Z5dxJyZYHaRt9pFDLanZtUtaJwO3cRk5351huDuR2
z122EX1HkROU46MokcnI1HHYZvM4hw4Jr7yIjEw85tx0Xk+8WLmSpiJmo6YS
Zwqu2yLdamgBFTk0z/re3ZqqaZdSfsr392ikwRUjxdkfilVPhkaaAjQOAeQR
oLUIt1E98tLoDRqSHuIGW28lB6oHorOGedTJatp/7LS6hUcriBCs26H2ydnr
+nPjl480S9QUC563fG27DmnJRnJVsp8vLTQ/r2CesrmrmYkoUmj0BDeQjMNk
o/o1L9IIsFWoDSYJydVep2etudAC85UMHfxe9Gxts2d5J6lG6l8+nHtW56SF
1AkvYbwJ2ktz9YyjzVAxmp0r+FFVcPnkixuufzT3dUIsikjmR+Jvsprh/lYu
i1TiKQK3Tmc3kFbcqM6OP4yKioCYCAkzQ+Ifo1NaJ5Qr3lmuG/GYg11bvBWk
lkwdQ2jYNcPIzcZhxvZJuBt97YwxvVi+Ucy4TTBUvaA1RKXKyfCLeBD1qOS8
eDXqjFo6iT9ILKuphvISDMSGgDB8z0qyVy1+SJ1dMTBzXVWy/pxX6RjDo85m
VTw7rRxtq0oyp07znHVgBv8efYqhUO2V5jngQf9N9FZbMte9hQIRjY/eTnfD
QpkKcSHt2FOipyMrU39vb85WzKhKETZtl1fy3vfPKLU5ztSzMa7zhtoYjhfF
yBI+IlxSrehDoEsWbunSZt36NiGN9doohJKMxcPtyUs/QQtUsVlBcTIBLG4D
XFl3S+HA2lVpEWuNdPez/oUK6cfLzRR4sHYoRHaWl8p09y2AUG16mhXq1LJ9
gTwH4H7s0ulrunPe4JYgDPwMtpUDTwW+eV+KytSlEeZ0vTXeX+3aWlgNTzUS
qiXnBoT8ZsT/q7V7CJVplynVAYyONGdqyJOssygls2KSMWzn1gyP5HtrxyN7
W1NK0g4hpneaekhoApNgmLlMZ93Fl1LMAAk8ycHUO0AU0aFvf/PGAvjQ0HXe
gsyU8fhbom34MVpqUu1FBBAFZrvIG9g7amt7cshAaPbii+8v2xNobc9xRjrv
fbG187Q6RkcV1xaygxNZu5fOEb/DerA0P/8D6QSgCI4cfNBCTdMZW4nD9uP1
5C7tQfr6YDiqgLUJPU62Ng3EEmLJ0Q1GMylRajgoowTuy7Vn4Q9QDFO2jYav
XH/f894VWzlHE5iBuwmBMNjyALElNJTvYGvCXnAbEVZS+HifzOOJlGRDu3VT
U/XhqjYLFc52Bvhz0A7sxXuh+YMPrnldNcCanqRO0hH5Kprm62uNsbX2sscd
3dRrkJiRUYEZQIeYhYrPCEK2IUhm/OmOhTSdAimUhPJbA02BAYT5bN9VKqAk
IPCud57sg1Sw41TnczK7TILGccIeUH+ZVWiObxkptX8PKp64bT31vZomV87V
s2FFKrpP0odUvdw/XhOV8WWdnfWuJr2pax7IRgQPeIt/y0ARpJbVwUoRrOJ1
TOwrAddmZXGsda6yp7FyAFI12FL3L5ZXjvHp9JdAZILEn//cNVvFC6IMxt0N
65qc/1hFbkO9fHnoNI2iAicQnSkD5Op8mYzz7zWighm7yjQ1ivK4ztz5Zl75
o+d6yI/8hebOow7kPH1k90FRRkEeMpyrV/9abIh21V6GW4UWRXDgPyoswKGk
CZF+rkPh3HH7E7mAeJ39Ixp5mU0iXGQfpIa0dDXxGTAv+kLFOUAUshOsSiZF
We1QVurq8f2oE5OWZP1tKVvEcGz2lKxY7HhWqqrWOyKdLltYD/pYVmfMwIEZ
srScD7sQC6ORJqDefvvtTim9gWzaAUC9Qd+oN6UGzPiTgeNaXq04KxN7JTkw
AtaVmtI3rL8HWoddGzvVQopXr8tliJWh44qto1EwBV3VhkisCKbnanXtZghs
onepmqXnLsMRh18mqhFfJbBNEhWNTap/gz3oKpF3fep88jXr7FmTV67StmLq
CYqf1qAriIOxB7F228LnjPqQ5qogBu9anzvRDSsokTARhXokYG+79bE3rb8H
kmvWI6lK/nydA4AE61TxZvs7wm1T6tky/oF1wKHEAKMEtqwoRAGlau6jyLFQ
oVrHubBcvZF8HVRljEmfmkYVcoVQeHFSruz/++b19/TvgkZ4HISnKH/iw/iU
SvVsRSSRXdHhmGfnDaODGCbyszHz3iVa86PA9VSJEs1ATmBMAyMS5GqP20ad
BIit7EtKY5wOvCHaBOwnzQSzUCdXL/YOPVpFqbPURnPe+FsbGKOqUF84I2WO
f4drOfX/P/hZq8o3BEHqOVAcWgYGiSPWzSLfSuBAOOa0EkofHLzbE0OcI5ig
3YXJqEEszK/kBjsKquO6NlR5m/+a1DKjnB7v87Ey3dYemeeeU3Coc7lweHJO
ii9+yNlCuWaMEzM57dUSnY0MJ78tiKsKHD5mgN5csazTy5gMMMyC6q+MhqTR
1Wmgb/bYMK5fv2JgVhcn7bIZqob8s0O3/xYCAM5BSaBkVKZo6FteFeCUzR9N
Jhr/GOfGi68S9VgwK9f6LVi8OC1YsMA+83y75aXDf0l8VQ3E+9B+LcATpss+
9dTaWXFnFZJp+mjm0g5YY3oXyXs1h3f1ULr5sq8q2PlnxjrfHl/VTube47Sg
6RHmLjZbANk2IjJZx+/mjfMCLbmQRnKooX9ZLjlXP/6CeNl4r9FeHmVm0nDL
K/4vvEEV1SPDw6kEk5yTlzrTz7WODTXDZ+NFz/6p9elVvKo8fdmcmWnu8iqC
tWLAb581sKKOV40Xroqn/5f/6hovRNRMLqzOyYR5i5en5UsH06zuLLSDK9vG
iPLktcaPxKHjh2RWLs4Ren16B5ZvKCQTDz4pejVuGIMkGWGMtaPjhjFyxWWj
8Vf/B78yYBg=\
\>"]]
}, Closed]],

Cell[TextData[{
 "Here is the ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"walk", "=", 
   RowBox[{"RandomWalkPi", "[", 
    RowBox[{"10000", ",", "5"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "walk", "]"}]}], ";"}]}], "InputOnly",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"walk", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", ".2", "]"}], ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Range", "[", "len", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJysfXd4VcW3dggBQie9h/Sc9B5SOUNCE5DeREQERJpKJypNQDpIkyYiICpV
EQFRAmfRERCRJiIgTXqvkfodZt41h73v9f7ufZ4v/+R5n3fmnTUza9aemT17
Tmind5u/6ezk5HS2hpPT8/+NLiXVuLHjoNWpVW2PKu9etzWW+KzVSf4tKL57
YueBrsuuWUuB79hg2I/v1dhk/fb34xN8Py+xndvw8Ze/tPzT6vuhbXeTK6Wp
V8KCqaF9j9oU70rflklPrV3ljq1u4sNGp5tXplJKmL4B7yzhTZ2+Q8VuXcYG
nrcV3W/t+k5QNa23Cvzwapu7/7xitebbSnv2oXwPaijtv6Px/LOPXJavL7Gu
r2iZlPKjD8048Po7JyddsLr8sO6al4c/NZDpH2l8DfXl9Mmob6+Oc+Jfft2L
OsE+5vPQfozLy/qcsnH6tg/3/LLh1l2dvrXETsTlrbg769NBZ2/ZGK+S+JKt
S3zjuPQ63iRk/XdZGbdR/WPj+jVX7aPr20zZZ+X2Wa/st21b+He35oPcKc+k
19ak19Sk51Qs+1fb01K1r05/6NaQEa3aO9Hew8k9ek51o6fXO3dPO1yWlD9V
oceyPZ/YSgEvVf1hC1lbYW+3Mh7UCnqc3qynyntkaztzShOPMRWp1I3n+vdt
zC+T7VVKl+ck+ac2svab3OBgWbTvP9B/ahv+4Ls1c3qUJh/4q8pfXvuj4svR
O1sqlmtVuhT6y4XatxvgEv7rbVv8k7/Pnyhy1jz377vAHZU/2HoDN0V/9AHm
/liN8cP94Qd7XkF/sL87ob71MH64vjxeVHu5mupTBvUpsSm+Ej1pqcYv11cN
w1V5rNeb6qR07vR+MbffM5XeupLbD/GgHerL8aAN/JnjwYdoP+S3tUX7cfuv
gl4p4I6orzNwb7RfGeirck8Vq/+7im8+e/53w+rss33iuO77ixsqe6yuSH9c
8n9ZuX0fSPzA+j3wY4lLizUGXFGsBY6S/VtF9JT9fQZ8OaHKP1qscFWhyj9e
/FRiD+BTxd1LTao0dWs10UTltyreTXyt9IG9xFfAKr27uIH2Zj1V3uni6U/7
3nknz0u4oX4K+wkPYNbrdu+zoCPW38H7iGNfl586uNw9m0XWx1ckXGr1y4fV
nWnjo7bHGq31M/HeopXMfwH5PcTRnou67N2yGbyneDQoc+apd2+BdxOxkX18
+/7+ELy7OCz1yhC3X36zq79+38KJuP0OGfgKwnPjMS/xRSViPS9g7o8j5Qf3
HLW8Gh1w9vcLG1NGpzfrcX9w+Sp9edHraVTzOhvKa7141J/1LLBfjc+n1hLU
73G1eTP3xt6yTv3kQfT8aqdsTSR/31pfts8D2/3QrIQ5rc5Yc1G/ber5Y6sL
fn1V+XyyTkL+79TzxnYP+isQ/yaAV+PNmRZEXT8bdXet1enk83h5zzYZOPbq
S03dGpcinf6kiqcXh8458lfxcfBl6HKl04N+nnnTyno9aoz8sOm+Z9YjiKfM
v4J4yuUp3oXGQX8F4sFV6LdFfObyWG8x/EPV56ZtJfBq1Pe+qb6TTPXl9mC9
Fciv+LJUH/6o6ldZl6filZu2z3qnwsfnq3vRPPAq3vnSTfAKe+r03W/eHLBt
to9uD8V76/ZXvB+lVb9z6utJf1vV8yyQfs5b0/fNxLvW3QN7Jv7mGkIZ4D3v
Ryxx/TqUCPk7DDgZKuqEUw0DH0YBPwU8bPf0H/ARdBXlL5H1iaT7sE/xkZQ/
vv6zTV3vI38EdZDxxFmo8iMoD7x6XoVrPrOoJKfT3jCa/27dced7VBCKj6By
fjG7gn4oAz6c8DwBDiXMz8TVkpqbYxNDaauaL4ijsn2CNS6U7R1EndV8QHwj
7Q/QvJ+011/rKT6In1di0Xsf1bvzcQhhvihqQw/PL5QfotOr8qrTIDWfAQ7Q
WOn78fMb5ftqXmFPjUfJ9vBAeR7gvXV9FO+l66Owm8Y3pH3VdP3WyPIrU1m0
7xo8f8sAj8d8Y3y5VaPXZD62dsTz0lP6wyXreDwvj8v+32v1xPP3ILBFjvdr
tt3AVEXFl83AVxGv1gN3bCfCC8/tt3bA82DQzgflW/c5bSPw7n2qXW0RdML6
A3CSnH9ctDbHeGO9NSa9jia9YvB5DVX8a6PmR9YNiAejUd99iAel0R4bEA96
qfmQ6Ib40hb5TyIejEV+V8SDduBTEQ/a4PmaivjXCrjL0ekLwuY9tLUAdkM8
bQf7N8K+5gb+CeYZR4rD5Hz3ik09z48VD0Z9K+N56w49ni+kIT73xfyuqyz/
tq0fcAT0umL+2BX2zVD1s+1dFV2rTtbftk+A6xdVb/jp0iO2OOUfNho0+POO
Xl/bmqr4Zm2J/ogHfwDPo0bMoz9SVX9a49C/ycAX0b9imOw/W3/Xxg27fuIk
XgKeL9drpUV32KvS/2OdDfty8byspPqTWK8/6tsc9q1H+wxD+3F7tId93B5F
8GfmL8er9cf3mN/m4Pm7BvgX1DcQ890B3vt3Vcu+qsvrDT2eL12Enivml4GY
jzO/DfNJ1f9nijMwn3QHP1bNV63lkf+4fB48tXoY+FtWnn8duKjWgyswPqxY
D3YB3yVRzvdtf2D+1a2+Wl/y/ORTrC+3Yv1yHuvfsii/m7ta/zLf6yW1/mW+
lGpvK/ONX5X9YWuH9dPNd6U/WX/B+mmJ8g/Mv6tQR+iVBn66Q+mFYb02DOtp
xm2wnub5WjzW04xXYT3N6eujvszPR315fhcu26vExvx+7B8MnHEuoet7njQc
7cc4AvsHsbL93KlI9t9jzUdCz7v6yzfr1fOlPKzfOu3+s2n8Qn/qKtO70jcD
enxX7VEg+LJU5UqpG4kJfuAr0RbZnt7gKxDXx13qu5r4KsTlK74S6fqq+a7O
n6bm1/QO9gt2yfm5j4n3Jhf0h+L9iOe3ivcl9h/FBxDPb1kvBpj1eP6s7PHS
6VkvDnqK96Ej8FeFPeh3YK7vUWCubyf4O9e3CsYL15efT2xfJQPvTezPXF9/
jPfXZH8Eoj2YD0D7l9Xtx/5v1lPYncoBs31VTfZ1NNlX2WSfihfHi9k+Xi9y
+1lUfivbF4H4qnh/6oL4p8r3M/GBFG/IX53uYX2o+GDi55XKH0R3wav9p0B6
KPFTa3+5vvTXvMLedNuQ3p9iUZ7ifXV9WI/tZT1+3ik+mHg9zXprDdib1gFz
fY3tGUjtDf4SQM3wfOb68vzg3JD4t786FqLnB4mSD8P+jLNQOIReBW4Pf2kH
XPQ8/PmE0O1V07ZfGVFOvCr5YOqC9ZLiQykT8+stsv3DqCrma5U+cG85qkUE
1QCvcJgpfaguX/Hh2l6FQ2kMsEofQjw/UvPNIHIGVulDqCfmS2o/KlSnZ71C
zEcVH0Zvy/Rugu2r/HL/nzN/89R6jH3l/DdQY7XfU502Y76r+GAqMOiH0HLM
t1dgfr8MeAHm9x6Yz1+W8+UwKoE/pmP94Ql+qKxvpPZXxUfQRjV+kT/CxEfS
XhVvrIqPpGT4ryo/grrBfxUfRZ3gv4qPpD6G/b0I+g7zC+5f3j9V/RNOvB+n
/CNc8+x/vB+q/DNU83OlP4fq/OnwZy7vc4xftqcCxhvzCvvSagP2pO8N+X2o
AfYH0xFfVht4Pz1e0zHeeLz+jPhSHuOR7eP4yvZxfGX7jHx1PE/uAQfQYQN2
PD/YPs6vyg/S+dm+5ogHbF9Z2Pcz4inv93XA+OX9PoX9iff77sj+D9bt2wHx
gP3hPcSDN+Evt2X6QHoLeIz0z+qIt/uLq2C88fojEOOjlQH7E68/VH4/4vVH
IMbbLswPFR+g45sq3594faSed76a5+cRr+deQ305PvHzaBv2Q/h5VAU8P893
GXh/Oob9B47P07FfUx7+d9TAB2h91vsFmOP9Q+zvqOeFJ/F+4F9y/82DhnTd
2HLQjXK0Sc7vqtJQ4BlyPVKJaiJ9Dzk/rKB5UWXEkGVflNO8t9vz9UcZzV/1
WPft9e+cadMHk//ImVCVtsj1gZPmk9MObX1z+CMb51e8C/H+4Sg5H7bPP4FT
ZPo7Nm/MT816Kv1N2zDgTl2XjNnjdMFmQ/kfQS8O89N/s2/YrqSkYdM9UN4j
W/UWs291fMOHTma53l86+b7NdsJpTUFSABWdDTn6dc4xjVdd3DryzL4fba93
6z4w4kkwbZTr+2s2D2lvIPkMKWp6PPus7dgXoVenZIXQGfn+7ADmy2E0sWae
5fq8W7ZR06t89vHtEOo99tSaLq0v2brNWzMo3ycY/D+2wFuRPq9sDCBf6DE+
B71iWZ/qNMmk19ekNzt6auqxv09qPqd273apy+9qe+pVD/YctM+JmJ9s0hsI
vUNHC4YO/yOMLCefB9zdVsbJvX447z7plDUieNDrfSiCjnZsMmJ878ua7yXX
20809l33ar9xdW9a308c/03fshHg71nZHtbbX/OzJ/0ahSN9icbjBj1fr5/X
6bfJ96GPNK7058ofa4c7CdZX/B1ryKjfTnZJi6QtZaq+Xm/iH7r8MdDb3W/T
x52vRZLTJdW/XB9f1Ld/5+Wi09dRFA/7ti35K7TFZAvdR38ES/+JpgUfXTvS
ftFU677KXar1fj+Slm2e7+J1+pB1qPS3cOqB+jKON7Uf6zH/EexjXA32He17
8enErmG0G/7HfDb8mfX+hj9z+8+APzPOnHzDY8WZM7p/ts1ZGJxYeq8tceSj
lyevCKX1fZ4H7B+s7G+9Md56739W1DoliELSvr3Z7elvVsZZ0NtfZ9a6/p39
iKDH/rvKpLce/cHlzYR9YxPWBM0bZvdXxAPm95nqm4P6cntcQH0t6wNPDXk5
gub7XT6dSqWI+2OXHP+uxP2p+DLE/ZkHPcZFqC/jxbDP87pH6doDYikf9v1U
+Gpa5qI46DtRxzmLOlt+jacpiFeMnbo8D7DzNN7Z5Oimn3Ze1vlD5f7BKVuF
cR97Ro9LoHNoP+aL0H495Ho05v9s3yG0H+vXRH1XnTxS229dIl1B+zlNK+Px
UeNk+hzt127f1ns+vZPoZ7TfmqLB2yMLE2kB2s/59bYtKnolk4Ae46vQ4/Rz
EF+YH4/4wvxsxL8q4RmfpHknUB3Eqw4y3ibSmen1/a71vaH52pJ/bOv2y7Uu
tS7FUSMZz1yI+YGBLo9a1qtIRt6VfMf+OLKpcyyFhT3f37KvYws+WvR6gAV8
JXpn9t4DzerHgK9Am2T8jwN21pj1uqTVP5fePh7YSWNVfjni9mb7uD25voyT
Ee8ZL8D4YPwN+pfbS6B/md8N/2P+rnz+lSUj76LtWYD+Zf+4JvvrqfaPuSb7
6qE/Dsv9lWQKdFPxivGn6N8laz4f+aRWCq1CvGJ8Av7H6WugvkPivY8/np9C
N+Avyz68vXWkawotgn3M74X/MX9f1q+Kia9ErL+X5xvAKn0FYnumyPlPNRPv
0LuP9jPqO/T+t/b9fmTf8gp9k1Geu+Yflf+zzYO2bnr8dJXzr2pkrH9lar54
YvrjRylUBH9+uCPqy/43Uum3Svd6+52qRtGBpSc9apsKvir9Kp+XaeDdadEl
8rp2Jo3y5HzOjRpUenX0m0fS6euqVcfnvlWNbifeu3/i5wyKkP5dRfMPI5rX
3XC8oub3R/d6/UTn8jS32cdvtd6YCb4q7fyqZ5MTUYzLaazSl6F3fy5Drfxr
0AIZ7x7aGDdqVenW08P3bMb0pbT+y5J/YivoH3N036oa9I/c7y6xMf9Vx/6t
xty+o/nkMl8sz5nxq8Zravq0uuV/0cq43ecTlhVVfqxxJfk++brVS+5XZoG/
a3378ephv7aoQb4znk+4j1vF10dm1b9cg8p+aTteHPBA45FyP7a0MOKKGhfI
/Vk3jdsdfm+Mk1dlwforLxcXDh/vrrFK7yG2/+FbtU3HTPDVBLc/63H//H5h
UWyH0h6a73XeK/gXq6fmS/091i1vsJfg/p8p95O9BfuPwv4mHKyxyh8gfunT
YOO1jzh/oBgg91tZ30/rq/K9TbyPzs/2sb6y302w/yrspTHX15jeQ/B4MOsp
7Guy38+U3ltENlnVaMC0VG0fj1+uL2PW4/HIejxeFQ7SeHjfba7Bm0I07inz
Bwt+fh2R9geI9e5hdVP3J4APFPx8Uryf2DLoq/QmxbHg/YW7XF/Eg/cRvd6a
/vfLA+OoFvxlh1ujta++FEsr4C8hxS4fdQ+MoUT5/quC5tvC/wbu9TnUo5MF
6d01VumriP0D939RlBGt9YanzNsypnEkynPTvFlP5S8rAsNed3nt4xhywXzc
yDtre/7NPu82w2c2So7XesUrdu6o+VoC+PKi0u1HXyfVTtL2GbGnCfuacKDG
PvJ9op/oKtdLicBBGleS+wchJhym8RZ5PiBU692Q76uCNd9Onm8IEFT37XoN
L8cDV9d4u3z/GmhKH6TrnyD330I0LpL7F6G6vV6Fnu5vdb5AY5U+TPQuld21
Xek42Buuy2c9fzk/Zz5M9MhsV/LS4gRdX+YVjjDhKFP+SNH/05Pnu06JBR8p
IlovKzNwqYVay/MWUeJQtYERH22JArZovEDub1pM6aPF7uW3Mrodifkveqq8
CDHUqfPhkYOjdX2NfLjW5/q+L/cPonX7GfkQnf/f9Lh+/6n92D7GrLftlPuu
NoPi0V8hInjCnllvNoijner8h+bbwz4ubyf8ZZ9cX8WADzLl99f5zXqp6jyH
Tv+ZbG8fUZQx6q1+QbHkqs5viAN/5dX48KYF2Ffjfuq8hk5/Uu6fuWt+mjqf
IeLH3yv78dZo8NXE8dqbI+cfj0R+NzHx2cTaK++FU7E6LynOL63juWFXGPKX
EaLl07O7Pg2l/Xj/O/fpuu+PvBNCg/H+l/lFeP/L/IOL6jz15cIrM3a2CqPP
8D40Z1z1gevzIigM55XH72vRZml4FGXhPHVyxKdjPm0aTbXxfvXUya5fLese
ifSPNDbrLamn3q8yn2nS809U75OPvHfmh0lDLGTxUO+TR6d/c2TezCiq5CPf
p9s4fxc5/zpjmzIndfuPI8JpMN4nM7/gHfU+mflNeJ+ceeO9e8u/jaD4vvK8
iY3bc72cn2+xzezilrb7dAhNk/ZdsTIOUucnrBNr/vTF6ntBFCX3G45YxfS4
wn2fBlAs9JgvNukdp+f7G9usXF4g9Bj3lu35QJe3bW9c3txhj3V5neTzraww
4ioaZ8n2LyfYHsVXEKeCZpRZ1b06+NJiRt8yX+6pGoTyH1qZV+U/sxrzO4sF
rluHX/3FhybK+YyLcBrablMFJ0/gShqzfY1iLgXfeMVb6zHP9V1zYM9rUV+5
6fpapuzIHLeqorYvBpjtm5q9dAA9LktT0R//nJmw5kF9Z92/W3xPnH8t9pGN
+7cEvCvOC3D6UPjzQ+Ap6jyheGTA5cVj4K7qfJTYBf0pGG9Tjw/4aeXfF2w/
qfPNJr6UmC33m2+BdxGVGob9EDPEiUIwPr5YaC26nVyGFO8kzq6r9mTt3kp0
To5fZ+F+/iblpbtTf5xn6DB1WGjoZE8SGG/L7AuTMhe9KQvjg3kX1HdTWZ/X
rVSNLuF8RF5J++wN58prvXxg1jvU+P2HI2dXIQG9deif2Ri/jKuj/Vq/lh7i
2t+L+kLv/oV5Zy7V8qM86BXAfxR/07oI/rND6t2zOsMf/oZ9rD8B/cv6/vAX
5t+Bv8TDPzZjfDD/5+Ln640buj77Md64/mtk+5zU7TNiTpui9GcXNe8pz6fc
0vx4ab+TYLzm1OkrY1NKC2P6f6yL0Z/DoZcLnmAfp++I8cHt3wvjg+31RX3z
DPwDK/tjsjqPZZ2O8XAc8YX9Nzj7+X7AddsO+GOR3H84Z2N/myLXuw9sFeGP
feX62ZkWGfhntm3Inyfj60PbOPg7600AZr3+nw54vVu7ezaB+DcA+CLs4/G2
Hv3B6ZegP5j/6vNVQwZ8fFiX3/FNtf/H5T9MVfunR09nd/4wcrd1k2zfu9Zf
gV9HvNoB3APt9/vWl9t8NOGoLQHttw/8QfjLROiz3l7wbN8h5H8f/cv1qwZ/
Yftvwz62vzr2d7l9t48Y8234jqvWMxjv67Dfznx57N8zr9YDLjo+8Pye+5Pn
90beWTTseCf3mq8r+DKC+5vXCxyPRsj2qarj1RGsL418RXHxYvmrm6c9sPF6
5hKwWc9sH69nuPw1pvoOx35dNvy9G/bvOV47XVb7YVPg77NPqPcL+zFequB9
APPr8D5lQf1Vp//Z/NT2zbI7VUrF3tZ8KexHcP5XW10Icm55zpqF8tOHbLl/
OH+H7VfwXVp9Nsi16War6+ovbeH+HtRY+ufftmLEg6atUrY9avO7rT3ir1PH
5/66wsEPSVx2JmO/1m8q9/9PW/n51BH7Lx/DPqeM5xPOb63zYX/bzReXVbH7
5fn373233dOFOsr97eO2Rnvqt3O5XWJbgf2c/OJa13fHl6JVe5tWnVXquu3h
y6cPVAm7A/6RzfIooNWCcY9tw+Xz0YXiWi6/MrvEmZbFji56drkCbVm2a8Ub
K8oBO9NW4EPYv2pX6vzbsR0r0VPsX3H6p9i/MqYvQyPl+1knWoL9q1HAKn1p
OjpkzS/Lfrxve/zS4okDf3xg+wPYgv3iFgvvzExdfNnWHPvFnH4w9uuagT+I
/bpdAf+8VLPlr7aa2K/7B/Vfiv26PLSP4j2oPtpP8e40tdbLCx/2P2vzlO9r
3Uy8J+Uiv+I96D70Ldj/e2Aoz52i0N6qPC+KRXuzfdz+bF/P7oN7t59RgViv
te2rh1V93dBeFen+S1U33vrbU7cfYwv225fNH96+8kR3rdfhzq1HltRqxO3H
2IL9+6dD1POX9ebj+cx6l79vdnp/tL/u3/GYX7J9V/pHjNgTHaL1GLNe7k9t
OxdXCYM/lDLx5Wjq7p6rN7YM1f5yuuqC6d/khmv/Y175qz0OVXh30Zw/g8lJ
zu9v2hi3w/jg9KVeVfudNUK+P/Pth2HkvG543dG7TmvcG+NtzJsXti7oFkGU
rsYb86+a9LpivHF58R3P7htSRLYzw8qe+qFyAN2LrjfRPiWwMn44PbzuzZtP
NP5KPi9uWmceGjTs4Pe+VB/xgPnm2D81pi+xFsjzGD70JfZjub9Zj/3joHxe
OQkjdtX48c9u4UUlFQTnj5LPq8qab7rtxM20y1VFL/a/M++U+N3zEG8DT5fz
n2rCheakRNavCuwpygCr9F5iUY+MV+/28QDvLq57bdtwdI8Xyq8icjY3D9wY
6UsHYB/zS36t06q4rLOJdxFzMy+/8mcbT+BKGv+b3uhepwcvHOav63v+dNFP
tu+8dX3rtqlWcuKsO/iy4uHyD2f9M64a+PJiTUHqsqSi8uCdReBVz0tdt7nQ
YvQHx68S9O9Yp5frrr1007YY/bFu5ZhddZs9tB1Af/wA3BT9a0xfYh3bceXu
s2EbbAvQv++U3TNkWNp52xfQ+8Gktx7YbJ+yv4zm/82+Ti+/VO1j15M2Af8b
A95s383pav+e69MRz7e+CW9E9jpeilbIeH7btga8U4Pn8fuZrY+Bf2jrlBxS
q9mHd21t8b5ivE/JCUv0YdsRxIOwrn36/dDpGvgntv3XEp90377AumqZ75kn
y6/YVgK7YvweK/T5vssHN6xs31Fgbr9eexM6Z997auX6Dnz0VmZH73LigWyP
e5pvIOdjD3X+z8ZuOP3WoWfW4SivaPPW3906OwsL7Jsn+QfWabD/hpy/PbZ2
Qf1U+rLiTeB50Jtxot3WMxef2FgvBnqLNi3ddONPF9ER5d2E3hg5/zqt9cYB
s94dOV+4basv7b+t00fI/i+l00fAnycAN5bj2z5/O1D42si2f6B+VcRE8M3+
avnXg7erifPgz8v1mZuYBP6D4zk7Dp93F3XlfLLEVk3O5zw1r7Cv+NiAA8VU
4C//CFn5/etB4jj0c+T8MFhkyu/P7lkVHyC6on8Uri7eBGY9Y/ogcRR6ivcX
e9Cfyl5v4dVkx5+Fkf+gPh7iF/BcX28D7yb2yO/nXATXt2Lzjx5YdlcUrFcB
mOv7ZVpczfur3YSyx0/zqn7+mv/1SNkZU48GaL6LnC8Haf6fg1fff7dZsKiz
abrT0eFeYrKcb1c38YHi+2rZG8JXVxGPuw/c+IMlRKwG7gw99f1eebFa7teH
CH9gVX6QGNn5ada0BmVQfnUxel67bp+99sjK9v25uMGAWZ2cYb+v6Ifxo3Cg
6AvM9TWm99flc/8ay68uVr410Fr1l2ravpdvnyx1a64ncJgJR2jcrWfp3fWv
holS9ZourFTLXQTL9w2hmlc43IQjNT7Ua8qRP74NN+WPEFuKft3Y6nwl4Cix
GViVFyU+RHuxnvoe0wl8pGh5o/r5ivdvWVlvFNpTlRcmWoMf//x4k1uoaDJq
9867gaeB7fYCs31d5Xz2mE3hSNEDmO075v76t9NP3QO2iD+BVfoo0UbOVy/a
lH6kTq9wtE4v3gk626NfpKggn9/PwEeJOnK+YZ+/Q8/IO/RU/nDhCv6+3K8K
FUcNfJhYIeejzsT1NfKhoqxBP0yMls/Xm+BDRDvU/4ocn0Fil/x+dbu1tRy/
/qI1+M1yP8ZHjEJ+xftivvIMvJeYI+cPLqR4b7FaPu//gb6PifcUzsjPeqWB
VXo/U3neornBXh9xCPUdLuOHr+a9EK+YVzhYHAZehvjX2pA+UOxH/Zch/rWD
f7FeG/gT67UCZr1lvca8XWrHAyvrPZDnZa9a2b7lBt5ffLJnRu62oaXFMsRn
zs96S4EPS38JFUsMOFx8bcCR4ivg6vDnRgb/jxDV3ng+H1puY39pbBofXQzj
IcI0fv7reOP4NkzWL1jHq8uyfwJ0fFN8oH7+eKL99uJ5oXh/cRLPm8vo330G
3lecuqqe54r30s/DVtI/3IXTtRd5D/Er8rfC8+icQd9NTEZ+1ptiwH5imkHf
W5RgfkDS3z1ElNwffQTeU7SQ+6llSPFuYoPcn3AC9hLFBuwnNhpwEPY/nUjp
BYunARfPOrd3JWVPdRMfKFqhvMsYv5/I9w2VwfsL9X6jGvR9xBm5/vOgOKw/
Ejck3p32iZe2b3LyjpTvdrpp+xjHYf1x7M+W0z4J9cR5C3fN8/kNxur8gYcY
JddzVXBeoZq4Kte7FcC7afuOYv3B9jnvVusPzs96HwHPxPqI4ynbx7y5vgoH
mHB1U3sEmNojCO8z/cD7iRFzXVtPKe8DHKQxn1fh9Hx+wx/nS/k8SFecf+bz
JcyPwv4f52+H/UTWV3w5ESa/z/Onb+R6roKJLy3U+zZP8GWFer/nS65yP+6Z
1ZjfWed3xX4d5/83Pe4v1psBf2O9lvDHo1hfMt8e55s4vxvONxn5u3g/6k6r
sH5j/kesPx5jPJzqoPb/umzfHZazpDR9gvXMbKwH5mN91Bl8HvYTOb0F6636
mG//J71ra9X6KAXriyicv0oD3gD7CPGJoBf3Uv3F7/151uqJ+sYAr8J+J6df
h/3Tz4DH43w2p9+B8/KcPgj7sZzeE+cdOT2NVOe9PTH/Hgs9i0lv228dWjZu
dcdaF+cn2V5fk95cnJ/k8q/jPCan/xTnMZdh/cbnMWPBN8b50/3IX4Tzp/Hg
+TzhDtizCOd3twPz+cm78nn6GHx5urjk+pzvKlzReszfhH13gE/hfOdt4Cyc
7/zxUFDvtIdlxBTsj68HJpxnDR3q9G2PuqXEfpwX3QJ7duD9wmbgm73V+edI
1Kcq3leEA4/F+61Q4NV4v7UJ7VUN77fy4E9d5PrxqTUZ7XVcxvdSYgueZwqX
FwTMetXQ36y3FXwR3qfsxfPvFN73bAf/O8577wefhPPe6VgPLsL7mTTgFXh/
1AnPc6euSm8b9PbjfQ/b2w3v39jeDnh/1BH5x+J9d2/MF8biffe7wNvk+1t3
8Q7wK/J8iYdoj/wK+4hXga/L+bKveNuQ3kscwfyE9YZi/qKwtxhiwP5isAEH
iw+Ak3BepRHmQ3NxXiUX86UyOK8S0knNtxTvJU5gPqiwfX0HzHrXLl2/e/+T
JygvUBwz8H5iHuZ3bF8WynsF57mmYP6meF/RHvNZld9LTATPepye7ZuG+bbi
fURTg/0eIgflmfUU76bzs950YNUe9vkC0p+S/VNFdIR9vdV9LKKNAfuIxsBl
cN6nF9Zf3H6NDLy3mGGwx0dkwF6FA0SaAVcXKcAvq+9pRRLwbPl9aJiYhfZu
rL53FWexPlV8qAgPW/14Yqqr+BR6G7C+VXyI+ADr2zPqPh0x0OA/1cVB+CPb
1xP+yvb1AJ4FvZbw7znqe1sRhfGYCL3ZGL+zYN8M4NPq+1uxDvNZhSPEeuB4
9b2tmIz0CkeJ8cDK/kixGONX1S9cOCPenIGeC+Ib65UgvrHeY2DW2zLvdmzQ
oP1IHylWIZ6y3inEa4WjxF/ArPct4vVA6S/R4oYcP5UF6xWGlP3zrwg38FGi
blxuyuOVFQTbx/lZ7xsDtoiVwKr8aOGN54Hio0Xr6b+lJZ5xBY4RrYBVeovY
hP0u1nvc+MX2ihafGtozUgw2tHeU2GLonyjxPniubzD6n+R5Pov4Ff5UQY4H
i4mPFn+d7b0xvtFF4BhxAliljxETtz1//77LxnrDMd5Y73GkGm8t5fnHGGFF
/Jsv/TFGlBh4e/0xHhWOFVuAVfpYEYzxdrFfM69vP4wT28ArnCB2GXCS2GvI
nyAWIb4onCS+AFblJYoD2H9YlnOj2oKwZHEQWNUnUSxGelXfBHEA+opPEHex
X6BwkrgHrNInigloH9Uf8WIV2k/hRPGjoT2TxG9ob8UnCF9D/ySKjob+jRdr
THobTXr7oddxQ8asbqOSxT4DThF7gcs8/175YIrYj/ySd0kRU2H/huffC2ck
iweoH+udRHuw3hlg1ivh/RTZvqmaVzhNnAdu8jx+9kkTD5H+7o9Lxv9OaWIj
9q8kfytVNMB6mvX8z6r1tiyvRYo4jPEg+UUpogfm7yp/ihiA+TvrDQRmvWLM
51lvIt4nKJwqJgEr/VQxGu9bWI/TK5xmTG+v7wa8X1I43b6+V1jVP12cxPsc
hTPEX8CqPTJEMt43Kf10sRPvy1ivw5wmPUviqgBniNeBlf2O9Kq/0kQS9GT/
rk0VO17kXdJ0/VT/p4rj/D5K5k8Viciv+tvEu6SKjwz5U0TgqKHn06eUJfaX
9S+290ETb/e/UYb8ySLAkD9ZrDPkN/EuyWL1sU+/flJYEfVPFn3R3zw+ygeq
9SKPtz4GPlF8h/w83vygr+JtrPgQ9ql4HCMOoP4c779E/6r8sSbeHj8N+aOF
j0E/WnyD+qn8FhNvfx4Z7IsWD+T39G7E8dnIRwlvQ/4IMdRQfrjYa7AvXESh
f89gfrAR/sHzl0gDHyp2G/KHik8M9Q/TPOE8OucfiPPoxdBXOFyXx3rG8kLE
JLwPjsd59Ll4f7oV8/FdKK8tzqNPNdgTIo5jftEG59FPYv5xFd9DFGH8tsH8
mfNvwfx5yhvq/bHi/cQvWG9uwXrhFPQT5PzLQxyDvuI9hTvmQ6xXDZj1XDF/
Uvb4a/5Dub8aqHlvfP+xDfOJ5fL9TbBwwfsuxQeIxi2bHS+pWU2o/L6ijIH3
E9uRX/He4jXMVxTvI4Iwv1G8p1iL+Y+yr5oINvDuohjztaNyPVpZBMD+b+R6
tJw4dUWtX49ivVqA9a2z3P+tJPaDj8f3PYXgl+P7mUUYH/H4Hqcbxq8zzus9
w37QKnxvPxP7Rc44D9ca+1GrcB7uGvYfXXD+byWeP2/w9/t4/rjgPoBWeD62
4fsAwJfF/gu/f/kG5+H4/csy7Ocw3xb7L4XYryzB/suxhhtOzr9TkdriPNwk
7J8+wffEI7Cf2RzfE1+G/U9xnmsZ9GNwnqsW9FvgPNJS8LE4P3QJ+Z0i1fkh
I1+BBPIr3v4f72NicR5pP9cP569qoX2sOH81dquaX1hx/moq8CF5fsxTp+8u
z8P60q/Qeyq/Nw0gK/jp8nvUYNpn4IPoa9irsB8tAVbpA8kK+1nvqU3Zr8rz
17zC3rq+bN9wtDfbd5HbG3pN4U9s3wXwCvvr9JZym2se/i3IlD6QpsA/FV+d
SuC/J+V9KKHUEf49Y2THzy9fDKEFiO8NXL6O/L5BCN1E/H8m7alu4kOpRsqP
3XY8qEpOH11b/sGKEMoL335/288e5FRBtR9js54qL1Tzyp5wGiu/R/Emy4iD
016JjKRD2E9WfAT1d2n4/rsNA8FHEX37x7EWXwaDj6TkoIX75maHQj9C8wqH
mdJH0Gjcr6BwmMZKP4Licd+CwmEac/sNxv0L3H5G/n+v11feVxOu0yscqnHx
8+3gN8K1/YoP0/VlveGdDn87ISRc6x2rNHnYnDuhWo/xOWlfdY2Vfiil/1C3
ydc7QqisvE/Hkb/p8+24+RFaX90vFUVRuF9C8ZE08EnTze+kRyF/JO3AfQKs
x5j1Qq7l9337OqePoP3y/ptIrRfbfEvH8ce4vGga9fj95Nkrw4AjNVb3X0Xp
9Op+LIuJj9b1Y71dZyOO97IFaT3GbB+nVzjM1D5hOj23n+WVYr8Jt/yoSLZ3
sMYqfSgdX5nw41ezfLSekQ/T/q9wiMaD/kWPx4MqP0SPl7PoXyMfqv2H+8Po
X2HUC/eXsB5j1jOm/3c9ts+YPoSO4H4S1T6BGnN92Z+5vuxvZ2T5QZpX2M+U
PpDG73xl/pJKIcC+Gqv0PtqfX5bxyNvEO/QU76vLXy/vi/LR/hku46mX9t/J
Mt56mngf7Y8Ke2hcVz6vqmocKM8fV9b2qfRu2t9U+V4m3kPbz/YZ7ffX7cv1
NWJ3jVX9vUzt6av5Srh/jePdQty/ZuSDdX8r/3bEQzW+wugA7tdRfCiF4X4e
xYfTLtw/xPfXMVbjN8yUPoz64v4ahUM05vvcjNhXY74fjvUq4P4w5gfg/jDm
Fa6mMeH+MK6P4t11fVmPeYXdNf4c958a03vSetwHxHq+eF/Lel3wPpfv12Oe
67sX73P5/jojH0xF8ntfH33/31G8X+f79ZgfgPs2Of8pjA8jH0jxeH89AP7C
mPVO4X0339c3A+9juX95fsL+chHvY83xj/2PMfsfzx/Y/4zxNUTHS/YXjofK
n8I1r54XkTq/4iO0PvsfY9Yzpg83lRduep6EmfgIU/5Izf9f7TPrqfLCNc/x
mXnz84jjM6fneM98Yxkvgmlw1swPxr4ZAOyv8Y9yPPiZ0tvnn86ft92S76X1
auO8NuvVx36Syh9ErthPiJbzmRDqjf0ExVenVVi/Kz6UfLF+Zz0/YDXfCdHp
LdArwflwng+1xfcvPB96xYAD9Pcx5/D8eBW4CeJpAMo7h/GxGuW9h/Hhb+Ad
ek3Qfsz/hPbj89c/Id6v5f07PI9GYz9CYU/i894qvQcV4fw529cL+wtsXzfw
bN/i9lbvSYdPWsthvLWV++O3rM0Rn78C7wp/WVoqtcnlq/etm+Avnt49VmS5
lxaumL+skO+vyonm8L/aWxcn7n6vkpiH+dVKAx9Bb7dZdzE/1gnYPv8ANutt
wnyD+cGYH/QEvoD5QWu2H/7HfHO0Xw/gjXheLoO+Bc/zyx+2vb3tjarAbnQJ
eDruR5ohz895iMe4z+iigXcncfWnP3ZUcNd6l0x6F/9Fz4Ln+amB4fOWHPXS
esNLTeww/is/EYX5AWPW27vC3/aOU6BoKucTFU24tMbv4z5Lzv8+vg9lvFiW
56rT78PzjfnBeB4xXyLbu7IpfUXqJe8zro701aj9Ldc+/p6hSF9eY5W+HK3I
zG9e8VEYynfRPNvH/AJ8v/r4gz5pj09HiJfx/SrzXN/mE0eNeBIdgfYqRc7y
fDDz5WjJvFm/PX07HPpVqLE8TxwB/3DXvPIPNyo5vWf1jZaRyF+V6kc7zTiV
G637Y3av9AG/hcXAHyponvt30W/rO1+vEqX9he3j/mX7n+L+K65/d9x/ZeQ9
dH7Fu2v9Azivwpj1uL2mY37aOiq2dIW14Vrvq54dzj38NFLr3Zf3U0eD96J5
ZY/dO/GtResxZr2C9qFR+4/HaL1pC1uV27w1TteXMdc368G8Gt/fjNd6Y/N+
8138e6LWO3N+3MXvliVovdT4TT8vmpoE3psmHhk4Z1WXRK3HmMfb+eFJ3TfV
SED/+Wme44GRD6DMHZ0bfBucpOMB4+aIz1N6B/pvvJWg48tl/8OXdm+LFxz/
mB+MeGpMH0Ai7mLW3grxwD4aD8b8iu1xw/yF7W2B+Qvz8zHf4PwXMT+Ye3iB
67ETseDDqcGUXtGX7ltES8RT5isgnhr5cFqcE/ng/s/RyB9p4iNM+SN0/Vti
fc71rYD1/qm1TR+tPJoEPopyOpbfs2F5IvQtmlf2x9DWMnu99o9IFqlyfhNn
4mNp9pCCd379i/l46mnpOrr+wBTwceTR0OkBdU/VeoxZTyw4frLewZT/qDdY
3secaOITtD2KT9L2nn2u1y5Z8zvkfDvRlD5Rtw/rGfsv3sQnav9TfIKpfZK0
/r/Zx+3NetsPBLdu/VKyqLmpyarxFZPpXJP7H/z0ZpLWm1Fhy9yfhyYofkIy
XV/zfo/fm8VrPcasp37fKVbrlfg9a3s3P0brLTm0e1DpNtFar3Gs+5J7Iy1o
rxQjXzFF55f8sRStPza/fOyWpamaV9iRPkGWl6rTHyje8sU/9dKo9vZJPx6d
Faf4klS6O+yVoxdWxWg99neVP037u8qfrnnWM+JUE07RWP5cjk+q1gvMGxyU
cj7VyM9y2CP5rml6fKn8aXp8qfyO+qj8abq/WI8x22dI/4Ke5HemGsuz6xnt
Sdf9tVm+H83Q/aVwusZsX9uPZ8507x2p+LXptDq7SdeQwgjRVb5PzaBK58pl
JnqHa732MXk+1Z9EIH86rXind0nVc1HIn0HNt/1gcXazaD3GbN+i8lfL33ng
aD/GbF/919Ny/o6IU+W7ZGj/VThdY6WfRjUfftNwV1ai1mOe24957l8jTtFY
ta9j/Cj/Sjb5Z4rJP5ON/bczxVi+vX+5Pub6sn23G4dcOXsyTvdHo3+O/nTr
O0f/Pv5+8R9Oeyxaj/H/tv2Yryjfh2cYeXv/8niUfItMXV+FMzQ29wf3L/Pc
vwbe7i/cPmwfY/P4MOtx/xrKH5Wu7VU4TWOln2Zs7/OO+PNv/WG099/b7z/5
M9fX0D//zfhQv/cWifwZtO7g3fPx+8PhDxnUdTKVybsUCn9KJ++XJkY0dA4B
TtOY458hvT3+8Xg16ymcrjHbx+m5Pwzjfa0pfVeHPdx+jLn9Tsn5X5Buvxm5
j8b80jRAj18jTtNYlWePr3L+6gOcorEqL4Vayvmvhx6/3eR6paoevxacr+Tx
a+Dt49cJ3xvy+CWcv+TxG2PIn0KXcH5TPz9wvlPlT6H6OI/G8bkpvpfi8dtX
nhc4Z+P2S36Rt/fHeJwn4/5Yj/NmKn869THkz6AQQ/4Muobzvip/BvH3XCp/
BjV60b56Dp795UtDfdJoGr4vY/+7j/PFrDf9Rd6ud/DUmzTGvyL6I5N6Gvoj
g1qhv1R7ZtA99KfKn0m15PrDD/2RQQvl+scbz/sM4u9DFU7XmPX4e1LJx9jb
Y3C9bQe6+QKna6z000366cby7XqT5O/rBP4Xvf9kn5ofmfiYTF1/1jO0xwt6
qr0c6VV716DyH3y6KPJVN7RXDTqA9lb5M438zho6v1nv3/qjB/qL7Yt90f9L
HP3N9f3qRX8pyqQb8D+u7wP4C9u3C79/yvaVvMgX1cDvrV7VeteBub6G8ux6
7M/KnkzNs31fmuy7ZtDPoCsGe+3+CHvU/DWdcuTvMZXV9TW0t10vFzzrGdLb
9e6a9C6+WJ5dz1uedzloZX/ZjvZR8+kM8gQ/5/l6qzidBmL8K5xGRcBqfp5O
UxAPJJ+XThMRT1ivL85Tsl5dtB/r1Qa+W3NmZou37fMJtF+T5+u/4DSaiv6X
/LU0HR9Zj7/PVvZk0Ap8T67ql0kl7mUW3Ili/69BtfE9PfsLY+5fTs/+x5j9
mfW5Pxph/LO/zP7s7U6H73ojHmXRufqPt/zY2E+Pj1EHu3z0aWAQxlcWZVmO
RPywxR/5s+jo6poXZk8JRvk1qHj+wZb5SaHwhxr6+ajq5+BVe5v4YzX081Ph
TBN2PJ+5/Xg+wO3H821uP+dhI+u5xUZpPZ6PsH0832D7eD7C9vH8UvVfJs2r
WXnemdnxwBkaK3syqWBGy72HtidoPeaVPVl0/+L2njd7xun6qt+3TdD2MWb7
ro6sNeTgsMT/osf2Gfj/g57yhyya9sfYldtXJAmOL4y5fw3pS0z1+W/sm38u
J6lTWrKu78x+iYkHspP+i32qvWpontuPsRqfmdSv/Xdj3piSrOsrOgf8tf+O
Q8/A2/UChjUs+WNkCuzJovqHok91vMb5s+jm/c1N/zgF/lgWBTWan9WxQQrq
k6151R45mlc4W2PVPjnUYOH7IRe+TwbO1liNJ0d+hbNNOMuoZx9vA2Jcdl1o
nazHW+0n9PqJ4UmYz2XT/K/fS7rSIlHrNe5Up/HDXrzezaKngW5vlx8dq/UY
c/+q32+26PHBPPuLgbf3b8uEiOIKe2O0vzwc0fPq45JY3b/L8mtUrOQeo/uj
XYlzbEBcNPJnkVPjBu0qt7Xo9jPwMdmm/Fmm/Nm0ZtGGfyxPI3V/GPPnmPKb
9JfmmMrPpa++mDr+2agY9FeeHt/Kv3P1+Fftl6fXKyp/nl5/qvz5Ov9/0lM4
R2O2j9Mrf80xxYtcYzw5lqPLV/lzafbitwKOVOR4k6vXY8rfHbzCORqr+JVt
TD8hR9dXjT9HeazH9rKeMT5mG+OnXa91h9eWVpkfre1b5er9XmCfKK3Xcevp
WXHjI7SeEWdrzP3L60FuP2P8zjHF/1wd/7k/eD+H+4Mx6xn337JN+285+vmh
+jtX8xwPDOtnn1zj+vd8rml9m2da3+aZ1rd5pvVtrml9m2PC2SacpbGKJ9n6
+cvxyvj8djzfOd4bnvd2vasvzu/t8cA4n8g2zSdyTPOJbD2fYD0jrmHCmRrz
/MWgZ5+/JN8dHz5/SYCeD03pHvZG8TEfwfNd5nl+sH/onb+HDayu4x/r8/yK
Mc833L89/0XNASFaj9uL9bh9WM/QPi+0H8dTY37TfMkeTzvd9f8oqX2Y7g9D
f9nbj3luP0N6e3/wfiT3B8+vzHocn432OPh/s4/9ietr2F+x15f3M7i+wrBe
zKKJWC+yfQbebh/n5/ryfgc/P9Ll+4LqerxR1nuHXyoO0ePNOF5yjONpVq6O
Dwo74gXr8fhU9mSb4neWKX5nmeJ3lmn+aOLtzzd+/vDzkjHPX3h+yPMhI87Q
WMXnDGP+ipn6ecfzU463ar2SoXm1XjHx1zJ0vFY4XWPW4/qxHreXwo79O7aP
4x/bZ4jX9vmGMZ7XMMZ7u/9VG7pyXc4XYXq8MWb/6yHfZ4Xq8cuYxy/7C7ef
gf8f9Ng+zm/W4/WqEadpzPslF+X7iECUl0715fsSX7RHOi0p4/JmuRgvrad+
X9ld8Hr18bkTO1w+8xa8XmWe15dFn/uNGuFcRa8vT8v4WF73x0J5/1op9Hc6
bcH6ednz6wN+TSNXrJ8lPz+dVsvv/36zKZxG64BZL0t+n3HFxnpZ8vvwtVov
G3yZ569Hh6dR8ot8k3SKlN9j/g2cRuHArLcZ9rH/Rb7I2+1bZ7LvJ5N9OSif
1+d5wNx+jeT3CA/0ep9/L5Xbj38vlf3FE79Hyv4yGDz7yzl53q80sb9EyPtf
KhCPXwNv9+fZ8vzfExvrzQHW/ie/T7hjY71lqB/rxaI92D4LMOttQ/uxXhx4
js+90R/8vOwAzM+3dLQXrxe4fH7+fgPMz19DerveXNSHn+dcf9bj9mG9SAPO
oCgDTqdoYN4//ViehyxLvD/5qzxvWJl4vI2V59/dicebZczZ2+994E083pjn
/Zz9yM/jLV2eB3Yj9hfLi/1p95cpKJ/jAdvH45fT8/7VlBfttdfXWJ8a+vdp
uf3492m5/dJgD7df1Iv69v49/2L72vuX/ZfnB3+DZz1Oz+vLeegvXl9yevV+
Ikf7u5q/ZlMexovCWXr8qPlsNn5fugyp90051FP+XmV5Uu/H7PNx+XvSVYBz
qDSwer+RQ2FrK+ztVsZD8Qdz6Ij8vb1qWm+g/H0xT22fgXfJ1eNV2ZNDsfg9
YJU/l4rR3qy3EZjt4/Sr5Pe/eTq9wrnG9Hb7uL0lv8hRfiv5/XGebr//rd5Q
9D/bV2yyj8cPtx+PH9Yz6pvqdzBb26v0s031N7WXvT+4Pv+pP/6t/Qz8Qfv6
Rf7eni/aK4/U7+96IX+eKX++qT55pvrkmuqTq/2R7av5on/a/WWoyZ95/LG/
8PhS4yFHjz8eH4x5/yXqxfFsH2/nTePtgin+Ncbzh/fX2D7Wa/Qi/4Iez5+N
4z9L28PzySjD88cRP1Q8q0EH5fj0IvV8zaR+qX1bdDjsi3hYg6JfjJcTsuhP
nJdX8TTbyNvX52MM8TTLlD9b6/P6nH9Pm9f7/PvbvH/A8Y/3D4z252j7ef/A
WH6OLl89/3Nop/y9NH9S8wsTfy3HVP9cbZ/Kn6vtU/lN/LVcqih/LzUI+fOM
9ZuQb6p/Tc2r/rPq/Cp+W6lNevCAimerU/cOp3973Flofqasv0A89aN46Q9W
E66p8RipX5P2YHydkf6Rb+SX1qQflq5dHeMVqHi7fVz+GJN98bCP7Wf7uH55
z+u7R+j2rRq8abJvWi3tP1J/bi3NS+xfy5j+jtD9ZdaT5X0hdH9LvmIt7Q8y
f79aur9Yz4D7ObDM31AY6xNu4ic42tvcH2wftxfrGfrPrjf49a2fDjwaqvu3
ral/D7x75PKg4FDdvy7yeRis+5cx9wen5/4o2h4U0KNhGHBNE8434TyNf5Px
JZ+CA95s2L4oHDhP43jsd77TcU78y69HKr5ePnmuO9XeOjFK623rveKDxl9G
wJ/yqH9c0dzXNoUB52rMevsOJ/foOTVU61mGX8p+r0sIDZTxr6auL9vXZfef
TeMX+it+Vk3yxfMjQMZjq+ZPSX8Smv/+xNyG6SME7YX/j35uzyUHL3F3B37l
+XWBvznSS9zMgaX96wUNR3x61r7l9p4htYx8iaBe8BeznixvqaB4PN/+zT7W
Z/sYV5LPO6vGb8nnm5VC4K9b5PPNSgR/DpLPt5qaVzjfhPM0LpLtm6fzF2G/
hPFB7Hca0vvk6foWYf+FcRD2O9cjvrAe+38Q9jvZn5X9+Ubebh+PH8mvzcf8
IwT586kSxqPKX9NU/3xT/fJ1+x2E/zGfCH9mfhz8mTA/GAd/3gycCH+OwfM2
Ee8XYg04h+IMOJvigcfh/Ucmnm+J2G8agfITsd80wmBPFm0zlJ9NifCnRMwP
jLiGCWeacIbGB3G+5H3M1xLxPtkf4yMR6y3GB3E+Yh/8V7VvpraX9cIM/lKD
jiBeH8T+7kA8P9g+bznfDET7mHj7+igWz4ODmF+dxPOF6zsU3+sdxPwqFd/n
FWF+dR7f5wVh/jcX3+dtwfxvHr7PC8L87zq+zyvCfjbzB7E/yTz3h4Gvl6P1
eXwY8+dQe9xfwHqvGXAWdQAuwv79DtxPXIT1207gIMxPO+C+Jq7vRtznxPWt
jPueuL4bwG/B+s2Q/n/QK8L7S5sB16DNhvJqUFVDefb5Lu73UPpZNAT3UShc
g4YBq/GcRddxPwXr/YTzGUU47xOG8xisJ3BfGuvx/WlsH9+fVoTzVzeA2Z/z
kZ7Hx0XwidiP+OvF9PUyaDfs4fFxG/Ym4nzYHeCDOB82BvVjvdpoj3E4f9UJ
/a1wGnUGZr096G8VD9KoIu5fGofz3pWAE3HesT/uu2C9NbjPgvUa4j6L/6te
Is6j831gB3F+nNMX4bzeFwZ/T6PbL46nWenUCOUH4bwe2xeE839rgVnPUJ5d
j/mDOE+47sX0s9IoGN9Xsh7fx8V6fN8Y66X6qvuFuL7n66v7drj9buN+QfU9
aiqde5G3t1/vi+q+He7fIxgPrHcU+CDOE3L6IpxPPGIYPxk0BXwQzju+bcBp
1MCAUyn6Rb1ZqfQh7j88iPOY1cAfxPnOaxdeLD+VThrGcwqdetHencnU+8V4
MCuFfoU/sl4wxnsizovexX14qn2SNe8u1/tJVN2AEygEeJeMF/Hksl3lHyrt
iadNuG9P8Qk0CuNR8Qn0OcaX+v47nppifF3G9zMLDXwCPcP4vIzvUwj33SyQ
8/F4clqj7pu5jO9TumE8qvxJtB/1t+L7D26fc/j+40Pct2TF9x+n0N7y++Xi
ZBqC/rkn15vJtP9FPs/R/gon0xm+P1/ak0R9UJ6yN8k+v1fjg/WqYjyy3qAX
+WvJ9vm9yq++n07W/HK5P2/ig1NoCOqjcDINA24t8yeRE/yL9f7C+FD2pFAI
eLbvyYUX0tv1hpv0CPdTsd4UjFe2byzGs0qfSOOAWe8MvidmvRR8f8x6c3D/
Gev9gd//4/r2xvfLkv81mfj+wH/T24Xvobm+nF61fyrNRnncH3MMOJnmAiv/
SqRPga34/qjsUPX7gUPxvVU5YDUeknR6Hh/zDDiOPgNW+ePoJ3xPrcqLpSWd
1ffSl/F92Xjcx6b8K4a24X7YBbhPZiuwSm+hGbivbAG+f2uK+9tYbwz0VHlx
1A/fV/P4bYbvldm+psBs3xR8v8x6zF/GfTdNDOlj6MLKg0vLnnQBjqbzwJdx
f04UvtdegPt90vA9c2t878d8JXzvx/m3yO8hIzRfhPuHOH+i/P4+nA7i+2bF
R1B1eR7UF3wEDZv1Us7yLp7gI2lPwdG5H2/yhn40+Vzv+qifrx/4KBok7zv2
Am+huPXvHl150x18tM6v9KOp5y/itT4T/YX6Hj6KKrZdWr1Fu2AxV97fFEmt
8P2twuEmHKrxOdxX1QHfOyfivir3iXdDevUPAh9Br0z45lbUwhDgMI1Zj9M3
xX1azJfFfVpL95854DM2TBTL71NDNF8kv9cN1LhyBXU/17NT90L99oWKZia9
T3H/FfOqvDBqgu+Bub738L3wOdynZeQj6HN8L6zyR9ANfC/MeoxZ76VXG37y
T6soXV/GXN85C4YNvJxnAR9Gdxpk1S2p6tArxPd0rPcZvqdj+5jn/jXyUfTy
vZteZc9GgrfQ158v/dtjHdcvmtrI98dhWo8x6z35tjjd63E4/Mli4i1UzqtW
eOrFEK33jnz/HKz1GHP77fP8bvOCdH/dfony/Le39r8zJ3+cf6ySJ/hIKsD9
isofIqg27k9UfBStxP2Kio+ka83U/YuKjzbljzLlt5jyR9MxzOcUH0NlcP+i
si+Wjhv4WFqP5xnrrQNW6e3xEvGP9SyIf2xfBDDbdx33VSh/j6Iw8H1Hv7++
Uu9IugFe4XC6ZUgfSVO6qHjNepye28+YPoJK8Dw066nvycM0f3JMue2fpYVp
fob8/jxU8w3Gzfgt8UEI5eH5pvgwOojnn+JDqcIKdf+I4sOpNe5DUfqRtAj3
pajy7e2B+1QUH0WTcd+K4u39O6lcwOKKfqTsj6H7+H1MxVtM+hbqhftWFB9D
zkXqPj6VP44a4/4Xxceayo81lR9nKj/BVH68Ll/xiab6JZjyJ2l91jOWF0+J
W5/m90irru1jrNLHUz7uy2L7JuH+N2V/HJ2o9a3buBkRaP9YEx9PabiPi+vL
WKWPobO4f0v1p0Xz6r5Di4mP0fao/HEmPtaUP5ZGzrpf64PNkbRufOhJ208x
mu8l472jfIWjNVbpLbo8haM0Zvu4vRQfTRe+SnP6ango+BiqJd+/cfpojVlv
6syQ7xbnhKH8KM2HTfzmctOh9vjl0/vER38E0lF5v2WE7t/Jk3IfnK4Voftf
8ZHav1T+aMrBfUdcX+ZV+bE6v+Jjtb7i47T/KT5O+5/i4/X4U3w8LcPvz6ry
4zSvcIwpfRwNxvyX7RsCrNLb2x/jn+37EvNLti/PwDv0zPap9k802Z9gql8C
zcTv46ry4ynzwUvWkS8Ho33j6Ir4Y/jqyqHgE2j8kfCFwzdXBx9Pn8j7X0OB
Y03YorHqPwv9PeCh+6JvwsHHkBW/r8ztxzy3nzG9xaQfpTG3X+7oyp2+uMt6
URqr+lrotNzfjND+YvTHGKpx9a3TM98K1/7CvGrPeM2r8Zeg44HiEyhB7qdG
gU+kMSnztoxpHIn7S5N1+YpPMukn6fHwZe3d3WZ9kKz7Q96PGp+s+0Pyj5J1
frMe22fEcRqreJJgqk+8ttdcX44vxvaJMY3/OG0/67H9qrxEuizvDw7Q9rE/
sX2M2T6ur1mP458RW0zlxZrKi9H6HK/YfzheMeZ4xf7H8crIR5v8K5om7KlV
OOPPiP+1/6WEjus32jVKxz/GrPf7wP1fFGVEA0dqrNJHUHSxy0fd7X6rcJjG
anw8v4cxu2u70nHgwymozfCZjZLjtd7WFTt31HwtQdfXyEfR2/K+wETgCI1Z
b+Ppi20TnyahvDAaPb3KZx/fTsZ4D6Ni8LXl/UehJj6cvr94eZR3e8ahGrOe
el+UpOvrH1Vvaf0Oido+Ix9JYzu+ccLrx2Tdfq9W/Oje5CYp+vlm5C06P/uz
UT+G1q7N3z4vLFnHF+aVfdG0+5T7rjaD4mF/NL3/6cnzXafEAkdqzPHqkLxf
MUbrJd5sMnpEpkXrDc0Y9Va/oFgd/yIm7Jn1ZoM4Hf84P8dT5lX7Rpv4GK3P
9hnLs7eH/D099qdYOlN7c+T845E6Pk97NrH2ynvh2j7GrFfwU9vOxVXCUH6U
5h9O3lW6X5koza+S929Hmvhourq0jueGXcxH0Tz5ficEOELjrlNaVXP5OdyU
3qGncLjGKn2Yro+6HzVM8wemngn8ZGKotm+se8wXr10Podv9I0bsiQ4BH0az
d/dcvbFlKPhQmiLv2w6mmtPfjYlqGqr5u/K+qhATH0bXjw0tZZsbgvz2eSDi
h9KP1LyyL1rnV/ZbTLyF8uI+EfPeCgIfQ2MRzxQfQxcR75S+hepvbh64MdIX
fCzNwPNe5Y+jU5hvKT6OBOZDio+nu5gvKD7elD/BpJ+gy1d8IqXzfELOh5NN
fJLOL/nvk7V+2q5Y1xFdknX58n5cr2RqifmMKi9RY1XfBOqG9YnCcdQdmO1z
wnqF7WuE9QrXlzHXty3ep3D7vWLAFmoHzP3xD97HcH+sxvsa7t/vgbl/A7Cf
zHp/Yv9b2R+teeU/UZpXOIKOAyt/i6As7PcrfwynbdjvXzbjccYPHvZxi/1+
xUfQ/WD1ez4qfxRF4fe6FB9JLfB7XoqPpmL8XpMq30ItwSt7Y+kq9g8UH0Mr
sD/A/cH7B4qPJRfsD7BeaWBVnoUKkV7ZY19PYD9C1SeaTmO/o6NXYfGwAVGa
9545rqD+75FUgPyKj6blsEfxUXQF9ireYsrv0Fe/5xhNH+J7qBGzvJv8MTeK
QvE9lOItdBjfUyk+mjLwfXmW72uHFz6O0vz12V+82qNDFA3A91GKj6YYfN+k
8sdoXunHaV7hGI2VvbE6vapPvOZVeyVqXrVnkuY///kHT48lyZqv/Xy+NCiF
NuP7LslbUnR9Jf8gRdfnUv0+kxvsSNW8us86jd7G/pXCqRrL9HVTqSz2v1iv
NfbHWG+VS+Kh5EWhWs/A102jr7Afp+JDOjk16LQ2dFw4cJoJp2qs9FNM+qla
X8WfNHqM/TsVv9Jpkfy+JFIMqXfuwx+dMzQfJvcLMoz8iAxqTr+O9C7g/Cbe
OZPqYz+T9RireJhOs7G/yXq3sb8py2uWqfmdOz57dDOkBtW8v+Or491jYE8m
Xcd+quQX1KAZuH+xl9zvyKIc3L+o8mfRZe9rtf+6F634m1lUe/OXntd2RSF/
lil/tlE/JFuXz3pGXMOEM004Q2NVfgada1jl930zY1F+hi5f1T9D28ftdxf7
zwqna6zaI53m4n5L1mNe1SfTyNvt4/Zg+4ztk0FTcH+nW902Ayy2TMrc8sGX
W5vEar3R8vu8eMVba1D8aw/WfdU5AThT43VyP7GGMf1/o3defg9p0fYxz/5n
4BdkksB9ouwvN3EfKfsf88rfMjSv/D+DFuA+U+W/mVQX951K/lwGzazhcfb0
h+yvmZQ3qZ3HoW+ikT+TrtaLSj27MxL5a5jyZ+r8avw59NX4dvAqPmQY+R0O
fYUzTDhdY6WfQdPk97RR/9E+1T5ZRv77Grp+ajxmaftU+2ZrXuEsY/oX9FR/
ZRnLs+vdX7EsxGlNmNab53y76e1T4VqPMY+3grbZH56rHAl/zKaLK4d/dySH
/TubZndrtP/vFhFaj3llTzZl3VkzbWeoBfXLorFZl/qtd42FPdl05szCwh1/
WrR9jFmP0yt7cihxcvLiZRlxsCdH88qfczWvsCl97xwaKp8/PD5y6eiQoFZL
b8RhfORRqnxexYpXt1e78fqJPJp4YPLdbZ/EAOdqLNNPzqXjPlsPrx2M/JNz
NJbpX8ulEW9XKLtkabxQ+yt5mlc415j+RI5JP0f3L+uxPyh7c/V45Poax3OO
KT7kmuJDjik+5NIB+X1xoq5vketonwkbk5S9K/Koqvy+Olmo/aN8Ix+fT5at
zTLnHklQ/KN82uc7p+vE0klC7k/trql5hfNNOE/jG89/XnpOvm4/tb+Vr/tH
8n41df+xHvuDyl9T+5PKX9OU36rbW/0+jlW352cLgxNLtxea7y3frwkjP0/o
9t5da1WTAf2Fbm/74rXPhUYmfo3Q/S35iQ79iOfv69408XuFrr/kvxS6f5qF
vblmzxBBboOzz23LTVb834LORb32OP9AMsqvpXnWM6T/X+gNXhQ3e1aDJMVv
FNpfhj7/ea6ZDnsl9nZg1mP7Jd/aUd7jUc/9yapxG+nfVl3+aumPVvpRfs+e
ovgT9v566UGvddtTtN7r8nv6VLG809gH3yYK+uG34Z4/dEvR9o0fvDg++VmK
4t8RlPp5zc+W3E5V/BFHfmlvfi3Nc30NON+Buf3KyPlemsKRDlxf+ptVY9n+
lRz52V8MvN1fVvZ6HDl3cPp/0WN/OXr3o1/mVk9X+e8KWi7np+nw11o0tMEv
TyY2yoC/1qJm8v1yBvy1Fv3jM2H00COZii9dQFFvv/VOGZEpCt94dDm4Z4Hm
veXP3RfQ3i3fzH/Qq4bilxdQxALPxGHvIf/IAho85P2NZUdDv72Dl/alO/Kr
8gtM5Rfq8lmPMevt+7jUX0PSaqA+BbRQvj8HLnRgmT6wgF56zfbWuxuztF6g
69lhF1tka71tsUNudqyXo/Vmyftmc7R9N1aXnf3G5Wxt35bXYlcdG56j9Qy4
tAPL/MdrUY/h20Ja9M/V9hn07fZZS3Lea/5brtZz/6LD1D1v5an2vWLiX7DP
rMf9weXJ/nIv1PylkKNf57xfqHn5+xmnHbz6PQ0TPl1gzP+Toz0kznFgmX6h
o/6qvALyz51i7TQpW+td+/v7Nn+GO/TqbPW70Ck5W9k7zcGz/zHP9WWe2495
9mfGajzV0uk5/n3i2nhXC59cjKdalC/vt87DeHL0l4q/tXR/cPxjzHrcP6zH
7SXjwxOh24fji4HPN5X3pcMeFS8d9rIeY9YzpH9Bj+OVAecLU3kme+zxmevD
8ZR5jqeG+tjjKY8njveMOT7z+JLxe7JV8ytMesNMeisQn/v/Xb9q745ZirfX
t548P5MlmqO+zEei/Qy8vf0M+q0d/SP5jbW0fTJ/ZIGRf+LI//9Lj9tX8m8W
UK+Xfd74IycX9XHEI6nv7YhXqn1qGbG3A5vta27yv//UfmY9c38MM/Vvc/gL
x9dIjA/mSzA+uPw9cr5Ty8hPNPXfm6b6/A/9K/NXcsQXVX4t6ut7f9+lOeAb
FdDnbx9Y17t0Fsov0Px8GT8KNT8f8d6AAx24D+Iz5++DeM+4tile9THFq9qI
zzTl93db/pQjfBCfmb+M+Mz1kfiho34+eP5yfK1tivd9TM+P+Xi+/bS9pFTt
V/NV/e3P304Xp/UtblxT1/fj/HfbFa7PR30KqXhaw4LdofmoTyFduhAd22xC
HupTSFPlfdb5uv0M/EhT/isOXtrfvLaRj6tNnr2/+61ZIvKXrq3HA+sxVvUp
1OND1adQ+wv3L2O2j/1T8ncd8wPpH3sd8w/W4/kJ6zE2+wvbZ+Dt9rG/Sn5r
oS5PtXehLo/ry/MbyR8v1PMb1mPM9nF65f+Fen6n/L/AyDdylKfiUaGe/6nx
V6jnZ2r8Fer5G+sxVvGtgA61O9Vo8rR0rfe13F8E/6SAmljmHx4WmIn4YML2
+MdYxaNaOr+M99+YeG9T+S/oqfhbYMyfaOJnOvKr54nDflV+AZVa9Xw/NQ3l
F9DSA62/nHQjXfwhz0MW6PYq+8XynBmvO3iJ/6plTF+vgI5Ep03yfCVd65Ue
UnXAp1vStH2MZfpyBXq+zvbxfF7i67U0lul31qLkA1fah8X/u96rcj85Vesl
lpkTOO/NNK3HmNuP68/9yzz3L/Mq/prS2/vjlUlh2+a5OvS+6zG2RYRXqtYb
5bWi52fLU3V/HL/t9ihifYr2l/L1r59ZHpqi+4Pzm/W4vlwe19fAv+Moj/uD
y5P9Vb2A0vcPGr9iW7JIK8xvX7akFvm+uiGt26Ik3b99y/QvPXBAouKzCiiM
rGEfTY5X/OcFtMtrTPNBGxIUX1RgzP+XI79ZT/WfI72qTyG93rZU6sq3ktE+
hZRaOrJB1NNktI+DV+3twGp8Fmo91d6Fun6q/2pTOXlfdgr6r1Bj1vv2swyP
+Y1Ttd6I+q/E+fydivhRm1rdGVw45YM0xMPaZJm/4NXy7umIH7Vp+Adlr0wJ
Bn+3Nq2U579TFe7vwCq+1aZjkbaf5t9KwfOkjrZHPc/qGPmRdbQ96nlSR9uj
nid1tT3yeflTXc1vfL7eCK2neYkXmtK/X5f2U87eD8tk/H/XU8/vOhrL9G/U
pS/keXTwOXWp4eSSlv0+zsR8wMTb9QZ6j3jcLzVT27fvzoUJj2pmaPsWzq+4
uP/hDG1f/5eSiq/1zNT2MWa9vVGfNBxQ5KhvhMujY49HpeN5bOKn1aXP5fsJ
5H9o4g+Y8i+vS4NPd+wxamoa+s/Bq+eZg1fPs7p0aNOOfyrOh3/Mq0tfd7/s
9lF6Gp63JjyvjsbKv+pQE/n7YtA/XsdYfmFdWip/jyxV65Xy/OL0tHKp2r7E
7sN+9usDfyvtwKx3ZIJfzrQu8Oc1dYz8C3rK/+vQK/J7ixRtH2PWi58XP276
shStN+q9af+Pta8Mryrn2sYZ3BlssCIF6np62tPu41KHKhQb3N3dpbi7u7tL
cLeBgQ7uboMP+m2SrBWy55ln3ve9vp/3dSd3VlZWkpWtJUpv9UG99afbZlpQ
3gf7K+EyAsP82GWfcja+qDfOD4k/YCWF6fsiXjjfJHzAgpi1ZyH7C3cJ/7WT
B/eHlTRvvqttwjxPnL/bVr+MtQ7zxvUA7If1QOqfuh5I/U/T9D/AiuMPeoBB
D8aT5ScWjCd2PrBgPML6J2GDwLD+QTzD/iZhdX8DDPkV1GfjqeZT9P5dAOaT
gCFfq3IuuvSgyADM/4CHfBd4Nr8spBZ9X8Wf59sW8slxsNPAZby+WcOvFOst
Wy+suL6CHmA2X0V5Nv819dV8PCOldc8SNfzQPp+g33LNC/ZFvbr0fRwf1Bt5
c+Qfq3P78PlvIQd73TrX0suLr2dW0vKce5a6dbzRvlL0fSFP1AMMep2DVr/s
Yffg66OVnKb/H6ihjLu5qXHSMSvyjRQ3810fG9YPmje+QsdpNuRz0fe77Mhf
rd/2+uhmdkJuhcbXm+/F8AMbYlqe2MjwIrrpVS0+qAf9B72st76/f+TL+Awb
qbOnzvp5l32YPetspCl9n8qb2TvCRoq/iplX/4En41/acH7S+il2nJ+sP3ac
H6AHmJYvYcf5Qu3pL8qz/tjJUNu9lPl9fJS19P1HB/IUnxHlB5aLnLk8yCGX
L+BA+yjf1YH2JX5/f+66ht8i6v+bHsVj7XL9d6L/Wvtof5YKXttf8B+st1r/
Uf/nEvVpPN2y4fpGeacd1y/mbztZm7kMKV2bj38JB/KsfYfMpzhI/j1Z59pO
Qfw4cH1k8aOpn8mJ9Vk8OmVecWJ9rR4tX9WJ7TF/ivLM3wKz8XPi+s387UDM
/O0gHen7hNX5+DlJCbfhoxttr8HGe44TefcbVVMOZXchT/EQp4yzC/yJvi8r
6p+ek63YrQuCZ/+/dpE99P8ZHgzvcso4TGBav6joP+V7O8mmIpFndB+9GZ/g
JANXRWRMeunD23MgBj3wP2tPjCctP0mMJ2tPYNqfZyI+aH8P2WXeU4zX/1aP
2e/Q2G/X2O8gicmNXuYb5ot6qwOO9Zs8kfO9HRp/CD2wT+J/sI/W/6yx/4KI
X/AfzJ/O9PtdTtI6y68vGnh64njA/IbxgPWAtS94iBeJV+MF5i/EC6x3lF/t
xHwA9ACz/jhxPQA9yPdAD/I3iD/gWX9cmF/Y6fvZkciXot8bi5T5yEhsn/Ib
IzEfpXx6JOajVL+Rhj8RSXoWzV/963F/3n4kqRi8bEbXPQHcn4Jn/hQ867+G
nyT0Wf8jyTfb9/8z+TF/WyNJcqUtPpOifdn8Lqvhh0TK/n4WieMBeoBBT/L3
6kjMh1l8RiHP+hOF/mLxFimP3wXhX9CD/A7sA57aX0/DH4ok79eUfd2ldCD3
TxQ5nmrK82J9II+3KNKx99VezRYH8f0skpSa2/XpjWnBvD9RxP6m5oWmWYK5
f6LIC/q8VTBfPyORZ+trpFz+v+ix/kTh+QvsAwz2QX7J/B2F+SLoxade2j/o
uT/aJ/FDojCfBD3AoAf5I+itzDpuwvh9fqgHPFv/I+Xyqh7ki9BfOO+CHpyP
ob9wXmfxEI08i9coGRcVGOIF9CFeAEO8gD0QL5I9QzT8M01/1HiR+q/2F/I7
6C/kf9BfyI+hv9nXOH6dO8kX/Qf5MYwH1GftR6E+m8/RMu8Zjfkn+E/CngL/
k30Sr9oH+SnowfwE+2A9ZPMpivRds3FF7hR/ng8InuUXgmf5ZiTGF8s3Rfyw
/FDEH/NPtCZeozHeWfvROJ9Z+9HyfJ8Tjesx6AEGPbCX+UeDf+gv+A8wzA9p
/P/D/JD4/+A/yb+HouT1UR1fif/BPjZ+oj74D/ZH6K+Uv78T+uA/WE9BDzDr
T7S8P6yO1uynGrw6Sl6f1fkrr+eiPN2/7gie7Y8x2B+2P8ZgPFLsr8EbozW8
wGw/jkb/s/bE+LB8TsQf5d2iMf7Y/iriEfQgHtn+Hi3zkdF4fY3t11GIQQ+u
x8F6VTakTJunlYNxvZJwb4GZ/ZF4vQ/yAwnfcWl4gSF/eU2ffw7m4yN4yIcA
Qz4klVfzofI52q3u+FToRdPnv4MwH+q5rmqf/nt5f900WM3/ADN/uvD+C8t/
nDLOIzDztxPvvzB/q/mezna12FzIjxyIWXsOLA/5rsTfcZBvt1u8GRMYgPk9
tAf5M2DIn+H+EOTjwDN/2eXyaj4O/WXzw05+Gz06708nIR8TmM1vTfn/oqe1
j9mvKT/Jjvay+LKTiuf3PfuwAeJPgz/bELP2bJr2hD7zr8ae3qI/zL92jX/t
JJm+X+CPeoBBr3qr1zPHZsB8FBjsg/yAxbcd7z+w8bfLvKoH9wNAT8ILbYhZ
vNnx+hez3ybnF7tsyDP/2nA/B/tgvwf7pPUmzC6vR6p90vlC9Z+UDyfY5f1G
jRfYT1k82RCz+LRjvsfi04brFehJ+d0PehAvUn01/qT6avxJ+eZquyY/FRj0
4P4CxJ+0HjZyyLwaz1J76nwDe/7NPm1/2X4q7m/8m33/1t9/sw/WA9nfDqz/
b/5j+YGdlGl9zKNp/WDUg/ME2AeY7c92MjVk2ObkRzq+39tJBH0/JgT1Cue0
hjs76fl+byct7644dbZfCF6PMIw9fc9ZXI/nfeDhvA/6cN6XePW8v39fwbop
o3S8Pw5Zf4hD076D7Kh2Y82+pqE837DLuJ7AYN+DvjunOM7qsb+AwX9FL0zt
eyZEj/1tvf5LvmRbCOoBz/JDO9n1zveF3TOU50s2xOC/sfMTc+47EIp6v0b1
KKevHYbjATyML9SH8ZVwgsCw/j2i7wfpMf6M1To3TVoYguM7nb4vpEO9w3W2
XGtcUofxJ+/fDjLzvEdQ4646tM9M30cSeoBBr33kwjGNzuvQPsBgn1Rete9J
iYY/J9bV4/wt0dbw7crhEJy/Eq/aB/Vh/wV92M+Bh/0ceIpfi/LP6PcTnWQ2
fV+M48sOxOT797NNTnL8bZ16HZYEKxPp9yVF+abfv79dyIV6lH/kRPtp/f2i
fdCT2i/lJEfdc5V9ciOY4RkOxLR8Fif6H+yD8WH5qQPzKZafCgx6kN8xfzgw
PwQ9uJ8LenB/B/QkvNGu4QVm7Yn7z8x+B+5vFA+0yziLwMweG/lS7OdNP7Xj
erUFZv4U96+ZPwVm4yPKs/Gxy/wjG+l+50LYxw+BjI+3k8W69ZUG/MrxOZuM
4wUOod9nt2H+kbfu9++zi/o3vn+fdJjITzaU8R047IXIT4Z8/95gssgPKb5k
l3GywLS+tx3zS8pPFflRytV8EQu/Cr4G/f6sA59/oXy4A5//oXiPHTHoSeW/
atr7wT7Qk/rzswPzK+gv5EvUH0fs+PwE648Dn/9g7TuQZ+07MF9i/XFiPsTa
d2K8sP6I+AI9GH/Qg/yO4r4CU/37mvKqHown5as4cTwpXuKQcRWBv858/GnP
aFGf4nwCn/v+fcwuovyiOke2Xb4q+G7fv7dvcWJ8Ur6MOA9RPMuBGPRgvaDt
RQse7AOe2W9HzPwh1mfmDzuub6AHPG1vs1h/wT6Jfyvao3yaWL8oH+iU688S
9Wn/s7mwfYoHi/XWVXpRl3dPxHpMcSuBf6H/L3CS9/R94GDl5eX+foVDXcgf
oP8DEvqU7+Uib/vcy97Ryct/ciIGPan9lYKnuIbAzH4nnlfBPhgPZr8YH6pf
S1Ne1ZPi4T/owXkI9ABr9Zj9Drn+SofcvyJi/6F4ohg/1p4Yf9CD8QM92J/Z
eGn4Jw55fA86cH+EeAaexZMGz7Jr4kPsz2z+2PF5Zhafdnxemc1HO76PwOLT
Tppv7HDz5OpQHp8OmQ904PsKMH8lXp1v8HwzzF94fhzmBzxPD+sB8LA+Aw/r
KTxvD+sLPB/N2neSe9EDl1u+hqEeYJhvUB7mG+jBfHtA/w8ZhvYBhvkLz1/D
eACG/kr6Vx2y/n/or8S/1fTnlAOfB4f+gj9hfQYe9kuJ3yP8Ceu95E91vYfn
r2H/+LNfasaDdSG4f0xf8NrRYJHQk3C4Bqv7JWBYTw+/P+PzIJ8e98uyvweS
tqVCcL/sumFm7LsqOtzPAcN+Ds9LU7zWhpjlDzZ8PprinBo8zIqY5h8NrPh8
Nc1PdIJn+Yp4fpvmM+MtWJ7mQy0s+Dwwy6cs+Hwty08Fz/JnM/LseoiZDL39
daVbR7geInh2vUHD3zHj87HsPCCe32XXTyyyfroFnxdm5wEL2Rh8ZeKKK/x6
SJiGX2ghw9fGP12ug+sdFnJz1NZevla4Pqupv0vUZ+cRCz6vzM43gmfnQ1Gf
necEz65/m2W+ngX7z86jwh/sfGgm1/c2Dl3ZV+jB88LsfGhBnl2/Exjsk8qr
9sHzyuz8aiFBs48f90v3+ZseO89ZSB76vRF4fsBCDt+NbtLpkTfqSfiQGTG7
/2HG+sx+DZ5jkvWzmzX2m9F+dn404/PR7PwoMLt+YMZ8FPQgX2X+Fc/TM/+a
ZL6seB+AjZd4Hp+Nl1muHyTeP4D+Qn7B7reK9y1gfOF9GxhfeD8GxhfeD4J4
gfUM4gXeD2HtW/B9DdAD/E96kj2qHrz/AeML71uw/ljw/Q/mTyuuR6w/Yv1g
8WAltfabk0Yt5/fHylrx/QAWX1Z8H4DFlxXfB2btW/F9YTaeNtL/5/LhRYrA
/XAbcdfvWJOeA+4P2Eji2ClTCrcPRD0JtxGYxY8V67P1QdSH67ED73bsO/0P
uF5vI9Vz5ntR6FQgXo/9st4nZ3qjILweu/jC8W5Zk4NRDzC7PqIpr+qdTUso
l+0jXO+2Igb7uvd7Prb3s3/Wi37f+GEvlw71ekYZz2bZxPkE9fxZbWn9keTf
7WO8VcNrsLr+AWbrr1XW/2yR279gIRXbXVF6LYXrOwKD3tuS31LeGEJQ7+jB
ih3aXAhBvfYPdt26d0SPeiVyJ9estzMU9QCz+BDl2XpmlrGnwLAeSPXV9cVa
319/r1Iori8dNxWo2HqM0Ct1afmEuwNCUQ8w2w/MxO4xtGerJ3rUm5vraa7X
7/n1r2cmGbcRmLVn0rRnQn02X0xk/1/mrHW7hPH5aiIty1zv9HtzA58vJmI4
knlUzDcD2gc86Enlf9Bj/hAY7HsRU/7JneuhaJ/E/xc9sE+yX7Xv2YBTK+qW
CMP1fvKiZqUv5jHgeDSPTfePXWDA9Zl4/Ln/4hpun9VMJl4qeiXWasDxAJ7N
BwvqM3+bUR/iBfQh/oCH/EAq/4Me5AdSe/9BL/TjmsijunDMDyR71f33yaae
LS/Fh2E876k/Z2DcwzDcf4sbshXOeBOK+2/bUi3n188civu5hIeYEcN+BPkm
7EfAs+cfBM+efzBhPsqe5xSYPc9pkssvNWF+y54nNWG+rNVjz3+K+v9bPfZ8
qoYn4v1i9jypGc8P7HlS8X4l7G9QH/Y32T8WtJf5x4L5N9uvLfi+JXs+ROx/
7PlT8T4k6494PxH0YD8E+wAzf4v3IUHv091rh7PNDkL7JP4HPeZvTf0f7GP+
Efs3e35XwzcT+mx8hD57fljk/+z5bzPm92x8RP7Lnic3yzhFYDZ+mvrTxPue
YB/kB1o9sA/eF2T+tpC6VY9alk/24/FjIZvp9+h8UQ8w6OW7PbHRtjU+aB9g
9vy1mRyn3+vzRvsqVVu1ebTTi/tDYNaeKM/a09TPMJGeIXuzjR3Ln4dW1Pzz
TrcLs371QL3Bc8yvV/aqjnrX6fcAq6EeYNCD7z2x571NyLPn9U1kTNajt442
q8rfP9Dwx0z4vSror8TnMsv67c34vSE2/ibE4D/4/hCML3zPCfwH3+sCPeBB
DzDYB+V38+9vSHwu0Z5Wjz0Pb8bvDYEeYK0ee79MYPb+hlFuX/UffO9Max9r
T2OvqgffF4PxgO+RMfsFZvabSBx9HroC6mWqVK+sXimH47uJPj9eBuOlOf9/
DsRLGf7/HogXCavrKWBYn8/y//+w9UKUh/MC6MN5AXg4zwCG/Qj04DzTPvOo
eiOXlEQ9iVf1Bp+YFHqwbxHc33Tlc1y5UakQni+BZ/urFXnIT/949PzNu8n5
+P5qJaO+3Qi7Nq0w5s8K//4o5M83+fdHId/14P97gfweeHjeQuLV/P4k/18M
e77HTkrQ92fL4P0tiU+3k9b8+5zs+oedpFVO6OjvVR6fB1lFz68V8XkL4OF5
EMDw/Aa0B8+/AA/PW4AenI8Aw/Mg8P1MOB9lofdPKvB8SvBsfDT8ENEe2z+F
PWx/Ejwbb6uMg6xy/TlW1IfzoNyepnw9K/YH9OB7oWw/1PBdrdgfFt9W/F4o
2w+t+P1Pth9b8fufoAeYzRcLeUivD1dHvTGhn4adiqvB92uLjGMFZv6wkIDx
pm17+3hgfy/fH/Fw/QpPPE8DhnxjJL2fXwPP0/D9Tq0es1/wsJ8DD/ulxC8V
+rBfQvvQ3/5h50osugTvA6n9J1n6uOr7oP92tqoy+cBb/j5TJitpNIZkD3vE
33dqZiXj7sx6tr8mvK8leIiXoJC7v2zuB8/j2siY4q7VYaPg/S8r8qx9K7le
p+8Yz048n5hmJUP7lvi2uGkAXz+txGv+hnZlawfy9VPDr7OS1GphP5f7EsDX
YytZn2PBkiW5AvD9vFx3cwZ5FffH9/2Ah/f9oD687yfhwho8wYwYvjcCevC9
EWivA//+lYTNGnzAqOE1+ICCeA7/Xl/DfW0Oba4I76sLfgr//p9UPk1Bf4Me
jBd7f9KI48ne11QQs/d1FYwP9n6twIbv3xPYFoHlp31vv3kE0eUIrhdq81Pm
0vd/FdKkThHb/rW+SkeuN2HdC09nSV/Gq/bpz4+Ysy+vn3KSvl+rkNtv3Qro
M/mjHmDQKxCZ6T1p4adM5/1t5t50qKOrL8fhiN/w7ydC+Vj+/cStbWY0C6nr
z/iSEWRkiT39NrwGHI4Y9OoeuDW1xsgA1Mt+v9dPi/oEot7qn4r3KNMhCPUu
133VYOHlQNQDHMu/7+gXmvKy+gOhV39cQMb6uADUy7nxtKO6JVBZwb8/ufb3
5tsXBAcp2en3Kw0k+UOW6qVrBCsN6PcGDeRbqdkzJpbVKTvp9wY1/DUDGRx9
o9CCSUEchyH+Jz1o75/0qi+sYpq0Lxj1AIPel2hX7XwpOtRLrLHu0aTGoB+G
ODv/3ubA/qPOlT4d9I96/9Rf0AMMeh7tewwsNTz4b/1twL8HKvc/DPUZDtW0
F4r+YFiv8Y8eyzMcovFXiKY/eo1/9OgP0IN4Kk6/hxqCPMM6ufyYENl//8U+
0JP47997rW6dX21+IOoBBr1c/SuMWJc7kPs3lAT9/qV9cOcA3j89GbOhUaa9
/f3Rfw3rDiuh+zmAxW+vMOQZDtVgvQaHyHoeIeT+2GNjbaP9+HwIIdv1z5bu
dYP2QkihErWC7T5+qBfexrvc6em+vL6eTHFNXpO4xAfH42rsu147mnjjeOz7
rWxSktMH+9vi7bbDp8N8OQ5BDOML7TGsQ8z8GyyXH6MjYfOuXrefBxyMmOnr
NO1p6ucPlu27Fkwm9TG1PXPD5296DAchLs6/n313f9dYctgP9WD9K86/nw3r
Ywf+/WyJjwjG+lo9hgMR0/ovA8ioewWJboc/x/6IT9LvLfvL5dsHoP8Y9kdM
y5f3x/GuSr8H7YfxxbCvBvsgZu35koCfVvqsXx3A9UV9hn3l8uV9Md7/SQ/i
k/LxvhifA+n3ojW8at/OnMpD62M/1ANMyw/0IY2qX07Zc81fyTb2+/9evBEz
fR+cb0zfB/V30P+5eCPfnv+vA/hr/H8i0F57/j8R0G/P/08CuAr//0ee6M7H
gs4FcFxDg6shvsr/n7KxXX792oOBnK9Ohpbyq+leJ4hjd8RX+f86rr+femtt
s0COKyOewP/XAf1hfBUcD4YraXBFDS6P2K1yTdvOq+Vw/MZUuVEzal5Z5P+q
2rr+tUa/kPULdv7l/jVQsdP/aZTH/WE8/58NrJ9M3w151r/KWJ/5s4qGr4Lr
KeOrYvtV+P9OoD70N/VQYsv5f/7df6An40qImX5lHA8WH1XJzYOPKwR5Cft0
C+LW79YHcN6dNHnvMd2yCOKvuoavRsb126JY7cDXwHhhfHWMh/b8/y5y+zU0
7Vcnwx8MnrCmQhDGi0/uclmrFgP/ViMZHts7zf1Jh/G38tLV9BJzdby+B+k7
MNOi8YEhXN9Lw3uSrJtNpeetDMZ4lnkvjb6Xpn1PtI/Fo4eG90J9xnuSOhOW
rai6LUhx0PjxxP5/pf8P8UD/bKL/F/FA/7Wk/x+pgfOzPP8/icx7oP838f+T
7L4wwf3kOj/Oe5JiGz5srbXbl/Pe5GFambMnawHvhfWZvqeG98b6jPcibcbW
s1855qNcpP9P8UJ+FP3fiie2z3hv8rhau4K1SgH2RMzKexBTzt/nXq7i+zc9
1p6wV2sf6Cn6gfUTGvii3rSfHz6/0tqH4+oa7I7YxP8XA/U/0P/JVNXw7mTk
H8NXH1rlzXl37P+ako9v+ZGqaC/jq6F9jHdH/zK+OvoH9GRcBTHYB/VH8f/Z
yLyYnyb+fxzA0F+Yr/+kB/EEehBv4D/YLxhfDddf0AMM/oP1mvW/CvKNZ/g0
/1ShCvKlSnd7fmBQZVyfzs7c3XnUvUrIDy2T7VOCXaz3jK+M6yPDbohBTy5f
Ce3/Nz1Wvyqux4wX6zXoybgiYqZfEc8XYbNdA35ZXgH5V7+Mz3k/dwUNXxHP
J4yvSJYagvPkLRzCeTdyYUKR1xN66bh+ZZL54YvLJe8Fo33AM/vdkWf+ro48
G48ayDNcDTEbvxpYno2vB9rD4sGL9HxY223IshDOe5KKed5O/DJTz+t7kuOe
Y7N1HRvKeS/yfmCrp58/AO9F5i7OXrfLU+C9Sce4al2eDwxTDkemL219ygf5
CvR/ej5Yn/LRvqRShv3CoF/1Siv6f0E/Eu9ZaVfukyG8vi/5K3aPx6C9el7f
F3nQk8qrerBfaPUKnrBUWPTET+Zn+ZGL9Zv6lzTpGN/KnyzPPTJyQoZO2fz9
/4f6ANJ78+pGedpBfX/0J6vvjzxr31/TnwDsL8P+cv9P+ZHYBud6Dc6u/0c9
aI/296ufzJ/y19QPwPEDPcCgB+MJ9s3O2FDmReUw3r8AmVf1pPGMDiClOh24
17SrgdcPJM9+efDlRt5wXj8QedADTP25Q5Sv7fo648qIIEKO5i6eujBc+Zbr
+/9Gg2U+VzCxfooa3awk1A/S1A/W1Nchv4j+nysE26d8ho7sn1w36UYLzi8L
IS8eh4Q3PW/gWIcY9Kbmu7Dm+mGh13Lb+8PJdSNQb8Szo6WbuyuoF+HTtlzy
jgjFSf8Xppd5dz259rVYQqUFCq8fgvw/6b3af3npok6cTwkhtgtVbzZ4JvTW
Lg9pPVtnZO2915MS/SI//DHIqDyn//sJlfluoaTOtKf+t/ZA/VCSc9jcT5Ws
0L6eNH2yaOi5KRG8/VBSJrJx7OLiCq8fRpr8yLuHkRxS/VDSmPOg11ijV1qj
N7h81yu3GirMXpsB+Yn0/2ThpBGvz/pjIDv5eFN+cjh5yMdbR/9fFEGK8fFm
/0tRkN/v9oqkDVCQn0yv9ynEdHTuqWc3wpTmd0736R5nRJ7is4qM4zT13RWy
m8cT1c+skCY8PijfXCETePxQ3qgQPY8Pyi9TyFA+3mDfZR4f1P5UhXgVbDTq
ZmmjUqZxsWxGP4UMrLDu4KzJ6nh+v36YWyEX/b58TilgUp5R/0Qg76D+jUB+
IR0vwTMcjvgrHS8DtpdK55cB7WE4TINDEW+i62WoXD9XGDmkj8+06Cznd4SS
klFzdA1cRtSD9ln9MLS3AF0/QpFvSdcjoc+wHvEhuj7p5fJlRHtaPWZPmMYe
g8YejT9yhZOp9zqX+KUZ+CucZNo5dFHqBuE/wKC3is8/0AOe2RNGEk6ev1rM
w8TtMZDd8+81r9mN97+VgRTa6Dc//58m3h/B0/6eCiMtxk3zmfIF/GEgvzVZ
ses3B+ejDaRvQt3Bxc8YlfJ0/wgj1c0Fo2onGpVeJ895Bq5V/e17oMicKwrj
+xpIm7T1wxqOUxjvbSD72nzd+0tuXt47TINDETP9UJLC1xewD3iwD9oH+6T2
/4N9YD/DoXJ/+oaRB/T8YUL7QkN3OQpMMikX6f95Q8nYqFwDTuQzc6zX4BDE
TF9PqnR7/2bMfl6/gZ70HG7xjAwzK77RJTZ9Kagnp6ePb5JzC+AQDdYhHvX9
f8D7grE+w0EaHIj4wal6+sMdA7G+6fv/g900/KtAcqdu0vZhwzi/MJAEt1v4
pzmzhdcPIvMsm/v0j7IwfWMwyVXqSK7dUwEHIWb2BpOOLzIm/3XbgvYdzlTl
9OY0K+oBD/YBBvuk8qp9dWsUNfUoZP1XPa19rH4Q2fxTz3OZynL9hcJe6C/g
2TGLyZgE0R6zJ4i8ScyyJeywsA8w2Jfe/2W1TL0AByCG8YDy1D/jgmRe9d+N
8YZfd70Rev4LR87o3lb0d1b3WVU2b7fy+sEke8yaDX9ms/F40pG2biTcKw5w
MGIYj/0B+bo9PmZDveK22muXmO2ot7q9w63lBxv6L/PAyXWqdLSj/xIn3p54
+4kd/bd8kffJOU0c6D/AMB7KmV+UX0s5cHwBQ38v/ZVnU+UzduzvoId7erVI
tKP/ADP9AOJ9qYN59RUbH58AcuVQpTx/NrTheFhmBk31XA04QIP9EdP6F/zI
tFWDzjyqAvr+cn87BiDP7A3U+CMA/QX2yfUDNfWDkIfxaJm89MGvu+3/OB79
SrcOvTPGjuNRg14/suN6MOmGz9hGDey4Hjx82edIuctQX0fiD4+tlVYZ/K0j
XzZ9v94E9geT5Qvf3r7jC/0PRh7GV8aBcn11fKF9mB/QPsQLtA96i+n1M4iH
YJJ/9fOfEx+LeJFxoAYHIIbx6EbPW04cD7cOG1v9vtOB4yHxP+jBeMj1A8mJ
idFXo9c6sb/lFs8omruaC+0b3nPVPFtnF44H8DAewLP1X4c8W/9DZL5BCLma
/ldGlucuXO8l/X06EtCifvORH8F+HbmZXNjndH9un5uOjLIdel8oJ9ivI29L
XxoUU9PJ64eQen8+LJA+G+qHkNw3Z1467cZ5o57Mp+dR8EcIYtCL/iusyMV6
DowXwGDfltMxcwuvcKB9oA/jK7enQ33ory6w+97E0ULvrluNYdOLODCeAUM8
94op+SntqB39J/Gq3rjC12OuTbejXljm8cUrlIf5EEIWX1ywoG4rO+6/+Vdt
8pqxxY75BvAM6zVYU18d33h6fZ2vtzeDEbPx1pGHL8zXGy+x8XwiBHnIJ4GH
fLIfvb5lw3yyuLX84ScFAOsRQ74L5SHfBT3Idyddf7d4mYfQAx70ZBwi2zMr
BP3H8kU9OV+j38i7F8BePalqOLl/Xowd9fY02xHUOKsd8+eWSW2+Lh0h+gs8
y8dCZP6URl/Nx+X2w5CHfBfqQ38Bs3zaQDIPqNOxVbgN8/FEen3dhnrAMxyK
GMYDyoN9sF4yHKLBOsTgP+X0naSl923ov0sfzh1vORNwCGLWXgiu7zAesF8z
+/XIM6wp/z/Qg/Vaqwf2wX4D4wu8Vo9hnQaL/Yn5I0jWmxWM+xvDYr9j7Yv9
jo2nDvcTZn8w2g96wLP4CiZhWU58u1LLwXEQYhZvgWRckRK6aaccaN9fD6sd
vFDCiXoS//9B79c9oXGFGjtRD/Yf0JOx2J+YP8X+1JJfDwPM2hP7HVtfAmT+
P+jB/gt6gEEP9mvQk/gf9A7x63WAmT/85f6qerCfMn8E4n4GerCfsfoBuJ+x
9TMA9wdmTyA5Q6+nOvh6HCj3Xx2PHTPn35jWXowH9EcbLxB/cvyI8YV4lv0j
9BgO1PhL+FPrP4b9Nf4M0MSTv2yP6j+YD4f49VgZ+2nml79mfvlpsK9mvmnq
l/HTrBd+mvXCX7Ne+GvWG3/N/P+7fbK//TXzy0+DfTX+8cH6Cr8fIPvLB8dj
JL3/4I1Y4fcXIH9l+j6k6ciEpVffCT2In3f0/oM3xvcqev/DC+ObxZ8PznfG
e+P4svj1QftZvuGD6wXoAf6V3n/xwvKgd57eXwbem1QNz7GqzkCHUoLev/FC
nuU/PnieYPmIj3zeGOeD5zdmjy95uvtsziXzIL/xk/mbvnieY/3xw/MbxDPw
EM+FexpTrqwT8byn+Zty5YKhvr/Mq/MD6mv1mD3+Gnv8kGf98SNfNvfOVucG
5K9+8vnzlS/WZ/mgH/aX5aeiPyyfFjw7H/ri+e3DmKNZOw3xxfNjrTNPbMlB
vuTliEf1OvjblDXfnx944IN8rji/U+Wm+ch8M1+SWv/T49V9ob4f8lQ/uz8Z
tunSbwEPrYzf4ofnf1bfD3mqX8IPz78M+yJm9viSji8L99tU3IZ6wLP++CMP
5+lcpTO/7nbCiudpib8QQA5nbrC1/TjA/ohBr1SR1S88cttRb71hZqOXe0Df
HzH0t65HTI0Aq7AP2of+Ag/9BR76K5VX+zvP+qJpaH/r3/QYFuWZvX5YHuwL
bn/t8tcAK14/AB7Ol5J/1PPl5lybduyMt+L5MipggVe/HMJ/cv1A1IfzPvBw
3gcerg9J5dXz6p164xaYdorraz1H9C2eo70Fzx8Sr+qNjTa3HGq04PWhKt19
rzvfmfE8I/HqeUaur0P+n/Q+VEx8t3+UBa83AQb7FhX6aU+OIsK+fA9Kusz1
hN72308WGnbXjHoVV16ffcDbgufprrtqXOy3XOgBBj24XgZ6cD1Ne30N7IPr
bwwHydfjCorrm0xfXB9kOFCDAzTYX4P9EMP6B9cnYf27Qp9nsvLxCCDeF4Nr
v1pqxXxo2krnfa/XVsw34HwC+QacTyAfAh70pPI/6MH6LGM/DfbVYB+NPb5o
L+y/gCHfgOuzsJ+XKtwpR8eLVsw3BtHnoyB/8EX8T3rQPuQv0vlO7685/wXI
50U1f4HzKjsvB+D1Anp/JSVQ5nMF4vUGVj8A809WPxDzU9Z+IOavBfj9aYnf
EYjXP1L5/Wm4PsLqB+H1mlR+f/rI4Y8zjzzk/I4gUpre/3ehHmDQG7w6tQFZ
7eL9CSbP6PMAgIMQs/tzwVie3s97L8qz+306kpTSp3uIJZLjYMTs/l8wyWL3
Ufoc5/W7BSFm+kFkTeCdnPviAAciZvezArA8jAfow3jspc8LROJ4FIm4GuaX
K4rXDyS9iz4/2jYhCvVk7I+Y6fuTs5VDM9c4DdgPMfO/H6kUPDzkgT2at+dP
RuedcchtYjT3tx+5Re/3xmD8AQ/xDDzEs1T+iS/p7vi9w8J9Qq8Avd8bjfYB
z/ofgPXBf67XH0aUSYnB/r67tTK+wfVoxi8LRHvAf1Af/KeuCUGzhsag/06m
VlxRP1ToydgfMdhXvlW726U3x+B869x7V6kMr1icb3mWrhgz804Mzret9P51
DI5vDIk8vqCs0AMMegvOTctSf1oMnj/e3b6nL104FvVG0/vdQq+Sbn/FBb2g
fgDp7ixQp95b0d9bZSs8mKHE4vyF+mz8ApCH84yM/RDD+EJ9WP+AL8+fHwqk
998B+yCG9e9MFvL7sSxxuJ663vh1upQei+cF6C/o1af3+2PxfAQ86EnlVT3w
H5xnAMN6CuMD6ymMH8M+iOF8BOMN8TxCGdA2JVMs6l2LP72kaM9YPG8BBj1b
1Zt+8YfAn74k5Wv3G7af4lAvC32+Iw7nR/SsKZuHlotD+95X2n2ucVocjseq
Aod/zjowDuOl4cfTdecvjcP4K37v0sKIU3EYL63p/eY4HF/gQU8q/4MerAeA
wb6tHZYZD7SMw/kL+hDPFew7Tn3bHIfzl91/BuyvwX6Imf1+pP+OR969S8Tz
+edHTpy5+ejaK14+w1eDfRCz9n1Il5ScOXZ58/opvoTQ++OAfRCz9cQXy7P1
35ffH+f8Ml9y4URQc90EoSfx7n7khmfJCR96Cj3A/6Qn9U/Vk/uv4dX+Bi5+
1aVUeDzvn9Bn4yN4hn3k8qre47Gfdm5rxPkdPkShzw/H8/H3kXm9pj11PICH
8QCe9cdf0x9/TX80vLqeyv3xJ+llTqaGZY7/W7xAPEN9iGfwJ8QzjA9cf2HP
L8TjegUY1iv3a4PmvclTE+cvYJhv146Muj/BtybOD+BhfnR61bN20v14XJ+P
tUgI7748Hq83lbvlWXFG63+3D64PAc/WOz/sH1wfgvGG9Q8w5KcjtkSsubg1
nq+fvsQ/ounxTW+E3kP6/EZNvL4xYcNkD9/kmpjvQn/h+prE9/UnYfR5j5p4
PeL+gduNn52tifmz7x9/lI1dKfQAw/WSKw0zhXo+rMnPG4Jn5w3Bs/OgL/Ls
POmLPDtP+pIhj6sk56lci5+/fZBn51kf5Nn1BcEvmXNp9JrWXnL57D5kHH0+
pZbykj5P7IWYlfck+t+9Zy93Aa6BmJX3xPb09PljL+SZvT7kxV7dHXv7Wvz8
60MWrTBWuz+Z8wt9yMcKpfP9lFoL+2sNLnykhX8tvJ4j8a98NfV9kWfndw3v
5kdSJ7vaDd4J9f1I/v61Nle8xfX3+ct8R3+StWyH9F8/1MLrQ4CZPf5kG31+
JAH1fh0/79n12gncHj+Sl573EtA+wGDflgXPKs+8kMD970sa0OdLEvn1CR+Z
H+JLMm+7e+PzGqjvp6nvp6nvS3Jv0tdLjknE6xuJx3xLbHdPxOsb8667/1Yq
ayJef3E1i33+ISIR9QDD8xHf4lMCpjYRessv943rskDo1Ts0bEqRo4l4vaTI
unFX1z9LxOslR2dMrxhXJIljf8TwvEVZeh4UesCDfcCDfVJ51b4WVVuS8+sS
/6YH4wEYxhfKs/EMkHnVvs4joh5PnM75fQGkWudEH7+9ifx6QiC5Xq9e17N3
E/H6AfAMB8rlCwaS8597RRX8DDgAMcRfnyELmj/XJaF9VfMfG3yySxLad5Ve
X09CvfF3LhfMtS8Jr0fY6P3FJL7eBCHPcKAGByCG6wegD9cPhg74cN+RkYT3
U0JbZ/Z88CUJ73+8TMrdaYhbMt5PWWwsst3NmYz3UwDD/bzaHmW+7WubjPfz
Cvxc2dpgEuBgxGy/02F5OP8CZvunpvyIYLJ9bmTD8HOcT9GRbPR9KqG3xtAi
uO9DqK8jjdw79imTP4Xv3yGkRJFeB3b4p/Dzq56c+jIoV2pqCjvv2kKRZ1iP
eAJ9fjhULn9YT7oNXVE5eArgEMS0/GQ92U/vL6QowfR54lCSb/206R9dQm9r
yN7NGcMA6xGDXsP9985tOSj0itP7E8K+1pWOfuq6GnAIYq0ewyGIqT13Q0iW
2C3t9L+mKFe/v++5UU+iG6+uNisM7NWT90/PW3v2EHrzu3xsmLJF2Cfxqn2r
6P0QYV9Sg6zL3l0R/c0Tmff5pMyp6L/N5/1ydwpPRT0Z6zQ4GDFrT0cyPfp+
P4bzNh22B9c3JHtUPbCXjb9O7o/qv6cj/yy9YxzU15Ep9H6N0JNxEGIWX0FE
mRWe0DV3Kl4vSV8fmD/jbgraJ/H/B723Q+0zivqk4vWcuQXabnnVOpXHe5DM
LwvG+nB96HGlJu0T7FBfp6kv9P9Jb0WHuJsbElPRf7I9OhL5tXzfoNcpqAf+
XcjfhwD/wvw10ftfKTh/gWf5b7DMjxDj95W/vwDjC3qAF/L3K6Ty6noA8Q3r
wbQei+58KS7WA4l312vqh2j6I+Kbta/HeGT90aO/vvL3F8BfrD969BdbH8X8
guc3oH14fgP6B8+DAIbnQWA+w/MbKfR+KGCdBgcjhvUe6rP9Igh52D8Aw/4h
lVf3D/Af7EdgP+iBvay+aA/2N9CH/RfWc3j+D9Z7yDckfl8grvdwfwb2C7if
0pbe/03G+wsSvy8I9xu4v3Aws1f61+3JeL8CeLi/IJVX9ZqM+eo+MDkZ71eU
6pGzXfk+yfh8GPDwfNg6+vwQYB1i5h8dyVH6zOHsb5NQD3i4XyHjQLm+mh9I
9qj5y87sGXkXlUrG+x+F+qx/eehaEvqv2ZuRFx7MS0L/Sbzqv8P0eS7R3141
D/TOUk30V+JV/7V/ebOmSRH+g/bhfpTE39Rp/BVCzjQquHnPAuE/wKDX42nQ
uVk3hJ7XpYifQ7OnoN5gej1f6IWEVDR+egb1Q8jYdZ8q/bI+GZ8nlPibIeQ5
fd4wBZ8ntMzM1mrnRaivJ38Nybc+9TO0H0rWtC/+/n0FmA+hpFGdcoYpdpgP
oWT7bx/Kb8vN7Wug4b3DsD68b5CNvn8J9oeR2C/3J/Xam4x6MtYj/jf74P2F
FPp8p7Av311raufBf7cP9GR71XzJ5j4ooM0/9xf04P0KaA/e1wCe4TAN1tT/
quYzrVt3qbkvBfvb8O2E8T5fhX15+m5fnT80Fe1LmriuWftigPUaHIIY4mUV
vV+TgvdDswxs5L1pZgo+zwr2w/PAgOH+peS/m6I8zA/Z3zqyMH/AqeCQFIxn
GC9YX+Tx02niS6fxt6Z9VQ/8BXoyDpL96R1MWid32fnyvlifAbP2RHm2XwSj
f9h5QLSH+9GPvLofgX9xfys3IPubDVBf3V+XLa3w2wsYf8FDf6On1n5UrCu0
r+7fq+IXdouD+nrk4flOaB+eF5X4J6Ga9kM17YeSSN/ThnUeqdz+MJKpzPfn
rVPxfSuJnxWmqa/hyxiw/r/pgX2yfih5u/1N6pgWqfg864pFX+Z6jP27HvNP
qMyr9tUfm+P+8U1Q30CK9izg0eJyKvdPODnWuETHnJlq8/YNpNzVPxOrHYD6
BuRh/kp8mXBygd6/BPvDkdfqsfwlnLSk9z/BnnCNPRHYnmflfqeeZVNI39gK
2xZXrs3f343A9tj71hHIF+R6gFtp7GPvOxtI9fAL/R6tTOXvJ4eTLrVOhEQO
FXqk+f7XqxpwvkwE2sveR44gm3PcPPa0W6pSh35/SUH/D2+yoOBvgQr6fzP9
fpJCEuj745zvopC5ptJdWy/hfIxCnCeME1x3wN8RiEHv62ZXxsOfaqN9gME+
0If+Ai7IxwPaK8jHA3ArPr4QX4f5+AJ/mMezVF6N58f0eU6hF9gm12PvOql8
fMJJf/p8aiqOx8W//hi28UMK2ifxqn0npr6v+7qA0AMMenD+BT0SWCzAvyro
GxBv5vHcpXzZnueiUvn73xGkep6qpF3HVP4+cQS58dY7R/5pnB8RIduvxl/6
3dun4sumYvyB/RB/HvR51BQcj4EPR8W+75uC45FBnx9I4fEWjjz73kC4zEdH
kNGudj22NktRtvB4Af4IrS/0t/B4gesRI77Hx2YFr1dQfoyC+e6dxYdqbWmq
YD5bkH5/S/Bsf47Q4HANNiCG9zlBD/IXKV9W8xfI59h+Gor5HsN6TX4YqskP
w5CH9zkrX3k07WYTkQ9BPgj2Qb7H1qdwzOda8vGQeHU8Lh96db1vOmAD4pZ8
PYD2YP0DDOsf5L+w/kH+C+sf5M+beLyk0ed3knD9A5zK42/p0rmNR0xIUr4N
/v79OYW82jWl7JPWScpvd+uMzDVJIYbfRmdE2ZOUxfR7doLvvkhnr9zIiHwk
/V6kEXmKXUa5vJuROALaZ8nnw/FCBTHV76WQOfT5m0TWfoJC3lR0Ox63JZHx
OxWyPJ9HwRdXEtG+WlNqepwqIeyD+mDfI6LMG3eK4zuKjBsJTOuHKiRCV2rw
hnGJaB+0T/uT24jtg963wdnfFJybiP11zfi8umOPRKXs9/fdNxjJ5LWvm12o
laj8Sd/nN8n8K6Osf1xT38+E+rT+dBPZRL/XlKgcpO/rm2X+DxPax9rX1C9p
lusPEPW1eowX9afS7w2I9lvS7wmYSYvaP/ePfszxWZOM4wRm31/V1B9nIrkf
PPjl3DCu31zwrD2jpr1/16v3ISBpdOYkxn8wkSJ3DLNqVE1SCi5cqZ9U30yO
nrLdPhbFeZ2ZdKTPc3F+rplUNXa12NYmKXeylCpZMadF5m+I+pS3W1B/y6/D
369dY5H5YRZSlr5PxfnnFrSf4rYCj9j/7nfDRQv2B/SgPxR7CQz2/USfT4P2
zDLOqcHDTIiZPSacP7T9JFE+rWKTTSd2m8nuVo235WrMsUFgWr64GftP+T7C
P94Dz09IvSf4LLeNHR5EWWS+svAPrf/FTDrv+mt5vvOJjG9iIdWWZnm58kMi
6gEGPam8qnfc//xo7ymcH2UhxZzH7ePbC7295142arda6AGG/krlVb0G9fZl
fu1KRPsgXtl4mWXeoGlvscaevFbSr+zV86d2Jiq/0+8hW0lArnslW99KVJZ9
/17wVcH3ot9Xtsl8GRsZ2X/Pl9GLeP03VnKTfp9K6En4jQUxrZ9mJTXyjZ1Z
yMT5ACsZMLh5P//snJ9lJUHtOhw6V/3veszfVmyf4pMWxNBfsBf8BxjG49Hr
Z/Vz50xC++bQ9weT0D7gaf8PCP/E0O8/22T/ZLWR3ydv3vqiL+db2Uj5las6
xKdy/MSKGPS6Vhya2KmM6K/E/6AH4wH+gvGA+lo9sE8qr+pJ/lX1Ln0yNko8
moD9BQx6o+67lr9+xrFZYDb+YnwoP0gzfv9lfCH+oD0W/xbi2am0vVt6Ao7v
7bqVRhdbn4DjCxjGF+xh892C9oCe1F6UVeYri/78kx60x9YjwcP6J/FTLGSq
w/P8xou8/heNvU2syIN9UvndFvJsb46tv08XeubgmzPepwm9MVGXElKDhR7w
zD9W5Jm/beSPhqfz7yzE8SYrYpi/lbodOlrmaS2MP8AQL+1G7RrY93AtjOcd
8zeG3ZxXS6nw/Xvuv9lI9q0r3hl7cVxTg3+zIqb1V1rJ2ohzhctv43xhG/mY
cPTkgAkcT7AiZu1ZSdzJ+esWJtbC+JP4/6L35vv36nvaiLXl3qF3Wgv7Zt6a
1jK7D+d32Mj9d2MrNcvNsV5g0Atr2+KnEadqot6wQQ32P15aE/V88w67fvRu
zX/VO0L/ryLan0H/d2LH/lE8wibjXALT+resZIm516RDJTjvtJE/UzrGVH1d
U2lDv+cv7FXo/1DsaG8R+j8DO/L36f8E7Fif4mYCb6f/J7Bje5RfKuwFPfA3
xZkEpu1n2Miia88f1j9TC+2LaVose3jeBLQva3zZyKu+CagHPNg3vVfevXPv
c31iJy9e3Vuwbzm3p6qD6H+6luY2WNgHGPTujsvaI/M+YR9gsG9MyeqTb3wR
9rHvQQr7Bm21typXLIHxL9X55FUh1pjB66fYSSVLiVwLNwj72qUWOJBtNMeK
wKBX8nbgjdvHOJ5mQwz2nT4ZXnnAC7DfJuNMArPx0tRXbORAy7RPJAfYL3hm
v1W2J8WmsV/TP9U+7yUf/RrN/Lv/IF5gfCBegB9F/2fhQL4+/Z+HA8fXj/4f
xynz1x04vpS3OjF+KF/WifFF+SFOnP/ZI77/H0fDH3JivFLe04XrUQb9/4sL
1zOKi2rwJCfilfR/M065/gUnqeM1+HKjcK6/2knWL667Z0hmodd0XNNslaoK
PcCgB+X70v/xusjnHQndH1ypqcTT/+G4kK/0/X85/pHIU7xRlH9P/y8cKZd/
7SI5fwlesPSg0Ks7qeDQY8Nqot6y5TmVGr9yPk8k+Vr+llt05ZrMnjsukjBt
R852D+MZHxlJcg06EJ0vv9ADDHpSeVVvRYFJT8atjGd8p0jytlL64ldD4pm9
lwV/nP4vOYrU/zjL1/sc50tFyfqvI5EHPQmr/QWstY/2Z6GLbMzzuMUT1/++
v8zfkWRPm5MTV/qL/kpYHQ/AMB6dUn7/w5nK8QyXjEsJTPs/0EXczdfLPezL
+dou0nfH1qy5TdCei1zwHf+gRnahN6LMDM/j1TnfyUVuTOxU6Okz8IdTxp0E
Zv53kurLW56IPgr+F/Vnf/+f9XIXmdS3d/LIIjUZriYwLZ/FRR6/TQxddVHo
KfT/AUIvfWCVP7w7Cz3g23//f3ahSOQpHi/Km7//b/uDKE9xd039eBeZcven
rC/T4tE+4Fl7Tk17GnseOUlgnui3+dZz3EKDHzkQs/acpH95y9p26dyebU5y
IjC0xbkmHOs0eJsDMeufg3TZ03DI2gVgj8CsPTuWp/7bbycVVheNfu0O/XOQ
i1N/mTg+hvNZHMSjwPuuGwtxPNCOmMWPXS6v6kH/2fgIzOLRTm799W1XfDDE
j40Ed/hjXqePcaj3tM7t+4XKw3jbZFxbYNaepv4Mm6zfyYbts/kmeDZ/rYjZ
/LWiHpu/oj02f63EdH7ncf87caj3fvfBgr/9JPQkHClwX/5/3fm2Jx7rrJxP
t5Ik3zcdY1qBP6wkT5kv256OE3oNJ16clT+B8/42smrZqaT2XvFoH9QH+zLt
KDXWYxnHjQReyf8nvMJkXJn7nujv22Rdk9Z7hX2AV/L//0aeKeQcMzCe70cW
tB/0oP2V/P+rgDP4/1fBXtADf/yTnuTvH8YD7AMMeqMfbhg8eXcc6t2pP6r5
1v5xfL+0kJBLTaL+MHPsKTDYN/hpWo7QskJvbtZl/UP+jEW9yFe1HX26xaIe
8H78/3k9Rva82jMwjuUP9dTzPedH8f+HAr+d/z9U4rtaSKDXlDefF8fy/ETw
fvz/3cCz9q3Is/5o8GpNfdU+14/2P7OQW2WcuxQP3r8Eq8z/oOfH/y8OvFYP
+vvuZr6C+77E8HxIHY88nwcN3hCDesBn8P8F1t9SbtYXB2+/qMDU/72t5Gi6
r7t+krCvc8+7L/qU4vwuK7lG/w8Ti3ojwpebvz6J4eNnJeVbTN26bx5v74KV
nEx29ctelfNhNtJooO710SvRvH0b2TpxSI0hicI+wNT+NlYsD/4DDP0t0OHJ
jry/RmN/l8z8w+ts8Wj0X82Ro94VmR2Feo/o/4ejUA8w9BfKQ3930v8TR+H8
AAz+k9r/wT7Q+7iqSrNR4/5uH8QLYK0ezA/AMD+6277YnKs57i0wW39EeVj/
JF6dv5UC1+Uf7f9/1wN72foo7Gfro7Cf7QdWme8k/At6X7tH7El2i0L7gGfr
j0Uun0eMn1aP7VcafqOVTF7o6Vc6IxLXe+OEm3/VqxeJ6zPwML5QH9a//jea
X5+RQ9gnYdU+wOC/Cy83F0/uD/FkIe5ZssYW+RiF61/vInHDznSC+LSQs5Vm
701/Fs3XHzPy9fn/rKXyh8ykSHj4pwnu0X/TY/Ekymfw/3ffe9iwSN69YnyB
Z+NvlnFvgdn4i/bYeFnIiuYe7ZKugX8txDix1J2SE7j/S1ll/rWFfO3RY2nh
ZBEvNdMP3zh9VsTLo82bak0YEo3jy/7fLuJlyawiJdJdMagHmOUjarx1rLzo
yGSOL1sQs/xH1Gf5olXmB6rry6COVwcViP1f60F/P65uEGc/yPEMi4xLCczs
N8v96aTBr00a3iS3d9kk+2ejCf3H/GnS+BP+Lx+NetJ4RJpwPNj4GBGz+DZi
eRYfGv6OEdtj66UR7WPrl+DZ+it4tl4qiFl8K2R8RszB3D1g/zKi/0APeBa/
RuKe1aA77Qn7jZH0Ljqy/cilsN+YyL1HMz8ffsX5oiZZ/5nGnjYa+1U98D+b
X6L/oCf1v7eJ9L+54EiiHtZ/E/E4kzh2OoH5byIZu39KvmaL4vPfRAav2lm2
wqlI3r6JlL60fMLdAZE8/zCRdg/fHZ/3ifOrRX3Wvhl5mL8Sn2DWtG+W7Ztk
1oyPGeOF9d+M4w/rC8xvWF9gfYD1BXhYX6Tyql5S8o2gGY1gP7WQvR5/7r+4
RqynsF7CeiDxd0R7bP22yOvTCbG+wXolrWduQp+1Z9a0ZyHjLxW9EmsV6x+s
n6w9s7yehplJyMc1kUd1MTgewLP4MiHP4tuE+Rm7XiZ4lo+asD7F74yI2X5g
kveH60bNfmHU7BdG9A9rz0iaxab7xy7g+l2NZGeDjFZ5yvD23ymI2fU+Bcuz
668K6rHrswLT8mMVbB/0ZPuNJGZPp7mO3Lz/1xUZ1xMY1gPJn56iPqwHEq/O
Xxg/mL8wvmw+GDX7sVHer1U9w+EjCyaegPgWGNY/eX8XerD+SfHqZsJ4h/VU
in9VL4ttwtdrjyJxPZ3evn/H+XMicX0GHtZ7iU83kWcDTq2oW4LrNzLhfszm
g1gvWPtivYH1Sl4v/r5eyeuFifycZ3xoyRcwv01kTWC/tVcXRqGehNX1WeY1
+LOCmI2XQmpX8utWvjqsD0byZ0z5J3euR+J4zDac31C1SSTuH06PoT1bPXHx
8RcY9DZknpZjWRCsnwqp99J1+skuF+q9LRViWtvBhfZJvDq+uW98mextduH4
dtpUoGLrMS6MlyOH0mq7/xSJ8QfrN8SftL6r+4fPzLb3G9eKxPgDzPYDUZ6d
9xS5vtpfGG+YHxAPoAfxAvZJvGqftb6//l4loQdYq8fWCw2v2rcmwHq4QvtI
nL+13T6MbvLOhfMXMOgd+JCr1AKjsM/jdOkl10cJvYxdp9tULCLsg/wc/Ac8
7OftHuy6de+IC/df0If4A32IPwn3FhjGV9JXx1fSV/0n6X/W1L+gsV8d38Er
BwQ2nS7se9Z/4r4Fd11on8Sr801u3yT3f5Kor9WD/EUq/4PeP/lPOv+o68GK
Zq+GzFzO15M8ar5vyFY44w2sRybSLCbeNaktnNfMeF5j65FZ5tPNeD6GfBfO
m2w9MpOzbo0unt0u9l+JV/ff0bn3zzjWV+y/t0oXOD/kA+SXZplX93Opfrqo
/z/VC/RMy2PqGIP5kHw9w6y5nmHG6xmQDwHP5qsZr5fA+Q2up7D5YkLM8jsz
8W1o3tT1RizqAQ/5mnQ9RrVPul7zWcOr9o2JifD5lCMO9XT8ehvYd5tfn2Pz
T4OHmBBD/uLZZVDFknXiMJ/szq+ngf8OzO0w5WqBOMyHAMP4/tLy3LzeF2Ix
P91mGNu6TNU4HI827tM27IiKw/xKwmr8AYb4q1hk/oeUjnG4v0k4UmDYf0/O
PFI0eG0czl/gYX5Af2D+As/8YcT6kL9IvJpfXfqyPPz9VI6tArP7mUYyYOjZ
2r9fiMN8qAa/fg/51e/8+j27Xmkk5fn9AHa90kiO8/sFkK/14/cnIP8L4Pcv
wD7AoHed3++B/G8iv78D5w/gob9SeVVvOL//BHp+i4lzWbOaqPeA/t+3JvZX
wur+AZjZr573ci7s1DyuplKCxlcE4k60fASWP/29/7ERZHyJlysrHa+pVKP3
pwXPcLgGGxAPpvf7w7D+je/PVzQMQ15Pn/8Q/GT6PFQoCZ1f/GiWnLU41iOm
5SeEkpfp5fLP96iFeou7uidE1AQcqsF6DQ7RYB1iaq9PCOqz/oj61B9n9Mgz
f4n2qD/bhJHaDX1nXOvG+bJhZF1G7r7f9FA/VObnhJECUfqbvWZzPjaMNDlQ
5ODsBlDfQEqtKZM7bCjXf2YgZ6ZVjru8spaym87/cDJ4kNeU7udqKb/S9TeC
hLQNvlr8fS0lG12/FOR9abwp5PLHnD1nTIL6EcSn4626u5LB/gjkGQ6Xy4dF
kMoFv/l/biv02ld+96yuk7efJwIx2Af2Myz6w+wNx/7k7Pv9+k8E2nuR7reK
zF8W7VM+QbS/il5fitDgcMRMX9jDsMaePAZyMMhcpdQBsDeMtN3bwvThG9hr
IG4rOg6fUjmB+8NAelSIar3tIfgnDDHoeeVN3JCUP4HbbyB33tX98MYfcBhi
Zq+BTLvVNHxiagLaZ2o5unaHKZyvFk7eJ0yZV2BXghJP79+Gk1URc++vvpWA
/U06eijLqLKJjO8eQeZf27Xr2YcEpRddjxWZ/xBBMsU/LduyTiLjGykksumd
jBOBicq7XfsX/nUkQoPDEc/sPbdBsamiPsPhGmxATOvbDWTFH4VDHdM4/3M4
efs819vlHUHfQOZ28yk0fK3QS/g1JLnK70JPxmGImX4Y+fq4fqdshZO4voE4
MyV7Nn0K+mEafQN5PKrqiUcjEhUlrPcvvk3DZV61D+pT/n44mVQs5sGRw8K+
8Dmdsy7JmsTbDycPq8wsN1iB9iPI7EKLmlRsmsTrR5Can1etJOlJ6L/Pg88f
mXM0SSlPrx8qZH27q/kMz3n5phGIQa8O/d93MtoHGPwnlVfta1r7Xq0rRZJR
r7T1+fQeIcnKa3p9VCFnvd/f+Ll+snKYXo9VyJBSmapsGcxxFoEffEq5HLU5
glwZ/0euDHuyYuJ6wM/m9km82t9xvW/Hdm0DOByxVo/hcA02aNozEN9cG5/9
lZvzgeGkd9kVS+vcS+L6BvLb5EHpfZYBDkM8m8eLe7667ea2SkK9a++bbDaM
57waL8P6jzpX+rTQC2s1+ecdr5PQvj8T59RNKQn2hBP7qW7GnlehvoZX+wv1
Z/PxmHC77acrW5LQf3J9NV4s8ZVnzU1C/z1Mddz40gPqR5DwcxUOlDMkKRV4
vIy4X6LPgJ+TlDf0+rci850UMsnxaYkxE+cvK+RG3VcNFl5OZLi2wKAX+PsJ
y6HZiUoMXb8Ukh612P1Bg0TUu9hw1m1HaCLqVeg2cdaKYonKEXp93khajxqZ
lPdlgjKDrkdGsnX+gIJtjycwfqCRNKy+zCMqZyLjHxlJ8WLrOz724PX3GwmZ
fWnM0RZcf4aRtKzydcWSJdC+4Cl+rSCm9p5QUI/1x0hOfNu+bXhNoSe1l8Uk
85eN2B/mH4FBr9vz1v1PZiQwvFFBTNtPF/6A9RT0wb7+j/d/rdJd6Mn+NuJ4
gJ40Pq/FeIIejDdtb6GGV/Wc/tme3ajM+TsKmbvi2tnMjxKVZXR/U8jbCls3
ua3i9roZyYq85OO+c5z/rJCEyfeLz8ufpPzOr+d8/SWff9/IJCULv56zbIl/
bNrwJMWbXy+p6V27lf5QkpLGr0d83tp/WIksycoImr9qeDU/zVmq0fqMx0mM
V/PT9QtGnNpSNVkpzPNTGYcj3srzF9AvzPOXJcrShe/Ck5l+WYXUqbHu0aTG
yUoRjR7Y13T0hCKJ0cnM/kOKzP8X+7bQfE3oU36Lgu1v4ddj446d2nuhV7Jy
hz7PqZCP8W+ubNjGefX8YW32ZHLRieAfI66PaTy/Bz6N5/dSefU88+JFoQ2v
zgi96d11p8/mTWHtLVWIOXP9x2ucKUpB+ryr4CnOpCmv2nd3tPdwvwdCz3th
FdOkfcmo90eN6HodvyajHvCgB7gXzf8j5PKKQsYUT1pUsFKKYqDPz4r2fqfP
X0cQffZcrRNWAA5H3JPrQX9BD3jQA//R8j5i/9HqMWxA7EPPFwa0J50+Dy/4
+/T9lTDUM9L3GcKQn0XfX9DwlcX+xeobkKf6B8JxPFn7wl6GwzXYIPenoaZ+
4XD0z7/1l/kzHPfvcnQ8IzAfuM3vLwBfQDO+Pfh4SPwP4xGmGY/zfHzvv97p
P82H8ykKmXn9YI+gJF6fKMiz9o0yn8mI+2sBHn+AafkHYv7d5vEMeDOPZyg/
nM83iVfP+7CebObzF/BwPt9g/tfh53NYP0BvV7bW77sW5Lw6fzu86GwoFsRx
WYFBr3T3mamvOwr7JP4HveF8fZFwkMDMfkW254f1arNmvRquWa/APuDr8PVP
Kq/qZd90MXun+X/Xa8mvHwA+xK8fQPvl+fUD4Hvx+AP+Io9n4H15PAM/is4X
A/IP6PtqBrTHxOfb2rAvFeKvq/kofV8vTOYXG8iOOTciCx3hfJKBFCy+3dt/
JNQPl/XfhKN/WPsRmvYjUJ/hcI094WgP6MH6z+wJx/0B9CDeWf0IjFfWn3CZ
XxyB9dn7MGI+sfdrxP7C6ov18wN9PzQCeYbFelKLvi8bLpfPGUEWXS71Ydxb
zm8LJzGNjEXb+aUoa+j7vOEyr4sgqYfcwr1Lpyi96ftOCsm/zmPwKSWF148g
javmaP4iK9SPwPFZQd+fEvHWh77/piAfR9/30/AHFPQ35WsY0d+Uz2pEf1G+
lRHra/Xc6PtHRrk9VQ/sBT3oD+gdmBF4vFVTzpuNpI1b2n3nQs6vNJKK+Zt4
PDzK+UFGcnJKuuNw9lTevpEMGDBpTOMaqbx9E/Lv6PtPJvLzqoFZ3G+mMH6C
iewLWF42xy+8fisTabX7jP5uaipv30SK2d4l7Z+Syv0p+Es0Ho1YPxt9v82I
vC+NLyPWr0ff1xN8Op0/oj7ldxtJXte8jGbvU1j9yiaSXH/qhGPnUhj/xUgy
P9y9Zml+Xv+ikaxsf/f4kEhe32AiDeo8K1ipA7Rv0rRvIntPl+k07zzn75lI
7rtFPLOsgfZFfa0eba+4iWz57fAbawDHU4yIwT6p/01EedaeUcZNNPieIuvt
VtAfrD2F/Lqvx64RO1KUbfR9cIVs09Wat7JPinKPvl8u5gfl1ygYT5QfpmA8
Uf65gvEE43HpQ5uOQ59z3kvEE/QX4om1L+KRtW8k3YeEF8w9Cto3Es/29qRl
61PQf7drx82yXUrB8QAe/AcY/Ad6LL5EeRp/AWbUo3iTScYBAtP4naWp39lE
Bj0orz/emfNXTUT3W7X+zWf8XY/Fvxnrs/lnRvvY/DOjv9n8s8h8DYs8f7Na
0J+sfbPMmy04Hqx9i2z/GzPyrD8CU39FmXH82HwSPPO3SR6fiyaZN5jJqDtd
t1UqCvNJU7+PRv+eGftTj78fL8XXFLMcH23NmvgRfOHv308oJ3iK55rk8jnN
cry21bR3UcOvEeN3j3//APjC/HsP0J8I/r2HGrl3rjA1T+Xtm8nNNwde3hzN
+e5mMrLP47x7j6cqrfn3LYCf/n0/chf8Yf69jIAcharNzlmb8c3N5NHLku1C
PTl+aEIMenOuVNz8R02Oz5oQg321Dtf41K075wuayXJD9hvTQ4WexP+gR+tv
E/WZvy0y/8FMHI2d57aO5Xx9C5nYQ0kv2ZLjG2bEoCfZP85MIpq/rln3ZSrq
gT/+yX/gH9DrV/qnO19vpaJetUVe366WFf4DnvrXqOGXmUnn7ZW3h/8lxgOw
Vg/suz4m2NrLAv7WjNcyDV9Q+IP5W/Sf2rNP9B/sAwx6Uv9VPclf3S3kTc3P
0z4Vg/HTjM82C44fiweLPJ5zRfl/G18YD8DaeAH/Sbzqvy8xNX9O2vzv8ULn
2xGLzKv2vXra7tnkk5zPaSVLL3X3D3hVm89nq8zbrXL9chp+mKjP2reS+AZz
Ywt71+H+ETzztxXtZ+Nn0cwXq2b+WWQcp8FnNf5aJvxxmH8/B/jX37+vkyr4
8vT7PWbsTzT9fpCG7yj8TXmXmL8UHxfzvSf9HpEJy1PsZpLrjzSRDSF16r65
DO0JTMvfMZKf1gcYi8+B9kxk90zDsE0HuD0bTKTjUNupmo94f0qaSdUOsUX+
zF+H8a9M5NxfXbzPRNbB/pYp0OaRT5U6OD8kfrqZ9Bo4K3L18DrY38p5DjRL
P8T5P8ykffkdFZ7N5fWNFrIzcP2VmJ6cL2khTfZceu+xVegBZuuvhaw7f3r9
mPF1+PohysP4llp+03Diah0cX8Aw36Ty40T7LP4taB/EH/BsvRTlIZ6l8mo8
H546MXuBRn/X09oH8Qz2aO0DPam8qnfQN2ft5SXT0L4C9q9F8rz5ux7MD7BX
21+t//5tPFj8C/thvkntxWns3WYlZyY+GtQiSxraJ2G1v4Chv4P7vjqW0z0N
+3v57YnV1Z6I8Rh788LrIwWF3r3kNZcenef8XCuZYdr6y/C/+PjktJFYT9Ko
Srk0vh7ZZN5uIy+3j8u8Yhf420Zsvi3vnegH/raSWcvMx56ZoH0biZ8YVWBU
c17/iE3m52rqd9fo37CR0DPDduaZCu3bydC7fbu06VCH5zd25Fm+7ZD553bi
02bx+Mg10L6mvpcD5yPL1zT12zrk+nYNv8Yh2zfMgf5l7Ttk/x1xEMuJayFN
g7h/vZzkr833+2VLS+P+d2r879T436nxvxP9x9p3kvG2hnM9a9dBPQmr9sm8
wNDfq3VSUscGiP76nfc1rH9fG/vb56H7+8K/1UY9WP9ADzAbPzv6F/RgPWT2
O3D+s3iwIwa9QqtH7m1vEPal7R/Q47efhV6OyGWT1yUIPYkfJupr9cA+eX0S
etBf2E9ZfDnJrC5TcnXOVYefB5wyn+Qknx4eavWyFed3O3H9ZecLgUGvdtrb
U61PCz1Yn9j5wonrF+i13eHZdVhSGo9XJylhTpjQZCLnvzjJKc+6GVm3p6Ge
hL84ELPzpqjPzptO0iglMupImzR+nnQhz86TLqzPzl8u0m3LoDe33vL6UYIH
Pam9xU7itjhoV+XenM/rIhljI7IcnJ+G/R1YomnZBddFfz3mj9L3L10X/QcY
/Hex2sakeil1sb8VIlYUJH51sb+Aob+tE+Yfr5BP6BW/duT+N6fQk3hVb2uL
aYMHPRD+Awx6WfqNDb+3Lw31VuXcUvvAV9Hf92VWF638h+ivyW/R6aEbhf9G
22cOfzia4zdOxNTfaap/0iaYXM3FeHhdaFWldY0f/Pcj/4MejMedPZ1b547n
9lR2kZCgmDiPoiJexq6uGhBzicfjRafMG1zkefnkKcdDeLwVdxHLNJ+eTz/X
wfiTcHGBYf2T6icJfdaeQ9OeU9Oek0xb3mfDsq5puD4DhvGQ+qeOh+QfNf4k
frGmf300/U/S8Ls19kwR9sD6DOMJ67PErxHtg/8k/rnQZ/uD8B9bD9X1v0Du
evkJrF8ucq9S5hLtZ8B66EKe+dNFYj8WXrTqHqw3kSTbvdKPXXmgPy7ErD8u
ef354sL1B/QgX2H90fDFI3F9Yv1x4frE+uOS86+5Lsx3WH8i5fzthkvOz7a5
NPmnS87PCrrk/OyhU5NfueT8y13Yw/JjwbN8W6y3LH93yuX3ifWZ5X8Cs/zP
SbafqeTzyIeXHyDWa60eO/84sX12vnDI9qh6kO+BnsT/F/vYecApnw9KOjX5
6d/1IP9m/nDIOFVgZr/Yv1l7Yn9l5xkHaVap8cIJmeB8ZEfMzm92LM/OWwKz
85soz853Nhm7afBCq6yf2yaf90ZaETN7RHnWPxvmJ6x/NjzvgR7woCeVV/Ug
32H9s+L5DuwDfin9nq8V86UL9Hu+VsyvKL/TivkX5SdZMT/LPOTZyl6trZiP
Uv6CFfNR0ANMy3tYMd+jeJUFMS1f1Ir5JOWfWjBfZ+0JzNqzYH5P7Q21khx9
ExOrj+F4p0XGoQIzf2jq97KQpbmrvF5dg+NPZsS0fCMLSXvrFRIVz/EdM2LW
nlnWd1PPZ83rzTy6Ueg1+XPw1iUvwX4z8sxfAjN/mUmhm8H9HncFf5lk7CGw
F/0euYk0Sy7UKK+e48FGGWcTmH6f/pqC9eF79YDh+/JS+dkK2dD6p1/aFuX4
F4FZewr5MuDbxTPPa/PxU4hj6rtxvsdqM/6gQubkP9u51ijOexhJrb8ydvy5
HuLLiDzzl4a/YCTL22+YU6QLr7/KSL49SB8YqBN6El6lIAb7oL4X/367pNda
IW+GLE/pEgvtKSRi5rzCl6oJvUduR7w2N4X2BL7Av3f9/zj7yvA4cqXrMDMz
M6Nj9tgxDHnsAdszpjAzM7PDnDjkMDOzwszM2XA2uCGH83UkVcnS3r373u/n
eY50VCqVpJK6p6eex75nBfyF3t0Dj9J9HMDbCxR8LP++t4x9FeyDeDv9/rwP
6lE+sy+pfO3Wvkgn53f5kEuN0tyqNz1al4d//x74Dvz7/IMsWxf1LhqtO06/
b+6N/HH+/xCAy9Lvp3theYY95fqhXuRkszWxNz+6uL438nn4/1cAD/YBr/Z3
O/8+f8KGmafd00H//IT/s7Dv88P4XOLfHwd+Gf3/LVF+Gf9eOJTvw78XDuNt
5t8Lj4/Z/WhjIucf6kimR3+kmnSN19+tQ/4SH1/gU/Hxhfi/xOMF5gvYBzgV
jxeYX6AH64eqV53Hi9SeFn97z/4ZXOMHtyefv2xvPzFfWPv+OB9Zf/xle6eJ
+v+rXio+32B9rM7XF+Cj+foC9aP5+gJ4FF9foPwW/v8GoHeI/78B8CX4/xFA
/Qe//7+gglhPDvP/SwAM/68B8/MI14P4gP83AJ79v4AfmbrmlXHqYs7/9MP1
i2FfxOz/BnyxPfZ/Bb4Yb+z/f3yJ8cdQ75l5ovn/afmQpO6xpXZecXHsjZj9
v5Y3+fSifrpbs1z8/1S9iblZzmffYzj/zpukthSqMWcI5xd7k9VXfY199kF9
H6yv6rH/J/Ih/qmr7/PuBtgbMdP3Ii/G2G8W2fB3+9j/M/jIfAo96K/UXor+
qvax/in8Ox8S0ahFy6hv0D8fpX++Sn1fxT++ZGbvDIvi3YQeYGaPUl7TW3Tz
2akSJYV9gFn/fEnUkb9y7w0Uemu9T328m1HYl3bLkhupTjn5/9cKnv1frQ/W
Z9gbMfv/Wm+SbcPXqJi2gL0Qs//b9SLb3Et391ju4v/n7EUaHwiZVPCR0AP/
MOyFmP0fsCfGC8MeiNflzJng1coD7WH6nnL7mt6BxLTzv0wU9vUcke3RzK3C
vtPfHx/b2RuwJ2LQK9N9/+pbXry9px6k94tZE3/8dOoyh9c5U3KWBznbtGu3
kgeduuaTInKlMwieYXcFN5DrF3In1a8uvDKnnIvxJxqQYaH9du59CvruqM9w
A6W9BqTcTVOU/wihd+OwY969VU5urzuZsD7u4YDzQs/dffivmOwutE/iC3mQ
hoktKxf75MT+fh7eqdOuoi7UAwzjAeUZdpfrt3Ins3Prsvvu5LybB7F819tv
33Xy8fEkaZ9aZ/dNB+PlgRj01nbqvdXpD7gBYjZe7qRp9JBvn1rCeLmTHRei
7xWqAvY2kPkUeqy+6B+Lf0/k2fz0kvnLnrL9WrxI/tDiZVH2GWNnOV3YX8D/
5D/Znr/rQXswHku6lWnwc6ET54crvuqAucfA38KfbDxFf1h9T8UfXqRgUIL/
9HEwn7xIhz3Nym8Pc6GejD0Qg32yvz1QH+ZHtofLC15ZLPSiPs+/4DZQrAfA
w3pw4MyGuG4nUsxfjnH+7ti5OPcbMX9L+d/f/6ZqNB8/b3Kl6vP0E6zRuD4n
FHhnqtYrGter++NP1bR4RuP6V3Xxwefr80XjfgQY9IYUmXvmwjWx3p+uOXVU
3U1iPQUe1mfgYf8AzPYfX/Q3rM/QP7b/+KE/QG9bu7N1N98XeoBhvYfyYB/w
uD5zHtfnlOW1/sJ44P7B4xX3j5S81t/UQ468yrc7xX40Y8/yntOhf35k5urN
Ta53cunajey7I1stHfK+T57NSJypw/qU76wjqzO/zPw+Gf6v0A8x6EF58B9g
lq/4yfoFddj+Na7nX+/mgG1rXLo6XO/FnlSJ0567dONp/wQ/nvdXKq+Nx6cS
Dw85LgL2Rcz0RXmGfRD35/nVOMOFBoVGufj/Y/nJfE3hr9I8X3tAVhX1NLrw
/61gf4D/t4L9wYf3F/i+XA9wSa4H+80Drnco1SRDoxtOXU6uV7h3m+pD5jox
PwXch+tB+cu8vx3GbGvhU8ClqwnxnOfOkKJ2wD6IL/N8smnFy14DqnNe89+O
+WtLLnj7z3rQXgIfD4nXxgP2Y9ADDHrX4o//1aeJ0AN/XObxAv4F+wD3Ufyn
6lF+vR+OZx9lfMF/UB7ye+BhPNwuJts/HXLheEA80nz/rA55+P88wPD/eYCP
8PPC/egSnS+nEueF6UEVt3WtEI3/xwc83JcAz87z/sjDfUTVzvmruN1y8fus
AJl/6Y/ts/ueALQf7jcAs/uqAJK0PPP9OjmjUQ/mD+gBz+4b/OXyKfTAPpg/
qh67/wqQ+RT2wX0T9B/0JFxNYLjPkfqv2ZfwMHDcJh9xPyTh9gLDfYnsX53S
nk5pT5Rfzv9vDPjl/P/LAPfl531jrVrfc5nhvlMn+0/Tk/zdXvBgH/BwHwb8
Nv5/gVL5dDoSMSVPhQv14L7Gj/yi31MSemDPv+lt4/clgHPz/0cEe7bx/5OD
/SA3/39EaL89/3864I/x/7uT+Lm+JMuAou07RXP9dn5kf6tym7IPjkY9wGCf
VP6FL2n84UPY5OKc1/qbn34fSvT35IkMt8+0FvdhgGF8oTyMh8Rr4wH5C9zX
tYu81seagWOHwCv4/RDg5fx+CPZ7Nh90uL9DvMD+DXqQD4Ie4LS/76ecfpg/
gh7kd6AH+R/EX5nl7dtF9OC4mcBgH+Q/oAf5W1p+Hybxmn2QT0E8u6Vfmrfz
D65f1h959vzAH+uX4v93J/En/cm1yT02vk/k9RcrfJYA1Ac9wP+kB/lhKf7/
edCfUvz/+ACr9vXl/xco+SuF/0L5//uBvaAn8Zpe7xLBYb3cwX4FJ+gUXmD2
PEnb/+v6ZL6Rx8WfT+lIDkO9Q56vnPx5nL/MF/bH8Wb+EPWZP5R4WKzwmn2g
D/2FeIL+SvXL+sv1E0R9GA8478B4rL+Srsm+BCeOr8Rr4yu376+0H4DxDnoS
NgoM9sF8AfvgvAP2QX7P/K1gzX8yLzBrTyf7e5MSHwk6Jd7/dz2p/wk62T/a
/G1Osi+P3eDE+burwdOEgd2cOH+Bh/kLfDxf/3KtJx2T3Jy6nXw9bVkh0Xbw
S5SuJt8/NnpNzlbucpQuDV//voePPjpiHee19XTZjXUPmr3gvLZf/vV66dwj
R6J0V/j9rne6eZEVkziv7b9Pxh3qmv4Or39YJ/Pafj6q8LRcY/ry+tNE/RX8
+Qzor+D3xRL+Jtrvx+cv1O/H4xmwhccLlC/N56/Ea/EypV9PT0Ozv+vR9rz8
sT/Q30n5/5zwsLAT7btV5Q990Ado359U0F1Ps/wstB9AukSc25NpJefLBpBj
p1ckVWkv+ls8cOhwc01oP4BcrDH25J8OoQd4Bb9vr7Ss+bpshYT/Bhb3nVLj
ViQfP39yeVrBnuHzIxmv5WslV+Wotal3JO9PAPKgBxjsk8pr9p2oU988aWsk
2pdPXy3Du4mRrH8nA5Avzd9/BntK8/eLAVv4+8pgf2n+fnG33TGtO777u14/
/v4z8GCfVF7T23feVub8aWFfa1cf33WZo1AP/Av2SXyWhli/NH9fOfMTw+3a
yyN1H/j7yo5vuhlTh3DsEhj0VnUt0ndrIOdnNyQfR+WuV7BkpO4Yf18Z+ET+
vm2juLLE3pbjZw0RH+PvU2+9/H1xj+pCL6v56qiZbyMYLiww+K/JofXtdm6O
wP5u9xwTdqtnBNqXJnxwZh9rBOqFtuh1aH7VCOzv4tvhy8lrB4/XhuSLvcrY
Bxsd3N8NSdiptJ3S9eB8QkOSeP9rpZZhDt6+4EFPKq/pLQ24Y6vgzvlNDUl0
9SezDscJvXTbsm1dlPh3PdYfUV/VA/u+7dzmpv9mR70NS/b3f1JK6LWYePzg
8GAHH79Ama8TSDIUm9040yM72gf4A3//2Vp7UpG2++yot3xFm59jh9ixvxLW
xgMwjMePkg0frA20YzwDD/EsYW2/lHmBYf0DvRU8/wN8hedrUnktX3u3t/GO
VzF/1+vH8wO5PYE/6btMMAb7yf3R8pfYqV0DqyyH/utI7oH9Eo6f5ry2v7X6
6Oj450S7bm4mi6nldD/EzN86Uux+3JbRW+26gONVMg1t7od43u/y+f3I0dbD
z7d8Z9d9/t3+UV/k7WOmXajRyxf5db/z5Uq+pPNfq14G1nQwPtmX7M6waNky
zRGUX+GL9jHso2BvBXsp2BNxZpqPe6J+c/o8WfAMe8jlr3ugvxh2R0zLj3En
m7KYK5nbgr4Hjifogf/30/OOO8ZjEXpecsf4p7ynBwk+t/btyiucf+FO5gaP
unxqFtT3IE9jBk6o3g3a90Sete+F+sy/3jJ/3QvjidX3Ivr6nnNzlhR6gJk9
nmT+mryDaz+woX2AwX/PD2TxnLrHhvb5eTwqvnWQDfUSLLeuFYi2od79I1t2
uxe38f55EDefCQui71uxv4BBb4hthGvPLivqAQ/9BR76e7pV/7wlpluxvz3f
Lqr5/YIV4+VA+sTncWusPB59SLaikxfvHwnYGzHoNZ3SdtQfBs4ne5OCA7qd
GdQJsBdiFu9K+RR6DHsp+l5k2+Lt++cdAns9SeNqd2/1S2XDeF7tf2X6nZui
vxEnv23cXdCG9iXde9eu+DthH/DMHh+SZWu6zy4fG/Z3i0/VfO59ob7gWfve
yIP/ZOwp19fs+2Urc3a2w4b9NbYuPPpbjb/bB3rAQ/xJvNObvPjwvPyg03y8
M3uT6QNyBcRlFvZJ+tp6IPFOH6yv6kF/3bL8ce/+MvCXKA/rFfDz+Pon8dp6
Cu2F8fX0/pSM3/c9tOrm8/UP8BdFbz7XG1Ly+uyAIVZdGb6enq53zr4kxop6
Pfd+7DR0FtT3Q95B/euH/HraHz9SKrjYuMZXrLos1D++5OTZgBW+eWy6Fvx9
mu5RbQ4XC7Mx3ulHKgd0zbK7O2BfxKB3t1q/cFciYF/ETN+HjN66sH2Da5zX
1mefpFWbrnwH7IM4Cx+Pp5UunN3sYWf2ZPYhkzcm/zm5p11H6Pz2lvkxPqSO
7/HR+fNx3tOH3D76esn7cKjvq9T3IV6eJTJ23mzH/r4tVzE0xw2o70sS14a2
eZnfwev7kccHA8ta3go9wKoe2CdjL8RF6frtJdf39Fba8yFhsyLXJ3gB9kac
hcczlM/C54eMPWU9bf2T+6fwmb0UfS+Sblijj5WaCD3AoBf91f2GsZwD9TZ0
ybO3/VPeP219zvD8RdKEVXZdT3r/p+2HjY8M39AB+q/tn6azJy1TAXsgpuWL
eZDdlz48qXZe6HXe96PaqY+A3REzfXdSJKScYWUdB+q1iC2aNmt2wO6ICd+P
wF6G3RG34PuvVF7bfyV7ND2wF/SO1r+W69WOv9vHcAMFuyn2u6H9F+jzBDdy
+JyxxahODu6PBiTnY/+Szw0O1JP4uQ1IR2eXIS3WOFAPMLO3ASnbsO+xtBcB
uyFm9ov6DIv6zB8NyM4Orb2OjYR4EOXZ/HWXeac72stwAwW7IWbrhegPw6L/
dP1KVsqvcFPacyPNPk2IWnoI7HUj2Qdt7TYsVQQfv/pke8bbE5v4RPD+1ydN
JqVZ49c3gvu3PslauPLx4tsjmP/P1CNbF4Y9+vY+QleNPk+qRxpV6ZnqZq1I
3Sj6fKoeybx5brEdHSIZ/7MecRyferWwnvPr65Gf4bveJQ+P1D2gz7cUvmZ9
suBOwqR+ZTh/vx756Gjefd7jCJ0PfV5WD3mG68rl/4Me2AN6m70Ouc9YFYl6
cYefO7o/hfr1yYob93NcPQD13ZBn/XGT+fVuxNY0Y9UtPzk/sAGZ1+vno/w3
oH4D8v71teMN5kL9Blif+dMdeYaV8in0WPy7k2fjPs7vtRlwA8RsvNxJ3UUv
nTfGR+J8G7j9YR6v1pG4HlTSZalZeKnQu3i8lin5j0hcX4rfrZjetScS1xeJ
19ar/taoVldKROF6Vdu78dpugVF8fniRJxXavM/dNgrXP8CgN2n9xJxvl0Wh
nsRrenNyd/XYMPHf9WB9hvZhfZZ4LR/ynh9wrW51oTclf7HdEW8jcf8ISVU+
9Yf8Qg8wmx+e5K/RpuIXbYA9EMN6D/pZeD4J/HqerwHv4PnkqM0ek6dnjOL5
iA/618HzSfAv5YN9ybGWltINvkRiPpSnf9CtWZciMR9q/b7E/l0zIjEf2pyp
QJ9iXTiv5VeZB7+J9a3H9bXzIPCQbwAP+YZUXjtf7mv7edFt19/1IL8Cvgw/
/3aLSP287yDOa+dfiKcy/H4X7P3I7+8l/p2or+oF/j4fP/JDvID3V6qv5X/g
T6o/W4f+Br07VfL22H5S2AfzBeyD+RLG758v19j7Kbaq6C9gyCerLJtxc+Dr
CMwngYf8D/Qgn4T5t54/34L+wHgABj3w7wB+HwH+D+f2wfdIy3L/wfdMP9H7
HX+Zr+OP3ysty/sL+J/0oD3QA3tAD8YznD9Pkfiu/lhf1Qvnz2cgHv9JD+Id
7AMMenGTvad/XSvsg++vnqD3h/4yP9sfv18K9sH39EAPMOjB9wM/8edREnYJ
zNpT6s/WKe0Je8N5/EH/1fGNoPPVjzRKPq5rnByh28DjBfis/PwB9bPy8wfg
DTz+wJ8b+PkDcFZ+/oDx2qCsB6Anta/pwfdwVfsi+PoC+CufH/keXBj5s5jo
74nTN0/PDRDxB/MDxhfmB4wHzNeyyvwN5usB4IV8PYD5/p2vV7A/RHH7JF6z
D9YLK7cP+HLcPli/k/l6Bev7Sfr7On+yrJujWefenNfiJfx730GWrZzX4g/2
s5P8+SXgefR7KqJ8Z/p7xwDkG9LvJQTgflaA/n4yAPvznH9fSuJLNkR7af3P
AbjfFeDfgwJ/0frHGiK/h36vIBD5ifT3o4E4Hk3p70cV/mog+ovyPkHYfn36
e9wg9Fcm+nvmYJl/HITt0/p7gzCfYe0HEd9054bO7snt6xhEpvVb0XK3B7c/
ROHXBWH+ROsXCJb514p+ZDDmV6z9YMznqH3lQ5Cn9o8Lwfq36O+5Q3D/oLi7
wOvo989CML6H0O+f6TH+KV9MT0oGbtmwLz3nh+lx/6B8rB7rU/16Cj9XT8YU
Pur9LVzoAVb1HPR7boKvSL/nZpD5qgZsj/JTDGgv5dsZZHsbGkiP3eOn3T8e
wfjVBkLOD7cELI5g9fMYSdYn/TItGaCtB7+/19jXiPwZ+v1bwSfd39I80mAi
kd+6Hkzv5PiEEXE3+v1iE5aneIOoH0y/ryvqUzxLqd/ZSNZ0NS+rWJTz140k
eVTDxmM+Ohh2ClyYfn9XlKdYJ/BL+v1npfxgIwn9VSxw9Q4H458aSZo/yycY
7jp0++n3X03IT6HfmzWRWfny/cw2VTuf0e/NmsnDyll3dOzg0LnT74ebSQ2/
NF3Ph3A+3kyuH6s0Yd1wXt9N8FQ/p8L3NJPxm2pfNq/i+JMJMegFzPMs8uKc
0AN7QA94iiea5PL/QQ/ap/YfMZOyd0rqczXiOEjBR0yIs9L/ZzGTju8KpOnq
wfn0ZlKon0+J8J5c/66JHEzb3LPGZqGXvXDMh4njef21ZuKsYVv3Vyvhv3VL
q07JW5Xzr8yk2aR61zeGC/t2Zsyx51Jerj/fTHIOerrg41U7jgdg0IuedtcV
tdGOektXXsm7c6xdd5f+/0ooebvv9JkiLe26jfR77KEyPy2UhNX5XnPmcV6/
g8JfDpX114aSdMXT96z/GtpX+Fei/r/pUXu8Lcir9g2n37u3YPko+r19i8w3
s5BvpdYn37Rw/pSFbMi6w6dPd7uuCv1+fxhp8YkMK5ho1/2g/y8QJvPdwkiG
YZNLz2nA65sEz9oPU9oPQ/9TnFVgWv6hBdtj/bEgD/0FTP2RT5QH/+3ukNjK
I074DzD4r7Nz8dprQ8X4Agb/lW+45n2PFWJ8++0acW1mO85/DyVHz/Wf/CVI
+A948F+tpROKu00GfwhM/bXZQh5PnNns8jYxHl4Zu4R86sP59xby9q8+46ct
EHqJfZNWdr0txiOsxco3udI40H9fXp3L+sbXgeMRmPbYkfDCDhwPqf5mpf5Y
pf77MLLu+nXr+OZCDzDoOZv86tBuoQPtk7BJYIg/WC+hv9sv1zj/NG0E9hd4
1p6C34cqvMA0Hm+GynqbQ0mTuIiXR3QRjC9iwfX9PP1/Dguu74vp/3Mo/EHR
PsUBCj6otJ8Yiv39J/tgf6A4WsE3zYiZ/WayuOenimf6cb5IKHk99tUfNSJ5
+0NDicfCR3Mm1RJ6EwvtG7TpvR3tg/Gn/atsQZ7ilUp5TQ/ikeI0AtPybUIx
fpk/QsnIYq1TOx12tA945g+zjIuY5fpDzUp7AjN/mNA+5g+TMl9MynwxKfPF
RILb2Ltsa8rn52LBs3hU8GKjwhtlvbFGbI/NdyOZPNBYtZAPrFcGxCz+jXL7
mt7c+9UirpcXek8/ls3pmUro+XT48S7mkI3bbySjh35Ys3eejc93E7k080XL
kr1t3L8mUmLtg1JDbDb0X5uDN24+qGZD/+U1pUombTgfYCbxjZM3lAm04Xhk
el78TKohNhwP+898o5rG2Ph8EHzPeb0yhVtDkaf4glJ+pZms7PG67fAS/7se
i89Qub4Wf79eHrMs+8OK80PitfiD/kA8S/3V4lnyhzY/9nts3pfurRXnR5aw
Vb1bnrSinoQPmhFDPDc+Oix29Hgrn98Kr9kX0XxhneNLhF5Sn1kvKw+y4vz4
9LbLeVOAFe3zz9AmYW0xK/YXMMy3cUUbB+ZMDuf+Vnitvy8mTFw21mVF/0lY
Gw/AMB7TC2472GaGFeMFMGvPTO5XW9v/VGcrjm/VgCVu1U0cWwU2/P4/tR1K
+clmkrD10qyVazn/2UyunDxpyzraqisW5zjSrnEo8m/o/3eFynxSKBlk/6vj
88O8fu9QUvl2wbHHUot4kfgdoeRk62eVTAug/VBS6v6BbB2aCv8BD+PR/a8c
QZVvi/EAnq0fZqzP5p9Z5uuK9mG9r+f7dcuoP8GfFuRZ+xasz+JfseegsBf0
ekbNeTuhvNADf8P+MWTngCJhOay4v0m8tr9BfdgvT5/tfnnDs3Ae/xZS8FG7
CXkOhaMeYNDrEBPUtd7IcNQrE2zZcXF1+L/qwX7Z9EtTffd5nE+0kB2dvavN
aByO+3mOZ/lz7SgL7VvIoYslIiMNQg8w6EF5Ft9hyLP4Vspr+3lh42eP3tmE
3t2hi73qLQjD/gKG/kJ5th6Hoh70F9qH/VzCWrxI/YkOVewPJb33Vpz7oWM4
ju/ZeqkHF6gTjuMr2ft/sE/iNft6rJ28Ptkehv3Ndn1Q2d2ZwtB/wEP+IpXX
xrf03MBeXjctqHcmIdl3UGML9hcw2OfWOPOp3ast2F/A0N8F9YtGff5kwfkG
GOabqdzZEt4DLLj+PbDsmfKr9v+/3vvg1hO3dA5DvYQukWl7lw/D+Qb9Y+uH
Fo9H67z4OcHC1w/Rf4rdLXL53BbsP+j16bMqw6EnoaiXa8msviPnhKLe8rMj
XxvCOT/ZQux7PbaNv2pGPcBsfbOQPVNMASdLC73WQ35mzrHCjPka8LDeA4b+
SuU1+36tfjngQqwZ/Qftgd6fTytWsY41o31D8hSYn0/H7fms8BcsxPdL96bZ
0/P+uYeRK/z/tNl6HUba8//j7vU7f0kbTtL2Yf/X3XhCoQOHGoSTxMXV6xS9
btIZfsdvO4WPCifr+f+BU35sOAnm/xdOsUlgVY+2V1bhNb07/P/HKd8wnNTm
/58+ocaqB/VrCZ7afz9MLq/pdef/x/5PemP4/6lDfwEX5Xr1E+v9WFnSiHrz
OwWPedLWyNrPFU6M8V/Cq/xlQL3NdbPeaeltRPsaldm3ZNVBg27p7/NlsXCS
NXeX9q/1Bt2es17pVmRSeO9wcjz5XK2n2Xn9zoL/Nz0jjdcwxL1oPIRh+SV0
/xL8En4+AnyBry9SeW19BnsonyaMdH8y9HOVaQbdT77el7pSn3QsYtBV5eff
04eejdqUpGe4roK19Q+wk69/vTfNCftUgeOsCh5rRjyC5tNmUm6hpaDn2hDG
a/v5+J6NF/f8zLFJ4Kr8vPXJ1LXm5oZCzxi3v1WnvdCegrXzB+Cq/Pzxx6i1
t+p01bP+RovyP3k+LpXXzjPzO2ZLqtrA8K96Tn6eAXtH8POMR4u87XYNDEH7
FnmWT/50gvdHy0+z5mowrG5+oQcY7Ov+WJ+zc2Pwv5kc/zQ9pNpNzmv5bqPS
w3e/maD/mx74b/vP58Zec7g9ZQW/id6PmLA+jAfow3hI+lp+Bf5Xx+MnX++h
/xf4+gfje4Hnz4B/8nwc4gH0IJ5Ar/7sr3nfvBD9BQz9lfxvUuLnP4wHlKf9
729CvXv0fknh95jkeC2rtJcinmF8pfIPTdgf0IP5RbG3wGDfmFUh5tUtDKgn
8ZoezFfo753d04a3umdA/wVPXpZrSRUj2pe46L2+8RIjjy8zqX3mjz1lXUYe
X6Eyr43v6826IcVKmLi/Q8mIuzU+3rsI64WFFMtcvM3iUUYcX8CgJ60v2v4G
6w/owXqq6i3h+Tjwvfj+JvFaPtm5SNuFjVKbGJ87jNx406/6XDPH2n4JGPSq
pz7RwnnUhHozrt78a1puM1tftf0S+OJ8vzxcdfuNov1MjO8dRgr5pMtz/QPH
2v4LGPRgfwU92D+NPN8ADPZFJYz7lHeeGe1bPedGjfMFQlEvX5cXu7I1DcX+
kkbzh4Y/M2N/K9ffkGN83VC0b0qWg4knBvL61jDypGjOSyM+h+L+EfZXqUYH
G1pwf5Pyq89hmI+yfCIMeZbPhMn56lCFfx6G+dju3/tfJaGv6vXk9sm8RWnP
QppvfbwpIL8FzwtyeyL/g/xZyn8TBa/mz5DfS/XTKPraeIC/IB9fnKbjzIF7
hV5y3t3nPBuI/N5UPlOm5A0iv9/ytfC0ut9Ffg886Enl/4Oe1F6K80IVvv+C
vdBfsBfOb1Af7nclfW0/b/z8dEyvodB+GPIwvsCf5/mBVP6m6J+qB/fFYC/c
twPP7t9CZdxMwQ/NCi8we55glvUXm/G8FMXzDclf3UJl3hRKTuy7+3TzGV6/
rML/l/Mbu29Q6i8WvKr3T/aBPvQXzkPseYYZeegvYPb8xIznTfb8xITnWfb8
RGD2fM6E9wXseZYJ7wtA71qtqJ+dLwi96itqPZgyjfMOM3kwxaNS7V0cXzYh
Bvuk8presJJZjm6J4niaScb5FDzNqPACU/3+RjyPM38Jno2nSebLmvA8D/fP
4A/mf5N8f9DNJJ//b4r+w302+AfudyW82YiYzScT3gey+WmUcRGBWXwZiNuS
kY1f1eX3Q9FG+f6orqKv6cH4sflpkvmboj5bb0yoz9YjI2J23jRheXbeNMl8
GxPeH/6bntpf1T62vij9SdFfZr9BuT8zKP43KP4wyPdf3Qzy+JsEz+avHjGb
n3osz+JHwYtDZL2seowfFo8hOL9Ye3q8TwM9uG8DPcAsvkPk8v9BT7JX04P7
PRbfevl+8L1oD/qbbeiY5rabQg8w86+eHGg/ZdXbX0Kv3ccdR896W/n6K3iw
DzBbr0KwPFsPQuT6Wn/h/hT6C/er7PlssIz7C8zWn2Csz95PCMb7U/Z+QjD6
g72fEIT+Yu9DCMzerwjC8WTvGwTJ66WmJ/GaHqwvbD0NxvWHrafByLP1K0RZ
n4NRn/UnBO8j2XoajBj0jvP9BfQa8f2PrZfBiNl6H0yy8v0O7NvO8wP2/oTC
jwgm3fl+xPwj2mPvYwh95h+lfvoQsojnF6z9EOJRPTZrQFcL74/Crw0hFp6f
sPYF/0960J6qx+JLL7eXT08e83yX+ScE8T/Zdz7KOCh9RaHXaqj7++O3QlFv
99QRVUdEcL6/npRrM3P7gSRe36GtD30fvdFWKB7/epJz6cVm/ucsfH4aZP67
qP//q7fsHLmWbrgF9b7ez57rwA/ojx550JPKp9Bj/hH9Y/4RPIsfhV8r7GXz
T8Ha+AKG8QX/svgPQf+y+Aohefn5BvT6B/8INqwNRfskvoMYH1UP+iu1V13x
b4r+/tP42vZ1W6DPwv39UE+eP2uSN9v+UNw/gIf9COrDfi7x78V4sfXXgOPF
1kMDsbyL1g/oxce7v4EsSrtisMdfYfh8euTL2AxeJfh620xg0FucsrymF8b1
IF4As/XcQHYca39558EwtG+yxa/Wtwxi/w320PecXS0c9/NvZa17Gtg4DhAY
+mudUyXJlV/s5xlG1n2S7Mmf9zwXPDvvmYhHk4Zbet4Lw3wD2oN8A+yBfOPs
2NqVPKeFYb4BPNgn2a/lG17XWphvNBT5xtsDHaf0aiP0gGfnTRP6E+yT8AUj
YnYeNZJaPYaVKRwDz7cEZvYbSb+Evrf71of2jDie/6bHnjeYyONG41pvHyz8
J9lrVfrzH/wH4wP9lfx/QfhfHQ/2PMREznN/g15/vh6BXiU+n2A8LvP5Bvnu
YD5/WTyYSEE+f2E8AEN+eojfZ4BeNX6fAXrX+fMLFq9GmY82YX3IxyX9RGEP
5PdQX9WD9zegPLxfAjycP4Bn669BLt/MSJ7z/YbtJ0biI+1PgmfrkUEu/z/o
gX3L+H4I76ssS7k/anpf+Xke33/xXdnw5wsL6j0O+9RvVwvYbwyIwT4oz9Zf
wbP9QeHXGjA+2PqrYG3/qJRyPc5nIPtT7i+vtPWe7z+w3ktYW+/zpty/tPV+
FV9fYb3/yddXlk8ofAo92N9abSs594c+DO2D+Af7YH6AfTDf2P6lx/kI/YX5
Cv6TeM1/icbp6yKWQb5nwPkO/oP6bP8U6zPLzwy4HrL2DaQFtx/GAzDL9wwk
d8r+anoruD9Az8H3K5YPG0iqtRVajZsUyvM9A2mTcr9Ob5T5u6I+a99I9kr5
glHmRxixfeZPI9rH/CMw848ov5Hfj/t9XWc67g7xYyIv+P68kd/fD80bPupc
N8gHTKRGmrRheb+aUQ8w6B2p9tfBq+vM+L4Z8HB/IJX/biQ3324tEDWY881M
pOHRY4umnhJ6b7b0bXvNakb75vDnn9Bf4KG/gMF/oMfGz0hmXst3KywolL/f
bZD5eCNZw++LYTwkHK/gu3rEEC9yewa0h42/XsYlBGb2hGD/6Pvo50KQZ+/j
C57iikr5iSGkDn/eq+ox+/UkHb8vZ/GpJ05+X87ehxf9AT0J5xSYvf8fjPFL
cSsFPw1SeAU/DUTMfo8QiPHN+heE8c/sCSIV+HoHen35fsr8FUQe8vWU9S8Y
efZ7hCAZuyn1cwbhesDaC0TM2gvE9YO1F0h28vwP9IBn7SnlNT1Yj1h7ArPf
MwRiPsPiS+FT6LH4CcL1k413IK6PcD6X1r8jQTI/X6nfU/Ds9xwKr/kP8iEY
D8iHWPtBuL6DHmDQe5xyfDQ9yIfgPA37CejBfgJ6Etb6CxjGYzcfDzZfAsko
7k8Y36U8f4TxAAzja+X5Pfs9jMKn0GO/hwkku3h77Pc1gaQlt4f9nieQ5OH9
Yb/XCSQr+frLfq8TSCJ4vLPfBwWS1Hw+sN//BJJZfL1iv/8JIjX5+snaDyJH
+XpLcSqBYX5I5XVBZBhfz/9ND+ZvXNQ9t8RmQg8wzDep/PIg0rXokoQi9WE9
CSaZg6f8vPPc9Dc9Fg/B5MOQM6viCgk9CYcJDPEC9WG+SXra+G5sXa1T5B0z
ri/Aw/oi8dr6op9a5GHhKWaMZ4lP0V/wn9SfFP0F/5XIEmWL323i8aDwJIjc
4vsdi4cgMupe67uJGcw8HoJIXb5+s3gQPP09WWlRn/7e7GugzDfR5i/fL9jv
y4KIi6/vlF8YRNLz9Z/ymYPJXL4/sN+raf7g7xOx9oPJRv5+Ems/mMRFLg29
V5PzY7TxGzz1wKJHRmb/W8Gz/oeQo/x5L+t/iMzPCiGZg5z5y27j9Tsr/HVR
/9/02Hjq0R42H/TYHzaeenKPv8/ExlNPxvL3l9h8EDzrTwiOB2tfT05+zlxk
kT+0rydNyn4e3+ITrz9LT7bWCzpaujPnUxmIuVFdz8floH0DeTim9LoVN4w8
PvWIWbwbSN8tOcu0n2Dk8a7lm/T71ZyfqOWjb41nX+wxYv7ynX7/24j5C/Bs
vTciD/mQVF7Lh1bQ73cbMD8FzNZbLR+l36/m+JMeMeRDe+n/ZxgwH5JwvMCQ
31eg3282Yj50kX5vmfPptfyYfi9X6OVfXeDV1yt6zK8GDq7Up0FpA+b3TyM8
03dvb8DzAmDQmxr46vT2d3o8L3wv/Mv5wceA5w/AYF94VfPkDduF3s5U8cVf
pTGiXos3uR7XGiPsy3330JruOUV/AYNe381X3DdGCz2JT6HH8nm9rP8/6MH5
aEWmTaXcD4v+OpKbP+tn1OP56EVpe6zfrxA8rwIP51/g4fwLGH6vAeXhvA88
3B8Az+6TTGTv6Z7dd0zX430EYLiPaLO7svf3onq830j1pOCG/edD+H2NwqfQ
Y/c1ZlJh0ehUH+/r8f17iW9jxvr/Vz3J/jRm9Cc8v4R4geeXEl/EjOMBvzeA
8YLff0j8QbPsj0SzbF+aUPQH6AH+wd9fW3P5ZK+0USH8vkbwUfz9Jml8Hwp7
o/j7TX51k6Z9663H31tJ/FhRX9WD578yb1LaM6I9cF8CWI0/uM8BHuIZMMQz
9BfiOf+q22l1izh2CAzz48CsiaeGVQrB+dZhVMDUY+uCUS/dploZxzYLRj3g
wT6J1+zbkPTw7NnnQXh/FXLqQsCU+UG8fSOZc7tEP0shXn+PkdTJmP1N7jNB
eP4FHvwn8dr5d2Sh6Ipng4Px91vFG+rnTP4WhOfpE7W/Nb0yJAjP5z1KratS
OFMQns+Bh/M5YLg/gPJwf1A6Z5N3sRMCcf+QeG3/yGaaO//2nkDuTxNZ3CMh
T1KXQO5PE0keec0Y+yIQ34+YsPHIvpJJgfh+xIODeZJvFRZ6gNn6b8TysB9J
9TX7QB/uSwDD+dw0q9ywQi2CcL9csLLL7st3g1DP7XKjmrOmBuF+Ce3D/gYY
9l9oH/SgPdh/of+wn4c197n5MLkhzycM5Jvt7cKKAxvy/NBAmldKU6P5iYY8
PzUiD3oSzqnU1/KD5f6L27RL1xDzF8AsX9YT3/aT79TYGcDb05MpA+7mf1FH
6FVecXrMuqcBqDdgZ+GDbZs0xP4+mVDVsnyN0AMMep5JvUc2qxDI81s9+gfy
K8BgH/gL8ivwF+Rrkv8qKvr/RQ/saxz7/OostyC8X4P4hv7CfIH+Ag96UvkU
etDfLR3cckZsCML+Zho0LCR3lWDUg/gC/0nxpcXLmZ+hi2P0wj7AkF9J5VPE
3z/Fsxp/wEP8yf4W8cnyWcFDfiqV1/JT6D/Lt5X+60R7kO9K7VcU9oMe9A/0
gGfnWb3MFxLzFewDzM4DevJ+1773k5zB/Dyi8P9Fj42fsIeNn0EZP2V92GaU
x6uEiTSv7F2w5I9AXK8As/EzklyF3txtOgzWIyPp8ypVuwVnxfon8Sn02Ppm
ktuLN5HSuebcKngwCPUA/5N98vpmJAmP17RyZA/m8W0kdz99WZBrVDCPR22/
KP0s72WvYN4fE8lGvy8P8WgiO+j35KF9Ewmj348Pwu9RAA/fowAevm8hlU//
+/fbh79FLw3C/gKG9+GgffheRmP6ffxg1GP/DxCM79cBhvfhoDzbD80kmX6P
P1i878h5eD9R4suGEtPs+PaXZgXj+4kPDpnvzwgNFu+fch7fP+3Y+XPOR8H4
/in7v4EQ/H2exKcJI5kG7611Oo7zbcL4/0OE4Pu7N+n/SYTg+8A1vGsMSd1R
j3qAQU8qr+k1TPX+8hA//d/0lvDfuwA//vf7yeHhyPf83f9hCt85nMyk/xeq
Z/Vjw8mLMuODvtYxMH5SOBlK//9Oz+ofUvgN4cSP/v+XgdWfG06m0v/LMjL+
fDipQv/fzMDqp7UiD3oSHiZwo9+/R9qu1F8cTgYOadr0nYPz18JJ/jXhV7dm
Nur0NB+1kjX0/2wNutqvRy6w+lmRp/iXKF+E5s+ifFrLxwH3WoryFFcQ+CWN
Byu2f2Vts9gOEwS/j8aH0Fue/aLnt4+Cn0TH14Z8nw66wmPibDJvsJE2e+fl
6DrMyPgBNpLq2e//o+fYR+Cmv8e/i43MzNP30+eXQu8F/X9qoedXP1+rLveF
3lX6f+9CDzDodUh4a/lsMOpMZ9YlF1hqI+m23j24+6dBV+/38+3rNjLn3mm3
QZsNuuLVi19dks2OfIbf7/vr7Fj/zbixW+p0V/jGdrJh8eSEX8M5LqXg+zbE
tH4+Owk5O+jnQQ+OL9sQX//9e+qMoj7Fx5T6W2wkdkqgrWFWrp+k8Cn0KE9s
5P2eOkczED3DgxWsE5j2v5qNLFj9eLwxWM/8U8hGTImzIiacDmG82Ua2dFr1
x8mCvHw2gWn5z1bSOD5uZY75IaiXTL8vFoJ6i+n3uoJRz5N+jysY7QMe+pst
NFcXW7kQ7C/oQ39P1O1U3/Sc42kCg16PMmV+TOjE7WkveGqPU+HH2cjd5Lpj
Tu3ifG8bqZN5yIFR9Xh/1yj1Z4n6NL5GCJ7iIIFpPNYW5Wm8FreR0rmvHL74
MZjxVhvZQb9/G4zx3Jx+vzcY4/nMr1HjCvQPRj3AtL0WNuJ2ZXYh+zGOywtM
y+e24f5A8QUrYlo+vY30ee3piE4TzPrnbiO56PeFg1BvD/0ecRD6r/ydV0Xn
jw5C/wEP8Qc8HZ8PNjJh06/lNy8FsfiuaMf97MDLL1NIjB33O8qH2HE/onw/
O+5XlG9lx/2U8nOU+qOU+ruV+svtuJ+x+LGTIy2LfTxcRs/nnx33L9CTcIjA
YB/UX1Ws9tBR6+0kdnKWNqOvhTDcScE1Bab1i2rzf1HUwkAr17tlQ0zL59TW
jzNB+TNl4PicDfFUc+sulrR2jN/+/Rc0zt9AlG+x5mrY7bZC33I7u9/i+Xb+
f60cxyu4hMC0fhY7/z9VA8MnbYhpe9tt/P/SDcyexWI/oPw1G+43oAc8bc/X
jnyDbEE12nYVfCnv/sVrL1P4KXbcTym2Cazq0faqKLzWX9ifVT3a3lHBZ26/
OdvnL3a8f6b8EzveN9P6FxU+gwPvsyn/zk52pp6VYYWbifEVHCS82si+7V4I
PcC0vcIOLP9uzp/f9oWK8hRnV/AZu4zHC3zrVOkXIw7YydPI7q9rJHF+rdK/
2XbMf0AP+kfrp3bgfT7lX9nxfpzWv2HH+2/wH9x/UzxSwcEC0/p97Hg/TrGH
wMxf2vh0uqXrt1zP/JlH8HQ8f9qQp3ifTS7/zob36aAH96G0PZcdeeZ/Bd9Q
6h+14X0965/ALH5txKvVKJ9aTzi/zIbPC1i82fB5AuhN7H25x8tGEG828jn0
SerKq7m/q9tlXrMPnr+weFN4zX9QH/q7xHv2ifa1jdjf7HlWR6zsL+KlJ//9
PIwHPC+CeIHnSRAv8LwJ4gWeV4EeYNCD53XUnpaCh/kLPIwvYBhfeD4I4wsY
xheeF0J/D/L3AaG/wIN9UJ/NL4HBf9A+jIeEd9rk/ixT7NHGN5C/T0PtHSh4
th4Lnq6PUYKn62dDwbP9wobP09l+ofBhNrKWv99C6w9T9Lcr/GLhL1p/ouDZ
fiZ4ir0U/M2KmO6HT634fBbs68h//8ryWxuOB8sHrKQAfz+T5ctW0pa/X0bz
idOCp/nGDoV/acX3DVj+bZN5LT/dx9+/AT3AtHwqG76/wPIVK2Kw7yV/nwzs
0/H3zVg+quDGArN8worvS7B8VNHfouhrejC+LL8V/QM9CTsEZvmJVY6P3YKn
4/tG+I/lJwLTeHhoJZf4+7ssv7CSQfz9U5Zf2Mgz/v4pxYesiEFvGv+9Mej9
uHepQoaTEG8Cs3jT/MO/t8LiV2AWv1aSh3+fhcWvwmt6Efz7KCy/0PzJv3/C
8gsb8iwf0OKBf3+F5QNavPDvr9D6BW2kQOeNF6w1hB5g6K9UPlnz7xr2vRbo
r2RPQaU9o7BHtU/VA/tm8d+js3zFhjzLzwRm66foD+xHwMN6BXps/7aRmvz3
7Wx9F5ju938o5c/Y0L8sH7CTYfz7M4e/OW+a69tJEf77d8qXtuP7DpSPsMv6
/kr9HqL+2qqTTuRdKXiK2yi4ssAzYo7tuBmr1DeI9infX7Q/aOzP5Qs3CL71
7vozWz8SPMVLlPKT7OQW/34A5Q/bSeCR8TuvzxR64C/QA/9T/rydrE1cEJT/
Ibdnj+ChvxAPlL9tR39T/oTQp/7aKtoH/0m4vsAwHm/59xtgPEbx7zdQ/TF2
UoJ/TwHsA57a/1bUB/vm8u9DUD6Xg6Tvnf7K3DdG1v9AB+kYWrDJDU+Tzvqi
/ciavQXvWXRJj0+rHVi/rOlW8733BJ+tXx7H8LwRWP/jKkNDU0gEuVam8qv8
I026uzcH18nTT/DHsuwofWNdBNbf4PkmV9KDCNSf3bZCqlYFIkld/n0LyqeJ
xP5RfDACMejBeNP25gie2jMqAvUov1u0R+u/FvZQ/lYE2dhyx9z7PTifI5IU
8T5ZqfgB3n5AJPLU3p4K3zQS+0v5GZHoD8oPjSRV6/Usf/GXCfUAg960zKM3
5jCZGXYTmJYvE0l0nz372C6Y0H8SXiQwtX9CBNan2CIw7a+XKE/xN4dcv0YE
WXnGnH5iMV6+aASJ2PPr9MVFfLwzRpDUqzdNK1DZhHptBx8uZe/O63eMIJci
rq6ZuF/Y5131mfvpLLx/VwU/NDHuTfUskci3Oznt7gefSOQdX0+d2d0lEvUp
ri0wLV88kuybnNuV87XQk/gUepSvEkkGBY7pfimI83GR5FnhOalyTea8UfN/
Jstxe0ETjocuOdWkmfOMOB4vH2+OulWWx0NkJBmWa9Gp+dcNrH6C4Kn+3kgS
sfvIw4KdOB4gMO3PRs3+Sdc6OXZxfp5m/6CEBrN0nL+g2e+Ye+jyWKPOp0ra
vUPTRxHvKuvCcl/j+EgkYtB7VqhJwYg4oQc82Ac89FfCWQSm/fukxU/GfPdm
PTSg/37cLt/uSg0xf1eeul6n8FYDji9g0Muz8M99EamE3r6J80bOHsnLbxOY
lv8zglRssT7P1QsGHN9Jngfm5ynO+2eNJF9yXqoS1pr3f0Qkafr40baxm40Y
Lzkuzxx4zsOI8QKYlm8RSZb+HPFuymsDw+UFrhDtucbgUsoHRZJdB43BeYkB
9Vpu/JE9KljYJ/GafWVnxV4My2rE+Ou1cmWWbCOM6L9Tuz4FHP9pxPiT7J8s
+gfxElq6VLOsD8T4PjLluHZ2BrfvcSTp1/O7cYrJyOwvHIX+zpnQZU6u0CiZ
94gi50YZhlmOcL5DFGm5qUFy7r5G3eedKxKuJUXh+FLcWGDQs77uunjyCo6z
K/hMJGJaP1UUxtMfz+/1mV9PlD9ZuGCbFq2jyK5Dw2uefc95h7CH4nyKfamU
8in0KP6gtH9fxCvoQTxTfDkSMbUnk+gvxceV+lsi5fa6R8r9WREp2zdNi6cr
F1oldDAxewYLnmKdUr67Yn9jLT5/7b8VWsb0r3qqfdSeZ4LfbLA4qxVT/P9f
+kvxaKX/3cV8B/skXrMPxuvf9Kg9e5TyK8R6oeqp/WXxK3iYvxI/XvEnUfi1
ij+1eOm16uH7oztMGM9lZ8/YncXPxPR3RuL8obiPgj0EhvVFmn+uSHl+jhc8
m18CQ39hvsP4Ag/jCzyML/AU346U8VyB5/YZEfL+nKhP8UQFhyn63pHEPS4m
59hcJsZ3Ev0dsXKP267FCj9Rqd9f8Gz+K/1zCB7mx7iOK0JCEkwYfzAeEH/Q
PsSLVH+wqK/qUX9XF+XZ+insgfGA9RfGF9ZniD/Yn2B8vSt3bxm52ID7x7OC
FWskVuY4vcCgZ33lvutqd7Ef/bj1YkiRb3q23ucWPN0PfkTI/H/Yj/IkbbiS
eFqP+1G/HgebXCtoQD3AoFexeY/KRefrcf+9ZKv0V3w5Pe7ng/xv7Vi0KgT3
8wLtT1Rr2SgE9/OD0f0/rHwcjPkp8DQfPKvlhwMKtChzIwTzcYnX8vG1M7Yn
Vc4Xgvm4a0Tb1h0SgzEff7veebtWWDDPVyNI4IGl+V4d53yNSHLrxdTRGwYE
Yz7etcDQ793qBGM+ntm/c+cGT4MwH4+z7V3xvjGv31HwoCeV1/SS2sU/+jon
6G96kP8BhvwKykN+JdXX8skP/VcX254/GPNJ4MF/UvkCSnvaeEj2aeejrTXL
uvfrEITnI4nX9CR/FFD8pZ23av64T9onB6N9sy6+M68MEOMLGPKX1CvS3Xg8
PgT1YPxATxq/FOML/YXxA/sAq3rgP4l3E/FA+baiPRgPqb0AxV7tvAXxCHqA
QU+Kf00P4h/Pb7UmDH5SS+hNS5+UrWz/EIyXZwVeBd77yOPbovBa/P24uXFW
o2MhGH/Wlz/PF/XXs/iO0fb7H6bM13fp+XlOW08qeQ6Y04nz/bT1xmPU1qjn
nF+nrUc5ZvtPq2dAPcDs/KXll49WnTk/CPJzLf/cuceV/RTnD2r73YpOpa1W
A9on4QCBYX6UnVnm+bRreuzvuPb1elwoY8D+3h8wZO34uQacv4BBz2Cf6nHy
qQH9Bzz1/yrRHsw3sJfyJyNJvYlnHxsK8PPEtkgyOqloiQyTeH79ZyQpeSrz
lBOBPH8uHkW2fUxOP/4LX+/uRCJm62EUCS31pE/4OlivRXk4b0n4SKSMRyh6
XYS/Ib/PcSluer4MBszvoX+wPgMGPSgP+wdgyDek8i3EeFB+tpbfHMgV5xyn
F/k4jy/IXyC+QA8w5kO8PcyHeHuQPwNP9299FNZn+3sUxivd/9dH4Xyi+cFD
wXe88b78kIJOmU/rxP2I1n+j1C/rxPlK+ZxOsm9Cs3l3bZxv6CQRO625F2Xk
9Ws6cf6z/MiJ6wPLf524frDzQxTyrP9RyDN/Cp75U+FfReF+SOuXcsp8didJ
3714rY2lOK9zkrnzsy7pfiWI5zeCZ/mw4Fk+p/DHFfu3OGX7k0T/2XnHies5
678L13/WfyfuD6An4e4Kricw9HfUzeDwD2mD0X8STlJwY4FZ/hZFSqSvf3j7
jiDevyjc35g9Ubi/sfw3Cvc31j9Rn+X7gmfxHUWOVjxXr9aaYD5fBM/yN6X8
+Ci5f5oe7Ecsv1SwTmCWX0ahv1l8iP2VtncjUi6fXWkvhR7zv+BZfCi85j/Y
H+E8Dfjf7IP7A4kPVewZrLS3RbEnxXiAfdL4pBhfsE8a79FKPHRX2v8P8QL9
g3gBXtWD9UrCmQRm5xthD8XfI2W8R2C2PkXK9W9Hyv44HinPL+38NixHjS+V
usD8FDycB6E+nD9k/0fK8amdPyCeQQ/yW9CD+QLrPcwnOH8ABj1p/iSJ/oFe
3RNfCronBKF9Es6u4DMRiNl6GYF6dP9aGoH9Y/uZwGx+Rsj9PSPyW2aPgkMj
5P56RKA/KP7ikP1TPQLzcRb/Iv8GvQYzzM594UJv7PLZk/qeDEI9wKoei1fR
PlsfBWbxHyGPny6CFPEo1uFleR4fqRRMHIjZeu0gG5tl+WP9TYgvgdn4OeT2
LjuwPTZ/BGbx6lDi1YHxyua3g7x86DeixZ4Q1NN9HLe3tJuez6cIsvLkfEP8
EJ4PeEfgeZTdF0Tg+ZPdF0SQR8bLr/I247iZwOz+IQLzXcoPi5DzgxR6tL3Y
CHJuZM7EqZM5Lqbg2w7ELH+IwPMzm+8OvM+F/kr8f9ED/4E9bP1RsF7BmQRm
42mX9So5iHts6Qrnb4M9dsTM/3b0F+hBPgt6C2vX3ZStkvFveiyfc5BxHTrG
j4s0on0fAwb/eXyhEfUAg57BcabMiKJwX2Yn81oUifGfznGSwGx+2slfPVtN
/ZHDzNcfhV9rJxm8qj0dcJ/fv8y2k2hzn5Ke0WY+30V9Nh8cZPTCiIwHDvH6
r+zk9qZFfgN8OF/KQbrdmbRZ947z2R3k2Os7L76347zOQeILn25ESpn5/qL1
r+GuS8Ou8PuoFQ68H4LxlXhtfA0RGbPpwswYL5uqFJ7VP9GM8ZLBu+V593yh
OD8kXpsfUn1tftwf9HFQ2nRmjGe4f4T5ATzNl6+J+lGZq+bXZ42U+eQItJ/y
VSPRfpZvR5KFdTrMORbDeVMkyZJpUMV0y006nUfTdDkHRaL/KreZ/f7KJoVf
oJ13PtV+E1Kd8xe189bphv2G9+b8flGf6q8WPG1/psKfUvR/Ke3XicLxzTP7
/IO5LaNk3haF40vr+0XJ+lWjZPsaRWH80PpTBA96gGl7I5XyXYU9oFfr8Jte
Hts5Likw6M2enTpdzzShqAf8t+MZLzbbJfhHn30PVHkdRdJ0yjtpU2io7kyl
nhv+Ku2U+RxOEjR6y6mdo82M93eiPRSnFnibc+2CHfWd6I8Fox9NGNTGif6m
uLLAo3cUHRgc58T46PLM1iH7ZMFTbFXK+zgxHijfxYn3pRTXFpiWLy70afuZ
FV7Tg/tXin9EIabln0fhfa2qB/YBH10oIfbycME31B8wzdkh7K/W+7Nn05eC
p3iNUn6WE+cP5U87cX5RPE7g/CtqVqlMnHg/DXpwPw16cP9OsVNgam+gUr63
6M+/6YF94C/oL9xPQ3/h+Sq1t5QLn79SfN+J+Oe1loXf5nVh+acZ52faHuJC
vfMNriQP6Cd4ir0E3tkq29PATkKf8jEu0nZguOVONs5PdJHUK30PJh3Q6xbN
bHg16yHBjz3W98jFTy5yyd70ZmGnQdc9eeOW2VWiZb5ANCnQIW2B0lN5/bTR
5GDMtjvNC+uZ/hsX6Whss3TFghDGl40m10r2q/34zxDG54wmVWsfb7OwOS9/
zoWY2rvbheVp/5cLnvpnqosMCsi/KO6unvHHXHi/T+t/EzzoSbifgr0UvYqi
/zAeEh8i2qM4o8C0/HsnmZbh5sc76/U4vpCvgR70j/KpXJjvQTwDhviD/BD0
IH8EPYnX9CCfp3xdF54fIf7g/EZ5uwvvMyivc+F9BugBhniG+w0a79edMp9N
aU+n2NNN4Rsr9mjjC+cVGF+J36zUTxI8Wx9ceH/D5rPCrxH6bD4L+9h8duH5
h81nF/qbrhdLXHgeYOu1wh8W40HrfxY81a8WLfOFouX2zdHYPvOnwMyfSvkU
esyf0Xi/wPyp8IOV+u0Ve5yCZ+uj4ClOp+AU/aX+2OiS6z8S/qT8BReed8F/
gEEPzseg16TE1V/73gei3sn3T8d+8w3C8QDM4lEpr+llzz7mWJq+HA8XGMa3
54NEu9+RQNQrcyG06DATx80FhngZu6zR8v0zhN697Wvu9csVhHr68fva7YgR
8QcY4m9j0/PJH5YF8fkseIhnwHT8LinliYvEWYftd6/+dz2wT+K1eD5aYbqp
R29hXxH3B8NqvxP+k/jrSn0t/j7061L3+x+BGM9gH4wHzDfQAwzjC/OP5g8D
BM/yI8HT/ClCzG/KjxHrD8UGBWcWmOUzLnzeyfIjFz5PAvuAh/7K61e0zGv9
hftv6C/cf8P8hftvmL9wXqe8u5iPtH45wYOeVF7Tk9Z/TQ/WG5i/cN/A1sNo
op/w2dFtIqyH0XgfwuInGu9LWPxEk3s7nhx3C+T8+2jS8+Fl76+fIR6jyckP
pXts6wrroeBZ/Aie+TOalMjQaW3Xl3z9uB5NRt0a7LG+Ae/fYW09eXmmS7uN
HA9XcKDAbL5Ek8CD934s/w77XzRZO/OvMY9C9LheAYb+Qj4C/ZX264wxyLP9
PkbZ72Pk/CMmBvdvli/F4PN/isMUnFNgmu80jMH7C5ov9VT4ZjH4fgHlZ8Rg
/kDzrZPCPspvi8F8hNZfrPBXY+R87FCMks/FKPlcLL4vwfK5WMwvWT4Xi/ks
y+diMB9m+Vws5sO0fmQsvg/E+h+L7/vQ+jUFD3oSXh8j138Yg+8rgX0Sn1bo
Q3+l9jQ9eL8I9OB8z/LNGDwvsPwwBvuj2qf2F/Sk/mv2gX9gPCQ8Q2AYX6n+
NmEPjK9krxZ/p3bXqjasjpnnrwqfor8s/1f6/1/0wH9Nn5RICn76dz3a3hzh
XzpfRgme5cNKec0+eH/u38YD/CfxaZX4eaPo31LszRkr++dbDCl5ZkBzvzVm
Zt9TxX9FY0m9yQE79g8w8/kcS+a1dAR+P25GPcAQz3C/xOaz4Cl2E5iOb1ul
vDY/4D4K+gsY+iuV1/Q65e4d26NRKMZf0VRVy+18LOyD+xeIZ8CgB/cd4L/h
V7w3fKwViv67/mTMs42rQnF8AcP4Vvt8tVTHchaer8eQwZnLuarMt/DzWAx5
frf+45bPLagn8cdiyOUiXSY/KRiGeoBBr1K1fScWTQ7j+WoM2Tc//ZD16cN5
vhpDuo3JcSy0ajjf72LIlNTnI+7dDuPrv8InaXrdC2Z/GR7O8/8YcvG7T+WT
48P5fhJD+o9oHrTiJOfXaP5KjPmVeSnnZ8WQLmWHFn32B+dPx5A97n2uGPYI
PQmbBQb7oD7bj2NIhRxjm4zMaMX4u/V56vJy1a18f4ohtTt3GBv8ltcnggf7
gIf+SuWTRH9AD/oDesXz1H9YtTXn38eQ1hWrzRsfwPn7wt+gJ+EU4wH9hfos
n4kheTbYdrYbJOyLO2LodsYl9IAHPQmXUupnU+zTCfvZ+VPBWv4CGPIDeTwF
D/kGxAvkLxAvkL8MfPH2bfZ84Zi/1L36xW2NRzjmL3nmLKs/90sYP49Ek31j
XD/uDQpj+ea8aNK2d7YjZTNw/kI0Sb34q/vTXRZ+XopBHvQAs/xSlAf7ALPz
tpY/nnm2ZlUnC/qvJp+fkK/VTDlf88aQo2WOTKt9IxTzIcDgv658fYH8LzNf
fyAfSuLrGYvfaMRs/YyRy2v51Va+nrH5H42YrcfRxMzvz1U9sO9Dr4X9dwSE
4nlVwnaB4fyrH/N6S/c9nO+m5bObb1dy78LtWa7wmt7cRK9XtdwsaF/6zqF9
OgyxoH3As3xAKa/pvV09uvyr9Ry3EhjsC9x7JW5l5TC0b9bZMjNaLA7D8/mn
Nw2eTsoRjufzYVniAx5fCMP8vuaXXFkqO8PwvCDx7ZX6SYIH/wEP4yHx74U+
xIvEa/Ei6WvzDexn90cxJPWSemUWvRZ6gCFepPIp9FT7YDwke48p9mxW7NX6
e+vpoQvt7/L5ME47X1ztOXtDcwv6DzD4r+6Ryk0+/BmK/jv5puCV7QtC8X6j
ROoW2bsXtuB5CzDoba1qH9LgbCjqZfZJ2vk+xILnN+Dh/CaV1/TMkf4fvw4N
/ZsenN+gPegv2K/2F/zXNc+moFpTLeg/wOA/KM/2W6V+N6HPxlPgf4pniH82
ngKz+BDzi61PLnl+ltLOm4smvu2XbMbzdAOeb8F5+iF/fgb+m8jv8+F+yCvl
84a9LvKUn0co/5eLDOT373A/BJitxy5Shd+Hw/0B8PR+oYeLXOT5N+VXivYo
P13YQ5/vDBH2suc/AtPnQzVc2D/KN3Hh+saeJwnMnicJf9HnUV+d6E/6vOqJ
E/1N8TKB2fMzUZ49P3SiHnt+6CRxoZszfRwv9KT2irhwfKg9Fhcpw/NlsE/C
Z52I2fMuF9mZ3O56miYcH3DKeIjAtH5HJ8meeWeu/Tc5v9BJltRdPnzoRM5P
cJLPgR/2+Gbm9vV14vxhzx8Fz57vKfxIJ84vioMFZs8znTh/KX4XhZj6716U
XD6PE+cnez4ahfONPt98EYU8e94aJZfX9GB+see3Cm4kMHseHIXrFXu+LDA8
X5XGv6vgWXxE4fpG/XczijQpksHQzyGeXwIPzy8lvobwF4sP4S8WH07sP4wv
8HS+bBU8e17oxPWHPS904f7Inhe6yNopT58/7h6G96fAs/sgpXxtF+4vbP47
ZbxRYDb/nXL9C065vXQuUqD1lx5lCORjThkPFxierx6MXOPTMjgMn69K+K8o
xGx/cBLXkMSNlb9Z8HmjxAc6ScegRulXnbagXpF6ec68sllQDzDoDePnK9B7
yc9foAf5ITy/hHwQnh9J+eN9J+aX8PwI8lF43gP5LTyPAgx6Uv46S/NXq/3j
Wo2z4PPQtZPXpqrqD/u1wKAH5eF52SDvC4WWXBP2Va06/P7TOKEHPDxfvRRa
wtrYGobPo7zL1rozd66wDzDoLf3s3+bG0zDsb8anK78mFA7H53l7LmzSVfYL
x+eDXfbsHnmsOedbuUjRoAeLli7k/BwXOV/zxbOGxzg/ykUqLD98ukVCOD5v
vDX5TJ50G8LxeajE33KR/iXmbxgVGo7PtyT+m6jP8mUXGVHkQ40HLzlfNFpu
P2M01lf14HmZ1J6md6zu9LbPKwo9idf0Lk7vNW1lLjg/ivr/V708hnHlTGmE
nuRfr2jZvxWj5foxwh52XxVNamde/ql8NxifaNk/Wv4C/oH8ReJHRSvjI9pn
4yPsY/ctMTKfM0a275uor+rBeUEqf0v0h8WP4u9Rir+1fC28yKK3M5aHYb4G
GPIrqbzW31GDB98McRN63u3GlHoSI/SmPGiaLlNJYd/uN5v7X3oXhv4DDHqt
7rYMLNgnDPXOb+593n447B/1Qs60My4LFPn9vMCgGsczCvsAw/noSS+fcpen
C72w0LANuf4Iw/ORtaale8vqQi9Dkahd6exCDzDoxU6uNb9CgXDMTwGD/3L3
93h02EvEi8Rres1z50s3eZPo75kn5Sed+cFxiMAQf0XvFs0xopzQO9IyoEqz
JkJP4lPoQX9zcXugv7vSNU61uHc4ji9gyJ+bjx9ZbMjWcMyfcxRY697oXTjm
zzvmX3L41LTi+aPDmNuJtxxWfL4FGJ6HHkq1beCPglbMn4GH/FnitXy894t9
h+f4WPH5L/CqHtgH5eF5o1T/9/PV7o/v9+kr7LsW/7pCoSShV/3qsSyezYR9
w0IXvo6pYMXneYBBz919Vb2vJqH3qszmvrO6WPF5qISdAsP7Aouy7yFuM634
vNY848HtfJfhPs5FZq6+MaPnOis+rwUezkeph7wos/mLFeMv6vPhDFf2WDH+
sj08Y+72wIrrKWDQaxq9vNb0pUKvYNCGnnVPCb0DZ65OyZ3JhuetdpE/1r0J
tGG8bGv3obW1pA3jpfGHIiNqxtrw+S9g0Mt/r+ypM0OE3v5Wxqer9wm97jZ7
deMjG8Yz8BDPwMP8kHBGpb7W35MnquVuv9yG/S3ln+Hj+LY2fN4NGMaj5457
19dXt+F4SPwa0X8YX6k/p5X2tP4O2lI/KssZG46HxGv9lfSzKbxO1Ff1wH+V
fWK7Pcts/0f/AQ/+u1uxxc6RNe24HozeMPZK8/Z2XA/qeGz6K2ClHde/AZaV
q5cMs+P9QcVr544NJXa8P7h94Hr20k+EHmBYnyev+cO+P6sD9bzqZ+o8T+/A
+4O3JXNv8+roQL3EFQ0uFl7twPsI4OH+BXh8Xls7/nXyUwd/X0LwLN8X9SnO
LTB739BFgmf+OTuutoOfH1wyX1zYC3ojjb8q/yrDeR/RX9ADDHpS+RR67P0B
4R/QA3vYehNNvg15f+9bpAPvize0/14+sT/nJ2v70aMrmff4OfB+1/rl9KHi
RRx4vws83O9KuLeC3QWG+ytJzxlNlndettzvjh2fn/94OmhskyQ76ul/9Aw6
1NeOehL+/f5GSrxDYFhP53cPr/zYx47r6fMxIQ+DC9lxfki8pvfhReXsGVPb
8b5z5dU69qUVRDwDD/EHPMwPqbw2336FZmtw7LkN49nYLO1flQ7bUC/p5u3L
xlFi/gIG+6A8rAcSHicwrC9QH973+WTdtqO9Uawv/q3Wdj1bTuiN67+kWq1f
Yn2+NnnOk8k3rLgeVM/c4+TmuVa0r3eJ9sPz97Jif4GH9V4qr+kNG2xZd6WR
2D/OTg9q3cDTivkG8JBPAg/5s1ReW5/LZS9pdv0I/0e9wqu9y8zOZ8V8HDDY
16lMgQy7r4n8Cnjor8T/zl8aZCfFNol8KH1our4Dx4l8CHjIn4GHfBx4yMdB
nz1PjcH+sOepAtPnr8YYciO54pTkMlaGswgcV/H54sa+MWTCg1rXp+s5XyWG
uLeL+tBtBOfjY8iriMaeeVZbUa/hGY8S9TpyfqCoHxxVamrFTYKnuKtS/j/o
zbw7MvLtUyt/3huD8cWeH8dg/EF/IT4pnxBDXry5NGFNExu+XwL14f0S4MF/
gOE8M73311UJ8234vgrMB/a+hmgPnvcAD88XJN4rhkQceVzk+RobPg+A+QvP
ewCD3hb3/ANa5LSjXpYNrxuPuvh3PThvAVbtU/sL71u4pT+lz+Ftw/ctgP83
/1F+VQzOb1WPtjdM8PC+xYP3A3LZDlrxfQuYz/A+CPAsHmNx/Fk8xhLziYlz
J2S34fs5i3RtBm84D/ETS6Kqdj1q+cTja4rgKbYp5f+DHsQTxX8q8XVV8ech
wcP7GxL/UImvxYo/rwp//ZP/7o//q/nL3jZ8/6Xq4mclLHahd6VqTq9qk2z4
vorEH1LqfxLxDHqAob8Qv9Q/JWIxHsF/Eq/5D/Yr8B/sd/D+hsQbY4lf6tLH
Wt+y4fsb0vwqG6vMP4VvGIv9gfelJH81i1XiO1ZeD04q/LZY2R89Y2V/rIqV
/afpJRQoNOTkVhgfxZ5Ogmf7i+DZ/qLw/YQ/WPwIf7H9Svgb9KT1JSRWXl80
PWn+a3qwXrB4jCX7E5OXlf/M+1MgDnk2PnFYn41PHFntvf9nls4QP7GIQS/1
llkPqtXl7Z1T+LRxpHHF44Erpwu9/HkuJITsFnoS3iYwi+9Y0m7Mqo5tBorx
BQzjUar75i0Zl4jx6Pli3KzKrYRe1avT7x4bB/Gt8FdFfbbexKE+i+845Nl+
FUeuxO/5uvSETVdzVNTQ10sFX2j7hC5bbyj8kThsn+1/cWRIaKeDz8O4/nyF
vxiH9tH66ePJgVTDbWP9Of8ujhTsHee2Np3QAwx6Hd64FTl3zIp6O9LVuFxr
EayHAoN9UJ7a/0XhH8eRHP0z7rC1+Lse2CfV94hHPvXTI437dxD8nwV+hDVc
KPhLwfX8slwRPMXTFRwh8J6e7WpcGC3qU6xXcCaBly5bVHyWdzxJW6T8hCn9
Of4eh5iWfxZHXJN/dtnix/li8dhfim+L/k+4eiNbo1zx5FDLXD/fJlh1vTLk
/l4+UJRv7KZ/8bKXwjcX9lN+Zjwpc9OvcYdXHEcJDHqnm7bsb6piY+3Visd4
AD2IF9C7T+aXa7nJpjO0HHRz8ymF3x6P8Qb2AQa9a4f1y7LmFXrj1ltfrnQX
ev6J0XX08ULvRZkhlgpzOP8iniRlT5h2mHD+Wjz5NLxZ7yfDuP7heGL+7h2b
KYTj4QLT/nWOJ4u6FdBVycL5JfHk1ejsX8c+sqIe8LS9rI2QB/sA15mx7UTf
X/HEfX66La/2WdG+Cfnvzsw5lPMlG5GGqZ7eWbvc+jc9yvs1wvpFj77a4d9N
8Ok+lVuRabngKW6l4IoCvyofO/NctFI/pBGZmbtegbalbYzv2wj9QbGnwFcj
po6c0bERSf00aNGy9jbd/hEne8QtEjzFTZXylkbof9CD8QE9GD+wD8aX8hMa
4fiDnoRzKPisiBdqTxpF73W83N+b8bI/jsXjeFD+qxgvincJzPwfTx6N296v
dhAfn6nxxDPd5Eb2THz8BsWTSf3aNuxxKpyNbzuFXxBPRhQeXXjrA86PjSc1
F62rP7UkjweTgrMq+FQcYjYf4siN/9fZVcdpcXNdXEqxxb24u/viDsvuPjKP
Lu5uXdzdtUjxLe5uJcDi7lDc3b3YN0xycjeh9n5/nt9JTm7sxmfynG3YyYP2
5mXZAo8kOF0C7dfLem6KePb6Q9B3ery9+VQ+r4+dKNDvdModQVIPmLdfH0tX
tfuYn6eR3t4js5bYzwR9p8fbL6WH8lN4s/xgr4VDCFvhh/lk/v6uPpT+Mknr
b/2Ih31q/9Law3/QQ/1DT2kPXbTy9VN96+0F7e/Z0+kRL/JTfoGhV615lxHJ
Xoj4RQmjPmZeqduu+HqqjxehORo6egTx+n/nVXmzfoMO2Nadvij4VD72Z1Dv
42tSUnsB5v7TyxZenP9oXIjAgwmj/cFe7t8Jc//uZdN7sF3HW2P88bL6jQ/G
bT8e4w9hPv5o+qaeEbmscIFw0b6XmePhqvU9jswmvaY5xrqfNiI9BacibOnH
0uKX9LI903fsaB0p9Nt42c+D98WM/1DgvBp+5JGYl7+X5e9wvNaixMEcX/NI
zPurh51/96bZkLoCjyJshd/pYaNvflmWtbPgl5nriTbZD0RfhfHQnL+/qnP7
2iOMX8Tz8YviW/MFj4fdNC6Mq1Zc8OPJHl6fxPP2ofG3yT4r/gniLf3tGv+c
0rfiZ/OqfBIqH10P9YHyhN6xj3Pu5VmB+Y+HZesSfrhux4ZS76J3YNJHUzCf
8rCCZ91vfjQEX8j0dw+DV7UvSu1P4YMo/r/p8fmZhw2pW/xigfSYn5n+sFG+
SePfBkk9hS/nZZf2JNoRdC2Ix8/lZYXL3p/beX6QqB8vu5v9xd0kB4KkHjD0
Zib5M9+qJ0HSPgWb5QeM8kN81C8w6hfh0Z7Bc/9E9nH/pPH9vKzcr4cOFRkl
+HVeNmztrsGTmwVxf3WPeMs/pzX9z7DTSU6uDhLjt0/ly/ikPp+v+FT9ZD42
MfnClaH1BV/Dx67kntlyYy6B4xK2wr/S7MmppefySZ7PL3zs1P7NFd5WDOLz
hd0+luHKqveOtEGBizdEb5btrcbf9LFcFSdmSR1T4PmErfDnyJ4Jd0qFPorv
l3zPFB2rrC3vZ/cWB2x5tbUB53P72aRpe/uXrNSAx09JPOYvsAfzl7uCt/BK
wrp9uh7sU/BUn2rPQYpv4RE+1f4dWvglVF4WbqWVn53sg16f09Hyb+rQQOqB
b1JtUZHwF8TX7XY1c2B2P0v+5encntkaBBaPSJE0ruFX+Wp+dvJ2vWZdHgg+
3M9aJi53scTsBoEZz9aNdmw58XFjD342+brGH/Ez3/jI4R8SBAUOjrG7R+1o
YSxZr6PHphUOCgz/9n3MtGEqnyRMxrf4PGHsa+k89f4MbsD5n8LYslxXkle4
WF/qAUOvcsjh4dHH1g98WWzbVfdrv8TxhX1Tm6betSOu0P+B9NsX+dA8abYw
yVs4FuFXQu9ht2YfwgcIPnkYGzA3pF35EqR3ds3ciA+rGkj7wGf6Vh6P/Sz/
uDjFB2yvL/MbueX14qqd6sv8um/fTB8vR32Z37inp9yus7we58uEsY6LF3Uc
/q6ezC8w9NJPc5U60qdeYDyRX2DYN6Rt28h4B+vJ/D6t1DeoWnIqvxmFCqce
MaOeLD9g5DdmnCoL996pF3i56cujWe77JW7y7fuiCSn+vsm5dzy4RPGvfAt/
wC/Ts/iPfuZINf7yAH/9QGfjQvYLqcieetb3pMleCyclbIWPG8YKuzONrtug
XuB+oafwUfRWR4YtX/2M0t8v7EP7uCrsQ31beDhhK/w2qj+LX+xnF/ts+RRZ
mfRQH9BD+b/5Vp7rNf4+xW8qyg/8AU3vmtBDezkg8gt7DJFf2As9tNcOWnt+
o/UP2Af847f2M5fyn/Vb+x1NfBnhD8A3/OYvmlH/sPjpftn+LX6IX/aPlt/8
USc/m3zj7dM/kgdxPsLPah35Wiy8TBDnJ/hZhWFrC5f42CCw3zd/1of4qZY/
9LNXYv69wvKHGj/Cz75sjNcrVZjgu/vZ4ooFp72ZFRQYKdbTwWJ+bvFT/Szu
Ot+HTl9F/IMav5HiW/wDSp9Z3xcOk/yG+SHTt+cKk/xS63vDYaxC6wwJtjQM
CpxzauTwQZ4wNqJf8r1p8wUFTra+P6zxbcPY/ZdVck4bK3BdwtCbKNa/0Lsy
vtHncxGkl+s356ZS/UnvlFhfWvzQMDZMrJcsvjfFt/Q7E2/hYC28qVdOrK9g
H7Cl3zyMvRDrE9g3U6xPYF+QWI9Y2E54xDd/1pHC97W+Zx7G7or1X5dv7Xkh
8S2t/9sQ7/3WH86b/kGsDy3+aBi7JNa3Fl5BGHpKeFOvt1g/Q2+/WH9beBNh
6HWy7dlbLKlIf38Y2956a7+pj0T4RYSt8L+GsYCbk5psXhnE059MPPKr8Asp
PQsPJmyF70npQy+HWN9buCthK/0xWnhTL93VBzcC6jeU9jV/dX1m11wN/9Y+
8FZ99df4Geb41X9N6fd7hb3rNX6plr/IMOZ9NzJD2hGifK4Qb5XfO638z2vl
f1TLT6RWXv9QfhZuqpWni/Ss/AVR+Vh8a618/kP5JRH7x2gve8X+MdpLz4Zp
qo5bTe0vm9gvhh4w9I6J/WPoDRL7vcjvRbHfC/uAdT205w5i/zrY+t8T8TUm
tqg25xHFt/Bhwlb4XZS+hecRtvSnaeHXkL6FJ2j2DNPKo08YO3HgZc41Xag9
g0d9IL6FaxO26i+Qwlv+pgTpWf4pn8ZXp/qx4odR/cFfbRXnD/B/4OGfUf/W
eFBK401/6hbnEfCnv/32Jm/KtIJvbPrDgulrvraL+M4w9uemyk1PTWoo/XM1
cZ/C4luGsWfiPoU1HvmIP9w5/dI3ocSf+/b9/jrE36h8Z2uBSsRbODPhx9/+
t5aKwl+w1kt+Fa8kvMtaL/mlvWe/pZcgjK2aX2dpxy0NAw99s8ecfzYdE/o8
0TXBpwtjiVL2+vFJumDOFwtjhjjft/i8WvyqWvyyFP/6N/vN+ePm2fNyHXYG
Bz76Zn/OMNZYnE9eF/lNJc4fLb5kGGsnzgPfBqw83CJ/GNsjzuOif/vfYNYw
lkacv/14q/vluWmIT22tj/1q+GRkz3/VQ/+DHjD00N6s8PGpPUEP7dVKrzy1
Z4svSv3Bip+b/Eeqb/9XzBTGfhbnTwWs8xW/xLAvvzhvgt5NcR4FvdG19gZW
fRYs7QMuKPRKnHrkyZIvROo92v56PmsYIvMLbIW/5meVih0bejN5iNR7m/H8
kf5lQqTe3EWf7/t6CLyTcHVrf88vw3ut/T2NP+xntolxCn6eJfhNfvY1bf46
ly6GBHa1zqf8bMmCkBZbUoYGjrL29/wsJF/PQdNCQgPnf9tP6k28hcsR3mLt
R5Gehe/7VLyYsBX/so+tj11iQvhXwR/wMd9YzwpHudDAE9/ORzf4WLxUgw4W
Dw8NvCfOVxX+rE9NP55f8rp9Fv6khb+v2ZPer9oTRU+3b4s4r1Xs6ablx8xv
q+cVzqfKLsK31HAuwlb6Hh/LeKlGho21Uf7EdxXnjeCt+nun8bd9bGeL1NtK
3xf1m8rPfuiTuNvM3aJ+Y/lZ2Ov7zh1DBF/Sz1JcezHbvUzw2fwyvpV+Er/U
t/AJLT1TT7GnJIW32lsbjXf4WdfgzNEvJAyV9gFb4ev4Vfuj6P2bfajfZOHN
Xr1pRPULHu0F8a32tMsn82/hAYS/3OXn+23shwf2aR8i299Plc4cSDc5ROqd
zXsl0dYt1F5Gprwb6rxG7VnBwwmjvRSb82OnEumFfcUJo730Wx8z7y9vRXib
j+Uun6dG96KiP1Qi3sLRCVv2P/HK8CnE/Q3wFp5OON+3+w5DvDI/VcR9kLwL
Nr681Dsk0GXdP/OyAWnHn/tcUeCMhDuJ+yXnJ7TamilmSOBwcf8F/HBxX0XB
3TVcgvAccV9K0bN7WJZFYV0HXAnmfBUPO1Jw2Hh/WtJLVa1v7V2vBd/Ew9pt
dxS4tSmY81M9bPPJ+verThT8IA9LVCvXkeY20gOG3p6ihQNi9wqW9gF3Et/3
UcLbNf0oehvFfS6FN+2LKc6//80+lJ/hyzT0QEHBL6D4lv44D1vRoe3vg5cI
fo+HvRfn5dAD3ijuc9UX5+tHxf2rheI+AvSQ3lFx/wrpWbgs4dvWfU9K/6N1
X9jDHO8n/tH4ruBreNh8cV4PvSfivH6juM8Ffo64f4X4w8V9LvDDxf0mYLQ/
JbzZ/qIP2PI2MKton3m8rO7U1avnf/5eb464zwUe5aeEj6KH+lD0H2rhTfsw
HsO+ZfGvB2QKE/2nglfy6G/gLVyEsNU/m1F4C2cnbPVnQwtfzSvHe4sP98rx
AHoYr+APMB5CD/jv9DC/gF7tQtlil19P9gHrehZOo+nHJn0r/y89anms9ajl
N9ujhj/lUfNn6sHfW3ivR2LoYXyAnsJH0bP43z1y/Pxf7XOJ+7uKvRM9svyq
iPunwC5x/1RtHx45P7TyE+GR803u301/Ke7nWf4/oVfyfLzwyvh8/CGejz+E
+fjjlXpbxHmjgu9TevPFeSPijxLnjUhvlDhvBO4qzuOV8IW8cn79d3pIr6u4
L5AF9xuFHjD0jny6eOLOddLrPiTakz0ZQqRe3o7xizauEiL1rrsCwqO1wvzY
y6ZUS7dz9liBexDuKs5/Kx6rdKn3Ycy3vez15tqZ070Q2EHYmt+M8sr5J/SU
+XdTrzo/n0b9C/ahPyG/wLpedXGfAXx1cf9AwXk1/Mij6p33qOlHUnvsKu4L
KOuNTdQ+oQe+urh/oK5PyF9WF/cZpi1b1DrWBayfND6KXkFxPwL9zeITeKU/
9orzaYwHXcX9A4xPo8R5t8LH8rIfb838KfqPon0897CNbXaXu1YT82NN30Hj
BeoD4wnaH3joAc8X9w+QHz5fJJ7PF7Xw22m84esxwpb+arLX4meRv5ov7m8A
W/o1yb/x/q/xLcmfQU+xN4p93J8Qb/mbRsRb/qiexg8gfb7e0/h51P6gp+DM
hLm/0+JX0vT/wr5/00N/gB76P/TgL/h6T+OneOT6ns/fCaP8sD+A+h1w72bK
wXFIT/Gvlz2qP4ziT+eL+yWK/n2Pyv8Hf6rwHb3SPrRnYPgrpKf7e+ihvKGn
+JOFWvzx5F95+yb/ytu3l428VWrK1Qi0R/LX88X9F2Dowb/r/n6+uE9z9n3B
BoH9Q+T41m+AvU3GHaK+UhDP13seNXw8L/spUc74813f66E+lPBmfUAf9VGs
rX/N9ptkH3iUH3iMRwq/kNLzivt1KJ/q4r4e+ILiPiHsTS3u/7XJmnFPzOKC
95vr3+VVr93oJOLXMdfLxdp83LmS9BR82Csx99fm/LJ24w2ZR8D/m/PLU8NP
ft0Lf22ux3dMSDX7Efa7vCqeQxjjJfQxvim8Ob5lXDzDWy5pqBwvDxTaFZ62
fqi0L1n1zUV75wqV9oHn+2ca7qfFN8fLzlvuTXk/MlTal3Ph80tTV4dK+07m
S/W+6xMaz3ttKJ88JI9N2rfvULFj62PZpH0dQ9wPJ1ayyfpNe3lAnE59bbJ/
RDZdnKXBNpus38Q951xePcUm2/OWGPvejz0l+Egvi5V6x9rny4X+O42/TfF1
PbQXpAf7lPSj2IfxTbG3EIVHewaP/gHe6j9vPKz9k2MV8r+3yf6W9cL5wYcz
2GX/UPBiwvCnR8O+zF3iskt/Cgx/OrBO3Hs1+tulf76w+/qhVlVIb8yKB0ni
tbLL8Q0Y45sSPooe/DPSw3ieuvsbV4Lidjk/aDLqcfJ2ie1yfrBy7q1jxx5Q
+aG+UH6ucVOnBnS0ST1g+HuEx/wAPMZL8BgvwVvj1xgPWx2nY89iRQW/y8M+
pmtRbGpCqg/wqA/w8Kfg0f4U3vTPEQvHBHWtbZP+D1jXQ/0q6Zv+VAkfz6vm
741m/w0tf0e1/Een9o/1DNobH9+19mij/oD1EeJb+vmpPvl+mkdi6KF+oQce
4wcwn295ZXtB+Snt11xv9XiQbcewaXZZfsDQQ3jkV+kfUfILPeQH4yV41K8S
Pop90Nv9JV2PB50ov22HVZ60f6Vd5nfTrNL1co9Af/GyGGsLxR3VBP3Fy+rt
z7nrcXn0Py9bUCF6RKLogr/sZU9D3vs6XkL79rKqh09Wnjgb7Zt43r41/qyX
fdjwx/BCkWg/PsnPF++jxl0/8OnVzwJ/8kq8RbyPKt3qWepTG2zSPmDYN7jv
3VNFx4v2n8THjk+6MnpKa/RnH0u75Ez1d1XRn32s408r86SJB3/oY/umDUtU
9nCotC994kYvPWNDZX6BkV8lvGlf0hV9D8yKCJX53VY84nbPm6SH9KAHDD3Y
B71mvx+OZmSi/AJz/0r6fH5OPPoHMPqHEr4Rpc/n+5Qfa3+iNOUX+0Pgrf2N
AIqP/absCTZ13JTfJvfDeg0cH3rxeajcfz75oVWpj+tC5f6awlfwskLtps/o
kdIm9/+G3u7cd/rFULn/Bx77f+Cx/weM/UmEx/6pEn+BR6aP/T8lfdO+O475
11OUs8n9RLRH2PfHm50bbSE2ud8Ovop43wg+n3jfqPBrST+feN84o/KyHOsb
2cR+m481yL++bfAw1I9P5UtT/0kh3ksC8/qm/sTr26f2xyk+tX8d0PgNlB7O
P4BxXgb7cf4BzP2XT5YnzqNQ3tzf+GR74eOp1h8va/3xgE/rfxp/n/Rx3gN9
nPegPvh45ZP+Auehij/x+FV/Mt6v+pNIv+yvfP6l4ap+zd/4WWThj43PDoC/
8bP2WzP3W/c75RcY52VbjqcunWI66Sm8qZe6Ss2ZEz6S3u7D7Td1KCXmO0F+
1mNjj88JfXZpH3icJ4Pn82HCOJ9Wwk+j9HA+fTR/wxsFM4vwowj/nV6+ef2r
LB9EeudyL/KPZHapNyr56ohcd8m+G6NGjKi9xC7Pu8GjPor/em5XnKwOed59
LfvnK7f9DnmeDMzn636Wp+zradXLOGT9ntmTdn22Hg6pN2Jl1j93z3LI+gWP
8gOGfZkuJm0/tKFD2newUamRTccK/ryf9a1b6USM9aSX62yLx9efC/6dn3V5
6Put8mHB36b4vL8QD/uAkd8MXYbs/imeU+ZXwZ98Kt5OGP3tlHdsvJ35nfK8
VuGTaOmb/VdJ39RT7DX1kvcoWHVfS4FXE4Y/+P2rLWxhBMpfw+kJY7xEfN5f
vZLn80uv5DHfAObzaS38Li+Ln6Je2jj9/12Pz1eJ/zc9i1/hZet+7VLi9naH
PJ/x5pgRvPuDQ57Xxl3F2s8t4eT8Fi8LjtyUK0ZSpzz//fXiyptNHgn9zD6V
T+hjn+perXq9nlOeJ68peW9k3y5O6e8VfXP8UNKPrfGlSZ+P7z62uOyEH7Od
ccjxCBh6r4KG7xuy0iHHI4Uvrdnbzifzw8+TfKxG47NfKuUS6VUjns8XNL4Z
5ZeXJ/G8fjR+C6XPz7u0/EXR4+c3Pvbb2ViNfh/pFPMPje+s2ROh8RNJH3rA
/6sePw/S8pfQr9W3X/J8PPaziT2ObF4QQ/CN/Oz+04hZe/eifjR+gJ9dGb2n
c+wrgm/nZ0Vj/WrPOVfg/ISh1zfN5CQjeqI9EoZ9ueZvzddik0PaB33dPj5f
0PgpWnqmfSN6dS9TqwnpAcO+ay8bZGyTg+ybfMXZNH5dyu/D0CI18yZGe/Sz
wCMJ8tU7ZRfzI5/E0HuzMXnnR+8En8bP6hR4aku4zS71oqV5N3PZdbvUs48/
0e/oArvoL362PO7SJs+a28V82M9i9BtUI2kegU/5JOb9z882tRo9ZlUDwb/0
sUYv1y4ZM9rO28tVH0vQ6+LeNgdJjzW7meCHZ6QHDL1uQY8aLk5O+cX4hvpV
eIPGK+7P/Kz103i57ueFP/OzDTGj3awVh+oDmM+3qDy4v/WzpfMybB6RQfBn
qTyhN6di2bEHi5EeMOxTyt8gHvWhYLN/KPHN9heap+qZFi5qL4o/NusX/pj7
V5/qny9q/nGv5h8/aP7M1AOP9rd9+sH1FTxO2V6aZ3l+Iv106r/A0EN4+Ctg
+IOApAt+CctE/kXho9jHxxMNV9PsD/ep9q3Q+Ola/odQ+cBfgYd/VvBLbXyL
Mn7w9qv5x1Ne1R/H1saHvxg/lPKep+VnDJWXnl/4e6U8Tf/ccnjv3gNvOqR/
Bm/hL141fBGtfJpp6f2H8kN7RP1i/oD2h/kU9IChh/kV9MDz9SbN56z1aG3i
+f0nis/vZxFvrYcTE2/d7/nolf6B33/ySf9g8eloPmbxDSi+rmfh415Vf5um
/8wr9WEfeH6fiMLz9T/Zw9frWvw9Xukf+XrdK/0pX6/7VP7/oQd/yu8TEeb7
CZq9UfT4foJP+lMLH/JKjPYH/8rvJ3mlf7XwUsJ8vPBK/4n+Bh7+wD86x5ec
VRyyfyi82Z6RHvqHwg/R4m+h+oceMPSQX7RnZbwx52tYP6H/KriehhMSxnwX
6zPMd4uWrJ1y3kWH3N+4nznEU/GrQ+5v/PqjZ/6VbE65fxD8run9XrWd8n4n
MPY3FrevcOTXhE6p9+VOqtU7T5BerY+JWmdehvHMHI86369Xpb1D7kc8HHYt
bkRNh/RXgV83P9qXgPILHvkFhv+bnCROtkFDHNL/Yf2K/AJjPo71L/wp1sfw
z1g/Y79JwZ0J5xPfD5vafeLx+8fs8n4YMG8fXvb4SZt1P0y0y/VMyZhN2rVt
+70e9v+Asf+H8NhfG9OzXMOxBe1yfw087hOC3yi+53brRYriq1/a5H1HYOz/
FYib8FnSozZ5fxIY9/+U8As0/XGUPu47wn7rPmQLjZ/pYQNTu3Ieq26X9zGB
cX/ywriiCZ7HJ72sEXn2Nrxtk3rYL7HuX4Z45H6JxQ/zyP0Xi+/ikfsvFr/I
w5o4K9penbVxfpKHJbzRrNPJANID1vW4Pyae+2PisX+qhDfz2zZ0yul63ag+
MJ/9Nz2Lv6TFT+xV43/0yPkwH3+8LOWVbc/yrhXtoYmXHd4fWfzQedFepnpZ
/7VHe7X8LLBdwyk1fM4jMdoL5stof4o/N9ufkt4/6KE9I3wn8X1HBY/U9LpT
ep3E9x0x3nD/7pHjF+4nKuOZqaeMJ7U96njS1yP9Me47KnwUPdyfxPoG9x2V
9c5eD5sXsb90wb5YT2n8HY+6Xkrjlesp3O9EfNzHBA/7gGEfwiO/79LPy9Cw
EpVfvck9o3eJZZf3sxV+qkeuz+APsB7DeQB49F/kB/0X+UH/RfnhPjUw7lNj
vIQexsej4v+16vzJo86PTD1lfmTah/EP/grjH9pfhen5Ahvtdsj2jPED+QWG
/8P4hfvPGN+gh/EP7dlr1AgoV9Qpz2cCqgY5/3A65fnH9iPdu26e4pT9Azz0
FDzVo8Y3+8f+Asbsn/s6pX0ZfisycEYlp8yvwpt6vdM0vp1yIdlXOFabPBsO
OmX/vTR6QvVJcQxpX475w6O9ue6U5zOdNvXbat/mlOMRMPTSBf52rth7sg8Y
9inhzfKDPvqvkt5Vj5rebA37CKO/oTzR3xR+LdmD+8XA0Nt74MjLgOKG1Ou5
7mypNS5D6im8qdeh4atELzoZ0r40f6TJe3ylIfsbePgXJbzpX7Y2f3gguO73
erBPCR/FPpf4nq9iT7CHJbm6Z3nXxMLeIRr/P+QX9mUr9yl03DSy72KO2DPz
7zCkvwIPfwUe56HgcT8bGOerCI/72WOTJrpx+KYhz1dLzSj2eUkmlzyPV/AN
j8S4H4H4fL5NPO6P38ziTjPc45L3x6clbOrPMdAl7av7vm1E5CKXtC/6rW6P
Gh91SfvA4zwZ8XF+Dn2cn+cvFXz6QQmXPD//uV6tMXWSuuT5+bHILJ3anTHE
/UKfbD/8PEHDt70Se8X35po+S3Kn0AhD3m8Cxn0ptC/cl4rd+8bA9TkMeb8O
GPel3K+2Nj/3wCn1fou39qdSkU55XwoY96U+9RsVyzXMKe9zYT2A+xbgcV9K
CR/kZWtaT679fvnf6yE96AVNuFAuZXRD3t/4M81X5+vyhrxfUq3g2wB7akPe
nxxf9cmRTS+dsvwU/oSXzfzt+Nsel5zyvg8wyg/pQU/Jv6n3IsOSP6bPdkq9
GlMG/r6tkVPeB1HWT4uJx/0DxMd9BujjPoOS3/tkH+5HID7OUxT+jZfd3bZv
9cUNTvn+Eryuh/MjJXw8HytXdO7kjz+TfQoeThj9Q4lv5rfwyR2ty46n/A6r
Oa2+NwT76V52ZWfHIv1SYr+KeLyfQXycH0Ef73FQv7hvoWBzfgUMf1XmaLIH
Uwoacr6m8LGpfWB+9WxT+oLFbIYcj6YHVqkTMNGQ9zdu28rE7tqW9IChh/Cw
T+Gzm/7ualjm4CXf6+E+SME2hXeerW7I/Pbsnyu8ZGZDri+zxW8wJYWP9ICh
d2xCtzWvZpDeoN59301ghlxfXnzluLRukCHHc6SH8XzIzR8WvItvyPkLyg/z
A9iL+QHi4/6GwvfV8ruW0sd5mZKfCC0/E7X87DX94aK2bWzdDLmeVnA1Dccm
jPrtkLF6gx6looy/AqO9bC1aPv7FAKrfJMtSPvnzrFO+j8L+NOYv2D/FfA08
5pPgMT8Fj/muwpvr6U6DT/15eYBTzneBoZejw6XAXotIr/fd9dl+be2U7y+B
MX9GeGu+HZd4C+93S2ytf9e55fm2xd9zy/7J18+E+frZLftrgPW/Jje7ZNwe
muaowIGEc1v/y9HCh7ll/w4Q/3sHtsL/6Jb91cJHXCoeTThA/O8d/dnil7uk
vwsQ/wNX0ptL+KP4/7Rin6mH/AaI/1EpONCllkcXlyy/APH/HqV8J7nY/o/L
rn6pSnqo39zi/0fpEn5Iue13lBdh6J14F91r3EZ5Ec4t/gcEfwH79k7JVHT6
R9JDe4ce+hv0FHzdkDi3+B8Q+mMg/neXdtbRk+cF/9hgewpOGlZ0reAvGLL/
wT7Eh33gA/C/HYE/iv/3NN3eJPumBobY/9H4EC0//6AH+5TwUfKr2xeI//uJ
/DnE/wfBt8f/AgU/RPy/G7yF+xCe9e3/W60o/Lpv/xO2afwIKi8L1yKs61m4
vGZPJwrvEP+3Qvk5xP+egAPF/56U8jmi8Wb9wh8Giv9HKbgUYd5+DRa7VrE9
ZZ6gvWn4sVNiXv5a/B+19N87WaJqIytNGW1IPcM14OPb5mi/BlvY4ecNzkqi
PUwy2LPBHTpsTSfay36NX2ew+u9nnyzRV/D3DDY94dRRvzgN4S9dkuf+1yV5
vv+m4eNa/G0GqzJ1+6LuUwTuRfi2+L/uk4y39oSeEjgn4Y/if73TFsW/XiSx
S+ynGKzuxIAcJ4u5RH8w2Pz4j+O/eve93lHxv95Sxf7os3E52Teo1smSqYcZ
4v6nS/L8vMslef7en3i+vnVJfT4eumT6fHx1q/xLl8wvH18J8/HVxd733/sk
+bZ/1+PzJ7e0h88X3dJePl90s4tsaboytTH+u1nBUoO/uhOSHjD0etbrtWXH
PdzfcbNs5+adnZkN8yc3O+Y78CK8EdkHzMd/lwzPx3/iUX7AfH+VwvPvJbhk
+ny8Nv13ZOiv15YK/MyQmJ/vmf7/jzqOSkOcsv3tbdy5S6bdzu/0UL8K3mNI
zPd7DDX+LdMfPvpl3OcvTtlewPP5CGG0Z8WeVQZr/qxy0gV+0gPP97cof3w/
xMWGrPLe6nNCzKf6Eo/2gvh8/4Iwnx9SeD4fJszPz0if7w+4WJkZzXOnf4v1
hIbrEebtw8VuZxlT7c8imF8Tz9sH8bx9GBLz9mGwscvWNbrQAf2B+j9fTxhq
fwmg/sbbL/VH3n4JQw/tnZeXobb/O5Q+35+h/sf3Pwy1P+411P72gfwL308x
1P4ZQf6Iz881/i/0lPxFsQ96SnlNNNTy30v+lc/3CcM+hOf3VYjn+0fkz/n+
Efl//t7ExWLeWpTq7ALBR3exFW2OFV13XfDFyV/x+9rE8/W1hu8bavyzhqq/
i8Yvvl435PgGPcyf+P6HS/J8ve5Sw8dzsc1HV3u7HCS9xvbz4Q3jiP2rDYT5
+arBfrz2eUrBKi5pn+P16wYTMriknsJH0YN9qSpd3/ksr0vap/A1KT7fn3FJ
fb6fQjzfT3GxXQfjXD7aUvAnXKxNcP73yyIEH8vNNrbItjZhf5f4XpKbRe+T
rm0Hl+CzuaU+9ID5fplbtk/+3pPGF+ihP/D3kG5Z3/x9m1u2F35f2y3bF39f
6Zbtj9/Xdkt/wd9/uuV8hL+vJAy9ap9qhly+6pT2AcO+mV2ylPwyzyntC/Ll
7TNrv1Pqgbfeu54210/D07zw9xZ4EuHo1v8yKPxD638txFt4K+HT1vcAzfXa
7CTLdtkFXknYCj/DXN/lKLl/ziShP8wt/S/0UB4W7knYCt/CXN8lDUxYYYuw
N0Qrv4rE8+85EI/6RfmjvYDn+3kuFQ92qfE30XjB3/O61PQzafWVQKufdy7J
o/2hfaA9g+f7g8SjfwDDvyjhZ7nk/BX9TcHpCfP9VS1+OZe0l++vutifdxtO
7xkL+78utuqk61rqPCL+eJf0Tyg/RX81+VPoKbgQYd0++BekD/uQPr9/b0gM
f4r1AvyVmyVc5FntlP4UPL+vp/Gmv8f+DZ8P0HoD/h7rQfh7hTfHD8TX9eBP
FdxIS68epcfnF8Tz8dEpMR8fnXJ/iM8vnNr+E/F8/qThCk51fyoPxefnbw4V
L3Wo+lcdcr+An+c55P4DP88jnp83OmT58fNGh8wv3090qvxbh1xv8vmiQ453
fP7pYO02b1mQ9BnWK045vvH5rENi6CnhTT2MT7oeX59p6T1zyPGUz2cJ6/bx
+SytR/l81il51Ad4Pj8jHvULns9/tPATnXL9Cz1lP3KtU9uv1Pj/ob1AD/Wr
tz/Yp9zHvehU308kNOR9e96/nOr9++iGej//iVN7r2HI+6u8fzlVPM+p3m8d
45T3ZXn/IszPF5zyvQWf/2h8FD3uTzR7dmnx32jxb2j2HHWq7zm2aHyU/KL8
UB58veJU3zcM0cKbesr7hL/Qg73QU96bmPZVaN6v/73hpIf7/6hf3P9H+wPP
z5e18KZ9tQ40WrqoE+l9Wdv6ebVpuN9ImK/PnOr7mOxO7b6zFr6aU70PXMQp
7wPz9Y9DYvgrJbyph/vKuh5fTznV++ylNfs/OFR77ji09zxO7X2QU963hn3q
/W6tfRhUP7AP9Qk95X2PqYf2gfy+ePgx7U/NnDK/5aK9OjOgIu5jO+T8Df4e
8yf4e2DoYf4Gf6+sz009ZX1u1oeyPjftU9bnZn6xHwD7kvzcKv+AWaS3Ndr4
Wv6L8E+E5XgkwvP9FIcaf7ZD7kdwf+dQ93PM8sN+D+xT1semfcp607RP2e8y
7QOP8lP2y8zx7eb2aDMmP6DxDft1GH8V3hx/R1fLubFzDsH7nKxSoUKfktR1
yf72Nm3pyqs6uaR/xvqa55946CnYtE+Jn1HTD6bwyC8w2t+y2JWH15vmkvWL
9RX0wCO/trEtF+Y9Q/n9IbzTw4MfRPzOxMO/gIe/Uvi9WvprKX2MR1j/8f5n
SB7zK4U351dhz2sfe7TdJedXwPw+sMFSXApJPvKmS87XwPPzao0fYLCdTXoW
apnJLdfTXesP6h6nmlvO/zKeXzLx9gC3nJ+2ejy3bnWPW85310f/Jc7iEgIf
MFQ8nDA/TzeYb+TvWYZ2cUv74iW7U6HparfML3jkF/GRX2CUn1I/p6g8eH8x
1PJ/qdXvVa3+D2nt4wvVD2+PTrm+5/3FKfcH+PxNm88NIszPMyk83x/V4jdx
yv0Vvj/vlPsr/D6gU65foIf1B5+vEg89YH5+61Tnf/9gHz+/1fhxTjnfhH3K
/PQ/6KH8+HkEYehhfwN6SnlvJF6vD+5fCaN+sf+C+sX8GfV7JO+D2GMbkl6W
BbsfrEoO/2Cw82MOF6xfBv7BYANSvqyTrwfpAcM+hEd95I8dkazjZ6oPYNTH
zWcrjERZRXw7Yb7/bfrvFsPKF7orwnd3sicNxw86loDyCx75Ve5DBND5GfKL
8zk9v9ADhn0oH9RH9/WJs7QdS/nNOyd1yx/WU/ldH5F55eKLpAcMvZEBNQ8N
TemW5Vfxc1CS7OXc0r7X9wz7nkZu4a8NlTfrY0rXPK+rf4X/N1htf9Eyd7K5
5f4peOyfIn3sxyJ97MeC5+MT8dz/a+E7a/b4KD3dPrSXR49iXmi52yX1SkT/
OOHQLJfUQ/uBHtrPv7U/vj50qnweQ62/lHQeC38FDH+lhI+ip7fnf+sfaH9K
+L/oH3p7QXuCntJfzfyiv8I+dT3s1NbDGh+TyoOvh6k98/Ww1r6j6KH84L/4
epj2v/n5oqH6o9Z0XsDnc9p5yClDnY/9w3kKzj+U85XZtP/P7+PSeTD3Dxq/
lM4DcD4DXteDfQiP8xmFf0np4fwI4w/Oe7D/xfuzIfdzeX92yf0snG8p6/tg
ug/B+zPtn+H8CJivxyg96CE92AfM1yda+lH0dPuQXyV8drIX5z3K/lcal7pf
V0/bbxvgUvf7NpB9fL7lkt8fwHmewu9yyf1tvh/okuslvn6n+Pz8xy33C/n5
hVvun/D9Wbfc7+L7s265X8L3Z91yf4TP5yi+rsfng4T5/gLlH/kF5vufWnmc
dan7o6Ye6hd6yn5rLre6H+yh/XHYh/Ug8ov1IN/vdbMc5QoMiN6e8ov1IPKL
9Rf0gPl+Kp2vwz5g2IfzZ9gHnu9H0/k+7MP6DvWB9SrsU/I3XMvfdtq/5/dV
6TyE3+em8xV+n9sjy5/f56b7gXy/26O2l/Qetf7ieWR/5fl3a/Wt4W5utT80
cqvxp7jl/invL265vwg9zF95f3Gr54Nn3dL/Qw8YevDvuG8Bnq+fCPP+TOFx
3wLjE+6D4DyP+1eXyge45XwU9zcwXnD/Red3vD/T+R3vz3Q/BPlV7ouMcavn
4eEav0K7TzKd2pt+v+S/6v2dfdzfeGR6fH/Uw/Kfehfydg/OHzxy/wDtBZj3
F4/cb4Ae0sP3rpEevp+t8C09crzE90UVeysRD/uA+f6jlr/MHjV/Nsofvi8K
/u/sQ3h+HqThT1Q/6G+Iz7+f5FbxasL8PE47703l0c6DKf/8fI8wP3+k9Pj5
I9UP9MDz9xNuNXwCyg/0cD8IevB30IP/5OeZHulvkV/FH5v+qve6uM2yFiZ/
tf/Al4xDEjhl+XVqmL1sk5q4/++WPPwBeD5+Eo/2nCHwQoxFxxzSHyg4P2H4
q5a249vjLXFI/wKe738QD/sUPop98M8KbqnZb9PSr+RmXTatuXtgwvf2wV+B
5/tRLhVPJ4z5FeJjPgSM+RDs4fNzlyxPPj93qfeh3hqSx30pxMf9K+jj/hUw
7l8hPN/v0OJ3MFjA1TcX7t7Be0pDljfuE/5+ZPHcPG1JD/mFHjD0lPB/oaek
Z+p5Xz2eWJM55P3EuL2Trcrx2SHu6xpsTawyh2OVEffJh9H9MdyfVPhFBnOP
Cbt3s7vgLxlyP1i/D8ffQ2v32QrSfAP3O9G/+H14uj9m2ffKkP2L3890yfkQ
z79LziegBww97L/z8nTJ+xL/psfrm87reXnSfJavx0if1w9hvp9C4fl61qWe
B/xA9zd4eyR7+PqTMPQwv4J9mH/hfiww8ovxEvYp9x8XEA/7wPP9Dy38IO0+
pWlfmq47l10qi/0Zcz00YmOz8inxnsXNVs1ekWnOc3y/xi15zDeAMd9Qwhdx
s9gph8XctQ7rL7c8n8D8AO2Ln6/RfBXzA2DMD2A/9H6+9zShc7Yh7VP4Idp8
ZIs2v/iH8Rf/c8D4xPeD3fL8ga/H3KzEsXqngppgP93DHm22p342HPvpHslD
Twn/F3pIj6+PNT62h513Zex4Jhrmg2424FbV0WvLY7+fMF9vu1netm0Wj+8p
9gtGavzvZD/fjyKs6/H9Iw0XIYz6UPJn1i/KA/WB8xTUh5K/CC3/E4lH/Srn
PxU0eztr9kRo/D/o6fahPSv2mu0P5z0Yz7Gfj/EcGPNd5XzFbM84j/qv83Hw
mJ9iPo/5JPaH0J7BQ08JH0UP83sFN9LSm6LFH0D5wfoI5xXQU85/zlJ5QA8Y
8xeUJ+YvKG/MX9B+sB5EfWI9eN3e9WmBuS45351SqU+xo3tdcn5f8dCCoGUx
3PJ/Nq/XL59aK5dbrIeJ5/e9tPCm3oPgQ21HVHRLvUmXng9v0dst66N801QR
1ba4ZX3ce1x+V9a3brn+mHW+etzd6TxyvaDw5vx+QremV6IX9cj1QtkvIz9c
6+CR/yN4fn9Sxb5TPFIPGP6qeli7rHOdHqn3sXb3VhX6eqR9wLCv4e4G9cIq
eWR7WVQ6d+GBsUjPk61Ij5/yeKS/irPCOelLc4/0z8DovwiP/rZ2ZgJ35Sfi
/Oyim31eHSPFwv1u6Q8UbBBG/6i578Ox2PPdsn+8rP/To1tX3bI9w170N2Do
Kfkz9VD+0EN5QQ/lDz1g6KG+4A9Q3/B/4DFegsf6XMGzNewjjPv8aF94T4L2
h/cLaJ94D4H2jPcBCj5nSIz3C7XzDe3Z5hH2o4nHexfwmJ8qOB1hPj+j+Hy+
51T5nIbsj/x9kFNi/j7QKfPD3wc6ZX75e0OnLA/+vop46/3VYIrP32uRvvWe
y0s8f/9F8a33YsVJ38JvHBJb4XM72dXn9yoftAs+hZMND0/kXzTJHXgoV/fV
L6I7WZEYxXsNOSHwLofE0OuTKl/xe0tJT+FNvcsj3dOaJPRIvaHJBq6rVNsj
9YBvvK+wK89KBys0a/HxTMMEbk/YCj/Pwe4MXZPi9+UCNyJspTfFwWZ02ur2
nBLYRpi/l9PCd3OwcYkvFJ71QPBLHOyPbMcffd5Dekr6A8hei9/gYCdzhbdb
kE3Ef+Bg6St0zBn7q8j/WQfrvKFWgpy7qfwU3iy/FiEtbjS/SOUHXteDfcBW
/V+h9C38q2aPmd9ea+aMGNBI8DsoP9BDfv6rXs65wQ333nNLPdSv1T5fOKR/
sfAawvw9JIW32ntqp9Tj7z9Jn7/vc6rh31P7gx7aK39fSfzf2afYf0VrvweJ
R/0qvFkfB/JlfVZzCNUHMNoL6hvtT6n/Slr4bqSP9qykP8Wh9p+/aH8YT6EH
DPswnkIP4wP0wKO/gX9/IO6pJi6NH0v6Fq5P2ApfhvqXhf+0q3gr4cTTT9yc
9Ztdxs/RavqrsxPtsr1Y/D67as+fxENPCW/qYbyy+D/ssj1AD+0FehifoAf8
v+pZ9q8lvnzpxrESz7HL+rP4U3ZZvxa/0y77l8W/tMv6hR4w9NB/Q+PnTVFz
lF36qzYXX2Uf0IP4gUu2l9jahPjp4UNqvGqg8YOoPiy+g136Q4tfQPH/Tm/w
ijdxL0fzSr3jux/vKn+J9LKX2Rfhn+0JXF2rvjOfxy790f40qVo1q0n5t/je
dunfrPiriLf0bxFv5TcV+U8Ln7dLbJVPAgdb29I388A6gQ/bJbbCb7KzeNdL
9nvY3S3zC95Kf5ydeV4M3vTbc7e0D7xlf0virz64Fj47lHgLJyf8Zsvikeej
UfgfR3aameSJjcXpuez04PyewKyuMstrXbSx1TFOPWvc2sP5hHb2MdXBJZFV
BT5qkxh61fOzJjkyeaTerIXTa9S8KfRXaLgdYSv+XBu7t2V89KXbhb1nbKzI
8WHbEkwT+YtnZ31u9+3WrpPIfzm75FG/iI/yA4/2AmyV9zQKj/qAPaiPl+m6
5G0d4ZbtGdgKv8zsn4Vb3zncj/QmLa5y8Ell0qs5qW7i0S1F//pKvNWfijjY
1R1lBjXIIPhMDlasePIWna67OB/sYP1qJ8h8equL9++hGt+Z4ut6VvjmDjU9
Uw/2WulVdMj8wz6lPB6Z/qzypgzDP1B7Lnv4SunmJUT730M8+gfi6/WB/obw
Fk6vxTf772XHyvMPTgucmLCVXhUtfEEtvWc2Nb3LNhneaj8HtPa1XuPv22R6
sC9nu4gJdVZ+3/6gp7THTzZ24EO3gsfrCLxdw70J8/KysWSJ2z0olEPws2xs
x7RJsRM3EfrDbazFT1szP5kjcE0NxyNs5ed1KEu65Hr5w5dFf7oeyrYVjuta
ksYj+r/Zv2t8SZbgNek19Lw52vaYiF/MxhadPrZm7AQR/yfioaeE/ws9pIf8
gkd+wXP/STz3n3aVj2mX+eHtzSaxFf6dje2b9GBQqxiklz7Bnhaj9or0jttY
54Gz6qwY7pZ6KF+0F5Qf2gv0Ub9K+a3X+PuUPvwV0kd7UfRNf6XYZ/aPk28O
r8j9iPzV0OtnXu1P4vnb/nYnJJa9aheP7G/jLufpnGU1jUd/vMicb/BIjxyP
wFv9uY5D8lZ/7+dg2eOmuXunqeDbONjxcRVjRM4T8R0OFp66ecb5VzG+O1iB
mB2aBsbyCn/oYBdGTemfsZJX+EMHG9N99r7tzQU/zcFKfo28OWOB4A872MDk
22d96iP4TRT/7/Syzhtdpn86r7QPmM8/HKz9xkGvb7wR+fET5vM3Cs/nRxq/
1sEi83svxNzikf5UwUUIw58mrhI6sdkkgXMQxvzU5axTd387mp9GtKscJ3dN
Wl+Cx3wXGPNnhMf8WcHFNb3MDtbgbcsscYeI9BI52Ie+4yrc2eWR8/uqk4e+
rz4L613C0Bu3pM/axd3F/LwV8VhvQQ/rmZWtfhk86J5YP8VySt7CkRQe6yPo
8e+xEObfd3Gwp+lXJM9+0SPXWwvibnTt+SLwL4T5/oNmTyfKP/Ri3ejUMmKp
4CdQ+cI+lB/0FFyVsBW/sKbf1Fy/Jwi73NJP9il8FPugp5THz5R/vt9C5Q+9
0kUWHhu6jvRubT30sOlzyi94vt9C8S2cgbAVvqHZ33/v2vaHhqSX/UybHG3z
Un2A59+3ofj8+zZOyfPzT6fk+fkn8fz80yn1cR+z44PG14/G9oj9NINt+2LM
KHgd+2mGylcxWNrOIz4tq+yR9x2bDeu/MWEGwTcxWOIki049MkgPGHqRf65K
PbKfR97vBMZ90faDzhVrud0j73du+eXo04NTPfJ+J3jcn1T4kVp63YnX7ePn
i2Q/P+/V8mPmd/WsHh07vHN/l1/Yp4SPUn66Hj8/dsr0sf8HHvt/iI/9P/D8
e15a+HVOaR/0Pq5pn+fkSYEXEebn2xSe728Sxv1dhMd7AyV+LyeLKDOl+qpE
wv4WGm/qVd/f7HaR5d/roX7B4/6zEn6Vkz1vMDpa0gdueR8Y6UGvwZ5tjcfU
ofYy48La9M+yU3tGfF0P7yGA8R4C6eM9BDDfz9XCl3Wyss0Gbe2853s9vDdQ
eLP8Jlz2zJ48lMrvXkiJgRtruWX5KbxZfpdfhDjfhrll/y3SKn+51Nncsv/2
6ZvtbfgXl9QDRn4RHvYBwz6kr9v3X+sD+fu7/N55suRcUDT0L8Iov3HdT7ws
UB79wSExb7+m//z6NlHCnugPpn8dliHvo42i/TNz/pKkao2Dr8g/l5zeusmi
Ql7xPTlz/rKyUYb4Cbzie2MOlq/k8NL3agg8mjD8/bmdK217B3ulXuazEYlz
+klP4Y9o8TdTetBT0jf1ju5xnm99R9jbVsP5NPzYLjH37w6W+mKDCUd2Cv5H
c34UlLvb04EYv+0qH0WPf7+M4v+bHv++nTkfK1tk2+jFAkcjDPvC1yaYs7IN
5gN2djz3nYEnCpDe4ORPD7QPJT3w/PuFDpa24uVyReILXJQw7IvcH8NIUl3g
63YVzyXM24edJb7yIaDzT2gfdral2U8Fg7yCf2VnsXqlerCmJPwlYd7e7KzB
+EQLkgUIvIgw/96bnX1IXXzni/qC329nVQvkCw/JjfZLPO+fhLk/ovC8P2nx
Z9rZjIjY3m6P0d+J5/efNByXMM+fjT3dGDylcHOUl439UjF8TeIFKC/CvLxs
7FZoxzad+pBegdYtsp92IH82iXn+bCy8n+9asSLC/oIUno+ndsnz+zVm/Uy2
TZ/6o+AH2Vn7DL03dK0l+I1m/RTp0uFcVjFePzTro2br3KW+4HzOzlw7qyR0
7YI/srPVJTK86DVY8G/t7GOd5Muu+MT5YB4Hq94oQbOKpXF+6GATusfINC8Z
zg8d7N6TSzH2nMN9DgebdeF2zUaf8F5Eiz/bIfXx/hc83v9CH+9/oY/3v0Vi
nt6ebQ3urzhUHKHhZoT5/QsHG95z+dzqXXH/wsHKN9tw9/Z03OdwsEmXxx6K
43XJ/D4Iabky108umV+FN/Nbc/+0JBEDKb+zK3R6va+aS+Y3JHfPMs3a4D6M
gy2ZG5JxWAHx/qa7g31NlT/Gkhd4P+dgtnFx7h5aj/tUDvZDz8T5Wv2B+1QO
FvbifuJRv+J+lsYvoPh8vCB9Pp4Rz8dHB1sW5/rBxz3w/UEHe5vu/KD6wQK7
CUOvUuFj5VfnI71pixdlPvUM9+UI8/NYB3uSaUDs12vF/bxkDlZlmutBiu5O
6f+mJyp2tGRpp/R/4OH/FN70f7ez5h02PZlT+ucyM2O12XbOIf3zkNUfs2VY
4xDnWQ52KefZeBW7Cr6ug+Uof2T33PqCL+VgvddH/LY7qYOvD7I52Km8/Ube
PmPnvNPBMlTqXrX6Krsc31ra231ZNMIux8t1bZpujt/ULscj7+uRZ+7Ntcvx
CJj7CwcLuDYp7dB93+thfPv9aPWbB+vapX3A0It/q/ysvDntMr/AGI9C3xez
j4ku/oczSeP7O5jflap/vYc2OX4AY/xY2iFRmVWRNqkX7d69DCeH2WT52X27
or+qbZP1AQy9BLUO1ZjQkfQUPooexiNF/y/05nXZvC00+/d6fDyh9Pj8m3i+
PnBKHu9NFb6gky0/O+NO8kQ2+X713cMJc7rfD5XvORV+kBbfnP/BfugBQ2/D
yedNOqywST2Fj6L3d/b9r3qoP7xHRP3iPSJ4vEd8Mzj26yRzbPK9aeCMTys6
h9vke86pSc9NmFzOJt9z1vl09XyRxvjfPWFdD+8lFf0A0uf3Www2atWrFmdC
xP/cww12LvJh5hIF8L93DX9wSoz38fnKRcZ2vgiV3xe4keNonbcpbfJ9PPTx
Pr54qbSD144n+8Bzf02Y+2un1MP3eFAe+N6DUj5rnbI8YB/qB+/3Ub+wD+0b
+QWP/ALj+wdK+DSGml5sKn/oob75+GlI/4D6+NLf3blNBbt8nwxeby94Xwse
6xnEx3oGPNZb4LHeWhx/4NhavfB/L40319O1pgbnO5oa/svJ5iTMl+TZJZvc
fwGGnpKeuX6Dv8N6Ff4T6/Pk1X7a9yixSG+/k7Xe/mFJwtM2ud5X+HvUf2Af
8L/pwT5F38wvK3p6TMGp8IcaP4n6N/ILrOshv5kWxXi+7L1NrleBUR9K+JmU
PvRSLlveqaFBeo3YgrzripIeMPQUf3hL85cpDVY52gjjwu5QuX/wS4/G5f8c
EirbCzDeO9dr3GbQL8tCpd6Ci1VbbG1Pek+fls2cvhbpVW2eInaFH0Pl/tC4
Xj/unHM3RO5f/TE+Znj0XSFy/yr7b38WaTIzRL7/BY/38cD4XqkSfq3BjhfI
3KDShe/18J5dCf8XerAPeqVjFb3UJ2uofF+L/ME+5A/vp2dceXrffzxEvndW
+Kta/g+RPt4nD06TZ8q1zyHyvYvCZ3TJ+Loe3jsjPbyfUXhT787LO/N3LQmR
74mB/84+8Hx8Ip7PX8l+3CdU6n8PtSfcJ1T4W4ZsP3iPo7SvmC4Wo17XgyVO
hsrvNSvtOatLbc92l+Rx31EJb+op4/U/6OG9C+zBexfw+J65wqdzqflt4GK3
Rhvv3GGh8r0Gygt6wNBD+UIP7RN6Cl+W6hPvXcq23jn0VtsQ+d7leeiBIwMm
hsj3JArfi+LrerAPGO97CsW74sk6+Hv78B4H7RffgwfG9+ARns+vDanH1+OG
mp+4lB70lPD/oIfv1QPz+bAWvj/5A11Prw+8j1LK/5Kh1o/ZXqCH74WD5+tH
4vE9847bXjyO7BYi3+OkrZo6/oK1IfI9TuSRCtkHPEP/c7HwTTXaZEoRKt/3
ZA1sP+xzw1BZv0cPTF5waSz6n4sNXPfrg/D18N8uVnL2bwVT/xEq9gvckuf+
0S15vId4PHxVt41fQ+V7CGC8r8B8CnoKH0UP95+V9H9wszEp+icr86vAh1wS
I79K+IcuVd/Uw/wKephfIb/gub/R+vdxrX9vc6n9exHF5/VN6fP26JL55/3F
Jeef0APm/obCc3/jljzsA+b+yy3ny3i/BYz8KuGj1C/0lPI09TDe8/0Rt8wv
3veAx/sehZ/tluWF90fwz3gvBH8KPQVXIIz3OIq+T9OfSPpof8B4j4PweG+g
8BGUHt4bID28XwCP9xXg8b4CPH8fSzzeawDz7yFo4Yd7pD14j63geITxngT5
4d/79cjxBO+xgfn/7DxyfOH/j/OwAvOD1uwoI/jBHul/+feXPXK8sXAPwroe
3rug/UDvQp4eR2f2IPuQHuwDxnschEd+Fb4cpYf3M0gP71PQnvE+BTzeTyvh
31D7/V/18N4FPNqLwiek/KC9KHx+jxo/DfF4n4f84n2ewmf3qP0vwCP9DZ/P
edT1ZDjx/L2Kxk/3qOvNIcTrenx+SO2Z78eSPdCDvfz9i5a/apR/5Fcpj9Ie
Od7gfSMw3jeifNF/gVEfGO9QH+1tzSr584XK90fAqF+Ex/so8Oi/4NFegPEe
TGm/Ncl+tGdgtD+Ex/s3pb3Mc8v2j/dvGM/x/g0Y7+mU/LZzy/Ed7+0V/ITG
f7y379Fw284th0V57nWxzH/cuDQtHtqDhqsRxveM1P0dl7qfk53GI6w/wGM9
Ax7rIyW8uf6AfVh/wH6sP5B/6KE8+XzAUOcvGSn/+H5T6qujvOVbhcr8Nnk1
MNWcKrQ+Asb6aEtrz0cWh+wDhn0ID/sS9l5StE9/sm9387Xh6X6j/AJjPQh7
+HzPkO2Rz/cMOd/D9wDA8/m3Fr4JlQ/0lPL5i/JDfD2/KL/EN4tfu3kwRJYf
7EH9KviUoeKJhPH9OqSH9T54fB9OCW+uz5X0TT3Xu3zTqy6EPYSx3xmrf8iG
LDdC5H6Ygn8njP1EtT6dav0HUP1g/09pP7ENtX2Zekr/yk71zf0jtW/+3lDj
ww3W9tmFKR9uhsr9P2BdT7cP+VXr09Dar1PFawljvxPxsT+p+Jt6hsqXNtTy
yK7xBqWP/KL8kd+V8XqejJYR45XBPmToNKrxe8FPN1iDKbU7DN4WIr+fCB77
z0p4U69q0ZbVIk+FSPsU/MGp4i2E8X3vcTX9X7OvEHgFYXzf+87OUrdqdAyR
3/eesbRS7rtTQuT31sHz8cVcb54t+OuS2iFifDFYr4c5HAmyC5xLw/edKl5M
mH9vxsn2fc2QtN3XYPG9GYrPv49F6fH5l8GG1o0/4HBCwTc1WNmSAftbFRV8
kMEmrHy0dNTbYDGfM1j16a+f506P+SHx/P8cBru852bTJycEXkaY/2/FYDkv
XszYYFkw/59IMpfKfzVYkbLbayaeLPBODfcjzP+3YrDha6fkK+wIFv+DIR75
hT7/Xo+GI50S8+8TOWV58Pk58Xx+Tjyf7xPP61ML39Ip86vr8f+POGX58e+f
Odm97HvHrtgi+OdONivJsTN1rgXL+kX5o34/Dvpc4kClEKkHjPwq4U2955nT
JYxnhPyrHspP4c32AnvQXmAvX09ovNleXg5btLndfJGfjhq/0GANP55L+zCW
aE/nNT5Sa2/vyD7+fSaX5K324XdJnv9fh/j/A3TNe+o=
   "], 
   {AbsoluteThickness[0.2], LineBox[CompressedData["
1:eJwU3UMUIEsSBdBp+7dt27Zt27Zt27Zt27Zt2/bcXtxT61pkITPiRfwGbSu0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     "]]}],
  AspectRatio->Automatic,
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],

Cell["\<\
And here it is with color mapped to the distance from the origin.\
\>", "SolutionText",
 CellTags->"10.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"walk", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hue", "[", 
           FractionBox[
            RowBox[{
            "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            "len"], "]"}], ",", 
          RowBox[{"AbsoluteThickness", "[", ".25", "]"}], ",", 
          RowBox[{"Line", "[", "#", "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"2", ",", "len"}], "]"}], ",", "2", ",", "1"}], "]"}]}], 
      "]"}]}], "]"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.2 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJysfXd4VcW3dggBQie9h/Sc9B5SOUNCE5DeREQERJpKJypNQDpIkyYiICpV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   "], {
    {Hue[
      NCache[
       Rational[2, 14307], 0.00013979171035157615`]], AbsoluteThickness[0.25],
      LineBox[{2, 3}]}, 
    {Hue[
      NCache[
       Rational[1, 4769], 0.00020968756552736424`]], AbsoluteThickness[0.25], 
     LineBox[{3, 4}]}, 
    {Hue[
      NCache[
       Rational[4, 14307], 0.0002795834207031523]], AbsoluteThickness[0.25], 
     LineBox[{4, 5}]}, 
    {Hue[
      NCache[
       Rational[5, 14307], 0.0003494792758789404]], AbsoluteThickness[0.25], 
     LineBox[{5, 6}]}, 
    {Hue[
      NCache[
       Rational[2, 4769], 0.0004193751310547285]], AbsoluteThickness[0.25], 
     LineBox[{6, 7}]}, 
    {Hue[
      NCache[
       Rational[7, 14307], 0.0004892709862305165]], AbsoluteThickness[0.25], 
     LineBox[{7, 8}]}, 
    {Hue[
      NCache[
       Rational[8, 14307], 0.0005591668414063046]], AbsoluteThickness[0.25], 
     LineBox[{8, 9}]}, 
    {Hue[
      NCache[
       Rational[3, 4769], 0.0006290626965820927]], AbsoluteThickness[0.25], 
     LineBox[{9, 10}]}, 
    {Hue[
      NCache[
       Rational[10, 14307], 0.0006989585517578808]], AbsoluteThickness[0.25], 
     LineBox[{10, 11}]}, 
    {Hue[
      NCache[
       Rational[11, 14307], 0.0007688544069336689]], AbsoluteThickness[0.25], 
     LineBox[{11, 12}]}, 
    {Hue[
      NCache[
       Rational[4, 4769], 0.000838750262109457]], AbsoluteThickness[0.25], 
     LineBox[{12, 13}]}, 
    {Hue[
      NCache[
       Rational[13, 14307], 0.000908646117285245]], AbsoluteThickness[0.25], 
     LineBox[{13, 14}]}, 
    {Hue[
      NCache[
       Rational[14, 14307], 0.000978541972461033]], AbsoluteThickness[0.25], 
     LineBox[{14, 15}]}, 
    {Hue[
      NCache[
       Rational[5, 4769], 0.0010484378276368212`]], AbsoluteThickness[0.25], 
     LineBox[{15, 16}]}, 
    {Hue[
      NCache[
       Rational[16, 14307], 0.0011183336828126092`]], AbsoluteThickness[0.25],
      LineBox[{16, 17}]}, 
    {Hue[
      NCache[
       Rational[17, 14307], 0.0011882295379883974`]], AbsoluteThickness[0.25],
      LineBox[{17, 18}]}, 
    {Hue[
      NCache[
       Rational[6, 4769], 0.0012581253931641854`]], AbsoluteThickness[0.25], 
     LineBox[{18, 19}]}, 
    {Hue[
      NCache[
       Rational[1, 753], 0.0013280212483399733`]], AbsoluteThickness[0.25], 
     LineBox[{19, 20}]}, 
    {Hue[
      NCache[
       Rational[20, 14307], 0.0013979171035157615`]], AbsoluteThickness[0.25],
      LineBox[{20, 21}]}, 
    {Hue[
      NCache[
       Rational[7, 4769], 0.0014678129586915495`]], AbsoluteThickness[0.25], 
     LineBox[{21, 22}]}, 
    {Hue[
      NCache[
       Rational[22, 14307], 0.0015377088138673377`]], AbsoluteThickness[0.25],
      LineBox[{22, 23}]}, 
    {Hue[
      NCache[
       Rational[23, 14307], 0.0016076046690431257`]], AbsoluteThickness[0.25],
      LineBox[{23, 24}]}, 
    {Hue[
      NCache[
       Rational[8, 4769], 0.001677500524218914]], AbsoluteThickness[0.25], 
     LineBox[{24, 25}]}, 
    {Hue[
      NCache[
       Rational[25, 14307], 0.0017473963793947019`]], AbsoluteThickness[0.25],
      LineBox[{25, 26}]}, 
    {Hue[
      NCache[
       Rational[26, 14307], 0.00181729223457049]], AbsoluteThickness[0.25], 
     LineBox[{26, 27}]}, 
    {Hue[
      NCache[
       Rational[9, 4769], 0.001887188089746278]], AbsoluteThickness[0.25], 
     LineBox[{27, 28}]}, 
    {Hue[
      NCache[
       Rational[28, 14307], 0.001957083944922066]], AbsoluteThickness[0.25], 
     LineBox[{28, 29}]}, 
    {Hue[
      NCache[
       Rational[29, 14307], 0.0020269798000978542`]], AbsoluteThickness[0.25],
      LineBox[{29, 30}]}, 
    {Hue[
      NCache[
       Rational[10, 4769], 0.0020968756552736424`]], AbsoluteThickness[0.25], 
     LineBox[{30, 31}]}, 
    {Hue[
      NCache[
       Rational[31, 14307], 0.00216677151044943]], AbsoluteThickness[0.25], 
     LineBox[{31, 32}]}, 
    {Hue[
      NCache[
       Rational[32, 14307], 0.0022366673656252184`]], AbsoluteThickness[0.25],
      LineBox[{32, 33}]}, 
    {Hue[
      NCache[
       Rational[11, 4769], 0.0023065632208010066`]], AbsoluteThickness[0.25], 
     LineBox[{33, 34}]}, 
    {Hue[
      NCache[
       Rational[34, 14307], 0.0023764590759767948`]], AbsoluteThickness[0.25],
      LineBox[{34, 35}]}, 
    {Hue[
      NCache[
       Rational[35, 14307], 0.0024463549311525825`]], AbsoluteThickness[0.25],
      LineBox[{35, 36}]}, 
    {Hue[
      NCache[
       Rational[12, 4769], 0.0025162507863283707`]], AbsoluteThickness[0.25], 
     LineBox[{36, 37}]}, 
    {Hue[
      NCache[
       Rational[37, 14307], 0.002586146641504159]], AbsoluteThickness[0.25], 
     LineBox[{37, 38}]}, 
    {Hue[
      NCache[
       Rational[2, 753], 0.0026560424966799467`]], AbsoluteThickness[0.25], 
     LineBox[{38, 39}]}, 
    {Hue[
      NCache[
       Rational[13, 4769], 0.002725938351855735]], AbsoluteThickness[0.25], 
     LineBox[{39, 40}]}, 
    {Hue[
      NCache[
       Rational[40, 14307], 0.002795834207031523]], AbsoluteThickness[0.25], 
     LineBox[{40, 41}]}, 
    {Hue[
      NCache[
       Rational[41, 14307], 0.0028657300622073113`]], AbsoluteThickness[0.25],
      LineBox[{41, 42}]}, 
    {Hue[
      NCache[
       Rational[14, 4769], 0.002935625917383099]], AbsoluteThickness[0.25], 
     LineBox[{42, 43}]}, 
    {Hue[
      NCache[
       Rational[43, 14307], 0.0030055217725588872`]], AbsoluteThickness[0.25],
      LineBox[{43, 44}]}, 
    {Hue[
      NCache[
       Rational[44, 14307], 0.0030754176277346754`]], AbsoluteThickness[0.25],
      LineBox[{44, 45}]}, 
    {Hue[
      NCache[
       Rational[15, 4769], 0.003145313482910463]], AbsoluteThickness[0.25], 
     LineBox[{45, 46}]}, 
    {Hue[
      NCache[
       Rational[46, 14307], 0.0032152093380862514`]], AbsoluteThickness[0.25],
      LineBox[{46, 47}]}, 
    {Hue[
      NCache[
       Rational[47, 14307], 0.0032851051932620396`]], AbsoluteThickness[0.25],
      LineBox[{47, 48}]}, 
    {Hue[
      NCache[
       Rational[16, 4769], 0.003355001048437828]], AbsoluteThickness[0.25], 
     LineBox[{48, 49}]}, 
    {Hue[
      NCache[
       Rational[49, 14307], 0.0034248969036136155`]], AbsoluteThickness[0.25],
      LineBox[{49, 50}]}, 
    {Hue[
      NCache[
       Rational[50, 14307], 0.0034947927587894037`]], AbsoluteThickness[0.25],
      LineBox[{50, 51}]}, 
    {Hue[
      NCache[
       Rational[17, 4769], 0.003564688613965192]], AbsoluteThickness[0.25], 
     LineBox[{51, 52}]}, 
    {Hue[
      NCache[
       Rational[52, 14307], 0.00363458446914098]], AbsoluteThickness[0.25], 
     LineBox[{52, 53}]}, 
    {Hue[
      NCache[
       Rational[53, 14307], 0.003704480324316768]], AbsoluteThickness[0.25], 
     LineBox[{53, 54}]}, 
    {Hue[
      NCache[
       Rational[18, 4769], 0.003774376179492556]], AbsoluteThickness[0.25], 
     LineBox[{54, 55}]}, 
    {Hue[
      NCache[
       Rational[55, 14307], 0.0038442720346683443`]], AbsoluteThickness[0.25],
      LineBox[{55, 56}]}, 
    {Hue[
      NCache[
       Rational[56, 14307], 0.003914167889844132]], AbsoluteThickness[0.25], 
     LineBox[{56, 57}]}, 
    {Hue[
      NCache[
       Rational[1, 251], 0.00398406374501992]], AbsoluteThickness[0.25], 
     LineBox[{57, 58}]}, 
    {Hue[
      NCache[
       Rational[58, 14307], 0.0040539596001957084`]], AbsoluteThickness[0.25],
      LineBox[{58, 59}]}, 
    {Hue[
      NCache[
       Rational[59, 14307], 0.004123855455371497]], AbsoluteThickness[0.25], 
     LineBox[{59, 60}]}, 
    {Hue[
      NCache[
       Rational[20, 4769], 0.004193751310547285]], AbsoluteThickness[0.25], 
     LineBox[{60, 61}]}, 
    {Hue[
      NCache[
       Rational[61, 14307], 0.004263647165723073]], AbsoluteThickness[0.25], 
     LineBox[{61, 62}]}, 
    {Hue[
      NCache[
       Rational[62, 14307], 0.00433354302089886]], AbsoluteThickness[0.25], 
     LineBox[{62, 63}]}, 
    {Hue[
      NCache[
       Rational[21, 4769], 0.0044034388760746486`]], AbsoluteThickness[0.25], 
     LineBox[{63, 64}]}, 
    {Hue[
      NCache[
       Rational[64, 14307], 0.004473334731250437]], AbsoluteThickness[0.25], 
     LineBox[{64, 65}]}, 
    {Hue[
      NCache[
       Rational[65, 14307], 0.004543230586426225]], AbsoluteThickness[0.25], 
     LineBox[{65, 66}]}, 
    {Hue[
      NCache[
       Rational[22, 4769], 0.004613126441602013]], AbsoluteThickness[0.25], 
     LineBox[{66, 67}]}, 
    {Hue[
      NCache[
       Rational[67, 14307], 0.004683022296777801]], AbsoluteThickness[0.25], 
     LineBox[{67, 68}]}, 
    {Hue[
      NCache[
       Rational[68, 14307], 0.0047529181519535895`]], AbsoluteThickness[0.25],
      LineBox[{68, 69}]}, 
    {Hue[
      NCache[
       Rational[23, 4769], 0.004822814007129377]], AbsoluteThickness[0.25], 
     LineBox[{69, 70}]}, 
    {Hue[
      NCache[
       Rational[70, 14307], 0.004892709862305165]], AbsoluteThickness[0.25], 
     LineBox[{70, 71}]}, 
    {Hue[
      NCache[
       Rational[71, 14307], 0.004962605717480953]], AbsoluteThickness[0.25], 
     LineBox[{71, 72}]}, 
    {Hue[
      NCache[
       Rational[24, 4769], 0.0050325015726567415`]], AbsoluteThickness[0.25], 
     LineBox[{72, 73}]}, 
    {Hue[
      NCache[
       Rational[73, 14307], 0.00510239742783253]], AbsoluteThickness[0.25], 
     LineBox[{73, 74}]}, 
    {Hue[
      NCache[
       Rational[74, 14307], 0.005172293283008318]], AbsoluteThickness[0.25], 
     LineBox[{74, 75}]}, 
    {Hue[
      NCache[
       Rational[25, 4769], 0.005242189138184106]], AbsoluteThickness[0.25], 
     LineBox[{75, 76}]}, 
    {Hue[
      NCache[
       Rational[4, 753], 0.005312084993359893]], AbsoluteThickness[0.25], 
     LineBox[{76, 77}]}, 
    {Hue[
      NCache[
       Rational[77, 14307], 0.005381980848535682]], AbsoluteThickness[0.25], 
     LineBox[{77, 78}]}, 
    {Hue[
      NCache[
       Rational[26, 4769], 0.00545187670371147]], AbsoluteThickness[0.25], 
     LineBox[{78, 79}]}, 
    {Hue[
      NCache[
       Rational[79, 14307], 0.005521772558887258]], AbsoluteThickness[0.25], 
     LineBox[{79, 80}]}, 
    {Hue[
      NCache[
       Rational[80, 14307], 0.005591668414063046]], AbsoluteThickness[0.25], 
     LineBox[{80, 81}]}, 
    {Hue[
      NCache[
       Rational[27, 4769], 0.005661564269238834]], AbsoluteThickness[0.25], 
     LineBox[{81, 82}]}, 
    {Hue[
      NCache[
       Rational[82, 14307], 0.0057314601244146226`]], AbsoluteThickness[0.25],
      LineBox[{82, 83}]}, 
    {Hue[
      NCache[
       Rational[83, 14307], 0.00580135597959041]], AbsoluteThickness[0.25], 
     LineBox[{83, 84}]}, 
    {Hue[
      NCache[
       Rational[28, 4769], 0.005871251834766198]], AbsoluteThickness[0.25], 
     LineBox[{84, 85}]}, 
    {Hue[
      NCache[
       Rational[85, 14307], 0.005941147689941986]], AbsoluteThickness[0.25], 
     LineBox[{85, 86}]}, 
    {Hue[
      NCache[
       Rational[86, 14307], 0.0060110435451177745`]], AbsoluteThickness[0.25],
      LineBox[{86, 87}]}, 
    {Hue[
      NCache[
       Rational[29, 4769], 0.006080939400293563]], AbsoluteThickness[0.25], 
     LineBox[{87, 88}]}, 
    {Hue[
      NCache[
       Rational[88, 14307], 0.006150835255469351]], AbsoluteThickness[0.25], 
     LineBox[{88, 89}]}, 
    {Hue[
      NCache[
       Rational[89, 14307], 0.006220731110645139]], AbsoluteThickness[0.25], 
     LineBox[{89, 90}]}, 
    {Hue[
      NCache[
       Rational[30, 4769], 0.006290626965820926]], AbsoluteThickness[0.25], 
     LineBox[{90, 91}]}, 
    {Hue[
      NCache[
       Rational[91, 14307], 0.006360522820996715]], AbsoluteThickness[0.25], 
     LineBox[{91, 92}]}, 
    {Hue[
      NCache[
       Rational[92, 14307], 0.006430418676172503]], AbsoluteThickness[0.25], 
     LineBox[{92, 93}]}, 
    {Hue[
      NCache[
       Rational[31, 4769], 0.006500314531348291]], AbsoluteThickness[0.25], 
     LineBox[{93, 94}]}, 
    {Hue[
      NCache[
       Rational[94, 14307], 0.006570210386524079]], AbsoluteThickness[0.25], 
     LineBox[{94, 95}]}, 
    {Hue[
      NCache[
       Rational[5, 753], 0.006640106241699867]], AbsoluteThickness[0.25], 
     LineBox[{95, 96}]}, 
    {Hue[
      NCache[
       Rational[32, 4769], 0.006710002096875656]], AbsoluteThickness[0.25], 
     LineBox[{96, 97}]}, 
    {Hue[
      NCache[
       Rational[97, 14307], 0.006779897952051444]], AbsoluteThickness[0.25], 
     LineBox[{97, 98}]}, 
    {Hue[
      NCache[
       Rational[98, 14307], 0.006849793807227231]], AbsoluteThickness[0.25], 
     LineBox[{98, 99}]}, 
    {Hue[
      NCache[
       Rational[33, 4769], 0.006919689662403019]], AbsoluteThickness[0.25], 
     LineBox[{99, 100}]}, 
    {Hue[
      NCache[
       Rational[100, 14307], 0.0069895855175788075`]], AbsoluteThickness[
     0.25], LineBox[{100, 101}]}, 
    {Hue[
      NCache[
       Rational[101, 14307], 0.007059481372754596]], AbsoluteThickness[0.25], 
     LineBox[{101, 102}]}, 
    {Hue[
      NCache[
       Rational[34, 4769], 0.007129377227930384]], AbsoluteThickness[0.25], 
     LineBox[{102, 103}]}, 
    {Hue[
      NCache[
       Rational[103, 14307], 0.007199273083106172]], AbsoluteThickness[0.25], 
     LineBox[{103, 104}]}, 
    {Hue[
      NCache[
       Rational[104, 14307], 0.00726916893828196]], AbsoluteThickness[0.25], 
     LineBox[{104, 105}]}, 
    {Hue[
      NCache[
       Rational[35, 4769], 0.007339064793457748]], AbsoluteThickness[0.25], 
     LineBox[{105, 106}]}, 
    {Hue[
      NCache[
       Rational[106, 14307], 0.007408960648633536]], AbsoluteThickness[0.25], 
     LineBox[{106, 107}]}, 
    {Hue[
      NCache[
       Rational[107, 14307], 0.007478856503809324]], AbsoluteThickness[0.25], 
     LineBox[{107, 108}]}, 
    {Hue[
      NCache[
       Rational[36, 4769], 0.007548752358985112]], AbsoluteThickness[0.25], 
     LineBox[{108, 109}]}, 
    {Hue[
      NCache[
       Rational[109, 14307], 0.0076186482141609]], AbsoluteThickness[0.25], 
     LineBox[{109, 110}]}, 
    {Hue[
      NCache[
       Rational[110, 14307], 0.007688544069336689]], AbsoluteThickness[0.25], 
     LineBox[{110, 111}]}, 
    {Hue[
      NCache[
       Rational[37, 4769], 0.007758439924512477]], AbsoluteThickness[0.25], 
     LineBox[{111, 112}]}, 
    {Hue[
      NCache[
       Rational[112, 14307], 0.007828335779688264]], AbsoluteThickness[0.25], 
     LineBox[{112, 113}]}, 
    {Hue[
      NCache[
       Rational[113, 14307], 0.007898231634864052]], AbsoluteThickness[0.25], 
     LineBox[{113, 114}]}, 
    {Hue[
      NCache[
       Rational[2, 251], 0.00796812749003984]], AbsoluteThickness[0.25], 
     LineBox[{114, 115}]}, 
    {Hue[
      NCache[
       Rational[115, 14307], 0.008038023345215629]], AbsoluteThickness[0.25], 
     LineBox[{115, 116}]}, 
    {Hue[
      NCache[
       Rational[116, 14307], 0.008107919200391417]], AbsoluteThickness[0.25], 
     LineBox[{116, 117}]}, 
    {Hue[
      NCache[
       Rational[39, 4769], 0.008177815055567205]], AbsoluteThickness[0.25], 
     LineBox[{117, 118}]}, 
    {Hue[
      NCache[
       Rational[118, 14307], 0.008247710910742993]], AbsoluteThickness[0.25], 
     LineBox[{118, 119}]}, 
    {Hue[
      NCache[
       Rational[119, 14307], 0.008317606765918781]], AbsoluteThickness[0.25], 
     LineBox[{119, 120}]}, 
    {Hue[
      NCache[
       Rational[40, 4769], 0.00838750262109457]], AbsoluteThickness[0.25], 
     LineBox[{120, 121}]}, 
    {Hue[
      NCache[
       Rational[121, 14307], 0.008457398476270358]], AbsoluteThickness[0.25], 
     LineBox[{121, 122}]}, 
    {Hue[
      NCache[
       Rational[122, 14307], 0.008527294331446146]], AbsoluteThickness[0.25], 
     LineBox[{122, 123}]}, 
    {Hue[
      NCache[
       Rational[41, 4769], 0.008597190186621933]], AbsoluteThickness[0.25], 
     LineBox[{123, 124}]}, 
    {Hue[
      NCache[
       Rational[124, 14307], 0.00866708604179772]], AbsoluteThickness[0.25], 
     LineBox[{124, 125}]}, 
    {Hue[
      NCache[
       Rational[125, 14307], 0.008736981896973509]], AbsoluteThickness[0.25], 
     LineBox[{125, 126}]}, 
    {Hue[
      NCache[
       Rational[42, 4769], 0.008806877752149297]], AbsoluteThickness[0.25], 
     LineBox[{126, 127}]}, 
    {Hue[
      NCache[
       Rational[127, 14307], 0.008876773607325085]], AbsoluteThickness[0.25], 
     LineBox[{127, 128}]}, 
    {Hue[
      NCache[
       Rational[128, 14307], 0.008946669462500874]], AbsoluteThickness[0.25], 
     LineBox[{128, 129}]}, 
    {Hue[
      NCache[
       Rational[43, 4769], 0.009016565317676662]], AbsoluteThickness[0.25], 
     LineBox[{129, 130}]}, 
    {Hue[
      NCache[
       Rational[130, 14307], 0.00908646117285245]], AbsoluteThickness[0.25], 
     LineBox[{130, 131}]}, 
    {Hue[
      NCache[
       Rational[131, 14307], 0.009156357028028238]], AbsoluteThickness[0.25], 
     LineBox[{131, 132}]}, 
    {Hue[
      NCache[
       Rational[44, 4769], 0.009226252883204026]], AbsoluteThickness[0.25], 
     LineBox[{132, 133}]}, 
    {Hue[
      NCache[
       Rational[7, 753], 0.009296148738379814]], AbsoluteThickness[0.25], 
     LineBox[{133, 134}]}, 
    {Hue[
      NCache[
       Rational[134, 14307], 0.009366044593555603]], AbsoluteThickness[0.25], 
     LineBox[{134, 135}]}, 
    {Hue[
      NCache[
       Rational[45, 4769], 0.009435940448731391]], AbsoluteThickness[0.25], 
     LineBox[{135, 136}]}, 
    {Hue[
      NCache[
       Rational[136, 14307], 0.009505836303907179]], AbsoluteThickness[0.25], 
     LineBox[{136, 137}]}, 
    {Hue[
      NCache[
       Rational[137, 14307], 0.009575732159082966]], AbsoluteThickness[0.25], 
     LineBox[{137, 138}]}, 
    {Hue[
      NCache[
       Rational[46, 4769], 0.009645628014258754]], AbsoluteThickness[0.25], 
     LineBox[{138, 139}]}, 
    {Hue[
      NCache[
       Rational[139, 14307], 0.009715523869434542]], AbsoluteThickness[0.25], 
     LineBox[{139, 140}]}, 
    {Hue[
      NCache[
       Rational[140, 14307], 0.00978541972461033]], AbsoluteThickness[0.25], 
     LineBox[{140, 141}]}, 
    {Hue[
      NCache[
       Rational[47, 4769], 0.009855315579786118]], AbsoluteThickness[0.25], 
     LineBox[{141, 142}]}, 
    {Hue[
      NCache[
       Rational[142, 14307], 0.009925211434961907]], AbsoluteThickness[0.25], 
     LineBox[{142, 143}]}, 
    {Hue[
      NCache[
       Rational[143, 14307], 0.009995107290137695]], AbsoluteThickness[0.25], 
     LineBox[{143, 144}]}, 
    {Hue[
      NCache[
       Rational[48, 4769], 0.010065003145313483`]], AbsoluteThickness[0.25], 
     LineBox[{144, 145}]}, 
    {Hue[
      NCache[
       Rational[145, 14307], 0.010134899000489271`]], AbsoluteThickness[0.25],
      LineBox[{145, 146}]}, 
    {Hue[
      NCache[
       Rational[146, 14307], 0.01020479485566506]], AbsoluteThickness[0.25], 
     LineBox[{146, 147}]}, 
    {Hue[
      NCache[
       Rational[49, 4769], 0.010274690710840848`]], AbsoluteThickness[0.25], 
     LineBox[{147, 148}]}, 
    {Hue[
      NCache[
       Rational[148, 14307], 0.010344586566016636`]], AbsoluteThickness[0.25],
      LineBox[{148, 149}]}, 
    {Hue[
      NCache[
       Rational[149, 14307], 0.010414482421192424`]], AbsoluteThickness[0.25],
      LineBox[{149, 150}]}, 
    {Hue[
      NCache[
       Rational[50, 4769], 0.010484378276368212`]], AbsoluteThickness[0.25], 
     LineBox[{150, 151}]}, 
    {Hue[
      NCache[
       Rational[151, 14307], 0.010554274131544]], AbsoluteThickness[0.25], 
     LineBox[{151, 152}]}, 
    {Hue[
      NCache[
       Rational[8, 753], 0.010624169986719787`]], AbsoluteThickness[0.25], 
     LineBox[{152, 153}]}, 
    {Hue[
      NCache[
       Rational[51, 4769], 0.010694065841895575`]], AbsoluteThickness[0.25], 
     LineBox[{153, 154}]}, 
    {Hue[
      NCache[
       Rational[154, 14307], 0.010763961697071363`]], AbsoluteThickness[0.25],
      LineBox[{154, 155}]}, 
    {Hue[
      NCache[
       Rational[155, 14307], 0.010833857552247151`]], AbsoluteThickness[0.25],
      LineBox[{155, 156}]}, 
    {Hue[
      NCache[
       Rational[52, 4769], 0.01090375340742294]], AbsoluteThickness[0.25], 
     LineBox[{156, 157}]}, 
    {Hue[
      NCache[
       Rational[157, 14307], 0.010973649262598728`]], AbsoluteThickness[0.25],
      LineBox[{157, 158}]}, 
    {Hue[
      NCache[
       Rational[158, 14307], 0.011043545117774516`]], AbsoluteThickness[0.25],
      LineBox[{158, 159}]}, 
    {Hue[
      NCache[
       Rational[53, 4769], 0.011113440972950304`]], AbsoluteThickness[0.25], 
     LineBox[{159, 160}]}, 
    {Hue[
      NCache[
       Rational[160, 14307], 0.011183336828126092`]], AbsoluteThickness[0.25],
      LineBox[{160, 161}]}, 
    {Hue[
      NCache[
       Rational[161, 14307], 0.01125323268330188]], AbsoluteThickness[0.25], 
     LineBox[{161, 162}]}, 
    {Hue[
      NCache[
       Rational[54, 4769], 0.011323128538477669`]], AbsoluteThickness[0.25], 
     LineBox[{162, 163}]}, 
    {Hue[
      NCache[
       Rational[163, 14307], 0.011393024393653457`]], AbsoluteThickness[0.25],
      LineBox[{163, 164}]}, 
    {Hue[
      NCache[
       Rational[164, 14307], 0.011462920248829245`]], AbsoluteThickness[0.25],
      LineBox[{164, 165}]}, 
    {Hue[
      NCache[
       Rational[55, 4769], 0.011532816104005033`]], AbsoluteThickness[0.25], 
     LineBox[{165, 166}]}, 
    {Hue[
      NCache[
       Rational[166, 14307], 0.01160271195918082]], AbsoluteThickness[0.25], 
     LineBox[{166, 167}]}, 
    {Hue[
      NCache[
       Rational[167, 14307], 0.011672607814356608`]], AbsoluteThickness[0.25],
      LineBox[{167, 168}]}, 
    {Hue[
      NCache[
       Rational[56, 4769], 0.011742503669532396`]], AbsoluteThickness[0.25], 
     LineBox[{168, 169}]}, 
    {Hue[
      NCache[
       Rational[169, 14307], 0.011812399524708184`]], AbsoluteThickness[0.25],
      LineBox[{169, 170}]}, 
    {Hue[
      NCache[
       Rational[170, 14307], 0.011882295379883973`]], AbsoluteThickness[0.25],
      LineBox[{170, 171}]}, 
    {Hue[
      NCache[
       Rational[3, 251], 0.01195219123505976]], AbsoluteThickness[0.25], 
     LineBox[{171, 172}]}, 
    {Hue[
      NCache[
       Rational[172, 14307], 0.012022087090235549`]], AbsoluteThickness[0.25],
      LineBox[{172, 173}]}, 
    {Hue[
      NCache[
       Rational[173, 14307], 0.012091982945411337`]], AbsoluteThickness[0.25],
      LineBox[{173, 174}]}, 
    {Hue[
      NCache[
       Rational[58, 4769], 0.012161878800587125`]], AbsoluteThickness[0.25], 
     LineBox[{174, 175}]}, 
    {Hue[
      NCache[
       Rational[175, 14307], 0.012231774655762914`]], AbsoluteThickness[0.25],
      LineBox[{175, 176}]}, 
    {Hue[
      NCache[
       Rational[176, 14307], 0.012301670510938702`]], AbsoluteThickness[0.25],
      LineBox[{176, 177}]}, 
    {Hue[
      NCache[
       Rational[59, 4769], 0.01237156636611449]], AbsoluteThickness[0.25], 
     LineBox[{177, 178}]}, 
    {Hue[
      NCache[
       Rational[178, 14307], 0.012441462221290278`]], AbsoluteThickness[0.25],
      LineBox[{178, 179}]}, 
    {Hue[
      NCache[
       Rational[179, 14307], 0.012511358076466066`]], AbsoluteThickness[0.25],
      LineBox[{179, 180}]}, 
    {Hue[
      NCache[
       Rational[60, 4769], 0.012581253931641853`]], AbsoluteThickness[0.25], 
     LineBox[{180, 181}]}, 
    {Hue[
      NCache[
       Rational[181, 14307], 0.012651149786817641`]], AbsoluteThickness[0.25],
      LineBox[{181, 182}]}, 
    {Hue[
      NCache[
       Rational[182, 14307], 0.01272104564199343]], AbsoluteThickness[0.25], 
     LineBox[{182, 183}]}, 
    {Hue[
      NCache[
       Rational[61, 4769], 0.012790941497169217`]], AbsoluteThickness[0.25], 
     LineBox[{183, 184}]}, 
    {Hue[
      NCache[
       Rational[184, 14307], 0.012860837352345006`]], AbsoluteThickness[0.25],
      LineBox[{184, 185}]}, 
    {Hue[
      NCache[
       Rational[185, 14307], 0.012930733207520794`]], AbsoluteThickness[0.25],
      LineBox[{185, 186}]}, 
    {Hue[
      NCache[
       Rational[62, 4769], 0.013000629062696582`]], AbsoluteThickness[0.25], 
     LineBox[{186, 187}]}, 
    {Hue[
      NCache[
       Rational[187, 14307], 0.01307052491787237]], AbsoluteThickness[0.25], 
     LineBox[{187, 188}]}, 
    {Hue[
      NCache[
       Rational[188, 14307], 0.013140420773048158`]], AbsoluteThickness[0.25],
      LineBox[{188, 189}]}, 
    {Hue[
      NCache[
       Rational[63, 4769], 0.013210316628223947`]], AbsoluteThickness[0.25], 
     LineBox[{189, 190}]}, 
    {Hue[
      NCache[
       Rational[10, 753], 0.013280212483399735`]], AbsoluteThickness[0.25], 
     LineBox[{190, 191}]}, 
    {Hue[
      NCache[
       Rational[191, 14307], 0.013350108338575523`]], AbsoluteThickness[0.25],
      LineBox[{191, 192}]}, 
    {Hue[
      NCache[
       Rational[64, 4769], 0.013420004193751311`]], AbsoluteThickness[0.25], 
     LineBox[{192, 193}]}, 
    {Hue[
      NCache[
       Rational[193, 14307], 0.0134899000489271]], AbsoluteThickness[0.25], 
     LineBox[{193, 194}]}, 
    {Hue[
      NCache[
       Rational[194, 14307], 0.013559795904102888`]], AbsoluteThickness[0.25],
      LineBox[{194, 195}]}, 
    {Hue[
      NCache[
       Rational[65, 4769], 0.013629691759278674`]], AbsoluteThickness[0.25], 
     LineBox[{195, 196}]}, 
    {Hue[
      NCache[
       Rational[196, 14307], 0.013699587614454462`]], AbsoluteThickness[0.25],
      LineBox[{196, 197}]}, 
    {Hue[
      NCache[
       Rational[197, 14307], 0.01376948346963025]], AbsoluteThickness[0.25], 
     LineBox[{197, 198}]}, 
    {Hue[
      NCache[
       Rational[66, 4769], 0.013839379324806039`]], AbsoluteThickness[0.25], 
     LineBox[{198, 199}]}, 
    {Hue[
      NCache[
       Rational[199, 14307], 0.013909275179981827`]], AbsoluteThickness[0.25],
      LineBox[{199, 200}]}, 
    {Hue[
      NCache[
       Rational[200, 14307], 0.013979171035157615`]], AbsoluteThickness[0.25],
      LineBox[{200, 201}]}, 
    {Hue[
      NCache[
       Rational[67, 4769], 0.014049066890333403`]], AbsoluteThickness[0.25], 
     LineBox[{201, 202}]}, 
    {Hue[
      NCache[
       Rational[202, 14307], 0.014118962745509191`]], AbsoluteThickness[0.25],
      LineBox[{202, 203}]}, 
    {Hue[
      NCache[
       Rational[203, 14307], 0.01418885860068498]], AbsoluteThickness[0.25], 
     LineBox[{203, 204}]}, 
    {Hue[
      NCache[
       Rational[68, 4769], 0.014258754455860768`]], AbsoluteThickness[0.25], 
     LineBox[{204, 205}]}, 
    {Hue[
      NCache[
       Rational[205, 14307], 0.014328650311036556`]], AbsoluteThickness[0.25],
      LineBox[{205, 206}]}, 
    {Hue[
      NCache[
       Rational[206, 14307], 0.014398546166212344`]], AbsoluteThickness[0.25],
      LineBox[{206, 207}]}, 
    {Hue[
      NCache[
       Rational[69, 4769], 0.014468442021388132`]], AbsoluteThickness[0.25], 
     LineBox[{207, 208}]}, 
    {Hue[
      NCache[
       Rational[208, 14307], 0.01453833787656392]], AbsoluteThickness[0.25], 
     LineBox[{208, 209}]}, 
    {Hue[
      NCache[
       Rational[11, 753], 0.014608233731739707`]], AbsoluteThickness[0.25], 
     LineBox[{209, 210}]}, 
    {Hue[
      NCache[
       Rational[70, 4769], 0.014678129586915495`]], AbsoluteThickness[0.25], 
     LineBox[{210, 211}]}, 
    {Hue[
      NCache[
       Rational[211, 14307], 0.014748025442091283`]], AbsoluteThickness[0.25],
      LineBox[{211, 212}]}, 
    {Hue[
      NCache[
       Rational[212, 14307], 0.014817921297267072`]], AbsoluteThickness[0.25],
      LineBox[{212, 213}]}, 
    {Hue[
      NCache[
       Rational[71, 4769], 0.01488781715244286]], AbsoluteThickness[0.25], 
     LineBox[{213, 214}]}, 
    {Hue[
      NCache[
       Rational[214, 14307], 0.014957713007618648`]], AbsoluteThickness[0.25],
      LineBox[{214, 215}]}, 
    {Hue[
      NCache[
       Rational[215, 14307], 0.015027608862794436`]], AbsoluteThickness[0.25],
      LineBox[{215, 216}]}, 
    {Hue[
      NCache[
       Rational[72, 4769], 0.015097504717970224`]], AbsoluteThickness[0.25], 
     LineBox[{216, 217}]}, 
    {Hue[
      NCache[
       Rational[217, 14307], 0.015167400573146013`]], AbsoluteThickness[0.25],
      LineBox[{217, 218}]}, 
    {Hue[
      NCache[
       Rational[218, 14307], 0.0152372964283218]], AbsoluteThickness[0.25], 
     LineBox[{218, 219}]}, 
    {Hue[
      NCache[
       Rational[73, 4769], 0.015307192283497589`]], AbsoluteThickness[0.25], 
     LineBox[{219, 220}]}, 
    {Hue[
      NCache[
       Rational[220, 14307], 0.015377088138673377`]], AbsoluteThickness[0.25],
      LineBox[{220, 221}]}, 
    {Hue[
      NCache[
       Rational[221, 14307], 0.015446983993849165`]], AbsoluteThickness[0.25],
      LineBox[{221, 222}]}, 
    {Hue[
      NCache[
       Rational[74, 4769], 0.015516879849024954`]], AbsoluteThickness[0.25], 
     LineBox[{222, 223}]}, 
    {Hue[
      NCache[
       Rational[223, 14307], 0.015586775704200742`]], AbsoluteThickness[0.25],
      LineBox[{223, 224}]}, 
    {Hue[
      NCache[
       Rational[224, 14307], 0.015656671559376528`]], AbsoluteThickness[0.25],
      LineBox[{224, 225}]}, 
    {Hue[
      NCache[
       Rational[75, 4769], 0.015726567414552316`]], AbsoluteThickness[0.25], 
     LineBox[{225, 226}]}, 
    {Hue[
      NCache[
       Rational[226, 14307], 0.015796463269728105`]], AbsoluteThickness[0.25],
      LineBox[{226, 227}]}, 
    {Hue[
      NCache[
       Rational[227, 14307], 0.015866359124903893`]], AbsoluteThickness[0.25],
      LineBox[{227, 228}]}, 
    {Hue[
      NCache[
       Rational[4, 251], 0.01593625498007968]], AbsoluteThickness[0.25], 
     LineBox[{228, 229}]}, 
    {Hue[
      NCache[
       Rational[229, 14307], 0.01600615083525547]], AbsoluteThickness[0.25], 
     LineBox[{229, 230}]}, 
    {Hue[
      NCache[
       Rational[230, 14307], 0.016076046690431257`]], AbsoluteThickness[0.25],
      LineBox[{230, 231}]}, 
    {Hue[
      NCache[
       Rational[77, 4769], 0.016145942545607046`]], AbsoluteThickness[0.25], 
     LineBox[{231, 232}]}, 
    {Hue[
      NCache[
       Rational[232, 14307], 0.016215838400782834`]], AbsoluteThickness[0.25],
      LineBox[{232, 233}]}, 
    {Hue[
      NCache[
       Rational[233, 14307], 0.016285734255958622`]], AbsoluteThickness[0.25],
      LineBox[{233, 234}]}, 
    {Hue[
      NCache[
       Rational[78, 4769], 0.01635563011113441]], AbsoluteThickness[0.25], 
     LineBox[{234, 235}]}, 
    {Hue[
      NCache[
       Rational[235, 14307], 0.0164255259663102]], AbsoluteThickness[0.25], 
     LineBox[{235, 236}]}, 
    {Hue[
      NCache[
       Rational[236, 14307], 0.016495421821485987`]], AbsoluteThickness[0.25],
      LineBox[{236, 237}]}, 
    {Hue[
      NCache[
       Rational[79, 4769], 0.016565317676661775`]], AbsoluteThickness[0.25], 
     LineBox[{237, 238}]}, 
    {Hue[
      NCache[
       Rational[238, 14307], 0.016635213531837563`]], AbsoluteThickness[0.25],
      LineBox[{238, 239}]}, 
    {Hue[
      NCache[
       Rational[239, 14307], 0.01670510938701335]], AbsoluteThickness[0.25], 
     LineBox[{239, 240}]}, 
    {Hue[
      NCache[
       Rational[80, 4769], 0.01677500524218914]], AbsoluteThickness[0.25], 
     LineBox[{240, 241}]}, 
    {Hue[
      NCache[
       Rational[241, 14307], 0.016844901097364928`]], AbsoluteThickness[0.25],
      LineBox[{241, 242}]}, 
    {Hue[
      NCache[
       Rational[242, 14307], 0.016914796952540716`]], AbsoluteThickness[0.25],
      LineBox[{242, 243}]}, 
    {Hue[
      NCache[
       Rational[81, 4769], 0.016984692807716504`]], AbsoluteThickness[0.25], 
     LineBox[{243, 244}]}, 
    {Hue[
      NCache[
       Rational[244, 14307], 0.017054588662892292`]], AbsoluteThickness[0.25],
      LineBox[{244, 245}]}, 
    {Hue[
      NCache[
       Rational[245, 14307], 0.017124484518068077`]], AbsoluteThickness[0.25],
      LineBox[{245, 246}]}, 
    {Hue[
      NCache[
       Rational[82, 4769], 0.017194380373243865`]], AbsoluteThickness[0.25], 
     LineBox[{246, 247}]}, 
    {Hue[
      NCache[
       Rational[13, 753], 0.017264276228419653`]], AbsoluteThickness[0.25], 
     LineBox[{247, 248}]}, 
    {Hue[
      NCache[
       Rational[248, 14307], 0.01733417208359544]], AbsoluteThickness[0.25], 
     LineBox[{248, 249}]}, 
    {Hue[
      NCache[
       Rational[83, 4769], 0.01740406793877123]], AbsoluteThickness[0.25], 
     LineBox[{249, 250}]}, 
    {Hue[
      NCache[
       Rational[250, 14307], 0.017473963793947018`]], AbsoluteThickness[0.25],
      LineBox[{250, 251}]}, 
    {Hue[
      NCache[
       Rational[1, 57], 0.017543859649122806`]], AbsoluteThickness[0.25], 
     LineBox[{251, 252}]}, 
    {Hue[
      NCache[
       Rational[84, 4769], 0.017613755504298594`]], AbsoluteThickness[0.25], 
     LineBox[{252, 253}]}, 
    {Hue[
      NCache[
       Rational[253, 14307], 0.017683651359474382`]], AbsoluteThickness[0.25],
      LineBox[{253, 254}]}, 
    {Hue[
      NCache[
       Rational[254, 14307], 0.01775354721465017]], AbsoluteThickness[0.25], 
     LineBox[{254, 255}]}, 
    {Hue[
      NCache[
       Rational[85, 4769], 0.01782344306982596]], AbsoluteThickness[0.25], 
     LineBox[{255, 256}]}, 
    {Hue[
      NCache[
       Rational[256, 14307], 0.017893338925001747`]], AbsoluteThickness[0.25],
      LineBox[{256, 257}]}, 
    {Hue[
      NCache[
       Rational[257, 14307], 0.017963234780177535`]], AbsoluteThickness[0.25],
      LineBox[{257, 258}]}, 
    {Hue[
      NCache[
       Rational[86, 4769], 0.018033130635353323`]], AbsoluteThickness[0.25], 
     LineBox[{258, 259}]}, 
    {Hue[
      NCache[
       Rational[259, 14307], 0.01810302649052911]], AbsoluteThickness[0.25], 
     LineBox[{259, 260}]}, 
    {Hue[
      NCache[
       Rational[260, 14307], 0.0181729223457049]], AbsoluteThickness[0.25], 
     LineBox[{260, 261}]}, 
    {Hue[
      NCache[
       Rational[87, 4769], 0.018242818200880688`]], AbsoluteThickness[0.25], 
     LineBox[{261, 262}]}, 
    {Hue[
      NCache[
       Rational[262, 14307], 0.018312714056056476`]], AbsoluteThickness[0.25],
      LineBox[{262, 263}]}, 
    {Hue[
      NCache[
       Rational[263, 14307], 0.018382609911232264`]], AbsoluteThickness[0.25],
      LineBox[{263, 264}]}, 
    {Hue[
      NCache[
       Rational[88, 4769], 0.018452505766408053`]], AbsoluteThickness[0.25], 
     LineBox[{264, 265}]}, 
    {Hue[
      NCache[
       Rational[265, 14307], 0.01852240162158384]], AbsoluteThickness[0.25], 
     LineBox[{265, 266}]}, 
    {Hue[
      NCache[
       Rational[14, 753], 0.01859229747675963]], AbsoluteThickness[0.25], 
     LineBox[{266, 267}]}, 
    {Hue[
      NCache[
       Rational[89, 4769], 0.018662193331935417`]], AbsoluteThickness[0.25], 
     LineBox[{267, 268}]}, 
    {Hue[
      NCache[
       Rational[268, 14307], 0.018732089187111205`]], AbsoluteThickness[0.25],
      LineBox[{268, 269}]}, 
    {Hue[
      NCache[
       Rational[269, 14307], 0.018801985042286994`]], AbsoluteThickness[0.25],
      LineBox[{269, 270}]}, 
    {Hue[
      NCache[
       Rational[90, 4769], 0.018871880897462782`]], AbsoluteThickness[0.25], 
     LineBox[{270, 271}]}, 
    {Hue[
      NCache[
       Rational[271, 14307], 0.01894177675263857]], AbsoluteThickness[0.25], 
     LineBox[{271, 272}]}, 
    {Hue[
      NCache[
       Rational[272, 14307], 0.019011672607814358`]], AbsoluteThickness[0.25],
      LineBox[{272, 273}]}, 
    {Hue[
      NCache[
       Rational[91, 4769], 0.019081568462990146`]], AbsoluteThickness[0.25], 
     LineBox[{273, 274}]}, 
    {Hue[
      NCache[
       Rational[274, 14307], 0.01915146431816593]], AbsoluteThickness[0.25], 
     LineBox[{274, 275}]}, 
    {Hue[
      NCache[
       Rational[275, 14307], 0.01922136017334172]], AbsoluteThickness[0.25], 
     LineBox[{275, 276}]}, 
    {Hue[
      NCache[
       Rational[92, 4769], 0.019291256028517507`]], AbsoluteThickness[0.25], 
     LineBox[{276, 277}]}, 
    {Hue[
      NCache[
       Rational[277, 14307], 0.019361151883693296`]], AbsoluteThickness[0.25],
      LineBox[{277, 278}]}, 
    {Hue[
      NCache[
       Rational[278, 14307], 0.019431047738869084`]], AbsoluteThickness[0.25],
      LineBox[{278, 279}]}, 
    {Hue[
      NCache[
       Rational[93, 4769], 0.019500943594044872`]], AbsoluteThickness[0.25], 
     LineBox[{279, 280}]}, 
    {Hue[
      NCache[
       Rational[280, 14307], 0.01957083944922066]], AbsoluteThickness[0.25], 
     LineBox[{280, 281}]}, 
    {Hue[
      NCache[
       Rational[281, 14307], 0.01964073530439645]], AbsoluteThickness[0.25], 
     LineBox[{281, 282}]}, 
    {Hue[
      NCache[
       Rational[94, 4769], 0.019710631159572237`]], AbsoluteThickness[0.25], 
     LineBox[{282, 283}]}, 
    {Hue[
      NCache[
       Rational[283, 14307], 0.019780527014748025`]], AbsoluteThickness[0.25],
      LineBox[{283, 284}]}, 
    {Hue[
      NCache[
       Rational[284, 14307], 0.019850422869923813`]], AbsoluteThickness[0.25],
      LineBox[{284, 285}]}, 
    {Hue[
      NCache[
       Rational[5, 251], 0.0199203187250996]], AbsoluteThickness[0.25], 
     LineBox[{285, 286}]}, 
    {Hue[
      NCache[
       Rational[286, 14307], 0.01999021458027539]], AbsoluteThickness[0.25], 
     LineBox[{286, 287}]}, 
    {Hue[
      NCache[
       Rational[287, 14307], 0.020060110435451178`]], AbsoluteThickness[0.25],
      LineBox[{287, 288}]}, 
    {Hue[
      NCache[
       Rational[96, 4769], 0.020130006290626966`]], AbsoluteThickness[0.25], 
     LineBox[{288, 289}]}, 
    {Hue[
      NCache[
       Rational[289, 14307], 0.020199902145802754`]], AbsoluteThickness[0.25],
      LineBox[{289, 290}]}, 
    {Hue[
      NCache[
       Rational[290, 14307], 0.020269798000978542`]], AbsoluteThickness[0.25],
      LineBox[{290, 291}]}, 
    {Hue[
      NCache[
       Rational[97, 4769], 0.02033969385615433]], AbsoluteThickness[0.25], 
     LineBox[{291, 292}]}, 
    {Hue[
      NCache[
       Rational[292, 14307], 0.02040958971133012]], AbsoluteThickness[0.25], 
     LineBox[{292, 293}]}, 
    {Hue[
      NCache[
       Rational[293, 14307], 0.020479485566505907`]], AbsoluteThickness[0.25],
      LineBox[{293, 294}]}, 
    {Hue[
      NCache[
       Rational[98, 4769], 0.020549381421681695`]], AbsoluteThickness[0.25], 
     LineBox[{294, 295}]}, 
    {Hue[
      NCache[
       Rational[295, 14307], 0.020619277276857483`]], AbsoluteThickness[0.25],
      LineBox[{295, 296}]}, 
    {Hue[
      NCache[
       Rational[296, 14307], 0.02068917313203327]], AbsoluteThickness[0.25], 
     LineBox[{296, 297}]}, 
    {Hue[
      NCache[
       Rational[99, 4769], 0.02075906898720906]], AbsoluteThickness[0.25], 
     LineBox[{297, 298}]}, 
    {Hue[
      NCache[
       Rational[298, 14307], 0.020828964842384848`]], AbsoluteThickness[0.25],
      LineBox[{298, 299}]}, 
    {Hue[
      NCache[
       Rational[299, 14307], 0.020898860697560636`]], AbsoluteThickness[0.25],
      LineBox[{299, 300}]}, 
    {Hue[
      NCache[
       Rational[100, 4769], 0.020968756552736424`]], AbsoluteThickness[0.25], 
     LineBox[{300, 301}]}, 
    {Hue[
      NCache[
       Rational[301, 14307], 0.021038652407912212`]], AbsoluteThickness[0.25],
      LineBox[{301, 302}]}, 
    {Hue[
      NCache[
       Rational[302, 14307], 0.021108548263088]], AbsoluteThickness[0.25], 
     LineBox[{302, 303}]}, 
    {Hue[
      NCache[
       Rational[101, 4769], 0.021178444118263785`]], AbsoluteThickness[0.25], 
     LineBox[{303, 304}]}, 
    {Hue[
      NCache[
       Rational[16, 753], 0.021248339973439574`]], AbsoluteThickness[0.25], 
     LineBox[{304, 305}]}, 
    {Hue[
      NCache[
       Rational[305, 14307], 0.02131823582861536]], AbsoluteThickness[0.25], 
     LineBox[{305, 306}]}, 
    {Hue[
      NCache[
       Rational[102, 4769], 0.02138813168379115]], AbsoluteThickness[0.25], 
     LineBox[{306, 307}]}, 
    {Hue[
      NCache[
       Rational[307, 14307], 0.021458027538966938`]], AbsoluteThickness[0.25],
      LineBox[{307, 308}]}, 
    {Hue[
      NCache[
       Rational[308, 14307], 0.021527923394142726`]], AbsoluteThickness[0.25],
      LineBox[{308, 309}]}, 
    {Hue[
      NCache[
       Rational[103, 4769], 0.021597819249318514`]], AbsoluteThickness[0.25], 
     LineBox[{309, 310}]}, 
    {Hue[
      NCache[
       Rational[310, 14307], 0.021667715104494303`]], AbsoluteThickness[0.25],
      LineBox[{310, 311}]}, 
    {Hue[
      NCache[
       Rational[311, 14307], 0.02173761095967009]], AbsoluteThickness[0.25], 
     LineBox[{311, 312}]}, 
    {Hue[
      NCache[
       Rational[104, 4769], 0.02180750681484588]], AbsoluteThickness[0.25], 
     LineBox[{312, 313}]}, 
    {Hue[
      NCache[
       Rational[313, 14307], 0.021877402670021667`]], AbsoluteThickness[0.25],
      LineBox[{313, 314}]}, 
    {Hue[
      NCache[
       Rational[314, 14307], 0.021947298525197455`]], AbsoluteThickness[0.25],
      LineBox[{314, 315}]}, 
    {Hue[
      NCache[
       Rational[105, 4769], 0.022017194380373244`]], AbsoluteThickness[0.25], 
     LineBox[{315, 316}]}, 
    {Hue[
      NCache[
       Rational[316, 14307], 0.022087090235549032`]], AbsoluteThickness[0.25],
      LineBox[{316, 317}]}, 
    {Hue[
      NCache[
       Rational[317, 14307], 0.02215698609072482]], AbsoluteThickness[0.25], 
     LineBox[{317, 318}]}, 
    {Hue[
      NCache[
       Rational[106, 4769], 0.022226881945900608`]], AbsoluteThickness[0.25], 
     LineBox[{318, 319}]}, 
    {Hue[
      NCache[
       Rational[319, 14307], 0.022296777801076396`]], AbsoluteThickness[0.25],
      LineBox[{319, 320}]}, 
    {Hue[
      NCache[
       Rational[320, 14307], 0.022366673656252185`]], AbsoluteThickness[0.25],
      LineBox[{320, 321}]}, 
    {Hue[
      NCache[
       Rational[107, 4769], 0.022436569511427973`]], AbsoluteThickness[0.25], 
     LineBox[{321, 322}]}, 
    {Hue[
      NCache[
       Rational[322, 14307], 0.02250646536660376]], AbsoluteThickness[0.25], 
     LineBox[{322, 323}]}, 
    {Hue[
      NCache[
       Rational[17, 753], 0.02257636122177955]], AbsoluteThickness[0.25], 
     LineBox[{323, 324}]}, 
    {Hue[
      NCache[
       Rational[108, 4769], 0.022646257076955337`]], AbsoluteThickness[0.25], 
     LineBox[{324, 325}]}, 
    {Hue[
      NCache[
       Rational[325, 14307], 0.022716152932131126`]], AbsoluteThickness[0.25],
      LineBox[{325, 326}]}, 
    {Hue[
      NCache[
       Rational[326, 14307], 0.022786048787306914`]], AbsoluteThickness[0.25],
      LineBox[{326, 327}]}, 
    {Hue[
      NCache[
       Rational[109, 4769], 0.022855944642482702`]], AbsoluteThickness[0.25], 
     LineBox[{327, 328}]}, 
    {Hue[
      NCache[
       Rational[328, 14307], 0.02292584049765849]], AbsoluteThickness[0.25], 
     LineBox[{328, 329}]}, 
    {Hue[
      NCache[
       Rational[329, 14307], 0.02299573635283428]], AbsoluteThickness[0.25], 
     LineBox[{329, 330}]}, 
    {Hue[
      NCache[
       Rational[110, 4769], 0.023065632208010067`]], AbsoluteThickness[0.25], 
     LineBox[{330, 331}]}, 
    {Hue[
      NCache[
       Rational[331, 14307], 0.023135528063185855`]], AbsoluteThickness[0.25],
      LineBox[{331, 332}]}, 
    {Hue[
      NCache[
       Rational[332, 14307], 0.02320542391836164]], AbsoluteThickness[0.25], 
     LineBox[{332, 333}]}, 
    {Hue[
      NCache[
       Rational[111, 4769], 0.023275319773537428`]], AbsoluteThickness[0.25], 
     LineBox[{333, 334}]}, 
    {Hue[
      NCache[
       Rational[334, 14307], 0.023345215628713216`]], AbsoluteThickness[0.25],
      LineBox[{334, 335}]}, 
    {Hue[
      NCache[
       Rational[335, 14307], 0.023415111483889004`]], AbsoluteThickness[0.25],
      LineBox[{335, 336}]}, 
    {Hue[
      NCache[
       Rational[112, 4769], 0.023485007339064792`]], AbsoluteThickness[0.25], 
     LineBox[{336, 337}]}, 
    {Hue[
      NCache[
       Rational[337, 14307], 0.02355490319424058]], AbsoluteThickness[0.25], 
     LineBox[{337, 338}]}, 
    {Hue[
      NCache[
       Rational[338, 14307], 0.02362479904941637]], AbsoluteThickness[0.25], 
     LineBox[{338, 339}]}, 
    {Hue[
      NCache[
       Rational[113, 4769], 0.023694694904592157`]], AbsoluteThickness[0.25], 
     LineBox[{339, 340}]}, 
    {Hue[
      NCache[
       Rational[340, 14307], 0.023764590759767945`]], AbsoluteThickness[0.25],
      LineBox[{340, 341}]}, 
    {Hue[
      NCache[
       Rational[341, 14307], 0.023834486614943733`]], AbsoluteThickness[0.25],
      LineBox[{341, 342}]}, 
    {Hue[
      NCache[
       Rational[6, 251], 0.02390438247011952]], AbsoluteThickness[0.25], 
     LineBox[{342, 343}]}, 
    {Hue[
      NCache[
       Rational[343, 14307], 0.02397427832529531]], AbsoluteThickness[0.25], 
     LineBox[{343, 344}]}, 
    {Hue[
      NCache[
       Rational[344, 14307], 0.024044174180471098`]], AbsoluteThickness[0.25],
      LineBox[{344, 345}]}, 
    {Hue[
      NCache[
       Rational[115, 4769], 0.024114070035646886`]], AbsoluteThickness[0.25], 
     LineBox[{345, 346}]}, 
    {Hue[
      NCache[
       Rational[346, 14307], 0.024183965890822674`]], AbsoluteThickness[0.25],
      LineBox[{346, 347}]}, 
    {Hue[
      NCache[
       Rational[347, 14307], 0.024253861745998462`]], AbsoluteThickness[0.25],
      LineBox[{347, 348}]}, 
    {Hue[
      NCache[
       Rational[116, 4769], 0.02432375760117425]], AbsoluteThickness[0.25], 
     LineBox[{348, 349}]}, 
    {Hue[
      NCache[
       Rational[349, 14307], 0.02439365345635004]], AbsoluteThickness[0.25], 
     LineBox[{349, 350}]}, 
    {Hue[
      NCache[
       Rational[350, 14307], 0.024463549311525827`]], AbsoluteThickness[0.25],
      LineBox[{350, 351}]}, 
    {Hue[
      NCache[
       Rational[117, 4769], 0.024533445166701615`]], AbsoluteThickness[0.25], 
     LineBox[{351, 352}]}, 
    {Hue[
      NCache[
       Rational[352, 14307], 0.024603341021877403`]], AbsoluteThickness[0.25],
      LineBox[{352, 353}]}, 
    {Hue[
      NCache[
       Rational[353, 14307], 0.02467323687705319]], AbsoluteThickness[0.25], 
     LineBox[{353, 354}]}, 
    {Hue[
      NCache[
       Rational[118, 4769], 0.02474313273222898]], AbsoluteThickness[0.25], 
     LineBox[{354, 355}]}, 
    {Hue[
      NCache[
       Rational[355, 14307], 0.024813028587404768`]], AbsoluteThickness[0.25],
      LineBox[{355, 356}]}, 
    {Hue[
      NCache[
       Rational[356, 14307], 0.024882924442580556`]], AbsoluteThickness[0.25],
      LineBox[{356, 357}]}, 
    {Hue[
      NCache[
       Rational[119, 4769], 0.024952820297756344`]], AbsoluteThickness[0.25], 
     LineBox[{357, 358}]}, 
    {Hue[
      NCache[
       Rational[358, 14307], 0.025022716152932133`]], AbsoluteThickness[0.25],
      LineBox[{358, 359}]}, 
    {Hue[
      NCache[
       Rational[359, 14307], 0.02509261200810792]], AbsoluteThickness[0.25], 
     LineBox[{359, 360}]}, 
    {Hue[
      NCache[
       Rational[120, 4769], 0.025162507863283706`]], AbsoluteThickness[0.25], 
     LineBox[{360, 361}]}, 
    {Hue[
      NCache[
       Rational[19, 753], 0.025232403718459494`]], AbsoluteThickness[0.25], 
     LineBox[{361, 362}]}, 
    {Hue[
      NCache[
       Rational[362, 14307], 0.025302299573635282`]], AbsoluteThickness[0.25],
      LineBox[{362, 363}]}, 
    {Hue[
      NCache[
       Rational[121, 4769], 0.02537219542881107]], AbsoluteThickness[0.25], 
     LineBox[{363, 364}]}, 
    {Hue[
      NCache[
       Rational[364, 14307], 0.02544209128398686]], AbsoluteThickness[0.25], 
     LineBox[{364, 365}]}, 
    {Hue[
      NCache[
       Rational[365, 14307], 0.025511987139162647`]], AbsoluteThickness[0.25],
      LineBox[{365, 366}]}, 
    {Hue[
      NCache[
       Rational[122, 4769], 0.025581882994338435`]], AbsoluteThickness[0.25], 
     LineBox[{366, 367}]}, 
    {Hue[
      NCache[
       Rational[367, 14307], 0.025651778849514223`]], AbsoluteThickness[0.25],
      LineBox[{367, 368}]}, 
    {Hue[
      NCache[
       Rational[368, 14307], 0.02572167470469001]], AbsoluteThickness[0.25], 
     LineBox[{368, 369}]}, 
    {Hue[
      NCache[
       Rational[123, 4769], 0.0257915705598658]], AbsoluteThickness[0.25], 
     LineBox[{369, 370}]}, 
    {Hue[
      NCache[
       Rational[370, 14307], 0.025861466415041588`]], AbsoluteThickness[0.25],
      LineBox[{370, 371}]}, 
    {Hue[
      NCache[
       Rational[371, 14307], 0.025931362270217376`]], AbsoluteThickness[0.25],
      LineBox[{371, 372}]}, 
    {Hue[
      NCache[
       Rational[124, 4769], 0.026001258125393164`]], AbsoluteThickness[0.25], 
     LineBox[{372, 373}]}, 
    {Hue[
      NCache[
       Rational[373, 14307], 0.026071153980568952`]], AbsoluteThickness[0.25],
      LineBox[{373, 374}]}, 
    {Hue[
      NCache[
       Rational[374, 14307], 0.02614104983574474]], AbsoluteThickness[0.25], 
     LineBox[{374, 375}]}, 
    {Hue[
      NCache[
       Rational[125, 4769], 0.02621094569092053]], AbsoluteThickness[0.25], 
     LineBox[{375, 376}]}, 
    {Hue[
      NCache[
       Rational[376, 14307], 0.026280841546096317`]], AbsoluteThickness[0.25],
      LineBox[{376, 377}]}, 
    {Hue[
      NCache[
       Rational[377, 14307], 0.026350737401272105`]], AbsoluteThickness[0.25],
      LineBox[{377, 378}]}, 
    {Hue[
      NCache[
       Rational[126, 4769], 0.026420633256447893`]], AbsoluteThickness[0.25], 
     LineBox[{378, 379}]}, 
    {Hue[
      NCache[
       Rational[379, 14307], 0.02649052911162368]], AbsoluteThickness[0.25], 
     LineBox[{379, 380}]}, 
    {Hue[
      NCache[
       Rational[20, 753], 0.02656042496679947]], AbsoluteThickness[0.25], 
     LineBox[{380, 381}]}, 
    {Hue[
      NCache[
       Rational[127, 4769], 0.026630320821975258`]], AbsoluteThickness[0.25], 
     LineBox[{381, 382}]}, 
    {Hue[
      NCache[
       Rational[382, 14307], 0.026700216677151046`]], AbsoluteThickness[0.25],
      LineBox[{382, 383}]}, 
    {Hue[
      NCache[
       Rational[383, 14307], 0.026770112532326834`]], AbsoluteThickness[0.25],
      LineBox[{383, 384}]}, 
    {Hue[
      NCache[
       Rational[128, 4769], 0.026840008387502622`]], AbsoluteThickness[0.25], 
     LineBox[{384, 385}]}, 
    {Hue[
      NCache[
       Rational[385, 14307], 0.02690990424267841]], AbsoluteThickness[0.25], 
     LineBox[{385, 386}]}, 
    {Hue[
      NCache[
       Rational[386, 14307], 0.0269798000978542]], AbsoluteThickness[0.25], 
     LineBox[{386, 387}]}, 
    {Hue[
      NCache[
       Rational[129, 4769], 0.027049695953029987`]], AbsoluteThickness[0.25], 
     LineBox[{387, 388}]}, 
    {Hue[
      NCache[
       Rational[388, 14307], 0.027119591808205775`]], AbsoluteThickness[0.25],
      LineBox[{388, 389}]}, 
    {Hue[
      NCache[
       Rational[389, 14307], 0.02718948766338156]], AbsoluteThickness[0.25], 
     LineBox[{389, 390}]}, 
    {Hue[
      NCache[
       Rational[130, 4769], 0.027259383518557348`]], AbsoluteThickness[0.25], 
     LineBox[{390, 391}]}, 
    {Hue[
      NCache[
       Rational[391, 14307], 0.027329279373733136`]], AbsoluteThickness[0.25],
      LineBox[{391, 392}]}, 
    {Hue[
      NCache[
       Rational[392, 14307], 0.027399175228908924`]], AbsoluteThickness[0.25],
      LineBox[{392, 393}]}, 
    {Hue[
      NCache[
       Rational[131, 4769], 0.027469071084084713`]], AbsoluteThickness[0.25], 
     LineBox[{393, 394}]}, 
    {Hue[
      NCache[
       Rational[394, 14307], 0.0275389669392605]], AbsoluteThickness[0.25], 
     LineBox[{394, 395}]}, 
    {Hue[
      NCache[
       Rational[395, 14307], 0.02760886279443629]], AbsoluteThickness[0.25], 
     LineBox[{395, 396}]}, 
    {Hue[
      NCache[
       Rational[132, 4769], 0.027678758649612077`]], AbsoluteThickness[0.25], 
     LineBox[{396, 397}]}, 
    {Hue[
      NCache[
       Rational[397, 14307], 0.027748654504787865`]], AbsoluteThickness[0.25],
      LineBox[{397, 398}]}, 
    {Hue[
      NCache[
       Rational[398, 14307], 0.027818550359963654`]], AbsoluteThickness[0.25],
      LineBox[{398, 399}]}, 
    {Hue[
      NCache[
       Rational[7, 251], 0.027888446215139442`]], AbsoluteThickness[0.25], 
     LineBox[{399, 400}]}, 
    {Hue[
      NCache[
       Rational[400, 14307], 0.02795834207031523]], AbsoluteThickness[0.25], 
     LineBox[{400, 401}]}, 
    {Hue[
      NCache[
       Rational[401, 14307], 0.028028237925491018`]], AbsoluteThickness[0.25],
      LineBox[{401, 402}]}, 
    {Hue[
      NCache[
       Rational[134, 4769], 0.028098133780666806`]], AbsoluteThickness[0.25], 
     LineBox[{402, 403}]}, 
    {Hue[
      NCache[
       Rational[403, 14307], 0.028168029635842595`]], AbsoluteThickness[0.25],
      LineBox[{403, 404}]}, 
    {Hue[
      NCache[
       Rational[404, 14307], 0.028237925491018383`]], AbsoluteThickness[0.25],
      LineBox[{404, 405}]}, 
    {Hue[
      NCache[
       Rational[135, 4769], 0.02830782134619417]], AbsoluteThickness[0.25], 
     LineBox[{405, 406}]}, 
    {Hue[
      NCache[
       Rational[406, 14307], 0.02837771720136996]], AbsoluteThickness[0.25], 
     LineBox[{406, 407}]}, 
    {Hue[
      NCache[
       Rational[407, 14307], 0.028447613056545747`]], AbsoluteThickness[0.25],
      LineBox[{407, 408}]}, 
    {Hue[
      NCache[
       Rational[136, 4769], 0.028517508911721536`]], AbsoluteThickness[0.25], 
     LineBox[{408, 409}]}, 
    {Hue[
      NCache[
       Rational[409, 14307], 0.028587404766897324`]], AbsoluteThickness[0.25],
      LineBox[{409, 410}]}, 
    {Hue[
      NCache[
       Rational[410, 14307], 0.028657300622073112`]], AbsoluteThickness[0.25],
      LineBox[{410, 411}]}, 
    {Hue[
      NCache[
       Rational[137, 4769], 0.0287271964772489]], AbsoluteThickness[0.25], 
     LineBox[{411, 412}]}, 
    {Hue[
      NCache[
       Rational[412, 14307], 0.02879709233242469]], AbsoluteThickness[0.25], 
     LineBox[{412, 413}]}, 
    {Hue[
      NCache[
       Rational[413, 14307], 0.028866988187600476`]], AbsoluteThickness[0.25],
      LineBox[{413, 414}]}, 
    {Hue[
      NCache[
       Rational[138, 4769], 0.028936884042776265`]], AbsoluteThickness[0.25], 
     LineBox[{414, 415}]}, 
    {Hue[
      NCache[
       Rational[415, 14307], 0.029006779897952053`]], AbsoluteThickness[0.25],
      LineBox[{415, 416}]}, 
    {Hue[
      NCache[
       Rational[416, 14307], 0.02907667575312784]], AbsoluteThickness[0.25], 
     LineBox[{416, 417}]}, 
    {Hue[
      NCache[
       Rational[139, 4769], 0.02914657160830363]], AbsoluteThickness[0.25], 
     LineBox[{417, 418}]}, 
    {Hue[
      NCache[
       Rational[22, 753], 0.029216467463479414`]], AbsoluteThickness[0.25], 
     LineBox[{418, 419}]}, 
    {Hue[
      NCache[
       Rational[419, 14307], 0.029286363318655202`]], AbsoluteThickness[0.25],
      LineBox[{419, 420}]}, 
    {Hue[
      NCache[
       Rational[140, 4769], 0.02935625917383099]], AbsoluteThickness[0.25], 
     LineBox[{420, 421}]}, 
    {Hue[
      NCache[
       Rational[421, 14307], 0.02942615502900678]], AbsoluteThickness[0.25], 
     LineBox[{421, 422}]}, 
    {Hue[
      NCache[
       Rational[422, 14307], 0.029496050884182567`]], AbsoluteThickness[0.25],
      LineBox[{422, 423}]}, 
    {Hue[
      NCache[
       Rational[141, 4769], 0.029565946739358355`]], AbsoluteThickness[0.25], 
     LineBox[{423, 424}]}, 
    {Hue[
      NCache[
       Rational[424, 14307], 0.029635842594534143`]], AbsoluteThickness[0.25],
      LineBox[{424, 425}]}, 
    {Hue[
      NCache[
       Rational[425, 14307], 0.02970573844970993]], AbsoluteThickness[0.25], 
     LineBox[{425, 426}]}, 
    {Hue[
      NCache[
       Rational[142, 4769], 0.02977563430488572]], AbsoluteThickness[0.25], 
     LineBox[{426, 427}]}, 
    {Hue[
      NCache[
       Rational[427, 14307], 0.029845530160061508`]], AbsoluteThickness[0.25],
      LineBox[{427, 428}]}, 
    {Hue[
      NCache[
       Rational[428, 14307], 0.029915426015237296`]], AbsoluteThickness[0.25],
      LineBox[{428, 429}]}, 
    {Hue[
      NCache[
       Rational[143, 4769], 0.029985321870413084`]], AbsoluteThickness[0.25], 
     LineBox[{429, 430}]}, 
    {Hue[
      NCache[
       Rational[430, 14307], 0.030055217725588872`]], AbsoluteThickness[0.25],
      LineBox[{430, 431}]}, 
    {Hue[
      NCache[
       Rational[431, 14307], 0.03012511358076466]], AbsoluteThickness[0.25], 
     LineBox[{431, 432}]}, 
    {Hue[
      NCache[
       Rational[144, 4769], 0.03019500943594045]], AbsoluteThickness[0.25], 
     LineBox[{432, 433}]}, 
    {Hue[
      NCache[
       Rational[433, 14307], 0.030264905291116237`]], AbsoluteThickness[0.25],
      LineBox[{433, 434}]}, 
    {Hue[
      NCache[
       Rational[434, 14307], 0.030334801146292025`]], AbsoluteThickness[0.25],
      LineBox[{434, 435}]}, 
    {Hue[
      NCache[
       Rational[145, 4769], 0.030404697001467813`]], AbsoluteThickness[0.25], 
     LineBox[{435, 436}]}, 
    {Hue[
      NCache[
       Rational[436, 14307], 0.0304745928566436]], AbsoluteThickness[0.25], 
     LineBox[{436, 437}]}, 
    {Hue[
      NCache[
       Rational[23, 753], 0.03054448871181939]], AbsoluteThickness[0.25], 
     LineBox[{437, 438}]}, 
    {Hue[
      NCache[
       Rational[146, 4769], 0.030614384566995178`]], AbsoluteThickness[0.25], 
     LineBox[{438, 439}]}, 
    {Hue[
      NCache[
       Rational[439, 14307], 0.030684280422170966`]], AbsoluteThickness[0.25],
      LineBox[{439, 440}]}, 
    {Hue[
      NCache[
       Rational[440, 14307], 0.030754176277346754`]], AbsoluteThickness[0.25],
      LineBox[{440, 441}]}, 
    {Hue[
      NCache[
       Rational[147, 4769], 0.030824072132522543`]], AbsoluteThickness[0.25], 
     LineBox[{441, 442}]}, 
    {Hue[
      NCache[
       Rational[442, 14307], 0.03089396798769833]], AbsoluteThickness[0.25], 
     LineBox[{442, 443}]}, 
    {Hue[
      NCache[
       Rational[443, 14307], 0.03096386384287412]], AbsoluteThickness[0.25], 
     LineBox[{443, 444}]}, 
    {Hue[
      NCache[
       Rational[148, 4769], 0.031033759698049907`]], AbsoluteThickness[0.25], 
     LineBox[{444, 445}]}, 
    {Hue[
      NCache[
       Rational[445, 14307], 0.031103655553225695`]], AbsoluteThickness[0.25],
      LineBox[{445, 446}]}, 
    {Hue[
      NCache[
       Rational[446, 14307], 0.031173551408401484`]], AbsoluteThickness[0.25],
      LineBox[{446, 447}]}, 
    {Hue[
      NCache[
       Rational[149, 4769], 0.031243447263577268`]], AbsoluteThickness[0.25], 
     LineBox[{447, 448}]}, 
    {Hue[
      NCache[
       Rational[448, 14307], 0.031313343118753056`]], AbsoluteThickness[0.25],
      LineBox[{448, 449}]}, 
    {Hue[
      NCache[
       Rational[449, 14307], 0.03138323897392885]], AbsoluteThickness[0.25], 
     LineBox[{449, 450}]}, 
    {Hue[
      NCache[
       Rational[150, 4769], 0.03145313482910463]], AbsoluteThickness[0.25], 
     LineBox[{450, 451}]}, 
    {Hue[
      NCache[
       Rational[451, 14307], 0.031523030684280424`]], AbsoluteThickness[0.25],
      LineBox[{451, 452}]}, 
    {Hue[
      NCache[
       Rational[452, 14307], 0.03159292653945621]], AbsoluteThickness[0.25], 
     LineBox[{452, 453}]}, 
    {Hue[
      NCache[
       Rational[151, 4769], 0.031662822394632]], AbsoluteThickness[0.25], 
     LineBox[{453, 454}]}, 
    {Hue[
      NCache[
       Rational[454, 14307], 0.031732718249807786`]], AbsoluteThickness[0.25],
      LineBox[{454, 455}]}, 
    {Hue[
      NCache[
       Rational[455, 14307], 0.03180261410498358]], AbsoluteThickness[0.25], 
     LineBox[{455, 456}]}, 
    {Hue[
      NCache[
       Rational[8, 251], 0.03187250996015936]], AbsoluteThickness[0.25], 
     LineBox[{456, 457}]}, 
    {Hue[
      NCache[
       Rational[457, 14307], 0.031942405815335154`]], AbsoluteThickness[0.25],
      LineBox[{457, 458}]}, 
    {Hue[
      NCache[
       Rational[458, 14307], 0.03201230167051094]], AbsoluteThickness[0.25], 
     LineBox[{458, 459}]}, 
    {Hue[
      NCache[
       Rational[153, 4769], 0.03208219752568673]], AbsoluteThickness[0.25], 
     LineBox[{459, 460}]}, 
    {Hue[
      NCache[
       Rational[460, 14307], 0.032152093380862515`]], AbsoluteThickness[0.25],
      LineBox[{460, 461}]}, 
    {Hue[
      NCache[
       Rational[461, 14307], 0.0322219892360383]], AbsoluteThickness[0.25], 
     LineBox[{461, 462}]}, 
    {Hue[
      NCache[
       Rational[154, 4769], 0.03229188509121409]], AbsoluteThickness[0.25], 
     LineBox[{462, 463}]}, 
    {Hue[
      NCache[
       Rational[463, 14307], 0.032361780946389876`]], AbsoluteThickness[0.25],
      LineBox[{463, 464}]}, 
    {Hue[
      NCache[
       Rational[464, 14307], 0.03243167680156567]], AbsoluteThickness[0.25], 
     LineBox[{464, 465}]}, 
    {Hue[
      NCache[
       Rational[155, 4769], 0.03250157265674145]], AbsoluteThickness[0.25], 
     LineBox[{465, 466}]}, 
    {Hue[
      NCache[
       Rational[466, 14307], 0.032571468511917244`]], AbsoluteThickness[0.25],
      LineBox[{466, 467}]}, 
    {Hue[
      NCache[
       Rational[467, 14307], 0.03264136436709303]], AbsoluteThickness[0.25], 
     LineBox[{467, 468}]}, 
    {Hue[
      NCache[
       Rational[156, 4769], 0.03271126022226882]], AbsoluteThickness[0.25], 
     LineBox[{468, 469}]}, 
    {Hue[
      NCache[
       Rational[469, 14307], 0.032781156077444605`]], AbsoluteThickness[0.25],
      LineBox[{469, 470}]}, 
    {Hue[
      NCache[
       Rational[470, 14307], 0.0328510519326204]], AbsoluteThickness[0.25], 
     LineBox[{470, 471}]}, 
    {Hue[
      NCache[
       Rational[157, 4769], 0.03292094778779618]], AbsoluteThickness[0.25], 
     LineBox[{471, 472}]}, 
    {Hue[
      NCache[
       Rational[472, 14307], 0.03299084364297197]], AbsoluteThickness[0.25], 
     LineBox[{472, 473}]}, 
    {Hue[
      NCache[
       Rational[473, 14307], 0.03306073949814776]], AbsoluteThickness[0.25], 
     LineBox[{473, 474}]}, 
    {Hue[
      NCache[
       Rational[158, 4769], 0.03313063535332355]], AbsoluteThickness[0.25], 
     LineBox[{474, 475}]}, 
    {Hue[
      NCache[
       Rational[25, 753], 0.033200531208499334`]], AbsoluteThickness[0.25], 
     LineBox[{475, 476}]}, 
    {Hue[
      NCache[
       Rational[476, 14307], 0.033270427063675126`]], AbsoluteThickness[0.25],
      LineBox[{476, 477}]}, 
    {Hue[
      NCache[
       Rational[159, 4769], 0.03334032291885091]], AbsoluteThickness[0.25], 
     LineBox[{477, 478}]}, 
    {Hue[
      NCache[
       Rational[478, 14307], 0.0334102187740267]], AbsoluteThickness[0.25], 
     LineBox[{478, 479}]}, 
    {Hue[
      NCache[
       Rational[479, 14307], 0.03348011462920249]], AbsoluteThickness[0.25], 
     LineBox[{479, 480}]}, 
    {Hue[
      NCache[
       Rational[160, 4769], 0.03355001048437828]], AbsoluteThickness[0.25], 
     LineBox[{480, 481}]}, 
    {Hue[
      NCache[
       Rational[481, 14307], 0.03361990633955406]], AbsoluteThickness[0.25], 
     LineBox[{481, 482}]}, 
    {Hue[
      NCache[
       Rational[482, 14307], 0.033689802194729855`]], AbsoluteThickness[0.25],
      LineBox[{482, 483}]}, 
    {Hue[
      NCache[
       Rational[161, 4769], 0.03375969804990564]], AbsoluteThickness[0.25], 
     LineBox[{483, 484}]}, 
    {Hue[
      NCache[
       Rational[484, 14307], 0.03382959390508143]], AbsoluteThickness[0.25], 
     LineBox[{484, 485}]}, 
    {Hue[
      NCache[
       Rational[485, 14307], 0.033899489760257216`]], AbsoluteThickness[0.25],
      LineBox[{485, 486}]}, 
    {Hue[
      NCache[
       Rational[162, 4769], 0.03396938561543301]], AbsoluteThickness[0.25], 
     LineBox[{486, 487}]}, 
    {Hue[
      NCache[
       Rational[487, 14307], 0.03403928147060879]], AbsoluteThickness[0.25], 
     LineBox[{487, 488}]}, 
    {Hue[
      NCache[
       Rational[488, 14307], 0.034109177325784584`]], AbsoluteThickness[0.25],
      LineBox[{488, 489}]}, 
    {Hue[
      NCache[
       Rational[163, 4769], 0.03417907318096037]], AbsoluteThickness[0.25], 
     LineBox[{489, 490}]}, 
    {Hue[
      NCache[
       Rational[490, 14307], 0.034248969036136154`]], AbsoluteThickness[0.25],
      LineBox[{490, 491}]}, 
    {Hue[
      NCache[
       Rational[491, 14307], 0.034318864891311945`]], AbsoluteThickness[0.25],
      LineBox[{491, 492}]}, 
    {Hue[
      NCache[
       Rational[164, 4769], 0.03438876074648773]], AbsoluteThickness[0.25], 
     LineBox[{492, 493}]}, 
    {Hue[
      NCache[
       Rational[493, 14307], 0.03445865660166352]], AbsoluteThickness[0.25], 
     LineBox[{493, 494}]}, 
    {Hue[
      NCache[
       Rational[26, 753], 0.034528552456839307`]], AbsoluteThickness[0.25], 
     LineBox[{494, 495}]}, 
    {Hue[
      NCache[
       Rational[165, 4769], 0.0345984483120151]], AbsoluteThickness[0.25], 
     LineBox[{495, 496}]}, 
    {Hue[
      NCache[
       Rational[496, 14307], 0.03466834416719088]], AbsoluteThickness[0.25], 
     LineBox[{496, 497}]}, 
    {Hue[
      NCache[
       Rational[497, 14307], 0.034738240022366675`]], AbsoluteThickness[0.25],
      LineBox[{497, 498}]}, 
    {Hue[
      NCache[
       Rational[166, 4769], 0.03480813587754246]], AbsoluteThickness[0.25], 
     LineBox[{498, 499}]}, 
    {Hue[
      NCache[
       Rational[499, 14307], 0.03487803173271825]], AbsoluteThickness[0.25], 
     LineBox[{499, 500}]}, 
    {Hue[
      NCache[
       Rational[500, 14307], 0.034947927587894036`]], AbsoluteThickness[0.25],
      LineBox[{500, 501}]}, 
    {Hue[
      NCache[
       Rational[167, 4769], 0.03501782344306983]], AbsoluteThickness[0.25], 
     LineBox[{501, 502}]}, 
    {Hue[
      NCache[
       Rational[2, 57], 0.03508771929824561]], AbsoluteThickness[0.25], 
     LineBox[{502, 503}]}, 
    {Hue[
      NCache[
       Rational[503, 14307], 0.035157615153421404`]], AbsoluteThickness[0.25],
      LineBox[{503, 504}]}, 
    {Hue[
      NCache[
       Rational[168, 4769], 0.03522751100859719]], AbsoluteThickness[0.25], 
     LineBox[{504, 505}]}, 
    {Hue[
      NCache[
       Rational[505, 14307], 0.03529740686377298]], AbsoluteThickness[0.25], 
     LineBox[{505, 506}]}, 
    {Hue[
      NCache[
       Rational[506, 14307], 0.035367302718948765`]], AbsoluteThickness[0.25],
      LineBox[{506, 507}]}, 
    {Hue[
      NCache[
       Rational[169, 4769], 0.03543719857412456]], AbsoluteThickness[0.25], 
     LineBox[{507, 508}]}, 
    {Hue[
      NCache[
       Rational[508, 14307], 0.03550709442930034]], AbsoluteThickness[0.25], 
     LineBox[{508, 509}]}, 
    {Hue[
      NCache[
       Rational[509, 14307], 0.03557699028447613]], AbsoluteThickness[0.25], 
     LineBox[{509, 510}]}, 
    {Hue[
      NCache[
       Rational[170, 4769], 0.03564688613965192]], AbsoluteThickness[0.25], 
     LineBox[{510, 511}]}, 
    {Hue[
      NCache[
       Rational[511, 14307], 0.03571678199482771]], AbsoluteThickness[0.25], 
     LineBox[{511, 512}]}, 
    {Hue[
      NCache[
       Rational[512, 14307], 0.035786677850003494`]], AbsoluteThickness[0.25],
      LineBox[{512, 513}]}, 
    {Hue[
      NCache[
       Rational[9, 251], 0.035856573705179286`]], AbsoluteThickness[0.25], 
     LineBox[{513, 514}]}, 
    {Hue[
      NCache[
       Rational[514, 14307], 0.03592646956035507]], AbsoluteThickness[0.25], 
     LineBox[{514, 515}]}, 
    {Hue[
      NCache[
       Rational[515, 14307], 0.03599636541553086]], AbsoluteThickness[0.25], 
     LineBox[{515, 516}]}, 
    {Hue[
      NCache[
       Rational[172, 4769], 0.03606626127070665]], AbsoluteThickness[0.25], 
     LineBox[{516, 517}]}, 
    {Hue[
      NCache[
       Rational[517, 14307], 0.03613615712588244]], AbsoluteThickness[0.25], 
     LineBox[{517, 518}]}, 
    {Hue[
      NCache[
       Rational[518, 14307], 0.03620605298105822]], AbsoluteThickness[0.25], 
     LineBox[{518, 519}]}, 
    {Hue[
      NCache[
       Rational[173, 4769], 0.03627594883623401]], AbsoluteThickness[0.25], 
     LineBox[{519, 520}]}, 
    {Hue[
      NCache[
       Rational[520, 14307], 0.0363458446914098]], AbsoluteThickness[0.25], 
     LineBox[{520, 521}]}, 
    {Hue[
      NCache[
       Rational[521, 14307], 0.036415740546585584`]], AbsoluteThickness[0.25],
      LineBox[{521, 522}]}, 
    {Hue[
      NCache[
       Rational[174, 4769], 0.036485636401761376`]], AbsoluteThickness[0.25], 
     LineBox[{522, 523}]}, 
    {Hue[
      NCache[
       Rational[523, 14307], 0.03655553225693716]], AbsoluteThickness[0.25], 
     LineBox[{523, 524}]}, 
    {Hue[
      NCache[
       Rational[524, 14307], 0.03662542811211295]], AbsoluteThickness[0.25], 
     LineBox[{524, 525}]}, 
    {Hue[
      NCache[
       Rational[175, 4769], 0.03669532396728874]], AbsoluteThickness[0.25], 
     LineBox[{525, 526}]}, 
    {Hue[
      NCache[
       Rational[526, 14307], 0.03676521982246453]], AbsoluteThickness[0.25], 
     LineBox[{526, 527}]}, 
    {Hue[
      NCache[
       Rational[527, 14307], 0.036835115677640314`]], AbsoluteThickness[0.25],
      LineBox[{527, 528}]}, 
    {Hue[
      NCache[
       Rational[176, 4769], 0.036905011532816105`]], AbsoluteThickness[0.25], 
     LineBox[{528, 529}]}, 
    {Hue[
      NCache[
       Rational[529, 14307], 0.03697490738799189]], AbsoluteThickness[0.25], 
     LineBox[{529, 530}]}, 
    {Hue[
      NCache[
       Rational[530, 14307], 0.03704480324316768]], AbsoluteThickness[0.25], 
     LineBox[{530, 531}]}, 
    {Hue[
      NCache[
       Rational[177, 4769], 0.037114699098343466`]], AbsoluteThickness[0.25], 
     LineBox[{531, 532}]}, 
    {Hue[
      NCache[
       Rational[28, 753], 0.03718459495351926]], AbsoluteThickness[0.25], 
     LineBox[{532, 533}]}, 
    {Hue[
      NCache[
       Rational[533, 14307], 0.03725449080869504]], AbsoluteThickness[0.25], 
     LineBox[{533, 534}]}, 
    {Hue[
      NCache[
       Rational[178, 4769], 0.037324386663870834`]], AbsoluteThickness[0.25], 
     LineBox[{534, 535}]}, 
    {Hue[
      NCache[
       Rational[535, 14307], 0.03739428251904662]], AbsoluteThickness[0.25], 
     LineBox[{535, 536}]}, 
    {Hue[
      NCache[
       Rational[536, 14307], 0.03746417837422241]], AbsoluteThickness[0.25], 
     LineBox[{536, 537}]}, 
    {Hue[
      NCache[
       Rational[179, 4769], 0.037534074229398195`]], AbsoluteThickness[0.25], 
     LineBox[{537, 538}]}, 
    {Hue[
      NCache[
       Rational[538, 14307], 0.03760397008457399]], AbsoluteThickness[0.25], 
     LineBox[{538, 539}]}, 
    {Hue[
      NCache[
       Rational[539, 14307], 0.03767386593974977]], AbsoluteThickness[0.25], 
     LineBox[{539, 540}]}, 
    {Hue[
      NCache[
       Rational[180, 4769], 0.037743761794925564`]], AbsoluteThickness[0.25], 
     LineBox[{540, 541}]}, 
    {Hue[
      NCache[
       Rational[541, 14307], 0.03781365765010135]], AbsoluteThickness[0.25], 
     LineBox[{541, 542}]}, 
    {Hue[
      NCache[
       Rational[542, 14307], 0.03788355350527714]], AbsoluteThickness[0.25], 
     LineBox[{542, 543}]}, 
    {Hue[
      NCache[
       Rational[181, 4769], 0.037953449360452925`]], AbsoluteThickness[0.25], 
     LineBox[{543, 544}]}, 
    {Hue[
      NCache[
       Rational[544, 14307], 0.038023345215628716`]], AbsoluteThickness[0.25],
      LineBox[{544, 545}]}, 
    {Hue[
      NCache[
       Rational[545, 14307], 0.0380932410708045]], AbsoluteThickness[0.25], 
     LineBox[{545, 546}]}, 
    {Hue[
      NCache[
       Rational[182, 4769], 0.03816313692598029]], AbsoluteThickness[0.25], 
     LineBox[{546, 547}]}, 
    {Hue[
      NCache[
       Rational[547, 14307], 0.03823303278115608]], AbsoluteThickness[0.25], 
     LineBox[{547, 548}]}, 
    {Hue[
      NCache[
       Rational[548, 14307], 0.03830292863633186]], AbsoluteThickness[0.25], 
     LineBox[{548, 549}]}, 
    {Hue[
      NCache[
       Rational[183, 4769], 0.038372824491507654`]], AbsoluteThickness[0.25], 
     LineBox[{549, 550}]}, 
    {Hue[
      NCache[
       Rational[550, 14307], 0.03844272034668344]], AbsoluteThickness[0.25], 
     LineBox[{550, 551}]}, 
    {Hue[
      NCache[
       Rational[29, 753], 0.03851261620185923]], AbsoluteThickness[0.25], 
     LineBox[{551, 552}]}, 
    {Hue[
      NCache[
       Rational[184, 4769], 0.038582512057035015`]], AbsoluteThickness[0.25], 
     LineBox[{552, 553}]}, 
    {Hue[
      NCache[
       Rational[553, 14307], 0.03865240791221081]], AbsoluteThickness[0.25], 
     LineBox[{553, 554}]}, 
    {Hue[
      NCache[
       Rational[554, 14307], 0.03872230376738659]], AbsoluteThickness[0.25], 
     LineBox[{554, 555}]}, 
    {Hue[
      NCache[
       Rational[185, 4769], 0.03879219962256238]], AbsoluteThickness[0.25], 
     LineBox[{555, 556}]}, 
    {Hue[
      NCache[
       Rational[556, 14307], 0.03886209547773817]], AbsoluteThickness[0.25], 
     LineBox[{556, 557}]}, 
    {Hue[
      NCache[
       Rational[557, 14307], 0.03893199133291396]], AbsoluteThickness[0.25], 
     LineBox[{557, 558}]}, 
    {Hue[
      NCache[
       Rational[186, 4769], 0.039001887188089744`]], AbsoluteThickness[0.25], 
     LineBox[{558, 559}]}, 
    {Hue[
      NCache[
       Rational[559, 14307], 0.039071783043265536`]], AbsoluteThickness[0.25],
      LineBox[{559, 560}]}, 
    {Hue[
      NCache[
       Rational[560, 14307], 0.03914167889844132]], AbsoluteThickness[0.25], 
     LineBox[{560, 561}]}, 
    {Hue[
      NCache[
       Rational[187, 4769], 0.03921157475361711]], AbsoluteThickness[0.25], 
     LineBox[{561, 562}]}, 
    {Hue[
      NCache[
       Rational[562, 14307], 0.0392814706087929]], AbsoluteThickness[0.25], 
     LineBox[{562, 563}]}, 
    {Hue[
      NCache[
       Rational[563, 14307], 0.03935136646396869]], AbsoluteThickness[0.25], 
     LineBox[{563, 564}]}, 
    {Hue[
      NCache[
       Rational[188, 4769], 0.03942126231914447]], AbsoluteThickness[0.25], 
     LineBox[{564, 565}]}, 
    {Hue[
      NCache[
       Rational[565, 14307], 0.039491158174320265`]], AbsoluteThickness[0.25],
      LineBox[{565, 566}]}, 
    {Hue[
      NCache[
       Rational[566, 14307], 0.03956105402949605]], AbsoluteThickness[0.25], 
     LineBox[{566, 567}]}, 
    {Hue[
      NCache[
       Rational[189, 4769], 0.03963094988467184]], AbsoluteThickness[0.25], 
     LineBox[{567, 568}]}, 
    {Hue[
      NCache[
       Rational[568, 14307], 0.039700845739847626`]], AbsoluteThickness[0.25],
      LineBox[{568, 569}]}, 
    {Hue[
      NCache[
       Rational[569, 14307], 0.03977074159502342]], AbsoluteThickness[0.25], 
     LineBox[{569, 570}]}, 
    {Hue[
      NCache[
       Rational[10, 251], 0.0398406374501992]], AbsoluteThickness[0.25], 
     LineBox[{570, 571}]}, 
    {Hue[
      NCache[
       Rational[571, 14307], 0.039910533305374994`]], AbsoluteThickness[0.25],
      LineBox[{571, 572}]}, 
    {Hue[
      NCache[
       Rational[572, 14307], 0.03998042916055078]], AbsoluteThickness[0.25], 
     LineBox[{572, 573}]}, 
    {Hue[
      NCache[
       Rational[191, 4769], 0.04005032501572657]], AbsoluteThickness[0.25], 
     LineBox[{573, 574}]}, 
    {Hue[
      NCache[
       Rational[574, 14307], 0.040120220870902355`]], AbsoluteThickness[0.25],
      LineBox[{574, 575}]}, 
    {Hue[
      NCache[
       Rational[575, 14307], 0.04019011672607815]], AbsoluteThickness[0.25], 
     LineBox[{575, 576}]}, 
    {Hue[
      NCache[
       Rational[192, 4769], 0.04026001258125393]], AbsoluteThickness[0.25], 
     LineBox[{576, 577}]}, 
    {Hue[
      NCache[
       Rational[577, 14307], 0.040329908436429716`]], AbsoluteThickness[0.25],
      LineBox[{577, 578}]}, 
    {Hue[
      NCache[
       Rational[578, 14307], 0.04039980429160551]], AbsoluteThickness[0.25], 
     LineBox[{578, 579}]}, 
    {Hue[
      NCache[
       Rational[193, 4769], 0.04046970014678129]], AbsoluteThickness[0.25], 
     LineBox[{579, 580}]}, 
    {Hue[
      NCache[
       Rational[580, 14307], 0.040539596001957084`]], AbsoluteThickness[0.25],
      LineBox[{580, 581}]}, 
    {Hue[
      NCache[
       Rational[581, 14307], 0.04060949185713287]], AbsoluteThickness[0.25], 
     LineBox[{581, 582}]}, 
    {Hue[
      NCache[
       Rational[194, 4769], 0.04067938771230866]], AbsoluteThickness[0.25], 
     LineBox[{582, 583}]}, 
    {Hue[
      NCache[
       Rational[583, 14307], 0.040749283567484446`]], AbsoluteThickness[0.25],
      LineBox[{583, 584}]}, 
    {Hue[
      NCache[
       Rational[584, 14307], 0.04081917942266024]], AbsoluteThickness[0.25], 
     LineBox[{584, 585}]}, 
    {Hue[
      NCache[
       Rational[195, 4769], 0.04088907527783602]], AbsoluteThickness[0.25], 
     LineBox[{585, 586}]}, 
    {Hue[
      NCache[
       Rational[586, 14307], 0.040958971133011814`]], AbsoluteThickness[0.25],
      LineBox[{586, 587}]}, 
    {Hue[
      NCache[
       Rational[587, 14307], 0.0410288669881876]], AbsoluteThickness[0.25], 
     LineBox[{587, 588}]}, 
    {Hue[
      NCache[
       Rational[196, 4769], 0.04109876284336339]], AbsoluteThickness[0.25], 
     LineBox[{588, 589}]}, 
    {Hue[
      NCache[
       Rational[31, 753], 0.041168658698539175`]], AbsoluteThickness[0.25], 
     LineBox[{589, 590}]}, 
    {Hue[
      NCache[
       Rational[590, 14307], 0.041238554553714966`]], AbsoluteThickness[0.25],
      LineBox[{590, 591}]}, 
    {Hue[
      NCache[
       Rational[197, 4769], 0.04130845040889075]], AbsoluteThickness[0.25], 
     LineBox[{591, 592}]}, 
    {Hue[
      NCache[
       Rational[592, 14307], 0.04137834626406654]], AbsoluteThickness[0.25], 
     LineBox[{592, 593}]}, 
    {Hue[
      NCache[
       Rational[593, 14307], 0.04144824211924233]], AbsoluteThickness[0.25], 
     LineBox[{593, 594}]}, 
    {Hue[
      NCache[
       Rational[198, 4769], 0.04151813797441812]], AbsoluteThickness[0.25], 
     LineBox[{594, 595}]}, 
    {Hue[
      NCache[
       Rational[595, 14307], 0.041588033829593904`]], AbsoluteThickness[0.25],
      LineBox[{595, 596}]}, 
    {Hue[
      NCache[
       Rational[596, 14307], 0.041657929684769696`]], AbsoluteThickness[0.25],
      LineBox[{596, 597}]}, 
    {Hue[
      NCache[
       Rational[199, 4769], 0.04172782553994548]], AbsoluteThickness[0.25], 
     LineBox[{597, 598}]}, 
    {Hue[
      NCache[
       Rational[598, 14307], 0.04179772139512127]], AbsoluteThickness[0.25], 
     LineBox[{598, 599}]}, 
    {Hue[
      NCache[
       Rational[599, 14307], 0.04186761725029706]], AbsoluteThickness[0.25], 
     LineBox[{599, 600}]}, 
    {Hue[
      NCache[
       Rational[200, 4769], 0.04193751310547285]], AbsoluteThickness[0.25], 
     LineBox[{600, 601}]}, 
    {Hue[
      NCache[
       Rational[601, 14307], 0.04200740896064863]], AbsoluteThickness[0.25], 
     LineBox[{601, 602}]}, 
    {Hue[
      NCache[
       Rational[602, 14307], 0.042077304815824425`]], AbsoluteThickness[0.25],
      LineBox[{602, 603}]}, 
    {Hue[
      NCache[
       Rational[201, 4769], 0.04214720067100021]], AbsoluteThickness[0.25], 
     LineBox[{603, 604}]}, 
    {Hue[
      NCache[
       Rational[604, 14307], 0.042217096526176]], AbsoluteThickness[0.25], 
     LineBox[{604, 605}]}, 
    {Hue[
      NCache[
       Rational[605, 14307], 0.042286992381351786`]], AbsoluteThickness[0.25],
      LineBox[{605, 606}]}, 
    {Hue[
      NCache[
       Rational[202, 4769], 0.04235688823652757]], AbsoluteThickness[0.25], 
     LineBox[{606, 607}]}, 
    {Hue[
      NCache[
       Rational[607, 14307], 0.04242678409170336]], AbsoluteThickness[0.25], 
     LineBox[{607, 608}]}, 
    {Hue[
      NCache[
       Rational[32, 753], 0.04249667994687915]], AbsoluteThickness[0.25], 
     LineBox[{608, 609}]}, 
    {Hue[
      NCache[
       Rational[203, 4769], 0.04256657580205494]], AbsoluteThickness[0.25], 
     LineBox[{609, 610}]}, 
    {Hue[
      NCache[
       Rational[610, 14307], 0.04263647165723072]], AbsoluteThickness[0.25], 
     LineBox[{610, 611}]}, 
    {Hue[
      NCache[
       Rational[611, 14307], 0.042706367512406515`]], AbsoluteThickness[0.25],
      LineBox[{611, 612}]}, 
    {Hue[
      NCache[
       Rational[204, 4769], 0.0427762633675823]], AbsoluteThickness[0.25], 
     LineBox[{612, 613}]}, 
    {Hue[
      NCache[
       Rational[613, 14307], 0.04284615922275809]], AbsoluteThickness[0.25], 
     LineBox[{613, 614}]}, 
    {Hue[
      NCache[
       Rational[614, 14307], 0.042916055077933876`]], AbsoluteThickness[0.25],
      LineBox[{614, 615}]}, 
    {Hue[
      NCache[
       Rational[205, 4769], 0.04298595093310967]], AbsoluteThickness[0.25], 
     LineBox[{615, 616}]}, 
    {Hue[
      NCache[
       Rational[616, 14307], 0.04305584678828545]], AbsoluteThickness[0.25], 
     LineBox[{616, 617}]}, 
    {Hue[
      NCache[
       Rational[617, 14307], 0.043125742643461244`]], AbsoluteThickness[0.25],
      LineBox[{617, 618}]}, 
    {Hue[
      NCache[
       Rational[206, 4769], 0.04319563849863703]], AbsoluteThickness[0.25], 
     LineBox[{618, 619}]}, 
    {Hue[
      NCache[
       Rational[619, 14307], 0.04326553435381282]], AbsoluteThickness[0.25], 
     LineBox[{619, 620}]}, 
    {Hue[
      NCache[
       Rational[620, 14307], 0.043335430208988605`]], AbsoluteThickness[0.25],
      LineBox[{620, 621}]}, 
    {Hue[
      NCache[
       Rational[207, 4769], 0.0434053260641644]], AbsoluteThickness[0.25], 
     LineBox[{621, 622}]}, 
    {Hue[
      NCache[
       Rational[622, 14307], 0.04347522191934018]], AbsoluteThickness[0.25], 
     LineBox[{622, 623}]}, 
    {Hue[
      NCache[
       Rational[623, 14307], 0.04354511777451597]], AbsoluteThickness[0.25], 
     LineBox[{623, 624}]}, 
    {Hue[
      NCache[
       Rational[208, 4769], 0.04361501362969176]], AbsoluteThickness[0.25], 
     LineBox[{624, 625}]}, 
    {Hue[
      NCache[
       Rational[625, 14307], 0.04368490948486755]], AbsoluteThickness[0.25], 
     LineBox[{625, 626}]}, 
    {Hue[
      NCache[
       Rational[626, 14307], 0.043754805340043335`]], AbsoluteThickness[0.25],
      LineBox[{626, 627}]}, 
    {Hue[
      NCache[
       Rational[11, 251], 0.043824701195219126`]], AbsoluteThickness[0.25], 
     LineBox[{627, 628}]}, 
    {Hue[
      NCache[
       Rational[628, 14307], 0.04389459705039491]], AbsoluteThickness[0.25], 
     LineBox[{628, 629}]}, 
    {Hue[
      NCache[
       Rational[629, 14307], 0.0439644929055707]], AbsoluteThickness[0.25], 
     LineBox[{629, 630}]}, 
    {Hue[
      NCache[
       Rational[210, 4769], 0.04403438876074649]], AbsoluteThickness[0.25], 
     LineBox[{630, 631}]}, 
    {Hue[
      NCache[
       Rational[631, 14307], 0.04410428461592228]], AbsoluteThickness[0.25], 
     LineBox[{631, 632}]}, 
    {Hue[
      NCache[
       Rational[632, 14307], 0.044174180471098064`]], AbsoluteThickness[0.25],
      LineBox[{632, 633}]}, 
    {Hue[
      NCache[
       Rational[211, 4769], 0.044244076326273855`]], AbsoluteThickness[0.25], 
     LineBox[{633, 634}]}, 
    {Hue[
      NCache[
       Rational[634, 14307], 0.04431397218144964]], AbsoluteThickness[0.25], 
     LineBox[{634, 635}]}, 
    {Hue[
      NCache[
       Rational[635, 14307], 0.044383868036625425`]], AbsoluteThickness[0.25],
      LineBox[{635, 636}]}, 
    {Hue[
      NCache[
       Rational[212, 4769], 0.044453763891801217`]], AbsoluteThickness[0.25], 
     LineBox[{636, 637}]}, 
    {Hue[
      NCache[
       Rational[637, 14307], 0.044523659746977]], AbsoluteThickness[0.25], 
     LineBox[{637, 638}]}, 
    {Hue[
      NCache[
       Rational[638, 14307], 0.04459355560215279]], AbsoluteThickness[0.25], 
     LineBox[{638, 639}]}, 
    {Hue[
      NCache[
       Rational[213, 4769], 0.04466345145732858]], AbsoluteThickness[0.25], 
     LineBox[{639, 640}]}, 
    {Hue[
      NCache[
       Rational[640, 14307], 0.04473334731250437]], AbsoluteThickness[0.25], 
     LineBox[{640, 641}]}, 
    {Hue[
      NCache[
       Rational[641, 14307], 0.044803243167680154`]], AbsoluteThickness[0.25],
      LineBox[{641, 642}]}, 
    {Hue[
      NCache[
       Rational[214, 4769], 0.044873139022855946`]], AbsoluteThickness[0.25], 
     LineBox[{642, 643}]}, 
    {Hue[
      NCache[
       Rational[643, 14307], 0.04494303487803173]], AbsoluteThickness[0.25], 
     LineBox[{643, 644}]}, 
    {Hue[
      NCache[
       Rational[644, 14307], 0.04501293073320752]], AbsoluteThickness[0.25], 
     LineBox[{644, 645}]}, 
    {Hue[
      NCache[
       Rational[215, 4769], 0.04508282658838331]], AbsoluteThickness[0.25], 
     LineBox[{645, 646}]}, 
    {Hue[
      NCache[
       Rational[34, 753], 0.0451527224435591]], AbsoluteThickness[0.25], 
     LineBox[{646, 647}]}, 
    {Hue[
      NCache[
       Rational[647, 14307], 0.04522261829873488]], AbsoluteThickness[0.25], 
     LineBox[{647, 648}]}, 
    {Hue[
      NCache[
       Rational[216, 4769], 0.045292514153910675`]], AbsoluteThickness[0.25], 
     LineBox[{648, 649}]}, 
    {Hue[
      NCache[
       Rational[649, 14307], 0.04536241000908646]], AbsoluteThickness[0.25], 
     LineBox[{649, 650}]}, 
    {Hue[
      NCache[
       Rational[650, 14307], 0.04543230586426225]], AbsoluteThickness[0.25], 
     LineBox[{650, 651}]}, 
    {Hue[
      NCache[
       Rational[217, 4769], 0.045502201719438036`]], AbsoluteThickness[0.25], 
     LineBox[{651, 652}]}, 
    {Hue[
      NCache[
       Rational[652, 14307], 0.04557209757461383]], AbsoluteThickness[0.25], 
     LineBox[{652, 653}]}, 
    {Hue[
      NCache[
       Rational[653, 14307], 0.04564199342978961]], AbsoluteThickness[0.25], 
     LineBox[{653, 654}]}, 
    {Hue[
      NCache[
       Rational[218, 4769], 0.045711889284965404`]], AbsoluteThickness[0.25], 
     LineBox[{654, 655}]}, 
    {Hue[
      NCache[
       Rational[655, 14307], 0.04578178514014119]], AbsoluteThickness[0.25], 
     LineBox[{655, 656}]}, 
    {Hue[
      NCache[
       Rational[656, 14307], 0.04585168099531698]], AbsoluteThickness[0.25], 
     LineBox[{656, 657}]}, 
    {Hue[
      NCache[
       Rational[219, 4769], 0.045921576850492765`]], AbsoluteThickness[0.25], 
     LineBox[{657, 658}]}, 
    {Hue[
      NCache[
       Rational[658, 14307], 0.04599147270566856]], AbsoluteThickness[0.25], 
     LineBox[{658, 659}]}, 
    {Hue[
      NCache[
       Rational[659, 14307], 0.04606136856084434]], AbsoluteThickness[0.25], 
     LineBox[{659, 660}]}, 
    {Hue[
      NCache[
       Rational[220, 4769], 0.04613126441602013]], AbsoluteThickness[0.25], 
     LineBox[{660, 661}]}, 
    {Hue[
      NCache[
       Rational[661, 14307], 0.04620116027119592]], AbsoluteThickness[0.25], 
     LineBox[{661, 662}]}, 
    {Hue[
      NCache[
       Rational[662, 14307], 0.04627105612637171]], AbsoluteThickness[0.25], 
     LineBox[{662, 663}]}, 
    {Hue[
      NCache[
       Rational[221, 4769], 0.046340951981547494`]], AbsoluteThickness[0.25], 
     LineBox[{663, 664}]}, 
    {Hue[
      NCache[
       Rational[664, 14307], 0.04641084783672328]], AbsoluteThickness[0.25], 
     LineBox[{664, 665}]}, 
    {Hue[
      NCache[
       Rational[35, 753], 0.04648074369189907]], AbsoluteThickness[0.25], 
     LineBox[{665, 666}]}, 
    {Hue[
      NCache[
       Rational[222, 4769], 0.046550639547074855`]], AbsoluteThickness[0.25], 
     LineBox[{666, 667}]}, 
    {Hue[
      NCache[
       Rational[667, 14307], 0.04662053540225065]], AbsoluteThickness[0.25], 
     LineBox[{667, 668}]}, 
    {Hue[
      NCache[
       Rational[668, 14307], 0.04669043125742643]], AbsoluteThickness[0.25], 
     LineBox[{668, 669}]}, 
    {Hue[
      NCache[
       Rational[223, 4769], 0.046760327112602224`]], AbsoluteThickness[0.25], 
     LineBox[{669, 670}]}, 
    {Hue[
      NCache[
       Rational[670, 14307], 0.04683022296777801]], AbsoluteThickness[0.25], 
     LineBox[{670, 671}]}, 
    {Hue[
      NCache[
       Rational[671, 14307], 0.0469001188229538]], AbsoluteThickness[0.25], 
     LineBox[{671, 672}]}, 
    {Hue[
      NCache[
       Rational[224, 4769], 0.046970014678129585`]], AbsoluteThickness[0.25], 
     LineBox[{672, 673}]}, 
    {Hue[
      NCache[
       Rational[673, 14307], 0.047039910533305376`]], AbsoluteThickness[0.25],
      LineBox[{673, 674}]}, 
    {Hue[
      NCache[
       Rational[674, 14307], 0.04710980638848116]], AbsoluteThickness[0.25], 
     LineBox[{674, 675}]}, 
    {Hue[
      NCache[
       Rational[225, 4769], 0.04717970224365695]], AbsoluteThickness[0.25], 
     LineBox[{675, 676}]}, 
    {Hue[
      NCache[
       Rational[676, 14307], 0.04724959809883274]], AbsoluteThickness[0.25], 
     LineBox[{676, 677}]}, 
    {Hue[
      NCache[
       Rational[677, 14307], 0.04731949395400853]], AbsoluteThickness[0.25], 
     LineBox[{677, 678}]}, 
    {Hue[
      NCache[
       Rational[226, 4769], 0.047389389809184314`]], AbsoluteThickness[0.25], 
     LineBox[{678, 679}]}, 
    {Hue[
      NCache[
       Rational[679, 14307], 0.047459285664360105`]], AbsoluteThickness[0.25],
      LineBox[{679, 680}]}, 
    {Hue[
      NCache[
       Rational[680, 14307], 0.04752918151953589]], AbsoluteThickness[0.25], 
     LineBox[{680, 681}]}, 
    {Hue[
      NCache[
       Rational[227, 4769], 0.04759907737471168]], AbsoluteThickness[0.25], 
     LineBox[{681, 682}]}, 
    {Hue[
      NCache[
       Rational[682, 14307], 0.04766897322988747]], AbsoluteThickness[0.25], 
     LineBox[{682, 683}]}, 
    {Hue[
      NCache[
       Rational[683, 14307], 0.04773886908506326]], AbsoluteThickness[0.25], 
     LineBox[{683, 684}]}, 
    {Hue[
      NCache[
       Rational[12, 251], 0.04780876494023904]], AbsoluteThickness[0.25], 
     LineBox[{684, 685}]}, 
    {Hue[
      NCache[
       Rational[685, 14307], 0.047878660795414835`]], AbsoluteThickness[0.25],
      LineBox[{685, 686}]}, 
    {Hue[
      NCache[
       Rational[686, 14307], 0.04794855665059062]], AbsoluteThickness[0.25], 
     LineBox[{686, 687}]}, 
    {Hue[
      NCache[
       Rational[229, 4769], 0.04801845250576641]], AbsoluteThickness[0.25], 
     LineBox[{687, 688}]}, 
    {Hue[
      NCache[
       Rational[688, 14307], 0.048088348360942196`]], AbsoluteThickness[0.25],
      LineBox[{688, 689}]}, 
    {Hue[
      NCache[
       Rational[689, 14307], 0.04815824421611799]], AbsoluteThickness[0.25], 
     LineBox[{689, 690}]}, 
    {Hue[
      NCache[
       Rational[230, 4769], 0.04822814007129377]], AbsoluteThickness[0.25], 
     LineBox[{690, 691}]}, 
    {Hue[
      NCache[
       Rational[691, 14307], 0.04829803592646956]], AbsoluteThickness[0.25], 
     LineBox[{691, 692}]}, 
    {Hue[
      NCache[
       Rational[692, 14307], 0.04836793178164535]], AbsoluteThickness[0.25], 
     LineBox[{692, 693}]}, 
    {Hue[
      NCache[
       Rational[231, 4769], 0.04843782763682113]], AbsoluteThickness[0.25], 
     LineBox[{693, 694}]}, 
    {Hue[
      NCache[
       Rational[694, 14307], 0.048507723491996925`]], AbsoluteThickness[0.25],
      LineBox[{694, 695}]}, 
    {Hue[
      NCache[
       Rational[695, 14307], 0.04857761934717271]], AbsoluteThickness[0.25], 
     LineBox[{695, 696}]}, 
    {Hue[
      NCache[
       Rational[232, 4769], 0.0486475152023485]], AbsoluteThickness[0.25], 
     LineBox[{696, 697}]}, 
    {Hue[
      NCache[
       Rational[697, 14307], 0.048717411057524286`]], AbsoluteThickness[0.25],
      LineBox[{697, 698}]}, 
    {Hue[
      NCache[
       Rational[698, 14307], 0.04878730691270008]], AbsoluteThickness[0.25], 
     LineBox[{698, 699}]}, 
    {Hue[
      NCache[
       Rational[233, 4769], 0.04885720276787586]], AbsoluteThickness[0.25], 
     LineBox[{699, 700}]}, 
    {Hue[
      NCache[
       Rational[700, 14307], 0.048927098623051654`]], AbsoluteThickness[0.25],
      LineBox[{700, 701}]}, 
    {Hue[
      NCache[
       Rational[701, 14307], 0.04899699447822744]], AbsoluteThickness[0.25], 
     LineBox[{701, 702}]}, 
    {Hue[
      NCache[
       Rational[234, 4769], 0.04906689033340323]], AbsoluteThickness[0.25], 
     LineBox[{702, 703}]}, 
    {Hue[
      NCache[
       Rational[37, 753], 0.049136786188579015`]], AbsoluteThickness[0.25], 
     LineBox[{703, 704}]}, 
    {Hue[
      NCache[
       Rational[704, 14307], 0.04920668204375481]], AbsoluteThickness[0.25], 
     LineBox[{704, 705}]}, 
    {Hue[
      NCache[
       Rational[235, 4769], 0.04927657789893059]], AbsoluteThickness[0.25], 
     LineBox[{705, 706}]}, 
    {Hue[
      NCache[
       Rational[706, 14307], 0.04934647375410638]], AbsoluteThickness[0.25], 
     LineBox[{706, 707}]}, 
    {Hue[
      NCache[
       Rational[707, 14307], 0.04941636960928217]], AbsoluteThickness[0.25], 
     LineBox[{707, 708}]}, 
    {Hue[
      NCache[
       Rational[236, 4769], 0.04948626546445796]], AbsoluteThickness[0.25], 
     LineBox[{708, 709}]}, 
    {Hue[
      NCache[
       Rational[709, 14307], 0.049556161319633744`]], AbsoluteThickness[0.25],
      LineBox[{709, 710}]}, 
    {Hue[
      NCache[
       Rational[710, 14307], 0.049626057174809536`]], AbsoluteThickness[0.25],
      LineBox[{710, 711}]}, 
    {Hue[
      NCache[
       Rational[237, 4769], 0.04969595302998532]], AbsoluteThickness[0.25], 
     LineBox[{711, 712}]}, 
    {Hue[
      NCache[
       Rational[712, 14307], 0.04976584888516111]], AbsoluteThickness[0.25], 
     LineBox[{712, 713}]}, 
    {Hue[
      NCache[
       Rational[713, 14307], 0.0498357447403369]], AbsoluteThickness[0.25], 
     LineBox[{713, 714}]}, 
    {Hue[
      NCache[
       Rational[238, 4769], 0.04990564059551269]], AbsoluteThickness[0.25], 
     LineBox[{714, 715}]}, 
    {Hue[
      NCache[
       Rational[715, 14307], 0.049975536450688474`]], AbsoluteThickness[0.25],
      LineBox[{715, 716}]}, 
    {Hue[
      NCache[
       Rational[716, 14307], 0.050045432305864265`]], AbsoluteThickness[0.25],
      LineBox[{716, 717}]}, 
    {Hue[
      NCache[
       Rational[239, 4769], 0.05011532816104005]], AbsoluteThickness[0.25], 
     LineBox[{717, 718}]}, 
    {Hue[
      NCache[
       Rational[718, 14307], 0.05018522401621584]], AbsoluteThickness[0.25], 
     LineBox[{718, 719}]}, 
    {Hue[
      NCache[
       Rational[719, 14307], 0.050255119871391626`]], AbsoluteThickness[0.25],
      LineBox[{719, 720}]}, 
    {Hue[
      NCache[
       Rational[240, 4769], 0.05032501572656741]], AbsoluteThickness[0.25], 
     LineBox[{720, 721}]}, 
    {Hue[
      NCache[
       Rational[721, 14307], 0.0503949115817432]], AbsoluteThickness[0.25], 
     LineBox[{721, 722}]}, 
    {Hue[
      NCache[
       Rational[38, 753], 0.05046480743691899]], AbsoluteThickness[0.25], 
     LineBox[{722, 723}]}, 
    {Hue[
      NCache[
       Rational[241, 4769], 0.05053470329209478]], AbsoluteThickness[0.25], 
     LineBox[{723, 724}]}, 
    {Hue[
      NCache[
       Rational[724, 14307], 0.050604599147270564`]], AbsoluteThickness[0.25],
      LineBox[{724, 725}]}, 
    {Hue[
      NCache[
       Rational[725, 14307], 0.050674495002446356`]], AbsoluteThickness[0.25],
      LineBox[{725, 726}]}, 
    {Hue[
      NCache[
       Rational[242, 4769], 0.05074439085762214]], AbsoluteThickness[0.25], 
     LineBox[{726, 727}]}, 
    {Hue[
      NCache[
       Rational[727, 14307], 0.05081428671279793]], AbsoluteThickness[0.25], 
     LineBox[{727, 728}]}, 
    {Hue[
      NCache[
       Rational[728, 14307], 0.05088418256797372]], AbsoluteThickness[0.25], 
     LineBox[{728, 729}]}, 
    {Hue[
      NCache[
       Rational[243, 4769], 0.05095407842314951]], AbsoluteThickness[0.25], 
     LineBox[{729, 730}]}, 
    {Hue[
      NCache[
       Rational[730, 14307], 0.05102397427832529]], AbsoluteThickness[0.25], 
     LineBox[{730, 731}]}, 
    {Hue[
      NCache[
       Rational[731, 14307], 0.051093870133501085`]], AbsoluteThickness[0.25],
      LineBox[{731, 732}]}, 
    {Hue[
      NCache[
       Rational[244, 4769], 0.05116376598867687]], AbsoluteThickness[0.25], 
     LineBox[{732, 733}]}, 
    {Hue[
      NCache[
       Rational[733, 14307], 0.05123366184385266]], AbsoluteThickness[0.25], 
     LineBox[{733, 734}]}, 
    {Hue[
      NCache[
       Rational[734, 14307], 0.051303557699028446`]], AbsoluteThickness[0.25],
      LineBox[{734, 735}]}, 
    {Hue[
      NCache[
       Rational[245, 4769], 0.05137345355420424]], AbsoluteThickness[0.25], 
     LineBox[{735, 736}]}, 
    {Hue[
      NCache[
       Rational[736, 14307], 0.05144334940938002]], AbsoluteThickness[0.25], 
     LineBox[{736, 737}]}, 
    {Hue[
      NCache[
       Rational[737, 14307], 0.051513245264555814`]], AbsoluteThickness[0.25],
      LineBox[{737, 738}]}, 
    {Hue[
      NCache[
       Rational[246, 4769], 0.0515831411197316]], AbsoluteThickness[0.25], 
     LineBox[{738, 739}]}, 
    {Hue[
      NCache[
       Rational[739, 14307], 0.05165303697490739]], AbsoluteThickness[0.25], 
     LineBox[{739, 740}]}, 
    {Hue[
      NCache[
       Rational[740, 14307], 0.051722932830083175`]], AbsoluteThickness[0.25],
      LineBox[{740, 741}]}, 
    {Hue[
      NCache[
       Rational[13, 251], 0.05179282868525897]], AbsoluteThickness[0.25], 
     LineBox[{741, 742}]}, 
    {Hue[
      NCache[
       Rational[742, 14307], 0.05186272454043475]], AbsoluteThickness[0.25], 
     LineBox[{742, 743}]}, 
    {Hue[
      NCache[
       Rational[743, 14307], 0.05193262039561054]], AbsoluteThickness[0.25], 
     LineBox[{743, 744}]}, 
    {Hue[
      NCache[
       Rational[248, 4769], 0.05200251625078633]], AbsoluteThickness[0.25], 
     LineBox[{744, 745}]}, 
    {Hue[
      NCache[
       Rational[745, 14307], 0.05207241210596212]], AbsoluteThickness[0.25], 
     LineBox[{745, 746}]}, 
    {Hue[
      NCache[
       Rational[746, 14307], 0.052142307961137904`]], AbsoluteThickness[0.25],
      LineBox[{746, 747}]}, 
    {Hue[
      NCache[
       Rational[249, 4769], 0.052212203816313696`]], AbsoluteThickness[0.25], 
     LineBox[{747, 748}]}, 
    {Hue[
      NCache[
       Rational[748, 14307], 0.05228209967148948]], AbsoluteThickness[0.25], 
     LineBox[{748, 749}]}, 
    {Hue[
      NCache[
       Rational[749, 14307], 0.052351995526665265`]], AbsoluteThickness[0.25],
      LineBox[{749, 750}]}, 
    {Hue[
      NCache[
       Rational[250, 4769], 0.05242189138184106]], AbsoluteThickness[0.25], 
     LineBox[{750, 751}]}, 
    {Hue[
      NCache[
       Rational[751, 14307], 0.05249178723701684]], AbsoluteThickness[0.25], 
     LineBox[{751, 752}]}, 
    {Hue[
      NCache[
       Rational[752, 14307], 0.05256168309219263]], AbsoluteThickness[0.25], 
     LineBox[{752, 753}]}, 
    {Hue[
      NCache[
       Rational[1, 19], 0.05263157894736842]], AbsoluteThickness[0.25], 
     LineBox[{753, 754}]}, 
    {Hue[
      NCache[
       Rational[754, 14307], 0.05270147480254421]], AbsoluteThickness[0.25], 
     LineBox[{754, 755}]}, 
    {Hue[
      NCache[
       Rational[755, 14307], 0.052771370657719995`]], AbsoluteThickness[0.25],
      LineBox[{755, 756}]}, 
    {Hue[
      NCache[
       Rational[252, 4769], 0.052841266512895786`]], AbsoluteThickness[0.25], 
     LineBox[{756, 757}]}, 
    {Hue[
      NCache[
       Rational[757, 14307], 0.05291116236807157]], AbsoluteThickness[0.25], 
     LineBox[{757, 758}]}, 
    {Hue[
      NCache[
       Rational[758, 14307], 0.05298105822324736]], AbsoluteThickness[0.25], 
     LineBox[{758, 759}]}, 
    {Hue[
      NCache[
       Rational[253, 4769], 0.05305095407842315]], AbsoluteThickness[0.25], 
     LineBox[{759, 760}]}, 
    {Hue[
      NCache[
       Rational[40, 753], 0.05312084993359894]], AbsoluteThickness[0.25], 
     LineBox[{760, 761}]}, 
    {Hue[
      NCache[
       Rational[761, 14307], 0.053190745788774724`]], AbsoluteThickness[0.25],
      LineBox[{761, 762}]}, 
    {Hue[
      NCache[
       Rational[254, 4769], 0.053260641643950515`]], AbsoluteThickness[0.25], 
     LineBox[{762, 763}]}, 
    {Hue[
      NCache[
       Rational[763, 14307], 0.0533305374991263]], AbsoluteThickness[0.25], 
     LineBox[{763, 764}]}, 
    {Hue[
      NCache[
       Rational[764, 14307], 0.05340043335430209]], AbsoluteThickness[0.25], 
     LineBox[{764, 765}]}, 
    {Hue[
      NCache[
       Rational[255, 4769], 0.053470329209477876`]], AbsoluteThickness[0.25], 
     LineBox[{765, 766}]}, 
    {Hue[
      NCache[
       Rational[766, 14307], 0.05354022506465367]], AbsoluteThickness[0.25], 
     LineBox[{766, 767}]}, 
    {Hue[
      NCache[
       Rational[767, 14307], 0.05361012091982945]], AbsoluteThickness[0.25], 
     LineBox[{767, 768}]}, 
    {Hue[
      NCache[
       Rational[256, 4769], 0.053680016775005245`]], AbsoluteThickness[0.25], 
     LineBox[{768, 769}]}, 
    {Hue[
      NCache[
       Rational[769, 14307], 0.05374991263018103]], AbsoluteThickness[0.25], 
     LineBox[{769, 770}]}, 
    {Hue[
      NCache[
       Rational[770, 14307], 0.05381980848535682]], AbsoluteThickness[0.25], 
     LineBox[{770, 771}]}, 
    {Hue[
      NCache[
       Rational[257, 4769], 0.053889704340532606`]], AbsoluteThickness[0.25], 
     LineBox[{771, 772}]}, 
    {Hue[
      NCache[
       Rational[772, 14307], 0.0539596001957084]], AbsoluteThickness[0.25], 
     LineBox[{772, 773}]}, 
    {Hue[
      NCache[
       Rational[773, 14307], 0.05402949605088418]], AbsoluteThickness[0.25], 
     LineBox[{773, 774}]}, 
    {Hue[
      NCache[
       Rational[258, 4769], 0.054099391906059974`]], AbsoluteThickness[0.25], 
     LineBox[{774, 775}]}, 
    {Hue[
      NCache[
       Rational[775, 14307], 0.05416928776123576]], AbsoluteThickness[0.25], 
     LineBox[{775, 776}]}, 
    {Hue[
      NCache[
       Rational[776, 14307], 0.05423918361641155]], AbsoluteThickness[0.25], 
     LineBox[{776, 777}]}, 
    {Hue[
      NCache[
       Rational[259, 4769], 0.054309079471587335`]], AbsoluteThickness[0.25], 
     LineBox[{777, 778}]}, 
    {Hue[
      NCache[
       Rational[778, 14307], 0.05437897532676312]], AbsoluteThickness[0.25], 
     LineBox[{778, 779}]}, 
    {Hue[
      NCache[
       Rational[41, 753], 0.05444887118193891]], AbsoluteThickness[0.25], 
     LineBox[{779, 780}]}, 
    {Hue[
      NCache[
       Rational[260, 4769], 0.054518767037114696`]], AbsoluteThickness[0.25], 
     LineBox[{780, 781}]}, 
    {Hue[
      NCache[
       Rational[781, 14307], 0.05458866289229049]], AbsoluteThickness[0.25], 
     LineBox[{781, 782}]}, 
    {Hue[
      NCache[
       Rational[782, 14307], 0.05465855874746627]], AbsoluteThickness[0.25], 
     LineBox[{782, 783}]}, 
    {Hue[
      NCache[
       Rational[261, 4769], 0.054728454602642064`]], AbsoluteThickness[0.25], 
     LineBox[{783, 784}]}, 
    {Hue[
      NCache[
       Rational[784, 14307], 0.05479835045781785]], AbsoluteThickness[0.25], 
     LineBox[{784, 785}]}, 
    {Hue[
      NCache[
       Rational[785, 14307], 0.05486824631299364]], AbsoluteThickness[0.25], 
     LineBox[{785, 786}]}, 
    {Hue[
      NCache[
       Rational[262, 4769], 0.054938142168169425`]], AbsoluteThickness[0.25], 
     LineBox[{786, 787}]}, 
    {Hue[
      NCache[
       Rational[787, 14307], 0.05500803802334522]], AbsoluteThickness[0.25], 
     LineBox[{787, 788}]}, 
    {Hue[
      NCache[
       Rational[788, 14307], 0.055077933878521]], AbsoluteThickness[0.25], 
     LineBox[{788, 789}]}, 
    {Hue[
      NCache[
       Rational[263, 4769], 0.05514782973369679]], AbsoluteThickness[0.25], 
     LineBox[{789, 790}]}, 
    {Hue[
      NCache[
       Rational[790, 14307], 0.05521772558887258]], AbsoluteThickness[0.25], 
     LineBox[{790, 791}]}, 
    {Hue[
      NCache[
       Rational[791, 14307], 0.05528762144404837]], AbsoluteThickness[0.25], 
     LineBox[{791, 792}]}, 
    {Hue[
      NCache[
       Rational[264, 4769], 0.055357517299224154`]], AbsoluteThickness[0.25], 
     LineBox[{792, 793}]}, 
    {Hue[
      NCache[
       Rational[793, 14307], 0.055427413154399946`]], AbsoluteThickness[0.25],
      LineBox[{793, 794}]}, 
    {Hue[
      NCache[
       Rational[794, 14307], 0.05549730900957573]], AbsoluteThickness[0.25], 
     LineBox[{794, 795}]}, 
    {Hue[
      NCache[
       Rational[265, 4769], 0.05556720486475152]], AbsoluteThickness[0.25], 
     LineBox[{795, 796}]}, 
    {Hue[
      NCache[
       Rational[796, 14307], 0.05563710071992731]], AbsoluteThickness[0.25], 
     LineBox[{796, 797}]}, 
    {Hue[
      NCache[
       Rational[797, 14307], 0.0557069965751031]], AbsoluteThickness[0.25], 
     LineBox[{797, 798}]}, 
    {Hue[
      NCache[
       Rational[14, 251], 0.055776892430278883`]], AbsoluteThickness[0.25], 
     LineBox[{798, 799}]}, 
    {Hue[
      NCache[
       Rational[799, 14307], 0.055846788285454675`]], AbsoluteThickness[0.25],
      LineBox[{799, 800}]}, 
    {Hue[
      NCache[
       Rational[800, 14307], 0.05591668414063046]], AbsoluteThickness[0.25], 
     LineBox[{800, 801}]}, 
    {Hue[
      NCache[
       Rational[267, 4769], 0.05598657999580625]], AbsoluteThickness[0.25], 
     LineBox[{801, 802}]}, 
    {Hue[
      NCache[
       Rational[802, 14307], 0.056056475850982036`]], AbsoluteThickness[0.25],
      LineBox[{802, 803}]}, 
    {Hue[
      NCache[
       Rational[803, 14307], 0.05612637170615783]], AbsoluteThickness[0.25], 
     LineBox[{803, 804}]}, 
    {Hue[
      NCache[
       Rational[268, 4769], 0.05619626756133361]], AbsoluteThickness[0.25], 
     LineBox[{804, 805}]}, 
    {Hue[
      NCache[
       Rational[805, 14307], 0.056266163416509404`]], AbsoluteThickness[0.25],
      LineBox[{805, 806}]}, 
    {Hue[
      NCache[
       Rational[806, 14307], 0.05633605927168519]], AbsoluteThickness[0.25], 
     LineBox[{806, 807}]}, 
    {Hue[
      NCache[
       Rational[269, 4769], 0.056405955126860974`]], AbsoluteThickness[0.25], 
     LineBox[{807, 808}]}, 
    {Hue[
      NCache[
       Rational[808, 14307], 0.056475850982036765`]], AbsoluteThickness[0.25],
      LineBox[{808, 809}]}, 
    {Hue[
      NCache[
       Rational[809, 14307], 0.05654574683721255]], AbsoluteThickness[0.25], 
     LineBox[{809, 810}]}, 
    {Hue[
      NCache[
       Rational[270, 4769], 0.05661564269238834]], AbsoluteThickness[0.25], 
     LineBox[{810, 811}]}, 
    {Hue[
      NCache[
       Rational[811, 14307], 0.05668553854756413]], AbsoluteThickness[0.25], 
     LineBox[{811, 812}]}, 
    {Hue[
      NCache[
       Rational[812, 14307], 0.05675543440273992]], AbsoluteThickness[0.25], 
     LineBox[{812, 813}]}, 
    {Hue[
      NCache[
       Rational[271, 4769], 0.0568253302579157]], AbsoluteThickness[0.25], 
     LineBox[{813, 814}]}, 
    {Hue[
      NCache[
       Rational[814, 14307], 0.056895226113091495`]], AbsoluteThickness[0.25],
      LineBox[{814, 815}]}, 
    {Hue[
      NCache[
       Rational[815, 14307], 0.05696512196826728]], AbsoluteThickness[0.25], 
     LineBox[{815, 816}]}, 
    {Hue[
      NCache[
       Rational[272, 4769], 0.05703501782344307]], AbsoluteThickness[0.25], 
     LineBox[{816, 817}]}, 
    {Hue[
      NCache[
       Rational[43, 753], 0.057104913678618856`]], AbsoluteThickness[0.25], 
     LineBox[{817, 818}]}, 
    {Hue[
      NCache[
       Rational[818, 14307], 0.05717480953379465]], AbsoluteThickness[0.25], 
     LineBox[{818, 819}]}, 
    {Hue[
      NCache[
       Rational[273, 4769], 0.05724470538897043]], AbsoluteThickness[0.25], 
     LineBox[{819, 820}]}, 
    {Hue[
      NCache[
       Rational[820, 14307], 0.057314601244146224`]], AbsoluteThickness[0.25],
      LineBox[{820, 821}]}, 
    {Hue[
      NCache[
       Rational[821, 14307], 0.05738449709932201]], AbsoluteThickness[0.25], 
     LineBox[{821, 822}]}, 
    {Hue[
      NCache[
       Rational[274, 4769], 0.0574543929544978]], AbsoluteThickness[0.25], 
     LineBox[{822, 823}]}, 
    {Hue[
      NCache[
       Rational[823, 14307], 0.057524288809673585`]], AbsoluteThickness[0.25],
      LineBox[{823, 824}]}, 
    {Hue[
      NCache[
       Rational[824, 14307], 0.05759418466484938]], AbsoluteThickness[0.25], 
     LineBox[{824, 825}]}, 
    {Hue[
      NCache[
       Rational[275, 4769], 0.05766408052002516]], AbsoluteThickness[0.25], 
     LineBox[{825, 826}]}, 
    {Hue[
      NCache[
       Rational[826, 14307], 0.05773397637520095]], AbsoluteThickness[0.25], 
     LineBox[{826, 827}]}, 
    {Hue[
      NCache[
       Rational[827, 14307], 0.05780387223037674]], AbsoluteThickness[0.25], 
     LineBox[{827, 828}]}, 
    {Hue[
      NCache[
       Rational[276, 4769], 0.05787376808555253]], AbsoluteThickness[0.25], 
     LineBox[{828, 829}]}, 
    {Hue[
      NCache[
       Rational[829, 14307], 0.057943663940728314`]], AbsoluteThickness[0.25],
      LineBox[{829, 830}]}, 
    {Hue[
      NCache[
       Rational[830, 14307], 0.058013559795904106`]], AbsoluteThickness[0.25],
      LineBox[{830, 831}]}, 
    {Hue[
      NCache[
       Rational[277, 4769], 0.05808345565107989]], AbsoluteThickness[0.25], 
     LineBox[{831, 832}]}, 
    {Hue[
      NCache[
       Rational[832, 14307], 0.05815335150625568]], AbsoluteThickness[0.25], 
     LineBox[{832, 833}]}, 
    {Hue[
      NCache[
       Rational[833, 14307], 0.05822324736143147]], AbsoluteThickness[0.25], 
     LineBox[{833, 834}]}, 
    {Hue[
      NCache[
       Rational[278, 4769], 0.05829314321660726]], AbsoluteThickness[0.25], 
     LineBox[{834, 835}]}, 
    {Hue[
      NCache[
       Rational[835, 14307], 0.05836303907178304]], AbsoluteThickness[0.25], 
     LineBox[{835, 836}]}, 
    {Hue[
      NCache[
       Rational[44, 753], 0.05843293492695883]], AbsoluteThickness[0.25], 
     LineBox[{836, 837}]}, 
    {Hue[
      NCache[
       Rational[279, 4769], 0.05850283078213462]], AbsoluteThickness[0.25], 
     LineBox[{837, 838}]}, 
    {Hue[
      NCache[
       Rational[838, 14307], 0.058572726637310404`]], AbsoluteThickness[0.25],
      LineBox[{838, 839}]}, 
    {Hue[
      NCache[
       Rational[839, 14307], 0.058642622492486196`]], AbsoluteThickness[0.25],
      LineBox[{839, 840}]}, 
    {Hue[
      NCache[
       Rational[280, 4769], 0.05871251834766198]], AbsoluteThickness[0.25], 
     LineBox[{840, 841}]}, 
    {Hue[
      NCache[
       Rational[841, 14307], 0.05878241420283777]], AbsoluteThickness[0.25], 
     LineBox[{841, 842}]}, 
    {Hue[
      NCache[
       Rational[842, 14307], 0.05885231005801356]], AbsoluteThickness[0.25], 
     LineBox[{842, 843}]}, 
    {Hue[
      NCache[
       Rational[281, 4769], 0.05892220591318935]], AbsoluteThickness[0.25], 
     LineBox[{843, 844}]}, 
    {Hue[
      NCache[
       Rational[844, 14307], 0.058992101768365134`]], AbsoluteThickness[0.25],
      LineBox[{844, 845}]}, 
    {Hue[
      NCache[
       Rational[845, 14307], 0.059061997623540925`]], AbsoluteThickness[0.25],
      LineBox[{845, 846}]}, 
    {Hue[
      NCache[
       Rational[282, 4769], 0.05913189347871671]], AbsoluteThickness[0.25], 
     LineBox[{846, 847}]}, 
    {Hue[
      NCache[
       Rational[847, 14307], 0.0592017893338925]], AbsoluteThickness[0.25], 
     LineBox[{847, 848}]}, 
    {Hue[
      NCache[
       Rational[848, 14307], 0.059271685189068286`]], AbsoluteThickness[0.25],
      LineBox[{848, 849}]}, 
    {Hue[
      NCache[
       Rational[283, 4769], 0.05934158104424408]], AbsoluteThickness[0.25], 
     LineBox[{849, 850}]}, 
    {Hue[
      NCache[
       Rational[850, 14307], 0.05941147689941986]], AbsoluteThickness[0.25], 
     LineBox[{850, 851}]}, 
    {Hue[
      NCache[
       Rational[851, 14307], 0.059481372754595654`]], AbsoluteThickness[0.25],
      LineBox[{851, 852}]}, 
    {Hue[
      NCache[
       Rational[284, 4769], 0.05955126860977144]], AbsoluteThickness[0.25], 
     LineBox[{852, 853}]}, 
    {Hue[
      NCache[
       Rational[853, 14307], 0.05962116446494723]], AbsoluteThickness[0.25], 
     LineBox[{853, 854}]}, 
    {Hue[
      NCache[
       Rational[854, 14307], 0.059691060320123016`]], AbsoluteThickness[0.25],
      LineBox[{854, 855}]}, 
    {Hue[
      NCache[
       Rational[15, 251], 0.05976095617529881]], AbsoluteThickness[0.25], 
     LineBox[{855, 856}]}, 
    {Hue[
      NCache[
       Rational[856, 14307], 0.05983085203047459]], AbsoluteThickness[0.25], 
     LineBox[{856, 857}]}, 
    {Hue[
      NCache[
       Rational[857, 14307], 0.059900747885650384`]], AbsoluteThickness[0.25],
      LineBox[{857, 858}]}, 
    {Hue[
      NCache[
       Rational[286, 4769], 0.05997064374082617]], AbsoluteThickness[0.25], 
     LineBox[{858, 859}]}, 
    {Hue[
      NCache[
       Rational[859, 14307], 0.06004053959600196]], AbsoluteThickness[0.25], 
     LineBox[{859, 860}]}, 
    {Hue[
      NCache[
       Rational[860, 14307], 0.060110435451177745`]], AbsoluteThickness[0.25],
      LineBox[{860, 861}]}, 
    {Hue[
      NCache[
       Rational[287, 4769], 0.060180331306353536`]], AbsoluteThickness[0.25], 
     LineBox[{861, 862}]}, 
    {Hue[
      NCache[
       Rational[862, 14307], 0.06025022716152932]], AbsoluteThickness[0.25], 
     LineBox[{862, 863}]}, 
    {Hue[
      NCache[
       Rational[863, 14307], 0.06032012301670511]], AbsoluteThickness[0.25], 
     LineBox[{863, 864}]}, 
    {Hue[
      NCache[
       Rational[288, 4769], 0.0603900188718809]], AbsoluteThickness[0.25], 
     LineBox[{864, 865}]}, 
    {Hue[
      NCache[
       Rational[865, 14307], 0.06045991472705668]], AbsoluteThickness[0.25], 
     LineBox[{865, 866}]}, 
    {Hue[
      NCache[
       Rational[866, 14307], 0.060529810582232474`]], AbsoluteThickness[0.25],
      LineBox[{866, 867}]}, 
    {Hue[
      NCache[
       Rational[289, 4769], 0.06059970643740826]], AbsoluteThickness[0.25], 
     LineBox[{867, 868}]}, 
    {Hue[
      NCache[
       Rational[868, 14307], 0.06066960229258405]], AbsoluteThickness[0.25], 
     LineBox[{868, 869}]}, 
    {Hue[
      NCache[
       Rational[869, 14307], 0.060739498147759835`]], AbsoluteThickness[0.25],
      LineBox[{869, 870}]}, 
    {Hue[
      NCache[
       Rational[290, 4769], 0.06080939400293563]], AbsoluteThickness[0.25], 
     LineBox[{870, 871}]}, 
    {Hue[
      NCache[
       Rational[871, 14307], 0.06087928985811141]], AbsoluteThickness[0.25], 
     LineBox[{871, 872}]}, 
    {Hue[
      NCache[
       Rational[872, 14307], 0.0609491857132872]], AbsoluteThickness[0.25], 
     LineBox[{872, 873}]}, 
    {Hue[
      NCache[
       Rational[291, 4769], 0.06101908156846299]], AbsoluteThickness[0.25], 
     LineBox[{873, 874}]}, 
    {Hue[
      NCache[
       Rational[46, 753], 0.06108897742363878]], AbsoluteThickness[0.25], 
     LineBox[{874, 875}]}, 
    {Hue[
      NCache[
       Rational[875, 14307], 0.061158873278814564`]], AbsoluteThickness[0.25],
      LineBox[{875, 876}]}, 
    {Hue[
      NCache[
       Rational[292, 4769], 0.061228769133990356`]], AbsoluteThickness[0.25], 
     LineBox[{876, 877}]}, 
    {Hue[
      NCache[
       Rational[877, 14307], 0.06129866498916614]], AbsoluteThickness[0.25], 
     LineBox[{877, 878}]}, 
    {Hue[
      NCache[
       Rational[878, 14307], 0.06136856084434193]], AbsoluteThickness[0.25], 
     LineBox[{878, 879}]}, 
    {Hue[
      NCache[
       Rational[293, 4769], 0.06143845669951772]], AbsoluteThickness[0.25], 
     LineBox[{879, 880}]}, 
    {Hue[
      NCache[
       Rational[880, 14307], 0.06150835255469351]], AbsoluteThickness[0.25], 
     LineBox[{880, 881}]}, 
    {Hue[
      NCache[
       Rational[881, 14307], 0.06157824840986929]], AbsoluteThickness[0.25], 
     LineBox[{881, 882}]}, 
    {Hue[
      NCache[
       Rational[294, 4769], 0.061648144265045085`]], AbsoluteThickness[0.25], 
     LineBox[{882, 883}]}, 
    {Hue[
      NCache[
       Rational[883, 14307], 0.06171804012022087]], AbsoluteThickness[0.25], 
     LineBox[{883, 884}]}, 
    {Hue[
      NCache[
       Rational[884, 14307], 0.06178793597539666]], AbsoluteThickness[0.25], 
     LineBox[{884, 885}]}, 
    {Hue[
      NCache[
       Rational[295, 4769], 0.061857831830572446`]], AbsoluteThickness[0.25], 
     LineBox[{885, 886}]}, 
    {Hue[
      NCache[
       Rational[886, 14307], 0.06192772768574824]], AbsoluteThickness[0.25], 
     LineBox[{886, 887}]}, 
    {Hue[
      NCache[
       Rational[887, 14307], 0.06199762354092402]], AbsoluteThickness[0.25], 
     LineBox[{887, 888}]}, 
    {Hue[
      NCache[
       Rational[296, 4769], 0.062067519396099814`]], AbsoluteThickness[0.25], 
     LineBox[{888, 889}]}, 
    {Hue[
      NCache[
       Rational[889, 14307], 0.0621374152512756]], AbsoluteThickness[0.25], 
     LineBox[{889, 890}]}, 
    {Hue[
      NCache[
       Rational[890, 14307], 0.06220731110645139]], AbsoluteThickness[0.25], 
     LineBox[{890, 891}]}, 
    {Hue[
      NCache[
       Rational[297, 4769], 0.062277206961627175`]], AbsoluteThickness[0.25], 
     LineBox[{891, 892}]}, 
    {Hue[
      NCache[
       Rational[892, 14307], 0.06234710281680297]], AbsoluteThickness[0.25], 
     LineBox[{892, 893}]}, 
    {Hue[
      NCache[
       Rational[47, 753], 0.06241699867197875]], AbsoluteThickness[0.25], 
     LineBox[{893, 894}]}, 
    {Hue[
      NCache[
       Rational[298, 4769], 0.062486894527154536`]], AbsoluteThickness[0.25], 
     LineBox[{894, 895}]}, 
    {Hue[
      NCache[
       Rational[895, 14307], 0.06255679038233032]], AbsoluteThickness[0.25], 
     LineBox[{895, 896}]}, 
    {Hue[
      NCache[
       Rational[896, 14307], 0.06262668623750611]], AbsoluteThickness[0.25], 
     LineBox[{896, 897}]}, 
    {Hue[
      NCache[
       Rational[299, 4769], 0.0626965820926819]], AbsoluteThickness[0.25], 
     LineBox[{897, 898}]}, 
    {Hue[
      NCache[
       Rational[898, 14307], 0.0627664779478577]], AbsoluteThickness[0.25], 
     LineBox[{898, 899}]}, 
    {Hue[
      NCache[
       Rational[899, 14307], 0.06283637380303347]], AbsoluteThickness[0.25], 
     LineBox[{899, 900}]}, 
    {Hue[
      NCache[
       Rational[300, 4769], 0.06290626965820927]], AbsoluteThickness[0.25], 
     LineBox[{900, 901}]}, 
    {Hue[
      NCache[
       Rational[901, 14307], 0.06297616551338506]], AbsoluteThickness[0.25], 
     LineBox[{901, 902}]}, 
    {Hue[
      NCache[
       Rational[902, 14307], 0.06304606136856085]], AbsoluteThickness[0.25], 
     LineBox[{902, 903}]}, 
    {Hue[
      NCache[
       Rational[301, 4769], 0.06311595722373663]], AbsoluteThickness[0.25], 
     LineBox[{903, 904}]}, 
    {Hue[
      NCache[
       Rational[904, 14307], 0.06318585307891242]], AbsoluteThickness[0.25], 
     LineBox[{904, 905}]}, 
    {Hue[
      NCache[
       Rational[905, 14307], 0.06325574893408821]], AbsoluteThickness[0.25], 
     LineBox[{905, 906}]}, 
    {Hue[
      NCache[
       Rational[302, 4769], 0.063325644789264]], AbsoluteThickness[0.25], 
     LineBox[{906, 907}]}, 
    {Hue[
      NCache[
       Rational[907, 14307], 0.06339554064443978]], AbsoluteThickness[0.25], 
     LineBox[{907, 908}]}, 
    {Hue[
      NCache[
       Rational[908, 14307], 0.06346543649961557]], AbsoluteThickness[0.25], 
     LineBox[{908, 909}]}, 
    {Hue[
      NCache[
       Rational[303, 4769], 0.06353533235479136]], AbsoluteThickness[0.25], 
     LineBox[{909, 910}]}, 
    {Hue[
      NCache[
       Rational[910, 14307], 0.06360522820996715]], AbsoluteThickness[0.25], 
     LineBox[{910, 911}]}, 
    {Hue[
      NCache[
       Rational[911, 14307], 0.06367512406514293]], AbsoluteThickness[0.25], 
     LineBox[{911, 912}]}, 
    {Hue[
      NCache[
       Rational[16, 251], 0.06374501992031872]], AbsoluteThickness[0.25], 
     LineBox[{912, 913}]}, 
    {Hue[
      NCache[
       Rational[913, 14307], 0.06381491577549452]], AbsoluteThickness[0.25], 
     LineBox[{913, 914}]}, 
    {Hue[
      NCache[
       Rational[914, 14307], 0.06388481163067031]], AbsoluteThickness[0.25], 
     LineBox[{914, 915}]}, 
    {Hue[
      NCache[
       Rational[305, 4769], 0.06395470748584609]], AbsoluteThickness[0.25], 
     LineBox[{915, 916}]}, 
    {Hue[
      NCache[
       Rational[916, 14307], 0.06402460334102188]], AbsoluteThickness[0.25], 
     LineBox[{916, 917}]}, 
    {Hue[
      NCache[
       Rational[917, 14307], 0.06409449919619767]], AbsoluteThickness[0.25], 
     LineBox[{917, 918}]}, 
    {Hue[
      NCache[
       Rational[306, 4769], 0.06416439505137346]], AbsoluteThickness[0.25], 
     LineBox[{918, 919}]}, 
    {Hue[
      NCache[
       Rational[919, 14307], 0.06423429090654924]], AbsoluteThickness[0.25], 
     LineBox[{919, 920}]}, 
    {Hue[
      NCache[
       Rational[920, 14307], 0.06430418676172503]], AbsoluteThickness[0.25], 
     LineBox[{920, 921}]}, 
    {Hue[
      NCache[
       Rational[307, 4769], 0.06437408261690082]], AbsoluteThickness[0.25], 
     LineBox[{921, 922}]}, 
    {Hue[
      NCache[
       Rational[922, 14307], 0.0644439784720766]], AbsoluteThickness[0.25], 
     LineBox[{922, 923}]}, 
    {Hue[
      NCache[
       Rational[923, 14307], 0.06451387432725239]], AbsoluteThickness[0.25], 
     LineBox[{923, 924}]}, 
    {Hue[
      NCache[
       Rational[308, 4769], 0.06458377018242818]], AbsoluteThickness[0.25], 
     LineBox[{924, 925}]}, 
    {Hue[
      NCache[
       Rational[925, 14307], 0.06465366603760397]], AbsoluteThickness[0.25], 
     LineBox[{925, 926}]}, 
    {Hue[
      NCache[
       Rational[926, 14307], 0.06472356189277975]], AbsoluteThickness[0.25], 
     LineBox[{926, 927}]}, 
    {Hue[
      NCache[
       Rational[309, 4769], 0.06479345774795554]], AbsoluteThickness[0.25], 
     LineBox[{927, 928}]}, 
    {Hue[
      NCache[
       Rational[928, 14307], 0.06486335360313134]], AbsoluteThickness[0.25], 
     LineBox[{928, 929}]}, 
    {Hue[
      NCache[
       Rational[929, 14307], 0.06493324945830713]], AbsoluteThickness[0.25], 
     LineBox[{929, 930}]}, 
    {Hue[
      NCache[
       Rational[310, 4769], 0.0650031453134829]], AbsoluteThickness[0.25], 
     LineBox[{930, 931}]}, 
    {Hue[
      NCache[
       Rational[49, 753], 0.0650730411686587]], AbsoluteThickness[0.25], 
     LineBox[{931, 932}]}, 
    {Hue[
      NCache[
       Rational[932, 14307], 0.06514293702383449]], AbsoluteThickness[0.25], 
     LineBox[{932, 933}]}, 
    {Hue[
      NCache[
       Rational[311, 4769], 0.06521283287901028]], AbsoluteThickness[0.25], 
     LineBox[{933, 934}]}, 
    {Hue[
      NCache[
       Rational[934, 14307], 0.06528272873418606]], AbsoluteThickness[0.25], 
     LineBox[{934, 935}]}, 
    {Hue[
      NCache[
       Rational[935, 14307], 0.06535262458936185]], AbsoluteThickness[0.25], 
     LineBox[{935, 936}]}, 
    {Hue[
      NCache[
       Rational[312, 4769], 0.06542252044453764]], AbsoluteThickness[0.25], 
     LineBox[{936, 937}]}, 
    {Hue[
      NCache[
       Rational[937, 14307], 0.06549241629971343]], AbsoluteThickness[0.25], 
     LineBox[{937, 938}]}, 
    {Hue[
      NCache[
       Rational[938, 14307], 0.06556231215488921]], AbsoluteThickness[0.25], 
     LineBox[{938, 939}]}, 
    {Hue[
      NCache[
       Rational[313, 4769], 0.065632208010065]], AbsoluteThickness[0.25], 
     LineBox[{939, 940}]}, 
    {Hue[
      NCache[
       Rational[940, 14307], 0.0657021038652408]], AbsoluteThickness[0.25], 
     LineBox[{940, 941}]}, 
    {Hue[
      NCache[
       Rational[941, 14307], 0.06577199972041659]], AbsoluteThickness[0.25], 
     LineBox[{941, 942}]}, 
    {Hue[
      NCache[
       Rational[314, 4769], 0.06584189557559236]], AbsoluteThickness[0.25], 
     LineBox[{942, 943}]}, 
    {Hue[
      NCache[
       Rational[943, 14307], 0.06591179143076815]], AbsoluteThickness[0.25], 
     LineBox[{943, 944}]}, 
    {Hue[
      NCache[
       Rational[944, 14307], 0.06598168728594395]], AbsoluteThickness[0.25], 
     LineBox[{944, 945}]}, 
    {Hue[
      NCache[
       Rational[315, 4769], 0.06605158314111974]], AbsoluteThickness[0.25], 
     LineBox[{945, 946}]}, 
    {Hue[
      NCache[
       Rational[946, 14307], 0.06612147899629552]], AbsoluteThickness[0.25], 
     LineBox[{946, 947}]}, 
    {Hue[
      NCache[
       Rational[947, 14307], 0.06619137485147131]], AbsoluteThickness[0.25], 
     LineBox[{947, 948}]}, 
    {Hue[
      NCache[
       Rational[316, 4769], 0.0662612707066471]], AbsoluteThickness[0.25], 
     LineBox[{948, 949}]}, 
    {Hue[
      NCache[
       Rational[949, 14307], 0.06633116656182289]], AbsoluteThickness[0.25], 
     LineBox[{949, 950}]}, 
    {Hue[
      NCache[
       Rational[50, 753], 0.06640106241699867]], AbsoluteThickness[0.25], 
     LineBox[{950, 951}]}, 
    {Hue[
      NCache[
       Rational[317, 4769], 0.06647095827217446]], AbsoluteThickness[0.25], 
     LineBox[{951, 952}]}, 
    {Hue[
      NCache[
       Rational[952, 14307], 0.06654085412735025]], AbsoluteThickness[0.25], 
     LineBox[{952, 953}]}, 
    {Hue[
      NCache[
       Rational[953, 14307], 0.06661074998252603]], AbsoluteThickness[0.25], 
     LineBox[{953, 954}]}, 
    {Hue[
      NCache[
       Rational[318, 4769], 0.06668064583770182]], AbsoluteThickness[0.25], 
     LineBox[{954, 955}]}, 
    {Hue[
      NCache[
       Rational[955, 14307], 0.06675054169287761]], AbsoluteThickness[0.25], 
     LineBox[{955, 956}]}, 
    {Hue[
      NCache[
       Rational[956, 14307], 0.0668204375480534]], AbsoluteThickness[0.25], 
     LineBox[{956, 957}]}, 
    {Hue[
      NCache[
       Rational[319, 4769], 0.06689033340322918]], AbsoluteThickness[0.25], 
     LineBox[{957, 958}]}, 
    {Hue[
      NCache[
       Rational[958, 14307], 0.06696022925840497]], AbsoluteThickness[0.25], 
     LineBox[{958, 959}]}, 
    {Hue[
      NCache[
       Rational[959, 14307], 0.06703012511358077]], AbsoluteThickness[0.25], 
     LineBox[{959, 960}]}, 
    {Hue[
      NCache[
       Rational[320, 4769], 0.06710002096875656]], AbsoluteThickness[0.25], 
     LineBox[{960, 961}]}, 
    {Hue[
      NCache[
       Rational[961, 14307], 0.06716991682393234]], AbsoluteThickness[0.25], 
     LineBox[{961, 962}]}, 
    {Hue[
      NCache[
       Rational[962, 14307], 0.06723981267910813]], AbsoluteThickness[0.25], 
     LineBox[{962, 963}]}, 
    {Hue[
      NCache[
       Rational[321, 4769], 0.06730970853428392]], AbsoluteThickness[0.25], 
     LineBox[{963, 964}]}, 
    {Hue[
      NCache[
       Rational[964, 14307], 0.06737960438945971]], AbsoluteThickness[0.25], 
     LineBox[{964, 965}]}, 
    {Hue[
      NCache[
       Rational[965, 14307], 0.06744950024463549]], AbsoluteThickness[0.25], 
     LineBox[{965, 966}]}, 
    {Hue[
      NCache[
       Rational[322, 4769], 0.06751939609981128]], AbsoluteThickness[0.25], 
     LineBox[{966, 967}]}, 
    {Hue[
      NCache[
       Rational[967, 14307], 0.06758929195498707]], AbsoluteThickness[0.25], 
     LineBox[{967, 968}]}, 
    {Hue[
      NCache[
       Rational[968, 14307], 0.06765918781016286]], AbsoluteThickness[0.25], 
     LineBox[{968, 969}]}, 
    {Hue[
      NCache[
       Rational[17, 251], 0.06772908366533864]], AbsoluteThickness[0.25], 
     LineBox[{969, 970}]}, 
    {Hue[
      NCache[
       Rational[970, 14307], 0.06779897952051443]], AbsoluteThickness[0.25], 
     LineBox[{970, 971}]}, 
    {Hue[
      NCache[
       Rational[971, 14307], 0.06786887537569022]], AbsoluteThickness[0.25], 
     LineBox[{971, 972}]}, 
    {Hue[
      NCache[
       Rational[324, 4769], 0.06793877123086602]], AbsoluteThickness[0.25], 
     LineBox[{972, 973}]}, 
    {Hue[
      NCache[
       Rational[973, 14307], 0.0680086670860418]], AbsoluteThickness[0.25], 
     LineBox[{973, 974}]}, 
    {Hue[
      NCache[
       Rational[974, 14307], 0.06807856294121759]], AbsoluteThickness[0.25], 
     LineBox[{974, 975}]}, 
    {Hue[
      NCache[
       Rational[325, 4769], 0.06814845879639338]], AbsoluteThickness[0.25], 
     LineBox[{975, 976}]}, 
    {Hue[
      NCache[
       Rational[976, 14307], 0.06821835465156917]], AbsoluteThickness[0.25], 
     LineBox[{976, 977}]}, 
    {Hue[
      NCache[
       Rational[977, 14307], 0.06828825050674495]], AbsoluteThickness[0.25], 
     LineBox[{977, 978}]}, 
    {Hue[
      NCache[
       Rational[326, 4769], 0.06835814636192074]], AbsoluteThickness[0.25], 
     LineBox[{978, 979}]}, 
    {Hue[
      NCache[
       Rational[979, 14307], 0.06842804221709653]], AbsoluteThickness[0.25], 
     LineBox[{979, 980}]}, 
    {Hue[
      NCache[
       Rational[980, 14307], 0.06849793807227231]], AbsoluteThickness[0.25], 
     LineBox[{980, 981}]}, 
    {Hue[
      NCache[
       Rational[327, 4769], 0.0685678339274481]], AbsoluteThickness[0.25], 
     LineBox[{981, 982}]}, 
    {Hue[
      NCache[
       Rational[982, 14307], 0.06863772978262389]], AbsoluteThickness[0.25], 
     LineBox[{982, 983}]}, 
    {Hue[
      NCache[
       Rational[983, 14307], 0.06870762563779968]], AbsoluteThickness[0.25], 
     LineBox[{983, 984}]}, 
    {Hue[
      NCache[
       Rational[328, 4769], 0.06877752149297546]], AbsoluteThickness[0.25], 
     LineBox[{984, 985}]}, 
    {Hue[
      NCache[
       Rational[985, 14307], 0.06884741734815125]], AbsoluteThickness[0.25], 
     LineBox[{985, 986}]}, 
    {Hue[
      NCache[
       Rational[986, 14307], 0.06891731320332704]], AbsoluteThickness[0.25], 
     LineBox[{986, 987}]}, 
    {Hue[
      NCache[
       Rational[329, 4769], 0.06898720905850284]], AbsoluteThickness[0.25], 
     LineBox[{987, 988}]}, 
    {Hue[
      NCache[
       Rational[52, 753], 0.06905710491367861]], AbsoluteThickness[0.25], 
     LineBox[{988, 989}]}, 
    {Hue[
      NCache[
       Rational[989, 14307], 0.0691270007688544]], AbsoluteThickness[0.25], 
     LineBox[{989, 990}]}, 
    {Hue[
      NCache[
       Rational[330, 4769], 0.0691968966240302]], AbsoluteThickness[0.25], 
     LineBox[{990, 991}]}, 
    {Hue[
      NCache[
       Rational[991, 14307], 0.06926679247920599]], AbsoluteThickness[0.25], 
     LineBox[{991, 992}]}, 
    {Hue[
      NCache[
       Rational[992, 14307], 0.06933668833438177]], AbsoluteThickness[0.25], 
     LineBox[{992, 993}]}, 
    {Hue[
      NCache[
       Rational[331, 4769], 0.06940658418955756]], AbsoluteThickness[0.25], 
     LineBox[{993, 994}]}, 
    {Hue[
      NCache[
       Rational[994, 14307], 0.06947648004473335]], AbsoluteThickness[0.25], 
     LineBox[{994, 995}]}, 
    {Hue[
      NCache[
       Rational[995, 14307], 0.06954637589990914]], AbsoluteThickness[0.25], 
     LineBox[{995, 996}]}, 
    {Hue[
      NCache[
       Rational[332, 4769], 0.06961627175508492]], AbsoluteThickness[0.25], 
     LineBox[{996, 997}]}, 
    {Hue[
      NCache[
       Rational[997, 14307], 0.06968616761026071]], AbsoluteThickness[0.25], 
     LineBox[{997, 998}]}, 
    {Hue[
      NCache[
       Rational[998, 14307], 0.0697560634654365]], AbsoluteThickness[0.25], 
     LineBox[{998, 999}]}, 
    {Hue[
      NCache[
       Rational[333, 4769], 0.0698259593206123]], AbsoluteThickness[0.25], 
     LineBox[{999, 1000}]}, 
    {Hue[
      NCache[
       Rational[1000, 14307], 0.06989585517578807]], AbsoluteThickness[0.25], 
     LineBox[{1000, 1001}]}, 
    {Hue[
      NCache[
       Rational[1001, 14307], 0.06996575103096386]], AbsoluteThickness[0.25], 
     LineBox[{1001, 1002}]}, 
    {Hue[
      NCache[
       Rational[334, 4769], 0.07003564688613965]], AbsoluteThickness[0.25], 
     LineBox[{1002, 1003}]}, 
    {Hue[
      NCache[
       Rational[1003, 14307], 0.07010554274131545]], AbsoluteThickness[0.25], 
     LineBox[{1003, 1004}]}, 
    {Hue[
      NCache[
       Rational[4, 57], 0.07017543859649122]], AbsoluteThickness[0.25], 
     LineBox[{1004, 1005}]}, 
    {Hue[
      NCache[
       Rational[335, 4769], 0.07024533445166702]], AbsoluteThickness[0.25], 
     LineBox[{1005, 1006}]}, 
    {Hue[
      NCache[
       Rational[1006, 14307], 0.07031523030684281]], AbsoluteThickness[0.25], 
     LineBox[{1006, 1007}]}, 
    {Hue[
      NCache[
       Rational[53, 753], 0.0703851261620186]], AbsoluteThickness[0.25], 
     LineBox[{1007, 1008}]}, 
    {Hue[
      NCache[
       Rational[336, 4769], 0.07045502201719438]], AbsoluteThickness[0.25], 
     LineBox[{1008, 1009}]}, 
    {Hue[
      NCache[
       Rational[1009, 14307], 0.07052491787237017]], AbsoluteThickness[0.25], 
     LineBox[{1009, 1010}]}, 
    {Hue[
      NCache[
       Rational[1010, 14307], 0.07059481372754596]], AbsoluteThickness[0.25], 
     LineBox[{1010, 1011}]}, 
    {Hue[
      NCache[
       Rational[337, 4769], 0.07066470958272174]], AbsoluteThickness[0.25], 
     LineBox[{1011, 1012}]}, 
    {Hue[
      NCache[
       Rational[1012, 14307], 0.07073460543789753]], AbsoluteThickness[0.25], 
     LineBox[{1012, 1013}]}, 
    {Hue[
      NCache[
       Rational[1013, 14307], 0.07080450129307332]], AbsoluteThickness[0.25], 
     LineBox[{1013, 1014}]}, 
    {Hue[
      NCache[
       Rational[338, 4769], 0.07087439714824911]], AbsoluteThickness[0.25], 
     LineBox[{1014, 1015}]}, 
    {Hue[
      NCache[
       Rational[1015, 14307], 0.07094429300342489]], AbsoluteThickness[0.25], 
     LineBox[{1015, 1016}]}, 
    {Hue[
      NCache[
       Rational[1016, 14307], 0.07101418885860068]], AbsoluteThickness[0.25], 
     LineBox[{1016, 1017}]}, 
    {Hue[
      NCache[
       Rational[339, 4769], 0.07108408471377647]], AbsoluteThickness[0.25], 
     LineBox[{1017, 1018}]}, 
    {Hue[
      NCache[
       Rational[1018, 14307], 0.07115398056895227]], AbsoluteThickness[0.25], 
     LineBox[{1018, 1019}]}, 
    {Hue[
      NCache[
       Rational[1019, 14307], 0.07122387642412804]], AbsoluteThickness[0.25], 
     LineBox[{1019, 1020}]}, 
    {Hue[
      NCache[
       Rational[340, 4769], 0.07129377227930384]], AbsoluteThickness[0.25], 
     LineBox[{1020, 1021}]}, 
    {Hue[
      NCache[
       Rational[1021, 14307], 0.07136366813447963]], AbsoluteThickness[0.25], 
     LineBox[{1021, 1022}]}, 
    {Hue[
      NCache[
       Rational[1022, 14307], 0.07143356398965542]], AbsoluteThickness[0.25], 
     LineBox[{1022, 1023}]}, 
    {Hue[
      NCache[
       Rational[341, 4769], 0.0715034598448312]], AbsoluteThickness[0.25], 
     LineBox[{1023, 1024}]}, 
    {Hue[
      NCache[
       Rational[1024, 14307], 0.07157335570000699]], AbsoluteThickness[0.25], 
     LineBox[{1024, 1025}]}, 
    {Hue[
      NCache[
       Rational[1025, 14307], 0.07164325155518278]], AbsoluteThickness[0.25], 
     LineBox[{1025, 1026}]}, 
    {Hue[
      NCache[
       Rational[18, 251], 0.07171314741035857]], AbsoluteThickness[0.25], 
     LineBox[{1026, 1027}]}, 
    {Hue[
      NCache[
       Rational[1027, 14307], 0.07178304326553435]], AbsoluteThickness[0.25], 
     LineBox[{1027, 1028}]}, 
    {Hue[
      NCache[
       Rational[1028, 14307], 0.07185293912071014]], AbsoluteThickness[0.25], 
     LineBox[{1028, 1029}]}, 
    {Hue[
      NCache[
       Rational[343, 4769], 0.07192283497588593]], AbsoluteThickness[0.25], 
     LineBox[{1029, 1030}]}, 
    {Hue[
      NCache[
       Rational[1030, 14307], 0.07199273083106172]], AbsoluteThickness[0.25], 
     LineBox[{1030, 1031}]}, 
    {Hue[
      NCache[
       Rational[1031, 14307], 0.0720626266862375]], AbsoluteThickness[0.25], 
     LineBox[{1031, 1032}]}, 
    {Hue[
      NCache[
       Rational[344, 4769], 0.0721325225414133]], AbsoluteThickness[0.25], 
     LineBox[{1032, 1033}]}, 
    {Hue[
      NCache[
       Rational[1033, 14307], 0.07220241839658909]], AbsoluteThickness[0.25], 
     LineBox[{1033, 1034}]}, 
    {Hue[
      NCache[
       Rational[1034, 14307], 0.07227231425176488]], AbsoluteThickness[0.25], 
     LineBox[{1034, 1035}]}, 
    {Hue[
      NCache[
       Rational[345, 4769], 0.07234221010694065]], AbsoluteThickness[0.25], 
     LineBox[{1035, 1036}]}, 
    {Hue[
      NCache[
       Rational[1036, 14307], 0.07241210596211645]], AbsoluteThickness[0.25], 
     LineBox[{1036, 1037}]}, 
    {Hue[
      NCache[
       Rational[1037, 14307], 0.07248200181729224]], AbsoluteThickness[0.25], 
     LineBox[{1037, 1038}]}, 
    {Hue[
      NCache[
       Rational[346, 4769], 0.07255189767246802]], AbsoluteThickness[0.25], 
     LineBox[{1038, 1039}]}, 
    {Hue[
      NCache[
       Rational[1039, 14307], 0.07262179352764381]], AbsoluteThickness[0.25], 
     LineBox[{1039, 1040}]}, 
    {Hue[
      NCache[
       Rational[1040, 14307], 0.0726916893828196]], AbsoluteThickness[0.25], 
     LineBox[{1040, 1041}]}, 
    {Hue[
      NCache[
       Rational[347, 4769], 0.07276158523799539]], AbsoluteThickness[0.25], 
     LineBox[{1041, 1042}]}, 
    {Hue[
      NCache[
       Rational[1042, 14307], 0.07283148109317117]], AbsoluteThickness[0.25], 
     LineBox[{1042, 1043}]}, 
    {Hue[
      NCache[
       Rational[1043, 14307], 0.07290137694834696]], AbsoluteThickness[0.25], 
     LineBox[{1043, 1044}]}, 
    {Hue[
      NCache[
       Rational[348, 4769], 0.07297127280352275]], AbsoluteThickness[0.25], 
     LineBox[{1044, 1045}]}, 
    {Hue[
      NCache[
       Rational[55, 753], 0.07304116865869854]], AbsoluteThickness[0.25], 
     LineBox[{1045, 1046}]}, 
    {Hue[
      NCache[
       Rational[1046, 14307], 0.07311106451387432]], AbsoluteThickness[0.25], 
     LineBox[{1046, 1047}]}, 
    {Hue[
      NCache[
       Rational[349, 4769], 0.07318096036905011]], AbsoluteThickness[0.25], 
     LineBox[{1047, 1048}]}, 
    {Hue[
      NCache[
       Rational[1048, 14307], 0.0732508562242259]], AbsoluteThickness[0.25], 
     LineBox[{1048, 1049}]}, 
    {Hue[
      NCache[
       Rational[1049, 14307], 0.0733207520794017]], AbsoluteThickness[0.25], 
     LineBox[{1049, 1050}]}, 
    {Hue[
      NCache[
       Rational[350, 4769], 0.07339064793457747]], AbsoluteThickness[0.25], 
     LineBox[{1050, 1051}]}, 
    {Hue[
      NCache[
       Rational[1051, 14307], 0.07346054378975327]], AbsoluteThickness[0.25], 
     LineBox[{1051, 1052}]}, 
    {Hue[
      NCache[
       Rational[1052, 14307], 0.07353043964492906]], AbsoluteThickness[0.25], 
     LineBox[{1052, 1053}]}, 
    {Hue[
      NCache[
       Rational[351, 4769], 0.07360033550010485]], AbsoluteThickness[0.25], 
     LineBox[{1053, 1054}]}, 
    {Hue[
      NCache[
       Rational[1054, 14307], 0.07367023135528063]], AbsoluteThickness[0.25], 
     LineBox[{1054, 1055}]}, 
    {Hue[
      NCache[
       Rational[1055, 14307], 0.07374012721045642]], AbsoluteThickness[0.25], 
     LineBox[{1055, 1056}]}, 
    {Hue[
      NCache[
       Rational[352, 4769], 0.07381002306563221]], AbsoluteThickness[0.25], 
     LineBox[{1056, 1057}]}, 
    {Hue[
      NCache[
       Rational[1057, 14307], 0.073879918920808]], AbsoluteThickness[0.25], 
     LineBox[{1057, 1058}]}, 
    {Hue[
      NCache[
       Rational[1058, 14307], 0.07394981477598378]], AbsoluteThickness[0.25], 
     LineBox[{1058, 1059}]}, 
    {Hue[
      NCache[
       Rational[353, 4769], 0.07401971063115957]], AbsoluteThickness[0.25], 
     LineBox[{1059, 1060}]}, 
    {Hue[
      NCache[
       Rational[1060, 14307], 0.07408960648633536]], AbsoluteThickness[0.25], 
     LineBox[{1060, 1061}]}, 
    {Hue[
      NCache[
       Rational[1061, 14307], 0.07415950234151115]], AbsoluteThickness[0.25], 
     LineBox[{1061, 1062}]}, 
    {Hue[
      NCache[
       Rational[354, 4769], 0.07422939819668693]], AbsoluteThickness[0.25], 
     LineBox[{1062, 1063}]}, 
    {Hue[
      NCache[
       Rational[1063, 14307], 0.07429929405186272]], AbsoluteThickness[0.25], 
     LineBox[{1063, 1064}]}, 
    {Hue[
      NCache[
       Rational[56, 753], 0.07436918990703852]], AbsoluteThickness[0.25], 
     LineBox[{1064, 1065}]}, 
    {Hue[
      NCache[
       Rational[355, 4769], 0.07443908576221431]], AbsoluteThickness[0.25], 
     LineBox[{1065, 1066}]}, 
    {Hue[
      NCache[
       Rational[1066, 14307], 0.07450898161739009]], AbsoluteThickness[0.25], 
     LineBox[{1066, 1067}]}, 
    {Hue[
      NCache[
       Rational[1067, 14307], 0.07457887747256588]], AbsoluteThickness[0.25], 
     LineBox[{1067, 1068}]}, 
    {Hue[
      NCache[
       Rational[356, 4769], 0.07464877332774167]], AbsoluteThickness[0.25], 
     LineBox[{1068, 1069}]}, 
    {Hue[
      NCache[
       Rational[1069, 14307], 0.07471866918291745]], AbsoluteThickness[0.25], 
     LineBox[{1069, 1070}]}, 
    {Hue[
      NCache[
       Rational[1070, 14307], 0.07478856503809324]], AbsoluteThickness[0.25], 
     LineBox[{1070, 1071}]}, 
    {Hue[
      NCache[
       Rational[357, 4769], 0.07485846089326903]], AbsoluteThickness[0.25], 
     LineBox[{1071, 1072}]}, 
    {Hue[
      NCache[
       Rational[1072, 14307], 0.07492835674844482]], AbsoluteThickness[0.25], 
     LineBox[{1072, 1073}]}, 
    {Hue[
      NCache[
       Rational[1073, 14307], 0.0749982526036206]], AbsoluteThickness[0.25], 
     LineBox[{1073, 1074}]}, 
    {Hue[
      NCache[
       Rational[358, 4769], 0.07506814845879639]], AbsoluteThickness[0.25], 
     LineBox[{1074, 1075}]}, 
    {Hue[
      NCache[
       Rational[1075, 14307], 0.07513804431397218]], AbsoluteThickness[0.25], 
     LineBox[{1075, 1076}]}, 
    {Hue[
      NCache[
       Rational[1076, 14307], 0.07520794016914797]], AbsoluteThickness[0.25], 
     LineBox[{1076, 1077}]}, 
    {Hue[
      NCache[
       Rational[359, 4769], 0.07527783602432375]], AbsoluteThickness[0.25], 
     LineBox[{1077, 1078}]}, 
    {Hue[
      NCache[
       Rational[1078, 14307], 0.07534773187949954]], AbsoluteThickness[0.25], 
     LineBox[{1078, 1079}]}, 
    {Hue[
      NCache[
       Rational[1079, 14307], 0.07541762773467534]], AbsoluteThickness[0.25], 
     LineBox[{1079, 1080}]}, 
    {Hue[
      NCache[
       Rational[360, 4769], 0.07548752358985113]], AbsoluteThickness[0.25], 
     LineBox[{1080, 1081}]}, 
    {Hue[
      NCache[
       Rational[1081, 14307], 0.0755574194450269]], AbsoluteThickness[0.25], 
     LineBox[{1081, 1082}]}, 
    {Hue[
      NCache[
       Rational[1082, 14307], 0.0756273153002027]], AbsoluteThickness[0.25], 
     LineBox[{1082, 1083}]}, 
    {Hue[
      NCache[
       Rational[19, 251], 0.07569721115537849]], AbsoluteThickness[0.25], 
     LineBox[{1083, 1084}]}, 
    {Hue[
      NCache[
       Rational[1084, 14307], 0.07576710701055428]], AbsoluteThickness[0.25], 
     LineBox[{1084, 1085}]}, 
    {Hue[
      NCache[
       Rational[1085, 14307], 0.07583700286573006]], AbsoluteThickness[0.25], 
     LineBox[{1085, 1086}]}, 
    {Hue[
      NCache[
       Rational[362, 4769], 0.07590689872090585]], AbsoluteThickness[0.25], 
     LineBox[{1086, 1087}]}, 
    {Hue[
      NCache[
       Rational[1087, 14307], 0.07597679457608164]], AbsoluteThickness[0.25], 
     LineBox[{1087, 1088}]}, 
    {Hue[
      NCache[
       Rational[1088, 14307], 0.07604669043125743]], AbsoluteThickness[0.25], 
     LineBox[{1088, 1089}]}, 
    {Hue[
      NCache[
       Rational[363, 4769], 0.07611658628643321]], AbsoluteThickness[0.25], 
     LineBox[{1089, 1090}]}, 
    {Hue[
      NCache[
       Rational[1090, 14307], 0.076186482141609]], AbsoluteThickness[0.25], 
     LineBox[{1090, 1091}]}, 
    {Hue[
      NCache[
       Rational[1091, 14307], 0.0762563779967848]], AbsoluteThickness[0.25], 
     LineBox[{1091, 1092}]}, 
    {Hue[
      NCache[
       Rational[364, 4769], 0.07632627385196059]], AbsoluteThickness[0.25], 
     LineBox[{1092, 1093}]}, 
    {Hue[
      NCache[
       Rational[1093, 14307], 0.07639616970713636]], AbsoluteThickness[0.25], 
     LineBox[{1093, 1094}]}, 
    {Hue[
      NCache[
       Rational[1094, 14307], 0.07646606556231215]], AbsoluteThickness[0.25], 
     LineBox[{1094, 1095}]}, 
    {Hue[
      NCache[
       Rational[365, 4769], 0.07653596141748795]], AbsoluteThickness[0.25], 
     LineBox[{1095, 1096}]}, 
    {Hue[
      NCache[
       Rational[1096, 14307], 0.07660585727266372]], AbsoluteThickness[0.25], 
     LineBox[{1096, 1097}]}, 
    {Hue[
      NCache[
       Rational[1097, 14307], 0.07667575312783952]], AbsoluteThickness[0.25], 
     LineBox[{1097, 1098}]}, 
    {Hue[
      NCache[
       Rational[366, 4769], 0.07674564898301531]], AbsoluteThickness[0.25], 
     LineBox[{1098, 1099}]}, 
    {Hue[
      NCache[
       Rational[1099, 14307], 0.0768155448381911]], AbsoluteThickness[0.25], 
     LineBox[{1099, 1100}]}, 
    {Hue[
      NCache[
       Rational[1100, 14307], 0.07688544069336688]], AbsoluteThickness[0.25], 
     LineBox[{1100, 1101}]}, 
    {Hue[
      NCache[
       Rational[367, 4769], 0.07695533654854267]], AbsoluteThickness[0.25], 
     LineBox[{1101, 1102}]}, 
    {Hue[
      NCache[
       Rational[58, 753], 0.07702523240371846]], AbsoluteThickness[0.25], 
     LineBox[{1102, 1103}]}, 
    {Hue[
      NCache[
       Rational[1103, 14307], 0.07709512825889425]], AbsoluteThickness[0.25], 
     LineBox[{1103, 1104}]}, 
    {Hue[
      NCache[
       Rational[368, 4769], 0.07716502411407003]], AbsoluteThickness[0.25], 
     LineBox[{1104, 1105}]}, 
    {Hue[
      NCache[
       Rational[1105, 14307], 0.07723491996924582]], AbsoluteThickness[0.25], 
     LineBox[{1105, 1106}]}, 
    {Hue[
      NCache[
       Rational[1106, 14307], 0.07730481582442161]], AbsoluteThickness[0.25], 
     LineBox[{1106, 1107}]}, 
    {Hue[
      NCache[
       Rational[369, 4769], 0.0773747116795974]], AbsoluteThickness[0.25], 
     LineBox[{1107, 1108}]}, 
    {Hue[
      NCache[
       Rational[1108, 14307], 0.07744460753477318]], AbsoluteThickness[0.25], 
     LineBox[{1108, 1109}]}, 
    {Hue[
      NCache[
       Rational[1109, 14307], 0.07751450338994897]], AbsoluteThickness[0.25], 
     LineBox[{1109, 1110}]}, 
    {Hue[
      NCache[
       Rational[370, 4769], 0.07758439924512477]], AbsoluteThickness[0.25], 
     LineBox[{1110, 1111}]}, 
    {Hue[
      NCache[
       Rational[1111, 14307], 0.07765429510030056]], AbsoluteThickness[0.25], 
     LineBox[{1111, 1112}]}, 
    {Hue[
      NCache[
       Rational[1112, 14307], 0.07772419095547634]], AbsoluteThickness[0.25], 
     LineBox[{1112, 1113}]}, 
    {Hue[
      NCache[
       Rational[371, 4769], 0.07779408681065213]], AbsoluteThickness[0.25], 
     LineBox[{1113, 1114}]}, 
    {Hue[
      NCache[
       Rational[1114, 14307], 0.07786398266582792]], AbsoluteThickness[0.25], 
     LineBox[{1114, 1115}]}, 
    {Hue[
      NCache[
       Rational[1115, 14307], 0.07793387852100371]], AbsoluteThickness[0.25], 
     LineBox[{1115, 1116}]}, 
    {Hue[
      NCache[
       Rational[372, 4769], 0.07800377437617949]], AbsoluteThickness[0.25], 
     LineBox[{1116, 1117}]}, 
    {Hue[
      NCache[
       Rational[1117, 14307], 0.07807367023135528]], AbsoluteThickness[0.25], 
     LineBox[{1117, 1118}]}, 
    {Hue[
      NCache[
       Rational[1118, 14307], 0.07814356608653107]], AbsoluteThickness[0.25], 
     LineBox[{1118, 1119}]}, 
    {Hue[
      NCache[
       Rational[373, 4769], 0.07821346194170686]], AbsoluteThickness[0.25], 
     LineBox[{1119, 1120}]}, 
    {Hue[
      NCache[
       Rational[1120, 14307], 0.07828335779688264]], AbsoluteThickness[0.25], 
     LineBox[{1120, 1121}]}, 
    {Hue[
      NCache[
       Rational[59, 753], 0.07835325365205843]], AbsoluteThickness[0.25], 
     LineBox[{1121, 1122}]}, 
    {Hue[
      NCache[
       Rational[374, 4769], 0.07842314950723422]], AbsoluteThickness[0.25], 
     LineBox[{1122, 1123}]}, 
    {Hue[
      NCache[
       Rational[1123, 14307], 0.07849304536241]], AbsoluteThickness[0.25], 
     LineBox[{1123, 1124}]}, 
    {Hue[
      NCache[
       Rational[1124, 14307], 0.0785629412175858]], AbsoluteThickness[0.25], 
     LineBox[{1124, 1125}]}, 
    {Hue[
      NCache[
       Rational[375, 4769], 0.07863283707276159]], AbsoluteThickness[0.25], 
     LineBox[{1125, 1126}]}, 
    {Hue[
      NCache[
       Rational[1126, 14307], 0.07870273292793738]], AbsoluteThickness[0.25], 
     LineBox[{1126, 1127}]}, 
    {Hue[
      NCache[
       Rational[1127, 14307], 0.07877262878311315]], AbsoluteThickness[0.25], 
     LineBox[{1127, 1128}]}, 
    {Hue[
      NCache[
       Rational[376, 4769], 0.07884252463828895]], AbsoluteThickness[0.25], 
     LineBox[{1128, 1129}]}, 
    {Hue[
      NCache[
       Rational[1129, 14307], 0.07891242049346474]], AbsoluteThickness[0.25], 
     LineBox[{1129, 1130}]}, 
    {Hue[
      NCache[
       Rational[1130, 14307], 0.07898231634864053]], AbsoluteThickness[0.25], 
     LineBox[{1130, 1131}]}, 
    {Hue[
      NCache[
       Rational[377, 4769], 0.07905221220381631]], AbsoluteThickness[0.25], 
     LineBox[{1131, 1132}]}, 
    {Hue[
      NCache[
       Rational[1132, 14307], 0.0791221080589921]], AbsoluteThickness[0.25], 
     LineBox[{1132, 1133}]}, 
    {Hue[
      NCache[
       Rational[1133, 14307], 0.07919200391416789]], AbsoluteThickness[0.25], 
     LineBox[{1133, 1134}]}, 
    {Hue[
      NCache[
       Rational[378, 4769], 0.07926189976934368]], AbsoluteThickness[0.25], 
     LineBox[{1134, 1135}]}, 
    {Hue[
      NCache[
       Rational[1135, 14307], 0.07933179562451946]], AbsoluteThickness[0.25], 
     LineBox[{1135, 1136}]}, 
    {Hue[
      NCache[
       Rational[1136, 14307], 0.07940169147969525]], AbsoluteThickness[0.25], 
     LineBox[{1136, 1137}]}, 
    {Hue[
      NCache[
       Rational[379, 4769], 0.07947158733487104]], AbsoluteThickness[0.25], 
     LineBox[{1137, 1138}]}, 
    {Hue[
      NCache[
       Rational[1138, 14307], 0.07954148319004684]], AbsoluteThickness[0.25], 
     LineBox[{1138, 1139}]}, 
    {Hue[
      NCache[
       Rational[1139, 14307], 0.07961137904522261]], AbsoluteThickness[0.25], 
     LineBox[{1139, 1140}]}, 
    {Hue[
      NCache[
       Rational[20, 251], 0.0796812749003984]], AbsoluteThickness[0.25], 
     LineBox[{1140, 1141}]}, 
    {Hue[
      NCache[
       Rational[1141, 14307], 0.0797511707555742]], AbsoluteThickness[0.25], 
     LineBox[{1141, 1142}]}, 
    {Hue[
      NCache[
       Rational[1142, 14307], 0.07982106661074999]], AbsoluteThickness[0.25], 
     LineBox[{1142, 1143}]}, 
    {Hue[
      NCache[
       Rational[381, 4769], 0.07989096246592577]], AbsoluteThickness[0.25], 
     LineBox[{1143, 1144}]}, 
    {Hue[
      NCache[
       Rational[1144, 14307], 0.07996085832110156]], AbsoluteThickness[0.25], 
     LineBox[{1144, 1145}]}, 
    {Hue[
      NCache[
       Rational[1145, 14307], 0.08003075417627735]], AbsoluteThickness[0.25], 
     LineBox[{1145, 1146}]}, 
    {Hue[
      NCache[
       Rational[382, 4769], 0.08010065003145314]], AbsoluteThickness[0.25], 
     LineBox[{1146, 1147}]}, 
    {Hue[
      NCache[
       Rational[1147, 14307], 0.08017054588662892]], AbsoluteThickness[0.25], 
     LineBox[{1147, 1148}]}, 
    {Hue[
      NCache[
       Rational[1148, 14307], 0.08024044174180471]], AbsoluteThickness[0.25], 
     LineBox[{1148, 1149}]}, 
    {Hue[
      NCache[
       Rational[383, 4769], 0.0803103375969805]], AbsoluteThickness[0.25], 
     LineBox[{1149, 1150}]}, 
    {Hue[
      NCache[
       Rational[1150, 14307], 0.0803802334521563]], AbsoluteThickness[0.25], 
     LineBox[{1150, 1151}]}, 
    {Hue[
      NCache[
       Rational[1151, 14307], 0.08045012930733207]], AbsoluteThickness[0.25], 
     LineBox[{1151, 1152}]}, 
    {Hue[
      NCache[
       Rational[384, 4769], 0.08052002516250786]], AbsoluteThickness[0.25], 
     LineBox[{1152, 1153}]}, 
    {Hue[
      NCache[
       Rational[1153, 14307], 0.08058992101768366]], AbsoluteThickness[0.25], 
     LineBox[{1153, 1154}]}, 
    {Hue[
      NCache[
       Rational[1154, 14307], 0.08065981687285943]], AbsoluteThickness[0.25], 
     LineBox[{1154, 1155}]}, 
    {Hue[
      NCache[
       Rational[385, 4769], 0.08072971272803522]], AbsoluteThickness[0.25], 
     LineBox[{1155, 1156}]}, 
    {Hue[
      NCache[
       Rational[1156, 14307], 0.08079960858321102]], AbsoluteThickness[0.25], 
     LineBox[{1156, 1157}]}, 
    {Hue[
      NCache[
       Rational[1157, 14307], 0.08086950443838681]], AbsoluteThickness[0.25], 
     LineBox[{1157, 1158}]}, 
    {Hue[
      NCache[
       Rational[386, 4769], 0.08093940029356259]], AbsoluteThickness[0.25], 
     LineBox[{1158, 1159}]}, 
    {Hue[
      NCache[
       Rational[61, 753], 0.08100929614873838]], AbsoluteThickness[0.25], 
     LineBox[{1159, 1160}]}, 
    {Hue[
      NCache[
       Rational[1160, 14307], 0.08107919200391417]], AbsoluteThickness[0.25], 
     LineBox[{1160, 1161}]}, 
    {Hue[
      NCache[
       Rational[387, 4769], 0.08114908785908996]], AbsoluteThickness[0.25], 
     LineBox[{1161, 1162}]}, 
    {Hue[
      NCache[
       Rational[1162, 14307], 0.08121898371426574]], AbsoluteThickness[0.25], 
     LineBox[{1162, 1163}]}, 
    {Hue[
      NCache[
       Rational[1163, 14307], 0.08128887956944153]], AbsoluteThickness[0.25], 
     LineBox[{1163, 1164}]}, 
    {Hue[
      NCache[
       Rational[388, 4769], 0.08135877542461732]], AbsoluteThickness[0.25], 
     LineBox[{1164, 1165}]}, 
    {Hue[
      NCache[
       Rational[1165, 14307], 0.08142867127979311]], AbsoluteThickness[0.25], 
     LineBox[{1165, 1166}]}, 
    {Hue[
      NCache[
       Rational[1166, 14307], 0.08149856713496889]], AbsoluteThickness[0.25], 
     LineBox[{1166, 1167}]}, 
    {Hue[
      NCache[
       Rational[389, 4769], 0.08156846299014468]], AbsoluteThickness[0.25], 
     LineBox[{1167, 1168}]}, 
    {Hue[
      NCache[
       Rational[1168, 14307], 0.08163835884532047]], AbsoluteThickness[0.25], 
     LineBox[{1168, 1169}]}, 
    {Hue[
      NCache[
       Rational[1169, 14307], 0.08170825470049627]], AbsoluteThickness[0.25], 
     LineBox[{1169, 1170}]}, 
    {Hue[
      NCache[
       Rational[390, 4769], 0.08177815055567204]], AbsoluteThickness[0.25], 
     LineBox[{1170, 1171}]}, 
    {Hue[
      NCache[
       Rational[1171, 14307], 0.08184804641084784]], AbsoluteThickness[0.25], 
     LineBox[{1171, 1172}]}, 
    {Hue[
      NCache[
       Rational[1172, 14307], 0.08191794226602363]], AbsoluteThickness[0.25], 
     LineBox[{1172, 1173}]}, 
    {Hue[
      NCache[
       Rational[391, 4769], 0.08198783812119942]], AbsoluteThickness[0.25], 
     LineBox[{1173, 1174}]}, 
    {Hue[
      NCache[
       Rational[1174, 14307], 0.0820577339763752]], AbsoluteThickness[0.25], 
     LineBox[{1174, 1175}]}, 
    {Hue[
      NCache[
       Rational[1175, 14307], 0.08212762983155099]], AbsoluteThickness[0.25], 
     LineBox[{1175, 1176}]}, 
    {Hue[
      NCache[
       Rational[392, 4769], 0.08219752568672678]], AbsoluteThickness[0.25], 
     LineBox[{1176, 1177}]}, 
    {Hue[
      NCache[
       Rational[1177, 14307], 0.08226742154190257]], AbsoluteThickness[0.25], 
     LineBox[{1177, 1178}]}, 
    {Hue[
      NCache[
       Rational[62, 753], 0.08233731739707835]], AbsoluteThickness[0.25], 
     LineBox[{1178, 1179}]}, 
    {Hue[
      NCache[
       Rational[393, 4769], 0.08240721325225414]], AbsoluteThickness[0.25], 
     LineBox[{1179, 1180}]}, 
    {Hue[
      NCache[
       Rational[1180, 14307], 0.08247710910742993]], AbsoluteThickness[0.25], 
     LineBox[{1180, 1181}]}, 
    {Hue[
      NCache[
       Rational[1181, 14307], 0.08254700496260571]], AbsoluteThickness[0.25], 
     LineBox[{1181, 1182}]}, 
    {Hue[
      NCache[
       Rational[394, 4769], 0.0826169008177815]], AbsoluteThickness[0.25], 
     LineBox[{1182, 1183}]}, 
    {Hue[
      NCache[
       Rational[1183, 14307], 0.0826867966729573]], AbsoluteThickness[0.25], 
     LineBox[{1183, 1184}]}, 
    {Hue[
      NCache[
       Rational[1184, 14307], 0.08275669252813309]], AbsoluteThickness[0.25], 
     LineBox[{1184, 1185}]}, 
    {Hue[
      NCache[
       Rational[395, 4769], 0.08282658838330886]], AbsoluteThickness[0.25], 
     LineBox[{1185, 1186}]}, 
    {Hue[
      NCache[
       Rational[1186, 14307], 0.08289648423848466]], AbsoluteThickness[0.25], 
     LineBox[{1186, 1187}]}, 
    {Hue[
      NCache[
       Rational[1187, 14307], 0.08296638009366045]], AbsoluteThickness[0.25], 
     LineBox[{1187, 1188}]}, 
    {Hue[
      NCache[
       Rational[396, 4769], 0.08303627594883624]], AbsoluteThickness[0.25], 
     LineBox[{1188, 1189}]}, 
    {Hue[
      NCache[
       Rational[1189, 14307], 0.08310617180401202]], AbsoluteThickness[0.25], 
     LineBox[{1189, 1190}]}, 
    {Hue[
      NCache[
       Rational[1190, 14307], 0.08317606765918781]], AbsoluteThickness[0.25], 
     LineBox[{1190, 1191}]}, 
    {Hue[
      NCache[
       Rational[397, 4769], 0.0832459635143636]], AbsoluteThickness[0.25], 
     LineBox[{1191, 1192}]}, 
    {Hue[
      NCache[
       Rational[1192, 14307], 0.08331585936953939]], AbsoluteThickness[0.25], 
     LineBox[{1192, 1193}]}, 
    {Hue[
      NCache[
       Rational[1193, 14307], 0.08338575522471517]], AbsoluteThickness[0.25], 
     LineBox[{1193, 1194}]}, 
    {Hue[
      NCache[
       Rational[398, 4769], 0.08345565107989096]], AbsoluteThickness[0.25], 
     LineBox[{1194, 1195}]}, 
    {Hue[
      NCache[
       Rational[1195, 14307], 0.08352554693506675]], AbsoluteThickness[0.25], 
     LineBox[{1195, 1196}]}, 
    {Hue[
      NCache[
       Rational[1196, 14307], 0.08359544279024254]], AbsoluteThickness[0.25], 
     LineBox[{1196, 1197}]}, 
    {Hue[
      NCache[
       Rational[21, 251], 0.08366533864541832]], AbsoluteThickness[0.25], 
     LineBox[{1197, 1198}]}, 
    {Hue[
      NCache[
       Rational[1198, 14307], 0.08373523450059411]], AbsoluteThickness[0.25], 
     LineBox[{1198, 1199}]}, 
    {Hue[
      NCache[
       Rational[1199, 14307], 0.0838051303557699]], AbsoluteThickness[0.25], 
     LineBox[{1199, 1200}]}, 
    {Hue[
      NCache[
       Rational[400, 4769], 0.0838750262109457]], AbsoluteThickness[0.25], 
     LineBox[{1200, 1201}]}, 
    {Hue[
      NCache[
       Rational[1201, 14307], 0.08394492206612147]], AbsoluteThickness[0.25], 
     LineBox[{1201, 1202}]}, 
    {Hue[
      NCache[
       Rational[1202, 14307], 0.08401481792129727]], AbsoluteThickness[0.25], 
     LineBox[{1202, 1203}]}, 
    {Hue[
      NCache[
       Rational[401, 4769], 0.08408471377647306]], AbsoluteThickness[0.25], 
     LineBox[{1203, 1204}]}, 
    {Hue[
      NCache[
       Rational[1204, 14307], 0.08415460963164885]], AbsoluteThickness[0.25], 
     LineBox[{1204, 1205}]}, 
    {Hue[
      NCache[
       Rational[1205, 14307], 0.08422450548682463]], AbsoluteThickness[0.25], 
     LineBox[{1205, 1206}]}, 
    {Hue[
      NCache[
       Rational[402, 4769], 0.08429440134200042]], AbsoluteThickness[0.25], 
     LineBox[{1206, 1207}]}, 
    {Hue[
      NCache[
       Rational[1207, 14307], 0.08436429719717621]], AbsoluteThickness[0.25], 
     LineBox[{1207, 1208}]}, 
    {Hue[
      NCache[
       Rational[1208, 14307], 0.084434193052352]], AbsoluteThickness[0.25], 
     LineBox[{1208, 1209}]}, 
    {Hue[
      NCache[
       Rational[403, 4769], 0.08450408890752778]], AbsoluteThickness[0.25], 
     LineBox[{1209, 1210}]}, 
    {Hue[
      NCache[
       Rational[1210, 14307], 0.08457398476270357]], AbsoluteThickness[0.25], 
     LineBox[{1210, 1211}]}, 
    {Hue[
      NCache[
       Rational[1211, 14307], 0.08464388061787936]], AbsoluteThickness[0.25], 
     LineBox[{1211, 1212}]}, 
    {Hue[
      NCache[
       Rational[404, 4769], 0.08471377647305514]], AbsoluteThickness[0.25], 
     LineBox[{1212, 1213}]}, 
    {Hue[
      NCache[
       Rational[1213, 14307], 0.08478367232823093]], AbsoluteThickness[0.25], 
     LineBox[{1213, 1214}]}, 
    {Hue[
      NCache[
       Rational[1214, 14307], 0.08485356818340672]], AbsoluteThickness[0.25], 
     LineBox[{1214, 1215}]}, 
    {Hue[
      NCache[
       Rational[405, 4769], 0.08492346403858252]], AbsoluteThickness[0.25], 
     LineBox[{1215, 1216}]}, 
    {Hue[
      NCache[
       Rational[64, 753], 0.0849933598937583]], AbsoluteThickness[0.25], 
     LineBox[{1216, 1217}]}, 
    {Hue[
      NCache[
       Rational[1217, 14307], 0.08506325574893409]], AbsoluteThickness[0.25], 
     LineBox[{1217, 1218}]}, 
    {Hue[
      NCache[
       Rational[406, 4769], 0.08513315160410988]], AbsoluteThickness[0.25], 
     LineBox[{1218, 1219}]}, 
    {Hue[
      NCache[
       Rational[1219, 14307], 0.08520304745928567]], AbsoluteThickness[0.25], 
     LineBox[{1219, 1220}]}, 
    {Hue[
      NCache[
       Rational[1220, 14307], 0.08527294331446145]], AbsoluteThickness[0.25], 
     LineBox[{1220, 1221}]}, 
    {Hue[
      NCache[
       Rational[407, 4769], 0.08534283916963724]], AbsoluteThickness[0.25], 
     LineBox[{1221, 1222}]}, 
    {Hue[
      NCache[
       Rational[1222, 14307], 0.08541273502481303]], AbsoluteThickness[0.25], 
     LineBox[{1222, 1223}]}, 
    {Hue[
      NCache[
       Rational[1223, 14307], 0.08548263087998882]], AbsoluteThickness[0.25], 
     LineBox[{1223, 1224}]}, 
    {Hue[
      NCache[
       Rational[408, 4769], 0.0855525267351646]], AbsoluteThickness[0.25], 
     LineBox[{1224, 1225}]}, 
    {Hue[
      NCache[
       Rational[1225, 14307], 0.08562242259034039]], AbsoluteThickness[0.25], 
     LineBox[{1225, 1226}]}, 
    {Hue[
      NCache[
       Rational[1226, 14307], 0.08569231844551618]], AbsoluteThickness[0.25], 
     LineBox[{1226, 1227}]}, 
    {Hue[
      NCache[
       Rational[409, 4769], 0.08576221430069197]], AbsoluteThickness[0.25], 
     LineBox[{1227, 1228}]}, 
    {Hue[
      NCache[
       Rational[1228, 14307], 0.08583211015586775]], AbsoluteThickness[0.25], 
     LineBox[{1228, 1229}]}, 
    {Hue[
      NCache[
       Rational[1229, 14307], 0.08590200601104354]], AbsoluteThickness[0.25], 
     LineBox[{1229, 1230}]}, 
    {Hue[
      NCache[
       Rational[410, 4769], 0.08597190186621934]], AbsoluteThickness[0.25], 
     LineBox[{1230, 1231}]}, 
    {Hue[
      NCache[
       Rational[1231, 14307], 0.08604179772139513]], AbsoluteThickness[0.25], 
     LineBox[{1231, 1232}]}, 
    {Hue[
      NCache[
       Rational[1232, 14307], 0.0861116935765709]], AbsoluteThickness[0.25], 
     LineBox[{1232, 1233}]}, 
    {Hue[
      NCache[
       Rational[411, 4769], 0.0861815894317467]], AbsoluteThickness[0.25], 
     LineBox[{1233, 1234}]}, 
    {Hue[
      NCache[
       Rational[1234, 14307], 0.08625148528692249]], AbsoluteThickness[0.25], 
     LineBox[{1234, 1235}]}, 
    {Hue[
      NCache[
       Rational[65, 753], 0.08632138114209828]], AbsoluteThickness[0.25], 
     LineBox[{1235, 1236}]}, 
    {Hue[
      NCache[
       Rational[412, 4769], 0.08639127699727406]], AbsoluteThickness[0.25], 
     LineBox[{1236, 1237}]}, 
    {Hue[
      NCache[
       Rational[1237, 14307], 0.08646117285244985]], AbsoluteThickness[0.25], 
     LineBox[{1237, 1238}]}, 
    {Hue[
      NCache[
       Rational[1238, 14307], 0.08653106870762564]], AbsoluteThickness[0.25], 
     LineBox[{1238, 1239}]}, 
    {Hue[
      NCache[
       Rational[413, 4769], 0.08660096456280142]], AbsoluteThickness[0.25], 
     LineBox[{1239, 1240}]}, 
    {Hue[
      NCache[
       Rational[1240, 14307], 0.08667086041797721]], AbsoluteThickness[0.25], 
     LineBox[{1240, 1241}]}, 
    {Hue[
      NCache[
       Rational[1241, 14307], 0.086740756273153]], AbsoluteThickness[0.25], 
     LineBox[{1241, 1242}]}, 
    {Hue[
      NCache[
       Rational[414, 4769], 0.0868106521283288]], AbsoluteThickness[0.25], 
     LineBox[{1242, 1243}]}, 
    {Hue[
      NCache[
       Rational[1243, 14307], 0.08688054798350457]], AbsoluteThickness[0.25], 
     LineBox[{1243, 1244}]}, 
    {Hue[
      NCache[
       Rational[1244, 14307], 0.08695044383868036]], AbsoluteThickness[0.25], 
     LineBox[{1244, 1245}]}, 
    {Hue[
      NCache[
       Rational[415, 4769], 0.08702033969385616]], AbsoluteThickness[0.25], 
     LineBox[{1245, 1246}]}, 
    {Hue[
      NCache[
       Rational[1246, 14307], 0.08709023554903195]], AbsoluteThickness[0.25], 
     LineBox[{1246, 1247}]}, 
    {Hue[
      NCache[
       Rational[1247, 14307], 0.08716013140420772]], AbsoluteThickness[0.25], 
     LineBox[{1247, 1248}]}, 
    {Hue[
      NCache[
       Rational[416, 4769], 0.08723002725938352]], AbsoluteThickness[0.25], 
     LineBox[{1248, 1249}]}, 
    {Hue[
      NCache[
       Rational[1249, 14307], 0.08729992311455931]], AbsoluteThickness[0.25], 
     LineBox[{1249, 1250}]}, 
    {Hue[
      NCache[
       Rational[1250, 14307], 0.0873698189697351]], AbsoluteThickness[0.25], 
     LineBox[{1250, 1251}]}, 
    {Hue[
      NCache[
       Rational[417, 4769], 0.08743971482491088]], AbsoluteThickness[0.25], 
     LineBox[{1251, 1252}]}, 
    {Hue[
      NCache[
       Rational[1252, 14307], 0.08750961068008667]], AbsoluteThickness[0.25], 
     LineBox[{1252, 1253}]}, 
    {Hue[
      NCache[
       Rational[1253, 14307], 0.08757950653526246]], AbsoluteThickness[0.25], 
     LineBox[{1253, 1254}]}, 
    {Hue[
      NCache[
       Rational[22, 251], 0.08764940239043825]], AbsoluteThickness[0.25], 
     LineBox[{1254, 1255}]}, 
    {Hue[
      NCache[
       Rational[5, 57], 0.08771929824561403]], AbsoluteThickness[0.25], 
     LineBox[{1255, 1256}]}, 
    {Hue[
      NCache[
       Rational[1256, 14307], 0.08778919410078982]], AbsoluteThickness[0.25], 
     LineBox[{1256, 1257}]}, 
    {Hue[
      NCache[
       Rational[419, 4769], 0.08785908995596561]], AbsoluteThickness[0.25], 
     LineBox[{1257, 1258}]}, 
    {Hue[
      NCache[
       Rational[1258, 14307], 0.0879289858111414]], AbsoluteThickness[0.25], 
     LineBox[{1258, 1259}]}, 
    {Hue[
      NCache[
       Rational[1259, 14307], 0.08799888166631718]], AbsoluteThickness[0.25], 
     LineBox[{1259, 1260}]}, 
    {Hue[
      NCache[
       Rational[420, 4769], 0.08806877752149297]], AbsoluteThickness[0.25], 
     LineBox[{1260, 1261}]}, 
    {Hue[
      NCache[
       Rational[1261, 14307], 0.08813867337666877]], AbsoluteThickness[0.25], 
     LineBox[{1261, 1262}]}, 
    {Hue[
      NCache[
       Rational[1262, 14307], 0.08820856923184456]], AbsoluteThickness[0.25], 
     LineBox[{1262, 1263}]}, 
    {Hue[
      NCache[
       Rational[421, 4769], 0.08827846508702034]], AbsoluteThickness[0.25], 
     LineBox[{1263, 1264}]}, 
    {Hue[
      NCache[
       Rational[1264, 14307], 0.08834836094219613]], AbsoluteThickness[0.25], 
     LineBox[{1264, 1265}]}, 
    {Hue[
      NCache[
       Rational[1265, 14307], 0.08841825679737192]], AbsoluteThickness[0.25], 
     LineBox[{1265, 1266}]}, 
    {Hue[
      NCache[
       Rational[422, 4769], 0.08848815265254771]], AbsoluteThickness[0.25], 
     LineBox[{1266, 1267}]}, 
    {Hue[
      NCache[
       Rational[1267, 14307], 0.08855804850772349]], AbsoluteThickness[0.25], 
     LineBox[{1267, 1268}]}, 
    {Hue[
      NCache[
       Rational[1268, 14307], 0.08862794436289928]], AbsoluteThickness[0.25], 
     LineBox[{1268, 1269}]}, 
    {Hue[
      NCache[
       Rational[423, 4769], 0.08869784021807507]], AbsoluteThickness[0.25], 
     LineBox[{1269, 1270}]}, 
    {Hue[
      NCache[
       Rational[1270, 14307], 0.08876773607325085]], AbsoluteThickness[0.25], 
     LineBox[{1270, 1271}]}, 
    {Hue[
      NCache[
       Rational[1271, 14307], 0.08883763192842664]], AbsoluteThickness[0.25], 
     LineBox[{1271, 1272}]}, 
    {Hue[
      NCache[
       Rational[424, 4769], 0.08890752778360243]], AbsoluteThickness[0.25], 
     LineBox[{1272, 1273}]}, 
    {Hue[
      NCache[
       Rational[67, 753], 0.08897742363877822]], AbsoluteThickness[0.25], 
     LineBox[{1273, 1274}]}, 
    {Hue[
      NCache[
       Rational[1274, 14307], 0.089047319493954]], AbsoluteThickness[0.25], 
     LineBox[{1274, 1275}]}, 
    {Hue[
      NCache[
       Rational[425, 4769], 0.0891172153491298]], AbsoluteThickness[0.25], 
     LineBox[{1275, 1276}]}, 
    {Hue[
      NCache[
       Rational[1276, 14307], 0.08918711120430559]], AbsoluteThickness[0.25], 
     LineBox[{1276, 1277}]}, 
    {Hue[
      NCache[
       Rational[1277, 14307], 0.08925700705948138]], AbsoluteThickness[0.25], 
     LineBox[{1277, 1278}]}, 
    {Hue[
      NCache[
       Rational[426, 4769], 0.08932690291465716]], AbsoluteThickness[0.25], 
     LineBox[{1278, 1279}]}, 
    {Hue[
      NCache[
       Rational[1279, 14307], 0.08939679876983295]], AbsoluteThickness[0.25], 
     LineBox[{1279, 1280}]}, 
    {Hue[
      NCache[
       Rational[1280, 14307], 0.08946669462500874]], AbsoluteThickness[0.25], 
     LineBox[{1280, 1281}]}, 
    {Hue[
      NCache[
       Rational[427, 4769], 0.08953659048018453]], AbsoluteThickness[0.25], 
     LineBox[{1281, 1282}]}, 
    {Hue[
      NCache[
       Rational[1282, 14307], 0.08960648633536031]], AbsoluteThickness[0.25], 
     LineBox[{1282, 1283}]}, 
    {Hue[
      NCache[
       Rational[1283, 14307], 0.0896763821905361]], AbsoluteThickness[0.25], 
     LineBox[{1283, 1284}]}, 
    {Hue[
      NCache[
       Rational[428, 4769], 0.08974627804571189]], AbsoluteThickness[0.25], 
     LineBox[{1284, 1285}]}, 
    {Hue[
      NCache[
       Rational[1285, 14307], 0.08981617390088768]], AbsoluteThickness[0.25], 
     LineBox[{1285, 1286}]}, 
    {Hue[
      NCache[
       Rational[1286, 14307], 0.08988606975606346]], AbsoluteThickness[0.25], 
     LineBox[{1286, 1287}]}, 
    {Hue[
      NCache[
       Rational[429, 4769], 0.08995596561123925]], AbsoluteThickness[0.25], 
     LineBox[{1287, 1288}]}, 
    {Hue[
      NCache[
       Rational[1288, 14307], 0.09002586146641504]], AbsoluteThickness[0.25], 
     LineBox[{1288, 1289}]}, 
    {Hue[
      NCache[
       Rational[1289, 14307], 0.09009575732159084]], AbsoluteThickness[0.25], 
     LineBox[{1289, 1290}]}, 
    {Hue[
      NCache[
       Rational[430, 4769], 0.09016565317676661]], AbsoluteThickness[0.25], 
     LineBox[{1290, 1291}]}, 
    {Hue[
      NCache[
       Rational[1291, 14307], 0.0902355490319424]], AbsoluteThickness[0.25], 
     LineBox[{1291, 1292}]}, 
    {Hue[
      NCache[
       Rational[68, 753], 0.0903054448871182]], AbsoluteThickness[0.25], 
     LineBox[{1292, 1293}]}, 
    {Hue[
      NCache[
       Rational[431, 4769], 0.09037534074229399]], AbsoluteThickness[0.25], 
     LineBox[{1293, 1294}]}, 
    {Hue[
      NCache[
       Rational[1294, 14307], 0.09044523659746977]], AbsoluteThickness[0.25], 
     LineBox[{1294, 1295}]}, 
    {Hue[
      NCache[
       Rational[1295, 14307], 0.09051513245264556]], AbsoluteThickness[0.25], 
     LineBox[{1295, 1296}]}, 
    {Hue[
      NCache[
       Rational[432, 4769], 0.09058502830782135]], AbsoluteThickness[0.25], 
     LineBox[{1296, 1297}]}, 
    {Hue[
      NCache[
       Rational[1297, 14307], 0.09065492416299713]], AbsoluteThickness[0.25], 
     LineBox[{1297, 1298}]}, 
    {Hue[
      NCache[
       Rational[1298, 14307], 0.09072482001817292]], AbsoluteThickness[0.25], 
     LineBox[{1298, 1299}]}, 
    {Hue[
      NCache[
       Rational[433, 4769], 0.09079471587334871]], AbsoluteThickness[0.25], 
     LineBox[{1299, 1300}]}, 
    {Hue[
      NCache[
       Rational[1300, 14307], 0.0908646117285245]], AbsoluteThickness[0.25], 
     LineBox[{1300, 1301}]}, 
    {Hue[
      NCache[
       Rational[1301, 14307], 0.09093450758370028]], AbsoluteThickness[0.25], 
     LineBox[{1301, 1302}]}, 
    {Hue[
      NCache[
       Rational[434, 4769], 0.09100440343887607]], AbsoluteThickness[0.25], 
     LineBox[{1302, 1303}]}, 
    {Hue[
      NCache[
       Rational[1303, 14307], 0.09107429929405186]], AbsoluteThickness[0.25], 
     LineBox[{1303, 1304}]}, 
    {Hue[
      NCache[
       Rational[1304, 14307], 0.09114419514922766]], AbsoluteThickness[0.25], 
     LineBox[{1304, 1305}]}, 
    {Hue[
      NCache[
       Rational[435, 4769], 0.09121409100440343]], AbsoluteThickness[0.25], 
     LineBox[{1305, 1306}]}, 
    {Hue[
      NCache[
       Rational[1306, 14307], 0.09128398685957922]], AbsoluteThickness[0.25], 
     LineBox[{1306, 1307}]}, 
    {Hue[
      NCache[
       Rational[1307, 14307], 0.09135388271475502]], AbsoluteThickness[0.25], 
     LineBox[{1307, 1308}]}, 
    {Hue[
      NCache[
       Rational[436, 4769], 0.09142377856993081]], AbsoluteThickness[0.25], 
     LineBox[{1308, 1309}]}, 
    {Hue[
      NCache[
       Rational[1309, 14307], 0.09149367442510659]], AbsoluteThickness[0.25], 
     LineBox[{1309, 1310}]}, 
    {Hue[
      NCache[
       Rational[1310, 14307], 0.09156357028028238]], AbsoluteThickness[0.25], 
     LineBox[{1310, 1311}]}, 
    {Hue[
      NCache[
       Rational[23, 251], 0.09163346613545817]], AbsoluteThickness[0.25], 
     LineBox[{1311, 1312}]}, 
    {Hue[
      NCache[
       Rational[1312, 14307], 0.09170336199063396]], AbsoluteThickness[0.25], 
     LineBox[{1312, 1313}]}, 
    {Hue[
      NCache[
       Rational[1313, 14307], 0.09177325784580974]], AbsoluteThickness[0.25], 
     LineBox[{1313, 1314}]}, 
    {Hue[
      NCache[
       Rational[438, 4769], 0.09184315370098553]], AbsoluteThickness[0.25], 
     LineBox[{1314, 1315}]}, 
    {Hue[
      NCache[
       Rational[1315, 14307], 0.09191304955616132]], AbsoluteThickness[0.25], 
     LineBox[{1315, 1316}]}, 
    {Hue[
      NCache[
       Rational[1316, 14307], 0.09198294541133711]], AbsoluteThickness[0.25], 
     LineBox[{1316, 1317}]}, 
    {Hue[
      NCache[
       Rational[439, 4769], 0.09205284126651289]], AbsoluteThickness[0.25], 
     LineBox[{1317, 1318}]}, 
    {Hue[
      NCache[
       Rational[1318, 14307], 0.09212273712168868]], AbsoluteThickness[0.25], 
     LineBox[{1318, 1319}]}, 
    {Hue[
      NCache[
       Rational[1319, 14307], 0.09219263297686447]], AbsoluteThickness[0.25], 
     LineBox[{1319, 1320}]}, 
    {Hue[
      NCache[
       Rational[440, 4769], 0.09226252883204027]], AbsoluteThickness[0.25], 
     LineBox[{1320, 1321}]}, 
    {Hue[
      NCache[
       Rational[1321, 14307], 0.09233242468721604]], AbsoluteThickness[0.25], 
     LineBox[{1321, 1322}]}, 
    {Hue[
      NCache[
       Rational[1322, 14307], 0.09240232054239184]], AbsoluteThickness[0.25], 
     LineBox[{1322, 1323}]}, 
    {Hue[
      NCache[
       Rational[441, 4769], 0.09247221639756763]], AbsoluteThickness[0.25], 
     LineBox[{1323, 1324}]}, 
    {Hue[
      NCache[
       Rational[1324, 14307], 0.09254211225274342]], AbsoluteThickness[0.25], 
     LineBox[{1324, 1325}]}, 
    {Hue[
      NCache[
       Rational[1325, 14307], 0.0926120081079192]], AbsoluteThickness[0.25], 
     LineBox[{1325, 1326}]}, 
    {Hue[
      NCache[
       Rational[442, 4769], 0.09268190396309499]], AbsoluteThickness[0.25], 
     LineBox[{1326, 1327}]}, 
    {Hue[
      NCache[
       Rational[1327, 14307], 0.09275179981827078]], AbsoluteThickness[0.25], 
     LineBox[{1327, 1328}]}, 
    {Hue[
      NCache[
       Rational[1328, 14307], 0.09282169567344656]], AbsoluteThickness[0.25], 
     LineBox[{1328, 1329}]}, 
    {Hue[
      NCache[
       Rational[443, 4769], 0.09289159152862235]], AbsoluteThickness[0.25], 
     LineBox[{1329, 1330}]}, 
    {Hue[
      NCache[
       Rational[70, 753], 0.09296148738379814]], AbsoluteThickness[0.25], 
     LineBox[{1330, 1331}]}, 
    {Hue[
      NCache[
       Rational[1331, 14307], 0.09303138323897393]], AbsoluteThickness[0.25], 
     LineBox[{1331, 1332}]}, 
    {Hue[
      NCache[
       Rational[444, 4769], 0.09310127909414971]], AbsoluteThickness[0.25], 
     LineBox[{1332, 1333}]}, 
    {Hue[
      NCache[
       Rational[1333, 14307], 0.0931711749493255]], AbsoluteThickness[0.25], 
     LineBox[{1333, 1334}]}, 
    {Hue[
      NCache[
       Rational[1334, 14307], 0.0932410708045013]], AbsoluteThickness[0.25], 
     LineBox[{1334, 1335}]}, 
    {Hue[
      NCache[
       Rational[445, 4769], 0.09331096665967709]], AbsoluteThickness[0.25], 
     LineBox[{1335, 1336}]}, 
    {Hue[
      NCache[
       Rational[1336, 14307], 0.09338086251485286]], AbsoluteThickness[0.25], 
     LineBox[{1336, 1337}]}, 
    {Hue[
      NCache[
       Rational[1337, 14307], 0.09345075837002866]], AbsoluteThickness[0.25], 
     LineBox[{1337, 1338}]}, 
    {Hue[
      NCache[
       Rational[446, 4769], 0.09352065422520445]], AbsoluteThickness[0.25], 
     LineBox[{1338, 1339}]}, 
    {Hue[
      NCache[
       Rational[1339, 14307], 0.09359055008038024]], AbsoluteThickness[0.25], 
     LineBox[{1339, 1340}]}, 
    {Hue[
      NCache[
       Rational[1340, 14307], 0.09366044593555602]], AbsoluteThickness[0.25], 
     LineBox[{1340, 1341}]}, 
    {Hue[
      NCache[
       Rational[447, 4769], 0.09373034179073181]], AbsoluteThickness[0.25], 
     LineBox[{1341, 1342}]}, 
    {Hue[
      NCache[
       Rational[1342, 14307], 0.0938002376459076]], AbsoluteThickness[0.25], 
     LineBox[{1342, 1343}]}, 
    {Hue[
      NCache[
       Rational[1343, 14307], 0.09387013350108339]], AbsoluteThickness[0.25], 
     LineBox[{1343, 1344}]}, 
    {Hue[
      NCache[
       Rational[448, 4769], 0.09394002935625917]], AbsoluteThickness[0.25], 
     LineBox[{1344, 1345}]}, 
    {Hue[
      NCache[
       Rational[1345, 14307], 0.09400992521143496]], AbsoluteThickness[0.25], 
     LineBox[{1345, 1346}]}, 
    {Hue[
      NCache[
       Rational[1346, 14307], 0.09407982106661075]], AbsoluteThickness[0.25], 
     LineBox[{1346, 1347}]}, 
    {Hue[
      NCache[
       Rational[449, 4769], 0.09414971692178654]], AbsoluteThickness[0.25], 
     LineBox[{1347, 1348}]}, 
    {Hue[
      NCache[
       Rational[1348, 14307], 0.09421961277696232]], AbsoluteThickness[0.25], 
     LineBox[{1348, 1349}]}, 
    {Hue[
      NCache[
       Rational[71, 753], 0.09428950863213811]], AbsoluteThickness[0.25], 
     LineBox[{1349, 1350}]}, 
    {Hue[
      NCache[
       Rational[450, 4769], 0.0943594044873139]], AbsoluteThickness[0.25], 
     LineBox[{1350, 1351}]}, 
    {Hue[
      NCache[
       Rational[1351, 14307], 0.0944293003424897]], AbsoluteThickness[0.25], 
     LineBox[{1351, 1352}]}, 
    {Hue[
      NCache[
       Rational[1352, 14307], 0.09449919619766547]], AbsoluteThickness[0.25], 
     LineBox[{1352, 1353}]}, 
    {Hue[
      NCache[
       Rational[451, 4769], 0.09456909205284127]], AbsoluteThickness[0.25], 
     LineBox[{1353, 1354}]}, 
    {Hue[
      NCache[
       Rational[1354, 14307], 0.09463898790801706]], AbsoluteThickness[0.25], 
     LineBox[{1354, 1355}]}, 
    {Hue[
      NCache[
       Rational[1355, 14307], 0.09470888376319284]], AbsoluteThickness[0.25], 
     LineBox[{1355, 1356}]}, 
    {Hue[
      NCache[
       Rational[452, 4769], 0.09477877961836863]], AbsoluteThickness[0.25], 
     LineBox[{1356, 1357}]}, 
    {Hue[
      NCache[
       Rational[1357, 14307], 0.09484867547354442]], AbsoluteThickness[0.25], 
     LineBox[{1357, 1358}]}, 
    {Hue[
      NCache[
       Rational[1358, 14307], 0.09491857132872021]], AbsoluteThickness[0.25], 
     LineBox[{1358, 1359}]}, 
    {Hue[
      NCache[
       Rational[453, 4769], 0.09498846718389599]], AbsoluteThickness[0.25], 
     LineBox[{1359, 1360}]}, 
    {Hue[
      NCache[
       Rational[1360, 14307], 0.09505836303907178]], AbsoluteThickness[0.25], 
     LineBox[{1360, 1361}]}, 
    {Hue[
      NCache[
       Rational[1361, 14307], 0.09512825889424757]], AbsoluteThickness[0.25], 
     LineBox[{1361, 1362}]}, 
    {Hue[
      NCache[
       Rational[454, 4769], 0.09519815474942336]], AbsoluteThickness[0.25], 
     LineBox[{1362, 1363}]}, 
    {Hue[
      NCache[
       Rational[1363, 14307], 0.09526805060459914]], AbsoluteThickness[0.25], 
     LineBox[{1363, 1364}]}, 
    {Hue[
      NCache[
       Rational[1364, 14307], 0.09533794645977493]], AbsoluteThickness[0.25], 
     LineBox[{1364, 1365}]}, 
    {Hue[
      NCache[
       Rational[455, 4769], 0.09540784231495072]], AbsoluteThickness[0.25], 
     LineBox[{1365, 1366}]}, 
    {Hue[
      NCache[
       Rational[1366, 14307], 0.09547773817012652]], AbsoluteThickness[0.25], 
     LineBox[{1366, 1367}]}, 
    {Hue[
      NCache[
       Rational[1367, 14307], 0.0955476340253023]], AbsoluteThickness[0.25], 
     LineBox[{1367, 1368}]}, 
    {Hue[
      NCache[
       Rational[24, 251], 0.09561752988047809]], AbsoluteThickness[0.25], 
     LineBox[{1368, 1369}]}, 
    {Hue[
      NCache[
       Rational[1369, 14307], 0.09568742573565388]], AbsoluteThickness[0.25], 
     LineBox[{1369, 1370}]}, 
    {Hue[
      NCache[
       Rational[1370, 14307], 0.09575732159082967]], AbsoluteThickness[0.25], 
     LineBox[{1370, 1371}]}, 
    {Hue[
      NCache[
       Rational[457, 4769], 0.09582721744600545]], AbsoluteThickness[0.25], 
     LineBox[{1371, 1372}]}, 
    {Hue[
      NCache[
       Rational[1372, 14307], 0.09589711330118124]], AbsoluteThickness[0.25], 
     LineBox[{1372, 1373}]}, 
    {Hue[
      NCache[
       Rational[1373, 14307], 0.09596700915635703]], AbsoluteThickness[0.25], 
     LineBox[{1373, 1374}]}, 
    {Hue[
      NCache[
       Rational[458, 4769], 0.09603690501153282]], AbsoluteThickness[0.25], 
     LineBox[{1374, 1375}]}, 
    {Hue[
      NCache[
       Rational[1375, 14307], 0.0961068008667086]], AbsoluteThickness[0.25], 
     LineBox[{1375, 1376}]}, 
    {Hue[
      NCache[
       Rational[1376, 14307], 0.09617669672188439]], AbsoluteThickness[0.25], 
     LineBox[{1376, 1377}]}, 
    {Hue[
      NCache[
       Rational[459, 4769], 0.09624659257706018]], AbsoluteThickness[0.25], 
     LineBox[{1377, 1378}]}, 
    {Hue[
      NCache[
       Rational[1378, 14307], 0.09631648843223597]], AbsoluteThickness[0.25], 
     LineBox[{1378, 1379}]}, 
    {Hue[
      NCache[
       Rational[1379, 14307], 0.09638638428741175]], AbsoluteThickness[0.25], 
     LineBox[{1379, 1380}]}, 
    {Hue[
      NCache[
       Rational[460, 4769], 0.09645628014258754]], AbsoluteThickness[0.25], 
     LineBox[{1380, 1381}]}, 
    {Hue[
      NCache[
       Rational[1381, 14307], 0.09652617599776334]], AbsoluteThickness[0.25], 
     LineBox[{1381, 1382}]}, 
    {Hue[
      NCache[
       Rational[1382, 14307], 0.09659607185293911]], AbsoluteThickness[0.25], 
     LineBox[{1382, 1383}]}, 
    {Hue[
      NCache[
       Rational[461, 4769], 0.0966659677081149]], AbsoluteThickness[0.25], 
     LineBox[{1383, 1384}]}, 
    {Hue[
      NCache[
       Rational[1384, 14307], 0.0967358635632907]], AbsoluteThickness[0.25], 
     LineBox[{1384, 1385}]}, 
    {Hue[
      NCache[
       Rational[1385, 14307], 0.09680575941846649]], AbsoluteThickness[0.25], 
     LineBox[{1385, 1386}]}, 
    {Hue[
      NCache[
       Rational[462, 4769], 0.09687565527364227]], AbsoluteThickness[0.25], 
     LineBox[{1386, 1387}]}, 
    {Hue[
      NCache[
       Rational[73, 753], 0.09694555112881806]], AbsoluteThickness[0.25], 
     LineBox[{1387, 1388}]}, 
    {Hue[
      NCache[
       Rational[1388, 14307], 0.09701544698399385]], AbsoluteThickness[0.25], 
     LineBox[{1388, 1389}]}, 
    {Hue[
      NCache[
       Rational[463, 4769], 0.09708534283916964]], AbsoluteThickness[0.25], 
     LineBox[{1389, 1390}]}, 
    {Hue[
      NCache[
       Rational[1390, 14307], 0.09715523869434542]], AbsoluteThickness[0.25], 
     LineBox[{1390, 1391}]}, 
    {Hue[
      NCache[
       Rational[1391, 14307], 0.09722513454952121]], AbsoluteThickness[0.25], 
     LineBox[{1391, 1392}]}, 
    {Hue[
      NCache[
       Rational[464, 4769], 0.097295030404697]], AbsoluteThickness[0.25], 
     LineBox[{1392, 1393}]}, 
    {Hue[
      NCache[
       Rational[1393, 14307], 0.0973649262598728]], AbsoluteThickness[0.25], 
     LineBox[{1393, 1394}]}, 
    {Hue[
      NCache[
       Rational[1394, 14307], 0.09743482211504857]], AbsoluteThickness[0.25], 
     LineBox[{1394, 1395}]}, 
    {Hue[
      NCache[
       Rational[465, 4769], 0.09750471797022436]], AbsoluteThickness[0.25], 
     LineBox[{1395, 1396}]}, 
    {Hue[
      NCache[
       Rational[1396, 14307], 0.09757461382540016]], AbsoluteThickness[0.25], 
     LineBox[{1396, 1397}]}, 
    {Hue[
      NCache[
       Rational[1397, 14307], 0.09764450968057595]], AbsoluteThickness[0.25], 
     LineBox[{1397, 1398}]}, 
    {Hue[
      NCache[
       Rational[466, 4769], 0.09771440553575172]], AbsoluteThickness[0.25], 
     LineBox[{1398, 1399}]}, 
    {Hue[
      NCache[
       Rational[1399, 14307], 0.09778430139092752]], AbsoluteThickness[0.25], 
     LineBox[{1399, 1400}]}, 
    {Hue[
      NCache[
       Rational[1400, 14307], 0.09785419724610331]], AbsoluteThickness[0.25], 
     LineBox[{1400, 1401}]}, 
    {Hue[
      NCache[
       Rational[467, 4769], 0.0979240931012791]], AbsoluteThickness[0.25], 
     LineBox[{1401, 1402}]}, 
    {Hue[
      NCache[
       Rational[1402, 14307], 0.09799398895645488]], AbsoluteThickness[0.25], 
     LineBox[{1402, 1403}]}, 
    {Hue[
      NCache[
       Rational[1403, 14307], 0.09806388481163067]], AbsoluteThickness[0.25], 
     LineBox[{1403, 1404}]}, 
    {Hue[
      NCache[
       Rational[468, 4769], 0.09813378066680646]], AbsoluteThickness[0.25], 
     LineBox[{1404, 1405}]}, 
    {Hue[
      NCache[
       Rational[1405, 14307], 0.09820367652198225]], AbsoluteThickness[0.25], 
     LineBox[{1405, 1406}]}, 
    {Hue[
      NCache[
       Rational[74, 753], 0.09827357237715803]], AbsoluteThickness[0.25], 
     LineBox[{1406, 1407}]}, 
    {Hue[
      NCache[
       Rational[469, 4769], 0.09834346823233382]], AbsoluteThickness[0.25], 
     LineBox[{1407, 1408}]}, 
    {Hue[
      NCache[
       Rational[1408, 14307], 0.09841336408750961]], AbsoluteThickness[0.25], 
     LineBox[{1408, 1409}]}, 
    {Hue[
      NCache[
       Rational[1409, 14307], 0.0984832599426854]], AbsoluteThickness[0.25], 
     LineBox[{1409, 1410}]}, 
    {Hue[
      NCache[
       Rational[470, 4769], 0.09855315579786118]], AbsoluteThickness[0.25], 
     LineBox[{1410, 1411}]}, 
    {Hue[
      NCache[
       Rational[1411, 14307], 0.09862305165303697]], AbsoluteThickness[0.25], 
     LineBox[{1411, 1412}]}, 
    {Hue[
      NCache[
       Rational[1412, 14307], 0.09869294750821277]], AbsoluteThickness[0.25], 
     LineBox[{1412, 1413}]}, 
    {Hue[
      NCache[
       Rational[471, 4769], 0.09876284336338854]], AbsoluteThickness[0.25], 
     LineBox[{1413, 1414}]}, 
    {Hue[
      NCache[
       Rational[1414, 14307], 0.09883273921856434]], AbsoluteThickness[0.25], 
     LineBox[{1414, 1415}]}, 
    {Hue[
      NCache[
       Rational[1415, 14307], 0.09890263507374013]], AbsoluteThickness[0.25], 
     LineBox[{1415, 1416}]}, 
    {Hue[
      NCache[
       Rational[472, 4769], 0.09897253092891592]], AbsoluteThickness[0.25], 
     LineBox[{1416, 1417}]}, 
    {Hue[
      NCache[
       Rational[1417, 14307], 0.0990424267840917]], AbsoluteThickness[0.25], 
     LineBox[{1417, 1418}]}, 
    {Hue[
      NCache[
       Rational[1418, 14307], 0.09911232263926749]], AbsoluteThickness[0.25], 
     LineBox[{1418, 1419}]}, 
    {Hue[
      NCache[
       Rational[473, 4769], 0.09918221849444328]], AbsoluteThickness[0.25], 
     LineBox[{1419, 1420}]}, 
    {Hue[
      NCache[
       Rational[1420, 14307], 0.09925211434961907]], AbsoluteThickness[0.25], 
     LineBox[{1420, 1421}]}, 
    {Hue[
      NCache[
       Rational[1421, 14307], 0.09932201020479485]], AbsoluteThickness[0.25], 
     LineBox[{1421, 1422}]}, 
    {Hue[
      NCache[
       Rational[474, 4769], 0.09939190605997064]], AbsoluteThickness[0.25], 
     LineBox[{1422, 1423}]}, 
    {Hue[
      NCache[
       Rational[1423, 14307], 0.09946180191514643]], AbsoluteThickness[0.25], 
     LineBox[{1423, 1424}]}, 
    {Hue[
      NCache[
       Rational[1424, 14307], 0.09953169777032222]], AbsoluteThickness[0.25], 
     LineBox[{1424, 1425}]}, 
    {Hue[
      NCache[
       Rational[25, 251], 0.099601593625498]], AbsoluteThickness[0.25], 
     LineBox[{1425, 1426}]}, 
    {Hue[
      NCache[
       Rational[1426, 14307], 0.0996714894806738]], AbsoluteThickness[0.25], 
     LineBox[{1426, 1427}]}, 
    {Hue[
      NCache[
       Rational[1427, 14307], 0.09974138533584959]], AbsoluteThickness[0.25], 
     LineBox[{1427, 1428}]}, 
    {Hue[
      NCache[
       Rational[476, 4769], 0.09981128119102538]], AbsoluteThickness[0.25], 
     LineBox[{1428, 1429}]}, 
    {Hue[
      NCache[
       Rational[1429, 14307], 0.09988117704620116]], AbsoluteThickness[0.25], 
     LineBox[{1429, 1430}]}, 
    {Hue[
      NCache[
       Rational[1430, 14307], 0.09995107290137695]], AbsoluteThickness[0.25], 
     LineBox[{1430, 1431}]}, 
    {Hue[
      NCache[
       Rational[477, 4769], 0.10002096875655274`]], AbsoluteThickness[0.25], 
     LineBox[{1431, 1432}]}, 
    {Hue[
      NCache[
       Rational[1432, 14307], 0.10009086461172853`]], AbsoluteThickness[0.25],
      LineBox[{1432, 1433}]}, 
    {Hue[
      NCache[
       Rational[1433, 14307], 0.10016076046690431`]], AbsoluteThickness[0.25],
      LineBox[{1433, 1434}]}, 
    {Hue[
      NCache[
       Rational[478, 4769], 0.1002306563220801]], AbsoluteThickness[0.25], 
     LineBox[{1434, 1435}]}, 
    {Hue[
      NCache[
       Rational[1435, 14307], 0.10030055217725589`]], AbsoluteThickness[0.25],
      LineBox[{1435, 1436}]}, 
    {Hue[
      NCache[
       Rational[1436, 14307], 0.10037044803243168`]], AbsoluteThickness[0.25],
      LineBox[{1436, 1437}]}, 
    {Hue[
      NCache[
       Rational[479, 4769], 0.10044034388760746`]], AbsoluteThickness[0.25], 
     LineBox[{1437, 1438}]}, 
    {Hue[
      NCache[
       Rational[1438, 14307], 0.10051023974278325`]], AbsoluteThickness[0.25],
      LineBox[{1438, 1439}]}, 
    {Hue[
      NCache[
       Rational[1439, 14307], 0.10058013559795904`]], AbsoluteThickness[0.25],
      LineBox[{1439, 1440}]}, 
    {Hue[
      NCache[
       Rational[480, 4769], 0.10065003145313482`]], AbsoluteThickness[0.25], 
     LineBox[{1440, 1441}]}, 
    {Hue[
      NCache[
       Rational[1441, 14307], 0.10071992730831061`]], AbsoluteThickness[0.25],
      LineBox[{1441, 1442}]}, 
    {Hue[
      NCache[
       Rational[1442, 14307], 0.1007898231634864]], AbsoluteThickness[0.25], 
     LineBox[{1442, 1443}]}, 
    {Hue[
      NCache[
       Rational[481, 4769], 0.1008597190186622]], AbsoluteThickness[0.25], 
     LineBox[{1443, 1444}]}, 
    {Hue[
      NCache[
       Rational[76, 753], 0.10092961487383798`]], AbsoluteThickness[0.25], 
     LineBox[{1444, 1445}]}, 
    {Hue[
      NCache[
       Rational[1445, 14307], 0.10099951072901377`]], AbsoluteThickness[0.25],
      LineBox[{1445, 1446}]}, 
    {Hue[
      NCache[
       Rational[482, 4769], 0.10106940658418956`]], AbsoluteThickness[0.25], 
     LineBox[{1446, 1447}]}, 
    {Hue[
      NCache[
       Rational[1447, 14307], 0.10113930243936535`]], AbsoluteThickness[0.25],
      LineBox[{1447, 1448}]}, 
    {Hue[
      NCache[
       Rational[1448, 14307], 0.10120919829454113`]], AbsoluteThickness[0.25],
      LineBox[{1448, 1449}]}, 
    {Hue[
      NCache[
       Rational[483, 4769], 0.10127909414971692`]], AbsoluteThickness[0.25], 
     LineBox[{1449, 1450}]}, 
    {Hue[
      NCache[
       Rational[1450, 14307], 0.10134899000489271`]], AbsoluteThickness[0.25],
      LineBox[{1450, 1451}]}, 
    {Hue[
      NCache[
       Rational[1451, 14307], 0.1014188858600685]], AbsoluteThickness[0.25], 
     LineBox[{1451, 1452}]}, 
    {Hue[
      NCache[
       Rational[484, 4769], 0.10148878171524428`]], AbsoluteThickness[0.25], 
     LineBox[{1452, 1453}]}, 
    {Hue[
      NCache[
       Rational[1453, 14307], 0.10155867757042007`]], AbsoluteThickness[0.25],
      LineBox[{1453, 1454}]}, 
    {Hue[
      NCache[
       Rational[1454, 14307], 0.10162857342559586`]], AbsoluteThickness[0.25],
      LineBox[{1454, 1455}]}, 
    {Hue[
      NCache[
       Rational[485, 4769], 0.10169846928077166`]], AbsoluteThickness[0.25], 
     LineBox[{1455, 1456}]}, 
    {Hue[
      NCache[
       Rational[1456, 14307], 0.10176836513594743`]], AbsoluteThickness[0.25],
      LineBox[{1456, 1457}]}, 
    {Hue[
      NCache[
       Rational[1457, 14307], 0.10183826099112323`]], AbsoluteThickness[0.25],
      LineBox[{1457, 1458}]}, 
    {Hue[
      NCache[
       Rational[486, 4769], 0.10190815684629902`]], AbsoluteThickness[0.25], 
     LineBox[{1458, 1459}]}, 
    {Hue[
      NCache[
       Rational[1459, 14307], 0.10197805270147481`]], AbsoluteThickness[0.25],
      LineBox[{1459, 1460}]}, 
    {Hue[
      NCache[
       Rational[1460, 14307], 0.10204794855665059`]], AbsoluteThickness[0.25],
      LineBox[{1460, 1461}]}, 
    {Hue[
      NCache[
       Rational[487, 4769], 0.10211784441182638`]], AbsoluteThickness[0.25], 
     LineBox[{1461, 1462}]}, 
    {Hue[
      NCache[
       Rational[1462, 14307], 0.10218774026700217`]], AbsoluteThickness[0.25],
      LineBox[{1462, 1463}]}, 
    {Hue[
      NCache[
       Rational[77, 753], 0.10225763612217796`]], AbsoluteThickness[0.25], 
     LineBox[{1463, 1464}]}, 
    {Hue[
      NCache[
       Rational[488, 4769], 0.10232753197735374`]], AbsoluteThickness[0.25], 
     LineBox[{1464, 1465}]}, 
    {Hue[
      NCache[
       Rational[1465, 14307], 0.10239742783252953`]], AbsoluteThickness[0.25],
      LineBox[{1465, 1466}]}, 
    {Hue[
      NCache[
       Rational[1466, 14307], 0.10246732368770532`]], AbsoluteThickness[0.25],
      LineBox[{1466, 1467}]}, 
    {Hue[
      NCache[
       Rational[489, 4769], 0.10253721954288111`]], AbsoluteThickness[0.25], 
     LineBox[{1467, 1468}]}, 
    {Hue[
      NCache[
       Rational[1468, 14307], 0.10260711539805689`]], AbsoluteThickness[0.25],
      LineBox[{1468, 1469}]}, 
    {Hue[
      NCache[
       Rational[1469, 14307], 0.10267701125323268`]], AbsoluteThickness[0.25],
      LineBox[{1469, 1470}]}, 
    {Hue[
      NCache[
       Rational[490, 4769], 0.10274690710840848`]], AbsoluteThickness[0.25], 
     LineBox[{1470, 1471}]}, 
    {Hue[
      NCache[
       Rational[1471, 14307], 0.10281680296358425`]], AbsoluteThickness[0.25],
      LineBox[{1471, 1472}]}, 
    {Hue[
      NCache[
       Rational[1472, 14307], 0.10288669881876004`]], AbsoluteThickness[0.25],
      LineBox[{1472, 1473}]}, 
    {Hue[
      NCache[
       Rational[491, 4769], 0.10295659467393584`]], AbsoluteThickness[0.25], 
     LineBox[{1473, 1474}]}, 
    {Hue[
      NCache[
       Rational[1474, 14307], 0.10302649052911163`]], AbsoluteThickness[0.25],
      LineBox[{1474, 1475}]}, 
    {Hue[
      NCache[
       Rational[1475, 14307], 0.1030963863842874]], AbsoluteThickness[0.25], 
     LineBox[{1475, 1476}]}, 
    {Hue[
      NCache[
       Rational[492, 4769], 0.1031662822394632]], AbsoluteThickness[0.25], 
     LineBox[{1476, 1477}]}, 
    {Hue[
      NCache[
       Rational[1477, 14307], 0.10323617809463899`]], AbsoluteThickness[0.25],
      LineBox[{1477, 1478}]}, 
    {Hue[
      NCache[
       Rational[1478, 14307], 0.10330607394981478`]], AbsoluteThickness[0.25],
      LineBox[{1478, 1479}]}, 
    {Hue[
      NCache[
       Rational[493, 4769], 0.10337596980499056`]], AbsoluteThickness[0.25], 
     LineBox[{1479, 1480}]}, 
    {Hue[
      NCache[
       Rational[1480, 14307], 0.10344586566016635`]], AbsoluteThickness[0.25],
      LineBox[{1480, 1481}]}, 
    {Hue[
      NCache[
       Rational[1481, 14307], 0.10351576151534214`]], AbsoluteThickness[0.25],
      LineBox[{1481, 1482}]}, 
    {Hue[
      NCache[
       Rational[26, 251], 0.10358565737051793`]], AbsoluteThickness[0.25], 
     LineBox[{1482, 1483}]}, 
    {Hue[
      NCache[
       Rational[1483, 14307], 0.10365555322569371`]], AbsoluteThickness[0.25],
      LineBox[{1483, 1484}]}, 
    {Hue[
      NCache[
       Rational[1484, 14307], 0.1037254490808695]], AbsoluteThickness[0.25], 
     LineBox[{1484, 1485}]}, 
    {Hue[
      NCache[
       Rational[495, 4769], 0.1037953449360453]], AbsoluteThickness[0.25], 
     LineBox[{1485, 1486}]}, 
    {Hue[
      NCache[
       Rational[1486, 14307], 0.10386524079122109`]], AbsoluteThickness[0.25],
      LineBox[{1486, 1487}]}, 
    {Hue[
      NCache[
       Rational[1487, 14307], 0.10393513664639686`]], AbsoluteThickness[0.25],
      LineBox[{1487, 1488}]}, 
    {Hue[
      NCache[
       Rational[496, 4769], 0.10400503250157266`]], AbsoluteThickness[0.25], 
     LineBox[{1488, 1489}]}, 
    {Hue[
      NCache[
       Rational[1489, 14307], 0.10407492835674845`]], AbsoluteThickness[0.25],
      LineBox[{1489, 1490}]}, 
    {Hue[
      NCache[
       Rational[1490, 14307], 0.10414482421192424`]], AbsoluteThickness[0.25],
      LineBox[{1490, 1491}]}, 
    {Hue[
      NCache[
       Rational[497, 4769], 0.10421472006710002`]], AbsoluteThickness[0.25], 
     LineBox[{1491, 1492}]}, 
    {Hue[
      NCache[
       Rational[1492, 14307], 0.10428461592227581`]], AbsoluteThickness[0.25],
      LineBox[{1492, 1493}]}, 
    {Hue[
      NCache[
       Rational[1493, 14307], 0.1043545117774516]], AbsoluteThickness[0.25], 
     LineBox[{1493, 1494}]}, 
    {Hue[
      NCache[
       Rational[498, 4769], 0.10442440763262739`]], AbsoluteThickness[0.25], 
     LineBox[{1494, 1495}]}, 
    {Hue[
      NCache[
       Rational[1495, 14307], 0.10449430348780317`]], AbsoluteThickness[0.25],
      LineBox[{1495, 1496}]}, 
    {Hue[
      NCache[
       Rational[1496, 14307], 0.10456419934297896`]], AbsoluteThickness[0.25],
      LineBox[{1496, 1497}]}, 
    {Hue[
      NCache[
       Rational[499, 4769], 0.10463409519815475`]], AbsoluteThickness[0.25], 
     LineBox[{1497, 1498}]}, 
    {Hue[
      NCache[
       Rational[1498, 14307], 0.10470399105333053`]], AbsoluteThickness[0.25],
      LineBox[{1498, 1499}]}, 
    {Hue[
      NCache[
       Rational[1499, 14307], 0.10477388690850632`]], AbsoluteThickness[0.25],
      LineBox[{1499, 1500}]}, 
    {Hue[
      NCache[
       Rational[500, 4769], 0.10484378276368211`]], AbsoluteThickness[0.25], 
     LineBox[{1500, 1501}]}, 
    {Hue[
      NCache[
       Rational[79, 753], 0.1049136786188579]], AbsoluteThickness[0.25], 
     LineBox[{1501, 1502}]}, 
    {Hue[
      NCache[
       Rational[1502, 14307], 0.10498357447403368`]], AbsoluteThickness[0.25],
      LineBox[{1502, 1503}]}, 
    {Hue[
      NCache[
       Rational[501, 4769], 0.10505347032920948`]], AbsoluteThickness[0.25], 
     LineBox[{1503, 1504}]}, 
    {Hue[
      NCache[
       Rational[1504, 14307], 0.10512336618438527`]], AbsoluteThickness[0.25],
      LineBox[{1504, 1505}]}, 
    {Hue[
      NCache[
       Rational[1505, 14307], 0.10519326203956106`]], AbsoluteThickness[0.25],
      LineBox[{1505, 1506}]}, 
    {Hue[
      NCache[
       Rational[2, 19], 0.10526315789473684`]], AbsoluteThickness[0.25], 
     LineBox[{1506, 1507}]}, 
    {Hue[
      NCache[
       Rational[1507, 14307], 0.10533305374991263`]], AbsoluteThickness[0.25],
      LineBox[{1507, 1508}]}, 
    {Hue[
      NCache[
       Rational[1508, 14307], 0.10540294960508842`]], AbsoluteThickness[0.25],
      LineBox[{1508, 1509}]}, 
    {Hue[
      NCache[
       Rational[503, 4769], 0.10547284546026421`]], AbsoluteThickness[0.25], 
     LineBox[{1509, 1510}]}, 
    {Hue[
      NCache[
       Rational[1510, 14307], 0.10554274131543999`]], AbsoluteThickness[0.25],
      LineBox[{1510, 1511}]}, 
    {Hue[
      NCache[
       Rational[1511, 14307], 0.10561263717061578`]], AbsoluteThickness[0.25],
      LineBox[{1511, 1512}]}, 
    {Hue[
      NCache[
       Rational[504, 4769], 0.10568253302579157`]], AbsoluteThickness[0.25], 
     LineBox[{1512, 1513}]}, 
    {Hue[
      NCache[
       Rational[1513, 14307], 0.10575242888096736`]], AbsoluteThickness[0.25],
      LineBox[{1513, 1514}]}, 
    {Hue[
      NCache[
       Rational[1514, 14307], 0.10582232473614314`]], AbsoluteThickness[0.25],
      LineBox[{1514, 1515}]}, 
    {Hue[
      NCache[
       Rational[505, 4769], 0.10589222059131893`]], AbsoluteThickness[0.25], 
     LineBox[{1515, 1516}]}, 
    {Hue[
      NCache[
       Rational[1516, 14307], 0.10596211644649473`]], AbsoluteThickness[0.25],
      LineBox[{1516, 1517}]}, 
    {Hue[
      NCache[
       Rational[1517, 14307], 0.10603201230167052`]], AbsoluteThickness[0.25],
      LineBox[{1517, 1518}]}, 
    {Hue[
      NCache[
       Rational[506, 4769], 0.1061019081568463]], AbsoluteThickness[0.25], 
     LineBox[{1518, 1519}]}, 
    {Hue[
      NCache[
       Rational[1519, 14307], 0.10617180401202209`]], AbsoluteThickness[0.25],
      LineBox[{1519, 1520}]}, 
    {Hue[
      NCache[
       Rational[80, 753], 0.10624169986719788`]], AbsoluteThickness[0.25], 
     LineBox[{1520, 1521}]}, 
    {Hue[
      NCache[
       Rational[507, 4769], 0.10631159572237367`]], AbsoluteThickness[0.25], 
     LineBox[{1521, 1522}]}, 
    {Hue[
      NCache[
       Rational[1522, 14307], 0.10638149157754945`]], AbsoluteThickness[0.25],
      LineBox[{1522, 1523}]}, 
    {Hue[
      NCache[
       Rational[1523, 14307], 0.10645138743272524`]], AbsoluteThickness[0.25],
      LineBox[{1523, 1524}]}, 
    {Hue[
      NCache[
       Rational[508, 4769], 0.10652128328790103`]], AbsoluteThickness[0.25], 
     LineBox[{1524, 1525}]}, 
    {Hue[
      NCache[
       Rational[1525, 14307], 0.10659117914307682`]], AbsoluteThickness[0.25],
      LineBox[{1525, 1526}]}, 
    {Hue[
      NCache[
       Rational[1526, 14307], 0.1066610749982526]], AbsoluteThickness[0.25], 
     LineBox[{1526, 1527}]}, 
    {Hue[
      NCache[
       Rational[509, 4769], 0.10673097085342839`]], AbsoluteThickness[0.25], 
     LineBox[{1527, 1528}]}, 
    {Hue[
      NCache[
       Rational[1528, 14307], 0.10680086670860418`]], AbsoluteThickness[0.25],
      LineBox[{1528, 1529}]}, 
    {Hue[
      NCache[
       Rational[1529, 14307], 0.10687076256377996`]], AbsoluteThickness[0.25],
      LineBox[{1529, 1530}]}, 
    {Hue[
      NCache[
       Rational[510, 4769], 0.10694065841895575`]], AbsoluteThickness[0.25], 
     LineBox[{1530, 1531}]}, 
    {Hue[
      NCache[
       Rational[1531, 14307], 0.10701055427413154`]], AbsoluteThickness[0.25],
      LineBox[{1531, 1532}]}, 
    {Hue[
      NCache[
       Rational[1532, 14307], 0.10708045012930734`]], AbsoluteThickness[0.25],
      LineBox[{1532, 1533}]}, 
    {Hue[
      NCache[
       Rational[511, 4769], 0.10715034598448311`]], AbsoluteThickness[0.25], 
     LineBox[{1533, 1534}]}, 
    {Hue[
      NCache[
       Rational[1534, 14307], 0.1072202418396589]], AbsoluteThickness[0.25], 
     LineBox[{1534, 1535}]}, 
    {Hue[
      NCache[
       Rational[1535, 14307], 0.1072901376948347]], AbsoluteThickness[0.25], 
     LineBox[{1535, 1536}]}, 
    {Hue[
      NCache[
       Rational[512, 4769], 0.10736003355001049`]], AbsoluteThickness[0.25], 
     LineBox[{1536, 1537}]}, 
    {Hue[
      NCache[
       Rational[1537, 14307], 0.10742992940518627`]], AbsoluteThickness[0.25],
      LineBox[{1537, 1538}]}, 
    {Hue[
      NCache[
       Rational[1538, 14307], 0.10749982526036206`]], AbsoluteThickness[0.25],
      LineBox[{1538, 1539}]}, 
    {Hue[
      NCache[
       Rational[27, 251], 0.10756972111553785`]], AbsoluteThickness[0.25], 
     LineBox[{1539, 1540}]}, 
    {Hue[
      NCache[
       Rational[1540, 14307], 0.10763961697071364`]], AbsoluteThickness[0.25],
      LineBox[{1540, 1541}]}, 
    {Hue[
      NCache[
       Rational[1541, 14307], 0.10770951282588942`]], AbsoluteThickness[0.25],
      LineBox[{1541, 1542}]}, 
    {Hue[
      NCache[
       Rational[514, 4769], 0.10777940868106521`]], AbsoluteThickness[0.25], 
     LineBox[{1542, 1543}]}, 
    {Hue[
      NCache[
       Rational[1543, 14307], 0.107849304536241]], AbsoluteThickness[0.25], 
     LineBox[{1543, 1544}]}, 
    {Hue[
      NCache[
       Rational[1544, 14307], 0.1079192003914168]], AbsoluteThickness[0.25], 
     LineBox[{1544, 1545}]}, 
    {Hue[
      NCache[
       Rational[515, 4769], 0.10798909624659257`]], AbsoluteThickness[0.25], 
     LineBox[{1545, 1546}]}, 
    {Hue[
      NCache[
       Rational[1546, 14307], 0.10805899210176836`]], AbsoluteThickness[0.25],
      LineBox[{1546, 1547}]}, 
    {Hue[
      NCache[
       Rational[1547, 14307], 0.10812888795694416`]], AbsoluteThickness[0.25],
      LineBox[{1547, 1548}]}, 
    {Hue[
      NCache[
       Rational[516, 4769], 0.10819878381211995`]], AbsoluteThickness[0.25], 
     LineBox[{1548, 1549}]}, 
    {Hue[
      NCache[
       Rational[1549, 14307], 0.10826867966729573`]], AbsoluteThickness[0.25],
      LineBox[{1549, 1550}]}, 
    {Hue[
      NCache[
       Rational[1550, 14307], 0.10833857552247152`]], AbsoluteThickness[0.25],
      LineBox[{1550, 1551}]}, 
    {Hue[
      NCache[
       Rational[517, 4769], 0.10840847137764731`]], AbsoluteThickness[0.25], 
     LineBox[{1551, 1552}]}, 
    {Hue[
      NCache[
       Rational[1552, 14307], 0.1084783672328231]], AbsoluteThickness[0.25], 
     LineBox[{1552, 1553}]}, 
    {Hue[
      NCache[
       Rational[1553, 14307], 0.10854826308799888`]], AbsoluteThickness[0.25],
      LineBox[{1553, 1554}]}, 
    {Hue[
      NCache[
       Rational[518, 4769], 0.10861815894317467`]], AbsoluteThickness[0.25], 
     LineBox[{1554, 1555}]}, 
    {Hue[
      NCache[
       Rational[1555, 14307], 0.10868805479835046`]], AbsoluteThickness[0.25],
      LineBox[{1555, 1556}]}, 
    {Hue[
      NCache[
       Rational[1556, 14307], 0.10875795065352624`]], AbsoluteThickness[0.25],
      LineBox[{1556, 1557}]}, 
    {Hue[
      NCache[
       Rational[519, 4769], 0.10882784650870203`]], AbsoluteThickness[0.25], 
     LineBox[{1557, 1558}]}, 
    {Hue[
      NCache[
       Rational[82, 753], 0.10889774236387782`]], AbsoluteThickness[0.25], 
     LineBox[{1558, 1559}]}, 
    {Hue[
      NCache[
       Rational[1559, 14307], 0.10896763821905361`]], AbsoluteThickness[0.25],
      LineBox[{1559, 1560}]}, 
    {Hue[
      NCache[
       Rational[520, 4769], 0.10903753407422939`]], AbsoluteThickness[0.25], 
     LineBox[{1560, 1561}]}, 
    {Hue[
      NCache[
       Rational[1561, 14307], 0.10910742992940518`]], AbsoluteThickness[0.25],
      LineBox[{1561, 1562}]}, 
    {Hue[
      NCache[
       Rational[1562, 14307], 0.10917732578458098`]], AbsoluteThickness[0.25],
      LineBox[{1562, 1563}]}, 
    {Hue[
      NCache[
       Rational[521, 4769], 0.10924722163975677`]], AbsoluteThickness[0.25], 
     LineBox[{1563, 1564}]}, 
    {Hue[
      NCache[
       Rational[1564, 14307], 0.10931711749493254`]], AbsoluteThickness[0.25],
      LineBox[{1564, 1565}]}, 
    {Hue[
      NCache[
       Rational[1565, 14307], 0.10938701335010834`]], AbsoluteThickness[0.25],
      LineBox[{1565, 1566}]}, 
    {Hue[
      NCache[
       Rational[522, 4769], 0.10945690920528413`]], AbsoluteThickness[0.25], 
     LineBox[{1566, 1567}]}, 
    {Hue[
      NCache[
       Rational[1567, 14307], 0.10952680506045992`]], AbsoluteThickness[0.25],
      LineBox[{1567, 1568}]}, 
    {Hue[
      NCache[
       Rational[1568, 14307], 0.1095967009156357]], AbsoluteThickness[0.25], 
     LineBox[{1568, 1569}]}, 
    {Hue[
      NCache[
       Rational[523, 4769], 0.10966659677081149`]], AbsoluteThickness[0.25], 
     LineBox[{1569, 1570}]}, 
    {Hue[
      NCache[
       Rational[1570, 14307], 0.10973649262598728`]], AbsoluteThickness[0.25],
      LineBox[{1570, 1571}]}, 
    {Hue[
      NCache[
       Rational[1571, 14307], 0.10980638848116307`]], AbsoluteThickness[0.25],
      LineBox[{1571, 1572}]}, 
    {Hue[
      NCache[
       Rational[524, 4769], 0.10987628433633885`]], AbsoluteThickness[0.25], 
     LineBox[{1572, 1573}]}, 
    {Hue[
      NCache[
       Rational[1573, 14307], 0.10994618019151464`]], AbsoluteThickness[0.25],
      LineBox[{1573, 1574}]}, 
    {Hue[
      NCache[
       Rational[1574, 14307], 0.11001607604669043`]], AbsoluteThickness[0.25],
      LineBox[{1574, 1575}]}, 
    {Hue[
      NCache[
       Rational[525, 4769], 0.11008597190186623`]], AbsoluteThickness[0.25], 
     LineBox[{1575, 1576}]}, 
    {Hue[
      NCache[
       Rational[1576, 14307], 0.110155867757042]], AbsoluteThickness[0.25], 
     LineBox[{1576, 1577}]}, 
    {Hue[
      NCache[
       Rational[83, 753], 0.1102257636122178]], AbsoluteThickness[0.25], 
     LineBox[{1577, 1578}]}, 
    {Hue[
      NCache[
       Rational[526, 4769], 0.11029565946739359`]], AbsoluteThickness[0.25], 
     LineBox[{1578, 1579}]}, 
    {Hue[
      NCache[
       Rational[1579, 14307], 0.11036555532256938`]], AbsoluteThickness[0.25],
      LineBox[{1579, 1580}]}, 
    {Hue[
      NCache[
       Rational[1580, 14307], 0.11043545117774516`]], AbsoluteThickness[0.25],
      LineBox[{1580, 1581}]}, 
    {Hue[
      NCache[
       Rational[527, 4769], 0.11050534703292095`]], AbsoluteThickness[0.25], 
     LineBox[{1581, 1582}]}, 
    {Hue[
      NCache[
       Rational[1582, 14307], 0.11057524288809674`]], AbsoluteThickness[0.25],
      LineBox[{1582, 1583}]}, 
    {Hue[
      NCache[
       Rational[1583, 14307], 0.11064513874327253`]], AbsoluteThickness[0.25],
      LineBox[{1583, 1584}]}, 
    {Hue[
      NCache[
       Rational[528, 4769], 0.11071503459844831`]], AbsoluteThickness[0.25], 
     LineBox[{1584, 1585}]}, 
    {Hue[
      NCache[
       Rational[1585, 14307], 0.1107849304536241]], AbsoluteThickness[0.25], 
     LineBox[{1585, 1586}]}, 
    {Hue[
      NCache[
       Rational[1586, 14307], 0.11085482630879989`]], AbsoluteThickness[0.25],
      LineBox[{1586, 1587}]}, 
    {Hue[
      NCache[
       Rational[529, 4769], 0.11092472216397567`]], AbsoluteThickness[0.25], 
     LineBox[{1587, 1588}]}, 
    {Hue[
      NCache[
       Rational[1588, 14307], 0.11099461801915146`]], AbsoluteThickness[0.25],
      LineBox[{1588, 1589}]}, 
    {Hue[
      NCache[
       Rational[1589, 14307], 0.11106451387432725`]], AbsoluteThickness[0.25],
      LineBox[{1589, 1590}]}, 
    {Hue[
      NCache[
       Rational[530, 4769], 0.11113440972950304`]], AbsoluteThickness[0.25], 
     LineBox[{1590, 1591}]}, 
    {Hue[
      NCache[
       Rational[1591, 14307], 0.11120430558467882`]], AbsoluteThickness[0.25],
      LineBox[{1591, 1592}]}, 
    {Hue[
      NCache[
       Rational[1592, 14307], 0.11127420143985461`]], AbsoluteThickness[0.25],
      LineBox[{1592, 1593}]}, 
    {Hue[
      NCache[
       Rational[531, 4769], 0.1113440972950304]], AbsoluteThickness[0.25], 
     LineBox[{1593, 1594}]}, 
    {Hue[
      NCache[
       Rational[1594, 14307], 0.1114139931502062]], AbsoluteThickness[0.25], 
     LineBox[{1594, 1595}]}, 
    {Hue[
      NCache[
       Rational[1595, 14307], 0.11148388900538198`]], AbsoluteThickness[0.25],
      LineBox[{1595, 1596}]}, 
    {Hue[
      NCache[
       Rational[28, 251], 0.11155378486055777`]], AbsoluteThickness[0.25], 
     LineBox[{1596, 1597}]}, 
    {Hue[
      NCache[
       Rational[1597, 14307], 0.11162368071573356`]], AbsoluteThickness[0.25],
      LineBox[{1597, 1598}]}, 
    {Hue[
      NCache[
       Rational[1598, 14307], 0.11169357657090935`]], AbsoluteThickness[0.25],
      LineBox[{1598, 1599}]}, 
    {Hue[
      NCache[
       Rational[533, 4769], 0.11176347242608513`]], AbsoluteThickness[0.25], 
     LineBox[{1599, 1600}]}, 
    {Hue[
      NCache[
       Rational[1600, 14307], 0.11183336828126092`]], AbsoluteThickness[0.25],
      LineBox[{1600, 1601}]}, 
    {Hue[
      NCache[
       Rational[1601, 14307], 0.11190326413643671`]], AbsoluteThickness[0.25],
      LineBox[{1601, 1602}]}, 
    {Hue[
      NCache[
       Rational[534, 4769], 0.1119731599916125]], AbsoluteThickness[0.25], 
     LineBox[{1602, 1603}]}, 
    {Hue[
      NCache[
       Rational[1603, 14307], 0.11204305584678828`]], AbsoluteThickness[0.25],
      LineBox[{1603, 1604}]}, 
    {Hue[
      NCache[
       Rational[1604, 14307], 0.11211295170196407`]], AbsoluteThickness[0.25],
      LineBox[{1604, 1605}]}, 
    {Hue[
      NCache[
       Rational[535, 4769], 0.11218284755713986`]], AbsoluteThickness[0.25], 
     LineBox[{1605, 1606}]}, 
    {Hue[
      NCache[
       Rational[1606, 14307], 0.11225274341231566`]], AbsoluteThickness[0.25],
      LineBox[{1606, 1607}]}, 
    {Hue[
      NCache[
       Rational[1607, 14307], 0.11232263926749143`]], AbsoluteThickness[0.25],
      LineBox[{1607, 1608}]}, 
    {Hue[
      NCache[
       Rational[536, 4769], 0.11239253512266723`]], AbsoluteThickness[0.25], 
     LineBox[{1608, 1609}]}, 
    {Hue[
      NCache[
       Rational[1609, 14307], 0.11246243097784302`]], AbsoluteThickness[0.25],
      LineBox[{1609, 1610}]}, 
    {Hue[
      NCache[
       Rational[1610, 14307], 0.11253232683301881`]], AbsoluteThickness[0.25],
      LineBox[{1610, 1611}]}, 
    {Hue[
      NCache[
       Rational[537, 4769], 0.11260222268819459`]], AbsoluteThickness[0.25], 
     LineBox[{1611, 1612}]}, 
    {Hue[
      NCache[
       Rational[1612, 14307], 0.11267211854337038`]], AbsoluteThickness[0.25],
      LineBox[{1612, 1613}]}, 
    {Hue[
      NCache[
       Rational[1613, 14307], 0.11274201439854617`]], AbsoluteThickness[0.25],
      LineBox[{1613, 1614}]}, 
    {Hue[
      NCache[
       Rational[538, 4769], 0.11281191025372195`]], AbsoluteThickness[0.25], 
     LineBox[{1614, 1615}]}, 
    {Hue[
      NCache[
       Rational[85, 753], 0.11288180610889774`]], AbsoluteThickness[0.25], 
     LineBox[{1615, 1616}]}, 
    {Hue[
      NCache[
       Rational[1616, 14307], 0.11295170196407353`]], AbsoluteThickness[0.25],
      LineBox[{1616, 1617}]}, 
    {Hue[
      NCache[
       Rational[539, 4769], 0.11302159781924932`]], AbsoluteThickness[0.25], 
     LineBox[{1617, 1618}]}, 
    {Hue[
      NCache[
       Rational[1618, 14307], 0.1130914936744251]], AbsoluteThickness[0.25], 
     LineBox[{1618, 1619}]}, 
    {Hue[
      NCache[
       Rational[1619, 14307], 0.11316138952960089`]], AbsoluteThickness[0.25],
      LineBox[{1619, 1620}]}, 
    {Hue[
      NCache[
       Rational[540, 4769], 0.11323128538477668`]], AbsoluteThickness[0.25], 
     LineBox[{1620, 1621}]}, 
    {Hue[
      NCache[
       Rational[1621, 14307], 0.11330118123995248`]], AbsoluteThickness[0.25],
      LineBox[{1621, 1622}]}, 
    {Hue[
      NCache[
       Rational[1622, 14307], 0.11337107709512825`]], AbsoluteThickness[0.25],
      LineBox[{1622, 1623}]}, 
    {Hue[
      NCache[
       Rational[541, 4769], 0.11344097295030404`]], AbsoluteThickness[0.25], 
     LineBox[{1623, 1624}]}, 
    {Hue[
      NCache[
       Rational[1624, 14307], 0.11351086880547984`]], AbsoluteThickness[0.25],
      LineBox[{1624, 1625}]}, 
    {Hue[
      NCache[
       Rational[1625, 14307], 0.11358076466065563`]], AbsoluteThickness[0.25],
      LineBox[{1625, 1626}]}, 
    {Hue[
      NCache[
       Rational[542, 4769], 0.1136506605158314]], AbsoluteThickness[0.25], 
     LineBox[{1626, 1627}]}, 
    {Hue[
      NCache[
       Rational[1627, 14307], 0.1137205563710072]], AbsoluteThickness[0.25], 
     LineBox[{1627, 1628}]}, 
    {Hue[
      NCache[
       Rational[1628, 14307], 0.11379045222618299`]], AbsoluteThickness[0.25],
      LineBox[{1628, 1629}]}, 
    {Hue[
      NCache[
       Rational[543, 4769], 0.11386034808135878`]], AbsoluteThickness[0.25], 
     LineBox[{1629, 1630}]}, 
    {Hue[
      NCache[
       Rational[1630, 14307], 0.11393024393653456`]], AbsoluteThickness[0.25],
      LineBox[{1630, 1631}]}, 
    {Hue[
      NCache[
       Rational[1631, 14307], 0.11400013979171035`]], AbsoluteThickness[0.25],
      LineBox[{1631, 1632}]}, 
    {Hue[
      NCache[
       Rational[544, 4769], 0.11407003564688614`]], AbsoluteThickness[0.25], 
     LineBox[{1632, 1633}]}, 
    {Hue[
      NCache[
       Rational[1633, 14307], 0.11413993150206193`]], AbsoluteThickness[0.25],
      LineBox[{1633, 1634}]}, 
    {Hue[
      NCache[
       Rational[86, 753], 0.11420982735723771`]], AbsoluteThickness[0.25], 
     LineBox[{1634, 1635}]}, 
    {Hue[
      NCache[
       Rational[545, 4769], 0.1142797232124135]], AbsoluteThickness[0.25], 
     LineBox[{1635, 1636}]}, 
    {Hue[
      NCache[
       Rational[1636, 14307], 0.1143496190675893]], AbsoluteThickness[0.25], 
     LineBox[{1636, 1637}]}, 
    {Hue[
      NCache[
       Rational[1637, 14307], 0.11441951492276509`]], AbsoluteThickness[0.25],
      LineBox[{1637, 1638}]}, 
    {Hue[
      NCache[
       Rational[546, 4769], 0.11448941077794086`]], AbsoluteThickness[0.25], 
     LineBox[{1638, 1639}]}, 
    {Hue[
      NCache[
       Rational[1639, 14307], 0.11455930663311666`]], AbsoluteThickness[0.25],
      LineBox[{1639, 1640}]}, 
    {Hue[
      NCache[
       Rational[1640, 14307], 0.11462920248829245`]], AbsoluteThickness[0.25],
      LineBox[{1640, 1641}]}, 
    {Hue[
      NCache[
       Rational[547, 4769], 0.11469909834346823`]], AbsoluteThickness[0.25], 
     LineBox[{1641, 1642}]}, 
    {Hue[
      NCache[
       Rational[1642, 14307], 0.11476899419864402`]], AbsoluteThickness[0.25],
      LineBox[{1642, 1643}]}, 
    {Hue[
      NCache[
       Rational[1643, 14307], 0.11483889005381981`]], AbsoluteThickness[0.25],
      LineBox[{1643, 1644}]}, 
    {Hue[
      NCache[
       Rational[548, 4769], 0.1149087859089956]], AbsoluteThickness[0.25], 
     LineBox[{1644, 1645}]}, 
    {Hue[
      NCache[
       Rational[1645, 14307], 0.11497868176417138`]], AbsoluteThickness[0.25],
      LineBox[{1645, 1646}]}, 
    {Hue[
      NCache[
       Rational[1646, 14307], 0.11504857761934717`]], AbsoluteThickness[0.25],
      LineBox[{1646, 1647}]}, 
    {Hue[
      NCache[
       Rational[549, 4769], 0.11511847347452296`]], AbsoluteThickness[0.25], 
     LineBox[{1647, 1648}]}, 
    {Hue[
      NCache[
       Rational[1648, 14307], 0.11518836932969875`]], AbsoluteThickness[0.25],
      LineBox[{1648, 1649}]}, 
    {Hue[
      NCache[
       Rational[1649, 14307], 0.11525826518487453`]], AbsoluteThickness[0.25],
      LineBox[{1649, 1650}]}, 
    {Hue[
      NCache[
       Rational[550, 4769], 0.11532816104005032`]], AbsoluteThickness[0.25], 
     LineBox[{1650, 1651}]}, 
    {Hue[
      NCache[
       Rational[1651, 14307], 0.11539805689522611`]], AbsoluteThickness[0.25],
      LineBox[{1651, 1652}]}, 
    {Hue[
      NCache[
       Rational[1652, 14307], 0.1154679527504019]], AbsoluteThickness[0.25], 
     LineBox[{1652, 1653}]}, 
    {Hue[
      NCache[
       Rational[29, 251], 0.11553784860557768`]], AbsoluteThickness[0.25], 
     LineBox[{1653, 1654}]}, 
    {Hue[
      NCache[
       Rational[1654, 14307], 0.11560774446075348`]], AbsoluteThickness[0.25],
      LineBox[{1654, 1655}]}, 
    {Hue[
      NCache[
       Rational[1655, 14307], 0.11567764031592927`]], AbsoluteThickness[0.25],
      LineBox[{1655, 1656}]}, 
    {Hue[
      NCache[
       Rational[552, 4769], 0.11574753617110506`]], AbsoluteThickness[0.25], 
     LineBox[{1656, 1657}]}, 
    {Hue[
      NCache[
       Rational[1657, 14307], 0.11581743202628084`]], AbsoluteThickness[0.25],
      LineBox[{1657, 1658}]}, 
    {Hue[
      NCache[
       Rational[1658, 14307], 0.11588732788145663`]], AbsoluteThickness[0.25],
      LineBox[{1658, 1659}]}, 
    {Hue[
      NCache[
       Rational[553, 4769], 0.11595722373663242`]], AbsoluteThickness[0.25], 
     LineBox[{1659, 1660}]}, 
    {Hue[
      NCache[
       Rational[1660, 14307], 0.11602711959180821`]], AbsoluteThickness[0.25],
      LineBox[{1660, 1661}]}, 
    {Hue[
      NCache[
       Rational[1661, 14307], 0.11609701544698399`]], AbsoluteThickness[0.25],
      LineBox[{1661, 1662}]}, 
    {Hue[
      NCache[
       Rational[554, 4769], 0.11616691130215978`]], AbsoluteThickness[0.25], 
     LineBox[{1662, 1663}]}, 
    {Hue[
      NCache[
       Rational[1663, 14307], 0.11623680715733557`]], AbsoluteThickness[0.25],
      LineBox[{1663, 1664}]}, 
    {Hue[
      NCache[
       Rational[1664, 14307], 0.11630670301251136`]], AbsoluteThickness[0.25],
      LineBox[{1664, 1665}]}, 
    {Hue[
      NCache[
       Rational[555, 4769], 0.11637659886768714`]], AbsoluteThickness[0.25], 
     LineBox[{1665, 1666}]}, 
    {Hue[
      NCache[
       Rational[1666, 14307], 0.11644649472286293`]], AbsoluteThickness[0.25],
      LineBox[{1666, 1667}]}, 
    {Hue[
      NCache[
       Rational[1667, 14307], 0.11651639057803873`]], AbsoluteThickness[0.25],
      LineBox[{1667, 1668}]}, 
    {Hue[
      NCache[
       Rational[556, 4769], 0.11658628643321452`]], AbsoluteThickness[0.25], 
     LineBox[{1668, 1669}]}, 
    {Hue[
      NCache[
       Rational[1669, 14307], 0.1166561822883903]], AbsoluteThickness[0.25], 
     LineBox[{1669, 1670}]}, 
    {Hue[
      NCache[
       Rational[1670, 14307], 0.11672607814356609`]], AbsoluteThickness[0.25],
      LineBox[{1670, 1671}]}, 
    {Hue[
      NCache[
       Rational[557, 4769], 0.11679597399874188`]], AbsoluteThickness[0.25], 
     LineBox[{1671, 1672}]}, 
    {Hue[
      NCache[
       Rational[88, 753], 0.11686586985391766`]], AbsoluteThickness[0.25], 
     LineBox[{1672, 1673}]}, 
    {Hue[
      NCache[
       Rational[1673, 14307], 0.11693576570909345`]], AbsoluteThickness[0.25],
      LineBox[{1673, 1674}]}, 
    {Hue[
      NCache[
       Rational[558, 4769], 0.11700566156426924`]], AbsoluteThickness[0.25], 
     LineBox[{1674, 1675}]}, 
    {Hue[
      NCache[
       Rational[1675, 14307], 0.11707555741944503`]], AbsoluteThickness[0.25],
      LineBox[{1675, 1676}]}, 
    {Hue[
      NCache[
       Rational[1676, 14307], 0.11714545327462081`]], AbsoluteThickness[0.25],
      LineBox[{1676, 1677}]}, 
    {Hue[
      NCache[
       Rational[559, 4769], 0.1172153491297966]], AbsoluteThickness[0.25], 
     LineBox[{1677, 1678}]}, 
    {Hue[
      NCache[
       Rational[1678, 14307], 0.11728524498497239`]], AbsoluteThickness[0.25],
      LineBox[{1678, 1679}]}, 
    {Hue[
      NCache[
       Rational[1679, 14307], 0.11735514084014818`]], AbsoluteThickness[0.25],
      LineBox[{1679, 1680}]}, 
    {Hue[
      NCache[
       Rational[560, 4769], 0.11742503669532396`]], AbsoluteThickness[0.25], 
     LineBox[{1680, 1681}]}, 
    {Hue[
      NCache[
       Rational[1681, 14307], 0.11749493255049975`]], AbsoluteThickness[0.25],
      LineBox[{1681, 1682}]}, 
    {Hue[
      NCache[
       Rational[1682, 14307], 0.11756482840567554`]], AbsoluteThickness[0.25],
      LineBox[{1682, 1683}]}, 
    {Hue[
      NCache[
       Rational[561, 4769], 0.11763472426085134`]], AbsoluteThickness[0.25], 
     LineBox[{1683, 1684}]}, 
    {Hue[
      NCache[
       Rational[1684, 14307], 0.11770462011602711`]], AbsoluteThickness[0.25],
      LineBox[{1684, 1685}]}, 
    {Hue[
      NCache[
       Rational[1685, 14307], 0.1177745159712029]], AbsoluteThickness[0.25], 
     LineBox[{1685, 1686}]}, 
    {Hue[
      NCache[
       Rational[562, 4769], 0.1178444118263787]], AbsoluteThickness[0.25], 
     LineBox[{1686, 1687}]}, 
    {Hue[
      NCache[
       Rational[1687, 14307], 0.11791430768155449`]], AbsoluteThickness[0.25],
      LineBox[{1687, 1688}]}, 
    {Hue[
      NCache[
       Rational[1688, 14307], 0.11798420353673027`]], AbsoluteThickness[0.25],
      LineBox[{1688, 1689}]}, 
    {Hue[
      NCache[
       Rational[563, 4769], 0.11805409939190606`]], AbsoluteThickness[0.25], 
     LineBox[{1689, 1690}]}, 
    {Hue[
      NCache[
       Rational[1690, 14307], 0.11812399524708185`]], AbsoluteThickness[0.25],
      LineBox[{1690, 1691}]}, 
    {Hue[
      NCache[
       Rational[89, 753], 0.11819389110225764`]], AbsoluteThickness[0.25], 
     LineBox[{1691, 1692}]}, 
    {Hue[
      NCache[
       Rational[564, 4769], 0.11826378695743342`]], AbsoluteThickness[0.25], 
     LineBox[{1692, 1693}]}, 
    {Hue[
      NCache[
       Rational[1693, 14307], 0.11833368281260921`]], AbsoluteThickness[0.25],
      LineBox[{1693, 1694}]}, 
    {Hue[
      NCache[
       Rational[1694, 14307], 0.118403578667785]], AbsoluteThickness[0.25], 
     LineBox[{1694, 1695}]}, 
    {Hue[
      NCache[
       Rational[565, 4769], 0.1184734745229608]], AbsoluteThickness[0.25], 
     LineBox[{1695, 1696}]}, 
    {Hue[
      NCache[
       Rational[1696, 14307], 0.11854337037813657`]], AbsoluteThickness[0.25],
      LineBox[{1696, 1697}]}, 
    {Hue[
      NCache[
       Rational[1697, 14307], 0.11861326623331236`]], AbsoluteThickness[0.25],
      LineBox[{1697, 1698}]}, 
    {Hue[
      NCache[
       Rational[566, 4769], 0.11868316208848816`]], AbsoluteThickness[0.25], 
     LineBox[{1698, 1699}]}, 
    {Hue[
      NCache[
       Rational[1699, 14307], 0.11875305794366393`]], AbsoluteThickness[0.25],
      LineBox[{1699, 1700}]}, 
    {Hue[
      NCache[
       Rational[1700, 14307], 0.11882295379883973`]], AbsoluteThickness[0.25],
      LineBox[{1700, 1701}]}, 
    {Hue[
      NCache[
       Rational[567, 4769], 0.11889284965401552`]], AbsoluteThickness[0.25], 
     LineBox[{1701, 1702}]}, 
    {Hue[
      NCache[
       Rational[1702, 14307], 0.11896274550919131`]], AbsoluteThickness[0.25],
      LineBox[{1702, 1703}]}, 
    {Hue[
      NCache[
       Rational[1703, 14307], 0.11903264136436709`]], AbsoluteThickness[0.25],
      LineBox[{1703, 1704}]}, 
    {Hue[
      NCache[
       Rational[568, 4769], 0.11910253721954288`]], AbsoluteThickness[0.25], 
     LineBox[{1704, 1705}]}, 
    {Hue[
      NCache[
       Rational[1705, 14307], 0.11917243307471867`]], AbsoluteThickness[0.25],
      LineBox[{1705, 1706}]}, 
    {Hue[
      NCache[
       Rational[1706, 14307], 0.11924232892989446`]], AbsoluteThickness[0.25],
      LineBox[{1706, 1707}]}, 
    {Hue[
      NCache[
       Rational[569, 4769], 0.11931222478507024`]], AbsoluteThickness[0.25], 
     LineBox[{1707, 1708}]}, 
    {Hue[
      NCache[
       Rational[1708, 14307], 0.11938212064024603`]], AbsoluteThickness[0.25],
      LineBox[{1708, 1709}]}, 
    {Hue[
      NCache[
       Rational[1709, 14307], 0.11945201649542182`]], AbsoluteThickness[0.25],
      LineBox[{1709, 1710}]}, 
    {Hue[
      NCache[
       Rational[30, 251], 0.11952191235059761`]], AbsoluteThickness[0.25], 
     LineBox[{1710, 1711}]}, 
    {Hue[
      NCache[
       Rational[1711, 14307], 0.11959180820577339`]], AbsoluteThickness[0.25],
      LineBox[{1711, 1712}]}, 
    {Hue[
      NCache[
       Rational[1712, 14307], 0.11966170406094918`]], AbsoluteThickness[0.25],
      LineBox[{1712, 1713}]}, 
    {Hue[
      NCache[
       Rational[571, 4769], 0.11973159991612498`]], AbsoluteThickness[0.25], 
     LineBox[{1713, 1714}]}, 
    {Hue[
      NCache[
       Rational[1714, 14307], 0.11980149577130077`]], AbsoluteThickness[0.25],
      LineBox[{1714, 1715}]}, 
    {Hue[
      NCache[
       Rational[1715, 14307], 0.11987139162647655`]], AbsoluteThickness[0.25],
      LineBox[{1715, 1716}]}, 
    {Hue[
      NCache[
       Rational[572, 4769], 0.11994128748165234`]], AbsoluteThickness[0.25], 
     LineBox[{1716, 1717}]}, 
    {Hue[
      NCache[
       Rational[1717, 14307], 0.12001118333682813`]], AbsoluteThickness[0.25],
      LineBox[{1717, 1718}]}, 
    {Hue[
      NCache[
       Rational[1718, 14307], 0.12008107919200392`]], AbsoluteThickness[0.25],
      LineBox[{1718, 1719}]}, 
    {Hue[
      NCache[
       Rational[573, 4769], 0.1201509750471797]], AbsoluteThickness[0.25], 
     LineBox[{1719, 1720}]}, 
    {Hue[
      NCache[
       Rational[1720, 14307], 0.12022087090235549`]], AbsoluteThickness[0.25],
      LineBox[{1720, 1721}]}, 
    {Hue[
      NCache[
       Rational[1721, 14307], 0.12029076675753128`]], AbsoluteThickness[0.25],
      LineBox[{1721, 1722}]}, 
    {Hue[
      NCache[
       Rational[574, 4769], 0.12036066261270707`]], AbsoluteThickness[0.25], 
     LineBox[{1722, 1723}]}, 
    {Hue[
      NCache[
       Rational[1723, 14307], 0.12043055846788285`]], AbsoluteThickness[0.25],
      LineBox[{1723, 1724}]}, 
    {Hue[
      NCache[
       Rational[1724, 14307], 0.12050045432305864`]], AbsoluteThickness[0.25],
      LineBox[{1724, 1725}]}, 
    {Hue[
      NCache[
       Rational[575, 4769], 0.12057035017823443`]], AbsoluteThickness[0.25], 
     LineBox[{1725, 1726}]}, 
    {Hue[
      NCache[
       Rational[1726, 14307], 0.12064024603341023`]], AbsoluteThickness[0.25],
      LineBox[{1726, 1727}]}, 
    {Hue[
      NCache[
       Rational[1727, 14307], 0.120710141888586]], AbsoluteThickness[0.25], 
     LineBox[{1727, 1728}]}, 
    {Hue[
      NCache[
       Rational[576, 4769], 0.1207800377437618]], AbsoluteThickness[0.25], 
     LineBox[{1728, 1729}]}, 
    {Hue[
      NCache[
       Rational[91, 753], 0.12084993359893759`]], AbsoluteThickness[0.25], 
     LineBox[{1729, 1730}]}, 
    {Hue[
      NCache[
       Rational[1730, 14307], 0.12091982945411336`]], AbsoluteThickness[0.25],
      LineBox[{1730, 1731}]}, 
    {Hue[
      NCache[
       Rational[577, 4769], 0.12098972530928916`]], AbsoluteThickness[0.25], 
     LineBox[{1731, 1732}]}, 
    {Hue[
      NCache[
       Rational[1732, 14307], 0.12105962116446495`]], AbsoluteThickness[0.25],
      LineBox[{1732, 1733}]}, 
    {Hue[
      NCache[
       Rational[1733, 14307], 0.12112951701964074`]], AbsoluteThickness[0.25],
      LineBox[{1733, 1734}]}, 
    {Hue[
      NCache[
       Rational[578, 4769], 0.12119941287481652`]], AbsoluteThickness[0.25], 
     LineBox[{1734, 1735}]}, 
    {Hue[
      NCache[
       Rational[1735, 14307], 0.12126930872999231`]], AbsoluteThickness[0.25],
      LineBox[{1735, 1736}]}, 
    {Hue[
      NCache[
       Rational[1736, 14307], 0.1213392045851681]], AbsoluteThickness[0.25], 
     LineBox[{1736, 1737}]}, 
    {Hue[
      NCache[
       Rational[579, 4769], 0.12140910044034389`]], AbsoluteThickness[0.25], 
     LineBox[{1737, 1738}]}, 
    {Hue[
      NCache[
       Rational[1738, 14307], 0.12147899629551967`]], AbsoluteThickness[0.25],
      LineBox[{1738, 1739}]}, 
    {Hue[
      NCache[
       Rational[1739, 14307], 0.12154889215069546`]], AbsoluteThickness[0.25],
      LineBox[{1739, 1740}]}, 
    {Hue[
      NCache[
       Rational[580, 4769], 0.12161878800587125`]], AbsoluteThickness[0.25], 
     LineBox[{1740, 1741}]}, 
    {Hue[
      NCache[
       Rational[1741, 14307], 0.12168868386104705`]], AbsoluteThickness[0.25],
      LineBox[{1741, 1742}]}, 
    {Hue[
      NCache[
       Rational[1742, 14307], 0.12175857971622282`]], AbsoluteThickness[0.25],
      LineBox[{1742, 1743}]}, 
    {Hue[
      NCache[
       Rational[581, 4769], 0.12182847557139861`]], AbsoluteThickness[0.25], 
     LineBox[{1743, 1744}]}, 
    {Hue[
      NCache[
       Rational[1744, 14307], 0.1218983714265744]], AbsoluteThickness[0.25], 
     LineBox[{1744, 1745}]}, 
    {Hue[
      NCache[
       Rational[1745, 14307], 0.1219682672817502]], AbsoluteThickness[0.25], 
     LineBox[{1745, 1746}]}, 
    {Hue[
      NCache[
       Rational[582, 4769], 0.12203816313692598`]], AbsoluteThickness[0.25], 
     LineBox[{1746, 1747}]}, 
    {Hue[
      NCache[
       Rational[1747, 14307], 0.12210805899210177`]], AbsoluteThickness[0.25],
      LineBox[{1747, 1748}]}, 
    {Hue[
      NCache[
       Rational[92, 753], 0.12217795484727756`]], AbsoluteThickness[0.25], 
     LineBox[{1748, 1749}]}, 
    {Hue[
      NCache[
       Rational[583, 4769], 0.12224785070245335`]], AbsoluteThickness[0.25], 
     LineBox[{1749, 1750}]}, 
    {Hue[
      NCache[
       Rational[1750, 14307], 0.12231774655762913`]], AbsoluteThickness[0.25],
      LineBox[{1750, 1751}]}, 
    {Hue[
      NCache[
       Rational[1751, 14307], 0.12238764241280492`]], AbsoluteThickness[0.25],
      LineBox[{1751, 1752}]}, 
    {Hue[
      NCache[
       Rational[584, 4769], 0.12245753826798071`]], AbsoluteThickness[0.25], 
     LineBox[{1752, 1753}]}, 
    {Hue[
      NCache[
       Rational[1753, 14307], 0.1225274341231565]], AbsoluteThickness[0.25], 
     LineBox[{1753, 1754}]}, 
    {Hue[
      NCache[
       Rational[1754, 14307], 0.12259732997833228`]], AbsoluteThickness[0.25],
      LineBox[{1754, 1755}]}, 
    {Hue[
      NCache[
       Rational[585, 4769], 0.12266722583350807`]], AbsoluteThickness[0.25], 
     LineBox[{1755, 1756}]}, 
    {Hue[
      NCache[
       Rational[1756, 14307], 0.12273712168868386`]], AbsoluteThickness[0.25],
      LineBox[{1756, 1757}]}, 
    {Hue[
      NCache[
       Rational[7, 57], 0.12280701754385964`]], AbsoluteThickness[0.25], 
     LineBox[{1757, 1758}]}, 
    {Hue[
      NCache[
       Rational[586, 4769], 0.12287691339903543`]], AbsoluteThickness[0.25], 
     LineBox[{1758, 1759}]}, 
    {Hue[
      NCache[
       Rational[1759, 14307], 0.12294680925421123`]], AbsoluteThickness[0.25],
      LineBox[{1759, 1760}]}, 
    {Hue[
      NCache[
       Rational[1760, 14307], 0.12301670510938702`]], AbsoluteThickness[0.25],
      LineBox[{1760, 1761}]}, 
    {Hue[
      NCache[
       Rational[587, 4769], 0.1230866009645628]], AbsoluteThickness[0.25], 
     LineBox[{1761, 1762}]}, 
    {Hue[
      NCache[
       Rational[1762, 14307], 0.12315649681973859`]], AbsoluteThickness[0.25],
      LineBox[{1762, 1763}]}, 
    {Hue[
      NCache[
       Rational[1763, 14307], 0.12322639267491438`]], AbsoluteThickness[0.25],
      LineBox[{1763, 1764}]}, 
    {Hue[
      NCache[
       Rational[588, 4769], 0.12329628853009017`]], AbsoluteThickness[0.25], 
     LineBox[{1764, 1765}]}, 
    {Hue[
      NCache[
       Rational[1765, 14307], 0.12336618438526595`]], AbsoluteThickness[0.25],
      LineBox[{1765, 1766}]}, 
    {Hue[
      NCache[
       Rational[1766, 14307], 0.12343608024044174`]], AbsoluteThickness[0.25],
      LineBox[{1766, 1767}]}, 
    {Hue[
      NCache[
       Rational[31, 251], 0.12350597609561753`]], AbsoluteThickness[0.25], 
     LineBox[{1767, 1768}]}, 
    {Hue[
      NCache[
       Rational[1768, 14307], 0.12357587195079332`]], AbsoluteThickness[0.25],
      LineBox[{1768, 1769}]}, 
    {Hue[
      NCache[
       Rational[1769, 14307], 0.1236457678059691]], AbsoluteThickness[0.25], 
     LineBox[{1769, 1770}]}, 
    {Hue[
      NCache[
       Rational[590, 4769], 0.12371566366114489`]], AbsoluteThickness[0.25], 
     LineBox[{1770, 1771}]}, 
    {Hue[
      NCache[
       Rational[1771, 14307], 0.12378555951632068`]], AbsoluteThickness[0.25],
      LineBox[{1771, 1772}]}, 
    {Hue[
      NCache[
       Rational[1772, 14307], 0.12385545537149648`]], AbsoluteThickness[0.25],
      LineBox[{1772, 1773}]}, 
    {Hue[
      NCache[
       Rational[591, 4769], 0.12392535122667225`]], AbsoluteThickness[0.25], 
     LineBox[{1773, 1774}]}, 
    {Hue[
      NCache[
       Rational[1774, 14307], 0.12399524708184805`]], AbsoluteThickness[0.25],
      LineBox[{1774, 1775}]}, 
    {Hue[
      NCache[
       Rational[1775, 14307], 0.12406514293702384`]], AbsoluteThickness[0.25],
      LineBox[{1775, 1776}]}, 
    {Hue[
      NCache[
       Rational[592, 4769], 0.12413503879219963`]], AbsoluteThickness[0.25], 
     LineBox[{1776, 1777}]}, 
    {Hue[
      NCache[
       Rational[1777, 14307], 0.1242049346473754]], AbsoluteThickness[0.25], 
     LineBox[{1777, 1778}]}, 
    {Hue[
      NCache[
       Rational[1778, 14307], 0.1242748305025512]], AbsoluteThickness[0.25], 
     LineBox[{1778, 1779}]}, 
    {Hue[
      NCache[
       Rational[593, 4769], 0.12434472635772699`]], AbsoluteThickness[0.25], 
     LineBox[{1779, 1780}]}, 
    {Hue[
      NCache[
       Rational[1780, 14307], 0.12441462221290278`]], AbsoluteThickness[0.25],
      LineBox[{1780, 1781}]}, 
    {Hue[
      NCache[
       Rational[1781, 14307], 0.12448451806807856`]], AbsoluteThickness[0.25],
      LineBox[{1781, 1782}]}, 
    {Hue[
      NCache[
       Rational[594, 4769], 0.12455441392325435`]], AbsoluteThickness[0.25], 
     LineBox[{1782, 1783}]}, 
    {Hue[
      NCache[
       Rational[1783, 14307], 0.12462430977843014`]], AbsoluteThickness[0.25],
      LineBox[{1783, 1784}]}, 
    {Hue[
      NCache[
       Rational[1784, 14307], 0.12469420563360593`]], AbsoluteThickness[0.25],
      LineBox[{1784, 1785}]}, 
    {Hue[
      NCache[
       Rational[595, 4769], 0.12476410148878171`]], AbsoluteThickness[0.25], 
     LineBox[{1785, 1786}]}, 
    {Hue[
      NCache[
       Rational[94, 753], 0.1248339973439575]], AbsoluteThickness[0.25], 
     LineBox[{1786, 1787}]}, 
    {Hue[
      NCache[
       Rational[1787, 14307], 0.1249038931991333]], AbsoluteThickness[0.25], 
     LineBox[{1787, 1788}]}, 
    {Hue[
      NCache[
       Rational[596, 4769], 0.12497378905430907`]], AbsoluteThickness[0.25], 
     LineBox[{1788, 1789}]}, 
    {Hue[
      NCache[
       Rational[1789, 14307], 0.12504368490948486`]], AbsoluteThickness[0.25],
      LineBox[{1789, 1790}]}, 
    {Hue[
      NCache[
       Rational[1790, 14307], 0.12511358076466064`]], AbsoluteThickness[0.25],
      LineBox[{1790, 1791}]}, 
    {Hue[
      NCache[
       Rational[597, 4769], 0.12518347661983645`]], AbsoluteThickness[0.25], 
     LineBox[{1791, 1792}]}, 
    {Hue[
      NCache[
       Rational[1792, 14307], 0.12525337247501223`]], AbsoluteThickness[0.25],
      LineBox[{1792, 1793}]}, 
    {Hue[
      NCache[
       Rational[1793, 14307], 0.12532326833018803`]], AbsoluteThickness[0.25],
      LineBox[{1793, 1794}]}, 
    {Hue[
      NCache[
       Rational[598, 4769], 0.1253931641853638]], AbsoluteThickness[0.25], 
     LineBox[{1794, 1795}]}, 
    {Hue[
      NCache[
       Rational[1795, 14307], 0.1254630600405396]], AbsoluteThickness[0.25], 
     LineBox[{1795, 1796}]}, 
    {Hue[
      NCache[
       Rational[1796, 14307], 0.1255329558957154]], AbsoluteThickness[0.25], 
     LineBox[{1796, 1797}]}, 
    {Hue[
      NCache[
       Rational[599, 4769], 0.12560285175089117`]], AbsoluteThickness[0.25], 
     LineBox[{1797, 1798}]}, 
    {Hue[
      NCache[
       Rational[1798, 14307], 0.12567274760606695`]], AbsoluteThickness[0.25],
      LineBox[{1798, 1799}]}, 
    {Hue[
      NCache[
       Rational[1799, 14307], 0.12574264346124275`]], AbsoluteThickness[0.25],
      LineBox[{1799, 1800}]}, 
    {Hue[
      NCache[
       Rational[600, 4769], 0.12581253931641853`]], AbsoluteThickness[0.25], 
     LineBox[{1800, 1801}]}, 
    {Hue[
      NCache[
       Rational[1801, 14307], 0.12588243517159434`]], AbsoluteThickness[0.25],
      LineBox[{1801, 1802}]}, 
    {Hue[
      NCache[
       Rational[1802, 14307], 0.12595233102677011`]], AbsoluteThickness[0.25],
      LineBox[{1802, 1803}]}, 
    {Hue[
      NCache[
       Rational[601, 4769], 0.1260222268819459]], AbsoluteThickness[0.25], 
     LineBox[{1803, 1804}]}, 
    {Hue[
      NCache[
       Rational[1804, 14307], 0.1260921227371217]], AbsoluteThickness[0.25], 
     LineBox[{1804, 1805}]}, 
    {Hue[
      NCache[
       Rational[95, 753], 0.12616201859229748`]], AbsoluteThickness[0.25], 
     LineBox[{1805, 1806}]}, 
    {Hue[
      NCache[
       Rational[602, 4769], 0.12623191444747325`]], AbsoluteThickness[0.25], 
     LineBox[{1806, 1807}]}, 
    {Hue[
      NCache[
       Rational[1807, 14307], 0.12630181030264906`]], AbsoluteThickness[0.25],
      LineBox[{1807, 1808}]}, 
    {Hue[
      NCache[
       Rational[1808, 14307], 0.12637170615782484`]], AbsoluteThickness[0.25],
      LineBox[{1808, 1809}]}, 
    {Hue[
      NCache[
       Rational[603, 4769], 0.12644160201300064`]], AbsoluteThickness[0.25], 
     LineBox[{1809, 1810}]}, 
    {Hue[
      NCache[
       Rational[1810, 14307], 0.12651149786817642`]], AbsoluteThickness[0.25],
      LineBox[{1810, 1811}]}, 
    {Hue[
      NCache[
       Rational[1811, 14307], 0.1265813937233522]], AbsoluteThickness[0.25], 
     LineBox[{1811, 1812}]}, 
    {Hue[
      NCache[
       Rational[604, 4769], 0.126651289578528]], AbsoluteThickness[0.25], 
     LineBox[{1812, 1813}]}, 
    {Hue[
      NCache[
       Rational[1813, 14307], 0.12672118543370378`]], AbsoluteThickness[0.25],
      LineBox[{1813, 1814}]}, 
    {Hue[
      NCache[
       Rational[1814, 14307], 0.12679108128887956`]], AbsoluteThickness[0.25],
      LineBox[{1814, 1815}]}, 
    {Hue[
      NCache[
       Rational[605, 4769], 0.12686097714405536`]], AbsoluteThickness[0.25], 
     LineBox[{1815, 1816}]}, 
    {Hue[
      NCache[
       Rational[1816, 14307], 0.12693087299923114`]], AbsoluteThickness[0.25],
      LineBox[{1816, 1817}]}, 
    {Hue[
      NCache[
       Rational[1817, 14307], 0.12700076885440692`]], AbsoluteThickness[0.25],
      LineBox[{1817, 1818}]}, 
    {Hue[
      NCache[
       Rational[606, 4769], 0.12707066470958273`]], AbsoluteThickness[0.25], 
     LineBox[{1818, 1819}]}, 
    {Hue[
      NCache[
       Rational[1819, 14307], 0.1271405605647585]], AbsoluteThickness[0.25], 
     LineBox[{1819, 1820}]}, 
    {Hue[
      NCache[
       Rational[1820, 14307], 0.1272104564199343]], AbsoluteThickness[0.25], 
     LineBox[{1820, 1821}]}, 
    {Hue[
      NCache[
       Rational[607, 4769], 0.1272803522751101]], AbsoluteThickness[0.25], 
     LineBox[{1821, 1822}]}, 
    {Hue[
      NCache[
       Rational[1822, 14307], 0.12735024813028586`]], AbsoluteThickness[0.25],
      LineBox[{1822, 1823}]}, 
    {Hue[
      NCache[
       Rational[1823, 14307], 0.12742014398546167`]], AbsoluteThickness[0.25],
      LineBox[{1823, 1824}]}, 
    {Hue[
      NCache[
       Rational[32, 251], 0.12749003984063745`]], AbsoluteThickness[0.25], 
     LineBox[{1824, 1825}]}, 
    {Hue[
      NCache[
       Rational[1825, 14307], 0.12755993569581323`]], AbsoluteThickness[0.25],
      LineBox[{1825, 1826}]}, 
    {Hue[
      NCache[
       Rational[1826, 14307], 0.12762983155098903`]], AbsoluteThickness[0.25],
      LineBox[{1826, 1827}]}, 
    {Hue[
      NCache[
       Rational[609, 4769], 0.1276997274061648]], AbsoluteThickness[0.25], 
     LineBox[{1827, 1828}]}, 
    {Hue[
      NCache[
       Rational[1828, 14307], 0.12776962326134061`]], AbsoluteThickness[0.25],
      LineBox[{1828, 1829}]}, 
    {Hue[
      NCache[
       Rational[1829, 14307], 0.1278395191165164]], AbsoluteThickness[0.25], 
     LineBox[{1829, 1830}]}, 
    {Hue[
      NCache[
       Rational[610, 4769], 0.12790941497169217`]], AbsoluteThickness[0.25], 
     LineBox[{1830, 1831}]}, 
    {Hue[
      NCache[
       Rational[1831, 14307], 0.12797931082686798`]], AbsoluteThickness[0.25],
      LineBox[{1831, 1832}]}, 
    {Hue[
      NCache[
       Rational[1832, 14307], 0.12804920668204375`]], AbsoluteThickness[0.25],
      LineBox[{1832, 1833}]}, 
    {Hue[
      NCache[
       Rational[611, 4769], 0.12811910253721953`]], AbsoluteThickness[0.25], 
     LineBox[{1833, 1834}]}, 
    {Hue[
      NCache[
       Rational[1834, 14307], 0.12818899839239534`]], AbsoluteThickness[0.25],
      LineBox[{1834, 1835}]}, 
    {Hue[
      NCache[
       Rational[1835, 14307], 0.12825889424757111`]], AbsoluteThickness[0.25],
      LineBox[{1835, 1836}]}, 
    {Hue[
      NCache[
       Rational[612, 4769], 0.12832879010274692`]], AbsoluteThickness[0.25], 
     LineBox[{1836, 1837}]}, 
    {Hue[
      NCache[
       Rational[1837, 14307], 0.1283986859579227]], AbsoluteThickness[0.25], 
     LineBox[{1837, 1838}]}, 
    {Hue[
      NCache[
       Rational[1838, 14307], 0.12846858181309848`]], AbsoluteThickness[0.25],
      LineBox[{1838, 1839}]}, 
    {Hue[
      NCache[
       Rational[613, 4769], 0.12853847766827428`]], AbsoluteThickness[0.25], 
     LineBox[{1839, 1840}]}, 
    {Hue[
      NCache[
       Rational[1840, 14307], 0.12860837352345006`]], AbsoluteThickness[0.25],
      LineBox[{1840, 1841}]}, 
    {Hue[
      NCache[
       Rational[1841, 14307], 0.12867826937862584`]], AbsoluteThickness[0.25],
      LineBox[{1841, 1842}]}, 
    {Hue[
      NCache[
       Rational[614, 4769], 0.12874816523380164`]], AbsoluteThickness[0.25], 
     LineBox[{1842, 1843}]}, 
    {Hue[
      NCache[
       Rational[97, 753], 0.12881806108897742`]], AbsoluteThickness[0.25], 
     LineBox[{1843, 1844}]}, 
    {Hue[
      NCache[
       Rational[1844, 14307], 0.1288879569441532]], AbsoluteThickness[0.25], 
     LineBox[{1844, 1845}]}, 
    {Hue[
      NCache[
       Rational[615, 4769], 0.128957852799329]], AbsoluteThickness[0.25], 
     LineBox[{1845, 1846}]}, 
    {Hue[
      NCache[
       Rational[1846, 14307], 0.12902774865450478`]], AbsoluteThickness[0.25],
      LineBox[{1846, 1847}]}, 
    {Hue[
      NCache[
       Rational[1847, 14307], 0.1290976445096806]], AbsoluteThickness[0.25], 
     LineBox[{1847, 1848}]}, 
    {Hue[
      NCache[
       Rational[616, 4769], 0.12916754036485636`]], AbsoluteThickness[0.25], 
     LineBox[{1848, 1849}]}, 
    {Hue[
      NCache[
       Rational[1849, 14307], 0.12923743622003214`]], AbsoluteThickness[0.25],
      LineBox[{1849, 1850}]}, 
    {Hue[
      NCache[
       Rational[1850, 14307], 0.12930733207520795`]], AbsoluteThickness[0.25],
      LineBox[{1850, 1851}]}, 
    {Hue[
      NCache[
       Rational[617, 4769], 0.12937722793038373`]], AbsoluteThickness[0.25], 
     LineBox[{1851, 1852}]}, 
    {Hue[
      NCache[
       Rational[1852, 14307], 0.1294471237855595]], AbsoluteThickness[0.25], 
     LineBox[{1852, 1853}]}, 
    {Hue[
      NCache[
       Rational[1853, 14307], 0.1295170196407353]], AbsoluteThickness[0.25], 
     LineBox[{1853, 1854}]}, 
    {Hue[
      NCache[
       Rational[618, 4769], 0.1295869154959111]], AbsoluteThickness[0.25], 
     LineBox[{1854, 1855}]}, 
    {Hue[
      NCache[
       Rational[1855, 14307], 0.1296568113510869]], AbsoluteThickness[0.25], 
     LineBox[{1855, 1856}]}, 
    {Hue[
      NCache[
       Rational[1856, 14307], 0.12972670720626267`]], AbsoluteThickness[0.25],
      LineBox[{1856, 1857}]}, 
    {Hue[
      NCache[
       Rational[619, 4769], 0.12979660306143845`]], AbsoluteThickness[0.25], 
     LineBox[{1857, 1858}]}, 
    {Hue[
      NCache[
       Rational[1858, 14307], 0.12986649891661425`]], AbsoluteThickness[0.25],
      LineBox[{1858, 1859}]}, 
    {Hue[
      NCache[
       Rational[1859, 14307], 0.12993639477179003`]], AbsoluteThickness[0.25],
      LineBox[{1859, 1860}]}, 
    {Hue[
      NCache[
       Rational[620, 4769], 0.1300062906269658]], AbsoluteThickness[0.25], 
     LineBox[{1860, 1861}]}, 
    {Hue[
      NCache[
       Rational[1861, 14307], 0.13007618648214161`]], AbsoluteThickness[0.25],
      LineBox[{1861, 1862}]}, 
    {Hue[
      NCache[
       Rational[98, 753], 0.1301460823373174]], AbsoluteThickness[0.25], 
     LineBox[{1862, 1863}]}, 
    {Hue[
      NCache[
       Rational[621, 4769], 0.1302159781924932]], AbsoluteThickness[0.25], 
     LineBox[{1863, 1864}]}, 
    {Hue[
      NCache[
       Rational[1864, 14307], 0.13028587404766898`]], AbsoluteThickness[0.25],
      LineBox[{1864, 1865}]}, 
    {Hue[
      NCache[
       Rational[1865, 14307], 0.13035576990284475`]], AbsoluteThickness[0.25],
      LineBox[{1865, 1866}]}, 
    {Hue[
      NCache[
       Rational[622, 4769], 0.13042566575802056`]], AbsoluteThickness[0.25], 
     LineBox[{1866, 1867}]}, 
    {Hue[
      NCache[
       Rational[1867, 14307], 0.13049556161319634`]], AbsoluteThickness[0.25],
      LineBox[{1867, 1868}]}, 
    {Hue[
      NCache[
       Rational[1868, 14307], 0.13056545746837211`]], AbsoluteThickness[0.25],
      LineBox[{1868, 1869}]}, 
    {Hue[
      NCache[
       Rational[623, 4769], 0.13063535332354792`]], AbsoluteThickness[0.25], 
     LineBox[{1869, 1870}]}, 
    {Hue[
      NCache[
       Rational[1870, 14307], 0.1307052491787237]], AbsoluteThickness[0.25], 
     LineBox[{1870, 1871}]}, 
    {Hue[
      NCache[
       Rational[1871, 14307], 0.1307751450338995]], AbsoluteThickness[0.25], 
     LineBox[{1871, 1872}]}, 
    {Hue[
      NCache[
       Rational[624, 4769], 0.13084504088907528`]], AbsoluteThickness[0.25], 
     LineBox[{1872, 1873}]}, 
    {Hue[
      NCache[
       Rational[1873, 14307], 0.13091493674425106`]], AbsoluteThickness[0.25],
      LineBox[{1873, 1874}]}, 
    {Hue[
      NCache[
       Rational[1874, 14307], 0.13098483259942686`]], AbsoluteThickness[0.25],
      LineBox[{1874, 1875}]}, 
    {Hue[
      NCache[
       Rational[625, 4769], 0.13105472845460264`]], AbsoluteThickness[0.25], 
     LineBox[{1875, 1876}]}, 
    {Hue[
      NCache[
       Rational[1876, 14307], 0.13112462430977842`]], AbsoluteThickness[0.25],
      LineBox[{1876, 1877}]}, 
    {Hue[
      NCache[
       Rational[1877, 14307], 0.13119452016495423`]], AbsoluteThickness[0.25],
      LineBox[{1877, 1878}]}, 
    {Hue[
      NCache[
       Rational[626, 4769], 0.13126441602013]], AbsoluteThickness[0.25], 
     LineBox[{1878, 1879}]}, 
    {Hue[
      NCache[
       Rational[1879, 14307], 0.13133431187530578`]], AbsoluteThickness[0.25],
      LineBox[{1879, 1880}]}, 
    {Hue[
      NCache[
       Rational[1880, 14307], 0.1314042077304816]], AbsoluteThickness[0.25], 
     LineBox[{1880, 1881}]}, 
    {Hue[
      NCache[
       Rational[33, 251], 0.13147410358565736`]], AbsoluteThickness[0.25], 
     LineBox[{1881, 1882}]}, 
    {Hue[
      NCache[
       Rational[1882, 14307], 0.13154399944083317`]], AbsoluteThickness[0.25],
      LineBox[{1882, 1883}]}, 
    {Hue[
      NCache[
       Rational[1883, 14307], 0.13161389529600895`]], AbsoluteThickness[0.25],
      LineBox[{1883, 1884}]}, 
    {Hue[
      NCache[
       Rational[628, 4769], 0.13168379115118473`]], AbsoluteThickness[0.25], 
     LineBox[{1884, 1885}]}, 
    {Hue[
      NCache[
       Rational[1885, 14307], 0.13175368700636053`]], AbsoluteThickness[0.25],
      LineBox[{1885, 1886}]}, 
    {Hue[
      NCache[
       Rational[1886, 14307], 0.1318235828615363]], AbsoluteThickness[0.25], 
     LineBox[{1886, 1887}]}, 
    {Hue[
      NCache[
       Rational[629, 4769], 0.1318934787167121]], AbsoluteThickness[0.25], 
     LineBox[{1887, 1888}]}, 
    {Hue[
      NCache[
       Rational[1888, 14307], 0.1319633745718879]], AbsoluteThickness[0.25], 
     LineBox[{1888, 1889}]}, 
    {Hue[
      NCache[
       Rational[1889, 14307], 0.13203327042706367`]], AbsoluteThickness[0.25],
      LineBox[{1889, 1890}]}, 
    {Hue[
      NCache[
       Rational[630, 4769], 0.13210316628223948`]], AbsoluteThickness[0.25], 
     LineBox[{1890, 1891}]}, 
    {Hue[
      NCache[
       Rational[1891, 14307], 0.13217306213741525`]], AbsoluteThickness[0.25],
      LineBox[{1891, 1892}]}, 
    {Hue[
      NCache[
       Rational[1892, 14307], 0.13224295799259103`]], AbsoluteThickness[0.25],
      LineBox[{1892, 1893}]}, 
    {Hue[
      NCache[
       Rational[631, 4769], 0.13231285384776684`]], AbsoluteThickness[0.25], 
     LineBox[{1893, 1894}]}, 
    {Hue[
      NCache[
       Rational[1894, 14307], 0.13238274970294261`]], AbsoluteThickness[0.25],
      LineBox[{1894, 1895}]}, 
    {Hue[
      NCache[
       Rational[1895, 14307], 0.1324526455581184]], AbsoluteThickness[0.25], 
     LineBox[{1895, 1896}]}, 
    {Hue[
      NCache[
       Rational[632, 4769], 0.1325225414132942]], AbsoluteThickness[0.25], 
     LineBox[{1896, 1897}]}, 
    {Hue[
      NCache[
       Rational[1897, 14307], 0.13259243726846998`]], AbsoluteThickness[0.25],
      LineBox[{1897, 1898}]}, 
    {Hue[
      NCache[
       Rational[1898, 14307], 0.13266233312364578`]], AbsoluteThickness[0.25],
      LineBox[{1898, 1899}]}, 
    {Hue[
      NCache[
       Rational[633, 4769], 0.13273222897882156`]], AbsoluteThickness[0.25], 
     LineBox[{1899, 1900}]}, 
    {Hue[
      NCache[
       Rational[100, 753], 0.13280212483399734`]], AbsoluteThickness[0.25], 
     LineBox[{1900, 1901}]}, 
    {Hue[
      NCache[
       Rational[1901, 14307], 0.13287202068917314`]], AbsoluteThickness[0.25],
      LineBox[{1901, 1902}]}, 
    {Hue[
      NCache[
       Rational[634, 4769], 0.13294191654434892`]], AbsoluteThickness[0.25], 
     LineBox[{1902, 1903}]}, 
    {Hue[
      NCache[
       Rational[1903, 14307], 0.1330118123995247]], AbsoluteThickness[0.25], 
     LineBox[{1903, 1904}]}, 
    {Hue[
      NCache[
       Rational[1904, 14307], 0.1330817082547005]], AbsoluteThickness[0.25], 
     LineBox[{1904, 1905}]}, 
    {Hue[
      NCache[
       Rational[635, 4769], 0.13315160410987628`]], AbsoluteThickness[0.25], 
     LineBox[{1905, 1906}]}, 
    {Hue[
      NCache[
       Rational[1906, 14307], 0.13322149996505206`]], AbsoluteThickness[0.25],
      LineBox[{1906, 1907}]}, 
    {Hue[
      NCache[
       Rational[1907, 14307], 0.13329139582022786`]], AbsoluteThickness[0.25],
      LineBox[{1907, 1908}]}, 
    {Hue[
      NCache[
       Rational[636, 4769], 0.13336129167540364`]], AbsoluteThickness[0.25], 
     LineBox[{1908, 1909}]}, 
    {Hue[
      NCache[
       Rational[1909, 14307], 0.13343118753057945`]], AbsoluteThickness[0.25],
      LineBox[{1909, 1910}]}, 
    {Hue[
      NCache[
       Rational[1910, 14307], 0.13350108338575523`]], AbsoluteThickness[0.25],
      LineBox[{1910, 1911}]}, 
    {Hue[
      NCache[
       Rational[637, 4769], 0.133570979240931]], AbsoluteThickness[0.25], 
     LineBox[{1911, 1912}]}, 
    {Hue[
      NCache[
       Rational[1912, 14307], 0.1336408750961068]], AbsoluteThickness[0.25], 
     LineBox[{1912, 1913}]}, 
    {Hue[
      NCache[
       Rational[1913, 14307], 0.1337107709512826]], AbsoluteThickness[0.25], 
     LineBox[{1913, 1914}]}, 
    {Hue[
      NCache[
       Rational[638, 4769], 0.13378066680645836`]], AbsoluteThickness[0.25], 
     LineBox[{1914, 1915}]}, 
    {Hue[
      NCache[
       Rational[1915, 14307], 0.13385056266163417`]], AbsoluteThickness[0.25],
      LineBox[{1915, 1916}]}, 
    {Hue[
      NCache[
       Rational[1916, 14307], 0.13392045851680995`]], AbsoluteThickness[0.25],
      LineBox[{1916, 1917}]}, 
    {Hue[
      NCache[
       Rational[639, 4769], 0.13399035437198575`]], AbsoluteThickness[0.25], 
     LineBox[{1917, 1918}]}, 
    {Hue[
      NCache[
       Rational[1918, 14307], 0.13406025022716153`]], AbsoluteThickness[0.25],
      LineBox[{1918, 1919}]}, 
    {Hue[
      NCache[
       Rational[101, 753], 0.1341301460823373]], AbsoluteThickness[0.25], 
     LineBox[{1919, 1920}]}, 
    {Hue[
      NCache[
       Rational[640, 4769], 0.13420004193751311`]], AbsoluteThickness[0.25], 
     LineBox[{1920, 1921}]}, 
    {Hue[
      NCache[
       Rational[1921, 14307], 0.1342699377926889]], AbsoluteThickness[0.25], 
     LineBox[{1921, 1922}]}, 
    {Hue[
      NCache[
       Rational[1922, 14307], 0.13433983364786467`]], AbsoluteThickness[0.25],
      LineBox[{1922, 1923}]}, 
    {Hue[
      NCache[
       Rational[641, 4769], 0.13440972950304048`]], AbsoluteThickness[0.25], 
     LineBox[{1923, 1924}]}, 
    {Hue[
      NCache[
       Rational[1924, 14307], 0.13447962535821625`]], AbsoluteThickness[0.25],
      LineBox[{1924, 1925}]}, 
    {Hue[
      NCache[
       Rational[1925, 14307], 0.13454952121339206`]], AbsoluteThickness[0.25],
      LineBox[{1925, 1926}]}, 
    {Hue[
      NCache[
       Rational[642, 4769], 0.13461941706856784`]], AbsoluteThickness[0.25], 
     LineBox[{1926, 1927}]}, 
    {Hue[
      NCache[
       Rational[1927, 14307], 0.13468931292374361`]], AbsoluteThickness[0.25],
      LineBox[{1927, 1928}]}, 
    {Hue[
      NCache[
       Rational[1928, 14307], 0.13475920877891942`]], AbsoluteThickness[0.25],
      LineBox[{1928, 1929}]}, 
    {Hue[
      NCache[
       Rational[643, 4769], 0.1348291046340952]], AbsoluteThickness[0.25], 
     LineBox[{1929, 1930}]}, 
    {Hue[
      NCache[
       Rational[1930, 14307], 0.13489900048927098`]], AbsoluteThickness[0.25],
      LineBox[{1930, 1931}]}, 
    {Hue[
      NCache[
       Rational[1931, 14307], 0.13496889634444678`]], AbsoluteThickness[0.25],
      LineBox[{1931, 1932}]}, 
    {Hue[
      NCache[
       Rational[644, 4769], 0.13503879219962256`]], AbsoluteThickness[0.25], 
     LineBox[{1932, 1933}]}, 
    {Hue[
      NCache[
       Rational[1933, 14307], 0.13510868805479834`]], AbsoluteThickness[0.25],
      LineBox[{1933, 1934}]}, 
    {Hue[
      NCache[
       Rational[1934, 14307], 0.13517858390997414`]], AbsoluteThickness[0.25],
      LineBox[{1934, 1935}]}, 
    {Hue[
      NCache[
       Rational[645, 4769], 0.13524847976514992`]], AbsoluteThickness[0.25], 
     LineBox[{1935, 1936}]}, 
    {Hue[
      NCache[
       Rational[1936, 14307], 0.13531837562032573`]], AbsoluteThickness[0.25],
      LineBox[{1936, 1937}]}, 
    {Hue[
      NCache[
       Rational[1937, 14307], 0.1353882714755015]], AbsoluteThickness[0.25], 
     LineBox[{1937, 1938}]}, 
    {Hue[
      NCache[
       Rational[34, 251], 0.13545816733067728`]], AbsoluteThickness[0.25], 
     LineBox[{1938, 1939}]}, 
    {Hue[
      NCache[
       Rational[1939, 14307], 0.1355280631858531]], AbsoluteThickness[0.25], 
     LineBox[{1939, 1940}]}, 
    {Hue[
      NCache[
       Rational[1940, 14307], 0.13559795904102886`]], AbsoluteThickness[0.25],
      LineBox[{1940, 1941}]}, 
    {Hue[
      NCache[
       Rational[647, 4769], 0.13566785489620464`]], AbsoluteThickness[0.25], 
     LineBox[{1941, 1942}]}, 
    {Hue[
      NCache[
       Rational[1942, 14307], 0.13573775075138045`]], AbsoluteThickness[0.25],
      LineBox[{1942, 1943}]}, 
    {Hue[
      NCache[
       Rational[1943, 14307], 0.13580764660655623`]], AbsoluteThickness[0.25],
      LineBox[{1943, 1944}]}, 
    {Hue[
      NCache[
       Rational[648, 4769], 0.13587754246173203`]], AbsoluteThickness[0.25], 
     LineBox[{1944, 1945}]}, 
    {Hue[
      NCache[
       Rational[1945, 14307], 0.1359474383169078]], AbsoluteThickness[0.25], 
     LineBox[{1945, 1946}]}, 
    {Hue[
      NCache[
       Rational[1946, 14307], 0.1360173341720836]], AbsoluteThickness[0.25], 
     LineBox[{1946, 1947}]}, 
    {Hue[
      NCache[
       Rational[649, 4769], 0.1360872300272594]], AbsoluteThickness[0.25], 
     LineBox[{1947, 1948}]}, 
    {Hue[
      NCache[
       Rational[1948, 14307], 0.13615712588243517`]], AbsoluteThickness[0.25],
      LineBox[{1948, 1949}]}, 
    {Hue[
      NCache[
       Rational[1949, 14307], 0.13622702173761095`]], AbsoluteThickness[0.25],
      LineBox[{1949, 1950}]}, 
    {Hue[
      NCache[
       Rational[650, 4769], 0.13629691759278675`]], AbsoluteThickness[0.25], 
     LineBox[{1950, 1951}]}, 
    {Hue[
      NCache[
       Rational[1951, 14307], 0.13636681344796253`]], AbsoluteThickness[0.25],
      LineBox[{1951, 1952}]}, 
    {Hue[
      NCache[
       Rational[1952, 14307], 0.13643670930313834`]], AbsoluteThickness[0.25],
      LineBox[{1952, 1953}]}, 
    {Hue[
      NCache[
       Rational[651, 4769], 0.13650660515831411`]], AbsoluteThickness[0.25], 
     LineBox[{1953, 1954}]}, 
    {Hue[
      NCache[
       Rational[1954, 14307], 0.1365765010134899]], AbsoluteThickness[0.25], 
     LineBox[{1954, 1955}]}, 
    {Hue[
      NCache[
       Rational[1955, 14307], 0.1366463968686657]], AbsoluteThickness[0.25], 
     LineBox[{1955, 1956}]}, 
    {Hue[
      NCache[
       Rational[652, 4769], 0.13671629272384148`]], AbsoluteThickness[0.25], 
     LineBox[{1956, 1957}]}, 
    {Hue[
      NCache[
       Rational[103, 753], 0.13678618857901725`]], AbsoluteThickness[0.25], 
     LineBox[{1957, 1958}]}, 
    {Hue[
      NCache[
       Rational[1958, 14307], 0.13685608443419306`]], AbsoluteThickness[0.25],
      LineBox[{1958, 1959}]}, 
    {Hue[
      NCache[
       Rational[653, 4769], 0.13692598028936884`]], AbsoluteThickness[0.25], 
     LineBox[{1959, 1960}]}, 
    {Hue[
      NCache[
       Rational[1960, 14307], 0.13699587614454461`]], AbsoluteThickness[0.25],
      LineBox[{1960, 1961}]}, 
    {Hue[
      NCache[
       Rational[1961, 14307], 0.13706577199972042`]], AbsoluteThickness[0.25],
      LineBox[{1961, 1962}]}, 
    {Hue[
      NCache[
       Rational[654, 4769], 0.1371356678548962]], AbsoluteThickness[0.25], 
     LineBox[{1962, 1963}]}, 
    {Hue[
      NCache[
       Rational[1963, 14307], 0.137205563710072]], AbsoluteThickness[0.25], 
     LineBox[{1963, 1964}]}, 
    {Hue[
      NCache[
       Rational[1964, 14307], 0.13727545956524778`]], AbsoluteThickness[0.25],
      LineBox[{1964, 1965}]}, 
    {Hue[
      NCache[
       Rational[655, 4769], 0.13734535542042356`]], AbsoluteThickness[0.25], 
     LineBox[{1965, 1966}]}, 
    {Hue[
      NCache[
       Rational[1966, 14307], 0.13741525127559936`]], AbsoluteThickness[0.25],
      LineBox[{1966, 1967}]}, 
    {Hue[
      NCache[
       Rational[1967, 14307], 0.13748514713077514`]], AbsoluteThickness[0.25],
      LineBox[{1967, 1968}]}, 
    {Hue[
      NCache[
       Rational[656, 4769], 0.13755504298595092`]], AbsoluteThickness[0.25], 
     LineBox[{1968, 1969}]}, 
    {Hue[
      NCache[
       Rational[1969, 14307], 0.13762493884112673`]], AbsoluteThickness[0.25],
      LineBox[{1969, 1970}]}, 
    {Hue[
      NCache[
       Rational[1970, 14307], 0.1376948346963025]], AbsoluteThickness[0.25], 
     LineBox[{1970, 1971}]}, 
    {Hue[
      NCache[
       Rational[657, 4769], 0.1377647305514783]], AbsoluteThickness[0.25], 
     LineBox[{1971, 1972}]}, 
    {Hue[
      NCache[
       Rational[1972, 14307], 0.1378346264066541]], AbsoluteThickness[0.25], 
     LineBox[{1972, 1973}]}, 
    {Hue[
      NCache[
       Rational[1973, 14307], 0.13790452226182986`]], AbsoluteThickness[0.25],
      LineBox[{1973, 1974}]}, 
    {Hue[
      NCache[
       Rational[658, 4769], 0.13797441811700567`]], AbsoluteThickness[0.25], 
     LineBox[{1974, 1975}]}, 
    {Hue[
      NCache[
       Rational[1975, 14307], 0.13804431397218145`]], AbsoluteThickness[0.25],
      LineBox[{1975, 1976}]}, 
    {Hue[
      NCache[
       Rational[104, 753], 0.13811420982735723`]], AbsoluteThickness[0.25], 
     LineBox[{1976, 1977}]}, 
    {Hue[
      NCache[
       Rational[659, 4769], 0.13818410568253303`]], AbsoluteThickness[0.25], 
     LineBox[{1977, 1978}]}, 
    {Hue[
      NCache[
       Rational[1978, 14307], 0.1382540015377088]], AbsoluteThickness[0.25], 
     LineBox[{1978, 1979}]}, 
    {Hue[
      NCache[
       Rational[1979, 14307], 0.13832389739288461`]], AbsoluteThickness[0.25],
      LineBox[{1979, 1980}]}, 
    {Hue[
      NCache[
       Rational[660, 4769], 0.1383937932480604]], AbsoluteThickness[0.25], 
     LineBox[{1980, 1981}]}, 
    {Hue[
      NCache[
       Rational[1981, 14307], 0.13846368910323617`]], AbsoluteThickness[0.25],
      LineBox[{1981, 1982}]}, 
    {Hue[
      NCache[
       Rational[1982, 14307], 0.13853358495841198`]], AbsoluteThickness[0.25],
      LineBox[{1982, 1983}]}, 
    {Hue[
      NCache[
       Rational[661, 4769], 0.13860348081358775`]], AbsoluteThickness[0.25], 
     LineBox[{1983, 1984}]}, 
    {Hue[
      NCache[
       Rational[1984, 14307], 0.13867337666876353`]], AbsoluteThickness[0.25],
      LineBox[{1984, 1985}]}, 
    {Hue[
      NCache[
       Rational[1985, 14307], 0.13874327252393934`]], AbsoluteThickness[0.25],
      LineBox[{1985, 1986}]}, 
    {Hue[
      NCache[
       Rational[662, 4769], 0.13881316837911511`]], AbsoluteThickness[0.25], 
     LineBox[{1986, 1987}]}, 
    {Hue[
      NCache[
       Rational[1987, 14307], 0.1388830642342909]], AbsoluteThickness[0.25], 
     LineBox[{1987, 1988}]}, 
    {Hue[
      NCache[
       Rational[1988, 14307], 0.1389529600894667]], AbsoluteThickness[0.25], 
     LineBox[{1988, 1989}]}, 
    {Hue[
      NCache[
       Rational[663, 4769], 0.13902285594464248`]], AbsoluteThickness[0.25], 
     LineBox[{1989, 1990}]}, 
    {Hue[
      NCache[
       Rational[1990, 14307], 0.13909275179981828`]], AbsoluteThickness[0.25],
      LineBox[{1990, 1991}]}, 
    {Hue[
      NCache[
       Rational[1991, 14307], 0.13916264765499406`]], AbsoluteThickness[0.25],
      LineBox[{1991, 1992}]}, 
    {Hue[
      NCache[
       Rational[664, 4769], 0.13923254351016984`]], AbsoluteThickness[0.25], 
     LineBox[{1992, 1993}]}, 
    {Hue[
      NCache[
       Rational[1993, 14307], 0.13930243936534564`]], AbsoluteThickness[0.25],
      LineBox[{1993, 1994}]}, 
    {Hue[
      NCache[
       Rational[1994, 14307], 0.13937233522052142`]], AbsoluteThickness[0.25],
      LineBox[{1994, 1995}]}, 
    {Hue[
      NCache[
       Rational[35, 251], 0.1394422310756972]], AbsoluteThickness[0.25], 
     LineBox[{1995, 1996}]}, 
    {Hue[
      NCache[
       Rational[1996, 14307], 0.139512126930873]], AbsoluteThickness[0.25], 
     LineBox[{1996, 1997}]}, 
    {Hue[
      NCache[
       Rational[1997, 14307], 0.13958202278604878`]], AbsoluteThickness[0.25],
      LineBox[{1997, 1998}]}, 
    {Hue[
      NCache[
       Rational[666, 4769], 0.1396519186412246]], AbsoluteThickness[0.25], 
     LineBox[{1998, 1999}]}, 
    {Hue[
      NCache[
       Rational[1999, 14307], 0.13972181449640036`]], AbsoluteThickness[0.25],
      LineBox[{1999, 2000}]}, 
    {Hue[
      NCache[
       Rational[2000, 14307], 0.13979171035157614`]], AbsoluteThickness[0.25],
      LineBox[{2000, 2001}]}, 
    {Hue[
      NCache[
       Rational[667, 4769], 0.13986160620675195`]], AbsoluteThickness[0.25], 
     LineBox[{2001, 2002}]}, 
    {Hue[
      NCache[
       Rational[2002, 14307], 0.13993150206192773`]], AbsoluteThickness[0.25],
      LineBox[{2002, 2003}]}, 
    {Hue[
      NCache[
       Rational[2003, 14307], 0.1400013979171035]], AbsoluteThickness[0.25], 
     LineBox[{2003, 2004}]}, 
    {Hue[
      NCache[
       Rational[668, 4769], 0.1400712937722793]], AbsoluteThickness[0.25], 
     LineBox[{2004, 2005}]}, 
    {Hue[
      NCache[
       Rational[2005, 14307], 0.1401411896274551]], AbsoluteThickness[0.25], 
     LineBox[{2005, 2006}]}, 
    {Hue[
      NCache[
       Rational[2006, 14307], 0.1402110854826309]], AbsoluteThickness[0.25], 
     LineBox[{2006, 2007}]}, 
    {Hue[
      NCache[
       Rational[669, 4769], 0.14028098133780667`]], AbsoluteThickness[0.25], 
     LineBox[{2007, 2008}]}, 
    {Hue[
      NCache[
       Rational[8, 57], 0.14035087719298245`]], AbsoluteThickness[0.25], 
     LineBox[{2008, 2009}]}, 
    {Hue[
      NCache[
       Rational[2009, 14307], 0.14042077304815825`]], AbsoluteThickness[0.25],
      LineBox[{2009, 2010}]}, 
    {Hue[
      NCache[
       Rational[670, 4769], 0.14049066890333403`]], AbsoluteThickness[0.25], 
     LineBox[{2010, 2011}]}, 
    {Hue[
      NCache[
       Rational[2011, 14307], 0.1405605647585098]], AbsoluteThickness[0.25], 
     LineBox[{2011, 2012}]}, 
    {Hue[
      NCache[
       Rational[2012, 14307], 0.14063046061368562`]], AbsoluteThickness[0.25],
      LineBox[{2012, 2013}]}, 
    {Hue[
      NCache[
       Rational[671, 4769], 0.1407003564688614]], AbsoluteThickness[0.25], 
     LineBox[{2013, 2014}]}, 
    {Hue[
      NCache[
       Rational[106, 753], 0.1407702523240372]], AbsoluteThickness[0.25], 
     LineBox[{2014, 2015}]}, 
    {Hue[
      NCache[
       Rational[2015, 14307], 0.14084014817921298`]], AbsoluteThickness[0.25],
      LineBox[{2015, 2016}]}, 
    {Hue[
      NCache[
       Rational[672, 4769], 0.14091004403438875`]], AbsoluteThickness[0.25], 
     LineBox[{2016, 2017}]}, 
    {Hue[
      NCache[
       Rational[2017, 14307], 0.14097993988956456`]], AbsoluteThickness[0.25],
      LineBox[{2017, 2018}]}, 
    {Hue[
      NCache[
       Rational[2018, 14307], 0.14104983574474034`]], AbsoluteThickness[0.25],
      LineBox[{2018, 2019}]}, 
    {Hue[
      NCache[
       Rational[673, 4769], 0.14111973159991612`]], AbsoluteThickness[0.25], 
     LineBox[{2019, 2020}]}, 
    {Hue[
      NCache[
       Rational[2020, 14307], 0.14118962745509192`]], AbsoluteThickness[0.25],
      LineBox[{2020, 2021}]}, 
    {Hue[
      NCache[
       Rational[2021, 14307], 0.1412595233102677]], AbsoluteThickness[0.25], 
     LineBox[{2021, 2022}]}, 
    {Hue[
      NCache[
       Rational[674, 4769], 0.14132941916544348`]], AbsoluteThickness[0.25], 
     LineBox[{2022, 2023}]}, 
    {Hue[
      NCache[
       Rational[2023, 14307], 0.14139931502061928`]], AbsoluteThickness[0.25],
      LineBox[{2023, 2024}]}, 
    {Hue[
      NCache[
       Rational[2024, 14307], 0.14146921087579506`]], AbsoluteThickness[0.25],
      LineBox[{2024, 2025}]}, 
    {Hue[
      NCache[
       Rational[675, 4769], 0.14153910673097087`]], AbsoluteThickness[0.25], 
     LineBox[{2025, 2026}]}, 
    {Hue[
      NCache[
       Rational[2026, 14307], 0.14160900258614664`]], AbsoluteThickness[0.25],
      LineBox[{2026, 2027}]}, 
    {Hue[
      NCache[
       Rational[2027, 14307], 0.14167889844132242`]], AbsoluteThickness[0.25],
      LineBox[{2027, 2028}]}, 
    {Hue[
      NCache[
       Rational[676, 4769], 0.14174879429649823`]], AbsoluteThickness[0.25], 
     LineBox[{2028, 2029}]}, 
    {Hue[
      NCache[
       Rational[2029, 14307], 0.141818690151674]], AbsoluteThickness[0.25], 
     LineBox[{2029, 2030}]}, 
    {Hue[
      NCache[
       Rational[2030, 14307], 0.14188858600684978`]], AbsoluteThickness[0.25],
      LineBox[{2030, 2031}]}, 
    {Hue[
      NCache[
       Rational[677, 4769], 0.1419584818620256]], AbsoluteThickness[0.25], 
     LineBox[{2031, 2032}]}, 
    {Hue[
      NCache[
       Rational[2032, 14307], 0.14202837771720137`]], AbsoluteThickness[0.25],
      LineBox[{2032, 2033}]}, 
    {Hue[
      NCache[
       Rational[107, 753], 0.14209827357237717`]], AbsoluteThickness[0.25], 
     LineBox[{2033, 2034}]}, 
    {Hue[
      NCache[
       Rational[678, 4769], 0.14216816942755295`]], AbsoluteThickness[0.25], 
     LineBox[{2034, 2035}]}, 
    {Hue[
      NCache[
       Rational[2035, 14307], 0.14223806528272873`]], AbsoluteThickness[0.25],
      LineBox[{2035, 2036}]}, 
    {Hue[
      NCache[
       Rational[2036, 14307], 0.14230796113790453`]], AbsoluteThickness[0.25],
      LineBox[{2036, 2037}]}, 
    {Hue[
      NCache[
       Rational[679, 4769], 0.1423778569930803]], AbsoluteThickness[0.25], 
     LineBox[{2037, 2038}]}, 
    {Hue[
      NCache[
       Rational[2038, 14307], 0.1424477528482561]], AbsoluteThickness[0.25], 
     LineBox[{2038, 2039}]}, 
    {Hue[
      NCache[
       Rational[2039, 14307], 0.1425176487034319]], AbsoluteThickness[0.25], 
     LineBox[{2039, 2040}]}, 
    {Hue[
      NCache[
       Rational[680, 4769], 0.14258754455860767`]], AbsoluteThickness[0.25], 
     LineBox[{2040, 2041}]}, 
    {Hue[
      NCache[
       Rational[2041, 14307], 0.14265744041378348`]], AbsoluteThickness[0.25],
      LineBox[{2041, 2042}]}, 
    {Hue[
      NCache[
       Rational[2042, 14307], 0.14272733626895925`]], AbsoluteThickness[0.25],
      LineBox[{2042, 2043}]}, 
    {Hue[
      NCache[
       Rational[681, 4769], 0.14279723212413503`]], AbsoluteThickness[0.25], 
     LineBox[{2043, 2044}]}, 
    {Hue[
      NCache[
       Rational[2044, 14307], 0.14286712797931084`]], AbsoluteThickness[0.25],
      LineBox[{2044, 2045}]}, 
    {Hue[
      NCache[
       Rational[2045, 14307], 0.14293702383448662`]], AbsoluteThickness[0.25],
      LineBox[{2045, 2046}]}, 
    {Hue[
      NCache[
       Rational[682, 4769], 0.1430069196896624]], AbsoluteThickness[0.25], 
     LineBox[{2046, 2047}]}, 
    {Hue[
      NCache[
       Rational[2047, 14307], 0.1430768155448382]], AbsoluteThickness[0.25], 
     LineBox[{2047, 2048}]}, 
    {Hue[
      NCache[
       Rational[2048, 14307], 0.14314671140001398`]], AbsoluteThickness[0.25],
      LineBox[{2048, 2049}]}, 
    {Hue[
      NCache[
       Rational[683, 4769], 0.14321660725518975`]], AbsoluteThickness[0.25], 
     LineBox[{2049, 2050}]}, 
    {Hue[
      NCache[
       Rational[2050, 14307], 0.14328650311036556`]], AbsoluteThickness[0.25],
      LineBox[{2050, 2051}]}, 
    {Hue[
      NCache[
       Rational[2051, 14307], 0.14335639896554134`]], AbsoluteThickness[0.25],
      LineBox[{2051, 2052}]}, 
    {Hue[
      NCache[
       Rational[36, 251], 0.14342629482071714`]], AbsoluteThickness[0.25], 
     LineBox[{2052, 2053}]}, 
    {Hue[
      NCache[
       Rational[2053, 14307], 0.14349619067589292`]], AbsoluteThickness[0.25],
      LineBox[{2053, 2054}]}, 
    {Hue[
      NCache[
       Rational[2054, 14307], 0.1435660865310687]], AbsoluteThickness[0.25], 
     LineBox[{2054, 2055}]}, 
    {Hue[
      NCache[
       Rational[685, 4769], 0.1436359823862445]], AbsoluteThickness[0.25], 
     LineBox[{2055, 2056}]}, 
    {Hue[
      NCache[
       Rational[2056, 14307], 0.14370587824142028`]], AbsoluteThickness[0.25],
      LineBox[{2056, 2057}]}, 
    {Hue[
      NCache[
       Rational[2057, 14307], 0.14377577409659606`]], AbsoluteThickness[0.25],
      LineBox[{2057, 2058}]}, 
    {Hue[
      NCache[
       Rational[686, 4769], 0.14384566995177187`]], AbsoluteThickness[0.25], 
     LineBox[{2058, 2059}]}, 
    {Hue[
      NCache[
       Rational[2059, 14307], 0.14391556580694764`]], AbsoluteThickness[0.25],
      LineBox[{2059, 2060}]}, 
    {Hue[
      NCache[
       Rational[2060, 14307], 0.14398546166212345`]], AbsoluteThickness[0.25],
      LineBox[{2060, 2061}]}, 
    {Hue[
      NCache[
       Rational[687, 4769], 0.14405535751729923`]], AbsoluteThickness[0.25], 
     LineBox[{2061, 2062}]}, 
    {Hue[
      NCache[
       Rational[2062, 14307], 0.144125253372475]], AbsoluteThickness[0.25], 
     LineBox[{2062, 2063}]}, 
    {Hue[
      NCache[
       Rational[2063, 14307], 0.1441951492276508]], AbsoluteThickness[0.25], 
     LineBox[{2063, 2064}]}, 
    {Hue[
      NCache[
       Rational[688, 4769], 0.1442650450828266]], AbsoluteThickness[0.25], 
     LineBox[{2064, 2065}]}, 
    {Hue[
      NCache[
       Rational[2065, 14307], 0.14433494093800237`]], AbsoluteThickness[0.25],
      LineBox[{2065, 2066}]}, 
    {Hue[
      NCache[
       Rational[2066, 14307], 0.14440483679317817`]], AbsoluteThickness[0.25],
      LineBox[{2066, 2067}]}, 
    {Hue[
      NCache[
       Rational[689, 4769], 0.14447473264835395`]], AbsoluteThickness[0.25], 
     LineBox[{2067, 2068}]}, 
    {Hue[
      NCache[
       Rational[2068, 14307], 0.14454462850352975`]], AbsoluteThickness[0.25],
      LineBox[{2068, 2069}]}, 
    {Hue[
      NCache[
       Rational[2069, 14307], 0.14461452435870553`]], AbsoluteThickness[0.25],
      LineBox[{2069, 2070}]}, 
    {Hue[
      NCache[
       Rational[690, 4769], 0.1446844202138813]], AbsoluteThickness[0.25], 
     LineBox[{2070, 2071}]}, 
    {Hue[
      NCache[
       Rational[109, 753], 0.14475431606905712`]], AbsoluteThickness[0.25], 
     LineBox[{2071, 2072}]}, 
    {Hue[
      NCache[
       Rational[2072, 14307], 0.1448242119242329]], AbsoluteThickness[0.25], 
     LineBox[{2072, 2073}]}, 
    {Hue[
      NCache[
       Rational[691, 4769], 0.14489410777940867`]], AbsoluteThickness[0.25], 
     LineBox[{2073, 2074}]}, 
    {Hue[
      NCache[
       Rational[2074, 14307], 0.14496400363458448`]], AbsoluteThickness[0.25],
      LineBox[{2074, 2075}]}, 
    {Hue[
      NCache[
       Rational[2075, 14307], 0.14503389948976025`]], AbsoluteThickness[0.25],
      LineBox[{2075, 2076}]}, 
    {Hue[
      NCache[
       Rational[692, 4769], 0.14510379534493603`]], AbsoluteThickness[0.25], 
     LineBox[{2076, 2077}]}, 
    {Hue[
      NCache[
       Rational[2077, 14307], 0.14517369120011184`]], AbsoluteThickness[0.25],
      LineBox[{2077, 2078}]}, 
    {Hue[
      NCache[
       Rational[2078, 14307], 0.14524358705528762`]], AbsoluteThickness[0.25],
      LineBox[{2078, 2079}]}, 
    {Hue[
      NCache[
       Rational[693, 4769], 0.14531348291046342`]], AbsoluteThickness[0.25], 
     LineBox[{2079, 2080}]}, 
    {Hue[
      NCache[
       Rational[2080, 14307], 0.1453833787656392]], AbsoluteThickness[0.25], 
     LineBox[{2080, 2081}]}, 
    {Hue[
      NCache[
       Rational[2081, 14307], 0.14545327462081498`]], AbsoluteThickness[0.25],
      LineBox[{2081, 2082}]}, 
    {Hue[
      NCache[
       Rational[694, 4769], 0.14552317047599078`]], AbsoluteThickness[0.25], 
     LineBox[{2082, 2083}]}, 
    {Hue[
      NCache[
       Rational[2083, 14307], 0.14559306633116656`]], AbsoluteThickness[0.25],
      LineBox[{2083, 2084}]}, 
    {Hue[
      NCache[
       Rational[2084, 14307], 0.14566296218634234`]], AbsoluteThickness[0.25],
      LineBox[{2084, 2085}]}, 
    {Hue[
      NCache[
       Rational[695, 4769], 0.14573285804151814`]], AbsoluteThickness[0.25], 
     LineBox[{2085, 2086}]}, 
    {Hue[
      NCache[
       Rational[2086, 14307], 0.14580275389669392`]], AbsoluteThickness[0.25],
      LineBox[{2086, 2087}]}, 
    {Hue[
      NCache[
       Rational[2087, 14307], 0.14587264975186973`]], AbsoluteThickness[0.25],
      LineBox[{2087, 2088}]}, 
    {Hue[
      NCache[
       Rational[696, 4769], 0.1459425456070455]], AbsoluteThickness[0.25], 
     LineBox[{2088, 2089}]}, 
    {Hue[
      NCache[
       Rational[2089, 14307], 0.14601244146222128`]], AbsoluteThickness[0.25],
      LineBox[{2089, 2090}]}, 
    {Hue[
      NCache[
       Rational[110, 753], 0.1460823373173971]], AbsoluteThickness[0.25], 
     LineBox[{2090, 2091}]}, 
    {Hue[
      NCache[
       Rational[697, 4769], 0.14615223317257287`]], AbsoluteThickness[0.25], 
     LineBox[{2091, 2092}]}, 
    {Hue[
      NCache[
       Rational[2092, 14307], 0.14622212902774864`]], AbsoluteThickness[0.25],
      LineBox[{2092, 2093}]}, 
    {Hue[
      NCache[
       Rational[2093, 14307], 0.14629202488292445`]], AbsoluteThickness[0.25],
      LineBox[{2093, 2094}]}, 
    {Hue[
      NCache[
       Rational[698, 4769], 0.14636192073810023`]], AbsoluteThickness[0.25], 
     LineBox[{2094, 2095}]}, 
    {Hue[
      NCache[
       Rational[2095, 14307], 0.14643181659327603`]], AbsoluteThickness[0.25],
      LineBox[{2095, 2096}]}, 
    {Hue[
      NCache[
       Rational[2096, 14307], 0.1465017124484518]], AbsoluteThickness[0.25], 
     LineBox[{2096, 2097}]}, 
    {Hue[
      NCache[
       Rational[699, 4769], 0.1465716083036276]], AbsoluteThickness[0.25], 
     LineBox[{2097, 2098}]}, 
    {Hue[
      NCache[
       Rational[2098, 14307], 0.1466415041588034]], AbsoluteThickness[0.25], 
     LineBox[{2098, 2099}]}, 
    {Hue[
      NCache[
       Rational[2099, 14307], 0.14671140001397917`]], AbsoluteThickness[0.25],
      LineBox[{2099, 2100}]}, 
    {Hue[
      NCache[
       Rational[700, 4769], 0.14678129586915495`]], AbsoluteThickness[0.25], 
     LineBox[{2100, 2101}]}, 
    {Hue[
      NCache[
       Rational[2101, 14307], 0.14685119172433075`]], AbsoluteThickness[0.25],
      LineBox[{2101, 2102}]}, 
    {Hue[
      NCache[
       Rational[2102, 14307], 0.14692108757950653`]], AbsoluteThickness[0.25],
      LineBox[{2102, 2103}]}, 
    {Hue[
      NCache[
       Rational[701, 4769], 0.1469909834346823]], AbsoluteThickness[0.25], 
     LineBox[{2103, 2104}]}, 
    {Hue[
      NCache[
       Rational[2104, 14307], 0.14706087928985812`]], AbsoluteThickness[0.25],
      LineBox[{2104, 2105}]}, 
    {Hue[
      NCache[
       Rational[2105, 14307], 0.1471307751450339]], AbsoluteThickness[0.25], 
     LineBox[{2105, 2106}]}, 
    {Hue[
      NCache[
       Rational[702, 4769], 0.1472006710002097]], AbsoluteThickness[0.25], 
     LineBox[{2106, 2107}]}, 
    {Hue[
      NCache[
       Rational[2107, 14307], 0.14727056685538548`]], AbsoluteThickness[0.25],
      LineBox[{2107, 2108}]}, 
    {Hue[
      NCache[
       Rational[2108, 14307], 0.14734046271056125`]], AbsoluteThickness[0.25],
      LineBox[{2108, 2109}]}, 
    {Hue[
      NCache[
       Rational[37, 251], 0.14741035856573706`]], AbsoluteThickness[0.25], 
     LineBox[{2109, 2110}]}, 
    {Hue[
      NCache[
       Rational[2110, 14307], 0.14748025442091284`]], AbsoluteThickness[0.25],
      LineBox[{2110, 2111}]}, 
    {Hue[
      NCache[
       Rational[2111, 14307], 0.14755015027608862`]], AbsoluteThickness[0.25],
      LineBox[{2111, 2112}]}, 
    {Hue[
      NCache[
       Rational[704, 4769], 0.14762004613126442`]], AbsoluteThickness[0.25], 
     LineBox[{2112, 2113}]}, 
    {Hue[
      NCache[
       Rational[2113, 14307], 0.1476899419864402]], AbsoluteThickness[0.25], 
     LineBox[{2113, 2114}]}, 
    {Hue[
      NCache[
       Rational[2114, 14307], 0.147759837841616]], AbsoluteThickness[0.25], 
     LineBox[{2114, 2115}]}, 
    {Hue[
      NCache[
       Rational[705, 4769], 0.14782973369679178`]], AbsoluteThickness[0.25], 
     LineBox[{2115, 2116}]}, 
    {Hue[
      NCache[
       Rational[2116, 14307], 0.14789962955196756`]], AbsoluteThickness[0.25],
      LineBox[{2116, 2117}]}, 
    {Hue[
      NCache[
       Rational[2117, 14307], 0.14796952540714337`]], AbsoluteThickness[0.25],
      LineBox[{2117, 2118}]}, 
    {Hue[
      NCache[
       Rational[706, 4769], 0.14803942126231914`]], AbsoluteThickness[0.25], 
     LineBox[{2118, 2119}]}, 
    {Hue[
      NCache[
       Rational[2119, 14307], 0.14810931711749492`]], AbsoluteThickness[0.25],
      LineBox[{2119, 2120}]}, 
    {Hue[
      NCache[
       Rational[2120, 14307], 0.14817921297267073`]], AbsoluteThickness[0.25],
      LineBox[{2120, 2121}]}, 
    {Hue[
      NCache[
       Rational[707, 4769], 0.1482491088278465]], AbsoluteThickness[0.25], 
     LineBox[{2121, 2122}]}, 
    {Hue[
      NCache[
       Rational[2122, 14307], 0.1483190046830223]], AbsoluteThickness[0.25], 
     LineBox[{2122, 2123}]}, 
    {Hue[
      NCache[
       Rational[2123, 14307], 0.1483889005381981]], AbsoluteThickness[0.25], 
     LineBox[{2123, 2124}]}, 
    {Hue[
      NCache[
       Rational[708, 4769], 0.14845879639337387`]], AbsoluteThickness[0.25], 
     LineBox[{2124, 2125}]}, 
    {Hue[
      NCache[
       Rational[2125, 14307], 0.14852869224854967`]], AbsoluteThickness[0.25],
      LineBox[{2125, 2126}]}, 
    {Hue[
      NCache[
       Rational[2126, 14307], 0.14859858810372545`]], AbsoluteThickness[0.25],
      LineBox[{2126, 2127}]}, 
    {Hue[
      NCache[
       Rational[709, 4769], 0.14866848395890123`]], AbsoluteThickness[0.25], 
     LineBox[{2127, 2128}]}, 
    {Hue[
      NCache[
       Rational[112, 753], 0.14873837981407703`]], AbsoluteThickness[0.25], 
     LineBox[{2128, 2129}]}, 
    {Hue[
      NCache[
       Rational[2129, 14307], 0.1488082756692528]], AbsoluteThickness[0.25], 
     LineBox[{2129, 2130}]}, 
    {Hue[
      NCache[
       Rational[710, 4769], 0.14887817152442862`]], AbsoluteThickness[0.25], 
     LineBox[{2130, 2131}]}, 
    {Hue[
      NCache[
       Rational[2131, 14307], 0.1489480673796044]], AbsoluteThickness[0.25], 
     LineBox[{2131, 2132}]}, 
    {Hue[
      NCache[
       Rational[2132, 14307], 0.14901796323478017`]], AbsoluteThickness[0.25],
      LineBox[{2132, 2133}]}, 
    {Hue[
      NCache[
       Rational[711, 4769], 0.14908785908995598`]], AbsoluteThickness[0.25], 
     LineBox[{2133, 2134}]}, 
    {Hue[
      NCache[
       Rational[2134, 14307], 0.14915775494513175`]], AbsoluteThickness[0.25],
      LineBox[{2134, 2135}]}, 
    {Hue[
      NCache[
       Rational[2135, 14307], 0.14922765080030753`]], AbsoluteThickness[0.25],
      LineBox[{2135, 2136}]}, 
    {Hue[
      NCache[
       Rational[712, 4769], 0.14929754665548334`]], AbsoluteThickness[0.25], 
     LineBox[{2136, 2137}]}, 
    {Hue[
      NCache[
       Rational[2137, 14307], 0.14936744251065912`]], AbsoluteThickness[0.25],
      LineBox[{2137, 2138}]}, 
    {Hue[
      NCache[
       Rational[2138, 14307], 0.1494373383658349]], AbsoluteThickness[0.25], 
     LineBox[{2138, 2139}]}, 
    {Hue[
      NCache[
       Rational[713, 4769], 0.1495072342210107]], AbsoluteThickness[0.25], 
     LineBox[{2139, 2140}]}, 
    {Hue[
      NCache[
       Rational[2140, 14307], 0.14957713007618648`]], AbsoluteThickness[0.25],
      LineBox[{2140, 2141}]}, 
    {Hue[
      NCache[
       Rational[2141, 14307], 0.14964702593136228`]], AbsoluteThickness[0.25],
      LineBox[{2141, 2142}]}, 
    {Hue[
      NCache[
       Rational[714, 4769], 0.14971692178653806`]], AbsoluteThickness[0.25], 
     LineBox[{2142, 2143}]}, 
    {Hue[
      NCache[
       Rational[2143, 14307], 0.14978681764171384`]], AbsoluteThickness[0.25],
      LineBox[{2143, 2144}]}, 
    {Hue[
      NCache[
       Rational[2144, 14307], 0.14985671349688964`]], AbsoluteThickness[0.25],
      LineBox[{2144, 2145}]}, 
    {Hue[
      NCache[
       Rational[715, 4769], 0.14992660935206542`]], AbsoluteThickness[0.25], 
     LineBox[{2145, 2146}]}, 
    {Hue[
      NCache[
       Rational[2146, 14307], 0.1499965052072412]], AbsoluteThickness[0.25], 
     LineBox[{2146, 2147}]}, 
    {Hue[
      NCache[
       Rational[113, 753], 0.150066401062417]], AbsoluteThickness[0.25], 
     LineBox[{2147, 2148}]}, 
    {Hue[
      NCache[
       Rational[716, 4769], 0.15013629691759278`]], AbsoluteThickness[0.25], 
     LineBox[{2148, 2149}]}, 
    {Hue[
      NCache[
       Rational[2149, 14307], 0.1502061927727686]], AbsoluteThickness[0.25], 
     LineBox[{2149, 2150}]}, 
    {Hue[
      NCache[
       Rational[2150, 14307], 0.15027608862794437`]], AbsoluteThickness[0.25],
      LineBox[{2150, 2151}]}, 
    {Hue[
      NCache[
       Rational[717, 4769], 0.15034598448312014`]], AbsoluteThickness[0.25], 
     LineBox[{2151, 2152}]}, 
    {Hue[
      NCache[
       Rational[2152, 14307], 0.15041588033829595`]], AbsoluteThickness[0.25],
      LineBox[{2152, 2153}]}, 
    {Hue[
      NCache[
       Rational[2153, 14307], 0.15048577619347173`]], AbsoluteThickness[0.25],
      LineBox[{2153, 2154}]}, 
    {Hue[
      NCache[
       Rational[718, 4769], 0.1505556720486475]], AbsoluteThickness[0.25], 
     LineBox[{2154, 2155}]}, 
    {Hue[
      NCache[
       Rational[2155, 14307], 0.1506255679038233]], AbsoluteThickness[0.25], 
     LineBox[{2155, 2156}]}, 
    {Hue[
      NCache[
       Rational[2156, 14307], 0.1506954637589991]], AbsoluteThickness[0.25], 
     LineBox[{2156, 2157}]}, 
    {Hue[
      NCache[
       Rational[719, 4769], 0.1507653596141749]], AbsoluteThickness[0.25], 
     LineBox[{2157, 2158}]}, 
    {Hue[
      NCache[
       Rational[2158, 14307], 0.15083525546935067`]], AbsoluteThickness[0.25],
      LineBox[{2158, 2159}]}, 
    {Hue[
      NCache[
       Rational[2159, 14307], 0.15090515132452645`]], AbsoluteThickness[0.25],
      LineBox[{2159, 2160}]}, 
    {Hue[
      NCache[
       Rational[720, 4769], 0.15097504717970225`]], AbsoluteThickness[0.25], 
     LineBox[{2160, 2161}]}, 
    {Hue[
      NCache[
       Rational[2161, 14307], 0.15104494303487803`]], AbsoluteThickness[0.25],
      LineBox[{2161, 2162}]}, 
    {Hue[
      NCache[
       Rational[2162, 14307], 0.1511148388900538]], AbsoluteThickness[0.25], 
     LineBox[{2162, 2163}]}, 
    {Hue[
      NCache[
       Rational[721, 4769], 0.15118473474522962`]], AbsoluteThickness[0.25], 
     LineBox[{2163, 2164}]}, 
    {Hue[
      NCache[
       Rational[2164, 14307], 0.1512546306004054]], AbsoluteThickness[0.25], 
     LineBox[{2164, 2165}]}, 
    {Hue[
      NCache[
       Rational[2165, 14307], 0.15132452645558117`]], AbsoluteThickness[0.25],
      LineBox[{2165, 2166}]}, 
    {Hue[
      NCache[
       Rational[38, 251], 0.15139442231075698`]], AbsoluteThickness[0.25], 
     LineBox[{2166, 2167}]}, 
    {Hue[
      NCache[
       Rational[2167, 14307], 0.15146431816593275`]], AbsoluteThickness[0.25],
      LineBox[{2167, 2168}]}, 
    {Hue[
      NCache[
       Rational[2168, 14307], 0.15153421402110856`]], AbsoluteThickness[0.25],
      LineBox[{2168, 2169}]}, 
    {Hue[
      NCache[
       Rational[723, 4769], 0.15160410987628434`]], AbsoluteThickness[0.25], 
     LineBox[{2169, 2170}]}, 
    {Hue[
      NCache[
       Rational[2170, 14307], 0.15167400573146012`]], AbsoluteThickness[0.25],
      LineBox[{2170, 2171}]}, 
    {Hue[
      NCache[
       Rational[2171, 14307], 0.15174390158663592`]], AbsoluteThickness[0.25],
      LineBox[{2171, 2172}]}, 
    {Hue[
      NCache[
       Rational[724, 4769], 0.1518137974418117]], AbsoluteThickness[0.25], 
     LineBox[{2172, 2173}]}, 
    {Hue[
      NCache[
       Rational[2173, 14307], 0.15188369329698748`]], AbsoluteThickness[0.25],
      LineBox[{2173, 2174}]}, 
    {Hue[
      NCache[
       Rational[2174, 14307], 0.15195358915216328`]], AbsoluteThickness[0.25],
      LineBox[{2174, 2175}]}, 
    {Hue[
      NCache[
       Rational[725, 4769], 0.15202348500733906`]], AbsoluteThickness[0.25], 
     LineBox[{2175, 2176}]}, 
    {Hue[
      NCache[
       Rational[2176, 14307], 0.15209338086251487`]], AbsoluteThickness[0.25],
      LineBox[{2176, 2177}]}, 
    {Hue[
      NCache[
       Rational[2177, 14307], 0.15216327671769064`]], AbsoluteThickness[0.25],
      LineBox[{2177, 2178}]}, 
    {Hue[
      NCache[
       Rational[726, 4769], 0.15223317257286642`]], AbsoluteThickness[0.25], 
     LineBox[{2178, 2179}]}, 
    {Hue[
      NCache[
       Rational[2179, 14307], 0.15230306842804223`]], AbsoluteThickness[0.25],
      LineBox[{2179, 2180}]}, 
    {Hue[
      NCache[
       Rational[2180, 14307], 0.152372964283218]], AbsoluteThickness[0.25], 
     LineBox[{2180, 2181}]}, 
    {Hue[
      NCache[
       Rational[727, 4769], 0.15244286013839378`]], AbsoluteThickness[0.25], 
     LineBox[{2181, 2182}]}, 
    {Hue[
      NCache[
       Rational[2182, 14307], 0.1525127559935696]], AbsoluteThickness[0.25], 
     LineBox[{2182, 2183}]}, 
    {Hue[
      NCache[
       Rational[2183, 14307], 0.15258265184874537`]], AbsoluteThickness[0.25],
      LineBox[{2183, 2184}]}, 
    {Hue[
      NCache[
       Rational[728, 4769], 0.15265254770392117`]], AbsoluteThickness[0.25], 
     LineBox[{2184, 2185}]}, 
    {Hue[
      NCache[
       Rational[115, 753], 0.15272244355909695`]], AbsoluteThickness[0.25], 
     LineBox[{2185, 2186}]}, 
    {Hue[
      NCache[
       Rational[2186, 14307], 0.15279233941427273`]], AbsoluteThickness[0.25],
      LineBox[{2186, 2187}]}, 
    {Hue[
      NCache[
       Rational[729, 4769], 0.15286223526944853`]], AbsoluteThickness[0.25], 
     LineBox[{2187, 2188}]}, 
    {Hue[
      NCache[
       Rational[2188, 14307], 0.1529321311246243]], AbsoluteThickness[0.25], 
     LineBox[{2188, 2189}]}, 
    {Hue[
      NCache[
       Rational[2189, 14307], 0.1530020269798001]], AbsoluteThickness[0.25], 
     LineBox[{2189, 2190}]}, 
    {Hue[
      NCache[
       Rational[730, 4769], 0.1530719228349759]], AbsoluteThickness[0.25], 
     LineBox[{2190, 2191}]}, 
    {Hue[
      NCache[
       Rational[2191, 14307], 0.15314181869015167`]], AbsoluteThickness[0.25],
      LineBox[{2191, 2192}]}, 
    {Hue[
      NCache[
       Rational[2192, 14307], 0.15321171454532745`]], AbsoluteThickness[0.25],
      LineBox[{2192, 2193}]}, 
    {Hue[
      NCache[
       Rational[731, 4769], 0.15328161040050325`]], AbsoluteThickness[0.25], 
     LineBox[{2193, 2194}]}, 
    {Hue[
      NCache[
       Rational[2194, 14307], 0.15335150625567903`]], AbsoluteThickness[0.25],
      LineBox[{2194, 2195}]}, 
    {Hue[
      NCache[
       Rational[2195, 14307], 0.15342140211085484`]], AbsoluteThickness[0.25],
      LineBox[{2195, 2196}]}, 
    {Hue[
      NCache[
       Rational[732, 4769], 0.15349129796603062`]], AbsoluteThickness[0.25], 
     LineBox[{2196, 2197}]}, 
    {Hue[
      NCache[
       Rational[2197, 14307], 0.1535611938212064]], AbsoluteThickness[0.25], 
     LineBox[{2197, 2198}]}, 
    {Hue[
      NCache[
       Rational[2198, 14307], 0.1536310896763822]], AbsoluteThickness[0.25], 
     LineBox[{2198, 2199}]}, 
    {Hue[
      NCache[
       Rational[733, 4769], 0.15370098553155798`]], AbsoluteThickness[0.25], 
     LineBox[{2199, 2200}]}, 
    {Hue[
      NCache[
       Rational[2200, 14307], 0.15377088138673375`]], AbsoluteThickness[0.25],
      LineBox[{2200, 2201}]}, 
    {Hue[
      NCache[
       Rational[2201, 14307], 0.15384077724190956`]], AbsoluteThickness[0.25],
      LineBox[{2201, 2202}]}, 
    {Hue[
      NCache[
       Rational[734, 4769], 0.15391067309708534`]], AbsoluteThickness[0.25], 
     LineBox[{2202, 2203}]}, 
    {Hue[
      NCache[
       Rational[2203, 14307], 0.15398056895226114`]], AbsoluteThickness[0.25],
      LineBox[{2203, 2204}]}, 
    {Hue[
      NCache[
       Rational[116, 753], 0.15405046480743692`]], AbsoluteThickness[0.25], 
     LineBox[{2204, 2205}]}, 
    {Hue[
      NCache[
       Rational[735, 4769], 0.1541203606626127]], AbsoluteThickness[0.25], 
     LineBox[{2205, 2206}]}, 
    {Hue[
      NCache[
       Rational[2206, 14307], 0.1541902565177885]], AbsoluteThickness[0.25], 
     LineBox[{2206, 2207}]}, 
    {Hue[
      NCache[
       Rational[2207, 14307], 0.15426015237296428`]], AbsoluteThickness[0.25],
      LineBox[{2207, 2208}]}, 
    {Hue[
      NCache[
       Rational[736, 4769], 0.15433004822814006`]], AbsoluteThickness[0.25], 
     LineBox[{2208, 2209}]}, 
    {Hue[
      NCache[
       Rational[2209, 14307], 0.15439994408331587`]], AbsoluteThickness[0.25],
      LineBox[{2209, 2210}]}, 
    {Hue[
      NCache[
       Rational[2210, 14307], 0.15446983993849164`]], AbsoluteThickness[0.25],
      LineBox[{2210, 2211}]}, 
    {Hue[
      NCache[
       Rational[737, 4769], 0.15453973579366745`]], AbsoluteThickness[0.25], 
     LineBox[{2211, 2212}]}, 
    {Hue[
      NCache[
       Rational[2212, 14307], 0.15460963164884323`]], AbsoluteThickness[0.25],
      LineBox[{2212, 2213}]}, 
    {Hue[
      NCache[
       Rational[2213, 14307], 0.154679527504019]], AbsoluteThickness[0.25], 
     LineBox[{2213, 2214}]}, 
    {Hue[
      NCache[
       Rational[738, 4769], 0.1547494233591948]], AbsoluteThickness[0.25], 
     LineBox[{2214, 2215}]}, 
    {Hue[
      NCache[
       Rational[2215, 14307], 0.1548193192143706]], AbsoluteThickness[0.25], 
     LineBox[{2215, 2216}]}, 
    {Hue[
      NCache[
       Rational[2216, 14307], 0.15488921506954637`]], AbsoluteThickness[0.25],
      LineBox[{2216, 2217}]}, 
    {Hue[
      NCache[
       Rational[739, 4769], 0.15495911092472217`]], AbsoluteThickness[0.25], 
     LineBox[{2217, 2218}]}, 
    {Hue[
      NCache[
       Rational[2218, 14307], 0.15502900677989795`]], AbsoluteThickness[0.25],
      LineBox[{2218, 2219}]}, 
    {Hue[
      NCache[
       Rational[2219, 14307], 0.15509890263507373`]], AbsoluteThickness[0.25],
      LineBox[{2219, 2220}]}, 
    {Hue[
      NCache[
       Rational[740, 4769], 0.15516879849024953`]], AbsoluteThickness[0.25], 
     LineBox[{2220, 2221}]}, 
    {Hue[
      NCache[
       Rational[2221, 14307], 0.1552386943454253]], AbsoluteThickness[0.25], 
     LineBox[{2221, 2222}]}, 
    {Hue[
      NCache[
       Rational[2222, 14307], 0.15530859020060112`]], AbsoluteThickness[0.25],
      LineBox[{2222, 2223}]}, 
    {Hue[
      NCache[
       Rational[39, 251], 0.1553784860557769]], AbsoluteThickness[0.25], 
     LineBox[{2223, 2224}]}, 
    {Hue[
      NCache[
       Rational[2224, 14307], 0.15544838191095267`]], AbsoluteThickness[0.25],
      LineBox[{2224, 2225}]}, 
    {Hue[
      NCache[
       Rational[2225, 14307], 0.15551827776612848`]], AbsoluteThickness[0.25],
      LineBox[{2225, 2226}]}, 
    {Hue[
      NCache[
       Rational[742, 4769], 0.15558817362130425`]], AbsoluteThickness[0.25], 
     LineBox[{2226, 2227}]}, 
    {Hue[
      NCache[
       Rational[2227, 14307], 0.15565806947648003`]], AbsoluteThickness[0.25],
      LineBox[{2227, 2228}]}, 
    {Hue[
      NCache[
       Rational[2228, 14307], 0.15572796533165584`]], AbsoluteThickness[0.25],
      LineBox[{2228, 2229}]}, 
    {Hue[
      NCache[
       Rational[743, 4769], 0.15579786118683162`]], AbsoluteThickness[0.25], 
     LineBox[{2229, 2230}]}, 
    {Hue[
      NCache[
       Rational[2230, 14307], 0.15586775704200742`]], AbsoluteThickness[0.25],
      LineBox[{2230, 2231}]}, 
    {Hue[
      NCache[
       Rational[2231, 14307], 0.1559376528971832]], AbsoluteThickness[0.25], 
     LineBox[{2231, 2232}]}, 
    {Hue[
      NCache[
       Rational[744, 4769], 0.15600754875235898`]], AbsoluteThickness[0.25], 
     LineBox[{2232, 2233}]}, 
    {Hue[
      NCache[
       Rational[2233, 14307], 0.15607744460753478`]], AbsoluteThickness[0.25],
      LineBox[{2233, 2234}]}, 
    {Hue[
      NCache[
       Rational[2234, 14307], 0.15614734046271056`]], AbsoluteThickness[0.25],
      LineBox[{2234, 2235}]}, 
    {Hue[
      NCache[
       Rational[745, 4769], 0.15621723631788634`]], AbsoluteThickness[0.25], 
     LineBox[{2235, 2236}]}, 
    {Hue[
      NCache[
       Rational[2236, 14307], 0.15628713217306214`]], AbsoluteThickness[0.25],
      LineBox[{2236, 2237}]}, 
    {Hue[
      NCache[
       Rational[2237, 14307], 0.15635702802823792`]], AbsoluteThickness[0.25],
      LineBox[{2237, 2238}]}, 
    {Hue[
      NCache[
       Rational[746, 4769], 0.15642692388341373`]], AbsoluteThickness[0.25], 
     LineBox[{2238, 2239}]}, 
    {Hue[
      NCache[
       Rational[2239, 14307], 0.1564968197385895]], AbsoluteThickness[0.25], 
     LineBox[{2239, 2240}]}, 
    {Hue[
      NCache[
       Rational[2240, 14307], 0.15656671559376528`]], AbsoluteThickness[0.25],
      LineBox[{2240, 2241}]}, 
    {Hue[
      NCache[
       Rational[747, 4769], 0.1566366114489411]], AbsoluteThickness[0.25], 
     LineBox[{2241, 2242}]}, 
    {Hue[
      NCache[
       Rational[118, 753], 0.15670650730411687`]], AbsoluteThickness[0.25], 
     LineBox[{2242, 2243}]}, 
    {Hue[
      NCache[
       Rational[2243, 14307], 0.15677640315929264`]], AbsoluteThickness[0.25],
      LineBox[{2243, 2244}]}, 
    {Hue[
      NCache[
       Rational[748, 4769], 0.15684629901446845`]], AbsoluteThickness[0.25], 
     LineBox[{2244, 2245}]}, 
    {Hue[
      NCache[
       Rational[2245, 14307], 0.15691619486964423`]], AbsoluteThickness[0.25],
      LineBox[{2245, 2246}]}, 
    {Hue[
      NCache[
       Rational[2246, 14307], 0.15698609072482]], AbsoluteThickness[0.25], 
     LineBox[{2246, 2247}]}, 
    {Hue[
      NCache[
       Rational[749, 4769], 0.1570559865799958]], AbsoluteThickness[0.25], 
     LineBox[{2247, 2248}]}, 
    {Hue[
      NCache[
       Rational[2248, 14307], 0.1571258824351716]], AbsoluteThickness[0.25], 
     LineBox[{2248, 2249}]}, 
    {Hue[
      NCache[
       Rational[2249, 14307], 0.1571957782903474]], AbsoluteThickness[0.25], 
     LineBox[{2249, 2250}]}, 
    {Hue[
      NCache[
       Rational[750, 4769], 0.15726567414552317`]], AbsoluteThickness[0.25], 
     LineBox[{2250, 2251}]}, 
    {Hue[
      NCache[
       Rational[2251, 14307], 0.15733557000069895`]], AbsoluteThickness[0.25],
      LineBox[{2251, 2252}]}, 
    {Hue[
      NCache[
       Rational[2252, 14307], 0.15740546585587475`]], AbsoluteThickness[0.25],
      LineBox[{2252, 2253}]}, 
    {Hue[
      NCache[
       Rational[751, 4769], 0.15747536171105053`]], AbsoluteThickness[0.25], 
     LineBox[{2253, 2254}]}, 
    {Hue[
      NCache[
       Rational[2254, 14307], 0.1575452575662263]], AbsoluteThickness[0.25], 
     LineBox[{2254, 2255}]}, 
    {Hue[
      NCache[
       Rational[2255, 14307], 0.15761515342140212`]], AbsoluteThickness[0.25],
      LineBox[{2255, 2256}]}, 
    {Hue[
      NCache[
       Rational[752, 4769], 0.1576850492765779]], AbsoluteThickness[0.25], 
     LineBox[{2256, 2257}]}, 
    {Hue[
      NCache[
       Rational[2257, 14307], 0.1577549451317537]], AbsoluteThickness[0.25], 
     LineBox[{2257, 2258}]}, 
    {Hue[
      NCache[
       Rational[2258, 14307], 0.15782484098692948`]], AbsoluteThickness[0.25],
      LineBox[{2258, 2259}]}, 
    {Hue[
      NCache[
       Rational[3, 19], 0.15789473684210525`]], AbsoluteThickness[0.25], 
     LineBox[{2259, 2260}]}, 
    {Hue[
      NCache[
       Rational[2260, 14307], 0.15796463269728106`]], AbsoluteThickness[0.25],
      LineBox[{2260, 2261}]}, 
    {Hue[
      NCache[
       Rational[119, 753], 0.15803452855245684`]], AbsoluteThickness[0.25], 
     LineBox[{2261, 2262}]}, 
    {Hue[
      NCache[
       Rational[754, 4769], 0.15810442440763262`]], AbsoluteThickness[0.25], 
     LineBox[{2262, 2263}]}, 
    {Hue[
      NCache[
       Rational[2263, 14307], 0.15817432026280842`]], AbsoluteThickness[0.25],
      LineBox[{2263, 2264}]}, 
    {Hue[
      NCache[
       Rational[2264, 14307], 0.1582442161179842]], AbsoluteThickness[0.25], 
     LineBox[{2264, 2265}]}, 
    {Hue[
      NCache[
       Rational[755, 4769], 0.15831411197316]], AbsoluteThickness[0.25], 
     LineBox[{2265, 2266}]}, 
    {Hue[
      NCache[
       Rational[2266, 14307], 0.15838400782833578`]], AbsoluteThickness[0.25],
      LineBox[{2266, 2267}]}, 
    {Hue[
      NCache[
       Rational[2267, 14307], 0.15845390368351156`]], AbsoluteThickness[0.25],
      LineBox[{2267, 2268}]}, 
    {Hue[
      NCache[
       Rational[756, 4769], 0.15852379953868737`]], AbsoluteThickness[0.25], 
     LineBox[{2268, 2269}]}, 
    {Hue[
      NCache[
       Rational[2269, 14307], 0.15859369539386314`]], AbsoluteThickness[0.25],
      LineBox[{2269, 2270}]}, 
    {Hue[
      NCache[
       Rational[2270, 14307], 0.15866359124903892`]], AbsoluteThickness[0.25],
      LineBox[{2270, 2271}]}, 
    {Hue[
      NCache[
       Rational[757, 4769], 0.15873348710421473`]], AbsoluteThickness[0.25], 
     LineBox[{2271, 2272}]}, 
    {Hue[
      NCache[
       Rational[2272, 14307], 0.1588033829593905]], AbsoluteThickness[0.25], 
     LineBox[{2272, 2273}]}, 
    {Hue[
      NCache[
       Rational[2273, 14307], 0.1588732788145663]], AbsoluteThickness[0.25], 
     LineBox[{2273, 2274}]}, 
    {Hue[
      NCache[
       Rational[758, 4769], 0.1589431746697421]], AbsoluteThickness[0.25], 
     LineBox[{2274, 2275}]}, 
    {Hue[
      NCache[
       Rational[2275, 14307], 0.15901307052491787`]], AbsoluteThickness[0.25],
      LineBox[{2275, 2276}]}, 
    {Hue[
      NCache[
       Rational[2276, 14307], 0.15908296638009367`]], AbsoluteThickness[0.25],
      LineBox[{2276, 2277}]}, 
    {Hue[
      NCache[
       Rational[759, 4769], 0.15915286223526945`]], AbsoluteThickness[0.25], 
     LineBox[{2277, 2278}]}, 
    {Hue[
      NCache[
       Rational[2278, 14307], 0.15922275809044523`]], AbsoluteThickness[0.25],
      LineBox[{2278, 2279}]}, 
    {Hue[
      NCache[
       Rational[2279, 14307], 0.15929265394562103`]], AbsoluteThickness[0.25],
      LineBox[{2279, 2280}]}, 
    {Hue[
      NCache[
       Rational[40, 251], 0.1593625498007968]], AbsoluteThickness[0.25], 
     LineBox[{2280, 2281}]}, 
    {Hue[
      NCache[
       Rational[2281, 14307], 0.1594324456559726]], AbsoluteThickness[0.25], 
     LineBox[{2281, 2282}]}, 
    {Hue[
      NCache[
       Rational[2282, 14307], 0.1595023415111484]], AbsoluteThickness[0.25], 
     LineBox[{2282, 2283}]}, 
    {Hue[
      NCache[
       Rational[761, 4769], 0.15957223736632417`]], AbsoluteThickness[0.25], 
     LineBox[{2283, 2284}]}, 
    {Hue[
      NCache[
       Rational[2284, 14307], 0.15964213322149998`]], AbsoluteThickness[0.25],
      LineBox[{2284, 2285}]}, 
    {Hue[
      NCache[
       Rational[2285, 14307], 0.15971202907667575`]], AbsoluteThickness[0.25],
      LineBox[{2285, 2286}]}, 
    {Hue[
      NCache[
       Rational[762, 4769], 0.15978192493185153`]], AbsoluteThickness[0.25], 
     LineBox[{2286, 2287}]}, 
    {Hue[
      NCache[
       Rational[2287, 14307], 0.15985182078702734`]], AbsoluteThickness[0.25],
      LineBox[{2287, 2288}]}, 
    {Hue[
      NCache[
       Rational[2288, 14307], 0.15992171664220312`]], AbsoluteThickness[0.25],
      LineBox[{2288, 2289}]}, 
    {Hue[
      NCache[
       Rational[763, 4769], 0.1599916124973789]], AbsoluteThickness[0.25], 
     LineBox[{2289, 2290}]}, 
    {Hue[
      NCache[
       Rational[2290, 14307], 0.1600615083525547]], AbsoluteThickness[0.25], 
     LineBox[{2290, 2291}]}, 
    {Hue[
      NCache[
       Rational[2291, 14307], 0.16013140420773048`]], AbsoluteThickness[0.25],
      LineBox[{2291, 2292}]}, 
    {Hue[
      NCache[
       Rational[764, 4769], 0.16020130006290628`]], AbsoluteThickness[0.25], 
     LineBox[{2292, 2293}]}, 
    {Hue[
      NCache[
       Rational[2293, 14307], 0.16027119591808206`]], AbsoluteThickness[0.25],
      LineBox[{2293, 2294}]}, 
    {Hue[
      NCache[
       Rational[2294, 14307], 0.16034109177325784`]], AbsoluteThickness[0.25],
      LineBox[{2294, 2295}]}, 
    {Hue[
      NCache[
       Rational[765, 4769], 0.16041098762843364`]], AbsoluteThickness[0.25], 
     LineBox[{2295, 2296}]}, 
    {Hue[
      NCache[
       Rational[2296, 14307], 0.16048088348360942`]], AbsoluteThickness[0.25],
      LineBox[{2296, 2297}]}, 
    {Hue[
      NCache[
       Rational[2297, 14307], 0.1605507793387852]], AbsoluteThickness[0.25], 
     LineBox[{2297, 2298}]}, 
    {Hue[
      NCache[
       Rational[766, 4769], 0.160620675193961]], AbsoluteThickness[0.25], 
     LineBox[{2298, 2299}]}, 
    {Hue[
      NCache[
       Rational[121, 753], 0.16069057104913678`]], AbsoluteThickness[0.25], 
     LineBox[{2299, 2300}]}, 
    {Hue[
      NCache[
       Rational[2300, 14307], 0.1607604669043126]], AbsoluteThickness[0.25], 
     LineBox[{2300, 2301}]}, 
    {Hue[
      NCache[
       Rational[767, 4769], 0.16083036275948837`]], AbsoluteThickness[0.25], 
     LineBox[{2301, 2302}]}, 
    {Hue[
      NCache[
       Rational[2302, 14307], 0.16090025861466414`]], AbsoluteThickness[0.25],
      LineBox[{2302, 2303}]}, 
    {Hue[
      NCache[
       Rational[2303, 14307], 0.16097015446983995`]], AbsoluteThickness[0.25],
      LineBox[{2303, 2304}]}, 
    {Hue[
      NCache[
       Rational[768, 4769], 0.16104005032501573`]], AbsoluteThickness[0.25], 
     LineBox[{2304, 2305}]}, 
    {Hue[
      NCache[
       Rational[2305, 14307], 0.1611099461801915]], AbsoluteThickness[0.25], 
     LineBox[{2305, 2306}]}, 
    {Hue[
      NCache[
       Rational[2306, 14307], 0.1611798420353673]], AbsoluteThickness[0.25], 
     LineBox[{2306, 2307}]}, 
    {Hue[
      NCache[
       Rational[769, 4769], 0.1612497378905431]], AbsoluteThickness[0.25], 
     LineBox[{2307, 2308}]}, 
    {Hue[
      NCache[
       Rational[2308, 14307], 0.16131963374571887`]], AbsoluteThickness[0.25],
      LineBox[{2308, 2309}]}, 
    {Hue[
      NCache[
       Rational[2309, 14307], 0.16138952960089467`]], AbsoluteThickness[0.25],
      LineBox[{2309, 2310}]}, 
    {Hue[
      NCache[
       Rational[770, 4769], 0.16145942545607045`]], AbsoluteThickness[0.25], 
     LineBox[{2310, 2311}]}, 
    {Hue[
      NCache[
       Rational[2311, 14307], 0.16152932131124625`]], AbsoluteThickness[0.25],
      LineBox[{2311, 2312}]}, 
    {Hue[
      NCache[
       Rational[2312, 14307], 0.16159921716642203`]], AbsoluteThickness[0.25],
      LineBox[{2312, 2313}]}, 
    {Hue[
      NCache[
       Rational[771, 4769], 0.1616691130215978]], AbsoluteThickness[0.25], 
     LineBox[{2313, 2314}]}, 
    {Hue[
      NCache[
       Rational[2314, 14307], 0.16173900887677362`]], AbsoluteThickness[0.25],
      LineBox[{2314, 2315}]}, 
    {Hue[
      NCache[
       Rational[2315, 14307], 0.1618089047319494]], AbsoluteThickness[0.25], 
     LineBox[{2315, 2316}]}, 
    {Hue[
      NCache[
       Rational[772, 4769], 0.16187880058712517`]], AbsoluteThickness[0.25], 
     LineBox[{2316, 2317}]}, 
    {Hue[
      NCache[
       Rational[2317, 14307], 0.16194869644230098`]], AbsoluteThickness[0.25],
      LineBox[{2317, 2318}]}, 
    {Hue[
      NCache[
       Rational[122, 753], 0.16201859229747675`]], AbsoluteThickness[0.25], 
     LineBox[{2318, 2319}]}, 
    {Hue[
      NCache[
       Rational[773, 4769], 0.16208848815265256`]], AbsoluteThickness[0.25], 
     LineBox[{2319, 2320}]}, 
    {Hue[
      NCache[
       Rational[2320, 14307], 0.16215838400782834`]], AbsoluteThickness[0.25],
      LineBox[{2320, 2321}]}, 
    {Hue[
      NCache[
       Rational[2321, 14307], 0.16222827986300412`]], AbsoluteThickness[0.25],
      LineBox[{2321, 2322}]}, 
    {Hue[
      NCache[
       Rational[774, 4769], 0.16229817571817992`]], AbsoluteThickness[0.25], 
     LineBox[{2322, 2323}]}, 
    {Hue[
      NCache[
       Rational[2323, 14307], 0.1623680715733557]], AbsoluteThickness[0.25], 
     LineBox[{2323, 2324}]}, 
    {Hue[
      NCache[
       Rational[2324, 14307], 0.16243796742853148`]], AbsoluteThickness[0.25],
      LineBox[{2324, 2325}]}, 
    {Hue[
      NCache[
       Rational[775, 4769], 0.16250786328370728`]], AbsoluteThickness[0.25], 
     LineBox[{2325, 2326}]}, 
    {Hue[
      NCache[
       Rational[2326, 14307], 0.16257775913888306`]], AbsoluteThickness[0.25],
      LineBox[{2326, 2327}]}, 
    {Hue[
      NCache[
       Rational[2327, 14307], 0.16264765499405887`]], AbsoluteThickness[0.25],
      LineBox[{2327, 2328}]}, 
    {Hue[
      NCache[
       Rational[776, 4769], 0.16271755084923464`]], AbsoluteThickness[0.25], 
     LineBox[{2328, 2329}]}, 
    {Hue[
      NCache[
       Rational[2329, 14307], 0.16278744670441042`]], AbsoluteThickness[0.25],
      LineBox[{2329, 2330}]}, 
    {Hue[
      NCache[
       Rational[2330, 14307], 0.16285734255958623`]], AbsoluteThickness[0.25],
      LineBox[{2330, 2331}]}, 
    {Hue[
      NCache[
       Rational[777, 4769], 0.162927238414762]], AbsoluteThickness[0.25], 
     LineBox[{2331, 2332}]}, 
    {Hue[
      NCache[
       Rational[2332, 14307], 0.16299713426993778`]], AbsoluteThickness[0.25],
      LineBox[{2332, 2333}]}, 
    {Hue[
      NCache[
       Rational[2333, 14307], 0.1630670301251136]], AbsoluteThickness[0.25], 
     LineBox[{2333, 2334}]}, 
    {Hue[
      NCache[
       Rational[778, 4769], 0.16313692598028937`]], AbsoluteThickness[0.25], 
     LineBox[{2334, 2335}]}, 
    {Hue[
      NCache[
       Rational[2335, 14307], 0.16320682183546514`]], AbsoluteThickness[0.25],
      LineBox[{2335, 2336}]}, 
    {Hue[
      NCache[
       Rational[2336, 14307], 0.16327671769064095`]], AbsoluteThickness[0.25],
      LineBox[{2336, 2337}]}, 
    {Hue[
      NCache[
       Rational[41, 251], 0.16334661354581673`]], AbsoluteThickness[0.25], 
     LineBox[{2337, 2338}]}, 
    {Hue[
      NCache[
       Rational[2338, 14307], 0.16341650940099253`]], AbsoluteThickness[0.25],
      LineBox[{2338, 2339}]}, 
    {Hue[
      NCache[
       Rational[2339, 14307], 0.1634864052561683]], AbsoluteThickness[0.25], 
     LineBox[{2339, 2340}]}, 
    {Hue[
      NCache[
       Rational[780, 4769], 0.1635563011113441]], AbsoluteThickness[0.25], 
     LineBox[{2340, 2341}]}, 
    {Hue[
      NCache[
       Rational[2341, 14307], 0.1636261969665199]], AbsoluteThickness[0.25], 
     LineBox[{2341, 2342}]}, 
    {Hue[
      NCache[
       Rational[2342, 14307], 0.16369609282169567`]], AbsoluteThickness[0.25],
      LineBox[{2342, 2343}]}, 
    {Hue[
      NCache[
       Rational[781, 4769], 0.16376598867687145`]], AbsoluteThickness[0.25], 
     LineBox[{2343, 2344}]}, 
    {Hue[
      NCache[
       Rational[2344, 14307], 0.16383588453204725`]], AbsoluteThickness[0.25],
      LineBox[{2344, 2345}]}, 
    {Hue[
      NCache[
       Rational[2345, 14307], 0.16390578038722303`]], AbsoluteThickness[0.25],
      LineBox[{2345, 2346}]}, 
    {Hue[
      NCache[
       Rational[782, 4769], 0.16397567624239884`]], AbsoluteThickness[0.25], 
     LineBox[{2346, 2347}]}, 
    {Hue[
      NCache[
       Rational[2347, 14307], 0.16404557209757462`]], AbsoluteThickness[0.25],
      LineBox[{2347, 2348}]}, 
    {Hue[
      NCache[
       Rational[2348, 14307], 0.1641154679527504]], AbsoluteThickness[0.25], 
     LineBox[{2348, 2349}]}, 
    {Hue[
      NCache[
       Rational[783, 4769], 0.1641853638079262]], AbsoluteThickness[0.25], 
     LineBox[{2349, 2350}]}, 
    {Hue[
      NCache[
       Rational[2350, 14307], 0.16425525966310198`]], AbsoluteThickness[0.25],
      LineBox[{2350, 2351}]}, 
    {Hue[
      NCache[
       Rational[2351, 14307], 0.16432515551827775`]], AbsoluteThickness[0.25],
      LineBox[{2351, 2352}]}, 
    {Hue[
      NCache[
       Rational[784, 4769], 0.16439505137345356`]], AbsoluteThickness[0.25], 
     LineBox[{2352, 2353}]}, 
    {Hue[
      NCache[
       Rational[2353, 14307], 0.16446494722862934`]], AbsoluteThickness[0.25],
      LineBox[{2353, 2354}]}, 
    {Hue[
      NCache[
       Rational[2354, 14307], 0.16453484308380514`]], AbsoluteThickness[0.25],
      LineBox[{2354, 2355}]}, 
    {Hue[
      NCache[
       Rational[785, 4769], 0.16460473893898092`]], AbsoluteThickness[0.25], 
     LineBox[{2355, 2356}]}, 
    {Hue[
      NCache[
       Rational[124, 753], 0.1646746347941567]], AbsoluteThickness[0.25], 
     LineBox[{2356, 2357}]}, 
    {Hue[
      NCache[
       Rational[2357, 14307], 0.1647445306493325]], AbsoluteThickness[0.25], 
     LineBox[{2357, 2358}]}, 
    {Hue[
      NCache[
       Rational[786, 4769], 0.16481442650450828`]], AbsoluteThickness[0.25], 
     LineBox[{2358, 2359}]}, 
    {Hue[
      NCache[
       Rational[2359, 14307], 0.16488432235968406`]], AbsoluteThickness[0.25],
      LineBox[{2359, 2360}]}, 
    {Hue[
      NCache[
       Rational[2360, 14307], 0.16495421821485987`]], AbsoluteThickness[0.25],
      LineBox[{2360, 2361}]}, 
    {Hue[
      NCache[
       Rational[787, 4769], 0.16502411407003564`]], AbsoluteThickness[0.25], 
     LineBox[{2361, 2362}]}, 
    {Hue[
      NCache[
       Rational[2362, 14307], 0.16509400992521142`]], AbsoluteThickness[0.25],
      LineBox[{2362, 2363}]}, 
    {Hue[
      NCache[
       Rational[2363, 14307], 0.16516390578038723`]], AbsoluteThickness[0.25],
      LineBox[{2363, 2364}]}, 
    {Hue[
      NCache[
       Rational[788, 4769], 0.165233801635563]], AbsoluteThickness[0.25], 
     LineBox[{2364, 2365}]}, 
    {Hue[
      NCache[
       Rational[2365, 14307], 0.1653036974907388]], AbsoluteThickness[0.25], 
     LineBox[{2365, 2366}]}, 
    {Hue[
      NCache[
       Rational[2366, 14307], 0.1653735933459146]], AbsoluteThickness[0.25], 
     LineBox[{2366, 2367}]}, 
    {Hue[
      NCache[
       Rational[789, 4769], 0.16544348920109037`]], AbsoluteThickness[0.25], 
     LineBox[{2367, 2368}]}, 
    {Hue[
      NCache[
       Rational[2368, 14307], 0.16551338505626617`]], AbsoluteThickness[0.25],
      LineBox[{2368, 2369}]}, 
    {Hue[
      NCache[
       Rational[2369, 14307], 0.16558328091144195`]], AbsoluteThickness[0.25],
      LineBox[{2369, 2370}]}, 
    {Hue[
      NCache[
       Rational[790, 4769], 0.16565317676661773`]], AbsoluteThickness[0.25], 
     LineBox[{2370, 2371}]}, 
    {Hue[
      NCache[
       Rational[2371, 14307], 0.16572307262179353`]], AbsoluteThickness[0.25],
      LineBox[{2371, 2372}]}, 
    {Hue[
      NCache[
       Rational[2372, 14307], 0.1657929684769693]], AbsoluteThickness[0.25], 
     LineBox[{2372, 2373}]}, 
    {Hue[
      NCache[
       Rational[791, 4769], 0.16586286433214512`]], AbsoluteThickness[0.25], 
     LineBox[{2373, 2374}]}, 
    {Hue[
      NCache[
       Rational[2374, 14307], 0.1659327601873209]], AbsoluteThickness[0.25], 
     LineBox[{2374, 2375}]}, 
    {Hue[
      NCache[
       Rational[125, 753], 0.16600265604249667`]], AbsoluteThickness[0.25], 
     LineBox[{2375, 2376}]}, 
    {Hue[
      NCache[
       Rational[792, 4769], 0.16607255189767248`]], AbsoluteThickness[0.25], 
     LineBox[{2376, 2377}]}, 
    {Hue[
      NCache[
       Rational[2377, 14307], 0.16614244775284825`]], AbsoluteThickness[0.25],
      LineBox[{2377, 2378}]}, 
    {Hue[
      NCache[
       Rational[2378, 14307], 0.16621234360802403`]], AbsoluteThickness[0.25],
      LineBox[{2378, 2379}]}, 
    {Hue[
      NCache[
       Rational[793, 4769], 0.16628223946319984`]], AbsoluteThickness[0.25], 
     LineBox[{2379, 2380}]}, 
    {Hue[
      NCache[
       Rational[2380, 14307], 0.16635213531837562`]], AbsoluteThickness[0.25],
      LineBox[{2380, 2381}]}, 
    {Hue[
      NCache[
       Rational[2381, 14307], 0.16642203117355142`]], AbsoluteThickness[0.25],
      LineBox[{2381, 2382}]}, 
    {Hue[
      NCache[
       Rational[794, 4769], 0.1664919270287272]], AbsoluteThickness[0.25], 
     LineBox[{2382, 2383}]}, 
    {Hue[
      NCache[
       Rational[2383, 14307], 0.16656182288390298`]], AbsoluteThickness[0.25],
      LineBox[{2383, 2384}]}, 
    {Hue[
      NCache[
       Rational[2384, 14307], 0.16663171873907878`]], AbsoluteThickness[0.25],
      LineBox[{2384, 2385}]}, 
    {Hue[
      NCache[
       Rational[795, 4769], 0.16670161459425456`]], AbsoluteThickness[0.25], 
     LineBox[{2385, 2386}]}, 
    {Hue[
      NCache[
       Rational[2386, 14307], 0.16677151044943034`]], AbsoluteThickness[0.25],
      LineBox[{2386, 2387}]}, 
    {Hue[
      NCache[
       Rational[2387, 14307], 0.16684140630460614`]], AbsoluteThickness[0.25],
      LineBox[{2387, 2388}]}, 
    {Hue[
      NCache[
       Rational[796, 4769], 0.16691130215978192`]], AbsoluteThickness[0.25], 
     LineBox[{2388, 2389}]}, 
    {Hue[
      NCache[
       Rational[2389, 14307], 0.16698119801495773`]], AbsoluteThickness[0.25],
      LineBox[{2389, 2390}]}, 
    {Hue[
      NCache[
       Rational[2390, 14307], 0.1670510938701335]], AbsoluteThickness[0.25], 
     LineBox[{2390, 2391}]}, 
    {Hue[
      NCache[
       Rational[797, 4769], 0.16712098972530928`]], AbsoluteThickness[0.25], 
     LineBox[{2391, 2392}]}, 
    {Hue[
      NCache[
       Rational[2392, 14307], 0.1671908855804851]], AbsoluteThickness[0.25], 
     LineBox[{2392, 2393}]}, 
    {Hue[
      NCache[
       Rational[2393, 14307], 0.16726078143566087`]], AbsoluteThickness[0.25],
      LineBox[{2393, 2394}]}, 
    {Hue[
      NCache[
       Rational[42, 251], 0.16733067729083664`]], AbsoluteThickness[0.25], 
     LineBox[{2394, 2395}]}, 
    {Hue[
      NCache[
       Rational[2395, 14307], 0.16740057314601245`]], AbsoluteThickness[0.25],
      LineBox[{2395, 2396}]}, 
    {Hue[
      NCache[
       Rational[2396, 14307], 0.16747046900118823`]], AbsoluteThickness[0.25],
      LineBox[{2396, 2397}]}, 
    {Hue[
      NCache[
       Rational[799, 4769], 0.167540364856364]], AbsoluteThickness[0.25], 
     LineBox[{2397, 2398}]}, 
    {Hue[
      NCache[
       Rational[2398, 14307], 0.1676102607115398]], AbsoluteThickness[0.25], 
     LineBox[{2398, 2399}]}, 
    {Hue[
      NCache[
       Rational[2399, 14307], 0.1676801565667156]], AbsoluteThickness[0.25], 
     LineBox[{2399, 2400}]}, 
    {Hue[
      NCache[
       Rational[800, 4769], 0.1677500524218914]], AbsoluteThickness[0.25], 
     LineBox[{2400, 2401}]}, 
    {Hue[
      NCache[
       Rational[2401, 14307], 0.16781994827706717`]], AbsoluteThickness[0.25],
      LineBox[{2401, 2402}]}, 
    {Hue[
      NCache[
       Rational[2402, 14307], 0.16788984413224295`]], AbsoluteThickness[0.25],
      LineBox[{2402, 2403}]}, 
    {Hue[
      NCache[
       Rational[801, 4769], 0.16795973998741875`]], AbsoluteThickness[0.25], 
     LineBox[{2403, 2404}]}, 
    {Hue[
      NCache[
       Rational[2404, 14307], 0.16802963584259453`]], AbsoluteThickness[0.25],
      LineBox[{2404, 2405}]}, 
    {Hue[
      NCache[
       Rational[2405, 14307], 0.1680995316977703]], AbsoluteThickness[0.25], 
     LineBox[{2405, 2406}]}, 
    {Hue[
      NCache[
       Rational[802, 4769], 0.16816942755294612`]], AbsoluteThickness[0.25], 
     LineBox[{2406, 2407}]}, 
    {Hue[
      NCache[
       Rational[2407, 14307], 0.1682393234081219]], AbsoluteThickness[0.25], 
     LineBox[{2407, 2408}]}, 
    {Hue[
      NCache[
       Rational[2408, 14307], 0.1683092192632977]], AbsoluteThickness[0.25], 
     LineBox[{2408, 2409}]}, 
    {Hue[
      NCache[
       Rational[803, 4769], 0.16837911511847348`]], AbsoluteThickness[0.25], 
     LineBox[{2409, 2410}]}, 
    {Hue[
      NCache[
       Rational[2410, 14307], 0.16844901097364925`]], AbsoluteThickness[0.25],
      LineBox[{2410, 2411}]}, 
    {Hue[
      NCache[
       Rational[2411, 14307], 0.16851890682882506`]], AbsoluteThickness[0.25],
      LineBox[{2411, 2412}]}, 
    {Hue[
      NCache[
       Rational[804, 4769], 0.16858880268400084`]], AbsoluteThickness[0.25], 
     LineBox[{2412, 2413}]}, 
    {Hue[
      NCache[
       Rational[127, 753], 0.16865869853917662`]], AbsoluteThickness[0.25], 
     LineBox[{2413, 2414}]}, 
    {Hue[
      NCache[
       Rational[2414, 14307], 0.16872859439435242`]], AbsoluteThickness[0.25],
      LineBox[{2414, 2415}]}, 
    {Hue[
      NCache[
       Rational[805, 4769], 0.1687984902495282]], AbsoluteThickness[0.25], 
     LineBox[{2415, 2416}]}, 
    {Hue[
      NCache[
       Rational[2416, 14307], 0.168868386104704]], AbsoluteThickness[0.25], 
     LineBox[{2416, 2417}]}, 
    {Hue[
      NCache[
       Rational[2417, 14307], 0.16893828195987978`]], AbsoluteThickness[0.25],
      LineBox[{2417, 2418}]}, 
    {Hue[
      NCache[
       Rational[806, 4769], 0.16900817781505556`]], AbsoluteThickness[0.25], 
     LineBox[{2418, 2419}]}, 
    {Hue[
      NCache[
       Rational[2419, 14307], 0.16907807367023137`]], AbsoluteThickness[0.25],
      LineBox[{2419, 2420}]}, 
    {Hue[
      NCache[
       Rational[2420, 14307], 0.16914796952540714`]], AbsoluteThickness[0.25],
      LineBox[{2420, 2421}]}, 
    {Hue[
      NCache[
       Rational[807, 4769], 0.16921786538058292`]], AbsoluteThickness[0.25], 
     LineBox[{2421, 2422}]}, 
    {Hue[
      NCache[
       Rational[2422, 14307], 0.16928776123575873`]], AbsoluteThickness[0.25],
      LineBox[{2422, 2423}]}, 
    {Hue[
      NCache[
       Rational[2423, 14307], 0.1693576570909345]], AbsoluteThickness[0.25], 
     LineBox[{2423, 2424}]}, 
    {Hue[
      NCache[
       Rational[808, 4769], 0.16942755294611028`]], AbsoluteThickness[0.25], 
     LineBox[{2424, 2425}]}, 
    {Hue[
      NCache[
       Rational[2425, 14307], 0.1694974488012861]], AbsoluteThickness[0.25], 
     LineBox[{2425, 2426}]}, 
    {Hue[
      NCache[
       Rational[2426, 14307], 0.16956734465646187`]], AbsoluteThickness[0.25],
      LineBox[{2426, 2427}]}, 
    {Hue[
      NCache[
       Rational[809, 4769], 0.16963724051163767`]], AbsoluteThickness[0.25], 
     LineBox[{2427, 2428}]}, 
    {Hue[
      NCache[
       Rational[2428, 14307], 0.16970713636681345`]], AbsoluteThickness[0.25],
      LineBox[{2428, 2429}]}, 
    {Hue[
      NCache[
       Rational[2429, 14307], 0.16977703222198923`]], AbsoluteThickness[0.25],
      LineBox[{2429, 2430}]}, 
    {Hue[
      NCache[
       Rational[810, 4769], 0.16984692807716503`]], AbsoluteThickness[0.25], 
     LineBox[{2430, 2431}]}, 
    {Hue[
      NCache[
       Rational[2431, 14307], 0.1699168239323408]], AbsoluteThickness[0.25], 
     LineBox[{2431, 2432}]}, 
    {Hue[
      NCache[
       Rational[128, 753], 0.1699867197875166]], AbsoluteThickness[0.25], 
     LineBox[{2432, 2433}]}, 
    {Hue[
      NCache[
       Rational[811, 4769], 0.1700566156426924]], AbsoluteThickness[0.25], 
     LineBox[{2433, 2434}]}, 
    {Hue[
      NCache[
       Rational[2434, 14307], 0.17012651149786817`]], AbsoluteThickness[0.25],
      LineBox[{2434, 2435}]}, 
    {Hue[
      NCache[
       Rational[2435, 14307], 0.17019640735304398`]], AbsoluteThickness[0.25],
      LineBox[{2435, 2436}]}, 
    {Hue[
      NCache[
       Rational[812, 4769], 0.17026630320821975`]], AbsoluteThickness[0.25], 
     LineBox[{2436, 2437}]}, 
    {Hue[
      NCache[
       Rational[2437, 14307], 0.17033619906339553`]], AbsoluteThickness[0.25],
      LineBox[{2437, 2438}]}, 
    {Hue[
      NCache[
       Rational[2438, 14307], 0.17040609491857134`]], AbsoluteThickness[0.25],
      LineBox[{2438, 2439}]}, 
    {Hue[
      NCache[
       Rational[813, 4769], 0.17047599077374712`]], AbsoluteThickness[0.25], 
     LineBox[{2439, 2440}]}, 
    {Hue[
      NCache[
       Rational[2440, 14307], 0.1705458866289229]], AbsoluteThickness[0.25], 
     LineBox[{2440, 2441}]}, 
    {Hue[
      NCache[
       Rational[2441, 14307], 0.1706157824840987]], AbsoluteThickness[0.25], 
     LineBox[{2441, 2442}]}, 
    {Hue[
      NCache[
       Rational[814, 4769], 0.17068567833927448`]], AbsoluteThickness[0.25], 
     LineBox[{2442, 2443}]}, 
    {Hue[
      NCache[
       Rational[2443, 14307], 0.17075557419445028`]], AbsoluteThickness[0.25],
      LineBox[{2443, 2444}]}, 
    {Hue[
      NCache[
       Rational[2444, 14307], 0.17082547004962606`]], AbsoluteThickness[0.25],
      LineBox[{2444, 2445}]}, 
    {Hue[
      NCache[
       Rational[815, 4769], 0.17089536590480184`]], AbsoluteThickness[0.25], 
     LineBox[{2445, 2446}]}, 
    {Hue[
      NCache[
       Rational[2446, 14307], 0.17096526175997764`]], AbsoluteThickness[0.25],
      LineBox[{2446, 2447}]}, 
    {Hue[
      NCache[
       Rational[2447, 14307], 0.17103515761515342`]], AbsoluteThickness[0.25],
      LineBox[{2447, 2448}]}, 
    {Hue[
      NCache[
       Rational[816, 4769], 0.1711050534703292]], AbsoluteThickness[0.25], 
     LineBox[{2448, 2449}]}, 
    {Hue[
      NCache[
       Rational[2449, 14307], 0.171174949325505]], AbsoluteThickness[0.25], 
     LineBox[{2449, 2450}]}, 
    {Hue[
      NCache[
       Rational[2450, 14307], 0.17124484518068078`]], AbsoluteThickness[0.25],
      LineBox[{2450, 2451}]}, 
    {Hue[
      NCache[
       Rational[43, 251], 0.17131474103585656`]], AbsoluteThickness[0.25], 
     LineBox[{2451, 2452}]}, 
    {Hue[
      NCache[
       Rational[2452, 14307], 0.17138463689103237`]], AbsoluteThickness[0.25],
      LineBox[{2452, 2453}]}, 
    {Hue[
      NCache[
       Rational[2453, 14307], 0.17145453274620814`]], AbsoluteThickness[0.25],
      LineBox[{2453, 2454}]}, 
    {Hue[
      NCache[
       Rational[818, 4769], 0.17152442860138395`]], AbsoluteThickness[0.25], 
     LineBox[{2454, 2455}]}, 
    {Hue[
      NCache[
       Rational[2455, 14307], 0.17159432445655973`]], AbsoluteThickness[0.25],
      LineBox[{2455, 2456}]}, 
    {Hue[
      NCache[
       Rational[2456, 14307], 0.1716642203117355]], AbsoluteThickness[0.25], 
     LineBox[{2456, 2457}]}, 
    {Hue[
      NCache[
       Rational[819, 4769], 0.1717341161669113]], AbsoluteThickness[0.25], 
     LineBox[{2457, 2458}]}, 
    {Hue[
      NCache[
       Rational[2458, 14307], 0.1718040120220871]], AbsoluteThickness[0.25], 
     LineBox[{2458, 2459}]}, 
    {Hue[
      NCache[
       Rational[2459, 14307], 0.17187390787726287`]], AbsoluteThickness[0.25],
      LineBox[{2459, 2460}]}, 
    {Hue[
      NCache[
       Rational[820, 4769], 0.17194380373243867`]], AbsoluteThickness[0.25], 
     LineBox[{2460, 2461}]}, 
    {Hue[
      NCache[
       Rational[2461, 14307], 0.17201369958761445`]], AbsoluteThickness[0.25],
      LineBox[{2461, 2462}]}, 
    {Hue[
      NCache[
       Rational[2462, 14307], 0.17208359544279025`]], AbsoluteThickness[0.25],
      LineBox[{2462, 2463}]}, 
    {Hue[
      NCache[
       Rational[821, 4769], 0.17215349129796603`]], AbsoluteThickness[0.25], 
     LineBox[{2463, 2464}]}, 
    {Hue[
      NCache[
       Rational[2464, 14307], 0.1722233871531418]], AbsoluteThickness[0.25], 
     LineBox[{2464, 2465}]}, 
    {Hue[
      NCache[
       Rational[2465, 14307], 0.17229328300831762`]], AbsoluteThickness[0.25],
      LineBox[{2465, 2466}]}, 
    {Hue[
      NCache[
       Rational[822, 4769], 0.1723631788634934]], AbsoluteThickness[0.25], 
     LineBox[{2466, 2467}]}, 
    {Hue[
      NCache[
       Rational[2467, 14307], 0.17243307471866917`]], AbsoluteThickness[0.25],
      LineBox[{2467, 2468}]}, 
    {Hue[
      NCache[
       Rational[2468, 14307], 0.17250297057384498`]], AbsoluteThickness[0.25],
      LineBox[{2468, 2469}]}, 
    {Hue[
      NCache[
       Rational[823, 4769], 0.17257286642902075`]], AbsoluteThickness[0.25], 
     LineBox[{2469, 2470}]}, 
    {Hue[
      NCache[
       Rational[130, 753], 0.17264276228419656`]], AbsoluteThickness[0.25], 
     LineBox[{2470, 2471}]}, 
    {Hue[
      NCache[
       Rational[2471, 14307], 0.17271265813937234`]], AbsoluteThickness[0.25],
      LineBox[{2471, 2472}]}, 
    {Hue[
      NCache[
       Rational[824, 4769], 0.17278255399454812`]], AbsoluteThickness[0.25], 
     LineBox[{2472, 2473}]}, 
    {Hue[
      NCache[
       Rational[2473, 14307], 0.17285244984972392`]], AbsoluteThickness[0.25],
      LineBox[{2473, 2474}]}, 
    {Hue[
      NCache[
       Rational[2474, 14307], 0.1729223457048997]], AbsoluteThickness[0.25], 
     LineBox[{2474, 2475}]}, 
    {Hue[
      NCache[
       Rational[825, 4769], 0.17299224156007548`]], AbsoluteThickness[0.25], 
     LineBox[{2475, 2476}]}, 
    {Hue[
      NCache[
       Rational[2476, 14307], 0.17306213741525128`]], AbsoluteThickness[0.25],
      LineBox[{2476, 2477}]}, 
    {Hue[
      NCache[
       Rational[2477, 14307], 0.17313203327042706`]], AbsoluteThickness[0.25],
      LineBox[{2477, 2478}]}, 
    {Hue[
      NCache[
       Rational[826, 4769], 0.17320192912560284`]], AbsoluteThickness[0.25], 
     LineBox[{2478, 2479}]}, 
    {Hue[
      NCache[
       Rational[2479, 14307], 0.17327182498077864`]], AbsoluteThickness[0.25],
      LineBox[{2479, 2480}]}, 
    {Hue[
      NCache[
       Rational[2480, 14307], 0.17334172083595442`]], AbsoluteThickness[0.25],
      LineBox[{2480, 2481}]}, 
    {Hue[
      NCache[
       Rational[827, 4769], 0.17341161669113023`]], AbsoluteThickness[0.25], 
     LineBox[{2481, 2482}]}, 
    {Hue[
      NCache[
       Rational[2482, 14307], 0.173481512546306]], AbsoluteThickness[0.25], 
     LineBox[{2482, 2483}]}, 
    {Hue[
      NCache[
       Rational[2483, 14307], 0.17355140840148178`]], AbsoluteThickness[0.25],
      LineBox[{2483, 2484}]}, 
    {Hue[
      NCache[
       Rational[828, 4769], 0.1736213042566576]], AbsoluteThickness[0.25], 
     LineBox[{2484, 2485}]}, 
    {Hue[
      NCache[
       Rational[2485, 14307], 0.17369120011183337`]], AbsoluteThickness[0.25],
      LineBox[{2485, 2486}]}, 
    {Hue[
      NCache[
       Rational[2486, 14307], 0.17376109596700914`]], AbsoluteThickness[0.25],
      LineBox[{2486, 2487}]}, 
    {Hue[
      NCache[
       Rational[829, 4769], 0.17383099182218495`]], AbsoluteThickness[0.25], 
     LineBox[{2487, 2488}]}, 
    {Hue[
      NCache[
       Rational[2488, 14307], 0.17390088767736073`]], AbsoluteThickness[0.25],
      LineBox[{2488, 2489}]}, 
    {Hue[
      NCache[
       Rational[131, 753], 0.17397078353253653`]], AbsoluteThickness[0.25], 
     LineBox[{2489, 2490}]}, 
    {Hue[
      NCache[
       Rational[830, 4769], 0.1740406793877123]], AbsoluteThickness[0.25], 
     LineBox[{2490, 2491}]}, 
    {Hue[
      NCache[
       Rational[2491, 14307], 0.1741105752428881]], AbsoluteThickness[0.25], 
     LineBox[{2491, 2492}]}, 
    {Hue[
      NCache[
       Rational[2492, 14307], 0.1741804710980639]], AbsoluteThickness[0.25], 
     LineBox[{2492, 2493}]}, 
    {Hue[
      NCache[
       Rational[831, 4769], 0.17425036695323967`]], AbsoluteThickness[0.25], 
     LineBox[{2493, 2494}]}, 
    {Hue[
      NCache[
       Rational[2494, 14307], 0.17432026280841545`]], AbsoluteThickness[0.25],
      LineBox[{2494, 2495}]}, 
    {Hue[
      NCache[
       Rational[2495, 14307], 0.17439015866359125`]], AbsoluteThickness[0.25],
      LineBox[{2495, 2496}]}, 
    {Hue[
      NCache[
       Rational[832, 4769], 0.17446005451876703`]], AbsoluteThickness[0.25], 
     LineBox[{2496, 2497}]}, 
    {Hue[
      NCache[
       Rational[2497, 14307], 0.17452995037394284`]], AbsoluteThickness[0.25],
      LineBox[{2497, 2498}]}, 
    {Hue[
      NCache[
       Rational[2498, 14307], 0.17459984622911862`]], AbsoluteThickness[0.25],
      LineBox[{2498, 2499}]}, 
    {Hue[
      NCache[
       Rational[833, 4769], 0.1746697420842944]], AbsoluteThickness[0.25], 
     LineBox[{2499, 2500}]}, 
    {Hue[
      NCache[
       Rational[2500, 14307], 0.1747396379394702]], AbsoluteThickness[0.25], 
     LineBox[{2500, 2501}]}, 
    {Hue[
      NCache[
       Rational[2501, 14307], 0.17480953379464598`]], AbsoluteThickness[0.25],
      LineBox[{2501, 2502}]}, 
    {Hue[
      NCache[
       Rational[834, 4769], 0.17487942964982175`]], AbsoluteThickness[0.25], 
     LineBox[{2502, 2503}]}, 
    {Hue[
      NCache[
       Rational[2503, 14307], 0.17494932550499756`]], AbsoluteThickness[0.25],
      LineBox[{2503, 2504}]}, 
    {Hue[
      NCache[
       Rational[2504, 14307], 0.17501922136017334`]], AbsoluteThickness[0.25],
      LineBox[{2504, 2505}]}, 
    {Hue[
      NCache[
       Rational[835, 4769], 0.17508911721534912`]], AbsoluteThickness[0.25], 
     LineBox[{2505, 2506}]}, 
    {Hue[
      NCache[
       Rational[2506, 14307], 0.17515901307052492`]], AbsoluteThickness[0.25],
      LineBox[{2506, 2507}]}, 
    {Hue[
      NCache[
       Rational[2507, 14307], 0.1752289089257007]], AbsoluteThickness[0.25], 
     LineBox[{2507, 2508}]}, 
    {Hue[
      NCache[
       Rational[44, 251], 0.1752988047808765]], AbsoluteThickness[0.25], 
     LineBox[{2508, 2509}]}, 
    {Hue[
      NCache[
       Rational[2509, 14307], 0.17536870063605228`]], AbsoluteThickness[0.25],
      LineBox[{2509, 2510}]}, 
    {Hue[
      NCache[
       Rational[10, 57], 0.17543859649122806`]], AbsoluteThickness[0.25], 
     LineBox[{2510, 2511}]}, 
    {Hue[
      NCache[
       Rational[837, 4769], 0.17550849234640387`]], AbsoluteThickness[0.25], 
     LineBox[{2511, 2512}]}, 
    {Hue[
      NCache[
       Rational[2512, 14307], 0.17557838820157964`]], AbsoluteThickness[0.25],
      LineBox[{2512, 2513}]}, 
    {Hue[
      NCache[
       Rational[2513, 14307], 0.17564828405675542`]], AbsoluteThickness[0.25],
      LineBox[{2513, 2514}]}, 
    {Hue[
      NCache[
       Rational[838, 4769], 0.17571817991193123`]], AbsoluteThickness[0.25], 
     LineBox[{2514, 2515}]}, 
    {Hue[
      NCache[
       Rational[2515, 14307], 0.175788075767107]], AbsoluteThickness[0.25], 
     LineBox[{2515, 2516}]}, 
    {Hue[
      NCache[
       Rational[2516, 14307], 0.1758579716222828]], AbsoluteThickness[0.25], 
     LineBox[{2516, 2517}]}, 
    {Hue[
      NCache[
       Rational[839, 4769], 0.1759278674774586]], AbsoluteThickness[0.25], 
     LineBox[{2517, 2518}]}, 
    {Hue[
      NCache[
       Rational[2518, 14307], 0.17599776333263437`]], AbsoluteThickness[0.25],
      LineBox[{2518, 2519}]}, 
    {Hue[
      NCache[
       Rational[2519, 14307], 0.17606765918781017`]], AbsoluteThickness[0.25],
      LineBox[{2519, 2520}]}, 
    {Hue[
      NCache[
       Rational[840, 4769], 0.17613755504298595`]], AbsoluteThickness[0.25], 
     LineBox[{2520, 2521}]}, 
    {Hue[
      NCache[
       Rational[2521, 14307], 0.17620745089816173`]], AbsoluteThickness[0.25],
      LineBox[{2521, 2522}]}, 
    {Hue[
      NCache[
       Rational[2522, 14307], 0.17627734675333753`]], AbsoluteThickness[0.25],
      LineBox[{2522, 2523}]}, 
    {Hue[
      NCache[
       Rational[841, 4769], 0.1763472426085133]], AbsoluteThickness[0.25], 
     LineBox[{2523, 2524}]}, 
    {Hue[
      NCache[
       Rational[2524, 14307], 0.17641713846368912`]], AbsoluteThickness[0.25],
      LineBox[{2524, 2525}]}, 
    {Hue[
      NCache[
       Rational[2525, 14307], 0.1764870343188649]], AbsoluteThickness[0.25], 
     LineBox[{2525, 2526}]}, 
    {Hue[
      NCache[
       Rational[842, 4769], 0.17655693017404067`]], AbsoluteThickness[0.25], 
     LineBox[{2526, 2527}]}, 
    {Hue[
      NCache[
       Rational[133, 753], 0.17662682602921648`]], AbsoluteThickness[0.25], 
     LineBox[{2527, 2528}]}, 
    {Hue[
      NCache[
       Rational[2528, 14307], 0.17669672188439225`]], AbsoluteThickness[0.25],
      LineBox[{2528, 2529}]}, 
    {Hue[
      NCache[
       Rational[843, 4769], 0.17676661773956803`]], AbsoluteThickness[0.25], 
     LineBox[{2529, 2530}]}, 
    {Hue[
      NCache[
       Rational[2530, 14307], 0.17683651359474384`]], AbsoluteThickness[0.25],
      LineBox[{2530, 2531}]}, 
    {Hue[
      NCache[
       Rational[2531, 14307], 0.17690640944991962`]], AbsoluteThickness[0.25],
      LineBox[{2531, 2532}]}, 
    {Hue[
      NCache[
       Rational[844, 4769], 0.17697630530509542`]], AbsoluteThickness[0.25], 
     LineBox[{2532, 2533}]}, 
    {Hue[
      NCache[
       Rational[2533, 14307], 0.1770462011602712]], AbsoluteThickness[0.25], 
     LineBox[{2533, 2534}]}, 
    {Hue[
      NCache[
       Rational[2534, 14307], 0.17711609701544698`]], AbsoluteThickness[0.25],
      LineBox[{2534, 2535}]}, 
    {Hue[
      NCache[
       Rational[845, 4769], 0.17718599287062278`]], AbsoluteThickness[0.25], 
     LineBox[{2535, 2536}]}, 
    {Hue[
      NCache[
       Rational[2536, 14307], 0.17725588872579856`]], AbsoluteThickness[0.25],
      LineBox[{2536, 2537}]}, 
    {Hue[
      NCache[
       Rational[2537, 14307], 0.17732578458097434`]], AbsoluteThickness[0.25],
      LineBox[{2537, 2538}]}, 
    {Hue[
      NCache[
       Rational[846, 4769], 0.17739568043615014`]], AbsoluteThickness[0.25], 
     LineBox[{2538, 2539}]}, 
    {Hue[
      NCache[
       Rational[2539, 14307], 0.17746557629132592`]], AbsoluteThickness[0.25],
      LineBox[{2539, 2540}]}, 
    {Hue[
      NCache[
       Rational[2540, 14307], 0.1775354721465017]], AbsoluteThickness[0.25], 
     LineBox[{2540, 2541}]}, 
    {Hue[
      NCache[
       Rational[847, 4769], 0.1776053680016775]], AbsoluteThickness[0.25], 
     LineBox[{2541, 2542}]}, 
    {Hue[
      NCache[
       Rational[2542, 14307], 0.17767526385685328`]], AbsoluteThickness[0.25],
      LineBox[{2542, 2543}]}, 
    {Hue[
      NCache[
       Rational[2543, 14307], 0.1777451597120291]], AbsoluteThickness[0.25], 
     LineBox[{2543, 2544}]}, 
    {Hue[
      NCache[
       Rational[848, 4769], 0.17781505556720487`]], AbsoluteThickness[0.25], 
     LineBox[{2544, 2545}]}, 
    {Hue[
      NCache[
       Rational[2545, 14307], 0.17788495142238064`]], AbsoluteThickness[0.25],
      LineBox[{2545, 2546}]}, 
    {Hue[
      NCache[
       Rational[134, 753], 0.17795484727755645`]], AbsoluteThickness[0.25], 
     LineBox[{2546, 2547}]}, 
    {Hue[
      NCache[
       Rational[849, 4769], 0.17802474313273223`]], AbsoluteThickness[0.25], 
     LineBox[{2547, 2548}]}, 
    {Hue[
      NCache[
       Rational[2548, 14307], 0.178094638987908]], AbsoluteThickness[0.25], 
     LineBox[{2548, 2549}]}, 
    {Hue[
      NCache[
       Rational[2549, 14307], 0.1781645348430838]], AbsoluteThickness[0.25], 
     LineBox[{2549, 2550}]}, 
    {Hue[
      NCache[
       Rational[850, 4769], 0.1782344306982596]], AbsoluteThickness[0.25], 
     LineBox[{2550, 2551}]}, 
    {Hue[
      NCache[
       Rational[2551, 14307], 0.1783043265534354]], AbsoluteThickness[0.25], 
     LineBox[{2551, 2552}]}, 
    {Hue[
      NCache[
       Rational[2552, 14307], 0.17837422240861117`]], AbsoluteThickness[0.25],
      LineBox[{2552, 2553}]}, 
    {Hue[
      NCache[
       Rational[851, 4769], 0.17844411826378695`]], AbsoluteThickness[0.25], 
     LineBox[{2553, 2554}]}, 
    {Hue[
      NCache[
       Rational[2554, 14307], 0.17851401411896275`]], AbsoluteThickness[0.25],
      LineBox[{2554, 2555}]}, 
    {Hue[
      NCache[
       Rational[2555, 14307], 0.17858390997413853`]], AbsoluteThickness[0.25],
      LineBox[{2555, 2556}]}, 
    {Hue[
      NCache[
       Rational[852, 4769], 0.1786538058293143]], AbsoluteThickness[0.25], 
     LineBox[{2556, 2557}]}, 
    {Hue[
      NCache[
       Rational[2557, 14307], 0.17872370168449012`]], AbsoluteThickness[0.25],
      LineBox[{2557, 2558}]}, 
    {Hue[
      NCache[
       Rational[2558, 14307], 0.1787935975396659]], AbsoluteThickness[0.25], 
     LineBox[{2558, 2559}]}, 
    {Hue[
      NCache[
       Rational[853, 4769], 0.1788634933948417]], AbsoluteThickness[0.25], 
     LineBox[{2559, 2560}]}, 
    {Hue[
      NCache[
       Rational[2560, 14307], 0.17893338925001748`]], AbsoluteThickness[0.25],
      LineBox[{2560, 2561}]}, 
    {Hue[
      NCache[
       Rational[2561, 14307], 0.17900328510519325`]], AbsoluteThickness[0.25],
      LineBox[{2561, 2562}]}, 
    {Hue[
      NCache[
       Rational[854, 4769], 0.17907318096036906`]], AbsoluteThickness[0.25], 
     LineBox[{2562, 2563}]}, 
    {Hue[
      NCache[
       Rational[2563, 14307], 0.17914307681554484`]], AbsoluteThickness[0.25],
      LineBox[{2563, 2564}]}, 
    {Hue[
      NCache[
       Rational[2564, 14307], 0.17921297267072062`]], AbsoluteThickness[0.25],
      LineBox[{2564, 2565}]}, 
    {Hue[
      NCache[
       Rational[45, 251], 0.17928286852589642`]], AbsoluteThickness[0.25], 
     LineBox[{2565, 2566}]}, 
    {Hue[
      NCache[
       Rational[2566, 14307], 0.1793527643810722]], AbsoluteThickness[0.25], 
     LineBox[{2566, 2567}]}, 
    {Hue[
      NCache[
       Rational[2567, 14307], 0.17942266023624798`]], AbsoluteThickness[0.25],
      LineBox[{2567, 2568}]}, 
    {Hue[
      NCache[
       Rational[856, 4769], 0.17949255609142378`]], AbsoluteThickness[0.25], 
     LineBox[{2568, 2569}]}, 
    {Hue[
      NCache[
       Rational[2569, 14307], 0.17956245194659956`]], AbsoluteThickness[0.25],
      LineBox[{2569, 2570}]}, 
    {Hue[
      NCache[
       Rational[2570, 14307], 0.17963234780177537`]], AbsoluteThickness[0.25],
      LineBox[{2570, 2571}]}, 
    {Hue[
      NCache[
       Rational[857, 4769], 0.17970224365695114`]], AbsoluteThickness[0.25], 
     LineBox[{2571, 2572}]}, 
    {Hue[
      NCache[
       Rational[2572, 14307], 0.17977213951212692`]], AbsoluteThickness[0.25],
      LineBox[{2572, 2573}]}, 
    {Hue[
      NCache[
       Rational[2573, 14307], 0.17984203536730273`]], AbsoluteThickness[0.25],
      LineBox[{2573, 2574}]}, 
    {Hue[
      NCache[
       Rational[858, 4769], 0.1799119312224785]], AbsoluteThickness[0.25], 
     LineBox[{2574, 2575}]}, 
    {Hue[
      NCache[
       Rational[2575, 14307], 0.17998182707765428`]], AbsoluteThickness[0.25],
      LineBox[{2575, 2576}]}, 
    {Hue[
      NCache[
       Rational[2576, 14307], 0.1800517229328301]], AbsoluteThickness[0.25], 
     LineBox[{2576, 2577}]}, 
    {Hue[
      NCache[
       Rational[859, 4769], 0.18012161878800587`]], AbsoluteThickness[0.25], 
     LineBox[{2577, 2578}]}, 
    {Hue[
      NCache[
       Rational[2578, 14307], 0.18019151464318167`]], AbsoluteThickness[0.25],
      LineBox[{2578, 2579}]}, 
    {Hue[
      NCache[
       Rational[2579, 14307], 0.18026141049835745`]], AbsoluteThickness[0.25],
      LineBox[{2579, 2580}]}, 
    {Hue[
      NCache[
       Rational[860, 4769], 0.18033130635353323`]], AbsoluteThickness[0.25], 
     LineBox[{2580, 2581}]}, 
    {Hue[
      NCache[
       Rational[2581, 14307], 0.18040120220870903`]], AbsoluteThickness[0.25],
      LineBox[{2581, 2582}]}, 
    {Hue[
      NCache[
       Rational[2582, 14307], 0.1804710980638848]], AbsoluteThickness[0.25], 
     LineBox[{2582, 2583}]}, 
    {Hue[
      NCache[
       Rational[861, 4769], 0.1805409939190606]], AbsoluteThickness[0.25], 
     LineBox[{2583, 2584}]}, 
    {Hue[
      NCache[
       Rational[136, 753], 0.1806108897742364]], AbsoluteThickness[0.25], 
     LineBox[{2584, 2585}]}, 
    {Hue[
      NCache[
       Rational[2585, 14307], 0.18068078562941217`]], AbsoluteThickness[0.25],
      LineBox[{2585, 2586}]}, 
    {Hue[
      NCache[
       Rational[862, 4769], 0.18075068148458798`]], AbsoluteThickness[0.25], 
     LineBox[{2586, 2587}]}, 
    {Hue[
      NCache[
       Rational[2587, 14307], 0.18082057733976376`]], AbsoluteThickness[0.25],
      LineBox[{2587, 2588}]}, 
    {Hue[
      NCache[
       Rational[2588, 14307], 0.18089047319493953`]], AbsoluteThickness[0.25],
      LineBox[{2588, 2589}]}, 
    {Hue[
      NCache[
       Rational[863, 4769], 0.18096036905011534`]], AbsoluteThickness[0.25], 
     LineBox[{2589, 2590}]}, 
    {Hue[
      NCache[
       Rational[2590, 14307], 0.18103026490529112`]], AbsoluteThickness[0.25],
      LineBox[{2590, 2591}]}, 
    {Hue[
      NCache[
       Rational[2591, 14307], 0.1811001607604669]], AbsoluteThickness[0.25], 
     LineBox[{2591, 2592}]}, 
    {Hue[
      NCache[
       Rational[864, 4769], 0.1811700566156427]], AbsoluteThickness[0.25], 
     LineBox[{2592, 2593}]}, 
    {Hue[
      NCache[
       Rational[2593, 14307], 0.18123995247081848`]], AbsoluteThickness[0.25],
      LineBox[{2593, 2594}]}, 
    {Hue[
      NCache[
       Rational[2594, 14307], 0.18130984832599426`]], AbsoluteThickness[0.25],
      LineBox[{2594, 2595}]}, 
    {Hue[
      NCache[
       Rational[865, 4769], 0.18137974418117006`]], AbsoluteThickness[0.25], 
     LineBox[{2595, 2596}]}, 
    {Hue[
      NCache[
       Rational[2596, 14307], 0.18144964003634584`]], AbsoluteThickness[0.25],
      LineBox[{2596, 2597}]}, 
    {Hue[
      NCache[
       Rational[2597, 14307], 0.18151953589152164`]], AbsoluteThickness[0.25],
      LineBox[{2597, 2598}]}, 
    {Hue[
      NCache[
       Rational[866, 4769], 0.18158943174669742`]], AbsoluteThickness[0.25], 
     LineBox[{2598, 2599}]}, 
    {Hue[
      NCache[
       Rational[2599, 14307], 0.1816593276018732]], AbsoluteThickness[0.25], 
     LineBox[{2599, 2600}]}, 
    {Hue[
      NCache[
       Rational[2600, 14307], 0.181729223457049]], AbsoluteThickness[0.25], 
     LineBox[{2600, 2601}]}, 
    {Hue[
      NCache[
       Rational[867, 4769], 0.18179911931222478`]], AbsoluteThickness[0.25], 
     LineBox[{2601, 2602}]}, 
    {Hue[
      NCache[
       Rational[2602, 14307], 0.18186901516740056`]], AbsoluteThickness[0.25],
      LineBox[{2602, 2603}]}, 
    {Hue[
      NCache[
       Rational[137, 753], 0.18193891102257637`]], AbsoluteThickness[0.25], 
     LineBox[{2603, 2604}]}, 
    {Hue[
      NCache[
       Rational[868, 4769], 0.18200880687775214`]], AbsoluteThickness[0.25], 
     LineBox[{2604, 2605}]}, 
    {Hue[
      NCache[
       Rational[2605, 14307], 0.18207870273292795`]], AbsoluteThickness[0.25],
      LineBox[{2605, 2606}]}, 
    {Hue[
      NCache[
       Rational[2606, 14307], 0.18214859858810373`]], AbsoluteThickness[0.25],
      LineBox[{2606, 2607}]}, 
    {Hue[
      NCache[
       Rational[869, 4769], 0.1822184944432795]], AbsoluteThickness[0.25], 
     LineBox[{2607, 2608}]}, 
    {Hue[
      NCache[
       Rational[2608, 14307], 0.1822883902984553]], AbsoluteThickness[0.25], 
     LineBox[{2608, 2609}]}, 
    {Hue[
      NCache[
       Rational[2609, 14307], 0.1823582861536311]], AbsoluteThickness[0.25], 
     LineBox[{2609, 2610}]}, 
    {Hue[
      NCache[
       Rational[870, 4769], 0.18242818200880687`]], AbsoluteThickness[0.25], 
     LineBox[{2610, 2611}]}, 
    {Hue[
      NCache[
       Rational[2611, 14307], 0.18249807786398267`]], AbsoluteThickness[0.25],
      LineBox[{2611, 2612}]}, 
    {Hue[
      NCache[
       Rational[2612, 14307], 0.18256797371915845`]], AbsoluteThickness[0.25],
      LineBox[{2612, 2613}]}, 
    {Hue[
      NCache[
       Rational[871, 4769], 0.18263786957433426`]], AbsoluteThickness[0.25], 
     LineBox[{2613, 2614}]}, 
    {Hue[
      NCache[
       Rational[2614, 14307], 0.18270776542951003`]], AbsoluteThickness[0.25],
      LineBox[{2614, 2615}]}, 
    {Hue[
      NCache[
       Rational[2615, 14307], 0.1827776612846858]], AbsoluteThickness[0.25], 
     LineBox[{2615, 2616}]}, 
    {Hue[
      NCache[
       Rational[872, 4769], 0.18284755713986162`]], AbsoluteThickness[0.25], 
     LineBox[{2616, 2617}]}, 
    {Hue[
      NCache[
       Rational[2617, 14307], 0.1829174529950374]], AbsoluteThickness[0.25], 
     LineBox[{2617, 2618}]}, 
    {Hue[
      NCache[
       Rational[2618, 14307], 0.18298734885021317`]], AbsoluteThickness[0.25],
      LineBox[{2618, 2619}]}, 
    {Hue[
      NCache[
       Rational[873, 4769], 0.18305724470538898`]], AbsoluteThickness[0.25], 
     LineBox[{2619, 2620}]}, 
    {Hue[
      NCache[
       Rational[2620, 14307], 0.18312714056056476`]], AbsoluteThickness[0.25],
      LineBox[{2620, 2621}]}, 
    {Hue[
      NCache[
       Rational[2621, 14307], 0.18319703641574053`]], AbsoluteThickness[0.25],
      LineBox[{2621, 2622}]}, 
    {Hue[
      NCache[
       Rational[46, 251], 0.18326693227091634`]], AbsoluteThickness[0.25], 
     LineBox[{2622, 2623}]}, 
    {Hue[
      NCache[
       Rational[2623, 14307], 0.18333682812609212`]], AbsoluteThickness[0.25],
      LineBox[{2623, 2624}]}, 
    {Hue[
      NCache[
       Rational[2624, 14307], 0.18340672398126792`]], AbsoluteThickness[0.25],
      LineBox[{2624, 2625}]}, 
    {Hue[
      NCache[
       Rational[875, 4769], 0.1834766198364437]], AbsoluteThickness[0.25], 
     LineBox[{2625, 2626}]}, 
    {Hue[
      NCache[
       Rational[2626, 14307], 0.18354651569161948`]], AbsoluteThickness[0.25],
      LineBox[{2626, 2627}]}, 
    {Hue[
      NCache[
       Rational[2627, 14307], 0.18361641154679528`]], AbsoluteThickness[0.25],
      LineBox[{2627, 2628}]}, 
    {Hue[
      NCache[
       Rational[876, 4769], 0.18368630740197106`]], AbsoluteThickness[0.25], 
     LineBox[{2628, 2629}]}, 
    {Hue[
      NCache[
       Rational[2629, 14307], 0.18375620325714684`]], AbsoluteThickness[0.25],
      LineBox[{2629, 2630}]}, 
    {Hue[
      NCache[
       Rational[2630, 14307], 0.18382609911232264`]], AbsoluteThickness[0.25],
      LineBox[{2630, 2631}]}, 
    {Hue[
      NCache[
       Rational[877, 4769], 0.18389599496749842`]], AbsoluteThickness[0.25], 
     LineBox[{2631, 2632}]}, 
    {Hue[
      NCache[
       Rational[2632, 14307], 0.18396589082267423`]], AbsoluteThickness[0.25],
      LineBox[{2632, 2633}]}, 
    {Hue[
      NCache[
       Rational[2633, 14307], 0.18403578667785]], AbsoluteThickness[0.25], 
     LineBox[{2633, 2634}]}, 
    {Hue[
      NCache[
       Rational[878, 4769], 0.18410568253302578`]], AbsoluteThickness[0.25], 
     LineBox[{2634, 2635}]}, 
    {Hue[
      NCache[
       Rational[2635, 14307], 0.1841755783882016]], AbsoluteThickness[0.25], 
     LineBox[{2635, 2636}]}, 
    {Hue[
      NCache[
       Rational[2636, 14307], 0.18424547424337737`]], AbsoluteThickness[0.25],
      LineBox[{2636, 2637}]}, 
    {Hue[
      NCache[
       Rational[879, 4769], 0.18431537009855314`]], AbsoluteThickness[0.25], 
     LineBox[{2637, 2638}]}, 
    {Hue[
      NCache[
       Rational[2638, 14307], 0.18438526595372895`]], AbsoluteThickness[0.25],
      LineBox[{2638, 2639}]}, 
    {Hue[
      NCache[
       Rational[2639, 14307], 0.18445516180890473`]], AbsoluteThickness[0.25],
      LineBox[{2639, 2640}]}, 
    {Hue[
      NCache[
       Rational[880, 4769], 0.18452505766408053`]], AbsoluteThickness[0.25], 
     LineBox[{2640, 2641}]}, 
    {Hue[
      NCache[
       Rational[139, 753], 0.1845949535192563]], AbsoluteThickness[0.25], 
     LineBox[{2641, 2642}]}, 
    {Hue[
      NCache[
       Rational[2642, 14307], 0.1846648493744321]], AbsoluteThickness[0.25], 
     LineBox[{2642, 2643}]}, 
    {Hue[
      NCache[
       Rational[881, 4769], 0.1847347452296079]], AbsoluteThickness[0.25], 
     LineBox[{2643, 2644}]}, 
    {Hue[
      NCache[
       Rational[2644, 14307], 0.18480464108478367`]], AbsoluteThickness[0.25],
      LineBox[{2644, 2645}]}, 
    {Hue[
      NCache[
       Rational[2645, 14307], 0.18487453693995945`]], AbsoluteThickness[0.25],
      LineBox[{2645, 2646}]}, 
    {Hue[
      NCache[
       Rational[882, 4769], 0.18494443279513526`]], AbsoluteThickness[0.25], 
     LineBox[{2646, 2647}]}, 
    {Hue[
      NCache[
       Rational[2647, 14307], 0.18501432865031103`]], AbsoluteThickness[0.25],
      LineBox[{2647, 2648}]}, 
    {Hue[
      NCache[
       Rational[2648, 14307], 0.18508422450548684`]], AbsoluteThickness[0.25],
      LineBox[{2648, 2649}]}, 
    {Hue[
      NCache[
       Rational[883, 4769], 0.18515412036066262`]], AbsoluteThickness[0.25], 
     LineBox[{2649, 2650}]}, 
    {Hue[
      NCache[
       Rational[2650, 14307], 0.1852240162158384]], AbsoluteThickness[0.25], 
     LineBox[{2650, 2651}]}, 
    {Hue[
      NCache[
       Rational[2651, 14307], 0.1852939120710142]], AbsoluteThickness[0.25], 
     LineBox[{2651, 2652}]}, 
    {Hue[
      NCache[
       Rational[884, 4769], 0.18536380792618998`]], AbsoluteThickness[0.25], 
     LineBox[{2652, 2653}]}, 
    {Hue[
      NCache[
       Rational[2653, 14307], 0.18543370378136576`]], AbsoluteThickness[0.25],
      LineBox[{2653, 2654}]}, 
    {Hue[
      NCache[
       Rational[2654, 14307], 0.18550359963654156`]], AbsoluteThickness[0.25],
      LineBox[{2654, 2655}]}, 
    {Hue[
      NCache[
       Rational[885, 4769], 0.18557349549171734`]], AbsoluteThickness[0.25], 
     LineBox[{2655, 2656}]}, 
    {Hue[
      NCache[
       Rational[2656, 14307], 0.18564339134689312`]], AbsoluteThickness[0.25],
      LineBox[{2656, 2657}]}, 
    {Hue[
      NCache[
       Rational[2657, 14307], 0.18571328720206892`]], AbsoluteThickness[0.25],
      LineBox[{2657, 2658}]}, 
    {Hue[
      NCache[
       Rational[886, 4769], 0.1857831830572447]], AbsoluteThickness[0.25], 
     LineBox[{2658, 2659}]}, 
    {Hue[
      NCache[
       Rational[2659, 14307], 0.1858530789124205]], AbsoluteThickness[0.25], 
     LineBox[{2659, 2660}]}, 
    {Hue[
      NCache[
       Rational[140, 753], 0.18592297476759628`]], AbsoluteThickness[0.25], 
     LineBox[{2660, 2661}]}, 
    {Hue[
      NCache[
       Rational[887, 4769], 0.18599287062277206`]], AbsoluteThickness[0.25], 
     LineBox[{2661, 2662}]}, 
    {Hue[
      NCache[
       Rational[2662, 14307], 0.18606276647794787`]], AbsoluteThickness[0.25],
      LineBox[{2662, 2663}]}, 
    {Hue[
      NCache[
       Rational[2663, 14307], 0.18613266233312364`]], AbsoluteThickness[0.25],
      LineBox[{2663, 2664}]}, 
    {Hue[
      NCache[
       Rational[888, 4769], 0.18620255818829942`]], AbsoluteThickness[0.25], 
     LineBox[{2664, 2665}]}, 
    {Hue[
      NCache[
       Rational[2665, 14307], 0.18627245404347523`]], AbsoluteThickness[0.25],
      LineBox[{2665, 2666}]}, 
    {Hue[
      NCache[
       Rational[2666, 14307], 0.186342349898651]], AbsoluteThickness[0.25], 
     LineBox[{2666, 2667}]}, 
    {Hue[
      NCache[
       Rational[889, 4769], 0.1864122457538268]], AbsoluteThickness[0.25], 
     LineBox[{2667, 2668}]}, 
    {Hue[
      NCache[
       Rational[2668, 14307], 0.1864821416090026]], AbsoluteThickness[0.25], 
     LineBox[{2668, 2669}]}, 
    {Hue[
      NCache[
       Rational[2669, 14307], 0.18655203746417837`]], AbsoluteThickness[0.25],
      LineBox[{2669, 2670}]}, 
    {Hue[
      NCache[
       Rational[890, 4769], 0.18662193331935417`]], AbsoluteThickness[0.25], 
     LineBox[{2670, 2671}]}, 
    {Hue[
      NCache[
       Rational[2671, 14307], 0.18669182917452995`]], AbsoluteThickness[0.25],
      LineBox[{2671, 2672}]}, 
    {Hue[
      NCache[
       Rational[2672, 14307], 0.18676172502970573`]], AbsoluteThickness[0.25],
      LineBox[{2672, 2673}]}, 
    {Hue[
      NCache[
       Rational[891, 4769], 0.18683162088488153`]], AbsoluteThickness[0.25], 
     LineBox[{2673, 2674}]}, 
    {Hue[
      NCache[
       Rational[2674, 14307], 0.1869015167400573]], AbsoluteThickness[0.25], 
     LineBox[{2674, 2675}]}, 
    {Hue[
      NCache[
       Rational[2675, 14307], 0.18697141259523312`]], AbsoluteThickness[0.25],
      LineBox[{2675, 2676}]}, 
    {Hue[
      NCache[
       Rational[892, 4769], 0.1870413084504089]], AbsoluteThickness[0.25], 
     LineBox[{2676, 2677}]}, 
    {Hue[
      NCache[
       Rational[2677, 14307], 0.18711120430558467`]], AbsoluteThickness[0.25],
      LineBox[{2677, 2678}]}, 
    {Hue[
      NCache[
       Rational[2678, 14307], 0.18718110016076048`]], AbsoluteThickness[0.25],
      LineBox[{2678, 2679}]}, 
    {Hue[
      NCache[
       Rational[47, 251], 0.18725099601593626`]], AbsoluteThickness[0.25], 
     LineBox[{2679, 2680}]}, 
    {Hue[
      NCache[
       Rational[2680, 14307], 0.18732089187111203`]], AbsoluteThickness[0.25],
      LineBox[{2680, 2681}]}, 
    {Hue[
      NCache[
       Rational[2681, 14307], 0.18739078772628784`]], AbsoluteThickness[0.25],
      LineBox[{2681, 2682}]}, 
    {Hue[
      NCache[
       Rational[894, 4769], 0.18746068358146362`]], AbsoluteThickness[0.25], 
     LineBox[{2682, 2683}]}, 
    {Hue[
      NCache[
       Rational[2683, 14307], 0.1875305794366394]], AbsoluteThickness[0.25], 
     LineBox[{2683, 2684}]}, 
    {Hue[
      NCache[
       Rational[2684, 14307], 0.1876004752918152]], AbsoluteThickness[0.25], 
     LineBox[{2684, 2685}]}, 
    {Hue[
      NCache[
       Rational[895, 4769], 0.18767037114699098`]], AbsoluteThickness[0.25], 
     LineBox[{2685, 2686}]}, 
    {Hue[
      NCache[
       Rational[2686, 14307], 0.18774026700216678`]], AbsoluteThickness[0.25],
      LineBox[{2686, 2687}]}, 
    {Hue[
      NCache[
       Rational[2687, 14307], 0.18781016285734256`]], AbsoluteThickness[0.25],
      LineBox[{2687, 2688}]}, 
    {Hue[
      NCache[
       Rational[896, 4769], 0.18788005871251834`]], AbsoluteThickness[0.25], 
     LineBox[{2688, 2689}]}, 
    {Hue[
      NCache[
       Rational[2689, 14307], 0.18794995456769414`]], AbsoluteThickness[0.25],
      LineBox[{2689, 2690}]}, 
    {Hue[
      NCache[
       Rational[2690, 14307], 0.18801985042286992`]], AbsoluteThickness[0.25],
      LineBox[{2690, 2691}]}, 
    {Hue[
      NCache[
       Rational[897, 4769], 0.1880897462780457]], AbsoluteThickness[0.25], 
     LineBox[{2691, 2692}]}, 
    {Hue[
      NCache[
       Rational[2692, 14307], 0.1881596421332215]], AbsoluteThickness[0.25], 
     LineBox[{2692, 2693}]}, 
    {Hue[
      NCache[
       Rational[2693, 14307], 0.18822953798839728`]], AbsoluteThickness[0.25],
      LineBox[{2693, 2694}]}, 
    {Hue[
      NCache[
       Rational[898, 4769], 0.1882994338435731]], AbsoluteThickness[0.25], 
     LineBox[{2694, 2695}]}, 
    {Hue[
      NCache[
       Rational[2695, 14307], 0.18836932969874887`]], AbsoluteThickness[0.25],
      LineBox[{2695, 2696}]}, 
    {Hue[
      NCache[
       Rational[2696, 14307], 0.18843922555392464`]], AbsoluteThickness[0.25],
      LineBox[{2696, 2697}]}, 
    {Hue[
      NCache[
       Rational[899, 4769], 0.18850912140910045`]], AbsoluteThickness[0.25], 
     LineBox[{2697, 2698}]}, 
    {Hue[
      NCache[
       Rational[142, 753], 0.18857901726427623`]], AbsoluteThickness[0.25], 
     LineBox[{2698, 2699}]}, 
    {Hue[
      NCache[
       Rational[2699, 14307], 0.188648913119452]], AbsoluteThickness[0.25], 
     LineBox[{2699, 2700}]}, 
    {Hue[
      NCache[
       Rational[900, 4769], 0.1887188089746278]], AbsoluteThickness[0.25], 
     LineBox[{2700, 2701}]}, 
    {Hue[
      NCache[
       Rational[2701, 14307], 0.1887887048298036]], AbsoluteThickness[0.25], 
     LineBox[{2701, 2702}]}, 
    {Hue[
      NCache[
       Rational[2702, 14307], 0.1888586006849794]], AbsoluteThickness[0.25], 
     LineBox[{2702, 2703}]}, 
    {Hue[
      NCache[
       Rational[901, 4769], 0.18892849654015517`]], AbsoluteThickness[0.25], 
     LineBox[{2703, 2704}]}, 
    {Hue[
      NCache[
       Rational[2704, 14307], 0.18899839239533095`]], AbsoluteThickness[0.25],
      LineBox[{2704, 2705}]}, 
    {Hue[
      NCache[
       Rational[2705, 14307], 0.18906828825050676`]], AbsoluteThickness[0.25],
      LineBox[{2705, 2706}]}, 
    {Hue[
      NCache[
       Rational[902, 4769], 0.18913818410568253`]], AbsoluteThickness[0.25], 
     LineBox[{2706, 2707}]}, 
    {Hue[
      NCache[
       Rational[2707, 14307], 0.1892080799608583]], AbsoluteThickness[0.25], 
     LineBox[{2707, 2708}]}, 
    {Hue[
      NCache[
       Rational[2708, 14307], 0.18927797581603412`]], AbsoluteThickness[0.25],
      LineBox[{2708, 2709}]}, 
    {Hue[
      NCache[
       Rational[903, 4769], 0.1893478716712099]], AbsoluteThickness[0.25], 
     LineBox[{2709, 2710}]}, 
    {Hue[
      NCache[
       Rational[2710, 14307], 0.18941776752638567`]], AbsoluteThickness[0.25],
      LineBox[{2710, 2711}]}, 
    {Hue[
      NCache[
       Rational[2711, 14307], 0.18948766338156148`]], AbsoluteThickness[0.25],
      LineBox[{2711, 2712}]}, 
    {Hue[
      NCache[
       Rational[904, 4769], 0.18955755923673726`]], AbsoluteThickness[0.25], 
     LineBox[{2712, 2713}]}, 
    {Hue[
      NCache[
       Rational[2713, 14307], 0.18962745509191306`]], AbsoluteThickness[0.25],
      LineBox[{2713, 2714}]}, 
    {Hue[
      NCache[
       Rational[2714, 14307], 0.18969735094708884`]], AbsoluteThickness[0.25],
      LineBox[{2714, 2715}]}, 
    {Hue[
      NCache[
       Rational[905, 4769], 0.18976724680226462`]], AbsoluteThickness[0.25], 
     LineBox[{2715, 2716}]}, 
    {Hue[
      NCache[
       Rational[2716, 14307], 0.18983714265744042`]], AbsoluteThickness[0.25],
      LineBox[{2716, 2717}]}, 
    {Hue[
      NCache[
       Rational[143, 753], 0.1899070385126162]], AbsoluteThickness[0.25], 
     LineBox[{2717, 2718}]}, 
    {Hue[
      NCache[
       Rational[906, 4769], 0.18997693436779198`]], AbsoluteThickness[0.25], 
     LineBox[{2718, 2719}]}, 
    {Hue[
      NCache[
       Rational[2719, 14307], 0.19004683022296778`]], AbsoluteThickness[0.25],
      LineBox[{2719, 2720}]}, 
    {Hue[
      NCache[
       Rational[2720, 14307], 0.19011672607814356`]], AbsoluteThickness[0.25],
      LineBox[{2720, 2721}]}, 
    {Hue[
      NCache[
       Rational[907, 4769], 0.19018662193331937`]], AbsoluteThickness[0.25], 
     LineBox[{2721, 2722}]}, 
    {Hue[
      NCache[
       Rational[2722, 14307], 0.19025651778849514`]], AbsoluteThickness[0.25],
      LineBox[{2722, 2723}]}, 
    {Hue[
      NCache[
       Rational[2723, 14307], 0.19032641364367092`]], AbsoluteThickness[0.25],
      LineBox[{2723, 2724}]}, 
    {Hue[
      NCache[
       Rational[908, 4769], 0.19039630949884673`]], AbsoluteThickness[0.25], 
     LineBox[{2724, 2725}]}, 
    {Hue[
      NCache[
       Rational[2725, 14307], 0.1904662053540225]], AbsoluteThickness[0.25], 
     LineBox[{2725, 2726}]}, 
    {Hue[
      NCache[
       Rational[2726, 14307], 0.19053610120919828`]], AbsoluteThickness[0.25],
      LineBox[{2726, 2727}]}, 
    {Hue[
      NCache[
       Rational[909, 4769], 0.1906059970643741]], AbsoluteThickness[0.25], 
     LineBox[{2727, 2728}]}, 
    {Hue[
      NCache[
       Rational[2728, 14307], 0.19067589291954987`]], AbsoluteThickness[0.25],
      LineBox[{2728, 2729}]}, 
    {Hue[
      NCache[
       Rational[2729, 14307], 0.19074578877472567`]], AbsoluteThickness[0.25],
      LineBox[{2729, 2730}]}, 
    {Hue[
      NCache[
       Rational[910, 4769], 0.19081568462990145`]], AbsoluteThickness[0.25], 
     LineBox[{2730, 2731}]}, 
    {Hue[
      NCache[
       Rational[2731, 14307], 0.19088558048507723`]], AbsoluteThickness[0.25],
      LineBox[{2731, 2732}]}, 
    {Hue[
      NCache[
       Rational[2732, 14307], 0.19095547634025303`]], AbsoluteThickness[0.25],
      LineBox[{2732, 2733}]}, 
    {Hue[
      NCache[
       Rational[911, 4769], 0.1910253721954288]], AbsoluteThickness[0.25], 
     LineBox[{2733, 2734}]}, 
    {Hue[
      NCache[
       Rational[2734, 14307], 0.1910952680506046]], AbsoluteThickness[0.25], 
     LineBox[{2734, 2735}]}, 
    {Hue[
      NCache[
       Rational[2735, 14307], 0.1911651639057804]], AbsoluteThickness[0.25], 
     LineBox[{2735, 2736}]}, 
    {Hue[
      NCache[
       Rational[48, 251], 0.19123505976095617`]], AbsoluteThickness[0.25], 
     LineBox[{2736, 2737}]}, 
    {Hue[
      NCache[
       Rational[2737, 14307], 0.19130495561613195`]], AbsoluteThickness[0.25],
      LineBox[{2737, 2738}]}, 
    {Hue[
      NCache[
       Rational[2738, 14307], 0.19137485147130776`]], AbsoluteThickness[0.25],
      LineBox[{2738, 2739}]}, 
    {Hue[
      NCache[
       Rational[913, 4769], 0.19144474732648353`]], AbsoluteThickness[0.25], 
     LineBox[{2739, 2740}]}, 
    {Hue[
      NCache[
       Rational[2740, 14307], 0.19151464318165934`]], AbsoluteThickness[0.25],
      LineBox[{2740, 2741}]}, 
    {Hue[
      NCache[
       Rational[2741, 14307], 0.19158453903683512`]], AbsoluteThickness[0.25],
      LineBox[{2741, 2742}]}, 
    {Hue[
      NCache[
       Rational[914, 4769], 0.1916544348920109]], AbsoluteThickness[0.25], 
     LineBox[{2742, 2743}]}, 
    {Hue[
      NCache[
       Rational[2743, 14307], 0.1917243307471867]], AbsoluteThickness[0.25], 
     LineBox[{2743, 2744}]}, 
    {Hue[
      NCache[
       Rational[2744, 14307], 0.19179422660236248`]], AbsoluteThickness[0.25],
      LineBox[{2744, 2745}]}, 
    {Hue[
      NCache[
       Rational[915, 4769], 0.19186412245753826`]], AbsoluteThickness[0.25], 
     LineBox[{2745, 2746}]}, 
    {Hue[
      NCache[
       Rational[2746, 14307], 0.19193401831271406`]], AbsoluteThickness[0.25],
      LineBox[{2746, 2747}]}, 
    {Hue[
      NCache[
       Rational[2747, 14307], 0.19200391416788984`]], AbsoluteThickness[0.25],
      LineBox[{2747, 2748}]}, 
    {Hue[
      NCache[
       Rational[916, 4769], 0.19207381002306564`]], AbsoluteThickness[0.25], 
     LineBox[{2748, 2749}]}, 
    {Hue[
      NCache[
       Rational[2749, 14307], 0.19214370587824142`]], AbsoluteThickness[0.25],
      LineBox[{2749, 2750}]}, 
    {Hue[
      NCache[
       Rational[2750, 14307], 0.1922136017334172]], AbsoluteThickness[0.25], 
     LineBox[{2750, 2751}]}, 
    {Hue[
      NCache[
       Rational[917, 4769], 0.192283497588593]], AbsoluteThickness[0.25], 
     LineBox[{2751, 2752}]}, 
    {Hue[
      NCache[
       Rational[2752, 14307], 0.19235339344376878`]], AbsoluteThickness[0.25],
      LineBox[{2752, 2753}]}, 
    {Hue[
      NCache[
       Rational[2753, 14307], 0.19242328929894456`]], AbsoluteThickness[0.25],
      LineBox[{2753, 2754}]}, 
    {Hue[
      NCache[
       Rational[918, 4769], 0.19249318515412037`]], AbsoluteThickness[0.25], 
     LineBox[{2754, 2755}]}, 
    {Hue[
      NCache[
       Rational[145, 753], 0.19256308100929614`]], AbsoluteThickness[0.25], 
     LineBox[{2755, 2756}]}, 
    {Hue[
      NCache[
       Rational[2756, 14307], 0.19263297686447195`]], AbsoluteThickness[0.25],
      LineBox[{2756, 2757}]}, 
    {Hue[
      NCache[
       Rational[919, 4769], 0.19270287271964773`]], AbsoluteThickness[0.25], 
     LineBox[{2757, 2758}]}, 
    {Hue[
      NCache[
       Rational[2758, 14307], 0.1927727685748235]], AbsoluteThickness[0.25], 
     LineBox[{2758, 2759}]}, 
    {Hue[
      NCache[
       Rational[2759, 14307], 0.1928426644299993]], AbsoluteThickness[0.25], 
     LineBox[{2759, 2760}]}, 
    {Hue[
      NCache[
       Rational[920, 4769], 0.1929125602851751]], AbsoluteThickness[0.25], 
     LineBox[{2760, 2761}]}, 
    {Hue[
      NCache[
       Rational[11, 57], 0.19298245614035087`]], AbsoluteThickness[0.25], 
     LineBox[{2761, 2762}]}, 
    {Hue[
      NCache[
       Rational[2762, 14307], 0.19305235199552667`]], AbsoluteThickness[0.25],
      LineBox[{2762, 2763}]}, 
    {Hue[
      NCache[
       Rational[921, 4769], 0.19312224785070245`]], AbsoluteThickness[0.25], 
     LineBox[{2763, 2764}]}, 
    {Hue[
      NCache[
       Rational[2764, 14307], 0.19319214370587823`]], AbsoluteThickness[0.25],
      LineBox[{2764, 2765}]}, 
    {Hue[
      NCache[
       Rational[2765, 14307], 0.19326203956105403`]], AbsoluteThickness[0.25],
      LineBox[{2765, 2766}]}, 
    {Hue[
      NCache[
       Rational[922, 4769], 0.1933319354162298]], AbsoluteThickness[0.25], 
     LineBox[{2766, 2767}]}, 
    {Hue[
      NCache[
       Rational[2767, 14307], 0.19340183127140562`]], AbsoluteThickness[0.25],
      LineBox[{2767, 2768}]}, 
    {Hue[
      NCache[
       Rational[2768, 14307], 0.1934717271265814]], AbsoluteThickness[0.25], 
     LineBox[{2768, 2769}]}, 
    {Hue[
      NCache[
       Rational[923, 4769], 0.19354162298175717`]], AbsoluteThickness[0.25], 
     LineBox[{2769, 2770}]}, 
    {Hue[
      NCache[
       Rational[2770, 14307], 0.19361151883693298`]], AbsoluteThickness[0.25],
      LineBox[{2770, 2771}]}, 
    {Hue[
      NCache[
       Rational[2771, 14307], 0.19368141469210876`]], AbsoluteThickness[0.25],
      LineBox[{2771, 2772}]}, 
    {Hue[
      NCache[
       Rational[924, 4769], 0.19375131054728453`]], AbsoluteThickness[0.25], 
     LineBox[{2772, 2773}]}, 
    {Hue[
      NCache[
       Rational[2773, 14307], 0.19382120640246034`]], AbsoluteThickness[0.25],
      LineBox[{2773, 2774}]}, 
    {Hue[
      NCache[
       Rational[146, 753], 0.19389110225763612`]], AbsoluteThickness[0.25], 
     LineBox[{2774, 2775}]}, 
    {Hue[
      NCache[
       Rational[925, 4769], 0.19396099811281192`]], AbsoluteThickness[0.25], 
     LineBox[{2775, 2776}]}, 
    {Hue[
      NCache[
       Rational[2776, 14307], 0.1940308939679877]], AbsoluteThickness[0.25], 
     LineBox[{2776, 2777}]}, 
    {Hue[
      NCache[
       Rational[2777, 14307], 0.19410078982316348`]], AbsoluteThickness[0.25],
      LineBox[{2777, 2778}]}, 
    {Hue[
      NCache[
       Rational[926, 4769], 0.19417068567833928`]], AbsoluteThickness[0.25], 
     LineBox[{2778, 2779}]}, 
    {Hue[
      NCache[
       Rational[2779, 14307], 0.19424058153351506`]], AbsoluteThickness[0.25],
      LineBox[{2779, 2780}]}, 
    {Hue[
      NCache[
       Rational[2780, 14307], 0.19431047738869084`]], AbsoluteThickness[0.25],
      LineBox[{2780, 2781}]}, 
    {Hue[
      NCache[
       Rational[927, 4769], 0.19438037324386664`]], AbsoluteThickness[0.25], 
     LineBox[{2781, 2782}]}, 
    {Hue[
      NCache[
       Rational[2782, 14307], 0.19445026909904242`]], AbsoluteThickness[0.25],
      LineBox[{2782, 2783}]}, 
    {Hue[
      NCache[
       Rational[2783, 14307], 0.19452016495421823`]], AbsoluteThickness[0.25],
      LineBox[{2783, 2784}]}, 
    {Hue[
      NCache[
       Rational[928, 4769], 0.194590060809394]], AbsoluteThickness[0.25], 
     LineBox[{2784, 2785}]}, 
    {Hue[
      NCache[
       Rational[2785, 14307], 0.19465995666456978`]], AbsoluteThickness[0.25],
      LineBox[{2785, 2786}]}, 
    {Hue[
      NCache[
       Rational[2786, 14307], 0.1947298525197456]], AbsoluteThickness[0.25], 
     LineBox[{2786, 2787}]}, 
    {Hue[
      NCache[
       Rational[929, 4769], 0.19479974837492137`]], AbsoluteThickness[0.25], 
     LineBox[{2787, 2788}]}, 
    {Hue[
      NCache[
       Rational[2788, 14307], 0.19486964423009714`]], AbsoluteThickness[0.25],
      LineBox[{2788, 2789}]}, 
    {Hue[
      NCache[
       Rational[2789, 14307], 0.19493954008527295`]], AbsoluteThickness[0.25],
      LineBox[{2789, 2790}]}, 
    {Hue[
      NCache[
       Rational[930, 4769], 0.19500943594044873`]], AbsoluteThickness[0.25], 
     LineBox[{2790, 2791}]}, 
    {Hue[
      NCache[
       Rational[2791, 14307], 0.19507933179562453`]], AbsoluteThickness[0.25],
      LineBox[{2791, 2792}]}, 
    {Hue[
      NCache[
       Rational[2792, 14307], 0.1951492276508003]], AbsoluteThickness[0.25], 
     LineBox[{2792, 2793}]}, 
    {Hue[
      NCache[
       Rational[49, 251], 0.1952191235059761]], AbsoluteThickness[0.25], 
     LineBox[{2793, 2794}]}, 
    {Hue[
      NCache[
       Rational[2794, 14307], 0.1952890193611519]], AbsoluteThickness[0.25], 
     LineBox[{2794, 2795}]}, 
    {Hue[
      NCache[
       Rational[2795, 14307], 0.19535891521632767`]], AbsoluteThickness[0.25],
      LineBox[{2795, 2796}]}, 
    {Hue[
      NCache[
       Rational[932, 4769], 0.19542881107150345`]], AbsoluteThickness[0.25], 
     LineBox[{2796, 2797}]}, 
    {Hue[
      NCache[
       Rational[2797, 14307], 0.19549870692667926`]], AbsoluteThickness[0.25],
      LineBox[{2797, 2798}]}, 
    {Hue[
      NCache[
       Rational[2798, 14307], 0.19556860278185503`]], AbsoluteThickness[0.25],
      LineBox[{2798, 2799}]}, 
    {Hue[
      NCache[
       Rational[933, 4769], 0.1956384986370308]], AbsoluteThickness[0.25], 
     LineBox[{2799, 2800}]}, 
    {Hue[
      NCache[
       Rational[2800, 14307], 0.19570839449220662`]], AbsoluteThickness[0.25],
      LineBox[{2800, 2801}]}, 
    {Hue[
      NCache[
       Rational[2801, 14307], 0.1957782903473824]], AbsoluteThickness[0.25], 
     LineBox[{2801, 2802}]}, 
    {Hue[
      NCache[
       Rational[934, 4769], 0.1958481862025582]], AbsoluteThickness[0.25], 
     LineBox[{2802, 2803}]}, 
    {Hue[
      NCache[
       Rational[2803, 14307], 0.19591808205773398`]], AbsoluteThickness[0.25],
      LineBox[{2803, 2804}]}, 
    {Hue[
      NCache[
       Rational[2804, 14307], 0.19598797791290976`]], AbsoluteThickness[0.25],
      LineBox[{2804, 2805}]}, 
    {Hue[
      NCache[
       Rational[935, 4769], 0.19605787376808556`]], AbsoluteThickness[0.25], 
     LineBox[{2805, 2806}]}, 
    {Hue[
      NCache[
       Rational[2806, 14307], 0.19612776962326134`]], AbsoluteThickness[0.25],
      LineBox[{2806, 2807}]}, 
    {Hue[
      NCache[
       Rational[2807, 14307], 0.19619766547843712`]], AbsoluteThickness[0.25],
      LineBox[{2807, 2808}]}, 
    {Hue[
      NCache[
       Rational[936, 4769], 0.19626756133361292`]], AbsoluteThickness[0.25], 
     LineBox[{2808, 2809}]}, 
    {Hue[
      NCache[
       Rational[2809, 14307], 0.1963374571887887]], AbsoluteThickness[0.25], 
     LineBox[{2809, 2810}]}, 
    {Hue[
      NCache[
       Rational[2810, 14307], 0.1964073530439645]], AbsoluteThickness[0.25], 
     LineBox[{2810, 2811}]}, 
    {Hue[
      NCache[
       Rational[937, 4769], 0.19647724889914028`]], AbsoluteThickness[0.25], 
     LineBox[{2811, 2812}]}, 
    {Hue[
      NCache[
       Rational[148, 753], 0.19654714475431606`]], AbsoluteThickness[0.25], 
     LineBox[{2812, 2813}]}, 
    {Hue[
      NCache[
       Rational[2813, 14307], 0.19661704060949187`]], AbsoluteThickness[0.25],
      LineBox[{2813, 2814}]}, 
    {Hue[
      NCache[
       Rational[938, 4769], 0.19668693646466764`]], AbsoluteThickness[0.25], 
     LineBox[{2814, 2815}]}, 
    {Hue[
      NCache[
       Rational[2815, 14307], 0.19675683231984342`]], AbsoluteThickness[0.25],
      LineBox[{2815, 2816}]}, 
    {Hue[
      NCache[
       Rational[2816, 14307], 0.19682672817501923`]], AbsoluteThickness[0.25],
      LineBox[{2816, 2817}]}, 
    {Hue[
      NCache[
       Rational[939, 4769], 0.196896624030195]], AbsoluteThickness[0.25], 
     LineBox[{2817, 2818}]}, 
    {Hue[
      NCache[
       Rational[2818, 14307], 0.1969665198853708]], AbsoluteThickness[0.25], 
     LineBox[{2818, 2819}]}, 
    {Hue[
      NCache[
       Rational[2819, 14307], 0.1970364157405466]], AbsoluteThickness[0.25], 
     LineBox[{2819, 2820}]}, 
    {Hue[
      NCache[
       Rational[940, 4769], 0.19710631159572237`]], AbsoluteThickness[0.25], 
     LineBox[{2820, 2821}]}, 
    {Hue[
      NCache[
       Rational[2821, 14307], 0.19717620745089817`]], AbsoluteThickness[0.25],
      LineBox[{2821, 2822}]}, 
    {Hue[
      NCache[
       Rational[2822, 14307], 0.19724610330607395`]], AbsoluteThickness[0.25],
      LineBox[{2822, 2823}]}, 
    {Hue[
      NCache[
       Rational[941, 4769], 0.19731599916124973`]], AbsoluteThickness[0.25], 
     LineBox[{2823, 2824}]}, 
    {Hue[
      NCache[
       Rational[2824, 14307], 0.19738589501642553`]], AbsoluteThickness[0.25],
      LineBox[{2824, 2825}]}, 
    {Hue[
      NCache[
       Rational[2825, 14307], 0.1974557908716013]], AbsoluteThickness[0.25], 
     LineBox[{2825, 2826}]}, 
    {Hue[
      NCache[
       Rational[942, 4769], 0.1975256867267771]], AbsoluteThickness[0.25], 
     LineBox[{2826, 2827}]}, 
    {Hue[
      NCache[
       Rational[2827, 14307], 0.1975955825819529]], AbsoluteThickness[0.25], 
     LineBox[{2827, 2828}]}, 
    {Hue[
      NCache[
       Rational[2828, 14307], 0.19766547843712867`]], AbsoluteThickness[0.25],
      LineBox[{2828, 2829}]}, 
    {Hue[
      NCache[
       Rational[943, 4769], 0.19773537429230448`]], AbsoluteThickness[0.25], 
     LineBox[{2829, 2830}]}, 
    {Hue[
      NCache[
       Rational[2830, 14307], 0.19780527014748026`]], AbsoluteThickness[0.25],
      LineBox[{2830, 2831}]}, 
    {Hue[
      NCache[
       Rational[149, 753], 0.19787516600265603`]], AbsoluteThickness[0.25], 
     LineBox[{2831, 2832}]}, 
    {Hue[
      NCache[
       Rational[944, 4769], 0.19794506185783184`]], AbsoluteThickness[0.25], 
     LineBox[{2832, 2833}]}, 
    {Hue[
      NCache[
       Rational[2833, 14307], 0.19801495771300762`]], AbsoluteThickness[0.25],
      LineBox[{2833, 2834}]}, 
    {Hue[
      NCache[
       Rational[2834, 14307], 0.1980848535681834]], AbsoluteThickness[0.25], 
     LineBox[{2834, 2835}]}, 
    {Hue[
      NCache[
       Rational[945, 4769], 0.1981547494233592]], AbsoluteThickness[0.25], 
     LineBox[{2835, 2836}]}, 
    {Hue[
      NCache[
       Rational[2836, 14307], 0.19822464527853498`]], AbsoluteThickness[0.25],
      LineBox[{2836, 2837}]}, 
    {Hue[
      NCache[
       Rational[2837, 14307], 0.19829454113371078`]], AbsoluteThickness[0.25],
      LineBox[{2837, 2838}]}, 
    {Hue[
      NCache[
       Rational[946, 4769], 0.19836443698888656`]], AbsoluteThickness[0.25], 
     LineBox[{2838, 2839}]}, 
    {Hue[
      NCache[
       Rational[2839, 14307], 0.19843433284406234`]], AbsoluteThickness[0.25],
      LineBox[{2839, 2840}]}, 
    {Hue[
      NCache[
       Rational[2840, 14307], 0.19850422869923814`]], AbsoluteThickness[0.25],
      LineBox[{2840, 2841}]}, 
    {Hue[
      NCache[
       Rational[947, 4769], 0.19857412455441392`]], AbsoluteThickness[0.25], 
     LineBox[{2841, 2842}]}, 
    {Hue[
      NCache[
       Rational[2842, 14307], 0.1986440204095897]], AbsoluteThickness[0.25], 
     LineBox[{2842, 2843}]}, 
    {Hue[
      NCache[
       Rational[2843, 14307], 0.1987139162647655]], AbsoluteThickness[0.25], 
     LineBox[{2843, 2844}]}, 
    {Hue[
      NCache[
       Rational[948, 4769], 0.19878381211994128`]], AbsoluteThickness[0.25], 
     LineBox[{2844, 2845}]}, 
    {Hue[
      NCache[
       Rational[2845, 14307], 0.1988537079751171]], AbsoluteThickness[0.25], 
     LineBox[{2845, 2846}]}, 
    {Hue[
      NCache[
       Rational[2846, 14307], 0.19892360383029287`]], AbsoluteThickness[0.25],
      LineBox[{2846, 2847}]}, 
    {Hue[
      NCache[
       Rational[949, 4769], 0.19899349968546864`]], AbsoluteThickness[0.25], 
     LineBox[{2847, 2848}]}, 
    {Hue[
      NCache[
       Rational[2848, 14307], 0.19906339554064445`]], AbsoluteThickness[0.25],
      LineBox[{2848, 2849}]}, 
    {Hue[
      NCache[
       Rational[2849, 14307], 0.19913329139582023`]], AbsoluteThickness[0.25],
      LineBox[{2849, 2850}]}, 
    {Hue[
      NCache[
       Rational[50, 251], 0.199203187250996]], AbsoluteThickness[0.25], 
     LineBox[{2850, 2851}]}, 
    {Hue[
      NCache[
       Rational[2851, 14307], 0.1992730831061718]], AbsoluteThickness[0.25], 
     LineBox[{2851, 2852}]}, 
    {Hue[
      NCache[
       Rational[2852, 14307], 0.1993429789613476]], AbsoluteThickness[0.25], 
     LineBox[{2852, 2853}]}, 
    {Hue[
      NCache[
       Rational[951, 4769], 0.19941287481652337`]], AbsoluteThickness[0.25], 
     LineBox[{2853, 2854}]}, 
    {Hue[
      NCache[
       Rational[2854, 14307], 0.19948277067169917`]], AbsoluteThickness[0.25],
      LineBox[{2854, 2855}]}, 
    {Hue[
      NCache[
       Rational[2855, 14307], 0.19955266652687495`]], AbsoluteThickness[0.25],
      LineBox[{2855, 2856}]}, 
    {Hue[
      NCache[
       Rational[952, 4769], 0.19962256238205076`]], AbsoluteThickness[0.25], 
     LineBox[{2856, 2857}]}, 
    {Hue[
      NCache[
       Rational[2857, 14307], 0.19969245823722653`]], AbsoluteThickness[0.25],
      LineBox[{2857, 2858}]}, 
    {Hue[
      NCache[
       Rational[2858, 14307], 0.1997623540924023]], AbsoluteThickness[0.25], 
     LineBox[{2858, 2859}]}, 
    {Hue[
      NCache[
       Rational[953, 4769], 0.19983224994757812`]], AbsoluteThickness[0.25], 
     LineBox[{2859, 2860}]}, 
    {Hue[
      NCache[
       Rational[2860, 14307], 0.1999021458027539]], AbsoluteThickness[0.25], 
     LineBox[{2860, 2861}]}, 
    {Hue[
      NCache[
       Rational[2861, 14307], 0.19997204165792967`]], AbsoluteThickness[0.25],
      LineBox[{2861, 2862}]}, 
    {Hue[
      NCache[
       Rational[954, 4769], 0.20004193751310548`]], AbsoluteThickness[0.25], 
     LineBox[{2862, 2863}]}, 
    {Hue[
      NCache[
       Rational[2863, 14307], 0.20011183336828126`]], AbsoluteThickness[0.25],
      LineBox[{2863, 2864}]}, 
    {Hue[
      NCache[
       Rational[2864, 14307], 0.20018172922345706`]], AbsoluteThickness[0.25],
      LineBox[{2864, 2865}]}, 
    {Hue[
      NCache[
       Rational[955, 4769], 0.20025162507863284`]], AbsoluteThickness[0.25], 
     LineBox[{2865, 2866}]}, 
    {Hue[
      NCache[
       Rational[2866, 14307], 0.20032152093380862`]], AbsoluteThickness[0.25],
      LineBox[{2866, 2867}]}, 
    {Hue[
      NCache[
       Rational[2867, 14307], 0.20039141678898442`]], AbsoluteThickness[0.25],
      LineBox[{2867, 2868}]}, 
    {Hue[
      NCache[
       Rational[956, 4769], 0.2004613126441602]], AbsoluteThickness[0.25], 
     LineBox[{2868, 2869}]}, 
    {Hue[
      NCache[
       Rational[151, 753], 0.20053120849933598`]], AbsoluteThickness[0.25], 
     LineBox[{2869, 2870}]}, 
    {Hue[
      NCache[
       Rational[2870, 14307], 0.20060110435451178`]], AbsoluteThickness[0.25],
      LineBox[{2870, 2871}]}, 
    {Hue[
      NCache[
       Rational[957, 4769], 0.20067100020968756`]], AbsoluteThickness[0.25], 
     LineBox[{2871, 2872}]}, 
    {Hue[
      NCache[
       Rational[2872, 14307], 0.20074089606486337`]], AbsoluteThickness[0.25],
      LineBox[{2872, 2873}]}, 
    {Hue[
      NCache[
       Rational[2873, 14307], 0.20081079192003914`]], AbsoluteThickness[0.25],
      LineBox[{2873, 2874}]}, 
    {Hue[
      NCache[
       Rational[958, 4769], 0.20088068777521492`]], AbsoluteThickness[0.25], 
     LineBox[{2874, 2875}]}, 
    {Hue[
      NCache[
       Rational[2875, 14307], 0.20095058363039073`]], AbsoluteThickness[0.25],
      LineBox[{2875, 2876}]}, 
    {Hue[
      NCache[
       Rational[2876, 14307], 0.2010204794855665]], AbsoluteThickness[0.25], 
     LineBox[{2876, 2877}]}, 
    {Hue[
      NCache[
       Rational[959, 4769], 0.20109037534074228`]], AbsoluteThickness[0.25], 
     LineBox[{2877, 2878}]}, 
    {Hue[
      NCache[
       Rational[2878, 14307], 0.2011602711959181]], AbsoluteThickness[0.25], 
     LineBox[{2878, 2879}]}, 
    {Hue[
      NCache[
       Rational[2879, 14307], 0.20123016705109387`]], AbsoluteThickness[0.25],
      LineBox[{2879, 2880}]}, 
    {Hue[
      NCache[
       Rational[960, 4769], 0.20130006290626964`]], AbsoluteThickness[0.25], 
     LineBox[{2880, 2881}]}, 
    {Hue[
      NCache[
       Rational[2881, 14307], 0.20136995876144545`]], AbsoluteThickness[0.25],
      LineBox[{2881, 2882}]}, 
    {Hue[
      NCache[
       Rational[2882, 14307], 0.20143985461662123`]], AbsoluteThickness[0.25],
      LineBox[{2882, 2883}]}, 
    {Hue[
      NCache[
       Rational[961, 4769], 0.20150975047179703`]], AbsoluteThickness[0.25], 
     LineBox[{2883, 2884}]}, 
    {Hue[
      NCache[
       Rational[2884, 14307], 0.2015796463269728]], AbsoluteThickness[0.25], 
     LineBox[{2884, 2885}]}, 
    {Hue[
      NCache[
       Rational[2885, 14307], 0.2016495421821486]], AbsoluteThickness[0.25], 
     LineBox[{2885, 2886}]}, 
    {Hue[
      NCache[
       Rational[962, 4769], 0.2017194380373244]], AbsoluteThickness[0.25], 
     LineBox[{2886, 2887}]}, 
    {Hue[
      NCache[
       Rational[2887, 14307], 0.20178933389250017`]], AbsoluteThickness[0.25],
      LineBox[{2887, 2888}]}, 
    {Hue[
      NCache[
       Rational[152, 753], 0.20185922974767595`]], AbsoluteThickness[0.25], 
     LineBox[{2888, 2889}]}, 
    {Hue[
      NCache[
       Rational[963, 4769], 0.20192912560285176`]], AbsoluteThickness[0.25], 
     LineBox[{2889, 2890}]}, 
    {Hue[
      NCache[
       Rational[2890, 14307], 0.20199902145802753`]], AbsoluteThickness[0.25],
      LineBox[{2890, 2891}]}, 
    {Hue[
      NCache[
       Rational[2891, 14307], 0.20206891731320334`]], AbsoluteThickness[0.25],
      LineBox[{2891, 2892}]}, 
    {Hue[
      NCache[
       Rational[964, 4769], 0.20213881316837912`]], AbsoluteThickness[0.25], 
     LineBox[{2892, 2893}]}, 
    {Hue[
      NCache[
       Rational[2893, 14307], 0.2022087090235549]], AbsoluteThickness[0.25], 
     LineBox[{2893, 2894}]}, 
    {Hue[
      NCache[
       Rational[2894, 14307], 0.2022786048787307]], AbsoluteThickness[0.25], 
     LineBox[{2894, 2895}]}, 
    {Hue[
      NCache[
       Rational[965, 4769], 0.20234850073390648`]], AbsoluteThickness[0.25], 
     LineBox[{2895, 2896}]}, 
    {Hue[
      NCache[
       Rational[2896, 14307], 0.20241839658908226`]], AbsoluteThickness[0.25],
      LineBox[{2896, 2897}]}, 
    {Hue[
      NCache[
       Rational[2897, 14307], 0.20248829244425806`]], AbsoluteThickness[0.25],
      LineBox[{2897, 2898}]}, 
    {Hue[
      NCache[
       Rational[966, 4769], 0.20255818829943384`]], AbsoluteThickness[0.25], 
     LineBox[{2898, 2899}]}, 
    {Hue[
      NCache[
       Rational[2899, 14307], 0.20262808415460964`]], AbsoluteThickness[0.25],
      LineBox[{2899, 2900}]}, 
    {Hue[
      NCache[
       Rational[2900, 14307], 0.20269798000978542`]], AbsoluteThickness[0.25],
      LineBox[{2900, 2901}]}, 
    {Hue[
      NCache[
       Rational[967, 4769], 0.2027678758649612]], AbsoluteThickness[0.25], 
     LineBox[{2901, 2902}]}, 
    {Hue[
      NCache[
       Rational[2902, 14307], 0.202837771720137]], AbsoluteThickness[0.25], 
     LineBox[{2902, 2903}]}, 
    {Hue[
      NCache[
       Rational[2903, 14307], 0.20290766757531278`]], AbsoluteThickness[0.25],
      LineBox[{2903, 2904}]}, 
    {Hue[
      NCache[
       Rational[968, 4769], 0.20297756343048856`]], AbsoluteThickness[0.25], 
     LineBox[{2904, 2905}]}, 
    {Hue[
      NCache[
       Rational[2905, 14307], 0.20304745928566437`]], AbsoluteThickness[0.25],
      LineBox[{2905, 2906}]}, 
    {Hue[
      NCache[
       Rational[2906, 14307], 0.20311735514084014`]], AbsoluteThickness[0.25],
      LineBox[{2906, 2907}]}, 
    {Hue[
      NCache[
       Rational[51, 251], 0.20318725099601595`]], AbsoluteThickness[0.25], 
     LineBox[{2907, 2908}]}, 
    {Hue[
      NCache[
       Rational[2908, 14307], 0.20325714685119173`]], AbsoluteThickness[0.25],
      LineBox[{2908, 2909}]}, 
    {Hue[
      NCache[
       Rational[2909, 14307], 0.2033270427063675]], AbsoluteThickness[0.25], 
     LineBox[{2909, 2910}]}, 
    {Hue[
      NCache[
       Rational[970, 4769], 0.2033969385615433]], AbsoluteThickness[0.25], 
     LineBox[{2910, 2911}]}, 
    {Hue[
      NCache[
       Rational[2911, 14307], 0.2034668344167191]], AbsoluteThickness[0.25], 
     LineBox[{2911, 2912}]}, 
    {Hue[
      NCache[
       Rational[2912, 14307], 0.20353673027189487`]], AbsoluteThickness[0.25],
      LineBox[{2912, 2913}]}, 
    {Hue[
      NCache[
       Rational[971, 4769], 0.20360662612707067`]], AbsoluteThickness[0.25], 
     LineBox[{2913, 2914}]}, 
    {Hue[
      NCache[
       Rational[2914, 14307], 0.20367652198224645`]], AbsoluteThickness[0.25],
      LineBox[{2914, 2915}]}, 
    {Hue[
      NCache[
       Rational[2915, 14307], 0.20374641783742223`]], AbsoluteThickness[0.25],
      LineBox[{2915, 2916}]}, 
    {Hue[
      NCache[
       Rational[972, 4769], 0.20381631369259803`]], AbsoluteThickness[0.25], 
     LineBox[{2916, 2917}]}, 
    {Hue[
      NCache[
       Rational[2917, 14307], 0.2038862095477738]], AbsoluteThickness[0.25], 
     LineBox[{2917, 2918}]}, 
    {Hue[
      NCache[
       Rational[2918, 14307], 0.20395610540294962`]], AbsoluteThickness[0.25],
      LineBox[{2918, 2919}]}, 
    {Hue[
      NCache[
       Rational[973, 4769], 0.2040260012581254]], AbsoluteThickness[0.25], 
     LineBox[{2919, 2920}]}, 
    {Hue[
      NCache[
       Rational[2920, 14307], 0.20409589711330117`]], AbsoluteThickness[0.25],
      LineBox[{2920, 2921}]}, 
    {Hue[
      NCache[
       Rational[2921, 14307], 0.20416579296847698`]], AbsoluteThickness[0.25],
      LineBox[{2921, 2922}]}, 
    {Hue[
      NCache[
       Rational[974, 4769], 0.20423568882365276`]], AbsoluteThickness[0.25], 
     LineBox[{2922, 2923}]}, 
    {Hue[
      NCache[
       Rational[2923, 14307], 0.20430558467882853`]], AbsoluteThickness[0.25],
      LineBox[{2923, 2924}]}, 
    {Hue[
      NCache[
       Rational[2924, 14307], 0.20437548053400434`]], AbsoluteThickness[0.25],
      LineBox[{2924, 2925}]}, 
    {Hue[
      NCache[
       Rational[975, 4769], 0.20444537638918012`]], AbsoluteThickness[0.25], 
     LineBox[{2925, 2926}]}, 
    {Hue[
      NCache[
       Rational[154, 753], 0.20451527224435592`]], AbsoluteThickness[0.25], 
     LineBox[{2926, 2927}]}, 
    {Hue[
      NCache[
       Rational[2927, 14307], 0.2045851680995317]], AbsoluteThickness[0.25], 
     LineBox[{2927, 2928}]}, 
    {Hue[
      NCache[
       Rational[976, 4769], 0.20465506395470748`]], AbsoluteThickness[0.25], 
     LineBox[{2928, 2929}]}, 
    {Hue[
      NCache[
       Rational[2929, 14307], 0.20472495980988328`]], AbsoluteThickness[0.25],
      LineBox[{2929, 2930}]}, 
    {Hue[
      NCache[
       Rational[2930, 14307], 0.20479485566505906`]], AbsoluteThickness[0.25],
      LineBox[{2930, 2931}]}, 
    {Hue[
      NCache[
       Rational[977, 4769], 0.20486475152023484`]], AbsoluteThickness[0.25], 
     LineBox[{2931, 2932}]}, 
    {Hue[
      NCache[
       Rational[2932, 14307], 0.20493464737541064`]], AbsoluteThickness[0.25],
      LineBox[{2932, 2933}]}, 
    {Hue[
      NCache[
       Rational[2933, 14307], 0.20500454323058642`]], AbsoluteThickness[0.25],
      LineBox[{2933, 2934}]}, 
    {Hue[
      NCache[
       Rational[978, 4769], 0.20507443908576223`]], AbsoluteThickness[0.25], 
     LineBox[{2934, 2935}]}, 
    {Hue[
      NCache[
       Rational[2935, 14307], 0.205144334940938]], AbsoluteThickness[0.25], 
     LineBox[{2935, 2936}]}, 
    {Hue[
      NCache[
       Rational[2936, 14307], 0.20521423079611378`]], AbsoluteThickness[0.25],
      LineBox[{2936, 2937}]}, 
    {Hue[
      NCache[
       Rational[979, 4769], 0.2052841266512896]], AbsoluteThickness[0.25], 
     LineBox[{2937, 2938}]}, 
    {Hue[
      NCache[
       Rational[2938, 14307], 0.20535402250646537`]], AbsoluteThickness[0.25],
      LineBox[{2938, 2939}]}, 
    {Hue[
      NCache[
       Rational[2939, 14307], 0.20542391836164114`]], AbsoluteThickness[0.25],
      LineBox[{2939, 2940}]}, 
    {Hue[
      NCache[
       Rational[980, 4769], 0.20549381421681695`]], AbsoluteThickness[0.25], 
     LineBox[{2940, 2941}]}, 
    {Hue[
      NCache[
       Rational[2941, 14307], 0.20556371007199273`]], AbsoluteThickness[0.25],
      LineBox[{2941, 2942}]}, 
    {Hue[
      NCache[
       Rational[2942, 14307], 0.2056336059271685]], AbsoluteThickness[0.25], 
     LineBox[{2942, 2943}]}, 
    {Hue[
      NCache[
       Rational[981, 4769], 0.2057035017823443]], AbsoluteThickness[0.25], 
     LineBox[{2943, 2944}]}, 
    {Hue[
      NCache[
       Rational[2944, 14307], 0.2057733976375201]], AbsoluteThickness[0.25], 
     LineBox[{2944, 2945}]}, 
    {Hue[
      NCache[
       Rational[155, 753], 0.2058432934926959]], AbsoluteThickness[0.25], 
     LineBox[{2945, 2946}]}, 
    {Hue[
      NCache[
       Rational[982, 4769], 0.20591318934787167`]], AbsoluteThickness[0.25], 
     LineBox[{2946, 2947}]}, 
    {Hue[
      NCache[
       Rational[2947, 14307], 0.20598308520304745`]], AbsoluteThickness[0.25],
      LineBox[{2947, 2948}]}, 
    {Hue[
      NCache[
       Rational[2948, 14307], 0.20605298105822326`]], AbsoluteThickness[0.25],
      LineBox[{2948, 2949}]}, 
    {Hue[
      NCache[
       Rational[983, 4769], 0.20612287691339903`]], AbsoluteThickness[0.25], 
     LineBox[{2949, 2950}]}, 
    {Hue[
      NCache[
       Rational[2950, 14307], 0.2061927727685748]], AbsoluteThickness[0.25], 
     LineBox[{2950, 2951}]}, 
    {Hue[
      NCache[
       Rational[2951, 14307], 0.20626266862375062`]], AbsoluteThickness[0.25],
      LineBox[{2951, 2952}]}, 
    {Hue[
      NCache[
       Rational[984, 4769], 0.2063325644789264]], AbsoluteThickness[0.25], 
     LineBox[{2952, 2953}]}, 
    {Hue[
      NCache[
       Rational[2953, 14307], 0.2064024603341022]], AbsoluteThickness[0.25], 
     LineBox[{2953, 2954}]}, 
    {Hue[
      NCache[
       Rational[2954, 14307], 0.20647235618927798`]], AbsoluteThickness[0.25],
      LineBox[{2954, 2955}]}, 
    {Hue[
      NCache[
       Rational[985, 4769], 0.20654225204445376`]], AbsoluteThickness[0.25], 
     LineBox[{2955, 2956}]}, 
    {Hue[
      NCache[
       Rational[2956, 14307], 0.20661214789962956`]], AbsoluteThickness[0.25],
      LineBox[{2956, 2957}]}, 
    {Hue[
      NCache[
       Rational[2957, 14307], 0.20668204375480534`]], AbsoluteThickness[0.25],
      LineBox[{2957, 2958}]}, 
    {Hue[
      NCache[
       Rational[986, 4769], 0.20675193960998112`]], AbsoluteThickness[0.25], 
     LineBox[{2958, 2959}]}, 
    {Hue[
      NCache[
       Rational[2959, 14307], 0.20682183546515692`]], AbsoluteThickness[0.25],
      LineBox[{2959, 2960}]}, 
    {Hue[
      NCache[
       Rational[2960, 14307], 0.2068917313203327]], AbsoluteThickness[0.25], 
     LineBox[{2960, 2961}]}, 
    {Hue[
      NCache[
       Rational[987, 4769], 0.2069616271755085]], AbsoluteThickness[0.25], 
     LineBox[{2961, 2962}]}, 
    {Hue[
      NCache[
       Rational[2962, 14307], 0.20703152303068428`]], AbsoluteThickness[0.25],
      LineBox[{2962, 2963}]}, 
    {Hue[
      NCache[
       Rational[2963, 14307], 0.20710141888586006`]], AbsoluteThickness[0.25],
      LineBox[{2963, 2964}]}, 
    {Hue[
      NCache[
       Rational[52, 251], 0.20717131474103587`]], AbsoluteThickness[0.25], 
     LineBox[{2964, 2965}]}, 
    {Hue[
      NCache[
       Rational[2965, 14307], 0.20724121059621164`]], AbsoluteThickness[0.25],
      LineBox[{2965, 2966}]}, 
    {Hue[
      NCache[
       Rational[2966, 14307], 0.20731110645138742`]], AbsoluteThickness[0.25],
      LineBox[{2966, 2967}]}, 
    {Hue[
      NCache[
       Rational[989, 4769], 0.20738100230656323`]], AbsoluteThickness[0.25], 
     LineBox[{2967, 2968}]}, 
    {Hue[
      NCache[
       Rational[2968, 14307], 0.207450898161739]], AbsoluteThickness[0.25], 
     LineBox[{2968, 2969}]}, 
    {Hue[
      NCache[
       Rational[2969, 14307], 0.20752079401691478`]], AbsoluteThickness[0.25],
      LineBox[{2969, 2970}]}, 
    {Hue[
      NCache[
       Rational[990, 4769], 0.2075906898720906]], AbsoluteThickness[0.25], 
     LineBox[{2970, 2971}]}, 
    {Hue[
      NCache[
       Rational[2971, 14307], 0.20766058572726637`]], AbsoluteThickness[0.25],
      LineBox[{2971, 2972}]}, 
    {Hue[
      NCache[
       Rational[2972, 14307], 0.20773048158244217`]], AbsoluteThickness[0.25],
      LineBox[{2972, 2973}]}, 
    {Hue[
      NCache[
       Rational[991, 4769], 0.20780037743761795`]], AbsoluteThickness[0.25], 
     LineBox[{2973, 2974}]}, 
    {Hue[
      NCache[
       Rational[2974, 14307], 0.20787027329279373`]], AbsoluteThickness[0.25],
      LineBox[{2974, 2975}]}, 
    {Hue[
      NCache[
       Rational[2975, 14307], 0.20794016914796953`]], AbsoluteThickness[0.25],
      LineBox[{2975, 2976}]}, 
    {Hue[
      NCache[
       Rational[992, 4769], 0.2080100650031453]], AbsoluteThickness[0.25], 
     LineBox[{2976, 2977}]}, 
    {Hue[
      NCache[
       Rational[2977, 14307], 0.2080799608583211]], AbsoluteThickness[0.25], 
     LineBox[{2977, 2978}]}, 
    {Hue[
      NCache[
       Rational[2978, 14307], 0.2081498567134969]], AbsoluteThickness[0.25], 
     LineBox[{2978, 2979}]}, 
    {Hue[
      NCache[
       Rational[993, 4769], 0.20821975256867267`]], AbsoluteThickness[0.25], 
     LineBox[{2979, 2980}]}, 
    {Hue[
      NCache[
       Rational[2980, 14307], 0.20828964842384848`]], AbsoluteThickness[0.25],
      LineBox[{2980, 2981}]}, 
    {Hue[
      NCache[
       Rational[2981, 14307], 0.20835954427902426`]], AbsoluteThickness[0.25],
      LineBox[{2981, 2982}]}, 
    {Hue[
      NCache[
       Rational[994, 4769], 0.20842944013420003`]], AbsoluteThickness[0.25], 
     LineBox[{2982, 2983}]}, 
    {Hue[
      NCache[
       Rational[157, 753], 0.20849933598937584`]], AbsoluteThickness[0.25], 
     LineBox[{2983, 2984}]}, 
    {Hue[
      NCache[
       Rational[2984, 14307], 0.20856923184455162`]], AbsoluteThickness[0.25],
      LineBox[{2984, 2985}]}, 
    {Hue[
      NCache[
       Rational[995, 4769], 0.2086391276997274]], AbsoluteThickness[0.25], 
     LineBox[{2985, 2986}]}, 
    {Hue[
      NCache[
       Rational[2986, 14307], 0.2087090235549032]], AbsoluteThickness[0.25], 
     LineBox[{2986, 2987}]}, 
    {Hue[
      NCache[
       Rational[2987, 14307], 0.20877891941007898`]], AbsoluteThickness[0.25],
      LineBox[{2987, 2988}]}, 
    {Hue[
      NCache[
       Rational[996, 4769], 0.20884881526525478`]], AbsoluteThickness[0.25], 
     LineBox[{2988, 2989}]}, 
    {Hue[
      NCache[
       Rational[2989, 14307], 0.20891871112043056`]], AbsoluteThickness[0.25],
      LineBox[{2989, 2990}]}, 
    {Hue[
      NCache[
       Rational[2990, 14307], 0.20898860697560634`]], AbsoluteThickness[0.25],
      LineBox[{2990, 2991}]}, 
    {Hue[
      NCache[
       Rational[997, 4769], 0.20905850283078214`]], AbsoluteThickness[0.25], 
     LineBox[{2991, 2992}]}, 
    {Hue[
      NCache[
       Rational[2992, 14307], 0.20912839868595792`]], AbsoluteThickness[0.25],
      LineBox[{2992, 2993}]}, 
    {Hue[
      NCache[
       Rational[2993, 14307], 0.2091982945411337]], AbsoluteThickness[0.25], 
     LineBox[{2993, 2994}]}, 
    {Hue[
      NCache[
       Rational[998, 4769], 0.2092681903963095]], AbsoluteThickness[0.25], 
     LineBox[{2994, 2995}]}, 
    {Hue[
      NCache[
       Rational[2995, 14307], 0.20933808625148528`]], AbsoluteThickness[0.25],
      LineBox[{2995, 2996}]}, 
    {Hue[
      NCache[
       Rational[2996, 14307], 0.20940798210666106`]], AbsoluteThickness[0.25],
      LineBox[{2996, 2997}]}, 
    {Hue[
      NCache[
       Rational[999, 4769], 0.20947787796183687`]], AbsoluteThickness[0.25], 
     LineBox[{2997, 2998}]}, 
    {Hue[
      NCache[
       Rational[2998, 14307], 0.20954777381701264`]], AbsoluteThickness[0.25],
      LineBox[{2998, 2999}]}, 
    {Hue[
      NCache[
       Rational[2999, 14307], 0.20961766967218845`]], AbsoluteThickness[0.25],
      LineBox[{2999, 3000}]}, 
    {Hue[
      NCache[
       Rational[1000, 4769], 0.20968756552736423`]], AbsoluteThickness[0.25], 
     LineBox[{3000, 3001}]}, 
    {Hue[
      NCache[
       Rational[3001, 14307], 0.20975746138254]], AbsoluteThickness[0.25], 
     LineBox[{3001, 3002}]}, 
    {Hue[
      NCache[
       Rational[158, 753], 0.2098273572377158]], AbsoluteThickness[0.25], 
     LineBox[{3002, 3003}]}, 
    {Hue[
      NCache[
       Rational[1001, 4769], 0.2098972530928916]], AbsoluteThickness[0.25], 
     LineBox[{3003, 3004}]}, 
    {Hue[
      NCache[
       Rational[3004, 14307], 0.20996714894806737`]], AbsoluteThickness[0.25],
      LineBox[{3004, 3005}]}, 
    {Hue[
      NCache[
       Rational[3005, 14307], 0.21003704480324317`]], AbsoluteThickness[0.25],
      LineBox[{3005, 3006}]}, 
    {Hue[
      NCache[
       Rational[1002, 4769], 0.21010694065841895`]], AbsoluteThickness[0.25], 
     LineBox[{3006, 3007}]}, 
    {Hue[
      NCache[
       Rational[3007, 14307], 0.21017683651359476`]], AbsoluteThickness[0.25],
      LineBox[{3007, 3008}]}, 
    {Hue[
      NCache[
       Rational[3008, 14307], 0.21024673236877053`]], AbsoluteThickness[0.25],
      LineBox[{3008, 3009}]}, 
    {Hue[
      NCache[
       Rational[1003, 4769], 0.2103166282239463]], AbsoluteThickness[0.25], 
     LineBox[{3009, 3010}]}, 
    {Hue[
      NCache[
       Rational[3010, 14307], 0.21038652407912212`]], AbsoluteThickness[0.25],
      LineBox[{3010, 3011}]}, 
    {Hue[
      NCache[
       Rational[3011, 14307], 0.2104564199342979]], AbsoluteThickness[0.25], 
     LineBox[{3011, 3012}]}, 
    {Hue[
      NCache[
       Rational[4, 19], 0.21052631578947367`]], AbsoluteThickness[0.25], 
     LineBox[{3012, 3013}]}, 
    {Hue[
      NCache[
       Rational[3013, 14307], 0.21059621164464948`]], AbsoluteThickness[0.25],
      LineBox[{3013, 3014}]}, 
    {Hue[
      NCache[
       Rational[3014, 14307], 0.21066610749982526`]], AbsoluteThickness[0.25],
      LineBox[{3014, 3015}]}, 
    {Hue[
      NCache[
       Rational[1005, 4769], 0.21073600335500106`]], AbsoluteThickness[0.25], 
     LineBox[{3015, 3016}]}, 
    {Hue[
      NCache[
       Rational[3016, 14307], 0.21080589921017684`]], AbsoluteThickness[0.25],
      LineBox[{3016, 3017}]}, 
    {Hue[
      NCache[
       Rational[3017, 14307], 0.21087579506535262`]], AbsoluteThickness[0.25],
      LineBox[{3017, 3018}]}, 
    {Hue[
      NCache[
       Rational[1006, 4769], 0.21094569092052842`]], AbsoluteThickness[0.25], 
     LineBox[{3018, 3019}]}, 
    {Hue[
      NCache[
       Rational[3019, 14307], 0.2110155867757042]], AbsoluteThickness[0.25], 
     LineBox[{3019, 3020}]}, 
    {Hue[
      NCache[
       Rational[3020, 14307], 0.21108548263087998`]], AbsoluteThickness[0.25],
      LineBox[{3020, 3021}]}, 
    {Hue[
      NCache[
       Rational[53, 251], 0.21115537848605578`]], AbsoluteThickness[0.25], 
     LineBox[{3021, 3022}]}, 
    {Hue[
      NCache[
       Rational[3022, 14307], 0.21122527434123156`]], AbsoluteThickness[0.25],
      LineBox[{3022, 3023}]}, 
    {Hue[
      NCache[
       Rational[3023, 14307], 0.21129517019640734`]], AbsoluteThickness[0.25],
      LineBox[{3023, 3024}]}, 
    {Hue[
      NCache[
       Rational[1008, 4769], 0.21136506605158314`]], AbsoluteThickness[0.25], 
     LineBox[{3024, 3025}]}, 
    {Hue[
      NCache[
       Rational[3025, 14307], 0.21143496190675892`]], AbsoluteThickness[0.25],
      LineBox[{3025, 3026}]}, 
    {Hue[
      NCache[
       Rational[3026, 14307], 0.21150485776193473`]], AbsoluteThickness[0.25],
      LineBox[{3026, 3027}]}, 
    {Hue[
      NCache[
       Rational[1009, 4769], 0.2115747536171105]], AbsoluteThickness[0.25], 
     LineBox[{3027, 3028}]}, 
    {Hue[
      NCache[
       Rational[3028, 14307], 0.21164464947228628`]], AbsoluteThickness[0.25],
      LineBox[{3028, 3029}]}, 
    {Hue[
      NCache[
       Rational[3029, 14307], 0.2117145453274621]], AbsoluteThickness[0.25], 
     LineBox[{3029, 3030}]}, 
    {Hue[
      NCache[
       Rational[1010, 4769], 0.21178444118263787`]], AbsoluteThickness[0.25], 
     LineBox[{3030, 3031}]}, 
    {Hue[
      NCache[
       Rational[3031, 14307], 0.21185433703781364`]], AbsoluteThickness[0.25],
      LineBox[{3031, 3032}]}, 
    {Hue[
      NCache[
       Rational[3032, 14307], 0.21192423289298945`]], AbsoluteThickness[0.25],
      LineBox[{3032, 3033}]}, 
    {Hue[
      NCache[
       Rational[1011, 4769], 0.21199412874816523`]], AbsoluteThickness[0.25], 
     LineBox[{3033, 3034}]}, 
    {Hue[
      NCache[
       Rational[3034, 14307], 0.21206402460334103`]], AbsoluteThickness[0.25],
      LineBox[{3034, 3035}]}, 
    {Hue[
      NCache[
       Rational[3035, 14307], 0.2121339204585168]], AbsoluteThickness[0.25], 
     LineBox[{3035, 3036}]}, 
    {Hue[
      NCache[
       Rational[1012, 4769], 0.2122038163136926]], AbsoluteThickness[0.25], 
     LineBox[{3036, 3037}]}, 
    {Hue[
      NCache[
       Rational[3037, 14307], 0.2122737121688684]], AbsoluteThickness[0.25], 
     LineBox[{3037, 3038}]}, 
    {Hue[
      NCache[
       Rational[3038, 14307], 0.21234360802404417`]], AbsoluteThickness[0.25],
      LineBox[{3038, 3039}]}, 
    {Hue[
      NCache[
       Rational[1013, 4769], 0.21241350387921995`]], AbsoluteThickness[0.25], 
     LineBox[{3039, 3040}]}, 
    {Hue[
      NCache[
       Rational[160, 753], 0.21248339973439576`]], AbsoluteThickness[0.25], 
     LineBox[{3040, 3041}]}, 
    {Hue[
      NCache[
       Rational[3041, 14307], 0.21255329558957153`]], AbsoluteThickness[0.25],
      LineBox[{3041, 3042}]}, 
    {Hue[
      NCache[
       Rational[1014, 4769], 0.21262319144474734`]], AbsoluteThickness[0.25], 
     LineBox[{3042, 3043}]}, 
    {Hue[
      NCache[
       Rational[3043, 14307], 0.21269308729992312`]], AbsoluteThickness[0.25],
      LineBox[{3043, 3044}]}, 
    {Hue[
      NCache[
       Rational[3044, 14307], 0.2127629831550989]], AbsoluteThickness[0.25], 
     LineBox[{3044, 3045}]}, 
    {Hue[
      NCache[
       Rational[1015, 4769], 0.2128328790102747]], AbsoluteThickness[0.25], 
     LineBox[{3045, 3046}]}, 
    {Hue[
      NCache[
       Rational[3046, 14307], 0.21290277486545048`]], AbsoluteThickness[0.25],
      LineBox[{3046, 3047}]}, 
    {Hue[
      NCache[
       Rational[3047, 14307], 0.21297267072062626`]], AbsoluteThickness[0.25],
      LineBox[{3047, 3048}]}, 
    {Hue[
      NCache[
       Rational[1016, 4769], 0.21304256657580206`]], AbsoluteThickness[0.25], 
     LineBox[{3048, 3049}]}, 
    {Hue[
      NCache[
       Rational[3049, 14307], 0.21311246243097784`]], AbsoluteThickness[0.25],
      LineBox[{3049, 3050}]}, 
    {Hue[
      NCache[
       Rational[3050, 14307], 0.21318235828615364`]], AbsoluteThickness[0.25],
      LineBox[{3050, 3051}]}, 
    {Hue[
      NCache[
       Rational[1017, 4769], 0.21325225414132942`]], AbsoluteThickness[0.25], 
     LineBox[{3051, 3052}]}, 
    {Hue[
      NCache[
       Rational[3052, 14307], 0.2133221499965052]], AbsoluteThickness[0.25], 
     LineBox[{3052, 3053}]}, 
    {Hue[
      NCache[
       Rational[3053, 14307], 0.213392045851681]], AbsoluteThickness[0.25], 
     LineBox[{3053, 3054}]}, 
    {Hue[
      NCache[
       Rational[1018, 4769], 0.21346194170685678`]], AbsoluteThickness[0.25], 
     LineBox[{3054, 3055}]}, 
    {Hue[
      NCache[
       Rational[3055, 14307], 0.21353183756203256`]], AbsoluteThickness[0.25],
      LineBox[{3055, 3056}]}, 
    {Hue[
      NCache[
       Rational[3056, 14307], 0.21360173341720837`]], AbsoluteThickness[0.25],
      LineBox[{3056, 3057}]}, 
    {Hue[
      NCache[
       Rational[1019, 4769], 0.21367162927238414`]], AbsoluteThickness[0.25], 
     LineBox[{3057, 3058}]}, 
    {Hue[
      NCache[
       Rational[3058, 14307], 0.21374152512755992`]], AbsoluteThickness[0.25],
      LineBox[{3058, 3059}]}, 
    {Hue[
      NCache[
       Rational[161, 753], 0.21381142098273573`]], AbsoluteThickness[0.25], 
     LineBox[{3059, 3060}]}, 
    {Hue[
      NCache[
       Rational[1020, 4769], 0.2138813168379115]], AbsoluteThickness[0.25], 
     LineBox[{3060, 3061}]}, 
    {Hue[
      NCache[
       Rational[3061, 14307], 0.2139512126930873]], AbsoluteThickness[0.25], 
     LineBox[{3061, 3062}]}, 
    {Hue[
      NCache[
       Rational[3062, 14307], 0.2140211085482631]], AbsoluteThickness[0.25], 
     LineBox[{3062, 3063}]}, 
    {Hue[
      NCache[
       Rational[1021, 4769], 0.21409100440343887`]], AbsoluteThickness[0.25], 
     LineBox[{3063, 3064}]}, 
    {Hue[
      NCache[
       Rational[3064, 14307], 0.21416090025861467`]], AbsoluteThickness[0.25],
      LineBox[{3064, 3065}]}, 
    {Hue[
      NCache[
       Rational[3065, 14307], 0.21423079611379045`]], AbsoluteThickness[0.25],
      LineBox[{3065, 3066}]}, 
    {Hue[
      NCache[
       Rational[1022, 4769], 0.21430069196896623`]], AbsoluteThickness[0.25], 
     LineBox[{3066, 3067}]}, 
    {Hue[
      NCache[
       Rational[3067, 14307], 0.21437058782414203`]], AbsoluteThickness[0.25],
      LineBox[{3067, 3068}]}, 
    {Hue[
      NCache[
       Rational[3068, 14307], 0.2144404836793178]], AbsoluteThickness[0.25], 
     LineBox[{3068, 3069}]}, 
    {Hue[
      NCache[
       Rational[1023, 4769], 0.21451037953449362`]], AbsoluteThickness[0.25], 
     LineBox[{3069, 3070}]}, 
    {Hue[
      NCache[
       Rational[3070, 14307], 0.2145802753896694]], AbsoluteThickness[0.25], 
     LineBox[{3070, 3071}]}, 
    {Hue[
      NCache[
       Rational[3071, 14307], 0.21465017124484517`]], AbsoluteThickness[0.25],
      LineBox[{3071, 3072}]}, 
    {Hue[
      NCache[
       Rational[1024, 4769], 0.21472006710002098`]], AbsoluteThickness[0.25], 
     LineBox[{3072, 3073}]}, 
    {Hue[
      NCache[
       Rational[3073, 14307], 0.21478996295519676`]], AbsoluteThickness[0.25],
      LineBox[{3073, 3074}]}, 
    {Hue[
      NCache[
       Rational[3074, 14307], 0.21485985881037253`]], AbsoluteThickness[0.25],
      LineBox[{3074, 3075}]}, 
    {Hue[
      NCache[
       Rational[1025, 4769], 0.21492975466554834`]], AbsoluteThickness[0.25], 
     LineBox[{3075, 3076}]}, 
    {Hue[
      NCache[
       Rational[3076, 14307], 0.21499965052072412`]], AbsoluteThickness[0.25],
      LineBox[{3076, 3077}]}, 
    {Hue[
      NCache[
       Rational[3077, 14307], 0.21506954637589992`]], AbsoluteThickness[0.25],
      LineBox[{3077, 3078}]}, 
    {Hue[
      NCache[
       Rational[54, 251], 0.2151394422310757]], AbsoluteThickness[0.25], 
     LineBox[{3078, 3079}]}, 
    {Hue[
      NCache[
       Rational[3079, 14307], 0.21520933808625148`]], AbsoluteThickness[0.25],
      LineBox[{3079, 3080}]}, 
    {Hue[
      NCache[
       Rational[3080, 14307], 0.21527923394142728`]], AbsoluteThickness[0.25],
      LineBox[{3080, 3081}]}, 
    {Hue[
      NCache[
       Rational[1027, 4769], 0.21534912979660306`]], AbsoluteThickness[0.25], 
     LineBox[{3081, 3082}]}, 
    {Hue[
      NCache[
       Rational[3082, 14307], 0.21541902565177884`]], AbsoluteThickness[0.25],
      LineBox[{3082, 3083}]}, 
    {Hue[
      NCache[
       Rational[3083, 14307], 0.21548892150695464`]], AbsoluteThickness[0.25],
      LineBox[{3083, 3084}]}, 
    {Hue[
      NCache[
       Rational[1028, 4769], 0.21555881736213042`]], AbsoluteThickness[0.25], 
     LineBox[{3084, 3085}]}, 
    {Hue[
      NCache[
       Rational[3085, 14307], 0.2156287132173062]], AbsoluteThickness[0.25], 
     LineBox[{3085, 3086}]}, 
    {Hue[
      NCache[
       Rational[3086, 14307], 0.215698609072482]], AbsoluteThickness[0.25], 
     LineBox[{3086, 3087}]}, 
    {Hue[
      NCache[
       Rational[1029, 4769], 0.21576850492765778`]], AbsoluteThickness[0.25], 
     LineBox[{3087, 3088}]}, 
    {Hue[
      NCache[
       Rational[3088, 14307], 0.2158384007828336]], AbsoluteThickness[0.25], 
     LineBox[{3088, 3089}]}, 
    {Hue[
      NCache[
       Rational[3089, 14307], 0.21590829663800937`]], AbsoluteThickness[0.25],
      LineBox[{3089, 3090}]}, 
    {Hue[
      NCache[
       Rational[1030, 4769], 0.21597819249318514`]], AbsoluteThickness[0.25], 
     LineBox[{3090, 3091}]}, 
    {Hue[
      NCache[
       Rational[3091, 14307], 0.21604808834836095`]], AbsoluteThickness[0.25],
      LineBox[{3091, 3092}]}, 
    {Hue[
      NCache[
       Rational[3092, 14307], 0.21611798420353673`]], AbsoluteThickness[0.25],
      LineBox[{3092, 3093}]}, 
    {Hue[
      NCache[
       Rational[1031, 4769], 0.2161878800587125]], AbsoluteThickness[0.25], 
     LineBox[{3093, 3094}]}, 
    {Hue[
      NCache[
       Rational[3094, 14307], 0.2162577759138883]], AbsoluteThickness[0.25], 
     LineBox[{3094, 3095}]}, 
    {Hue[
      NCache[
       Rational[3095, 14307], 0.2163276717690641]], AbsoluteThickness[0.25], 
     LineBox[{3095, 3096}]}, 
    {Hue[
      NCache[
       Rational[1032, 4769], 0.2163975676242399]], AbsoluteThickness[0.25], 
     LineBox[{3096, 3097}]}, 
    {Hue[
      NCache[
       Rational[163, 753], 0.21646746347941567`]], AbsoluteThickness[0.25], 
     LineBox[{3097, 3098}]}, 
    {Hue[
      NCache[
       Rational[3098, 14307], 0.21653735933459145`]], AbsoluteThickness[0.25],
      LineBox[{3098, 3099}]}, 
    {Hue[
      NCache[
       Rational[1033, 4769], 0.21660725518976726`]], AbsoluteThickness[0.25], 
     LineBox[{3099, 3100}]}, 
    {Hue[
      NCache[
       Rational[3100, 14307], 0.21667715104494303`]], AbsoluteThickness[0.25],
      LineBox[{3100, 3101}]}, 
    {Hue[
      NCache[
       Rational[3101, 14307], 0.2167470469001188]], AbsoluteThickness[0.25], 
     LineBox[{3101, 3102}]}, 
    {Hue[
      NCache[
       Rational[1034, 4769], 0.21681694275529462`]], AbsoluteThickness[0.25], 
     LineBox[{3102, 3103}]}, 
    {Hue[
      NCache[
       Rational[3103, 14307], 0.2168868386104704]], AbsoluteThickness[0.25], 
     LineBox[{3103, 3104}]}, 
    {Hue[
      NCache[
       Rational[3104, 14307], 0.2169567344656462]], AbsoluteThickness[0.25], 
     LineBox[{3104, 3105}]}, 
    {Hue[
      NCache[
       Rational[1035, 4769], 0.21702663032082198`]], AbsoluteThickness[0.25], 
     LineBox[{3105, 3106}]}, 
    {Hue[
      NCache[
       Rational[3106, 14307], 0.21709652617599776`]], AbsoluteThickness[0.25],
      LineBox[{3106, 3107}]}, 
    {Hue[
      NCache[
       Rational[3107, 14307], 0.21716642203117356`]], AbsoluteThickness[0.25],
      LineBox[{3107, 3108}]}, 
    {Hue[
      NCache[
       Rational[1036, 4769], 0.21723631788634934`]], AbsoluteThickness[0.25], 
     LineBox[{3108, 3109}]}, 
    {Hue[
      NCache[
       Rational[3109, 14307], 0.21730621374152512`]], AbsoluteThickness[0.25],
      LineBox[{3109, 3110}]}, 
    {Hue[
      NCache[
       Rational[3110, 14307], 0.21737610959670092`]], AbsoluteThickness[0.25],
      LineBox[{3110, 3111}]}, 
    {Hue[
      NCache[
       Rational[1037, 4769], 0.2174460054518767]], AbsoluteThickness[0.25], 
     LineBox[{3111, 3112}]}, 
    {Hue[
      NCache[
       Rational[3112, 14307], 0.21751590130705248`]], AbsoluteThickness[0.25],
      LineBox[{3112, 3113}]}, 
    {Hue[
      NCache[
       Rational[3113, 14307], 0.21758579716222828`]], AbsoluteThickness[0.25],
      LineBox[{3113, 3114}]}, 
    {Hue[
      NCache[
       Rational[1038, 4769], 0.21765569301740406`]], AbsoluteThickness[0.25], 
     LineBox[{3114, 3115}]}, 
    {Hue[
      NCache[
       Rational[3115, 14307], 0.21772558887257987`]], AbsoluteThickness[0.25],
      LineBox[{3115, 3116}]}, 
    {Hue[
      NCache[
       Rational[164, 753], 0.21779548472775564`]], AbsoluteThickness[0.25], 
     LineBox[{3116, 3117}]}, 
    {Hue[
      NCache[
       Rational[1039, 4769], 0.21786538058293142`]], AbsoluteThickness[0.25], 
     LineBox[{3117, 3118}]}, 
    {Hue[
      NCache[
       Rational[3118, 14307], 0.21793527643810723`]], AbsoluteThickness[0.25],
      LineBox[{3118, 3119}]}, 
    {Hue[
      NCache[
       Rational[3119, 14307], 0.218005172293283]], AbsoluteThickness[0.25], 
     LineBox[{3119, 3120}]}, 
    {Hue[
      NCache[
       Rational[1040, 4769], 0.21807506814845878`]], AbsoluteThickness[0.25], 
     LineBox[{3120, 3121}]}, 
    {Hue[
      NCache[
       Rational[3121, 14307], 0.2181449640036346]], AbsoluteThickness[0.25], 
     LineBox[{3121, 3122}]}, 
    {Hue[
      NCache[
       Rational[3122, 14307], 0.21821485985881037`]], AbsoluteThickness[0.25],
      LineBox[{3122, 3123}]}, 
    {Hue[
      NCache[
       Rational[1041, 4769], 0.21828475571398617`]], AbsoluteThickness[0.25], 
     LineBox[{3123, 3124}]}, 
    {Hue[
      NCache[
       Rational[3124, 14307], 0.21835465156916195`]], AbsoluteThickness[0.25],
      LineBox[{3124, 3125}]}, 
    {Hue[
      NCache[
       Rational[3125, 14307], 0.21842454742433773`]], AbsoluteThickness[0.25],
      LineBox[{3125, 3126}]}, 
    {Hue[
      NCache[
       Rational[1042, 4769], 0.21849444327951353`]], AbsoluteThickness[0.25], 
     LineBox[{3126, 3127}]}, 
    {Hue[
      NCache[
       Rational[3127, 14307], 0.2185643391346893]], AbsoluteThickness[0.25], 
     LineBox[{3127, 3128}]}, 
    {Hue[
      NCache[
       Rational[3128, 14307], 0.2186342349898651]], AbsoluteThickness[0.25], 
     LineBox[{3128, 3129}]}, 
    {Hue[
      NCache[
       Rational[1043, 4769], 0.2187041308450409]], AbsoluteThickness[0.25], 
     LineBox[{3129, 3130}]}, 
    {Hue[
      NCache[
       Rational[3130, 14307], 0.21877402670021667`]], AbsoluteThickness[0.25],
      LineBox[{3130, 3131}]}, 
    {Hue[
      NCache[
       Rational[3131, 14307], 0.21884392255539248`]], AbsoluteThickness[0.25],
      LineBox[{3131, 3132}]}, 
    {Hue[
      NCache[
       Rational[1044, 4769], 0.21891381841056826`]], AbsoluteThickness[0.25], 
     LineBox[{3132, 3133}]}, 
    {Hue[
      NCache[
       Rational[3133, 14307], 0.21898371426574403`]], AbsoluteThickness[0.25],
      LineBox[{3133, 3134}]}, 
    {Hue[
      NCache[
       Rational[3134, 14307], 0.21905361012091984`]], AbsoluteThickness[0.25],
      LineBox[{3134, 3135}]}, 
    {Hue[
      NCache[
       Rational[55, 251], 0.21912350597609562`]], AbsoluteThickness[0.25], 
     LineBox[{3135, 3136}]}, 
    {Hue[
      NCache[
       Rational[3136, 14307], 0.2191934018312714]], AbsoluteThickness[0.25], 
     LineBox[{3136, 3137}]}, 
    {Hue[
      NCache[
       Rational[3137, 14307], 0.2192632976864472]], AbsoluteThickness[0.25], 
     LineBox[{3137, 3138}]}, 
    {Hue[
      NCache[
       Rational[1046, 4769], 0.21933319354162298`]], AbsoluteThickness[0.25], 
     LineBox[{3138, 3139}]}, 
    {Hue[
      NCache[
       Rational[3139, 14307], 0.21940308939679876`]], AbsoluteThickness[0.25],
      LineBox[{3139, 3140}]}, 
    {Hue[
      NCache[
       Rational[3140, 14307], 0.21947298525197456`]], AbsoluteThickness[0.25],
      LineBox[{3140, 3141}]}, 
    {Hue[
      NCache[
       Rational[1047, 4769], 0.21954288110715034`]], AbsoluteThickness[0.25], 
     LineBox[{3141, 3142}]}, 
    {Hue[
      NCache[
       Rational[3142, 14307], 0.21961277696232614`]], AbsoluteThickness[0.25],
      LineBox[{3142, 3143}]}, 
    {Hue[
      NCache[
       Rational[3143, 14307], 0.21968267281750192`]], AbsoluteThickness[0.25],
      LineBox[{3143, 3144}]}, 
    {Hue[
      NCache[
       Rational[1048, 4769], 0.2197525686726777]], AbsoluteThickness[0.25], 
     LineBox[{3144, 3145}]}, 
    {Hue[
      NCache[
       Rational[3145, 14307], 0.2198224645278535]], AbsoluteThickness[0.25], 
     LineBox[{3145, 3146}]}, 
    {Hue[
      NCache[
       Rational[3146, 14307], 0.21989236038302928`]], AbsoluteThickness[0.25],
      LineBox[{3146, 3147}]}, 
    {Hue[
      NCache[
       Rational[1049, 4769], 0.21996225623820506`]], AbsoluteThickness[0.25], 
     LineBox[{3147, 3148}]}, 
    {Hue[
      NCache[
       Rational[3148, 14307], 0.22003215209338087`]], AbsoluteThickness[0.25],
      LineBox[{3148, 3149}]}, 
    {Hue[
      NCache[
       Rational[3149, 14307], 0.22010204794855665`]], AbsoluteThickness[0.25],
      LineBox[{3149, 3150}]}, 
    {Hue[
      NCache[
       Rational[1050, 4769], 0.22017194380373245`]], AbsoluteThickness[0.25], 
     LineBox[{3150, 3151}]}, 
    {Hue[
      NCache[
       Rational[3151, 14307], 0.22024183965890823`]], AbsoluteThickness[0.25],
      LineBox[{3151, 3152}]}, 
    {Hue[
      NCache[
       Rational[3152, 14307], 0.220311735514084]], AbsoluteThickness[0.25], 
     LineBox[{3152, 3153}]}, 
    {Hue[
      NCache[
       Rational[1051, 4769], 0.2203816313692598]], AbsoluteThickness[0.25], 
     LineBox[{3153, 3154}]}, 
    {Hue[
      NCache[
       Rational[166, 753], 0.2204515272244356]], AbsoluteThickness[0.25], 
     LineBox[{3154, 3155}]}, 
    {Hue[
      NCache[
       Rational[3155, 14307], 0.22052142307961137`]], AbsoluteThickness[0.25],
      LineBox[{3155, 3156}]}, 
    {Hue[
      NCache[
       Rational[1052, 4769], 0.22059131893478717`]], AbsoluteThickness[0.25], 
     LineBox[{3156, 3157}]}, 
    {Hue[
      NCache[
       Rational[3157, 14307], 0.22066121478996295`]], AbsoluteThickness[0.25],
      LineBox[{3157, 3158}]}, 
    {Hue[
      NCache[
       Rational[3158, 14307], 0.22073111064513876`]], AbsoluteThickness[0.25],
      LineBox[{3158, 3159}]}, 
    {Hue[
      NCache[
       Rational[1053, 4769], 0.22080100650031453`]], AbsoluteThickness[0.25], 
     LineBox[{3159, 3160}]}, 
    {Hue[
      NCache[
       Rational[3160, 14307], 0.2208709023554903]], AbsoluteThickness[0.25], 
     LineBox[{3160, 3161}]}, 
    {Hue[
      NCache[
       Rational[3161, 14307], 0.22094079821066612`]], AbsoluteThickness[0.25],
      LineBox[{3161, 3162}]}, 
    {Hue[
      NCache[
       Rational[1054, 4769], 0.2210106940658419]], AbsoluteThickness[0.25], 
     LineBox[{3162, 3163}]}, 
    {Hue[
      NCache[
       Rational[3163, 14307], 0.22108058992101767`]], AbsoluteThickness[0.25],
      LineBox[{3163, 3164}]}, 
    {Hue[
      NCache[
       Rational[3164, 14307], 0.22115048577619348`]], AbsoluteThickness[0.25],
      LineBox[{3164, 3165}]}, 
    {Hue[
      NCache[
       Rational[1055, 4769], 0.22122038163136926`]], AbsoluteThickness[0.25], 
     LineBox[{3165, 3166}]}, 
    {Hue[
      NCache[
       Rational[3166, 14307], 0.22129027748654506`]], AbsoluteThickness[0.25],
      LineBox[{3166, 3167}]}, 
    {Hue[
      NCache[
       Rational[3167, 14307], 0.22136017334172084`]], AbsoluteThickness[0.25],
      LineBox[{3167, 3168}]}, 
    {Hue[
      NCache[
       Rational[1056, 4769], 0.22143006919689662`]], AbsoluteThickness[0.25], 
     LineBox[{3168, 3169}]}, 
    {Hue[
      NCache[
       Rational[3169, 14307], 0.22149996505207242`]], AbsoluteThickness[0.25],
      LineBox[{3169, 3170}]}, 
    {Hue[
      NCache[
       Rational[3170, 14307], 0.2215698609072482]], AbsoluteThickness[0.25], 
     LineBox[{3170, 3171}]}, 
    {Hue[
      NCache[
       Rational[1057, 4769], 0.22163975676242398`]], AbsoluteThickness[0.25], 
     LineBox[{3171, 3172}]}, 
    {Hue[
      NCache[
       Rational[3172, 14307], 0.22170965261759978`]], AbsoluteThickness[0.25],
      LineBox[{3172, 3173}]}, 
    {Hue[
      NCache[
       Rational[167, 753], 0.22177954847277556`]], AbsoluteThickness[0.25], 
     LineBox[{3173, 3174}]}, 
    {Hue[
      NCache[
       Rational[1058, 4769], 0.22184944432795134`]], AbsoluteThickness[0.25], 
     LineBox[{3174, 3175}]}, 
    {Hue[
      NCache[
       Rational[3175, 14307], 0.22191934018312715`]], AbsoluteThickness[0.25],
      LineBox[{3175, 3176}]}, 
    {Hue[
      NCache[
       Rational[3176, 14307], 0.22198923603830292`]], AbsoluteThickness[0.25],
      LineBox[{3176, 3177}]}, 
    {Hue[
      NCache[
       Rational[1059, 4769], 0.22205913189347873`]], AbsoluteThickness[0.25], 
     LineBox[{3177, 3178}]}, 
    {Hue[
      NCache[
       Rational[3178, 14307], 0.2221290277486545]], AbsoluteThickness[0.25], 
     LineBox[{3178, 3179}]}, 
    {Hue[
      NCache[
       Rational[3179, 14307], 0.22219892360383028`]], AbsoluteThickness[0.25],
      LineBox[{3179, 3180}]}, 
    {Hue[
      NCache[
       Rational[1060, 4769], 0.2222688194590061]], AbsoluteThickness[0.25], 
     LineBox[{3180, 3181}]}, 
    {Hue[
      NCache[
       Rational[3181, 14307], 0.22233871531418187`]], AbsoluteThickness[0.25],
      LineBox[{3181, 3182}]}, 
    {Hue[
      NCache[
       Rational[3182, 14307], 0.22240861116935765`]], AbsoluteThickness[0.25],
      LineBox[{3182, 3183}]}, 
    {Hue[
      NCache[
       Rational[1061, 4769], 0.22247850702453345`]], AbsoluteThickness[0.25], 
     LineBox[{3183, 3184}]}, 
    {Hue[
      NCache[
       Rational[3184, 14307], 0.22254840287970923`]], AbsoluteThickness[0.25],
      LineBox[{3184, 3185}]}, 
    {Hue[
      NCache[
       Rational[3185, 14307], 0.22261829873488503`]], AbsoluteThickness[0.25],
      LineBox[{3185, 3186}]}, 
    {Hue[
      NCache[
       Rational[1062, 4769], 0.2226881945900608]], AbsoluteThickness[0.25], 
     LineBox[{3186, 3187}]}, 
    {Hue[
      NCache[
       Rational[3187, 14307], 0.2227580904452366]], AbsoluteThickness[0.25], 
     LineBox[{3187, 3188}]}, 
    {Hue[
      NCache[
       Rational[3188, 14307], 0.2228279863004124]], AbsoluteThickness[0.25], 
     LineBox[{3188, 3189}]}, 
    {Hue[
      NCache[
       Rational[1063, 4769], 0.22289788215558817`]], AbsoluteThickness[0.25], 
     LineBox[{3189, 3190}]}, 
    {Hue[
      NCache[
       Rational[3190, 14307], 0.22296777801076395`]], AbsoluteThickness[0.25],
      LineBox[{3190, 3191}]}, 
    {Hue[
      NCache[
       Rational[3191, 14307], 0.22303767386593976`]], AbsoluteThickness[0.25],
      LineBox[{3191, 3192}]}, 
    {Hue[
      NCache[
       Rational[56, 251], 0.22310756972111553`]], AbsoluteThickness[0.25], 
     LineBox[{3192, 3193}]}, 
    {Hue[
      NCache[
       Rational[3193, 14307], 0.22317746557629134`]], AbsoluteThickness[0.25],
      LineBox[{3193, 3194}]}, 
    {Hue[
      NCache[
       Rational[3194, 14307], 0.22324736143146712`]], AbsoluteThickness[0.25],
      LineBox[{3194, 3195}]}, 
    {Hue[
      NCache[
       Rational[1065, 4769], 0.2233172572866429]], AbsoluteThickness[0.25], 
     LineBox[{3195, 3196}]}, 
    {Hue[
      NCache[
       Rational[3196, 14307], 0.2233871531418187]], AbsoluteThickness[0.25], 
     LineBox[{3196, 3197}]}, 
    {Hue[
      NCache[
       Rational[3197, 14307], 0.22345704899699448`]], AbsoluteThickness[0.25],
      LineBox[{3197, 3198}]}, 
    {Hue[
      NCache[
       Rational[1066, 4769], 0.22352694485217026`]], AbsoluteThickness[0.25], 
     LineBox[{3198, 3199}]}, 
    {Hue[
      NCache[
       Rational[3199, 14307], 0.22359684070734606`]], AbsoluteThickness[0.25],
      LineBox[{3199, 3200}]}, 
    {Hue[
      NCache[
       Rational[3200, 14307], 0.22366673656252184`]], AbsoluteThickness[0.25],
      LineBox[{3200, 3201}]}, 
    {Hue[
      NCache[
       Rational[1067, 4769], 0.22373663241769762`]], AbsoluteThickness[0.25], 
     LineBox[{3201, 3202}]}, 
    {Hue[
      NCache[
       Rational[3202, 14307], 0.22380652827287342`]], AbsoluteThickness[0.25],
      LineBox[{3202, 3203}]}, 
    {Hue[
      NCache[
       Rational[3203, 14307], 0.2238764241280492]], AbsoluteThickness[0.25], 
     LineBox[{3203, 3204}]}, 
    {Hue[
      NCache[
       Rational[1068, 4769], 0.223946319983225]], AbsoluteThickness[0.25], 
     LineBox[{3204, 3205}]}, 
    {Hue[
      NCache[
       Rational[3205, 14307], 0.22401621583840078`]], AbsoluteThickness[0.25],
      LineBox[{3205, 3206}]}, 
    {Hue[
      NCache[
       Rational[3206, 14307], 0.22408611169357656`]], AbsoluteThickness[0.25],
      LineBox[{3206, 3207}]}, 
    {Hue[
      NCache[
       Rational[1069, 4769], 0.22415600754875237`]], AbsoluteThickness[0.25], 
     LineBox[{3207, 3208}]}, 
    {Hue[
      NCache[
       Rational[3208, 14307], 0.22422590340392815`]], AbsoluteThickness[0.25],
      LineBox[{3208, 3209}]}, 
    {Hue[
      NCache[
       Rational[3209, 14307], 0.22429579925910392`]], AbsoluteThickness[0.25],
      LineBox[{3209, 3210}]}, 
    {Hue[
      NCache[
       Rational[1070, 4769], 0.22436569511427973`]], AbsoluteThickness[0.25], 
     LineBox[{3210, 3211}]}, 
    {Hue[
      NCache[
       Rational[169, 753], 0.2244355909694555]], AbsoluteThickness[0.25], 
     LineBox[{3211, 3212}]}, 
    {Hue[
      NCache[
       Rational[3212, 14307], 0.2245054868246313]], AbsoluteThickness[0.25], 
     LineBox[{3212, 3213}]}, 
    {Hue[
      NCache[
       Rational[1071, 4769], 0.2245753826798071]], AbsoluteThickness[0.25], 
     LineBox[{3213, 3214}]}, 
    {Hue[
      NCache[
       Rational[3214, 14307], 0.22464527853498287`]], AbsoluteThickness[0.25],
      LineBox[{3214, 3215}]}, 
    {Hue[
      NCache[
       Rational[3215, 14307], 0.22471517439015867`]], AbsoluteThickness[0.25],
      LineBox[{3215, 3216}]}, 
    {Hue[
      NCache[
       Rational[1072, 4769], 0.22478507024533445`]], AbsoluteThickness[0.25], 
     LineBox[{3216, 3217}]}, 
    {Hue[
      NCache[
       Rational[3217, 14307], 0.22485496610051023`]], AbsoluteThickness[0.25],
      LineBox[{3217, 3218}]}, 
    {Hue[
      NCache[
       Rational[3218, 14307], 0.22492486195568603`]], AbsoluteThickness[0.25],
      LineBox[{3218, 3219}]}, 
    {Hue[
      NCache[
       Rational[1073, 4769], 0.2249947578108618]], AbsoluteThickness[0.25], 
     LineBox[{3219, 3220}]}, 
    {Hue[
      NCache[
       Rational[3220, 14307], 0.22506465366603762`]], AbsoluteThickness[0.25],
      LineBox[{3220, 3221}]}, 
    {Hue[
      NCache[
       Rational[3221, 14307], 0.2251345495212134]], AbsoluteThickness[0.25], 
     LineBox[{3221, 3222}]}, 
    {Hue[
      NCache[
       Rational[1074, 4769], 0.22520444537638917`]], AbsoluteThickness[0.25], 
     LineBox[{3222, 3223}]}, 
    {Hue[
      NCache[
       Rational[3223, 14307], 0.22527434123156498`]], AbsoluteThickness[0.25],
      LineBox[{3223, 3224}]}, 
    {Hue[
      NCache[
       Rational[3224, 14307], 0.22534423708674076`]], AbsoluteThickness[0.25],
      LineBox[{3224, 3225}]}, 
    {Hue[
      NCache[
       Rational[1075, 4769], 0.22541413294191653`]], AbsoluteThickness[0.25], 
     LineBox[{3225, 3226}]}, 
    {Hue[
      NCache[
       Rational[3226, 14307], 0.22548402879709234`]], AbsoluteThickness[0.25],
      LineBox[{3226, 3227}]}, 
    {Hue[
      NCache[
       Rational[3227, 14307], 0.22555392465226812`]], AbsoluteThickness[0.25],
      LineBox[{3227, 3228}]}, 
    {Hue[
      NCache[
       Rational[1076, 4769], 0.2256238205074439]], AbsoluteThickness[0.25], 
     LineBox[{3228, 3229}]}, 
    {Hue[
      NCache[
       Rational[3229, 14307], 0.2256937163626197]], AbsoluteThickness[0.25], 
     LineBox[{3229, 3230}]}, 
    {Hue[
      NCache[
       Rational[170, 753], 0.22576361221779548`]], AbsoluteThickness[0.25], 
     LineBox[{3230, 3231}]}, 
    {Hue[
      NCache[
       Rational[1077, 4769], 0.22583350807297128`]], AbsoluteThickness[0.25], 
     LineBox[{3231, 3232}]}, 
    {Hue[
      NCache[
       Rational[3232, 14307], 0.22590340392814706`]], AbsoluteThickness[0.25],
      LineBox[{3232, 3233}]}, 
    {Hue[
      NCache[
       Rational[3233, 14307], 0.22597329978332284`]], AbsoluteThickness[0.25],
      LineBox[{3233, 3234}]}, 
    {Hue[
      NCache[
       Rational[1078, 4769], 0.22604319563849865`]], AbsoluteThickness[0.25], 
     LineBox[{3234, 3235}]}, 
    {Hue[
      NCache[
       Rational[3235, 14307], 0.22611309149367442`]], AbsoluteThickness[0.25],
      LineBox[{3235, 3236}]}, 
    {Hue[
      NCache[
       Rational[3236, 14307], 0.2261829873488502]], AbsoluteThickness[0.25], 
     LineBox[{3236, 3237}]}, 
    {Hue[
      NCache[
       Rational[1079, 4769], 0.226252883204026]], AbsoluteThickness[0.25], 
     LineBox[{3237, 3238}]}, 
    {Hue[
      NCache[
       Rational[3238, 14307], 0.22632277905920178`]], AbsoluteThickness[0.25],
      LineBox[{3238, 3239}]}, 
    {Hue[
      NCache[
       Rational[3239, 14307], 0.2263926749143776]], AbsoluteThickness[0.25], 
     LineBox[{3239, 3240}]}, 
    {Hue[
      NCache[
       Rational[1080, 4769], 0.22646257076955337`]], AbsoluteThickness[0.25], 
     LineBox[{3240, 3241}]}, 
    {Hue[
      NCache[
       Rational[3241, 14307], 0.22653246662472915`]], AbsoluteThickness[0.25],
      LineBox[{3241, 3242}]}, 
    {Hue[
      NCache[
       Rational[3242, 14307], 0.22660236247990495`]], AbsoluteThickness[0.25],
      LineBox[{3242, 3243}]}, 
    {Hue[
      NCache[
       Rational[1081, 4769], 0.22667225833508073`]], AbsoluteThickness[0.25], 
     LineBox[{3243, 3244}]}, 
    {Hue[
      NCache[
       Rational[3244, 14307], 0.2267421541902565]], AbsoluteThickness[0.25], 
     LineBox[{3244, 3245}]}, 
    {Hue[
      NCache[
       Rational[3245, 14307], 0.2268120500454323]], AbsoluteThickness[0.25], 
     LineBox[{3245, 3246}]}, 
    {Hue[
      NCache[
       Rational[1082, 4769], 0.2268819459006081]], AbsoluteThickness[0.25], 
     LineBox[{3246, 3247}]}, 
    {Hue[
      NCache[
       Rational[3247, 14307], 0.2269518417557839]], AbsoluteThickness[0.25], 
     LineBox[{3247, 3248}]}, 
    {Hue[
      NCache[
       Rational[3248, 14307], 0.22702173761095967`]], AbsoluteThickness[0.25],
      LineBox[{3248, 3249}]}, 
    {Hue[
      NCache[
       Rational[57, 251], 0.22709163346613545`]], AbsoluteThickness[0.25], 
     LineBox[{3249, 3250}]}, 
    {Hue[
      NCache[
       Rational[3250, 14307], 0.22716152932131126`]], AbsoluteThickness[0.25],
      LineBox[{3250, 3251}]}, 
    {Hue[
      NCache[
       Rational[3251, 14307], 0.22723142517648703`]], AbsoluteThickness[0.25],
      LineBox[{3251, 3252}]}, 
    {Hue[
      NCache[
       Rational[1084, 4769], 0.2273013210316628]], AbsoluteThickness[0.25], 
     LineBox[{3252, 3253}]}, 
    {Hue[
      NCache[
       Rational[3253, 14307], 0.22737121688683862`]], AbsoluteThickness[0.25],
      LineBox[{3253, 3254}]}, 
    {Hue[
      NCache[
       Rational[3254, 14307], 0.2274411127420144]], AbsoluteThickness[0.25], 
     LineBox[{3254, 3255}]}, 
    {Hue[
      NCache[
       Rational[1085, 4769], 0.22751100859719017`]], AbsoluteThickness[0.25], 
     LineBox[{3255, 3256}]}, 
    {Hue[
      NCache[
       Rational[3256, 14307], 0.22758090445236598`]], AbsoluteThickness[0.25],
      LineBox[{3256, 3257}]}, 
    {Hue[
      NCache[
       Rational[3257, 14307], 0.22765080030754176`]], AbsoluteThickness[0.25],
      LineBox[{3257, 3258}]}, 
    {Hue[
      NCache[
       Rational[1086, 4769], 0.22772069616271756`]], AbsoluteThickness[0.25], 
     LineBox[{3258, 3259}]}, 
    {Hue[
      NCache[
       Rational[3259, 14307], 0.22779059201789334`]], AbsoluteThickness[0.25],
      LineBox[{3259, 3260}]}, 
    {Hue[
      NCache[
       Rational[3260, 14307], 0.22786048787306912`]], AbsoluteThickness[0.25],
      LineBox[{3260, 3261}]}, 
    {Hue[
      NCache[
       Rational[1087, 4769], 0.22793038372824492`]], AbsoluteThickness[0.25], 
     LineBox[{3261, 3262}]}, 
    {Hue[
      NCache[
       Rational[3262, 14307], 0.2280002795834207]], AbsoluteThickness[0.25], 
     LineBox[{3262, 3263}]}, 
    {Hue[
      NCache[
       Rational[13, 57], 0.22807017543859648`]], AbsoluteThickness[0.25], 
     LineBox[{3263, 3264}]}, 
    {Hue[
      NCache[
       Rational[1088, 4769], 0.22814007129377228`]], AbsoluteThickness[0.25], 
     LineBox[{3264, 3265}]}, 
    {Hue[
      NCache[
       Rational[3265, 14307], 0.22820996714894806`]], AbsoluteThickness[0.25],
      LineBox[{3265, 3266}]}, 
    {Hue[
      NCache[
       Rational[3266, 14307], 0.22827986300412387`]], AbsoluteThickness[0.25],
      LineBox[{3266, 3267}]}, 
    {Hue[
      NCache[
       Rational[1089, 4769], 0.22834975885929965`]], AbsoluteThickness[0.25], 
     LineBox[{3267, 3268}]}, 
    {Hue[
      NCache[
       Rational[172, 753], 0.22841965471447542`]], AbsoluteThickness[0.25], 
     LineBox[{3268, 3269}]}, 
    {Hue[
      NCache[
       Rational[3269, 14307], 0.22848955056965123`]], AbsoluteThickness[0.25],
      LineBox[{3269, 3270}]}, 
    {Hue[
      NCache[
       Rational[1090, 4769], 0.228559446424827]], AbsoluteThickness[0.25], 
     LineBox[{3270, 3271}]}, 
    {Hue[
      NCache[
       Rational[3271, 14307], 0.22862934228000278`]], AbsoluteThickness[0.25],
      LineBox[{3271, 3272}]}, 
    {Hue[
      NCache[
       Rational[3272, 14307], 0.2286992381351786]], AbsoluteThickness[0.25], 
     LineBox[{3272, 3273}]}, 
    {Hue[
      NCache[
       Rational[1091, 4769], 0.22876913399035437`]], AbsoluteThickness[0.25], 
     LineBox[{3273, 3274}]}, 
    {Hue[
      NCache[
       Rational[3274, 14307], 0.22883902984553017`]], AbsoluteThickness[0.25],
      LineBox[{3274, 3275}]}, 
    {Hue[
      NCache[
       Rational[3275, 14307], 0.22890892570070595`]], AbsoluteThickness[0.25],
      LineBox[{3275, 3276}]}, 
    {Hue[
      NCache[
       Rational[1092, 4769], 0.22897882155588173`]], AbsoluteThickness[0.25], 
     LineBox[{3276, 3277}]}, 
    {Hue[
      NCache[
       Rational[3277, 14307], 0.22904871741105753`]], AbsoluteThickness[0.25],
      LineBox[{3277, 3278}]}, 
    {Hue[
      NCache[
       Rational[3278, 14307], 0.2291186132662333]], AbsoluteThickness[0.25], 
     LineBox[{3278, 3279}]}, 
    {Hue[
      NCache[
       Rational[1093, 4769], 0.2291885091214091]], AbsoluteThickness[0.25], 
     LineBox[{3279, 3280}]}, 
    {Hue[
      NCache[
       Rational[3280, 14307], 0.2292584049765849]], AbsoluteThickness[0.25], 
     LineBox[{3280, 3281}]}, 
    {Hue[
      NCache[
       Rational[3281, 14307], 0.22932830083176067`]], AbsoluteThickness[0.25],
      LineBox[{3281, 3282}]}, 
    {Hue[
      NCache[
       Rational[1094, 4769], 0.22939819668693645`]], AbsoluteThickness[0.25], 
     LineBox[{3282, 3283}]}, 
    {Hue[
      NCache[
       Rational[3283, 14307], 0.22946809254211226`]], AbsoluteThickness[0.25],
      LineBox[{3283, 3284}]}, 
    {Hue[
      NCache[
       Rational[3284, 14307], 0.22953798839728803`]], AbsoluteThickness[0.25],
      LineBox[{3284, 3285}]}, 
    {Hue[
      NCache[
       Rational[1095, 4769], 0.22960788425246384`]], AbsoluteThickness[0.25], 
     LineBox[{3285, 3286}]}, 
    {Hue[
      NCache[
       Rational[3286, 14307], 0.22967778010763962`]], AbsoluteThickness[0.25],
      LineBox[{3286, 3287}]}, 
    {Hue[
      NCache[
       Rational[173, 753], 0.2297476759628154]], AbsoluteThickness[0.25], 
     LineBox[{3287, 3288}]}, 
    {Hue[
      NCache[
       Rational[1096, 4769], 0.2298175718179912]], AbsoluteThickness[0.25], 
     LineBox[{3288, 3289}]}, 
    {Hue[
      NCache[
       Rational[3289, 14307], 0.22988746767316698`]], AbsoluteThickness[0.25],
      LineBox[{3289, 3290}]}, 
    {Hue[
      NCache[
       Rational[3290, 14307], 0.22995736352834276`]], AbsoluteThickness[0.25],
      LineBox[{3290, 3291}]}, 
    {Hue[
      NCache[
       Rational[1097, 4769], 0.23002725938351856`]], AbsoluteThickness[0.25], 
     LineBox[{3291, 3292}]}, 
    {Hue[
      NCache[
       Rational[3292, 14307], 0.23009715523869434`]], AbsoluteThickness[0.25],
      LineBox[{3292, 3293}]}, 
    {Hue[
      NCache[
       Rational[3293, 14307], 0.23016705109387015`]], AbsoluteThickness[0.25],
      LineBox[{3293, 3294}]}, 
    {Hue[
      NCache[
       Rational[1098, 4769], 0.23023694694904592`]], AbsoluteThickness[0.25], 
     LineBox[{3294, 3295}]}, 
    {Hue[
      NCache[
       Rational[3295, 14307], 0.2303068428042217]], AbsoluteThickness[0.25], 
     LineBox[{3295, 3296}]}, 
    {Hue[
      NCache[
       Rational[3296, 14307], 0.2303767386593975]], AbsoluteThickness[0.25], 
     LineBox[{3296, 3297}]}, 
    {Hue[
      NCache[
       Rational[1099, 4769], 0.23044663451457328`]], AbsoluteThickness[0.25], 
     LineBox[{3297, 3298}]}, 
    {Hue[
      NCache[
       Rational[3298, 14307], 0.23051653036974906`]], AbsoluteThickness[0.25],
      LineBox[{3298, 3299}]}, 
    {Hue[
      NCache[
       Rational[3299, 14307], 0.23058642622492487`]], AbsoluteThickness[0.25],
      LineBox[{3299, 3300}]}, 
    {Hue[
      NCache[
       Rational[1100, 4769], 0.23065632208010065`]], AbsoluteThickness[0.25], 
     LineBox[{3300, 3301}]}, 
    {Hue[
      NCache[
       Rational[3301, 14307], 0.23072621793527645`]], AbsoluteThickness[0.25],
      LineBox[{3301, 3302}]}, 
    {Hue[
      NCache[
       Rational[3302, 14307], 0.23079611379045223`]], AbsoluteThickness[0.25],
      LineBox[{3302, 3303}]}, 
    {Hue[
      NCache[
       Rational[1101, 4769], 0.230866009645628]], AbsoluteThickness[0.25], 
     LineBox[{3303, 3304}]}, 
    {Hue[
      NCache[
       Rational[3304, 14307], 0.2309359055008038]], AbsoluteThickness[0.25], 
     LineBox[{3304, 3305}]}, 
    {Hue[
      NCache[
       Rational[3305, 14307], 0.2310058013559796]], AbsoluteThickness[0.25], 
     LineBox[{3305, 3306}]}, 
    {Hue[
      NCache[
       Rational[58, 251], 0.23107569721115537`]], AbsoluteThickness[0.25], 
     LineBox[{3306, 3307}]}, 
    {Hue[
      NCache[
       Rational[3307, 14307], 0.23114559306633117`]], AbsoluteThickness[0.25],
      LineBox[{3307, 3308}]}, 
    {Hue[
      NCache[
       Rational[3308, 14307], 0.23121548892150695`]], AbsoluteThickness[0.25],
      LineBox[{3308, 3309}]}, 
    {Hue[
      NCache[
       Rational[1103, 4769], 0.23128538477668276`]], AbsoluteThickness[0.25], 
     LineBox[{3309, 3310}]}, 
    {Hue[
      NCache[
       Rational[3310, 14307], 0.23135528063185853`]], AbsoluteThickness[0.25],
      LineBox[{3310, 3311}]}, 
    {Hue[
      NCache[
       Rational[3311, 14307], 0.2314251764870343]], AbsoluteThickness[0.25], 
     LineBox[{3311, 3312}]}, 
    {Hue[
      NCache[
       Rational[1104, 4769], 0.23149507234221012`]], AbsoluteThickness[0.25], 
     LineBox[{3312, 3313}]}, 
    {Hue[
      NCache[
       Rational[3313, 14307], 0.2315649681973859]], AbsoluteThickness[0.25], 
     LineBox[{3313, 3314}]}, 
    {Hue[
      NCache[
       Rational[3314, 14307], 0.23163486405256167`]], AbsoluteThickness[0.25],
      LineBox[{3314, 3315}]}, 
    {Hue[
      NCache[
       Rational[1105, 4769], 0.23170475990773748`]], AbsoluteThickness[0.25], 
     LineBox[{3315, 3316}]}, 
    {Hue[
      NCache[
       Rational[3316, 14307], 0.23177465576291326`]], AbsoluteThickness[0.25],
      LineBox[{3316, 3317}]}, 
    {Hue[
      NCache[
       Rational[3317, 14307], 0.23184455161808903`]], AbsoluteThickness[0.25],
      LineBox[{3317, 3318}]}, 
    {Hue[
      NCache[
       Rational[1106, 4769], 0.23191444747326484`]], AbsoluteThickness[0.25], 
     LineBox[{3318, 3319}]}, 
    {Hue[
      NCache[
       Rational[3319, 14307], 0.23198434332844062`]], AbsoluteThickness[0.25],
      LineBox[{3319, 3320}]}, 
    {Hue[
      NCache[
       Rational[3320, 14307], 0.23205423918361642`]], AbsoluteThickness[0.25],
      LineBox[{3320, 3321}]}, 
    {Hue[
      NCache[
       Rational[1107, 4769], 0.2321241350387922]], AbsoluteThickness[0.25], 
     LineBox[{3321, 3322}]}, 
    {Hue[
      NCache[
       Rational[3322, 14307], 0.23219403089396798`]], AbsoluteThickness[0.25],
      LineBox[{3322, 3323}]}, 
    {Hue[
      NCache[
       Rational[3323, 14307], 0.23226392674914378`]], AbsoluteThickness[0.25],
      LineBox[{3323, 3324}]}, 
    {Hue[
      NCache[
       Rational[1108, 4769], 0.23233382260431956`]], AbsoluteThickness[0.25], 
     LineBox[{3324, 3325}]}, 
    {Hue[
      NCache[
       Rational[175, 753], 0.23240371845949534`]], AbsoluteThickness[0.25], 
     LineBox[{3325, 3326}]}, 
    {Hue[
      NCache[
       Rational[3326, 14307], 0.23247361431467115`]], AbsoluteThickness[0.25],
      LineBox[{3326, 3327}]}, 
    {Hue[
      NCache[
       Rational[1109, 4769], 0.23254351016984692`]], AbsoluteThickness[0.25], 
     LineBox[{3327, 3328}]}, 
    {Hue[
      NCache[
       Rational[3328, 14307], 0.23261340602502273`]], AbsoluteThickness[0.25],
      LineBox[{3328, 3329}]}, 
    {Hue[
      NCache[
       Rational[3329, 14307], 0.2326833018801985]], AbsoluteThickness[0.25], 
     LineBox[{3329, 3330}]}, 
    {Hue[
      NCache[
       Rational[1110, 4769], 0.23275319773537428`]], AbsoluteThickness[0.25], 
     LineBox[{3330, 3331}]}, 
    {Hue[
      NCache[
       Rational[3331, 14307], 0.2328230935905501]], AbsoluteThickness[0.25], 
     LineBox[{3331, 3332}]}, 
    {Hue[
      NCache[
       Rational[3332, 14307], 0.23289298944572587`]], AbsoluteThickness[0.25],
      LineBox[{3332, 3333}]}, 
    {Hue[
      NCache[
       Rational[1111, 4769], 0.23296288530090165`]], AbsoluteThickness[0.25], 
     LineBox[{3333, 3334}]}, 
    {Hue[
      NCache[
       Rational[3334, 14307], 0.23303278115607745`]], AbsoluteThickness[0.25],
      LineBox[{3334, 3335}]}, 
    {Hue[
      NCache[
       Rational[3335, 14307], 0.23310267701125323`]], AbsoluteThickness[0.25],
      LineBox[{3335, 3336}]}, 
    {Hue[
      NCache[
       Rational[1112, 4769], 0.23317257286642903`]], AbsoluteThickness[0.25], 
     LineBox[{3336, 3337}]}, 
    {Hue[
      NCache[
       Rational[3337, 14307], 0.2332424687216048]], AbsoluteThickness[0.25], 
     LineBox[{3337, 3338}]}, 
    {Hue[
      NCache[
       Rational[3338, 14307], 0.2333123645767806]], AbsoluteThickness[0.25], 
     LineBox[{3338, 3339}]}, 
    {Hue[
      NCache[
       Rational[1113, 4769], 0.2333822604319564]], AbsoluteThickness[0.25], 
     LineBox[{3339, 3340}]}, 
    {Hue[
      NCache[
       Rational[3340, 14307], 0.23345215628713217`]], AbsoluteThickness[0.25],
      LineBox[{3340, 3341}]}, 
    {Hue[
      NCache[
       Rational[3341, 14307], 0.23352205214230795`]], AbsoluteThickness[0.25],
      LineBox[{3341, 3342}]}, 
    {Hue[
      NCache[
       Rational[1114, 4769], 0.23359194799748376`]], AbsoluteThickness[0.25], 
     LineBox[{3342, 3343}]}, 
    {Hue[
      NCache[
       Rational[3343, 14307], 0.23366184385265953`]], AbsoluteThickness[0.25],
      LineBox[{3343, 3344}]}, 
    {Hue[
      NCache[
       Rational[176, 753], 0.2337317397078353]], AbsoluteThickness[0.25], 
     LineBox[{3344, 3345}]}, 
    {Hue[
      NCache[
       Rational[1115, 4769], 0.23380163556301112`]], AbsoluteThickness[0.25], 
     LineBox[{3345, 3346}]}, 
    {Hue[
      NCache[
       Rational[3346, 14307], 0.2338715314181869]], AbsoluteThickness[0.25], 
     LineBox[{3346, 3347}]}, 
    {Hue[
      NCache[
       Rational[3347, 14307], 0.2339414272733627]], AbsoluteThickness[0.25], 
     LineBox[{3347, 3348}]}, 
    {Hue[
      NCache[
       Rational[1116, 4769], 0.23401132312853848`]], AbsoluteThickness[0.25], 
     LineBox[{3348, 3349}]}, 
    {Hue[
      NCache[
       Rational[3349, 14307], 0.23408121898371426`]], AbsoluteThickness[0.25],
      LineBox[{3349, 3350}]}, 
    {Hue[
      NCache[
       Rational[3350, 14307], 0.23415111483889006`]], AbsoluteThickness[0.25],
      LineBox[{3350, 3351}]}, 
    {Hue[
      NCache[
       Rational[1117, 4769], 0.23422101069406584`]], AbsoluteThickness[0.25], 
     LineBox[{3351, 3352}]}, 
    {Hue[
      NCache[
       Rational[3352, 14307], 0.23429090654924162`]], AbsoluteThickness[0.25],
      LineBox[{3352, 3353}]}, 
    {Hue[
      NCache[
       Rational[3353, 14307], 0.23436080240441742`]], AbsoluteThickness[0.25],
      LineBox[{3353, 3354}]}, 
    {Hue[
      NCache[
       Rational[1118, 4769], 0.2344306982595932]], AbsoluteThickness[0.25], 
     LineBox[{3354, 3355}]}, 
    {Hue[
      NCache[
       Rational[3355, 14307], 0.234500594114769]], AbsoluteThickness[0.25], 
     LineBox[{3355, 3356}]}, 
    {Hue[
      NCache[
       Rational[3356, 14307], 0.23457048996994478`]], AbsoluteThickness[0.25],
      LineBox[{3356, 3357}]}, 
    {Hue[
      NCache[
       Rational[1119, 4769], 0.23464038582512056`]], AbsoluteThickness[0.25], 
     LineBox[{3357, 3358}]}, 
    {Hue[
      NCache[
       Rational[3358, 14307], 0.23471028168029637`]], AbsoluteThickness[0.25],
      LineBox[{3358, 3359}]}, 
    {Hue[
      NCache[
       Rational[3359, 14307], 0.23478017753547215`]], AbsoluteThickness[0.25],
      LineBox[{3359, 3360}]}, 
    {Hue[
      NCache[
       Rational[1120, 4769], 0.23485007339064792`]], AbsoluteThickness[0.25], 
     LineBox[{3360, 3361}]}, 
    {Hue[
      NCache[
       Rational[3361, 14307], 0.23491996924582373`]], AbsoluteThickness[0.25],
      LineBox[{3361, 3362}]}, 
    {Hue[
      NCache[
       Rational[3362, 14307], 0.2349898651009995]], AbsoluteThickness[0.25], 
     LineBox[{3362, 3363}]}, 
    {Hue[
      NCache[
       Rational[59, 251], 0.2350597609561753]], AbsoluteThickness[0.25], 
     LineBox[{3363, 3364}]}, 
    {Hue[
      NCache[
       Rational[3364, 14307], 0.2351296568113511]], AbsoluteThickness[0.25], 
     LineBox[{3364, 3365}]}, 
    {Hue[
      NCache[
       Rational[3365, 14307], 0.23519955266652687`]], AbsoluteThickness[0.25],
      LineBox[{3365, 3366}]}, 
    {Hue[
      NCache[
       Rational[1122, 4769], 0.23526944852170267`]], AbsoluteThickness[0.25], 
     LineBox[{3366, 3367}]}, 
    {Hue[
      NCache[
       Rational[3367, 14307], 0.23533934437687845`]], AbsoluteThickness[0.25],
      LineBox[{3367, 3368}]}, 
    {Hue[
      NCache[
       Rational[3368, 14307], 0.23540924023205423`]], AbsoluteThickness[0.25],
      LineBox[{3368, 3369}]}, 
    {Hue[
      NCache[
       Rational[1123, 4769], 0.23547913608723003`]], AbsoluteThickness[0.25], 
     LineBox[{3369, 3370}]}, 
    {Hue[
      NCache[
       Rational[3370, 14307], 0.2355490319424058]], AbsoluteThickness[0.25], 
     LineBox[{3370, 3371}]}, 
    {Hue[
      NCache[
       Rational[3371, 14307], 0.2356189277975816]], AbsoluteThickness[0.25], 
     LineBox[{3371, 3372}]}, 
    {Hue[
      NCache[
       Rational[1124, 4769], 0.2356888236527574]], AbsoluteThickness[0.25], 
     LineBox[{3372, 3373}]}, 
    {Hue[
      NCache[
       Rational[3373, 14307], 0.23575871950793317`]], AbsoluteThickness[0.25],
      LineBox[{3373, 3374}]}, 
    {Hue[
      NCache[
       Rational[3374, 14307], 0.23582861536310898`]], AbsoluteThickness[0.25],
      LineBox[{3374, 3375}]}, 
    {Hue[
      NCache[
       Rational[1125, 4769], 0.23589851121828476`]], AbsoluteThickness[0.25], 
     LineBox[{3375, 3376}]}, 
    {Hue[
      NCache[
       Rational[3376, 14307], 0.23596840707346053`]], AbsoluteThickness[0.25],
      LineBox[{3376, 3377}]}, 
    {Hue[
      NCache[
       Rational[3377, 14307], 0.23603830292863634`]], AbsoluteThickness[0.25],
      LineBox[{3377, 3378}]}, 
    {Hue[
      NCache[
       Rational[1126, 4769], 0.23610819878381212`]], AbsoluteThickness[0.25], 
     LineBox[{3378, 3379}]}, 
    {Hue[
      NCache[
       Rational[3379, 14307], 0.2361780946389879]], AbsoluteThickness[0.25], 
     LineBox[{3379, 3380}]}, 
    {Hue[
      NCache[
       Rational[3380, 14307], 0.2362479904941637]], AbsoluteThickness[0.25], 
     LineBox[{3380, 3381}]}, 
    {Hue[
      NCache[
       Rational[1127, 4769], 0.23631788634933948`]], AbsoluteThickness[0.25], 
     LineBox[{3381, 3382}]}, 
    {Hue[
      NCache[
       Rational[178, 753], 0.23638778220451528`]], AbsoluteThickness[0.25], 
     LineBox[{3382, 3383}]}, 
    {Hue[
      NCache[
       Rational[3383, 14307], 0.23645767805969106`]], AbsoluteThickness[0.25],
      LineBox[{3383, 3384}]}, 
    {Hue[
      NCache[
       Rational[1128, 4769], 0.23652757391486684`]], AbsoluteThickness[0.25], 
     LineBox[{3384, 3385}]}, 
    {Hue[
      NCache[
       Rational[3385, 14307], 0.23659746977004265`]], AbsoluteThickness[0.25],
      LineBox[{3385, 3386}]}, 
    {Hue[
      NCache[
       Rational[3386, 14307], 0.23666736562521842`]], AbsoluteThickness[0.25],
      LineBox[{3386, 3387}]}, 
    {Hue[
      NCache[
       Rational[1129, 4769], 0.2367372614803942]], AbsoluteThickness[0.25], 
     LineBox[{3387, 3388}]}, 
    {Hue[
      NCache[
       Rational[3388, 14307], 0.23680715733557]], AbsoluteThickness[0.25], 
     LineBox[{3388, 3389}]}, 
    {Hue[
      NCache[
       Rational[3389, 14307], 0.23687705319074578`]], AbsoluteThickness[0.25],
      LineBox[{3389, 3390}]}, 
    {Hue[
      NCache[
       Rational[1130, 4769], 0.2369469490459216]], AbsoluteThickness[0.25], 
     LineBox[{3390, 3391}]}, 
    {Hue[
      NCache[
       Rational[3391, 14307], 0.23701684490109737`]], AbsoluteThickness[0.25],
      LineBox[{3391, 3392}]}, 
    {Hue[
      NCache[
       Rational[3392, 14307], 0.23708674075627315`]], AbsoluteThickness[0.25],
      LineBox[{3392, 3393}]}, 
    {Hue[
      NCache[
       Rational[1131, 4769], 0.23715663661144895`]], AbsoluteThickness[0.25], 
     LineBox[{3393, 3394}]}, 
    {Hue[
      NCache[
       Rational[3394, 14307], 0.23722653246662473`]], AbsoluteThickness[0.25],
      LineBox[{3394, 3395}]}, 
    {Hue[
      NCache[
       Rational[3395, 14307], 0.2372964283218005]], AbsoluteThickness[0.25], 
     LineBox[{3395, 3396}]}, 
    {Hue[
      NCache[
       Rational[1132, 4769], 0.2373663241769763]], AbsoluteThickness[0.25], 
     LineBox[{3396, 3397}]}, 
    {Hue[
      NCache[
       Rational[3397, 14307], 0.2374362200321521]], AbsoluteThickness[0.25], 
     LineBox[{3397, 3398}]}, 
    {Hue[
      NCache[
       Rational[3398, 14307], 0.23750611588732787`]], AbsoluteThickness[0.25],
      LineBox[{3398, 3399}]}, 
    {Hue[
      NCache[
       Rational[1133, 4769], 0.23757601174250367`]], AbsoluteThickness[0.25], 
     LineBox[{3399, 3400}]}, 
    {Hue[
      NCache[
       Rational[3400, 14307], 0.23764590759767945`]], AbsoluteThickness[0.25],
      LineBox[{3400, 3401}]}, 
    {Hue[
      NCache[
       Rational[179, 753], 0.23771580345285526`]], AbsoluteThickness[0.25], 
     LineBox[{3401, 3402}]}, 
    {Hue[
      NCache[
       Rational[1134, 4769], 0.23778569930803103`]], AbsoluteThickness[0.25], 
     LineBox[{3402, 3403}]}, 
    {Hue[
      NCache[
       Rational[3403, 14307], 0.2378555951632068]], AbsoluteThickness[0.25], 
     LineBox[{3403, 3404}]}, 
    {Hue[
      NCache[
       Rational[3404, 14307], 0.23792549101838262`]], AbsoluteThickness[0.25],
      LineBox[{3404, 3405}]}, 
    {Hue[
      NCache[
       Rational[1135, 4769], 0.2379953868735584]], AbsoluteThickness[0.25], 
     LineBox[{3405, 3406}]}, 
    {Hue[
      NCache[
       Rational[3406, 14307], 0.23806528272873417`]], AbsoluteThickness[0.25],
      LineBox[{3406, 3407}]}, 
    {Hue[
      NCache[
       Rational[3407, 14307], 0.23813517858390998`]], AbsoluteThickness[0.25],
      LineBox[{3407, 3408}]}, 
    {Hue[
      NCache[
       Rational[1136, 4769], 0.23820507443908576`]], AbsoluteThickness[0.25], 
     LineBox[{3408, 3409}]}, 
    {Hue[
      NCache[
       Rational[3409, 14307], 0.23827497029426156`]], AbsoluteThickness[0.25],
      LineBox[{3409, 3410}]}, 
    {Hue[
      NCache[
       Rational[3410, 14307], 0.23834486614943734`]], AbsoluteThickness[0.25],
      LineBox[{3410, 3411}]}, 
    {Hue[
      NCache[
       Rational[1137, 4769], 0.23841476200461312`]], AbsoluteThickness[0.25], 
     LineBox[{3411, 3412}]}, 
    {Hue[
      NCache[
       Rational[3412, 14307], 0.23848465785978892`]], AbsoluteThickness[0.25],
      LineBox[{3412, 3413}]}, 
    {Hue[
      NCache[
       Rational[3413, 14307], 0.2385545537149647]], AbsoluteThickness[0.25], 
     LineBox[{3413, 3414}]}, 
    {Hue[
      NCache[
       Rational[1138, 4769], 0.23862444957014048`]], AbsoluteThickness[0.25], 
     LineBox[{3414, 3415}]}, 
    {Hue[
      NCache[
       Rational[3415, 14307], 0.23869434542531628`]], AbsoluteThickness[0.25],
      LineBox[{3415, 3416}]}, 
    {Hue[
      NCache[
       Rational[3416, 14307], 0.23876424128049206`]], AbsoluteThickness[0.25],
      LineBox[{3416, 3417}]}, 
    {Hue[
      NCache[
       Rational[1139, 4769], 0.23883413713566787`]], AbsoluteThickness[0.25], 
     LineBox[{3417, 3418}]}, 
    {Hue[
      NCache[
       Rational[3418, 14307], 0.23890403299084365`]], AbsoluteThickness[0.25],
      LineBox[{3418, 3419}]}, 
    {Hue[
      NCache[
       Rational[3419, 14307], 0.23897392884601942`]], AbsoluteThickness[0.25],
      LineBox[{3419, 3420}]}, 
    {Hue[
      NCache[
       Rational[60, 251], 0.23904382470119523`]], AbsoluteThickness[0.25], 
     LineBox[{3420, 3421}]}, 
    {Hue[
      NCache[
       Rational[3421, 14307], 0.239113720556371]], AbsoluteThickness[0.25], 
     LineBox[{3421, 3422}]}, 
    {Hue[
      NCache[
       Rational[3422, 14307], 0.23918361641154678`]], AbsoluteThickness[0.25],
      LineBox[{3422, 3423}]}, 
    {Hue[
      NCache[
       Rational[1141, 4769], 0.2392535122667226]], AbsoluteThickness[0.25], 
     LineBox[{3423, 3424}]}, 
    {Hue[
      NCache[
       Rational[3424, 14307], 0.23932340812189837`]], AbsoluteThickness[0.25],
      LineBox[{3424, 3425}]}, 
    {Hue[
      NCache[
       Rational[3425, 14307], 0.23939330397707417`]], AbsoluteThickness[0.25],
      LineBox[{3425, 3426}]}, 
    {Hue[
      NCache[
       Rational[1142, 4769], 0.23946319983224995`]], AbsoluteThickness[0.25], 
     LineBox[{3426, 3427}]}, 
    {Hue[
      NCache[
       Rational[3427, 14307], 0.23953309568742573`]], AbsoluteThickness[0.25],
      LineBox[{3427, 3428}]}, 
    {Hue[
      NCache[
       Rational[3428, 14307], 0.23960299154260153`]], AbsoluteThickness[0.25],
      LineBox[{3428, 3429}]}, 
    {Hue[
      NCache[
       Rational[1143, 4769], 0.2396728873977773]], AbsoluteThickness[0.25], 
     LineBox[{3429, 3430}]}, 
    {Hue[
      NCache[
       Rational[3430, 14307], 0.2397427832529531]], AbsoluteThickness[0.25], 
     LineBox[{3430, 3431}]}, 
    {Hue[
      NCache[
       Rational[3431, 14307], 0.2398126791081289]], AbsoluteThickness[0.25], 
     LineBox[{3431, 3432}]}, 
    {Hue[
      NCache[
       Rational[1144, 4769], 0.23988257496330467`]], AbsoluteThickness[0.25], 
     LineBox[{3432, 3433}]}, 
    {Hue[
      NCache[
       Rational[3433, 14307], 0.23995247081848045`]], AbsoluteThickness[0.25],
      LineBox[{3433, 3434}]}, 
    {Hue[
      NCache[
       Rational[3434, 14307], 0.24002236667365626`]], AbsoluteThickness[0.25],
      LineBox[{3434, 3435}]}, 
    {Hue[
      NCache[
       Rational[1145, 4769], 0.24009226252883203`]], AbsoluteThickness[0.25], 
     LineBox[{3435, 3436}]}, 
    {Hue[
      NCache[
       Rational[3436, 14307], 0.24016215838400784`]], AbsoluteThickness[0.25],
      LineBox[{3436, 3437}]}, 
    {Hue[
      NCache[
       Rational[3437, 14307], 0.24023205423918362`]], AbsoluteThickness[0.25],
      LineBox[{3437, 3438}]}, 
    {Hue[
      NCache[
       Rational[1146, 4769], 0.2403019500943594]], AbsoluteThickness[0.25], 
     LineBox[{3438, 3439}]}, 
    {Hue[
      NCache[
       Rational[181, 753], 0.2403718459495352]], AbsoluteThickness[0.25], 
     LineBox[{3439, 3440}]}, 
    {Hue[
      NCache[
       Rational[3440, 14307], 0.24044174180471098`]], AbsoluteThickness[0.25],
      LineBox[{3440, 3441}]}, 
    {Hue[
      NCache[
       Rational[1147, 4769], 0.24051163765988676`]], AbsoluteThickness[0.25], 
     LineBox[{3441, 3442}]}, 
    {Hue[
      NCache[
       Rational[3442, 14307], 0.24058153351506256`]], AbsoluteThickness[0.25],
      LineBox[{3442, 3443}]}, 
    {Hue[
      NCache[
       Rational[3443, 14307], 0.24065142937023834`]], AbsoluteThickness[0.25],
      LineBox[{3443, 3444}]}, 
    {Hue[
      NCache[
       Rational[1148, 4769], 0.24072132522541415`]], AbsoluteThickness[0.25], 
     LineBox[{3444, 3445}]}, 
    {Hue[
      NCache[
       Rational[3445, 14307], 0.24079122108058992`]], AbsoluteThickness[0.25],
      LineBox[{3445, 3446}]}, 
    {Hue[
      NCache[
       Rational[3446, 14307], 0.2408611169357657]], AbsoluteThickness[0.25], 
     LineBox[{3446, 3447}]}, 
    {Hue[
      NCache[
       Rational[1149, 4769], 0.2409310127909415]], AbsoluteThickness[0.25], 
     LineBox[{3447, 3448}]}, 
    {Hue[
      NCache[
       Rational[3448, 14307], 0.24100090864611728`]], AbsoluteThickness[0.25],
      LineBox[{3448, 3449}]}, 
    {Hue[
      NCache[
       Rational[3449, 14307], 0.24107080450129306`]], AbsoluteThickness[0.25],
      LineBox[{3449, 3450}]}, 
    {Hue[
      NCache[
       Rational[1150, 4769], 0.24114070035646887`]], AbsoluteThickness[0.25], 
     LineBox[{3450, 3451}]}, 
    {Hue[
      NCache[
       Rational[3451, 14307], 0.24121059621164465`]], AbsoluteThickness[0.25],
      LineBox[{3451, 3452}]}, 
    {Hue[
      NCache[
       Rational[3452, 14307], 0.24128049206682045`]], AbsoluteThickness[0.25],
      LineBox[{3452, 3453}]}, 
    {Hue[
      NCache[
       Rational[1151, 4769], 0.24135038792199623`]], AbsoluteThickness[0.25], 
     LineBox[{3453, 3454}]}, 
    {Hue[
      NCache[
       Rational[3454, 14307], 0.241420283777172]], AbsoluteThickness[0.25], 
     LineBox[{3454, 3455}]}, 
    {Hue[
      NCache[
       Rational[3455, 14307], 0.2414901796323478]], AbsoluteThickness[0.25], 
     LineBox[{3455, 3456}]}, 
    {Hue[
      NCache[
       Rational[1152, 4769], 0.2415600754875236]], AbsoluteThickness[0.25], 
     LineBox[{3456, 3457}]}, 
    {Hue[
      NCache[
       Rational[3457, 14307], 0.24162997134269937`]], AbsoluteThickness[0.25],
      LineBox[{3457, 3458}]}, 
    {Hue[
      NCache[
       Rational[182, 753], 0.24169986719787517`]], AbsoluteThickness[0.25], 
     LineBox[{3458, 3459}]}, 
    {Hue[
      NCache[
       Rational[1153, 4769], 0.24176976305305095`]], AbsoluteThickness[0.25], 
     LineBox[{3459, 3460}]}, 
    {Hue[
      NCache[
       Rational[3460, 14307], 0.24183965890822673`]], AbsoluteThickness[0.25],
      LineBox[{3460, 3461}]}, 
    {Hue[
      NCache[
       Rational[3461, 14307], 0.24190955476340253`]], AbsoluteThickness[0.25],
      LineBox[{3461, 3462}]}, 
    {Hue[
      NCache[
       Rational[1154, 4769], 0.2419794506185783]], AbsoluteThickness[0.25], 
     LineBox[{3462, 3463}]}, 
    {Hue[
      NCache[
       Rational[3463, 14307], 0.24204934647375412`]], AbsoluteThickness[0.25],
      LineBox[{3463, 3464}]}, 
    {Hue[
      NCache[
       Rational[3464, 14307], 0.2421192423289299]], AbsoluteThickness[0.25], 
     LineBox[{3464, 3465}]}, 
    {Hue[
      NCache[
       Rational[1155, 4769], 0.24218913818410567`]], AbsoluteThickness[0.25], 
     LineBox[{3465, 3466}]}, 
    {Hue[
      NCache[
       Rational[3466, 14307], 0.24225903403928148`]], AbsoluteThickness[0.25],
      LineBox[{3466, 3467}]}, 
    {Hue[
      NCache[
       Rational[3467, 14307], 0.24232892989445726`]], AbsoluteThickness[0.25],
      LineBox[{3467, 3468}]}, 
    {Hue[
      NCache[
       Rational[1156, 4769], 0.24239882574963303`]], AbsoluteThickness[0.25], 
     LineBox[{3468, 3469}]}, 
    {Hue[
      NCache[
       Rational[3469, 14307], 0.24246872160480884`]], AbsoluteThickness[0.25],
      LineBox[{3469, 3470}]}, 
    {Hue[
      NCache[
       Rational[3470, 14307], 0.24253861745998462`]], AbsoluteThickness[0.25],
      LineBox[{3470, 3471}]}, 
    {Hue[
      NCache[
       Rational[1157, 4769], 0.24260851331516042`]], AbsoluteThickness[0.25], 
     LineBox[{3471, 3472}]}, 
    {Hue[
      NCache[
       Rational[3472, 14307], 0.2426784091703362]], AbsoluteThickness[0.25], 
     LineBox[{3472, 3473}]}, 
    {Hue[
      NCache[
       Rational[3473, 14307], 0.24274830502551198`]], AbsoluteThickness[0.25],
      LineBox[{3473, 3474}]}, 
    {Hue[
      NCache[
       Rational[1158, 4769], 0.24281820088068778`]], AbsoluteThickness[0.25], 
     LineBox[{3474, 3475}]}, 
    {Hue[
      NCache[
       Rational[3475, 14307], 0.24288809673586356`]], AbsoluteThickness[0.25],
      LineBox[{3475, 3476}]}, 
    {Hue[
      NCache[
       Rational[3476, 14307], 0.24295799259103934`]], AbsoluteThickness[0.25],
      LineBox[{3476, 3477}]}, 
    {Hue[
      NCache[
       Rational[61, 251], 0.24302788844621515`]], AbsoluteThickness[0.25], 
     LineBox[{3477, 3478}]}, 
    {Hue[
      NCache[
       Rational[3478, 14307], 0.24309778430139092`]], AbsoluteThickness[0.25],
      LineBox[{3478, 3479}]}, 
    {Hue[
      NCache[
       Rational[3479, 14307], 0.24316768015656673`]], AbsoluteThickness[0.25],
      LineBox[{3479, 3480}]}, 
    {Hue[
      NCache[
       Rational[1160, 4769], 0.2432375760117425]], AbsoluteThickness[0.25], 
     LineBox[{3480, 3481}]}, 
    {Hue[
      NCache[
       Rational[3481, 14307], 0.24330747186691828`]], AbsoluteThickness[0.25],
      LineBox[{3481, 3482}]}, 
    {Hue[
      NCache[
       Rational[3482, 14307], 0.2433773677220941]], AbsoluteThickness[0.25], 
     LineBox[{3482, 3483}]}, 
    {Hue[
      NCache[
       Rational[1161, 4769], 0.24344726357726987`]], AbsoluteThickness[0.25], 
     LineBox[{3483, 3484}]}, 
    {Hue[
      NCache[
       Rational[3484, 14307], 0.24351715943244565`]], AbsoluteThickness[0.25],
      LineBox[{3484, 3485}]}, 
    {Hue[
      NCache[
       Rational[3485, 14307], 0.24358705528762145`]], AbsoluteThickness[0.25],
      LineBox[{3485, 3486}]}, 
    {Hue[
      NCache[
       Rational[1162, 4769], 0.24365695114279723`]], AbsoluteThickness[0.25], 
     LineBox[{3486, 3487}]}, 
    {Hue[
      NCache[
       Rational[3487, 14307], 0.243726846997973]], AbsoluteThickness[0.25], 
     LineBox[{3487, 3488}]}, 
    {Hue[
      NCache[
       Rational[3488, 14307], 0.2437967428531488]], AbsoluteThickness[0.25], 
     LineBox[{3488, 3489}]}, 
    {Hue[
      NCache[
       Rational[1163, 4769], 0.2438666387083246]], AbsoluteThickness[0.25], 
     LineBox[{3489, 3490}]}, 
    {Hue[
      NCache[
       Rational[3490, 14307], 0.2439365345635004]], AbsoluteThickness[0.25], 
     LineBox[{3490, 3491}]}, 
    {Hue[
      NCache[
       Rational[3491, 14307], 0.24400643041867617`]], AbsoluteThickness[0.25],
      LineBox[{3491, 3492}]}, 
    {Hue[
      NCache[
       Rational[1164, 4769], 0.24407632627385195`]], AbsoluteThickness[0.25], 
     LineBox[{3492, 3493}]}, 
    {Hue[
      NCache[
       Rational[3493, 14307], 0.24414622212902776`]], AbsoluteThickness[0.25],
      LineBox[{3493, 3494}]}, 
    {Hue[
      NCache[
       Rational[3494, 14307], 0.24421611798420353`]], AbsoluteThickness[0.25],
      LineBox[{3494, 3495}]}, 
    {Hue[
      NCache[
       Rational[1165, 4769], 0.2442860138393793]], AbsoluteThickness[0.25], 
     LineBox[{3495, 3496}]}, 
    {Hue[
      NCache[
       Rational[184, 753], 0.24435590969455512`]], AbsoluteThickness[0.25], 
     LineBox[{3496, 3497}]}, 
    {Hue[
      NCache[
       Rational[3497, 14307], 0.2444258055497309]], AbsoluteThickness[0.25], 
     LineBox[{3497, 3498}]}, 
    {Hue[
      NCache[
       Rational[1166, 4769], 0.2444957014049067]], AbsoluteThickness[0.25], 
     LineBox[{3498, 3499}]}, 
    {Hue[
      NCache[
       Rational[3499, 14307], 0.24456559726008248`]], AbsoluteThickness[0.25],
      LineBox[{3499, 3500}]}, 
    {Hue[
      NCache[
       Rational[3500, 14307], 0.24463549311525826`]], AbsoluteThickness[0.25],
      LineBox[{3500, 3501}]}, 
    {Hue[
      NCache[
       Rational[1167, 4769], 0.24470538897043406`]], AbsoluteThickness[0.25], 
     LineBox[{3501, 3502}]}, 
    {Hue[
      NCache[
       Rational[3502, 14307], 0.24477528482560984`]], AbsoluteThickness[0.25],
      LineBox[{3502, 3503}]}, 
    {Hue[
      NCache[
       Rational[3503, 14307], 0.24484518068078562`]], AbsoluteThickness[0.25],
      LineBox[{3503, 3504}]}, 
    {Hue[
      NCache[
       Rational[1168, 4769], 0.24491507653596142`]], AbsoluteThickness[0.25], 
     LineBox[{3504, 3505}]}, 
    {Hue[
      NCache[
       Rational[3505, 14307], 0.2449849723911372]], AbsoluteThickness[0.25], 
     LineBox[{3505, 3506}]}, 
    {Hue[
      NCache[
       Rational[3506, 14307], 0.245054868246313]], AbsoluteThickness[0.25], 
     LineBox[{3506, 3507}]}, 
    {Hue[
      NCache[
       Rational[1169, 4769], 0.24512476410148878`]], AbsoluteThickness[0.25], 
     LineBox[{3507, 3508}]}, 
    {Hue[
      NCache[
       Rational[3508, 14307], 0.24519465995666456`]], AbsoluteThickness[0.25],
      LineBox[{3508, 3509}]}, 
    {Hue[
      NCache[
       Rational[3509, 14307], 0.24526455581184037`]], AbsoluteThickness[0.25],
      LineBox[{3509, 3510}]}, 
    {Hue[
      NCache[
       Rational[1170, 4769], 0.24533445166701615`]], AbsoluteThickness[0.25], 
     LineBox[{3510, 3511}]}, 
    {Hue[
      NCache[
       Rational[3511, 14307], 0.24540434752219192`]], AbsoluteThickness[0.25],
      LineBox[{3511, 3512}]}, 
    {Hue[
      NCache[
       Rational[3512, 14307], 0.24547424337736773`]], AbsoluteThickness[0.25],
      LineBox[{3512, 3513}]}, 
    {Hue[
      NCache[
       Rational[1171, 4769], 0.2455441392325435]], AbsoluteThickness[0.25], 
     LineBox[{3513, 3514}]}, 
    {Hue[
      NCache[
       Rational[14, 57], 0.24561403508771928`]], AbsoluteThickness[0.25], 
     LineBox[{3514, 3515}]}, 
    {Hue[
      NCache[
       Rational[185, 753], 0.2456839309428951]], AbsoluteThickness[0.25], 
     LineBox[{3515, 3516}]}, 
    {Hue[
      NCache[
       Rational[1172, 4769], 0.24575382679807087`]], AbsoluteThickness[0.25], 
     LineBox[{3516, 3517}]}, 
    {Hue[
      NCache[
       Rational[3517, 14307], 0.24582372265324667`]], AbsoluteThickness[0.25],
      LineBox[{3517, 3518}]}, 
    {Hue[
      NCache[
       Rational[3518, 14307], 0.24589361850842245`]], AbsoluteThickness[0.25],
      LineBox[{3518, 3519}]}, 
    {Hue[
      NCache[
       Rational[1173, 4769], 0.24596351436359823`]], AbsoluteThickness[0.25], 
     LineBox[{3519, 3520}]}, 
    {Hue[
      NCache[
       Rational[3520, 14307], 0.24603341021877403`]], AbsoluteThickness[0.25],
      LineBox[{3520, 3521}]}, 
    {Hue[
      NCache[
       Rational[3521, 14307], 0.2461033060739498]], AbsoluteThickness[0.25], 
     LineBox[{3521, 3522}]}, 
    {Hue[
      NCache[
       Rational[1174, 4769], 0.2461732019291256]], AbsoluteThickness[0.25], 
     LineBox[{3522, 3523}]}, 
    {Hue[
      NCache[
       Rational[3523, 14307], 0.2462430977843014]], AbsoluteThickness[0.25], 
     LineBox[{3523, 3524}]}, 
    {Hue[
      NCache[
       Rational[3524, 14307], 0.24631299363947717`]], AbsoluteThickness[0.25],
      LineBox[{3524, 3525}]}, 
    {Hue[
      NCache[
       Rational[1175, 4769], 0.24638288949465298`]], AbsoluteThickness[0.25], 
     LineBox[{3525, 3526}]}, 
    {Hue[
      NCache[
       Rational[3526, 14307], 0.24645278534982876`]], AbsoluteThickness[0.25],
      LineBox[{3526, 3527}]}, 
    {Hue[
      NCache[
       Rational[3527, 14307], 0.24652268120500453`]], AbsoluteThickness[0.25],
      LineBox[{3527, 3528}]}, 
    {Hue[
      NCache[
       Rational[1176, 4769], 0.24659257706018034`]], AbsoluteThickness[0.25], 
     LineBox[{3528, 3529}]}, 
    {Hue[
      NCache[
       Rational[3529, 14307], 0.24666247291535612`]], AbsoluteThickness[0.25],
      LineBox[{3529, 3530}]}, 
    {Hue[
      NCache[
       Rational[3530, 14307], 0.2467323687705319]], AbsoluteThickness[0.25], 
     LineBox[{3530, 3531}]}, 
    {Hue[
      NCache[
       Rational[1177, 4769], 0.2468022646257077]], AbsoluteThickness[0.25], 
     LineBox[{3531, 3532}]}, 
    {Hue[
      NCache[
       Rational[3532, 14307], 0.24687216048088348`]], AbsoluteThickness[0.25],
      LineBox[{3532, 3533}]}, 
    {Hue[
      NCache[
       Rational[3533, 14307], 0.24694205633605928`]], AbsoluteThickness[0.25],
      LineBox[{3533, 3534}]}, 
    {Hue[
      NCache[
       Rational[62, 251], 0.24701195219123506`]], AbsoluteThickness[0.25], 
     LineBox[{3534, 3535}]}, 
    {Hue[
      NCache[
       Rational[3535, 14307], 0.24708184804641084`]], AbsoluteThickness[0.25],
      LineBox[{3535, 3536}]}, 
    {Hue[
      NCache[
       Rational[3536, 14307], 0.24715174390158665`]], AbsoluteThickness[0.25],
      LineBox[{3536, 3537}]}, 
    {Hue[
      NCache[
       Rational[1179, 4769], 0.24722163975676242`]], AbsoluteThickness[0.25], 
     LineBox[{3537, 3538}]}, 
    {Hue[
      NCache[
       Rational[3538, 14307], 0.2472915356119382]], AbsoluteThickness[0.25], 
     LineBox[{3538, 3539}]}, 
    {Hue[
      NCache[
       Rational[3539, 14307], 0.247361431467114]], AbsoluteThickness[0.25], 
     LineBox[{3539, 3540}]}, 
    {Hue[
      NCache[
       Rational[1180, 4769], 0.24743132732228978`]], AbsoluteThickness[0.25], 
     LineBox[{3540, 3541}]}, 
    {Hue[
      NCache[
       Rational[3541, 14307], 0.24750122317746556`]], AbsoluteThickness[0.25],
      LineBox[{3541, 3542}]}, 
    {Hue[
      NCache[
       Rational[3542, 14307], 0.24757111903264137`]], AbsoluteThickness[0.25],
      LineBox[{3542, 3543}]}, 
    {Hue[
      NCache[
       Rational[1181, 4769], 0.24764101488781715`]], AbsoluteThickness[0.25], 
     LineBox[{3543, 3544}]}, 
    {Hue[
      NCache[
       Rational[3544, 14307], 0.24771091074299295`]], AbsoluteThickness[0.25],
      LineBox[{3544, 3545}]}, 
    {Hue[
      NCache[
       Rational[3545, 14307], 0.24778080659816873`]], AbsoluteThickness[0.25],
      LineBox[{3545, 3546}]}, 
    {Hue[
      NCache[
       Rational[1182, 4769], 0.2478507024533445]], AbsoluteThickness[0.25], 
     LineBox[{3546, 3547}]}, 
    {Hue[
      NCache[
       Rational[3547, 14307], 0.2479205983085203]], AbsoluteThickness[0.25], 
     LineBox[{3547, 3548}]}, 
    {Hue[
      NCache[
       Rational[3548, 14307], 0.2479904941636961]], AbsoluteThickness[0.25], 
     LineBox[{3548, 3549}]}, 
    {Hue[
      NCache[
       Rational[1183, 4769], 0.24806039001887187`]], AbsoluteThickness[0.25], 
     LineBox[{3549, 3550}]}, 
    {Hue[
      NCache[
       Rational[3550, 14307], 0.24813028587404767`]], AbsoluteThickness[0.25],
      LineBox[{3550, 3551}]}, 
    {Hue[
      NCache[
       Rational[3551, 14307], 0.24820018172922345`]], AbsoluteThickness[0.25],
      LineBox[{3551, 3552}]}, 
    {Hue[
      NCache[
       Rational[1184, 4769], 0.24827007758439926`]], AbsoluteThickness[0.25], 
     LineBox[{3552, 3553}]}, 
    {Hue[
      NCache[
       Rational[187, 753], 0.24833997343957503`]], AbsoluteThickness[0.25], 
     LineBox[{3553, 3554}]}, 
    {Hue[
      NCache[
       Rational[3554, 14307], 0.2484098692947508]], AbsoluteThickness[0.25], 
     LineBox[{3554, 3555}]}, 
    {Hue[
      NCache[
       Rational[1185, 4769], 0.24847976514992662`]], AbsoluteThickness[0.25], 
     LineBox[{3555, 3556}]}, 
    {Hue[
      NCache[
       Rational[3556, 14307], 0.2485496610051024]], AbsoluteThickness[0.25], 
     LineBox[{3556, 3557}]}, 
    {Hue[
      NCache[
       Rational[3557, 14307], 0.24861955686027817`]], AbsoluteThickness[0.25],
      LineBox[{3557, 3558}]}, 
    {Hue[
      NCache[
       Rational[1186, 4769], 0.24868945271545398`]], AbsoluteThickness[0.25], 
     LineBox[{3558, 3559}]}, 
    {Hue[
      NCache[
       Rational[3559, 14307], 0.24875934857062976`]], AbsoluteThickness[0.25],
      LineBox[{3559, 3560}]}, 
    {Hue[
      NCache[
       Rational[3560, 14307], 0.24882924442580556`]], AbsoluteThickness[0.25],
      LineBox[{3560, 3561}]}, 
    {Hue[
      NCache[
       Rational[1187, 4769], 0.24889914028098134`]], AbsoluteThickness[0.25], 
     LineBox[{3561, 3562}]}, 
    {Hue[
      NCache[
       Rational[3562, 14307], 0.24896903613615712`]], AbsoluteThickness[0.25],
      LineBox[{3562, 3563}]}, 
    {Hue[
      NCache[
       Rational[3563, 14307], 0.24903893199133292`]], AbsoluteThickness[0.25],
      LineBox[{3563, 3564}]}, 
    {Hue[
      NCache[
       Rational[1188, 4769], 0.2491088278465087]], AbsoluteThickness[0.25], 
     LineBox[{3564, 3565}]}, 
    {Hue[
      NCache[
       Rational[3565, 14307], 0.24917872370168448`]], AbsoluteThickness[0.25],
      LineBox[{3565, 3566}]}, 
    {Hue[
      NCache[
       Rational[3566, 14307], 0.24924861955686028`]], AbsoluteThickness[0.25],
      LineBox[{3566, 3567}]}, 
    {Hue[
      NCache[
       Rational[1189, 4769], 0.24931851541203606`]], AbsoluteThickness[0.25], 
     LineBox[{3567, 3568}]}, 
    {Hue[
      NCache[
       Rational[3568, 14307], 0.24938841126721187`]], AbsoluteThickness[0.25],
      LineBox[{3568, 3569}]}, 
    {Hue[
      NCache[
       Rational[3569, 14307], 0.24945830712238765`]], AbsoluteThickness[0.25],
      LineBox[{3569, 3570}]}, 
    {Hue[
      NCache[
       Rational[1190, 4769], 0.24952820297756342`]], AbsoluteThickness[0.25], 
     LineBox[{3570, 3571}]}, 
    {Hue[
      NCache[
       Rational[3571, 14307], 0.24959809883273923`]], AbsoluteThickness[0.25],
      LineBox[{3571, 3572}]}, 
    {Hue[
      NCache[
       Rational[188, 753], 0.249667994687915]], AbsoluteThickness[0.25], 
     LineBox[{3572, 3573}]}, 
    {Hue[
      NCache[
       Rational[1191, 4769], 0.24973789054309078`]], AbsoluteThickness[0.25], 
     LineBox[{3573, 3574}]}, 
    {Hue[
      NCache[
       Rational[3574, 14307], 0.2498077863982666]], AbsoluteThickness[0.25], 
     LineBox[{3574, 3575}]}, 
    {Hue[
      NCache[
       Rational[3575, 14307], 0.24987768225344237`]], AbsoluteThickness[0.25],
      LineBox[{3575, 3576}]}, 
    {Hue[
      NCache[
       Rational[1192, 4769], 0.24994757810861815`]], AbsoluteThickness[0.25], 
     LineBox[{3576, 3577}]}, 
    {Hue[
      NCache[
       Rational[3577, 14307], 0.2500174739637939]], AbsoluteThickness[0.25], 
     LineBox[{3577, 3578}]}, 
    {Hue[
      NCache[
       Rational[3578, 14307], 0.25008736981896973`]], AbsoluteThickness[0.25],
      LineBox[{3578, 3579}]}, 
    {Hue[
      NCache[
       Rational[1193, 4769], 0.25015726567414553`]], AbsoluteThickness[0.25], 
     LineBox[{3579, 3580}]}, 
    {Hue[
      NCache[
       Rational[3580, 14307], 0.2502271615293213]], AbsoluteThickness[0.25], 
     LineBox[{3580, 3581}]}, 
    {Hue[
      NCache[
       Rational[3581, 14307], 0.2502970573844971]], AbsoluteThickness[0.25], 
     LineBox[{3581, 3582}]}, 
    {Hue[
      NCache[
       Rational[1194, 4769], 0.2503669532396729]], AbsoluteThickness[0.25], 
     LineBox[{3582, 3583}]}, 
    {Hue[
      NCache[
       Rational[3583, 14307], 0.2504368490948487]], AbsoluteThickness[0.25], 
     LineBox[{3583, 3584}]}, 
    {Hue[
      NCache[
       Rational[3584, 14307], 0.25050674495002445`]], AbsoluteThickness[0.25],
      LineBox[{3584, 3585}]}, 
    {Hue[
      NCache[
       Rational[1195, 4769], 0.25057664080520026`]], AbsoluteThickness[0.25], 
     LineBox[{3585, 3586}]}, 
    {Hue[
      NCache[
       Rational[3586, 14307], 0.25064653666037606`]], AbsoluteThickness[0.25],
      LineBox[{3586, 3587}]}, 
    {Hue[
      NCache[
       Rational[3587, 14307], 0.2507164325155518]], AbsoluteThickness[0.25], 
     LineBox[{3587, 3588}]}, 
    {Hue[
      NCache[
       Rational[1196, 4769], 0.2507863283707276]], AbsoluteThickness[0.25], 
     LineBox[{3588, 3589}]}, 
    {Hue[
      NCache[
       Rational[3589, 14307], 0.2508562242259034]], AbsoluteThickness[0.25], 
     LineBox[{3589, 3590}]}, 
    {Hue[
      NCache[
       Rational[3590, 14307], 0.2509261200810792]], AbsoluteThickness[0.25], 
     LineBox[{3590, 3591}]}, 
    {Hue[
      NCache[
       Rational[63, 251], 0.250996015936255]], AbsoluteThickness[0.25], 
     LineBox[{3591, 3592}]}, 
    {Hue[
      NCache[
       Rational[3592, 14307], 0.2510659117914308]], AbsoluteThickness[0.25], 
     LineBox[{3592, 3593}]}, 
    {Hue[
      NCache[
       Rational[3593, 14307], 0.25113580764660653`]], AbsoluteThickness[0.25],
      LineBox[{3593, 3594}]}, 
    {Hue[
      NCache[
       Rational[1198, 4769], 0.25120570350178234`]], AbsoluteThickness[0.25], 
     LineBox[{3594, 3595}]}, 
    {Hue[
      NCache[
       Rational[3595, 14307], 0.25127559935695815`]], AbsoluteThickness[0.25],
      LineBox[{3595, 3596}]}, 
    {Hue[
      NCache[
       Rational[3596, 14307], 0.2513454952121339]], AbsoluteThickness[0.25], 
     LineBox[{3596, 3597}]}, 
    {Hue[
      NCache[
       Rational[1199, 4769], 0.2514153910673097]], AbsoluteThickness[0.25], 
     LineBox[{3597, 3598}]}, 
    {Hue[
      NCache[
       Rational[3598, 14307], 0.2514852869224855]], AbsoluteThickness[0.25], 
     LineBox[{3598, 3599}]}, 
    {Hue[
      NCache[
       Rational[3599, 14307], 0.25155518277766126`]], AbsoluteThickness[0.25],
      LineBox[{3599, 3600}]}, 
    {Hue[
      NCache[
       Rational[1200, 4769], 0.25162507863283706`]], AbsoluteThickness[0.25], 
     LineBox[{3600, 3601}]}, 
    {Hue[
      NCache[
       Rational[3601, 14307], 0.25169497448801287`]], AbsoluteThickness[0.25],
      LineBox[{3601, 3602}]}, 
    {Hue[
      NCache[
       Rational[3602, 14307], 0.2517648703431887]], AbsoluteThickness[0.25], 
     LineBox[{3602, 3603}]}, 
    {Hue[
      NCache[
       Rational[1201, 4769], 0.2518347661983644]], AbsoluteThickness[0.25], 
     LineBox[{3603, 3604}]}, 
    {Hue[
      NCache[
       Rational[3604, 14307], 0.25190466205354023`]], AbsoluteThickness[0.25],
      LineBox[{3604, 3605}]}, 
    {Hue[
      NCache[
       Rational[3605, 14307], 0.25197455790871603`]], AbsoluteThickness[0.25],
      LineBox[{3605, 3606}]}, 
    {Hue[
      NCache[
       Rational[1202, 4769], 0.2520444537638918]], AbsoluteThickness[0.25], 
     LineBox[{3606, 3607}]}, 
    {Hue[
      NCache[
       Rational[3607, 14307], 0.2521143496190676]], AbsoluteThickness[0.25], 
     LineBox[{3607, 3608}]}, 
    {Hue[
      NCache[
       Rational[3608, 14307], 0.2521842454742434]], AbsoluteThickness[0.25], 
     LineBox[{3608, 3609}]}, 
    {Hue[
      NCache[
       Rational[1203, 4769], 0.25225414132941915`]], AbsoluteThickness[0.25], 
     LineBox[{3609, 3610}]}, 
    {Hue[
      NCache[
       Rational[190, 753], 0.25232403718459495`]], AbsoluteThickness[0.25], 
     LineBox[{3610, 3611}]}, 
    {Hue[
      NCache[
       Rational[3611, 14307], 0.25239393303977076`]], AbsoluteThickness[0.25],
      LineBox[{3611, 3612}]}, 
    {Hue[
      NCache[
       Rational[1204, 4769], 0.2524638288949465]], AbsoluteThickness[0.25], 
     LineBox[{3612, 3613}]}, 
    {Hue[
      NCache[
       Rational[3613, 14307], 0.2525337247501223]], AbsoluteThickness[0.25], 
     LineBox[{3613, 3614}]}, 
    {Hue[
      NCache[
       Rational[3614, 14307], 0.2526036206052981]], AbsoluteThickness[0.25], 
     LineBox[{3614, 3615}]}, 
    {Hue[
      NCache[
       Rational[1205, 4769], 0.25267351646047387`]], AbsoluteThickness[0.25], 
     LineBox[{3615, 3616}]}, 
    {Hue[
      NCache[
       Rational[3616, 14307], 0.2527434123156497]], AbsoluteThickness[0.25], 
     LineBox[{3616, 3617}]}, 
    {Hue[
      NCache[
       Rational[3617, 14307], 0.2528133081708255]], AbsoluteThickness[0.25], 
     LineBox[{3617, 3618}]}, 
    {Hue[
      NCache[
       Rational[1206, 4769], 0.2528832040260013]], AbsoluteThickness[0.25], 
     LineBox[{3618, 3619}]}, 
    {Hue[
      NCache[
       Rational[3619, 14307], 0.25295309988117703`]], AbsoluteThickness[0.25],
      LineBox[{3619, 3620}]}, 
    {Hue[
      NCache[
       Rational[3620, 14307], 0.25302299573635284`]], AbsoluteThickness[0.25],
      LineBox[{3620, 3621}]}, 
    {Hue[
      NCache[
       Rational[1207, 4769], 0.25309289159152865`]], AbsoluteThickness[0.25], 
     LineBox[{3621, 3622}]}, 
    {Hue[
      NCache[
       Rational[3622, 14307], 0.2531627874467044]], AbsoluteThickness[0.25], 
     LineBox[{3622, 3623}]}, 
    {Hue[
      NCache[
       Rational[3623, 14307], 0.2532326833018802]], AbsoluteThickness[0.25], 
     LineBox[{3623, 3624}]}, 
    {Hue[
      NCache[
       Rational[1208, 4769], 0.253302579157056]], AbsoluteThickness[0.25], 
     LineBox[{3624, 3625}]}, 
    {Hue[
      NCache[
       Rational[3625, 14307], 0.25337247501223176`]], AbsoluteThickness[0.25],
      LineBox[{3625, 3626}]}, 
    {Hue[
      NCache[
       Rational[3626, 14307], 0.25344237086740756`]], AbsoluteThickness[0.25],
      LineBox[{3626, 3627}]}, 
    {Hue[
      NCache[
       Rational[1209, 4769], 0.25351226672258337`]], AbsoluteThickness[0.25], 
     LineBox[{3627, 3628}]}, 
    {Hue[
      NCache[
       Rational[3628, 14307], 0.2535821625777591]], AbsoluteThickness[0.25], 
     LineBox[{3628, 3629}]}, 
    {Hue[
      NCache[
       Rational[191, 753], 0.2536520584329349]], AbsoluteThickness[0.25], 
     LineBox[{3629, 3630}]}, 
    {Hue[
      NCache[
       Rational[1210, 4769], 0.25372195428811073`]], AbsoluteThickness[0.25], 
     LineBox[{3630, 3631}]}, 
    {Hue[
      NCache[
       Rational[3631, 14307], 0.2537918501432865]], AbsoluteThickness[0.25], 
     LineBox[{3631, 3632}]}, 
    {Hue[
      NCache[
       Rational[3632, 14307], 0.2538617459984623]], AbsoluteThickness[0.25], 
     LineBox[{3632, 3633}]}, 
    {Hue[
      NCache[
       Rational[1211, 4769], 0.2539316418536381]], AbsoluteThickness[0.25], 
     LineBox[{3633, 3634}]}, 
    {Hue[
      NCache[
       Rational[3634, 14307], 0.25400153770881384`]], AbsoluteThickness[0.25],
      LineBox[{3634, 3635}]}, 
    {Hue[
      NCache[
       Rational[3635, 14307], 0.25407143356398965`]], AbsoluteThickness[0.25],
      LineBox[{3635, 3636}]}, 
    {Hue[
      NCache[
       Rational[1212, 4769], 0.25414132941916545`]], AbsoluteThickness[0.25], 
     LineBox[{3636, 3637}]}, 
    {Hue[
      NCache[
       Rational[3637, 14307], 0.25421122527434126`]], AbsoluteThickness[0.25],
      LineBox[{3637, 3638}]}, 
    {Hue[
      NCache[
       Rational[3638, 14307], 0.254281121129517]], AbsoluteThickness[0.25], 
     LineBox[{3638, 3639}]}, 
    {Hue[
      NCache[
       Rational[1213, 4769], 0.2543510169846928]], AbsoluteThickness[0.25], 
     LineBox[{3639, 3640}]}, 
    {Hue[
      NCache[
       Rational[3640, 14307], 0.2544209128398686]], AbsoluteThickness[0.25], 
     LineBox[{3640, 3641}]}, 
    {Hue[
      NCache[
       Rational[3641, 14307], 0.25449080869504437`]], AbsoluteThickness[0.25],
      LineBox[{3641, 3642}]}, 
    {Hue[
      NCache[
       Rational[1214, 4769], 0.2545607045502202]], AbsoluteThickness[0.25], 
     LineBox[{3642, 3643}]}, 
    {Hue[
      NCache[
       Rational[3643, 14307], 0.254630600405396]], AbsoluteThickness[0.25], 
     LineBox[{3643, 3644}]}, 
    {Hue[
      NCache[
       Rational[3644, 14307], 0.25470049626057173`]], AbsoluteThickness[0.25],
      LineBox[{3644, 3645}]}, 
    {Hue[
      NCache[
       Rational[1215, 4769], 0.25477039211574753`]], AbsoluteThickness[0.25], 
     LineBox[{3645, 3646}]}, 
    {Hue[
      NCache[
       Rational[3646, 14307], 0.25484028797092334`]], AbsoluteThickness[0.25],
      LineBox[{3646, 3647}]}, 
    {Hue[
      NCache[
       Rational[3647, 14307], 0.2549101838260991]], AbsoluteThickness[0.25], 
     LineBox[{3647, 3648}]}, 
    {Hue[
      NCache[
       Rational[64, 251], 0.2549800796812749]], AbsoluteThickness[0.25], 
     LineBox[{3648, 3649}]}, 
    {Hue[
      NCache[
       Rational[3649, 14307], 0.2550499755364507]], AbsoluteThickness[0.25], 
     LineBox[{3649, 3650}]}, 
    {Hue[
      NCache[
       Rational[3650, 14307], 0.25511987139162645`]], AbsoluteThickness[0.25],
      LineBox[{3650, 3651}]}, 
    {Hue[
      NCache[
       Rational[1217, 4769], 0.25518976724680226`]], AbsoluteThickness[0.25], 
     LineBox[{3651, 3652}]}, 
    {Hue[
      NCache[
       Rational[3652, 14307], 0.25525966310197806`]], AbsoluteThickness[0.25],
      LineBox[{3652, 3653}]}, 
    {Hue[
      NCache[
       Rational[3653, 14307], 0.25532955895715387`]], AbsoluteThickness[0.25],
      LineBox[{3653, 3654}]}, 
    {Hue[
      NCache[
       Rational[1218, 4769], 0.2553994548123296]], AbsoluteThickness[0.25], 
     LineBox[{3654, 3655}]}, 
    {Hue[
      NCache[
       Rational[3655, 14307], 0.2554693506675054]], AbsoluteThickness[0.25], 
     LineBox[{3655, 3656}]}, 
    {Hue[
      NCache[
       Rational[3656, 14307], 0.25553924652268123`]], AbsoluteThickness[0.25],
      LineBox[{3656, 3657}]}, 
    {Hue[
      NCache[
       Rational[1219, 4769], 0.255609142377857]], AbsoluteThickness[0.25], 
     LineBox[{3657, 3658}]}, 
    {Hue[
      NCache[
       Rational[3658, 14307], 0.2556790382330328]], AbsoluteThickness[0.25], 
     LineBox[{3658, 3659}]}, 
    {Hue[
      NCache[
       Rational[3659, 14307], 0.2557489340882086]], AbsoluteThickness[0.25], 
     LineBox[{3659, 3660}]}, 
    {Hue[
      NCache[
       Rational[1220, 4769], 0.25581882994338434`]], AbsoluteThickness[0.25], 
     LineBox[{3660, 3661}]}, 
    {Hue[
      NCache[
       Rational[3661, 14307], 0.25588872579856015`]], AbsoluteThickness[0.25],
      LineBox[{3661, 3662}]}, 
    {Hue[
      NCache[
       Rational[3662, 14307], 0.25595862165373595`]], AbsoluteThickness[0.25],
      LineBox[{3662, 3663}]}, 
    {Hue[
      NCache[
       Rational[1221, 4769], 0.2560285175089117]], AbsoluteThickness[0.25], 
     LineBox[{3663, 3664}]}, 
    {Hue[
      NCache[
       Rational[3664, 14307], 0.2560984133640875]], AbsoluteThickness[0.25], 
     LineBox[{3664, 3665}]}, 
    {Hue[
      NCache[
       Rational[3665, 14307], 0.2561683092192633]], AbsoluteThickness[0.25], 
     LineBox[{3665, 3666}]}, 
    {Hue[
      NCache[
       Rational[1222, 4769], 0.25623820507443906`]], AbsoluteThickness[0.25], 
     LineBox[{3666, 3667}]}, 
    {Hue[
      NCache[
       Rational[193, 753], 0.25630810092961487`]], AbsoluteThickness[0.25], 
     LineBox[{3667, 3668}]}, 
    {Hue[
      NCache[
       Rational[3668, 14307], 0.2563779967847907]], AbsoluteThickness[0.25], 
     LineBox[{3668, 3669}]}, 
    {Hue[
      NCache[
       Rational[1223, 4769], 0.2564478926399664]], AbsoluteThickness[0.25], 
     LineBox[{3669, 3670}]}, 
    {Hue[
      NCache[
       Rational[3670, 14307], 0.25651778849514223`]], AbsoluteThickness[0.25],
      LineBox[{3670, 3671}]}, 
    {Hue[
      NCache[
       Rational[3671, 14307], 0.25658768435031803`]], AbsoluteThickness[0.25],
      LineBox[{3671, 3672}]}, 
    {Hue[
      NCache[
       Rational[1224, 4769], 0.25665758020549384`]], AbsoluteThickness[0.25], 
     LineBox[{3672, 3673}]}, 
    {Hue[
      NCache[
       Rational[3673, 14307], 0.2567274760606696]], AbsoluteThickness[0.25], 
     LineBox[{3673, 3674}]}, 
    {Hue[
      NCache[
       Rational[3674, 14307], 0.2567973719158454]], AbsoluteThickness[0.25], 
     LineBox[{3674, 3675}]}, 
    {Hue[
      NCache[
       Rational[1225, 4769], 0.2568672677710212]], AbsoluteThickness[0.25], 
     LineBox[{3675, 3676}]}, 
    {Hue[
      NCache[
       Rational[3676, 14307], 0.25693716362619695`]], AbsoluteThickness[0.25],
      LineBox[{3676, 3677}]}, 
    {Hue[
      NCache[
       Rational[3677, 14307], 0.25700705948137276`]], AbsoluteThickness[0.25],
      LineBox[{3677, 3678}]}, 
    {Hue[
      NCache[
       Rational[1226, 4769], 0.25707695533654856`]], AbsoluteThickness[0.25], 
     LineBox[{3678, 3679}]}, 
    {Hue[
      NCache[
       Rational[3679, 14307], 0.2571468511917243]], AbsoluteThickness[0.25], 
     LineBox[{3679, 3680}]}, 
    {Hue[
      NCache[
       Rational[3680, 14307], 0.2572167470469001]], AbsoluteThickness[0.25], 
     LineBox[{3680, 3681}]}, 
    {Hue[
      NCache[
       Rational[1227, 4769], 0.2572866429020759]], AbsoluteThickness[0.25], 
     LineBox[{3681, 3682}]}, 
    {Hue[
      NCache[
       Rational[3682, 14307], 0.2573565387572517]], AbsoluteThickness[0.25], 
     LineBox[{3682, 3683}]}, 
    {Hue[
      NCache[
       Rational[3683, 14307], 0.2574264346124275]], AbsoluteThickness[0.25], 
     LineBox[{3683, 3684}]}, 
    {Hue[
      NCache[
       Rational[1228, 4769], 0.2574963304676033]], AbsoluteThickness[0.25], 
     LineBox[{3684, 3685}]}, 
    {Hue[
      NCache[
       Rational[3685, 14307], 0.25756622632277903`]], AbsoluteThickness[0.25],
      LineBox[{3685, 3686}]}, 
    {Hue[
      NCache[
       Rational[194, 753], 0.25763612217795484`]], AbsoluteThickness[0.25], 
     LineBox[{3686, 3687}]}, 
    {Hue[
      NCache[
       Rational[1229, 4769], 0.25770601803313065`]], AbsoluteThickness[0.25], 
     LineBox[{3687, 3688}]}, 
    {Hue[
      NCache[
       Rational[3688, 14307], 0.2577759138883064]], AbsoluteThickness[0.25], 
     LineBox[{3688, 3689}]}, 
    {Hue[
      NCache[
       Rational[3689, 14307], 0.2578458097434822]], AbsoluteThickness[0.25], 
     LineBox[{3689, 3690}]}, 
    {Hue[
      NCache[
       Rational[1230, 4769], 0.257915705598658]], AbsoluteThickness[0.25], 
     LineBox[{3690, 3691}]}, 
    {Hue[
      NCache[
       Rational[3691, 14307], 0.2579856014538338]], AbsoluteThickness[0.25], 
     LineBox[{3691, 3692}]}, 
    {Hue[
      NCache[
       Rational[3692, 14307], 0.25805549730900956`]], AbsoluteThickness[0.25],
      LineBox[{3692, 3693}]}, 
    {Hue[
      NCache[
       Rational[1231, 4769], 0.25812539316418537`]], AbsoluteThickness[0.25], 
     LineBox[{3693, 3694}]}, 
    {Hue[
      NCache[
       Rational[3694, 14307], 0.2581952890193612]], AbsoluteThickness[0.25], 
     LineBox[{3694, 3695}]}, 
    {Hue[
      NCache[
       Rational[3695, 14307], 0.2582651848745369]], AbsoluteThickness[0.25], 
     LineBox[{3695, 3696}]}, 
    {Hue[
      NCache[
       Rational[1232, 4769], 0.25833508072971273`]], AbsoluteThickness[0.25], 
     LineBox[{3696, 3697}]}, 
    {Hue[
      NCache[
       Rational[3697, 14307], 0.25840497658488853`]], AbsoluteThickness[0.25],
      LineBox[{3697, 3698}]}, 
    {Hue[
      NCache[
       Rational[3698, 14307], 0.2584748724400643]], AbsoluteThickness[0.25], 
     LineBox[{3698, 3699}]}, 
    {Hue[
      NCache[
       Rational[1233, 4769], 0.2585447682952401]], AbsoluteThickness[0.25], 
     LineBox[{3699, 3700}]}, 
    {Hue[
      NCache[
       Rational[3700, 14307], 0.2586146641504159]], AbsoluteThickness[0.25], 
     LineBox[{3700, 3701}]}, 
    {Hue[
      NCache[
       Rational[3701, 14307], 0.25868456000559165`]], AbsoluteThickness[0.25],
      LineBox[{3701, 3702}]}, 
    {Hue[
      NCache[
       Rational[1234, 4769], 0.25875445586076745`]], AbsoluteThickness[0.25], 
     LineBox[{3702, 3703}]}, 
    {Hue[
      NCache[
       Rational[3703, 14307], 0.25882435171594326`]], AbsoluteThickness[0.25],
      LineBox[{3703, 3704}]}, 
    {Hue[
      NCache[
       Rational[3704, 14307], 0.258894247571119]], AbsoluteThickness[0.25], 
     LineBox[{3704, 3705}]}, 
    {Hue[
      NCache[
       Rational[65, 251], 0.2589641434262948]], AbsoluteThickness[0.25], 
     LineBox[{3705, 3706}]}, 
    {Hue[
      NCache[
       Rational[3706, 14307], 0.2590340392814706]], AbsoluteThickness[0.25], 
     LineBox[{3706, 3707}]}, 
    {Hue[
      NCache[
       Rational[3707, 14307], 0.2591039351366464]], AbsoluteThickness[0.25], 
     LineBox[{3707, 3708}]}, 
    {Hue[
      NCache[
       Rational[1236, 4769], 0.2591738309918222]], AbsoluteThickness[0.25], 
     LineBox[{3708, 3709}]}, 
    {Hue[
      NCache[
       Rational[3709, 14307], 0.259243726846998]], AbsoluteThickness[0.25], 
     LineBox[{3709, 3710}]}, 
    {Hue[
      NCache[
       Rational[3710, 14307], 0.2593136227021738]], AbsoluteThickness[0.25], 
     LineBox[{3710, 3711}]}, 
    {Hue[
      NCache[
       Rational[1237, 4769], 0.25938351855734953`]], AbsoluteThickness[0.25], 
     LineBox[{3711, 3712}]}, 
    {Hue[
      NCache[
       Rational[3712, 14307], 0.25945341441252534`]], AbsoluteThickness[0.25],
      LineBox[{3712, 3713}]}, 
    {Hue[
      NCache[
       Rational[3713, 14307], 0.25952331026770115`]], AbsoluteThickness[0.25],
      LineBox[{3713, 3714}]}, 
    {Hue[
      NCache[
       Rational[1238, 4769], 0.2595932061228769]], AbsoluteThickness[0.25], 
     LineBox[{3714, 3715}]}, 
    {Hue[
      NCache[
       Rational[3715, 14307], 0.2596631019780527]], AbsoluteThickness[0.25], 
     LineBox[{3715, 3716}]}, 
    {Hue[
      NCache[
       Rational[3716, 14307], 0.2597329978332285]], AbsoluteThickness[0.25], 
     LineBox[{3716, 3717}]}, 
    {Hue[
      NCache[
       Rational[1239, 4769], 0.25980289368840426`]], AbsoluteThickness[0.25], 
     LineBox[{3717, 3718}]}, 
    {Hue[
      NCache[
       Rational[3718, 14307], 0.25987278954358006`]], AbsoluteThickness[0.25],
      LineBox[{3718, 3719}]}, 
    {Hue[
      NCache[
       Rational[3719, 14307], 0.25994268539875587`]], AbsoluteThickness[0.25],
      LineBox[{3719, 3720}]}, 
    {Hue[
      NCache[
       Rational[1240, 4769], 0.2600125812539316]], AbsoluteThickness[0.25], 
     LineBox[{3720, 3721}]}, 
    {Hue[
      NCache[
       Rational[3721, 14307], 0.2600824771091074]], AbsoluteThickness[0.25], 
     LineBox[{3721, 3722}]}, 
    {Hue[
      NCache[
       Rational[3722, 14307], 0.26015237296428323`]], AbsoluteThickness[0.25],
      LineBox[{3722, 3723}]}, 
    {Hue[
      NCache[
       Rational[1241, 4769], 0.260222268819459]], AbsoluteThickness[0.25], 
     LineBox[{3723, 3724}]}, 
    {Hue[
      NCache[
       Rational[196, 753], 0.2602921646746348]], AbsoluteThickness[0.25], 
     LineBox[{3724, 3725}]}, 
    {Hue[
      NCache[
       Rational[3725, 14307], 0.2603620605298106]], AbsoluteThickness[0.25], 
     LineBox[{3725, 3726}]}, 
    {Hue[
      NCache[
       Rational[1242, 4769], 0.2604319563849864]], AbsoluteThickness[0.25], 
     LineBox[{3726, 3727}]}, 
    {Hue[
      NCache[
       Rational[3727, 14307], 0.26050185224016215`]], AbsoluteThickness[0.25],
      LineBox[{3727, 3728}]}, 
    {Hue[
      NCache[
       Rational[3728, 14307], 0.26057174809533795`]], AbsoluteThickness[0.25],
      LineBox[{3728, 3729}]}, 
    {Hue[
      NCache[
       Rational[1243, 4769], 0.26064164395051376`]], AbsoluteThickness[0.25], 
     LineBox[{3729, 3730}]}, 
    {Hue[
      NCache[
       Rational[3730, 14307], 0.2607115398056895]], AbsoluteThickness[0.25], 
     LineBox[{3730, 3731}]}, 
    {Hue[
      NCache[
       Rational[3731, 14307], 0.2607814356608653]], AbsoluteThickness[0.25], 
     LineBox[{3731, 3732}]}, 
    {Hue[
      NCache[
       Rational[1244, 4769], 0.2608513315160411]], AbsoluteThickness[0.25], 
     LineBox[{3732, 3733}]}, 
    {Hue[
      NCache[
       Rational[3733, 14307], 0.26092122737121687`]], AbsoluteThickness[0.25],
      LineBox[{3733, 3734}]}, 
    {Hue[
      NCache[
       Rational[3734, 14307], 0.2609911232263927]], AbsoluteThickness[0.25], 
     LineBox[{3734, 3735}]}, 
    {Hue[
      NCache[
       Rational[1245, 4769], 0.2610610190815685]], AbsoluteThickness[0.25], 
     LineBox[{3735, 3736}]}, 
    {Hue[
      NCache[
       Rational[3736, 14307], 0.26113091493674423`]], AbsoluteThickness[0.25],
      LineBox[{3736, 3737}]}, 
    {Hue[
      NCache[
       Rational[3737, 14307], 0.26120081079192004`]], AbsoluteThickness[0.25],
      LineBox[{3737, 3738}]}, 
    {Hue[
      NCache[
       Rational[1246, 4769], 0.26127070664709584`]], AbsoluteThickness[0.25], 
     LineBox[{3738, 3739}]}, 
    {Hue[
      NCache[
       Rational[3739, 14307], 0.2613406025022716]], AbsoluteThickness[0.25], 
     LineBox[{3739, 3740}]}, 
    {Hue[
      NCache[
       Rational[3740, 14307], 0.2614104983574474]], AbsoluteThickness[0.25], 
     LineBox[{3740, 3741}]}, 
    {Hue[
      NCache[
       Rational[1247, 4769], 0.2614803942126232]], AbsoluteThickness[0.25], 
     LineBox[{3741, 3742}]}, 
    {Hue[
      NCache[
       Rational[3742, 14307], 0.261550290067799]], AbsoluteThickness[0.25], 
     LineBox[{3742, 3743}]}, 
    {Hue[
      NCache[
       Rational[197, 753], 0.26162018592297476`]], AbsoluteThickness[0.25], 
     LineBox[{3743, 3744}]}, 
    {Hue[
      NCache[
       Rational[1248, 4769], 0.26169008177815056`]], AbsoluteThickness[0.25], 
     LineBox[{3744, 3745}]}, 
    {Hue[
      NCache[
       Rational[3745, 14307], 0.26175997763332637`]], AbsoluteThickness[0.25],
      LineBox[{3745, 3746}]}, 
    {Hue[
      NCache[
       Rational[3746, 14307], 0.2618298734885021]], AbsoluteThickness[0.25], 
     LineBox[{3746, 3747}]}, 
    {Hue[
      NCache[
       Rational[1249, 4769], 0.2618997693436779]], AbsoluteThickness[0.25], 
     LineBox[{3747, 3748}]}, 
    {Hue[
      NCache[
       Rational[3748, 14307], 0.26196966519885373`]], AbsoluteThickness[0.25],
      LineBox[{3748, 3749}]}, 
    {Hue[
      NCache[
       Rational[3749, 14307], 0.2620395610540295]], AbsoluteThickness[0.25], 
     LineBox[{3749, 3750}]}, 
    {Hue[
      NCache[
       Rational[1250, 4769], 0.2621094569092053]], AbsoluteThickness[0.25], 
     LineBox[{3750, 3751}]}, 
    {Hue[
      NCache[
       Rational[3751, 14307], 0.2621793527643811]], AbsoluteThickness[0.25], 
     LineBox[{3751, 3752}]}, 
    {Hue[
      NCache[
       Rational[3752, 14307], 0.26224924861955684`]], AbsoluteThickness[0.25],
      LineBox[{3752, 3753}]}, 
    {Hue[
      NCache[
       Rational[1251, 4769], 0.26231914447473265`]], AbsoluteThickness[0.25], 
     LineBox[{3753, 3754}]}, 
    {Hue[
      NCache[
       Rational[3754, 14307], 0.26238904032990845`]], AbsoluteThickness[0.25],
      LineBox[{3754, 3755}]}, 
    {Hue[
      NCache[
       Rational[3755, 14307], 0.2624589361850842]], AbsoluteThickness[0.25], 
     LineBox[{3755, 3756}]}, 
    {Hue[
      NCache[
       Rational[1252, 4769], 0.26252883204026]], AbsoluteThickness[0.25], 
     LineBox[{3756, 3757}]}, 
    {Hue[
      NCache[
       Rational[3757, 14307], 0.2625987278954358]], AbsoluteThickness[0.25], 
     LineBox[{3757, 3758}]}, 
    {Hue[
      NCache[
       Rational[3758, 14307], 0.26266862375061156`]], AbsoluteThickness[0.25],
      LineBox[{3758, 3759}]}, 
    {Hue[
      NCache[
       Rational[1253, 4769], 0.26273851960578737`]], AbsoluteThickness[0.25], 
     LineBox[{3759, 3760}]}, 
    {Hue[
      NCache[
       Rational[3760, 14307], 0.2628084154609632]], AbsoluteThickness[0.25], 
     LineBox[{3760, 3761}]}, 
    {Hue[
      NCache[
       Rational[3761, 14307], 0.262878311316139]], AbsoluteThickness[0.25], 
     LineBox[{3761, 3762}]}, 
    {Hue[
      NCache[
       Rational[66, 251], 0.26294820717131473`]], AbsoluteThickness[0.25], 
     LineBox[{3762, 3763}]}, 
    {Hue[
      NCache[
       Rational[3763, 14307], 0.26301810302649054`]], AbsoluteThickness[0.25],
      LineBox[{3763, 3764}]}, 
    {Hue[
      NCache[
       Rational[3764, 14307], 0.26308799888166634`]], AbsoluteThickness[0.25],
      LineBox[{3764, 3765}]}, 
    {Hue[
      NCache[
       Rational[5, 19], 0.2631578947368421]], AbsoluteThickness[0.25], 
     LineBox[{3765, 3766}]}, 
    {Hue[
      NCache[
       Rational[3766, 14307], 0.2632277905920179]], AbsoluteThickness[0.25], 
     LineBox[{3766, 3767}]}, 
    {Hue[
      NCache[
       Rational[3767, 14307], 0.2632976864471937]], AbsoluteThickness[0.25], 
     LineBox[{3767, 3768}]}, 
    {Hue[
      NCache[
       Rational[1256, 4769], 0.26336758230236945`]], AbsoluteThickness[0.25], 
     LineBox[{3768, 3769}]}, 
    {Hue[
      NCache[
       Rational[3769, 14307], 0.26343747815754526`]], AbsoluteThickness[0.25],
      LineBox[{3769, 3770}]}, 
    {Hue[
      NCache[
       Rational[3770, 14307], 0.26350737401272106`]], AbsoluteThickness[0.25],
      LineBox[{3770, 3771}]}, 
    {Hue[
      NCache[
       Rational[1257, 4769], 0.2635772698678968]], AbsoluteThickness[0.25], 
     LineBox[{3771, 3772}]}, 
    {Hue[
      NCache[
       Rational[3772, 14307], 0.2636471657230726]], AbsoluteThickness[0.25], 
     LineBox[{3772, 3773}]}, 
    {Hue[
      NCache[
       Rational[3773, 14307], 0.2637170615782484]], AbsoluteThickness[0.25], 
     LineBox[{3773, 3774}]}, 
    {Hue[
      NCache[
       Rational[1258, 4769], 0.2637869574334242]], AbsoluteThickness[0.25], 
     LineBox[{3774, 3775}]}, 
    {Hue[
      NCache[
       Rational[3775, 14307], 0.2638568532886]], AbsoluteThickness[0.25], 
     LineBox[{3775, 3776}]}, 
    {Hue[
      NCache[
       Rational[3776, 14307], 0.2639267491437758]], AbsoluteThickness[0.25], 
     LineBox[{3776, 3777}]}, 
    {Hue[
      NCache[
       Rational[1259, 4769], 0.26399664499895154`]], AbsoluteThickness[0.25], 
     LineBox[{3777, 3778}]}, 
    {Hue[
      NCache[
       Rational[3778, 14307], 0.26406654085412734`]], AbsoluteThickness[0.25],
      LineBox[{3778, 3779}]}, 
    {Hue[
      NCache[
       Rational[3779, 14307], 0.26413643670930315`]], AbsoluteThickness[0.25],
      LineBox[{3779, 3780}]}, 
    {Hue[
      NCache[
       Rational[1260, 4769], 0.26420633256447895`]], AbsoluteThickness[0.25], 
     LineBox[{3780, 3781}]}, 
    {Hue[
      NCache[
       Rational[199, 753], 0.2642762284196547]], AbsoluteThickness[0.25], 
     LineBox[{3781, 3782}]}, 
    {Hue[
      NCache[
       Rational[3782, 14307], 0.2643461242748305]], AbsoluteThickness[0.25], 
     LineBox[{3782, 3783}]}, 
    {Hue[
      NCache[
       Rational[1261, 4769], 0.2644160201300063]], AbsoluteThickness[0.25], 
     LineBox[{3783, 3784}]}, 
    {Hue[
      NCache[
       Rational[3784, 14307], 0.26448591598518206`]], AbsoluteThickness[0.25],
      LineBox[{3784, 3785}]}, 
    {Hue[
      NCache[
       Rational[3785, 14307], 0.26455581184035787`]], AbsoluteThickness[0.25],
      LineBox[{3785, 3786}]}, 
    {Hue[
      NCache[
       Rational[1262, 4769], 0.2646257076955337]], AbsoluteThickness[0.25], 
     LineBox[{3786, 3787}]}, 
    {Hue[
      NCache[
       Rational[3787, 14307], 0.2646956035507094]], AbsoluteThickness[0.25], 
     LineBox[{3787, 3788}]}, 
    {Hue[
      NCache[
       Rational[3788, 14307], 0.26476549940588523`]], AbsoluteThickness[0.25],
      LineBox[{3788, 3789}]}, 
    {Hue[
      NCache[
       Rational[1263, 4769], 0.26483539526106104`]], AbsoluteThickness[0.25], 
     LineBox[{3789, 3790}]}, 
    {Hue[
      NCache[
       Rational[3790, 14307], 0.2649052911162368]], AbsoluteThickness[0.25], 
     LineBox[{3790, 3791}]}, 
    {Hue[
      NCache[
       Rational[3791, 14307], 0.2649751869714126]], AbsoluteThickness[0.25], 
     LineBox[{3791, 3792}]}, 
    {Hue[
      NCache[
       Rational[1264, 4769], 0.2650450828265884]], AbsoluteThickness[0.25], 
     LineBox[{3792, 3793}]}, 
    {Hue[
      NCache[
       Rational[3793, 14307], 0.26511497868176415`]], AbsoluteThickness[0.25],
      LineBox[{3793, 3794}]}, 
    {Hue[
      NCache[
       Rational[3794, 14307], 0.26518487453693995`]], AbsoluteThickness[0.25],
      LineBox[{3794, 3795}]}, 
    {Hue[
      NCache[
       Rational[1265, 4769], 0.26525477039211576`]], AbsoluteThickness[0.25], 
     LineBox[{3795, 3796}]}, 
    {Hue[
      NCache[
       Rational[3796, 14307], 0.26532466624729156`]], AbsoluteThickness[0.25],
      LineBox[{3796, 3797}]}, 
    {Hue[
      NCache[
       Rational[3797, 14307], 0.2653945621024673]], AbsoluteThickness[0.25], 
     LineBox[{3797, 3798}]}, 
    {Hue[
      NCache[
       Rational[1266, 4769], 0.2654644579576431]], AbsoluteThickness[0.25], 
     LineBox[{3798, 3799}]}, 
    {Hue[
      NCache[
       Rational[3799, 14307], 0.2655343538128189]], AbsoluteThickness[0.25], 
     LineBox[{3799, 3800}]}, 
    {Hue[
      NCache[
       Rational[200, 753], 0.2656042496679947]], AbsoluteThickness[0.25], 
     LineBox[{3800, 3801}]}, 
    {Hue[
      NCache[
       Rational[1267, 4769], 0.2656741455231705]], AbsoluteThickness[0.25], 
     LineBox[{3801, 3802}]}, 
    {Hue[
      NCache[
       Rational[3802, 14307], 0.2657440413783463]], AbsoluteThickness[0.25], 
     LineBox[{3802, 3803}]}, 
    {Hue[
      NCache[
       Rational[3803, 14307], 0.26581393723352204`]], AbsoluteThickness[0.25],
      LineBox[{3803, 3804}]}, 
    {Hue[
      NCache[
       Rational[1268, 4769], 0.26588383308869784`]], AbsoluteThickness[0.25], 
     LineBox[{3804, 3805}]}, 
    {Hue[
      NCache[
       Rational[3805, 14307], 0.26595372894387365`]], AbsoluteThickness[0.25],
      LineBox[{3805, 3806}]}, 
    {Hue[
      NCache[
       Rational[3806, 14307], 0.2660236247990494]], AbsoluteThickness[0.25], 
     LineBox[{3806, 3807}]}, 
    {Hue[
      NCache[
       Rational[1269, 4769], 0.2660935206542252]], AbsoluteThickness[0.25], 
     LineBox[{3807, 3808}]}, 
    {Hue[
      NCache[
       Rational[3808, 14307], 0.266163416509401]], AbsoluteThickness[0.25], 
     LineBox[{3808, 3809}]}, 
    {Hue[
      NCache[
       Rational[3809, 14307], 0.26623331236457676`]], AbsoluteThickness[0.25],
      LineBox[{3809, 3810}]}, 
    {Hue[
      NCache[
       Rational[1270, 4769], 0.26630320821975256`]], AbsoluteThickness[0.25], 
     LineBox[{3810, 3811}]}, 
    {Hue[
      NCache[
       Rational[3811, 14307], 0.26637310407492837`]], AbsoluteThickness[0.25],
      LineBox[{3811, 3812}]}, 
    {Hue[
      NCache[
       Rational[3812, 14307], 0.2664429999301041]], AbsoluteThickness[0.25], 
     LineBox[{3812, 3813}]}, 
    {Hue[
      NCache[
       Rational[1271, 4769], 0.2665128957852799]], AbsoluteThickness[0.25], 
     LineBox[{3813, 3814}]}, 
    {Hue[
      NCache[
       Rational[3814, 14307], 0.26658279164045573`]], AbsoluteThickness[0.25],
      LineBox[{3814, 3815}]}, 
    {Hue[
      NCache[
       Rational[3815, 14307], 0.26665268749563154`]], AbsoluteThickness[0.25],
      LineBox[{3815, 3816}]}, 
    {Hue[
      NCache[
       Rational[1272, 4769], 0.2667225833508073]], AbsoluteThickness[0.25], 
     LineBox[{3816, 3817}]}, 
    {Hue[
      NCache[
       Rational[3817, 14307], 0.2667924792059831]], AbsoluteThickness[0.25], 
     LineBox[{3817, 3818}]}, 
    {Hue[
      NCache[
       Rational[3818, 14307], 0.2668623750611589]], AbsoluteThickness[0.25], 
     LineBox[{3818, 3819}]}, 
    {Hue[
      NCache[
       Rational[67, 251], 0.26693227091633465`]], AbsoluteThickness[0.25], 
     LineBox[{3819, 3820}]}, 
    {Hue[
      NCache[
       Rational[3820, 14307], 0.26700216677151045`]], AbsoluteThickness[0.25],
      LineBox[{3820, 3821}]}, 
    {Hue[
      NCache[
       Rational[3821, 14307], 0.26707206262668626`]], AbsoluteThickness[0.25],
      LineBox[{3821, 3822}]}, 
    {Hue[
      NCache[
       Rational[1274, 4769], 0.267141958481862]], AbsoluteThickness[0.25], 
     LineBox[{3822, 3823}]}, 
    {Hue[
      NCache[
       Rational[3823, 14307], 0.2672118543370378]], AbsoluteThickness[0.25], 
     LineBox[{3823, 3824}]}, 
    {Hue[
      NCache[
       Rational[3824, 14307], 0.2672817501922136]], AbsoluteThickness[0.25], 
     LineBox[{3824, 3825}]}, 
    {Hue[
      NCache[
       Rational[1275, 4769], 0.26735164604738937`]], AbsoluteThickness[0.25], 
     LineBox[{3825, 3826}]}, 
    {Hue[
      NCache[
       Rational[3826, 14307], 0.2674215419025652]], AbsoluteThickness[0.25], 
     LineBox[{3826, 3827}]}, 
    {Hue[
      NCache[
       Rational[3827, 14307], 0.267491437757741]], AbsoluteThickness[0.25], 
     LineBox[{3827, 3828}]}, 
    {Hue[
      NCache[
       Rational[1276, 4769], 0.26756133361291673`]], AbsoluteThickness[0.25], 
     LineBox[{3828, 3829}]}, 
    {Hue[
      NCache[
       Rational[3829, 14307], 0.26763122946809254`]], AbsoluteThickness[0.25],
      LineBox[{3829, 3830}]}, 
    {Hue[
      NCache[
       Rational[3830, 14307], 0.26770112532326834`]], AbsoluteThickness[0.25],
      LineBox[{3830, 3831}]}, 
    {Hue[
      NCache[
       Rational[1277, 4769], 0.2677710211784441]], AbsoluteThickness[0.25], 
     LineBox[{3831, 3832}]}, 
    {Hue[
      NCache[
       Rational[3832, 14307], 0.2678409170336199]], AbsoluteThickness[0.25], 
     LineBox[{3832, 3833}]}, 
    {Hue[
      NCache[
       Rational[3833, 14307], 0.2679108128887957]], AbsoluteThickness[0.25], 
     LineBox[{3833, 3834}]}, 
    {Hue[
      NCache[
       Rational[1278, 4769], 0.2679807087439715]], AbsoluteThickness[0.25], 
     LineBox[{3834, 3835}]}, 
    {Hue[
      NCache[
       Rational[3835, 14307], 0.26805060459914726`]], AbsoluteThickness[0.25],
      LineBox[{3835, 3836}]}, 
    {Hue[
      NCache[
       Rational[3836, 14307], 0.26812050045432306`]], AbsoluteThickness[0.25],
      LineBox[{3836, 3837}]}, 
    {Hue[
      NCache[
       Rational[1279, 4769], 0.26819039630949887`]], AbsoluteThickness[0.25], 
     LineBox[{3837, 3838}]}, 
    {Hue[
      NCache[
       Rational[202, 753], 0.2682602921646746]], AbsoluteThickness[0.25], 
     LineBox[{3838, 3839}]}, 
    {Hue[
      NCache[
       Rational[3839, 14307], 0.2683301880198504]], AbsoluteThickness[0.25], 
     LineBox[{3839, 3840}]}, 
    {Hue[
      NCache[
       Rational[1280, 4769], 0.26840008387502623`]], AbsoluteThickness[0.25], 
     LineBox[{3840, 3841}]}, 
    {Hue[
      NCache[
       Rational[3841, 14307], 0.268469979730202]], AbsoluteThickness[0.25], 
     LineBox[{3841, 3842}]}, 
    {Hue[
      NCache[
       Rational[3842, 14307], 0.2685398755853778]], AbsoluteThickness[0.25], 
     LineBox[{3842, 3843}]}, 
    {Hue[
      NCache[
       Rational[1281, 4769], 0.2686097714405536]], AbsoluteThickness[0.25], 
     LineBox[{3843, 3844}]}, 
    {Hue[
      NCache[
       Rational[3844, 14307], 0.26867966729572934`]], AbsoluteThickness[0.25],
      LineBox[{3844, 3845}]}, 
    {Hue[
      NCache[
       Rational[3845, 14307], 0.26874956315090515`]], AbsoluteThickness[0.25],
      LineBox[{3845, 3846}]}, 
    {Hue[
      NCache[
       Rational[1282, 4769], 0.26881945900608095`]], AbsoluteThickness[0.25], 
     LineBox[{3846, 3847}]}, 
    {Hue[
      NCache[
       Rational[3847, 14307], 0.2688893548612567]], AbsoluteThickness[0.25], 
     LineBox[{3847, 3848}]}, 
    {Hue[
      NCache[
       Rational[3848, 14307], 0.2689592507164325]], AbsoluteThickness[0.25], 
     LineBox[{3848, 3849}]}, 
    {Hue[
      NCache[
       Rational[1283, 4769], 0.2690291465716083]], AbsoluteThickness[0.25], 
     LineBox[{3849, 3850}]}, 
    {Hue[
      NCache[
       Rational[3850, 14307], 0.2690990424267841]], AbsoluteThickness[0.25], 
     LineBox[{3850, 3851}]}, 
    {Hue[
      NCache[
       Rational[3851, 14307], 0.26916893828195987`]], AbsoluteThickness[0.25],
      LineBox[{3851, 3852}]}, 
    {Hue[
      NCache[
       Rational[1284, 4769], 0.2692388341371357]], AbsoluteThickness[0.25], 
     LineBox[{3852, 3853}]}, 
    {Hue[
      NCache[
       Rational[3853, 14307], 0.2693087299923115]], AbsoluteThickness[0.25], 
     LineBox[{3853, 3854}]}, 
    {Hue[
      NCache[
       Rational[3854, 14307], 0.26937862584748723`]], AbsoluteThickness[0.25],
      LineBox[{3854, 3855}]}, 
    {Hue[
      NCache[
       Rational[1285, 4769], 0.26944852170266304`]], AbsoluteThickness[0.25], 
     LineBox[{3855, 3856}]}, 
    {Hue[
      NCache[
       Rational[3856, 14307], 0.26951841755783884`]], AbsoluteThickness[0.25],
      LineBox[{3856, 3857}]}, 
    {Hue[
      NCache[
       Rational[203, 753], 0.2695883134130146]], AbsoluteThickness[0.25], 
     LineBox[{3857, 3858}]}, 
    {Hue[
      NCache[
       Rational[1286, 4769], 0.2696582092681904]], AbsoluteThickness[0.25], 
     LineBox[{3858, 3859}]}, 
    {Hue[
      NCache[
       Rational[3859, 14307], 0.2697281051233662]], AbsoluteThickness[0.25], 
     LineBox[{3859, 3860}]}, 
    {Hue[
      NCache[
       Rational[3860, 14307], 0.26979800097854195`]], AbsoluteThickness[0.25],
      LineBox[{3860, 3861}]}, 
    {Hue[
      NCache[
       Rational[1287, 4769], 0.26986789683371776`]], AbsoluteThickness[0.25], 
     LineBox[{3861, 3862}]}, 
    {Hue[
      NCache[
       Rational[3862, 14307], 0.26993779268889356`]], AbsoluteThickness[0.25],
      LineBox[{3862, 3863}]}, 
    {Hue[
      NCache[
       Rational[3863, 14307], 0.2700076885440693]], AbsoluteThickness[0.25], 
     LineBox[{3863, 3864}]}, 
    {Hue[
      NCache[
       Rational[1288, 4769], 0.2700775843992451]], AbsoluteThickness[0.25], 
     LineBox[{3864, 3865}]}, 
    {Hue[
      NCache[
       Rational[3865, 14307], 0.2701474802544209]], AbsoluteThickness[0.25], 
     LineBox[{3865, 3866}]}, 
    {Hue[
      NCache[
       Rational[3866, 14307], 0.2702173761095967]], AbsoluteThickness[0.25], 
     LineBox[{3866, 3867}]}, 
    {Hue[
      NCache[
       Rational[1289, 4769], 0.2702872719647725]], AbsoluteThickness[0.25], 
     LineBox[{3867, 3868}]}, 
    {Hue[
      NCache[
       Rational[3868, 14307], 0.2703571678199483]], AbsoluteThickness[0.25], 
     LineBox[{3868, 3869}]}, 
    {Hue[
      NCache[
       Rational[3869, 14307], 0.2704270636751241]], AbsoluteThickness[0.25], 
     LineBox[{3869, 3870}]}, 
    {Hue[
      NCache[
       Rational[1290, 4769], 0.27049695953029984`]], AbsoluteThickness[0.25], 
     LineBox[{3870, 3871}]}, 
    {Hue[
      NCache[
       Rational[3871, 14307], 0.27056685538547565`]], AbsoluteThickness[0.25],
      LineBox[{3871, 3872}]}, 
    {Hue[
      NCache[
       Rational[3872, 14307], 0.27063675124065145`]], AbsoluteThickness[0.25],
      LineBox[{3872, 3873}]}, 
    {Hue[
      NCache[
       Rational[1291, 4769], 0.2707066470958272]], AbsoluteThickness[0.25], 
     LineBox[{3873, 3874}]}, 
    {Hue[
      NCache[
       Rational[3874, 14307], 0.270776542951003]], AbsoluteThickness[0.25], 
     LineBox[{3874, 3875}]}, 
    {Hue[
      NCache[
       Rational[3875, 14307], 0.2708464388061788]], AbsoluteThickness[0.25], 
     LineBox[{3875, 3876}]}, 
    {Hue[
      NCache[
       Rational[68, 251], 0.27091633466135456`]], AbsoluteThickness[0.25], 
     LineBox[{3876, 3877}]}, 
    {Hue[
      NCache[
       Rational[3877, 14307], 0.27098623051653037`]], AbsoluteThickness[0.25],
      LineBox[{3877, 3878}]}, 
    {Hue[
      NCache[
       Rational[3878, 14307], 0.2710561263717062]], AbsoluteThickness[0.25], 
     LineBox[{3878, 3879}]}, 
    {Hue[
      NCache[
       Rational[1293, 4769], 0.2711260222268819]], AbsoluteThickness[0.25], 
     LineBox[{3879, 3880}]}, 
    {Hue[
      NCache[
       Rational[3880, 14307], 0.27119591808205773`]], AbsoluteThickness[0.25],
      LineBox[{3880, 3881}]}, 
    {Hue[
      NCache[
       Rational[3881, 14307], 0.27126581393723354`]], AbsoluteThickness[0.25],
      LineBox[{3881, 3882}]}, 
    {Hue[
      NCache[
       Rational[1294, 4769], 0.2713357097924093]], AbsoluteThickness[0.25], 
     LineBox[{3882, 3883}]}, 
    {Hue[
      NCache[
       Rational[3883, 14307], 0.2714056056475851]], AbsoluteThickness[0.25], 
     LineBox[{3883, 3884}]}, 
    {Hue[
      NCache[
       Rational[3884, 14307], 0.2714755015027609]], AbsoluteThickness[0.25], 
     LineBox[{3884, 3885}]}, 
    {Hue[
      NCache[
       Rational[1295, 4769], 0.2715453973579367]], AbsoluteThickness[0.25], 
     LineBox[{3885, 3886}]}, 
    {Hue[
      NCache[
       Rational[3886, 14307], 0.27161529321311245`]], AbsoluteThickness[0.25],
      LineBox[{3886, 3887}]}, 
    {Hue[
      NCache[
       Rational[3887, 14307], 0.27168518906828826`]], AbsoluteThickness[0.25],
      LineBox[{3887, 3888}]}, 
    {Hue[
      NCache[
       Rational[1296, 4769], 0.27175508492346406`]], AbsoluteThickness[0.25], 
     LineBox[{3888, 3889}]}, 
    {Hue[
      NCache[
       Rational[3889, 14307], 0.2718249807786398]], AbsoluteThickness[0.25], 
     LineBox[{3889, 3890}]}, 
    {Hue[
      NCache[
       Rational[3890, 14307], 0.2718948766338156]], AbsoluteThickness[0.25], 
     LineBox[{3890, 3891}]}, 
    {Hue[
      NCache[
       Rational[1297, 4769], 0.2719647724889914]], AbsoluteThickness[0.25], 
     LineBox[{3891, 3892}]}, 
    {Hue[
      NCache[
       Rational[3892, 14307], 0.2720346683441672]], AbsoluteThickness[0.25], 
     LineBox[{3892, 3893}]}, 
    {Hue[
      NCache[
       Rational[3893, 14307], 0.272104564199343]], AbsoluteThickness[0.25], 
     LineBox[{3893, 3894}]}, 
    {Hue[
      NCache[
       Rational[1298, 4769], 0.2721744600545188]], AbsoluteThickness[0.25], 
     LineBox[{3894, 3895}]}, 
    {Hue[
      NCache[
       Rational[205, 753], 0.27224435590969454`]], AbsoluteThickness[0.25], 
     LineBox[{3895, 3896}]}, 
    {Hue[
      NCache[
       Rational[3896, 14307], 0.27231425176487034`]], AbsoluteThickness[0.25],
      LineBox[{3896, 3897}]}, 
    {Hue[
      NCache[
       Rational[1299, 4769], 0.27238414762004615`]], AbsoluteThickness[0.25], 
     LineBox[{3897, 3898}]}, 
    {Hue[
      NCache[
       Rational[3898, 14307], 0.2724540434752219]], AbsoluteThickness[0.25], 
     LineBox[{3898, 3899}]}, 
    {Hue[
      NCache[
       Rational[3899, 14307], 0.2725239393303977]], AbsoluteThickness[0.25], 
     LineBox[{3899, 3900}]}, 
    {Hue[
      NCache[
       Rational[1300, 4769], 0.2725938351855735]], AbsoluteThickness[0.25], 
     LineBox[{3900, 3901}]}, 
    {Hue[
      NCache[
       Rational[3901, 14307], 0.27266373104074926`]], AbsoluteThickness[0.25],
      LineBox[{3901, 3902}]}, 
    {Hue[
      NCache[
       Rational[3902, 14307], 0.27273362689592506`]], AbsoluteThickness[0.25],
      LineBox[{3902, 3903}]}, 
    {Hue[
      NCache[
       Rational[1301, 4769], 0.27280352275110087`]], AbsoluteThickness[0.25], 
     LineBox[{3903, 3904}]}, 
    {Hue[
      NCache[
       Rational[3904, 14307], 0.2728734186062767]], AbsoluteThickness[0.25], 
     LineBox[{3904, 3905}]}, 
    {Hue[
      NCache[
       Rational[3905, 14307], 0.2729433144614524]], AbsoluteThickness[0.25], 
     LineBox[{3905, 3906}]}, 
    {Hue[
      NCache[
       Rational[1302, 4769], 0.27301321031662823`]], AbsoluteThickness[0.25], 
     LineBox[{3906, 3907}]}, 
    {Hue[
      NCache[
       Rational[3907, 14307], 0.27308310617180404`]], AbsoluteThickness[0.25],
      LineBox[{3907, 3908}]}, 
    {Hue[
      NCache[
       Rational[3908, 14307], 0.2731530020269798]], AbsoluteThickness[0.25], 
     LineBox[{3908, 3909}]}, 
    {Hue[
      NCache[
       Rational[1303, 4769], 0.2732228978821556]], AbsoluteThickness[0.25], 
     LineBox[{3909, 3910}]}, 
    {Hue[
      NCache[
       Rational[3910, 14307], 0.2732927937373314]], AbsoluteThickness[0.25], 
     LineBox[{3910, 3911}]}, 
    {Hue[
      NCache[
       Rational[3911, 14307], 0.27336268959250715`]], AbsoluteThickness[0.25],
      LineBox[{3911, 3912}]}, 
    {Hue[
      NCache[
       Rational[1304, 4769], 0.27343258544768295`]], AbsoluteThickness[0.25], 
     LineBox[{3912, 3913}]}, 
    {Hue[
      NCache[
       Rational[3913, 14307], 0.27350248130285876`]], AbsoluteThickness[0.25],
      LineBox[{3913, 3914}]}, 
    {Hue[
      NCache[
       Rational[206, 753], 0.2735723771580345]], AbsoluteThickness[0.25], 
     LineBox[{3914, 3915}]}, 
    {Hue[
      NCache[
       Rational[1305, 4769], 0.2736422730132103]], AbsoluteThickness[0.25], 
     LineBox[{3915, 3916}]}, 
    {Hue[
      NCache[
       Rational[3916, 14307], 0.2737121688683861]], AbsoluteThickness[0.25], 
     LineBox[{3916, 3917}]}, 
    {Hue[
      NCache[
       Rational[3917, 14307], 0.27378206472356187`]], AbsoluteThickness[0.25],
      LineBox[{3917, 3918}]}, 
    {Hue[
      NCache[
       Rational[1306, 4769], 0.2738519605787377]], AbsoluteThickness[0.25], 
     LineBox[{3918, 3919}]}, 
    {Hue[
      NCache[
       Rational[3919, 14307], 0.2739218564339135]], AbsoluteThickness[0.25], 
     LineBox[{3919, 3920}]}, 
    {Hue[
      NCache[
       Rational[3920, 14307], 0.27399175228908923`]], AbsoluteThickness[0.25],
      LineBox[{3920, 3921}]}, 
    {Hue[
      NCache[
       Rational[1307, 4769], 0.27406164814426504`]], AbsoluteThickness[0.25], 
     LineBox[{3921, 3922}]}, 
    {Hue[
      NCache[
       Rational[3922, 14307], 0.27413154399944084`]], AbsoluteThickness[0.25],
      LineBox[{3922, 3923}]}, 
    {Hue[
      NCache[
       Rational[3923, 14307], 0.27420143985461665`]], AbsoluteThickness[0.25],
      LineBox[{3923, 3924}]}, 
    {Hue[
      NCache[
       Rational[1308, 4769], 0.2742713357097924]], AbsoluteThickness[0.25], 
     LineBox[{3924, 3925}]}, 
    {Hue[
      NCache[
       Rational[3925, 14307], 0.2743412315649682]], AbsoluteThickness[0.25], 
     LineBox[{3925, 3926}]}, 
    {Hue[
      NCache[
       Rational[3926, 14307], 0.274411127420144]], AbsoluteThickness[0.25], 
     LineBox[{3926, 3927}]}, 
    {Hue[
      NCache[
       Rational[1309, 4769], 0.27448102327531976`]], AbsoluteThickness[0.25], 
     LineBox[{3927, 3928}]}, 
    {Hue[
      NCache[
       Rational[3928, 14307], 0.27455091913049556`]], AbsoluteThickness[0.25],
      LineBox[{3928, 3929}]}, 
    {Hue[
      NCache[
       Rational[3929, 14307], 0.27462081498567137`]], AbsoluteThickness[0.25],
      LineBox[{3929, 3930}]}, 
    {Hue[
      NCache[
       Rational[1310, 4769], 0.2746907108408471]], AbsoluteThickness[0.25], 
     LineBox[{3930, 3931}]}, 
    {Hue[
      NCache[
       Rational[3931, 14307], 0.2747606066960229]], AbsoluteThickness[0.25], 
     LineBox[{3931, 3932}]}, 
    {Hue[
      NCache[
       Rational[3932, 14307], 0.27483050255119873`]], AbsoluteThickness[0.25],
      LineBox[{3932, 3933}]}, 
    {Hue[
      NCache[
       Rational[69, 251], 0.2749003984063745]], AbsoluteThickness[0.25], 
     LineBox[{3933, 3934}]}, 
    {Hue[
      NCache[
       Rational[3934, 14307], 0.2749702942615503]], AbsoluteThickness[0.25], 
     LineBox[{3934, 3935}]}, 
    {Hue[
      NCache[
       Rational[3935, 14307], 0.2750401901167261]], AbsoluteThickness[0.25], 
     LineBox[{3935, 3936}]}, 
    {Hue[
      NCache[
       Rational[1312, 4769], 0.27511008597190184`]], AbsoluteThickness[0.25], 
     LineBox[{3936, 3937}]}, 
    {Hue[
      NCache[
       Rational[3937, 14307], 0.27517998182707765`]], AbsoluteThickness[0.25],
      LineBox[{3937, 3938}]}, 
    {Hue[
      NCache[
       Rational[3938, 14307], 0.27524987768225345`]], AbsoluteThickness[0.25],
      LineBox[{3938, 3939}]}, 
    {Hue[
      NCache[
       Rational[1313, 4769], 0.27531977353742926`]], AbsoluteThickness[0.25], 
     LineBox[{3939, 3940}]}, 
    {Hue[
      NCache[
       Rational[3940, 14307], 0.275389669392605]], AbsoluteThickness[0.25], 
     LineBox[{3940, 3941}]}, 
    {Hue[
      NCache[
       Rational[3941, 14307], 0.2754595652477808]], AbsoluteThickness[0.25], 
     LineBox[{3941, 3942}]}, 
    {Hue[
      NCache[
       Rational[1314, 4769], 0.2755294611029566]], AbsoluteThickness[0.25], 
     LineBox[{3942, 3943}]}, 
    {Hue[
      NCache[
       Rational[3943, 14307], 0.27559935695813237`]], AbsoluteThickness[0.25],
      LineBox[{3943, 3944}]}, 
    {Hue[
      NCache[
       Rational[3944, 14307], 0.2756692528133082]], AbsoluteThickness[0.25], 
     LineBox[{3944, 3945}]}, 
    {Hue[
      NCache[
       Rational[1315, 4769], 0.275739148668484]], AbsoluteThickness[0.25], 
     LineBox[{3945, 3946}]}, 
    {Hue[
      NCache[
       Rational[3946, 14307], 0.27580904452365973`]], AbsoluteThickness[0.25],
      LineBox[{3946, 3947}]}, 
    {Hue[
      NCache[
       Rational[3947, 14307], 0.27587894037883554`]], AbsoluteThickness[0.25],
      LineBox[{3947, 3948}]}, 
    {Hue[
      NCache[
       Rational[1316, 4769], 0.27594883623401134`]], AbsoluteThickness[0.25], 
     LineBox[{3948, 3949}]}, 
    {Hue[
      NCache[
       Rational[3949, 14307], 0.2760187320891871]], AbsoluteThickness[0.25], 
     LineBox[{3949, 3950}]}, 
    {Hue[
      NCache[
       Rational[3950, 14307], 0.2760886279443629]], AbsoluteThickness[0.25], 
     LineBox[{3950, 3951}]}, 
    {Hue[
      NCache[
       Rational[1317, 4769], 0.2761585237995387]], AbsoluteThickness[0.25], 
     LineBox[{3951, 3952}]}, 
    {Hue[
      NCache[
       Rational[208, 753], 0.27622841965471445`]], AbsoluteThickness[0.25], 
     LineBox[{3952, 3953}]}, 
    {Hue[
      NCache[
       Rational[3953, 14307], 0.27629831550989026`]], AbsoluteThickness[0.25],
      LineBox[{3953, 3954}]}, 
    {Hue[
      NCache[
       Rational[1318, 4769], 0.27636821136506606`]], AbsoluteThickness[0.25], 
     LineBox[{3954, 3955}]}, 
    {Hue[
      NCache[
       Rational[3955, 14307], 0.2764381072202418]], AbsoluteThickness[0.25], 
     LineBox[{3955, 3956}]}, 
    {Hue[
      NCache[
       Rational[3956, 14307], 0.2765080030754176]], AbsoluteThickness[0.25], 
     LineBox[{3956, 3957}]}, 
    {Hue[
      NCache[
       Rational[1319, 4769], 0.2765778989305934]], AbsoluteThickness[0.25], 
     LineBox[{3957, 3958}]}, 
    {Hue[
      NCache[
       Rational[3958, 14307], 0.27664779478576923`]], AbsoluteThickness[0.25],
      LineBox[{3958, 3959}]}, 
    {Hue[
      NCache[
       Rational[3959, 14307], 0.276717690640945]], AbsoluteThickness[0.25], 
     LineBox[{3959, 3960}]}, 
    {Hue[
      NCache[
       Rational[1320, 4769], 0.2767875864961208]], AbsoluteThickness[0.25], 
     LineBox[{3960, 3961}]}, 
    {Hue[
      NCache[
       Rational[3961, 14307], 0.2768574823512966]], AbsoluteThickness[0.25], 
     LineBox[{3961, 3962}]}, 
    {Hue[
      NCache[
       Rational[3962, 14307], 0.27692737820647234`]], AbsoluteThickness[0.25],
      LineBox[{3962, 3963}]}, 
    {Hue[
      NCache[
       Rational[1321, 4769], 0.27699727406164815`]], AbsoluteThickness[0.25], 
     LineBox[{3963, 3964}]}, 
    {Hue[
      NCache[
       Rational[3964, 14307], 0.27706716991682395`]], AbsoluteThickness[0.25],
      LineBox[{3964, 3965}]}, 
    {Hue[
      NCache[
       Rational[3965, 14307], 0.2771370657719997]], AbsoluteThickness[0.25], 
     LineBox[{3965, 3966}]}, 
    {Hue[
      NCache[
       Rational[1322, 4769], 0.2772069616271755]], AbsoluteThickness[0.25], 
     LineBox[{3966, 3967}]}, 
    {Hue[
      NCache[
       Rational[3967, 14307], 0.2772768574823513]], AbsoluteThickness[0.25], 
     LineBox[{3967, 3968}]}, 
    {Hue[
      NCache[
       Rational[3968, 14307], 0.27734675333752706`]], AbsoluteThickness[0.25],
      LineBox[{3968, 3969}]}, 
    {Hue[
      NCache[
       Rational[1323, 4769], 0.27741664919270287`]], AbsoluteThickness[0.25], 
     LineBox[{3969, 3970}]}, 
    {Hue[
      NCache[
       Rational[3970, 14307], 0.2774865450478787]], AbsoluteThickness[0.25], 
     LineBox[{3970, 3971}]}, 
    {Hue[
      NCache[
       Rational[209, 753], 0.2775564409030544]], AbsoluteThickness[0.25], 
     LineBox[{3971, 3972}]}, 
    {Hue[
      NCache[
       Rational[1324, 4769], 0.27762633675823023`]], AbsoluteThickness[0.25], 
     LineBox[{3972, 3973}]}, 
    {Hue[
      NCache[
       Rational[3973, 14307], 0.27769623261340604`]], AbsoluteThickness[0.25],
      LineBox[{3973, 3974}]}, 
    {Hue[
      NCache[
       Rational[3974, 14307], 0.2777661284685818]], AbsoluteThickness[0.25], 
     LineBox[{3974, 3975}]}, 
    {Hue[
      NCache[
       Rational[1325, 4769], 0.2778360243237576]], AbsoluteThickness[0.25], 
     LineBox[{3975, 3976}]}, 
    {Hue[
      NCache[
       Rational[3976, 14307], 0.2779059201789334]], AbsoluteThickness[0.25], 
     LineBox[{3976, 3977}]}, 
    {Hue[
      NCache[
       Rational[3977, 14307], 0.2779758160341092]], AbsoluteThickness[0.25], 
     LineBox[{3977, 3978}]}, 
    {Hue[
      NCache[
       Rational[1326, 4769], 0.27804571188928495`]], AbsoluteThickness[0.25], 
     LineBox[{3978, 3979}]}, 
    {Hue[
      NCache[
       Rational[3979, 14307], 0.27811560774446076`]], AbsoluteThickness[0.25],
      LineBox[{3979, 3980}]}, 
    {Hue[
      NCache[
       Rational[3980, 14307], 0.27818550359963656`]], AbsoluteThickness[0.25],
      LineBox[{3980, 3981}]}, 
    {Hue[
      NCache[
       Rational[1327, 4769], 0.2782553994548123]], AbsoluteThickness[0.25], 
     LineBox[{3981, 3982}]}, 
    {Hue[
      NCache[
       Rational[3982, 14307], 0.2783252953099881]], AbsoluteThickness[0.25], 
     LineBox[{3982, 3983}]}, 
    {Hue[
      NCache[
       Rational[3983, 14307], 0.2783951911651639]], AbsoluteThickness[0.25], 
     LineBox[{3983, 3984}]}, 
    {Hue[
      NCache[
       Rational[1328, 4769], 0.2784650870203397]], AbsoluteThickness[0.25], 
     LineBox[{3984, 3985}]}, 
    {Hue[
      NCache[
       Rational[3985, 14307], 0.2785349828755155]], AbsoluteThickness[0.25], 
     LineBox[{3985, 3986}]}, 
    {Hue[
      NCache[
       Rational[3986, 14307], 0.2786048787306913]], AbsoluteThickness[0.25], 
     LineBox[{3986, 3987}]}, 
    {Hue[
      NCache[
       Rational[1329, 4769], 0.27867477458586704`]], AbsoluteThickness[0.25], 
     LineBox[{3987, 3988}]}, 
    {Hue[
      NCache[
       Rational[3988, 14307], 0.27874467044104284`]], AbsoluteThickness[0.25],
      LineBox[{3988, 3989}]}, 
    {Hue[
      NCache[
       Rational[3989, 14307], 0.27881456629621865`]], AbsoluteThickness[0.25],
      LineBox[{3989, 3990}]}, 
    {Hue[
      NCache[
       Rational[70, 251], 0.2788844621513944]], AbsoluteThickness[0.25], 
     LineBox[{3990, 3991}]}, 
    {Hue[
      NCache[
       Rational[3991, 14307], 0.2789543580065702]], AbsoluteThickness[0.25], 
     LineBox[{3991, 3992}]}, 
    {Hue[
      NCache[
       Rational[3992, 14307], 0.279024253861746]], AbsoluteThickness[0.25], 
     LineBox[{3992, 3993}]}, 
    {Hue[
      NCache[
       Rational[1331, 4769], 0.2790941497169218]], AbsoluteThickness[0.25], 
     LineBox[{3993, 3994}]}, 
    {Hue[
      NCache[
       Rational[3994, 14307], 0.27916404557209756`]], AbsoluteThickness[0.25],
      LineBox[{3994, 3995}]}, 
    {Hue[
      NCache[
       Rational[3995, 14307], 0.27923394142727337`]], AbsoluteThickness[0.25],
      LineBox[{3995, 3996}]}, 
    {Hue[
      NCache[
       Rational[1332, 4769], 0.2793038372824492]], AbsoluteThickness[0.25], 
     LineBox[{3996, 3997}]}, 
    {Hue[
      NCache[
       Rational[3997, 14307], 0.2793737331376249]], AbsoluteThickness[0.25], 
     LineBox[{3997, 3998}]}, 
    {Hue[
      NCache[
       Rational[3998, 14307], 0.27944362899280073`]], AbsoluteThickness[0.25],
      LineBox[{3998, 3999}]}, 
    {Hue[
      NCache[
       Rational[1333, 4769], 0.27951352484797654`]], AbsoluteThickness[0.25], 
     LineBox[{3999, 4000}]}, 
    {Hue[
      NCache[
       Rational[4000, 14307], 0.2795834207031523]], AbsoluteThickness[0.25], 
     LineBox[{4000, 4001}]}, 
    {Hue[
      NCache[
       Rational[4001, 14307], 0.2796533165583281]], AbsoluteThickness[0.25], 
     LineBox[{4001, 4002}]}, 
    {Hue[
      NCache[
       Rational[1334, 4769], 0.2797232124135039]], AbsoluteThickness[0.25], 
     LineBox[{4002, 4003}]}, 
    {Hue[
      NCache[
       Rational[4003, 14307], 0.27979310826867965`]], AbsoluteThickness[0.25],
      LineBox[{4003, 4004}]}, 
    {Hue[
      NCache[
       Rational[4004, 14307], 0.27986300412385545`]], AbsoluteThickness[0.25],
      LineBox[{4004, 4005}]}, 
    {Hue[
      NCache[
       Rational[1335, 4769], 0.27993289997903126`]], AbsoluteThickness[0.25], 
     LineBox[{4005, 4006}]}, 
    {Hue[
      NCache[
       Rational[4006, 14307], 0.280002795834207]], AbsoluteThickness[0.25], 
     LineBox[{4006, 4007}]}, 
    {Hue[
      NCache[
       Rational[4007, 14307], 0.2800726916893828]], AbsoluteThickness[0.25], 
     LineBox[{4007, 4008}]}, 
    {Hue[
      NCache[
       Rational[1336, 4769], 0.2801425875445586]], AbsoluteThickness[0.25], 
     LineBox[{4008, 4009}]}, 
    {Hue[
      NCache[
       Rational[211, 753], 0.28021248339973437`]], AbsoluteThickness[0.25], 
     LineBox[{4009, 4010}]}, 
    {Hue[
      NCache[
       Rational[4010, 14307], 0.2802823792549102]], AbsoluteThickness[0.25], 
     LineBox[{4010, 4011}]}, 
    {Hue[
      NCache[
       Rational[1337, 4769], 0.280352275110086]], AbsoluteThickness[0.25], 
     LineBox[{4011, 4012}]}, 
    {Hue[
      NCache[
       Rational[4012, 14307], 0.2804221709652618]], AbsoluteThickness[0.25], 
     LineBox[{4012, 4013}]}, 
    {Hue[
      NCache[
       Rational[4013, 14307], 0.28049206682043754`]], AbsoluteThickness[0.25],
      LineBox[{4013, 4014}]}, 
    {Hue[
      NCache[
       Rational[1338, 4769], 0.28056196267561334`]], AbsoluteThickness[0.25], 
     LineBox[{4014, 4015}]}, 
    {Hue[
      NCache[
       Rational[4015, 14307], 0.28063185853078915`]], AbsoluteThickness[0.25],
      LineBox[{4015, 4016}]}, 
    {Hue[
      NCache[
       Rational[16, 57], 0.2807017543859649]], AbsoluteThickness[0.25], 
     LineBox[{4016, 4017}]}, 
    {Hue[
      NCache[
       Rational[1339, 4769], 0.2807716502411407]], AbsoluteThickness[0.25], 
     LineBox[{4017, 4018}]}, 
    {Hue[
      NCache[
       Rational[4018, 14307], 0.2808415460963165]], AbsoluteThickness[0.25], 
     LineBox[{4018, 4019}]}, 
    {Hue[
      NCache[
       Rational[4019, 14307], 0.28091144195149226`]], AbsoluteThickness[0.25],
      LineBox[{4019, 4020}]}, 
    {Hue[
      NCache[
       Rational[1340, 4769], 0.28098133780666806`]], AbsoluteThickness[0.25], 
     LineBox[{4020, 4021}]}, 
    {Hue[
      NCache[
       Rational[4021, 14307], 0.28105123366184387`]], AbsoluteThickness[0.25],
      LineBox[{4021, 4022}]}, 
    {Hue[
      NCache[
       Rational[4022, 14307], 0.2811211295170196]], AbsoluteThickness[0.25], 
     LineBox[{4022, 4023}]}, 
    {Hue[
      NCache[
       Rational[1341, 4769], 0.2811910253721954]], AbsoluteThickness[0.25], 
     LineBox[{4023, 4024}]}, 
    {Hue[
      NCache[
       Rational[4024, 14307], 0.28126092122737123`]], AbsoluteThickness[0.25],
      LineBox[{4024, 4025}]}, 
    {Hue[
      NCache[
       Rational[4025, 14307], 0.281330817082547]], AbsoluteThickness[0.25], 
     LineBox[{4025, 4026}]}, 
    {Hue[
      NCache[
       Rational[1342, 4769], 0.2814007129377228]], AbsoluteThickness[0.25], 
     LineBox[{4026, 4027}]}, 
    {Hue[
      NCache[
       Rational[4027, 14307], 0.2814706087928986]], AbsoluteThickness[0.25], 
     LineBox[{4027, 4028}]}, 
    {Hue[
      NCache[
       Rational[212, 753], 0.2815405046480744]], AbsoluteThickness[0.25], 
     LineBox[{4028, 4029}]}, 
    {Hue[
      NCache[
       Rational[1343, 4769], 0.28161040050325015`]], AbsoluteThickness[0.25], 
     LineBox[{4029, 4030}]}, 
    {Hue[
      NCache[
       Rational[4030, 14307], 0.28168029635842595`]], AbsoluteThickness[0.25],
      LineBox[{4030, 4031}]}, 
    {Hue[
      NCache[
       Rational[4031, 14307], 0.28175019221360176`]], AbsoluteThickness[0.25],
      LineBox[{4031, 4032}]}, 
    {Hue[
      NCache[
       Rational[1344, 4769], 0.2818200880687775]], AbsoluteThickness[0.25], 
     LineBox[{4032, 4033}]}, 
    {Hue[
      NCache[
       Rational[4033, 14307], 0.2818899839239533]], AbsoluteThickness[0.25], 
     LineBox[{4033, 4034}]}, 
    {Hue[
      NCache[
       Rational[4034, 14307], 0.2819598797791291]], AbsoluteThickness[0.25], 
     LineBox[{4034, 4035}]}, 
    {Hue[
      NCache[
       Rational[1345, 4769], 0.28202977563430487`]], AbsoluteThickness[0.25], 
     LineBox[{4035, 4036}]}, 
    {Hue[
      NCache[
       Rational[4036, 14307], 0.2820996714894807]], AbsoluteThickness[0.25], 
     LineBox[{4036, 4037}]}, 
    {Hue[
      NCache[
       Rational[4037, 14307], 0.2821695673446565]], AbsoluteThickness[0.25], 
     LineBox[{4037, 4038}]}, 
    {Hue[
      NCache[
       Rational[1346, 4769], 0.28223946319983223`]], AbsoluteThickness[0.25], 
     LineBox[{4038, 4039}]}, 
    {Hue[
      NCache[
       Rational[4039, 14307], 0.28230935905500804`]], AbsoluteThickness[0.25],
      LineBox[{4039, 4040}]}, 
    {Hue[
      NCache[
       Rational[4040, 14307], 0.28237925491018384`]], AbsoluteThickness[0.25],
      LineBox[{4040, 4041}]}, 
    {Hue[
      NCache[
       Rational[1347, 4769], 0.2824491507653596]], AbsoluteThickness[0.25], 
     LineBox[{4041, 4042}]}, 
    {Hue[
      NCache[
       Rational[4042, 14307], 0.2825190466205354]], AbsoluteThickness[0.25], 
     LineBox[{4042, 4043}]}, 
    {Hue[
      NCache[
       Rational[4043, 14307], 0.2825889424757112]], AbsoluteThickness[0.25], 
     LineBox[{4043, 4044}]}, 
    {Hue[
      NCache[
       Rational[1348, 4769], 0.28265883833088695`]], AbsoluteThickness[0.25], 
     LineBox[{4044, 4045}]}, 
    {Hue[
      NCache[
       Rational[4045, 14307], 0.28272873418606276`]], AbsoluteThickness[0.25],
      LineBox[{4045, 4046}]}, 
    {Hue[
      NCache[
       Rational[4046, 14307], 0.28279863004123856`]], AbsoluteThickness[0.25],
      LineBox[{4046, 4047}]}, 
    {Hue[
      NCache[
       Rational[71, 251], 0.28286852589641437`]], AbsoluteThickness[0.25], 
     LineBox[{4047, 4048}]}, 
    {Hue[
      NCache[
       Rational[4048, 14307], 0.2829384217515901]], AbsoluteThickness[0.25], 
     LineBox[{4048, 4049}]}, 
    {Hue[
      NCache[
       Rational[4049, 14307], 0.2830083176067659]], AbsoluteThickness[0.25], 
     LineBox[{4049, 4050}]}, 
    {Hue[
      NCache[
       Rational[1350, 4769], 0.28307821346194173`]], AbsoluteThickness[0.25], 
     LineBox[{4050, 4051}]}, 
    {Hue[
      NCache[
       Rational[4051, 14307], 0.2831481093171175]], AbsoluteThickness[0.25], 
     LineBox[{4051, 4052}]}, 
    {Hue[
      NCache[
       Rational[4052, 14307], 0.2832180051722933]], AbsoluteThickness[0.25], 
     LineBox[{4052, 4053}]}, 
    {Hue[
      NCache[
       Rational[1351, 4769], 0.2832879010274691]], AbsoluteThickness[0.25], 
     LineBox[{4053, 4054}]}, 
    {Hue[
      NCache[
       Rational[4054, 14307], 0.28335779688264484`]], AbsoluteThickness[0.25],
      LineBox[{4054, 4055}]}, 
    {Hue[
      NCache[
       Rational[4055, 14307], 0.28342769273782065`]], AbsoluteThickness[0.25],
      LineBox[{4055, 4056}]}, 
    {Hue[
      NCache[
       Rational[1352, 4769], 0.28349758859299645`]], AbsoluteThickness[0.25], 
     LineBox[{4056, 4057}]}, 
    {Hue[
      NCache[
       Rational[4057, 14307], 0.2835674844481722]], AbsoluteThickness[0.25], 
     LineBox[{4057, 4058}]}, 
    {Hue[
      NCache[
       Rational[4058, 14307], 0.283637380303348]], AbsoluteThickness[0.25], 
     LineBox[{4058, 4059}]}, 
    {Hue[
      NCache[
       Rational[1353, 4769], 0.2837072761585238]], AbsoluteThickness[0.25], 
     LineBox[{4059, 4060}]}, 
    {Hue[
      NCache[
       Rational[4060, 14307], 0.28377717201369956`]], AbsoluteThickness[0.25],
      LineBox[{4060, 4061}]}, 
    {Hue[
      NCache[
       Rational[4061, 14307], 0.28384706786887537`]], AbsoluteThickness[0.25],
      LineBox[{4061, 4062}]}, 
    {Hue[
      NCache[
       Rational[1354, 4769], 0.2839169637240512]], AbsoluteThickness[0.25], 
     LineBox[{4062, 4063}]}, 
    {Hue[
      NCache[
       Rational[4063, 14307], 0.2839868595792269]], AbsoluteThickness[0.25], 
     LineBox[{4063, 4064}]}, 
    {Hue[
      NCache[
       Rational[4064, 14307], 0.28405675543440273`]], AbsoluteThickness[0.25],
      LineBox[{4064, 4065}]}, 
    {Hue[
      NCache[
       Rational[1355, 4769], 0.28412665128957854`]], AbsoluteThickness[0.25], 
     LineBox[{4065, 4066}]}, 
    {Hue[
      NCache[
       Rational[214, 753], 0.28419654714475434`]], AbsoluteThickness[0.25], 
     LineBox[{4066, 4067}]}, 
    {Hue[
      NCache[
       Rational[4067, 14307], 0.2842664429999301]], AbsoluteThickness[0.25], 
     LineBox[{4067, 4068}]}, 
    {Hue[
      NCache[
       Rational[1356, 4769], 0.2843363388551059]], AbsoluteThickness[0.25], 
     LineBox[{4068, 4069}]}, 
    {Hue[
      NCache[
       Rational[4069, 14307], 0.2844062347102817]], AbsoluteThickness[0.25], 
     LineBox[{4069, 4070}]}, 
    {Hue[
      NCache[
       Rational[4070, 14307], 0.28447613056545745`]], AbsoluteThickness[0.25],
      LineBox[{4070, 4071}]}, 
    {Hue[
      NCache[
       Rational[1357, 4769], 0.28454602642063326`]], AbsoluteThickness[0.25], 
     LineBox[{4071, 4072}]}, 
    {Hue[
      NCache[
       Rational[4072, 14307], 0.28461592227580906`]], AbsoluteThickness[0.25],
      LineBox[{4072, 4073}]}, 
    {Hue[
      NCache[
       Rational[4073, 14307], 0.2846858181309848]], AbsoluteThickness[0.25], 
     LineBox[{4073, 4074}]}, 
    {Hue[
      NCache[
       Rational[1358, 4769], 0.2847557139861606]], AbsoluteThickness[0.25], 
     LineBox[{4074, 4075}]}, 
    {Hue[
      NCache[
       Rational[4075, 14307], 0.2848256098413364]], AbsoluteThickness[0.25], 
     LineBox[{4075, 4076}]}, 
    {Hue[
      NCache[
       Rational[4076, 14307], 0.2848955056965122]], AbsoluteThickness[0.25], 
     LineBox[{4076, 4077}]}, 
    {Hue[
      NCache[
       Rational[1359, 4769], 0.284965401551688]], AbsoluteThickness[0.25], 
     LineBox[{4077, 4078}]}, 
    {Hue[
      NCache[
       Rational[4078, 14307], 0.2850352974068638]], AbsoluteThickness[0.25], 
     LineBox[{4078, 4079}]}, 
    {Hue[
      NCache[
       Rational[4079, 14307], 0.28510519326203954`]], AbsoluteThickness[0.25],
      LineBox[{4079, 4080}]}, 
    {Hue[
      NCache[
       Rational[1360, 4769], 0.28517508911721534`]], AbsoluteThickness[0.25], 
     LineBox[{4080, 4081}]}, 
    {Hue[
      NCache[
       Rational[4081, 14307], 0.28524498497239115`]], AbsoluteThickness[0.25],
      LineBox[{4081, 4082}]}, 
    {Hue[
      NCache[
       Rational[4082, 14307], 0.28531488082756695`]], AbsoluteThickness[0.25],
      LineBox[{4082, 4083}]}, 
    {Hue[
      NCache[
       Rational[1361, 4769], 0.2853847766827427]], AbsoluteThickness[0.25], 
     LineBox[{4083, 4084}]}, 
    {Hue[
      NCache[
       Rational[4084, 14307], 0.2854546725379185]], AbsoluteThickness[0.25], 
     LineBox[{4084, 4085}]}, 
    {Hue[
      NCache[
       Rational[215, 753], 0.2855245683930943]], AbsoluteThickness[0.25], 
     LineBox[{4085, 4086}]}, 
    {Hue[
      NCache[
       Rational[1362, 4769], 0.28559446424827006`]], AbsoluteThickness[0.25], 
     LineBox[{4086, 4087}]}, 
    {Hue[
      NCache[
       Rational[4087, 14307], 0.28566436010344587`]], AbsoluteThickness[0.25],
      LineBox[{4087, 4088}]}, 
    {Hue[
      NCache[
       Rational[4088, 14307], 0.2857342559586217]], AbsoluteThickness[0.25], 
     LineBox[{4088, 4089}]}, 
    {Hue[
      NCache[
       Rational[1363, 4769], 0.2858041518137974]], AbsoluteThickness[0.25], 
     LineBox[{4089, 4090}]}, 
    {Hue[
      NCache[
       Rational[4090, 14307], 0.28587404766897323`]], AbsoluteThickness[0.25],
      LineBox[{4090, 4091}]}, 
    {Hue[
      NCache[
       Rational[4091, 14307], 0.28594394352414904`]], AbsoluteThickness[0.25],
      LineBox[{4091, 4092}]}, 
    {Hue[
      NCache[
       Rational[1364, 4769], 0.2860138393793248]], AbsoluteThickness[0.25], 
     LineBox[{4092, 4093}]}, 
    {Hue[
      NCache[
       Rational[4093, 14307], 0.2860837352345006]], AbsoluteThickness[0.25], 
     LineBox[{4093, 4094}]}, 
    {Hue[
      NCache[
       Rational[4094, 14307], 0.2861536310896764]], AbsoluteThickness[0.25], 
     LineBox[{4094, 4095}]}, 
    {Hue[
      NCache[
       Rational[1365, 4769], 0.28622352694485215`]], AbsoluteThickness[0.25], 
     LineBox[{4095, 4096}]}, 
    {Hue[
      NCache[
       Rational[4096, 14307], 0.28629342280002795`]], AbsoluteThickness[0.25],
      LineBox[{4096, 4097}]}, 
    {Hue[
      NCache[
       Rational[4097, 14307], 0.28636331865520376`]], AbsoluteThickness[0.25],
      LineBox[{4097, 4098}]}, 
    {Hue[
      NCache[
       Rational[1366, 4769], 0.2864332145103795]], AbsoluteThickness[0.25], 
     LineBox[{4098, 4099}]}, 
    {Hue[
      NCache[
       Rational[4099, 14307], 0.2865031103655553]], AbsoluteThickness[0.25], 
     LineBox[{4099, 4100}]}, 
    {Hue[
      NCache[
       Rational[4100, 14307], 0.2865730062207311]], AbsoluteThickness[0.25], 
     LineBox[{4100, 4101}]}, 
    {Hue[
      NCache[
       Rational[1367, 4769], 0.2866429020759069]], AbsoluteThickness[0.25], 
     LineBox[{4101, 4102}]}, 
    {Hue[
      NCache[
       Rational[4102, 14307], 0.2867127979310827]], AbsoluteThickness[0.25], 
     LineBox[{4102, 4103}]}, 
    {Hue[
      NCache[
       Rational[4103, 14307], 0.2867826937862585]], AbsoluteThickness[0.25], 
     LineBox[{4103, 4104}]}, 
    {Hue[
      NCache[
       Rational[72, 251], 0.2868525896414343]], AbsoluteThickness[0.25], 
     LineBox[{4104, 4105}]}, 
    {Hue[
      NCache[
       Rational[4105, 14307], 0.28692248549661004`]], AbsoluteThickness[0.25],
      LineBox[{4105, 4106}]}, 
    {Hue[
      NCache[
       Rational[4106, 14307], 0.28699238135178584`]], AbsoluteThickness[0.25],
      LineBox[{4106, 4107}]}, 
    {Hue[
      NCache[
       Rational[1369, 4769], 0.28706227720696165`]], AbsoluteThickness[0.25], 
     LineBox[{4107, 4108}]}, 
    {Hue[
      NCache[
       Rational[4108, 14307], 0.2871321730621374]], AbsoluteThickness[0.25], 
     LineBox[{4108, 4109}]}, 
    {Hue[
      NCache[
       Rational[4109, 14307], 0.2872020689173132]], AbsoluteThickness[0.25], 
     LineBox[{4109, 4110}]}, 
    {Hue[
      NCache[
       Rational[1370, 4769], 0.287271964772489]], AbsoluteThickness[0.25], 
     LineBox[{4110, 4111}]}, 
    {Hue[
      NCache[
       Rational[4111, 14307], 0.28734186062766476`]], AbsoluteThickness[0.25],
      LineBox[{4111, 4112}]}, 
    {Hue[
      NCache[
       Rational[4112, 14307], 0.28741175648284056`]], AbsoluteThickness[0.25],
      LineBox[{4112, 4113}]}, 
    {Hue[
      NCache[
       Rational[1371, 4769], 0.28748165233801637`]], AbsoluteThickness[0.25], 
     LineBox[{4113, 4114}]}, 
    {Hue[
      NCache[
       Rational[4114, 14307], 0.2875515481931921]], AbsoluteThickness[0.25], 
     LineBox[{4114, 4115}]}, 
    {Hue[
      NCache[
       Rational[4115, 14307], 0.2876214440483679]], AbsoluteThickness[0.25], 
     LineBox[{4115, 4116}]}, 
    {Hue[
      NCache[
       Rational[1372, 4769], 0.28769133990354373`]], AbsoluteThickness[0.25], 
     LineBox[{4116, 4117}]}, 
    {Hue[
      NCache[
       Rational[4117, 14307], 0.2877612357587195]], AbsoluteThickness[0.25], 
     LineBox[{4117, 4118}]}, 
    {Hue[
      NCache[
       Rational[4118, 14307], 0.2878311316138953]], AbsoluteThickness[0.25], 
     LineBox[{4118, 4119}]}, 
    {Hue[
      NCache[
       Rational[1373, 4769], 0.2879010274690711]], AbsoluteThickness[0.25], 
     LineBox[{4119, 4120}]}, 
    {Hue[
      NCache[
       Rational[4120, 14307], 0.2879709233242469]], AbsoluteThickness[0.25], 
     LineBox[{4120, 4121}]}, 
    {Hue[
      NCache[
       Rational[4121, 14307], 0.28804081917942265`]], AbsoluteThickness[0.25],
      LineBox[{4121, 4122}]}, 
    {Hue[
      NCache[
       Rational[1374, 4769], 0.28811071503459845`]], AbsoluteThickness[0.25], 
     LineBox[{4122, 4123}]}, 
    {Hue[
      NCache[
       Rational[217, 753], 0.28818061088977426`]], AbsoluteThickness[0.25], 
     LineBox[{4123, 4124}]}, 
    {Hue[
      NCache[
       Rational[4124, 14307], 0.28825050674495]], AbsoluteThickness[0.25], 
     LineBox[{4124, 4125}]}, 
    {Hue[
      NCache[
       Rational[1375, 4769], 0.2883204026001258]], AbsoluteThickness[0.25], 
     LineBox[{4125, 4126}]}, 
    {Hue[
      NCache[
       Rational[4126, 14307], 0.2883902984553016]], AbsoluteThickness[0.25], 
     LineBox[{4126, 4127}]}, 
    {Hue[
      NCache[
       Rational[4127, 14307], 0.28846019431047737`]], AbsoluteThickness[0.25],
      LineBox[{4127, 4128}]}, 
    {Hue[
      NCache[
       Rational[1376, 4769], 0.2885300901656532]], AbsoluteThickness[0.25], 
     LineBox[{4128, 4129}]}, 
    {Hue[
      NCache[
       Rational[4129, 14307], 0.288599986020829]], AbsoluteThickness[0.25], 
     LineBox[{4129, 4130}]}, 
    {Hue[
      NCache[
       Rational[4130, 14307], 0.28866988187600473`]], AbsoluteThickness[0.25],
      LineBox[{4130, 4131}]}, 
    {Hue[
      NCache[
       Rational[1377, 4769], 0.28873977773118054`]], AbsoluteThickness[0.25], 
     LineBox[{4131, 4132}]}, 
    {Hue[
      NCache[
       Rational[4132, 14307], 0.28880967358635634`]], AbsoluteThickness[0.25],
      LineBox[{4132, 4133}]}, 
    {Hue[
      NCache[
       Rational[4133, 14307], 0.2888795694415321]], AbsoluteThickness[0.25], 
     LineBox[{4133, 4134}]}, 
    {Hue[
      NCache[
       Rational[1378, 4769], 0.2889494652967079]], AbsoluteThickness[0.25], 
     LineBox[{4134, 4135}]}, 
    {Hue[
      NCache[
       Rational[4135, 14307], 0.2890193611518837]], AbsoluteThickness[0.25], 
     LineBox[{4135, 4136}]}, 
    {Hue[
      NCache[
       Rational[4136, 14307], 0.2890892570070595]], AbsoluteThickness[0.25], 
     LineBox[{4136, 4137}]}, 
    {Hue[
      NCache[
       Rational[1379, 4769], 0.28915915286223526`]], AbsoluteThickness[0.25], 
     LineBox[{4137, 4138}]}, 
    {Hue[
      NCache[
       Rational[4138, 14307], 0.28922904871741106`]], AbsoluteThickness[0.25],
      LineBox[{4138, 4139}]}, 
    {Hue[
      NCache[
       Rational[4139, 14307], 0.28929894457258687`]], AbsoluteThickness[0.25],
      LineBox[{4139, 4140}]}, 
    {Hue[
      NCache[
       Rational[1380, 4769], 0.2893688404277626]], AbsoluteThickness[0.25], 
     LineBox[{4140, 4141}]}, 
    {Hue[
      NCache[
       Rational[4141, 14307], 0.2894387362829384]], AbsoluteThickness[0.25], 
     LineBox[{4141, 4142}]}, 
    {Hue[
      NCache[
       Rational[218, 753], 0.28950863213811423`]], AbsoluteThickness[0.25], 
     LineBox[{4142, 4143}]}, 
    {Hue[
      NCache[
       Rational[1381, 4769], 0.28957852799329]], AbsoluteThickness[0.25], 
     LineBox[{4143, 4144}]}, 
    {Hue[
      NCache[
       Rational[4144, 14307], 0.2896484238484658]], AbsoluteThickness[0.25], 
     LineBox[{4144, 4145}]}, 
    {Hue[
      NCache[
       Rational[4145, 14307], 0.2897183197036416]], AbsoluteThickness[0.25], 
     LineBox[{4145, 4146}]}, 
    {Hue[
      NCache[
       Rational[1382, 4769], 0.28978821555881734`]], AbsoluteThickness[0.25], 
     LineBox[{4146, 4147}]}, 
    {Hue[
      NCache[
       Rational[4147, 14307], 0.28985811141399315`]], AbsoluteThickness[0.25],
      LineBox[{4147, 4148}]}, 
    {Hue[
      NCache[
       Rational[4148, 14307], 0.28992800726916895`]], AbsoluteThickness[0.25],
      LineBox[{4148, 4149}]}, 
    {Hue[
      NCache[
       Rational[1383, 4769], 0.2899979031243447]], AbsoluteThickness[0.25], 
     LineBox[{4149, 4150}]}, 
    {Hue[
      NCache[
       Rational[4150, 14307], 0.2900677989795205]], AbsoluteThickness[0.25], 
     LineBox[{4150, 4151}]}, 
    {Hue[
      NCache[
       Rational[4151, 14307], 0.2901376948346963]], AbsoluteThickness[0.25], 
     LineBox[{4151, 4152}]}, 
    {Hue[
      NCache[
       Rational[1384, 4769], 0.29020759068987206`]], AbsoluteThickness[0.25], 
     LineBox[{4152, 4153}]}, 
    {Hue[
      NCache[
       Rational[4153, 14307], 0.29027748654504787`]], AbsoluteThickness[0.25],
      LineBox[{4153, 4154}]}, 
    {Hue[
      NCache[
       Rational[4154, 14307], 0.2903473824002237]], AbsoluteThickness[0.25], 
     LineBox[{4154, 4155}]}, 
    {Hue[
      NCache[
       Rational[1385, 4769], 0.2904172782553995]], AbsoluteThickness[0.25], 
     LineBox[{4155, 4156}]}, 
    {Hue[
      NCache[
       Rational[4156, 14307], 0.29048717411057523`]], AbsoluteThickness[0.25],
      LineBox[{4156, 4157}]}, 
    {Hue[
      NCache[
       Rational[4157, 14307], 0.29055706996575104`]], AbsoluteThickness[0.25],
      LineBox[{4157, 4158}]}, 
    {Hue[
      NCache[
       Rational[1386, 4769], 0.29062696582092684`]], AbsoluteThickness[0.25], 
     LineBox[{4158, 4159}]}, 
    {Hue[
      NCache[
       Rational[4159, 14307], 0.2906968616761026]], AbsoluteThickness[0.25], 
     LineBox[{4159, 4160}]}, 
    {Hue[
      NCache[
       Rational[4160, 14307], 0.2907667575312784]], AbsoluteThickness[0.25], 
     LineBox[{4160, 4161}]}, 
    {Hue[
      NCache[
       Rational[73, 251], 0.2908366533864542]], AbsoluteThickness[0.25], 
     LineBox[{4161, 4162}]}, 
    {Hue[
      NCache[
       Rational[4162, 14307], 0.29090654924162995`]], AbsoluteThickness[0.25],
      LineBox[{4162, 4163}]}, 
    {Hue[
      NCache[
       Rational[4163, 14307], 0.29097644509680576`]], AbsoluteThickness[0.25],
      LineBox[{4163, 4164}]}, 
    {Hue[
      NCache[
       Rational[1388, 4769], 0.29104634095198156`]], AbsoluteThickness[0.25], 
     LineBox[{4164, 4165}]}, 
    {Hue[
      NCache[
       Rational[4165, 14307], 0.2911162368071573]], AbsoluteThickness[0.25], 
     LineBox[{4165, 4166}]}, 
    {Hue[
      NCache[
       Rational[4166, 14307], 0.2911861326623331]], AbsoluteThickness[0.25], 
     LineBox[{4166, 4167}]}, 
    {Hue[
      NCache[
       Rational[1389, 4769], 0.2912560285175089]], AbsoluteThickness[0.25], 
     LineBox[{4167, 4168}]}, 
    {Hue[
      NCache[
       Rational[4168, 14307], 0.2913259243726847]], AbsoluteThickness[0.25], 
     LineBox[{4168, 4169}]}, 
    {Hue[
      NCache[
       Rational[4169, 14307], 0.2913958202278605]], AbsoluteThickness[0.25], 
     LineBox[{4169, 4170}]}, 
    {Hue[
      NCache[
       Rational[1390, 4769], 0.2914657160830363]], AbsoluteThickness[0.25], 
     LineBox[{4170, 4171}]}, 
    {Hue[
      NCache[
       Rational[4171, 14307], 0.2915356119382121]], AbsoluteThickness[0.25], 
     LineBox[{4171, 4172}]}, 
    {Hue[
      NCache[
       Rational[4172, 14307], 0.29160550779338784`]], AbsoluteThickness[0.25],
      LineBox[{4172, 4173}]}, 
    {Hue[
      NCache[
       Rational[1391, 4769], 0.29167540364856365`]], AbsoluteThickness[0.25], 
     LineBox[{4173, 4174}]}, 
    {Hue[
      NCache[
       Rational[4174, 14307], 0.29174529950373945`]], AbsoluteThickness[0.25],
      LineBox[{4174, 4175}]}, 
    {Hue[
      NCache[
       Rational[4175, 14307], 0.2918151953589152]], AbsoluteThickness[0.25], 
     LineBox[{4175, 4176}]}, 
    {Hue[
      NCache[
       Rational[1392, 4769], 0.291885091214091]], AbsoluteThickness[0.25], 
     LineBox[{4176, 4177}]}, 
    {Hue[
      NCache[
       Rational[4177, 14307], 0.2919549870692668]], AbsoluteThickness[0.25], 
     LineBox[{4177, 4178}]}, 
    {Hue[
      NCache[
       Rational[4178, 14307], 0.29202488292444256`]], AbsoluteThickness[0.25],
      LineBox[{4178, 4179}]}, 
    {Hue[
      NCache[
       Rational[1393, 4769], 0.29209477877961837`]], AbsoluteThickness[0.25], 
     LineBox[{4179, 4180}]}, 
    {Hue[
      NCache[
       Rational[220, 753], 0.2921646746347942]], AbsoluteThickness[0.25], 
     LineBox[{4180, 4181}]}, 
    {Hue[
      NCache[
       Rational[4181, 14307], 0.2922345704899699]], AbsoluteThickness[0.25], 
     LineBox[{4181, 4182}]}, 
    {Hue[
      NCache[
       Rational[1394, 4769], 0.29230446634514573`]], AbsoluteThickness[0.25], 
     LineBox[{4182, 4183}]}, 
    {Hue[
      NCache[
       Rational[4183, 14307], 0.29237436220032154`]], AbsoluteThickness[0.25],
      LineBox[{4183, 4184}]}, 
    {Hue[
      NCache[
       Rational[4184, 14307], 0.2924442580554973]], AbsoluteThickness[0.25], 
     LineBox[{4184, 4185}]}, 
    {Hue[
      NCache[
       Rational[1395, 4769], 0.2925141539106731]], AbsoluteThickness[0.25], 
     LineBox[{4185, 4186}]}, 
    {Hue[
      NCache[
       Rational[4186, 14307], 0.2925840497658489]], AbsoluteThickness[0.25], 
     LineBox[{4186, 4187}]}, 
    {Hue[
      NCache[
       Rational[4187, 14307], 0.29265394562102465`]], AbsoluteThickness[0.25],
      LineBox[{4187, 4188}]}, 
    {Hue[
      NCache[
       Rational[1396, 4769], 0.29272384147620045`]], AbsoluteThickness[0.25], 
     LineBox[{4188, 4189}]}, 
    {Hue[
      NCache[
       Rational[4189, 14307], 0.29279373733137626`]], AbsoluteThickness[0.25],
      LineBox[{4189, 4190}]}, 
    {Hue[
      NCache[
       Rational[4190, 14307], 0.29286363318655206`]], AbsoluteThickness[0.25],
      LineBox[{4190, 4191}]}, 
    {Hue[
      NCache[
       Rational[1397, 4769], 0.2929335290417278]], AbsoluteThickness[0.25], 
     LineBox[{4191, 4192}]}, 
    {Hue[
      NCache[
       Rational[4192, 14307], 0.2930034248969036]], AbsoluteThickness[0.25], 
     LineBox[{4192, 4193}]}, 
    {Hue[
      NCache[
       Rational[4193, 14307], 0.2930733207520794]], AbsoluteThickness[0.25], 
     LineBox[{4193, 4194}]}, 
    {Hue[
      NCache[
       Rational[1398, 4769], 0.2931432166072552]], AbsoluteThickness[0.25], 
     LineBox[{4194, 4195}]}, 
    {Hue[
      NCache[
       Rational[4195, 14307], 0.293213112462431]], AbsoluteThickness[0.25], 
     LineBox[{4195, 4196}]}, 
    {Hue[
      NCache[
       Rational[4196, 14307], 0.2932830083176068]], AbsoluteThickness[0.25], 
     LineBox[{4196, 4197}]}, 
    {Hue[
      NCache[
       Rational[1399, 4769], 0.29335290417278254`]], AbsoluteThickness[0.25], 
     LineBox[{4197, 4198}]}, 
    {Hue[
      NCache[
       Rational[4198, 14307], 0.29342280002795834`]], AbsoluteThickness[0.25],
      LineBox[{4198, 4199}]}, 
    {Hue[
      NCache[
       Rational[221, 753], 0.29349269588313415`]], AbsoluteThickness[0.25], 
     LineBox[{4199, 4200}]}, 
    {Hue[
      NCache[
       Rational[1400, 4769], 0.2935625917383099]], AbsoluteThickness[0.25], 
     LineBox[{4200, 4201}]}, 
    {Hue[
      NCache[
       Rational[4201, 14307], 0.2936324875934857]], AbsoluteThickness[0.25], 
     LineBox[{4201, 4202}]}, 
    {Hue[
      NCache[
       Rational[4202, 14307], 0.2937023834486615]], AbsoluteThickness[0.25], 
     LineBox[{4202, 4203}]}, 
    {Hue[
      NCache[
       Rational[1401, 4769], 0.29377227930383726`]], AbsoluteThickness[0.25], 
     LineBox[{4203, 4204}]}, 
    {Hue[
      NCache[
       Rational[4204, 14307], 0.29384217515901306`]], AbsoluteThickness[0.25],
      LineBox[{4204, 4205}]}, 
    {Hue[
      NCache[
       Rational[4205, 14307], 0.29391207101418887`]], AbsoluteThickness[0.25],
      LineBox[{4205, 4206}]}, 
    {Hue[
      NCache[
       Rational[1402, 4769], 0.2939819668693646]], AbsoluteThickness[0.25], 
     LineBox[{4206, 4207}]}, 
    {Hue[
      NCache[
       Rational[4207, 14307], 0.2940518627245404]], AbsoluteThickness[0.25], 
     LineBox[{4207, 4208}]}, 
    {Hue[
      NCache[
       Rational[4208, 14307], 0.29412175857971623`]], AbsoluteThickness[0.25],
      LineBox[{4208, 4209}]}, 
    {Hue[
      NCache[
       Rational[1403, 4769], 0.29419165443489204`]], AbsoluteThickness[0.25], 
     LineBox[{4209, 4210}]}, 
    {Hue[
      NCache[
       Rational[4210, 14307], 0.2942615502900678]], AbsoluteThickness[0.25], 
     LineBox[{4210, 4211}]}, 
    {Hue[
      NCache[
       Rational[4211, 14307], 0.2943314461452436]], AbsoluteThickness[0.25], 
     LineBox[{4211, 4212}]}, 
    {Hue[
      NCache[
       Rational[1404, 4769], 0.2944013420004194]], AbsoluteThickness[0.25], 
     LineBox[{4212, 4213}]}, 
    {Hue[
      NCache[
       Rational[4213, 14307], 0.29447123785559515`]], AbsoluteThickness[0.25],
      LineBox[{4213, 4214}]}, 
    {Hue[
      NCache[
       Rational[4214, 14307], 0.29454113371077095`]], AbsoluteThickness[0.25],
      LineBox[{4214, 4215}]}, 
    {Hue[
      NCache[
       Rational[1405, 4769], 0.29461102956594676`]], AbsoluteThickness[0.25], 
     LineBox[{4215, 4216}]}, 
    {Hue[
      NCache[
       Rational[4216, 14307], 0.2946809254211225]], AbsoluteThickness[0.25], 
     LineBox[{4216, 4217}]}, 
    {Hue[
      NCache[
       Rational[4217, 14307], 0.2947508212762983]], AbsoluteThickness[0.25], 
     LineBox[{4217, 4218}]}, 
    {Hue[
      NCache[
       Rational[74, 251], 0.2948207171314741]], AbsoluteThickness[0.25], 
     LineBox[{4218, 4219}]}, 
    {Hue[
      NCache[
       Rational[4219, 14307], 0.29489061298664987`]], AbsoluteThickness[0.25],
      LineBox[{4219, 4220}]}, 
    {Hue[
      NCache[
       Rational[4220, 14307], 0.2949605088418257]], AbsoluteThickness[0.25], 
     LineBox[{4220, 4221}]}, 
    {Hue[
      NCache[
       Rational[1407, 4769], 0.2950304046970015]], AbsoluteThickness[0.25], 
     LineBox[{4221, 4222}]}, 
    {Hue[
      NCache[
       Rational[4222, 14307], 0.29510030055217723`]], AbsoluteThickness[0.25],
      LineBox[{4222, 4223}]}, 
    {Hue[
      NCache[
       Rational[4223, 14307], 0.29517019640735304`]], AbsoluteThickness[0.25],
      LineBox[{4223, 4224}]}, 
    {Hue[
      NCache[
       Rational[1408, 4769], 0.29524009226252884`]], AbsoluteThickness[0.25], 
     LineBox[{4224, 4225}]}, 
    {Hue[
      NCache[
       Rational[4225, 14307], 0.29530998811770465`]], AbsoluteThickness[0.25],
      LineBox[{4225, 4226}]}, 
    {Hue[
      NCache[
       Rational[4226, 14307], 0.2953798839728804]], AbsoluteThickness[0.25], 
     LineBox[{4226, 4227}]}, 
    {Hue[
      NCache[
       Rational[1409, 4769], 0.2954497798280562]], AbsoluteThickness[0.25], 
     LineBox[{4227, 4228}]}, 
    {Hue[
      NCache[
       Rational[4228, 14307], 0.295519675683232]], AbsoluteThickness[0.25], 
     LineBox[{4228, 4229}]}, 
    {Hue[
      NCache[
       Rational[4229, 14307], 0.29558957153840776`]], AbsoluteThickness[0.25],
      LineBox[{4229, 4230}]}, 
    {Hue[
      NCache[
       Rational[1410, 4769], 0.29565946739358356`]], AbsoluteThickness[0.25], 
     LineBox[{4230, 4231}]}, 
    {Hue[
      NCache[
       Rational[4231, 14307], 0.29572936324875937`]], AbsoluteThickness[0.25],
      LineBox[{4231, 4232}]}, 
    {Hue[
      NCache[
       Rational[4232, 14307], 0.2957992591039351]], AbsoluteThickness[0.25], 
     LineBox[{4232, 4233}]}, 
    {Hue[
      NCache[
       Rational[1411, 4769], 0.2958691549591109]], AbsoluteThickness[0.25], 
     LineBox[{4233, 4234}]}, 
    {Hue[
      NCache[
       Rational[4234, 14307], 0.29593905081428673`]], AbsoluteThickness[0.25],
      LineBox[{4234, 4235}]}, 
    {Hue[
      NCache[
       Rational[4235, 14307], 0.2960089466694625]], AbsoluteThickness[0.25], 
     LineBox[{4235, 4236}]}, 
    {Hue[
      NCache[
       Rational[1412, 4769], 0.2960788425246383]], AbsoluteThickness[0.25], 
     LineBox[{4236, 4237}]}, 
    {Hue[
      NCache[
       Rational[223, 753], 0.2961487383798141]], AbsoluteThickness[0.25], 
     LineBox[{4237, 4238}]}, 
    {Hue[
      NCache[
       Rational[4238, 14307], 0.29621863423498984`]], AbsoluteThickness[0.25],
      LineBox[{4238, 4239}]}, 
    {Hue[
      NCache[
       Rational[1413, 4769], 0.29628853009016565`]], AbsoluteThickness[0.25], 
     LineBox[{4239, 4240}]}, 
    {Hue[
      NCache[
       Rational[4240, 14307], 0.29635842594534145`]], AbsoluteThickness[0.25],
      LineBox[{4240, 4241}]}, 
    {Hue[
      NCache[
       Rational[4241, 14307], 0.2964283218005172]], AbsoluteThickness[0.25], 
     LineBox[{4241, 4242}]}, 
    {Hue[
      NCache[
       Rational[1414, 4769], 0.296498217655693]], AbsoluteThickness[0.25], 
     LineBox[{4242, 4243}]}, 
    {Hue[
      NCache[
       Rational[4243, 14307], 0.2965681135108688]], AbsoluteThickness[0.25], 
     LineBox[{4243, 4244}]}, 
    {Hue[
      NCache[
       Rational[4244, 14307], 0.2966380093660446]], AbsoluteThickness[0.25], 
     LineBox[{4244, 4245}]}, 
    {Hue[
      NCache[
       Rational[1415, 4769], 0.29670790522122037`]], AbsoluteThickness[0.25], 
     LineBox[{4245, 4246}]}, 
    {Hue[
      NCache[
       Rational[4246, 14307], 0.2967778010763962]], AbsoluteThickness[0.25], 
     LineBox[{4246, 4247}]}, 
    {Hue[
      NCache[
       Rational[4247, 14307], 0.296847696931572]], AbsoluteThickness[0.25], 
     LineBox[{4247, 4248}]}, 
    {Hue[
      NCache[
       Rational[1416, 4769], 0.29691759278674773`]], AbsoluteThickness[0.25], 
     LineBox[{4248, 4249}]}, 
    {Hue[
      NCache[
       Rational[4249, 14307], 0.29698748864192354`]], AbsoluteThickness[0.25],
      LineBox[{4249, 4250}]}, 
    {Hue[
      NCache[
       Rational[4250, 14307], 0.29705738449709934`]], AbsoluteThickness[0.25],
      LineBox[{4250, 4251}]}, 
    {Hue[
      NCache[
       Rational[1417, 4769], 0.2971272803522751]], AbsoluteThickness[0.25], 
     LineBox[{4251, 4252}]}, 
    {Hue[
      NCache[
       Rational[4252, 14307], 0.2971971762074509]], AbsoluteThickness[0.25], 
     LineBox[{4252, 4253}]}, 
    {Hue[
      NCache[
       Rational[4253, 14307], 0.2972670720626267]], AbsoluteThickness[0.25], 
     LineBox[{4253, 4254}]}, 
    {Hue[
      NCache[
       Rational[1418, 4769], 0.29733696791780245`]], AbsoluteThickness[0.25], 
     LineBox[{4254, 4255}]}, 
    {Hue[
      NCache[
       Rational[4255, 14307], 0.29740686377297826`]], AbsoluteThickness[0.25],
      LineBox[{4255, 4256}]}, 
    {Hue[
      NCache[
       Rational[224, 753], 0.29747675962815406`]], AbsoluteThickness[0.25], 
     LineBox[{4256, 4257}]}, 
    {Hue[
      NCache[
       Rational[1419, 4769], 0.2975466554833298]], AbsoluteThickness[0.25], 
     LineBox[{4257, 4258}]}, 
    {Hue[
      NCache[
       Rational[4258, 14307], 0.2976165513385056]], AbsoluteThickness[0.25], 
     LineBox[{4258, 4259}]}, 
    {Hue[
      NCache[
       Rational[4259, 14307], 0.2976864471936814]], AbsoluteThickness[0.25], 
     LineBox[{4259, 4260}]}, 
    {Hue[
      NCache[
       Rational[1420, 4769], 0.29775634304885723`]], AbsoluteThickness[0.25], 
     LineBox[{4260, 4261}]}, 
    {Hue[
      NCache[
       Rational[4261, 14307], 0.297826238904033]], AbsoluteThickness[0.25], 
     LineBox[{4261, 4262}]}, 
    {Hue[
      NCache[
       Rational[4262, 14307], 0.2978961347592088]], AbsoluteThickness[0.25], 
     LineBox[{4262, 4263}]}, 
    {Hue[
      NCache[
       Rational[1421, 4769], 0.2979660306143846]], AbsoluteThickness[0.25], 
     LineBox[{4263, 4264}]}, 
    {Hue[
      NCache[
       Rational[4264, 14307], 0.29803592646956034`]], AbsoluteThickness[0.25],
      LineBox[{4264, 4265}]}, 
    {Hue[
      NCache[
       Rational[4265, 14307], 0.29810582232473615`]], AbsoluteThickness[0.25],
      LineBox[{4265, 4266}]}, 
    {Hue[
      NCache[
       Rational[1422, 4769], 0.29817571817991195`]], AbsoluteThickness[0.25], 
     LineBox[{4266, 4267}]}, 
    {Hue[
      NCache[
       Rational[17, 57], 0.2982456140350877]], AbsoluteThickness[0.25], 
     LineBox[{4267, 4268}]}, 
    {Hue[
      NCache[
       Rational[4268, 14307], 0.2983155098902635]], AbsoluteThickness[0.25], 
     LineBox[{4268, 4269}]}, 
    {Hue[
      NCache[
       Rational[1423, 4769], 0.2983854057454393]], AbsoluteThickness[0.25], 
     LineBox[{4269, 4270}]}, 
    {Hue[
      NCache[
       Rational[4270, 14307], 0.29845530160061506`]], AbsoluteThickness[0.25],
      LineBox[{4270, 4271}]}, 
    {Hue[
      NCache[
       Rational[4271, 14307], 0.29852519745579087`]], AbsoluteThickness[0.25],
      LineBox[{4271, 4272}]}, 
    {Hue[
      NCache[
       Rational[1424, 4769], 0.2985950933109667]], AbsoluteThickness[0.25], 
     LineBox[{4272, 4273}]}, 
    {Hue[
      NCache[
       Rational[4273, 14307], 0.2986649891661424]], AbsoluteThickness[0.25], 
     LineBox[{4273, 4274}]}, 
    {Hue[
      NCache[
       Rational[4274, 14307], 0.29873488502131823`]], AbsoluteThickness[0.25],
      LineBox[{4274, 4275}]}, 
    {Hue[
      NCache[
       Rational[75, 251], 0.29880478087649404`]], AbsoluteThickness[0.25], 
     LineBox[{4275, 4276}]}, 
    {Hue[
      NCache[
       Rational[4276, 14307], 0.2988746767316698]], AbsoluteThickness[0.25], 
     LineBox[{4276, 4277}]}, 
    {Hue[
      NCache[
       Rational[4277, 14307], 0.2989445725868456]], AbsoluteThickness[0.25], 
     LineBox[{4277, 4278}]}, 
    {Hue[
      NCache[
       Rational[1426, 4769], 0.2990144684420214]], AbsoluteThickness[0.25], 
     LineBox[{4278, 4279}]}, 
    {Hue[
      NCache[
       Rational[4279, 14307], 0.2990843642971972]], AbsoluteThickness[0.25], 
     LineBox[{4279, 4280}]}, 
    {Hue[
      NCache[
       Rational[4280, 14307], 0.29915426015237295`]], AbsoluteThickness[0.25],
      LineBox[{4280, 4281}]}, 
    {Hue[
      NCache[
       Rational[1427, 4769], 0.29922415600754876`]], AbsoluteThickness[0.25], 
     LineBox[{4281, 4282}]}, 
    {Hue[
      NCache[
       Rational[4282, 14307], 0.29929405186272456`]], AbsoluteThickness[0.25],
      LineBox[{4282, 4283}]}, 
    {Hue[
      NCache[
       Rational[4283, 14307], 0.2993639477179003]], AbsoluteThickness[0.25], 
     LineBox[{4283, 4284}]}, 
    {Hue[
      NCache[
       Rational[1428, 4769], 0.2994338435730761]], AbsoluteThickness[0.25], 
     LineBox[{4284, 4285}]}, 
    {Hue[
      NCache[
       Rational[4285, 14307], 0.2995037394282519]], AbsoluteThickness[0.25], 
     LineBox[{4285, 4286}]}, 
    {Hue[
      NCache[
       Rational[4286, 14307], 0.2995736352834277]], AbsoluteThickness[0.25], 
     LineBox[{4286, 4287}]}, 
    {Hue[
      NCache[
       Rational[1429, 4769], 0.2996435311386035]], AbsoluteThickness[0.25], 
     LineBox[{4287, 4288}]}, 
    {Hue[
      NCache[
       Rational[4288, 14307], 0.2997134269937793]], AbsoluteThickness[0.25], 
     LineBox[{4288, 4289}]}, 
    {Hue[
      NCache[
       Rational[4289, 14307], 0.29978332284895504`]], AbsoluteThickness[0.25],
      LineBox[{4289, 4290}]}, 
    {Hue[
      NCache[
       Rational[1430, 4769], 0.29985321870413084`]], AbsoluteThickness[0.25], 
     LineBox[{4290, 4291}]}, 
    {Hue[
      NCache[
       Rational[4291, 14307], 0.29992311455930665`]], AbsoluteThickness[0.25],
      LineBox[{4291, 4292}]}, 
    {Hue[
      NCache[
       Rational[4292, 14307], 0.2999930104144824]], AbsoluteThickness[0.25], 
     LineBox[{4292, 4293}]}, 
    {Hue[
      NCache[
       Rational[1431, 4769], 0.3000629062696582]], AbsoluteThickness[0.25], 
     LineBox[{4293, 4294}]}, 
    {Hue[
      NCache[
       Rational[226, 753], 0.300132802124834]], AbsoluteThickness[0.25], 
     LineBox[{4294, 4295}]}, 
    {Hue[
      NCache[
       Rational[4295, 14307], 0.30020269798000976`]], AbsoluteThickness[0.25],
      LineBox[{4295, 4296}]}, 
    {Hue[
      NCache[
       Rational[1432, 4769], 0.30027259383518556`]], AbsoluteThickness[0.25], 
     LineBox[{4296, 4297}]}, 
    {Hue[
      NCache[
       Rational[4297, 14307], 0.30034248969036137`]], AbsoluteThickness[0.25],
      LineBox[{4297, 4298}]}, 
    {Hue[
      NCache[
       Rational[4298, 14307], 0.3004123855455372]], AbsoluteThickness[0.25], 
     LineBox[{4298, 4299}]}, 
    {Hue[
      NCache[
       Rational[1433, 4769], 0.3004822814007129]], AbsoluteThickness[0.25], 
     LineBox[{4299, 4300}]}, 
    {Hue[
      NCache[
       Rational[4300, 14307], 0.30055217725588873`]], AbsoluteThickness[0.25],
      LineBox[{4300, 4301}]}, 
    {Hue[
      NCache[
       Rational[4301, 14307], 0.30062207311106454`]], AbsoluteThickness[0.25],
      LineBox[{4301, 4302}]}, 
    {Hue[
      NCache[
       Rational[1434, 4769], 0.3006919689662403]], AbsoluteThickness[0.25], 
     LineBox[{4302, 4303}]}, 
    {Hue[
      NCache[
       Rational[4303, 14307], 0.3007618648214161]], AbsoluteThickness[0.25], 
     LineBox[{4303, 4304}]}, 
    {Hue[
      NCache[
       Rational[4304, 14307], 0.3008317606765919]], AbsoluteThickness[0.25], 
     LineBox[{4304, 4305}]}, 
    {Hue[
      NCache[
       Rational[1435, 4769], 0.30090165653176765`]], AbsoluteThickness[0.25], 
     LineBox[{4305, 4306}]}, 
    {Hue[
      NCache[
       Rational[4306, 14307], 0.30097155238694345`]], AbsoluteThickness[0.25],
      LineBox[{4306, 4307}]}, 
    {Hue[
      NCache[
       Rational[4307, 14307], 0.30104144824211926`]], AbsoluteThickness[0.25],
      LineBox[{4307, 4308}]}, 
    {Hue[
      NCache[
       Rational[1436, 4769], 0.301111344097295]], AbsoluteThickness[0.25], 
     LineBox[{4308, 4309}]}, 
    {Hue[
      NCache[
       Rational[4309, 14307], 0.3011812399524708]], AbsoluteThickness[0.25], 
     LineBox[{4309, 4310}]}, 
    {Hue[
      NCache[
       Rational[4310, 14307], 0.3012511358076466]], AbsoluteThickness[0.25], 
     LineBox[{4310, 4311}]}, 
    {Hue[
      NCache[
       Rational[1437, 4769], 0.30132103166282237`]], AbsoluteThickness[0.25], 
     LineBox[{4311, 4312}]}, 
    {Hue[
      NCache[
       Rational[4312, 14307], 0.3013909275179982]], AbsoluteThickness[0.25], 
     LineBox[{4312, 4313}]}, 
    {Hue[
      NCache[
       Rational[227, 753], 0.301460823373174]], AbsoluteThickness[0.25], 
     LineBox[{4313, 4314}]}, 
    {Hue[
      NCache[
       Rational[1438, 4769], 0.3015307192283498]], AbsoluteThickness[0.25], 
     LineBox[{4314, 4315}]}, 
    {Hue[
      NCache[
       Rational[4315, 14307], 0.30160061508352554`]], AbsoluteThickness[0.25],
      LineBox[{4315, 4316}]}, 
    {Hue[
      NCache[
       Rational[4316, 14307], 0.30167051093870134`]], AbsoluteThickness[0.25],
      LineBox[{4316, 4317}]}, 
    {Hue[
      NCache[
       Rational[1439, 4769], 0.30174040679387715`]], AbsoluteThickness[0.25], 
     LineBox[{4317, 4318}]}, 
    {Hue[
      NCache[
       Rational[4318, 14307], 0.3018103026490529]], AbsoluteThickness[0.25], 
     LineBox[{4318, 4319}]}, 
    {Hue[
      NCache[
       Rational[4319, 14307], 0.3018801985042287]], AbsoluteThickness[0.25], 
     LineBox[{4319, 4320}]}, 
    {Hue[
      NCache[
       Rational[1440, 4769], 0.3019500943594045]], AbsoluteThickness[0.25], 
     LineBox[{4320, 4321}]}, 
    {Hue[
      NCache[
       Rational[4321, 14307], 0.30201999021458026`]], AbsoluteThickness[0.25],
      LineBox[{4321, 4322}]}, 
    {Hue[
      NCache[
       Rational[4322, 14307], 0.30208988606975606`]], AbsoluteThickness[0.25],
      LineBox[{4322, 4323}]}, 
    {Hue[
      NCache[
       Rational[1441, 4769], 0.30215978192493187`]], AbsoluteThickness[0.25], 
     LineBox[{4323, 4324}]}, 
    {Hue[
      NCache[
       Rational[4324, 14307], 0.3022296777801076]], AbsoluteThickness[0.25], 
     LineBox[{4324, 4325}]}, 
    {Hue[
      NCache[
       Rational[4325, 14307], 0.3022995736352834]], AbsoluteThickness[0.25], 
     LineBox[{4325, 4326}]}, 
    {Hue[
      NCache[
       Rational[1442, 4769], 0.30236946949045923`]], AbsoluteThickness[0.25], 
     LineBox[{4326, 4327}]}, 
    {Hue[
      NCache[
       Rational[4327, 14307], 0.302439365345635]], AbsoluteThickness[0.25], 
     LineBox[{4327, 4328}]}, 
    {Hue[
      NCache[
       Rational[4328, 14307], 0.3025092612008108]], AbsoluteThickness[0.25], 
     LineBox[{4328, 4329}]}, 
    {Hue[
      NCache[
       Rational[1443, 4769], 0.3025791570559866]], AbsoluteThickness[0.25], 
     LineBox[{4329, 4330}]}, 
    {Hue[
      NCache[
       Rational[4330, 14307], 0.30264905291116234`]], AbsoluteThickness[0.25],
      LineBox[{4330, 4331}]}, 
    {Hue[
      NCache[
       Rational[4331, 14307], 0.30271894876633815`]], AbsoluteThickness[0.25],
      LineBox[{4331, 4332}]}, 
    {Hue[
      NCache[
       Rational[76, 251], 0.30278884462151395`]], AbsoluteThickness[0.25], 
     LineBox[{4332, 4333}]}, 
    {Hue[
      NCache[
       Rational[4333, 14307], 0.30285874047668976`]], AbsoluteThickness[0.25],
      LineBox[{4333, 4334}]}, 
    {Hue[
      NCache[
       Rational[4334, 14307], 0.3029286363318655]], AbsoluteThickness[0.25], 
     LineBox[{4334, 4335}]}, 
    {Hue[
      NCache[
       Rational[1445, 4769], 0.3029985321870413]], AbsoluteThickness[0.25], 
     LineBox[{4335, 4336}]}, 
    {Hue[
      NCache[
       Rational[4336, 14307], 0.3030684280422171]], AbsoluteThickness[0.25], 
     LineBox[{4336, 4337}]}, 
    {Hue[
      NCache[
       Rational[4337, 14307], 0.30313832389739287`]], AbsoluteThickness[0.25],
      LineBox[{4337, 4338}]}, 
    {Hue[
      NCache[
       Rational[1446, 4769], 0.3032082197525687]], AbsoluteThickness[0.25], 
     LineBox[{4338, 4339}]}, 
    {Hue[
      NCache[
       Rational[4339, 14307], 0.3032781156077445]], AbsoluteThickness[0.25], 
     LineBox[{4339, 4340}]}, 
    {Hue[
      NCache[
       Rational[4340, 14307], 0.30334801146292023`]], AbsoluteThickness[0.25],
      LineBox[{4340, 4341}]}, 
    {Hue[
      NCache[
       Rational[1447, 4769], 0.30341790731809604`]], AbsoluteThickness[0.25], 
     LineBox[{4341, 4342}]}, 
    {Hue[
      NCache[
       Rational[4342, 14307], 0.30348780317327184`]], AbsoluteThickness[0.25],
      LineBox[{4342, 4343}]}, 
    {Hue[
      NCache[
       Rational[4343, 14307], 0.3035576990284476]], AbsoluteThickness[0.25], 
     LineBox[{4343, 4344}]}, 
    {Hue[
      NCache[
       Rational[1448, 4769], 0.3036275948836234]], AbsoluteThickness[0.25], 
     LineBox[{4344, 4345}]}, 
    {Hue[
      NCache[
       Rational[4345, 14307], 0.3036974907387992]], AbsoluteThickness[0.25], 
     LineBox[{4345, 4346}]}, 
    {Hue[
      NCache[
       Rational[4346, 14307], 0.30376738659397495`]], AbsoluteThickness[0.25],
      LineBox[{4346, 4347}]}, 
    {Hue[
      NCache[
       Rational[1449, 4769], 0.30383728244915076`]], AbsoluteThickness[0.25], 
     LineBox[{4347, 4348}]}, 
    {Hue[
      NCache[
       Rational[4348, 14307], 0.30390717830432656`]], AbsoluteThickness[0.25],
      LineBox[{4348, 4349}]}, 
    {Hue[
      NCache[
       Rational[4349, 14307], 0.3039770741595023]], AbsoluteThickness[0.25], 
     LineBox[{4349, 4350}]}, 
    {Hue[
      NCache[
       Rational[1450, 4769], 0.3040469700146781]], AbsoluteThickness[0.25], 
     LineBox[{4350, 4351}]}, 
    {Hue[
      NCache[
       Rational[229, 753], 0.3041168658698539]], AbsoluteThickness[0.25], 
     LineBox[{4351, 4352}]}, 
    {Hue[
      NCache[
       Rational[4352, 14307], 0.30418676172502973`]], AbsoluteThickness[0.25],
      LineBox[{4352, 4353}]}, 
    {Hue[
      NCache[
       Rational[1451, 4769], 0.3042566575802055]], AbsoluteThickness[0.25], 
     LineBox[{4353, 4354}]}, 
    {Hue[
      NCache[
       Rational[4354, 14307], 0.3043265534353813]], AbsoluteThickness[0.25], 
     LineBox[{4354, 4355}]}, 
    {Hue[
      NCache[
       Rational[4355, 14307], 0.3043964492905571]], AbsoluteThickness[0.25], 
     LineBox[{4355, 4356}]}, 
    {Hue[
      NCache[
       Rational[1452, 4769], 0.30446634514573284`]], AbsoluteThickness[0.25], 
     LineBox[{4356, 4357}]}, 
    {Hue[
      NCache[
       Rational[4357, 14307], 0.30453624100090865`]], AbsoluteThickness[0.25],
      LineBox[{4357, 4358}]}, 
    {Hue[
      NCache[
       Rational[4358, 14307], 0.30460613685608445`]], AbsoluteThickness[0.25],
      LineBox[{4358, 4359}]}, 
    {Hue[
      NCache[
       Rational[1453, 4769], 0.3046760327112602]], AbsoluteThickness[0.25], 
     LineBox[{4359, 4360}]}, 
    {Hue[
      NCache[
       Rational[4360, 14307], 0.304745928566436]], AbsoluteThickness[0.25], 
     LineBox[{4360, 4361}]}, 
    {Hue[
      NCache[
       Rational[4361, 14307], 0.3048158244216118]], AbsoluteThickness[0.25], 
     LineBox[{4361, 4362}]}, 
    {Hue[
      NCache[
       Rational[1454, 4769], 0.30488572027678756`]], AbsoluteThickness[0.25], 
     LineBox[{4362, 4363}]}, 
    {Hue[
      NCache[
       Rational[4363, 14307], 0.30495561613196337`]], AbsoluteThickness[0.25],
      LineBox[{4363, 4364}]}, 
    {Hue[
      NCache[
       Rational[4364, 14307], 0.3050255119871392]], AbsoluteThickness[0.25], 
     LineBox[{4364, 4365}]}, 
    {Hue[
      NCache[
       Rational[1455, 4769], 0.3050954078423149]], AbsoluteThickness[0.25], 
     LineBox[{4365, 4366}]}, 
    {Hue[
      NCache[
       Rational[4366, 14307], 0.30516530369749073`]], AbsoluteThickness[0.25],
      LineBox[{4366, 4367}]}, 
    {Hue[
      NCache[
       Rational[4367, 14307], 0.30523519955266654`]], AbsoluteThickness[0.25],
      LineBox[{4367, 4368}]}, 
    {Hue[
      NCache[
       Rational[1456, 4769], 0.30530509540784234`]], AbsoluteThickness[0.25], 
     LineBox[{4368, 4369}]}, 
    {Hue[
      NCache[
       Rational[4369, 14307], 0.3053749912630181]], AbsoluteThickness[0.25], 
     LineBox[{4369, 4370}]}, 
    {Hue[
      NCache[
       Rational[230, 753], 0.3054448871181939]], AbsoluteThickness[0.25], 
     LineBox[{4370, 4371}]}, 
    {Hue[
      NCache[
       Rational[1457, 4769], 0.3055147829733697]], AbsoluteThickness[0.25], 
     LineBox[{4371, 4372}]}, 
    {Hue[
      NCache[
       Rational[4372, 14307], 0.30558467882854545`]], AbsoluteThickness[0.25],
      LineBox[{4372, 4373}]}, 
    {Hue[
      NCache[
       Rational[4373, 14307], 0.30565457468372126`]], AbsoluteThickness[0.25],
      LineBox[{4373, 4374}]}, 
    {Hue[
      NCache[
       Rational[1458, 4769], 0.30572447053889706`]], AbsoluteThickness[0.25], 
     LineBox[{4374, 4375}]}, 
    {Hue[
      NCache[
       Rational[4375, 14307], 0.3057943663940728]], AbsoluteThickness[0.25], 
     LineBox[{4375, 4376}]}, 
    {Hue[
      NCache[
       Rational[4376, 14307], 0.3058642622492486]], AbsoluteThickness[0.25], 
     LineBox[{4376, 4377}]}, 
    {Hue[
      NCache[
       Rational[1459, 4769], 0.3059341581044244]], AbsoluteThickness[0.25], 
     LineBox[{4377, 4378}]}, 
    {Hue[
      NCache[
       Rational[4378, 14307], 0.3060040539596002]], AbsoluteThickness[0.25], 
     LineBox[{4378, 4379}]}, 
    {Hue[
      NCache[
       Rational[4379, 14307], 0.306073949814776]], AbsoluteThickness[0.25], 
     LineBox[{4379, 4380}]}, 
    {Hue[
      NCache[
       Rational[1460, 4769], 0.3061438456699518]], AbsoluteThickness[0.25], 
     LineBox[{4380, 4381}]}, 
    {Hue[
      NCache[
       Rational[4381, 14307], 0.30621374152512754`]], AbsoluteThickness[0.25],
      LineBox[{4381, 4382}]}, 
    {Hue[
      NCache[
       Rational[4382, 14307], 0.30628363738030334`]], AbsoluteThickness[0.25],
      LineBox[{4382, 4383}]}, 
    {Hue[
      NCache[
       Rational[1461, 4769], 0.30635353323547915`]], AbsoluteThickness[0.25], 
     LineBox[{4383, 4384}]}, 
    {Hue[
      NCache[
       Rational[4384, 14307], 0.3064234290906549]], AbsoluteThickness[0.25], 
     LineBox[{4384, 4385}]}, 
    {Hue[
      NCache[
       Rational[4385, 14307], 0.3064933249458307]], AbsoluteThickness[0.25], 
     LineBox[{4385, 4386}]}, 
    {Hue[
      NCache[
       Rational[1462, 4769], 0.3065632208010065]], AbsoluteThickness[0.25], 
     LineBox[{4386, 4387}]}, 
    {Hue[
      NCache[
       Rational[4387, 14307], 0.3066331166561823]], AbsoluteThickness[0.25], 
     LineBox[{4387, 4388}]}, 
    {Hue[
      NCache[
       Rational[4388, 14307], 0.30670301251135806`]], AbsoluteThickness[0.25],
      LineBox[{4388, 4389}]}, 
    {Hue[
      NCache[
       Rational[77, 251], 0.30677290836653387`]], AbsoluteThickness[0.25], 
     LineBox[{4389, 4390}]}, 
    {Hue[
      NCache[
       Rational[4390, 14307], 0.3068428042217097]], AbsoluteThickness[0.25], 
     LineBox[{4390, 4391}]}, 
    {Hue[
      NCache[
       Rational[4391, 14307], 0.3069127000768854]], AbsoluteThickness[0.25], 
     LineBox[{4391, 4392}]}, 
    {Hue[
      NCache[
       Rational[1464, 4769], 0.30698259593206123`]], AbsoluteThickness[0.25], 
     LineBox[{4392, 4393}]}, 
    {Hue[
      NCache[
       Rational[4393, 14307], 0.30705249178723704`]], AbsoluteThickness[0.25],
      LineBox[{4393, 4394}]}, 
    {Hue[
      NCache[
       Rational[4394, 14307], 0.3071223876424128]], AbsoluteThickness[0.25], 
     LineBox[{4394, 4395}]}, 
    {Hue[
      NCache[
       Rational[1465, 4769], 0.3071922834975886]], AbsoluteThickness[0.25], 
     LineBox[{4395, 4396}]}, 
    {Hue[
      NCache[
       Rational[4396, 14307], 0.3072621793527644]], AbsoluteThickness[0.25], 
     LineBox[{4396, 4397}]}, 
    {Hue[
      NCache[
       Rational[4397, 14307], 0.30733207520794015`]], AbsoluteThickness[0.25],
      LineBox[{4397, 4398}]}, 
    {Hue[
      NCache[
       Rational[1466, 4769], 0.30740197106311595`]], AbsoluteThickness[0.25], 
     LineBox[{4398, 4399}]}, 
    {Hue[
      NCache[
       Rational[4399, 14307], 0.30747186691829176`]], AbsoluteThickness[0.25],
      LineBox[{4399, 4400}]}, 
    {Hue[
      NCache[
       Rational[4400, 14307], 0.3075417627734675]], AbsoluteThickness[0.25], 
     LineBox[{4400, 4401}]}, 
    {Hue[
      NCache[
       Rational[1467, 4769], 0.3076116586286433]], AbsoluteThickness[0.25], 
     LineBox[{4401, 4402}]}, 
    {Hue[
      NCache[
       Rational[4402, 14307], 0.3076815544838191]], AbsoluteThickness[0.25], 
     LineBox[{4402, 4403}]}, 
    {Hue[
      NCache[
       Rational[4403, 14307], 0.3077514503389949]], AbsoluteThickness[0.25], 
     LineBox[{4403, 4404}]}, 
    {Hue[
      NCache[
       Rational[1468, 4769], 0.3078213461941707]], AbsoluteThickness[0.25], 
     LineBox[{4404, 4405}]}, 
    {Hue[
      NCache[
       Rational[4405, 14307], 0.3078912420493465]], AbsoluteThickness[0.25], 
     LineBox[{4405, 4406}]}, 
    {Hue[
      NCache[
       Rational[4406, 14307], 0.3079611379045223]], AbsoluteThickness[0.25], 
     LineBox[{4406, 4407}]}, 
    {Hue[
      NCache[
       Rational[1469, 4769], 0.30803103375969804`]], AbsoluteThickness[0.25], 
     LineBox[{4407, 4408}]}, 
    {Hue[
      NCache[
       Rational[232, 753], 0.30810092961487384`]], AbsoluteThickness[0.25], 
     LineBox[{4408, 4409}]}, 
    {Hue[
      NCache[
       Rational[4409, 14307], 0.30817082547004965`]], AbsoluteThickness[0.25],
      LineBox[{4409, 4410}]}, 
    {Hue[
      NCache[
       Rational[1470, 4769], 0.3082407213252254]], AbsoluteThickness[0.25], 
     LineBox[{4410, 4411}]}, 
    {Hue[
      NCache[
       Rational[4411, 14307], 0.3083106171804012]], AbsoluteThickness[0.25], 
     LineBox[{4411, 4412}]}, 
    {Hue[
      NCache[
       Rational[4412, 14307], 0.308380513035577]], AbsoluteThickness[0.25], 
     LineBox[{4412, 4413}]}, 
    {Hue[
      NCache[
       Rational[1471, 4769], 0.30845040889075276`]], AbsoluteThickness[0.25], 
     LineBox[{4413, 4414}]}, 
    {Hue[
      NCache[
       Rational[4414, 14307], 0.30852030474592856`]], AbsoluteThickness[0.25],
      LineBox[{4414, 4415}]}, 
    {Hue[
      NCache[
       Rational[4415, 14307], 0.30859020060110437`]], AbsoluteThickness[0.25],
      LineBox[{4415, 4416}]}, 
    {Hue[
      NCache[
       Rational[1472, 4769], 0.3086600964562801]], AbsoluteThickness[0.25], 
     LineBox[{4416, 4417}]}, 
    {Hue[
      NCache[
       Rational[4417, 14307], 0.3087299923114559]], AbsoluteThickness[0.25], 
     LineBox[{4417, 4418}]}, 
    {Hue[
      NCache[
       Rational[4418, 14307], 0.30879988816663173`]], AbsoluteThickness[0.25],
      LineBox[{4418, 4419}]}, 
    {Hue[
      NCache[
       Rational[1473, 4769], 0.3088697840218075]], AbsoluteThickness[0.25], 
     LineBox[{4419, 4420}]}, 
    {Hue[
      NCache[
       Rational[4420, 14307], 0.3089396798769833]], AbsoluteThickness[0.25], 
     LineBox[{4420, 4421}]}, 
    {Hue[
      NCache[
       Rational[4421, 14307], 0.3090095757321591]], AbsoluteThickness[0.25], 
     LineBox[{4421, 4422}]}, 
    {Hue[
      NCache[
       Rational[1474, 4769], 0.3090794715873349]], AbsoluteThickness[0.25], 
     LineBox[{4422, 4423}]}, 
    {Hue[
      NCache[
       Rational[4423, 14307], 0.30914936744251065`]], AbsoluteThickness[0.25],
      LineBox[{4423, 4424}]}, 
    {Hue[
      NCache[
       Rational[4424, 14307], 0.30921926329768645`]], AbsoluteThickness[0.25],
      LineBox[{4424, 4425}]}, 
    {Hue[
      NCache[
       Rational[1475, 4769], 0.30928915915286226`]], AbsoluteThickness[0.25], 
     LineBox[{4425, 4426}]}, 
    {Hue[
      NCache[
       Rational[4426, 14307], 0.309359055008038]], AbsoluteThickness[0.25], 
     LineBox[{4426, 4427}]}, 
    {Hue[
      NCache[
       Rational[233, 753], 0.3094289508632138]], AbsoluteThickness[0.25], 
     LineBox[{4427, 4428}]}, 
    {Hue[
      NCache[
       Rational[1476, 4769], 0.3094988467183896]], AbsoluteThickness[0.25], 
     LineBox[{4428, 4429}]}, 
    {Hue[
      NCache[
       Rational[4429, 14307], 0.30956874257356537`]], AbsoluteThickness[0.25],
      LineBox[{4429, 4430}]}, 
    {Hue[
      NCache[
       Rational[4430, 14307], 0.3096386384287412]], AbsoluteThickness[0.25], 
     LineBox[{4430, 4431}]}, 
    {Hue[
      NCache[
       Rational[1477, 4769], 0.309708534283917]], AbsoluteThickness[0.25], 
     LineBox[{4431, 4432}]}, 
    {Hue[
      NCache[
       Rational[4432, 14307], 0.30977843013909273`]], AbsoluteThickness[0.25],
      LineBox[{4432, 4433}]}, 
    {Hue[
      NCache[
       Rational[4433, 14307], 0.30984832599426854`]], AbsoluteThickness[0.25],
      LineBox[{4433, 4434}]}, 
    {Hue[
      NCache[
       Rational[1478, 4769], 0.30991822184944434`]], AbsoluteThickness[0.25], 
     LineBox[{4434, 4435}]}, 
    {Hue[
      NCache[
       Rational[4435, 14307], 0.3099881177046201]], AbsoluteThickness[0.25], 
     LineBox[{4435, 4436}]}, 
    {Hue[
      NCache[
       Rational[4436, 14307], 0.3100580135597959]], AbsoluteThickness[0.25], 
     LineBox[{4436, 4437}]}, 
    {Hue[
      NCache[
       Rational[1479, 4769], 0.3101279094149717]], AbsoluteThickness[0.25], 
     LineBox[{4437, 4438}]}, 
    {Hue[
      NCache[
       Rational[4438, 14307], 0.31019780527014745`]], AbsoluteThickness[0.25],
      LineBox[{4438, 4439}]}, 
    {Hue[
      NCache[
       Rational[4439, 14307], 0.31026770112532326`]], AbsoluteThickness[0.25],
      LineBox[{4439, 4440}]}, 
    {Hue[
      NCache[
       Rational[1480, 4769], 0.31033759698049906`]], AbsoluteThickness[0.25], 
     LineBox[{4440, 4441}]}, 
    {Hue[
      NCache[
       Rational[4441, 14307], 0.31040749283567487`]], AbsoluteThickness[0.25],
      LineBox[{4441, 4442}]}, 
    {Hue[
      NCache[
       Rational[4442, 14307], 0.3104773886908506]], AbsoluteThickness[0.25], 
     LineBox[{4442, 4443}]}, 
    {Hue[
      NCache[
       Rational[1481, 4769], 0.3105472845460264]], AbsoluteThickness[0.25], 
     LineBox[{4443, 4444}]}, 
    {Hue[
      NCache[
       Rational[4444, 14307], 0.31061718040120223`]], AbsoluteThickness[0.25],
      LineBox[{4444, 4445}]}, 
    {Hue[
      NCache[
       Rational[4445, 14307], 0.310687076256378]], AbsoluteThickness[0.25], 
     LineBox[{4445, 4446}]}, 
    {Hue[
      NCache[
       Rational[78, 251], 0.3107569721115538]], AbsoluteThickness[0.25], 
     LineBox[{4446, 4447}]}, 
    {Hue[
      NCache[
       Rational[4447, 14307], 0.3108268679667296]], AbsoluteThickness[0.25], 
     LineBox[{4447, 4448}]}, 
    {Hue[
      NCache[
       Rational[4448, 14307], 0.31089676382190534`]], AbsoluteThickness[0.25],
      LineBox[{4448, 4449}]}, 
    {Hue[
      NCache[
       Rational[1483, 4769], 0.31096665967708115`]], AbsoluteThickness[0.25], 
     LineBox[{4449, 4450}]}, 
    {Hue[
      NCache[
       Rational[4450, 14307], 0.31103655553225695`]], AbsoluteThickness[0.25],
      LineBox[{4450, 4451}]}, 
    {Hue[
      NCache[
       Rational[4451, 14307], 0.3111064513874327]], AbsoluteThickness[0.25], 
     LineBox[{4451, 4452}]}, 
    {Hue[
      NCache[
       Rational[1484, 4769], 0.3111763472426085]], AbsoluteThickness[0.25], 
     LineBox[{4452, 4453}]}, 
    {Hue[
      NCache[
       Rational[4453, 14307], 0.3112462430977843]], AbsoluteThickness[0.25], 
     LineBox[{4453, 4454}]}, 
    {Hue[
      NCache[
       Rational[4454, 14307], 0.31131613895296006`]], AbsoluteThickness[0.25],
      LineBox[{4454, 4455}]}, 
    {Hue[
      NCache[
       Rational[1485, 4769], 0.31138603480813587`]], AbsoluteThickness[0.25], 
     LineBox[{4455, 4456}]}, 
    {Hue[
      NCache[
       Rational[4456, 14307], 0.3114559306633117]], AbsoluteThickness[0.25], 
     LineBox[{4456, 4457}]}, 
    {Hue[
      NCache[
       Rational[4457, 14307], 0.3115258265184875]], AbsoluteThickness[0.25], 
     LineBox[{4457, 4458}]}, 
    {Hue[
      NCache[
       Rational[1486, 4769], 0.31159572237366323`]], AbsoluteThickness[0.25], 
     LineBox[{4458, 4459}]}, 
    {Hue[
      NCache[
       Rational[4459, 14307], 0.31166561822883904`]], AbsoluteThickness[0.25],
      LineBox[{4459, 4460}]}, 
    {Hue[
      NCache[
       Rational[4460, 14307], 0.31173551408401484`]], AbsoluteThickness[0.25],
      LineBox[{4460, 4461}]}, 
    {Hue[
      NCache[
       Rational[1487, 4769], 0.3118054099391906]], AbsoluteThickness[0.25], 
     LineBox[{4461, 4462}]}, 
    {Hue[
      NCache[
       Rational[4462, 14307], 0.3118753057943664]], AbsoluteThickness[0.25], 
     LineBox[{4462, 4463}]}, 
    {Hue[
      NCache[
       Rational[4463, 14307], 0.3119452016495422]], AbsoluteThickness[0.25], 
     LineBox[{4463, 4464}]}, 
    {Hue[
      NCache[
       Rational[1488, 4769], 0.31201509750471795`]], AbsoluteThickness[0.25], 
     LineBox[{4464, 4465}]}, 
    {Hue[
      NCache[
       Rational[235, 753], 0.31208499335989376`]], AbsoluteThickness[0.25], 
     LineBox[{4465, 4466}]}, 
    {Hue[
      NCache[
       Rational[4466, 14307], 0.31215488921506956`]], AbsoluteThickness[0.25],
      LineBox[{4466, 4467}]}, 
    {Hue[
      NCache[
       Rational[1489, 4769], 0.3122247850702453]], AbsoluteThickness[0.25], 
     LineBox[{4467, 4468}]}, 
    {Hue[
      NCache[
       Rational[4468, 14307], 0.3122946809254211]], AbsoluteThickness[0.25], 
     LineBox[{4468, 4469}]}, 
    {Hue[
      NCache[
       Rational[4469, 14307], 0.3123645767805969]], AbsoluteThickness[0.25], 
     LineBox[{4469, 4470}]}, 
    {Hue[
      NCache[
       Rational[1490, 4769], 0.3124344726357727]], AbsoluteThickness[0.25], 
     LineBox[{4470, 4471}]}, 
    {Hue[
      NCache[
       Rational[4471, 14307], 0.3125043684909485]], AbsoluteThickness[0.25], 
     LineBox[{4471, 4472}]}, 
    {Hue[
      NCache[
       Rational[4472, 14307], 0.3125742643461243]], AbsoluteThickness[0.25], 
     LineBox[{4472, 4473}]}, 
    {Hue[
      NCache[
       Rational[1491, 4769], 0.31264416020130004`]], AbsoluteThickness[0.25], 
     LineBox[{4473, 4474}]}, 
    {Hue[
      NCache[
       Rational[4474, 14307], 0.31271405605647584`]], AbsoluteThickness[0.25],
      LineBox[{4474, 4475}]}, 
    {Hue[
      NCache[
       Rational[4475, 14307], 0.31278395191165165`]], AbsoluteThickness[0.25],
      LineBox[{4475, 4476}]}, 
    {Hue[
      NCache[
       Rational[1492, 4769], 0.31285384776682745`]], AbsoluteThickness[0.25], 
     LineBox[{4476, 4477}]}, 
    {Hue[
      NCache[
       Rational[4477, 14307], 0.3129237436220032]], AbsoluteThickness[0.25], 
     LineBox[{4477, 4478}]}, 
    {Hue[
      NCache[
       Rational[4478, 14307], 0.312993639477179]], AbsoluteThickness[0.25], 
     LineBox[{4478, 4479}]}, 
    {Hue[
      NCache[
       Rational[1493, 4769], 0.3130635353323548]], AbsoluteThickness[0.25], 
     LineBox[{4479, 4480}]}, 
    {Hue[
      NCache[
       Rational[4480, 14307], 0.31313343118753056`]], AbsoluteThickness[0.25],
      LineBox[{4480, 4481}]}, 
    {Hue[
      NCache[
       Rational[4481, 14307], 0.31320332704270637`]], AbsoluteThickness[0.25],
      LineBox[{4481, 4482}]}, 
    {Hue[
      NCache[
       Rational[1494, 4769], 0.3132732228978822]], AbsoluteThickness[0.25], 
     LineBox[{4482, 4483}]}, 
    {Hue[
      NCache[
       Rational[4483, 14307], 0.3133431187530579]], AbsoluteThickness[0.25], 
     LineBox[{4483, 4484}]}, 
    {Hue[
      NCache[
       Rational[236, 753], 0.31341301460823373`]], AbsoluteThickness[0.25], 
     LineBox[{4484, 4485}]}, 
    {Hue[
      NCache[
       Rational[1495, 4769], 0.31348291046340954`]], AbsoluteThickness[0.25], 
     LineBox[{4485, 4486}]}, 
    {Hue[
      NCache[
       Rational[4486, 14307], 0.3135528063185853]], AbsoluteThickness[0.25], 
     LineBox[{4486, 4487}]}, 
    {Hue[
      NCache[
       Rational[4487, 14307], 0.3136227021737611]], AbsoluteThickness[0.25], 
     LineBox[{4487, 4488}]}, 
    {Hue[
      NCache[
       Rational[1496, 4769], 0.3136925980289369]], AbsoluteThickness[0.25], 
     LineBox[{4488, 4489}]}, 
    {Hue[
      NCache[
       Rational[4489, 14307], 0.31376249388411265`]], AbsoluteThickness[0.25],
      LineBox[{4489, 4490}]}, 
    {Hue[
      NCache[
       Rational[4490, 14307], 0.31383238973928845`]], AbsoluteThickness[0.25],
      LineBox[{4490, 4491}]}, 
    {Hue[
      NCache[
       Rational[1497, 4769], 0.31390228559446426`]], AbsoluteThickness[0.25], 
     LineBox[{4491, 4492}]}, 
    {Hue[
      NCache[
       Rational[4492, 14307], 0.31397218144964]], AbsoluteThickness[0.25], 
     LineBox[{4492, 4493}]}, 
    {Hue[
      NCache[
       Rational[4493, 14307], 0.3140420773048158]], AbsoluteThickness[0.25], 
     LineBox[{4493, 4494}]}, 
    {Hue[
      NCache[
       Rational[1498, 4769], 0.3141119731599916]], AbsoluteThickness[0.25], 
     LineBox[{4494, 4495}]}, 
    {Hue[
      NCache[
       Rational[4495, 14307], 0.3141818690151674]], AbsoluteThickness[0.25], 
     LineBox[{4495, 4496}]}, 
    {Hue[
      NCache[
       Rational[4496, 14307], 0.3142517648703432]], AbsoluteThickness[0.25], 
     LineBox[{4496, 4497}]}, 
    {Hue[
      NCache[
       Rational[1499, 4769], 0.314321660725519]], AbsoluteThickness[0.25], 
     LineBox[{4497, 4498}]}, 
    {Hue[
      NCache[
       Rational[4498, 14307], 0.3143915565806948]], AbsoluteThickness[0.25], 
     LineBox[{4498, 4499}]}, 
    {Hue[
      NCache[
       Rational[4499, 14307], 0.31446145243587054`]], AbsoluteThickness[0.25],
      LineBox[{4499, 4500}]}, 
    {Hue[
      NCache[
       Rational[1500, 4769], 0.31453134829104634`]], AbsoluteThickness[0.25], 
     LineBox[{4500, 4501}]}, 
    {Hue[
      NCache[
       Rational[4501, 14307], 0.31460124414622215`]], AbsoluteThickness[0.25],
      LineBox[{4501, 4502}]}, 
    {Hue[
      NCache[
       Rational[4502, 14307], 0.3146711400013979]], AbsoluteThickness[0.25], 
     LineBox[{4502, 4503}]}, 
    {Hue[
      NCache[
       Rational[79, 251], 0.3147410358565737]], AbsoluteThickness[0.25], 
     LineBox[{4503, 4504}]}, 
    {Hue[
      NCache[
       Rational[4504, 14307], 0.3148109317117495]], AbsoluteThickness[0.25], 
     LineBox[{4504, 4505}]}, 
    {Hue[
      NCache[
       Rational[4505, 14307], 0.31488082756692526`]], AbsoluteThickness[0.25],
      LineBox[{4505, 4506}]}, 
    {Hue[
      NCache[
       Rational[1502, 4769], 0.31495072342210106`]], AbsoluteThickness[0.25], 
     LineBox[{4506, 4507}]}, 
    {Hue[
      NCache[
       Rational[4507, 14307], 0.31502061927727687`]], AbsoluteThickness[0.25],
      LineBox[{4507, 4508}]}, 
    {Hue[
      NCache[
       Rational[4508, 14307], 0.3150905151324526]], AbsoluteThickness[0.25], 
     LineBox[{4508, 4509}]}, 
    {Hue[
      NCache[
       Rational[1503, 4769], 0.3151604109876284]], AbsoluteThickness[0.25], 
     LineBox[{4509, 4510}]}, 
    {Hue[
      NCache[
       Rational[4510, 14307], 0.31523030684280423`]], AbsoluteThickness[0.25],
      LineBox[{4510, 4511}]}, 
    {Hue[
      NCache[
       Rational[4511, 14307], 0.31530020269798004`]], AbsoluteThickness[0.25],
      LineBox[{4511, 4512}]}, 
    {Hue[
      NCache[
       Rational[1504, 4769], 0.3153700985531558]], AbsoluteThickness[0.25], 
     LineBox[{4512, 4513}]}, 
    {Hue[
      NCache[
       Rational[4513, 14307], 0.3154399944083316]], AbsoluteThickness[0.25], 
     LineBox[{4513, 4514}]}, 
    {Hue[
      NCache[
       Rational[4514, 14307], 0.3155098902635074]], AbsoluteThickness[0.25], 
     LineBox[{4514, 4515}]}, 
    {Hue[
      NCache[
       Rational[1505, 4769], 0.31557978611868315`]], AbsoluteThickness[0.25], 
     LineBox[{4515, 4516}]}, 
    {Hue[
      NCache[
       Rational[4516, 14307], 0.31564968197385895`]], AbsoluteThickness[0.25],
      LineBox[{4516, 4517}]}, 
    {Hue[
      NCache[
       Rational[4517, 14307], 0.31571957782903476`]], AbsoluteThickness[0.25],
      LineBox[{4517, 4518}]}, 
    {Hue[
      NCache[
       Rational[6, 19], 0.3157894736842105]], AbsoluteThickness[0.25], 
     LineBox[{4518, 4519}]}, 
    {Hue[
      NCache[
       Rational[4519, 14307], 0.3158593695393863]], AbsoluteThickness[0.25], 
     LineBox[{4519, 4520}]}, 
    {Hue[
      NCache[
       Rational[4520, 14307], 0.3159292653945621]], AbsoluteThickness[0.25], 
     LineBox[{4520, 4521}]}, 
    {Hue[
      NCache[
       Rational[1507, 4769], 0.31599916124973787`]], AbsoluteThickness[0.25], 
     LineBox[{4521, 4522}]}, 
    {Hue[
      NCache[
       Rational[238, 753], 0.3160690571049137]], AbsoluteThickness[0.25], 
     LineBox[{4522, 4523}]}, 
    {Hue[
      NCache[
       Rational[4523, 14307], 0.3161389529600895]], AbsoluteThickness[0.25], 
     LineBox[{4523, 4524}]}, 
    {Hue[
      NCache[
       Rational[1508, 4769], 0.31620884881526523`]], AbsoluteThickness[0.25], 
     LineBox[{4524, 4525}]}, 
    {Hue[
      NCache[
       Rational[4525, 14307], 0.31627874467044104`]], AbsoluteThickness[0.25],
      LineBox[{4525, 4526}]}, 
    {Hue[
      NCache[
       Rational[4526, 14307], 0.31634864052561684`]], AbsoluteThickness[0.25],
      LineBox[{4526, 4527}]}, 
    {Hue[
      NCache[
       Rational[1509, 4769], 0.3164185363807926]], AbsoluteThickness[0.25], 
     LineBox[{4527, 4528}]}, 
    {Hue[
      NCache[
       Rational[4528, 14307], 0.3164884322359684]], AbsoluteThickness[0.25], 
     LineBox[{4528, 4529}]}, 
    {Hue[
      NCache[
       Rational[4529, 14307], 0.3165583280911442]], AbsoluteThickness[0.25], 
     LineBox[{4529, 4530}]}, 
    {Hue[
      NCache[
       Rational[1510, 4769], 0.31662822394632]], AbsoluteThickness[0.25], 
     LineBox[{4530, 4531}]}, 
    {Hue[
      NCache[
       Rational[4531, 14307], 0.31669811980149576`]], AbsoluteThickness[0.25],
      LineBox[{4531, 4532}]}, 
    {Hue[
      NCache[
       Rational[4532, 14307], 0.31676801565667156`]], AbsoluteThickness[0.25],
      LineBox[{4532, 4533}]}, 
    {Hue[
      NCache[
       Rational[1511, 4769], 0.31683791151184737`]], AbsoluteThickness[0.25], 
     LineBox[{4533, 4534}]}, 
    {Hue[
      NCache[
       Rational[4534, 14307], 0.3169078073670231]], AbsoluteThickness[0.25], 
     LineBox[{4534, 4535}]}, 
    {Hue[
      NCache[
       Rational[4535, 14307], 0.3169777032221989]], AbsoluteThickness[0.25], 
     LineBox[{4535, 4536}]}, 
    {Hue[
      NCache[
       Rational[1512, 4769], 0.31704759907737473`]], AbsoluteThickness[0.25], 
     LineBox[{4536, 4537}]}, 
    {Hue[
      NCache[
       Rational[4537, 14307], 0.3171174949325505]], AbsoluteThickness[0.25], 
     LineBox[{4537, 4538}]}, 
    {Hue[
      NCache[
       Rational[4538, 14307], 0.3171873907877263]], AbsoluteThickness[0.25], 
     LineBox[{4538, 4539}]}, 
    {Hue[
      NCache[
       Rational[1513, 4769], 0.3172572866429021]], AbsoluteThickness[0.25], 
     LineBox[{4539, 4540}]}, 
    {Hue[
      NCache[
       Rational[4540, 14307], 0.31732718249807784`]], AbsoluteThickness[0.25],
      LineBox[{4540, 4541}]}, 
    {Hue[
      NCache[
       Rational[239, 753], 0.31739707835325365`]], AbsoluteThickness[0.25], 
     LineBox[{4541, 4542}]}, 
    {Hue[
      NCache[
       Rational[1514, 4769], 0.31746697420842945`]], AbsoluteThickness[0.25], 
     LineBox[{4542, 4543}]}, 
    {Hue[
      NCache[
       Rational[4543, 14307], 0.3175368700636052]], AbsoluteThickness[0.25], 
     LineBox[{4543, 4544}]}, 
    {Hue[
      NCache[
       Rational[4544, 14307], 0.317606765918781]], AbsoluteThickness[0.25], 
     LineBox[{4544, 4545}]}, 
    {Hue[
      NCache[
       Rational[1515, 4769], 0.3176766617739568]], AbsoluteThickness[0.25], 
     LineBox[{4545, 4546}]}, 
    {Hue[
      NCache[
       Rational[4546, 14307], 0.3177465576291326]], AbsoluteThickness[0.25], 
     LineBox[{4546, 4547}]}, 
    {Hue[
      NCache[
       Rational[4547, 14307], 0.31781645348430837`]], AbsoluteThickness[0.25],
      LineBox[{4547, 4548}]}, 
    {Hue[
      NCache[
       Rational[1516, 4769], 0.3178863493394842]], AbsoluteThickness[0.25], 
     LineBox[{4548, 4549}]}, 
    {Hue[
      NCache[
       Rational[4549, 14307], 0.31795624519466]], AbsoluteThickness[0.25], 
     LineBox[{4549, 4550}]}, 
    {Hue[
      NCache[
       Rational[4550, 14307], 0.31802614104983573`]], AbsoluteThickness[0.25],
      LineBox[{4550, 4551}]}, 
    {Hue[
      NCache[
       Rational[1517, 4769], 0.31809603690501154`]], AbsoluteThickness[0.25], 
     LineBox[{4551, 4552}]}, 
    {Hue[
      NCache[
       Rational[4552, 14307], 0.31816593276018734`]], AbsoluteThickness[0.25],
      LineBox[{4552, 4553}]}, 
    {Hue[
      NCache[
       Rational[4553, 14307], 0.3182358286153631]], AbsoluteThickness[0.25], 
     LineBox[{4553, 4554}]}, 
    {Hue[
      NCache[
       Rational[1518, 4769], 0.3183057244705389]], AbsoluteThickness[0.25], 
     LineBox[{4554, 4555}]}, 
    {Hue[
      NCache[
       Rational[4555, 14307], 0.3183756203257147]], AbsoluteThickness[0.25], 
     LineBox[{4555, 4556}]}, 
    {Hue[
      NCache[
       Rational[4556, 14307], 0.31844551618089045`]], AbsoluteThickness[0.25],
      LineBox[{4556, 4557}]}, 
    {Hue[
      NCache[
       Rational[1519, 4769], 0.31851541203606626`]], AbsoluteThickness[0.25], 
     LineBox[{4557, 4558}]}, 
    {Hue[
      NCache[
       Rational[4558, 14307], 0.31858530789124206`]], AbsoluteThickness[0.25],
      LineBox[{4558, 4559}]}, 
    {Hue[
      NCache[
       Rational[4559, 14307], 0.3186552037464178]], AbsoluteThickness[0.25], 
     LineBox[{4559, 4560}]}, 
    {Hue[
      NCache[
       Rational[80, 251], 0.3187250996015936]], AbsoluteThickness[0.25], 
     LineBox[{4560, 4561}]}, 
    {Hue[
      NCache[
       Rational[4561, 14307], 0.3187949954567694]], AbsoluteThickness[0.25], 
     LineBox[{4561, 4562}]}, 
    {Hue[
      NCache[
       Rational[4562, 14307], 0.3188648913119452]], AbsoluteThickness[0.25], 
     LineBox[{4562, 4563}]}, 
    {Hue[
      NCache[
       Rational[1521, 4769], 0.318934787167121]], AbsoluteThickness[0.25], 
     LineBox[{4563, 4564}]}, 
    {Hue[
      NCache[
       Rational[4564, 14307], 0.3190046830222968]], AbsoluteThickness[0.25], 
     LineBox[{4564, 4565}]}, 
    {Hue[
      NCache[
       Rational[4565, 14307], 0.3190745788774726]], AbsoluteThickness[0.25], 
     LineBox[{4565, 4566}]}, 
    {Hue[
      NCache[
       Rational[1522, 4769], 0.31914447473264834`]], AbsoluteThickness[0.25], 
     LineBox[{4566, 4567}]}, 
    {Hue[
      NCache[
       Rational[4567, 14307], 0.31921437058782415`]], AbsoluteThickness[0.25],
      LineBox[{4567, 4568}]}, 
    {Hue[
      NCache[
       Rational[4568, 14307], 0.31928426644299995`]], AbsoluteThickness[0.25],
      LineBox[{4568, 4569}]}, 
    {Hue[
      NCache[
       Rational[1523, 4769], 0.3193541622981757]], AbsoluteThickness[0.25], 
     LineBox[{4569, 4570}]}, 
    {Hue[
      NCache[
       Rational[4570, 14307], 0.3194240581533515]], AbsoluteThickness[0.25], 
     LineBox[{4570, 4571}]}, 
    {Hue[
      NCache[
       Rational[4571, 14307], 0.3194939540085273]], AbsoluteThickness[0.25], 
     LineBox[{4571, 4572}]}, 
    {Hue[
      NCache[
       Rational[1524, 4769], 0.31956384986370306`]], AbsoluteThickness[0.25], 
     LineBox[{4572, 4573}]}, 
    {Hue[
      NCache[
       Rational[4573, 14307], 0.31963374571887887`]], AbsoluteThickness[0.25],
      LineBox[{4573, 4574}]}, 
    {Hue[
      NCache[
       Rational[4574, 14307], 0.3197036415740547]], AbsoluteThickness[0.25], 
     LineBox[{4574, 4575}]}, 
    {Hue[
      NCache[
       Rational[1525, 4769], 0.3197735374292304]], AbsoluteThickness[0.25], 
     LineBox[{4575, 4576}]}, 
    {Hue[
      NCache[
       Rational[4576, 14307], 0.31984343328440623`]], AbsoluteThickness[0.25],
      LineBox[{4576, 4577}]}, 
    {Hue[
      NCache[
       Rational[4577, 14307], 0.31991332913958204`]], AbsoluteThickness[0.25],
      LineBox[{4577, 4578}]}, 
    {Hue[
      NCache[
       Rational[1526, 4769], 0.3199832249947578]], AbsoluteThickness[0.25], 
     LineBox[{4578, 4579}]}, 
    {Hue[
      NCache[
       Rational[241, 753], 0.3200531208499336]], AbsoluteThickness[0.25], 
     LineBox[{4579, 4580}]}, 
    {Hue[
      NCache[
       Rational[4580, 14307], 0.3201230167051094]], AbsoluteThickness[0.25], 
     LineBox[{4580, 4581}]}, 
    {Hue[
      NCache[
       Rational[1527, 4769], 0.32019291256028515`]], AbsoluteThickness[0.25], 
     LineBox[{4581, 4582}]}, 
    {Hue[
      NCache[
       Rational[4582, 14307], 0.32026280841546095`]], AbsoluteThickness[0.25],
      LineBox[{4582, 4583}]}, 
    {Hue[
      NCache[
       Rational[4583, 14307], 0.32033270427063676`]], AbsoluteThickness[0.25],
      LineBox[{4583, 4584}]}, 
    {Hue[
      NCache[
       Rational[1528, 4769], 0.32040260012581256`]], AbsoluteThickness[0.25], 
     LineBox[{4584, 4585}]}, 
    {Hue[
      NCache[
       Rational[4585, 14307], 0.3204724959809883]], AbsoluteThickness[0.25], 
     LineBox[{4585, 4586}]}, 
    {Hue[
      NCache[
       Rational[4586, 14307], 0.3205423918361641]], AbsoluteThickness[0.25], 
     LineBox[{4586, 4587}]}, 
    {Hue[
      NCache[
       Rational[1529, 4769], 0.3206122876913399]], AbsoluteThickness[0.25], 
     LineBox[{4587, 4588}]}, 
    {Hue[
      NCache[
       Rational[4588, 14307], 0.3206821835465157]], AbsoluteThickness[0.25], 
     LineBox[{4588, 4589}]}, 
    {Hue[
      NCache[
       Rational[4589, 14307], 0.3207520794016915]], AbsoluteThickness[0.25], 
     LineBox[{4589, 4590}]}, 
    {Hue[
      NCache[
       Rational[1530, 4769], 0.3208219752568673]], AbsoluteThickness[0.25], 
     LineBox[{4590, 4591}]}, 
    {Hue[
      NCache[
       Rational[4591, 14307], 0.32089187111204304`]], AbsoluteThickness[0.25],
      LineBox[{4591, 4592}]}, 
    {Hue[
      NCache[
       Rational[4592, 14307], 0.32096176696721884`]], AbsoluteThickness[0.25],
      LineBox[{4592, 4593}]}, 
    {Hue[
      NCache[
       Rational[1531, 4769], 0.32103166282239465`]], AbsoluteThickness[0.25], 
     LineBox[{4593, 4594}]}, 
    {Hue[
      NCache[
       Rational[4594, 14307], 0.3211015586775704]], AbsoluteThickness[0.25], 
     LineBox[{4594, 4595}]}, 
    {Hue[
      NCache[
       Rational[4595, 14307], 0.3211714545327462]], AbsoluteThickness[0.25], 
     LineBox[{4595, 4596}]}, 
    {Hue[
      NCache[
       Rational[1532, 4769], 0.321241350387922]], AbsoluteThickness[0.25], 
     LineBox[{4596, 4597}]}, 
    {Hue[
      NCache[
       Rational[4597, 14307], 0.32131124624309776`]], AbsoluteThickness[0.25],
      LineBox[{4597, 4598}]}, 
    {Hue[
      NCache[
       Rational[242, 753], 0.32138114209827356`]], AbsoluteThickness[0.25], 
     LineBox[{4598, 4599}]}, 
    {Hue[
      NCache[
       Rational[1533, 4769], 0.32145103795344937`]], AbsoluteThickness[0.25], 
     LineBox[{4599, 4600}]}, 
    {Hue[
      NCache[
       Rational[4600, 14307], 0.3215209338086252]], AbsoluteThickness[0.25], 
     LineBox[{4600, 4601}]}, 
    {Hue[
      NCache[
       Rational[4601, 14307], 0.3215908296638009]], AbsoluteThickness[0.25], 
     LineBox[{4601, 4602}]}, 
    {Hue[
      NCache[
       Rational[1534, 4769], 0.32166072551897673`]], AbsoluteThickness[0.25], 
     LineBox[{4602, 4603}]}, 
    {Hue[
      NCache[
       Rational[4603, 14307], 0.32173062137415254`]], AbsoluteThickness[0.25],
      LineBox[{4603, 4604}]}, 
    {Hue[
      NCache[
       Rational[4604, 14307], 0.3218005172293283]], AbsoluteThickness[0.25], 
     LineBox[{4604, 4605}]}, 
    {Hue[
      NCache[
       Rational[1535, 4769], 0.3218704130845041]], AbsoluteThickness[0.25], 
     LineBox[{4605, 4606}]}, 
    {Hue[
      NCache[
       Rational[4606, 14307], 0.3219403089396799]], AbsoluteThickness[0.25], 
     LineBox[{4606, 4607}]}, 
    {Hue[
      NCache[
       Rational[4607, 14307], 0.32201020479485565`]], AbsoluteThickness[0.25],
      LineBox[{4607, 4608}]}, 
    {Hue[
      NCache[
       Rational[1536, 4769], 0.32208010065003145`]], AbsoluteThickness[0.25], 
     LineBox[{4608, 4609}]}, 
    {Hue[
      NCache[
       Rational[4609, 14307], 0.32214999650520726`]], AbsoluteThickness[0.25],
      LineBox[{4609, 4610}]}, 
    {Hue[
      NCache[
       Rational[4610, 14307], 0.322219892360383]], AbsoluteThickness[0.25], 
     LineBox[{4610, 4611}]}, 
    {Hue[
      NCache[
       Rational[1537, 4769], 0.3222897882155588]], AbsoluteThickness[0.25], 
     LineBox[{4611, 4612}]}, 
    {Hue[
      NCache[
       Rational[4612, 14307], 0.3223596840707346]], AbsoluteThickness[0.25], 
     LineBox[{4612, 4613}]}, 
    {Hue[
      NCache[
       Rational[4613, 14307], 0.32242957992591037`]], AbsoluteThickness[0.25],
      LineBox[{4613, 4614}]}, 
    {Hue[
      NCache[
       Rational[1538, 4769], 0.3224994757810862]], AbsoluteThickness[0.25], 
     LineBox[{4614, 4615}]}, 
    {Hue[
      NCache[
       Rational[4615, 14307], 0.322569371636262]], AbsoluteThickness[0.25], 
     LineBox[{4615, 4616}]}, 
    {Hue[
      NCache[
       Rational[4616, 14307], 0.32263926749143773`]], AbsoluteThickness[0.25],
      LineBox[{4616, 4617}]}, 
    {Hue[
      NCache[
       Rational[81, 251], 0.32270916334661354`]], AbsoluteThickness[0.25], 
     LineBox[{4617, 4618}]}, 
    {Hue[
      NCache[
       Rational[4618, 14307], 0.32277905920178934`]], AbsoluteThickness[0.25],
      LineBox[{4618, 4619}]}, 
    {Hue[
      NCache[
       Rational[4619, 14307], 0.32284895505696515`]], AbsoluteThickness[0.25],
      LineBox[{4619, 4620}]}, 
    {Hue[
      NCache[
       Rational[1540, 4769], 0.3229188509121409]], AbsoluteThickness[0.25], 
     LineBox[{4620, 4621}]}, 
    {Hue[
      NCache[
       Rational[4621, 14307], 0.3229887467673167]], AbsoluteThickness[0.25], 
     LineBox[{4621, 4622}]}, 
    {Hue[
      NCache[
       Rational[4622, 14307], 0.3230586426224925]], AbsoluteThickness[0.25], 
     LineBox[{4622, 4623}]}, 
    {Hue[
      NCache[
       Rational[1541, 4769], 0.32312853847766826`]], AbsoluteThickness[0.25], 
     LineBox[{4623, 4624}]}, 
    {Hue[
      NCache[
       Rational[4624, 14307], 0.32319843433284406`]], AbsoluteThickness[0.25],
      LineBox[{4624, 4625}]}, 
    {Hue[
      NCache[
       Rational[4625, 14307], 0.32326833018801987`]], AbsoluteThickness[0.25],
      LineBox[{4625, 4626}]}, 
    {Hue[
      NCache[
       Rational[1542, 4769], 0.3233382260431956]], AbsoluteThickness[0.25], 
     LineBox[{4626, 4627}]}, 
    {Hue[
      NCache[
       Rational[4627, 14307], 0.3234081218983714]], AbsoluteThickness[0.25], 
     LineBox[{4627, 4628}]}, 
    {Hue[
      NCache[
       Rational[4628, 14307], 0.32347801775354723`]], AbsoluteThickness[0.25],
      LineBox[{4628, 4629}]}, 
    {Hue[
      NCache[
       Rational[1543, 4769], 0.323547913608723]], AbsoluteThickness[0.25], 
     LineBox[{4629, 4630}]}, 
    {Hue[
      NCache[
       Rational[4630, 14307], 0.3236178094638988]], AbsoluteThickness[0.25], 
     LineBox[{4630, 4631}]}, 
    {Hue[
      NCache[
       Rational[4631, 14307], 0.3236877053190746]], AbsoluteThickness[0.25], 
     LineBox[{4631, 4632}]}, 
    {Hue[
      NCache[
       Rational[1544, 4769], 0.32375760117425034`]], AbsoluteThickness[0.25], 
     LineBox[{4632, 4633}]}, 
    {Hue[
      NCache[
       Rational[4633, 14307], 0.32382749702942615`]], AbsoluteThickness[0.25],
      LineBox[{4633, 4634}]}, 
    {Hue[
      NCache[
       Rational[4634, 14307], 0.32389739288460195`]], AbsoluteThickness[0.25],
      LineBox[{4634, 4635}]}, 
    {Hue[
      NCache[
       Rational[1545, 4769], 0.3239672887397777]], AbsoluteThickness[0.25], 
     LineBox[{4635, 4636}]}, 
    {Hue[
      NCache[
       Rational[244, 753], 0.3240371845949535]], AbsoluteThickness[0.25], 
     LineBox[{4636, 4637}]}, 
    {Hue[
      NCache[
       Rational[4637, 14307], 0.3241070804501293]], AbsoluteThickness[0.25], 
     LineBox[{4637, 4638}]}, 
    {Hue[
      NCache[
       Rational[1546, 4769], 0.3241769763053051]], AbsoluteThickness[0.25], 
     LineBox[{4638, 4639}]}, 
    {Hue[
      NCache[
       Rational[4639, 14307], 0.32424687216048087`]], AbsoluteThickness[0.25],
      LineBox[{4639, 4640}]}, 
    {Hue[
      NCache[
       Rational[4640, 14307], 0.3243167680156567]], AbsoluteThickness[0.25], 
     LineBox[{4640, 4641}]}, 
    {Hue[
      NCache[
       Rational[1547, 4769], 0.3243866638708325]], AbsoluteThickness[0.25], 
     LineBox[{4641, 4642}]}, 
    {Hue[
      NCache[
       Rational[4642, 14307], 0.32445655972600823`]], AbsoluteThickness[0.25],
      LineBox[{4642, 4643}]}, 
    {Hue[
      NCache[
       Rational[4643, 14307], 0.32452645558118404`]], AbsoluteThickness[0.25],
      LineBox[{4643, 4644}]}, 
    {Hue[
      NCache[
       Rational[1548, 4769], 0.32459635143635984`]], AbsoluteThickness[0.25], 
     LineBox[{4644, 4645}]}, 
    {Hue[
      NCache[
       Rational[4645, 14307], 0.3246662472915356]], AbsoluteThickness[0.25], 
     LineBox[{4645, 4646}]}, 
    {Hue[
      NCache[
       Rational[4646, 14307], 0.3247361431467114]], AbsoluteThickness[0.25], 
     LineBox[{4646, 4647}]}, 
    {Hue[
      NCache[
       Rational[1549, 4769], 0.3248060390018872]], AbsoluteThickness[0.25], 
     LineBox[{4647, 4648}]}, 
    {Hue[
      NCache[
       Rational[4648, 14307], 0.32487593485706295`]], AbsoluteThickness[0.25],
      LineBox[{4648, 4649}]}, 
    {Hue[
      NCache[
       Rational[4649, 14307], 0.32494583071223876`]], AbsoluteThickness[0.25],
      LineBox[{4649, 4650}]}, 
    {Hue[
      NCache[
       Rational[1550, 4769], 0.32501572656741456`]], AbsoluteThickness[0.25], 
     LineBox[{4650, 4651}]}, 
    {Hue[
      NCache[
       Rational[4651, 14307], 0.3250856224225903]], AbsoluteThickness[0.25], 
     LineBox[{4651, 4652}]}, 
    {Hue[
      NCache[
       Rational[4652, 14307], 0.3251555182777661]], AbsoluteThickness[0.25], 
     LineBox[{4652, 4653}]}, 
    {Hue[
      NCache[
       Rational[1551, 4769], 0.3252254141329419]], AbsoluteThickness[0.25], 
     LineBox[{4653, 4654}]}, 
    {Hue[
      NCache[
       Rational[4654, 14307], 0.32529530998811773`]], AbsoluteThickness[0.25],
      LineBox[{4654, 4655}]}, 
    {Hue[
      NCache[
       Rational[245, 753], 0.3253652058432935]], AbsoluteThickness[0.25], 
     LineBox[{4655, 4656}]}, 
    {Hue[
      NCache[
       Rational[1552, 4769], 0.3254351016984693]], AbsoluteThickness[0.25], 
     LineBox[{4656, 4657}]}, 
    {Hue[
      NCache[
       Rational[4657, 14307], 0.3255049975536451]], AbsoluteThickness[0.25], 
     LineBox[{4657, 4658}]}, 
    {Hue[
      NCache[
       Rational[4658, 14307], 0.32557489340882084`]], AbsoluteThickness[0.25],
      LineBox[{4658, 4659}]}, 
    {Hue[
      NCache[
       Rational[1553, 4769], 0.32564478926399665`]], AbsoluteThickness[0.25], 
     LineBox[{4659, 4660}]}, 
    {Hue[
      NCache[
       Rational[4660, 14307], 0.32571468511917245`]], AbsoluteThickness[0.25],
      LineBox[{4660, 4661}]}, 
    {Hue[
      NCache[
       Rational[4661, 14307], 0.3257845809743482]], AbsoluteThickness[0.25], 
     LineBox[{4661, 4662}]}, 
    {Hue[
      NCache[
       Rational[1554, 4769], 0.325854476829524]], AbsoluteThickness[0.25], 
     LineBox[{4662, 4663}]}, 
    {Hue[
      NCache[
       Rational[4663, 14307], 0.3259243726846998]], AbsoluteThickness[0.25], 
     LineBox[{4663, 4664}]}, 
    {Hue[
      NCache[
       Rational[4664, 14307], 0.32599426853987556`]], AbsoluteThickness[0.25],
      LineBox[{4664, 4665}]}, 
    {Hue[
      NCache[
       Rational[1555, 4769], 0.32606416439505137`]], AbsoluteThickness[0.25], 
     LineBox[{4665, 4666}]}, 
    {Hue[
      NCache[
       Rational[4666, 14307], 0.3261340602502272]], AbsoluteThickness[0.25], 
     LineBox[{4666, 4667}]}, 
    {Hue[
      NCache[
       Rational[4667, 14307], 0.3262039561054029]], AbsoluteThickness[0.25], 
     LineBox[{4667, 4668}]}, 
    {Hue[
      NCache[
       Rational[1556, 4769], 0.32627385196057873`]], AbsoluteThickness[0.25], 
     LineBox[{4668, 4669}]}, 
    {Hue[
      NCache[
       Rational[4669, 14307], 0.32634374781575454`]], AbsoluteThickness[0.25],
      LineBox[{4669, 4670}]}, 
    {Hue[
      NCache[
       Rational[4670, 14307], 0.3264136436709303]], AbsoluteThickness[0.25], 
     LineBox[{4670, 4671}]}, 
    {Hue[
      NCache[
       Rational[1557, 4769], 0.3264835395261061]], AbsoluteThickness[0.25], 
     LineBox[{4671, 4672}]}, 
    {Hue[
      NCache[
       Rational[4672, 14307], 0.3265534353812819]], AbsoluteThickness[0.25], 
     LineBox[{4672, 4673}]}, 
    {Hue[
      NCache[
       Rational[4673, 14307], 0.3266233312364577]], AbsoluteThickness[0.25], 
     LineBox[{4673, 4674}]}, 
    {Hue[
      NCache[
       Rational[82, 251], 0.32669322709163345`]], AbsoluteThickness[0.25], 
     LineBox[{4674, 4675}]}, 
    {Hue[
      NCache[
       Rational[4675, 14307], 0.32676312294680926`]], AbsoluteThickness[0.25],
      LineBox[{4675, 4676}]}, 
    {Hue[
      NCache[
       Rational[4676, 14307], 0.32683301880198506`]], AbsoluteThickness[0.25],
      LineBox[{4676, 4677}]}, 
    {Hue[
      NCache[
       Rational[1559, 4769], 0.3269029146571608]], AbsoluteThickness[0.25], 
     LineBox[{4677, 4678}]}, 
    {Hue[
      NCache[
       Rational[4678, 14307], 0.3269728105123366]], AbsoluteThickness[0.25], 
     LineBox[{4678, 4679}]}, 
    {Hue[
      NCache[
       Rational[4679, 14307], 0.3270427063675124]], AbsoluteThickness[0.25], 
     LineBox[{4679, 4680}]}, 
    {Hue[
      NCache[
       Rational[1560, 4769], 0.3271126022226882]], AbsoluteThickness[0.25], 
     LineBox[{4680, 4681}]}, 
    {Hue[
      NCache[
       Rational[4681, 14307], 0.327182498077864]], AbsoluteThickness[0.25], 
     LineBox[{4681, 4682}]}, 
    {Hue[
      NCache[
       Rational[4682, 14307], 0.3272523939330398]], AbsoluteThickness[0.25], 
     LineBox[{4682, 4683}]}, 
    {Hue[
      NCache[
       Rational[1561, 4769], 0.32732228978821554`]], AbsoluteThickness[0.25], 
     LineBox[{4683, 4684}]}, 
    {Hue[
      NCache[
       Rational[4684, 14307], 0.32739218564339134`]], AbsoluteThickness[0.25],
      LineBox[{4684, 4685}]}, 
    {Hue[
      NCache[
       Rational[4685, 14307], 0.32746208149856715`]], AbsoluteThickness[0.25],
      LineBox[{4685, 4686}]}, 
    {Hue[
      NCache[
       Rational[1562, 4769], 0.3275319773537429]], AbsoluteThickness[0.25], 
     LineBox[{4686, 4687}]}, 
    {Hue[
      NCache[
       Rational[4687, 14307], 0.3276018732089187]], AbsoluteThickness[0.25], 
     LineBox[{4687, 4688}]}, 
    {Hue[
      NCache[
       Rational[4688, 14307], 0.3276717690640945]], AbsoluteThickness[0.25], 
     LineBox[{4688, 4689}]}, 
    {Hue[
      NCache[
       Rational[1563, 4769], 0.3277416649192703]], AbsoluteThickness[0.25], 
     LineBox[{4689, 4690}]}, 
    {Hue[
      NCache[
       Rational[4690, 14307], 0.32781156077444606`]], AbsoluteThickness[0.25],
      LineBox[{4690, 4691}]}, 
    {Hue[
      NCache[
       Rational[4691, 14307], 0.32788145662962187`]], AbsoluteThickness[0.25],
      LineBox[{4691, 4692}]}, 
    {Hue[
      NCache[
       Rational[1564, 4769], 0.3279513524847977]], AbsoluteThickness[0.25], 
     LineBox[{4692, 4693}]}, 
    {Hue[
      NCache[
       Rational[247, 753], 0.3280212483399734]], AbsoluteThickness[0.25], 
     LineBox[{4693, 4694}]}, 
    {Hue[
      NCache[
       Rational[4694, 14307], 0.32809114419514923`]], AbsoluteThickness[0.25],
      LineBox[{4694, 4695}]}, 
    {Hue[
      NCache[
       Rational[1565, 4769], 0.32816104005032504`]], AbsoluteThickness[0.25], 
     LineBox[{4695, 4696}]}, 
    {Hue[
      NCache[
       Rational[4696, 14307], 0.3282309359055008]], AbsoluteThickness[0.25], 
     LineBox[{4696, 4697}]}, 
    {Hue[
      NCache[
       Rational[4697, 14307], 0.3283008317606766]], AbsoluteThickness[0.25], 
     LineBox[{4697, 4698}]}, 
    {Hue[
      NCache[
       Rational[1566, 4769], 0.3283707276158524]], AbsoluteThickness[0.25], 
     LineBox[{4698, 4699}]}, 
    {Hue[
      NCache[
       Rational[4699, 14307], 0.32844062347102815`]], AbsoluteThickness[0.25],
      LineBox[{4699, 4700}]}, 
    {Hue[
      NCache[
       Rational[4700, 14307], 0.32851051932620395`]], AbsoluteThickness[0.25],
      LineBox[{4700, 4701}]}, 
    {Hue[
      NCache[
       Rational[1567, 4769], 0.32858041518137976`]], AbsoluteThickness[0.25], 
     LineBox[{4701, 4702}]}, 
    {Hue[
      NCache[
       Rational[4702, 14307], 0.3286503110365555]], AbsoluteThickness[0.25], 
     LineBox[{4702, 4703}]}, 
    {Hue[
      NCache[
       Rational[4703, 14307], 0.3287202068917313]], AbsoluteThickness[0.25], 
     LineBox[{4703, 4704}]}, 
    {Hue[
      NCache[
       Rational[1568, 4769], 0.3287901027469071]], AbsoluteThickness[0.25], 
     LineBox[{4704, 4705}]}, 
    {Hue[
      NCache[
       Rational[4705, 14307], 0.32885999860208287`]], AbsoluteThickness[0.25],
      LineBox[{4705, 4706}]}, 
    {Hue[
      NCache[
       Rational[4706, 14307], 0.3289298944572587]], AbsoluteThickness[0.25], 
     LineBox[{4706, 4707}]}, 
    {Hue[
      NCache[
       Rational[1569, 4769], 0.3289997903124345]], AbsoluteThickness[0.25], 
     LineBox[{4707, 4708}]}, 
    {Hue[
      NCache[
       Rational[4708, 14307], 0.3290696861676103]], AbsoluteThickness[0.25], 
     LineBox[{4708, 4709}]}, 
    {Hue[
      NCache[
       Rational[4709, 14307], 0.32913958202278604`]], AbsoluteThickness[0.25],
      LineBox[{4709, 4710}]}, 
    {Hue[
      NCache[
       Rational[1570, 4769], 0.32920947787796184`]], AbsoluteThickness[0.25], 
     LineBox[{4710, 4711}]}, 
    {Hue[
      NCache[
       Rational[4711, 14307], 0.32927937373313765`]], AbsoluteThickness[0.25],
      LineBox[{4711, 4712}]}, 
    {Hue[
      NCache[
       Rational[248, 753], 0.3293492695883134]], AbsoluteThickness[0.25], 
     LineBox[{4712, 4713}]}, 
    {Hue[
      NCache[
       Rational[1571, 4769], 0.3294191654434892]], AbsoluteThickness[0.25], 
     LineBox[{4713, 4714}]}, 
    {Hue[
      NCache[
       Rational[4714, 14307], 0.329489061298665]], AbsoluteThickness[0.25], 
     LineBox[{4714, 4715}]}, 
    {Hue[
      NCache[
       Rational[4715, 14307], 0.32955895715384076`]], AbsoluteThickness[0.25],
      LineBox[{4715, 4716}]}, 
    {Hue[
      NCache[
       Rational[1572, 4769], 0.32962885300901656`]], AbsoluteThickness[0.25], 
     LineBox[{4716, 4717}]}, 
    {Hue[
      NCache[
       Rational[4717, 14307], 0.32969874886419237`]], AbsoluteThickness[0.25],
      LineBox[{4717, 4718}]}, 
    {Hue[
      NCache[
       Rational[4718, 14307], 0.3297686447193681]], AbsoluteThickness[0.25], 
     LineBox[{4718, 4719}]}, 
    {Hue[
      NCache[
       Rational[1573, 4769], 0.3298385405745439]], AbsoluteThickness[0.25], 
     LineBox[{4719, 4720}]}, 
    {Hue[
      NCache[
       Rational[4720, 14307], 0.32990843642971973`]], AbsoluteThickness[0.25],
      LineBox[{4720, 4721}]}, 
    {Hue[
      NCache[
       Rational[4721, 14307], 0.3299783322848955]], AbsoluteThickness[0.25], 
     LineBox[{4721, 4722}]}, 
    {Hue[
      NCache[
       Rational[1574, 4769], 0.3300482281400713]], AbsoluteThickness[0.25], 
     LineBox[{4722, 4723}]}, 
    {Hue[
      NCache[
       Rational[4723, 14307], 0.3301181239952471]], AbsoluteThickness[0.25], 
     LineBox[{4723, 4724}]}, 
    {Hue[
      NCache[
       Rational[4724, 14307], 0.33018801985042284`]], AbsoluteThickness[0.25],
      LineBox[{4724, 4725}]}, 
    {Hue[
      NCache[
       Rational[1575, 4769], 0.33025791570559865`]], AbsoluteThickness[0.25], 
     LineBox[{4725, 4726}]}, 
    {Hue[
      NCache[
       Rational[4726, 14307], 0.33032781156077445`]], AbsoluteThickness[0.25],
      LineBox[{4726, 4727}]}, 
    {Hue[
      NCache[
       Rational[4727, 14307], 0.33039770741595026`]], AbsoluteThickness[0.25],
      LineBox[{4727, 4728}]}, 
    {Hue[
      NCache[
       Rational[1576, 4769], 0.330467603271126]], AbsoluteThickness[0.25], 
     LineBox[{4728, 4729}]}, 
    {Hue[
      NCache[
       Rational[4729, 14307], 0.3305374991263018]], AbsoluteThickness[0.25], 
     LineBox[{4729, 4730}]}, 
    {Hue[
      NCache[
       Rational[4730, 14307], 0.3306073949814776]], AbsoluteThickness[0.25], 
     LineBox[{4730, 4731}]}, 
    {Hue[
      NCache[
       Rational[83, 251], 0.33067729083665337`]], AbsoluteThickness[0.25], 
     LineBox[{4731, 4732}]}, 
    {Hue[
      NCache[
       Rational[4732, 14307], 0.3307471866918292]], AbsoluteThickness[0.25], 
     LineBox[{4732, 4733}]}, 
    {Hue[
      NCache[
       Rational[4733, 14307], 0.330817082547005]], AbsoluteThickness[0.25], 
     LineBox[{4733, 4734}]}, 
    {Hue[
      NCache[
       Rational[1578, 4769], 0.33088697840218073`]], AbsoluteThickness[0.25], 
     LineBox[{4734, 4735}]}, 
    {Hue[
      NCache[
       Rational[4735, 14307], 0.33095687425735654`]], AbsoluteThickness[0.25],
      LineBox[{4735, 4736}]}, 
    {Hue[
      NCache[
       Rational[4736, 14307], 0.33102677011253234`]], AbsoluteThickness[0.25],
      LineBox[{4736, 4737}]}, 
    {Hue[
      NCache[
       Rational[1579, 4769], 0.3310966659677081]], AbsoluteThickness[0.25], 
     LineBox[{4737, 4738}]}, 
    {Hue[
      NCache[
       Rational[4738, 14307], 0.3311665618228839]], AbsoluteThickness[0.25], 
     LineBox[{4738, 4739}]}, 
    {Hue[
      NCache[
       Rational[4739, 14307], 0.3312364576780597]], AbsoluteThickness[0.25], 
     LineBox[{4739, 4740}]}, 
    {Hue[
      NCache[
       Rational[1580, 4769], 0.33130635353323545`]], AbsoluteThickness[0.25], 
     LineBox[{4740, 4741}]}, 
    {Hue[
      NCache[
       Rational[4741, 14307], 0.33137624938841126`]], AbsoluteThickness[0.25],
      LineBox[{4741, 4742}]}, 
    {Hue[
      NCache[
       Rational[4742, 14307], 0.33144614524358706`]], AbsoluteThickness[0.25],
      LineBox[{4742, 4743}]}, 
    {Hue[
      NCache[
       Rational[1581, 4769], 0.33151604109876287`]], AbsoluteThickness[0.25], 
     LineBox[{4743, 4744}]}, 
    {Hue[
      NCache[
       Rational[4744, 14307], 0.3315859369539386]], AbsoluteThickness[0.25], 
     LineBox[{4744, 4745}]}, 
    {Hue[
      NCache[
       Rational[4745, 14307], 0.3316558328091144]], AbsoluteThickness[0.25], 
     LineBox[{4745, 4746}]}, 
    {Hue[
      NCache[
       Rational[1582, 4769], 0.33172572866429023`]], AbsoluteThickness[0.25], 
     LineBox[{4746, 4747}]}, 
    {Hue[
      NCache[
       Rational[4747, 14307], 0.331795624519466]], AbsoluteThickness[0.25], 
     LineBox[{4747, 4748}]}, 
    {Hue[
      NCache[
       Rational[4748, 14307], 0.3318655203746418]], AbsoluteThickness[0.25], 
     LineBox[{4748, 4749}]}, 
    {Hue[
      NCache[
       Rational[1583, 4769], 0.3319354162298176]], AbsoluteThickness[0.25], 
     LineBox[{4749, 4750}]}, 
    {Hue[
      NCache[
       Rational[250, 753], 0.33200531208499334`]], AbsoluteThickness[0.25], 
     LineBox[{4750, 4751}]}, 
    {Hue[
      NCache[
       Rational[4751, 14307], 0.33207520794016915`]], AbsoluteThickness[0.25],
      LineBox[{4751, 4752}]}, 
    {Hue[
      NCache[
       Rational[1584, 4769], 0.33214510379534495`]], AbsoluteThickness[0.25], 
     LineBox[{4752, 4753}]}, 
    {Hue[
      NCache[
       Rational[4753, 14307], 0.3322149996505207]], AbsoluteThickness[0.25], 
     LineBox[{4753, 4754}]}, 
    {Hue[
      NCache[
       Rational[4754, 14307], 0.3322848955056965]], AbsoluteThickness[0.25], 
     LineBox[{4754, 4755}]}, 
    {Hue[
      NCache[
       Rational[1585, 4769], 0.3323547913608723]], AbsoluteThickness[0.25], 
     LineBox[{4755, 4756}]}, 
    {Hue[
      NCache[
       Rational[4756, 14307], 0.33242468721604806`]], AbsoluteThickness[0.25],
      LineBox[{4756, 4757}]}, 
    {Hue[
      NCache[
       Rational[4757, 14307], 0.33249458307122387`]], AbsoluteThickness[0.25],
      LineBox[{4757, 4758}]}, 
    {Hue[
      NCache[
       Rational[1586, 4769], 0.3325644789263997]], AbsoluteThickness[0.25], 
     LineBox[{4758, 4759}]}, 
    {Hue[
      NCache[
       Rational[4759, 14307], 0.3326343747815754]], AbsoluteThickness[0.25], 
     LineBox[{4759, 4760}]}, 
    {Hue[
      NCache[
       Rational[4760, 14307], 0.33270427063675123`]], AbsoluteThickness[0.25],
      LineBox[{4760, 4761}]}, 
    {Hue[
      NCache[
       Rational[1587, 4769], 0.33277416649192704`]], AbsoluteThickness[0.25], 
     LineBox[{4761, 4762}]}, 
    {Hue[
      NCache[
       Rational[4762, 14307], 0.33284406234710284`]], AbsoluteThickness[0.25],
      LineBox[{4762, 4763}]}, 
    {Hue[
      NCache[
       Rational[4763, 14307], 0.3329139582022786]], AbsoluteThickness[0.25], 
     LineBox[{4763, 4764}]}, 
    {Hue[
      NCache[
       Rational[1588, 4769], 0.3329838540574544]], AbsoluteThickness[0.25], 
     LineBox[{4764, 4765}]}, 
    {Hue[
      NCache[
       Rational[4765, 14307], 0.3330537499126302]], AbsoluteThickness[0.25], 
     LineBox[{4765, 4766}]}, 
    {Hue[
      NCache[
       Rational[4766, 14307], 0.33312364576780595`]], AbsoluteThickness[0.25],
      LineBox[{4766, 4767}]}, 
    {Hue[
      NCache[
       Rational[1589, 4769], 0.33319354162298176`]], AbsoluteThickness[0.25], 
     LineBox[{4767, 4768}]}, 
    {Hue[
      NCache[
       Rational[4768, 14307], 0.33326343747815756`]], AbsoluteThickness[0.25],
      LineBox[{4768, 4769}]}, 
    {Hue[
      NCache[
       Rational[1, 3], 0.3333333333333333]], AbsoluteThickness[0.25], 
     LineBox[{4769, 4770}]}, 
    {Hue[
      NCache[
       Rational[1590, 4769], 0.3334032291885091]], AbsoluteThickness[0.25], 
     LineBox[{4770, 4771}]}, 
    {Hue[
      NCache[
       Rational[4771, 14307], 0.3334731250436849]], AbsoluteThickness[0.25], 
     LineBox[{4771, 4772}]}, 
    {Hue[
      NCache[
       Rational[4772, 14307], 0.3335430208988607]], AbsoluteThickness[0.25], 
     LineBox[{4772, 4773}]}, 
    {Hue[
      NCache[
       Rational[1591, 4769], 0.3336129167540365]], AbsoluteThickness[0.25], 
     LineBox[{4773, 4774}]}, 
    {Hue[
      NCache[
       Rational[4774, 14307], 0.3336828126092123]], AbsoluteThickness[0.25], 
     LineBox[{4774, 4775}]}, 
    {Hue[
      NCache[
       Rational[4775, 14307], 0.33375270846438804`]], AbsoluteThickness[0.25],
      LineBox[{4775, 4776}]}, 
    {Hue[
      NCache[
       Rational[1592, 4769], 0.33382260431956384`]], AbsoluteThickness[0.25], 
     LineBox[{4776, 4777}]}, 
    {Hue[
      NCache[
       Rational[4777, 14307], 0.33389250017473965`]], AbsoluteThickness[0.25],
      LineBox[{4777, 4778}]}, 
    {Hue[
      NCache[
       Rational[4778, 14307], 0.33396239602991545`]], AbsoluteThickness[0.25],
      LineBox[{4778, 4779}]}, 
    {Hue[
      NCache[
       Rational[1593, 4769], 0.3340322918850912]], AbsoluteThickness[0.25], 
     LineBox[{4779, 4780}]}, 
    {Hue[
      NCache[
       Rational[4780, 14307], 0.334102187740267]], AbsoluteThickness[0.25], 
     LineBox[{4780, 4781}]}, 
    {Hue[
      NCache[
       Rational[4781, 14307], 0.3341720835954428]], AbsoluteThickness[0.25], 
     LineBox[{4781, 4782}]}, 
    {Hue[
      NCache[
       Rational[1594, 4769], 0.33424197945061856`]], AbsoluteThickness[0.25], 
     LineBox[{4782, 4783}]}, 
    {Hue[
      NCache[
       Rational[4783, 14307], 0.33431187530579437`]], AbsoluteThickness[0.25],
      LineBox[{4783, 4784}]}, 
    {Hue[
      NCache[
       Rational[4784, 14307], 0.3343817711609702]], AbsoluteThickness[0.25], 
     LineBox[{4784, 4785}]}, 
    {Hue[
      NCache[
       Rational[1595, 4769], 0.3344516670161459]], AbsoluteThickness[0.25], 
     LineBox[{4785, 4786}]}, 
    {Hue[
      NCache[
       Rational[4786, 14307], 0.33452156287132173`]], AbsoluteThickness[0.25],
      LineBox[{4786, 4787}]}, 
    {Hue[
      NCache[
       Rational[4787, 14307], 0.33459145872649754`]], AbsoluteThickness[0.25],
      LineBox[{4787, 4788}]}, 
    {Hue[
      NCache[
       Rational[84, 251], 0.3346613545816733]], AbsoluteThickness[0.25], 
     LineBox[{4788, 4789}]}, 
    {Hue[
      NCache[
       Rational[4789, 14307], 0.3347312504368491]], AbsoluteThickness[0.25], 
     LineBox[{4789, 4790}]}, 
    {Hue[
      NCache[
       Rational[4790, 14307], 0.3348011462920249]], AbsoluteThickness[0.25], 
     LineBox[{4790, 4791}]}, 
    {Hue[
      NCache[
       Rational[1597, 4769], 0.33487104214720065`]], AbsoluteThickness[0.25], 
     LineBox[{4791, 4792}]}, 
    {Hue[
      NCache[
       Rational[4792, 14307], 0.33494093800237645`]], AbsoluteThickness[0.25],
      LineBox[{4792, 4793}]}, 
    {Hue[
      NCache[
       Rational[4793, 14307], 0.33501083385755226`]], AbsoluteThickness[0.25],
      LineBox[{4793, 4794}]}, 
    {Hue[
      NCache[
       Rational[1598, 4769], 0.335080729712728]], AbsoluteThickness[0.25], 
     LineBox[{4794, 4795}]}, 
    {Hue[
      NCache[
       Rational[4795, 14307], 0.3351506255679038]], AbsoluteThickness[0.25], 
     LineBox[{4795, 4796}]}, 
    {Hue[
      NCache[
       Rational[4796, 14307], 0.3352205214230796]], AbsoluteThickness[0.25], 
     LineBox[{4796, 4797}]}, 
    {Hue[
      NCache[
       Rational[1599, 4769], 0.3352904172782554]], AbsoluteThickness[0.25], 
     LineBox[{4797, 4798}]}, 
    {Hue[
      NCache[
       Rational[4798, 14307], 0.3353603131334312]], AbsoluteThickness[0.25], 
     LineBox[{4798, 4799}]}, 
    {Hue[
      NCache[
       Rational[4799, 14307], 0.335430208988607]], AbsoluteThickness[0.25], 
     LineBox[{4799, 4800}]}, 
    {Hue[
      NCache[
       Rational[1600, 4769], 0.3355001048437828]], AbsoluteThickness[0.25], 
     LineBox[{4800, 4801}]}, 
    {Hue[
      NCache[
       Rational[4801, 14307], 0.33557000069895854`]], AbsoluteThickness[0.25],
      LineBox[{4801, 4802}]}, 
    {Hue[
      NCache[
       Rational[4802, 14307], 0.33563989655413434`]], AbsoluteThickness[0.25],
      LineBox[{4802, 4803}]}, 
    {Hue[
      NCache[
       Rational[1601, 4769], 0.33570979240931015`]], AbsoluteThickness[0.25], 
     LineBox[{4803, 4804}]}, 
    {Hue[
      NCache[
       Rational[4804, 14307], 0.3357796882644859]], AbsoluteThickness[0.25], 
     LineBox[{4804, 4805}]}, 
    {Hue[
      NCache[
       Rational[4805, 14307], 0.3358495841196617]], AbsoluteThickness[0.25], 
     LineBox[{4805, 4806}]}, 
    {Hue[
      NCache[
       Rational[1602, 4769], 0.3359194799748375]], AbsoluteThickness[0.25], 
     LineBox[{4806, 4807}]}, 
    {Hue[
      NCache[
       Rational[253, 753], 0.33598937583001326`]], AbsoluteThickness[0.25], 
     LineBox[{4807, 4808}]}, 
    {Hue[
      NCache[
       Rational[4808, 14307], 0.33605927168518906`]], AbsoluteThickness[0.25],
      LineBox[{4808, 4809}]}, 
    {Hue[
      NCache[
       Rational[1603, 4769], 0.33612916754036487`]], AbsoluteThickness[0.25], 
     LineBox[{4809, 4810}]}, 
    {Hue[
      NCache[
       Rational[4810, 14307], 0.3361990633955406]], AbsoluteThickness[0.25], 
     LineBox[{4810, 4811}]}, 
    {Hue[
      NCache[
       Rational[4811, 14307], 0.3362689592507164]], AbsoluteThickness[0.25], 
     LineBox[{4811, 4812}]}, 
    {Hue[
      NCache[
       Rational[1604, 4769], 0.33633885510589223`]], AbsoluteThickness[0.25], 
     LineBox[{4812, 4813}]}, 
    {Hue[
      NCache[
       Rational[4813, 14307], 0.336408750961068]], AbsoluteThickness[0.25], 
     LineBox[{4813, 4814}]}, 
    {Hue[
      NCache[
       Rational[4814, 14307], 0.3364786468162438]], AbsoluteThickness[0.25], 
     LineBox[{4814, 4815}]}, 
    {Hue[
      NCache[
       Rational[1605, 4769], 0.3365485426714196]], AbsoluteThickness[0.25], 
     LineBox[{4815, 4816}]}, 
    {Hue[
      NCache[
       Rational[4816, 14307], 0.3366184385265954]], AbsoluteThickness[0.25], 
     LineBox[{4816, 4817}]}, 
    {Hue[
      NCache[
       Rational[4817, 14307], 0.33668833438177115`]], AbsoluteThickness[0.25],
      LineBox[{4817, 4818}]}, 
    {Hue[
      NCache[
       Rational[1606, 4769], 0.33675823023694695`]], AbsoluteThickness[0.25], 
     LineBox[{4818, 4819}]}, 
    {Hue[
      NCache[
       Rational[4819, 14307], 0.33682812609212276`]], AbsoluteThickness[0.25],
      LineBox[{4819, 4820}]}, 
    {Hue[
      NCache[
       Rational[4820, 14307], 0.3368980219472985]], AbsoluteThickness[0.25], 
     LineBox[{4820, 4821}]}, 
    {Hue[
      NCache[
       Rational[1607, 4769], 0.3369679178024743]], AbsoluteThickness[0.25], 
     LineBox[{4821, 4822}]}, 
    {Hue[
      NCache[
       Rational[4822, 14307], 0.3370378136576501]], AbsoluteThickness[0.25], 
     LineBox[{4822, 4823}]}, 
    {Hue[
      NCache[
       Rational[4823, 14307], 0.33710770951282587`]], AbsoluteThickness[0.25],
      LineBox[{4823, 4824}]}, 
    {Hue[
      NCache[
       Rational[1608, 4769], 0.3371776053680017]], AbsoluteThickness[0.25], 
     LineBox[{4824, 4825}]}, 
    {Hue[
      NCache[
       Rational[4825, 14307], 0.3372475012231775]], AbsoluteThickness[0.25], 
     LineBox[{4825, 4826}]}, 
    {Hue[
      NCache[
       Rational[254, 753], 0.33731739707835323`]], AbsoluteThickness[0.25], 
     LineBox[{4826, 4827}]}, 
    {Hue[
      NCache[
       Rational[1609, 4769], 0.33738729293352904`]], AbsoluteThickness[0.25], 
     LineBox[{4827, 4828}]}, 
    {Hue[
      NCache[
       Rational[4828, 14307], 0.33745718878870484`]], AbsoluteThickness[0.25],
      LineBox[{4828, 4829}]}, 
    {Hue[
      NCache[
       Rational[4829, 14307], 0.3375270846438806]], AbsoluteThickness[0.25], 
     LineBox[{4829, 4830}]}, 
    {Hue[
      NCache[
       Rational[1610, 4769], 0.3375969804990564]], AbsoluteThickness[0.25], 
     LineBox[{4830, 4831}]}, 
    {Hue[
      NCache[
       Rational[4831, 14307], 0.3376668763542322]], AbsoluteThickness[0.25], 
     LineBox[{4831, 4832}]}, 
    {Hue[
      NCache[
       Rational[4832, 14307], 0.337736772209408]], AbsoluteThickness[0.25], 
     LineBox[{4832, 4833}]}, 
    {Hue[
      NCache[
       Rational[1611, 4769], 0.33780666806458376`]], AbsoluteThickness[0.25], 
     LineBox[{4833, 4834}]}, 
    {Hue[
      NCache[
       Rational[4834, 14307], 0.33787656391975956`]], AbsoluteThickness[0.25],
      LineBox[{4834, 4835}]}, 
    {Hue[
      NCache[
       Rational[4835, 14307], 0.33794645977493537`]], AbsoluteThickness[0.25],
      LineBox[{4835, 4836}]}, 
    {Hue[
      NCache[
       Rational[1612, 4769], 0.3380163556301111]], AbsoluteThickness[0.25], 
     LineBox[{4836, 4837}]}, 
    {Hue[
      NCache[
       Rational[4837, 14307], 0.3380862514852869]], AbsoluteThickness[0.25], 
     LineBox[{4837, 4838}]}, 
    {Hue[
      NCache[
       Rational[4838, 14307], 0.33815614734046273`]], AbsoluteThickness[0.25],
      LineBox[{4838, 4839}]}, 
    {Hue[
      NCache[
       Rational[1613, 4769], 0.3382260431956385]], AbsoluteThickness[0.25], 
     LineBox[{4839, 4840}]}, 
    {Hue[
      NCache[
       Rational[4840, 14307], 0.3382959390508143]], AbsoluteThickness[0.25], 
     LineBox[{4840, 4841}]}, 
    {Hue[
      NCache[
       Rational[4841, 14307], 0.3383658349059901]], AbsoluteThickness[0.25], 
     LineBox[{4841, 4842}]}, 
    {Hue[
      NCache[
       Rational[1614, 4769], 0.33843573076116584`]], AbsoluteThickness[0.25], 
     LineBox[{4842, 4843}]}, 
    {Hue[
      NCache[
       Rational[4843, 14307], 0.33850562661634165`]], AbsoluteThickness[0.25],
      LineBox[{4843, 4844}]}, 
    {Hue[
      NCache[
       Rational[4844, 14307], 0.33857552247151745`]], AbsoluteThickness[0.25],
      LineBox[{4844, 4845}]}, 
    {Hue[
      NCache[
       Rational[85, 251], 0.3386454183266932]], AbsoluteThickness[0.25], 
     LineBox[{4845, 4846}]}, 
    {Hue[
      NCache[
       Rational[4846, 14307], 0.338715314181869]], AbsoluteThickness[0.25], 
     LineBox[{4846, 4847}]}, 
    {Hue[
      NCache[
       Rational[4847, 14307], 0.3387852100370448]], AbsoluteThickness[0.25], 
     LineBox[{4847, 4848}]}, 
    {Hue[
      NCache[
       Rational[1616, 4769], 0.33885510589222056`]], AbsoluteThickness[0.25], 
     LineBox[{4848, 4849}]}, 
    {Hue[
      NCache[
       Rational[4849, 14307], 0.33892500174739637`]], AbsoluteThickness[0.25],
      LineBox[{4849, 4850}]}, 
    {Hue[
      NCache[
       Rational[4850, 14307], 0.3389948976025722]], AbsoluteThickness[0.25], 
     LineBox[{4850, 4851}]}, 
    {Hue[
      NCache[
       Rational[1617, 4769], 0.339064793457748]], AbsoluteThickness[0.25], 
     LineBox[{4851, 4852}]}, 
    {Hue[
      NCache[
       Rational[4852, 14307], 0.33913468931292373`]], AbsoluteThickness[0.25],
      LineBox[{4852, 4853}]}, 
    {Hue[
      NCache[
       Rational[4853, 14307], 0.33920458516809954`]], AbsoluteThickness[0.25],
      LineBox[{4853, 4854}]}, 
    {Hue[
      NCache[
       Rational[1618, 4769], 0.33927448102327534`]], AbsoluteThickness[0.25], 
     LineBox[{4854, 4855}]}, 
    {Hue[
      NCache[
       Rational[4855, 14307], 0.3393443768784511]], AbsoluteThickness[0.25], 
     LineBox[{4855, 4856}]}, 
    {Hue[
      NCache[
       Rational[4856, 14307], 0.3394142727336269]], AbsoluteThickness[0.25], 
     LineBox[{4856, 4857}]}, 
    {Hue[
      NCache[
       Rational[1619, 4769], 0.3394841685888027]], AbsoluteThickness[0.25], 
     LineBox[{4857, 4858}]}, 
    {Hue[
      NCache[
       Rational[4858, 14307], 0.33955406444397845`]], AbsoluteThickness[0.25],
      LineBox[{4858, 4859}]}, 
    {Hue[
      NCache[
       Rational[4859, 14307], 0.33962396029915426`]], AbsoluteThickness[0.25],
      LineBox[{4859, 4860}]}, 
    {Hue[
      NCache[
       Rational[1620, 4769], 0.33969385615433006`]], AbsoluteThickness[0.25], 
     LineBox[{4860, 4861}]}, 
    {Hue[
      NCache[
       Rational[4861, 14307], 0.3397637520095058]], AbsoluteThickness[0.25], 
     LineBox[{4861, 4862}]}, 
    {Hue[
      NCache[
       Rational[4862, 14307], 0.3398336478646816]], AbsoluteThickness[0.25], 
     LineBox[{4862, 4863}]}, 
    {Hue[
      NCache[
       Rational[1621, 4769], 0.3399035437198574]], AbsoluteThickness[0.25], 
     LineBox[{4863, 4864}]}, 
    {Hue[
      NCache[
       Rational[256, 753], 0.3399734395750332]], AbsoluteThickness[0.25], 
     LineBox[{4864, 4865}]}, 
    {Hue[
      NCache[
       Rational[4865, 14307], 0.340043335430209]], AbsoluteThickness[0.25], 
     LineBox[{4865, 4866}]}, 
    {Hue[
      NCache[
       Rational[1622, 4769], 0.3401132312853848]], AbsoluteThickness[0.25], 
     LineBox[{4866, 4867}]}, 
    {Hue[
      NCache[
       Rational[4867, 14307], 0.34018312714056054`]], AbsoluteThickness[0.25],
      LineBox[{4867, 4868}]}, 
    {Hue[
      NCache[
       Rational[4868, 14307], 0.34025302299573634`]], AbsoluteThickness[0.25],
      LineBox[{4868, 4869}]}, 
    {Hue[
      NCache[
       Rational[1623, 4769], 0.34032291885091215`]], AbsoluteThickness[0.25], 
     LineBox[{4869, 4870}]}, 
    {Hue[
      NCache[
       Rational[4870, 14307], 0.34039281470608795`]], AbsoluteThickness[0.25],
      LineBox[{4870, 4871}]}, 
    {Hue[
      NCache[
       Rational[4871, 14307], 0.3404627105612637]], AbsoluteThickness[0.25], 
     LineBox[{4871, 4872}]}, 
    {Hue[
      NCache[
       Rational[1624, 4769], 0.3405326064164395]], AbsoluteThickness[0.25], 
     LineBox[{4872, 4873}]}, 
    {Hue[
      NCache[
       Rational[4873, 14307], 0.3406025022716153]], AbsoluteThickness[0.25], 
     LineBox[{4873, 4874}]}, 
    {Hue[
      NCache[
       Rational[4874, 14307], 0.34067239812679107`]], AbsoluteThickness[0.25],
      LineBox[{4874, 4875}]}, 
    {Hue[
      NCache[
       Rational[1625, 4769], 0.34074229398196687`]], AbsoluteThickness[0.25], 
     LineBox[{4875, 4876}]}, 
    {Hue[
      NCache[
       Rational[4876, 14307], 0.3408121898371427]], AbsoluteThickness[0.25], 
     LineBox[{4876, 4877}]}, 
    {Hue[
      NCache[
       Rational[4877, 14307], 0.3408820856923184]], AbsoluteThickness[0.25], 
     LineBox[{4877, 4878}]}, 
    {Hue[
      NCache[
       Rational[1626, 4769], 0.34095198154749423`]], AbsoluteThickness[0.25], 
     LineBox[{4878, 4879}]}, 
    {Hue[
      NCache[
       Rational[4879, 14307], 0.34102187740267004`]], AbsoluteThickness[0.25],
      LineBox[{4879, 4880}]}, 
    {Hue[
      NCache[
       Rational[4880, 14307], 0.3410917732578458]], AbsoluteThickness[0.25], 
     LineBox[{4880, 4881}]}, 
    {Hue[
      NCache[
       Rational[1627, 4769], 0.3411616691130216]], AbsoluteThickness[0.25], 
     LineBox[{4881, 4882}]}, 
    {Hue[
      NCache[
       Rational[4882, 14307], 0.3412315649681974]], AbsoluteThickness[0.25], 
     LineBox[{4882, 4883}]}, 
    {Hue[
      NCache[
       Rational[257, 753], 0.34130146082337315`]], AbsoluteThickness[0.25], 
     LineBox[{4883, 4884}]}, 
    {Hue[
      NCache[
       Rational[1628, 4769], 0.34137135667854895`]], AbsoluteThickness[0.25], 
     LineBox[{4884, 4885}]}, 
    {Hue[
      NCache[
       Rational[4885, 14307], 0.34144125253372476`]], AbsoluteThickness[0.25],
      LineBox[{4885, 4886}]}, 
    {Hue[
      NCache[
       Rational[4886, 14307], 0.34151114838890057`]], AbsoluteThickness[0.25],
      LineBox[{4886, 4887}]}, 
    {Hue[
      NCache[
       Rational[1629, 4769], 0.3415810442440763]], AbsoluteThickness[0.25], 
     LineBox[{4887, 4888}]}, 
    {Hue[
      NCache[
       Rational[4888, 14307], 0.3416509400992521]], AbsoluteThickness[0.25], 
     LineBox[{4888, 4889}]}, 
    {Hue[
      NCache[
       Rational[4889, 14307], 0.3417208359544279]], AbsoluteThickness[0.25], 
     LineBox[{4889, 4890}]}, 
    {Hue[
      NCache[
       Rational[1630, 4769], 0.3417907318096037]], AbsoluteThickness[0.25], 
     LineBox[{4890, 4891}]}, 
    {Hue[
      NCache[
       Rational[4891, 14307], 0.3418606276647795]], AbsoluteThickness[0.25], 
     LineBox[{4891, 4892}]}, 
    {Hue[
      NCache[
       Rational[4892, 14307], 0.3419305235199553]], AbsoluteThickness[0.25], 
     LineBox[{4892, 4893}]}, 
    {Hue[
      NCache[
       Rational[1631, 4769], 0.34200041937513104`]], AbsoluteThickness[0.25], 
     LineBox[{4893, 4894}]}, 
    {Hue[
      NCache[
       Rational[4894, 14307], 0.34207031523030684`]], AbsoluteThickness[0.25],
      LineBox[{4894, 4895}]}, 
    {Hue[
      NCache[
       Rational[4895, 14307], 0.34214021108548265`]], AbsoluteThickness[0.25],
      LineBox[{4895, 4896}]}, 
    {Hue[
      NCache[
       Rational[1632, 4769], 0.3422101069406584]], AbsoluteThickness[0.25], 
     LineBox[{4896, 4897}]}, 
    {Hue[
      NCache[
       Rational[4897, 14307], 0.3422800027958342]], AbsoluteThickness[0.25], 
     LineBox[{4897, 4898}]}, 
    {Hue[
      NCache[
       Rational[4898, 14307], 0.34234989865101]], AbsoluteThickness[0.25], 
     LineBox[{4898, 4899}]}, 
    {Hue[
      NCache[
       Rational[1633, 4769], 0.34241979450618576`]], AbsoluteThickness[0.25], 
     LineBox[{4899, 4900}]}, 
    {Hue[
      NCache[
       Rational[4900, 14307], 0.34248969036136157`]], AbsoluteThickness[0.25],
      LineBox[{4900, 4901}]}, 
    {Hue[
      NCache[
       Rational[4901, 14307], 0.34255958621653737`]], AbsoluteThickness[0.25],
      LineBox[{4901, 4902}]}, 
    {Hue[
      NCache[
       Rational[86, 251], 0.3426294820717131]], AbsoluteThickness[0.25], 
     LineBox[{4902, 4903}]}, 
    {Hue[
      NCache[
       Rational[4903, 14307], 0.3426993779268889]], AbsoluteThickness[0.25], 
     LineBox[{4903, 4904}]}, 
    {Hue[
      NCache[
       Rational[4904, 14307], 0.34276927378206473`]], AbsoluteThickness[0.25],
      LineBox[{4904, 4905}]}, 
    {Hue[
      NCache[
       Rational[1635, 4769], 0.34283916963724054`]], AbsoluteThickness[0.25], 
     LineBox[{4905, 4906}]}, 
    {Hue[
      NCache[
       Rational[4906, 14307], 0.3429090654924163]], AbsoluteThickness[0.25], 
     LineBox[{4906, 4907}]}, 
    {Hue[
      NCache[
       Rational[4907, 14307], 0.3429789613475921]], AbsoluteThickness[0.25], 
     LineBox[{4907, 4908}]}, 
    {Hue[
      NCache[
       Rational[1636, 4769], 0.3430488572027679]], AbsoluteThickness[0.25], 
     LineBox[{4908, 4909}]}, 
    {Hue[
      NCache[
       Rational[4909, 14307], 0.34311875305794365`]], AbsoluteThickness[0.25],
      LineBox[{4909, 4910}]}, 
    {Hue[
      NCache[
       Rational[4910, 14307], 0.34318864891311945`]], AbsoluteThickness[0.25],
      LineBox[{4910, 4911}]}, 
    {Hue[
      NCache[
       Rational[1637, 4769], 0.34325854476829526`]], AbsoluteThickness[0.25], 
     LineBox[{4911, 4912}]}, 
    {Hue[
      NCache[
       Rational[4912, 14307], 0.343328440623471]], AbsoluteThickness[0.25], 
     LineBox[{4912, 4913}]}, 
    {Hue[
      NCache[
       Rational[4913, 14307], 0.3433983364786468]], AbsoluteThickness[0.25], 
     LineBox[{4913, 4914}]}, 
    {Hue[
      NCache[
       Rational[1638, 4769], 0.3434682323338226]], AbsoluteThickness[0.25], 
     LineBox[{4914, 4915}]}, 
    {Hue[
      NCache[
       Rational[4915, 14307], 0.34353812818899837`]], AbsoluteThickness[0.25],
      LineBox[{4915, 4916}]}, 
    {Hue[
      NCache[
       Rational[4916, 14307], 0.3436080240441742]], AbsoluteThickness[0.25], 
     LineBox[{4916, 4917}]}, 
    {Hue[
      NCache[
       Rational[1639, 4769], 0.34367791989935]], AbsoluteThickness[0.25], 
     LineBox[{4917, 4918}]}, 
    {Hue[
      NCache[
       Rational[4918, 14307], 0.34374781575452573`]], AbsoluteThickness[0.25],
      LineBox[{4918, 4919}]}, 
    {Hue[
      NCache[
       Rational[4919, 14307], 0.34381771160970154`]], AbsoluteThickness[0.25],
      LineBox[{4919, 4920}]}, 
    {Hue[
      NCache[
       Rational[1640, 4769], 0.34388760746487734`]], AbsoluteThickness[0.25], 
     LineBox[{4920, 4921}]}, 
    {Hue[
      NCache[
       Rational[259, 753], 0.34395750332005315`]], AbsoluteThickness[0.25], 
     LineBox[{4921, 4922}]}, 
    {Hue[
      NCache[
       Rational[4922, 14307], 0.3440273991752289]], AbsoluteThickness[0.25], 
     LineBox[{4922, 4923}]}, 
    {Hue[
      NCache[
       Rational[1641, 4769], 0.3440972950304047]], AbsoluteThickness[0.25], 
     LineBox[{4923, 4924}]}, 
    {Hue[
      NCache[
       Rational[4924, 14307], 0.3441671908855805]], AbsoluteThickness[0.25], 
     LineBox[{4924, 4925}]}, 
    {Hue[
      NCache[
       Rational[4925, 14307], 0.34423708674075626`]], AbsoluteThickness[0.25],
      LineBox[{4925, 4926}]}, 
    {Hue[
      NCache[
       Rational[1642, 4769], 0.34430698259593207`]], AbsoluteThickness[0.25], 
     LineBox[{4926, 4927}]}, 
    {Hue[
      NCache[
       Rational[4927, 14307], 0.34437687845110787`]], AbsoluteThickness[0.25],
      LineBox[{4927, 4928}]}, 
    {Hue[
      NCache[
       Rational[4928, 14307], 0.3444467743062836]], AbsoluteThickness[0.25], 
     LineBox[{4928, 4929}]}, 
    {Hue[
      NCache[
       Rational[1643, 4769], 0.3445166701614594]], AbsoluteThickness[0.25], 
     LineBox[{4929, 4930}]}, 
    {Hue[
      NCache[
       Rational[4930, 14307], 0.34458656601663523`]], AbsoluteThickness[0.25],
      LineBox[{4930, 4931}]}, 
    {Hue[
      NCache[
       Rational[4931, 14307], 0.344656461871811]], AbsoluteThickness[0.25], 
     LineBox[{4931, 4932}]}, 
    {Hue[
      NCache[
       Rational[1644, 4769], 0.3447263577269868]], AbsoluteThickness[0.25], 
     LineBox[{4932, 4933}]}, 
    {Hue[
      NCache[
       Rational[4933, 14307], 0.3447962535821626]], AbsoluteThickness[0.25], 
     LineBox[{4933, 4934}]}, 
    {Hue[
      NCache[
       Rational[4934, 14307], 0.34486614943733834`]], AbsoluteThickness[0.25],
      LineBox[{4934, 4935}]}, 
    {Hue[
      NCache[
       Rational[1645, 4769], 0.34493604529251415`]], AbsoluteThickness[0.25], 
     LineBox[{4935, 4936}]}, 
    {Hue[
      NCache[
       Rational[4936, 14307], 0.34500594114768995`]], AbsoluteThickness[0.25],
      LineBox[{4936, 4937}]}, 
    {Hue[
      NCache[
       Rational[4937, 14307], 0.3450758370028657]], AbsoluteThickness[0.25], 
     LineBox[{4937, 4938}]}, 
    {Hue[
      NCache[
       Rational[1646, 4769], 0.3451457328580415]], AbsoluteThickness[0.25], 
     LineBox[{4938, 4939}]}, 
    {Hue[
      NCache[
       Rational[4939, 14307], 0.3452156287132173]], AbsoluteThickness[0.25], 
     LineBox[{4939, 4940}]}, 
    {Hue[
      NCache[
       Rational[260, 753], 0.3452855245683931]], AbsoluteThickness[0.25], 
     LineBox[{4940, 4941}]}, 
    {Hue[
      NCache[
       Rational[1647, 4769], 0.34535542042356887`]], AbsoluteThickness[0.25], 
     LineBox[{4941, 4942}]}, 
    {Hue[
      NCache[
       Rational[4942, 14307], 0.3454253162787447]], AbsoluteThickness[0.25], 
     LineBox[{4942, 4943}]}, 
    {Hue[
      NCache[
       Rational[4943, 14307], 0.3454952121339205]], AbsoluteThickness[0.25], 
     LineBox[{4943, 4944}]}, 
    {Hue[
      NCache[
       Rational[1648, 4769], 0.34556510798909623`]], AbsoluteThickness[0.25], 
     LineBox[{4944, 4945}]}, 
    {Hue[
      NCache[
       Rational[4945, 14307], 0.34563500384427204`]], AbsoluteThickness[0.25],
      LineBox[{4945, 4946}]}, 
    {Hue[
      NCache[
       Rational[4946, 14307], 0.34570489969944784`]], AbsoluteThickness[0.25],
      LineBox[{4946, 4947}]}, 
    {Hue[
      NCache[
       Rational[1649, 4769], 0.3457747955546236]], AbsoluteThickness[0.25], 
     LineBox[{4947, 4948}]}, 
    {Hue[
      NCache[
       Rational[4948, 14307], 0.3458446914097994]], AbsoluteThickness[0.25], 
     LineBox[{4948, 4949}]}, 
    {Hue[
      NCache[
       Rational[4949, 14307], 0.3459145872649752]], AbsoluteThickness[0.25], 
     LineBox[{4949, 4950}]}, 
    {Hue[
      NCache[
       Rational[1650, 4769], 0.34598448312015095`]], AbsoluteThickness[0.25], 
     LineBox[{4950, 4951}]}, 
    {Hue[
      NCache[
       Rational[4951, 14307], 0.34605437897532676`]], AbsoluteThickness[0.25],
      LineBox[{4951, 4952}]}, 
    {Hue[
      NCache[
       Rational[4952, 14307], 0.34612427483050257`]], AbsoluteThickness[0.25],
      LineBox[{4952, 4953}]}, 
    {Hue[
      NCache[
       Rational[1651, 4769], 0.3461941706856783]], AbsoluteThickness[0.25], 
     LineBox[{4953, 4954}]}, 
    {Hue[
      NCache[
       Rational[4954, 14307], 0.3462640665408541]], AbsoluteThickness[0.25], 
     LineBox[{4954, 4955}]}, 
    {Hue[
      NCache[
       Rational[4955, 14307], 0.3463339623960299]], AbsoluteThickness[0.25], 
     LineBox[{4955, 4956}]}, 
    {Hue[
      NCache[
       Rational[1652, 4769], 0.3464038582512057]], AbsoluteThickness[0.25], 
     LineBox[{4956, 4957}]}, 
    {Hue[
      NCache[
       Rational[4957, 14307], 0.3464737541063815]], AbsoluteThickness[0.25], 
     LineBox[{4957, 4958}]}, 
    {Hue[
      NCache[
       Rational[4958, 14307], 0.3465436499615573]], AbsoluteThickness[0.25], 
     LineBox[{4958, 4959}]}, 
    {Hue[
      NCache[
       Rational[87, 251], 0.3466135458167331]], AbsoluteThickness[0.25], 
     LineBox[{4959, 4960}]}, 
    {Hue[
      NCache[
       Rational[4960, 14307], 0.34668344167190884`]], AbsoluteThickness[0.25],
      LineBox[{4960, 4961}]}, 
    {Hue[
      NCache[
       Rational[4961, 14307], 0.34675333752708465`]], AbsoluteThickness[0.25],
      LineBox[{4961, 4962}]}, 
    {Hue[
      NCache[
       Rational[1654, 4769], 0.34682323338226045`]], AbsoluteThickness[0.25], 
     LineBox[{4962, 4963}]}, 
    {Hue[
      NCache[
       Rational[4963, 14307], 0.3468931292374362]], AbsoluteThickness[0.25], 
     LineBox[{4963, 4964}]}, 
    {Hue[
      NCache[
       Rational[4964, 14307], 0.346963025092612]], AbsoluteThickness[0.25], 
     LineBox[{4964, 4965}]}, 
    {Hue[
      NCache[
       Rational[1655, 4769], 0.3470329209477878]], AbsoluteThickness[0.25], 
     LineBox[{4965, 4966}]}, 
    {Hue[
      NCache[
       Rational[4966, 14307], 0.34710281680296357`]], AbsoluteThickness[0.25],
      LineBox[{4966, 4967}]}, 
    {Hue[
      NCache[
       Rational[4967, 14307], 0.34717271265813937`]], AbsoluteThickness[0.25],
      LineBox[{4967, 4968}]}, 
    {Hue[
      NCache[
       Rational[1656, 4769], 0.3472426085133152]], AbsoluteThickness[0.25], 
     LineBox[{4968, 4969}]}, 
    {Hue[
      NCache[
       Rational[4969, 14307], 0.3473125043684909]], AbsoluteThickness[0.25], 
     LineBox[{4969, 4970}]}, 
    {Hue[
      NCache[
       Rational[4970, 14307], 0.34738240022366673`]], AbsoluteThickness[0.25],
      LineBox[{4970, 4971}]}, 
    {Hue[
      NCache[
       Rational[1657, 4769], 0.34745229607884254`]], AbsoluteThickness[0.25], 
     LineBox[{4971, 4972}]}, 
    {Hue[
      NCache[
       Rational[4972, 14307], 0.3475221919340183]], AbsoluteThickness[0.25], 
     LineBox[{4972, 4973}]}, 
    {Hue[
      NCache[
       Rational[4973, 14307], 0.3475920877891941]], AbsoluteThickness[0.25], 
     LineBox[{4973, 4974}]}, 
    {Hue[
      NCache[
       Rational[1658, 4769], 0.3476619836443699]], AbsoluteThickness[0.25], 
     LineBox[{4974, 4975}]}, 
    {Hue[
      NCache[
       Rational[4975, 14307], 0.3477318794995457]], AbsoluteThickness[0.25], 
     LineBox[{4975, 4976}]}, 
    {Hue[
      NCache[
       Rational[4976, 14307], 0.34780177535472145`]], AbsoluteThickness[0.25],
      LineBox[{4976, 4977}]}, 
    {Hue[
      NCache[
       Rational[1659, 4769], 0.34787167120989726`]], AbsoluteThickness[0.25], 
     LineBox[{4977, 4978}]}, 
    {Hue[
      NCache[
       Rational[262, 753], 0.34794156706507307`]], AbsoluteThickness[0.25], 
     LineBox[{4978, 4979}]}, 
    {Hue[
      NCache[
       Rational[4979, 14307], 0.3480114629202488]], AbsoluteThickness[0.25], 
     LineBox[{4979, 4980}]}, 
    {Hue[
      NCache[
       Rational[1660, 4769], 0.3480813587754246]], AbsoluteThickness[0.25], 
     LineBox[{4980, 4981}]}, 
    {Hue[
      NCache[
       Rational[4981, 14307], 0.3481512546306004]], AbsoluteThickness[0.25], 
     LineBox[{4981, 4982}]}, 
    {Hue[
      NCache[
       Rational[4982, 14307], 0.3482211504857762]], AbsoluteThickness[0.25], 
     LineBox[{4982, 4983}]}, 
    {Hue[
      NCache[
       Rational[1661, 4769], 0.348291046340952]], AbsoluteThickness[0.25], 
     LineBox[{4983, 4984}]}, 
    {Hue[
      NCache[
       Rational[4984, 14307], 0.3483609421961278]], AbsoluteThickness[0.25], 
     LineBox[{4984, 4985}]}, 
    {Hue[
      NCache[
       Rational[4985, 14307], 0.34843083805130354`]], AbsoluteThickness[0.25],
      LineBox[{4985, 4986}]}, 
    {Hue[
      NCache[
       Rational[1662, 4769], 0.34850073390647934`]], AbsoluteThickness[0.25], 
     LineBox[{4986, 4987}]}, 
    {Hue[
      NCache[
       Rational[4987, 14307], 0.34857062976165515`]], AbsoluteThickness[0.25],
      LineBox[{4987, 4988}]}, 
    {Hue[
      NCache[
       Rational[4988, 14307], 0.3486405256168309]], AbsoluteThickness[0.25], 
     LineBox[{4988, 4989}]}, 
    {Hue[
      NCache[
       Rational[1663, 4769], 0.3487104214720067]], AbsoluteThickness[0.25], 
     LineBox[{4989, 4990}]}, 
    {Hue[
      NCache[
       Rational[4990, 14307], 0.3487803173271825]], AbsoluteThickness[0.25], 
     LineBox[{4990, 4991}]}, 
    {Hue[
      NCache[
       Rational[4991, 14307], 0.34885021318235826`]], AbsoluteThickness[0.25],
      LineBox[{4991, 4992}]}, 
    {Hue[
      NCache[
       Rational[1664, 4769], 0.34892010903753407`]], AbsoluteThickness[0.25], 
     LineBox[{4992, 4993}]}, 
    {Hue[
      NCache[
       Rational[4993, 14307], 0.34899000489270987`]], AbsoluteThickness[0.25],
      LineBox[{4993, 4994}]}, 
    {Hue[
      NCache[
       Rational[4994, 14307], 0.3490599007478857]], AbsoluteThickness[0.25], 
     LineBox[{4994, 4995}]}, 
    {Hue[
      NCache[
       Rational[1665, 4769], 0.3491297966030614]], AbsoluteThickness[0.25], 
     LineBox[{4995, 4996}]}, 
    {Hue[
      NCache[
       Rational[4996, 14307], 0.34919969245823723`]], AbsoluteThickness[0.25],
      LineBox[{4996, 4997}]}, 
    {Hue[
      NCache[
       Rational[263, 753], 0.34926958831341304`]], AbsoluteThickness[0.25], 
     LineBox[{4997, 4998}]}, 
    {Hue[
      NCache[
       Rational[1666, 4769], 0.3493394841685888]], AbsoluteThickness[0.25], 
     LineBox[{4998, 4999}]}, 
    {Hue[
      NCache[
       Rational[4999, 14307], 0.3494093800237646]], AbsoluteThickness[0.25], 
     LineBox[{4999, 5000}]}, 
    {Hue[
      NCache[
       Rational[5000, 14307], 0.3494792758789404]], AbsoluteThickness[0.25], 
     LineBox[{5000, 5001}]}, 
    {Hue[
      NCache[
       Rational[1667, 4769], 0.34954917173411615`]], AbsoluteThickness[0.25], 
     LineBox[{5001, 5002}]}, 
    {Hue[
      NCache[
       Rational[5002, 14307], 0.34961906758929195`]], AbsoluteThickness[0.25],
      LineBox[{5002, 5003}]}, 
    {Hue[
      NCache[
       Rational[5003, 14307], 0.34968896344446776`]], AbsoluteThickness[0.25],
      LineBox[{5003, 5004}]}, 
    {Hue[
      NCache[
       Rational[1668, 4769], 0.3497588592996435]], AbsoluteThickness[0.25], 
     LineBox[{5004, 5005}]}, 
    {Hue[
      NCache[
       Rational[5005, 14307], 0.3498287551548193]], AbsoluteThickness[0.25], 
     LineBox[{5005, 5006}]}, 
    {Hue[
      NCache[
       Rational[5006, 14307], 0.3498986510099951]], AbsoluteThickness[0.25], 
     LineBox[{5006, 5007}]}, 
    {Hue[
      NCache[
       Rational[1669, 4769], 0.34996854686517087`]], AbsoluteThickness[0.25], 
     LineBox[{5007, 5008}]}, 
    {Hue[
      NCache[
       Rational[5008, 14307], 0.3500384427203467]], AbsoluteThickness[0.25], 
     LineBox[{5008, 5009}]}, 
    {Hue[
      NCache[
       Rational[5009, 14307], 0.3501083385755225]], AbsoluteThickness[0.25], 
     LineBox[{5009, 5010}]}, 
    {Hue[
      NCache[
       Rational[1670, 4769], 0.35017823443069823`]], AbsoluteThickness[0.25], 
     LineBox[{5010, 5011}]}, 
    {Hue[
      NCache[
       Rational[5011, 14307], 0.35024813028587404`]], AbsoluteThickness[0.25],
      LineBox[{5011, 5012}]}, 
    {Hue[
      NCache[
       Rational[5012, 14307], 0.35031802614104984`]], AbsoluteThickness[0.25],
      LineBox[{5012, 5013}]}, 
    {Hue[
      NCache[
       Rational[1671, 4769], 0.35038792199622565`]], AbsoluteThickness[0.25], 
     LineBox[{5013, 5014}]}, 
    {Hue[
      NCache[
       Rational[5014, 14307], 0.3504578178514014]], AbsoluteThickness[0.25], 
     LineBox[{5014, 5015}]}, 
    {Hue[
      NCache[
       Rational[5015, 14307], 0.3505277137065772]], AbsoluteThickness[0.25], 
     LineBox[{5015, 5016}]}, 
    {Hue[
      NCache[
       Rational[88, 251], 0.350597609561753]], AbsoluteThickness[0.25], 
     LineBox[{5016, 5017}]}, 
    {Hue[
      NCache[
       Rational[5017, 14307], 0.35066750541692876`]], AbsoluteThickness[0.25],
      LineBox[{5017, 5018}]}, 
    {Hue[
      NCache[
       Rational[5018, 14307], 0.35073740127210457`]], AbsoluteThickness[0.25],
      LineBox[{5018, 5019}]}, 
    {Hue[
      NCache[
       Rational[1673, 4769], 0.35080729712728037`]], AbsoluteThickness[0.25], 
     LineBox[{5019, 5020}]}, 
    {Hue[
      NCache[
       Rational[20, 57], 0.3508771929824561]], AbsoluteThickness[0.25], 
     LineBox[{5020, 5021}]}, 
    {Hue[
      NCache[
       Rational[5021, 14307], 0.3509470888376319]], AbsoluteThickness[0.25], 
     LineBox[{5021, 5022}]}, 
    {Hue[
      NCache[
       Rational[1674, 4769], 0.35101698469280773`]], AbsoluteThickness[0.25], 
     LineBox[{5022, 5023}]}, 
    {Hue[
      NCache[
       Rational[5023, 14307], 0.3510868805479835]], AbsoluteThickness[0.25], 
     LineBox[{5023, 5024}]}, 
    {Hue[
      NCache[
       Rational[5024, 14307], 0.3511567764031593]], AbsoluteThickness[0.25], 
     LineBox[{5024, 5025}]}, 
    {Hue[
      NCache[
       Rational[1675, 4769], 0.3512266722583351]], AbsoluteThickness[0.25], 
     LineBox[{5025, 5026}]}, 
    {Hue[
      NCache[
       Rational[5026, 14307], 0.35129656811351084`]], AbsoluteThickness[0.25],
      LineBox[{5026, 5027}]}, 
    {Hue[
      NCache[
       Rational[5027, 14307], 0.35136646396868665`]], AbsoluteThickness[0.25],
      LineBox[{5027, 5028}]}, 
    {Hue[
      NCache[
       Rational[1676, 4769], 0.35143635982386245`]], AbsoluteThickness[0.25], 
     LineBox[{5028, 5029}]}, 
    {Hue[
      NCache[
       Rational[5029, 14307], 0.35150625567903826`]], AbsoluteThickness[0.25],
      LineBox[{5029, 5030}]}, 
    {Hue[
      NCache[
       Rational[5030, 14307], 0.351576151534214]], AbsoluteThickness[0.25], 
     LineBox[{5030, 5031}]}, 
    {Hue[
      NCache[
       Rational[1677, 4769], 0.3516460473893898]], AbsoluteThickness[0.25], 
     LineBox[{5031, 5032}]}, 
    {Hue[
      NCache[
       Rational[5032, 14307], 0.3517159432445656]], AbsoluteThickness[0.25], 
     LineBox[{5032, 5033}]}, 
    {Hue[
      NCache[
       Rational[5033, 14307], 0.35178583909974137`]], AbsoluteThickness[0.25],
      LineBox[{5033, 5034}]}, 
    {Hue[
      NCache[
       Rational[1678, 4769], 0.3518557349549172]], AbsoluteThickness[0.25], 
     LineBox[{5034, 5035}]}, 
    {Hue[
      NCache[
       Rational[265, 753], 0.351925630810093]], AbsoluteThickness[0.25], 
     LineBox[{5035, 5036}]}, 
    {Hue[
      NCache[
       Rational[5036, 14307], 0.35199552666526873`]], AbsoluteThickness[0.25],
      LineBox[{5036, 5037}]}, 
    {Hue[
      NCache[
       Rational[1679, 4769], 0.35206542252044454`]], AbsoluteThickness[0.25], 
     LineBox[{5037, 5038}]}, 
    {Hue[
      NCache[
       Rational[5038, 14307], 0.35213531837562034`]], AbsoluteThickness[0.25],
      LineBox[{5038, 5039}]}, 
    {Hue[
      NCache[
       Rational[5039, 14307], 0.3522052142307961]], AbsoluteThickness[0.25], 
     LineBox[{5039, 5040}]}, 
    {Hue[
      NCache[
       Rational[1680, 4769], 0.3522751100859719]], AbsoluteThickness[0.25], 
     LineBox[{5040, 5041}]}, 
    {Hue[
      NCache[
       Rational[5041, 14307], 0.3523450059411477]], AbsoluteThickness[0.25], 
     LineBox[{5041, 5042}]}, 
    {Hue[
      NCache[
       Rational[5042, 14307], 0.35241490179632345`]], AbsoluteThickness[0.25],
      LineBox[{5042, 5043}]}, 
    {Hue[
      NCache[
       Rational[1681, 4769], 0.35248479765149926`]], AbsoluteThickness[0.25], 
     LineBox[{5043, 5044}]}, 
    {Hue[
      NCache[
       Rational[5044, 14307], 0.35255469350667507`]], AbsoluteThickness[0.25],
      LineBox[{5044, 5045}]}, 
    {Hue[
      NCache[
       Rational[5045, 14307], 0.3526245893618508]], AbsoluteThickness[0.25], 
     LineBox[{5045, 5046}]}, 
    {Hue[
      NCache[
       Rational[1682, 4769], 0.3526944852170266]], AbsoluteThickness[0.25], 
     LineBox[{5046, 5047}]}, 
    {Hue[
      NCache[
       Rational[5047, 14307], 0.3527643810722024]], AbsoluteThickness[0.25], 
     LineBox[{5047, 5048}]}, 
    {Hue[
      NCache[
       Rational[5048, 14307], 0.35283427692737823`]], AbsoluteThickness[0.25],
      LineBox[{5048, 5049}]}, 
    {Hue[
      NCache[
       Rational[1683, 4769], 0.352904172782554]], AbsoluteThickness[0.25], 
     LineBox[{5049, 5050}]}, 
    {Hue[
      NCache[
       Rational[5050, 14307], 0.3529740686377298]], AbsoluteThickness[0.25], 
     LineBox[{5050, 5051}]}, 
    {Hue[
      NCache[
       Rational[5051, 14307], 0.3530439644929056]], AbsoluteThickness[0.25], 
     LineBox[{5051, 5052}]}, 
    {Hue[
      NCache[
       Rational[1684, 4769], 0.35311386034808134`]], AbsoluteThickness[0.25], 
     LineBox[{5052, 5053}]}, 
    {Hue[
      NCache[
       Rational[5053, 14307], 0.35318375620325715`]], AbsoluteThickness[0.25],
      LineBox[{5053, 5054}]}, 
    {Hue[
      NCache[
       Rational[266, 753], 0.35325365205843295`]], AbsoluteThickness[0.25], 
     LineBox[{5054, 5055}]}, 
    {Hue[
      NCache[
       Rational[1685, 4769], 0.3533235479136087]], AbsoluteThickness[0.25], 
     LineBox[{5055, 5056}]}, 
    {Hue[
      NCache[
       Rational[5056, 14307], 0.3533934437687845]], AbsoluteThickness[0.25], 
     LineBox[{5056, 5057}]}, 
    {Hue[
      NCache[
       Rational[5057, 14307], 0.3534633396239603]], AbsoluteThickness[0.25], 
     LineBox[{5057, 5058}]}, 
    {Hue[
      NCache[
       Rational[1686, 4769], 0.35353323547913607`]], AbsoluteThickness[0.25], 
     LineBox[{5058, 5059}]}, 
    {Hue[
      NCache[
       Rational[5059, 14307], 0.35360313133431187`]], AbsoluteThickness[0.25],
      LineBox[{5059, 5060}]}, 
    {Hue[
      NCache[
       Rational[5060, 14307], 0.3536730271894877]], AbsoluteThickness[0.25], 
     LineBox[{5060, 5061}]}, 
    {Hue[
      NCache[
       Rational[1687, 4769], 0.3537429230446634]], AbsoluteThickness[0.25], 
     LineBox[{5061, 5062}]}, 
    {Hue[
      NCache[
       Rational[5062, 14307], 0.35381281889983923`]], AbsoluteThickness[0.25],
      LineBox[{5062, 5063}]}, 
    {Hue[
      NCache[
       Rational[5063, 14307], 0.35388271475501504`]], AbsoluteThickness[0.25],
      LineBox[{5063, 5064}]}, 
    {Hue[
      NCache[
       Rational[1688, 4769], 0.35395261061019084`]], AbsoluteThickness[0.25], 
     LineBox[{5064, 5065}]}, 
    {Hue[
      NCache[
       Rational[5065, 14307], 0.3540225064653666]], AbsoluteThickness[0.25], 
     LineBox[{5065, 5066}]}, 
    {Hue[
      NCache[
       Rational[5066, 14307], 0.3540924023205424]], AbsoluteThickness[0.25], 
     LineBox[{5066, 5067}]}, 
    {Hue[
      NCache[
       Rational[1689, 4769], 0.3541622981757182]], AbsoluteThickness[0.25], 
     LineBox[{5067, 5068}]}, 
    {Hue[
      NCache[
       Rational[5068, 14307], 0.35423219403089395`]], AbsoluteThickness[0.25],
      LineBox[{5068, 5069}]}, 
    {Hue[
      NCache[
       Rational[5069, 14307], 0.35430208988606976`]], AbsoluteThickness[0.25],
      LineBox[{5069, 5070}]}, 
    {Hue[
      NCache[
       Rational[1690, 4769], 0.35437198574124557`]], AbsoluteThickness[0.25], 
     LineBox[{5070, 5071}]}, 
    {Hue[
      NCache[
       Rational[5071, 14307], 0.3544418815964213]], AbsoluteThickness[0.25], 
     LineBox[{5071, 5072}]}, 
    {Hue[
      NCache[
       Rational[5072, 14307], 0.3545117774515971]], AbsoluteThickness[0.25], 
     LineBox[{5072, 5073}]}, 
    {Hue[
      NCache[
       Rational[89, 251], 0.3545816733067729]], AbsoluteThickness[0.25], 
     LineBox[{5073, 5074}]}, 
    {Hue[
      NCache[
       Rational[5074, 14307], 0.3546515691619487]], AbsoluteThickness[0.25], 
     LineBox[{5074, 5075}]}, 
    {Hue[
      NCache[
       Rational[5075, 14307], 0.3547214650171245]], AbsoluteThickness[0.25], 
     LineBox[{5075, 5076}]}, 
    {Hue[
      NCache[
       Rational[1692, 4769], 0.3547913608723003]], AbsoluteThickness[0.25], 
     LineBox[{5076, 5077}]}, 
    {Hue[
      NCache[
       Rational[5077, 14307], 0.35486125672747604`]], AbsoluteThickness[0.25],
      LineBox[{5077, 5078}]}, 
    {Hue[
      NCache[
       Rational[5078, 14307], 0.35493115258265184`]], AbsoluteThickness[0.25],
      LineBox[{5078, 5079}]}, 
    {Hue[
      NCache[
       Rational[1693, 4769], 0.35500104843782765`]], AbsoluteThickness[0.25], 
     LineBox[{5079, 5080}]}, 
    {Hue[
      NCache[
       Rational[5080, 14307], 0.3550709442930034]], AbsoluteThickness[0.25], 
     LineBox[{5080, 5081}]}, 
    {Hue[
      NCache[
       Rational[5081, 14307], 0.3551408401481792]], AbsoluteThickness[0.25], 
     LineBox[{5081, 5082}]}, 
    {Hue[
      NCache[
       Rational[1694, 4769], 0.355210736003355]], AbsoluteThickness[0.25], 
     LineBox[{5082, 5083}]}, 
    {Hue[
      NCache[
       Rational[5083, 14307], 0.3552806318585308]], AbsoluteThickness[0.25], 
     LineBox[{5083, 5084}]}, 
    {Hue[
      NCache[
       Rational[5084, 14307], 0.35535052771370657`]], AbsoluteThickness[0.25],
      LineBox[{5084, 5085}]}, 
    {Hue[
      NCache[
       Rational[1695, 4769], 0.35542042356888237`]], AbsoluteThickness[0.25], 
     LineBox[{5085, 5086}]}, 
    {Hue[
      NCache[
       Rational[5086, 14307], 0.3554903194240582]], AbsoluteThickness[0.25], 
     LineBox[{5086, 5087}]}, 
    {Hue[
      NCache[
       Rational[5087, 14307], 0.3555602152792339]], AbsoluteThickness[0.25], 
     LineBox[{5087, 5088}]}, 
    {Hue[
      NCache[
       Rational[1696, 4769], 0.35563011113440973`]], AbsoluteThickness[0.25], 
     LineBox[{5088, 5089}]}, 
    {Hue[
      NCache[
       Rational[5089, 14307], 0.35570000698958554`]], AbsoluteThickness[0.25],
      LineBox[{5089, 5090}]}, 
    {Hue[
      NCache[
       Rational[5090, 14307], 0.3557699028447613]], AbsoluteThickness[0.25], 
     LineBox[{5090, 5091}]}, 
    {Hue[
      NCache[
       Rational[1697, 4769], 0.3558397986999371]], AbsoluteThickness[0.25], 
     LineBox[{5091, 5092}]}, 
    {Hue[
      NCache[
       Rational[268, 753], 0.3559096945551129]], AbsoluteThickness[0.25], 
     LineBox[{5092, 5093}]}, 
    {Hue[
      NCache[
       Rational[5093, 14307], 0.35597959041028865`]], AbsoluteThickness[0.25],
      LineBox[{5093, 5094}]}, 
    {Hue[
      NCache[
       Rational[1698, 4769], 0.35604948626546445`]], AbsoluteThickness[0.25], 
     LineBox[{5094, 5095}]}, 
    {Hue[
      NCache[
       Rational[5095, 14307], 0.35611938212064026`]], AbsoluteThickness[0.25],
      LineBox[{5095, 5096}]}, 
    {Hue[
      NCache[
       Rational[5096, 14307], 0.356189277975816]], AbsoluteThickness[0.25], 
     LineBox[{5096, 5097}]}, 
    {Hue[
      NCache[
       Rational[1699, 4769], 0.3562591738309918]], AbsoluteThickness[0.25], 
     LineBox[{5097, 5098}]}, 
    {Hue[
      NCache[
       Rational[5098, 14307], 0.3563290696861676]], AbsoluteThickness[0.25], 
     LineBox[{5098, 5099}]}, 
    {Hue[
      NCache[
       Rational[5099, 14307], 0.35639896554134337`]], AbsoluteThickness[0.25],
      LineBox[{5099, 5100}]}, 
    {Hue[
      NCache[
       Rational[1700, 4769], 0.3564688613965192]], AbsoluteThickness[0.25], 
     LineBox[{5100, 5101}]}, 
    {Hue[
      NCache[
       Rational[5101, 14307], 0.356538757251695]], AbsoluteThickness[0.25], 
     LineBox[{5101, 5102}]}, 
    {Hue[
      NCache[
       Rational[5102, 14307], 0.3566086531068708]], AbsoluteThickness[0.25], 
     LineBox[{5102, 5103}]}, 
    {Hue[
      NCache[
       Rational[1701, 4769], 0.35667854896204654`]], AbsoluteThickness[0.25], 
     LineBox[{5103, 5104}]}, 
    {Hue[
      NCache[
       Rational[5104, 14307], 0.35674844481722234`]], AbsoluteThickness[0.25],
      LineBox[{5104, 5105}]}, 
    {Hue[
      NCache[
       Rational[5105, 14307], 0.35681834067239815`]], AbsoluteThickness[0.25],
      LineBox[{5105, 5106}]}, 
    {Hue[
      NCache[
       Rational[1702, 4769], 0.3568882365275739]], AbsoluteThickness[0.25], 
     LineBox[{5106, 5107}]}, 
    {Hue[
      NCache[
       Rational[5107, 14307], 0.3569581323827497]], AbsoluteThickness[0.25], 
     LineBox[{5107, 5108}]}, 
    {Hue[
      NCache[
       Rational[5108, 14307], 0.3570280282379255]], AbsoluteThickness[0.25], 
     LineBox[{5108, 5109}]}, 
    {Hue[
      NCache[
       Rational[1703, 4769], 0.35709792409310126`]], AbsoluteThickness[0.25], 
     LineBox[{5109, 5110}]}, 
    {Hue[
      NCache[
       Rational[5110, 14307], 0.35716781994827707`]], AbsoluteThickness[0.25],
      LineBox[{5110, 5111}]}, 
    {Hue[
      NCache[
       Rational[269, 753], 0.35723771580345287`]], AbsoluteThickness[0.25], 
     LineBox[{5111, 5112}]}, 
    {Hue[
      NCache[
       Rational[1704, 4769], 0.3573076116586286]], AbsoluteThickness[0.25], 
     LineBox[{5112, 5113}]}, 
    {Hue[
      NCache[
       Rational[5113, 14307], 0.3573775075138044]], AbsoluteThickness[0.25], 
     LineBox[{5113, 5114}]}, 
    {Hue[
      NCache[
       Rational[5114, 14307], 0.35744740336898023`]], AbsoluteThickness[0.25],
      LineBox[{5114, 5115}]}, 
    {Hue[
      NCache[
       Rational[1705, 4769], 0.357517299224156]], AbsoluteThickness[0.25], 
     LineBox[{5115, 5116}]}, 
    {Hue[
      NCache[
       Rational[5116, 14307], 0.3575871950793318]], AbsoluteThickness[0.25], 
     LineBox[{5116, 5117}]}, 
    {Hue[
      NCache[
       Rational[5117, 14307], 0.3576570909345076]], AbsoluteThickness[0.25], 
     LineBox[{5117, 5118}]}, 
    {Hue[
      NCache[
       Rational[1706, 4769], 0.3577269867896834]], AbsoluteThickness[0.25], 
     LineBox[{5118, 5119}]}, 
    {Hue[
      NCache[
       Rational[5119, 14307], 0.35779688264485915`]], AbsoluteThickness[0.25],
      LineBox[{5119, 5120}]}, 
    {Hue[
      NCache[
       Rational[5120, 14307], 0.35786677850003495`]], AbsoluteThickness[0.25],
      LineBox[{5120, 5121}]}, 
    {Hue[
      NCache[
       Rational[1707, 4769], 0.35793667435521076`]], AbsoluteThickness[0.25], 
     LineBox[{5121, 5122}]}, 
    {Hue[
      NCache[
       Rational[5122, 14307], 0.3580065702103865]], AbsoluteThickness[0.25], 
     LineBox[{5122, 5123}]}, 
    {Hue[
      NCache[
       Rational[5123, 14307], 0.3580764660655623]], AbsoluteThickness[0.25], 
     LineBox[{5123, 5124}]}, 
    {Hue[
      NCache[
       Rational[1708, 4769], 0.3581463619207381]], AbsoluteThickness[0.25], 
     LineBox[{5124, 5125}]}, 
    {Hue[
      NCache[
       Rational[5125, 14307], 0.35821625777591387`]], AbsoluteThickness[0.25],
      LineBox[{5125, 5126}]}, 
    {Hue[
      NCache[
       Rational[5126, 14307], 0.3582861536310897]], AbsoluteThickness[0.25], 
     LineBox[{5126, 5127}]}, 
    {Hue[
      NCache[
       Rational[1709, 4769], 0.3583560494862655]], AbsoluteThickness[0.25], 
     LineBox[{5127, 5128}]}, 
    {Hue[
      NCache[
       Rational[5128, 14307], 0.35842594534144123`]], AbsoluteThickness[0.25],
      LineBox[{5128, 5129}]}, 
    {Hue[
      NCache[
       Rational[5129, 14307], 0.35849584119661704`]], AbsoluteThickness[0.25],
      LineBox[{5129, 5130}]}, 
    {Hue[
      NCache[
       Rational[90, 251], 0.35856573705179284`]], AbsoluteThickness[0.25], 
     LineBox[{5130, 5131}]}, 
    {Hue[
      NCache[
       Rational[5131, 14307], 0.3586356329069686]], AbsoluteThickness[0.25], 
     LineBox[{5131, 5132}]}, 
    {Hue[
      NCache[
       Rational[5132, 14307], 0.3587055287621444]], AbsoluteThickness[0.25], 
     LineBox[{5132, 5133}]}, 
    {Hue[
      NCache[
       Rational[1711, 4769], 0.3587754246173202]], AbsoluteThickness[0.25], 
     LineBox[{5133, 5134}]}, 
    {Hue[
      NCache[
       Rational[5134, 14307], 0.35884532047249595`]], AbsoluteThickness[0.25],
      LineBox[{5134, 5135}]}, 
    {Hue[
      NCache[
       Rational[5135, 14307], 0.35891521632767176`]], AbsoluteThickness[0.25],
      LineBox[{5135, 5136}]}, 
    {Hue[
      NCache[
       Rational[1712, 4769], 0.35898511218284757`]], AbsoluteThickness[0.25], 
     LineBox[{5136, 5137}]}, 
    {Hue[
      NCache[
       Rational[5137, 14307], 0.35905500803802337`]], AbsoluteThickness[0.25],
      LineBox[{5137, 5138}]}, 
    {Hue[
      NCache[
       Rational[5138, 14307], 0.3591249038931991]], AbsoluteThickness[0.25], 
     LineBox[{5138, 5139}]}, 
    {Hue[
      NCache[
       Rational[1713, 4769], 0.3591947997483749]], AbsoluteThickness[0.25], 
     LineBox[{5139, 5140}]}, 
    {Hue[
      NCache[
       Rational[5140, 14307], 0.35926469560355073`]], AbsoluteThickness[0.25],
      LineBox[{5140, 5141}]}, 
    {Hue[
      NCache[
       Rational[5141, 14307], 0.3593345914587265]], AbsoluteThickness[0.25], 
     LineBox[{5141, 5142}]}, 
    {Hue[
      NCache[
       Rational[1714, 4769], 0.3594044873139023]], AbsoluteThickness[0.25], 
     LineBox[{5142, 5143}]}, 
    {Hue[
      NCache[
       Rational[5143, 14307], 0.3594743831690781]], AbsoluteThickness[0.25], 
     LineBox[{5143, 5144}]}, 
    {Hue[
      NCache[
       Rational[5144, 14307], 0.35954427902425384`]], AbsoluteThickness[0.25],
      LineBox[{5144, 5145}]}, 
    {Hue[
      NCache[
       Rational[1715, 4769], 0.35961417487942965`]], AbsoluteThickness[0.25], 
     LineBox[{5145, 5146}]}, 
    {Hue[
      NCache[
       Rational[5146, 14307], 0.35968407073460545`]], AbsoluteThickness[0.25],
      LineBox[{5146, 5147}]}, 
    {Hue[
      NCache[
       Rational[5147, 14307], 0.3597539665897812]], AbsoluteThickness[0.25], 
     LineBox[{5147, 5148}]}, 
    {Hue[
      NCache[
       Rational[1716, 4769], 0.359823862444957]], AbsoluteThickness[0.25], 
     LineBox[{5148, 5149}]}, 
    {Hue[
      NCache[
       Rational[271, 753], 0.3598937583001328]], AbsoluteThickness[0.25], 
     LineBox[{5149, 5150}]}, 
    {Hue[
      NCache[
       Rational[5150, 14307], 0.35996365415530857`]], AbsoluteThickness[0.25],
      LineBox[{5150, 5151}]}, 
    {Hue[
      NCache[
       Rational[1717, 4769], 0.36003355001048437`]], AbsoluteThickness[0.25], 
     LineBox[{5151, 5152}]}, 
    {Hue[
      NCache[
       Rational[5152, 14307], 0.3601034458656602]], AbsoluteThickness[0.25], 
     LineBox[{5152, 5153}]}, 
    {Hue[
      NCache[
       Rational[5153, 14307], 0.3601733417208359]], AbsoluteThickness[0.25], 
     LineBox[{5153, 5154}]}, 
    {Hue[
      NCache[
       Rational[1718, 4769], 0.36024323757601173`]], AbsoluteThickness[0.25], 
     LineBox[{5154, 5155}]}, 
    {Hue[
      NCache[
       Rational[5155, 14307], 0.36031313343118754`]], AbsoluteThickness[0.25],
      LineBox[{5155, 5156}]}, 
    {Hue[
      NCache[
       Rational[5156, 14307], 0.36038302928636334`]], AbsoluteThickness[0.25],
      LineBox[{5156, 5157}]}, 
    {Hue[
      NCache[
       Rational[1719, 4769], 0.3604529251415391]], AbsoluteThickness[0.25], 
     LineBox[{5157, 5158}]}, 
    {Hue[
      NCache[
       Rational[5158, 14307], 0.3605228209967149]], AbsoluteThickness[0.25], 
     LineBox[{5158, 5159}]}, 
    {Hue[
      NCache[
       Rational[5159, 14307], 0.3605927168518907]], AbsoluteThickness[0.25], 
     LineBox[{5159, 5160}]}, 
    {Hue[
      NCache[
       Rational[1720, 4769], 0.36066261270706645`]], AbsoluteThickness[0.25], 
     LineBox[{5160, 5161}]}, 
    {Hue[
      NCache[
       Rational[5161, 14307], 0.36073250856224226`]], AbsoluteThickness[0.25],
      LineBox[{5161, 5162}]}, 
    {Hue[
      NCache[
       Rational[5162, 14307], 0.36080240441741807`]], AbsoluteThickness[0.25],
      LineBox[{5162, 5163}]}, 
    {Hue[
      NCache[
       Rational[1721, 4769], 0.3608723002725938]], AbsoluteThickness[0.25], 
     LineBox[{5163, 5164}]}, 
    {Hue[
      NCache[
       Rational[5164, 14307], 0.3609421961277696]], AbsoluteThickness[0.25], 
     LineBox[{5164, 5165}]}, 
    {Hue[
      NCache[
       Rational[5165, 14307], 0.3610120919829454]], AbsoluteThickness[0.25], 
     LineBox[{5165, 5166}]}, 
    {Hue[
      NCache[
       Rational[1722, 4769], 0.3610819878381212]], AbsoluteThickness[0.25], 
     LineBox[{5166, 5167}]}, 
    {Hue[
      NCache[
       Rational[5167, 14307], 0.361151883693297]], AbsoluteThickness[0.25], 
     LineBox[{5167, 5168}]}, 
    {Hue[
      NCache[
       Rational[272, 753], 0.3612217795484728]], AbsoluteThickness[0.25], 
     LineBox[{5168, 5169}]}, 
    {Hue[
      NCache[
       Rational[1723, 4769], 0.36129167540364854`]], AbsoluteThickness[0.25], 
     LineBox[{5169, 5170}]}, 
    {Hue[
      NCache[
       Rational[5170, 14307], 0.36136157125882434`]], AbsoluteThickness[0.25],
      LineBox[{5170, 5171}]}, 
    {Hue[
      NCache[
       Rational[5171, 14307], 0.36143146711400015`]], AbsoluteThickness[0.25],
      LineBox[{5171, 5172}]}, 
    {Hue[
      NCache[
       Rational[1724, 4769], 0.36150136296917595`]], AbsoluteThickness[0.25], 
     LineBox[{5172, 5173}]}, 
    {Hue[
      NCache[
       Rational[5173, 14307], 0.3615712588243517]], AbsoluteThickness[0.25], 
     LineBox[{5173, 5174}]}, 
    {Hue[
      NCache[
       Rational[5174, 14307], 0.3616411546795275]], AbsoluteThickness[0.25], 
     LineBox[{5174, 5175}]}, 
    {Hue[
      NCache[
       Rational[1725, 4769], 0.3617110505347033]], AbsoluteThickness[0.25], 
     LineBox[{5175, 5176}]}, 
    {Hue[
      NCache[
       Rational[5176, 14307], 0.36178094638987907`]], AbsoluteThickness[0.25],
      LineBox[{5176, 5177}]}, 
    {Hue[
      NCache[
       Rational[5177, 14307], 0.36185084224505487`]], AbsoluteThickness[0.25],
      LineBox[{5177, 5178}]}, 
    {Hue[
      NCache[
       Rational[1726, 4769], 0.3619207381002307]], AbsoluteThickness[0.25], 
     LineBox[{5178, 5179}]}, 
    {Hue[
      NCache[
       Rational[5179, 14307], 0.3619906339554064]], AbsoluteThickness[0.25], 
     LineBox[{5179, 5180}]}, 
    {Hue[
      NCache[
       Rational[5180, 14307], 0.36206052981058223`]], AbsoluteThickness[0.25],
      LineBox[{5180, 5181}]}, 
    {Hue[
      NCache[
       Rational[1727, 4769], 0.36213042566575804`]], AbsoluteThickness[0.25], 
     LineBox[{5181, 5182}]}, 
    {Hue[
      NCache[
       Rational[5182, 14307], 0.3622003215209338]], AbsoluteThickness[0.25], 
     LineBox[{5182, 5183}]}, 
    {Hue[
      NCache[
       Rational[5183, 14307], 0.3622702173761096]], AbsoluteThickness[0.25], 
     LineBox[{5183, 5184}]}, 
    {Hue[
      NCache[
       Rational[1728, 4769], 0.3623401132312854]], AbsoluteThickness[0.25], 
     LineBox[{5184, 5185}]}, 
    {Hue[
      NCache[
       Rational[5185, 14307], 0.36241000908646115`]], AbsoluteThickness[0.25],
      LineBox[{5185, 5186}]}, 
    {Hue[
      NCache[
       Rational[5186, 14307], 0.36247990494163695`]], AbsoluteThickness[0.25],
      LineBox[{5186, 5187}]}, 
    {Hue[
      NCache[
       Rational[91, 251], 0.36254980079681276`]], AbsoluteThickness[0.25], 
     LineBox[{5187, 5188}]}, 
    {Hue[
      NCache[
       Rational[5188, 14307], 0.3626196966519885]], AbsoluteThickness[0.25], 
     LineBox[{5188, 5189}]}, 
    {Hue[
      NCache[
       Rational[5189, 14307], 0.3626895925071643]], AbsoluteThickness[0.25], 
     LineBox[{5189, 5190}]}, 
    {Hue[
      NCache[
       Rational[1730, 4769], 0.3627594883623401]], AbsoluteThickness[0.25], 
     LineBox[{5190, 5191}]}, 
    {Hue[
      NCache[
       Rational[5191, 14307], 0.3628293842175159]], AbsoluteThickness[0.25], 
     LineBox[{5191, 5192}]}, 
    {Hue[
      NCache[
       Rational[5192, 14307], 0.3628992800726917]], AbsoluteThickness[0.25], 
     LineBox[{5192, 5193}]}, 
    {Hue[
      NCache[
       Rational[1731, 4769], 0.3629691759278675]], AbsoluteThickness[0.25], 
     LineBox[{5193, 5194}]}, 
    {Hue[
      NCache[
       Rational[5194, 14307], 0.3630390717830433]], AbsoluteThickness[0.25], 
     LineBox[{5194, 5195}]}, 
    {Hue[
      NCache[
       Rational[5195, 14307], 0.36310896763821904`]], AbsoluteThickness[0.25],
      LineBox[{5195, 5196}]}, 
    {Hue[
      NCache[
       Rational[1732, 4769], 0.36317886349339484`]], AbsoluteThickness[0.25], 
     LineBox[{5196, 5197}]}, 
    {Hue[
      NCache[
       Rational[5197, 14307], 0.36324875934857065`]], AbsoluteThickness[0.25],
      LineBox[{5197, 5198}]}, 
    {Hue[
      NCache[
       Rational[5198, 14307], 0.3633186552037464]], AbsoluteThickness[0.25], 
     LineBox[{5198, 5199}]}, 
    {Hue[
      NCache[
       Rational[1733, 4769], 0.3633885510589222]], AbsoluteThickness[0.25], 
     LineBox[{5199, 5200}]}, 
    {Hue[
      NCache[
       Rational[5200, 14307], 0.363458446914098]], AbsoluteThickness[0.25], 
     LineBox[{5200, 5201}]}, 
    {Hue[
      NCache[
       Rational[5201, 14307], 0.36352834276927376`]], AbsoluteThickness[0.25],
      LineBox[{5201, 5202}]}, 
    {Hue[
      NCache[
       Rational[1734, 4769], 0.36359823862444957`]], AbsoluteThickness[0.25], 
     LineBox[{5202, 5203}]}, 
    {Hue[
      NCache[
       Rational[5203, 14307], 0.36366813447962537`]], AbsoluteThickness[0.25],
      LineBox[{5203, 5204}]}, 
    {Hue[
      NCache[
       Rational[5204, 14307], 0.3637380303348011]], AbsoluteThickness[0.25], 
     LineBox[{5204, 5205}]}, 
    {Hue[
      NCache[
       Rational[1735, 4769], 0.3638079261899769]], AbsoluteThickness[0.25], 
     LineBox[{5205, 5206}]}, 
    {Hue[
      NCache[
       Rational[274, 753], 0.36387782204515273`]], AbsoluteThickness[0.25], 
     LineBox[{5206, 5207}]}, 
    {Hue[
      NCache[
       Rational[5207, 14307], 0.36394771790032854`]], AbsoluteThickness[0.25],
      LineBox[{5207, 5208}]}, 
    {Hue[
      NCache[
       Rational[1736, 4769], 0.3640176137555043]], AbsoluteThickness[0.25], 
     LineBox[{5208, 5209}]}, 
    {Hue[
      NCache[
       Rational[5209, 14307], 0.3640875096106801]], AbsoluteThickness[0.25], 
     LineBox[{5209, 5210}]}, 
    {Hue[
      NCache[
       Rational[5210, 14307], 0.3641574054658559]], AbsoluteThickness[0.25], 
     LineBox[{5210, 5211}]}, 
    {Hue[
      NCache[
       Rational[1737, 4769], 0.36422730132103165`]], AbsoluteThickness[0.25], 
     LineBox[{5211, 5212}]}, 
    {Hue[
      NCache[
       Rational[5212, 14307], 0.36429719717620745`]], AbsoluteThickness[0.25],
      LineBox[{5212, 5213}]}, 
    {Hue[
      NCache[
       Rational[5213, 14307], 0.36436709303138326`]], AbsoluteThickness[0.25],
      LineBox[{5213, 5214}]}, 
    {Hue[
      NCache[
       Rational[1738, 4769], 0.364436988886559]], AbsoluteThickness[0.25], 
     LineBox[{5214, 5215}]}, 
    {Hue[
      NCache[
       Rational[5215, 14307], 0.3645068847417348]], AbsoluteThickness[0.25], 
     LineBox[{5215, 5216}]}, 
    {Hue[
      NCache[
       Rational[5216, 14307], 0.3645767805969106]], AbsoluteThickness[0.25], 
     LineBox[{5216, 5217}]}, 
    {Hue[
      NCache[
       Rational[1739, 4769], 0.36464667645208637`]], AbsoluteThickness[0.25], 
     LineBox[{5217, 5218}]}, 
    {Hue[
      NCache[
       Rational[5218, 14307], 0.3647165723072622]], AbsoluteThickness[0.25], 
     LineBox[{5218, 5219}]}, 
    {Hue[
      NCache[
       Rational[5219, 14307], 0.364786468162438]], AbsoluteThickness[0.25], 
     LineBox[{5219, 5220}]}, 
    {Hue[
      NCache[
       Rational[1740, 4769], 0.36485636401761373`]], AbsoluteThickness[0.25], 
     LineBox[{5220, 5221}]}, 
    {Hue[
      NCache[
       Rational[5221, 14307], 0.36492625987278954`]], AbsoluteThickness[0.25],
      LineBox[{5221, 5222}]}, 
    {Hue[
      NCache[
       Rational[5222, 14307], 0.36499615572796534`]], AbsoluteThickness[0.25],
      LineBox[{5222, 5223}]}, 
    {Hue[
      NCache[
       Rational[1741, 4769], 0.3650660515831411]], AbsoluteThickness[0.25], 
     LineBox[{5223, 5224}]}, 
    {Hue[
      NCache[
       Rational[5224, 14307], 0.3651359474383169]], AbsoluteThickness[0.25], 
     LineBox[{5224, 5225}]}, 
    {Hue[
      NCache[
       Rational[275, 753], 0.3652058432934927]], AbsoluteThickness[0.25], 
     LineBox[{5225, 5226}]}, 
    {Hue[
      NCache[
       Rational[1742, 4769], 0.3652757391486685]], AbsoluteThickness[0.25], 
     LineBox[{5226, 5227}]}, 
    {Hue[
      NCache[
       Rational[5227, 14307], 0.36534563500384426`]], AbsoluteThickness[0.25],
      LineBox[{5227, 5228}]}, 
    {Hue[
      NCache[
       Rational[5228, 14307], 0.36541553085902007`]], AbsoluteThickness[0.25],
      LineBox[{5228, 5229}]}, 
    {Hue[
      NCache[
       Rational[1743, 4769], 0.36548542671419587`]], AbsoluteThickness[0.25], 
     LineBox[{5229, 5230}]}, 
    {Hue[
      NCache[
       Rational[5230, 14307], 0.3655553225693716]], AbsoluteThickness[0.25], 
     LineBox[{5230, 5231}]}, 
    {Hue[
      NCache[
       Rational[5231, 14307], 0.3656252184245474]], AbsoluteThickness[0.25], 
     LineBox[{5231, 5232}]}, 
    {Hue[
      NCache[
       Rational[1744, 4769], 0.36569511427972323`]], AbsoluteThickness[0.25], 
     LineBox[{5232, 5233}]}, 
    {Hue[
      NCache[
       Rational[5233, 14307], 0.365765010134899]], AbsoluteThickness[0.25], 
     LineBox[{5233, 5234}]}, 
    {Hue[
      NCache[
       Rational[5234, 14307], 0.3658349059900748]], AbsoluteThickness[0.25], 
     LineBox[{5234, 5235}]}, 
    {Hue[
      NCache[
       Rational[1745, 4769], 0.3659048018452506]], AbsoluteThickness[0.25], 
     LineBox[{5235, 5236}]}, 
    {Hue[
      NCache[
       Rational[5236, 14307], 0.36597469770042634`]], AbsoluteThickness[0.25],
      LineBox[{5236, 5237}]}, 
    {Hue[
      NCache[
       Rational[5237, 14307], 0.36604459355560215`]], AbsoluteThickness[0.25],
      LineBox[{5237, 5238}]}, 
    {Hue[
      NCache[
       Rational[1746, 4769], 0.36611448941077795`]], AbsoluteThickness[0.25], 
     LineBox[{5238, 5239}]}, 
    {Hue[
      NCache[
       Rational[5239, 14307], 0.3661843852659537]], AbsoluteThickness[0.25], 
     LineBox[{5239, 5240}]}, 
    {Hue[
      NCache[
       Rational[5240, 14307], 0.3662542811211295]], AbsoluteThickness[0.25], 
     LineBox[{5240, 5241}]}, 
    {Hue[
      NCache[
       Rational[1747, 4769], 0.3663241769763053]], AbsoluteThickness[0.25], 
     LineBox[{5241, 5242}]}, 
    {Hue[
      NCache[
       Rational[5242, 14307], 0.36639407283148107`]], AbsoluteThickness[0.25],
      LineBox[{5242, 5243}]}, 
    {Hue[
      NCache[
       Rational[5243, 14307], 0.36646396868665687`]], AbsoluteThickness[0.25],
      LineBox[{5243, 5244}]}, 
    {Hue[
      NCache[
       Rational[92, 251], 0.3665338645418327]], AbsoluteThickness[0.25], 
     LineBox[{5244, 5245}]}, 
    {Hue[
      NCache[
       Rational[5245, 14307], 0.3666037603970085]], AbsoluteThickness[0.25], 
     LineBox[{5245, 5246}]}, 
    {Hue[
      NCache[
       Rational[5246, 14307], 0.36667365625218423`]], AbsoluteThickness[0.25],
      LineBox[{5246, 5247}]}, 
    {Hue[
      NCache[
       Rational[1749, 4769], 0.36674355210736004`]], AbsoluteThickness[0.25], 
     LineBox[{5247, 5248}]}, 
    {Hue[
      NCache[
       Rational[5248, 14307], 0.36681344796253584`]], AbsoluteThickness[0.25],
      LineBox[{5248, 5249}]}, 
    {Hue[
      NCache[
       Rational[5249, 14307], 0.3668833438177116]], AbsoluteThickness[0.25], 
     LineBox[{5249, 5250}]}, 
    {Hue[
      NCache[
       Rational[1750, 4769], 0.3669532396728874]], AbsoluteThickness[0.25], 
     LineBox[{5250, 5251}]}, 
    {Hue[
      NCache[
       Rational[5251, 14307], 0.3670231355280632]], AbsoluteThickness[0.25], 
     LineBox[{5251, 5252}]}, 
    {Hue[
      NCache[
       Rational[5252, 14307], 0.36709303138323895`]], AbsoluteThickness[0.25],
      LineBox[{5252, 5253}]}, 
    {Hue[
      NCache[
       Rational[1751, 4769], 0.36716292723841476`]], AbsoluteThickness[0.25], 
     LineBox[{5253, 5254}]}, 
    {Hue[
      NCache[
       Rational[5254, 14307], 0.36723282309359057`]], AbsoluteThickness[0.25],
      LineBox[{5254, 5255}]}, 
    {Hue[
      NCache[
       Rational[5255, 14307], 0.3673027189487663]], AbsoluteThickness[0.25], 
     LineBox[{5255, 5256}]}, 
    {Hue[
      NCache[
       Rational[1752, 4769], 0.3673726148039421]], AbsoluteThickness[0.25], 
     LineBox[{5256, 5257}]}, 
    {Hue[
      NCache[
       Rational[5257, 14307], 0.3674425106591179]], AbsoluteThickness[0.25], 
     LineBox[{5257, 5258}]}, 
    {Hue[
      NCache[
       Rational[5258, 14307], 0.3675124065142937]], AbsoluteThickness[0.25], 
     LineBox[{5258, 5259}]}, 
    {Hue[
      NCache[
       Rational[1753, 4769], 0.3675823023694695]], AbsoluteThickness[0.25], 
     LineBox[{5259, 5260}]}, 
    {Hue[
      NCache[
       Rational[5260, 14307], 0.3676521982246453]], AbsoluteThickness[0.25], 
     LineBox[{5260, 5261}]}, 
    {Hue[
      NCache[
       Rational[5261, 14307], 0.3677220940798211]], AbsoluteThickness[0.25], 
     LineBox[{5261, 5262}]}, 
    {Hue[
      NCache[
       Rational[1754, 4769], 0.36779198993499684`]], AbsoluteThickness[0.25], 
     LineBox[{5262, 5263}]}, 
    {Hue[
      NCache[
       Rational[277, 753], 0.36786188579017265`]], AbsoluteThickness[0.25], 
     LineBox[{5263, 5264}]}, 
    {Hue[
      NCache[
       Rational[5264, 14307], 0.36793178164534845`]], AbsoluteThickness[0.25],
      LineBox[{5264, 5265}]}, 
    {Hue[
      NCache[
       Rational[1755, 4769], 0.3680016775005242]], AbsoluteThickness[0.25], 
     LineBox[{5265, 5266}]}, 
    {Hue[
      NCache[
       Rational[5266, 14307], 0.3680715733557]], AbsoluteThickness[0.25], 
     LineBox[{5266, 5267}]}, 
    {Hue[
      NCache[
       Rational[5267, 14307], 0.3681414692108758]], AbsoluteThickness[0.25], 
     LineBox[{5267, 5268}]}, 
    {Hue[
      NCache[
       Rational[1756, 4769], 0.36821136506605157`]], AbsoluteThickness[0.25], 
     LineBox[{5268, 5269}]}, 
    {Hue[
      NCache[
       Rational[5269, 14307], 0.36828126092122737`]], AbsoluteThickness[0.25],
      LineBox[{5269, 5270}]}, 
    {Hue[
      NCache[
       Rational[5270, 14307], 0.3683511567764032]], AbsoluteThickness[0.25], 
     LineBox[{5270, 5271}]}, 
    {Hue[
      NCache[
       Rational[7, 19], 0.3684210526315789]], AbsoluteThickness[0.25], 
     LineBox[{5271, 5272}]}, 
    {Hue[
      NCache[
       Rational[5272, 14307], 0.36849094848675473`]], AbsoluteThickness[0.25],
      LineBox[{5272, 5273}]}, 
    {Hue[
      NCache[
       Rational[5273, 14307], 0.36856084434193054`]], AbsoluteThickness[0.25],
      LineBox[{5273, 5274}]}, 
    {Hue[
      NCache[
       Rational[1758, 4769], 0.3686307401971063]], AbsoluteThickness[0.25], 
     LineBox[{5274, 5275}]}, 
    {Hue[
      NCache[
       Rational[5275, 14307], 0.3687006360522821]], AbsoluteThickness[0.25], 
     LineBox[{5275, 5276}]}, 
    {Hue[
      NCache[
       Rational[5276, 14307], 0.3687705319074579]], AbsoluteThickness[0.25], 
     LineBox[{5276, 5277}]}, 
    {Hue[
      NCache[
       Rational[1759, 4769], 0.36884042776263365`]], AbsoluteThickness[0.25], 
     LineBox[{5277, 5278}]}, 
    {Hue[
      NCache[
       Rational[5278, 14307], 0.36891032361780945`]], AbsoluteThickness[0.25],
      LineBox[{5278, 5279}]}, 
    {Hue[
      NCache[
       Rational[5279, 14307], 0.36898021947298526`]], AbsoluteThickness[0.25],
      LineBox[{5279, 5280}]}, 
    {Hue[
      NCache[
       Rational[1760, 4769], 0.36905011532816107`]], AbsoluteThickness[0.25], 
     LineBox[{5280, 5281}]}, 
    {Hue[
      NCache[
       Rational[5281, 14307], 0.3691200111833368]], AbsoluteThickness[0.25], 
     LineBox[{5281, 5282}]}, 
    {Hue[
      NCache[
       Rational[278, 753], 0.3691899070385126]], AbsoluteThickness[0.25], 
     LineBox[{5282, 5283}]}, 
    {Hue[
      NCache[
       Rational[1761, 4769], 0.3692598028936884]], AbsoluteThickness[0.25], 
     LineBox[{5283, 5284}]}, 
    {Hue[
      NCache[
       Rational[5284, 14307], 0.3693296987488642]], AbsoluteThickness[0.25], 
     LineBox[{5284, 5285}]}, 
    {Hue[
      NCache[
       Rational[5285, 14307], 0.36939959460404]], AbsoluteThickness[0.25], 
     LineBox[{5285, 5286}]}, 
    {Hue[
      NCache[
       Rational[1762, 4769], 0.3694694904592158]], AbsoluteThickness[0.25], 
     LineBox[{5286, 5287}]}, 
    {Hue[
      NCache[
       Rational[5287, 14307], 0.36953938631439154`]], AbsoluteThickness[0.25],
      LineBox[{5287, 5288}]}, 
    {Hue[
      NCache[
       Rational[5288, 14307], 0.36960928216956734`]], AbsoluteThickness[0.25],
      LineBox[{5288, 5289}]}, 
    {Hue[
      NCache[
       Rational[1763, 4769], 0.36967917802474315`]], AbsoluteThickness[0.25], 
     LineBox[{5289, 5290}]}, 
    {Hue[
      NCache[
       Rational[5290, 14307], 0.3697490738799189]], AbsoluteThickness[0.25], 
     LineBox[{5290, 5291}]}, 
    {Hue[
      NCache[
       Rational[5291, 14307], 0.3698189697350947]], AbsoluteThickness[0.25], 
     LineBox[{5291, 5292}]}, 
    {Hue[
      NCache[
       Rational[1764, 4769], 0.3698888655902705]], AbsoluteThickness[0.25], 
     LineBox[{5292, 5293}]}, 
    {Hue[
      NCache[
       Rational[5293, 14307], 0.36995876144544626`]], AbsoluteThickness[0.25],
      LineBox[{5293, 5294}]}, 
    {Hue[
      NCache[
       Rational[5294, 14307], 0.37002865730062207`]], AbsoluteThickness[0.25],
      LineBox[{5294, 5295}]}, 
    {Hue[
      NCache[
       Rational[1765, 4769], 0.37009855315579787`]], AbsoluteThickness[0.25], 
     LineBox[{5295, 5296}]}, 
    {Hue[
      NCache[
       Rational[5296, 14307], 0.3701684490109737]], AbsoluteThickness[0.25], 
     LineBox[{5296, 5297}]}, 
    {Hue[
      NCache[
       Rational[5297, 14307], 0.3702383448661494]], AbsoluteThickness[0.25], 
     LineBox[{5297, 5298}]}, 
    {Hue[
      NCache[
       Rational[1766, 4769], 0.37030824072132523`]], AbsoluteThickness[0.25], 
     LineBox[{5298, 5299}]}, 
    {Hue[
      NCache[
       Rational[5299, 14307], 0.37037813657650104`]], AbsoluteThickness[0.25],
      LineBox[{5299, 5300}]}, 
    {Hue[
      NCache[
       Rational[5300, 14307], 0.3704480324316768]], AbsoluteThickness[0.25], 
     LineBox[{5300, 5301}]}, 
    {Hue[
      NCache[
       Rational[93, 251], 0.3705179282868526]], AbsoluteThickness[0.25], 
     LineBox[{5301, 5302}]}, 
    {Hue[
      NCache[
       Rational[5302, 14307], 0.3705878241420284]], AbsoluteThickness[0.25], 
     LineBox[{5302, 5303}]}, 
    {Hue[
      NCache[
       Rational[5303, 14307], 0.37065771999720415`]], AbsoluteThickness[0.25],
      LineBox[{5303, 5304}]}, 
    {Hue[
      NCache[
       Rational[1768, 4769], 0.37072761585237995`]], AbsoluteThickness[0.25], 
     LineBox[{5304, 5305}]}, 
    {Hue[
      NCache[
       Rational[5305, 14307], 0.37079751170755576`]], AbsoluteThickness[0.25],
      LineBox[{5305, 5306}]}, 
    {Hue[
      NCache[
       Rational[5306, 14307], 0.3708674075627315]], AbsoluteThickness[0.25], 
     LineBox[{5306, 5307}]}, 
    {Hue[
      NCache[
       Rational[1769, 4769], 0.3709373034179073]], AbsoluteThickness[0.25], 
     LineBox[{5307, 5308}]}, 
    {Hue[
      NCache[
       Rational[5308, 14307], 0.3710071992730831]], AbsoluteThickness[0.25], 
     LineBox[{5308, 5309}]}, 
    {Hue[
      NCache[
       Rational[5309, 14307], 0.37107709512825887`]], AbsoluteThickness[0.25],
      LineBox[{5309, 5310}]}, 
    {Hue[
      NCache[
       Rational[1770, 4769], 0.3711469909834347]], AbsoluteThickness[0.25], 
     LineBox[{5310, 5311}]}, 
    {Hue[
      NCache[
       Rational[5311, 14307], 0.3712168868386105]], AbsoluteThickness[0.25], 
     LineBox[{5311, 5312}]}, 
    {Hue[
      NCache[
       Rational[5312, 14307], 0.37128678269378623`]], AbsoluteThickness[0.25],
      LineBox[{5312, 5313}]}, 
    {Hue[
      NCache[
       Rational[1771, 4769], 0.37135667854896204`]], AbsoluteThickness[0.25], 
     LineBox[{5313, 5314}]}, 
    {Hue[
      NCache[
       Rational[5314, 14307], 0.37142657440413784`]], AbsoluteThickness[0.25],
      LineBox[{5314, 5315}]}, 
    {Hue[
      NCache[
       Rational[5315, 14307], 0.37149647025931365`]], AbsoluteThickness[0.25],
      LineBox[{5315, 5316}]}, 
    {Hue[
      NCache[
       Rational[1772, 4769], 0.3715663661144894]], AbsoluteThickness[0.25], 
     LineBox[{5316, 5317}]}, 
    {Hue[
      NCache[
       Rational[5317, 14307], 0.3716362619696652]], AbsoluteThickness[0.25], 
     LineBox[{5317, 5318}]}, 
    {Hue[
      NCache[
       Rational[5318, 14307], 0.371706157824841]], AbsoluteThickness[0.25], 
     LineBox[{5318, 5319}]}, 
    {Hue[
      NCache[
       Rational[1773, 4769], 0.37177605368001676`]], AbsoluteThickness[0.25], 
     LineBox[{5319, 5320}]}, 
    {Hue[
      NCache[
       Rational[280, 753], 0.37184594953519257`]], AbsoluteThickness[0.25], 
     LineBox[{5320, 5321}]}, 
    {Hue[
      NCache[
       Rational[5321, 14307], 0.37191584539036837`]], AbsoluteThickness[0.25],
      LineBox[{5321, 5322}]}, 
    {Hue[
      NCache[
       Rational[1774, 4769], 0.3719857412455441]], AbsoluteThickness[0.25], 
     LineBox[{5322, 5323}]}, 
    {Hue[
      NCache[
       Rational[5323, 14307], 0.3720556371007199]], AbsoluteThickness[0.25], 
     LineBox[{5323, 5324}]}, 
    {Hue[
      NCache[
       Rational[5324, 14307], 0.37212553295589573`]], AbsoluteThickness[0.25],
      LineBox[{5324, 5325}]}, 
    {Hue[
      NCache[
       Rational[1775, 4769], 0.3721954288110715]], AbsoluteThickness[0.25], 
     LineBox[{5325, 5326}]}, 
    {Hue[
      NCache[
       Rational[5326, 14307], 0.3722653246662473]], AbsoluteThickness[0.25], 
     LineBox[{5326, 5327}]}, 
    {Hue[
      NCache[
       Rational[5327, 14307], 0.3723352205214231]], AbsoluteThickness[0.25], 
     LineBox[{5327, 5328}]}, 
    {Hue[
      NCache[
       Rational[1776, 4769], 0.37240511637659884`]], AbsoluteThickness[0.25], 
     LineBox[{5328, 5329}]}, 
    {Hue[
      NCache[
       Rational[5329, 14307], 0.37247501223177465`]], AbsoluteThickness[0.25],
      LineBox[{5329, 5330}]}, 
    {Hue[
      NCache[
       Rational[5330, 14307], 0.37254490808695045`]], AbsoluteThickness[0.25],
      LineBox[{5330, 5331}]}, 
    {Hue[
      NCache[
       Rational[1777, 4769], 0.3726148039421262]], AbsoluteThickness[0.25], 
     LineBox[{5331, 5332}]}, 
    {Hue[
      NCache[
       Rational[5332, 14307], 0.372684699797302]], AbsoluteThickness[0.25], 
     LineBox[{5332, 5333}]}, 
    {Hue[
      NCache[
       Rational[5333, 14307], 0.3727545956524778]], AbsoluteThickness[0.25], 
     LineBox[{5333, 5334}]}, 
    {Hue[
      NCache[
       Rational[1778, 4769], 0.3728244915076536]], AbsoluteThickness[0.25], 
     LineBox[{5334, 5335}]}, 
    {Hue[
      NCache[
       Rational[5335, 14307], 0.37289438736282937`]], AbsoluteThickness[0.25],
      LineBox[{5335, 5336}]}, 
    {Hue[
      NCache[
       Rational[5336, 14307], 0.3729642832180052]], AbsoluteThickness[0.25], 
     LineBox[{5336, 5337}]}, 
    {Hue[
      NCache[
       Rational[1779, 4769], 0.373034179073181]], AbsoluteThickness[0.25], 
     LineBox[{5337, 5338}]}, 
    {Hue[
      NCache[
       Rational[5338, 14307], 0.37310407492835673`]], AbsoluteThickness[0.25],
      LineBox[{5338, 5339}]}, 
    {Hue[
      NCache[
       Rational[281, 753], 0.37317397078353254`]], AbsoluteThickness[0.25], 
     LineBox[{5339, 5340}]}, 
    {Hue[
      NCache[
       Rational[1780, 4769], 0.37324386663870834`]], AbsoluteThickness[0.25], 
     LineBox[{5340, 5341}]}, 
    {Hue[
      NCache[
       Rational[5341, 14307], 0.3733137624938841]], AbsoluteThickness[0.25], 
     LineBox[{5341, 5342}]}, 
    {Hue[
      NCache[
       Rational[5342, 14307], 0.3733836583490599]], AbsoluteThickness[0.25], 
     LineBox[{5342, 5343}]}, 
    {Hue[
      NCache[
       Rational[1781, 4769], 0.3734535542042357]], AbsoluteThickness[0.25], 
     LineBox[{5343, 5344}]}, 
    {Hue[
      NCache[
       Rational[5344, 14307], 0.37352345005941145`]], AbsoluteThickness[0.25],
      LineBox[{5344, 5345}]}, 
    {Hue[
      NCache[
       Rational[5345, 14307], 0.37359334591458726`]], AbsoluteThickness[0.25],
      LineBox[{5345, 5346}]}, 
    {Hue[
      NCache[
       Rational[1782, 4769], 0.37366324176976307`]], AbsoluteThickness[0.25], 
     LineBox[{5346, 5347}]}, 
    {Hue[
      NCache[
       Rational[5347, 14307], 0.3737331376249388]], AbsoluteThickness[0.25], 
     LineBox[{5347, 5348}]}, 
    {Hue[
      NCache[
       Rational[5348, 14307], 0.3738030334801146]], AbsoluteThickness[0.25], 
     LineBox[{5348, 5349}]}, 
    {Hue[
      NCache[
       Rational[1783, 4769], 0.3738729293352904]], AbsoluteThickness[0.25], 
     LineBox[{5349, 5350}]}, 
    {Hue[
      NCache[
       Rational[5350, 14307], 0.37394282519046623`]], AbsoluteThickness[0.25],
      LineBox[{5350, 5351}]}, 
    {Hue[
      NCache[
       Rational[5351, 14307], 0.374012721045642]], AbsoluteThickness[0.25], 
     LineBox[{5351, 5352}]}, 
    {Hue[
      NCache[
       Rational[1784, 4769], 0.3740826169008178]], AbsoluteThickness[0.25], 
     LineBox[{5352, 5353}]}, 
    {Hue[
      NCache[
       Rational[5353, 14307], 0.3741525127559936]], AbsoluteThickness[0.25], 
     LineBox[{5353, 5354}]}, 
    {Hue[
      NCache[
       Rational[5354, 14307], 0.37422240861116934`]], AbsoluteThickness[0.25],
      LineBox[{5354, 5355}]}, 
    {Hue[
      NCache[
       Rational[1785, 4769], 0.37429230446634515`]], AbsoluteThickness[0.25], 
     LineBox[{5355, 5356}]}, 
    {Hue[
      NCache[
       Rational[5356, 14307], 0.37436220032152095`]], AbsoluteThickness[0.25],
      LineBox[{5356, 5357}]}, 
    {Hue[
      NCache[
       Rational[5357, 14307], 0.3744320961766967]], AbsoluteThickness[0.25], 
     LineBox[{5357, 5358}]}, 
    {Hue[
      NCache[
       Rational[94, 251], 0.3745019920318725]], AbsoluteThickness[0.25], 
     LineBox[{5358, 5359}]}, 
    {Hue[
      NCache[
       Rational[5359, 14307], 0.3745718878870483]], AbsoluteThickness[0.25], 
     LineBox[{5359, 5360}]}, 
    {Hue[
      NCache[
       Rational[5360, 14307], 0.37464178374222407`]], AbsoluteThickness[0.25],
      LineBox[{5360, 5361}]}, 
    {Hue[
      NCache[
       Rational[1787, 4769], 0.37471167959739987`]], AbsoluteThickness[0.25], 
     LineBox[{5361, 5362}]}, 
    {Hue[
      NCache[
       Rational[5362, 14307], 0.3747815754525757]], AbsoluteThickness[0.25], 
     LineBox[{5362, 5363}]}, 
    {Hue[
      NCache[
       Rational[5363, 14307], 0.3748514713077514]], AbsoluteThickness[0.25], 
     LineBox[{5363, 5364}]}, 
    {Hue[
      NCache[
       Rational[1788, 4769], 0.37492136716292723`]], AbsoluteThickness[0.25], 
     LineBox[{5364, 5365}]}, 
    {Hue[
      NCache[
       Rational[5365, 14307], 0.37499126301810304`]], AbsoluteThickness[0.25],
      LineBox[{5365, 5366}]}, 
    {Hue[
      NCache[
       Rational[5366, 14307], 0.3750611588732788]], AbsoluteThickness[0.25], 
     LineBox[{5366, 5367}]}, 
    {Hue[
      NCache[
       Rational[1789, 4769], 0.3751310547284546]], AbsoluteThickness[0.25], 
     LineBox[{5367, 5368}]}, 
    {Hue[
      NCache[
       Rational[5368, 14307], 0.3752009505836304]], AbsoluteThickness[0.25], 
     LineBox[{5368, 5369}]}, 
    {Hue[
      NCache[
       Rational[5369, 14307], 0.3752708464388062]], AbsoluteThickness[0.25], 
     LineBox[{5369, 5370}]}, 
    {Hue[
      NCache[
       Rational[1790, 4769], 0.37534074229398195`]], AbsoluteThickness[0.25], 
     LineBox[{5370, 5371}]}, 
    {Hue[
      NCache[
       Rational[5371, 14307], 0.37541063814915776`]], AbsoluteThickness[0.25],
      LineBox[{5371, 5372}]}, 
    {Hue[
      NCache[
       Rational[5372, 14307], 0.37548053400433357`]], AbsoluteThickness[0.25],
      LineBox[{5372, 5373}]}, 
    {Hue[
      NCache[
       Rational[1791, 4769], 0.3755504298595093]], AbsoluteThickness[0.25], 
     LineBox[{5373, 5374}]}, 
    {Hue[
      NCache[
       Rational[5374, 14307], 0.3756203257146851]], AbsoluteThickness[0.25], 
     LineBox[{5374, 5375}]}, 
    {Hue[
      NCache[
       Rational[5375, 14307], 0.3756902215698609]], AbsoluteThickness[0.25], 
     LineBox[{5375, 5376}]}, 
    {Hue[
      NCache[
       Rational[1792, 4769], 0.3757601174250367]], AbsoluteThickness[0.25], 
     LineBox[{5376, 5377}]}, 
    {Hue[
      NCache[
       Rational[283, 753], 0.3758300132802125]], AbsoluteThickness[0.25], 
     LineBox[{5377, 5378}]}, 
    {Hue[
      NCache[
       Rational[5378, 14307], 0.3758999091353883]], AbsoluteThickness[0.25], 
     LineBox[{5378, 5379}]}, 
    {Hue[
      NCache[
       Rational[1793, 4769], 0.37596980499056404`]], AbsoluteThickness[0.25], 
     LineBox[{5379, 5380}]}, 
    {Hue[
      NCache[
       Rational[5380, 14307], 0.37603970084573984`]], AbsoluteThickness[0.25],
      LineBox[{5380, 5381}]}, 
    {Hue[
      NCache[
       Rational[5381, 14307], 0.37610959670091565`]], AbsoluteThickness[0.25],
      LineBox[{5381, 5382}]}, 
    {Hue[
      NCache[
       Rational[1794, 4769], 0.3761794925560914]], AbsoluteThickness[0.25], 
     LineBox[{5382, 5383}]}, 
    {Hue[
      NCache[
       Rational[5383, 14307], 0.3762493884112672]], AbsoluteThickness[0.25], 
     LineBox[{5383, 5384}]}, 
    {Hue[
      NCache[
       Rational[5384, 14307], 0.376319284266443]], AbsoluteThickness[0.25], 
     LineBox[{5384, 5385}]}, 
    {Hue[
      NCache[
       Rational[1795, 4769], 0.37638918012161876`]], AbsoluteThickness[0.25], 
     LineBox[{5385, 5386}]}, 
    {Hue[
      NCache[
       Rational[5386, 14307], 0.37645907597679457`]], AbsoluteThickness[0.25],
      LineBox[{5386, 5387}]}, 
    {Hue[
      NCache[
       Rational[5387, 14307], 0.37652897183197037`]], AbsoluteThickness[0.25],
      LineBox[{5387, 5388}]}, 
    {Hue[
      NCache[
       Rational[1796, 4769], 0.3765988676871462]], AbsoluteThickness[0.25], 
     LineBox[{5388, 5389}]}, 
    {Hue[
      NCache[
       Rational[5389, 14307], 0.3766687635423219]], AbsoluteThickness[0.25], 
     LineBox[{5389, 5390}]}, 
    {Hue[
      NCache[
       Rational[5390, 14307], 0.37673865939749773`]], AbsoluteThickness[0.25],
      LineBox[{5390, 5391}]}, 
    {Hue[
      NCache[
       Rational[1797, 4769], 0.37680855525267354`]], AbsoluteThickness[0.25], 
     LineBox[{5391, 5392}]}, 
    {Hue[
      NCache[
       Rational[5392, 14307], 0.3768784511078493]], AbsoluteThickness[0.25], 
     LineBox[{5392, 5393}]}, 
    {Hue[
      NCache[
       Rational[5393, 14307], 0.3769483469630251]], AbsoluteThickness[0.25], 
     LineBox[{5393, 5394}]}, 
    {Hue[
      NCache[
       Rational[1798, 4769], 0.3770182428182009]], AbsoluteThickness[0.25], 
     LineBox[{5394, 5395}]}, 
    {Hue[
      NCache[
       Rational[5395, 14307], 0.37708813867337665`]], AbsoluteThickness[0.25],
      LineBox[{5395, 5396}]}, 
    {Hue[
      NCache[
       Rational[284, 753], 0.37715803452855245`]], AbsoluteThickness[0.25], 
     LineBox[{5396, 5397}]}, 
    {Hue[
      NCache[
       Rational[1799, 4769], 0.37722793038372826`]], AbsoluteThickness[0.25], 
     LineBox[{5397, 5398}]}, 
    {Hue[
      NCache[
       Rational[5398, 14307], 0.377297826238904]], AbsoluteThickness[0.25], 
     LineBox[{5398, 5399}]}, 
    {Hue[
      NCache[
       Rational[5399, 14307], 0.3773677220940798]], AbsoluteThickness[0.25], 
     LineBox[{5399, 5400}]}, 
    {Hue[
      NCache[
       Rational[1800, 4769], 0.3774376179492556]], AbsoluteThickness[0.25], 
     LineBox[{5400, 5401}]}, 
    {Hue[
      NCache[
       Rational[5401, 14307], 0.37750751380443137`]], AbsoluteThickness[0.25],
      LineBox[{5401, 5402}]}, 
    {Hue[
      NCache[
       Rational[5402, 14307], 0.3775774096596072]], AbsoluteThickness[0.25], 
     LineBox[{5402, 5403}]}, 
    {Hue[
      NCache[
       Rational[1801, 4769], 0.377647305514783]], AbsoluteThickness[0.25], 
     LineBox[{5403, 5404}]}, 
    {Hue[
      NCache[
       Rational[5404, 14307], 0.3777172013699588]], AbsoluteThickness[0.25], 
     LineBox[{5404, 5405}]}, 
    {Hue[
      NCache[
       Rational[5405, 14307], 0.37778709722513454`]], AbsoluteThickness[0.25],
      LineBox[{5405, 5406}]}, 
    {Hue[
      NCache[
       Rational[1802, 4769], 0.37785699308031034`]], AbsoluteThickness[0.25], 
     LineBox[{5406, 5407}]}, 
    {Hue[
      NCache[
       Rational[5407, 14307], 0.37792688893548615`]], AbsoluteThickness[0.25],
      LineBox[{5407, 5408}]}, 
    {Hue[
      NCache[
       Rational[5408, 14307], 0.3779967847906619]], AbsoluteThickness[0.25], 
     LineBox[{5408, 5409}]}, 
    {Hue[
      NCache[
       Rational[1803, 4769], 0.3780666806458377]], AbsoluteThickness[0.25], 
     LineBox[{5409, 5410}]}, 
    {Hue[
      NCache[
       Rational[5410, 14307], 0.3781365765010135]], AbsoluteThickness[0.25], 
     LineBox[{5410, 5411}]}, 
    {Hue[
      NCache[
       Rational[5411, 14307], 0.37820647235618926`]], AbsoluteThickness[0.25],
      LineBox[{5411, 5412}]}, 
    {Hue[
      NCache[
       Rational[1804, 4769], 0.37827636821136507`]], AbsoluteThickness[0.25], 
     LineBox[{5412, 5413}]}, 
    {Hue[
      NCache[
       Rational[5413, 14307], 0.37834626406654087`]], AbsoluteThickness[0.25],
      LineBox[{5413, 5414}]}, 
    {Hue[
      NCache[
       Rational[5414, 14307], 0.3784161599217166]], AbsoluteThickness[0.25], 
     LineBox[{5414, 5415}]}, 
    {Hue[
      NCache[
       Rational[95, 251], 0.3784860557768924]], AbsoluteThickness[0.25], 
     LineBox[{5415, 5416}]}, 
    {Hue[
      NCache[
       Rational[5416, 14307], 0.37855595163206823`]], AbsoluteThickness[0.25],
      LineBox[{5416, 5417}]}, 
    {Hue[
      NCache[
       Rational[5417, 14307], 0.378625847487244]], AbsoluteThickness[0.25], 
     LineBox[{5417, 5418}]}, 
    {Hue[
      NCache[
       Rational[1806, 4769], 0.3786957433424198]], AbsoluteThickness[0.25], 
     LineBox[{5418, 5419}]}, 
    {Hue[
      NCache[
       Rational[5419, 14307], 0.3787656391975956]], AbsoluteThickness[0.25], 
     LineBox[{5419, 5420}]}, 
    {Hue[
      NCache[
       Rational[5420, 14307], 0.37883553505277134`]], AbsoluteThickness[0.25],
      LineBox[{5420, 5421}]}, 
    {Hue[
      NCache[
       Rational[1807, 4769], 0.37890543090794715`]], AbsoluteThickness[0.25], 
     LineBox[{5421, 5422}]}, 
    {Hue[
      NCache[
       Rational[5422, 14307], 0.37897532676312295`]], AbsoluteThickness[0.25],
      LineBox[{5422, 5423}]}, 
    {Hue[
      NCache[
       Rational[5423, 14307], 0.37904522261829876`]], AbsoluteThickness[0.25],
      LineBox[{5423, 5424}]}, 
    {Hue[
      NCache[
       Rational[1808, 4769], 0.3791151184734745]], AbsoluteThickness[0.25], 
     LineBox[{5424, 5425}]}, 
    {Hue[
      NCache[
       Rational[5425, 14307], 0.3791850143286503]], AbsoluteThickness[0.25], 
     LineBox[{5425, 5426}]}, 
    {Hue[
      NCache[
       Rational[5426, 14307], 0.3792549101838261]], AbsoluteThickness[0.25], 
     LineBox[{5426, 5427}]}, 
    {Hue[
      NCache[
       Rational[1809, 4769], 0.37932480603900187`]], AbsoluteThickness[0.25], 
     LineBox[{5427, 5428}]}, 
    {Hue[
      NCache[
       Rational[5428, 14307], 0.3793947018941777]], AbsoluteThickness[0.25], 
     LineBox[{5428, 5429}]}, 
    {Hue[
      NCache[
       Rational[5429, 14307], 0.3794645977493535]], AbsoluteThickness[0.25], 
     LineBox[{5429, 5430}]}, 
    {Hue[
      NCache[
       Rational[1810, 4769], 0.37953449360452923`]], AbsoluteThickness[0.25], 
     LineBox[{5430, 5431}]}, 
    {Hue[
      NCache[
       Rational[5431, 14307], 0.37960438945970504`]], AbsoluteThickness[0.25],
      LineBox[{5431, 5432}]}, 
    {Hue[
      NCache[
       Rational[5432, 14307], 0.37967428531488084`]], AbsoluteThickness[0.25],
      LineBox[{5432, 5433}]}, 
    {Hue[
      NCache[
       Rational[1811, 4769], 0.3797441811700566]], AbsoluteThickness[0.25], 
     LineBox[{5433, 5434}]}, 
    {Hue[
      NCache[
       Rational[286, 753], 0.3798140770252324]], AbsoluteThickness[0.25], 
     LineBox[{5434, 5435}]}, 
    {Hue[
      NCache[
       Rational[5435, 14307], 0.3798839728804082]], AbsoluteThickness[0.25], 
     LineBox[{5435, 5436}]}, 
    {Hue[
      NCache[
       Rational[1812, 4769], 0.37995386873558396`]], AbsoluteThickness[0.25], 
     LineBox[{5436, 5437}]}, 
    {Hue[
      NCache[
       Rational[5437, 14307], 0.38002376459075976`]], AbsoluteThickness[0.25],
      LineBox[{5437, 5438}]}, 
    {Hue[
      NCache[
       Rational[5438, 14307], 0.38009366044593557`]], AbsoluteThickness[0.25],
      LineBox[{5438, 5439}]}, 
    {Hue[
      NCache[
       Rational[1813, 4769], 0.38016355630111137`]], AbsoluteThickness[0.25], 
     LineBox[{5439, 5440}]}, 
    {Hue[
      NCache[
       Rational[5440, 14307], 0.3802334521562871]], AbsoluteThickness[0.25], 
     LineBox[{5440, 5441}]}, 
    {Hue[
      NCache[
       Rational[5441, 14307], 0.3803033480114629]], AbsoluteThickness[0.25], 
     LineBox[{5441, 5442}]}, 
    {Hue[
      NCache[
       Rational[1814, 4769], 0.38037324386663873`]], AbsoluteThickness[0.25], 
     LineBox[{5442, 5443}]}, 
    {Hue[
      NCache[
       Rational[5443, 14307], 0.3804431397218145]], AbsoluteThickness[0.25], 
     LineBox[{5443, 5444}]}, 
    {Hue[
      NCache[
       Rational[5444, 14307], 0.3805130355769903]], AbsoluteThickness[0.25], 
     LineBox[{5444, 5445}]}, 
    {Hue[
      NCache[
       Rational[1815, 4769], 0.3805829314321661]], AbsoluteThickness[0.25], 
     LineBox[{5445, 5446}]}, 
    {Hue[
      NCache[
       Rational[5446, 14307], 0.38065282728734184`]], AbsoluteThickness[0.25],
      LineBox[{5446, 5447}]}, 
    {Hue[
      NCache[
       Rational[5447, 14307], 0.38072272314251765`]], AbsoluteThickness[0.25],
      LineBox[{5447, 5448}]}, 
    {Hue[
      NCache[
       Rational[1816, 4769], 0.38079261899769346`]], AbsoluteThickness[0.25], 
     LineBox[{5448, 5449}]}, 
    {Hue[
      NCache[
       Rational[5449, 14307], 0.3808625148528692]], AbsoluteThickness[0.25], 
     LineBox[{5449, 5450}]}, 
    {Hue[
      NCache[
       Rational[5450, 14307], 0.380932410708045]], AbsoluteThickness[0.25], 
     LineBox[{5450, 5451}]}, 
    {Hue[
      NCache[
       Rational[1817, 4769], 0.3810023065632208]], AbsoluteThickness[0.25], 
     LineBox[{5451, 5452}]}, 
    {Hue[
      NCache[
       Rational[5452, 14307], 0.38107220241839657`]], AbsoluteThickness[0.25],
      LineBox[{5452, 5453}]}, 
    {Hue[
      NCache[
       Rational[287, 753], 0.38114209827357237`]], AbsoluteThickness[0.25], 
     LineBox[{5453, 5454}]}, 
    {Hue[
      NCache[
       Rational[1818, 4769], 0.3812119941287482]], AbsoluteThickness[0.25], 
     LineBox[{5454, 5455}]}, 
    {Hue[
      NCache[
       Rational[5455, 14307], 0.3812818899839239]], AbsoluteThickness[0.25], 
     LineBox[{5455, 5456}]}, 
    {Hue[
      NCache[
       Rational[5456, 14307], 0.38135178583909973`]], AbsoluteThickness[0.25],
      LineBox[{5456, 5457}]}, 
    {Hue[
      NCache[
       Rational[1819, 4769], 0.38142168169427554`]], AbsoluteThickness[0.25], 
     LineBox[{5457, 5458}]}, 
    {Hue[
      NCache[
       Rational[5458, 14307], 0.38149157754945134`]], AbsoluteThickness[0.25],
      LineBox[{5458, 5459}]}, 
    {Hue[
      NCache[
       Rational[5459, 14307], 0.3815614734046271]], AbsoluteThickness[0.25], 
     LineBox[{5459, 5460}]}, 
    {Hue[
      NCache[
       Rational[1820, 4769], 0.3816313692598029]], AbsoluteThickness[0.25], 
     LineBox[{5460, 5461}]}, 
    {Hue[
      NCache[
       Rational[5461, 14307], 0.3817012651149787]], AbsoluteThickness[0.25], 
     LineBox[{5461, 5462}]}, 
    {Hue[
      NCache[
       Rational[5462, 14307], 0.38177116097015446`]], AbsoluteThickness[0.25],
      LineBox[{5462, 5463}]}, 
    {Hue[
      NCache[
       Rational[1821, 4769], 0.38184105682533026`]], AbsoluteThickness[0.25], 
     LineBox[{5463, 5464}]}, 
    {Hue[
      NCache[
       Rational[5464, 14307], 0.38191095268050607`]], AbsoluteThickness[0.25],
      LineBox[{5464, 5465}]}, 
    {Hue[
      NCache[
       Rational[5465, 14307], 0.3819808485356818]], AbsoluteThickness[0.25], 
     LineBox[{5465, 5466}]}, 
    {Hue[
      NCache[
       Rational[1822, 4769], 0.3820507443908576]], AbsoluteThickness[0.25], 
     LineBox[{5466, 5467}]}, 
    {Hue[
      NCache[
       Rational[5467, 14307], 0.3821206402460334]], AbsoluteThickness[0.25], 
     LineBox[{5467, 5468}]}, 
    {Hue[
      NCache[
       Rational[5468, 14307], 0.3821905361012092]], AbsoluteThickness[0.25], 
     LineBox[{5468, 5469}]}, 
    {Hue[
      NCache[
       Rational[1823, 4769], 0.382260431956385]], AbsoluteThickness[0.25], 
     LineBox[{5469, 5470}]}, 
    {Hue[
      NCache[
       Rational[5470, 14307], 0.3823303278115608]], AbsoluteThickness[0.25], 
     LineBox[{5470, 5471}]}, 
    {Hue[
      NCache[
       Rational[5471, 14307], 0.38240022366673654`]], AbsoluteThickness[0.25],
      LineBox[{5471, 5472}]}, 
    {Hue[
      NCache[
       Rational[96, 251], 0.38247011952191234`]], AbsoluteThickness[0.25], 
     LineBox[{5472, 5473}]}, 
    {Hue[
      NCache[
       Rational[5473, 14307], 0.38254001537708815`]], AbsoluteThickness[0.25],
      LineBox[{5473, 5474}]}, 
    {Hue[
      NCache[
       Rational[5474, 14307], 0.3826099112322639]], AbsoluteThickness[0.25], 
     LineBox[{5474, 5475}]}, 
    {Hue[
      NCache[
       Rational[1825, 4769], 0.3826798070874397]], AbsoluteThickness[0.25], 
     LineBox[{5475, 5476}]}, 
    {Hue[
      NCache[
       Rational[5476, 14307], 0.3827497029426155]], AbsoluteThickness[0.25], 
     LineBox[{5476, 5477}]}, 
    {Hue[
      NCache[
       Rational[5477, 14307], 0.3828195987977913]], AbsoluteThickness[0.25], 
     LineBox[{5477, 5478}]}, 
    {Hue[
      NCache[
       Rational[1826, 4769], 0.38288949465296707`]], AbsoluteThickness[0.25], 
     LineBox[{5478, 5479}]}, 
    {Hue[
      NCache[
       Rational[5479, 14307], 0.38295939050814287`]], AbsoluteThickness[0.25],
      LineBox[{5479, 5480}]}, 
    {Hue[
      NCache[
       Rational[5480, 14307], 0.3830292863633187]], AbsoluteThickness[0.25], 
     LineBox[{5480, 5481}]}, 
    {Hue[
      NCache[
       Rational[1827, 4769], 0.3830991822184944]], AbsoluteThickness[0.25], 
     LineBox[{5481, 5482}]}, 
    {Hue[
      NCache[
       Rational[5482, 14307], 0.38316907807367023`]], AbsoluteThickness[0.25],
      LineBox[{5482, 5483}]}, 
    {Hue[
      NCache[
       Rational[5483, 14307], 0.38323897392884604`]], AbsoluteThickness[0.25],
      LineBox[{5483, 5484}]}, 
    {Hue[
      NCache[
       Rational[1828, 4769], 0.3833088697840218]], AbsoluteThickness[0.25], 
     LineBox[{5484, 5485}]}, 
    {Hue[
      NCache[
       Rational[5485, 14307], 0.3833787656391976]], AbsoluteThickness[0.25], 
     LineBox[{5485, 5486}]}, 
    {Hue[
      NCache[
       Rational[5486, 14307], 0.3834486614943734]], AbsoluteThickness[0.25], 
     LineBox[{5486, 5487}]}, 
    {Hue[
      NCache[
       Rational[1829, 4769], 0.38351855734954915`]], AbsoluteThickness[0.25], 
     LineBox[{5487, 5488}]}, 
    {Hue[
      NCache[
       Rational[5488, 14307], 0.38358845320472496`]], AbsoluteThickness[0.25],
      LineBox[{5488, 5489}]}, 
    {Hue[
      NCache[
       Rational[5489, 14307], 0.38365834905990076`]], AbsoluteThickness[0.25],
      LineBox[{5489, 5490}]}, 
    {Hue[
      NCache[
       Rational[1830, 4769], 0.3837282449150765]], AbsoluteThickness[0.25], 
     LineBox[{5490, 5491}]}, 
    {Hue[
      NCache[
       Rational[289, 753], 0.3837981407702523]], AbsoluteThickness[0.25], 
     LineBox[{5491, 5492}]}, 
    {Hue[
      NCache[
       Rational[5492, 14307], 0.3838680366254281]], AbsoluteThickness[0.25], 
     LineBox[{5492, 5493}]}, 
    {Hue[
      NCache[
       Rational[1831, 4769], 0.3839379324806039]], AbsoluteThickness[0.25], 
     LineBox[{5493, 5494}]}, 
    {Hue[
      NCache[
       Rational[5494, 14307], 0.3840078283357797]], AbsoluteThickness[0.25], 
     LineBox[{5494, 5495}]}, 
    {Hue[
      NCache[
       Rational[5495, 14307], 0.3840777241909555]], AbsoluteThickness[0.25], 
     LineBox[{5495, 5496}]}, 
    {Hue[
      NCache[
       Rational[1832, 4769], 0.3841476200461313]], AbsoluteThickness[0.25], 
     LineBox[{5496, 5497}]}, 
    {Hue[
      NCache[
       Rational[5497, 14307], 0.38421751590130704`]], AbsoluteThickness[0.25],
      LineBox[{5497, 5498}]}, 
    {Hue[
      NCache[
       Rational[5498, 14307], 0.38428741175648284`]], AbsoluteThickness[0.25],
      LineBox[{5498, 5499}]}, 
    {Hue[
      NCache[
       Rational[1833, 4769], 0.38435730761165865`]], AbsoluteThickness[0.25], 
     LineBox[{5499, 5500}]}, 
    {Hue[
      NCache[
       Rational[5500, 14307], 0.3844272034668344]], AbsoluteThickness[0.25], 
     LineBox[{5500, 5501}]}, 
    {Hue[
      NCache[
       Rational[5501, 14307], 0.3844970993220102]], AbsoluteThickness[0.25], 
     LineBox[{5501, 5502}]}, 
    {Hue[
      NCache[
       Rational[1834, 4769], 0.384566995177186]], AbsoluteThickness[0.25], 
     LineBox[{5502, 5503}]}, 
    {Hue[
      NCache[
       Rational[5503, 14307], 0.38463689103236176`]], AbsoluteThickness[0.25],
      LineBox[{5503, 5504}]}, 
    {Hue[
      NCache[
       Rational[5504, 14307], 0.38470678688753757`]], AbsoluteThickness[0.25],
      LineBox[{5504, 5505}]}, 
    {Hue[
      NCache[
       Rational[1835, 4769], 0.38477668274271337`]], AbsoluteThickness[0.25], 
     LineBox[{5505, 5506}]}, 
    {Hue[
      NCache[
       Rational[5506, 14307], 0.3848465785978891]], AbsoluteThickness[0.25], 
     LineBox[{5506, 5507}]}, 
    {Hue[
      NCache[
       Rational[5507, 14307], 0.3849164744530649]], AbsoluteThickness[0.25], 
     LineBox[{5507, 5508}]}, 
    {Hue[
      NCache[
       Rational[1836, 4769], 0.38498637030824073`]], AbsoluteThickness[0.25], 
     LineBox[{5508, 5509}]}, 
    {Hue[
      NCache[
       Rational[5509, 14307], 0.3850562661634165]], AbsoluteThickness[0.25], 
     LineBox[{5509, 5510}]}, 
    {Hue[
      NCache[
       Rational[290, 753], 0.3851261620185923]], AbsoluteThickness[0.25], 
     LineBox[{5510, 5511}]}, 
    {Hue[
      NCache[
       Rational[1837, 4769], 0.3851960578737681]], AbsoluteThickness[0.25], 
     LineBox[{5511, 5512}]}, 
    {Hue[
      NCache[
       Rational[5512, 14307], 0.3852659537289439]], AbsoluteThickness[0.25], 
     LineBox[{5512, 5513}]}, 
    {Hue[
      NCache[
       Rational[5513, 14307], 0.38533584958411965`]], AbsoluteThickness[0.25],
      LineBox[{5513, 5514}]}, 
    {Hue[
      NCache[
       Rational[1838, 4769], 0.38540574543929546`]], AbsoluteThickness[0.25], 
     LineBox[{5514, 5515}]}, 
    {Hue[
      NCache[
       Rational[5515, 14307], 0.38547564129447126`]], AbsoluteThickness[0.25],
      LineBox[{5515, 5516}]}, 
    {Hue[
      NCache[
       Rational[5516, 14307], 0.385545537149647]], AbsoluteThickness[0.25], 
     LineBox[{5516, 5517}]}, 
    {Hue[
      NCache[
       Rational[1839, 4769], 0.3856154330048228]], AbsoluteThickness[0.25], 
     LineBox[{5517, 5518}]}, 
    {Hue[
      NCache[
       Rational[5518, 14307], 0.3856853288599986]], AbsoluteThickness[0.25], 
     LineBox[{5518, 5519}]}, 
    {Hue[
      NCache[
       Rational[5519, 14307], 0.38575522471517437`]], AbsoluteThickness[0.25],
      LineBox[{5519, 5520}]}, 
    {Hue[
      NCache[
       Rational[1840, 4769], 0.3858251205703502]], AbsoluteThickness[0.25], 
     LineBox[{5520, 5521}]}, 
    {Hue[
      NCache[
       Rational[5521, 14307], 0.385895016425526]], AbsoluteThickness[0.25], 
     LineBox[{5521, 5522}]}, 
    {Hue[
      NCache[
       Rational[22, 57], 0.38596491228070173`]], AbsoluteThickness[0.25], 
     LineBox[{5522, 5523}]}, 
    {Hue[
      NCache[
       Rational[1841, 4769], 0.38603480813587754`]], AbsoluteThickness[0.25], 
     LineBox[{5523, 5524}]}, 
    {Hue[
      NCache[
       Rational[5524, 14307], 0.38610470399105334`]], AbsoluteThickness[0.25],
      LineBox[{5524, 5525}]}, 
    {Hue[
      NCache[
       Rational[5525, 14307], 0.3861745998462291]], AbsoluteThickness[0.25], 
     LineBox[{5525, 5526}]}, 
    {Hue[
      NCache[
       Rational[1842, 4769], 0.3862444957014049]], AbsoluteThickness[0.25], 
     LineBox[{5526, 5527}]}, 
    {Hue[
      NCache[
       Rational[5527, 14307], 0.3863143915565807]], AbsoluteThickness[0.25], 
     LineBox[{5527, 5528}]}, 
    {Hue[
      NCache[
       Rational[5528, 14307], 0.38638428741175646`]], AbsoluteThickness[0.25],
      LineBox[{5528, 5529}]}, 
    {Hue[
      NCache[
       Rational[97, 251], 0.38645418326693226`]], AbsoluteThickness[0.25], 
     LineBox[{5529, 5530}]}, 
    {Hue[
      NCache[
       Rational[5530, 14307], 0.38652407912210807`]], AbsoluteThickness[0.25],
      LineBox[{5530, 5531}]}, 
    {Hue[
      NCache[
       Rational[5531, 14307], 0.38659397497728387`]], AbsoluteThickness[0.25],
      LineBox[{5531, 5532}]}, 
    {Hue[
      NCache[
       Rational[1844, 4769], 0.3866638708324596]], AbsoluteThickness[0.25], 
     LineBox[{5532, 5533}]}, 
    {Hue[
      NCache[
       Rational[5533, 14307], 0.3867337666876354]], AbsoluteThickness[0.25], 
     LineBox[{5533, 5534}]}, 
    {Hue[
      NCache[
       Rational[5534, 14307], 0.38680366254281123`]], AbsoluteThickness[0.25],
      LineBox[{5534, 5535}]}, 
    {Hue[
      NCache[
       Rational[1845, 4769], 0.386873558397987]], AbsoluteThickness[0.25], 
     LineBox[{5535, 5536}]}, 
    {Hue[
      NCache[
       Rational[5536, 14307], 0.3869434542531628]], AbsoluteThickness[0.25], 
     LineBox[{5536, 5537}]}, 
    {Hue[
      NCache[
       Rational[5537, 14307], 0.3870133501083386]], AbsoluteThickness[0.25], 
     LineBox[{5537, 5538}]}, 
    {Hue[
      NCache[
       Rational[1846, 4769], 0.38708324596351434`]], AbsoluteThickness[0.25], 
     LineBox[{5538, 5539}]}, 
    {Hue[
      NCache[
       Rational[5539, 14307], 0.38715314181869015`]], AbsoluteThickness[0.25],
      LineBox[{5539, 5540}]}, 
    {Hue[
      NCache[
       Rational[5540, 14307], 0.38722303767386596`]], AbsoluteThickness[0.25],
      LineBox[{5540, 5541}]}, 
    {Hue[
      NCache[
       Rational[1847, 4769], 0.3872929335290417]], AbsoluteThickness[0.25], 
     LineBox[{5541, 5542}]}, 
    {Hue[
      NCache[
       Rational[5542, 14307], 0.3873628293842175]], AbsoluteThickness[0.25], 
     LineBox[{5542, 5543}]}, 
    {Hue[
      NCache[
       Rational[5543, 14307], 0.3874327252393933]], AbsoluteThickness[0.25], 
     LineBox[{5543, 5544}]}, 
    {Hue[
      NCache[
       Rational[1848, 4769], 0.38750262109456907`]], AbsoluteThickness[0.25], 
     LineBox[{5544, 5545}]}, 
    {Hue[
      NCache[
       Rational[5545, 14307], 0.38757251694974487`]], AbsoluteThickness[0.25],
      LineBox[{5545, 5546}]}, 
    {Hue[
      NCache[
       Rational[5546, 14307], 0.3876424128049207]], AbsoluteThickness[0.25], 
     LineBox[{5546, 5547}]}, 
    {Hue[
      NCache[
       Rational[1849, 4769], 0.3877123086600965]], AbsoluteThickness[0.25], 
     LineBox[{5547, 5548}]}, 
    {Hue[
      NCache[
       Rational[292, 753], 0.38778220451527223`]], AbsoluteThickness[0.25], 
     LineBox[{5548, 5549}]}, 
    {Hue[
      NCache[
       Rational[5549, 14307], 0.38785210037044804`]], AbsoluteThickness[0.25],
      LineBox[{5549, 5550}]}, 
    {Hue[
      NCache[
       Rational[1850, 4769], 0.38792199622562384`]], AbsoluteThickness[0.25], 
     LineBox[{5550, 5551}]}, 
    {Hue[
      NCache[
       Rational[5551, 14307], 0.3879918920807996]], AbsoluteThickness[0.25], 
     LineBox[{5551, 5552}]}, 
    {Hue[
      NCache[
       Rational[5552, 14307], 0.3880617879359754]], AbsoluteThickness[0.25], 
     LineBox[{5552, 5553}]}, 
    {Hue[
      NCache[
       Rational[1851, 4769], 0.3881316837911512]], AbsoluteThickness[0.25], 
     LineBox[{5553, 5554}]}, 
    {Hue[
      NCache[
       Rational[5554, 14307], 0.38820157964632696`]], AbsoluteThickness[0.25],
      LineBox[{5554, 5555}]}, 
    {Hue[
      NCache[
       Rational[5555, 14307], 0.38827147550150276`]], AbsoluteThickness[0.25],
      LineBox[{5555, 5556}]}, 
    {Hue[
      NCache[
       Rational[1852, 4769], 0.38834137135667857`]], AbsoluteThickness[0.25], 
     LineBox[{5556, 5557}]}, 
    {Hue[
      NCache[
       Rational[5557, 14307], 0.3884112672118543]], AbsoluteThickness[0.25], 
     LineBox[{5557, 5558}]}, 
    {Hue[
      NCache[
       Rational[5558, 14307], 0.3884811630670301]], AbsoluteThickness[0.25], 
     LineBox[{5558, 5559}]}, 
    {Hue[
      NCache[
       Rational[1853, 4769], 0.3885510589222059]], AbsoluteThickness[0.25], 
     LineBox[{5559, 5560}]}, 
    {Hue[
      NCache[
       Rational[5560, 14307], 0.3886209547773817]], AbsoluteThickness[0.25], 
     LineBox[{5560, 5561}]}, 
    {Hue[
      NCache[
       Rational[5561, 14307], 0.3886908506325575]], AbsoluteThickness[0.25], 
     LineBox[{5561, 5562}]}, 
    {Hue[
      NCache[
       Rational[1854, 4769], 0.3887607464877333]], AbsoluteThickness[0.25], 
     LineBox[{5562, 5563}]}, 
    {Hue[
      NCache[
       Rational[5563, 14307], 0.38883064234290904`]], AbsoluteThickness[0.25],
      LineBox[{5563, 5564}]}, 
    {Hue[
      NCache[
       Rational[5564, 14307], 0.38890053819808484`]], AbsoluteThickness[0.25],
      LineBox[{5564, 5565}]}, 
    {Hue[
      NCache[
       Rational[1855, 4769], 0.38897043405326065`]], AbsoluteThickness[0.25], 
     LineBox[{5565, 5566}]}, 
    {Hue[
      NCache[
       Rational[5566, 14307], 0.38904032990843646`]], AbsoluteThickness[0.25],
      LineBox[{5566, 5567}]}, 
    {Hue[
      NCache[
       Rational[293, 753], 0.3891102257636122]], AbsoluteThickness[0.25], 
     LineBox[{5567, 5568}]}, 
    {Hue[
      NCache[
       Rational[1856, 4769], 0.389180121618788]], AbsoluteThickness[0.25], 
     LineBox[{5568, 5569}]}, 
    {Hue[
      NCache[
       Rational[5569, 14307], 0.3892500174739638]], AbsoluteThickness[0.25], 
     LineBox[{5569, 5570}]}, 
    {Hue[
      NCache[
       Rational[5570, 14307], 0.38931991332913957`]], AbsoluteThickness[0.25],
      LineBox[{5570, 5571}]}, 
    {Hue[
      NCache[
       Rational[1857, 4769], 0.38938980918431537`]], AbsoluteThickness[0.25], 
     LineBox[{5571, 5572}]}, 
    {Hue[
      NCache[
       Rational[5572, 14307], 0.3894597050394912]], AbsoluteThickness[0.25], 
     LineBox[{5572, 5573}]}, 
    {Hue[
      NCache[
       Rational[5573, 14307], 0.3895296008946669]], AbsoluteThickness[0.25], 
     LineBox[{5573, 5574}]}, 
    {Hue[
      NCache[
       Rational[1858, 4769], 0.38959949674984273`]], AbsoluteThickness[0.25], 
     LineBox[{5574, 5575}]}, 
    {Hue[
      NCache[
       Rational[5575, 14307], 0.38966939260501854`]], AbsoluteThickness[0.25],
      LineBox[{5575, 5576}]}, 
    {Hue[
      NCache[
       Rational[5576, 14307], 0.3897392884601943]], AbsoluteThickness[0.25], 
     LineBox[{5576, 5577}]}, 
    {Hue[
      NCache[
       Rational[1859, 4769], 0.3898091843153701]], AbsoluteThickness[0.25], 
     LineBox[{5577, 5578}]}, 
    {Hue[
      NCache[
       Rational[5578, 14307], 0.3898790801705459]], AbsoluteThickness[0.25], 
     LineBox[{5578, 5579}]}, 
    {Hue[
      NCache[
       Rational[5579, 14307], 0.38994897602572165`]], AbsoluteThickness[0.25],
      LineBox[{5579, 5580}]}, 
    {Hue[
      NCache[
       Rational[1860, 4769], 0.39001887188089746`]], AbsoluteThickness[0.25], 
     LineBox[{5580, 5581}]}, 
    {Hue[
      NCache[
       Rational[5581, 14307], 0.39008876773607326`]], AbsoluteThickness[0.25],
      LineBox[{5581, 5582}]}, 
    {Hue[
      NCache[
       Rational[5582, 14307], 0.39015866359124907`]], AbsoluteThickness[0.25],
      LineBox[{5582, 5583}]}, 
    {Hue[
      NCache[
       Rational[1861, 4769], 0.3902285594464248]], AbsoluteThickness[0.25], 
     LineBox[{5583, 5584}]}, 
    {Hue[
      NCache[
       Rational[5584, 14307], 0.3902984553016006]], AbsoluteThickness[0.25], 
     LineBox[{5584, 5585}]}, 
    {Hue[
      NCache[
       Rational[5585, 14307], 0.3903683511567764]], AbsoluteThickness[0.25], 
     LineBox[{5585, 5586}]}, 
    {Hue[
      NCache[
       Rational[98, 251], 0.3904382470119522]], AbsoluteThickness[0.25], 
     LineBox[{5586, 5587}]}, 
    {Hue[
      NCache[
       Rational[5587, 14307], 0.390508142867128]], AbsoluteThickness[0.25], 
     LineBox[{5587, 5588}]}, 
    {Hue[
      NCache[
       Rational[5588, 14307], 0.3905780387223038]], AbsoluteThickness[0.25], 
     LineBox[{5588, 5589}]}, 
    {Hue[
      NCache[
       Rational[1863, 4769], 0.39064793457747954`]], AbsoluteThickness[0.25], 
     LineBox[{5589, 5590}]}, 
    {Hue[
      NCache[
       Rational[5590, 14307], 0.39071783043265534`]], AbsoluteThickness[0.25],
      LineBox[{5590, 5591}]}, 
    {Hue[
      NCache[
       Rational[5591, 14307], 0.39078772628783115`]], AbsoluteThickness[0.25],
      LineBox[{5591, 5592}]}, 
    {Hue[
      NCache[
       Rational[1864, 4769], 0.3908576221430069]], AbsoluteThickness[0.25], 
     LineBox[{5592, 5593}]}, 
    {Hue[
      NCache[
       Rational[5593, 14307], 0.3909275179981827]], AbsoluteThickness[0.25], 
     LineBox[{5593, 5594}]}, 
    {Hue[
      NCache[
       Rational[5594, 14307], 0.3909974138533585]], AbsoluteThickness[0.25], 
     LineBox[{5594, 5595}]}, 
    {Hue[
      NCache[
       Rational[1865, 4769], 0.39106730970853426`]], AbsoluteThickness[0.25], 
     LineBox[{5595, 5596}]}, 
    {Hue[
      NCache[
       Rational[5596, 14307], 0.39113720556371007`]], AbsoluteThickness[0.25],
      LineBox[{5596, 5597}]}, 
    {Hue[
      NCache[
       Rational[5597, 14307], 0.39120710141888587`]], AbsoluteThickness[0.25],
      LineBox[{5597, 5598}]}, 
    {Hue[
      NCache[
       Rational[1866, 4769], 0.3912769972740616]], AbsoluteThickness[0.25], 
     LineBox[{5598, 5599}]}, 
    {Hue[
      NCache[
       Rational[5599, 14307], 0.3913468931292374]], AbsoluteThickness[0.25], 
     LineBox[{5599, 5600}]}, 
    {Hue[
      NCache[
       Rational[5600, 14307], 0.39141678898441323`]], AbsoluteThickness[0.25],
      LineBox[{5600, 5601}]}, 
    {Hue[
      NCache[
       Rational[1867, 4769], 0.39148668483958904`]], AbsoluteThickness[0.25], 
     LineBox[{5601, 5602}]}, 
    {Hue[
      NCache[
       Rational[5602, 14307], 0.3915565806947648]], AbsoluteThickness[0.25], 
     LineBox[{5602, 5603}]}, 
    {Hue[
      NCache[
       Rational[5603, 14307], 0.3916264765499406]], AbsoluteThickness[0.25], 
     LineBox[{5603, 5604}]}, 
    {Hue[
      NCache[
       Rational[1868, 4769], 0.3916963724051164]], AbsoluteThickness[0.25], 
     LineBox[{5604, 5605}]}, 
    {Hue[
      NCache[
       Rational[295, 753], 0.39176626826029215`]], AbsoluteThickness[0.25], 
     LineBox[{5605, 5606}]}, 
    {Hue[
      NCache[
       Rational[5606, 14307], 0.39183616411546796`]], AbsoluteThickness[0.25],
      LineBox[{5606, 5607}]}, 
    {Hue[
      NCache[
       Rational[1869, 4769], 0.39190605997064376`]], AbsoluteThickness[0.25], 
     LineBox[{5607, 5608}]}, 
    {Hue[
      NCache[
       Rational[5608, 14307], 0.3919759558258195]], AbsoluteThickness[0.25], 
     LineBox[{5608, 5609}]}, 
    {Hue[
      NCache[
       Rational[5609, 14307], 0.3920458516809953]], AbsoluteThickness[0.25], 
     LineBox[{5609, 5610}]}, 
    {Hue[
      NCache[
       Rational[1870, 4769], 0.3921157475361711]], AbsoluteThickness[0.25], 
     LineBox[{5610, 5611}]}, 
    {Hue[
      NCache[
       Rational[5611, 14307], 0.39218564339134687`]], AbsoluteThickness[0.25],
      LineBox[{5611, 5612}]}, 
    {Hue[
      NCache[
       Rational[5612, 14307], 0.3922555392465227]], AbsoluteThickness[0.25], 
     LineBox[{5612, 5613}]}, 
    {Hue[
      NCache[
       Rational[1871, 4769], 0.3923254351016985]], AbsoluteThickness[0.25], 
     LineBox[{5613, 5614}]}, 
    {Hue[
      NCache[
       Rational[5614, 14307], 0.39239533095687423`]], AbsoluteThickness[0.25],
      LineBox[{5614, 5615}]}, 
    {Hue[
      NCache[
       Rational[5615, 14307], 0.39246522681205004`]], AbsoluteThickness[0.25],
      LineBox[{5615, 5616}]}, 
    {Hue[
      NCache[
       Rational[1872, 4769], 0.39253512266722584`]], AbsoluteThickness[0.25], 
     LineBox[{5616, 5617}]}, 
    {Hue[
      NCache[
       Rational[5617, 14307], 0.3926050185224016]], AbsoluteThickness[0.25], 
     LineBox[{5617, 5618}]}, 
    {Hue[
      NCache[
       Rational[5618, 14307], 0.3926749143775774]], AbsoluteThickness[0.25], 
     LineBox[{5618, 5619}]}, 
    {Hue[
      NCache[
       Rational[1873, 4769], 0.3927448102327532]], AbsoluteThickness[0.25], 
     LineBox[{5619, 5620}]}, 
    {Hue[
      NCache[
       Rational[5620, 14307], 0.392814706087929]], AbsoluteThickness[0.25], 
     LineBox[{5620, 5621}]}, 
    {Hue[
      NCache[
       Rational[5621, 14307], 0.39288460194310476`]], AbsoluteThickness[0.25],
      LineBox[{5621, 5622}]}, 
    {Hue[
      NCache[
       Rational[1874, 4769], 0.39295449779828057`]], AbsoluteThickness[0.25], 
     LineBox[{5622, 5623}]}, 
    {Hue[
      NCache[
       Rational[5623, 14307], 0.39302439365345637`]], AbsoluteThickness[0.25],
      LineBox[{5623, 5624}]}, 
    {Hue[
      NCache[
       Rational[296, 753], 0.3930942895086321]], AbsoluteThickness[0.25], 
     LineBox[{5624, 5625}]}, 
    {Hue[
      NCache[
       Rational[1875, 4769], 0.3931641853638079]], AbsoluteThickness[0.25], 
     LineBox[{5625, 5626}]}, 
    {Hue[
      NCache[
       Rational[5626, 14307], 0.39323408121898373`]], AbsoluteThickness[0.25],
      LineBox[{5626, 5627}]}, 
    {Hue[
      NCache[
       Rational[5627, 14307], 0.3933039770741595]], AbsoluteThickness[0.25], 
     LineBox[{5627, 5628}]}, 
    {Hue[
      NCache[
       Rational[1876, 4769], 0.3933738729293353]], AbsoluteThickness[0.25], 
     LineBox[{5628, 5629}]}, 
    {Hue[
      NCache[
       Rational[5629, 14307], 0.3934437687845111]], AbsoluteThickness[0.25], 
     LineBox[{5629, 5630}]}, 
    {Hue[
      NCache[
       Rational[5630, 14307], 0.39351366463968684`]], AbsoluteThickness[0.25],
      LineBox[{5630, 5631}]}, 
    {Hue[
      NCache[
       Rational[1877, 4769], 0.39358356049486265`]], AbsoluteThickness[0.25], 
     LineBox[{5631, 5632}]}, 
    {Hue[
      NCache[
       Rational[5632, 14307], 0.39365345635003846`]], AbsoluteThickness[0.25],
      LineBox[{5632, 5633}]}, 
    {Hue[
      NCache[
       Rational[5633, 14307], 0.3937233522052142]], AbsoluteThickness[0.25], 
     LineBox[{5633, 5634}]}, 
    {Hue[
      NCache[
       Rational[1878, 4769], 0.39379324806039]], AbsoluteThickness[0.25], 
     LineBox[{5634, 5635}]}, 
    {Hue[
      NCache[
       Rational[5635, 14307], 0.3938631439155658]], AbsoluteThickness[0.25], 
     LineBox[{5635, 5636}]}, 
    {Hue[
      NCache[
       Rational[5636, 14307], 0.3939330397707416]], AbsoluteThickness[0.25], 
     LineBox[{5636, 5637}]}, 
    {Hue[
      NCache[
       Rational[1879, 4769], 0.39400293562591737`]], AbsoluteThickness[0.25], 
     LineBox[{5637, 5638}]}, 
    {Hue[
      NCache[
       Rational[5638, 14307], 0.3940728314810932]], AbsoluteThickness[0.25], 
     LineBox[{5638, 5639}]}, 
    {Hue[
      NCache[
       Rational[5639, 14307], 0.394142727336269]], AbsoluteThickness[0.25], 
     LineBox[{5639, 5640}]}, 
    {Hue[
      NCache[
       Rational[1880, 4769], 0.39421262319144473`]], AbsoluteThickness[0.25], 
     LineBox[{5640, 5641}]}, 
    {Hue[
      NCache[
       Rational[5641, 14307], 0.39428251904662054`]], AbsoluteThickness[0.25],
      LineBox[{5641, 5642}]}, 
    {Hue[
      NCache[
       Rational[5642, 14307], 0.39435241490179634`]], AbsoluteThickness[0.25],
      LineBox[{5642, 5643}]}, 
    {Hue[
      NCache[
       Rational[99, 251], 0.3944223107569721]], AbsoluteThickness[0.25], 
     LineBox[{5643, 5644}]}, 
    {Hue[
      NCache[
       Rational[5644, 14307], 0.3944922066121479]], AbsoluteThickness[0.25], 
     LineBox[{5644, 5645}]}, 
    {Hue[
      NCache[
       Rational[5645, 14307], 0.3945621024673237]], AbsoluteThickness[0.25], 
     LineBox[{5645, 5646}]}, 
    {Hue[
      NCache[
       Rational[1882, 4769], 0.39463199832249946`]], AbsoluteThickness[0.25], 
     LineBox[{5646, 5647}]}, 
    {Hue[
      NCache[
       Rational[5647, 14307], 0.39470189417767526`]], AbsoluteThickness[0.25],
      LineBox[{5647, 5648}]}, 
    {Hue[
      NCache[
       Rational[5648, 14307], 0.39477179003285107`]], AbsoluteThickness[0.25],
      LineBox[{5648, 5649}]}, 
    {Hue[
      NCache[
       Rational[1883, 4769], 0.3948416858880268]], AbsoluteThickness[0.25], 
     LineBox[{5649, 5650}]}, 
    {Hue[
      NCache[
       Rational[5650, 14307], 0.3949115817432026]], AbsoluteThickness[0.25], 
     LineBox[{5650, 5651}]}, 
    {Hue[
      NCache[
       Rational[5651, 14307], 0.3949814775983784]], AbsoluteThickness[0.25], 
     LineBox[{5651, 5652}]}, 
    {Hue[
      NCache[
       Rational[1884, 4769], 0.3950513734535542]], AbsoluteThickness[0.25], 
     LineBox[{5652, 5653}]}, 
    {Hue[
      NCache[
       Rational[5653, 14307], 0.39512126930873]], AbsoluteThickness[0.25], 
     LineBox[{5653, 5654}]}, 
    {Hue[
      NCache[
       Rational[5654, 14307], 0.3951911651639058]], AbsoluteThickness[0.25], 
     LineBox[{5654, 5655}]}, 
    {Hue[
      NCache[
       Rational[1885, 4769], 0.3952610610190816]], AbsoluteThickness[0.25], 
     LineBox[{5655, 5656}]}, 
    {Hue[
      NCache[
       Rational[5656, 14307], 0.39533095687425734`]], AbsoluteThickness[0.25],
      LineBox[{5656, 5657}]}, 
    {Hue[
      NCache[
       Rational[5657, 14307], 0.39540085272943315`]], AbsoluteThickness[0.25],
      LineBox[{5657, 5658}]}, 
    {Hue[
      NCache[
       Rational[1886, 4769], 0.39547074858460896`]], AbsoluteThickness[0.25], 
     LineBox[{5658, 5659}]}, 
    {Hue[
      NCache[
       Rational[5659, 14307], 0.3955406444397847]], AbsoluteThickness[0.25], 
     LineBox[{5659, 5660}]}, 
    {Hue[
      NCache[
       Rational[5660, 14307], 0.3956105402949605]], AbsoluteThickness[0.25], 
     LineBox[{5660, 5661}]}, 
    {Hue[
      NCache[
       Rational[1887, 4769], 0.3956804361501363]], AbsoluteThickness[0.25], 
     LineBox[{5661, 5662}]}, 
    {Hue[
      NCache[
       Rational[298, 753], 0.39575033200531207`]], AbsoluteThickness[0.25], 
     LineBox[{5662, 5663}]}, 
    {Hue[
      NCache[
       Rational[5663, 14307], 0.39582022786048787`]], AbsoluteThickness[0.25],
      LineBox[{5663, 5664}]}, 
    {Hue[
      NCache[
       Rational[1888, 4769], 0.3958901237156637]], AbsoluteThickness[0.25], 
     LineBox[{5664, 5665}]}, 
    {Hue[
      NCache[
       Rational[5665, 14307], 0.3959600195708394]], AbsoluteThickness[0.25], 
     LineBox[{5665, 5666}]}, 
    {Hue[
      NCache[
       Rational[5666, 14307], 0.39602991542601523`]], AbsoluteThickness[0.25],
      LineBox[{5666, 5667}]}, 
    {Hue[
      NCache[
       Rational[1889, 4769], 0.39609981128119104`]], AbsoluteThickness[0.25], 
     LineBox[{5667, 5668}]}, 
    {Hue[
      NCache[
       Rational[5668, 14307], 0.3961697071363668]], AbsoluteThickness[0.25], 
     LineBox[{5668, 5669}]}, 
    {Hue[
      NCache[
       Rational[5669, 14307], 0.3962396029915426]], AbsoluteThickness[0.25], 
     LineBox[{5669, 5670}]}, 
    {Hue[
      NCache[
       Rational[1890, 4769], 0.3963094988467184]], AbsoluteThickness[0.25], 
     LineBox[{5670, 5671}]}, 
    {Hue[
      NCache[
       Rational[5671, 14307], 0.39637939470189415`]], AbsoluteThickness[0.25],
      LineBox[{5671, 5672}]}, 
    {Hue[
      NCache[
       Rational[5672, 14307], 0.39644929055706996`]], AbsoluteThickness[0.25],
      LineBox[{5672, 5673}]}, 
    {Hue[
      NCache[
       Rational[1891, 4769], 0.39651918641224576`]], AbsoluteThickness[0.25], 
     LineBox[{5673, 5674}]}, 
    {Hue[
      NCache[
       Rational[5674, 14307], 0.39658908226742157`]], AbsoluteThickness[0.25],
      LineBox[{5674, 5675}]}, 
    {Hue[
      NCache[
       Rational[5675, 14307], 0.3966589781225973]], AbsoluteThickness[0.25], 
     LineBox[{5675, 5676}]}, 
    {Hue[
      NCache[
       Rational[1892, 4769], 0.3967288739777731]], AbsoluteThickness[0.25], 
     LineBox[{5676, 5677}]}, 
    {Hue[
      NCache[
       Rational[5677, 14307], 0.3967987698329489]], AbsoluteThickness[0.25], 
     LineBox[{5677, 5678}]}, 
    {Hue[
      NCache[
       Rational[5678, 14307], 0.3968686656881247]], AbsoluteThickness[0.25], 
     LineBox[{5678, 5679}]}, 
    {Hue[
      NCache[
       Rational[1893, 4769], 0.3969385615433005]], AbsoluteThickness[0.25], 
     LineBox[{5679, 5680}]}, 
    {Hue[
      NCache[
       Rational[5680, 14307], 0.3970084573984763]], AbsoluteThickness[0.25], 
     LineBox[{5680, 5681}]}, 
    {Hue[
      NCache[
       Rational[299, 753], 0.39707835325365204`]], AbsoluteThickness[0.25], 
     LineBox[{5681, 5682}]}, 
    {Hue[
      NCache[
       Rational[1894, 4769], 0.39714824910882784`]], AbsoluteThickness[0.25], 
     LineBox[{5682, 5683}]}, 
    {Hue[
      NCache[
       Rational[5683, 14307], 0.39721814496400365`]], AbsoluteThickness[0.25],
      LineBox[{5683, 5684}]}, 
    {Hue[
      NCache[
       Rational[5684, 14307], 0.3972880408191794]], AbsoluteThickness[0.25], 
     LineBox[{5684, 5685}]}, 
    {Hue[
      NCache[
       Rational[1895, 4769], 0.3973579366743552]], AbsoluteThickness[0.25], 
     LineBox[{5685, 5686}]}, 
    {Hue[
      NCache[
       Rational[5686, 14307], 0.397427832529531]], AbsoluteThickness[0.25], 
     LineBox[{5686, 5687}]}, 
    {Hue[
      NCache[
       Rational[5687, 14307], 0.39749772838470676`]], AbsoluteThickness[0.25],
      LineBox[{5687, 5688}]}, 
    {Hue[
      NCache[
       Rational[1896, 4769], 0.39756762423988257`]], AbsoluteThickness[0.25], 
     LineBox[{5688, 5689}]}, 
    {Hue[
      NCache[
       Rational[5689, 14307], 0.39763752009505837`]], AbsoluteThickness[0.25],
      LineBox[{5689, 5690}]}, 
    {Hue[
      NCache[
       Rational[5690, 14307], 0.3977074159502342]], AbsoluteThickness[0.25], 
     LineBox[{5690, 5691}]}, 
    {Hue[
      NCache[
       Rational[1897, 4769], 0.3977773118054099]], AbsoluteThickness[0.25], 
     LineBox[{5691, 5692}]}, 
    {Hue[
      NCache[
       Rational[5692, 14307], 0.39784720766058573`]], AbsoluteThickness[0.25],
      LineBox[{5692, 5693}]}, 
    {Hue[
      NCache[
       Rational[5693, 14307], 0.39791710351576154`]], AbsoluteThickness[0.25],
      LineBox[{5693, 5694}]}, 
    {Hue[
      NCache[
       Rational[1898, 4769], 0.3979869993709373]], AbsoluteThickness[0.25], 
     LineBox[{5694, 5695}]}, 
    {Hue[
      NCache[
       Rational[5695, 14307], 0.3980568952261131]], AbsoluteThickness[0.25], 
     LineBox[{5695, 5696}]}, 
    {Hue[
      NCache[
       Rational[5696, 14307], 0.3981267910812889]], AbsoluteThickness[0.25], 
     LineBox[{5696, 5697}]}, 
    {Hue[
      NCache[
       Rational[1899, 4769], 0.39819668693646465`]], AbsoluteThickness[0.25], 
     LineBox[{5697, 5698}]}, 
    {Hue[
      NCache[
       Rational[5698, 14307], 0.39826658279164046`]], AbsoluteThickness[0.25],
      LineBox[{5698, 5699}]}, 
    {Hue[
      NCache[
       Rational[5699, 14307], 0.39833647864681626`]], AbsoluteThickness[0.25],
      LineBox[{5699, 5700}]}, 
    {Hue[
      NCache[
       Rational[100, 251], 0.398406374501992]], AbsoluteThickness[0.25], 
     LineBox[{5700, 5701}]}, 
    {Hue[
      NCache[
       Rational[5701, 14307], 0.3984762703571678]], AbsoluteThickness[0.25], 
     LineBox[{5701, 5702}]}, 
    {Hue[
      NCache[
       Rational[5702, 14307], 0.3985461662123436]], AbsoluteThickness[0.25], 
     LineBox[{5702, 5703}]}, 
    {Hue[
      NCache[
       Rational[1901, 4769], 0.39861606206751937`]], AbsoluteThickness[0.25], 
     LineBox[{5703, 5704}]}, 
    {Hue[
      NCache[
       Rational[5704, 14307], 0.3986859579226952]], AbsoluteThickness[0.25], 
     LineBox[{5704, 5705}]}, 
    {Hue[
      NCache[
       Rational[5705, 14307], 0.398755853777871]], AbsoluteThickness[0.25], 
     LineBox[{5705, 5706}]}, 
    {Hue[
      NCache[
       Rational[1902, 4769], 0.39882574963304673`]], AbsoluteThickness[0.25], 
     LineBox[{5706, 5707}]}, 
    {Hue[
      NCache[
       Rational[5707, 14307], 0.39889564548822254`]], AbsoluteThickness[0.25],
      LineBox[{5707, 5708}]}, 
    {Hue[
      NCache[
       Rational[5708, 14307], 0.39896554134339834`]], AbsoluteThickness[0.25],
      LineBox[{5708, 5709}]}, 
    {Hue[
      NCache[
       Rational[1903, 4769], 0.39903543719857415`]], AbsoluteThickness[0.25], 
     LineBox[{5709, 5710}]}, 
    {Hue[
      NCache[
       Rational[5710, 14307], 0.3991053330537499]], AbsoluteThickness[0.25], 
     LineBox[{5710, 5711}]}, 
    {Hue[
      NCache[
       Rational[5711, 14307], 0.3991752289089257]], AbsoluteThickness[0.25], 
     LineBox[{5711, 5712}]}, 
    {Hue[
      NCache[
       Rational[1904, 4769], 0.3992451247641015]], AbsoluteThickness[0.25], 
     LineBox[{5712, 5713}]}, 
    {Hue[
      NCache[
       Rational[5713, 14307], 0.39931502061927726`]], AbsoluteThickness[0.25],
      LineBox[{5713, 5714}]}, 
    {Hue[
      NCache[
       Rational[5714, 14307], 0.39938491647445307`]], AbsoluteThickness[0.25],
      LineBox[{5714, 5715}]}, 
    {Hue[
      NCache[
       Rational[1905, 4769], 0.39945481232962887`]], AbsoluteThickness[0.25], 
     LineBox[{5715, 5716}]}, 
    {Hue[
      NCache[
       Rational[5716, 14307], 0.3995247081848046]], AbsoluteThickness[0.25], 
     LineBox[{5716, 5717}]}, 
    {Hue[
      NCache[
       Rational[5717, 14307], 0.39959460403998043`]], AbsoluteThickness[0.25],
      LineBox[{5717, 5718}]}, 
    {Hue[
      NCache[
       Rational[1906, 4769], 0.39966449989515623`]], AbsoluteThickness[0.25], 
     LineBox[{5718, 5719}]}, 
    {Hue[
      NCache[
       Rational[301, 753], 0.399734395750332]], AbsoluteThickness[0.25], 
     LineBox[{5719, 5720}]}, 
    {Hue[
      NCache[
       Rational[5720, 14307], 0.3998042916055078]], AbsoluteThickness[0.25], 
     LineBox[{5720, 5721}]}, 
    {Hue[
      NCache[
       Rational[1907, 4769], 0.3998741874606836]], AbsoluteThickness[0.25], 
     LineBox[{5721, 5722}]}, 
    {Hue[
      NCache[
       Rational[5722, 14307], 0.39994408331585934`]], AbsoluteThickness[0.25],
      LineBox[{5722, 5723}]}, 
    {Hue[
      NCache[
       Rational[5723, 14307], 0.40001397917103515`]], AbsoluteThickness[0.25],
      LineBox[{5723, 5724}]}, 
    {Hue[
      NCache[
       Rational[1908, 4769], 0.40008387502621096`]], AbsoluteThickness[0.25], 
     LineBox[{5724, 5725}]}, 
    {Hue[
      NCache[
       Rational[5725, 14307], 0.40015377088138676`]], AbsoluteThickness[0.25],
      LineBox[{5725, 5726}]}, 
    {Hue[
      NCache[
       Rational[5726, 14307], 0.4002236667365625]], AbsoluteThickness[0.25], 
     LineBox[{5726, 5727}]}, 
    {Hue[
      NCache[
       Rational[1909, 4769], 0.4002935625917383]], AbsoluteThickness[0.25], 
     LineBox[{5727, 5728}]}, 
    {Hue[
      NCache[
       Rational[5728, 14307], 0.4003634584469141]], AbsoluteThickness[0.25], 
     LineBox[{5728, 5729}]}, 
    {Hue[
      NCache[
       Rational[5729, 14307], 0.4004333543020899]], AbsoluteThickness[0.25], 
     LineBox[{5729, 5730}]}, 
    {Hue[
      NCache[
       Rational[1910, 4769], 0.4005032501572657]], AbsoluteThickness[0.25], 
     LineBox[{5730, 5731}]}, 
    {Hue[
      NCache[
       Rational[5731, 14307], 0.4005731460124415]], AbsoluteThickness[0.25], 
     LineBox[{5731, 5732}]}, 
    {Hue[
      NCache[
       Rational[5732, 14307], 0.40064304186761723`]], AbsoluteThickness[0.25],
      LineBox[{5732, 5733}]}, 
    {Hue[
      NCache[
       Rational[1911, 4769], 0.40071293772279304`]], AbsoluteThickness[0.25], 
     LineBox[{5733, 5734}]}, 
    {Hue[
      NCache[
       Rational[5734, 14307], 0.40078283357796884`]], AbsoluteThickness[0.25],
      LineBox[{5734, 5735}]}, 
    {Hue[
      NCache[
       Rational[5735, 14307], 0.4008527294331446]], AbsoluteThickness[0.25], 
     LineBox[{5735, 5736}]}, 
    {Hue[
      NCache[
       Rational[1912, 4769], 0.4009226252883204]], AbsoluteThickness[0.25], 
     LineBox[{5736, 5737}]}, 
    {Hue[
      NCache[
       Rational[5737, 14307], 0.4009925211434962]], AbsoluteThickness[0.25], 
     LineBox[{5737, 5738}]}, 
    {Hue[
      NCache[
       Rational[302, 753], 0.40106241699867196`]], AbsoluteThickness[0.25], 
     LineBox[{5738, 5739}]}, 
    {Hue[
      NCache[
       Rational[1913, 4769], 0.40113231285384776`]], AbsoluteThickness[0.25], 
     LineBox[{5739, 5740}]}, 
    {Hue[
      NCache[
       Rational[5740, 14307], 0.40120220870902357`]], AbsoluteThickness[0.25],
      LineBox[{5740, 5741}]}, 
    {Hue[
      NCache[
       Rational[5741, 14307], 0.4012721045641993]], AbsoluteThickness[0.25], 
     LineBox[{5741, 5742}]}, 
    {Hue[
      NCache[
       Rational[1914, 4769], 0.4013420004193751]], AbsoluteThickness[0.25], 
     LineBox[{5742, 5743}]}, 
    {Hue[
      NCache[
       Rational[5743, 14307], 0.40141189627455093`]], AbsoluteThickness[0.25],
      LineBox[{5743, 5744}]}, 
    {Hue[
      NCache[
       Rational[5744, 14307], 0.40148179212972673`]], AbsoluteThickness[0.25],
      LineBox[{5744, 5745}]}, 
    {Hue[
      NCache[
       Rational[1915, 4769], 0.4015516879849025]], AbsoluteThickness[0.25], 
     LineBox[{5745, 5746}]}, 
    {Hue[
      NCache[
       Rational[5746, 14307], 0.4016215838400783]], AbsoluteThickness[0.25], 
     LineBox[{5746, 5747}]}, 
    {Hue[
      NCache[
       Rational[5747, 14307], 0.4016914796952541]], AbsoluteThickness[0.25], 
     LineBox[{5747, 5748}]}, 
    {Hue[
      NCache[
       Rational[1916, 4769], 0.40176137555042984`]], AbsoluteThickness[0.25], 
     LineBox[{5748, 5749}]}, 
    {Hue[
      NCache[
       Rational[5749, 14307], 0.40183127140560565`]], AbsoluteThickness[0.25],
      LineBox[{5749, 5750}]}, 
    {Hue[
      NCache[
       Rational[5750, 14307], 0.40190116726078146`]], AbsoluteThickness[0.25],
      LineBox[{5750, 5751}]}, 
    {Hue[
      NCache[
       Rational[1917, 4769], 0.4019710631159572]], AbsoluteThickness[0.25], 
     LineBox[{5751, 5752}]}, 
    {Hue[
      NCache[
       Rational[5752, 14307], 0.402040958971133]], AbsoluteThickness[0.25], 
     LineBox[{5752, 5753}]}, 
    {Hue[
      NCache[
       Rational[5753, 14307], 0.4021108548263088]], AbsoluteThickness[0.25], 
     LineBox[{5753, 5754}]}, 
    {Hue[
      NCache[
       Rational[1918, 4769], 0.40218075068148457`]], AbsoluteThickness[0.25], 
     LineBox[{5754, 5755}]}, 
    {Hue[
      NCache[
       Rational[5755, 14307], 0.4022506465366604]], AbsoluteThickness[0.25], 
     LineBox[{5755, 5756}]}, 
    {Hue[
      NCache[
       Rational[5756, 14307], 0.4023205423918362]], AbsoluteThickness[0.25], 
     LineBox[{5756, 5757}]}, 
    {Hue[
      NCache[
       Rational[101, 251], 0.40239043824701193`]], AbsoluteThickness[0.25], 
     LineBox[{5757, 5758}]}, 
    {Hue[
      NCache[
       Rational[5758, 14307], 0.40246033410218773`]], AbsoluteThickness[0.25],
      LineBox[{5758, 5759}]}, 
    {Hue[
      NCache[
       Rational[5759, 14307], 0.40253022995736354`]], AbsoluteThickness[0.25],
      LineBox[{5759, 5760}]}, 
    {Hue[
      NCache[
       Rational[1920, 4769], 0.4026001258125393]], AbsoluteThickness[0.25], 
     LineBox[{5760, 5761}]}, 
    {Hue[
      NCache[
       Rational[5761, 14307], 0.4026700216677151]], AbsoluteThickness[0.25], 
     LineBox[{5761, 5762}]}, 
    {Hue[
      NCache[
       Rational[5762, 14307], 0.4027399175228909]], AbsoluteThickness[0.25], 
     LineBox[{5762, 5763}]}, 
    {Hue[
      NCache[
       Rational[1921, 4769], 0.4028098133780667]], AbsoluteThickness[0.25], 
     LineBox[{5763, 5764}]}, 
    {Hue[
      NCache[
       Rational[5764, 14307], 0.40287970923324246`]], AbsoluteThickness[0.25],
      LineBox[{5764, 5765}]}, 
    {Hue[
      NCache[
       Rational[5765, 14307], 0.40294960508841826`]], AbsoluteThickness[0.25],
      LineBox[{5765, 5766}]}, 
    {Hue[
      NCache[
       Rational[1922, 4769], 0.40301950094359407`]], AbsoluteThickness[0.25], 
     LineBox[{5766, 5767}]}, 
    {Hue[
      NCache[
       Rational[5767, 14307], 0.4030893967987698]], AbsoluteThickness[0.25], 
     LineBox[{5767, 5768}]}, 
    {Hue[
      NCache[
       Rational[5768, 14307], 0.4031592926539456]], AbsoluteThickness[0.25], 
     LineBox[{5768, 5769}]}, 
    {Hue[
      NCache[
       Rational[1923, 4769], 0.40322918850912143`]], AbsoluteThickness[0.25], 
     LineBox[{5769, 5770}]}, 
    {Hue[
      NCache[
       Rational[5770, 14307], 0.4032990843642972]], AbsoluteThickness[0.25], 
     LineBox[{5770, 5771}]}, 
    {Hue[
      NCache[
       Rational[5771, 14307], 0.403368980219473]], AbsoluteThickness[0.25], 
     LineBox[{5771, 5772}]}, 
    {Hue[
      NCache[
       Rational[1924, 4769], 0.4034388760746488]], AbsoluteThickness[0.25], 
     LineBox[{5772, 5773}]}, 
    {Hue[
      NCache[
       Rational[23, 57], 0.40350877192982454`]], AbsoluteThickness[0.25], 
     LineBox[{5773, 5774}]}, 
    {Hue[
      NCache[
       Rational[5774, 14307], 0.40357866778500034`]], AbsoluteThickness[0.25],
      LineBox[{5774, 5775}]}, 
    {Hue[
      NCache[
       Rational[1925, 4769], 0.40364856364017615`]], AbsoluteThickness[0.25], 
     LineBox[{5775, 5776}]}, 
    {Hue[
      NCache[
       Rational[304, 753], 0.4037184594953519]], AbsoluteThickness[0.25], 
     LineBox[{5776, 5777}]}, 
    {Hue[
      NCache[
       Rational[5777, 14307], 0.4037883553505277]], AbsoluteThickness[0.25], 
     LineBox[{5777, 5778}]}, 
    {Hue[
      NCache[
       Rational[1926, 4769], 0.4038582512057035]], AbsoluteThickness[0.25], 
     LineBox[{5778, 5779}]}, 
    {Hue[
      NCache[
       Rational[5779, 14307], 0.4039281470608793]], AbsoluteThickness[0.25], 
     LineBox[{5779, 5780}]}, 
    {Hue[
      NCache[
       Rational[5780, 14307], 0.40399804291605507`]], AbsoluteThickness[0.25],
      LineBox[{5780, 5781}]}, 
    {Hue[
      NCache[
       Rational[1927, 4769], 0.4040679387712309]], AbsoluteThickness[0.25], 
     LineBox[{5781, 5782}]}, 
    {Hue[
      NCache[
       Rational[5782, 14307], 0.4041378346264067]], AbsoluteThickness[0.25], 
     LineBox[{5782, 5783}]}, 
    {Hue[
      NCache[
       Rational[5783, 14307], 0.40420773048158243`]], AbsoluteThickness[0.25],
      LineBox[{5783, 5784}]}, 
    {Hue[
      NCache[
       Rational[1928, 4769], 0.40427762633675823`]], AbsoluteThickness[0.25], 
     LineBox[{5784, 5785}]}, 
    {Hue[
      NCache[
       Rational[5785, 14307], 0.40434752219193404`]], AbsoluteThickness[0.25],
      LineBox[{5785, 5786}]}, 
    {Hue[
      NCache[
       Rational[5786, 14307], 0.4044174180471098]], AbsoluteThickness[0.25], 
     LineBox[{5786, 5787}]}, 
    {Hue[
      NCache[
       Rational[1929, 4769], 0.4044873139022856]], AbsoluteThickness[0.25], 
     LineBox[{5787, 5788}]}, 
    {Hue[
      NCache[
       Rational[5788, 14307], 0.4045572097574614]], AbsoluteThickness[0.25], 
     LineBox[{5788, 5789}]}, 
    {Hue[
      NCache[
       Rational[5789, 14307], 0.40462710561263715`]], AbsoluteThickness[0.25],
      LineBox[{5789, 5790}]}, 
    {Hue[
      NCache[
       Rational[1930, 4769], 0.40469700146781296`]], AbsoluteThickness[0.25], 
     LineBox[{5790, 5791}]}, 
    {Hue[
      NCache[
       Rational[5791, 14307], 0.40476689732298876`]], AbsoluteThickness[0.25],
      LineBox[{5791, 5792}]}, 
    {Hue[
      NCache[
       Rational[5792, 14307], 0.4048367931781645]], AbsoluteThickness[0.25], 
     LineBox[{5792, 5793}]}, 
    {Hue[
      NCache[
       Rational[1931, 4769], 0.4049066890333403]], AbsoluteThickness[0.25], 
     LineBox[{5793, 5794}]}, 
    {Hue[
      NCache[
       Rational[5794, 14307], 0.4049765848885161]], AbsoluteThickness[0.25], 
     LineBox[{5794, 5795}]}, 
    {Hue[
      NCache[
       Rational[305, 753], 0.4050464807436919]], AbsoluteThickness[0.25], 
     LineBox[{5795, 5796}]}, 
    {Hue[
      NCache[
       Rational[1932, 4769], 0.4051163765988677]], AbsoluteThickness[0.25], 
     LineBox[{5796, 5797}]}, 
    {Hue[
      NCache[
       Rational[5797, 14307], 0.4051862724540435]], AbsoluteThickness[0.25], 
     LineBox[{5797, 5798}]}, 
    {Hue[
      NCache[
       Rational[5798, 14307], 0.4052561683092193]], AbsoluteThickness[0.25], 
     LineBox[{5798, 5799}]}, 
    {Hue[
      NCache[
       Rational[1933, 4769], 0.40532606416439504`]], AbsoluteThickness[0.25], 
     LineBox[{5799, 5800}]}, 
    {Hue[
      NCache[
       Rational[5800, 14307], 0.40539596001957084`]], AbsoluteThickness[0.25],
      LineBox[{5800, 5801}]}, 
    {Hue[
      NCache[
       Rational[5801, 14307], 0.40546585587474665`]], AbsoluteThickness[0.25],
      LineBox[{5801, 5802}]}, 
    {Hue[
      NCache[
       Rational[1934, 4769], 0.4055357517299224]], AbsoluteThickness[0.25], 
     LineBox[{5802, 5803}]}, 
    {Hue[
      NCache[
       Rational[5803, 14307], 0.4056056475850982]], AbsoluteThickness[0.25], 
     LineBox[{5803, 5804}]}, 
    {Hue[
      NCache[
       Rational[5804, 14307], 0.405675543440274]], AbsoluteThickness[0.25], 
     LineBox[{5804, 5805}]}, 
    {Hue[
      NCache[
       Rational[1935, 4769], 0.40574543929544976`]], AbsoluteThickness[0.25], 
     LineBox[{5805, 5806}]}, 
    {Hue[
      NCache[
       Rational[5806, 14307], 0.40581533515062557`]], AbsoluteThickness[0.25],
      LineBox[{5806, 5807}]}, 
    {Hue[
      NCache[
       Rational[5807, 14307], 0.4058852310058014]], AbsoluteThickness[0.25], 
     LineBox[{5807, 5808}]}, 
    {Hue[
      NCache[
       Rational[1936, 4769], 0.4059551268609771]], AbsoluteThickness[0.25], 
     LineBox[{5808, 5809}]}, 
    {Hue[
      NCache[
       Rational[5809, 14307], 0.40602502271615293`]], AbsoluteThickness[0.25],
      LineBox[{5809, 5810}]}, 
    {Hue[
      NCache[
       Rational[5810, 14307], 0.40609491857132873`]], AbsoluteThickness[0.25],
      LineBox[{5810, 5811}]}, 
    {Hue[
      NCache[
       Rational[1937, 4769], 0.4061648144265045]], AbsoluteThickness[0.25], 
     LineBox[{5811, 5812}]}, 
    {Hue[
      NCache[
       Rational[5812, 14307], 0.4062347102816803]], AbsoluteThickness[0.25], 
     LineBox[{5812, 5813}]}, 
    {Hue[
      NCache[
       Rational[5813, 14307], 0.4063046061368561]], AbsoluteThickness[0.25], 
     LineBox[{5813, 5814}]}, 
    {Hue[
      NCache[
       Rational[102, 251], 0.4063745019920319]], AbsoluteThickness[0.25], 
     LineBox[{5814, 5815}]}, 
    {Hue[
      NCache[
       Rational[5815, 14307], 0.40644439784720765`]], AbsoluteThickness[0.25],
      LineBox[{5815, 5816}]}, 
    {Hue[
      NCache[
       Rational[5816, 14307], 0.40651429370238346`]], AbsoluteThickness[0.25],
      LineBox[{5816, 5817}]}, 
    {Hue[
      NCache[
       Rational[1939, 4769], 0.40658418955755926`]], AbsoluteThickness[0.25], 
     LineBox[{5817, 5818}]}, 
    {Hue[
      NCache[
       Rational[5818, 14307], 0.406654085412735]], AbsoluteThickness[0.25], 
     LineBox[{5818, 5819}]}, 
    {Hue[
      NCache[
       Rational[5819, 14307], 0.4067239812679108]], AbsoluteThickness[0.25], 
     LineBox[{5819, 5820}]}, 
    {Hue[
      NCache[
       Rational[1940, 4769], 0.4067938771230866]], AbsoluteThickness[0.25], 
     LineBox[{5820, 5821}]}, 
    {Hue[
      NCache[
       Rational[5821, 14307], 0.4068637729782624]], AbsoluteThickness[0.25], 
     LineBox[{5821, 5822}]}, 
    {Hue[
      NCache[
       Rational[5822, 14307], 0.4069336688334382]], AbsoluteThickness[0.25], 
     LineBox[{5822, 5823}]}, 
    {Hue[
      NCache[
       Rational[1941, 4769], 0.407003564688614]], AbsoluteThickness[0.25], 
     LineBox[{5823, 5824}]}, 
    {Hue[
      NCache[
       Rational[5824, 14307], 0.40707346054378973`]], AbsoluteThickness[0.25],
      LineBox[{5824, 5825}]}, 
    {Hue[
      NCache[
       Rational[5825, 14307], 0.40714335639896554`]], AbsoluteThickness[0.25],
      LineBox[{5825, 5826}]}, 
    {Hue[
      NCache[
       Rational[1942, 4769], 0.40721325225414134`]], AbsoluteThickness[0.25], 
     LineBox[{5826, 5827}]}, 
    {Hue[
      NCache[
       Rational[5827, 14307], 0.4072831481093171]], AbsoluteThickness[0.25], 
     LineBox[{5827, 5828}]}, 
    {Hue[
      NCache[
       Rational[5828, 14307], 0.4073530439644929]], AbsoluteThickness[0.25], 
     LineBox[{5828, 5829}]}, 
    {Hue[
      NCache[
       Rational[1943, 4769], 0.4074229398196687]], AbsoluteThickness[0.25], 
     LineBox[{5829, 5830}]}, 
    {Hue[
      NCache[
       Rational[5830, 14307], 0.40749283567484446`]], AbsoluteThickness[0.25],
      LineBox[{5830, 5831}]}, 
    {Hue[
      NCache[
       Rational[5831, 14307], 0.40756273153002026`]], AbsoluteThickness[0.25],
      LineBox[{5831, 5832}]}, 
    {Hue[
      NCache[
       Rational[1944, 4769], 0.40763262738519607`]], AbsoluteThickness[0.25], 
     LineBox[{5832, 5833}]}, 
    {Hue[
      NCache[
       Rational[307, 753], 0.4077025232403719]], AbsoluteThickness[0.25], 
     LineBox[{5833, 5834}]}, 
    {Hue[
      NCache[
       Rational[5834, 14307], 0.4077724190955476]], AbsoluteThickness[0.25], 
     LineBox[{5834, 5835}]}, 
    {Hue[
      NCache[
       Rational[1945, 4769], 0.40784231495072343`]], AbsoluteThickness[0.25], 
     LineBox[{5835, 5836}]}, 
    {Hue[
      NCache[
       Rational[5836, 14307], 0.40791221080589923`]], AbsoluteThickness[0.25],
      LineBox[{5836, 5837}]}, 
    {Hue[
      NCache[
       Rational[5837, 14307], 0.407982106661075]], AbsoluteThickness[0.25], 
     LineBox[{5837, 5838}]}, 
    {Hue[
      NCache[
       Rational[1946, 4769], 0.4080520025162508]], AbsoluteThickness[0.25], 
     LineBox[{5838, 5839}]}, 
    {Hue[
      NCache[
       Rational[5839, 14307], 0.4081218983714266]], AbsoluteThickness[0.25], 
     LineBox[{5839, 5840}]}, 
    {Hue[
      NCache[
       Rational[5840, 14307], 0.40819179422660234`]], AbsoluteThickness[0.25],
      LineBox[{5840, 5841}]}, 
    {Hue[
      NCache[
       Rational[1947, 4769], 0.40826169008177815`]], AbsoluteThickness[0.25], 
     LineBox[{5841, 5842}]}, 
    {Hue[
      NCache[
       Rational[5842, 14307], 0.40833158593695396`]], AbsoluteThickness[0.25],
      LineBox[{5842, 5843}]}, 
    {Hue[
      NCache[
       Rational[5843, 14307], 0.4084014817921297]], AbsoluteThickness[0.25], 
     LineBox[{5843, 5844}]}, 
    {Hue[
      NCache[
       Rational[1948, 4769], 0.4084713776473055]], AbsoluteThickness[0.25], 
     LineBox[{5844, 5845}]}, 
    {Hue[
      NCache[
       Rational[5845, 14307], 0.4085412735024813]], AbsoluteThickness[0.25], 
     LineBox[{5845, 5846}]}, 
    {Hue[
      NCache[
       Rational[5846, 14307], 0.40861116935765707`]], AbsoluteThickness[0.25],
      LineBox[{5846, 5847}]}, 
    {Hue[
      NCache[
       Rational[1949, 4769], 0.4086810652128329]], AbsoluteThickness[0.25], 
     LineBox[{5847, 5848}]}, 
    {Hue[
      NCache[
       Rational[5848, 14307], 0.4087509610680087]], AbsoluteThickness[0.25], 
     LineBox[{5848, 5849}]}, 
    {Hue[
      NCache[
       Rational[5849, 14307], 0.40882085692318443`]], AbsoluteThickness[0.25],
      LineBox[{5849, 5850}]}, 
    {Hue[
      NCache[
       Rational[1950, 4769], 0.40889075277836023`]], AbsoluteThickness[0.25], 
     LineBox[{5850, 5851}]}, 
    {Hue[
      NCache[
       Rational[5851, 14307], 0.40896064863353604`]], AbsoluteThickness[0.25],
      LineBox[{5851, 5852}]}, 
    {Hue[
      NCache[
       Rational[308, 753], 0.40903054448871184`]], AbsoluteThickness[0.25], 
     LineBox[{5852, 5853}]}, 
    {Hue[
      NCache[
       Rational[1951, 4769], 0.4091004403438876]], AbsoluteThickness[0.25], 
     LineBox[{5853, 5854}]}, 
    {Hue[
      NCache[
       Rational[5854, 14307], 0.4091703361990634]], AbsoluteThickness[0.25], 
     LineBox[{5854, 5855}]}, 
    {Hue[
      NCache[
       Rational[5855, 14307], 0.4092402320542392]], AbsoluteThickness[0.25], 
     LineBox[{5855, 5856}]}, 
    {Hue[
      NCache[
       Rational[1952, 4769], 0.40931012790941496`]], AbsoluteThickness[0.25], 
     LineBox[{5856, 5857}]}, 
    {Hue[
      NCache[
       Rational[5857, 14307], 0.40938002376459076`]], AbsoluteThickness[0.25],
      LineBox[{5857, 5858}]}, 
    {Hue[
      NCache[
       Rational[5858, 14307], 0.40944991961976657`]], AbsoluteThickness[0.25],
      LineBox[{5858, 5859}]}, 
    {Hue[
      NCache[
       Rational[1953, 4769], 0.4095198154749423]], AbsoluteThickness[0.25], 
     LineBox[{5859, 5860}]}, 
    {Hue[
      NCache[
       Rational[5860, 14307], 0.4095897113301181]], AbsoluteThickness[0.25], 
     LineBox[{5860, 5861}]}, 
    {Hue[
      NCache[
       Rational[5861, 14307], 0.40965960718529393`]], AbsoluteThickness[0.25],
      LineBox[{5861, 5862}]}, 
    {Hue[
      NCache[
       Rational[1954, 4769], 0.4097295030404697]], AbsoluteThickness[0.25], 
     LineBox[{5862, 5863}]}, 
    {Hue[
      NCache[
       Rational[5863, 14307], 0.4097993988956455]], AbsoluteThickness[0.25], 
     LineBox[{5863, 5864}]}, 
    {Hue[
      NCache[
       Rational[5864, 14307], 0.4098692947508213]], AbsoluteThickness[0.25], 
     LineBox[{5864, 5865}]}, 
    {Hue[
      NCache[
       Rational[1955, 4769], 0.40993919060599704`]], AbsoluteThickness[0.25], 
     LineBox[{5865, 5866}]}, 
    {Hue[
      NCache[
       Rational[5866, 14307], 0.41000908646117284`]], AbsoluteThickness[0.25],
      LineBox[{5866, 5867}]}, 
    {Hue[
      NCache[
       Rational[5867, 14307], 0.41007898231634865`]], AbsoluteThickness[0.25],
      LineBox[{5867, 5868}]}, 
    {Hue[
      NCache[
       Rational[1956, 4769], 0.41014887817152446`]], AbsoluteThickness[0.25], 
     LineBox[{5868, 5869}]}, 
    {Hue[
      NCache[
       Rational[5869, 14307], 0.4102187740267002]], AbsoluteThickness[0.25], 
     LineBox[{5869, 5870}]}, 
    {Hue[
      NCache[
       Rational[5870, 14307], 0.410288669881876]], AbsoluteThickness[0.25], 
     LineBox[{5870, 5871}]}, 
    {Hue[
      NCache[
       Rational[103, 251], 0.4103585657370518]], AbsoluteThickness[0.25], 
     LineBox[{5871, 5872}]}, 
    {Hue[
      NCache[
       Rational[5872, 14307], 0.41042846159222757`]], AbsoluteThickness[0.25],
      LineBox[{5872, 5873}]}, 
    {Hue[
      NCache[
       Rational[5873, 14307], 0.4104983574474034]], AbsoluteThickness[0.25], 
     LineBox[{5873, 5874}]}, 
    {Hue[
      NCache[
       Rational[1958, 4769], 0.4105682533025792]], AbsoluteThickness[0.25], 
     LineBox[{5874, 5875}]}, 
    {Hue[
      NCache[
       Rational[5875, 14307], 0.41063814915775493`]], AbsoluteThickness[0.25],
      LineBox[{5875, 5876}]}, 
    {Hue[
      NCache[
       Rational[5876, 14307], 0.41070804501293073`]], AbsoluteThickness[0.25],
      LineBox[{5876, 5877}]}, 
    {Hue[
      NCache[
       Rational[1959, 4769], 0.41077794086810654`]], AbsoluteThickness[0.25], 
     LineBox[{5877, 5878}]}, 
    {Hue[
      NCache[
       Rational[5878, 14307], 0.4108478367232823]], AbsoluteThickness[0.25], 
     LineBox[{5878, 5879}]}, 
    {Hue[
      NCache[
       Rational[5879, 14307], 0.4109177325784581]], AbsoluteThickness[0.25], 
     LineBox[{5879, 5880}]}, 
    {Hue[
      NCache[
       Rational[1960, 4769], 0.4109876284336339]], AbsoluteThickness[0.25], 
     LineBox[{5880, 5881}]}, 
    {Hue[
      NCache[
       Rational[5881, 14307], 0.41105752428880965`]], AbsoluteThickness[0.25],
      LineBox[{5881, 5882}]}, 
    {Hue[
      NCache[
       Rational[5882, 14307], 0.41112742014398546`]], AbsoluteThickness[0.25],
      LineBox[{5882, 5883}]}, 
    {Hue[
      NCache[
       Rational[1961, 4769], 0.41119731599916126`]], AbsoluteThickness[0.25], 
     LineBox[{5883, 5884}]}, 
    {Hue[
      NCache[
       Rational[5884, 14307], 0.411267211854337]], AbsoluteThickness[0.25], 
     LineBox[{5884, 5885}]}, 
    {Hue[
      NCache[
       Rational[5885, 14307], 0.4113371077095128]], AbsoluteThickness[0.25], 
     LineBox[{5885, 5886}]}, 
    {Hue[
      NCache[
       Rational[1962, 4769], 0.4114070035646886]], AbsoluteThickness[0.25], 
     LineBox[{5886, 5887}]}, 
    {Hue[
      NCache[
       Rational[5887, 14307], 0.41147689941986443`]], AbsoluteThickness[0.25],
      LineBox[{5887, 5888}]}, 
    {Hue[
      NCache[
       Rational[5888, 14307], 0.4115467952750402]], AbsoluteThickness[0.25], 
     LineBox[{5888, 5889}]}, 
    {Hue[
      NCache[
       Rational[1963, 4769], 0.411616691130216]], AbsoluteThickness[0.25], 
     LineBox[{5889, 5890}]}, 
    {Hue[
      NCache[
       Rational[310, 753], 0.4116865869853918]], AbsoluteThickness[0.25], 
     LineBox[{5890, 5891}]}, 
    {Hue[
      NCache[
       Rational[5891, 14307], 0.41175648284056754`]], AbsoluteThickness[0.25],
      LineBox[{5891, 5892}]}, 
    {Hue[
      NCache[
       Rational[1964, 4769], 0.41182637869574334`]], AbsoluteThickness[0.25], 
     LineBox[{5892, 5893}]}, 
    {Hue[
      NCache[
       Rational[5893, 14307], 0.41189627455091915`]], AbsoluteThickness[0.25],
      LineBox[{5893, 5894}]}, 
    {Hue[
      NCache[
       Rational[5894, 14307], 0.4119661704060949]], AbsoluteThickness[0.25], 
     LineBox[{5894, 5895}]}, 
    {Hue[
      NCache[
       Rational[1965, 4769], 0.4120360662612707]], AbsoluteThickness[0.25], 
     LineBox[{5895, 5896}]}, 
    {Hue[
      NCache[
       Rational[5896, 14307], 0.4121059621164465]], AbsoluteThickness[0.25], 
     LineBox[{5896, 5897}]}, 
    {Hue[
      NCache[
       Rational[5897, 14307], 0.41217585797162226`]], AbsoluteThickness[0.25],
      LineBox[{5897, 5898}]}, 
    {Hue[
      NCache[
       Rational[1966, 4769], 0.41224575382679807`]], AbsoluteThickness[0.25], 
     LineBox[{5898, 5899}]}, 
    {Hue[
      NCache[
       Rational[5899, 14307], 0.4123156496819739]], AbsoluteThickness[0.25], 
     LineBox[{5899, 5900}]}, 
    {Hue[
      NCache[
       Rational[5900, 14307], 0.4123855455371496]], AbsoluteThickness[0.25], 
     LineBox[{5900, 5901}]}, 
    {Hue[
      NCache[
       Rational[1967, 4769], 0.41245544139232543`]], AbsoluteThickness[0.25], 
     LineBox[{5901, 5902}]}, 
    {Hue[
      NCache[
       Rational[5902, 14307], 0.41252533724750123`]], AbsoluteThickness[0.25],
      LineBox[{5902, 5903}]}, 
    {Hue[
      NCache[
       Rational[5903, 14307], 0.412595233102677]], AbsoluteThickness[0.25], 
     LineBox[{5903, 5904}]}, 
    {Hue[
      NCache[
       Rational[1968, 4769], 0.4126651289578528]], AbsoluteThickness[0.25], 
     LineBox[{5904, 5905}]}, 
    {Hue[
      NCache[
       Rational[5905, 14307], 0.4127350248130286]], AbsoluteThickness[0.25], 
     LineBox[{5905, 5906}]}, 
    {Hue[
      NCache[
       Rational[5906, 14307], 0.4128049206682044]], AbsoluteThickness[0.25], 
     LineBox[{5906, 5907}]}, 
    {Hue[
      NCache[
       Rational[1969, 4769], 0.41287481652338015`]], AbsoluteThickness[0.25], 
     LineBox[{5907, 5908}]}, 
    {Hue[
      NCache[
       Rational[5908, 14307], 0.41294471237855596`]], AbsoluteThickness[0.25],
      LineBox[{5908, 5909}]}, 
    {Hue[
      NCache[
       Rational[311, 753], 0.41301460823373176`]], AbsoluteThickness[0.25], 
     LineBox[{5909, 5910}]}, 
    {Hue[
      NCache[
       Rational[1970, 4769], 0.4130845040889075]], AbsoluteThickness[0.25], 
     LineBox[{5910, 5911}]}, 
    {Hue[
      NCache[
       Rational[5911, 14307], 0.4131543999440833]], AbsoluteThickness[0.25], 
     LineBox[{5911, 5912}]}, 
    {Hue[
      NCache[
       Rational[5912, 14307], 0.4132242957992591]], AbsoluteThickness[0.25], 
     LineBox[{5912, 5913}]}, 
    {Hue[
      NCache[
       Rational[1971, 4769], 0.4132941916544349]], AbsoluteThickness[0.25], 
     LineBox[{5913, 5914}]}, 
    {Hue[
      NCache[
       Rational[5914, 14307], 0.4133640875096107]], AbsoluteThickness[0.25], 
     LineBox[{5914, 5915}]}, 
    {Hue[
      NCache[
       Rational[5915, 14307], 0.4134339833647865]], AbsoluteThickness[0.25], 
     LineBox[{5915, 5916}]}, 
    {Hue[
      NCache[
       Rational[1972, 4769], 0.41350387921996223`]], AbsoluteThickness[0.25], 
     LineBox[{5916, 5917}]}, 
    {Hue[
      NCache[
       Rational[5917, 14307], 0.41357377507513804`]], AbsoluteThickness[0.25],
      LineBox[{5917, 5918}]}, 
    {Hue[
      NCache[
       Rational[5918, 14307], 0.41364367093031384`]], AbsoluteThickness[0.25],
      LineBox[{5918, 5919}]}, 
    {Hue[
      NCache[
       Rational[1973, 4769], 0.4137135667854896]], AbsoluteThickness[0.25], 
     LineBox[{5919, 5920}]}, 
    {Hue[
      NCache[
       Rational[5920, 14307], 0.4137834626406654]], AbsoluteThickness[0.25], 
     LineBox[{5920, 5921}]}, 
    {Hue[
      NCache[
       Rational[5921, 14307], 0.4138533584958412]], AbsoluteThickness[0.25], 
     LineBox[{5921, 5922}]}, 
    {Hue[
      NCache[
       Rational[1974, 4769], 0.413923254351017]], AbsoluteThickness[0.25], 
     LineBox[{5922, 5923}]}, 
    {Hue[
      NCache[
       Rational[5923, 14307], 0.41399315020619276`]], AbsoluteThickness[0.25],
      LineBox[{5923, 5924}]}, 
    {Hue[
      NCache[
       Rational[5924, 14307], 0.41406304606136857`]], AbsoluteThickness[0.25],
      LineBox[{5924, 5925}]}, 
    {Hue[
      NCache[
       Rational[1975, 4769], 0.4141329419165444]], AbsoluteThickness[0.25], 
     LineBox[{5925, 5926}]}, 
    {Hue[
      NCache[
       Rational[5926, 14307], 0.4142028377717201]], AbsoluteThickness[0.25], 
     LineBox[{5926, 5927}]}, 
    {Hue[
      NCache[
       Rational[5927, 14307], 0.41427273362689593`]], AbsoluteThickness[0.25],
      LineBox[{5927, 5928}]}, 
    {Hue[
      NCache[
       Rational[104, 251], 0.41434262948207173`]], AbsoluteThickness[0.25], 
     LineBox[{5928, 5929}]}, 
    {Hue[
      NCache[
       Rational[5929, 14307], 0.4144125253372475]], AbsoluteThickness[0.25], 
     LineBox[{5929, 5930}]}, 
    {Hue[
      NCache[
       Rational[5930, 14307], 0.4144824211924233]], AbsoluteThickness[0.25], 
     LineBox[{5930, 5931}]}, 
    {Hue[
      NCache[
       Rational[1977, 4769], 0.4145523170475991]], AbsoluteThickness[0.25], 
     LineBox[{5931, 5932}]}, 
    {Hue[
      NCache[
       Rational[5932, 14307], 0.41462221290277484`]], AbsoluteThickness[0.25],
      LineBox[{5932, 5933}]}, 
    {Hue[
      NCache[
       Rational[5933, 14307], 0.41469210875795065`]], AbsoluteThickness[0.25],
      LineBox[{5933, 5934}]}, 
    {Hue[
      NCache[
       Rational[1978, 4769], 0.41476200461312646`]], AbsoluteThickness[0.25], 
     LineBox[{5934, 5935}]}, 
    {Hue[
      NCache[
       Rational[5935, 14307], 0.4148319004683022]], AbsoluteThickness[0.25], 
     LineBox[{5935, 5936}]}, 
    {Hue[
      NCache[
       Rational[5936, 14307], 0.414901796323478]], AbsoluteThickness[0.25], 
     LineBox[{5936, 5937}]}, 
    {Hue[
      NCache[
       Rational[1979, 4769], 0.4149716921786538]], AbsoluteThickness[0.25], 
     LineBox[{5937, 5938}]}, 
    {Hue[
      NCache[
       Rational[5938, 14307], 0.41504158803382957`]], AbsoluteThickness[0.25],
      LineBox[{5938, 5939}]}, 
    {Hue[
      NCache[
       Rational[5939, 14307], 0.4151114838890054]], AbsoluteThickness[0.25], 
     LineBox[{5939, 5940}]}, 
    {Hue[
      NCache[
       Rational[1980, 4769], 0.4151813797441812]], AbsoluteThickness[0.25], 
     LineBox[{5940, 5941}]}, 
    {Hue[
      NCache[
       Rational[5941, 14307], 0.415251275599357]], AbsoluteThickness[0.25], 
     LineBox[{5941, 5942}]}, 
    {Hue[
      NCache[
       Rational[5942, 14307], 0.41532117145453273`]], AbsoluteThickness[0.25],
      LineBox[{5942, 5943}]}, 
    {Hue[
      NCache[
       Rational[1981, 4769], 0.41539106730970854`]], AbsoluteThickness[0.25], 
     LineBox[{5943, 5944}]}, 
    {Hue[
      NCache[
       Rational[5944, 14307], 0.41546096316488434`]], AbsoluteThickness[0.25],
      LineBox[{5944, 5945}]}, 
    {Hue[
      NCache[
       Rational[5945, 14307], 0.4155308590200601]], AbsoluteThickness[0.25], 
     LineBox[{5945, 5946}]}, 
    {Hue[
      NCache[
       Rational[1982, 4769], 0.4156007548752359]], AbsoluteThickness[0.25], 
     LineBox[{5946, 5947}]}, 
    {Hue[
      NCache[
       Rational[313, 753], 0.4156706507304117]], AbsoluteThickness[0.25], 
     LineBox[{5947, 5948}]}, 
    {Hue[
      NCache[
       Rational[5948, 14307], 0.41574054658558746`]], AbsoluteThickness[0.25],
      LineBox[{5948, 5949}]}, 
    {Hue[
      NCache[
       Rational[1983, 4769], 0.41581044244076326`]], AbsoluteThickness[0.25], 
     LineBox[{5949, 5950}]}, 
    {Hue[
      NCache[
       Rational[5950, 14307], 0.41588033829593907`]], AbsoluteThickness[0.25],
      LineBox[{5950, 5951}]}, 
    {Hue[
      NCache[
       Rational[5951, 14307], 0.4159502341511148]], AbsoluteThickness[0.25], 
     LineBox[{5951, 5952}]}, 
    {Hue[
      NCache[
       Rational[1984, 4769], 0.4160201300062906]], AbsoluteThickness[0.25], 
     LineBox[{5952, 5953}]}, 
    {Hue[
      NCache[
       Rational[5953, 14307], 0.41609002586146643`]], AbsoluteThickness[0.25],
      LineBox[{5953, 5954}]}, 
    {Hue[
      NCache[
       Rational[5954, 14307], 0.4161599217166422]], AbsoluteThickness[0.25], 
     LineBox[{5954, 5955}]}, 
    {Hue[
      NCache[
       Rational[1985, 4769], 0.416229817571818]], AbsoluteThickness[0.25], 
     LineBox[{5955, 5956}]}, 
    {Hue[
      NCache[
       Rational[5956, 14307], 0.4162997134269938]], AbsoluteThickness[0.25], 
     LineBox[{5956, 5957}]}, 
    {Hue[
      NCache[
       Rational[5957, 14307], 0.4163696092821696]], AbsoluteThickness[0.25], 
     LineBox[{5957, 5958}]}, 
    {Hue[
      NCache[
       Rational[1986, 4769], 0.41643950513734534`]], AbsoluteThickness[0.25], 
     LineBox[{5958, 5959}]}, 
    {Hue[
      NCache[
       Rational[5959, 14307], 0.41650940099252115`]], AbsoluteThickness[0.25],
      LineBox[{5959, 5960}]}, 
    {Hue[
      NCache[
       Rational[5960, 14307], 0.41657929684769696`]], AbsoluteThickness[0.25],
      LineBox[{5960, 5961}]}, 
    {Hue[
      NCache[
       Rational[1987, 4769], 0.4166491927028727]], AbsoluteThickness[0.25], 
     LineBox[{5961, 5962}]}, 
    {Hue[
      NCache[
       Rational[5962, 14307], 0.4167190885580485]], AbsoluteThickness[0.25], 
     LineBox[{5962, 5963}]}, 
    {Hue[
      NCache[
       Rational[5963, 14307], 0.4167889844132243]], AbsoluteThickness[0.25], 
     LineBox[{5963, 5964}]}, 
    {Hue[
      NCache[
       Rational[1988, 4769], 0.41685888026840007`]], AbsoluteThickness[0.25], 
     LineBox[{5964, 5965}]}, 
    {Hue[
      NCache[
       Rational[5965, 14307], 0.4169287761235759]], AbsoluteThickness[0.25], 
     LineBox[{5965, 5966}]}, 
    {Hue[
      NCache[
       Rational[314, 753], 0.4169986719787517]], AbsoluteThickness[0.25], 
     LineBox[{5966, 5967}]}, 
    {Hue[
      NCache[
       Rational[1989, 4769], 0.41706856783392743`]], AbsoluteThickness[0.25], 
     LineBox[{5967, 5968}]}, 
    {Hue[
      NCache[
       Rational[5968, 14307], 0.41713846368910323`]], AbsoluteThickness[0.25],
      LineBox[{5968, 5969}]}, 
    {Hue[
      NCache[
       Rational[5969, 14307], 0.41720835954427904`]], AbsoluteThickness[0.25],
      LineBox[{5969, 5970}]}, 
    {Hue[
      NCache[
       Rational[1990, 4769], 0.4172782553994548]], AbsoluteThickness[0.25], 
     LineBox[{5970, 5971}]}, 
    {Hue[
      NCache[
       Rational[5971, 14307], 0.4173481512546306]], AbsoluteThickness[0.25], 
     LineBox[{5971, 5972}]}, 
    {Hue[
      NCache[
       Rational[5972, 14307], 0.4174180471098064]], AbsoluteThickness[0.25], 
     LineBox[{5972, 5973}]}, 
    {Hue[
      NCache[
       Rational[1991, 4769], 0.41748794296498215`]], AbsoluteThickness[0.25], 
     LineBox[{5973, 5974}]}, 
    {Hue[
      NCache[
       Rational[5974, 14307], 0.41755783882015796`]], AbsoluteThickness[0.25],
      LineBox[{5974, 5975}]}, 
    {Hue[
      NCache[
       Rational[5975, 14307], 0.41762773467533376`]], AbsoluteThickness[0.25],
      LineBox[{5975, 5976}]}, 
    {Hue[
      NCache[
       Rational[1992, 4769], 0.41769763053050957`]], AbsoluteThickness[0.25], 
     LineBox[{5976, 5977}]}, 
    {Hue[
      NCache[
       Rational[5977, 14307], 0.4177675263856853]], AbsoluteThickness[0.25], 
     LineBox[{5977, 5978}]}, 
    {Hue[
      NCache[
       Rational[5978, 14307], 0.4178374222408611]], AbsoluteThickness[0.25], 
     LineBox[{5978, 5979}]}, 
    {Hue[
      NCache[
       Rational[1993, 4769], 0.41790731809603693`]], AbsoluteThickness[0.25], 
     LineBox[{5979, 5980}]}, 
    {Hue[
      NCache[
       Rational[5980, 14307], 0.4179772139512127]], AbsoluteThickness[0.25], 
     LineBox[{5980, 5981}]}, 
    {Hue[
      NCache[
       Rational[5981, 14307], 0.4180471098063885]], AbsoluteThickness[0.25], 
     LineBox[{5981, 5982}]}, 
    {Hue[
      NCache[
       Rational[1994, 4769], 0.4181170056615643]], AbsoluteThickness[0.25], 
     LineBox[{5982, 5983}]}, 
    {Hue[
      NCache[
       Rational[5983, 14307], 0.41818690151674004`]], AbsoluteThickness[0.25],
      LineBox[{5983, 5984}]}, 
    {Hue[
      NCache[
       Rational[5984, 14307], 0.41825679737191584`]], AbsoluteThickness[0.25],
      LineBox[{5984, 5985}]}, 
    {Hue[
      NCache[
       Rational[105, 251], 0.41832669322709165`]], AbsoluteThickness[0.25], 
     LineBox[{5985, 5986}]}, 
    {Hue[
      NCache[
       Rational[5986, 14307], 0.4183965890822674]], AbsoluteThickness[0.25], 
     LineBox[{5986, 5987}]}, 
    {Hue[
      NCache[
       Rational[5987, 14307], 0.4184664849374432]], AbsoluteThickness[0.25], 
     LineBox[{5987, 5988}]}, 
    {Hue[
      NCache[
       Rational[1996, 4769], 0.418536380792619]], AbsoluteThickness[0.25], 
     LineBox[{5988, 5989}]}, 
    {Hue[
      NCache[
       Rational[5989, 14307], 0.41860627664779476`]], AbsoluteThickness[0.25],
      LineBox[{5989, 5990}]}, 
    {Hue[
      NCache[
       Rational[5990, 14307], 0.41867617250297057`]], AbsoluteThickness[0.25],
      LineBox[{5990, 5991}]}, 
    {Hue[
      NCache[
       Rational[1997, 4769], 0.4187460683581464]], AbsoluteThickness[0.25], 
     LineBox[{5991, 5992}]}, 
    {Hue[
      NCache[
       Rational[5992, 14307], 0.4188159642133221]], AbsoluteThickness[0.25], 
     LineBox[{5992, 5993}]}, 
    {Hue[
      NCache[
       Rational[5993, 14307], 0.41888586006849793`]], AbsoluteThickness[0.25],
      LineBox[{5993, 5994}]}, 
    {Hue[
      NCache[
       Rational[1998, 4769], 0.41895575592367373`]], AbsoluteThickness[0.25], 
     LineBox[{5994, 5995}]}, 
    {Hue[
      NCache[
       Rational[5995, 14307], 0.41902565177884954`]], AbsoluteThickness[0.25],
      LineBox[{5995, 5996}]}, 
    {Hue[
      NCache[
       Rational[5996, 14307], 0.4190955476340253]], AbsoluteThickness[0.25], 
     LineBox[{5996, 5997}]}, 
    {Hue[
      NCache[
       Rational[1999, 4769], 0.4191654434892011]], AbsoluteThickness[0.25], 
     LineBox[{5997, 5998}]}, 
    {Hue[
      NCache[
       Rational[5998, 14307], 0.4192353393443769]], AbsoluteThickness[0.25], 
     LineBox[{5998, 5999}]}, 
    {Hue[
      NCache[
       Rational[5999, 14307], 0.41930523519955265`]], AbsoluteThickness[0.25],
      LineBox[{5999, 6000}]}, 
    {Hue[
      NCache[
       Rational[2000, 4769], 0.41937513105472846`]], AbsoluteThickness[0.25], 
     LineBox[{6000, 6001}]}, 
    {Hue[
      NCache[
       Rational[6001, 14307], 0.41944502690990426`]], AbsoluteThickness[0.25],
      LineBox[{6001, 6002}]}, 
    {Hue[
      NCache[
       Rational[6002, 14307], 0.41951492276508]], AbsoluteThickness[0.25], 
     LineBox[{6002, 6003}]}, 
    {Hue[
      NCache[
       Rational[2001, 4769], 0.4195848186202558]], AbsoluteThickness[0.25], 
     LineBox[{6003, 6004}]}, 
    {Hue[
      NCache[
       Rational[316, 753], 0.4196547144754316]], AbsoluteThickness[0.25], 
     LineBox[{6004, 6005}]}, 
    {Hue[
      NCache[
       Rational[6005, 14307], 0.4197246103306074]], AbsoluteThickness[0.25], 
     LineBox[{6005, 6006}]}, 
    {Hue[
      NCache[
       Rational[2002, 4769], 0.4197945061857832]], AbsoluteThickness[0.25], 
     LineBox[{6006, 6007}]}, 
    {Hue[
      NCache[
       Rational[6007, 14307], 0.419864402040959]], AbsoluteThickness[0.25], 
     LineBox[{6007, 6008}]}, 
    {Hue[
      NCache[
       Rational[6008, 14307], 0.41993429789613473`]], AbsoluteThickness[0.25],
      LineBox[{6008, 6009}]}, 
    {Hue[
      NCache[
       Rational[2003, 4769], 0.42000419375131054`]], AbsoluteThickness[0.25], 
     LineBox[{6009, 6010}]}, 
    {Hue[
      NCache[
       Rational[6010, 14307], 0.42007408960648634`]], AbsoluteThickness[0.25],
      LineBox[{6010, 6011}]}, 
    {Hue[
      NCache[
       Rational[6011, 14307], 0.42014398546166215`]], AbsoluteThickness[0.25],
      LineBox[{6011, 6012}]}, 
    {Hue[
      NCache[
       Rational[2004, 4769], 0.4202138813168379]], AbsoluteThickness[0.25], 
     LineBox[{6012, 6013}]}, 
    {Hue[
      NCache[
       Rational[6013, 14307], 0.4202837771720137]], AbsoluteThickness[0.25], 
     LineBox[{6013, 6014}]}, 
    {Hue[
      NCache[
       Rational[6014, 14307], 0.4203536730271895]], AbsoluteThickness[0.25], 
     LineBox[{6014, 6015}]}, 
    {Hue[
      NCache[
       Rational[2005, 4769], 0.42042356888236526`]], AbsoluteThickness[0.25], 
     LineBox[{6015, 6016}]}, 
    {Hue[
      NCache[
       Rational[6016, 14307], 0.42049346473754107`]], AbsoluteThickness[0.25],
      LineBox[{6016, 6017}]}, 
    {Hue[
      NCache[
       Rational[6017, 14307], 0.4205633605927169]], AbsoluteThickness[0.25], 
     LineBox[{6017, 6018}]}, 
    {Hue[
      NCache[
       Rational[2006, 4769], 0.4206332564478926]], AbsoluteThickness[0.25], 
     LineBox[{6018, 6019}]}, 
    {Hue[
      NCache[
       Rational[6019, 14307], 0.42070315230306843`]], AbsoluteThickness[0.25],
      LineBox[{6019, 6020}]}, 
    {Hue[
      NCache[
       Rational[6020, 14307], 0.42077304815824423`]], AbsoluteThickness[0.25],
      LineBox[{6020, 6021}]}, 
    {Hue[
      NCache[
       Rational[2007, 4769], 0.42084294401342]], AbsoluteThickness[0.25], 
     LineBox[{6021, 6022}]}, 
    {Hue[
      NCache[
       Rational[6022, 14307], 0.4209128398685958]], AbsoluteThickness[0.25], 
     LineBox[{6022, 6023}]}, 
    {Hue[
      NCache[
       Rational[317, 753], 0.4209827357237716]], AbsoluteThickness[0.25], 
     LineBox[{6023, 6024}]}, 
    {Hue[
      NCache[
       Rational[8, 19], 0.42105263157894735`]], AbsoluteThickness[0.25], 
     LineBox[{6024, 6025}]}, 
    {Hue[
      NCache[
       Rational[6025, 14307], 0.42112252743412315`]], AbsoluteThickness[0.25],
      LineBox[{6025, 6026}]}, 
    {Hue[
      NCache[
       Rational[6026, 14307], 0.42119242328929896`]], AbsoluteThickness[0.25],
      LineBox[{6026, 6027}]}, 
    {Hue[
      NCache[
       Rational[2009, 4769], 0.4212623191444747]], AbsoluteThickness[0.25], 
     LineBox[{6027, 6028}]}, 
    {Hue[
      NCache[
       Rational[6028, 14307], 0.4213322149996505]], AbsoluteThickness[0.25], 
     LineBox[{6028, 6029}]}, 
    {Hue[
      NCache[
       Rational[6029, 14307], 0.4214021108548263]], AbsoluteThickness[0.25], 
     LineBox[{6029, 6030}]}, 
    {Hue[
      NCache[
       Rational[2010, 4769], 0.4214720067100021]], AbsoluteThickness[0.25], 
     LineBox[{6030, 6031}]}, 
    {Hue[
      NCache[
       Rational[6031, 14307], 0.4215419025651779]], AbsoluteThickness[0.25], 
     LineBox[{6031, 6032}]}, 
    {Hue[
      NCache[
       Rational[6032, 14307], 0.4216117984203537]], AbsoluteThickness[0.25], 
     LineBox[{6032, 6033}]}, 
    {Hue[
      NCache[
       Rational[2011, 4769], 0.4216816942755295]], AbsoluteThickness[0.25], 
     LineBox[{6033, 6034}]}, 
    {Hue[
      NCache[
       Rational[6034, 14307], 0.42175159013070523`]], AbsoluteThickness[0.25],
      LineBox[{6034, 6035}]}, 
    {Hue[
      NCache[
       Rational[6035, 14307], 0.42182148598588104`]], AbsoluteThickness[0.25],
      LineBox[{6035, 6036}]}, 
    {Hue[
      NCache[
       Rational[2012, 4769], 0.42189138184105685`]], AbsoluteThickness[0.25], 
     LineBox[{6036, 6037}]}, 
    {Hue[
      NCache[
       Rational[6037, 14307], 0.4219612776962326]], AbsoluteThickness[0.25], 
     LineBox[{6037, 6038}]}, 
    {Hue[
      NCache[
       Rational[6038, 14307], 0.4220311735514084]], AbsoluteThickness[0.25], 
     LineBox[{6038, 6039}]}, 
    {Hue[
      NCache[
       Rational[2013, 4769], 0.4221010694065842]], AbsoluteThickness[0.25], 
     LineBox[{6039, 6040}]}, 
    {Hue[
      NCache[
       Rational[6040, 14307], 0.42217096526175996`]], AbsoluteThickness[0.25],
      LineBox[{6040, 6041}]}, 
    {Hue[
      NCache[
       Rational[6041, 14307], 0.42224086111693576`]], AbsoluteThickness[0.25],
      LineBox[{6041, 6042}]}, 
    {Hue[
      NCache[
       Rational[106, 251], 0.42231075697211157`]], AbsoluteThickness[0.25], 
     LineBox[{6042, 6043}]}, 
    {Hue[
      NCache[
       Rational[6043, 14307], 0.4223806528272873]], AbsoluteThickness[0.25], 
     LineBox[{6043, 6044}]}, 
    {Hue[
      NCache[
       Rational[6044, 14307], 0.4224505486824631]], AbsoluteThickness[0.25], 
     LineBox[{6044, 6045}]}, 
    {Hue[
      NCache[
       Rational[2015, 4769], 0.42252044453763893`]], AbsoluteThickness[0.25], 
     LineBox[{6045, 6046}]}, 
    {Hue[
      NCache[
       Rational[6046, 14307], 0.4225903403928147]], AbsoluteThickness[0.25], 
     LineBox[{6046, 6047}]}, 
    {Hue[
      NCache[
       Rational[6047, 14307], 0.4226602362479905]], AbsoluteThickness[0.25], 
     LineBox[{6047, 6048}]}, 
    {Hue[
      NCache[
       Rational[2016, 4769], 0.4227301321031663]], AbsoluteThickness[0.25], 
     LineBox[{6048, 6049}]}, 
    {Hue[
      NCache[
       Rational[6049, 14307], 0.4228000279583421]], AbsoluteThickness[0.25], 
     LineBox[{6049, 6050}]}, 
    {Hue[
      NCache[
       Rational[6050, 14307], 0.42286992381351785`]], AbsoluteThickness[0.25],
      LineBox[{6050, 6051}]}, 
    {Hue[
      NCache[
       Rational[2017, 4769], 0.42293981966869365`]], AbsoluteThickness[0.25], 
     LineBox[{6051, 6052}]}, 
    {Hue[
      NCache[
       Rational[6052, 14307], 0.42300971552386946`]], AbsoluteThickness[0.25],
      LineBox[{6052, 6053}]}, 
    {Hue[
      NCache[
       Rational[6053, 14307], 0.4230796113790452]], AbsoluteThickness[0.25], 
     LineBox[{6053, 6054}]}, 
    {Hue[
      NCache[
       Rational[2018, 4769], 0.423149507234221]], AbsoluteThickness[0.25], 
     LineBox[{6054, 6055}]}, 
    {Hue[
      NCache[
       Rational[6055, 14307], 0.4232194030893968]], AbsoluteThickness[0.25], 
     LineBox[{6055, 6056}]}, 
    {Hue[
      NCache[
       Rational[6056, 14307], 0.42328929894457257`]], AbsoluteThickness[0.25],
      LineBox[{6056, 6057}]}, 
    {Hue[
      NCache[
       Rational[2019, 4769], 0.4233591947997484]], AbsoluteThickness[0.25], 
     LineBox[{6057, 6058}]}, 
    {Hue[
      NCache[
       Rational[6058, 14307], 0.4234290906549242]], AbsoluteThickness[0.25], 
     LineBox[{6058, 6059}]}, 
    {Hue[
      NCache[
       Rational[6059, 14307], 0.42349898651009993`]], AbsoluteThickness[0.25],
      LineBox[{6059, 6060}]}, 
    {Hue[
      NCache[
       Rational[2020, 4769], 0.42356888236527573`]], AbsoluteThickness[0.25], 
     LineBox[{6060, 6061}]}, 
    {Hue[
      NCache[
       Rational[319, 753], 0.42363877822045154`]], AbsoluteThickness[0.25], 
     LineBox[{6061, 6062}]}, 
    {Hue[
      NCache[
       Rational[6062, 14307], 0.4237086740756273]], AbsoluteThickness[0.25], 
     LineBox[{6062, 6063}]}, 
    {Hue[
      NCache[
       Rational[2021, 4769], 0.4237785699308031]], AbsoluteThickness[0.25], 
     LineBox[{6063, 6064}]}, 
    {Hue[
      NCache[
       Rational[6064, 14307], 0.4238484657859789]], AbsoluteThickness[0.25], 
     LineBox[{6064, 6065}]}, 
    {Hue[
      NCache[
       Rational[6065, 14307], 0.4239183616411547]], AbsoluteThickness[0.25], 
     LineBox[{6065, 6066}]}, 
    {Hue[
      NCache[
       Rational[2022, 4769], 0.42398825749633046`]], AbsoluteThickness[0.25], 
     LineBox[{6066, 6067}]}, 
    {Hue[
      NCache[
       Rational[6067, 14307], 0.42405815335150626`]], AbsoluteThickness[0.25],
      LineBox[{6067, 6068}]}, 
    {Hue[
      NCache[
       Rational[6068, 14307], 0.42412804920668207`]], AbsoluteThickness[0.25],
      LineBox[{6068, 6069}]}, 
    {Hue[
      NCache[
       Rational[2023, 4769], 0.4241979450618578]], AbsoluteThickness[0.25], 
     LineBox[{6069, 6070}]}, 
    {Hue[
      NCache[
       Rational[6070, 14307], 0.4242678409170336]], AbsoluteThickness[0.25], 
     LineBox[{6070, 6071}]}, 
    {Hue[
      NCache[
       Rational[6071, 14307], 0.42433773677220943`]], AbsoluteThickness[0.25],
      LineBox[{6071, 6072}]}, 
    {Hue[
      NCache[
       Rational[2024, 4769], 0.4244076326273852]], AbsoluteThickness[0.25], 
     LineBox[{6072, 6073}]}, 
    {Hue[
      NCache[
       Rational[6073, 14307], 0.424477528482561]], AbsoluteThickness[0.25], 
     LineBox[{6073, 6074}]}, 
    {Hue[
      NCache[
       Rational[6074, 14307], 0.4245474243377368]], AbsoluteThickness[0.25], 
     LineBox[{6074, 6075}]}, 
    {Hue[
      NCache[
       Rational[2025, 4769], 0.42461732019291254`]], AbsoluteThickness[0.25], 
     LineBox[{6075, 6076}]}, 
    {Hue[
      NCache[
       Rational[6076, 14307], 0.42468721604808835`]], AbsoluteThickness[0.25],
      LineBox[{6076, 6077}]}, 
    {Hue[
      NCache[
       Rational[6077, 14307], 0.42475711190326415`]], AbsoluteThickness[0.25],
      LineBox[{6077, 6078}]}, 
    {Hue[
      NCache[
       Rational[2026, 4769], 0.4248270077584399]], AbsoluteThickness[0.25], 
     LineBox[{6078, 6079}]}, 
    {Hue[
      NCache[
       Rational[6079, 14307], 0.4248969036136157]], AbsoluteThickness[0.25], 
     LineBox[{6079, 6080}]}, 
    {Hue[
      NCache[
       Rational[320, 753], 0.4249667994687915]], AbsoluteThickness[0.25], 
     LineBox[{6080, 6081}]}, 
    {Hue[
      NCache[
       Rational[2027, 4769], 0.42503669532396726`]], AbsoluteThickness[0.25], 
     LineBox[{6081, 6082}]}, 
    {Hue[
      NCache[
       Rational[6082, 14307], 0.42510659117914307`]], AbsoluteThickness[0.25],
      LineBox[{6082, 6083}]}, 
    {Hue[
      NCache[
       Rational[6083, 14307], 0.4251764870343189]], AbsoluteThickness[0.25], 
     LineBox[{6083, 6084}]}, 
    {Hue[
      NCache[
       Rational[2028, 4769], 0.4252463828894947]], AbsoluteThickness[0.25], 
     LineBox[{6084, 6085}]}, 
    {Hue[
      NCache[
       Rational[6085, 14307], 0.42531627874467043`]], AbsoluteThickness[0.25],
      LineBox[{6085, 6086}]}, 
    {Hue[
      NCache[
       Rational[6086, 14307], 0.42538617459984623`]], AbsoluteThickness[0.25],
      LineBox[{6086, 6087}]}, 
    {Hue[
      NCache[
       Rational[2029, 4769], 0.42545607045502204`]], AbsoluteThickness[0.25], 
     LineBox[{6087, 6088}]}, 
    {Hue[
      NCache[
       Rational[6088, 14307], 0.4255259663101978]], AbsoluteThickness[0.25], 
     LineBox[{6088, 6089}]}, 
    {Hue[
      NCache[
       Rational[6089, 14307], 0.4255958621653736]], AbsoluteThickness[0.25], 
     LineBox[{6089, 6090}]}, 
    {Hue[
      NCache[
       Rational[2030, 4769], 0.4256657580205494]], AbsoluteThickness[0.25], 
     LineBox[{6090, 6091}]}, 
    {Hue[
      NCache[
       Rational[6091, 14307], 0.42573565387572515`]], AbsoluteThickness[0.25],
      LineBox[{6091, 6092}]}, 
    {Hue[
      NCache[
       Rational[6092, 14307], 0.42580554973090096`]], AbsoluteThickness[0.25],
      LineBox[{6092, 6093}]}, 
    {Hue[
      NCache[
       Rational[2031, 4769], 0.42587544558607676`]], AbsoluteThickness[0.25], 
     LineBox[{6093, 6094}]}, 
    {Hue[
      NCache[
       Rational[6094, 14307], 0.4259453414412525]], AbsoluteThickness[0.25], 
     LineBox[{6094, 6095}]}, 
    {Hue[
      NCache[
       Rational[6095, 14307], 0.4260152372964283]], AbsoluteThickness[0.25], 
     LineBox[{6095, 6096}]}, 
    {Hue[
      NCache[
       Rational[2032, 4769], 0.4260851331516041]], AbsoluteThickness[0.25], 
     LineBox[{6096, 6097}]}, 
    {Hue[
      NCache[
       Rational[6097, 14307], 0.4261550290067799]], AbsoluteThickness[0.25], 
     LineBox[{6097, 6098}]}, 
    {Hue[
      NCache[
       Rational[6098, 14307], 0.4262249248619557]], AbsoluteThickness[0.25], 
     LineBox[{6098, 6099}]}, 
    {Hue[
      NCache[
       Rational[107, 251], 0.4262948207171315]], AbsoluteThickness[0.25], 
     LineBox[{6099, 6100}]}, 
    {Hue[
      NCache[
       Rational[6100, 14307], 0.4263647165723073]], AbsoluteThickness[0.25], 
     LineBox[{6100, 6101}]}, 
    {Hue[
      NCache[
       Rational[6101, 14307], 0.42643461242748304`]], AbsoluteThickness[0.25],
      LineBox[{6101, 6102}]}, 
    {Hue[
      NCache[
       Rational[2034, 4769], 0.42650450828265885`]], AbsoluteThickness[0.25], 
     LineBox[{6102, 6103}]}, 
    {Hue[
      NCache[
       Rational[6103, 14307], 0.42657440413783465`]], AbsoluteThickness[0.25],
      LineBox[{6103, 6104}]}, 
    {Hue[
      NCache[
       Rational[6104, 14307], 0.4266442999930104]], AbsoluteThickness[0.25], 
     LineBox[{6104, 6105}]}, 
    {Hue[
      NCache[
       Rational[2035, 4769], 0.4267141958481862]], AbsoluteThickness[0.25], 
     LineBox[{6105, 6106}]}, 
    {Hue[
      NCache[
       Rational[6106, 14307], 0.426784091703362]], AbsoluteThickness[0.25], 
     LineBox[{6106, 6107}]}, 
    {Hue[
      NCache[
       Rational[6107, 14307], 0.42685398755853776`]], AbsoluteThickness[0.25],
      LineBox[{6107, 6108}]}, 
    {Hue[
      NCache[
       Rational[2036, 4769], 0.42692388341371357`]], AbsoluteThickness[0.25], 
     LineBox[{6108, 6109}]}, 
    {Hue[
      NCache[
       Rational[6109, 14307], 0.4269937792688894]], AbsoluteThickness[0.25], 
     LineBox[{6109, 6110}]}, 
    {Hue[
      NCache[
       Rational[6110, 14307], 0.4270636751240651]], AbsoluteThickness[0.25], 
     LineBox[{6110, 6111}]}, 
    {Hue[
      NCache[
       Rational[2037, 4769], 0.42713357097924093`]], AbsoluteThickness[0.25], 
     LineBox[{6111, 6112}]}, 
    {Hue[
      NCache[
       Rational[6112, 14307], 0.42720346683441673`]], AbsoluteThickness[0.25],
      LineBox[{6112, 6113}]}, 
    {Hue[
      NCache[
       Rational[6113, 14307], 0.4272733626895925]], AbsoluteThickness[0.25], 
     LineBox[{6113, 6114}]}, 
    {Hue[
      NCache[
       Rational[2038, 4769], 0.4273432585447683]], AbsoluteThickness[0.25], 
     LineBox[{6114, 6115}]}, 
    {Hue[
      NCache[
       Rational[6115, 14307], 0.4274131543999441]], AbsoluteThickness[0.25], 
     LineBox[{6115, 6116}]}, 
    {Hue[
      NCache[
       Rational[6116, 14307], 0.42748305025511985`]], AbsoluteThickness[0.25],
      LineBox[{6116, 6117}]}, 
    {Hue[
      NCache[
       Rational[2039, 4769], 0.42755294611029565`]], AbsoluteThickness[0.25], 
     LineBox[{6117, 6118}]}, 
    {Hue[
      NCache[
       Rational[322, 753], 0.42762284196547146`]], AbsoluteThickness[0.25], 
     LineBox[{6118, 6119}]}, 
    {Hue[
      NCache[
       Rational[6119, 14307], 0.42769273782064726`]], AbsoluteThickness[0.25],
      LineBox[{6119, 6120}]}, 
    {Hue[
      NCache[
       Rational[2040, 4769], 0.427762633675823]], AbsoluteThickness[0.25], 
     LineBox[{6120, 6121}]}, 
    {Hue[
      NCache[
       Rational[6121, 14307], 0.4278325295309988]], AbsoluteThickness[0.25], 
     LineBox[{6121, 6122}]}, 
    {Hue[
      NCache[
       Rational[6122, 14307], 0.4279024253861746]], AbsoluteThickness[0.25], 
     LineBox[{6122, 6123}]}, 
    {Hue[
      NCache[
       Rational[2041, 4769], 0.4279723212413504]], AbsoluteThickness[0.25], 
     LineBox[{6123, 6124}]}, 
    {Hue[
      NCache[
       Rational[6124, 14307], 0.4280422170965262]], AbsoluteThickness[0.25], 
     LineBox[{6124, 6125}]}, 
    {Hue[
      NCache[
       Rational[6125, 14307], 0.428112112951702]], AbsoluteThickness[0.25], 
     LineBox[{6125, 6126}]}, 
    {Hue[
      NCache[
       Rational[2042, 4769], 0.42818200880687773`]], AbsoluteThickness[0.25], 
     LineBox[{6126, 6127}]}, 
    {Hue[
      NCache[
       Rational[6127, 14307], 0.42825190466205354`]], AbsoluteThickness[0.25],
      LineBox[{6127, 6128}]}, 
    {Hue[
      NCache[
       Rational[6128, 14307], 0.42832180051722935`]], AbsoluteThickness[0.25],
      LineBox[{6128, 6129}]}, 
    {Hue[
      NCache[
       Rational[2043, 4769], 0.4283916963724051]], AbsoluteThickness[0.25], 
     LineBox[{6129, 6130}]}, 
    {Hue[
      NCache[
       Rational[6130, 14307], 0.4284615922275809]], AbsoluteThickness[0.25], 
     LineBox[{6130, 6131}]}, 
    {Hue[
      NCache[
       Rational[6131, 14307], 0.4285314880827567]], AbsoluteThickness[0.25], 
     LineBox[{6131, 6132}]}, 
    {Hue[
      NCache[
       Rational[2044, 4769], 0.42860138393793246`]], AbsoluteThickness[0.25], 
     LineBox[{6132, 6133}]}, 
    {Hue[
      NCache[
       Rational[6133, 14307], 0.42867127979310826`]], AbsoluteThickness[0.25],
      LineBox[{6133, 6134}]}, 
    {Hue[
      NCache[
       Rational[6134, 14307], 0.42874117564828407`]], AbsoluteThickness[0.25],
      LineBox[{6134, 6135}]}, 
    {Hue[
      NCache[
       Rational[2045, 4769], 0.4288110715034598]], AbsoluteThickness[0.25], 
     LineBox[{6135, 6136}]}, 
    {Hue[
      NCache[
       Rational[6136, 14307], 0.4288809673586356]], AbsoluteThickness[0.25], 
     LineBox[{6136, 6137}]}, 
    {Hue[
      NCache[
       Rational[323, 753], 0.42895086321381143`]], AbsoluteThickness[0.25], 
     LineBox[{6137, 6138}]}, 
    {Hue[
      NCache[
       Rational[2046, 4769], 0.42902075906898723`]], AbsoluteThickness[0.25], 
     LineBox[{6138, 6139}]}, 
    {Hue[
      NCache[
       Rational[6139, 14307], 0.429090654924163]], AbsoluteThickness[0.25], 
     LineBox[{6139, 6140}]}, 
    {Hue[
      NCache[
       Rational[6140, 14307], 0.4291605507793388]], AbsoluteThickness[0.25], 
     LineBox[{6140, 6141}]}, 
    {Hue[
      NCache[
       Rational[2047, 4769], 0.4292304466345146]], AbsoluteThickness[0.25], 
     LineBox[{6141, 6142}]}, 
    {Hue[
      NCache[
       Rational[6142, 14307], 0.42930034248969035`]], AbsoluteThickness[0.25],
      LineBox[{6142, 6143}]}, 
    {Hue[
      NCache[
       Rational[6143, 14307], 0.42937023834486615`]], AbsoluteThickness[0.25],
      LineBox[{6143, 6144}]}, 
    {Hue[
      NCache[
       Rational[2048, 4769], 0.42944013420004196`]], AbsoluteThickness[0.25], 
     LineBox[{6144, 6145}]}, 
    {Hue[
      NCache[
       Rational[6145, 14307], 0.4295100300552177]], AbsoluteThickness[0.25], 
     LineBox[{6145, 6146}]}, 
    {Hue[
      NCache[
       Rational[6146, 14307], 0.4295799259103935]], AbsoluteThickness[0.25], 
     LineBox[{6146, 6147}]}, 
    {Hue[
      NCache[
       Rational[2049, 4769], 0.4296498217655693]], AbsoluteThickness[0.25], 
     LineBox[{6147, 6148}]}, 
    {Hue[
      NCache[
       Rational[6148, 14307], 0.42971971762074507`]], AbsoluteThickness[0.25],
      LineBox[{6148, 6149}]}, 
    {Hue[
      NCache[
       Rational[6149, 14307], 0.4297896134759209]], AbsoluteThickness[0.25], 
     LineBox[{6149, 6150}]}, 
    {Hue[
      NCache[
       Rational[2050, 4769], 0.4298595093310967]], AbsoluteThickness[0.25], 
     LineBox[{6150, 6151}]}, 
    {Hue[
      NCache[
       Rational[6151, 14307], 0.42992940518627243`]], AbsoluteThickness[0.25],
      LineBox[{6151, 6152}]}, 
    {Hue[
      NCache[
       Rational[6152, 14307], 0.42999930104144823`]], AbsoluteThickness[0.25],
      LineBox[{6152, 6153}]}, 
    {Hue[
      NCache[
       Rational[2051, 4769], 0.43006919689662404`]], AbsoluteThickness[0.25], 
     LineBox[{6153, 6154}]}, 
    {Hue[
      NCache[
       Rational[6154, 14307], 0.43013909275179985`]], AbsoluteThickness[0.25],
      LineBox[{6154, 6155}]}, 
    {Hue[
      NCache[
       Rational[6155, 14307], 0.4302089886069756]], AbsoluteThickness[0.25], 
     LineBox[{6155, 6156}]}, 
    {Hue[
      NCache[
       Rational[108, 251], 0.4302788844621514]], AbsoluteThickness[0.25], 
     LineBox[{6156, 6157}]}, 
    {Hue[
      NCache[
       Rational[6157, 14307], 0.4303487803173272]], AbsoluteThickness[0.25], 
     LineBox[{6157, 6158}]}, 
    {Hue[
      NCache[
       Rational[6158, 14307], 0.43041867617250296`]], AbsoluteThickness[0.25],
      LineBox[{6158, 6159}]}, 
    {Hue[
      NCache[
       Rational[2053, 4769], 0.43048857202767876`]], AbsoluteThickness[0.25], 
     LineBox[{6159, 6160}]}, 
    {Hue[
      NCache[
       Rational[6160, 14307], 0.43055846788285457`]], AbsoluteThickness[0.25],
      LineBox[{6160, 6161}]}, 
    {Hue[
      NCache[
       Rational[6161, 14307], 0.4306283637380303]], AbsoluteThickness[0.25], 
     LineBox[{6161, 6162}]}, 
    {Hue[
      NCache[
       Rational[2054, 4769], 0.4306982595932061]], AbsoluteThickness[0.25], 
     LineBox[{6162, 6163}]}, 
    {Hue[
      NCache[
       Rational[6163, 14307], 0.43076815544838193`]], AbsoluteThickness[0.25],
      LineBox[{6163, 6164}]}, 
    {Hue[
      NCache[
       Rational[6164, 14307], 0.4308380513035577]], AbsoluteThickness[0.25], 
     LineBox[{6164, 6165}]}, 
    {Hue[
      NCache[
       Rational[2055, 4769], 0.4309079471587335]], AbsoluteThickness[0.25], 
     LineBox[{6165, 6166}]}, 
    {Hue[
      NCache[
       Rational[6166, 14307], 0.4309778430139093]], AbsoluteThickness[0.25], 
     LineBox[{6166, 6167}]}, 
    {Hue[
      NCache[
       Rational[6167, 14307], 0.43104773886908504`]], AbsoluteThickness[0.25],
      LineBox[{6167, 6168}]}, 
    {Hue[
      NCache[
       Rational[2056, 4769], 0.43111763472426085`]], AbsoluteThickness[0.25], 
     LineBox[{6168, 6169}]}, 
    {Hue[
      NCache[
       Rational[6169, 14307], 0.43118753057943665`]], AbsoluteThickness[0.25],
      LineBox[{6169, 6170}]}, 
    {Hue[
      NCache[
       Rational[6170, 14307], 0.4312574264346124]], AbsoluteThickness[0.25], 
     LineBox[{6170, 6171}]}, 
    {Hue[
      NCache[
       Rational[2057, 4769], 0.4313273222897882]], AbsoluteThickness[0.25], 
     LineBox[{6171, 6172}]}, 
    {Hue[
      NCache[
       Rational[6172, 14307], 0.431397218144964]], AbsoluteThickness[0.25], 
     LineBox[{6172, 6173}]}, 
    {Hue[
      NCache[
       Rational[6173, 14307], 0.4314671140001398]], AbsoluteThickness[0.25], 
     LineBox[{6173, 6174}]}, 
    {Hue[
      NCache[
       Rational[2058, 4769], 0.43153700985531557`]], AbsoluteThickness[0.25], 
     LineBox[{6174, 6175}]}, 
    {Hue[
      NCache[
       Rational[325, 753], 0.4316069057104914]], AbsoluteThickness[0.25], 
     LineBox[{6175, 6176}]}, 
    {Hue[
      NCache[
       Rational[6176, 14307], 0.4316768015656672]], AbsoluteThickness[0.25], 
     LineBox[{6176, 6177}]}, 
    {Hue[
      NCache[
       Rational[2059, 4769], 0.43174669742084293`]], AbsoluteThickness[0.25], 
     LineBox[{6177, 6178}]}, 
    {Hue[
      NCache[
       Rational[6178, 14307], 0.43181659327601873`]], AbsoluteThickness[0.25],
      LineBox[{6178, 6179}]}, 
    {Hue[
      NCache[
       Rational[6179, 14307], 0.43188648913119454`]], AbsoluteThickness[0.25],
      LineBox[{6179, 6180}]}, 
    {Hue[
      NCache[
       Rational[2060, 4769], 0.4319563849863703]], AbsoluteThickness[0.25], 
     LineBox[{6180, 6181}]}, 
    {Hue[
      NCache[
       Rational[6181, 14307], 0.4320262808415461]], AbsoluteThickness[0.25], 
     LineBox[{6181, 6182}]}, 
    {Hue[
      NCache[
       Rational[6182, 14307], 0.4320961766967219]], AbsoluteThickness[0.25], 
     LineBox[{6182, 6183}]}, 
    {Hue[
      NCache[
       Rational[2061, 4769], 0.43216607255189765`]], AbsoluteThickness[0.25], 
     LineBox[{6183, 6184}]}, 
    {Hue[
      NCache[
       Rational[6184, 14307], 0.43223596840707346`]], AbsoluteThickness[0.25],
      LineBox[{6184, 6185}]}, 
    {Hue[
      NCache[
       Rational[6185, 14307], 0.43230586426224926`]], AbsoluteThickness[0.25],
      LineBox[{6185, 6186}]}, 
    {Hue[
      NCache[
       Rational[2062, 4769], 0.432375760117425]], AbsoluteThickness[0.25], 
     LineBox[{6186, 6187}]}, 
    {Hue[
      NCache[
       Rational[6187, 14307], 0.4324456559726008]], AbsoluteThickness[0.25], 
     LineBox[{6187, 6188}]}, 
    {Hue[
      NCache[
       Rational[6188, 14307], 0.4325155518277766]], AbsoluteThickness[0.25], 
     LineBox[{6188, 6189}]}, 
    {Hue[
      NCache[
       Rational[2063, 4769], 0.43258544768295243`]], AbsoluteThickness[0.25], 
     LineBox[{6189, 6190}]}, 
    {Hue[
      NCache[
       Rational[6190, 14307], 0.4326553435381282]], AbsoluteThickness[0.25], 
     LineBox[{6190, 6191}]}, 
    {Hue[
      NCache[
       Rational[6191, 14307], 0.432725239393304]], AbsoluteThickness[0.25], 
     LineBox[{6191, 6192}]}, 
    {Hue[
      NCache[
       Rational[2064, 4769], 0.4327951352484798]], AbsoluteThickness[0.25], 
     LineBox[{6192, 6193}]}, 
    {Hue[
      NCache[
       Rational[6193, 14307], 0.43286503110365554`]], AbsoluteThickness[0.25],
      LineBox[{6193, 6194}]}, 
    {Hue[
      NCache[
       Rational[326, 753], 0.43293492695883135`]], AbsoluteThickness[0.25], 
     LineBox[{6194, 6195}]}, 
    {Hue[
      NCache[
       Rational[2065, 4769], 0.43300482281400715`]], AbsoluteThickness[0.25], 
     LineBox[{6195, 6196}]}, 
    {Hue[
      NCache[
       Rational[6196, 14307], 0.4330747186691829]], AbsoluteThickness[0.25], 
     LineBox[{6196, 6197}]}, 
    {Hue[
      NCache[
       Rational[6197, 14307], 0.4331446145243587]], AbsoluteThickness[0.25], 
     LineBox[{6197, 6198}]}, 
    {Hue[
      NCache[
       Rational[2066, 4769], 0.4332145103795345]], AbsoluteThickness[0.25], 
     LineBox[{6198, 6199}]}, 
    {Hue[
      NCache[
       Rational[6199, 14307], 0.43328440623471026`]], AbsoluteThickness[0.25],
      LineBox[{6199, 6200}]}, 
    {Hue[
      NCache[
       Rational[6200, 14307], 0.43335430208988607`]], AbsoluteThickness[0.25],
      LineBox[{6200, 6201}]}, 
    {Hue[
      NCache[
       Rational[2067, 4769], 0.4334241979450619]], AbsoluteThickness[0.25], 
     LineBox[{6201, 6202}]}, 
    {Hue[
      NCache[
       Rational[6202, 14307], 0.4334940938002376]], AbsoluteThickness[0.25], 
     LineBox[{6202, 6203}]}, 
    {Hue[
      NCache[
       Rational[6203, 14307], 0.43356398965541343`]], AbsoluteThickness[0.25],
      LineBox[{6203, 6204}]}, 
    {Hue[
      NCache[
       Rational[2068, 4769], 0.43363388551058923`]], AbsoluteThickness[0.25], 
     LineBox[{6204, 6205}]}, 
    {Hue[
      NCache[
       Rational[6205, 14307], 0.433703781365765]], AbsoluteThickness[0.25], 
     LineBox[{6205, 6206}]}, 
    {Hue[
      NCache[
       Rational[6206, 14307], 0.4337736772209408]], AbsoluteThickness[0.25], 
     LineBox[{6206, 6207}]}, 
    {Hue[
      NCache[
       Rational[2069, 4769], 0.4338435730761166]], AbsoluteThickness[0.25], 
     LineBox[{6207, 6208}]}, 
    {Hue[
      NCache[
       Rational[6208, 14307], 0.4339134689312924]], AbsoluteThickness[0.25], 
     LineBox[{6208, 6209}]}, 
    {Hue[
      NCache[
       Rational[6209, 14307], 0.43398336478646815`]], AbsoluteThickness[0.25],
      LineBox[{6209, 6210}]}, 
    {Hue[
      NCache[
       Rational[2070, 4769], 0.43405326064164396`]], AbsoluteThickness[0.25], 
     LineBox[{6210, 6211}]}, 
    {Hue[
      NCache[
       Rational[6211, 14307], 0.43412315649681976`]], AbsoluteThickness[0.25],
      LineBox[{6211, 6212}]}, 
    {Hue[
      NCache[
       Rational[6212, 14307], 0.4341930523519955]], AbsoluteThickness[0.25], 
     LineBox[{6212, 6213}]}, 
    {Hue[
      NCache[
       Rational[109, 251], 0.4342629482071713]], AbsoluteThickness[0.25], 
     LineBox[{6213, 6214}]}, 
    {Hue[
      NCache[
       Rational[6214, 14307], 0.4343328440623471]], AbsoluteThickness[0.25], 
     LineBox[{6214, 6215}]}, 
    {Hue[
      NCache[
       Rational[6215, 14307], 0.4344027399175229]], AbsoluteThickness[0.25], 
     LineBox[{6215, 6216}]}, 
    {Hue[
      NCache[
       Rational[2072, 4769], 0.4344726357726987]], AbsoluteThickness[0.25], 
     LineBox[{6216, 6217}]}, 
    {Hue[
      NCache[
       Rational[6217, 14307], 0.4345425316278745]], AbsoluteThickness[0.25], 
     LineBox[{6217, 6218}]}, 
    {Hue[
      NCache[
       Rational[6218, 14307], 0.43461242748305023`]], AbsoluteThickness[0.25],
      LineBox[{6218, 6219}]}, 
    {Hue[
      NCache[
       Rational[2073, 4769], 0.43468232333822604`]], AbsoluteThickness[0.25], 
     LineBox[{6219, 6220}]}, 
    {Hue[
      NCache[
       Rational[6220, 14307], 0.43475221919340185`]], AbsoluteThickness[0.25],
      LineBox[{6220, 6221}]}, 
    {Hue[
      NCache[
       Rational[6221, 14307], 0.4348221150485776]], AbsoluteThickness[0.25], 
     LineBox[{6221, 6222}]}, 
    {Hue[
      NCache[
       Rational[2074, 4769], 0.4348920109037534]], AbsoluteThickness[0.25], 
     LineBox[{6222, 6223}]}, 
    {Hue[
      NCache[
       Rational[6223, 14307], 0.4349619067589292]], AbsoluteThickness[0.25], 
     LineBox[{6223, 6224}]}, 
    {Hue[
      NCache[
       Rational[6224, 14307], 0.43503180261410496`]], AbsoluteThickness[0.25],
      LineBox[{6224, 6225}]}, 
    {Hue[
      NCache[
       Rational[2075, 4769], 0.43510169846928076`]], AbsoluteThickness[0.25], 
     LineBox[{6225, 6226}]}, 
    {Hue[
      NCache[
       Rational[6226, 14307], 0.43517159432445657`]], AbsoluteThickness[0.25],
      LineBox[{6226, 6227}]}, 
    {Hue[
      NCache[
       Rational[6227, 14307], 0.4352414901796324]], AbsoluteThickness[0.25], 
     LineBox[{6227, 6228}]}, 
    {Hue[
      NCache[
       Rational[2076, 4769], 0.4353113860348081]], AbsoluteThickness[0.25], 
     LineBox[{6228, 6229}]}, 
    {Hue[
      NCache[
       Rational[6229, 14307], 0.43538128188998393`]], AbsoluteThickness[0.25],
      LineBox[{6229, 6230}]}, 
    {Hue[
      NCache[
       Rational[6230, 14307], 0.43545117774515973`]], AbsoluteThickness[0.25],
      LineBox[{6230, 6231}]}, 
    {Hue[
      NCache[
       Rational[2077, 4769], 0.4355210736003355]], AbsoluteThickness[0.25], 
     LineBox[{6231, 6232}]}, 
    {Hue[
      NCache[
       Rational[328, 753], 0.4355909694555113]], AbsoluteThickness[0.25], 
     LineBox[{6232, 6233}]}, 
    {Hue[
      NCache[
       Rational[6233, 14307], 0.4356608653106871]], AbsoluteThickness[0.25], 
     LineBox[{6233, 6234}]}, 
    {Hue[
      NCache[
       Rational[2078, 4769], 0.43573076116586285`]], AbsoluteThickness[0.25], 
     LineBox[{6234, 6235}]}, 
    {Hue[
      NCache[
       Rational[6235, 14307], 0.43580065702103865`]], AbsoluteThickness[0.25],
      LineBox[{6235, 6236}]}, 
    {Hue[
      NCache[
       Rational[6236, 14307], 0.43587055287621446`]], AbsoluteThickness[0.25],
      LineBox[{6236, 6237}]}, 
    {Hue[
      NCache[
       Rational[2079, 4769], 0.4359404487313902]], AbsoluteThickness[0.25], 
     LineBox[{6237, 6238}]}, 
    {Hue[
      NCache[
       Rational[6238, 14307], 0.436010344586566]], AbsoluteThickness[0.25], 
     LineBox[{6238, 6239}]}, 
    {Hue[
      NCache[
       Rational[6239, 14307], 0.4360802404417418]], AbsoluteThickness[0.25], 
     LineBox[{6239, 6240}]}, 
    {Hue[
      NCache[
       Rational[2080, 4769], 0.43615013629691757`]], AbsoluteThickness[0.25], 
     LineBox[{6240, 6241}]}, 
    {Hue[
      NCache[
       Rational[6241, 14307], 0.4362200321520934]], AbsoluteThickness[0.25], 
     LineBox[{6241, 6242}]}, 
    {Hue[
      NCache[
       Rational[6242, 14307], 0.4362899280072692]], AbsoluteThickness[0.25], 
     LineBox[{6242, 6243}]}, 
    {Hue[
      NCache[
       Rational[2081, 4769], 0.436359823862445]], AbsoluteThickness[0.25], 
     LineBox[{6243, 6244}]}, 
    {Hue[
      NCache[
       Rational[6244, 14307], 0.43642971971762073`]], AbsoluteThickness[0.25],
      LineBox[{6244, 6245}]}, 
    {Hue[
      NCache[
       Rational[6245, 14307], 0.43649961557279654`]], AbsoluteThickness[0.25],
      LineBox[{6245, 6246}]}, 
    {Hue[
      NCache[
       Rational[2082, 4769], 0.43656951142797235`]], AbsoluteThickness[0.25], 
     LineBox[{6246, 6247}]}, 
    {Hue[
      NCache[
       Rational[6247, 14307], 0.4366394072831481]], AbsoluteThickness[0.25], 
     LineBox[{6247, 6248}]}, 
    {Hue[
      NCache[
       Rational[6248, 14307], 0.4367093031383239]], AbsoluteThickness[0.25], 
     LineBox[{6248, 6249}]}, 
    {Hue[
      NCache[
       Rational[2083, 4769], 0.4367791989934997]], AbsoluteThickness[0.25], 
     LineBox[{6249, 6250}]}, 
    {Hue[
      NCache[
       Rational[6250, 14307], 0.43684909484867546`]], AbsoluteThickness[0.25],
      LineBox[{6250, 6251}]}, 
    {Hue[
      NCache[
       Rational[329, 753], 0.43691899070385126`]], AbsoluteThickness[0.25], 
     LineBox[{6251, 6252}]}, 
    {Hue[
      NCache[
       Rational[2084, 4769], 0.43698888655902707`]], AbsoluteThickness[0.25], 
     LineBox[{6252, 6253}]}, 
    {Hue[
      NCache[
       Rational[6253, 14307], 0.4370587824142028]], AbsoluteThickness[0.25], 
     LineBox[{6253, 6254}]}, 
    {Hue[
      NCache[
       Rational[6254, 14307], 0.4371286782693786]], AbsoluteThickness[0.25], 
     LineBox[{6254, 6255}]}, 
    {Hue[
      NCache[
       Rational[2085, 4769], 0.43719857412455443`]], AbsoluteThickness[0.25], 
     LineBox[{6255, 6256}]}, 
    {Hue[
      NCache[
       Rational[6256, 14307], 0.4372684699797302]], AbsoluteThickness[0.25], 
     LineBox[{6256, 6257}]}, 
    {Hue[
      NCache[
       Rational[6257, 14307], 0.437338365834906]], AbsoluteThickness[0.25], 
     LineBox[{6257, 6258}]}, 
    {Hue[
      NCache[
       Rational[2086, 4769], 0.4374082616900818]], AbsoluteThickness[0.25], 
     LineBox[{6258, 6259}]}, 
    {Hue[
      NCache[
       Rational[6259, 14307], 0.43747815754525754`]], AbsoluteThickness[0.25],
      LineBox[{6259, 6260}]}, 
    {Hue[
      NCache[
       Rational[6260, 14307], 0.43754805340043335`]], AbsoluteThickness[0.25],
      LineBox[{6260, 6261}]}, 
    {Hue[
      NCache[
       Rational[2087, 4769], 0.43761794925560915`]], AbsoluteThickness[0.25], 
     LineBox[{6261, 6262}]}, 
    {Hue[
      NCache[
       Rational[6262, 14307], 0.43768784511078496`]], AbsoluteThickness[0.25],
      LineBox[{6262, 6263}]}, 
    {Hue[
      NCache[
       Rational[6263, 14307], 0.4377577409659607]], AbsoluteThickness[0.25], 
     LineBox[{6263, 6264}]}, 
    {Hue[
      NCache[
       Rational[2088, 4769], 0.4378276368211365]], AbsoluteThickness[0.25], 
     LineBox[{6264, 6265}]}, 
    {Hue[
      NCache[
       Rational[6265, 14307], 0.4378975326763123]], AbsoluteThickness[0.25], 
     LineBox[{6265, 6266}]}, 
    {Hue[
      NCache[
       Rational[6266, 14307], 0.43796742853148807`]], AbsoluteThickness[0.25],
      LineBox[{6266, 6267}]}, 
    {Hue[
      NCache[
       Rational[2089, 4769], 0.4380373243866639]], AbsoluteThickness[0.25], 
     LineBox[{6267, 6268}]}, 
    {Hue[
      NCache[
       Rational[6268, 14307], 0.4381072202418397]], AbsoluteThickness[0.25], 
     LineBox[{6268, 6269}]}, 
    {Hue[
      NCache[
       Rational[6269, 14307], 0.43817711609701543`]], AbsoluteThickness[0.25],
      LineBox[{6269, 6270}]}, 
    {Hue[
      NCache[
       Rational[110, 251], 0.43824701195219123`]], AbsoluteThickness[0.25], 
     LineBox[{6270, 6271}]}, 
    {Hue[
      NCache[
       Rational[6271, 14307], 0.43831690780736704`]], AbsoluteThickness[0.25],
      LineBox[{6271, 6272}]}, 
    {Hue[
      NCache[
       Rational[6272, 14307], 0.4383868036625428]], AbsoluteThickness[0.25], 
     LineBox[{6272, 6273}]}, 
    {Hue[
      NCache[
       Rational[2091, 4769], 0.4384566995177186]], AbsoluteThickness[0.25], 
     LineBox[{6273, 6274}]}, 
    {Hue[
      NCache[
       Rational[6274, 14307], 0.4385265953728944]], AbsoluteThickness[0.25], 
     LineBox[{6274, 6275}]}, 
    {Hue[
      NCache[
       Rational[25, 57], 0.43859649122807015`]], AbsoluteThickness[0.25], 
     LineBox[{6275, 6276}]}, 
    {Hue[
      NCache[
       Rational[2092, 4769], 0.43866638708324596`]], AbsoluteThickness[0.25], 
     LineBox[{6276, 6277}]}, 
    {Hue[
      NCache[
       Rational[6277, 14307], 0.43873628293842176`]], AbsoluteThickness[0.25],
      LineBox[{6277, 6278}]}, 
    {Hue[
      NCache[
       Rational[6278, 14307], 0.4388061787935975]], AbsoluteThickness[0.25], 
     LineBox[{6278, 6279}]}, 
    {Hue[
      NCache[
       Rational[2093, 4769], 0.4388760746487733]], AbsoluteThickness[0.25], 
     LineBox[{6279, 6280}]}, 
    {Hue[
      NCache[
       Rational[6280, 14307], 0.4389459705039491]], AbsoluteThickness[0.25], 
     LineBox[{6280, 6281}]}, 
    {Hue[
      NCache[
       Rational[6281, 14307], 0.43901586635912493`]], AbsoluteThickness[0.25],
      LineBox[{6281, 6282}]}, 
    {Hue[
      NCache[
       Rational[2094, 4769], 0.4390857622143007]], AbsoluteThickness[0.25], 
     LineBox[{6282, 6283}]}, 
    {Hue[
      NCache[
       Rational[6283, 14307], 0.4391556580694765]], AbsoluteThickness[0.25], 
     LineBox[{6283, 6284}]}, 
    {Hue[
      NCache[
       Rational[6284, 14307], 0.4392255539246523]], AbsoluteThickness[0.25], 
     LineBox[{6284, 6285}]}, 
    {Hue[
      NCache[
       Rational[2095, 4769], 0.43929544977982804`]], AbsoluteThickness[0.25], 
     LineBox[{6285, 6286}]}, 
    {Hue[
      NCache[
       Rational[6286, 14307], 0.43936534563500385`]], AbsoluteThickness[0.25],
      LineBox[{6286, 6287}]}, 
    {Hue[
      NCache[
       Rational[6287, 14307], 0.43943524149017965`]], AbsoluteThickness[0.25],
      LineBox[{6287, 6288}]}, 
    {Hue[
      NCache[
       Rational[2096, 4769], 0.4395051373453554]], AbsoluteThickness[0.25], 
     LineBox[{6288, 6289}]}, 
    {Hue[
      NCache[
       Rational[331, 753], 0.4395750332005312]], AbsoluteThickness[0.25], 
     LineBox[{6289, 6290}]}, 
    {Hue[
      NCache[
       Rational[6290, 14307], 0.439644929055707]], AbsoluteThickness[0.25], 
     LineBox[{6290, 6291}]}, 
    {Hue[
      NCache[
       Rational[2097, 4769], 0.43971482491088276`]], AbsoluteThickness[0.25], 
     LineBox[{6291, 6292}]}, 
    {Hue[
      NCache[
       Rational[6292, 14307], 0.43978472076605857`]], AbsoluteThickness[0.25],
      LineBox[{6292, 6293}]}, 
    {Hue[
      NCache[
       Rational[6293, 14307], 0.4398546166212344]], AbsoluteThickness[0.25], 
     LineBox[{6293, 6294}]}, 
    {Hue[
      NCache[
       Rational[2098, 4769], 0.4399245124764101]], AbsoluteThickness[0.25], 
     LineBox[{6294, 6295}]}, 
    {Hue[
      NCache[
       Rational[6295, 14307], 0.43999440833158593`]], AbsoluteThickness[0.25],
      LineBox[{6295, 6296}]}, 
    {Hue[
      NCache[
       Rational[6296, 14307], 0.44006430418676173`]], AbsoluteThickness[0.25],
      LineBox[{6296, 6297}]}, 
    {Hue[
      NCache[
       Rational[2099, 4769], 0.44013420004193754`]], AbsoluteThickness[0.25], 
     LineBox[{6297, 6298}]}, 
    {Hue[
      NCache[
       Rational[6298, 14307], 0.4402040958971133]], AbsoluteThickness[0.25], 
     LineBox[{6298, 6299}]}, 
    {Hue[
      NCache[
       Rational[6299, 14307], 0.4402739917522891]], AbsoluteThickness[0.25], 
     LineBox[{6299, 6300}]}, 
    {Hue[
      NCache[
       Rational[2100, 4769], 0.4403438876074649]], AbsoluteThickness[0.25], 
     LineBox[{6300, 6301}]}, 
    {Hue[
      NCache[
       Rational[6301, 14307], 0.44041378346264065`]], AbsoluteThickness[0.25],
      LineBox[{6301, 6302}]}, 
    {Hue[
      NCache[
       Rational[6302, 14307], 0.44048367931781646`]], AbsoluteThickness[0.25],
      LineBox[{6302, 6303}]}, 
    {Hue[
      NCache[
       Rational[2101, 4769], 0.44055357517299226`]], AbsoluteThickness[0.25], 
     LineBox[{6303, 6304}]}, 
    {Hue[
      NCache[
       Rational[6304, 14307], 0.440623471028168]], AbsoluteThickness[0.25], 
     LineBox[{6304, 6305}]}, 
    {Hue[
      NCache[
       Rational[6305, 14307], 0.4406933668833438]], AbsoluteThickness[0.25], 
     LineBox[{6305, 6306}]}, 
    {Hue[
      NCache[
       Rational[2102, 4769], 0.4407632627385196]], AbsoluteThickness[0.25], 
     LineBox[{6306, 6307}]}, 
    {Hue[
      NCache[
       Rational[6307, 14307], 0.4408331585936954]], AbsoluteThickness[0.25], 
     LineBox[{6307, 6308}]}, 
    {Hue[
      NCache[
       Rational[332, 753], 0.4409030544488712]], AbsoluteThickness[0.25], 
     LineBox[{6308, 6309}]}, 
    {Hue[
      NCache[
       Rational[2103, 4769], 0.440972950304047]], AbsoluteThickness[0.25], 
     LineBox[{6309, 6310}]}, 
    {Hue[
      NCache[
       Rational[6310, 14307], 0.44104284615922273`]], AbsoluteThickness[0.25],
      LineBox[{6310, 6311}]}, 
    {Hue[
      NCache[
       Rational[6311, 14307], 0.44111274201439854`]], AbsoluteThickness[0.25],
      LineBox[{6311, 6312}]}, 
    {Hue[
      NCache[
       Rational[2104, 4769], 0.44118263786957435`]], AbsoluteThickness[0.25], 
     LineBox[{6312, 6313}]}, 
    {Hue[
      NCache[
       Rational[6313, 14307], 0.4412525337247501]], AbsoluteThickness[0.25], 
     LineBox[{6313, 6314}]}, 
    {Hue[
      NCache[
       Rational[6314, 14307], 0.4413224295799259]], AbsoluteThickness[0.25], 
     LineBox[{6314, 6315}]}, 
    {Hue[
      NCache[
       Rational[2105, 4769], 0.4413923254351017]], AbsoluteThickness[0.25], 
     LineBox[{6315, 6316}]}, 
    {Hue[
      NCache[
       Rational[6316, 14307], 0.4414622212902775]], AbsoluteThickness[0.25], 
     LineBox[{6316, 6317}]}, 
    {Hue[
      NCache[
       Rational[6317, 14307], 0.44153211714545326`]], AbsoluteThickness[0.25],
      LineBox[{6317, 6318}]}, 
    {Hue[
      NCache[
       Rational[2106, 4769], 0.44160201300062907`]], AbsoluteThickness[0.25], 
     LineBox[{6318, 6319}]}, 
    {Hue[
      NCache[
       Rational[6319, 14307], 0.4416719088558049]], AbsoluteThickness[0.25], 
     LineBox[{6319, 6320}]}, 
    {Hue[
      NCache[
       Rational[6320, 14307], 0.4417418047109806]], AbsoluteThickness[0.25], 
     LineBox[{6320, 6321}]}, 
    {Hue[
      NCache[
       Rational[2107, 4769], 0.44181170056615643`]], AbsoluteThickness[0.25], 
     LineBox[{6321, 6322}]}, 
    {Hue[
      NCache[
       Rational[6322, 14307], 0.44188159642133223`]], AbsoluteThickness[0.25],
      LineBox[{6322, 6323}]}, 
    {Hue[
      NCache[
       Rational[6323, 14307], 0.441951492276508]], AbsoluteThickness[0.25], 
     LineBox[{6323, 6324}]}, 
    {Hue[
      NCache[
       Rational[2108, 4769], 0.4420213881316838]], AbsoluteThickness[0.25], 
     LineBox[{6324, 6325}]}, 
    {Hue[
      NCache[
       Rational[6325, 14307], 0.4420912839868596]], AbsoluteThickness[0.25], 
     LineBox[{6325, 6326}]}, 
    {Hue[
      NCache[
       Rational[6326, 14307], 0.44216117984203535`]], AbsoluteThickness[0.25],
      LineBox[{6326, 6327}]}, 
    {Hue[
      NCache[
       Rational[111, 251], 0.44223107569721115`]], AbsoluteThickness[0.25], 
     LineBox[{6327, 6328}]}, 
    {Hue[
      NCache[
       Rational[6328, 14307], 0.44230097155238696`]], AbsoluteThickness[0.25],
      LineBox[{6328, 6329}]}, 
    {Hue[
      NCache[
       Rational[6329, 14307], 0.4423708674075627]], AbsoluteThickness[0.25], 
     LineBox[{6329, 6330}]}, 
    {Hue[
      NCache[
       Rational[2110, 4769], 0.4424407632627385]], AbsoluteThickness[0.25], 
     LineBox[{6330, 6331}]}, 
    {Hue[
      NCache[
       Rational[6331, 14307], 0.4425106591179143]], AbsoluteThickness[0.25], 
     LineBox[{6331, 6332}]}, 
    {Hue[
      NCache[
       Rational[6332, 14307], 0.4425805549730901]], AbsoluteThickness[0.25], 
     LineBox[{6332, 6333}]}, 
    {Hue[
      NCache[
       Rational[2111, 4769], 0.4426504508282659]], AbsoluteThickness[0.25], 
     LineBox[{6333, 6334}]}, 
    {Hue[
      NCache[
       Rational[6334, 14307], 0.4427203466834417]], AbsoluteThickness[0.25], 
     LineBox[{6334, 6335}]}, 
    {Hue[
      NCache[
       Rational[6335, 14307], 0.4427902425386175]], AbsoluteThickness[0.25], 
     LineBox[{6335, 6336}]}, 
    {Hue[
      NCache[
       Rational[2112, 4769], 0.44286013839379323`]], AbsoluteThickness[0.25], 
     LineBox[{6336, 6337}]}, 
    {Hue[
      NCache[
       Rational[6337, 14307], 0.44293003424896904`]], AbsoluteThickness[0.25],
      LineBox[{6337, 6338}]}, 
    {Hue[
      NCache[
       Rational[6338, 14307], 0.44299993010414485`]], AbsoluteThickness[0.25],
      LineBox[{6338, 6339}]}, 
    {Hue[
      NCache[
       Rational[2113, 4769], 0.4430698259593206]], AbsoluteThickness[0.25], 
     LineBox[{6339, 6340}]}, 
    {Hue[
      NCache[
       Rational[6340, 14307], 0.4431397218144964]], AbsoluteThickness[0.25], 
     LineBox[{6340, 6341}]}, 
    {Hue[
      NCache[
       Rational[6341, 14307], 0.4432096176696722]], AbsoluteThickness[0.25], 
     LineBox[{6341, 6342}]}, 
    {Hue[
      NCache[
       Rational[2114, 4769], 0.44327951352484796`]], AbsoluteThickness[0.25], 
     LineBox[{6342, 6343}]}, 
    {Hue[
      NCache[
       Rational[6343, 14307], 0.44334940938002376`]], AbsoluteThickness[0.25],
      LineBox[{6343, 6344}]}, 
    {Hue[
      NCache[
       Rational[6344, 14307], 0.44341930523519957`]], AbsoluteThickness[0.25],
      LineBox[{6344, 6345}]}, 
    {Hue[
      NCache[
       Rational[2115, 4769], 0.4434892010903753]], AbsoluteThickness[0.25], 
     LineBox[{6345, 6346}]}, 
    {Hue[
      NCache[
       Rational[334, 753], 0.4435590969455511]], AbsoluteThickness[0.25], 
     LineBox[{6346, 6347}]}, 
    {Hue[
      NCache[
       Rational[6347, 14307], 0.44362899280072693`]], AbsoluteThickness[0.25],
      LineBox[{6347, 6348}]}, 
    {Hue[
      NCache[
       Rational[2116, 4769], 0.4436988886559027]], AbsoluteThickness[0.25], 
     LineBox[{6348, 6349}]}, 
    {Hue[
      NCache[
       Rational[6349, 14307], 0.4437687845110785]], AbsoluteThickness[0.25], 
     LineBox[{6349, 6350}]}, 
    {Hue[
      NCache[
       Rational[6350, 14307], 0.4438386803662543]], AbsoluteThickness[0.25], 
     LineBox[{6350, 6351}]}, 
    {Hue[
      NCache[
       Rational[2117, 4769], 0.4439085762214301]], AbsoluteThickness[0.25], 
     LineBox[{6351, 6352}]}, 
    {Hue[
      NCache[
       Rational[6352, 14307], 0.44397847207660585`]], AbsoluteThickness[0.25],
      LineBox[{6352, 6353}]}, 
    {Hue[
      NCache[
       Rational[6353, 14307], 0.44404836793178165`]], AbsoluteThickness[0.25],
      LineBox[{6353, 6354}]}, 
    {Hue[
      NCache[
       Rational[2118, 4769], 0.44411826378695746`]], AbsoluteThickness[0.25], 
     LineBox[{6354, 6355}]}, 
    {Hue[
      NCache[
       Rational[6355, 14307], 0.4441881596421332]], AbsoluteThickness[0.25], 
     LineBox[{6355, 6356}]}, 
    {Hue[
      NCache[
       Rational[6356, 14307], 0.444258055497309]], AbsoluteThickness[0.25], 
     LineBox[{6356, 6357}]}, 
    {Hue[
      NCache[
       Rational[2119, 4769], 0.4443279513524848]], AbsoluteThickness[0.25], 
     LineBox[{6357, 6358}]}, 
    {Hue[
      NCache[
       Rational[6358, 14307], 0.44439784720766057`]], AbsoluteThickness[0.25],
      LineBox[{6358, 6359}]}, 
    {Hue[
      NCache[
       Rational[6359, 14307], 0.4444677430628364]], AbsoluteThickness[0.25], 
     LineBox[{6359, 6360}]}, 
    {Hue[
      NCache[
       Rational[2120, 4769], 0.4445376389180122]], AbsoluteThickness[0.25], 
     LineBox[{6360, 6361}]}, 
    {Hue[
      NCache[
       Rational[6361, 14307], 0.44460753477318793`]], AbsoluteThickness[0.25],
      LineBox[{6361, 6362}]}, 
    {Hue[
      NCache[
       Rational[6362, 14307], 0.44467743062836373`]], AbsoluteThickness[0.25],
      LineBox[{6362, 6363}]}, 
    {Hue[
      NCache[
       Rational[2121, 4769], 0.44474732648353954`]], AbsoluteThickness[0.25], 
     LineBox[{6363, 6364}]}, 
    {Hue[
      NCache[
       Rational[6364, 14307], 0.4448172223387153]], AbsoluteThickness[0.25], 
     LineBox[{6364, 6365}]}, 
    {Hue[
      NCache[
       Rational[335, 753], 0.4448871181938911]], AbsoluteThickness[0.25], 
     LineBox[{6365, 6366}]}, 
    {Hue[
      NCache[
       Rational[2122, 4769], 0.4449570140490669]], AbsoluteThickness[0.25], 
     LineBox[{6366, 6367}]}, 
    {Hue[
      NCache[
       Rational[6367, 14307], 0.44502690990424265`]], AbsoluteThickness[0.25],
      LineBox[{6367, 6368}]}, 
    {Hue[
      NCache[
       Rational[6368, 14307], 0.44509680575941846`]], AbsoluteThickness[0.25],
      LineBox[{6368, 6369}]}, 
    {Hue[
      NCache[
       Rational[2123, 4769], 0.44516670161459426`]], AbsoluteThickness[0.25], 
     LineBox[{6369, 6370}]}, 
    {Hue[
      NCache[
       Rational[6370, 14307], 0.44523659746977007`]], AbsoluteThickness[0.25],
      LineBox[{6370, 6371}]}, 
    {Hue[
      NCache[
       Rational[6371, 14307], 0.4453064933249458]], AbsoluteThickness[0.25], 
     LineBox[{6371, 6372}]}, 
    {Hue[
      NCache[
       Rational[2124, 4769], 0.4453763891801216]], AbsoluteThickness[0.25], 
     LineBox[{6372, 6373}]}, 
    {Hue[
      NCache[
       Rational[6373, 14307], 0.44544628503529743`]], AbsoluteThickness[0.25],
      LineBox[{6373, 6374}]}, 
    {Hue[
      NCache[
       Rational[6374, 14307], 0.4455161808904732]], AbsoluteThickness[0.25], 
     LineBox[{6374, 6375}]}, 
    {Hue[
      NCache[
       Rational[2125, 4769], 0.445586076745649]], AbsoluteThickness[0.25], 
     LineBox[{6375, 6376}]}, 
    {Hue[
      NCache[
       Rational[6376, 14307], 0.4456559726008248]], AbsoluteThickness[0.25], 
     LineBox[{6376, 6377}]}, 
    {Hue[
      NCache[
       Rational[6377, 14307], 0.44572586845600054`]], AbsoluteThickness[0.25],
      LineBox[{6377, 6378}]}, 
    {Hue[
      NCache[
       Rational[2126, 4769], 0.44579576431117635`]], AbsoluteThickness[0.25], 
     LineBox[{6378, 6379}]}, 
    {Hue[
      NCache[
       Rational[6379, 14307], 0.44586566016635215`]], AbsoluteThickness[0.25],
      LineBox[{6379, 6380}]}, 
    {Hue[
      NCache[
       Rational[6380, 14307], 0.4459355560215279]], AbsoluteThickness[0.25], 
     LineBox[{6380, 6381}]}, 
    {Hue[
      NCache[
       Rational[2127, 4769], 0.4460054518767037]], AbsoluteThickness[0.25], 
     LineBox[{6381, 6382}]}, 
    {Hue[
      NCache[
       Rational[6382, 14307], 0.4460753477318795]], AbsoluteThickness[0.25], 
     LineBox[{6382, 6383}]}, 
    {Hue[
      NCache[
       Rational[6383, 14307], 0.44614524358705526`]], AbsoluteThickness[0.25],
      LineBox[{6383, 6384}]}, 
    {Hue[
      NCache[
       Rational[112, 251], 0.44621513944223107`]], AbsoluteThickness[0.25], 
     LineBox[{6384, 6385}]}, 
    {Hue[
      NCache[
       Rational[6385, 14307], 0.4462850352974069]], AbsoluteThickness[0.25], 
     LineBox[{6385, 6386}]}, 
    {Hue[
      NCache[
       Rational[6386, 14307], 0.4463549311525827]], AbsoluteThickness[0.25], 
     LineBox[{6386, 6387}]}, 
    {Hue[
      NCache[
       Rational[2129, 4769], 0.44642482700775843`]], AbsoluteThickness[0.25], 
     LineBox[{6387, 6388}]}, 
    {Hue[
      NCache[
       Rational[6388, 14307], 0.44649472286293423`]], AbsoluteThickness[0.25],
      LineBox[{6388, 6389}]}, 
    {Hue[
      NCache[
       Rational[6389, 14307], 0.44656461871811004`]], AbsoluteThickness[0.25],
      LineBox[{6389, 6390}]}, 
    {Hue[
      NCache[
       Rational[2130, 4769], 0.4466345145732858]], AbsoluteThickness[0.25], 
     LineBox[{6390, 6391}]}, 
    {Hue[
      NCache[
       Rational[6391, 14307], 0.4467044104284616]], AbsoluteThickness[0.25], 
     LineBox[{6391, 6392}]}, 
    {Hue[
      NCache[
       Rational[6392, 14307], 0.4467743062836374]], AbsoluteThickness[0.25], 
     LineBox[{6392, 6393}]}, 
    {Hue[
      NCache[
       Rational[2131, 4769], 0.44684420213881315`]], AbsoluteThickness[0.25], 
     LineBox[{6393, 6394}]}, 
    {Hue[
      NCache[
       Rational[6394, 14307], 0.44691409799398896`]], AbsoluteThickness[0.25],
      LineBox[{6394, 6395}]}, 
    {Hue[
      NCache[
       Rational[6395, 14307], 0.44698399384916476`]], AbsoluteThickness[0.25],
      LineBox[{6395, 6396}]}, 
    {Hue[
      NCache[
       Rational[2132, 4769], 0.4470538897043405]], AbsoluteThickness[0.25], 
     LineBox[{6396, 6397}]}, 
    {Hue[
      NCache[
       Rational[6397, 14307], 0.4471237855595163]], AbsoluteThickness[0.25], 
     LineBox[{6397, 6398}]}, 
    {Hue[
      NCache[
       Rational[6398, 14307], 0.4471936814146921]], AbsoluteThickness[0.25], 
     LineBox[{6398, 6399}]}, 
    {Hue[
      NCache[
       Rational[2133, 4769], 0.4472635772698679]], AbsoluteThickness[0.25], 
     LineBox[{6399, 6400}]}, 
    {Hue[
      NCache[
       Rational[6400, 14307], 0.4473334731250437]], AbsoluteThickness[0.25], 
     LineBox[{6400, 6401}]}, 
    {Hue[
      NCache[
       Rational[6401, 14307], 0.4474033689802195]], AbsoluteThickness[0.25], 
     LineBox[{6401, 6402}]}, 
    {Hue[
      NCache[
       Rational[2134, 4769], 0.44747326483539523`]], AbsoluteThickness[0.25], 
     LineBox[{6402, 6403}]}, 
    {Hue[
      NCache[
       Rational[337, 753], 0.44754316069057104`]], AbsoluteThickness[0.25], 
     LineBox[{6403, 6404}]}, 
    {Hue[
      NCache[
       Rational[6404, 14307], 0.44761305654574685`]], AbsoluteThickness[0.25],
      LineBox[{6404, 6405}]}, 
    {Hue[
      NCache[
       Rational[2135, 4769], 0.44768295240092265`]], AbsoluteThickness[0.25], 
     LineBox[{6405, 6406}]}, 
    {Hue[
      NCache[
       Rational[6406, 14307], 0.4477528482560984]], AbsoluteThickness[0.25], 
     LineBox[{6406, 6407}]}, 
    {Hue[
      NCache[
       Rational[6407, 14307], 0.4478227441112742]], AbsoluteThickness[0.25], 
     LineBox[{6407, 6408}]}, 
    {Hue[
      NCache[
       Rational[2136, 4769], 0.44789263996645]], AbsoluteThickness[0.25], 
     LineBox[{6408, 6409}]}, 
    {Hue[
      NCache[
       Rational[6409, 14307], 0.44796253582162576`]], AbsoluteThickness[0.25],
      LineBox[{6409, 6410}]}, 
    {Hue[
      NCache[
       Rational[6410, 14307], 0.44803243167680157`]], AbsoluteThickness[0.25],
      LineBox[{6410, 6411}]}, 
    {Hue[
      NCache[
       Rational[2137, 4769], 0.4481023275319774]], AbsoluteThickness[0.25], 
     LineBox[{6411, 6412}]}, 
    {Hue[
      NCache[
       Rational[6412, 14307], 0.4481722233871531]], AbsoluteThickness[0.25], 
     LineBox[{6412, 6413}]}, 
    {Hue[
      NCache[
       Rational[6413, 14307], 0.44824211924232893`]], AbsoluteThickness[0.25],
      LineBox[{6413, 6414}]}, 
    {Hue[
      NCache[
       Rational[2138, 4769], 0.44831201509750473`]], AbsoluteThickness[0.25], 
     LineBox[{6414, 6415}]}, 
    {Hue[
      NCache[
       Rational[6415, 14307], 0.4483819109526805]], AbsoluteThickness[0.25], 
     LineBox[{6415, 6416}]}, 
    {Hue[
      NCache[
       Rational[6416, 14307], 0.4484518068078563]], AbsoluteThickness[0.25], 
     LineBox[{6416, 6417}]}, 
    {Hue[
      NCache[
       Rational[2139, 4769], 0.4485217026630321]], AbsoluteThickness[0.25], 
     LineBox[{6417, 6418}]}, 
    {Hue[
      NCache[
       Rational[6418, 14307], 0.44859159851820785`]], AbsoluteThickness[0.25],
      LineBox[{6418, 6419}]}, 
    {Hue[
      NCache[
       Rational[6419, 14307], 0.44866149437338365`]], AbsoluteThickness[0.25],
      LineBox[{6419, 6420}]}, 
    {Hue[
      NCache[
       Rational[2140, 4769], 0.44873139022855946`]], AbsoluteThickness[0.25], 
     LineBox[{6420, 6421}]}, 
    {Hue[
      NCache[
       Rational[6421, 14307], 0.4488012860837352]], AbsoluteThickness[0.25], 
     LineBox[{6421, 6422}]}, 
    {Hue[
      NCache[
       Rational[338, 753], 0.448871181938911]], AbsoluteThickness[0.25], 
     LineBox[{6422, 6423}]}, 
    {Hue[
      NCache[
       Rational[2141, 4769], 0.4489410777940868]], AbsoluteThickness[0.25], 
     LineBox[{6423, 6424}]}, 
    {Hue[
      NCache[
       Rational[6424, 14307], 0.4490109736492626]], AbsoluteThickness[0.25], 
     LineBox[{6424, 6425}]}, 
    {Hue[
      NCache[
       Rational[6425, 14307], 0.4490808695044384]], AbsoluteThickness[0.25], 
     LineBox[{6425, 6426}]}, 
    {Hue[
      NCache[
       Rational[2142, 4769], 0.4491507653596142]], AbsoluteThickness[0.25], 
     LineBox[{6426, 6427}]}, 
    {Hue[
      NCache[
       Rational[6427, 14307], 0.44922066121479]], AbsoluteThickness[0.25], 
     LineBox[{6427, 6428}]}, 
    {Hue[
      NCache[
       Rational[6428, 14307], 0.44929055706996573`]], AbsoluteThickness[0.25],
      LineBox[{6428, 6429}]}, 
    {Hue[
      NCache[
       Rational[2143, 4769], 0.44936045292514154`]], AbsoluteThickness[0.25], 
     LineBox[{6429, 6430}]}, 
    {Hue[
      NCache[
       Rational[6430, 14307], 0.44943034878031735`]], AbsoluteThickness[0.25],
      LineBox[{6430, 6431}]}, 
    {Hue[
      NCache[
       Rational[6431, 14307], 0.4495002446354931]], AbsoluteThickness[0.25], 
     LineBox[{6431, 6432}]}, 
    {Hue[
      NCache[
       Rational[2144, 4769], 0.4495701404906689]], AbsoluteThickness[0.25], 
     LineBox[{6432, 6433}]}, 
    {Hue[
      NCache[
       Rational[6433, 14307], 0.4496400363458447]], AbsoluteThickness[0.25], 
     LineBox[{6433, 6434}]}, 
    {Hue[
      NCache[
       Rational[6434, 14307], 0.44970993220102046`]], AbsoluteThickness[0.25],
      LineBox[{6434, 6435}]}, 
    {Hue[
      NCache[
       Rational[2145, 4769], 0.44977982805619626`]], AbsoluteThickness[0.25], 
     LineBox[{6435, 6436}]}, 
    {Hue[
      NCache[
       Rational[6436, 14307], 0.44984972391137207`]], AbsoluteThickness[0.25],
      LineBox[{6436, 6437}]}, 
    {Hue[
      NCache[
       Rational[6437, 14307], 0.4499196197665478]], AbsoluteThickness[0.25], 
     LineBox[{6437, 6438}]}, 
    {Hue[
      NCache[
       Rational[2146, 4769], 0.4499895156217236]], AbsoluteThickness[0.25], 
     LineBox[{6438, 6439}]}, 
    {Hue[
      NCache[
       Rational[6439, 14307], 0.45005941147689943`]], AbsoluteThickness[0.25],
      LineBox[{6439, 6440}]}, 
    {Hue[
      NCache[
       Rational[6440, 14307], 0.45012930733207523`]], AbsoluteThickness[0.25],
      LineBox[{6440, 6441}]}, 
    {Hue[
      NCache[
       Rational[113, 251], 0.450199203187251]], AbsoluteThickness[0.25], 
     LineBox[{6441, 6442}]}, 
    {Hue[
      NCache[
       Rational[6442, 14307], 0.4502690990424268]], AbsoluteThickness[0.25], 
     LineBox[{6442, 6443}]}, 
    {Hue[
      NCache[
       Rational[6443, 14307], 0.4503389948976026]], AbsoluteThickness[0.25], 
     LineBox[{6443, 6444}]}, 
    {Hue[
      NCache[
       Rational[2148, 4769], 0.45040889075277835`]], AbsoluteThickness[0.25], 
     LineBox[{6444, 6445}]}, 
    {Hue[
      NCache[
       Rational[6445, 14307], 0.45047878660795415`]], AbsoluteThickness[0.25],
      LineBox[{6445, 6446}]}, 
    {Hue[
      NCache[
       Rational[6446, 14307], 0.45054868246312996`]], AbsoluteThickness[0.25],
      LineBox[{6446, 6447}]}, 
    {Hue[
      NCache[
       Rational[2149, 4769], 0.4506185783183057]], AbsoluteThickness[0.25], 
     LineBox[{6447, 6448}]}, 
    {Hue[
      NCache[
       Rational[6448, 14307], 0.4506884741734815]], AbsoluteThickness[0.25], 
     LineBox[{6448, 6449}]}, 
    {Hue[
      NCache[
       Rational[6449, 14307], 0.4507583700286573]], AbsoluteThickness[0.25], 
     LineBox[{6449, 6450}]}, 
    {Hue[
      NCache[
       Rational[2150, 4769], 0.45082826588383307`]], AbsoluteThickness[0.25], 
     LineBox[{6450, 6451}]}, 
    {Hue[
      NCache[
       Rational[6451, 14307], 0.4508981617390089]], AbsoluteThickness[0.25], 
     LineBox[{6451, 6452}]}, 
    {Hue[
      NCache[
       Rational[6452, 14307], 0.4509680575941847]], AbsoluteThickness[0.25], 
     LineBox[{6452, 6453}]}, 
    {Hue[
      NCache[
       Rational[2151, 4769], 0.45103795344936043`]], AbsoluteThickness[0.25], 
     LineBox[{6453, 6454}]}, 
    {Hue[
      NCache[
       Rational[6454, 14307], 0.45110784930453623`]], AbsoluteThickness[0.25],
      LineBox[{6454, 6455}]}, 
    {Hue[
      NCache[
       Rational[6455, 14307], 0.45117774515971204`]], AbsoluteThickness[0.25],
      LineBox[{6455, 6456}]}, 
    {Hue[
      NCache[
       Rational[2152, 4769], 0.4512476410148878]], AbsoluteThickness[0.25], 
     LineBox[{6456, 6457}]}, 
    {Hue[
      NCache[
       Rational[6457, 14307], 0.4513175368700636]], AbsoluteThickness[0.25], 
     LineBox[{6457, 6458}]}, 
    {Hue[
      NCache[
       Rational[6458, 14307], 0.4513874327252394]], AbsoluteThickness[0.25], 
     LineBox[{6458, 6459}]}, 
    {Hue[
      NCache[
       Rational[2153, 4769], 0.4514573285804152]], AbsoluteThickness[0.25], 
     LineBox[{6459, 6460}]}, 
    {Hue[
      NCache[
       Rational[340, 753], 0.45152722443559096`]], AbsoluteThickness[0.25], 
     LineBox[{6460, 6461}]}, 
    {Hue[
      NCache[
       Rational[6461, 14307], 0.45159712029076676`]], AbsoluteThickness[0.25],
      LineBox[{6461, 6462}]}, 
    {Hue[
      NCache[
       Rational[2154, 4769], 0.45166701614594257`]], AbsoluteThickness[0.25], 
     LineBox[{6462, 6463}]}, 
    {Hue[
      NCache[
       Rational[6463, 14307], 0.4517369120011183]], AbsoluteThickness[0.25], 
     LineBox[{6463, 6464}]}, 
    {Hue[
      NCache[
       Rational[6464, 14307], 0.4518068078562941]], AbsoluteThickness[0.25], 
     LineBox[{6464, 6465}]}, 
    {Hue[
      NCache[
       Rational[2155, 4769], 0.45187670371146993`]], AbsoluteThickness[0.25], 
     LineBox[{6465, 6466}]}, 
    {Hue[
      NCache[
       Rational[6466, 14307], 0.4519465995666457]], AbsoluteThickness[0.25], 
     LineBox[{6466, 6467}]}, 
    {Hue[
      NCache[
       Rational[6467, 14307], 0.4520164954218215]], AbsoluteThickness[0.25], 
     LineBox[{6467, 6468}]}, 
    {Hue[
      NCache[
       Rational[2156, 4769], 0.4520863912769973]], AbsoluteThickness[0.25], 
     LineBox[{6468, 6469}]}, 
    {Hue[
      NCache[
       Rational[6469, 14307], 0.45215628713217304`]], AbsoluteThickness[0.25],
      LineBox[{6469, 6470}]}, 
    {Hue[
      NCache[
       Rational[6470, 14307], 0.45222618298734885`]], AbsoluteThickness[0.25],
      LineBox[{6470, 6471}]}, 
    {Hue[
      NCache[
       Rational[2157, 4769], 0.45229607884252465`]], AbsoluteThickness[0.25], 
     LineBox[{6471, 6472}]}, 
    {Hue[
      NCache[
       Rational[6472, 14307], 0.4523659746977004]], AbsoluteThickness[0.25], 
     LineBox[{6472, 6473}]}, 
    {Hue[
      NCache[
       Rational[6473, 14307], 0.4524358705528762]], AbsoluteThickness[0.25], 
     LineBox[{6473, 6474}]}, 
    {Hue[
      NCache[
       Rational[2158, 4769], 0.452505766408052]], AbsoluteThickness[0.25], 
     LineBox[{6474, 6475}]}, 
    {Hue[
      NCache[
       Rational[6475, 14307], 0.4525756622632278]], AbsoluteThickness[0.25], 
     LineBox[{6475, 6476}]}, 
    {Hue[
      NCache[
       Rational[6476, 14307], 0.45264555811840357`]], AbsoluteThickness[0.25],
      LineBox[{6476, 6477}]}, 
    {Hue[
      NCache[
       Rational[2159, 4769], 0.4527154539735794]], AbsoluteThickness[0.25], 
     LineBox[{6477, 6478}]}, 
    {Hue[
      NCache[
       Rational[6478, 14307], 0.4527853498287552]], AbsoluteThickness[0.25], 
     LineBox[{6478, 6479}]}, 
    {Hue[
      NCache[
       Rational[341, 753], 0.45285524568393093`]], AbsoluteThickness[0.25], 
     LineBox[{6479, 6480}]}, 
    {Hue[
      NCache[
       Rational[2160, 4769], 0.45292514153910673`]], AbsoluteThickness[0.25], 
     LineBox[{6480, 6481}]}, 
    {Hue[
      NCache[
       Rational[6481, 14307], 0.45299503739428254`]], AbsoluteThickness[0.25],
      LineBox[{6481, 6482}]}, 
    {Hue[
      NCache[
       Rational[6482, 14307], 0.4530649332494583]], AbsoluteThickness[0.25], 
     LineBox[{6482, 6483}]}, 
    {Hue[
      NCache[
       Rational[2161, 4769], 0.4531348291046341]], AbsoluteThickness[0.25], 
     LineBox[{6483, 6484}]}, 
    {Hue[
      NCache[
       Rational[6484, 14307], 0.4532047249598099]], AbsoluteThickness[0.25], 
     LineBox[{6484, 6485}]}, 
    {Hue[
      NCache[
       Rational[6485, 14307], 0.45327462081498565`]], AbsoluteThickness[0.25],
      LineBox[{6485, 6486}]}, 
    {Hue[
      NCache[
       Rational[2162, 4769], 0.45334451667016146`]], AbsoluteThickness[0.25], 
     LineBox[{6486, 6487}]}, 
    {Hue[
      NCache[
       Rational[6487, 14307], 0.45341441252533726`]], AbsoluteThickness[0.25],
      LineBox[{6487, 6488}]}, 
    {Hue[
      NCache[
       Rational[6488, 14307], 0.453484308380513]], AbsoluteThickness[0.25], 
     LineBox[{6488, 6489}]}, 
    {Hue[
      NCache[
       Rational[2163, 4769], 0.4535542042356888]], AbsoluteThickness[0.25], 
     LineBox[{6489, 6490}]}, 
    {Hue[
      NCache[
       Rational[6490, 14307], 0.4536241000908646]], AbsoluteThickness[0.25], 
     LineBox[{6490, 6491}]}, 
    {Hue[
      NCache[
       Rational[6491, 14307], 0.4536939959460404]], AbsoluteThickness[0.25], 
     LineBox[{6491, 6492}]}, 
    {Hue[
      NCache[
       Rational[2164, 4769], 0.4537638918012162]], AbsoluteThickness[0.25], 
     LineBox[{6492, 6493}]}, 
    {Hue[
      NCache[
       Rational[6493, 14307], 0.453833787656392]], AbsoluteThickness[0.25], 
     LineBox[{6493, 6494}]}, 
    {Hue[
      NCache[
       Rational[6494, 14307], 0.4539036835115678]], AbsoluteThickness[0.25], 
     LineBox[{6494, 6495}]}, 
    {Hue[
      NCache[
       Rational[2165, 4769], 0.45397357936674354`]], AbsoluteThickness[0.25], 
     LineBox[{6495, 6496}]}, 
    {Hue[
      NCache[
       Rational[6496, 14307], 0.45404347522191935`]], AbsoluteThickness[0.25],
      LineBox[{6496, 6497}]}, 
    {Hue[
      NCache[
       Rational[6497, 14307], 0.45411337107709515`]], AbsoluteThickness[0.25],
      LineBox[{6497, 6498}]}, 
    {Hue[
      NCache[
       Rational[114, 251], 0.4541832669322709]], AbsoluteThickness[0.25], 
     LineBox[{6498, 6499}]}, 
    {Hue[
      NCache[
       Rational[6499, 14307], 0.4542531627874467]], AbsoluteThickness[0.25], 
     LineBox[{6499, 6500}]}, 
    {Hue[
      NCache[
       Rational[6500, 14307], 0.4543230586426225]], AbsoluteThickness[0.25], 
     LineBox[{6500, 6501}]}, 
    {Hue[
      NCache[
       Rational[2167, 4769], 0.45439295449779826`]], AbsoluteThickness[0.25], 
     LineBox[{6501, 6502}]}, 
    {Hue[
      NCache[
       Rational[6502, 14307], 0.45446285035297407`]], AbsoluteThickness[0.25],
      LineBox[{6502, 6503}]}, 
    {Hue[
      NCache[
       Rational[6503, 14307], 0.4545327462081499]], AbsoluteThickness[0.25], 
     LineBox[{6503, 6504}]}, 
    {Hue[
      NCache[
       Rational[2168, 4769], 0.4546026420633256]], AbsoluteThickness[0.25], 
     LineBox[{6504, 6505}]}, 
    {Hue[
      NCache[
       Rational[6505, 14307], 0.45467253791850143`]], AbsoluteThickness[0.25],
      LineBox[{6505, 6506}]}, 
    {Hue[
      NCache[
       Rational[6506, 14307], 0.45474243377367723`]], AbsoluteThickness[0.25],
      LineBox[{6506, 6507}]}, 
    {Hue[
      NCache[
       Rational[2169, 4769], 0.454812329628853]], AbsoluteThickness[0.25], 
     LineBox[{6507, 6508}]}, 
    {Hue[
      NCache[
       Rational[6508, 14307], 0.4548822254840288]], AbsoluteThickness[0.25], 
     LineBox[{6508, 6509}]}, 
    {Hue[
      NCache[
       Rational[6509, 14307], 0.4549521213392046]], AbsoluteThickness[0.25], 
     LineBox[{6509, 6510}]}, 
    {Hue[
      NCache[
       Rational[2170, 4769], 0.45502201719438035`]], AbsoluteThickness[0.25], 
     LineBox[{6510, 6511}]}, 
    {Hue[
      NCache[
       Rational[6511, 14307], 0.45509191304955615`]], AbsoluteThickness[0.25],
      LineBox[{6511, 6512}]}, 
    {Hue[
      NCache[
       Rational[6512, 14307], 0.45516180890473196`]], AbsoluteThickness[0.25],
      LineBox[{6512, 6513}]}, 
    {Hue[
      NCache[
       Rational[2171, 4769], 0.45523170475990776`]], AbsoluteThickness[0.25], 
     LineBox[{6513, 6514}]}, 
    {Hue[
      NCache[
       Rational[6514, 14307], 0.4553016006150835]], AbsoluteThickness[0.25], 
     LineBox[{6514, 6515}]}, 
    {Hue[
      NCache[
       Rational[6515, 14307], 0.4553714964702593]], AbsoluteThickness[0.25], 
     LineBox[{6515, 6516}]}, 
    {Hue[
      NCache[
       Rational[2172, 4769], 0.4554413923254351]], AbsoluteThickness[0.25], 
     LineBox[{6516, 6517}]}, 
    {Hue[
      NCache[
       Rational[343, 753], 0.4555112881806109]], AbsoluteThickness[0.25], 
     LineBox[{6517, 6518}]}, 
    {Hue[
      NCache[
       Rational[6518, 14307], 0.4555811840357867]], AbsoluteThickness[0.25], 
     LineBox[{6518, 6519}]}, 
    {Hue[
      NCache[
       Rational[2173, 4769], 0.4556510798909625]], AbsoluteThickness[0.25], 
     LineBox[{6519, 6520}]}, 
    {Hue[
      NCache[
       Rational[6520, 14307], 0.45572097574613823`]], AbsoluteThickness[0.25],
      LineBox[{6520, 6521}]}, 
    {Hue[
      NCache[
       Rational[6521, 14307], 0.45579087160131404`]], AbsoluteThickness[0.25],
      LineBox[{6521, 6522}]}, 
    {Hue[
      NCache[
       Rational[2174, 4769], 0.45586076745648985`]], AbsoluteThickness[0.25], 
     LineBox[{6522, 6523}]}, 
    {Hue[
      NCache[
       Rational[6523, 14307], 0.4559306633116656]], AbsoluteThickness[0.25], 
     LineBox[{6523, 6524}]}, 
    {Hue[
      NCache[
       Rational[6524, 14307], 0.4560005591668414]], AbsoluteThickness[0.25], 
     LineBox[{6524, 6525}]}, 
    {Hue[
      NCache[
       Rational[2175, 4769], 0.4560704550220172]], AbsoluteThickness[0.25], 
     LineBox[{6525, 6526}]}, 
    {Hue[
      NCache[
       Rational[26, 57], 0.45614035087719296`]], AbsoluteThickness[0.25], 
     LineBox[{6526, 6527}]}, 
    {Hue[
      NCache[
       Rational[6527, 14307], 0.45621024673236876`]], AbsoluteThickness[0.25],
      LineBox[{6527, 6528}]}, 
    {Hue[
      NCache[
       Rational[2176, 4769], 0.45628014258754457`]], AbsoluteThickness[0.25], 
     LineBox[{6528, 6529}]}, 
    {Hue[
      NCache[
       Rational[6529, 14307], 0.4563500384427204]], AbsoluteThickness[0.25], 
     LineBox[{6529, 6530}]}, 
    {Hue[
      NCache[
       Rational[6530, 14307], 0.4564199342978961]], AbsoluteThickness[0.25], 
     LineBox[{6530, 6531}]}, 
    {Hue[
      NCache[
       Rational[2177, 4769], 0.45648983015307193`]], AbsoluteThickness[0.25], 
     LineBox[{6531, 6532}]}, 
    {Hue[
      NCache[
       Rational[6532, 14307], 0.45655972600824773`]], AbsoluteThickness[0.25],
      LineBox[{6532, 6533}]}, 
    {Hue[
      NCache[
       Rational[6533, 14307], 0.4566296218634235]], AbsoluteThickness[0.25], 
     LineBox[{6533, 6534}]}, 
    {Hue[
      NCache[
       Rational[2178, 4769], 0.4566995177185993]], AbsoluteThickness[0.25], 
     LineBox[{6534, 6535}]}, 
    {Hue[
      NCache[
       Rational[6535, 14307], 0.4567694135737751]], AbsoluteThickness[0.25], 
     LineBox[{6535, 6536}]}, 
    {Hue[
      NCache[
       Rational[344, 753], 0.45683930942895085`]], AbsoluteThickness[0.25], 
     LineBox[{6536, 6537}]}, 
    {Hue[
      NCache[
       Rational[2179, 4769], 0.45690920528412665`]], AbsoluteThickness[0.25], 
     LineBox[{6537, 6538}]}, 
    {Hue[
      NCache[
       Rational[6538, 14307], 0.45697910113930246`]], AbsoluteThickness[0.25],
      LineBox[{6538, 6539}]}, 
    {Hue[
      NCache[
       Rational[6539, 14307], 0.4570489969944782]], AbsoluteThickness[0.25], 
     LineBox[{6539, 6540}]}, 
    {Hue[
      NCache[
       Rational[2180, 4769], 0.457118892849654]], AbsoluteThickness[0.25], 
     LineBox[{6540, 6541}]}, 
    {Hue[
      NCache[
       Rational[6541, 14307], 0.4571887887048298]], AbsoluteThickness[0.25], 
     LineBox[{6541, 6542}]}, 
    {Hue[
      NCache[
       Rational[6542, 14307], 0.45725868456000557`]], AbsoluteThickness[0.25],
      LineBox[{6542, 6543}]}, 
    {Hue[
      NCache[
       Rational[2181, 4769], 0.4573285804151814]], AbsoluteThickness[0.25], 
     LineBox[{6543, 6544}]}, 
    {Hue[
      NCache[
       Rational[6544, 14307], 0.4573984762703572]], AbsoluteThickness[0.25], 
     LineBox[{6544, 6545}]}, 
    {Hue[
      NCache[
       Rational[6545, 14307], 0.45746837212553293`]], AbsoluteThickness[0.25],
      LineBox[{6545, 6546}]}, 
    {Hue[
      NCache[
       Rational[2182, 4769], 0.45753826798070873`]], AbsoluteThickness[0.25], 
     LineBox[{6546, 6547}]}, 
    {Hue[
      NCache[
       Rational[6547, 14307], 0.45760816383588454`]], AbsoluteThickness[0.25],
      LineBox[{6547, 6548}]}, 
    {Hue[
      NCache[
       Rational[6548, 14307], 0.45767805969106035`]], AbsoluteThickness[0.25],
      LineBox[{6548, 6549}]}, 
    {Hue[
      NCache[
       Rational[2183, 4769], 0.4577479555462361]], AbsoluteThickness[0.25], 
     LineBox[{6549, 6550}]}, 
    {Hue[
      NCache[
       Rational[6550, 14307], 0.4578178514014119]], AbsoluteThickness[0.25], 
     LineBox[{6550, 6551}]}, 
    {Hue[
      NCache[
       Rational[6551, 14307], 0.4578877472565877]], AbsoluteThickness[0.25], 
     LineBox[{6551, 6552}]}, 
    {Hue[
      NCache[
       Rational[2184, 4769], 0.45795764311176346`]], AbsoluteThickness[0.25], 
     LineBox[{6552, 6553}]}, 
    {Hue[
      NCache[
       Rational[6553, 14307], 0.45802753896693926`]], AbsoluteThickness[0.25],
      LineBox[{6553, 6554}]}, 
    {Hue[
      NCache[
       Rational[6554, 14307], 0.45809743482211507`]], AbsoluteThickness[0.25],
      LineBox[{6554, 6555}]}, 
    {Hue[
      NCache[
       Rational[115, 251], 0.4581673306772908]], AbsoluteThickness[0.25], 
     LineBox[{6555, 6556}]}, 
    {Hue[
      NCache[
       Rational[6556, 14307], 0.4582372265324666]], AbsoluteThickness[0.25], 
     LineBox[{6556, 6557}]}, 
    {Hue[
      NCache[
       Rational[6557, 14307], 0.45830712238764243`]], AbsoluteThickness[0.25],
      LineBox[{6557, 6558}]}, 
    {Hue[
      NCache[
       Rational[2186, 4769], 0.4583770182428182]], AbsoluteThickness[0.25], 
     LineBox[{6558, 6559}]}, 
    {Hue[
      NCache[
       Rational[6559, 14307], 0.458446914097994]], AbsoluteThickness[0.25], 
     LineBox[{6559, 6560}]}, 
    {Hue[
      NCache[
       Rational[6560, 14307], 0.4585168099531698]], AbsoluteThickness[0.25], 
     LineBox[{6560, 6561}]}, 
    {Hue[
      NCache[
       Rational[2187, 4769], 0.45858670580834554`]], AbsoluteThickness[0.25], 
     LineBox[{6561, 6562}]}, 
    {Hue[
      NCache[
       Rational[6562, 14307], 0.45865660166352135`]], AbsoluteThickness[0.25],
      LineBox[{6562, 6563}]}, 
    {Hue[
      NCache[
       Rational[6563, 14307], 0.45872649751869715`]], AbsoluteThickness[0.25],
      LineBox[{6563, 6564}]}, 
    {Hue[
      NCache[
       Rational[2188, 4769], 0.4587963933738729]], AbsoluteThickness[0.25], 
     LineBox[{6564, 6565}]}, 
    {Hue[
      NCache[
       Rational[6565, 14307], 0.4588662892290487]], AbsoluteThickness[0.25], 
     LineBox[{6565, 6566}]}, 
    {Hue[
      NCache[
       Rational[6566, 14307], 0.4589361850842245]], AbsoluteThickness[0.25], 
     LineBox[{6566, 6567}]}, 
    {Hue[
      NCache[
       Rational[2189, 4769], 0.4590060809394003]], AbsoluteThickness[0.25], 
     LineBox[{6567, 6568}]}, 
    {Hue[
      NCache[
       Rational[6568, 14307], 0.45907597679457607`]], AbsoluteThickness[0.25],
      LineBox[{6568, 6569}]}, 
    {Hue[
      NCache[
       Rational[6569, 14307], 0.4591458726497519]], AbsoluteThickness[0.25], 
     LineBox[{6569, 6570}]}, 
    {Hue[
      NCache[
       Rational[2190, 4769], 0.4592157685049277]], AbsoluteThickness[0.25], 
     LineBox[{6570, 6571}]}, 
    {Hue[
      NCache[
       Rational[6571, 14307], 0.45928566436010343`]], AbsoluteThickness[0.25],
      LineBox[{6571, 6572}]}, 
    {Hue[
      NCache[
       Rational[6572, 14307], 0.45935556021527923`]], AbsoluteThickness[0.25],
      LineBox[{6572, 6573}]}, 
    {Hue[
      NCache[
       Rational[2191, 4769], 0.45942545607045504`]], AbsoluteThickness[0.25], 
     LineBox[{6573, 6574}]}, 
    {Hue[
      NCache[
       Rational[346, 753], 0.4594953519256308]], AbsoluteThickness[0.25], 
     LineBox[{6574, 6575}]}, 
    {Hue[
      NCache[
       Rational[6575, 14307], 0.4595652477808066]], AbsoluteThickness[0.25], 
     LineBox[{6575, 6576}]}, 
    {Hue[
      NCache[
       Rational[2192, 4769], 0.4596351436359824]], AbsoluteThickness[0.25], 
     LineBox[{6576, 6577}]}, 
    {Hue[
      NCache[
       Rational[6577, 14307], 0.45970503949115815`]], AbsoluteThickness[0.25],
      LineBox[{6577, 6578}]}, 
    {Hue[
      NCache[
       Rational[6578, 14307], 0.45977493534633396`]], AbsoluteThickness[0.25],
      LineBox[{6578, 6579}]}, 
    {Hue[
      NCache[
       Rational[2193, 4769], 0.45984483120150976`]], AbsoluteThickness[0.25], 
     LineBox[{6579, 6580}]}, 
    {Hue[
      NCache[
       Rational[6580, 14307], 0.4599147270566855]], AbsoluteThickness[0.25], 
     LineBox[{6580, 6581}]}, 
    {Hue[
      NCache[
       Rational[6581, 14307], 0.4599846229118613]], AbsoluteThickness[0.25], 
     LineBox[{6581, 6582}]}, 
    {Hue[
      NCache[
       Rational[2194, 4769], 0.4600545187670371]], AbsoluteThickness[0.25], 
     LineBox[{6582, 6583}]}, 
    {Hue[
      NCache[
       Rational[6583, 14307], 0.46012441462221293`]], AbsoluteThickness[0.25],
      LineBox[{6583, 6584}]}, 
    {Hue[
      NCache[
       Rational[6584, 14307], 0.4601943104773887]], AbsoluteThickness[0.25], 
     LineBox[{6584, 6585}]}, 
    {Hue[
      NCache[
       Rational[2195, 4769], 0.4602642063325645]], AbsoluteThickness[0.25], 
     LineBox[{6585, 6586}]}, 
    {Hue[
      NCache[
       Rational[6586, 14307], 0.4603341021877403]], AbsoluteThickness[0.25], 
     LineBox[{6586, 6587}]}, 
    {Hue[
      NCache[
       Rational[6587, 14307], 0.46040399804291604`]], AbsoluteThickness[0.25],
      LineBox[{6587, 6588}]}, 
    {Hue[
      NCache[
       Rational[2196, 4769], 0.46047389389809185`]], AbsoluteThickness[0.25], 
     LineBox[{6588, 6589}]}, 
    {Hue[
      NCache[
       Rational[6589, 14307], 0.46054378975326765`]], AbsoluteThickness[0.25],
      LineBox[{6589, 6590}]}, 
    {Hue[
      NCache[
       Rational[6590, 14307], 0.4606136856084434]], AbsoluteThickness[0.25], 
     LineBox[{6590, 6591}]}, 
    {Hue[
      NCache[
       Rational[2197, 4769], 0.4606835814636192]], AbsoluteThickness[0.25], 
     LineBox[{6591, 6592}]}, 
    {Hue[
      NCache[
       Rational[6592, 14307], 0.460753477318795]], AbsoluteThickness[0.25], 
     LineBox[{6592, 6593}]}, 
    {Hue[
      NCache[
       Rational[347, 753], 0.46082337317397076`]], AbsoluteThickness[0.25], 
     LineBox[{6593, 6594}]}, 
    {Hue[
      NCache[
       Rational[2198, 4769], 0.46089326902914657`]], AbsoluteThickness[0.25], 
     LineBox[{6594, 6595}]}, 
    {Hue[
      NCache[
       Rational[6595, 14307], 0.4609631648843224]], AbsoluteThickness[0.25], 
     LineBox[{6595, 6596}]}, 
    {Hue[
      NCache[
       Rational[6596, 14307], 0.4610330607394981]], AbsoluteThickness[0.25], 
     LineBox[{6596, 6597}]}, 
    {Hue[
      NCache[
       Rational[2199, 4769], 0.46110295659467393`]], AbsoluteThickness[0.25], 
     LineBox[{6597, 6598}]}, 
    {Hue[
      NCache[
       Rational[6598, 14307], 0.46117285244984974`]], AbsoluteThickness[0.25],
      LineBox[{6598, 6599}]}, 
    {Hue[
      NCache[
       Rational[6599, 14307], 0.4612427483050255]], AbsoluteThickness[0.25], 
     LineBox[{6599, 6600}]}, 
    {Hue[
      NCache[
       Rational[2200, 4769], 0.4613126441602013]], AbsoluteThickness[0.25], 
     LineBox[{6600, 6601}]}, 
    {Hue[
      NCache[
       Rational[6601, 14307], 0.4613825400153771]], AbsoluteThickness[0.25], 
     LineBox[{6601, 6602}]}, 
    {Hue[
      NCache[
       Rational[6602, 14307], 0.4614524358705529]], AbsoluteThickness[0.25], 
     LineBox[{6602, 6603}]}, 
    {Hue[
      NCache[
       Rational[2201, 4769], 0.46152233172572865`]], AbsoluteThickness[0.25], 
     LineBox[{6603, 6604}]}, 
    {Hue[
      NCache[
       Rational[6604, 14307], 0.46159222758090446`]], AbsoluteThickness[0.25],
      LineBox[{6604, 6605}]}, 
    {Hue[
      NCache[
       Rational[6605, 14307], 0.46166212343608026`]], AbsoluteThickness[0.25],
      LineBox[{6605, 6606}]}, 
    {Hue[
      NCache[
       Rational[2202, 4769], 0.461732019291256]], AbsoluteThickness[0.25], 
     LineBox[{6606, 6607}]}, 
    {Hue[
      NCache[
       Rational[6607, 14307], 0.4618019151464318]], AbsoluteThickness[0.25], 
     LineBox[{6607, 6608}]}, 
    {Hue[
      NCache[
       Rational[6608, 14307], 0.4618718110016076]], AbsoluteThickness[0.25], 
     LineBox[{6608, 6609}]}, 
    {Hue[
      NCache[
       Rational[2203, 4769], 0.4619417068567834]], AbsoluteThickness[0.25], 
     LineBox[{6609, 6610}]}, 
    {Hue[
      NCache[
       Rational[6610, 14307], 0.4620116027119592]], AbsoluteThickness[0.25], 
     LineBox[{6610, 6611}]}, 
    {Hue[
      NCache[
       Rational[6611, 14307], 0.462081498567135]], AbsoluteThickness[0.25], 
     LineBox[{6611, 6612}]}, 
    {Hue[
      NCache[
       Rational[116, 251], 0.46215139442231074`]], AbsoluteThickness[0.25], 
     LineBox[{6612, 6613}]}, 
    {Hue[
      NCache[
       Rational[6613, 14307], 0.46222129027748654`]], AbsoluteThickness[0.25],
      LineBox[{6613, 6614}]}, 
    {Hue[
      NCache[
       Rational[6614, 14307], 0.46229118613266235`]], AbsoluteThickness[0.25],
      LineBox[{6614, 6615}]}, 
    {Hue[
      NCache[
       Rational[2205, 4769], 0.4623610819878381]], AbsoluteThickness[0.25], 
     LineBox[{6615, 6616}]}, 
    {Hue[
      NCache[
       Rational[6616, 14307], 0.4624309778430139]], AbsoluteThickness[0.25], 
     LineBox[{6616, 6617}]}, 
    {Hue[
      NCache[
       Rational[6617, 14307], 0.4625008736981897]], AbsoluteThickness[0.25], 
     LineBox[{6617, 6618}]}, 
    {Hue[
      NCache[
       Rational[2206, 4769], 0.4625707695533655]], AbsoluteThickness[0.25], 
     LineBox[{6618, 6619}]}, 
    {Hue[
      NCache[
       Rational[6619, 14307], 0.46264066540854126`]], AbsoluteThickness[0.25],
      LineBox[{6619, 6620}]}, 
    {Hue[
      NCache[
       Rational[6620, 14307], 0.46271056126371707`]], AbsoluteThickness[0.25],
      LineBox[{6620, 6621}]}, 
    {Hue[
      NCache[
       Rational[2207, 4769], 0.4627804571188929]], AbsoluteThickness[0.25], 
     LineBox[{6621, 6622}]}, 
    {Hue[
      NCache[
       Rational[6622, 14307], 0.4628503529740686]], AbsoluteThickness[0.25], 
     LineBox[{6622, 6623}]}, 
    {Hue[
      NCache[
       Rational[6623, 14307], 0.46292024882924443`]], AbsoluteThickness[0.25],
      LineBox[{6623, 6624}]}, 
    {Hue[
      NCache[
       Rational[2208, 4769], 0.46299014468442024`]], AbsoluteThickness[0.25], 
     LineBox[{6624, 6625}]}, 
    {Hue[
      NCache[
       Rational[6625, 14307], 0.463060040539596]], AbsoluteThickness[0.25], 
     LineBox[{6625, 6626}]}, 
    {Hue[
      NCache[
       Rational[6626, 14307], 0.4631299363947718]], AbsoluteThickness[0.25], 
     LineBox[{6626, 6627}]}, 
    {Hue[
      NCache[
       Rational[2209, 4769], 0.4631998322499476]], AbsoluteThickness[0.25], 
     LineBox[{6627, 6628}]}, 
    {Hue[
      NCache[
       Rational[6628, 14307], 0.46326972810512335`]], AbsoluteThickness[0.25],
      LineBox[{6628, 6629}]}, 
    {Hue[
      NCache[
       Rational[6629, 14307], 0.46333962396029915`]], AbsoluteThickness[0.25],
      LineBox[{6629, 6630}]}, 
    {Hue[
      NCache[
       Rational[2210, 4769], 0.46340951981547496`]], AbsoluteThickness[0.25], 
     LineBox[{6630, 6631}]}, 
    {Hue[
      NCache[
       Rational[349, 753], 0.4634794156706507]], AbsoluteThickness[0.25], 
     LineBox[{6631, 6632}]}, 
    {Hue[
      NCache[
       Rational[6632, 14307], 0.4635493115258265]], AbsoluteThickness[0.25], 
     LineBox[{6632, 6633}]}, 
    {Hue[
      NCache[
       Rational[2211, 4769], 0.4636192073810023]], AbsoluteThickness[0.25], 
     LineBox[{6633, 6634}]}, 
    {Hue[
      NCache[
       Rational[6634, 14307], 0.46368910323617807`]], AbsoluteThickness[0.25],
      LineBox[{6634, 6635}]}, 
    {Hue[
      NCache[
       Rational[6635, 14307], 0.4637589990913539]], AbsoluteThickness[0.25], 
     LineBox[{6635, 6636}]}, 
    {Hue[
      NCache[
       Rational[2212, 4769], 0.4638288949465297]], AbsoluteThickness[0.25], 
     LineBox[{6636, 6637}]}, 
    {Hue[
      NCache[
       Rational[6637, 14307], 0.4638987908017055]], AbsoluteThickness[0.25], 
     LineBox[{6637, 6638}]}, 
    {Hue[
      NCache[
       Rational[6638, 14307], 0.46396868665688124`]], AbsoluteThickness[0.25],
      LineBox[{6638, 6639}]}, 
    {Hue[
      NCache[
       Rational[2213, 4769], 0.46403858251205704`]], AbsoluteThickness[0.25], 
     LineBox[{6639, 6640}]}, 
    {Hue[
      NCache[
       Rational[6640, 14307], 0.46410847836723285`]], AbsoluteThickness[0.25],
      LineBox[{6640, 6641}]}, 
    {Hue[
      NCache[
       Rational[6641, 14307], 0.4641783742224086]], AbsoluteThickness[0.25], 
     LineBox[{6641, 6642}]}, 
    {Hue[
      NCache[
       Rational[2214, 4769], 0.4642482700775844]], AbsoluteThickness[0.25], 
     LineBox[{6642, 6643}]}, 
    {Hue[
      NCache[
       Rational[6643, 14307], 0.4643181659327602]], AbsoluteThickness[0.25], 
     LineBox[{6643, 6644}]}, 
    {Hue[
      NCache[
       Rational[6644, 14307], 0.46438806178793596`]], AbsoluteThickness[0.25],
      LineBox[{6644, 6645}]}, 
    {Hue[
      NCache[
       Rational[2215, 4769], 0.46445795764311176`]], AbsoluteThickness[0.25], 
     LineBox[{6645, 6646}]}, 
    {Hue[
      NCache[
       Rational[6646, 14307], 0.46452785349828757`]], AbsoluteThickness[0.25],
      LineBox[{6646, 6647}]}, 
    {Hue[
      NCache[
       Rational[6647, 14307], 0.4645977493534633]], AbsoluteThickness[0.25], 
     LineBox[{6647, 6648}]}, 
    {Hue[
      NCache[
       Rational[2216, 4769], 0.4646676452086391]], AbsoluteThickness[0.25], 
     LineBox[{6648, 6649}]}, 
    {Hue[
      NCache[
       Rational[6649, 14307], 0.46473754106381493`]], AbsoluteThickness[0.25],
      LineBox[{6649, 6650}]}, 
    {Hue[
      NCache[
       Rational[350, 753], 0.4648074369189907]], AbsoluteThickness[0.25], 
     LineBox[{6650, 6651}]}, 
    {Hue[
      NCache[
       Rational[2217, 4769], 0.4648773327741665]], AbsoluteThickness[0.25], 
     LineBox[{6651, 6652}]}, 
    {Hue[
      NCache[
       Rational[6652, 14307], 0.4649472286293423]], AbsoluteThickness[0.25], 
     LineBox[{6652, 6653}]}, 
    {Hue[
      NCache[
       Rational[6653, 14307], 0.46501712448451804`]], AbsoluteThickness[0.25],
      LineBox[{6653, 6654}]}, 
    {Hue[
      NCache[
       Rational[2218, 4769], 0.46508702033969385`]], AbsoluteThickness[0.25], 
     LineBox[{6654, 6655}]}, 
    {Hue[
      NCache[
       Rational[6655, 14307], 0.46515691619486965`]], AbsoluteThickness[0.25],
      LineBox[{6655, 6656}]}, 
    {Hue[
      NCache[
       Rational[6656, 14307], 0.46522681205004546`]], AbsoluteThickness[0.25],
      LineBox[{6656, 6657}]}, 
    {Hue[
      NCache[
       Rational[2219, 4769], 0.4652967079052212]], AbsoluteThickness[0.25], 
     LineBox[{6657, 6658}]}, 
    {Hue[
      NCache[
       Rational[6658, 14307], 0.465366603760397]], AbsoluteThickness[0.25], 
     LineBox[{6658, 6659}]}, 
    {Hue[
      NCache[
       Rational[6659, 14307], 0.4654364996155728]], AbsoluteThickness[0.25], 
     LineBox[{6659, 6660}]}, 
    {Hue[
      NCache[
       Rational[2220, 4769], 0.46550639547074857`]], AbsoluteThickness[0.25], 
     LineBox[{6660, 6661}]}, 
    {Hue[
      NCache[
       Rational[6661, 14307], 0.4655762913259244]], AbsoluteThickness[0.25], 
     LineBox[{6661, 6662}]}, 
    {Hue[
      NCache[
       Rational[6662, 14307], 0.4656461871811002]], AbsoluteThickness[0.25], 
     LineBox[{6662, 6663}]}, 
    {Hue[
      NCache[
       Rational[2221, 4769], 0.46571608303627593`]], AbsoluteThickness[0.25], 
     LineBox[{6663, 6664}]}, 
    {Hue[
      NCache[
       Rational[6664, 14307], 0.46578597889145174`]], AbsoluteThickness[0.25],
      LineBox[{6664, 6665}]}, 
    {Hue[
      NCache[
       Rational[6665, 14307], 0.46585587474662754`]], AbsoluteThickness[0.25],
      LineBox[{6665, 6666}]}, 
    {Hue[
      NCache[
       Rational[2222, 4769], 0.4659257706018033]], AbsoluteThickness[0.25], 
     LineBox[{6666, 6667}]}, 
    {Hue[
      NCache[
       Rational[6667, 14307], 0.4659956664569791]], AbsoluteThickness[0.25], 
     LineBox[{6667, 6668}]}, 
    {Hue[
      NCache[
       Rational[6668, 14307], 0.4660655623121549]], AbsoluteThickness[0.25], 
     LineBox[{6668, 6669}]}, 
    {Hue[
      NCache[
       Rational[117, 251], 0.46613545816733065`]], AbsoluteThickness[0.25], 
     LineBox[{6669, 6670}]}, 
    {Hue[
      NCache[
       Rational[6670, 14307], 0.46620535402250646`]], AbsoluteThickness[0.25],
      LineBox[{6670, 6671}]}, 
    {Hue[
      NCache[
       Rational[6671, 14307], 0.46627524987768226`]], AbsoluteThickness[0.25],
      LineBox[{6671, 6672}]}, 
    {Hue[
      NCache[
       Rational[2224, 4769], 0.46634514573285807`]], AbsoluteThickness[0.25], 
     LineBox[{6672, 6673}]}, 
    {Hue[
      NCache[
       Rational[6673, 14307], 0.4664150415880338]], AbsoluteThickness[0.25], 
     LineBox[{6673, 6674}]}, 
    {Hue[
      NCache[
       Rational[6674, 14307], 0.4664849374432096]], AbsoluteThickness[0.25], 
     LineBox[{6674, 6675}]}, 
    {Hue[
      NCache[
       Rational[2225, 4769], 0.46655483329838543`]], AbsoluteThickness[0.25], 
     LineBox[{6675, 6676}]}, 
    {Hue[
      NCache[
       Rational[6676, 14307], 0.4666247291535612]], AbsoluteThickness[0.25], 
     LineBox[{6676, 6677}]}, 
    {Hue[
      NCache[
       Rational[6677, 14307], 0.466694625008737]], AbsoluteThickness[0.25], 
     LineBox[{6677, 6678}]}, 
    {Hue[
      NCache[
       Rational[2226, 4769], 0.4667645208639128]], AbsoluteThickness[0.25], 
     LineBox[{6678, 6679}]}, 
    {Hue[
      NCache[
       Rational[6679, 14307], 0.46683441671908854`]], AbsoluteThickness[0.25],
      LineBox[{6679, 6680}]}, 
    {Hue[
      NCache[
       Rational[6680, 14307], 0.46690431257426435`]], AbsoluteThickness[0.25],
      LineBox[{6680, 6681}]}, 
    {Hue[
      NCache[
       Rational[2227, 4769], 0.46697420842944015`]], AbsoluteThickness[0.25], 
     LineBox[{6681, 6682}]}, 
    {Hue[
      NCache[
       Rational[6682, 14307], 0.4670441042846159]], AbsoluteThickness[0.25], 
     LineBox[{6682, 6683}]}, 
    {Hue[
      NCache[
       Rational[6683, 14307], 0.4671140001397917]], AbsoluteThickness[0.25], 
     LineBox[{6683, 6684}]}, 
    {Hue[
      NCache[
       Rational[2228, 4769], 0.4671838959949675]], AbsoluteThickness[0.25], 
     LineBox[{6684, 6685}]}, 
    {Hue[
      NCache[
       Rational[6685, 14307], 0.46725379185014326`]], AbsoluteThickness[0.25],
      LineBox[{6685, 6686}]}, 
    {Hue[
      NCache[
       Rational[6686, 14307], 0.46732368770531907`]], AbsoluteThickness[0.25],
      LineBox[{6686, 6687}]}, 
    {Hue[
      NCache[
       Rational[2229, 4769], 0.4673935835604949]], AbsoluteThickness[0.25], 
     LineBox[{6687, 6688}]}, 
    {Hue[
      NCache[
       Rational[352, 753], 0.4674634794156706]], AbsoluteThickness[0.25], 
     LineBox[{6688, 6689}]}, 
    {Hue[
      NCache[
       Rational[6689, 14307], 0.46753337527084643`]], AbsoluteThickness[0.25],
      LineBox[{6689, 6690}]}, 
    {Hue[
      NCache[
       Rational[2230, 4769], 0.46760327112602224`]], AbsoluteThickness[0.25], 
     LineBox[{6690, 6691}]}, 
    {Hue[
      NCache[
       Rational[6691, 14307], 0.46767316698119804`]], AbsoluteThickness[0.25],
      LineBox[{6691, 6692}]}, 
    {Hue[
      NCache[
       Rational[6692, 14307], 0.4677430628363738]], AbsoluteThickness[0.25], 
     LineBox[{6692, 6693}]}, 
    {Hue[
      NCache[
       Rational[2231, 4769], 0.4678129586915496]], AbsoluteThickness[0.25], 
     LineBox[{6693, 6694}]}, 
    {Hue[
      NCache[
       Rational[6694, 14307], 0.4678828545467254]], AbsoluteThickness[0.25], 
     LineBox[{6694, 6695}]}, 
    {Hue[
      NCache[
       Rational[6695, 14307], 0.46795275040190115`]], AbsoluteThickness[0.25],
      LineBox[{6695, 6696}]}, 
    {Hue[
      NCache[
       Rational[2232, 4769], 0.46802264625707696`]], AbsoluteThickness[0.25], 
     LineBox[{6696, 6697}]}, 
    {Hue[
      NCache[
       Rational[6697, 14307], 0.46809254211225276`]], AbsoluteThickness[0.25],
      LineBox[{6697, 6698}]}, 
    {Hue[
      NCache[
       Rational[6698, 14307], 0.4681624379674285]], AbsoluteThickness[0.25], 
     LineBox[{6698, 6699}]}, 
    {Hue[
      NCache[
       Rational[2233, 4769], 0.4682323338226043]], AbsoluteThickness[0.25], 
     LineBox[{6699, 6700}]}, 
    {Hue[
      NCache[
       Rational[6700, 14307], 0.4683022296777801]], AbsoluteThickness[0.25], 
     LineBox[{6700, 6701}]}, 
    {Hue[
      NCache[
       Rational[6701, 14307], 0.4683721255329559]], AbsoluteThickness[0.25], 
     LineBox[{6701, 6702}]}, 
    {Hue[
      NCache[
       Rational[2234, 4769], 0.4684420213881317]], AbsoluteThickness[0.25], 
     LineBox[{6702, 6703}]}, 
    {Hue[
      NCache[
       Rational[6703, 14307], 0.4685119172433075]], AbsoluteThickness[0.25], 
     LineBox[{6703, 6704}]}, 
    {Hue[
      NCache[
       Rational[6704, 14307], 0.46858181309848324`]], AbsoluteThickness[0.25],
      LineBox[{6704, 6705}]}, 
    {Hue[
      NCache[
       Rational[2235, 4769], 0.46865170895365904`]], AbsoluteThickness[0.25], 
     LineBox[{6705, 6706}]}, 
    {Hue[
      NCache[
       Rational[6706, 14307], 0.46872160480883485`]], AbsoluteThickness[0.25],
      LineBox[{6706, 6707}]}, 
    {Hue[
      NCache[
       Rational[353, 753], 0.46879150066401065`]], AbsoluteThickness[0.25], 
     LineBox[{6707, 6708}]}, 
    {Hue[
      NCache[
       Rational[2236, 4769], 0.4688613965191864]], AbsoluteThickness[0.25], 
     LineBox[{6708, 6709}]}, 
    {Hue[
      NCache[
       Rational[6709, 14307], 0.4689312923743622]], AbsoluteThickness[0.25], 
     LineBox[{6709, 6710}]}, 
    {Hue[
      NCache[
       Rational[6710, 14307], 0.469001188229538]], AbsoluteThickness[0.25], 
     LineBox[{6710, 6711}]}, 
    {Hue[
      NCache[
       Rational[2237, 4769], 0.46907108408471376`]], AbsoluteThickness[0.25], 
     LineBox[{6711, 6712}]}, 
    {Hue[
      NCache[
       Rational[6712, 14307], 0.46914097993988957`]], AbsoluteThickness[0.25],
      LineBox[{6712, 6713}]}, 
    {Hue[
      NCache[
       Rational[6713, 14307], 0.4692108757950654]], AbsoluteThickness[0.25], 
     LineBox[{6713, 6714}]}, 
    {Hue[
      NCache[
       Rational[2238, 4769], 0.4692807716502411]], AbsoluteThickness[0.25], 
     LineBox[{6714, 6715}]}, 
    {Hue[
      NCache[
       Rational[6715, 14307], 0.46935066750541693`]], AbsoluteThickness[0.25],
      LineBox[{6715, 6716}]}, 
    {Hue[
      NCache[
       Rational[6716, 14307], 0.46942056336059274`]], AbsoluteThickness[0.25],
      LineBox[{6716, 6717}]}, 
    {Hue[
      NCache[
       Rational[2239, 4769], 0.4694904592157685]], AbsoluteThickness[0.25], 
     LineBox[{6717, 6718}]}, 
    {Hue[
      NCache[
       Rational[6718, 14307], 0.4695603550709443]], AbsoluteThickness[0.25], 
     LineBox[{6718, 6719}]}, 
    {Hue[
      NCache[
       Rational[6719, 14307], 0.4696302509261201]], AbsoluteThickness[0.25], 
     LineBox[{6719, 6720}]}, 
    {Hue[
      NCache[
       Rational[2240, 4769], 0.46970014678129585`]], AbsoluteThickness[0.25], 
     LineBox[{6720, 6721}]}, 
    {Hue[
      NCache[
       Rational[6721, 14307], 0.46977004263647165`]], AbsoluteThickness[0.25],
      LineBox[{6721, 6722}]}, 
    {Hue[
      NCache[
       Rational[6722, 14307], 0.46983993849164746`]], AbsoluteThickness[0.25],
      LineBox[{6722, 6723}]}, 
    {Hue[
      NCache[
       Rational[2241, 4769], 0.4699098343468232]], AbsoluteThickness[0.25], 
     LineBox[{6723, 6724}]}, 
    {Hue[
      NCache[
       Rational[6724, 14307], 0.469979730201999]], AbsoluteThickness[0.25], 
     LineBox[{6724, 6725}]}, 
    {Hue[
      NCache[
       Rational[6725, 14307], 0.4700496260571748]], AbsoluteThickness[0.25], 
     LineBox[{6725, 6726}]}, 
    {Hue[
      NCache[
       Rational[118, 251], 0.4701195219123506]], AbsoluteThickness[0.25], 
     LineBox[{6726, 6727}]}, 
    {Hue[
      NCache[
       Rational[6727, 14307], 0.4701894177675264]], AbsoluteThickness[0.25], 
     LineBox[{6727, 6728}]}, 
    {Hue[
      NCache[
       Rational[6728, 14307], 0.4702593136227022]], AbsoluteThickness[0.25], 
     LineBox[{6728, 6729}]}, 
    {Hue[
      NCache[
       Rational[2243, 4769], 0.470329209477878]], AbsoluteThickness[0.25], 
     LineBox[{6729, 6730}]}, 
    {Hue[
      NCache[
       Rational[6730, 14307], 0.47039910533305374`]], AbsoluteThickness[0.25],
      LineBox[{6730, 6731}]}, 
    {Hue[
      NCache[
       Rational[6731, 14307], 0.47046900118822954`]], AbsoluteThickness[0.25],
      LineBox[{6731, 6732}]}, 
    {Hue[
      NCache[
       Rational[2244, 4769], 0.47053889704340535`]], AbsoluteThickness[0.25], 
     LineBox[{6732, 6733}]}, 
    {Hue[
      NCache[
       Rational[6733, 14307], 0.4706087928985811]], AbsoluteThickness[0.25], 
     LineBox[{6733, 6734}]}, 
    {Hue[
      NCache[
       Rational[6734, 14307], 0.4706786887537569]], AbsoluteThickness[0.25], 
     LineBox[{6734, 6735}]}, 
    {Hue[
      NCache[
       Rational[2245, 4769], 0.4707485846089327]], AbsoluteThickness[0.25], 
     LineBox[{6735, 6736}]}, 
    {Hue[
      NCache[
       Rational[6736, 14307], 0.47081848046410846`]], AbsoluteThickness[0.25],
      LineBox[{6736, 6737}]}, 
    {Hue[
      NCache[
       Rational[6737, 14307], 0.47088837631928426`]], AbsoluteThickness[0.25],
      LineBox[{6737, 6738}]}, 
    {Hue[
      NCache[
       Rational[2246, 4769], 0.47095827217446007`]], AbsoluteThickness[0.25], 
     LineBox[{6738, 6739}]}, 
    {Hue[
      NCache[
       Rational[6739, 14307], 0.4710281680296358]], AbsoluteThickness[0.25], 
     LineBox[{6739, 6740}]}, 
    {Hue[
      NCache[
       Rational[6740, 14307], 0.4710980638848116]], AbsoluteThickness[0.25], 
     LineBox[{6740, 6741}]}, 
    {Hue[
      NCache[
       Rational[2247, 4769], 0.47116795973998743`]], AbsoluteThickness[0.25], 
     LineBox[{6741, 6742}]}, 
    {Hue[
      NCache[
       Rational[6742, 14307], 0.4712378555951632]], AbsoluteThickness[0.25], 
     LineBox[{6742, 6743}]}, 
    {Hue[
      NCache[
       Rational[6743, 14307], 0.471307751450339]], AbsoluteThickness[0.25], 
     LineBox[{6743, 6744}]}, 
    {Hue[
      NCache[
       Rational[2248, 4769], 0.4713776473055148]], AbsoluteThickness[0.25], 
     LineBox[{6744, 6745}]}, 
    {Hue[
      NCache[
       Rational[355, 753], 0.4714475431606906]], AbsoluteThickness[0.25], 
     LineBox[{6745, 6746}]}, 
    {Hue[
      NCache[
       Rational[6746, 14307], 0.47151743901586635`]], AbsoluteThickness[0.25],
      LineBox[{6746, 6747}]}, 
    {Hue[
      NCache[
       Rational[2249, 4769], 0.47158733487104215`]], AbsoluteThickness[0.25], 
     LineBox[{6747, 6748}]}, 
    {Hue[
      NCache[
       Rational[6748, 14307], 0.47165723072621796`]], AbsoluteThickness[0.25],
      LineBox[{6748, 6749}]}, 
    {Hue[
      NCache[
       Rational[6749, 14307], 0.4717271265813937]], AbsoluteThickness[0.25], 
     LineBox[{6749, 6750}]}, 
    {Hue[
      NCache[
       Rational[2250, 4769], 0.4717970224365695]], AbsoluteThickness[0.25], 
     LineBox[{6750, 6751}]}, 
    {Hue[
      NCache[
       Rational[6751, 14307], 0.4718669182917453]], AbsoluteThickness[0.25], 
     LineBox[{6751, 6752}]}, 
    {Hue[
      NCache[
       Rational[6752, 14307], 0.47193681414692107`]], AbsoluteThickness[0.25],
      LineBox[{6752, 6753}]}, 
    {Hue[
      NCache[
       Rational[2251, 4769], 0.4720067100020969]], AbsoluteThickness[0.25], 
     LineBox[{6753, 6754}]}, 
    {Hue[
      NCache[
       Rational[6754, 14307], 0.4720766058572727]], AbsoluteThickness[0.25], 
     LineBox[{6754, 6755}]}, 
    {Hue[
      NCache[
       Rational[6755, 14307], 0.47214650171244843`]], AbsoluteThickness[0.25],
      LineBox[{6755, 6756}]}, 
    {Hue[
      NCache[
       Rational[2252, 4769], 0.47221639756762424`]], AbsoluteThickness[0.25], 
     LineBox[{6756, 6757}]}, 
    {Hue[
      NCache[
       Rational[6757, 14307], 0.47228629342280004`]], AbsoluteThickness[0.25],
      LineBox[{6757, 6758}]}, 
    {Hue[
      NCache[
       Rational[6758, 14307], 0.4723561892779758]], AbsoluteThickness[0.25], 
     LineBox[{6758, 6759}]}, 
    {Hue[
      NCache[
       Rational[2253, 4769], 0.4724260851331516]], AbsoluteThickness[0.25], 
     LineBox[{6759, 6760}]}, 
    {Hue[
      NCache[
       Rational[6760, 14307], 0.4724959809883274]], AbsoluteThickness[0.25], 
     LineBox[{6760, 6761}]}, 
    {Hue[
      NCache[
       Rational[6761, 14307], 0.4725658768435032]], AbsoluteThickness[0.25], 
     LineBox[{6761, 6762}]}, 
    {Hue[
      NCache[
       Rational[2254, 4769], 0.47263577269867896`]], AbsoluteThickness[0.25], 
     LineBox[{6762, 6763}]}, 
    {Hue[
      NCache[
       Rational[6763, 14307], 0.47270566855385476`]], AbsoluteThickness[0.25],
      LineBox[{6763, 6764}]}, 
    {Hue[
      NCache[
       Rational[356, 753], 0.47277556440903057`]], AbsoluteThickness[0.25], 
     LineBox[{6764, 6765}]}, 
    {Hue[
      NCache[
       Rational[2255, 4769], 0.4728454602642063]], AbsoluteThickness[0.25], 
     LineBox[{6765, 6766}]}, 
    {Hue[
      NCache[
       Rational[6766, 14307], 0.4729153561193821]], AbsoluteThickness[0.25], 
     LineBox[{6766, 6767}]}, 
    {Hue[
      NCache[
       Rational[6767, 14307], 0.47298525197455793`]], AbsoluteThickness[0.25],
      LineBox[{6767, 6768}]}, 
    {Hue[
      NCache[
       Rational[2256, 4769], 0.4730551478297337]], AbsoluteThickness[0.25], 
     LineBox[{6768, 6769}]}, 
    {Hue[
      NCache[
       Rational[6769, 14307], 0.4731250436849095]], AbsoluteThickness[0.25], 
     LineBox[{6769, 6770}]}, 
    {Hue[
      NCache[
       Rational[6770, 14307], 0.4731949395400853]], AbsoluteThickness[0.25], 
     LineBox[{6770, 6771}]}, 
    {Hue[
      NCache[
       Rational[2257, 4769], 0.47326483539526104`]], AbsoluteThickness[0.25], 
     LineBox[{6771, 6772}]}, 
    {Hue[
      NCache[
       Rational[6772, 14307], 0.47333473125043685`]], AbsoluteThickness[0.25],
      LineBox[{6772, 6773}]}, 
    {Hue[
      NCache[
       Rational[6773, 14307], 0.47340462710561265`]], AbsoluteThickness[0.25],
      LineBox[{6773, 6774}]}, 
    {Hue[
      NCache[
       Rational[2258, 4769], 0.4734745229607884]], AbsoluteThickness[0.25], 
     LineBox[{6774, 6775}]}, 
    {Hue[
      NCache[
       Rational[6775, 14307], 0.4735444188159642]], AbsoluteThickness[0.25], 
     LineBox[{6775, 6776}]}, 
    {Hue[
      NCache[
       Rational[6776, 14307], 0.47361431467114]], AbsoluteThickness[0.25], 
     LineBox[{6776, 6777}]}, 
    {Hue[
      NCache[
       Rational[9, 19], 0.47368421052631576`]], AbsoluteThickness[0.25], 
     LineBox[{6777, 6778}]}, 
    {Hue[
      NCache[
       Rational[6778, 14307], 0.47375410638149157`]], AbsoluteThickness[0.25],
      LineBox[{6778, 6779}]}, 
    {Hue[
      NCache[
       Rational[6779, 14307], 0.4738240022366674]], AbsoluteThickness[0.25], 
     LineBox[{6779, 6780}]}, 
    {Hue[
      NCache[
       Rational[2260, 4769], 0.4738938980918432]], AbsoluteThickness[0.25], 
     LineBox[{6780, 6781}]}, 
    {Hue[
      NCache[
       Rational[6781, 14307], 0.47396379394701893`]], AbsoluteThickness[0.25],
      LineBox[{6781, 6782}]}, 
    {Hue[
      NCache[
       Rational[6782, 14307], 0.47403368980219474`]], AbsoluteThickness[0.25],
      LineBox[{6782, 6783}]}, 
    {Hue[
      NCache[
       Rational[119, 251], 0.47410358565737054`]], AbsoluteThickness[0.25], 
     LineBox[{6783, 6784}]}, 
    {Hue[
      NCache[
       Rational[6784, 14307], 0.4741734815125463]], AbsoluteThickness[0.25], 
     LineBox[{6784, 6785}]}, 
    {Hue[
      NCache[
       Rational[6785, 14307], 0.4742433773677221]], AbsoluteThickness[0.25], 
     LineBox[{6785, 6786}]}, 
    {Hue[
      NCache[
       Rational[2262, 4769], 0.4743132732228979]], AbsoluteThickness[0.25], 
     LineBox[{6786, 6787}]}, 
    {Hue[
      NCache[
       Rational[6787, 14307], 0.47438316907807365`]], AbsoluteThickness[0.25],
      LineBox[{6787, 6788}]}, 
    {Hue[
      NCache[
       Rational[6788, 14307], 0.47445306493324946`]], AbsoluteThickness[0.25],
      LineBox[{6788, 6789}]}, 
    {Hue[
      NCache[
       Rational[2263, 4769], 0.47452296078842526`]], AbsoluteThickness[0.25], 
     LineBox[{6789, 6790}]}, 
    {Hue[
      NCache[
       Rational[6790, 14307], 0.474592856643601]], AbsoluteThickness[0.25], 
     LineBox[{6790, 6791}]}, 
    {Hue[
      NCache[
       Rational[6791, 14307], 0.4746627524987768]], AbsoluteThickness[0.25], 
     LineBox[{6791, 6792}]}, 
    {Hue[
      NCache[
       Rational[2264, 4769], 0.4747326483539526]], AbsoluteThickness[0.25], 
     LineBox[{6792, 6793}]}, 
    {Hue[
      NCache[
       Rational[6793, 14307], 0.4748025442091284]], AbsoluteThickness[0.25], 
     LineBox[{6793, 6794}]}, 
    {Hue[
      NCache[
       Rational[6794, 14307], 0.4748724400643042]], AbsoluteThickness[0.25], 
     LineBox[{6794, 6795}]}, 
    {Hue[
      NCache[
       Rational[2265, 4769], 0.47494233591948]], AbsoluteThickness[0.25], 
     LineBox[{6795, 6796}]}, 
    {Hue[
      NCache[
       Rational[6796, 14307], 0.47501223177465574`]], AbsoluteThickness[0.25],
      LineBox[{6796, 6797}]}, 
    {Hue[
      NCache[
       Rational[6797, 14307], 0.47508212762983154`]], AbsoluteThickness[0.25],
      LineBox[{6797, 6798}]}, 
    {Hue[
      NCache[
       Rational[2266, 4769], 0.47515202348500735`]], AbsoluteThickness[0.25], 
     LineBox[{6798, 6799}]}, 
    {Hue[
      NCache[
       Rational[6799, 14307], 0.47522191934018315`]], AbsoluteThickness[0.25],
      LineBox[{6799, 6800}]}, 
    {Hue[
      NCache[
       Rational[6800, 14307], 0.4752918151953589]], AbsoluteThickness[0.25], 
     LineBox[{6800, 6801}]}, 
    {Hue[
      NCache[
       Rational[2267, 4769], 0.4753617110505347]], AbsoluteThickness[0.25], 
     LineBox[{6801, 6802}]}, 
    {Hue[
      NCache[
       Rational[358, 753], 0.4754316069057105]], AbsoluteThickness[0.25], 
     LineBox[{6802, 6803}]}, 
    {Hue[
      NCache[
       Rational[6803, 14307], 0.47550150276088626`]], AbsoluteThickness[0.25],
      LineBox[{6803, 6804}]}, 
    {Hue[
      NCache[
       Rational[2268, 4769], 0.47557139861606207`]], AbsoluteThickness[0.25], 
     LineBox[{6804, 6805}]}, 
    {Hue[
      NCache[
       Rational[6805, 14307], 0.4756412944712379]], AbsoluteThickness[0.25], 
     LineBox[{6805, 6806}]}, 
    {Hue[
      NCache[
       Rational[6806, 14307], 0.4757111903264136]], AbsoluteThickness[0.25], 
     LineBox[{6806, 6807}]}, 
    {Hue[
      NCache[
       Rational[2269, 4769], 0.47578108618158943`]], AbsoluteThickness[0.25], 
     LineBox[{6807, 6808}]}, 
    {Hue[
      NCache[
       Rational[6808, 14307], 0.47585098203676524`]], AbsoluteThickness[0.25],
      LineBox[{6808, 6809}]}, 
    {Hue[
      NCache[
       Rational[6809, 14307], 0.475920877891941]], AbsoluteThickness[0.25], 
     LineBox[{6809, 6810}]}, 
    {Hue[
      NCache[
       Rational[2270, 4769], 0.4759907737471168]], AbsoluteThickness[0.25], 
     LineBox[{6810, 6811}]}, 
    {Hue[
      NCache[
       Rational[6811, 14307], 0.4760606696022926]], AbsoluteThickness[0.25], 
     LineBox[{6811, 6812}]}, 
    {Hue[
      NCache[
       Rational[6812, 14307], 0.47613056545746835`]], AbsoluteThickness[0.25],
      LineBox[{6812, 6813}]}, 
    {Hue[
      NCache[
       Rational[2271, 4769], 0.47620046131264415`]], AbsoluteThickness[0.25], 
     LineBox[{6813, 6814}]}, 
    {Hue[
      NCache[
       Rational[6814, 14307], 0.47627035716781996`]], AbsoluteThickness[0.25],
      LineBox[{6814, 6815}]}, 
    {Hue[
      NCache[
       Rational[6815, 14307], 0.47634025302299576`]], AbsoluteThickness[0.25],
      LineBox[{6815, 6816}]}, 
    {Hue[
      NCache[
       Rational[2272, 4769], 0.4764101488781715]], AbsoluteThickness[0.25], 
     LineBox[{6816, 6817}]}, 
    {Hue[
      NCache[
       Rational[6817, 14307], 0.4764800447333473]], AbsoluteThickness[0.25], 
     LineBox[{6817, 6818}]}, 
    {Hue[
      NCache[
       Rational[6818, 14307], 0.4765499405885231]], AbsoluteThickness[0.25], 
     LineBox[{6818, 6819}]}, 
    {Hue[
      NCache[
       Rational[2273, 4769], 0.4766198364436989]], AbsoluteThickness[0.25], 
     LineBox[{6819, 6820}]}, 
    {Hue[
      NCache[
       Rational[6820, 14307], 0.4766897322988747]], AbsoluteThickness[0.25], 
     LineBox[{6820, 6821}]}, 
    {Hue[
      NCache[
       Rational[359, 753], 0.4767596281540505]], AbsoluteThickness[0.25], 
     LineBox[{6821, 6822}]}, 
    {Hue[
      NCache[
       Rational[2274, 4769], 0.47682952400922624`]], AbsoluteThickness[0.25], 
     LineBox[{6822, 6823}]}, 
    {Hue[
      NCache[
       Rational[6823, 14307], 0.47689941986440204`]], AbsoluteThickness[0.25],
      LineBox[{6823, 6824}]}, 
    {Hue[
      NCache[
       Rational[6824, 14307], 0.47696931571957785`]], AbsoluteThickness[0.25],
      LineBox[{6824, 6825}]}, 
    {Hue[
      NCache[
       Rational[2275, 4769], 0.4770392115747536]], AbsoluteThickness[0.25], 
     LineBox[{6825, 6826}]}, 
    {Hue[
      NCache[
       Rational[6826, 14307], 0.4771091074299294]], AbsoluteThickness[0.25], 
     LineBox[{6826, 6827}]}, 
    {Hue[
      NCache[
       Rational[6827, 14307], 0.4771790032851052]], AbsoluteThickness[0.25], 
     LineBox[{6827, 6828}]}, 
    {Hue[
      NCache[
       Rational[2276, 4769], 0.47724889914028096`]], AbsoluteThickness[0.25], 
     LineBox[{6828, 6829}]}, 
    {Hue[
      NCache[
       Rational[6829, 14307], 0.47731879499545676`]], AbsoluteThickness[0.25],
      LineBox[{6829, 6830}]}, 
    {Hue[
      NCache[
       Rational[6830, 14307], 0.47738869085063257`]], AbsoluteThickness[0.25],
      LineBox[{6830, 6831}]}, 
    {Hue[
      NCache[
       Rational[2277, 4769], 0.4774585867058083]], AbsoluteThickness[0.25], 
     LineBox[{6831, 6832}]}, 
    {Hue[
      NCache[
       Rational[6832, 14307], 0.4775284825609841]], AbsoluteThickness[0.25], 
     LineBox[{6832, 6833}]}, 
    {Hue[
      NCache[
       Rational[6833, 14307], 0.47759837841615993`]], AbsoluteThickness[0.25],
      LineBox[{6833, 6834}]}, 
    {Hue[
      NCache[
       Rational[2278, 4769], 0.47766827427133574`]], AbsoluteThickness[0.25], 
     LineBox[{6834, 6835}]}, 
    {Hue[
      NCache[
       Rational[6835, 14307], 0.4777381701265115]], AbsoluteThickness[0.25], 
     LineBox[{6835, 6836}]}, 
    {Hue[
      NCache[
       Rational[6836, 14307], 0.4778080659816873]], AbsoluteThickness[0.25], 
     LineBox[{6836, 6837}]}, 
    {Hue[
      NCache[
       Rational[2279, 4769], 0.4778779618368631]], AbsoluteThickness[0.25], 
     LineBox[{6837, 6838}]}, 
    {Hue[
      NCache[
       Rational[6838, 14307], 0.47794785769203885`]], AbsoluteThickness[0.25],
      LineBox[{6838, 6839}]}, 
    {Hue[
      NCache[
       Rational[6839, 14307], 0.47801775354721465`]], AbsoluteThickness[0.25],
      LineBox[{6839, 6840}]}, 
    {Hue[
      NCache[
       Rational[120, 251], 0.47808764940239046`]], AbsoluteThickness[0.25], 
     LineBox[{6840, 6841}]}, 
    {Hue[
      NCache[
       Rational[6841, 14307], 0.4781575452575662]], AbsoluteThickness[0.25], 
     LineBox[{6841, 6842}]}, 
    {Hue[
      NCache[
       Rational[6842, 14307], 0.478227441112742]], AbsoluteThickness[0.25], 
     LineBox[{6842, 6843}]}, 
    {Hue[
      NCache[
       Rational[2281, 4769], 0.4782973369679178]], AbsoluteThickness[0.25], 
     LineBox[{6843, 6844}]}, 
    {Hue[
      NCache[
       Rational[6844, 14307], 0.47836723282309357`]], AbsoluteThickness[0.25],
      LineBox[{6844, 6845}]}, 
    {Hue[
      NCache[
       Rational[6845, 14307], 0.4784371286782694]], AbsoluteThickness[0.25], 
     LineBox[{6845, 6846}]}, 
    {Hue[
      NCache[
       Rational[2282, 4769], 0.4785070245334452]], AbsoluteThickness[0.25], 
     LineBox[{6846, 6847}]}, 
    {Hue[
      NCache[
       Rational[6847, 14307], 0.47857692038862093`]], AbsoluteThickness[0.25],
      LineBox[{6847, 6848}]}, 
    {Hue[
      NCache[
       Rational[6848, 14307], 0.47864681624379674`]], AbsoluteThickness[0.25],
      LineBox[{6848, 6849}]}, 
    {Hue[
      NCache[
       Rational[2283, 4769], 0.47871671209897254`]], AbsoluteThickness[0.25], 
     LineBox[{6849, 6850}]}, 
    {Hue[
      NCache[
       Rational[6850, 14307], 0.47878660795414835`]], AbsoluteThickness[0.25],
      LineBox[{6850, 6851}]}, 
    {Hue[
      NCache[
       Rational[6851, 14307], 0.4788565038093241]], AbsoluteThickness[0.25], 
     LineBox[{6851, 6852}]}, 
    {Hue[
      NCache[
       Rational[2284, 4769], 0.4789263996644999]], AbsoluteThickness[0.25], 
     LineBox[{6852, 6853}]}, 
    {Hue[
      NCache[
       Rational[6853, 14307], 0.4789962955196757]], AbsoluteThickness[0.25], 
     LineBox[{6853, 6854}]}, 
    {Hue[
      NCache[
       Rational[6854, 14307], 0.47906619137485146`]], AbsoluteThickness[0.25],
      LineBox[{6854, 6855}]}, 
    {Hue[
      NCache[
       Rational[2285, 4769], 0.47913608723002726`]], AbsoluteThickness[0.25], 
     LineBox[{6855, 6856}]}, 
    {Hue[
      NCache[
       Rational[6856, 14307], 0.47920598308520307`]], AbsoluteThickness[0.25],
      LineBox[{6856, 6857}]}, 
    {Hue[
      NCache[
       Rational[6857, 14307], 0.4792758789403788]], AbsoluteThickness[0.25], 
     LineBox[{6857, 6858}]}, 
    {Hue[
      NCache[
       Rational[2286, 4769], 0.4793457747955546]], AbsoluteThickness[0.25], 
     LineBox[{6858, 6859}]}, 
    {Hue[
      NCache[
       Rational[361, 753], 0.47941567065073043`]], AbsoluteThickness[0.25], 
     LineBox[{6859, 6860}]}, 
    {Hue[
      NCache[
       Rational[6860, 14307], 0.4794855665059062]], AbsoluteThickness[0.25], 
     LineBox[{6860, 6861}]}, 
    {Hue[
      NCache[
       Rational[2287, 4769], 0.479555462361082]], AbsoluteThickness[0.25], 
     LineBox[{6861, 6862}]}, 
    {Hue[
      NCache[
       Rational[6862, 14307], 0.4796253582162578]], AbsoluteThickness[0.25], 
     LineBox[{6862, 6863}]}, 
    {Hue[
      NCache[
       Rational[6863, 14307], 0.47969525407143354`]], AbsoluteThickness[0.25],
      LineBox[{6863, 6864}]}, 
    {Hue[
      NCache[
       Rational[2288, 4769], 0.47976514992660935`]], AbsoluteThickness[0.25], 
     LineBox[{6864, 6865}]}, 
    {Hue[
      NCache[
       Rational[6865, 14307], 0.47983504578178515`]], AbsoluteThickness[0.25],
      LineBox[{6865, 6866}]}, 
    {Hue[
      NCache[
       Rational[6866, 14307], 0.4799049416369609]], AbsoluteThickness[0.25], 
     LineBox[{6866, 6867}]}, 
    {Hue[
      NCache[
       Rational[2289, 4769], 0.4799748374921367]], AbsoluteThickness[0.25], 
     LineBox[{6867, 6868}]}, 
    {Hue[
      NCache[
       Rational[6868, 14307], 0.4800447333473125]], AbsoluteThickness[0.25], 
     LineBox[{6868, 6869}]}, 
    {Hue[
      NCache[
       Rational[6869, 14307], 0.4801146292024883]], AbsoluteThickness[0.25], 
     LineBox[{6869, 6870}]}, 
    {Hue[
      NCache[
       Rational[2290, 4769], 0.48018452505766407`]], AbsoluteThickness[0.25], 
     LineBox[{6870, 6871}]}, 
    {Hue[
      NCache[
       Rational[6871, 14307], 0.4802544209128399]], AbsoluteThickness[0.25], 
     LineBox[{6871, 6872}]}, 
    {Hue[
      NCache[
       Rational[6872, 14307], 0.4803243167680157]], AbsoluteThickness[0.25], 
     LineBox[{6872, 6873}]}, 
    {Hue[
      NCache[
       Rational[2291, 4769], 0.48039421262319143`]], AbsoluteThickness[0.25], 
     LineBox[{6873, 6874}]}, 
    {Hue[
      NCache[
       Rational[6874, 14307], 0.48046410847836724`]], AbsoluteThickness[0.25],
      LineBox[{6874, 6875}]}, 
    {Hue[
      NCache[
       Rational[6875, 14307], 0.48053400433354304`]], AbsoluteThickness[0.25],
      LineBox[{6875, 6876}]}, 
    {Hue[
      NCache[
       Rational[2292, 4769], 0.4806039001887188]], AbsoluteThickness[0.25], 
     LineBox[{6876, 6877}]}, 
    {Hue[
      NCache[
       Rational[6877, 14307], 0.4806737960438946]], AbsoluteThickness[0.25], 
     LineBox[{6877, 6878}]}, 
    {Hue[
      NCache[
       Rational[362, 753], 0.4807436918990704]], AbsoluteThickness[0.25], 
     LineBox[{6878, 6879}]}, 
    {Hue[
      NCache[
       Rational[2293, 4769], 0.48081358775424615`]], AbsoluteThickness[0.25], 
     LineBox[{6879, 6880}]}, 
    {Hue[
      NCache[
       Rational[6880, 14307], 0.48088348360942196`]], AbsoluteThickness[0.25],
      LineBox[{6880, 6881}]}, 
    {Hue[
      NCache[
       Rational[6881, 14307], 0.48095337946459776`]], AbsoluteThickness[0.25],
      LineBox[{6881, 6882}]}, 
    {Hue[
      NCache[
       Rational[2294, 4769], 0.4810232753197735]], AbsoluteThickness[0.25], 
     LineBox[{6882, 6883}]}, 
    {Hue[
      NCache[
       Rational[6883, 14307], 0.4810931711749493]], AbsoluteThickness[0.25], 
     LineBox[{6883, 6884}]}, 
    {Hue[
      NCache[
       Rational[6884, 14307], 0.4811630670301251]], AbsoluteThickness[0.25], 
     LineBox[{6884, 6885}]}, 
    {Hue[
      NCache[
       Rational[2295, 4769], 0.4812329628853009]], AbsoluteThickness[0.25], 
     LineBox[{6885, 6886}]}, 
    {Hue[
      NCache[
       Rational[6886, 14307], 0.4813028587404767]], AbsoluteThickness[0.25], 
     LineBox[{6886, 6887}]}, 
    {Hue[
      NCache[
       Rational[6887, 14307], 0.4813727545956525]], AbsoluteThickness[0.25], 
     LineBox[{6887, 6888}]}, 
    {Hue[
      NCache[
       Rational[2296, 4769], 0.4814426504508283]], AbsoluteThickness[0.25], 
     LineBox[{6888, 6889}]}, 
    {Hue[
      NCache[
       Rational[6889, 14307], 0.48151254630600404`]], AbsoluteThickness[0.25],
      LineBox[{6889, 6890}]}, 
    {Hue[
      NCache[
       Rational[6890, 14307], 0.48158244216117985`]], AbsoluteThickness[0.25],
      LineBox[{6890, 6891}]}, 
    {Hue[
      NCache[
       Rational[2297, 4769], 0.48165233801635565`]], AbsoluteThickness[0.25], 
     LineBox[{6891, 6892}]}, 
    {Hue[
      NCache[
       Rational[6892, 14307], 0.4817222338715314]], AbsoluteThickness[0.25], 
     LineBox[{6892, 6893}]}, 
    {Hue[
      NCache[
       Rational[6893, 14307], 0.4817921297267072]], AbsoluteThickness[0.25], 
     LineBox[{6893, 6894}]}, 
    {Hue[
      NCache[
       Rational[2298, 4769], 0.481862025581883]], AbsoluteThickness[0.25], 
     LineBox[{6894, 6895}]}, 
    {Hue[
      NCache[
       Rational[6895, 14307], 0.48193192143705876`]], AbsoluteThickness[0.25],
      LineBox[{6895, 6896}]}, 
    {Hue[
      NCache[
       Rational[6896, 14307], 0.48200181729223457`]], AbsoluteThickness[0.25],
      LineBox[{6896, 6897}]}, 
    {Hue[
      NCache[
       Rational[121, 251], 0.4820717131474104]], AbsoluteThickness[0.25], 
     LineBox[{6897, 6898}]}, 
    {Hue[
      NCache[
       Rational[6898, 14307], 0.4821416090025861]], AbsoluteThickness[0.25], 
     LineBox[{6898, 6899}]}, 
    {Hue[
      NCache[
       Rational[6899, 14307], 0.48221150485776193`]], AbsoluteThickness[0.25],
      LineBox[{6899, 6900}]}, 
    {Hue[
      NCache[
       Rational[2300, 4769], 0.48228140071293774`]], AbsoluteThickness[0.25], 
     LineBox[{6900, 6901}]}, 
    {Hue[
      NCache[
       Rational[6901, 14307], 0.4823512965681135]], AbsoluteThickness[0.25], 
     LineBox[{6901, 6902}]}, 
    {Hue[
      NCache[
       Rational[6902, 14307], 0.4824211924232893]], AbsoluteThickness[0.25], 
     LineBox[{6902, 6903}]}, 
    {Hue[
      NCache[
       Rational[2301, 4769], 0.4824910882784651]], AbsoluteThickness[0.25], 
     LineBox[{6903, 6904}]}, 
    {Hue[
      NCache[
       Rational[6904, 14307], 0.4825609841336409]], AbsoluteThickness[0.25], 
     LineBox[{6904, 6905}]}, 
    {Hue[
      NCache[
       Rational[6905, 14307], 0.48263087998881665`]], AbsoluteThickness[0.25],
      LineBox[{6905, 6906}]}, 
    {Hue[
      NCache[
       Rational[2302, 4769], 0.48270077584399246`]], AbsoluteThickness[0.25], 
     LineBox[{6906, 6907}]}, 
    {Hue[
      NCache[
       Rational[6907, 14307], 0.48277067169916826`]], AbsoluteThickness[0.25],
      LineBox[{6907, 6908}]}, 
    {Hue[
      NCache[
       Rational[6908, 14307], 0.482840567554344]], AbsoluteThickness[0.25], 
     LineBox[{6908, 6909}]}, 
    {Hue[
      NCache[
       Rational[2303, 4769], 0.4829104634095198]], AbsoluteThickness[0.25], 
     LineBox[{6909, 6910}]}, 
    {Hue[
      NCache[
       Rational[6910, 14307], 0.4829803592646956]], AbsoluteThickness[0.25], 
     LineBox[{6910, 6911}]}, 
    {Hue[
      NCache[
       Rational[6911, 14307], 0.4830502551198714]], AbsoluteThickness[0.25], 
     LineBox[{6911, 6912}]}, 
    {Hue[
      NCache[
       Rational[2304, 4769], 0.4831201509750472]], AbsoluteThickness[0.25], 
     LineBox[{6912, 6913}]}, 
    {Hue[
      NCache[
       Rational[6913, 14307], 0.483190046830223]], AbsoluteThickness[0.25], 
     LineBox[{6913, 6914}]}, 
    {Hue[
      NCache[
       Rational[6914, 14307], 0.48325994268539874`]], AbsoluteThickness[0.25],
      LineBox[{6914, 6915}]}, 
    {Hue[
      NCache[
       Rational[2305, 4769], 0.48332983854057454`]], AbsoluteThickness[0.25], 
     LineBox[{6915, 6916}]}, 
    {Hue[
      NCache[
       Rational[364, 753], 0.48339973439575035`]], AbsoluteThickness[0.25], 
     LineBox[{6916, 6917}]}, 
    {Hue[
      NCache[
       Rational[6917, 14307], 0.4834696302509261]], AbsoluteThickness[0.25], 
     LineBox[{6917, 6918}]}, 
    {Hue[
      NCache[
       Rational[2306, 4769], 0.4835395261061019]], AbsoluteThickness[0.25], 
     LineBox[{6918, 6919}]}, 
    {Hue[
      NCache[
       Rational[6919, 14307], 0.4836094219612777]], AbsoluteThickness[0.25], 
     LineBox[{6919, 6920}]}, 
    {Hue[
      NCache[
       Rational[6920, 14307], 0.48367931781645346`]], AbsoluteThickness[0.25],
      LineBox[{6920, 6921}]}, 
    {Hue[
      NCache[
       Rational[2307, 4769], 0.48374921367162926`]], AbsoluteThickness[0.25], 
     LineBox[{6921, 6922}]}, 
    {Hue[
      NCache[
       Rational[6922, 14307], 0.48381910952680507`]], AbsoluteThickness[0.25],
      LineBox[{6922, 6923}]}, 
    {Hue[
      NCache[
       Rational[6923, 14307], 0.4838890053819809]], AbsoluteThickness[0.25], 
     LineBox[{6923, 6924}]}, 
    {Hue[
      NCache[
       Rational[2308, 4769], 0.4839589012371566]], AbsoluteThickness[0.25], 
     LineBox[{6924, 6925}]}, 
    {Hue[
      NCache[
       Rational[6925, 14307], 0.48402879709233243`]], AbsoluteThickness[0.25],
      LineBox[{6925, 6926}]}, 
    {Hue[
      NCache[
       Rational[6926, 14307], 0.48409869294750824`]], AbsoluteThickness[0.25],
      LineBox[{6926, 6927}]}, 
    {Hue[
      NCache[
       Rational[2309, 4769], 0.484168588802684]], AbsoluteThickness[0.25], 
     LineBox[{6927, 6928}]}, 
    {Hue[
      NCache[
       Rational[6928, 14307], 0.4842384846578598]], AbsoluteThickness[0.25], 
     LineBox[{6928, 6929}]}, 
    {Hue[
      NCache[
       Rational[6929, 14307], 0.4843083805130356]], AbsoluteThickness[0.25], 
     LineBox[{6929, 6930}]}, 
    {Hue[
      NCache[
       Rational[2310, 4769], 0.48437827636821135`]], AbsoluteThickness[0.25], 
     LineBox[{6930, 6931}]}, 
    {Hue[
      NCache[
       Rational[6931, 14307], 0.48444817222338715`]], AbsoluteThickness[0.25],
      LineBox[{6931, 6932}]}, 
    {Hue[
      NCache[
       Rational[6932, 14307], 0.48451806807856296`]], AbsoluteThickness[0.25],
      LineBox[{6932, 6933}]}, 
    {Hue[
      NCache[
       Rational[2311, 4769], 0.4845879639337387]], AbsoluteThickness[0.25], 
     LineBox[{6933, 6934}]}, 
    {Hue[
      NCache[
       Rational[6934, 14307], 0.4846578597889145]], AbsoluteThickness[0.25], 
     LineBox[{6934, 6935}]}, 
    {Hue[
      NCache[
       Rational[365, 753], 0.4847277556440903]], AbsoluteThickness[0.25], 
     LineBox[{6935, 6936}]}, 
    {Hue[
      NCache[
       Rational[2312, 4769], 0.48479765149926607`]], AbsoluteThickness[0.25], 
     LineBox[{6936, 6937}]}, 
    {Hue[
      NCache[
       Rational[6937, 14307], 0.4848675473544419]], AbsoluteThickness[0.25], 
     LineBox[{6937, 6938}]}, 
    {Hue[
      NCache[
       Rational[6938, 14307], 0.4849374432096177]], AbsoluteThickness[0.25], 
     LineBox[{6938, 6939}]}, 
    {Hue[
      NCache[
       Rational[2313, 4769], 0.48500733906479343`]], AbsoluteThickness[0.25], 
     LineBox[{6939, 6940}]}, 
    {Hue[
      NCache[
       Rational[6940, 14307], 0.48507723491996924`]], AbsoluteThickness[0.25],
      LineBox[{6940, 6941}]}, 
    {Hue[
      NCache[
       Rational[6941, 14307], 0.48514713077514504`]], AbsoluteThickness[0.25],
      LineBox[{6941, 6942}]}, 
    {Hue[
      NCache[
       Rational[2314, 4769], 0.48521702663032085`]], AbsoluteThickness[0.25], 
     LineBox[{6942, 6943}]}, 
    {Hue[
      NCache[
       Rational[6943, 14307], 0.4852869224854966]], AbsoluteThickness[0.25], 
     LineBox[{6943, 6944}]}, 
    {Hue[
      NCache[
       Rational[6944, 14307], 0.4853568183406724]], AbsoluteThickness[0.25], 
     LineBox[{6944, 6945}]}, 
    {Hue[
      NCache[
       Rational[2315, 4769], 0.4854267141958482]], AbsoluteThickness[0.25], 
     LineBox[{6945, 6946}]}, 
    {Hue[
      NCache[
       Rational[6946, 14307], 0.48549661005102396`]], AbsoluteThickness[0.25],
      LineBox[{6946, 6947}]}, 
    {Hue[
      NCache[
       Rational[6947, 14307], 0.48556650590619976`]], AbsoluteThickness[0.25],
      LineBox[{6947, 6948}]}, 
    {Hue[
      NCache[
       Rational[2316, 4769], 0.48563640176137557`]], AbsoluteThickness[0.25], 
     LineBox[{6948, 6949}]}, 
    {Hue[
      NCache[
       Rational[6949, 14307], 0.4857062976165513]], AbsoluteThickness[0.25], 
     LineBox[{6949, 6950}]}, 
    {Hue[
      NCache[
       Rational[6950, 14307], 0.4857761934717271]], AbsoluteThickness[0.25], 
     LineBox[{6950, 6951}]}, 
    {Hue[
      NCache[
       Rational[2317, 4769], 0.48584608932690293`]], AbsoluteThickness[0.25], 
     LineBox[{6951, 6952}]}, 
    {Hue[
      NCache[
       Rational[6952, 14307], 0.4859159851820787]], AbsoluteThickness[0.25], 
     LineBox[{6952, 6953}]}, 
    {Hue[
      NCache[
       Rational[6953, 14307], 0.4859858810372545]], AbsoluteThickness[0.25], 
     LineBox[{6953, 6954}]}, 
    {Hue[
      NCache[
       Rational[122, 251], 0.4860557768924303]], AbsoluteThickness[0.25], 
     LineBox[{6954, 6955}]}, 
    {Hue[
      NCache[
       Rational[6955, 14307], 0.48612567274760604`]], AbsoluteThickness[0.25],
      LineBox[{6955, 6956}]}, 
    {Hue[
      NCache[
       Rational[6956, 14307], 0.48619556860278185`]], AbsoluteThickness[0.25],
      LineBox[{6956, 6957}]}, 
    {Hue[
      NCache[
       Rational[2319, 4769], 0.48626546445795765`]], AbsoluteThickness[0.25], 
     LineBox[{6957, 6958}]}, 
    {Hue[
      NCache[
       Rational[6958, 14307], 0.48633536031313346`]], AbsoluteThickness[0.25],
      LineBox[{6958, 6959}]}, 
    {Hue[
      NCache[
       Rational[6959, 14307], 0.4864052561683092]], AbsoluteThickness[0.25], 
     LineBox[{6959, 6960}]}, 
    {Hue[
      NCache[
       Rational[2320, 4769], 0.486475152023485]], AbsoluteThickness[0.25], 
     LineBox[{6960, 6961}]}, 
    {Hue[
      NCache[
       Rational[6961, 14307], 0.4865450478786608]], AbsoluteThickness[0.25], 
     LineBox[{6961, 6962}]}, 
    {Hue[
      NCache[
       Rational[6962, 14307], 0.48661494373383657`]], AbsoluteThickness[0.25],
      LineBox[{6962, 6963}]}, 
    {Hue[
      NCache[
       Rational[2321, 4769], 0.4866848395890124]], AbsoluteThickness[0.25], 
     LineBox[{6963, 6964}]}, 
    {Hue[
      NCache[
       Rational[6964, 14307], 0.4867547354441882]], AbsoluteThickness[0.25], 
     LineBox[{6964, 6965}]}, 
    {Hue[
      NCache[
       Rational[6965, 14307], 0.48682463129936393`]], AbsoluteThickness[0.25],
      LineBox[{6965, 6966}]}, 
    {Hue[
      NCache[
       Rational[2322, 4769], 0.48689452715453974`]], AbsoluteThickness[0.25], 
     LineBox[{6966, 6967}]}, 
    {Hue[
      NCache[
       Rational[6967, 14307], 0.48696442300971554`]], AbsoluteThickness[0.25],
      LineBox[{6967, 6968}]}, 
    {Hue[
      NCache[
       Rational[6968, 14307], 0.4870343188648913]], AbsoluteThickness[0.25], 
     LineBox[{6968, 6969}]}, 
    {Hue[
      NCache[
       Rational[2323, 4769], 0.4871042147200671]], AbsoluteThickness[0.25], 
     LineBox[{6969, 6970}]}, 
    {Hue[
      NCache[
       Rational[6970, 14307], 0.4871741105752429]], AbsoluteThickness[0.25], 
     LineBox[{6970, 6971}]}, 
    {Hue[
      NCache[
       Rational[6971, 14307], 0.48724400643041865`]], AbsoluteThickness[0.25],
      LineBox[{6971, 6972}]}, 
    {Hue[
      NCache[
       Rational[2324, 4769], 0.48731390228559446`]], AbsoluteThickness[0.25], 
     LineBox[{6972, 6973}]}, 
    {Hue[
      NCache[
       Rational[367, 753], 0.48738379814077026`]], AbsoluteThickness[0.25], 
     LineBox[{6973, 6974}]}, 
    {Hue[
      NCache[
       Rational[6974, 14307], 0.487453693995946]], AbsoluteThickness[0.25], 
     LineBox[{6974, 6975}]}, 
    {Hue[
      NCache[
       Rational[2325, 4769], 0.4875235898511218]], AbsoluteThickness[0.25], 
     LineBox[{6975, 6976}]}, 
    {Hue[
      NCache[
       Rational[6976, 14307], 0.4875934857062976]], AbsoluteThickness[0.25], 
     LineBox[{6976, 6977}]}, 
    {Hue[
      NCache[
       Rational[6977, 14307], 0.48766338156147343`]], AbsoluteThickness[0.25],
      LineBox[{6977, 6978}]}, 
    {Hue[
      NCache[
       Rational[2326, 4769], 0.4877332774166492]], AbsoluteThickness[0.25], 
     LineBox[{6978, 6979}]}, 
    {Hue[
      NCache[
       Rational[6979, 14307], 0.487803173271825]], AbsoluteThickness[0.25], 
     LineBox[{6979, 6980}]}, 
    {Hue[
      NCache[
       Rational[6980, 14307], 0.4878730691270008]], AbsoluteThickness[0.25], 
     LineBox[{6980, 6981}]}, 
    {Hue[
      NCache[
       Rational[2327, 4769], 0.48794296498217654`]], AbsoluteThickness[0.25], 
     LineBox[{6981, 6982}]}, 
    {Hue[
      NCache[
       Rational[6982, 14307], 0.48801286083735235`]], AbsoluteThickness[0.25],
      LineBox[{6982, 6983}]}, 
    {Hue[
      NCache[
       Rational[6983, 14307], 0.48808275669252815`]], AbsoluteThickness[0.25],
      LineBox[{6983, 6984}]}, 
    {Hue[
      NCache[
       Rational[2328, 4769], 0.4881526525477039]], AbsoluteThickness[0.25], 
     LineBox[{6984, 6985}]}, 
    {Hue[
      NCache[
       Rational[6985, 14307], 0.4882225484028797]], AbsoluteThickness[0.25], 
     LineBox[{6985, 6986}]}, 
    {Hue[
      NCache[
       Rational[6986, 14307], 0.4882924442580555]], AbsoluteThickness[0.25], 
     LineBox[{6986, 6987}]}, 
    {Hue[
      NCache[
       Rational[2329, 4769], 0.48836234011323126`]], AbsoluteThickness[0.25], 
     LineBox[{6987, 6988}]}, 
    {Hue[
      NCache[
       Rational[6988, 14307], 0.48843223596840707`]], AbsoluteThickness[0.25],
      LineBox[{6988, 6989}]}, 
    {Hue[
      NCache[
       Rational[6989, 14307], 0.4885021318235829]], AbsoluteThickness[0.25], 
     LineBox[{6989, 6990}]}, 
    {Hue[
      NCache[
       Rational[2330, 4769], 0.4885720276787586]], AbsoluteThickness[0.25], 
     LineBox[{6990, 6991}]}, 
    {Hue[
      NCache[
       Rational[6991, 14307], 0.48864192353393443`]], AbsoluteThickness[0.25],
      LineBox[{6991, 6992}]}, 
    {Hue[
      NCache[
       Rational[368, 753], 0.48871181938911024`]], AbsoluteThickness[0.25], 
     LineBox[{6992, 6993}]}, 
    {Hue[
      NCache[
       Rational[2331, 4769], 0.48878171524428604`]], AbsoluteThickness[0.25], 
     LineBox[{6993, 6994}]}, 
    {Hue[
      NCache[
       Rational[6994, 14307], 0.4888516110994618]], AbsoluteThickness[0.25], 
     LineBox[{6994, 6995}]}, 
    {Hue[
      NCache[
       Rational[6995, 14307], 0.4889215069546376]], AbsoluteThickness[0.25], 
     LineBox[{6995, 6996}]}, 
    {Hue[
      NCache[
       Rational[2332, 4769], 0.4889914028098134]], AbsoluteThickness[0.25], 
     LineBox[{6996, 6997}]}, 
    {Hue[
      NCache[
       Rational[6997, 14307], 0.48906129866498915`]], AbsoluteThickness[0.25],
      LineBox[{6997, 6998}]}, 
    {Hue[
      NCache[
       Rational[6998, 14307], 0.48913119452016496`]], AbsoluteThickness[0.25],
      LineBox[{6998, 6999}]}, 
    {Hue[
      NCache[
       Rational[2333, 4769], 0.48920109037534076`]], AbsoluteThickness[0.25], 
     LineBox[{6999, 7000}]}, 
    {Hue[
      NCache[
       Rational[7000, 14307], 0.4892709862305165]], AbsoluteThickness[0.25], 
     LineBox[{7000, 7001}]}, 
    {Hue[
      NCache[
       Rational[7001, 14307], 0.4893408820856923]], AbsoluteThickness[0.25], 
     LineBox[{7001, 7002}]}, 
    {Hue[
      NCache[
       Rational[2334, 4769], 0.4894107779408681]], AbsoluteThickness[0.25], 
     LineBox[{7002, 7003}]}, 
    {Hue[
      NCache[
       Rational[7003, 14307], 0.4894806737960439]], AbsoluteThickness[0.25], 
     LineBox[{7003, 7004}]}, 
    {Hue[
      NCache[
       Rational[7004, 14307], 0.4895505696512197]], AbsoluteThickness[0.25], 
     LineBox[{7004, 7005}]}, 
    {Hue[
      NCache[
       Rational[2335, 4769], 0.4896204655063955]], AbsoluteThickness[0.25], 
     LineBox[{7005, 7006}]}, 
    {Hue[
      NCache[
       Rational[7006, 14307], 0.48969036136157124`]], AbsoluteThickness[0.25],
      LineBox[{7006, 7007}]}, 
    {Hue[
      NCache[
       Rational[7007, 14307], 0.48976025721674704`]], AbsoluteThickness[0.25],
      LineBox[{7007, 7008}]}, 
    {Hue[
      NCache[
       Rational[2336, 4769], 0.48983015307192285`]], AbsoluteThickness[0.25], 
     LineBox[{7008, 7009}]}, 
    {Hue[
      NCache[
       Rational[7009, 14307], 0.4899000489270986]], AbsoluteThickness[0.25], 
     LineBox[{7009, 7010}]}, 
    {Hue[
      NCache[
       Rational[7010, 14307], 0.4899699447822744]], AbsoluteThickness[0.25], 
     LineBox[{7010, 7011}]}, 
    {Hue[
      NCache[
       Rational[123, 251], 0.4900398406374502]], AbsoluteThickness[0.25], 
     LineBox[{7011, 7012}]}, 
    {Hue[
      NCache[
       Rational[7012, 14307], 0.490109736492626]], AbsoluteThickness[0.25], 
     LineBox[{7012, 7013}]}, 
    {Hue[
      NCache[
       Rational[7013, 14307], 0.49017963234780176`]], AbsoluteThickness[0.25],
      LineBox[{7013, 7014}]}, 
    {Hue[
      NCache[
       Rational[2338, 4769], 0.49024952820297757`]], AbsoluteThickness[0.25], 
     LineBox[{7014, 7015}]}, 
    {Hue[
      NCache[
       Rational[7015, 14307], 0.4903194240581534]], AbsoluteThickness[0.25], 
     LineBox[{7015, 7016}]}, 
    {Hue[
      NCache[
       Rational[7016, 14307], 0.4903893199133291]], AbsoluteThickness[0.25], 
     LineBox[{7016, 7017}]}, 
    {Hue[
      NCache[
       Rational[2339, 4769], 0.49045921576850493`]], AbsoluteThickness[0.25], 
     LineBox[{7017, 7018}]}, 
    {Hue[
      NCache[
       Rational[7018, 14307], 0.49052911162368074`]], AbsoluteThickness[0.25],
      LineBox[{7018, 7019}]}, 
    {Hue[
      NCache[
       Rational[7019, 14307], 0.4905990074788565]], AbsoluteThickness[0.25], 
     LineBox[{7019, 7020}]}, 
    {Hue[
      NCache[
       Rational[2340, 4769], 0.4906689033340323]], AbsoluteThickness[0.25], 
     LineBox[{7020, 7021}]}, 
    {Hue[
      NCache[
       Rational[7021, 14307], 0.4907387991892081]], AbsoluteThickness[0.25], 
     LineBox[{7021, 7022}]}, 
    {Hue[
      NCache[
       Rational[7022, 14307], 0.49080869504438385`]], AbsoluteThickness[0.25],
      LineBox[{7022, 7023}]}, 
    {Hue[
      NCache[
       Rational[2341, 4769], 0.49087859089955965`]], AbsoluteThickness[0.25], 
     LineBox[{7023, 7024}]}, 
    {Hue[
      NCache[
       Rational[7024, 14307], 0.49094848675473546`]], AbsoluteThickness[0.25],
      LineBox[{7024, 7025}]}, 
    {Hue[
      NCache[
       Rational[7025, 14307], 0.4910183826099112]], AbsoluteThickness[0.25], 
     LineBox[{7025, 7026}]}, 
    {Hue[
      NCache[
       Rational[2342, 4769], 0.491088278465087]], AbsoluteThickness[0.25], 
     LineBox[{7026, 7027}]}, 
    {Hue[
      NCache[
       Rational[7027, 14307], 0.4911581743202628]], AbsoluteThickness[0.25], 
     LineBox[{7027, 7028}]}, 
    {Hue[
      NCache[
       Rational[28, 57], 0.49122807017543857`]], AbsoluteThickness[0.25], 
     LineBox[{7028, 7029}]}, 
    {Hue[
      NCache[
       Rational[2343, 4769], 0.4912979660306144]], AbsoluteThickness[0.25], 
     LineBox[{7029, 7030}]}, 
    {Hue[
      NCache[
       Rational[370, 753], 0.4913678618857902]], AbsoluteThickness[0.25], 
     LineBox[{7030, 7031}]}, 
    {Hue[
      NCache[
       Rational[7031, 14307], 0.491437757740966]], AbsoluteThickness[0.25], 
     LineBox[{7031, 7032}]}, 
    {Hue[
      NCache[
       Rational[2344, 4769], 0.49150765359614174`]], AbsoluteThickness[0.25], 
     LineBox[{7032, 7033}]}, 
    {Hue[
      NCache[
       Rational[7033, 14307], 0.49157754945131754`]], AbsoluteThickness[0.25],
      LineBox[{7033, 7034}]}, 
    {Hue[
      NCache[
       Rational[7034, 14307], 0.49164744530649335`]], AbsoluteThickness[0.25],
      LineBox[{7034, 7035}]}, 
    {Hue[
      NCache[
       Rational[2345, 4769], 0.4917173411616691]], AbsoluteThickness[0.25], 
     LineBox[{7035, 7036}]}, 
    {Hue[
      NCache[
       Rational[7036, 14307], 0.4917872370168449]], AbsoluteThickness[0.25], 
     LineBox[{7036, 7037}]}, 
    {Hue[
      NCache[
       Rational[7037, 14307], 0.4918571328720207]], AbsoluteThickness[0.25], 
     LineBox[{7037, 7038}]}, 
    {Hue[
      NCache[
       Rational[2346, 4769], 0.49192702872719646`]], AbsoluteThickness[0.25], 
     LineBox[{7038, 7039}]}, 
    {Hue[
      NCache[
       Rational[7039, 14307], 0.49199692458237226`]], AbsoluteThickness[0.25],
      LineBox[{7039, 7040}]}, 
    {Hue[
      NCache[
       Rational[7040, 14307], 0.49206682043754807`]], AbsoluteThickness[0.25],
      LineBox[{7040, 7041}]}, 
    {Hue[
      NCache[
       Rational[2347, 4769], 0.4921367162927238]], AbsoluteThickness[0.25], 
     LineBox[{7041, 7042}]}, 
    {Hue[
      NCache[
       Rational[7042, 14307], 0.4922066121478996]], AbsoluteThickness[0.25], 
     LineBox[{7042, 7043}]}, 
    {Hue[
      NCache[
       Rational[7043, 14307], 0.49227650800307543`]], AbsoluteThickness[0.25],
      LineBox[{7043, 7044}]}, 
    {Hue[
      NCache[
       Rational[2348, 4769], 0.4923464038582512]], AbsoluteThickness[0.25], 
     LineBox[{7044, 7045}]}, 
    {Hue[
      NCache[
       Rational[7045, 14307], 0.492416299713427]], AbsoluteThickness[0.25], 
     LineBox[{7045, 7046}]}, 
    {Hue[
      NCache[
       Rational[7046, 14307], 0.4924861955686028]], AbsoluteThickness[0.25], 
     LineBox[{7046, 7047}]}, 
    {Hue[
      NCache[
       Rational[2349, 4769], 0.4925560914237786]], AbsoluteThickness[0.25], 
     LineBox[{7047, 7048}]}, 
    {Hue[
      NCache[
       Rational[7048, 14307], 0.49262598727895435`]], AbsoluteThickness[0.25],
      LineBox[{7048, 7049}]}, 
    {Hue[
      NCache[
       Rational[371, 753], 0.49269588313413015`]], AbsoluteThickness[0.25], 
     LineBox[{7049, 7050}]}, 
    {Hue[
      NCache[
       Rational[2350, 4769], 0.49276577898930596`]], AbsoluteThickness[0.25], 
     LineBox[{7050, 7051}]}, 
    {Hue[
      NCache[
       Rational[7051, 14307], 0.4928356748444817]], AbsoluteThickness[0.25], 
     LineBox[{7051, 7052}]}, 
    {Hue[
      NCache[
       Rational[7052, 14307], 0.4929055706996575]], AbsoluteThickness[0.25], 
     LineBox[{7052, 7053}]}, 
    {Hue[
      NCache[
       Rational[2351, 4769], 0.4929754665548333]], AbsoluteThickness[0.25], 
     LineBox[{7053, 7054}]}, 
    {Hue[
      NCache[
       Rational[7054, 14307], 0.49304536241000907`]], AbsoluteThickness[0.25],
      LineBox[{7054, 7055}]}, 
    {Hue[
      NCache[
       Rational[7055, 14307], 0.4931152582651849]], AbsoluteThickness[0.25], 
     LineBox[{7055, 7056}]}, 
    {Hue[
      NCache[
       Rational[2352, 4769], 0.4931851541203607]], AbsoluteThickness[0.25], 
     LineBox[{7056, 7057}]}, 
    {Hue[
      NCache[
       Rational[7057, 14307], 0.49325504997553643`]], AbsoluteThickness[0.25],
      LineBox[{7057, 7058}]}, 
    {Hue[
      NCache[
       Rational[7058, 14307], 0.49332494583071224`]], AbsoluteThickness[0.25],
      LineBox[{7058, 7059}]}, 
    {Hue[
      NCache[
       Rational[2353, 4769], 0.49339484168588804`]], AbsoluteThickness[0.25], 
     LineBox[{7059, 7060}]}, 
    {Hue[
      NCache[
       Rational[7060, 14307], 0.4934647375410638]], AbsoluteThickness[0.25], 
     LineBox[{7060, 7061}]}, 
    {Hue[
      NCache[
       Rational[7061, 14307], 0.4935346333962396]], AbsoluteThickness[0.25], 
     LineBox[{7061, 7062}]}, 
    {Hue[
      NCache[
       Rational[2354, 4769], 0.4936045292514154]], AbsoluteThickness[0.25], 
     LineBox[{7062, 7063}]}, 
    {Hue[
      NCache[
       Rational[7063, 14307], 0.49367442510659115`]], AbsoluteThickness[0.25],
      LineBox[{7063, 7064}]}, 
    {Hue[
      NCache[
       Rational[7064, 14307], 0.49374432096176696`]], AbsoluteThickness[0.25],
      LineBox[{7064, 7065}]}, 
    {Hue[
      NCache[
       Rational[2355, 4769], 0.49381421681694276`]], AbsoluteThickness[0.25], 
     LineBox[{7065, 7066}]}, 
    {Hue[
      NCache[
       Rational[7066, 14307], 0.49388411267211857`]], AbsoluteThickness[0.25],
      LineBox[{7066, 7067}]}, 
    {Hue[
      NCache[
       Rational[7067, 14307], 0.4939540085272943]], AbsoluteThickness[0.25], 
     LineBox[{7067, 7068}]}, 
    {Hue[
      NCache[
       Rational[124, 251], 0.4940239043824701]], AbsoluteThickness[0.25], 
     LineBox[{7068, 7069}]}, 
    {Hue[
      NCache[
       Rational[7069, 14307], 0.49409380023764593`]], AbsoluteThickness[0.25],
      LineBox[{7069, 7070}]}, 
    {Hue[
      NCache[
       Rational[7070, 14307], 0.4941636960928217]], AbsoluteThickness[0.25], 
     LineBox[{7070, 7071}]}, 
    {Hue[
      NCache[
       Rational[2357, 4769], 0.4942335919479975]], AbsoluteThickness[0.25], 
     LineBox[{7071, 7072}]}, 
    {Hue[
      NCache[
       Rational[7072, 14307], 0.4943034878031733]], AbsoluteThickness[0.25], 
     LineBox[{7072, 7073}]}, 
    {Hue[
      NCache[
       Rational[7073, 14307], 0.49437338365834904`]], AbsoluteThickness[0.25],
      LineBox[{7073, 7074}]}, 
    {Hue[
      NCache[
       Rational[2358, 4769], 0.49444327951352485`]], AbsoluteThickness[0.25], 
     LineBox[{7074, 7075}]}, 
    {Hue[
      NCache[
       Rational[7075, 14307], 0.49451317536870065`]], AbsoluteThickness[0.25],
      LineBox[{7075, 7076}]}, 
    {Hue[
      NCache[
       Rational[7076, 14307], 0.4945830712238764]], AbsoluteThickness[0.25], 
     LineBox[{7076, 7077}]}, 
    {Hue[
      NCache[
       Rational[2359, 4769], 0.4946529670790522]], AbsoluteThickness[0.25], 
     LineBox[{7077, 7078}]}, 
    {Hue[
      NCache[
       Rational[7078, 14307], 0.494722862934228]], AbsoluteThickness[0.25], 
     LineBox[{7078, 7079}]}, 
    {Hue[
      NCache[
       Rational[7079, 14307], 0.49479275878940376`]], AbsoluteThickness[0.25],
      LineBox[{7079, 7080}]}, 
    {Hue[
      NCache[
       Rational[2360, 4769], 0.49486265464457957`]], AbsoluteThickness[0.25], 
     LineBox[{7080, 7081}]}, 
    {Hue[
      NCache[
       Rational[7081, 14307], 0.4949325504997554]], AbsoluteThickness[0.25], 
     LineBox[{7081, 7082}]}, 
    {Hue[
      NCache[
       Rational[7082, 14307], 0.4950024463549311]], AbsoluteThickness[0.25], 
     LineBox[{7082, 7083}]}, 
    {Hue[
      NCache[
       Rational[2361, 4769], 0.49507234221010693`]], AbsoluteThickness[0.25], 
     LineBox[{7083, 7084}]}, 
    {Hue[
      NCache[
       Rational[7084, 14307], 0.49514223806528274`]], AbsoluteThickness[0.25],
      LineBox[{7084, 7085}]}, 
    {Hue[
      NCache[
       Rational[7085, 14307], 0.49521213392045854`]], AbsoluteThickness[0.25],
      LineBox[{7085, 7086}]}, 
    {Hue[
      NCache[
       Rational[2362, 4769], 0.4952820297756343]], AbsoluteThickness[0.25], 
     LineBox[{7086, 7087}]}, 
    {Hue[
      NCache[
       Rational[373, 753], 0.4953519256308101]], AbsoluteThickness[0.25], 
     LineBox[{7087, 7088}]}, 
    {Hue[
      NCache[
       Rational[7088, 14307], 0.4954218214859859]], AbsoluteThickness[0.25], 
     LineBox[{7088, 7089}]}, 
    {Hue[
      NCache[
       Rational[2363, 4769], 0.49549171734116165`]], AbsoluteThickness[0.25], 
     LineBox[{7089, 7090}]}, 
    {Hue[
      NCache[
       Rational[7090, 14307], 0.49556161319633746`]], AbsoluteThickness[0.25],
      LineBox[{7090, 7091}]}, 
    {Hue[
      NCache[
       Rational[7091, 14307], 0.49563150905151326`]], AbsoluteThickness[0.25],
      LineBox[{7091, 7092}]}, 
    {Hue[
      NCache[
       Rational[2364, 4769], 0.495701404906689]], AbsoluteThickness[0.25], 
     LineBox[{7092, 7093}]}, 
    {Hue[
      NCache[
       Rational[7093, 14307], 0.4957713007618648]], AbsoluteThickness[0.25], 
     LineBox[{7093, 7094}]}, 
    {Hue[
      NCache[
       Rational[7094, 14307], 0.4958411966170406]], AbsoluteThickness[0.25], 
     LineBox[{7094, 7095}]}, 
    {Hue[
      NCache[
       Rational[2365, 4769], 0.4959110924722164]], AbsoluteThickness[0.25], 
     LineBox[{7095, 7096}]}, 
    {Hue[
      NCache[
       Rational[7096, 14307], 0.4959809883273922]], AbsoluteThickness[0.25], 
     LineBox[{7096, 7097}]}, 
    {Hue[
      NCache[
       Rational[7097, 14307], 0.496050884182568]], AbsoluteThickness[0.25], 
     LineBox[{7097, 7098}]}, 
    {Hue[
      NCache[
       Rational[2366, 4769], 0.49612078003774374`]], AbsoluteThickness[0.25], 
     LineBox[{7098, 7099}]}, 
    {Hue[
      NCache[
       Rational[7099, 14307], 0.49619067589291954`]], AbsoluteThickness[0.25],
      LineBox[{7099, 7100}]}, 
    {Hue[
      NCache[
       Rational[7100, 14307], 0.49626057174809535`]], AbsoluteThickness[0.25],
      LineBox[{7100, 7101}]}, 
    {Hue[
      NCache[
       Rational[2367, 4769], 0.49633046760327115`]], AbsoluteThickness[0.25], 
     LineBox[{7101, 7102}]}, 
    {Hue[
      NCache[
       Rational[7102, 14307], 0.4964003634584469]], AbsoluteThickness[0.25], 
     LineBox[{7102, 7103}]}, 
    {Hue[
      NCache[
       Rational[7103, 14307], 0.4964702593136227]], AbsoluteThickness[0.25], 
     LineBox[{7103, 7104}]}, 
    {Hue[
      NCache[
       Rational[2368, 4769], 0.4965401551687985]], AbsoluteThickness[0.25], 
     LineBox[{7104, 7105}]}, 
    {Hue[
      NCache[
       Rational[7105, 14307], 0.49661005102397426`]], AbsoluteThickness[0.25],
      LineBox[{7105, 7106}]}, 
    {Hue[
      NCache[
       Rational[374, 753], 0.49667994687915007`]], AbsoluteThickness[0.25], 
     LineBox[{7106, 7107}]}, 
    {Hue[
      NCache[
       Rational[2369, 4769], 0.4967498427343259]], AbsoluteThickness[0.25], 
     LineBox[{7107, 7108}]}, 
    {Hue[
      NCache[
       Rational[7108, 14307], 0.4968197385895016]], AbsoluteThickness[0.25], 
     LineBox[{7108, 7109}]}, 
    {Hue[
      NCache[
       Rational[7109, 14307], 0.49688963444467743`]], AbsoluteThickness[0.25],
      LineBox[{7109, 7110}]}, 
    {Hue[
      NCache[
       Rational[2370, 4769], 0.49695953029985324`]], AbsoluteThickness[0.25], 
     LineBox[{7110, 7111}]}, 
    {Hue[
      NCache[
       Rational[7111, 14307], 0.497029426155029]], AbsoluteThickness[0.25], 
     LineBox[{7111, 7112}]}, 
    {Hue[
      NCache[
       Rational[7112, 14307], 0.4970993220102048]], AbsoluteThickness[0.25], 
     LineBox[{7112, 7113}]}, 
    {Hue[
      NCache[
       Rational[2371, 4769], 0.4971692178653806]], AbsoluteThickness[0.25], 
     LineBox[{7113, 7114}]}, 
    {Hue[
      NCache[
       Rational[7114, 14307], 0.49723911372055635`]], AbsoluteThickness[0.25],
      LineBox[{7114, 7115}]}, 
    {Hue[
      NCache[
       Rational[7115, 14307], 0.49730900957573215`]], AbsoluteThickness[0.25],
      LineBox[{7115, 7116}]}, 
    {Hue[
      NCache[
       Rational[2372, 4769], 0.49737890543090796`]], AbsoluteThickness[0.25], 
     LineBox[{7116, 7117}]}, 
    {Hue[
      NCache[
       Rational[7117, 14307], 0.4974488012860837]], AbsoluteThickness[0.25], 
     LineBox[{7117, 7118}]}, 
    {Hue[
      NCache[
       Rational[7118, 14307], 0.4975186971412595]], AbsoluteThickness[0.25], 
     LineBox[{7118, 7119}]}, 
    {Hue[
      NCache[
       Rational[2373, 4769], 0.4975885929964353]], AbsoluteThickness[0.25], 
     LineBox[{7119, 7120}]}, 
    {Hue[
      NCache[
       Rational[7120, 14307], 0.4976584888516111]], AbsoluteThickness[0.25], 
     LineBox[{7120, 7121}]}, 
    {Hue[
      NCache[
       Rational[7121, 14307], 0.4977283847067869]], AbsoluteThickness[0.25], 
     LineBox[{7121, 7122}]}, 
    {Hue[
      NCache[
       Rational[2374, 4769], 0.4977982805619627]], AbsoluteThickness[0.25], 
     LineBox[{7122, 7123}]}, 
    {Hue[
      NCache[
       Rational[7123, 14307], 0.4978681764171385]], AbsoluteThickness[0.25], 
     LineBox[{7123, 7124}]}, 
    {Hue[
      NCache[
       Rational[7124, 14307], 0.49793807227231424`]], AbsoluteThickness[0.25],
      LineBox[{7124, 7125}]}, 
    {Hue[
      NCache[
       Rational[125, 251], 0.49800796812749004`]], AbsoluteThickness[0.25], 
     LineBox[{7125, 7126}]}, 
    {Hue[
      NCache[
       Rational[7126, 14307], 0.49807786398266585`]], AbsoluteThickness[0.25],
      LineBox[{7126, 7127}]}, 
    {Hue[
      NCache[
       Rational[7127, 14307], 0.4981477598378416]], AbsoluteThickness[0.25], 
     LineBox[{7127, 7128}]}, 
    {Hue[
      NCache[
       Rational[2376, 4769], 0.4982176556930174]], AbsoluteThickness[0.25], 
     LineBox[{7128, 7129}]}, 
    {Hue[
      NCache[
       Rational[7129, 14307], 0.4982875515481932]], AbsoluteThickness[0.25], 
     LineBox[{7129, 7130}]}, 
    {Hue[
      NCache[
       Rational[7130, 14307], 0.49835744740336896`]], AbsoluteThickness[0.25],
      LineBox[{7130, 7131}]}, 
    {Hue[
      NCache[
       Rational[2377, 4769], 0.49842734325854476`]], AbsoluteThickness[0.25], 
     LineBox[{7131, 7132}]}, 
    {Hue[
      NCache[
       Rational[7132, 14307], 0.49849723911372057`]], AbsoluteThickness[0.25],
      LineBox[{7132, 7133}]}, 
    {Hue[
      NCache[
       Rational[7133, 14307], 0.4985671349688963]], AbsoluteThickness[0.25], 
     LineBox[{7133, 7134}]}, 
    {Hue[
      NCache[
       Rational[2378, 4769], 0.4986370308240721]], AbsoluteThickness[0.25], 
     LineBox[{7134, 7135}]}, 
    {Hue[
      NCache[
       Rational[7135, 14307], 0.49870692667924793`]], AbsoluteThickness[0.25],
      LineBox[{7135, 7136}]}, 
    {Hue[
      NCache[
       Rational[7136, 14307], 0.49877682253442374`]], AbsoluteThickness[0.25],
      LineBox[{7136, 7137}]}, 
    {Hue[
      NCache[
       Rational[2379, 4769], 0.4988467183895995]], AbsoluteThickness[0.25], 
     LineBox[{7137, 7138}]}, 
    {Hue[
      NCache[
       Rational[7138, 14307], 0.4989166142447753]], AbsoluteThickness[0.25], 
     LineBox[{7138, 7139}]}, 
    {Hue[
      NCache[
       Rational[7139, 14307], 0.4989865100999511]], AbsoluteThickness[0.25], 
     LineBox[{7139, 7140}]}, 
    {Hue[
      NCache[
       Rational[2380, 4769], 0.49905640595512685`]], AbsoluteThickness[0.25], 
     LineBox[{7140, 7141}]}, 
    {Hue[
      NCache[
       Rational[7141, 14307], 0.49912630181030265`]], AbsoluteThickness[0.25],
      LineBox[{7141, 7142}]}, 
    {Hue[
      NCache[
       Rational[7142, 14307], 0.49919619766547846`]], AbsoluteThickness[0.25],
      LineBox[{7142, 7143}]}, 
    {Hue[
      NCache[
       Rational[2381, 4769], 0.4992660935206542]], AbsoluteThickness[0.25], 
     LineBox[{7143, 7144}]}, 
    {Hue[
      NCache[
       Rational[376, 753], 0.49933598937583]], AbsoluteThickness[0.25], 
     LineBox[{7144, 7145}]}, 
    {Hue[
      NCache[
       Rational[7145, 14307], 0.4994058852310058]], AbsoluteThickness[0.25], 
     LineBox[{7145, 7146}]}, 
    {Hue[
      NCache[
       Rational[2382, 4769], 0.49947578108618157`]], AbsoluteThickness[0.25], 
     LineBox[{7146, 7147}]}, 
    {Hue[
      NCache[
       Rational[7147, 14307], 0.4995456769413574]], AbsoluteThickness[0.25], 
     LineBox[{7147, 7148}]}, 
    {Hue[
      NCache[
       Rational[7148, 14307], 0.4996155727965332]], AbsoluteThickness[0.25], 
     LineBox[{7148, 7149}]}, 
    {Hue[
      NCache[
       Rational[2383, 4769], 0.49968546865170893`]], AbsoluteThickness[0.25], 
     LineBox[{7149, 7150}]}, 
    {Hue[
      NCache[
       Rational[7150, 14307], 0.49975536450688474`]], AbsoluteThickness[0.25],
      LineBox[{7150, 7151}]}, 
    {Hue[
      NCache[
       Rational[7151, 14307], 0.49982526036206054`]], AbsoluteThickness[0.25],
      LineBox[{7151, 7152}]}, 
    {Hue[
      NCache[
       Rational[2384, 4769], 0.4998951562172363]], AbsoluteThickness[0.25], 
     LineBox[{7152, 7153}]}, 
    {Hue[
      NCache[
       Rational[7153, 14307], 0.4999650520724121]], AbsoluteThickness[0.25], 
     LineBox[{7153, 7154}]}, 
    {Hue[
      NCache[
       Rational[7154, 14307], 0.5000349479275878]], AbsoluteThickness[0.25], 
     LineBox[{7154, 7155}]}, 
    {Hue[
      NCache[
       Rational[2385, 4769], 0.5001048437827637]], AbsoluteThickness[0.25], 
     LineBox[{7155, 7156}]}, 
    {Hue[
      NCache[
       Rational[7156, 14307], 0.5001747396379395]], AbsoluteThickness[0.25], 
     LineBox[{7156, 7157}]}, 
    {Hue[
      NCache[
       Rational[7157, 14307], 0.5002446354931153]], AbsoluteThickness[0.25], 
     LineBox[{7157, 7158}]}, 
    {Hue[
      NCache[
       Rational[2386, 4769], 0.5003145313482911]], AbsoluteThickness[0.25], 
     LineBox[{7158, 7159}]}, 
    {Hue[
      NCache[
       Rational[7159, 14307], 0.5003844272034669]], AbsoluteThickness[0.25], 
     LineBox[{7159, 7160}]}, 
    {Hue[
      NCache[
       Rational[7160, 14307], 0.5004543230586426]], AbsoluteThickness[0.25], 
     LineBox[{7160, 7161}]}, 
    {Hue[
      NCache[
       Rational[2387, 4769], 0.5005242189138184]], AbsoluteThickness[0.25], 
     LineBox[{7161, 7162}]}, 
    {Hue[
      NCache[
       Rational[7162, 14307], 0.5005941147689942]], AbsoluteThickness[0.25], 
     LineBox[{7162, 7163}]}, 
    {Hue[
      NCache[
       Rational[377, 753], 0.50066401062417]], AbsoluteThickness[0.25], 
     LineBox[{7163, 7164}]}, 
    {Hue[
      NCache[
       Rational[2388, 4769], 0.5007339064793458]], AbsoluteThickness[0.25], 
     LineBox[{7164, 7165}]}, 
    {Hue[
      NCache[
       Rational[7165, 14307], 0.5008038023345216]], AbsoluteThickness[0.25], 
     LineBox[{7165, 7166}]}, 
    {Hue[
      NCache[
       Rational[7166, 14307], 0.5008736981896974]], AbsoluteThickness[0.25], 
     LineBox[{7166, 7167}]}, 
    {Hue[
      NCache[
       Rational[2389, 4769], 0.5009435940448731]], AbsoluteThickness[0.25], 
     LineBox[{7167, 7168}]}, 
    {Hue[
      NCache[
       Rational[7168, 14307], 0.5010134899000489]], AbsoluteThickness[0.25], 
     LineBox[{7168, 7169}]}, 
    {Hue[
      NCache[
       Rational[7169, 14307], 0.5010833857552247]], AbsoluteThickness[0.25], 
     LineBox[{7169, 7170}]}, 
    {Hue[
      NCache[
       Rational[2390, 4769], 0.5011532816104005]], AbsoluteThickness[0.25], 
     LineBox[{7170, 7171}]}, 
    {Hue[
      NCache[
       Rational[7171, 14307], 0.5012231774655763]], AbsoluteThickness[0.25], 
     LineBox[{7171, 7172}]}, 
    {Hue[
      NCache[
       Rational[7172, 14307], 0.5012930733207521]], AbsoluteThickness[0.25], 
     LineBox[{7172, 7173}]}, 
    {Hue[
      NCache[
       Rational[2391, 4769], 0.5013629691759278]], AbsoluteThickness[0.25], 
     LineBox[{7173, 7174}]}, 
    {Hue[
      NCache[
       Rational[7174, 14307], 0.5014328650311036]], AbsoluteThickness[0.25], 
     LineBox[{7174, 7175}]}, 
    {Hue[
      NCache[
       Rational[7175, 14307], 0.5015027608862794]], AbsoluteThickness[0.25], 
     LineBox[{7175, 7176}]}, 
    {Hue[
      NCache[
       Rational[2392, 4769], 0.5015726567414552]], AbsoluteThickness[0.25], 
     LineBox[{7176, 7177}]}, 
    {Hue[
      NCache[
       Rational[7177, 14307], 0.501642552596631]], AbsoluteThickness[0.25], 
     LineBox[{7177, 7178}]}, 
    {Hue[
      NCache[
       Rational[7178, 14307], 0.5017124484518068]], AbsoluteThickness[0.25], 
     LineBox[{7178, 7179}]}, 
    {Hue[
      NCache[
       Rational[2393, 4769], 0.5017823443069825]], AbsoluteThickness[0.25], 
     LineBox[{7179, 7180}]}, 
    {Hue[
      NCache[
       Rational[7180, 14307], 0.5018522401621583]], AbsoluteThickness[0.25], 
     LineBox[{7180, 7181}]}, 
    {Hue[
      NCache[
       Rational[7181, 14307], 0.5019221360173342]], AbsoluteThickness[0.25], 
     LineBox[{7181, 7182}]}, 
    {Hue[
      NCache[
       Rational[126, 251], 0.50199203187251]], AbsoluteThickness[0.25], 
     LineBox[{7182, 7183}]}, 
    {Hue[
      NCache[
       Rational[7183, 14307], 0.5020619277276858]], AbsoluteThickness[0.25], 
     LineBox[{7183, 7184}]}, 
    {Hue[
      NCache[
       Rational[7184, 14307], 0.5021318235828616]], AbsoluteThickness[0.25], 
     LineBox[{7184, 7185}]}, 
    {Hue[
      NCache[
       Rational[2395, 4769], 0.5022017194380374]], AbsoluteThickness[0.25], 
     LineBox[{7185, 7186}]}, 
    {Hue[
      NCache[
       Rational[7186, 14307], 0.5022716152932131]], AbsoluteThickness[0.25], 
     LineBox[{7186, 7187}]}, 
    {Hue[
      NCache[
       Rational[7187, 14307], 0.5023415111483889]], AbsoluteThickness[0.25], 
     LineBox[{7187, 7188}]}, 
    {Hue[
      NCache[
       Rational[2396, 4769], 0.5024114070035647]], AbsoluteThickness[0.25], 
     LineBox[{7188, 7189}]}, 
    {Hue[
      NCache[
       Rational[7189, 14307], 0.5024813028587405]], AbsoluteThickness[0.25], 
     LineBox[{7189, 7190}]}, 
    {Hue[
      NCache[
       Rational[7190, 14307], 0.5025511987139163]], AbsoluteThickness[0.25], 
     LineBox[{7190, 7191}]}, 
    {Hue[
      NCache[
       Rational[2397, 4769], 0.5026210945690921]], AbsoluteThickness[0.25], 
     LineBox[{7191, 7192}]}, 
    {Hue[
      NCache[
       Rational[7192, 14307], 0.5026909904242678]], AbsoluteThickness[0.25], 
     LineBox[{7192, 7193}]}, 
    {Hue[
      NCache[
       Rational[7193, 14307], 0.5027608862794436]], AbsoluteThickness[0.25], 
     LineBox[{7193, 7194}]}, 
    {Hue[
      NCache[
       Rational[2398, 4769], 0.5028307821346194]], AbsoluteThickness[0.25], 
     LineBox[{7194, 7195}]}, 
    {Hue[
      NCache[
       Rational[7195, 14307], 0.5029006779897952]], AbsoluteThickness[0.25], 
     LineBox[{7195, 7196}]}, 
    {Hue[
      NCache[
       Rational[7196, 14307], 0.502970573844971]], AbsoluteThickness[0.25], 
     LineBox[{7196, 7197}]}, 
    {Hue[
      NCache[
       Rational[2399, 4769], 0.5030404697001468]], AbsoluteThickness[0.25], 
     LineBox[{7197, 7198}]}, 
    {Hue[
      NCache[
       Rational[7198, 14307], 0.5031103655553225]], AbsoluteThickness[0.25], 
     LineBox[{7198, 7199}]}, 
    {Hue[
      NCache[
       Rational[7199, 14307], 0.5031802614104983]], AbsoluteThickness[0.25], 
     LineBox[{7199, 7200}]}, 
    {Hue[
      NCache[
       Rational[2400, 4769], 0.5032501572656741]], AbsoluteThickness[0.25], 
     LineBox[{7200, 7201}]}, 
    {Hue[
      NCache[
       Rational[379, 753], 0.5033200531208499]], AbsoluteThickness[0.25], 
     LineBox[{7201, 7202}]}, 
    {Hue[
      NCache[
       Rational[7202, 14307], 0.5033899489760257]], AbsoluteThickness[0.25], 
     LineBox[{7202, 7203}]}, 
    {Hue[
      NCache[
       Rational[2401, 4769], 0.5034598448312015]], AbsoluteThickness[0.25], 
     LineBox[{7203, 7204}]}, 
    {Hue[
      NCache[
       Rational[7204, 14307], 0.5035297406863773]], AbsoluteThickness[0.25], 
     LineBox[{7204, 7205}]}, 
    {Hue[
      NCache[
       Rational[7205, 14307], 0.503599636541553]], AbsoluteThickness[0.25], 
     LineBox[{7205, 7206}]}, 
    {Hue[
      NCache[
       Rational[2402, 4769], 0.5036695323967288]], AbsoluteThickness[0.25], 
     LineBox[{7206, 7207}]}, 
    {Hue[
      NCache[
       Rational[7207, 14307], 0.5037394282519047]], AbsoluteThickness[0.25], 
     LineBox[{7207, 7208}]}, 
    {Hue[
      NCache[
       Rational[7208, 14307], 0.5038093241070805]], AbsoluteThickness[0.25], 
     LineBox[{7208, 7209}]}, 
    {Hue[
      NCache[
       Rational[2403, 4769], 0.5038792199622563]], AbsoluteThickness[0.25], 
     LineBox[{7209, 7210}]}, 
    {Hue[
      NCache[
       Rational[7210, 14307], 0.5039491158174321]], AbsoluteThickness[0.25], 
     LineBox[{7210, 7211}]}, 
    {Hue[
      NCache[
       Rational[7211, 14307], 0.5040190116726078]], AbsoluteThickness[0.25], 
     LineBox[{7211, 7212}]}, 
    {Hue[
      NCache[
       Rational[2404, 4769], 0.5040889075277836]], AbsoluteThickness[0.25], 
     LineBox[{7212, 7213}]}, 
    {Hue[
      NCache[
       Rational[7213, 14307], 0.5041588033829594]], AbsoluteThickness[0.25], 
     LineBox[{7213, 7214}]}, 
    {Hue[
      NCache[
       Rational[7214, 14307], 0.5042286992381352]], AbsoluteThickness[0.25], 
     LineBox[{7214, 7215}]}, 
    {Hue[
      NCache[
       Rational[2405, 4769], 0.504298595093311]], AbsoluteThickness[0.25], 
     LineBox[{7215, 7216}]}, 
    {Hue[
      NCache[
       Rational[7216, 14307], 0.5043684909484868]], AbsoluteThickness[0.25], 
     LineBox[{7216, 7217}]}, 
    {Hue[
      NCache[
       Rational[7217, 14307], 0.5044383868036626]], AbsoluteThickness[0.25], 
     LineBox[{7217, 7218}]}, 
    {Hue[
      NCache[
       Rational[2406, 4769], 0.5045082826588383]], AbsoluteThickness[0.25], 
     LineBox[{7218, 7219}]}, 
    {Hue[
      NCache[
       Rational[7219, 14307], 0.5045781785140141]], AbsoluteThickness[0.25], 
     LineBox[{7219, 7220}]}, 
    {Hue[
      NCache[
       Rational[380, 753], 0.5046480743691899]], AbsoluteThickness[0.25], 
     LineBox[{7220, 7221}]}, 
    {Hue[
      NCache[
       Rational[2407, 4769], 0.5047179702243657]], AbsoluteThickness[0.25], 
     LineBox[{7221, 7222}]}, 
    {Hue[
      NCache[
       Rational[7222, 14307], 0.5047878660795415]], AbsoluteThickness[0.25], 
     LineBox[{7222, 7223}]}, 
    {Hue[
      NCache[
       Rational[7223, 14307], 0.5048577619347173]], AbsoluteThickness[0.25], 
     LineBox[{7223, 7224}]}, 
    {Hue[
      NCache[
       Rational[2408, 4769], 0.504927657789893]], AbsoluteThickness[0.25], 
     LineBox[{7224, 7225}]}, 
    {Hue[
      NCache[
       Rational[7225, 14307], 0.5049975536450688]], AbsoluteThickness[0.25], 
     LineBox[{7225, 7226}]}, 
    {Hue[
      NCache[
       Rational[7226, 14307], 0.5050674495002446]], AbsoluteThickness[0.25], 
     LineBox[{7226, 7227}]}, 
    {Hue[
      NCache[
       Rational[2409, 4769], 0.5051373453554204]], AbsoluteThickness[0.25], 
     LineBox[{7227, 7228}]}, 
    {Hue[
      NCache[
       Rational[7228, 14307], 0.5052072412105962]], AbsoluteThickness[0.25], 
     LineBox[{7228, 7229}]}, 
    {Hue[
      NCache[
       Rational[7229, 14307], 0.505277137065772]], AbsoluteThickness[0.25], 
     LineBox[{7229, 7230}]}, 
    {Hue[
      NCache[
       Rational[2410, 4769], 0.5053470329209477]], AbsoluteThickness[0.25], 
     LineBox[{7230, 7231}]}, 
    {Hue[
      NCache[
       Rational[7231, 14307], 0.5054169287761235]], AbsoluteThickness[0.25], 
     LineBox[{7231, 7232}]}, 
    {Hue[
      NCache[
       Rational[7232, 14307], 0.5054868246312993]], AbsoluteThickness[0.25], 
     LineBox[{7232, 7233}]}, 
    {Hue[
      NCache[
       Rational[2411, 4769], 0.5055567204864752]], AbsoluteThickness[0.25], 
     LineBox[{7233, 7234}]}, 
    {Hue[
      NCache[
       Rational[7234, 14307], 0.505626616341651]], AbsoluteThickness[0.25], 
     LineBox[{7234, 7235}]}, 
    {Hue[
      NCache[
       Rational[7235, 14307], 0.5056965121968268]], AbsoluteThickness[0.25], 
     LineBox[{7235, 7236}]}, 
    {Hue[
      NCache[
       Rational[2412, 4769], 0.5057664080520026]], AbsoluteThickness[0.25], 
     LineBox[{7236, 7237}]}, 
    {Hue[
      NCache[
       Rational[7237, 14307], 0.5058363039071783]], AbsoluteThickness[0.25], 
     LineBox[{7237, 7238}]}, 
    {Hue[
      NCache[
       Rational[7238, 14307], 0.5059061997623541]], AbsoluteThickness[0.25], 
     LineBox[{7238, 7239}]}, 
    {Hue[
      NCache[
       Rational[127, 251], 0.5059760956175299]], AbsoluteThickness[0.25], 
     LineBox[{7239, 7240}]}, 
    {Hue[
      NCache[
       Rational[7240, 14307], 0.5060459914727057]], AbsoluteThickness[0.25], 
     LineBox[{7240, 7241}]}, 
    {Hue[
      NCache[
       Rational[7241, 14307], 0.5061158873278815]], AbsoluteThickness[0.25], 
     LineBox[{7241, 7242}]}, 
    {Hue[
      NCache[
       Rational[2414, 4769], 0.5061857831830573]], AbsoluteThickness[0.25], 
     LineBox[{7242, 7243}]}, 
    {Hue[
      NCache[
       Rational[7243, 14307], 0.506255679038233]], AbsoluteThickness[0.25], 
     LineBox[{7243, 7244}]}, 
    {Hue[
      NCache[
       Rational[7244, 14307], 0.5063255748934088]], AbsoluteThickness[0.25], 
     LineBox[{7244, 7245}]}, 
    {Hue[
      NCache[
       Rational[2415, 4769], 0.5063954707485846]], AbsoluteThickness[0.25], 
     LineBox[{7245, 7246}]}, 
    {Hue[
      NCache[
       Rational[7246, 14307], 0.5064653666037604]], AbsoluteThickness[0.25], 
     LineBox[{7246, 7247}]}, 
    {Hue[
      NCache[
       Rational[7247, 14307], 0.5065352624589362]], AbsoluteThickness[0.25], 
     LineBox[{7247, 7248}]}, 
    {Hue[
      NCache[
       Rational[2416, 4769], 0.506605158314112]], AbsoluteThickness[0.25], 
     LineBox[{7248, 7249}]}, 
    {Hue[
      NCache[
       Rational[7249, 14307], 0.5066750541692877]], AbsoluteThickness[0.25], 
     LineBox[{7249, 7250}]}, 
    {Hue[
      NCache[
       Rational[7250, 14307], 0.5067449500244635]], AbsoluteThickness[0.25], 
     LineBox[{7250, 7251}]}, 
    {Hue[
      NCache[
       Rational[2417, 4769], 0.5068148458796393]], AbsoluteThickness[0.25], 
     LineBox[{7251, 7252}]}, 
    {Hue[
      NCache[
       Rational[7252, 14307], 0.5068847417348151]], AbsoluteThickness[0.25], 
     LineBox[{7252, 7253}]}, 
    {Hue[
      NCache[
       Rational[7253, 14307], 0.5069546375899909]], AbsoluteThickness[0.25], 
     LineBox[{7253, 7254}]}, 
    {Hue[
      NCache[
       Rational[2418, 4769], 0.5070245334451667]], AbsoluteThickness[0.25], 
     LineBox[{7254, 7255}]}, 
    {Hue[
      NCache[
       Rational[7255, 14307], 0.5070944293003425]], AbsoluteThickness[0.25], 
     LineBox[{7255, 7256}]}, 
    {Hue[
      NCache[
       Rational[7256, 14307], 0.5071643251555182]], AbsoluteThickness[0.25], 
     LineBox[{7256, 7257}]}, 
    {Hue[
      NCache[
       Rational[2419, 4769], 0.507234221010694]], AbsoluteThickness[0.25], 
     LineBox[{7257, 7258}]}, 
    {Hue[
      NCache[
       Rational[382, 753], 0.5073041168658698]], AbsoluteThickness[0.25], 
     LineBox[{7258, 7259}]}, 
    {Hue[
      NCache[
       Rational[7259, 14307], 0.5073740127210457]], AbsoluteThickness[0.25], 
     LineBox[{7259, 7260}]}, 
    {Hue[
      NCache[
       Rational[2420, 4769], 0.5074439085762215]], AbsoluteThickness[0.25], 
     LineBox[{7260, 7261}]}, 
    {Hue[
      NCache[
       Rational[7261, 14307], 0.5075138044313973]], AbsoluteThickness[0.25], 
     LineBox[{7261, 7262}]}, 
    {Hue[
      NCache[
       Rational[7262, 14307], 0.507583700286573]], AbsoluteThickness[0.25], 
     LineBox[{7262, 7263}]}, 
    {Hue[
      NCache[
       Rational[2421, 4769], 0.5076535961417488]], AbsoluteThickness[0.25], 
     LineBox[{7263, 7264}]}, 
    {Hue[
      NCache[
       Rational[7264, 14307], 0.5077234919969246]], AbsoluteThickness[0.25], 
     LineBox[{7264, 7265}]}, 
    {Hue[
      NCache[
       Rational[7265, 14307], 0.5077933878521004]], AbsoluteThickness[0.25], 
     LineBox[{7265, 7266}]}, 
    {Hue[
      NCache[
       Rational[2422, 4769], 0.5078632837072762]], AbsoluteThickness[0.25], 
     LineBox[{7266, 7267}]}, 
    {Hue[
      NCache[
       Rational[7267, 14307], 0.507933179562452]], AbsoluteThickness[0.25], 
     LineBox[{7267, 7268}]}, 
    {Hue[
      NCache[
       Rational[7268, 14307], 0.5080030754176277]], AbsoluteThickness[0.25], 
     LineBox[{7268, 7269}]}, 
    {Hue[
      NCache[
       Rational[2423, 4769], 0.5080729712728035]], AbsoluteThickness[0.25], 
     LineBox[{7269, 7270}]}, 
    {Hue[
      NCache[
       Rational[7270, 14307], 0.5081428671279793]], AbsoluteThickness[0.25], 
     LineBox[{7270, 7271}]}, 
    {Hue[
      NCache[
       Rational[7271, 14307], 0.5082127629831551]], AbsoluteThickness[0.25], 
     LineBox[{7271, 7272}]}, 
    {Hue[
      NCache[
       Rational[2424, 4769], 0.5082826588383309]], AbsoluteThickness[0.25], 
     LineBox[{7272, 7273}]}, 
    {Hue[
      NCache[
       Rational[7273, 14307], 0.5083525546935067]], AbsoluteThickness[0.25], 
     LineBox[{7273, 7274}]}, 
    {Hue[
      NCache[
       Rational[7274, 14307], 0.5084224505486825]], AbsoluteThickness[0.25], 
     LineBox[{7274, 7275}]}, 
    {Hue[
      NCache[
       Rational[2425, 4769], 0.5084923464038582]], AbsoluteThickness[0.25], 
     LineBox[{7275, 7276}]}, 
    {Hue[
      NCache[
       Rational[7276, 14307], 0.508562242259034]], AbsoluteThickness[0.25], 
     LineBox[{7276, 7277}]}, 
    {Hue[
      NCache[
       Rational[383, 753], 0.5086321381142098]], AbsoluteThickness[0.25], 
     LineBox[{7277, 7278}]}, 
    {Hue[
      NCache[
       Rational[2426, 4769], 0.5087020339693856]], AbsoluteThickness[0.25], 
     LineBox[{7278, 7279}]}, 
    {Hue[
      NCache[
       Rational[29, 57], 0.5087719298245614]], AbsoluteThickness[0.25], 
     LineBox[{7279, 7280}]}, 
    {Hue[
      NCache[
       Rational[7280, 14307], 0.5088418256797372]], AbsoluteThickness[0.25], 
     LineBox[{7280, 7281}]}, 
    {Hue[
      NCache[
       Rational[2427, 4769], 0.5089117215349129]], AbsoluteThickness[0.25], 
     LineBox[{7281, 7282}]}, 
    {Hue[
      NCache[
       Rational[7282, 14307], 0.5089816173900887]], AbsoluteThickness[0.25], 
     LineBox[{7282, 7283}]}, 
    {Hue[
      NCache[
       Rational[7283, 14307], 0.5090515132452645]], AbsoluteThickness[0.25], 
     LineBox[{7283, 7284}]}, 
    {Hue[
      NCache[
       Rational[2428, 4769], 0.5091214091004403]], AbsoluteThickness[0.25], 
     LineBox[{7284, 7285}]}, 
    {Hue[
      NCache[
       Rational[7285, 14307], 0.5091913049556162]], AbsoluteThickness[0.25], 
     LineBox[{7285, 7286}]}, 
    {Hue[
      NCache[
       Rational[7286, 14307], 0.509261200810792]], AbsoluteThickness[0.25], 
     LineBox[{7286, 7287}]}, 
    {Hue[
      NCache[
       Rational[2429, 4769], 0.5093310966659677]], AbsoluteThickness[0.25], 
     LineBox[{7287, 7288}]}, 
    {Hue[
      NCache[
       Rational[7288, 14307], 0.5094009925211435]], AbsoluteThickness[0.25], 
     LineBox[{7288, 7289}]}, 
    {Hue[
      NCache[
       Rational[7289, 14307], 0.5094708883763193]], AbsoluteThickness[0.25], 
     LineBox[{7289, 7290}]}, 
    {Hue[
      NCache[
       Rational[2430, 4769], 0.5095407842314951]], AbsoluteThickness[0.25], 
     LineBox[{7290, 7291}]}, 
    {Hue[
      NCache[
       Rational[7291, 14307], 0.5096106800866709]], AbsoluteThickness[0.25], 
     LineBox[{7291, 7292}]}, 
    {Hue[
      NCache[
       Rational[7292, 14307], 0.5096805759418467]], AbsoluteThickness[0.25], 
     LineBox[{7292, 7293}]}, 
    {Hue[
      NCache[
       Rational[2431, 4769], 0.5097504717970225]], AbsoluteThickness[0.25], 
     LineBox[{7293, 7294}]}, 
    {Hue[
      NCache[
       Rational[7294, 14307], 0.5098203676521982]], AbsoluteThickness[0.25], 
     LineBox[{7294, 7295}]}, 
    {Hue[
      NCache[
       Rational[7295, 14307], 0.509890263507374]], AbsoluteThickness[0.25], 
     LineBox[{7295, 7296}]}, 
    {Hue[
      NCache[
       Rational[128, 251], 0.5099601593625498]], AbsoluteThickness[0.25], 
     LineBox[{7296, 7297}]}, 
    {Hue[
      NCache[
       Rational[7297, 14307], 0.5100300552177256]], AbsoluteThickness[0.25], 
     LineBox[{7297, 7298}]}, 
    {Hue[
      NCache[
       Rational[7298, 14307], 0.5100999510729014]], AbsoluteThickness[0.25], 
     LineBox[{7298, 7299}]}, 
    {Hue[
      NCache[
       Rational[2433, 4769], 0.5101698469280772]], AbsoluteThickness[0.25], 
     LineBox[{7299, 7300}]}, 
    {Hue[
      NCache[
       Rational[7300, 14307], 0.5102397427832529]], AbsoluteThickness[0.25], 
     LineBox[{7300, 7301}]}, 
    {Hue[
      NCache[
       Rational[7301, 14307], 0.5103096386384287]], AbsoluteThickness[0.25], 
     LineBox[{7301, 7302}]}, 
    {Hue[
      NCache[
       Rational[2434, 4769], 0.5103795344936045]], AbsoluteThickness[0.25], 
     LineBox[{7302, 7303}]}, 
    {Hue[
      NCache[
       Rational[7303, 14307], 0.5104494303487803]], AbsoluteThickness[0.25], 
     LineBox[{7303, 7304}]}, 
    {Hue[
      NCache[
       Rational[7304, 14307], 0.5105193262039561]], AbsoluteThickness[0.25], 
     LineBox[{7304, 7305}]}, 
    {Hue[
      NCache[
       Rational[2435, 4769], 0.5105892220591319]], AbsoluteThickness[0.25], 
     LineBox[{7305, 7306}]}, 
    {Hue[
      NCache[
       Rational[7306, 14307], 0.5106591179143077]], AbsoluteThickness[0.25], 
     LineBox[{7306, 7307}]}, 
    {Hue[
      NCache[
       Rational[7307, 14307], 0.5107290137694834]], AbsoluteThickness[0.25], 
     LineBox[{7307, 7308}]}, 
    {Hue[
      NCache[
       Rational[2436, 4769], 0.5107989096246592]], AbsoluteThickness[0.25], 
     LineBox[{7308, 7309}]}, 
    {Hue[
      NCache[
       Rational[7309, 14307], 0.510868805479835]], AbsoluteThickness[0.25], 
     LineBox[{7309, 7310}]}, 
    {Hue[
      NCache[
       Rational[7310, 14307], 0.5109387013350108]], AbsoluteThickness[0.25], 
     LineBox[{7310, 7311}]}, 
    {Hue[
      NCache[
       Rational[2437, 4769], 0.5110085971901867]], AbsoluteThickness[0.25], 
     LineBox[{7311, 7312}]}, 
    {Hue[
      NCache[
       Rational[7312, 14307], 0.5110784930453625]], AbsoluteThickness[0.25], 
     LineBox[{7312, 7313}]}, 
    {Hue[
      NCache[
       Rational[7313, 14307], 0.5111483889005382]], AbsoluteThickness[0.25], 
     LineBox[{7313, 7314}]}, 
    {Hue[
      NCache[
       Rational[2438, 4769], 0.511218284755714]], AbsoluteThickness[0.25], 
     LineBox[{7314, 7315}]}, 
    {Hue[
      NCache[
       Rational[385, 753], 0.5112881806108898]], AbsoluteThickness[0.25], 
     LineBox[{7315, 7316}]}, 
    {Hue[
      NCache[
       Rational[7316, 14307], 0.5113580764660656]], AbsoluteThickness[0.25], 
     LineBox[{7316, 7317}]}, 
    {Hue[
      NCache[
       Rational[2439, 4769], 0.5114279723212414]], AbsoluteThickness[0.25], 
     LineBox[{7317, 7318}]}, 
    {Hue[
      NCache[
       Rational[7318, 14307], 0.5114978681764172]], AbsoluteThickness[0.25], 
     LineBox[{7318, 7319}]}, 
    {Hue[
      NCache[
       Rational[7319, 14307], 0.5115677640315929]], AbsoluteThickness[0.25], 
     LineBox[{7319, 7320}]}, 
    {Hue[
      NCache[
       Rational[2440, 4769], 0.5116376598867687]], AbsoluteThickness[0.25], 
     LineBox[{7320, 7321}]}, 
    {Hue[
      NCache[
       Rational[7321, 14307], 0.5117075557419445]], AbsoluteThickness[0.25], 
     LineBox[{7321, 7322}]}, 
    {Hue[
      NCache[
       Rational[7322, 14307], 0.5117774515971203]], AbsoluteThickness[0.25], 
     LineBox[{7322, 7323}]}, 
    {Hue[
      NCache[
       Rational[2441, 4769], 0.5118473474522961]], AbsoluteThickness[0.25], 
     LineBox[{7323, 7324}]}, 
    {Hue[
      NCache[
       Rational[7324, 14307], 0.5119172433074719]], AbsoluteThickness[0.25], 
     LineBox[{7324, 7325}]}, 
    {Hue[
      NCache[
       Rational[7325, 14307], 0.5119871391626477]], AbsoluteThickness[0.25], 
     LineBox[{7325, 7326}]}, 
    {Hue[
      NCache[
       Rational[2442, 4769], 0.5120570350178234]], AbsoluteThickness[0.25], 
     LineBox[{7326, 7327}]}, 
    {Hue[
      NCache[
       Rational[7327, 14307], 0.5121269308729992]], AbsoluteThickness[0.25], 
     LineBox[{7327, 7328}]}, 
    {Hue[
      NCache[
       Rational[7328, 14307], 0.512196826728175]], AbsoluteThickness[0.25], 
     LineBox[{7328, 7329}]}, 
    {Hue[
      NCache[
       Rational[2443, 4769], 0.5122667225833508]], AbsoluteThickness[0.25], 
     LineBox[{7329, 7330}]}, 
    {Hue[
      NCache[
       Rational[7330, 14307], 0.5123366184385266]], AbsoluteThickness[0.25], 
     LineBox[{7330, 7331}]}, 
    {Hue[
      NCache[
       Rational[7331, 14307], 0.5124065142937024]], AbsoluteThickness[0.25], 
     LineBox[{7331, 7332}]}, 
    {Hue[
      NCache[
       Rational[2444, 4769], 0.5124764101488781]], AbsoluteThickness[0.25], 
     LineBox[{7332, 7333}]}, 
    {Hue[
      NCache[
       Rational[7333, 14307], 0.5125463060040539]], AbsoluteThickness[0.25], 
     LineBox[{7333, 7334}]}, 
    {Hue[
      NCache[
       Rational[386, 753], 0.5126162018592297]], AbsoluteThickness[0.25], 
     LineBox[{7334, 7335}]}, 
    {Hue[
      NCache[
       Rational[2445, 4769], 0.5126860977144055]], AbsoluteThickness[0.25], 
     LineBox[{7335, 7336}]}, 
    {Hue[
      NCache[
       Rational[7336, 14307], 0.5127559935695813]], AbsoluteThickness[0.25], 
     LineBox[{7336, 7337}]}, 
    {Hue[
      NCache[
       Rational[7337, 14307], 0.5128258894247572]], AbsoluteThickness[0.25], 
     LineBox[{7337, 7338}]}, 
    {Hue[
      NCache[
       Rational[2446, 4769], 0.5128957852799328]], AbsoluteThickness[0.25], 
     LineBox[{7338, 7339}]}, 
    {Hue[
      NCache[
       Rational[7339, 14307], 0.5129656811351087]], AbsoluteThickness[0.25], 
     LineBox[{7339, 7340}]}, 
    {Hue[
      NCache[
       Rational[7340, 14307], 0.5130355769902845]], AbsoluteThickness[0.25], 
     LineBox[{7340, 7341}]}, 
    {Hue[
      NCache[
       Rational[2447, 4769], 0.5131054728454603]], AbsoluteThickness[0.25], 
     LineBox[{7341, 7342}]}, 
    {Hue[
      NCache[
       Rational[7342, 14307], 0.5131753687006361]], AbsoluteThickness[0.25], 
     LineBox[{7342, 7343}]}, 
    {Hue[
      NCache[
       Rational[7343, 14307], 0.5132452645558119]], AbsoluteThickness[0.25], 
     LineBox[{7343, 7344}]}, 
    {Hue[
      NCache[
       Rational[2448, 4769], 0.5133151604109877]], AbsoluteThickness[0.25], 
     LineBox[{7344, 7345}]}, 
    {Hue[
      NCache[
       Rational[7345, 14307], 0.5133850562661634]], AbsoluteThickness[0.25], 
     LineBox[{7345, 7346}]}, 
    {Hue[
      NCache[
       Rational[7346, 14307], 0.5134549521213392]], AbsoluteThickness[0.25], 
     LineBox[{7346, 7347}]}, 
    {Hue[
      NCache[
       Rational[2449, 4769], 0.513524847976515]], AbsoluteThickness[0.25], 
     LineBox[{7347, 7348}]}, 
    {Hue[
      NCache[
       Rational[7348, 14307], 0.5135947438316908]], AbsoluteThickness[0.25], 
     LineBox[{7348, 7349}]}, 
    {Hue[
      NCache[
       Rational[7349, 14307], 0.5136646396868666]], AbsoluteThickness[0.25], 
     LineBox[{7349, 7350}]}, 
    {Hue[
      NCache[
       Rational[2450, 4769], 0.5137345355420424]], AbsoluteThickness[0.25], 
     LineBox[{7350, 7351}]}, 
    {Hue[
      NCache[
       Rational[7351, 14307], 0.5138044313972181]], AbsoluteThickness[0.25], 
     LineBox[{7351, 7352}]}, 
    {Hue[
      NCache[
       Rational[7352, 14307], 0.5138743272523939]], AbsoluteThickness[0.25], 
     LineBox[{7352, 7353}]}, 
    {Hue[
      NCache[
       Rational[129, 251], 0.5139442231075697]], AbsoluteThickness[0.25], 
     LineBox[{7353, 7354}]}, 
    {Hue[
      NCache[
       Rational[7354, 14307], 0.5140141189627455]], AbsoluteThickness[0.25], 
     LineBox[{7354, 7355}]}, 
    {Hue[
      NCache[
       Rational[7355, 14307], 0.5140840148179213]], AbsoluteThickness[0.25], 
     LineBox[{7355, 7356}]}, 
    {Hue[
      NCache[
       Rational[2452, 4769], 0.5141539106730971]], AbsoluteThickness[0.25], 
     LineBox[{7356, 7357}]}, 
    {Hue[
      NCache[
       Rational[7357, 14307], 0.5142238065282728]], AbsoluteThickness[0.25], 
     LineBox[{7357, 7358}]}, 
    {Hue[
      NCache[
       Rational[7358, 14307], 0.5142937023834486]], AbsoluteThickness[0.25], 
     LineBox[{7358, 7359}]}, 
    {Hue[
      NCache[
       Rational[2453, 4769], 0.5143635982386244]], AbsoluteThickness[0.25], 
     LineBox[{7359, 7360}]}, 
    {Hue[
      NCache[
       Rational[7360, 14307], 0.5144334940938002]], AbsoluteThickness[0.25], 
     LineBox[{7360, 7361}]}, 
    {Hue[
      NCache[
       Rational[7361, 14307], 0.514503389948976]], AbsoluteThickness[0.25], 
     LineBox[{7361, 7362}]}, 
    {Hue[
      NCache[
       Rational[2454, 4769], 0.5145732858041518]], AbsoluteThickness[0.25], 
     LineBox[{7362, 7363}]}, 
    {Hue[
      NCache[
       Rational[7363, 14307], 0.5146431816593277]], AbsoluteThickness[0.25], 
     LineBox[{7363, 7364}]}, 
    {Hue[
      NCache[
       Rational[7364, 14307], 0.5147130775145033]], AbsoluteThickness[0.25], 
     LineBox[{7364, 7365}]}, 
    {Hue[
      NCache[
       Rational[2455, 4769], 0.5147829733696792]], AbsoluteThickness[0.25], 
     LineBox[{7365, 7366}]}, 
    {Hue[
      NCache[
       Rational[7366, 14307], 0.514852869224855]], AbsoluteThickness[0.25], 
     LineBox[{7366, 7367}]}, 
    {Hue[
      NCache[
       Rational[7367, 14307], 0.5149227650800308]], AbsoluteThickness[0.25], 
     LineBox[{7367, 7368}]}, 
    {Hue[
      NCache[
       Rational[2456, 4769], 0.5149926609352066]], AbsoluteThickness[0.25], 
     LineBox[{7368, 7369}]}, 
    {Hue[
      NCache[
       Rational[7369, 14307], 0.5150625567903824]], AbsoluteThickness[0.25], 
     LineBox[{7369, 7370}]}, 
    {Hue[
      NCache[
       Rational[7370, 14307], 0.5151324526455581]], AbsoluteThickness[0.25], 
     LineBox[{7370, 7371}]}, 
    {Hue[
      NCache[
       Rational[2457, 4769], 0.5152023485007339]], AbsoluteThickness[0.25], 
     LineBox[{7371, 7372}]}, 
    {Hue[
      NCache[
       Rational[388, 753], 0.5152722443559097]], AbsoluteThickness[0.25], 
     LineBox[{7372, 7373}]}, 
    {Hue[
      NCache[
       Rational[7373, 14307], 0.5153421402110855]], AbsoluteThickness[0.25], 
     LineBox[{7373, 7374}]}, 
    {Hue[
      NCache[
       Rational[2458, 4769], 0.5154120360662613]], AbsoluteThickness[0.25], 
     LineBox[{7374, 7375}]}, 
    {Hue[
      NCache[
       Rational[7375, 14307], 0.5154819319214371]], AbsoluteThickness[0.25], 
     LineBox[{7375, 7376}]}, 
    {Hue[
      NCache[
       Rational[7376, 14307], 0.5155518277766128]], AbsoluteThickness[0.25], 
     LineBox[{7376, 7377}]}, 
    {Hue[
      NCache[
       Rational[2459, 4769], 0.5156217236317886]], AbsoluteThickness[0.25], 
     LineBox[{7377, 7378}]}, 
    {Hue[
      NCache[
       Rational[7378, 14307], 0.5156916194869644]], AbsoluteThickness[0.25], 
     LineBox[{7378, 7379}]}, 
    {Hue[
      NCache[
       Rational[7379, 14307], 0.5157615153421402]], AbsoluteThickness[0.25], 
     LineBox[{7379, 7380}]}, 
    {Hue[
      NCache[
       Rational[2460, 4769], 0.515831411197316]], AbsoluteThickness[0.25], 
     LineBox[{7380, 7381}]}, 
    {Hue[
      NCache[
       Rational[7381, 14307], 0.5159013070524918]], AbsoluteThickness[0.25], 
     LineBox[{7381, 7382}]}, 
    {Hue[
      NCache[
       Rational[7382, 14307], 0.5159712029076676]], AbsoluteThickness[0.25], 
     LineBox[{7382, 7383}]}, 
    {Hue[
      NCache[
       Rational[2461, 4769], 0.5160410987628433]], AbsoluteThickness[0.25], 
     LineBox[{7383, 7384}]}, 
    {Hue[
      NCache[
       Rational[7384, 14307], 0.5161109946180191]], AbsoluteThickness[0.25], 
     LineBox[{7384, 7385}]}, 
    {Hue[
      NCache[
       Rational[7385, 14307], 0.5161808904731949]], AbsoluteThickness[0.25], 
     LineBox[{7385, 7386}]}, 
    {Hue[
      NCache[
       Rational[2462, 4769], 0.5162507863283707]], AbsoluteThickness[0.25], 
     LineBox[{7386, 7387}]}, 
    {Hue[
      NCache[
       Rational[7387, 14307], 0.5163206821835465]], AbsoluteThickness[0.25], 
     LineBox[{7387, 7388}]}, 
    {Hue[
      NCache[
       Rational[7388, 14307], 0.5163905780387223]], AbsoluteThickness[0.25], 
     LineBox[{7388, 7389}]}, 
    {Hue[
      NCache[
       Rational[2463, 4769], 0.516460473893898]], AbsoluteThickness[0.25], 
     LineBox[{7389, 7390}]}, 
    {Hue[
      NCache[
       Rational[7390, 14307], 0.5165303697490738]], AbsoluteThickness[0.25], 
     LineBox[{7390, 7391}]}, 
    {Hue[
      NCache[
       Rational[389, 753], 0.5166002656042497]], AbsoluteThickness[0.25], 
     LineBox[{7391, 7392}]}, 
    {Hue[
      NCache[
       Rational[2464, 4769], 0.5166701614594255]], AbsoluteThickness[0.25], 
     LineBox[{7392, 7393}]}, 
    {Hue[
      NCache[
       Rational[7393, 14307], 0.5167400573146013]], AbsoluteThickness[0.25], 
     LineBox[{7393, 7394}]}, 
    {Hue[
      NCache[
       Rational[7394, 14307], 0.5168099531697771]], AbsoluteThickness[0.25], 
     LineBox[{7394, 7395}]}, 
    {Hue[
      NCache[
       Rational[2465, 4769], 0.5168798490249529]], AbsoluteThickness[0.25], 
     LineBox[{7395, 7396}]}, 
    {Hue[
      NCache[
       Rational[7396, 14307], 0.5169497448801286]], AbsoluteThickness[0.25], 
     LineBox[{7396, 7397}]}, 
    {Hue[
      NCache[
       Rational[7397, 14307], 0.5170196407353044]], AbsoluteThickness[0.25], 
     LineBox[{7397, 7398}]}, 
    {Hue[
      NCache[
       Rational[2466, 4769], 0.5170895365904802]], AbsoluteThickness[0.25], 
     LineBox[{7398, 7399}]}, 
    {Hue[
      NCache[
       Rational[7399, 14307], 0.517159432445656]], AbsoluteThickness[0.25], 
     LineBox[{7399, 7400}]}, 
    {Hue[
      NCache[
       Rational[7400, 14307], 0.5172293283008318]], AbsoluteThickness[0.25], 
     LineBox[{7400, 7401}]}, 
    {Hue[
      NCache[
       Rational[2467, 4769], 0.5172992241560076]], AbsoluteThickness[0.25], 
     LineBox[{7401, 7402}]}, 
    {Hue[
      NCache[
       Rational[7402, 14307], 0.5173691200111833]], AbsoluteThickness[0.25], 
     LineBox[{7402, 7403}]}, 
    {Hue[
      NCache[
       Rational[7403, 14307], 0.5174390158663591]], AbsoluteThickness[0.25], 
     LineBox[{7403, 7404}]}, 
    {Hue[
      NCache[
       Rational[2468, 4769], 0.5175089117215349]], AbsoluteThickness[0.25], 
     LineBox[{7404, 7405}]}, 
    {Hue[
      NCache[
       Rational[7405, 14307], 0.5175788075767107]], AbsoluteThickness[0.25], 
     LineBox[{7405, 7406}]}, 
    {Hue[
      NCache[
       Rational[7406, 14307], 0.5176487034318865]], AbsoluteThickness[0.25], 
     LineBox[{7406, 7407}]}, 
    {Hue[
      NCache[
       Rational[2469, 4769], 0.5177185992870623]], AbsoluteThickness[0.25], 
     LineBox[{7407, 7408}]}, 
    {Hue[
      NCache[
       Rational[7408, 14307], 0.517788495142238]], AbsoluteThickness[0.25], 
     LineBox[{7408, 7409}]}, 
    {Hue[
      NCache[
       Rational[7409, 14307], 0.5178583909974138]], AbsoluteThickness[0.25], 
     LineBox[{7409, 7410}]}, 
    {Hue[
      NCache[
       Rational[130, 251], 0.5179282868525896]], AbsoluteThickness[0.25], 
     LineBox[{7410, 7411}]}, 
    {Hue[
      NCache[
       Rational[7411, 14307], 0.5179981827077654]], AbsoluteThickness[0.25], 
     LineBox[{7411, 7412}]}, 
    {Hue[
      NCache[
       Rational[7412, 14307], 0.5180680785629412]], AbsoluteThickness[0.25], 
     LineBox[{7412, 7413}]}, 
    {Hue[
      NCache[
       Rational[2471, 4769], 0.518137974418117]], AbsoluteThickness[0.25], 
     LineBox[{7413, 7414}]}, 
    {Hue[
      NCache[
       Rational[7414, 14307], 0.5182078702732928]], AbsoluteThickness[0.25], 
     LineBox[{7414, 7415}]}, 
    {Hue[
      NCache[
       Rational[7415, 14307], 0.5182777661284685]], AbsoluteThickness[0.25], 
     LineBox[{7415, 7416}]}, 
    {Hue[
      NCache[
       Rational[2472, 4769], 0.5183476619836443]], AbsoluteThickness[0.25], 
     LineBox[{7416, 7417}]}, 
    {Hue[
      NCache[
       Rational[7417, 14307], 0.5184175578388202]], AbsoluteThickness[0.25], 
     LineBox[{7417, 7418}]}, 
    {Hue[
      NCache[
       Rational[7418, 14307], 0.518487453693996]], AbsoluteThickness[0.25], 
     LineBox[{7418, 7419}]}, 
    {Hue[
      NCache[
       Rational[2473, 4769], 0.5185573495491718]], AbsoluteThickness[0.25], 
     LineBox[{7419, 7420}]}, 
    {Hue[
      NCache[
       Rational[7420, 14307], 0.5186272454043476]], AbsoluteThickness[0.25], 
     LineBox[{7420, 7421}]}, 
    {Hue[
      NCache[
       Rational[7421, 14307], 0.5186971412595233]], AbsoluteThickness[0.25], 
     LineBox[{7421, 7422}]}, 
    {Hue[
      NCache[
       Rational[2474, 4769], 0.5187670371146991]], AbsoluteThickness[0.25], 
     LineBox[{7422, 7423}]}, 
    {Hue[
      NCache[
       Rational[7423, 14307], 0.5188369329698749]], AbsoluteThickness[0.25], 
     LineBox[{7423, 7424}]}, 
    {Hue[
      NCache[
       Rational[7424, 14307], 0.5189068288250507]], AbsoluteThickness[0.25], 
     LineBox[{7424, 7425}]}, 
    {Hue[
      NCache[
       Rational[2475, 4769], 0.5189767246802265]], AbsoluteThickness[0.25], 
     LineBox[{7425, 7426}]}, 
    {Hue[
      NCache[
       Rational[7426, 14307], 0.5190466205354023]], AbsoluteThickness[0.25], 
     LineBox[{7426, 7427}]}, 
    {Hue[
      NCache[
       Rational[7427, 14307], 0.519116516390578]], AbsoluteThickness[0.25], 
     LineBox[{7427, 7428}]}, 
    {Hue[
      NCache[
       Rational[2476, 4769], 0.5191864122457538]], AbsoluteThickness[0.25], 
     LineBox[{7428, 7429}]}, 
    {Hue[
      NCache[
       Rational[391, 753], 0.5192563081009296]], AbsoluteThickness[0.25], 
     LineBox[{7429, 7430}]}, 
    {Hue[
      NCache[
       Rational[7430, 14307], 0.5193262039561054]], AbsoluteThickness[0.25], 
     LineBox[{7430, 7431}]}, 
    {Hue[
      NCache[
       Rational[2477, 4769], 0.5193960998112812]], AbsoluteThickness[0.25], 
     LineBox[{7431, 7432}]}, 
    {Hue[
      NCache[
       Rational[7432, 14307], 0.519465995666457]], AbsoluteThickness[0.25], 
     LineBox[{7432, 7433}]}, 
    {Hue[
      NCache[
       Rational[7433, 14307], 0.5195358915216328]], AbsoluteThickness[0.25], 
     LineBox[{7433, 7434}]}, 
    {Hue[
      NCache[
       Rational[2478, 4769], 0.5196057873768085]], AbsoluteThickness[0.25], 
     LineBox[{7434, 7435}]}, 
    {Hue[
      NCache[
       Rational[7435, 14307], 0.5196756832319843]], AbsoluteThickness[0.25], 
     LineBox[{7435, 7436}]}, 
    {Hue[
      NCache[
       Rational[7436, 14307], 0.5197455790871601]], AbsoluteThickness[0.25], 
     LineBox[{7436, 7437}]}, 
    {Hue[
      NCache[
       Rational[2479, 4769], 0.5198154749423359]], AbsoluteThickness[0.25], 
     LineBox[{7437, 7438}]}, 
    {Hue[
      NCache[
       Rational[7438, 14307], 0.5198853707975117]], AbsoluteThickness[0.25], 
     LineBox[{7438, 7439}]}, 
    {Hue[
      NCache[
       Rational[7439, 14307], 0.5199552666526875]], AbsoluteThickness[0.25], 
     LineBox[{7439, 7440}]}, 
    {Hue[
      NCache[
       Rational[2480, 4769], 0.5200251625078632]], AbsoluteThickness[0.25], 
     LineBox[{7440, 7441}]}, 
    {Hue[
      NCache[
       Rational[7441, 14307], 0.520095058363039]], AbsoluteThickness[0.25], 
     LineBox[{7441, 7442}]}, 
    {Hue[
      NCache[
       Rational[7442, 14307], 0.5201649542182148]], AbsoluteThickness[0.25], 
     LineBox[{7442, 7443}]}, 
    {Hue[
      NCache[
       Rational[2481, 4769], 0.5202348500733907]], AbsoluteThickness[0.25], 
     LineBox[{7443, 7444}]}, 
    {Hue[
      NCache[
       Rational[7444, 14307], 0.5203047459285665]], AbsoluteThickness[0.25], 
     LineBox[{7444, 7445}]}, 
    {Hue[
      NCache[
       Rational[7445, 14307], 0.5203746417837423]], AbsoluteThickness[0.25], 
     LineBox[{7445, 7446}]}, 
    {Hue[
      NCache[
       Rational[2482, 4769], 0.520444537638918]], AbsoluteThickness[0.25], 
     LineBox[{7446, 7447}]}, 
    {Hue[
      NCache[
       Rational[7447, 14307], 0.5205144334940938]], AbsoluteThickness[0.25], 
     LineBox[{7447, 7448}]}, 
    {Hue[
      NCache[
       Rational[392, 753], 0.5205843293492696]], AbsoluteThickness[0.25], 
     LineBox[{7448, 7449}]}, 
    {Hue[
      NCache[
       Rational[2483, 4769], 0.5206542252044454]], AbsoluteThickness[0.25], 
     LineBox[{7449, 7450}]}, 
    {Hue[
      NCache[
       Rational[7450, 14307], 0.5207241210596212]], AbsoluteThickness[0.25], 
     LineBox[{7450, 7451}]}, 
    {Hue[
      NCache[
       Rational[7451, 14307], 0.520794016914797]], AbsoluteThickness[0.25], 
     LineBox[{7451, 7452}]}, 
    {Hue[
      NCache[
       Rational[2484, 4769], 0.5208639127699728]], AbsoluteThickness[0.25], 
     LineBox[{7452, 7453}]}, 
    {Hue[
      NCache[
       Rational[7453, 14307], 0.5209338086251485]], AbsoluteThickness[0.25], 
     LineBox[{7453, 7454}]}, 
    {Hue[
      NCache[
       Rational[7454, 14307], 0.5210037044803243]], AbsoluteThickness[0.25], 
     LineBox[{7454, 7455}]}, 
    {Hue[
      NCache[
       Rational[2485, 4769], 0.5210736003355001]], AbsoluteThickness[0.25], 
     LineBox[{7455, 7456}]}, 
    {Hue[
      NCache[
       Rational[7456, 14307], 0.5211434961906759]], AbsoluteThickness[0.25], 
     LineBox[{7456, 7457}]}, 
    {Hue[
      NCache[
       Rational[7457, 14307], 0.5212133920458517]], AbsoluteThickness[0.25], 
     LineBox[{7457, 7458}]}, 
    {Hue[
      NCache[
       Rational[2486, 4769], 0.5212832879010275]], AbsoluteThickness[0.25], 
     LineBox[{7458, 7459}]}, 
    {Hue[
      NCache[
       Rational[7459, 14307], 0.5213531837562032]], AbsoluteThickness[0.25], 
     LineBox[{7459, 7460}]}, 
    {Hue[
      NCache[
       Rational[7460, 14307], 0.521423079611379]], AbsoluteThickness[0.25], 
     LineBox[{7460, 7461}]}, 
    {Hue[
      NCache[
       Rational[2487, 4769], 0.5214929754665548]], AbsoluteThickness[0.25], 
     LineBox[{7461, 7462}]}, 
    {Hue[
      NCache[
       Rational[7462, 14307], 0.5215628713217306]], AbsoluteThickness[0.25], 
     LineBox[{7462, 7463}]}, 
    {Hue[
      NCache[
       Rational[7463, 14307], 0.5216327671769064]], AbsoluteThickness[0.25], 
     LineBox[{7463, 7464}]}, 
    {Hue[
      NCache[
       Rational[2488, 4769], 0.5217026630320822]], AbsoluteThickness[0.25], 
     LineBox[{7464, 7465}]}, 
    {Hue[
      NCache[
       Rational[7465, 14307], 0.5217725588872579]], AbsoluteThickness[0.25], 
     LineBox[{7465, 7466}]}, 
    {Hue[
      NCache[
       Rational[7466, 14307], 0.5218424547424337]], AbsoluteThickness[0.25], 
     LineBox[{7466, 7467}]}, 
    {Hue[
      NCache[
       Rational[131, 251], 0.5219123505976095]], AbsoluteThickness[0.25], 
     LineBox[{7467, 7468}]}, 
    {Hue[
      NCache[
       Rational[7468, 14307], 0.5219822464527853]], AbsoluteThickness[0.25], 
     LineBox[{7468, 7469}]}, 
    {Hue[
      NCache[
       Rational[7469, 14307], 0.5220521423079612]], AbsoluteThickness[0.25], 
     LineBox[{7469, 7470}]}, 
    {Hue[
      NCache[
       Rational[2490, 4769], 0.522122038163137]], AbsoluteThickness[0.25], 
     LineBox[{7470, 7471}]}, 
    {Hue[
      NCache[
       Rational[7471, 14307], 0.5221919340183128]], AbsoluteThickness[0.25], 
     LineBox[{7471, 7472}]}, 
    {Hue[
      NCache[
       Rational[7472, 14307], 0.5222618298734885]], AbsoluteThickness[0.25], 
     LineBox[{7472, 7473}]}, 
    {Hue[
      NCache[
       Rational[2491, 4769], 0.5223317257286643]], AbsoluteThickness[0.25], 
     LineBox[{7473, 7474}]}, 
    {Hue[
      NCache[
       Rational[7474, 14307], 0.5224016215838401]], AbsoluteThickness[0.25], 
     LineBox[{7474, 7475}]}, 
    {Hue[
      NCache[
       Rational[7475, 14307], 0.5224715174390159]], AbsoluteThickness[0.25], 
     LineBox[{7475, 7476}]}, 
    {Hue[
      NCache[
       Rational[2492, 4769], 0.5225414132941917]], AbsoluteThickness[0.25], 
     LineBox[{7476, 7477}]}, 
    {Hue[
      NCache[
       Rational[7477, 14307], 0.5226113091493675]], AbsoluteThickness[0.25], 
     LineBox[{7477, 7478}]}, 
    {Hue[
      NCache[
       Rational[7478, 14307], 0.5226812050045432]], AbsoluteThickness[0.25], 
     LineBox[{7478, 7479}]}, 
    {Hue[
      NCache[
       Rational[2493, 4769], 0.522751100859719]], AbsoluteThickness[0.25], 
     LineBox[{7479, 7480}]}, 
    {Hue[
      NCache[
       Rational[7480, 14307], 0.5228209967148948]], AbsoluteThickness[0.25], 
     LineBox[{7480, 7481}]}, 
    {Hue[
      NCache[
       Rational[7481, 14307], 0.5228908925700706]], AbsoluteThickness[0.25], 
     LineBox[{7481, 7482}]}, 
    {Hue[
      NCache[
       Rational[2494, 4769], 0.5229607884252464]], AbsoluteThickness[0.25], 
     LineBox[{7482, 7483}]}, 
    {Hue[
      NCache[
       Rational[7483, 14307], 0.5230306842804222]], AbsoluteThickness[0.25], 
     LineBox[{7483, 7484}]}, 
    {Hue[
      NCache[
       Rational[7484, 14307], 0.523100580135598]], AbsoluteThickness[0.25], 
     LineBox[{7484, 7485}]}, 
    {Hue[
      NCache[
       Rational[2495, 4769], 0.5231704759907737]], AbsoluteThickness[0.25], 
     LineBox[{7485, 7486}]}, 
    {Hue[
      NCache[
       Rational[394, 753], 0.5232403718459495]], AbsoluteThickness[0.25], 
     LineBox[{7486, 7487}]}, 
    {Hue[
      NCache[
       Rational[7487, 14307], 0.5233102677011253]], AbsoluteThickness[0.25], 
     LineBox[{7487, 7488}]}, 
    {Hue[
      NCache[
       Rational[2496, 4769], 0.5233801635563011]], AbsoluteThickness[0.25], 
     LineBox[{7488, 7489}]}, 
    {Hue[
      NCache[
       Rational[7489, 14307], 0.5234500594114769]], AbsoluteThickness[0.25], 
     LineBox[{7489, 7490}]}, 
    {Hue[
      NCache[
       Rational[7490, 14307], 0.5235199552666527]], AbsoluteThickness[0.25], 
     LineBox[{7490, 7491}]}, 
    {Hue[
      NCache[
       Rational[2497, 4769], 0.5235898511218284]], AbsoluteThickness[0.25], 
     LineBox[{7491, 7492}]}, 
    {Hue[
      NCache[
       Rational[7492, 14307], 0.5236597469770042]], AbsoluteThickness[0.25], 
     LineBox[{7492, 7493}]}, 
    {Hue[
      NCache[
       Rational[7493, 14307], 0.52372964283218]], AbsoluteThickness[0.25], 
     LineBox[{7493, 7494}]}, 
    {Hue[
      NCache[
       Rational[2498, 4769], 0.5237995386873558]], AbsoluteThickness[0.25], 
     LineBox[{7494, 7495}]}, 
    {Hue[
      NCache[
       Rational[7495, 14307], 0.5238694345425317]], AbsoluteThickness[0.25], 
     LineBox[{7495, 7496}]}, 
    {Hue[
      NCache[
       Rational[7496, 14307], 0.5239393303977075]], AbsoluteThickness[0.25], 
     LineBox[{7496, 7497}]}, 
    {Hue[
      NCache[
       Rational[2499, 4769], 0.5240092262528832]], AbsoluteThickness[0.25], 
     LineBox[{7497, 7498}]}, 
    {Hue[
      NCache[
       Rational[7498, 14307], 0.524079122108059]], AbsoluteThickness[0.25], 
     LineBox[{7498, 7499}]}, 
    {Hue[
      NCache[
       Rational[7499, 14307], 0.5241490179632348]], AbsoluteThickness[0.25], 
     LineBox[{7499, 7500}]}, 
    {Hue[
      NCache[
       Rational[2500, 4769], 0.5242189138184106]], AbsoluteThickness[0.25], 
     LineBox[{7500, 7501}]}, 
    {Hue[
      NCache[
       Rational[7501, 14307], 0.5242888096735864]], AbsoluteThickness[0.25], 
     LineBox[{7501, 7502}]}, 
    {Hue[
      NCache[
       Rational[7502, 14307], 0.5243587055287622]], AbsoluteThickness[0.25], 
     LineBox[{7502, 7503}]}, 
    {Hue[
      NCache[
       Rational[2501, 4769], 0.524428601383938]], AbsoluteThickness[0.25], 
     LineBox[{7503, 7504}]}, 
    {Hue[
      NCache[
       Rational[7504, 14307], 0.5244984972391137]], AbsoluteThickness[0.25], 
     LineBox[{7504, 7505}]}, 
    {Hue[
      NCache[
       Rational[395, 753], 0.5245683930942895]], AbsoluteThickness[0.25], 
     LineBox[{7505, 7506}]}, 
    {Hue[
      NCache[
       Rational[2502, 4769], 0.5246382889494653]], AbsoluteThickness[0.25], 
     LineBox[{7506, 7507}]}, 
    {Hue[
      NCache[
       Rational[7507, 14307], 0.5247081848046411]], AbsoluteThickness[0.25], 
     LineBox[{7507, 7508}]}, 
    {Hue[
      NCache[
       Rational[7508, 14307], 0.5247780806598169]], AbsoluteThickness[0.25], 
     LineBox[{7508, 7509}]}, 
    {Hue[
      NCache[
       Rational[2503, 4769], 0.5248479765149927]], AbsoluteThickness[0.25], 
     LineBox[{7509, 7510}]}, 
    {Hue[
      NCache[
       Rational[7510, 14307], 0.5249178723701684]], AbsoluteThickness[0.25], 
     LineBox[{7510, 7511}]}, 
    {Hue[
      NCache[
       Rational[7511, 14307], 0.5249877682253442]], AbsoluteThickness[0.25], 
     LineBox[{7511, 7512}]}, 
    {Hue[
      NCache[
       Rational[2504, 4769], 0.52505766408052]], AbsoluteThickness[0.25], 
     LineBox[{7512, 7513}]}, 
    {Hue[
      NCache[
       Rational[7513, 14307], 0.5251275599356958]], AbsoluteThickness[0.25], 
     LineBox[{7513, 7514}]}, 
    {Hue[
      NCache[
       Rational[7514, 14307], 0.5251974557908716]], AbsoluteThickness[0.25], 
     LineBox[{7514, 7515}]}, 
    {Hue[
      NCache[
       Rational[2505, 4769], 0.5252673516460474]], AbsoluteThickness[0.25], 
     LineBox[{7515, 7516}]}, 
    {Hue[
      NCache[
       Rational[7516, 14307], 0.5253372475012231]], AbsoluteThickness[0.25], 
     LineBox[{7516, 7517}]}, 
    {Hue[
      NCache[
       Rational[7517, 14307], 0.5254071433563989]], AbsoluteThickness[0.25], 
     LineBox[{7517, 7518}]}, 
    {Hue[
      NCache[
       Rational[2506, 4769], 0.5254770392115747]], AbsoluteThickness[0.25], 
     LineBox[{7518, 7519}]}, 
    {Hue[
      NCache[
       Rational[7519, 14307], 0.5255469350667505]], AbsoluteThickness[0.25], 
     LineBox[{7519, 7520}]}, 
    {Hue[
      NCache[
       Rational[7520, 14307], 0.5256168309219263]], AbsoluteThickness[0.25], 
     LineBox[{7520, 7521}]}, 
    {Hue[
      NCache[
       Rational[2507, 4769], 0.5256867267771022]], AbsoluteThickness[0.25], 
     LineBox[{7521, 7522}]}, 
    {Hue[
      NCache[
       Rational[7522, 14307], 0.525756622632278]], AbsoluteThickness[0.25], 
     LineBox[{7522, 7523}]}, 
    {Hue[
      NCache[
       Rational[7523, 14307], 0.5258265184874537]], AbsoluteThickness[0.25], 
     LineBox[{7523, 7524}]}, 
    {Hue[
      NCache[
       Rational[132, 251], 0.5258964143426295]], AbsoluteThickness[0.25], 
     LineBox[{7524, 7525}]}, 
    {Hue[
      NCache[
       Rational[7525, 14307], 0.5259663101978053]], AbsoluteThickness[0.25], 
     LineBox[{7525, 7526}]}, 
    {Hue[
      NCache[
       Rational[7526, 14307], 0.5260362060529811]], AbsoluteThickness[0.25], 
     LineBox[{7526, 7527}]}, 
    {Hue[
      NCache[
       Rational[2509, 4769], 0.5261061019081569]], AbsoluteThickness[0.25], 
     LineBox[{7527, 7528}]}, 
    {Hue[
      NCache[
       Rational[7528, 14307], 0.5261759977633327]], AbsoluteThickness[0.25], 
     LineBox[{7528, 7529}]}, 
    {Hue[
      NCache[
       Rational[7529, 14307], 0.5262458936185084]], AbsoluteThickness[0.25], 
     LineBox[{7529, 7530}]}, 
    {Hue[
      NCache[
       Rational[10, 19], 0.5263157894736842]], AbsoluteThickness[0.25], 
     LineBox[{7530, 7531}]}, 
    {Hue[
      NCache[
       Rational[7531, 14307], 0.52638568532886]], AbsoluteThickness[0.25], 
     LineBox[{7531, 7532}]}, 
    {Hue[
      NCache[
       Rational[7532, 14307], 0.5264555811840358]], AbsoluteThickness[0.25], 
     LineBox[{7532, 7533}]}, 
    {Hue[
      NCache[
       Rational[2511, 4769], 0.5265254770392116]], AbsoluteThickness[0.25], 
     LineBox[{7533, 7534}]}, 
    {Hue[
      NCache[
       Rational[7534, 14307], 0.5265953728943874]], AbsoluteThickness[0.25], 
     LineBox[{7534, 7535}]}, 
    {Hue[
      NCache[
       Rational[7535, 14307], 0.5266652687495631]], AbsoluteThickness[0.25], 
     LineBox[{7535, 7536}]}, 
    {Hue[
      NCache[
       Rational[2512, 4769], 0.5267351646047389]], AbsoluteThickness[0.25], 
     LineBox[{7536, 7537}]}, 
    {Hue[
      NCache[
       Rational[7537, 14307], 0.5268050604599147]], AbsoluteThickness[0.25], 
     LineBox[{7537, 7538}]}, 
    {Hue[
      NCache[
       Rational[7538, 14307], 0.5268749563150905]], AbsoluteThickness[0.25], 
     LineBox[{7538, 7539}]}, 
    {Hue[
      NCache[
       Rational[2513, 4769], 0.5269448521702663]], AbsoluteThickness[0.25], 
     LineBox[{7539, 7540}]}, 
    {Hue[
      NCache[
       Rational[7540, 14307], 0.5270147480254421]], AbsoluteThickness[0.25], 
     LineBox[{7540, 7541}]}, 
    {Hue[
      NCache[
       Rational[7541, 14307], 0.5270846438806179]], AbsoluteThickness[0.25], 
     LineBox[{7541, 7542}]}, 
    {Hue[
      NCache[
       Rational[2514, 4769], 0.5271545397357936]], AbsoluteThickness[0.25], 
     LineBox[{7542, 7543}]}, 
    {Hue[
      NCache[
       Rational[397, 753], 0.5272244355909694]], AbsoluteThickness[0.25], 
     LineBox[{7543, 7544}]}, 
    {Hue[
      NCache[
       Rational[7544, 14307], 0.5272943314461452]], AbsoluteThickness[0.25], 
     LineBox[{7544, 7545}]}, 
    {Hue[
      NCache[
       Rational[2515, 4769], 0.527364227301321]], AbsoluteThickness[0.25], 
     LineBox[{7545, 7546}]}, 
    {Hue[
      NCache[
       Rational[7546, 14307], 0.5274341231564968]], AbsoluteThickness[0.25], 
     LineBox[{7546, 7547}]}, 
    {Hue[
      NCache[
       Rational[7547, 14307], 0.5275040190116727]], AbsoluteThickness[0.25], 
     LineBox[{7547, 7548}]}, 
    {Hue[
      NCache[
       Rational[2516, 4769], 0.5275739148668483]], AbsoluteThickness[0.25], 
     LineBox[{7548, 7549}]}, 
    {Hue[
      NCache[
       Rational[7549, 14307], 0.5276438107220242]], AbsoluteThickness[0.25], 
     LineBox[{7549, 7550}]}, 
    {Hue[
      NCache[
       Rational[7550, 14307], 0.5277137065772]], AbsoluteThickness[0.25], 
     LineBox[{7550, 7551}]}, 
    {Hue[
      NCache[
       Rational[2517, 4769], 0.5277836024323758]], AbsoluteThickness[0.25], 
     LineBox[{7551, 7552}]}, 
    {Hue[
      NCache[
       Rational[7552, 14307], 0.5278534982875516]], AbsoluteThickness[0.25], 
     LineBox[{7552, 7553}]}, 
    {Hue[
      NCache[
       Rational[7553, 14307], 0.5279233941427274]], AbsoluteThickness[0.25], 
     LineBox[{7553, 7554}]}, 
    {Hue[
      NCache[
       Rational[2518, 4769], 0.5279932899979031]], AbsoluteThickness[0.25], 
     LineBox[{7554, 7555}]}, 
    {Hue[
      NCache[
       Rational[7555, 14307], 0.5280631858530789]], AbsoluteThickness[0.25], 
     LineBox[{7555, 7556}]}, 
    {Hue[
      NCache[
       Rational[7556, 14307], 0.5281330817082547]], AbsoluteThickness[0.25], 
     LineBox[{7556, 7557}]}, 
    {Hue[
      NCache[
       Rational[2519, 4769], 0.5282029775634305]], AbsoluteThickness[0.25], 
     LineBox[{7557, 7558}]}, 
    {Hue[
      NCache[
       Rational[7558, 14307], 0.5282728734186063]], AbsoluteThickness[0.25], 
     LineBox[{7558, 7559}]}, 
    {Hue[
      NCache[
       Rational[7559, 14307], 0.5283427692737821]], AbsoluteThickness[0.25], 
     LineBox[{7559, 7560}]}, 
    {Hue[
      NCache[
       Rational[2520, 4769], 0.5284126651289579]], AbsoluteThickness[0.25], 
     LineBox[{7560, 7561}]}, 
    {Hue[
      NCache[
       Rational[7561, 14307], 0.5284825609841336]], AbsoluteThickness[0.25], 
     LineBox[{7561, 7562}]}, 
    {Hue[
      NCache[
       Rational[398, 753], 0.5285524568393094]], AbsoluteThickness[0.25], 
     LineBox[{7562, 7563}]}, 
    {Hue[
      NCache[
       Rational[2521, 4769], 0.5286223526944852]], AbsoluteThickness[0.25], 
     LineBox[{7563, 7564}]}, 
    {Hue[
      NCache[
       Rational[7564, 14307], 0.528692248549661]], AbsoluteThickness[0.25], 
     LineBox[{7564, 7565}]}, 
    {Hue[
      NCache[
       Rational[7565, 14307], 0.5287621444048368]], AbsoluteThickness[0.25], 
     LineBox[{7565, 7566}]}, 
    {Hue[
      NCache[
       Rational[2522, 4769], 0.5288320402600126]], AbsoluteThickness[0.25], 
     LineBox[{7566, 7567}]}, 
    {Hue[
      NCache[
       Rational[7567, 14307], 0.5289019361151883]], AbsoluteThickness[0.25], 
     LineBox[{7567, 7568}]}, 
    {Hue[
      NCache[
       Rational[7568, 14307], 0.5289718319703641]], AbsoluteThickness[0.25], 
     LineBox[{7568, 7569}]}, 
    {Hue[
      NCache[
       Rational[2523, 4769], 0.5290417278255399]], AbsoluteThickness[0.25], 
     LineBox[{7569, 7570}]}, 
    {Hue[
      NCache[
       Rational[7570, 14307], 0.5291116236807157]], AbsoluteThickness[0.25], 
     LineBox[{7570, 7571}]}, 
    {Hue[
      NCache[
       Rational[7571, 14307], 0.5291815195358915]], AbsoluteThickness[0.25], 
     LineBox[{7571, 7572}]}, 
    {Hue[
      NCache[
       Rational[2524, 4769], 0.5292514153910673]], AbsoluteThickness[0.25], 
     LineBox[{7572, 7573}]}, 
    {Hue[
      NCache[
       Rational[7573, 14307], 0.529321311246243]], AbsoluteThickness[0.25], 
     LineBox[{7573, 7574}]}, 
    {Hue[
      NCache[
       Rational[7574, 14307], 0.5293912071014188]], AbsoluteThickness[0.25], 
     LineBox[{7574, 7575}]}, 
    {Hue[
      NCache[
       Rational[2525, 4769], 0.5294611029565947]], AbsoluteThickness[0.25], 
     LineBox[{7575, 7576}]}, 
    {Hue[
      NCache[
       Rational[7576, 14307], 0.5295309988117705]], AbsoluteThickness[0.25], 
     LineBox[{7576, 7577}]}, 
    {Hue[
      NCache[
       Rational[7577, 14307], 0.5296008946669463]], AbsoluteThickness[0.25], 
     LineBox[{7577, 7578}]}, 
    {Hue[
      NCache[
       Rational[2526, 4769], 0.5296707905221221]], AbsoluteThickness[0.25], 
     LineBox[{7578, 7579}]}, 
    {Hue[
      NCache[
       Rational[7579, 14307], 0.5297406863772979]], AbsoluteThickness[0.25], 
     LineBox[{7579, 7580}]}, 
    {Hue[
      NCache[
       Rational[7580, 14307], 0.5298105822324736]], AbsoluteThickness[0.25], 
     LineBox[{7580, 7581}]}, 
    {Hue[
      NCache[
       Rational[133, 251], 0.5298804780876494]], AbsoluteThickness[0.25], 
     LineBox[{7581, 7582}]}, 
    {Hue[
      NCache[
       Rational[7582, 14307], 0.5299503739428252]], AbsoluteThickness[0.25], 
     LineBox[{7582, 7583}]}, 
    {Hue[
      NCache[
       Rational[7583, 14307], 0.530020269798001]], AbsoluteThickness[0.25], 
     LineBox[{7583, 7584}]}, 
    {Hue[
      NCache[
       Rational[2528, 4769], 0.5300901656531768]], AbsoluteThickness[0.25], 
     LineBox[{7584, 7585}]}, 
    {Hue[
      NCache[
       Rational[7585, 14307], 0.5301600615083526]], AbsoluteThickness[0.25], 
     LineBox[{7585, 7586}]}, 
    {Hue[
      NCache[
       Rational[7586, 14307], 0.5302299573635283]], AbsoluteThickness[0.25], 
     LineBox[{7586, 7587}]}, 
    {Hue[
      NCache[
       Rational[2529, 4769], 0.5302998532187041]], AbsoluteThickness[0.25], 
     LineBox[{7587, 7588}]}, 
    {Hue[
      NCache[
       Rational[7588, 14307], 0.5303697490738799]], AbsoluteThickness[0.25], 
     LineBox[{7588, 7589}]}, 
    {Hue[
      NCache[
       Rational[7589, 14307], 0.5304396449290557]], AbsoluteThickness[0.25], 
     LineBox[{7589, 7590}]}, 
    {Hue[
      NCache[
       Rational[2530, 4769], 0.5305095407842315]], AbsoluteThickness[0.25], 
     LineBox[{7590, 7591}]}, 
    {Hue[
      NCache[
       Rational[7591, 14307], 0.5305794366394073]], AbsoluteThickness[0.25], 
     LineBox[{7591, 7592}]}, 
    {Hue[
      NCache[
       Rational[7592, 14307], 0.5306493324945831]], AbsoluteThickness[0.25], 
     LineBox[{7592, 7593}]}, 
    {Hue[
      NCache[
       Rational[2531, 4769], 0.5307192283497588]], AbsoluteThickness[0.25], 
     LineBox[{7593, 7594}]}, 
    {Hue[
      NCache[
       Rational[7594, 14307], 0.5307891242049346]], AbsoluteThickness[0.25], 
     LineBox[{7594, 7595}]}, 
    {Hue[
      NCache[
       Rational[7595, 14307], 0.5308590200601104]], AbsoluteThickness[0.25], 
     LineBox[{7595, 7596}]}, 
    {Hue[
      NCache[
       Rational[2532, 4769], 0.5309289159152862]], AbsoluteThickness[0.25], 
     LineBox[{7596, 7597}]}, 
    {Hue[
      NCache[
       Rational[7597, 14307], 0.530998811770462]], AbsoluteThickness[0.25], 
     LineBox[{7597, 7598}]}, 
    {Hue[
      NCache[
       Rational[7598, 14307], 0.5310687076256378]], AbsoluteThickness[0.25], 
     LineBox[{7598, 7599}]}, 
    {Hue[
      NCache[
       Rational[2533, 4769], 0.5311386034808135]], AbsoluteThickness[0.25], 
     LineBox[{7599, 7600}]}, 
    {Hue[
      NCache[
       Rational[400, 753], 0.5312084993359893]], AbsoluteThickness[0.25], 
     LineBox[{7600, 7601}]}, 
    {Hue[
      NCache[
       Rational[7601, 14307], 0.5312783951911652]], AbsoluteThickness[0.25], 
     LineBox[{7601, 7602}]}, 
    {Hue[
      NCache[
       Rational[2534, 4769], 0.531348291046341]], AbsoluteThickness[0.25], 
     LineBox[{7602, 7603}]}, 
    {Hue[
      NCache[
       Rational[7603, 14307], 0.5314181869015168]], AbsoluteThickness[0.25], 
     LineBox[{7603, 7604}]}, 
    {Hue[
      NCache[
       Rational[7604, 14307], 0.5314880827566926]], AbsoluteThickness[0.25], 
     LineBox[{7604, 7605}]}, 
    {Hue[
      NCache[
       Rational[2535, 4769], 0.5315579786118683]], AbsoluteThickness[0.25], 
     LineBox[{7605, 7606}]}, 
    {Hue[
      NCache[
       Rational[7606, 14307], 0.5316278744670441]], AbsoluteThickness[0.25], 
     LineBox[{7606, 7607}]}, 
    {Hue[
      NCache[
       Rational[7607, 14307], 0.5316977703222199]], AbsoluteThickness[0.25], 
     LineBox[{7607, 7608}]}, 
    {Hue[
      NCache[
       Rational[2536, 4769], 0.5317676661773957]], AbsoluteThickness[0.25], 
     LineBox[{7608, 7609}]}, 
    {Hue[
      NCache[
       Rational[7609, 14307], 0.5318375620325715]], AbsoluteThickness[0.25], 
     LineBox[{7609, 7610}]}, 
    {Hue[
      NCache[
       Rational[7610, 14307], 0.5319074578877473]], AbsoluteThickness[0.25], 
     LineBox[{7610, 7611}]}, 
    {Hue[
      NCache[
       Rational[2537, 4769], 0.5319773537429231]], AbsoluteThickness[0.25], 
     LineBox[{7611, 7612}]}, 
    {Hue[
      NCache[
       Rational[7612, 14307], 0.5320472495980988]], AbsoluteThickness[0.25], 
     LineBox[{7612, 7613}]}, 
    {Hue[
      NCache[
       Rational[7613, 14307], 0.5321171454532746]], AbsoluteThickness[0.25], 
     LineBox[{7613, 7614}]}, 
    {Hue[
      NCache[
       Rational[2538, 4769], 0.5321870413084504]], AbsoluteThickness[0.25], 
     LineBox[{7614, 7615}]}, 
    {Hue[
      NCache[
       Rational[7615, 14307], 0.5322569371636262]], AbsoluteThickness[0.25], 
     LineBox[{7615, 7616}]}, 
    {Hue[
      NCache[
       Rational[7616, 14307], 0.532326833018802]], AbsoluteThickness[0.25], 
     LineBox[{7616, 7617}]}, 
    {Hue[
      NCache[
       Rational[2539, 4769], 0.5323967288739778]], AbsoluteThickness[0.25], 
     LineBox[{7617, 7618}]}, 
    {Hue[
      NCache[
       Rational[7618, 14307], 0.5324666247291535]], AbsoluteThickness[0.25], 
     LineBox[{7618, 7619}]}, 
    {Hue[
      NCache[
       Rational[401, 753], 0.5325365205843293]], AbsoluteThickness[0.25], 
     LineBox[{7619, 7620}]}, 
    {Hue[
      NCache[
       Rational[2540, 4769], 0.5326064164395051]], AbsoluteThickness[0.25], 
     LineBox[{7620, 7621}]}, 
    {Hue[
      NCache[
       Rational[7621, 14307], 0.5326763122946809]], AbsoluteThickness[0.25], 
     LineBox[{7621, 7622}]}, 
    {Hue[
      NCache[
       Rational[7622, 14307], 0.5327462081498567]], AbsoluteThickness[0.25], 
     LineBox[{7622, 7623}]}, 
    {Hue[
      NCache[
       Rational[2541, 4769], 0.5328161040050325]], AbsoluteThickness[0.25], 
     LineBox[{7623, 7624}]}, 
    {Hue[
      NCache[
       Rational[7624, 14307], 0.5328859998602082]], AbsoluteThickness[0.25], 
     LineBox[{7624, 7625}]}, 
    {Hue[
      NCache[
       Rational[7625, 14307], 0.532955895715384]], AbsoluteThickness[0.25], 
     LineBox[{7625, 7626}]}, 
    {Hue[
      NCache[
       Rational[2542, 4769], 0.5330257915705598]], AbsoluteThickness[0.25], 
     LineBox[{7626, 7627}]}, 
    {Hue[
      NCache[
       Rational[7627, 14307], 0.5330956874257357]], AbsoluteThickness[0.25], 
     LineBox[{7627, 7628}]}, 
    {Hue[
      NCache[
       Rational[7628, 14307], 0.5331655832809115]], AbsoluteThickness[0.25], 
     LineBox[{7628, 7629}]}, 
    {Hue[
      NCache[
       Rational[2543, 4769], 0.5332354791360873]], AbsoluteThickness[0.25], 
     LineBox[{7629, 7630}]}, 
    {Hue[
      NCache[
       Rational[7630, 14307], 0.5333053749912631]], AbsoluteThickness[0.25], 
     LineBox[{7630, 7631}]}, 
    {Hue[
      NCache[
       Rational[7631, 14307], 0.5333752708464388]], AbsoluteThickness[0.25], 
     LineBox[{7631, 7632}]}, 
    {Hue[
      NCache[
       Rational[2544, 4769], 0.5334451667016146]], AbsoluteThickness[0.25], 
     LineBox[{7632, 7633}]}, 
    {Hue[
      NCache[
       Rational[7633, 14307], 0.5335150625567904]], AbsoluteThickness[0.25], 
     LineBox[{7633, 7634}]}, 
    {Hue[
      NCache[
       Rational[7634, 14307], 0.5335849584119662]], AbsoluteThickness[0.25], 
     LineBox[{7634, 7635}]}, 
    {Hue[
      NCache[
       Rational[2545, 4769], 0.533654854267142]], AbsoluteThickness[0.25], 
     LineBox[{7635, 7636}]}, 
    {Hue[
      NCache[
       Rational[7636, 14307], 0.5337247501223178]], AbsoluteThickness[0.25], 
     LineBox[{7636, 7637}]}, 
    {Hue[
      NCache[
       Rational[7637, 14307], 0.5337946459774935]], AbsoluteThickness[0.25], 
     LineBox[{7637, 7638}]}, 
    {Hue[
      NCache[
       Rational[134, 251], 0.5338645418326693]], AbsoluteThickness[0.25], 
     LineBox[{7638, 7639}]}, 
    {Hue[
      NCache[
       Rational[7639, 14307], 0.5339344376878451]], AbsoluteThickness[0.25], 
     LineBox[{7639, 7640}]}, 
    {Hue[
      NCache[
       Rational[7640, 14307], 0.5340043335430209]], AbsoluteThickness[0.25], 
     LineBox[{7640, 7641}]}, 
    {Hue[
      NCache[
       Rational[2547, 4769], 0.5340742293981967]], AbsoluteThickness[0.25], 
     LineBox[{7641, 7642}]}, 
    {Hue[
      NCache[
       Rational[7642, 14307], 0.5341441252533725]], AbsoluteThickness[0.25], 
     LineBox[{7642, 7643}]}, 
    {Hue[
      NCache[
       Rational[7643, 14307], 0.5342140211085482]], AbsoluteThickness[0.25], 
     LineBox[{7643, 7644}]}, 
    {Hue[
      NCache[
       Rational[2548, 4769], 0.534283916963724]], AbsoluteThickness[0.25], 
     LineBox[{7644, 7645}]}, 
    {Hue[
      NCache[
       Rational[7645, 14307], 0.5343538128188998]], AbsoluteThickness[0.25], 
     LineBox[{7645, 7646}]}, 
    {Hue[
      NCache[
       Rational[7646, 14307], 0.5344237086740756]], AbsoluteThickness[0.25], 
     LineBox[{7646, 7647}]}, 
    {Hue[
      NCache[
       Rational[2549, 4769], 0.5344936045292514]], AbsoluteThickness[0.25], 
     LineBox[{7647, 7648}]}, 
    {Hue[
      NCache[
       Rational[7648, 14307], 0.5345635003844272]], AbsoluteThickness[0.25], 
     LineBox[{7648, 7649}]}, 
    {Hue[
      NCache[
       Rational[7649, 14307], 0.534633396239603]], AbsoluteThickness[0.25], 
     LineBox[{7649, 7650}]}, 
    {Hue[
      NCache[
       Rational[2550, 4769], 0.5347032920947787]], AbsoluteThickness[0.25], 
     LineBox[{7650, 7651}]}, 
    {Hue[
      NCache[
       Rational[7651, 14307], 0.5347731879499545]], AbsoluteThickness[0.25], 
     LineBox[{7651, 7652}]}, 
    {Hue[
      NCache[
       Rational[7652, 14307], 0.5348430838051303]], AbsoluteThickness[0.25], 
     LineBox[{7652, 7653}]}, 
    {Hue[
      NCache[
       Rational[2551, 4769], 0.5349129796603062]], AbsoluteThickness[0.25], 
     LineBox[{7653, 7654}]}, 
    {Hue[
      NCache[
       Rational[7654, 14307], 0.534982875515482]], AbsoluteThickness[0.25], 
     LineBox[{7654, 7655}]}, 
    {Hue[
      NCache[
       Rational[7655, 14307], 0.5350527713706578]], AbsoluteThickness[0.25], 
     LineBox[{7655, 7656}]}, 
    {Hue[
      NCache[
       Rational[2552, 4769], 0.5351226672258335]], AbsoluteThickness[0.25], 
     LineBox[{7656, 7657}]}, 
    {Hue[
      NCache[
       Rational[403, 753], 0.5351925630810093]], AbsoluteThickness[0.25], 
     LineBox[{7657, 7658}]}, 
    {Hue[
      NCache[
       Rational[7658, 14307], 0.5352624589361851]], AbsoluteThickness[0.25], 
     LineBox[{7658, 7659}]}, 
    {Hue[
      NCache[
       Rational[2553, 4769], 0.5353323547913609]], AbsoluteThickness[0.25], 
     LineBox[{7659, 7660}]}, 
    {Hue[
      NCache[
       Rational[7660, 14307], 0.5354022506465367]], AbsoluteThickness[0.25], 
     LineBox[{7660, 7661}]}, 
    {Hue[
      NCache[
       Rational[7661, 14307], 0.5354721465017125]], AbsoluteThickness[0.25], 
     LineBox[{7661, 7662}]}, 
    {Hue[
      NCache[
       Rational[2554, 4769], 0.5355420423568882]], AbsoluteThickness[0.25], 
     LineBox[{7662, 7663}]}, 
    {Hue[
      NCache[
       Rational[7663, 14307], 0.535611938212064]], AbsoluteThickness[0.25], 
     LineBox[{7663, 7664}]}, 
    {Hue[
      NCache[
       Rational[7664, 14307], 0.5356818340672398]], AbsoluteThickness[0.25], 
     LineBox[{7664, 7665}]}, 
    {Hue[
      NCache[
       Rational[2555, 4769], 0.5357517299224156]], AbsoluteThickness[0.25], 
     LineBox[{7665, 7666}]}, 
    {Hue[
      NCache[
       Rational[7666, 14307], 0.5358216257775914]], AbsoluteThickness[0.25], 
     LineBox[{7666, 7667}]}, 
    {Hue[
      NCache[
       Rational[7667, 14307], 0.5358915216327672]], AbsoluteThickness[0.25], 
     LineBox[{7667, 7668}]}, 
    {Hue[
      NCache[
       Rational[2556, 4769], 0.535961417487943]], AbsoluteThickness[0.25], 
     LineBox[{7668, 7669}]}, 
    {Hue[
      NCache[
       Rational[7669, 14307], 0.5360313133431187]], AbsoluteThickness[0.25], 
     LineBox[{7669, 7670}]}, 
    {Hue[
      NCache[
       Rational[7670, 14307], 0.5361012091982945]], AbsoluteThickness[0.25], 
     LineBox[{7670, 7671}]}, 
    {Hue[
      NCache[
       Rational[2557, 4769], 0.5361711050534703]], AbsoluteThickness[0.25], 
     LineBox[{7671, 7672}]}, 
    {Hue[
      NCache[
       Rational[7672, 14307], 0.5362410009086461]], AbsoluteThickness[0.25], 
     LineBox[{7672, 7673}]}, 
    {Hue[
      NCache[
       Rational[7673, 14307], 0.5363108967638219]], AbsoluteThickness[0.25], 
     LineBox[{7673, 7674}]}, 
    {Hue[
      NCache[
       Rational[2558, 4769], 0.5363807926189977]], AbsoluteThickness[0.25], 
     LineBox[{7674, 7675}]}, 
    {Hue[
      NCache[
       Rational[7675, 14307], 0.5364506884741734]], AbsoluteThickness[0.25], 
     LineBox[{7675, 7676}]}, 
    {Hue[
      NCache[
       Rational[404, 753], 0.5365205843293492]], AbsoluteThickness[0.25], 
     LineBox[{7676, 7677}]}, 
    {Hue[
      NCache[
       Rational[2559, 4769], 0.536590480184525]], AbsoluteThickness[0.25], 
     LineBox[{7677, 7678}]}, 
    {Hue[
      NCache[
       Rational[7678, 14307], 0.5366603760397008]], AbsoluteThickness[0.25], 
     LineBox[{7678, 7679}]}, 
    {Hue[
      NCache[
       Rational[7679, 14307], 0.5367302718948767]], AbsoluteThickness[0.25], 
     LineBox[{7679, 7680}]}, 
    {Hue[
      NCache[
       Rational[2560, 4769], 0.5368001677500525]], AbsoluteThickness[0.25], 
     LineBox[{7680, 7681}]}, 
    {Hue[
      NCache[
       Rational[7681, 14307], 0.5368700636052283]], AbsoluteThickness[0.25], 
     LineBox[{7681, 7682}]}, 
    {Hue[
      NCache[
       Rational[7682, 14307], 0.536939959460404]], AbsoluteThickness[0.25], 
     LineBox[{7682, 7683}]}, 
    {Hue[
      NCache[
       Rational[2561, 4769], 0.5370098553155798]], AbsoluteThickness[0.25], 
     LineBox[{7683, 7684}]}, 
    {Hue[
      NCache[
       Rational[7684, 14307], 0.5370797511707556]], AbsoluteThickness[0.25], 
     LineBox[{7684, 7685}]}, 
    {Hue[
      NCache[
       Rational[7685, 14307], 0.5371496470259314]], AbsoluteThickness[0.25], 
     LineBox[{7685, 7686}]}, 
    {Hue[
      NCache[
       Rational[2562, 4769], 0.5372195428811072]], AbsoluteThickness[0.25], 
     LineBox[{7686, 7687}]}, 
    {Hue[
      NCache[
       Rational[7687, 14307], 0.537289438736283]], AbsoluteThickness[0.25], 
     LineBox[{7687, 7688}]}, 
    {Hue[
      NCache[
       Rational[7688, 14307], 0.5373593345914587]], AbsoluteThickness[0.25], 
     LineBox[{7688, 7689}]}, 
    {Hue[
      NCache[
       Rational[2563, 4769], 0.5374292304466345]], AbsoluteThickness[0.25], 
     LineBox[{7689, 7690}]}, 
    {Hue[
      NCache[
       Rational[7690, 14307], 0.5374991263018103]], AbsoluteThickness[0.25], 
     LineBox[{7690, 7691}]}, 
    {Hue[
      NCache[
       Rational[7691, 14307], 0.5375690221569861]], AbsoluteThickness[0.25], 
     LineBox[{7691, 7692}]}, 
    {Hue[
      NCache[
       Rational[2564, 4769], 0.5376389180121619]], AbsoluteThickness[0.25], 
     LineBox[{7692, 7693}]}, 
    {Hue[
      NCache[
       Rational[7693, 14307], 0.5377088138673377]], AbsoluteThickness[0.25], 
     LineBox[{7693, 7694}]}, 
    {Hue[
      NCache[
       Rational[7694, 14307], 0.5377787097225134]], AbsoluteThickness[0.25], 
     LineBox[{7694, 7695}]}, 
    {Hue[
      NCache[
       Rational[135, 251], 0.5378486055776892]], AbsoluteThickness[0.25], 
     LineBox[{7695, 7696}]}, 
    {Hue[
      NCache[
       Rational[7696, 14307], 0.537918501432865]], AbsoluteThickness[0.25], 
     LineBox[{7696, 7697}]}, 
    {Hue[
      NCache[
       Rational[7697, 14307], 0.5379883972880408]], AbsoluteThickness[0.25], 
     LineBox[{7697, 7698}]}, 
    {Hue[
      NCache[
       Rational[2566, 4769], 0.5380582931432166]], AbsoluteThickness[0.25], 
     LineBox[{7698, 7699}]}, 
    {Hue[
      NCache[
       Rational[7699, 14307], 0.5381281889983924]], AbsoluteThickness[0.25], 
     LineBox[{7699, 7700}]}, 
    {Hue[
      NCache[
       Rational[7700, 14307], 0.5381980848535682]], AbsoluteThickness[0.25], 
     LineBox[{7700, 7701}]}, 
    {Hue[
      NCache[
       Rational[2567, 4769], 0.5382679807087439]], AbsoluteThickness[0.25], 
     LineBox[{7701, 7702}]}, 
    {Hue[
      NCache[
       Rational[7702, 14307], 0.5383378765639197]], AbsoluteThickness[0.25], 
     LineBox[{7702, 7703}]}, 
    {Hue[
      NCache[
       Rational[7703, 14307], 0.5384077724190955]], AbsoluteThickness[0.25], 
     LineBox[{7703, 7704}]}, 
    {Hue[
      NCache[
       Rational[2568, 4769], 0.5384776682742713]], AbsoluteThickness[0.25], 
     LineBox[{7704, 7705}]}, 
    {Hue[
      NCache[
       Rational[7705, 14307], 0.5385475641294472]], AbsoluteThickness[0.25], 
     LineBox[{7705, 7706}]}, 
    {Hue[
      NCache[
       Rational[7706, 14307], 0.538617459984623]], AbsoluteThickness[0.25], 
     LineBox[{7706, 7707}]}, 
    {Hue[
      NCache[
       Rational[2569, 4769], 0.5386873558397987]], AbsoluteThickness[0.25], 
     LineBox[{7707, 7708}]}, 
    {Hue[
      NCache[
       Rational[7708, 14307], 0.5387572516949745]], AbsoluteThickness[0.25], 
     LineBox[{7708, 7709}]}, 
    {Hue[
      NCache[
       Rational[7709, 14307], 0.5388271475501503]], AbsoluteThickness[0.25], 
     LineBox[{7709, 7710}]}, 
    {Hue[
      NCache[
       Rational[2570, 4769], 0.5388970434053261]], AbsoluteThickness[0.25], 
     LineBox[{7710, 7711}]}, 
    {Hue[
      NCache[
       Rational[7711, 14307], 0.5389669392605019]], AbsoluteThickness[0.25], 
     LineBox[{7711, 7712}]}, 
    {Hue[
      NCache[
       Rational[7712, 14307], 0.5390368351156777]], AbsoluteThickness[0.25], 
     LineBox[{7712, 7713}]}, 
    {Hue[
      NCache[
       Rational[2571, 4769], 0.5391067309708534]], AbsoluteThickness[0.25], 
     LineBox[{7713, 7714}]}, 
    {Hue[
      NCache[
       Rational[406, 753], 0.5391766268260292]], AbsoluteThickness[0.25], 
     LineBox[{7714, 7715}]}, 
    {Hue[
      NCache[
       Rational[7715, 14307], 0.539246522681205]], AbsoluteThickness[0.25], 
     LineBox[{7715, 7716}]}, 
    {Hue[
      NCache[
       Rational[2572, 4769], 0.5393164185363808]], AbsoluteThickness[0.25], 
     LineBox[{7716, 7717}]}, 
    {Hue[
      NCache[
       Rational[7717, 14307], 0.5393863143915566]], AbsoluteThickness[0.25], 
     LineBox[{7717, 7718}]}, 
    {Hue[
      NCache[
       Rational[7718, 14307], 0.5394562102467324]], AbsoluteThickness[0.25], 
     LineBox[{7718, 7719}]}, 
    {Hue[
      NCache[
       Rational[2573, 4769], 0.5395261061019082]], AbsoluteThickness[0.25], 
     LineBox[{7719, 7720}]}, 
    {Hue[
      NCache[
       Rational[7720, 14307], 0.5395960019570839]], AbsoluteThickness[0.25], 
     LineBox[{7720, 7721}]}, 
    {Hue[
      NCache[
       Rational[7721, 14307], 0.5396658978122597]], AbsoluteThickness[0.25], 
     LineBox[{7721, 7722}]}, 
    {Hue[
      NCache[
       Rational[2574, 4769], 0.5397357936674355]], AbsoluteThickness[0.25], 
     LineBox[{7722, 7723}]}, 
    {Hue[
      NCache[
       Rational[7723, 14307], 0.5398056895226113]], AbsoluteThickness[0.25], 
     LineBox[{7723, 7724}]}, 
    {Hue[
      NCache[
       Rational[7724, 14307], 0.5398755853777871]], AbsoluteThickness[0.25], 
     LineBox[{7724, 7725}]}, 
    {Hue[
      NCache[
       Rational[2575, 4769], 0.5399454812329629]], AbsoluteThickness[0.25], 
     LineBox[{7725, 7726}]}, 
    {Hue[
      NCache[
       Rational[7726, 14307], 0.5400153770881386]], AbsoluteThickness[0.25], 
     LineBox[{7726, 7727}]}, 
    {Hue[
      NCache[
       Rational[7727, 14307], 0.5400852729433144]], AbsoluteThickness[0.25], 
     LineBox[{7727, 7728}]}, 
    {Hue[
      NCache[
       Rational[2576, 4769], 0.5401551687984902]], AbsoluteThickness[0.25], 
     LineBox[{7728, 7729}]}, 
    {Hue[
      NCache[
       Rational[7729, 14307], 0.540225064653666]], AbsoluteThickness[0.25], 
     LineBox[{7729, 7730}]}, 
    {Hue[
      NCache[
       Rational[7730, 14307], 0.5402949605088418]], AbsoluteThickness[0.25], 
     LineBox[{7730, 7731}]}, 
    {Hue[
      NCache[
       Rational[2577, 4769], 0.5403648563640177]], AbsoluteThickness[0.25], 
     LineBox[{7731, 7732}]}, 
    {Hue[
      NCache[
       Rational[7732, 14307], 0.5404347522191933]], AbsoluteThickness[0.25], 
     LineBox[{7732, 7733}]}, 
    {Hue[
      NCache[
       Rational[407, 753], 0.5405046480743692]], AbsoluteThickness[0.25], 
     LineBox[{7733, 7734}]}, 
    {Hue[
      NCache[
       Rational[2578, 4769], 0.540574543929545]], AbsoluteThickness[0.25], 
     LineBox[{7734, 7735}]}, 
    {Hue[
      NCache[
       Rational[7735, 14307], 0.5406444397847208]], AbsoluteThickness[0.25], 
     LineBox[{7735, 7736}]}, 
    {Hue[
      NCache[
       Rational[7736, 14307], 0.5407143356398966]], AbsoluteThickness[0.25], 
     LineBox[{7736, 7737}]}, 
    {Hue[
      NCache[
       Rational[2579, 4769], 0.5407842314950724]], AbsoluteThickness[0.25], 
     LineBox[{7737, 7738}]}, 
    {Hue[
      NCache[
       Rational[7738, 14307], 0.5408541273502482]], AbsoluteThickness[0.25], 
     LineBox[{7738, 7739}]}, 
    {Hue[
      NCache[
       Rational[7739, 14307], 0.5409240232054239]], AbsoluteThickness[0.25], 
     LineBox[{7739, 7740}]}, 
    {Hue[
      NCache[
       Rational[2580, 4769], 0.5409939190605997]], AbsoluteThickness[0.25], 
     LineBox[{7740, 7741}]}, 
    {Hue[
      NCache[
       Rational[7741, 14307], 0.5410638149157755]], AbsoluteThickness[0.25], 
     LineBox[{7741, 7742}]}, 
    {Hue[
      NCache[
       Rational[7742, 14307], 0.5411337107709513]], AbsoluteThickness[0.25], 
     LineBox[{7742, 7743}]}, 
    {Hue[
      NCache[
       Rational[2581, 4769], 0.5412036066261271]], AbsoluteThickness[0.25], 
     LineBox[{7743, 7744}]}, 
    {Hue[
      NCache[
       Rational[7744, 14307], 0.5412735024813029]], AbsoluteThickness[0.25], 
     LineBox[{7744, 7745}]}, 
    {Hue[
      NCache[
       Rational[7745, 14307], 0.5413433983364786]], AbsoluteThickness[0.25], 
     LineBox[{7745, 7746}]}, 
    {Hue[
      NCache[
       Rational[2582, 4769], 0.5414132941916544]], AbsoluteThickness[0.25], 
     LineBox[{7746, 7747}]}, 
    {Hue[
      NCache[
       Rational[7747, 14307], 0.5414831900468302]], AbsoluteThickness[0.25], 
     LineBox[{7747, 7748}]}, 
    {Hue[
      NCache[
       Rational[7748, 14307], 0.541553085902006]], AbsoluteThickness[0.25], 
     LineBox[{7748, 7749}]}, 
    {Hue[
      NCache[
       Rational[2583, 4769], 0.5416229817571818]], AbsoluteThickness[0.25], 
     LineBox[{7749, 7750}]}, 
    {Hue[
      NCache[
       Rational[7750, 14307], 0.5416928776123576]], AbsoluteThickness[0.25], 
     LineBox[{7750, 7751}]}, 
    {Hue[
      NCache[
       Rational[7751, 14307], 0.5417627734675333]], AbsoluteThickness[0.25], 
     LineBox[{7751, 7752}]}, 
    {Hue[
      NCache[
       Rational[136, 251], 0.5418326693227091]], AbsoluteThickness[0.25], 
     LineBox[{7752, 7753}]}, 
    {Hue[
      NCache[
       Rational[7753, 14307], 0.5419025651778849]], AbsoluteThickness[0.25], 
     LineBox[{7753, 7754}]}, 
    {Hue[
      NCache[
       Rational[7754, 14307], 0.5419724610330607]], AbsoluteThickness[0.25], 
     LineBox[{7754, 7755}]}, 
    {Hue[
      NCache[
       Rational[2585, 4769], 0.5420423568882365]], AbsoluteThickness[0.25], 
     LineBox[{7755, 7756}]}, 
    {Hue[
      NCache[
       Rational[7756, 14307], 0.5421122527434123]], AbsoluteThickness[0.25], 
     LineBox[{7756, 7757}]}, 
    {Hue[
      NCache[
       Rational[7757, 14307], 0.5421821485985882]], AbsoluteThickness[0.25], 
     LineBox[{7757, 7758}]}, 
    {Hue[
      NCache[
       Rational[2586, 4769], 0.5422520444537638]], AbsoluteThickness[0.25], 
     LineBox[{7758, 7759}]}, 
    {Hue[
      NCache[
       Rational[7759, 14307], 0.5423219403089397]], AbsoluteThickness[0.25], 
     LineBox[{7759, 7760}]}, 
    {Hue[
      NCache[
       Rational[7760, 14307], 0.5423918361641155]], AbsoluteThickness[0.25], 
     LineBox[{7760, 7761}]}, 
    {Hue[
      NCache[
       Rational[2587, 4769], 0.5424617320192913]], AbsoluteThickness[0.25], 
     LineBox[{7761, 7762}]}, 
    {Hue[
      NCache[
       Rational[7762, 14307], 0.5425316278744671]], AbsoluteThickness[0.25], 
     LineBox[{7762, 7763}]}, 
    {Hue[
      NCache[
       Rational[7763, 14307], 0.5426015237296429]], AbsoluteThickness[0.25], 
     LineBox[{7763, 7764}]}, 
    {Hue[
      NCache[
       Rational[2588, 4769], 0.5426714195848186]], AbsoluteThickness[0.25], 
     LineBox[{7764, 7765}]}, 
    {Hue[
      NCache[
       Rational[7765, 14307], 0.5427413154399944]], AbsoluteThickness[0.25], 
     LineBox[{7765, 7766}]}, 
    {Hue[
      NCache[
       Rational[7766, 14307], 0.5428112112951702]], AbsoluteThickness[0.25], 
     LineBox[{7766, 7767}]}, 
    {Hue[
      NCache[
       Rational[2589, 4769], 0.542881107150346]], AbsoluteThickness[0.25], 
     LineBox[{7767, 7768}]}, 
    {Hue[
      NCache[
       Rational[7768, 14307], 0.5429510030055218]], AbsoluteThickness[0.25], 
     LineBox[{7768, 7769}]}, 
    {Hue[
      NCache[
       Rational[7769, 14307], 0.5430208988606976]], AbsoluteThickness[0.25], 
     LineBox[{7769, 7770}]}, 
    {Hue[
      NCache[
       Rational[2590, 4769], 0.5430907947158734]], AbsoluteThickness[0.25], 
     LineBox[{7770, 7771}]}, 
    {Hue[
      NCache[
       Rational[409, 753], 0.5431606905710491]], AbsoluteThickness[0.25], 
     LineBox[{7771, 7772}]}, 
    {Hue[
      NCache[
       Rational[7772, 14307], 0.5432305864262249]], AbsoluteThickness[0.25], 
     LineBox[{7772, 7773}]}, 
    {Hue[
      NCache[
       Rational[2591, 4769], 0.5433004822814007]], AbsoluteThickness[0.25], 
     LineBox[{7773, 7774}]}, 
    {Hue[
      NCache[
       Rational[7774, 14307], 0.5433703781365765]], AbsoluteThickness[0.25], 
     LineBox[{7774, 7775}]}, 
    {Hue[
      NCache[
       Rational[7775, 14307], 0.5434402739917523]], AbsoluteThickness[0.25], 
     LineBox[{7775, 7776}]}, 
    {Hue[
      NCache[
       Rational[2592, 4769], 0.5435101698469281]], AbsoluteThickness[0.25], 
     LineBox[{7776, 7777}]}, 
    {Hue[
      NCache[
       Rational[7777, 14307], 0.5435800657021038]], AbsoluteThickness[0.25], 
     LineBox[{7777, 7778}]}, 
    {Hue[
      NCache[
       Rational[7778, 14307], 0.5436499615572796]], AbsoluteThickness[0.25], 
     LineBox[{7778, 7779}]}, 
    {Hue[
      NCache[
       Rational[2593, 4769], 0.5437198574124554]], AbsoluteThickness[0.25], 
     LineBox[{7779, 7780}]}, 
    {Hue[
      NCache[
       Rational[7780, 14307], 0.5437897532676312]], AbsoluteThickness[0.25], 
     LineBox[{7780, 7781}]}, 
    {Hue[
      NCache[
       Rational[31, 57], 0.543859649122807]], AbsoluteThickness[0.25], 
     LineBox[{7781, 7782}]}, 
    {Hue[
      NCache[
       Rational[2594, 4769], 0.5439295449779828]], AbsoluteThickness[0.25], 
     LineBox[{7782, 7783}]}, 
    {Hue[
      NCache[
       Rational[7783, 14307], 0.5439994408331585]], AbsoluteThickness[0.25], 
     LineBox[{7783, 7784}]}, 
    {Hue[
      NCache[
       Rational[7784, 14307], 0.5440693366883343]], AbsoluteThickness[0.25], 
     LineBox[{7784, 7785}]}, 
    {Hue[
      NCache[
       Rational[2595, 4769], 0.5441392325435102]], AbsoluteThickness[0.25], 
     LineBox[{7785, 7786}]}, 
    {Hue[
      NCache[
       Rational[7786, 14307], 0.544209128398686]], AbsoluteThickness[0.25], 
     LineBox[{7786, 7787}]}, 
    {Hue[
      NCache[
       Rational[7787, 14307], 0.5442790242538618]], AbsoluteThickness[0.25], 
     LineBox[{7787, 7788}]}, 
    {Hue[
      NCache[
       Rational[2596, 4769], 0.5443489201090376]], AbsoluteThickness[0.25], 
     LineBox[{7788, 7789}]}, 
    {Hue[
      NCache[
       Rational[7789, 14307], 0.5444188159642134]], AbsoluteThickness[0.25], 
     LineBox[{7789, 7790}]}, 
    {Hue[
      NCache[
       Rational[410, 753], 0.5444887118193891]], AbsoluteThickness[0.25], 
     LineBox[{7790, 7791}]}, 
    {Hue[
      NCache[
       Rational[2597, 4769], 0.5445586076745649]], AbsoluteThickness[0.25], 
     LineBox[{7791, 7792}]}, 
    {Hue[
      NCache[
       Rational[7792, 14307], 0.5446285035297407]], AbsoluteThickness[0.25], 
     LineBox[{7792, 7793}]}, 
    {Hue[
      NCache[
       Rational[7793, 14307], 0.5446983993849165]], AbsoluteThickness[0.25], 
     LineBox[{7793, 7794}]}, 
    {Hue[
      NCache[
       Rational[2598, 4769], 0.5447682952400923]], AbsoluteThickness[0.25], 
     LineBox[{7794, 7795}]}, 
    {Hue[
      NCache[
       Rational[7795, 14307], 0.5448381910952681]], AbsoluteThickness[0.25], 
     LineBox[{7795, 7796}]}, 
    {Hue[
      NCache[
       Rational[7796, 14307], 0.5449080869504438]], AbsoluteThickness[0.25], 
     LineBox[{7796, 7797}]}, 
    {Hue[
      NCache[
       Rational[2599, 4769], 0.5449779828056196]], AbsoluteThickness[0.25], 
     LineBox[{7797, 7798}]}, 
    {Hue[
      NCache[
       Rational[7798, 14307], 0.5450478786607954]], AbsoluteThickness[0.25], 
     LineBox[{7798, 7799}]}, 
    {Hue[
      NCache[
       Rational[7799, 14307], 0.5451177745159712]], AbsoluteThickness[0.25], 
     LineBox[{7799, 7800}]}, 
    {Hue[
      NCache[
       Rational[2600, 4769], 0.545187670371147]], AbsoluteThickness[0.25], 
     LineBox[{7800, 7801}]}, 
    {Hue[
      NCache[
       Rational[7801, 14307], 0.5452575662263228]], AbsoluteThickness[0.25], 
     LineBox[{7801, 7802}]}, 
    {Hue[
      NCache[
       Rational[7802, 14307], 0.5453274620814985]], AbsoluteThickness[0.25], 
     LineBox[{7802, 7803}]}, 
    {Hue[
      NCache[
       Rational[2601, 4769], 0.5453973579366743]], AbsoluteThickness[0.25], 
     LineBox[{7803, 7804}]}, 
    {Hue[
      NCache[
       Rational[7804, 14307], 0.5454672537918501]], AbsoluteThickness[0.25], 
     LineBox[{7804, 7805}]}, 
    {Hue[
      NCache[
       Rational[7805, 14307], 0.5455371496470259]], AbsoluteThickness[0.25], 
     LineBox[{7805, 7806}]}, 
    {Hue[
      NCache[
       Rational[2602, 4769], 0.5456070455022017]], AbsoluteThickness[0.25], 
     LineBox[{7806, 7807}]}, 
    {Hue[
      NCache[
       Rational[7807, 14307], 0.5456769413573775]], AbsoluteThickness[0.25], 
     LineBox[{7807, 7808}]}, 
    {Hue[
      NCache[
       Rational[7808, 14307], 0.5457468372125533]], AbsoluteThickness[0.25], 
     LineBox[{7808, 7809}]}, 
    {Hue[
      NCache[
       Rational[137, 251], 0.545816733067729]], AbsoluteThickness[0.25], 
     LineBox[{7809, 7810}]}, 
    {Hue[
      NCache[
       Rational[7810, 14307], 0.5458866289229048]], AbsoluteThickness[0.25], 
     LineBox[{7810, 7811}]}, 
    {Hue[
      NCache[
       Rational[7811, 14307], 0.5459565247780807]], AbsoluteThickness[0.25], 
     LineBox[{7811, 7812}]}, 
    {Hue[
      NCache[
       Rational[2604, 4769], 0.5460264206332565]], AbsoluteThickness[0.25], 
     LineBox[{7812, 7813}]}, 
    {Hue[
      NCache[
       Rational[7813, 14307], 0.5460963164884323]], AbsoluteThickness[0.25], 
     LineBox[{7813, 7814}]}, 
    {Hue[
      NCache[
       Rational[7814, 14307], 0.5461662123436081]], AbsoluteThickness[0.25], 
     LineBox[{7814, 7815}]}, 
    {Hue[
      NCache[
       Rational[2605, 4769], 0.5462361081987838]], AbsoluteThickness[0.25], 
     LineBox[{7815, 7816}]}, 
    {Hue[
      NCache[
       Rational[7816, 14307], 0.5463060040539596]], AbsoluteThickness[0.25], 
     LineBox[{7816, 7817}]}, 
    {Hue[
      NCache[
       Rational[7817, 14307], 0.5463758999091354]], AbsoluteThickness[0.25], 
     LineBox[{7817, 7818}]}, 
    {Hue[
      NCache[
       Rational[2606, 4769], 0.5464457957643112]], AbsoluteThickness[0.25], 
     LineBox[{7818, 7819}]}, 
    {Hue[
      NCache[
       Rational[7819, 14307], 0.546515691619487]], AbsoluteThickness[0.25], 
     LineBox[{7819, 7820}]}, 
    {Hue[
      NCache[
       Rational[7820, 14307], 0.5465855874746628]], AbsoluteThickness[0.25], 
     LineBox[{7820, 7821}]}, 
    {Hue[
      NCache[
       Rational[2607, 4769], 0.5466554833298385]], AbsoluteThickness[0.25], 
     LineBox[{7821, 7822}]}, 
    {Hue[
      NCache[
       Rational[7822, 14307], 0.5467253791850143]], AbsoluteThickness[0.25], 
     LineBox[{7822, 7823}]}, 
    {Hue[
      NCache[
       Rational[7823, 14307], 0.5467952750401901]], AbsoluteThickness[0.25], 
     LineBox[{7823, 7824}]}, 
    {Hue[
      NCache[
       Rational[2608, 4769], 0.5468651708953659]], AbsoluteThickness[0.25], 
     LineBox[{7824, 7825}]}, 
    {Hue[
      NCache[
       Rational[7825, 14307], 0.5469350667505417]], AbsoluteThickness[0.25], 
     LineBox[{7825, 7826}]}, 
    {Hue[
      NCache[
       Rational[7826, 14307], 0.5470049626057175]], AbsoluteThickness[0.25], 
     LineBox[{7826, 7827}]}, 
    {Hue[
      NCache[
       Rational[2609, 4769], 0.5470748584608933]], AbsoluteThickness[0.25], 
     LineBox[{7827, 7828}]}, 
    {Hue[
      NCache[
       Rational[412, 753], 0.547144754316069]], AbsoluteThickness[0.25], 
     LineBox[{7828, 7829}]}, 
    {Hue[
      NCache[
       Rational[7829, 14307], 0.5472146501712448]], AbsoluteThickness[0.25], 
     LineBox[{7829, 7830}]}, 
    {Hue[
      NCache[
       Rational[2610, 4769], 0.5472845460264206]], AbsoluteThickness[0.25], 
     LineBox[{7830, 7831}]}, 
    {Hue[
      NCache[
       Rational[7831, 14307], 0.5473544418815964]], AbsoluteThickness[0.25], 
     LineBox[{7831, 7832}]}, 
    {Hue[
      NCache[
       Rational[7832, 14307], 0.5474243377367722]], AbsoluteThickness[0.25], 
     LineBox[{7832, 7833}]}, 
    {Hue[
      NCache[
       Rational[2611, 4769], 0.547494233591948]], AbsoluteThickness[0.25], 
     LineBox[{7833, 7834}]}, 
    {Hue[
      NCache[
       Rational[7834, 14307], 0.5475641294471237]], AbsoluteThickness[0.25], 
     LineBox[{7834, 7835}]}, 
    {Hue[
      NCache[
       Rational[7835, 14307], 0.5476340253022995]], AbsoluteThickness[0.25], 
     LineBox[{7835, 7836}]}, 
    {Hue[
      NCache[
       Rational[2612, 4769], 0.5477039211574753]], AbsoluteThickness[0.25], 
     LineBox[{7836, 7837}]}, 
    {Hue[
      NCache[
       Rational[7837, 14307], 0.5477738170126512]], AbsoluteThickness[0.25], 
     LineBox[{7837, 7838}]}, 
    {Hue[
      NCache[
       Rational[7838, 14307], 0.547843712867827]], AbsoluteThickness[0.25], 
     LineBox[{7838, 7839}]}, 
    {Hue[
      NCache[
       Rational[2613, 4769], 0.5479136087230028]], AbsoluteThickness[0.25], 
     LineBox[{7839, 7840}]}, 
    {Hue[
      NCache[
       Rational[7840, 14307], 0.5479835045781785]], AbsoluteThickness[0.25], 
     LineBox[{7840, 7841}]}, 
    {Hue[
      NCache[
       Rational[7841, 14307], 0.5480534004333543]], AbsoluteThickness[0.25], 
     LineBox[{7841, 7842}]}, 
    {Hue[
      NCache[
       Rational[2614, 4769], 0.5481232962885301]], AbsoluteThickness[0.25], 
     LineBox[{7842, 7843}]}, 
    {Hue[
      NCache[
       Rational[7843, 14307], 0.5481931921437059]], AbsoluteThickness[0.25], 
     LineBox[{7843, 7844}]}, 
    {Hue[
      NCache[
       Rational[7844, 14307], 0.5482630879988817]], AbsoluteThickness[0.25], 
     LineBox[{7844, 7845}]}, 
    {Hue[
      NCache[
       Rational[2615, 4769], 0.5483329838540575]], AbsoluteThickness[0.25], 
     LineBox[{7845, 7846}]}, 
    {Hue[
      NCache[
       Rational[7846, 14307], 0.5484028797092333]], AbsoluteThickness[0.25], 
     LineBox[{7846, 7847}]}, 
    {Hue[
      NCache[
       Rational[413, 753], 0.548472775564409]], AbsoluteThickness[0.25], 
     LineBox[{7847, 7848}]}, 
    {Hue[
      NCache[
       Rational[2616, 4769], 0.5485426714195848]], AbsoluteThickness[0.25], 
     LineBox[{7848, 7849}]}, 
    {Hue[
      NCache[
       Rational[7849, 14307], 0.5486125672747606]], AbsoluteThickness[0.25], 
     LineBox[{7849, 7850}]}, 
    {Hue[
      NCache[
       Rational[7850, 14307], 0.5486824631299364]], AbsoluteThickness[0.25], 
     LineBox[{7850, 7851}]}, 
    {Hue[
      NCache[
       Rational[2617, 4769], 0.5487523589851122]], AbsoluteThickness[0.25], 
     LineBox[{7851, 7852}]}, 
    {Hue[
      NCache[
       Rational[7852, 14307], 0.548822254840288]], AbsoluteThickness[0.25], 
     LineBox[{7852, 7853}]}, 
    {Hue[
      NCache[
       Rational[7853, 14307], 0.5488921506954637]], AbsoluteThickness[0.25], 
     LineBox[{7853, 7854}]}, 
    {Hue[
      NCache[
       Rational[2618, 4769], 0.5489620465506395]], AbsoluteThickness[0.25], 
     LineBox[{7854, 7855}]}, 
    {Hue[
      NCache[
       Rational[7855, 14307], 0.5490319424058153]], AbsoluteThickness[0.25], 
     LineBox[{7855, 7856}]}, 
    {Hue[
      NCache[
       Rational[7856, 14307], 0.5491018382609911]], AbsoluteThickness[0.25], 
     LineBox[{7856, 7857}]}, 
    {Hue[
      NCache[
       Rational[2619, 4769], 0.5491717341161669]], AbsoluteThickness[0.25], 
     LineBox[{7857, 7858}]}, 
    {Hue[
      NCache[
       Rational[7858, 14307], 0.5492416299713427]], AbsoluteThickness[0.25], 
     LineBox[{7858, 7859}]}, 
    {Hue[
      NCache[
       Rational[7859, 14307], 0.5493115258265184]], AbsoluteThickness[0.25], 
     LineBox[{7859, 7860}]}, 
    {Hue[
      NCache[
       Rational[2620, 4769], 0.5493814216816942]], AbsoluteThickness[0.25], 
     LineBox[{7860, 7861}]}, 
    {Hue[
      NCache[
       Rational[7861, 14307], 0.54945131753687]], AbsoluteThickness[0.25], 
     LineBox[{7861, 7862}]}, 
    {Hue[
      NCache[
       Rational[7862, 14307], 0.5495212133920458]], AbsoluteThickness[0.25], 
     LineBox[{7862, 7863}]}, 
    {Hue[
      NCache[
       Rational[2621, 4769], 0.5495911092472217]], AbsoluteThickness[0.25], 
     LineBox[{7863, 7864}]}, 
    {Hue[
      NCache[
       Rational[7864, 14307], 0.5496610051023975]], AbsoluteThickness[0.25], 
     LineBox[{7864, 7865}]}, 
    {Hue[
      NCache[
       Rational[7865, 14307], 0.5497309009575733]], AbsoluteThickness[0.25], 
     LineBox[{7865, 7866}]}, 
    {Hue[
      NCache[
       Rational[138, 251], 0.549800796812749]], AbsoluteThickness[0.25], 
     LineBox[{7866, 7867}]}, 
    {Hue[
      NCache[
       Rational[7867, 14307], 0.5498706926679248]], AbsoluteThickness[0.25], 
     LineBox[{7867, 7868}]}, 
    {Hue[
      NCache[
       Rational[7868, 14307], 0.5499405885231006]], AbsoluteThickness[0.25], 
     LineBox[{7868, 7869}]}, 
    {Hue[
      NCache[
       Rational[2623, 4769], 0.5500104843782764]], AbsoluteThickness[0.25], 
     LineBox[{7869, 7870}]}, 
    {Hue[
      NCache[
       Rational[7870, 14307], 0.5500803802334522]], AbsoluteThickness[0.25], 
     LineBox[{7870, 7871}]}, 
    {Hue[
      NCache[
       Rational[7871, 14307], 0.550150276088628]], AbsoluteThickness[0.25], 
     LineBox[{7871, 7872}]}, 
    {Hue[
      NCache[
       Rational[2624, 4769], 0.5502201719438037]], AbsoluteThickness[0.25], 
     LineBox[{7872, 7873}]}, 
    {Hue[
      NCache[
       Rational[7873, 14307], 0.5502900677989795]], AbsoluteThickness[0.25], 
     LineBox[{7873, 7874}]}, 
    {Hue[
      NCache[
       Rational[7874, 14307], 0.5503599636541553]], AbsoluteThickness[0.25], 
     LineBox[{7874, 7875}]}, 
    {Hue[
      NCache[
       Rational[2625, 4769], 0.5504298595093311]], AbsoluteThickness[0.25], 
     LineBox[{7875, 7876}]}, 
    {Hue[
      NCache[
       Rational[7876, 14307], 0.5504997553645069]], AbsoluteThickness[0.25], 
     LineBox[{7876, 7877}]}, 
    {Hue[
      NCache[
       Rational[7877, 14307], 0.5505696512196827]], AbsoluteThickness[0.25], 
     LineBox[{7877, 7878}]}, 
    {Hue[
      NCache[
       Rational[2626, 4769], 0.5506395470748585]], AbsoluteThickness[0.25], 
     LineBox[{7878, 7879}]}, 
    {Hue[
      NCache[
       Rational[7879, 14307], 0.5507094429300342]], AbsoluteThickness[0.25], 
     LineBox[{7879, 7880}]}, 
    {Hue[
      NCache[
       Rational[7880, 14307], 0.55077933878521]], AbsoluteThickness[0.25], 
     LineBox[{7880, 7881}]}, 
    {Hue[
      NCache[
       Rational[2627, 4769], 0.5508492346403858]], AbsoluteThickness[0.25], 
     LineBox[{7881, 7882}]}, 
    {Hue[
      NCache[
       Rational[7882, 14307], 0.5509191304955616]], AbsoluteThickness[0.25], 
     LineBox[{7882, 7883}]}, 
    {Hue[
      NCache[
       Rational[7883, 14307], 0.5509890263507374]], AbsoluteThickness[0.25], 
     LineBox[{7883, 7884}]}, 
    {Hue[
      NCache[
       Rational[2628, 4769], 0.5510589222059132]], AbsoluteThickness[0.25], 
     LineBox[{7884, 7885}]}, 
    {Hue[
      NCache[
       Rational[415, 753], 0.5511288180610889]], AbsoluteThickness[0.25], 
     LineBox[{7885, 7886}]}, 
    {Hue[
      NCache[
       Rational[7886, 14307], 0.5511987139162647]], AbsoluteThickness[0.25], 
     LineBox[{7886, 7887}]}, 
    {Hue[
      NCache[
       Rational[2629, 4769], 0.5512686097714405]], AbsoluteThickness[0.25], 
     LineBox[{7887, 7888}]}, 
    {Hue[
      NCache[
       Rational[7888, 14307], 0.5513385056266163]], AbsoluteThickness[0.25], 
     LineBox[{7888, 7889}]}, 
    {Hue[
      NCache[
       Rational[7889, 14307], 0.5514084014817922]], AbsoluteThickness[0.25], 
     LineBox[{7889, 7890}]}, 
    {Hue[
      NCache[
       Rational[2630, 4769], 0.551478297336968]], AbsoluteThickness[0.25], 
     LineBox[{7890, 7891}]}, 
    {Hue[
      NCache[
       Rational[7891, 14307], 0.5515481931921437]], AbsoluteThickness[0.25], 
     LineBox[{7891, 7892}]}, 
    {Hue[
      NCache[
       Rational[7892, 14307], 0.5516180890473195]], AbsoluteThickness[0.25], 
     LineBox[{7892, 7893}]}, 
    {Hue[
      NCache[
       Rational[2631, 4769], 0.5516879849024953]], AbsoluteThickness[0.25], 
     LineBox[{7893, 7894}]}, 
    {Hue[
      NCache[
       Rational[7894, 14307], 0.5517578807576711]], AbsoluteThickness[0.25], 
     LineBox[{7894, 7895}]}, 
    {Hue[
      NCache[
       Rational[7895, 14307], 0.5518277766128469]], AbsoluteThickness[0.25], 
     LineBox[{7895, 7896}]}, 
    {Hue[
      NCache[
       Rational[2632, 4769], 0.5518976724680227]], AbsoluteThickness[0.25], 
     LineBox[{7896, 7897}]}, 
    {Hue[
      NCache[
       Rational[7897, 14307], 0.5519675683231985]], AbsoluteThickness[0.25], 
     LineBox[{7897, 7898}]}, 
    {Hue[
      NCache[
       Rational[7898, 14307], 0.5520374641783742]], AbsoluteThickness[0.25], 
     LineBox[{7898, 7899}]}, 
    {Hue[
      NCache[
       Rational[2633, 4769], 0.55210736003355]], AbsoluteThickness[0.25], 
     LineBox[{7899, 7900}]}, 
    {Hue[
      NCache[
       Rational[7900, 14307], 0.5521772558887258]], AbsoluteThickness[0.25], 
     LineBox[{7900, 7901}]}, 
    {Hue[
      NCache[
       Rational[7901, 14307], 0.5522471517439016]], AbsoluteThickness[0.25], 
     LineBox[{7901, 7902}]}, 
    {Hue[
      NCache[
       Rational[2634, 4769], 0.5523170475990774]], AbsoluteThickness[0.25], 
     LineBox[{7902, 7903}]}, 
    {Hue[
      NCache[
       Rational[7903, 14307], 0.5523869434542532]], AbsoluteThickness[0.25], 
     LineBox[{7903, 7904}]}, 
    {Hue[
      NCache[
       Rational[416, 753], 0.5524568393094289]], AbsoluteThickness[0.25], 
     LineBox[{7904, 7905}]}, 
    {Hue[
      NCache[
       Rational[2635, 4769], 0.5525267351646047]], AbsoluteThickness[0.25], 
     LineBox[{7905, 7906}]}, 
    {Hue[
      NCache[
       Rational[7906, 14307], 0.5525966310197805]], AbsoluteThickness[0.25], 
     LineBox[{7906, 7907}]}, 
    {Hue[
      NCache[
       Rational[7907, 14307], 0.5526665268749563]], AbsoluteThickness[0.25], 
     LineBox[{7907, 7908}]}, 
    {Hue[
      NCache[
       Rational[2636, 4769], 0.5527364227301321]], AbsoluteThickness[0.25], 
     LineBox[{7908, 7909}]}, 
    {Hue[
      NCache[
       Rational[7909, 14307], 0.5528063185853079]], AbsoluteThickness[0.25], 
     LineBox[{7909, 7910}]}, 
    {Hue[
      NCache[
       Rational[7910, 14307], 0.5528762144404836]], AbsoluteThickness[0.25], 
     LineBox[{7910, 7911}]}, 
    {Hue[
      NCache[
       Rational[2637, 4769], 0.5529461102956594]], AbsoluteThickness[0.25], 
     LineBox[{7911, 7912}]}, 
    {Hue[
      NCache[
       Rational[7912, 14307], 0.5530160061508352]], AbsoluteThickness[0.25], 
     LineBox[{7912, 7913}]}, 
    {Hue[
      NCache[
       Rational[7913, 14307], 0.553085902006011]], AbsoluteThickness[0.25], 
     LineBox[{7913, 7914}]}, 
    {Hue[
      NCache[
       Rational[2638, 4769], 0.5531557978611868]], AbsoluteThickness[0.25], 
     LineBox[{7914, 7915}]}, 
    {Hue[
      NCache[
       Rational[7915, 14307], 0.5532256937163627]], AbsoluteThickness[0.25], 
     LineBox[{7915, 7916}]}, 
    {Hue[
      NCache[
       Rational[7916, 14307], 0.5532955895715385]], AbsoluteThickness[0.25], 
     LineBox[{7916, 7917}]}, 
    {Hue[
      NCache[
       Rational[2639, 4769], 0.5533654854267142]], AbsoluteThickness[0.25], 
     LineBox[{7917, 7918}]}, 
    {Hue[
      NCache[
       Rational[7918, 14307], 0.55343538128189]], AbsoluteThickness[0.25], 
     LineBox[{7918, 7919}]}, 
    {Hue[
      NCache[
       Rational[7919, 14307], 0.5535052771370658]], AbsoluteThickness[0.25], 
     LineBox[{7919, 7920}]}, 
    {Hue[
      NCache[
       Rational[2640, 4769], 0.5535751729922416]], AbsoluteThickness[0.25], 
     LineBox[{7920, 7921}]}, 
    {Hue[
      NCache[
       Rational[7921, 14307], 0.5536450688474174]], AbsoluteThickness[0.25], 
     LineBox[{7921, 7922}]}, 
    {Hue[
      NCache[
       Rational[7922, 14307], 0.5537149647025932]], AbsoluteThickness[0.25], 
     LineBox[{7922, 7923}]}, 
    {Hue[
      NCache[
       Rational[139, 251], 0.5537848605577689]], AbsoluteThickness[0.25], 
     LineBox[{7923, 7924}]}, 
    {Hue[
      NCache[
       Rational[7924, 14307], 0.5538547564129447]], AbsoluteThickness[0.25], 
     LineBox[{7924, 7925}]}, 
    {Hue[
      NCache[
       Rational[7925, 14307], 0.5539246522681205]], AbsoluteThickness[0.25], 
     LineBox[{7925, 7926}]}, 
    {Hue[
      NCache[
       Rational[2642, 4769], 0.5539945481232963]], AbsoluteThickness[0.25], 
     LineBox[{7926, 7927}]}, 
    {Hue[
      NCache[
       Rational[7927, 14307], 0.5540644439784721]], AbsoluteThickness[0.25], 
     LineBox[{7927, 7928}]}, 
    {Hue[
      NCache[
       Rational[7928, 14307], 0.5541343398336479]], AbsoluteThickness[0.25], 
     LineBox[{7928, 7929}]}, 
    {Hue[
      NCache[
       Rational[2643, 4769], 0.5542042356888236]], AbsoluteThickness[0.25], 
     LineBox[{7929, 7930}]}, 
    {Hue[
      NCache[
       Rational[7930, 14307], 0.5542741315439994]], AbsoluteThickness[0.25], 
     LineBox[{7930, 7931}]}, 
    {Hue[
      NCache[
       Rational[7931, 14307], 0.5543440273991752]], AbsoluteThickness[0.25], 
     LineBox[{7931, 7932}]}, 
    {Hue[
      NCache[
       Rational[2644, 4769], 0.554413923254351]], AbsoluteThickness[0.25], 
     LineBox[{7932, 7933}]}, 
    {Hue[
      NCache[
       Rational[7933, 14307], 0.5544838191095268]], AbsoluteThickness[0.25], 
     LineBox[{7933, 7934}]}, 
    {Hue[
      NCache[
       Rational[7934, 14307], 0.5545537149647026]], AbsoluteThickness[0.25], 
     LineBox[{7934, 7935}]}, 
    {Hue[
      NCache[
       Rational[2645, 4769], 0.5546236108198784]], AbsoluteThickness[0.25], 
     LineBox[{7935, 7936}]}, 
    {Hue[
      NCache[
       Rational[7936, 14307], 0.5546935066750541]], AbsoluteThickness[0.25], 
     LineBox[{7936, 7937}]}, 
    {Hue[
      NCache[
       Rational[7937, 14307], 0.5547634025302299]], AbsoluteThickness[0.25], 
     LineBox[{7937, 7938}]}, 
    {Hue[
      NCache[
       Rational[2646, 4769], 0.5548332983854057]], AbsoluteThickness[0.25], 
     LineBox[{7938, 7939}]}, 
    {Hue[
      NCache[
       Rational[7939, 14307], 0.5549031942405815]], AbsoluteThickness[0.25], 
     LineBox[{7939, 7940}]}, 
    {Hue[
      NCache[
       Rational[7940, 14307], 0.5549730900957573]], AbsoluteThickness[0.25], 
     LineBox[{7940, 7941}]}, 
    {Hue[
      NCache[
       Rational[2647, 4769], 0.5550429859509332]], AbsoluteThickness[0.25], 
     LineBox[{7941, 7942}]}, 
    {Hue[
      NCache[
       Rational[418, 753], 0.5551128818061088]], AbsoluteThickness[0.25], 
     LineBox[{7942, 7943}]}, 
    {Hue[
      NCache[
       Rational[7943, 14307], 0.5551827776612847]], AbsoluteThickness[0.25], 
     LineBox[{7943, 7944}]}, 
    {Hue[
      NCache[
       Rational[2648, 4769], 0.5552526735164605]], AbsoluteThickness[0.25], 
     LineBox[{7944, 7945}]}, 
    {Hue[
      NCache[
       Rational[7945, 14307], 0.5553225693716363]], AbsoluteThickness[0.25], 
     LineBox[{7945, 7946}]}, 
    {Hue[
      NCache[
       Rational[7946, 14307], 0.5553924652268121]], AbsoluteThickness[0.25], 
     LineBox[{7946, 7947}]}, 
    {Hue[
      NCache[
       Rational[2649, 4769], 0.5554623610819879]], AbsoluteThickness[0.25], 
     LineBox[{7947, 7948}]}, 
    {Hue[
      NCache[
       Rational[7948, 14307], 0.5555322569371636]], AbsoluteThickness[0.25], 
     LineBox[{7948, 7949}]}, 
    {Hue[
      NCache[
       Rational[7949, 14307], 0.5556021527923394]], AbsoluteThickness[0.25], 
     LineBox[{7949, 7950}]}, 
    {Hue[
      NCache[
       Rational[2650, 4769], 0.5556720486475152]], AbsoluteThickness[0.25], 
     LineBox[{7950, 7951}]}, 
    {Hue[
      NCache[
       Rational[7951, 14307], 0.555741944502691]], AbsoluteThickness[0.25], 
     LineBox[{7951, 7952}]}, 
    {Hue[
      NCache[
       Rational[7952, 14307], 0.5558118403578668]], AbsoluteThickness[0.25], 
     LineBox[{7952, 7953}]}, 
    {Hue[
      NCache[
       Rational[2651, 4769], 0.5558817362130426]], AbsoluteThickness[0.25], 
     LineBox[{7953, 7954}]}, 
    {Hue[
      NCache[
       Rational[7954, 14307], 0.5559516320682184]], AbsoluteThickness[0.25], 
     LineBox[{7954, 7955}]}, 
    {Hue[
      NCache[
       Rational[7955, 14307], 0.5560215279233941]], AbsoluteThickness[0.25], 
     LineBox[{7955, 7956}]}, 
    {Hue[
      NCache[
       Rational[2652, 4769], 0.5560914237785699]], AbsoluteThickness[0.25], 
     LineBox[{7956, 7957}]}, 
    {Hue[
      NCache[
       Rational[7957, 14307], 0.5561613196337457]], AbsoluteThickness[0.25], 
     LineBox[{7957, 7958}]}, 
    {Hue[
      NCache[
       Rational[7958, 14307], 0.5562312154889215]], AbsoluteThickness[0.25], 
     LineBox[{7958, 7959}]}, 
    {Hue[
      NCache[
       Rational[2653, 4769], 0.5563011113440973]], AbsoluteThickness[0.25], 
     LineBox[{7959, 7960}]}, 
    {Hue[
      NCache[
       Rational[7960, 14307], 0.5563710071992731]], AbsoluteThickness[0.25], 
     LineBox[{7960, 7961}]}, 
    {Hue[
      NCache[
       Rational[419, 753], 0.5564409030544488]], AbsoluteThickness[0.25], 
     LineBox[{7961, 7962}]}, 
    {Hue[
      NCache[
       Rational[2654, 4769], 0.5565107989096246]], AbsoluteThickness[0.25], 
     LineBox[{7962, 7963}]}, 
    {Hue[
      NCache[
       Rational[7963, 14307], 0.5565806947648004]], AbsoluteThickness[0.25], 
     LineBox[{7963, 7964}]}, 
    {Hue[
      NCache[
       Rational[7964, 14307], 0.5566505906199762]], AbsoluteThickness[0.25], 
     LineBox[{7964, 7965}]}, 
    {Hue[
      NCache[
       Rational[2655, 4769], 0.556720486475152]], AbsoluteThickness[0.25], 
     LineBox[{7965, 7966}]}, 
    {Hue[
      NCache[
       Rational[7966, 14307], 0.5567903823303278]], AbsoluteThickness[0.25], 
     LineBox[{7966, 7967}]}, 
    {Hue[
      NCache[
       Rational[7967, 14307], 0.5568602781855037]], AbsoluteThickness[0.25], 
     LineBox[{7967, 7968}]}, 
    {Hue[
      NCache[
       Rational[2656, 4769], 0.5569301740406793]], AbsoluteThickness[0.25], 
     LineBox[{7968, 7969}]}, 
    {Hue[
      NCache[
       Rational[7969, 14307], 0.5570000698958552]], AbsoluteThickness[0.25], 
     LineBox[{7969, 7970}]}, 
    {Hue[
      NCache[
       Rational[7970, 14307], 0.557069965751031]], AbsoluteThickness[0.25], 
     LineBox[{7970, 7971}]}, 
    {Hue[
      NCache[
       Rational[2657, 4769], 0.5571398616062068]], AbsoluteThickness[0.25], 
     LineBox[{7971, 7972}]}, 
    {Hue[
      NCache[
       Rational[7972, 14307], 0.5572097574613826]], AbsoluteThickness[0.25], 
     LineBox[{7972, 7973}]}, 
    {Hue[
      NCache[
       Rational[7973, 14307], 0.5572796533165584]], AbsoluteThickness[0.25], 
     LineBox[{7973, 7974}]}, 
    {Hue[
      NCache[
       Rational[2658, 4769], 0.5573495491717341]], AbsoluteThickness[0.25], 
     LineBox[{7974, 7975}]}, 
    {Hue[
      NCache[
       Rational[7975, 14307], 0.5574194450269099]], AbsoluteThickness[0.25], 
     LineBox[{7975, 7976}]}, 
    {Hue[
      NCache[
       Rational[7976, 14307], 0.5574893408820857]], AbsoluteThickness[0.25], 
     LineBox[{7976, 7977}]}, 
    {Hue[
      NCache[
       Rational[2659, 4769], 0.5575592367372615]], AbsoluteThickness[0.25], 
     LineBox[{7977, 7978}]}, 
    {Hue[
      NCache[
       Rational[7978, 14307], 0.5576291325924373]], AbsoluteThickness[0.25], 
     LineBox[{7978, 7979}]}, 
    {Hue[
      NCache[
       Rational[7979, 14307], 0.5576990284476131]], AbsoluteThickness[0.25], 
     LineBox[{7979, 7980}]}, 
    {Hue[
      NCache[
       Rational[140, 251], 0.5577689243027888]], AbsoluteThickness[0.25], 
     LineBox[{7980, 7981}]}, 
    {Hue[
      NCache[
       Rational[7981, 14307], 0.5578388201579646]], AbsoluteThickness[0.25], 
     LineBox[{7981, 7982}]}, 
    {Hue[
      NCache[
       Rational[7982, 14307], 0.5579087160131404]], AbsoluteThickness[0.25], 
     LineBox[{7982, 7983}]}, 
    {Hue[
      NCache[
       Rational[2661, 4769], 0.5579786118683162]], AbsoluteThickness[0.25], 
     LineBox[{7983, 7984}]}, 
    {Hue[
      NCache[
       Rational[7984, 14307], 0.558048507723492]], AbsoluteThickness[0.25], 
     LineBox[{7984, 7985}]}, 
    {Hue[
      NCache[
       Rational[7985, 14307], 0.5581184035786678]], AbsoluteThickness[0.25], 
     LineBox[{7985, 7986}]}, 
    {Hue[
      NCache[
       Rational[2662, 4769], 0.5581882994338436]], AbsoluteThickness[0.25], 
     LineBox[{7986, 7987}]}, 
    {Hue[
      NCache[
       Rational[7987, 14307], 0.5582581952890193]], AbsoluteThickness[0.25], 
     LineBox[{7987, 7988}]}, 
    {Hue[
      NCache[
       Rational[7988, 14307], 0.5583280911441951]], AbsoluteThickness[0.25], 
     LineBox[{7988, 7989}]}, 
    {Hue[
      NCache[
       Rational[2663, 4769], 0.5583979869993709]], AbsoluteThickness[0.25], 
     LineBox[{7989, 7990}]}, 
    {Hue[
      NCache[
       Rational[7990, 14307], 0.5584678828545467]], AbsoluteThickness[0.25], 
     LineBox[{7990, 7991}]}, 
    {Hue[
      NCache[
       Rational[7991, 14307], 0.5585377787097225]], AbsoluteThickness[0.25], 
     LineBox[{7991, 7992}]}, 
    {Hue[
      NCache[
       Rational[2664, 4769], 0.5586076745648983]], AbsoluteThickness[0.25], 
     LineBox[{7992, 7993}]}, 
    {Hue[
      NCache[
       Rational[7993, 14307], 0.558677570420074]], AbsoluteThickness[0.25], 
     LineBox[{7993, 7994}]}, 
    {Hue[
      NCache[
       Rational[7994, 14307], 0.5587474662752498]], AbsoluteThickness[0.25], 
     LineBox[{7994, 7995}]}, 
    {Hue[
      NCache[
       Rational[2665, 4769], 0.5588173621304257]], AbsoluteThickness[0.25], 
     LineBox[{7995, 7996}]}, 
    {Hue[
      NCache[
       Rational[7996, 14307], 0.5588872579856015]], AbsoluteThickness[0.25], 
     LineBox[{7996, 7997}]}, 
    {Hue[
      NCache[
       Rational[7997, 14307], 0.5589571538407773]], AbsoluteThickness[0.25], 
     LineBox[{7997, 7998}]}, 
    {Hue[
      NCache[
       Rational[2666, 4769], 0.5590270496959531]], AbsoluteThickness[0.25], 
     LineBox[{7998, 7999}]}, 
    {Hue[
      NCache[
       Rational[421, 753], 0.5590969455511288]], AbsoluteThickness[0.25], 
     LineBox[{7999, 8000}]}, 
    {Hue[
      NCache[
       Rational[8000, 14307], 0.5591668414063046]], AbsoluteThickness[0.25], 
     LineBox[{8000, 8001}]}, 
    {Hue[
      NCache[
       Rational[2667, 4769], 0.5592367372614804]], AbsoluteThickness[0.25], 
     LineBox[{8001, 8002}]}, 
    {Hue[
      NCache[
       Rational[8002, 14307], 0.5593066331166562]], AbsoluteThickness[0.25], 
     LineBox[{8002, 8003}]}, 
    {Hue[
      NCache[
       Rational[8003, 14307], 0.559376528971832]], AbsoluteThickness[0.25], 
     LineBox[{8003, 8004}]}, 
    {Hue[
      NCache[
       Rational[2668, 4769], 0.5594464248270078]], AbsoluteThickness[0.25], 
     LineBox[{8004, 8005}]}, 
    {Hue[
      NCache[
       Rational[8005, 14307], 0.5595163206821836]], AbsoluteThickness[0.25], 
     LineBox[{8005, 8006}]}, 
    {Hue[
      NCache[
       Rational[8006, 14307], 0.5595862165373593]], AbsoluteThickness[0.25], 
     LineBox[{8006, 8007}]}, 
    {Hue[
      NCache[
       Rational[2669, 4769], 0.5596561123925351]], AbsoluteThickness[0.25], 
     LineBox[{8007, 8008}]}, 
    {Hue[
      NCache[
       Rational[8008, 14307], 0.5597260082477109]], AbsoluteThickness[0.25], 
     LineBox[{8008, 8009}]}, 
    {Hue[
      NCache[
       Rational[8009, 14307], 0.5597959041028867]], AbsoluteThickness[0.25], 
     LineBox[{8009, 8010}]}, 
    {Hue[
      NCache[
       Rational[2670, 4769], 0.5598657999580625]], AbsoluteThickness[0.25], 
     LineBox[{8010, 8011}]}, 
    {Hue[
      NCache[
       Rational[8011, 14307], 0.5599356958132383]], AbsoluteThickness[0.25], 
     LineBox[{8011, 8012}]}, 
    {Hue[
      NCache[
       Rational[8012, 14307], 0.560005591668414]], AbsoluteThickness[0.25], 
     LineBox[{8012, 8013}]}, 
    {Hue[
      NCache[
       Rational[2671, 4769], 0.5600754875235898]], AbsoluteThickness[0.25], 
     LineBox[{8013, 8014}]}, 
    {Hue[
      NCache[
       Rational[8014, 14307], 0.5601453833787656]], AbsoluteThickness[0.25], 
     LineBox[{8014, 8015}]}, 
    {Hue[
      NCache[
       Rational[8015, 14307], 0.5602152792339414]], AbsoluteThickness[0.25], 
     LineBox[{8015, 8016}]}, 
    {Hue[
      NCache[
       Rational[2672, 4769], 0.5602851750891172]], AbsoluteThickness[0.25], 
     LineBox[{8016, 8017}]}, 
    {Hue[
      NCache[
       Rational[8017, 14307], 0.560355070944293]], AbsoluteThickness[0.25], 
     LineBox[{8017, 8018}]}, 
    {Hue[
      NCache[
       Rational[422, 753], 0.5604249667994687]], AbsoluteThickness[0.25], 
     LineBox[{8018, 8019}]}, 
    {Hue[
      NCache[
       Rational[2673, 4769], 0.5604948626546445]], AbsoluteThickness[0.25], 
     LineBox[{8019, 8020}]}, 
    {Hue[
      NCache[
       Rational[8020, 14307], 0.5605647585098203]], AbsoluteThickness[0.25], 
     LineBox[{8020, 8021}]}, 
    {Hue[
      NCache[
       Rational[8021, 14307], 0.5606346543649962]], AbsoluteThickness[0.25], 
     LineBox[{8021, 8022}]}, 
    {Hue[
      NCache[
       Rational[2674, 4769], 0.560704550220172]], AbsoluteThickness[0.25], 
     LineBox[{8022, 8023}]}, 
    {Hue[
      NCache[
       Rational[8023, 14307], 0.5607744460753478]], AbsoluteThickness[0.25], 
     LineBox[{8023, 8024}]}, 
    {Hue[
      NCache[
       Rational[8024, 14307], 0.5608443419305236]], AbsoluteThickness[0.25], 
     LineBox[{8024, 8025}]}, 
    {Hue[
      NCache[
       Rational[2675, 4769], 0.5609142377856993]], AbsoluteThickness[0.25], 
     LineBox[{8025, 8026}]}, 
    {Hue[
      NCache[
       Rational[8026, 14307], 0.5609841336408751]], AbsoluteThickness[0.25], 
     LineBox[{8026, 8027}]}, 
    {Hue[
      NCache[
       Rational[8027, 14307], 0.5610540294960509]], AbsoluteThickness[0.25], 
     LineBox[{8027, 8028}]}, 
    {Hue[
      NCache[
       Rational[2676, 4769], 0.5611239253512267]], AbsoluteThickness[0.25], 
     LineBox[{8028, 8029}]}, 
    {Hue[
      NCache[
       Rational[8029, 14307], 0.5611938212064025]], AbsoluteThickness[0.25], 
     LineBox[{8029, 8030}]}, 
    {Hue[
      NCache[
       Rational[8030, 14307], 0.5612637170615783]], AbsoluteThickness[0.25], 
     LineBox[{8030, 8031}]}, 
    {Hue[
      NCache[
       Rational[2677, 4769], 0.561333612916754]], AbsoluteThickness[0.25], 
     LineBox[{8031, 8032}]}, 
    {Hue[
      NCache[
       Rational[32, 57], 0.5614035087719298]], AbsoluteThickness[0.25], 
     LineBox[{8032, 8033}]}, 
    {Hue[
      NCache[
       Rational[8033, 14307], 0.5614734046271056]], AbsoluteThickness[0.25], 
     LineBox[{8033, 8034}]}, 
    {Hue[
      NCache[
       Rational[2678, 4769], 0.5615433004822814]], AbsoluteThickness[0.25], 
     LineBox[{8034, 8035}]}, 
    {Hue[
      NCache[
       Rational[8035, 14307], 0.5616131963374572]], AbsoluteThickness[0.25], 
     LineBox[{8035, 8036}]}, 
    {Hue[
      NCache[
       Rational[8036, 14307], 0.561683092192633]], AbsoluteThickness[0.25], 
     LineBox[{8036, 8037}]}, 
    {Hue[
      NCache[
       Rational[141, 251], 0.5617529880478087]], AbsoluteThickness[0.25], 
     LineBox[{8037, 8038}]}, 
    {Hue[
      NCache[
       Rational[8038, 14307], 0.5618228839029845]], AbsoluteThickness[0.25], 
     LineBox[{8038, 8039}]}, 
    {Hue[
      NCache[
       Rational[8039, 14307], 0.5618927797581603]], AbsoluteThickness[0.25], 
     LineBox[{8039, 8040}]}, 
    {Hue[
      NCache[
       Rational[2680, 4769], 0.5619626756133361]], AbsoluteThickness[0.25], 
     LineBox[{8040, 8041}]}, 
    {Hue[
      NCache[
       Rational[8041, 14307], 0.5620325714685119]], AbsoluteThickness[0.25], 
     LineBox[{8041, 8042}]}, 
    {Hue[
      NCache[
       Rational[8042, 14307], 0.5621024673236877]], AbsoluteThickness[0.25], 
     LineBox[{8042, 8043}]}, 
    {Hue[
      NCache[
       Rational[2681, 4769], 0.5621723631788635]], AbsoluteThickness[0.25], 
     LineBox[{8043, 8044}]}, 
    {Hue[
      NCache[
       Rational[8044, 14307], 0.5622422590340392]], AbsoluteThickness[0.25], 
     LineBox[{8044, 8045}]}, 
    {Hue[
      NCache[
       Rational[8045, 14307], 0.562312154889215]], AbsoluteThickness[0.25], 
     LineBox[{8045, 8046}]}, 
    {Hue[
      NCache[
       Rational[2682, 4769], 0.5623820507443908]], AbsoluteThickness[0.25], 
     LineBox[{8046, 8047}]}, 
    {Hue[
      NCache[
       Rational[8047, 14307], 0.5624519465995667]], AbsoluteThickness[0.25], 
     LineBox[{8047, 8048}]}, 
    {Hue[
      NCache[
       Rational[8048, 14307], 0.5625218424547425]], AbsoluteThickness[0.25], 
     LineBox[{8048, 8049}]}, 
    {Hue[
      NCache[
       Rational[2683, 4769], 0.5625917383099183]], AbsoluteThickness[0.25], 
     LineBox[{8049, 8050}]}, 
    {Hue[
      NCache[
       Rational[8050, 14307], 0.562661634165094]], AbsoluteThickness[0.25], 
     LineBox[{8050, 8051}]}, 
    {Hue[
      NCache[
       Rational[8051, 14307], 0.5627315300202698]], AbsoluteThickness[0.25], 
     LineBox[{8051, 8052}]}, 
    {Hue[
      NCache[
       Rational[2684, 4769], 0.5628014258754456]], AbsoluteThickness[0.25], 
     LineBox[{8052, 8053}]}, 
    {Hue[
      NCache[
       Rational[8053, 14307], 0.5628713217306214]], AbsoluteThickness[0.25], 
     LineBox[{8053, 8054}]}, 
    {Hue[
      NCache[
       Rational[8054, 14307], 0.5629412175857972]], AbsoluteThickness[0.25], 
     LineBox[{8054, 8055}]}, 
    {Hue[
      NCache[
       Rational[2685, 4769], 0.563011113440973]], AbsoluteThickness[0.25], 
     LineBox[{8055, 8056}]}, 
    {Hue[
      NCache[
       Rational[424, 753], 0.5630810092961488]], AbsoluteThickness[0.25], 
     LineBox[{8056, 8057}]}, 
    {Hue[
      NCache[
       Rational[8057, 14307], 0.5631509051513245]], AbsoluteThickness[0.25], 
     LineBox[{8057, 8058}]}, 
    {Hue[
      NCache[
       Rational[2686, 4769], 0.5632208010065003]], AbsoluteThickness[0.25], 
     LineBox[{8058, 8059}]}, 
    {Hue[
      NCache[
       Rational[8059, 14307], 0.5632906968616761]], AbsoluteThickness[0.25], 
     LineBox[{8059, 8060}]}, 
    {Hue[
      NCache[
       Rational[8060, 14307], 0.5633605927168519]], AbsoluteThickness[0.25], 
     LineBox[{8060, 8061}]}, 
    {Hue[
      NCache[
       Rational[2687, 4769], 0.5634304885720277]], AbsoluteThickness[0.25], 
     LineBox[{8061, 8062}]}, 
    {Hue[
      NCache[
       Rational[8062, 14307], 0.5635003844272035]], AbsoluteThickness[0.25], 
     LineBox[{8062, 8063}]}, 
    {Hue[
      NCache[
       Rational[8063, 14307], 0.5635702802823792]], AbsoluteThickness[0.25], 
     LineBox[{8063, 8064}]}, 
    {Hue[
      NCache[
       Rational[2688, 4769], 0.563640176137555]], AbsoluteThickness[0.25], 
     LineBox[{8064, 8065}]}, 
    {Hue[
      NCache[
       Rational[8065, 14307], 0.5637100719927308]], AbsoluteThickness[0.25], 
     LineBox[{8065, 8066}]}, 
    {Hue[
      NCache[
       Rational[8066, 14307], 0.5637799678479066]], AbsoluteThickness[0.25], 
     LineBox[{8066, 8067}]}, 
    {Hue[
      NCache[
       Rational[2689, 4769], 0.5638498637030824]], AbsoluteThickness[0.25], 
     LineBox[{8067, 8068}]}, 
    {Hue[
      NCache[
       Rational[8068, 14307], 0.5639197595582582]], AbsoluteThickness[0.25], 
     LineBox[{8068, 8069}]}, 
    {Hue[
      NCache[
       Rational[8069, 14307], 0.5639896554134339]], AbsoluteThickness[0.25], 
     LineBox[{8069, 8070}]}, 
    {Hue[
      NCache[
       Rational[2690, 4769], 0.5640595512686097]], AbsoluteThickness[0.25], 
     LineBox[{8070, 8071}]}, 
    {Hue[
      NCache[
       Rational[8071, 14307], 0.5641294471237855]], AbsoluteThickness[0.25], 
     LineBox[{8071, 8072}]}, 
    {Hue[
      NCache[
       Rational[8072, 14307], 0.5641993429789613]], AbsoluteThickness[0.25], 
     LineBox[{8072, 8073}]}, 
    {Hue[
      NCache[
       Rational[2691, 4769], 0.5642692388341372]], AbsoluteThickness[0.25], 
     LineBox[{8073, 8074}]}, 
    {Hue[
      NCache[
       Rational[8074, 14307], 0.564339134689313]], AbsoluteThickness[0.25], 
     LineBox[{8074, 8075}]}, 
    {Hue[
      NCache[
       Rational[425, 753], 0.5644090305444888]], AbsoluteThickness[0.25], 
     LineBox[{8075, 8076}]}, 
    {Hue[
      NCache[
       Rational[2692, 4769], 0.5644789263996645]], AbsoluteThickness[0.25], 
     LineBox[{8076, 8077}]}, 
    {Hue[
      NCache[
       Rational[8077, 14307], 0.5645488222548403]], AbsoluteThickness[0.25], 
     LineBox[{8077, 8078}]}, 
    {Hue[
      NCache[
       Rational[8078, 14307], 0.5646187181100161]], AbsoluteThickness[0.25], 
     LineBox[{8078, 8079}]}, 
    {Hue[
      NCache[
       Rational[2693, 4769], 0.5646886139651919]], AbsoluteThickness[0.25], 
     LineBox[{8079, 8080}]}, 
    {Hue[
      NCache[
       Rational[8080, 14307], 0.5647585098203677]], AbsoluteThickness[0.25], 
     LineBox[{8080, 8081}]}, 
    {Hue[
      NCache[
       Rational[8081, 14307], 0.5648284056755435]], AbsoluteThickness[0.25], 
     LineBox[{8081, 8082}]}, 
    {Hue[
      NCache[
       Rational[2694, 4769], 0.5648983015307192]], AbsoluteThickness[0.25], 
     LineBox[{8082, 8083}]}, 
    {Hue[
      NCache[
       Rational[8083, 14307], 0.564968197385895]], AbsoluteThickness[0.25], 
     LineBox[{8083, 8084}]}, 
    {Hue[
      NCache[
       Rational[8084, 14307], 0.5650380932410708]], AbsoluteThickness[0.25], 
     LineBox[{8084, 8085}]}, 
    {Hue[
      NCache[
       Rational[2695, 4769], 0.5651079890962466]], AbsoluteThickness[0.25], 
     LineBox[{8085, 8086}]}, 
    {Hue[
      NCache[
       Rational[8086, 14307], 0.5651778849514224]], AbsoluteThickness[0.25], 
     LineBox[{8086, 8087}]}, 
    {Hue[
      NCache[
       Rational[8087, 14307], 0.5652477808065982]], AbsoluteThickness[0.25], 
     LineBox[{8087, 8088}]}, 
    {Hue[
      NCache[
       Rational[2696, 4769], 0.5653176766617739]], AbsoluteThickness[0.25], 
     LineBox[{8088, 8089}]}, 
    {Hue[
      NCache[
       Rational[8089, 14307], 0.5653875725169497]], AbsoluteThickness[0.25], 
     LineBox[{8089, 8090}]}, 
    {Hue[
      NCache[
       Rational[8090, 14307], 0.5654574683721255]], AbsoluteThickness[0.25], 
     LineBox[{8090, 8091}]}, 
    {Hue[
      NCache[
       Rational[2697, 4769], 0.5655273642273013]], AbsoluteThickness[0.25], 
     LineBox[{8091, 8092}]}, 
    {Hue[
      NCache[
       Rational[8092, 14307], 0.5655972600824771]], AbsoluteThickness[0.25], 
     LineBox[{8092, 8093}]}, 
    {Hue[
      NCache[
       Rational[8093, 14307], 0.5656671559376529]], AbsoluteThickness[0.25], 
     LineBox[{8093, 8094}]}, 
    {Hue[
      NCache[
       Rational[142, 251], 0.5657370517928287]], AbsoluteThickness[0.25], 
     LineBox[{8094, 8095}]}, 
    {Hue[
      NCache[
       Rational[8095, 14307], 0.5658069476480044]], AbsoluteThickness[0.25], 
     LineBox[{8095, 8096}]}, 
    {Hue[
      NCache[
       Rational[8096, 14307], 0.5658768435031802]], AbsoluteThickness[0.25], 
     LineBox[{8096, 8097}]}, 
    {Hue[
      NCache[
       Rational[2699, 4769], 0.565946739358356]], AbsoluteThickness[0.25], 
     LineBox[{8097, 8098}]}, 
    {Hue[
      NCache[
       Rational[8098, 14307], 0.5660166352135318]], AbsoluteThickness[0.25], 
     LineBox[{8098, 8099}]}, 
    {Hue[
      NCache[
       Rational[8099, 14307], 0.5660865310687077]], AbsoluteThickness[0.25], 
     LineBox[{8099, 8100}]}, 
    {Hue[
      NCache[
       Rational[2700, 4769], 0.5661564269238835]], AbsoluteThickness[0.25], 
     LineBox[{8100, 8101}]}, 
    {Hue[
      NCache[
       Rational[8101, 14307], 0.5662263227790592]], AbsoluteThickness[0.25], 
     LineBox[{8101, 8102}]}, 
    {Hue[
      NCache[
       Rational[8102, 14307], 0.566296218634235]], AbsoluteThickness[0.25], 
     LineBox[{8102, 8103}]}, 
    {Hue[
      NCache[
       Rational[2701, 4769], 0.5663661144894108]], AbsoluteThickness[0.25], 
     LineBox[{8103, 8104}]}, 
    {Hue[
      NCache[
       Rational[8104, 14307], 0.5664360103445866]], AbsoluteThickness[0.25], 
     LineBox[{8104, 8105}]}, 
    {Hue[
      NCache[
       Rational[8105, 14307], 0.5665059061997624]], AbsoluteThickness[0.25], 
     LineBox[{8105, 8106}]}, 
    {Hue[
      NCache[
       Rational[2702, 4769], 0.5665758020549382]], AbsoluteThickness[0.25], 
     LineBox[{8106, 8107}]}, 
    {Hue[
      NCache[
       Rational[8107, 14307], 0.5666456979101139]], AbsoluteThickness[0.25], 
     LineBox[{8107, 8108}]}, 
    {Hue[
      NCache[
       Rational[8108, 14307], 0.5667155937652897]], AbsoluteThickness[0.25], 
     LineBox[{8108, 8109}]}, 
    {Hue[
      NCache[
       Rational[2703, 4769], 0.5667854896204655]], AbsoluteThickness[0.25], 
     LineBox[{8109, 8110}]}, 
    {Hue[
      NCache[
       Rational[8110, 14307], 0.5668553854756413]], AbsoluteThickness[0.25], 
     LineBox[{8110, 8111}]}, 
    {Hue[
      NCache[
       Rational[8111, 14307], 0.5669252813308171]], AbsoluteThickness[0.25], 
     LineBox[{8111, 8112}]}, 
    {Hue[
      NCache[
       Rational[2704, 4769], 0.5669951771859929]], AbsoluteThickness[0.25], 
     LineBox[{8112, 8113}]}, 
    {Hue[
      NCache[
       Rational[427, 753], 0.5670650730411687]], AbsoluteThickness[0.25], 
     LineBox[{8113, 8114}]}, 
    {Hue[
      NCache[
       Rational[8114, 14307], 0.5671349688963444]], AbsoluteThickness[0.25], 
     LineBox[{8114, 8115}]}, 
    {Hue[
      NCache[
       Rational[2705, 4769], 0.5672048647515202]], AbsoluteThickness[0.25], 
     LineBox[{8115, 8116}]}, 
    {Hue[
      NCache[
       Rational[8116, 14307], 0.567274760606696]], AbsoluteThickness[0.25], 
     LineBox[{8116, 8117}]}, 
    {Hue[
      NCache[
       Rational[8117, 14307], 0.5673446564618718]], AbsoluteThickness[0.25], 
     LineBox[{8117, 8118}]}, 
    {Hue[
      NCache[
       Rational[2706, 4769], 0.5674145523170476]], AbsoluteThickness[0.25], 
     LineBox[{8118, 8119}]}, 
    {Hue[
      NCache[
       Rational[8119, 14307], 0.5674844481722234]], AbsoluteThickness[0.25], 
     LineBox[{8119, 8120}]}, 
    {Hue[
      NCache[
       Rational[8120, 14307], 0.5675543440273991]], AbsoluteThickness[0.25], 
     LineBox[{8120, 8121}]}, 
    {Hue[
      NCache[
       Rational[2707, 4769], 0.5676242398825749]], AbsoluteThickness[0.25], 
     LineBox[{8121, 8122}]}, 
    {Hue[
      NCache[
       Rational[8122, 14307], 0.5676941357377507]], AbsoluteThickness[0.25], 
     LineBox[{8122, 8123}]}, 
    {Hue[
      NCache[
       Rational[8123, 14307], 0.5677640315929265]], AbsoluteThickness[0.25], 
     LineBox[{8123, 8124}]}, 
    {Hue[
      NCache[
       Rational[2708, 4769], 0.5678339274481023]], AbsoluteThickness[0.25], 
     LineBox[{8124, 8125}]}, 
    {Hue[
      NCache[
       Rational[8125, 14307], 0.5679038233032782]], AbsoluteThickness[0.25], 
     LineBox[{8125, 8126}]}, 
    {Hue[
      NCache[
       Rational[8126, 14307], 0.5679737191584538]], AbsoluteThickness[0.25], 
     LineBox[{8126, 8127}]}, 
    {Hue[
      NCache[
       Rational[2709, 4769], 0.5680436150136297]], AbsoluteThickness[0.25], 
     LineBox[{8127, 8128}]}, 
    {Hue[
      NCache[
       Rational[8128, 14307], 0.5681135108688055]], AbsoluteThickness[0.25], 
     LineBox[{8128, 8129}]}, 
    {Hue[
      NCache[
       Rational[8129, 14307], 0.5681834067239813]], AbsoluteThickness[0.25], 
     LineBox[{8129, 8130}]}, 
    {Hue[
      NCache[
       Rational[2710, 4769], 0.5682533025791571]], AbsoluteThickness[0.25], 
     LineBox[{8130, 8131}]}, 
    {Hue[
      NCache[
       Rational[8131, 14307], 0.5683231984343329]], AbsoluteThickness[0.25], 
     LineBox[{8131, 8132}]}, 
    {Hue[
      NCache[
       Rational[428, 753], 0.5683930942895087]], AbsoluteThickness[0.25], 
     LineBox[{8132, 8133}]}, 
    {Hue[
      NCache[
       Rational[2711, 4769], 0.5684629901446844]], AbsoluteThickness[0.25], 
     LineBox[{8133, 8134}]}, 
    {Hue[
      NCache[
       Rational[8134, 14307], 0.5685328859998602]], AbsoluteThickness[0.25], 
     LineBox[{8134, 8135}]}, 
    {Hue[
      NCache[
       Rational[8135, 14307], 0.568602781855036]], AbsoluteThickness[0.25], 
     LineBox[{8135, 8136}]}, 
    {Hue[
      NCache[
       Rational[2712, 4769], 0.5686726777102118]], AbsoluteThickness[0.25], 
     LineBox[{8136, 8137}]}, 
    {Hue[
      NCache[
       Rational[8137, 14307], 0.5687425735653876]], AbsoluteThickness[0.25], 
     LineBox[{8137, 8138}]}, 
    {Hue[
      NCache[
       Rational[8138, 14307], 0.5688124694205634]], AbsoluteThickness[0.25], 
     LineBox[{8138, 8139}]}, 
    {Hue[
      NCache[
       Rational[2713, 4769], 0.5688823652757391]], AbsoluteThickness[0.25], 
     LineBox[{8139, 8140}]}, 
    {Hue[
      NCache[
       Rational[8140, 14307], 0.5689522611309149]], AbsoluteThickness[0.25], 
     LineBox[{8140, 8141}]}, 
    {Hue[
      NCache[
       Rational[8141, 14307], 0.5690221569860907]], AbsoluteThickness[0.25], 
     LineBox[{8141, 8142}]}, 
    {Hue[
      NCache[
       Rational[2714, 4769], 0.5690920528412665]], AbsoluteThickness[0.25], 
     LineBox[{8142, 8143}]}, 
    {Hue[
      NCache[
       Rational[8143, 14307], 0.5691619486964423]], AbsoluteThickness[0.25], 
     LineBox[{8143, 8144}]}, 
    {Hue[
      NCache[
       Rational[8144, 14307], 0.5692318445516181]], AbsoluteThickness[0.25], 
     LineBox[{8144, 8145}]}, 
    {Hue[
      NCache[
       Rational[2715, 4769], 0.5693017404067939]], AbsoluteThickness[0.25], 
     LineBox[{8145, 8146}]}, 
    {Hue[
      NCache[
       Rational[8146, 14307], 0.5693716362619696]], AbsoluteThickness[0.25], 
     LineBox[{8146, 8147}]}, 
    {Hue[
      NCache[
       Rational[8147, 14307], 0.5694415321171454]], AbsoluteThickness[0.25], 
     LineBox[{8147, 8148}]}, 
    {Hue[
      NCache[
       Rational[2716, 4769], 0.5695114279723212]], AbsoluteThickness[0.25], 
     LineBox[{8148, 8149}]}, 
    {Hue[
      NCache[
       Rational[8149, 14307], 0.569581323827497]], AbsoluteThickness[0.25], 
     LineBox[{8149, 8150}]}, 
    {Hue[
      NCache[
       Rational[8150, 14307], 0.5696512196826728]], AbsoluteThickness[0.25], 
     LineBox[{8150, 8151}]}, 
    {Hue[
      NCache[
       Rational[143, 251], 0.5697211155378487]], AbsoluteThickness[0.25], 
     LineBox[{8151, 8152}]}, 
    {Hue[
      NCache[
       Rational[8152, 14307], 0.5697910113930243]], AbsoluteThickness[0.25], 
     LineBox[{8152, 8153}]}, 
    {Hue[
      NCache[
       Rational[8153, 14307], 0.5698609072482002]], AbsoluteThickness[0.25], 
     LineBox[{8153, 8154}]}, 
    {Hue[
      NCache[
       Rational[2718, 4769], 0.569930803103376]], AbsoluteThickness[0.25], 
     LineBox[{8154, 8155}]}, 
    {Hue[
      NCache[
       Rational[8155, 14307], 0.5700006989585518]], AbsoluteThickness[0.25], 
     LineBox[{8155, 8156}]}, 
    {Hue[
      NCache[
       Rational[8156, 14307], 0.5700705948137276]], AbsoluteThickness[0.25], 
     LineBox[{8156, 8157}]}, 
    {Hue[
      NCache[
       Rational[2719, 4769], 0.5701404906689034]], AbsoluteThickness[0.25], 
     LineBox[{8157, 8158}]}, 
    {Hue[
      NCache[
       Rational[8158, 14307], 0.5702103865240791]], AbsoluteThickness[0.25], 
     LineBox[{8158, 8159}]}, 
    {Hue[
      NCache[
       Rational[8159, 14307], 0.5702802823792549]], AbsoluteThickness[0.25], 
     LineBox[{8159, 8160}]}, 
    {Hue[
      NCache[
       Rational[2720, 4769], 0.5703501782344307]], AbsoluteThickness[0.25], 
     LineBox[{8160, 8161}]}, 
    {Hue[
      NCache[
       Rational[8161, 14307], 0.5704200740896065]], AbsoluteThickness[0.25], 
     LineBox[{8161, 8162}]}, 
    {Hue[
      NCache[
       Rational[8162, 14307], 0.5704899699447823]], AbsoluteThickness[0.25], 
     LineBox[{8162, 8163}]}, 
    {Hue[
      NCache[
       Rational[2721, 4769], 0.5705598657999581]], AbsoluteThickness[0.25], 
     LineBox[{8163, 8164}]}, 
    {Hue[
      NCache[
       Rational[8164, 14307], 0.5706297616551339]], AbsoluteThickness[0.25], 
     LineBox[{8164, 8165}]}, 
    {Hue[
      NCache[
       Rational[8165, 14307], 0.5706996575103096]], AbsoluteThickness[0.25], 
     LineBox[{8165, 8166}]}, 
    {Hue[
      NCache[
       Rational[2722, 4769], 0.5707695533654854]], AbsoluteThickness[0.25], 
     LineBox[{8166, 8167}]}, 
    {Hue[
      NCache[
       Rational[8167, 14307], 0.5708394492206612]], AbsoluteThickness[0.25], 
     LineBox[{8167, 8168}]}, 
    {Hue[
      NCache[
       Rational[8168, 14307], 0.570909345075837]], AbsoluteThickness[0.25], 
     LineBox[{8168, 8169}]}, 
    {Hue[
      NCache[
       Rational[2723, 4769], 0.5709792409310128]], AbsoluteThickness[0.25], 
     LineBox[{8169, 8170}]}, 
    {Hue[
      NCache[
       Rational[430, 753], 0.5710491367861886]], AbsoluteThickness[0.25], 
     LineBox[{8170, 8171}]}, 
    {Hue[
      NCache[
       Rational[8171, 14307], 0.5711190326413643]], AbsoluteThickness[0.25], 
     LineBox[{8171, 8172}]}, 
    {Hue[
      NCache[
       Rational[2724, 4769], 0.5711889284965401]], AbsoluteThickness[0.25], 
     LineBox[{8172, 8173}]}, 
    {Hue[
      NCache[
       Rational[8173, 14307], 0.5712588243517159]], AbsoluteThickness[0.25], 
     LineBox[{8173, 8174}]}, 
    {Hue[
      NCache[
       Rational[8174, 14307], 0.5713287202068917]], AbsoluteThickness[0.25], 
     LineBox[{8174, 8175}]}, 
    {Hue[
      NCache[
       Rational[2725, 4769], 0.5713986160620675]], AbsoluteThickness[0.25], 
     LineBox[{8175, 8176}]}, 
    {Hue[
      NCache[
       Rational[8176, 14307], 0.5714685119172433]], AbsoluteThickness[0.25], 
     LineBox[{8176, 8177}]}, 
    {Hue[
      NCache[
       Rational[8177, 14307], 0.571538407772419]], AbsoluteThickness[0.25], 
     LineBox[{8177, 8178}]}, 
    {Hue[
      NCache[
       Rational[2726, 4769], 0.5716083036275948]], AbsoluteThickness[0.25], 
     LineBox[{8178, 8179}]}, 
    {Hue[
      NCache[
       Rational[8179, 14307], 0.5716781994827707]], AbsoluteThickness[0.25], 
     LineBox[{8179, 8180}]}, 
    {Hue[
      NCache[
       Rational[8180, 14307], 0.5717480953379465]], AbsoluteThickness[0.25], 
     LineBox[{8180, 8181}]}, 
    {Hue[
      NCache[
       Rational[2727, 4769], 0.5718179911931223]], AbsoluteThickness[0.25], 
     LineBox[{8181, 8182}]}, 
    {Hue[
      NCache[
       Rational[8182, 14307], 0.5718878870482981]], AbsoluteThickness[0.25], 
     LineBox[{8182, 8183}]}, 
    {Hue[
      NCache[
       Rational[8183, 14307], 0.5719577829034739]], AbsoluteThickness[0.25], 
     LineBox[{8183, 8184}]}, 
    {Hue[
      NCache[
       Rational[2728, 4769], 0.5720276787586496]], AbsoluteThickness[0.25], 
     LineBox[{8184, 8185}]}, 
    {Hue[
      NCache[
       Rational[8185, 14307], 0.5720975746138254]], AbsoluteThickness[0.25], 
     LineBox[{8185, 8186}]}, 
    {Hue[
      NCache[
       Rational[8186, 14307], 0.5721674704690012]], AbsoluteThickness[0.25], 
     LineBox[{8186, 8187}]}, 
    {Hue[
      NCache[
       Rational[2729, 4769], 0.572237366324177]], AbsoluteThickness[0.25], 
     LineBox[{8187, 8188}]}, 
    {Hue[
      NCache[
       Rational[8188, 14307], 0.5723072621793528]], AbsoluteThickness[0.25], 
     LineBox[{8188, 8189}]}, 
    {Hue[
      NCache[
       Rational[431, 753], 0.5723771580345286]], AbsoluteThickness[0.25], 
     LineBox[{8189, 8190}]}, 
    {Hue[
      NCache[
       Rational[2730, 4769], 0.5724470538897043]], AbsoluteThickness[0.25], 
     LineBox[{8190, 8191}]}, 
    {Hue[
      NCache[
       Rational[8191, 14307], 0.5725169497448801]], AbsoluteThickness[0.25], 
     LineBox[{8191, 8192}]}, 
    {Hue[
      NCache[
       Rational[8192, 14307], 0.5725868456000559]], AbsoluteThickness[0.25], 
     LineBox[{8192, 8193}]}, 
    {Hue[
      NCache[
       Rational[2731, 4769], 0.5726567414552317]], AbsoluteThickness[0.25], 
     LineBox[{8193, 8194}]}, 
    {Hue[
      NCache[
       Rational[8194, 14307], 0.5727266373104075]], AbsoluteThickness[0.25], 
     LineBox[{8194, 8195}]}, 
    {Hue[
      NCache[
       Rational[8195, 14307], 0.5727965331655833]], AbsoluteThickness[0.25], 
     LineBox[{8195, 8196}]}, 
    {Hue[
      NCache[
       Rational[2732, 4769], 0.572866429020759]], AbsoluteThickness[0.25], 
     LineBox[{8196, 8197}]}, 
    {Hue[
      NCache[
       Rational[8197, 14307], 0.5729363248759348]], AbsoluteThickness[0.25], 
     LineBox[{8197, 8198}]}, 
    {Hue[
      NCache[
       Rational[8198, 14307], 0.5730062207311106]], AbsoluteThickness[0.25], 
     LineBox[{8198, 8199}]}, 
    {Hue[
      NCache[
       Rational[2733, 4769], 0.5730761165862864]], AbsoluteThickness[0.25], 
     LineBox[{8199, 8200}]}, 
    {Hue[
      NCache[
       Rational[8200, 14307], 0.5731460124414622]], AbsoluteThickness[0.25], 
     LineBox[{8200, 8201}]}, 
    {Hue[
      NCache[
       Rational[8201, 14307], 0.573215908296638]], AbsoluteThickness[0.25], 
     LineBox[{8201, 8202}]}, 
    {Hue[
      NCache[
       Rational[2734, 4769], 0.5732858041518138]], AbsoluteThickness[0.25], 
     LineBox[{8202, 8203}]}, 
    {Hue[
      NCache[
       Rational[8203, 14307], 0.5733557000069895]], AbsoluteThickness[0.25], 
     LineBox[{8203, 8204}]}, 
    {Hue[
      NCache[
       Rational[8204, 14307], 0.5734255958621653]], AbsoluteThickness[0.25], 
     LineBox[{8204, 8205}]}, 
    {Hue[
      NCache[
       Rational[2735, 4769], 0.5734954917173412]], AbsoluteThickness[0.25], 
     LineBox[{8205, 8206}]}, 
    {Hue[
      NCache[
       Rational[8206, 14307], 0.573565387572517]], AbsoluteThickness[0.25], 
     LineBox[{8206, 8207}]}, 
    {Hue[
      NCache[
       Rational[8207, 14307], 0.5736352834276928]], AbsoluteThickness[0.25], 
     LineBox[{8207, 8208}]}, 
    {Hue[
      NCache[
       Rational[144, 251], 0.5737051792828686]], AbsoluteThickness[0.25], 
     LineBox[{8208, 8209}]}, 
    {Hue[
      NCache[
       Rational[8209, 14307], 0.5737750751380443]], AbsoluteThickness[0.25], 
     LineBox[{8209, 8210}]}, 
    {Hue[
      NCache[
       Rational[8210, 14307], 0.5738449709932201]], AbsoluteThickness[0.25], 
     LineBox[{8210, 8211}]}, 
    {Hue[
      NCache[
       Rational[2737, 4769], 0.5739148668483959]], AbsoluteThickness[0.25], 
     LineBox[{8211, 8212}]}, 
    {Hue[
      NCache[
       Rational[8212, 14307], 0.5739847627035717]], AbsoluteThickness[0.25], 
     LineBox[{8212, 8213}]}, 
    {Hue[
      NCache[
       Rational[8213, 14307], 0.5740546585587475]], AbsoluteThickness[0.25], 
     LineBox[{8213, 8214}]}, 
    {Hue[
      NCache[
       Rational[2738, 4769], 0.5741245544139233]], AbsoluteThickness[0.25], 
     LineBox[{8214, 8215}]}, 
    {Hue[
      NCache[
       Rational[8215, 14307], 0.574194450269099]], AbsoluteThickness[0.25], 
     LineBox[{8215, 8216}]}, 
    {Hue[
      NCache[
       Rational[8216, 14307], 0.5742643461242748]], AbsoluteThickness[0.25], 
     LineBox[{8216, 8217}]}, 
    {Hue[
      NCache[
       Rational[2739, 4769], 0.5743342419794506]], AbsoluteThickness[0.25], 
     LineBox[{8217, 8218}]}, 
    {Hue[
      NCache[
       Rational[8218, 14307], 0.5744041378346264]], AbsoluteThickness[0.25], 
     LineBox[{8218, 8219}]}, 
    {Hue[
      NCache[
       Rational[8219, 14307], 0.5744740336898022]], AbsoluteThickness[0.25], 
     LineBox[{8219, 8220}]}, 
    {Hue[
      NCache[
       Rational[2740, 4769], 0.574543929544978]], AbsoluteThickness[0.25], 
     LineBox[{8220, 8221}]}, 
    {Hue[
      NCache[
       Rational[8221, 14307], 0.5746138254001538]], AbsoluteThickness[0.25], 
     LineBox[{8221, 8222}]}, 
    {Hue[
      NCache[
       Rational[8222, 14307], 0.5746837212553295]], AbsoluteThickness[0.25], 
     LineBox[{8222, 8223}]}, 
    {Hue[
      NCache[
       Rational[2741, 4769], 0.5747536171105053]], AbsoluteThickness[0.25], 
     LineBox[{8223, 8224}]}, 
    {Hue[
      NCache[
       Rational[8224, 14307], 0.5748235129656811]], AbsoluteThickness[0.25], 
     LineBox[{8224, 8225}]}, 
    {Hue[
      NCache[
       Rational[8225, 14307], 0.5748934088208569]], AbsoluteThickness[0.25], 
     LineBox[{8225, 8226}]}, 
    {Hue[
      NCache[
       Rational[2742, 4769], 0.5749633046760327]], AbsoluteThickness[0.25], 
     LineBox[{8226, 8227}]}, 
    {Hue[
      NCache[
       Rational[433, 753], 0.5750332005312085]], AbsoluteThickness[0.25], 
     LineBox[{8227, 8228}]}, 
    {Hue[
      NCache[
       Rational[8228, 14307], 0.5751030963863842]], AbsoluteThickness[0.25], 
     LineBox[{8228, 8229}]}, 
    {Hue[
      NCache[
       Rational[2743, 4769], 0.57517299224156]], AbsoluteThickness[0.25], 
     LineBox[{8229, 8230}]}, 
    {Hue[
      NCache[
       Rational[8230, 14307], 0.5752428880967358]], AbsoluteThickness[0.25], 
     LineBox[{8230, 8231}]}, 
    {Hue[
      NCache[
       Rational[8231, 14307], 0.5753127839519117]], AbsoluteThickness[0.25], 
     LineBox[{8231, 8232}]}, 
    {Hue[
      NCache[
       Rational[2744, 4769], 0.5753826798070875]], AbsoluteThickness[0.25], 
     LineBox[{8232, 8233}]}, 
    {Hue[
      NCache[
       Rational[8233, 14307], 0.5754525756622633]], AbsoluteThickness[0.25], 
     LineBox[{8233, 8234}]}, 
    {Hue[
      NCache[
       Rational[8234, 14307], 0.575522471517439]], AbsoluteThickness[0.25], 
     LineBox[{8234, 8235}]}, 
    {Hue[
      NCache[
       Rational[2745, 4769], 0.5755923673726148]], AbsoluteThickness[0.25], 
     LineBox[{8235, 8236}]}, 
    {Hue[
      NCache[
       Rational[8236, 14307], 0.5756622632277906]], AbsoluteThickness[0.25], 
     LineBox[{8236, 8237}]}, 
    {Hue[
      NCache[
       Rational[8237, 14307], 0.5757321590829664]], AbsoluteThickness[0.25], 
     LineBox[{8237, 8238}]}, 
    {Hue[
      NCache[
       Rational[2746, 4769], 0.5758020549381422]], AbsoluteThickness[0.25], 
     LineBox[{8238, 8239}]}, 
    {Hue[
      NCache[
       Rational[8239, 14307], 0.575871950793318]], AbsoluteThickness[0.25], 
     LineBox[{8239, 8240}]}, 
    {Hue[
      NCache[
       Rational[8240, 14307], 0.5759418466484938]], AbsoluteThickness[0.25], 
     LineBox[{8240, 8241}]}, 
    {Hue[
      NCache[
       Rational[2747, 4769], 0.5760117425036695]], AbsoluteThickness[0.25], 
     LineBox[{8241, 8242}]}, 
    {Hue[
      NCache[
       Rational[8242, 14307], 0.5760816383588453]], AbsoluteThickness[0.25], 
     LineBox[{8242, 8243}]}, 
    {Hue[
      NCache[
       Rational[8243, 14307], 0.5761515342140211]], AbsoluteThickness[0.25], 
     LineBox[{8243, 8244}]}, 
    {Hue[
      NCache[
       Rational[2748, 4769], 0.5762214300691969]], AbsoluteThickness[0.25], 
     LineBox[{8244, 8245}]}, 
    {Hue[
      NCache[
       Rational[8245, 14307], 0.5762913259243727]], AbsoluteThickness[0.25], 
     LineBox[{8245, 8246}]}, 
    {Hue[
      NCache[
       Rational[434, 753], 0.5763612217795485]], AbsoluteThickness[0.25], 
     LineBox[{8246, 8247}]}, 
    {Hue[
      NCache[
       Rational[2749, 4769], 0.5764311176347242]], AbsoluteThickness[0.25], 
     LineBox[{8247, 8248}]}, 
    {Hue[
      NCache[
       Rational[8248, 14307], 0.5765010134899]], AbsoluteThickness[0.25], 
     LineBox[{8248, 8249}]}, 
    {Hue[
      NCache[
       Rational[8249, 14307], 0.5765709093450758]], AbsoluteThickness[0.25], 
     LineBox[{8249, 8250}]}, 
    {Hue[
      NCache[
       Rational[2750, 4769], 0.5766408052002516]], AbsoluteThickness[0.25], 
     LineBox[{8250, 8251}]}, 
    {Hue[
      NCache[
       Rational[8251, 14307], 0.5767107010554274]], AbsoluteThickness[0.25], 
     LineBox[{8251, 8252}]}, 
    {Hue[
      NCache[
       Rational[8252, 14307], 0.5767805969106032]], AbsoluteThickness[0.25], 
     LineBox[{8252, 8253}]}, 
    {Hue[
      NCache[
       Rational[2751, 4769], 0.576850492765779]], AbsoluteThickness[0.25], 
     LineBox[{8253, 8254}]}, 
    {Hue[
      NCache[
       Rational[8254, 14307], 0.5769203886209547]], AbsoluteThickness[0.25], 
     LineBox[{8254, 8255}]}, 
    {Hue[
      NCache[
       Rational[8255, 14307], 0.5769902844761305]], AbsoluteThickness[0.25], 
     LineBox[{8255, 8256}]}, 
    {Hue[
      NCache[
       Rational[2752, 4769], 0.5770601803313063]], AbsoluteThickness[0.25], 
     LineBox[{8256, 8257}]}, 
    {Hue[
      NCache[
       Rational[8257, 14307], 0.5771300761864822]], AbsoluteThickness[0.25], 
     LineBox[{8257, 8258}]}, 
    {Hue[
      NCache[
       Rational[8258, 14307], 0.577199972041658]], AbsoluteThickness[0.25], 
     LineBox[{8258, 8259}]}, 
    {Hue[
      NCache[
       Rational[2753, 4769], 0.5772698678968338]], AbsoluteThickness[0.25], 
     LineBox[{8259, 8260}]}, 
    {Hue[
      NCache[
       Rational[8260, 14307], 0.5773397637520095]], AbsoluteThickness[0.25], 
     LineBox[{8260, 8261}]}, 
    {Hue[
      NCache[
       Rational[8261, 14307], 0.5774096596071853]], AbsoluteThickness[0.25], 
     LineBox[{8261, 8262}]}, 
    {Hue[
      NCache[
       Rational[2754, 4769], 0.5774795554623611]], AbsoluteThickness[0.25], 
     LineBox[{8262, 8263}]}, 
    {Hue[
      NCache[
       Rational[8263, 14307], 0.5775494513175369]], AbsoluteThickness[0.25], 
     LineBox[{8263, 8264}]}, 
    {Hue[
      NCache[
       Rational[8264, 14307], 0.5776193471727127]], AbsoluteThickness[0.25], 
     LineBox[{8264, 8265}]}, 
    {Hue[
      NCache[
       Rational[145, 251], 0.5776892430278885]], AbsoluteThickness[0.25], 
     LineBox[{8265, 8266}]}, 
    {Hue[
      NCache[
       Rational[8266, 14307], 0.5777591388830642]], AbsoluteThickness[0.25], 
     LineBox[{8266, 8267}]}, 
    {Hue[
      NCache[
       Rational[8267, 14307], 0.57782903473824]], AbsoluteThickness[0.25], 
     LineBox[{8267, 8268}]}, 
    {Hue[
      NCache[
       Rational[2756, 4769], 0.5778989305934158]], AbsoluteThickness[0.25], 
     LineBox[{8268, 8269}]}, 
    {Hue[
      NCache[
       Rational[8269, 14307], 0.5779688264485916]], AbsoluteThickness[0.25], 
     LineBox[{8269, 8270}]}, 
    {Hue[
      NCache[
       Rational[8270, 14307], 0.5780387223037674]], AbsoluteThickness[0.25], 
     LineBox[{8270, 8271}]}, 
    {Hue[
      NCache[
       Rational[2757, 4769], 0.5781086181589432]], AbsoluteThickness[0.25], 
     LineBox[{8271, 8272}]}, 
    {Hue[
      NCache[
       Rational[8272, 14307], 0.578178514014119]], AbsoluteThickness[0.25], 
     LineBox[{8272, 8273}]}, 
    {Hue[
      NCache[
       Rational[8273, 14307], 0.5782484098692947]], AbsoluteThickness[0.25], 
     LineBox[{8273, 8274}]}, 
    {Hue[
      NCache[
       Rational[2758, 4769], 0.5783183057244705]], AbsoluteThickness[0.25], 
     LineBox[{8274, 8275}]}, 
    {Hue[
      NCache[
       Rational[8275, 14307], 0.5783882015796463]], AbsoluteThickness[0.25], 
     LineBox[{8275, 8276}]}, 
    {Hue[
      NCache[
       Rational[8276, 14307], 0.5784580974348221]], AbsoluteThickness[0.25], 
     LineBox[{8276, 8277}]}, 
    {Hue[
      NCache[
       Rational[2759, 4769], 0.5785279932899979]], AbsoluteThickness[0.25], 
     LineBox[{8277, 8278}]}, 
    {Hue[
      NCache[
       Rational[8278, 14307], 0.5785978891451737]], AbsoluteThickness[0.25], 
     LineBox[{8278, 8279}]}, 
    {Hue[
      NCache[
       Rational[8279, 14307], 0.5786677850003494]], AbsoluteThickness[0.25], 
     LineBox[{8279, 8280}]}, 
    {Hue[
      NCache[
       Rational[2760, 4769], 0.5787376808555252]], AbsoluteThickness[0.25], 
     LineBox[{8280, 8281}]}, 
    {Hue[
      NCache[
       Rational[8281, 14307], 0.578807576710701]], AbsoluteThickness[0.25], 
     LineBox[{8281, 8282}]}, 
    {Hue[
      NCache[
       Rational[8282, 14307], 0.5788774725658768]], AbsoluteThickness[0.25], 
     LineBox[{8282, 8283}]}, 
    {Hue[
      NCache[
       Rational[11, 19], 0.5789473684210527]], AbsoluteThickness[0.25], 
     LineBox[{8283, 8284}]}, 
    {Hue[
      NCache[
       Rational[436, 753], 0.5790172642762285]], AbsoluteThickness[0.25], 
     LineBox[{8284, 8285}]}, 
    {Hue[
      NCache[
       Rational[8285, 14307], 0.5790871601314042]], AbsoluteThickness[0.25], 
     LineBox[{8285, 8286}]}, 
    {Hue[
      NCache[
       Rational[2762, 4769], 0.57915705598658]], AbsoluteThickness[0.25], 
     LineBox[{8286, 8287}]}, 
    {Hue[
      NCache[
       Rational[8287, 14307], 0.5792269518417558]], AbsoluteThickness[0.25], 
     LineBox[{8287, 8288}]}, 
    {Hue[
      NCache[
       Rational[8288, 14307], 0.5792968476969316]], AbsoluteThickness[0.25], 
     LineBox[{8288, 8289}]}, 
    {Hue[
      NCache[
       Rational[2763, 4769], 0.5793667435521074]], AbsoluteThickness[0.25], 
     LineBox[{8289, 8290}]}, 
    {Hue[
      NCache[
       Rational[8290, 14307], 0.5794366394072832]], AbsoluteThickness[0.25], 
     LineBox[{8290, 8291}]}, 
    {Hue[
      NCache[
       Rational[8291, 14307], 0.579506535262459]], AbsoluteThickness[0.25], 
     LineBox[{8291, 8292}]}, 
    {Hue[
      NCache[
       Rational[2764, 4769], 0.5795764311176347]], AbsoluteThickness[0.25], 
     LineBox[{8292, 8293}]}, 
    {Hue[
      NCache[
       Rational[8293, 14307], 0.5796463269728105]], AbsoluteThickness[0.25], 
     LineBox[{8293, 8294}]}, 
    {Hue[
      NCache[
       Rational[8294, 14307], 0.5797162228279863]], AbsoluteThickness[0.25], 
     LineBox[{8294, 8295}]}, 
    {Hue[
      NCache[
       Rational[2765, 4769], 0.5797861186831621]], AbsoluteThickness[0.25], 
     LineBox[{8295, 8296}]}, 
    {Hue[
      NCache[
       Rational[8296, 14307], 0.5798560145383379]], AbsoluteThickness[0.25], 
     LineBox[{8296, 8297}]}, 
    {Hue[
      NCache[
       Rational[8297, 14307], 0.5799259103935137]], AbsoluteThickness[0.25], 
     LineBox[{8297, 8298}]}, 
    {Hue[
      NCache[
       Rational[2766, 4769], 0.5799958062486894]], AbsoluteThickness[0.25], 
     LineBox[{8298, 8299}]}, 
    {Hue[
      NCache[
       Rational[8299, 14307], 0.5800657021038652]], AbsoluteThickness[0.25], 
     LineBox[{8299, 8300}]}, 
    {Hue[
      NCache[
       Rational[8300, 14307], 0.580135597959041]], AbsoluteThickness[0.25], 
     LineBox[{8300, 8301}]}, 
    {Hue[
      NCache[
       Rational[2767, 4769], 0.5802054938142168]], AbsoluteThickness[0.25], 
     LineBox[{8301, 8302}]}, 
    {Hue[
      NCache[
       Rational[8302, 14307], 0.5802753896693926]], AbsoluteThickness[0.25], 
     LineBox[{8302, 8303}]}, 
    {Hue[
      NCache[
       Rational[437, 753], 0.5803452855245684]], AbsoluteThickness[0.25], 
     LineBox[{8303, 8304}]}, 
    {Hue[
      NCache[
       Rational[2768, 4769], 0.5804151813797441]], AbsoluteThickness[0.25], 
     LineBox[{8304, 8305}]}, 
    {Hue[
      NCache[
       Rational[8305, 14307], 0.5804850772349199]], AbsoluteThickness[0.25], 
     LineBox[{8305, 8306}]}, 
    {Hue[
      NCache[
       Rational[8306, 14307], 0.5805549730900957]], AbsoluteThickness[0.25], 
     LineBox[{8306, 8307}]}, 
    {Hue[
      NCache[
       Rational[2769, 4769], 0.5806248689452715]], AbsoluteThickness[0.25], 
     LineBox[{8307, 8308}]}, 
    {Hue[
      NCache[
       Rational[8308, 14307], 0.5806947648004473]], AbsoluteThickness[0.25], 
     LineBox[{8308, 8309}]}, 
    {Hue[
      NCache[
       Rational[8309, 14307], 0.5807646606556232]], AbsoluteThickness[0.25], 
     LineBox[{8309, 8310}]}, 
    {Hue[
      NCache[
       Rational[2770, 4769], 0.580834556510799]], AbsoluteThickness[0.25], 
     LineBox[{8310, 8311}]}, 
    {Hue[
      NCache[
       Rational[8311, 14307], 0.5809044523659747]], AbsoluteThickness[0.25], 
     LineBox[{8311, 8312}]}, 
    {Hue[
      NCache[
       Rational[8312, 14307], 0.5809743482211505]], AbsoluteThickness[0.25], 
     LineBox[{8312, 8313}]}, 
    {Hue[
      NCache[
       Rational[2771, 4769], 0.5810442440763263]], AbsoluteThickness[0.25], 
     LineBox[{8313, 8314}]}, 
    {Hue[
      NCache[
       Rational[8314, 14307], 0.5811141399315021]], AbsoluteThickness[0.25], 
     LineBox[{8314, 8315}]}, 
    {Hue[
      NCache[
       Rational[8315, 14307], 0.5811840357866779]], AbsoluteThickness[0.25], 
     LineBox[{8315, 8316}]}, 
    {Hue[
      NCache[
       Rational[2772, 4769], 0.5812539316418537]], AbsoluteThickness[0.25], 
     LineBox[{8316, 8317}]}, 
    {Hue[
      NCache[
       Rational[8317, 14307], 0.5813238274970294]], AbsoluteThickness[0.25], 
     LineBox[{8317, 8318}]}, 
    {Hue[
      NCache[
       Rational[8318, 14307], 0.5813937233522052]], AbsoluteThickness[0.25], 
     LineBox[{8318, 8319}]}, 
    {Hue[
      NCache[
       Rational[2773, 4769], 0.581463619207381]], AbsoluteThickness[0.25], 
     LineBox[{8319, 8320}]}, 
    {Hue[
      NCache[
       Rational[8320, 14307], 0.5815335150625568]], AbsoluteThickness[0.25], 
     LineBox[{8320, 8321}]}, 
    {Hue[
      NCache[
       Rational[8321, 14307], 0.5816034109177326]], AbsoluteThickness[0.25], 
     LineBox[{8321, 8322}]}, 
    {Hue[
      NCache[
       Rational[146, 251], 0.5816733067729084]], AbsoluteThickness[0.25], 
     LineBox[{8322, 8323}]}, 
    {Hue[
      NCache[
       Rational[8323, 14307], 0.5817432026280841]], AbsoluteThickness[0.25], 
     LineBox[{8323, 8324}]}, 
    {Hue[
      NCache[
       Rational[8324, 14307], 0.5818130984832599]], AbsoluteThickness[0.25], 
     LineBox[{8324, 8325}]}, 
    {Hue[
      NCache[
       Rational[2775, 4769], 0.5818829943384357]], AbsoluteThickness[0.25], 
     LineBox[{8325, 8326}]}, 
    {Hue[
      NCache[
       Rational[8326, 14307], 0.5819528901936115]], AbsoluteThickness[0.25], 
     LineBox[{8326, 8327}]}, 
    {Hue[
      NCache[
       Rational[8327, 14307], 0.5820227860487873]], AbsoluteThickness[0.25], 
     LineBox[{8327, 8328}]}, 
    {Hue[
      NCache[
       Rational[2776, 4769], 0.5820926819039631]], AbsoluteThickness[0.25], 
     LineBox[{8328, 8329}]}, 
    {Hue[
      NCache[
       Rational[8329, 14307], 0.5821625777591389]], AbsoluteThickness[0.25], 
     LineBox[{8329, 8330}]}, 
    {Hue[
      NCache[
       Rational[8330, 14307], 0.5822324736143146]], AbsoluteThickness[0.25], 
     LineBox[{8330, 8331}]}, 
    {Hue[
      NCache[
       Rational[2777, 4769], 0.5823023694694904]], AbsoluteThickness[0.25], 
     LineBox[{8331, 8332}]}, 
    {Hue[
      NCache[
       Rational[8332, 14307], 0.5823722653246662]], AbsoluteThickness[0.25], 
     LineBox[{8332, 8333}]}, 
    {Hue[
      NCache[
       Rational[8333, 14307], 0.582442161179842]], AbsoluteThickness[0.25], 
     LineBox[{8333, 8334}]}, 
    {Hue[
      NCache[
       Rational[2778, 4769], 0.5825120570350178]], AbsoluteThickness[0.25], 
     LineBox[{8334, 8335}]}, 
    {Hue[
      NCache[
       Rational[8335, 14307], 0.5825819528901937]], AbsoluteThickness[0.25], 
     LineBox[{8335, 8336}]}, 
    {Hue[
      NCache[
       Rational[8336, 14307], 0.5826518487453693]], AbsoluteThickness[0.25], 
     LineBox[{8336, 8337}]}, 
    {Hue[
      NCache[
       Rational[2779, 4769], 0.5827217446005452]], AbsoluteThickness[0.25], 
     LineBox[{8337, 8338}]}, 
    {Hue[
      NCache[
       Rational[8338, 14307], 0.582791640455721]], AbsoluteThickness[0.25], 
     LineBox[{8338, 8339}]}, 
    {Hue[
      NCache[
       Rational[8339, 14307], 0.5828615363108968]], AbsoluteThickness[0.25], 
     LineBox[{8339, 8340}]}, 
    {Hue[
      NCache[
       Rational[2780, 4769], 0.5829314321660726]], AbsoluteThickness[0.25], 
     LineBox[{8340, 8341}]}, 
    {Hue[
      NCache[
       Rational[439, 753], 0.5830013280212484]], AbsoluteThickness[0.25], 
     LineBox[{8341, 8342}]}, 
    {Hue[
      NCache[
       Rational[8342, 14307], 0.5830712238764242]], AbsoluteThickness[0.25], 
     LineBox[{8342, 8343}]}, 
    {Hue[
      NCache[
       Rational[2781, 4769], 0.5831411197315999]], AbsoluteThickness[0.25], 
     LineBox[{8343, 8344}]}, 
    {Hue[
      NCache[
       Rational[8344, 14307], 0.5832110155867757]], AbsoluteThickness[0.25], 
     LineBox[{8344, 8345}]}, 
    {Hue[
      NCache[
       Rational[8345, 14307], 0.5832809114419515]], AbsoluteThickness[0.25], 
     LineBox[{8345, 8346}]}, 
    {Hue[
      NCache[
       Rational[2782, 4769], 0.5833508072971273]], AbsoluteThickness[0.25], 
     LineBox[{8346, 8347}]}, 
    {Hue[
      NCache[
       Rational[8347, 14307], 0.5834207031523031]], AbsoluteThickness[0.25], 
     LineBox[{8347, 8348}]}, 
    {Hue[
      NCache[
       Rational[8348, 14307], 0.5834905990074789]], AbsoluteThickness[0.25], 
     LineBox[{8348, 8349}]}, 
    {Hue[
      NCache[
       Rational[2783, 4769], 0.5835604948626546]], AbsoluteThickness[0.25], 
     LineBox[{8349, 8350}]}, 
    {Hue[
      NCache[
       Rational[8350, 14307], 0.5836303907178304]], AbsoluteThickness[0.25], 
     LineBox[{8350, 8351}]}, 
    {Hue[
      NCache[
       Rational[8351, 14307], 0.5837002865730062]], AbsoluteThickness[0.25], 
     LineBox[{8351, 8352}]}, 
    {Hue[
      NCache[
       Rational[2784, 4769], 0.583770182428182]], AbsoluteThickness[0.25], 
     LineBox[{8352, 8353}]}, 
    {Hue[
      NCache[
       Rational[8353, 14307], 0.5838400782833578]], AbsoluteThickness[0.25], 
     LineBox[{8353, 8354}]}, 
    {Hue[
      NCache[
       Rational[8354, 14307], 0.5839099741385336]], AbsoluteThickness[0.25], 
     LineBox[{8354, 8355}]}, 
    {Hue[
      NCache[
       Rational[2785, 4769], 0.5839798699937093]], AbsoluteThickness[0.25], 
     LineBox[{8355, 8356}]}, 
    {Hue[
      NCache[
       Rational[8356, 14307], 0.5840497658488851]], AbsoluteThickness[0.25], 
     LineBox[{8356, 8357}]}, 
    {Hue[
      NCache[
       Rational[8357, 14307], 0.5841196617040609]], AbsoluteThickness[0.25], 
     LineBox[{8357, 8358}]}, 
    {Hue[
      NCache[
       Rational[2786, 4769], 0.5841895575592367]], AbsoluteThickness[0.25], 
     LineBox[{8358, 8359}]}, 
    {Hue[
      NCache[
       Rational[8359, 14307], 0.5842594534144125]], AbsoluteThickness[0.25], 
     LineBox[{8359, 8360}]}, 
    {Hue[
      NCache[
       Rational[440, 753], 0.5843293492695883]], AbsoluteThickness[0.25], 
     LineBox[{8360, 8361}]}, 
    {Hue[
      NCache[
       Rational[2787, 4769], 0.5843992451247642]], AbsoluteThickness[0.25], 
     LineBox[{8361, 8362}]}, 
    {Hue[
      NCache[
       Rational[8362, 14307], 0.5844691409799398]], AbsoluteThickness[0.25], 
     LineBox[{8362, 8363}]}, 
    {Hue[
      NCache[
       Rational[8363, 14307], 0.5845390368351157]], AbsoluteThickness[0.25], 
     LineBox[{8363, 8364}]}, 
    {Hue[
      NCache[
       Rational[2788, 4769], 0.5846089326902915]], AbsoluteThickness[0.25], 
     LineBox[{8364, 8365}]}, 
    {Hue[
      NCache[
       Rational[8365, 14307], 0.5846788285454673]], AbsoluteThickness[0.25], 
     LineBox[{8365, 8366}]}, 
    {Hue[
      NCache[
       Rational[8366, 14307], 0.5847487244006431]], AbsoluteThickness[0.25], 
     LineBox[{8366, 8367}]}, 
    {Hue[
      NCache[
       Rational[2789, 4769], 0.5848186202558189]], AbsoluteThickness[0.25], 
     LineBox[{8367, 8368}]}, 
    {Hue[
      NCache[
       Rational[8368, 14307], 0.5848885161109946]], AbsoluteThickness[0.25], 
     LineBox[{8368, 8369}]}, 
    {Hue[
      NCache[
       Rational[8369, 14307], 0.5849584119661704]], AbsoluteThickness[0.25], 
     LineBox[{8369, 8370}]}, 
    {Hue[
      NCache[
       Rational[2790, 4769], 0.5850283078213462]], AbsoluteThickness[0.25], 
     LineBox[{8370, 8371}]}, 
    {Hue[
      NCache[
       Rational[8371, 14307], 0.585098203676522]], AbsoluteThickness[0.25], 
     LineBox[{8371, 8372}]}, 
    {Hue[
      NCache[
       Rational[8372, 14307], 0.5851680995316978]], AbsoluteThickness[0.25], 
     LineBox[{8372, 8373}]}, 
    {Hue[
      NCache[
       Rational[2791, 4769], 0.5852379953868736]], AbsoluteThickness[0.25], 
     LineBox[{8373, 8374}]}, 
    {Hue[
      NCache[
       Rational[8374, 14307], 0.5853078912420493]], AbsoluteThickness[0.25], 
     LineBox[{8374, 8375}]}, 
    {Hue[
      NCache[
       Rational[8375, 14307], 0.5853777870972251]], AbsoluteThickness[0.25], 
     LineBox[{8375, 8376}]}, 
    {Hue[
      NCache[
       Rational[2792, 4769], 0.5854476829524009]], AbsoluteThickness[0.25], 
     LineBox[{8376, 8377}]}, 
    {Hue[
      NCache[
       Rational[8377, 14307], 0.5855175788075767]], AbsoluteThickness[0.25], 
     LineBox[{8377, 8378}]}, 
    {Hue[
      NCache[
       Rational[8378, 14307], 0.5855874746627525]], AbsoluteThickness[0.25], 
     LineBox[{8378, 8379}]}, 
    {Hue[
      NCache[
       Rational[147, 251], 0.5856573705179283]], AbsoluteThickness[0.25], 
     LineBox[{8379, 8380}]}, 
    {Hue[
      NCache[
       Rational[8380, 14307], 0.5857272663731041]], AbsoluteThickness[0.25], 
     LineBox[{8380, 8381}]}, 
    {Hue[
      NCache[
       Rational[8381, 14307], 0.5857971622282798]], AbsoluteThickness[0.25], 
     LineBox[{8381, 8382}]}, 
    {Hue[
      NCache[
       Rational[2794, 4769], 0.5858670580834556]], AbsoluteThickness[0.25], 
     LineBox[{8382, 8383}]}, 
    {Hue[
      NCache[
       Rational[8383, 14307], 0.5859369539386314]], AbsoluteThickness[0.25], 
     LineBox[{8383, 8384}]}, 
    {Hue[
      NCache[
       Rational[8384, 14307], 0.5860068497938072]], AbsoluteThickness[0.25], 
     LineBox[{8384, 8385}]}, 
    {Hue[
      NCache[
       Rational[2795, 4769], 0.586076745648983]], AbsoluteThickness[0.25], 
     LineBox[{8385, 8386}]}, 
    {Hue[
      NCache[
       Rational[8386, 14307], 0.5861466415041588]], AbsoluteThickness[0.25], 
     LineBox[{8386, 8387}]}, 
    {Hue[
      NCache[
       Rational[8387, 14307], 0.5862165373593345]], AbsoluteThickness[0.25], 
     LineBox[{8387, 8388}]}, 
    {Hue[
      NCache[
       Rational[2796, 4769], 0.5862864332145103]], AbsoluteThickness[0.25], 
     LineBox[{8388, 8389}]}, 
    {Hue[
      NCache[
       Rational[8389, 14307], 0.5863563290696862]], AbsoluteThickness[0.25], 
     LineBox[{8389, 8390}]}, 
    {Hue[
      NCache[
       Rational[8390, 14307], 0.586426224924862]], AbsoluteThickness[0.25], 
     LineBox[{8390, 8391}]}, 
    {Hue[
      NCache[
       Rational[2797, 4769], 0.5864961207800378]], AbsoluteThickness[0.25], 
     LineBox[{8391, 8392}]}, 
    {Hue[
      NCache[
       Rational[8392, 14307], 0.5865660166352136]], AbsoluteThickness[0.25], 
     LineBox[{8392, 8393}]}, 
    {Hue[
      NCache[
       Rational[8393, 14307], 0.5866359124903893]], AbsoluteThickness[0.25], 
     LineBox[{8393, 8394}]}, 
    {Hue[
      NCache[
       Rational[2798, 4769], 0.5867058083455651]], AbsoluteThickness[0.25], 
     LineBox[{8394, 8395}]}, 
    {Hue[
      NCache[
       Rational[8395, 14307], 0.5867757042007409]], AbsoluteThickness[0.25], 
     LineBox[{8395, 8396}]}, 
    {Hue[
      NCache[
       Rational[8396, 14307], 0.5868456000559167]], AbsoluteThickness[0.25], 
     LineBox[{8396, 8397}]}, 
    {Hue[
      NCache[
       Rational[2799, 4769], 0.5869154959110925]], AbsoluteThickness[0.25], 
     LineBox[{8397, 8398}]}, 
    {Hue[
      NCache[
       Rational[442, 753], 0.5869853917662683]], AbsoluteThickness[0.25], 
     LineBox[{8398, 8399}]}, 
    {Hue[
      NCache[
       Rational[8399, 14307], 0.5870552876214441]], AbsoluteThickness[0.25], 
     LineBox[{8399, 8400}]}, 
    {Hue[
      NCache[
       Rational[2800, 4769], 0.5871251834766198]], AbsoluteThickness[0.25], 
     LineBox[{8400, 8401}]}, 
    {Hue[
      NCache[
       Rational[8401, 14307], 0.5871950793317956]], AbsoluteThickness[0.25], 
     LineBox[{8401, 8402}]}, 
    {Hue[
      NCache[
       Rational[8402, 14307], 0.5872649751869714]], AbsoluteThickness[0.25], 
     LineBox[{8402, 8403}]}, 
    {Hue[
      NCache[
       Rational[2801, 4769], 0.5873348710421472]], AbsoluteThickness[0.25], 
     LineBox[{8403, 8404}]}, 
    {Hue[
      NCache[
       Rational[8404, 14307], 0.587404766897323]], AbsoluteThickness[0.25], 
     LineBox[{8404, 8405}]}, 
    {Hue[
      NCache[
       Rational[8405, 14307], 0.5874746627524988]], AbsoluteThickness[0.25], 
     LineBox[{8405, 8406}]}, 
    {Hue[
      NCache[
       Rational[2802, 4769], 0.5875445586076745]], AbsoluteThickness[0.25], 
     LineBox[{8406, 8407}]}, 
    {Hue[
      NCache[
       Rational[8407, 14307], 0.5876144544628503]], AbsoluteThickness[0.25], 
     LineBox[{8407, 8408}]}, 
    {Hue[
      NCache[
       Rational[8408, 14307], 0.5876843503180261]], AbsoluteThickness[0.25], 
     LineBox[{8408, 8409}]}, 
    {Hue[
      NCache[
       Rational[2803, 4769], 0.5877542461732019]], AbsoluteThickness[0.25], 
     LineBox[{8409, 8410}]}, 
    {Hue[
      NCache[
       Rational[8410, 14307], 0.5878241420283777]], AbsoluteThickness[0.25], 
     LineBox[{8410, 8411}]}, 
    {Hue[
      NCache[
       Rational[8411, 14307], 0.5878940378835535]], AbsoluteThickness[0.25], 
     LineBox[{8411, 8412}]}, 
    {Hue[
      NCache[
       Rational[2804, 4769], 0.5879639337387292]], AbsoluteThickness[0.25], 
     LineBox[{8412, 8413}]}, 
    {Hue[
      NCache[
       Rational[8413, 14307], 0.588033829593905]], AbsoluteThickness[0.25], 
     LineBox[{8413, 8414}]}, 
    {Hue[
      NCache[
       Rational[8414, 14307], 0.5881037254490808]], AbsoluteThickness[0.25], 
     LineBox[{8414, 8415}]}, 
    {Hue[
      NCache[
       Rational[2805, 4769], 0.5881736213042567]], AbsoluteThickness[0.25], 
     LineBox[{8415, 8416}]}, 
    {Hue[
      NCache[
       Rational[8416, 14307], 0.5882435171594325]], AbsoluteThickness[0.25], 
     LineBox[{8416, 8417}]}, 
    {Hue[
      NCache[
       Rational[443, 753], 0.5883134130146083]], AbsoluteThickness[0.25], 
     LineBox[{8417, 8418}]}, 
    {Hue[
      NCache[
       Rational[2806, 4769], 0.5883833088697841]], AbsoluteThickness[0.25], 
     LineBox[{8418, 8419}]}, 
    {Hue[
      NCache[
       Rational[8419, 14307], 0.5884532047249598]], AbsoluteThickness[0.25], 
     LineBox[{8419, 8420}]}, 
    {Hue[
      NCache[
       Rational[8420, 14307], 0.5885231005801356]], AbsoluteThickness[0.25], 
     LineBox[{8420, 8421}]}, 
    {Hue[
      NCache[
       Rational[2807, 4769], 0.5885929964353114]], AbsoluteThickness[0.25], 
     LineBox[{8421, 8422}]}, 
    {Hue[
      NCache[
       Rational[8422, 14307], 0.5886628922904872]], AbsoluteThickness[0.25], 
     LineBox[{8422, 8423}]}, 
    {Hue[
      NCache[
       Rational[8423, 14307], 0.588732788145663]], AbsoluteThickness[0.25], 
     LineBox[{8423, 8424}]}, 
    {Hue[
      NCache[
       Rational[2808, 4769], 0.5888026840008388]], AbsoluteThickness[0.25], 
     LineBox[{8424, 8425}]}, 
    {Hue[
      NCache[
       Rational[8425, 14307], 0.5888725798560145]], AbsoluteThickness[0.25], 
     LineBox[{8425, 8426}]}, 
    {Hue[
      NCache[
       Rational[8426, 14307], 0.5889424757111903]], AbsoluteThickness[0.25], 
     LineBox[{8426, 8427}]}, 
    {Hue[
      NCache[
       Rational[2809, 4769], 0.5890123715663661]], AbsoluteThickness[0.25], 
     LineBox[{8427, 8428}]}, 
    {Hue[
      NCache[
       Rational[8428, 14307], 0.5890822674215419]], AbsoluteThickness[0.25], 
     LineBox[{8428, 8429}]}, 
    {Hue[
      NCache[
       Rational[8429, 14307], 0.5891521632767177]], AbsoluteThickness[0.25], 
     LineBox[{8429, 8430}]}, 
    {Hue[
      NCache[
       Rational[2810, 4769], 0.5892220591318935]], AbsoluteThickness[0.25], 
     LineBox[{8430, 8431}]}, 
    {Hue[
      NCache[
       Rational[8431, 14307], 0.5892919549870693]], AbsoluteThickness[0.25], 
     LineBox[{8431, 8432}]}, 
    {Hue[
      NCache[
       Rational[8432, 14307], 0.589361850842245]], AbsoluteThickness[0.25], 
     LineBox[{8432, 8433}]}, 
    {Hue[
      NCache[
       Rational[2811, 4769], 0.5894317466974208]], AbsoluteThickness[0.25], 
     LineBox[{8433, 8434}]}, 
    {Hue[
      NCache[
       Rational[8434, 14307], 0.5895016425525966]], AbsoluteThickness[0.25], 
     LineBox[{8434, 8435}]}, 
    {Hue[
      NCache[
       Rational[8435, 14307], 0.5895715384077724]], AbsoluteThickness[0.25], 
     LineBox[{8435, 8436}]}, 
    {Hue[
      NCache[
       Rational[148, 251], 0.5896414342629482]], AbsoluteThickness[0.25], 
     LineBox[{8436, 8437}]}, 
    {Hue[
      NCache[
       Rational[8437, 14307], 0.589711330118124]], AbsoluteThickness[0.25], 
     LineBox[{8437, 8438}]}, 
    {Hue[
      NCache[
       Rational[8438, 14307], 0.5897812259732997]], AbsoluteThickness[0.25], 
     LineBox[{8438, 8439}]}, 
    {Hue[
      NCache[
       Rational[2813, 4769], 0.5898511218284755]], AbsoluteThickness[0.25], 
     LineBox[{8439, 8440}]}, 
    {Hue[
      NCache[
       Rational[8440, 14307], 0.5899210176836513]], AbsoluteThickness[0.25], 
     LineBox[{8440, 8441}]}, 
    {Hue[
      NCache[
       Rational[8441, 14307], 0.5899909135388272]], AbsoluteThickness[0.25], 
     LineBox[{8441, 8442}]}, 
    {Hue[
      NCache[
       Rational[2814, 4769], 0.590060809394003]], AbsoluteThickness[0.25], 
     LineBox[{8442, 8443}]}, 
    {Hue[
      NCache[
       Rational[8443, 14307], 0.5901307052491788]], AbsoluteThickness[0.25], 
     LineBox[{8443, 8444}]}, 
    {Hue[
      NCache[
       Rational[8444, 14307], 0.5902006011043545]], AbsoluteThickness[0.25], 
     LineBox[{8444, 8445}]}, 
    {Hue[
      NCache[
       Rational[2815, 4769], 0.5902704969595303]], AbsoluteThickness[0.25], 
     LineBox[{8445, 8446}]}, 
    {Hue[
      NCache[
       Rational[8446, 14307], 0.5903403928147061]], AbsoluteThickness[0.25], 
     LineBox[{8446, 8447}]}, 
    {Hue[
      NCache[
       Rational[8447, 14307], 0.5904102886698819]], AbsoluteThickness[0.25], 
     LineBox[{8447, 8448}]}, 
    {Hue[
      NCache[
       Rational[2816, 4769], 0.5904801845250577]], AbsoluteThickness[0.25], 
     LineBox[{8448, 8449}]}, 
    {Hue[
      NCache[
       Rational[8449, 14307], 0.5905500803802335]], AbsoluteThickness[0.25], 
     LineBox[{8449, 8450}]}, 
    {Hue[
      NCache[
       Rational[8450, 14307], 0.5906199762354093]], AbsoluteThickness[0.25], 
     LineBox[{8450, 8451}]}, 
    {Hue[
      NCache[
       Rational[2817, 4769], 0.590689872090585]], AbsoluteThickness[0.25], 
     LineBox[{8451, 8452}]}, 
    {Hue[
      NCache[
       Rational[8452, 14307], 0.5907597679457608]], AbsoluteThickness[0.25], 
     LineBox[{8452, 8453}]}, 
    {Hue[
      NCache[
       Rational[8453, 14307], 0.5908296638009366]], AbsoluteThickness[0.25], 
     LineBox[{8453, 8454}]}, 
    {Hue[
      NCache[
       Rational[2818, 4769], 0.5908995596561124]], AbsoluteThickness[0.25], 
     LineBox[{8454, 8455}]}, 
    {Hue[
      NCache[
       Rational[445, 753], 0.5909694555112882]], AbsoluteThickness[0.25], 
     LineBox[{8455, 8456}]}, 
    {Hue[
      NCache[
       Rational[8456, 14307], 0.591039351366464]], AbsoluteThickness[0.25], 
     LineBox[{8456, 8457}]}, 
    {Hue[
      NCache[
       Rational[2819, 4769], 0.5911092472216397]], AbsoluteThickness[0.25], 
     LineBox[{8457, 8458}]}, 
    {Hue[
      NCache[
       Rational[8458, 14307], 0.5911791430768155]], AbsoluteThickness[0.25], 
     LineBox[{8458, 8459}]}, 
    {Hue[
      NCache[
       Rational[8459, 14307], 0.5912490389319913]], AbsoluteThickness[0.25], 
     LineBox[{8459, 8460}]}, 
    {Hue[
      NCache[
       Rational[2820, 4769], 0.5913189347871671]], AbsoluteThickness[0.25], 
     LineBox[{8460, 8461}]}, 
    {Hue[
      NCache[
       Rational[8461, 14307], 0.5913888306423429]], AbsoluteThickness[0.25], 
     LineBox[{8461, 8462}]}, 
    {Hue[
      NCache[
       Rational[8462, 14307], 0.5914587264975187]], AbsoluteThickness[0.25], 
     LineBox[{8462, 8463}]}, 
    {Hue[
      NCache[
       Rational[2821, 4769], 0.5915286223526944]], AbsoluteThickness[0.25], 
     LineBox[{8463, 8464}]}, 
    {Hue[
      NCache[
       Rational[8464, 14307], 0.5915985182078702]], AbsoluteThickness[0.25], 
     LineBox[{8464, 8465}]}, 
    {Hue[
      NCache[
       Rational[8465, 14307], 0.591668414063046]], AbsoluteThickness[0.25], 
     LineBox[{8465, 8466}]}, 
    {Hue[
      NCache[
       Rational[2822, 4769], 0.5917383099182218]], AbsoluteThickness[0.25], 
     LineBox[{8466, 8467}]}, 
    {Hue[
      NCache[
       Rational[8467, 14307], 0.5918082057733977]], AbsoluteThickness[0.25], 
     LineBox[{8467, 8468}]}, 
    {Hue[
      NCache[
       Rational[8468, 14307], 0.5918781016285735]], AbsoluteThickness[0.25], 
     LineBox[{8468, 8469}]}, 
    {Hue[
      NCache[
       Rational[2823, 4769], 0.5919479974837493]], AbsoluteThickness[0.25], 
     LineBox[{8469, 8470}]}, 
    {Hue[
      NCache[
       Rational[8470, 14307], 0.592017893338925]], AbsoluteThickness[0.25], 
     LineBox[{8470, 8471}]}, 
    {Hue[
      NCache[
       Rational[8471, 14307], 0.5920877891941008]], AbsoluteThickness[0.25], 
     LineBox[{8471, 8472}]}, 
    {Hue[
      NCache[
       Rational[2824, 4769], 0.5921576850492766]], AbsoluteThickness[0.25], 
     LineBox[{8472, 8473}]}, 
    {Hue[
      NCache[
       Rational[8473, 14307], 0.5922275809044524]], AbsoluteThickness[0.25], 
     LineBox[{8473, 8474}]}, 
    {Hue[
      NCache[
       Rational[446, 753], 0.5922974767596282]], AbsoluteThickness[0.25], 
     LineBox[{8474, 8475}]}, 
    {Hue[
      NCache[
       Rational[2825, 4769], 0.592367372614804]], AbsoluteThickness[0.25], 
     LineBox[{8475, 8476}]}, 
    {Hue[
      NCache[
       Rational[8476, 14307], 0.5924372684699797]], AbsoluteThickness[0.25], 
     LineBox[{8476, 8477}]}, 
    {Hue[
      NCache[
       Rational[8477, 14307], 0.5925071643251555]], AbsoluteThickness[0.25], 
     LineBox[{8477, 8478}]}, 
    {Hue[
      NCache[
       Rational[2826, 4769], 0.5925770601803313]], AbsoluteThickness[0.25], 
     LineBox[{8478, 8479}]}, 
    {Hue[
      NCache[
       Rational[8479, 14307], 0.5926469560355071]], AbsoluteThickness[0.25], 
     LineBox[{8479, 8480}]}, 
    {Hue[
      NCache[
       Rational[8480, 14307], 0.5927168518906829]], AbsoluteThickness[0.25], 
     LineBox[{8480, 8481}]}, 
    {Hue[
      NCache[
       Rational[2827, 4769], 0.5927867477458587]], AbsoluteThickness[0.25], 
     LineBox[{8481, 8482}]}, 
    {Hue[
      NCache[
       Rational[8482, 14307], 0.5928566436010344]], AbsoluteThickness[0.25], 
     LineBox[{8482, 8483}]}, 
    {Hue[
      NCache[
       Rational[8483, 14307], 0.5929265394562102]], AbsoluteThickness[0.25], 
     LineBox[{8483, 8484}]}, 
    {Hue[
      NCache[
       Rational[2828, 4769], 0.592996435311386]], AbsoluteThickness[0.25], 
     LineBox[{8484, 8485}]}, 
    {Hue[
      NCache[
       Rational[8485, 14307], 0.5930663311665618]], AbsoluteThickness[0.25], 
     LineBox[{8485, 8486}]}, 
    {Hue[
      NCache[
       Rational[8486, 14307], 0.5931362270217376]], AbsoluteThickness[0.25], 
     LineBox[{8486, 8487}]}, 
    {Hue[
      NCache[
       Rational[2829, 4769], 0.5932061228769134]], AbsoluteThickness[0.25], 
     LineBox[{8487, 8488}]}, 
    {Hue[
      NCache[
       Rational[8488, 14307], 0.5932760187320892]], AbsoluteThickness[0.25], 
     LineBox[{8488, 8489}]}, 
    {Hue[
      NCache[
       Rational[8489, 14307], 0.5933459145872649]], AbsoluteThickness[0.25], 
     LineBox[{8489, 8490}]}, 
    {Hue[
      NCache[
       Rational[2830, 4769], 0.5934158104424407]], AbsoluteThickness[0.25], 
     LineBox[{8490, 8491}]}, 
    {Hue[
      NCache[
       Rational[8491, 14307], 0.5934857062976165]], AbsoluteThickness[0.25], 
     LineBox[{8491, 8492}]}, 
    {Hue[
      NCache[
       Rational[8492, 14307], 0.5935556021527923]], AbsoluteThickness[0.25], 
     LineBox[{8492, 8493}]}, 
    {Hue[
      NCache[
       Rational[149, 251], 0.5936254980079682]], AbsoluteThickness[0.25], 
     LineBox[{8493, 8494}]}, 
    {Hue[
      NCache[
       Rational[8494, 14307], 0.593695393863144]], AbsoluteThickness[0.25], 
     LineBox[{8494, 8495}]}, 
    {Hue[
      NCache[
       Rational[8495, 14307], 0.5937652897183197]], AbsoluteThickness[0.25], 
     LineBox[{8495, 8496}]}, 
    {Hue[
      NCache[
       Rational[2832, 4769], 0.5938351855734955]], AbsoluteThickness[0.25], 
     LineBox[{8496, 8497}]}, 
    {Hue[
      NCache[
       Rational[8497, 14307], 0.5939050814286713]], AbsoluteThickness[0.25], 
     LineBox[{8497, 8498}]}, 
    {Hue[
      NCache[
       Rational[8498, 14307], 0.5939749772838471]], AbsoluteThickness[0.25], 
     LineBox[{8498, 8499}]}, 
    {Hue[
      NCache[
       Rational[2833, 4769], 0.5940448731390229]], AbsoluteThickness[0.25], 
     LineBox[{8499, 8500}]}, 
    {Hue[
      NCache[
       Rational[8500, 14307], 0.5941147689941987]], AbsoluteThickness[0.25], 
     LineBox[{8500, 8501}]}, 
    {Hue[
      NCache[
       Rational[8501, 14307], 0.5941846648493744]], AbsoluteThickness[0.25], 
     LineBox[{8501, 8502}]}, 
    {Hue[
      NCache[
       Rational[2834, 4769], 0.5942545607045502]], AbsoluteThickness[0.25], 
     LineBox[{8502, 8503}]}, 
    {Hue[
      NCache[
       Rational[8503, 14307], 0.594324456559726]], AbsoluteThickness[0.25], 
     LineBox[{8503, 8504}]}, 
    {Hue[
      NCache[
       Rational[8504, 14307], 0.5943943524149018]], AbsoluteThickness[0.25], 
     LineBox[{8504, 8505}]}, 
    {Hue[
      NCache[
       Rational[2835, 4769], 0.5944642482700776]], AbsoluteThickness[0.25], 
     LineBox[{8505, 8506}]}, 
    {Hue[
      NCache[
       Rational[8506, 14307], 0.5945341441252534]], AbsoluteThickness[0.25], 
     LineBox[{8506, 8507}]}, 
    {Hue[
      NCache[
       Rational[8507, 14307], 0.5946040399804292]], AbsoluteThickness[0.25], 
     LineBox[{8507, 8508}]}, 
    {Hue[
      NCache[
       Rational[2836, 4769], 0.5946739358356049]], AbsoluteThickness[0.25], 
     LineBox[{8508, 8509}]}, 
    {Hue[
      NCache[
       Rational[8509, 14307], 0.5947438316907807]], AbsoluteThickness[0.25], 
     LineBox[{8509, 8510}]}, 
    {Hue[
      NCache[
       Rational[8510, 14307], 0.5948137275459565]], AbsoluteThickness[0.25], 
     LineBox[{8510, 8511}]}, 
    {Hue[
      NCache[
       Rational[2837, 4769], 0.5948836234011323]], AbsoluteThickness[0.25], 
     LineBox[{8511, 8512}]}, 
    {Hue[
      NCache[
       Rational[448, 753], 0.5949535192563081]], AbsoluteThickness[0.25], 
     LineBox[{8512, 8513}]}, 
    {Hue[
      NCache[
       Rational[8513, 14307], 0.5950234151114839]], AbsoluteThickness[0.25], 
     LineBox[{8513, 8514}]}, 
    {Hue[
      NCache[
       Rational[2838, 4769], 0.5950933109666596]], AbsoluteThickness[0.25], 
     LineBox[{8514, 8515}]}, 
    {Hue[
      NCache[
       Rational[8515, 14307], 0.5951632068218354]], AbsoluteThickness[0.25], 
     LineBox[{8515, 8516}]}, 
    {Hue[
      NCache[
       Rational[8516, 14307], 0.5952331026770112]], AbsoluteThickness[0.25], 
     LineBox[{8516, 8517}]}, 
    {Hue[
      NCache[
       Rational[2839, 4769], 0.595302998532187]], AbsoluteThickness[0.25], 
     LineBox[{8517, 8518}]}, 
    {Hue[
      NCache[
       Rational[8518, 14307], 0.5953728943873628]], AbsoluteThickness[0.25], 
     LineBox[{8518, 8519}]}, 
    {Hue[
      NCache[
       Rational[8519, 14307], 0.5954427902425387]], AbsoluteThickness[0.25], 
     LineBox[{8519, 8520}]}, 
    {Hue[
      NCache[
       Rational[2840, 4769], 0.5955126860977145]], AbsoluteThickness[0.25], 
     LineBox[{8520, 8521}]}, 
    {Hue[
      NCache[
       Rational[8521, 14307], 0.5955825819528902]], AbsoluteThickness[0.25], 
     LineBox[{8521, 8522}]}, 
    {Hue[
      NCache[
       Rational[8522, 14307], 0.595652477808066]], AbsoluteThickness[0.25], 
     LineBox[{8522, 8523}]}, 
    {Hue[
      NCache[
       Rational[2841, 4769], 0.5957223736632418]], AbsoluteThickness[0.25], 
     LineBox[{8523, 8524}]}, 
    {Hue[
      NCache[
       Rational[8524, 14307], 0.5957922695184176]], AbsoluteThickness[0.25], 
     LineBox[{8524, 8525}]}, 
    {Hue[
      NCache[
       Rational[8525, 14307], 0.5958621653735934]], AbsoluteThickness[0.25], 
     LineBox[{8525, 8526}]}, 
    {Hue[
      NCache[
       Rational[2842, 4769], 0.5959320612287692]], AbsoluteThickness[0.25], 
     LineBox[{8526, 8527}]}, 
    {Hue[
      NCache[
       Rational[8527, 14307], 0.5960019570839449]], AbsoluteThickness[0.25], 
     LineBox[{8527, 8528}]}, 
    {Hue[
      NCache[
       Rational[8528, 14307], 0.5960718529391207]], AbsoluteThickness[0.25], 
     LineBox[{8528, 8529}]}, 
    {Hue[
      NCache[
       Rational[2843, 4769], 0.5961417487942965]], AbsoluteThickness[0.25], 
     LineBox[{8529, 8530}]}, 
    {Hue[
      NCache[
       Rational[8530, 14307], 0.5962116446494723]], AbsoluteThickness[0.25], 
     LineBox[{8530, 8531}]}, 
    {Hue[
      NCache[
       Rational[449, 753], 0.5962815405046481]], AbsoluteThickness[0.25], 
     LineBox[{8531, 8532}]}, 
    {Hue[
      NCache[
       Rational[2844, 4769], 0.5963514363598239]], AbsoluteThickness[0.25], 
     LineBox[{8532, 8533}]}, 
    {Hue[
      NCache[
       Rational[8533, 14307], 0.5964213322149996]], AbsoluteThickness[0.25], 
     LineBox[{8533, 8534}]}, 
    {Hue[
      NCache[
       Rational[34, 57], 0.5964912280701754]], AbsoluteThickness[0.25], 
     LineBox[{8534, 8535}]}, 
    {Hue[
      NCache[
       Rational[2845, 4769], 0.5965611239253512]], AbsoluteThickness[0.25], 
     LineBox[{8535, 8536}]}, 
    {Hue[
      NCache[
       Rational[8536, 14307], 0.596631019780527]], AbsoluteThickness[0.25], 
     LineBox[{8536, 8537}]}, 
    {Hue[
      NCache[
       Rational[8537, 14307], 0.5967009156357028]], AbsoluteThickness[0.25], 
     LineBox[{8537, 8538}]}, 
    {Hue[
      NCache[
       Rational[2846, 4769], 0.5967708114908786]], AbsoluteThickness[0.25], 
     LineBox[{8538, 8539}]}, 
    {Hue[
      NCache[
       Rational[8539, 14307], 0.5968407073460544]], AbsoluteThickness[0.25], 
     LineBox[{8539, 8540}]}, 
    {Hue[
      NCache[
       Rational[8540, 14307], 0.5969106032012301]], AbsoluteThickness[0.25], 
     LineBox[{8540, 8541}]}, 
    {Hue[
      NCache[
       Rational[2847, 4769], 0.5969804990564059]], AbsoluteThickness[0.25], 
     LineBox[{8541, 8542}]}, 
    {Hue[
      NCache[
       Rational[8542, 14307], 0.5970503949115817]], AbsoluteThickness[0.25], 
     LineBox[{8542, 8543}]}, 
    {Hue[
      NCache[
       Rational[8543, 14307], 0.5971202907667575]], AbsoluteThickness[0.25], 
     LineBox[{8543, 8544}]}, 
    {Hue[
      NCache[
       Rational[2848, 4769], 0.5971901866219333]], AbsoluteThickness[0.25], 
     LineBox[{8544, 8545}]}, 
    {Hue[
      NCache[
       Rational[8545, 14307], 0.5972600824771092]], AbsoluteThickness[0.25], 
     LineBox[{8545, 8546}]}, 
    {Hue[
      NCache[
       Rational[8546, 14307], 0.5973299783322848]], AbsoluteThickness[0.25], 
     LineBox[{8546, 8547}]}, 
    {Hue[
      NCache[
       Rational[2849, 4769], 0.5973998741874607]], AbsoluteThickness[0.25], 
     LineBox[{8547, 8548}]}, 
    {Hue[
      NCache[
       Rational[8548, 14307], 0.5974697700426365]], AbsoluteThickness[0.25], 
     LineBox[{8548, 8549}]}, 
    {Hue[
      NCache[
       Rational[8549, 14307], 0.5975396658978123]], AbsoluteThickness[0.25], 
     LineBox[{8549, 8550}]}, 
    {Hue[
      NCache[
       Rational[150, 251], 0.5976095617529881]], AbsoluteThickness[0.25], 
     LineBox[{8550, 8551}]}, 
    {Hue[
      NCache[
       Rational[8551, 14307], 0.5976794576081639]], AbsoluteThickness[0.25], 
     LineBox[{8551, 8552}]}, 
    {Hue[
      NCache[
       Rational[8552, 14307], 0.5977493534633396]], AbsoluteThickness[0.25], 
     LineBox[{8552, 8553}]}, 
    {Hue[
      NCache[
       Rational[2851, 4769], 0.5978192493185154]], AbsoluteThickness[0.25], 
     LineBox[{8553, 8554}]}, 
    {Hue[
      NCache[
       Rational[8554, 14307], 0.5978891451736912]], AbsoluteThickness[0.25], 
     LineBox[{8554, 8555}]}, 
    {Hue[
      NCache[
       Rational[8555, 14307], 0.597959041028867]], AbsoluteThickness[0.25], 
     LineBox[{8555, 8556}]}, 
    {Hue[
      NCache[
       Rational[2852, 4769], 0.5980289368840428]], AbsoluteThickness[0.25], 
     LineBox[{8556, 8557}]}, 
    {Hue[
      NCache[
       Rational[8557, 14307], 0.5980988327392186]], AbsoluteThickness[0.25], 
     LineBox[{8557, 8558}]}, 
    {Hue[
      NCache[
       Rational[8558, 14307], 0.5981687285943944]], AbsoluteThickness[0.25], 
     LineBox[{8558, 8559}]}, 
    {Hue[
      NCache[
       Rational[2853, 4769], 0.5982386244495701]], AbsoluteThickness[0.25], 
     LineBox[{8559, 8560}]}, 
    {Hue[
      NCache[
       Rational[8560, 14307], 0.5983085203047459]], AbsoluteThickness[0.25], 
     LineBox[{8560, 8561}]}, 
    {Hue[
      NCache[
       Rational[8561, 14307], 0.5983784161599217]], AbsoluteThickness[0.25], 
     LineBox[{8561, 8562}]}, 
    {Hue[
      NCache[
       Rational[2854, 4769], 0.5984483120150975]], AbsoluteThickness[0.25], 
     LineBox[{8562, 8563}]}, 
    {Hue[
      NCache[
       Rational[8563, 14307], 0.5985182078702733]], AbsoluteThickness[0.25], 
     LineBox[{8563, 8564}]}, 
    {Hue[
      NCache[
       Rational[8564, 14307], 0.5985881037254491]], AbsoluteThickness[0.25], 
     LineBox[{8564, 8565}]}, 
    {Hue[
      NCache[
       Rational[2855, 4769], 0.5986579995806248]], AbsoluteThickness[0.25], 
     LineBox[{8565, 8566}]}, 
    {Hue[
      NCache[
       Rational[8566, 14307], 0.5987278954358006]], AbsoluteThickness[0.25], 
     LineBox[{8566, 8567}]}, 
    {Hue[
      NCache[
       Rational[8567, 14307], 0.5987977912909764]], AbsoluteThickness[0.25], 
     LineBox[{8567, 8568}]}, 
    {Hue[
      NCache[
       Rational[2856, 4769], 0.5988676871461522]], AbsoluteThickness[0.25], 
     LineBox[{8568, 8569}]}, 
    {Hue[
      NCache[
       Rational[451, 753], 0.598937583001328]], AbsoluteThickness[0.25], 
     LineBox[{8569, 8570}]}, 
    {Hue[
      NCache[
       Rational[8570, 14307], 0.5990074788565038]], AbsoluteThickness[0.25], 
     LineBox[{8570, 8571}]}, 
    {Hue[
      NCache[
       Rational[2857, 4769], 0.5990773747116795]], AbsoluteThickness[0.25], 
     LineBox[{8571, 8572}]}, 
    {Hue[
      NCache[
       Rational[8572, 14307], 0.5991472705668554]], AbsoluteThickness[0.25], 
     LineBox[{8572, 8573}]}, 
    {Hue[
      NCache[
       Rational[8573, 14307], 0.5992171664220312]], AbsoluteThickness[0.25], 
     LineBox[{8573, 8574}]}, 
    {Hue[
      NCache[
       Rational[2858, 4769], 0.599287062277207]], AbsoluteThickness[0.25], 
     LineBox[{8574, 8575}]}, 
    {Hue[
      NCache[
       Rational[8575, 14307], 0.5993569581323828]], AbsoluteThickness[0.25], 
     LineBox[{8575, 8576}]}, 
    {Hue[
      NCache[
       Rational[8576, 14307], 0.5994268539875586]], AbsoluteThickness[0.25], 
     LineBox[{8576, 8577}]}, 
    {Hue[
      NCache[
       Rational[2859, 4769], 0.5994967498427344]], AbsoluteThickness[0.25], 
     LineBox[{8577, 8578}]}, 
    {Hue[
      NCache[
       Rational[8578, 14307], 0.5995666456979101]], AbsoluteThickness[0.25], 
     LineBox[{8578, 8579}]}, 
    {Hue[
      NCache[
       Rational[8579, 14307], 0.5996365415530859]], AbsoluteThickness[0.25], 
     LineBox[{8579, 8580}]}, 
    {Hue[
      NCache[
       Rational[2860, 4769], 0.5997064374082617]], AbsoluteThickness[0.25], 
     LineBox[{8580, 8581}]}, 
    {Hue[
      NCache[
       Rational[8581, 14307], 0.5997763332634375]], AbsoluteThickness[0.25], 
     LineBox[{8581, 8582}]}, 
    {Hue[
      NCache[
       Rational[8582, 14307], 0.5998462291186133]], AbsoluteThickness[0.25], 
     LineBox[{8582, 8583}]}, 
    {Hue[
      NCache[
       Rational[2861, 4769], 0.5999161249737891]], AbsoluteThickness[0.25], 
     LineBox[{8583, 8584}]}, 
    {Hue[
      NCache[
       Rational[8584, 14307], 0.5999860208289648]], AbsoluteThickness[0.25], 
     LineBox[{8584, 8585}]}, 
    {Hue[
      NCache[
       Rational[8585, 14307], 0.6000559166841406]], AbsoluteThickness[0.25], 
     LineBox[{8585, 8586}]}, 
    {Hue[
      NCache[
       Rational[2862, 4769], 0.6001258125393164]], AbsoluteThickness[0.25], 
     LineBox[{8586, 8587}]}, 
    {Hue[
      NCache[
       Rational[8587, 14307], 0.6001957083944922]], AbsoluteThickness[0.25], 
     LineBox[{8587, 8588}]}, 
    {Hue[
      NCache[
       Rational[452, 753], 0.600265604249668]], AbsoluteThickness[0.25], 
     LineBox[{8588, 8589}]}, 
    {Hue[
      NCache[
       Rational[2863, 4769], 0.6003355001048438]], AbsoluteThickness[0.25], 
     LineBox[{8589, 8590}]}, 
    {Hue[
      NCache[
       Rational[8590, 14307], 0.6004053959600195]], AbsoluteThickness[0.25], 
     LineBox[{8590, 8591}]}, 
    {Hue[
      NCache[
       Rational[8591, 14307], 0.6004752918151953]], AbsoluteThickness[0.25], 
     LineBox[{8591, 8592}]}, 
    {Hue[
      NCache[
       Rational[2864, 4769], 0.6005451876703711]], AbsoluteThickness[0.25], 
     LineBox[{8592, 8593}]}, 
    {Hue[
      NCache[
       Rational[8593, 14307], 0.6006150835255469]], AbsoluteThickness[0.25], 
     LineBox[{8593, 8594}]}, 
    {Hue[
      NCache[
       Rational[8594, 14307], 0.6006849793807227]], AbsoluteThickness[0.25], 
     LineBox[{8594, 8595}]}, 
    {Hue[
      NCache[
       Rational[2865, 4769], 0.6007548752358985]], AbsoluteThickness[0.25], 
     LineBox[{8595, 8596}]}, 
    {Hue[
      NCache[
       Rational[8596, 14307], 0.6008247710910743]], AbsoluteThickness[0.25], 
     LineBox[{8596, 8597}]}, 
    {Hue[
      NCache[
       Rational[8597, 14307], 0.60089466694625]], AbsoluteThickness[0.25], 
     LineBox[{8597, 8598}]}, 
    {Hue[
      NCache[
       Rational[2866, 4769], 0.6009645628014259]], AbsoluteThickness[0.25], 
     LineBox[{8598, 8599}]}, 
    {Hue[
      NCache[
       Rational[8599, 14307], 0.6010344586566017]], AbsoluteThickness[0.25], 
     LineBox[{8599, 8600}]}, 
    {Hue[
      NCache[
       Rational[8600, 14307], 0.6011043545117775]], AbsoluteThickness[0.25], 
     LineBox[{8600, 8601}]}, 
    {Hue[
      NCache[
       Rational[2867, 4769], 0.6011742503669533]], AbsoluteThickness[0.25], 
     LineBox[{8601, 8602}]}, 
    {Hue[
      NCache[
       Rational[8602, 14307], 0.6012441462221291]], AbsoluteThickness[0.25], 
     LineBox[{8602, 8603}]}, 
    {Hue[
      NCache[
       Rational[8603, 14307], 0.6013140420773048]], AbsoluteThickness[0.25], 
     LineBox[{8603, 8604}]}, 
    {Hue[
      NCache[
       Rational[2868, 4769], 0.6013839379324806]], AbsoluteThickness[0.25], 
     LineBox[{8604, 8605}]}, 
    {Hue[
      NCache[
       Rational[8605, 14307], 0.6014538337876564]], AbsoluteThickness[0.25], 
     LineBox[{8605, 8606}]}, 
    {Hue[
      NCache[
       Rational[8606, 14307], 0.6015237296428322]], AbsoluteThickness[0.25], 
     LineBox[{8606, 8607}]}, 
    {Hue[
      NCache[
       Rational[151, 251], 0.601593625498008]], AbsoluteThickness[0.25], 
     LineBox[{8607, 8608}]}, 
    {Hue[
      NCache[
       Rational[8608, 14307], 0.6016635213531838]], AbsoluteThickness[0.25], 
     LineBox[{8608, 8609}]}, 
    {Hue[
      NCache[
       Rational[8609, 14307], 0.6017334172083595]], AbsoluteThickness[0.25], 
     LineBox[{8609, 8610}]}, 
    {Hue[
      NCache[
       Rational[2870, 4769], 0.6018033130635353]], AbsoluteThickness[0.25], 
     LineBox[{8610, 8611}]}, 
    {Hue[
      NCache[
       Rational[8611, 14307], 0.6018732089187111]], AbsoluteThickness[0.25], 
     LineBox[{8611, 8612}]}, 
    {Hue[
      NCache[
       Rational[8612, 14307], 0.6019431047738869]], AbsoluteThickness[0.25], 
     LineBox[{8612, 8613}]}, 
    {Hue[
      NCache[
       Rational[2871, 4769], 0.6020130006290627]], AbsoluteThickness[0.25], 
     LineBox[{8613, 8614}]}, 
    {Hue[
      NCache[
       Rational[8614, 14307], 0.6020828964842385]], AbsoluteThickness[0.25], 
     LineBox[{8614, 8615}]}, 
    {Hue[
      NCache[
       Rational[8615, 14307], 0.6021527923394143]], AbsoluteThickness[0.25], 
     LineBox[{8615, 8616}]}, 
    {Hue[
      NCache[
       Rational[2872, 4769], 0.60222268819459]], AbsoluteThickness[0.25], 
     LineBox[{8616, 8617}]}, 
    {Hue[
      NCache[
       Rational[8617, 14307], 0.6022925840497658]], AbsoluteThickness[0.25], 
     LineBox[{8617, 8618}]}, 
    {Hue[
      NCache[
       Rational[8618, 14307], 0.6023624799049416]], AbsoluteThickness[0.25], 
     LineBox[{8618, 8619}]}, 
    {Hue[
      NCache[
       Rational[2873, 4769], 0.6024323757601174]], AbsoluteThickness[0.25], 
     LineBox[{8619, 8620}]}, 
    {Hue[
      NCache[
       Rational[8620, 14307], 0.6025022716152932]], AbsoluteThickness[0.25], 
     LineBox[{8620, 8621}]}, 
    {Hue[
      NCache[
       Rational[8621, 14307], 0.602572167470469]], AbsoluteThickness[0.25], 
     LineBox[{8621, 8622}]}, 
    {Hue[
      NCache[
       Rational[2874, 4769], 0.6026420633256447]], AbsoluteThickness[0.25], 
     LineBox[{8622, 8623}]}, 
    {Hue[
      NCache[
       Rational[8623, 14307], 0.6027119591808205]], AbsoluteThickness[0.25], 
     LineBox[{8623, 8624}]}, 
    {Hue[
      NCache[
       Rational[8624, 14307], 0.6027818550359964]], AbsoluteThickness[0.25], 
     LineBox[{8624, 8625}]}, 
    {Hue[
      NCache[
       Rational[2875, 4769], 0.6028517508911722]], AbsoluteThickness[0.25], 
     LineBox[{8625, 8626}]}, 
    {Hue[
      NCache[
       Rational[454, 753], 0.602921646746348]], AbsoluteThickness[0.25], 
     LineBox[{8626, 8627}]}, 
    {Hue[
      NCache[
       Rational[8627, 14307], 0.6029915426015238]], AbsoluteThickness[0.25], 
     LineBox[{8627, 8628}]}, 
    {Hue[
      NCache[
       Rational[2876, 4769], 0.6030614384566996]], AbsoluteThickness[0.25], 
     LineBox[{8628, 8629}]}, 
    {Hue[
      NCache[
       Rational[8629, 14307], 0.6031313343118753]], AbsoluteThickness[0.25], 
     LineBox[{8629, 8630}]}, 
    {Hue[
      NCache[
       Rational[8630, 14307], 0.6032012301670511]], AbsoluteThickness[0.25], 
     LineBox[{8630, 8631}]}, 
    {Hue[
      NCache[
       Rational[2877, 4769], 0.6032711260222269]], AbsoluteThickness[0.25], 
     LineBox[{8631, 8632}]}, 
    {Hue[
      NCache[
       Rational[8632, 14307], 0.6033410218774027]], AbsoluteThickness[0.25], 
     LineBox[{8632, 8633}]}, 
    {Hue[
      NCache[
       Rational[8633, 14307], 0.6034109177325785]], AbsoluteThickness[0.25], 
     LineBox[{8633, 8634}]}, 
    {Hue[
      NCache[
       Rational[2878, 4769], 0.6034808135877543]], AbsoluteThickness[0.25], 
     LineBox[{8634, 8635}]}, 
    {Hue[
      NCache[
       Rational[8635, 14307], 0.60355070944293]], AbsoluteThickness[0.25], 
     LineBox[{8635, 8636}]}, 
    {Hue[
      NCache[
       Rational[8636, 14307], 0.6036206052981058]], AbsoluteThickness[0.25], 
     LineBox[{8636, 8637}]}, 
    {Hue[
      NCache[
       Rational[2879, 4769], 0.6036905011532816]], AbsoluteThickness[0.25], 
     LineBox[{8637, 8638}]}, 
    {Hue[
      NCache[
       Rational[8638, 14307], 0.6037603970084574]], AbsoluteThickness[0.25], 
     LineBox[{8638, 8639}]}, 
    {Hue[
      NCache[
       Rational[8639, 14307], 0.6038302928636332]], AbsoluteThickness[0.25], 
     LineBox[{8639, 8640}]}, 
    {Hue[
      NCache[
       Rational[2880, 4769], 0.603900188718809]], AbsoluteThickness[0.25], 
     LineBox[{8640, 8641}]}, 
    {Hue[
      NCache[
       Rational[8641, 14307], 0.6039700845739847]], AbsoluteThickness[0.25], 
     LineBox[{8641, 8642}]}, 
    {Hue[
      NCache[
       Rational[8642, 14307], 0.6040399804291605]], AbsoluteThickness[0.25], 
     LineBox[{8642, 8643}]}, 
    {Hue[
      NCache[
       Rational[2881, 4769], 0.6041098762843363]], AbsoluteThickness[0.25], 
     LineBox[{8643, 8644}]}, 
    {Hue[
      NCache[
       Rational[8644, 14307], 0.6041797721395121]], AbsoluteThickness[0.25], 
     LineBox[{8644, 8645}]}, 
    {Hue[
      NCache[
       Rational[455, 753], 0.6042496679946879]], AbsoluteThickness[0.25], 
     LineBox[{8645, 8646}]}, 
    {Hue[
      NCache[
       Rational[2882, 4769], 0.6043195638498637]], AbsoluteThickness[0.25], 
     LineBox[{8646, 8647}]}, 
    {Hue[
      NCache[
       Rational[8647, 14307], 0.6043894597050395]], AbsoluteThickness[0.25], 
     LineBox[{8647, 8648}]}, 
    {Hue[
      NCache[
       Rational[8648, 14307], 0.6044593555602152]], AbsoluteThickness[0.25], 
     LineBox[{8648, 8649}]}, 
    {Hue[
      NCache[
       Rational[2883, 4769], 0.604529251415391]], AbsoluteThickness[0.25], 
     LineBox[{8649, 8650}]}, 
    {Hue[
      NCache[
       Rational[8650, 14307], 0.6045991472705669]], AbsoluteThickness[0.25], 
     LineBox[{8650, 8651}]}, 
    {Hue[
      NCache[
       Rational[8651, 14307], 0.6046690431257427]], AbsoluteThickness[0.25], 
     LineBox[{8651, 8652}]}, 
    {Hue[
      NCache[
       Rational[2884, 4769], 0.6047389389809185]], AbsoluteThickness[0.25], 
     LineBox[{8652, 8653}]}, 
    {Hue[
      NCache[
       Rational[8653, 14307], 0.6048088348360943]], AbsoluteThickness[0.25], 
     LineBox[{8653, 8654}]}, 
    {Hue[
      NCache[
       Rational[8654, 14307], 0.60487873069127]], AbsoluteThickness[0.25], 
     LineBox[{8654, 8655}]}, 
    {Hue[
      NCache[
       Rational[2885, 4769], 0.6049486265464458]], AbsoluteThickness[0.25], 
     LineBox[{8655, 8656}]}, 
    {Hue[
      NCache[
       Rational[8656, 14307], 0.6050185224016216]], AbsoluteThickness[0.25], 
     LineBox[{8656, 8657}]}, 
    {Hue[
      NCache[
       Rational[8657, 14307], 0.6050884182567974]], AbsoluteThickness[0.25], 
     LineBox[{8657, 8658}]}, 
    {Hue[
      NCache[
       Rational[2886, 4769], 0.6051583141119732]], AbsoluteThickness[0.25], 
     LineBox[{8658, 8659}]}, 
    {Hue[
      NCache[
       Rational[8659, 14307], 0.605228209967149]], AbsoluteThickness[0.25], 
     LineBox[{8659, 8660}]}, 
    {Hue[
      NCache[
       Rational[8660, 14307], 0.6052981058223247]], AbsoluteThickness[0.25], 
     LineBox[{8660, 8661}]}, 
    {Hue[
      NCache[
       Rational[2887, 4769], 0.6053680016775005]], AbsoluteThickness[0.25], 
     LineBox[{8661, 8662}]}, 
    {Hue[
      NCache[
       Rational[8662, 14307], 0.6054378975326763]], AbsoluteThickness[0.25], 
     LineBox[{8662, 8663}]}, 
    {Hue[
      NCache[
       Rational[8663, 14307], 0.6055077933878521]], AbsoluteThickness[0.25], 
     LineBox[{8663, 8664}]}, 
    {Hue[
      NCache[
       Rational[152, 251], 0.6055776892430279]], AbsoluteThickness[0.25], 
     LineBox[{8664, 8665}]}, 
    {Hue[
      NCache[
       Rational[8665, 14307], 0.6056475850982037]], AbsoluteThickness[0.25], 
     LineBox[{8665, 8666}]}, 
    {Hue[
      NCache[
       Rational[8666, 14307], 0.6057174809533795]], AbsoluteThickness[0.25], 
     LineBox[{8666, 8667}]}, 
    {Hue[
      NCache[
       Rational[2889, 4769], 0.6057873768085552]], AbsoluteThickness[0.25], 
     LineBox[{8667, 8668}]}, 
    {Hue[
      NCache[
       Rational[8668, 14307], 0.605857272663731]], AbsoluteThickness[0.25], 
     LineBox[{8668, 8669}]}, 
    {Hue[
      NCache[
       Rational[8669, 14307], 0.6059271685189068]], AbsoluteThickness[0.25], 
     LineBox[{8669, 8670}]}, 
    {Hue[
      NCache[
       Rational[2890, 4769], 0.6059970643740826]], AbsoluteThickness[0.25], 
     LineBox[{8670, 8671}]}, 
    {Hue[
      NCache[
       Rational[8671, 14307], 0.6060669602292584]], AbsoluteThickness[0.25], 
     LineBox[{8671, 8672}]}, 
    {Hue[
      NCache[
       Rational[8672, 14307], 0.6061368560844342]], AbsoluteThickness[0.25], 
     LineBox[{8672, 8673}]}, 
    {Hue[
      NCache[
       Rational[2891, 4769], 0.6062067519396099]], AbsoluteThickness[0.25], 
     LineBox[{8673, 8674}]}, 
    {Hue[
      NCache[
       Rational[8674, 14307], 0.6062766477947857]], AbsoluteThickness[0.25], 
     LineBox[{8674, 8675}]}, 
    {Hue[
      NCache[
       Rational[8675, 14307], 0.6063465436499615]], AbsoluteThickness[0.25], 
     LineBox[{8675, 8676}]}, 
    {Hue[
      NCache[
       Rational[2892, 4769], 0.6064164395051374]], AbsoluteThickness[0.25], 
     LineBox[{8676, 8677}]}, 
    {Hue[
      NCache[
       Rational[8677, 14307], 0.6064863353603132]], AbsoluteThickness[0.25], 
     LineBox[{8677, 8678}]}, 
    {Hue[
      NCache[
       Rational[8678, 14307], 0.606556231215489]], AbsoluteThickness[0.25], 
     LineBox[{8678, 8679}]}, 
    {Hue[
      NCache[
       Rational[2893, 4769], 0.6066261270706647]], AbsoluteThickness[0.25], 
     LineBox[{8679, 8680}]}, 
    {Hue[
      NCache[
       Rational[8680, 14307], 0.6066960229258405]], AbsoluteThickness[0.25], 
     LineBox[{8680, 8681}]}, 
    {Hue[
      NCache[
       Rational[8681, 14307], 0.6067659187810163]], AbsoluteThickness[0.25], 
     LineBox[{8681, 8682}]}, 
    {Hue[
      NCache[
       Rational[2894, 4769], 0.6068358146361921]], AbsoluteThickness[0.25], 
     LineBox[{8682, 8683}]}, 
    {Hue[
      NCache[
       Rational[457, 753], 0.6069057104913679]], AbsoluteThickness[0.25], 
     LineBox[{8683, 8684}]}, 
    {Hue[
      NCache[
       Rational[8684, 14307], 0.6069756063465437]], AbsoluteThickness[0.25], 
     LineBox[{8684, 8685}]}, 
    {Hue[
      NCache[
       Rational[2895, 4769], 0.6070455022017195]], AbsoluteThickness[0.25], 
     LineBox[{8685, 8686}]}, 
    {Hue[
      NCache[
       Rational[8686, 14307], 0.6071153980568952]], AbsoluteThickness[0.25], 
     LineBox[{8686, 8687}]}, 
    {Hue[
      NCache[
       Rational[8687, 14307], 0.607185293912071]], AbsoluteThickness[0.25], 
     LineBox[{8687, 8688}]}, 
    {Hue[
      NCache[
       Rational[2896, 4769], 0.6072551897672468]], AbsoluteThickness[0.25], 
     LineBox[{8688, 8689}]}, 
    {Hue[
      NCache[
       Rational[8689, 14307], 0.6073250856224226]], AbsoluteThickness[0.25], 
     LineBox[{8689, 8690}]}, 
    {Hue[
      NCache[
       Rational[8690, 14307], 0.6073949814775984]], AbsoluteThickness[0.25], 
     LineBox[{8690, 8691}]}, 
    {Hue[
      NCache[
       Rational[2897, 4769], 0.6074648773327742]], AbsoluteThickness[0.25], 
     LineBox[{8691, 8692}]}, 
    {Hue[
      NCache[
       Rational[8692, 14307], 0.6075347731879499]], AbsoluteThickness[0.25], 
     LineBox[{8692, 8693}]}, 
    {Hue[
      NCache[
       Rational[8693, 14307], 0.6076046690431257]], AbsoluteThickness[0.25], 
     LineBox[{8693, 8694}]}, 
    {Hue[
      NCache[
       Rational[2898, 4769], 0.6076745648983015]], AbsoluteThickness[0.25], 
     LineBox[{8694, 8695}]}, 
    {Hue[
      NCache[
       Rational[8695, 14307], 0.6077444607534773]], AbsoluteThickness[0.25], 
     LineBox[{8695, 8696}]}, 
    {Hue[
      NCache[
       Rational[8696, 14307], 0.6078143566086531]], AbsoluteThickness[0.25], 
     LineBox[{8696, 8697}]}, 
    {Hue[
      NCache[
       Rational[2899, 4769], 0.6078842524638289]], AbsoluteThickness[0.25], 
     LineBox[{8697, 8698}]}, 
    {Hue[
      NCache[
       Rational[8698, 14307], 0.6079541483190046]], AbsoluteThickness[0.25], 
     LineBox[{8698, 8699}]}, 
    {Hue[
      NCache[
       Rational[8699, 14307], 0.6080240441741804]], AbsoluteThickness[0.25], 
     LineBox[{8699, 8700}]}, 
    {Hue[
      NCache[
       Rational[2900, 4769], 0.6080939400293562]], AbsoluteThickness[0.25], 
     LineBox[{8700, 8701}]}, 
    {Hue[
      NCache[
       Rational[8701, 14307], 0.608163835884532]], AbsoluteThickness[0.25], 
     LineBox[{8701, 8702}]}, 
    {Hue[
      NCache[
       Rational[458, 753], 0.6082337317397079]], AbsoluteThickness[0.25], 
     LineBox[{8702, 8703}]}, 
    {Hue[
      NCache[
       Rational[2901, 4769], 0.6083036275948837]], AbsoluteThickness[0.25], 
     LineBox[{8703, 8704}]}, 
    {Hue[
      NCache[
       Rational[8704, 14307], 0.6083735234500595]], AbsoluteThickness[0.25], 
     LineBox[{8704, 8705}]}, 
    {Hue[
      NCache[
       Rational[8705, 14307], 0.6084434193052352]], AbsoluteThickness[0.25], 
     LineBox[{8705, 8706}]}, 
    {Hue[
      NCache[
       Rational[2902, 4769], 0.608513315160411]], AbsoluteThickness[0.25], 
     LineBox[{8706, 8707}]}, 
    {Hue[
      NCache[
       Rational[8707, 14307], 0.6085832110155868]], AbsoluteThickness[0.25], 
     LineBox[{8707, 8708}]}, 
    {Hue[
      NCache[
       Rational[8708, 14307], 0.6086531068707626]], AbsoluteThickness[0.25], 
     LineBox[{8708, 8709}]}, 
    {Hue[
      NCache[
       Rational[2903, 4769], 0.6087230027259384]], AbsoluteThickness[0.25], 
     LineBox[{8709, 8710}]}, 
    {Hue[
      NCache[
       Rational[8710, 14307], 0.6087928985811142]], AbsoluteThickness[0.25], 
     LineBox[{8710, 8711}]}, 
    {Hue[
      NCache[
       Rational[8711, 14307], 0.6088627944362899]], AbsoluteThickness[0.25], 
     LineBox[{8711, 8712}]}, 
    {Hue[
      NCache[
       Rational[2904, 4769], 0.6089326902914657]], AbsoluteThickness[0.25], 
     LineBox[{8712, 8713}]}, 
    {Hue[
      NCache[
       Rational[8713, 14307], 0.6090025861466415]], AbsoluteThickness[0.25], 
     LineBox[{8713, 8714}]}, 
    {Hue[
      NCache[
       Rational[8714, 14307], 0.6090724820018173]], AbsoluteThickness[0.25], 
     LineBox[{8714, 8715}]}, 
    {Hue[
      NCache[
       Rational[2905, 4769], 0.6091423778569931]], AbsoluteThickness[0.25], 
     LineBox[{8715, 8716}]}, 
    {Hue[
      NCache[
       Rational[8716, 14307], 0.6092122737121689]], AbsoluteThickness[0.25], 
     LineBox[{8716, 8717}]}, 
    {Hue[
      NCache[
       Rational[8717, 14307], 0.6092821695673447]], AbsoluteThickness[0.25], 
     LineBox[{8717, 8718}]}, 
    {Hue[
      NCache[
       Rational[2906, 4769], 0.6093520654225204]], AbsoluteThickness[0.25], 
     LineBox[{8718, 8719}]}, 
    {Hue[
      NCache[
       Rational[8719, 14307], 0.6094219612776962]], AbsoluteThickness[0.25], 
     LineBox[{8719, 8720}]}, 
    {Hue[
      NCache[
       Rational[8720, 14307], 0.609491857132872]], AbsoluteThickness[0.25], 
     LineBox[{8720, 8721}]}, 
    {Hue[
      NCache[
       Rational[153, 251], 0.6095617529880478]], AbsoluteThickness[0.25], 
     LineBox[{8721, 8722}]}, 
    {Hue[
      NCache[
       Rational[8722, 14307], 0.6096316488432236]], AbsoluteThickness[0.25], 
     LineBox[{8722, 8723}]}, 
    {Hue[
      NCache[
       Rational[8723, 14307], 0.6097015446983994]], AbsoluteThickness[0.25], 
     LineBox[{8723, 8724}]}, 
    {Hue[
      NCache[
       Rational[2908, 4769], 0.6097714405535751]], AbsoluteThickness[0.25], 
     LineBox[{8724, 8725}]}, 
    {Hue[
      NCache[
       Rational[8725, 14307], 0.6098413364087509]], AbsoluteThickness[0.25], 
     LineBox[{8725, 8726}]}, 
    {Hue[
      NCache[
       Rational[8726, 14307], 0.6099112322639267]], AbsoluteThickness[0.25], 
     LineBox[{8726, 8727}]}, 
    {Hue[
      NCache[
       Rational[2909, 4769], 0.6099811281191025]], AbsoluteThickness[0.25], 
     LineBox[{8727, 8728}]}, 
    {Hue[
      NCache[
       Rational[8728, 14307], 0.6100510239742784]], AbsoluteThickness[0.25], 
     LineBox[{8728, 8729}]}, 
    {Hue[
      NCache[
       Rational[8729, 14307], 0.6101209198294542]], AbsoluteThickness[0.25], 
     LineBox[{8729, 8730}]}, 
    {Hue[
      NCache[
       Rational[2910, 4769], 0.6101908156846299]], AbsoluteThickness[0.25], 
     LineBox[{8730, 8731}]}, 
    {Hue[
      NCache[
       Rational[8731, 14307], 0.6102607115398057]], AbsoluteThickness[0.25], 
     LineBox[{8731, 8732}]}, 
    {Hue[
      NCache[
       Rational[8732, 14307], 0.6103306073949815]], AbsoluteThickness[0.25], 
     LineBox[{8732, 8733}]}, 
    {Hue[
      NCache[
       Rational[2911, 4769], 0.6104005032501573]], AbsoluteThickness[0.25], 
     LineBox[{8733, 8734}]}, 
    {Hue[
      NCache[
       Rational[8734, 14307], 0.6104703991053331]], AbsoluteThickness[0.25], 
     LineBox[{8734, 8735}]}, 
    {Hue[
      NCache[
       Rational[8735, 14307], 0.6105402949605089]], AbsoluteThickness[0.25], 
     LineBox[{8735, 8736}]}, 
    {Hue[
      NCache[
       Rational[2912, 4769], 0.6106101908156847]], AbsoluteThickness[0.25], 
     LineBox[{8736, 8737}]}, 
    {Hue[
      NCache[
       Rational[8737, 14307], 0.6106800866708604]], AbsoluteThickness[0.25], 
     LineBox[{8737, 8738}]}, 
    {Hue[
      NCache[
       Rational[8738, 14307], 0.6107499825260362]], AbsoluteThickness[0.25], 
     LineBox[{8738, 8739}]}, 
    {Hue[
      NCache[
       Rational[2913, 4769], 0.610819878381212]], AbsoluteThickness[0.25], 
     LineBox[{8739, 8740}]}, 
    {Hue[
      NCache[
       Rational[460, 753], 0.6108897742363878]], AbsoluteThickness[0.25], 
     LineBox[{8740, 8741}]}, 
    {Hue[
      NCache[
       Rational[8741, 14307], 0.6109596700915636]], AbsoluteThickness[0.25], 
     LineBox[{8741, 8742}]}, 
    {Hue[
      NCache[
       Rational[2914, 4769], 0.6110295659467394]], AbsoluteThickness[0.25], 
     LineBox[{8742, 8743}]}, 
    {Hue[
      NCache[
       Rational[8743, 14307], 0.6110994618019151]], AbsoluteThickness[0.25], 
     LineBox[{8743, 8744}]}, 
    {Hue[
      NCache[
       Rational[8744, 14307], 0.6111693576570909]], AbsoluteThickness[0.25], 
     LineBox[{8744, 8745}]}, 
    {Hue[
      NCache[
       Rational[2915, 4769], 0.6112392535122667]], AbsoluteThickness[0.25], 
     LineBox[{8745, 8746}]}, 
    {Hue[
      NCache[
       Rational[8746, 14307], 0.6113091493674425]], AbsoluteThickness[0.25], 
     LineBox[{8746, 8747}]}, 
    {Hue[
      NCache[
       Rational[8747, 14307], 0.6113790452226183]], AbsoluteThickness[0.25], 
     LineBox[{8747, 8748}]}, 
    {Hue[
      NCache[
       Rational[2916, 4769], 0.6114489410777941]], AbsoluteThickness[0.25], 
     LineBox[{8748, 8749}]}, 
    {Hue[
      NCache[
       Rational[8749, 14307], 0.6115188369329698]], AbsoluteThickness[0.25], 
     LineBox[{8749, 8750}]}, 
    {Hue[
      NCache[
       Rational[8750, 14307], 0.6115887327881456]], AbsoluteThickness[0.25], 
     LineBox[{8750, 8751}]}, 
    {Hue[
      NCache[
       Rational[2917, 4769], 0.6116586286433214]], AbsoluteThickness[0.25], 
     LineBox[{8751, 8752}]}, 
    {Hue[
      NCache[
       Rational[8752, 14307], 0.6117285244984972]], AbsoluteThickness[0.25], 
     LineBox[{8752, 8753}]}, 
    {Hue[
      NCache[
       Rational[8753, 14307], 0.611798420353673]], AbsoluteThickness[0.25], 
     LineBox[{8753, 8754}]}, 
    {Hue[
      NCache[
       Rational[2918, 4769], 0.6118683162088489]], AbsoluteThickness[0.25], 
     LineBox[{8754, 8755}]}, 
    {Hue[
      NCache[
       Rational[8755, 14307], 0.6119382120640247]], AbsoluteThickness[0.25], 
     LineBox[{8755, 8756}]}, 
    {Hue[
      NCache[
       Rational[8756, 14307], 0.6120081079192004]], AbsoluteThickness[0.25], 
     LineBox[{8756, 8757}]}, 
    {Hue[
      NCache[
       Rational[2919, 4769], 0.6120780037743762]], AbsoluteThickness[0.25], 
     LineBox[{8757, 8758}]}, 
    {Hue[
      NCache[
       Rational[8758, 14307], 0.612147899629552]], AbsoluteThickness[0.25], 
     LineBox[{8758, 8759}]}, 
    {Hue[
      NCache[
       Rational[461, 753], 0.6122177954847278]], AbsoluteThickness[0.25], 
     LineBox[{8759, 8760}]}, 
    {Hue[
      NCache[
       Rational[2920, 4769], 0.6122876913399036]], AbsoluteThickness[0.25], 
     LineBox[{8760, 8761}]}, 
    {Hue[
      NCache[
       Rational[8761, 14307], 0.6123575871950794]], AbsoluteThickness[0.25], 
     LineBox[{8761, 8762}]}, 
    {Hue[
      NCache[
       Rational[8762, 14307], 0.6124274830502551]], AbsoluteThickness[0.25], 
     LineBox[{8762, 8763}]}, 
    {Hue[
      NCache[
       Rational[2921, 4769], 0.6124973789054309]], AbsoluteThickness[0.25], 
     LineBox[{8763, 8764}]}, 
    {Hue[
      NCache[
       Rational[8764, 14307], 0.6125672747606067]], AbsoluteThickness[0.25], 
     LineBox[{8764, 8765}]}, 
    {Hue[
      NCache[
       Rational[8765, 14307], 0.6126371706157825]], AbsoluteThickness[0.25], 
     LineBox[{8765, 8766}]}, 
    {Hue[
      NCache[
       Rational[2922, 4769], 0.6127070664709583]], AbsoluteThickness[0.25], 
     LineBox[{8766, 8767}]}, 
    {Hue[
      NCache[
       Rational[8767, 14307], 0.6127769623261341]], AbsoluteThickness[0.25], 
     LineBox[{8767, 8768}]}, 
    {Hue[
      NCache[
       Rational[8768, 14307], 0.6128468581813098]], AbsoluteThickness[0.25], 
     LineBox[{8768, 8769}]}, 
    {Hue[
      NCache[
       Rational[2923, 4769], 0.6129167540364856]], AbsoluteThickness[0.25], 
     LineBox[{8769, 8770}]}, 
    {Hue[
      NCache[
       Rational[8770, 14307], 0.6129866498916614]], AbsoluteThickness[0.25], 
     LineBox[{8770, 8771}]}, 
    {Hue[
      NCache[
       Rational[8771, 14307], 0.6130565457468372]], AbsoluteThickness[0.25], 
     LineBox[{8771, 8772}]}, 
    {Hue[
      NCache[
       Rational[2924, 4769], 0.613126441602013]], AbsoluteThickness[0.25], 
     LineBox[{8772, 8773}]}, 
    {Hue[
      NCache[
       Rational[8773, 14307], 0.6131963374571888]], AbsoluteThickness[0.25], 
     LineBox[{8773, 8774}]}, 
    {Hue[
      NCache[
       Rational[8774, 14307], 0.6132662333123646]], AbsoluteThickness[0.25], 
     LineBox[{8774, 8775}]}, 
    {Hue[
      NCache[
       Rational[2925, 4769], 0.6133361291675403]], AbsoluteThickness[0.25], 
     LineBox[{8775, 8776}]}, 
    {Hue[
      NCache[
       Rational[8776, 14307], 0.6134060250227161]], AbsoluteThickness[0.25], 
     LineBox[{8776, 8777}]}, 
    {Hue[
      NCache[
       Rational[8777, 14307], 0.6134759208778919]], AbsoluteThickness[0.25], 
     LineBox[{8777, 8778}]}, 
    {Hue[
      NCache[
       Rational[154, 251], 0.6135458167330677]], AbsoluteThickness[0.25], 
     LineBox[{8778, 8779}]}, 
    {Hue[
      NCache[
       Rational[8779, 14307], 0.6136157125882435]], AbsoluteThickness[0.25], 
     LineBox[{8779, 8780}]}, 
    {Hue[
      NCache[
       Rational[8780, 14307], 0.6136856084434194]], AbsoluteThickness[0.25], 
     LineBox[{8780, 8781}]}, 
    {Hue[
      NCache[
       Rational[2927, 4769], 0.613755504298595]], AbsoluteThickness[0.25], 
     LineBox[{8781, 8782}]}, 
    {Hue[
      NCache[
       Rational[8782, 14307], 0.6138254001537709]], AbsoluteThickness[0.25], 
     LineBox[{8782, 8783}]}, 
    {Hue[
      NCache[
       Rational[8783, 14307], 0.6138952960089467]], AbsoluteThickness[0.25], 
     LineBox[{8783, 8784}]}, 
    {Hue[
      NCache[
       Rational[2928, 4769], 0.6139651918641225]], AbsoluteThickness[0.25], 
     LineBox[{8784, 8785}]}, 
    {Hue[
      NCache[
       Rational[35, 57], 0.6140350877192983]], AbsoluteThickness[0.25], 
     LineBox[{8785, 8786}]}, 
    {Hue[
      NCache[
       Rational[8786, 14307], 0.6141049835744741]], AbsoluteThickness[0.25], 
     LineBox[{8786, 8787}]}, 
    {Hue[
      NCache[
       Rational[2929, 4769], 0.6141748794296498]], AbsoluteThickness[0.25], 
     LineBox[{8787, 8788}]}, 
    {Hue[
      NCache[
       Rational[8788, 14307], 0.6142447752848256]], AbsoluteThickness[0.25], 
     LineBox[{8788, 8789}]}, 
    {Hue[
      NCache[
       Rational[8789, 14307], 0.6143146711400014]], AbsoluteThickness[0.25], 
     LineBox[{8789, 8790}]}, 
    {Hue[
      NCache[
       Rational[2930, 4769], 0.6143845669951772]], AbsoluteThickness[0.25], 
     LineBox[{8790, 8791}]}, 
    {Hue[
      NCache[
       Rational[8791, 14307], 0.614454462850353]], AbsoluteThickness[0.25], 
     LineBox[{8791, 8792}]}, 
    {Hue[
      NCache[
       Rational[8792, 14307], 0.6145243587055288]], AbsoluteThickness[0.25], 
     LineBox[{8792, 8793}]}, 
    {Hue[
      NCache[
       Rational[2931, 4769], 0.6145942545607046]], AbsoluteThickness[0.25], 
     LineBox[{8793, 8794}]}, 
    {Hue[
      NCache[
       Rational[8794, 14307], 0.6146641504158803]], AbsoluteThickness[0.25], 
     LineBox[{8794, 8795}]}, 
    {Hue[
      NCache[
       Rational[8795, 14307], 0.6147340462710561]], AbsoluteThickness[0.25], 
     LineBox[{8795, 8796}]}, 
    {Hue[
      NCache[
       Rational[2932, 4769], 0.6148039421262319]], AbsoluteThickness[0.25], 
     LineBox[{8796, 8797}]}, 
    {Hue[
      NCache[
       Rational[463, 753], 0.6148738379814077]], AbsoluteThickness[0.25], 
     LineBox[{8797, 8798}]}, 
    {Hue[
      NCache[
       Rational[8798, 14307], 0.6149437338365835]], AbsoluteThickness[0.25], 
     LineBox[{8798, 8799}]}, 
    {Hue[
      NCache[
       Rational[2933, 4769], 0.6150136296917593]], AbsoluteThickness[0.25], 
     LineBox[{8799, 8800}]}, 
    {Hue[
      NCache[
       Rational[8800, 14307], 0.615083525546935]], AbsoluteThickness[0.25], 
     LineBox[{8800, 8801}]}, 
    {Hue[
      NCache[
       Rational[8801, 14307], 0.6151534214021108]], AbsoluteThickness[0.25], 
     LineBox[{8801, 8802}]}, 
    {Hue[
      NCache[
       Rational[2934, 4769], 0.6152233172572866]], AbsoluteThickness[0.25], 
     LineBox[{8802, 8803}]}, 
    {Hue[
      NCache[
       Rational[8803, 14307], 0.6152932131124624]], AbsoluteThickness[0.25], 
     LineBox[{8803, 8804}]}, 
    {Hue[
      NCache[
       Rational[8804, 14307], 0.6153631089676382]], AbsoluteThickness[0.25], 
     LineBox[{8804, 8805}]}, 
    {Hue[
      NCache[
       Rational[2935, 4769], 0.615433004822814]], AbsoluteThickness[0.25], 
     LineBox[{8805, 8806}]}, 
    {Hue[
      NCache[
       Rational[8806, 14307], 0.6155029006779899]], AbsoluteThickness[0.25], 
     LineBox[{8806, 8807}]}, 
    {Hue[
      NCache[
       Rational[8807, 14307], 0.6155727965331655]], AbsoluteThickness[0.25], 
     LineBox[{8807, 8808}]}, 
    {Hue[
      NCache[
       Rational[2936, 4769], 0.6156426923883414]], AbsoluteThickness[0.25], 
     LineBox[{8808, 8809}]}, 
    {Hue[
      NCache[
       Rational[8809, 14307], 0.6157125882435172]], AbsoluteThickness[0.25], 
     LineBox[{8809, 8810}]}, 
    {Hue[
      NCache[
       Rational[8810, 14307], 0.615782484098693]], AbsoluteThickness[0.25], 
     LineBox[{8810, 8811}]}, 
    {Hue[
      NCache[
       Rational[2937, 4769], 0.6158523799538688]], AbsoluteThickness[0.25], 
     LineBox[{8811, 8812}]}, 
    {Hue[
      NCache[
       Rational[8812, 14307], 0.6159222758090446]], AbsoluteThickness[0.25], 
     LineBox[{8812, 8813}]}, 
    {Hue[
      NCache[
       Rational[8813, 14307], 0.6159921716642203]], AbsoluteThickness[0.25], 
     LineBox[{8813, 8814}]}, 
    {Hue[
      NCache[
       Rational[2938, 4769], 0.6160620675193961]], AbsoluteThickness[0.25], 
     LineBox[{8814, 8815}]}, 
    {Hue[
      NCache[
       Rational[8815, 14307], 0.6161319633745719]], AbsoluteThickness[0.25], 
     LineBox[{8815, 8816}]}, 
    {Hue[
      NCache[
       Rational[464, 753], 0.6162018592297477]], AbsoluteThickness[0.25], 
     LineBox[{8816, 8817}]}, 
    {Hue[
      NCache[
       Rational[2939, 4769], 0.6162717550849235]], AbsoluteThickness[0.25], 
     LineBox[{8817, 8818}]}, 
    {Hue[
      NCache[
       Rational[8818, 14307], 0.6163416509400993]], AbsoluteThickness[0.25], 
     LineBox[{8818, 8819}]}, 
    {Hue[
      NCache[
       Rational[8819, 14307], 0.616411546795275]], AbsoluteThickness[0.25], 
     LineBox[{8819, 8820}]}, 
    {Hue[
      NCache[
       Rational[2940, 4769], 0.6164814426504508]], AbsoluteThickness[0.25], 
     LineBox[{8820, 8821}]}, 
    {Hue[
      NCache[
       Rational[8821, 14307], 0.6165513385056266]], AbsoluteThickness[0.25], 
     LineBox[{8821, 8822}]}, 
    {Hue[
      NCache[
       Rational[8822, 14307], 0.6166212343608024]], AbsoluteThickness[0.25], 
     LineBox[{8822, 8823}]}, 
    {Hue[
      NCache[
       Rational[2941, 4769], 0.6166911302159782]], AbsoluteThickness[0.25], 
     LineBox[{8823, 8824}]}, 
    {Hue[
      NCache[
       Rational[8824, 14307], 0.616761026071154]], AbsoluteThickness[0.25], 
     LineBox[{8824, 8825}]}, 
    {Hue[
      NCache[
       Rational[8825, 14307], 0.6168309219263298]], AbsoluteThickness[0.25], 
     LineBox[{8825, 8826}]}, 
    {Hue[
      NCache[
       Rational[2942, 4769], 0.6169008177815055]], AbsoluteThickness[0.25], 
     LineBox[{8826, 8827}]}, 
    {Hue[
      NCache[
       Rational[8827, 14307], 0.6169707136366813]], AbsoluteThickness[0.25], 
     LineBox[{8827, 8828}]}, 
    {Hue[
      NCache[
       Rational[8828, 14307], 0.6170406094918571]], AbsoluteThickness[0.25], 
     LineBox[{8828, 8829}]}, 
    {Hue[
      NCache[
       Rational[2943, 4769], 0.6171105053470329]], AbsoluteThickness[0.25], 
     LineBox[{8829, 8830}]}, 
    {Hue[
      NCache[
       Rational[8830, 14307], 0.6171804012022087]], AbsoluteThickness[0.25], 
     LineBox[{8830, 8831}]}, 
    {Hue[
      NCache[
       Rational[8831, 14307], 0.6172502970573845]], AbsoluteThickness[0.25], 
     LineBox[{8831, 8832}]}, 
    {Hue[
      NCache[
       Rational[2944, 4769], 0.6173201929125602]], AbsoluteThickness[0.25], 
     LineBox[{8832, 8833}]}, 
    {Hue[
      NCache[
       Rational[8833, 14307], 0.617390088767736]], AbsoluteThickness[0.25], 
     LineBox[{8833, 8834}]}, 
    {Hue[
      NCache[
       Rational[8834, 14307], 0.6174599846229119]], AbsoluteThickness[0.25], 
     LineBox[{8834, 8835}]}, 
    {Hue[
      NCache[
       Rational[155, 251], 0.6175298804780877]], AbsoluteThickness[0.25], 
     LineBox[{8835, 8836}]}, 
    {Hue[
      NCache[
       Rational[8836, 14307], 0.6175997763332635]], AbsoluteThickness[0.25], 
     LineBox[{8836, 8837}]}, 
    {Hue[
      NCache[
       Rational[8837, 14307], 0.6176696721884393]], AbsoluteThickness[0.25], 
     LineBox[{8837, 8838}]}, 
    {Hue[
      NCache[
       Rational[2946, 4769], 0.617739568043615]], AbsoluteThickness[0.25], 
     LineBox[{8838, 8839}]}, 
    {Hue[
      NCache[
       Rational[8839, 14307], 0.6178094638987908]], AbsoluteThickness[0.25], 
     LineBox[{8839, 8840}]}, 
    {Hue[
      NCache[
       Rational[8840, 14307], 0.6178793597539666]], AbsoluteThickness[0.25], 
     LineBox[{8840, 8841}]}, 
    {Hue[
      NCache[
       Rational[2947, 4769], 0.6179492556091424]], AbsoluteThickness[0.25], 
     LineBox[{8841, 8842}]}, 
    {Hue[
      NCache[
       Rational[8842, 14307], 0.6180191514643182]], AbsoluteThickness[0.25], 
     LineBox[{8842, 8843}]}, 
    {Hue[
      NCache[
       Rational[8843, 14307], 0.618089047319494]], AbsoluteThickness[0.25], 
     LineBox[{8843, 8844}]}, 
    {Hue[
      NCache[
       Rational[2948, 4769], 0.6181589431746698]], AbsoluteThickness[0.25], 
     LineBox[{8844, 8845}]}, 
    {Hue[
      NCache[
       Rational[8845, 14307], 0.6182288390298455]], AbsoluteThickness[0.25], 
     LineBox[{8845, 8846}]}, 
    {Hue[
      NCache[
       Rational[8846, 14307], 0.6182987348850213]], AbsoluteThickness[0.25], 
     LineBox[{8846, 8847}]}, 
    {Hue[
      NCache[
       Rational[2949, 4769], 0.6183686307401971]], AbsoluteThickness[0.25], 
     LineBox[{8847, 8848}]}, 
    {Hue[
      NCache[
       Rational[8848, 14307], 0.6184385265953729]], AbsoluteThickness[0.25], 
     LineBox[{8848, 8849}]}, 
    {Hue[
      NCache[
       Rational[8849, 14307], 0.6185084224505487]], AbsoluteThickness[0.25], 
     LineBox[{8849, 8850}]}, 
    {Hue[
      NCache[
       Rational[2950, 4769], 0.6185783183057245]], AbsoluteThickness[0.25], 
     LineBox[{8850, 8851}]}, 
    {Hue[
      NCache[
       Rational[8851, 14307], 0.6186482141609002]], AbsoluteThickness[0.25], 
     LineBox[{8851, 8852}]}, 
    {Hue[
      NCache[
       Rational[8852, 14307], 0.618718110016076]], AbsoluteThickness[0.25], 
     LineBox[{8852, 8853}]}, 
    {Hue[
      NCache[
       Rational[2951, 4769], 0.6187880058712518]], AbsoluteThickness[0.25], 
     LineBox[{8853, 8854}]}, 
    {Hue[
      NCache[
       Rational[466, 753], 0.6188579017264276]], AbsoluteThickness[0.25], 
     LineBox[{8854, 8855}]}, 
    {Hue[
      NCache[
       Rational[8855, 14307], 0.6189277975816034]], AbsoluteThickness[0.25], 
     LineBox[{8855, 8856}]}, 
    {Hue[
      NCache[
       Rational[2952, 4769], 0.6189976934367792]], AbsoluteThickness[0.25], 
     LineBox[{8856, 8857}]}, 
    {Hue[
      NCache[
       Rational[8857, 14307], 0.6190675892919549]], AbsoluteThickness[0.25], 
     LineBox[{8857, 8858}]}, 
    {Hue[
      NCache[
       Rational[8858, 14307], 0.6191374851471307]], AbsoluteThickness[0.25], 
     LineBox[{8858, 8859}]}, 
    {Hue[
      NCache[
       Rational[2953, 4769], 0.6192073810023065]], AbsoluteThickness[0.25], 
     LineBox[{8859, 8860}]}, 
    {Hue[
      NCache[
       Rational[8860, 14307], 0.6192772768574824]], AbsoluteThickness[0.25], 
     LineBox[{8860, 8861}]}, 
    {Hue[
      NCache[
       Rational[8861, 14307], 0.6193471727126582]], AbsoluteThickness[0.25], 
     LineBox[{8861, 8862}]}, 
    {Hue[
      NCache[
       Rational[2954, 4769], 0.619417068567834]], AbsoluteThickness[0.25], 
     LineBox[{8862, 8863}]}, 
    {Hue[
      NCache[
       Rational[8863, 14307], 0.6194869644230098]], AbsoluteThickness[0.25], 
     LineBox[{8863, 8864}]}, 
    {Hue[
      NCache[
       Rational[8864, 14307], 0.6195568602781855]], AbsoluteThickness[0.25], 
     LineBox[{8864, 8865}]}, 
    {Hue[
      NCache[
       Rational[2955, 4769], 0.6196267561333613]], AbsoluteThickness[0.25], 
     LineBox[{8865, 8866}]}, 
    {Hue[
      NCache[
       Rational[8866, 14307], 0.6196966519885371]], AbsoluteThickness[0.25], 
     LineBox[{8866, 8867}]}, 
    {Hue[
      NCache[
       Rational[8867, 14307], 0.6197665478437129]], AbsoluteThickness[0.25], 
     LineBox[{8867, 8868}]}, 
    {Hue[
      NCache[
       Rational[2956, 4769], 0.6198364436988887]], AbsoluteThickness[0.25], 
     LineBox[{8868, 8869}]}, 
    {Hue[
      NCache[
       Rational[8869, 14307], 0.6199063395540645]], AbsoluteThickness[0.25], 
     LineBox[{8869, 8870}]}, 
    {Hue[
      NCache[
       Rational[8870, 14307], 0.6199762354092402]], AbsoluteThickness[0.25], 
     LineBox[{8870, 8871}]}, 
    {Hue[
      NCache[
       Rational[2957, 4769], 0.620046131264416]], AbsoluteThickness[0.25], 
     LineBox[{8871, 8872}]}, 
    {Hue[
      NCache[
       Rational[8872, 14307], 0.6201160271195918]], AbsoluteThickness[0.25], 
     LineBox[{8872, 8873}]}, 
    {Hue[
      NCache[
       Rational[467, 753], 0.6201859229747676]], AbsoluteThickness[0.25], 
     LineBox[{8873, 8874}]}, 
    {Hue[
      NCache[
       Rational[2958, 4769], 0.6202558188299434]], AbsoluteThickness[0.25], 
     LineBox[{8874, 8875}]}, 
    {Hue[
      NCache[
       Rational[8875, 14307], 0.6203257146851192]], AbsoluteThickness[0.25], 
     LineBox[{8875, 8876}]}, 
    {Hue[
      NCache[
       Rational[8876, 14307], 0.6203956105402949]], AbsoluteThickness[0.25], 
     LineBox[{8876, 8877}]}, 
    {Hue[
      NCache[
       Rational[2959, 4769], 0.6204655063954707]], AbsoluteThickness[0.25], 
     LineBox[{8877, 8878}]}, 
    {Hue[
      NCache[
       Rational[8878, 14307], 0.6205354022506465]], AbsoluteThickness[0.25], 
     LineBox[{8878, 8879}]}, 
    {Hue[
      NCache[
       Rational[8879, 14307], 0.6206052981058223]], AbsoluteThickness[0.25], 
     LineBox[{8879, 8880}]}, 
    {Hue[
      NCache[
       Rational[2960, 4769], 0.6206751939609981]], AbsoluteThickness[0.25], 
     LineBox[{8880, 8881}]}, 
    {Hue[
      NCache[
       Rational[8881, 14307], 0.6207450898161739]], AbsoluteThickness[0.25], 
     LineBox[{8881, 8882}]}, 
    {Hue[
      NCache[
       Rational[8882, 14307], 0.6208149856713497]], AbsoluteThickness[0.25], 
     LineBox[{8882, 8883}]}, 
    {Hue[
      NCache[
       Rational[2961, 4769], 0.6208848815265254]], AbsoluteThickness[0.25], 
     LineBox[{8883, 8884}]}, 
    {Hue[
      NCache[
       Rational[8884, 14307], 0.6209547773817012]], AbsoluteThickness[0.25], 
     LineBox[{8884, 8885}]}, 
    {Hue[
      NCache[
       Rational[8885, 14307], 0.621024673236877]], AbsoluteThickness[0.25], 
     LineBox[{8885, 8886}]}, 
    {Hue[
      NCache[
       Rational[2962, 4769], 0.6210945690920529]], AbsoluteThickness[0.25], 
     LineBox[{8886, 8887}]}, 
    {Hue[
      NCache[
       Rational[8887, 14307], 0.6211644649472287]], AbsoluteThickness[0.25], 
     LineBox[{8887, 8888}]}, 
    {Hue[
      NCache[
       Rational[8888, 14307], 0.6212343608024045]], AbsoluteThickness[0.25], 
     LineBox[{8888, 8889}]}, 
    {Hue[
      NCache[
       Rational[2963, 4769], 0.6213042566575802]], AbsoluteThickness[0.25], 
     LineBox[{8889, 8890}]}, 
    {Hue[
      NCache[
       Rational[8890, 14307], 0.621374152512756]], AbsoluteThickness[0.25], 
     LineBox[{8890, 8891}]}, 
    {Hue[
      NCache[
       Rational[8891, 14307], 0.6214440483679318]], AbsoluteThickness[0.25], 
     LineBox[{8891, 8892}]}, 
    {Hue[
      NCache[
       Rational[156, 251], 0.6215139442231076]], AbsoluteThickness[0.25], 
     LineBox[{8892, 8893}]}, 
    {Hue[
      NCache[
       Rational[8893, 14307], 0.6215838400782834]], AbsoluteThickness[0.25], 
     LineBox[{8893, 8894}]}, 
    {Hue[
      NCache[
       Rational[8894, 14307], 0.6216537359334592]], AbsoluteThickness[0.25], 
     LineBox[{8894, 8895}]}, 
    {Hue[
      NCache[
       Rational[2965, 4769], 0.621723631788635]], AbsoluteThickness[0.25], 
     LineBox[{8895, 8896}]}, 
    {Hue[
      NCache[
       Rational[8896, 14307], 0.6217935276438107]], AbsoluteThickness[0.25], 
     LineBox[{8896, 8897}]}, 
    {Hue[
      NCache[
       Rational[8897, 14307], 0.6218634234989865]], AbsoluteThickness[0.25], 
     LineBox[{8897, 8898}]}, 
    {Hue[
      NCache[
       Rational[2966, 4769], 0.6219333193541623]], AbsoluteThickness[0.25], 
     LineBox[{8898, 8899}]}, 
    {Hue[
      NCache[
       Rational[8899, 14307], 0.6220032152093381]], AbsoluteThickness[0.25], 
     LineBox[{8899, 8900}]}, 
    {Hue[
      NCache[
       Rational[8900, 14307], 0.6220731110645139]], AbsoluteThickness[0.25], 
     LineBox[{8900, 8901}]}, 
    {Hue[
      NCache[
       Rational[2967, 4769], 0.6221430069196897]], AbsoluteThickness[0.25], 
     LineBox[{8901, 8902}]}, 
    {Hue[
      NCache[
       Rational[8902, 14307], 0.6222129027748654]], AbsoluteThickness[0.25], 
     LineBox[{8902, 8903}]}, 
    {Hue[
      NCache[
       Rational[8903, 14307], 0.6222827986300412]], AbsoluteThickness[0.25], 
     LineBox[{8903, 8904}]}, 
    {Hue[
      NCache[
       Rational[2968, 4769], 0.622352694485217]], AbsoluteThickness[0.25], 
     LineBox[{8904, 8905}]}, 
    {Hue[
      NCache[
       Rational[8905, 14307], 0.6224225903403928]], AbsoluteThickness[0.25], 
     LineBox[{8905, 8906}]}, 
    {Hue[
      NCache[
       Rational[8906, 14307], 0.6224924861955686]], AbsoluteThickness[0.25], 
     LineBox[{8906, 8907}]}, 
    {Hue[
      NCache[
       Rational[2969, 4769], 0.6225623820507444]], AbsoluteThickness[0.25], 
     LineBox[{8907, 8908}]}, 
    {Hue[
      NCache[
       Rational[8908, 14307], 0.6226322779059201]], AbsoluteThickness[0.25], 
     LineBox[{8908, 8909}]}, 
    {Hue[
      NCache[
       Rational[8909, 14307], 0.6227021737610959]], AbsoluteThickness[0.25], 
     LineBox[{8909, 8910}]}, 
    {Hue[
      NCache[
       Rational[2970, 4769], 0.6227720696162717]], AbsoluteThickness[0.25], 
     LineBox[{8910, 8911}]}, 
    {Hue[
      NCache[
       Rational[469, 753], 0.6228419654714475]], AbsoluteThickness[0.25], 
     LineBox[{8911, 8912}]}, 
    {Hue[
      NCache[
       Rational[8912, 14307], 0.6229118613266234]], AbsoluteThickness[0.25], 
     LineBox[{8912, 8913}]}, 
    {Hue[
      NCache[
       Rational[2971, 4769], 0.6229817571817992]], AbsoluteThickness[0.25], 
     LineBox[{8913, 8914}]}, 
    {Hue[
      NCache[
       Rational[8914, 14307], 0.623051653036975]], AbsoluteThickness[0.25], 
     LineBox[{8914, 8915}]}, 
    {Hue[
      NCache[
       Rational[8915, 14307], 0.6231215488921507]], AbsoluteThickness[0.25], 
     LineBox[{8915, 8916}]}, 
    {Hue[
      NCache[
       Rational[2972, 4769], 0.6231914447473265]], AbsoluteThickness[0.25], 
     LineBox[{8916, 8917}]}, 
    {Hue[
      NCache[
       Rational[8917, 14307], 0.6232613406025023]], AbsoluteThickness[0.25], 
     LineBox[{8917, 8918}]}, 
    {Hue[
      NCache[
       Rational[8918, 14307], 0.6233312364576781]], AbsoluteThickness[0.25], 
     LineBox[{8918, 8919}]}, 
    {Hue[
      NCache[
       Rational[2973, 4769], 0.6234011323128539]], AbsoluteThickness[0.25], 
     LineBox[{8919, 8920}]}, 
    {Hue[
      NCache[
       Rational[8920, 14307], 0.6234710281680297]], AbsoluteThickness[0.25], 
     LineBox[{8920, 8921}]}, 
    {Hue[
      NCache[
       Rational[8921, 14307], 0.6235409240232054]], AbsoluteThickness[0.25], 
     LineBox[{8921, 8922}]}, 
    {Hue[
      NCache[
       Rational[2974, 4769], 0.6236108198783812]], AbsoluteThickness[0.25], 
     LineBox[{8922, 8923}]}, 
    {Hue[
      NCache[
       Rational[8923, 14307], 0.623680715733557]], AbsoluteThickness[0.25], 
     LineBox[{8923, 8924}]}, 
    {Hue[
      NCache[
       Rational[8924, 14307], 0.6237506115887328]], AbsoluteThickness[0.25], 
     LineBox[{8924, 8925}]}, 
    {Hue[
      NCache[
       Rational[2975, 4769], 0.6238205074439086]], AbsoluteThickness[0.25], 
     LineBox[{8925, 8926}]}, 
    {Hue[
      NCache[
       Rational[8926, 14307], 0.6238904032990844]], AbsoluteThickness[0.25], 
     LineBox[{8926, 8927}]}, 
    {Hue[
      NCache[
       Rational[8927, 14307], 0.6239602991542601]], AbsoluteThickness[0.25], 
     LineBox[{8927, 8928}]}, 
    {Hue[
      NCache[
       Rational[2976, 4769], 0.6240301950094359]], AbsoluteThickness[0.25], 
     LineBox[{8928, 8929}]}, 
    {Hue[
      NCache[
       Rational[8929, 14307], 0.6241000908646117]], AbsoluteThickness[0.25], 
     LineBox[{8929, 8930}]}, 
    {Hue[
      NCache[
       Rational[470, 753], 0.6241699867197875]], AbsoluteThickness[0.25], 
     LineBox[{8930, 8931}]}, 
    {Hue[
      NCache[
       Rational[2977, 4769], 0.6242398825749633]], AbsoluteThickness[0.25], 
     LineBox[{8931, 8932}]}, 
    {Hue[
      NCache[
       Rational[8932, 14307], 0.6243097784301391]], AbsoluteThickness[0.25], 
     LineBox[{8932, 8933}]}, 
    {Hue[
      NCache[
       Rational[8933, 14307], 0.6243796742853149]], AbsoluteThickness[0.25], 
     LineBox[{8933, 8934}]}, 
    {Hue[
      NCache[
       Rational[2978, 4769], 0.6244495701404906]], AbsoluteThickness[0.25], 
     LineBox[{8934, 8935}]}, 
    {Hue[
      NCache[
       Rational[8935, 14307], 0.6245194659956664]], AbsoluteThickness[0.25], 
     LineBox[{8935, 8936}]}, 
    {Hue[
      NCache[
       Rational[8936, 14307], 0.6245893618508422]], AbsoluteThickness[0.25], 
     LineBox[{8936, 8937}]}, 
    {Hue[
      NCache[
       Rational[2979, 4769], 0.624659257706018]], AbsoluteThickness[0.25], 
     LineBox[{8937, 8938}]}, 
    {Hue[
      NCache[
       Rational[8938, 14307], 0.6247291535611939]], AbsoluteThickness[0.25], 
     LineBox[{8938, 8939}]}, 
    {Hue[
      NCache[
       Rational[8939, 14307], 0.6247990494163697]], AbsoluteThickness[0.25], 
     LineBox[{8939, 8940}]}, 
    {Hue[
      NCache[
       Rational[2980, 4769], 0.6248689452715454]], AbsoluteThickness[0.25], 
     LineBox[{8940, 8941}]}, 
    {Hue[
      NCache[
       Rational[8941, 14307], 0.6249388411267212]], AbsoluteThickness[0.25], 
     LineBox[{8941, 8942}]}, 
    {Hue[
      NCache[
       Rational[8942, 14307], 0.625008736981897]], AbsoluteThickness[0.25], 
     LineBox[{8942, 8943}]}, 
    {Hue[
      NCache[
       Rational[2981, 4769], 0.6250786328370728]], AbsoluteThickness[0.25], 
     LineBox[{8943, 8944}]}, 
    {Hue[
      NCache[
       Rational[8944, 14307], 0.6251485286922486]], AbsoluteThickness[0.25], 
     LineBox[{8944, 8945}]}, 
    {Hue[
      NCache[
       Rational[8945, 14307], 0.6252184245474244]], AbsoluteThickness[0.25], 
     LineBox[{8945, 8946}]}, 
    {Hue[
      NCache[
       Rational[2982, 4769], 0.6252883204026001]], AbsoluteThickness[0.25], 
     LineBox[{8946, 8947}]}, 
    {Hue[
      NCache[
       Rational[8947, 14307], 0.6253582162577759]], AbsoluteThickness[0.25], 
     LineBox[{8947, 8948}]}, 
    {Hue[
      NCache[
       Rational[8948, 14307], 0.6254281121129517]], AbsoluteThickness[0.25], 
     LineBox[{8948, 8949}]}, 
    {Hue[
      NCache[
       Rational[157, 251], 0.6254980079681275]], AbsoluteThickness[0.25], 
     LineBox[{8949, 8950}]}, 
    {Hue[
      NCache[
       Rational[8950, 14307], 0.6255679038233033]], AbsoluteThickness[0.25], 
     LineBox[{8950, 8951}]}, 
    {Hue[
      NCache[
       Rational[8951, 14307], 0.6256377996784791]], AbsoluteThickness[0.25], 
     LineBox[{8951, 8952}]}, 
    {Hue[
      NCache[
       Rational[2984, 4769], 0.6257076955336549]], AbsoluteThickness[0.25], 
     LineBox[{8952, 8953}]}, 
    {Hue[
      NCache[
       Rational[8953, 14307], 0.6257775913888306]], AbsoluteThickness[0.25], 
     LineBox[{8953, 8954}]}, 
    {Hue[
      NCache[
       Rational[8954, 14307], 0.6258474872440064]], AbsoluteThickness[0.25], 
     LineBox[{8954, 8955}]}, 
    {Hue[
      NCache[
       Rational[2985, 4769], 0.6259173830991822]], AbsoluteThickness[0.25], 
     LineBox[{8955, 8956}]}, 
    {Hue[
      NCache[
       Rational[8956, 14307], 0.625987278954358]], AbsoluteThickness[0.25], 
     LineBox[{8956, 8957}]}, 
    {Hue[
      NCache[
       Rational[8957, 14307], 0.6260571748095338]], AbsoluteThickness[0.25], 
     LineBox[{8957, 8958}]}, 
    {Hue[
      NCache[
       Rational[2986, 4769], 0.6261270706647096]], AbsoluteThickness[0.25], 
     LineBox[{8958, 8959}]}, 
    {Hue[
      NCache[
       Rational[8959, 14307], 0.6261969665198853]], AbsoluteThickness[0.25], 
     LineBox[{8959, 8960}]}, 
    {Hue[
      NCache[
       Rational[8960, 14307], 0.6262668623750611]], AbsoluteThickness[0.25], 
     LineBox[{8960, 8961}]}, 
    {Hue[
      NCache[
       Rational[2987, 4769], 0.6263367582302369]], AbsoluteThickness[0.25], 
     LineBox[{8961, 8962}]}, 
    {Hue[
      NCache[
       Rational[8962, 14307], 0.6264066540854127]], AbsoluteThickness[0.25], 
     LineBox[{8962, 8963}]}, 
    {Hue[
      NCache[
       Rational[8963, 14307], 0.6264765499405885]], AbsoluteThickness[0.25], 
     LineBox[{8963, 8964}]}, 
    {Hue[
      NCache[
       Rational[2988, 4769], 0.6265464457957644]], AbsoluteThickness[0.25], 
     LineBox[{8964, 8965}]}, 
    {Hue[
      NCache[
       Rational[8965, 14307], 0.62661634165094]], AbsoluteThickness[0.25], 
     LineBox[{8965, 8966}]}, 
    {Hue[
      NCache[
       Rational[8966, 14307], 0.6266862375061159]], AbsoluteThickness[0.25], 
     LineBox[{8966, 8967}]}, 
    {Hue[
      NCache[
       Rational[2989, 4769], 0.6267561333612917]], AbsoluteThickness[0.25], 
     LineBox[{8967, 8968}]}, 
    {Hue[
      NCache[
       Rational[472, 753], 0.6268260292164675]], AbsoluteThickness[0.25], 
     LineBox[{8968, 8969}]}, 
    {Hue[
      NCache[
       Rational[8969, 14307], 0.6268959250716433]], AbsoluteThickness[0.25], 
     LineBox[{8969, 8970}]}, 
    {Hue[
      NCache[
       Rational[2990, 4769], 0.6269658209268191]], AbsoluteThickness[0.25], 
     LineBox[{8970, 8971}]}, 
    {Hue[
      NCache[
       Rational[8971, 14307], 0.6270357167819949]], AbsoluteThickness[0.25], 
     LineBox[{8971, 8972}]}, 
    {Hue[
      NCache[
       Rational[8972, 14307], 0.6271056126371706]], AbsoluteThickness[0.25], 
     LineBox[{8972, 8973}]}, 
    {Hue[
      NCache[
       Rational[2991, 4769], 0.6271755084923464]], AbsoluteThickness[0.25], 
     LineBox[{8973, 8974}]}, 
    {Hue[
      NCache[
       Rational[8974, 14307], 0.6272454043475222]], AbsoluteThickness[0.25], 
     LineBox[{8974, 8975}]}, 
    {Hue[
      NCache[
       Rational[8975, 14307], 0.627315300202698]], AbsoluteThickness[0.25], 
     LineBox[{8975, 8976}]}, 
    {Hue[
      NCache[
       Rational[2992, 4769], 0.6273851960578738]], AbsoluteThickness[0.25], 
     LineBox[{8976, 8977}]}, 
    {Hue[
      NCache[
       Rational[8977, 14307], 0.6274550919130496]], AbsoluteThickness[0.25], 
     LineBox[{8977, 8978}]}, 
    {Hue[
      NCache[
       Rational[8978, 14307], 0.6275249877682253]], AbsoluteThickness[0.25], 
     LineBox[{8978, 8979}]}, 
    {Hue[
      NCache[
       Rational[2993, 4769], 0.6275948836234011]], AbsoluteThickness[0.25], 
     LineBox[{8979, 8980}]}, 
    {Hue[
      NCache[
       Rational[8980, 14307], 0.6276647794785769]], AbsoluteThickness[0.25], 
     LineBox[{8980, 8981}]}, 
    {Hue[
      NCache[
       Rational[8981, 14307], 0.6277346753337527]], AbsoluteThickness[0.25], 
     LineBox[{8981, 8982}]}, 
    {Hue[
      NCache[
       Rational[2994, 4769], 0.6278045711889285]], AbsoluteThickness[0.25], 
     LineBox[{8982, 8983}]}, 
    {Hue[
      NCache[
       Rational[8983, 14307], 0.6278744670441043]], AbsoluteThickness[0.25], 
     LineBox[{8983, 8984}]}, 
    {Hue[
      NCache[
       Rational[8984, 14307], 0.62794436289928]], AbsoluteThickness[0.25], 
     LineBox[{8984, 8985}]}, 
    {Hue[
      NCache[
       Rational[2995, 4769], 0.6280142587544558]], AbsoluteThickness[0.25], 
     LineBox[{8985, 8986}]}, 
    {Hue[
      NCache[
       Rational[8986, 14307], 0.6280841546096316]], AbsoluteThickness[0.25], 
     LineBox[{8986, 8987}]}, 
    {Hue[
      NCache[
       Rational[473, 753], 0.6281540504648074]], AbsoluteThickness[0.25], 
     LineBox[{8987, 8988}]}, 
    {Hue[
      NCache[
       Rational[2996, 4769], 0.6282239463199832]], AbsoluteThickness[0.25], 
     LineBox[{8988, 8989}]}, 
    {Hue[
      NCache[
       Rational[8989, 14307], 0.628293842175159]], AbsoluteThickness[0.25], 
     LineBox[{8989, 8990}]}, 
    {Hue[
      NCache[
       Rational[8990, 14307], 0.6283637380303349]], AbsoluteThickness[0.25], 
     LineBox[{8990, 8991}]}, 
    {Hue[
      NCache[
       Rational[2997, 4769], 0.6284336338855105]], AbsoluteThickness[0.25], 
     LineBox[{8991, 8992}]}, 
    {Hue[
      NCache[
       Rational[8992, 14307], 0.6285035297406864]], AbsoluteThickness[0.25], 
     LineBox[{8992, 8993}]}, 
    {Hue[
      NCache[
       Rational[8993, 14307], 0.6285734255958622]], AbsoluteThickness[0.25], 
     LineBox[{8993, 8994}]}, 
    {Hue[
      NCache[
       Rational[2998, 4769], 0.628643321451038]], AbsoluteThickness[0.25], 
     LineBox[{8994, 8995}]}, 
    {Hue[
      NCache[
       Rational[8995, 14307], 0.6287132173062138]], AbsoluteThickness[0.25], 
     LineBox[{8995, 8996}]}, 
    {Hue[
      NCache[
       Rational[8996, 14307], 0.6287831131613896]], AbsoluteThickness[0.25], 
     LineBox[{8996, 8997}]}, 
    {Hue[
      NCache[
       Rational[2999, 4769], 0.6288530090165653]], AbsoluteThickness[0.25], 
     LineBox[{8997, 8998}]}, 
    {Hue[
      NCache[
       Rational[8998, 14307], 0.6289229048717411]], AbsoluteThickness[0.25], 
     LineBox[{8998, 8999}]}, 
    {Hue[
      NCache[
       Rational[8999, 14307], 0.6289928007269169]], AbsoluteThickness[0.25], 
     LineBox[{8999, 9000}]}, 
    {Hue[
      NCache[
       Rational[3000, 4769], 0.6290626965820927]], AbsoluteThickness[0.25], 
     LineBox[{9000, 9001}]}, 
    {Hue[
      NCache[
       Rational[9001, 14307], 0.6291325924372685]], AbsoluteThickness[0.25], 
     LineBox[{9001, 9002}]}, 
    {Hue[
      NCache[
       Rational[9002, 14307], 0.6292024882924443]], AbsoluteThickness[0.25], 
     LineBox[{9002, 9003}]}, 
    {Hue[
      NCache[
       Rational[3001, 4769], 0.6292723841476201]], AbsoluteThickness[0.25], 
     LineBox[{9003, 9004}]}, 
    {Hue[
      NCache[
       Rational[9004, 14307], 0.6293422800027958]], AbsoluteThickness[0.25], 
     LineBox[{9004, 9005}]}, 
    {Hue[
      NCache[
       Rational[9005, 14307], 0.6294121758579716]], AbsoluteThickness[0.25], 
     LineBox[{9005, 9006}]}, 
    {Hue[
      NCache[
       Rational[158, 251], 0.6294820717131474]], AbsoluteThickness[0.25], 
     LineBox[{9006, 9007}]}, 
    {Hue[
      NCache[
       Rational[9007, 14307], 0.6295519675683232]], AbsoluteThickness[0.25], 
     LineBox[{9007, 9008}]}, 
    {Hue[
      NCache[
       Rational[9008, 14307], 0.629621863423499]], AbsoluteThickness[0.25], 
     LineBox[{9008, 9009}]}, 
    {Hue[
      NCache[
       Rational[3003, 4769], 0.6296917592786748]], AbsoluteThickness[0.25], 
     LineBox[{9009, 9010}]}, 
    {Hue[
      NCache[
       Rational[9010, 14307], 0.6297616551338505]], AbsoluteThickness[0.25], 
     LineBox[{9010, 9011}]}, 
    {Hue[
      NCache[
       Rational[9011, 14307], 0.6298315509890263]], AbsoluteThickness[0.25], 
     LineBox[{9011, 9012}]}, 
    {Hue[
      NCache[
       Rational[3004, 4769], 0.6299014468442021]], AbsoluteThickness[0.25], 
     LineBox[{9012, 9013}]}, 
    {Hue[
      NCache[
       Rational[9013, 14307], 0.6299713426993779]], AbsoluteThickness[0.25], 
     LineBox[{9013, 9014}]}, 
    {Hue[
      NCache[
       Rational[9014, 14307], 0.6300412385545537]], AbsoluteThickness[0.25], 
     LineBox[{9014, 9015}]}, 
    {Hue[
      NCache[
       Rational[3005, 4769], 0.6301111344097295]], AbsoluteThickness[0.25], 
     LineBox[{9015, 9016}]}, 
    {Hue[
      NCache[
       Rational[9016, 14307], 0.6301810302649052]], AbsoluteThickness[0.25], 
     LineBox[{9016, 9017}]}, 
    {Hue[
      NCache[
       Rational[9017, 14307], 0.630250926120081]], AbsoluteThickness[0.25], 
     LineBox[{9017, 9018}]}, 
    {Hue[
      NCache[
       Rational[3006, 4769], 0.6303208219752569]], AbsoluteThickness[0.25], 
     LineBox[{9018, 9019}]}, 
    {Hue[
      NCache[
       Rational[9019, 14307], 0.6303907178304327]], AbsoluteThickness[0.25], 
     LineBox[{9019, 9020}]}, 
    {Hue[
      NCache[
       Rational[9020, 14307], 0.6304606136856085]], AbsoluteThickness[0.25], 
     LineBox[{9020, 9021}]}, 
    {Hue[
      NCache[
       Rational[3007, 4769], 0.6305305095407843]], AbsoluteThickness[0.25], 
     LineBox[{9021, 9022}]}, 
    {Hue[
      NCache[
       Rational[9022, 14307], 0.6306004053959601]], AbsoluteThickness[0.25], 
     LineBox[{9022, 9023}]}, 
    {Hue[
      NCache[
       Rational[9023, 14307], 0.6306703012511358]], AbsoluteThickness[0.25], 
     LineBox[{9023, 9024}]}, 
    {Hue[
      NCache[
       Rational[3008, 4769], 0.6307401971063116]], AbsoluteThickness[0.25], 
     LineBox[{9024, 9025}]}, 
    {Hue[
      NCache[
       Rational[475, 753], 0.6308100929614874]], AbsoluteThickness[0.25], 
     LineBox[{9025, 9026}]}, 
    {Hue[
      NCache[
       Rational[9026, 14307], 0.6308799888166632]], AbsoluteThickness[0.25], 
     LineBox[{9026, 9027}]}, 
    {Hue[
      NCache[
       Rational[3009, 4769], 0.630949884671839]], AbsoluteThickness[0.25], 
     LineBox[{9027, 9028}]}, 
    {Hue[
      NCache[
       Rational[9028, 14307], 0.6310197805270148]], AbsoluteThickness[0.25], 
     LineBox[{9028, 9029}]}, 
    {Hue[
      NCache[
       Rational[9029, 14307], 0.6310896763821905]], AbsoluteThickness[0.25], 
     LineBox[{9029, 9030}]}, 
    {Hue[
      NCache[
       Rational[3010, 4769], 0.6311595722373663]], AbsoluteThickness[0.25], 
     LineBox[{9030, 9031}]}, 
    {Hue[
      NCache[
       Rational[9031, 14307], 0.6312294680925421]], AbsoluteThickness[0.25], 
     LineBox[{9031, 9032}]}, 
    {Hue[
      NCache[
       Rational[9032, 14307], 0.6312993639477179]], AbsoluteThickness[0.25], 
     LineBox[{9032, 9033}]}, 
    {Hue[
      NCache[
       Rational[3011, 4769], 0.6313692598028937]], AbsoluteThickness[0.25], 
     LineBox[{9033, 9034}]}, 
    {Hue[
      NCache[
       Rational[9034, 14307], 0.6314391556580695]], AbsoluteThickness[0.25], 
     LineBox[{9034, 9035}]}, 
    {Hue[
      NCache[
       Rational[9035, 14307], 0.6315090515132452]], AbsoluteThickness[0.25], 
     LineBox[{9035, 9036}]}, 
    {Hue[
      NCache[
       Rational[12, 19], 0.631578947368421]], AbsoluteThickness[0.25], 
     LineBox[{9036, 9037}]}, 
    {Hue[
      NCache[
       Rational[9037, 14307], 0.6316488432235968]], AbsoluteThickness[0.25], 
     LineBox[{9037, 9038}]}, 
    {Hue[
      NCache[
       Rational[9038, 14307], 0.6317187390787726]], AbsoluteThickness[0.25], 
     LineBox[{9038, 9039}]}, 
    {Hue[
      NCache[
       Rational[3013, 4769], 0.6317886349339484]], AbsoluteThickness[0.25], 
     LineBox[{9039, 9040}]}, 
    {Hue[
      NCache[
       Rational[9040, 14307], 0.6318585307891242]], AbsoluteThickness[0.25], 
     LineBox[{9040, 9041}]}, 
    {Hue[
      NCache[
       Rational[9041, 14307], 0.6319284266443]], AbsoluteThickness[0.25], 
     LineBox[{9041, 9042}]}, 
    {Hue[
      NCache[
       Rational[3014, 4769], 0.6319983224994757]], AbsoluteThickness[0.25], 
     LineBox[{9042, 9043}]}, 
    {Hue[
      NCache[
       Rational[9043, 14307], 0.6320682183546515]], AbsoluteThickness[0.25], 
     LineBox[{9043, 9044}]}, 
    {Hue[
      NCache[
       Rational[476, 753], 0.6321381142098274]], AbsoluteThickness[0.25], 
     LineBox[{9044, 9045}]}, 
    {Hue[
      NCache[
       Rational[3015, 4769], 0.6322080100650032]], AbsoluteThickness[0.25], 
     LineBox[{9045, 9046}]}, 
    {Hue[
      NCache[
       Rational[9046, 14307], 0.632277905920179]], AbsoluteThickness[0.25], 
     LineBox[{9046, 9047}]}, 
    {Hue[
      NCache[
       Rational[9047, 14307], 0.6323478017753548]], AbsoluteThickness[0.25], 
     LineBox[{9047, 9048}]}, 
    {Hue[
      NCache[
       Rational[3016, 4769], 0.6324176976305305]], AbsoluteThickness[0.25], 
     LineBox[{9048, 9049}]}, 
    {Hue[
      NCache[
       Rational[9049, 14307], 0.6324875934857063]], AbsoluteThickness[0.25], 
     LineBox[{9049, 9050}]}, 
    {Hue[
      NCache[
       Rational[9050, 14307], 0.6325574893408821]], AbsoluteThickness[0.25], 
     LineBox[{9050, 9051}]}, 
    {Hue[
      NCache[
       Rational[3017, 4769], 0.6326273851960579]], AbsoluteThickness[0.25], 
     LineBox[{9051, 9052}]}, 
    {Hue[
      NCache[
       Rational[9052, 14307], 0.6326972810512337]], AbsoluteThickness[0.25], 
     LineBox[{9052, 9053}]}, 
    {Hue[
      NCache[
       Rational[9053, 14307], 0.6327671769064095]], AbsoluteThickness[0.25], 
     LineBox[{9053, 9054}]}, 
    {Hue[
      NCache[
       Rational[3018, 4769], 0.6328370727615852]], AbsoluteThickness[0.25], 
     LineBox[{9054, 9055}]}, 
    {Hue[
      NCache[
       Rational[9055, 14307], 0.632906968616761]], AbsoluteThickness[0.25], 
     LineBox[{9055, 9056}]}, 
    {Hue[
      NCache[
       Rational[9056, 14307], 0.6329768644719368]], AbsoluteThickness[0.25], 
     LineBox[{9056, 9057}]}, 
    {Hue[
      NCache[
       Rational[3019, 4769], 0.6330467603271126]], AbsoluteThickness[0.25], 
     LineBox[{9057, 9058}]}, 
    {Hue[
      NCache[
       Rational[9058, 14307], 0.6331166561822884]], AbsoluteThickness[0.25], 
     LineBox[{9058, 9059}]}, 
    {Hue[
      NCache[
       Rational[9059, 14307], 0.6331865520374642]], AbsoluteThickness[0.25], 
     LineBox[{9059, 9060}]}, 
    {Hue[
      NCache[
       Rational[3020, 4769], 0.63325644789264]], AbsoluteThickness[0.25], 
     LineBox[{9060, 9061}]}, 
    {Hue[
      NCache[
       Rational[9061, 14307], 0.6333263437478157]], AbsoluteThickness[0.25], 
     LineBox[{9061, 9062}]}, 
    {Hue[
      NCache[
       Rational[9062, 14307], 0.6333962396029915]], AbsoluteThickness[0.25], 
     LineBox[{9062, 9063}]}, 
    {Hue[
      NCache[
       Rational[159, 251], 0.6334661354581673]], AbsoluteThickness[0.25], 
     LineBox[{9063, 9064}]}, 
    {Hue[
      NCache[
       Rational[9064, 14307], 0.6335360313133431]], AbsoluteThickness[0.25], 
     LineBox[{9064, 9065}]}, 
    {Hue[
      NCache[
       Rational[9065, 14307], 0.6336059271685189]], AbsoluteThickness[0.25], 
     LineBox[{9065, 9066}]}, 
    {Hue[
      NCache[
       Rational[3022, 4769], 0.6336758230236947]], AbsoluteThickness[0.25], 
     LineBox[{9066, 9067}]}, 
    {Hue[
      NCache[
       Rational[9067, 14307], 0.6337457188788704]], AbsoluteThickness[0.25], 
     LineBox[{9067, 9068}]}, 
    {Hue[
      NCache[
       Rational[9068, 14307], 0.6338156147340462]], AbsoluteThickness[0.25], 
     LineBox[{9068, 9069}]}, 
    {Hue[
      NCache[
       Rational[3023, 4769], 0.633885510589222]], AbsoluteThickness[0.25], 
     LineBox[{9069, 9070}]}, 
    {Hue[
      NCache[
       Rational[9070, 14307], 0.6339554064443979]], AbsoluteThickness[0.25], 
     LineBox[{9070, 9071}]}, 
    {Hue[
      NCache[
       Rational[9071, 14307], 0.6340253022995737]], AbsoluteThickness[0.25], 
     LineBox[{9071, 9072}]}, 
    {Hue[
      NCache[
       Rational[3024, 4769], 0.6340951981547495]], AbsoluteThickness[0.25], 
     LineBox[{9072, 9073}]}, 
    {Hue[
      NCache[
       Rational[9073, 14307], 0.6341650940099252]], AbsoluteThickness[0.25], 
     LineBox[{9073, 9074}]}, 
    {Hue[
      NCache[
       Rational[9074, 14307], 0.634234989865101]], AbsoluteThickness[0.25], 
     LineBox[{9074, 9075}]}, 
    {Hue[
      NCache[
       Rational[3025, 4769], 0.6343048857202768]], AbsoluteThickness[0.25], 
     LineBox[{9075, 9076}]}, 
    {Hue[
      NCache[
       Rational[9076, 14307], 0.6343747815754526]], AbsoluteThickness[0.25], 
     LineBox[{9076, 9077}]}, 
    {Hue[
      NCache[
       Rational[9077, 14307], 0.6344446774306284]], AbsoluteThickness[0.25], 
     LineBox[{9077, 9078}]}, 
    {Hue[
      NCache[
       Rational[3026, 4769], 0.6345145732858042]], AbsoluteThickness[0.25], 
     LineBox[{9078, 9079}]}, 
    {Hue[
      NCache[
       Rational[9079, 14307], 0.63458446914098]], AbsoluteThickness[0.25], 
     LineBox[{9079, 9080}]}, 
    {Hue[
      NCache[
       Rational[9080, 14307], 0.6346543649961557]], AbsoluteThickness[0.25], 
     LineBox[{9080, 9081}]}, 
    {Hue[
      NCache[
       Rational[3027, 4769], 0.6347242608513315]], AbsoluteThickness[0.25], 
     LineBox[{9081, 9082}]}, 
    {Hue[
      NCache[
       Rational[478, 753], 0.6347941567065073]], AbsoluteThickness[0.25], 
     LineBox[{9082, 9083}]}, 
    {Hue[
      NCache[
       Rational[9083, 14307], 0.6348640525616831]], AbsoluteThickness[0.25], 
     LineBox[{9083, 9084}]}, 
    {Hue[
      NCache[
       Rational[3028, 4769], 0.6349339484168589]], AbsoluteThickness[0.25], 
     LineBox[{9084, 9085}]}, 
    {Hue[
      NCache[
       Rational[9085, 14307], 0.6350038442720347]], AbsoluteThickness[0.25], 
     LineBox[{9085, 9086}]}, 
    {Hue[
      NCache[
       Rational[9086, 14307], 0.6350737401272104]], AbsoluteThickness[0.25], 
     LineBox[{9086, 9087}]}, 
    {Hue[
      NCache[
       Rational[3029, 4769], 0.6351436359823862]], AbsoluteThickness[0.25], 
     LineBox[{9087, 9088}]}, 
    {Hue[
      NCache[
       Rational[9088, 14307], 0.635213531837562]], AbsoluteThickness[0.25], 
     LineBox[{9088, 9089}]}, 
    {Hue[
      NCache[
       Rational[9089, 14307], 0.6352834276927378]], AbsoluteThickness[0.25], 
     LineBox[{9089, 9090}]}, 
    {Hue[
      NCache[
       Rational[3030, 4769], 0.6353533235479136]], AbsoluteThickness[0.25], 
     LineBox[{9090, 9091}]}, 
    {Hue[
      NCache[
       Rational[9091, 14307], 0.6354232194030894]], AbsoluteThickness[0.25], 
     LineBox[{9091, 9092}]}, 
    {Hue[
      NCache[
       Rational[9092, 14307], 0.6354931152582652]], AbsoluteThickness[0.25], 
     LineBox[{9092, 9093}]}, 
    {Hue[
      NCache[
       Rational[3031, 4769], 0.6355630111134409]], AbsoluteThickness[0.25], 
     LineBox[{9093, 9094}]}, 
    {Hue[
      NCache[
       Rational[9094, 14307], 0.6356329069686167]], AbsoluteThickness[0.25], 
     LineBox[{9094, 9095}]}, 
    {Hue[
      NCache[
       Rational[9095, 14307], 0.6357028028237925]], AbsoluteThickness[0.25], 
     LineBox[{9095, 9096}]}, 
    {Hue[
      NCache[
       Rational[3032, 4769], 0.6357726986789684]], AbsoluteThickness[0.25], 
     LineBox[{9096, 9097}]}, 
    {Hue[
      NCache[
       Rational[9097, 14307], 0.6358425945341442]], AbsoluteThickness[0.25], 
     LineBox[{9097, 9098}]}, 
    {Hue[
      NCache[
       Rational[9098, 14307], 0.63591249038932]], AbsoluteThickness[0.25], 
     LineBox[{9098, 9099}]}, 
    {Hue[
      NCache[
       Rational[3033, 4769], 0.6359823862444957]], AbsoluteThickness[0.25], 
     LineBox[{9099, 9100}]}, 
    {Hue[
      NCache[
       Rational[9100, 14307], 0.6360522820996715]], AbsoluteThickness[0.25], 
     LineBox[{9100, 9101}]}, 
    {Hue[
      NCache[
       Rational[479, 753], 0.6361221779548473]], AbsoluteThickness[0.25], 
     LineBox[{9101, 9102}]}, 
    {Hue[
      NCache[
       Rational[3034, 4769], 0.6361920738100231]], AbsoluteThickness[0.25], 
     LineBox[{9102, 9103}]}, 
    {Hue[
      NCache[
       Rational[9103, 14307], 0.6362619696651989]], AbsoluteThickness[0.25], 
     LineBox[{9103, 9104}]}, 
    {Hue[
      NCache[
       Rational[9104, 14307], 0.6363318655203747]], AbsoluteThickness[0.25], 
     LineBox[{9104, 9105}]}, 
    {Hue[
      NCache[
       Rational[3035, 4769], 0.6364017613755504]], AbsoluteThickness[0.25], 
     LineBox[{9105, 9106}]}, 
    {Hue[
      NCache[
       Rational[9106, 14307], 0.6364716572307262]], AbsoluteThickness[0.25], 
     LineBox[{9106, 9107}]}, 
    {Hue[
      NCache[
       Rational[9107, 14307], 0.636541553085902]], AbsoluteThickness[0.25], 
     LineBox[{9107, 9108}]}, 
    {Hue[
      NCache[
       Rational[3036, 4769], 0.6366114489410778]], AbsoluteThickness[0.25], 
     LineBox[{9108, 9109}]}, 
    {Hue[
      NCache[
       Rational[9109, 14307], 0.6366813447962536]], AbsoluteThickness[0.25], 
     LineBox[{9109, 9110}]}, 
    {Hue[
      NCache[
       Rational[9110, 14307], 0.6367512406514294]], AbsoluteThickness[0.25], 
     LineBox[{9110, 9111}]}, 
    {Hue[
      NCache[
       Rational[3037, 4769], 0.6368211365066052]], AbsoluteThickness[0.25], 
     LineBox[{9111, 9112}]}, 
    {Hue[
      NCache[
       Rational[9112, 14307], 0.6368910323617809]], AbsoluteThickness[0.25], 
     LineBox[{9112, 9113}]}, 
    {Hue[
      NCache[
       Rational[9113, 14307], 0.6369609282169567]], AbsoluteThickness[0.25], 
     LineBox[{9113, 9114}]}, 
    {Hue[
      NCache[
       Rational[3038, 4769], 0.6370308240721325]], AbsoluteThickness[0.25], 
     LineBox[{9114, 9115}]}, 
    {Hue[
      NCache[
       Rational[9115, 14307], 0.6371007199273083]], AbsoluteThickness[0.25], 
     LineBox[{9115, 9116}]}, 
    {Hue[
      NCache[
       Rational[9116, 14307], 0.6371706157824841]], AbsoluteThickness[0.25], 
     LineBox[{9116, 9117}]}, 
    {Hue[
      NCache[
       Rational[3039, 4769], 0.6372405116376599]], AbsoluteThickness[0.25], 
     LineBox[{9117, 9118}]}, 
    {Hue[
      NCache[
       Rational[9118, 14307], 0.6373104074928356]], AbsoluteThickness[0.25], 
     LineBox[{9118, 9119}]}, 
    {Hue[
      NCache[
       Rational[9119, 14307], 0.6373803033480114]], AbsoluteThickness[0.25], 
     LineBox[{9119, 9120}]}, 
    {Hue[
      NCache[
       Rational[160, 251], 0.6374501992031872]], AbsoluteThickness[0.25], 
     LineBox[{9120, 9121}]}, 
    {Hue[
      NCache[
       Rational[9121, 14307], 0.637520095058363]], AbsoluteThickness[0.25], 
     LineBox[{9121, 9122}]}, 
    {Hue[
      NCache[
       Rational[9122, 14307], 0.6375899909135389]], AbsoluteThickness[0.25], 
     LineBox[{9122, 9123}]}, 
    {Hue[
      NCache[
       Rational[3041, 4769], 0.6376598867687147]], AbsoluteThickness[0.25], 
     LineBox[{9123, 9124}]}, 
    {Hue[
      NCache[
       Rational[9124, 14307], 0.6377297826238904]], AbsoluteThickness[0.25], 
     LineBox[{9124, 9125}]}, 
    {Hue[
      NCache[
       Rational[9125, 14307], 0.6377996784790662]], AbsoluteThickness[0.25], 
     LineBox[{9125, 9126}]}, 
    {Hue[
      NCache[
       Rational[3042, 4769], 0.637869574334242]], AbsoluteThickness[0.25], 
     LineBox[{9126, 9127}]}, 
    {Hue[
      NCache[
       Rational[9127, 14307], 0.6379394701894178]], AbsoluteThickness[0.25], 
     LineBox[{9127, 9128}]}, 
    {Hue[
      NCache[
       Rational[9128, 14307], 0.6380093660445936]], AbsoluteThickness[0.25], 
     LineBox[{9128, 9129}]}, 
    {Hue[
      NCache[
       Rational[3043, 4769], 0.6380792618997694]], AbsoluteThickness[0.25], 
     LineBox[{9129, 9130}]}, 
    {Hue[
      NCache[
       Rational[9130, 14307], 0.6381491577549452]], AbsoluteThickness[0.25], 
     LineBox[{9130, 9131}]}, 
    {Hue[
      NCache[
       Rational[9131, 14307], 0.6382190536101209]], AbsoluteThickness[0.25], 
     LineBox[{9131, 9132}]}, 
    {Hue[
      NCache[
       Rational[3044, 4769], 0.6382889494652967]], AbsoluteThickness[0.25], 
     LineBox[{9132, 9133}]}, 
    {Hue[
      NCache[
       Rational[9133, 14307], 0.6383588453204725]], AbsoluteThickness[0.25], 
     LineBox[{9133, 9134}]}, 
    {Hue[
      NCache[
       Rational[9134, 14307], 0.6384287411756483]], AbsoluteThickness[0.25], 
     LineBox[{9134, 9135}]}, 
    {Hue[
      NCache[
       Rational[3045, 4769], 0.6384986370308241]], AbsoluteThickness[0.25], 
     LineBox[{9135, 9136}]}, 
    {Hue[
      NCache[
       Rational[9136, 14307], 0.6385685328859999]], AbsoluteThickness[0.25], 
     LineBox[{9136, 9137}]}, 
    {Hue[
      NCache[
       Rational[9137, 14307], 0.6386384287411756]], AbsoluteThickness[0.25], 
     LineBox[{9137, 9138}]}, 
    {Hue[
      NCache[
       Rational[3046, 4769], 0.6387083245963514]], AbsoluteThickness[0.25], 
     LineBox[{9138, 9139}]}, 
    {Hue[
      NCache[
       Rational[481, 753], 0.6387782204515272]], AbsoluteThickness[0.25], 
     LineBox[{9139, 9140}]}, 
    {Hue[
      NCache[
       Rational[9140, 14307], 0.638848116306703]], AbsoluteThickness[0.25], 
     LineBox[{9140, 9141}]}, 
    {Hue[
      NCache[
       Rational[3047, 4769], 0.6389180121618788]], AbsoluteThickness[0.25], 
     LineBox[{9141, 9142}]}, 
    {Hue[
      NCache[
       Rational[9142, 14307], 0.6389879080170546]], AbsoluteThickness[0.25], 
     LineBox[{9142, 9143}]}, 
    {Hue[
      NCache[
       Rational[9143, 14307], 0.6390578038722303]], AbsoluteThickness[0.25], 
     LineBox[{9143, 9144}]}, 
    {Hue[
      NCache[
       Rational[3048, 4769], 0.6391276997274061]], AbsoluteThickness[0.25], 
     LineBox[{9144, 9145}]}, 
    {Hue[
      NCache[
       Rational[9145, 14307], 0.6391975955825819]], AbsoluteThickness[0.25], 
     LineBox[{9145, 9146}]}, 
    {Hue[
      NCache[
       Rational[9146, 14307], 0.6392674914377577]], AbsoluteThickness[0.25], 
     LineBox[{9146, 9147}]}, 
    {Hue[
      NCache[
       Rational[3049, 4769], 0.6393373872929335]], AbsoluteThickness[0.25], 
     LineBox[{9147, 9148}]}, 
    {Hue[
      NCache[
       Rational[9148, 14307], 0.6394072831481094]], AbsoluteThickness[0.25], 
     LineBox[{9148, 9149}]}, 
    {Hue[
      NCache[
       Rational[9149, 14307], 0.6394771790032852]], AbsoluteThickness[0.25], 
     LineBox[{9149, 9150}]}, 
    {Hue[
      NCache[
       Rational[3050, 4769], 0.6395470748584609]], AbsoluteThickness[0.25], 
     LineBox[{9150, 9151}]}, 
    {Hue[
      NCache[
       Rational[9151, 14307], 0.6396169707136367]], AbsoluteThickness[0.25], 
     LineBox[{9151, 9152}]}, 
    {Hue[
      NCache[
       Rational[9152, 14307], 0.6396868665688125]], AbsoluteThickness[0.25], 
     LineBox[{9152, 9153}]}, 
    {Hue[
      NCache[
       Rational[3051, 4769], 0.6397567624239883]], AbsoluteThickness[0.25], 
     LineBox[{9153, 9154}]}, 
    {Hue[
      NCache[
       Rational[9154, 14307], 0.6398266582791641]], AbsoluteThickness[0.25], 
     LineBox[{9154, 9155}]}, 
    {Hue[
      NCache[
       Rational[9155, 14307], 0.6398965541343399]], AbsoluteThickness[0.25], 
     LineBox[{9155, 9156}]}, 
    {Hue[
      NCache[
       Rational[3052, 4769], 0.6399664499895156]], AbsoluteThickness[0.25], 
     LineBox[{9156, 9157}]}, 
    {Hue[
      NCache[
       Rational[9157, 14307], 0.6400363458446914]], AbsoluteThickness[0.25], 
     LineBox[{9157, 9158}]}, 
    {Hue[
      NCache[
       Rational[482, 753], 0.6401062416998672]], AbsoluteThickness[0.25], 
     LineBox[{9158, 9159}]}, 
    {Hue[
      NCache[
       Rational[3053, 4769], 0.640176137555043]], AbsoluteThickness[0.25], 
     LineBox[{9159, 9160}]}, 
    {Hue[
      NCache[
       Rational[9160, 14307], 0.6402460334102188]], AbsoluteThickness[0.25], 
     LineBox[{9160, 9161}]}, 
    {Hue[
      NCache[
       Rational[9161, 14307], 0.6403159292653946]], AbsoluteThickness[0.25], 
     LineBox[{9161, 9162}]}, 
    {Hue[
      NCache[
       Rational[3054, 4769], 0.6403858251205703]], AbsoluteThickness[0.25], 
     LineBox[{9162, 9163}]}, 
    {Hue[
      NCache[
       Rational[9163, 14307], 0.6404557209757461]], AbsoluteThickness[0.25], 
     LineBox[{9163, 9164}]}, 
    {Hue[
      NCache[
       Rational[9164, 14307], 0.6405256168309219]], AbsoluteThickness[0.25], 
     LineBox[{9164, 9165}]}, 
    {Hue[
      NCache[
       Rational[3055, 4769], 0.6405955126860977]], AbsoluteThickness[0.25], 
     LineBox[{9165, 9166}]}, 
    {Hue[
      NCache[
       Rational[9166, 14307], 0.6406654085412735]], AbsoluteThickness[0.25], 
     LineBox[{9166, 9167}]}, 
    {Hue[
      NCache[
       Rational[9167, 14307], 0.6407353043964493]], AbsoluteThickness[0.25], 
     LineBox[{9167, 9168}]}, 
    {Hue[
      NCache[
       Rational[3056, 4769], 0.6408052002516251]], AbsoluteThickness[0.25], 
     LineBox[{9168, 9169}]}, 
    {Hue[
      NCache[
       Rational[9169, 14307], 0.6408750961068008]], AbsoluteThickness[0.25], 
     LineBox[{9169, 9170}]}, 
    {Hue[
      NCache[
       Rational[9170, 14307], 0.6409449919619766]], AbsoluteThickness[0.25], 
     LineBox[{9170, 9171}]}, 
    {Hue[
      NCache[
       Rational[3057, 4769], 0.6410148878171524]], AbsoluteThickness[0.25], 
     LineBox[{9171, 9172}]}, 
    {Hue[
      NCache[
       Rational[9172, 14307], 0.6410847836723282]], AbsoluteThickness[0.25], 
     LineBox[{9172, 9173}]}, 
    {Hue[
      NCache[
       Rational[9173, 14307], 0.641154679527504]], AbsoluteThickness[0.25], 
     LineBox[{9173, 9174}]}, 
    {Hue[
      NCache[
       Rational[3058, 4769], 0.6412245753826799]], AbsoluteThickness[0.25], 
     LineBox[{9174, 9175}]}, 
    {Hue[
      NCache[
       Rational[9175, 14307], 0.6412944712378555]], AbsoluteThickness[0.25], 
     LineBox[{9175, 9176}]}, 
    {Hue[
      NCache[
       Rational[9176, 14307], 0.6413643670930314]], AbsoluteThickness[0.25], 
     LineBox[{9176, 9177}]}, 
    {Hue[
      NCache[
       Rational[161, 251], 0.6414342629482072]], AbsoluteThickness[0.25], 
     LineBox[{9177, 9178}]}, 
    {Hue[
      NCache[
       Rational[9178, 14307], 0.641504158803383]], AbsoluteThickness[0.25], 
     LineBox[{9178, 9179}]}, 
    {Hue[
      NCache[
       Rational[9179, 14307], 0.6415740546585588]], AbsoluteThickness[0.25], 
     LineBox[{9179, 9180}]}, 
    {Hue[
      NCache[
       Rational[3060, 4769], 0.6416439505137346]], AbsoluteThickness[0.25], 
     LineBox[{9180, 9181}]}, 
    {Hue[
      NCache[
       Rational[9181, 14307], 0.6417138463689104]], AbsoluteThickness[0.25], 
     LineBox[{9181, 9182}]}, 
    {Hue[
      NCache[
       Rational[9182, 14307], 0.6417837422240861]], AbsoluteThickness[0.25], 
     LineBox[{9182, 9183}]}, 
    {Hue[
      NCache[
       Rational[3061, 4769], 0.6418536380792619]], AbsoluteThickness[0.25], 
     LineBox[{9183, 9184}]}, 
    {Hue[
      NCache[
       Rational[9184, 14307], 0.6419235339344377]], AbsoluteThickness[0.25], 
     LineBox[{9184, 9185}]}, 
    {Hue[
      NCache[
       Rational[9185, 14307], 0.6419934297896135]], AbsoluteThickness[0.25], 
     LineBox[{9185, 9186}]}, 
    {Hue[
      NCache[
       Rational[3062, 4769], 0.6420633256447893]], AbsoluteThickness[0.25], 
     LineBox[{9186, 9187}]}, 
    {Hue[
      NCache[
       Rational[9187, 14307], 0.6421332214999651]], AbsoluteThickness[0.25], 
     LineBox[{9187, 9188}]}, 
    {Hue[
      NCache[
       Rational[9188, 14307], 0.6422031173551408]], AbsoluteThickness[0.25], 
     LineBox[{9188, 9189}]}, 
    {Hue[
      NCache[
       Rational[3063, 4769], 0.6422730132103166]], AbsoluteThickness[0.25], 
     LineBox[{9189, 9190}]}, 
    {Hue[
      NCache[
       Rational[9190, 14307], 0.6423429090654924]], AbsoluteThickness[0.25], 
     LineBox[{9190, 9191}]}, 
    {Hue[
      NCache[
       Rational[9191, 14307], 0.6424128049206682]], AbsoluteThickness[0.25], 
     LineBox[{9191, 9192}]}, 
    {Hue[
      NCache[
       Rational[3064, 4769], 0.642482700775844]], AbsoluteThickness[0.25], 
     LineBox[{9192, 9193}]}, 
    {Hue[
      NCache[
       Rational[9193, 14307], 0.6425525966310198]], AbsoluteThickness[0.25], 
     LineBox[{9193, 9194}]}, 
    {Hue[
      NCache[
       Rational[9194, 14307], 0.6426224924861955]], AbsoluteThickness[0.25], 
     LineBox[{9194, 9195}]}, 
    {Hue[
      NCache[
       Rational[3065, 4769], 0.6426923883413713]], AbsoluteThickness[0.25], 
     LineBox[{9195, 9196}]}, 
    {Hue[
      NCache[
       Rational[484, 753], 0.6427622841965471]], AbsoluteThickness[0.25], 
     LineBox[{9196, 9197}]}, 
    {Hue[
      NCache[
       Rational[9197, 14307], 0.6428321800517229]], AbsoluteThickness[0.25], 
     LineBox[{9197, 9198}]}, 
    {Hue[
      NCache[
       Rational[3066, 4769], 0.6429020759068987]], AbsoluteThickness[0.25], 
     LineBox[{9198, 9199}]}, 
    {Hue[
      NCache[
       Rational[9199, 14307], 0.6429719717620745]], AbsoluteThickness[0.25], 
     LineBox[{9199, 9200}]}, 
    {Hue[
      NCache[
       Rational[9200, 14307], 0.6430418676172504]], AbsoluteThickness[0.25], 
     LineBox[{9200, 9201}]}, 
    {Hue[
      NCache[
       Rational[3067, 4769], 0.643111763472426]], AbsoluteThickness[0.25], 
     LineBox[{9201, 9202}]}, 
    {Hue[
      NCache[
       Rational[9202, 14307], 0.6431816593276019]], AbsoluteThickness[0.25], 
     LineBox[{9202, 9203}]}, 
    {Hue[
      NCache[
       Rational[9203, 14307], 0.6432515551827777]], AbsoluteThickness[0.25], 
     LineBox[{9203, 9204}]}, 
    {Hue[
      NCache[
       Rational[3068, 4769], 0.6433214510379535]], AbsoluteThickness[0.25], 
     LineBox[{9204, 9205}]}, 
    {Hue[
      NCache[
       Rational[9205, 14307], 0.6433913468931293]], AbsoluteThickness[0.25], 
     LineBox[{9205, 9206}]}, 
    {Hue[
      NCache[
       Rational[9206, 14307], 0.6434612427483051]], AbsoluteThickness[0.25], 
     LineBox[{9206, 9207}]}, 
    {Hue[
      NCache[
       Rational[3069, 4769], 0.6435311386034808]], AbsoluteThickness[0.25], 
     LineBox[{9207, 9208}]}, 
    {Hue[
      NCache[
       Rational[9208, 14307], 0.6436010344586566]], AbsoluteThickness[0.25], 
     LineBox[{9208, 9209}]}, 
    {Hue[
      NCache[
       Rational[9209, 14307], 0.6436709303138324]], AbsoluteThickness[0.25], 
     LineBox[{9209, 9210}]}, 
    {Hue[
      NCache[
       Rational[3070, 4769], 0.6437408261690082]], AbsoluteThickness[0.25], 
     LineBox[{9210, 9211}]}, 
    {Hue[
      NCache[
       Rational[9211, 14307], 0.643810722024184]], AbsoluteThickness[0.25], 
     LineBox[{9211, 9212}]}, 
    {Hue[
      NCache[
       Rational[9212, 14307], 0.6438806178793598]], AbsoluteThickness[0.25], 
     LineBox[{9212, 9213}]}, 
    {Hue[
      NCache[
       Rational[3071, 4769], 0.6439505137345355]], AbsoluteThickness[0.25], 
     LineBox[{9213, 9214}]}, 
    {Hue[
      NCache[
       Rational[9214, 14307], 0.6440204095897113]], AbsoluteThickness[0.25], 
     LineBox[{9214, 9215}]}, 
    {Hue[
      NCache[
       Rational[485, 753], 0.6440903054448871]], AbsoluteThickness[0.25], 
     LineBox[{9215, 9216}]}, 
    {Hue[
      NCache[
       Rational[3072, 4769], 0.6441602013000629]], AbsoluteThickness[0.25], 
     LineBox[{9216, 9217}]}, 
    {Hue[
      NCache[
       Rational[9217, 14307], 0.6442300971552387]], AbsoluteThickness[0.25], 
     LineBox[{9217, 9218}]}, 
    {Hue[
      NCache[
       Rational[9218, 14307], 0.6442999930104145]], AbsoluteThickness[0.25], 
     LineBox[{9218, 9219}]}, 
    {Hue[
      NCache[
       Rational[3073, 4769], 0.6443698888655903]], AbsoluteThickness[0.25], 
     LineBox[{9219, 9220}]}, 
    {Hue[
      NCache[
       Rational[9220, 14307], 0.644439784720766]], AbsoluteThickness[0.25], 
     LineBox[{9220, 9221}]}, 
    {Hue[
      NCache[
       Rational[9221, 14307], 0.6445096805759418]], AbsoluteThickness[0.25], 
     LineBox[{9221, 9222}]}, 
    {Hue[
      NCache[
       Rational[3074, 4769], 0.6445795764311176]], AbsoluteThickness[0.25], 
     LineBox[{9222, 9223}]}, 
    {Hue[
      NCache[
       Rational[9223, 14307], 0.6446494722862934]], AbsoluteThickness[0.25], 
     LineBox[{9223, 9224}]}, 
    {Hue[
      NCache[
       Rational[9224, 14307], 0.6447193681414692]], AbsoluteThickness[0.25], 
     LineBox[{9224, 9225}]}, 
    {Hue[
      NCache[
       Rational[3075, 4769], 0.644789263996645]], AbsoluteThickness[0.25], 
     LineBox[{9225, 9226}]}, 
    {Hue[
      NCache[
       Rational[9226, 14307], 0.6448591598518207]], AbsoluteThickness[0.25], 
     LineBox[{9226, 9227}]}, 
    {Hue[
      NCache[
       Rational[9227, 14307], 0.6449290557069965]], AbsoluteThickness[0.25], 
     LineBox[{9227, 9228}]}, 
    {Hue[
      NCache[
       Rational[3076, 4769], 0.6449989515621724]], AbsoluteThickness[0.25], 
     LineBox[{9228, 9229}]}, 
    {Hue[
      NCache[
       Rational[9229, 14307], 0.6450688474173482]], AbsoluteThickness[0.25], 
     LineBox[{9229, 9230}]}, 
    {Hue[
      NCache[
       Rational[9230, 14307], 0.645138743272524]], AbsoluteThickness[0.25], 
     LineBox[{9230, 9231}]}, 
    {Hue[
      NCache[
       Rational[3077, 4769], 0.6452086391276998]], AbsoluteThickness[0.25], 
     LineBox[{9231, 9232}]}, 
    {Hue[
      NCache[
       Rational[9232, 14307], 0.6452785349828755]], AbsoluteThickness[0.25], 
     LineBox[{9232, 9233}]}, 
    {Hue[
      NCache[
       Rational[9233, 14307], 0.6453484308380513]], AbsoluteThickness[0.25], 
     LineBox[{9233, 9234}]}, 
    {Hue[
      NCache[
       Rational[162, 251], 0.6454183266932271]], AbsoluteThickness[0.25], 
     LineBox[{9234, 9235}]}, 
    {Hue[
      NCache[
       Rational[9235, 14307], 0.6454882225484029]], AbsoluteThickness[0.25], 
     LineBox[{9235, 9236}]}, 
    {Hue[
      NCache[
       Rational[9236, 14307], 0.6455581184035787]], AbsoluteThickness[0.25], 
     LineBox[{9236, 9237}]}, 
    {Hue[
      NCache[
       Rational[3079, 4769], 0.6456280142587545]], AbsoluteThickness[0.25], 
     LineBox[{9237, 9238}]}, 
    {Hue[
      NCache[
       Rational[9238, 14307], 0.6456979101139303]], AbsoluteThickness[0.25], 
     LineBox[{9238, 9239}]}, 
    {Hue[
      NCache[
       Rational[9239, 14307], 0.645767805969106]], AbsoluteThickness[0.25], 
     LineBox[{9239, 9240}]}, 
    {Hue[
      NCache[
       Rational[3080, 4769], 0.6458377018242818]], AbsoluteThickness[0.25], 
     LineBox[{9240, 9241}]}, 
    {Hue[
      NCache[
       Rational[9241, 14307], 0.6459075976794576]], AbsoluteThickness[0.25], 
     LineBox[{9241, 9242}]}, 
    {Hue[
      NCache[
       Rational[9242, 14307], 0.6459774935346334]], AbsoluteThickness[0.25], 
     LineBox[{9242, 9243}]}, 
    {Hue[
      NCache[
       Rational[3081, 4769], 0.6460473893898092]], AbsoluteThickness[0.25], 
     LineBox[{9243, 9244}]}, 
    {Hue[
      NCache[
       Rational[9244, 14307], 0.646117285244985]], AbsoluteThickness[0.25], 
     LineBox[{9244, 9245}]}, 
    {Hue[
      NCache[
       Rational[9245, 14307], 0.6461871811001607]], AbsoluteThickness[0.25], 
     LineBox[{9245, 9246}]}, 
    {Hue[
      NCache[
       Rational[3082, 4769], 0.6462570769553365]], AbsoluteThickness[0.25], 
     LineBox[{9246, 9247}]}, 
    {Hue[
      NCache[
       Rational[9247, 14307], 0.6463269728105123]], AbsoluteThickness[0.25], 
     LineBox[{9247, 9248}]}, 
    {Hue[
      NCache[
       Rational[9248, 14307], 0.6463968686656881]], AbsoluteThickness[0.25], 
     LineBox[{9248, 9249}]}, 
    {Hue[
      NCache[
       Rational[3083, 4769], 0.6464667645208639]], AbsoluteThickness[0.25], 
     LineBox[{9249, 9250}]}, 
    {Hue[
      NCache[
       Rational[9250, 14307], 0.6465366603760397]], AbsoluteThickness[0.25], 
     LineBox[{9250, 9251}]}, 
    {Hue[
      NCache[
       Rational[9251, 14307], 0.6466065562312154]], AbsoluteThickness[0.25], 
     LineBox[{9251, 9252}]}, 
    {Hue[
      NCache[
       Rational[3084, 4769], 0.6466764520863912]], AbsoluteThickness[0.25], 
     LineBox[{9252, 9253}]}, 
    {Hue[
      NCache[
       Rational[487, 753], 0.646746347941567]], AbsoluteThickness[0.25], 
     LineBox[{9253, 9254}]}, 
    {Hue[
      NCache[
       Rational[9254, 14307], 0.6468162437967429]], AbsoluteThickness[0.25], 
     LineBox[{9254, 9255}]}, 
    {Hue[
      NCache[
       Rational[3085, 4769], 0.6468861396519187]], AbsoluteThickness[0.25], 
     LineBox[{9255, 9256}]}, 
    {Hue[
      NCache[
       Rational[9256, 14307], 0.6469560355070945]], AbsoluteThickness[0.25], 
     LineBox[{9256, 9257}]}, 
    {Hue[
      NCache[
       Rational[9257, 14307], 0.6470259313622703]], AbsoluteThickness[0.25], 
     LineBox[{9257, 9258}]}, 
    {Hue[
      NCache[
       Rational[3086, 4769], 0.647095827217446]], AbsoluteThickness[0.25], 
     LineBox[{9258, 9259}]}, 
    {Hue[
      NCache[
       Rational[9259, 14307], 0.6471657230726218]], AbsoluteThickness[0.25], 
     LineBox[{9259, 9260}]}, 
    {Hue[
      NCache[
       Rational[9260, 14307], 0.6472356189277976]], AbsoluteThickness[0.25], 
     LineBox[{9260, 9261}]}, 
    {Hue[
      NCache[
       Rational[3087, 4769], 0.6473055147829734]], AbsoluteThickness[0.25], 
     LineBox[{9261, 9262}]}, 
    {Hue[
      NCache[
       Rational[9262, 14307], 0.6473754106381492]], AbsoluteThickness[0.25], 
     LineBox[{9262, 9263}]}, 
    {Hue[
      NCache[
       Rational[9263, 14307], 0.647445306493325]], AbsoluteThickness[0.25], 
     LineBox[{9263, 9264}]}, 
    {Hue[
      NCache[
       Rational[3088, 4769], 0.6475152023485007]], AbsoluteThickness[0.25], 
     LineBox[{9264, 9265}]}, 
    {Hue[
      NCache[
       Rational[9265, 14307], 0.6475850982036765]], AbsoluteThickness[0.25], 
     LineBox[{9265, 9266}]}, 
    {Hue[
      NCache[
       Rational[9266, 14307], 0.6476549940588523]], AbsoluteThickness[0.25], 
     LineBox[{9266, 9267}]}, 
    {Hue[
      NCache[
       Rational[3089, 4769], 0.6477248899140281]], AbsoluteThickness[0.25], 
     LineBox[{9267, 9268}]}, 
    {Hue[
      NCache[
       Rational[9268, 14307], 0.6477947857692039]], AbsoluteThickness[0.25], 
     LineBox[{9268, 9269}]}, 
    {Hue[
      NCache[
       Rational[9269, 14307], 0.6478646816243797]], AbsoluteThickness[0.25], 
     LineBox[{9269, 9270}]}, 
    {Hue[
      NCache[
       Rational[3090, 4769], 0.6479345774795554]], AbsoluteThickness[0.25], 
     LineBox[{9270, 9271}]}, 
    {Hue[
      NCache[
       Rational[9271, 14307], 0.6480044733347312]], AbsoluteThickness[0.25], 
     LineBox[{9271, 9272}]}, 
    {Hue[
      NCache[
       Rational[488, 753], 0.648074369189907]], AbsoluteThickness[0.25], 
     LineBox[{9272, 9273}]}, 
    {Hue[
      NCache[
       Rational[3091, 4769], 0.6481442650450828]], AbsoluteThickness[0.25], 
     LineBox[{9273, 9274}]}, 
    {Hue[
      NCache[
       Rational[9274, 14307], 0.6482141609002586]], AbsoluteThickness[0.25], 
     LineBox[{9274, 9275}]}, 
    {Hue[
      NCache[
       Rational[9275, 14307], 0.6482840567554344]], AbsoluteThickness[0.25], 
     LineBox[{9275, 9276}]}, 
    {Hue[
      NCache[
       Rational[3092, 4769], 0.6483539526106102]], AbsoluteThickness[0.25], 
     LineBox[{9276, 9277}]}, 
    {Hue[
      NCache[
       Rational[9277, 14307], 0.6484238484657859]], AbsoluteThickness[0.25], 
     LineBox[{9277, 9278}]}, 
    {Hue[
      NCache[
       Rational[9278, 14307], 0.6484937443209617]], AbsoluteThickness[0.25], 
     LineBox[{9278, 9279}]}, 
    {Hue[
      NCache[
       Rational[3093, 4769], 0.6485636401761375]], AbsoluteThickness[0.25], 
     LineBox[{9279, 9280}]}, 
    {Hue[
      NCache[
       Rational[9280, 14307], 0.6486335360313134]], AbsoluteThickness[0.25], 
     LineBox[{9280, 9281}]}, 
    {Hue[
      NCache[
       Rational[9281, 14307], 0.6487034318864892]], AbsoluteThickness[0.25], 
     LineBox[{9281, 9282}]}, 
    {Hue[
      NCache[
       Rational[3094, 4769], 0.648773327741665]], AbsoluteThickness[0.25], 
     LineBox[{9282, 9283}]}, 
    {Hue[
      NCache[
       Rational[9283, 14307], 0.6488432235968407]], AbsoluteThickness[0.25], 
     LineBox[{9283, 9284}]}, 
    {Hue[
      NCache[
       Rational[9284, 14307], 0.6489131194520165]], AbsoluteThickness[0.25], 
     LineBox[{9284, 9285}]}, 
    {Hue[
      NCache[
       Rational[3095, 4769], 0.6489830153071923]], AbsoluteThickness[0.25], 
     LineBox[{9285, 9286}]}, 
    {Hue[
      NCache[
       Rational[9286, 14307], 0.6490529111623681]], AbsoluteThickness[0.25], 
     LineBox[{9286, 9287}]}, 
    {Hue[
      NCache[
       Rational[37, 57], 0.6491228070175439]], AbsoluteThickness[0.25], 
     LineBox[{9287, 9288}]}, 
    {Hue[
      NCache[
       Rational[3096, 4769], 0.6491927028727197]], AbsoluteThickness[0.25], 
     LineBox[{9288, 9289}]}, 
    {Hue[
      NCache[
       Rational[9289, 14307], 0.6492625987278955]], AbsoluteThickness[0.25], 
     LineBox[{9289, 9290}]}, 
    {Hue[
      NCache[
       Rational[9290, 14307], 0.6493324945830712]], AbsoluteThickness[0.25], 
     LineBox[{9290, 9291}]}, 
    {Hue[
      NCache[
       Rational[163, 251], 0.649402390438247]], AbsoluteThickness[0.25], 
     LineBox[{9291, 9292}]}, 
    {Hue[
      NCache[
       Rational[9292, 14307], 0.6494722862934228]], AbsoluteThickness[0.25], 
     LineBox[{9292, 9293}]}, 
    {Hue[
      NCache[
       Rational[9293, 14307], 0.6495421821485986]], AbsoluteThickness[0.25], 
     LineBox[{9293, 9294}]}, 
    {Hue[
      NCache[
       Rational[3098, 4769], 0.6496120780037744]], AbsoluteThickness[0.25], 
     LineBox[{9294, 9295}]}, 
    {Hue[
      NCache[
       Rational[9295, 14307], 0.6496819738589502]], AbsoluteThickness[0.25], 
     LineBox[{9295, 9296}]}, 
    {Hue[
      NCache[
       Rational[9296, 14307], 0.6497518697141259]], AbsoluteThickness[0.25], 
     LineBox[{9296, 9297}]}, 
    {Hue[
      NCache[
       Rational[3099, 4769], 0.6498217655693017]], AbsoluteThickness[0.25], 
     LineBox[{9297, 9298}]}, 
    {Hue[
      NCache[
       Rational[9298, 14307], 0.6498916614244775]], AbsoluteThickness[0.25], 
     LineBox[{9298, 9299}]}, 
    {Hue[
      NCache[
       Rational[9299, 14307], 0.6499615572796533]], AbsoluteThickness[0.25], 
     LineBox[{9299, 9300}]}, 
    {Hue[
      NCache[
       Rational[3100, 4769], 0.6500314531348291]], AbsoluteThickness[0.25], 
     LineBox[{9300, 9301}]}, 
    {Hue[
      NCache[
       Rational[9301, 14307], 0.6501013489900049]], AbsoluteThickness[0.25], 
     LineBox[{9301, 9302}]}, 
    {Hue[
      NCache[
       Rational[9302, 14307], 0.6501712448451806]], AbsoluteThickness[0.25], 
     LineBox[{9302, 9303}]}, 
    {Hue[
      NCache[
       Rational[3101, 4769], 0.6502411407003564]], AbsoluteThickness[0.25], 
     LineBox[{9303, 9304}]}, 
    {Hue[
      NCache[
       Rational[9304, 14307], 0.6503110365555322]], AbsoluteThickness[0.25], 
     LineBox[{9304, 9305}]}, 
    {Hue[
      NCache[
       Rational[9305, 14307], 0.650380932410708]], AbsoluteThickness[0.25], 
     LineBox[{9305, 9306}]}, 
    {Hue[
      NCache[
       Rational[3102, 4769], 0.6504508282658839]], AbsoluteThickness[0.25], 
     LineBox[{9306, 9307}]}, 
    {Hue[
      NCache[
       Rational[9307, 14307], 0.6505207241210597]], AbsoluteThickness[0.25], 
     LineBox[{9307, 9308}]}, 
    {Hue[
      NCache[
       Rational[9308, 14307], 0.6505906199762355]], AbsoluteThickness[0.25], 
     LineBox[{9308, 9309}]}, 
    {Hue[
      NCache[
       Rational[3103, 4769], 0.6506605158314112]], AbsoluteThickness[0.25], 
     LineBox[{9309, 9310}]}, 
    {Hue[
      NCache[
       Rational[490, 753], 0.650730411686587]], AbsoluteThickness[0.25], 
     LineBox[{9310, 9311}]}, 
    {Hue[
      NCache[
       Rational[9311, 14307], 0.6508003075417628]], AbsoluteThickness[0.25], 
     LineBox[{9311, 9312}]}, 
    {Hue[
      NCache[
       Rational[3104, 4769], 0.6508702033969386]], AbsoluteThickness[0.25], 
     LineBox[{9312, 9313}]}, 
    {Hue[
      NCache[
       Rational[9313, 14307], 0.6509400992521144]], AbsoluteThickness[0.25], 
     LineBox[{9313, 9314}]}, 
    {Hue[
      NCache[
       Rational[9314, 14307], 0.6510099951072902]], AbsoluteThickness[0.25], 
     LineBox[{9314, 9315}]}, 
    {Hue[
      NCache[
       Rational[3105, 4769], 0.6510798909624659]], AbsoluteThickness[0.25], 
     LineBox[{9315, 9316}]}, 
    {Hue[
      NCache[
       Rational[9316, 14307], 0.6511497868176417]], AbsoluteThickness[0.25], 
     LineBox[{9316, 9317}]}, 
    {Hue[
      NCache[
       Rational[9317, 14307], 0.6512196826728175]], AbsoluteThickness[0.25], 
     LineBox[{9317, 9318}]}, 
    {Hue[
      NCache[
       Rational[3106, 4769], 0.6512895785279933]], AbsoluteThickness[0.25], 
     LineBox[{9318, 9319}]}, 
    {Hue[
      NCache[
       Rational[9319, 14307], 0.6513594743831691]], AbsoluteThickness[0.25], 
     LineBox[{9319, 9320}]}, 
    {Hue[
      NCache[
       Rational[9320, 14307], 0.6514293702383449]], AbsoluteThickness[0.25], 
     LineBox[{9320, 9321}]}, 
    {Hue[
      NCache[
       Rational[3107, 4769], 0.6514992660935206]], AbsoluteThickness[0.25], 
     LineBox[{9321, 9322}]}, 
    {Hue[
      NCache[
       Rational[9322, 14307], 0.6515691619486964]], AbsoluteThickness[0.25], 
     LineBox[{9322, 9323}]}, 
    {Hue[
      NCache[
       Rational[9323, 14307], 0.6516390578038722]], AbsoluteThickness[0.25], 
     LineBox[{9323, 9324}]}, 
    {Hue[
      NCache[
       Rational[3108, 4769], 0.651708953659048]], AbsoluteThickness[0.25], 
     LineBox[{9324, 9325}]}, 
    {Hue[
      NCache[
       Rational[9325, 14307], 0.6517788495142238]], AbsoluteThickness[0.25], 
     LineBox[{9325, 9326}]}, 
    {Hue[
      NCache[
       Rational[9326, 14307], 0.6518487453693996]], AbsoluteThickness[0.25], 
     LineBox[{9326, 9327}]}, 
    {Hue[
      NCache[
       Rational[3109, 4769], 0.6519186412245754]], AbsoluteThickness[0.25], 
     LineBox[{9327, 9328}]}, 
    {Hue[
      NCache[
       Rational[9328, 14307], 0.6519885370797511]], AbsoluteThickness[0.25], 
     LineBox[{9328, 9329}]}, 
    {Hue[
      NCache[
       Rational[491, 753], 0.6520584329349269]], AbsoluteThickness[0.25], 
     LineBox[{9329, 9330}]}, 
    {Hue[
      NCache[
       Rational[3110, 4769], 0.6521283287901027]], AbsoluteThickness[0.25], 
     LineBox[{9330, 9331}]}, 
    {Hue[
      NCache[
       Rational[9331, 14307], 0.6521982246452785]], AbsoluteThickness[0.25], 
     LineBox[{9331, 9332}]}, 
    {Hue[
      NCache[
       Rational[9332, 14307], 0.6522681205004544]], AbsoluteThickness[0.25], 
     LineBox[{9332, 9333}]}, 
    {Hue[
      NCache[
       Rational[3111, 4769], 0.6523380163556302]], AbsoluteThickness[0.25], 
     LineBox[{9333, 9334}]}, 
    {Hue[
      NCache[
       Rational[9334, 14307], 0.6524079122108059]], AbsoluteThickness[0.25], 
     LineBox[{9334, 9335}]}, 
    {Hue[
      NCache[
       Rational[9335, 14307], 0.6524778080659817]], AbsoluteThickness[0.25], 
     LineBox[{9335, 9336}]}, 
    {Hue[
      NCache[
       Rational[3112, 4769], 0.6525477039211575]], AbsoluteThickness[0.25], 
     LineBox[{9336, 9337}]}, 
    {Hue[
      NCache[
       Rational[9337, 14307], 0.6526175997763333]], AbsoluteThickness[0.25], 
     LineBox[{9337, 9338}]}, 
    {Hue[
      NCache[
       Rational[9338, 14307], 0.6526874956315091]], AbsoluteThickness[0.25], 
     LineBox[{9338, 9339}]}, 
    {Hue[
      NCache[
       Rational[3113, 4769], 0.6527573914866849]], AbsoluteThickness[0.25], 
     LineBox[{9339, 9340}]}, 
    {Hue[
      NCache[
       Rational[9340, 14307], 0.6528272873418606]], AbsoluteThickness[0.25], 
     LineBox[{9340, 9341}]}, 
    {Hue[
      NCache[
       Rational[9341, 14307], 0.6528971831970364]], AbsoluteThickness[0.25], 
     LineBox[{9341, 9342}]}, 
    {Hue[
      NCache[
       Rational[3114, 4769], 0.6529670790522122]], AbsoluteThickness[0.25], 
     LineBox[{9342, 9343}]}, 
    {Hue[
      NCache[
       Rational[9343, 14307], 0.653036974907388]], AbsoluteThickness[0.25], 
     LineBox[{9343, 9344}]}, 
    {Hue[
      NCache[
       Rational[9344, 14307], 0.6531068707625638]], AbsoluteThickness[0.25], 
     LineBox[{9344, 9345}]}, 
    {Hue[
      NCache[
       Rational[3115, 4769], 0.6531767666177396]], AbsoluteThickness[0.25], 
     LineBox[{9345, 9346}]}, 
    {Hue[
      NCache[
       Rational[9346, 14307], 0.6532466624729154]], AbsoluteThickness[0.25], 
     LineBox[{9346, 9347}]}, 
    {Hue[
      NCache[
       Rational[9347, 14307], 0.6533165583280911]], AbsoluteThickness[0.25], 
     LineBox[{9347, 9348}]}, 
    {Hue[
      NCache[
       Rational[164, 251], 0.6533864541832669]], AbsoluteThickness[0.25], 
     LineBox[{9348, 9349}]}, 
    {Hue[
      NCache[
       Rational[9349, 14307], 0.6534563500384427]], AbsoluteThickness[0.25], 
     LineBox[{9349, 9350}]}, 
    {Hue[
      NCache[
       Rational[9350, 14307], 0.6535262458936185]], AbsoluteThickness[0.25], 
     LineBox[{9350, 9351}]}, 
    {Hue[
      NCache[
       Rational[3117, 4769], 0.6535961417487943]], AbsoluteThickness[0.25], 
     LineBox[{9351, 9352}]}, 
    {Hue[
      NCache[
       Rational[9352, 14307], 0.6536660376039701]], AbsoluteThickness[0.25], 
     LineBox[{9352, 9353}]}, 
    {Hue[
      NCache[
       Rational[9353, 14307], 0.6537359334591458]], AbsoluteThickness[0.25], 
     LineBox[{9353, 9354}]}, 
    {Hue[
      NCache[
       Rational[3118, 4769], 0.6538058293143216]], AbsoluteThickness[0.25], 
     LineBox[{9354, 9355}]}, 
    {Hue[
      NCache[
       Rational[9355, 14307], 0.6538757251694974]], AbsoluteThickness[0.25], 
     LineBox[{9355, 9356}]}, 
    {Hue[
      NCache[
       Rational[9356, 14307], 0.6539456210246732]], AbsoluteThickness[0.25], 
     LineBox[{9356, 9357}]}, 
    {Hue[
      NCache[
       Rational[3119, 4769], 0.654015516879849]], AbsoluteThickness[0.25], 
     LineBox[{9357, 9358}]}, 
    {Hue[
      NCache[
       Rational[9358, 14307], 0.6540854127350249]], AbsoluteThickness[0.25], 
     LineBox[{9358, 9359}]}, 
    {Hue[
      NCache[
       Rational[9359, 14307], 0.6541553085902005]], AbsoluteThickness[0.25], 
     LineBox[{9359, 9360}]}, 
    {Hue[
      NCache[
       Rational[3120, 4769], 0.6542252044453764]], AbsoluteThickness[0.25], 
     LineBox[{9360, 9361}]}, 
    {Hue[
      NCache[
       Rational[9361, 14307], 0.6542951003005522]], AbsoluteThickness[0.25], 
     LineBox[{9361, 9362}]}, 
    {Hue[
      NCache[
       Rational[9362, 14307], 0.654364996155728]], AbsoluteThickness[0.25], 
     LineBox[{9362, 9363}]}, 
    {Hue[
      NCache[
       Rational[3121, 4769], 0.6544348920109038]], AbsoluteThickness[0.25], 
     LineBox[{9363, 9364}]}, 
    {Hue[
      NCache[
       Rational[9364, 14307], 0.6545047878660796]], AbsoluteThickness[0.25], 
     LineBox[{9364, 9365}]}, 
    {Hue[
      NCache[
       Rational[9365, 14307], 0.6545746837212554]], AbsoluteThickness[0.25], 
     LineBox[{9365, 9366}]}, 
    {Hue[
      NCache[
       Rational[3122, 4769], 0.6546445795764311]], AbsoluteThickness[0.25], 
     LineBox[{9366, 9367}]}, 
    {Hue[
      NCache[
       Rational[493, 753], 0.6547144754316069]], AbsoluteThickness[0.25], 
     LineBox[{9367, 9368}]}, 
    {Hue[
      NCache[
       Rational[9368, 14307], 0.6547843712867827]], AbsoluteThickness[0.25], 
     LineBox[{9368, 9369}]}, 
    {Hue[
      NCache[
       Rational[3123, 4769], 0.6548542671419585]], AbsoluteThickness[0.25], 
     LineBox[{9369, 9370}]}, 
    {Hue[
      NCache[
       Rational[9370, 14307], 0.6549241629971343]], AbsoluteThickness[0.25], 
     LineBox[{9370, 9371}]}, 
    {Hue[
      NCache[
       Rational[9371, 14307], 0.6549940588523101]], AbsoluteThickness[0.25], 
     LineBox[{9371, 9372}]}, 
    {Hue[
      NCache[
       Rational[3124, 4769], 0.6550639547074858]], AbsoluteThickness[0.25], 
     LineBox[{9372, 9373}]}, 
    {Hue[
      NCache[
       Rational[9373, 14307], 0.6551338505626616]], AbsoluteThickness[0.25], 
     LineBox[{9373, 9374}]}, 
    {Hue[
      NCache[
       Rational[9374, 14307], 0.6552037464178374]], AbsoluteThickness[0.25], 
     LineBox[{9374, 9375}]}, 
    {Hue[
      NCache[
       Rational[3125, 4769], 0.6552736422730132]], AbsoluteThickness[0.25], 
     LineBox[{9375, 9376}]}, 
    {Hue[
      NCache[
       Rational[9376, 14307], 0.655343538128189]], AbsoluteThickness[0.25], 
     LineBox[{9376, 9377}]}, 
    {Hue[
      NCache[
       Rational[9377, 14307], 0.6554134339833648]], AbsoluteThickness[0.25], 
     LineBox[{9377, 9378}]}, 
    {Hue[
      NCache[
       Rational[3126, 4769], 0.6554833298385406]], AbsoluteThickness[0.25], 
     LineBox[{9378, 9379}]}, 
    {Hue[
      NCache[
       Rational[9379, 14307], 0.6555532256937163]], AbsoluteThickness[0.25], 
     LineBox[{9379, 9380}]}, 
    {Hue[
      NCache[
       Rational[9380, 14307], 0.6556231215488921]], AbsoluteThickness[0.25], 
     LineBox[{9380, 9381}]}, 
    {Hue[
      NCache[
       Rational[3127, 4769], 0.6556930174040679]], AbsoluteThickness[0.25], 
     LineBox[{9381, 9382}]}, 
    {Hue[
      NCache[
       Rational[9382, 14307], 0.6557629132592437]], AbsoluteThickness[0.25], 
     LineBox[{9382, 9383}]}, 
    {Hue[
      NCache[
       Rational[9383, 14307], 0.6558328091144195]], AbsoluteThickness[0.25], 
     LineBox[{9383, 9384}]}, 
    {Hue[
      NCache[
       Rational[3128, 4769], 0.6559027049695954]], AbsoluteThickness[0.25], 
     LineBox[{9384, 9385}]}, 
    {Hue[
      NCache[
       Rational[9385, 14307], 0.655972600824771]], AbsoluteThickness[0.25], 
     LineBox[{9385, 9386}]}, 
    {Hue[
      NCache[
       Rational[494, 753], 0.6560424966799469]], AbsoluteThickness[0.25], 
     LineBox[{9386, 9387}]}, 
    {Hue[
      NCache[
       Rational[3129, 4769], 0.6561123925351227]], AbsoluteThickness[0.25], 
     LineBox[{9387, 9388}]}, 
    {Hue[
      NCache[
       Rational[9388, 14307], 0.6561822883902985]], AbsoluteThickness[0.25], 
     LineBox[{9388, 9389}]}, 
    {Hue[
      NCache[
       Rational[9389, 14307], 0.6562521842454743]], AbsoluteThickness[0.25], 
     LineBox[{9389, 9390}]}, 
    {Hue[
      NCache[
       Rational[3130, 4769], 0.6563220801006501]], AbsoluteThickness[0.25], 
     LineBox[{9390, 9391}]}, 
    {Hue[
      NCache[
       Rational[9391, 14307], 0.6563919759558258]], AbsoluteThickness[0.25], 
     LineBox[{9391, 9392}]}, 
    {Hue[
      NCache[
       Rational[9392, 14307], 0.6564618718110016]], AbsoluteThickness[0.25], 
     LineBox[{9392, 9393}]}, 
    {Hue[
      NCache[
       Rational[3131, 4769], 0.6565317676661774]], AbsoluteThickness[0.25], 
     LineBox[{9393, 9394}]}, 
    {Hue[
      NCache[
       Rational[9394, 14307], 0.6566016635213532]], AbsoluteThickness[0.25], 
     LineBox[{9394, 9395}]}, 
    {Hue[
      NCache[
       Rational[9395, 14307], 0.656671559376529]], AbsoluteThickness[0.25], 
     LineBox[{9395, 9396}]}, 
    {Hue[
      NCache[
       Rational[3132, 4769], 0.6567414552317048]], AbsoluteThickness[0.25], 
     LineBox[{9396, 9397}]}, 
    {Hue[
      NCache[
       Rational[9397, 14307], 0.6568113510868806]], AbsoluteThickness[0.25], 
     LineBox[{9397, 9398}]}, 
    {Hue[
      NCache[
       Rational[9398, 14307], 0.6568812469420563]], AbsoluteThickness[0.25], 
     LineBox[{9398, 9399}]}, 
    {Hue[
      NCache[
       Rational[3133, 4769], 0.6569511427972321]], AbsoluteThickness[0.25], 
     LineBox[{9399, 9400}]}, 
    {Hue[
      NCache[
       Rational[9400, 14307], 0.6570210386524079]], AbsoluteThickness[0.25], 
     LineBox[{9400, 9401}]}, 
    {Hue[
      NCache[
       Rational[9401, 14307], 0.6570909345075837]], AbsoluteThickness[0.25], 
     LineBox[{9401, 9402}]}, 
    {Hue[
      NCache[
       Rational[3134, 4769], 0.6571608303627595]], AbsoluteThickness[0.25], 
     LineBox[{9402, 9403}]}, 
    {Hue[
      NCache[
       Rational[9403, 14307], 0.6572307262179353]], AbsoluteThickness[0.25], 
     LineBox[{9403, 9404}]}, 
    {Hue[
      NCache[
       Rational[9404, 14307], 0.657300622073111]], AbsoluteThickness[0.25], 
     LineBox[{9404, 9405}]}, 
    {Hue[
      NCache[
       Rational[165, 251], 0.6573705179282868]], AbsoluteThickness[0.25], 
     LineBox[{9405, 9406}]}, 
    {Hue[
      NCache[
       Rational[9406, 14307], 0.6574404137834626]], AbsoluteThickness[0.25], 
     LineBox[{9406, 9407}]}, 
    {Hue[
      NCache[
       Rational[9407, 14307], 0.6575103096386384]], AbsoluteThickness[0.25], 
     LineBox[{9407, 9408}]}, 
    {Hue[
      NCache[
       Rational[3136, 4769], 0.6575802054938142]], AbsoluteThickness[0.25], 
     LineBox[{9408, 9409}]}, 
    {Hue[
      NCache[
       Rational[9409, 14307], 0.65765010134899]], AbsoluteThickness[0.25], 
     LineBox[{9409, 9410}]}, 
    {Hue[
      NCache[
       Rational[9410, 14307], 0.6577199972041657]], AbsoluteThickness[0.25], 
     LineBox[{9410, 9411}]}, 
    {Hue[
      NCache[
       Rational[3137, 4769], 0.6577898930593415]], AbsoluteThickness[0.25], 
     LineBox[{9411, 9412}]}, 
    {Hue[
      NCache[
       Rational[9412, 14307], 0.6578597889145174]], AbsoluteThickness[0.25], 
     LineBox[{9412, 9413}]}, 
    {Hue[
      NCache[
       Rational[9413, 14307], 0.6579296847696932]], AbsoluteThickness[0.25], 
     LineBox[{9413, 9414}]}, 
    {Hue[
      NCache[
       Rational[3138, 4769], 0.657999580624869]], AbsoluteThickness[0.25], 
     LineBox[{9414, 9415}]}, 
    {Hue[
      NCache[
       Rational[9415, 14307], 0.6580694764800448]], AbsoluteThickness[0.25], 
     LineBox[{9415, 9416}]}, 
    {Hue[
      NCache[
       Rational[9416, 14307], 0.6581393723352206]], AbsoluteThickness[0.25], 
     LineBox[{9416, 9417}]}, 
    {Hue[
      NCache[
       Rational[3139, 4769], 0.6582092681903963]], AbsoluteThickness[0.25], 
     LineBox[{9417, 9418}]}, 
    {Hue[
      NCache[
       Rational[9418, 14307], 0.6582791640455721]], AbsoluteThickness[0.25], 
     LineBox[{9418, 9419}]}, 
    {Hue[
      NCache[
       Rational[9419, 14307], 0.6583490599007479]], AbsoluteThickness[0.25], 
     LineBox[{9419, 9420}]}, 
    {Hue[
      NCache[
       Rational[3140, 4769], 0.6584189557559237]], AbsoluteThickness[0.25], 
     LineBox[{9420, 9421}]}, 
    {Hue[
      NCache[
       Rational[9421, 14307], 0.6584888516110995]], AbsoluteThickness[0.25], 
     LineBox[{9421, 9422}]}, 
    {Hue[
      NCache[
       Rational[9422, 14307], 0.6585587474662753]], AbsoluteThickness[0.25], 
     LineBox[{9422, 9423}]}, 
    {Hue[
      NCache[
       Rational[3141, 4769], 0.658628643321451]], AbsoluteThickness[0.25], 
     LineBox[{9423, 9424}]}, 
    {Hue[
      NCache[
       Rational[496, 753], 0.6586985391766268]], AbsoluteThickness[0.25], 
     LineBox[{9424, 9425}]}, 
    {Hue[
      NCache[
       Rational[9425, 14307], 0.6587684350318026]], AbsoluteThickness[0.25], 
     LineBox[{9425, 9426}]}, 
    {Hue[
      NCache[
       Rational[3142, 4769], 0.6588383308869784]], AbsoluteThickness[0.25], 
     LineBox[{9426, 9427}]}, 
    {Hue[
      NCache[
       Rational[9427, 14307], 0.6589082267421542]], AbsoluteThickness[0.25], 
     LineBox[{9427, 9428}]}, 
    {Hue[
      NCache[
       Rational[9428, 14307], 0.65897812259733]], AbsoluteThickness[0.25], 
     LineBox[{9428, 9429}]}, 
    {Hue[
      NCache[
       Rational[3143, 4769], 0.6590480184525057]], AbsoluteThickness[0.25], 
     LineBox[{9429, 9430}]}, 
    {Hue[
      NCache[
       Rational[9430, 14307], 0.6591179143076815]], AbsoluteThickness[0.25], 
     LineBox[{9430, 9431}]}, 
    {Hue[
      NCache[
       Rational[9431, 14307], 0.6591878101628573]], AbsoluteThickness[0.25], 
     LineBox[{9431, 9432}]}, 
    {Hue[
      NCache[
       Rational[3144, 4769], 0.6592577060180331]], AbsoluteThickness[0.25], 
     LineBox[{9432, 9433}]}, 
    {Hue[
      NCache[
       Rational[9433, 14307], 0.6593276018732089]], AbsoluteThickness[0.25], 
     LineBox[{9433, 9434}]}, 
    {Hue[
      NCache[
       Rational[9434, 14307], 0.6593974977283847]], AbsoluteThickness[0.25], 
     LineBox[{9434, 9435}]}, 
    {Hue[
      NCache[
       Rational[3145, 4769], 0.6594673935835605]], AbsoluteThickness[0.25], 
     LineBox[{9435, 9436}]}, 
    {Hue[
      NCache[
       Rational[9436, 14307], 0.6595372894387362]], AbsoluteThickness[0.25], 
     LineBox[{9436, 9437}]}, 
    {Hue[
      NCache[
       Rational[9437, 14307], 0.659607185293912]], AbsoluteThickness[0.25], 
     LineBox[{9437, 9438}]}, 
    {Hue[
      NCache[
       Rational[3146, 4769], 0.6596770811490879]], AbsoluteThickness[0.25], 
     LineBox[{9438, 9439}]}, 
    {Hue[
      NCache[
       Rational[9439, 14307], 0.6597469770042637]], AbsoluteThickness[0.25], 
     LineBox[{9439, 9440}]}, 
    {Hue[
      NCache[
       Rational[9440, 14307], 0.6598168728594395]], AbsoluteThickness[0.25], 
     LineBox[{9440, 9441}]}, 
    {Hue[
      NCache[
       Rational[3147, 4769], 0.6598867687146153]], AbsoluteThickness[0.25], 
     LineBox[{9441, 9442}]}, 
    {Hue[
      NCache[
       Rational[9442, 14307], 0.659956664569791]], AbsoluteThickness[0.25], 
     LineBox[{9442, 9443}]}, 
    {Hue[
      NCache[
       Rational[497, 753], 0.6600265604249668]], AbsoluteThickness[0.25], 
     LineBox[{9443, 9444}]}, 
    {Hue[
      NCache[
       Rational[3148, 4769], 0.6600964562801426]], AbsoluteThickness[0.25], 
     LineBox[{9444, 9445}]}, 
    {Hue[
      NCache[
       Rational[9445, 14307], 0.6601663521353184]], AbsoluteThickness[0.25], 
     LineBox[{9445, 9446}]}, 
    {Hue[
      NCache[
       Rational[9446, 14307], 0.6602362479904942]], AbsoluteThickness[0.25], 
     LineBox[{9446, 9447}]}, 
    {Hue[
      NCache[
       Rational[3149, 4769], 0.66030614384567]], AbsoluteThickness[0.25], 
     LineBox[{9447, 9448}]}, 
    {Hue[
      NCache[
       Rational[9448, 14307], 0.6603760397008457]], AbsoluteThickness[0.25], 
     LineBox[{9448, 9449}]}, 
    {Hue[
      NCache[
       Rational[9449, 14307], 0.6604459355560215]], AbsoluteThickness[0.25], 
     LineBox[{9449, 9450}]}, 
    {Hue[
      NCache[
       Rational[3150, 4769], 0.6605158314111973]], AbsoluteThickness[0.25], 
     LineBox[{9450, 9451}]}, 
    {Hue[
      NCache[
       Rational[9451, 14307], 0.6605857272663731]], AbsoluteThickness[0.25], 
     LineBox[{9451, 9452}]}, 
    {Hue[
      NCache[
       Rational[9452, 14307], 0.6606556231215489]], AbsoluteThickness[0.25], 
     LineBox[{9452, 9453}]}, 
    {Hue[
      NCache[
       Rational[3151, 4769], 0.6607255189767247]], AbsoluteThickness[0.25], 
     LineBox[{9453, 9454}]}, 
    {Hue[
      NCache[
       Rational[9454, 14307], 0.6607954148319005]], AbsoluteThickness[0.25], 
     LineBox[{9454, 9455}]}, 
    {Hue[
      NCache[
       Rational[9455, 14307], 0.6608653106870762]], AbsoluteThickness[0.25], 
     LineBox[{9455, 9456}]}, 
    {Hue[
      NCache[
       Rational[3152, 4769], 0.660935206542252]], AbsoluteThickness[0.25], 
     LineBox[{9456, 9457}]}, 
    {Hue[
      NCache[
       Rational[9457, 14307], 0.6610051023974278]], AbsoluteThickness[0.25], 
     LineBox[{9457, 9458}]}, 
    {Hue[
      NCache[
       Rational[9458, 14307], 0.6610749982526036]], AbsoluteThickness[0.25], 
     LineBox[{9458, 9459}]}, 
    {Hue[
      NCache[
       Rational[3153, 4769], 0.6611448941077794]], AbsoluteThickness[0.25], 
     LineBox[{9459, 9460}]}, 
    {Hue[
      NCache[
       Rational[9460, 14307], 0.6612147899629552]], AbsoluteThickness[0.25], 
     LineBox[{9460, 9461}]}, 
    {Hue[
      NCache[
       Rational[9461, 14307], 0.6612846858181309]], AbsoluteThickness[0.25], 
     LineBox[{9461, 9462}]}, 
    {Hue[
      NCache[
       Rational[166, 251], 0.6613545816733067]], AbsoluteThickness[0.25], 
     LineBox[{9462, 9463}]}, 
    {Hue[
      NCache[
       Rational[9463, 14307], 0.6614244775284825]], AbsoluteThickness[0.25], 
     LineBox[{9463, 9464}]}, 
    {Hue[
      NCache[
       Rational[9464, 14307], 0.6614943733836584]], AbsoluteThickness[0.25], 
     LineBox[{9464, 9465}]}, 
    {Hue[
      NCache[
       Rational[3155, 4769], 0.6615642692388342]], AbsoluteThickness[0.25], 
     LineBox[{9465, 9466}]}, 
    {Hue[
      NCache[
       Rational[9466, 14307], 0.66163416509401]], AbsoluteThickness[0.25], 
     LineBox[{9466, 9467}]}, 
    {Hue[
      NCache[
       Rational[9467, 14307], 0.6617040609491858]], AbsoluteThickness[0.25], 
     LineBox[{9467, 9468}]}, 
    {Hue[
      NCache[
       Rational[3156, 4769], 0.6617739568043615]], AbsoluteThickness[0.25], 
     LineBox[{9468, 9469}]}, 
    {Hue[
      NCache[
       Rational[9469, 14307], 0.6618438526595373]], AbsoluteThickness[0.25], 
     LineBox[{9469, 9470}]}, 
    {Hue[
      NCache[
       Rational[9470, 14307], 0.6619137485147131]], AbsoluteThickness[0.25], 
     LineBox[{9470, 9471}]}, 
    {Hue[
      NCache[
       Rational[3157, 4769], 0.6619836443698889]], AbsoluteThickness[0.25], 
     LineBox[{9471, 9472}]}, 
    {Hue[
      NCache[
       Rational[9472, 14307], 0.6620535402250647]], AbsoluteThickness[0.25], 
     LineBox[{9472, 9473}]}, 
    {Hue[
      NCache[
       Rational[9473, 14307], 0.6621234360802405]], AbsoluteThickness[0.25], 
     LineBox[{9473, 9474}]}, 
    {Hue[
      NCache[
       Rational[3158, 4769], 0.6621933319354162]], AbsoluteThickness[0.25], 
     LineBox[{9474, 9475}]}, 
    {Hue[
      NCache[
       Rational[9475, 14307], 0.662263227790592]], AbsoluteThickness[0.25], 
     LineBox[{9475, 9476}]}, 
    {Hue[
      NCache[
       Rational[9476, 14307], 0.6623331236457678]], AbsoluteThickness[0.25], 
     LineBox[{9476, 9477}]}, 
    {Hue[
      NCache[
       Rational[3159, 4769], 0.6624030195009436]], AbsoluteThickness[0.25], 
     LineBox[{9477, 9478}]}, 
    {Hue[
      NCache[
       Rational[9478, 14307], 0.6624729153561194]], AbsoluteThickness[0.25], 
     LineBox[{9478, 9479}]}, 
    {Hue[
      NCache[
       Rational[9479, 14307], 0.6625428112112952]], AbsoluteThickness[0.25], 
     LineBox[{9479, 9480}]}, 
    {Hue[
      NCache[
       Rational[3160, 4769], 0.6626127070664709]], AbsoluteThickness[0.25], 
     LineBox[{9480, 9481}]}, 
    {Hue[
      NCache[
       Rational[499, 753], 0.6626826029216467]], AbsoluteThickness[0.25], 
     LineBox[{9481, 9482}]}, 
    {Hue[
      NCache[
       Rational[9482, 14307], 0.6627524987768225]], AbsoluteThickness[0.25], 
     LineBox[{9482, 9483}]}, 
    {Hue[
      NCache[
       Rational[3161, 4769], 0.6628223946319983]], AbsoluteThickness[0.25], 
     LineBox[{9483, 9484}]}, 
    {Hue[
      NCache[
       Rational[9484, 14307], 0.6628922904871741]], AbsoluteThickness[0.25], 
     LineBox[{9484, 9485}]}, 
    {Hue[
      NCache[
       Rational[9485, 14307], 0.6629621863423499]], AbsoluteThickness[0.25], 
     LineBox[{9485, 9486}]}, 
    {Hue[
      NCache[
       Rational[3162, 4769], 0.6630320821975257]], AbsoluteThickness[0.25], 
     LineBox[{9486, 9487}]}, 
    {Hue[
      NCache[
       Rational[9487, 14307], 0.6631019780527014]], AbsoluteThickness[0.25], 
     LineBox[{9487, 9488}]}, 
    {Hue[
      NCache[
       Rational[9488, 14307], 0.6631718739078772]], AbsoluteThickness[0.25], 
     LineBox[{9488, 9489}]}, 
    {Hue[
      NCache[
       Rational[3163, 4769], 0.663241769763053]], AbsoluteThickness[0.25], 
     LineBox[{9489, 9490}]}, 
    {Hue[
      NCache[
       Rational[9490, 14307], 0.6633116656182289]], AbsoluteThickness[0.25], 
     LineBox[{9490, 9491}]}, 
    {Hue[
      NCache[
       Rational[9491, 14307], 0.6633815614734047]], AbsoluteThickness[0.25], 
     LineBox[{9491, 9492}]}, 
    {Hue[
      NCache[
       Rational[3164, 4769], 0.6634514573285805]], AbsoluteThickness[0.25], 
     LineBox[{9492, 9493}]}, 
    {Hue[
      NCache[
       Rational[9493, 14307], 0.6635213531837562]], AbsoluteThickness[0.25], 
     LineBox[{9493, 9494}]}, 
    {Hue[
      NCache[
       Rational[9494, 14307], 0.663591249038932]], AbsoluteThickness[0.25], 
     LineBox[{9494, 9495}]}, 
    {Hue[
      NCache[
       Rational[3165, 4769], 0.6636611448941078]], AbsoluteThickness[0.25], 
     LineBox[{9495, 9496}]}, 
    {Hue[
      NCache[
       Rational[9496, 14307], 0.6637310407492836]], AbsoluteThickness[0.25], 
     LineBox[{9496, 9497}]}, 
    {Hue[
      NCache[
       Rational[9497, 14307], 0.6638009366044594]], AbsoluteThickness[0.25], 
     LineBox[{9497, 9498}]}, 
    {Hue[
      NCache[
       Rational[3166, 4769], 0.6638708324596352]], AbsoluteThickness[0.25], 
     LineBox[{9498, 9499}]}, 
    {Hue[
      NCache[
       Rational[9499, 14307], 0.6639407283148109]], AbsoluteThickness[0.25], 
     LineBox[{9499, 9500}]}, 
    {Hue[
      NCache[
       Rational[500, 753], 0.6640106241699867]], AbsoluteThickness[0.25], 
     LineBox[{9500, 9501}]}, 
    {Hue[
      NCache[
       Rational[3167, 4769], 0.6640805200251625]], AbsoluteThickness[0.25], 
     LineBox[{9501, 9502}]}, 
    {Hue[
      NCache[
       Rational[9502, 14307], 0.6641504158803383]], AbsoluteThickness[0.25], 
     LineBox[{9502, 9503}]}, 
    {Hue[
      NCache[
       Rational[9503, 14307], 0.6642203117355141]], AbsoluteThickness[0.25], 
     LineBox[{9503, 9504}]}, 
    {Hue[
      NCache[
       Rational[3168, 4769], 0.6642902075906899]], AbsoluteThickness[0.25], 
     LineBox[{9504, 9505}]}, 
    {Hue[
      NCache[
       Rational[9505, 14307], 0.6643601034458657]], AbsoluteThickness[0.25], 
     LineBox[{9505, 9506}]}, 
    {Hue[
      NCache[
       Rational[9506, 14307], 0.6644299993010414]], AbsoluteThickness[0.25], 
     LineBox[{9506, 9507}]}, 
    {Hue[
      NCache[
       Rational[3169, 4769], 0.6644998951562172]], AbsoluteThickness[0.25], 
     LineBox[{9507, 9508}]}, 
    {Hue[
      NCache[
       Rational[9508, 14307], 0.664569791011393]], AbsoluteThickness[0.25], 
     LineBox[{9508, 9509}]}, 
    {Hue[
      NCache[
       Rational[9509, 14307], 0.6646396868665688]], AbsoluteThickness[0.25], 
     LineBox[{9509, 9510}]}, 
    {Hue[
      NCache[
       Rational[3170, 4769], 0.6647095827217446]], AbsoluteThickness[0.25], 
     LineBox[{9510, 9511}]}, 
    {Hue[
      NCache[
       Rational[9511, 14307], 0.6647794785769204]], AbsoluteThickness[0.25], 
     LineBox[{9511, 9512}]}, 
    {Hue[
      NCache[
       Rational[9512, 14307], 0.6648493744320961]], AbsoluteThickness[0.25], 
     LineBox[{9512, 9513}]}, 
    {Hue[
      NCache[
       Rational[3171, 4769], 0.6649192702872719]], AbsoluteThickness[0.25], 
     LineBox[{9513, 9514}]}, 
    {Hue[
      NCache[
       Rational[9514, 14307], 0.6649891661424477]], AbsoluteThickness[0.25], 
     LineBox[{9514, 9515}]}, 
    {Hue[
      NCache[
       Rational[9515, 14307], 0.6650590619976235]], AbsoluteThickness[0.25], 
     LineBox[{9515, 9516}]}, 
    {Hue[
      NCache[
       Rational[3172, 4769], 0.6651289578527994]], AbsoluteThickness[0.25], 
     LineBox[{9516, 9517}]}, 
    {Hue[
      NCache[
       Rational[9517, 14307], 0.6651988537079752]], AbsoluteThickness[0.25], 
     LineBox[{9517, 9518}]}, 
    {Hue[
      NCache[
       Rational[9518, 14307], 0.6652687495631509]], AbsoluteThickness[0.25], 
     LineBox[{9518, 9519}]}, 
    {Hue[
      NCache[
       Rational[167, 251], 0.6653386454183267]], AbsoluteThickness[0.25], 
     LineBox[{9519, 9520}]}, 
    {Hue[
      NCache[
       Rational[9520, 14307], 0.6654085412735025]], AbsoluteThickness[0.25], 
     LineBox[{9520, 9521}]}, 
    {Hue[
      NCache[
       Rational[9521, 14307], 0.6654784371286783]], AbsoluteThickness[0.25], 
     LineBox[{9521, 9522}]}, 
    {Hue[
      NCache[
       Rational[3174, 4769], 0.6655483329838541]], AbsoluteThickness[0.25], 
     LineBox[{9522, 9523}]}, 
    {Hue[
      NCache[
       Rational[9523, 14307], 0.6656182288390299]], AbsoluteThickness[0.25], 
     LineBox[{9523, 9524}]}, 
    {Hue[
      NCache[
       Rational[9524, 14307], 0.6656881246942057]], AbsoluteThickness[0.25], 
     LineBox[{9524, 9525}]}, 
    {Hue[
      NCache[
       Rational[3175, 4769], 0.6657580205493814]], AbsoluteThickness[0.25], 
     LineBox[{9525, 9526}]}, 
    {Hue[
      NCache[
       Rational[9526, 14307], 0.6658279164045572]], AbsoluteThickness[0.25], 
     LineBox[{9526, 9527}]}, 
    {Hue[
      NCache[
       Rational[9527, 14307], 0.665897812259733]], AbsoluteThickness[0.25], 
     LineBox[{9527, 9528}]}, 
    {Hue[
      NCache[
       Rational[3176, 4769], 0.6659677081149088]], AbsoluteThickness[0.25], 
     LineBox[{9528, 9529}]}, 
    {Hue[
      NCache[
       Rational[9529, 14307], 0.6660376039700846]], AbsoluteThickness[0.25], 
     LineBox[{9529, 9530}]}, 
    {Hue[
      NCache[
       Rational[9530, 14307], 0.6661074998252604]], AbsoluteThickness[0.25], 
     LineBox[{9530, 9531}]}, 
    {Hue[
      NCache[
       Rational[3177, 4769], 0.6661773956804361]], AbsoluteThickness[0.25], 
     LineBox[{9531, 9532}]}, 
    {Hue[
      NCache[
       Rational[9532, 14307], 0.6662472915356119]], AbsoluteThickness[0.25], 
     LineBox[{9532, 9533}]}, 
    {Hue[
      NCache[
       Rational[9533, 14307], 0.6663171873907877]], AbsoluteThickness[0.25], 
     LineBox[{9533, 9534}]}, 
    {Hue[
      NCache[
       Rational[3178, 4769], 0.6663870832459635]], AbsoluteThickness[0.25], 
     LineBox[{9534, 9535}]}, 
    {Hue[
      NCache[
       Rational[9535, 14307], 0.6664569791011393]], AbsoluteThickness[0.25], 
     LineBox[{9535, 9536}]}, 
    {Hue[
      NCache[
       Rational[9536, 14307], 0.6665268749563151]], AbsoluteThickness[0.25], 
     LineBox[{9536, 9537}]}, 
    {Hue[
      NCache[
       Rational[3179, 4769], 0.6665967708114908]], AbsoluteThickness[0.25], 
     LineBox[{9537, 9538}]}, 
    {Hue[
      NCache[
       Rational[2, 3], 0.6666666666666666]], AbsoluteThickness[0.25], 
     LineBox[{9538, 9539}]}, 
    {Hue[
      NCache[
       Rational[9539, 14307], 0.6667365625218424]], AbsoluteThickness[0.25], 
     LineBox[{9539, 9540}]}, 
    {Hue[
      NCache[
       Rational[3180, 4769], 0.6668064583770182]], AbsoluteThickness[0.25], 
     LineBox[{9540, 9541}]}, 
    {Hue[
      NCache[
       Rational[9541, 14307], 0.666876354232194]], AbsoluteThickness[0.25], 
     LineBox[{9541, 9542}]}, 
    {Hue[
      NCache[
       Rational[9542, 14307], 0.6669462500873699]], AbsoluteThickness[0.25], 
     LineBox[{9542, 9543}]}, 
    {Hue[
      NCache[
       Rational[3181, 4769], 0.6670161459425457]], AbsoluteThickness[0.25], 
     LineBox[{9543, 9544}]}, 
    {Hue[
      NCache[
       Rational[9544, 14307], 0.6670860417977214]], AbsoluteThickness[0.25], 
     LineBox[{9544, 9545}]}, 
    {Hue[
      NCache[
       Rational[9545, 14307], 0.6671559376528972]], AbsoluteThickness[0.25], 
     LineBox[{9545, 9546}]}, 
    {Hue[
      NCache[
       Rational[3182, 4769], 0.667225833508073]], AbsoluteThickness[0.25], 
     LineBox[{9546, 9547}]}, 
    {Hue[
      NCache[
       Rational[9547, 14307], 0.6672957293632488]], AbsoluteThickness[0.25], 
     LineBox[{9547, 9548}]}, 
    {Hue[
      NCache[
       Rational[9548, 14307], 0.6673656252184246]], AbsoluteThickness[0.25], 
     LineBox[{9548, 9549}]}, 
    {Hue[
      NCache[
       Rational[3183, 4769], 0.6674355210736004]], AbsoluteThickness[0.25], 
     LineBox[{9549, 9550}]}, 
    {Hue[
      NCache[
       Rational[9550, 14307], 0.6675054169287761]], AbsoluteThickness[0.25], 
     LineBox[{9550, 9551}]}, 
    {Hue[
      NCache[
       Rational[9551, 14307], 0.6675753127839519]], AbsoluteThickness[0.25], 
     LineBox[{9551, 9552}]}, 
    {Hue[
      NCache[
       Rational[3184, 4769], 0.6676452086391277]], AbsoluteThickness[0.25], 
     LineBox[{9552, 9553}]}, 
    {Hue[
      NCache[
       Rational[9553, 14307], 0.6677151044943035]], AbsoluteThickness[0.25], 
     LineBox[{9553, 9554}]}, 
    {Hue[
      NCache[
       Rational[9554, 14307], 0.6677850003494793]], AbsoluteThickness[0.25], 
     LineBox[{9554, 9555}]}, 
    {Hue[
      NCache[
       Rational[3185, 4769], 0.6678548962046551]], AbsoluteThickness[0.25], 
     LineBox[{9555, 9556}]}, 
    {Hue[
      NCache[
       Rational[9556, 14307], 0.6679247920598309]], AbsoluteThickness[0.25], 
     LineBox[{9556, 9557}]}, 
    {Hue[
      NCache[
       Rational[503, 753], 0.6679946879150066]], AbsoluteThickness[0.25], 
     LineBox[{9557, 9558}]}, 
    {Hue[
      NCache[
       Rational[3186, 4769], 0.6680645837701824]], AbsoluteThickness[0.25], 
     LineBox[{9558, 9559}]}, 
    {Hue[
      NCache[
       Rational[9559, 14307], 0.6681344796253582]], AbsoluteThickness[0.25], 
     LineBox[{9559, 9560}]}, 
    {Hue[
      NCache[
       Rational[9560, 14307], 0.668204375480534]], AbsoluteThickness[0.25], 
     LineBox[{9560, 9561}]}, 
    {Hue[
      NCache[
       Rational[3187, 4769], 0.6682742713357098]], AbsoluteThickness[0.25], 
     LineBox[{9561, 9562}]}, 
    {Hue[
      NCache[
       Rational[9562, 14307], 0.6683441671908856]], AbsoluteThickness[0.25], 
     LineBox[{9562, 9563}]}, 
    {Hue[
      NCache[
       Rational[9563, 14307], 0.6684140630460613]], AbsoluteThickness[0.25], 
     LineBox[{9563, 9564}]}, 
    {Hue[
      NCache[
       Rational[3188, 4769], 0.6684839589012371]], AbsoluteThickness[0.25], 
     LineBox[{9564, 9565}]}, 
    {Hue[
      NCache[
       Rational[9565, 14307], 0.6685538547564129]], AbsoluteThickness[0.25], 
     LineBox[{9565, 9566}]}, 
    {Hue[
      NCache[
       Rational[9566, 14307], 0.6686237506115887]], AbsoluteThickness[0.25], 
     LineBox[{9566, 9567}]}, 
    {Hue[
      NCache[
       Rational[3189, 4769], 0.6686936464667645]], AbsoluteThickness[0.25], 
     LineBox[{9567, 9568}]}, 
    {Hue[
      NCache[
       Rational[9568, 14307], 0.6687635423219404]], AbsoluteThickness[0.25], 
     LineBox[{9568, 9569}]}, 
    {Hue[
      NCache[
       Rational[9569, 14307], 0.668833438177116]], AbsoluteThickness[0.25], 
     LineBox[{9569, 9570}]}, 
    {Hue[
      NCache[
       Rational[3190, 4769], 0.6689033340322919]], AbsoluteThickness[0.25], 
     LineBox[{9570, 9571}]}, 
    {Hue[
      NCache[
       Rational[9571, 14307], 0.6689732298874677]], AbsoluteThickness[0.25], 
     LineBox[{9571, 9572}]}, 
    {Hue[
      NCache[
       Rational[9572, 14307], 0.6690431257426435]], AbsoluteThickness[0.25], 
     LineBox[{9572, 9573}]}, 
    {Hue[
      NCache[
       Rational[3191, 4769], 0.6691130215978193]], AbsoluteThickness[0.25], 
     LineBox[{9573, 9574}]}, 
    {Hue[
      NCache[
       Rational[9574, 14307], 0.6691829174529951]], AbsoluteThickness[0.25], 
     LineBox[{9574, 9575}]}, 
    {Hue[
      NCache[
       Rational[9575, 14307], 0.6692528133081709]], AbsoluteThickness[0.25], 
     LineBox[{9575, 9576}]}, 
    {Hue[
      NCache[
       Rational[168, 251], 0.6693227091633466]], AbsoluteThickness[0.25], 
     LineBox[{9576, 9577}]}, 
    {Hue[
      NCache[
       Rational[9577, 14307], 0.6693926050185224]], AbsoluteThickness[0.25], 
     LineBox[{9577, 9578}]}, 
    {Hue[
      NCache[
       Rational[9578, 14307], 0.6694625008736982]], AbsoluteThickness[0.25], 
     LineBox[{9578, 9579}]}, 
    {Hue[
      NCache[
       Rational[3193, 4769], 0.669532396728874]], AbsoluteThickness[0.25], 
     LineBox[{9579, 9580}]}, 
    {Hue[
      NCache[
       Rational[9580, 14307], 0.6696022925840498]], AbsoluteThickness[0.25], 
     LineBox[{9580, 9581}]}, 
    {Hue[
      NCache[
       Rational[9581, 14307], 0.6696721884392256]], AbsoluteThickness[0.25], 
     LineBox[{9581, 9582}]}, 
    {Hue[
      NCache[
       Rational[3194, 4769], 0.6697420842944013]], AbsoluteThickness[0.25], 
     LineBox[{9582, 9583}]}, 
    {Hue[
      NCache[
       Rational[9583, 14307], 0.6698119801495771]], AbsoluteThickness[0.25], 
     LineBox[{9583, 9584}]}, 
    {Hue[
      NCache[
       Rational[9584, 14307], 0.6698818760047529]], AbsoluteThickness[0.25], 
     LineBox[{9584, 9585}]}, 
    {Hue[
      NCache[
       Rational[3195, 4769], 0.6699517718599287]], AbsoluteThickness[0.25], 
     LineBox[{9585, 9586}]}, 
    {Hue[
      NCache[
       Rational[9586, 14307], 0.6700216677151045]], AbsoluteThickness[0.25], 
     LineBox[{9586, 9587}]}, 
    {Hue[
      NCache[
       Rational[9587, 14307], 0.6700915635702803]], AbsoluteThickness[0.25], 
     LineBox[{9587, 9588}]}, 
    {Hue[
      NCache[
       Rational[3196, 4769], 0.670161459425456]], AbsoluteThickness[0.25], 
     LineBox[{9588, 9589}]}, 
    {Hue[
      NCache[
       Rational[9589, 14307], 0.6702313552806318]], AbsoluteThickness[0.25], 
     LineBox[{9589, 9590}]}, 
    {Hue[
      NCache[
       Rational[9590, 14307], 0.6703012511358076]], AbsoluteThickness[0.25], 
     LineBox[{9590, 9591}]}, 
    {Hue[
      NCache[
       Rational[3197, 4769], 0.6703711469909834]], AbsoluteThickness[0.25], 
     LineBox[{9591, 9592}]}, 
    {Hue[
      NCache[
       Rational[9592, 14307], 0.6704410428461592]], AbsoluteThickness[0.25], 
     LineBox[{9592, 9593}]}, 
    {Hue[
      NCache[
       Rational[9593, 14307], 0.670510938701335]], AbsoluteThickness[0.25], 
     LineBox[{9593, 9594}]}, 
    {Hue[
      NCache[
       Rational[3198, 4769], 0.6705808345565109]], AbsoluteThickness[0.25], 
     LineBox[{9594, 9595}]}, 
    {Hue[
      NCache[
       Rational[505, 753], 0.6706507304116865]], AbsoluteThickness[0.25], 
     LineBox[{9595, 9596}]}, 
    {Hue[
      NCache[
       Rational[9596, 14307], 0.6707206262668624]], AbsoluteThickness[0.25], 
     LineBox[{9596, 9597}]}, 
    {Hue[
      NCache[
       Rational[3199, 4769], 0.6707905221220382]], AbsoluteThickness[0.25], 
     LineBox[{9597, 9598}]}, 
    {Hue[
      NCache[
       Rational[9598, 14307], 0.670860417977214]], AbsoluteThickness[0.25], 
     LineBox[{9598, 9599}]}, 
    {Hue[
      NCache[
       Rational[9599, 14307], 0.6709303138323898]], AbsoluteThickness[0.25], 
     LineBox[{9599, 9600}]}, 
    {Hue[
      NCache[
       Rational[3200, 4769], 0.6710002096875656]], AbsoluteThickness[0.25], 
     LineBox[{9600, 9601}]}, 
    {Hue[
      NCache[
       Rational[9601, 14307], 0.6710701055427413]], AbsoluteThickness[0.25], 
     LineBox[{9601, 9602}]}, 
    {Hue[
      NCache[
       Rational[9602, 14307], 0.6711400013979171]], AbsoluteThickness[0.25], 
     LineBox[{9602, 9603}]}, 
    {Hue[
      NCache[
       Rational[3201, 4769], 0.6712098972530929]], AbsoluteThickness[0.25], 
     LineBox[{9603, 9604}]}, 
    {Hue[
      NCache[
       Rational[9604, 14307], 0.6712797931082687]], AbsoluteThickness[0.25], 
     LineBox[{9604, 9605}]}, 
    {Hue[
      NCache[
       Rational[9605, 14307], 0.6713496889634445]], AbsoluteThickness[0.25], 
     LineBox[{9605, 9606}]}, 
    {Hue[
      NCache[
       Rational[3202, 4769], 0.6714195848186203]], AbsoluteThickness[0.25], 
     LineBox[{9606, 9607}]}, 
    {Hue[
      NCache[
       Rational[9607, 14307], 0.671489480673796]], AbsoluteThickness[0.25], 
     LineBox[{9607, 9608}]}, 
    {Hue[
      NCache[
       Rational[9608, 14307], 0.6715593765289718]], AbsoluteThickness[0.25], 
     LineBox[{9608, 9609}]}, 
    {Hue[
      NCache[
       Rational[3203, 4769], 0.6716292723841476]], AbsoluteThickness[0.25], 
     LineBox[{9609, 9610}]}, 
    {Hue[
      NCache[
       Rational[9610, 14307], 0.6716991682393234]], AbsoluteThickness[0.25], 
     LineBox[{9610, 9611}]}, 
    {Hue[
      NCache[
       Rational[9611, 14307], 0.6717690640944992]], AbsoluteThickness[0.25], 
     LineBox[{9611, 9612}]}, 
    {Hue[
      NCache[
       Rational[3204, 4769], 0.671838959949675]], AbsoluteThickness[0.25], 
     LineBox[{9612, 9613}]}, 
    {Hue[
      NCache[
       Rational[9613, 14307], 0.6719088558048508]], AbsoluteThickness[0.25], 
     LineBox[{9613, 9614}]}, 
    {Hue[
      NCache[
       Rational[506, 753], 0.6719787516600265]], AbsoluteThickness[0.25], 
     LineBox[{9614, 9615}]}, 
    {Hue[
      NCache[
       Rational[3205, 4769], 0.6720486475152023]], AbsoluteThickness[0.25], 
     LineBox[{9615, 9616}]}, 
    {Hue[
      NCache[
       Rational[9616, 14307], 0.6721185433703781]], AbsoluteThickness[0.25], 
     LineBox[{9616, 9617}]}, 
    {Hue[
      NCache[
       Rational[9617, 14307], 0.6721884392255539]], AbsoluteThickness[0.25], 
     LineBox[{9617, 9618}]}, 
    {Hue[
      NCache[
       Rational[3206, 4769], 0.6722583350807297]], AbsoluteThickness[0.25], 
     LineBox[{9618, 9619}]}, 
    {Hue[
      NCache[
       Rational[9619, 14307], 0.6723282309359055]], AbsoluteThickness[0.25], 
     LineBox[{9619, 9620}]}, 
    {Hue[
      NCache[
       Rational[9620, 14307], 0.6723981267910812]], AbsoluteThickness[0.25], 
     LineBox[{9620, 9621}]}, 
    {Hue[
      NCache[
       Rational[3207, 4769], 0.672468022646257]], AbsoluteThickness[0.25], 
     LineBox[{9621, 9622}]}, 
    {Hue[
      NCache[
       Rational[9622, 14307], 0.6725379185014329]], AbsoluteThickness[0.25], 
     LineBox[{9622, 9623}]}, 
    {Hue[
      NCache[
       Rational[9623, 14307], 0.6726078143566087]], AbsoluteThickness[0.25], 
     LineBox[{9623, 9624}]}, 
    {Hue[
      NCache[
       Rational[3208, 4769], 0.6726777102117845]], AbsoluteThickness[0.25], 
     LineBox[{9624, 9625}]}, 
    {Hue[
      NCache[
       Rational[9625, 14307], 0.6727476060669603]], AbsoluteThickness[0.25], 
     LineBox[{9625, 9626}]}, 
    {Hue[
      NCache[
       Rational[9626, 14307], 0.672817501922136]], AbsoluteThickness[0.25], 
     LineBox[{9626, 9627}]}, 
    {Hue[
      NCache[
       Rational[3209, 4769], 0.6728873977773118]], AbsoluteThickness[0.25], 
     LineBox[{9627, 9628}]}, 
    {Hue[
      NCache[
       Rational[9628, 14307], 0.6729572936324876]], AbsoluteThickness[0.25], 
     LineBox[{9628, 9629}]}, 
    {Hue[
      NCache[
       Rational[9629, 14307], 0.6730271894876634]], AbsoluteThickness[0.25], 
     LineBox[{9629, 9630}]}, 
    {Hue[
      NCache[
       Rational[3210, 4769], 0.6730970853428392]], AbsoluteThickness[0.25], 
     LineBox[{9630, 9631}]}, 
    {Hue[
      NCache[
       Rational[9631, 14307], 0.673166981198015]], AbsoluteThickness[0.25], 
     LineBox[{9631, 9632}]}, 
    {Hue[
      NCache[
       Rational[9632, 14307], 0.6732368770531908]], AbsoluteThickness[0.25], 
     LineBox[{9632, 9633}]}, 
    {Hue[
      NCache[
       Rational[169, 251], 0.6733067729083665]], AbsoluteThickness[0.25], 
     LineBox[{9633, 9634}]}, 
    {Hue[
      NCache[
       Rational[9634, 14307], 0.6733766687635423]], AbsoluteThickness[0.25], 
     LineBox[{9634, 9635}]}, 
    {Hue[
      NCache[
       Rational[9635, 14307], 0.6734465646187181]], AbsoluteThickness[0.25], 
     LineBox[{9635, 9636}]}, 
    {Hue[
      NCache[
       Rational[3212, 4769], 0.6735164604738939]], AbsoluteThickness[0.25], 
     LineBox[{9636, 9637}]}, 
    {Hue[
      NCache[
       Rational[9637, 14307], 0.6735863563290697]], AbsoluteThickness[0.25], 
     LineBox[{9637, 9638}]}, 
    {Hue[
      NCache[
       Rational[9638, 14307], 0.6736562521842455]], AbsoluteThickness[0.25], 
     LineBox[{9638, 9639}]}, 
    {Hue[
      NCache[
       Rational[3213, 4769], 0.6737261480394212]], AbsoluteThickness[0.25], 
     LineBox[{9639, 9640}]}, 
    {Hue[
      NCache[
       Rational[9640, 14307], 0.673796043894597]], AbsoluteThickness[0.25], 
     LineBox[{9640, 9641}]}, 
    {Hue[
      NCache[
       Rational[9641, 14307], 0.6738659397497728]], AbsoluteThickness[0.25], 
     LineBox[{9641, 9642}]}, 
    {Hue[
      NCache[
       Rational[3214, 4769], 0.6739358356049486]], AbsoluteThickness[0.25], 
     LineBox[{9642, 9643}]}, 
    {Hue[
      NCache[
       Rational[9643, 14307], 0.6740057314601244]], AbsoluteThickness[0.25], 
     LineBox[{9643, 9644}]}, 
    {Hue[
      NCache[
       Rational[9644, 14307], 0.6740756273153002]], AbsoluteThickness[0.25], 
     LineBox[{9644, 9645}]}, 
    {Hue[
      NCache[
       Rational[3215, 4769], 0.6741455231704759]], AbsoluteThickness[0.25], 
     LineBox[{9645, 9646}]}, 
    {Hue[
      NCache[
       Rational[9646, 14307], 0.6742154190256517]], AbsoluteThickness[0.25], 
     LineBox[{9646, 9647}]}, 
    {Hue[
      NCache[
       Rational[9647, 14307], 0.6742853148808275]], AbsoluteThickness[0.25], 
     LineBox[{9647, 9648}]}, 
    {Hue[
      NCache[
       Rational[3216, 4769], 0.6743552107360034]], AbsoluteThickness[0.25], 
     LineBox[{9648, 9649}]}, 
    {Hue[
      NCache[
       Rational[9649, 14307], 0.6744251065911792]], AbsoluteThickness[0.25], 
     LineBox[{9649, 9650}]}, 
    {Hue[
      NCache[
       Rational[9650, 14307], 0.674495002446355]], AbsoluteThickness[0.25], 
     LineBox[{9650, 9651}]}, 
    {Hue[
      NCache[
       Rational[3217, 4769], 0.6745648983015308]], AbsoluteThickness[0.25], 
     LineBox[{9651, 9652}]}, 
    {Hue[
      NCache[
       Rational[508, 753], 0.6746347941567065]], AbsoluteThickness[0.25], 
     LineBox[{9652, 9653}]}, 
    {Hue[
      NCache[
       Rational[9653, 14307], 0.6747046900118823]], AbsoluteThickness[0.25], 
     LineBox[{9653, 9654}]}, 
    {Hue[
      NCache[
       Rational[3218, 4769], 0.6747745858670581]], AbsoluteThickness[0.25], 
     LineBox[{9654, 9655}]}, 
    {Hue[
      NCache[
       Rational[9655, 14307], 0.6748444817222339]], AbsoluteThickness[0.25], 
     LineBox[{9655, 9656}]}, 
    {Hue[
      NCache[
       Rational[9656, 14307], 0.6749143775774097]], AbsoluteThickness[0.25], 
     LineBox[{9656, 9657}]}, 
    {Hue[
      NCache[
       Rational[3219, 4769], 0.6749842734325855]], AbsoluteThickness[0.25], 
     LineBox[{9657, 9658}]}, 
    {Hue[
      NCache[
       Rational[9658, 14307], 0.6750541692877612]], AbsoluteThickness[0.25], 
     LineBox[{9658, 9659}]}, 
    {Hue[
      NCache[
       Rational[9659, 14307], 0.675124065142937]], AbsoluteThickness[0.25], 
     LineBox[{9659, 9660}]}, 
    {Hue[
      NCache[
       Rational[3220, 4769], 0.6751939609981128]], AbsoluteThickness[0.25], 
     LineBox[{9660, 9661}]}, 
    {Hue[
      NCache[
       Rational[9661, 14307], 0.6752638568532886]], AbsoluteThickness[0.25], 
     LineBox[{9661, 9662}]}, 
    {Hue[
      NCache[
       Rational[9662, 14307], 0.6753337527084644]], AbsoluteThickness[0.25], 
     LineBox[{9662, 9663}]}, 
    {Hue[
      NCache[
       Rational[3221, 4769], 0.6754036485636402]], AbsoluteThickness[0.25], 
     LineBox[{9663, 9664}]}, 
    {Hue[
      NCache[
       Rational[9664, 14307], 0.675473544418816]], AbsoluteThickness[0.25], 
     LineBox[{9664, 9665}]}, 
    {Hue[
      NCache[
       Rational[9665, 14307], 0.6755434402739917]], AbsoluteThickness[0.25], 
     LineBox[{9665, 9666}]}, 
    {Hue[
      NCache[
       Rational[3222, 4769], 0.6756133361291675]], AbsoluteThickness[0.25], 
     LineBox[{9666, 9667}]}, 
    {Hue[
      NCache[
       Rational[9667, 14307], 0.6756832319843433]], AbsoluteThickness[0.25], 
     LineBox[{9667, 9668}]}, 
    {Hue[
      NCache[
       Rational[9668, 14307], 0.6757531278395191]], AbsoluteThickness[0.25], 
     LineBox[{9668, 9669}]}, 
    {Hue[
      NCache[
       Rational[3223, 4769], 0.6758230236946949]], AbsoluteThickness[0.25], 
     LineBox[{9669, 9670}]}, 
    {Hue[
      NCache[
       Rational[9670, 14307], 0.6758929195498707]], AbsoluteThickness[0.25], 
     LineBox[{9670, 9671}]}, 
    {Hue[
      NCache[
       Rational[509, 753], 0.6759628154050464]], AbsoluteThickness[0.25], 
     LineBox[{9671, 9672}]}, 
    {Hue[
      NCache[
       Rational[3224, 4769], 0.6760327112602222]], AbsoluteThickness[0.25], 
     LineBox[{9672, 9673}]}, 
    {Hue[
      NCache[
       Rational[9673, 14307], 0.676102607115398]], AbsoluteThickness[0.25], 
     LineBox[{9673, 9674}]}, 
    {Hue[
      NCache[
       Rational[9674, 14307], 0.6761725029705739]], AbsoluteThickness[0.25], 
     LineBox[{9674, 9675}]}, 
    {Hue[
      NCache[
       Rational[3225, 4769], 0.6762423988257497]], AbsoluteThickness[0.25], 
     LineBox[{9675, 9676}]}, 
    {Hue[
      NCache[
       Rational[9676, 14307], 0.6763122946809255]], AbsoluteThickness[0.25], 
     LineBox[{9676, 9677}]}, 
    {Hue[
      NCache[
       Rational[9677, 14307], 0.6763821905361012]], AbsoluteThickness[0.25], 
     LineBox[{9677, 9678}]}, 
    {Hue[
      NCache[
       Rational[3226, 4769], 0.676452086391277]], AbsoluteThickness[0.25], 
     LineBox[{9678, 9679}]}, 
    {Hue[
      NCache[
       Rational[9679, 14307], 0.6765219822464528]], AbsoluteThickness[0.25], 
     LineBox[{9679, 9680}]}, 
    {Hue[
      NCache[
       Rational[9680, 14307], 0.6765918781016286]], AbsoluteThickness[0.25], 
     LineBox[{9680, 9681}]}, 
    {Hue[
      NCache[
       Rational[3227, 4769], 0.6766617739568044]], AbsoluteThickness[0.25], 
     LineBox[{9681, 9682}]}, 
    {Hue[
      NCache[
       Rational[9682, 14307], 0.6767316698119802]], AbsoluteThickness[0.25], 
     LineBox[{9682, 9683}]}, 
    {Hue[
      NCache[
       Rational[9683, 14307], 0.676801565667156]], AbsoluteThickness[0.25], 
     LineBox[{9683, 9684}]}, 
    {Hue[
      NCache[
       Rational[3228, 4769], 0.6768714615223317]], AbsoluteThickness[0.25], 
     LineBox[{9684, 9685}]}, 
    {Hue[
      NCache[
       Rational[9685, 14307], 0.6769413573775075]], AbsoluteThickness[0.25], 
     LineBox[{9685, 9686}]}, 
    {Hue[
      NCache[
       Rational[9686, 14307], 0.6770112532326833]], AbsoluteThickness[0.25], 
     LineBox[{9686, 9687}]}, 
    {Hue[
      NCache[
       Rational[3229, 4769], 0.6770811490878591]], AbsoluteThickness[0.25], 
     LineBox[{9687, 9688}]}, 
    {Hue[
      NCache[
       Rational[9688, 14307], 0.6771510449430349]], AbsoluteThickness[0.25], 
     LineBox[{9688, 9689}]}, 
    {Hue[
      NCache[
       Rational[9689, 14307], 0.6772209407982107]], AbsoluteThickness[0.25], 
     LineBox[{9689, 9690}]}, 
    {Hue[
      NCache[
       Rational[170, 251], 0.6772908366533864]], AbsoluteThickness[0.25], 
     LineBox[{9690, 9691}]}, 
    {Hue[
      NCache[
       Rational[9691, 14307], 0.6773607325085622]], AbsoluteThickness[0.25], 
     LineBox[{9691, 9692}]}, 
    {Hue[
      NCache[
       Rational[9692, 14307], 0.677430628363738]], AbsoluteThickness[0.25], 
     LineBox[{9692, 9693}]}, 
    {Hue[
      NCache[
       Rational[3231, 4769], 0.6775005242189138]], AbsoluteThickness[0.25], 
     LineBox[{9693, 9694}]}, 
    {Hue[
      NCache[
       Rational[9694, 14307], 0.6775704200740896]], AbsoluteThickness[0.25], 
     LineBox[{9694, 9695}]}, 
    {Hue[
      NCache[
       Rational[9695, 14307], 0.6776403159292654]], AbsoluteThickness[0.25], 
     LineBox[{9695, 9696}]}, 
    {Hue[
      NCache[
       Rational[3232, 4769], 0.6777102117844411]], AbsoluteThickness[0.25], 
     LineBox[{9696, 9697}]}, 
    {Hue[
      NCache[
       Rational[9697, 14307], 0.6777801076396169]], AbsoluteThickness[0.25], 
     LineBox[{9697, 9698}]}, 
    {Hue[
      NCache[
       Rational[9698, 14307], 0.6778500034947927]], AbsoluteThickness[0.25], 
     LineBox[{9698, 9699}]}, 
    {Hue[
      NCache[
       Rational[3233, 4769], 0.6779198993499685]], AbsoluteThickness[0.25], 
     LineBox[{9699, 9700}]}, 
    {Hue[
      NCache[
       Rational[9700, 14307], 0.6779897952051444]], AbsoluteThickness[0.25], 
     LineBox[{9700, 9701}]}, 
    {Hue[
      NCache[
       Rational[9701, 14307], 0.6780596910603202]], AbsoluteThickness[0.25], 
     LineBox[{9701, 9702}]}, 
    {Hue[
      NCache[
       Rational[3234, 4769], 0.678129586915496]], AbsoluteThickness[0.25], 
     LineBox[{9702, 9703}]}, 
    {Hue[
      NCache[
       Rational[9703, 14307], 0.6781994827706717]], AbsoluteThickness[0.25], 
     LineBox[{9703, 9704}]}, 
    {Hue[
      NCache[
       Rational[9704, 14307], 0.6782693786258475]], AbsoluteThickness[0.25], 
     LineBox[{9704, 9705}]}, 
    {Hue[
      NCache[
       Rational[3235, 4769], 0.6783392744810233]], AbsoluteThickness[0.25], 
     LineBox[{9705, 9706}]}, 
    {Hue[
      NCache[
       Rational[9706, 14307], 0.6784091703361991]], AbsoluteThickness[0.25], 
     LineBox[{9706, 9707}]}, 
    {Hue[
      NCache[
       Rational[9707, 14307], 0.6784790661913749]], AbsoluteThickness[0.25], 
     LineBox[{9707, 9708}]}, 
    {Hue[
      NCache[
       Rational[3236, 4769], 0.6785489620465507]], AbsoluteThickness[0.25], 
     LineBox[{9708, 9709}]}, 
    {Hue[
      NCache[
       Rational[511, 753], 0.6786188579017264]], AbsoluteThickness[0.25], 
     LineBox[{9709, 9710}]}, 
    {Hue[
      NCache[
       Rational[9710, 14307], 0.6786887537569022]], AbsoluteThickness[0.25], 
     LineBox[{9710, 9711}]}, 
    {Hue[
      NCache[
       Rational[3237, 4769], 0.678758649612078]], AbsoluteThickness[0.25], 
     LineBox[{9711, 9712}]}, 
    {Hue[
      NCache[
       Rational[9712, 14307], 0.6788285454672538]], AbsoluteThickness[0.25], 
     LineBox[{9712, 9713}]}, 
    {Hue[
      NCache[
       Rational[9713, 14307], 0.6788984413224296]], AbsoluteThickness[0.25], 
     LineBox[{9713, 9714}]}, 
    {Hue[
      NCache[
       Rational[3238, 4769], 0.6789683371776054]], AbsoluteThickness[0.25], 
     LineBox[{9714, 9715}]}, 
    {Hue[
      NCache[
       Rational[9715, 14307], 0.6790382330327811]], AbsoluteThickness[0.25], 
     LineBox[{9715, 9716}]}, 
    {Hue[
      NCache[
       Rational[9716, 14307], 0.6791081288879569]], AbsoluteThickness[0.25], 
     LineBox[{9716, 9717}]}, 
    {Hue[
      NCache[
       Rational[3239, 4769], 0.6791780247431327]], AbsoluteThickness[0.25], 
     LineBox[{9717, 9718}]}, 
    {Hue[
      NCache[
       Rational[9718, 14307], 0.6792479205983085]], AbsoluteThickness[0.25], 
     LineBox[{9718, 9719}]}, 
    {Hue[
      NCache[
       Rational[9719, 14307], 0.6793178164534843]], AbsoluteThickness[0.25], 
     LineBox[{9719, 9720}]}, 
    {Hue[
      NCache[
       Rational[3240, 4769], 0.6793877123086601]], AbsoluteThickness[0.25], 
     LineBox[{9720, 9721}]}, 
    {Hue[
      NCache[
       Rational[9721, 14307], 0.6794576081638359]], AbsoluteThickness[0.25], 
     LineBox[{9721, 9722}]}, 
    {Hue[
      NCache[
       Rational[9722, 14307], 0.6795275040190116]], AbsoluteThickness[0.25], 
     LineBox[{9722, 9723}]}, 
    {Hue[
      NCache[
       Rational[3241, 4769], 0.6795973998741874]], AbsoluteThickness[0.25], 
     LineBox[{9723, 9724}]}, 
    {Hue[
      NCache[
       Rational[9724, 14307], 0.6796672957293632]], AbsoluteThickness[0.25], 
     LineBox[{9724, 9725}]}, 
    {Hue[
      NCache[
       Rational[9725, 14307], 0.679737191584539]], AbsoluteThickness[0.25], 
     LineBox[{9725, 9726}]}, 
    {Hue[
      NCache[
       Rational[3242, 4769], 0.6798070874397149]], AbsoluteThickness[0.25], 
     LineBox[{9726, 9727}]}, 
    {Hue[
      NCache[
       Rational[9727, 14307], 0.6798769832948907]], AbsoluteThickness[0.25], 
     LineBox[{9727, 9728}]}, 
    {Hue[
      NCache[
       Rational[512, 753], 0.6799468791500664]], AbsoluteThickness[0.25], 
     LineBox[{9728, 9729}]}, 
    {Hue[
      NCache[
       Rational[3243, 4769], 0.6800167750052422]], AbsoluteThickness[0.25], 
     LineBox[{9729, 9730}]}, 
    {Hue[
      NCache[
       Rational[9730, 14307], 0.680086670860418]], AbsoluteThickness[0.25], 
     LineBox[{9730, 9731}]}, 
    {Hue[
      NCache[
       Rational[9731, 14307], 0.6801565667155938]], AbsoluteThickness[0.25], 
     LineBox[{9731, 9732}]}, 
    {Hue[
      NCache[
       Rational[3244, 4769], 0.6802264625707696]], AbsoluteThickness[0.25], 
     LineBox[{9732, 9733}]}, 
    {Hue[
      NCache[
       Rational[9733, 14307], 0.6802963584259454]], AbsoluteThickness[0.25], 
     LineBox[{9733, 9734}]}, 
    {Hue[
      NCache[
       Rational[9734, 14307], 0.6803662542811211]], AbsoluteThickness[0.25], 
     LineBox[{9734, 9735}]}, 
    {Hue[
      NCache[
       Rational[3245, 4769], 0.6804361501362969]], AbsoluteThickness[0.25], 
     LineBox[{9735, 9736}]}, 
    {Hue[
      NCache[
       Rational[9736, 14307], 0.6805060459914727]], AbsoluteThickness[0.25], 
     LineBox[{9736, 9737}]}, 
    {Hue[
      NCache[
       Rational[9737, 14307], 0.6805759418466485]], AbsoluteThickness[0.25], 
     LineBox[{9737, 9738}]}, 
    {Hue[
      NCache[
       Rational[3246, 4769], 0.6806458377018243]], AbsoluteThickness[0.25], 
     LineBox[{9738, 9739}]}, 
    {Hue[
      NCache[
       Rational[9739, 14307], 0.6807157335570001]], AbsoluteThickness[0.25], 
     LineBox[{9739, 9740}]}, 
    {Hue[
      NCache[
       Rational[9740, 14307], 0.6807856294121759]], AbsoluteThickness[0.25], 
     LineBox[{9740, 9741}]}, 
    {Hue[
      NCache[
       Rational[3247, 4769], 0.6808555252673516]], AbsoluteThickness[0.25], 
     LineBox[{9741, 9742}]}, 
    {Hue[
      NCache[
       Rational[9742, 14307], 0.6809254211225274]], AbsoluteThickness[0.25], 
     LineBox[{9742, 9743}]}, 
    {Hue[
      NCache[
       Rational[9743, 14307], 0.6809953169777032]], AbsoluteThickness[0.25], 
     LineBox[{9743, 9744}]}, 
    {Hue[
      NCache[
       Rational[3248, 4769], 0.681065212832879]], AbsoluteThickness[0.25], 
     LineBox[{9744, 9745}]}, 
    {Hue[
      NCache[
       Rational[9745, 14307], 0.6811351086880548]], AbsoluteThickness[0.25], 
     LineBox[{9745, 9746}]}, 
    {Hue[
      NCache[
       Rational[9746, 14307], 0.6812050045432306]], AbsoluteThickness[0.25], 
     LineBox[{9746, 9747}]}, 
    {Hue[
      NCache[
       Rational[171, 251], 0.6812749003984063]], AbsoluteThickness[0.25], 
     LineBox[{9747, 9748}]}, 
    {Hue[
      NCache[
       Rational[9748, 14307], 0.6813447962535821]], AbsoluteThickness[0.25], 
     LineBox[{9748, 9749}]}, 
    {Hue[
      NCache[
       Rational[9749, 14307], 0.6814146921087579]], AbsoluteThickness[0.25], 
     LineBox[{9749, 9750}]}, 
    {Hue[
      NCache[
       Rational[3250, 4769], 0.6814845879639337]], AbsoluteThickness[0.25], 
     LineBox[{9750, 9751}]}, 
    {Hue[
      NCache[
       Rational[9751, 14307], 0.6815544838191095]], AbsoluteThickness[0.25], 
     LineBox[{9751, 9752}]}, 
    {Hue[
      NCache[
       Rational[9752, 14307], 0.6816243796742854]], AbsoluteThickness[0.25], 
     LineBox[{9752, 9753}]}, 
    {Hue[
      NCache[
       Rational[3251, 4769], 0.6816942755294612]], AbsoluteThickness[0.25], 
     LineBox[{9753, 9754}]}, 
    {Hue[
      NCache[
       Rational[9754, 14307], 0.6817641713846369]], AbsoluteThickness[0.25], 
     LineBox[{9754, 9755}]}, 
    {Hue[
      NCache[
       Rational[9755, 14307], 0.6818340672398127]], AbsoluteThickness[0.25], 
     LineBox[{9755, 9756}]}, 
    {Hue[
      NCache[
       Rational[3252, 4769], 0.6819039630949885]], AbsoluteThickness[0.25], 
     LineBox[{9756, 9757}]}, 
    {Hue[
      NCache[
       Rational[9757, 14307], 0.6819738589501643]], AbsoluteThickness[0.25], 
     LineBox[{9757, 9758}]}, 
    {Hue[
      NCache[
       Rational[9758, 14307], 0.6820437548053401]], AbsoluteThickness[0.25], 
     LineBox[{9758, 9759}]}, 
    {Hue[
      NCache[
       Rational[3253, 4769], 0.6821136506605159]], AbsoluteThickness[0.25], 
     LineBox[{9759, 9760}]}, 
    {Hue[
      NCache[
       Rational[9760, 14307], 0.6821835465156916]], AbsoluteThickness[0.25], 
     LineBox[{9760, 9761}]}, 
    {Hue[
      NCache[
       Rational[9761, 14307], 0.6822534423708674]], AbsoluteThickness[0.25], 
     LineBox[{9761, 9762}]}, 
    {Hue[
      NCache[
       Rational[3254, 4769], 0.6823233382260432]], AbsoluteThickness[0.25], 
     LineBox[{9762, 9763}]}, 
    {Hue[
      NCache[
       Rational[9763, 14307], 0.682393234081219]], AbsoluteThickness[0.25], 
     LineBox[{9763, 9764}]}, 
    {Hue[
      NCache[
       Rational[9764, 14307], 0.6824631299363948]], AbsoluteThickness[0.25], 
     LineBox[{9764, 9765}]}, 
    {Hue[
      NCache[
       Rational[3255, 4769], 0.6825330257915706]], AbsoluteThickness[0.25], 
     LineBox[{9765, 9766}]}, 
    {Hue[
      NCache[
       Rational[514, 753], 0.6826029216467463]], AbsoluteThickness[0.25], 
     LineBox[{9766, 9767}]}, 
    {Hue[
      NCache[
       Rational[9767, 14307], 0.6826728175019221]], AbsoluteThickness[0.25], 
     LineBox[{9767, 9768}]}, 
    {Hue[
      NCache[
       Rational[3256, 4769], 0.6827427133570979]], AbsoluteThickness[0.25], 
     LineBox[{9768, 9769}]}, 
    {Hue[
      NCache[
       Rational[9769, 14307], 0.6828126092122737]], AbsoluteThickness[0.25], 
     LineBox[{9769, 9770}]}, 
    {Hue[
      NCache[
       Rational[9770, 14307], 0.6828825050674495]], AbsoluteThickness[0.25], 
     LineBox[{9770, 9771}]}, 
    {Hue[
      NCache[
       Rational[3257, 4769], 0.6829524009226253]], AbsoluteThickness[0.25], 
     LineBox[{9771, 9772}]}, 
    {Hue[
      NCache[
       Rational[9772, 14307], 0.6830222967778011]], AbsoluteThickness[0.25], 
     LineBox[{9772, 9773}]}, 
    {Hue[
      NCache[
       Rational[9773, 14307], 0.6830921926329768]], AbsoluteThickness[0.25], 
     LineBox[{9773, 9774}]}, 
    {Hue[
      NCache[
       Rational[3258, 4769], 0.6831620884881526]], AbsoluteThickness[0.25], 
     LineBox[{9774, 9775}]}, 
    {Hue[
      NCache[
       Rational[9775, 14307], 0.6832319843433284]], AbsoluteThickness[0.25], 
     LineBox[{9775, 9776}]}, 
    {Hue[
      NCache[
       Rational[9776, 14307], 0.6833018801985042]], AbsoluteThickness[0.25], 
     LineBox[{9776, 9777}]}, 
    {Hue[
      NCache[
       Rational[3259, 4769], 0.68337177605368]], AbsoluteThickness[0.25], 
     LineBox[{9777, 9778}]}, 
    {Hue[
      NCache[
       Rational[9778, 14307], 0.6834416719088559]], AbsoluteThickness[0.25], 
     LineBox[{9778, 9779}]}, 
    {Hue[
      NCache[
       Rational[9779, 14307], 0.6835115677640315]], AbsoluteThickness[0.25], 
     LineBox[{9779, 9780}]}, 
    {Hue[
      NCache[
       Rational[3260, 4769], 0.6835814636192074]], AbsoluteThickness[0.25], 
     LineBox[{9780, 9781}]}, 
    {Hue[
      NCache[
       Rational[9781, 14307], 0.6836513594743832]], AbsoluteThickness[0.25], 
     LineBox[{9781, 9782}]}, 
    {Hue[
      NCache[
       Rational[9782, 14307], 0.683721255329559]], AbsoluteThickness[0.25], 
     LineBox[{9782, 9783}]}, 
    {Hue[
      NCache[
       Rational[3261, 4769], 0.6837911511847348]], AbsoluteThickness[0.25], 
     LineBox[{9783, 9784}]}, 
    {Hue[
      NCache[
       Rational[9784, 14307], 0.6838610470399106]], AbsoluteThickness[0.25], 
     LineBox[{9784, 9785}]}, 
    {Hue[
      NCache[
       Rational[515, 753], 0.6839309428950863]], AbsoluteThickness[0.25], 
     LineBox[{9785, 9786}]}, 
    {Hue[
      NCache[
       Rational[3262, 4769], 0.6840008387502621]], AbsoluteThickness[0.25], 
     LineBox[{9786, 9787}]}, 
    {Hue[
      NCache[
       Rational[9787, 14307], 0.6840707346054379]], AbsoluteThickness[0.25], 
     LineBox[{9787, 9788}]}, 
    {Hue[
      NCache[
       Rational[9788, 14307], 0.6841406304606137]], AbsoluteThickness[0.25], 
     LineBox[{9788, 9789}]}, 
    {Hue[
      NCache[
       Rational[13, 19], 0.6842105263157895]], AbsoluteThickness[0.25], 
     LineBox[{9789, 9790}]}, 
    {Hue[
      NCache[
       Rational[9790, 14307], 0.6842804221709653]], AbsoluteThickness[0.25], 
     LineBox[{9790, 9791}]}, 
    {Hue[
      NCache[
       Rational[9791, 14307], 0.6843503180261411]], AbsoluteThickness[0.25], 
     LineBox[{9791, 9792}]}, 
    {Hue[
      NCache[
       Rational[3264, 4769], 0.6844202138813168]], AbsoluteThickness[0.25], 
     LineBox[{9792, 9793}]}, 
    {Hue[
      NCache[
       Rational[9793, 14307], 0.6844901097364926]], AbsoluteThickness[0.25], 
     LineBox[{9793, 9794}]}, 
    {Hue[
      NCache[
       Rational[9794, 14307], 0.6845600055916684]], AbsoluteThickness[0.25], 
     LineBox[{9794, 9795}]}, 
    {Hue[
      NCache[
       Rational[3265, 4769], 0.6846299014468442]], AbsoluteThickness[0.25], 
     LineBox[{9795, 9796}]}, 
    {Hue[
      NCache[
       Rational[9796, 14307], 0.68469979730202]], AbsoluteThickness[0.25], 
     LineBox[{9796, 9797}]}, 
    {Hue[
      NCache[
       Rational[9797, 14307], 0.6847696931571958]], AbsoluteThickness[0.25], 
     LineBox[{9797, 9798}]}, 
    {Hue[
      NCache[
       Rational[3266, 4769], 0.6848395890123715]], AbsoluteThickness[0.25], 
     LineBox[{9798, 9799}]}, 
    {Hue[
      NCache[
       Rational[9799, 14307], 0.6849094848675473]], AbsoluteThickness[0.25], 
     LineBox[{9799, 9800}]}, 
    {Hue[
      NCache[
       Rational[9800, 14307], 0.6849793807227231]], AbsoluteThickness[0.25], 
     LineBox[{9800, 9801}]}, 
    {Hue[
      NCache[
       Rational[3267, 4769], 0.6850492765778989]], AbsoluteThickness[0.25], 
     LineBox[{9801, 9802}]}, 
    {Hue[
      NCache[
       Rational[9802, 14307], 0.6851191724330747]], AbsoluteThickness[0.25], 
     LineBox[{9802, 9803}]}, 
    {Hue[
      NCache[
       Rational[9803, 14307], 0.6851890682882505]], AbsoluteThickness[0.25], 
     LineBox[{9803, 9804}]}, 
    {Hue[
      NCache[
       Rational[172, 251], 0.6852589641434262]], AbsoluteThickness[0.25], 
     LineBox[{9804, 9805}]}, 
    {Hue[
      NCache[
       Rational[9805, 14307], 0.685328859998602]], AbsoluteThickness[0.25], 
     LineBox[{9805, 9806}]}, 
    {Hue[
      NCache[
       Rational[9806, 14307], 0.6853987558537779]], AbsoluteThickness[0.25], 
     LineBox[{9806, 9807}]}, 
    {Hue[
      NCache[
       Rational[3269, 4769], 0.6854686517089537]], AbsoluteThickness[0.25], 
     LineBox[{9807, 9808}]}, 
    {Hue[
      NCache[
       Rational[9808, 14307], 0.6855385475641295]], AbsoluteThickness[0.25], 
     LineBox[{9808, 9809}]}, 
    {Hue[
      NCache[
       Rational[9809, 14307], 0.6856084434193053]], AbsoluteThickness[0.25], 
     LineBox[{9809, 9810}]}, 
    {Hue[
      NCache[
       Rational[3270, 4769], 0.6856783392744811]], AbsoluteThickness[0.25], 
     LineBox[{9810, 9811}]}, 
    {Hue[
      NCache[
       Rational[9811, 14307], 0.6857482351296568]], AbsoluteThickness[0.25], 
     LineBox[{9811, 9812}]}, 
    {Hue[
      NCache[
       Rational[9812, 14307], 0.6858181309848326]], AbsoluteThickness[0.25], 
     LineBox[{9812, 9813}]}, 
    {Hue[
      NCache[
       Rational[3271, 4769], 0.6858880268400084]], AbsoluteThickness[0.25], 
     LineBox[{9813, 9814}]}, 
    {Hue[
      NCache[
       Rational[9814, 14307], 0.6859579226951842]], AbsoluteThickness[0.25], 
     LineBox[{9814, 9815}]}, 
    {Hue[
      NCache[
       Rational[9815, 14307], 0.68602781855036]], AbsoluteThickness[0.25], 
     LineBox[{9815, 9816}]}, 
    {Hue[
      NCache[
       Rational[3272, 4769], 0.6860977144055358]], AbsoluteThickness[0.25], 
     LineBox[{9816, 9817}]}, 
    {Hue[
      NCache[
       Rational[9817, 14307], 0.6861676102607115]], AbsoluteThickness[0.25], 
     LineBox[{9817, 9818}]}, 
    {Hue[
      NCache[
       Rational[9818, 14307], 0.6862375061158873]], AbsoluteThickness[0.25], 
     LineBox[{9818, 9819}]}, 
    {Hue[
      NCache[
       Rational[3273, 4769], 0.6863074019710631]], AbsoluteThickness[0.25], 
     LineBox[{9819, 9820}]}, 
    {Hue[
      NCache[
       Rational[9820, 14307], 0.6863772978262389]], AbsoluteThickness[0.25], 
     LineBox[{9820, 9821}]}, 
    {Hue[
      NCache[
       Rational[9821, 14307], 0.6864471936814147]], AbsoluteThickness[0.25], 
     LineBox[{9821, 9822}]}, 
    {Hue[
      NCache[
       Rational[3274, 4769], 0.6865170895365905]], AbsoluteThickness[0.25], 
     LineBox[{9822, 9823}]}, 
    {Hue[
      NCache[
       Rational[517, 753], 0.6865869853917662]], AbsoluteThickness[0.25], 
     LineBox[{9823, 9824}]}, 
    {Hue[
      NCache[
       Rational[9824, 14307], 0.686656881246942]], AbsoluteThickness[0.25], 
     LineBox[{9824, 9825}]}, 
    {Hue[
      NCache[
       Rational[3275, 4769], 0.6867267771021178]], AbsoluteThickness[0.25], 
     LineBox[{9825, 9826}]}, 
    {Hue[
      NCache[
       Rational[9826, 14307], 0.6867966729572936]], AbsoluteThickness[0.25], 
     LineBox[{9826, 9827}]}, 
    {Hue[
      NCache[
       Rational[9827, 14307], 0.6868665688124694]], AbsoluteThickness[0.25], 
     LineBox[{9827, 9828}]}, 
    {Hue[
      NCache[
       Rational[3276, 4769], 0.6869364646676452]], AbsoluteThickness[0.25], 
     LineBox[{9828, 9829}]}, 
    {Hue[
      NCache[
       Rational[9829, 14307], 0.687006360522821]], AbsoluteThickness[0.25], 
     LineBox[{9829, 9830}]}, 
    {Hue[
      NCache[
       Rational[9830, 14307], 0.6870762563779967]], AbsoluteThickness[0.25], 
     LineBox[{9830, 9831}]}, 
    {Hue[
      NCache[
       Rational[3277, 4769], 0.6871461522331725]], AbsoluteThickness[0.25], 
     LineBox[{9831, 9832}]}, 
    {Hue[
      NCache[
       Rational[9832, 14307], 0.6872160480883484]], AbsoluteThickness[0.25], 
     LineBox[{9832, 9833}]}, 
    {Hue[
      NCache[
       Rational[9833, 14307], 0.6872859439435242]], AbsoluteThickness[0.25], 
     LineBox[{9833, 9834}]}, 
    {Hue[
      NCache[
       Rational[3278, 4769], 0.6873558397987]], AbsoluteThickness[0.25], 
     LineBox[{9834, 9835}]}, 
    {Hue[
      NCache[
       Rational[9835, 14307], 0.6874257356538758]], AbsoluteThickness[0.25], 
     LineBox[{9835, 9836}]}, 
    {Hue[
      NCache[
       Rational[9836, 14307], 0.6874956315090515]], AbsoluteThickness[0.25], 
     LineBox[{9836, 9837}]}, 
    {Hue[
      NCache[
       Rational[3279, 4769], 0.6875655273642273]], AbsoluteThickness[0.25], 
     LineBox[{9837, 9838}]}, 
    {Hue[
      NCache[
       Rational[9838, 14307], 0.6876354232194031]], AbsoluteThickness[0.25], 
     LineBox[{9838, 9839}]}, 
    {Hue[
      NCache[
       Rational[9839, 14307], 0.6877053190745789]], AbsoluteThickness[0.25], 
     LineBox[{9839, 9840}]}, 
    {Hue[
      NCache[
       Rational[3280, 4769], 0.6877752149297547]], AbsoluteThickness[0.25], 
     LineBox[{9840, 9841}]}, 
    {Hue[
      NCache[
       Rational[9841, 14307], 0.6878451107849305]], AbsoluteThickness[0.25], 
     LineBox[{9841, 9842}]}, 
    {Hue[
      NCache[
       Rational[518, 753], 0.6879150066401063]], AbsoluteThickness[0.25], 
     LineBox[{9842, 9843}]}, 
    {Hue[
      NCache[
       Rational[3281, 4769], 0.687984902495282]], AbsoluteThickness[0.25], 
     LineBox[{9843, 9844}]}, 
    {Hue[
      NCache[
       Rational[9844, 14307], 0.6880547983504578]], AbsoluteThickness[0.25], 
     LineBox[{9844, 9845}]}, 
    {Hue[
      NCache[
       Rational[9845, 14307], 0.6881246942056336]], AbsoluteThickness[0.25], 
     LineBox[{9845, 9846}]}, 
    {Hue[
      NCache[
       Rational[3282, 4769], 0.6881945900608094]], AbsoluteThickness[0.25], 
     LineBox[{9846, 9847}]}, 
    {Hue[
      NCache[
       Rational[9847, 14307], 0.6882644859159852]], AbsoluteThickness[0.25], 
     LineBox[{9847, 9848}]}, 
    {Hue[
      NCache[
       Rational[9848, 14307], 0.688334381771161]], AbsoluteThickness[0.25], 
     LineBox[{9848, 9849}]}, 
    {Hue[
      NCache[
       Rational[3283, 4769], 0.6884042776263367]], AbsoluteThickness[0.25], 
     LineBox[{9849, 9850}]}, 
    {Hue[
      NCache[
       Rational[9850, 14307], 0.6884741734815125]], AbsoluteThickness[0.25], 
     LineBox[{9850, 9851}]}, 
    {Hue[
      NCache[
       Rational[9851, 14307], 0.6885440693366883]], AbsoluteThickness[0.25], 
     LineBox[{9851, 9852}]}, 
    {Hue[
      NCache[
       Rational[3284, 4769], 0.6886139651918641]], AbsoluteThickness[0.25], 
     LineBox[{9852, 9853}]}, 
    {Hue[
      NCache[
       Rational[9853, 14307], 0.6886838610470399]], AbsoluteThickness[0.25], 
     LineBox[{9853, 9854}]}, 
    {Hue[
      NCache[
       Rational[9854, 14307], 0.6887537569022157]], AbsoluteThickness[0.25], 
     LineBox[{9854, 9855}]}, 
    {Hue[
      NCache[
       Rational[3285, 4769], 0.6888236527573914]], AbsoluteThickness[0.25], 
     LineBox[{9855, 9856}]}, 
    {Hue[
      NCache[
       Rational[9856, 14307], 0.6888935486125672]], AbsoluteThickness[0.25], 
     LineBox[{9856, 9857}]}, 
    {Hue[
      NCache[
       Rational[9857, 14307], 0.688963444467743]], AbsoluteThickness[0.25], 
     LineBox[{9857, 9858}]}, 
    {Hue[
      NCache[
       Rational[3286, 4769], 0.6890333403229189]], AbsoluteThickness[0.25], 
     LineBox[{9858, 9859}]}, 
    {Hue[
      NCache[
       Rational[9859, 14307], 0.6891032361780947]], AbsoluteThickness[0.25], 
     LineBox[{9859, 9860}]}, 
    {Hue[
      NCache[
       Rational[9860, 14307], 0.6891731320332705]], AbsoluteThickness[0.25], 
     LineBox[{9860, 9861}]}, 
    {Hue[
      NCache[
       Rational[173, 251], 0.6892430278884463]], AbsoluteThickness[0.25], 
     LineBox[{9861, 9862}]}, 
    {Hue[
      NCache[
       Rational[9862, 14307], 0.689312923743622]], AbsoluteThickness[0.25], 
     LineBox[{9862, 9863}]}, 
    {Hue[
      NCache[
       Rational[9863, 14307], 0.6893828195987978]], AbsoluteThickness[0.25], 
     LineBox[{9863, 9864}]}, 
    {Hue[
      NCache[
       Rational[3288, 4769], 0.6894527154539736]], AbsoluteThickness[0.25], 
     LineBox[{9864, 9865}]}, 
    {Hue[
      NCache[
       Rational[9865, 14307], 0.6895226113091494]], AbsoluteThickness[0.25], 
     LineBox[{9865, 9866}]}, 
    {Hue[
      NCache[
       Rational[9866, 14307], 0.6895925071643252]], AbsoluteThickness[0.25], 
     LineBox[{9866, 9867}]}, 
    {Hue[
      NCache[
       Rational[3289, 4769], 0.689662403019501]], AbsoluteThickness[0.25], 
     LineBox[{9867, 9868}]}, 
    {Hue[
      NCache[
       Rational[9868, 14307], 0.6897322988746767]], AbsoluteThickness[0.25], 
     LineBox[{9868, 9869}]}, 
    {Hue[
      NCache[
       Rational[9869, 14307], 0.6898021947298525]], AbsoluteThickness[0.25], 
     LineBox[{9869, 9870}]}, 
    {Hue[
      NCache[
       Rational[3290, 4769], 0.6898720905850283]], AbsoluteThickness[0.25], 
     LineBox[{9870, 9871}]}, 
    {Hue[
      NCache[
       Rational[9871, 14307], 0.6899419864402041]], AbsoluteThickness[0.25], 
     LineBox[{9871, 9872}]}, 
    {Hue[
      NCache[
       Rational[9872, 14307], 0.6900118822953799]], AbsoluteThickness[0.25], 
     LineBox[{9872, 9873}]}, 
    {Hue[
      NCache[
       Rational[3291, 4769], 0.6900817781505557]], AbsoluteThickness[0.25], 
     LineBox[{9873, 9874}]}, 
    {Hue[
      NCache[
       Rational[9874, 14307], 0.6901516740057314]], AbsoluteThickness[0.25], 
     LineBox[{9874, 9875}]}, 
    {Hue[
      NCache[
       Rational[9875, 14307], 0.6902215698609072]], AbsoluteThickness[0.25], 
     LineBox[{9875, 9876}]}, 
    {Hue[
      NCache[
       Rational[3292, 4769], 0.690291465716083]], AbsoluteThickness[0.25], 
     LineBox[{9876, 9877}]}, 
    {Hue[
      NCache[
       Rational[9877, 14307], 0.6903613615712588]], AbsoluteThickness[0.25], 
     LineBox[{9877, 9878}]}, 
    {Hue[
      NCache[
       Rational[9878, 14307], 0.6904312574264346]], AbsoluteThickness[0.25], 
     LineBox[{9878, 9879}]}, 
    {Hue[
      NCache[
       Rational[3293, 4769], 0.6905011532816104]], AbsoluteThickness[0.25], 
     LineBox[{9879, 9880}]}, 
    {Hue[
      NCache[
       Rational[520, 753], 0.6905710491367862]], AbsoluteThickness[0.25], 
     LineBox[{9880, 9881}]}, 
    {Hue[
      NCache[
       Rational[9881, 14307], 0.6906409449919619]], AbsoluteThickness[0.25], 
     LineBox[{9881, 9882}]}, 
    {Hue[
      NCache[
       Rational[3294, 4769], 0.6907108408471377]], AbsoluteThickness[0.25], 
     LineBox[{9882, 9883}]}, 
    {Hue[
      NCache[
       Rational[9883, 14307], 0.6907807367023135]], AbsoluteThickness[0.25], 
     LineBox[{9883, 9884}]}, 
    {Hue[
      NCache[
       Rational[9884, 14307], 0.6908506325574894]], AbsoluteThickness[0.25], 
     LineBox[{9884, 9885}]}, 
    {Hue[
      NCache[
       Rational[3295, 4769], 0.6909205284126652]], AbsoluteThickness[0.25], 
     LineBox[{9885, 9886}]}, 
    {Hue[
      NCache[
       Rational[9886, 14307], 0.690990424267841]], AbsoluteThickness[0.25], 
     LineBox[{9886, 9887}]}, 
    {Hue[
      NCache[
       Rational[9887, 14307], 0.6910603201230167]], AbsoluteThickness[0.25], 
     LineBox[{9887, 9888}]}, 
    {Hue[
      NCache[
       Rational[3296, 4769], 0.6911302159781925]], AbsoluteThickness[0.25], 
     LineBox[{9888, 9889}]}, 
    {Hue[
      NCache[
       Rational[9889, 14307], 0.6912001118333683]], AbsoluteThickness[0.25], 
     LineBox[{9889, 9890}]}, 
    {Hue[
      NCache[
       Rational[9890, 14307], 0.6912700076885441]], AbsoluteThickness[0.25], 
     LineBox[{9890, 9891}]}, 
    {Hue[
      NCache[
       Rational[3297, 4769], 0.6913399035437199]], AbsoluteThickness[0.25], 
     LineBox[{9891, 9892}]}, 
    {Hue[
      NCache[
       Rational[9892, 14307], 0.6914097993988957]], AbsoluteThickness[0.25], 
     LineBox[{9892, 9893}]}, 
    {Hue[
      NCache[
       Rational[9893, 14307], 0.6914796952540714]], AbsoluteThickness[0.25], 
     LineBox[{9893, 9894}]}, 
    {Hue[
      NCache[
       Rational[3298, 4769], 0.6915495911092472]], AbsoluteThickness[0.25], 
     LineBox[{9894, 9895}]}, 
    {Hue[
      NCache[
       Rational[9895, 14307], 0.691619486964423]], AbsoluteThickness[0.25], 
     LineBox[{9895, 9896}]}, 
    {Hue[
      NCache[
       Rational[9896, 14307], 0.6916893828195988]], AbsoluteThickness[0.25], 
     LineBox[{9896, 9897}]}, 
    {Hue[
      NCache[
       Rational[3299, 4769], 0.6917592786747746]], AbsoluteThickness[0.25], 
     LineBox[{9897, 9898}]}, 
    {Hue[
      NCache[
       Rational[9898, 14307], 0.6918291745299504]], AbsoluteThickness[0.25], 
     LineBox[{9898, 9899}]}, 
    {Hue[
      NCache[
       Rational[521, 753], 0.6918990703851262]], AbsoluteThickness[0.25], 
     LineBox[{9899, 9900}]}, 
    {Hue[
      NCache[
       Rational[3300, 4769], 0.6919689662403019]], AbsoluteThickness[0.25], 
     LineBox[{9900, 9901}]}, 
    {Hue[
      NCache[
       Rational[9901, 14307], 0.6920388620954777]], AbsoluteThickness[0.25], 
     LineBox[{9901, 9902}]}, 
    {Hue[
      NCache[
       Rational[9902, 14307], 0.6921087579506535]], AbsoluteThickness[0.25], 
     LineBox[{9902, 9903}]}, 
    {Hue[
      NCache[
       Rational[3301, 4769], 0.6921786538058293]], AbsoluteThickness[0.25], 
     LineBox[{9903, 9904}]}, 
    {Hue[
      NCache[
       Rational[9904, 14307], 0.6922485496610051]], AbsoluteThickness[0.25], 
     LineBox[{9904, 9905}]}, 
    {Hue[
      NCache[
       Rational[9905, 14307], 0.6923184455161809]], AbsoluteThickness[0.25], 
     LineBox[{9905, 9906}]}, 
    {Hue[
      NCache[
       Rational[3302, 4769], 0.6923883413713566]], AbsoluteThickness[0.25], 
     LineBox[{9906, 9907}]}, 
    {Hue[
      NCache[
       Rational[9907, 14307], 0.6924582372265324]], AbsoluteThickness[0.25], 
     LineBox[{9907, 9908}]}, 
    {Hue[
      NCache[
       Rational[9908, 14307], 0.6925281330817082]], AbsoluteThickness[0.25], 
     LineBox[{9908, 9909}]}, 
    {Hue[
      NCache[
       Rational[3303, 4769], 0.692598028936884]], AbsoluteThickness[0.25], 
     LineBox[{9909, 9910}]}, 
    {Hue[
      NCache[
       Rational[9910, 14307], 0.6926679247920599]], AbsoluteThickness[0.25], 
     LineBox[{9910, 9911}]}, 
    {Hue[
      NCache[
       Rational[9911, 14307], 0.6927378206472357]], AbsoluteThickness[0.25], 
     LineBox[{9911, 9912}]}, 
    {Hue[
      NCache[
       Rational[3304, 4769], 0.6928077165024114]], AbsoluteThickness[0.25], 
     LineBox[{9912, 9913}]}, 
    {Hue[
      NCache[
       Rational[9913, 14307], 0.6928776123575872]], AbsoluteThickness[0.25], 
     LineBox[{9913, 9914}]}, 
    {Hue[
      NCache[
       Rational[9914, 14307], 0.692947508212763]], AbsoluteThickness[0.25], 
     LineBox[{9914, 9915}]}, 
    {Hue[
      NCache[
       Rational[3305, 4769], 0.6930174040679388]], AbsoluteThickness[0.25], 
     LineBox[{9915, 9916}]}, 
    {Hue[
      NCache[
       Rational[9916, 14307], 0.6930872999231146]], AbsoluteThickness[0.25], 
     LineBox[{9916, 9917}]}, 
    {Hue[
      NCache[
       Rational[9917, 14307], 0.6931571957782904]], AbsoluteThickness[0.25], 
     LineBox[{9917, 9918}]}, 
    {Hue[
      NCache[
       Rational[174, 251], 0.6932270916334662]], AbsoluteThickness[0.25], 
     LineBox[{9918, 9919}]}, 
    {Hue[
      NCache[
       Rational[9919, 14307], 0.6932969874886419]], AbsoluteThickness[0.25], 
     LineBox[{9919, 9920}]}, 
    {Hue[
      NCache[
       Rational[9920, 14307], 0.6933668833438177]], AbsoluteThickness[0.25], 
     LineBox[{9920, 9921}]}, 
    {Hue[
      NCache[
       Rational[3307, 4769], 0.6934367791989935]], AbsoluteThickness[0.25], 
     LineBox[{9921, 9922}]}, 
    {Hue[
      NCache[
       Rational[9922, 14307], 0.6935066750541693]], AbsoluteThickness[0.25], 
     LineBox[{9922, 9923}]}, 
    {Hue[
      NCache[
       Rational[9923, 14307], 0.6935765709093451]], AbsoluteThickness[0.25], 
     LineBox[{9923, 9924}]}, 
    {Hue[
      NCache[
       Rational[3308, 4769], 0.6936464667645209]], AbsoluteThickness[0.25], 
     LineBox[{9924, 9925}]}, 
    {Hue[
      NCache[
       Rational[9925, 14307], 0.6937163626196966]], AbsoluteThickness[0.25], 
     LineBox[{9925, 9926}]}, 
    {Hue[
      NCache[
       Rational[9926, 14307], 0.6937862584748724]], AbsoluteThickness[0.25], 
     LineBox[{9926, 9927}]}, 
    {Hue[
      NCache[
       Rational[3309, 4769], 0.6938561543300482]], AbsoluteThickness[0.25], 
     LineBox[{9927, 9928}]}, 
    {Hue[
      NCache[
       Rational[9928, 14307], 0.693926050185224]], AbsoluteThickness[0.25], 
     LineBox[{9928, 9929}]}, 
    {Hue[
      NCache[
       Rational[9929, 14307], 0.6939959460403998]], AbsoluteThickness[0.25], 
     LineBox[{9929, 9930}]}, 
    {Hue[
      NCache[
       Rational[3310, 4769], 0.6940658418955756]], AbsoluteThickness[0.25], 
     LineBox[{9930, 9931}]}, 
    {Hue[
      NCache[
       Rational[9931, 14307], 0.6941357377507514]], AbsoluteThickness[0.25], 
     LineBox[{9931, 9932}]}, 
    {Hue[
      NCache[
       Rational[9932, 14307], 0.6942056336059271]], AbsoluteThickness[0.25], 
     LineBox[{9932, 9933}]}, 
    {Hue[
      NCache[
       Rational[3311, 4769], 0.6942755294611029]], AbsoluteThickness[0.25], 
     LineBox[{9933, 9934}]}, 
    {Hue[
      NCache[
       Rational[9934, 14307], 0.6943454253162787]], AbsoluteThickness[0.25], 
     LineBox[{9934, 9935}]}, 
    {Hue[
      NCache[
       Rational[9935, 14307], 0.6944153211714545]], AbsoluteThickness[0.25], 
     LineBox[{9935, 9936}]}, 
    {Hue[
      NCache[
       Rational[3312, 4769], 0.6944852170266304]], AbsoluteThickness[0.25], 
     LineBox[{9936, 9937}]}, 
    {Hue[
      NCache[
       Rational[523, 753], 0.6945551128818062]], AbsoluteThickness[0.25], 
     LineBox[{9937, 9938}]}, 
    {Hue[
      NCache[
       Rational[9938, 14307], 0.6946250087369819]], AbsoluteThickness[0.25], 
     LineBox[{9938, 9939}]}, 
    {Hue[
      NCache[
       Rational[3313, 4769], 0.6946949045921577]], AbsoluteThickness[0.25], 
     LineBox[{9939, 9940}]}, 
    {Hue[
      NCache[
       Rational[9940, 14307], 0.6947648004473335]], AbsoluteThickness[0.25], 
     LineBox[{9940, 9941}]}, 
    {Hue[
      NCache[
       Rational[9941, 14307], 0.6948346963025093]], AbsoluteThickness[0.25], 
     LineBox[{9941, 9942}]}, 
    {Hue[
      NCache[
       Rational[3314, 4769], 0.6949045921576851]], AbsoluteThickness[0.25], 
     LineBox[{9942, 9943}]}, 
    {Hue[
      NCache[
       Rational[9943, 14307], 0.6949744880128609]], AbsoluteThickness[0.25], 
     LineBox[{9943, 9944}]}, 
    {Hue[
      NCache[
       Rational[9944, 14307], 0.6950443838680366]], AbsoluteThickness[0.25], 
     LineBox[{9944, 9945}]}, 
    {Hue[
      NCache[
       Rational[3315, 4769], 0.6951142797232124]], AbsoluteThickness[0.25], 
     LineBox[{9945, 9946}]}, 
    {Hue[
      NCache[
       Rational[9946, 14307], 0.6951841755783882]], AbsoluteThickness[0.25], 
     LineBox[{9946, 9947}]}, 
    {Hue[
      NCache[
       Rational[9947, 14307], 0.695254071433564]], AbsoluteThickness[0.25], 
     LineBox[{9947, 9948}]}, 
    {Hue[
      NCache[
       Rational[3316, 4769], 0.6953239672887398]], AbsoluteThickness[0.25], 
     LineBox[{9948, 9949}]}, 
    {Hue[
      NCache[
       Rational[9949, 14307], 0.6953938631439156]], AbsoluteThickness[0.25], 
     LineBox[{9949, 9950}]}, 
    {Hue[
      NCache[
       Rational[9950, 14307], 0.6954637589990914]], AbsoluteThickness[0.25], 
     LineBox[{9950, 9951}]}, 
    {Hue[
      NCache[
       Rational[3317, 4769], 0.6955336548542671]], AbsoluteThickness[0.25], 
     LineBox[{9951, 9952}]}, 
    {Hue[
      NCache[
       Rational[9952, 14307], 0.6956035507094429]], AbsoluteThickness[0.25], 
     LineBox[{9952, 9953}]}, 
    {Hue[
      NCache[
       Rational[9953, 14307], 0.6956734465646187]], AbsoluteThickness[0.25], 
     LineBox[{9953, 9954}]}, 
    {Hue[
      NCache[
       Rational[3318, 4769], 0.6957433424197945]], AbsoluteThickness[0.25], 
     LineBox[{9954, 9955}]}, 
    {Hue[
      NCache[
       Rational[9955, 14307], 0.6958132382749703]], AbsoluteThickness[0.25], 
     LineBox[{9955, 9956}]}, 
    {Hue[
      NCache[
       Rational[524, 753], 0.6958831341301461]], AbsoluteThickness[0.25], 
     LineBox[{9956, 9957}]}, 
    {Hue[
      NCache[
       Rational[3319, 4769], 0.6959530299853218]], AbsoluteThickness[0.25], 
     LineBox[{9957, 9958}]}, 
    {Hue[
      NCache[
       Rational[9958, 14307], 0.6960229258404976]], AbsoluteThickness[0.25], 
     LineBox[{9958, 9959}]}, 
    {Hue[
      NCache[
       Rational[9959, 14307], 0.6960928216956734]], AbsoluteThickness[0.25], 
     LineBox[{9959, 9960}]}, 
    {Hue[
      NCache[
       Rational[3320, 4769], 0.6961627175508492]], AbsoluteThickness[0.25], 
     LineBox[{9960, 9961}]}, 
    {Hue[
      NCache[
       Rational[9961, 14307], 0.696232613406025]], AbsoluteThickness[0.25], 
     LineBox[{9961, 9962}]}, 
    {Hue[
      NCache[
       Rational[9962, 14307], 0.6963025092612009]], AbsoluteThickness[0.25], 
     LineBox[{9962, 9963}]}, 
    {Hue[
      NCache[
       Rational[3321, 4769], 0.6963724051163765]], AbsoluteThickness[0.25], 
     LineBox[{9963, 9964}]}, 
    {Hue[
      NCache[
       Rational[9964, 14307], 0.6964423009715524]], AbsoluteThickness[0.25], 
     LineBox[{9964, 9965}]}, 
    {Hue[
      NCache[
       Rational[9965, 14307], 0.6965121968267282]], AbsoluteThickness[0.25], 
     LineBox[{9965, 9966}]}, 
    {Hue[
      NCache[
       Rational[3322, 4769], 0.696582092681904]], AbsoluteThickness[0.25], 
     LineBox[{9966, 9967}]}, 
    {Hue[
      NCache[
       Rational[9967, 14307], 0.6966519885370798]], AbsoluteThickness[0.25], 
     LineBox[{9967, 9968}]}, 
    {Hue[
      NCache[
       Rational[9968, 14307], 0.6967218843922556]], AbsoluteThickness[0.25], 
     LineBox[{9968, 9969}]}, 
    {Hue[
      NCache[
       Rational[3323, 4769], 0.6967917802474314]], AbsoluteThickness[0.25], 
     LineBox[{9969, 9970}]}, 
    {Hue[
      NCache[
       Rational[9970, 14307], 0.6968616761026071]], AbsoluteThickness[0.25], 
     LineBox[{9970, 9971}]}, 
    {Hue[
      NCache[
       Rational[9971, 14307], 0.6969315719577829]], AbsoluteThickness[0.25], 
     LineBox[{9971, 9972}]}, 
    {Hue[
      NCache[
       Rational[3324, 4769], 0.6970014678129587]], AbsoluteThickness[0.25], 
     LineBox[{9972, 9973}]}, 
    {Hue[
      NCache[
       Rational[9973, 14307], 0.6970713636681345]], AbsoluteThickness[0.25], 
     LineBox[{9973, 9974}]}, 
    {Hue[
      NCache[
       Rational[9974, 14307], 0.6971412595233103]], AbsoluteThickness[0.25], 
     LineBox[{9974, 9975}]}, 
    {Hue[
      NCache[
       Rational[175, 251], 0.6972111553784861]], AbsoluteThickness[0.25], 
     LineBox[{9975, 9976}]}, 
    {Hue[
      NCache[
       Rational[9976, 14307], 0.6972810512336618]], AbsoluteThickness[0.25], 
     LineBox[{9976, 9977}]}, 
    {Hue[
      NCache[
       Rational[9977, 14307], 0.6973509470888376]], AbsoluteThickness[0.25], 
     LineBox[{9977, 9978}]}, 
    {Hue[
      NCache[
       Rational[3326, 4769], 0.6974208429440134]], AbsoluteThickness[0.25], 
     LineBox[{9978, 9979}]}, 
    {Hue[
      NCache[
       Rational[9979, 14307], 0.6974907387991892]], AbsoluteThickness[0.25], 
     LineBox[{9979, 9980}]}, 
    {Hue[
      NCache[
       Rational[9980, 14307], 0.697560634654365]], AbsoluteThickness[0.25], 
     LineBox[{9980, 9981}]}, 
    {Hue[
      NCache[
       Rational[3327, 4769], 0.6976305305095408]], AbsoluteThickness[0.25], 
     LineBox[{9981, 9982}]}, 
    {Hue[
      NCache[
       Rational[9982, 14307], 0.6977004263647165]], AbsoluteThickness[0.25], 
     LineBox[{9982, 9983}]}, 
    {Hue[
      NCache[
       Rational[9983, 14307], 0.6977703222198923]], AbsoluteThickness[0.25], 
     LineBox[{9983, 9984}]}, 
    {Hue[
      NCache[
       Rational[3328, 4769], 0.6978402180750681]], AbsoluteThickness[0.25], 
     LineBox[{9984, 9985}]}, 
    {Hue[
      NCache[
       Rational[9985, 14307], 0.6979101139302439]], AbsoluteThickness[0.25], 
     LineBox[{9985, 9986}]}, 
    {Hue[
      NCache[
       Rational[9986, 14307], 0.6979800097854197]], AbsoluteThickness[0.25], 
     LineBox[{9986, 9987}]}, 
    {Hue[
      NCache[
       Rational[3329, 4769], 0.6980499056405955]], AbsoluteThickness[0.25], 
     LineBox[{9987, 9988}]}, 
    {Hue[
      NCache[
       Rational[9988, 14307], 0.6981198014957714]], AbsoluteThickness[0.25], 
     LineBox[{9988, 9989}]}, 
    {Hue[
      NCache[
       Rational[9989, 14307], 0.698189697350947]], AbsoluteThickness[0.25], 
     LineBox[{9989, 9990}]}, 
    {Hue[
      NCache[
       Rational[3330, 4769], 0.6982595932061229]], AbsoluteThickness[0.25], 
     LineBox[{9990, 9991}]}, 
    {Hue[
      NCache[
       Rational[9991, 14307], 0.6983294890612987]], AbsoluteThickness[0.25], 
     LineBox[{9991, 9992}]}, 
    {Hue[
      NCache[
       Rational[9992, 14307], 0.6983993849164745]], AbsoluteThickness[0.25], 
     LineBox[{9992, 9993}]}, 
    {Hue[
      NCache[
       Rational[3331, 4769], 0.6984692807716503]], AbsoluteThickness[0.25], 
     LineBox[{9993, 9994}]}, 
    {Hue[
      NCache[
       Rational[526, 753], 0.6985391766268261]], AbsoluteThickness[0.25], 
     LineBox[{9994, 9995}]}, 
    {Hue[
      NCache[
       Rational[9995, 14307], 0.6986090724820018]], AbsoluteThickness[0.25], 
     LineBox[{9995, 9996}]}, 
    {Hue[
      NCache[
       Rational[3332, 4769], 0.6986789683371776]], AbsoluteThickness[0.25], 
     LineBox[{9996, 9997}]}, 
    {Hue[
      NCache[
       Rational[9997, 14307], 0.6987488641923534]], AbsoluteThickness[0.25], 
     LineBox[{9997, 9998}]}, 
    {Hue[
      NCache[
       Rational[9998, 14307], 0.6988187600475292]], AbsoluteThickness[0.25], 
     LineBox[{9998, 9999}]}, 
    {Hue[
      NCache[
       Rational[3333, 4769], 0.698888655902705]], AbsoluteThickness[0.25], 
     LineBox[{9999, 10000}]}, 
    {Hue[
      NCache[
       Rational[10000, 14307], 0.6989585517578808]], AbsoluteThickness[0.25], 
     LineBox[{10000, 10001}]}, 
    {Hue[
      NCache[
       Rational[10001, 14307], 0.6990284476130565]], AbsoluteThickness[0.25], 
     LineBox[{10001, 10002}]}, 
    {Hue[
      NCache[
       Rational[3334, 4769], 0.6990983434682323]], AbsoluteThickness[0.25], 
     LineBox[{10002, 10003}]}, 
    {Hue[
      NCache[
       Rational[10003, 14307], 0.6991682393234081]], AbsoluteThickness[0.25], 
     LineBox[{10003, 10004}]}, 
    {Hue[
      NCache[
       Rational[10004, 14307], 0.6992381351785839]], AbsoluteThickness[0.25], 
     LineBox[{10004, 10005}]}, 
    {Hue[
      NCache[
       Rational[3335, 4769], 0.6993080310337597]], AbsoluteThickness[0.25], 
     LineBox[{10005, 10006}]}, 
    {Hue[
      NCache[
       Rational[10006, 14307], 0.6993779268889355]], AbsoluteThickness[0.25], 
     LineBox[{10006, 10007}]}, 
    {Hue[
      NCache[
       Rational[10007, 14307], 0.6994478227441113]], AbsoluteThickness[0.25], 
     LineBox[{10007, 10008}]}, 
    {Hue[
      NCache[
       Rational[3336, 4769], 0.699517718599287]], AbsoluteThickness[0.25], 
     LineBox[{10008, 10009}]}, 
    {Hue[
      NCache[
       Rational[10009, 14307], 0.6995876144544628]], AbsoluteThickness[0.25], 
     LineBox[{10009, 10010}]}, 
    {Hue[
      NCache[
       Rational[10010, 14307], 0.6996575103096386]], AbsoluteThickness[0.25], 
     LineBox[{10010, 10011}]}, 
    {Hue[
      NCache[
       Rational[3337, 4769], 0.6997274061648144]], AbsoluteThickness[0.25], 
     LineBox[{10011, 10012}]}, 
    {Hue[
      NCache[
       Rational[10012, 14307], 0.6997973020199902]], AbsoluteThickness[0.25], 
     LineBox[{10012, 10013}]}, 
    {Hue[
      NCache[
       Rational[527, 753], 0.699867197875166]], AbsoluteThickness[0.25], 
     LineBox[{10013, 10014}]}, 
    {Hue[
      NCache[
       Rational[3338, 4769], 0.6999370937303417]], AbsoluteThickness[0.25], 
     LineBox[{10014, 10015}]}, 
    {Hue[
      NCache[
       Rational[10015, 14307], 0.7000069895855175]], AbsoluteThickness[0.25], 
     LineBox[{10015, 10016}]}, 
    {Hue[
      NCache[
       Rational[10016, 14307], 0.7000768854406934]], AbsoluteThickness[0.25], 
     LineBox[{10016, 10017}]}, 
    {Hue[
      NCache[
       Rational[3339, 4769], 0.7001467812958692]], AbsoluteThickness[0.25], 
     LineBox[{10017, 10018}]}, 
    {Hue[
      NCache[
       Rational[10018, 14307], 0.700216677151045]], AbsoluteThickness[0.25], 
     LineBox[{10018, 10019}]}, 
    {Hue[
      NCache[
       Rational[10019, 14307], 0.7002865730062208]], AbsoluteThickness[0.25], 
     LineBox[{10019, 10020}]}, 
    {Hue[
      NCache[
       Rational[3340, 4769], 0.7003564688613965]], AbsoluteThickness[0.25], 
     LineBox[{10020, 10021}]}, 
    {Hue[
      NCache[
       Rational[10021, 14307], 0.7004263647165723]], AbsoluteThickness[0.25], 
     LineBox[{10021, 10022}]}, 
    {Hue[
      NCache[
       Rational[10022, 14307], 0.7004962605717481]], AbsoluteThickness[0.25], 
     LineBox[{10022, 10023}]}, 
    {Hue[
      NCache[
       Rational[3341, 4769], 0.7005661564269239]], AbsoluteThickness[0.25], 
     LineBox[{10023, 10024}]}, 
    {Hue[
      NCache[
       Rational[10024, 14307], 0.7006360522820997]], AbsoluteThickness[0.25], 
     LineBox[{10024, 10025}]}, 
    {Hue[
      NCache[
       Rational[10025, 14307], 0.7007059481372755]], AbsoluteThickness[0.25], 
     LineBox[{10025, 10026}]}, 
    {Hue[
      NCache[
       Rational[3342, 4769], 0.7007758439924513]], AbsoluteThickness[0.25], 
     LineBox[{10026, 10027}]}, 
    {Hue[
      NCache[
       Rational[10027, 14307], 0.700845739847627]], AbsoluteThickness[0.25], 
     LineBox[{10027, 10028}]}, 
    {Hue[
      NCache[
       Rational[10028, 14307], 0.7009156357028028]], AbsoluteThickness[0.25], 
     LineBox[{10028, 10029}]}, 
    {Hue[
      NCache[
       Rational[3343, 4769], 0.7009855315579786]], AbsoluteThickness[0.25], 
     LineBox[{10029, 10030}]}, 
    {Hue[
      NCache[
       Rational[10030, 14307], 0.7010554274131544]], AbsoluteThickness[0.25], 
     LineBox[{10030, 10031}]}, 
    {Hue[
      NCache[
       Rational[10031, 14307], 0.7011253232683302]], AbsoluteThickness[0.25], 
     LineBox[{10031, 10032}]}, 
    {Hue[
      NCache[
       Rational[176, 251], 0.701195219123506]], AbsoluteThickness[0.25], 
     LineBox[{10032, 10033}]}, 
    {Hue[
      NCache[
       Rational[10033, 14307], 0.7012651149786817]], AbsoluteThickness[0.25], 
     LineBox[{10033, 10034}]}, 
    {Hue[
      NCache[
       Rational[10034, 14307], 0.7013350108338575]], AbsoluteThickness[0.25], 
     LineBox[{10034, 10035}]}, 
    {Hue[
      NCache[
       Rational[3345, 4769], 0.7014049066890333]], AbsoluteThickness[0.25], 
     LineBox[{10035, 10036}]}, 
    {Hue[
      NCache[
       Rational[10036, 14307], 0.7014748025442091]], AbsoluteThickness[0.25], 
     LineBox[{10036, 10037}]}, 
    {Hue[
      NCache[
       Rational[10037, 14307], 0.7015446983993849]], AbsoluteThickness[0.25], 
     LineBox[{10037, 10038}]}, 
    {Hue[
      NCache[
       Rational[3346, 4769], 0.7016145942545607]], AbsoluteThickness[0.25], 
     LineBox[{10038, 10039}]}, 
    {Hue[
      NCache[
       Rational[10039, 14307], 0.7016844901097365]], AbsoluteThickness[0.25], 
     LineBox[{10039, 10040}]}, 
    {Hue[
      NCache[
       Rational[40, 57], 0.7017543859649122]], AbsoluteThickness[0.25], 
     LineBox[{10040, 10041}]}, 
    {Hue[
      NCache[
       Rational[3347, 4769], 0.701824281820088]], AbsoluteThickness[0.25], 
     LineBox[{10041, 10042}]}, 
    {Hue[
      NCache[
       Rational[10042, 14307], 0.7018941776752639]], AbsoluteThickness[0.25], 
     LineBox[{10042, 10043}]}, 
    {Hue[
      NCache[
       Rational[10043, 14307], 0.7019640735304397]], AbsoluteThickness[0.25], 
     LineBox[{10043, 10044}]}, 
    {Hue[
      NCache[
       Rational[3348, 4769], 0.7020339693856155]], AbsoluteThickness[0.25], 
     LineBox[{10044, 10045}]}, 
    {Hue[
      NCache[
       Rational[10045, 14307], 0.7021038652407913]], AbsoluteThickness[0.25], 
     LineBox[{10045, 10046}]}, 
    {Hue[
      NCache[
       Rational[10046, 14307], 0.702173761095967]], AbsoluteThickness[0.25], 
     LineBox[{10046, 10047}]}, 
    {Hue[
      NCache[
       Rational[3349, 4769], 0.7022436569511428]], AbsoluteThickness[0.25], 
     LineBox[{10047, 10048}]}, 
    {Hue[
      NCache[
       Rational[10048, 14307], 0.7023135528063186]], AbsoluteThickness[0.25], 
     LineBox[{10048, 10049}]}, 
    {Hue[
      NCache[
       Rational[10049, 14307], 0.7023834486614944]], AbsoluteThickness[0.25], 
     LineBox[{10049, 10050}]}, 
    {Hue[
      NCache[
       Rational[3350, 4769], 0.7024533445166702]], AbsoluteThickness[0.25], 
     LineBox[{10050, 10051}]}, 
    {Hue[
      NCache[
       Rational[529, 753], 0.702523240371846]], AbsoluteThickness[0.25], 
     LineBox[{10051, 10052}]}, 
    {Hue[
      NCache[
       Rational[10052, 14307], 0.7025931362270217]], AbsoluteThickness[0.25], 
     LineBox[{10052, 10053}]}, 
    {Hue[
      NCache[
       Rational[3351, 4769], 0.7026630320821975]], AbsoluteThickness[0.25], 
     LineBox[{10053, 10054}]}, 
    {Hue[
      NCache[
       Rational[10054, 14307], 0.7027329279373733]], AbsoluteThickness[0.25], 
     LineBox[{10054, 10055}]}, 
    {Hue[
      NCache[
       Rational[10055, 14307], 0.7028028237925491]], AbsoluteThickness[0.25], 
     LineBox[{10055, 10056}]}, 
    {Hue[
      NCache[
       Rational[3352, 4769], 0.7028727196477249]], AbsoluteThickness[0.25], 
     LineBox[{10056, 10057}]}, 
    {Hue[
      NCache[
       Rational[10057, 14307], 0.7029426155029007]], AbsoluteThickness[0.25], 
     LineBox[{10057, 10058}]}, 
    {Hue[
      NCache[
       Rational[10058, 14307], 0.7030125113580765]], AbsoluteThickness[0.25], 
     LineBox[{10058, 10059}]}, 
    {Hue[
      NCache[
       Rational[3353, 4769], 0.7030824072132522]], AbsoluteThickness[0.25], 
     LineBox[{10059, 10060}]}, 
    {Hue[
      NCache[
       Rational[10060, 14307], 0.703152303068428]], AbsoluteThickness[0.25], 
     LineBox[{10060, 10061}]}, 
    {Hue[
      NCache[
       Rational[10061, 14307], 0.7032221989236038]], AbsoluteThickness[0.25], 
     LineBox[{10061, 10062}]}, 
    {Hue[
      NCache[
       Rational[3354, 4769], 0.7032920947787796]], AbsoluteThickness[0.25], 
     LineBox[{10062, 10063}]}, 
    {Hue[
      NCache[
       Rational[10063, 14307], 0.7033619906339554]], AbsoluteThickness[0.25], 
     LineBox[{10063, 10064}]}, 
    {Hue[
      NCache[
       Rational[10064, 14307], 0.7034318864891312]], AbsoluteThickness[0.25], 
     LineBox[{10064, 10065}]}, 
    {Hue[
      NCache[
       Rational[3355, 4769], 0.7035017823443069]], AbsoluteThickness[0.25], 
     LineBox[{10065, 10066}]}, 
    {Hue[
      NCache[
       Rational[10066, 14307], 0.7035716781994827]], AbsoluteThickness[0.25], 
     LineBox[{10066, 10067}]}, 
    {Hue[
      NCache[
       Rational[10067, 14307], 0.7036415740546585]], AbsoluteThickness[0.25], 
     LineBox[{10067, 10068}]}, 
    {Hue[
      NCache[
       Rational[3356, 4769], 0.7037114699098344]], AbsoluteThickness[0.25], 
     LineBox[{10068, 10069}]}, 
    {Hue[
      NCache[
       Rational[10069, 14307], 0.7037813657650102]], AbsoluteThickness[0.25], 
     LineBox[{10069, 10070}]}, 
    {Hue[
      NCache[
       Rational[530, 753], 0.703851261620186]], AbsoluteThickness[0.25], 
     LineBox[{10070, 10071}]}, 
    {Hue[
      NCache[
       Rational[3357, 4769], 0.7039211574753617]], AbsoluteThickness[0.25], 
     LineBox[{10071, 10072}]}, 
    {Hue[
      NCache[
       Rational[10072, 14307], 0.7039910533305375]], AbsoluteThickness[0.25], 
     LineBox[{10072, 10073}]}, 
    {Hue[
      NCache[
       Rational[10073, 14307], 0.7040609491857133]], AbsoluteThickness[0.25], 
     LineBox[{10073, 10074}]}, 
    {Hue[
      NCache[
       Rational[3358, 4769], 0.7041308450408891]], AbsoluteThickness[0.25], 
     LineBox[{10074, 10075}]}, 
    {Hue[
      NCache[
       Rational[10075, 14307], 0.7042007408960649]], AbsoluteThickness[0.25], 
     LineBox[{10075, 10076}]}, 
    {Hue[
      NCache[
       Rational[10076, 14307], 0.7042706367512407]], AbsoluteThickness[0.25], 
     LineBox[{10076, 10077}]}, 
    {Hue[
      NCache[
       Rational[3359, 4769], 0.7043405326064165]], AbsoluteThickness[0.25], 
     LineBox[{10077, 10078}]}, 
    {Hue[
      NCache[
       Rational[10078, 14307], 0.7044104284615922]], AbsoluteThickness[0.25], 
     LineBox[{10078, 10079}]}, 
    {Hue[
      NCache[
       Rational[10079, 14307], 0.704480324316768]], AbsoluteThickness[0.25], 
     LineBox[{10079, 10080}]}, 
    {Hue[
      NCache[
       Rational[3360, 4769], 0.7045502201719438]], AbsoluteThickness[0.25], 
     LineBox[{10080, 10081}]}, 
    {Hue[
      NCache[
       Rational[10081, 14307], 0.7046201160271196]], AbsoluteThickness[0.25], 
     LineBox[{10081, 10082}]}, 
    {Hue[
      NCache[
       Rational[10082, 14307], 0.7046900118822954]], AbsoluteThickness[0.25], 
     LineBox[{10082, 10083}]}, 
    {Hue[
      NCache[
       Rational[3361, 4769], 0.7047599077374712]], AbsoluteThickness[0.25], 
     LineBox[{10083, 10084}]}, 
    {Hue[
      NCache[
       Rational[10084, 14307], 0.7048298035926469]], AbsoluteThickness[0.25], 
     LineBox[{10084, 10085}]}, 
    {Hue[
      NCache[
       Rational[10085, 14307], 0.7048996994478227]], AbsoluteThickness[0.25], 
     LineBox[{10085, 10086}]}, 
    {Hue[
      NCache[
       Rational[3362, 4769], 0.7049695953029985]], AbsoluteThickness[0.25], 
     LineBox[{10086, 10087}]}, 
    {Hue[
      NCache[
       Rational[10087, 14307], 0.7050394911581743]], AbsoluteThickness[0.25], 
     LineBox[{10087, 10088}]}, 
    {Hue[
      NCache[
       Rational[10088, 14307], 0.7051093870133501]], AbsoluteThickness[0.25], 
     LineBox[{10088, 10089}]}, 
    {Hue[
      NCache[
       Rational[177, 251], 0.7051792828685259]], AbsoluteThickness[0.25], 
     LineBox[{10089, 10090}]}, 
    {Hue[
      NCache[
       Rational[10090, 14307], 0.7052491787237016]], AbsoluteThickness[0.25], 
     LineBox[{10090, 10091}]}, 
    {Hue[
      NCache[
       Rational[10091, 14307], 0.7053190745788774]], AbsoluteThickness[0.25], 
     LineBox[{10091, 10092}]}, 
    {Hue[
      NCache[
       Rational[3364, 4769], 0.7053889704340532]], AbsoluteThickness[0.25], 
     LineBox[{10092, 10093}]}, 
    {Hue[
      NCache[
       Rational[10093, 14307], 0.705458866289229]], AbsoluteThickness[0.25], 
     LineBox[{10093, 10094}]}, 
    {Hue[
      NCache[
       Rational[10094, 14307], 0.7055287621444049]], AbsoluteThickness[0.25], 
     LineBox[{10094, 10095}]}, 
    {Hue[
      NCache[
       Rational[3365, 4769], 0.7055986579995807]], AbsoluteThickness[0.25], 
     LineBox[{10095, 10096}]}, 
    {Hue[
      NCache[
       Rational[10096, 14307], 0.7056685538547565]], AbsoluteThickness[0.25], 
     LineBox[{10096, 10097}]}, 
    {Hue[
      NCache[
       Rational[10097, 14307], 0.7057384497099322]], AbsoluteThickness[0.25], 
     LineBox[{10097, 10098}]}, 
    {Hue[
      NCache[
       Rational[3366, 4769], 0.705808345565108]], AbsoluteThickness[0.25], 
     LineBox[{10098, 10099}]}, 
    {Hue[
      NCache[
       Rational[10099, 14307], 0.7058782414202838]], AbsoluteThickness[0.25], 
     LineBox[{10099, 10100}]}, 
    {Hue[
      NCache[
       Rational[10100, 14307], 0.7059481372754596]], AbsoluteThickness[0.25], 
     LineBox[{10100, 10101}]}, 
    {Hue[
      NCache[
       Rational[3367, 4769], 0.7060180331306354]], AbsoluteThickness[0.25], 
     LineBox[{10101, 10102}]}, 
    {Hue[
      NCache[
       Rational[10102, 14307], 0.7060879289858112]], AbsoluteThickness[0.25], 
     LineBox[{10102, 10103}]}, 
    {Hue[
      NCache[
       Rational[10103, 14307], 0.7061578248409869]], AbsoluteThickness[0.25], 
     LineBox[{10103, 10104}]}, 
    {Hue[
      NCache[
       Rational[3368, 4769], 0.7062277206961627]], AbsoluteThickness[0.25], 
     LineBox[{10104, 10105}]}, 
    {Hue[
      NCache[
       Rational[10105, 14307], 0.7062976165513385]], AbsoluteThickness[0.25], 
     LineBox[{10105, 10106}]}, 
    {Hue[
      NCache[
       Rational[10106, 14307], 0.7063675124065143]], AbsoluteThickness[0.25], 
     LineBox[{10106, 10107}]}, 
    {Hue[
      NCache[
       Rational[3369, 4769], 0.7064374082616901]], AbsoluteThickness[0.25], 
     LineBox[{10107, 10108}]}, 
    {Hue[
      NCache[
       Rational[532, 753], 0.7065073041168659]], AbsoluteThickness[0.25], 
     LineBox[{10108, 10109}]}, 
    {Hue[
      NCache[
       Rational[10109, 14307], 0.7065771999720416]], AbsoluteThickness[0.25], 
     LineBox[{10109, 10110}]}, 
    {Hue[
      NCache[
       Rational[3370, 4769], 0.7066470958272174]], AbsoluteThickness[0.25], 
     LineBox[{10110, 10111}]}, 
    {Hue[
      NCache[
       Rational[10111, 14307], 0.7067169916823932]], AbsoluteThickness[0.25], 
     LineBox[{10111, 10112}]}, 
    {Hue[
      NCache[
       Rational[10112, 14307], 0.706786887537569]], AbsoluteThickness[0.25], 
     LineBox[{10112, 10113}]}, 
    {Hue[
      NCache[
       Rational[3371, 4769], 0.7068567833927448]], AbsoluteThickness[0.25], 
     LineBox[{10113, 10114}]}, 
    {Hue[
      NCache[
       Rational[10114, 14307], 0.7069266792479206]], AbsoluteThickness[0.25], 
     LineBox[{10114, 10115}]}, 
    {Hue[
      NCache[
       Rational[10115, 14307], 0.7069965751030964]], AbsoluteThickness[0.25], 
     LineBox[{10115, 10116}]}, 
    {Hue[
      NCache[
       Rational[3372, 4769], 0.7070664709582721]], AbsoluteThickness[0.25], 
     LineBox[{10116, 10117}]}, 
    {Hue[
      NCache[
       Rational[10117, 14307], 0.7071363668134479]], AbsoluteThickness[0.25], 
     LineBox[{10117, 10118}]}, 
    {Hue[
      NCache[
       Rational[10118, 14307], 0.7072062626686237]], AbsoluteThickness[0.25], 
     LineBox[{10118, 10119}]}, 
    {Hue[
      NCache[
       Rational[3373, 4769], 0.7072761585237995]], AbsoluteThickness[0.25], 
     LineBox[{10119, 10120}]}, 
    {Hue[
      NCache[
       Rational[10120, 14307], 0.7073460543789754]], AbsoluteThickness[0.25], 
     LineBox[{10120, 10121}]}, 
    {Hue[
      NCache[
       Rational[10121, 14307], 0.7074159502341512]], AbsoluteThickness[0.25], 
     LineBox[{10121, 10122}]}, 
    {Hue[
      NCache[
       Rational[3374, 4769], 0.7074858460893269]], AbsoluteThickness[0.25], 
     LineBox[{10122, 10123}]}, 
    {Hue[
      NCache[
       Rational[10123, 14307], 0.7075557419445027]], AbsoluteThickness[0.25], 
     LineBox[{10123, 10124}]}, 
    {Hue[
      NCache[
       Rational[10124, 14307], 0.7076256377996785]], AbsoluteThickness[0.25], 
     LineBox[{10124, 10125}]}, 
    {Hue[
      NCache[
       Rational[3375, 4769], 0.7076955336548543]], AbsoluteThickness[0.25], 
     LineBox[{10125, 10126}]}, 
    {Hue[
      NCache[
       Rational[10126, 14307], 0.7077654295100301]], AbsoluteThickness[0.25], 
     LineBox[{10126, 10127}]}, 
    {Hue[
      NCache[
       Rational[533, 753], 0.7078353253652059]], AbsoluteThickness[0.25], 
     LineBox[{10127, 10128}]}, 
    {Hue[
      NCache[
       Rational[3376, 4769], 0.7079052212203817]], AbsoluteThickness[0.25], 
     LineBox[{10128, 10129}]}, 
    {Hue[
      NCache[
       Rational[10129, 14307], 0.7079751170755574]], AbsoluteThickness[0.25], 
     LineBox[{10129, 10130}]}, 
    {Hue[
      NCache[
       Rational[10130, 14307], 0.7080450129307332]], AbsoluteThickness[0.25], 
     LineBox[{10130, 10131}]}, 
    {Hue[
      NCache[
       Rational[3377, 4769], 0.708114908785909]], AbsoluteThickness[0.25], 
     LineBox[{10131, 10132}]}, 
    {Hue[
      NCache[
       Rational[10132, 14307], 0.7081848046410848]], AbsoluteThickness[0.25], 
     LineBox[{10132, 10133}]}, 
    {Hue[
      NCache[
       Rational[10133, 14307], 0.7082547004962606]], AbsoluteThickness[0.25], 
     LineBox[{10133, 10134}]}, 
    {Hue[
      NCache[
       Rational[3378, 4769], 0.7083245963514364]], AbsoluteThickness[0.25], 
     LineBox[{10134, 10135}]}, 
    {Hue[
      NCache[
       Rational[10135, 14307], 0.7083944922066121]], AbsoluteThickness[0.25], 
     LineBox[{10135, 10136}]}, 
    {Hue[
      NCache[
       Rational[10136, 14307], 0.7084643880617879]], AbsoluteThickness[0.25], 
     LineBox[{10136, 10137}]}, 
    {Hue[
      NCache[
       Rational[3379, 4769], 0.7085342839169637]], AbsoluteThickness[0.25], 
     LineBox[{10137, 10138}]}, 
    {Hue[
      NCache[
       Rational[10138, 14307], 0.7086041797721395]], AbsoluteThickness[0.25], 
     LineBox[{10138, 10139}]}, 
    {Hue[
      NCache[
       Rational[10139, 14307], 0.7086740756273153]], AbsoluteThickness[0.25], 
     LineBox[{10139, 10140}]}, 
    {Hue[
      NCache[
       Rational[3380, 4769], 0.7087439714824911]], AbsoluteThickness[0.25], 
     LineBox[{10140, 10141}]}, 
    {Hue[
      NCache[
       Rational[10141, 14307], 0.7088138673376668]], AbsoluteThickness[0.25], 
     LineBox[{10141, 10142}]}, 
    {Hue[
      NCache[
       Rational[10142, 14307], 0.7088837631928426]], AbsoluteThickness[0.25], 
     LineBox[{10142, 10143}]}, 
    {Hue[
      NCache[
       Rational[3381, 4769], 0.7089536590480184]], AbsoluteThickness[0.25], 
     LineBox[{10143, 10144}]}, 
    {Hue[
      NCache[
       Rational[10144, 14307], 0.7090235549031942]], AbsoluteThickness[0.25], 
     LineBox[{10144, 10145}]}, 
    {Hue[
      NCache[
       Rational[10145, 14307], 0.70909345075837]], AbsoluteThickness[0.25], 
     LineBox[{10145, 10146}]}, 
    {Hue[
      NCache[
       Rational[178, 251], 0.7091633466135459]], AbsoluteThickness[0.25], 
     LineBox[{10146, 10147}]}, 
    {Hue[
      NCache[
       Rational[10147, 14307], 0.7092332424687217]], AbsoluteThickness[0.25], 
     LineBox[{10147, 10148}]}, 
    {Hue[
      NCache[
       Rational[10148, 14307], 0.7093031383238974]], AbsoluteThickness[0.25], 
     LineBox[{10148, 10149}]}, 
    {Hue[
      NCache[
       Rational[3383, 4769], 0.7093730341790732]], AbsoluteThickness[0.25], 
     LineBox[{10149, 10150}]}, 
    {Hue[
      NCache[
       Rational[10150, 14307], 0.709442930034249]], AbsoluteThickness[0.25], 
     LineBox[{10150, 10151}]}, 
    {Hue[
      NCache[
       Rational[10151, 14307], 0.7095128258894248]], AbsoluteThickness[0.25], 
     LineBox[{10151, 10152}]}, 
    {Hue[
      NCache[
       Rational[3384, 4769], 0.7095827217446006]], AbsoluteThickness[0.25], 
     LineBox[{10152, 10153}]}, 
    {Hue[
      NCache[
       Rational[10153, 14307], 0.7096526175997764]], AbsoluteThickness[0.25], 
     LineBox[{10153, 10154}]}, 
    {Hue[
      NCache[
       Rational[10154, 14307], 0.7097225134549521]], AbsoluteThickness[0.25], 
     LineBox[{10154, 10155}]}, 
    {Hue[
      NCache[
       Rational[3385, 4769], 0.7097924093101279]], AbsoluteThickness[0.25], 
     LineBox[{10155, 10156}]}, 
    {Hue[
      NCache[
       Rational[10156, 14307], 0.7098623051653037]], AbsoluteThickness[0.25], 
     LineBox[{10156, 10157}]}, 
    {Hue[
      NCache[
       Rational[10157, 14307], 0.7099322010204795]], AbsoluteThickness[0.25], 
     LineBox[{10157, 10158}]}, 
    {Hue[
      NCache[
       Rational[3386, 4769], 0.7100020968756553]], AbsoluteThickness[0.25], 
     LineBox[{10158, 10159}]}, 
    {Hue[
      NCache[
       Rational[10159, 14307], 0.7100719927308311]], AbsoluteThickness[0.25], 
     LineBox[{10159, 10160}]}, 
    {Hue[
      NCache[
       Rational[10160, 14307], 0.7101418885860068]], AbsoluteThickness[0.25], 
     LineBox[{10160, 10161}]}, 
    {Hue[
      NCache[
       Rational[3387, 4769], 0.7102117844411826]], AbsoluteThickness[0.25], 
     LineBox[{10161, 10162}]}, 
    {Hue[
      NCache[
       Rational[10162, 14307], 0.7102816802963584]], AbsoluteThickness[0.25], 
     LineBox[{10162, 10163}]}, 
    {Hue[
      NCache[
       Rational[10163, 14307], 0.7103515761515342]], AbsoluteThickness[0.25], 
     LineBox[{10163, 10164}]}, 
    {Hue[
      NCache[
       Rational[3388, 4769], 0.71042147200671]], AbsoluteThickness[0.25], 
     LineBox[{10164, 10165}]}, 
    {Hue[
      NCache[
       Rational[535, 753], 0.7104913678618858]], AbsoluteThickness[0.25], 
     LineBox[{10165, 10166}]}, 
    {Hue[
      NCache[
       Rational[10166, 14307], 0.7105612637170616]], AbsoluteThickness[0.25], 
     LineBox[{10166, 10167}]}, 
    {Hue[
      NCache[
       Rational[3389, 4769], 0.7106311595722373]], AbsoluteThickness[0.25], 
     LineBox[{10167, 10168}]}, 
    {Hue[
      NCache[
       Rational[10168, 14307], 0.7107010554274131]], AbsoluteThickness[0.25], 
     LineBox[{10168, 10169}]}, 
    {Hue[
      NCache[
       Rational[10169, 14307], 0.7107709512825889]], AbsoluteThickness[0.25], 
     LineBox[{10169, 10170}]}, 
    {Hue[
      NCache[
       Rational[3390, 4769], 0.7108408471377647]], AbsoluteThickness[0.25], 
     LineBox[{10170, 10171}]}, 
    {Hue[
      NCache[
       Rational[10171, 14307], 0.7109107429929405]], AbsoluteThickness[0.25], 
     LineBox[{10171, 10172}]}, 
    {Hue[
      NCache[
       Rational[10172, 14307], 0.7109806388481164]], AbsoluteThickness[0.25], 
     LineBox[{10172, 10173}]}, 
    {Hue[
      NCache[
       Rational[3391, 4769], 0.711050534703292]], AbsoluteThickness[0.25], 
     LineBox[{10173, 10174}]}, 
    {Hue[
      NCache[
       Rational[10174, 14307], 0.7111204305584679]], AbsoluteThickness[0.25], 
     LineBox[{10174, 10175}]}, 
    {Hue[
      NCache[
       Rational[10175, 14307], 0.7111903264136437]], AbsoluteThickness[0.25], 
     LineBox[{10175, 10176}]}, 
    {Hue[
      NCache[
       Rational[3392, 4769], 0.7112602222688195]], AbsoluteThickness[0.25], 
     LineBox[{10176, 10177}]}, 
    {Hue[
      NCache[
       Rational[10177, 14307], 0.7113301181239953]], AbsoluteThickness[0.25], 
     LineBox[{10177, 10178}]}, 
    {Hue[
      NCache[
       Rational[10178, 14307], 0.7114000139791711]], AbsoluteThickness[0.25], 
     LineBox[{10178, 10179}]}, 
    {Hue[
      NCache[
       Rational[3393, 4769], 0.7114699098343468]], AbsoluteThickness[0.25], 
     LineBox[{10179, 10180}]}, 
    {Hue[
      NCache[
       Rational[10180, 14307], 0.7115398056895226]], AbsoluteThickness[0.25], 
     LineBox[{10180, 10181}]}, 
    {Hue[
      NCache[
       Rational[10181, 14307], 0.7116097015446984]], AbsoluteThickness[0.25], 
     LineBox[{10181, 10182}]}, 
    {Hue[
      NCache[
       Rational[3394, 4769], 0.7116795973998742]], AbsoluteThickness[0.25], 
     LineBox[{10182, 10183}]}, 
    {Hue[
      NCache[
       Rational[10183, 14307], 0.71174949325505]], AbsoluteThickness[0.25], 
     LineBox[{10183, 10184}]}, 
    {Hue[
      NCache[
       Rational[536, 753], 0.7118193891102258]], AbsoluteThickness[0.25], 
     LineBox[{10184, 10185}]}, 
    {Hue[
      NCache[
       Rational[3395, 4769], 0.7118892849654016]], AbsoluteThickness[0.25], 
     LineBox[{10185, 10186}]}, 
    {Hue[
      NCache[
       Rational[10186, 14307], 0.7119591808205773]], AbsoluteThickness[0.25], 
     LineBox[{10186, 10187}]}, 
    {Hue[
      NCache[
       Rational[10187, 14307], 0.7120290766757531]], AbsoluteThickness[0.25], 
     LineBox[{10187, 10188}]}, 
    {Hue[
      NCache[
       Rational[3396, 4769], 0.7120989725309289]], AbsoluteThickness[0.25], 
     LineBox[{10188, 10189}]}, 
    {Hue[
      NCache[
       Rational[10189, 14307], 0.7121688683861047]], AbsoluteThickness[0.25], 
     LineBox[{10189, 10190}]}, 
    {Hue[
      NCache[
       Rational[10190, 14307], 0.7122387642412805]], AbsoluteThickness[0.25], 
     LineBox[{10190, 10191}]}, 
    {Hue[
      NCache[
       Rational[3397, 4769], 0.7123086600964563]], AbsoluteThickness[0.25], 
     LineBox[{10191, 10192}]}, 
    {Hue[
      NCache[
       Rational[10192, 14307], 0.712378555951632]], AbsoluteThickness[0.25], 
     LineBox[{10192, 10193}]}, 
    {Hue[
      NCache[
       Rational[10193, 14307], 0.7124484518068078]], AbsoluteThickness[0.25], 
     LineBox[{10193, 10194}]}, 
    {Hue[
      NCache[
       Rational[3398, 4769], 0.7125183476619836]], AbsoluteThickness[0.25], 
     LineBox[{10194, 10195}]}, 
    {Hue[
      NCache[
       Rational[10195, 14307], 0.7125882435171594]], AbsoluteThickness[0.25], 
     LineBox[{10195, 10196}]}, 
    {Hue[
      NCache[
       Rational[10196, 14307], 0.7126581393723352]], AbsoluteThickness[0.25], 
     LineBox[{10196, 10197}]}, 
    {Hue[
      NCache[
       Rational[3399, 4769], 0.712728035227511]], AbsoluteThickness[0.25], 
     LineBox[{10197, 10198}]}, 
    {Hue[
      NCache[
       Rational[10198, 14307], 0.7127979310826867]], AbsoluteThickness[0.25], 
     LineBox[{10198, 10199}]}, 
    {Hue[
      NCache[
       Rational[10199, 14307], 0.7128678269378625]], AbsoluteThickness[0.25], 
     LineBox[{10199, 10200}]}, 
    {Hue[
      NCache[
       Rational[3400, 4769], 0.7129377227930384]], AbsoluteThickness[0.25], 
     LineBox[{10200, 10201}]}, 
    {Hue[
      NCache[
       Rational[10201, 14307], 0.7130076186482142]], AbsoluteThickness[0.25], 
     LineBox[{10201, 10202}]}, 
    {Hue[
      NCache[
       Rational[10202, 14307], 0.71307751450339]], AbsoluteThickness[0.25], 
     LineBox[{10202, 10203}]}, 
    {Hue[
      NCache[
       Rational[179, 251], 0.7131474103585658]], AbsoluteThickness[0.25], 
     LineBox[{10203, 10204}]}, 
    {Hue[
      NCache[
       Rational[10204, 14307], 0.7132173062137416]], AbsoluteThickness[0.25], 
     LineBox[{10204, 10205}]}, 
    {Hue[
      NCache[
       Rational[10205, 14307], 0.7132872020689173]], AbsoluteThickness[0.25], 
     LineBox[{10205, 10206}]}, 
    {Hue[
      NCache[
       Rational[3402, 4769], 0.7133570979240931]], AbsoluteThickness[0.25], 
     LineBox[{10206, 10207}]}, 
    {Hue[
      NCache[
       Rational[10207, 14307], 0.7134269937792689]], AbsoluteThickness[0.25], 
     LineBox[{10207, 10208}]}, 
    {Hue[
      NCache[
       Rational[10208, 14307], 0.7134968896344447]], AbsoluteThickness[0.25], 
     LineBox[{10208, 10209}]}, 
    {Hue[
      NCache[
       Rational[3403, 4769], 0.7135667854896205]], AbsoluteThickness[0.25], 
     LineBox[{10209, 10210}]}, 
    {Hue[
      NCache[
       Rational[10210, 14307], 0.7136366813447963]], AbsoluteThickness[0.25], 
     LineBox[{10210, 10211}]}, 
    {Hue[
      NCache[
       Rational[10211, 14307], 0.713706577199972]], AbsoluteThickness[0.25], 
     LineBox[{10211, 10212}]}, 
    {Hue[
      NCache[
       Rational[3404, 4769], 0.7137764730551478]], AbsoluteThickness[0.25], 
     LineBox[{10212, 10213}]}, 
    {Hue[
      NCache[
       Rational[10213, 14307], 0.7138463689103236]], AbsoluteThickness[0.25], 
     LineBox[{10213, 10214}]}, 
    {Hue[
      NCache[
       Rational[10214, 14307], 0.7139162647654994]], AbsoluteThickness[0.25], 
     LineBox[{10214, 10215}]}, 
    {Hue[
      NCache[
       Rational[3405, 4769], 0.7139861606206752]], AbsoluteThickness[0.25], 
     LineBox[{10215, 10216}]}, 
    {Hue[
      NCache[
       Rational[10216, 14307], 0.714056056475851]], AbsoluteThickness[0.25], 
     LineBox[{10216, 10217}]}, 
    {Hue[
      NCache[
       Rational[10217, 14307], 0.7141259523310268]], AbsoluteThickness[0.25], 
     LineBox[{10217, 10218}]}, 
    {Hue[
      NCache[
       Rational[3406, 4769], 0.7141958481862025]], AbsoluteThickness[0.25], 
     LineBox[{10218, 10219}]}, 
    {Hue[
      NCache[
       Rational[10219, 14307], 0.7142657440413783]], AbsoluteThickness[0.25], 
     LineBox[{10219, 10220}]}, 
    {Hue[
      NCache[
       Rational[10220, 14307], 0.7143356398965541]], AbsoluteThickness[0.25], 
     LineBox[{10220, 10221}]}, 
    {Hue[
      NCache[
       Rational[3407, 4769], 0.7144055357517299]], AbsoluteThickness[0.25], 
     LineBox[{10221, 10222}]}, 
    {Hue[
      NCache[
       Rational[538, 753], 0.7144754316069057]], AbsoluteThickness[0.25], 
     LineBox[{10222, 10223}]}, 
    {Hue[
      NCache[
       Rational[10223, 14307], 0.7145453274620815]], AbsoluteThickness[0.25], 
     LineBox[{10223, 10224}]}, 
    {Hue[
      NCache[
       Rational[3408, 4769], 0.7146152233172572]], AbsoluteThickness[0.25], 
     LineBox[{10224, 10225}]}, 
    {Hue[
      NCache[
       Rational[10225, 14307], 0.714685119172433]], AbsoluteThickness[0.25], 
     LineBox[{10225, 10226}]}, 
    {Hue[
      NCache[
       Rational[10226, 14307], 0.7147550150276089]], AbsoluteThickness[0.25], 
     LineBox[{10226, 10227}]}, 
    {Hue[
      NCache[
       Rational[3409, 4769], 0.7148249108827847]], AbsoluteThickness[0.25], 
     LineBox[{10227, 10228}]}, 
    {Hue[
      NCache[
       Rational[10228, 14307], 0.7148948067379605]], AbsoluteThickness[0.25], 
     LineBox[{10228, 10229}]}, 
    {Hue[
      NCache[
       Rational[10229, 14307], 0.7149647025931363]], AbsoluteThickness[0.25], 
     LineBox[{10229, 10230}]}, 
    {Hue[
      NCache[
       Rational[3410, 4769], 0.715034598448312]], AbsoluteThickness[0.25], 
     LineBox[{10230, 10231}]}, 
    {Hue[
      NCache[
       Rational[10231, 14307], 0.7151044943034878]], AbsoluteThickness[0.25], 
     LineBox[{10231, 10232}]}, 
    {Hue[
      NCache[
       Rational[10232, 14307], 0.7151743901586636]], AbsoluteThickness[0.25], 
     LineBox[{10232, 10233}]}, 
    {Hue[
      NCache[
       Rational[3411, 4769], 0.7152442860138394]], AbsoluteThickness[0.25], 
     LineBox[{10233, 10234}]}, 
    {Hue[
      NCache[
       Rational[10234, 14307], 0.7153141818690152]], AbsoluteThickness[0.25], 
     LineBox[{10234, 10235}]}, 
    {Hue[
      NCache[
       Rational[10235, 14307], 0.715384077724191]], AbsoluteThickness[0.25], 
     LineBox[{10235, 10236}]}, 
    {Hue[
      NCache[
       Rational[3412, 4769], 0.7154539735793668]], AbsoluteThickness[0.25], 
     LineBox[{10236, 10237}]}, 
    {Hue[
      NCache[
       Rational[10237, 14307], 0.7155238694345425]], AbsoluteThickness[0.25], 
     LineBox[{10237, 10238}]}, 
    {Hue[
      NCache[
       Rational[10238, 14307], 0.7155937652897183]], AbsoluteThickness[0.25], 
     LineBox[{10238, 10239}]}, 
    {Hue[
      NCache[
       Rational[3413, 4769], 0.7156636611448941]], AbsoluteThickness[0.25], 
     LineBox[{10239, 10240}]}, 
    {Hue[
      NCache[
       Rational[10240, 14307], 0.7157335570000699]], AbsoluteThickness[0.25], 
     LineBox[{10240, 10241}]}, 
    {Hue[
      NCache[
       Rational[539, 753], 0.7158034528552457]], AbsoluteThickness[0.25], 
     LineBox[{10241, 10242}]}, 
    {Hue[
      NCache[
       Rational[3414, 4769], 0.7158733487104215]], AbsoluteThickness[0.25], 
     LineBox[{10242, 10243}]}, 
    {Hue[
      NCache[
       Rational[10243, 14307], 0.7159432445655972]], AbsoluteThickness[0.25], 
     LineBox[{10243, 10244}]}, 
    {Hue[
      NCache[
       Rational[10244, 14307], 0.716013140420773]], AbsoluteThickness[0.25], 
     LineBox[{10244, 10245}]}, 
    {Hue[
      NCache[
       Rational[3415, 4769], 0.7160830362759488]], AbsoluteThickness[0.25], 
     LineBox[{10245, 10246}]}, 
    {Hue[
      NCache[
       Rational[10246, 14307], 0.7161529321311246]], AbsoluteThickness[0.25], 
     LineBox[{10246, 10247}]}, 
    {Hue[
      NCache[
       Rational[10247, 14307], 0.7162228279863004]], AbsoluteThickness[0.25], 
     LineBox[{10247, 10248}]}, 
    {Hue[
      NCache[
       Rational[3416, 4769], 0.7162927238414762]], AbsoluteThickness[0.25], 
     LineBox[{10248, 10249}]}, 
    {Hue[
      NCache[
       Rational[10249, 14307], 0.7163626196966519]], AbsoluteThickness[0.25], 
     LineBox[{10249, 10250}]}, 
    {Hue[
      NCache[
       Rational[10250, 14307], 0.7164325155518277]], AbsoluteThickness[0.25], 
     LineBox[{10250, 10251}]}, 
    {Hue[
      NCache[
       Rational[3417, 4769], 0.7165024114070035]], AbsoluteThickness[0.25], 
     LineBox[{10251, 10252}]}, 
    {Hue[
      NCache[
       Rational[10252, 14307], 0.7165723072621794]], AbsoluteThickness[0.25], 
     LineBox[{10252, 10253}]}, 
    {Hue[
      NCache[
       Rational[10253, 14307], 0.7166422031173552]], AbsoluteThickness[0.25], 
     LineBox[{10253, 10254}]}, 
    {Hue[
      NCache[
       Rational[3418, 4769], 0.716712098972531]], AbsoluteThickness[0.25], 
     LineBox[{10254, 10255}]}, 
    {Hue[
      NCache[
       Rational[10255, 14307], 0.7167819948277068]], AbsoluteThickness[0.25], 
     LineBox[{10255, 10256}]}, 
    {Hue[
      NCache[
       Rational[10256, 14307], 0.7168518906828825]], AbsoluteThickness[0.25], 
     LineBox[{10256, 10257}]}, 
    {Hue[
      NCache[
       Rational[3419, 4769], 0.7169217865380583]], AbsoluteThickness[0.25], 
     LineBox[{10257, 10258}]}, 
    {Hue[
      NCache[
       Rational[10258, 14307], 0.7169916823932341]], AbsoluteThickness[0.25], 
     LineBox[{10258, 10259}]}, 
    {Hue[
      NCache[
       Rational[10259, 14307], 0.7170615782484099]], AbsoluteThickness[0.25], 
     LineBox[{10259, 10260}]}, 
    {Hue[
      NCache[
       Rational[180, 251], 0.7171314741035857]], AbsoluteThickness[0.25], 
     LineBox[{10260, 10261}]}, 
    {Hue[
      NCache[
       Rational[10261, 14307], 0.7172013699587615]], AbsoluteThickness[0.25], 
     LineBox[{10261, 10262}]}, 
    {Hue[
      NCache[
       Rational[10262, 14307], 0.7172712658139372]], AbsoluteThickness[0.25], 
     LineBox[{10262, 10263}]}, 
    {Hue[
      NCache[
       Rational[3421, 4769], 0.717341161669113]], AbsoluteThickness[0.25], 
     LineBox[{10263, 10264}]}, 
    {Hue[
      NCache[
       Rational[10264, 14307], 0.7174110575242888]], AbsoluteThickness[0.25], 
     LineBox[{10264, 10265}]}, 
    {Hue[
      NCache[
       Rational[10265, 14307], 0.7174809533794646]], AbsoluteThickness[0.25], 
     LineBox[{10265, 10266}]}, 
    {Hue[
      NCache[
       Rational[3422, 4769], 0.7175508492346404]], AbsoluteThickness[0.25], 
     LineBox[{10266, 10267}]}, 
    {Hue[
      NCache[
       Rational[10267, 14307], 0.7176207450898162]], AbsoluteThickness[0.25], 
     LineBox[{10267, 10268}]}, 
    {Hue[
      NCache[
       Rational[10268, 14307], 0.7176906409449919]], AbsoluteThickness[0.25], 
     LineBox[{10268, 10269}]}, 
    {Hue[
      NCache[
       Rational[3423, 4769], 0.7177605368001677]], AbsoluteThickness[0.25], 
     LineBox[{10269, 10270}]}, 
    {Hue[
      NCache[
       Rational[10270, 14307], 0.7178304326553435]], AbsoluteThickness[0.25], 
     LineBox[{10270, 10271}]}, 
    {Hue[
      NCache[
       Rational[10271, 14307], 0.7179003285105193]], AbsoluteThickness[0.25], 
     LineBox[{10271, 10272}]}, 
    {Hue[
      NCache[
       Rational[3424, 4769], 0.7179702243656951]], AbsoluteThickness[0.25], 
     LineBox[{10272, 10273}]}, 
    {Hue[
      NCache[
       Rational[10273, 14307], 0.7180401202208709]], AbsoluteThickness[0.25], 
     LineBox[{10273, 10274}]}, 
    {Hue[
      NCache[
       Rational[10274, 14307], 0.7181100160760467]], AbsoluteThickness[0.25], 
     LineBox[{10274, 10275}]}, 
    {Hue[
      NCache[
       Rational[3425, 4769], 0.7181799119312224]], AbsoluteThickness[0.25], 
     LineBox[{10275, 10276}]}, 
    {Hue[
      NCache[
       Rational[10276, 14307], 0.7182498077863982]], AbsoluteThickness[0.25], 
     LineBox[{10276, 10277}]}, 
    {Hue[
      NCache[
       Rational[10277, 14307], 0.718319703641574]], AbsoluteThickness[0.25], 
     LineBox[{10277, 10278}]}, 
    {Hue[
      NCache[
       Rational[3426, 4769], 0.7183895994967499]], AbsoluteThickness[0.25], 
     LineBox[{10278, 10279}]}, 
    {Hue[
      NCache[
       Rational[541, 753], 0.7184594953519257]], AbsoluteThickness[0.25], 
     LineBox[{10279, 10280}]}, 
    {Hue[
      NCache[
       Rational[10280, 14307], 0.7185293912071015]], AbsoluteThickness[0.25], 
     LineBox[{10280, 10281}]}, 
    {Hue[
      NCache[
       Rational[3427, 4769], 0.7185992870622772]], AbsoluteThickness[0.25], 
     LineBox[{10281, 10282}]}, 
    {Hue[
      NCache[
       Rational[10282, 14307], 0.718669182917453]], AbsoluteThickness[0.25], 
     LineBox[{10282, 10283}]}, 
    {Hue[
      NCache[
       Rational[10283, 14307], 0.7187390787726288]], AbsoluteThickness[0.25], 
     LineBox[{10283, 10284}]}, 
    {Hue[
      NCache[
       Rational[3428, 4769], 0.7188089746278046]], AbsoluteThickness[0.25], 
     LineBox[{10284, 10285}]}, 
    {Hue[
      NCache[
       Rational[10285, 14307], 0.7188788704829804]], AbsoluteThickness[0.25], 
     LineBox[{10285, 10286}]}, 
    {Hue[
      NCache[
       Rational[10286, 14307], 0.7189487663381562]], AbsoluteThickness[0.25], 
     LineBox[{10286, 10287}]}, 
    {Hue[
      NCache[
       Rational[3429, 4769], 0.7190186621933319]], AbsoluteThickness[0.25], 
     LineBox[{10287, 10288}]}, 
    {Hue[
      NCache[
       Rational[10288, 14307], 0.7190885580485077]], AbsoluteThickness[0.25], 
     LineBox[{10288, 10289}]}, 
    {Hue[
      NCache[
       Rational[10289, 14307], 0.7191584539036835]], AbsoluteThickness[0.25], 
     LineBox[{10289, 10290}]}, 
    {Hue[
      NCache[
       Rational[3430, 4769], 0.7192283497588593]], AbsoluteThickness[0.25], 
     LineBox[{10290, 10291}]}, 
    {Hue[
      NCache[
       Rational[41, 57], 0.7192982456140351]], AbsoluteThickness[0.25], 
     LineBox[{10291, 10292}]}, 
    {Hue[
      NCache[
       Rational[10292, 14307], 0.7193681414692109]], AbsoluteThickness[0.25], 
     LineBox[{10292, 10293}]}, 
    {Hue[
      NCache[
       Rational[3431, 4769], 0.7194380373243867]], AbsoluteThickness[0.25], 
     LineBox[{10293, 10294}]}, 
    {Hue[
      NCache[
       Rational[10294, 14307], 0.7195079331795624]], AbsoluteThickness[0.25], 
     LineBox[{10294, 10295}]}, 
    {Hue[
      NCache[
       Rational[10295, 14307], 0.7195778290347382]], AbsoluteThickness[0.25], 
     LineBox[{10295, 10296}]}, 
    {Hue[
      NCache[
       Rational[3432, 4769], 0.719647724889914]], AbsoluteThickness[0.25], 
     LineBox[{10296, 10297}]}, 
    {Hue[
      NCache[
       Rational[10297, 14307], 0.7197176207450898]], AbsoluteThickness[0.25], 
     LineBox[{10297, 10298}]}, 
    {Hue[
      NCache[
       Rational[542, 753], 0.7197875166002656]], AbsoluteThickness[0.25], 
     LineBox[{10298, 10299}]}, 
    {Hue[
      NCache[
       Rational[3433, 4769], 0.7198574124554414]], AbsoluteThickness[0.25], 
     LineBox[{10299, 10300}]}, 
    {Hue[
      NCache[
       Rational[10300, 14307], 0.7199273083106171]], AbsoluteThickness[0.25], 
     LineBox[{10300, 10301}]}, 
    {Hue[
      NCache[
       Rational[10301, 14307], 0.7199972041657929]], AbsoluteThickness[0.25], 
     LineBox[{10301, 10302}]}, 
    {Hue[
      NCache[
       Rational[3434, 4769], 0.7200671000209687]], AbsoluteThickness[0.25], 
     LineBox[{10302, 10303}]}, 
    {Hue[
      NCache[
       Rational[10303, 14307], 0.7201369958761445]], AbsoluteThickness[0.25], 
     LineBox[{10303, 10304}]}, 
    {Hue[
      NCache[
       Rational[10304, 14307], 0.7202068917313204]], AbsoluteThickness[0.25], 
     LineBox[{10304, 10305}]}, 
    {Hue[
      NCache[
       Rational[3435, 4769], 0.7202767875864962]], AbsoluteThickness[0.25], 
     LineBox[{10305, 10306}]}, 
    {Hue[
      NCache[
       Rational[10306, 14307], 0.7203466834416719]], AbsoluteThickness[0.25], 
     LineBox[{10306, 10307}]}, 
    {Hue[
      NCache[
       Rational[10307, 14307], 0.7204165792968477]], AbsoluteThickness[0.25], 
     LineBox[{10307, 10308}]}, 
    {Hue[
      NCache[
       Rational[3436, 4769], 0.7204864751520235]], AbsoluteThickness[0.25], 
     LineBox[{10308, 10309}]}, 
    {Hue[
      NCache[
       Rational[10309, 14307], 0.7205563710071993]], AbsoluteThickness[0.25], 
     LineBox[{10309, 10310}]}, 
    {Hue[
      NCache[
       Rational[10310, 14307], 0.7206262668623751]], AbsoluteThickness[0.25], 
     LineBox[{10310, 10311}]}, 
    {Hue[
      NCache[
       Rational[3437, 4769], 0.7206961627175509]], AbsoluteThickness[0.25], 
     LineBox[{10311, 10312}]}, 
    {Hue[
      NCache[
       Rational[10312, 14307], 0.7207660585727267]], AbsoluteThickness[0.25], 
     LineBox[{10312, 10313}]}, 
    {Hue[
      NCache[
       Rational[10313, 14307], 0.7208359544279024]], AbsoluteThickness[0.25], 
     LineBox[{10313, 10314}]}, 
    {Hue[
      NCache[
       Rational[3438, 4769], 0.7209058502830782]], AbsoluteThickness[0.25], 
     LineBox[{10314, 10315}]}, 
    {Hue[
      NCache[
       Rational[10315, 14307], 0.720975746138254]], AbsoluteThickness[0.25], 
     LineBox[{10315, 10316}]}, 
    {Hue[
      NCache[
       Rational[10316, 14307], 0.7210456419934298]], AbsoluteThickness[0.25], 
     LineBox[{10316, 10317}]}, 
    {Hue[
      NCache[
       Rational[181, 251], 0.7211155378486056]], AbsoluteThickness[0.25], 
     LineBox[{10317, 10318}]}, 
    {Hue[
      NCache[
       Rational[10318, 14307], 0.7211854337037814]], AbsoluteThickness[0.25], 
     LineBox[{10318, 10319}]}, 
    {Hue[
      NCache[
       Rational[10319, 14307], 0.7212553295589571]], AbsoluteThickness[0.25], 
     LineBox[{10319, 10320}]}, 
    {Hue[
      NCache[
       Rational[3440, 4769], 0.7213252254141329]], AbsoluteThickness[0.25], 
     LineBox[{10320, 10321}]}, 
    {Hue[
      NCache[
       Rational[10321, 14307], 0.7213951212693087]], AbsoluteThickness[0.25], 
     LineBox[{10321, 10322}]}, 
    {Hue[
      NCache[
       Rational[10322, 14307], 0.7214650171244845]], AbsoluteThickness[0.25], 
     LineBox[{10322, 10323}]}, 
    {Hue[
      NCache[
       Rational[3441, 4769], 0.7215349129796603]], AbsoluteThickness[0.25], 
     LineBox[{10323, 10324}]}, 
    {Hue[
      NCache[
       Rational[10324, 14307], 0.7216048088348361]], AbsoluteThickness[0.25], 
     LineBox[{10324, 10325}]}, 
    {Hue[
      NCache[
       Rational[10325, 14307], 0.7216747046900119]], AbsoluteThickness[0.25], 
     LineBox[{10325, 10326}]}, 
    {Hue[
      NCache[
       Rational[3442, 4769], 0.7217446005451876]], AbsoluteThickness[0.25], 
     LineBox[{10326, 10327}]}, 
    {Hue[
      NCache[
       Rational[10327, 14307], 0.7218144964003634]], AbsoluteThickness[0.25], 
     LineBox[{10327, 10328}]}, 
    {Hue[
      NCache[
       Rational[10328, 14307], 0.7218843922555392]], AbsoluteThickness[0.25], 
     LineBox[{10328, 10329}]}, 
    {Hue[
      NCache[
       Rational[3443, 4769], 0.721954288110715]], AbsoluteThickness[0.25], 
     LineBox[{10329, 10330}]}, 
    {Hue[
      NCache[
       Rational[10330, 14307], 0.7220241839658909]], AbsoluteThickness[0.25], 
     LineBox[{10330, 10331}]}, 
    {Hue[
      NCache[
       Rational[10331, 14307], 0.7220940798210667]], AbsoluteThickness[0.25], 
     LineBox[{10331, 10332}]}, 
    {Hue[
      NCache[
       Rational[3444, 4769], 0.7221639756762424]], AbsoluteThickness[0.25], 
     LineBox[{10332, 10333}]}, 
    {Hue[
      NCache[
       Rational[10333, 14307], 0.7222338715314182]], AbsoluteThickness[0.25], 
     LineBox[{10333, 10334}]}, 
    {Hue[
      NCache[
       Rational[10334, 14307], 0.722303767386594]], AbsoluteThickness[0.25], 
     LineBox[{10334, 10335}]}, 
    {Hue[
      NCache[
       Rational[3445, 4769], 0.7223736632417698]], AbsoluteThickness[0.25], 
     LineBox[{10335, 10336}]}, 
    {Hue[
      NCache[
       Rational[544, 753], 0.7224435590969456]], AbsoluteThickness[0.25], 
     LineBox[{10336, 10337}]}, 
    {Hue[
      NCache[
       Rational[10337, 14307], 0.7225134549521214]], AbsoluteThickness[0.25], 
     LineBox[{10337, 10338}]}, 
    {Hue[
      NCache[
       Rational[3446, 4769], 0.7225833508072971]], AbsoluteThickness[0.25], 
     LineBox[{10338, 10339}]}, 
    {Hue[
      NCache[
       Rational[10339, 14307], 0.7226532466624729]], AbsoluteThickness[0.25], 
     LineBox[{10339, 10340}]}, 
    {Hue[
      NCache[
       Rational[10340, 14307], 0.7227231425176487]], AbsoluteThickness[0.25], 
     LineBox[{10340, 10341}]}, 
    {Hue[
      NCache[
       Rational[3447, 4769], 0.7227930383728245]], AbsoluteThickness[0.25], 
     LineBox[{10341, 10342}]}, 
    {Hue[
      NCache[
       Rational[10342, 14307], 0.7228629342280003]], AbsoluteThickness[0.25], 
     LineBox[{10342, 10343}]}, 
    {Hue[
      NCache[
       Rational[10343, 14307], 0.7229328300831761]], AbsoluteThickness[0.25], 
     LineBox[{10343, 10344}]}, 
    {Hue[
      NCache[
       Rational[3448, 4769], 0.7230027259383519]], AbsoluteThickness[0.25], 
     LineBox[{10344, 10345}]}, 
    {Hue[
      NCache[
       Rational[10345, 14307], 0.7230726217935276]], AbsoluteThickness[0.25], 
     LineBox[{10345, 10346}]}, 
    {Hue[
      NCache[
       Rational[10346, 14307], 0.7231425176487034]], AbsoluteThickness[0.25], 
     LineBox[{10346, 10347}]}, 
    {Hue[
      NCache[
       Rational[3449, 4769], 0.7232124135038792]], AbsoluteThickness[0.25], 
     LineBox[{10347, 10348}]}, 
    {Hue[
      NCache[
       Rational[10348, 14307], 0.723282309359055]], AbsoluteThickness[0.25], 
     LineBox[{10348, 10349}]}, 
    {Hue[
      NCache[
       Rational[10349, 14307], 0.7233522052142308]], AbsoluteThickness[0.25], 
     LineBox[{10349, 10350}]}, 
    {Hue[
      NCache[
       Rational[3450, 4769], 0.7234221010694066]], AbsoluteThickness[0.25], 
     LineBox[{10350, 10351}]}, 
    {Hue[
      NCache[
       Rational[10351, 14307], 0.7234919969245823]], AbsoluteThickness[0.25], 
     LineBox[{10351, 10352}]}, 
    {Hue[
      NCache[
       Rational[10352, 14307], 0.7235618927797581]], AbsoluteThickness[0.25], 
     LineBox[{10352, 10353}]}, 
    {Hue[
      NCache[
       Rational[3451, 4769], 0.7236317886349339]], AbsoluteThickness[0.25], 
     LineBox[{10353, 10354}]}, 
    {Hue[
      NCache[
       Rational[10354, 14307], 0.7237016844901097]], AbsoluteThickness[0.25], 
     LineBox[{10354, 10355}]}, 
    {Hue[
      NCache[
       Rational[545, 753], 0.7237715803452855]], AbsoluteThickness[0.25], 
     LineBox[{10355, 10356}]}, 
    {Hue[
      NCache[
       Rational[3452, 4769], 0.7238414762004614]], AbsoluteThickness[0.25], 
     LineBox[{10356, 10357}]}, 
    {Hue[
      NCache[
       Rational[10357, 14307], 0.723911372055637]], AbsoluteThickness[0.25], 
     LineBox[{10357, 10358}]}, 
    {Hue[
      NCache[
       Rational[10358, 14307], 0.7239812679108129]], AbsoluteThickness[0.25], 
     LineBox[{10358, 10359}]}, 
    {Hue[
      NCache[
       Rational[3453, 4769], 0.7240511637659887]], AbsoluteThickness[0.25], 
     LineBox[{10359, 10360}]}, 
    {Hue[
      NCache[
       Rational[10360, 14307], 0.7241210596211645]], AbsoluteThickness[0.25], 
     LineBox[{10360, 10361}]}, 
    {Hue[
      NCache[
       Rational[10361, 14307], 0.7241909554763403]], AbsoluteThickness[0.25], 
     LineBox[{10361, 10362}]}, 
    {Hue[
      NCache[
       Rational[3454, 4769], 0.7242608513315161]], AbsoluteThickness[0.25], 
     LineBox[{10362, 10363}]}, 
    {Hue[
      NCache[
       Rational[10363, 14307], 0.7243307471866919]], AbsoluteThickness[0.25], 
     LineBox[{10363, 10364}]}, 
    {Hue[
      NCache[
       Rational[10364, 14307], 0.7244006430418676]], AbsoluteThickness[0.25], 
     LineBox[{10364, 10365}]}, 
    {Hue[
      NCache[
       Rational[3455, 4769], 0.7244705388970434]], AbsoluteThickness[0.25], 
     LineBox[{10365, 10366}]}, 
    {Hue[
      NCache[
       Rational[10366, 14307], 0.7245404347522192]], AbsoluteThickness[0.25], 
     LineBox[{10366, 10367}]}, 
    {Hue[
      NCache[
       Rational[10367, 14307], 0.724610330607395]], AbsoluteThickness[0.25], 
     LineBox[{10367, 10368}]}, 
    {Hue[
      NCache[
       Rational[3456, 4769], 0.7246802264625708]], AbsoluteThickness[0.25], 
     LineBox[{10368, 10369}]}, 
    {Hue[
      NCache[
       Rational[10369, 14307], 0.7247501223177466]], AbsoluteThickness[0.25], 
     LineBox[{10369, 10370}]}, 
    {Hue[
      NCache[
       Rational[10370, 14307], 0.7248200181729223]], AbsoluteThickness[0.25], 
     LineBox[{10370, 10371}]}, 
    {Hue[
      NCache[
       Rational[3457, 4769], 0.7248899140280981]], AbsoluteThickness[0.25], 
     LineBox[{10371, 10372}]}, 
    {Hue[
      NCache[
       Rational[10372, 14307], 0.7249598098832739]], AbsoluteThickness[0.25], 
     LineBox[{10372, 10373}]}, 
    {Hue[
      NCache[
       Rational[10373, 14307], 0.7250297057384497]], AbsoluteThickness[0.25], 
     LineBox[{10373, 10374}]}, 
    {Hue[
      NCache[
       Rational[182, 251], 0.7250996015936255]], AbsoluteThickness[0.25], 
     LineBox[{10374, 10375}]}, 
    {Hue[
      NCache[
       Rational[10375, 14307], 0.7251694974488013]], AbsoluteThickness[0.25], 
     LineBox[{10375, 10376}]}, 
    {Hue[
      NCache[
       Rational[10376, 14307], 0.725239393303977]], AbsoluteThickness[0.25], 
     LineBox[{10376, 10377}]}, 
    {Hue[
      NCache[
       Rational[3459, 4769], 0.7253092891591528]], AbsoluteThickness[0.25], 
     LineBox[{10377, 10378}]}, 
    {Hue[
      NCache[
       Rational[10378, 14307], 0.7253791850143286]], AbsoluteThickness[0.25], 
     LineBox[{10378, 10379}]}, 
    {Hue[
      NCache[
       Rational[10379, 14307], 0.7254490808695044]], AbsoluteThickness[0.25], 
     LineBox[{10379, 10380}]}, 
    {Hue[
      NCache[
       Rational[3460, 4769], 0.7255189767246802]], AbsoluteThickness[0.25], 
     LineBox[{10380, 10381}]}, 
    {Hue[
      NCache[
       Rational[10381, 14307], 0.725588872579856]], AbsoluteThickness[0.25], 
     LineBox[{10381, 10382}]}, 
    {Hue[
      NCache[
       Rational[10382, 14307], 0.7256587684350319]], AbsoluteThickness[0.25], 
     LineBox[{10382, 10383}]}, 
    {Hue[
      NCache[
       Rational[3461, 4769], 0.7257286642902075]], AbsoluteThickness[0.25], 
     LineBox[{10383, 10384}]}, 
    {Hue[
      NCache[
       Rational[10384, 14307], 0.7257985601453834]], AbsoluteThickness[0.25], 
     LineBox[{10384, 10385}]}, 
    {Hue[
      NCache[
       Rational[10385, 14307], 0.7258684560005592]], AbsoluteThickness[0.25], 
     LineBox[{10385, 10386}]}, 
    {Hue[
      NCache[
       Rational[3462, 4769], 0.725938351855735]], AbsoluteThickness[0.25], 
     LineBox[{10386, 10387}]}, 
    {Hue[
      NCache[
       Rational[10387, 14307], 0.7260082477109108]], AbsoluteThickness[0.25], 
     LineBox[{10387, 10388}]}, 
    {Hue[
      NCache[
       Rational[10388, 14307], 0.7260781435660866]], AbsoluteThickness[0.25], 
     LineBox[{10388, 10389}]}, 
    {Hue[
      NCache[
       Rational[3463, 4769], 0.7261480394212623]], AbsoluteThickness[0.25], 
     LineBox[{10389, 10390}]}, 
    {Hue[
      NCache[
       Rational[10390, 14307], 0.7262179352764381]], AbsoluteThickness[0.25], 
     LineBox[{10390, 10391}]}, 
    {Hue[
      NCache[
       Rational[10391, 14307], 0.7262878311316139]], AbsoluteThickness[0.25], 
     LineBox[{10391, 10392}]}, 
    {Hue[
      NCache[
       Rational[3464, 4769], 0.7263577269867897]], AbsoluteThickness[0.25], 
     LineBox[{10392, 10393}]}, 
    {Hue[
      NCache[
       Rational[547, 753], 0.7264276228419655]], AbsoluteThickness[0.25], 
     LineBox[{10393, 10394}]}, 
    {Hue[
      NCache[
       Rational[10394, 14307], 0.7264975186971413]], AbsoluteThickness[0.25], 
     LineBox[{10394, 10395}]}, 
    {Hue[
      NCache[
       Rational[3465, 4769], 0.726567414552317]], AbsoluteThickness[0.25], 
     LineBox[{10395, 10396}]}, 
    {Hue[
      NCache[
       Rational[10396, 14307], 0.7266373104074928]], AbsoluteThickness[0.25], 
     LineBox[{10396, 10397}]}, 
    {Hue[
      NCache[
       Rational[10397, 14307], 0.7267072062626686]], AbsoluteThickness[0.25], 
     LineBox[{10397, 10398}]}, 
    {Hue[
      NCache[
       Rational[3466, 4769], 0.7267771021178444]], AbsoluteThickness[0.25], 
     LineBox[{10398, 10399}]}, 
    {Hue[
      NCache[
       Rational[10399, 14307], 0.7268469979730202]], AbsoluteThickness[0.25], 
     LineBox[{10399, 10400}]}, 
    {Hue[
      NCache[
       Rational[10400, 14307], 0.726916893828196]], AbsoluteThickness[0.25], 
     LineBox[{10400, 10401}]}, 
    {Hue[
      NCache[
       Rational[3467, 4769], 0.7269867896833718]], AbsoluteThickness[0.25], 
     LineBox[{10401, 10402}]}, 
    {Hue[
      NCache[
       Rational[10402, 14307], 0.7270566855385475]], AbsoluteThickness[0.25], 
     LineBox[{10402, 10403}]}, 
    {Hue[
      NCache[
       Rational[10403, 14307], 0.7271265813937233]], AbsoluteThickness[0.25], 
     LineBox[{10403, 10404}]}, 
    {Hue[
      NCache[
       Rational[3468, 4769], 0.7271964772488991]], AbsoluteThickness[0.25], 
     LineBox[{10404, 10405}]}, 
    {Hue[
      NCache[
       Rational[10405, 14307], 0.7272663731040749]], AbsoluteThickness[0.25], 
     LineBox[{10405, 10406}]}, 
    {Hue[
      NCache[
       Rational[10406, 14307], 0.7273362689592507]], AbsoluteThickness[0.25], 
     LineBox[{10406, 10407}]}, 
    {Hue[
      NCache[
       Rational[3469, 4769], 0.7274061648144265]], AbsoluteThickness[0.25], 
     LineBox[{10407, 10408}]}, 
    {Hue[
      NCache[
       Rational[10408, 14307], 0.7274760606696022]], AbsoluteThickness[0.25], 
     LineBox[{10408, 10409}]}, 
    {Hue[
      NCache[
       Rational[10409, 14307], 0.727545956524778]], AbsoluteThickness[0.25], 
     LineBox[{10409, 10410}]}, 
    {Hue[
      NCache[
       Rational[3470, 4769], 0.7276158523799539]], AbsoluteThickness[0.25], 
     LineBox[{10410, 10411}]}, 
    {Hue[
      NCache[
       Rational[10411, 14307], 0.7276857482351297]], AbsoluteThickness[0.25], 
     LineBox[{10411, 10412}]}, 
    {Hue[
      NCache[
       Rational[548, 753], 0.7277556440903055]], AbsoluteThickness[0.25], 
     LineBox[{10412, 10413}]}, 
    {Hue[
      NCache[
       Rational[3471, 4769], 0.7278255399454813]], AbsoluteThickness[0.25], 
     LineBox[{10413, 10414}]}, 
    {Hue[
      NCache[
       Rational[10414, 14307], 0.7278954358006571]], AbsoluteThickness[0.25], 
     LineBox[{10414, 10415}]}, 
    {Hue[
      NCache[
       Rational[10415, 14307], 0.7279653316558328]], AbsoluteThickness[0.25], 
     LineBox[{10415, 10416}]}, 
    {Hue[
      NCache[
       Rational[3472, 4769], 0.7280352275110086]], AbsoluteThickness[0.25], 
     LineBox[{10416, 10417}]}, 
    {Hue[
      NCache[
       Rational[10417, 14307], 0.7281051233661844]], AbsoluteThickness[0.25], 
     LineBox[{10417, 10418}]}, 
    {Hue[
      NCache[
       Rational[10418, 14307], 0.7281750192213602]], AbsoluteThickness[0.25], 
     LineBox[{10418, 10419}]}, 
    {Hue[
      NCache[
       Rational[3473, 4769], 0.728244915076536]], AbsoluteThickness[0.25], 
     LineBox[{10419, 10420}]}, 
    {Hue[
      NCache[
       Rational[10420, 14307], 0.7283148109317118]], AbsoluteThickness[0.25], 
     LineBox[{10420, 10421}]}, 
    {Hue[
      NCache[
       Rational[10421, 14307], 0.7283847067868875]], AbsoluteThickness[0.25], 
     LineBox[{10421, 10422}]}, 
    {Hue[
      NCache[
       Rational[3474, 4769], 0.7284546026420633]], AbsoluteThickness[0.25], 
     LineBox[{10422, 10423}]}, 
    {Hue[
      NCache[
       Rational[10423, 14307], 0.7285244984972391]], AbsoluteThickness[0.25], 
     LineBox[{10423, 10424}]}, 
    {Hue[
      NCache[
       Rational[10424, 14307], 0.7285943943524149]], AbsoluteThickness[0.25], 
     LineBox[{10424, 10425}]}, 
    {Hue[
      NCache[
       Rational[3475, 4769], 0.7286642902075907]], AbsoluteThickness[0.25], 
     LineBox[{10425, 10426}]}, 
    {Hue[
      NCache[
       Rational[10426, 14307], 0.7287341860627665]], AbsoluteThickness[0.25], 
     LineBox[{10426, 10427}]}, 
    {Hue[
      NCache[
       Rational[10427, 14307], 0.7288040819179422]], AbsoluteThickness[0.25], 
     LineBox[{10427, 10428}]}, 
    {Hue[
      NCache[
       Rational[3476, 4769], 0.728873977773118]], AbsoluteThickness[0.25], 
     LineBox[{10428, 10429}]}, 
    {Hue[
      NCache[
       Rational[10429, 14307], 0.7289438736282938]], AbsoluteThickness[0.25], 
     LineBox[{10429, 10430}]}, 
    {Hue[
      NCache[
       Rational[10430, 14307], 0.7290137694834696]], AbsoluteThickness[0.25], 
     LineBox[{10430, 10431}]}, 
    {Hue[
      NCache[
       Rational[183, 251], 0.7290836653386454]], AbsoluteThickness[0.25], 
     LineBox[{10431, 10432}]}, 
    {Hue[
      NCache[
       Rational[10432, 14307], 0.7291535611938212]], AbsoluteThickness[0.25], 
     LineBox[{10432, 10433}]}, 
    {Hue[
      NCache[
       Rational[10433, 14307], 0.729223457048997]], AbsoluteThickness[0.25], 
     LineBox[{10433, 10434}]}, 
    {Hue[
      NCache[
       Rational[3478, 4769], 0.7292933529041727]], AbsoluteThickness[0.25], 
     LineBox[{10434, 10435}]}, 
    {Hue[
      NCache[
       Rational[10435, 14307], 0.7293632487593485]], AbsoluteThickness[0.25], 
     LineBox[{10435, 10436}]}, 
    {Hue[
      NCache[
       Rational[10436, 14307], 0.7294331446145244]], AbsoluteThickness[0.25], 
     LineBox[{10436, 10437}]}, 
    {Hue[
      NCache[
       Rational[3479, 4769], 0.7295030404697002]], AbsoluteThickness[0.25], 
     LineBox[{10437, 10438}]}, 
    {Hue[
      NCache[
       Rational[10438, 14307], 0.729572936324876]], AbsoluteThickness[0.25], 
     LineBox[{10438, 10439}]}, 
    {Hue[
      NCache[
       Rational[10439, 14307], 0.7296428321800518]], AbsoluteThickness[0.25], 
     LineBox[{10439, 10440}]}, 
    {Hue[
      NCache[
       Rational[3480, 4769], 0.7297127280352275]], AbsoluteThickness[0.25], 
     LineBox[{10440, 10441}]}, 
    {Hue[
      NCache[
       Rational[10441, 14307], 0.7297826238904033]], AbsoluteThickness[0.25], 
     LineBox[{10441, 10442}]}, 
    {Hue[
      NCache[
       Rational[10442, 14307], 0.7298525197455791]], AbsoluteThickness[0.25], 
     LineBox[{10442, 10443}]}, 
    {Hue[
      NCache[
       Rational[3481, 4769], 0.7299224156007549]], AbsoluteThickness[0.25], 
     LineBox[{10443, 10444}]}, 
    {Hue[
      NCache[
       Rational[10444, 14307], 0.7299923114559307]], AbsoluteThickness[0.25], 
     LineBox[{10444, 10445}]}, 
    {Hue[
      NCache[
       Rational[10445, 14307], 0.7300622073111065]], AbsoluteThickness[0.25], 
     LineBox[{10445, 10446}]}, 
    {Hue[
      NCache[
       Rational[3482, 4769], 0.7301321031662822]], AbsoluteThickness[0.25], 
     LineBox[{10446, 10447}]}, 
    {Hue[
      NCache[
       Rational[10447, 14307], 0.730201999021458]], AbsoluteThickness[0.25], 
     LineBox[{10447, 10448}]}, 
    {Hue[
      NCache[
       Rational[10448, 14307], 0.7302718948766338]], AbsoluteThickness[0.25], 
     LineBox[{10448, 10449}]}, 
    {Hue[
      NCache[
       Rational[3483, 4769], 0.7303417907318096]], AbsoluteThickness[0.25], 
     LineBox[{10449, 10450}]}, 
    {Hue[
      NCache[
       Rational[550, 753], 0.7304116865869854]], AbsoluteThickness[0.25], 
     LineBox[{10450, 10451}]}, 
    {Hue[
      NCache[
       Rational[10451, 14307], 0.7304815824421612]], AbsoluteThickness[0.25], 
     LineBox[{10451, 10452}]}, 
    {Hue[
      NCache[
       Rational[3484, 4769], 0.730551478297337]], AbsoluteThickness[0.25], 
     LineBox[{10452, 10453}]}, 
    {Hue[
      NCache[
       Rational[10453, 14307], 0.7306213741525127]], AbsoluteThickness[0.25], 
     LineBox[{10453, 10454}]}, 
    {Hue[
      NCache[
       Rational[10454, 14307], 0.7306912700076885]], AbsoluteThickness[0.25], 
     LineBox[{10454, 10455}]}, 
    {Hue[
      NCache[
       Rational[3485, 4769], 0.7307611658628643]], AbsoluteThickness[0.25], 
     LineBox[{10455, 10456}]}, 
    {Hue[
      NCache[
       Rational[10456, 14307], 0.7308310617180401]], AbsoluteThickness[0.25], 
     LineBox[{10456, 10457}]}, 
    {Hue[
      NCache[
       Rational[10457, 14307], 0.7309009575732159]], AbsoluteThickness[0.25], 
     LineBox[{10457, 10458}]}, 
    {Hue[
      NCache[
       Rational[3486, 4769], 0.7309708534283917]], AbsoluteThickness[0.25], 
     LineBox[{10458, 10459}]}, 
    {Hue[
      NCache[
       Rational[10459, 14307], 0.7310407492835674]], AbsoluteThickness[0.25], 
     LineBox[{10459, 10460}]}, 
    {Hue[
      NCache[
       Rational[10460, 14307], 0.7311106451387432]], AbsoluteThickness[0.25], 
     LineBox[{10460, 10461}]}, 
    {Hue[
      NCache[
       Rational[3487, 4769], 0.731180540993919]], AbsoluteThickness[0.25], 
     LineBox[{10461, 10462}]}, 
    {Hue[
      NCache[
       Rational[10462, 14307], 0.7312504368490949]], AbsoluteThickness[0.25], 
     LineBox[{10462, 10463}]}, 
    {Hue[
      NCache[
       Rational[10463, 14307], 0.7313203327042707]], AbsoluteThickness[0.25], 
     LineBox[{10463, 10464}]}, 
    {Hue[
      NCache[
       Rational[3488, 4769], 0.7313902285594465]], AbsoluteThickness[0.25], 
     LineBox[{10464, 10465}]}, 
    {Hue[
      NCache[
       Rational[10465, 14307], 0.7314601244146222]], AbsoluteThickness[0.25], 
     LineBox[{10465, 10466}]}, 
    {Hue[
      NCache[
       Rational[10466, 14307], 0.731530020269798]], AbsoluteThickness[0.25], 
     LineBox[{10466, 10467}]}, 
    {Hue[
      NCache[
       Rational[3489, 4769], 0.7315999161249738]], AbsoluteThickness[0.25], 
     LineBox[{10467, 10468}]}, 
    {Hue[
      NCache[
       Rational[10468, 14307], 0.7316698119801496]], AbsoluteThickness[0.25], 
     LineBox[{10468, 10469}]}, 
    {Hue[
      NCache[
       Rational[551, 753], 0.7317397078353254]], AbsoluteThickness[0.25], 
     LineBox[{10469, 10470}]}, 
    {Hue[
      NCache[
       Rational[3490, 4769], 0.7318096036905012]], AbsoluteThickness[0.25], 
     LineBox[{10470, 10471}]}, 
    {Hue[
      NCache[
       Rational[10471, 14307], 0.731879499545677]], AbsoluteThickness[0.25], 
     LineBox[{10471, 10472}]}, 
    {Hue[
      NCache[
       Rational[10472, 14307], 0.7319493954008527]], AbsoluteThickness[0.25], 
     LineBox[{10472, 10473}]}, 
    {Hue[
      NCache[
       Rational[3491, 4769], 0.7320192912560285]], AbsoluteThickness[0.25], 
     LineBox[{10473, 10474}]}, 
    {Hue[
      NCache[
       Rational[10474, 14307], 0.7320891871112043]], AbsoluteThickness[0.25], 
     LineBox[{10474, 10475}]}, 
    {Hue[
      NCache[
       Rational[10475, 14307], 0.7321590829663801]], AbsoluteThickness[0.25], 
     LineBox[{10475, 10476}]}, 
    {Hue[
      NCache[
       Rational[3492, 4769], 0.7322289788215559]], AbsoluteThickness[0.25], 
     LineBox[{10476, 10477}]}, 
    {Hue[
      NCache[
       Rational[10477, 14307], 0.7322988746767317]], AbsoluteThickness[0.25], 
     LineBox[{10477, 10478}]}, 
    {Hue[
      NCache[
       Rational[10478, 14307], 0.7323687705319074]], AbsoluteThickness[0.25], 
     LineBox[{10478, 10479}]}, 
    {Hue[
      NCache[
       Rational[3493, 4769], 0.7324386663870832]], AbsoluteThickness[0.25], 
     LineBox[{10479, 10480}]}, 
    {Hue[
      NCache[
       Rational[10480, 14307], 0.732508562242259]], AbsoluteThickness[0.25], 
     LineBox[{10480, 10481}]}, 
    {Hue[
      NCache[
       Rational[10481, 14307], 0.7325784580974348]], AbsoluteThickness[0.25], 
     LineBox[{10481, 10482}]}, 
    {Hue[
      NCache[
       Rational[3494, 4769], 0.7326483539526106]], AbsoluteThickness[0.25], 
     LineBox[{10482, 10483}]}, 
    {Hue[
      NCache[
       Rational[10483, 14307], 0.7327182498077864]], AbsoluteThickness[0.25], 
     LineBox[{10483, 10484}]}, 
    {Hue[
      NCache[
       Rational[10484, 14307], 0.7327881456629621]], AbsoluteThickness[0.25], 
     LineBox[{10484, 10485}]}, 
    {Hue[
      NCache[
       Rational[3495, 4769], 0.7328580415181379]], AbsoluteThickness[0.25], 
     LineBox[{10485, 10486}]}, 
    {Hue[
      NCache[
       Rational[10486, 14307], 0.7329279373733137]], AbsoluteThickness[0.25], 
     LineBox[{10486, 10487}]}, 
    {Hue[
      NCache[
       Rational[10487, 14307], 0.7329978332284895]], AbsoluteThickness[0.25], 
     LineBox[{10487, 10488}]}, 
    {Hue[
      NCache[
       Rational[184, 251], 0.7330677290836654]], AbsoluteThickness[0.25], 
     LineBox[{10488, 10489}]}, 
    {Hue[
      NCache[
       Rational[10489, 14307], 0.7331376249388412]], AbsoluteThickness[0.25], 
     LineBox[{10489, 10490}]}, 
    {Hue[
      NCache[
       Rational[10490, 14307], 0.733207520794017]], AbsoluteThickness[0.25], 
     LineBox[{10490, 10491}]}, 
    {Hue[
      NCache[
       Rational[3497, 4769], 0.7332774166491927]], AbsoluteThickness[0.25], 
     LineBox[{10491, 10492}]}, 
    {Hue[
      NCache[
       Rational[10492, 14307], 0.7333473125043685]], AbsoluteThickness[0.25], 
     LineBox[{10492, 10493}]}, 
    {Hue[
      NCache[
       Rational[10493, 14307], 0.7334172083595443]], AbsoluteThickness[0.25], 
     LineBox[{10493, 10494}]}, 
    {Hue[
      NCache[
       Rational[3498, 4769], 0.7334871042147201]], AbsoluteThickness[0.25], 
     LineBox[{10494, 10495}]}, 
    {Hue[
      NCache[
       Rational[10495, 14307], 0.7335570000698959]], AbsoluteThickness[0.25], 
     LineBox[{10495, 10496}]}, 
    {Hue[
      NCache[
       Rational[10496, 14307], 0.7336268959250717]], AbsoluteThickness[0.25], 
     LineBox[{10496, 10497}]}, 
    {Hue[
      NCache[
       Rational[3499, 4769], 0.7336967917802474]], AbsoluteThickness[0.25], 
     LineBox[{10497, 10498}]}, 
    {Hue[
      NCache[
       Rational[10498, 14307], 0.7337666876354232]], AbsoluteThickness[0.25], 
     LineBox[{10498, 10499}]}, 
    {Hue[
      NCache[
       Rational[10499, 14307], 0.733836583490599]], AbsoluteThickness[0.25], 
     LineBox[{10499, 10500}]}, 
    {Hue[
      NCache[
       Rational[3500, 4769], 0.7339064793457748]], AbsoluteThickness[0.25], 
     LineBox[{10500, 10501}]}, 
    {Hue[
      NCache[
       Rational[10501, 14307], 0.7339763752009506]], AbsoluteThickness[0.25], 
     LineBox[{10501, 10502}]}, 
    {Hue[
      NCache[
       Rational[10502, 14307], 0.7340462710561264]], AbsoluteThickness[0.25], 
     LineBox[{10502, 10503}]}, 
    {Hue[
      NCache[
       Rational[3501, 4769], 0.7341161669113022]], AbsoluteThickness[0.25], 
     LineBox[{10503, 10504}]}, 
    {Hue[
      NCache[
       Rational[10504, 14307], 0.7341860627664779]], AbsoluteThickness[0.25], 
     LineBox[{10504, 10505}]}, 
    {Hue[
      NCache[
       Rational[10505, 14307], 0.7342559586216537]], AbsoluteThickness[0.25], 
     LineBox[{10505, 10506}]}, 
    {Hue[
      NCache[
       Rational[3502, 4769], 0.7343258544768295]], AbsoluteThickness[0.25], 
     LineBox[{10506, 10507}]}, 
    {Hue[
      NCache[
       Rational[553, 753], 0.7343957503320053]], AbsoluteThickness[0.25], 
     LineBox[{10507, 10508}]}, 
    {Hue[
      NCache[
       Rational[10508, 14307], 0.7344656461871811]], AbsoluteThickness[0.25], 
     LineBox[{10508, 10509}]}, 
    {Hue[
      NCache[
       Rational[3503, 4769], 0.7345355420423569]], AbsoluteThickness[0.25], 
     LineBox[{10509, 10510}]}, 
    {Hue[
      NCache[
       Rational[10510, 14307], 0.7346054378975326]], AbsoluteThickness[0.25], 
     LineBox[{10510, 10511}]}, 
    {Hue[
      NCache[
       Rational[10511, 14307], 0.7346753337527084]], AbsoluteThickness[0.25], 
     LineBox[{10511, 10512}]}, 
    {Hue[
      NCache[
       Rational[3504, 4769], 0.7347452296078842]], AbsoluteThickness[0.25], 
     LineBox[{10512, 10513}]}, 
    {Hue[
      NCache[
       Rational[10513, 14307], 0.73481512546306]], AbsoluteThickness[0.25], 
     LineBox[{10513, 10514}]}, 
    {Hue[
      NCache[
       Rational[10514, 14307], 0.7348850213182359]], AbsoluteThickness[0.25], 
     LineBox[{10514, 10515}]}, 
    {Hue[
      NCache[
       Rational[3505, 4769], 0.7349549171734117]], AbsoluteThickness[0.25], 
     LineBox[{10515, 10516}]}, 
    {Hue[
      NCache[
       Rational[10516, 14307], 0.7350248130285874]], AbsoluteThickness[0.25], 
     LineBox[{10516, 10517}]}, 
    {Hue[
      NCache[
       Rational[10517, 14307], 0.7350947088837632]], AbsoluteThickness[0.25], 
     LineBox[{10517, 10518}]}, 
    {Hue[
      NCache[
       Rational[3506, 4769], 0.735164604738939]], AbsoluteThickness[0.25], 
     LineBox[{10518, 10519}]}, 
    {Hue[
      NCache[
       Rational[10519, 14307], 0.7352345005941148]], AbsoluteThickness[0.25], 
     LineBox[{10519, 10520}]}, 
    {Hue[
      NCache[
       Rational[10520, 14307], 0.7353043964492906]], AbsoluteThickness[0.25], 
     LineBox[{10520, 10521}]}, 
    {Hue[
      NCache[
       Rational[3507, 4769], 0.7353742923044664]], AbsoluteThickness[0.25], 
     LineBox[{10521, 10522}]}, 
    {Hue[
      NCache[
       Rational[10522, 14307], 0.7354441881596422]], AbsoluteThickness[0.25], 
     LineBox[{10522, 10523}]}, 
    {Hue[
      NCache[
       Rational[10523, 14307], 0.7355140840148179]], AbsoluteThickness[0.25], 
     LineBox[{10523, 10524}]}, 
    {Hue[
      NCache[
       Rational[3508, 4769], 0.7355839798699937]], AbsoluteThickness[0.25], 
     LineBox[{10524, 10525}]}, 
    {Hue[
      NCache[
       Rational[10525, 14307], 0.7356538757251695]], AbsoluteThickness[0.25], 
     LineBox[{10525, 10526}]}, 
    {Hue[
      NCache[
       Rational[554, 753], 0.7357237715803453]], AbsoluteThickness[0.25], 
     LineBox[{10526, 10527}]}, 
    {Hue[
      NCache[
       Rational[3509, 4769], 0.7357936674355211]], AbsoluteThickness[0.25], 
     LineBox[{10527, 10528}]}, 
    {Hue[
      NCache[
       Rational[10528, 14307], 0.7358635632906969]], AbsoluteThickness[0.25], 
     LineBox[{10528, 10529}]}, 
    {Hue[
      NCache[
       Rational[10529, 14307], 0.7359334591458726]], AbsoluteThickness[0.25], 
     LineBox[{10529, 10530}]}, 
    {Hue[
      NCache[
       Rational[3510, 4769], 0.7360033550010484]], AbsoluteThickness[0.25], 
     LineBox[{10530, 10531}]}, 
    {Hue[
      NCache[
       Rational[10531, 14307], 0.7360732508562242]], AbsoluteThickness[0.25], 
     LineBox[{10531, 10532}]}, 
    {Hue[
      NCache[
       Rational[10532, 14307], 0.7361431467114]], AbsoluteThickness[0.25], 
     LineBox[{10532, 10533}]}, 
    {Hue[
      NCache[
       Rational[3511, 4769], 0.7362130425665758]], AbsoluteThickness[0.25], 
     LineBox[{10533, 10534}]}, 
    {Hue[
      NCache[
       Rational[10534, 14307], 0.7362829384217516]], AbsoluteThickness[0.25], 
     LineBox[{10534, 10535}]}, 
    {Hue[
      NCache[
       Rational[10535, 14307], 0.7363528342769273]], AbsoluteThickness[0.25], 
     LineBox[{10535, 10536}]}, 
    {Hue[
      NCache[
       Rational[3512, 4769], 0.7364227301321031]], AbsoluteThickness[0.25], 
     LineBox[{10536, 10537}]}, 
    {Hue[
      NCache[
       Rational[10537, 14307], 0.7364926259872789]], AbsoluteThickness[0.25], 
     LineBox[{10537, 10538}]}, 
    {Hue[
      NCache[
       Rational[10538, 14307], 0.7365625218424547]], AbsoluteThickness[0.25], 
     LineBox[{10538, 10539}]}, 
    {Hue[
      NCache[
       Rational[3513, 4769], 0.7366324176976305]], AbsoluteThickness[0.25], 
     LineBox[{10539, 10540}]}, 
    {Hue[
      NCache[
       Rational[10540, 14307], 0.7367023135528064]], AbsoluteThickness[0.25], 
     LineBox[{10540, 10541}]}, 
    {Hue[
      NCache[
       Rational[10541, 14307], 0.7367722094079822]], AbsoluteThickness[0.25], 
     LineBox[{10541, 10542}]}, 
    {Hue[
      NCache[
       Rational[14, 19], 0.7368421052631579]], AbsoluteThickness[0.25], 
     LineBox[{10542, 10543}]}, 
    {Hue[
      NCache[
       Rational[10543, 14307], 0.7369120011183337]], AbsoluteThickness[0.25], 
     LineBox[{10543, 10544}]}, 
    {Hue[
      NCache[
       Rational[10544, 14307], 0.7369818969735095]], AbsoluteThickness[0.25], 
     LineBox[{10544, 10545}]}, 
    {Hue[
      NCache[
       Rational[185, 251], 0.7370517928286853]], AbsoluteThickness[0.25], 
     LineBox[{10545, 10546}]}, 
    {Hue[
      NCache[
       Rational[10546, 14307], 0.7371216886838611]], AbsoluteThickness[0.25], 
     LineBox[{10546, 10547}]}, 
    {Hue[
      NCache[
       Rational[10547, 14307], 0.7371915845390369]], AbsoluteThickness[0.25], 
     LineBox[{10547, 10548}]}, 
    {Hue[
      NCache[
       Rational[3516, 4769], 0.7372614803942126]], AbsoluteThickness[0.25], 
     LineBox[{10548, 10549}]}, 
    {Hue[
      NCache[
       Rational[10549, 14307], 0.7373313762493884]], AbsoluteThickness[0.25], 
     LineBox[{10549, 10550}]}, 
    {Hue[
      NCache[
       Rational[10550, 14307], 0.7374012721045642]], AbsoluteThickness[0.25], 
     LineBox[{10550, 10551}]}, 
    {Hue[
      NCache[
       Rational[3517, 4769], 0.73747116795974]], AbsoluteThickness[0.25], 
     LineBox[{10551, 10552}]}, 
    {Hue[
      NCache[
       Rational[10552, 14307], 0.7375410638149158]], AbsoluteThickness[0.25], 
     LineBox[{10552, 10553}]}, 
    {Hue[
      NCache[
       Rational[10553, 14307], 0.7376109596700916]], AbsoluteThickness[0.25], 
     LineBox[{10553, 10554}]}, 
    {Hue[
      NCache[
       Rational[3518, 4769], 0.7376808555252673]], AbsoluteThickness[0.25], 
     LineBox[{10554, 10555}]}, 
    {Hue[
      NCache[
       Rational[10555, 14307], 0.7377507513804431]], AbsoluteThickness[0.25], 
     LineBox[{10555, 10556}]}, 
    {Hue[
      NCache[
       Rational[10556, 14307], 0.7378206472356189]], AbsoluteThickness[0.25], 
     LineBox[{10556, 10557}]}, 
    {Hue[
      NCache[
       Rational[3519, 4769], 0.7378905430907947]], AbsoluteThickness[0.25], 
     LineBox[{10557, 10558}]}, 
    {Hue[
      NCache[
       Rational[10558, 14307], 0.7379604389459705]], AbsoluteThickness[0.25], 
     LineBox[{10558, 10559}]}, 
    {Hue[
      NCache[
       Rational[10559, 14307], 0.7380303348011463]], AbsoluteThickness[0.25], 
     LineBox[{10559, 10560}]}, 
    {Hue[
      NCache[
       Rational[3520, 4769], 0.7381002306563221]], AbsoluteThickness[0.25], 
     LineBox[{10560, 10561}]}, 
    {Hue[
      NCache[
       Rational[10561, 14307], 0.7381701265114978]], AbsoluteThickness[0.25], 
     LineBox[{10561, 10562}]}, 
    {Hue[
      NCache[
       Rational[10562, 14307], 0.7382400223666736]], AbsoluteThickness[0.25], 
     LineBox[{10562, 10563}]}, 
    {Hue[
      NCache[
       Rational[3521, 4769], 0.7383099182218494]], AbsoluteThickness[0.25], 
     LineBox[{10563, 10564}]}, 
    {Hue[
      NCache[
       Rational[556, 753], 0.7383798140770252]], AbsoluteThickness[0.25], 
     LineBox[{10564, 10565}]}, 
    {Hue[
      NCache[
       Rational[10565, 14307], 0.738449709932201]], AbsoluteThickness[0.25], 
     LineBox[{10565, 10566}]}, 
    {Hue[
      NCache[
       Rational[3522, 4769], 0.7385196057873769]], AbsoluteThickness[0.25], 
     LineBox[{10566, 10567}]}, 
    {Hue[
      NCache[
       Rational[10567, 14307], 0.7385895016425525]], AbsoluteThickness[0.25], 
     LineBox[{10567, 10568}]}, 
    {Hue[
      NCache[
       Rational[10568, 14307], 0.7386593974977284]], AbsoluteThickness[0.25], 
     LineBox[{10568, 10569}]}, 
    {Hue[
      NCache[
       Rational[3523, 4769], 0.7387292933529042]], AbsoluteThickness[0.25], 
     LineBox[{10569, 10570}]}, 
    {Hue[
      NCache[
       Rational[10570, 14307], 0.73879918920808]], AbsoluteThickness[0.25], 
     LineBox[{10570, 10571}]}, 
    {Hue[
      NCache[
       Rational[10571, 14307], 0.7388690850632558]], AbsoluteThickness[0.25], 
     LineBox[{10571, 10572}]}, 
    {Hue[
      NCache[
       Rational[3524, 4769], 0.7389389809184316]], AbsoluteThickness[0.25], 
     LineBox[{10572, 10573}]}, 
    {Hue[
      NCache[
       Rational[10573, 14307], 0.7390088767736073]], AbsoluteThickness[0.25], 
     LineBox[{10573, 10574}]}, 
    {Hue[
      NCache[
       Rational[10574, 14307], 0.7390787726287831]], AbsoluteThickness[0.25], 
     LineBox[{10574, 10575}]}, 
    {Hue[
      NCache[
       Rational[3525, 4769], 0.7391486684839589]], AbsoluteThickness[0.25], 
     LineBox[{10575, 10576}]}, 
    {Hue[
      NCache[
       Rational[10576, 14307], 0.7392185643391347]], AbsoluteThickness[0.25], 
     LineBox[{10576, 10577}]}, 
    {Hue[
      NCache[
       Rational[10577, 14307], 0.7392884601943105]], AbsoluteThickness[0.25], 
     LineBox[{10577, 10578}]}, 
    {Hue[
      NCache[
       Rational[3526, 4769], 0.7393583560494863]], AbsoluteThickness[0.25], 
     LineBox[{10578, 10579}]}, 
    {Hue[
      NCache[
       Rational[10579, 14307], 0.7394282519046621]], AbsoluteThickness[0.25], 
     LineBox[{10579, 10580}]}, 
    {Hue[
      NCache[
       Rational[10580, 14307], 0.7394981477598378]], AbsoluteThickness[0.25], 
     LineBox[{10580, 10581}]}, 
    {Hue[
      NCache[
       Rational[3527, 4769], 0.7395680436150136]], AbsoluteThickness[0.25], 
     LineBox[{10581, 10582}]}, 
    {Hue[
      NCache[
       Rational[10582, 14307], 0.7396379394701894]], AbsoluteThickness[0.25], 
     LineBox[{10582, 10583}]}, 
    {Hue[
      NCache[
       Rational[557, 753], 0.7397078353253652]], AbsoluteThickness[0.25], 
     LineBox[{10583, 10584}]}, 
    {Hue[
      NCache[
       Rational[3528, 4769], 0.739777731180541]], AbsoluteThickness[0.25], 
     LineBox[{10584, 10585}]}, 
    {Hue[
      NCache[
       Rational[10585, 14307], 0.7398476270357168]], AbsoluteThickness[0.25], 
     LineBox[{10585, 10586}]}, 
    {Hue[
      NCache[
       Rational[10586, 14307], 0.7399175228908925]], AbsoluteThickness[0.25], 
     LineBox[{10586, 10587}]}, 
    {Hue[
      NCache[
       Rational[3529, 4769], 0.7399874187460683]], AbsoluteThickness[0.25], 
     LineBox[{10587, 10588}]}, 
    {Hue[
      NCache[
       Rational[10588, 14307], 0.7400573146012441]], AbsoluteThickness[0.25], 
     LineBox[{10588, 10589}]}, 
    {Hue[
      NCache[
       Rational[10589, 14307], 0.7401272104564199]], AbsoluteThickness[0.25], 
     LineBox[{10589, 10590}]}, 
    {Hue[
      NCache[
       Rational[3530, 4769], 0.7401971063115957]], AbsoluteThickness[0.25], 
     LineBox[{10590, 10591}]}, 
    {Hue[
      NCache[
       Rational[10591, 14307], 0.7402670021667715]], AbsoluteThickness[0.25], 
     LineBox[{10591, 10592}]}, 
    {Hue[
      NCache[
       Rational[10592, 14307], 0.7403368980219474]], AbsoluteThickness[0.25], 
     LineBox[{10592, 10593}]}, 
    {Hue[
      NCache[
       Rational[3531, 4769], 0.740406793877123]], AbsoluteThickness[0.25], 
     LineBox[{10593, 10594}]}, 
    {Hue[
      NCache[
       Rational[10594, 14307], 0.7404766897322989]], AbsoluteThickness[0.25], 
     LineBox[{10594, 10595}]}, 
    {Hue[
      NCache[
       Rational[10595, 14307], 0.7405465855874747]], AbsoluteThickness[0.25], 
     LineBox[{10595, 10596}]}, 
    {Hue[
      NCache[
       Rational[3532, 4769], 0.7406164814426505]], AbsoluteThickness[0.25], 
     LineBox[{10596, 10597}]}, 
    {Hue[
      NCache[
       Rational[10597, 14307], 0.7406863772978263]], AbsoluteThickness[0.25], 
     LineBox[{10597, 10598}]}, 
    {Hue[
      NCache[
       Rational[10598, 14307], 0.7407562731530021]], AbsoluteThickness[0.25], 
     LineBox[{10598, 10599}]}, 
    {Hue[
      NCache[
       Rational[3533, 4769], 0.7408261690081778]], AbsoluteThickness[0.25], 
     LineBox[{10599, 10600}]}, 
    {Hue[
      NCache[
       Rational[10600, 14307], 0.7408960648633536]], AbsoluteThickness[0.25], 
     LineBox[{10600, 10601}]}, 
    {Hue[
      NCache[
       Rational[10601, 14307], 0.7409659607185294]], AbsoluteThickness[0.25], 
     LineBox[{10601, 10602}]}, 
    {Hue[
      NCache[
       Rational[186, 251], 0.7410358565737052]], AbsoluteThickness[0.25], 
     LineBox[{10602, 10603}]}, 
    {Hue[
      NCache[
       Rational[10603, 14307], 0.741105752428881]], AbsoluteThickness[0.25], 
     LineBox[{10603, 10604}]}, 
    {Hue[
      NCache[
       Rational[10604, 14307], 0.7411756482840568]], AbsoluteThickness[0.25], 
     LineBox[{10604, 10605}]}, 
    {Hue[
      NCache[
       Rational[3535, 4769], 0.7412455441392325]], AbsoluteThickness[0.25], 
     LineBox[{10605, 10606}]}, 
    {Hue[
      NCache[
       Rational[10606, 14307], 0.7413154399944083]], AbsoluteThickness[0.25], 
     LineBox[{10606, 10607}]}, 
    {Hue[
      NCache[
       Rational[10607, 14307], 0.7413853358495841]], AbsoluteThickness[0.25], 
     LineBox[{10607, 10608}]}, 
    {Hue[
      NCache[
       Rational[3536, 4769], 0.7414552317047599]], AbsoluteThickness[0.25], 
     LineBox[{10608, 10609}]}, 
    {Hue[
      NCache[
       Rational[10609, 14307], 0.7415251275599357]], AbsoluteThickness[0.25], 
     LineBox[{10609, 10610}]}, 
    {Hue[
      NCache[
       Rational[10610, 14307], 0.7415950234151115]], AbsoluteThickness[0.25], 
     LineBox[{10610, 10611}]}, 
    {Hue[
      NCache[
       Rational[3537, 4769], 0.7416649192702873]], AbsoluteThickness[0.25], 
     LineBox[{10611, 10612}]}, 
    {Hue[
      NCache[
       Rational[10612, 14307], 0.741734815125463]], AbsoluteThickness[0.25], 
     LineBox[{10612, 10613}]}, 
    {Hue[
      NCache[
       Rational[10613, 14307], 0.7418047109806388]], AbsoluteThickness[0.25], 
     LineBox[{10613, 10614}]}, 
    {Hue[
      NCache[
       Rational[3538, 4769], 0.7418746068358146]], AbsoluteThickness[0.25], 
     LineBox[{10614, 10615}]}, 
    {Hue[
      NCache[
       Rational[10615, 14307], 0.7419445026909904]], AbsoluteThickness[0.25], 
     LineBox[{10615, 10616}]}, 
    {Hue[
      NCache[
       Rational[10616, 14307], 0.7420143985461662]], AbsoluteThickness[0.25], 
     LineBox[{10616, 10617}]}, 
    {Hue[
      NCache[
       Rational[3539, 4769], 0.742084294401342]], AbsoluteThickness[0.25], 
     LineBox[{10617, 10618}]}, 
    {Hue[
      NCache[
       Rational[10618, 14307], 0.7421541902565177]], AbsoluteThickness[0.25], 
     LineBox[{10618, 10619}]}, 
    {Hue[
      NCache[
       Rational[10619, 14307], 0.7422240861116935]], AbsoluteThickness[0.25], 
     LineBox[{10619, 10620}]}, 
    {Hue[
      NCache[
       Rational[3540, 4769], 0.7422939819668694]], AbsoluteThickness[0.25], 
     LineBox[{10620, 10621}]}, 
    {Hue[
      NCache[
       Rational[559, 753], 0.7423638778220452]], AbsoluteThickness[0.25], 
     LineBox[{10621, 10622}]}, 
    {Hue[
      NCache[
       Rational[10622, 14307], 0.742433773677221]], AbsoluteThickness[0.25], 
     LineBox[{10622, 10623}]}, 
    {Hue[
      NCache[
       Rational[3541, 4769], 0.7425036695323968]], AbsoluteThickness[0.25], 
     LineBox[{10623, 10624}]}, 
    {Hue[
      NCache[
       Rational[10624, 14307], 0.7425735653875725]], AbsoluteThickness[0.25], 
     LineBox[{10624, 10625}]}, 
    {Hue[
      NCache[
       Rational[10625, 14307], 0.7426434612427483]], AbsoluteThickness[0.25], 
     LineBox[{10625, 10626}]}, 
    {Hue[
      NCache[
       Rational[3542, 4769], 0.7427133570979241]], AbsoluteThickness[0.25], 
     LineBox[{10626, 10627}]}, 
    {Hue[
      NCache[
       Rational[10627, 14307], 0.7427832529530999]], AbsoluteThickness[0.25], 
     LineBox[{10627, 10628}]}, 
    {Hue[
      NCache[
       Rational[10628, 14307], 0.7428531488082757]], AbsoluteThickness[0.25], 
     LineBox[{10628, 10629}]}, 
    {Hue[
      NCache[
       Rational[3543, 4769], 0.7429230446634515]], AbsoluteThickness[0.25], 
     LineBox[{10629, 10630}]}, 
    {Hue[
      NCache[
       Rational[10630, 14307], 0.7429929405186273]], AbsoluteThickness[0.25], 
     LineBox[{10630, 10631}]}, 
    {Hue[
      NCache[
       Rational[10631, 14307], 0.743062836373803]], AbsoluteThickness[0.25], 
     LineBox[{10631, 10632}]}, 
    {Hue[
      NCache[
       Rational[3544, 4769], 0.7431327322289788]], AbsoluteThickness[0.25], 
     LineBox[{10632, 10633}]}, 
    {Hue[
      NCache[
       Rational[10633, 14307], 0.7432026280841546]], AbsoluteThickness[0.25], 
     LineBox[{10633, 10634}]}, 
    {Hue[
      NCache[
       Rational[10634, 14307], 0.7432725239393304]], AbsoluteThickness[0.25], 
     LineBox[{10634, 10635}]}, 
    {Hue[
      NCache[
       Rational[3545, 4769], 0.7433424197945062]], AbsoluteThickness[0.25], 
     LineBox[{10635, 10636}]}, 
    {Hue[
      NCache[
       Rational[10636, 14307], 0.743412315649682]], AbsoluteThickness[0.25], 
     LineBox[{10636, 10637}]}, 
    {Hue[
      NCache[
       Rational[10637, 14307], 0.7434822115048577]], AbsoluteThickness[0.25], 
     LineBox[{10637, 10638}]}, 
    {Hue[
      NCache[
       Rational[3546, 4769], 0.7435521073600335]], AbsoluteThickness[0.25], 
     LineBox[{10638, 10639}]}, 
    {Hue[
      NCache[
       Rational[10639, 14307], 0.7436220032152093]], AbsoluteThickness[0.25], 
     LineBox[{10639, 10640}]}, 
    {Hue[
      NCache[
       Rational[560, 753], 0.7436918990703851]], AbsoluteThickness[0.25], 
     LineBox[{10640, 10641}]}, 
    {Hue[
      NCache[
       Rational[3547, 4769], 0.7437617949255609]], AbsoluteThickness[0.25], 
     LineBox[{10641, 10642}]}, 
    {Hue[
      NCache[
       Rational[10642, 14307], 0.7438316907807367]], AbsoluteThickness[0.25], 
     LineBox[{10642, 10643}]}, 
    {Hue[
      NCache[
       Rational[10643, 14307], 0.7439015866359124]], AbsoluteThickness[0.25], 
     LineBox[{10643, 10644}]}, 
    {Hue[
      NCache[
       Rational[3548, 4769], 0.7439714824910882]], AbsoluteThickness[0.25], 
     LineBox[{10644, 10645}]}, 
    {Hue[
      NCache[
       Rational[10645, 14307], 0.744041378346264]], AbsoluteThickness[0.25], 
     LineBox[{10645, 10646}]}, 
    {Hue[
      NCache[
       Rational[10646, 14307], 0.7441112742014399]], AbsoluteThickness[0.25], 
     LineBox[{10646, 10647}]}, 
    {Hue[
      NCache[
       Rational[3549, 4769], 0.7441811700566157]], AbsoluteThickness[0.25], 
     LineBox[{10647, 10648}]}, 
    {Hue[
      NCache[
       Rational[10648, 14307], 0.7442510659117915]], AbsoluteThickness[0.25], 
     LineBox[{10648, 10649}]}, 
    {Hue[
      NCache[
       Rational[10649, 14307], 0.7443209617669673]], AbsoluteThickness[0.25], 
     LineBox[{10649, 10650}]}, 
    {Hue[
      NCache[
       Rational[3550, 4769], 0.744390857622143]], AbsoluteThickness[0.25], 
     LineBox[{10650, 10651}]}, 
    {Hue[
      NCache[
       Rational[10651, 14307], 0.7444607534773188]], AbsoluteThickness[0.25], 
     LineBox[{10651, 10652}]}, 
    {Hue[
      NCache[
       Rational[10652, 14307], 0.7445306493324946]], AbsoluteThickness[0.25], 
     LineBox[{10652, 10653}]}, 
    {Hue[
      NCache[
       Rational[3551, 4769], 0.7446005451876704]], AbsoluteThickness[0.25], 
     LineBox[{10653, 10654}]}, 
    {Hue[
      NCache[
       Rational[10654, 14307], 0.7446704410428462]], AbsoluteThickness[0.25], 
     LineBox[{10654, 10655}]}, 
    {Hue[
      NCache[
       Rational[10655, 14307], 0.744740336898022]], AbsoluteThickness[0.25], 
     LineBox[{10655, 10656}]}, 
    {Hue[
      NCache[
       Rational[3552, 4769], 0.7448102327531977]], AbsoluteThickness[0.25], 
     LineBox[{10656, 10657}]}, 
    {Hue[
      NCache[
       Rational[10657, 14307], 0.7448801286083735]], AbsoluteThickness[0.25], 
     LineBox[{10657, 10658}]}, 
    {Hue[
      NCache[
       Rational[10658, 14307], 0.7449500244635493]], AbsoluteThickness[0.25], 
     LineBox[{10658, 10659}]}, 
    {Hue[
      NCache[
       Rational[187, 251], 0.7450199203187251]], AbsoluteThickness[0.25], 
     LineBox[{10659, 10660}]}, 
    {Hue[
      NCache[
       Rational[10660, 14307], 0.7450898161739009]], AbsoluteThickness[0.25], 
     LineBox[{10660, 10661}]}, 
    {Hue[
      NCache[
       Rational[10661, 14307], 0.7451597120290767]], AbsoluteThickness[0.25], 
     LineBox[{10661, 10662}]}, 
    {Hue[
      NCache[
       Rational[3554, 4769], 0.7452296078842524]], AbsoluteThickness[0.25], 
     LineBox[{10662, 10663}]}, 
    {Hue[
      NCache[
       Rational[10663, 14307], 0.7452995037394282]], AbsoluteThickness[0.25], 
     LineBox[{10663, 10664}]}, 
    {Hue[
      NCache[
       Rational[10664, 14307], 0.745369399594604]], AbsoluteThickness[0.25], 
     LineBox[{10664, 10665}]}, 
    {Hue[
      NCache[
       Rational[3555, 4769], 0.7454392954497798]], AbsoluteThickness[0.25], 
     LineBox[{10665, 10666}]}, 
    {Hue[
      NCache[
       Rational[10666, 14307], 0.7455091913049556]], AbsoluteThickness[0.25], 
     LineBox[{10666, 10667}]}, 
    {Hue[
      NCache[
       Rational[10667, 14307], 0.7455790871601314]], AbsoluteThickness[0.25], 
     LineBox[{10667, 10668}]}, 
    {Hue[
      NCache[
       Rational[3556, 4769], 0.7456489830153072]], AbsoluteThickness[0.25], 
     LineBox[{10668, 10669}]}, 
    {Hue[
      NCache[
       Rational[10669, 14307], 0.7457188788704829]], AbsoluteThickness[0.25], 
     LineBox[{10669, 10670}]}, 
    {Hue[
      NCache[
       Rational[10670, 14307], 0.7457887747256587]], AbsoluteThickness[0.25], 
     LineBox[{10670, 10671}]}, 
    {Hue[
      NCache[
       Rational[3557, 4769], 0.7458586705808345]], AbsoluteThickness[0.25], 
     LineBox[{10671, 10672}]}, 
    {Hue[
      NCache[
       Rational[10672, 14307], 0.7459285664360104]], AbsoluteThickness[0.25], 
     LineBox[{10672, 10673}]}, 
    {Hue[
      NCache[
       Rational[10673, 14307], 0.7459984622911862]], AbsoluteThickness[0.25], 
     LineBox[{10673, 10674}]}, 
    {Hue[
      NCache[
       Rational[3558, 4769], 0.746068358146362]], AbsoluteThickness[0.25], 
     LineBox[{10674, 10675}]}, 
    {Hue[
      NCache[
       Rational[10675, 14307], 0.7461382540015377]], AbsoluteThickness[0.25], 
     LineBox[{10675, 10676}]}, 
    {Hue[
      NCache[
       Rational[10676, 14307], 0.7462081498567135]], AbsoluteThickness[0.25], 
     LineBox[{10676, 10677}]}, 
    {Hue[
      NCache[
       Rational[3559, 4769], 0.7462780457118893]], AbsoluteThickness[0.25], 
     LineBox[{10677, 10678}]}, 
    {Hue[
      NCache[
       Rational[562, 753], 0.7463479415670651]], AbsoluteThickness[0.25], 
     LineBox[{10678, 10679}]}, 
    {Hue[
      NCache[
       Rational[10679, 14307], 0.7464178374222409]], AbsoluteThickness[0.25], 
     LineBox[{10679, 10680}]}, 
    {Hue[
      NCache[
       Rational[3560, 4769], 0.7464877332774167]], AbsoluteThickness[0.25], 
     LineBox[{10680, 10681}]}, 
    {Hue[
      NCache[
       Rational[10681, 14307], 0.7465576291325924]], AbsoluteThickness[0.25], 
     LineBox[{10681, 10682}]}, 
    {Hue[
      NCache[
       Rational[10682, 14307], 0.7466275249877682]], AbsoluteThickness[0.25], 
     LineBox[{10682, 10683}]}, 
    {Hue[
      NCache[
       Rational[3561, 4769], 0.746697420842944]], AbsoluteThickness[0.25], 
     LineBox[{10683, 10684}]}, 
    {Hue[
      NCache[
       Rational[10684, 14307], 0.7467673166981198]], AbsoluteThickness[0.25], 
     LineBox[{10684, 10685}]}, 
    {Hue[
      NCache[
       Rational[10685, 14307], 0.7468372125532956]], AbsoluteThickness[0.25], 
     LineBox[{10685, 10686}]}, 
    {Hue[
      NCache[
       Rational[3562, 4769], 0.7469071084084714]], AbsoluteThickness[0.25], 
     LineBox[{10686, 10687}]}, 
    {Hue[
      NCache[
       Rational[10687, 14307], 0.7469770042636472]], AbsoluteThickness[0.25], 
     LineBox[{10687, 10688}]}, 
    {Hue[
      NCache[
       Rational[10688, 14307], 0.7470469001188229]], AbsoluteThickness[0.25], 
     LineBox[{10688, 10689}]}, 
    {Hue[
      NCache[
       Rational[3563, 4769], 0.7471167959739987]], AbsoluteThickness[0.25], 
     LineBox[{10689, 10690}]}, 
    {Hue[
      NCache[
       Rational[10690, 14307], 0.7471866918291745]], AbsoluteThickness[0.25], 
     LineBox[{10690, 10691}]}, 
    {Hue[
      NCache[
       Rational[10691, 14307], 0.7472565876843503]], AbsoluteThickness[0.25], 
     LineBox[{10691, 10692}]}, 
    {Hue[
      NCache[
       Rational[3564, 4769], 0.7473264835395261]], AbsoluteThickness[0.25], 
     LineBox[{10692, 10693}]}, 
    {Hue[
      NCache[
       Rational[10693, 14307], 0.7473963793947019]], AbsoluteThickness[0.25], 
     LineBox[{10693, 10694}]}, 
    {Hue[
      NCache[
       Rational[10694, 14307], 0.7474662752498776]], AbsoluteThickness[0.25], 
     LineBox[{10694, 10695}]}, 
    {Hue[
      NCache[
       Rational[3565, 4769], 0.7475361711050534]], AbsoluteThickness[0.25], 
     LineBox[{10695, 10696}]}, 
    {Hue[
      NCache[
       Rational[10696, 14307], 0.7476060669602292]], AbsoluteThickness[0.25], 
     LineBox[{10696, 10697}]}, 
    {Hue[
      NCache[
       Rational[563, 753], 0.747675962815405]], AbsoluteThickness[0.25], 
     LineBox[{10697, 10698}]}, 
    {Hue[
      NCache[
       Rational[3566, 4769], 0.7477458586705809]], AbsoluteThickness[0.25], 
     LineBox[{10698, 10699}]}, 
    {Hue[
      NCache[
       Rational[10699, 14307], 0.7478157545257567]], AbsoluteThickness[0.25], 
     LineBox[{10699, 10700}]}, 
    {Hue[
      NCache[
       Rational[10700, 14307], 0.7478856503809325]], AbsoluteThickness[0.25], 
     LineBox[{10700, 10701}]}, 
    {Hue[
      NCache[
       Rational[3567, 4769], 0.7479555462361082]], AbsoluteThickness[0.25], 
     LineBox[{10701, 10702}]}, 
    {Hue[
      NCache[
       Rational[10702, 14307], 0.748025442091284]], AbsoluteThickness[0.25], 
     LineBox[{10702, 10703}]}, 
    {Hue[
      NCache[
       Rational[10703, 14307], 0.7480953379464598]], AbsoluteThickness[0.25], 
     LineBox[{10703, 10704}]}, 
    {Hue[
      NCache[
       Rational[3568, 4769], 0.7481652338016356]], AbsoluteThickness[0.25], 
     LineBox[{10704, 10705}]}, 
    {Hue[
      NCache[
       Rational[10705, 14307], 0.7482351296568114]], AbsoluteThickness[0.25], 
     LineBox[{10705, 10706}]}, 
    {Hue[
      NCache[
       Rational[10706, 14307], 0.7483050255119872]], AbsoluteThickness[0.25], 
     LineBox[{10706, 10707}]}, 
    {Hue[
      NCache[
       Rational[3569, 4769], 0.7483749213671629]], AbsoluteThickness[0.25], 
     LineBox[{10707, 10708}]}, 
    {Hue[
      NCache[
       Rational[10708, 14307], 0.7484448172223387]], AbsoluteThickness[0.25], 
     LineBox[{10708, 10709}]}, 
    {Hue[
      NCache[
       Rational[10709, 14307], 0.7485147130775145]], AbsoluteThickness[0.25], 
     LineBox[{10709, 10710}]}, 
    {Hue[
      NCache[
       Rational[3570, 4769], 0.7485846089326903]], AbsoluteThickness[0.25], 
     LineBox[{10710, 10711}]}, 
    {Hue[
      NCache[
       Rational[10711, 14307], 0.7486545047878661]], AbsoluteThickness[0.25], 
     LineBox[{10711, 10712}]}, 
    {Hue[
      NCache[
       Rational[10712, 14307], 0.7487244006430419]], AbsoluteThickness[0.25], 
     LineBox[{10712, 10713}]}, 
    {Hue[
      NCache[
       Rational[3571, 4769], 0.7487942964982176]], AbsoluteThickness[0.25], 
     LineBox[{10713, 10714}]}, 
    {Hue[
      NCache[
       Rational[10714, 14307], 0.7488641923533934]], AbsoluteThickness[0.25], 
     LineBox[{10714, 10715}]}, 
    {Hue[
      NCache[
       Rational[10715, 14307], 0.7489340882085692]], AbsoluteThickness[0.25], 
     LineBox[{10715, 10716}]}, 
    {Hue[
      NCache[
       Rational[188, 251], 0.749003984063745]], AbsoluteThickness[0.25], 
     LineBox[{10716, 10717}]}, 
    {Hue[
      NCache[
       Rational[10717, 14307], 0.7490738799189208]], AbsoluteThickness[0.25], 
     LineBox[{10717, 10718}]}, 
    {Hue[
      NCache[
       Rational[10718, 14307], 0.7491437757740966]], AbsoluteThickness[0.25], 
     LineBox[{10718, 10719}]}, 
    {Hue[
      NCache[
       Rational[3573, 4769], 0.7492136716292724]], AbsoluteThickness[0.25], 
     LineBox[{10719, 10720}]}, 
    {Hue[
      NCache[
       Rational[10720, 14307], 0.7492835674844481]], AbsoluteThickness[0.25], 
     LineBox[{10720, 10721}]}, 
    {Hue[
      NCache[
       Rational[10721, 14307], 0.7493534633396239]], AbsoluteThickness[0.25], 
     LineBox[{10721, 10722}]}, 
    {Hue[
      NCache[
       Rational[3574, 4769], 0.7494233591947997]], AbsoluteThickness[0.25], 
     LineBox[{10722, 10723}]}, 
    {Hue[
      NCache[
       Rational[10723, 14307], 0.7494932550499755]], AbsoluteThickness[0.25], 
     LineBox[{10723, 10724}]}, 
    {Hue[
      NCache[
       Rational[10724, 14307], 0.7495631509051514]], AbsoluteThickness[0.25], 
     LineBox[{10724, 10725}]}, 
    {Hue[
      NCache[
       Rational[3575, 4769], 0.7496330467603272]], AbsoluteThickness[0.25], 
     LineBox[{10725, 10726}]}, 
    {Hue[
      NCache[
       Rational[10726, 14307], 0.7497029426155029]], AbsoluteThickness[0.25], 
     LineBox[{10726, 10727}]}, 
    {Hue[
      NCache[
       Rational[10727, 14307], 0.7497728384706787]], AbsoluteThickness[0.25], 
     LineBox[{10727, 10728}]}, 
    {Hue[
      NCache[
       Rational[3576, 4769], 0.7498427343258545]], AbsoluteThickness[0.25], 
     LineBox[{10728, 10729}]}, 
    {Hue[
      NCache[
       Rational[10729, 14307], 0.7499126301810303]], AbsoluteThickness[0.25], 
     LineBox[{10729, 10730}]}, 
    {Hue[
      NCache[
       Rational[10730, 14307], 0.7499825260362061]], AbsoluteThickness[0.25], 
     LineBox[{10730, 10731}]}, 
    {Hue[
      NCache[
       Rational[3577, 4769], 0.7500524218913819]], AbsoluteThickness[0.25], 
     LineBox[{10731, 10732}]}, 
    {Hue[
      NCache[
       Rational[10732, 14307], 0.7501223177465576]], AbsoluteThickness[0.25], 
     LineBox[{10732, 10733}]}, 
    {Hue[
      NCache[
       Rational[10733, 14307], 0.7501922136017334]], AbsoluteThickness[0.25], 
     LineBox[{10733, 10734}]}, 
    {Hue[
      NCache[
       Rational[3578, 4769], 0.7502621094569092]], AbsoluteThickness[0.25], 
     LineBox[{10734, 10735}]}, 
    {Hue[
      NCache[
       Rational[565, 753], 0.750332005312085]], AbsoluteThickness[0.25], 
     LineBox[{10735, 10736}]}, 
    {Hue[
      NCache[
       Rational[10736, 14307], 0.7504019011672608]], AbsoluteThickness[0.25], 
     LineBox[{10736, 10737}]}, 
    {Hue[
      NCache[
       Rational[3579, 4769], 0.7504717970224366]], AbsoluteThickness[0.25], 
     LineBox[{10737, 10738}]}, 
    {Hue[
      NCache[
       Rational[10738, 14307], 0.7505416928776124]], AbsoluteThickness[0.25], 
     LineBox[{10738, 10739}]}, 
    {Hue[
      NCache[
       Rational[10739, 14307], 0.7506115887327881]], AbsoluteThickness[0.25], 
     LineBox[{10739, 10740}]}, 
    {Hue[
      NCache[
       Rational[3580, 4769], 0.7506814845879639]], AbsoluteThickness[0.25], 
     LineBox[{10740, 10741}]}, 
    {Hue[
      NCache[
       Rational[10741, 14307], 0.7507513804431397]], AbsoluteThickness[0.25], 
     LineBox[{10741, 10742}]}, 
    {Hue[
      NCache[
       Rational[10742, 14307], 0.7508212762983155]], AbsoluteThickness[0.25], 
     LineBox[{10742, 10743}]}, 
    {Hue[
      NCache[
       Rational[3581, 4769], 0.7508911721534913]], AbsoluteThickness[0.25], 
     LineBox[{10743, 10744}]}, 
    {Hue[
      NCache[
       Rational[10744, 14307], 0.7509610680086671]], AbsoluteThickness[0.25], 
     LineBox[{10744, 10745}]}, 
    {Hue[
      NCache[
       Rational[10745, 14307], 0.7510309638638428]], AbsoluteThickness[0.25], 
     LineBox[{10745, 10746}]}, 
    {Hue[
      NCache[
       Rational[3582, 4769], 0.7511008597190186]], AbsoluteThickness[0.25], 
     LineBox[{10746, 10747}]}, 
    {Hue[
      NCache[
       Rational[10747, 14307], 0.7511707555741944]], AbsoluteThickness[0.25], 
     LineBox[{10747, 10748}]}, 
    {Hue[
      NCache[
       Rational[10748, 14307], 0.7512406514293702]], AbsoluteThickness[0.25], 
     LineBox[{10748, 10749}]}, 
    {Hue[
      NCache[
       Rational[3583, 4769], 0.751310547284546]], AbsoluteThickness[0.25], 
     LineBox[{10749, 10750}]}, 
    {Hue[
      NCache[
       Rational[10750, 14307], 0.7513804431397219]], AbsoluteThickness[0.25], 
     LineBox[{10750, 10751}]}, 
    {Hue[
      NCache[
       Rational[10751, 14307], 0.7514503389948975]], AbsoluteThickness[0.25], 
     LineBox[{10751, 10752}]}, 
    {Hue[
      NCache[
       Rational[3584, 4769], 0.7515202348500734]], AbsoluteThickness[0.25], 
     LineBox[{10752, 10753}]}, 
    {Hue[
      NCache[
       Rational[10753, 14307], 0.7515901307052492]], AbsoluteThickness[0.25], 
     LineBox[{10753, 10754}]}, 
    {Hue[
      NCache[
       Rational[566, 753], 0.751660026560425]], AbsoluteThickness[0.25], 
     LineBox[{10754, 10755}]}, 
    {Hue[
      NCache[
       Rational[3585, 4769], 0.7517299224156008]], AbsoluteThickness[0.25], 
     LineBox[{10755, 10756}]}, 
    {Hue[
      NCache[
       Rational[10756, 14307], 0.7517998182707766]], AbsoluteThickness[0.25], 
     LineBox[{10756, 10757}]}, 
    {Hue[
      NCache[
       Rational[10757, 14307], 0.7518697141259524]], AbsoluteThickness[0.25], 
     LineBox[{10757, 10758}]}, 
    {Hue[
      NCache[
       Rational[3586, 4769], 0.7519396099811281]], AbsoluteThickness[0.25], 
     LineBox[{10758, 10759}]}, 
    {Hue[
      NCache[
       Rational[10759, 14307], 0.7520095058363039]], AbsoluteThickness[0.25], 
     LineBox[{10759, 10760}]}, 
    {Hue[
      NCache[
       Rational[10760, 14307], 0.7520794016914797]], AbsoluteThickness[0.25], 
     LineBox[{10760, 10761}]}, 
    {Hue[
      NCache[
       Rational[3587, 4769], 0.7521492975466555]], AbsoluteThickness[0.25], 
     LineBox[{10761, 10762}]}, 
    {Hue[
      NCache[
       Rational[10762, 14307], 0.7522191934018313]], AbsoluteThickness[0.25], 
     LineBox[{10762, 10763}]}, 
    {Hue[
      NCache[
       Rational[10763, 14307], 0.7522890892570071]], AbsoluteThickness[0.25], 
     LineBox[{10763, 10764}]}, 
    {Hue[
      NCache[
       Rational[3588, 4769], 0.7523589851121828]], AbsoluteThickness[0.25], 
     LineBox[{10764, 10765}]}, 
    {Hue[
      NCache[
       Rational[10765, 14307], 0.7524288809673586]], AbsoluteThickness[0.25], 
     LineBox[{10765, 10766}]}, 
    {Hue[
      NCache[
       Rational[10766, 14307], 0.7524987768225344]], AbsoluteThickness[0.25], 
     LineBox[{10766, 10767}]}, 
    {Hue[
      NCache[
       Rational[3589, 4769], 0.7525686726777102]], AbsoluteThickness[0.25], 
     LineBox[{10767, 10768}]}, 
    {Hue[
      NCache[
       Rational[10768, 14307], 0.752638568532886]], AbsoluteThickness[0.25], 
     LineBox[{10768, 10769}]}, 
    {Hue[
      NCache[
       Rational[10769, 14307], 0.7527084643880618]], AbsoluteThickness[0.25], 
     LineBox[{10769, 10770}]}, 
    {Hue[
      NCache[
       Rational[3590, 4769], 0.7527783602432375]], AbsoluteThickness[0.25], 
     LineBox[{10770, 10771}]}, 
    {Hue[
      NCache[
       Rational[10771, 14307], 0.7528482560984133]], AbsoluteThickness[0.25], 
     LineBox[{10771, 10772}]}, 
    {Hue[
      NCache[
       Rational[10772, 14307], 0.7529181519535891]], AbsoluteThickness[0.25], 
     LineBox[{10772, 10773}]}, 
    {Hue[
      NCache[
       Rational[189, 251], 0.7529880478087649]], AbsoluteThickness[0.25], 
     LineBox[{10773, 10774}]}, 
    {Hue[
      NCache[
       Rational[10774, 14307], 0.7530579436639407]], AbsoluteThickness[0.25], 
     LineBox[{10774, 10775}]}, 
    {Hue[
      NCache[
       Rational[10775, 14307], 0.7531278395191165]], AbsoluteThickness[0.25], 
     LineBox[{10775, 10776}]}, 
    {Hue[
      NCache[
       Rational[3592, 4769], 0.7531977353742924]], AbsoluteThickness[0.25], 
     LineBox[{10776, 10777}]}, 
    {Hue[
      NCache[
       Rational[10777, 14307], 0.753267631229468]], AbsoluteThickness[0.25], 
     LineBox[{10777, 10778}]}, 
    {Hue[
      NCache[
       Rational[10778, 14307], 0.7533375270846439]], AbsoluteThickness[0.25], 
     LineBox[{10778, 10779}]}, 
    {Hue[
      NCache[
       Rational[3593, 4769], 0.7534074229398197]], AbsoluteThickness[0.25], 
     LineBox[{10779, 10780}]}, 
    {Hue[
      NCache[
       Rational[10780, 14307], 0.7534773187949955]], AbsoluteThickness[0.25], 
     LineBox[{10780, 10781}]}, 
    {Hue[
      NCache[
       Rational[10781, 14307], 0.7535472146501713]], AbsoluteThickness[0.25], 
     LineBox[{10781, 10782}]}, 
    {Hue[
      NCache[
       Rational[3594, 4769], 0.7536171105053471]], AbsoluteThickness[0.25], 
     LineBox[{10782, 10783}]}, 
    {Hue[
      NCache[
       Rational[10783, 14307], 0.7536870063605228]], AbsoluteThickness[0.25], 
     LineBox[{10783, 10784}]}, 
    {Hue[
      NCache[
       Rational[10784, 14307], 0.7537569022156986]], AbsoluteThickness[0.25], 
     LineBox[{10784, 10785}]}, 
    {Hue[
      NCache[
       Rational[3595, 4769], 0.7538267980708744]], AbsoluteThickness[0.25], 
     LineBox[{10785, 10786}]}, 
    {Hue[
      NCache[
       Rational[10786, 14307], 0.7538966939260502]], AbsoluteThickness[0.25], 
     LineBox[{10786, 10787}]}, 
    {Hue[
      NCache[
       Rational[10787, 14307], 0.753966589781226]], AbsoluteThickness[0.25], 
     LineBox[{10787, 10788}]}, 
    {Hue[
      NCache[
       Rational[3596, 4769], 0.7540364856364018]], AbsoluteThickness[0.25], 
     LineBox[{10788, 10789}]}, 
    {Hue[
      NCache[
       Rational[10789, 14307], 0.7541063814915776]], AbsoluteThickness[0.25], 
     LineBox[{10789, 10790}]}, 
    {Hue[
      NCache[
       Rational[10790, 14307], 0.7541762773467533]], AbsoluteThickness[0.25], 
     LineBox[{10790, 10791}]}, 
    {Hue[
      NCache[
       Rational[3597, 4769], 0.7542461732019291]], AbsoluteThickness[0.25], 
     LineBox[{10791, 10792}]}, 
    {Hue[
      NCache[
       Rational[568, 753], 0.7543160690571049]], AbsoluteThickness[0.25], 
     LineBox[{10792, 10793}]}, 
    {Hue[
      NCache[
       Rational[43, 57], 0.7543859649122807]], AbsoluteThickness[0.25], 
     LineBox[{10793, 10794}]}, 
    {Hue[
      NCache[
       Rational[3598, 4769], 0.7544558607674565]], AbsoluteThickness[0.25], 
     LineBox[{10794, 10795}]}, 
    {Hue[
      NCache[
       Rational[10795, 14307], 0.7545257566226323]], AbsoluteThickness[0.25], 
     LineBox[{10795, 10796}]}, 
    {Hue[
      NCache[
       Rational[10796, 14307], 0.754595652477808]], AbsoluteThickness[0.25], 
     LineBox[{10796, 10797}]}, 
    {Hue[
      NCache[
       Rational[3599, 4769], 0.7546655483329838]], AbsoluteThickness[0.25], 
     LineBox[{10797, 10798}]}, 
    {Hue[
      NCache[
       Rational[10798, 14307], 0.7547354441881596]], AbsoluteThickness[0.25], 
     LineBox[{10798, 10799}]}, 
    {Hue[
      NCache[
       Rational[10799, 14307], 0.7548053400433354]], AbsoluteThickness[0.25], 
     LineBox[{10799, 10800}]}, 
    {Hue[
      NCache[
       Rational[3600, 4769], 0.7548752358985112]], AbsoluteThickness[0.25], 
     LineBox[{10800, 10801}]}, 
    {Hue[
      NCache[
       Rational[10801, 14307], 0.754945131753687]], AbsoluteThickness[0.25], 
     LineBox[{10801, 10802}]}, 
    {Hue[
      NCache[
       Rational[10802, 14307], 0.7550150276088627]], AbsoluteThickness[0.25], 
     LineBox[{10802, 10803}]}, 
    {Hue[
      NCache[
       Rational[3601, 4769], 0.7550849234640385]], AbsoluteThickness[0.25], 
     LineBox[{10803, 10804}]}, 
    {Hue[
      NCache[
       Rational[10804, 14307], 0.7551548193192144]], AbsoluteThickness[0.25], 
     LineBox[{10804, 10805}]}, 
    {Hue[
      NCache[
       Rational[10805, 14307], 0.7552247151743902]], AbsoluteThickness[0.25], 
     LineBox[{10805, 10806}]}, 
    {Hue[
      NCache[
       Rational[3602, 4769], 0.755294611029566]], AbsoluteThickness[0.25], 
     LineBox[{10806, 10807}]}, 
    {Hue[
      NCache[
       Rational[10807, 14307], 0.7553645068847418]], AbsoluteThickness[0.25], 
     LineBox[{10807, 10808}]}, 
    {Hue[
      NCache[
       Rational[10808, 14307], 0.7554344027399176]], AbsoluteThickness[0.25], 
     LineBox[{10808, 10809}]}, 
    {Hue[
      NCache[
       Rational[3603, 4769], 0.7555042985950933]], AbsoluteThickness[0.25], 
     LineBox[{10809, 10810}]}, 
    {Hue[
      NCache[
       Rational[10810, 14307], 0.7555741944502691]], AbsoluteThickness[0.25], 
     LineBox[{10810, 10811}]}, 
    {Hue[
      NCache[
       Rational[569, 753], 0.7556440903054449]], AbsoluteThickness[0.25], 
     LineBox[{10811, 10812}]}, 
    {Hue[
      NCache[
       Rational[3604, 4769], 0.7557139861606207]], AbsoluteThickness[0.25], 
     LineBox[{10812, 10813}]}, 
    {Hue[
      NCache[
       Rational[10813, 14307], 0.7557838820157965]], AbsoluteThickness[0.25], 
     LineBox[{10813, 10814}]}, 
    {Hue[
      NCache[
       Rational[10814, 14307], 0.7558537778709723]], AbsoluteThickness[0.25], 
     LineBox[{10814, 10815}]}, 
    {Hue[
      NCache[
       Rational[3605, 4769], 0.755923673726148]], AbsoluteThickness[0.25], 
     LineBox[{10815, 10816}]}, 
    {Hue[
      NCache[
       Rational[10816, 14307], 0.7559935695813238]], AbsoluteThickness[0.25], 
     LineBox[{10816, 10817}]}, 
    {Hue[
      NCache[
       Rational[10817, 14307], 0.7560634654364996]], AbsoluteThickness[0.25], 
     LineBox[{10817, 10818}]}, 
    {Hue[
      NCache[
       Rational[3606, 4769], 0.7561333612916754]], AbsoluteThickness[0.25], 
     LineBox[{10818, 10819}]}, 
    {Hue[
      NCache[
       Rational[10819, 14307], 0.7562032571468512]], AbsoluteThickness[0.25], 
     LineBox[{10819, 10820}]}, 
    {Hue[
      NCache[
       Rational[10820, 14307], 0.756273153002027]], AbsoluteThickness[0.25], 
     LineBox[{10820, 10821}]}, 
    {Hue[
      NCache[
       Rational[3607, 4769], 0.7563430488572027]], AbsoluteThickness[0.25], 
     LineBox[{10821, 10822}]}, 
    {Hue[
      NCache[
       Rational[10822, 14307], 0.7564129447123785]], AbsoluteThickness[0.25], 
     LineBox[{10822, 10823}]}, 
    {Hue[
      NCache[
       Rational[10823, 14307], 0.7564828405675543]], AbsoluteThickness[0.25], 
     LineBox[{10823, 10824}]}, 
    {Hue[
      NCache[
       Rational[3608, 4769], 0.7565527364227301]], AbsoluteThickness[0.25], 
     LineBox[{10824, 10825}]}, 
    {Hue[
      NCache[
       Rational[10825, 14307], 0.7566226322779059]], AbsoluteThickness[0.25], 
     LineBox[{10825, 10826}]}, 
    {Hue[
      NCache[
       Rational[10826, 14307], 0.7566925281330817]], AbsoluteThickness[0.25], 
     LineBox[{10826, 10827}]}, 
    {Hue[
      NCache[
       Rational[3609, 4769], 0.7567624239882575]], AbsoluteThickness[0.25], 
     LineBox[{10827, 10828}]}, 
    {Hue[
      NCache[
       Rational[10828, 14307], 0.7568323198434332]], AbsoluteThickness[0.25], 
     LineBox[{10828, 10829}]}, 
    {Hue[
      NCache[
       Rational[10829, 14307], 0.756902215698609]], AbsoluteThickness[0.25], 
     LineBox[{10829, 10830}]}, 
    {Hue[
      NCache[
       Rational[190, 251], 0.7569721115537849]], AbsoluteThickness[0.25], 
     LineBox[{10830, 10831}]}, 
    {Hue[
      NCache[
       Rational[10831, 14307], 0.7570420074089607]], AbsoluteThickness[0.25], 
     LineBox[{10831, 10832}]}, 
    {Hue[
      NCache[
       Rational[10832, 14307], 0.7571119032641365]], AbsoluteThickness[0.25], 
     LineBox[{10832, 10833}]}, 
    {Hue[
      NCache[
       Rational[3611, 4769], 0.7571817991193123]], AbsoluteThickness[0.25], 
     LineBox[{10833, 10834}]}, 
    {Hue[
      NCache[
       Rational[10834, 14307], 0.757251694974488]], AbsoluteThickness[0.25], 
     LineBox[{10834, 10835}]}, 
    {Hue[
      NCache[
       Rational[10835, 14307], 0.7573215908296638]], AbsoluteThickness[0.25], 
     LineBox[{10835, 10836}]}, 
    {Hue[
      NCache[
       Rational[3612, 4769], 0.7573914866848396]], AbsoluteThickness[0.25], 
     LineBox[{10836, 10837}]}, 
    {Hue[
      NCache[
       Rational[10837, 14307], 0.7574613825400154]], AbsoluteThickness[0.25], 
     LineBox[{10837, 10838}]}, 
    {Hue[
      NCache[
       Rational[10838, 14307], 0.7575312783951912]], AbsoluteThickness[0.25], 
     LineBox[{10838, 10839}]}, 
    {Hue[
      NCache[
       Rational[3613, 4769], 0.757601174250367]], AbsoluteThickness[0.25], 
     LineBox[{10839, 10840}]}, 
    {Hue[
      NCache[
       Rational[10840, 14307], 0.7576710701055427]], AbsoluteThickness[0.25], 
     LineBox[{10840, 10841}]}, 
    {Hue[
      NCache[
       Rational[10841, 14307], 0.7577409659607185]], AbsoluteThickness[0.25], 
     LineBox[{10841, 10842}]}, 
    {Hue[
      NCache[
       Rational[3614, 4769], 0.7578108618158943]], AbsoluteThickness[0.25], 
     LineBox[{10842, 10843}]}, 
    {Hue[
      NCache[
       Rational[10843, 14307], 0.7578807576710701]], AbsoluteThickness[0.25], 
     LineBox[{10843, 10844}]}, 
    {Hue[
      NCache[
       Rational[10844, 14307], 0.7579506535262459]], AbsoluteThickness[0.25], 
     LineBox[{10844, 10845}]}, 
    {Hue[
      NCache[
       Rational[3615, 4769], 0.7580205493814217]], AbsoluteThickness[0.25], 
     LineBox[{10845, 10846}]}, 
    {Hue[
      NCache[
       Rational[10846, 14307], 0.7580904452365975]], AbsoluteThickness[0.25], 
     LineBox[{10846, 10847}]}, 
    {Hue[
      NCache[
       Rational[10847, 14307], 0.7581603410917732]], AbsoluteThickness[0.25], 
     LineBox[{10847, 10848}]}, 
    {Hue[
      NCache[
       Rational[3616, 4769], 0.758230236946949]], AbsoluteThickness[0.25], 
     LineBox[{10848, 10849}]}, 
    {Hue[
      NCache[
       Rational[571, 753], 0.7583001328021248]], AbsoluteThickness[0.25], 
     LineBox[{10849, 10850}]}, 
    {Hue[
      NCache[
       Rational[10850, 14307], 0.7583700286573006]], AbsoluteThickness[0.25], 
     LineBox[{10850, 10851}]}, 
    {Hue[
      NCache[
       Rational[3617, 4769], 0.7584399245124764]], AbsoluteThickness[0.25], 
     LineBox[{10851, 10852}]}, 
    {Hue[
      NCache[
       Rational[10852, 14307], 0.7585098203676522]], AbsoluteThickness[0.25], 
     LineBox[{10852, 10853}]}, 
    {Hue[
      NCache[
       Rational[10853, 14307], 0.7585797162228279]], AbsoluteThickness[0.25], 
     LineBox[{10853, 10854}]}, 
    {Hue[
      NCache[
       Rational[3618, 4769], 0.7586496120780037]], AbsoluteThickness[0.25], 
     LineBox[{10854, 10855}]}, 
    {Hue[
      NCache[
       Rational[10855, 14307], 0.7587195079331795]], AbsoluteThickness[0.25], 
     LineBox[{10855, 10856}]}, 
    {Hue[
      NCache[
       Rational[10856, 14307], 0.7587894037883554]], AbsoluteThickness[0.25], 
     LineBox[{10856, 10857}]}, 
    {Hue[
      NCache[
       Rational[3619, 4769], 0.7588592996435312]], AbsoluteThickness[0.25], 
     LineBox[{10857, 10858}]}, 
    {Hue[
      NCache[
       Rational[10858, 14307], 0.758929195498707]], AbsoluteThickness[0.25], 
     LineBox[{10858, 10859}]}, 
    {Hue[
      NCache[
       Rational[10859, 14307], 0.7589990913538827]], AbsoluteThickness[0.25], 
     LineBox[{10859, 10860}]}, 
    {Hue[
      NCache[
       Rational[3620, 4769], 0.7590689872090585]], AbsoluteThickness[0.25], 
     LineBox[{10860, 10861}]}, 
    {Hue[
      NCache[
       Rational[10861, 14307], 0.7591388830642343]], AbsoluteThickness[0.25], 
     LineBox[{10861, 10862}]}, 
    {Hue[
      NCache[
       Rational[10862, 14307], 0.7592087789194101]], AbsoluteThickness[0.25], 
     LineBox[{10862, 10863}]}, 
    {Hue[
      NCache[
       Rational[3621, 4769], 0.7592786747745859]], AbsoluteThickness[0.25], 
     LineBox[{10863, 10864}]}, 
    {Hue[
      NCache[
       Rational[10864, 14307], 0.7593485706297617]], AbsoluteThickness[0.25], 
     LineBox[{10864, 10865}]}, 
    {Hue[
      NCache[
       Rational[10865, 14307], 0.7594184664849375]], AbsoluteThickness[0.25], 
     LineBox[{10865, 10866}]}, 
    {Hue[
      NCache[
       Rational[3622, 4769], 0.7594883623401132]], AbsoluteThickness[0.25], 
     LineBox[{10866, 10867}]}, 
    {Hue[
      NCache[
       Rational[10867, 14307], 0.759558258195289]], AbsoluteThickness[0.25], 
     LineBox[{10867, 10868}]}, 
    {Hue[
      NCache[
       Rational[572, 753], 0.7596281540504648]], AbsoluteThickness[0.25], 
     LineBox[{10868, 10869}]}, 
    {Hue[
      NCache[
       Rational[3623, 4769], 0.7596980499056406]], AbsoluteThickness[0.25], 
     LineBox[{10869, 10870}]}, 
    {Hue[
      NCache[
       Rational[10870, 14307], 0.7597679457608164]], AbsoluteThickness[0.25], 
     LineBox[{10870, 10871}]}, 
    {Hue[
      NCache[
       Rational[10871, 14307], 0.7598378416159922]], AbsoluteThickness[0.25], 
     LineBox[{10871, 10872}]}, 
    {Hue[
      NCache[
       Rational[3624, 4769], 0.7599077374711679]], AbsoluteThickness[0.25], 
     LineBox[{10872, 10873}]}, 
    {Hue[
      NCache[
       Rational[10873, 14307], 0.7599776333263437]], AbsoluteThickness[0.25], 
     LineBox[{10873, 10874}]}, 
    {Hue[
      NCache[
       Rational[10874, 14307], 0.7600475291815195]], AbsoluteThickness[0.25], 
     LineBox[{10874, 10875}]}, 
    {Hue[
      NCache[
       Rational[3625, 4769], 0.7601174250366953]], AbsoluteThickness[0.25], 
     LineBox[{10875, 10876}]}, 
    {Hue[
      NCache[
       Rational[10876, 14307], 0.7601873208918711]], AbsoluteThickness[0.25], 
     LineBox[{10876, 10877}]}, 
    {Hue[
      NCache[
       Rational[10877, 14307], 0.7602572167470469]], AbsoluteThickness[0.25], 
     LineBox[{10877, 10878}]}, 
    {Hue[
      NCache[
       Rational[3626, 4769], 0.7603271126022227]], AbsoluteThickness[0.25], 
     LineBox[{10878, 10879}]}, 
    {Hue[
      NCache[
       Rational[10879, 14307], 0.7603970084573984]], AbsoluteThickness[0.25], 
     LineBox[{10879, 10880}]}, 
    {Hue[
      NCache[
       Rational[10880, 14307], 0.7604669043125742]], AbsoluteThickness[0.25], 
     LineBox[{10880, 10881}]}, 
    {Hue[
      NCache[
       Rational[3627, 4769], 0.76053680016775]], AbsoluteThickness[0.25], 
     LineBox[{10881, 10882}]}, 
    {Hue[
      NCache[
       Rational[10882, 14307], 0.7606066960229259]], AbsoluteThickness[0.25], 
     LineBox[{10882, 10883}]}, 
    {Hue[
      NCache[
       Rational[10883, 14307], 0.7606765918781017]], AbsoluteThickness[0.25], 
     LineBox[{10883, 10884}]}, 
    {Hue[
      NCache[
       Rational[3628, 4769], 0.7607464877332775]], AbsoluteThickness[0.25], 
     LineBox[{10884, 10885}]}, 
    {Hue[
      NCache[
       Rational[10885, 14307], 0.7608163835884532]], AbsoluteThickness[0.25], 
     LineBox[{10885, 10886}]}, 
    {Hue[
      NCache[
       Rational[10886, 14307], 0.760886279443629]], AbsoluteThickness[0.25], 
     LineBox[{10886, 10887}]}, 
    {Hue[
      NCache[
       Rational[191, 251], 0.7609561752988048]], AbsoluteThickness[0.25], 
     LineBox[{10887, 10888}]}, 
    {Hue[
      NCache[
       Rational[10888, 14307], 0.7610260711539806]], AbsoluteThickness[0.25], 
     LineBox[{10888, 10889}]}, 
    {Hue[
      NCache[
       Rational[10889, 14307], 0.7610959670091564]], AbsoluteThickness[0.25], 
     LineBox[{10889, 10890}]}, 
    {Hue[
      NCache[
       Rational[3630, 4769], 0.7611658628643322]], AbsoluteThickness[0.25], 
     LineBox[{10890, 10891}]}, 
    {Hue[
      NCache[
       Rational[10891, 14307], 0.7612357587195079]], AbsoluteThickness[0.25], 
     LineBox[{10891, 10892}]}, 
    {Hue[
      NCache[
       Rational[10892, 14307], 0.7613056545746837]], AbsoluteThickness[0.25], 
     LineBox[{10892, 10893}]}, 
    {Hue[
      NCache[
       Rational[3631, 4769], 0.7613755504298595]], AbsoluteThickness[0.25], 
     LineBox[{10893, 10894}]}, 
    {Hue[
      NCache[
       Rational[10894, 14307], 0.7614454462850353]], AbsoluteThickness[0.25], 
     LineBox[{10894, 10895}]}, 
    {Hue[
      NCache[
       Rational[10895, 14307], 0.7615153421402111]], AbsoluteThickness[0.25], 
     LineBox[{10895, 10896}]}, 
    {Hue[
      NCache[
       Rational[3632, 4769], 0.7615852379953869]], AbsoluteThickness[0.25], 
     LineBox[{10896, 10897}]}, 
    {Hue[
      NCache[
       Rational[10897, 14307], 0.7616551338505627]], AbsoluteThickness[0.25], 
     LineBox[{10897, 10898}]}, 
    {Hue[
      NCache[
       Rational[10898, 14307], 0.7617250297057384]], AbsoluteThickness[0.25], 
     LineBox[{10898, 10899}]}, 
    {Hue[
      NCache[
       Rational[3633, 4769], 0.7617949255609142]], AbsoluteThickness[0.25], 
     LineBox[{10899, 10900}]}, 
    {Hue[
      NCache[
       Rational[10900, 14307], 0.76186482141609]], AbsoluteThickness[0.25], 
     LineBox[{10900, 10901}]}, 
    {Hue[
      NCache[
       Rational[10901, 14307], 0.7619347172712658]], AbsoluteThickness[0.25], 
     LineBox[{10901, 10902}]}, 
    {Hue[
      NCache[
       Rational[3634, 4769], 0.7620046131264416]], AbsoluteThickness[0.25], 
     LineBox[{10902, 10903}]}, 
    {Hue[
      NCache[
       Rational[10903, 14307], 0.7620745089816174]], AbsoluteThickness[0.25], 
     LineBox[{10903, 10904}]}, 
    {Hue[
      NCache[
       Rational[10904, 14307], 0.7621444048367931]], AbsoluteThickness[0.25], 
     LineBox[{10904, 10905}]}, 
    {Hue[
      NCache[
       Rational[3635, 4769], 0.7622143006919689]], AbsoluteThickness[0.25], 
     LineBox[{10905, 10906}]}, 
    {Hue[
      NCache[
       Rational[574, 753], 0.7622841965471447]], AbsoluteThickness[0.25], 
     LineBox[{10906, 10907}]}, 
    {Hue[
      NCache[
       Rational[10907, 14307], 0.7623540924023205]], AbsoluteThickness[0.25], 
     LineBox[{10907, 10908}]}, 
    {Hue[
      NCache[
       Rational[3636, 4769], 0.7624239882574964]], AbsoluteThickness[0.25], 
     LineBox[{10908, 10909}]}, 
    {Hue[
      NCache[
       Rational[10909, 14307], 0.7624938841126722]], AbsoluteThickness[0.25], 
     LineBox[{10909, 10910}]}, 
    {Hue[
      NCache[
       Rational[10910, 14307], 0.7625637799678479]], AbsoluteThickness[0.25], 
     LineBox[{10910, 10911}]}, 
    {Hue[
      NCache[
       Rational[3637, 4769], 0.7626336758230237]], AbsoluteThickness[0.25], 
     LineBox[{10911, 10912}]}, 
    {Hue[
      NCache[
       Rational[10912, 14307], 0.7627035716781995]], AbsoluteThickness[0.25], 
     LineBox[{10912, 10913}]}, 
    {Hue[
      NCache[
       Rational[10913, 14307], 0.7627734675333753]], AbsoluteThickness[0.25], 
     LineBox[{10913, 10914}]}, 
    {Hue[
      NCache[
       Rational[3638, 4769], 0.7628433633885511]], AbsoluteThickness[0.25], 
     LineBox[{10914, 10915}]}, 
    {Hue[
      NCache[
       Rational[10915, 14307], 0.7629132592437269]], AbsoluteThickness[0.25], 
     LineBox[{10915, 10916}]}, 
    {Hue[
      NCache[
       Rational[10916, 14307], 0.7629831550989027]], AbsoluteThickness[0.25], 
     LineBox[{10916, 10917}]}, 
    {Hue[
      NCache[
       Rational[3639, 4769], 0.7630530509540784]], AbsoluteThickness[0.25], 
     LineBox[{10917, 10918}]}, 
    {Hue[
      NCache[
       Rational[10918, 14307], 0.7631229468092542]], AbsoluteThickness[0.25], 
     LineBox[{10918, 10919}]}, 
    {Hue[
      NCache[
       Rational[10919, 14307], 0.76319284266443]], AbsoluteThickness[0.25], 
     LineBox[{10919, 10920}]}, 
    {Hue[
      NCache[
       Rational[3640, 4769], 0.7632627385196058]], AbsoluteThickness[0.25], 
     LineBox[{10920, 10921}]}, 
    {Hue[
      NCache[
       Rational[10921, 14307], 0.7633326343747816]], AbsoluteThickness[0.25], 
     LineBox[{10921, 10922}]}, 
    {Hue[
      NCache[
       Rational[10922, 14307], 0.7634025302299574]], AbsoluteThickness[0.25], 
     LineBox[{10922, 10923}]}, 
    {Hue[
      NCache[
       Rational[3641, 4769], 0.7634724260851331]], AbsoluteThickness[0.25], 
     LineBox[{10923, 10924}]}, 
    {Hue[
      NCache[
       Rational[10924, 14307], 0.7635423219403089]], AbsoluteThickness[0.25], 
     LineBox[{10924, 10925}]}, 
    {Hue[
      NCache[
       Rational[575, 753], 0.7636122177954847]], AbsoluteThickness[0.25], 
     LineBox[{10925, 10926}]}, 
    {Hue[
      NCache[
       Rational[3642, 4769], 0.7636821136506605]], AbsoluteThickness[0.25], 
     LineBox[{10926, 10927}]}, 
    {Hue[
      NCache[
       Rational[10927, 14307], 0.7637520095058363]], AbsoluteThickness[0.25], 
     LineBox[{10927, 10928}]}, 
    {Hue[
      NCache[
       Rational[10928, 14307], 0.7638219053610121]], AbsoluteThickness[0.25], 
     LineBox[{10928, 10929}]}, 
    {Hue[
      NCache[
       Rational[3643, 4769], 0.7638918012161878]], AbsoluteThickness[0.25], 
     LineBox[{10929, 10930}]}, 
    {Hue[
      NCache[
       Rational[10930, 14307], 0.7639616970713636]], AbsoluteThickness[0.25], 
     LineBox[{10930, 10931}]}, 
    {Hue[
      NCache[
       Rational[10931, 14307], 0.7640315929265394]], AbsoluteThickness[0.25], 
     LineBox[{10931, 10932}]}, 
    {Hue[
      NCache[
       Rational[3644, 4769], 0.7641014887817152]], AbsoluteThickness[0.25], 
     LineBox[{10932, 10933}]}, 
    {Hue[
      NCache[
       Rational[10933, 14307], 0.764171384636891]], AbsoluteThickness[0.25], 
     LineBox[{10933, 10934}]}, 
    {Hue[
      NCache[
       Rational[10934, 14307], 0.7642412804920669]], AbsoluteThickness[0.25], 
     LineBox[{10934, 10935}]}, 
    {Hue[
      NCache[
       Rational[3645, 4769], 0.7643111763472427]], AbsoluteThickness[0.25], 
     LineBox[{10935, 10936}]}, 
    {Hue[
      NCache[
       Rational[10936, 14307], 0.7643810722024184]], AbsoluteThickness[0.25], 
     LineBox[{10936, 10937}]}, 
    {Hue[
      NCache[
       Rational[10937, 14307], 0.7644509680575942]], AbsoluteThickness[0.25], 
     LineBox[{10937, 10938}]}, 
    {Hue[
      NCache[
       Rational[3646, 4769], 0.76452086391277]], AbsoluteThickness[0.25], 
     LineBox[{10938, 10939}]}, 
    {Hue[
      NCache[
       Rational[10939, 14307], 0.7645907597679458]], AbsoluteThickness[0.25], 
     LineBox[{10939, 10940}]}, 
    {Hue[
      NCache[
       Rational[10940, 14307], 0.7646606556231216]], AbsoluteThickness[0.25], 
     LineBox[{10940, 10941}]}, 
    {Hue[
      NCache[
       Rational[3647, 4769], 0.7647305514782974]], AbsoluteThickness[0.25], 
     LineBox[{10941, 10942}]}, 
    {Hue[
      NCache[
       Rational[10942, 14307], 0.7648004473334731]], AbsoluteThickness[0.25], 
     LineBox[{10942, 10943}]}, 
    {Hue[
      NCache[
       Rational[10943, 14307], 0.7648703431886489]], AbsoluteThickness[0.25], 
     LineBox[{10943, 10944}]}, 
    {Hue[
      NCache[
       Rational[192, 251], 0.7649402390438247]], AbsoluteThickness[0.25], 
     LineBox[{10944, 10945}]}, 
    {Hue[
      NCache[
       Rational[10945, 14307], 0.7650101348990005]], AbsoluteThickness[0.25], 
     LineBox[{10945, 10946}]}, 
    {Hue[
      NCache[
       Rational[10946, 14307], 0.7650800307541763]], AbsoluteThickness[0.25], 
     LineBox[{10946, 10947}]}, 
    {Hue[
      NCache[
       Rational[3649, 4769], 0.7651499266093521]], AbsoluteThickness[0.25], 
     LineBox[{10947, 10948}]}, 
    {Hue[
      NCache[
       Rational[10948, 14307], 0.7652198224645278]], AbsoluteThickness[0.25], 
     LineBox[{10948, 10949}]}, 
    {Hue[
      NCache[
       Rational[10949, 14307], 0.7652897183197036]], AbsoluteThickness[0.25], 
     LineBox[{10949, 10950}]}, 
    {Hue[
      NCache[
       Rational[3650, 4769], 0.7653596141748794]], AbsoluteThickness[0.25], 
     LineBox[{10950, 10951}]}, 
    {Hue[
      NCache[
       Rational[10951, 14307], 0.7654295100300552]], AbsoluteThickness[0.25], 
     LineBox[{10951, 10952}]}, 
    {Hue[
      NCache[
       Rational[10952, 14307], 0.765499405885231]], AbsoluteThickness[0.25], 
     LineBox[{10952, 10953}]}, 
    {Hue[
      NCache[
       Rational[3651, 4769], 0.7655693017404068]], AbsoluteThickness[0.25], 
     LineBox[{10953, 10954}]}, 
    {Hue[
      NCache[
       Rational[10954, 14307], 0.7656391975955826]], AbsoluteThickness[0.25], 
     LineBox[{10954, 10955}]}, 
    {Hue[
      NCache[
       Rational[10955, 14307], 0.7657090934507583]], AbsoluteThickness[0.25], 
     LineBox[{10955, 10956}]}, 
    {Hue[
      NCache[
       Rational[3652, 4769], 0.7657789893059341]], AbsoluteThickness[0.25], 
     LineBox[{10956, 10957}]}, 
    {Hue[
      NCache[
       Rational[10957, 14307], 0.7658488851611099]], AbsoluteThickness[0.25], 
     LineBox[{10957, 10958}]}, 
    {Hue[
      NCache[
       Rational[10958, 14307], 0.7659187810162857]], AbsoluteThickness[0.25], 
     LineBox[{10958, 10959}]}, 
    {Hue[
      NCache[
       Rational[3653, 4769], 0.7659886768714615]], AbsoluteThickness[0.25], 
     LineBox[{10959, 10960}]}, 
    {Hue[
      NCache[
       Rational[10960, 14307], 0.7660585727266374]], AbsoluteThickness[0.25], 
     LineBox[{10960, 10961}]}, 
    {Hue[
      NCache[
       Rational[10961, 14307], 0.766128468581813]], AbsoluteThickness[0.25], 
     LineBox[{10961, 10962}]}, 
    {Hue[
      NCache[
       Rational[3654, 4769], 0.7661983644369889]], AbsoluteThickness[0.25], 
     LineBox[{10962, 10963}]}, 
    {Hue[
      NCache[
       Rational[577, 753], 0.7662682602921647]], AbsoluteThickness[0.25], 
     LineBox[{10963, 10964}]}, 
    {Hue[
      NCache[
       Rational[10964, 14307], 0.7663381561473405]], AbsoluteThickness[0.25], 
     LineBox[{10964, 10965}]}, 
    {Hue[
      NCache[
       Rational[3655, 4769], 0.7664080520025163]], AbsoluteThickness[0.25], 
     LineBox[{10965, 10966}]}, 
    {Hue[
      NCache[
       Rational[10966, 14307], 0.7664779478576921]], AbsoluteThickness[0.25], 
     LineBox[{10966, 10967}]}, 
    {Hue[
      NCache[
       Rational[10967, 14307], 0.7665478437128679]], AbsoluteThickness[0.25], 
     LineBox[{10967, 10968}]}, 
    {Hue[
      NCache[
       Rational[3656, 4769], 0.7666177395680436]], AbsoluteThickness[0.25], 
     LineBox[{10968, 10969}]}, 
    {Hue[
      NCache[
       Rational[10969, 14307], 0.7666876354232194]], AbsoluteThickness[0.25], 
     LineBox[{10969, 10970}]}, 
    {Hue[
      NCache[
       Rational[10970, 14307], 0.7667575312783952]], AbsoluteThickness[0.25], 
     LineBox[{10970, 10971}]}, 
    {Hue[
      NCache[
       Rational[3657, 4769], 0.766827427133571]], AbsoluteThickness[0.25], 
     LineBox[{10971, 10972}]}, 
    {Hue[
      NCache[
       Rational[10972, 14307], 0.7668973229887468]], AbsoluteThickness[0.25], 
     LineBox[{10972, 10973}]}, 
    {Hue[
      NCache[
       Rational[10973, 14307], 0.7669672188439226]], AbsoluteThickness[0.25], 
     LineBox[{10973, 10974}]}, 
    {Hue[
      NCache[
       Rational[3658, 4769], 0.7670371146990983]], AbsoluteThickness[0.25], 
     LineBox[{10974, 10975}]}, 
    {Hue[
      NCache[
       Rational[10975, 14307], 0.7671070105542741]], AbsoluteThickness[0.25], 
     LineBox[{10975, 10976}]}, 
    {Hue[
      NCache[
       Rational[10976, 14307], 0.7671769064094499]], AbsoluteThickness[0.25], 
     LineBox[{10976, 10977}]}, 
    {Hue[
      NCache[
       Rational[3659, 4769], 0.7672468022646257]], AbsoluteThickness[0.25], 
     LineBox[{10977, 10978}]}, 
    {Hue[
      NCache[
       Rational[10978, 14307], 0.7673166981198015]], AbsoluteThickness[0.25], 
     LineBox[{10978, 10979}]}, 
    {Hue[
      NCache[
       Rational[10979, 14307], 0.7673865939749773]], AbsoluteThickness[0.25], 
     LineBox[{10979, 10980}]}, 
    {Hue[
      NCache[
       Rational[3660, 4769], 0.767456489830153]], AbsoluteThickness[0.25], 
     LineBox[{10980, 10981}]}, 
    {Hue[
      NCache[
       Rational[10981, 14307], 0.7675263856853288]], AbsoluteThickness[0.25], 
     LineBox[{10981, 10982}]}, 
    {Hue[
      NCache[
       Rational[578, 753], 0.7675962815405046]], AbsoluteThickness[0.25], 
     LineBox[{10982, 10983}]}, 
    {Hue[
      NCache[
       Rational[3661, 4769], 0.7676661773956804]], AbsoluteThickness[0.25], 
     LineBox[{10983, 10984}]}, 
    {Hue[
      NCache[
       Rational[10984, 14307], 0.7677360732508562]], AbsoluteThickness[0.25], 
     LineBox[{10984, 10985}]}, 
    {Hue[
      NCache[
       Rational[10985, 14307], 0.767805969106032]], AbsoluteThickness[0.25], 
     LineBox[{10985, 10986}]}, 
    {Hue[
      NCache[
       Rational[3662, 4769], 0.7678758649612079]], AbsoluteThickness[0.25], 
     LineBox[{10986, 10987}]}, 
    {Hue[
      NCache[
       Rational[10987, 14307], 0.7679457608163835]], AbsoluteThickness[0.25], 
     LineBox[{10987, 10988}]}, 
    {Hue[
      NCache[
       Rational[10988, 14307], 0.7680156566715594]], AbsoluteThickness[0.25], 
     LineBox[{10988, 10989}]}, 
    {Hue[
      NCache[
       Rational[3663, 4769], 0.7680855525267352]], AbsoluteThickness[0.25], 
     LineBox[{10989, 10990}]}, 
    {Hue[
      NCache[
       Rational[10990, 14307], 0.768155448381911]], AbsoluteThickness[0.25], 
     LineBox[{10990, 10991}]}, 
    {Hue[
      NCache[
       Rational[10991, 14307], 0.7682253442370868]], AbsoluteThickness[0.25], 
     LineBox[{10991, 10992}]}, 
    {Hue[
      NCache[
       Rational[3664, 4769], 0.7682952400922626]], AbsoluteThickness[0.25], 
     LineBox[{10992, 10993}]}, 
    {Hue[
      NCache[
       Rational[10993, 14307], 0.7683651359474383]], AbsoluteThickness[0.25], 
     LineBox[{10993, 10994}]}, 
    {Hue[
      NCache[
       Rational[10994, 14307], 0.7684350318026141]], AbsoluteThickness[0.25], 
     LineBox[{10994, 10995}]}, 
    {Hue[
      NCache[
       Rational[3665, 4769], 0.7685049276577899]], AbsoluteThickness[0.25], 
     LineBox[{10995, 10996}]}, 
    {Hue[
      NCache[
       Rational[10996, 14307], 0.7685748235129657]], AbsoluteThickness[0.25], 
     LineBox[{10996, 10997}]}, 
    {Hue[
      NCache[
       Rational[10997, 14307], 0.7686447193681415]], AbsoluteThickness[0.25], 
     LineBox[{10997, 10998}]}, 
    {Hue[
      NCache[
       Rational[3666, 4769], 0.7687146152233173]], AbsoluteThickness[0.25], 
     LineBox[{10998, 10999}]}, 
    {Hue[
      NCache[
       Rational[10999, 14307], 0.768784511078493]], AbsoluteThickness[0.25], 
     LineBox[{10999, 11000}]}, 
    {Hue[
      NCache[
       Rational[11000, 14307], 0.7688544069336688]], AbsoluteThickness[0.25], 
     LineBox[{11000, 11001}]}, 
    {Hue[
      NCache[
       Rational[193, 251], 0.7689243027888446]], AbsoluteThickness[0.25], 
     LineBox[{11001, 11002}]}, 
    {Hue[
      NCache[
       Rational[11002, 14307], 0.7689941986440204]], AbsoluteThickness[0.25], 
     LineBox[{11002, 11003}]}, 
    {Hue[
      NCache[
       Rational[11003, 14307], 0.7690640944991962]], AbsoluteThickness[0.25], 
     LineBox[{11003, 11004}]}, 
    {Hue[
      NCache[
       Rational[3668, 4769], 0.769133990354372]], AbsoluteThickness[0.25], 
     LineBox[{11004, 11005}]}, 
    {Hue[
      NCache[
       Rational[11005, 14307], 0.7692038862095478]], AbsoluteThickness[0.25], 
     LineBox[{11005, 11006}]}, 
    {Hue[
      NCache[
       Rational[11006, 14307], 0.7692737820647235]], AbsoluteThickness[0.25], 
     LineBox[{11006, 11007}]}, 
    {Hue[
      NCache[
       Rational[3669, 4769], 0.7693436779198993]], AbsoluteThickness[0.25], 
     LineBox[{11007, 11008}]}, 
    {Hue[
      NCache[
       Rational[11008, 14307], 0.7694135737750751]], AbsoluteThickness[0.25], 
     LineBox[{11008, 11009}]}, 
    {Hue[
      NCache[
       Rational[11009, 14307], 0.7694834696302509]], AbsoluteThickness[0.25], 
     LineBox[{11009, 11010}]}, 
    {Hue[
      NCache[
       Rational[3670, 4769], 0.7695533654854267]], AbsoluteThickness[0.25], 
     LineBox[{11010, 11011}]}, 
    {Hue[
      NCache[
       Rational[11011, 14307], 0.7696232613406025]], AbsoluteThickness[0.25], 
     LineBox[{11011, 11012}]}, 
    {Hue[
      NCache[
       Rational[11012, 14307], 0.7696931571957782]], AbsoluteThickness[0.25], 
     LineBox[{11012, 11013}]}, 
    {Hue[
      NCache[
       Rational[3671, 4769], 0.769763053050954]], AbsoluteThickness[0.25], 
     LineBox[{11013, 11014}]}, 
    {Hue[
      NCache[
       Rational[11014, 14307], 0.7698329489061299]], AbsoluteThickness[0.25], 
     LineBox[{11014, 11015}]}, 
    {Hue[
      NCache[
       Rational[11015, 14307], 0.7699028447613057]], AbsoluteThickness[0.25], 
     LineBox[{11015, 11016}]}, 
    {Hue[
      NCache[
       Rational[3672, 4769], 0.7699727406164815]], AbsoluteThickness[0.25], 
     LineBox[{11016, 11017}]}, 
    {Hue[
      NCache[
       Rational[11017, 14307], 0.7700426364716573]], AbsoluteThickness[0.25], 
     LineBox[{11017, 11018}]}, 
    {Hue[
      NCache[
       Rational[11018, 14307], 0.770112532326833]], AbsoluteThickness[0.25], 
     LineBox[{11018, 11019}]}, 
    {Hue[
      NCache[
       Rational[3673, 4769], 0.7701824281820088]], AbsoluteThickness[0.25], 
     LineBox[{11019, 11020}]}, 
    {Hue[
      NCache[
       Rational[580, 753], 0.7702523240371846]], AbsoluteThickness[0.25], 
     LineBox[{11020, 11021}]}, 
    {Hue[
      NCache[
       Rational[11021, 14307], 0.7703222198923604]], AbsoluteThickness[0.25], 
     LineBox[{11021, 11022}]}, 
    {Hue[
      NCache[
       Rational[3674, 4769], 0.7703921157475362]], AbsoluteThickness[0.25], 
     LineBox[{11022, 11023}]}, 
    {Hue[
      NCache[
       Rational[11023, 14307], 0.770462011602712]], AbsoluteThickness[0.25], 
     LineBox[{11023, 11024}]}, 
    {Hue[
      NCache[
       Rational[11024, 14307], 0.7705319074578878]], AbsoluteThickness[0.25], 
     LineBox[{11024, 11025}]}, 
    {Hue[
      NCache[
       Rational[3675, 4769], 0.7706018033130635]], AbsoluteThickness[0.25], 
     LineBox[{11025, 11026}]}, 
    {Hue[
      NCache[
       Rational[11026, 14307], 0.7706716991682393]], AbsoluteThickness[0.25], 
     LineBox[{11026, 11027}]}, 
    {Hue[
      NCache[
       Rational[11027, 14307], 0.7707415950234151]], AbsoluteThickness[0.25], 
     LineBox[{11027, 11028}]}, 
    {Hue[
      NCache[
       Rational[3676, 4769], 0.7708114908785909]], AbsoluteThickness[0.25], 
     LineBox[{11028, 11029}]}, 
    {Hue[
      NCache[
       Rational[11029, 14307], 0.7708813867337667]], AbsoluteThickness[0.25], 
     LineBox[{11029, 11030}]}, 
    {Hue[
      NCache[
       Rational[11030, 14307], 0.7709512825889425]], AbsoluteThickness[0.25], 
     LineBox[{11030, 11031}]}, 
    {Hue[
      NCache[
       Rational[3677, 4769], 0.7710211784441182]], AbsoluteThickness[0.25], 
     LineBox[{11031, 11032}]}, 
    {Hue[
      NCache[
       Rational[11032, 14307], 0.771091074299294]], AbsoluteThickness[0.25], 
     LineBox[{11032, 11033}]}, 
    {Hue[
      NCache[
       Rational[11033, 14307], 0.7711609701544698]], AbsoluteThickness[0.25], 
     LineBox[{11033, 11034}]}, 
    {Hue[
      NCache[
       Rational[3678, 4769], 0.7712308660096456]], AbsoluteThickness[0.25], 
     LineBox[{11034, 11035}]}, 
    {Hue[
      NCache[
       Rational[11035, 14307], 0.7713007618648214]], AbsoluteThickness[0.25], 
     LineBox[{11035, 11036}]}, 
    {Hue[
      NCache[
       Rational[11036, 14307], 0.7713706577199972]], AbsoluteThickness[0.25], 
     LineBox[{11036, 11037}]}, 
    {Hue[
      NCache[
       Rational[3679, 4769], 0.7714405535751729]], AbsoluteThickness[0.25], 
     LineBox[{11037, 11038}]}, 
    {Hue[
      NCache[
       Rational[11038, 14307], 0.7715104494303487]], AbsoluteThickness[0.25], 
     LineBox[{11038, 11039}]}, 
    {Hue[
      NCache[
       Rational[581, 753], 0.7715803452855245]], AbsoluteThickness[0.25], 
     LineBox[{11039, 11040}]}, 
    {Hue[
      NCache[
       Rational[3680, 4769], 0.7716502411407004]], AbsoluteThickness[0.25], 
     LineBox[{11040, 11041}]}, 
    {Hue[
      NCache[
       Rational[11041, 14307], 0.7717201369958762]], AbsoluteThickness[0.25], 
     LineBox[{11041, 11042}]}, 
    {Hue[
      NCache[
       Rational[11042, 14307], 0.771790032851052]], AbsoluteThickness[0.25], 
     LineBox[{11042, 11043}]}, 
    {Hue[
      NCache[
       Rational[3681, 4769], 0.7718599287062278]], AbsoluteThickness[0.25], 
     LineBox[{11043, 11044}]}, 
    {Hue[
      NCache[
       Rational[44, 57], 0.7719298245614035]], AbsoluteThickness[0.25], 
     LineBox[{11044, 11045}]}, 
    {Hue[
      NCache[
       Rational[11045, 14307], 0.7719997204165793]], AbsoluteThickness[0.25], 
     LineBox[{11045, 11046}]}, 
    {Hue[
      NCache[
       Rational[3682, 4769], 0.7720696162717551]], AbsoluteThickness[0.25], 
     LineBox[{11046, 11047}]}, 
    {Hue[
      NCache[
       Rational[11047, 14307], 0.7721395121269309]], AbsoluteThickness[0.25], 
     LineBox[{11047, 11048}]}, 
    {Hue[
      NCache[
       Rational[11048, 14307], 0.7722094079821067]], AbsoluteThickness[0.25], 
     LineBox[{11048, 11049}]}, 
    {Hue[
      NCache[
       Rational[3683, 4769], 0.7722793038372825]], AbsoluteThickness[0.25], 
     LineBox[{11049, 11050}]}, 
    {Hue[
      NCache[
       Rational[11050, 14307], 0.7723491996924582]], AbsoluteThickness[0.25], 
     LineBox[{11050, 11051}]}, 
    {Hue[
      NCache[
       Rational[11051, 14307], 0.772419095547634]], AbsoluteThickness[0.25], 
     LineBox[{11051, 11052}]}, 
    {Hue[
      NCache[
       Rational[3684, 4769], 0.7724889914028098]], AbsoluteThickness[0.25], 
     LineBox[{11052, 11053}]}, 
    {Hue[
      NCache[
       Rational[11053, 14307], 0.7725588872579856]], AbsoluteThickness[0.25], 
     LineBox[{11053, 11054}]}, 
    {Hue[
      NCache[
       Rational[11054, 14307], 0.7726287831131614]], AbsoluteThickness[0.25], 
     LineBox[{11054, 11055}]}, 
    {Hue[
      NCache[
       Rational[3685, 4769], 0.7726986789683372]], AbsoluteThickness[0.25], 
     LineBox[{11055, 11056}]}, 
    {Hue[
      NCache[
       Rational[11056, 14307], 0.7727685748235129]], AbsoluteThickness[0.25], 
     LineBox[{11056, 11057}]}, 
    {Hue[
      NCache[
       Rational[11057, 14307], 0.7728384706786887]], AbsoluteThickness[0.25], 
     LineBox[{11057, 11058}]}, 
    {Hue[
      NCache[
       Rational[194, 251], 0.7729083665338645]], AbsoluteThickness[0.25], 
     LineBox[{11058, 11059}]}, 
    {Hue[
      NCache[
       Rational[11059, 14307], 0.7729782623890403]], AbsoluteThickness[0.25], 
     LineBox[{11059, 11060}]}, 
    {Hue[
      NCache[
       Rational[11060, 14307], 0.7730481582442161]], AbsoluteThickness[0.25], 
     LineBox[{11060, 11061}]}, 
    {Hue[
      NCache[
       Rational[3687, 4769], 0.7731180540993919]], AbsoluteThickness[0.25], 
     LineBox[{11061, 11062}]}, 
    {Hue[
      NCache[
       Rational[11062, 14307], 0.7731879499545677]], AbsoluteThickness[0.25], 
     LineBox[{11062, 11063}]}, 
    {Hue[
      NCache[
       Rational[11063, 14307], 0.7732578458097434]], AbsoluteThickness[0.25], 
     LineBox[{11063, 11064}]}, 
    {Hue[
      NCache[
       Rational[3688, 4769], 0.7733277416649192]], AbsoluteThickness[0.25], 
     LineBox[{11064, 11065}]}, 
    {Hue[
      NCache[
       Rational[11065, 14307], 0.773397637520095]], AbsoluteThickness[0.25], 
     LineBox[{11065, 11066}]}, 
    {Hue[
      NCache[
       Rational[11066, 14307], 0.7734675333752709]], AbsoluteThickness[0.25], 
     LineBox[{11066, 11067}]}, 
    {Hue[
      NCache[
       Rational[3689, 4769], 0.7735374292304467]], AbsoluteThickness[0.25], 
     LineBox[{11067, 11068}]}, 
    {Hue[
      NCache[
       Rational[11068, 14307], 0.7736073250856225]], AbsoluteThickness[0.25], 
     LineBox[{11068, 11069}]}, 
    {Hue[
      NCache[
       Rational[11069, 14307], 0.7736772209407982]], AbsoluteThickness[0.25], 
     LineBox[{11069, 11070}]}, 
    {Hue[
      NCache[
       Rational[3690, 4769], 0.773747116795974]], AbsoluteThickness[0.25], 
     LineBox[{11070, 11071}]}, 
    {Hue[
      NCache[
       Rational[11071, 14307], 0.7738170126511498]], AbsoluteThickness[0.25], 
     LineBox[{11071, 11072}]}, 
    {Hue[
      NCache[
       Rational[11072, 14307], 0.7738869085063256]], AbsoluteThickness[0.25], 
     LineBox[{11072, 11073}]}, 
    {Hue[
      NCache[
       Rational[3691, 4769], 0.7739568043615014]], AbsoluteThickness[0.25], 
     LineBox[{11073, 11074}]}, 
    {Hue[
      NCache[
       Rational[11074, 14307], 0.7740267002166772]], AbsoluteThickness[0.25], 
     LineBox[{11074, 11075}]}, 
    {Hue[
      NCache[
       Rational[11075, 14307], 0.774096596071853]], AbsoluteThickness[0.25], 
     LineBox[{11075, 11076}]}, 
    {Hue[
      NCache[
       Rational[3692, 4769], 0.7741664919270287]], AbsoluteThickness[0.25], 
     LineBox[{11076, 11077}]}, 
    {Hue[
      NCache[
       Rational[583, 753], 0.7742363877822045]], AbsoluteThickness[0.25], 
     LineBox[{11077, 11078}]}, 
    {Hue[
      NCache[
       Rational[11078, 14307], 0.7743062836373803]], AbsoluteThickness[0.25], 
     LineBox[{11078, 11079}]}, 
    {Hue[
      NCache[
       Rational[3693, 4769], 0.7743761794925561]], AbsoluteThickness[0.25], 
     LineBox[{11079, 11080}]}, 
    {Hue[
      NCache[
       Rational[11080, 14307], 0.7744460753477319]], AbsoluteThickness[0.25], 
     LineBox[{11080, 11081}]}, 
    {Hue[
      NCache[
       Rational[11081, 14307], 0.7745159712029077]], AbsoluteThickness[0.25], 
     LineBox[{11081, 11082}]}, 
    {Hue[
      NCache[
       Rational[3694, 4769], 0.7745858670580834]], AbsoluteThickness[0.25], 
     LineBox[{11082, 11083}]}, 
    {Hue[
      NCache[
       Rational[11083, 14307], 0.7746557629132592]], AbsoluteThickness[0.25], 
     LineBox[{11083, 11084}]}, 
    {Hue[
      NCache[
       Rational[11084, 14307], 0.774725658768435]], AbsoluteThickness[0.25], 
     LineBox[{11084, 11085}]}, 
    {Hue[
      NCache[
       Rational[3695, 4769], 0.7747955546236108]], AbsoluteThickness[0.25], 
     LineBox[{11085, 11086}]}, 
    {Hue[
      NCache[
       Rational[11086, 14307], 0.7748654504787866]], AbsoluteThickness[0.25], 
     LineBox[{11086, 11087}]}, 
    {Hue[
      NCache[
       Rational[11087, 14307], 0.7749353463339624]], AbsoluteThickness[0.25], 
     LineBox[{11087, 11088}]}, 
    {Hue[
      NCache[
       Rational[3696, 4769], 0.7750052421891381]], AbsoluteThickness[0.25], 
     LineBox[{11088, 11089}]}, 
    {Hue[
      NCache[
       Rational[11089, 14307], 0.7750751380443139]], AbsoluteThickness[0.25], 
     LineBox[{11089, 11090}]}, 
    {Hue[
      NCache[
       Rational[11090, 14307], 0.7751450338994897]], AbsoluteThickness[0.25], 
     LineBox[{11090, 11091}]}, 
    {Hue[
      NCache[
       Rational[3697, 4769], 0.7752149297546655]], AbsoluteThickness[0.25], 
     LineBox[{11091, 11092}]}, 
    {Hue[
      NCache[
       Rational[11092, 14307], 0.7752848256098414]], AbsoluteThickness[0.25], 
     LineBox[{11092, 11093}]}, 
    {Hue[
      NCache[
       Rational[11093, 14307], 0.7753547214650172]], AbsoluteThickness[0.25], 
     LineBox[{11093, 11094}]}, 
    {Hue[
      NCache[
       Rational[3698, 4769], 0.775424617320193]], AbsoluteThickness[0.25], 
     LineBox[{11094, 11095}]}, 
    {Hue[
      NCache[
       Rational[11095, 14307], 0.7754945131753687]], AbsoluteThickness[0.25], 
     LineBox[{11095, 11096}]}, 
    {Hue[
      NCache[
       Rational[584, 753], 0.7755644090305445]], AbsoluteThickness[0.25], 
     LineBox[{11096, 11097}]}, 
    {Hue[
      NCache[
       Rational[3699, 4769], 0.7756343048857203]], AbsoluteThickness[0.25], 
     LineBox[{11097, 11098}]}, 
    {Hue[
      NCache[
       Rational[11098, 14307], 0.7757042007408961]], AbsoluteThickness[0.25], 
     LineBox[{11098, 11099}]}, 
    {Hue[
      NCache[
       Rational[11099, 14307], 0.7757740965960719]], AbsoluteThickness[0.25], 
     LineBox[{11099, 11100}]}, 
    {Hue[
      NCache[
       Rational[3700, 4769], 0.7758439924512477]], AbsoluteThickness[0.25], 
     LineBox[{11100, 11101}]}, 
    {Hue[
      NCache[
       Rational[11101, 14307], 0.7759138883064234]], AbsoluteThickness[0.25], 
     LineBox[{11101, 11102}]}, 
    {Hue[
      NCache[
       Rational[11102, 14307], 0.7759837841615992]], AbsoluteThickness[0.25], 
     LineBox[{11102, 11103}]}, 
    {Hue[
      NCache[
       Rational[3701, 4769], 0.776053680016775]], AbsoluteThickness[0.25], 
     LineBox[{11103, 11104}]}, 
    {Hue[
      NCache[
       Rational[11104, 14307], 0.7761235758719508]], AbsoluteThickness[0.25], 
     LineBox[{11104, 11105}]}, 
    {Hue[
      NCache[
       Rational[11105, 14307], 0.7761934717271266]], AbsoluteThickness[0.25], 
     LineBox[{11105, 11106}]}, 
    {Hue[
      NCache[
       Rational[3702, 4769], 0.7762633675823024]], AbsoluteThickness[0.25], 
     LineBox[{11106, 11107}]}, 
    {Hue[
      NCache[
       Rational[11107, 14307], 0.7763332634374781]], AbsoluteThickness[0.25], 
     LineBox[{11107, 11108}]}, 
    {Hue[
      NCache[
       Rational[11108, 14307], 0.7764031592926539]], AbsoluteThickness[0.25], 
     LineBox[{11108, 11109}]}, 
    {Hue[
      NCache[
       Rational[3703, 4769], 0.7764730551478297]], AbsoluteThickness[0.25], 
     LineBox[{11109, 11110}]}, 
    {Hue[
      NCache[
       Rational[11110, 14307], 0.7765429510030055]], AbsoluteThickness[0.25], 
     LineBox[{11110, 11111}]}, 
    {Hue[
      NCache[
       Rational[11111, 14307], 0.7766128468581813]], AbsoluteThickness[0.25], 
     LineBox[{11111, 11112}]}, 
    {Hue[
      NCache[
       Rational[3704, 4769], 0.7766827427133571]], AbsoluteThickness[0.25], 
     LineBox[{11112, 11113}]}, 
    {Hue[
      NCache[
       Rational[11113, 14307], 0.7767526385685329]], AbsoluteThickness[0.25], 
     LineBox[{11113, 11114}]}, 
    {Hue[
      NCache[
       Rational[11114, 14307], 0.7768225344237086]], AbsoluteThickness[0.25], 
     LineBox[{11114, 11115}]}, 
    {Hue[
      NCache[
       Rational[195, 251], 0.7768924302788844]], AbsoluteThickness[0.25], 
     LineBox[{11115, 11116}]}, 
    {Hue[
      NCache[
       Rational[11116, 14307], 0.7769623261340602]], AbsoluteThickness[0.25], 
     LineBox[{11116, 11117}]}, 
    {Hue[
      NCache[
       Rational[11117, 14307], 0.777032221989236]], AbsoluteThickness[0.25], 
     LineBox[{11117, 11118}]}, 
    {Hue[
      NCache[
       Rational[3706, 4769], 0.7771021178444119]], AbsoluteThickness[0.25], 
     LineBox[{11118, 11119}]}, 
    {Hue[
      NCache[
       Rational[11119, 14307], 0.7771720136995877]], AbsoluteThickness[0.25], 
     LineBox[{11119, 11120}]}, 
    {Hue[
      NCache[
       Rational[11120, 14307], 0.7772419095547634]], AbsoluteThickness[0.25], 
     LineBox[{11120, 11121}]}, 
    {Hue[
      NCache[
       Rational[3707, 4769], 0.7773118054099392]], AbsoluteThickness[0.25], 
     LineBox[{11121, 11122}]}, 
    {Hue[
      NCache[
       Rational[11122, 14307], 0.777381701265115]], AbsoluteThickness[0.25], 
     LineBox[{11122, 11123}]}, 
    {Hue[
      NCache[
       Rational[11123, 14307], 0.7774515971202908]], AbsoluteThickness[0.25], 
     LineBox[{11123, 11124}]}, 
    {Hue[
      NCache[
       Rational[3708, 4769], 0.7775214929754666]], AbsoluteThickness[0.25], 
     LineBox[{11124, 11125}]}, 
    {Hue[
      NCache[
       Rational[11125, 14307], 0.7775913888306424]], AbsoluteThickness[0.25], 
     LineBox[{11125, 11126}]}, 
    {Hue[
      NCache[
       Rational[11126, 14307], 0.7776612846858181]], AbsoluteThickness[0.25], 
     LineBox[{11126, 11127}]}, 
    {Hue[
      NCache[
       Rational[3709, 4769], 0.7777311805409939]], AbsoluteThickness[0.25], 
     LineBox[{11127, 11128}]}, 
    {Hue[
      NCache[
       Rational[11128, 14307], 0.7778010763961697]], AbsoluteThickness[0.25], 
     LineBox[{11128, 11129}]}, 
    {Hue[
      NCache[
       Rational[11129, 14307], 0.7778709722513455]], AbsoluteThickness[0.25], 
     LineBox[{11129, 11130}]}, 
    {Hue[
      NCache[
       Rational[3710, 4769], 0.7779408681065213]], AbsoluteThickness[0.25], 
     LineBox[{11130, 11131}]}, 
    {Hue[
      NCache[
       Rational[11131, 14307], 0.7780107639616971]], AbsoluteThickness[0.25], 
     LineBox[{11131, 11132}]}, 
    {Hue[
      NCache[
       Rational[11132, 14307], 0.7780806598168729]], AbsoluteThickness[0.25], 
     LineBox[{11132, 11133}]}, 
    {Hue[
      NCache[
       Rational[3711, 4769], 0.7781505556720486]], AbsoluteThickness[0.25], 
     LineBox[{11133, 11134}]}, 
    {Hue[
      NCache[
       Rational[586, 753], 0.7782204515272244]], AbsoluteThickness[0.25], 
     LineBox[{11134, 11135}]}, 
    {Hue[
      NCache[
       Rational[11135, 14307], 0.7782903473824002]], AbsoluteThickness[0.25], 
     LineBox[{11135, 11136}]}, 
    {Hue[
      NCache[
       Rational[3712, 4769], 0.778360243237576]], AbsoluteThickness[0.25], 
     LineBox[{11136, 11137}]}, 
    {Hue[
      NCache[
       Rational[11137, 14307], 0.7784301390927518]], AbsoluteThickness[0.25], 
     LineBox[{11137, 11138}]}, 
    {Hue[
      NCache[
       Rational[11138, 14307], 0.7785000349479276]], AbsoluteThickness[0.25], 
     LineBox[{11138, 11139}]}, 
    {Hue[
      NCache[
       Rational[3713, 4769], 0.7785699308031033]], AbsoluteThickness[0.25], 
     LineBox[{11139, 11140}]}, 
    {Hue[
      NCache[
       Rational[11140, 14307], 0.7786398266582791]], AbsoluteThickness[0.25], 
     LineBox[{11140, 11141}]}, 
    {Hue[
      NCache[
       Rational[11141, 14307], 0.7787097225134549]], AbsoluteThickness[0.25], 
     LineBox[{11141, 11142}]}, 
    {Hue[
      NCache[
       Rational[3714, 4769], 0.7787796183686307]], AbsoluteThickness[0.25], 
     LineBox[{11142, 11143}]}, 
    {Hue[
      NCache[
       Rational[11143, 14307], 0.7788495142238065]], AbsoluteThickness[0.25], 
     LineBox[{11143, 11144}]}, 
    {Hue[
      NCache[
       Rational[11144, 14307], 0.7789194100789824]], AbsoluteThickness[0.25], 
     LineBox[{11144, 11145}]}, 
    {Hue[
      NCache[
       Rational[3715, 4769], 0.778989305934158]], AbsoluteThickness[0.25], 
     LineBox[{11145, 11146}]}, 
    {Hue[
      NCache[
       Rational[11146, 14307], 0.7790592017893339]], AbsoluteThickness[0.25], 
     LineBox[{11146, 11147}]}, 
    {Hue[
      NCache[
       Rational[11147, 14307], 0.7791290976445097]], AbsoluteThickness[0.25], 
     LineBox[{11147, 11148}]}, 
    {Hue[
      NCache[
       Rational[3716, 4769], 0.7791989934996855]], AbsoluteThickness[0.25], 
     LineBox[{11148, 11149}]}, 
    {Hue[
      NCache[
       Rational[11149, 14307], 0.7792688893548613]], AbsoluteThickness[0.25], 
     LineBox[{11149, 11150}]}, 
    {Hue[
      NCache[
       Rational[11150, 14307], 0.7793387852100371]], AbsoluteThickness[0.25], 
     LineBox[{11150, 11151}]}, 
    {Hue[
      NCache[
       Rational[3717, 4769], 0.7794086810652129]], AbsoluteThickness[0.25], 
     LineBox[{11151, 11152}]}, 
    {Hue[
      NCache[
       Rational[11152, 14307], 0.7794785769203886]], AbsoluteThickness[0.25], 
     LineBox[{11152, 11153}]}, 
    {Hue[
      NCache[
       Rational[587, 753], 0.7795484727755644]], AbsoluteThickness[0.25], 
     LineBox[{11153, 11154}]}, 
    {Hue[
      NCache[
       Rational[3718, 4769], 0.7796183686307402]], AbsoluteThickness[0.25], 
     LineBox[{11154, 11155}]}, 
    {Hue[
      NCache[
       Rational[11155, 14307], 0.779688264485916]], AbsoluteThickness[0.25], 
     LineBox[{11155, 11156}]}, 
    {Hue[
      NCache[
       Rational[11156, 14307], 0.7797581603410918]], AbsoluteThickness[0.25], 
     LineBox[{11156, 11157}]}, 
    {Hue[
      NCache[
       Rational[3719, 4769], 0.7798280561962676]], AbsoluteThickness[0.25], 
     LineBox[{11157, 11158}]}, 
    {Hue[
      NCache[
       Rational[11158, 14307], 0.7798979520514433]], AbsoluteThickness[0.25], 
     LineBox[{11158, 11159}]}, 
    {Hue[
      NCache[
       Rational[11159, 14307], 0.7799678479066191]], AbsoluteThickness[0.25], 
     LineBox[{11159, 11160}]}, 
    {Hue[
      NCache[
       Rational[3720, 4769], 0.7800377437617949]], AbsoluteThickness[0.25], 
     LineBox[{11160, 11161}]}, 
    {Hue[
      NCache[
       Rational[11161, 14307], 0.7801076396169707]], AbsoluteThickness[0.25], 
     LineBox[{11161, 11162}]}, 
    {Hue[
      NCache[
       Rational[11162, 14307], 0.7801775354721465]], AbsoluteThickness[0.25], 
     LineBox[{11162, 11163}]}, 
    {Hue[
      NCache[
       Rational[3721, 4769], 0.7802474313273223]], AbsoluteThickness[0.25], 
     LineBox[{11163, 11164}]}, 
    {Hue[
      NCache[
       Rational[11164, 14307], 0.7803173271824981]], AbsoluteThickness[0.25], 
     LineBox[{11164, 11165}]}, 
    {Hue[
      NCache[
       Rational[11165, 14307], 0.7803872230376738]], AbsoluteThickness[0.25], 
     LineBox[{11165, 11166}]}, 
    {Hue[
      NCache[
       Rational[3722, 4769], 0.7804571188928496]], AbsoluteThickness[0.25], 
     LineBox[{11166, 11167}]}, 
    {Hue[
      NCache[
       Rational[11167, 14307], 0.7805270147480254]], AbsoluteThickness[0.25], 
     LineBox[{11167, 11168}]}, 
    {Hue[
      NCache[
       Rational[11168, 14307], 0.7805969106032012]], AbsoluteThickness[0.25], 
     LineBox[{11168, 11169}]}, 
    {Hue[
      NCache[
       Rational[3723, 4769], 0.780666806458377]], AbsoluteThickness[0.25], 
     LineBox[{11169, 11170}]}, 
    {Hue[
      NCache[
       Rational[11170, 14307], 0.7807367023135529]], AbsoluteThickness[0.25], 
     LineBox[{11170, 11171}]}, 
    {Hue[
      NCache[
       Rational[11171, 14307], 0.7808065981687285]], AbsoluteThickness[0.25], 
     LineBox[{11171, 11172}]}, 
    {Hue[
      NCache[
       Rational[196, 251], 0.7808764940239044]], AbsoluteThickness[0.25], 
     LineBox[{11172, 11173}]}, 
    {Hue[
      NCache[
       Rational[11173, 14307], 0.7809463898790802]], AbsoluteThickness[0.25], 
     LineBox[{11173, 11174}]}, 
    {Hue[
      NCache[
       Rational[11174, 14307], 0.781016285734256]], AbsoluteThickness[0.25], 
     LineBox[{11174, 11175}]}, 
    {Hue[
      NCache[
       Rational[3725, 4769], 0.7810861815894318]], AbsoluteThickness[0.25], 
     LineBox[{11175, 11176}]}, 
    {Hue[
      NCache[
       Rational[11176, 14307], 0.7811560774446076]], AbsoluteThickness[0.25], 
     LineBox[{11176, 11177}]}, 
    {Hue[
      NCache[
       Rational[11177, 14307], 0.7812259732997833]], AbsoluteThickness[0.25], 
     LineBox[{11177, 11178}]}, 
    {Hue[
      NCache[
       Rational[3726, 4769], 0.7812958691549591]], AbsoluteThickness[0.25], 
     LineBox[{11178, 11179}]}, 
    {Hue[
      NCache[
       Rational[11179, 14307], 0.7813657650101349]], AbsoluteThickness[0.25], 
     LineBox[{11179, 11180}]}, 
    {Hue[
      NCache[
       Rational[11180, 14307], 0.7814356608653107]], AbsoluteThickness[0.25], 
     LineBox[{11180, 11181}]}, 
    {Hue[
      NCache[
       Rational[3727, 4769], 0.7815055567204865]], AbsoluteThickness[0.25], 
     LineBox[{11181, 11182}]}, 
    {Hue[
      NCache[
       Rational[11182, 14307], 0.7815754525756623]], AbsoluteThickness[0.25], 
     LineBox[{11182, 11183}]}, 
    {Hue[
      NCache[
       Rational[11183, 14307], 0.7816453484308381]], AbsoluteThickness[0.25], 
     LineBox[{11183, 11184}]}, 
    {Hue[
      NCache[
       Rational[3728, 4769], 0.7817152442860138]], AbsoluteThickness[0.25], 
     LineBox[{11184, 11185}]}, 
    {Hue[
      NCache[
       Rational[11185, 14307], 0.7817851401411896]], AbsoluteThickness[0.25], 
     LineBox[{11185, 11186}]}, 
    {Hue[
      NCache[
       Rational[11186, 14307], 0.7818550359963654]], AbsoluteThickness[0.25], 
     LineBox[{11186, 11187}]}, 
    {Hue[
      NCache[
       Rational[3729, 4769], 0.7819249318515412]], AbsoluteThickness[0.25], 
     LineBox[{11187, 11188}]}, 
    {Hue[
      NCache[
       Rational[11188, 14307], 0.781994827706717]], AbsoluteThickness[0.25], 
     LineBox[{11188, 11189}]}, 
    {Hue[
      NCache[
       Rational[11189, 14307], 0.7820647235618928]], AbsoluteThickness[0.25], 
     LineBox[{11189, 11190}]}, 
    {Hue[
      NCache[
       Rational[3730, 4769], 0.7821346194170685]], AbsoluteThickness[0.25], 
     LineBox[{11190, 11191}]}, 
    {Hue[
      NCache[
       Rational[589, 753], 0.7822045152722443]], AbsoluteThickness[0.25], 
     LineBox[{11191, 11192}]}, 
    {Hue[
      NCache[
       Rational[11192, 14307], 0.7822744111274201]], AbsoluteThickness[0.25], 
     LineBox[{11192, 11193}]}, 
    {Hue[
      NCache[
       Rational[3731, 4769], 0.7823443069825959]], AbsoluteThickness[0.25], 
     LineBox[{11193, 11194}]}, 
    {Hue[
      NCache[
       Rational[11194, 14307], 0.7824142028377717]], AbsoluteThickness[0.25], 
     LineBox[{11194, 11195}]}, 
    {Hue[
      NCache[
       Rational[11195, 14307], 0.7824840986929475]], AbsoluteThickness[0.25], 
     LineBox[{11195, 11196}]}, 
    {Hue[
      NCache[
       Rational[3732, 4769], 0.7825539945481232]], AbsoluteThickness[0.25], 
     LineBox[{11196, 11197}]}, 
    {Hue[
      NCache[
       Rational[11197, 14307], 0.782623890403299]], AbsoluteThickness[0.25], 
     LineBox[{11197, 11198}]}, 
    {Hue[
      NCache[
       Rational[11198, 14307], 0.7826937862584749]], AbsoluteThickness[0.25], 
     LineBox[{11198, 11199}]}, 
    {Hue[
      NCache[
       Rational[3733, 4769], 0.7827636821136507]], AbsoluteThickness[0.25], 
     LineBox[{11199, 11200}]}, 
    {Hue[
      NCache[
       Rational[11200, 14307], 0.7828335779688265]], AbsoluteThickness[0.25], 
     LineBox[{11200, 11201}]}, 
    {Hue[
      NCache[
       Rational[11201, 14307], 0.7829034738240023]], AbsoluteThickness[0.25], 
     LineBox[{11201, 11202}]}, 
    {Hue[
      NCache[
       Rational[3734, 4769], 0.7829733696791781]], AbsoluteThickness[0.25], 
     LineBox[{11202, 11203}]}, 
    {Hue[
      NCache[
       Rational[11203, 14307], 0.7830432655343538]], AbsoluteThickness[0.25], 
     LineBox[{11203, 11204}]}, 
    {Hue[
      NCache[
       Rational[11204, 14307], 0.7831131613895296]], AbsoluteThickness[0.25], 
     LineBox[{11204, 11205}]}, 
    {Hue[
      NCache[
       Rational[3735, 4769], 0.7831830572447054]], AbsoluteThickness[0.25], 
     LineBox[{11205, 11206}]}, 
    {Hue[
      NCache[
       Rational[11206, 14307], 0.7832529530998812]], AbsoluteThickness[0.25], 
     LineBox[{11206, 11207}]}, 
    {Hue[
      NCache[
       Rational[11207, 14307], 0.783322848955057]], AbsoluteThickness[0.25], 
     LineBox[{11207, 11208}]}, 
    {Hue[
      NCache[
       Rational[3736, 4769], 0.7833927448102328]], AbsoluteThickness[0.25], 
     LineBox[{11208, 11209}]}, 
    {Hue[
      NCache[
       Rational[11209, 14307], 0.7834626406654085]], AbsoluteThickness[0.25], 
     LineBox[{11209, 11210}]}, 
    {Hue[
      NCache[
       Rational[590, 753], 0.7835325365205843]], AbsoluteThickness[0.25], 
     LineBox[{11210, 11211}]}, 
    {Hue[
      NCache[
       Rational[3737, 4769], 0.7836024323757601]], AbsoluteThickness[0.25], 
     LineBox[{11211, 11212}]}, 
    {Hue[
      NCache[
       Rational[11212, 14307], 0.7836723282309359]], AbsoluteThickness[0.25], 
     LineBox[{11212, 11213}]}, 
    {Hue[
      NCache[
       Rational[11213, 14307], 0.7837422240861117]], AbsoluteThickness[0.25], 
     LineBox[{11213, 11214}]}, 
    {Hue[
      NCache[
       Rational[3738, 4769], 0.7838121199412875]], AbsoluteThickness[0.25], 
     LineBox[{11214, 11215}]}, 
    {Hue[
      NCache[
       Rational[11215, 14307], 0.7838820157964632]], AbsoluteThickness[0.25], 
     LineBox[{11215, 11216}]}, 
    {Hue[
      NCache[
       Rational[11216, 14307], 0.783951911651639]], AbsoluteThickness[0.25], 
     LineBox[{11216, 11217}]}, 
    {Hue[
      NCache[
       Rational[3739, 4769], 0.7840218075068148]], AbsoluteThickness[0.25], 
     LineBox[{11217, 11218}]}, 
    {Hue[
      NCache[
       Rational[11218, 14307], 0.7840917033619906]], AbsoluteThickness[0.25], 
     LineBox[{11218, 11219}]}, 
    {Hue[
      NCache[
       Rational[11219, 14307], 0.7841615992171664]], AbsoluteThickness[0.25], 
     LineBox[{11219, 11220}]}, 
    {Hue[
      NCache[
       Rational[3740, 4769], 0.7842314950723422]], AbsoluteThickness[0.25], 
     LineBox[{11220, 11221}]}, 
    {Hue[
      NCache[
       Rational[11221, 14307], 0.784301390927518]], AbsoluteThickness[0.25], 
     LineBox[{11221, 11222}]}, 
    {Hue[
      NCache[
       Rational[11222, 14307], 0.7843712867826937]], AbsoluteThickness[0.25], 
     LineBox[{11222, 11223}]}, 
    {Hue[
      NCache[
       Rational[3741, 4769], 0.7844411826378695]], AbsoluteThickness[0.25], 
     LineBox[{11223, 11224}]}, 
    {Hue[
      NCache[
       Rational[11224, 14307], 0.7845110784930454]], AbsoluteThickness[0.25], 
     LineBox[{11224, 11225}]}, 
    {Hue[
      NCache[
       Rational[11225, 14307], 0.7845809743482212]], AbsoluteThickness[0.25], 
     LineBox[{11225, 11226}]}, 
    {Hue[
      NCache[
       Rational[3742, 4769], 0.784650870203397]], AbsoluteThickness[0.25], 
     LineBox[{11226, 11227}]}, 
    {Hue[
      NCache[
       Rational[11227, 14307], 0.7847207660585728]], AbsoluteThickness[0.25], 
     LineBox[{11227, 11228}]}, 
    {Hue[
      NCache[
       Rational[11228, 14307], 0.7847906619137485]], AbsoluteThickness[0.25], 
     LineBox[{11228, 11229}]}, 
    {Hue[
      NCache[
       Rational[197, 251], 0.7848605577689243]], AbsoluteThickness[0.25], 
     LineBox[{11229, 11230}]}, 
    {Hue[
      NCache[
       Rational[11230, 14307], 0.7849304536241001]], AbsoluteThickness[0.25], 
     LineBox[{11230, 11231}]}, 
    {Hue[
      NCache[
       Rational[11231, 14307], 0.7850003494792759]], AbsoluteThickness[0.25], 
     LineBox[{11231, 11232}]}, 
    {Hue[
      NCache[
       Rational[3744, 4769], 0.7850702453344517]], AbsoluteThickness[0.25], 
     LineBox[{11232, 11233}]}, 
    {Hue[
      NCache[
       Rational[11233, 14307], 0.7851401411896275]], AbsoluteThickness[0.25], 
     LineBox[{11233, 11234}]}, 
    {Hue[
      NCache[
       Rational[11234, 14307], 0.7852100370448032]], AbsoluteThickness[0.25], 
     LineBox[{11234, 11235}]}, 
    {Hue[
      NCache[
       Rational[3745, 4769], 0.785279932899979]], AbsoluteThickness[0.25], 
     LineBox[{11235, 11236}]}, 
    {Hue[
      NCache[
       Rational[11236, 14307], 0.7853498287551548]], AbsoluteThickness[0.25], 
     LineBox[{11236, 11237}]}, 
    {Hue[
      NCache[
       Rational[11237, 14307], 0.7854197246103306]], AbsoluteThickness[0.25], 
     LineBox[{11237, 11238}]}, 
    {Hue[
      NCache[
       Rational[3746, 4769], 0.7854896204655064]], AbsoluteThickness[0.25], 
     LineBox[{11238, 11239}]}, 
    {Hue[
      NCache[
       Rational[11239, 14307], 0.7855595163206822]], AbsoluteThickness[0.25], 
     LineBox[{11239, 11240}]}, 
    {Hue[
      NCache[
       Rational[11240, 14307], 0.785629412175858]], AbsoluteThickness[0.25], 
     LineBox[{11240, 11241}]}, 
    {Hue[
      NCache[
       Rational[3747, 4769], 0.7856993080310337]], AbsoluteThickness[0.25], 
     LineBox[{11241, 11242}]}, 
    {Hue[
      NCache[
       Rational[11242, 14307], 0.7857692038862095]], AbsoluteThickness[0.25], 
     LineBox[{11242, 11243}]}, 
    {Hue[
      NCache[
       Rational[11243, 14307], 0.7858390997413853]], AbsoluteThickness[0.25], 
     LineBox[{11243, 11244}]}, 
    {Hue[
      NCache[
       Rational[3748, 4769], 0.7859089955965611]], AbsoluteThickness[0.25], 
     LineBox[{11244, 11245}]}, 
    {Hue[
      NCache[
       Rational[11245, 14307], 0.7859788914517369]], AbsoluteThickness[0.25], 
     LineBox[{11245, 11246}]}, 
    {Hue[
      NCache[
       Rational[11246, 14307], 0.7860487873069127]], AbsoluteThickness[0.25], 
     LineBox[{11246, 11247}]}, 
    {Hue[
      NCache[
       Rational[3749, 4769], 0.7861186831620884]], AbsoluteThickness[0.25], 
     LineBox[{11247, 11248}]}, 
    {Hue[
      NCache[
       Rational[592, 753], 0.7861885790172642]], AbsoluteThickness[0.25], 
     LineBox[{11248, 11249}]}, 
    {Hue[
      NCache[
       Rational[11249, 14307], 0.78625847487244]], AbsoluteThickness[0.25], 
     LineBox[{11249, 11250}]}, 
    {Hue[
      NCache[
       Rational[3750, 4769], 0.7863283707276159]], AbsoluteThickness[0.25], 
     LineBox[{11250, 11251}]}, 
    {Hue[
      NCache[
       Rational[11251, 14307], 0.7863982665827917]], AbsoluteThickness[0.25], 
     LineBox[{11251, 11252}]}, 
    {Hue[
      NCache[
       Rational[11252, 14307], 0.7864681624379675]], AbsoluteThickness[0.25], 
     LineBox[{11252, 11253}]}, 
    {Hue[
      NCache[
       Rational[3751, 4769], 0.7865380582931433]], AbsoluteThickness[0.25], 
     LineBox[{11253, 11254}]}, 
    {Hue[
      NCache[
       Rational[11254, 14307], 0.786607954148319]], AbsoluteThickness[0.25], 
     LineBox[{11254, 11255}]}, 
    {Hue[
      NCache[
       Rational[11255, 14307], 0.7866778500034948]], AbsoluteThickness[0.25], 
     LineBox[{11255, 11256}]}, 
    {Hue[
      NCache[
       Rational[3752, 4769], 0.7867477458586706]], AbsoluteThickness[0.25], 
     LineBox[{11256, 11257}]}, 
    {Hue[
      NCache[
       Rational[11257, 14307], 0.7868176417138464]], AbsoluteThickness[0.25], 
     LineBox[{11257, 11258}]}, 
    {Hue[
      NCache[
       Rational[11258, 14307], 0.7868875375690222]], AbsoluteThickness[0.25], 
     LineBox[{11258, 11259}]}, 
    {Hue[
      NCache[
       Rational[3753, 4769], 0.786957433424198]], AbsoluteThickness[0.25], 
     LineBox[{11259, 11260}]}, 
    {Hue[
      NCache[
       Rational[11260, 14307], 0.7870273292793737]], AbsoluteThickness[0.25], 
     LineBox[{11260, 11261}]}, 
    {Hue[
      NCache[
       Rational[11261, 14307], 0.7870972251345495]], AbsoluteThickness[0.25], 
     LineBox[{11261, 11262}]}, 
    {Hue[
      NCache[
       Rational[3754, 4769], 0.7871671209897253]], AbsoluteThickness[0.25], 
     LineBox[{11262, 11263}]}, 
    {Hue[
      NCache[
       Rational[11263, 14307], 0.7872370168449011]], AbsoluteThickness[0.25], 
     LineBox[{11263, 11264}]}, 
    {Hue[
      NCache[
       Rational[11264, 14307], 0.7873069127000769]], AbsoluteThickness[0.25], 
     LineBox[{11264, 11265}]}, 
    {Hue[
      NCache[
       Rational[3755, 4769], 0.7873768085552527]], AbsoluteThickness[0.25], 
     LineBox[{11265, 11266}]}, 
    {Hue[
      NCache[
       Rational[11266, 14307], 0.7874467044104284]], AbsoluteThickness[0.25], 
     LineBox[{11266, 11267}]}, 
    {Hue[
      NCache[
       Rational[593, 753], 0.7875166002656042]], AbsoluteThickness[0.25], 
     LineBox[{11267, 11268}]}, 
    {Hue[
      NCache[
       Rational[3756, 4769], 0.78758649612078]], AbsoluteThickness[0.25], 
     LineBox[{11268, 11269}]}, 
    {Hue[
      NCache[
       Rational[11269, 14307], 0.7876563919759558]], AbsoluteThickness[0.25], 
     LineBox[{11269, 11270}]}, 
    {Hue[
      NCache[
       Rational[11270, 14307], 0.7877262878311316]], AbsoluteThickness[0.25], 
     LineBox[{11270, 11271}]}, 
    {Hue[
      NCache[
       Rational[3757, 4769], 0.7877961836863074]], AbsoluteThickness[0.25], 
     LineBox[{11271, 11272}]}, 
    {Hue[
      NCache[
       Rational[11272, 14307], 0.7878660795414832]], AbsoluteThickness[0.25], 
     LineBox[{11272, 11273}]}, 
    {Hue[
      NCache[
       Rational[11273, 14307], 0.7879359753966589]], AbsoluteThickness[0.25], 
     LineBox[{11273, 11274}]}, 
    {Hue[
      NCache[
       Rational[3758, 4769], 0.7880058712518347]], AbsoluteThickness[0.25], 
     LineBox[{11274, 11275}]}, 
    {Hue[
      NCache[
       Rational[11275, 14307], 0.7880757671070105]], AbsoluteThickness[0.25], 
     LineBox[{11275, 11276}]}, 
    {Hue[
      NCache[
       Rational[11276, 14307], 0.7881456629621864]], AbsoluteThickness[0.25], 
     LineBox[{11276, 11277}]}, 
    {Hue[
      NCache[
       Rational[3759, 4769], 0.7882155588173622]], AbsoluteThickness[0.25], 
     LineBox[{11277, 11278}]}, 
    {Hue[
      NCache[
       Rational[11278, 14307], 0.788285454672538]], AbsoluteThickness[0.25], 
     LineBox[{11278, 11279}]}, 
    {Hue[
      NCache[
       Rational[11279, 14307], 0.7883553505277137]], AbsoluteThickness[0.25], 
     LineBox[{11279, 11280}]}, 
    {Hue[
      NCache[
       Rational[3760, 4769], 0.7884252463828895]], AbsoluteThickness[0.25], 
     LineBox[{11280, 11281}]}, 
    {Hue[
      NCache[
       Rational[11281, 14307], 0.7884951422380653]], AbsoluteThickness[0.25], 
     LineBox[{11281, 11282}]}, 
    {Hue[
      NCache[
       Rational[11282, 14307], 0.7885650380932411]], AbsoluteThickness[0.25], 
     LineBox[{11282, 11283}]}, 
    {Hue[
      NCache[
       Rational[3761, 4769], 0.7886349339484169]], AbsoluteThickness[0.25], 
     LineBox[{11283, 11284}]}, 
    {Hue[
      NCache[
       Rational[11284, 14307], 0.7887048298035927]], AbsoluteThickness[0.25], 
     LineBox[{11284, 11285}]}, 
    {Hue[
      NCache[
       Rational[11285, 14307], 0.7887747256587684]], AbsoluteThickness[0.25], 
     LineBox[{11285, 11286}]}, 
    {Hue[
      NCache[
       Rational[198, 251], 0.7888446215139442]], AbsoluteThickness[0.25], 
     LineBox[{11286, 11287}]}, 
    {Hue[
      NCache[
       Rational[11287, 14307], 0.78891451736912]], AbsoluteThickness[0.25], 
     LineBox[{11287, 11288}]}, 
    {Hue[
      NCache[
       Rational[11288, 14307], 0.7889844132242958]], AbsoluteThickness[0.25], 
     LineBox[{11288, 11289}]}, 
    {Hue[
      NCache[
       Rational[3763, 4769], 0.7890543090794716]], AbsoluteThickness[0.25], 
     LineBox[{11289, 11290}]}, 
    {Hue[
      NCache[
       Rational[11290, 14307], 0.7891242049346474]], AbsoluteThickness[0.25], 
     LineBox[{11290, 11291}]}, 
    {Hue[
      NCache[
       Rational[11291, 14307], 0.7891941007898232]], AbsoluteThickness[0.25], 
     LineBox[{11291, 11292}]}, 
    {Hue[
      NCache[
       Rational[3764, 4769], 0.7892639966449989]], AbsoluteThickness[0.25], 
     LineBox[{11292, 11293}]}, 
    {Hue[
      NCache[
       Rational[11293, 14307], 0.7893338925001747]], AbsoluteThickness[0.25], 
     LineBox[{11293, 11294}]}, 
    {Hue[
      NCache[
       Rational[11294, 14307], 0.7894037883553505]], AbsoluteThickness[0.25], 
     LineBox[{11294, 11295}]}, 
    {Hue[
      NCache[
       Rational[15, 19], 0.7894736842105263]], AbsoluteThickness[0.25], 
     LineBox[{11295, 11296}]}, 
    {Hue[
      NCache[
       Rational[11296, 14307], 0.7895435800657021]], AbsoluteThickness[0.25], 
     LineBox[{11296, 11297}]}, 
    {Hue[
      NCache[
       Rational[11297, 14307], 0.7896134759208779]], AbsoluteThickness[0.25], 
     LineBox[{11297, 11298}]}, 
    {Hue[
      NCache[
       Rational[3766, 4769], 0.7896833717760536]], AbsoluteThickness[0.25], 
     LineBox[{11298, 11299}]}, 
    {Hue[
      NCache[
       Rational[11299, 14307], 0.7897532676312294]], AbsoluteThickness[0.25], 
     LineBox[{11299, 11300}]}, 
    {Hue[
      NCache[
       Rational[11300, 14307], 0.7898231634864052]], AbsoluteThickness[0.25], 
     LineBox[{11300, 11301}]}, 
    {Hue[
      NCache[
       Rational[3767, 4769], 0.789893059341581]], AbsoluteThickness[0.25], 
     LineBox[{11301, 11302}]}, 
    {Hue[
      NCache[
       Rational[11302, 14307], 0.7899629551967569]], AbsoluteThickness[0.25], 
     LineBox[{11302, 11303}]}, 
    {Hue[
      NCache[
       Rational[11303, 14307], 0.7900328510519327]], AbsoluteThickness[0.25], 
     LineBox[{11303, 11304}]}, 
    {Hue[
      NCache[
       Rational[3768, 4769], 0.7901027469071084]], AbsoluteThickness[0.25], 
     LineBox[{11304, 11305}]}, 
    {Hue[
      NCache[
       Rational[595, 753], 0.7901726427622842]], AbsoluteThickness[0.25], 
     LineBox[{11305, 11306}]}, 
    {Hue[
      NCache[
       Rational[11306, 14307], 0.79024253861746]], AbsoluteThickness[0.25], 
     LineBox[{11306, 11307}]}, 
    {Hue[
      NCache[
       Rational[3769, 4769], 0.7903124344726358]], AbsoluteThickness[0.25], 
     LineBox[{11307, 11308}]}, 
    {Hue[
      NCache[
       Rational[11308, 14307], 0.7903823303278116]], AbsoluteThickness[0.25], 
     LineBox[{11308, 11309}]}, 
    {Hue[
      NCache[
       Rational[11309, 14307], 0.7904522261829874]], AbsoluteThickness[0.25], 
     LineBox[{11309, 11310}]}, 
    {Hue[
      NCache[
       Rational[3770, 4769], 0.7905221220381632]], AbsoluteThickness[0.25], 
     LineBox[{11310, 11311}]}, 
    {Hue[
      NCache[
       Rational[11311, 14307], 0.7905920178933389]], AbsoluteThickness[0.25], 
     LineBox[{11311, 11312}]}, 
    {Hue[
      NCache[
       Rational[11312, 14307], 0.7906619137485147]], AbsoluteThickness[0.25], 
     LineBox[{11312, 11313}]}, 
    {Hue[
      NCache[
       Rational[3771, 4769], 0.7907318096036905]], AbsoluteThickness[0.25], 
     LineBox[{11313, 11314}]}, 
    {Hue[
      NCache[
       Rational[11314, 14307], 0.7908017054588663]], AbsoluteThickness[0.25], 
     LineBox[{11314, 11315}]}, 
    {Hue[
      NCache[
       Rational[11315, 14307], 0.7908716013140421]], AbsoluteThickness[0.25], 
     LineBox[{11315, 11316}]}, 
    {Hue[
      NCache[
       Rational[3772, 4769], 0.7909414971692179]], AbsoluteThickness[0.25], 
     LineBox[{11316, 11317}]}, 
    {Hue[
      NCache[
       Rational[11317, 14307], 0.7910113930243936]], AbsoluteThickness[0.25], 
     LineBox[{11317, 11318}]}, 
    {Hue[
      NCache[
       Rational[11318, 14307], 0.7910812888795694]], AbsoluteThickness[0.25], 
     LineBox[{11318, 11319}]}, 
    {Hue[
      NCache[
       Rational[3773, 4769], 0.7911511847347452]], AbsoluteThickness[0.25], 
     LineBox[{11319, 11320}]}, 
    {Hue[
      NCache[
       Rational[11320, 14307], 0.791221080589921]], AbsoluteThickness[0.25], 
     LineBox[{11320, 11321}]}, 
    {Hue[
      NCache[
       Rational[11321, 14307], 0.7912909764450968]], AbsoluteThickness[0.25], 
     LineBox[{11321, 11322}]}, 
    {Hue[
      NCache[
       Rational[3774, 4769], 0.7913608723002726]], AbsoluteThickness[0.25], 
     LineBox[{11322, 11323}]}, 
    {Hue[
      NCache[
       Rational[11323, 14307], 0.7914307681554483]], AbsoluteThickness[0.25], 
     LineBox[{11323, 11324}]}, 
    {Hue[
      NCache[
       Rational[596, 753], 0.7915006640106241]], AbsoluteThickness[0.25], 
     LineBox[{11324, 11325}]}, 
    {Hue[
      NCache[
       Rational[3775, 4769], 0.7915705598657999]], AbsoluteThickness[0.25], 
     LineBox[{11325, 11326}]}, 
    {Hue[
      NCache[
       Rational[11326, 14307], 0.7916404557209757]], AbsoluteThickness[0.25], 
     LineBox[{11326, 11327}]}, 
    {Hue[
      NCache[
       Rational[11327, 14307], 0.7917103515761515]], AbsoluteThickness[0.25], 
     LineBox[{11327, 11328}]}, 
    {Hue[
      NCache[
       Rational[3776, 4769], 0.7917802474313274]], AbsoluteThickness[0.25], 
     LineBox[{11328, 11329}]}, 
    {Hue[
      NCache[
       Rational[11329, 14307], 0.7918501432865032]], AbsoluteThickness[0.25], 
     LineBox[{11329, 11330}]}, 
    {Hue[
      NCache[
       Rational[11330, 14307], 0.7919200391416789]], AbsoluteThickness[0.25], 
     LineBox[{11330, 11331}]}, 
    {Hue[
      NCache[
       Rational[3777, 4769], 0.7919899349968547]], AbsoluteThickness[0.25], 
     LineBox[{11331, 11332}]}, 
    {Hue[
      NCache[
       Rational[11332, 14307], 0.7920598308520305]], AbsoluteThickness[0.25], 
     LineBox[{11332, 11333}]}, 
    {Hue[
      NCache[
       Rational[11333, 14307], 0.7921297267072063]], AbsoluteThickness[0.25], 
     LineBox[{11333, 11334}]}, 
    {Hue[
      NCache[
       Rational[3778, 4769], 0.7921996225623821]], AbsoluteThickness[0.25], 
     LineBox[{11334, 11335}]}, 
    {Hue[
      NCache[
       Rational[11335, 14307], 0.7922695184175579]], AbsoluteThickness[0.25], 
     LineBox[{11335, 11336}]}, 
    {Hue[
      NCache[
       Rational[11336, 14307], 0.7923394142727336]], AbsoluteThickness[0.25], 
     LineBox[{11336, 11337}]}, 
    {Hue[
      NCache[
       Rational[3779, 4769], 0.7924093101279094]], AbsoluteThickness[0.25], 
     LineBox[{11337, 11338}]}, 
    {Hue[
      NCache[
       Rational[11338, 14307], 0.7924792059830852]], AbsoluteThickness[0.25], 
     LineBox[{11338, 11339}]}, 
    {Hue[
      NCache[
       Rational[11339, 14307], 0.792549101838261]], AbsoluteThickness[0.25], 
     LineBox[{11339, 11340}]}, 
    {Hue[
      NCache[
       Rational[3780, 4769], 0.7926189976934368]], AbsoluteThickness[0.25], 
     LineBox[{11340, 11341}]}, 
    {Hue[
      NCache[
       Rational[11341, 14307], 0.7926888935486126]], AbsoluteThickness[0.25], 
     LineBox[{11341, 11342}]}, 
    {Hue[
      NCache[
       Rational[11342, 14307], 0.7927587894037883]], AbsoluteThickness[0.25], 
     LineBox[{11342, 11343}]}, 
    {Hue[
      NCache[
       Rational[199, 251], 0.7928286852589641]], AbsoluteThickness[0.25], 
     LineBox[{11343, 11344}]}, 
    {Hue[
      NCache[
       Rational[11344, 14307], 0.7928985811141399]], AbsoluteThickness[0.25], 
     LineBox[{11344, 11345}]}, 
    {Hue[
      NCache[
       Rational[11345, 14307], 0.7929684769693157]], AbsoluteThickness[0.25], 
     LineBox[{11345, 11346}]}, 
    {Hue[
      NCache[
       Rational[3782, 4769], 0.7930383728244915]], AbsoluteThickness[0.25], 
     LineBox[{11346, 11347}]}, 
    {Hue[
      NCache[
       Rational[11347, 14307], 0.7931082686796673]], AbsoluteThickness[0.25], 
     LineBox[{11347, 11348}]}, 
    {Hue[
      NCache[
       Rational[11348, 14307], 0.7931781645348431]], AbsoluteThickness[0.25], 
     LineBox[{11348, 11349}]}, 
    {Hue[
      NCache[
       Rational[3783, 4769], 0.7932480603900188]], AbsoluteThickness[0.25], 
     LineBox[{11349, 11350}]}, 
    {Hue[
      NCache[
       Rational[11350, 14307], 0.7933179562451946]], AbsoluteThickness[0.25], 
     LineBox[{11350, 11351}]}, 
    {Hue[
      NCache[
       Rational[11351, 14307], 0.7933878521003704]], AbsoluteThickness[0.25], 
     LineBox[{11351, 11352}]}, 
    {Hue[
      NCache[
       Rational[3784, 4769], 0.7934577479555462]], AbsoluteThickness[0.25], 
     LineBox[{11352, 11353}]}, 
    {Hue[
      NCache[
       Rational[11353, 14307], 0.793527643810722]], AbsoluteThickness[0.25], 
     LineBox[{11353, 11354}]}, 
    {Hue[
      NCache[
       Rational[11354, 14307], 0.7935975396658979]], AbsoluteThickness[0.25], 
     LineBox[{11354, 11355}]}, 
    {Hue[
      NCache[
       Rational[3785, 4769], 0.7936674355210735]], AbsoluteThickness[0.25], 
     LineBox[{11355, 11356}]}, 
    {Hue[
      NCache[
       Rational[11356, 14307], 0.7937373313762494]], AbsoluteThickness[0.25], 
     LineBox[{11356, 11357}]}, 
    {Hue[
      NCache[
       Rational[11357, 14307], 0.7938072272314252]], AbsoluteThickness[0.25], 
     LineBox[{11357, 11358}]}, 
    {Hue[
      NCache[
       Rational[3786, 4769], 0.793877123086601]], AbsoluteThickness[0.25], 
     LineBox[{11358, 11359}]}, 
    {Hue[
      NCache[
       Rational[11359, 14307], 0.7939470189417768]], AbsoluteThickness[0.25], 
     LineBox[{11359, 11360}]}, 
    {Hue[
      NCache[
       Rational[11360, 14307], 0.7940169147969526]], AbsoluteThickness[0.25], 
     LineBox[{11360, 11361}]}, 
    {Hue[
      NCache[
       Rational[3787, 4769], 0.7940868106521284]], AbsoluteThickness[0.25], 
     LineBox[{11361, 11362}]}, 
    {Hue[
      NCache[
       Rational[598, 753], 0.7941567065073041]], AbsoluteThickness[0.25], 
     LineBox[{11362, 11363}]}, 
    {Hue[
      NCache[
       Rational[11363, 14307], 0.7942266023624799]], AbsoluteThickness[0.25], 
     LineBox[{11363, 11364}]}, 
    {Hue[
      NCache[
       Rational[3788, 4769], 0.7942964982176557]], AbsoluteThickness[0.25], 
     LineBox[{11364, 11365}]}, 
    {Hue[
      NCache[
       Rational[11365, 14307], 0.7943663940728315]], AbsoluteThickness[0.25], 
     LineBox[{11365, 11366}]}, 
    {Hue[
      NCache[
       Rational[11366, 14307], 0.7944362899280073]], AbsoluteThickness[0.25], 
     LineBox[{11366, 11367}]}, 
    {Hue[
      NCache[
       Rational[3789, 4769], 0.7945061857831831]], AbsoluteThickness[0.25], 
     LineBox[{11367, 11368}]}, 
    {Hue[
      NCache[
       Rational[11368, 14307], 0.7945760816383588]], AbsoluteThickness[0.25], 
     LineBox[{11368, 11369}]}, 
    {Hue[
      NCache[
       Rational[11369, 14307], 0.7946459774935346]], AbsoluteThickness[0.25], 
     LineBox[{11369, 11370}]}, 
    {Hue[
      NCache[
       Rational[3790, 4769], 0.7947158733487104]], AbsoluteThickness[0.25], 
     LineBox[{11370, 11371}]}, 
    {Hue[
      NCache[
       Rational[11371, 14307], 0.7947857692038862]], AbsoluteThickness[0.25], 
     LineBox[{11371, 11372}]}, 
    {Hue[
      NCache[
       Rational[11372, 14307], 0.794855665059062]], AbsoluteThickness[0.25], 
     LineBox[{11372, 11373}]}, 
    {Hue[
      NCache[
       Rational[3791, 4769], 0.7949255609142378]], AbsoluteThickness[0.25], 
     LineBox[{11373, 11374}]}, 
    {Hue[
      NCache[
       Rational[11374, 14307], 0.7949954567694135]], AbsoluteThickness[0.25], 
     LineBox[{11374, 11375}]}, 
    {Hue[
      NCache[
       Rational[11375, 14307], 0.7950653526245893]], AbsoluteThickness[0.25], 
     LineBox[{11375, 11376}]}, 
    {Hue[
      NCache[
       Rational[3792, 4769], 0.7951352484797651]], AbsoluteThickness[0.25], 
     LineBox[{11376, 11377}]}, 
    {Hue[
      NCache[
       Rational[11377, 14307], 0.7952051443349409]], AbsoluteThickness[0.25], 
     LineBox[{11377, 11378}]}, 
    {Hue[
      NCache[
       Rational[11378, 14307], 0.7952750401901167]], AbsoluteThickness[0.25], 
     LineBox[{11378, 11379}]}, 
    {Hue[
      NCache[
       Rational[3793, 4769], 0.7953449360452925]], AbsoluteThickness[0.25], 
     LineBox[{11379, 11380}]}, 
    {Hue[
      NCache[
       Rational[11380, 14307], 0.7954148319004684]], AbsoluteThickness[0.25], 
     LineBox[{11380, 11381}]}, 
    {Hue[
      NCache[
       Rational[599, 753], 0.795484727755644]], AbsoluteThickness[0.25], 
     LineBox[{11381, 11382}]}, 
    {Hue[
      NCache[
       Rational[3794, 4769], 0.7955546236108199]], AbsoluteThickness[0.25], 
     LineBox[{11382, 11383}]}, 
    {Hue[
      NCache[
       Rational[11383, 14307], 0.7956245194659957]], AbsoluteThickness[0.25], 
     LineBox[{11383, 11384}]}, 
    {Hue[
      NCache[
       Rational[11384, 14307], 0.7956944153211715]], AbsoluteThickness[0.25], 
     LineBox[{11384, 11385}]}, 
    {Hue[
      NCache[
       Rational[3795, 4769], 0.7957643111763473]], AbsoluteThickness[0.25], 
     LineBox[{11385, 11386}]}, 
    {Hue[
      NCache[
       Rational[11386, 14307], 0.7958342070315231]], AbsoluteThickness[0.25], 
     LineBox[{11386, 11387}]}, 
    {Hue[
      NCache[
       Rational[11387, 14307], 0.7959041028866988]], AbsoluteThickness[0.25], 
     LineBox[{11387, 11388}]}, 
    {Hue[
      NCache[
       Rational[3796, 4769], 0.7959739987418746]], AbsoluteThickness[0.25], 
     LineBox[{11388, 11389}]}, 
    {Hue[
      NCache[
       Rational[11389, 14307], 0.7960438945970504]], AbsoluteThickness[0.25], 
     LineBox[{11389, 11390}]}, 
    {Hue[
      NCache[
       Rational[11390, 14307], 0.7961137904522262]], AbsoluteThickness[0.25], 
     LineBox[{11390, 11391}]}, 
    {Hue[
      NCache[
       Rational[3797, 4769], 0.796183686307402]], AbsoluteThickness[0.25], 
     LineBox[{11391, 11392}]}, 
    {Hue[
      NCache[
       Rational[11392, 14307], 0.7962535821625778]], AbsoluteThickness[0.25], 
     LineBox[{11392, 11393}]}, 
    {Hue[
      NCache[
       Rational[11393, 14307], 0.7963234780177535]], AbsoluteThickness[0.25], 
     LineBox[{11393, 11394}]}, 
    {Hue[
      NCache[
       Rational[3798, 4769], 0.7963933738729293]], AbsoluteThickness[0.25], 
     LineBox[{11394, 11395}]}, 
    {Hue[
      NCache[
       Rational[11395, 14307], 0.7964632697281051]], AbsoluteThickness[0.25], 
     LineBox[{11395, 11396}]}, 
    {Hue[
      NCache[
       Rational[11396, 14307], 0.7965331655832809]], AbsoluteThickness[0.25], 
     LineBox[{11396, 11397}]}, 
    {Hue[
      NCache[
       Rational[3799, 4769], 0.7966030614384567]], AbsoluteThickness[0.25], 
     LineBox[{11397, 11398}]}, 
    {Hue[
      NCache[
       Rational[11398, 14307], 0.7966729572936325]], AbsoluteThickness[0.25], 
     LineBox[{11398, 11399}]}, 
    {Hue[
      NCache[
       Rational[11399, 14307], 0.7967428531488083]], AbsoluteThickness[0.25], 
     LineBox[{11399, 11400}]}, 
    {Hue[
      NCache[
       Rational[200, 251], 0.796812749003984]], AbsoluteThickness[0.25], 
     LineBox[{11400, 11401}]}, 
    {Hue[
      NCache[
       Rational[11401, 14307], 0.7968826448591598]], AbsoluteThickness[0.25], 
     LineBox[{11401, 11402}]}, 
    {Hue[
      NCache[
       Rational[11402, 14307], 0.7969525407143356]], AbsoluteThickness[0.25], 
     LineBox[{11402, 11403}]}, 
    {Hue[
      NCache[
       Rational[3801, 4769], 0.7970224365695114]], AbsoluteThickness[0.25], 
     LineBox[{11403, 11404}]}, 
    {Hue[
      NCache[
       Rational[11404, 14307], 0.7970923324246872]], AbsoluteThickness[0.25], 
     LineBox[{11404, 11405}]}, 
    {Hue[
      NCache[
       Rational[11405, 14307], 0.797162228279863]], AbsoluteThickness[0.25], 
     LineBox[{11405, 11406}]}, 
    {Hue[
      NCache[
       Rational[3802, 4769], 0.7972321241350387]], AbsoluteThickness[0.25], 
     LineBox[{11406, 11407}]}, 
    {Hue[
      NCache[
       Rational[11407, 14307], 0.7973020199902145]], AbsoluteThickness[0.25], 
     LineBox[{11407, 11408}]}, 
    {Hue[
      NCache[
       Rational[11408, 14307], 0.7973719158453904]], AbsoluteThickness[0.25], 
     LineBox[{11408, 11409}]}, 
    {Hue[
      NCache[
       Rational[3803, 4769], 0.7974418117005662]], AbsoluteThickness[0.25], 
     LineBox[{11409, 11410}]}, 
    {Hue[
      NCache[
       Rational[11410, 14307], 0.797511707555742]], AbsoluteThickness[0.25], 
     LineBox[{11410, 11411}]}, 
    {Hue[
      NCache[
       Rational[11411, 14307], 0.7975816034109178]], AbsoluteThickness[0.25], 
     LineBox[{11411, 11412}]}, 
    {Hue[
      NCache[
       Rational[3804, 4769], 0.7976514992660935]], AbsoluteThickness[0.25], 
     LineBox[{11412, 11413}]}, 
    {Hue[
      NCache[
       Rational[11413, 14307], 0.7977213951212693]], AbsoluteThickness[0.25], 
     LineBox[{11413, 11414}]}, 
    {Hue[
      NCache[
       Rational[11414, 14307], 0.7977912909764451]], AbsoluteThickness[0.25], 
     LineBox[{11414, 11415}]}, 
    {Hue[
      NCache[
       Rational[3805, 4769], 0.7978611868316209]], AbsoluteThickness[0.25], 
     LineBox[{11415, 11416}]}, 
    {Hue[
      NCache[
       Rational[11416, 14307], 0.7979310826867967]], AbsoluteThickness[0.25], 
     LineBox[{11416, 11417}]}, 
    {Hue[
      NCache[
       Rational[11417, 14307], 0.7980009785419725]], AbsoluteThickness[0.25], 
     LineBox[{11417, 11418}]}, 
    {Hue[
      NCache[
       Rational[3806, 4769], 0.7980708743971483]], AbsoluteThickness[0.25], 
     LineBox[{11418, 11419}]}, 
    {Hue[
      NCache[
       Rational[601, 753], 0.798140770252324]], AbsoluteThickness[0.25], 
     LineBox[{11419, 11420}]}, 
    {Hue[
      NCache[
       Rational[11420, 14307], 0.7982106661074998]], AbsoluteThickness[0.25], 
     LineBox[{11420, 11421}]}, 
    {Hue[
      NCache[
       Rational[3807, 4769], 0.7982805619626756]], AbsoluteThickness[0.25], 
     LineBox[{11421, 11422}]}, 
    {Hue[
      NCache[
       Rational[11422, 14307], 0.7983504578178514]], AbsoluteThickness[0.25], 
     LineBox[{11422, 11423}]}, 
    {Hue[
      NCache[
       Rational[11423, 14307], 0.7984203536730272]], AbsoluteThickness[0.25], 
     LineBox[{11423, 11424}]}, 
    {Hue[
      NCache[
       Rational[3808, 4769], 0.798490249528203]], AbsoluteThickness[0.25], 
     LineBox[{11424, 11425}]}, 
    {Hue[
      NCache[
       Rational[11425, 14307], 0.7985601453833787]], AbsoluteThickness[0.25], 
     LineBox[{11425, 11426}]}, 
    {Hue[
      NCache[
       Rational[11426, 14307], 0.7986300412385545]], AbsoluteThickness[0.25], 
     LineBox[{11426, 11427}]}, 
    {Hue[
      NCache[
       Rational[3809, 4769], 0.7986999370937303]], AbsoluteThickness[0.25], 
     LineBox[{11427, 11428}]}, 
    {Hue[
      NCache[
       Rational[11428, 14307], 0.7987698329489061]], AbsoluteThickness[0.25], 
     LineBox[{11428, 11429}]}, 
    {Hue[
      NCache[
       Rational[11429, 14307], 0.7988397288040819]], AbsoluteThickness[0.25], 
     LineBox[{11429, 11430}]}, 
    {Hue[
      NCache[
       Rational[3810, 4769], 0.7989096246592577]], AbsoluteThickness[0.25], 
     LineBox[{11430, 11431}]}, 
    {Hue[
      NCache[
       Rational[11431, 14307], 0.7989795205144334]], AbsoluteThickness[0.25], 
     LineBox[{11431, 11432}]}, 
    {Hue[
      NCache[
       Rational[11432, 14307], 0.7990494163696092]], AbsoluteThickness[0.25], 
     LineBox[{11432, 11433}]}, 
    {Hue[
      NCache[
       Rational[3811, 4769], 0.799119312224785]], AbsoluteThickness[0.25], 
     LineBox[{11433, 11434}]}, 
    {Hue[
      NCache[
       Rational[11434, 14307], 0.7991892080799609]], AbsoluteThickness[0.25], 
     LineBox[{11434, 11435}]}, 
    {Hue[
      NCache[
       Rational[11435, 14307], 0.7992591039351367]], AbsoluteThickness[0.25], 
     LineBox[{11435, 11436}]}, 
    {Hue[
      NCache[
       Rational[3812, 4769], 0.7993289997903125]], AbsoluteThickness[0.25], 
     LineBox[{11436, 11437}]}, 
    {Hue[
      NCache[
       Rational[11437, 14307], 0.7993988956454883]], AbsoluteThickness[0.25], 
     LineBox[{11437, 11438}]}, 
    {Hue[
      NCache[
       Rational[602, 753], 0.799468791500664]], AbsoluteThickness[0.25], 
     LineBox[{11438, 11439}]}, 
    {Hue[
      NCache[
       Rational[3813, 4769], 0.7995386873558398]], AbsoluteThickness[0.25], 
     LineBox[{11439, 11440}]}, 
    {Hue[
      NCache[
       Rational[11440, 14307], 0.7996085832110156]], AbsoluteThickness[0.25], 
     LineBox[{11440, 11441}]}, 
    {Hue[
      NCache[
       Rational[11441, 14307], 0.7996784790661914]], AbsoluteThickness[0.25], 
     LineBox[{11441, 11442}]}, 
    {Hue[
      NCache[
       Rational[3814, 4769], 0.7997483749213672]], AbsoluteThickness[0.25], 
     LineBox[{11442, 11443}]}, 
    {Hue[
      NCache[
       Rational[11443, 14307], 0.799818270776543]], AbsoluteThickness[0.25], 
     LineBox[{11443, 11444}]}, 
    {Hue[
      NCache[
       Rational[11444, 14307], 0.7998881666317187]], AbsoluteThickness[0.25], 
     LineBox[{11444, 11445}]}, 
    {Hue[
      NCache[
       Rational[3815, 4769], 0.7999580624868945]], AbsoluteThickness[0.25], 
     LineBox[{11445, 11446}]}, 
    {Hue[
      NCache[
       Rational[11446, 14307], 0.8000279583420703]], AbsoluteThickness[0.25], 
     LineBox[{11446, 11447}]}, 
    {Hue[
      NCache[
       Rational[11447, 14307], 0.8000978541972461]], AbsoluteThickness[0.25], 
     LineBox[{11447, 11448}]}, 
    {Hue[
      NCache[
       Rational[3816, 4769], 0.8001677500524219]], AbsoluteThickness[0.25], 
     LineBox[{11448, 11449}]}, 
    {Hue[
      NCache[
       Rational[11449, 14307], 0.8002376459075977]], AbsoluteThickness[0.25], 
     LineBox[{11449, 11450}]}, 
    {Hue[
      NCache[
       Rational[11450, 14307], 0.8003075417627735]], AbsoluteThickness[0.25], 
     LineBox[{11450, 11451}]}, 
    {Hue[
      NCache[
       Rational[3817, 4769], 0.8003774376179492]], AbsoluteThickness[0.25], 
     LineBox[{11451, 11452}]}, 
    {Hue[
      NCache[
       Rational[11452, 14307], 0.800447333473125]], AbsoluteThickness[0.25], 
     LineBox[{11452, 11453}]}, 
    {Hue[
      NCache[
       Rational[11453, 14307], 0.8005172293283008]], AbsoluteThickness[0.25], 
     LineBox[{11453, 11454}]}, 
    {Hue[
      NCache[
       Rational[3818, 4769], 0.8005871251834766]], AbsoluteThickness[0.25], 
     LineBox[{11454, 11455}]}, 
    {Hue[
      NCache[
       Rational[11455, 14307], 0.8006570210386524]], AbsoluteThickness[0.25], 
     LineBox[{11455, 11456}]}, 
    {Hue[
      NCache[
       Rational[11456, 14307], 0.8007269168938282]], AbsoluteThickness[0.25], 
     LineBox[{11456, 11457}]}, 
    {Hue[
      NCache[
       Rational[201, 251], 0.8007968127490039]], AbsoluteThickness[0.25], 
     LineBox[{11457, 11458}]}, 
    {Hue[
      NCache[
       Rational[11458, 14307], 0.8008667086041797]], AbsoluteThickness[0.25], 
     LineBox[{11458, 11459}]}, 
    {Hue[
      NCache[
       Rational[11459, 14307], 0.8009366044593556]], AbsoluteThickness[0.25], 
     LineBox[{11459, 11460}]}, 
    {Hue[
      NCache[
       Rational[3820, 4769], 0.8010065003145314]], AbsoluteThickness[0.25], 
     LineBox[{11460, 11461}]}, 
    {Hue[
      NCache[
       Rational[11461, 14307], 0.8010763961697072]], AbsoluteThickness[0.25], 
     LineBox[{11461, 11462}]}, 
    {Hue[
      NCache[
       Rational[11462, 14307], 0.801146292024883]], AbsoluteThickness[0.25], 
     LineBox[{11462, 11463}]}, 
    {Hue[
      NCache[
       Rational[3821, 4769], 0.8012161878800587]], AbsoluteThickness[0.25], 
     LineBox[{11463, 11464}]}, 
    {Hue[
      NCache[
       Rational[11464, 14307], 0.8012860837352345]], AbsoluteThickness[0.25], 
     LineBox[{11464, 11465}]}, 
    {Hue[
      NCache[
       Rational[11465, 14307], 0.8013559795904103]], AbsoluteThickness[0.25], 
     LineBox[{11465, 11466}]}, 
    {Hue[
      NCache[
       Rational[3822, 4769], 0.8014258754455861]], AbsoluteThickness[0.25], 
     LineBox[{11466, 11467}]}, 
    {Hue[
      NCache[
       Rational[11467, 14307], 0.8014957713007619]], AbsoluteThickness[0.25], 
     LineBox[{11467, 11468}]}, 
    {Hue[
      NCache[
       Rational[11468, 14307], 0.8015656671559377]], AbsoluteThickness[0.25], 
     LineBox[{11468, 11469}]}, 
    {Hue[
      NCache[
       Rational[3823, 4769], 0.8016355630111135]], AbsoluteThickness[0.25], 
     LineBox[{11469, 11470}]}, 
    {Hue[
      NCache[
       Rational[11470, 14307], 0.8017054588662892]], AbsoluteThickness[0.25], 
     LineBox[{11470, 11471}]}, 
    {Hue[
      NCache[
       Rational[11471, 14307], 0.801775354721465]], AbsoluteThickness[0.25], 
     LineBox[{11471, 11472}]}, 
    {Hue[
      NCache[
       Rational[3824, 4769], 0.8018452505766408]], AbsoluteThickness[0.25], 
     LineBox[{11472, 11473}]}, 
    {Hue[
      NCache[
       Rational[11473, 14307], 0.8019151464318166]], AbsoluteThickness[0.25], 
     LineBox[{11473, 11474}]}, 
    {Hue[
      NCache[
       Rational[11474, 14307], 0.8019850422869924]], AbsoluteThickness[0.25], 
     LineBox[{11474, 11475}]}, 
    {Hue[
      NCache[
       Rational[3825, 4769], 0.8020549381421682]], AbsoluteThickness[0.25], 
     LineBox[{11475, 11476}]}, 
    {Hue[
      NCache[
       Rational[604, 753], 0.8021248339973439]], AbsoluteThickness[0.25], 
     LineBox[{11476, 11477}]}, 
    {Hue[
      NCache[
       Rational[11477, 14307], 0.8021947298525197]], AbsoluteThickness[0.25], 
     LineBox[{11477, 11478}]}, 
    {Hue[
      NCache[
       Rational[3826, 4769], 0.8022646257076955]], AbsoluteThickness[0.25], 
     LineBox[{11478, 11479}]}, 
    {Hue[
      NCache[
       Rational[11479, 14307], 0.8023345215628713]], AbsoluteThickness[0.25], 
     LineBox[{11479, 11480}]}, 
    {Hue[
      NCache[
       Rational[11480, 14307], 0.8024044174180471]], AbsoluteThickness[0.25], 
     LineBox[{11480, 11481}]}, 
    {Hue[
      NCache[
       Rational[3827, 4769], 0.8024743132732229]], AbsoluteThickness[0.25], 
     LineBox[{11481, 11482}]}, 
    {Hue[
      NCache[
       Rational[11482, 14307], 0.8025442091283986]], AbsoluteThickness[0.25], 
     LineBox[{11482, 11483}]}, 
    {Hue[
      NCache[
       Rational[11483, 14307], 0.8026141049835744]], AbsoluteThickness[0.25], 
     LineBox[{11483, 11484}]}, 
    {Hue[
      NCache[
       Rational[3828, 4769], 0.8026840008387502]], AbsoluteThickness[0.25], 
     LineBox[{11484, 11485}]}, 
    {Hue[
      NCache[
       Rational[11485, 14307], 0.802753896693926]], AbsoluteThickness[0.25], 
     LineBox[{11485, 11486}]}, 
    {Hue[
      NCache[
       Rational[11486, 14307], 0.8028237925491019]], AbsoluteThickness[0.25], 
     LineBox[{11486, 11487}]}, 
    {Hue[
      NCache[
       Rational[3829, 4769], 0.8028936884042777]], AbsoluteThickness[0.25], 
     LineBox[{11487, 11488}]}, 
    {Hue[
      NCache[
       Rational[11488, 14307], 0.8029635842594535]], AbsoluteThickness[0.25], 
     LineBox[{11488, 11489}]}, 
    {Hue[
      NCache[
       Rational[11489, 14307], 0.8030334801146292]], AbsoluteThickness[0.25], 
     LineBox[{11489, 11490}]}, 
    {Hue[
      NCache[
       Rational[3830, 4769], 0.803103375969805]], AbsoluteThickness[0.25], 
     LineBox[{11490, 11491}]}, 
    {Hue[
      NCache[
       Rational[11491, 14307], 0.8031732718249808]], AbsoluteThickness[0.25], 
     LineBox[{11491, 11492}]}, 
    {Hue[
      NCache[
       Rational[11492, 14307], 0.8032431676801566]], AbsoluteThickness[0.25], 
     LineBox[{11492, 11493}]}, 
    {Hue[
      NCache[
       Rational[3831, 4769], 0.8033130635353324]], AbsoluteThickness[0.25], 
     LineBox[{11493, 11494}]}, 
    {Hue[
      NCache[
       Rational[11494, 14307], 0.8033829593905082]], AbsoluteThickness[0.25], 
     LineBox[{11494, 11495}]}, 
    {Hue[
      NCache[
       Rational[605, 753], 0.8034528552456839]], AbsoluteThickness[0.25], 
     LineBox[{11495, 11496}]}, 
    {Hue[
      NCache[
       Rational[3832, 4769], 0.8035227511008597]], AbsoluteThickness[0.25], 
     LineBox[{11496, 11497}]}, 
    {Hue[
      NCache[
       Rational[11497, 14307], 0.8035926469560355]], AbsoluteThickness[0.25], 
     LineBox[{11497, 11498}]}, 
    {Hue[
      NCache[
       Rational[11498, 14307], 0.8036625428112113]], AbsoluteThickness[0.25], 
     LineBox[{11498, 11499}]}, 
    {Hue[
      NCache[
       Rational[3833, 4769], 0.8037324386663871]], AbsoluteThickness[0.25], 
     LineBox[{11499, 11500}]}, 
    {Hue[
      NCache[
       Rational[11500, 14307], 0.8038023345215629]], AbsoluteThickness[0.25], 
     LineBox[{11500, 11501}]}, 
    {Hue[
      NCache[
       Rational[11501, 14307], 0.8038722303767386]], AbsoluteThickness[0.25], 
     LineBox[{11501, 11502}]}, 
    {Hue[
      NCache[
       Rational[3834, 4769], 0.8039421262319144]], AbsoluteThickness[0.25], 
     LineBox[{11502, 11503}]}, 
    {Hue[
      NCache[
       Rational[11503, 14307], 0.8040120220870902]], AbsoluteThickness[0.25], 
     LineBox[{11503, 11504}]}, 
    {Hue[
      NCache[
       Rational[11504, 14307], 0.804081917942266]], AbsoluteThickness[0.25], 
     LineBox[{11504, 11505}]}, 
    {Hue[
      NCache[
       Rational[3835, 4769], 0.8041518137974418]], AbsoluteThickness[0.25], 
     LineBox[{11505, 11506}]}, 
    {Hue[
      NCache[
       Rational[11506, 14307], 0.8042217096526176]], AbsoluteThickness[0.25], 
     LineBox[{11506, 11507}]}, 
    {Hue[
      NCache[
       Rational[11507, 14307], 0.8042916055077934]], AbsoluteThickness[0.25], 
     LineBox[{11507, 11508}]}, 
    {Hue[
      NCache[
       Rational[3836, 4769], 0.8043615013629691]], AbsoluteThickness[0.25], 
     LineBox[{11508, 11509}]}, 
    {Hue[
      NCache[
       Rational[11509, 14307], 0.8044313972181449]], AbsoluteThickness[0.25], 
     LineBox[{11509, 11510}]}, 
    {Hue[
      NCache[
       Rational[11510, 14307], 0.8045012930733207]], AbsoluteThickness[0.25], 
     LineBox[{11510, 11511}]}, 
    {Hue[
      NCache[
       Rational[3837, 4769], 0.8045711889284966]], AbsoluteThickness[0.25], 
     LineBox[{11511, 11512}]}, 
    {Hue[
      NCache[
       Rational[11512, 14307], 0.8046410847836724]], AbsoluteThickness[0.25], 
     LineBox[{11512, 11513}]}, 
    {Hue[
      NCache[
       Rational[11513, 14307], 0.8047109806388482]], AbsoluteThickness[0.25], 
     LineBox[{11513, 11514}]}, 
    {Hue[
      NCache[
       Rational[202, 251], 0.8047808764940239]], AbsoluteThickness[0.25], 
     LineBox[{11514, 11515}]}, 
    {Hue[
      NCache[
       Rational[11515, 14307], 0.8048507723491997]], AbsoluteThickness[0.25], 
     LineBox[{11515, 11516}]}, 
    {Hue[
      NCache[
       Rational[11516, 14307], 0.8049206682043755]], AbsoluteThickness[0.25], 
     LineBox[{11516, 11517}]}, 
    {Hue[
      NCache[
       Rational[3839, 4769], 0.8049905640595513]], AbsoluteThickness[0.25], 
     LineBox[{11517, 11518}]}, 
    {Hue[
      NCache[
       Rational[11518, 14307], 0.8050604599147271]], AbsoluteThickness[0.25], 
     LineBox[{11518, 11519}]}, 
    {Hue[
      NCache[
       Rational[11519, 14307], 0.8051303557699029]], AbsoluteThickness[0.25], 
     LineBox[{11519, 11520}]}, 
    {Hue[
      NCache[
       Rational[3840, 4769], 0.8052002516250786]], AbsoluteThickness[0.25], 
     LineBox[{11520, 11521}]}, 
    {Hue[
      NCache[
       Rational[11521, 14307], 0.8052701474802544]], AbsoluteThickness[0.25], 
     LineBox[{11521, 11522}]}, 
    {Hue[
      NCache[
       Rational[11522, 14307], 0.8053400433354302]], AbsoluteThickness[0.25], 
     LineBox[{11522, 11523}]}, 
    {Hue[
      NCache[
       Rational[3841, 4769], 0.805409939190606]], AbsoluteThickness[0.25], 
     LineBox[{11523, 11524}]}, 
    {Hue[
      NCache[
       Rational[11524, 14307], 0.8054798350457818]], AbsoluteThickness[0.25], 
     LineBox[{11524, 11525}]}, 
    {Hue[
      NCache[
       Rational[11525, 14307], 0.8055497309009576]], AbsoluteThickness[0.25], 
     LineBox[{11525, 11526}]}, 
    {Hue[
      NCache[
       Rational[3842, 4769], 0.8056196267561334]], AbsoluteThickness[0.25], 
     LineBox[{11526, 11527}]}, 
    {Hue[
      NCache[
       Rational[11527, 14307], 0.8056895226113091]], AbsoluteThickness[0.25], 
     LineBox[{11527, 11528}]}, 
    {Hue[
      NCache[
       Rational[11528, 14307], 0.8057594184664849]], AbsoluteThickness[0.25], 
     LineBox[{11528, 11529}]}, 
    {Hue[
      NCache[
       Rational[3843, 4769], 0.8058293143216607]], AbsoluteThickness[0.25], 
     LineBox[{11529, 11530}]}, 
    {Hue[
      NCache[
       Rational[11530, 14307], 0.8058992101768365]], AbsoluteThickness[0.25], 
     LineBox[{11530, 11531}]}, 
    {Hue[
      NCache[
       Rational[11531, 14307], 0.8059691060320123]], AbsoluteThickness[0.25], 
     LineBox[{11531, 11532}]}, 
    {Hue[
      NCache[
       Rational[3844, 4769], 0.8060390018871881]], AbsoluteThickness[0.25], 
     LineBox[{11532, 11533}]}, 
    {Hue[
      NCache[
       Rational[607, 753], 0.8061088977423638]], AbsoluteThickness[0.25], 
     LineBox[{11533, 11534}]}, 
    {Hue[
      NCache[
       Rational[11534, 14307], 0.8061787935975396]], AbsoluteThickness[0.25], 
     LineBox[{11534, 11535}]}, 
    {Hue[
      NCache[
       Rational[3845, 4769], 0.8062486894527154]], AbsoluteThickness[0.25], 
     LineBox[{11535, 11536}]}, 
    {Hue[
      NCache[
       Rational[11536, 14307], 0.8063185853078912]], AbsoluteThickness[0.25], 
     LineBox[{11536, 11537}]}, 
    {Hue[
      NCache[
       Rational[11537, 14307], 0.806388481163067]], AbsoluteThickness[0.25], 
     LineBox[{11537, 11538}]}, 
    {Hue[
      NCache[
       Rational[3846, 4769], 0.8064583770182429]], AbsoluteThickness[0.25], 
     LineBox[{11538, 11539}]}, 
    {Hue[
      NCache[
       Rational[11539, 14307], 0.8065282728734187]], AbsoluteThickness[0.25], 
     LineBox[{11539, 11540}]}, 
    {Hue[
      NCache[
       Rational[11540, 14307], 0.8065981687285944]], AbsoluteThickness[0.25], 
     LineBox[{11540, 11541}]}, 
    {Hue[
      NCache[
       Rational[3847, 4769], 0.8066680645837702]], AbsoluteThickness[0.25], 
     LineBox[{11541, 11542}]}, 
    {Hue[
      NCache[
       Rational[11542, 14307], 0.806737960438946]], AbsoluteThickness[0.25], 
     LineBox[{11542, 11543}]}, 
    {Hue[
      NCache[
       Rational[11543, 14307], 0.8068078562941218]], AbsoluteThickness[0.25], 
     LineBox[{11543, 11544}]}, 
    {Hue[
      NCache[
       Rational[3848, 4769], 0.8068777521492976]], AbsoluteThickness[0.25], 
     LineBox[{11544, 11545}]}, 
    {Hue[
      NCache[
       Rational[11545, 14307], 0.8069476480044734]], AbsoluteThickness[0.25], 
     LineBox[{11545, 11546}]}, 
    {Hue[
      NCache[
       Rational[46, 57], 0.8070175438596491]], AbsoluteThickness[0.25], 
     LineBox[{11546, 11547}]}, 
    {Hue[
      NCache[
       Rational[3849, 4769], 0.8070874397148249]], AbsoluteThickness[0.25], 
     LineBox[{11547, 11548}]}, 
    {Hue[
      NCache[
       Rational[11548, 14307], 0.8071573355700007]], AbsoluteThickness[0.25], 
     LineBox[{11548, 11549}]}, 
    {Hue[
      NCache[
       Rational[11549, 14307], 0.8072272314251765]], AbsoluteThickness[0.25], 
     LineBox[{11549, 11550}]}, 
    {Hue[
      NCache[
       Rational[3850, 4769], 0.8072971272803523]], AbsoluteThickness[0.25], 
     LineBox[{11550, 11551}]}, 
    {Hue[
      NCache[
       Rational[11551, 14307], 0.8073670231355281]], AbsoluteThickness[0.25], 
     LineBox[{11551, 11552}]}, 
    {Hue[
      NCache[
       Rational[608, 753], 0.8074369189907038]], AbsoluteThickness[0.25], 
     LineBox[{11552, 11553}]}, 
    {Hue[
      NCache[
       Rational[3851, 4769], 0.8075068148458796]], AbsoluteThickness[0.25], 
     LineBox[{11553, 11554}]}, 
    {Hue[
      NCache[
       Rational[11554, 14307], 0.8075767107010554]], AbsoluteThickness[0.25], 
     LineBox[{11554, 11555}]}, 
    {Hue[
      NCache[
       Rational[11555, 14307], 0.8076466065562312]], AbsoluteThickness[0.25], 
     LineBox[{11555, 11556}]}, 
    {Hue[
      NCache[
       Rational[3852, 4769], 0.807716502411407]], AbsoluteThickness[0.25], 
     LineBox[{11556, 11557}]}, 
    {Hue[
      NCache[
       Rational[11557, 14307], 0.8077863982665828]], AbsoluteThickness[0.25], 
     LineBox[{11557, 11558}]}, 
    {Hue[
      NCache[
       Rational[11558, 14307], 0.8078562941217586]], AbsoluteThickness[0.25], 
     LineBox[{11558, 11559}]}, 
    {Hue[
      NCache[
       Rational[3853, 4769], 0.8079261899769343]], AbsoluteThickness[0.25], 
     LineBox[{11559, 11560}]}, 
    {Hue[
      NCache[
       Rational[11560, 14307], 0.8079960858321101]], AbsoluteThickness[0.25], 
     LineBox[{11560, 11561}]}, 
    {Hue[
      NCache[
       Rational[11561, 14307], 0.8080659816872859]], AbsoluteThickness[0.25], 
     LineBox[{11561, 11562}]}, 
    {Hue[
      NCache[
       Rational[3854, 4769], 0.8081358775424617]], AbsoluteThickness[0.25], 
     LineBox[{11562, 11563}]}, 
    {Hue[
      NCache[
       Rational[11563, 14307], 0.8082057733976376]], AbsoluteThickness[0.25], 
     LineBox[{11563, 11564}]}, 
    {Hue[
      NCache[
       Rational[11564, 14307], 0.8082756692528134]], AbsoluteThickness[0.25], 
     LineBox[{11564, 11565}]}, 
    {Hue[
      NCache[
       Rational[3855, 4769], 0.808345565107989]], AbsoluteThickness[0.25], 
     LineBox[{11565, 11566}]}, 
    {Hue[
      NCache[
       Rational[11566, 14307], 0.8084154609631649]], AbsoluteThickness[0.25], 
     LineBox[{11566, 11567}]}, 
    {Hue[
      NCache[
       Rational[11567, 14307], 0.8084853568183407]], AbsoluteThickness[0.25], 
     LineBox[{11567, 11568}]}, 
    {Hue[
      NCache[
       Rational[3856, 4769], 0.8085552526735165]], AbsoluteThickness[0.25], 
     LineBox[{11568, 11569}]}, 
    {Hue[
      NCache[
       Rational[11569, 14307], 0.8086251485286923]], AbsoluteThickness[0.25], 
     LineBox[{11569, 11570}]}, 
    {Hue[
      NCache[
       Rational[11570, 14307], 0.8086950443838681]], AbsoluteThickness[0.25], 
     LineBox[{11570, 11571}]}, 
    {Hue[
      NCache[
       Rational[203, 251], 0.8087649402390438]], AbsoluteThickness[0.25], 
     LineBox[{11571, 11572}]}, 
    {Hue[
      NCache[
       Rational[11572, 14307], 0.8088348360942196]], AbsoluteThickness[0.25], 
     LineBox[{11572, 11573}]}, 
    {Hue[
      NCache[
       Rational[11573, 14307], 0.8089047319493954]], AbsoluteThickness[0.25], 
     LineBox[{11573, 11574}]}, 
    {Hue[
      NCache[
       Rational[3858, 4769], 0.8089746278045712]], AbsoluteThickness[0.25], 
     LineBox[{11574, 11575}]}, 
    {Hue[
      NCache[
       Rational[11575, 14307], 0.809044523659747]], AbsoluteThickness[0.25], 
     LineBox[{11575, 11576}]}, 
    {Hue[
      NCache[
       Rational[11576, 14307], 0.8091144195149228]], AbsoluteThickness[0.25], 
     LineBox[{11576, 11577}]}, 
    {Hue[
      NCache[
       Rational[3859, 4769], 0.8091843153700986]], AbsoluteThickness[0.25], 
     LineBox[{11577, 11578}]}, 
    {Hue[
      NCache[
       Rational[11578, 14307], 0.8092542112252743]], AbsoluteThickness[0.25], 
     LineBox[{11578, 11579}]}, 
    {Hue[
      NCache[
       Rational[11579, 14307], 0.8093241070804501]], AbsoluteThickness[0.25], 
     LineBox[{11579, 11580}]}, 
    {Hue[
      NCache[
       Rational[3860, 4769], 0.8093940029356259]], AbsoluteThickness[0.25], 
     LineBox[{11580, 11581}]}, 
    {Hue[
      NCache[
       Rational[11581, 14307], 0.8094638987908017]], AbsoluteThickness[0.25], 
     LineBox[{11581, 11582}]}, 
    {Hue[
      NCache[
       Rational[11582, 14307], 0.8095337946459775]], AbsoluteThickness[0.25], 
     LineBox[{11582, 11583}]}, 
    {Hue[
      NCache[
       Rational[3861, 4769], 0.8096036905011533]], AbsoluteThickness[0.25], 
     LineBox[{11583, 11584}]}, 
    {Hue[
      NCache[
       Rational[11584, 14307], 0.809673586356329]], AbsoluteThickness[0.25], 
     LineBox[{11584, 11585}]}, 
    {Hue[
      NCache[
       Rational[11585, 14307], 0.8097434822115048]], AbsoluteThickness[0.25], 
     LineBox[{11585, 11586}]}, 
    {Hue[
      NCache[
       Rational[3862, 4769], 0.8098133780666806]], AbsoluteThickness[0.25], 
     LineBox[{11586, 11587}]}, 
    {Hue[
      NCache[
       Rational[11587, 14307], 0.8098832739218564]], AbsoluteThickness[0.25], 
     LineBox[{11587, 11588}]}, 
    {Hue[
      NCache[
       Rational[11588, 14307], 0.8099531697770322]], AbsoluteThickness[0.25], 
     LineBox[{11588, 11589}]}, 
    {Hue[
      NCache[
       Rational[3863, 4769], 0.810023065632208]], AbsoluteThickness[0.25], 
     LineBox[{11589, 11590}]}, 
    {Hue[
      NCache[
       Rational[610, 753], 0.8100929614873837]], AbsoluteThickness[0.25], 
     LineBox[{11590, 11591}]}, 
    {Hue[
      NCache[
       Rational[11591, 14307], 0.8101628573425596]], AbsoluteThickness[0.25], 
     LineBox[{11591, 11592}]}, 
    {Hue[
      NCache[
       Rational[3864, 4769], 0.8102327531977354]], AbsoluteThickness[0.25], 
     LineBox[{11592, 11593}]}, 
    {Hue[
      NCache[
       Rational[11593, 14307], 0.8103026490529112]], AbsoluteThickness[0.25], 
     LineBox[{11593, 11594}]}, 
    {Hue[
      NCache[
       Rational[11594, 14307], 0.810372544908087]], AbsoluteThickness[0.25], 
     LineBox[{11594, 11595}]}, 
    {Hue[
      NCache[
       Rational[3865, 4769], 0.8104424407632628]], AbsoluteThickness[0.25], 
     LineBox[{11595, 11596}]}, 
    {Hue[
      NCache[
       Rational[11596, 14307], 0.8105123366184386]], AbsoluteThickness[0.25], 
     LineBox[{11596, 11597}]}, 
    {Hue[
      NCache[
       Rational[11597, 14307], 0.8105822324736143]], AbsoluteThickness[0.25], 
     LineBox[{11597, 11598}]}, 
    {Hue[
      NCache[
       Rational[3866, 4769], 0.8106521283287901]], AbsoluteThickness[0.25], 
     LineBox[{11598, 11599}]}, 
    {Hue[
      NCache[
       Rational[11599, 14307], 0.8107220241839659]], AbsoluteThickness[0.25], 
     LineBox[{11599, 11600}]}, 
    {Hue[
      NCache[
       Rational[11600, 14307], 0.8107919200391417]], AbsoluteThickness[0.25], 
     LineBox[{11600, 11601}]}, 
    {Hue[
      NCache[
       Rational[3867, 4769], 0.8108618158943175]], AbsoluteThickness[0.25], 
     LineBox[{11601, 11602}]}, 
    {Hue[
      NCache[
       Rational[11602, 14307], 0.8109317117494933]], AbsoluteThickness[0.25], 
     LineBox[{11602, 11603}]}, 
    {Hue[
      NCache[
       Rational[11603, 14307], 0.811001607604669]], AbsoluteThickness[0.25], 
     LineBox[{11603, 11604}]}, 
    {Hue[
      NCache[
       Rational[3868, 4769], 0.8110715034598448]], AbsoluteThickness[0.25], 
     LineBox[{11604, 11605}]}, 
    {Hue[
      NCache[
       Rational[11605, 14307], 0.8111413993150206]], AbsoluteThickness[0.25], 
     LineBox[{11605, 11606}]}, 
    {Hue[
      NCache[
       Rational[11606, 14307], 0.8112112951701964]], AbsoluteThickness[0.25], 
     LineBox[{11606, 11607}]}, 
    {Hue[
      NCache[
       Rational[3869, 4769], 0.8112811910253722]], AbsoluteThickness[0.25], 
     LineBox[{11607, 11608}]}, 
    {Hue[
      NCache[
       Rational[11608, 14307], 0.811351086880548]], AbsoluteThickness[0.25], 
     LineBox[{11608, 11609}]}, 
    {Hue[
      NCache[
       Rational[611, 753], 0.8114209827357237]], AbsoluteThickness[0.25], 
     LineBox[{11609, 11610}]}, 
    {Hue[
      NCache[
       Rational[3870, 4769], 0.8114908785908995]], AbsoluteThickness[0.25], 
     LineBox[{11610, 11611}]}, 
    {Hue[
      NCache[
       Rational[11611, 14307], 0.8115607744460753]], AbsoluteThickness[0.25], 
     LineBox[{11611, 11612}]}, 
    {Hue[
      NCache[
       Rational[11612, 14307], 0.8116306703012511]], AbsoluteThickness[0.25], 
     LineBox[{11612, 11613}]}, 
    {Hue[
      NCache[
       Rational[3871, 4769], 0.8117005661564269]], AbsoluteThickness[0.25], 
     LineBox[{11613, 11614}]}, 
    {Hue[
      NCache[
       Rational[11614, 14307], 0.8117704620116027]], AbsoluteThickness[0.25], 
     LineBox[{11614, 11615}]}, 
    {Hue[
      NCache[
       Rational[11615, 14307], 0.8118403578667786]], AbsoluteThickness[0.25], 
     LineBox[{11615, 11616}]}, 
    {Hue[
      NCache[
       Rational[3872, 4769], 0.8119102537219542]], AbsoluteThickness[0.25], 
     LineBox[{11616, 11617}]}, 
    {Hue[
      NCache[
       Rational[11617, 14307], 0.81198014957713]], AbsoluteThickness[0.25], 
     LineBox[{11617, 11618}]}, 
    {Hue[
      NCache[
       Rational[11618, 14307], 0.8120500454323059]], AbsoluteThickness[0.25], 
     LineBox[{11618, 11619}]}, 
    {Hue[
      NCache[
       Rational[3873, 4769], 0.8121199412874817]], AbsoluteThickness[0.25], 
     LineBox[{11619, 11620}]}, 
    {Hue[
      NCache[
       Rational[11620, 14307], 0.8121898371426575]], AbsoluteThickness[0.25], 
     LineBox[{11620, 11621}]}, 
    {Hue[
      NCache[
       Rational[11621, 14307], 0.8122597329978333]], AbsoluteThickness[0.25], 
     LineBox[{11621, 11622}]}, 
    {Hue[
      NCache[
       Rational[3874, 4769], 0.812329628853009]], AbsoluteThickness[0.25], 
     LineBox[{11622, 11623}]}, 
    {Hue[
      NCache[
       Rational[11623, 14307], 0.8123995247081848]], AbsoluteThickness[0.25], 
     LineBox[{11623, 11624}]}, 
    {Hue[
      NCache[
       Rational[11624, 14307], 0.8124694205633606]], AbsoluteThickness[0.25], 
     LineBox[{11624, 11625}]}, 
    {Hue[
      NCache[
       Rational[3875, 4769], 0.8125393164185364]], AbsoluteThickness[0.25], 
     LineBox[{11625, 11626}]}, 
    {Hue[
      NCache[
       Rational[11626, 14307], 0.8126092122737122]], AbsoluteThickness[0.25], 
     LineBox[{11626, 11627}]}, 
    {Hue[
      NCache[
       Rational[11627, 14307], 0.812679108128888]], AbsoluteThickness[0.25], 
     LineBox[{11627, 11628}]}, 
    {Hue[
      NCache[
       Rational[204, 251], 0.8127490039840638]], AbsoluteThickness[0.25], 
     LineBox[{11628, 11629}]}, 
    {Hue[
      NCache[
       Rational[11629, 14307], 0.8128188998392395]], AbsoluteThickness[0.25], 
     LineBox[{11629, 11630}]}, 
    {Hue[
      NCache[
       Rational[11630, 14307], 0.8128887956944153]], AbsoluteThickness[0.25], 
     LineBox[{11630, 11631}]}, 
    {Hue[
      NCache[
       Rational[3877, 4769], 0.8129586915495911]], AbsoluteThickness[0.25], 
     LineBox[{11631, 11632}]}, 
    {Hue[
      NCache[
       Rational[11632, 14307], 0.8130285874047669]], AbsoluteThickness[0.25], 
     LineBox[{11632, 11633}]}, 
    {Hue[
      NCache[
       Rational[11633, 14307], 0.8130984832599427]], AbsoluteThickness[0.25], 
     LineBox[{11633, 11634}]}, 
    {Hue[
      NCache[
       Rational[3878, 4769], 0.8131683791151185]], AbsoluteThickness[0.25], 
     LineBox[{11634, 11635}]}, 
    {Hue[
      NCache[
       Rational[11635, 14307], 0.8132382749702942]], AbsoluteThickness[0.25], 
     LineBox[{11635, 11636}]}, 
    {Hue[
      NCache[
       Rational[11636, 14307], 0.81330817082547]], AbsoluteThickness[0.25], 
     LineBox[{11636, 11637}]}, 
    {Hue[
      NCache[
       Rational[3879, 4769], 0.8133780666806458]], AbsoluteThickness[0.25], 
     LineBox[{11637, 11638}]}, 
    {Hue[
      NCache[
       Rational[11638, 14307], 0.8134479625358216]], AbsoluteThickness[0.25], 
     LineBox[{11638, 11639}]}, 
    {Hue[
      NCache[
       Rational[11639, 14307], 0.8135178583909974]], AbsoluteThickness[0.25], 
     LineBox[{11639, 11640}]}, 
    {Hue[
      NCache[
       Rational[3880, 4769], 0.8135877542461732]], AbsoluteThickness[0.25], 
     LineBox[{11640, 11641}]}, 
    {Hue[
      NCache[
       Rational[11641, 14307], 0.8136576501013489]], AbsoluteThickness[0.25], 
     LineBox[{11641, 11642}]}, 
    {Hue[
      NCache[
       Rational[11642, 14307], 0.8137275459565247]], AbsoluteThickness[0.25], 
     LineBox[{11642, 11643}]}, 
    {Hue[
      NCache[
       Rational[3881, 4769], 0.8137974418117006]], AbsoluteThickness[0.25], 
     LineBox[{11643, 11644}]}, 
    {Hue[
      NCache[
       Rational[11644, 14307], 0.8138673376668764]], AbsoluteThickness[0.25], 
     LineBox[{11644, 11645}]}, 
    {Hue[
      NCache[
       Rational[11645, 14307], 0.8139372335220522]], AbsoluteThickness[0.25], 
     LineBox[{11645, 11646}]}, 
    {Hue[
      NCache[
       Rational[3882, 4769], 0.814007129377228]], AbsoluteThickness[0.25], 
     LineBox[{11646, 11647}]}, 
    {Hue[
      NCache[
       Rational[613, 753], 0.8140770252324038]], AbsoluteThickness[0.25], 
     LineBox[{11647, 11648}]}, 
    {Hue[
      NCache[
       Rational[11648, 14307], 0.8141469210875795]], AbsoluteThickness[0.25], 
     LineBox[{11648, 11649}]}, 
    {Hue[
      NCache[
       Rational[3883, 4769], 0.8142168169427553]], AbsoluteThickness[0.25], 
     LineBox[{11649, 11650}]}, 
    {Hue[
      NCache[
       Rational[11650, 14307], 0.8142867127979311]], AbsoluteThickness[0.25], 
     LineBox[{11650, 11651}]}, 
    {Hue[
      NCache[
       Rational[11651, 14307], 0.8143566086531069]], AbsoluteThickness[0.25], 
     LineBox[{11651, 11652}]}, 
    {Hue[
      NCache[
       Rational[3884, 4769], 0.8144265045082827]], AbsoluteThickness[0.25], 
     LineBox[{11652, 11653}]}, 
    {Hue[
      NCache[
       Rational[11653, 14307], 0.8144964003634585]], AbsoluteThickness[0.25], 
     LineBox[{11653, 11654}]}, 
    {Hue[
      NCache[
       Rational[11654, 14307], 0.8145662962186342]], AbsoluteThickness[0.25], 
     LineBox[{11654, 11655}]}, 
    {Hue[
      NCache[
       Rational[3885, 4769], 0.81463619207381]], AbsoluteThickness[0.25], 
     LineBox[{11655, 11656}]}, 
    {Hue[
      NCache[
       Rational[11656, 14307], 0.8147060879289858]], AbsoluteThickness[0.25], 
     LineBox[{11656, 11657}]}, 
    {Hue[
      NCache[
       Rational[11657, 14307], 0.8147759837841616]], AbsoluteThickness[0.25], 
     LineBox[{11657, 11658}]}, 
    {Hue[
      NCache[
       Rational[3886, 4769], 0.8148458796393374]], AbsoluteThickness[0.25], 
     LineBox[{11658, 11659}]}, 
    {Hue[
      NCache[
       Rational[11659, 14307], 0.8149157754945132]], AbsoluteThickness[0.25], 
     LineBox[{11659, 11660}]}, 
    {Hue[
      NCache[
       Rational[11660, 14307], 0.8149856713496889]], AbsoluteThickness[0.25], 
     LineBox[{11660, 11661}]}, 
    {Hue[
      NCache[
       Rational[3887, 4769], 0.8150555672048647]], AbsoluteThickness[0.25], 
     LineBox[{11661, 11662}]}, 
    {Hue[
      NCache[
       Rational[11662, 14307], 0.8151254630600405]], AbsoluteThickness[0.25], 
     LineBox[{11662, 11663}]}, 
    {Hue[
      NCache[
       Rational[11663, 14307], 0.8151953589152163]], AbsoluteThickness[0.25], 
     LineBox[{11663, 11664}]}, 
    {Hue[
      NCache[
       Rational[3888, 4769], 0.8152652547703921]], AbsoluteThickness[0.25], 
     LineBox[{11664, 11665}]}, 
    {Hue[
      NCache[
       Rational[11665, 14307], 0.8153351506255679]], AbsoluteThickness[0.25], 
     LineBox[{11665, 11666}]}, 
    {Hue[
      NCache[
       Rational[614, 753], 0.8154050464807437]], AbsoluteThickness[0.25], 
     LineBox[{11666, 11667}]}, 
    {Hue[
      NCache[
       Rational[3889, 4769], 0.8154749423359194]], AbsoluteThickness[0.25], 
     LineBox[{11667, 11668}]}, 
    {Hue[
      NCache[
       Rational[11668, 14307], 0.8155448381910952]], AbsoluteThickness[0.25], 
     LineBox[{11668, 11669}]}, 
    {Hue[
      NCache[
       Rational[11669, 14307], 0.815614734046271]], AbsoluteThickness[0.25], 
     LineBox[{11669, 11670}]}, 
    {Hue[
      NCache[
       Rational[3890, 4769], 0.8156846299014469]], AbsoluteThickness[0.25], 
     LineBox[{11670, 11671}]}, 
    {Hue[
      NCache[
       Rational[11671, 14307], 0.8157545257566227]], AbsoluteThickness[0.25], 
     LineBox[{11671, 11672}]}, 
    {Hue[
      NCache[
       Rational[11672, 14307], 0.8158244216117985]], AbsoluteThickness[0.25], 
     LineBox[{11672, 11673}]}, 
    {Hue[
      NCache[
       Rational[3891, 4769], 0.8158943174669742]], AbsoluteThickness[0.25], 
     LineBox[{11673, 11674}]}, 
    {Hue[
      NCache[
       Rational[11674, 14307], 0.81596421332215]], AbsoluteThickness[0.25], 
     LineBox[{11674, 11675}]}, 
    {Hue[
      NCache[
       Rational[11675, 14307], 0.8160341091773258]], AbsoluteThickness[0.25], 
     LineBox[{11675, 11676}]}, 
    {Hue[
      NCache[
       Rational[3892, 4769], 0.8161040050325016]], AbsoluteThickness[0.25], 
     LineBox[{11676, 11677}]}, 
    {Hue[
      NCache[
       Rational[11677, 14307], 0.8161739008876774]], AbsoluteThickness[0.25], 
     LineBox[{11677, 11678}]}, 
    {Hue[
      NCache[
       Rational[11678, 14307], 0.8162437967428532]], AbsoluteThickness[0.25], 
     LineBox[{11678, 11679}]}, 
    {Hue[
      NCache[
       Rational[3893, 4769], 0.8163136925980289]], AbsoluteThickness[0.25], 
     LineBox[{11679, 11680}]}, 
    {Hue[
      NCache[
       Rational[11680, 14307], 0.8163835884532047]], AbsoluteThickness[0.25], 
     LineBox[{11680, 11681}]}, 
    {Hue[
      NCache[
       Rational[11681, 14307], 0.8164534843083805]], AbsoluteThickness[0.25], 
     LineBox[{11681, 11682}]}, 
    {Hue[
      NCache[
       Rational[3894, 4769], 0.8165233801635563]], AbsoluteThickness[0.25], 
     LineBox[{11682, 11683}]}, 
    {Hue[
      NCache[
       Rational[11683, 14307], 0.8165932760187321]], AbsoluteThickness[0.25], 
     LineBox[{11683, 11684}]}, 
    {Hue[
      NCache[
       Rational[11684, 14307], 0.8166631718739079]], AbsoluteThickness[0.25], 
     LineBox[{11684, 11685}]}, 
    {Hue[
      NCache[
       Rational[205, 251], 0.8167330677290837]], AbsoluteThickness[0.25], 
     LineBox[{11685, 11686}]}, 
    {Hue[
      NCache[
       Rational[11686, 14307], 0.8168029635842594]], AbsoluteThickness[0.25], 
     LineBox[{11686, 11687}]}, 
    {Hue[
      NCache[
       Rational[11687, 14307], 0.8168728594394352]], AbsoluteThickness[0.25], 
     LineBox[{11687, 11688}]}, 
    {Hue[
      NCache[
       Rational[3896, 4769], 0.816942755294611]], AbsoluteThickness[0.25], 
     LineBox[{11688, 11689}]}, 
    {Hue[
      NCache[
       Rational[11689, 14307], 0.8170126511497868]], AbsoluteThickness[0.25], 
     LineBox[{11689, 11690}]}, 
    {Hue[
      NCache[
       Rational[11690, 14307], 0.8170825470049626]], AbsoluteThickness[0.25], 
     LineBox[{11690, 11691}]}, 
    {Hue[
      NCache[
       Rational[3897, 4769], 0.8171524428601384]], AbsoluteThickness[0.25], 
     LineBox[{11691, 11692}]}, 
    {Hue[
      NCache[
       Rational[11692, 14307], 0.8172223387153141]], AbsoluteThickness[0.25], 
     LineBox[{11692, 11693}]}, 
    {Hue[
      NCache[
       Rational[11693, 14307], 0.8172922345704899]], AbsoluteThickness[0.25], 
     LineBox[{11693, 11694}]}, 
    {Hue[
      NCache[
       Rational[3898, 4769], 0.8173621304256657]], AbsoluteThickness[0.25], 
     LineBox[{11694, 11695}]}, 
    {Hue[
      NCache[
       Rational[11695, 14307], 0.8174320262808416]], AbsoluteThickness[0.25], 
     LineBox[{11695, 11696}]}, 
    {Hue[
      NCache[
       Rational[11696, 14307], 0.8175019221360174]], AbsoluteThickness[0.25], 
     LineBox[{11696, 11697}]}, 
    {Hue[
      NCache[
       Rational[3899, 4769], 0.8175718179911932]], AbsoluteThickness[0.25], 
     LineBox[{11697, 11698}]}, 
    {Hue[
      NCache[
       Rational[11698, 14307], 0.8176417138463689]], AbsoluteThickness[0.25], 
     LineBox[{11698, 11699}]}, 
    {Hue[
      NCache[
       Rational[11699, 14307], 0.8177116097015447]], AbsoluteThickness[0.25], 
     LineBox[{11699, 11700}]}, 
    {Hue[
      NCache[
       Rational[3900, 4769], 0.8177815055567205]], AbsoluteThickness[0.25], 
     LineBox[{11700, 11701}]}, 
    {Hue[
      NCache[
       Rational[11701, 14307], 0.8178514014118963]], AbsoluteThickness[0.25], 
     LineBox[{11701, 11702}]}, 
    {Hue[
      NCache[
       Rational[11702, 14307], 0.8179212972670721]], AbsoluteThickness[0.25], 
     LineBox[{11702, 11703}]}, 
    {Hue[
      NCache[
       Rational[3901, 4769], 0.8179911931222479]], AbsoluteThickness[0.25], 
     LineBox[{11703, 11704}]}, 
    {Hue[
      NCache[
       Rational[616, 753], 0.8180610889774237]], AbsoluteThickness[0.25], 
     LineBox[{11704, 11705}]}, 
    {Hue[
      NCache[
       Rational[11705, 14307], 0.8181309848325994]], AbsoluteThickness[0.25], 
     LineBox[{11705, 11706}]}, 
    {Hue[
      NCache[
       Rational[3902, 4769], 0.8182008806877752]], AbsoluteThickness[0.25], 
     LineBox[{11706, 11707}]}, 
    {Hue[
      NCache[
       Rational[11707, 14307], 0.818270776542951]], AbsoluteThickness[0.25], 
     LineBox[{11707, 11708}]}, 
    {Hue[
      NCache[
       Rational[11708, 14307], 0.8183406723981268]], AbsoluteThickness[0.25], 
     LineBox[{11708, 11709}]}, 
    {Hue[
      NCache[
       Rational[3903, 4769], 0.8184105682533026]], AbsoluteThickness[0.25], 
     LineBox[{11709, 11710}]}, 
    {Hue[
      NCache[
       Rational[11710, 14307], 0.8184804641084784]], AbsoluteThickness[0.25], 
     LineBox[{11710, 11711}]}, 
    {Hue[
      NCache[
       Rational[11711, 14307], 0.8185503599636541]], AbsoluteThickness[0.25], 
     LineBox[{11711, 11712}]}, 
    {Hue[
      NCache[
       Rational[3904, 4769], 0.8186202558188299]], AbsoluteThickness[0.25], 
     LineBox[{11712, 11713}]}, 
    {Hue[
      NCache[
       Rational[11713, 14307], 0.8186901516740057]], AbsoluteThickness[0.25], 
     LineBox[{11713, 11714}]}, 
    {Hue[
      NCache[
       Rational[11714, 14307], 0.8187600475291815]], AbsoluteThickness[0.25], 
     LineBox[{11714, 11715}]}, 
    {Hue[
      NCache[
       Rational[3905, 4769], 0.8188299433843573]], AbsoluteThickness[0.25], 
     LineBox[{11715, 11716}]}, 
    {Hue[
      NCache[
       Rational[11716, 14307], 0.8188998392395331]], AbsoluteThickness[0.25], 
     LineBox[{11716, 11717}]}, 
    {Hue[
      NCache[
       Rational[11717, 14307], 0.8189697350947088]], AbsoluteThickness[0.25], 
     LineBox[{11717, 11718}]}, 
    {Hue[
      NCache[
       Rational[3906, 4769], 0.8190396309498846]], AbsoluteThickness[0.25], 
     LineBox[{11718, 11719}]}, 
    {Hue[
      NCache[
       Rational[11719, 14307], 0.8191095268050604]], AbsoluteThickness[0.25], 
     LineBox[{11719, 11720}]}, 
    {Hue[
      NCache[
       Rational[11720, 14307], 0.8191794226602362]], AbsoluteThickness[0.25], 
     LineBox[{11720, 11721}]}, 
    {Hue[
      NCache[
       Rational[3907, 4769], 0.819249318515412]], AbsoluteThickness[0.25], 
     LineBox[{11721, 11722}]}, 
    {Hue[
      NCache[
       Rational[11722, 14307], 0.8193192143705879]], AbsoluteThickness[0.25], 
     LineBox[{11722, 11723}]}, 
    {Hue[
      NCache[
       Rational[617, 753], 0.8193891102257637]], AbsoluteThickness[0.25], 
     LineBox[{11723, 11724}]}, 
    {Hue[
      NCache[
       Rational[3908, 4769], 0.8194590060809394]], AbsoluteThickness[0.25], 
     LineBox[{11724, 11725}]}, 
    {Hue[
      NCache[
       Rational[11725, 14307], 0.8195289019361152]], AbsoluteThickness[0.25], 
     LineBox[{11725, 11726}]}, 
    {Hue[
      NCache[
       Rational[11726, 14307], 0.819598797791291]], AbsoluteThickness[0.25], 
     LineBox[{11726, 11727}]}, 
    {Hue[
      NCache[
       Rational[3909, 4769], 0.8196686936464668]], AbsoluteThickness[0.25], 
     LineBox[{11727, 11728}]}, 
    {Hue[
      NCache[
       Rational[11728, 14307], 0.8197385895016426]], AbsoluteThickness[0.25], 
     LineBox[{11728, 11729}]}, 
    {Hue[
      NCache[
       Rational[11729, 14307], 0.8198084853568184]], AbsoluteThickness[0.25], 
     LineBox[{11729, 11730}]}, 
    {Hue[
      NCache[
       Rational[3910, 4769], 0.8198783812119941]], AbsoluteThickness[0.25], 
     LineBox[{11730, 11731}]}, 
    {Hue[
      NCache[
       Rational[11731, 14307], 0.8199482770671699]], AbsoluteThickness[0.25], 
     LineBox[{11731, 11732}]}, 
    {Hue[
      NCache[
       Rational[11732, 14307], 0.8200181729223457]], AbsoluteThickness[0.25], 
     LineBox[{11732, 11733}]}, 
    {Hue[
      NCache[
       Rational[3911, 4769], 0.8200880687775215]], AbsoluteThickness[0.25], 
     LineBox[{11733, 11734}]}, 
    {Hue[
      NCache[
       Rational[11734, 14307], 0.8201579646326973]], AbsoluteThickness[0.25], 
     LineBox[{11734, 11735}]}, 
    {Hue[
      NCache[
       Rational[11735, 14307], 0.8202278604878731]], AbsoluteThickness[0.25], 
     LineBox[{11735, 11736}]}, 
    {Hue[
      NCache[
       Rational[3912, 4769], 0.8202977563430489]], AbsoluteThickness[0.25], 
     LineBox[{11736, 11737}]}, 
    {Hue[
      NCache[
       Rational[11737, 14307], 0.8203676521982246]], AbsoluteThickness[0.25], 
     LineBox[{11737, 11738}]}, 
    {Hue[
      NCache[
       Rational[11738, 14307], 0.8204375480534004]], AbsoluteThickness[0.25], 
     LineBox[{11738, 11739}]}, 
    {Hue[
      NCache[
       Rational[3913, 4769], 0.8205074439085762]], AbsoluteThickness[0.25], 
     LineBox[{11739, 11740}]}, 
    {Hue[
      NCache[
       Rational[11740, 14307], 0.820577339763752]], AbsoluteThickness[0.25], 
     LineBox[{11740, 11741}]}, 
    {Hue[
      NCache[
       Rational[11741, 14307], 0.8206472356189278]], AbsoluteThickness[0.25], 
     LineBox[{11741, 11742}]}, 
    {Hue[
      NCache[
       Rational[206, 251], 0.8207171314741036]], AbsoluteThickness[0.25], 
     LineBox[{11742, 11743}]}, 
    {Hue[
      NCache[
       Rational[11743, 14307], 0.8207870273292793]], AbsoluteThickness[0.25], 
     LineBox[{11743, 11744}]}, 
    {Hue[
      NCache[
       Rational[11744, 14307], 0.8208569231844551]], AbsoluteThickness[0.25], 
     LineBox[{11744, 11745}]}, 
    {Hue[
      NCache[
       Rational[3915, 4769], 0.8209268190396309]], AbsoluteThickness[0.25], 
     LineBox[{11745, 11746}]}, 
    {Hue[
      NCache[
       Rational[11746, 14307], 0.8209967148948067]], AbsoluteThickness[0.25], 
     LineBox[{11746, 11747}]}, 
    {Hue[
      NCache[
       Rational[11747, 14307], 0.8210666107499826]], AbsoluteThickness[0.25], 
     LineBox[{11747, 11748}]}, 
    {Hue[
      NCache[
       Rational[3916, 4769], 0.8211365066051584]], AbsoluteThickness[0.25], 
     LineBox[{11748, 11749}]}, 
    {Hue[
      NCache[
       Rational[11749, 14307], 0.821206402460334]], AbsoluteThickness[0.25], 
     LineBox[{11749, 11750}]}, 
    {Hue[
      NCache[
       Rational[11750, 14307], 0.8212762983155099]], AbsoluteThickness[0.25], 
     LineBox[{11750, 11751}]}, 
    {Hue[
      NCache[
       Rational[3917, 4769], 0.8213461941706857]], AbsoluteThickness[0.25], 
     LineBox[{11751, 11752}]}, 
    {Hue[
      NCache[
       Rational[11752, 14307], 0.8214160900258615]], AbsoluteThickness[0.25], 
     LineBox[{11752, 11753}]}, 
    {Hue[
      NCache[
       Rational[11753, 14307], 0.8214859858810373]], AbsoluteThickness[0.25], 
     LineBox[{11753, 11754}]}, 
    {Hue[
      NCache[
       Rational[3918, 4769], 0.8215558817362131]], AbsoluteThickness[0.25], 
     LineBox[{11754, 11755}]}, 
    {Hue[
      NCache[
       Rational[11755, 14307], 0.8216257775913889]], AbsoluteThickness[0.25], 
     LineBox[{11755, 11756}]}, 
    {Hue[
      NCache[
       Rational[11756, 14307], 0.8216956734465646]], AbsoluteThickness[0.25], 
     LineBox[{11756, 11757}]}, 
    {Hue[
      NCache[
       Rational[3919, 4769], 0.8217655693017404]], AbsoluteThickness[0.25], 
     LineBox[{11757, 11758}]}, 
    {Hue[
      NCache[
       Rational[11758, 14307], 0.8218354651569162]], AbsoluteThickness[0.25], 
     LineBox[{11758, 11759}]}, 
    {Hue[
      NCache[
       Rational[11759, 14307], 0.821905361012092]], AbsoluteThickness[0.25], 
     LineBox[{11759, 11760}]}, 
    {Hue[
      NCache[
       Rational[3920, 4769], 0.8219752568672678]], AbsoluteThickness[0.25], 
     LineBox[{11760, 11761}]}, 
    {Hue[
      NCache[
       Rational[619, 753], 0.8220451527224436]], AbsoluteThickness[0.25], 
     LineBox[{11761, 11762}]}, 
    {Hue[
      NCache[
       Rational[11762, 14307], 0.8221150485776193]], AbsoluteThickness[0.25], 
     LineBox[{11762, 11763}]}, 
    {Hue[
      NCache[
       Rational[3921, 4769], 0.8221849444327951]], AbsoluteThickness[0.25], 
     LineBox[{11763, 11764}]}, 
    {Hue[
      NCache[
       Rational[11764, 14307], 0.8222548402879709]], AbsoluteThickness[0.25], 
     LineBox[{11764, 11765}]}, 
    {Hue[
      NCache[
       Rational[11765, 14307], 0.8223247361431467]], AbsoluteThickness[0.25], 
     LineBox[{11765, 11766}]}, 
    {Hue[
      NCache[
       Rational[3922, 4769], 0.8223946319983225]], AbsoluteThickness[0.25], 
     LineBox[{11766, 11767}]}, 
    {Hue[
      NCache[
       Rational[11767, 14307], 0.8224645278534983]], AbsoluteThickness[0.25], 
     LineBox[{11767, 11768}]}, 
    {Hue[
      NCache[
       Rational[11768, 14307], 0.822534423708674]], AbsoluteThickness[0.25], 
     LineBox[{11768, 11769}]}, 
    {Hue[
      NCache[
       Rational[3923, 4769], 0.8226043195638498]], AbsoluteThickness[0.25], 
     LineBox[{11769, 11770}]}, 
    {Hue[
      NCache[
       Rational[11770, 14307], 0.8226742154190256]], AbsoluteThickness[0.25], 
     LineBox[{11770, 11771}]}, 
    {Hue[
      NCache[
       Rational[11771, 14307], 0.8227441112742014]], AbsoluteThickness[0.25], 
     LineBox[{11771, 11772}]}, 
    {Hue[
      NCache[
       Rational[3924, 4769], 0.8228140071293772]], AbsoluteThickness[0.25], 
     LineBox[{11772, 11773}]}, 
    {Hue[
      NCache[
       Rational[11773, 14307], 0.822883902984553]], AbsoluteThickness[0.25], 
     LineBox[{11773, 11774}]}, 
    {Hue[
      NCache[
       Rational[11774, 14307], 0.8229537988397289]], AbsoluteThickness[0.25], 
     LineBox[{11774, 11775}]}, 
    {Hue[
      NCache[
       Rational[3925, 4769], 0.8230236946949046]], AbsoluteThickness[0.25], 
     LineBox[{11775, 11776}]}, 
    {Hue[
      NCache[
       Rational[11776, 14307], 0.8230935905500804]], AbsoluteThickness[0.25], 
     LineBox[{11776, 11777}]}, 
    {Hue[
      NCache[
       Rational[11777, 14307], 0.8231634864052562]], AbsoluteThickness[0.25], 
     LineBox[{11777, 11778}]}, 
    {Hue[
      NCache[
       Rational[3926, 4769], 0.823233382260432]], AbsoluteThickness[0.25], 
     LineBox[{11778, 11779}]}, 
    {Hue[
      NCache[
       Rational[11779, 14307], 0.8233032781156078]], AbsoluteThickness[0.25], 
     LineBox[{11779, 11780}]}, 
    {Hue[
      NCache[
       Rational[620, 753], 0.8233731739707836]], AbsoluteThickness[0.25], 
     LineBox[{11780, 11781}]}, 
    {Hue[
      NCache[
       Rational[3927, 4769], 0.8234430698259593]], AbsoluteThickness[0.25], 
     LineBox[{11781, 11782}]}, 
    {Hue[
      NCache[
       Rational[11782, 14307], 0.8235129656811351]], AbsoluteThickness[0.25], 
     LineBox[{11782, 11783}]}, 
    {Hue[
      NCache[
       Rational[11783, 14307], 0.8235828615363109]], AbsoluteThickness[0.25], 
     LineBox[{11783, 11784}]}, 
    {Hue[
      NCache[
       Rational[3928, 4769], 0.8236527573914867]], AbsoluteThickness[0.25], 
     LineBox[{11784, 11785}]}, 
    {Hue[
      NCache[
       Rational[11785, 14307], 0.8237226532466625]], AbsoluteThickness[0.25], 
     LineBox[{11785, 11786}]}, 
    {Hue[
      NCache[
       Rational[11786, 14307], 0.8237925491018383]], AbsoluteThickness[0.25], 
     LineBox[{11786, 11787}]}, 
    {Hue[
      NCache[
       Rational[3929, 4769], 0.823862444957014]], AbsoluteThickness[0.25], 
     LineBox[{11787, 11788}]}, 
    {Hue[
      NCache[
       Rational[11788, 14307], 0.8239323408121898]], AbsoluteThickness[0.25], 
     LineBox[{11788, 11789}]}, 
    {Hue[
      NCache[
       Rational[11789, 14307], 0.8240022366673656]], AbsoluteThickness[0.25], 
     LineBox[{11789, 11790}]}, 
    {Hue[
      NCache[
       Rational[3930, 4769], 0.8240721325225414]], AbsoluteThickness[0.25], 
     LineBox[{11790, 11791}]}, 
    {Hue[
      NCache[
       Rational[11791, 14307], 0.8241420283777172]], AbsoluteThickness[0.25], 
     LineBox[{11791, 11792}]}, 
    {Hue[
      NCache[
       Rational[11792, 14307], 0.824211924232893]], AbsoluteThickness[0.25], 
     LineBox[{11792, 11793}]}, 
    {Hue[
      NCache[
       Rational[3931, 4769], 0.8242818200880688]], AbsoluteThickness[0.25], 
     LineBox[{11793, 11794}]}, 
    {Hue[
      NCache[
       Rational[11794, 14307], 0.8243517159432445]], AbsoluteThickness[0.25], 
     LineBox[{11794, 11795}]}, 
    {Hue[
      NCache[
       Rational[11795, 14307], 0.8244216117984203]], AbsoluteThickness[0.25], 
     LineBox[{11795, 11796}]}, 
    {Hue[
      NCache[
       Rational[3932, 4769], 0.8244915076535961]], AbsoluteThickness[0.25], 
     LineBox[{11796, 11797}]}, 
    {Hue[
      NCache[
       Rational[47, 57], 0.8245614035087719]], AbsoluteThickness[0.25], 
     LineBox[{11797, 11798}]}, 
    {Hue[
      NCache[
       Rational[11798, 14307], 0.8246312993639477]], AbsoluteThickness[0.25], 
     LineBox[{11798, 11799}]}, 
    {Hue[
      NCache[
       Rational[207, 251], 0.8247011952191236]], AbsoluteThickness[0.25], 
     LineBox[{11799, 11800}]}, 
    {Hue[
      NCache[
       Rational[11800, 14307], 0.8247710910742992]], AbsoluteThickness[0.25], 
     LineBox[{11800, 11801}]}, 
    {Hue[
      NCache[
       Rational[11801, 14307], 0.824840986929475]], AbsoluteThickness[0.25], 
     LineBox[{11801, 11802}]}, 
    {Hue[
      NCache[
       Rational[3934, 4769], 0.8249108827846509]], AbsoluteThickness[0.25], 
     LineBox[{11802, 11803}]}, 
    {Hue[
      NCache[
       Rational[11803, 14307], 0.8249807786398267]], AbsoluteThickness[0.25], 
     LineBox[{11803, 11804}]}, 
    {Hue[
      NCache[
       Rational[11804, 14307], 0.8250506744950025]], AbsoluteThickness[0.25], 
     LineBox[{11804, 11805}]}, 
    {Hue[
      NCache[
       Rational[3935, 4769], 0.8251205703501783]], AbsoluteThickness[0.25], 
     LineBox[{11805, 11806}]}, 
    {Hue[
      NCache[
       Rational[11806, 14307], 0.825190466205354]], AbsoluteThickness[0.25], 
     LineBox[{11806, 11807}]}, 
    {Hue[
      NCache[
       Rational[11807, 14307], 0.8252603620605298]], AbsoluteThickness[0.25], 
     LineBox[{11807, 11808}]}, 
    {Hue[
      NCache[
       Rational[3936, 4769], 0.8253302579157056]], AbsoluteThickness[0.25], 
     LineBox[{11808, 11809}]}, 
    {Hue[
      NCache[
       Rational[11809, 14307], 0.8254001537708814]], AbsoluteThickness[0.25], 
     LineBox[{11809, 11810}]}, 
    {Hue[
      NCache[
       Rational[11810, 14307], 0.8254700496260572]], AbsoluteThickness[0.25], 
     LineBox[{11810, 11811}]}, 
    {Hue[
      NCache[
       Rational[3937, 4769], 0.825539945481233]], AbsoluteThickness[0.25], 
     LineBox[{11811, 11812}]}, 
    {Hue[
      NCache[
       Rational[11812, 14307], 0.8256098413364088]], AbsoluteThickness[0.25], 
     LineBox[{11812, 11813}]}, 
    {Hue[
      NCache[
       Rational[11813, 14307], 0.8256797371915845]], AbsoluteThickness[0.25], 
     LineBox[{11813, 11814}]}, 
    {Hue[
      NCache[
       Rational[3938, 4769], 0.8257496330467603]], AbsoluteThickness[0.25], 
     LineBox[{11814, 11815}]}, 
    {Hue[
      NCache[
       Rational[11815, 14307], 0.8258195289019361]], AbsoluteThickness[0.25], 
     LineBox[{11815, 11816}]}, 
    {Hue[
      NCache[
       Rational[11816, 14307], 0.8258894247571119]], AbsoluteThickness[0.25], 
     LineBox[{11816, 11817}]}, 
    {Hue[
      NCache[
       Rational[3939, 4769], 0.8259593206122877]], AbsoluteThickness[0.25], 
     LineBox[{11817, 11818}]}, 
    {Hue[
      NCache[
       Rational[622, 753], 0.8260292164674635]], AbsoluteThickness[0.25], 
     LineBox[{11818, 11819}]}, 
    {Hue[
      NCache[
       Rational[11819, 14307], 0.8260991123226392]], AbsoluteThickness[0.25], 
     LineBox[{11819, 11820}]}, 
    {Hue[
      NCache[
       Rational[3940, 4769], 0.826169008177815]], AbsoluteThickness[0.25], 
     LineBox[{11820, 11821}]}, 
    {Hue[
      NCache[
       Rational[11821, 14307], 0.8262389040329908]], AbsoluteThickness[0.25], 
     LineBox[{11821, 11822}]}, 
    {Hue[
      NCache[
       Rational[11822, 14307], 0.8263087998881666]], AbsoluteThickness[0.25], 
     LineBox[{11822, 11823}]}, 
    {Hue[
      NCache[
       Rational[3941, 4769], 0.8263786957433424]], AbsoluteThickness[0.25], 
     LineBox[{11823, 11824}]}, 
    {Hue[
      NCache[
       Rational[11824, 14307], 0.8264485915985182]], AbsoluteThickness[0.25], 
     LineBox[{11824, 11825}]}, 
    {Hue[
      NCache[
       Rational[11825, 14307], 0.826518487453694]], AbsoluteThickness[0.25], 
     LineBox[{11825, 11826}]}, 
    {Hue[
      NCache[
       Rational[3942, 4769], 0.8265883833088697]], AbsoluteThickness[0.25], 
     LineBox[{11826, 11827}]}, 
    {Hue[
      NCache[
       Rational[11827, 14307], 0.8266582791640456]], AbsoluteThickness[0.25], 
     LineBox[{11827, 11828}]}, 
    {Hue[
      NCache[
       Rational[11828, 14307], 0.8267281750192214]], AbsoluteThickness[0.25], 
     LineBox[{11828, 11829}]}, 
    {Hue[
      NCache[
       Rational[3943, 4769], 0.8267980708743972]], AbsoluteThickness[0.25], 
     LineBox[{11829, 11830}]}, 
    {Hue[
      NCache[
       Rational[11830, 14307], 0.826867966729573]], AbsoluteThickness[0.25], 
     LineBox[{11830, 11831}]}, 
    {Hue[
      NCache[
       Rational[11831, 14307], 0.8269378625847488]], AbsoluteThickness[0.25], 
     LineBox[{11831, 11832}]}, 
    {Hue[
      NCache[
       Rational[3944, 4769], 0.8270077584399245]], AbsoluteThickness[0.25], 
     LineBox[{11832, 11833}]}, 
    {Hue[
      NCache[
       Rational[11833, 14307], 0.8270776542951003]], AbsoluteThickness[0.25], 
     LineBox[{11833, 11834}]}, 
    {Hue[
      NCache[
       Rational[11834, 14307], 0.8271475501502761]], AbsoluteThickness[0.25], 
     LineBox[{11834, 11835}]}, 
    {Hue[
      NCache[
       Rational[3945, 4769], 0.8272174460054519]], AbsoluteThickness[0.25], 
     LineBox[{11835, 11836}]}, 
    {Hue[
      NCache[
       Rational[11836, 14307], 0.8272873418606277]], AbsoluteThickness[0.25], 
     LineBox[{11836, 11837}]}, 
    {Hue[
      NCache[
       Rational[623, 753], 0.8273572377158035]], AbsoluteThickness[0.25], 
     LineBox[{11837, 11838}]}, 
    {Hue[
      NCache[
       Rational[3946, 4769], 0.8274271335709792]], AbsoluteThickness[0.25], 
     LineBox[{11838, 11839}]}, 
    {Hue[
      NCache[
       Rational[11839, 14307], 0.827497029426155]], AbsoluteThickness[0.25], 
     LineBox[{11839, 11840}]}, 
    {Hue[
      NCache[
       Rational[11840, 14307], 0.8275669252813308]], AbsoluteThickness[0.25], 
     LineBox[{11840, 11841}]}, 
    {Hue[
      NCache[
       Rational[3947, 4769], 0.8276368211365066]], AbsoluteThickness[0.25], 
     LineBox[{11841, 11842}]}, 
    {Hue[
      NCache[
       Rational[11842, 14307], 0.8277067169916824]], AbsoluteThickness[0.25], 
     LineBox[{11842, 11843}]}, 
    {Hue[
      NCache[
       Rational[11843, 14307], 0.8277766128468582]], AbsoluteThickness[0.25], 
     LineBox[{11843, 11844}]}, 
    {Hue[
      NCache[
       Rational[3948, 4769], 0.827846508702034]], AbsoluteThickness[0.25], 
     LineBox[{11844, 11845}]}, 
    {Hue[
      NCache[
       Rational[11845, 14307], 0.8279164045572097]], AbsoluteThickness[0.25], 
     LineBox[{11845, 11846}]}, 
    {Hue[
      NCache[
       Rational[11846, 14307], 0.8279863004123855]], AbsoluteThickness[0.25], 
     LineBox[{11846, 11847}]}, 
    {Hue[
      NCache[
       Rational[3949, 4769], 0.8280561962675613]], AbsoluteThickness[0.25], 
     LineBox[{11847, 11848}]}, 
    {Hue[
      NCache[
       Rational[11848, 14307], 0.8281260921227371]], AbsoluteThickness[0.25], 
     LineBox[{11848, 11849}]}, 
    {Hue[
      NCache[
       Rational[11849, 14307], 0.8281959879779129]], AbsoluteThickness[0.25], 
     LineBox[{11849, 11850}]}, 
    {Hue[
      NCache[
       Rational[3950, 4769], 0.8282658838330887]], AbsoluteThickness[0.25], 
     LineBox[{11850, 11851}]}, 
    {Hue[
      NCache[
       Rational[11851, 14307], 0.8283357796882644]], AbsoluteThickness[0.25], 
     LineBox[{11851, 11852}]}, 
    {Hue[
      NCache[
       Rational[11852, 14307], 0.8284056755434402]], AbsoluteThickness[0.25], 
     LineBox[{11852, 11853}]}, 
    {Hue[
      NCache[
       Rational[3951, 4769], 0.828475571398616]], AbsoluteThickness[0.25], 
     LineBox[{11853, 11854}]}, 
    {Hue[
      NCache[
       Rational[11854, 14307], 0.8285454672537919]], AbsoluteThickness[0.25], 
     LineBox[{11854, 11855}]}, 
    {Hue[
      NCache[
       Rational[11855, 14307], 0.8286153631089677]], AbsoluteThickness[0.25], 
     LineBox[{11855, 11856}]}, 
    {Hue[
      NCache[
       Rational[208, 251], 0.8286852589641435]], AbsoluteThickness[0.25], 
     LineBox[{11856, 11857}]}, 
    {Hue[
      NCache[
       Rational[11857, 14307], 0.8287551548193192]], AbsoluteThickness[0.25], 
     LineBox[{11857, 11858}]}, 
    {Hue[
      NCache[
       Rational[11858, 14307], 0.828825050674495]], AbsoluteThickness[0.25], 
     LineBox[{11858, 11859}]}, 
    {Hue[
      NCache[
       Rational[3953, 4769], 0.8288949465296708]], AbsoluteThickness[0.25], 
     LineBox[{11859, 11860}]}, 
    {Hue[
      NCache[
       Rational[11860, 14307], 0.8289648423848466]], AbsoluteThickness[0.25], 
     LineBox[{11860, 11861}]}, 
    {Hue[
      NCache[
       Rational[11861, 14307], 0.8290347382400224]], AbsoluteThickness[0.25], 
     LineBox[{11861, 11862}]}, 
    {Hue[
      NCache[
       Rational[3954, 4769], 0.8291046340951982]], AbsoluteThickness[0.25], 
     LineBox[{11862, 11863}]}, 
    {Hue[
      NCache[
       Rational[11863, 14307], 0.829174529950374]], AbsoluteThickness[0.25], 
     LineBox[{11863, 11864}]}, 
    {Hue[
      NCache[
       Rational[11864, 14307], 0.8292444258055497]], AbsoluteThickness[0.25], 
     LineBox[{11864, 11865}]}, 
    {Hue[
      NCache[
       Rational[3955, 4769], 0.8293143216607255]], AbsoluteThickness[0.25], 
     LineBox[{11865, 11866}]}, 
    {Hue[
      NCache[
       Rational[11866, 14307], 0.8293842175159013]], AbsoluteThickness[0.25], 
     LineBox[{11866, 11867}]}, 
    {Hue[
      NCache[
       Rational[11867, 14307], 0.8294541133710771]], AbsoluteThickness[0.25], 
     LineBox[{11867, 11868}]}, 
    {Hue[
      NCache[
       Rational[3956, 4769], 0.8295240092262529]], AbsoluteThickness[0.25], 
     LineBox[{11868, 11869}]}, 
    {Hue[
      NCache[
       Rational[11869, 14307], 0.8295939050814287]], AbsoluteThickness[0.25], 
     LineBox[{11869, 11870}]}, 
    {Hue[
      NCache[
       Rational[11870, 14307], 0.8296638009366044]], AbsoluteThickness[0.25], 
     LineBox[{11870, 11871}]}, 
    {Hue[
      NCache[
       Rational[3957, 4769], 0.8297336967917802]], AbsoluteThickness[0.25], 
     LineBox[{11871, 11872}]}, 
    {Hue[
      NCache[
       Rational[11872, 14307], 0.829803592646956]], AbsoluteThickness[0.25], 
     LineBox[{11872, 11873}]}, 
    {Hue[
      NCache[
       Rational[11873, 14307], 0.8298734885021318]], AbsoluteThickness[0.25], 
     LineBox[{11873, 11874}]}, 
    {Hue[
      NCache[
       Rational[3958, 4769], 0.8299433843573076]], AbsoluteThickness[0.25], 
     LineBox[{11874, 11875}]}, 
    {Hue[
      NCache[
       Rational[625, 753], 0.8300132802124834]], AbsoluteThickness[0.25], 
     LineBox[{11875, 11876}]}, 
    {Hue[
      NCache[
       Rational[11876, 14307], 0.8300831760676591]], AbsoluteThickness[0.25], 
     LineBox[{11876, 11877}]}, 
    {Hue[
      NCache[
       Rational[3959, 4769], 0.8301530719228349]], AbsoluteThickness[0.25], 
     LineBox[{11877, 11878}]}, 
    {Hue[
      NCache[
       Rational[11878, 14307], 0.8302229677780107]], AbsoluteThickness[0.25], 
     LineBox[{11878, 11879}]}, 
    {Hue[
      NCache[
       Rational[11879, 14307], 0.8302928636331866]], AbsoluteThickness[0.25], 
     LineBox[{11879, 11880}]}, 
    {Hue[
      NCache[
       Rational[3960, 4769], 0.8303627594883624]], AbsoluteThickness[0.25], 
     LineBox[{11880, 11881}]}, 
    {Hue[
      NCache[
       Rational[11881, 14307], 0.8304326553435382]], AbsoluteThickness[0.25], 
     LineBox[{11881, 11882}]}, 
    {Hue[
      NCache[
       Rational[11882, 14307], 0.830502551198714]], AbsoluteThickness[0.25], 
     LineBox[{11882, 11883}]}, 
    {Hue[
      NCache[
       Rational[3961, 4769], 0.8305724470538897]], AbsoluteThickness[0.25], 
     LineBox[{11883, 11884}]}, 
    {Hue[
      NCache[
       Rational[11884, 14307], 0.8306423429090655]], AbsoluteThickness[0.25], 
     LineBox[{11884, 11885}]}, 
    {Hue[
      NCache[
       Rational[11885, 14307], 0.8307122387642413]], AbsoluteThickness[0.25], 
     LineBox[{11885, 11886}]}, 
    {Hue[
      NCache[
       Rational[3962, 4769], 0.8307821346194171]], AbsoluteThickness[0.25], 
     LineBox[{11886, 11887}]}, 
    {Hue[
      NCache[
       Rational[11887, 14307], 0.8308520304745929]], AbsoluteThickness[0.25], 
     LineBox[{11887, 11888}]}, 
    {Hue[
      NCache[
       Rational[11888, 14307], 0.8309219263297687]], AbsoluteThickness[0.25], 
     LineBox[{11888, 11889}]}, 
    {Hue[
      NCache[
       Rational[3963, 4769], 0.8309918221849444]], AbsoluteThickness[0.25], 
     LineBox[{11889, 11890}]}, 
    {Hue[
      NCache[
       Rational[11890, 14307], 0.8310617180401202]], AbsoluteThickness[0.25], 
     LineBox[{11890, 11891}]}, 
    {Hue[
      NCache[
       Rational[11891, 14307], 0.831131613895296]], AbsoluteThickness[0.25], 
     LineBox[{11891, 11892}]}, 
    {Hue[
      NCache[
       Rational[3964, 4769], 0.8312015097504718]], AbsoluteThickness[0.25], 
     LineBox[{11892, 11893}]}, 
    {Hue[
      NCache[
       Rational[11893, 14307], 0.8312714056056476]], AbsoluteThickness[0.25], 
     LineBox[{11893, 11894}]}, 
    {Hue[
      NCache[
       Rational[626, 753], 0.8313413014608234]], AbsoluteThickness[0.25], 
     LineBox[{11894, 11895}]}, 
    {Hue[
      NCache[
       Rational[3965, 4769], 0.8314111973159991]], AbsoluteThickness[0.25], 
     LineBox[{11895, 11896}]}, 
    {Hue[
      NCache[
       Rational[11896, 14307], 0.8314810931711749]], AbsoluteThickness[0.25], 
     LineBox[{11896, 11897}]}, 
    {Hue[
      NCache[
       Rational[11897, 14307], 0.8315509890263507]], AbsoluteThickness[0.25], 
     LineBox[{11897, 11898}]}, 
    {Hue[
      NCache[
       Rational[3966, 4769], 0.8316208848815265]], AbsoluteThickness[0.25], 
     LineBox[{11898, 11899}]}, 
    {Hue[
      NCache[
       Rational[11899, 14307], 0.8316907807367023]], AbsoluteThickness[0.25], 
     LineBox[{11899, 11900}]}, 
    {Hue[
      NCache[
       Rational[11900, 14307], 0.8317606765918781]], AbsoluteThickness[0.25], 
     LineBox[{11900, 11901}]}, 
    {Hue[
      NCache[
       Rational[3967, 4769], 0.8318305724470539]], AbsoluteThickness[0.25], 
     LineBox[{11901, 11902}]}, 
    {Hue[
      NCache[
       Rational[11902, 14307], 0.8319004683022296]], AbsoluteThickness[0.25], 
     LineBox[{11902, 11903}]}, 
    {Hue[
      NCache[
       Rational[11903, 14307], 0.8319703641574054]], AbsoluteThickness[0.25], 
     LineBox[{11903, 11904}]}, 
    {Hue[
      NCache[
       Rational[3968, 4769], 0.8320402600125812]], AbsoluteThickness[0.25], 
     LineBox[{11904, 11905}]}, 
    {Hue[
      NCache[
       Rational[11905, 14307], 0.832110155867757]], AbsoluteThickness[0.25], 
     LineBox[{11905, 11906}]}, 
    {Hue[
      NCache[
       Rational[11906, 14307], 0.8321800517229329]], AbsoluteThickness[0.25], 
     LineBox[{11906, 11907}]}, 
    {Hue[
      NCache[
       Rational[3969, 4769], 0.8322499475781087]], AbsoluteThickness[0.25], 
     LineBox[{11907, 11908}]}, 
    {Hue[
      NCache[
       Rational[11908, 14307], 0.8323198434332844]], AbsoluteThickness[0.25], 
     LineBox[{11908, 11909}]}, 
    {Hue[
      NCache[
       Rational[11909, 14307], 0.8323897392884602]], AbsoluteThickness[0.25], 
     LineBox[{11909, 11910}]}, 
    {Hue[
      NCache[
       Rational[3970, 4769], 0.832459635143636]], AbsoluteThickness[0.25], 
     LineBox[{11910, 11911}]}, 
    {Hue[
      NCache[
       Rational[11911, 14307], 0.8325295309988118]], AbsoluteThickness[0.25], 
     LineBox[{11911, 11912}]}, 
    {Hue[
      NCache[
       Rational[11912, 14307], 0.8325994268539876]], AbsoluteThickness[0.25], 
     LineBox[{11912, 11913}]}, 
    {Hue[
      NCache[
       Rational[209, 251], 0.8326693227091634]], AbsoluteThickness[0.25], 
     LineBox[{11913, 11914}]}, 
    {Hue[
      NCache[
       Rational[11914, 14307], 0.8327392185643392]], AbsoluteThickness[0.25], 
     LineBox[{11914, 11915}]}, 
    {Hue[
      NCache[
       Rational[11915, 14307], 0.8328091144195149]], AbsoluteThickness[0.25], 
     LineBox[{11915, 11916}]}, 
    {Hue[
      NCache[
       Rational[3972, 4769], 0.8328790102746907]], AbsoluteThickness[0.25], 
     LineBox[{11916, 11917}]}, 
    {Hue[
      NCache[
       Rational[11917, 14307], 0.8329489061298665]], AbsoluteThickness[0.25], 
     LineBox[{11917, 11918}]}, 
    {Hue[
      NCache[
       Rational[11918, 14307], 0.8330188019850423]], AbsoluteThickness[0.25], 
     LineBox[{11918, 11919}]}, 
    {Hue[
      NCache[
       Rational[3973, 4769], 0.8330886978402181]], AbsoluteThickness[0.25], 
     LineBox[{11919, 11920}]}, 
    {Hue[
      NCache[
       Rational[11920, 14307], 0.8331585936953939]], AbsoluteThickness[0.25], 
     LineBox[{11920, 11921}]}, 
    {Hue[
      NCache[
       Rational[11921, 14307], 0.8332284895505696]], AbsoluteThickness[0.25], 
     LineBox[{11921, 11922}]}, 
    {Hue[
      NCache[
       Rational[3974, 4769], 0.8332983854057454]], AbsoluteThickness[0.25], 
     LineBox[{11922, 11923}]}, 
    {Hue[
      NCache[
       Rational[11923, 14307], 0.8333682812609212]], AbsoluteThickness[0.25], 
     LineBox[{11923, 11924}]}, 
    {Hue[
      NCache[
       Rational[11924, 14307], 0.833438177116097]], AbsoluteThickness[0.25], 
     LineBox[{11924, 11925}]}, 
    {Hue[
      NCache[
       Rational[3975, 4769], 0.8335080729712728]], AbsoluteThickness[0.25], 
     LineBox[{11925, 11926}]}, 
    {Hue[
      NCache[
       Rational[11926, 14307], 0.8335779688264486]], AbsoluteThickness[0.25], 
     LineBox[{11926, 11927}]}, 
    {Hue[
      NCache[
       Rational[11927, 14307], 0.8336478646816243]], AbsoluteThickness[0.25], 
     LineBox[{11927, 11928}]}, 
    {Hue[
      NCache[
       Rational[3976, 4769], 0.8337177605368001]], AbsoluteThickness[0.25], 
     LineBox[{11928, 11929}]}, 
    {Hue[
      NCache[
       Rational[11929, 14307], 0.8337876563919759]], AbsoluteThickness[0.25], 
     LineBox[{11929, 11930}]}, 
    {Hue[
      NCache[
       Rational[11930, 14307], 0.8338575522471517]], AbsoluteThickness[0.25], 
     LineBox[{11930, 11931}]}, 
    {Hue[
      NCache[
       Rational[3977, 4769], 0.8339274481023276]], AbsoluteThickness[0.25], 
     LineBox[{11931, 11932}]}, 
    {Hue[
      NCache[
       Rational[628, 753], 0.8339973439575034]], AbsoluteThickness[0.25], 
     LineBox[{11932, 11933}]}, 
    {Hue[
      NCache[
       Rational[11933, 14307], 0.8340672398126792]], AbsoluteThickness[0.25], 
     LineBox[{11933, 11934}]}, 
    {Hue[
      NCache[
       Rational[3978, 4769], 0.8341371356678549]], AbsoluteThickness[0.25], 
     LineBox[{11934, 11935}]}, 
    {Hue[
      NCache[
       Rational[11935, 14307], 0.8342070315230307]], AbsoluteThickness[0.25], 
     LineBox[{11935, 11936}]}, 
    {Hue[
      NCache[
       Rational[11936, 14307], 0.8342769273782065]], AbsoluteThickness[0.25], 
     LineBox[{11936, 11937}]}, 
    {Hue[
      NCache[
       Rational[3979, 4769], 0.8343468232333823]], AbsoluteThickness[0.25], 
     LineBox[{11937, 11938}]}, 
    {Hue[
      NCache[
       Rational[11938, 14307], 0.8344167190885581]], AbsoluteThickness[0.25], 
     LineBox[{11938, 11939}]}, 
    {Hue[
      NCache[
       Rational[11939, 14307], 0.8344866149437339]], AbsoluteThickness[0.25], 
     LineBox[{11939, 11940}]}, 
    {Hue[
      NCache[
       Rational[3980, 4769], 0.8345565107989096]], AbsoluteThickness[0.25], 
     LineBox[{11940, 11941}]}, 
    {Hue[
      NCache[
       Rational[11941, 14307], 0.8346264066540854]], AbsoluteThickness[0.25], 
     LineBox[{11941, 11942}]}, 
    {Hue[
      NCache[
       Rational[11942, 14307], 0.8346963025092612]], AbsoluteThickness[0.25], 
     LineBox[{11942, 11943}]}, 
    {Hue[
      NCache[
       Rational[3981, 4769], 0.834766198364437]], AbsoluteThickness[0.25], 
     LineBox[{11943, 11944}]}, 
    {Hue[
      NCache[
       Rational[11944, 14307], 0.8348360942196128]], AbsoluteThickness[0.25], 
     LineBox[{11944, 11945}]}, 
    {Hue[
      NCache[
       Rational[11945, 14307], 0.8349059900747886]], AbsoluteThickness[0.25], 
     LineBox[{11945, 11946}]}, 
    {Hue[
      NCache[
       Rational[3982, 4769], 0.8349758859299643]], AbsoluteThickness[0.25], 
     LineBox[{11946, 11947}]}, 
    {Hue[
      NCache[
       Rational[11947, 14307], 0.8350457817851401]], AbsoluteThickness[0.25], 
     LineBox[{11947, 11948}]}, 
    {Hue[
      NCache[
       Rational[11948, 14307], 0.8351156776403159]], AbsoluteThickness[0.25], 
     LineBox[{11948, 11949}]}, 
    {Hue[
      NCache[
       Rational[3983, 4769], 0.8351855734954917]], AbsoluteThickness[0.25], 
     LineBox[{11949, 11950}]}, 
    {Hue[
      NCache[
       Rational[11950, 14307], 0.8352554693506675]], AbsoluteThickness[0.25], 
     LineBox[{11950, 11951}]}, 
    {Hue[
      NCache[
       Rational[629, 753], 0.8353253652058433]], AbsoluteThickness[0.25], 
     LineBox[{11951, 11952}]}, 
    {Hue[
      NCache[
       Rational[3984, 4769], 0.8353952610610191]], AbsoluteThickness[0.25], 
     LineBox[{11952, 11953}]}, 
    {Hue[
      NCache[
       Rational[11953, 14307], 0.8354651569161948]], AbsoluteThickness[0.25], 
     LineBox[{11953, 11954}]}, 
    {Hue[
      NCache[
       Rational[11954, 14307], 0.8355350527713706]], AbsoluteThickness[0.25], 
     LineBox[{11954, 11955}]}, 
    {Hue[
      NCache[
       Rational[3985, 4769], 0.8356049486265464]], AbsoluteThickness[0.25], 
     LineBox[{11955, 11956}]}, 
    {Hue[
      NCache[
       Rational[11956, 14307], 0.8356748444817222]], AbsoluteThickness[0.25], 
     LineBox[{11956, 11957}]}, 
    {Hue[
      NCache[
       Rational[11957, 14307], 0.835744740336898]], AbsoluteThickness[0.25], 
     LineBox[{11957, 11958}]}, 
    {Hue[
      NCache[
       Rational[3986, 4769], 0.8358146361920739]], AbsoluteThickness[0.25], 
     LineBox[{11958, 11959}]}, 
    {Hue[
      NCache[
       Rational[11959, 14307], 0.8358845320472496]], AbsoluteThickness[0.25], 
     LineBox[{11959, 11960}]}, 
    {Hue[
      NCache[
       Rational[11960, 14307], 0.8359544279024254]], AbsoluteThickness[0.25], 
     LineBox[{11960, 11961}]}, 
    {Hue[
      NCache[
       Rational[3987, 4769], 0.8360243237576012]], AbsoluteThickness[0.25], 
     LineBox[{11961, 11962}]}, 
    {Hue[
      NCache[
       Rational[11962, 14307], 0.836094219612777]], AbsoluteThickness[0.25], 
     LineBox[{11962, 11963}]}, 
    {Hue[
      NCache[
       Rational[11963, 14307], 0.8361641154679528]], AbsoluteThickness[0.25], 
     LineBox[{11963, 11964}]}, 
    {Hue[
      NCache[
       Rational[3988, 4769], 0.8362340113231286]], AbsoluteThickness[0.25], 
     LineBox[{11964, 11965}]}, 
    {Hue[
      NCache[
       Rational[11965, 14307], 0.8363039071783043]], AbsoluteThickness[0.25], 
     LineBox[{11965, 11966}]}, 
    {Hue[
      NCache[
       Rational[11966, 14307], 0.8363738030334801]], AbsoluteThickness[0.25], 
     LineBox[{11966, 11967}]}, 
    {Hue[
      NCache[
       Rational[3989, 4769], 0.8364436988886559]], AbsoluteThickness[0.25], 
     LineBox[{11967, 11968}]}, 
    {Hue[
      NCache[
       Rational[11968, 14307], 0.8365135947438317]], AbsoluteThickness[0.25], 
     LineBox[{11968, 11969}]}, 
    {Hue[
      NCache[
       Rational[11969, 14307], 0.8365834905990075]], AbsoluteThickness[0.25], 
     LineBox[{11969, 11970}]}, 
    {Hue[
      NCache[
       Rational[210, 251], 0.8366533864541833]], AbsoluteThickness[0.25], 
     LineBox[{11970, 11971}]}, 
    {Hue[
      NCache[
       Rational[11971, 14307], 0.8367232823093591]], AbsoluteThickness[0.25], 
     LineBox[{11971, 11972}]}, 
    {Hue[
      NCache[
       Rational[11972, 14307], 0.8367931781645348]], AbsoluteThickness[0.25], 
     LineBox[{11972, 11973}]}, 
    {Hue[
      NCache[
       Rational[3991, 4769], 0.8368630740197106]], AbsoluteThickness[0.25], 
     LineBox[{11973, 11974}]}, 
    {Hue[
      NCache[
       Rational[11974, 14307], 0.8369329698748864]], AbsoluteThickness[0.25], 
     LineBox[{11974, 11975}]}, 
    {Hue[
      NCache[
       Rational[11975, 14307], 0.8370028657300622]], AbsoluteThickness[0.25], 
     LineBox[{11975, 11976}]}, 
    {Hue[
      NCache[
       Rational[3992, 4769], 0.837072761585238]], AbsoluteThickness[0.25], 
     LineBox[{11976, 11977}]}, 
    {Hue[
      NCache[
       Rational[11977, 14307], 0.8371426574404138]], AbsoluteThickness[0.25], 
     LineBox[{11977, 11978}]}, 
    {Hue[
      NCache[
       Rational[11978, 14307], 0.8372125532955895]], AbsoluteThickness[0.25], 
     LineBox[{11978, 11979}]}, 
    {Hue[
      NCache[
       Rational[3993, 4769], 0.8372824491507653]], AbsoluteThickness[0.25], 
     LineBox[{11979, 11980}]}, 
    {Hue[
      NCache[
       Rational[11980, 14307], 0.8373523450059411]], AbsoluteThickness[0.25], 
     LineBox[{11980, 11981}]}, 
    {Hue[
      NCache[
       Rational[11981, 14307], 0.8374222408611169]], AbsoluteThickness[0.25], 
     LineBox[{11981, 11982}]}, 
    {Hue[
      NCache[
       Rational[3994, 4769], 0.8374921367162927]], AbsoluteThickness[0.25], 
     LineBox[{11982, 11983}]}, 
    {Hue[
      NCache[
       Rational[11983, 14307], 0.8375620325714686]], AbsoluteThickness[0.25], 
     LineBox[{11983, 11984}]}, 
    {Hue[
      NCache[
       Rational[11984, 14307], 0.8376319284266442]], AbsoluteThickness[0.25], 
     LineBox[{11984, 11985}]}, 
    {Hue[
      NCache[
       Rational[3995, 4769], 0.83770182428182]], AbsoluteThickness[0.25], 
     LineBox[{11985, 11986}]}, 
    {Hue[
      NCache[
       Rational[11986, 14307], 0.8377717201369959]], AbsoluteThickness[0.25], 
     LineBox[{11986, 11987}]}, 
    {Hue[
      NCache[
       Rational[11987, 14307], 0.8378416159921717]], AbsoluteThickness[0.25], 
     LineBox[{11987, 11988}]}, 
    {Hue[
      NCache[
       Rational[3996, 4769], 0.8379115118473475]], AbsoluteThickness[0.25], 
     LineBox[{11988, 11989}]}, 
    {Hue[
      NCache[
       Rational[631, 753], 0.8379814077025233]], AbsoluteThickness[0.25], 
     LineBox[{11989, 11990}]}, 
    {Hue[
      NCache[
       Rational[11990, 14307], 0.8380513035576991]], AbsoluteThickness[0.25], 
     LineBox[{11990, 11991}]}, 
    {Hue[
      NCache[
       Rational[3997, 4769], 0.8381211994128748]], AbsoluteThickness[0.25], 
     LineBox[{11991, 11992}]}, 
    {Hue[
      NCache[
       Rational[11992, 14307], 0.8381910952680506]], AbsoluteThickness[0.25], 
     LineBox[{11992, 11993}]}, 
    {Hue[
      NCache[
       Rational[11993, 14307], 0.8382609911232264]], AbsoluteThickness[0.25], 
     LineBox[{11993, 11994}]}, 
    {Hue[
      NCache[
       Rational[3998, 4769], 0.8383308869784022]], AbsoluteThickness[0.25], 
     LineBox[{11994, 11995}]}, 
    {Hue[
      NCache[
       Rational[11995, 14307], 0.838400782833578]], AbsoluteThickness[0.25], 
     LineBox[{11995, 11996}]}, 
    {Hue[
      NCache[
       Rational[11996, 14307], 0.8384706786887538]], AbsoluteThickness[0.25], 
     LineBox[{11996, 11997}]}, 
    {Hue[
      NCache[
       Rational[3999, 4769], 0.8385405745439295]], AbsoluteThickness[0.25], 
     LineBox[{11997, 11998}]}, 
    {Hue[
      NCache[
       Rational[11998, 14307], 0.8386104703991053]], AbsoluteThickness[0.25], 
     LineBox[{11998, 11999}]}, 
    {Hue[
      NCache[
       Rational[11999, 14307], 0.8386803662542811]], AbsoluteThickness[0.25], 
     LineBox[{11999, 12000}]}, 
    {Hue[
      NCache[
       Rational[4000, 4769], 0.8387502621094569]], AbsoluteThickness[0.25], 
     LineBox[{12000, 12001}]}, 
    {Hue[
      NCache[
       Rational[12001, 14307], 0.8388201579646327]], AbsoluteThickness[0.25], 
     LineBox[{12001, 12002}]}, 
    {Hue[
      NCache[
       Rational[12002, 14307], 0.8388900538198085]], AbsoluteThickness[0.25], 
     LineBox[{12002, 12003}]}, 
    {Hue[
      NCache[
       Rational[4001, 4769], 0.8389599496749843]], AbsoluteThickness[0.25], 
     LineBox[{12003, 12004}]}, 
    {Hue[
      NCache[
       Rational[12004, 14307], 0.83902984553016]], AbsoluteThickness[0.25], 
     LineBox[{12004, 12005}]}, 
    {Hue[
      NCache[
       Rational[12005, 14307], 0.8390997413853358]], AbsoluteThickness[0.25], 
     LineBox[{12005, 12006}]}, 
    {Hue[
      NCache[
       Rational[4002, 4769], 0.8391696372405116]], AbsoluteThickness[0.25], 
     LineBox[{12006, 12007}]}, 
    {Hue[
      NCache[
       Rational[12007, 14307], 0.8392395330956874]], AbsoluteThickness[0.25], 
     LineBox[{12007, 12008}]}, 
    {Hue[
      NCache[
       Rational[632, 753], 0.8393094289508632]], AbsoluteThickness[0.25], 
     LineBox[{12008, 12009}]}, 
    {Hue[
      NCache[
       Rational[4003, 4769], 0.839379324806039]], AbsoluteThickness[0.25], 
     LineBox[{12009, 12010}]}, 
    {Hue[
      NCache[
       Rational[12010, 14307], 0.8394492206612147]], AbsoluteThickness[0.25], 
     LineBox[{12010, 12011}]}, 
    {Hue[
      NCache[
       Rational[12011, 14307], 0.8395191165163906]], AbsoluteThickness[0.25], 
     LineBox[{12011, 12012}]}, 
    {Hue[
      NCache[
       Rational[4004, 4769], 0.8395890123715664]], AbsoluteThickness[0.25], 
     LineBox[{12012, 12013}]}, 
    {Hue[
      NCache[
       Rational[12013, 14307], 0.8396589082267422]], AbsoluteThickness[0.25], 
     LineBox[{12013, 12014}]}, 
    {Hue[
      NCache[
       Rational[12014, 14307], 0.839728804081918]], AbsoluteThickness[0.25], 
     LineBox[{12014, 12015}]}, 
    {Hue[
      NCache[
       Rational[4005, 4769], 0.8397986999370938]], AbsoluteThickness[0.25], 
     LineBox[{12015, 12016}]}, 
    {Hue[
      NCache[
       Rational[12016, 14307], 0.8398685957922695]], AbsoluteThickness[0.25], 
     LineBox[{12016, 12017}]}, 
    {Hue[
      NCache[
       Rational[12017, 14307], 0.8399384916474453]], AbsoluteThickness[0.25], 
     LineBox[{12017, 12018}]}, 
    {Hue[
      NCache[
       Rational[4006, 4769], 0.8400083875026211]], AbsoluteThickness[0.25], 
     LineBox[{12018, 12019}]}, 
    {Hue[
      NCache[
       Rational[12019, 14307], 0.8400782833577969]], AbsoluteThickness[0.25], 
     LineBox[{12019, 12020}]}, 
    {Hue[
      NCache[
       Rational[12020, 14307], 0.8401481792129727]], AbsoluteThickness[0.25], 
     LineBox[{12020, 12021}]}, 
    {Hue[
      NCache[
       Rational[4007, 4769], 0.8402180750681485]], AbsoluteThickness[0.25], 
     LineBox[{12021, 12022}]}, 
    {Hue[
      NCache[
       Rational[12022, 14307], 0.8402879709233243]], AbsoluteThickness[0.25], 
     LineBox[{12022, 12023}]}, 
    {Hue[
      NCache[
       Rational[12023, 14307], 0.8403578667785]], AbsoluteThickness[0.25], 
     LineBox[{12023, 12024}]}, 
    {Hue[
      NCache[
       Rational[4008, 4769], 0.8404277626336758]], AbsoluteThickness[0.25], 
     LineBox[{12024, 12025}]}, 
    {Hue[
      NCache[
       Rational[12025, 14307], 0.8404976584888516]], AbsoluteThickness[0.25], 
     LineBox[{12025, 12026}]}, 
    {Hue[
      NCache[
       Rational[12026, 14307], 0.8405675543440274]], AbsoluteThickness[0.25], 
     LineBox[{12026, 12027}]}, 
    {Hue[
      NCache[
       Rational[211, 251], 0.8406374501992032]], AbsoluteThickness[0.25], 
     LineBox[{12027, 12028}]}, 
    {Hue[
      NCache[
       Rational[12028, 14307], 0.840707346054379]], AbsoluteThickness[0.25], 
     LineBox[{12028, 12029}]}, 
    {Hue[
      NCache[
       Rational[12029, 14307], 0.8407772419095547]], AbsoluteThickness[0.25], 
     LineBox[{12029, 12030}]}, 
    {Hue[
      NCache[
       Rational[4010, 4769], 0.8408471377647305]], AbsoluteThickness[0.25], 
     LineBox[{12030, 12031}]}, 
    {Hue[
      NCache[
       Rational[12031, 14307], 0.8409170336199063]], AbsoluteThickness[0.25], 
     LineBox[{12031, 12032}]}, 
    {Hue[
      NCache[
       Rational[12032, 14307], 0.8409869294750821]], AbsoluteThickness[0.25], 
     LineBox[{12032, 12033}]}, 
    {Hue[
      NCache[
       Rational[4011, 4769], 0.8410568253302579]], AbsoluteThickness[0.25], 
     LineBox[{12033, 12034}]}, 
    {Hue[
      NCache[
       Rational[12034, 14307], 0.8411267211854337]], AbsoluteThickness[0.25], 
     LineBox[{12034, 12035}]}, 
    {Hue[
      NCache[
       Rational[12035, 14307], 0.8411966170406094]], AbsoluteThickness[0.25], 
     LineBox[{12035, 12036}]}, 
    {Hue[
      NCache[
       Rational[4012, 4769], 0.8412665128957852]], AbsoluteThickness[0.25], 
     LineBox[{12036, 12037}]}, 
    {Hue[
      NCache[
       Rational[12037, 14307], 0.841336408750961]], AbsoluteThickness[0.25], 
     LineBox[{12037, 12038}]}, 
    {Hue[
      NCache[
       Rational[12038, 14307], 0.8414063046061369]], AbsoluteThickness[0.25], 
     LineBox[{12038, 12039}]}, 
    {Hue[
      NCache[
       Rational[4013, 4769], 0.8414762004613127]], AbsoluteThickness[0.25], 
     LineBox[{12039, 12040}]}, 
    {Hue[
      NCache[
       Rational[12040, 14307], 0.8415460963164885]], AbsoluteThickness[0.25], 
     LineBox[{12040, 12041}]}, 
    {Hue[
      NCache[
       Rational[12041, 14307], 0.8416159921716643]], AbsoluteThickness[0.25], 
     LineBox[{12041, 12042}]}, 
    {Hue[
      NCache[
       Rational[4014, 4769], 0.84168588802684]], AbsoluteThickness[0.25], 
     LineBox[{12042, 12043}]}, 
    {Hue[
      NCache[
       Rational[12043, 14307], 0.8417557838820158]], AbsoluteThickness[0.25], 
     LineBox[{12043, 12044}]}, 
    {Hue[
      NCache[
       Rational[12044, 14307], 0.8418256797371916]], AbsoluteThickness[0.25], 
     LineBox[{12044, 12045}]}, 
    {Hue[
      NCache[
       Rational[4015, 4769], 0.8418955755923674]], AbsoluteThickness[0.25], 
     LineBox[{12045, 12046}]}, 
    {Hue[
      NCache[
       Rational[634, 753], 0.8419654714475432]], AbsoluteThickness[0.25], 
     LineBox[{12046, 12047}]}, 
    {Hue[
      NCache[
       Rational[12047, 14307], 0.842035367302719]], AbsoluteThickness[0.25], 
     LineBox[{12047, 12048}]}, 
    {Hue[
      NCache[
       Rational[16, 19], 0.8421052631578947]], AbsoluteThickness[0.25], 
     LineBox[{12048, 12049}]}, 
    {Hue[
      NCache[
       Rational[12049, 14307], 0.8421751590130705]], AbsoluteThickness[0.25], 
     LineBox[{12049, 12050}]}, 
    {Hue[
      NCache[
       Rational[12050, 14307], 0.8422450548682463]], AbsoluteThickness[0.25], 
     LineBox[{12050, 12051}]}, 
    {Hue[
      NCache[
       Rational[4017, 4769], 0.8423149507234221]], AbsoluteThickness[0.25], 
     LineBox[{12051, 12052}]}, 
    {Hue[
      NCache[
       Rational[12052, 14307], 0.8423848465785979]], AbsoluteThickness[0.25], 
     LineBox[{12052, 12053}]}, 
    {Hue[
      NCache[
       Rational[12053, 14307], 0.8424547424337737]], AbsoluteThickness[0.25], 
     LineBox[{12053, 12054}]}, 
    {Hue[
      NCache[
       Rational[4018, 4769], 0.8425246382889494]], AbsoluteThickness[0.25], 
     LineBox[{12054, 12055}]}, 
    {Hue[
      NCache[
       Rational[12055, 14307], 0.8425945341441252]], AbsoluteThickness[0.25], 
     LineBox[{12055, 12056}]}, 
    {Hue[
      NCache[
       Rational[12056, 14307], 0.842664429999301]], AbsoluteThickness[0.25], 
     LineBox[{12056, 12057}]}, 
    {Hue[
      NCache[
       Rational[4019, 4769], 0.8427343258544768]], AbsoluteThickness[0.25], 
     LineBox[{12057, 12058}]}, 
    {Hue[
      NCache[
       Rational[12058, 14307], 0.8428042217096526]], AbsoluteThickness[0.25], 
     LineBox[{12058, 12059}]}, 
    {Hue[
      NCache[
       Rational[12059, 14307], 0.8428741175648284]], AbsoluteThickness[0.25], 
     LineBox[{12059, 12060}]}, 
    {Hue[
      NCache[
       Rational[4020, 4769], 0.8429440134200042]], AbsoluteThickness[0.25], 
     LineBox[{12060, 12061}]}, 
    {Hue[
      NCache[
       Rational[12061, 14307], 0.8430139092751799]], AbsoluteThickness[0.25], 
     LineBox[{12061, 12062}]}, 
    {Hue[
      NCache[
       Rational[12062, 14307], 0.8430838051303557]], AbsoluteThickness[0.25], 
     LineBox[{12062, 12063}]}, 
    {Hue[
      NCache[
       Rational[4021, 4769], 0.8431537009855316]], AbsoluteThickness[0.25], 
     LineBox[{12063, 12064}]}, 
    {Hue[
      NCache[
       Rational[12064, 14307], 0.8432235968407074]], AbsoluteThickness[0.25], 
     LineBox[{12064, 12065}]}, 
    {Hue[
      NCache[
       Rational[635, 753], 0.8432934926958832]], AbsoluteThickness[0.25], 
     LineBox[{12065, 12066}]}, 
    {Hue[
      NCache[
       Rational[4022, 4769], 0.843363388551059]], AbsoluteThickness[0.25], 
     LineBox[{12066, 12067}]}, 
    {Hue[
      NCache[
       Rational[12067, 14307], 0.8434332844062347]], AbsoluteThickness[0.25], 
     LineBox[{12067, 12068}]}, 
    {Hue[
      NCache[
       Rational[12068, 14307], 0.8435031802614105]], AbsoluteThickness[0.25], 
     LineBox[{12068, 12069}]}, 
    {Hue[
      NCache[
       Rational[4023, 4769], 0.8435730761165863]], AbsoluteThickness[0.25], 
     LineBox[{12069, 12070}]}, 
    {Hue[
      NCache[
       Rational[12070, 14307], 0.8436429719717621]], AbsoluteThickness[0.25], 
     LineBox[{12070, 12071}]}, 
    {Hue[
      NCache[
       Rational[12071, 14307], 0.8437128678269379]], AbsoluteThickness[0.25], 
     LineBox[{12071, 12072}]}, 
    {Hue[
      NCache[
       Rational[4024, 4769], 0.8437827636821137]], AbsoluteThickness[0.25], 
     LineBox[{12072, 12073}]}, 
    {Hue[
      NCache[
       Rational[12073, 14307], 0.8438526595372894]], AbsoluteThickness[0.25], 
     LineBox[{12073, 12074}]}, 
    {Hue[
      NCache[
       Rational[12074, 14307], 0.8439225553924652]], AbsoluteThickness[0.25], 
     LineBox[{12074, 12075}]}, 
    {Hue[
      NCache[
       Rational[4025, 4769], 0.843992451247641]], AbsoluteThickness[0.25], 
     LineBox[{12075, 12076}]}, 
    {Hue[
      NCache[
       Rational[12076, 14307], 0.8440623471028168]], AbsoluteThickness[0.25], 
     LineBox[{12076, 12077}]}, 
    {Hue[
      NCache[
       Rational[12077, 14307], 0.8441322429579926]], AbsoluteThickness[0.25], 
     LineBox[{12077, 12078}]}, 
    {Hue[
      NCache[
       Rational[4026, 4769], 0.8442021388131684]], AbsoluteThickness[0.25], 
     LineBox[{12078, 12079}]}, 
    {Hue[
      NCache[
       Rational[12079, 14307], 0.8442720346683442]], AbsoluteThickness[0.25], 
     LineBox[{12079, 12080}]}, 
    {Hue[
      NCache[
       Rational[12080, 14307], 0.8443419305235199]], AbsoluteThickness[0.25], 
     LineBox[{12080, 12081}]}, 
    {Hue[
      NCache[
       Rational[4027, 4769], 0.8444118263786957]], AbsoluteThickness[0.25], 
     LineBox[{12081, 12082}]}, 
    {Hue[
      NCache[
       Rational[12082, 14307], 0.8444817222338715]], AbsoluteThickness[0.25], 
     LineBox[{12082, 12083}]}, 
    {Hue[
      NCache[
       Rational[12083, 14307], 0.8445516180890473]], AbsoluteThickness[0.25], 
     LineBox[{12083, 12084}]}, 
    {Hue[
      NCache[
       Rational[212, 251], 0.8446215139442231]], AbsoluteThickness[0.25], 
     LineBox[{12084, 12085}]}, 
    {Hue[
      NCache[
       Rational[12085, 14307], 0.8446914097993989]], AbsoluteThickness[0.25], 
     LineBox[{12085, 12086}]}, 
    {Hue[
      NCache[
       Rational[12086, 14307], 0.8447613056545746]], AbsoluteThickness[0.25], 
     LineBox[{12086, 12087}]}, 
    {Hue[
      NCache[
       Rational[4029, 4769], 0.8448312015097504]], AbsoluteThickness[0.25], 
     LineBox[{12087, 12088}]}, 
    {Hue[
      NCache[
       Rational[12088, 14307], 0.8449010973649262]], AbsoluteThickness[0.25], 
     LineBox[{12088, 12089}]}, 
    {Hue[
      NCache[
       Rational[12089, 14307], 0.844970993220102]], AbsoluteThickness[0.25], 
     LineBox[{12089, 12090}]}, 
    {Hue[
      NCache[
       Rational[4030, 4769], 0.8450408890752779]], AbsoluteThickness[0.25], 
     LineBox[{12090, 12091}]}, 
    {Hue[
      NCache[
       Rational[12091, 14307], 0.8451107849304537]], AbsoluteThickness[0.25], 
     LineBox[{12091, 12092}]}, 
    {Hue[
      NCache[
       Rational[12092, 14307], 0.8451806807856294]], AbsoluteThickness[0.25], 
     LineBox[{12092, 12093}]}, 
    {Hue[
      NCache[
       Rational[4031, 4769], 0.8452505766408052]], AbsoluteThickness[0.25], 
     LineBox[{12093, 12094}]}, 
    {Hue[
      NCache[
       Rational[12094, 14307], 0.845320472495981]], AbsoluteThickness[0.25], 
     LineBox[{12094, 12095}]}, 
    {Hue[
      NCache[
       Rational[12095, 14307], 0.8453903683511568]], AbsoluteThickness[0.25], 
     LineBox[{12095, 12096}]}, 
    {Hue[
      NCache[
       Rational[4032, 4769], 0.8454602642063326]], AbsoluteThickness[0.25], 
     LineBox[{12096, 12097}]}, 
    {Hue[
      NCache[
       Rational[12097, 14307], 0.8455301600615084]], AbsoluteThickness[0.25], 
     LineBox[{12097, 12098}]}, 
    {Hue[
      NCache[
       Rational[12098, 14307], 0.8456000559166842]], AbsoluteThickness[0.25], 
     LineBox[{12098, 12099}]}, 
    {Hue[
      NCache[
       Rational[4033, 4769], 0.8456699517718599]], AbsoluteThickness[0.25], 
     LineBox[{12099, 12100}]}, 
    {Hue[
      NCache[
       Rational[12100, 14307], 0.8457398476270357]], AbsoluteThickness[0.25], 
     LineBox[{12100, 12101}]}, 
    {Hue[
      NCache[
       Rational[12101, 14307], 0.8458097434822115]], AbsoluteThickness[0.25], 
     LineBox[{12101, 12102}]}, 
    {Hue[
      NCache[
       Rational[4034, 4769], 0.8458796393373873]], AbsoluteThickness[0.25], 
     LineBox[{12102, 12103}]}, 
    {Hue[
      NCache[
       Rational[637, 753], 0.8459495351925631]], AbsoluteThickness[0.25], 
     LineBox[{12103, 12104}]}, 
    {Hue[
      NCache[
       Rational[12104, 14307], 0.8460194310477389]], AbsoluteThickness[0.25], 
     LineBox[{12104, 12105}]}, 
    {Hue[
      NCache[
       Rational[4035, 4769], 0.8460893269029146]], AbsoluteThickness[0.25], 
     LineBox[{12105, 12106}]}, 
    {Hue[
      NCache[
       Rational[12106, 14307], 0.8461592227580904]], AbsoluteThickness[0.25], 
     LineBox[{12106, 12107}]}, 
    {Hue[
      NCache[
       Rational[12107, 14307], 0.8462291186132662]], AbsoluteThickness[0.25], 
     LineBox[{12107, 12108}]}, 
    {Hue[
      NCache[
       Rational[4036, 4769], 0.846299014468442]], AbsoluteThickness[0.25], 
     LineBox[{12108, 12109}]}, 
    {Hue[
      NCache[
       Rational[12109, 14307], 0.8463689103236178]], AbsoluteThickness[0.25], 
     LineBox[{12109, 12110}]}, 
    {Hue[
      NCache[
       Rational[12110, 14307], 0.8464388061787936]], AbsoluteThickness[0.25], 
     LineBox[{12110, 12111}]}, 
    {Hue[
      NCache[
       Rational[4037, 4769], 0.8465087020339694]], AbsoluteThickness[0.25], 
     LineBox[{12111, 12112}]}, 
    {Hue[
      NCache[
       Rational[12112, 14307], 0.8465785978891451]], AbsoluteThickness[0.25], 
     LineBox[{12112, 12113}]}, 
    {Hue[
      NCache[
       Rational[12113, 14307], 0.8466484937443209]], AbsoluteThickness[0.25], 
     LineBox[{12113, 12114}]}, 
    {Hue[
      NCache[
       Rational[4038, 4769], 0.8467183895994967]], AbsoluteThickness[0.25], 
     LineBox[{12114, 12115}]}, 
    {Hue[
      NCache[
       Rational[12115, 14307], 0.8467882854546726]], AbsoluteThickness[0.25], 
     LineBox[{12115, 12116}]}, 
    {Hue[
      NCache[
       Rational[12116, 14307], 0.8468581813098484]], AbsoluteThickness[0.25], 
     LineBox[{12116, 12117}]}, 
    {Hue[
      NCache[
       Rational[4039, 4769], 0.8469280771650242]], AbsoluteThickness[0.25], 
     LineBox[{12117, 12118}]}, 
    {Hue[
      NCache[
       Rational[12118, 14307], 0.8469979730201999]], AbsoluteThickness[0.25], 
     LineBox[{12118, 12119}]}, 
    {Hue[
      NCache[
       Rational[12119, 14307], 0.8470678688753757]], AbsoluteThickness[0.25], 
     LineBox[{12119, 12120}]}, 
    {Hue[
      NCache[
       Rational[4040, 4769], 0.8471377647305515]], AbsoluteThickness[0.25], 
     LineBox[{12120, 12121}]}, 
    {Hue[
      NCache[
       Rational[12121, 14307], 0.8472076605857273]], AbsoluteThickness[0.25], 
     LineBox[{12121, 12122}]}, 
    {Hue[
      NCache[
       Rational[638, 753], 0.8472775564409031]], AbsoluteThickness[0.25], 
     LineBox[{12122, 12123}]}, 
    {Hue[
      NCache[
       Rational[4041, 4769], 0.8473474522960789]], AbsoluteThickness[0.25], 
     LineBox[{12123, 12124}]}, 
    {Hue[
      NCache[
       Rational[12124, 14307], 0.8474173481512546]], AbsoluteThickness[0.25], 
     LineBox[{12124, 12125}]}, 
    {Hue[
      NCache[
       Rational[12125, 14307], 0.8474872440064304]], AbsoluteThickness[0.25], 
     LineBox[{12125, 12126}]}, 
    {Hue[
      NCache[
       Rational[4042, 4769], 0.8475571398616062]], AbsoluteThickness[0.25], 
     LineBox[{12126, 12127}]}, 
    {Hue[
      NCache[
       Rational[12127, 14307], 0.847627035716782]], AbsoluteThickness[0.25], 
     LineBox[{12127, 12128}]}, 
    {Hue[
      NCache[
       Rational[12128, 14307], 0.8476969315719578]], AbsoluteThickness[0.25], 
     LineBox[{12128, 12129}]}, 
    {Hue[
      NCache[
       Rational[4043, 4769], 0.8477668274271336]], AbsoluteThickness[0.25], 
     LineBox[{12129, 12130}]}, 
    {Hue[
      NCache[
       Rational[12130, 14307], 0.8478367232823094]], AbsoluteThickness[0.25], 
     LineBox[{12130, 12131}]}, 
    {Hue[
      NCache[
       Rational[12131, 14307], 0.8479066191374851]], AbsoluteThickness[0.25], 
     LineBox[{12131, 12132}]}, 
    {Hue[
      NCache[
       Rational[4044, 4769], 0.8479765149926609]], AbsoluteThickness[0.25], 
     LineBox[{12132, 12133}]}, 
    {Hue[
      NCache[
       Rational[12133, 14307], 0.8480464108478367]], AbsoluteThickness[0.25], 
     LineBox[{12133, 12134}]}, 
    {Hue[
      NCache[
       Rational[12134, 14307], 0.8481163067030125]], AbsoluteThickness[0.25], 
     LineBox[{12134, 12135}]}, 
    {Hue[
      NCache[
       Rational[4045, 4769], 0.8481862025581883]], AbsoluteThickness[0.25], 
     LineBox[{12135, 12136}]}, 
    {Hue[
      NCache[
       Rational[12136, 14307], 0.8482560984133641]], AbsoluteThickness[0.25], 
     LineBox[{12136, 12137}]}, 
    {Hue[
      NCache[
       Rational[12137, 14307], 0.8483259942685398]], AbsoluteThickness[0.25], 
     LineBox[{12137, 12138}]}, 
    {Hue[
      NCache[
       Rational[4046, 4769], 0.8483958901237156]], AbsoluteThickness[0.25], 
     LineBox[{12138, 12139}]}, 
    {Hue[
      NCache[
       Rational[12139, 14307], 0.8484657859788914]], AbsoluteThickness[0.25], 
     LineBox[{12139, 12140}]}, 
    {Hue[
      NCache[
       Rational[12140, 14307], 0.8485356818340672]], AbsoluteThickness[0.25], 
     LineBox[{12140, 12141}]}, 
    {Hue[
      NCache[
       Rational[213, 251], 0.848605577689243]], AbsoluteThickness[0.25], 
     LineBox[{12141, 12142}]}, 
    {Hue[
      NCache[
       Rational[12142, 14307], 0.8486754735444189]], AbsoluteThickness[0.25], 
     LineBox[{12142, 12143}]}, 
    {Hue[
      NCache[
       Rational[12143, 14307], 0.8487453693995946]], AbsoluteThickness[0.25], 
     LineBox[{12143, 12144}]}, 
    {Hue[
      NCache[
       Rational[4048, 4769], 0.8488152652547704]], AbsoluteThickness[0.25], 
     LineBox[{12144, 12145}]}, 
    {Hue[
      NCache[
       Rational[12145, 14307], 0.8488851611099462]], AbsoluteThickness[0.25], 
     LineBox[{12145, 12146}]}, 
    {Hue[
      NCache[
       Rational[12146, 14307], 0.848955056965122]], AbsoluteThickness[0.25], 
     LineBox[{12146, 12147}]}, 
    {Hue[
      NCache[
       Rational[4049, 4769], 0.8490249528202978]], AbsoluteThickness[0.25], 
     LineBox[{12147, 12148}]}, 
    {Hue[
      NCache[
       Rational[12148, 14307], 0.8490948486754736]], AbsoluteThickness[0.25], 
     LineBox[{12148, 12149}]}, 
    {Hue[
      NCache[
       Rational[12149, 14307], 0.8491647445306494]], AbsoluteThickness[0.25], 
     LineBox[{12149, 12150}]}, 
    {Hue[
      NCache[
       Rational[4050, 4769], 0.8492346403858251]], AbsoluteThickness[0.25], 
     LineBox[{12150, 12151}]}, 
    {Hue[
      NCache[
       Rational[12151, 14307], 0.8493045362410009]], AbsoluteThickness[0.25], 
     LineBox[{12151, 12152}]}, 
    {Hue[
      NCache[
       Rational[12152, 14307], 0.8493744320961767]], AbsoluteThickness[0.25], 
     LineBox[{12152, 12153}]}, 
    {Hue[
      NCache[
       Rational[4051, 4769], 0.8494443279513525]], AbsoluteThickness[0.25], 
     LineBox[{12153, 12154}]}, 
    {Hue[
      NCache[
       Rational[12154, 14307], 0.8495142238065283]], AbsoluteThickness[0.25], 
     LineBox[{12154, 12155}]}, 
    {Hue[
      NCache[
       Rational[12155, 14307], 0.8495841196617041]], AbsoluteThickness[0.25], 
     LineBox[{12155, 12156}]}, 
    {Hue[
      NCache[
       Rational[4052, 4769], 0.8496540155168798]], AbsoluteThickness[0.25], 
     LineBox[{12156, 12157}]}, 
    {Hue[
      NCache[
       Rational[12157, 14307], 0.8497239113720556]], AbsoluteThickness[0.25], 
     LineBox[{12157, 12158}]}, 
    {Hue[
      NCache[
       Rational[12158, 14307], 0.8497938072272314]], AbsoluteThickness[0.25], 
     LineBox[{12158, 12159}]}, 
    {Hue[
      NCache[
       Rational[4053, 4769], 0.8498637030824072]], AbsoluteThickness[0.25], 
     LineBox[{12159, 12160}]}, 
    {Hue[
      NCache[
       Rational[640, 753], 0.849933598937583]], AbsoluteThickness[0.25], 
     LineBox[{12160, 12161}]}, 
    {Hue[
      NCache[
       Rational[12161, 14307], 0.8500034947927588]], AbsoluteThickness[0.25], 
     LineBox[{12161, 12162}]}, 
    {Hue[
      NCache[
       Rational[4054, 4769], 0.8500733906479345]], AbsoluteThickness[0.25], 
     LineBox[{12162, 12163}]}, 
    {Hue[
      NCache[
       Rational[12163, 14307], 0.8501432865031103]], AbsoluteThickness[0.25], 
     LineBox[{12163, 12164}]}, 
    {Hue[
      NCache[
       Rational[12164, 14307], 0.8502131823582861]], AbsoluteThickness[0.25], 
     LineBox[{12164, 12165}]}, 
    {Hue[
      NCache[
       Rational[4055, 4769], 0.8502830782134619]], AbsoluteThickness[0.25], 
     LineBox[{12165, 12166}]}, 
    {Hue[
      NCache[
       Rational[12166, 14307], 0.8503529740686377]], AbsoluteThickness[0.25], 
     LineBox[{12166, 12167}]}, 
    {Hue[
      NCache[
       Rational[12167, 14307], 0.8504228699238136]], AbsoluteThickness[0.25], 
     LineBox[{12167, 12168}]}, 
    {Hue[
      NCache[
       Rational[4056, 4769], 0.8504927657789894]], AbsoluteThickness[0.25], 
     LineBox[{12168, 12169}]}, 
    {Hue[
      NCache[
       Rational[12169, 14307], 0.850562661634165]], AbsoluteThickness[0.25], 
     LineBox[{12169, 12170}]}, 
    {Hue[
      NCache[
       Rational[12170, 14307], 0.8506325574893409]], AbsoluteThickness[0.25], 
     LineBox[{12170, 12171}]}, 
    {Hue[
      NCache[
       Rational[4057, 4769], 0.8507024533445167]], AbsoluteThickness[0.25], 
     LineBox[{12171, 12172}]}, 
    {Hue[
      NCache[
       Rational[12172, 14307], 0.8507723491996925]], AbsoluteThickness[0.25], 
     LineBox[{12172, 12173}]}, 
    {Hue[
      NCache[
       Rational[12173, 14307], 0.8508422450548683]], AbsoluteThickness[0.25], 
     LineBox[{12173, 12174}]}, 
    {Hue[
      NCache[
       Rational[4058, 4769], 0.8509121409100441]], AbsoluteThickness[0.25], 
     LineBox[{12174, 12175}]}, 
    {Hue[
      NCache[
       Rational[12175, 14307], 0.8509820367652198]], AbsoluteThickness[0.25], 
     LineBox[{12175, 12176}]}, 
    {Hue[
      NCache[
       Rational[12176, 14307], 0.8510519326203956]], AbsoluteThickness[0.25], 
     LineBox[{12176, 12177}]}, 
    {Hue[
      NCache[
       Rational[4059, 4769], 0.8511218284755714]], AbsoluteThickness[0.25], 
     LineBox[{12177, 12178}]}, 
    {Hue[
      NCache[
       Rational[12178, 14307], 0.8511917243307472]], AbsoluteThickness[0.25], 
     LineBox[{12178, 12179}]}, 
    {Hue[
      NCache[
       Rational[641, 753], 0.851261620185923]], AbsoluteThickness[0.25], 
     LineBox[{12179, 12180}]}, 
    {Hue[
      NCache[
       Rational[4060, 4769], 0.8513315160410988]], AbsoluteThickness[0.25], 
     LineBox[{12180, 12181}]}, 
    {Hue[
      NCache[
       Rational[12181, 14307], 0.8514014118962745]], AbsoluteThickness[0.25], 
     LineBox[{12181, 12182}]}, 
    {Hue[
      NCache[
       Rational[12182, 14307], 0.8514713077514503]], AbsoluteThickness[0.25], 
     LineBox[{12182, 12183}]}, 
    {Hue[
      NCache[
       Rational[4061, 4769], 0.8515412036066261]], AbsoluteThickness[0.25], 
     LineBox[{12183, 12184}]}, 
    {Hue[
      NCache[
       Rational[12184, 14307], 0.8516110994618019]], AbsoluteThickness[0.25], 
     LineBox[{12184, 12185}]}, 
    {Hue[
      NCache[
       Rational[12185, 14307], 0.8516809953169777]], AbsoluteThickness[0.25], 
     LineBox[{12185, 12186}]}, 
    {Hue[
      NCache[
       Rational[4062, 4769], 0.8517508911721535]], AbsoluteThickness[0.25], 
     LineBox[{12186, 12187}]}, 
    {Hue[
      NCache[
       Rational[12187, 14307], 0.8518207870273293]], AbsoluteThickness[0.25], 
     LineBox[{12187, 12188}]}, 
    {Hue[
      NCache[
       Rational[12188, 14307], 0.851890682882505]], AbsoluteThickness[0.25], 
     LineBox[{12188, 12189}]}, 
    {Hue[
      NCache[
       Rational[4063, 4769], 0.8519605787376808]], AbsoluteThickness[0.25], 
     LineBox[{12189, 12190}]}, 
    {Hue[
      NCache[
       Rational[12190, 14307], 0.8520304745928566]], AbsoluteThickness[0.25], 
     LineBox[{12190, 12191}]}, 
    {Hue[
      NCache[
       Rational[12191, 14307], 0.8521003704480324]], AbsoluteThickness[0.25], 
     LineBox[{12191, 12192}]}, 
    {Hue[
      NCache[
       Rational[4064, 4769], 0.8521702663032082]], AbsoluteThickness[0.25], 
     LineBox[{12192, 12193}]}, 
    {Hue[
      NCache[
       Rational[12193, 14307], 0.852240162158384]], AbsoluteThickness[0.25], 
     LineBox[{12193, 12194}]}, 
    {Hue[
      NCache[
       Rational[12194, 14307], 0.8523100580135597]], AbsoluteThickness[0.25], 
     LineBox[{12194, 12195}]}, 
    {Hue[
      NCache[
       Rational[4065, 4769], 0.8523799538687356]], AbsoluteThickness[0.25], 
     LineBox[{12195, 12196}]}, 
    {Hue[
      NCache[
       Rational[12196, 14307], 0.8524498497239114]], AbsoluteThickness[0.25], 
     LineBox[{12196, 12197}]}, 
    {Hue[
      NCache[
       Rational[12197, 14307], 0.8525197455790872]], AbsoluteThickness[0.25], 
     LineBox[{12197, 12198}]}, 
    {Hue[
      NCache[
       Rational[214, 251], 0.852589641434263]], AbsoluteThickness[0.25], 
     LineBox[{12198, 12199}]}, 
    {Hue[
      NCache[
       Rational[12199, 14307], 0.8526595372894388]], AbsoluteThickness[0.25], 
     LineBox[{12199, 12200}]}, 
    {Hue[
      NCache[
       Rational[12200, 14307], 0.8527294331446146]], AbsoluteThickness[0.25], 
     LineBox[{12200, 12201}]}, 
    {Hue[
      NCache[
       Rational[4067, 4769], 0.8527993289997903]], AbsoluteThickness[0.25], 
     LineBox[{12201, 12202}]}, 
    {Hue[
      NCache[
       Rational[12202, 14307], 0.8528692248549661]], AbsoluteThickness[0.25], 
     LineBox[{12202, 12203}]}, 
    {Hue[
      NCache[
       Rational[12203, 14307], 0.8529391207101419]], AbsoluteThickness[0.25], 
     LineBox[{12203, 12204}]}, 
    {Hue[
      NCache[
       Rational[4068, 4769], 0.8530090165653177]], AbsoluteThickness[0.25], 
     LineBox[{12204, 12205}]}, 
    {Hue[
      NCache[
       Rational[12205, 14307], 0.8530789124204935]], AbsoluteThickness[0.25], 
     LineBox[{12205, 12206}]}, 
    {Hue[
      NCache[
       Rational[12206, 14307], 0.8531488082756693]], AbsoluteThickness[0.25], 
     LineBox[{12206, 12207}]}, 
    {Hue[
      NCache[
       Rational[4069, 4769], 0.853218704130845]], AbsoluteThickness[0.25], 
     LineBox[{12207, 12208}]}, 
    {Hue[
      NCache[
       Rational[12208, 14307], 0.8532885999860208]], AbsoluteThickness[0.25], 
     LineBox[{12208, 12209}]}, 
    {Hue[
      NCache[
       Rational[12209, 14307], 0.8533584958411966]], AbsoluteThickness[0.25], 
     LineBox[{12209, 12210}]}, 
    {Hue[
      NCache[
       Rational[4070, 4769], 0.8534283916963724]], AbsoluteThickness[0.25], 
     LineBox[{12210, 12211}]}, 
    {Hue[
      NCache[
       Rational[12211, 14307], 0.8534982875515482]], AbsoluteThickness[0.25], 
     LineBox[{12211, 12212}]}, 
    {Hue[
      NCache[
       Rational[12212, 14307], 0.853568183406724]], AbsoluteThickness[0.25], 
     LineBox[{12212, 12213}]}, 
    {Hue[
      NCache[
       Rational[4071, 4769], 0.8536380792618997]], AbsoluteThickness[0.25], 
     LineBox[{12213, 12214}]}, 
    {Hue[
      NCache[
       Rational[12214, 14307], 0.8537079751170755]], AbsoluteThickness[0.25], 
     LineBox[{12214, 12215}]}, 
    {Hue[
      NCache[
       Rational[12215, 14307], 0.8537778709722513]], AbsoluteThickness[0.25], 
     LineBox[{12215, 12216}]}, 
    {Hue[
      NCache[
       Rational[4072, 4769], 0.8538477668274271]], AbsoluteThickness[0.25], 
     LineBox[{12216, 12217}]}, 
    {Hue[
      NCache[
       Rational[643, 753], 0.8539176626826029]], AbsoluteThickness[0.25], 
     LineBox[{12217, 12218}]}, 
    {Hue[
      NCache[
       Rational[12218, 14307], 0.8539875585377787]], AbsoluteThickness[0.25], 
     LineBox[{12218, 12219}]}, 
    {Hue[
      NCache[
       Rational[4073, 4769], 0.8540574543929546]], AbsoluteThickness[0.25], 
     LineBox[{12219, 12220}]}, 
    {Hue[
      NCache[
       Rational[12220, 14307], 0.8541273502481302]], AbsoluteThickness[0.25], 
     LineBox[{12220, 12221}]}, 
    {Hue[
      NCache[
       Rational[12221, 14307], 0.854197246103306]], AbsoluteThickness[0.25], 
     LineBox[{12221, 12222}]}, 
    {Hue[
      NCache[
       Rational[4074, 4769], 0.8542671419584819]], AbsoluteThickness[0.25], 
     LineBox[{12222, 12223}]}, 
    {Hue[
      NCache[
       Rational[12223, 14307], 0.8543370378136577]], AbsoluteThickness[0.25], 
     LineBox[{12223, 12224}]}, 
    {Hue[
      NCache[
       Rational[12224, 14307], 0.8544069336688335]], AbsoluteThickness[0.25], 
     LineBox[{12224, 12225}]}, 
    {Hue[
      NCache[
       Rational[4075, 4769], 0.8544768295240093]], AbsoluteThickness[0.25], 
     LineBox[{12225, 12226}]}, 
    {Hue[
      NCache[
       Rational[12226, 14307], 0.854546725379185]], AbsoluteThickness[0.25], 
     LineBox[{12226, 12227}]}, 
    {Hue[
      NCache[
       Rational[12227, 14307], 0.8546166212343608]], AbsoluteThickness[0.25], 
     LineBox[{12227, 12228}]}, 
    {Hue[
      NCache[
       Rational[4076, 4769], 0.8546865170895366]], AbsoluteThickness[0.25], 
     LineBox[{12228, 12229}]}, 
    {Hue[
      NCache[
       Rational[12229, 14307], 0.8547564129447124]], AbsoluteThickness[0.25], 
     LineBox[{12229, 12230}]}, 
    {Hue[
      NCache[
       Rational[12230, 14307], 0.8548263087998882]], AbsoluteThickness[0.25], 
     LineBox[{12230, 12231}]}, 
    {Hue[
      NCache[
       Rational[4077, 4769], 0.854896204655064]], AbsoluteThickness[0.25], 
     LineBox[{12231, 12232}]}, 
    {Hue[
      NCache[
       Rational[12232, 14307], 0.8549661005102397]], AbsoluteThickness[0.25], 
     LineBox[{12232, 12233}]}, 
    {Hue[
      NCache[
       Rational[12233, 14307], 0.8550359963654155]], AbsoluteThickness[0.25], 
     LineBox[{12233, 12234}]}, 
    {Hue[
      NCache[
       Rational[4078, 4769], 0.8551058922205913]], AbsoluteThickness[0.25], 
     LineBox[{12234, 12235}]}, 
    {Hue[
      NCache[
       Rational[12235, 14307], 0.8551757880757671]], AbsoluteThickness[0.25], 
     LineBox[{12235, 12236}]}, 
    {Hue[
      NCache[
       Rational[644, 753], 0.8552456839309429]], AbsoluteThickness[0.25], 
     LineBox[{12236, 12237}]}, 
    {Hue[
      NCache[
       Rational[4079, 4769], 0.8553155797861187]], AbsoluteThickness[0.25], 
     LineBox[{12237, 12238}]}, 
    {Hue[
      NCache[
       Rational[12238, 14307], 0.8553854756412945]], AbsoluteThickness[0.25], 
     LineBox[{12238, 12239}]}, 
    {Hue[
      NCache[
       Rational[12239, 14307], 0.8554553714964702]], AbsoluteThickness[0.25], 
     LineBox[{12239, 12240}]}, 
    {Hue[
      NCache[
       Rational[4080, 4769], 0.855525267351646]], AbsoluteThickness[0.25], 
     LineBox[{12240, 12241}]}, 
    {Hue[
      NCache[
       Rational[12241, 14307], 0.8555951632068218]], AbsoluteThickness[0.25], 
     LineBox[{12241, 12242}]}, 
    {Hue[
      NCache[
       Rational[12242, 14307], 0.8556650590619976]], AbsoluteThickness[0.25], 
     LineBox[{12242, 12243}]}, 
    {Hue[
      NCache[
       Rational[4081, 4769], 0.8557349549171734]], AbsoluteThickness[0.25], 
     LineBox[{12243, 12244}]}, 
    {Hue[
      NCache[
       Rational[12244, 14307], 0.8558048507723492]], AbsoluteThickness[0.25], 
     LineBox[{12244, 12245}]}, 
    {Hue[
      NCache[
       Rational[12245, 14307], 0.8558747466275249]], AbsoluteThickness[0.25], 
     LineBox[{12245, 12246}]}, 
    {Hue[
      NCache[
       Rational[4082, 4769], 0.8559446424827007]], AbsoluteThickness[0.25], 
     LineBox[{12246, 12247}]}, 
    {Hue[
      NCache[
       Rational[12247, 14307], 0.8560145383378766]], AbsoluteThickness[0.25], 
     LineBox[{12247, 12248}]}, 
    {Hue[
      NCache[
       Rational[12248, 14307], 0.8560844341930524]], AbsoluteThickness[0.25], 
     LineBox[{12248, 12249}]}, 
    {Hue[
      NCache[
       Rational[4083, 4769], 0.8561543300482282]], AbsoluteThickness[0.25], 
     LineBox[{12249, 12250}]}, 
    {Hue[
      NCache[
       Rational[12250, 14307], 0.856224225903404]], AbsoluteThickness[0.25], 
     LineBox[{12250, 12251}]}, 
    {Hue[
      NCache[
       Rational[12251, 14307], 0.8562941217585797]], AbsoluteThickness[0.25], 
     LineBox[{12251, 12252}]}, 
    {Hue[
      NCache[
       Rational[4084, 4769], 0.8563640176137555]], AbsoluteThickness[0.25], 
     LineBox[{12252, 12253}]}, 
    {Hue[
      NCache[
       Rational[12253, 14307], 0.8564339134689313]], AbsoluteThickness[0.25], 
     LineBox[{12253, 12254}]}, 
    {Hue[
      NCache[
       Rational[12254, 14307], 0.8565038093241071]], AbsoluteThickness[0.25], 
     LineBox[{12254, 12255}]}, 
    {Hue[
      NCache[
       Rational[215, 251], 0.8565737051792829]], AbsoluteThickness[0.25], 
     LineBox[{12255, 12256}]}, 
    {Hue[
      NCache[
       Rational[12256, 14307], 0.8566436010344587]], AbsoluteThickness[0.25], 
     LineBox[{12256, 12257}]}, 
    {Hue[
      NCache[
       Rational[12257, 14307], 0.8567134968896345]], AbsoluteThickness[0.25], 
     LineBox[{12257, 12258}]}, 
    {Hue[
      NCache[
       Rational[4086, 4769], 0.8567833927448102]], AbsoluteThickness[0.25], 
     LineBox[{12258, 12259}]}, 
    {Hue[
      NCache[
       Rational[12259, 14307], 0.856853288599986]], AbsoluteThickness[0.25], 
     LineBox[{12259, 12260}]}, 
    {Hue[
      NCache[
       Rational[12260, 14307], 0.8569231844551618]], AbsoluteThickness[0.25], 
     LineBox[{12260, 12261}]}, 
    {Hue[
      NCache[
       Rational[4087, 4769], 0.8569930803103376]], AbsoluteThickness[0.25], 
     LineBox[{12261, 12262}]}, 
    {Hue[
      NCache[
       Rational[12262, 14307], 0.8570629761655134]], AbsoluteThickness[0.25], 
     LineBox[{12262, 12263}]}, 
    {Hue[
      NCache[
       Rational[12263, 14307], 0.8571328720206892]], AbsoluteThickness[0.25], 
     LineBox[{12263, 12264}]}, 
    {Hue[
      NCache[
       Rational[4088, 4769], 0.8572027678758649]], AbsoluteThickness[0.25], 
     LineBox[{12264, 12265}]}, 
    {Hue[
      NCache[
       Rational[12265, 14307], 0.8572726637310407]], AbsoluteThickness[0.25], 
     LineBox[{12265, 12266}]}, 
    {Hue[
      NCache[
       Rational[12266, 14307], 0.8573425595862165]], AbsoluteThickness[0.25], 
     LineBox[{12266, 12267}]}, 
    {Hue[
      NCache[
       Rational[4089, 4769], 0.8574124554413923]], AbsoluteThickness[0.25], 
     LineBox[{12267, 12268}]}, 
    {Hue[
      NCache[
       Rational[12268, 14307], 0.8574823512965681]], AbsoluteThickness[0.25], 
     LineBox[{12268, 12269}]}, 
    {Hue[
      NCache[
       Rational[12269, 14307], 0.8575522471517439]], AbsoluteThickness[0.25], 
     LineBox[{12269, 12270}]}, 
    {Hue[
      NCache[
       Rational[4090, 4769], 0.8576221430069196]], AbsoluteThickness[0.25], 
     LineBox[{12270, 12271}]}, 
    {Hue[
      NCache[
       Rational[12271, 14307], 0.8576920388620954]], AbsoluteThickness[0.25], 
     LineBox[{12271, 12272}]}, 
    {Hue[
      NCache[
       Rational[12272, 14307], 0.8577619347172712]], AbsoluteThickness[0.25], 
     LineBox[{12272, 12273}]}, 
    {Hue[
      NCache[
       Rational[4091, 4769], 0.857831830572447]], AbsoluteThickness[0.25], 
     LineBox[{12273, 12274}]}, 
    {Hue[
      NCache[
       Rational[646, 753], 0.8579017264276229]], AbsoluteThickness[0.25], 
     LineBox[{12274, 12275}]}, 
    {Hue[
      NCache[
       Rational[12275, 14307], 0.8579716222827987]], AbsoluteThickness[0.25], 
     LineBox[{12275, 12276}]}, 
    {Hue[
      NCache[
       Rational[4092, 4769], 0.8580415181379745]], AbsoluteThickness[0.25], 
     LineBox[{12276, 12277}]}, 
    {Hue[
      NCache[
       Rational[12277, 14307], 0.8581114139931502]], AbsoluteThickness[0.25], 
     LineBox[{12277, 12278}]}, 
    {Hue[
      NCache[
       Rational[12278, 14307], 0.858181309848326]], AbsoluteThickness[0.25], 
     LineBox[{12278, 12279}]}, 
    {Hue[
      NCache[
       Rational[4093, 4769], 0.8582512057035018]], AbsoluteThickness[0.25], 
     LineBox[{12279, 12280}]}, 
    {Hue[
      NCache[
       Rational[12280, 14307], 0.8583211015586776]], AbsoluteThickness[0.25], 
     LineBox[{12280, 12281}]}, 
    {Hue[
      NCache[
       Rational[12281, 14307], 0.8583909974138534]], AbsoluteThickness[0.25], 
     LineBox[{12281, 12282}]}, 
    {Hue[
      NCache[
       Rational[4094, 4769], 0.8584608932690292]], AbsoluteThickness[0.25], 
     LineBox[{12282, 12283}]}, 
    {Hue[
      NCache[
       Rational[12283, 14307], 0.8585307891242049]], AbsoluteThickness[0.25], 
     LineBox[{12283, 12284}]}, 
    {Hue[
      NCache[
       Rational[12284, 14307], 0.8586006849793807]], AbsoluteThickness[0.25], 
     LineBox[{12284, 12285}]}, 
    {Hue[
      NCache[
       Rational[4095, 4769], 0.8586705808345565]], AbsoluteThickness[0.25], 
     LineBox[{12285, 12286}]}, 
    {Hue[
      NCache[
       Rational[12286, 14307], 0.8587404766897323]], AbsoluteThickness[0.25], 
     LineBox[{12286, 12287}]}, 
    {Hue[
      NCache[
       Rational[12287, 14307], 0.8588103725449081]], AbsoluteThickness[0.25], 
     LineBox[{12287, 12288}]}, 
    {Hue[
      NCache[
       Rational[4096, 4769], 0.8588802684000839]], AbsoluteThickness[0.25], 
     LineBox[{12288, 12289}]}, 
    {Hue[
      NCache[
       Rational[12289, 14307], 0.8589501642552597]], AbsoluteThickness[0.25], 
     LineBox[{12289, 12290}]}, 
    {Hue[
      NCache[
       Rational[12290, 14307], 0.8590200601104354]], AbsoluteThickness[0.25], 
     LineBox[{12290, 12291}]}, 
    {Hue[
      NCache[
       Rational[4097, 4769], 0.8590899559656112]], AbsoluteThickness[0.25], 
     LineBox[{12291, 12292}]}, 
    {Hue[
      NCache[
       Rational[12292, 14307], 0.859159851820787]], AbsoluteThickness[0.25], 
     LineBox[{12292, 12293}]}, 
    {Hue[
      NCache[
       Rational[647, 753], 0.8592297476759628]], AbsoluteThickness[0.25], 
     LineBox[{12293, 12294}]}, 
    {Hue[
      NCache[
       Rational[4098, 4769], 0.8592996435311386]], AbsoluteThickness[0.25], 
     LineBox[{12294, 12295}]}, 
    {Hue[
      NCache[
       Rational[12295, 14307], 0.8593695393863144]], AbsoluteThickness[0.25], 
     LineBox[{12295, 12296}]}, 
    {Hue[
      NCache[
       Rational[12296, 14307], 0.8594394352414901]], AbsoluteThickness[0.25], 
     LineBox[{12296, 12297}]}, 
    {Hue[
      NCache[
       Rational[4099, 4769], 0.8595093310966659]], AbsoluteThickness[0.25], 
     LineBox[{12297, 12298}]}, 
    {Hue[
      NCache[
       Rational[12298, 14307], 0.8595792269518417]], AbsoluteThickness[0.25], 
     LineBox[{12298, 12299}]}, 
    {Hue[
      NCache[
       Rational[49, 57], 0.8596491228070176]], AbsoluteThickness[0.25], 
     LineBox[{12299, 12300}]}, 
    {Hue[
      NCache[
       Rational[4100, 4769], 0.8597190186621934]], AbsoluteThickness[0.25], 
     LineBox[{12300, 12301}]}, 
    {Hue[
      NCache[
       Rational[12301, 14307], 0.8597889145173692]], AbsoluteThickness[0.25], 
     LineBox[{12301, 12302}]}, 
    {Hue[
      NCache[
       Rational[12302, 14307], 0.8598588103725449]], AbsoluteThickness[0.25], 
     LineBox[{12302, 12303}]}, 
    {Hue[
      NCache[
       Rational[4101, 4769], 0.8599287062277207]], AbsoluteThickness[0.25], 
     LineBox[{12303, 12304}]}, 
    {Hue[
      NCache[
       Rational[12304, 14307], 0.8599986020828965]], AbsoluteThickness[0.25], 
     LineBox[{12304, 12305}]}, 
    {Hue[
      NCache[
       Rational[12305, 14307], 0.8600684979380723]], AbsoluteThickness[0.25], 
     LineBox[{12305, 12306}]}, 
    {Hue[
      NCache[
       Rational[4102, 4769], 0.8601383937932481]], AbsoluteThickness[0.25], 
     LineBox[{12306, 12307}]}, 
    {Hue[
      NCache[
       Rational[12307, 14307], 0.8602082896484239]], AbsoluteThickness[0.25], 
     LineBox[{12307, 12308}]}, 
    {Hue[
      NCache[
       Rational[12308, 14307], 0.8602781855035997]], AbsoluteThickness[0.25], 
     LineBox[{12308, 12309}]}, 
    {Hue[
      NCache[
       Rational[4103, 4769], 0.8603480813587754]], AbsoluteThickness[0.25], 
     LineBox[{12309, 12310}]}, 
    {Hue[
      NCache[
       Rational[12310, 14307], 0.8604179772139512]], AbsoluteThickness[0.25], 
     LineBox[{12310, 12311}]}, 
    {Hue[
      NCache[
       Rational[12311, 14307], 0.860487873069127]], AbsoluteThickness[0.25], 
     LineBox[{12311, 12312}]}, 
    {Hue[
      NCache[
       Rational[216, 251], 0.8605577689243028]], AbsoluteThickness[0.25], 
     LineBox[{12312, 12313}]}, 
    {Hue[
      NCache[
       Rational[12313, 14307], 0.8606276647794786]], AbsoluteThickness[0.25], 
     LineBox[{12313, 12314}]}, 
    {Hue[
      NCache[
       Rational[12314, 14307], 0.8606975606346544]], AbsoluteThickness[0.25], 
     LineBox[{12314, 12315}]}, 
    {Hue[
      NCache[
       Rational[4105, 4769], 0.8607674564898301]], AbsoluteThickness[0.25], 
     LineBox[{12315, 12316}]}, 
    {Hue[
      NCache[
       Rational[12316, 14307], 0.8608373523450059]], AbsoluteThickness[0.25], 
     LineBox[{12316, 12317}]}, 
    {Hue[
      NCache[
       Rational[12317, 14307], 0.8609072482001817]], AbsoluteThickness[0.25], 
     LineBox[{12317, 12318}]}, 
    {Hue[
      NCache[
       Rational[4106, 4769], 0.8609771440553575]], AbsoluteThickness[0.25], 
     LineBox[{12318, 12319}]}, 
    {Hue[
      NCache[
       Rational[12319, 14307], 0.8610470399105333]], AbsoluteThickness[0.25], 
     LineBox[{12319, 12320}]}, 
    {Hue[
      NCache[
       Rational[12320, 14307], 0.8611169357657091]], AbsoluteThickness[0.25], 
     LineBox[{12320, 12321}]}, 
    {Hue[
      NCache[
       Rational[4107, 4769], 0.8611868316208848]], AbsoluteThickness[0.25], 
     LineBox[{12321, 12322}]}, 
    {Hue[
      NCache[
       Rational[12322, 14307], 0.8612567274760606]], AbsoluteThickness[0.25], 
     LineBox[{12322, 12323}]}, 
    {Hue[
      NCache[
       Rational[12323, 14307], 0.8613266233312364]], AbsoluteThickness[0.25], 
     LineBox[{12323, 12324}]}, 
    {Hue[
      NCache[
       Rational[4108, 4769], 0.8613965191864122]], AbsoluteThickness[0.25], 
     LineBox[{12324, 12325}]}, 
    {Hue[
      NCache[
       Rational[12325, 14307], 0.861466415041588]], AbsoluteThickness[0.25], 
     LineBox[{12325, 12326}]}, 
    {Hue[
      NCache[
       Rational[12326, 14307], 0.8615363108967639]], AbsoluteThickness[0.25], 
     LineBox[{12326, 12327}]}, 
    {Hue[
      NCache[
       Rational[4109, 4769], 0.8616062067519397]], AbsoluteThickness[0.25], 
     LineBox[{12327, 12328}]}, 
    {Hue[
      NCache[
       Rational[12328, 14307], 0.8616761026071154]], AbsoluteThickness[0.25], 
     LineBox[{12328, 12329}]}, 
    {Hue[
      NCache[
       Rational[12329, 14307], 0.8617459984622912]], AbsoluteThickness[0.25], 
     LineBox[{12329, 12330}]}, 
    {Hue[
      NCache[
       Rational[4110, 4769], 0.861815894317467]], AbsoluteThickness[0.25], 
     LineBox[{12330, 12331}]}, 
    {Hue[
      NCache[
       Rational[649, 753], 0.8618857901726428]], AbsoluteThickness[0.25], 
     LineBox[{12331, 12332}]}, 
    {Hue[
      NCache[
       Rational[12332, 14307], 0.8619556860278186]], AbsoluteThickness[0.25], 
     LineBox[{12332, 12333}]}, 
    {Hue[
      NCache[
       Rational[4111, 4769], 0.8620255818829944]], AbsoluteThickness[0.25], 
     LineBox[{12333, 12334}]}, 
    {Hue[
      NCache[
       Rational[12334, 14307], 0.8620954777381701]], AbsoluteThickness[0.25], 
     LineBox[{12334, 12335}]}, 
    {Hue[
      NCache[
       Rational[12335, 14307], 0.8621653735933459]], AbsoluteThickness[0.25], 
     LineBox[{12335, 12336}]}, 
    {Hue[
      NCache[
       Rational[4112, 4769], 0.8622352694485217]], AbsoluteThickness[0.25], 
     LineBox[{12336, 12337}]}, 
    {Hue[
      NCache[
       Rational[12337, 14307], 0.8623051653036975]], AbsoluteThickness[0.25], 
     LineBox[{12337, 12338}]}, 
    {Hue[
      NCache[
       Rational[12338, 14307], 0.8623750611588733]], AbsoluteThickness[0.25], 
     LineBox[{12338, 12339}]}, 
    {Hue[
      NCache[
       Rational[4113, 4769], 0.8624449570140491]], AbsoluteThickness[0.25], 
     LineBox[{12339, 12340}]}, 
    {Hue[
      NCache[
       Rational[12340, 14307], 0.8625148528692248]], AbsoluteThickness[0.25], 
     LineBox[{12340, 12341}]}, 
    {Hue[
      NCache[
       Rational[12341, 14307], 0.8625847487244006]], AbsoluteThickness[0.25], 
     LineBox[{12341, 12342}]}, 
    {Hue[
      NCache[
       Rational[4114, 4769], 0.8626546445795764]], AbsoluteThickness[0.25], 
     LineBox[{12342, 12343}]}, 
    {Hue[
      NCache[
       Rational[12343, 14307], 0.8627245404347522]], AbsoluteThickness[0.25], 
     LineBox[{12343, 12344}]}, 
    {Hue[
      NCache[
       Rational[12344, 14307], 0.862794436289928]], AbsoluteThickness[0.25], 
     LineBox[{12344, 12345}]}, 
    {Hue[
      NCache[
       Rational[4115, 4769], 0.8628643321451038]], AbsoluteThickness[0.25], 
     LineBox[{12345, 12346}]}, 
    {Hue[
      NCache[
       Rational[12346, 14307], 0.8629342280002796]], AbsoluteThickness[0.25], 
     LineBox[{12346, 12347}]}, 
    {Hue[
      NCache[
       Rational[12347, 14307], 0.8630041238554553]], AbsoluteThickness[0.25], 
     LineBox[{12347, 12348}]}, 
    {Hue[
      NCache[
       Rational[4116, 4769], 0.8630740197106311]], AbsoluteThickness[0.25], 
     LineBox[{12348, 12349}]}, 
    {Hue[
      NCache[
       Rational[12349, 14307], 0.8631439155658069]], AbsoluteThickness[0.25], 
     LineBox[{12349, 12350}]}, 
    {Hue[
      NCache[
       Rational[650, 753], 0.8632138114209827]], AbsoluteThickness[0.25], 
     LineBox[{12350, 12351}]}, 
    {Hue[
      NCache[
       Rational[4117, 4769], 0.8632837072761586]], AbsoluteThickness[0.25], 
     LineBox[{12351, 12352}]}, 
    {Hue[
      NCache[
       Rational[12352, 14307], 0.8633536031313344]], AbsoluteThickness[0.25], 
     LineBox[{12352, 12353}]}, 
    {Hue[
      NCache[
       Rational[12353, 14307], 0.86342349898651]], AbsoluteThickness[0.25], 
     LineBox[{12353, 12354}]}, 
    {Hue[
      NCache[
       Rational[4118, 4769], 0.8634933948416859]], AbsoluteThickness[0.25], 
     LineBox[{12354, 12355}]}, 
    {Hue[
      NCache[
       Rational[12355, 14307], 0.8635632906968617]], AbsoluteThickness[0.25], 
     LineBox[{12355, 12356}]}, 
    {Hue[
      NCache[
       Rational[12356, 14307], 0.8636331865520375]], AbsoluteThickness[0.25], 
     LineBox[{12356, 12357}]}, 
    {Hue[
      NCache[
       Rational[4119, 4769], 0.8637030824072133]], AbsoluteThickness[0.25], 
     LineBox[{12357, 12358}]}, 
    {Hue[
      NCache[
       Rational[12358, 14307], 0.8637729782623891]], AbsoluteThickness[0.25], 
     LineBox[{12358, 12359}]}, 
    {Hue[
      NCache[
       Rational[12359, 14307], 0.8638428741175648]], AbsoluteThickness[0.25], 
     LineBox[{12359, 12360}]}, 
    {Hue[
      NCache[
       Rational[4120, 4769], 0.8639127699727406]], AbsoluteThickness[0.25], 
     LineBox[{12360, 12361}]}, 
    {Hue[
      NCache[
       Rational[12361, 14307], 0.8639826658279164]], AbsoluteThickness[0.25], 
     LineBox[{12361, 12362}]}, 
    {Hue[
      NCache[
       Rational[12362, 14307], 0.8640525616830922]], AbsoluteThickness[0.25], 
     LineBox[{12362, 12363}]}, 
    {Hue[
      NCache[
       Rational[4121, 4769], 0.864122457538268]], AbsoluteThickness[0.25], 
     LineBox[{12363, 12364}]}, 
    {Hue[
      NCache[
       Rational[12364, 14307], 0.8641923533934438]], AbsoluteThickness[0.25], 
     LineBox[{12364, 12365}]}, 
    {Hue[
      NCache[
       Rational[12365, 14307], 0.8642622492486196]], AbsoluteThickness[0.25], 
     LineBox[{12365, 12366}]}, 
    {Hue[
      NCache[
       Rational[4122, 4769], 0.8643321451037953]], AbsoluteThickness[0.25], 
     LineBox[{12366, 12367}]}, 
    {Hue[
      NCache[
       Rational[12367, 14307], 0.8644020409589711]], AbsoluteThickness[0.25], 
     LineBox[{12367, 12368}]}, 
    {Hue[
      NCache[
       Rational[12368, 14307], 0.8644719368141469]], AbsoluteThickness[0.25], 
     LineBox[{12368, 12369}]}, 
    {Hue[
      NCache[
       Rational[217, 251], 0.8645418326693227]], AbsoluteThickness[0.25], 
     LineBox[{12369, 12370}]}, 
    {Hue[
      NCache[
       Rational[12370, 14307], 0.8646117285244985]], AbsoluteThickness[0.25], 
     LineBox[{12370, 12371}]}, 
    {Hue[
      NCache[
       Rational[12371, 14307], 0.8646816243796743]], AbsoluteThickness[0.25], 
     LineBox[{12371, 12372}]}, 
    {Hue[
      NCache[
       Rational[4124, 4769], 0.86475152023485]], AbsoluteThickness[0.25], 
     LineBox[{12372, 12373}]}, 
    {Hue[
      NCache[
       Rational[12373, 14307], 0.8648214160900258]], AbsoluteThickness[0.25], 
     LineBox[{12373, 12374}]}, 
    {Hue[
      NCache[
       Rational[12374, 14307], 0.8648913119452016]], AbsoluteThickness[0.25], 
     LineBox[{12374, 12375}]}, 
    {Hue[
      NCache[
       Rational[4125, 4769], 0.8649612078003774]], AbsoluteThickness[0.25], 
     LineBox[{12375, 12376}]}, 
    {Hue[
      NCache[
       Rational[12376, 14307], 0.8650311036555532]], AbsoluteThickness[0.25], 
     LineBox[{12376, 12377}]}, 
    {Hue[
      NCache[
       Rational[12377, 14307], 0.865100999510729]], AbsoluteThickness[0.25], 
     LineBox[{12377, 12378}]}, 
    {Hue[
      NCache[
       Rational[4126, 4769], 0.8651708953659049]], AbsoluteThickness[0.25], 
     LineBox[{12378, 12379}]}, 
    {Hue[
      NCache[
       Rational[12379, 14307], 0.8652407912210806]], AbsoluteThickness[0.25], 
     LineBox[{12379, 12380}]}, 
    {Hue[
      NCache[
       Rational[12380, 14307], 0.8653106870762564]], AbsoluteThickness[0.25], 
     LineBox[{12380, 12381}]}, 
    {Hue[
      NCache[
       Rational[4127, 4769], 0.8653805829314322]], AbsoluteThickness[0.25], 
     LineBox[{12381, 12382}]}, 
    {Hue[
      NCache[
       Rational[12382, 14307], 0.865450478786608]], AbsoluteThickness[0.25], 
     LineBox[{12382, 12383}]}, 
    {Hue[
      NCache[
       Rational[12383, 14307], 0.8655203746417838]], AbsoluteThickness[0.25], 
     LineBox[{12383, 12384}]}, 
    {Hue[
      NCache[
       Rational[4128, 4769], 0.8655902704969596]], AbsoluteThickness[0.25], 
     LineBox[{12384, 12385}]}, 
    {Hue[
      NCache[
       Rational[12385, 14307], 0.8656601663521353]], AbsoluteThickness[0.25], 
     LineBox[{12385, 12386}]}, 
    {Hue[
      NCache[
       Rational[12386, 14307], 0.8657300622073111]], AbsoluteThickness[0.25], 
     LineBox[{12386, 12387}]}, 
    {Hue[
      NCache[
       Rational[4129, 4769], 0.8657999580624869]], AbsoluteThickness[0.25], 
     LineBox[{12387, 12388}]}, 
    {Hue[
      NCache[
       Rational[652, 753], 0.8658698539176627]], AbsoluteThickness[0.25], 
     LineBox[{12388, 12389}]}, 
    {Hue[
      NCache[
       Rational[12389, 14307], 0.8659397497728385]], AbsoluteThickness[0.25], 
     LineBox[{12389, 12390}]}, 
    {Hue[
      NCache[
       Rational[4130, 4769], 0.8660096456280143]], AbsoluteThickness[0.25], 
     LineBox[{12390, 12391}]}, 
    {Hue[
      NCache[
       Rational[12391, 14307], 0.86607954148319]], AbsoluteThickness[0.25], 
     LineBox[{12391, 12392}]}, 
    {Hue[
      NCache[
       Rational[12392, 14307], 0.8661494373383658]], AbsoluteThickness[0.25], 
     LineBox[{12392, 12393}]}, 
    {Hue[
      NCache[
       Rational[4131, 4769], 0.8662193331935416]], AbsoluteThickness[0.25], 
     LineBox[{12393, 12394}]}, 
    {Hue[
      NCache[
       Rational[12394, 14307], 0.8662892290487174]], AbsoluteThickness[0.25], 
     LineBox[{12394, 12395}]}, 
    {Hue[
      NCache[
       Rational[12395, 14307], 0.8663591249038932]], AbsoluteThickness[0.25], 
     LineBox[{12395, 12396}]}, 
    {Hue[
      NCache[
       Rational[4132, 4769], 0.866429020759069]], AbsoluteThickness[0.25], 
     LineBox[{12396, 12397}]}, 
    {Hue[
      NCache[
       Rational[12397, 14307], 0.8664989166142448]], AbsoluteThickness[0.25], 
     LineBox[{12397, 12398}]}, 
    {Hue[
      NCache[
       Rational[12398, 14307], 0.8665688124694205]], AbsoluteThickness[0.25], 
     LineBox[{12398, 12399}]}, 
    {Hue[
      NCache[
       Rational[4133, 4769], 0.8666387083245963]], AbsoluteThickness[0.25], 
     LineBox[{12399, 12400}]}, 
    {Hue[
      NCache[
       Rational[12400, 14307], 0.8667086041797721]], AbsoluteThickness[0.25], 
     LineBox[{12400, 12401}]}, 
    {Hue[
      NCache[
       Rational[12401, 14307], 0.8667785000349479]], AbsoluteThickness[0.25], 
     LineBox[{12401, 12402}]}, 
    {Hue[
      NCache[
       Rational[4134, 4769], 0.8668483958901237]], AbsoluteThickness[0.25], 
     LineBox[{12402, 12403}]}, 
    {Hue[
      NCache[
       Rational[12403, 14307], 0.8669182917452996]], AbsoluteThickness[0.25], 
     LineBox[{12403, 12404}]}, 
    {Hue[
      NCache[
       Rational[12404, 14307], 0.8669881876004752]], AbsoluteThickness[0.25], 
     LineBox[{12404, 12405}]}, 
    {Hue[
      NCache[
       Rational[4135, 4769], 0.867058083455651]], AbsoluteThickness[0.25], 
     LineBox[{12405, 12406}]}, 
    {Hue[
      NCache[
       Rational[12406, 14307], 0.8671279793108269]], AbsoluteThickness[0.25], 
     LineBox[{12406, 12407}]}, 
    {Hue[
      NCache[
       Rational[653, 753], 0.8671978751660027]], AbsoluteThickness[0.25], 
     LineBox[{12407, 12408}]}, 
    {Hue[
      NCache[
       Rational[4136, 4769], 0.8672677710211785]], AbsoluteThickness[0.25], 
     LineBox[{12408, 12409}]}, 
    {Hue[
      NCache[
       Rational[12409, 14307], 0.8673376668763543]], AbsoluteThickness[0.25], 
     LineBox[{12409, 12410}]}, 
    {Hue[
      NCache[
       Rational[12410, 14307], 0.86740756273153]], AbsoluteThickness[0.25], 
     LineBox[{12410, 12411}]}, 
    {Hue[
      NCache[
       Rational[4137, 4769], 0.8674774585867058]], AbsoluteThickness[0.25], 
     LineBox[{12411, 12412}]}, 
    {Hue[
      NCache[
       Rational[12412, 14307], 0.8675473544418816]], AbsoluteThickness[0.25], 
     LineBox[{12412, 12413}]}, 
    {Hue[
      NCache[
       Rational[12413, 14307], 0.8676172502970574]], AbsoluteThickness[0.25], 
     LineBox[{12413, 12414}]}, 
    {Hue[
      NCache[
       Rational[4138, 4769], 0.8676871461522332]], AbsoluteThickness[0.25], 
     LineBox[{12414, 12415}]}, 
    {Hue[
      NCache[
       Rational[12415, 14307], 0.867757042007409]], AbsoluteThickness[0.25], 
     LineBox[{12415, 12416}]}, 
    {Hue[
      NCache[
       Rational[12416, 14307], 0.8678269378625848]], AbsoluteThickness[0.25], 
     LineBox[{12416, 12417}]}, 
    {Hue[
      NCache[
       Rational[4139, 4769], 0.8678968337177605]], AbsoluteThickness[0.25], 
     LineBox[{12417, 12418}]}, 
    {Hue[
      NCache[
       Rational[12418, 14307], 0.8679667295729363]], AbsoluteThickness[0.25], 
     LineBox[{12418, 12419}]}, 
    {Hue[
      NCache[
       Rational[12419, 14307], 0.8680366254281121]], AbsoluteThickness[0.25], 
     LineBox[{12419, 12420}]}, 
    {Hue[
      NCache[
       Rational[4140, 4769], 0.8681065212832879]], AbsoluteThickness[0.25], 
     LineBox[{12420, 12421}]}, 
    {Hue[
      NCache[
       Rational[12421, 14307], 0.8681764171384637]], AbsoluteThickness[0.25], 
     LineBox[{12421, 12422}]}, 
    {Hue[
      NCache[
       Rational[12422, 14307], 0.8682463129936395]], AbsoluteThickness[0.25], 
     LineBox[{12422, 12423}]}, 
    {Hue[
      NCache[
       Rational[4141, 4769], 0.8683162088488152]], AbsoluteThickness[0.25], 
     LineBox[{12423, 12424}]}, 
    {Hue[
      NCache[
       Rational[12424, 14307], 0.868386104703991]], AbsoluteThickness[0.25], 
     LineBox[{12424, 12425}]}, 
    {Hue[
      NCache[
       Rational[12425, 14307], 0.8684560005591668]], AbsoluteThickness[0.25], 
     LineBox[{12425, 12426}]}, 
    {Hue[
      NCache[
       Rational[218, 251], 0.8685258964143426]], AbsoluteThickness[0.25], 
     LineBox[{12426, 12427}]}, 
    {Hue[
      NCache[
       Rational[12427, 14307], 0.8685957922695184]], AbsoluteThickness[0.25], 
     LineBox[{12427, 12428}]}, 
    {Hue[
      NCache[
       Rational[12428, 14307], 0.8686656881246942]], AbsoluteThickness[0.25], 
     LineBox[{12428, 12429}]}, 
    {Hue[
      NCache[
       Rational[4143, 4769], 0.8687355839798699]], AbsoluteThickness[0.25], 
     LineBox[{12429, 12430}]}, 
    {Hue[
      NCache[
       Rational[12430, 14307], 0.8688054798350457]], AbsoluteThickness[0.25], 
     LineBox[{12430, 12431}]}, 
    {Hue[
      NCache[
       Rational[12431, 14307], 0.8688753756902216]], AbsoluteThickness[0.25], 
     LineBox[{12431, 12432}]}, 
    {Hue[
      NCache[
       Rational[4144, 4769], 0.8689452715453974]], AbsoluteThickness[0.25], 
     LineBox[{12432, 12433}]}, 
    {Hue[
      NCache[
       Rational[12433, 14307], 0.8690151674005732]], AbsoluteThickness[0.25], 
     LineBox[{12433, 12434}]}, 
    {Hue[
      NCache[
       Rational[12434, 14307], 0.869085063255749]], AbsoluteThickness[0.25], 
     LineBox[{12434, 12435}]}, 
    {Hue[
      NCache[
       Rational[4145, 4769], 0.8691549591109248]], AbsoluteThickness[0.25], 
     LineBox[{12435, 12436}]}, 
    {Hue[
      NCache[
       Rational[12436, 14307], 0.8692248549661005]], AbsoluteThickness[0.25], 
     LineBox[{12436, 12437}]}, 
    {Hue[
      NCache[
       Rational[12437, 14307], 0.8692947508212763]], AbsoluteThickness[0.25], 
     LineBox[{12437, 12438}]}, 
    {Hue[
      NCache[
       Rational[4146, 4769], 0.8693646466764521]], AbsoluteThickness[0.25], 
     LineBox[{12438, 12439}]}, 
    {Hue[
      NCache[
       Rational[12439, 14307], 0.8694345425316279]], AbsoluteThickness[0.25], 
     LineBox[{12439, 12440}]}, 
    {Hue[
      NCache[
       Rational[12440, 14307], 0.8695044383868037]], AbsoluteThickness[0.25], 
     LineBox[{12440, 12441}]}, 
    {Hue[
      NCache[
       Rational[4147, 4769], 0.8695743342419795]], AbsoluteThickness[0.25], 
     LineBox[{12441, 12442}]}, 
    {Hue[
      NCache[
       Rational[12442, 14307], 0.8696442300971552]], AbsoluteThickness[0.25], 
     LineBox[{12442, 12443}]}, 
    {Hue[
      NCache[
       Rational[12443, 14307], 0.869714125952331]], AbsoluteThickness[0.25], 
     LineBox[{12443, 12444}]}, 
    {Hue[
      NCache[
       Rational[4148, 4769], 0.8697840218075068]], AbsoluteThickness[0.25], 
     LineBox[{12444, 12445}]}, 
    {Hue[
      NCache[
       Rational[655, 753], 0.8698539176626826]], AbsoluteThickness[0.25], 
     LineBox[{12445, 12446}]}, 
    {Hue[
      NCache[
       Rational[12446, 14307], 0.8699238135178584]], AbsoluteThickness[0.25], 
     LineBox[{12446, 12447}]}, 
    {Hue[
      NCache[
       Rational[4149, 4769], 0.8699937093730342]], AbsoluteThickness[0.25], 
     LineBox[{12447, 12448}]}, 
    {Hue[
      NCache[
       Rational[12448, 14307], 0.8700636052282099]], AbsoluteThickness[0.25], 
     LineBox[{12448, 12449}]}, 
    {Hue[
      NCache[
       Rational[12449, 14307], 0.8701335010833857]], AbsoluteThickness[0.25], 
     LineBox[{12449, 12450}]}, 
    {Hue[
      NCache[
       Rational[4150, 4769], 0.8702033969385615]], AbsoluteThickness[0.25], 
     LineBox[{12450, 12451}]}, 
    {Hue[
      NCache[
       Rational[12451, 14307], 0.8702732927937373]], AbsoluteThickness[0.25], 
     LineBox[{12451, 12452}]}, 
    {Hue[
      NCache[
       Rational[12452, 14307], 0.8703431886489131]], AbsoluteThickness[0.25], 
     LineBox[{12452, 12453}]}, 
    {Hue[
      NCache[
       Rational[4151, 4769], 0.8704130845040889]], AbsoluteThickness[0.25], 
     LineBox[{12453, 12454}]}, 
    {Hue[
      NCache[
       Rational[12454, 14307], 0.8704829803592647]], AbsoluteThickness[0.25], 
     LineBox[{12454, 12455}]}, 
    {Hue[
      NCache[
       Rational[12455, 14307], 0.8705528762144404]], AbsoluteThickness[0.25], 
     LineBox[{12455, 12456}]}, 
    {Hue[
      NCache[
       Rational[4152, 4769], 0.8706227720696162]], AbsoluteThickness[0.25], 
     LineBox[{12456, 12457}]}, 
    {Hue[
      NCache[
       Rational[12457, 14307], 0.870692667924792]], AbsoluteThickness[0.25], 
     LineBox[{12457, 12458}]}, 
    {Hue[
      NCache[
       Rational[12458, 14307], 0.8707625637799679]], AbsoluteThickness[0.25], 
     LineBox[{12458, 12459}]}, 
    {Hue[
      NCache[
       Rational[4153, 4769], 0.8708324596351437]], AbsoluteThickness[0.25], 
     LineBox[{12459, 12460}]}, 
    {Hue[
      NCache[
       Rational[12460, 14307], 0.8709023554903195]], AbsoluteThickness[0.25], 
     LineBox[{12460, 12461}]}, 
    {Hue[
      NCache[
       Rational[12461, 14307], 0.8709722513454952]], AbsoluteThickness[0.25], 
     LineBox[{12461, 12462}]}, 
    {Hue[
      NCache[
       Rational[4154, 4769], 0.871042147200671]], AbsoluteThickness[0.25], 
     LineBox[{12462, 12463}]}, 
    {Hue[
      NCache[
       Rational[12463, 14307], 0.8711120430558468]], AbsoluteThickness[0.25], 
     LineBox[{12463, 12464}]}, 
    {Hue[
      NCache[
       Rational[656, 753], 0.8711819389110226]], AbsoluteThickness[0.25], 
     LineBox[{12464, 12465}]}, 
    {Hue[
      NCache[
       Rational[4155, 4769], 0.8712518347661984]], AbsoluteThickness[0.25], 
     LineBox[{12465, 12466}]}, 
    {Hue[
      NCache[
       Rational[12466, 14307], 0.8713217306213742]], AbsoluteThickness[0.25], 
     LineBox[{12466, 12467}]}, 
    {Hue[
      NCache[
       Rational[12467, 14307], 0.8713916264765499]], AbsoluteThickness[0.25], 
     LineBox[{12467, 12468}]}, 
    {Hue[
      NCache[
       Rational[4156, 4769], 0.8714615223317257]], AbsoluteThickness[0.25], 
     LineBox[{12468, 12469}]}, 
    {Hue[
      NCache[
       Rational[12469, 14307], 0.8715314181869015]], AbsoluteThickness[0.25], 
     LineBox[{12469, 12470}]}, 
    {Hue[
      NCache[
       Rational[12470, 14307], 0.8716013140420773]], AbsoluteThickness[0.25], 
     LineBox[{12470, 12471}]}, 
    {Hue[
      NCache[
       Rational[4157, 4769], 0.8716712098972531]], AbsoluteThickness[0.25], 
     LineBox[{12471, 12472}]}, 
    {Hue[
      NCache[
       Rational[12472, 14307], 0.8717411057524289]], AbsoluteThickness[0.25], 
     LineBox[{12472, 12473}]}, 
    {Hue[
      NCache[
       Rational[12473, 14307], 0.8718110016076047]], AbsoluteThickness[0.25], 
     LineBox[{12473, 12474}]}, 
    {Hue[
      NCache[
       Rational[4158, 4769], 0.8718808974627804]], AbsoluteThickness[0.25], 
     LineBox[{12474, 12475}]}, 
    {Hue[
      NCache[
       Rational[12475, 14307], 0.8719507933179562]], AbsoluteThickness[0.25], 
     LineBox[{12475, 12476}]}, 
    {Hue[
      NCache[
       Rational[12476, 14307], 0.872020689173132]], AbsoluteThickness[0.25], 
     LineBox[{12476, 12477}]}, 
    {Hue[
      NCache[
       Rational[4159, 4769], 0.8720905850283078]], AbsoluteThickness[0.25], 
     LineBox[{12477, 12478}]}, 
    {Hue[
      NCache[
       Rational[12478, 14307], 0.8721604808834836]], AbsoluteThickness[0.25], 
     LineBox[{12478, 12479}]}, 
    {Hue[
      NCache[
       Rational[12479, 14307], 0.8722303767386594]], AbsoluteThickness[0.25], 
     LineBox[{12479, 12480}]}, 
    {Hue[
      NCache[
       Rational[4160, 4769], 0.8723002725938351]], AbsoluteThickness[0.25], 
     LineBox[{12480, 12481}]}, 
    {Hue[
      NCache[
       Rational[12481, 14307], 0.8723701684490109]], AbsoluteThickness[0.25], 
     LineBox[{12481, 12482}]}, 
    {Hue[
      NCache[
       Rational[12482, 14307], 0.8724400643041867]], AbsoluteThickness[0.25], 
     LineBox[{12482, 12483}]}, 
    {Hue[
      NCache[
       Rational[219, 251], 0.8725099601593626]], AbsoluteThickness[0.25], 
     LineBox[{12483, 12484}]}, 
    {Hue[
      NCache[
       Rational[12484, 14307], 0.8725798560145384]], AbsoluteThickness[0.25], 
     LineBox[{12484, 12485}]}, 
    {Hue[
      NCache[
       Rational[12485, 14307], 0.8726497518697142]], AbsoluteThickness[0.25], 
     LineBox[{12485, 12486}]}, 
    {Hue[
      NCache[
       Rational[4162, 4769], 0.87271964772489]], AbsoluteThickness[0.25], 
     LineBox[{12486, 12487}]}, 
    {Hue[
      NCache[
       Rational[12487, 14307], 0.8727895435800657]], AbsoluteThickness[0.25], 
     LineBox[{12487, 12488}]}, 
    {Hue[
      NCache[
       Rational[12488, 14307], 0.8728594394352415]], AbsoluteThickness[0.25], 
     LineBox[{12488, 12489}]}, 
    {Hue[
      NCache[
       Rational[4163, 4769], 0.8729293352904173]], AbsoluteThickness[0.25], 
     LineBox[{12489, 12490}]}, 
    {Hue[
      NCache[
       Rational[12490, 14307], 0.8729992311455931]], AbsoluteThickness[0.25], 
     LineBox[{12490, 12491}]}, 
    {Hue[
      NCache[
       Rational[12491, 14307], 0.8730691270007689]], AbsoluteThickness[0.25], 
     LineBox[{12491, 12492}]}, 
    {Hue[
      NCache[
       Rational[4164, 4769], 0.8731390228559447]], AbsoluteThickness[0.25], 
     LineBox[{12492, 12493}]}, 
    {Hue[
      NCache[
       Rational[12493, 14307], 0.8732089187111204]], AbsoluteThickness[0.25], 
     LineBox[{12493, 12494}]}, 
    {Hue[
      NCache[
       Rational[12494, 14307], 0.8732788145662962]], AbsoluteThickness[0.25], 
     LineBox[{12494, 12495}]}, 
    {Hue[
      NCache[
       Rational[4165, 4769], 0.873348710421472]], AbsoluteThickness[0.25], 
     LineBox[{12495, 12496}]}, 
    {Hue[
      NCache[
       Rational[12496, 14307], 0.8734186062766478]], AbsoluteThickness[0.25], 
     LineBox[{12496, 12497}]}, 
    {Hue[
      NCache[
       Rational[12497, 14307], 0.8734885021318236]], AbsoluteThickness[0.25], 
     LineBox[{12497, 12498}]}, 
    {Hue[
      NCache[
       Rational[4166, 4769], 0.8735583979869994]], AbsoluteThickness[0.25], 
     LineBox[{12498, 12499}]}, 
    {Hue[
      NCache[
       Rational[12499, 14307], 0.8736282938421751]], AbsoluteThickness[0.25], 
     LineBox[{12499, 12500}]}, 
    {Hue[
      NCache[
       Rational[12500, 14307], 0.8736981896973509]], AbsoluteThickness[0.25], 
     LineBox[{12500, 12501}]}, 
    {Hue[
      NCache[
       Rational[4167, 4769], 0.8737680855525267]], AbsoluteThickness[0.25], 
     LineBox[{12501, 12502}]}, 
    {Hue[
      NCache[
       Rational[658, 753], 0.8738379814077025]], AbsoluteThickness[0.25], 
     LineBox[{12502, 12503}]}, 
    {Hue[
      NCache[
       Rational[12503, 14307], 0.8739078772628783]], AbsoluteThickness[0.25], 
     LineBox[{12503, 12504}]}, 
    {Hue[
      NCache[
       Rational[4168, 4769], 0.8739777731180541]], AbsoluteThickness[0.25], 
     LineBox[{12504, 12505}]}, 
    {Hue[
      NCache[
       Rational[12505, 14307], 0.8740476689732299]], AbsoluteThickness[0.25], 
     LineBox[{12505, 12506}]}, 
    {Hue[
      NCache[
       Rational[12506, 14307], 0.8741175648284056]], AbsoluteThickness[0.25], 
     LineBox[{12506, 12507}]}, 
    {Hue[
      NCache[
       Rational[4169, 4769], 0.8741874606835814]], AbsoluteThickness[0.25], 
     LineBox[{12507, 12508}]}, 
    {Hue[
      NCache[
       Rational[12508, 14307], 0.8742573565387572]], AbsoluteThickness[0.25], 
     LineBox[{12508, 12509}]}, 
    {Hue[
      NCache[
       Rational[12509, 14307], 0.874327252393933]], AbsoluteThickness[0.25], 
     LineBox[{12509, 12510}]}, 
    {Hue[
      NCache[
       Rational[4170, 4769], 0.8743971482491089]], AbsoluteThickness[0.25], 
     LineBox[{12510, 12511}]}, 
    {Hue[
      NCache[
       Rational[12511, 14307], 0.8744670441042847]], AbsoluteThickness[0.25], 
     LineBox[{12511, 12512}]}, 
    {Hue[
      NCache[
       Rational[12512, 14307], 0.8745369399594604]], AbsoluteThickness[0.25], 
     LineBox[{12512, 12513}]}, 
    {Hue[
      NCache[
       Rational[4171, 4769], 0.8746068358146362]], AbsoluteThickness[0.25], 
     LineBox[{12513, 12514}]}, 
    {Hue[
      NCache[
       Rational[12514, 14307], 0.874676731669812]], AbsoluteThickness[0.25], 
     LineBox[{12514, 12515}]}, 
    {Hue[
      NCache[
       Rational[12515, 14307], 0.8747466275249878]], AbsoluteThickness[0.25], 
     LineBox[{12515, 12516}]}, 
    {Hue[
      NCache[
       Rational[4172, 4769], 0.8748165233801636]], AbsoluteThickness[0.25], 
     LineBox[{12516, 12517}]}, 
    {Hue[
      NCache[
       Rational[12517, 14307], 0.8748864192353394]], AbsoluteThickness[0.25], 
     LineBox[{12517, 12518}]}, 
    {Hue[
      NCache[
       Rational[12518, 14307], 0.8749563150905151]], AbsoluteThickness[0.25], 
     LineBox[{12518, 12519}]}, 
    {Hue[
      NCache[
       Rational[4173, 4769], 0.8750262109456909]], AbsoluteThickness[0.25], 
     LineBox[{12519, 12520}]}, 
    {Hue[
      NCache[
       Rational[12520, 14307], 0.8750961068008667]], AbsoluteThickness[0.25], 
     LineBox[{12520, 12521}]}, 
    {Hue[
      NCache[
       Rational[659, 753], 0.8751660026560425]], AbsoluteThickness[0.25], 
     LineBox[{12521, 12522}]}, 
    {Hue[
      NCache[
       Rational[4174, 4769], 0.8752358985112183]], AbsoluteThickness[0.25], 
     LineBox[{12522, 12523}]}, 
    {Hue[
      NCache[
       Rational[12523, 14307], 0.8753057943663941]], AbsoluteThickness[0.25], 
     LineBox[{12523, 12524}]}, 
    {Hue[
      NCache[
       Rational[12524, 14307], 0.8753756902215699]], AbsoluteThickness[0.25], 
     LineBox[{12524, 12525}]}, 
    {Hue[
      NCache[
       Rational[4175, 4769], 0.8754455860767456]], AbsoluteThickness[0.25], 
     LineBox[{12525, 12526}]}, 
    {Hue[
      NCache[
       Rational[12526, 14307], 0.8755154819319214]], AbsoluteThickness[0.25], 
     LineBox[{12526, 12527}]}, 
    {Hue[
      NCache[
       Rational[12527, 14307], 0.8755853777870972]], AbsoluteThickness[0.25], 
     LineBox[{12527, 12528}]}, 
    {Hue[
      NCache[
       Rational[4176, 4769], 0.875655273642273]], AbsoluteThickness[0.25], 
     LineBox[{12528, 12529}]}, 
    {Hue[
      NCache[
       Rational[12529, 14307], 0.8757251694974488]], AbsoluteThickness[0.25], 
     LineBox[{12529, 12530}]}, 
    {Hue[
      NCache[
       Rational[12530, 14307], 0.8757950653526246]], AbsoluteThickness[0.25], 
     LineBox[{12530, 12531}]}, 
    {Hue[
      NCache[
       Rational[4177, 4769], 0.8758649612078003]], AbsoluteThickness[0.25], 
     LineBox[{12531, 12532}]}, 
    {Hue[
      NCache[
       Rational[12532, 14307], 0.8759348570629761]], AbsoluteThickness[0.25], 
     LineBox[{12532, 12533}]}, 
    {Hue[
      NCache[
       Rational[12533, 14307], 0.8760047529181519]], AbsoluteThickness[0.25], 
     LineBox[{12533, 12534}]}, 
    {Hue[
      NCache[
       Rational[4178, 4769], 0.8760746487733277]], AbsoluteThickness[0.25], 
     LineBox[{12534, 12535}]}, 
    {Hue[
      NCache[
       Rational[12535, 14307], 0.8761445446285036]], AbsoluteThickness[0.25], 
     LineBox[{12535, 12536}]}, 
    {Hue[
      NCache[
       Rational[12536, 14307], 0.8762144404836794]], AbsoluteThickness[0.25], 
     LineBox[{12536, 12537}]}, 
    {Hue[
      NCache[
       Rational[4179, 4769], 0.876284336338855]], AbsoluteThickness[0.25], 
     LineBox[{12537, 12538}]}, 
    {Hue[
      NCache[
       Rational[12538, 14307], 0.8763542321940309]], AbsoluteThickness[0.25], 
     LineBox[{12538, 12539}]}, 
    {Hue[
      NCache[
       Rational[12539, 14307], 0.8764241280492067]], AbsoluteThickness[0.25], 
     LineBox[{12539, 12540}]}, 
    {Hue[
      NCache[
       Rational[220, 251], 0.8764940239043825]], AbsoluteThickness[0.25], 
     LineBox[{12540, 12541}]}, 
    {Hue[
      NCache[
       Rational[12541, 14307], 0.8765639197595583]], AbsoluteThickness[0.25], 
     LineBox[{12541, 12542}]}, 
    {Hue[
      NCache[
       Rational[12542, 14307], 0.8766338156147341]], AbsoluteThickness[0.25], 
     LineBox[{12542, 12543}]}, 
    {Hue[
      NCache[
       Rational[4181, 4769], 0.8767037114699099]], AbsoluteThickness[0.25], 
     LineBox[{12543, 12544}]}, 
    {Hue[
      NCache[
       Rational[12544, 14307], 0.8767736073250856]], AbsoluteThickness[0.25], 
     LineBox[{12544, 12545}]}, 
    {Hue[
      NCache[
       Rational[12545, 14307], 0.8768435031802614]], AbsoluteThickness[0.25], 
     LineBox[{12545, 12546}]}, 
    {Hue[
      NCache[
       Rational[4182, 4769], 0.8769133990354372]], AbsoluteThickness[0.25], 
     LineBox[{12546, 12547}]}, 
    {Hue[
      NCache[
       Rational[12547, 14307], 0.876983294890613]], AbsoluteThickness[0.25], 
     LineBox[{12547, 12548}]}, 
    {Hue[
      NCache[
       Rational[12548, 14307], 0.8770531907457888]], AbsoluteThickness[0.25], 
     LineBox[{12548, 12549}]}, 
    {Hue[
      NCache[
       Rational[4183, 4769], 0.8771230866009646]], AbsoluteThickness[0.25], 
     LineBox[{12549, 12550}]}, 
    {Hue[
      NCache[
       Rational[50, 57], 0.8771929824561403]], AbsoluteThickness[0.25], 
     LineBox[{12550, 12551}]}, 
    {Hue[
      NCache[
       Rational[12551, 14307], 0.8772628783113161]], AbsoluteThickness[0.25], 
     LineBox[{12551, 12552}]}, 
    {Hue[
      NCache[
       Rational[4184, 4769], 0.8773327741664919]], AbsoluteThickness[0.25], 
     LineBox[{12552, 12553}]}, 
    {Hue[
      NCache[
       Rational[12553, 14307], 0.8774026700216677]], AbsoluteThickness[0.25], 
     LineBox[{12553, 12554}]}, 
    {Hue[
      NCache[
       Rational[12554, 14307], 0.8774725658768435]], AbsoluteThickness[0.25], 
     LineBox[{12554, 12555}]}, 
    {Hue[
      NCache[
       Rational[4185, 4769], 0.8775424617320193]], AbsoluteThickness[0.25], 
     LineBox[{12555, 12556}]}, 
    {Hue[
      NCache[
       Rational[12556, 14307], 0.877612357587195]], AbsoluteThickness[0.25], 
     LineBox[{12556, 12557}]}, 
    {Hue[
      NCache[
       Rational[12557, 14307], 0.8776822534423708]], AbsoluteThickness[0.25], 
     LineBox[{12557, 12558}]}, 
    {Hue[
      NCache[
       Rational[4186, 4769], 0.8777521492975466]], AbsoluteThickness[0.25], 
     LineBox[{12558, 12559}]}, 
    {Hue[
      NCache[
       Rational[661, 753], 0.8778220451527224]], AbsoluteThickness[0.25], 
     LineBox[{12559, 12560}]}, 
    {Hue[
      NCache[
       Rational[12560, 14307], 0.8778919410078982]], AbsoluteThickness[0.25], 
     LineBox[{12560, 12561}]}, 
    {Hue[
      NCache[
       Rational[4187, 4769], 0.877961836863074]], AbsoluteThickness[0.25], 
     LineBox[{12561, 12562}]}, 
    {Hue[
      NCache[
       Rational[12562, 14307], 0.8780317327182499]], AbsoluteThickness[0.25], 
     LineBox[{12562, 12563}]}, 
    {Hue[
      NCache[
       Rational[12563, 14307], 0.8781016285734256]], AbsoluteThickness[0.25], 
     LineBox[{12563, 12564}]}, 
    {Hue[
      NCache[
       Rational[4188, 4769], 0.8781715244286014]], AbsoluteThickness[0.25], 
     LineBox[{12564, 12565}]}, 
    {Hue[
      NCache[
       Rational[12565, 14307], 0.8782414202837772]], AbsoluteThickness[0.25], 
     LineBox[{12565, 12566}]}, 
    {Hue[
      NCache[
       Rational[12566, 14307], 0.878311316138953]], AbsoluteThickness[0.25], 
     LineBox[{12566, 12567}]}, 
    {Hue[
      NCache[
       Rational[4189, 4769], 0.8783812119941288]], AbsoluteThickness[0.25], 
     LineBox[{12567, 12568}]}, 
    {Hue[
      NCache[
       Rational[12568, 14307], 0.8784511078493046]], AbsoluteThickness[0.25], 
     LineBox[{12568, 12569}]}, 
    {Hue[
      NCache[
       Rational[12569, 14307], 0.8785210037044803]], AbsoluteThickness[0.25], 
     LineBox[{12569, 12570}]}, 
    {Hue[
      NCache[
       Rational[4190, 4769], 0.8785908995596561]], AbsoluteThickness[0.25], 
     LineBox[{12570, 12571}]}, 
    {Hue[
      NCache[
       Rational[12571, 14307], 0.8786607954148319]], AbsoluteThickness[0.25], 
     LineBox[{12571, 12572}]}, 
    {Hue[
      NCache[
       Rational[12572, 14307], 0.8787306912700077]], AbsoluteThickness[0.25], 
     LineBox[{12572, 12573}]}, 
    {Hue[
      NCache[
       Rational[4191, 4769], 0.8788005871251835]], AbsoluteThickness[0.25], 
     LineBox[{12573, 12574}]}, 
    {Hue[
      NCache[
       Rational[12574, 14307], 0.8788704829803593]], AbsoluteThickness[0.25], 
     LineBox[{12574, 12575}]}, 
    {Hue[
      NCache[
       Rational[12575, 14307], 0.8789403788355351]], AbsoluteThickness[0.25], 
     LineBox[{12575, 12576}]}, 
    {Hue[
      NCache[
       Rational[4192, 4769], 0.8790102746907108]], AbsoluteThickness[0.25], 
     LineBox[{12576, 12577}]}, 
    {Hue[
      NCache[
       Rational[12577, 14307], 0.8790801705458866]], AbsoluteThickness[0.25], 
     LineBox[{12577, 12578}]}, 
    {Hue[
      NCache[
       Rational[662, 753], 0.8791500664010624]], AbsoluteThickness[0.25], 
     LineBox[{12578, 12579}]}, 
    {Hue[
      NCache[
       Rational[4193, 4769], 0.8792199622562382]], AbsoluteThickness[0.25], 
     LineBox[{12579, 12580}]}, 
    {Hue[
      NCache[
       Rational[12580, 14307], 0.879289858111414]], AbsoluteThickness[0.25], 
     LineBox[{12580, 12581}]}, 
    {Hue[
      NCache[
       Rational[12581, 14307], 0.8793597539665898]], AbsoluteThickness[0.25], 
     LineBox[{12581, 12582}]}, 
    {Hue[
      NCache[
       Rational[4194, 4769], 0.8794296498217655]], AbsoluteThickness[0.25], 
     LineBox[{12582, 12583}]}, 
    {Hue[
      NCache[
       Rational[12583, 14307], 0.8794995456769413]], AbsoluteThickness[0.25], 
     LineBox[{12583, 12584}]}, 
    {Hue[
      NCache[
       Rational[12584, 14307], 0.8795694415321171]], AbsoluteThickness[0.25], 
     LineBox[{12584, 12585}]}, 
    {Hue[
      NCache[
       Rational[4195, 4769], 0.8796393373872929]], AbsoluteThickness[0.25], 
     LineBox[{12585, 12586}]}, 
    {Hue[
      NCache[
       Rational[12586, 14307], 0.8797092332424687]], AbsoluteThickness[0.25], 
     LineBox[{12586, 12587}]}, 
    {Hue[
      NCache[
       Rational[12587, 14307], 0.8797791290976446]], AbsoluteThickness[0.25], 
     LineBox[{12587, 12588}]}, 
    {Hue[
      NCache[
       Rational[4196, 4769], 0.8798490249528202]], AbsoluteThickness[0.25], 
     LineBox[{12588, 12589}]}, 
    {Hue[
      NCache[
       Rational[12589, 14307], 0.879918920807996]], AbsoluteThickness[0.25], 
     LineBox[{12589, 12590}]}, 
    {Hue[
      NCache[
       Rational[12590, 14307], 0.8799888166631719]], AbsoluteThickness[0.25], 
     LineBox[{12590, 12591}]}, 
    {Hue[
      NCache[
       Rational[4197, 4769], 0.8800587125183477]], AbsoluteThickness[0.25], 
     LineBox[{12591, 12592}]}, 
    {Hue[
      NCache[
       Rational[12592, 14307], 0.8801286083735235]], AbsoluteThickness[0.25], 
     LineBox[{12592, 12593}]}, 
    {Hue[
      NCache[
       Rational[12593, 14307], 0.8801985042286993]], AbsoluteThickness[0.25], 
     LineBox[{12593, 12594}]}, 
    {Hue[
      NCache[
       Rational[4198, 4769], 0.8802684000838751]], AbsoluteThickness[0.25], 
     LineBox[{12594, 12595}]}, 
    {Hue[
      NCache[
       Rational[12595, 14307], 0.8803382959390508]], AbsoluteThickness[0.25], 
     LineBox[{12595, 12596}]}, 
    {Hue[
      NCache[
       Rational[12596, 14307], 0.8804081917942266]], AbsoluteThickness[0.25], 
     LineBox[{12596, 12597}]}, 
    {Hue[
      NCache[
       Rational[221, 251], 0.8804780876494024]], AbsoluteThickness[0.25], 
     LineBox[{12597, 12598}]}, 
    {Hue[
      NCache[
       Rational[12598, 14307], 0.8805479835045782]], AbsoluteThickness[0.25], 
     LineBox[{12598, 12599}]}, 
    {Hue[
      NCache[
       Rational[12599, 14307], 0.880617879359754]], AbsoluteThickness[0.25], 
     LineBox[{12599, 12600}]}, 
    {Hue[
      NCache[
       Rational[4200, 4769], 0.8806877752149298]], AbsoluteThickness[0.25], 
     LineBox[{12600, 12601}]}, 
    {Hue[
      NCache[
       Rational[12601, 14307], 0.8807576710701055]], AbsoluteThickness[0.25], 
     LineBox[{12601, 12602}]}, 
    {Hue[
      NCache[
       Rational[12602, 14307], 0.8808275669252813]], AbsoluteThickness[0.25], 
     LineBox[{12602, 12603}]}, 
    {Hue[
      NCache[
       Rational[4201, 4769], 0.8808974627804571]], AbsoluteThickness[0.25], 
     LineBox[{12603, 12604}]}, 
    {Hue[
      NCache[
       Rational[12604, 14307], 0.8809673586356329]], AbsoluteThickness[0.25], 
     LineBox[{12604, 12605}]}, 
    {Hue[
      NCache[
       Rational[12605, 14307], 0.8810372544908087]], AbsoluteThickness[0.25], 
     LineBox[{12605, 12606}]}, 
    {Hue[
      NCache[
       Rational[4202, 4769], 0.8811071503459845]], AbsoluteThickness[0.25], 
     LineBox[{12606, 12607}]}, 
    {Hue[
      NCache[
       Rational[12607, 14307], 0.8811770462011602]], AbsoluteThickness[0.25], 
     LineBox[{12607, 12608}]}, 
    {Hue[
      NCache[
       Rational[12608, 14307], 0.881246942056336]], AbsoluteThickness[0.25], 
     LineBox[{12608, 12609}]}, 
    {Hue[
      NCache[
       Rational[4203, 4769], 0.8813168379115118]], AbsoluteThickness[0.25], 
     LineBox[{12609, 12610}]}, 
    {Hue[
      NCache[
       Rational[12610, 14307], 0.8813867337666876]], AbsoluteThickness[0.25], 
     LineBox[{12610, 12611}]}, 
    {Hue[
      NCache[
       Rational[12611, 14307], 0.8814566296218634]], AbsoluteThickness[0.25], 
     LineBox[{12611, 12612}]}, 
    {Hue[
      NCache[
       Rational[4204, 4769], 0.8815265254770392]], AbsoluteThickness[0.25], 
     LineBox[{12612, 12613}]}, 
    {Hue[
      NCache[
       Rational[12613, 14307], 0.881596421332215]], AbsoluteThickness[0.25], 
     LineBox[{12613, 12614}]}, 
    {Hue[
      NCache[
       Rational[12614, 14307], 0.8816663171873907]], AbsoluteThickness[0.25], 
     LineBox[{12614, 12615}]}, 
    {Hue[
      NCache[
       Rational[4205, 4769], 0.8817362130425666]], AbsoluteThickness[0.25], 
     LineBox[{12615, 12616}]}, 
    {Hue[
      NCache[
       Rational[664, 753], 0.8818061088977424]], AbsoluteThickness[0.25], 
     LineBox[{12616, 12617}]}, 
    {Hue[
      NCache[
       Rational[12617, 14307], 0.8818760047529182]], AbsoluteThickness[0.25], 
     LineBox[{12617, 12618}]}, 
    {Hue[
      NCache[
       Rational[4206, 4769], 0.881945900608094]], AbsoluteThickness[0.25], 
     LineBox[{12618, 12619}]}, 
    {Hue[
      NCache[
       Rational[12619, 14307], 0.8820157964632698]], AbsoluteThickness[0.25], 
     LineBox[{12619, 12620}]}, 
    {Hue[
      NCache[
       Rational[12620, 14307], 0.8820856923184455]], AbsoluteThickness[0.25], 
     LineBox[{12620, 12621}]}, 
    {Hue[
      NCache[
       Rational[4207, 4769], 0.8821555881736213]], AbsoluteThickness[0.25], 
     LineBox[{12621, 12622}]}, 
    {Hue[
      NCache[
       Rational[12622, 14307], 0.8822254840287971]], AbsoluteThickness[0.25], 
     LineBox[{12622, 12623}]}, 
    {Hue[
      NCache[
       Rational[12623, 14307], 0.8822953798839729]], AbsoluteThickness[0.25], 
     LineBox[{12623, 12624}]}, 
    {Hue[
      NCache[
       Rational[4208, 4769], 0.8823652757391487]], AbsoluteThickness[0.25], 
     LineBox[{12624, 12625}]}, 
    {Hue[
      NCache[
       Rational[12625, 14307], 0.8824351715943245]], AbsoluteThickness[0.25], 
     LineBox[{12625, 12626}]}, 
    {Hue[
      NCache[
       Rational[12626, 14307], 0.8825050674495002]], AbsoluteThickness[0.25], 
     LineBox[{12626, 12627}]}, 
    {Hue[
      NCache[
       Rational[4209, 4769], 0.882574963304676]], AbsoluteThickness[0.25], 
     LineBox[{12627, 12628}]}, 
    {Hue[
      NCache[
       Rational[12628, 14307], 0.8826448591598518]], AbsoluteThickness[0.25], 
     LineBox[{12628, 12629}]}, 
    {Hue[
      NCache[
       Rational[12629, 14307], 0.8827147550150276]], AbsoluteThickness[0.25], 
     LineBox[{12629, 12630}]}, 
    {Hue[
      NCache[
       Rational[4210, 4769], 0.8827846508702034]], AbsoluteThickness[0.25], 
     LineBox[{12630, 12631}]}, 
    {Hue[
      NCache[
       Rational[12631, 14307], 0.8828545467253792]], AbsoluteThickness[0.25], 
     LineBox[{12631, 12632}]}, 
    {Hue[
      NCache[
       Rational[12632, 14307], 0.882924442580555]], AbsoluteThickness[0.25], 
     LineBox[{12632, 12633}]}, 
    {Hue[
      NCache[
       Rational[4211, 4769], 0.8829943384357307]], AbsoluteThickness[0.25], 
     LineBox[{12633, 12634}]}, 
    {Hue[
      NCache[
       Rational[12634, 14307], 0.8830642342909065]], AbsoluteThickness[0.25], 
     LineBox[{12634, 12635}]}, 
    {Hue[
      NCache[
       Rational[665, 753], 0.8831341301460823]], AbsoluteThickness[0.25], 
     LineBox[{12635, 12636}]}, 
    {Hue[
      NCache[
       Rational[4212, 4769], 0.8832040260012581]], AbsoluteThickness[0.25], 
     LineBox[{12636, 12637}]}, 
    {Hue[
      NCache[
       Rational[12637, 14307], 0.8832739218564339]], AbsoluteThickness[0.25], 
     LineBox[{12637, 12638}]}, 
    {Hue[
      NCache[
       Rational[12638, 14307], 0.8833438177116097]], AbsoluteThickness[0.25], 
     LineBox[{12638, 12639}]}, 
    {Hue[
      NCache[
       Rational[4213, 4769], 0.8834137135667854]], AbsoluteThickness[0.25], 
     LineBox[{12639, 12640}]}, 
    {Hue[
      NCache[
       Rational[12640, 14307], 0.8834836094219612]], AbsoluteThickness[0.25], 
     LineBox[{12640, 12641}]}, 
    {Hue[
      NCache[
       Rational[12641, 14307], 0.883553505277137]], AbsoluteThickness[0.25], 
     LineBox[{12641, 12642}]}, 
    {Hue[
      NCache[
       Rational[4214, 4769], 0.8836234011323129]], AbsoluteThickness[0.25], 
     LineBox[{12642, 12643}]}, 
    {Hue[
      NCache[
       Rational[12643, 14307], 0.8836932969874887]], AbsoluteThickness[0.25], 
     LineBox[{12643, 12644}]}, 
    {Hue[
      NCache[
       Rational[12644, 14307], 0.8837631928426645]], AbsoluteThickness[0.25], 
     LineBox[{12644, 12645}]}, 
    {Hue[
      NCache[
       Rational[4215, 4769], 0.8838330886978402]], AbsoluteThickness[0.25], 
     LineBox[{12645, 12646}]}, 
    {Hue[
      NCache[
       Rational[12646, 14307], 0.883902984553016]], AbsoluteThickness[0.25], 
     LineBox[{12646, 12647}]}, 
    {Hue[
      NCache[
       Rational[12647, 14307], 0.8839728804081918]], AbsoluteThickness[0.25], 
     LineBox[{12647, 12648}]}, 
    {Hue[
      NCache[
       Rational[4216, 4769], 0.8840427762633676]], AbsoluteThickness[0.25], 
     LineBox[{12648, 12649}]}, 
    {Hue[
      NCache[
       Rational[12649, 14307], 0.8841126721185434]], AbsoluteThickness[0.25], 
     LineBox[{12649, 12650}]}, 
    {Hue[
      NCache[
       Rational[12650, 14307], 0.8841825679737192]], AbsoluteThickness[0.25], 
     LineBox[{12650, 12651}]}, 
    {Hue[
      NCache[
       Rational[4217, 4769], 0.884252463828895]], AbsoluteThickness[0.25], 
     LineBox[{12651, 12652}]}, 
    {Hue[
      NCache[
       Rational[12652, 14307], 0.8843223596840707]], AbsoluteThickness[0.25], 
     LineBox[{12652, 12653}]}, 
    {Hue[
      NCache[
       Rational[12653, 14307], 0.8843922555392465]], AbsoluteThickness[0.25], 
     LineBox[{12653, 12654}]}, 
    {Hue[
      NCache[
       Rational[222, 251], 0.8844621513944223]], AbsoluteThickness[0.25], 
     LineBox[{12654, 12655}]}, 
    {Hue[
      NCache[
       Rational[12655, 14307], 0.8845320472495981]], AbsoluteThickness[0.25], 
     LineBox[{12655, 12656}]}, 
    {Hue[
      NCache[
       Rational[12656, 14307], 0.8846019431047739]], AbsoluteThickness[0.25], 
     LineBox[{12656, 12657}]}, 
    {Hue[
      NCache[
       Rational[4219, 4769], 0.8846718389599497]], AbsoluteThickness[0.25], 
     LineBox[{12657, 12658}]}, 
    {Hue[
      NCache[
       Rational[12658, 14307], 0.8847417348151254]], AbsoluteThickness[0.25], 
     LineBox[{12658, 12659}]}, 
    {Hue[
      NCache[
       Rational[12659, 14307], 0.8848116306703012]], AbsoluteThickness[0.25], 
     LineBox[{12659, 12660}]}, 
    {Hue[
      NCache[
       Rational[4220, 4769], 0.884881526525477]], AbsoluteThickness[0.25], 
     LineBox[{12660, 12661}]}, 
    {Hue[
      NCache[
       Rational[12661, 14307], 0.8849514223806528]], AbsoluteThickness[0.25], 
     LineBox[{12661, 12662}]}, 
    {Hue[
      NCache[
       Rational[12662, 14307], 0.8850213182358286]], AbsoluteThickness[0.25], 
     LineBox[{12662, 12663}]}, 
    {Hue[
      NCache[
       Rational[4221, 4769], 0.8850912140910044]], AbsoluteThickness[0.25], 
     LineBox[{12663, 12664}]}, 
    {Hue[
      NCache[
       Rational[12664, 14307], 0.8851611099461802]], AbsoluteThickness[0.25], 
     LineBox[{12664, 12665}]}, 
    {Hue[
      NCache[
       Rational[12665, 14307], 0.8852310058013559]], AbsoluteThickness[0.25], 
     LineBox[{12665, 12666}]}, 
    {Hue[
      NCache[
       Rational[4222, 4769], 0.8853009016565317]], AbsoluteThickness[0.25], 
     LineBox[{12666, 12667}]}, 
    {Hue[
      NCache[
       Rational[12667, 14307], 0.8853707975117076]], AbsoluteThickness[0.25], 
     LineBox[{12667, 12668}]}, 
    {Hue[
      NCache[
       Rational[12668, 14307], 0.8854406933668834]], AbsoluteThickness[0.25], 
     LineBox[{12668, 12669}]}, 
    {Hue[
      NCache[
       Rational[4223, 4769], 0.8855105892220592]], AbsoluteThickness[0.25], 
     LineBox[{12669, 12670}]}, 
    {Hue[
      NCache[
       Rational[12670, 14307], 0.885580485077235]], AbsoluteThickness[0.25], 
     LineBox[{12670, 12671}]}, 
    {Hue[
      NCache[
       Rational[12671, 14307], 0.8856503809324107]], AbsoluteThickness[0.25], 
     LineBox[{12671, 12672}]}, 
    {Hue[
      NCache[
       Rational[4224, 4769], 0.8857202767875865]], AbsoluteThickness[0.25], 
     LineBox[{12672, 12673}]}, 
    {Hue[
      NCache[
       Rational[667, 753], 0.8857901726427623]], AbsoluteThickness[0.25], 
     LineBox[{12673, 12674}]}, 
    {Hue[
      NCache[
       Rational[12674, 14307], 0.8858600684979381]], AbsoluteThickness[0.25], 
     LineBox[{12674, 12675}]}, 
    {Hue[
      NCache[
       Rational[4225, 4769], 0.8859299643531139]], AbsoluteThickness[0.25], 
     LineBox[{12675, 12676}]}, 
    {Hue[
      NCache[
       Rational[12676, 14307], 0.8859998602082897]], AbsoluteThickness[0.25], 
     LineBox[{12676, 12677}]}, 
    {Hue[
      NCache[
       Rational[12677, 14307], 0.8860697560634654]], AbsoluteThickness[0.25], 
     LineBox[{12677, 12678}]}, 
    {Hue[
      NCache[
       Rational[4226, 4769], 0.8861396519186412]], AbsoluteThickness[0.25], 
     LineBox[{12678, 12679}]}, 
    {Hue[
      NCache[
       Rational[12679, 14307], 0.886209547773817]], AbsoluteThickness[0.25], 
     LineBox[{12679, 12680}]}, 
    {Hue[
      NCache[
       Rational[12680, 14307], 0.8862794436289928]], AbsoluteThickness[0.25], 
     LineBox[{12680, 12681}]}, 
    {Hue[
      NCache[
       Rational[4227, 4769], 0.8863493394841686]], AbsoluteThickness[0.25], 
     LineBox[{12681, 12682}]}, 
    {Hue[
      NCache[
       Rational[12682, 14307], 0.8864192353393444]], AbsoluteThickness[0.25], 
     LineBox[{12682, 12683}]}, 
    {Hue[
      NCache[
       Rational[12683, 14307], 0.8864891311945202]], AbsoluteThickness[0.25], 
     LineBox[{12683, 12684}]}, 
    {Hue[
      NCache[
       Rational[4228, 4769], 0.8865590270496959]], AbsoluteThickness[0.25], 
     LineBox[{12684, 12685}]}, 
    {Hue[
      NCache[
       Rational[12685, 14307], 0.8866289229048717]], AbsoluteThickness[0.25], 
     LineBox[{12685, 12686}]}, 
    {Hue[
      NCache[
       Rational[12686, 14307], 0.8866988187600475]], AbsoluteThickness[0.25], 
     LineBox[{12686, 12687}]}, 
    {Hue[
      NCache[
       Rational[4229, 4769], 0.8867687146152233]], AbsoluteThickness[0.25], 
     LineBox[{12687, 12688}]}, 
    {Hue[
      NCache[
       Rational[12688, 14307], 0.8868386104703991]], AbsoluteThickness[0.25], 
     LineBox[{12688, 12689}]}, 
    {Hue[
      NCache[
       Rational[12689, 14307], 0.8869085063255749]], AbsoluteThickness[0.25], 
     LineBox[{12689, 12690}]}, 
    {Hue[
      NCache[
       Rational[4230, 4769], 0.8869784021807506]], AbsoluteThickness[0.25], 
     LineBox[{12690, 12691}]}, 
    {Hue[
      NCache[
       Rational[12691, 14307], 0.8870482980359264]], AbsoluteThickness[0.25], 
     LineBox[{12691, 12692}]}, 
    {Hue[
      NCache[
       Rational[668, 753], 0.8871181938911022]], AbsoluteThickness[0.25], 
     LineBox[{12692, 12693}]}, 
    {Hue[
      NCache[
       Rational[4231, 4769], 0.887188089746278]], AbsoluteThickness[0.25], 
     LineBox[{12693, 12694}]}, 
    {Hue[
      NCache[
       Rational[12694, 14307], 0.8872579856014539]], AbsoluteThickness[0.25], 
     LineBox[{12694, 12695}]}, 
    {Hue[
      NCache[
       Rational[12695, 14307], 0.8873278814566297]], AbsoluteThickness[0.25], 
     LineBox[{12695, 12696}]}, 
    {Hue[
      NCache[
       Rational[4232, 4769], 0.8873977773118054]], AbsoluteThickness[0.25], 
     LineBox[{12696, 12697}]}, 
    {Hue[
      NCache[
       Rational[12697, 14307], 0.8874676731669812]], AbsoluteThickness[0.25], 
     LineBox[{12697, 12698}]}, 
    {Hue[
      NCache[
       Rational[12698, 14307], 0.887537569022157]], AbsoluteThickness[0.25], 
     LineBox[{12698, 12699}]}, 
    {Hue[
      NCache[
       Rational[4233, 4769], 0.8876074648773328]], AbsoluteThickness[0.25], 
     LineBox[{12699, 12700}]}, 
    {Hue[
      NCache[
       Rational[12700, 14307], 0.8876773607325086]], AbsoluteThickness[0.25], 
     LineBox[{12700, 12701}]}, 
    {Hue[
      NCache[
       Rational[12701, 14307], 0.8877472565876844]], AbsoluteThickness[0.25], 
     LineBox[{12701, 12702}]}, 
    {Hue[
      NCache[
       Rational[4234, 4769], 0.8878171524428602]], AbsoluteThickness[0.25], 
     LineBox[{12702, 12703}]}, 
    {Hue[
      NCache[
       Rational[12703, 14307], 0.8878870482980359]], AbsoluteThickness[0.25], 
     LineBox[{12703, 12704}]}, 
    {Hue[
      NCache[
       Rational[12704, 14307], 0.8879569441532117]], AbsoluteThickness[0.25], 
     LineBox[{12704, 12705}]}, 
    {Hue[
      NCache[
       Rational[4235, 4769], 0.8880268400083875]], AbsoluteThickness[0.25], 
     LineBox[{12705, 12706}]}, 
    {Hue[
      NCache[
       Rational[12706, 14307], 0.8880967358635633]], AbsoluteThickness[0.25], 
     LineBox[{12706, 12707}]}, 
    {Hue[
      NCache[
       Rational[12707, 14307], 0.8881666317187391]], AbsoluteThickness[0.25], 
     LineBox[{12707, 12708}]}, 
    {Hue[
      NCache[
       Rational[4236, 4769], 0.8882365275739149]], AbsoluteThickness[0.25], 
     LineBox[{12708, 12709}]}, 
    {Hue[
      NCache[
       Rational[12709, 14307], 0.8883064234290906]], AbsoluteThickness[0.25], 
     LineBox[{12709, 12710}]}, 
    {Hue[
      NCache[
       Rational[12710, 14307], 0.8883763192842664]], AbsoluteThickness[0.25], 
     LineBox[{12710, 12711}]}, 
    {Hue[
      NCache[
       Rational[223, 251], 0.8884462151394422]], AbsoluteThickness[0.25], 
     LineBox[{12711, 12712}]}, 
    {Hue[
      NCache[
       Rational[12712, 14307], 0.888516110994618]], AbsoluteThickness[0.25], 
     LineBox[{12712, 12713}]}, 
    {Hue[
      NCache[
       Rational[12713, 14307], 0.8885860068497938]], AbsoluteThickness[0.25], 
     LineBox[{12713, 12714}]}, 
    {Hue[
      NCache[
       Rational[4238, 4769], 0.8886559027049696]], AbsoluteThickness[0.25], 
     LineBox[{12714, 12715}]}, 
    {Hue[
      NCache[
       Rational[12715, 14307], 0.8887257985601453]], AbsoluteThickness[0.25], 
     LineBox[{12715, 12716}]}, 
    {Hue[
      NCache[
       Rational[12716, 14307], 0.8887956944153211]], AbsoluteThickness[0.25], 
     LineBox[{12716, 12717}]}, 
    {Hue[
      NCache[
       Rational[4239, 4769], 0.8888655902704969]], AbsoluteThickness[0.25], 
     LineBox[{12717, 12718}]}, 
    {Hue[
      NCache[
       Rational[12718, 14307], 0.8889354861256727]], AbsoluteThickness[0.25], 
     LineBox[{12718, 12719}]}, 
    {Hue[
      NCache[
       Rational[12719, 14307], 0.8890053819808486]], AbsoluteThickness[0.25], 
     LineBox[{12719, 12720}]}, 
    {Hue[
      NCache[
       Rational[4240, 4769], 0.8890752778360244]], AbsoluteThickness[0.25], 
     LineBox[{12720, 12721}]}, 
    {Hue[
      NCache[
       Rational[12721, 14307], 0.8891451736912002]], AbsoluteThickness[0.25], 
     LineBox[{12721, 12722}]}, 
    {Hue[
      NCache[
       Rational[12722, 14307], 0.8892150695463759]], AbsoluteThickness[0.25], 
     LineBox[{12722, 12723}]}, 
    {Hue[
      NCache[
       Rational[4241, 4769], 0.8892849654015517]], AbsoluteThickness[0.25], 
     LineBox[{12723, 12724}]}, 
    {Hue[
      NCache[
       Rational[12724, 14307], 0.8893548612567275]], AbsoluteThickness[0.25], 
     LineBox[{12724, 12725}]}, 
    {Hue[
      NCache[
       Rational[12725, 14307], 0.8894247571119033]], AbsoluteThickness[0.25], 
     LineBox[{12725, 12726}]}, 
    {Hue[
      NCache[
       Rational[4242, 4769], 0.8894946529670791]], AbsoluteThickness[0.25], 
     LineBox[{12726, 12727}]}, 
    {Hue[
      NCache[
       Rational[12727, 14307], 0.8895645488222549]], AbsoluteThickness[0.25], 
     LineBox[{12727, 12728}]}, 
    {Hue[
      NCache[
       Rational[12728, 14307], 0.8896344446774306]], AbsoluteThickness[0.25], 
     LineBox[{12728, 12729}]}, 
    {Hue[
      NCache[
       Rational[4243, 4769], 0.8897043405326064]], AbsoluteThickness[0.25], 
     LineBox[{12729, 12730}]}, 
    {Hue[
      NCache[
       Rational[670, 753], 0.8897742363877822]], AbsoluteThickness[0.25], 
     LineBox[{12730, 12731}]}, 
    {Hue[
      NCache[
       Rational[12731, 14307], 0.889844132242958]], AbsoluteThickness[0.25], 
     LineBox[{12731, 12732}]}, 
    {Hue[
      NCache[
       Rational[4244, 4769], 0.8899140280981338]], AbsoluteThickness[0.25], 
     LineBox[{12732, 12733}]}, 
    {Hue[
      NCache[
       Rational[12733, 14307], 0.8899839239533096]], AbsoluteThickness[0.25], 
     LineBox[{12733, 12734}]}, 
    {Hue[
      NCache[
       Rational[12734, 14307], 0.8900538198084853]], AbsoluteThickness[0.25], 
     LineBox[{12734, 12735}]}, 
    {Hue[
      NCache[
       Rational[4245, 4769], 0.8901237156636611]], AbsoluteThickness[0.25], 
     LineBox[{12735, 12736}]}, 
    {Hue[
      NCache[
       Rational[12736, 14307], 0.8901936115188369]], AbsoluteThickness[0.25], 
     LineBox[{12736, 12737}]}, 
    {Hue[
      NCache[
       Rational[12737, 14307], 0.8902635073740127]], AbsoluteThickness[0.25], 
     LineBox[{12737, 12738}]}, 
    {Hue[
      NCache[
       Rational[4246, 4769], 0.8903334032291885]], AbsoluteThickness[0.25], 
     LineBox[{12738, 12739}]}, 
    {Hue[
      NCache[
       Rational[12739, 14307], 0.8904032990843643]], AbsoluteThickness[0.25], 
     LineBox[{12739, 12740}]}, 
    {Hue[
      NCache[
       Rational[12740, 14307], 0.8904731949395401]], AbsoluteThickness[0.25], 
     LineBox[{12740, 12741}]}, 
    {Hue[
      NCache[
       Rational[4247, 4769], 0.8905430907947158]], AbsoluteThickness[0.25], 
     LineBox[{12741, 12742}]}, 
    {Hue[
      NCache[
       Rational[12742, 14307], 0.8906129866498916]], AbsoluteThickness[0.25], 
     LineBox[{12742, 12743}]}, 
    {Hue[
      NCache[
       Rational[12743, 14307], 0.8906828825050674]], AbsoluteThickness[0.25], 
     LineBox[{12743, 12744}]}, 
    {Hue[
      NCache[
       Rational[4248, 4769], 0.8907527783602432]], AbsoluteThickness[0.25], 
     LineBox[{12744, 12745}]}, 
    {Hue[
      NCache[
       Rational[12745, 14307], 0.890822674215419]], AbsoluteThickness[0.25], 
     LineBox[{12745, 12746}]}, 
    {Hue[
      NCache[
       Rational[12746, 14307], 0.8908925700705949]], AbsoluteThickness[0.25], 
     LineBox[{12746, 12747}]}, 
    {Hue[
      NCache[
       Rational[4249, 4769], 0.8909624659257706]], AbsoluteThickness[0.25], 
     LineBox[{12747, 12748}]}, 
    {Hue[
      NCache[
       Rational[12748, 14307], 0.8910323617809464]], AbsoluteThickness[0.25], 
     LineBox[{12748, 12749}]}, 
    {Hue[
      NCache[
       Rational[671, 753], 0.8911022576361222]], AbsoluteThickness[0.25], 
     LineBox[{12749, 12750}]}, 
    {Hue[
      NCache[
       Rational[4250, 4769], 0.891172153491298]], AbsoluteThickness[0.25], 
     LineBox[{12750, 12751}]}, 
    {Hue[
      NCache[
       Rational[12751, 14307], 0.8912420493464738]], AbsoluteThickness[0.25], 
     LineBox[{12751, 12752}]}, 
    {Hue[
      NCache[
       Rational[12752, 14307], 0.8913119452016496]], AbsoluteThickness[0.25], 
     LineBox[{12752, 12753}]}, 
    {Hue[
      NCache[
       Rational[4251, 4769], 0.8913818410568253]], AbsoluteThickness[0.25], 
     LineBox[{12753, 12754}]}, 
    {Hue[
      NCache[
       Rational[12754, 14307], 0.8914517369120011]], AbsoluteThickness[0.25], 
     LineBox[{12754, 12755}]}, 
    {Hue[
      NCache[
       Rational[12755, 14307], 0.8915216327671769]], AbsoluteThickness[0.25], 
     LineBox[{12755, 12756}]}, 
    {Hue[
      NCache[
       Rational[4252, 4769], 0.8915915286223527]], AbsoluteThickness[0.25], 
     LineBox[{12756, 12757}]}, 
    {Hue[
      NCache[
       Rational[12757, 14307], 0.8916614244775285]], AbsoluteThickness[0.25], 
     LineBox[{12757, 12758}]}, 
    {Hue[
      NCache[
       Rational[12758, 14307], 0.8917313203327043]], AbsoluteThickness[0.25], 
     LineBox[{12758, 12759}]}, 
    {Hue[
      NCache[
       Rational[4253, 4769], 0.8918012161878801]], AbsoluteThickness[0.25], 
     LineBox[{12759, 12760}]}, 
    {Hue[
      NCache[
       Rational[12760, 14307], 0.8918711120430558]], AbsoluteThickness[0.25], 
     LineBox[{12760, 12761}]}, 
    {Hue[
      NCache[
       Rational[12761, 14307], 0.8919410078982316]], AbsoluteThickness[0.25], 
     LineBox[{12761, 12762}]}, 
    {Hue[
      NCache[
       Rational[4254, 4769], 0.8920109037534074]], AbsoluteThickness[0.25], 
     LineBox[{12762, 12763}]}, 
    {Hue[
      NCache[
       Rational[12763, 14307], 0.8920807996085832]], AbsoluteThickness[0.25], 
     LineBox[{12763, 12764}]}, 
    {Hue[
      NCache[
       Rational[12764, 14307], 0.892150695463759]], AbsoluteThickness[0.25], 
     LineBox[{12764, 12765}]}, 
    {Hue[
      NCache[
       Rational[4255, 4769], 0.8922205913189348]], AbsoluteThickness[0.25], 
     LineBox[{12765, 12766}]}, 
    {Hue[
      NCache[
       Rational[12766, 14307], 0.8922904871741105]], AbsoluteThickness[0.25], 
     LineBox[{12766, 12767}]}, 
    {Hue[
      NCache[
       Rational[12767, 14307], 0.8923603830292863]], AbsoluteThickness[0.25], 
     LineBox[{12767, 12768}]}, 
    {Hue[
      NCache[
       Rational[224, 251], 0.8924302788844621]], AbsoluteThickness[0.25], 
     LineBox[{12768, 12769}]}, 
    {Hue[
      NCache[
       Rational[12769, 14307], 0.8925001747396379]], AbsoluteThickness[0.25], 
     LineBox[{12769, 12770}]}, 
    {Hue[
      NCache[
       Rational[12770, 14307], 0.8925700705948137]], AbsoluteThickness[0.25], 
     LineBox[{12770, 12771}]}, 
    {Hue[
      NCache[
       Rational[4257, 4769], 0.8926399664499896]], AbsoluteThickness[0.25], 
     LineBox[{12771, 12772}]}, 
    {Hue[
      NCache[
       Rational[12772, 14307], 0.8927098623051654]], AbsoluteThickness[0.25], 
     LineBox[{12772, 12773}]}, 
    {Hue[
      NCache[
       Rational[12773, 14307], 0.892779758160341]], AbsoluteThickness[0.25], 
     LineBox[{12773, 12774}]}, 
    {Hue[
      NCache[
       Rational[4258, 4769], 0.8928496540155169]], AbsoluteThickness[0.25], 
     LineBox[{12774, 12775}]}, 
    {Hue[
      NCache[
       Rational[12775, 14307], 0.8929195498706927]], AbsoluteThickness[0.25], 
     LineBox[{12775, 12776}]}, 
    {Hue[
      NCache[
       Rational[12776, 14307], 0.8929894457258685]], AbsoluteThickness[0.25], 
     LineBox[{12776, 12777}]}, 
    {Hue[
      NCache[
       Rational[4259, 4769], 0.8930593415810443]], AbsoluteThickness[0.25], 
     LineBox[{12777, 12778}]}, 
    {Hue[
      NCache[
       Rational[12778, 14307], 0.8931292374362201]], AbsoluteThickness[0.25], 
     LineBox[{12778, 12779}]}, 
    {Hue[
      NCache[
       Rational[12779, 14307], 0.8931991332913958]], AbsoluteThickness[0.25], 
     LineBox[{12779, 12780}]}, 
    {Hue[
      NCache[
       Rational[4260, 4769], 0.8932690291465716]], AbsoluteThickness[0.25], 
     LineBox[{12780, 12781}]}, 
    {Hue[
      NCache[
       Rational[12781, 14307], 0.8933389250017474]], AbsoluteThickness[0.25], 
     LineBox[{12781, 12782}]}, 
    {Hue[
      NCache[
       Rational[12782, 14307], 0.8934088208569232]], AbsoluteThickness[0.25], 
     LineBox[{12782, 12783}]}, 
    {Hue[
      NCache[
       Rational[4261, 4769], 0.893478716712099]], AbsoluteThickness[0.25], 
     LineBox[{12783, 12784}]}, 
    {Hue[
      NCache[
       Rational[12784, 14307], 0.8935486125672748]], AbsoluteThickness[0.25], 
     LineBox[{12784, 12785}]}, 
    {Hue[
      NCache[
       Rational[12785, 14307], 0.8936185084224505]], AbsoluteThickness[0.25], 
     LineBox[{12785, 12786}]}, 
    {Hue[
      NCache[
       Rational[4262, 4769], 0.8936884042776263]], AbsoluteThickness[0.25], 
     LineBox[{12786, 12787}]}, 
    {Hue[
      NCache[
       Rational[673, 753], 0.8937583001328021]], AbsoluteThickness[0.25], 
     LineBox[{12787, 12788}]}, 
    {Hue[
      NCache[
       Rational[12788, 14307], 0.8938281959879779]], AbsoluteThickness[0.25], 
     LineBox[{12788, 12789}]}, 
    {Hue[
      NCache[
       Rational[4263, 4769], 0.8938980918431537]], AbsoluteThickness[0.25], 
     LineBox[{12789, 12790}]}, 
    {Hue[
      NCache[
       Rational[12790, 14307], 0.8939679876983295]], AbsoluteThickness[0.25], 
     LineBox[{12790, 12791}]}, 
    {Hue[
      NCache[
       Rational[12791, 14307], 0.8940378835535053]], AbsoluteThickness[0.25], 
     LineBox[{12791, 12792}]}, 
    {Hue[
      NCache[
       Rational[4264, 4769], 0.894107779408681]], AbsoluteThickness[0.25], 
     LineBox[{12792, 12793}]}, 
    {Hue[
      NCache[
       Rational[12793, 14307], 0.8941776752638568]], AbsoluteThickness[0.25], 
     LineBox[{12793, 12794}]}, 
    {Hue[
      NCache[
       Rational[12794, 14307], 0.8942475711190326]], AbsoluteThickness[0.25], 
     LineBox[{12794, 12795}]}, 
    {Hue[
      NCache[
       Rational[4265, 4769], 0.8943174669742084]], AbsoluteThickness[0.25], 
     LineBox[{12795, 12796}]}, 
    {Hue[
      NCache[
       Rational[12796, 14307], 0.8943873628293842]], AbsoluteThickness[0.25], 
     LineBox[{12796, 12797}]}, 
    {Hue[
      NCache[
       Rational[12797, 14307], 0.89445725868456]], AbsoluteThickness[0.25], 
     LineBox[{12797, 12798}]}, 
    {Hue[
      NCache[
       Rational[4266, 4769], 0.8945271545397357]], AbsoluteThickness[0.25], 
     LineBox[{12798, 12799}]}, 
    {Hue[
      NCache[
       Rational[12799, 14307], 0.8945970503949116]], AbsoluteThickness[0.25], 
     LineBox[{12799, 12800}]}, 
    {Hue[
      NCache[
       Rational[12800, 14307], 0.8946669462500874]], AbsoluteThickness[0.25], 
     LineBox[{12800, 12801}]}, 
    {Hue[
      NCache[
       Rational[17, 19], 0.8947368421052632]], AbsoluteThickness[0.25], 
     LineBox[{12801, 12802}]}, 
    {Hue[
      NCache[
       Rational[12802, 14307], 0.894806737960439]], AbsoluteThickness[0.25], 
     LineBox[{12802, 12803}]}, 
    {Hue[
      NCache[
       Rational[12803, 14307], 0.8948766338156148]], AbsoluteThickness[0.25], 
     LineBox[{12803, 12804}]}, 
    {Hue[
      NCache[
       Rational[4268, 4769], 0.8949465296707905]], AbsoluteThickness[0.25], 
     LineBox[{12804, 12805}]}, 
    {Hue[
      NCache[
       Rational[12805, 14307], 0.8950164255259663]], AbsoluteThickness[0.25], 
     LineBox[{12805, 12806}]}, 
    {Hue[
      NCache[
       Rational[674, 753], 0.8950863213811421]], AbsoluteThickness[0.25], 
     LineBox[{12806, 12807}]}, 
    {Hue[
      NCache[
       Rational[4269, 4769], 0.8951562172363179]], AbsoluteThickness[0.25], 
     LineBox[{12807, 12808}]}, 
    {Hue[
      NCache[
       Rational[12808, 14307], 0.8952261130914937]], AbsoluteThickness[0.25], 
     LineBox[{12808, 12809}]}, 
    {Hue[
      NCache[
       Rational[12809, 14307], 0.8952960089466695]], AbsoluteThickness[0.25], 
     LineBox[{12809, 12810}]}, 
    {Hue[
      NCache[
       Rational[4270, 4769], 0.8953659048018453]], AbsoluteThickness[0.25], 
     LineBox[{12810, 12811}]}, 
    {Hue[
      NCache[
       Rational[12811, 14307], 0.895435800657021]], AbsoluteThickness[0.25], 
     LineBox[{12811, 12812}]}, 
    {Hue[
      NCache[
       Rational[12812, 14307], 0.8955056965121968]], AbsoluteThickness[0.25], 
     LineBox[{12812, 12813}]}, 
    {Hue[
      NCache[
       Rational[4271, 4769], 0.8955755923673726]], AbsoluteThickness[0.25], 
     LineBox[{12813, 12814}]}, 
    {Hue[
      NCache[
       Rational[12814, 14307], 0.8956454882225484]], AbsoluteThickness[0.25], 
     LineBox[{12814, 12815}]}, 
    {Hue[
      NCache[
       Rational[12815, 14307], 0.8957153840777242]], AbsoluteThickness[0.25], 
     LineBox[{12815, 12816}]}, 
    {Hue[
      NCache[
       Rational[4272, 4769], 0.8957852799329]], AbsoluteThickness[0.25], 
     LineBox[{12816, 12817}]}, 
    {Hue[
      NCache[
       Rational[12817, 14307], 0.8958551757880757]], AbsoluteThickness[0.25], 
     LineBox[{12817, 12818}]}, 
    {Hue[
      NCache[
       Rational[12818, 14307], 0.8959250716432515]], AbsoluteThickness[0.25], 
     LineBox[{12818, 12819}]}, 
    {Hue[
      NCache[
       Rational[4273, 4769], 0.8959949674984273]], AbsoluteThickness[0.25], 
     LineBox[{12819, 12820}]}, 
    {Hue[
      NCache[
       Rational[12820, 14307], 0.8960648633536031]], AbsoluteThickness[0.25], 
     LineBox[{12820, 12821}]}, 
    {Hue[
      NCache[
       Rational[12821, 14307], 0.8961347592087789]], AbsoluteThickness[0.25], 
     LineBox[{12821, 12822}]}, 
    {Hue[
      NCache[
       Rational[4274, 4769], 0.8962046550639547]], AbsoluteThickness[0.25], 
     LineBox[{12822, 12823}]}, 
    {Hue[
      NCache[
       Rational[12823, 14307], 0.8962745509191304]], AbsoluteThickness[0.25], 
     LineBox[{12823, 12824}]}, 
    {Hue[
      NCache[
       Rational[12824, 14307], 0.8963444467743062]], AbsoluteThickness[0.25], 
     LineBox[{12824, 12825}]}, 
    {Hue[
      NCache[
       Rational[225, 251], 0.896414342629482]], AbsoluteThickness[0.25], 
     LineBox[{12825, 12826}]}, 
    {Hue[
      NCache[
       Rational[12826, 14307], 0.8964842384846579]], AbsoluteThickness[0.25], 
     LineBox[{12826, 12827}]}, 
    {Hue[
      NCache[
       Rational[12827, 14307], 0.8965541343398337]], AbsoluteThickness[0.25], 
     LineBox[{12827, 12828}]}, 
    {Hue[
      NCache[
       Rational[4276, 4769], 0.8966240301950095]], AbsoluteThickness[0.25], 
     LineBox[{12828, 12829}]}, 
    {Hue[
      NCache[
       Rational[12829, 14307], 0.8966939260501853]], AbsoluteThickness[0.25], 
     LineBox[{12829, 12830}]}, 
    {Hue[
      NCache[
       Rational[12830, 14307], 0.896763821905361]], AbsoluteThickness[0.25], 
     LineBox[{12830, 12831}]}, 
    {Hue[
      NCache[
       Rational[4277, 4769], 0.8968337177605368]], AbsoluteThickness[0.25], 
     LineBox[{12831, 12832}]}, 
    {Hue[
      NCache[
       Rational[12832, 14307], 0.8969036136157126]], AbsoluteThickness[0.25], 
     LineBox[{12832, 12833}]}, 
    {Hue[
      NCache[
       Rational[12833, 14307], 0.8969735094708884]], AbsoluteThickness[0.25], 
     LineBox[{12833, 12834}]}, 
    {Hue[
      NCache[
       Rational[4278, 4769], 0.8970434053260642]], AbsoluteThickness[0.25], 
     LineBox[{12834, 12835}]}, 
    {Hue[
      NCache[
       Rational[12835, 14307], 0.89711330118124]], AbsoluteThickness[0.25], 
     LineBox[{12835, 12836}]}, 
    {Hue[
      NCache[
       Rational[12836, 14307], 0.8971831970364157]], AbsoluteThickness[0.25], 
     LineBox[{12836, 12837}]}, 
    {Hue[
      NCache[
       Rational[4279, 4769], 0.8972530928915915]], AbsoluteThickness[0.25], 
     LineBox[{12837, 12838}]}, 
    {Hue[
      NCache[
       Rational[12838, 14307], 0.8973229887467673]], AbsoluteThickness[0.25], 
     LineBox[{12838, 12839}]}, 
    {Hue[
      NCache[
       Rational[12839, 14307], 0.8973928846019431]], AbsoluteThickness[0.25], 
     LineBox[{12839, 12840}]}, 
    {Hue[
      NCache[
       Rational[4280, 4769], 0.8974627804571189]], AbsoluteThickness[0.25], 
     LineBox[{12840, 12841}]}, 
    {Hue[
      NCache[
       Rational[12841, 14307], 0.8975326763122947]], AbsoluteThickness[0.25], 
     LineBox[{12841, 12842}]}, 
    {Hue[
      NCache[
       Rational[12842, 14307], 0.8976025721674704]], AbsoluteThickness[0.25], 
     LineBox[{12842, 12843}]}, 
    {Hue[
      NCache[
       Rational[4281, 4769], 0.8976724680226462]], AbsoluteThickness[0.25], 
     LineBox[{12843, 12844}]}, 
    {Hue[
      NCache[
       Rational[676, 753], 0.897742363877822]], AbsoluteThickness[0.25], 
     LineBox[{12844, 12845}]}, 
    {Hue[
      NCache[
       Rational[12845, 14307], 0.8978122597329978]], AbsoluteThickness[0.25], 
     LineBox[{12845, 12846}]}, 
    {Hue[
      NCache[
       Rational[4282, 4769], 0.8978821555881736]], AbsoluteThickness[0.25], 
     LineBox[{12846, 12847}]}, 
    {Hue[
      NCache[
       Rational[12847, 14307], 0.8979520514433494]], AbsoluteThickness[0.25], 
     LineBox[{12847, 12848}]}, 
    {Hue[
      NCache[
       Rational[12848, 14307], 0.8980219472985252]], AbsoluteThickness[0.25], 
     LineBox[{12848, 12849}]}, 
    {Hue[
      NCache[
       Rational[4283, 4769], 0.8980918431537009]], AbsoluteThickness[0.25], 
     LineBox[{12849, 12850}]}, 
    {Hue[
      NCache[
       Rational[12850, 14307], 0.8981617390088767]], AbsoluteThickness[0.25], 
     LineBox[{12850, 12851}]}, 
    {Hue[
      NCache[
       Rational[12851, 14307], 0.8982316348640526]], AbsoluteThickness[0.25], 
     LineBox[{12851, 12852}]}, 
    {Hue[
      NCache[
       Rational[4284, 4769], 0.8983015307192284]], AbsoluteThickness[0.25], 
     LineBox[{12852, 12853}]}, 
    {Hue[
      NCache[
       Rational[12853, 14307], 0.8983714265744042]], AbsoluteThickness[0.25], 
     LineBox[{12853, 12854}]}, 
    {Hue[
      NCache[
       Rational[12854, 14307], 0.89844132242958]], AbsoluteThickness[0.25], 
     LineBox[{12854, 12855}]}, 
    {Hue[
      NCache[
       Rational[4285, 4769], 0.8985112182847557]], AbsoluteThickness[0.25], 
     LineBox[{12855, 12856}]}, 
    {Hue[
      NCache[
       Rational[12856, 14307], 0.8985811141399315]], AbsoluteThickness[0.25], 
     LineBox[{12856, 12857}]}, 
    {Hue[
      NCache[
       Rational[12857, 14307], 0.8986510099951073]], AbsoluteThickness[0.25], 
     LineBox[{12857, 12858}]}, 
    {Hue[
      NCache[
       Rational[4286, 4769], 0.8987209058502831]], AbsoluteThickness[0.25], 
     LineBox[{12858, 12859}]}, 
    {Hue[
      NCache[
       Rational[12859, 14307], 0.8987908017054589]], AbsoluteThickness[0.25], 
     LineBox[{12859, 12860}]}, 
    {Hue[
      NCache[
       Rational[12860, 14307], 0.8988606975606347]], AbsoluteThickness[0.25], 
     LineBox[{12860, 12861}]}, 
    {Hue[
      NCache[
       Rational[4287, 4769], 0.8989305934158105]], AbsoluteThickness[0.25], 
     LineBox[{12861, 12862}]}, 
    {Hue[
      NCache[
       Rational[12862, 14307], 0.8990004892709862]], AbsoluteThickness[0.25], 
     LineBox[{12862, 12863}]}, 
    {Hue[
      NCache[
       Rational[677, 753], 0.899070385126162]], AbsoluteThickness[0.25], 
     LineBox[{12863, 12864}]}, 
    {Hue[
      NCache[
       Rational[4288, 4769], 0.8991402809813378]], AbsoluteThickness[0.25], 
     LineBox[{12864, 12865}]}, 
    {Hue[
      NCache[
       Rational[12865, 14307], 0.8992101768365136]], AbsoluteThickness[0.25], 
     LineBox[{12865, 12866}]}, 
    {Hue[
      NCache[
       Rational[12866, 14307], 0.8992800726916894]], AbsoluteThickness[0.25], 
     LineBox[{12866, 12867}]}, 
    {Hue[
      NCache[
       Rational[4289, 4769], 0.8993499685468652]], AbsoluteThickness[0.25], 
     LineBox[{12867, 12868}]}, 
    {Hue[
      NCache[
       Rational[12868, 14307], 0.8994198644020409]], AbsoluteThickness[0.25], 
     LineBox[{12868, 12869}]}, 
    {Hue[
      NCache[
       Rational[12869, 14307], 0.8994897602572167]], AbsoluteThickness[0.25], 
     LineBox[{12869, 12870}]}, 
    {Hue[
      NCache[
       Rational[4290, 4769], 0.8995596561123925]], AbsoluteThickness[0.25], 
     LineBox[{12870, 12871}]}, 
    {Hue[
      NCache[
       Rational[12871, 14307], 0.8996295519675683]], AbsoluteThickness[0.25], 
     LineBox[{12871, 12872}]}, 
    {Hue[
      NCache[
       Rational[12872, 14307], 0.8996994478227441]], AbsoluteThickness[0.25], 
     LineBox[{12872, 12873}]}, 
    {Hue[
      NCache[
       Rational[4291, 4769], 0.8997693436779199]], AbsoluteThickness[0.25], 
     LineBox[{12873, 12874}]}, 
    {Hue[
      NCache[
       Rational[12874, 14307], 0.8998392395330956]], AbsoluteThickness[0.25], 
     LineBox[{12874, 12875}]}, 
    {Hue[
      NCache[
       Rational[12875, 14307], 0.8999091353882714]], AbsoluteThickness[0.25], 
     LineBox[{12875, 12876}]}, 
    {Hue[
      NCache[
       Rational[4292, 4769], 0.8999790312434472]], AbsoluteThickness[0.25], 
     LineBox[{12876, 12877}]}, 
    {Hue[
      NCache[
       Rational[12877, 14307], 0.900048927098623]], AbsoluteThickness[0.25], 
     LineBox[{12877, 12878}]}, 
    {Hue[
      NCache[
       Rational[12878, 14307], 0.9001188229537989]], AbsoluteThickness[0.25], 
     LineBox[{12878, 12879}]}, 
    {Hue[
      NCache[
       Rational[4293, 4769], 0.9001887188089747]], AbsoluteThickness[0.25], 
     LineBox[{12879, 12880}]}, 
    {Hue[
      NCache[
       Rational[12880, 14307], 0.9002586146641505]], AbsoluteThickness[0.25], 
     LineBox[{12880, 12881}]}, 
    {Hue[
      NCache[
       Rational[12881, 14307], 0.9003285105193262]], AbsoluteThickness[0.25], 
     LineBox[{12881, 12882}]}, 
    {Hue[
      NCache[
       Rational[226, 251], 0.900398406374502]], AbsoluteThickness[0.25], 
     LineBox[{12882, 12883}]}, 
    {Hue[
      NCache[
       Rational[12883, 14307], 0.9004683022296778]], AbsoluteThickness[0.25], 
     LineBox[{12883, 12884}]}, 
    {Hue[
      NCache[
       Rational[12884, 14307], 0.9005381980848536]], AbsoluteThickness[0.25], 
     LineBox[{12884, 12885}]}, 
    {Hue[
      NCache[
       Rational[4295, 4769], 0.9006080939400294]], AbsoluteThickness[0.25], 
     LineBox[{12885, 12886}]}, 
    {Hue[
      NCache[
       Rational[12886, 14307], 0.9006779897952052]], AbsoluteThickness[0.25], 
     LineBox[{12886, 12887}]}, 
    {Hue[
      NCache[
       Rational[12887, 14307], 0.9007478856503809]], AbsoluteThickness[0.25], 
     LineBox[{12887, 12888}]}, 
    {Hue[
      NCache[
       Rational[4296, 4769], 0.9008177815055567]], AbsoluteThickness[0.25], 
     LineBox[{12888, 12889}]}, 
    {Hue[
      NCache[
       Rational[12889, 14307], 0.9008876773607325]], AbsoluteThickness[0.25], 
     LineBox[{12889, 12890}]}, 
    {Hue[
      NCache[
       Rational[12890, 14307], 0.9009575732159083]], AbsoluteThickness[0.25], 
     LineBox[{12890, 12891}]}, 
    {Hue[
      NCache[
       Rational[4297, 4769], 0.9010274690710841]], AbsoluteThickness[0.25], 
     LineBox[{12891, 12892}]}, 
    {Hue[
      NCache[
       Rational[12892, 14307], 0.9010973649262599]], AbsoluteThickness[0.25], 
     LineBox[{12892, 12893}]}, 
    {Hue[
      NCache[
       Rational[12893, 14307], 0.9011672607814356]], AbsoluteThickness[0.25], 
     LineBox[{12893, 12894}]}, 
    {Hue[
      NCache[
       Rational[4298, 4769], 0.9012371566366114]], AbsoluteThickness[0.25], 
     LineBox[{12894, 12895}]}, 
    {Hue[
      NCache[
       Rational[12895, 14307], 0.9013070524917872]], AbsoluteThickness[0.25], 
     LineBox[{12895, 12896}]}, 
    {Hue[
      NCache[
       Rational[12896, 14307], 0.901376948346963]], AbsoluteThickness[0.25], 
     LineBox[{12896, 12897}]}, 
    {Hue[
      NCache[
       Rational[4299, 4769], 0.9014468442021388]], AbsoluteThickness[0.25], 
     LineBox[{12897, 12898}]}, 
    {Hue[
      NCache[
       Rational[12898, 14307], 0.9015167400573146]], AbsoluteThickness[0.25], 
     LineBox[{12898, 12899}]}, 
    {Hue[
      NCache[
       Rational[12899, 14307], 0.9015866359124904]], AbsoluteThickness[0.25], 
     LineBox[{12899, 12900}]}, 
    {Hue[
      NCache[
       Rational[4300, 4769], 0.9016565317676661]], AbsoluteThickness[0.25], 
     LineBox[{12900, 12901}]}, 
    {Hue[
      NCache[
       Rational[679, 753], 0.9017264276228419]], AbsoluteThickness[0.25], 
     LineBox[{12901, 12902}]}, 
    {Hue[
      NCache[
       Rational[12902, 14307], 0.9017963234780177]], AbsoluteThickness[0.25], 
     LineBox[{12902, 12903}]}, 
    {Hue[
      NCache[
       Rational[4301, 4769], 0.9018662193331936]], AbsoluteThickness[0.25], 
     LineBox[{12903, 12904}]}, 
    {Hue[
      NCache[
       Rational[12904, 14307], 0.9019361151883694]], AbsoluteThickness[0.25], 
     LineBox[{12904, 12905}]}, 
    {Hue[
      NCache[
       Rational[12905, 14307], 0.9020060110435452]], AbsoluteThickness[0.25], 
     LineBox[{12905, 12906}]}, 
    {Hue[
      NCache[
       Rational[4302, 4769], 0.9020759068987209]], AbsoluteThickness[0.25], 
     LineBox[{12906, 12907}]}, 
    {Hue[
      NCache[
       Rational[12907, 14307], 0.9021458027538967]], AbsoluteThickness[0.25], 
     LineBox[{12907, 12908}]}, 
    {Hue[
      NCache[
       Rational[12908, 14307], 0.9022156986090725]], AbsoluteThickness[0.25], 
     LineBox[{12908, 12909}]}, 
    {Hue[
      NCache[
       Rational[4303, 4769], 0.9022855944642483]], AbsoluteThickness[0.25], 
     LineBox[{12909, 12910}]}, 
    {Hue[
      NCache[
       Rational[12910, 14307], 0.9023554903194241]], AbsoluteThickness[0.25], 
     LineBox[{12910, 12911}]}, 
    {Hue[
      NCache[
       Rational[12911, 14307], 0.9024253861745999]], AbsoluteThickness[0.25], 
     LineBox[{12911, 12912}]}, 
    {Hue[
      NCache[
       Rational[4304, 4769], 0.9024952820297756]], AbsoluteThickness[0.25], 
     LineBox[{12912, 12913}]}, 
    {Hue[
      NCache[
       Rational[12913, 14307], 0.9025651778849514]], AbsoluteThickness[0.25], 
     LineBox[{12913, 12914}]}, 
    {Hue[
      NCache[
       Rational[12914, 14307], 0.9026350737401272]], AbsoluteThickness[0.25], 
     LineBox[{12914, 12915}]}, 
    {Hue[
      NCache[
       Rational[4305, 4769], 0.902704969595303]], AbsoluteThickness[0.25], 
     LineBox[{12915, 12916}]}, 
    {Hue[
      NCache[
       Rational[12916, 14307], 0.9027748654504788]], AbsoluteThickness[0.25], 
     LineBox[{12916, 12917}]}, 
    {Hue[
      NCache[
       Rational[12917, 14307], 0.9028447613056546]], AbsoluteThickness[0.25], 
     LineBox[{12917, 12918}]}, 
    {Hue[
      NCache[
       Rational[4306, 4769], 0.9029146571608304]], AbsoluteThickness[0.25], 
     LineBox[{12918, 12919}]}, 
    {Hue[
      NCache[
       Rational[12919, 14307], 0.9029845530160061]], AbsoluteThickness[0.25], 
     LineBox[{12919, 12920}]}, 
    {Hue[
      NCache[
       Rational[680, 753], 0.9030544488711819]], AbsoluteThickness[0.25], 
     LineBox[{12920, 12921}]}, 
    {Hue[
      NCache[
       Rational[4307, 4769], 0.9031243447263577]], AbsoluteThickness[0.25], 
     LineBox[{12921, 12922}]}, 
    {Hue[
      NCache[
       Rational[12922, 14307], 0.9031942405815335]], AbsoluteThickness[0.25], 
     LineBox[{12922, 12923}]}, 
    {Hue[
      NCache[
       Rational[12923, 14307], 0.9032641364367093]], AbsoluteThickness[0.25], 
     LineBox[{12923, 12924}]}, 
    {Hue[
      NCache[
       Rational[4308, 4769], 0.9033340322918851]], AbsoluteThickness[0.25], 
     LineBox[{12924, 12925}]}, 
    {Hue[
      NCache[
       Rational[12925, 14307], 0.9034039281470608]], AbsoluteThickness[0.25], 
     LineBox[{12925, 12926}]}, 
    {Hue[
      NCache[
       Rational[12926, 14307], 0.9034738240022366]], AbsoluteThickness[0.25], 
     LineBox[{12926, 12927}]}, 
    {Hue[
      NCache[
       Rational[4309, 4769], 0.9035437198574124]], AbsoluteThickness[0.25], 
     LineBox[{12927, 12928}]}, 
    {Hue[
      NCache[
       Rational[12928, 14307], 0.9036136157125882]], AbsoluteThickness[0.25], 
     LineBox[{12928, 12929}]}, 
    {Hue[
      NCache[
       Rational[12929, 14307], 0.903683511567764]], AbsoluteThickness[0.25], 
     LineBox[{12929, 12930}]}, 
    {Hue[
      NCache[
       Rational[4310, 4769], 0.9037534074229399]], AbsoluteThickness[0.25], 
     LineBox[{12930, 12931}]}, 
    {Hue[
      NCache[
       Rational[12931, 14307], 0.9038233032781156]], AbsoluteThickness[0.25], 
     LineBox[{12931, 12932}]}, 
    {Hue[
      NCache[
       Rational[12932, 14307], 0.9038931991332914]], AbsoluteThickness[0.25], 
     LineBox[{12932, 12933}]}, 
    {Hue[
      NCache[
       Rational[4311, 4769], 0.9039630949884672]], AbsoluteThickness[0.25], 
     LineBox[{12933, 12934}]}, 
    {Hue[
      NCache[
       Rational[12934, 14307], 0.904032990843643]], AbsoluteThickness[0.25], 
     LineBox[{12934, 12935}]}, 
    {Hue[
      NCache[
       Rational[12935, 14307], 0.9041028866988188]], AbsoluteThickness[0.25], 
     LineBox[{12935, 12936}]}, 
    {Hue[
      NCache[
       Rational[4312, 4769], 0.9041727825539946]], AbsoluteThickness[0.25], 
     LineBox[{12936, 12937}]}, 
    {Hue[
      NCache[
       Rational[12937, 14307], 0.9042426784091704]], AbsoluteThickness[0.25], 
     LineBox[{12937, 12938}]}, 
    {Hue[
      NCache[
       Rational[12938, 14307], 0.9043125742643461]], AbsoluteThickness[0.25], 
     LineBox[{12938, 12939}]}, 
    {Hue[
      NCache[
       Rational[227, 251], 0.9043824701195219]], AbsoluteThickness[0.25], 
     LineBox[{12939, 12940}]}, 
    {Hue[
      NCache[
       Rational[12940, 14307], 0.9044523659746977]], AbsoluteThickness[0.25], 
     LineBox[{12940, 12941}]}, 
    {Hue[
      NCache[
       Rational[12941, 14307], 0.9045222618298735]], AbsoluteThickness[0.25], 
     LineBox[{12941, 12942}]}, 
    {Hue[
      NCache[
       Rational[4314, 4769], 0.9045921576850493]], AbsoluteThickness[0.25], 
     LineBox[{12942, 12943}]}, 
    {Hue[
      NCache[
       Rational[12943, 14307], 0.9046620535402251]], AbsoluteThickness[0.25], 
     LineBox[{12943, 12944}]}, 
    {Hue[
      NCache[
       Rational[12944, 14307], 0.9047319493954008]], AbsoluteThickness[0.25], 
     LineBox[{12944, 12945}]}, 
    {Hue[
      NCache[
       Rational[4315, 4769], 0.9048018452505766]], AbsoluteThickness[0.25], 
     LineBox[{12945, 12946}]}, 
    {Hue[
      NCache[
       Rational[12946, 14307], 0.9048717411057524]], AbsoluteThickness[0.25], 
     LineBox[{12946, 12947}]}, 
    {Hue[
      NCache[
       Rational[12947, 14307], 0.9049416369609282]], AbsoluteThickness[0.25], 
     LineBox[{12947, 12948}]}, 
    {Hue[
      NCache[
       Rational[4316, 4769], 0.905011532816104]], AbsoluteThickness[0.25], 
     LineBox[{12948, 12949}]}, 
    {Hue[
      NCache[
       Rational[12949, 14307], 0.9050814286712798]], AbsoluteThickness[0.25], 
     LineBox[{12949, 12950}]}, 
    {Hue[
      NCache[
       Rational[12950, 14307], 0.9051513245264556]], AbsoluteThickness[0.25], 
     LineBox[{12950, 12951}]}, 
    {Hue[
      NCache[
       Rational[4317, 4769], 0.9052212203816313]], AbsoluteThickness[0.25], 
     LineBox[{12951, 12952}]}, 
    {Hue[
      NCache[
       Rational[12952, 14307], 0.9052911162368071]], AbsoluteThickness[0.25], 
     LineBox[{12952, 12953}]}, 
    {Hue[
      NCache[
       Rational[12953, 14307], 0.9053610120919829]], AbsoluteThickness[0.25], 
     LineBox[{12953, 12954}]}, 
    {Hue[
      NCache[
       Rational[4318, 4769], 0.9054309079471587]], AbsoluteThickness[0.25], 
     LineBox[{12954, 12955}]}, 
    {Hue[
      NCache[
       Rational[12955, 14307], 0.9055008038023346]], AbsoluteThickness[0.25], 
     LineBox[{12955, 12956}]}, 
    {Hue[
      NCache[
       Rational[12956, 14307], 0.9055706996575104]], AbsoluteThickness[0.25], 
     LineBox[{12956, 12957}]}, 
    {Hue[
      NCache[
       Rational[4319, 4769], 0.905640595512686]], AbsoluteThickness[0.25], 
     LineBox[{12957, 12958}]}, 
    {Hue[
      NCache[
       Rational[682, 753], 0.9057104913678619]], AbsoluteThickness[0.25], 
     LineBox[{12958, 12959}]}, 
    {Hue[
      NCache[
       Rational[12959, 14307], 0.9057803872230377]], AbsoluteThickness[0.25], 
     LineBox[{12959, 12960}]}, 
    {Hue[
      NCache[
       Rational[4320, 4769], 0.9058502830782135]], AbsoluteThickness[0.25], 
     LineBox[{12960, 12961}]}, 
    {Hue[
      NCache[
       Rational[12961, 14307], 0.9059201789333893]], AbsoluteThickness[0.25], 
     LineBox[{12961, 12962}]}, 
    {Hue[
      NCache[
       Rational[12962, 14307], 0.9059900747885651]], AbsoluteThickness[0.25], 
     LineBox[{12962, 12963}]}, 
    {Hue[
      NCache[
       Rational[4321, 4769], 0.9060599706437408]], AbsoluteThickness[0.25], 
     LineBox[{12963, 12964}]}, 
    {Hue[
      NCache[
       Rational[12964, 14307], 0.9061298664989166]], AbsoluteThickness[0.25], 
     LineBox[{12964, 12965}]}, 
    {Hue[
      NCache[
       Rational[12965, 14307], 0.9061997623540924]], AbsoluteThickness[0.25], 
     LineBox[{12965, 12966}]}, 
    {Hue[
      NCache[
       Rational[4322, 4769], 0.9062696582092682]], AbsoluteThickness[0.25], 
     LineBox[{12966, 12967}]}, 
    {Hue[
      NCache[
       Rational[12967, 14307], 0.906339554064444]], AbsoluteThickness[0.25], 
     LineBox[{12967, 12968}]}, 
    {Hue[
      NCache[
       Rational[12968, 14307], 0.9064094499196198]], AbsoluteThickness[0.25], 
     LineBox[{12968, 12969}]}, 
    {Hue[
      NCache[
       Rational[4323, 4769], 0.9064793457747956]], AbsoluteThickness[0.25], 
     LineBox[{12969, 12970}]}, 
    {Hue[
      NCache[
       Rational[12970, 14307], 0.9065492416299713]], AbsoluteThickness[0.25], 
     LineBox[{12970, 12971}]}, 
    {Hue[
      NCache[
       Rational[12971, 14307], 0.9066191374851471]], AbsoluteThickness[0.25], 
     LineBox[{12971, 12972}]}, 
    {Hue[
      NCache[
       Rational[4324, 4769], 0.9066890333403229]], AbsoluteThickness[0.25], 
     LineBox[{12972, 12973}]}, 
    {Hue[
      NCache[
       Rational[12973, 14307], 0.9067589291954987]], AbsoluteThickness[0.25], 
     LineBox[{12973, 12974}]}, 
    {Hue[
      NCache[
       Rational[12974, 14307], 0.9068288250506745]], AbsoluteThickness[0.25], 
     LineBox[{12974, 12975}]}, 
    {Hue[
      NCache[
       Rational[4325, 4769], 0.9068987209058503]], AbsoluteThickness[0.25], 
     LineBox[{12975, 12976}]}, 
    {Hue[
      NCache[
       Rational[12976, 14307], 0.906968616761026]], AbsoluteThickness[0.25], 
     LineBox[{12976, 12977}]}, 
    {Hue[
      NCache[
       Rational[683, 753], 0.9070385126162018]], AbsoluteThickness[0.25], 
     LineBox[{12977, 12978}]}, 
    {Hue[
      NCache[
       Rational[4326, 4769], 0.9071084084713776]], AbsoluteThickness[0.25], 
     LineBox[{12978, 12979}]}, 
    {Hue[
      NCache[
       Rational[12979, 14307], 0.9071783043265534]], AbsoluteThickness[0.25], 
     LineBox[{12979, 12980}]}, 
    {Hue[
      NCache[
       Rational[12980, 14307], 0.9072482001817292]], AbsoluteThickness[0.25], 
     LineBox[{12980, 12981}]}, 
    {Hue[
      NCache[
       Rational[4327, 4769], 0.907318096036905]], AbsoluteThickness[0.25], 
     LineBox[{12981, 12982}]}, 
    {Hue[
      NCache[
       Rational[12982, 14307], 0.9073879918920807]], AbsoluteThickness[0.25], 
     LineBox[{12982, 12983}]}, 
    {Hue[
      NCache[
       Rational[12983, 14307], 0.9074578877472566]], AbsoluteThickness[0.25], 
     LineBox[{12983, 12984}]}, 
    {Hue[
      NCache[
       Rational[4328, 4769], 0.9075277836024324]], AbsoluteThickness[0.25], 
     LineBox[{12984, 12985}]}, 
    {Hue[
      NCache[
       Rational[12985, 14307], 0.9075976794576082]], AbsoluteThickness[0.25], 
     LineBox[{12985, 12986}]}, 
    {Hue[
      NCache[
       Rational[12986, 14307], 0.907667575312784]], AbsoluteThickness[0.25], 
     LineBox[{12986, 12987}]}, 
    {Hue[
      NCache[
       Rational[4329, 4769], 0.9077374711679598]], AbsoluteThickness[0.25], 
     LineBox[{12987, 12988}]}, 
    {Hue[
      NCache[
       Rational[12988, 14307], 0.9078073670231356]], AbsoluteThickness[0.25], 
     LineBox[{12988, 12989}]}, 
    {Hue[
      NCache[
       Rational[12989, 14307], 0.9078772628783113]], AbsoluteThickness[0.25], 
     LineBox[{12989, 12990}]}, 
    {Hue[
      NCache[
       Rational[4330, 4769], 0.9079471587334871]], AbsoluteThickness[0.25], 
     LineBox[{12990, 12991}]}, 
    {Hue[
      NCache[
       Rational[12991, 14307], 0.9080170545886629]], AbsoluteThickness[0.25], 
     LineBox[{12991, 12992}]}, 
    {Hue[
      NCache[
       Rational[12992, 14307], 0.9080869504438387]], AbsoluteThickness[0.25], 
     LineBox[{12992, 12993}]}, 
    {Hue[
      NCache[
       Rational[4331, 4769], 0.9081568462990145]], AbsoluteThickness[0.25], 
     LineBox[{12993, 12994}]}, 
    {Hue[
      NCache[
       Rational[12994, 14307], 0.9082267421541903]], AbsoluteThickness[0.25], 
     LineBox[{12994, 12995}]}, 
    {Hue[
      NCache[
       Rational[12995, 14307], 0.908296638009366]], AbsoluteThickness[0.25], 
     LineBox[{12995, 12996}]}, 
    {Hue[
      NCache[
       Rational[228, 251], 0.9083665338645418]], AbsoluteThickness[0.25], 
     LineBox[{12996, 12997}]}, 
    {Hue[
      NCache[
       Rational[12997, 14307], 0.9084364297197176]], AbsoluteThickness[0.25], 
     LineBox[{12997, 12998}]}, 
    {Hue[
      NCache[
       Rational[12998, 14307], 0.9085063255748934]], AbsoluteThickness[0.25], 
     LineBox[{12998, 12999}]}, 
    {Hue[
      NCache[
       Rational[4333, 4769], 0.9085762214300692]], AbsoluteThickness[0.25], 
     LineBox[{12999, 13000}]}, 
    {Hue[
      NCache[
       Rational[13000, 14307], 0.908646117285245]], AbsoluteThickness[0.25], 
     LineBox[{13000, 13001}]}, 
    {Hue[
      NCache[
       Rational[13001, 14307], 0.9087160131404207]], AbsoluteThickness[0.25], 
     LineBox[{13001, 13002}]}, 
    {Hue[
      NCache[
       Rational[4334, 4769], 0.9087859089955965]], AbsoluteThickness[0.25], 
     LineBox[{13002, 13003}]}, 
    {Hue[
      NCache[
       Rational[13003, 14307], 0.9088558048507723]], AbsoluteThickness[0.25], 
     LineBox[{13003, 13004}]}, 
    {Hue[
      NCache[
       Rational[13004, 14307], 0.9089257007059481]], AbsoluteThickness[0.25], 
     LineBox[{13004, 13005}]}, 
    {Hue[
      NCache[
       Rational[4335, 4769], 0.9089955965611239]], AbsoluteThickness[0.25], 
     LineBox[{13005, 13006}]}, 
    {Hue[
      NCache[
       Rational[13006, 14307], 0.9090654924162997]], AbsoluteThickness[0.25], 
     LineBox[{13006, 13007}]}, 
    {Hue[
      NCache[
       Rational[13007, 14307], 0.9091353882714756]], AbsoluteThickness[0.25], 
     LineBox[{13007, 13008}]}, 
    {Hue[
      NCache[
       Rational[4336, 4769], 0.9092052841266512]], AbsoluteThickness[0.25], 
     LineBox[{13008, 13009}]}, 
    {Hue[
      NCache[
       Rational[13009, 14307], 0.909275179981827]], AbsoluteThickness[0.25], 
     LineBox[{13009, 13010}]}, 
    {Hue[
      NCache[
       Rational[13010, 14307], 0.9093450758370029]], AbsoluteThickness[0.25], 
     LineBox[{13010, 13011}]}, 
    {Hue[
      NCache[
       Rational[4337, 4769], 0.9094149716921787]], AbsoluteThickness[0.25], 
     LineBox[{13011, 13012}]}, 
    {Hue[
      NCache[
       Rational[13012, 14307], 0.9094848675473545]], AbsoluteThickness[0.25], 
     LineBox[{13012, 13013}]}, 
    {Hue[
      NCache[
       Rational[13013, 14307], 0.9095547634025303]], AbsoluteThickness[0.25], 
     LineBox[{13013, 13014}]}, 
    {Hue[
      NCache[
       Rational[4338, 4769], 0.909624659257706]], AbsoluteThickness[0.25], 
     LineBox[{13014, 13015}]}, 
    {Hue[
      NCache[
       Rational[685, 753], 0.9096945551128818]], AbsoluteThickness[0.25], 
     LineBox[{13015, 13016}]}, 
    {Hue[
      NCache[
       Rational[13016, 14307], 0.9097644509680576]], AbsoluteThickness[0.25], 
     LineBox[{13016, 13017}]}, 
    {Hue[
      NCache[
       Rational[4339, 4769], 0.9098343468232334]], AbsoluteThickness[0.25], 
     LineBox[{13017, 13018}]}, 
    {Hue[
      NCache[
       Rational[13018, 14307], 0.9099042426784092]], AbsoluteThickness[0.25], 
     LineBox[{13018, 13019}]}, 
    {Hue[
      NCache[
       Rational[13019, 14307], 0.909974138533585]], AbsoluteThickness[0.25], 
     LineBox[{13019, 13020}]}, 
    {Hue[
      NCache[
       Rational[4340, 4769], 0.9100440343887607]], AbsoluteThickness[0.25], 
     LineBox[{13020, 13021}]}, 
    {Hue[
      NCache[
       Rational[13021, 14307], 0.9101139302439365]], AbsoluteThickness[0.25], 
     LineBox[{13021, 13022}]}, 
    {Hue[
      NCache[
       Rational[13022, 14307], 0.9101838260991123]], AbsoluteThickness[0.25], 
     LineBox[{13022, 13023}]}, 
    {Hue[
      NCache[
       Rational[4341, 4769], 0.9102537219542881]], AbsoluteThickness[0.25], 
     LineBox[{13023, 13024}]}, 
    {Hue[
      NCache[
       Rational[13024, 14307], 0.9103236178094639]], AbsoluteThickness[0.25], 
     LineBox[{13024, 13025}]}, 
    {Hue[
      NCache[
       Rational[13025, 14307], 0.9103935136646397]], AbsoluteThickness[0.25], 
     LineBox[{13025, 13026}]}, 
    {Hue[
      NCache[
       Rational[4342, 4769], 0.9104634095198155]], AbsoluteThickness[0.25], 
     LineBox[{13026, 13027}]}, 
    {Hue[
      NCache[
       Rational[13027, 14307], 0.9105333053749912]], AbsoluteThickness[0.25], 
     LineBox[{13027, 13028}]}, 
    {Hue[
      NCache[
       Rational[13028, 14307], 0.910603201230167]], AbsoluteThickness[0.25], 
     LineBox[{13028, 13029}]}, 
    {Hue[
      NCache[
       Rational[4343, 4769], 0.9106730970853428]], AbsoluteThickness[0.25], 
     LineBox[{13029, 13030}]}, 
    {Hue[
      NCache[
       Rational[13030, 14307], 0.9107429929405186]], AbsoluteThickness[0.25], 
     LineBox[{13030, 13031}]}, 
    {Hue[
      NCache[
       Rational[13031, 14307], 0.9108128887956944]], AbsoluteThickness[0.25], 
     LineBox[{13031, 13032}]}, 
    {Hue[
      NCache[
       Rational[4344, 4769], 0.9108827846508702]], AbsoluteThickness[0.25], 
     LineBox[{13032, 13033}]}, 
    {Hue[
      NCache[
       Rational[13033, 14307], 0.9109526805060459]], AbsoluteThickness[0.25], 
     LineBox[{13033, 13034}]}, 
    {Hue[
      NCache[
       Rational[686, 753], 0.9110225763612217]], AbsoluteThickness[0.25], 
     LineBox[{13034, 13035}]}, 
    {Hue[
      NCache[
       Rational[4345, 4769], 0.9110924722163976]], AbsoluteThickness[0.25], 
     LineBox[{13035, 13036}]}, 
    {Hue[
      NCache[
       Rational[13036, 14307], 0.9111623680715734]], AbsoluteThickness[0.25], 
     LineBox[{13036, 13037}]}, 
    {Hue[
      NCache[
       Rational[13037, 14307], 0.9112322639267492]], AbsoluteThickness[0.25], 
     LineBox[{13037, 13038}]}, 
    {Hue[
      NCache[
       Rational[4346, 4769], 0.911302159781925]], AbsoluteThickness[0.25], 
     LineBox[{13038, 13039}]}, 
    {Hue[
      NCache[
       Rational[13039, 14307], 0.9113720556371008]], AbsoluteThickness[0.25], 
     LineBox[{13039, 13040}]}, 
    {Hue[
      NCache[
       Rational[13040, 14307], 0.9114419514922765]], AbsoluteThickness[0.25], 
     LineBox[{13040, 13041}]}, 
    {Hue[
      NCache[
       Rational[4347, 4769], 0.9115118473474523]], AbsoluteThickness[0.25], 
     LineBox[{13041, 13042}]}, 
    {Hue[
      NCache[
       Rational[13042, 14307], 0.9115817432026281]], AbsoluteThickness[0.25], 
     LineBox[{13042, 13043}]}, 
    {Hue[
      NCache[
       Rational[13043, 14307], 0.9116516390578039]], AbsoluteThickness[0.25], 
     LineBox[{13043, 13044}]}, 
    {Hue[
      NCache[
       Rational[4348, 4769], 0.9117215349129797]], AbsoluteThickness[0.25], 
     LineBox[{13044, 13045}]}, 
    {Hue[
      NCache[
       Rational[13045, 14307], 0.9117914307681555]], AbsoluteThickness[0.25], 
     LineBox[{13045, 13046}]}, 
    {Hue[
      NCache[
       Rational[13046, 14307], 0.9118613266233312]], AbsoluteThickness[0.25], 
     LineBox[{13046, 13047}]}, 
    {Hue[
      NCache[
       Rational[4349, 4769], 0.911931222478507]], AbsoluteThickness[0.25], 
     LineBox[{13047, 13048}]}, 
    {Hue[
      NCache[
       Rational[13048, 14307], 0.9120011183336828]], AbsoluteThickness[0.25], 
     LineBox[{13048, 13049}]}, 
    {Hue[
      NCache[
       Rational[13049, 14307], 0.9120710141888586]], AbsoluteThickness[0.25], 
     LineBox[{13049, 13050}]}, 
    {Hue[
      NCache[
       Rational[4350, 4769], 0.9121409100440344]], AbsoluteThickness[0.25], 
     LineBox[{13050, 13051}]}, 
    {Hue[
      NCache[
       Rational[13051, 14307], 0.9122108058992102]], AbsoluteThickness[0.25], 
     LineBox[{13051, 13052}]}, 
    {Hue[
      NCache[
       Rational[52, 57], 0.9122807017543859]], AbsoluteThickness[0.25], 
     LineBox[{13052, 13053}]}, 
    {Hue[
      NCache[
       Rational[229, 251], 0.9123505976095617]], AbsoluteThickness[0.25], 
     LineBox[{13053, 13054}]}, 
    {Hue[
      NCache[
       Rational[13054, 14307], 0.9124204934647375]], AbsoluteThickness[0.25], 
     LineBox[{13054, 13055}]}, 
    {Hue[
      NCache[
       Rational[13055, 14307], 0.9124903893199133]], AbsoluteThickness[0.25], 
     LineBox[{13055, 13056}]}, 
    {Hue[
      NCache[
       Rational[4352, 4769], 0.9125602851750891]], AbsoluteThickness[0.25], 
     LineBox[{13056, 13057}]}, 
    {Hue[
      NCache[
       Rational[13057, 14307], 0.9126301810302649]], AbsoluteThickness[0.25], 
     LineBox[{13057, 13058}]}, 
    {Hue[
      NCache[
       Rational[13058, 14307], 0.9127000768854407]], AbsoluteThickness[0.25], 
     LineBox[{13058, 13059}]}, 
    {Hue[
      NCache[
       Rational[4353, 4769], 0.9127699727406164]], AbsoluteThickness[0.25], 
     LineBox[{13059, 13060}]}, 
    {Hue[
      NCache[
       Rational[13060, 14307], 0.9128398685957922]], AbsoluteThickness[0.25], 
     LineBox[{13060, 13061}]}, 
    {Hue[
      NCache[
       Rational[13061, 14307], 0.912909764450968]], AbsoluteThickness[0.25], 
     LineBox[{13061, 13062}]}, 
    {Hue[
      NCache[
       Rational[4354, 4769], 0.9129796603061439]], AbsoluteThickness[0.25], 
     LineBox[{13062, 13063}]}, 
    {Hue[
      NCache[
       Rational[13063, 14307], 0.9130495561613197]], AbsoluteThickness[0.25], 
     LineBox[{13063, 13064}]}, 
    {Hue[
      NCache[
       Rational[13064, 14307], 0.9131194520164955]], AbsoluteThickness[0.25], 
     LineBox[{13064, 13065}]}, 
    {Hue[
      NCache[
       Rational[4355, 4769], 0.9131893478716712]], AbsoluteThickness[0.25], 
     LineBox[{13065, 13066}]}, 
    {Hue[
      NCache[
       Rational[13066, 14307], 0.913259243726847]], AbsoluteThickness[0.25], 
     LineBox[{13066, 13067}]}, 
    {Hue[
      NCache[
       Rational[13067, 14307], 0.9133291395820228]], AbsoluteThickness[0.25], 
     LineBox[{13067, 13068}]}, 
    {Hue[
      NCache[
       Rational[4356, 4769], 0.9133990354371986]], AbsoluteThickness[0.25], 
     LineBox[{13068, 13069}]}, 
    {Hue[
      NCache[
       Rational[13069, 14307], 0.9134689312923744]], AbsoluteThickness[0.25], 
     LineBox[{13069, 13070}]}, 
    {Hue[
      NCache[
       Rational[13070, 14307], 0.9135388271475502]], AbsoluteThickness[0.25], 
     LineBox[{13070, 13071}]}, 
    {Hue[
      NCache[
       Rational[4357, 4769], 0.9136087230027259]], AbsoluteThickness[0.25], 
     LineBox[{13071, 13072}]}, 
    {Hue[
      NCache[
       Rational[688, 753], 0.9136786188579017]], AbsoluteThickness[0.25], 
     LineBox[{13072, 13073}]}, 
    {Hue[
      NCache[
       Rational[13073, 14307], 0.9137485147130775]], AbsoluteThickness[0.25], 
     LineBox[{13073, 13074}]}, 
    {Hue[
      NCache[
       Rational[4358, 4769], 0.9138184105682533]], AbsoluteThickness[0.25], 
     LineBox[{13074, 13075}]}, 
    {Hue[
      NCache[
       Rational[13075, 14307], 0.9138883064234291]], AbsoluteThickness[0.25], 
     LineBox[{13075, 13076}]}, 
    {Hue[
      NCache[
       Rational[13076, 14307], 0.9139582022786049]], AbsoluteThickness[0.25], 
     LineBox[{13076, 13077}]}, 
    {Hue[
      NCache[
       Rational[4359, 4769], 0.9140280981337807]], AbsoluteThickness[0.25], 
     LineBox[{13077, 13078}]}, 
    {Hue[
      NCache[
       Rational[13078, 14307], 0.9140979939889564]], AbsoluteThickness[0.25], 
     LineBox[{13078, 13079}]}, 
    {Hue[
      NCache[
       Rational[13079, 14307], 0.9141678898441322]], AbsoluteThickness[0.25], 
     LineBox[{13079, 13080}]}, 
    {Hue[
      NCache[
       Rational[4360, 4769], 0.914237785699308]], AbsoluteThickness[0.25], 
     LineBox[{13080, 13081}]}, 
    {Hue[
      NCache[
       Rational[13081, 14307], 0.9143076815544838]], AbsoluteThickness[0.25], 
     LineBox[{13081, 13082}]}, 
    {Hue[
      NCache[
       Rational[13082, 14307], 0.9143775774096596]], AbsoluteThickness[0.25], 
     LineBox[{13082, 13083}]}, 
    {Hue[
      NCache[
       Rational[4361, 4769], 0.9144474732648354]], AbsoluteThickness[0.25], 
     LineBox[{13083, 13084}]}, 
    {Hue[
      NCache[
       Rational[13084, 14307], 0.9145173691200111]], AbsoluteThickness[0.25], 
     LineBox[{13084, 13085}]}, 
    {Hue[
      NCache[
       Rational[13085, 14307], 0.9145872649751869]], AbsoluteThickness[0.25], 
     LineBox[{13085, 13086}]}, 
    {Hue[
      NCache[
       Rational[4362, 4769], 0.9146571608303627]], AbsoluteThickness[0.25], 
     LineBox[{13086, 13087}]}, 
    {Hue[
      NCache[
       Rational[13087, 14307], 0.9147270566855386]], AbsoluteThickness[0.25], 
     LineBox[{13087, 13088}]}, 
    {Hue[
      NCache[
       Rational[13088, 14307], 0.9147969525407144]], AbsoluteThickness[0.25], 
     LineBox[{13088, 13089}]}, 
    {Hue[
      NCache[
       Rational[4363, 4769], 0.9148668483958902]], AbsoluteThickness[0.25], 
     LineBox[{13089, 13090}]}, 
    {Hue[
      NCache[
       Rational[13090, 14307], 0.9149367442510659]], AbsoluteThickness[0.25], 
     LineBox[{13090, 13091}]}, 
    {Hue[
      NCache[
       Rational[689, 753], 0.9150066401062417]], AbsoluteThickness[0.25], 
     LineBox[{13091, 13092}]}, 
    {Hue[
      NCache[
       Rational[4364, 4769], 0.9150765359614175]], AbsoluteThickness[0.25], 
     LineBox[{13092, 13093}]}, 
    {Hue[
      NCache[
       Rational[13093, 14307], 0.9151464318165933]], AbsoluteThickness[0.25], 
     LineBox[{13093, 13094}]}, 
    {Hue[
      NCache[
       Rational[13094, 14307], 0.9152163276717691]], AbsoluteThickness[0.25], 
     LineBox[{13094, 13095}]}, 
    {Hue[
      NCache[
       Rational[4365, 4769], 0.9152862235269449]], AbsoluteThickness[0.25], 
     LineBox[{13095, 13096}]}, 
    {Hue[
      NCache[
       Rational[13096, 14307], 0.9153561193821207]], AbsoluteThickness[0.25], 
     LineBox[{13096, 13097}]}, 
    {Hue[
      NCache[
       Rational[13097, 14307], 0.9154260152372964]], AbsoluteThickness[0.25], 
     LineBox[{13097, 13098}]}, 
    {Hue[
      NCache[
       Rational[4366, 4769], 0.9154959110924722]], AbsoluteThickness[0.25], 
     LineBox[{13098, 13099}]}, 
    {Hue[
      NCache[
       Rational[13099, 14307], 0.915565806947648]], AbsoluteThickness[0.25], 
     LineBox[{13099, 13100}]}, 
    {Hue[
      NCache[
       Rational[13100, 14307], 0.9156357028028238]], AbsoluteThickness[0.25], 
     LineBox[{13100, 13101}]}, 
    {Hue[
      NCache[
       Rational[4367, 4769], 0.9157055986579996]], AbsoluteThickness[0.25], 
     LineBox[{13101, 13102}]}, 
    {Hue[
      NCache[
       Rational[13102, 14307], 0.9157754945131754]], AbsoluteThickness[0.25], 
     LineBox[{13102, 13103}]}, 
    {Hue[
      NCache[
       Rational[13103, 14307], 0.9158453903683511]], AbsoluteThickness[0.25], 
     LineBox[{13103, 13104}]}, 
    {Hue[
      NCache[
       Rational[4368, 4769], 0.9159152862235269]], AbsoluteThickness[0.25], 
     LineBox[{13104, 13105}]}, 
    {Hue[
      NCache[
       Rational[13105, 14307], 0.9159851820787027]], AbsoluteThickness[0.25], 
     LineBox[{13105, 13106}]}, 
    {Hue[
      NCache[
       Rational[13106, 14307], 0.9160550779338785]], AbsoluteThickness[0.25], 
     LineBox[{13106, 13107}]}, 
    {Hue[
      NCache[
       Rational[4369, 4769], 0.9161249737890543]], AbsoluteThickness[0.25], 
     LineBox[{13107, 13108}]}, 
    {Hue[
      NCache[
       Rational[13108, 14307], 0.9161948696442301]], AbsoluteThickness[0.25], 
     LineBox[{13108, 13109}]}, 
    {Hue[
      NCache[
       Rational[13109, 14307], 0.9162647654994058]], AbsoluteThickness[0.25], 
     LineBox[{13109, 13110}]}, 
    {Hue[
      NCache[
       Rational[230, 251], 0.9163346613545816]], AbsoluteThickness[0.25], 
     LineBox[{13110, 13111}]}, 
    {Hue[
      NCache[
       Rational[13111, 14307], 0.9164045572097574]], AbsoluteThickness[0.25], 
     LineBox[{13111, 13112}]}, 
    {Hue[
      NCache[
       Rational[13112, 14307], 0.9164744530649332]], AbsoluteThickness[0.25], 
     LineBox[{13112, 13113}]}, 
    {Hue[
      NCache[
       Rational[4371, 4769], 0.916544348920109]], AbsoluteThickness[0.25], 
     LineBox[{13113, 13114}]}, 
    {Hue[
      NCache[
       Rational[13114, 14307], 0.9166142447752849]], AbsoluteThickness[0.25], 
     LineBox[{13114, 13115}]}, 
    {Hue[
      NCache[
       Rational[13115, 14307], 0.9166841406304607]], AbsoluteThickness[0.25], 
     LineBox[{13115, 13116}]}, 
    {Hue[
      NCache[
       Rational[4372, 4769], 0.9167540364856364]], AbsoluteThickness[0.25], 
     LineBox[{13116, 13117}]}, 
    {Hue[
      NCache[
       Rational[13117, 14307], 0.9168239323408122]], AbsoluteThickness[0.25], 
     LineBox[{13117, 13118}]}, 
    {Hue[
      NCache[
       Rational[13118, 14307], 0.916893828195988]], AbsoluteThickness[0.25], 
     LineBox[{13118, 13119}]}, 
    {Hue[
      NCache[
       Rational[4373, 4769], 0.9169637240511638]], AbsoluteThickness[0.25], 
     LineBox[{13119, 13120}]}, 
    {Hue[
      NCache[
       Rational[13120, 14307], 0.9170336199063396]], AbsoluteThickness[0.25], 
     LineBox[{13120, 13121}]}, 
    {Hue[
      NCache[
       Rational[13121, 14307], 0.9171035157615154]], AbsoluteThickness[0.25], 
     LineBox[{13121, 13122}]}, 
    {Hue[
      NCache[
       Rational[4374, 4769], 0.9171734116166911]], AbsoluteThickness[0.25], 
     LineBox[{13122, 13123}]}, 
    {Hue[
      NCache[
       Rational[13123, 14307], 0.9172433074718669]], AbsoluteThickness[0.25], 
     LineBox[{13123, 13124}]}, 
    {Hue[
      NCache[
       Rational[13124, 14307], 0.9173132033270427]], AbsoluteThickness[0.25], 
     LineBox[{13124, 13125}]}, 
    {Hue[
      NCache[
       Rational[4375, 4769], 0.9173830991822185]], AbsoluteThickness[0.25], 
     LineBox[{13125, 13126}]}, 
    {Hue[
      NCache[
       Rational[13126, 14307], 0.9174529950373943]], AbsoluteThickness[0.25], 
     LineBox[{13126, 13127}]}, 
    {Hue[
      NCache[
       Rational[13127, 14307], 0.9175228908925701]], AbsoluteThickness[0.25], 
     LineBox[{13127, 13128}]}, 
    {Hue[
      NCache[
       Rational[4376, 4769], 0.9175927867477458]], AbsoluteThickness[0.25], 
     LineBox[{13128, 13129}]}, 
    {Hue[
      NCache[
       Rational[691, 753], 0.9176626826029216]], AbsoluteThickness[0.25], 
     LineBox[{13129, 13130}]}, 
    {Hue[
      NCache[
       Rational[13130, 14307], 0.9177325784580974]], AbsoluteThickness[0.25], 
     LineBox[{13130, 13131}]}, 
    {Hue[
      NCache[
       Rational[4377, 4769], 0.9178024743132732]], AbsoluteThickness[0.25], 
     LineBox[{13131, 13132}]}, 
    {Hue[
      NCache[
       Rational[13132, 14307], 0.917872370168449]], AbsoluteThickness[0.25], 
     LineBox[{13132, 13133}]}, 
    {Hue[
      NCache[
       Rational[13133, 14307], 0.9179422660236248]], AbsoluteThickness[0.25], 
     LineBox[{13133, 13134}]}, 
    {Hue[
      NCache[
       Rational[4378, 4769], 0.9180121618788006]], AbsoluteThickness[0.25], 
     LineBox[{13134, 13135}]}, 
    {Hue[
      NCache[
       Rational[13135, 14307], 0.9180820577339763]], AbsoluteThickness[0.25], 
     LineBox[{13135, 13136}]}, 
    {Hue[
      NCache[
       Rational[13136, 14307], 0.9181519535891521]], AbsoluteThickness[0.25], 
     LineBox[{13136, 13137}]}, 
    {Hue[
      NCache[
       Rational[4379, 4769], 0.9182218494443279]], AbsoluteThickness[0.25], 
     LineBox[{13137, 13138}]}, 
    {Hue[
      NCache[
       Rational[13138, 14307], 0.9182917452995037]], AbsoluteThickness[0.25], 
     LineBox[{13138, 13139}]}, 
    {Hue[
      NCache[
       Rational[13139, 14307], 0.9183616411546796]], AbsoluteThickness[0.25], 
     LineBox[{13139, 13140}]}, 
    {Hue[
      NCache[
       Rational[4380, 4769], 0.9184315370098554]], AbsoluteThickness[0.25], 
     LineBox[{13140, 13141}]}, 
    {Hue[
      NCache[
       Rational[13141, 14307], 0.918501432865031]], AbsoluteThickness[0.25], 
     LineBox[{13141, 13142}]}, 
    {Hue[
      NCache[
       Rational[13142, 14307], 0.9185713287202069]], AbsoluteThickness[0.25], 
     LineBox[{13142, 13143}]}, 
    {Hue[
      NCache[
       Rational[4381, 4769], 0.9186412245753827]], AbsoluteThickness[0.25], 
     LineBox[{13143, 13144}]}, 
    {Hue[
      NCache[
       Rational[13144, 14307], 0.9187111204305585]], AbsoluteThickness[0.25], 
     LineBox[{13144, 13145}]}, 
    {Hue[
      NCache[
       Rational[13145, 14307], 0.9187810162857343]], AbsoluteThickness[0.25], 
     LineBox[{13145, 13146}]}, 
    {Hue[
      NCache[
       Rational[4382, 4769], 0.9188509121409101]], AbsoluteThickness[0.25], 
     LineBox[{13146, 13147}]}, 
    {Hue[
      NCache[
       Rational[13147, 14307], 0.9189208079960859]], AbsoluteThickness[0.25], 
     LineBox[{13147, 13148}]}, 
    {Hue[
      NCache[
       Rational[692, 753], 0.9189907038512616]], AbsoluteThickness[0.25], 
     LineBox[{13148, 13149}]}, 
    {Hue[
      NCache[
       Rational[4383, 4769], 0.9190605997064374]], AbsoluteThickness[0.25], 
     LineBox[{13149, 13150}]}, 
    {Hue[
      NCache[
       Rational[13150, 14307], 0.9191304955616132]], AbsoluteThickness[0.25], 
     LineBox[{13150, 13151}]}, 
    {Hue[
      NCache[
       Rational[13151, 14307], 0.919200391416789]], AbsoluteThickness[0.25], 
     LineBox[{13151, 13152}]}, 
    {Hue[
      NCache[
       Rational[4384, 4769], 0.9192702872719648]], AbsoluteThickness[0.25], 
     LineBox[{13152, 13153}]}, 
    {Hue[
      NCache[
       Rational[13153, 14307], 0.9193401831271406]], AbsoluteThickness[0.25], 
     LineBox[{13153, 13154}]}, 
    {Hue[
      NCache[
       Rational[13154, 14307], 0.9194100789823163]], AbsoluteThickness[0.25], 
     LineBox[{13154, 13155}]}, 
    {Hue[
      NCache[
       Rational[4385, 4769], 0.9194799748374921]], AbsoluteThickness[0.25], 
     LineBox[{13155, 13156}]}, 
    {Hue[
      NCache[
       Rational[13156, 14307], 0.9195498706926679]], AbsoluteThickness[0.25], 
     LineBox[{13156, 13157}]}, 
    {Hue[
      NCache[
       Rational[13157, 14307], 0.9196197665478437]], AbsoluteThickness[0.25], 
     LineBox[{13157, 13158}]}, 
    {Hue[
      NCache[
       Rational[4386, 4769], 0.9196896624030195]], AbsoluteThickness[0.25], 
     LineBox[{13158, 13159}]}, 
    {Hue[
      NCache[
       Rational[13159, 14307], 0.9197595582581953]], AbsoluteThickness[0.25], 
     LineBox[{13159, 13160}]}, 
    {Hue[
      NCache[
       Rational[13160, 14307], 0.919829454113371]], AbsoluteThickness[0.25], 
     LineBox[{13160, 13161}]}, 
    {Hue[
      NCache[
       Rational[4387, 4769], 0.9198993499685468]], AbsoluteThickness[0.25], 
     LineBox[{13161, 13162}]}, 
    {Hue[
      NCache[
       Rational[13162, 14307], 0.9199692458237226]], AbsoluteThickness[0.25], 
     LineBox[{13162, 13163}]}, 
    {Hue[
      NCache[
       Rational[13163, 14307], 0.9200391416788984]], AbsoluteThickness[0.25], 
     LineBox[{13163, 13164}]}, 
    {Hue[
      NCache[
       Rational[4388, 4769], 0.9201090375340742]], AbsoluteThickness[0.25], 
     LineBox[{13164, 13165}]}, 
    {Hue[
      NCache[
       Rational[13165, 14307], 0.92017893338925]], AbsoluteThickness[0.25], 
     LineBox[{13165, 13166}]}, 
    {Hue[
      NCache[
       Rational[13166, 14307], 0.9202488292444259]], AbsoluteThickness[0.25], 
     LineBox[{13166, 13167}]}, 
    {Hue[
      NCache[
       Rational[231, 251], 0.9203187250996016]], AbsoluteThickness[0.25], 
     LineBox[{13167, 13168}]}, 
    {Hue[
      NCache[
       Rational[13168, 14307], 0.9203886209547774]], AbsoluteThickness[0.25], 
     LineBox[{13168, 13169}]}, 
    {Hue[
      NCache[
       Rational[13169, 14307], 0.9204585168099532]], AbsoluteThickness[0.25], 
     LineBox[{13169, 13170}]}, 
    {Hue[
      NCache[
       Rational[4390, 4769], 0.920528412665129]], AbsoluteThickness[0.25], 
     LineBox[{13170, 13171}]}, 
    {Hue[
      NCache[
       Rational[13171, 14307], 0.9205983085203048]], AbsoluteThickness[0.25], 
     LineBox[{13171, 13172}]}, 
    {Hue[
      NCache[
       Rational[13172, 14307], 0.9206682043754806]], AbsoluteThickness[0.25], 
     LineBox[{13172, 13173}]}, 
    {Hue[
      NCache[
       Rational[4391, 4769], 0.9207381002306563]], AbsoluteThickness[0.25], 
     LineBox[{13173, 13174}]}, 
    {Hue[
      NCache[
       Rational[13174, 14307], 0.9208079960858321]], AbsoluteThickness[0.25], 
     LineBox[{13174, 13175}]}, 
    {Hue[
      NCache[
       Rational[13175, 14307], 0.9208778919410079]], AbsoluteThickness[0.25], 
     LineBox[{13175, 13176}]}, 
    {Hue[
      NCache[
       Rational[4392, 4769], 0.9209477877961837]], AbsoluteThickness[0.25], 
     LineBox[{13176, 13177}]}, 
    {Hue[
      NCache[
       Rational[13177, 14307], 0.9210176836513595]], AbsoluteThickness[0.25], 
     LineBox[{13177, 13178}]}, 
    {Hue[
      NCache[
       Rational[13178, 14307], 0.9210875795065353]], AbsoluteThickness[0.25], 
     LineBox[{13178, 13179}]}, 
    {Hue[
      NCache[
       Rational[4393, 4769], 0.921157475361711]], AbsoluteThickness[0.25], 
     LineBox[{13179, 13180}]}, 
    {Hue[
      NCache[
       Rational[13180, 14307], 0.9212273712168868]], AbsoluteThickness[0.25], 
     LineBox[{13180, 13181}]}, 
    {Hue[
      NCache[
       Rational[13181, 14307], 0.9212972670720626]], AbsoluteThickness[0.25], 
     LineBox[{13181, 13182}]}, 
    {Hue[
      NCache[
       Rational[4394, 4769], 0.9213671629272384]], AbsoluteThickness[0.25], 
     LineBox[{13182, 13183}]}, 
    {Hue[
      NCache[
       Rational[13183, 14307], 0.9214370587824142]], AbsoluteThickness[0.25], 
     LineBox[{13183, 13184}]}, 
    {Hue[
      NCache[
       Rational[13184, 14307], 0.92150695463759]], AbsoluteThickness[0.25], 
     LineBox[{13184, 13185}]}, 
    {Hue[
      NCache[
       Rational[4395, 4769], 0.9215768504927658]], AbsoluteThickness[0.25], 
     LineBox[{13185, 13186}]}, 
    {Hue[
      NCache[
       Rational[694, 753], 0.9216467463479415]], AbsoluteThickness[0.25], 
     LineBox[{13186, 13187}]}, 
    {Hue[
      NCache[
       Rational[13187, 14307], 0.9217166422031173]], AbsoluteThickness[0.25], 
     LineBox[{13187, 13188}]}, 
    {Hue[
      NCache[
       Rational[4396, 4769], 0.9217865380582931]], AbsoluteThickness[0.25], 
     LineBox[{13188, 13189}]}, 
    {Hue[
      NCache[
       Rational[13189, 14307], 0.9218564339134689]], AbsoluteThickness[0.25], 
     LineBox[{13189, 13190}]}, 
    {Hue[
      NCache[
       Rational[13190, 14307], 0.9219263297686447]], AbsoluteThickness[0.25], 
     LineBox[{13190, 13191}]}, 
    {Hue[
      NCache[
       Rational[4397, 4769], 0.9219962256238206]], AbsoluteThickness[0.25], 
     LineBox[{13191, 13192}]}, 
    {Hue[
      NCache[
       Rational[13192, 14307], 0.9220661214789962]], AbsoluteThickness[0.25], 
     LineBox[{13192, 13193}]}, 
    {Hue[
      NCache[
       Rational[13193, 14307], 0.922136017334172]], AbsoluteThickness[0.25], 
     LineBox[{13193, 13194}]}, 
    {Hue[
      NCache[
       Rational[4398, 4769], 0.9222059131893479]], AbsoluteThickness[0.25], 
     LineBox[{13194, 13195}]}, 
    {Hue[
      NCache[
       Rational[13195, 14307], 0.9222758090445237]], AbsoluteThickness[0.25], 
     LineBox[{13195, 13196}]}, 
    {Hue[
      NCache[
       Rational[13196, 14307], 0.9223457048996995]], AbsoluteThickness[0.25], 
     LineBox[{13196, 13197}]}, 
    {Hue[
      NCache[
       Rational[4399, 4769], 0.9224156007548753]], AbsoluteThickness[0.25], 
     LineBox[{13197, 13198}]}, 
    {Hue[
      NCache[
       Rational[13198, 14307], 0.922485496610051]], AbsoluteThickness[0.25], 
     LineBox[{13198, 13199}]}, 
    {Hue[
      NCache[
       Rational[13199, 14307], 0.9225553924652268]], AbsoluteThickness[0.25], 
     LineBox[{13199, 13200}]}, 
    {Hue[
      NCache[
       Rational[4400, 4769], 0.9226252883204026]], AbsoluteThickness[0.25], 
     LineBox[{13200, 13201}]}, 
    {Hue[
      NCache[
       Rational[13201, 14307], 0.9226951841755784]], AbsoluteThickness[0.25], 
     LineBox[{13201, 13202}]}, 
    {Hue[
      NCache[
       Rational[13202, 14307], 0.9227650800307542]], AbsoluteThickness[0.25], 
     LineBox[{13202, 13203}]}, 
    {Hue[
      NCache[
       Rational[4401, 4769], 0.92283497588593]], AbsoluteThickness[0.25], 
     LineBox[{13203, 13204}]}, 
    {Hue[
      NCache[
       Rational[13204, 14307], 0.9229048717411058]], AbsoluteThickness[0.25], 
     LineBox[{13204, 13205}]}, 
    {Hue[
      NCache[
       Rational[695, 753], 0.9229747675962815]], AbsoluteThickness[0.25], 
     LineBox[{13205, 13206}]}, 
    {Hue[
      NCache[
       Rational[4402, 4769], 0.9230446634514573]], AbsoluteThickness[0.25], 
     LineBox[{13206, 13207}]}, 
    {Hue[
      NCache[
       Rational[13207, 14307], 0.9231145593066331]], AbsoluteThickness[0.25], 
     LineBox[{13207, 13208}]}, 
    {Hue[
      NCache[
       Rational[13208, 14307], 0.9231844551618089]], AbsoluteThickness[0.25], 
     LineBox[{13208, 13209}]}, 
    {Hue[
      NCache[
       Rational[4403, 4769], 0.9232543510169847]], AbsoluteThickness[0.25], 
     LineBox[{13209, 13210}]}, 
    {Hue[
      NCache[
       Rational[13210, 14307], 0.9233242468721605]], AbsoluteThickness[0.25], 
     LineBox[{13210, 13211}]}, 
    {Hue[
      NCache[
       Rational[13211, 14307], 0.9233941427273362]], AbsoluteThickness[0.25], 
     LineBox[{13211, 13212}]}, 
    {Hue[
      NCache[
       Rational[4404, 4769], 0.923464038582512]], AbsoluteThickness[0.25], 
     LineBox[{13212, 13213}]}, 
    {Hue[
      NCache[
       Rational[13213, 14307], 0.9235339344376878]], AbsoluteThickness[0.25], 
     LineBox[{13213, 13214}]}, 
    {Hue[
      NCache[
       Rational[13214, 14307], 0.9236038302928636]], AbsoluteThickness[0.25], 
     LineBox[{13214, 13215}]}, 
    {Hue[
      NCache[
       Rational[4405, 4769], 0.9236737261480394]], AbsoluteThickness[0.25], 
     LineBox[{13215, 13216}]}, 
    {Hue[
      NCache[
       Rational[13216, 14307], 0.9237436220032152]], AbsoluteThickness[0.25], 
     LineBox[{13216, 13217}]}, 
    {Hue[
      NCache[
       Rational[13217, 14307], 0.9238135178583909]], AbsoluteThickness[0.25], 
     LineBox[{13217, 13218}]}, 
    {Hue[
      NCache[
       Rational[4406, 4769], 0.9238834137135667]], AbsoluteThickness[0.25], 
     LineBox[{13218, 13219}]}, 
    {Hue[
      NCache[
       Rational[13219, 14307], 0.9239533095687426]], AbsoluteThickness[0.25], 
     LineBox[{13219, 13220}]}, 
    {Hue[
      NCache[
       Rational[13220, 14307], 0.9240232054239184]], AbsoluteThickness[0.25], 
     LineBox[{13220, 13221}]}, 
    {Hue[
      NCache[
       Rational[4407, 4769], 0.9240931012790942]], AbsoluteThickness[0.25], 
     LineBox[{13221, 13222}]}, 
    {Hue[
      NCache[
       Rational[13222, 14307], 0.92416299713427]], AbsoluteThickness[0.25], 
     LineBox[{13222, 13223}]}, 
    {Hue[
      NCache[
       Rational[13223, 14307], 0.9242328929894458]], AbsoluteThickness[0.25], 
     LineBox[{13223, 13224}]}, 
    {Hue[
      NCache[
       Rational[232, 251], 0.9243027888446215]], AbsoluteThickness[0.25], 
     LineBox[{13224, 13225}]}, 
    {Hue[
      NCache[
       Rational[13225, 14307], 0.9243726846997973]], AbsoluteThickness[0.25], 
     LineBox[{13225, 13226}]}, 
    {Hue[
      NCache[
       Rational[13226, 14307], 0.9244425805549731]], AbsoluteThickness[0.25], 
     LineBox[{13226, 13227}]}, 
    {Hue[
      NCache[
       Rational[4409, 4769], 0.9245124764101489]], AbsoluteThickness[0.25], 
     LineBox[{13227, 13228}]}, 
    {Hue[
      NCache[
       Rational[13228, 14307], 0.9245823722653247]], AbsoluteThickness[0.25], 
     LineBox[{13228, 13229}]}, 
    {Hue[
      NCache[
       Rational[13229, 14307], 0.9246522681205005]], AbsoluteThickness[0.25], 
     LineBox[{13229, 13230}]}, 
    {Hue[
      NCache[
       Rational[4410, 4769], 0.9247221639756762]], AbsoluteThickness[0.25], 
     LineBox[{13230, 13231}]}, 
    {Hue[
      NCache[
       Rational[13231, 14307], 0.924792059830852]], AbsoluteThickness[0.25], 
     LineBox[{13231, 13232}]}, 
    {Hue[
      NCache[
       Rational[13232, 14307], 0.9248619556860278]], AbsoluteThickness[0.25], 
     LineBox[{13232, 13233}]}, 
    {Hue[
      NCache[
       Rational[4411, 4769], 0.9249318515412036]], AbsoluteThickness[0.25], 
     LineBox[{13233, 13234}]}, 
    {Hue[
      NCache[
       Rational[13234, 14307], 0.9250017473963794]], AbsoluteThickness[0.25], 
     LineBox[{13234, 13235}]}, 
    {Hue[
      NCache[
       Rational[13235, 14307], 0.9250716432515552]], AbsoluteThickness[0.25], 
     LineBox[{13235, 13236}]}, 
    {Hue[
      NCache[
       Rational[4412, 4769], 0.925141539106731]], AbsoluteThickness[0.25], 
     LineBox[{13236, 13237}]}, 
    {Hue[
      NCache[
       Rational[13237, 14307], 0.9252114349619067]], AbsoluteThickness[0.25], 
     LineBox[{13237, 13238}]}, 
    {Hue[
      NCache[
       Rational[13238, 14307], 0.9252813308170825]], AbsoluteThickness[0.25], 
     LineBox[{13238, 13239}]}, 
    {Hue[
      NCache[
       Rational[4413, 4769], 0.9253512266722583]], AbsoluteThickness[0.25], 
     LineBox[{13239, 13240}]}, 
    {Hue[
      NCache[
       Rational[13240, 14307], 0.9254211225274341]], AbsoluteThickness[0.25], 
     LineBox[{13240, 13241}]}, 
    {Hue[
      NCache[
       Rational[13241, 14307], 0.9254910183826099]], AbsoluteThickness[0.25], 
     LineBox[{13241, 13242}]}, 
    {Hue[
      NCache[
       Rational[4414, 4769], 0.9255609142377857]], AbsoluteThickness[0.25], 
     LineBox[{13242, 13243}]}, 
    {Hue[
      NCache[
       Rational[697, 753], 0.9256308100929614]], AbsoluteThickness[0.25], 
     LineBox[{13243, 13244}]}, 
    {Hue[
      NCache[
       Rational[13244, 14307], 0.9257007059481372]], AbsoluteThickness[0.25], 
     LineBox[{13244, 13245}]}, 
    {Hue[
      NCache[
       Rational[4415, 4769], 0.925770601803313]], AbsoluteThickness[0.25], 
     LineBox[{13245, 13246}]}, 
    {Hue[
      NCache[
       Rational[13246, 14307], 0.9258404976584889]], AbsoluteThickness[0.25], 
     LineBox[{13246, 13247}]}, 
    {Hue[
      NCache[
       Rational[13247, 14307], 0.9259103935136647]], AbsoluteThickness[0.25], 
     LineBox[{13247, 13248}]}, 
    {Hue[
      NCache[
       Rational[4416, 4769], 0.9259802893688405]], AbsoluteThickness[0.25], 
     LineBox[{13248, 13249}]}, 
    {Hue[
      NCache[
       Rational[13249, 14307], 0.9260501852240162]], AbsoluteThickness[0.25], 
     LineBox[{13249, 13250}]}, 
    {Hue[
      NCache[
       Rational[13250, 14307], 0.926120081079192]], AbsoluteThickness[0.25], 
     LineBox[{13250, 13251}]}, 
    {Hue[
      NCache[
       Rational[4417, 4769], 0.9261899769343678]], AbsoluteThickness[0.25], 
     LineBox[{13251, 13252}]}, 
    {Hue[
      NCache[
       Rational[13252, 14307], 0.9262598727895436]], AbsoluteThickness[0.25], 
     LineBox[{13252, 13253}]}, 
    {Hue[
      NCache[
       Rational[13253, 14307], 0.9263297686447194]], AbsoluteThickness[0.25], 
     LineBox[{13253, 13254}]}, 
    {Hue[
      NCache[
       Rational[4418, 4769], 0.9263996644998952]], AbsoluteThickness[0.25], 
     LineBox[{13254, 13255}]}, 
    {Hue[
      NCache[
       Rational[13255, 14307], 0.926469560355071]], AbsoluteThickness[0.25], 
     LineBox[{13255, 13256}]}, 
    {Hue[
      NCache[
       Rational[13256, 14307], 0.9265394562102467]], AbsoluteThickness[0.25], 
     LineBox[{13256, 13257}]}, 
    {Hue[
      NCache[
       Rational[4419, 4769], 0.9266093520654225]], AbsoluteThickness[0.25], 
     LineBox[{13257, 13258}]}, 
    {Hue[
      NCache[
       Rational[13258, 14307], 0.9266792479205983]], AbsoluteThickness[0.25], 
     LineBox[{13258, 13259}]}, 
    {Hue[
      NCache[
       Rational[13259, 14307], 0.9267491437757741]], AbsoluteThickness[0.25], 
     LineBox[{13259, 13260}]}, 
    {Hue[
      NCache[
       Rational[4420, 4769], 0.9268190396309499]], AbsoluteThickness[0.25], 
     LineBox[{13260, 13261}]}, 
    {Hue[
      NCache[
       Rational[13261, 14307], 0.9268889354861257]], AbsoluteThickness[0.25], 
     LineBox[{13261, 13262}]}, 
    {Hue[
      NCache[
       Rational[698, 753], 0.9269588313413014]], AbsoluteThickness[0.25], 
     LineBox[{13262, 13263}]}, 
    {Hue[
      NCache[
       Rational[4421, 4769], 0.9270287271964772]], AbsoluteThickness[0.25], 
     LineBox[{13263, 13264}]}, 
    {Hue[
      NCache[
       Rational[13264, 14307], 0.927098623051653]], AbsoluteThickness[0.25], 
     LineBox[{13264, 13265}]}, 
    {Hue[
      NCache[
       Rational[13265, 14307], 0.9271685189068288]], AbsoluteThickness[0.25], 
     LineBox[{13265, 13266}]}, 
    {Hue[
      NCache[
       Rational[4422, 4769], 0.9272384147620046]], AbsoluteThickness[0.25], 
     LineBox[{13266, 13267}]}, 
    {Hue[
      NCache[
       Rational[13267, 14307], 0.9273083106171804]], AbsoluteThickness[0.25], 
     LineBox[{13267, 13268}]}, 
    {Hue[
      NCache[
       Rational[13268, 14307], 0.9273782064723561]], AbsoluteThickness[0.25], 
     LineBox[{13268, 13269}]}, 
    {Hue[
      NCache[
       Rational[4423, 4769], 0.9274481023275319]], AbsoluteThickness[0.25], 
     LineBox[{13269, 13270}]}, 
    {Hue[
      NCache[
       Rational[13270, 14307], 0.9275179981827077]], AbsoluteThickness[0.25], 
     LineBox[{13270, 13271}]}, 
    {Hue[
      NCache[
       Rational[13271, 14307], 0.9275878940378836]], AbsoluteThickness[0.25], 
     LineBox[{13271, 13272}]}, 
    {Hue[
      NCache[
       Rational[4424, 4769], 0.9276577898930594]], AbsoluteThickness[0.25], 
     LineBox[{13272, 13273}]}, 
    {Hue[
      NCache[
       Rational[13273, 14307], 0.9277276857482352]], AbsoluteThickness[0.25], 
     LineBox[{13273, 13274}]}, 
    {Hue[
      NCache[
       Rational[13274, 14307], 0.927797581603411]], AbsoluteThickness[0.25], 
     LineBox[{13274, 13275}]}, 
    {Hue[
      NCache[
       Rational[4425, 4769], 0.9278674774585867]], AbsoluteThickness[0.25], 
     LineBox[{13275, 13276}]}, 
    {Hue[
      NCache[
       Rational[13276, 14307], 0.9279373733137625]], AbsoluteThickness[0.25], 
     LineBox[{13276, 13277}]}, 
    {Hue[
      NCache[
       Rational[13277, 14307], 0.9280072691689383]], AbsoluteThickness[0.25], 
     LineBox[{13277, 13278}]}, 
    {Hue[
      NCache[
       Rational[4426, 4769], 0.9280771650241141]], AbsoluteThickness[0.25], 
     LineBox[{13278, 13279}]}, 
    {Hue[
      NCache[
       Rational[13279, 14307], 0.9281470608792899]], AbsoluteThickness[0.25], 
     LineBox[{13279, 13280}]}, 
    {Hue[
      NCache[
       Rational[13280, 14307], 0.9282169567344657]], AbsoluteThickness[0.25], 
     LineBox[{13280, 13281}]}, 
    {Hue[
      NCache[
       Rational[233, 251], 0.9282868525896414]], AbsoluteThickness[0.25], 
     LineBox[{13281, 13282}]}, 
    {Hue[
      NCache[
       Rational[13282, 14307], 0.9283567484448172]], AbsoluteThickness[0.25], 
     LineBox[{13282, 13283}]}, 
    {Hue[
      NCache[
       Rational[13283, 14307], 0.928426644299993]], AbsoluteThickness[0.25], 
     LineBox[{13283, 13284}]}, 
    {Hue[
      NCache[
       Rational[4428, 4769], 0.9284965401551688]], AbsoluteThickness[0.25], 
     LineBox[{13284, 13285}]}, 
    {Hue[
      NCache[
       Rational[13285, 14307], 0.9285664360103446]], AbsoluteThickness[0.25], 
     LineBox[{13285, 13286}]}, 
    {Hue[
      NCache[
       Rational[13286, 14307], 0.9286363318655204]], AbsoluteThickness[0.25], 
     LineBox[{13286, 13287}]}, 
    {Hue[
      NCache[
       Rational[4429, 4769], 0.9287062277206961]], AbsoluteThickness[0.25], 
     LineBox[{13287, 13288}]}, 
    {Hue[
      NCache[
       Rational[13288, 14307], 0.9287761235758719]], AbsoluteThickness[0.25], 
     LineBox[{13288, 13289}]}, 
    {Hue[
      NCache[
       Rational[13289, 14307], 0.9288460194310477]], AbsoluteThickness[0.25], 
     LineBox[{13289, 13290}]}, 
    {Hue[
      NCache[
       Rational[4430, 4769], 0.9289159152862235]], AbsoluteThickness[0.25], 
     LineBox[{13290, 13291}]}, 
    {Hue[
      NCache[
       Rational[13291, 14307], 0.9289858111413993]], AbsoluteThickness[0.25], 
     LineBox[{13291, 13292}]}, 
    {Hue[
      NCache[
       Rational[13292, 14307], 0.9290557069965751]], AbsoluteThickness[0.25], 
     LineBox[{13292, 13293}]}, 
    {Hue[
      NCache[
       Rational[4431, 4769], 0.9291256028517509]], AbsoluteThickness[0.25], 
     LineBox[{13293, 13294}]}, 
    {Hue[
      NCache[
       Rational[13294, 14307], 0.9291954987069266]], AbsoluteThickness[0.25], 
     LineBox[{13294, 13295}]}, 
    {Hue[
      NCache[
       Rational[13295, 14307], 0.9292653945621024]], AbsoluteThickness[0.25], 
     LineBox[{13295, 13296}]}, 
    {Hue[
      NCache[
       Rational[4432, 4769], 0.9293352904172782]], AbsoluteThickness[0.25], 
     LineBox[{13296, 13297}]}, 
    {Hue[
      NCache[
       Rational[13297, 14307], 0.929405186272454]], AbsoluteThickness[0.25], 
     LineBox[{13297, 13298}]}, 
    {Hue[
      NCache[
       Rational[13298, 14307], 0.9294750821276299]], AbsoluteThickness[0.25], 
     LineBox[{13298, 13299}]}, 
    {Hue[
      NCache[
       Rational[4433, 4769], 0.9295449779828057]], AbsoluteThickness[0.25], 
     LineBox[{13299, 13300}]}, 
    {Hue[
      NCache[
       Rational[700, 753], 0.9296148738379814]], AbsoluteThickness[0.25], 
     LineBox[{13300, 13301}]}, 
    {Hue[
      NCache[
       Rational[13301, 14307], 0.9296847696931572]], AbsoluteThickness[0.25], 
     LineBox[{13301, 13302}]}, 
    {Hue[
      NCache[
       Rational[4434, 4769], 0.929754665548333]], AbsoluteThickness[0.25], 
     LineBox[{13302, 13303}]}, 
    {Hue[
      NCache[
       Rational[53, 57], 0.9298245614035088]], AbsoluteThickness[0.25], 
     LineBox[{13303, 13304}]}, 
    {Hue[
      NCache[
       Rational[13304, 14307], 0.9298944572586846]], AbsoluteThickness[0.25], 
     LineBox[{13304, 13305}]}, 
    {Hue[
      NCache[
       Rational[4435, 4769], 0.9299643531138604]], AbsoluteThickness[0.25], 
     LineBox[{13305, 13306}]}, 
    {Hue[
      NCache[
       Rational[13306, 14307], 0.9300342489690361]], AbsoluteThickness[0.25], 
     LineBox[{13306, 13307}]}, 
    {Hue[
      NCache[
       Rational[13307, 14307], 0.9301041448242119]], AbsoluteThickness[0.25], 
     LineBox[{13307, 13308}]}, 
    {Hue[
      NCache[
       Rational[4436, 4769], 0.9301740406793877]], AbsoluteThickness[0.25], 
     LineBox[{13308, 13309}]}, 
    {Hue[
      NCache[
       Rational[13309, 14307], 0.9302439365345635]], AbsoluteThickness[0.25], 
     LineBox[{13309, 13310}]}, 
    {Hue[
      NCache[
       Rational[13310, 14307], 0.9303138323897393]], AbsoluteThickness[0.25], 
     LineBox[{13310, 13311}]}, 
    {Hue[
      NCache[
       Rational[4437, 4769], 0.9303837282449151]], AbsoluteThickness[0.25], 
     LineBox[{13311, 13312}]}, 
    {Hue[
      NCache[
       Rational[13312, 14307], 0.9304536241000909]], AbsoluteThickness[0.25], 
     LineBox[{13312, 13313}]}, 
    {Hue[
      NCache[
       Rational[13313, 14307], 0.9305235199552666]], AbsoluteThickness[0.25], 
     LineBox[{13313, 13314}]}, 
    {Hue[
      NCache[
       Rational[4438, 4769], 0.9305934158104424]], AbsoluteThickness[0.25], 
     LineBox[{13314, 13315}]}, 
    {Hue[
      NCache[
       Rational[13315, 14307], 0.9306633116656182]], AbsoluteThickness[0.25], 
     LineBox[{13315, 13316}]}, 
    {Hue[
      NCache[
       Rational[13316, 14307], 0.930733207520794]], AbsoluteThickness[0.25], 
     LineBox[{13316, 13317}]}, 
    {Hue[
      NCache[
       Rational[4439, 4769], 0.9308031033759698]], AbsoluteThickness[0.25], 
     LineBox[{13317, 13318}]}, 
    {Hue[
      NCache[
       Rational[13318, 14307], 0.9308729992311456]], AbsoluteThickness[0.25], 
     LineBox[{13318, 13319}]}, 
    {Hue[
      NCache[
       Rational[701, 753], 0.9309428950863213]], AbsoluteThickness[0.25], 
     LineBox[{13319, 13320}]}, 
    {Hue[
      NCache[
       Rational[4440, 4769], 0.9310127909414971]], AbsoluteThickness[0.25], 
     LineBox[{13320, 13321}]}, 
    {Hue[
      NCache[
       Rational[13321, 14307], 0.9310826867966729]], AbsoluteThickness[0.25], 
     LineBox[{13321, 13322}]}, 
    {Hue[
      NCache[
       Rational[13322, 14307], 0.9311525826518487]], AbsoluteThickness[0.25], 
     LineBox[{13322, 13323}]}, 
    {Hue[
      NCache[
       Rational[4441, 4769], 0.9312224785070246]], AbsoluteThickness[0.25], 
     LineBox[{13323, 13324}]}, 
    {Hue[
      NCache[
       Rational[13324, 14307], 0.9312923743622004]], AbsoluteThickness[0.25], 
     LineBox[{13324, 13325}]}, 
    {Hue[
      NCache[
       Rational[13325, 14307], 0.9313622702173762]], AbsoluteThickness[0.25], 
     LineBox[{13325, 13326}]}, 
    {Hue[
      NCache[
       Rational[4442, 4769], 0.9314321660725519]], AbsoluteThickness[0.25], 
     LineBox[{13326, 13327}]}, 
    {Hue[
      NCache[
       Rational[13327, 14307], 0.9315020619277277]], AbsoluteThickness[0.25], 
     LineBox[{13327, 13328}]}, 
    {Hue[
      NCache[
       Rational[13328, 14307], 0.9315719577829035]], AbsoluteThickness[0.25], 
     LineBox[{13328, 13329}]}, 
    {Hue[
      NCache[
       Rational[4443, 4769], 0.9316418536380793]], AbsoluteThickness[0.25], 
     LineBox[{13329, 13330}]}, 
    {Hue[
      NCache[
       Rational[13330, 14307], 0.9317117494932551]], AbsoluteThickness[0.25], 
     LineBox[{13330, 13331}]}, 
    {Hue[
      NCache[
       Rational[13331, 14307], 0.9317816453484309]], AbsoluteThickness[0.25], 
     LineBox[{13331, 13332}]}, 
    {Hue[
      NCache[
       Rational[4444, 4769], 0.9318515412036066]], AbsoluteThickness[0.25], 
     LineBox[{13332, 13333}]}, 
    {Hue[
      NCache[
       Rational[13333, 14307], 0.9319214370587824]], AbsoluteThickness[0.25], 
     LineBox[{13333, 13334}]}, 
    {Hue[
      NCache[
       Rational[13334, 14307], 0.9319913329139582]], AbsoluteThickness[0.25], 
     LineBox[{13334, 13335}]}, 
    {Hue[
      NCache[
       Rational[4445, 4769], 0.932061228769134]], AbsoluteThickness[0.25], 
     LineBox[{13335, 13336}]}, 
    {Hue[
      NCache[
       Rational[13336, 14307], 0.9321311246243098]], AbsoluteThickness[0.25], 
     LineBox[{13336, 13337}]}, 
    {Hue[
      NCache[
       Rational[13337, 14307], 0.9322010204794856]], AbsoluteThickness[0.25], 
     LineBox[{13337, 13338}]}, 
    {Hue[
      NCache[
       Rational[234, 251], 0.9322709163346613]], AbsoluteThickness[0.25], 
     LineBox[{13338, 13339}]}, 
    {Hue[
      NCache[
       Rational[13339, 14307], 0.9323408121898371]], AbsoluteThickness[0.25], 
     LineBox[{13339, 13340}]}, 
    {Hue[
      NCache[
       Rational[13340, 14307], 0.9324107080450129]], AbsoluteThickness[0.25], 
     LineBox[{13340, 13341}]}, 
    {Hue[
      NCache[
       Rational[4447, 4769], 0.9324806039001887]], AbsoluteThickness[0.25], 
     LineBox[{13341, 13342}]}, 
    {Hue[
      NCache[
       Rational[13342, 14307], 0.9325504997553645]], AbsoluteThickness[0.25], 
     LineBox[{13342, 13343}]}, 
    {Hue[
      NCache[
       Rational[13343, 14307], 0.9326203956105403]], AbsoluteThickness[0.25], 
     LineBox[{13343, 13344}]}, 
    {Hue[
      NCache[
       Rational[4448, 4769], 0.9326902914657161]], AbsoluteThickness[0.25], 
     LineBox[{13344, 13345}]}, 
    {Hue[
      NCache[
       Rational[13345, 14307], 0.9327601873208918]], AbsoluteThickness[0.25], 
     LineBox[{13345, 13346}]}, 
    {Hue[
      NCache[
       Rational[13346, 14307], 0.9328300831760676]], AbsoluteThickness[0.25], 
     LineBox[{13346, 13347}]}, 
    {Hue[
      NCache[
       Rational[4449, 4769], 0.9328999790312434]], AbsoluteThickness[0.25], 
     LineBox[{13347, 13348}]}, 
    {Hue[
      NCache[
       Rational[13348, 14307], 0.9329698748864192]], AbsoluteThickness[0.25], 
     LineBox[{13348, 13349}]}, 
    {Hue[
      NCache[
       Rational[13349, 14307], 0.933039770741595]], AbsoluteThickness[0.25], 
     LineBox[{13349, 13350}]}, 
    {Hue[
      NCache[
       Rational[4450, 4769], 0.9331096665967709]], AbsoluteThickness[0.25], 
     LineBox[{13350, 13351}]}, 
    {Hue[
      NCache[
       Rational[13351, 14307], 0.9331795624519466]], AbsoluteThickness[0.25], 
     LineBox[{13351, 13352}]}, 
    {Hue[
      NCache[
       Rational[13352, 14307], 0.9332494583071224]], AbsoluteThickness[0.25], 
     LineBox[{13352, 13353}]}, 
    {Hue[
      NCache[
       Rational[4451, 4769], 0.9333193541622982]], AbsoluteThickness[0.25], 
     LineBox[{13353, 13354}]}, 
    {Hue[
      NCache[
       Rational[13354, 14307], 0.933389250017474]], AbsoluteThickness[0.25], 
     LineBox[{13354, 13355}]}, 
    {Hue[
      NCache[
       Rational[13355, 14307], 0.9334591458726498]], AbsoluteThickness[0.25], 
     LineBox[{13355, 13356}]}, 
    {Hue[
      NCache[
       Rational[4452, 4769], 0.9335290417278256]], AbsoluteThickness[0.25], 
     LineBox[{13356, 13357}]}, 
    {Hue[
      NCache[
       Rational[703, 753], 0.9335989375830013]], AbsoluteThickness[0.25], 
     LineBox[{13357, 13358}]}, 
    {Hue[
      NCache[
       Rational[13358, 14307], 0.9336688334381771]], AbsoluteThickness[0.25], 
     LineBox[{13358, 13359}]}, 
    {Hue[
      NCache[
       Rational[4453, 4769], 0.9337387292933529]], AbsoluteThickness[0.25], 
     LineBox[{13359, 13360}]}, 
    {Hue[
      NCache[
       Rational[13360, 14307], 0.9338086251485287]], AbsoluteThickness[0.25], 
     LineBox[{13360, 13361}]}, 
    {Hue[
      NCache[
       Rational[13361, 14307], 0.9338785210037045]], AbsoluteThickness[0.25], 
     LineBox[{13361, 13362}]}, 
    {Hue[
      NCache[
       Rational[4454, 4769], 0.9339484168588803]], AbsoluteThickness[0.25], 
     LineBox[{13362, 13363}]}, 
    {Hue[
      NCache[
       Rational[13363, 14307], 0.9340183127140561]], AbsoluteThickness[0.25], 
     LineBox[{13363, 13364}]}, 
    {Hue[
      NCache[
       Rational[13364, 14307], 0.9340882085692318]], AbsoluteThickness[0.25], 
     LineBox[{13364, 13365}]}, 
    {Hue[
      NCache[
       Rational[4455, 4769], 0.9341581044244076]], AbsoluteThickness[0.25], 
     LineBox[{13365, 13366}]}, 
    {Hue[
      NCache[
       Rational[13366, 14307], 0.9342280002795834]], AbsoluteThickness[0.25], 
     LineBox[{13366, 13367}]}, 
    {Hue[
      NCache[
       Rational[13367, 14307], 0.9342978961347592]], AbsoluteThickness[0.25], 
     LineBox[{13367, 13368}]}, 
    {Hue[
      NCache[
       Rational[4456, 4769], 0.934367791989935]], AbsoluteThickness[0.25], 
     LineBox[{13368, 13369}]}, 
    {Hue[
      NCache[
       Rational[13369, 14307], 0.9344376878451108]], AbsoluteThickness[0.25], 
     LineBox[{13369, 13370}]}, 
    {Hue[
      NCache[
       Rational[13370, 14307], 0.9345075837002865]], AbsoluteThickness[0.25], 
     LineBox[{13370, 13371}]}, 
    {Hue[
      NCache[
       Rational[4457, 4769], 0.9345774795554623]], AbsoluteThickness[0.25], 
     LineBox[{13371, 13372}]}, 
    {Hue[
      NCache[
       Rational[13372, 14307], 0.9346473754106381]], AbsoluteThickness[0.25], 
     LineBox[{13372, 13373}]}, 
    {Hue[
      NCache[
       Rational[13373, 14307], 0.9347172712658139]], AbsoluteThickness[0.25], 
     LineBox[{13373, 13374}]}, 
    {Hue[
      NCache[
       Rational[4458, 4769], 0.9347871671209897]], AbsoluteThickness[0.25], 
     LineBox[{13374, 13375}]}, 
    {Hue[
      NCache[
       Rational[13375, 14307], 0.9348570629761656]], AbsoluteThickness[0.25], 
     LineBox[{13375, 13376}]}, 
    {Hue[
      NCache[
       Rational[704, 753], 0.9349269588313412]], AbsoluteThickness[0.25], 
     LineBox[{13376, 13377}]}, 
    {Hue[
      NCache[
       Rational[4459, 4769], 0.934996854686517]], AbsoluteThickness[0.25], 
     LineBox[{13377, 13378}]}, 
    {Hue[
      NCache[
       Rational[13378, 14307], 0.9350667505416929]], AbsoluteThickness[0.25], 
     LineBox[{13378, 13379}]}, 
    {Hue[
      NCache[
       Rational[13379, 14307], 0.9351366463968687]], AbsoluteThickness[0.25], 
     LineBox[{13379, 13380}]}, 
    {Hue[
      NCache[
       Rational[4460, 4769], 0.9352065422520445]], AbsoluteThickness[0.25], 
     LineBox[{13380, 13381}]}, 
    {Hue[
      NCache[
       Rational[13381, 14307], 0.9352764381072203]], AbsoluteThickness[0.25], 
     LineBox[{13381, 13382}]}, 
    {Hue[
      NCache[
       Rational[13382, 14307], 0.9353463339623961]], AbsoluteThickness[0.25], 
     LineBox[{13382, 13383}]}, 
    {Hue[
      NCache[
       Rational[4461, 4769], 0.9354162298175718]], AbsoluteThickness[0.25], 
     LineBox[{13383, 13384}]}, 
    {Hue[
      NCache[
       Rational[13384, 14307], 0.9354861256727476]], AbsoluteThickness[0.25], 
     LineBox[{13384, 13385}]}, 
    {Hue[
      NCache[
       Rational[13385, 14307], 0.9355560215279234]], AbsoluteThickness[0.25], 
     LineBox[{13385, 13386}]}, 
    {Hue[
      NCache[
       Rational[4462, 4769], 0.9356259173830992]], AbsoluteThickness[0.25], 
     LineBox[{13386, 13387}]}, 
    {Hue[
      NCache[
       Rational[13387, 14307], 0.935695813238275]], AbsoluteThickness[0.25], 
     LineBox[{13387, 13388}]}, 
    {Hue[
      NCache[
       Rational[13388, 14307], 0.9357657090934508]], AbsoluteThickness[0.25], 
     LineBox[{13388, 13389}]}, 
    {Hue[
      NCache[
       Rational[4463, 4769], 0.9358356049486265]], AbsoluteThickness[0.25], 
     LineBox[{13389, 13390}]}, 
    {Hue[
      NCache[
       Rational[13390, 14307], 0.9359055008038023]], AbsoluteThickness[0.25], 
     LineBox[{13390, 13391}]}, 
    {Hue[
      NCache[
       Rational[13391, 14307], 0.9359753966589781]], AbsoluteThickness[0.25], 
     LineBox[{13391, 13392}]}, 
    {Hue[
      NCache[
       Rational[4464, 4769], 0.9360452925141539]], AbsoluteThickness[0.25], 
     LineBox[{13392, 13393}]}, 
    {Hue[
      NCache[
       Rational[13393, 14307], 0.9361151883693297]], AbsoluteThickness[0.25], 
     LineBox[{13393, 13394}]}, 
    {Hue[
      NCache[
       Rational[13394, 14307], 0.9361850842245055]], AbsoluteThickness[0.25], 
     LineBox[{13394, 13395}]}, 
    {Hue[
      NCache[
       Rational[235, 251], 0.9362549800796812]], AbsoluteThickness[0.25], 
     LineBox[{13395, 13396}]}, 
    {Hue[
      NCache[
       Rational[13396, 14307], 0.936324875934857]], AbsoluteThickness[0.25], 
     LineBox[{13396, 13397}]}, 
    {Hue[
      NCache[
       Rational[13397, 14307], 0.9363947717900328]], AbsoluteThickness[0.25], 
     LineBox[{13397, 13398}]}, 
    {Hue[
      NCache[
       Rational[4466, 4769], 0.9364646676452086]], AbsoluteThickness[0.25], 
     LineBox[{13398, 13399}]}, 
    {Hue[
      NCache[
       Rational[13399, 14307], 0.9365345635003844]], AbsoluteThickness[0.25], 
     LineBox[{13399, 13400}]}, 
    {Hue[
      NCache[
       Rational[13400, 14307], 0.9366044593555602]], AbsoluteThickness[0.25], 
     LineBox[{13400, 13401}]}, 
    {Hue[
      NCache[
       Rational[4467, 4769], 0.936674355210736]], AbsoluteThickness[0.25], 
     LineBox[{13401, 13402}]}, 
    {Hue[
      NCache[
       Rational[13402, 14307], 0.9367442510659117]], AbsoluteThickness[0.25], 
     LineBox[{13402, 13403}]}, 
    {Hue[
      NCache[
       Rational[13403, 14307], 0.9368141469210876]], AbsoluteThickness[0.25], 
     LineBox[{13403, 13404}]}, 
    {Hue[
      NCache[
       Rational[4468, 4769], 0.9368840427762634]], AbsoluteThickness[0.25], 
     LineBox[{13404, 13405}]}, 
    {Hue[
      NCache[
       Rational[13405, 14307], 0.9369539386314392]], AbsoluteThickness[0.25], 
     LineBox[{13405, 13406}]}, 
    {Hue[
      NCache[
       Rational[13406, 14307], 0.937023834486615]], AbsoluteThickness[0.25], 
     LineBox[{13406, 13407}]}, 
    {Hue[
      NCache[
       Rational[4469, 4769], 0.9370937303417908]], AbsoluteThickness[0.25], 
     LineBox[{13407, 13408}]}, 
    {Hue[
      NCache[
       Rational[13408, 14307], 0.9371636261969665]], AbsoluteThickness[0.25], 
     LineBox[{13408, 13409}]}, 
    {Hue[
      NCache[
       Rational[13409, 14307], 0.9372335220521423]], AbsoluteThickness[0.25], 
     LineBox[{13409, 13410}]}, 
    {Hue[
      NCache[
       Rational[4470, 4769], 0.9373034179073181]], AbsoluteThickness[0.25], 
     LineBox[{13410, 13411}]}, 
    {Hue[
      NCache[
       Rational[13411, 14307], 0.9373733137624939]], AbsoluteThickness[0.25], 
     LineBox[{13411, 13412}]}, 
    {Hue[
      NCache[
       Rational[13412, 14307], 0.9374432096176697]], AbsoluteThickness[0.25], 
     LineBox[{13412, 13413}]}, 
    {Hue[
      NCache[
       Rational[4471, 4769], 0.9375131054728455]], AbsoluteThickness[0.25], 
     LineBox[{13413, 13414}]}, 
    {Hue[
      NCache[
       Rational[706, 753], 0.9375830013280213]], AbsoluteThickness[0.25], 
     LineBox[{13414, 13415}]}, 
    {Hue[
      NCache[
       Rational[13415, 14307], 0.937652897183197]], AbsoluteThickness[0.25], 
     LineBox[{13415, 13416}]}, 
    {Hue[
      NCache[
       Rational[4472, 4769], 0.9377227930383728]], AbsoluteThickness[0.25], 
     LineBox[{13416, 13417}]}, 
    {Hue[
      NCache[
       Rational[13417, 14307], 0.9377926888935486]], AbsoluteThickness[0.25], 
     LineBox[{13417, 13418}]}, 
    {Hue[
      NCache[
       Rational[13418, 14307], 0.9378625847487244]], AbsoluteThickness[0.25], 
     LineBox[{13418, 13419}]}, 
    {Hue[
      NCache[
       Rational[4473, 4769], 0.9379324806039002]], AbsoluteThickness[0.25], 
     LineBox[{13419, 13420}]}, 
    {Hue[
      NCache[
       Rational[13420, 14307], 0.938002376459076]], AbsoluteThickness[0.25], 
     LineBox[{13420, 13421}]}, 
    {Hue[
      NCache[
       Rational[13421, 14307], 0.9380722723142517]], AbsoluteThickness[0.25], 
     LineBox[{13421, 13422}]}, 
    {Hue[
      NCache[
       Rational[4474, 4769], 0.9381421681694275]], AbsoluteThickness[0.25], 
     LineBox[{13422, 13423}]}, 
    {Hue[
      NCache[
       Rational[13423, 14307], 0.9382120640246033]], AbsoluteThickness[0.25], 
     LineBox[{13423, 13424}]}, 
    {Hue[
      NCache[
       Rational[13424, 14307], 0.9382819598797791]], AbsoluteThickness[0.25], 
     LineBox[{13424, 13425}]}, 
    {Hue[
      NCache[
       Rational[4475, 4769], 0.9383518557349549]], AbsoluteThickness[0.25], 
     LineBox[{13425, 13426}]}, 
    {Hue[
      NCache[
       Rational[13426, 14307], 0.9384217515901307]], AbsoluteThickness[0.25], 
     LineBox[{13426, 13427}]}, 
    {Hue[
      NCache[
       Rational[13427, 14307], 0.9384916474453064]], AbsoluteThickness[0.25], 
     LineBox[{13427, 13428}]}, 
    {Hue[
      NCache[
       Rational[4476, 4769], 0.9385615433004822]], AbsoluteThickness[0.25], 
     LineBox[{13428, 13429}]}, 
    {Hue[
      NCache[
       Rational[13429, 14307], 0.938631439155658]], AbsoluteThickness[0.25], 
     LineBox[{13429, 13430}]}, 
    {Hue[
      NCache[
       Rational[13430, 14307], 0.9387013350108339]], AbsoluteThickness[0.25], 
     LineBox[{13430, 13431}]}, 
    {Hue[
      NCache[
       Rational[4477, 4769], 0.9387712308660097]], AbsoluteThickness[0.25], 
     LineBox[{13431, 13432}]}, 
    {Hue[
      NCache[
       Rational[13432, 14307], 0.9388411267211855]], AbsoluteThickness[0.25], 
     LineBox[{13432, 13433}]}, 
    {Hue[
      NCache[
       Rational[707, 753], 0.9389110225763613]], AbsoluteThickness[0.25], 
     LineBox[{13433, 13434}]}, 
    {Hue[
      NCache[
       Rational[4478, 4769], 0.938980918431537]], AbsoluteThickness[0.25], 
     LineBox[{13434, 13435}]}, 
    {Hue[
      NCache[
       Rational[13435, 14307], 0.9390508142867128]], AbsoluteThickness[0.25], 
     LineBox[{13435, 13436}]}, 
    {Hue[
      NCache[
       Rational[13436, 14307], 0.9391207101418886]], AbsoluteThickness[0.25], 
     LineBox[{13436, 13437}]}, 
    {Hue[
      NCache[
       Rational[4479, 4769], 0.9391906059970644]], AbsoluteThickness[0.25], 
     LineBox[{13437, 13438}]}, 
    {Hue[
      NCache[
       Rational[13438, 14307], 0.9392605018522402]], AbsoluteThickness[0.25], 
     LineBox[{13438, 13439}]}, 
    {Hue[
      NCache[
       Rational[13439, 14307], 0.939330397707416]], AbsoluteThickness[0.25], 
     LineBox[{13439, 13440}]}, 
    {Hue[
      NCache[
       Rational[4480, 4769], 0.9394002935625917]], AbsoluteThickness[0.25], 
     LineBox[{13440, 13441}]}, 
    {Hue[
      NCache[
       Rational[13441, 14307], 0.9394701894177675]], AbsoluteThickness[0.25], 
     LineBox[{13441, 13442}]}, 
    {Hue[
      NCache[
       Rational[13442, 14307], 0.9395400852729433]], AbsoluteThickness[0.25], 
     LineBox[{13442, 13443}]}, 
    {Hue[
      NCache[
       Rational[4481, 4769], 0.9396099811281191]], AbsoluteThickness[0.25], 
     LineBox[{13443, 13444}]}, 
    {Hue[
      NCache[
       Rational[13444, 14307], 0.9396798769832949]], AbsoluteThickness[0.25], 
     LineBox[{13444, 13445}]}, 
    {Hue[
      NCache[
       Rational[13445, 14307], 0.9397497728384707]], AbsoluteThickness[0.25], 
     LineBox[{13445, 13446}]}, 
    {Hue[
      NCache[
       Rational[4482, 4769], 0.9398196686936464]], AbsoluteThickness[0.25], 
     LineBox[{13446, 13447}]}, 
    {Hue[
      NCache[
       Rational[13447, 14307], 0.9398895645488222]], AbsoluteThickness[0.25], 
     LineBox[{13447, 13448}]}, 
    {Hue[
      NCache[
       Rational[13448, 14307], 0.939959460403998]], AbsoluteThickness[0.25], 
     LineBox[{13448, 13449}]}, 
    {Hue[
      NCache[
       Rational[4483, 4769], 0.9400293562591738]], AbsoluteThickness[0.25], 
     LineBox[{13449, 13450}]}, 
    {Hue[
      NCache[
       Rational[13450, 14307], 0.9400992521143496]], AbsoluteThickness[0.25], 
     LineBox[{13450, 13451}]}, 
    {Hue[
      NCache[
       Rational[13451, 14307], 0.9401691479695254]], AbsoluteThickness[0.25], 
     LineBox[{13451, 13452}]}, 
    {Hue[
      NCache[
       Rational[236, 251], 0.9402390438247012]], AbsoluteThickness[0.25], 
     LineBox[{13452, 13453}]}, 
    {Hue[
      NCache[
       Rational[13453, 14307], 0.9403089396798769]], AbsoluteThickness[0.25], 
     LineBox[{13453, 13454}]}, 
    {Hue[
      NCache[
       Rational[13454, 14307], 0.9403788355350527]], AbsoluteThickness[0.25], 
     LineBox[{13454, 13455}]}, 
    {Hue[
      NCache[
       Rational[4485, 4769], 0.9404487313902286]], AbsoluteThickness[0.25], 
     LineBox[{13455, 13456}]}, 
    {Hue[
      NCache[
       Rational[13456, 14307], 0.9405186272454044]], AbsoluteThickness[0.25], 
     LineBox[{13456, 13457}]}, 
    {Hue[
      NCache[
       Rational[13457, 14307], 0.9405885231005802]], AbsoluteThickness[0.25], 
     LineBox[{13457, 13458}]}, 
    {Hue[
      NCache[
       Rational[4486, 4769], 0.940658418955756]], AbsoluteThickness[0.25], 
     LineBox[{13458, 13459}]}, 
    {Hue[
      NCache[
       Rational[13459, 14307], 0.9407283148109317]], AbsoluteThickness[0.25], 
     LineBox[{13459, 13460}]}, 
    {Hue[
      NCache[
       Rational[13460, 14307], 0.9407982106661075]], AbsoluteThickness[0.25], 
     LineBox[{13460, 13461}]}, 
    {Hue[
      NCache[
       Rational[4487, 4769], 0.9408681065212833]], AbsoluteThickness[0.25], 
     LineBox[{13461, 13462}]}, 
    {Hue[
      NCache[
       Rational[13462, 14307], 0.9409380023764591]], AbsoluteThickness[0.25], 
     LineBox[{13462, 13463}]}, 
    {Hue[
      NCache[
       Rational[13463, 14307], 0.9410078982316349]], AbsoluteThickness[0.25], 
     LineBox[{13463, 13464}]}, 
    {Hue[
      NCache[
       Rational[4488, 4769], 0.9410777940868107]], AbsoluteThickness[0.25], 
     LineBox[{13464, 13465}]}, 
    {Hue[
      NCache[
       Rational[13465, 14307], 0.9411476899419864]], AbsoluteThickness[0.25], 
     LineBox[{13465, 13466}]}, 
    {Hue[
      NCache[
       Rational[13466, 14307], 0.9412175857971622]], AbsoluteThickness[0.25], 
     LineBox[{13466, 13467}]}, 
    {Hue[
      NCache[
       Rational[4489, 4769], 0.941287481652338]], AbsoluteThickness[0.25], 
     LineBox[{13467, 13468}]}, 
    {Hue[
      NCache[
       Rational[13468, 14307], 0.9413573775075138]], AbsoluteThickness[0.25], 
     LineBox[{13468, 13469}]}, 
    {Hue[
      NCache[
       Rational[13469, 14307], 0.9414272733626896]], AbsoluteThickness[0.25], 
     LineBox[{13469, 13470}]}, 
    {Hue[
      NCache[
       Rational[4490, 4769], 0.9414971692178654]], AbsoluteThickness[0.25], 
     LineBox[{13470, 13471}]}, 
    {Hue[
      NCache[
       Rational[709, 753], 0.9415670650730412]], AbsoluteThickness[0.25], 
     LineBox[{13471, 13472}]}, 
    {Hue[
      NCache[
       Rational[13472, 14307], 0.9416369609282169]], AbsoluteThickness[0.25], 
     LineBox[{13472, 13473}]}, 
    {Hue[
      NCache[
       Rational[4491, 4769], 0.9417068567833927]], AbsoluteThickness[0.25], 
     LineBox[{13473, 13474}]}, 
    {Hue[
      NCache[
       Rational[13474, 14307], 0.9417767526385685]], AbsoluteThickness[0.25], 
     LineBox[{13474, 13475}]}, 
    {Hue[
      NCache[
       Rational[13475, 14307], 0.9418466484937443]], AbsoluteThickness[0.25], 
     LineBox[{13475, 13476}]}, 
    {Hue[
      NCache[
       Rational[4492, 4769], 0.9419165443489201]], AbsoluteThickness[0.25], 
     LineBox[{13476, 13477}]}, 
    {Hue[
      NCache[
       Rational[13477, 14307], 0.9419864402040959]], AbsoluteThickness[0.25], 
     LineBox[{13477, 13478}]}, 
    {Hue[
      NCache[
       Rational[13478, 14307], 0.9420563360592716]], AbsoluteThickness[0.25], 
     LineBox[{13478, 13479}]}, 
    {Hue[
      NCache[
       Rational[4493, 4769], 0.9421262319144474]], AbsoluteThickness[0.25], 
     LineBox[{13479, 13480}]}, 
    {Hue[
      NCache[
       Rational[13480, 14307], 0.9421961277696232]], AbsoluteThickness[0.25], 
     LineBox[{13480, 13481}]}, 
    {Hue[
      NCache[
       Rational[13481, 14307], 0.942266023624799]], AbsoluteThickness[0.25], 
     LineBox[{13481, 13482}]}, 
    {Hue[
      NCache[
       Rational[4494, 4769], 0.9423359194799749]], AbsoluteThickness[0.25], 
     LineBox[{13482, 13483}]}, 
    {Hue[
      NCache[
       Rational[13483, 14307], 0.9424058153351507]], AbsoluteThickness[0.25], 
     LineBox[{13483, 13484}]}, 
    {Hue[
      NCache[
       Rational[13484, 14307], 0.9424757111903264]], AbsoluteThickness[0.25], 
     LineBox[{13484, 13485}]}, 
    {Hue[
      NCache[
       Rational[4495, 4769], 0.9425456070455022]], AbsoluteThickness[0.25], 
     LineBox[{13485, 13486}]}, 
    {Hue[
      NCache[
       Rational[13486, 14307], 0.942615502900678]], AbsoluteThickness[0.25], 
     LineBox[{13486, 13487}]}, 
    {Hue[
      NCache[
       Rational[13487, 14307], 0.9426853987558538]], AbsoluteThickness[0.25], 
     LineBox[{13487, 13488}]}, 
    {Hue[
      NCache[
       Rational[4496, 4769], 0.9427552946110296]], AbsoluteThickness[0.25], 
     LineBox[{13488, 13489}]}, 
    {Hue[
      NCache[
       Rational[13489, 14307], 0.9428251904662054]], AbsoluteThickness[0.25], 
     LineBox[{13489, 13490}]}, 
    {Hue[
      NCache[
       Rational[710, 753], 0.9428950863213812]], AbsoluteThickness[0.25], 
     LineBox[{13490, 13491}]}, 
    {Hue[
      NCache[
       Rational[4497, 4769], 0.9429649821765569]], AbsoluteThickness[0.25], 
     LineBox[{13491, 13492}]}, 
    {Hue[
      NCache[
       Rational[13492, 14307], 0.9430348780317327]], AbsoluteThickness[0.25], 
     LineBox[{13492, 13493}]}, 
    {Hue[
      NCache[
       Rational[13493, 14307], 0.9431047738869085]], AbsoluteThickness[0.25], 
     LineBox[{13493, 13494}]}, 
    {Hue[
      NCache[
       Rational[4498, 4769], 0.9431746697420843]], AbsoluteThickness[0.25], 
     LineBox[{13494, 13495}]}, 
    {Hue[
      NCache[
       Rational[13495, 14307], 0.9432445655972601]], AbsoluteThickness[0.25], 
     LineBox[{13495, 13496}]}, 
    {Hue[
      NCache[
       Rational[13496, 14307], 0.9433144614524359]], AbsoluteThickness[0.25], 
     LineBox[{13496, 13497}]}, 
    {Hue[
      NCache[
       Rational[4499, 4769], 0.9433843573076116]], AbsoluteThickness[0.25], 
     LineBox[{13497, 13498}]}, 
    {Hue[
      NCache[
       Rational[13498, 14307], 0.9434542531627874]], AbsoluteThickness[0.25], 
     LineBox[{13498, 13499}]}, 
    {Hue[
      NCache[
       Rational[13499, 14307], 0.9435241490179632]], AbsoluteThickness[0.25], 
     LineBox[{13499, 13500}]}, 
    {Hue[
      NCache[
       Rational[4500, 4769], 0.943594044873139]], AbsoluteThickness[0.25], 
     LineBox[{13500, 13501}]}, 
    {Hue[
      NCache[
       Rational[13501, 14307], 0.9436639407283148]], AbsoluteThickness[0.25], 
     LineBox[{13501, 13502}]}, 
    {Hue[
      NCache[
       Rational[13502, 14307], 0.9437338365834906]], AbsoluteThickness[0.25], 
     LineBox[{13502, 13503}]}, 
    {Hue[
      NCache[
       Rational[4501, 4769], 0.9438037324386663]], AbsoluteThickness[0.25], 
     LineBox[{13503, 13504}]}, 
    {Hue[
      NCache[
       Rational[13504, 14307], 0.9438736282938421]], AbsoluteThickness[0.25], 
     LineBox[{13504, 13505}]}, 
    {Hue[
      NCache[
       Rational[13505, 14307], 0.9439435241490179]], AbsoluteThickness[0.25], 
     LineBox[{13505, 13506}]}, 
    {Hue[
      NCache[
       Rational[4502, 4769], 0.9440134200041937]], AbsoluteThickness[0.25], 
     LineBox[{13506, 13507}]}, 
    {Hue[
      NCache[
       Rational[13507, 14307], 0.9440833158593696]], AbsoluteThickness[0.25], 
     LineBox[{13507, 13508}]}, 
    {Hue[
      NCache[
       Rational[13508, 14307], 0.9441532117145454]], AbsoluteThickness[0.25], 
     LineBox[{13508, 13509}]}, 
    {Hue[
      NCache[
       Rational[237, 251], 0.9442231075697212]], AbsoluteThickness[0.25], 
     LineBox[{13509, 13510}]}, 
    {Hue[
      NCache[
       Rational[13510, 14307], 0.9442930034248969]], AbsoluteThickness[0.25], 
     LineBox[{13510, 13511}]}, 
    {Hue[
      NCache[
       Rational[13511, 14307], 0.9443628992800727]], AbsoluteThickness[0.25], 
     LineBox[{13511, 13512}]}, 
    {Hue[
      NCache[
       Rational[4504, 4769], 0.9444327951352485]], AbsoluteThickness[0.25], 
     LineBox[{13512, 13513}]}, 
    {Hue[
      NCache[
       Rational[13513, 14307], 0.9445026909904243]], AbsoluteThickness[0.25], 
     LineBox[{13513, 13514}]}, 
    {Hue[
      NCache[
       Rational[13514, 14307], 0.9445725868456001]], AbsoluteThickness[0.25], 
     LineBox[{13514, 13515}]}, 
    {Hue[
      NCache[
       Rational[4505, 4769], 0.9446424827007759]], AbsoluteThickness[0.25], 
     LineBox[{13515, 13516}]}, 
    {Hue[
      NCache[
       Rational[13516, 14307], 0.9447123785559516]], AbsoluteThickness[0.25], 
     LineBox[{13516, 13517}]}, 
    {Hue[
      NCache[
       Rational[13517, 14307], 0.9447822744111274]], AbsoluteThickness[0.25], 
     LineBox[{13517, 13518}]}, 
    {Hue[
      NCache[
       Rational[4506, 4769], 0.9448521702663032]], AbsoluteThickness[0.25], 
     LineBox[{13518, 13519}]}, 
    {Hue[
      NCache[
       Rational[13519, 14307], 0.944922066121479]], AbsoluteThickness[0.25], 
     LineBox[{13519, 13520}]}, 
    {Hue[
      NCache[
       Rational[13520, 14307], 0.9449919619766548]], AbsoluteThickness[0.25], 
     LineBox[{13520, 13521}]}, 
    {Hue[
      NCache[
       Rational[4507, 4769], 0.9450618578318306]], AbsoluteThickness[0.25], 
     LineBox[{13521, 13522}]}, 
    {Hue[
      NCache[
       Rational[13522, 14307], 0.9451317536870064]], AbsoluteThickness[0.25], 
     LineBox[{13522, 13523}]}, 
    {Hue[
      NCache[
       Rational[13523, 14307], 0.9452016495421821]], AbsoluteThickness[0.25], 
     LineBox[{13523, 13524}]}, 
    {Hue[
      NCache[
       Rational[4508, 4769], 0.9452715453973579]], AbsoluteThickness[0.25], 
     LineBox[{13524, 13525}]}, 
    {Hue[
      NCache[
       Rational[13525, 14307], 0.9453414412525337]], AbsoluteThickness[0.25], 
     LineBox[{13525, 13526}]}, 
    {Hue[
      NCache[
       Rational[13526, 14307], 0.9454113371077095]], AbsoluteThickness[0.25], 
     LineBox[{13526, 13527}]}, 
    {Hue[
      NCache[
       Rational[4509, 4769], 0.9454812329628853]], AbsoluteThickness[0.25], 
     LineBox[{13527, 13528}]}, 
    {Hue[
      NCache[
       Rational[712, 753], 0.9455511288180611]], AbsoluteThickness[0.25], 
     LineBox[{13528, 13529}]}, 
    {Hue[
      NCache[
       Rational[13529, 14307], 0.9456210246732368]], AbsoluteThickness[0.25], 
     LineBox[{13529, 13530}]}, 
    {Hue[
      NCache[
       Rational[4510, 4769], 0.9456909205284126]], AbsoluteThickness[0.25], 
     LineBox[{13530, 13531}]}, 
    {Hue[
      NCache[
       Rational[13531, 14307], 0.9457608163835884]], AbsoluteThickness[0.25], 
     LineBox[{13531, 13532}]}, 
    {Hue[
      NCache[
       Rational[13532, 14307], 0.9458307122387642]], AbsoluteThickness[0.25], 
     LineBox[{13532, 13533}]}, 
    {Hue[
      NCache[
       Rational[4511, 4769], 0.94590060809394]], AbsoluteThickness[0.25], 
     LineBox[{13533, 13534}]}, 
    {Hue[
      NCache[
       Rational[13534, 14307], 0.9459705039491159]], AbsoluteThickness[0.25], 
     LineBox[{13534, 13535}]}, 
    {Hue[
      NCache[
       Rational[13535, 14307], 0.9460403998042916]], AbsoluteThickness[0.25], 
     LineBox[{13535, 13536}]}, 
    {Hue[
      NCache[
       Rational[4512, 4769], 0.9461102956594674]], AbsoluteThickness[0.25], 
     LineBox[{13536, 13537}]}, 
    {Hue[
      NCache[
       Rational[13537, 14307], 0.9461801915146432]], AbsoluteThickness[0.25], 
     LineBox[{13537, 13538}]}, 
    {Hue[
      NCache[
       Rational[13538, 14307], 0.946250087369819]], AbsoluteThickness[0.25], 
     LineBox[{13538, 13539}]}, 
    {Hue[
      NCache[
       Rational[4513, 4769], 0.9463199832249948]], AbsoluteThickness[0.25], 
     LineBox[{13539, 13540}]}, 
    {Hue[
      NCache[
       Rational[13540, 14307], 0.9463898790801706]], AbsoluteThickness[0.25], 
     LineBox[{13540, 13541}]}, 
    {Hue[
      NCache[
       Rational[13541, 14307], 0.9464597749353464]], AbsoluteThickness[0.25], 
     LineBox[{13541, 13542}]}, 
    {Hue[
      NCache[
       Rational[4514, 4769], 0.9465296707905221]], AbsoluteThickness[0.25], 
     LineBox[{13542, 13543}]}, 
    {Hue[
      NCache[
       Rational[13543, 14307], 0.9465995666456979]], AbsoluteThickness[0.25], 
     LineBox[{13543, 13544}]}, 
    {Hue[
      NCache[
       Rational[13544, 14307], 0.9466694625008737]], AbsoluteThickness[0.25], 
     LineBox[{13544, 13545}]}, 
    {Hue[
      NCache[
       Rational[4515, 4769], 0.9467393583560495]], AbsoluteThickness[0.25], 
     LineBox[{13545, 13546}]}, 
    {Hue[
      NCache[
       Rational[13546, 14307], 0.9468092542112253]], AbsoluteThickness[0.25], 
     LineBox[{13546, 13547}]}, 
    {Hue[
      NCache[
       Rational[713, 753], 0.9468791500664011]], AbsoluteThickness[0.25], 
     LineBox[{13547, 13548}]}, 
    {Hue[
      NCache[
       Rational[4516, 4769], 0.9469490459215768]], AbsoluteThickness[0.25], 
     LineBox[{13548, 13549}]}, 
    {Hue[
      NCache[
       Rational[13549, 14307], 0.9470189417767526]], AbsoluteThickness[0.25], 
     LineBox[{13549, 13550}]}, 
    {Hue[
      NCache[
       Rational[13550, 14307], 0.9470888376319284]], AbsoluteThickness[0.25], 
     LineBox[{13550, 13551}]}, 
    {Hue[
      NCache[
       Rational[4517, 4769], 0.9471587334871042]], AbsoluteThickness[0.25], 
     LineBox[{13551, 13552}]}, 
    {Hue[
      NCache[
       Rational[13552, 14307], 0.94722862934228]], AbsoluteThickness[0.25], 
     LineBox[{13552, 13553}]}, 
    {Hue[
      NCache[
       Rational[13553, 14307], 0.9472985251974558]], AbsoluteThickness[0.25], 
     LineBox[{13553, 13554}]}, 
    {Hue[
      NCache[
       Rational[18, 19], 0.9473684210526315]], AbsoluteThickness[0.25], 
     LineBox[{13554, 13555}]}, 
    {Hue[
      NCache[
       Rational[13555, 14307], 0.9474383169078073]], AbsoluteThickness[0.25], 
     LineBox[{13555, 13556}]}, 
    {Hue[
      NCache[
       Rational[13556, 14307], 0.9475082127629831]], AbsoluteThickness[0.25], 
     LineBox[{13556, 13557}]}, 
    {Hue[
      NCache[
       Rational[4519, 4769], 0.9475781086181589]], AbsoluteThickness[0.25], 
     LineBox[{13557, 13558}]}, 
    {Hue[
      NCache[
       Rational[13558, 14307], 0.9476480044733347]], AbsoluteThickness[0.25], 
     LineBox[{13558, 13559}]}, 
    {Hue[
      NCache[
       Rational[13559, 14307], 0.9477179003285106]], AbsoluteThickness[0.25], 
     LineBox[{13559, 13560}]}, 
    {Hue[
      NCache[
       Rational[4520, 4769], 0.9477877961836864]], AbsoluteThickness[0.25], 
     LineBox[{13560, 13561}]}, 
    {Hue[
      NCache[
       Rational[13561, 14307], 0.947857692038862]], AbsoluteThickness[0.25], 
     LineBox[{13561, 13562}]}, 
    {Hue[
      NCache[
       Rational[13562, 14307], 0.9479275878940379]], AbsoluteThickness[0.25], 
     LineBox[{13562, 13563}]}, 
    {Hue[
      NCache[
       Rational[4521, 4769], 0.9479974837492137]], AbsoluteThickness[0.25], 
     LineBox[{13563, 13564}]}, 
    {Hue[
      NCache[
       Rational[13564, 14307], 0.9480673796043895]], AbsoluteThickness[0.25], 
     LineBox[{13564, 13565}]}, 
    {Hue[
      NCache[
       Rational[13565, 14307], 0.9481372754595653]], AbsoluteThickness[0.25], 
     LineBox[{13565, 13566}]}, 
    {Hue[
      NCache[
       Rational[238, 251], 0.9482071713147411]], AbsoluteThickness[0.25], 
     LineBox[{13566, 13567}]}, 
    {Hue[
      NCache[
       Rational[13567, 14307], 0.9482770671699168]], AbsoluteThickness[0.25], 
     LineBox[{13567, 13568}]}, 
    {Hue[
      NCache[
       Rational[13568, 14307], 0.9483469630250926]], AbsoluteThickness[0.25], 
     LineBox[{13568, 13569}]}, 
    {Hue[
      NCache[
       Rational[4523, 4769], 0.9484168588802684]], AbsoluteThickness[0.25], 
     LineBox[{13569, 13570}]}, 
    {Hue[
      NCache[
       Rational[13570, 14307], 0.9484867547354442]], AbsoluteThickness[0.25], 
     LineBox[{13570, 13571}]}, 
    {Hue[
      NCache[
       Rational[13571, 14307], 0.94855665059062]], AbsoluteThickness[0.25], 
     LineBox[{13571, 13572}]}, 
    {Hue[
      NCache[
       Rational[4524, 4769], 0.9486265464457958]], AbsoluteThickness[0.25], 
     LineBox[{13572, 13573}]}, 
    {Hue[
      NCache[
       Rational[13573, 14307], 0.9486964423009715]], AbsoluteThickness[0.25], 
     LineBox[{13573, 13574}]}, 
    {Hue[
      NCache[
       Rational[13574, 14307], 0.9487663381561473]], AbsoluteThickness[0.25], 
     LineBox[{13574, 13575}]}, 
    {Hue[
      NCache[
       Rational[4525, 4769], 0.9488362340113231]], AbsoluteThickness[0.25], 
     LineBox[{13575, 13576}]}, 
    {Hue[
      NCache[
       Rational[13576, 14307], 0.9489061298664989]], AbsoluteThickness[0.25], 
     LineBox[{13576, 13577}]}, 
    {Hue[
      NCache[
       Rational[13577, 14307], 0.9489760257216747]], AbsoluteThickness[0.25], 
     LineBox[{13577, 13578}]}, 
    {Hue[
      NCache[
       Rational[4526, 4769], 0.9490459215768505]], AbsoluteThickness[0.25], 
     LineBox[{13578, 13579}]}, 
    {Hue[
      NCache[
       Rational[13579, 14307], 0.9491158174320263]], AbsoluteThickness[0.25], 
     LineBox[{13579, 13580}]}, 
    {Hue[
      NCache[
       Rational[13580, 14307], 0.949185713287202]], AbsoluteThickness[0.25], 
     LineBox[{13580, 13581}]}, 
    {Hue[
      NCache[
       Rational[4527, 4769], 0.9492556091423778]], AbsoluteThickness[0.25], 
     LineBox[{13581, 13582}]}, 
    {Hue[
      NCache[
       Rational[13582, 14307], 0.9493255049975536]], AbsoluteThickness[0.25], 
     LineBox[{13582, 13583}]}, 
    {Hue[
      NCache[
       Rational[13583, 14307], 0.9493954008527294]], AbsoluteThickness[0.25], 
     LineBox[{13583, 13584}]}, 
    {Hue[
      NCache[
       Rational[4528, 4769], 0.9494652967079052]], AbsoluteThickness[0.25], 
     LineBox[{13584, 13585}]}, 
    {Hue[
      NCache[
       Rational[715, 753], 0.949535192563081]], AbsoluteThickness[0.25], 
     LineBox[{13585, 13586}]}, 
    {Hue[
      NCache[
       Rational[13586, 14307], 0.9496050884182567]], AbsoluteThickness[0.25], 
     LineBox[{13586, 13587}]}, 
    {Hue[
      NCache[
       Rational[4529, 4769], 0.9496749842734326]], AbsoluteThickness[0.25], 
     LineBox[{13587, 13588}]}, 
    {Hue[
      NCache[
       Rational[13588, 14307], 0.9497448801286084]], AbsoluteThickness[0.25], 
     LineBox[{13588, 13589}]}, 
    {Hue[
      NCache[
       Rational[13589, 14307], 0.9498147759837842]], AbsoluteThickness[0.25], 
     LineBox[{13589, 13590}]}, 
    {Hue[
      NCache[
       Rational[4530, 4769], 0.94988467183896]], AbsoluteThickness[0.25], 
     LineBox[{13590, 13591}]}, 
    {Hue[
      NCache[
       Rational[13591, 14307], 0.9499545676941358]], AbsoluteThickness[0.25], 
     LineBox[{13591, 13592}]}, 
    {Hue[
      NCache[
       Rational[13592, 14307], 0.9500244635493115]], AbsoluteThickness[0.25], 
     LineBox[{13592, 13593}]}, 
    {Hue[
      NCache[
       Rational[4531, 4769], 0.9500943594044873]], AbsoluteThickness[0.25], 
     LineBox[{13593, 13594}]}, 
    {Hue[
      NCache[
       Rational[13594, 14307], 0.9501642552596631]], AbsoluteThickness[0.25], 
     LineBox[{13594, 13595}]}, 
    {Hue[
      NCache[
       Rational[13595, 14307], 0.9502341511148389]], AbsoluteThickness[0.25], 
     LineBox[{13595, 13596}]}, 
    {Hue[
      NCache[
       Rational[4532, 4769], 0.9503040469700147]], AbsoluteThickness[0.25], 
     LineBox[{13596, 13597}]}, 
    {Hue[
      NCache[
       Rational[13597, 14307], 0.9503739428251905]], AbsoluteThickness[0.25], 
     LineBox[{13597, 13598}]}, 
    {Hue[
      NCache[
       Rational[13598, 14307], 0.9504438386803663]], AbsoluteThickness[0.25], 
     LineBox[{13598, 13599}]}, 
    {Hue[
      NCache[
       Rational[4533, 4769], 0.950513734535542]], AbsoluteThickness[0.25], 
     LineBox[{13599, 13600}]}, 
    {Hue[
      NCache[
       Rational[13600, 14307], 0.9505836303907178]], AbsoluteThickness[0.25], 
     LineBox[{13600, 13601}]}, 
    {Hue[
      NCache[
       Rational[13601, 14307], 0.9506535262458936]], AbsoluteThickness[0.25], 
     LineBox[{13601, 13602}]}, 
    {Hue[
      NCache[
       Rational[4534, 4769], 0.9507234221010694]], AbsoluteThickness[0.25], 
     LineBox[{13602, 13603}]}, 
    {Hue[
      NCache[
       Rational[13603, 14307], 0.9507933179562452]], AbsoluteThickness[0.25], 
     LineBox[{13603, 13604}]}, 
    {Hue[
      NCache[
       Rational[716, 753], 0.950863213811421]], AbsoluteThickness[0.25], 
     LineBox[{13604, 13605}]}, 
    {Hue[
      NCache[
       Rational[4535, 4769], 0.9509331096665967]], AbsoluteThickness[0.25], 
     LineBox[{13605, 13606}]}, 
    {Hue[
      NCache[
       Rational[13606, 14307], 0.9510030055217725]], AbsoluteThickness[0.25], 
     LineBox[{13606, 13607}]}, 
    {Hue[
      NCache[
       Rational[13607, 14307], 0.9510729013769483]], AbsoluteThickness[0.25], 
     LineBox[{13607, 13608}]}, 
    {Hue[
      NCache[
       Rational[4536, 4769], 0.9511427972321241]], AbsoluteThickness[0.25], 
     LineBox[{13608, 13609}]}, 
    {Hue[
      NCache[
       Rational[13609, 14307], 0.9512126930872999]], AbsoluteThickness[0.25], 
     LineBox[{13609, 13610}]}, 
    {Hue[
      NCache[
       Rational[13610, 14307], 0.9512825889424757]], AbsoluteThickness[0.25], 
     LineBox[{13610, 13611}]}, 
    {Hue[
      NCache[
       Rational[4537, 4769], 0.9513524847976516]], AbsoluteThickness[0.25], 
     LineBox[{13611, 13612}]}, 
    {Hue[
      NCache[
       Rational[13612, 14307], 0.9514223806528272]], AbsoluteThickness[0.25], 
     LineBox[{13612, 13613}]}, 
    {Hue[
      NCache[
       Rational[13613, 14307], 0.951492276508003]], AbsoluteThickness[0.25], 
     LineBox[{13613, 13614}]}, 
    {Hue[
      NCache[
       Rational[4538, 4769], 0.9515621723631789]], AbsoluteThickness[0.25], 
     LineBox[{13614, 13615}]}, 
    {Hue[
      NCache[
       Rational[13615, 14307], 0.9516320682183547]], AbsoluteThickness[0.25], 
     LineBox[{13615, 13616}]}, 
    {Hue[
      NCache[
       Rational[13616, 14307], 0.9517019640735305]], AbsoluteThickness[0.25], 
     LineBox[{13616, 13617}]}, 
    {Hue[
      NCache[
       Rational[4539, 4769], 0.9517718599287063]], AbsoluteThickness[0.25], 
     LineBox[{13617, 13618}]}, 
    {Hue[
      NCache[
       Rational[13618, 14307], 0.951841755783882]], AbsoluteThickness[0.25], 
     LineBox[{13618, 13619}]}, 
    {Hue[
      NCache[
       Rational[13619, 14307], 0.9519116516390578]], AbsoluteThickness[0.25], 
     LineBox[{13619, 13620}]}, 
    {Hue[
      NCache[
       Rational[4540, 4769], 0.9519815474942336]], AbsoluteThickness[0.25], 
     LineBox[{13620, 13621}]}, 
    {Hue[
      NCache[
       Rational[13621, 14307], 0.9520514433494094]], AbsoluteThickness[0.25], 
     LineBox[{13621, 13622}]}, 
    {Hue[
      NCache[
       Rational[13622, 14307], 0.9521213392045852]], AbsoluteThickness[0.25], 
     LineBox[{13622, 13623}]}, 
    {Hue[
      NCache[
       Rational[239, 251], 0.952191235059761]], AbsoluteThickness[0.25], 
     LineBox[{13623, 13624}]}, 
    {Hue[
      NCache[
       Rational[13624, 14307], 0.9522611309149367]], AbsoluteThickness[0.25], 
     LineBox[{13624, 13625}]}, 
    {Hue[
      NCache[
       Rational[13625, 14307], 0.9523310267701125]], AbsoluteThickness[0.25], 
     LineBox[{13625, 13626}]}, 
    {Hue[
      NCache[
       Rational[4542, 4769], 0.9524009226252883]], AbsoluteThickness[0.25], 
     LineBox[{13626, 13627}]}, 
    {Hue[
      NCache[
       Rational[13627, 14307], 0.9524708184804641]], AbsoluteThickness[0.25], 
     LineBox[{13627, 13628}]}, 
    {Hue[
      NCache[
       Rational[13628, 14307], 0.9525407143356399]], AbsoluteThickness[0.25], 
     LineBox[{13628, 13629}]}, 
    {Hue[
      NCache[
       Rational[4543, 4769], 0.9526106101908157]], AbsoluteThickness[0.25], 
     LineBox[{13629, 13630}]}, 
    {Hue[
      NCache[
       Rational[13630, 14307], 0.9526805060459915]], AbsoluteThickness[0.25], 
     LineBox[{13630, 13631}]}, 
    {Hue[
      NCache[
       Rational[13631, 14307], 0.9527504019011672]], AbsoluteThickness[0.25], 
     LineBox[{13631, 13632}]}, 
    {Hue[
      NCache[
       Rational[4544, 4769], 0.952820297756343]], AbsoluteThickness[0.25], 
     LineBox[{13632, 13633}]}, 
    {Hue[
      NCache[
       Rational[13633, 14307], 0.9528901936115188]], AbsoluteThickness[0.25], 
     LineBox[{13633, 13634}]}, 
    {Hue[
      NCache[
       Rational[13634, 14307], 0.9529600894666946]], AbsoluteThickness[0.25], 
     LineBox[{13634, 13635}]}, 
    {Hue[
      NCache[
       Rational[4545, 4769], 0.9530299853218704]], AbsoluteThickness[0.25], 
     LineBox[{13635, 13636}]}, 
    {Hue[
      NCache[
       Rational[13636, 14307], 0.9530998811770462]], AbsoluteThickness[0.25], 
     LineBox[{13636, 13637}]}, 
    {Hue[
      NCache[
       Rational[13637, 14307], 0.9531697770322219]], AbsoluteThickness[0.25], 
     LineBox[{13637, 13638}]}, 
    {Hue[
      NCache[
       Rational[4546, 4769], 0.9532396728873977]], AbsoluteThickness[0.25], 
     LineBox[{13638, 13639}]}, 
    {Hue[
      NCache[
       Rational[13639, 14307], 0.9533095687425736]], AbsoluteThickness[0.25], 
     LineBox[{13639, 13640}]}, 
    {Hue[
      NCache[
       Rational[13640, 14307], 0.9533794645977494]], AbsoluteThickness[0.25], 
     LineBox[{13640, 13641}]}, 
    {Hue[
      NCache[
       Rational[4547, 4769], 0.9534493604529252]], AbsoluteThickness[0.25], 
     LineBox[{13641, 13642}]}, 
    {Hue[
      NCache[
       Rational[718, 753], 0.953519256308101]], AbsoluteThickness[0.25], 
     LineBox[{13642, 13643}]}, 
    {Hue[
      NCache[
       Rational[13643, 14307], 0.9535891521632767]], AbsoluteThickness[0.25], 
     LineBox[{13643, 13644}]}, 
    {Hue[
      NCache[
       Rational[4548, 4769], 0.9536590480184525]], AbsoluteThickness[0.25], 
     LineBox[{13644, 13645}]}, 
    {Hue[
      NCache[
       Rational[13645, 14307], 0.9537289438736283]], AbsoluteThickness[0.25], 
     LineBox[{13645, 13646}]}, 
    {Hue[
      NCache[
       Rational[13646, 14307], 0.9537988397288041]], AbsoluteThickness[0.25], 
     LineBox[{13646, 13647}]}, 
    {Hue[
      NCache[
       Rational[4549, 4769], 0.9538687355839799]], AbsoluteThickness[0.25], 
     LineBox[{13647, 13648}]}, 
    {Hue[
      NCache[
       Rational[13648, 14307], 0.9539386314391557]], AbsoluteThickness[0.25], 
     LineBox[{13648, 13649}]}, 
    {Hue[
      NCache[
       Rational[13649, 14307], 0.9540085272943315]], AbsoluteThickness[0.25], 
     LineBox[{13649, 13650}]}, 
    {Hue[
      NCache[
       Rational[4550, 4769], 0.9540784231495072]], AbsoluteThickness[0.25], 
     LineBox[{13650, 13651}]}, 
    {Hue[
      NCache[
       Rational[13651, 14307], 0.954148319004683]], AbsoluteThickness[0.25], 
     LineBox[{13651, 13652}]}, 
    {Hue[
      NCache[
       Rational[13652, 14307], 0.9542182148598588]], AbsoluteThickness[0.25], 
     LineBox[{13652, 13653}]}, 
    {Hue[
      NCache[
       Rational[4551, 4769], 0.9542881107150346]], AbsoluteThickness[0.25], 
     LineBox[{13653, 13654}]}, 
    {Hue[
      NCache[
       Rational[13654, 14307], 0.9543580065702104]], AbsoluteThickness[0.25], 
     LineBox[{13654, 13655}]}, 
    {Hue[
      NCache[
       Rational[13655, 14307], 0.9544279024253862]], AbsoluteThickness[0.25], 
     LineBox[{13655, 13656}]}, 
    {Hue[
      NCache[
       Rational[4552, 4769], 0.9544977982805619]], AbsoluteThickness[0.25], 
     LineBox[{13656, 13657}]}, 
    {Hue[
      NCache[
       Rational[13657, 14307], 0.9545676941357377]], AbsoluteThickness[0.25], 
     LineBox[{13657, 13658}]}, 
    {Hue[
      NCache[
       Rational[13658, 14307], 0.9546375899909135]], AbsoluteThickness[0.25], 
     LineBox[{13658, 13659}]}, 
    {Hue[
      NCache[
       Rational[4553, 4769], 0.9547074858460893]], AbsoluteThickness[0.25], 
     LineBox[{13659, 13660}]}, 
    {Hue[
      NCache[
       Rational[13660, 14307], 0.9547773817012651]], AbsoluteThickness[0.25], 
     LineBox[{13660, 13661}]}, 
    {Hue[
      NCache[
       Rational[719, 753], 0.9548472775564409]], AbsoluteThickness[0.25], 
     LineBox[{13661, 13662}]}, 
    {Hue[
      NCache[
       Rational[4554, 4769], 0.9549171734116166]], AbsoluteThickness[0.25], 
     LineBox[{13662, 13663}]}, 
    {Hue[
      NCache[
       Rational[13663, 14307], 0.9549870692667924]], AbsoluteThickness[0.25], 
     LineBox[{13663, 13664}]}, 
    {Hue[
      NCache[
       Rational[13664, 14307], 0.9550569651219682]], AbsoluteThickness[0.25], 
     LineBox[{13664, 13665}]}, 
    {Hue[
      NCache[
       Rational[4555, 4769], 0.955126860977144]], AbsoluteThickness[0.25], 
     LineBox[{13665, 13666}]}, 
    {Hue[
      NCache[
       Rational[13666, 14307], 0.9551967568323199]], AbsoluteThickness[0.25], 
     LineBox[{13666, 13667}]}, 
    {Hue[
      NCache[
       Rational[13667, 14307], 0.9552666526874957]], AbsoluteThickness[0.25], 
     LineBox[{13667, 13668}]}, 
    {Hue[
      NCache[
       Rational[4556, 4769], 0.9553365485426715]], AbsoluteThickness[0.25], 
     LineBox[{13668, 13669}]}, 
    {Hue[
      NCache[
       Rational[13669, 14307], 0.9554064443978472]], AbsoluteThickness[0.25], 
     LineBox[{13669, 13670}]}, 
    {Hue[
      NCache[
       Rational[13670, 14307], 0.955476340253023]], AbsoluteThickness[0.25], 
     LineBox[{13670, 13671}]}, 
    {Hue[
      NCache[
       Rational[4557, 4769], 0.9555462361081988]], AbsoluteThickness[0.25], 
     LineBox[{13671, 13672}]}, 
    {Hue[
      NCache[
       Rational[13672, 14307], 0.9556161319633746]], AbsoluteThickness[0.25], 
     LineBox[{13672, 13673}]}, 
    {Hue[
      NCache[
       Rational[13673, 14307], 0.9556860278185504]], AbsoluteThickness[0.25], 
     LineBox[{13673, 13674}]}, 
    {Hue[
      NCache[
       Rational[4558, 4769], 0.9557559236737262]], AbsoluteThickness[0.25], 
     LineBox[{13674, 13675}]}, 
    {Hue[
      NCache[
       Rational[13675, 14307], 0.9558258195289019]], AbsoluteThickness[0.25], 
     LineBox[{13675, 13676}]}, 
    {Hue[
      NCache[
       Rational[13676, 14307], 0.9558957153840777]], AbsoluteThickness[0.25], 
     LineBox[{13676, 13677}]}, 
    {Hue[
      NCache[
       Rational[4559, 4769], 0.9559656112392535]], AbsoluteThickness[0.25], 
     LineBox[{13677, 13678}]}, 
    {Hue[
      NCache[
       Rational[13678, 14307], 0.9560355070944293]], AbsoluteThickness[0.25], 
     LineBox[{13678, 13679}]}, 
    {Hue[
      NCache[
       Rational[13679, 14307], 0.9561054029496051]], AbsoluteThickness[0.25], 
     LineBox[{13679, 13680}]}, 
    {Hue[
      NCache[
       Rational[240, 251], 0.9561752988047809]], AbsoluteThickness[0.25], 
     LineBox[{13680, 13681}]}, 
    {Hue[
      NCache[
       Rational[13681, 14307], 0.9562451946599566]], AbsoluteThickness[0.25], 
     LineBox[{13681, 13682}]}, 
    {Hue[
      NCache[
       Rational[13682, 14307], 0.9563150905151324]], AbsoluteThickness[0.25], 
     LineBox[{13682, 13683}]}, 
    {Hue[
      NCache[
       Rational[4561, 4769], 0.9563849863703082]], AbsoluteThickness[0.25], 
     LineBox[{13683, 13684}]}, 
    {Hue[
      NCache[
       Rational[13684, 14307], 0.956454882225484]], AbsoluteThickness[0.25], 
     LineBox[{13684, 13685}]}, 
    {Hue[
      NCache[
       Rational[13685, 14307], 0.9565247780806598]], AbsoluteThickness[0.25], 
     LineBox[{13685, 13686}]}, 
    {Hue[
      NCache[
       Rational[4562, 4769], 0.9565946739358356]], AbsoluteThickness[0.25], 
     LineBox[{13686, 13687}]}, 
    {Hue[
      NCache[
       Rational[13687, 14307], 0.9566645697910114]], AbsoluteThickness[0.25], 
     LineBox[{13687, 13688}]}, 
    {Hue[
      NCache[
       Rational[13688, 14307], 0.9567344656461871]], AbsoluteThickness[0.25], 
     LineBox[{13688, 13689}]}, 
    {Hue[
      NCache[
       Rational[4563, 4769], 0.9568043615013629]], AbsoluteThickness[0.25], 
     LineBox[{13689, 13690}]}, 
    {Hue[
      NCache[
       Rational[13690, 14307], 0.9568742573565387]], AbsoluteThickness[0.25], 
     LineBox[{13690, 13691}]}, 
    {Hue[
      NCache[
       Rational[13691, 14307], 0.9569441532117146]], AbsoluteThickness[0.25], 
     LineBox[{13691, 13692}]}, 
    {Hue[
      NCache[
       Rational[4564, 4769], 0.9570140490668904]], AbsoluteThickness[0.25], 
     LineBox[{13692, 13693}]}, 
    {Hue[
      NCache[
       Rational[13693, 14307], 0.9570839449220662]], AbsoluteThickness[0.25], 
     LineBox[{13693, 13694}]}, 
    {Hue[
      NCache[
       Rational[13694, 14307], 0.9571538407772419]], AbsoluteThickness[0.25], 
     LineBox[{13694, 13695}]}, 
    {Hue[
      NCache[
       Rational[4565, 4769], 0.9572237366324177]], AbsoluteThickness[0.25], 
     LineBox[{13695, 13696}]}, 
    {Hue[
      NCache[
       Rational[13696, 14307], 0.9572936324875935]], AbsoluteThickness[0.25], 
     LineBox[{13696, 13697}]}, 
    {Hue[
      NCache[
       Rational[13697, 14307], 0.9573635283427693]], AbsoluteThickness[0.25], 
     LineBox[{13697, 13698}]}, 
    {Hue[
      NCache[
       Rational[4566, 4769], 0.9574334241979451]], AbsoluteThickness[0.25], 
     LineBox[{13698, 13699}]}, 
    {Hue[
      NCache[
       Rational[721, 753], 0.9575033200531209]], AbsoluteThickness[0.25], 
     LineBox[{13699, 13700}]}, 
    {Hue[
      NCache[
       Rational[13700, 14307], 0.9575732159082967]], AbsoluteThickness[0.25], 
     LineBox[{13700, 13701}]}, 
    {Hue[
      NCache[
       Rational[4567, 4769], 0.9576431117634724]], AbsoluteThickness[0.25], 
     LineBox[{13701, 13702}]}, 
    {Hue[
      NCache[
       Rational[13702, 14307], 0.9577130076186482]], AbsoluteThickness[0.25], 
     LineBox[{13702, 13703}]}, 
    {Hue[
      NCache[
       Rational[13703, 14307], 0.957782903473824]], AbsoluteThickness[0.25], 
     LineBox[{13703, 13704}]}, 
    {Hue[
      NCache[
       Rational[4568, 4769], 0.9578527993289998]], AbsoluteThickness[0.25], 
     LineBox[{13704, 13705}]}, 
    {Hue[
      NCache[
       Rational[13705, 14307], 0.9579226951841756]], AbsoluteThickness[0.25], 
     LineBox[{13705, 13706}]}, 
    {Hue[
      NCache[
       Rational[13706, 14307], 0.9579925910393514]], AbsoluteThickness[0.25], 
     LineBox[{13706, 13707}]}, 
    {Hue[
      NCache[
       Rational[4569, 4769], 0.9580624868945271]], AbsoluteThickness[0.25], 
     LineBox[{13707, 13708}]}, 
    {Hue[
      NCache[
       Rational[13708, 14307], 0.9581323827497029]], AbsoluteThickness[0.25], 
     LineBox[{13708, 13709}]}, 
    {Hue[
      NCache[
       Rational[13709, 14307], 0.9582022786048787]], AbsoluteThickness[0.25], 
     LineBox[{13709, 13710}]}, 
    {Hue[
      NCache[
       Rational[4570, 4769], 0.9582721744600545]], AbsoluteThickness[0.25], 
     LineBox[{13710, 13711}]}, 
    {Hue[
      NCache[
       Rational[13711, 14307], 0.9583420703152303]], AbsoluteThickness[0.25], 
     LineBox[{13711, 13712}]}, 
    {Hue[
      NCache[
       Rational[13712, 14307], 0.9584119661704061]], AbsoluteThickness[0.25], 
     LineBox[{13712, 13713}]}, 
    {Hue[
      NCache[
       Rational[4571, 4769], 0.9584818620255818]], AbsoluteThickness[0.25], 
     LineBox[{13713, 13714}]}, 
    {Hue[
      NCache[
       Rational[13714, 14307], 0.9585517578807576]], AbsoluteThickness[0.25], 
     LineBox[{13714, 13715}]}, 
    {Hue[
      NCache[
       Rational[13715, 14307], 0.9586216537359334]], AbsoluteThickness[0.25], 
     LineBox[{13715, 13716}]}, 
    {Hue[
      NCache[
       Rational[4572, 4769], 0.9586915495911092]], AbsoluteThickness[0.25], 
     LineBox[{13716, 13717}]}, 
    {Hue[
      NCache[
       Rational[13717, 14307], 0.958761445446285]], AbsoluteThickness[0.25], 
     LineBox[{13717, 13718}]}, 
    {Hue[
      NCache[
       Rational[722, 753], 0.9588313413014609]], AbsoluteThickness[0.25], 
     LineBox[{13718, 13719}]}, 
    {Hue[
      NCache[
       Rational[4573, 4769], 0.9589012371566367]], AbsoluteThickness[0.25], 
     LineBox[{13719, 13720}]}, 
    {Hue[
      NCache[
       Rational[13720, 14307], 0.9589711330118124]], AbsoluteThickness[0.25], 
     LineBox[{13720, 13721}]}, 
    {Hue[
      NCache[
       Rational[13721, 14307], 0.9590410288669882]], AbsoluteThickness[0.25], 
     LineBox[{13721, 13722}]}, 
    {Hue[
      NCache[
       Rational[4574, 4769], 0.959110924722164]], AbsoluteThickness[0.25], 
     LineBox[{13722, 13723}]}, 
    {Hue[
      NCache[
       Rational[13723, 14307], 0.9591808205773398]], AbsoluteThickness[0.25], 
     LineBox[{13723, 13724}]}, 
    {Hue[
      NCache[
       Rational[13724, 14307], 0.9592507164325156]], AbsoluteThickness[0.25], 
     LineBox[{13724, 13725}]}, 
    {Hue[
      NCache[
       Rational[4575, 4769], 0.9593206122876914]], AbsoluteThickness[0.25], 
     LineBox[{13725, 13726}]}, 
    {Hue[
      NCache[
       Rational[13726, 14307], 0.9593905081428671]], AbsoluteThickness[0.25], 
     LineBox[{13726, 13727}]}, 
    {Hue[
      NCache[
       Rational[13727, 14307], 0.9594604039980429]], AbsoluteThickness[0.25], 
     LineBox[{13727, 13728}]}, 
    {Hue[
      NCache[
       Rational[4576, 4769], 0.9595302998532187]], AbsoluteThickness[0.25], 
     LineBox[{13728, 13729}]}, 
    {Hue[
      NCache[
       Rational[13729, 14307], 0.9596001957083945]], AbsoluteThickness[0.25], 
     LineBox[{13729, 13730}]}, 
    {Hue[
      NCache[
       Rational[13730, 14307], 0.9596700915635703]], AbsoluteThickness[0.25], 
     LineBox[{13730, 13731}]}, 
    {Hue[
      NCache[
       Rational[4577, 4769], 0.9597399874187461]], AbsoluteThickness[0.25], 
     LineBox[{13731, 13732}]}, 
    {Hue[
      NCache[
       Rational[13732, 14307], 0.9598098832739218]], AbsoluteThickness[0.25], 
     LineBox[{13732, 13733}]}, 
    {Hue[
      NCache[
       Rational[13733, 14307], 0.9598797791290976]], AbsoluteThickness[0.25], 
     LineBox[{13733, 13734}]}, 
    {Hue[
      NCache[
       Rational[4578, 4769], 0.9599496749842734]], AbsoluteThickness[0.25], 
     LineBox[{13734, 13735}]}, 
    {Hue[
      NCache[
       Rational[13735, 14307], 0.9600195708394492]], AbsoluteThickness[0.25], 
     LineBox[{13735, 13736}]}, 
    {Hue[
      NCache[
       Rational[13736, 14307], 0.960089466694625]], AbsoluteThickness[0.25], 
     LineBox[{13736, 13737}]}, 
    {Hue[
      NCache[
       Rational[241, 251], 0.9601593625498008]], AbsoluteThickness[0.25], 
     LineBox[{13737, 13738}]}, 
    {Hue[
      NCache[
       Rational[13738, 14307], 0.9602292584049766]], AbsoluteThickness[0.25], 
     LineBox[{13738, 13739}]}, 
    {Hue[
      NCache[
       Rational[13739, 14307], 0.9602991542601523]], AbsoluteThickness[0.25], 
     LineBox[{13739, 13740}]}, 
    {Hue[
      NCache[
       Rational[4580, 4769], 0.9603690501153281]], AbsoluteThickness[0.25], 
     LineBox[{13740, 13741}]}, 
    {Hue[
      NCache[
       Rational[13741, 14307], 0.9604389459705039]], AbsoluteThickness[0.25], 
     LineBox[{13741, 13742}]}, 
    {Hue[
      NCache[
       Rational[13742, 14307], 0.9605088418256797]], AbsoluteThickness[0.25], 
     LineBox[{13742, 13743}]}, 
    {Hue[
      NCache[
       Rational[4581, 4769], 0.9605787376808556]], AbsoluteThickness[0.25], 
     LineBox[{13743, 13744}]}, 
    {Hue[
      NCache[
       Rational[13744, 14307], 0.9606486335360314]], AbsoluteThickness[0.25], 
     LineBox[{13744, 13745}]}, 
    {Hue[
      NCache[
       Rational[13745, 14307], 0.960718529391207]], AbsoluteThickness[0.25], 
     LineBox[{13745, 13746}]}, 
    {Hue[
      NCache[
       Rational[4582, 4769], 0.9607884252463829]], AbsoluteThickness[0.25], 
     LineBox[{13746, 13747}]}, 
    {Hue[
      NCache[
       Rational[13747, 14307], 0.9608583211015587]], AbsoluteThickness[0.25], 
     LineBox[{13747, 13748}]}, 
    {Hue[
      NCache[
       Rational[13748, 14307], 0.9609282169567345]], AbsoluteThickness[0.25], 
     LineBox[{13748, 13749}]}, 
    {Hue[
      NCache[
       Rational[4583, 4769], 0.9609981128119103]], AbsoluteThickness[0.25], 
     LineBox[{13749, 13750}]}, 
    {Hue[
      NCache[
       Rational[13750, 14307], 0.9610680086670861]], AbsoluteThickness[0.25], 
     LineBox[{13750, 13751}]}, 
    {Hue[
      NCache[
       Rational[13751, 14307], 0.9611379045222618]], AbsoluteThickness[0.25], 
     LineBox[{13751, 13752}]}, 
    {Hue[
      NCache[
       Rational[4584, 4769], 0.9612078003774376]], AbsoluteThickness[0.25], 
     LineBox[{13752, 13753}]}, 
    {Hue[
      NCache[
       Rational[13753, 14307], 0.9612776962326134]], AbsoluteThickness[0.25], 
     LineBox[{13753, 13754}]}, 
    {Hue[
      NCache[
       Rational[13754, 14307], 0.9613475920877892]], AbsoluteThickness[0.25], 
     LineBox[{13754, 13755}]}, 
    {Hue[
      NCache[
       Rational[4585, 4769], 0.961417487942965]], AbsoluteThickness[0.25], 
     LineBox[{13755, 13756}]}, 
    {Hue[
      NCache[
       Rational[724, 753], 0.9614873837981408]], AbsoluteThickness[0.25], 
     LineBox[{13756, 13757}]}, 
    {Hue[
      NCache[
       Rational[13757, 14307], 0.9615572796533166]], AbsoluteThickness[0.25], 
     LineBox[{13757, 13758}]}, 
    {Hue[
      NCache[
       Rational[4586, 4769], 0.9616271755084923]], AbsoluteThickness[0.25], 
     LineBox[{13758, 13759}]}, 
    {Hue[
      NCache[
       Rational[13759, 14307], 0.9616970713636681]], AbsoluteThickness[0.25], 
     LineBox[{13759, 13760}]}, 
    {Hue[
      NCache[
       Rational[13760, 14307], 0.9617669672188439]], AbsoluteThickness[0.25], 
     LineBox[{13760, 13761}]}, 
    {Hue[
      NCache[
       Rational[4587, 4769], 0.9618368630740197]], AbsoluteThickness[0.25], 
     LineBox[{13761, 13762}]}, 
    {Hue[
      NCache[
       Rational[13762, 14307], 0.9619067589291955]], AbsoluteThickness[0.25], 
     LineBox[{13762, 13763}]}, 
    {Hue[
      NCache[
       Rational[13763, 14307], 0.9619766547843713]], AbsoluteThickness[0.25], 
     LineBox[{13763, 13764}]}, 
    {Hue[
      NCache[
       Rational[4588, 4769], 0.962046550639547]], AbsoluteThickness[0.25], 
     LineBox[{13764, 13765}]}, 
    {Hue[
      NCache[
       Rational[13765, 14307], 0.9621164464947228]], AbsoluteThickness[0.25], 
     LineBox[{13765, 13766}]}, 
    {Hue[
      NCache[
       Rational[13766, 14307], 0.9621863423498986]], AbsoluteThickness[0.25], 
     LineBox[{13766, 13767}]}, 
    {Hue[
      NCache[
       Rational[4589, 4769], 0.9622562382050744]], AbsoluteThickness[0.25], 
     LineBox[{13767, 13768}]}, 
    {Hue[
      NCache[
       Rational[13768, 14307], 0.9623261340602502]], AbsoluteThickness[0.25], 
     LineBox[{13768, 13769}]}, 
    {Hue[
      NCache[
       Rational[13769, 14307], 0.962396029915426]], AbsoluteThickness[0.25], 
     LineBox[{13769, 13770}]}, 
    {Hue[
      NCache[
       Rational[4590, 4769], 0.9624659257706017]], AbsoluteThickness[0.25], 
     LineBox[{13770, 13771}]}, 
    {Hue[
      NCache[
       Rational[13771, 14307], 0.9625358216257776]], AbsoluteThickness[0.25], 
     LineBox[{13771, 13772}]}, 
    {Hue[
      NCache[
       Rational[13772, 14307], 0.9626057174809534]], AbsoluteThickness[0.25], 
     LineBox[{13772, 13773}]}, 
    {Hue[
      NCache[
       Rational[4591, 4769], 0.9626756133361292]], AbsoluteThickness[0.25], 
     LineBox[{13773, 13774}]}, 
    {Hue[
      NCache[
       Rational[13774, 14307], 0.962745509191305]], AbsoluteThickness[0.25], 
     LineBox[{13774, 13775}]}, 
    {Hue[
      NCache[
       Rational[725, 753], 0.9628154050464808]], AbsoluteThickness[0.25], 
     LineBox[{13775, 13776}]}, 
    {Hue[
      NCache[
       Rational[4592, 4769], 0.9628853009016566]], AbsoluteThickness[0.25], 
     LineBox[{13776, 13777}]}, 
    {Hue[
      NCache[
       Rational[13777, 14307], 0.9629551967568323]], AbsoluteThickness[0.25], 
     LineBox[{13777, 13778}]}, 
    {Hue[
      NCache[
       Rational[13778, 14307], 0.9630250926120081]], AbsoluteThickness[0.25], 
     LineBox[{13778, 13779}]}, 
    {Hue[
      NCache[
       Rational[4593, 4769], 0.9630949884671839]], AbsoluteThickness[0.25], 
     LineBox[{13779, 13780}]}, 
    {Hue[
      NCache[
       Rational[13780, 14307], 0.9631648843223597]], AbsoluteThickness[0.25], 
     LineBox[{13780, 13781}]}, 
    {Hue[
      NCache[
       Rational[13781, 14307], 0.9632347801775355]], AbsoluteThickness[0.25], 
     LineBox[{13781, 13782}]}, 
    {Hue[
      NCache[
       Rational[4594, 4769], 0.9633046760327113]], AbsoluteThickness[0.25], 
     LineBox[{13782, 13783}]}, 
    {Hue[
      NCache[
       Rational[13783, 14307], 0.963374571887887]], AbsoluteThickness[0.25], 
     LineBox[{13783, 13784}]}, 
    {Hue[
      NCache[
       Rational[13784, 14307], 0.9634444677430628]], AbsoluteThickness[0.25], 
     LineBox[{13784, 13785}]}, 
    {Hue[
      NCache[
       Rational[4595, 4769], 0.9635143635982386]], AbsoluteThickness[0.25], 
     LineBox[{13785, 13786}]}, 
    {Hue[
      NCache[
       Rational[13786, 14307], 0.9635842594534144]], AbsoluteThickness[0.25], 
     LineBox[{13786, 13787}]}, 
    {Hue[
      NCache[
       Rational[13787, 14307], 0.9636541553085902]], AbsoluteThickness[0.25], 
     LineBox[{13787, 13788}]}, 
    {Hue[
      NCache[
       Rational[4596, 4769], 0.963724051163766]], AbsoluteThickness[0.25], 
     LineBox[{13788, 13789}]}, 
    {Hue[
      NCache[
       Rational[13789, 14307], 0.9637939470189417]], AbsoluteThickness[0.25], 
     LineBox[{13789, 13790}]}, 
    {Hue[
      NCache[
       Rational[13790, 14307], 0.9638638428741175]], AbsoluteThickness[0.25], 
     LineBox[{13790, 13791}]}, 
    {Hue[
      NCache[
       Rational[4597, 4769], 0.9639337387292933]], AbsoluteThickness[0.25], 
     LineBox[{13791, 13792}]}, 
    {Hue[
      NCache[
       Rational[13792, 14307], 0.9640036345844691]], AbsoluteThickness[0.25], 
     LineBox[{13792, 13793}]}, 
    {Hue[
      NCache[
       Rational[13793, 14307], 0.9640735304396449]], AbsoluteThickness[0.25], 
     LineBox[{13793, 13794}]}, 
    {Hue[
      NCache[
       Rational[242, 251], 0.9641434262948207]], AbsoluteThickness[0.25], 
     LineBox[{13794, 13795}]}, 
    {Hue[
      NCache[
       Rational[13795, 14307], 0.9642133221499966]], AbsoluteThickness[0.25], 
     LineBox[{13795, 13796}]}, 
    {Hue[
      NCache[
       Rational[13796, 14307], 0.9642832180051722]], AbsoluteThickness[0.25], 
     LineBox[{13796, 13797}]}, 
    {Hue[
      NCache[
       Rational[4599, 4769], 0.964353113860348]], AbsoluteThickness[0.25], 
     LineBox[{13797, 13798}]}, 
    {Hue[
      NCache[
       Rational[13798, 14307], 0.9644230097155239]], AbsoluteThickness[0.25], 
     LineBox[{13798, 13799}]}, 
    {Hue[
      NCache[
       Rational[13799, 14307], 0.9644929055706997]], AbsoluteThickness[0.25], 
     LineBox[{13799, 13800}]}, 
    {Hue[
      NCache[
       Rational[4600, 4769], 0.9645628014258755]], AbsoluteThickness[0.25], 
     LineBox[{13800, 13801}]}, 
    {Hue[
      NCache[
       Rational[13801, 14307], 0.9646326972810513]], AbsoluteThickness[0.25], 
     LineBox[{13801, 13802}]}, 
    {Hue[
      NCache[
       Rational[13802, 14307], 0.964702593136227]], AbsoluteThickness[0.25], 
     LineBox[{13802, 13803}]}, 
    {Hue[
      NCache[
       Rational[4601, 4769], 0.9647724889914028]], AbsoluteThickness[0.25], 
     LineBox[{13803, 13804}]}, 
    {Hue[
      NCache[
       Rational[13804, 14307], 0.9648423848465786]], AbsoluteThickness[0.25], 
     LineBox[{13804, 13805}]}, 
    {Hue[
      NCache[
       Rational[55, 57], 0.9649122807017544]], AbsoluteThickness[0.25], 
     LineBox[{13805, 13806}]}, 
    {Hue[
      NCache[
       Rational[4602, 4769], 0.9649821765569302]], AbsoluteThickness[0.25], 
     LineBox[{13806, 13807}]}, 
    {Hue[
      NCache[
       Rational[13807, 14307], 0.965052072412106]], AbsoluteThickness[0.25], 
     LineBox[{13807, 13808}]}, 
    {Hue[
      NCache[
       Rational[13808, 14307], 0.9651219682672818]], AbsoluteThickness[0.25], 
     LineBox[{13808, 13809}]}, 
    {Hue[
      NCache[
       Rational[4603, 4769], 0.9651918641224575]], AbsoluteThickness[0.25], 
     LineBox[{13809, 13810}]}, 
    {Hue[
      NCache[
       Rational[13810, 14307], 0.9652617599776333]], AbsoluteThickness[0.25], 
     LineBox[{13810, 13811}]}, 
    {Hue[
      NCache[
       Rational[13811, 14307], 0.9653316558328091]], AbsoluteThickness[0.25], 
     LineBox[{13811, 13812}]}, 
    {Hue[
      NCache[
       Rational[4604, 4769], 0.9654015516879849]], AbsoluteThickness[0.25], 
     LineBox[{13812, 13813}]}, 
    {Hue[
      NCache[
       Rational[727, 753], 0.9654714475431607]], AbsoluteThickness[0.25], 
     LineBox[{13813, 13814}]}, 
    {Hue[
      NCache[
       Rational[13814, 14307], 0.9655413433983365]], AbsoluteThickness[0.25], 
     LineBox[{13814, 13815}]}, 
    {Hue[
      NCache[
       Rational[4605, 4769], 0.9656112392535122]], AbsoluteThickness[0.25], 
     LineBox[{13815, 13816}]}, 
    {Hue[
      NCache[
       Rational[13816, 14307], 0.965681135108688]], AbsoluteThickness[0.25], 
     LineBox[{13816, 13817}]}, 
    {Hue[
      NCache[
       Rational[13817, 14307], 0.9657510309638638]], AbsoluteThickness[0.25], 
     LineBox[{13817, 13818}]}, 
    {Hue[
      NCache[
       Rational[4606, 4769], 0.9658209268190396]], AbsoluteThickness[0.25], 
     LineBox[{13818, 13819}]}, 
    {Hue[
      NCache[
       Rational[13819, 14307], 0.9658908226742154]], AbsoluteThickness[0.25], 
     LineBox[{13819, 13820}]}, 
    {Hue[
      NCache[
       Rational[13820, 14307], 0.9659607185293912]], AbsoluteThickness[0.25], 
     LineBox[{13820, 13821}]}, 
    {Hue[
      NCache[
       Rational[4607, 4769], 0.9660306143845669]], AbsoluteThickness[0.25], 
     LineBox[{13821, 13822}]}, 
    {Hue[
      NCache[
       Rational[13822, 14307], 0.9661005102397427]], AbsoluteThickness[0.25], 
     LineBox[{13822, 13823}]}, 
    {Hue[
      NCache[
       Rational[13823, 14307], 0.9661704060949186]], AbsoluteThickness[0.25], 
     LineBox[{13823, 13824}]}, 
    {Hue[
      NCache[
       Rational[4608, 4769], 0.9662403019500944]], AbsoluteThickness[0.25], 
     LineBox[{13824, 13825}]}, 
    {Hue[
      NCache[
       Rational[13825, 14307], 0.9663101978052702]], AbsoluteThickness[0.25], 
     LineBox[{13825, 13826}]}, 
    {Hue[
      NCache[
       Rational[13826, 14307], 0.966380093660446]], AbsoluteThickness[0.25], 
     LineBox[{13826, 13827}]}, 
    {Hue[
      NCache[
       Rational[4609, 4769], 0.9664499895156218]], AbsoluteThickness[0.25], 
     LineBox[{13827, 13828}]}, 
    {Hue[
      NCache[
       Rational[13828, 14307], 0.9665198853707975]], AbsoluteThickness[0.25], 
     LineBox[{13828, 13829}]}, 
    {Hue[
      NCache[
       Rational[13829, 14307], 0.9665897812259733]], AbsoluteThickness[0.25], 
     LineBox[{13829, 13830}]}, 
    {Hue[
      NCache[
       Rational[4610, 4769], 0.9666596770811491]], AbsoluteThickness[0.25], 
     LineBox[{13830, 13831}]}, 
    {Hue[
      NCache[
       Rational[13831, 14307], 0.9667295729363249]], AbsoluteThickness[0.25], 
     LineBox[{13831, 13832}]}, 
    {Hue[
      NCache[
       Rational[728, 753], 0.9667994687915007]], AbsoluteThickness[0.25], 
     LineBox[{13832, 13833}]}, 
    {Hue[
      NCache[
       Rational[4611, 4769], 0.9668693646466765]], AbsoluteThickness[0.25], 
     LineBox[{13833, 13834}]}, 
    {Hue[
      NCache[
       Rational[13834, 14307], 0.9669392605018522]], AbsoluteThickness[0.25], 
     LineBox[{13834, 13835}]}, 
    {Hue[
      NCache[
       Rational[13835, 14307], 0.967009156357028]], AbsoluteThickness[0.25], 
     LineBox[{13835, 13836}]}, 
    {Hue[
      NCache[
       Rational[4612, 4769], 0.9670790522122038]], AbsoluteThickness[0.25], 
     LineBox[{13836, 13837}]}, 
    {Hue[
      NCache[
       Rational[13837, 14307], 0.9671489480673796]], AbsoluteThickness[0.25], 
     LineBox[{13837, 13838}]}, 
    {Hue[
      NCache[
       Rational[13838, 14307], 0.9672188439225554]], AbsoluteThickness[0.25], 
     LineBox[{13838, 13839}]}, 
    {Hue[
      NCache[
       Rational[4613, 4769], 0.9672887397777312]], AbsoluteThickness[0.25], 
     LineBox[{13839, 13840}]}, 
    {Hue[
      NCache[
       Rational[13840, 14307], 0.9673586356329069]], AbsoluteThickness[0.25], 
     LineBox[{13840, 13841}]}, 
    {Hue[
      NCache[
       Rational[13841, 14307], 0.9674285314880827]], AbsoluteThickness[0.25], 
     LineBox[{13841, 13842}]}, 
    {Hue[
      NCache[
       Rational[4614, 4769], 0.9674984273432585]], AbsoluteThickness[0.25], 
     LineBox[{13842, 13843}]}, 
    {Hue[
      NCache[
       Rational[13843, 14307], 0.9675683231984343]], AbsoluteThickness[0.25], 
     LineBox[{13843, 13844}]}, 
    {Hue[
      NCache[
       Rational[13844, 14307], 0.9676382190536101]], AbsoluteThickness[0.25], 
     LineBox[{13844, 13845}]}, 
    {Hue[
      NCache[
       Rational[4615, 4769], 0.9677081149087859]], AbsoluteThickness[0.25], 
     LineBox[{13845, 13846}]}, 
    {Hue[
      NCache[
       Rational[13846, 14307], 0.9677780107639617]], AbsoluteThickness[0.25], 
     LineBox[{13846, 13847}]}, 
    {Hue[
      NCache[
       Rational[13847, 14307], 0.9678479066191374]], AbsoluteThickness[0.25], 
     LineBox[{13847, 13848}]}, 
    {Hue[
      NCache[
       Rational[4616, 4769], 0.9679178024743132]], AbsoluteThickness[0.25], 
     LineBox[{13848, 13849}]}, 
    {Hue[
      NCache[
       Rational[13849, 14307], 0.967987698329489]], AbsoluteThickness[0.25], 
     LineBox[{13849, 13850}]}, 
    {Hue[
      NCache[
       Rational[13850, 14307], 0.9680575941846649]], AbsoluteThickness[0.25], 
     LineBox[{13850, 13851}]}, 
    {Hue[
      NCache[
       Rational[243, 251], 0.9681274900398407]], AbsoluteThickness[0.25], 
     LineBox[{13851, 13852}]}, 
    {Hue[
      NCache[
       Rational[13852, 14307], 0.9681973858950165]], AbsoluteThickness[0.25], 
     LineBox[{13852, 13853}]}, 
    {Hue[
      NCache[
       Rational[13853, 14307], 0.9682672817501922]], AbsoluteThickness[0.25], 
     LineBox[{13853, 13854}]}, 
    {Hue[
      NCache[
       Rational[4618, 4769], 0.968337177605368]], AbsoluteThickness[0.25], 
     LineBox[{13854, 13855}]}, 
    {Hue[
      NCache[
       Rational[13855, 14307], 0.9684070734605438]], AbsoluteThickness[0.25], 
     LineBox[{13855, 13856}]}, 
    {Hue[
      NCache[
       Rational[13856, 14307], 0.9684769693157196]], AbsoluteThickness[0.25], 
     LineBox[{13856, 13857}]}, 
    {Hue[
      NCache[
       Rational[4619, 4769], 0.9685468651708954]], AbsoluteThickness[0.25], 
     LineBox[{13857, 13858}]}, 
    {Hue[
      NCache[
       Rational[13858, 14307], 0.9686167610260712]], AbsoluteThickness[0.25], 
     LineBox[{13858, 13859}]}, 
    {Hue[
      NCache[
       Rational[13859, 14307], 0.9686866568812469]], AbsoluteThickness[0.25], 
     LineBox[{13859, 13860}]}, 
    {Hue[
      NCache[
       Rational[4620, 4769], 0.9687565527364227]], AbsoluteThickness[0.25], 
     LineBox[{13860, 13861}]}, 
    {Hue[
      NCache[
       Rational[13861, 14307], 0.9688264485915985]], AbsoluteThickness[0.25], 
     LineBox[{13861, 13862}]}, 
    {Hue[
      NCache[
       Rational[13862, 14307], 0.9688963444467743]], AbsoluteThickness[0.25], 
     LineBox[{13862, 13863}]}, 
    {Hue[
      NCache[
       Rational[4621, 4769], 0.9689662403019501]], AbsoluteThickness[0.25], 
     LineBox[{13863, 13864}]}, 
    {Hue[
      NCache[
       Rational[13864, 14307], 0.9690361361571259]], AbsoluteThickness[0.25], 
     LineBox[{13864, 13865}]}, 
    {Hue[
      NCache[
       Rational[13865, 14307], 0.9691060320123017]], AbsoluteThickness[0.25], 
     LineBox[{13865, 13866}]}, 
    {Hue[
      NCache[
       Rational[4622, 4769], 0.9691759278674774]], AbsoluteThickness[0.25], 
     LineBox[{13866, 13867}]}, 
    {Hue[
      NCache[
       Rational[13867, 14307], 0.9692458237226532]], AbsoluteThickness[0.25], 
     LineBox[{13867, 13868}]}, 
    {Hue[
      NCache[
       Rational[13868, 14307], 0.969315719577829]], AbsoluteThickness[0.25], 
     LineBox[{13868, 13869}]}, 
    {Hue[
      NCache[
       Rational[4623, 4769], 0.9693856154330048]], AbsoluteThickness[0.25], 
     LineBox[{13869, 13870}]}, 
    {Hue[
      NCache[
       Rational[730, 753], 0.9694555112881806]], AbsoluteThickness[0.25], 
     LineBox[{13870, 13871}]}, 
    {Hue[
      NCache[
       Rational[13871, 14307], 0.9695254071433564]], AbsoluteThickness[0.25], 
     LineBox[{13871, 13872}]}, 
    {Hue[
      NCache[
       Rational[4624, 4769], 0.9695953029985321]], AbsoluteThickness[0.25], 
     LineBox[{13872, 13873}]}, 
    {Hue[
      NCache[
       Rational[13873, 14307], 0.9696651988537079]], AbsoluteThickness[0.25], 
     LineBox[{13873, 13874}]}, 
    {Hue[
      NCache[
       Rational[13874, 14307], 0.9697350947088837]], AbsoluteThickness[0.25], 
     LineBox[{13874, 13875}]}, 
    {Hue[
      NCache[
       Rational[4625, 4769], 0.9698049905640596]], AbsoluteThickness[0.25], 
     LineBox[{13875, 13876}]}, 
    {Hue[
      NCache[
       Rational[13876, 14307], 0.9698748864192354]], AbsoluteThickness[0.25], 
     LineBox[{13876, 13877}]}, 
    {Hue[
      NCache[
       Rational[13877, 14307], 0.9699447822744112]], AbsoluteThickness[0.25], 
     LineBox[{13877, 13878}]}, 
    {Hue[
      NCache[
       Rational[4626, 4769], 0.9700146781295869]], AbsoluteThickness[0.25], 
     LineBox[{13878, 13879}]}, 
    {Hue[
      NCache[
       Rational[13879, 14307], 0.9700845739847627]], AbsoluteThickness[0.25], 
     LineBox[{13879, 13880}]}, 
    {Hue[
      NCache[
       Rational[13880, 14307], 0.9701544698399385]], AbsoluteThickness[0.25], 
     LineBox[{13880, 13881}]}, 
    {Hue[
      NCache[
       Rational[4627, 4769], 0.9702243656951143]], AbsoluteThickness[0.25], 
     LineBox[{13881, 13882}]}, 
    {Hue[
      NCache[
       Rational[13882, 14307], 0.9702942615502901]], AbsoluteThickness[0.25], 
     LineBox[{13882, 13883}]}, 
    {Hue[
      NCache[
       Rational[13883, 14307], 0.9703641574054659]], AbsoluteThickness[0.25], 
     LineBox[{13883, 13884}]}, 
    {Hue[
      NCache[
       Rational[4628, 4769], 0.9704340532606417]], AbsoluteThickness[0.25], 
     LineBox[{13884, 13885}]}, 
    {Hue[
      NCache[
       Rational[13885, 14307], 0.9705039491158174]], AbsoluteThickness[0.25], 
     LineBox[{13885, 13886}]}, 
    {Hue[
      NCache[
       Rational[13886, 14307], 0.9705738449709932]], AbsoluteThickness[0.25], 
     LineBox[{13886, 13887}]}, 
    {Hue[
      NCache[
       Rational[4629, 4769], 0.970643740826169]], AbsoluteThickness[0.25], 
     LineBox[{13887, 13888}]}, 
    {Hue[
      NCache[
       Rational[13888, 14307], 0.9707136366813448]], AbsoluteThickness[0.25], 
     LineBox[{13888, 13889}]}, 
    {Hue[
      NCache[
       Rational[731, 753], 0.9707835325365206]], AbsoluteThickness[0.25], 
     LineBox[{13889, 13890}]}, 
    {Hue[
      NCache[
       Rational[4630, 4769], 0.9708534283916964]], AbsoluteThickness[0.25], 
     LineBox[{13890, 13891}]}, 
    {Hue[
      NCache[
       Rational[13891, 14307], 0.9709233242468721]], AbsoluteThickness[0.25], 
     LineBox[{13891, 13892}]}, 
    {Hue[
      NCache[
       Rational[13892, 14307], 0.9709932201020479]], AbsoluteThickness[0.25], 
     LineBox[{13892, 13893}]}, 
    {Hue[
      NCache[
       Rational[4631, 4769], 0.9710631159572237]], AbsoluteThickness[0.25], 
     LineBox[{13893, 13894}]}, 
    {Hue[
      NCache[
       Rational[13894, 14307], 0.9711330118123995]], AbsoluteThickness[0.25], 
     LineBox[{13894, 13895}]}, 
    {Hue[
      NCache[
       Rational[13895, 14307], 0.9712029076675753]], AbsoluteThickness[0.25], 
     LineBox[{13895, 13896}]}, 
    {Hue[
      NCache[
       Rational[4632, 4769], 0.9712728035227511]], AbsoluteThickness[0.25], 
     LineBox[{13896, 13897}]}, 
    {Hue[
      NCache[
       Rational[13897, 14307], 0.9713426993779269]], AbsoluteThickness[0.25], 
     LineBox[{13897, 13898}]}, 
    {Hue[
      NCache[
       Rational[13898, 14307], 0.9714125952331026]], AbsoluteThickness[0.25], 
     LineBox[{13898, 13899}]}, 
    {Hue[
      NCache[
       Rational[4633, 4769], 0.9714824910882784]], AbsoluteThickness[0.25], 
     LineBox[{13899, 13900}]}, 
    {Hue[
      NCache[
       Rational[13900, 14307], 0.9715523869434542]], AbsoluteThickness[0.25], 
     LineBox[{13900, 13901}]}, 
    {Hue[
      NCache[
       Rational[13901, 14307], 0.97162228279863]], AbsoluteThickness[0.25], 
     LineBox[{13901, 13902}]}, 
    {Hue[
      NCache[
       Rational[4634, 4769], 0.9716921786538059]], AbsoluteThickness[0.25], 
     LineBox[{13902, 13903}]}, 
    {Hue[
      NCache[
       Rational[13903, 14307], 0.9717620745089817]], AbsoluteThickness[0.25], 
     LineBox[{13903, 13904}]}, 
    {Hue[
      NCache[
       Rational[13904, 14307], 0.9718319703641574]], AbsoluteThickness[0.25], 
     LineBox[{13904, 13905}]}, 
    {Hue[
      NCache[
       Rational[4635, 4769], 0.9719018662193332]], AbsoluteThickness[0.25], 
     LineBox[{13905, 13906}]}, 
    {Hue[
      NCache[
       Rational[13906, 14307], 0.971971762074509]], AbsoluteThickness[0.25], 
     LineBox[{13906, 13907}]}, 
    {Hue[
      NCache[
       Rational[13907, 14307], 0.9720416579296848]], AbsoluteThickness[0.25], 
     LineBox[{13907, 13908}]}, 
    {Hue[
      NCache[
       Rational[244, 251], 0.9721115537848606]], AbsoluteThickness[0.25], 
     LineBox[{13908, 13909}]}, 
    {Hue[
      NCache[
       Rational[13909, 14307], 0.9721814496400364]], AbsoluteThickness[0.25], 
     LineBox[{13909, 13910}]}, 
    {Hue[
      NCache[
       Rational[13910, 14307], 0.9722513454952121]], AbsoluteThickness[0.25], 
     LineBox[{13910, 13911}]}, 
    {Hue[
      NCache[
       Rational[4637, 4769], 0.9723212413503879]], AbsoluteThickness[0.25], 
     LineBox[{13911, 13912}]}, 
    {Hue[
      NCache[
       Rational[13912, 14307], 0.9723911372055637]], AbsoluteThickness[0.25], 
     LineBox[{13912, 13913}]}, 
    {Hue[
      NCache[
       Rational[13913, 14307], 0.9724610330607395]], AbsoluteThickness[0.25], 
     LineBox[{13913, 13914}]}, 
    {Hue[
      NCache[
       Rational[4638, 4769], 0.9725309289159153]], AbsoluteThickness[0.25], 
     LineBox[{13914, 13915}]}, 
    {Hue[
      NCache[
       Rational[13915, 14307], 0.9726008247710911]], AbsoluteThickness[0.25], 
     LineBox[{13915, 13916}]}, 
    {Hue[
      NCache[
       Rational[13916, 14307], 0.9726707206262669]], AbsoluteThickness[0.25], 
     LineBox[{13916, 13917}]}, 
    {Hue[
      NCache[
       Rational[4639, 4769], 0.9727406164814426]], AbsoluteThickness[0.25], 
     LineBox[{13917, 13918}]}, 
    {Hue[
      NCache[
       Rational[13918, 14307], 0.9728105123366184]], AbsoluteThickness[0.25], 
     LineBox[{13918, 13919}]}, 
    {Hue[
      NCache[
       Rational[13919, 14307], 0.9728804081917942]], AbsoluteThickness[0.25], 
     LineBox[{13919, 13920}]}, 
    {Hue[
      NCache[
       Rational[4640, 4769], 0.97295030404697]], AbsoluteThickness[0.25], 
     LineBox[{13920, 13921}]}, 
    {Hue[
      NCache[
       Rational[13921, 14307], 0.9730201999021458]], AbsoluteThickness[0.25], 
     LineBox[{13921, 13922}]}, 
    {Hue[
      NCache[
       Rational[13922, 14307], 0.9730900957573216]], AbsoluteThickness[0.25], 
     LineBox[{13922, 13923}]}, 
    {Hue[
      NCache[
       Rational[4641, 4769], 0.9731599916124973]], AbsoluteThickness[0.25], 
     LineBox[{13923, 13924}]}, 
    {Hue[
      NCache[
       Rational[13924, 14307], 0.9732298874676731]], AbsoluteThickness[0.25], 
     LineBox[{13924, 13925}]}, 
    {Hue[
      NCache[
       Rational[13925, 14307], 0.9732997833228489]], AbsoluteThickness[0.25], 
     LineBox[{13925, 13926}]}, 
    {Hue[
      NCache[
       Rational[4642, 4769], 0.9733696791780247]], AbsoluteThickness[0.25], 
     LineBox[{13926, 13927}]}, 
    {Hue[
      NCache[
       Rational[733, 753], 0.9734395750332006]], AbsoluteThickness[0.25], 
     LineBox[{13927, 13928}]}, 
    {Hue[
      NCache[
       Rational[13928, 14307], 0.9735094708883764]], AbsoluteThickness[0.25], 
     LineBox[{13928, 13929}]}, 
    {Hue[
      NCache[
       Rational[4643, 4769], 0.973579366743552]], AbsoluteThickness[0.25], 
     LineBox[{13929, 13930}]}, 
    {Hue[
      NCache[
       Rational[13930, 14307], 0.9736492625987279]], AbsoluteThickness[0.25], 
     LineBox[{13930, 13931}]}, 
    {Hue[
      NCache[
       Rational[13931, 14307], 0.9737191584539037]], AbsoluteThickness[0.25], 
     LineBox[{13931, 13932}]}, 
    {Hue[
      NCache[
       Rational[4644, 4769], 0.9737890543090795]], AbsoluteThickness[0.25], 
     LineBox[{13932, 13933}]}, 
    {Hue[
      NCache[
       Rational[13933, 14307], 0.9738589501642553]], AbsoluteThickness[0.25], 
     LineBox[{13933, 13934}]}, 
    {Hue[
      NCache[
       Rational[13934, 14307], 0.9739288460194311]], AbsoluteThickness[0.25], 
     LineBox[{13934, 13935}]}, 
    {Hue[
      NCache[
       Rational[4645, 4769], 0.9739987418746069]], AbsoluteThickness[0.25], 
     LineBox[{13935, 13936}]}, 
    {Hue[
      NCache[
       Rational[13936, 14307], 0.9740686377297826]], AbsoluteThickness[0.25], 
     LineBox[{13936, 13937}]}, 
    {Hue[
      NCache[
       Rational[13937, 14307], 0.9741385335849584]], AbsoluteThickness[0.25], 
     LineBox[{13937, 13938}]}, 
    {Hue[
      NCache[
       Rational[4646, 4769], 0.9742084294401342]], AbsoluteThickness[0.25], 
     LineBox[{13938, 13939}]}, 
    {Hue[
      NCache[
       Rational[13939, 14307], 0.97427832529531]], AbsoluteThickness[0.25], 
     LineBox[{13939, 13940}]}, 
    {Hue[
      NCache[
       Rational[13940, 14307], 0.9743482211504858]], AbsoluteThickness[0.25], 
     LineBox[{13940, 13941}]}, 
    {Hue[
      NCache[
       Rational[4647, 4769], 0.9744181170056616]], AbsoluteThickness[0.25], 
     LineBox[{13941, 13942}]}, 
    {Hue[
      NCache[
       Rational[13942, 14307], 0.9744880128608373]], AbsoluteThickness[0.25], 
     LineBox[{13942, 13943}]}, 
    {Hue[
      NCache[
       Rational[13943, 14307], 0.9745579087160131]], AbsoluteThickness[0.25], 
     LineBox[{13943, 13944}]}, 
    {Hue[
      NCache[
       Rational[4648, 4769], 0.9746278045711889]], AbsoluteThickness[0.25], 
     LineBox[{13944, 13945}]}, 
    {Hue[
      NCache[
       Rational[13945, 14307], 0.9746977004263647]], AbsoluteThickness[0.25], 
     LineBox[{13945, 13946}]}, 
    {Hue[
      NCache[
       Rational[734, 753], 0.9747675962815405]], AbsoluteThickness[0.25], 
     LineBox[{13946, 13947}]}, 
    {Hue[
      NCache[
       Rational[4649, 4769], 0.9748374921367163]], AbsoluteThickness[0.25], 
     LineBox[{13947, 13948}]}, 
    {Hue[
      NCache[
       Rational[13948, 14307], 0.974907387991892]], AbsoluteThickness[0.25], 
     LineBox[{13948, 13949}]}, 
    {Hue[
      NCache[
       Rational[13949, 14307], 0.9749772838470678]], AbsoluteThickness[0.25], 
     LineBox[{13949, 13950}]}, 
    {Hue[
      NCache[
       Rational[4650, 4769], 0.9750471797022436]], AbsoluteThickness[0.25], 
     LineBox[{13950, 13951}]}, 
    {Hue[
      NCache[
       Rational[13951, 14307], 0.9751170755574194]], AbsoluteThickness[0.25], 
     LineBox[{13951, 13952}]}, 
    {Hue[
      NCache[
       Rational[13952, 14307], 0.9751869714125952]], AbsoluteThickness[0.25], 
     LineBox[{13952, 13953}]}, 
    {Hue[
      NCache[
       Rational[4651, 4769], 0.975256867267771]], AbsoluteThickness[0.25], 
     LineBox[{13953, 13954}]}, 
    {Hue[
      NCache[
       Rational[13954, 14307], 0.9753267631229469]], AbsoluteThickness[0.25], 
     LineBox[{13954, 13955}]}, 
    {Hue[
      NCache[
       Rational[13955, 14307], 0.9753966589781226]], AbsoluteThickness[0.25], 
     LineBox[{13955, 13956}]}, 
    {Hue[
      NCache[
       Rational[4652, 4769], 0.9754665548332984]], AbsoluteThickness[0.25], 
     LineBox[{13956, 13957}]}, 
    {Hue[
      NCache[
       Rational[13957, 14307], 0.9755364506884742]], AbsoluteThickness[0.25], 
     LineBox[{13957, 13958}]}, 
    {Hue[
      NCache[
       Rational[13958, 14307], 0.97560634654365]], AbsoluteThickness[0.25], 
     LineBox[{13958, 13959}]}, 
    {Hue[
      NCache[
       Rational[4653, 4769], 0.9756762423988258]], AbsoluteThickness[0.25], 
     LineBox[{13959, 13960}]}, 
    {Hue[
      NCache[
       Rational[13960, 14307], 0.9757461382540016]], AbsoluteThickness[0.25], 
     LineBox[{13960, 13961}]}, 
    {Hue[
      NCache[
       Rational[13961, 14307], 0.9758160341091773]], AbsoluteThickness[0.25], 
     LineBox[{13961, 13962}]}, 
    {Hue[
      NCache[
       Rational[4654, 4769], 0.9758859299643531]], AbsoluteThickness[0.25], 
     LineBox[{13962, 13963}]}, 
    {Hue[
      NCache[
       Rational[13963, 14307], 0.9759558258195289]], AbsoluteThickness[0.25], 
     LineBox[{13963, 13964}]}, 
    {Hue[
      NCache[
       Rational[13964, 14307], 0.9760257216747047]], AbsoluteThickness[0.25], 
     LineBox[{13964, 13965}]}, 
    {Hue[
      NCache[
       Rational[245, 251], 0.9760956175298805]], AbsoluteThickness[0.25], 
     LineBox[{13965, 13966}]}, 
    {Hue[
      NCache[
       Rational[13966, 14307], 0.9761655133850563]], AbsoluteThickness[0.25], 
     LineBox[{13966, 13967}]}, 
    {Hue[
      NCache[
       Rational[13967, 14307], 0.976235409240232]], AbsoluteThickness[0.25], 
     LineBox[{13967, 13968}]}, 
    {Hue[
      NCache[
       Rational[4656, 4769], 0.9763053050954078]], AbsoluteThickness[0.25], 
     LineBox[{13968, 13969}]}, 
    {Hue[
      NCache[
       Rational[13969, 14307], 0.9763752009505836]], AbsoluteThickness[0.25], 
     LineBox[{13969, 13970}]}, 
    {Hue[
      NCache[
       Rational[13970, 14307], 0.9764450968057594]], AbsoluteThickness[0.25], 
     LineBox[{13970, 13971}]}, 
    {Hue[
      NCache[
       Rational[4657, 4769], 0.9765149926609352]], AbsoluteThickness[0.25], 
     LineBox[{13971, 13972}]}, 
    {Hue[
      NCache[
       Rational[13972, 14307], 0.976584888516111]], AbsoluteThickness[0.25], 
     LineBox[{13972, 13973}]}, 
    {Hue[
      NCache[
       Rational[13973, 14307], 0.9766547843712868]], AbsoluteThickness[0.25], 
     LineBox[{13973, 13974}]}, 
    {Hue[
      NCache[
       Rational[4658, 4769], 0.9767246802264625]], AbsoluteThickness[0.25], 
     LineBox[{13974, 13975}]}, 
    {Hue[
      NCache[
       Rational[13975, 14307], 0.9767945760816383]], AbsoluteThickness[0.25], 
     LineBox[{13975, 13976}]}, 
    {Hue[
      NCache[
       Rational[13976, 14307], 0.9768644719368141]], AbsoluteThickness[0.25], 
     LineBox[{13976, 13977}]}, 
    {Hue[
      NCache[
       Rational[4659, 4769], 0.9769343677919899]], AbsoluteThickness[0.25], 
     LineBox[{13977, 13978}]}, 
    {Hue[
      NCache[
       Rational[13978, 14307], 0.9770042636471657]], AbsoluteThickness[0.25], 
     LineBox[{13978, 13979}]}, 
    {Hue[
      NCache[
       Rational[13979, 14307], 0.9770741595023416]], AbsoluteThickness[0.25], 
     LineBox[{13979, 13980}]}, 
    {Hue[
      NCache[
       Rational[4660, 4769], 0.9771440553575172]], AbsoluteThickness[0.25], 
     LineBox[{13980, 13981}]}, 
    {Hue[
      NCache[
       Rational[13981, 14307], 0.977213951212693]], AbsoluteThickness[0.25], 
     LineBox[{13981, 13982}]}, 
    {Hue[
      NCache[
       Rational[13982, 14307], 0.9772838470678689]], AbsoluteThickness[0.25], 
     LineBox[{13982, 13983}]}, 
    {Hue[
      NCache[
       Rational[4661, 4769], 0.9773537429230447]], AbsoluteThickness[0.25], 
     LineBox[{13983, 13984}]}, 
    {Hue[
      NCache[
       Rational[736, 753], 0.9774236387782205]], AbsoluteThickness[0.25], 
     LineBox[{13984, 13985}]}, 
    {Hue[
      NCache[
       Rational[13985, 14307], 0.9774935346333963]], AbsoluteThickness[0.25], 
     LineBox[{13985, 13986}]}, 
    {Hue[
      NCache[
       Rational[4662, 4769], 0.9775634304885721]], AbsoluteThickness[0.25], 
     LineBox[{13986, 13987}]}, 
    {Hue[
      NCache[
       Rational[13987, 14307], 0.9776333263437478]], AbsoluteThickness[0.25], 
     LineBox[{13987, 13988}]}, 
    {Hue[
      NCache[
       Rational[13988, 14307], 0.9777032221989236]], AbsoluteThickness[0.25], 
     LineBox[{13988, 13989}]}, 
    {Hue[
      NCache[
       Rational[4663, 4769], 0.9777731180540994]], AbsoluteThickness[0.25], 
     LineBox[{13989, 13990}]}, 
    {Hue[
      NCache[
       Rational[13990, 14307], 0.9778430139092752]], AbsoluteThickness[0.25], 
     LineBox[{13990, 13991}]}, 
    {Hue[
      NCache[
       Rational[13991, 14307], 0.977912909764451]], AbsoluteThickness[0.25], 
     LineBox[{13991, 13992}]}, 
    {Hue[
      NCache[
       Rational[4664, 4769], 0.9779828056196268]], AbsoluteThickness[0.25], 
     LineBox[{13992, 13993}]}, 
    {Hue[
      NCache[
       Rational[13993, 14307], 0.9780527014748025]], AbsoluteThickness[0.25], 
     LineBox[{13993, 13994}]}, 
    {Hue[
      NCache[
       Rational[13994, 14307], 0.9781225973299783]], AbsoluteThickness[0.25], 
     LineBox[{13994, 13995}]}, 
    {Hue[
      NCache[
       Rational[4665, 4769], 0.9781924931851541]], AbsoluteThickness[0.25], 
     LineBox[{13995, 13996}]}, 
    {Hue[
      NCache[
       Rational[13996, 14307], 0.9782623890403299]], AbsoluteThickness[0.25], 
     LineBox[{13996, 13997}]}, 
    {Hue[
      NCache[
       Rational[13997, 14307], 0.9783322848955057]], AbsoluteThickness[0.25], 
     LineBox[{13997, 13998}]}, 
    {Hue[
      NCache[
       Rational[4666, 4769], 0.9784021807506815]], AbsoluteThickness[0.25], 
     LineBox[{13998, 13999}]}, 
    {Hue[
      NCache[
       Rational[13999, 14307], 0.9784720766058572]], AbsoluteThickness[0.25], 
     LineBox[{13999, 14000}]}, 
    {Hue[
      NCache[
       Rational[14000, 14307], 0.978541972461033]], AbsoluteThickness[0.25], 
     LineBox[{14000, 14001}]}, 
    {Hue[
      NCache[
       Rational[4667, 4769], 0.9786118683162088]], AbsoluteThickness[0.25], 
     LineBox[{14001, 14002}]}, 
    {Hue[
      NCache[
       Rational[14002, 14307], 0.9786817641713846]], AbsoluteThickness[0.25], 
     LineBox[{14002, 14003}]}, 
    {Hue[
      NCache[
       Rational[737, 753], 0.9787516600265604]], AbsoluteThickness[0.25], 
     LineBox[{14003, 14004}]}, 
    {Hue[
      NCache[
       Rational[4668, 4769], 0.9788215558817362]], AbsoluteThickness[0.25], 
     LineBox[{14004, 14005}]}, 
    {Hue[
      NCache[
       Rational[14005, 14307], 0.978891451736912]], AbsoluteThickness[0.25], 
     LineBox[{14005, 14006}]}, 
    {Hue[
      NCache[
       Rational[14006, 14307], 0.9789613475920877]], AbsoluteThickness[0.25], 
     LineBox[{14006, 14007}]}, 
    {Hue[
      NCache[
       Rational[4669, 4769], 0.9790312434472636]], AbsoluteThickness[0.25], 
     LineBox[{14007, 14008}]}, 
    {Hue[
      NCache[
       Rational[14008, 14307], 0.9791011393024394]], AbsoluteThickness[0.25], 
     LineBox[{14008, 14009}]}, 
    {Hue[
      NCache[
       Rational[14009, 14307], 0.9791710351576152]], AbsoluteThickness[0.25], 
     LineBox[{14009, 14010}]}, 
    {Hue[
      NCache[
       Rational[4670, 4769], 0.979240931012791]], AbsoluteThickness[0.25], 
     LineBox[{14010, 14011}]}, 
    {Hue[
      NCache[
       Rational[14011, 14307], 0.9793108268679668]], AbsoluteThickness[0.25], 
     LineBox[{14011, 14012}]}, 
    {Hue[
      NCache[
       Rational[14012, 14307], 0.9793807227231425]], AbsoluteThickness[0.25], 
     LineBox[{14012, 14013}]}, 
    {Hue[
      NCache[
       Rational[4671, 4769], 0.9794506185783183]], AbsoluteThickness[0.25], 
     LineBox[{14013, 14014}]}, 
    {Hue[
      NCache[
       Rational[14014, 14307], 0.9795205144334941]], AbsoluteThickness[0.25], 
     LineBox[{14014, 14015}]}, 
    {Hue[
      NCache[
       Rational[14015, 14307], 0.9795904102886699]], AbsoluteThickness[0.25], 
     LineBox[{14015, 14016}]}, 
    {Hue[
      NCache[
       Rational[4672, 4769], 0.9796603061438457]], AbsoluteThickness[0.25], 
     LineBox[{14016, 14017}]}, 
    {Hue[
      NCache[
       Rational[14017, 14307], 0.9797302019990215]], AbsoluteThickness[0.25], 
     LineBox[{14017, 14018}]}, 
    {Hue[
      NCache[
       Rational[14018, 14307], 0.9798000978541972]], AbsoluteThickness[0.25], 
     LineBox[{14018, 14019}]}, 
    {Hue[
      NCache[
       Rational[4673, 4769], 0.979869993709373]], AbsoluteThickness[0.25], 
     LineBox[{14019, 14020}]}, 
    {Hue[
      NCache[
       Rational[14020, 14307], 0.9799398895645488]], AbsoluteThickness[0.25], 
     LineBox[{14020, 14021}]}, 
    {Hue[
      NCache[
       Rational[14021, 14307], 0.9800097854197246]], AbsoluteThickness[0.25], 
     LineBox[{14021, 14022}]}, 
    {Hue[
      NCache[
       Rational[246, 251], 0.9800796812749004]], AbsoluteThickness[0.25], 
     LineBox[{14022, 14023}]}, 
    {Hue[
      NCache[
       Rational[14023, 14307], 0.9801495771300762]], AbsoluteThickness[0.25], 
     LineBox[{14023, 14024}]}, 
    {Hue[
      NCache[
       Rational[14024, 14307], 0.980219472985252]], AbsoluteThickness[0.25], 
     LineBox[{14024, 14025}]}, 
    {Hue[
      NCache[
       Rational[4675, 4769], 0.9802893688404277]], AbsoluteThickness[0.25], 
     LineBox[{14025, 14026}]}, 
    {Hue[
      NCache[
       Rational[14026, 14307], 0.9803592646956035]], AbsoluteThickness[0.25], 
     LineBox[{14026, 14027}]}, 
    {Hue[
      NCache[
       Rational[14027, 14307], 0.9804291605507793]], AbsoluteThickness[0.25], 
     LineBox[{14027, 14028}]}, 
    {Hue[
      NCache[
       Rational[4676, 4769], 0.9804990564059551]], AbsoluteThickness[0.25], 
     LineBox[{14028, 14029}]}, 
    {Hue[
      NCache[
       Rational[14029, 14307], 0.9805689522611309]], AbsoluteThickness[0.25], 
     LineBox[{14029, 14030}]}, 
    {Hue[
      NCache[
       Rational[14030, 14307], 0.9806388481163067]], AbsoluteThickness[0.25], 
     LineBox[{14030, 14031}]}, 
    {Hue[
      NCache[
       Rational[4677, 4769], 0.9807087439714824]], AbsoluteThickness[0.25], 
     LineBox[{14031, 14032}]}, 
    {Hue[
      NCache[
       Rational[14032, 14307], 0.9807786398266582]], AbsoluteThickness[0.25], 
     LineBox[{14032, 14033}]}, 
    {Hue[
      NCache[
       Rational[14033, 14307], 0.980848535681834]], AbsoluteThickness[0.25], 
     LineBox[{14033, 14034}]}, 
    {Hue[
      NCache[
       Rational[4678, 4769], 0.9809184315370099]], AbsoluteThickness[0.25], 
     LineBox[{14034, 14035}]}, 
    {Hue[
      NCache[
       Rational[14035, 14307], 0.9809883273921857]], AbsoluteThickness[0.25], 
     LineBox[{14035, 14036}]}, 
    {Hue[
      NCache[
       Rational[14036, 14307], 0.9810582232473615]], AbsoluteThickness[0.25], 
     LineBox[{14036, 14037}]}, 
    {Hue[
      NCache[
       Rational[4679, 4769], 0.9811281191025372]], AbsoluteThickness[0.25], 
     LineBox[{14037, 14038}]}, 
    {Hue[
      NCache[
       Rational[14038, 14307], 0.981198014957713]], AbsoluteThickness[0.25], 
     LineBox[{14038, 14039}]}, 
    {Hue[
      NCache[
       Rational[14039, 14307], 0.9812679108128888]], AbsoluteThickness[0.25], 
     LineBox[{14039, 14040}]}, 
    {Hue[
      NCache[
       Rational[4680, 4769], 0.9813378066680646]], AbsoluteThickness[0.25], 
     LineBox[{14040, 14041}]}, 
    {Hue[
      NCache[
       Rational[739, 753], 0.9814077025232404]], AbsoluteThickness[0.25], 
     LineBox[{14041, 14042}]}, 
    {Hue[
      NCache[
       Rational[14042, 14307], 0.9814775983784162]], AbsoluteThickness[0.25], 
     LineBox[{14042, 14043}]}, 
    {Hue[
      NCache[
       Rational[4681, 4769], 0.981547494233592]], AbsoluteThickness[0.25], 
     LineBox[{14043, 14044}]}, 
    {Hue[
      NCache[
       Rational[14044, 14307], 0.9816173900887677]], AbsoluteThickness[0.25], 
     LineBox[{14044, 14045}]}, 
    {Hue[
      NCache[
       Rational[14045, 14307], 0.9816872859439435]], AbsoluteThickness[0.25], 
     LineBox[{14045, 14046}]}, 
    {Hue[
      NCache[
       Rational[4682, 4769], 0.9817571817991193]], AbsoluteThickness[0.25], 
     LineBox[{14046, 14047}]}, 
    {Hue[
      NCache[
       Rational[14047, 14307], 0.9818270776542951]], AbsoluteThickness[0.25], 
     LineBox[{14047, 14048}]}, 
    {Hue[
      NCache[
       Rational[14048, 14307], 0.9818969735094709]], AbsoluteThickness[0.25], 
     LineBox[{14048, 14049}]}, 
    {Hue[
      NCache[
       Rational[4683, 4769], 0.9819668693646467]], AbsoluteThickness[0.25], 
     LineBox[{14049, 14050}]}, 
    {Hue[
      NCache[
       Rational[14050, 14307], 0.9820367652198224]], AbsoluteThickness[0.25], 
     LineBox[{14050, 14051}]}, 
    {Hue[
      NCache[
       Rational[14051, 14307], 0.9821066610749982]], AbsoluteThickness[0.25], 
     LineBox[{14051, 14052}]}, 
    {Hue[
      NCache[
       Rational[4684, 4769], 0.982176556930174]], AbsoluteThickness[0.25], 
     LineBox[{14052, 14053}]}, 
    {Hue[
      NCache[
       Rational[14053, 14307], 0.9822464527853498]], AbsoluteThickness[0.25], 
     LineBox[{14053, 14054}]}, 
    {Hue[
      NCache[
       Rational[14054, 14307], 0.9823163486405256]], AbsoluteThickness[0.25], 
     LineBox[{14054, 14055}]}, 
    {Hue[
      NCache[
       Rational[4685, 4769], 0.9823862444957014]], AbsoluteThickness[0.25], 
     LineBox[{14055, 14056}]}, 
    {Hue[
      NCache[
       Rational[56, 57], 0.9824561403508771]], AbsoluteThickness[0.25], 
     LineBox[{14056, 14057}]}, 
    {Hue[
      NCache[
       Rational[14057, 14307], 0.9825260362060529]], AbsoluteThickness[0.25], 
     LineBox[{14057, 14058}]}, 
    {Hue[
      NCache[
       Rational[4686, 4769], 0.9825959320612287]], AbsoluteThickness[0.25], 
     LineBox[{14058, 14059}]}, 
    {Hue[
      NCache[
       Rational[14059, 14307], 0.9826658279164046]], AbsoluteThickness[0.25], 
     LineBox[{14059, 14060}]}, 
    {Hue[
      NCache[
       Rational[740, 753], 0.9827357237715804]], AbsoluteThickness[0.25], 
     LineBox[{14060, 14061}]}, 
    {Hue[
      NCache[
       Rational[4687, 4769], 0.9828056196267562]], AbsoluteThickness[0.25], 
     LineBox[{14061, 14062}]}, 
    {Hue[
      NCache[
       Rational[14062, 14307], 0.982875515481932]], AbsoluteThickness[0.25], 
     LineBox[{14062, 14063}]}, 
    {Hue[
      NCache[
       Rational[14063, 14307], 0.9829454113371077]], AbsoluteThickness[0.25], 
     LineBox[{14063, 14064}]}, 
    {Hue[
      NCache[
       Rational[4688, 4769], 0.9830153071922835]], AbsoluteThickness[0.25], 
     LineBox[{14064, 14065}]}, 
    {Hue[
      NCache[
       Rational[14065, 14307], 0.9830852030474593]], AbsoluteThickness[0.25], 
     LineBox[{14065, 14066}]}, 
    {Hue[
      NCache[
       Rational[14066, 14307], 0.9831550989026351]], AbsoluteThickness[0.25], 
     LineBox[{14066, 14067}]}, 
    {Hue[
      NCache[
       Rational[4689, 4769], 0.9832249947578109]], AbsoluteThickness[0.25], 
     LineBox[{14067, 14068}]}, 
    {Hue[
      NCache[
       Rational[14068, 14307], 0.9832948906129867]], AbsoluteThickness[0.25], 
     LineBox[{14068, 14069}]}, 
    {Hue[
      NCache[
       Rational[14069, 14307], 0.9833647864681624]], AbsoluteThickness[0.25], 
     LineBox[{14069, 14070}]}, 
    {Hue[
      NCache[
       Rational[4690, 4769], 0.9834346823233382]], AbsoluteThickness[0.25], 
     LineBox[{14070, 14071}]}, 
    {Hue[
      NCache[
       Rational[14071, 14307], 0.983504578178514]], AbsoluteThickness[0.25], 
     LineBox[{14071, 14072}]}, 
    {Hue[
      NCache[
       Rational[14072, 14307], 0.9835744740336898]], AbsoluteThickness[0.25], 
     LineBox[{14072, 14073}]}, 
    {Hue[
      NCache[
       Rational[4691, 4769], 0.9836443698888656]], AbsoluteThickness[0.25], 
     LineBox[{14073, 14074}]}, 
    {Hue[
      NCache[
       Rational[14074, 14307], 0.9837142657440414]], AbsoluteThickness[0.25], 
     LineBox[{14074, 14075}]}, 
    {Hue[
      NCache[
       Rational[14075, 14307], 0.9837841615992172]], AbsoluteThickness[0.25], 
     LineBox[{14075, 14076}]}, 
    {Hue[
      NCache[
       Rational[4692, 4769], 0.9838540574543929]], AbsoluteThickness[0.25], 
     LineBox[{14076, 14077}]}, 
    {Hue[
      NCache[
       Rational[14077, 14307], 0.9839239533095687]], AbsoluteThickness[0.25], 
     LineBox[{14077, 14078}]}, 
    {Hue[
      NCache[
       Rational[14078, 14307], 0.9839938491647445]], AbsoluteThickness[0.25], 
     LineBox[{14078, 14079}]}, 
    {Hue[
      NCache[
       Rational[247, 251], 0.9840637450199203]], AbsoluteThickness[0.25], 
     LineBox[{14079, 14080}]}, 
    {Hue[
      NCache[
       Rational[14080, 14307], 0.9841336408750961]], AbsoluteThickness[0.25], 
     LineBox[{14080, 14081}]}, 
    {Hue[
      NCache[
       Rational[14081, 14307], 0.9842035367302719]], AbsoluteThickness[0.25], 
     LineBox[{14081, 14082}]}, 
    {Hue[
      NCache[
       Rational[4694, 4769], 0.9842734325854476]], AbsoluteThickness[0.25], 
     LineBox[{14082, 14083}]}, 
    {Hue[
      NCache[
       Rational[14083, 14307], 0.9843433284406234]], AbsoluteThickness[0.25], 
     LineBox[{14083, 14084}]}, 
    {Hue[
      NCache[
       Rational[14084, 14307], 0.9844132242957992]], AbsoluteThickness[0.25], 
     LineBox[{14084, 14085}]}, 
    {Hue[
      NCache[
       Rational[4695, 4769], 0.984483120150975]], AbsoluteThickness[0.25], 
     LineBox[{14085, 14086}]}, 
    {Hue[
      NCache[
       Rational[14086, 14307], 0.9845530160061509]], AbsoluteThickness[0.25], 
     LineBox[{14086, 14087}]}, 
    {Hue[
      NCache[
       Rational[14087, 14307], 0.9846229118613267]], AbsoluteThickness[0.25], 
     LineBox[{14087, 14088}]}, 
    {Hue[
      NCache[
       Rational[4696, 4769], 0.9846928077165024]], AbsoluteThickness[0.25], 
     LineBox[{14088, 14089}]}, 
    {Hue[
      NCache[
       Rational[14089, 14307], 0.9847627035716782]], AbsoluteThickness[0.25], 
     LineBox[{14089, 14090}]}, 
    {Hue[
      NCache[
       Rational[14090, 14307], 0.984832599426854]], AbsoluteThickness[0.25], 
     LineBox[{14090, 14091}]}, 
    {Hue[
      NCache[
       Rational[4697, 4769], 0.9849024952820298]], AbsoluteThickness[0.25], 
     LineBox[{14091, 14092}]}, 
    {Hue[
      NCache[
       Rational[14092, 14307], 0.9849723911372056]], AbsoluteThickness[0.25], 
     LineBox[{14092, 14093}]}, 
    {Hue[
      NCache[
       Rational[14093, 14307], 0.9850422869923814]], AbsoluteThickness[0.25], 
     LineBox[{14093, 14094}]}, 
    {Hue[
      NCache[
       Rational[4698, 4769], 0.9851121828475572]], AbsoluteThickness[0.25], 
     LineBox[{14094, 14095}]}, 
    {Hue[
      NCache[
       Rational[14095, 14307], 0.9851820787027329]], AbsoluteThickness[0.25], 
     LineBox[{14095, 14096}]}, 
    {Hue[
      NCache[
       Rational[14096, 14307], 0.9852519745579087]], AbsoluteThickness[0.25], 
     LineBox[{14096, 14097}]}, 
    {Hue[
      NCache[
       Rational[4699, 4769], 0.9853218704130845]], AbsoluteThickness[0.25], 
     LineBox[{14097, 14098}]}, 
    {Hue[
      NCache[
       Rational[742, 753], 0.9853917662682603]], AbsoluteThickness[0.25], 
     LineBox[{14098, 14099}]}, 
    {Hue[
      NCache[
       Rational[14099, 14307], 0.9854616621234361]], AbsoluteThickness[0.25], 
     LineBox[{14099, 14100}]}, 
    {Hue[
      NCache[
       Rational[4700, 4769], 0.9855315579786119]], AbsoluteThickness[0.25], 
     LineBox[{14100, 14101}]}, 
    {Hue[
      NCache[
       Rational[14101, 14307], 0.9856014538337876]], AbsoluteThickness[0.25], 
     LineBox[{14101, 14102}]}, 
    {Hue[
      NCache[
       Rational[14102, 14307], 0.9856713496889634]], AbsoluteThickness[0.25], 
     LineBox[{14102, 14103}]}, 
    {Hue[
      NCache[
       Rational[4701, 4769], 0.9857412455441392]], AbsoluteThickness[0.25], 
     LineBox[{14103, 14104}]}, 
    {Hue[
      NCache[
       Rational[14104, 14307], 0.985811141399315]], AbsoluteThickness[0.25], 
     LineBox[{14104, 14105}]}, 
    {Hue[
      NCache[
       Rational[14105, 14307], 0.9858810372544908]], AbsoluteThickness[0.25], 
     LineBox[{14105, 14106}]}, 
    {Hue[
      NCache[
       Rational[4702, 4769], 0.9859509331096666]], AbsoluteThickness[0.25], 
     LineBox[{14106, 14107}]}, 
    {Hue[
      NCache[
       Rational[14107, 14307], 0.9860208289648423]], AbsoluteThickness[0.25], 
     LineBox[{14107, 14108}]}, 
    {Hue[
      NCache[
       Rational[14108, 14307], 0.9860907248200181]], AbsoluteThickness[0.25], 
     LineBox[{14108, 14109}]}, 
    {Hue[
      NCache[
       Rational[4703, 4769], 0.9861606206751939]], AbsoluteThickness[0.25], 
     LineBox[{14109, 14110}]}, 
    {Hue[
      NCache[
       Rational[14110, 14307], 0.9862305165303697]], AbsoluteThickness[0.25], 
     LineBox[{14110, 14111}]}, 
    {Hue[
      NCache[
       Rational[14111, 14307], 0.9863004123855456]], AbsoluteThickness[0.25], 
     LineBox[{14111, 14112}]}, 
    {Hue[
      NCache[
       Rational[4704, 4769], 0.9863703082407214]], AbsoluteThickness[0.25], 
     LineBox[{14112, 14113}]}, 
    {Hue[
      NCache[
       Rational[14113, 14307], 0.9864402040958972]], AbsoluteThickness[0.25], 
     LineBox[{14113, 14114}]}, 
    {Hue[
      NCache[
       Rational[14114, 14307], 0.9865100999510729]], AbsoluteThickness[0.25], 
     LineBox[{14114, 14115}]}, 
    {Hue[
      NCache[
       Rational[4705, 4769], 0.9865799958062487]], AbsoluteThickness[0.25], 
     LineBox[{14115, 14116}]}, 
    {Hue[
      NCache[
       Rational[14116, 14307], 0.9866498916614245]], AbsoluteThickness[0.25], 
     LineBox[{14116, 14117}]}, 
    {Hue[
      NCache[
       Rational[743, 753], 0.9867197875166003]], AbsoluteThickness[0.25], 
     LineBox[{14117, 14118}]}, 
    {Hue[
      NCache[
       Rational[4706, 4769], 0.9867896833717761]], AbsoluteThickness[0.25], 
     LineBox[{14118, 14119}]}, 
    {Hue[
      NCache[
       Rational[14119, 14307], 0.9868595792269519]], AbsoluteThickness[0.25], 
     LineBox[{14119, 14120}]}, 
    {Hue[
      NCache[
       Rational[14120, 14307], 0.9869294750821276]], AbsoluteThickness[0.25], 
     LineBox[{14120, 14121}]}, 
    {Hue[
      NCache[
       Rational[4707, 4769], 0.9869993709373034]], AbsoluteThickness[0.25], 
     LineBox[{14121, 14122}]}, 
    {Hue[
      NCache[
       Rational[14122, 14307], 0.9870692667924792]], AbsoluteThickness[0.25], 
     LineBox[{14122, 14123}]}, 
    {Hue[
      NCache[
       Rational[14123, 14307], 0.987139162647655]], AbsoluteThickness[0.25], 
     LineBox[{14123, 14124}]}, 
    {Hue[
      NCache[
       Rational[4708, 4769], 0.9872090585028308]], AbsoluteThickness[0.25], 
     LineBox[{14124, 14125}]}, 
    {Hue[
      NCache[
       Rational[14125, 14307], 0.9872789543580066]], AbsoluteThickness[0.25], 
     LineBox[{14125, 14126}]}, 
    {Hue[
      NCache[
       Rational[14126, 14307], 0.9873488502131823]], AbsoluteThickness[0.25], 
     LineBox[{14126, 14127}]}, 
    {Hue[
      NCache[
       Rational[4709, 4769], 0.9874187460683581]], AbsoluteThickness[0.25], 
     LineBox[{14127, 14128}]}, 
    {Hue[
      NCache[
       Rational[14128, 14307], 0.9874886419235339]], AbsoluteThickness[0.25], 
     LineBox[{14128, 14129}]}, 
    {Hue[
      NCache[
       Rational[14129, 14307], 0.9875585377787097]], AbsoluteThickness[0.25], 
     LineBox[{14129, 14130}]}, 
    {Hue[
      NCache[
       Rational[4710, 4769], 0.9876284336338855]], AbsoluteThickness[0.25], 
     LineBox[{14130, 14131}]}, 
    {Hue[
      NCache[
       Rational[14131, 14307], 0.9876983294890613]], AbsoluteThickness[0.25], 
     LineBox[{14131, 14132}]}, 
    {Hue[
      NCache[
       Rational[14132, 14307], 0.9877682253442371]], AbsoluteThickness[0.25], 
     LineBox[{14132, 14133}]}, 
    {Hue[
      NCache[
       Rational[4711, 4769], 0.9878381211994128]], AbsoluteThickness[0.25], 
     LineBox[{14133, 14134}]}, 
    {Hue[
      NCache[
       Rational[14134, 14307], 0.9879080170545886]], AbsoluteThickness[0.25], 
     LineBox[{14134, 14135}]}, 
    {Hue[
      NCache[
       Rational[14135, 14307], 0.9879779129097644]], AbsoluteThickness[0.25], 
     LineBox[{14135, 14136}]}, 
    {Hue[
      NCache[
       Rational[248, 251], 0.9880478087649402]], AbsoluteThickness[0.25], 
     LineBox[{14136, 14137}]}, 
    {Hue[
      NCache[
       Rational[14137, 14307], 0.988117704620116]], AbsoluteThickness[0.25], 
     LineBox[{14137, 14138}]}, 
    {Hue[
      NCache[
       Rational[14138, 14307], 0.9881876004752919]], AbsoluteThickness[0.25], 
     LineBox[{14138, 14139}]}, 
    {Hue[
      NCache[
       Rational[4713, 4769], 0.9882574963304676]], AbsoluteThickness[0.25], 
     LineBox[{14139, 14140}]}, 
    {Hue[
      NCache[
       Rational[14140, 14307], 0.9883273921856434]], AbsoluteThickness[0.25], 
     LineBox[{14140, 14141}]}, 
    {Hue[
      NCache[
       Rational[14141, 14307], 0.9883972880408192]], AbsoluteThickness[0.25], 
     LineBox[{14141, 14142}]}, 
    {Hue[
      NCache[
       Rational[4714, 4769], 0.988467183895995]], AbsoluteThickness[0.25], 
     LineBox[{14142, 14143}]}, 
    {Hue[
      NCache[
       Rational[14143, 14307], 0.9885370797511708]], AbsoluteThickness[0.25], 
     LineBox[{14143, 14144}]}, 
    {Hue[
      NCache[
       Rational[14144, 14307], 0.9886069756063466]], AbsoluteThickness[0.25], 
     LineBox[{14144, 14145}]}, 
    {Hue[
      NCache[
       Rational[4715, 4769], 0.9886768714615223]], AbsoluteThickness[0.25], 
     LineBox[{14145, 14146}]}, 
    {Hue[
      NCache[
       Rational[14146, 14307], 0.9887467673166981]], AbsoluteThickness[0.25], 
     LineBox[{14146, 14147}]}, 
    {Hue[
      NCache[
       Rational[14147, 14307], 0.9888166631718739]], AbsoluteThickness[0.25], 
     LineBox[{14147, 14148}]}, 
    {Hue[
      NCache[
       Rational[4716, 4769], 0.9888865590270497]], AbsoluteThickness[0.25], 
     LineBox[{14148, 14149}]}, 
    {Hue[
      NCache[
       Rational[14149, 14307], 0.9889564548822255]], AbsoluteThickness[0.25], 
     LineBox[{14149, 14150}]}, 
    {Hue[
      NCache[
       Rational[14150, 14307], 0.9890263507374013]], AbsoluteThickness[0.25], 
     LineBox[{14150, 14151}]}, 
    {Hue[
      NCache[
       Rational[4717, 4769], 0.9890962465925771]], AbsoluteThickness[0.25], 
     LineBox[{14151, 14152}]}, 
    {Hue[
      NCache[
       Rational[14152, 14307], 0.9891661424477528]], AbsoluteThickness[0.25], 
     LineBox[{14152, 14153}]}, 
    {Hue[
      NCache[
       Rational[14153, 14307], 0.9892360383029286]], AbsoluteThickness[0.25], 
     LineBox[{14153, 14154}]}, 
    {Hue[
      NCache[
       Rational[4718, 4769], 0.9893059341581044]], AbsoluteThickness[0.25], 
     LineBox[{14154, 14155}]}, 
    {Hue[
      NCache[
       Rational[745, 753], 0.9893758300132802]], AbsoluteThickness[0.25], 
     LineBox[{14155, 14156}]}, 
    {Hue[
      NCache[
       Rational[14156, 14307], 0.989445725868456]], AbsoluteThickness[0.25], 
     LineBox[{14156, 14157}]}, 
    {Hue[
      NCache[
       Rational[4719, 4769], 0.9895156217236318]], AbsoluteThickness[0.25], 
     LineBox[{14157, 14158}]}, 
    {Hue[
      NCache[
       Rational[14158, 14307], 0.9895855175788075]], AbsoluteThickness[0.25], 
     LineBox[{14158, 14159}]}, 
    {Hue[
      NCache[
       Rational[14159, 14307], 0.9896554134339833]], AbsoluteThickness[0.25], 
     LineBox[{14159, 14160}]}, 
    {Hue[
      NCache[
       Rational[4720, 4769], 0.9897253092891591]], AbsoluteThickness[0.25], 
     LineBox[{14160, 14161}]}, 
    {Hue[
      NCache[
       Rational[14161, 14307], 0.9897952051443349]], AbsoluteThickness[0.25], 
     LineBox[{14161, 14162}]}, 
    {Hue[
      NCache[
       Rational[14162, 14307], 0.9898651009995107]], AbsoluteThickness[0.25], 
     LineBox[{14162, 14163}]}, 
    {Hue[
      NCache[
       Rational[4721, 4769], 0.9899349968546866]], AbsoluteThickness[0.25], 
     LineBox[{14163, 14164}]}, 
    {Hue[
      NCache[
       Rational[14164, 14307], 0.9900048927098622]], AbsoluteThickness[0.25], 
     LineBox[{14164, 14165}]}, 
    {Hue[
      NCache[
       Rational[14165, 14307], 0.990074788565038]], AbsoluteThickness[0.25], 
     LineBox[{14165, 14166}]}, 
    {Hue[
      NCache[
       Rational[4722, 4769], 0.9901446844202139]], AbsoluteThickness[0.25], 
     LineBox[{14166, 14167}]}, 
    {Hue[
      NCache[
       Rational[14167, 14307], 0.9902145802753897]], AbsoluteThickness[0.25], 
     LineBox[{14167, 14168}]}, 
    {Hue[
      NCache[
       Rational[14168, 14307], 0.9902844761305655]], AbsoluteThickness[0.25], 
     LineBox[{14168, 14169}]}, 
    {Hue[
      NCache[
       Rational[4723, 4769], 0.9903543719857413]], AbsoluteThickness[0.25], 
     LineBox[{14169, 14170}]}, 
    {Hue[
      NCache[
       Rational[14170, 14307], 0.9904242678409171]], AbsoluteThickness[0.25], 
     LineBox[{14170, 14171}]}, 
    {Hue[
      NCache[
       Rational[14171, 14307], 0.9904941636960928]], AbsoluteThickness[0.25], 
     LineBox[{14171, 14172}]}, 
    {Hue[
      NCache[
       Rational[4724, 4769], 0.9905640595512686]], AbsoluteThickness[0.25], 
     LineBox[{14172, 14173}]}, 
    {Hue[
      NCache[
       Rational[14173, 14307], 0.9906339554064444]], AbsoluteThickness[0.25], 
     LineBox[{14173, 14174}]}, 
    {Hue[
      NCache[
       Rational[746, 753], 0.9907038512616202]], AbsoluteThickness[0.25], 
     LineBox[{14174, 14175}]}, 
    {Hue[
      NCache[
       Rational[4725, 4769], 0.990773747116796]], AbsoluteThickness[0.25], 
     LineBox[{14175, 14176}]}, 
    {Hue[
      NCache[
       Rational[14176, 14307], 0.9908436429719718]], AbsoluteThickness[0.25], 
     LineBox[{14176, 14177}]}, 
    {Hue[
      NCache[
       Rational[14177, 14307], 0.9909135388271475]], AbsoluteThickness[0.25], 
     LineBox[{14177, 14178}]}, 
    {Hue[
      NCache[
       Rational[4726, 4769], 0.9909834346823233]], AbsoluteThickness[0.25], 
     LineBox[{14178, 14179}]}, 
    {Hue[
      NCache[
       Rational[14179, 14307], 0.9910533305374991]], AbsoluteThickness[0.25], 
     LineBox[{14179, 14180}]}, 
    {Hue[
      NCache[
       Rational[14180, 14307], 0.9911232263926749]], AbsoluteThickness[0.25], 
     LineBox[{14180, 14181}]}, 
    {Hue[
      NCache[
       Rational[4727, 4769], 0.9911931222478507]], AbsoluteThickness[0.25], 
     LineBox[{14181, 14182}]}, 
    {Hue[
      NCache[
       Rational[14182, 14307], 0.9912630181030265]], AbsoluteThickness[0.25], 
     LineBox[{14182, 14183}]}, 
    {Hue[
      NCache[
       Rational[14183, 14307], 0.9913329139582023]], AbsoluteThickness[0.25], 
     LineBox[{14183, 14184}]}, 
    {Hue[
      NCache[
       Rational[4728, 4769], 0.991402809813378]], AbsoluteThickness[0.25], 
     LineBox[{14184, 14185}]}, 
    {Hue[
      NCache[
       Rational[14185, 14307], 0.9914727056685538]], AbsoluteThickness[0.25], 
     LineBox[{14185, 14186}]}, 
    {Hue[
      NCache[
       Rational[14186, 14307], 0.9915426015237296]], AbsoluteThickness[0.25], 
     LineBox[{14186, 14187}]}, 
    {Hue[
      NCache[
       Rational[4729, 4769], 0.9916124973789054]], AbsoluteThickness[0.25], 
     LineBox[{14187, 14188}]}, 
    {Hue[
      NCache[
       Rational[14188, 14307], 0.9916823932340812]], AbsoluteThickness[0.25], 
     LineBox[{14188, 14189}]}, 
    {Hue[
      NCache[
       Rational[14189, 14307], 0.991752289089257]], AbsoluteThickness[0.25], 
     LineBox[{14189, 14190}]}, 
    {Hue[
      NCache[
       Rational[4730, 4769], 0.9918221849444327]], AbsoluteThickness[0.25], 
     LineBox[{14190, 14191}]}, 
    {Hue[
      NCache[
       Rational[14191, 14307], 0.9918920807996086]], AbsoluteThickness[0.25], 
     LineBox[{14191, 14192}]}, 
    {Hue[
      NCache[
       Rational[14192, 14307], 0.9919619766547844]], AbsoluteThickness[0.25], 
     LineBox[{14192, 14193}]}, 
    {Hue[
      NCache[
       Rational[249, 251], 0.9920318725099602]], AbsoluteThickness[0.25], 
     LineBox[{14193, 14194}]}, 
    {Hue[
      NCache[
       Rational[14194, 14307], 0.992101768365136]], AbsoluteThickness[0.25], 
     LineBox[{14194, 14195}]}, 
    {Hue[
      NCache[
       Rational[14195, 14307], 0.9921716642203118]], AbsoluteThickness[0.25], 
     LineBox[{14195, 14196}]}, 
    {Hue[
      NCache[
       Rational[4732, 4769], 0.9922415600754875]], AbsoluteThickness[0.25], 
     LineBox[{14196, 14197}]}, 
    {Hue[
      NCache[
       Rational[14197, 14307], 0.9923114559306633]], AbsoluteThickness[0.25], 
     LineBox[{14197, 14198}]}, 
    {Hue[
      NCache[
       Rational[14198, 14307], 0.9923813517858391]], AbsoluteThickness[0.25], 
     LineBox[{14198, 14199}]}, 
    {Hue[
      NCache[
       Rational[4733, 4769], 0.9924512476410149]], AbsoluteThickness[0.25], 
     LineBox[{14199, 14200}]}, 
    {Hue[
      NCache[
       Rational[14200, 14307], 0.9925211434961907]], AbsoluteThickness[0.25], 
     LineBox[{14200, 14201}]}, 
    {Hue[
      NCache[
       Rational[14201, 14307], 0.9925910393513665]], AbsoluteThickness[0.25], 
     LineBox[{14201, 14202}]}, 
    {Hue[
      NCache[
       Rational[4734, 4769], 0.9926609352065423]], AbsoluteThickness[0.25], 
     LineBox[{14202, 14203}]}, 
    {Hue[
      NCache[
       Rational[14203, 14307], 0.992730831061718]], AbsoluteThickness[0.25], 
     LineBox[{14203, 14204}]}, 
    {Hue[
      NCache[
       Rational[14204, 14307], 0.9928007269168938]], AbsoluteThickness[0.25], 
     LineBox[{14204, 14205}]}, 
    {Hue[
      NCache[
       Rational[4735, 4769], 0.9928706227720696]], AbsoluteThickness[0.25], 
     LineBox[{14205, 14206}]}, 
    {Hue[
      NCache[
       Rational[14206, 14307], 0.9929405186272454]], AbsoluteThickness[0.25], 
     LineBox[{14206, 14207}]}, 
    {Hue[
      NCache[
       Rational[14207, 14307], 0.9930104144824212]], AbsoluteThickness[0.25], 
     LineBox[{14207, 14208}]}, 
    {Hue[
      NCache[
       Rational[4736, 4769], 0.993080310337597]], AbsoluteThickness[0.25], 
     LineBox[{14208, 14209}]}, 
    {Hue[
      NCache[
       Rational[14209, 14307], 0.9931502061927727]], AbsoluteThickness[0.25], 
     LineBox[{14209, 14210}]}, 
    {Hue[
      NCache[
       Rational[14210, 14307], 0.9932201020479485]], AbsoluteThickness[0.25], 
     LineBox[{14210, 14211}]}, 
    {Hue[
      NCache[
       Rational[4737, 4769], 0.9932899979031243]], AbsoluteThickness[0.25], 
     LineBox[{14211, 14212}]}, 
    {Hue[
      NCache[
       Rational[748, 753], 0.9933598937583001]], AbsoluteThickness[0.25], 
     LineBox[{14212, 14213}]}, 
    {Hue[
      NCache[
       Rational[14213, 14307], 0.9934297896134759]], AbsoluteThickness[0.25], 
     LineBox[{14213, 14214}]}, 
    {Hue[
      NCache[
       Rational[4738, 4769], 0.9934996854686517]], AbsoluteThickness[0.25], 
     LineBox[{14214, 14215}]}, 
    {Hue[
      NCache[
       Rational[14215, 14307], 0.9935695813238274]], AbsoluteThickness[0.25], 
     LineBox[{14215, 14216}]}, 
    {Hue[
      NCache[
       Rational[14216, 14307], 0.9936394771790032]], AbsoluteThickness[0.25], 
     LineBox[{14216, 14217}]}, 
    {Hue[
      NCache[
       Rational[4739, 4769], 0.993709373034179]], AbsoluteThickness[0.25], 
     LineBox[{14217, 14218}]}, 
    {Hue[
      NCache[
       Rational[14218, 14307], 0.9937792688893549]], AbsoluteThickness[0.25], 
     LineBox[{14218, 14219}]}, 
    {Hue[
      NCache[
       Rational[14219, 14307], 0.9938491647445307]], AbsoluteThickness[0.25], 
     LineBox[{14219, 14220}]}, 
    {Hue[
      NCache[
       Rational[4740, 4769], 0.9939190605997065]], AbsoluteThickness[0.25], 
     LineBox[{14220, 14221}]}, 
    {Hue[
      NCache[
       Rational[14221, 14307], 0.9939889564548823]], AbsoluteThickness[0.25], 
     LineBox[{14221, 14222}]}, 
    {Hue[
      NCache[
       Rational[14222, 14307], 0.994058852310058]], AbsoluteThickness[0.25], 
     LineBox[{14222, 14223}]}, 
    {Hue[
      NCache[
       Rational[4741, 4769], 0.9941287481652338]], AbsoluteThickness[0.25], 
     LineBox[{14223, 14224}]}, 
    {Hue[
      NCache[
       Rational[14224, 14307], 0.9941986440204096]], AbsoluteThickness[0.25], 
     LineBox[{14224, 14225}]}, 
    {Hue[
      NCache[
       Rational[14225, 14307], 0.9942685398755854]], AbsoluteThickness[0.25], 
     LineBox[{14225, 14226}]}, 
    {Hue[
      NCache[
       Rational[4742, 4769], 0.9943384357307612]], AbsoluteThickness[0.25], 
     LineBox[{14226, 14227}]}, 
    {Hue[
      NCache[
       Rational[14227, 14307], 0.994408331585937]], AbsoluteThickness[0.25], 
     LineBox[{14227, 14228}]}, 
    {Hue[
      NCache[
       Rational[14228, 14307], 0.9944782274411127]], AbsoluteThickness[0.25], 
     LineBox[{14228, 14229}]}, 
    {Hue[
      NCache[
       Rational[4743, 4769], 0.9945481232962885]], AbsoluteThickness[0.25], 
     LineBox[{14229, 14230}]}, 
    {Hue[
      NCache[
       Rational[14230, 14307], 0.9946180191514643]], AbsoluteThickness[0.25], 
     LineBox[{14230, 14231}]}, 
    {Hue[
      NCache[
       Rational[749, 753], 0.9946879150066401]], AbsoluteThickness[0.25], 
     LineBox[{14231, 14232}]}, 
    {Hue[
      NCache[
       Rational[4744, 4769], 0.9947578108618159]], AbsoluteThickness[0.25], 
     LineBox[{14232, 14233}]}, 
    {Hue[
      NCache[
       Rational[14233, 14307], 0.9948277067169917]], AbsoluteThickness[0.25], 
     LineBox[{14233, 14234}]}, 
    {Hue[
      NCache[
       Rational[14234, 14307], 0.9948976025721674]], AbsoluteThickness[0.25], 
     LineBox[{14234, 14235}]}, 
    {Hue[
      NCache[
       Rational[4745, 4769], 0.9949674984273432]], AbsoluteThickness[0.25], 
     LineBox[{14235, 14236}]}, 
    {Hue[
      NCache[
       Rational[14236, 14307], 0.995037394282519]], AbsoluteThickness[0.25], 
     LineBox[{14236, 14237}]}, 
    {Hue[
      NCache[
       Rational[14237, 14307], 0.9951072901376948]], AbsoluteThickness[0.25], 
     LineBox[{14237, 14238}]}, 
    {Hue[
      NCache[
       Rational[4746, 4769], 0.9951771859928706]], AbsoluteThickness[0.25], 
     LineBox[{14238, 14239}]}, 
    {Hue[
      NCache[
       Rational[14239, 14307], 0.9952470818480464]], AbsoluteThickness[0.25], 
     LineBox[{14239, 14240}]}, 
    {Hue[
      NCache[
       Rational[14240, 14307], 0.9953169777032222]], AbsoluteThickness[0.25], 
     LineBox[{14240, 14241}]}, 
    {Hue[
      NCache[
       Rational[4747, 4769], 0.9953868735583979]], AbsoluteThickness[0.25], 
     LineBox[{14241, 14242}]}, 
    {Hue[
      NCache[
       Rational[14242, 14307], 0.9954567694135737]], AbsoluteThickness[0.25], 
     LineBox[{14242, 14243}]}, 
    {Hue[
      NCache[
       Rational[14243, 14307], 0.9955266652687496]], AbsoluteThickness[0.25], 
     LineBox[{14243, 14244}]}, 
    {Hue[
      NCache[
       Rational[4748, 4769], 0.9955965611239254]], AbsoluteThickness[0.25], 
     LineBox[{14244, 14245}]}, 
    {Hue[
      NCache[
       Rational[14245, 14307], 0.9956664569791012]], AbsoluteThickness[0.25], 
     LineBox[{14245, 14246}]}, 
    {Hue[
      NCache[
       Rational[14246, 14307], 0.995736352834277]], AbsoluteThickness[0.25], 
     LineBox[{14246, 14247}]}, 
    {Hue[
      NCache[
       Rational[4749, 4769], 0.9958062486894527]], AbsoluteThickness[0.25], 
     LineBox[{14247, 14248}]}, 
    {Hue[
      NCache[
       Rational[14248, 14307], 0.9958761445446285]], AbsoluteThickness[0.25], 
     LineBox[{14248, 14249}]}, 
    {Hue[
      NCache[
       Rational[14249, 14307], 0.9959460403998043]], AbsoluteThickness[0.25], 
     LineBox[{14249, 14250}]}, 
    {Hue[
      NCache[
       Rational[250, 251], 0.9960159362549801]], AbsoluteThickness[0.25], 
     LineBox[{14250, 14251}]}, 
    {Hue[
      NCache[
       Rational[14251, 14307], 0.9960858321101559]], AbsoluteThickness[0.25], 
     LineBox[{14251, 14252}]}, 
    {Hue[
      NCache[
       Rational[14252, 14307], 0.9961557279653317]], AbsoluteThickness[0.25], 
     LineBox[{14252, 14253}]}, 
    {Hue[
      NCache[
       Rational[4751, 4769], 0.9962256238205074]], AbsoluteThickness[0.25], 
     LineBox[{14253, 14254}]}, 
    {Hue[
      NCache[
       Rational[14254, 14307], 0.9962955196756832]], AbsoluteThickness[0.25], 
     LineBox[{14254, 14255}]}, 
    {Hue[
      NCache[
       Rational[14255, 14307], 0.996365415530859]], AbsoluteThickness[0.25], 
     LineBox[{14255, 14256}]}, 
    {Hue[
      NCache[
       Rational[4752, 4769], 0.9964353113860348]], AbsoluteThickness[0.25], 
     LineBox[{14256, 14257}]}, 
    {Hue[
      NCache[
       Rational[14257, 14307], 0.9965052072412106]], AbsoluteThickness[0.25], 
     LineBox[{14257, 14258}]}, 
    {Hue[
      NCache[
       Rational[14258, 14307], 0.9965751030963864]], AbsoluteThickness[0.25], 
     LineBox[{14258, 14259}]}, 
    {Hue[
      NCache[
       Rational[4753, 4769], 0.9966449989515622]], AbsoluteThickness[0.25], 
     LineBox[{14259, 14260}]}, 
    {Hue[
      NCache[
       Rational[14260, 14307], 0.9967148948067379]], AbsoluteThickness[0.25], 
     LineBox[{14260, 14261}]}, 
    {Hue[
      NCache[
       Rational[14261, 14307], 0.9967847906619137]], AbsoluteThickness[0.25], 
     LineBox[{14261, 14262}]}, 
    {Hue[
      NCache[
       Rational[4754, 4769], 0.9968546865170895]], AbsoluteThickness[0.25], 
     LineBox[{14262, 14263}]}, 
    {Hue[
      NCache[
       Rational[14263, 14307], 0.9969245823722653]], AbsoluteThickness[0.25], 
     LineBox[{14263, 14264}]}, 
    {Hue[
      NCache[
       Rational[14264, 14307], 0.9969944782274411]], AbsoluteThickness[0.25], 
     LineBox[{14264, 14265}]}, 
    {Hue[
      NCache[
       Rational[4755, 4769], 0.9970643740826169]], AbsoluteThickness[0.25], 
     LineBox[{14265, 14266}]}, 
    {Hue[
      NCache[
       Rational[14266, 14307], 0.9971342699377926]], AbsoluteThickness[0.25], 
     LineBox[{14266, 14267}]}, 
    {Hue[
      NCache[
       Rational[14267, 14307], 0.9972041657929684]], AbsoluteThickness[0.25], 
     LineBox[{14267, 14268}]}, 
    {Hue[
      NCache[
       Rational[4756, 4769], 0.9972740616481442]], AbsoluteThickness[0.25], 
     LineBox[{14268, 14269}]}, 
    {Hue[
      NCache[
       Rational[751, 753], 0.99734395750332]], AbsoluteThickness[0.25], 
     LineBox[{14269, 14270}]}, 
    {Hue[
      NCache[
       Rational[14270, 14307], 0.9974138533584959]], AbsoluteThickness[0.25], 
     LineBox[{14270, 14271}]}, 
    {Hue[
      NCache[
       Rational[4757, 4769], 0.9974837492136717]], AbsoluteThickness[0.25], 
     LineBox[{14271, 14272}]}, 
    {Hue[
      NCache[
       Rational[14272, 14307], 0.9975536450688475]], AbsoluteThickness[0.25], 
     LineBox[{14272, 14273}]}, 
    {Hue[
      NCache[
       Rational[14273, 14307], 0.9976235409240232]], AbsoluteThickness[0.25], 
     LineBox[{14273, 14274}]}, 
    {Hue[
      NCache[
       Rational[4758, 4769], 0.997693436779199]], AbsoluteThickness[0.25], 
     LineBox[{14274, 14275}]}, 
    {Hue[
      NCache[
       Rational[14275, 14307], 0.9977633326343748]], AbsoluteThickness[0.25], 
     LineBox[{14275, 14276}]}, 
    {Hue[
      NCache[
       Rational[14276, 14307], 0.9978332284895506]], AbsoluteThickness[0.25], 
     LineBox[{14276, 14277}]}, 
    {Hue[
      NCache[
       Rational[4759, 4769], 0.9979031243447264]], AbsoluteThickness[0.25], 
     LineBox[{14277, 14278}]}, 
    {Hue[
      NCache[
       Rational[14278, 14307], 0.9979730201999022]], AbsoluteThickness[0.25], 
     LineBox[{14278, 14279}]}, 
    {Hue[
      NCache[
       Rational[14279, 14307], 0.9980429160550779]], AbsoluteThickness[0.25], 
     LineBox[{14279, 14280}]}, 
    {Hue[
      NCache[
       Rational[4760, 4769], 0.9981128119102537]], AbsoluteThickness[0.25], 
     LineBox[{14280, 14281}]}, 
    {Hue[
      NCache[
       Rational[14281, 14307], 0.9981827077654295]], AbsoluteThickness[0.25], 
     LineBox[{14281, 14282}]}, 
    {Hue[
      NCache[
       Rational[14282, 14307], 0.9982526036206053]], AbsoluteThickness[0.25], 
     LineBox[{14282, 14283}]}, 
    {Hue[
      NCache[
       Rational[4761, 4769], 0.9983224994757811]], AbsoluteThickness[0.25], 
     LineBox[{14283, 14284}]}, 
    {Hue[
      NCache[
       Rational[14284, 14307], 0.9983923953309569]], AbsoluteThickness[0.25], 
     LineBox[{14284, 14285}]}, 
    {Hue[
      NCache[
       Rational[14285, 14307], 0.9984622911861326]], AbsoluteThickness[0.25], 
     LineBox[{14285, 14286}]}, 
    {Hue[
      NCache[
       Rational[4762, 4769], 0.9985321870413084]], AbsoluteThickness[0.25], 
     LineBox[{14286, 14287}]}, 
    {Hue[
      NCache[
       Rational[14287, 14307], 0.9986020828964842]], AbsoluteThickness[0.25], 
     LineBox[{14287, 14288}]}, 
    {Hue[
      NCache[
       Rational[752, 753], 0.99867197875166]], AbsoluteThickness[0.25], 
     LineBox[{14288, 14289}]}, 
    {Hue[
      NCache[
       Rational[4763, 4769], 0.9987418746068358]], AbsoluteThickness[0.25], 
     LineBox[{14289, 14290}]}, 
    {Hue[
      NCache[
       Rational[14290, 14307], 0.9988117704620116]], AbsoluteThickness[0.25], 
     LineBox[{14290, 14291}]}, 
    {Hue[
      NCache[
       Rational[14291, 14307], 0.9988816663171874]], AbsoluteThickness[0.25], 
     LineBox[{14291, 14292}]}, 
    {Hue[
      NCache[
       Rational[4764, 4769], 0.9989515621723631]], AbsoluteThickness[0.25], 
     LineBox[{14292, 14293}]}, 
    {Hue[
      NCache[
       Rational[14293, 14307], 0.9990214580275389]], AbsoluteThickness[0.25], 
     LineBox[{14293, 14294}]}, 
    {Hue[
      NCache[
       Rational[14294, 14307], 0.9990913538827147]], AbsoluteThickness[0.25], 
     LineBox[{14294, 14295}]}, 
    {Hue[
      NCache[
       Rational[4765, 4769], 0.9991612497378906]], AbsoluteThickness[0.25], 
     LineBox[{14295, 14296}]}, 
    {Hue[
      NCache[
       Rational[14296, 14307], 0.9992311455930664]], AbsoluteThickness[0.25], 
     LineBox[{14296, 14297}]}, 
    {Hue[
      NCache[
       Rational[14297, 14307], 0.9993010414482422]], AbsoluteThickness[0.25], 
     LineBox[{14297, 14298}]}, 
    {Hue[
      NCache[
       Rational[4766, 4769], 0.9993709373034179]], AbsoluteThickness[0.25], 
     LineBox[{14298, 14299}]}, 
    {Hue[
      NCache[
       Rational[14299, 14307], 0.9994408331585937]], AbsoluteThickness[0.25], 
     LineBox[{14299, 14300}]}, 
    {Hue[
      NCache[
       Rational[14300, 14307], 0.9995107290137695]], AbsoluteThickness[0.25], 
     LineBox[{14300, 14301}]}, 
    {Hue[
      NCache[
       Rational[4767, 4769], 0.9995806248689453]], AbsoluteThickness[0.25], 
     LineBox[{14301, 14302}]}, 
    {Hue[
      NCache[
       Rational[14302, 14307], 0.9996505207241211]], AbsoluteThickness[0.25], 
     LineBox[{14302, 14303}]}, 
    {Hue[
      NCache[
       Rational[14303, 14307], 0.9997204165792969]], AbsoluteThickness[0.25], 
     LineBox[{14303, 14304}]}, 
    {Hue[
      NCache[
       Rational[4768, 4769], 0.9997903124344726]], AbsoluteThickness[0.25], 
     LineBox[{14304, 14305}]}, 
    {Hue[
      NCache[
       Rational[14305, 14307], 0.9998602082896484]], AbsoluteThickness[0.25], 
     LineBox[{14305, 14306}]}, 
    {Hue[
      NCache[
       Rational[14306, 14307], 0.9999301041448242]], AbsoluteThickness[0.25], 
     LineBox[{14306, 14307}]}}],
  AspectRatio->Automatic,
  ImageSize->100]], "Output",
 CellTags->"10.2 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Sound", "ExerciseSubsection"],

Cell[TextData[{
 "Evaluate ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"Play", "[", 
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"1000", "/", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}], "MR", "ExLink"]]],
 ". Explain the dynamics of the sound generated from this function."
}], "ExerciseItem",
 CellTags->"10.3 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Experiment with the ",
 Cell[BoxData[
  ButtonBox["Play",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Play"]]],
 " function by creating arithmetic combinations of sine functions. For \
example, you might try the following."
}], "ExerciseItem",
 CellTags->"10.3 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Play", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"Sin", "[", 
     RowBox[{"440", " ", "2", " ", "\[Pi]", " ", "t"}], "]"}], 
    RowBox[{"Sin", "[", 
     RowBox[{"660", " ", "2", " ", "\[Pi]", " ", "t"}], "]"}]], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"10.3 Exercises"],

Cell[BoxData[
 StyleBox[
  InterpretationBox[
   GraphicsBox[{
     {GrayLevel[0.9], RectangleBox[{0, 0}, {360, -164}]}, {InsetBox[
       GraphicsBox[InsetBox[
         GraphicsBox[RasterBox[CompressedData["
1:eJzs3flXTfH7N/6Q0iBDA5lSxlKUlJR6EkWEDFEiihQyNJGxgSJNkpSSqZSI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           "],
           ColorFunction->(Blend[{
              RGBColor[1, 1, 1], 
              RGBColor[0, 0, 1]}, #]& )],
          AspectRatio->Full,
          ImagePadding->Automatic,
          ImageSize->{1},
          PlotRangePadding->None], {0, 0}, {0, 0}, {1, 1}],
        AspectRatio->NCache[
          Rational[6, 35], 0.17142857142857143`],
        Background->GrayLevel[1],
        Frame->True,
        FrameStyle->GrayLevel[0.75],
        FrameTicks->False,
        ImagePadding->Automatic,
        ImageSize->{Automatic, 100},
        PlotRange->{{0, 1}, {0, 1}},
        PlotRangePadding->{
          Scaled[0.017142857142857144`], 
          Scaled[0.1]}], {180, -35}, ImageScaled[{0.5, 0.5}], {350, 60},
       Background->GrayLevel[0.9]], InsetBox[
       GraphicsBox[InsetBox[
         GraphicsBox[
          {RGBColor[0.325101, 0.364492, 0.820256], LineBox[CompressedData["
1:eJxcfWVUHN3SdVyIuwtxd0/IjrsQd3f3J8RdiBISCCGGB3f3YRjGhbghcXf3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            "]]},
          AspectRatio->Full,
          ImagePadding->Automatic,
          ImageSize->{Automatic, 100},
          PlotRange->{Automatic, {0, 1}},
          PlotRangePadding->None], {0, 0}, {0, 0}, {1, 1}],
        AspectRatio->NCache[
          Rational[6, 35], 0.17142857142857143`],
        Background->GrayLevel[1],
        Frame->True,
        FrameStyle->GrayLevel[0.75],
        FrameTicks->False,
        ImagePadding->Automatic,
        ImageSize->{Automatic, 100},
        PlotRange->{{0, 1}, {0, 1}},
        PlotRangePadding->{
          Scaled[0.017142857142857144`], 
          Scaled[0.1]}], {180, -100}, ImageScaled[{0.5, 0.5}], {350, 60},
       Background->GrayLevel[0.9]]}, InsetBox[
      StyleBox[
       TemplateBox[{
        TemplateBox[{"1", "\" s\""}, "Row", 
          DisplayFunction -> (RowBox[{#, "\[InvisibleSpace]", #2}]& ), 
          InterpretationFunction -> (RowBox[{"Row", "[", 
             RowBox[{"{", 
               RowBox[{#, ",", #2}], "}"}], "]"}]& )],
         TemplateBox[{"8000", "\" Hz\""}, "Row", 
          DisplayFunction -> (RowBox[{#, "\[InvisibleSpace]", #2}]& ), 
          InterpretationFunction -> (RowBox[{"Row", "[", 
             RowBox[{"{", 
               RowBox[{#, ",", #2}], "}"}], "]"}]& )]},
        "Row",
        DisplayFunction->(RowBox[{#, 
           StyleBox[
           "\" | \"", FontSize -> 14, FontColor -> GrayLevel[0.75], 
            StripOnInput -> False], #2}]& ),
        InterpretationFunction->(RowBox[{"Row", "[", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{#, ",", #2}], "}"}], ",", 
             StyleBox[
             "\" | \"", FontSize -> 14, FontColor -> GrayLevel[0.75], 
              StripOnInput -> False]}], "]"}]& )], "DialogStyle",
       StripOnInput->False], {355, -159}, Scaled[{1, 0}]], 
     TagBox[
      TooltipBox[
       TagBox[{
         {GrayLevel[0.9], RectangleBox[{5, -158}, {29, -135}]}, 
         {GrayLevel[0.3], 
          PolygonBox[
           NCache[{{13, -153}, {13, -140}, {21, Rational[-293, 2]}, {
             13, -153}}, {{13, -153}, {13, -140}, {21, -146.5}, {
             13, -153}}]]}, 
         {GrayLevel[0.5], 
          
          StyleBox[
           LineBox[{{5, -158}, {5, -135}, {29, -135}, {29, -158}, {5, -158}}],
           
           Antialiasing->False]}},
        EventHandlerTag[{"MouseClicked" :> FEPrivate`EmitSound[
            SampledSoundList[CompressedData["
1:eJxcnWVYld3WthFRsbsTAwMDA1sXIioWihiggpjYmIhJqyh2C3aBimJiL6Xs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             "], 8000], "Preemptive"], PassEventsDown -> Automatic, 
          PassEventsUp -> True}]],
       DynamicBox[
        ToBoxes[
         FEPrivate`FrontEndResource["FEStrings", "playText"], StandardForm]]],
      
      Annotation[#, 
       Dynamic[
        FEPrivate`FrontEndResource["FEStrings", "playText"]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[{
         {GrayLevel[0.9], RectangleBox[{34, -158}, {58, -135}]}, 
         {GrayLevel[0.3], RectangleBox[{42, -150}, {50, -143}]}, 
         {GrayLevel[0.5], 
          
          StyleBox[
           LineBox[{{34, -158}, {34, -135}, {58, -135}, {58, -158}, {
            34, -158}}],
           Antialiasing->False]}},
        EventHandlerTag[{"MouseClicked" :> FEPrivate`EmitSound[
            SampledSoundList[{{0.}}, 8000], "Preemptive"], PassEventsDown -> 
          Automatic, PassEventsUp -> True}]],
       DynamicBox[
        ToBoxes[
         FEPrivate`FrontEndResource["FEStrings", "stopText"], StandardForm]]],
      
      Annotation[#, 
       Dynamic[
        FEPrivate`FrontEndResource["FEStrings", "stopText"]], "Tooltip"]& ], 
     {GrayLevel[0.75], 
      StyleBox[LineBox[{{0, 0}, {360, 0}, {360, -164}, {0, -164}, {0, 0}}],
       Antialiasing->False]}},
    ContentSelectable->False,
    ImagePadding->Automatic,
    ImageSize->250,
    PlotRange->{{0, 360}, {-164, 0}},
    PlotRangePadding->1],
   Sound[
    SampledSoundFunction[
     CompiledFunction[{8, 8., 5444}, {
       Blank[Integer]}, {{2, 0, 0}, {3, 0, 
      5}}, {{0.22974524295023702`, {3, 0, 8}}, {
       0.000125, {3, 0, 1}}, {-0.03277823398096835, {3, 0, 7}}, {
       2, {2, 0, 2}}, {3.141592653589793, {3, 0, 4}}, {440, {2, 0, 1}}, {
       0., {3, 0, 0}}, {660, {2, 0, 3}}}, {0, 4, 9, 0, 
      0}, {{10, 0, 2}, {16, 1, 2, 3}, {13, 0, 3, 2}, {10, 1, 3}, {10, 2, 5}, {
       16, 3, 5, 4, 2, 3}, {40, 1, 3, 0, 3, 3, 0, 5}, {10, 3, 3}, {10, 2, 
       6}, {16, 3, 6, 4, 2, 3}, {40, 1, 3, 0, 3, 3, 0, 6}, {40, 58, 3, 0, 6, 
       3, 0, 3}, {16, 5, 3, 5}, {13, 5, 7, 5}, {16, 5, 8, 5}, {1}}, 
      Function[{Play`Time23}, 
       Block[{$CellContext`t = 0. + 0.000125 Play`Time23}, (
         Sin[((440 2) Pi) $CellContext`t]/Sin[((660 2) Pi) $CellContext`t] - 
         0.03277823398096835) 0.22974524295023702`]], Evaluate], 8000, 8000]]],
  StripOnInput->False,
  Magnification->0.5 Inherited]], "ExerciseOutput", "ExerciseMR",
 CellTags->"10.3 Exercises"]
}, Closed]]
}, Closed]],

Cell["Create a tone that doubles in frequency each second.", "ExerciseItem",
 CellTags->"10.3 Exercises"],

Cell[TextData[{
 "Create a \[OpenCurlyDoubleQuote]composition\[CloseCurlyDoubleQuote] using \
the digits of \[Pi] as representing notes on the C scale where a digit ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is interpreted as a note ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " semitones from middle C. For example, the first few digits, ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["4", "OsF"],
 ", ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["5", "OsF"],
 " would give the notes one, four, one, and five semitones from middle C."
}], "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:67"}],

Cell[TextData[{
 "A ",
 StyleBox["square wave", "TermDefinition"],
 " consists of the addition of sine waves, each an odd multiple of a \
fundamental frequency, that is, it consists of the sum of sine waves having \
frequencies ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["f", "0"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["3", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["5", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["7", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", etc. Create a square wave with a fundamental frequency ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["f", "0"], TraditionalForm]]],
 " of ",
 StyleBox["440", "OsF"],
 " hertz. The more overtones you include, the \[OpenCurlyDoubleQuote]squarer\
\[CloseCurlyDoubleQuote] the wave."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->{"10.3 Exercises", "i:68"}],

Cell[TextData[{
 "Create a square wave consisting of the sum of sine waves with frequencies \
",
 Cell[BoxData[
  FormBox[
   SubscriptBox["f", "0"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["3", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["5", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["7", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", etc., and amplitudes ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["1/3", "OsF"],
 ", ",
 StyleBox["1/5", "OsF"],
 ", ",
 StyleBox["1/7", "OsF"],
 ", respectively. This is actually a truer square wave than that produced in \
the previous exercise."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->"10.3 Exercises"],

Cell["\<\
Create a square wave consisting of overtones that are randomly out of phase. \
How does this wave differ from the previous two?\
\>", "ExerciseItem",
 CellTags->"10.3 Exercises"],

Cell[TextData[{
 "A ",
 StyleBox["sawtooth wave", "TermDefinition"],
 " consists of the sum of both odd- and even-numbered overtones: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["f", "0"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["2", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["3", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["4", "OsF"], 
    SubscriptBox["f", "0"]}], TraditionalForm]]],
 ", etc. with amplitudes in the ratios ",
 StyleBox["1", "OsF"],
 ", ",
 StyleBox["1/2", "OsF"],
 ", ",
 StyleBox["1/3", "OsF"],
 ", ",
 StyleBox["1/4", "OsF"],
 ", etc. Create a sawtooth wave and compare its tonal qualities with the \
square wave."
}], "ExerciseItem",
 ZeroWidthTimes->True,
 CellTags->{"10.3 Exercises", "i:69"}],

Cell[CellGroupData[{

Cell[TextData[{
 "A wide variety of sounds can be generated using ",
 StyleBox["frequency modulation (FM) synthesis", "TermDefinition"],
 ". The basic idea of FM synthesis is to use functions of the form"
}], "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:70"}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{"a", "  ", 
    RowBox[{"sin", "(", 
     RowBox[{
      RowBox[{
       StyleBox["2", "OsF"], "\[Pi]", " ", 
       SubscriptBox["F", "c"]}], ",", 
      RowBox[{"t", "+", 
       RowBox[{"mod", "  ", 
        RowBox[{"sin", "(", 
         RowBox[{
          StyleBox["2", "OsF"], "\[Pi]", " ", 
          SubscriptBox["F", "m"], "t"}], ")"}]}]}]}], ")"}]}], 
   TraditionalForm]]],
 "."
}], "ExerciseDisplayFormula",
 CellTags->"10.3 Exercises"],

Cell[TextData[{
 "where ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " is the peak amplitude, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "c"], TraditionalForm]]],
 " is the carrier frequency in hertz, ",
 Cell[BoxData[
  FormBox["mod", TraditionalForm]]],
 " is the modulation index, and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "m"], TraditionalForm]]],
 " is the modulating frequency in hertz. "
}], "ExerciseText",
 CellTags->"10.3 Exercises"],

Cell[TextData[{
 "Determine what effect varying the parameters has on the resulting tones by \
creating a series of FM synthesized tones. First, create a function ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"FM", "[", 
    RowBox[{"Amp", ",", "Fc", ",", "mod", ",", "Fm", ",", "time"}], "]"}], 
   "ExerciseMR"]]],
 " that implements the above formula and generates a tone using the ",
 Cell[BoxData[
  ButtonBox["Play",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Play"]]],
 " function. Then you should try several examples to see what effect varying \
the parameters has on the resulting tones. For example, you can generate a \
tone with strong vibrato at a carrier frequency at middle A for one second by \
evaluating ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"FM", "[", 
    RowBox[{"1", ",", "440", ",", "45", ",", "5", ",", "1"}], "]"}], 
   "ExLink"]]],
 "."
}], "ExerciseText",
 ParagraphIndent->12,
 CellTags->"10.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "When ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " is close to ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"-", "2"}], "OsF"], TraditionalForm]]],
 ", the frequency is quite low. As ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " increases, the fraction ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["1000", "OsF"], "/", "x"}], TraditionalForm]]],
 " increases, making the frequency of the sine function bigger. This in turn \
makes the tone much higher in pitch. As ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " approaches ",
 StyleBox["0", "OsF"],
 ", the function is oscillating more and more, and at ",
 StyleBox["0", "OsF"],
 ", the function can be thought of as oscillating infinitely often. In fact, \
it is oscillating so much that the sampling routine is not able to compute \
amplitudes effectively and, hence, we hear noise near ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "=", 
    StyleBox["0", "OsF"]}], TraditionalForm]]],
 "."
}], "SolutionItem",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{"Play", "[", 
  RowBox[{
   RowBox[{"Sin", "[", 
    FractionBox["1000", "x"], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "To generate a tone whose rate increases one octave per second, you need the \
sine of a function whose derivative doubles each second (frequency is a \
rate). That function is ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    StyleBox["2", "OsF"], 
    StyleBox["t",
     FontSize->8]], TraditionalForm]]],
 ". You need to carefully choose values for ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 " that generates tones in a reasonable range."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 2}},
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Play", "[", 
   RowBox[{
    RowBox[{"Sin", "[", 
     SuperscriptBox["2", "t"], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "10", ",", "14"}], "}"}]}], "]"}], "//", 
  "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First generate ",
 StyleBox["100", "OsF"],
 " digits for a ",
 StyleBox["100", "OsF"],
 "-note \[OpenCurlyDoubleQuote]composition\[CloseCurlyDoubleQuote]."
}], "SolutionItem",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"digs", "=", 
   RowBox[{"First", "[", 
    RowBox[{"RealDigits", "[", 
     RowBox[{"N", "[", 
      RowBox[{"\[Pi]", ",", "100"}], "]"}], "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"10.3 Solutions"],

Cell[TextData[{
 "Fix note duration at ",
 StyleBox["0.5", "OsF"],
 " seconds."
}], "SolutionText",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sound", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"SoundNote", "[", 
      RowBox[{"#", ",", "0.5"}], "]"}], "&"}], "/@", "digs"}], "]"}], "//", 
  "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"],

Cell[TextData[{
 "Change the duration to be dependent upon the digit. Also change the ",
 StyleBox["midi", "OsF"],
 " instrument."
}], "SolutionText",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sound", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"SoundNote", "[", 
      RowBox[{"#", ",", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"#", "+", "1"}], ")"}]}], ",", "\"\<Vibraphone\>\""}], "]"}],
      "&"}], "/@", "digs"}], "]"}], "//", "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"],

Cell["\<\
Go a bit further, expanding the range of notes that will be played.\
\>", "SolutionText",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sound", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"SoundNote", "[", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"2", "#"}]}], ",", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"#", "+", "1"}], ")"}]}], ",", "\"\<Vibraphone\>\""}], "]"}],
      "&"}], "/@", "digs"}], "]"}], "//", "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Here is a function that creates a square wave with decreasing amplitudes for \
higher overtones.\
\>", "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"squareWave", "[", 
   RowBox[{"freq_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"Sin", "[", 
      RowBox[{"freq", " ", "i", " ", "2", " ", "\[Pi]", " ", "t"}], "]"}], 
     "i"], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n", ",", "2"}], "}"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"10.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"squareWave", "[", 
    RowBox[{"440", ",", "17"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", ".01"}], "}"}]}], "]"}]], "Input",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUWnk4Vl8XJUolKvOckExJRCosJHPmeZ7nJpUkIZUmFZFSMpRkHjImdUNK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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0, 0.01}, {-0.9267733820569221, 0.9267719959099802}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell["Here then, is an example of playing a square wave.", "SolutionText",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Play", "[", 
   RowBox[{
    RowBox[{"squareWave", "[", 
     RowBox[{"440", ",", "17"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", ".5"}], "}"}]}], "]"}], "//", 
  "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
This function creates a sawtooth wave. The user specifies the fundamental \
frequency and the number of terms in the approximation.\
\>", "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sawtoothWave", "[", 
   RowBox[{"freq_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"Sin", "[", 
      RowBox[{"freq", " ", "i", " ", "2", " ", "\[Pi]", " ", "t"}], "]"}], 
     "i"], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]], "InputOnly",
 CellTags->"10.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"sawtoothWave", "[", 
    RowBox[{"440", ",", "17"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", ".01"}], "}"}]}], "]"}]], "Input",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUl3k8lF8bxgmRJPuWSsiSkrWkciHZKtn3fd+TSqWSpKhoE5UkyZKthJDU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->140,
  PlotRange->{{0, 0.01}, {-1.763853883508721, 1.7638083218207523`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.3 Solutions"]
}, Closed]],

Cell["This plays the wave for a half-second duration.", "SolutionText",
 CellTags->"10.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Play", "[", 
   RowBox[{
    RowBox[{"sawtoothWave", "[", 
     RowBox[{"440", ",", "17"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", ".5"}], "}"}]}], "]"}], "//", 
  "EmitSound"}]], "Input",
 CellTags->"10.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  StyleBox["ComplexListPlot", "ExLink"]]],
 " that plots a list of complex numbers in the complex plane using ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]]],
 ". Set initial options so that the ",
 Cell[BoxData[
  ButtonBox["PlotStyle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/PlotStyle"]]],
 " is red, the ",
 Cell[BoxData[
  ButtonBox["PointSize",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/PointSize"]]],
 " is a little larger than the default, and the horizontal and vertical axes \
are labeled \[OpenCurlyDoubleQuote]Re\[CloseCurlyDoubleQuote] and \
\[OpenCurlyDoubleQuote]Im,\[CloseCurlyDoubleQuote] respectively. Set it up so \
that options to ",
 Cell[BoxData[
  StyleBox["ComplexListPlot", "ExLink"]]],
 " are inherited from ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]]],
 ". "
}], "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:112"}],

Cell[TextData[{
 "Create a function ",
 Cell[BoxData[
  StyleBox["ComplexRootPlot", "ExerciseMR"]]],
 " that plots the complex solutions to a polynomial in the plane. Use your \
implementation of ",
 Cell[BoxData[
  StyleBox["ComplexListPlot", "ExLink"]]],
 " that you developed in the previous exercise. "
}], "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:113"}],

Cell[TextData[{
 "Modify ",
 Cell[BoxData[
  StyleBox["PathPlot", "ExLink"]]],
 " so that it inherits options from ",
 Cell[BoxData[
  ButtonBox["Graphics",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graphics"]]],
 " as well as having its own option, ",
 Cell[BoxData[
  StyleBox["PathClosed", "ExLink"]]],
 ", that can take on values of ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/True"]]],
 " or ",
 Cell[BoxData[
  ButtonBox["False",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/False"]]],
 " and closes the path accordingly by appending the first point to the end of \
the list of coordinate points."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "Extend the code for ",
 Cell[BoxData[
  StyleBox["ListLinePlot3D", "ExLink"]]],
 " so that the rule for multiple datasets incorporates the options that were \
used for the single dataset rule in the text."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "Although the program ",
 StyleBox["SimpleClosedPath", "MR", "ExLink"],
 " works well, there are conditions under which it will occasionally fail. \
Experiment by repeatedly computing ",
 StyleBox["SimpleClosedPath", "MR", "ExLink"],
 " for a set of ten points until you see the failure. Determine the \
conditions that must be imposed on the selection of the base point for the \
program to work consistently."
}], "ExerciseItem",
 CellTags->{"Ex.SimpleClosedPath", "10.4 Exercises", "i:114"}],

Cell[TextData[{
 "Modify ",
 StyleBox["SimpleClosedPath", "MR", "ExLink"],
 " so that the point with the smallest ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 "-coordinate of the list of data is chosen as the ",
 StyleBox["base", "MR", "ExLink"],
 " point; repeat but with the largest ",
 StyleBox["y",
  FontSlant->"Italic"],
 "-coordinate."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "Another way of finding a simple closed path is to start with any closed \
path and progressively make it simpler by finding intersections and changing \
the path to avoid them. Prove that this process ends, and that it ends with a \
closed path. Write a program to implement this procedure and then compare the \
paths given by your function with those of ",
 StyleBox["SimpleClosedPath", "MR", "ExLink"],
 " given in the text."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Following on the framework of the ",
 StyleBox["RootPlot", "ExerciseMR"],
 " example in this section, create a function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["ShowWalk", "ExerciseMR"], "[", 
   StyleBox["walk", "ExerciseTI"], "]"}]], "ExerciseMR"],
 " that takes the coordinates of a random walk and plots them in one, two, or \
three dimensions, depending upon the structure of the argument ",
 StyleBox["walk",
  FontSlant->"Italic"],
 ". For example:"
}], "ExerciseItem",
 CellTags->{"10.4 Exercises", "Ex.ShowWalk", "i:115"}],

Cell[BoxData[
 RowBox[{"<<", "PwM`RandomWalks`"}]], "Input", "ExerciseMR",
 CellTags->"10.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowWalk", "[", 
  RowBox[{
   RowBox[{"RandomWalk", "[", 
    RowBox[{"500", ",", 
     RowBox[{"Dimension", "\[Rule]", "1"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input", \
"ExerciseMR",
 CellTags->"10.4 Exercises"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxd2EvS1UQYh/HWkcMMGDBgECnqK4qiqHC/qNByUVCQCAoCChHEK0pAQBCU
XsJZQi8hO7CXkCX0EjJwAZb2+4/Vzxlw6qlfvelOzuHkq7x99+GV+2865/5+
w7l/38trOVW/O1+/v+Vrb+T22ib/q7xvl6fytkPHsW6tG+ud1tusd1lvt96C
78b8Hhx/L9bfB+8wvx/HPwA/iPlD8MOYP4L9H4Ufgx+33mF9wrq1fsd6p/W7
1rus34OfhJ+y3rL21rtLB/Ue8/fhas2fhp+Gn4GfgZ+t9xfOws/Bz8E/wPHV
2v+H1nvN1fvMz1t35ufhFzB/Af4RXK31P8b+1Nr/RWud30X4Jcxfgn+CebU+
/8vW9v0Jl+F97V5t37+gtu9ngrtPMa+24wd4grsr9f79ldqDWvNqrX8V61+t
Pai1f7j7rHavtv+fQW3/vxPcfV67V9vvQ4AnuLtmbb9P/lrtQa15uLuO+eu1
B7Xm1dr/F9i/WvPwBHc3MH+j9gBPcHcT+79Ze1BrXq3938L6t2oP8AR3X2Je
rfXVtr+k1v3tK3l5ebXdH8Pq5T2pdR+9Xbu/XXtQ2302wd2d2v2d2oNa66t1
/x5qb9U27+EDPMAjPKltf1mtvxO+tnf7O6FV298JHj6obT6o7fhRrfXhGfPu
LtZXa334oNb68Ij5BM+Yd/fq/bX3avfwAR7UWh+eMJ/h7husr9bnDx/gAR7V
Wh+e4e4+1ldrffgAD/AIT2r7fma1vv/f1t6qtT58gAd4hCe1zh/uvsP6atuf
hw9qrQ+PmE/wDHffY321zh8+qPX7tnp5RXjCfMbx3Q9YX63zX728BniAR3iC
59Xt9/tHeSrrq+3338MHeFDb/SOq7f6S4Bnz7iesr7b9efgAD/CotuMneMa8
eyAvr/ZB7R4+rG7Xf/XyHtX6/sMz3P1ce6vW5w8f4GH18orwhPms1vq/YH21
1l+9vIbV7fqvnsr6al1/tT5/uHtYz7dqXf/Vbf3V7fxXL+9Rreuv1u8P3I31
fDPW3sI7ta4PvMf8oLb1R3iAb9R2f4jwCZ7gMzyr7f64qPUc4pG923OI5lHt
rdrmO7Xuz2pbv1fr/NV2fUZ4gG/gET7BE9afsb8MX+Dusb3b+TWPa2/VNt+p
dX+A95gf4CPmg1rnr7bvV1y9vCZ4wvwMz5hfVrffv19rb9Q2365e3ju4h/dq
ff7wER7gGxw/wifMJ/iM+QxfMO+e2Lt9Ps2T2lu1zh/uMd+r9fnDR8wH+AYe
4RM8YX8zPGN+gbun9XzztPYW3sE9vFfb9R9WL69xdbt/rJ7++3ezHr90VNv9
Y1Lr7wv4jPkMX+DuWe3Ns9pbte2vg3t4Dx/gIzxg/Q08wid4gs9quz4ZvmDe
/Vbvr1Hb59PCO7XOX23H7+EDfFTr+YTanj9t1PZ8Kqrt+daktudjSW3Pz2Z4
xvwCd8/r+eZ57S28U2+V9mp7Ptmr7fnnoLbnoyM8YH6D40esP8ET5md4hi9Y
372ovXlRewvv1HZ8r7b99Wq7foParv+o1vNJtT5/eMT8hOMnrD9jfxm+YN79
Xh+/Udv6LbyDe7Xtv4cPmB/Ver6rtv1t1Lb/qLbrP6nt80nwGZ7V9v1b1Hp+
/9Lanv83L2tv4Z16f2kP7+EDfMTxA3wDj2rb/wRP8Fmt81fr+w93r2pvXtXe
wjv1VmkP7zE/qPX/Hx7gG7XOHz7Bk9qu3wzPmF+wvvuj9katzx/ewb1an79a
n7/6QOkRHuAb9cHSET5hPsFnzGf4And/Wh8q3agPl27VR0p3cA/v1UdLD+pj
pUf18dIBvoFH9YnSEzzBZ3iGL3D3uvbmde2t2vbXqe38/P/+DyKJbaA=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Frame->True,
  GridLines->Automatic,
  ImageSize->{170.8188883682936, Automatic},
  PlotRange->{{0., 500.}, {-26., 8.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowWalk", "[", 
  RowBox[{
   RowBox[{"RandomWalk", "[", 
    RowBox[{"500", ",", 
     RowBox[{"Dimension", "\[Rule]", "2"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
   RowBox[{"MeshStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"Brown", ",", 
      RowBox[{"PointSize", "[", "Small", "]"}]}], "]"}]}]}], "]"}]], "Input", \
"ExerciseMR",
 CellTags->"10.4 Exercises"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJytmDuO3DAQRGlHChUwYMBAFgTDt9g5wx7BgGMfcXSkDXwAw7CbgN6opsiR
mQhP1c3/p8kv33++//icUvr1KaU/37/p456OaT/nsJsEh90kvrP4Tz9Vziz0
Xn/XjtZuka8qh/mqbySpi/KZ/1Xdlp+O/PH2XI/0MI/Mf6kj32l/ro/2v6zH
G37c8B883VBPcAI/5B//1fyAvfKnrr4PdlHu7Zxbgt7tvx+5rXvBMzgLPQnO
4GJ0+k/gV+s/C2Z7WB9V/0kw8wt9FvbkCvsq9OAF9sHZ6PQPXmEfnMFFsCqf
/q5+bH8Gu/5x/iyf9S+wD47xquDF6MEZHPNxAVMvg3oWPIFjPRXBsX9UMHX6
u/yr0V35zT+d64vgSKtg5e/KL+AMngXHvp3BRXDbh/5927wHU1f+kX8VHOlq
/1F3/k7fBMf8CY75vgpO4Ifyhf8imOvZ6bEfrIJno5eLOvNn/6j9yelsH/e/
As6CuX+9qnN/dOVTH60/4wue/1lwr//V+OPV+IfxoIqv2P/Ue+OzSehufF89
H9X4jp6vRbA6H2fB7Z4NfRL2Kn91/vfGx278OD/iHFH66P2Culsfrv5qfqn+
VfcL3kdG7+e8R/M9hZzB7T61H5m6829xDfJr8bXgpVNPglfYr0JX/qyv0l37
6N9bf/pzPLLRlb8bnxZnhX865wouQm9xH5j2RegtjoU9ebT8Bdzmw+3I1IM3
2G9CD/6K+pG/GV3l/6Dfz9mVz/xWcOuv+zlz/qjxjaTGhzrLd7qbv8P6/ly3
7d+P3Ns/vfOb+uj+69Z/u7fAfxU6518kNT+d7uYv15daf2p9833qf79fVcHq
fYi68o/2FcGq/AW8Co7yNzB1+jP/Bfau/aPvf+59zb3vufc7937o3k8TWJ0/
FfZkdT5G6o3PGD9c1SfwLLiAK+yq0Nu9H/ZtvMHV6O3dolPP4BnM+NLpwZvQ
X41P231dMMdLnU9Ovxofu/N1NL5355PrXzd+wdv+Gzhk0gI=
   "], {{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1dOWGAgQBNBMbNu2bds2J+bEtm3btm3btu01sjdnH271F1R1ssCg6p0C
ggUL9l38vMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEIS
kZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpR
mCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGY
JjSlGYE0pwUtaUVr2tCWdrSnAx3pRBCd6UJXutGdHvSkF73pQ1/60Z8BDGQQ
gxnCUIYxnBGMZBSjGcNYxjGeCUxkEpOZwlSmMZ0ZzGQWs5nDXOYxnwUsZBGL
WcJSlrGcFaxkFatZw1rWsZ4NbGQTm9nCVraxnR3sZBe72cNe9rGfAxzkEIc5
wlGOcZwTnOQUpznDWc5xngtc5BKXucJVrnGdG9zkFre5w13ucZ8HPOQRj3nC
U57xnBe85BWvecNb3vGeD3zkE5/5wle+8Z1f+JXf+J0/+JO/+Jt/+Jcf/Cx/
AMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEISkZgkJCUZ
yUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpRmCIUpRjF
KUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGYJjSlGYE0
pwUtaUVr2tCWdrSnAx35Od5BdKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZ
xnBGMJJRjGYMYxnHeCYwkUlMZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nG
clawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZx
TnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzmCU95xnNe
8JJXvOYNb3nHez7wkU985gtf+Rbw/z//Dz189+A=
       "]]}}, {
     {RGBColor[0.6, 0.4, 0.2], PointSize[Small], PointBox[CompressedData["
1:eJwl1dOWGAgQBNBMbNu2bds2J+bEtm3btm3btu01sjdnH271F1R1ssCg6p0C
ggUL9l38vMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEIS
kZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpR
mCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGY
JjSlGYE0pwUtaUVr2tCWdrSnAx3pRBCd6UJXutGdHvSkF73pQ1/60Z8BDGQQ
gxnCUIYxnBGMZBSjGcNYxjGeCUxkEpOZwlSmMZ0ZzGQWs5nDXOYxnwUsZBGL
WcJSlrGcFaxkFatZw1rWsZ4NbGQTm9nCVraxnR3sZBe72cNe9rGfAxzkEIc5
wlGOcZwTnOQUpznDWc5xngtc5BKXucJVrnGdG9zkFre5w13ucZ8HPOQRj3nC
U57xnBe85BWvecNb3vGeD3zkE5/5wle+8Z1f+JXf+J0/+JO/+Jt/+Jcf/Cx/
AMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEISkZgkJCUZ
yUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpRmCIUpRjF
KUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGYJjSlGYE0
pwUtaUVr2tCWdrSnAx35Od5BdKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZ
xnBGMJJRjGYMYxnHeCYwkUlMZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nG
clawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZx
TnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzmCU95xnNe
8JJXvOYNb3nHez7wkU985gtf+Rbw/z//Dz189+A=
       "]]}, {}, {}}}],
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{119.40000000000003`, Automatic},
  PlotRange->{{-7., 10.}, {-12., 3.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowWalk", "[", 
  RowBox[{
   RowBox[{"RandomWalk", "[", 
    RowBox[{"2500", ",", 
     RowBox[{"Dimension", "\[Rule]", "3"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Background", "\[Rule]", "LightGray"}], ",", 
   RowBox[{"BoxRatios", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], "]"}]], "Input", \
"ExerciseMR",
 CellTags->"10.4 Exercises"],

Cell[BoxData[
 Graphics3DBox[Line3DBox[CompressedData["
1:eJy13AmS3EZ6xXEstXeTLdKSPBI94/CVfAQfwL6k72GPNBKbbC7dtS9YTITz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   "]],
  Background->GrayLevel[0.85],
  BoxRatios->{1, 1, 1},
  ImageSize->{108.30314947094904`, Automatic}]], "Output",
 CellTags->"10.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["Mesh",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Mesh"]], "InlineFormula"],
 " in a manner similar to its use in the ",
 Cell[BoxData[
  StyleBox["RootPlot", "ExerciseMR"]]],
 " function to highlight the ",
 StyleBox["intersection",
  FontSlant->"Italic"],
 " of two surfaces, say ",
 Cell[BoxData[
  FormBox[
   RowBox[{"sin", "(", 
    RowBox[{
     RowBox[{"2", "x"}], "-", 
     RowBox[{"cos", "(", "y", ")"}]}], ")"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"sin", "(", 
    RowBox[{"x", "-", 
     RowBox[{"cos", "(", 
      RowBox[{"2", "y"}], ")"}]}], ")"}], TraditionalForm]]],
 ". You may need to increase the value of ",
 Cell[BoxData[
  ButtonBox["MaxRecursion",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MaxRecursion"]], "InlineFormula"],
 " to get the sampling just right."
}], "ExerciseItem",
 CellTags->{"Ex.Mesh", "i:116", "10.4 Exercises"}],

Cell[TextData[{
 "Rewrite ",
 Cell[BoxData[
  StyleBox["TrendPlot", "ExLink"]]],
 " to compute a more robust plot range, one based on the minimum and maximum \
values of the data together with the minimum and maximum user-specified rates."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "Modify the graphics code at the end of the ",
 Cell[BoxData[
  StyleBox["PointInPolygonQ", "MR", "ExLink"]]],
 " example so that ",
 Cell[BoxData[
  ButtonBox["GatherBy",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GatherBy"]]],
 " always orders the two lists so that the list of points that pass occurs \
before the list of points that fail the test."
}], "ExerciseItem",
 CellTags->{"Ex.PointInPolygon", "10.4 Exercises"}],

Cell[TextData[{
 "Write a function ",
 StyleBox["pentatonic", "MR", "ExLink"],
 " that generates ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["f", "2"]}], TraditionalForm]]],
 " music choosing notes from a five-tone scale. A pentatonic scale can be \
played on a piano by beginning with C\[Sharp], and then playing only the \
black keys: C\[Sharp], E\[Flat], F\[Sharp], A\[Flat], C\[Sharp]. The \
pentatonic scale is common to Chinese, Celtic, and Native American music."
}], "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:117"}],

Cell[TextData[{
 "Modify the routine for generating ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["f", "0"]}], TraditionalForm]]],
 " music so that frequencies are chosen according to a specified probability \
distribution. For example, you might use the following distribution that \
indicates a note and its probability of being chosen: C \[Dash] ",
 StyleBox["5", "OsF"],
 "%, C\[Sharp] \[Dash] ",
 StyleBox["5", "OsF"],
 "%, D \[Dash] ",
 StyleBox["5", "OsF"],
 "%, E\[Flat] \[Dash] ",
 StyleBox["10", "OsF"],
 "%, E \[Dash] ",
 StyleBox["10", "OsF"],
 "%, F \[Dash] ",
 StyleBox["10", "OsF"],
 "%, F\[Sharp] \[Dash] ",
 StyleBox["10", "OsF"],
 "%, G \[Dash] ",
 StyleBox["10", "OsF"],
 "%, A\[Flat] \[Dash] ",
 StyleBox["10", "OsF"],
 "%, A \[Dash] ",
 StyleBox["10", "OsF"],
 "%, B\[Flat] \[Dash] ",
 StyleBox["5", "OsF"],
 "%, B \[Dash] ",
 StyleBox["5", "OsF"],
 "%, C \[Dash] ",
 StyleBox["5", "OsF"],
 "%."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "Modify the routine for generating ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["f", "0"]}], TraditionalForm]]],
 " music so that the ",
 StyleBox["durations",
  FontSlant->"Italic"],
 " of the notes obey ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["f", "0"]}], TraditionalForm]]],
 " scaling."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[TextData[{
 "If you read musical notation, take a musical composition such as one of \
Bach\[CloseCurlyQuote]s ",
 StyleBox["Brandenburg Concertos ",
  FontSlant->"Italic"],
 "and write down a list of the frequency intervals ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " between successive notes. Then find a function that interpolates the power \
spectrum of these frequency intervals and determine if this function is of \
the form ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"f", "(", "x", ")"}], "=", 
    RowBox[{"c", "/", "x"}]}], TraditionalForm]]],
 " for some constant ",
 Cell[BoxData[
  FormBox["c", TraditionalForm]]],
 ". (",
 StyleBox["Hint",
  FontSlant->"Italic"],
 ": To get the power spectrum, you will need to square the magnitude of the \
Fourier transform: take ",
 Cell[BoxData[
  StyleBox[
   SuperscriptBox[
    RowBox[{"Abs", "[", 
     RowBox[{"Fourier", "[", "\[Ellipsis]", "]"}], "]"}], "2"], "ExLink"]]],
 " of your data.) Compute the power spectra of different types of music using \
this procedure."
}], "ExerciseItem",
 CellTags->"10.4 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "The function ",
 Cell[BoxData["ComplexListPlot"]],
 " plots a list of numbers in the complex plane \[Dash] the real part is \
identified with the horizontal axis and the imaginary part is identified with \
the vertical axis. Start by setting the options for ",
 Cell[BoxData["ComplexListPlot"]],
 " to inherit those for ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ComplexListPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{"points_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Re", "[", "#", "]"}], ",", 
         RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], ",", "points"}], 
     "]"}], ",", "opts", ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"PointSize", "[", ".025", "]"}]}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Re\>\"", ",", "10"}], "]"}], ",", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Im\>\"", ",", "10"}], "]"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"\"\<Menu\>\"", ",", "7"}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[TextData[{
 "This plots four complex numbers in the plane and uses some options, \
inherited from ",
 Cell[BoxData[
  ButtonBox["ListPlot",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ListPlot"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ComplexListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "I"}], ",", 
     RowBox[{"2", "+", "I"}], ",", 
     RowBox[{"1", "-", 
      RowBox[{"2", "I"}]}], ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", 
      RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], "]"}]], "Input",\

 CellTags->"10.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {RGBColor[0, 0, 1], PointSize[Medium], 
    PointBox[{{-1., 1.}, {2., 1.}, {1., -2.}, {0., 0.}, {1., 0.}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox[
     StyleBox["\"Re\"", 10, StripOnInput -> False], TraditionalForm], 
    FormBox[
     StyleBox["\"Im\"", 10, StripOnInput -> False], TraditionalForm]},
  AxesOrigin->{0, 0},
  ImageSize->140,
  LabelStyle->Directive["Menu", 7],
  PlotRange->{{-1., 2.}, {-2., 1.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The function ",
 Cell[BoxData["ComplexRootPlot"]],
 " takes a polynomial, solves for its roots, and then uses ",
 Cell[BoxData["ComplexListPlot"]],
 " from the previous exercise to plot these roots in the complex plane."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexRootPlot", "[", 
   RowBox[{"poly_", ",", "z_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"ComplexListPlot", "[", 
   RowBox[{
    RowBox[{"z", "/.", 
     RowBox[{"NSolve", "[", 
      RowBox[{
       RowBox[{"poly", "==", "0"}], ",", "z"}], "]"}]}], ",", "opts", ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ComplexRootPlot", "[", 
  RowBox[{
   RowBox[{"Cyclotomic", "[", 
    RowBox[{"17", ",", "z"}], "]"}], ",", "z", ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{{}, 
   {RGBColor[1, 0, 0], PointSize[0.025], 
    PointBox[{{-0.9829730996839018, -0.1837495178165703}, \
{-0.9829730996839018, 
     0.1837495178165703}, {-0.8502171357296141, -0.5264321628773558}, \
{-0.8502171357296141, 
     0.5264321628773558}, {-0.6026346363792564, -0.7980172272802395}, \
{-0.6026346363792564, 
     0.7980172272802395}, {-0.27366299007208283`, -0.961825643172819}, \
{-0.27366299007208283`, 0.961825643172819}, {
     0.09226835946330199, -0.9957341762950345}, {0.09226835946330199, 
     0.9957341762950345}, {0.44573835577653825`, -0.8951632913550623}, {
     0.44573835577653825`, 0.8951632913550623}, {
     0.7390089172206591, -0.6736956436465572}, {0.7390089172206591, 
     0.6736956436465572}, {0.9324722294043558, -0.361241666187153}, {
     0.9324722294043558, 0.361241666187153}}]}, {}},
  Axes->True,
  AxesLabel->{
    FormBox[
     StyleBox["\"Re\"", 10, StripOnInput -> False], TraditionalForm], 
    FormBox[
     StyleBox["\"Im\"", 10, StripOnInput -> False], TraditionalForm]},
  AxesOrigin->{0, 0},
  GridLines->Automatic,
  ImageSize->{117.49999999999943`, Automatic},
  LabelStyle->Directive["Menu", 7],
  PlotRange->{{-0.9829730996839018, 0.9324722294043558}, {-0.9957341762950345,
    0.9957341762950345}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First, set up the options structure.", "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "PathPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ClosedPath", "\[Rule]", "True"}], "}"}], ",", 
     RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[TextData[{
 "Make two changes to the original ",
 Cell[BoxData["PathPlot"]],
 ": add an ",
 Cell[BoxData[
  ButtonBox["If",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/If"]], "InlineFormula"],
 " statement that checks the value of ",
 Cell[BoxData["ClosedPath"]],
 " and if ",
 Cell[BoxData["True"]],
 ", appends the first point to the end of the list; if ",
 Cell[BoxData["False"]],
 ", it leaves the coordinate list as is. The second change is to filter those \
options that are specific to ",
 Cell[BoxData[
  ButtonBox["Graphics",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graphics"]], "InlineFormula"],
 " and insert them in the appropriate place."
}], "SolutionText",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PathPlot", "[", 
   RowBox[{"lis_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"coords", "=", "lis"}], "}"}], ",", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"OptionValue", "[", "ClosedPath", "]"}], ",", 
       RowBox[{"coords", "=", 
        RowBox[{"coords", "/.", "\[VeryThinSpace]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}]}]}], "]"}], ";", 
     RowBox[{"Graphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", "coords", "]"}], ",", 
         RowBox[{"PointSize", "[", "Medium", "]"}], ",", "Red", ",", 
         RowBox[{"Point", "[", "coords", "]"}]}], "}"}], ",", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], "]"}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "424", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "2"}], "}"}]}], "]"}]}], ";"}]}], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PathPlot", "[", 
  RowBox[{"coords", ",", 
   RowBox[{"ClosedPath", "\[Rule]", "True"}], ",", 
   RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   LineBox[{{0.6787838216938529, 0.5452963820009011}, {0.461919091833626, 
    0.9162533375419761}, {0.4309757578196278, 0.4975172614852761}, {
    0.9075689219421059, 0.522305863824448}, {0.894369504184636, 
    0.4739011186812556}, {0.7372864936045569, 0.2821643765062798}, {
    0.058635675752258365`, 0.14485648698711873`}, {0.554460814746407, 
    0.8990541477766953}, {0.10973314310203675`, 0.4497053727499607}, {
    0.49048014508455773`, 0.17966863661174504`}, {0.6787838216938529, 
    0.5452963820009011}}], 
   {RGBColor[1, 0, 0], PointSize[Medium], 
    PointBox[{{0.6787838216938529, 0.5452963820009011}, {0.461919091833626, 
     0.9162533375419761}, {0.4309757578196278, 0.4975172614852761}, {
     0.9075689219421059, 0.522305863824448}, {0.894369504184636, 
     0.4739011186812556}, {0.7372864936045569, 0.2821643765062798}, {
     0.058635675752258365`, 0.14485648698711873`}, {0.554460814746407, 
     0.8990541477766953}, {0.10973314310203675`, 0.4497053727499607}, {
     0.49048014508455773`, 0.17966863661174504`}, {0.6787838216938529, 
     0.5452963820009011}}]}},
  GridLines->Automatic,
  ImageSize->100]], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Choosing a base point randomly and then sorting according to the arc \
tangent could cause a number of things to go wrong with the algorithm.",
 " The default branch cut for ",
 Cell[BoxData[
  ButtonBox["ArcTan",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ArcTan"]], "InlineFormula"],
 " gives values between ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Pi]"}], "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Pi]", "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 ". (You are encouraged to think about why this could occasionally cause the \
algorithm in the text to fail.) By choosing the base point so that it lies at \
some extreme of the diameter of the set of points, the polar angle algorithm \
given in the text will work consistently. If you choose the base point so \
that it is lowest and left-most, then all the angles will be in the range (",
 StyleBox["0", "OsF"],
 ", \[Pi]]."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimpleClosedPath1", "[", "lis_List", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"base", ",", "angle", ",", "sorted"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"base", "=", 
      RowBox[{"First", "[", 
       RowBox[{"SortBy", "[", 
        RowBox[{"lis", ",", "Last"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angle", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
      RowBox[{"ArcTan", "@@", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sorted", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"lis", ",", 
          RowBox[{"{", "base", "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#1"}], "]"}], "\[LessEqual]", 
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#2"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "base", "}"}], ",", "sorted", ",", 
       RowBox[{"{", "base", "}"}]}], "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PathPlot", "[", "coords_List", "]"}], ":=", 
  RowBox[{"Show", "[", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Line", "[", "coords", "]"}], ",", 
      RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
      RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
      RowBox[{"Point", "/@", "coords"}]}], "}"}], "]"}], "]"}]}]], "InputOnly",\

 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PathPlot", "[", 
  RowBox[{"SimpleClosedPath1", "[", "pts", "]"}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQzbMxOl3j4lV7h1UMlioeE+0bfMsu/5K7Z//gr3Hl
Mc7l9ka65ufumT6zfyERUH/p4yl7FmXnk1w/3ttv2LDwxrWvt+3DZuXf72t8
Zf/ngEmc68cH9vesYvn/iD6zf/Nio8IasZv2GdGtJ6+ue2P/QGbtbf9Tj+1T
alY818p5Z88j9ffJb51n9hc+ccY+Enli3/BOJdZz+y37Fxf1U6KKH9knTNuy
9h/DffsNQgJTdULu2t95HTd/6YUL9u+WT+i+bwA053prZuXWF/ZT+KvFL6ne
s79y5+bhdt079iwKB+yzzW7ZW/DaZ281uWQ/o8y6sSHtlr1PuVmSVMdde4vz
imsS427bZwQveldp9cjegWvq1DSdm/ZCdo171zu+sncw9Q7733re3sx1y9mt
4U/sHdzco3YqHbdPU3blfyEAdOezez67g/fZvxFQ447SfGqPHn4ADo+mTg==

    "]], 
   {RGBColor[1, 0, 0], PointSize[Medium], 
    PointBox[{0.3408909806592113, 0.016876760462915863`}], 
    PointBox[{0.4706408562717215, 0.04499645452051104}], 
    PointBox[{0.694075968517984, 0.21050482956361027`}], 
    PointBox[{0.9990285807517414, 0.4368798366110793}], 
    PointBox[{0.8283151973708509, 0.5294520225488948}], 
    PointBox[{0.6901836681443816, 0.3920088118826601}], 
    PointBox[{0.8963421760516725, 0.6184462824393471}], 
    PointBox[{0.9507040524075703, 0.6929912064013606}], 
    PointBox[{0.6275493447461375, 0.4174369248973804}], 
    PointBox[{0.5765811878941891, 0.48443572009487035`}], 
    PointBox[{0.4582625823680173, 0.2627347999911629}], 
    PointBox[{0.5997159696464658, 0.7721526204102074}], 
    PointBox[{0.4710583905509733, 0.4402789509399103}], 
    PointBox[{0.40957146859773297`, 0.2844670817687134}], 
    PointBox[{0.4125062238725632, 0.4614320716008151}], 
    PointBox[{0.42763559160015374`, 0.5696382199117638}], 
    PointBox[{0.3933350048793365, 0.8205183697954814}], 
    PointBox[{0.24627677644313373`, 0.6357068078670298}], 
    PointBox[{0.18074719341398016`, 0.6270637796634275}], 
    PointBox[{0.11846514345861614`, 0.6612978189228023}], 
    PointBox[{0.3408909806592113, 0.016876760462915863`}]}},
  ImageSize->100]], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A simple change to the program ",
 Cell[BoxData["SimpleClosedPath"]],
 " chooses the base point with the largest ",
 Cell[BoxData[
  FormBox["y", TraditionalForm]]],
 "-coordinate."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimpleClosedPath3", "[", "lis_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"base", ",", "angle", ",", "sorted"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"base", "=", 
      RowBox[{"Last", "[", 
       RowBox[{"SortBy", "[", 
        RowBox[{"lis", ",", "Last"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angle", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
      RowBox[{"ArcTan", "@@", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}]}]}], ";", 
     RowBox[{"sorted", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Complement", "[", 
         RowBox[{"lis", ",", 
          RowBox[{"{", "base", "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#1"}], "]"}], "\[LessEqual]", 
          RowBox[{"angle", "[", 
           RowBox[{"base", ",", "#2"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "base", "}"}], ",", "sorted", ",", 
       RowBox[{"{", "base", "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{"PathPlot", "[", 
  RowBox[{"SimpleClosedPath3", "[", "pts", "]"}], "]"}]], "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create three rules, one for each of the three dimensions of random walk \
that will be passed to ",
 Cell[BoxData["ShowWalk"]],
 ". Some pattern matching will help to identify the rule to use for the one-, \
two-, and three-dimensional cases."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"_", "?", "VectorQ"}]}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatchQ", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], 
  "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell["\<\
The first rule uses a pattern that will be matched by a one-dimensional \
vector.\
\>", "SolutionText",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowWalk", "[", 
   RowBox[{
    RowBox[{"coords_", "?", "VectorQ"}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"coords", ",", " ", 
    RowBox[{"FilterRules", "[", 
     RowBox[{
      RowBox[{"{", "opts", "}"}], ",", 
      RowBox[{"Options", "[", "ListLinePlot", "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"10.4 Solutions"],

Cell["\<\
The second rule uses a pattern that will be matched by a list of one or more \
pairs of numbers.\
\>", "SolutionText",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowWalk", "[", 
   RowBox[{
    RowBox[{"coords", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumberQ"}], ",", 
         RowBox[{"_", "?", "NumberQ"}]}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"ListLinePlot", "[", 
   RowBox[{"coords", ",", " ", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", 
        RowBox[{"Options", "[", "ListLinePlot", "]"}]}], "]"}], ",", " ", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"10.4 Solutions"],

Cell["\<\
The third rule uses a pattern that will be matched by one or more triples of \
numbers.\
\>", "SolutionText",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowWalk", "[", 
   RowBox[{
    RowBox[{"coords", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumberQ"}], ",", 
         RowBox[{"_", "?", "NumberQ"}], ",", 
         RowBox[{"_", "?", "NumberQ"}]}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"Graphics3D", "[", 
   RowBox[{
    RowBox[{"Line", "[", "coords", "]"}], ",", " ", 
    RowBox[{"FilterRules", "[", 
     RowBox[{
      RowBox[{"{", "opts", "}"}], ",", 
      RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  ButtonBox["PlotStyle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/PlotStyle"]], "InlineFormula"],
 " to highlight the two different surfaces and ",
 Cell[BoxData[
  ButtonBox["MeshStyle",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MeshStyle"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Mesh",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Mesh"]], "InlineFormula"],
 " to highlight their intersection."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Sin", "[", 
    RowBox[{
     RowBox[{"2", "x"}], "-", 
     RowBox[{"Cos", "[", "y", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"Sin", "[", 
    RowBox[{"x", "-", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", "y"}], "]"}]}], "]"}]}], ";"}]}], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"x", ",", "y"}], "]"}], ",", 
     RowBox[{"g", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
   RowBox[{"Mesh", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"{", "0.", "}"}], "}"}]}], ",", 
   RowBox[{"MaxRecursion", "\[Rule]", "4"}], ",", 
   RowBox[{"MeshFunctions", "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"#1", ",", "#2"}], "]"}], "-", 
       RowBox[{"g", "[", 
        RowBox[{"#1", ",", "#2"}], "]"}]}], "&"}], ")"}]}], ",", 
   RowBox[{"MeshStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", "Red"}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Cyan", ",", "Yellow"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx0XXVcF+nzx8SuU8/uM884AxXjWfvsjrO7u87ubsXu7u6zntWzDxss0AMR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   "], {{
     {RGBColor[0, 1, 1], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxEnXW8VMX7x/fu3T67d/de7ADh7kUxQcUWC8RARUTBQASRUBQsSpBGQEFR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         "]], Polygon3DBox[CompressedData["
1:eJwtmgm4ltMWx98zfKczdDpNpijpe9/PEAoN5jEhhSZDihAuuRQyTxlKxSVj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         "]]}]}, 
     {RGBColor[1, 1, 0], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxMnXW8VcXXxq9iIGBxzj25T1695yp2YCc2KgbYGIgtBooBioUIAiaIgqLY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         "]], Polygon3DBox[CompressedData["
1:eJwtmnmgV9MWx4+pDCW6vzv87lS3m3OOoQwZn5kUHk+S8ZmTPKUyRANCMqdC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         "]]}]}, {}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl08tvjHEUxvHjUrcyWkSs0LhG06bVNobpyOgtEmwkNmqjYWHS6FYTJCyw
kNghJIKmJC6NBSIZpoZKBXWrutSlJDaE2vgDfCYWb77nPOc55/x+75u3oqNr
694JETHkeVIeUYzz2FQa0Tg5oobQOSOijL4DN8oXievUqnEsEZHGa0siNuOW
iRHtuA2z2I7duBuP4V2+U9gxJeISPiqJuIUJ9bN2DojP4WL5WrXKmRHPnGeY
3o9Ztct2J2Y5B09OnuRbxfeG54W4gj4iHrTrLb6iLaOlsJrvHe25/uvmlOEK
tZ6l7qv+Xm2l/ANWYoY2Kr7BW85bRXtgZxO9xqyPasPFufRP4sd2fsYR2mpa
C9bxfaG91H/bnLlYr9aqNkZvEH/FNdhGq+cfctdvtMzyiIL4ip2/9R7ieU3f
jw/xpuegd9mLfXrz9p8svlffaZeeo+Kd2CdfPydinzyFZ+Snfc898pLpESfk
28Vd3kOtPZvEo75tI1Z52uxbWCTfX/VxM586V499s+n3xUdoBbVmXq3Rwuuq
0elcG8R/7BucxDstwhXjMH8//wKmjJ5e9yDFBTNZI61ngN/xolWhmfe4xhT9
F0NBzai4R0/rnypOqhkTWTu/m9Mg/8mb580xk+OAWTk98+1dp++iBmmc52eL
Wj05gVJ0895RnMebJFyVj8t/lP7/X/4B+nJnZA==
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0j1IlWEYxvHbOAahpalp0vHYyTwKpdDmKaPARfwgcgisBmkJG3Rp0MmM
IC1wSKimaDGIwqVP+zDLsSVzSXLTvr8jiGjp99Lw8r+u677v53nehyd7bLBn
oCAiZnwd2YiVsohSfLElYqQqIlcRsXdzxE95G11QHnEU22WldFF1xEm+l6/l
p82c4ftzEc38RDKPFfqu0KP6uvhqfpqf4I/w8/QJfG5umb4sH+Yb9P3ir/Nj
/F/rpzZFXKI34DVs0ZOhF/QMpK3v/HfkOzHFl8tr1O/KUvQ9LMQRe92n2zMR
S74ZulbfKfkDeiv9ELP4CLvs/RiLzc7ioYaI9fQTusP8a98cvU3/U6zDZ1iP
L/UNOku3M83LphojmuhCWaXadj1p699WG6ancNx/FdFV8ov8H1zDl+FZPm/u
OD/kvEP8UnLvuKw+R/+ujDic3Cl/g//Kd/LdZlpxzPq3zJ5Xe6XWJLup9zS/
yGf4Rnvs0V9C98oDJ/Xsp9uSmvN3+o8+6/zwRjbSi97OBT379HyXteI3zCdn
wINqX7Ckzj3VeGvuopj+LDun9gnH8SPuMvMBm/E9XrXPDvodfUDPW1xnNm+N
WWutpd/IRtVWMZf8q3PuTv9/3/8Aw/pngw==
       "]]}, 
     {RGBColor[1, 0, 0], Thickness[Large], Line3DBox[CompressedData["
1:eJwV0jtIllEYB/DjoIZLOKjlFflSumAI0SJok4O4hNaUEtrkooWBFBiSDZp4
ydtYtqlRqeAgURaUThoVXkArsCGjQG3ShOp3hh//53nOed/zve/7FTa21DQn
hRDGokQIb0+EsMA7ZotCWGGNVc6ZvZclvOAsdWb3ZQ+p1Osr+E2pfldeKQ5h
T56XF2QbmeoMrnLEvnFnj5gP81P9TD5nST3BhnqTJ0zyxjXN8rv8wXY8y749
psyn+cZT/ed4LzkjV1nhi/6VTLhuXt6O57LDlLWT5qc5RaNZi2yQL+V1Euoc
WUsuvfqLZKsDedTor1GgvkE+RfrLcoZpLtFn1i7v8MHZs6Srf5lXMqge4gFf
rf2j3fyv/MQcD/VbJLNMB6nx/ZDCaHxO+9Li88vXPFI/Zoyj3OUenfH72L8v
s3yfYzSpqyhXH8o6eSDL7Psjq+nmuL4rvk+5zC1u0spHzlgboD/+z/yGbLku
F/kPWUlupA==
       "]], Line3DBox[CompressedData["
1:eJwV0TtIlmEYBuDXNrNcalHBs7+LUYm2pP/vGYIMchAqM2gtdTHNPVsa2go6
QWGesDUXMalArSFty1pKDSUPhUGmRl7vcHHfz/t87/fLZ8HVrpbOtBDCCE+L
QpguDuEDMzwzv5CDcl7O8ZH35oclITzgETXOztKuv+Sz/QV5kXEu0Wx/IhFC
vd5Avr7uuTq9QC+ikEPmFc/WccB8X2Y4uyen5S0W+MRXTsbf4w2vuclbKj0/
QIfeyV+2+UM5l727Pf49NPDL2ZbnT+m/Zaa5RE+R4Lp5gmS8Z9+mX5Fl5mOU
mhP8pNW8KTfsj+rnOUKVedd5k97Ijp5Gtp5DFl98k7vO5pnjnDuH4x2K7Tfs
G/U1mWfO5WB8jzxDoNad/876ZLp8wuP4bczX4l1+MBW/pfcMOx9hVB+Sz+Uq
3+zfySW5SIXdivmOzOU0eeTb/ZO98f9iPylfcZwe5zWylhTL9oXyu0zKasY8
c1vO0s+euUfeiPRuqvQld/YBvqhu8A==
       "]], 
      Line3DBox[{9123, 9794, 9709, 9609, 9509, 9363, 9307, 9191, 9161, 9124, 
       9194, 9248, 9164, 9127, 9417, 9427, 9418, 9419, 9420, 9449, 9421, 9249,
        9199, 9356, 9330, 9676, 9331, 9616, 9181, 9328, 9329, 9327}], 
      Line3DBox[{9132, 9428, 9131, 9202, 9702, 9701, 9706, 9395, 9205, 9206, 
       9139, 9209, 9210, 9373, 9439, 9143, 9438, 9170, 9144, 9220, 9148}], 
      Line3DBox[{9150, 9400, 9399, 9620, 9621, 9257, 9695, 9256, 9317, 9225, 
       9431, 9432, 9405, 9463, 9404, 9403, 9234, 9258, 9235, 9154, 9241, 9265,
        9175, 9157, 9245, 9266, 9325, 9362, 9516, 9603, 9710, 9793, 9792}], 
      Line3DBox[CompressedData["
1:eJwV0btL1WEYwPFXqAg0M7yCOoiaXVXQvDsrkZbH8pjQonktClobUkGNNqdy
9J6VLrXUFjpI0hYNTlr/QaaTt887fPg+z/uec37HY1Hv88SzlBDCMpvFIRSU
hJDPhjlPK5gpDaFSp5hk1f6JNX7R7Oyn9uiwjjBEHX99zqDW89B9z+UQPpg/
ct+c7qzDXGDupJBz9mNazUc6xSHfvPaMLvOeu6Q6e6Q17HjWV3u2+byOMW9e
YIlF2kk6r9LH7PGPfWf1nnegmfYycxVXaLPPUW2e1Tt0eV2v9sXfwHOvuWvg
KlnO0uL7SKUl/o6apNpdud6Kz+SA//QzQJO7Rrq956x9hYT9gv1e/Fx9YL9O
rj1d2+M9re4u6pDmuRvUF7oVP9tcq+/44/u+1V295HyCDH7bv5NrXtdsbSCL
bUaY4zY3KIn/Jx3VV4wxTiPTzpP6Of5W3LQXxb9dv2g36+bX+oMc8wkvzU/0
DU9J2Of1FAV2YBY=
       "]], 
      Line3DBox[{9824, 10414, 10371, 10243, 10160, 10075, 10006, 9891, 10007, 
       10051, 9857, 9825, 10076, 10008, 9892, 9895, 9860, 10120, 10357, 10119,
        10144, 10145, 9899, 10077, 10122, 10121, 10123, 9993, 10421, 9994, 
       9967, 9900, 9995, 9949, 10127, 9950, 9905, 10155, 9908, 10109, 9907}], 
      Line3DBox[{9833, 10056, 10030, 10031, 9909, 10129, 10128, 10146, 9951, 
       10179, 9910, 10271, 9911, 10334, 10265, 10270, 10269, 9953, 10267, 
       10268, 10266, 9913, 10183, 9914, 10182, 9954, 9917, 9841, 10112, 9865, 
       9927, 9926, 10067, 9931}], 
      Line3DBox[{9848, 10132, 9957, 10133, 10022, 9959, 10134, 9958, 10001, 
       9934, 9974, 10003, 10430, 10002, 10137, 10135, 10136, 10091, 9937, 
       10114, 10115, 9940, 9964, 10024, 10025, 10097, 9853, 10026, 10028, 
       10027, 9941, 10029, 10071, 10162, 10232, 10372, 10406, 10405}], 
      Line3DBox[CompressedData["
1:eJwV0jtIlWEcB+BPSRIDB1HSoSEHdTHNFk2HlsrMwkRLzRzsHCvxAkGBiyYo
hFSj2gVapZAumlppEc2mQwaaRoZbKig0idrzDs/5vf8L3znnPedoc2d1R0IU
Ra/oyfGSF0X7uVFUJftkP936CepE7qif8I4JUvR6OcS4+qq8RiNl6nOygn/O
NXyhlq96zygNz5NPKecsZzjNDbM2btLKLbp8lge8N//Ih/Bs9bScZIYpUu3W
00Ada3ZaZJxh55idXPK4y229AQ47Z1Jlr5pLDOnH9VpIC++hl02MTrP7zDnP
88n5ovwsL8jKcH9UcJ4TlLDBDps0027/uixknVPe568c1N+S2xSHO9dv01uW
rfKnXGKRJvNRvaVwR86PeEgyr8Pvw4bZG7kp38oxfrDAQXvfZdysnyPqEZkl
V/R/EVMfl0X0cI/HDIf/jVmtTLLfIQ+Eu5f1XOEye3YWwneWheoX7DoXyGPk
81z9x84q6fwmg5NmL5mjgW/MUsJ/nKF0YA==
       "]], Line3DBox[CompressedData["
1:eJwVzjsvg2EYBuDXL+An6KJOo1PEqdhIJCR2FgNVGkHoYOoidHaMUyQk/AUl
GBxCWpvZeSQYKnF1uHI/z/0+yfdFhhP94yUhhCQLFSFkiEVD2JSTlSE0mpOy
QfbIXnbYYptv/Z7c5YCCPSP/5DFp8ylnZDmhTf/Dhm+0yk5djJQ9xzzL/PDL
Knes8eQ+Sov7Z/lCM932Otkl6+UUb+5vGdFVUc0Q07pFBsw5d3lu7Of2Sy54
1JUVe3OpvJYrbq7kKLN82ve9zRR7+SXj+jHuzSn5Lpvkq1xijkO3WdbNR7LG
ey0P5oIuISeI06cflx20s8aHm+vivxHxXk5el7YP8g9vqlOq
       "]], 
      Line3DBox[CompressedData["
1:eJwVzzcsRlEYgOFjMalRBiy6nRWJKJOB2MkvwYQgOgOxq6uWqNE2dbJgIBiU
aCuTGYvnDk/ec8537s29ubGuxs64EMIQy0Uh5JWEMK35+qOrVBWHsKIP+sgh
ryS5k8iMWYJ200W8WZpmkEk6a+5UO69hNnoXyc4ntE97GTBbYpBhhmgzr9VR
Rpizf+SXOvs/vdEtvdY4Sr2riSdnrfqsMd3WF3rc6aXdekOfmYruR/+nF1xx
ybezs+h7rE91wTOp1ifWB9ab2qHnuq97jJi/apk200IBRRQyxjjHnvngnRT7
ec806Jv9EYFscpg0qzfLsl6P/otF634++aLSvIJddrinPPov7rjlH+yhUwQ=

       "]], Line3DBox[CompressedData["
1:eJwl0ckrBGAcBuCPsV8s/4FtHJw4GM5kL3txsuRMzsQ/gLOtuHC0hSwpFDmh
XCg0CgflRFEoz+Tw9H6/9/s1802TPzDcPpQUQhijpSiE7OIQ6mmgjrJoCN28
umuRrTTRTCM1+lly7M7IUQpYN6/xUeiz5RmnxNy1UUmj+cv9svMKV85bdDh3
UsIYW/zqr+3/yEHzNnfmex44J6KbIDnBvJN4lzfmUkceEf2bvse5PPFbzEss
kkdX4m36dPrNWbJWlyEzKdVNc+gdU/JATspxO1Uk8UKcR/bdB7kjn+QJz3yb
b2WUeRYYsXosjyji086c3JSXbPBOha6PXd97Q5xV/QV7zvv0kuq9KVTbjcg+
XZqMRf//6z83ak7F
       "]], Line3DBox[CompressedData["
1:eJwl0bkrxnEAx/Gvm2KyO3KuFAZ/gYXiD3BMjnooVyYxuMltcQwIpZ6wKHIr
bLKZFJPJtTDI68nw6v35fp/h+9Qvt6m9NhIXQujhozCEY0qLQrimhB0+iRaH
sKtvfp+0N+1nZuxpsuxZnePHbmTbrubbXtMtVnlzfmXQ7mOMKudxneDXPmDI
W2002PWssMy+uw2dYz32LsPuIlzZT3rIO+nOdZkh1OiZc78e6TM3doee08mA
80Xsnjw7ny77Ubv1S0f8v2ES7FEtp4JWTt31ajMtvDhX6goF9j1L9iJ79rwu
ELUf9NYbU3qnGe5q7RON58rdbey7aJn7S811TrFzNFXTSCaJRLKL/r/pH3Xo
U/I=
       "]]}, {}, {}, {}, {}, {}}},
   VertexNormals->CompressedData["
1:eJxse3k0V9/3PlGGhKQ0IAmhzKRBjiQhGgwpGdOMSoqEogwZIsmYEKJBIhnD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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  ImageSize->120,
  Method->{"RotationControl" -> "Globe"},
  PlotRange->
   NCache[{{-Pi, Pi}, {-Pi, Pi}, {-1., 1.}}, {{-3.141592653589793, 
    3.141592653589793}, {-3.141592653589793, 3.141592653589793}, {-1., 1.}}],
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellTags->"10.4 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "One approach is to compute a plot range using something like the following, \
where ",
 Cell[BoxData["minR"]],
 " is the minimum rate and ",
 Cell[BoxData["maxR"]],
 " is the maximum rate specified by the user."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1.05", "+", "minR"}], ")"}], " ", "min"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{".95", "+", "maxR"}], ")"}], " ", "max"}]}], "}"}]], "Program",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "TrendPlot", "]"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrendPlot", "::", "usage"}], "=", 
   "\"\<TrendPlot[data,{r1,r2,\[Ellipsis]}] plots data with trend lines \
showing growth rates over time.\>\""}], ";"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrendlineStyle", "::", "usage"}], "=", 
   "\"\<TrendlineStyle is an option for TrendPlot that specifies the style of \
the trend lines.\>\""}], ";"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TrendPlot", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"TrendlineStyle", "\[Rule]", "Automatic"}], "}"}], ",", 
     RowBox[{"Options", "[", "DateListPlot", "]"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TrendPlot", "[", 
   RowBox[{"data_", ",", "rates_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "min", ",", "max", ",", "tlStyle", ",", "tLine", ",", "rtTicks", ",", 
      RowBox[{"init", "=", 
       RowBox[{"data", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", "minR", ",", "maxR"}], 
     "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", "max"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"Max", "[", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"minR", ",", "maxR"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", "rates", "]"}], ",", 
        RowBox[{"Max", "[", "rates", "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"tlStyle", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "TrendlineStyle", "]"}], "===", 
         "Automatic"}], ",", 
        RowBox[{"{", 
         RowBox[{"Dashed", ",", "Gray"}], "}"}], ",", 
        RowBox[{"OptionValue", "[", "TrendlineStyle", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tLine", "[", "r_", "]"}], ":=", 
      RowBox[{"Flatten", "@", 
       RowBox[{"{", 
        RowBox[{"tlStyle", ",", "\[IndentingNewLine]", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"First", "[", "data", "]"}], ",", 
            RowBox[{
             RowBox[{"Last", "[", "data", "]"}], "/.", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"d_List", ",", 
                RowBox[{"val_", "?", "NumberQ"}]}], "}"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"d", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "+", "r"}], " ", ")"}], "init"}]}], 
               "}"}]}]}]}], "}"}], "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"rtTicks", "=", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "+", "#"}], ")"}], "init"}], ",", 
           RowBox[{"StringForm", "[", 
            RowBox[{"\"\< `1`%\>\"", ",", "#2"}], "]"}]}], "}"}], "&"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"rates", ",", 
          RowBox[{"100", "rates"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"DateListPlot", "[", 
      RowBox[{"data", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", 
         RowBox[{"Options", "[", "DateListPlot", "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Epilog", "\[RuleDelayed]", 
        RowBox[{"Map", "[", 
         RowBox[{"tLine", ",", "rates"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1.05", "+", "minR"}], ")"}], "min"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{".95", "+", "maxR"}], ")"}], "max"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "rtTicks"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"FinancialData", "[", 
    RowBox[{"\"\<^DJI\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<August 30 2011\>\"", ",", "\"\<December 30 2011\>\""}], 
      "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rates", "=", 
   RowBox[{"{", 
    RowBox[{"0.05", ",", "0.12", ",", 
     RowBox[{"-", "0.05"}], ",", 
     RowBox[{"-", "0.12"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"TrendPlot", "[", 
  RowBox[{"data", ",", "rates", ",", "\[IndentingNewLine]", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", "Blue"}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"TrendlineStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Thick", ",", "Dashed", ",", 
      RowBox[{"Lighter", "@", "Gray"}]}], "}"}]}]}], "]"}]}], "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "If the first point returned by ",
 Cell[BoxData[
  ButtonBox["GatherBy",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GatherBy"]], "InlineFormula"],
 " fails the ",
 Cell[BoxData["PointInPolygonQ"]],
 " test, then reverse the two lists (",
 Cell[BoxData["out"]],
 " and ",
 Cell[BoxData["in"]],
 "), otherwise, leave it alone."
}], "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"poly", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.5"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.", ",", 
       RowBox[{"-", "1.1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.5", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7500", ",", "2"}], "}"}]}], "]"}]}], ";"}]}], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleArea", "[", 
   RowBox[{"tri", ":", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Det", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"PadRight", "[", 
        RowBox[{"#", ",", "3", ",", "1"}], "]"}], "&"}], ",", "tri"}], "]"}], 
    "]"}], "/", "2"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PointInPolygonQ", "[", 
   RowBox[{
    RowBox[{"poly", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"pt", ":", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"edges", ",", "e2", ",", "e3", ",", "e4"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"edges", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"poly", "/.", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], ",", "2", ",", "1"}],
        "]"}]}], ";", 
     RowBox[{"e2", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{"edges", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x1_", ",", "y1_"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x2_", ",", "y2_"}], "}"}]}], "}"}], "/;", 
         RowBox[{"y1", "\[Equal]", "y2"}]}]}], "]"}]}], ";", 
     RowBox[{"e3", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{"e2", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x1_", ",", "y1_"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x2_", ",", "y2_"}], "}"}]}], "}"}], "/;", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Min", "[", 
             RowBox[{"y1", ",", "y2"}], "]"}], "\[GreaterEqual]", "y"}], "||", 
           RowBox[{
            RowBox[{"Max", "[", 
             RowBox[{"y1", ",", "y2"}], "]"}], "<", "y"}]}], ")"}]}]}], 
       "]"}]}], ";", 
     RowBox[{"e4", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Reverse", "@", 
          RowBox[{"SortBy", "[", 
           RowBox[{"#", ",", "Last"}], "]"}]}], "&"}], ",", "e3"}], "]"}]}], 
     ";", 
     RowBox[{"OddQ", "[", 
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"TriangleArea", "[", 
           RowBox[{"Join", "[", 
            RowBox[{"#", ",", 
             RowBox[{"{", "pt", "}"}]}], "]"}], "]"}], "&"}], "/@", "e4"}], 
        ",", 
        RowBox[{"_", "?", "Positive"}]}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"gbPts", "=", 
   RowBox[{"GatherBy", "[", 
    RowBox[{"pts", ",", 
     RowBox[{
      RowBox[{"PointInPolygonQ", "[", 
       RowBox[{"poly", ",", "#"}], "]"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"PointSize", "[", "Small", "]"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"PointInPolygonQ", "[", 
          RowBox[{"poly", ",", 
           RowBox[{"gbPts", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}], ",", "gbPts", 
         ",", 
         RowBox[{"Reverse", "[", "gbPts", "]"}]}], "]"}], "/.", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"in_List", ",", "out_List"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"Point", "@", "in"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"LightGray", ",", 
            RowBox[{"Point", "@", "out"}]}], "}"}]}], "}"}]}]}]}], "}"}], ",",
     "Thick", ",", 
    RowBox[{"Line", "[", 
     RowBox[{"poly", "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a_", ",", "b__"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "a"}], "}"}]}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PointSize", "[", "Large", "]"}], ",", 
    RowBox[{"Point", "[", "poly", "]"}]}], "\[IndentingNewLine]", "}"}], 
  "]"}]}], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 GraphicsBox[{
   {PointSize[Small], 
    {GrayLevel[0], PointBox[CompressedData["
1:eJwUmnk4VO8bxo+lopRpUSppkkpRVLKUek67SpEkRTVSkpB8JQlNhURqipBU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      "]]}, 
    {GrayLevel[0.85], PointBox[CompressedData["
1:eJwUmHs4VG8Xhuc8koRUCBGVSlKpFFmvSEJShApNqFQqSVIpKkmi/FRSUZMk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      "]]}}, 
   {Thickness[Large], 
    LineBox[{{-0.5, 0}, {0.5, -1}, {1.5, 0}, {2., -1.1}, {2.5, 0}, {1.5, 2}, {
      1., 1}, {0., 1}, {-0.5, 0}}], 
    {PointSize[Large], 
     PointBox[{{-0.5, 0}, {0.5, -1}, {1.5, 0}, {2., -1.1}, {2.5, 0}, {
       1.5, 2}, {1., 1}, {0., 1}}]}}},
  ImageSize->{231.9999999999999, Automatic}]], "Output",
 CellTags->"10.4 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["First create the pentatonic scale using symbolic notes.", "SolutionItem",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pscale", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C#\>\"", ",", "\"\<Eb\>\"", ",", "\"\<F#4\>\"", ",", "\"\<Ab\>\"", 
     ",", "\"\<C#2\>\""}], "}"}]}], ";"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"steps", "=", "12"}], ",", 
      RowBox[{"instr", "=", "\"\<Vibraphone\>\""}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"notes", "=", 
      RowBox[{"RandomChoice", "[", 
       RowBox[{"pscale", ",", 
        RowBox[{"{", "steps", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"durs", "=", 
      RowBox[{"RandomChoice", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"1", "/", "16"}], ",", "1", ",", 
          RowBox[{"1", "/", "16"}]}], "]"}], ",", 
        RowBox[{"{", "steps", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Sound", "@", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SoundNote", "[", 
          RowBox[{"#1", ",", "#2", ",", "instr"}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"notes", ",", "durs"}], "}"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}], "//", "EmitSound"}]], "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["First set up the options structure.", "SolutionItem",
 AutoSpacing->False,
 CounterAssignments->{{"SolutionItem", 13}},
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "BrownianCompose", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Weights", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"steps_Integer", ",", 
    RowBox[{"instr_:", "\"\<Vibraphone\>\""}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"walk", ",", "durs", ",", "weights"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"weights", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "Weights", "]"}], "===", "Automatic"}], 
        ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"1", "/", "9"}], ",", 
          RowBox[{"{", "9", "}"}]}], "]"}], ",", 
        RowBox[{"OptionValue", "[", "Weights", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"walk", "[", "n_", "]"}], ":=", 
      RowBox[{"Accumulate", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"weights", "\[Rule]", 
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "4"}], ",", "4"}], "]"}]}], ",", "n"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"durs", "=", 
      RowBox[{"RandomChoice", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"1", "/", "16"}], ",", "1", ",", 
          RowBox[{"1", "/", "16"}]}], "]"}], ",", 
        RowBox[{"{", "steps", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Sound", "@", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SoundNote", "[", 
          RowBox[{"#1", ",", "#2", ",", "instr"}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"walk", "[", "steps", "]"}], ",", "durs"}], "}"}]}], 
       "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"18", ",", "\"\<Marimba\>\""}], "]"}], "//", 
  "EmitSound"}]], "InputOnly",
 CellTags->"10.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrownianCompose", "[", 
   RowBox[{"18", ",", "\"\<Marimba\>\"", ",", 
    RowBox[{"Weights", "\[Rule]", 
     RowBox[{"Abs", "@", 
      RowBox[{"RandomVariate", "[", 
       RowBox[{
        RowBox[{"NormalDistribution", "[", 
         RowBox[{"0", ",", "4"}], "]"}], ",", "9"}], 
       StyleBox["]", "DesignDiscussion"]}]}]}]}], "]"}], "//", 
  "EmitSound"}]], "Input",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["11", "ChapterN"],

Cell[CellGroupData[{

Cell["Dynamic expressions", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Manipulating expressions", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell["\<\
Create a dynamic interface that displays various diagrams and plots of the \
amino acids. A list of the amino acids is given by:\
\>", "ExerciseItem",
 CellTags->{"11.1 Exercises", "i:26"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChemicalData", "[", "\"\<AminoAcids\>\"", "]"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"11.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Glycine\"\>", ",", "\<\"LAlanine\"\>", ",", "\<\"LSerine\"\>", 
   ",", "\<\"LProline\"\>", ",", "\<\"LValine\"\>", ",", "\<\"LThreonine\"\>",
    ",", "\<\"LCysteine\"\>", ",", "\<\"LIsoleucine\"\>", 
   ",", "\<\"LLeucine\"\>", ",", "\<\"LAsparagine\"\>", 
   ",", "\<\"LAsparticAcid\"\>", ",", "\<\"LGlutamine\"\>", 
   ",", "\<\"LLysine\"\>", ",", "\<\"LGlutamicAcid\"\>", 
   ",", "\<\"LMethionine\"\>", ",", "\<\"LHistidine\"\>", 
   ",", "\<\"LPhenylalanine\"\>", ",", "\<\"LArginine\"\>", 
   ",", "\<\"LTyrosine\"\>", ",", "\<\"LTryptophan\"\>"}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"11.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "The diagrams and plots that should be included are built into ",
 Cell[BoxData[
  ButtonBox["ChemicalData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ChemicalData"]], "InlineFormula"],
 ":"
}], "ExerciseText",
 CellTags->"11.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringCases", "[", 
   RowBox[{
    RowBox[{"ChemicalData", "[", "\"\<Properties\>\"", "]"}], ",", 
    RowBox[{"__", "~~", 
     RowBox[{"\"\<Diagram\>\"", "|", 
      RowBox[{"(", 
       RowBox[{"__", "~~", "\"\<Plot\>\""}], ")"}]}]}]}], "]"}], "//", 
  "Flatten"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"11.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"CHColorStructureDiagram\"\>", 
   ",", "\<\"CHStructureDiagram\"\>", ",", "\<\"ColorStructureDiagram\"\>", 
   ",", "\<\"MoleculePlot\"\>", ",", "\<\"SpaceFillingMoleculePlot\"\>", 
   ",", "\<\"StructureDiagram\"\>"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"11.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Create a dynamic interface that applies several built-in effects to an \
image. The effects are given by ",
 Cell[BoxData[
  ButtonBox["ImageEffect",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ImageEffect"]], "InlineFormula"],
 " and include ",
 Cell[BoxData[
  StyleBox["\"\<Charcoal\>\"", "ExerciseMR"]]],
 ", ",
 Cell[BoxData[
  StyleBox["\"\<Solarization\>\"", "ExerciseMR"]]],
 ", ",
 Cell[BoxData[
  StyleBox["\"\<GaussianNoise\>\"", "ExerciseMR"]]],
 " and many others. See the documentation for ",
 Cell[BoxData[
  ButtonBox["ImageEffect",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ImageEffect"]], "InlineFormula"],
 " for a complete list."
}], "ExerciseItem",
 CellTags->{"i:27", "11.1 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Modify the dynamic Venn diagram created in this section to display a truth \
table like that developed in Exercise ",
 StyleBox["9", "OsF"],
 " from Section ",
 StyleBox["5.8.", "OsF"],
 " Include the truth table side-by-side with the Venn diagram, like in the \
following:"
}], "ExerciseItem",
 CellTags->{"i:28", "11.1 Exercises"}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`f$$ = Xor, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`f$$], Xor, "Logical function"}, {
      And, Or, Xor, Implies, Nand, Nor}}}, Typeset`size$$ = {
    379., {85., 95.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = False, $CellContext`f$779$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`f$$ = Xor}, 
      "ControllerVariables" :> {
        Hold[$CellContext`f$$, $CellContext`f$779$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Row[{
         IPM4`Chap05Functional`TruthTable[
          $CellContext`f$$[$CellContext`A, $CellContext`B], {$CellContext`A, \
$CellContext`B}], 
         Show[
          RegionPlot[
           
           Apply[$CellContext`f$$, $CellContext`eqns], {$CellContext`x, -2, 
            2}, {$CellContext`y, -2, 2}, Frame -> None, 
           PlotLabel -> $CellContext`f$$[$CellContext`A, $CellContext`B], 
           PlotRange -> {{-2, 2}, {-1.2, 1.2}}, AspectRatio -> Automatic, 
           MaxRecursion -> 5], 
          Graphics[{
            Circle[$CellContext`c1], 
            Circle[$CellContext`c2], 
            Text[
            "\!\(\*\nStyleBox[\"A\",\nFontSlant->\"Italic\"]\)", {-0.5, 0.8}], 
            Text[
            "\!\(\*\nStyleBox[\"B\",\nFontSlant->\"Italic\"]\)", {0.5, 
             0.8}]}], ImageSize -> Small]}], 
      "Specifications" :> {{{$CellContext`f$$, Xor, "Logical function"}, {
         And, Or, Xor, Implies, Nand, Nor}}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{443., {147., 155.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({{IPM4`Chap05Functional`TruthTable[
           Pattern[IPM4`Chap05Functional`Private`expr, 
            Blank[]], 
           Pattern[IPM4`Chap05Functional`Private`vars, 
            Blank[]]] := 
         Module[{IPM4`Chap05Functional`Private`len = 
            Length[IPM4`Chap05Functional`Private`vars], 
            IPM4`Chap05Functional`Private`tuples, 
            IPM4`Chap05Functional`Private`rules, 
            IPM4`Chap05Functional`Private`table, 
            IPM4`Chap05Functional`Private`head}, 
           IPM4`Chap05Functional`Private`tuples = 
            Tuples[{True, False}, IPM4`Chap05Functional`Private`len]; 
           IPM4`Chap05Functional`Private`rules = 
            Map[Thread[IPM4`Chap05Functional`Private`vars -> #]& , 
              IPM4`Chap05Functional`Private`tuples]; 
           IPM4`Chap05Functional`Private`table = Transpose[
              Join[
               Transpose[IPM4`Chap05Functional`Private`tuples], {
                ReplaceAll[
                IPM4`Chap05Functional`Private`expr, 
                 IPM4`Chap05Functional`Private`rules]}]]; 
           IPM4`Chap05Functional`Private`head = Append[
              Map[TraditionalForm, IPM4`Chap05Functional`Private`vars], 
              TraditionalForm[IPM4`Chap05Functional`Private`expr]]; Grid[
             Prepend[
              ReplaceAll[
              IPM4`Chap05Functional`Private`table, {
               True -> "T", False -> "F"}], 
              IPM4`Chap05Functional`Private`head], 
             Dividers -> {{
               1 -> {Thin, Black}, -1 -> {Thin, Black}, -2 -> {
                 Thin, LightGray}}, {
               1 -> {Thin, Black}, 
                2 -> {Thin, LightGray}, -1 -> {Thin, Black}}}, 
             BaseStyle -> {FontFamily -> "Times"}]], 
         TagSet[IPM4`Chap05Functional`TruthTable, 
          MessageName[IPM4`Chap05Functional`TruthTable, "usage"], 
          ""], $CellContext`eqns = {((-1)/
               2 + $CellContext`x)^2 + $CellContext`y^2 < 
           1, (1/2 + $CellContext`x)^2 + $CellContext`y^2 < 
           1}, $CellContext`c1 = {(-1)/2, 0}, $CellContext`c2 = {
          1/2, 0}}; {$CellContext`c1 = {(-1)/2, 0}; $CellContext`c2 = {
           1/2, 0}; $CellContext`eqns = 
          Apply[(# + $CellContext`x)^2 + (#2 + $CellContext`y)^2 < 
            1& , {$CellContext`c1, $CellContext`c2}, {1}]}}; 
     Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Figure",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"11.1 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Create a dynamic interface that displays some sample text using two different \
fonts from your system\[CloseCurlyQuote]s list of fonts. Set it up so that \
you can select which two fonts to compare by using a pulldown menu. The list \
of fonts on your system is given by the following:\
\>", "ExerciseItem",
 CellTags->{"i:29", "11.1 Exercises"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fonts", "=", 
   RowBox[{"FE`Evaluate", "[", 
    RowBox[{"FEPrivate`GetPopupList", "[", "\"\<MenuListFonts\>\"", "]"}], 
    "]"}]}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"11.1 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomSample", "[", 
  RowBox[{"fonts", ",", "3"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"11.1 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"Gurmukhi Sangam MN\"\>", 
    "\[Rule]", "\<\"Gurmukhi Sangam MN\"\>"}], ",", 
   RowBox[{"\<\"Impact\"\>", "\[Rule]", "\<\"Impact\"\>"}], ",", 
   RowBox[{"\<\"DTL Albertina TOT Italic\"\>", 
    "\[Rule]", "\<\"DTL Albertina TOT Italic\"\>"}]}], 
  "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"11.1 Exercises"]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "Take one of the two-dimensional random walk programs developed elsewhere in \
this book (for example, Sections ",
 StyleBox["8.1", "OsF"],
 " and ",
 StyleBox["13.1", "OsF"],
 ") and create an animation that displays successive steps of the random walk."
}], "ExerciseItem",
 CellTags->{"Ex.Random walk animate", "i:30", "11.1 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a plot of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"sin", "(", "\[Theta]", ")"}], TraditionalForm]]],
 " side-by-side with a circle and a dynamic point that moves along the curve \
and the circle as \[Theta] varies from ",
 StyleBox["0", "OsF"],
 " to ",
 StyleBox["2\[Pi]", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"i:31", "11.1 Exercises"}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`\[Theta]$$ = Rational[1, 4] Pi, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[Theta]$$], Rational[1, 4] Pi}, 0, 2 Pi}}, 
    Typeset`size$$ = {320., {58.34375, 63.65625}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`\[Theta]$746175$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`\[Theta]$$ = Rational[1, 4] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`\[Theta]$$, $CellContext`\[Theta]$746175$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Grid[{{
          Graphics[{
            Circle[], Blue, 
            PointSize[0.04], 
            Point[{
              Cos[$CellContext`\[Theta]$$], 
              Sin[$CellContext`\[Theta]$$]}]}, Axes -> True, ImageSize -> 
           120], 
          Plot[
           Sin[$CellContext`x], {$CellContext`x, 0, 2 Pi}, ImageSize -> 180, 
           Epilog -> {Blue, 
             Line[{{$CellContext`\[Theta]$$, 0}, {$CellContext`\[Theta]$$, 
                Sin[$CellContext`\[Theta]$$]}}], 
             PointSize[0.025], 
             Point[{$CellContext`\[Theta]$$, 
               Sin[$CellContext`\[Theta]$$]}]}]}}, Frame -> All], 
      "Specifications" :> {{{$CellContext`\[Theta]$$, Rational[1, 4] Pi}, 0, 
         2 Pi}}, "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{363., {101., 107.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Picture",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"11.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Modify the ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]], "InlineFormula"],
 " expression that animates the hypocycloid so that the plot range deals with \
the situation when the radius of the inner circle is larger than the radius \
of the outer circle."
}], "ExerciseItem",
 CellTags->{"Ex.Hypocycloid", "11.1 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "An ",
 StyleBox["epicycloid",
  FontSlant->"Italic"],
 " is a curve that can be generated by tracing out a fixed point on a circle \
that rolls around the outside of a second circle. The formula for an \
epicycloid is quite similar to that for the hypocycloid. The epicycloid is \
given parametrically by the following:"
}], "ExerciseItem",
 CellTags->{"Ex.Epicycloids", "i:32", "11.1 Exercises"}],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{
       RowBox[{"x", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"cos", "(", "\[Theta]", ")"}]}], "-", 
         RowBox[{"b", " ", 
          RowBox[{"cos", "(", 
           RowBox[{
            StyleBox[
             FractionBox[
              RowBox[{"a", "+", "b"}], "b"],
             FontSize->12], "\[Theta]"}], ")"}]}]}]}], ","}]},
     {
      RowBox[{"y", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", "b"}], ")"}], 
         RowBox[{"sin", "(", "\[Theta]", ")"}]}], "-", 
        RowBox[{"b", " ", 
         RowBox[{
          RowBox[{"sin", "(", 
           RowBox[{
            StyleBox[
             FractionBox[
              RowBox[{"a", "+", "b"}], "b"],
             FontSize->12], "\[Theta]"}], ")"}], "."}]}]}]}]}
    }], TraditionalForm]]]
}], "ExerciseText",
 CellTags->"11.1 Exercises"],

Cell["\<\
Create a dynamic interface to animate the epicycloid similar to that for the \
hypocycloid in this section.\
\>", "ExerciseText",
 CellTags->"11.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "In the ",
 StyleBox["1920", "OsF"],
 "s and ",
 StyleBox["1930", "OsF"],
 "s the artist Marcel Duchamp created what he termed ",
 StyleBox["rotoreliefs",
  FontSlant->"Italic"],
 ", spinning concentric circles (and variants thereof) giving a \
three-dimensional illusion of depth (",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Duchamp 1926\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.5]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Duchamp\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Marcel\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1926.\", \"OsF\"]\) \!\(\*\nStyleBox[\"An\
\[EAcute]mic\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\
\"Italic\"]\)\!\(\*\nStyleBox[\"Cin\[EAcute]ma\",\nFontSlant->\"Italic\"]\)\!\
\(\*\nStyleBox[\".\",\nFontSlant->\"Italic\"]\) Video available online at\n\
`1`", 
         Hyperlink[
         "http://www.ubu.com/film/duchamp_anemic.html", 
          "http://www.ubu.com/film/duchamp_anemic.html"]], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 "). Create you own rotoreliefs by starting with several concentric circles \
of different radii, then varying their centers around a path given by another \
circle, and animating."
}], "ExerciseItem",
 CellTags->{"i:33", "11.1 Exercises"}],

Cell["\<\
Create a dynamic table that displays the temperature of several cities around \
the world. Include a control (pulldown menu or setter bar) to switch the \
display between Celsius and Fahrenheit.\
\>", "ExerciseItem",
 CellTags->{"i:34", "11.1 Exercises"}],

Cell[TextData[{
 "Looking forward to ",
 "Chapter",
 " ",
 StyleBox["13", "OsF"],
 " where we develop a full application for computing and visualizing random \
walks, create a dynamic interface that displays random walks, adding controls \
to select the number of steps from a pulldown menu, the dimension from a \
setter bar, and a checkbox to turn on and off lattice walks. "
}], "ExerciseItem",
 CellTags->{"i:35", "11.1 Exercises"}],

Cell[CellGroupData[{

Cell["\<\
Create a visualization of two-dimensional vector addition. The interface \
should include either a 2D slider for each of two vectors in the plane or \
locators to change the position of each vector; the display should show the \
two vectors as well as their vector sum. Extend the solution to three \
dimensions. (The solution of this vector arithmetic interface is due to Harry \
Calkins of Wolfram Research.)\
\>", "ExerciseItem",
 CellTags->{"i:36", "11.1 Exercises"}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`pt1$$ = {1, 4}, $CellContext`pt2$$ = {3, 1},
     Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`pt1$$], {1, 4}, "red vector"}, {-5, -5}, {5, 5}}, {{
       Hold[$CellContext`pt2$$], {3, 1}, "blue vector"}, {-5, -5}, {5, 5}}}, 
    Typeset`size$$ = {180., {89., 94.}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`pt1$45676$$ = {0, 0}, $CellContext`pt2$45677$$ = {0, 
    0}}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`pt1$$ = {1, 4}, $CellContext`pt2$$ = {3, 
         1}}, "ControllerVariables" :> {
        Hold[$CellContext`pt1$$, $CellContext`pt1$45676$$, {0, 0}], 
        Hold[$CellContext`pt2$$, $CellContext`pt2$45677$$, {0, 0}]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Graphics[{Red, 
         Arrow[{{0, 0}, $CellContext`pt1$$}], Blue, 
         Arrow[{{0, 0}, $CellContext`pt2$$}], Green, 
         Arrow[{{0, 0}, $CellContext`pt1$$ + $CellContext`pt2$$}], Dashed, 
         Orange, 
         Line[{$CellContext`pt1$$, $CellContext`pt1$$ + $CellContext`pt2$$, \
$CellContext`pt2$$}]}, PlotRange -> 6, Axes -> True, GridLines -> Automatic, 
        ImageSize -> Small], 
      "Specifications" :> {{{$CellContext`pt1$$, {1, 4}, 
          "red vector"}, {-5, -5}, {5, 5}, Appearance -> 
         Tiny}, {{$CellContext`pt2$$, {3, 1}, "blue vector"}, {-5, -5}, {5, 
         5}, Appearance -> Tiny}}, "Options" :> {ControlPlacement -> Left}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{341., {115., 121.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Picture",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"11.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create a dynamic interface to display information about a word drawn from \
",
 Cell[BoxData[
  ButtonBox["WordData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/WordData"]], "InlineFormula"],
 ". The interface should include an input field for the word and use tabs to \
display either a definition, the Porter stem, or synonyms (try other word \
properties in ",
 Cell[BoxData[
  ButtonBox["WordData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/WordData"]], "InlineFormula"],
 ")."
}], "ExerciseItem",
 CellTags->{"i:37", "11.1 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "We will put this together in two parts: first create a function to display \
any amino acid using one of the various diagrams; then pour it into a ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]], "InlineFormula"],
 ". Note, this function is dependent upon ",
 Cell[BoxData[
  ButtonBox["ChemicalData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ChemicalData"]], "InlineFormula"],
 " to create the displays. You could modify it to use you own visualizations, \
such as the space-filling plots in ",
 "Section",
 " ",
 StyleBox["10.4", "OsF"],
 "."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AminoAcidPlot", "[", 
   RowBox[{"aa_String", ",", 
    RowBox[{"diagram_:", "\"\<ColorStructureDiagram\>\""}]}], "]"}], ":=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Framed", "[", 
     RowBox[{
      RowBox[{"ChemicalData", "[", 
       RowBox[{"aa", ",", "diagram"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "All"}]}], "]"}], ",", 
    RowBox[{"ChemicalData", "[", 
     RowBox[{"aa", ",", "\"\<Name\>\""}], "]"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"\"\<Menu\>\"", ",", "9"}], "]"}]}]}], "]"}]}]], "InputOnly",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"AminoAcidPlot", "[", "\"\<Glycine\>\"", "]"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"AminoAcidPlot", "[", 
    RowBox[{"aminoacid", ",", "diagram"}], "]"}], ",", "\[IndentingNewLine]", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "aminoacid", ",", "\"\<LAlanine\>\"", ",", "\"\<Amino acid\>\""}], 
      "}"}], ",", "aa"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"diagram", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<StructureDiagram\>\"", ",", "\"\<CHColorStructureDiagram\>\"", 
       ",", "\"\<CHStructureDiagram\>\"", ",", 
       "\"\<ColorStructureDiagram\>\"", ",", "\"\<MoleculePlot\>\"", ",", 
       "\"\<SpaceFillingMoleculePlot\>\""}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{"aa", "=", 
      RowBox[{"ChemicalData", "[", "\"\<AminoAcids\>\"", "]"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "This is a straightforward use of ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]], "InlineFormula"],
 ". The lengthy parameter list forces a pulldown menu to be used as the \
control."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ImageEffect", "[", 
    RowBox[{
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJw0vHd4I+eV5osCEyJzRM45Z6BQyDkQAEHkQBI5EMw5s3NWq9UKLcmSbHkU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        "], {{0, 172}, {200, 0}}, {0, 255},
        ColorFunction->RGBColor],
       BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
       Selectable->False],
      BaseStyle->"ImageGraphics",
      ImageSize->{66.66666666666593, Automatic},
      ImageSizeRaw->{200, 172},
      PlotRange->{{0, 200}, {0, 172}}], ",", "effect"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"effect", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Charcoal\>\"", ",", "\"\<Embossing\>\"", ",", 
       "\"\<OilPainting\>\"", ",", "\"\<Posterization\>\"", ",", 
       "\"\<Solarization\>\"", ",", "\"\<MotionBlur\>\"", ",", 
       "\"\<Noise\>\"", ",", "\"\<GaussianNoise\>\"", ",", 
       "\"\<SaltPepperNoise\>\"", ",", "\"\<PoissonNoise\>\""}], "}"}]}], 
    "}"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the code for the ",
 Cell[BoxData["TruthTable"]],
 " function from Exercise ",
 StyleBox["9", "OsF"],
 " in Section ",
 StyleBox["5.8", "OsF"],
 ":"
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "vars", "]"}]}], ",", "tuples", ",", "rules", 
      ",", "table", ",", "head"}], "}"}], ",", 
    RowBox[{
     RowBox[{"tuples", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"True", ",", "False"}], "}"}], ",", "len"}], "]"}]}], ";", 
     RowBox[{"rules", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Thread", "[", 
          RowBox[{"vars", "\[Rule]", "#1"}], "]"}], "&"}], ")"}], "/@", 
       "tuples"}]}], ";", 
     RowBox[{"table", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "tuples", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"expr", "/.", "\[VeryThinSpace]", "rules"}], "}"}]}], "]"}],
        "]"}]}], ";", 
     RowBox[{"head", "=", 
      RowBox[{"Append", "[", 
       RowBox[{"vars", ",", 
        RowBox[{"TraditionalForm", "[", "expr", "]"}]}], "]"}]}], ";", 
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"table", "/.", "\[VeryThinSpace]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"True", "\[Rule]", "\"\<T\>\""}], ",", 
            RowBox[{"False", "\[Rule]", "\"\<F\>\""}]}], "}"}]}], ",", 
         "head"}], "]"}], ",", 
       RowBox[{"Dividers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "2"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "LightGray"}], "}"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}], ",", 
            RowBox[{"2", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "LightGray"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Thin", ",", "Black"}], "}"}]}]}], "}"}]}], "}"}]}]}], 
      "]"}]}]}], "]"}]}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[TextData[{
 "This puts the truth table together with the Venn diagram using ",
 Cell[BoxData[
  ButtonBox["Row",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Row"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"TruthTable", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"A", ",", "B"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}]}], "]"}], ",", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"RegionPlot", "[", 
         RowBox[{
          RowBox[{"f", "@@", "eqns"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
          RowBox[{"Frame", "\[Rule]", "None"}], ",", 
          RowBox[{"PlotLabel", "\[Rule]", 
           RowBox[{"f", "[", 
            RowBox[{"A", ",", "B"}], "]"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"MaxRecursion", "\[Rule]", "5"}]}], "]"}], ",", 
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Circle", "[", "c1", "]"}], ",", 
           RowBox[{"Circle", "[", "c2", "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<A\>\"", ",", 
               RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", ".5"}], ",", ".8"}], "}"}]}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<B\>\"", ",", 
               RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{".5", ",", ".8"}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
        
        RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"f", ",", "Xor", ",", "\"\<Logical function\>\""}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{
      "And", ",", "Or", ",", "Xor", ",", "Implies", ",", "Nand", ",", "Nor"}],
       "}"}]}], "}"}], ",", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"c1", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], ",", "0"}], "}"}]}], ";", 
      RowBox[{"c2", "=", 
       RowBox[{"{", 
        RowBox[{
         FractionBox["1", "2"], ",", "0"}], "}"}]}], ";", 
      RowBox[{"eqns", "=", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"#1", "+", "x"}], ")"}], "2"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"#2", "+", "y"}], ")"}], "2"]}], "<", "1"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"c1", ",", "c2"}], "}"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}]}], "}"}]}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "You might want to add some additional options to each of the ",
 Cell[BoxData[
  ButtonBox["Style",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Style"]], "InlineFormula"],
 " expressions; for example, ",
 Cell[BoxData[
  ButtonBox["FontSize",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FontSize"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["FontWeight",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FontWeight"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fonts", "=", 
   RowBox[{"FE`Evaluate", "[", 
    RowBox[{"FEPrivate`GetPopupList", "[", "\"\<MenuListFonts\>\"", "]"}], 
    "]"}]}], ";"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Lorem ipsum dolor sit amet \[Dash] 0123456789\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "font1"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Lorem ipsum dolor sit amet \[Dash] 0123456789\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "font2"}]}], "]"}]}], "}"}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"font1", ",", "\"\<Times\>\"", ",", "\"\<Font 1\>\""}], "}"}], 
     ",", "fonts"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"font2", ",", "\"\<Helvetica\>\"", ",", "\"\<Font 2\>\""}], 
      "}"}], ",", "fonts"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
First load the package that contains the random walk code. You could use you \
own implementation as well.\
\>", "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"<<", "PwM`RandomWalks`"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[TextData[{
 "Create a ",
 StyleBox["1000", "OsF"],
 "-step, two-dimensional, lattice walk."
}], "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rw", "=", 
   RowBox[{"RandomWalk", "[", 
    RowBox[{"1000", ",", 
     RowBox[{"Dimension", "\[Rule]", "2"}], ",", 
     RowBox[{"LatticeWalk", "\[Rule]", "True"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[TextData[{
 "This is a basic start. ",
 Cell[BoxData[
  ButtonBox["Take",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Take"]], "InlineFormula"],
 " is used to display successive increments. Note the need for the ",
 StyleBox["1", "OsF"],
 " in the parameter list to insure that steps only take on integer values."
}], "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Animate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics", "[", 
    RowBox[{"Line", "[", 
     RowBox[{"Take", "[", 
      RowBox[{"rw", ",", "n"}], "]"}], "]"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"n", ",", "2", ",", 
     RowBox[{"Length", "[", "rw", "]"}], ",", "1"}], "}"}]}], "]"}]], "Input",\

 CellTags->"11.1 Solutions"],

Cell[TextData[{
 "The output above suffers from the fact that the display jumps around a lot \
as ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " tries to figure out a sensible plot range for ",
 StyleBox["each",
  FontSlant->"Italic"],
 " frame. Instead, we should fix the plot range for ",
 StyleBox["all",
  FontSlant->"Italic"],
 " frames to avoid this jumpiness. This is done in the definitions for ",
 Cell[BoxData["xran"]],
 " and ",
 Cell[BoxData["yran"]],
 " in the ",
 Cell[BoxData[
  ButtonBox["Initialization",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Initialization"]], "InlineFormula"],
 " below."
}], "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"Line", "[", 
      RowBox[{"Take", "[", 
       RowBox[{"rw", ",", "n"}], "]"}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"xran", ",", "yran"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"n", ",", "2", ",", 
     RowBox[{"Length", "[", "rw", "]"}], ",", "1"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rw", "=", 
       RowBox[{"RandomWalk", "[", 
        RowBox[{"1000", ",", 
         RowBox[{"Dimension", "\[Rule]", "2"}], ",", 
         RowBox[{"LatticeWalk", "\[Rule]", "True"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xran", ",", "yran"}], "}"}], "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Min", "[", "#1", "]"}], ",", 
            RowBox[{"Max", "[", "#1", "]"}]}], "}"}], "&"}], ",", 
         RowBox[{"Transpose", "[", "rw", "]"}]}], "]"}]}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Putting the two graphics pieces (",
 Cell[BoxData[
  RowBox[{"Graphics", "[", "\[Ellipsis]", "]"}]]],
 " and ",
 Cell[BoxData[
  RowBox[{"Plot", "[", "\[Ellipsis]", "]"}]]],
 ") in a grid gives you finer control over their placement and formatting."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Grid", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Circle", "[", "]"}], ",", "Blue", ",", 
            RowBox[{"PointSize", "[", ".04", "]"}], ",", 
            RowBox[{"Point", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], "]"}]}], "}"}],
           ",", 
          RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}], ",", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"Sin", "[", "x", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", 
            RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
          RowBox[{"Epilog", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Blue", ",", 
             RowBox[{"Line", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], 
              "]"}], ",", 
             RowBox[{"PointSize", "[", ".025", "]"}], ",", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], "]"}]}], 
            "}"}]}]}], "]"}]}], "}"}], "}"}], ",", 
     RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Just a few modifications to the code for the hypocycloid are needed: use \
the formula for the epicycloid; change the center of the rotating circle so \
that its radius is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"R", "+", "r"}], TraditionalForm]]],
 ", not ",
 Cell[BoxData[
  FormBox[
   RowBox[{"R", "-", "r"}], TraditionalForm]]],
 "; and modify the plot range."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EpicycloidPlot", "[", 
   RowBox[{"R_", ",", "r_", ",", "\[Theta]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"epicycloid", ",", "center"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"epicycloid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_"}], "}"}], ",", "t_"}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Cos", "[", "t", "]"}]}], "-", 
         RowBox[{"b", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}], 
          RowBox[{"Sin", "[", "t", "]"}]}], "+", 
         RowBox[{"b", " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"t", " ", 
            FractionBox[
             RowBox[{"a", "+", "b"}], "b"]}], "]"}]}]}]}], "}"}]}], ";", 
     RowBox[{
      RowBox[{"center", "[", 
       RowBox[{"th_", ",", "R1_", ",", "r2_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"R1", "+", "r2"}], ")"}], 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", "th", "]"}], ",", 
         RowBox[{"Sin", "[", "th", "]"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ParametricPlot", "[", 
          RowBox[{
           RowBox[{"epicycloid", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"R", ",", "r"}], "}"}], ",", "t"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "\[Theta]"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Thick", ",", 
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", "R"}], "]"}]}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Circle", "[", 
              RowBox[{
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", "r"}], 
              "]"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"center", "[", 
                RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], "]"}]}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Line", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"center", "[", 
                  RowBox[{"\[Theta]", ",", "R", ",", "r"}], "]"}], ",", 
                 RowBox[{"epicycloid", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], 
                  "]"}]}], "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"PointSize", "[", ".015", "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"epicycloid", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"R", ",", "r"}], "}"}], ",", "\[Theta]"}], "]"}], 
               "]"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "}"}],
        ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"1.5", 
         RowBox[{"(", 
          RowBox[{"R", "+", "r"}], ")"}]}]}], ",", 
       RowBox[{"GridLines", "\[Rule]", "Automatic"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellTags->"11.1 Solutions"],

Cell["First, create a static image.", "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"EpicycloidPlot", "[", 
  RowBox[{"3", ",", "1", ",", 
   RowBox[{"2", "\[Pi]"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell["And here is the dynamic version.", "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"EpicycloidPlot", "[", 
    RowBox[{"R", ",", "r", ",", "\[Theta]"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{"0", "+", "0.01"}], ",", 
     RowBox[{"2", 
      RowBox[{"Denominator", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"R", "-", "r"}], ")"}], "/", "r"}], "]"}], "\[Pi]"}]}], 
    "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"R", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8"}], "}"}], 
     ",", "Setter"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     "Setter"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Modify the radii and the centers to get different effects. Try using \
transparent disks instead of circles.\
\>", "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Circle", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"r", "/", "4"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Cos", "[", "t", "]"}], ",", 
            RowBox[{"Sin", "[", "t", "]"}]}], "}"}]}], ",", 
         RowBox[{"1.1", "-", "r"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", ".2", ",", "1", ",", ".05"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", "1"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", 
     RowBox[{"2", "\[Pi]"}], ",", ".1"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"TrackedSymbols", "\[RuleDelayed]", 
    RowBox[{"{", "t", "}"}]}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 Cell[BoxData[
  ButtonBox["Units",
   BaseStyle->"ExLink",
   ButtonData->"paclet:Units/tutorial/Units"]], "InlineFormula"],
 " package contains the function ",
 Cell[BoxData[
  ButtonBox["ConvertTemperature",
   BaseStyle->"ExLink",
   ButtonData->"paclet:Units/ref/ConvertTemperature"]], "InlineFormula"],
 " as well as ",
 Cell[BoxData[
  ButtonBox["Centigrade",
   BaseStyle->"ExLink",
   ButtonData->"paclet:Units/ref/Centigrade"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Fahrenheit",
   BaseStyle->"ExLink",
   ButtonData->"paclet:Units/ref/Fahrenheit"]], "InlineFormula"],
 " scales. We load it as part of the initialization. Since this might take \
some time, we also set ",
 Cell[BoxData[
  ButtonBox["SyncrhonousUpdating",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/SyncrhonousUpdating"]], "InlineFormula"],
 " to ",
 Cell[BoxData[
  ButtonBox["False",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/False"]], "InlineFormula"],
 " to make sure the evaluation does not time out before the default five \
second limit in ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]], "InlineFormula"],
 " is reached."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Grid", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<City\>\"", ",", 
            RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"StringForm", "[", 
             RowBox[{"\"\<Temp (\[Degree]`1`)\>\"", ",", "sym"}], "]"}], ",", 
            
            RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}]}], "]"}]}], 
         "}"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"#", ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"sym", "===", "\"\<C\>\""}], ",", "\[IndentingNewLine]", 
              RowBox[{"WeatherData", "[", 
               RowBox[{"#", ",", "\"\<Temperature\>\""}], "]"}], ",", 
              RowBox[{"Units`ConvertTemperature", "[", 
               RowBox[{
                RowBox[{"WeatherData", "[", 
                 RowBox[{"#", ",", "\"\<Temperature\>\""}], "]"}], ",", 
                "Units`Centigrade", ",", "Units`Fahrenheit"}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], "}"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Brasilia\>\"", ",", "\"\<Cairo\>\"", ",", "\"\<Chicago\>\"", 
           ",", "\"\<Melbourne\>\"", ",", "\"\<Paris\>\"", ",", 
           "\"\<Tokyo\>\""}], "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "All"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
     RowBox[{"Alignment", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Left", ",", "Right", ",", "Right"}], "}"}], ",", 
        "Automatic"}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}], "}"}]}]}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sym", ",", "\"\<C\>\"", ",", "\"\<Temp\>\""}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<F\>\"", ",", "\"\<C\>\""}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"{", 
     RowBox[{"Needs", "[", "\"\<Units`\>\"", "]"}], "}"}]}], ",", 
   RowBox[{"SynchronousUpdating", "\[Rule]", "False"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"FrameMargins", "\[Rule]", "0"}], ",", 
   RowBox[{"Deployed", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Using the programs developed in Section ",
 StyleBox["13.1", "OsF"],
 ", here is the code, including a pulldown menu for the steps parameter, a \
setter bar for",
 " ",
 "the dimension parameter, and a checkbox for the lattice parameter."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ShowWalk", "@", 
    RowBox[{"RandomWalk", "[", 
     RowBox[{"steps", ",", 
      RowBox[{"Dimension", "\[Rule]", "dim"}], ",", 
      RowBox[{"LatticeWalk", "\[Rule]", "latticeQ"}]}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"steps", ",", 
     RowBox[{"{", 
      RowBox[{
      "100", ",", "250", ",", "500", ",", "750", ",", "1000", ",", "10000"}], 
      "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dim", ",", "1", ",", "\"\<Dimension\>\""}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"latticeQ", ",", "True", ",", "\"\<Lattice walk\>\""}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"Needs", "[", "\"\<PWM`RandomWalks`\>\"", "]"}]}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the solution using ",
 Cell[BoxData[
  ButtonBox["Slider2D",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Slider2D"]], "InlineFormula"],
 ". Using ",
 Cell[BoxData[
  ButtonBox["Locator",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Locator"]], "InlineFormula"],
 " instead is left for the reader."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"Red", ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "pt1"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", "Blue", ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "pt2"}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", "Green", ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"pt1", "+", "pt2"}]}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", "Dashed", ",", "Orange", ",", 
       RowBox[{"Line", "[", 
        RowBox[{"{", 
         RowBox[{"pt1", ",", 
          RowBox[{"pt1", "+", "pt2"}], ",", "pt2"}], "}"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", " ", "6"}], ",", 
     RowBox[{"Axes", "\[Rule]", " ", "True"}], ",", 
     RowBox[{"GridLines", "\[Rule]", " ", "Automatic"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pt1", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "4"}], "}"}], ",", "\"\<Red vector\>\""}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5"}], ",", 
       RowBox[{"-", "5"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pt2", ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "1"}], "}"}], ",", "\"\<Blue vector\>\""}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5"}], ",", 
       RowBox[{"-", "5"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ControlPlacement", "\[Rule]", " ", "Left"}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First create a ",
 Cell[BoxData[
  ButtonBox["TabView",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/TabView"]], "InlineFormula"],
 " for one word."
}], "SolutionItem",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"word", "=", "\"\<lighting\>\""}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"TabView", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\"\<Definitions\>\"", "\[Rule]", 
       RowBox[{"TableForm", "@", 
        RowBox[{"WordData", "[", 
         RowBox[{"word", ",", "\"\<Definitions\>\""}], "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"\"\<PorterStem\>\"", "\[Rule]", 
       RowBox[{"WordData", "[", 
        RowBox[{"word", ",", "\"\<PorterStem\>\""}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"\"\<Synonyms\>\"", "\[Rule]", 
       RowBox[{"TableForm", "@", 
        RowBox[{"WordData", "[", 
         RowBox[{"word", ",", "\"\<Synonyms\>\""}], "]"}]}]}]}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellTags->"11.1 Solutions"],

Cell[TextData[{
 "Then make the word the parameter inside a ",
 Cell[BoxData[
  ButtonBox["Manipulate",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Manipulate"]], "InlineFormula"],
 ", using ",
 Cell[BoxData[
  ButtonBox["InputField",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/InputField"]], "InlineFormula"],
 " as the ",
 Cell[BoxData[
  ButtonBox["ControlType",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ControlType"]], "InlineFormula"],
 ". Use ",
 Cell[BoxData[
  ButtonBox["ToString",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ToString"]], "InlineFormula"],
 " to insure that the expression passed to ",
 Cell[BoxData[
  ButtonBox["WordData",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/WordData"]], "InlineFormula"],
 " is a string, regardless of what is typed in the input field."
}], "SolutionText",
 CellTags->"11.1 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TabView", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\"\<Definitions\>\"", "\[Rule]", 
       RowBox[{"WordData", "[", 
        RowBox[{
         RowBox[{"ToString", "@", "word"}], ",", "\"\<Definitions\>\""}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"\"\<PorterStem\>\"", "\[Rule]", 
       RowBox[{"WordData", "[", 
        RowBox[{
         RowBox[{"ToString", "@", "word"}], ",", "\"\<PorterStem\>\""}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"\"\<Synonyms\>\"", "\[Rule]", 
       RowBox[{"WordData", "[", 
        RowBox[{
         RowBox[{"ToString", "@", "word"}], ",", "\"\<Synonyms\>\""}], 
        "]"}]}]}], "\[IndentingNewLine]", "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"word", ",", "\"\<training\>\""}], "}"}], ",", 
   RowBox[{"ControlType", "\[Rule]", "InputField"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ContentSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"400", ",", "200"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"11.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["The structure of dynamic expressions", "ExerciseSubsection"],

Cell[TextData[{
 "Display a random word from the dictionary (",
 Cell[BoxData[
  ButtonBox["DictionaryLookup",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DictionaryLookup"]], "InlineFormula"],
 ") that changes every second."
}], "ExerciseItem",
 CellTags->{"11.2 Exercises", "i:55"}],

Cell["\<\
Create a dynamic interface consisting of a locator constrained to the unit \
circle.\
\>", "ExerciseItem",
 CellTags->"11.2 Exercises"],

Cell["\<\
Create a dynamic interface that controls one sphere rotating about another.\
\>", "ExerciseItem",
 CellTags->"11.2 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Use the ",
 Cell[BoxData[
  ButtonBox["UpdateInterval",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/UpdateInterval"]], "InlineFormula"],
 " option to ",
 Cell[BoxData[
  ButtonBox["Dynamic",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Dynamic"]], "InlineFormula"],
 "."
}], "SolutionItem",
 CellTags->"11.2 Solutions"],

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{
   RowBox[{"RandomChoice", "[", 
    RowBox[{"DictionaryLookup", "[", "]"}], "]"}], ",", 
   RowBox[{"UpdateInterval", "\[Rule]", "5"}]}], "]"}]], "Input",
 CellTags->"11.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Normalize",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Normalize"]], "InlineFormula"],
 " takes a vector as input and returns a unit vector."
}], "SolutionItem",
 CellTags->"11.2 Solutions"],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"pt", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Circle", "[", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Locator", "[", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"pt", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"pt", "=", 
            RowBox[{"Normalize", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}], 
       "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "]"}]], "Input",
 CellTags->"11.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples and applications", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell["\<\
Here are data on Nobel prizes in the fields of chemistry, medicine, and \
physics, available from the National Bureau of Economic Research.\
\>", "ExerciseItem",
 CellTags->{"11.3 Exercises", "i:71"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<http://www.nber.org/nobel/Jones_Weinberg_2011_PNAS.xlsx\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<XLSX\>\"", ",", "\"\<Data\>\"", ",", "1"}], "}"}]}], 
    "]"}]}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"11.3 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Take", "[", 
  RowBox[{"data", ",", "4"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"11.3 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"name\"\>", ",", "\<\"field\"\>", ",", "\<\"year_birth\"\>", 
     ",", "\<\"year_prize\"\>", ",", "\<\"year_research_mid\"\>", 
     ",", "\<\"year_death\"\>", ",", "\<\"TheoryOrTheoryAndEmpirical\"\>", 
     ",", "\<\"age_highdegree\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Van'T Hoff, Jacobus Henricus\"\>", ",", "\<\"Chemistry\"\>", 
     ",", "1852.`", ",", "1901.`", ",", "1885.`", ",", "1911.`", ",", "1.`", 
     ",", "22.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Fischer, Hermann Emil\"\>", ",", "\<\"Chemistry\"\>", ",", 
     "1852.`", ",", "1902.`", ",", "1895.`", ",", "1919.`", ",", "0.`", ",", 
     "22.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Arrhenius, Svante August\"\>", ",", "\<\"Chemistry\"\>", ",",
      "1859.`", ",", "1903.`", ",", "1884.`", ",", "1927.`", ",", "1.`", ",", 
     "25.`"}], "}"}]}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"11.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "Create a ",
 Cell[BoxData[
  ButtonBox["TabView",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/TabView"]], "InlineFormula"],
 " visualization showing the age of each prize recipient vs. the year of \
prize award. Include one tab for each of the three fields given in the data \
and also include a plot label that displays the mean age at award for each \
field."
}], "ExerciseText",
 CellTags->"11.3 Exercises"]
}, Closed]],

Cell[TextData[{
 "Using ",
 StyleBox["FunctionsWithAttribute", "ExerciseMR"],
 " developed in Section ",
 StyleBox["5.6", "OsF"],
 ", create a paneled interface that displays all built-in functions with a \
specified attribute. Include an input field control to allow the user to type \
in an attribute. Do likewise for ",
 Cell[BoxData["FunctionsWithOption"]],
 " also developed in Section ",
 StyleBox["5.6", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->"11.3 Exercises"],

Cell[TextData[{
 "Create a dynamic interface that displays twenty random points in the unit \
square whose locations are randomized each time you click your mouse on the \
graphic display of these points. Add a checkbox to toggle the display of the \
shortest path (",
 Cell[BoxData[
  ButtonBox["FindShortestTour",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/FindShortestTour"]], "InlineFormula"],
 ") through the points."
}], "ExerciseItem",
 CellTags->{"i:72", "11.3 Exercises"}],

Cell[TextData[{
 "Create a similar dynamic interface to that in the industrial production \
index problem in this section but comparing industrial production with \
unemployment rates with retail sales data over the last twenty years or some \
other suitable time period. Annual and historical retail sales data are \
available at the US Census Bureau (",
 ButtonBox["www.census.gov/retail",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.census.gov/retail/"], None},
  ButtonNote->"http://www.census.gov/retail/"],
 "); unemployment data are available at the US Bureau of Labor Statistics (",
 ButtonBox["www.bls.gov/cps/cpsatabs.htm",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.bls.gov/cps/cpsatabs.htm"], None},
  ButtonNote->"http://www.bls.gov/cps/cpsatabs.htm"],
 "); industrial production indices are available at the US Federal Reserve \
System (",
 ButtonBox["www.federalreserve.gov/releases/g17/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.federalreserve.gov/releases/g17/download.htm"], None},
  ButtonNote->"http://www.federalreserve.gov/releases/g17/download.htm"],
 ")."
}], "ExerciseItem",
 CellTags->"11.3 Exercises"],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["\<\
Import the data only; the first four columns give name, field, birth year, \
award year.\
\>", "SolutionItem",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<http://www.nber.org/nobel/Jones_Weinberg_2011_PNAS.xlsx\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<XLSX\>\"", ",", "\"\<Data\>\"", ",", "1", ",", "All", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "InputOnly",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"data", "[", 
  RowBox[{"[", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], "]"}], "]"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "[", 
   RowBox[{"[", 
    RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a__String", ",", "birth_Real", ",", "award_Real"}], "}"}], 
   "\[RuleDelayed]", 
   RowBox[{"{", 
    RowBox[{"a", ",", "birth", ",", "award", ",", 
     RowBox[{"award", "-", "birth"}]}], "}"}]}]}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nobelData", "=", 
   RowBox[{
    RowBox[{"data", "[", 
     RowBox[{"[", 
      RowBox[{"2", ";;", 
       RowBox[{"-", "1"}]}], "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a__String", ",", "birth_Real", ",", "award_Real"}], "}"}], 
     "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"a", ",", "birth", ",", "award", ",", 
       RowBox[{"award", "-", "birth"}]}], "}"}]}]}]}], ";"}]], "InputOnly",
 CellTags->"11.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"chem", "=", 
   RowBox[{"Cases", "[", 
    RowBox[{"nobelData", ",", 
     RowBox[{"{", 
      RowBox[{"name_String", ",", "\"\<Chemistry\>\"", ",", "rest__"}], 
      "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"med", "=", 
   RowBox[{"Cases", "[", 
    RowBox[{"nobelData", ",", 
     RowBox[{"{", 
      RowBox[{"name_String", ",", "\"\<Medicine\>\"", ",", "rest__"}], 
      "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"physics", "=", 
   RowBox[{"Cases", "[", 
    RowBox[{"nobelData", ",", 
     RowBox[{"{", 
      RowBox[{"name_String", ",", "\"\<Physics\>\"", ",", "rest__"}], "}"}]}],
     "]"}]}], ";"}]}], "InputOnly",
 CellTags->"11.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"timeChem", "=", 
   RowBox[{"chem", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "5"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeMed", "=", 
   RowBox[{"med", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "5"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timePhysics", "=", 
   RowBox[{"physics", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "5"}], "}"}]}], "]"}], "]"}]}], ";"}]}], "InputOnly",\

 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"DateListPlot", "[", 
  RowBox[{
   RowBox[{"Tooltip", "[", 
    RowBox[{"timeChem", "/.", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_"}], "}"}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Round", "@", "a"}], "}"}], ",", "b"}], "}"}]}]}], "]"}], 
   ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", 
    RowBox[{"StringForm", "[", 
     RowBox[{"\"\<Average age for chemistry Nobel award = `1`\>\"", ",", 
      RowBox[{"Mean", "[", 
       RowBox[{"timeChem", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"TabView", "[", "\[IndentingNewLine]", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "\[Rule]", 
      RowBox[{"DateListPlot", "[", 
       RowBox[{
        RowBox[{"Tooltip", "[", 
         RowBox[{"#2", "/.", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a_", ",", "b_"}], "}"}], "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Round", "@", "a"}], "}"}], ",", "b"}], "}"}]}]}], 
         "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", 
         RowBox[{"StringForm", "[", 
          RowBox[{
          "\"\<Average age for `1` Nobel award = `2`\>\"", ",", "#1", ",", 
           RowBox[{"Mean", "[", 
            RowBox[{"#2", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}]}]}], 
       "]"}]}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "\"\<Chemistry\>\"", ",", "\"\<Medicine\>\"", ",", "\"\<Physics\>\""}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"timeChem", ",", "timeMed", ",", "timePhysics"}], "}"}]}], 
     "}"}]}], "]"}], "]"}]], "Input",
 CellTags->"11.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First, here is the interface for listing all functions with a given \
attribute. We have used the ",
 Cell[BoxData[
  ButtonBox["Initialization",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Initialization"]], "InlineFormula"],
 " option to ",
 Cell[BoxData[
  ButtonBox["DynamicModule",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DynamicModule"]], "InlineFormula"],
 " to define the function ",
 Cell[BoxData["FunctionsWithAttributes"]],
 ". "
}], "SolutionItem",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"Panel", "[", 
  RowBox[{
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"att", "=", "Constant"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Column", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<Built-in attribute:\>\"", ",", "\"\<Menu\>\""}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{"Dynamic", "[", "att", "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Dynamic", "@", 
         RowBox[{"TextCell", "[", 
          RowBox[{"FunctionsWithAttribute", "[", "att", "]"}], "]"}]}]}], 
       "\[IndentingNewLine]", "}"}], "]"}], ",", 
     RowBox[{"Initialization", "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FunctionsWithAttribute", "[", "attrib_Symbol", "]"}], ":=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Names", "[", "\"\<System`*\>\"", "]"}], ",", 
          RowBox[{
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"Attributes", "[", "#", "]"}], ",", "attrib"}], "]"}], 
           "&"}]}], "]"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"360", ",", "Automatic"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[TextData[{
 "Here is the panel for ",
 Cell[BoxData["FunctionsWithOption"]],
 "."
}], "SolutionText",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"Panel", "[", 
  RowBox[{
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"option", "=", "StepMonitor"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Column", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<Built-in option:\>\"", ",", "\"\<Menu\>\""}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"InputField", "[", 
         RowBox[{"Dynamic", "[", "option", "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Dynamic", "[", 
         RowBox[{"FunctionsWithOption", "[", "option", "]"}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}], ",", 
     RowBox[{"Initialization", "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FunctionsWithOption", "[", "opt_Symbol", "]"}], ":=", 
        RowBox[{"Quiet", "[", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Names", "[", "\"\<System`*\>\"", "]"}], ",", 
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Options", "[", 
               RowBox[{"Symbol", "[", "#", "]"}], "]"}], ",", "opt", ",", 
              RowBox[{"{", "2", "}"}]}], "]"}], "&"}]}], "]"}], "]"}]}], 
       "}"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"360", ",", "Automatic"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"11.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a static version of the problem; we use ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " to display the points and the tour."
}], "SolutionItem",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"Point", "@", 
      RowBox[{"Range", "[", 
       RowBox[{"Length", "[", "pts", "]"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tour", "=", 
   RowBox[{"Last", "[", 
    RowBox[{"FindShortestTour", "[", "pts", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"pts", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Line", "[", "tour", "]"}], ",", "Red", ",", 
       RowBox[{"PointSize", "[", ".015", "]"}], ",", 
       RowBox[{"Point", "[", "tour", "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}]}], "Input",
 CellTags->"11.3 Solutions"],

Cell[TextData[{
 "Here is the dynamic interface using ",
 Cell[BoxData[
  ButtonBox["EventHandler",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EventHandler"]], "InlineFormula"],
 " to choose a new set of random points with each mouse click. "
}], "SolutionText",
 CellTags->"11.3 Solutions"],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pts", "=", 
        RowBox[{"RandomReal", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"20", ",", "2"}], "}"}]}], "]"}]}], ",", "tour"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tour", "=", 
       RowBox[{"Dynamic", "[", 
        RowBox[{"Last", "[", 
         RowBox[{"FindShortestTour", "[", "pts", "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"EventHandler", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Dynamic", "[", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"GraphicsComplex", "[", 
            RowBox[{"pts", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"Not", "[", "showtour", "]"}], ",", 
               RowBox[{"Point", "@", 
                RowBox[{"Range", "[", 
                 RowBox[{"Length", "[", "pts", "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Line", "[", "tour", "]"}], ",", "Red", ",", 
                 RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
                 RowBox[{"Point", "[", "tour", "]"}]}], "}"}]}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"Axes", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\"\<MouseClicked\>\"", "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{"pts", "=", 
            RowBox[{"RandomReal", "[", 
             RowBox[{"1", ",", 
              RowBox[{"{", 
               RowBox[{"20", ",", "2"}], "}"}]}], "]"}]}], ")"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"showtour", ",", "False", ",", "\"\<Show tour\>\""}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ContentSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"220", ",", "140"}], "}"}]}]}], "]"}]], "Input",
 CellTags->"11.3 Solutions"],

Cell[TextData[{
 "A suggested addition would be to add a control to change the number of \
points that are used. But be careful: traveling salesman type problems are \
notoriously hard; in fact they are known to be ",
 StyleBox["NP",
  FontSlant->"Italic"],
 "-hard, meaning they cannot be computed in polynomial time. See ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Lawler et al. (1985)\"\>", "TR",
    StripOnInput->False,
    FontColor->RGBColor[0.1, 0.1, 0.55]],
   Appearance->None,
   BaseStyle->{},
   ButtonFunction:>CreateDocument[
     Internal`PopupWindowNotebook[
      TextCell[
       Style[
        StringForm[
        "\!\(\*\nStyleBox[\"Lawler\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Eugene\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\
\!\(\*\nStyleBox[\"L\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Jan\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\" \", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Karel\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Lenstra\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\",\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"A\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"\[VeryThinSpace]\", \"SmallCaps\"]\)\!\(\*\
\nStyleBox[\"H\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"\[VeryThinSpace]\", \"SmallCaps\"]\)\!\(\*\
\nStyleBox[\"G\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"Rinnooy\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"Kan\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\",\", \"SmallCaps\"]\) and \!\(\*\nStyleBox[\"D\", \"SmallCaps\"]\)\
\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\"\[VeryThinSpace]\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"B\", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \
\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\"Shmoys\", \"SmallCaps\"]\)\!\(\*\n\
StyleBox[\".\", \"SmallCaps\"]\)\!\(\*\nStyleBox[\" \", \
\"SmallCaps\"]\)\!\(\*\nStyleBox[\"1985.\", \"OsF\"]\) \!\(\*\nStyleBox[\"The\
\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Traveling\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Salesman\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Problem\",\nFontSlant->\"Italic\"]\
\)\!\(\*\nStyleBox[\":\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"A\",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Guided\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Tour\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"of\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"Combinatorial\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \
\",\nFontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\"Optimization\",\n\
FontSlant->\"Italic\"]\). John Wiley & Sons."], {
        FontFamily -> "Times", FontSize -> 16}], "Text"], {
      WindowSize -> {500, 140}, WindowOpacity -> 0.9}]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"]], "Output"],
 " for more on traveling salesman problems."
}], "SolutionText",
 CellTags->"11.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["12", "ChapterN"],

Cell[CellGroupData[{

Cell[TextData[{
 "Optimizing ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " programs"
}], "ChapterTitle"],

Cell[CellGroupData[{

Cell["Efficient programs", "ExerciseSubsection",
 CounterAssignments->{{"Section", 1}, {"ExerciseItem", 0}},
 CellTags->"12.2 Exercises"],

Cell[TextData[{
 "Modify ",
 Cell[BoxData[
  StyleBox["AverageTiming", "ExLink"]]],
 " to return both the average time and the result of evaluating its argument, \
mirroring the behavior of ",
 Cell[BoxData[
  ButtonBox["Timing",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Timing"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["AbsoluteTiming",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/AbsoluteTiming"]]],
 "."
}], "ExerciseItem",
 CellTags->"12.2 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "The ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th triangular number is defined as the sum of the integers ",
 StyleBox["1", "OsF"],
 " through ",
 StyleBox["n",
  FontSlant->"Italic"],
 ". They are so named because they can be represented visually by arranging \
rows of dots in a triangular manner (Figure ",
 StyleBox[
 CounterBox["Chapter"], "OsF"],
 StyleBox[".", "OsF"],
 StyleBox[
 CounterBox["NumberedFigure", "Figure triangular numbers"], "OsF"],
 "). ",
 "Program several different approaches to computing triangular numbers and \
compare their efficiency."
}], "ExerciseItem",
 CellTags->{"i:28", "12.2 Exercises"}],

Cell[CellGroupData[{

Cell["\<\
Pictorial representation of the first five triangular numbers.\
\>", "NumberedFigure",
 CellTags->{"12.2 Exercises", "Figure triangular numbers"}],

Cell[BoxData[
 TemplateBox[{RotationBox[
    GraphicsBox[{
      PointSize[0.175], 
      PointBox[{{0., 0.}, {0., 0.}}]}, ImagePadding -> 6, ImageSize -> 40], 
    BoxRotation -> 1.5707963267948966`],"\"   \"",RotationBox[
    GraphicsBox[{
      PointSize[0.175], 
      PointBox[{{0., 0.}, {0., 0.}}], 
      PointBox[{{-0.75, 0.4330127018922193}, {-0.75, -0.4330127018922193}}]}, 
     ImagePadding -> 6, ImageSize -> 40], BoxRotation -> 1.5707963267948966`],
   "\"   \"",RotationBox[
    GraphicsBox[{
      PointSize[0.175], 
      PointBox[{{0., 0.}, {0., 0.}}], 
      PointBox[{{-0.75, 0.4330127018922193}, {-0.75, -0.4330127018922193}}], 
      PointBox[{{-1.5, 
       0.8660254037844386}, {-1.5, -0.8660254037844386}, {-1.5, 0.}}]}, 
     ImagePadding -> 6, ImageSize -> 40], BoxRotation -> 1.5707963267948966`],
   "\"   \"",RotationBox[
    GraphicsBox[{
      PointSize[0.175], 
      PointBox[{{0., 0.}, {0., 0.}}], 
      PointBox[{{-0.75, 0.4330127018922193}, {-0.75, -0.4330127018922193}}], 
      PointBox[{{-1.5, 
       0.8660254037844386}, {-1.5, -0.8660254037844386}, {-1.5, 0.}}], 
      PointBox[{{-2.25, 
       1.299038105676658}, {-2.25, -1.299038105676658}, {-2.25, \
-0.4330127018922194}, {-2.25, 0.4330127018922192}}]}, ImagePadding -> 6, 
     ImageSize -> 40], BoxRotation -> 1.5707963267948966`],"\"   \"",
   RotationBox[
    GraphicsBox[{
      PointSize[0.175], 
      PointBox[{{0., 0.}, {0., 0.}}], 
      PointBox[{{-0.75, 0.4330127018922193}, {-0.75, -0.4330127018922193}}], 
      PointBox[{{-1.5, 
       0.8660254037844386}, {-1.5, -0.8660254037844386}, {-1.5, 0.}}], 
      PointBox[{{-2.25, 
       1.299038105676658}, {-2.25, -1.299038105676658}, {-2.25, \
-0.4330127018922194}, {-2.25, 0.4330127018922192}}], 
      PointBox[{{-3., 
       1.7320508075688772`}, {-3., -1.7320508075688772`}, {-3., \
-0.8660254037844386}, {-3., 0.}, {-3., 0.8660254037844388}}]}, ImagePadding -> 
     6, ImageSize -> 40], BoxRotation -> 1.5707963267948966`]},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7, 
     "\[InvisibleSpace]", #8, "\[InvisibleSpace]", #9}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
         ",", #8, ",", #9}], "}"}], "]"}]& )]], "Figure",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowStringCharacters->False,
 CellTags->"12.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Several different implementations of the Hamming distance computation were \
given in Section ",
 StyleBox["5.8", "OsF"],
 "; some run much faster than others. For example, the version with bit \
operators runs about one-and-a-half orders of magnitude faster than the \
version using ",
 Cell[BoxData[
  ButtonBox["Count",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Count"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]], "InlineFormula"],
 ". Using some of the concepts from this section, determine what is causing \
these differences."
}], "ExerciseItem",
 CellTags->{"i:27", "12.2 Exercises"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance1", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"MapThread", "[", 
     RowBox[{"SameQ", ",", 
      RowBox[{"{", 
       RowBox[{"lis1", ",", "lis2"}], "}"}]}], "]"}], ",", "False"}], 
   "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance2", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"BitXor", "[", 
    RowBox[{"lis1", ",", "lis2"}], "]"}], "]"}]}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "ExerciseInput", \
"ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"HammingDistance1", "[", 
   RowBox[{"sig1", ",", "sig2"}], "]"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4594990000000223`", ",", "498955"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"12.2 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"HammingDistance2", "[", 
   RowBox[{"sig1", ",", "sig2"}], "]"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.2 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.009060000000005175`", ",", "498955"}], "}"}]], "ExerciseOutput", \
"ExerciseMR",
 CellTags->"12.2 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Collect the results of the ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " and pull out the parts needed \[Dash] the timings and the result."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 0}},
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"AverageTiming", ",", "HoldAll"}], "]"}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AverageTiming", "[", 
   RowBox[{"expr_", ",", "trials_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "lis", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lis", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"AbsoluteTiming", "[", "expr", "]"}], ",", 
        RowBox[{"{", "trials", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Mean", "[", 
        RowBox[{"lis", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
       RowBox[{"lis", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AverageTiming", "[", 
  RowBox[{
   RowBox[{"FactorInteger", "[", 
    RowBox[{
     RowBox[{"50", "!"}], "+", "1"}], "]"}], ",", "5"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.3112018`6.569214530252377", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"149", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3989", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"74195127103", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6854870037011", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100612041036938568804690996722352077", ",", "1"}], "}"}]}], 
    "}"}]}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The first implementation essentially performs a transpose of the two lists, \
wrapping ",
 Cell[BoxData[
  ButtonBox["SameQ",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/SameQ"]], "InlineFormula"],
 " around each corresponding pair of numbers. It then does a pattern match \
(",
 Cell[BoxData[
  ButtonBox["Count",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Count"]], "InlineFormula"],
 ") to determine which expressions of the form ",
 Cell[BoxData[
  RowBox[{"SameQ", "[", 
   RowBox[{
    SubscriptBox[
     StyleBox["expr", "ExerciseTI"], "1"], ",", 
    SubscriptBox[
     StyleBox["expr", "ExerciseTI"], "2"]}], "]"}]]],
 " return ",
 Cell[BoxData[
  ButtonBox["False",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/False"]], "InlineFormula"],
 ". "
}], "SolutionItem",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance1", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"MapThread", "[", 
     RowBox[{"SameQ", ",", 
      RowBox[{"{", 
       RowBox[{"lis1", ",", "lis2"}], "}"}]}], "]"}], ",", "False"}], 
   "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HammingDistance2", "[", 
   RowBox[{"lis1_", ",", "lis2_"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"BitXor", "[", 
    RowBox[{"lis1", ",", "lis2"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sig2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      SuperscriptBox["10", "6"], "}"}]}], "]"}]}], ";"}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[TextData[{
 "In this case, it is the threading that is expensive rather than the pattern \
matching with ",
 Cell[BoxData[
  ButtonBox["Count",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Count"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"MapThread", "[", 
     RowBox[{"SameQ", ",", 
      RowBox[{"{", 
       RowBox[{"sig1", ",", "sig2"}], "}"}]}], "]"}]}], ";"}], "//", 
  "Timing"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.46963700000000586`", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Count", "[", 
   RowBox[{"res", ",", "False"}], "]"}], "//", "Timing"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.04937600000002362`", ",", "499582"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell["\<\
The reason the threading is expensive can be seen by turning on the packing \
message as discussed in this section.\
\>", "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetSystemOptions", "[", 
  RowBox[{"\"\<PackedArrayOptions\>\"", "\[Rule]", 
   RowBox[{"\"\<UnpackMessage\>\"", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"\<\"PackedArrayOptions\"\>", "\[Rule]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\<\"ListableAutoPackLength\"\>", "\[Rule]", "250"}], ",", 
    RowBox[{"\<\"PackedArrayMathLinkRead\"\>", "\[Rule]", "True"}], ",", 
    RowBox[{"\<\"PackedArrayPatterns\"\>", "\[Rule]", "True"}], ",", 
    RowBox[{"\<\"PackedRange\"\>", "\[Rule]", "True"}], ",", 
    RowBox[{"\<\"UnpackMessage\"\>", "\[Rule]", "True"}]}], "}"}]}]], "Output",\

 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"MapThread", "[", 
    RowBox[{"SameQ", ",", 
     RowBox[{"{", 
      RowBox[{"sig1", ",", "sig2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Developer`FromPackedArray", "::", "punpack1"}], "MessageName"], 
  ":", " ", "\<\"Unpacking array with dimensions \[NoBreak]\\!\\({1000000}\\)\
\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/punpack1\\\", ButtonNote -> \
\\\"Developer`FromPackedArray::punpack1\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "The other factors contributing to the significant timing differences have \
to do with the fact that ",
 Cell[BoxData[
  ButtonBox["BitXor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/BitXor"]], "InlineFormula"],
 " has the ",
 Cell[BoxData[
  ButtonBox["Listable",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Listable"]], "InlineFormula"],
 " attribute. ",
 Cell[BoxData[
  ButtonBox["MapThread",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/MapThread"]], "InlineFormula"],
 " does not. And so, ",
 Cell[BoxData[
  ButtonBox["BitXor",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/BitXor"]], "InlineFormula"],
 " can take advantage of specialized (compiled) codes internally to speed up \
its computations. "
}], "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "BitXor", "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Flat", ",", "Listable", ",", "OneIdentity", ",", "Orderless", ",", 
   "Protected"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "MapThread", "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", "Protected", "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"temp", "=", 
    RowBox[{"BitXor", "[", 
     RowBox[{"sig1", ",", "sig2"}], "]"}]}], ";"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.003729999999990241`", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "And finally, compute the number of ",
 StyleBox["1", "OsF"],
 "s using ",
 Cell[BoxData[
  ButtonBox["Total",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Total"]], "InlineFormula"],
 " which is extremely fast at adding lists of numbers."
}], "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Total", "[", "temp", "]"}], ";"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.003227000000009639`", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell["Return the packed array messaging to its default value.", "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSystemOptions", "[", 
   RowBox[{"\"\<PackedArrayOptions\>\"", "\[Rule]", 
    RowBox[{"\"\<UnpackMessage\>\"", "\[Rule]", "False"}]}], "]"}], 
  ";"}]], "Input",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "A first attempt, using a brute force approach, is to total the list ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "\[Ellipsis]", ",", 
    StyleBox["n", "ExerciseTI"]}], "}"}]]],
 " for each ",
 StyleBox["n",
  FontSlant->"Italic"],
 "."
}], "SolutionItem",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularNumber", "[", "n_", "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"Range", "[", "n", "]"}], "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"TriangularNumber", "[", "i", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "100"}], "}"}]}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "3", ",", "6", ",", "10", ",", "15", ",", "21", ",", "28", ",", 
   "36", ",", "45", ",", "55", ",", "66", ",", "78", ",", "91", ",", "105", 
   ",", "120", ",", "136", ",", "153", ",", "171", ",", "190", ",", "210", 
   ",", "231", ",", "253", ",", "276", ",", "300", ",", "325", ",", "351", 
   ",", "378", ",", "406", ",", "435", ",", "465", ",", "496", ",", "528", 
   ",", "561", ",", "595", ",", "630", ",", "666", ",", "703", ",", "741", 
   ",", "780", ",", "820", ",", "861", ",", "903", ",", "946", ",", "990", 
   ",", "1035", ",", "1081", ",", "1128", ",", "1176", ",", "1225", ",", 
   "1275", ",", "1326", ",", "1378", ",", "1431", ",", "1485", ",", "1540", 
   ",", "1596", ",", "1653", ",", "1711", ",", "1770", ",", "1830", ",", 
   "1891", ",", "1953", ",", "2016", ",", "2080", ",", "2145", ",", "2211", 
   ",", "2278", ",", "2346", ",", "2415", ",", "2485", ",", "2556", ",", 
   "2628", ",", "2701", ",", "2775", ",", "2850", ",", "2926", ",", "3003", 
   ",", "3081", ",", "3160", ",", "3240", ",", "3321", ",", "3403", ",", 
   "3486", ",", "3570", ",", "3655", ",", "3741", ",", "3828", ",", "3916", 
   ",", "4005", ",", "4095", ",", "4186", ",", "4278", ",", "4371", ",", 
   "4465", ",", "4560", ",", "4656", ",", "4753", ",", "4851", ",", "4950", 
   ",", "5050"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"TriangularNumber", "[", 
   SuperscriptBox["10", "7"], "]"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.866882000000004`", ",", "50000005000000"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell["\<\
A second approach uses iteration. As might be expected, this is the slowest \
of the approaches here.\
\>", "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularNumber2", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"TriangularNumber2", "[", 
   SuperscriptBox["10", "7"], "]"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.346434999999985`", ",", "50000005000000"}], "}"}]], "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],

Cell[TextData[{
 "This is a situation where some mathematical knowledge is useful. The ",
 StyleBox["n",
  FontSlant->"Italic"],
 "th triangular numbers is just the (",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "+", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 ")th binomial coefficient ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", GridBox[{
      {
       RowBox[{"n", "+", 
        StyleBox["1", "OsF"]}]},
      {
       StyleBox["2", "OsF"]}
     }], ")"}], TraditionalForm]]],
 " ."
}], "SolutionText",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularNumber3", "[", "n_", "]"}], ":=", 
  RowBox[{"Binomial", "[", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", "2"}], "]"}]}]], "InputOnly",
 CellTags->"12.2 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"TriangularNumber3", "[", 
   SuperscriptBox["10", "7"], "]"}], "]"}]], "Input",
 CellTags->"12.2 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.00004500000002849447`", ",", "50000005000000"}], "}"}]], "Output",\

 CellTags->"12.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Parallel processing", "ExerciseSubsection",
 CellTags->"12.3 Exercises"],

Cell[TextData[{
 "In the eighteenth century, Leonhard Euler proved that all even perfect \
numbers must be of the form ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["2", 
     RowBox[{"p", "-", "1"}]], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "p"], "-", "1"}], ")"}]}], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["2", "p"], "-", "1"}], TraditionalForm]]],
 " prime. (No one has yet proved that any odd perfect numbers exist.) Use \
this fact to find all even perfect numbers for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"p", "<", 
    StyleBox[
     SuperscriptBox["10", "4"], "OsF"]}], TraditionalForm]]],
 "."
}], "ExerciseItem",
 CellTags->{"i:47", "12.3 Exercises"}],

Cell[CellGroupData[{

Cell[TextData[{
 "The following code can be used to create a plot of the Mandelbrot set. It \
uses ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " to compute the value for each point in the complex plane on a small grid. \
We have deliberately chosen a relatively coarse grid (",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["100", "OsF"]}], TraditionalForm]]],
 ") as this is an intensive and time-consuming computation. The last argument \
to ",
 Cell[BoxData[
  ButtonBox["NestWhileList",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/NestWhileList"]], "InlineFormula"],
 ", ",
 StyleBox["250", "OsF"],
 " here, sets a limit on the number of iterations that can be performed for \
each input."
}], "ExerciseItem",
 CellTags->{"i:48", "12.3 Exercises"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mandelbrot", "[", "c_", "]"}], ":=", 
  RowBox[{"Length", "[", 
   RowBox[{"NestWhileList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "^", "2"}], "+", "c"}], "&"}], ",", "0", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", "#", "]"}], "<", "2"}], "&"}], ",", "1", ",", 
     "250"}], "]"}], "]"}]}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.3 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", "100"}], "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Mandelbrot", "[", 
        RowBox[{"x", "+", 
         RowBox[{"I", " ", "y"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{"-", "0.5"}], ",", "0.5", ",", 
         FractionBox["1", "n"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "1.75"}], ",", 
         RowBox[{"-", "0.75"}], ",", 
         FractionBox["1", "n"]}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.3 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<GreenPinkTones\>\""}]}], 
  "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"12.3 Exercises"],

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJztnQlQVFfTsI0bGsRdUXHDhUhwR4yosTGoccG4iwsQg0TEiEvcjYoL0fgi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   "], {{0, 0}, {101, 101}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}},
  ImagePadding->2,
  ImageSize->{118.1698717948718, Automatic}]], "ExerciseOutput", "ExerciseMR",
 
 CellTags->"12.3 Exercises"]
}, Closed]],

Cell["\<\
Increase the resolution of the graphic by running the computation in \
parallel. \
\>", "ExerciseText",
 CellTags->"12.3 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "First we find those values of ",
 StyleBox["p",
  FontSlant->"Italic"],
 " for which ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["2", "p"], "-", "1"}], TraditionalForm]]],
 " is prime. This first step is quite compute-intensive; fortunately, it \
parallelizes well."
}], "SolutionItem",
 CellTags->"12.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LaunchKernels", "[", "]"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"KernelObject", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"primes", "=", 
  RowBox[{"Parallelize", "[", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"Range", "[", "10000", "]"}], ",", 
     RowBox[{
      RowBox[{"PrimeQ", "[", 
       RowBox[{
        SuperscriptBox["2", "#"], "-", "1"}], "]"}], "&"}]}], "]"}], 
   "]"}]}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "5", ",", "7", ",", "13", ",", "17", ",", "19", ",", 
   "31", ",", "61", ",", "89", ",", "107", ",", "127", ",", "521", ",", "607",
    ",", "1279", ",", "2203", ",", "2281", ",", "3217", ",", "4253", ",", 
   "4423", ",", "9689", ",", "9941"}], "}"}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],

Cell[TextData[{
 "So for each of the above values of the list ",
 Cell[BoxData["primes"]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["2", 
     RowBox[{"p", "-", "1"}]], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["2", "p"], "-", "1"}], ")"}]}], TraditionalForm]]],
 " will be perfect (thanks to Euler)."
}], "SolutionText",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"perfectLis", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"#", "-", "1"}]], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["2", "#"], "-", "1"}], ")"}]}], "&"}], ",", 
     "primes"}], "]"}]}], ";"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell["And finally, a check.", "SolutionText",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"perfectQ", "[", "j_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Total", "[", 
     RowBox[{"Divisors", "[", "j", "]"}], "]"}], "\[Equal]", 
    RowBox[{"2", " ", "j"}]}]}], ";"}]], "InputOnly",
 CellTags->"12.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"perfectQ", ",", "perfectLis"}], "]"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", "True", 
   ",", "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
   "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", "True", 
   ",", "True", ",", "True", ",", "True", ",", "True", ",", "True"}], 
  "}"}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell["These are very large numbers indeed.", "SolutionText",
 CellTags->"12.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["2", 
      RowBox[{"#", "-", "1"}]], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["2", "#"], "-", "1"}], ")"}]}], "&"}], "[", "9941", 
   "]"}], "//", "N"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData["5.98885496387336159215158337179296643572869874198415`15.\
954589770191005*^5984"], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Only two changes are required to run this in parallel \[Dash] distribute \
the definition for ",
 Cell[BoxData["Mandelbrot"]],
 " and change ",
 Cell[BoxData[
  ButtonBox["Table",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Table"]], "InlineFormula"],
 " to ",
 Cell[BoxData[
  ButtonBox["ParallelTable",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/ParallelTable"]], "InlineFormula"],
 ". Of course, to increase the resolution, the grid now has many more \
divisions in each direction (",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "=", 
    StyleBox["500", "OsF"]}], TraditionalForm]]],
 ")."
}], "SolutionItem",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mandelbrot", "[", "c_", "]"}], ":=", 
  RowBox[{"Length", "[", 
   RowBox[{"NestWhileList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "^", "2"}], "+", "c"}], "&"}], ",", "0", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", "#", "]"}], "<", "2"}], "&"}], ",", "1", ",", 
     "250"}], "]"}], "]"}]}]], "InputOnly",
 CellTags->"12.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LaunchKernels", "[", "]"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"KernelObject", "[", 
    RowBox[{"5", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"6", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"7", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"KernelObject", "[", 
    RowBox[{"8", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DistributeDefinitions", "[", "Mandelbrot", "]"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  TagBox["Mandelbrot",
   HoldForm], "}"}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", "500"}], "}"}], ",", 
     RowBox[{"ParallelTable", "[", 
      RowBox[{
       RowBox[{"Mandelbrot", "[", 
        RowBox[{"x", "+", 
         RowBox[{"\[ImaginaryI]", " ", "y"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{"-", "0.5"}], ",", "0.5", ",", 
         FractionBox["1", "n"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "1.75"}], ",", 
         RowBox[{"-", "0.75"}], ",", 
         FractionBox["1", "n"]}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"12.3 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<CMYKColors\>\""}]}], 
  "]"}]], "Input",
 CellTags->"12.3 Solutions"],

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJzs3XvUjXX++H/cMURJhDBORSFpDJEbrw5ohEzlfCMlCUU5lGMhp6GMU3Jq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   "], {{0, 0}, {501, 501}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}},
  ImageSize->{Automatic, 110}]], "Output",
 CellTags->"12.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Compiling", "ExerciseSubsection",
 CellTags->"12.4 Exercises"],

Cell[TextData[{
 "Create a compiled function that computes the distance to the origin of a \
two-dimensional point. Then compare it to some of the built-in functions such \
as ",
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["EuclideanDistance",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/EuclideanDistance"]], "InlineFormula"],
 " for a large set of points. If you have a C compiler installed on your \
computer, use the ",
 Cell[BoxData[
  ButtonBox["Compile",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Compile"]], "InlineFormula"],
 " option, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}], "ExerciseMR"]]],
 " and compare the results."
}], "ExerciseItem",
 CellTags->"12.4 Exercises"],

Cell["\<\
Modify the previous exercise under the assumption that complex numbers are \
given as input to your compiled function.\
\>", "ExerciseItem",
 CellTags->"12.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Many other iteration functions can be used for the Julia set computation. \
Experiment with some other functions such as ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", " ", 
    RowBox[{"sin", "(", "z", ")"}]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", " ", 
    SuperscriptBox["\[ExponentialE]", "z"]}], TraditionalForm]]],
 ", or Gaston Julia\[CloseCurlyQuote]s original function:"
}], "ExerciseItem",
 CellTags->{"i:63", "12.4 Exercises"}],

Cell[TextData[{
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["z", "4"], "+", 
    RowBox[{
     SuperscriptBox["z", "3"], "/", 
     RowBox[{"(", 
      RowBox[{"z", "-", "1"}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "2"], "/", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["z", "3"], "+", 
       RowBox[{"4", 
        SuperscriptBox["z", "2"]}], "+", "5"}], ")"}]}], "+", "c"}], 
   TraditionalForm]]],
 ". "
}], "ExerciseDisplayFormula",
 CellTags->{"i:63", "12.4 Exercises"}],

Cell[TextData[{
 "For these functions, you will have to adjust the test to determine if a \
point is unbounded upon iteration. Try ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"Im", "[", "#", "]"}], "]"}], ">", "50"}], "&"}], ")"}], 
   "ExerciseMR"]]],
 ". "
}], "ExerciseText",
 CellTags->{"i:63", "12.4 Exercises"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell["First, create a test point with which to work.", "SolutionItem",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pt", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3338808869801315`", ",", "0.13532075176903624`"}], 
  "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["\<\
The following does not quite work because the default pattern is expected to \
be a flat expression.\
\>", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"p", ",", "_Real"}], "}"}], "}"}], ",", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}], "]"}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}]}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Compile", "::", "part"}], "MessageName"], ":", 
  " ", "\<\"Part specification \[NoBreak]\\!\\(p \[LeftDoubleBracket] 1 \
\[RightDoubleBracket]\\)\[NoBreak] cannot be compiled since the argument is \
not a tensor of sufficient rank. Evaluation will use the uncompiled function. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Compile\\\", ButtonNote -> \
\\\"Compile::part\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", "p", "}"}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}]], 
    ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "Give a third argument to the pattern specification to deal with this: ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{"p", ",", "_Real", ",", "1"}], "}"}]]],
 "."
}], "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ArrayDepth", "[", "pt", "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["1"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"p", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}], "]"}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}]}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", "p", "}"}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}]], 
    ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal", "[", "pt", "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["0.3602612282080553`"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["Check it against the built-in function:", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Norm", "[", "pt", "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["0.3602612282080553`"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["Check that it threads properly over a list of points.", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.22374271213404873`", ",", "0.8102990031487669`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.873594837881962`", ",", "0.7216801465449691`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9518921114508279`", ",", "0.5474749168041022`"}], "}"}]}], 
  "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal", "[", "pts", "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.8406219576819208`", ",", "1.13313290248372`", ",", 
   "1.0981017149481072`"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Norm",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Norm"]], "InlineFormula"],
 " does not have the ",
 Cell[BoxData[
  ButtonBox["Listable",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Listable"]], "InlineFormula"],
 " attribute so it must be mapped over the list."
}], "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Norm", ",", "pts"}], "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.8406219576819208`", ",", "1.1331329024837198`", ",", 
   "1.0981017149481072`"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"distReal", "[", "pts", "]"}], "==", 
  RowBox[{"Map", "[", 
   RowBox[{"Norm", ",", "pts"}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["\<\
Now scale up the size of the list of points and check efficiency.\
\>", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["10", "6"], ",", "2"}], "}"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"distReal", "[", "pts", "]"}], ";"}], "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.109824`5.492242250992545", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{"Norm", ",", "pts"}], "]"}], ";"}], "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.113652`5.507122076155478", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"distReal", "[", "pts", "]"}], "\[Equal]", 
  RowBox[{"Map", "[", 
   RowBox[{"Norm", ",", "pts"}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["\<\
Compiling to C (assuming you have a C compiler installed), speeds things up \
even more.\
\>", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"p", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}], "]"}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}], ",", 
    RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}]}], "]"}]}]], "Input",\

 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", "p", "}"}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"First", "[", "p", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Last", "[", "p", "]"}], "2"]}]], 
    ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[TextData[{
 "You can squeeze a little more speed out of these functions by using ",
 Cell[BoxData[
  ButtonBox["Part",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Part"]], "InlineFormula"],
 " instead of ",
 Cell[BoxData[
  ButtonBox["First",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/First"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Last",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Last"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distReal2", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"p", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"p", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"p", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "2"]}], "]"}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}], ",", 
    RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}]}], "]"}]}]], "Input",\

 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", "p", "}"}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"p", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       "2"], "+", 
      SuperscriptBox[
       RowBox[{"p", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "2"]}]], ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"distReal2", "[", "pts", "]"}], ";"}], "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.059632`5.227024368905742", ",", "Null"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell["\<\
As an aside, the mean distance to the origin for random points in the unit \
square approaches the following, asymptotically.\
\>", "SolutionText",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   SqrtBox[
    RowBox[{
     SuperscriptBox["x", "2"], "+", 
     SuperscriptBox["y", "2"]}]], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["0.7651960148783958`"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mean", "@", 
  RowBox[{"distReal", "[", "pts", "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["0.7654520131982939`"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "We need to make just three slight modifications to the code from the \
previous exercise: remove the rank specification; specify ",
 Cell[BoxData[
  ButtonBox["Complex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Complex"]], "InlineFormula"],
 " as the type; extract the real and imaginary parts to do the norm \
computation."
}], "SolutionItem",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "distComplex", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"distComplex", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"z", ",", "_Complex"}], "}"}], "}"}], ",", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Re", "[", "z", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Im", "[", "z", "]"}], "2"]}], "]"}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}]}], "]"}]}]}], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", "z", "}"}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"Re", "[", "z", "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"Im", "[", "z", "]"}], "2"]}]], 
    ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"RandomComplex", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.3495191034516183`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.5067764722268293`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.15351592302197847`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"distComplex", "[", "pts", "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3495191034516183`", ",", "0.5067764722268293`", ",", 
   "0.15351592302197847`"}], "}"}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"distComplex", "[", "pts", "]"}], "==", 
  RowBox[{"Map", "[", 
   RowBox[{"Norm", ",", "pts"}], "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData["True"], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the computation for the iteration function ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", " ", 
    RowBox[{"sin", "(", "z", ")"}]}], TraditionalForm]]],
 " using ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "=", 
    RowBox[{"1", "+", 
     RowBox[{"0.4", "\[ImaginaryI]"}]}]}], TraditionalForm]]],
 "."
}], "SolutionItem",
 CellTags->"12.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cJulia2", "=", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"z", ",", "_Complex"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"c", ",", "_Complex"}], "}"}]}], "}"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"cnt", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FixedPoint", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"cnt", "++"}], ";", 
            RowBox[{"c", " ", 
             RowBox[{"Sin", "[", "#", "]"}]}]}], ")"}], "&"}], ",", "z", ",", 
         "100", ",", 
         RowBox[{"SameTest", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Im", "[", "#2", "]"}], "]"}], ">", "50"}], "&"}], 
           ")"}]}]}], "]"}], ";", "cnt"}]}], "]"}], ",", " ", 
    RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}], ",", 
    RowBox[{"RuntimeAttributes", "\[Rule]", 
     RowBox[{"{", "Listable", "}"}]}], ",", 
    RowBox[{"Parallelization", "\[Rule]", "True"}], ",", 
    RowBox[{"\"\<RuntimeOptions\>\"", "\[Rule]", "\"\<Speed\>\""}]}], 
   "]"}]}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 TagBox[
  RowBox[{"CompiledFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"z", ",", "c"}], "}"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"cnt", "=", "1"}], "}"}], ",", 
      RowBox[{
       RowBox[{"FixedPoint", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"cnt", "++"}], ";", 
            RowBox[{"c", " ", 
             RowBox[{"Sin", "[", "#1", "]"}]}]}], ")"}], "&"}], ",", "z", ",",
          "100", ",", 
         RowBox[{"SameTest", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Im", "[", "#2", "]"}], "]"}], ">", "50"}], "&"}], 
           ")"}]}]}], "]"}], ";", "cnt"}]}], "]"}], 
    ",", "\<\"-CompiledCode-\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"res", "=", "100"}], "}"}], ",", 
   RowBox[{"ArrayPlot", "[", 
    RowBox[{
     RowBox[{"ParallelTable", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"cJulia2", "[", 
         RowBox[{
          RowBox[{"x", "+", 
           RowBox[{"y", " ", "I"}]}], ",", 
          RowBox[{"1", "+", 
           RowBox[{"0.4", "I"}]}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Pi]"}], ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         FractionBox["1", "res"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Pi]"}], ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         FractionBox["1", "res"]}], "}"}]}], "]"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"ColorData", "[", "\"\<CMYKColors\>\"", "]"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellTags->"12.4 Solutions"],

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJzs3FuQloWd73sxGFudwoYW0A2TmITA6iWCaLBAgf+0eFjA2IuD43KjThKs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   "], {{0, 0}, {1885, 1885}}, {0, 1}],
  Frame->Automatic,
  FrameLabel->{None, None},
  FrameTicks->{{None, None}, {None, None}},
  ImagePadding->2,
  ImageSize->{Automatic, 110}]], "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJx10u9OglAYBnD686Hb6FLqEuwKdKuvbdbWvLkitUCI/hAoBGqJQRBlI1pG
mj29747TD/023HEKnPd5zmZlv7S3KknSwQY+SuWjrWq1XNtZx5ft2uFuZQ2L
FVwqrr/1TPgRptPpZDL5XlYUxRf5JB9Cnufvy7IseyOj0eiVvJA0TZ9JkiRx
HD8JURSFYfhIhsNhEAQP5J70+/0e6Xa7vu97nncnuK7rOE6HtNtt27Yty7ol
N+SaXJFLckE0TWu1WqqqKopyTs5Is9lsNBqnwolwTHgtyzL/Wq/X8We+kR+i
EDwWz9d1HS8yDIPfiw3wZnhjpmnyPm3SETAOhuLpMCnmxdQ9gQPhcAaDAYJC
XJwbAkSMnGdMEDKnjdg5f+4CpXA7qGmxNfQ475QrHo/H3DiqXzwJOBs4IfPT
MvvHL8Y6Gi8=
    "], {{0, 1}, {200, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSizeRaw->{200, 1},
  PlotRange->{{0, 200}, {0, 1}}]], "TitleFlourish"],

Cell["13", "ChapterN"],

Cell[CellGroupData[{

Cell["Applications and packages", "ChapterTitle"],

Cell[CellGroupData[{

Cell["Random walk application", "ExerciseSubsection"],

Cell[CellGroupData[{

Cell["\<\
Although all the lattice walks in this chapter were done on the square \
lattice, we could also implement the walks on lattices with different \
geometries. For example, the hexagonal lattice in two dimensions can be used \
as the grid on which our random walkers move.\
\>", "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:18"}],

Cell[BoxData[
 GraphicsBox[{
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       1}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 1}}, {{2.88675134594813, 1}, {
      2.3094010767585, 2}, {1.15470053837925, 2}, {0.577350269189626, 1}, {
      1.15470053837925, 0}, {2.3094010767585, 0}, {2.88675134594813, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       3}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 3}}, {{2.88675134594813, 3}, {
      2.3094010767585, 4}, {1.15470053837925, 4}, {0.577350269189626, 3}, {
      1.15470053837925, 2}, {2.3094010767585, 2}, {2.88675134594813, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       5}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 5}}, {{2.88675134594813, 5}, {
      2.3094010767585, 6}, {1.15470053837925, 6}, {0.577350269189626, 5}, {
      1.15470053837925, 4}, {2.3094010767585, 4}, {2.88675134594813, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       7}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 7}}, {{2.88675134594813, 7}, {
      2.3094010767585, 8}, {1.15470053837925, 8}, {0.577350269189626, 7}, {
      1.15470053837925, 6}, {2.3094010767585, 6}, {2.88675134594813, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       9}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 9}}, {{2.88675134594813, 9}, {
      2.3094010767585, 10}, {1.15470053837925, 10}, {0.577350269189626, 9}, {
      1.15470053837925, 8}, {2.3094010767585, 8}, {2.88675134594813, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 3^Rational[1, 2], 
       11}, {-3^Rational[-1, 2] + 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 3^Rational[1, 2], 11}}, {{2.88675134594813, 11}, {
      2.3094010767585, 12}, {1.15470053837925, 12}, {0.577350269189626, 11}, {
      1.15470053837925, 10}, {2.3094010767585, 10}, {2.88675134594813, 11}}]],
    LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       0}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 0}}, {{4.61880215351701, 0}, {
      4.04145188432738, 1}, {2.88675134594813, 1}, {2.3094010767585, 0}, {
      2.88675134594813, -1}, {4.04145188432738, -1}, {4.61880215351701, 0}}]],
    LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       2}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 2}}, {{4.61880215351701, 2}, {
      4.04145188432738, 3}, {2.88675134594813, 3}, {2.3094010767585, 2}, {
      2.88675134594813, 1}, {4.04145188432738, 1}, {4.61880215351701, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       4}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 4}}, {{4.61880215351701, 4}, {
      4.04145188432738, 5}, {2.88675134594813, 5}, {2.3094010767585, 4}, {
      2.88675134594813, 3}, {4.04145188432738, 3}, {4.61880215351701, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       6}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 6}}, {{4.61880215351701, 6}, {
      4.04145188432738, 7}, {2.88675134594813, 7}, {2.3094010767585, 6}, {
      2.88675134594813, 5}, {4.04145188432738, 5}, {4.61880215351701, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       8}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 8}}, {{4.61880215351701, 8}, {
      4.04145188432738, 9}, {2.88675134594813, 9}, {2.3094010767585, 8}, {
      2.88675134594813, 7}, {4.04145188432738, 7}, {4.61880215351701, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       2 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 2 3^Rational[1, 2], 
       10}, {-3^Rational[-1, 2] + 2 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 2 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 2 3^Rational[1, 2], 10}}, {{
      4.61880215351701, 10}, {4.04145188432738, 11}, {2.88675134594813, 11}, {
      2.3094010767585, 10}, {2.88675134594813, 9}, {4.04145188432738, 9}, {
      4.61880215351701, 10}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       1}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 1}}, {{6.35085296108588, 1}, {
      5.77350269189626, 2}, {4.61880215351701, 2}, {4.04145188432738, 1}, {
      4.61880215351701, 0}, {5.77350269189626, 0}, {6.35085296108588, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       3}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 3}}, {{6.35085296108588, 3}, {
      5.77350269189626, 4}, {4.61880215351701, 4}, {4.04145188432738, 3}, {
      4.61880215351701, 2}, {5.77350269189626, 2}, {6.35085296108588, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       5}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 5}}, {{6.35085296108588, 5}, {
      5.77350269189626, 6}, {4.61880215351701, 6}, {4.04145188432738, 5}, {
      4.61880215351701, 4}, {5.77350269189626, 4}, {6.35085296108588, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       7}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 7}}, {{6.35085296108588, 7}, {
      5.77350269189626, 8}, {4.61880215351701, 8}, {4.04145188432738, 7}, {
      4.61880215351701, 6}, {5.77350269189626, 6}, {6.35085296108588, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       9}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 9}}, {{6.35085296108588, 9}, {
      5.77350269189626, 10}, {4.61880215351701, 10}, {4.04145188432738, 9}, {
      4.61880215351701, 8}, {5.77350269189626, 8}, {6.35085296108588, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       3 3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 3 3^Rational[1, 2], 
       11}, {-3^Rational[-1, 2] + 3 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 3 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 3 3^Rational[1, 2], 11}}, {{
      6.35085296108588, 11}, {5.77350269189626, 12}, {4.61880215351701, 12}, {
      4.04145188432738, 11}, {4.61880215351701, 10}, {5.77350269189626, 10}, {
      6.35085296108588, 11}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       0}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 0}}, {{8.08290376865476, 0}, {
      7.50555349946513, 1}, {6.35085296108588, 1}, {5.77350269189626, 0}, {
      6.35085296108588, -1}, {7.50555349946513, -1}, {8.08290376865476, 0}}]],
    LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       2}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 2}}, {{8.08290376865476, 2}, {
      7.50555349946513, 3}, {6.35085296108588, 3}, {5.77350269189626, 2}, {
      6.35085296108588, 1}, {7.50555349946513, 1}, {8.08290376865476, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       4}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 4}}, {{8.08290376865476, 4}, {
      7.50555349946513, 5}, {6.35085296108588, 5}, {5.77350269189626, 4}, {
      6.35085296108588, 3}, {7.50555349946513, 3}, {8.08290376865476, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       6}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 6}}, {{8.08290376865476, 6}, {
      7.50555349946513, 7}, {6.35085296108588, 7}, {5.77350269189626, 6}, {
      6.35085296108588, 5}, {7.50555349946513, 5}, {8.08290376865476, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       8}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 8}}, {{8.08290376865476, 8}, {
      7.50555349946513, 9}, {6.35085296108588, 9}, {5.77350269189626, 8}, {
      6.35085296108588, 7}, {7.50555349946513, 7}, {8.08290376865476, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       4 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 4 3^Rational[1, 2], 
       10}, {-3^Rational[-1, 2] + 4 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 4 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 4 3^Rational[1, 2], 10}}, {{
      8.08290376865476, 10}, {7.50555349946513, 11}, {6.35085296108588, 11}, {
      5.77350269189626, 10}, {6.35085296108588, 9}, {7.50555349946513, 9}, {
      8.08290376865476, 10}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       1}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 1}}, {{9.81495457622364, 1}, {
      9.23760430703401, 2}, {8.08290376865476, 2}, {7.50555349946513, 1}, {
      8.08290376865476, 0}, {9.23760430703401, 0}, {9.81495457622364, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       3}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 3}}, {{9.81495457622364, 3}, {
      9.23760430703401, 4}, {8.08290376865476, 4}, {7.50555349946513, 3}, {
      8.08290376865476, 2}, {9.23760430703401, 2}, {9.81495457622364, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       5}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 5}}, {{9.81495457622364, 5}, {
      9.23760430703401, 6}, {8.08290376865476, 6}, {7.50555349946513, 5}, {
      8.08290376865476, 4}, {9.23760430703401, 4}, {9.81495457622364, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       7}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 7}}, {{9.81495457622364, 7}, {
      9.23760430703401, 8}, {8.08290376865476, 8}, {7.50555349946513, 7}, {
      8.08290376865476, 6}, {9.23760430703401, 6}, {9.81495457622364, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       9}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 9}}, {{9.81495457622364, 9}, {
      9.23760430703401, 10}, {8.08290376865476, 10}, {7.50555349946513, 9}, {
      8.08290376865476, 8}, {9.23760430703401, 8}, {9.81495457622364, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       5 3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 5 3^Rational[1, 2], 
       11}, {-3^Rational[-1, 2] + 5 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 5 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 5 3^Rational[1, 2], 11}}, {{
      9.81495457622364, 11}, {9.23760430703401, 12}, {8.08290376865476, 12}, {
      7.50555349946513, 11}, {8.08290376865476, 10}, {9.23760430703401, 10}, {
      9.81495457622364, 11}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       0}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 0}}, {{11.5470053837925, 0}, {
      10.9696551146029, 1}, {9.81495457622364, 1}, {9.23760430703401, 0}, {
      9.81495457622364, -1}, {10.9696551146029, -1}, {11.5470053837925, 0}}]],
    LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       2}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 2}}, {{11.5470053837925, 2}, {
      10.9696551146029, 3}, {9.81495457622364, 3}, {9.23760430703401, 2}, {
      9.81495457622364, 1}, {10.9696551146029, 1}, {11.5470053837925, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       4}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 4}}, {{11.5470053837925, 4}, {
      10.9696551146029, 5}, {9.81495457622364, 5}, {9.23760430703401, 4}, {
      9.81495457622364, 3}, {10.9696551146029, 3}, {11.5470053837925, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       6}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 6}}, {{11.5470053837925, 6}, {
      10.9696551146029, 7}, {9.81495457622364, 7}, {9.23760430703401, 6}, {
      9.81495457622364, 5}, {10.9696551146029, 5}, {11.5470053837925, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       8}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 8}}, {{11.5470053837925, 8}, {
      10.9696551146029, 9}, {9.81495457622364, 9}, {9.23760430703401, 8}, {
      9.81495457622364, 7}, {10.9696551146029, 7}, {11.5470053837925, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       6 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 6 3^Rational[1, 2], 
       10}, {-3^Rational[-1, 2] + 6 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 6 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 6 3^Rational[1, 2], 10}}, {{
      11.5470053837925, 10}, {10.9696551146029, 11}, {9.81495457622364, 11}, {
      9.23760430703401, 10}, {9.81495457622364, 9}, {10.9696551146029, 9}, {
      11.5470053837925, 10}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       1}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 1}}, {{13.2790561913614, 1}, {
      12.7017059221718, 2}, {11.5470053837925, 2}, {10.9696551146029, 1}, {
      11.5470053837925, 0}, {12.7017059221718, 0}, {13.2790561913614, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       3}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 3}}, {{13.2790561913614, 3}, {
      12.7017059221718, 4}, {11.5470053837925, 4}, {10.9696551146029, 3}, {
      11.5470053837925, 2}, {12.7017059221718, 2}, {13.2790561913614, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       5}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 5}}, {{13.2790561913614, 5}, {
      12.7017059221718, 6}, {11.5470053837925, 6}, {10.9696551146029, 5}, {
      11.5470053837925, 4}, {12.7017059221718, 4}, {13.2790561913614, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       7}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 7}}, {{13.2790561913614, 7}, {
      12.7017059221718, 8}, {11.5470053837925, 8}, {10.9696551146029, 7}, {
      11.5470053837925, 6}, {12.7017059221718, 6}, {13.2790561913614, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       9}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 9}}, {{13.2790561913614, 9}, {
      12.7017059221718, 10}, {11.5470053837925, 10}, {10.9696551146029, 9}, {
      11.5470053837925, 8}, {12.7017059221718, 8}, {13.2790561913614, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       7 3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 7 3^Rational[1, 2], 
       11}, {-3^Rational[-1, 2] + 7 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 7 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 7 3^Rational[1, 2], 11}}, {{
      13.2790561913614, 11}, {12.7017059221718, 12}, {11.5470053837925, 12}, {
      10.9696551146029, 11}, {11.5470053837925, 10}, {12.7017059221718, 10}, {
      13.2790561913614, 11}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       0}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 0}}, {{15.0111069989303, 0}, {
      14.4337567297406, 1}, {13.2790561913614, 1}, {12.7017059221718, 0}, {
      13.2790561913614, -1}, {14.4337567297406, -1}, {15.0111069989303, 0}}]],
    LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       2}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 2}}, {{15.0111069989303, 2}, {
      14.4337567297406, 3}, {13.2790561913614, 3}, {12.7017059221718, 2}, {
      13.2790561913614, 1}, {14.4337567297406, 1}, {15.0111069989303, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       4}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 4}}, {{15.0111069989303, 4}, {
      14.4337567297406, 5}, {13.2790561913614, 5}, {12.7017059221718, 4}, {
      13.2790561913614, 3}, {14.4337567297406, 3}, {15.0111069989303, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       6}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 6}}, {{15.0111069989303, 6}, {
      14.4337567297406, 7}, {13.2790561913614, 7}, {12.7017059221718, 6}, {
      13.2790561913614, 5}, {14.4337567297406, 5}, {15.0111069989303, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       8}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 8}}, {{15.0111069989303, 8}, {
      14.4337567297406, 9}, {13.2790561913614, 9}, {12.7017059221718, 8}, {
      13.2790561913614, 7}, {14.4337567297406, 7}, {15.0111069989303, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       8 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 8 3^Rational[1, 2], 
       10}, {-3^Rational[-1, 2] + 8 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 8 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 8 3^Rational[1, 2], 10}}, {{
      15.0111069989303, 10}, {14.4337567297406, 11}, {13.2790561913614, 11}, {
      12.7017059221718, 10}, {13.2790561913614, 9}, {14.4337567297406, 9}, {
      15.0111069989303, 10}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       1}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 1}}, {{16.7431578064991, 1}, {
      16.1658075373095, 2}, {15.0111069989303, 2}, {14.4337567297406, 1}, {
      15.0111069989303, 0}, {16.1658075373095, 0}, {16.7431578064991, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       3}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 3}}, {{16.7431578064991, 3}, {
      16.1658075373095, 4}, {15.0111069989303, 4}, {14.4337567297406, 3}, {
      15.0111069989303, 2}, {16.1658075373095, 2}, {16.7431578064991, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       5}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 5}}, {{16.7431578064991, 5}, {
      16.1658075373095, 6}, {15.0111069989303, 6}, {14.4337567297406, 5}, {
      15.0111069989303, 4}, {16.1658075373095, 4}, {16.7431578064991, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       7}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 7}}, {{16.7431578064991, 7}, {
      16.1658075373095, 8}, {15.0111069989303, 8}, {14.4337567297406, 7}, {
      15.0111069989303, 6}, {16.1658075373095, 6}, {16.7431578064991, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       9}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 9}}, {{16.7431578064991, 9}, {
      16.1658075373095, 10}, {15.0111069989303, 10}, {14.4337567297406, 9}, {
      15.0111069989303, 8}, {16.1658075373095, 8}, {16.7431578064991, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       9 3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 9 3^Rational[1, 2], 
       11}, {-3^Rational[-1, 2] + 9 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 9 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 9 3^Rational[1, 2], 11}}, {{
      16.7431578064991, 11}, {16.1658075373095, 12}, {15.0111069989303, 12}, {
      14.4337567297406, 11}, {15.0111069989303, 10}, {16.1658075373095, 10}, {
      16.7431578064991, 11}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 10 3^Rational[1, 2],
        0}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 0}}, {{18.475208614068, 0}, {
      17.8978583448784, 1}, {16.7431578064991, 1}, {16.1658075373095, 0}, {
      16.7431578064991, -1}, {17.8978583448784, -1}, {18.475208614068, 0}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 10 3^Rational[1, 2],
        2}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 2}}, {{18.475208614068, 2}, {
      17.8978583448784, 3}, {16.7431578064991, 3}, {16.1658075373095, 2}, {
      16.7431578064991, 1}, {17.8978583448784, 1}, {18.475208614068, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 10 3^Rational[1, 2],
        4}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 4}}, {{18.475208614068, 4}, {
      17.8978583448784, 5}, {16.7431578064991, 5}, {16.1658075373095, 4}, {
      16.7431578064991, 3}, {17.8978583448784, 3}, {18.475208614068, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 10 3^Rational[1, 2],
        6}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 6}}, {{18.475208614068, 6}, {
      17.8978583448784, 7}, {16.7431578064991, 7}, {16.1658075373095, 6}, {
      16.7431578064991, 5}, {17.8978583448784, 5}, {18.475208614068, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 10 3^Rational[1, 2],
        8}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 8}}, {{18.475208614068, 8}, {
      17.8978583448784, 9}, {16.7431578064991, 9}, {16.1658075373095, 8}, {
      16.7431578064991, 7}, {17.8978583448784, 7}, {18.475208614068, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 10 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 
       10 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 10 3^Rational[1, 2], 
       9}, {3^Rational[-1, 2] + 10 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 10 3^Rational[1, 2], 10}}, {{
      18.475208614068, 10}, {17.8978583448784, 11}, {16.7431578064991, 11}, {
      16.1658075373095, 10}, {16.7431578064991, 9}, {17.8978583448784, 9}, {
      18.475208614068, 10}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 2}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 2}, {(-2) 3^Rational[-1, 2] + 11 3^Rational[1, 2],
        1}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 0}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 1}}, {{
      20.2072594216369, 1}, {19.6299091524473, 2}, {18.475208614068, 2}, {
      17.8978583448784, 1}, {18.475208614068, 0}, {19.6299091524473, 0}, {
      20.2072594216369, 1}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 4}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 4}, {(-2) 3^Rational[-1, 2] + 11 3^Rational[1, 2],
        3}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 2}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 3}}, {{
      20.2072594216369, 3}, {19.6299091524473, 4}, {18.475208614068, 4}, {
      17.8978583448784, 3}, {18.475208614068, 2}, {19.6299091524473, 2}, {
      20.2072594216369, 3}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 6}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 6}, {(-2) 3^Rational[-1, 2] + 11 3^Rational[1, 2],
        5}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 4}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 5}}, {{
      20.2072594216369, 5}, {19.6299091524473, 6}, {18.475208614068, 6}, {
      17.8978583448784, 5}, {18.475208614068, 4}, {19.6299091524473, 4}, {
      20.2072594216369, 5}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 8}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 8}, {(-2) 3^Rational[-1, 2] + 11 3^Rational[1, 2],
        7}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 6}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 7}}, {{
      20.2072594216369, 7}, {19.6299091524473, 8}, {18.475208614068, 8}, {
      17.8978583448784, 7}, {18.475208614068, 6}, {19.6299091524473, 6}, {
      20.2072594216369, 7}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 9}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 10}, {(-2) 3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 
       8}, {3^Rational[-1, 2] + 11 3^Rational[1, 2], 8}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 9}}, {{
      20.2072594216369, 9}, {19.6299091524473, 10}, {18.475208614068, 10}, {
      17.8978583448784, 9}, {18.475208614068, 8}, {19.6299091524473, 8}, {
      20.2072594216369, 9}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 11}, {
      3^Rational[-1, 2] + 11 3^Rational[1, 2], 12}, {-3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 12}, {(-2) 3^Rational[-1, 2] + 
       11 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 11 3^Rational[1, 2], 
       10}, {3^Rational[-1, 2] + 11 3^Rational[1, 2], 10}, {
      2 3^Rational[-1, 2] + 11 3^Rational[1, 2], 11}}, {{
      20.2072594216369, 11}, {19.6299091524473, 12}, {18.475208614068, 12}, {
      17.8978583448784, 11}, {18.475208614068, 10}, {19.6299091524473, 10}, {
      20.2072594216369, 11}}]], 
   LineBox[
    NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 0}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 1}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 1}, {(-2) 3^Rational[-1, 2] + 12 3^Rational[1, 2],
        0}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], -1}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], -1}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 0}}, {{
      21.9393102292058, 0}, {21.3619599600162, 1}, {20.2072594216369, 1}, {
      19.6299091524473, 0}, {20.2072594216369, -1}, {21.3619599600162, -1}, {
      21.9393102292058, 0}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 2}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 3}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 3}, {(-2) 3^Rational[-1, 2] + 12 3^Rational[1, 2],
        2}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], 1}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 1}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 2}}, {{
      21.9393102292058, 2}, {21.3619599600162, 3}, {20.2072594216369, 3}, {
      19.6299091524473, 2}, {20.2072594216369, 1}, {21.3619599600162, 1}, {
      21.9393102292058, 2}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 4}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 5}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 5}, {(-2) 3^Rational[-1, 2] + 12 3^Rational[1, 2],
        4}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], 3}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 3}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 4}}, {{
      21.9393102292058, 4}, {21.3619599600162, 5}, {20.2072594216369, 5}, {
      19.6299091524473, 4}, {20.2072594216369, 3}, {21.3619599600162, 3}, {
      21.9393102292058, 4}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 6}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 7}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 7}, {(-2) 3^Rational[-1, 2] + 12 3^Rational[1, 2],
        6}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], 5}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 5}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 6}}, {{
      21.9393102292058, 6}, {21.3619599600162, 7}, {20.2072594216369, 7}, {
      19.6299091524473, 6}, {20.2072594216369, 5}, {21.3619599600162, 5}, {
      21.9393102292058, 6}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 8}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 9}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 9}, {(-2) 3^Rational[-1, 2] + 12 3^Rational[1, 2],
        8}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], 7}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 7}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 8}}, {{
      21.9393102292058, 8}, {21.3619599600162, 9}, {20.2072594216369, 9}, {
      19.6299091524473, 8}, {20.2072594216369, 7}, {21.3619599600162, 7}, {
      21.9393102292058, 8}}]], 
   LineBox[NCache[{{2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 10}, {
      3^Rational[-1, 2] + 12 3^Rational[1, 2], 11}, {-3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 11}, {(-2) 3^Rational[-1, 2] + 
       12 3^Rational[1, 2], 10}, {-3^Rational[-1, 2] + 12 3^Rational[1, 2], 
       9}, {3^Rational[-1, 2] + 12 3^Rational[1, 2], 9}, {
      2 3^Rational[-1, 2] + 12 3^Rational[1, 2], 10}}, {{
      21.9393102292058, 10}, {21.3619599600162, 11}, {20.2072594216369, 11}, {
      19.6299091524473, 10}, {20.2072594216369, 9}, {21.3619599600162, 9}, {
      21.9393102292058, 10}}]]},
  ImageSize->{162., Automatic}]], "Figure",
 CellTags->"13.1 Exercises"],

Cell[TextData[{
 "Create a two-dimensional random walk that can move in one of six directions \
each separated by ",
 StyleBox["60", "OsF"],
 " degrees."
}], "ExerciseText",
 CellTags->"13.1 Exercises"]
}, Closed]],

Cell[TextData[{
 "Generate random walks where the step length ",
 StyleBox["t",
  FontSlant->"Italic"],
 " occurs with a probability proportional to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["t", "2"]}], TraditionalForm]]],
 ". These walks are sometimes referred to as L\[EAcute]vy flights."
}], "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:19"}],

Cell[TextData[{
 "Create a version of ",
 Cell[BoxData[
  StyleBox["ShowWalk", "ExLink"]]],
 " that uses ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " directly. The first argument to ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " is the coordinate information as given by ",
 Cell[BoxData[
  StyleBox["RandomWalk", "ExLink"]]],
 "; the second argument should be graphics primitives (",
 Cell[BoxData[
  ButtonBox["Line",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Line"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Point",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Point"]], "InlineFormula"],
 ") that indicate how the coordinates should be displayed."
}], "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:20"}],

Cell[TextData[{
 "Create a visualization of random walks that takes advantage of the \
efficiency of ",
 Cell[BoxData[
  ButtonBox["Graph",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graph"]], "InlineFormula"],
 " to store and represent large amounts of graphical data. The first argument \
to ",
 Cell[BoxData[
  ButtonBox["Graph",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graph"]], "InlineFormula"],
 " can be a list of rules that represents the connectivity information. For \
example, ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"2", "\[DirectedEdge]", "3"}], "ExLink"]]],
 " indicates that the second vertex is connected to the third vertex with a \
directed edge. Use the option ",
 Cell[BoxData[
  ButtonBox["VertexCoordinates",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/VertexCoordinates"]], "InlineFormula"],
 " to pass the explicit coordinate information from ",
 Cell[BoxData[
  StyleBox["RandomWalk", "ExLink"]]],
 " to ",
 Cell[BoxData[
  ButtonBox["Graph",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graph"]], "InlineFormula"],
 ". Run some tests to determine the efficiency (in terms of running time and \
memory) of this approach as compared to the ",
 Cell[BoxData[
  StyleBox["ShowWalk", "ExLink"]]],
 " function that was developed in this chapter."
}], "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:21"}],

Cell["\<\
Create a function that generates random walks with random step length. \
Advanced: Do the same but allow for arbitrary distributions.\
\>", "ExerciseItem",
 CellTags->"13.1 Exercises"],

Cell[TextData[{
 "Create a random walk that is bounded by a region in the Cartesian plane, \
for example, a circle centered at the origin of radius ",
 StyleBox["2", "OsF"],
 "."
}], "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:22"}],

Cell["\<\
Create a one-dimensional random walk over the digits of \[Pi] \[Dash] if the \
digit is even, take a step to the right; if the digit is odd, take a step to \
the left.\
\>", "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:23"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the usage message for ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 ","
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 2}},
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GraphicsComplex"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"GraphicsComplex\\\", \\\"[\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{SubscriptBox[StyleBox[\\\"pt\\\", \\\"IT\\\
\"], StyleBox[\\\"1\\\", \\\"TR\\\"]], \\\",\\\", \
SubscriptBox[StyleBox[\\\"pt\\\", \\\"IT\\\"], StyleBox[\\\"2\\\", \
\\\"TR\\\"]], \\\",\\\", StyleBox[\\\"\[Ellipsis]\\\", \\\"TR\\\"]}], \\\"}\\\
\"}], \\\",\\\", StyleBox[\\\"data\\\", \\\"IT\\\"]}], \\\"]\\\"}]\) \
represents a graphics complex in which coordinates given as integers \
\!\(\*StyleBox[\\\"i\\\", \\\"IT\\\"]\) in graphics primitives in \
\!\(\*StyleBox[\\\"data\\\", \\\"IT\\\"]\) are taken to be \
\!\(\*SubscriptBox[StyleBox[\\\"pt\\\", \\\"IT\\\"], StyleBox[\\\"i\\\", \
\\\"IT\\\"]]\). \"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/GraphicsComplex"]}]], "Print", "PrintUsage",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "The first argument to ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " is a list of coordinate points, such as the output from ",
 Cell[BoxData["RandomWalk"]],
 ". The second argument is a set of graphics primitives indexed by the \
positions of the points in the list of coordinates.",
 " ",
 "Here are two examples, one in two dimensions and the other in three."
}], "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<PWM`RandomWalks`\>\"", "]"}]], "InputOnly",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"GraphicsComplex", "[", 
   RowBox[{
    RowBox[{"RandomWalk", "[", 
     RowBox[{"500", ",", 
      RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}], ",", 
    RowBox[{"Line", "[", 
     RowBox[{"Range", "[", "500", "]"}], "]"}]}], "]"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJwVWHk41N8XnmHs68wYY8861pDdoM8p2fqmKFFpEUqLJaXIUkKWiiRLRSlb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   "], LineBox[CompressedData["
1:eJwl1dOWGAgQBNBMbNu2bds2J+bEtm3btm3btu01sjdnH271F1R1ssCg6p0C
ggUL9l38vMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEIS
kZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpR
mCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGY
JjSlGYE0pwUtaUVr2tCWdrSnAx3pRBCd6UJXutGdHvSkF73pQ1/60Z8BDGQQ
gxnCUIYxnBGMZBSjGcNYxjGeCUxkEpOZwlSmMZ0ZzGQWs5nDXOYxnwUsZBGL
WcJSlrGcFaxkFatZw1rWsZ4NbGQTm9nCVraxnR3sZBe72cNe9rGfAxzkEIc5
wlGOcZwTnOQUpznDWc5xngtc5BKXucJVrnGdG9zkFre5w13ucZ8HPOQRj3nC
U57xnBe85BWvecNb3vGeD3zkE5/5wle+8Z1f+JXf+J0/+JO/+Jt/+Jcf/Cx/
AMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEISkZgkJCUZ
yUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpRmCIUpRjF
KUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGYJjSlGYE0
pwUtaUVr2tCWdrSnAx35Od5BdKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZ
xnBGMJJRjGYMYxnHeCYwkUlMZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nG
clawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZx
TnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzmCU95xnNe
8JJXvOYNb3nHez7wkU985gtf+Rbw/z//Dz189+A=
    "]]],
  ImageSize->100]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"GraphicsComplex", "[", 
   RowBox[{
    RowBox[{"RandomWalk", "[", 
     RowBox[{"500", ",", 
      RowBox[{"Dimension", "\[Rule]", "3"}], ",", 
      RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}], ",", 
    RowBox[{"Line", "[", 
     RowBox[{"Range", "[", "500", "]"}], "]"}]}], "]"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJwVV3c8lu8XtnfW+3rtvWd2xut9TqHQJKQ0qPSlEiIasiKioSiiKKM0JVIh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   "], Line3DBox[CompressedData["
1:eJwl1dOWGAgQBNBMbNu2bds2J+bEtm3btm3btu01sjdnH271F1R1ssCg6p0C
ggUL9l38vMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEIS
kZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpR
mCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGY
JjSlGYE0pwUtaUVr2tCWdrSnAx3pRBCd6UJXutGdHvSkF73pQ1/60Z8BDGQQ
gxnCUIYxnBGMZBSjGcNYxjGeCUxkEpOZwlSmMZ0ZzGQWs5nDXOYxnwUsZBGL
WcJSlrGcFaxkFatZw1rWsZ4NbGQTm9nCVraxnR3sZBe72cNe9rGfAxzkEIc5
wlGOcZwTnOQUpznDWc5xngtc5BKXucJVrnGdG9zkFre5w13ucZ8HPOQRj3nC
U57xnBe85BWvecNb3vGeD3zkE5/5wle+8Z1f+JXf+J0/+JO/+Jt/+Jcf/Cx/
AMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEISkZgkJCUZ
yUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpRmCIUpRjF
KUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGYJjSlGYE0
pwUtaUVr2tCWdrSnAx35Od5BdKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZ
xnBGMJJRjGYMYxnHeCYwkUlMZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nG
clawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZx
TnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzmCU95xnNe
8JJXvOYNb3nHez7wkU985gtf+Rbw/z//Dz189+A=
    "]]],
  ImageSize->100]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "We can quickly modify the code for ",
 Cell[BoxData["ShowWalk"]],
 " developed in the chapter to use ",
 Cell[BoxData[
  ButtonBox["GraphicsComplex",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/GraphicsComplex"]], "InlineFormula"],
 " instead."
}], "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowWalkGC", "[", "walk_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dim", "=", 
       RowBox[{"Dimensions", "[", "walk", "]"}]}], ",", 
      RowBox[{"ran", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"Length", "[", "walk", "]"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "dim", "]"}], "\[Equal]", "1"}], "||", 
       RowBox[{
        RowBox[{"dim", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
         "\[Equal]", "2"}]}], ",", 
      RowBox[{"Graphics", "[", 
       RowBox[{"GraphicsComplex", "[", 
        RowBox[{"walk", ",", 
         RowBox[{"Line", "[", "ran", "]"}]}], "]"}], "]"}], ",", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"GraphicsComplex", "[", 
        RowBox[{"walk", ",", 
         RowBox[{"Line", "[", "ran", "]"}]}], "]"}], "]"}]}], "]"}]}], 
   "]"}]}]], "InputOnly",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowWalkGC", "[", 
  RowBox[{"RandomWalk", "[", "2500", "]"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJydm+tSHDkShVX3W9/obozn57zSPMI+wO5L7pPMAgYbGwz4BjS1q5iTweGQ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   "], LineBox[CompressedData["
1:eJwl2kMQIMqSAMA/tm3btm3btm3btm3btm3b9pvNiT1k9KWvVd2FBA3bVWwb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    "]]],
  ImageSize->100]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowWalkGC", "[", 
  RowBox[{"RandomWalk", "[", 
   RowBox[{"2500", ",", 
    RowBox[{"Dimension", "\[Rule]", "3"}], ",", 
    RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJwUl3k0ld8Xxq97zTP3GjKLzHNKhm/nREklJJVISZImmZJESZJooCJDSkQq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   "], Line3DBox[CompressedData["
1:eJwU3UMUIEsSBdBp+7dt27Zt27Zt27Zt27Zt2/bcXtxT29pkITPiRfwGbSu0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    "]]],
  ImageSize->100]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "Here are some comparisons of running times for this approach and the ",
 Cell[BoxData["ShowWalk"]],
 " function developed in the chapter."
}], "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rw", "=", 
   RowBox[{"RandomWalk", "[", 
    RowBox[{"1000000", ",", 
     RowBox[{"Dimension", "\[Rule]", "3"}], ",", 
     RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}]], "InputOnly",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"gc", "=", 
    RowBox[{"ShowWalkGC", "[", "rw", "]"}]}], ";"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0038360000000352557`", ",", "Null"}], "}"}]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"sw", "=", 
    RowBox[{"ShowWalk", "[", "rw", "]"}]}], ";"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1288099999999872`", ",", "Null"}], "}"}]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Start by creating a list of rules that indicate the first point is connected \
to the second, the second point is connected to the third, and so on. If you \
have ten points, partition them as follows.\
\>", "SolutionItem",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", "2", ",", "1"}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell[TextData[{
 "The graph rules are created by applying ",
 Cell[BoxData[
  ButtonBox["DirectedEdge",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/DirectedEdge"]], "InlineFormula"],
 " at level ",
 StyleBox["1", "OsF"],
 "."
}], "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"DirectedEdge", ",", "%", ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "\[DirectedEdge]", "2"}], ",", 
   RowBox[{"2", "\[DirectedEdge]", "3"}], ",", 
   RowBox[{"3", "\[DirectedEdge]", "4"}], ",", 
   RowBox[{"4", "\[DirectedEdge]", "5"}], ",", 
   RowBox[{"5", "\[DirectedEdge]", "6"}], ",", 
   RowBox[{"6", "\[DirectedEdge]", "7"}], ",", 
   RowBox[{"7", "\[DirectedEdge]", "8"}], ",", 
   RowBox[{"8", "\[DirectedEdge]", "9"}], ",", 
   RowBox[{"9", "\[DirectedEdge]", "10"}]}], "}"}]], "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],

Cell["Here is a little function that puts these pieces together.", \
"SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "bonds", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bonds", "[", "n_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"DirectedEdge", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Range", "[", "n", "]"}], ",", "2", ",", "1"}], "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]}], "Input",
 CellTags->"13.1 Solutions"],

Cell[TextData[{
 "The bond information is the first argument to ",
 Cell[BoxData[
  ButtonBox["Graph",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graph"]], "InlineFormula"],
 "; the coordinates given by ",
 Cell[BoxData["RandomWalk"]],
 " are the value of the option ",
 Cell[BoxData[
  ButtonBox["VertexCoordinates",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/VertexCoordinates"]], "InlineFormula"],
 "."
}], "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"<<", "PWM`RandomWalks`"}]], "InputOnly",
 CellTags->"13.1 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"steps", "=", "1500"}], "}"}], ",", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"bonds", "[", "steps", "]"}], ",", 
     RowBox[{"VertexCoordinates", "\[Rule]", 
      RowBox[{"RandomWalk", "[", 
       RowBox[{"steps", ",", 
        RowBox[{"LatticeWalk", "\[Rule]", "True"}]}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[CompressedData["
1:eJwl2EMQGAgSAMDYtm3btm3btm3btm3bNndj29xcp+7RNVXzHyZs1L5Su4AB
AgS4EzRAgL8xEIEJglSAYAQnBCEJRWjCEJZwhCcCEYlEZKIQlWhEJwYxiUVs
4hCXeMQnAQlJRGKSkJRkJCcFKUlFatKQlnSkJwMZyURmspCVbGQnBznJRW7y
kJd85KcABSlEYYpQlGIUpwQlKUVpylCWcpSnAhWpRGWqUJVqVKcGNalFbepQ
l3rUpwENaURjmtCUZjSnBS1pRWva0JZ2tKcDHelEZ7rQlW50pwc96UVv+tCX
fvRnAAMZxGCGMJRhDGcEIxnFaMYwlnGMZwITmcRkpjCVaUxnBjOZxWzmMJd5
zGcBC1nEYpawlGUsZwUrWcVq1rCWdaxnAxvZxGa2sJVtbGcHO9nFbvawl33s
5wAHOcRhjnCUYxznBCc5xWnOcJZznOcCF7nEZa5wlWtc5wY3ucVt7nCXf/iX
e9znAQ95xGOe8JRnPOcFL3nFa97wlne85wMf+cRnvvCVb3znBz/5xW/+4w9/
iz8ggQhMEIISjOCEICShCE0YwhKO8EQgIpGITBSiEo3oxCAmsYhNHOISj/gk
ICGJSEwSkpKM5KQgJalITRrSko70ZCAjmchMFrKSjezkICe5yE0e8pKP/BSg
IIUoTBGKUozilKAkpShNGcpSjvJUoCKVqEwVqlKN6tSgJrWoTR3qUo/6NKAh
jWhME5rSjOa0oCWtaE0b2vK3ebenAx3pRGe60JVudKcHPelFb/rQl370ZwAD
GcRghjCUYQxnBCMZxWjGMJZxjGcCE5nEZKYwlWlMZwYzmcVs5jCXecxnAQtZ
xGKWsJRlLGcFK1nFatawlnWsZwMb2cRmtrCVbWxnBzvZxW72sJd97OcABznE
YY5wlGMc5wQnOcVpznCWc5znAhe5xGWucJVrXOcGN7nFbe5wl3/4l3vc5wEP
ecRjnvCUZzznBS95xWve8JZ3vOcDH/nEZ77wlW985wc/+cVv/uMPfwd/QAIR
mCAEJRjBCUFIQhGaMIQlHOGJQEQiEZkoRCUa0YlBTGIRmzjEJR7xSUBCEpGY
JCQlGclJQUpSkZo0pCUd6clARjKRmSxkJRvZyUFOcpGbPOQlH/kpQEEKUZgi
FKUYxSlBSUpRmjKUpRzlqUBFKlGZKlSlGtWpQU1qUZs61KUe9WlAQxrRmCY0
pRnNaUFLWtGaNrSlHe3pQEc60ZkudKUb3elBT3rRmz70pR/9GcBABjGYIQxl
GMMZwUhGMZoxjGUc45nARCYxmSlMZRrTmcFMZjGbOcxlHvNZwEIWsZglLGUZ
y1nBSlaxmjWsZR3r2cBGNrGZLWxlG9vZwU52sZs97GUf+znAQQ5xmCMc5RjH
OcFJTnGaM5zlHOe5wEUucZkrXOUa17nBTW5xmzvc5R/+5R73ecBDHvGYJzzl
Gc95wUte8Zo3vOUd7/nARz7xmS985Rvf+cFPfvGb//jD36U/IIEITBCCEozg
hCAkoQhNGMISjvBEICKRiEwUohKN6MQgJrGITRziEo/4JCAhiUhMEpKSjOSk
ICWpSE0a0pKO9GQgI5nITBayko3s5CAnuchNHvKSj/wUoCCFKEwRilKM4pSg
JKUoTRnKUo7yVKAilahMFapSjerUoCa1qE0d6lKP+jSgIY1oTBOa0ozmtKAl
rWhNG9rSjvZ0oCOd6EwXutKN7vSgJ73oTR/60o/+DGAggxjMEIYyjOGMYCSj
GM0YxjKO8UxgIpOYzBSmMo3pzGAms5jNHOYyj/ksYCGLWMwSlrKM5axgJatY
zRrWso71bGAjm9jMFrayje3sYCe72M0e9rKP/RzgIIc4zBGOcozjnOAkpzjN
Gc5yjvNc4CKXuMwVrnKN69zgJre4zR3u8g//co/7POAhj3jME57yjOe84CWv
eM0b3vKO93zgI5/4zBe+8o3v/OAnv/jNf/zh78EfkEAEJghBCUZwQhCSUIQm
DGEJR3giEJFIRCYKUYlGdGIQk1jEJg5xiUd8EpCQRCQmCUlJRnJSkJJUpCYN
aUlHejKQkUxkJgtZyUZ2cpCTXOQmD3nJR34KUJBCFKYIRSlGcUpQklKUpgxl
KUd5KlCRSlSmClWpRnVqUJNa1KYOdalHfRrQkEY0pglNaUZzWtCSVrSmDW1p
R3s60JFOdKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZxnBGMJJRjGYMYxnH
eCYwkUlMZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nGclawklWsZg1rWcd6
NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZxTnCSU5zmDGc5x3ku
cJFLXOYKV7nGdW5wk1vc5g53+Yd/ucd9HvCQRzzmCU95xnNe8JJXvOYNb3nH
ez7wkU985gtf+cZ3fvCTX/zmP/7w99kXkEAEJghBCUZwQhCSUIQmDGEJR3gi
EJFIRCYKUYlGdGIQk1jEJg5xiUd8EpCQRCQmCUlJRnJSkJJUpCYNaUlHejKQ
kUxkJgtZyUZ2cpCTXOQmD3nJR34KUJBCFKYIRSlGcUpQklKUpgxlKUd5KlCR
SlSmClWpRnVqUJNa1KYOdalHfRrQkEY0pglNaUZzWtCSVrSmDW1pR3s60JFO
dKYLXelGd3rQk170pg996Ud/BjCQQQxmCEMZxnBGMJJRjGYMYxnHeCYwkUlM
ZgpTmcZ0ZjCTWcxmDnOZx3wWsJBFLGYJS1nGclawklWsZg1rWcd6NrCRTWxm
C1vZxnZ2sJNd7GYPe9nHfg5wkEMc5ghHOcZxTnCSU5zmDGc5x3kucJFLXOYK
V7nGdW5wk1vcDvr/f/v/AA5e7Xo=
      "], {CompressedData["
1:eJw12tMWIAiSBcCybdu2bdu2bdu2bdu2bXaXbbNrZnajH+LcT8hzMzNho/aV
2gUKECDA7aABAvwvAwb4//yfwAQhKMEITghCEorQhCEs4QhPBCISichEISrR
iE4MYhKL2MQhLvGITwISkojEJCEpyUhOClKSitSkIS3pSE8GMpKJzGQhK9nI
Tg5ykovc5CEv+chPAQpSiMIUoSjFKE4JSlKK0pShLOUoTwUqUonKVKEq1ahO
DWpSi9rUoS71qE8DGtKIxjShKc1oTgta0orWtKEt7WhPBzrSic50oSvd6E4P
etKL3vShL/3ozwAGMojBDGEowxjOCEYyitGMYSzjGM8EJjKJyUxhKtOYzgxm
MovZzGEu85jPAhayiMUsYSnLWM4KVrKK1axhLetYzwY2sonNbGEr29jODnay
i93sYS/72M8BDnKIwxzhKMc4zglOcorTnOEs5zjPBS5yictc4SrXuM4NbnKL
29zhLn/xN/e4zwMe8ojHPOEpz3jOC17yite84S3veM8HPvKJz3zhK9/4zg9+
8ovf/MMf/m/o/1dAAhGYIAQlGMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFM
YhGbOMQlHvFJQEISkZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5y
kZs85CUf+SlAQQpRmCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpR
mzrUpR71aUBDGtGYJjSlGc1pQUta0Zo2tKUd7elARzrRmS50pRvd6UFPetGb
PvSlH/0ZwEAGMZghDGUYwxnBSEYxmjGMZRzjmcBEJjGZKUxlGtOZwUxmMZs5
zGUe81nAQhaxmCUsZRnLWcFKVrGaNaxlHevZwEY2sZktbGUb29nBTnaxmz3s
ZR/7OcBBDnGYIxzlGMc5wUlOcZoznOUc57nARS5xmStc5RrXucFNbnGbO9zl
L/7mHvd5wEMe8ZgnPOUZz3nBS17xmje85R3v+cBHPvGZL3zlG9/5wU9+8Zt/
+MO/hT8ggQhMEIISjOCEICShCE0YwhKO8EQgIpGITBSiEo3oxCAmsYhNHOIS
j/gkICGJSEwSkpKM5KQgJalITRrSko70ZCAjmchMFrKSjezkICe5yE0e8pKP
/BSgIIUoTBGKUozilKAkpShNGcpSjvJUoCKVqEwVqlKN6tSgJrWoTR3qUo/6
NKAhjWhME5rSjOa0oCWtaE0b2tKO9nSgI53oTBe60o3u9KAnvehNH/rSj/4M
YCCDGMwQhjKM4YxgJKMYzRjGMo7xTGAik5jMFKYyjenMYCazmM0c5jKP+Sxg
IYtYzBKWsozlrGAlq1jNGtayjvVsYCOb2MwWtrKN7exgJ7vYzR72so/9HOAg
hzjMEY5yjOOc4CSnOM0ZznKO81zgIpe4zBWuco3r3OAmt7jNHe7yF39zj/s8
4CGPeMwTnvKM57zgJa94zRve8o73fOAjn/jMF77yje/84Ce/+M0//OHfRX9A
AhGYIAQlGMEJQUhCEZowhCUc4YlARCIRmShEJRrRiUFMYhGbOMQlHvFJQEIS
kZgkJCUZyUlBSlKRmjSkJR3pyUBGMpGZLGQlG9nJQU5ykZs85CUf+SlAQQpR
mCIUpRjFKUFJSlGaMpSlHOWpQEUqUZkqVKUa1alBTWpRmzrUpR71aUBDGtGY
JjSlGc1pQUta0Zo2tKUd7elARzrRmS50pRvd6UFPetGbPvSlH/0ZwEAGMZgh
DGUYwxnBSEYxmjGMZRzjmcBEJjGZKUxlGtOZwUxmMZs5zGUe81nAQhaxmCUs
ZRnLWcFKVrGaNaxlHevZwEY2sZktbGUb29nBTnaxmz3sZR/7OcBBDnGYIxzl
GMc5wUlOcZoznOUc57nARS5xmStc5RrXucFNbnGbO9zlL/7mHvd5wEMe8Zgn
POUZz3nBS17xmje85R3v+cBHPvGZL3zlG9/5wU9+8Zt/+MO/B/6ABCIwQQhK
MIITgpCEIjRhCEs4whOBiEQiMlGISjSiE4OYxCI2cYhLPOKTgIQkIjFJSEoy
kpOClKQiNWlISzrSk4GMZCIzWchKNrKTg5zkIjd5yEs+8lOAghSiMEUoSjGK
U4KSlKI0ZShLOcpTgYpUojJVqEo1qlODmtSiNnWoSz3q04CGNKIxTWhKM5rT
gpa0ojVtaEs72tOBjnSiM13oSje604Oe9KI3fehLP/ozgIEMYjBDGMowhjOC
kYxiNGMYyzjGM4GJTGIyU5jKNKYzg5nMYjZzmMs85rOAhSxiMUtYyjKWs4KV
rGI1a1jLOtazgY1sYjNb2Mo2trODnexiN3vYyz72c4CDHOIwRzjKMY5zgpOc
4jRnOMs5znOBi1ziMle4yjWuc4Ob3OI2d7jLX/zNPe7zgIc84jFPeMoznvOC
l7ziNW94yzve84GPfOIzX/jKN77zg5/84jf/8Id/H/sCEojABCEowQhOCEIS
itCEISzhCE8EIhKJyEQhKtGITgxiEovYxCEu8YhPAhKSiMQkISnJSE4KUpKK
1KQhLelITwYykonMZCEr2chODnKSi9zkIS/5yE8BClKIwhShKMUoTglKUorS
lKEs5ShPBSpSicpUoSrVqE4NalKL2tShLvWoTwMa0ojGNKEpzWhOC1rSita0
oS3taE8HOtKJznShK93oTg960ove9KEv/ejPAAYyiMEMYSjDGM4IRjKK0Yxh
LOMYzwQmMonJTGEq05jODGYyi9nMYS7zmM8CFrKIxSxhKctYzgpWsorVrGEt
61jPBjayic1sYSvb2M4OdrKL3exhL/vYzwEOcojDHOEoxzjOCU5yitOc4Szn
OM8FLnKJy1zhKte4zg1ucovb3Pmv/wAmw9eO
       "], Null}, {
      ImagePadding -> 11, ImageSize -> 132, 
       VertexCoordinates -> CompressedData["
1:eJy9m0mO40YQRQkDBrjkggsttJCFQsMwjEYNUs1VYvcRfAQDXvsKfTPpID6E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        "]}]], Typeset`boxes, Typeset`boxes$s2d = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$3"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$4"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        DiskBox[{-1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$6"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$7"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$8"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$9"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$10"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$11"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$12"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$13"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$14"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$15"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$16"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$17"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$18"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$19"], 
       TagBox[
        DiskBox[{2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$20"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$21"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$22"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$23"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$24"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$25"], 
       TagBox[
        DiskBox[{-1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$26"], 
       TagBox[
        DiskBox[{-1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$27"], 
       TagBox[
        DiskBox[{-1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$28"], 
       TagBox[
        DiskBox[{-1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$29"], 
       TagBox[
        DiskBox[{-1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$30"], 
       TagBox[
        DiskBox[{-1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$31"], 
       TagBox[
        DiskBox[{-1., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$32"], 
       TagBox[
        DiskBox[{-1., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$33"], 
       TagBox[
        DiskBox[{-1., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$34"], 
       TagBox[
        DiskBox[{-2., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$35"], 
       TagBox[
        DiskBox[{-2., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$36"], 
       TagBox[
        DiskBox[{-2., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$37"], 
       TagBox[
        DiskBox[{-1., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$38"], 
       TagBox[
        DiskBox[{-1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$39"], 
       TagBox[
        DiskBox[{-1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$40"], 
       TagBox[
        DiskBox[{-1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$41"], 
       TagBox[
        DiskBox[{-1., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$42"], 
       TagBox[
        DiskBox[{0., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$43"], 
       TagBox[
        DiskBox[{1., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$44"], 
       TagBox[
        DiskBox[{0., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$45"], 
       TagBox[
        DiskBox[{0., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$46"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$47"], 
       TagBox[
        DiskBox[{0., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$48"], 
       TagBox[
        DiskBox[{-1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$49"], 
       TagBox[
        DiskBox[{0., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$50"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$51"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$52"], 
       TagBox[
        DiskBox[{1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$53"], 
       TagBox[
        DiskBox[{2., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$54"], 
       TagBox[
        DiskBox[{1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$55"], 
       TagBox[
        DiskBox[{2., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$56"], 
       TagBox[
        DiskBox[{1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$57"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$58"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$59"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$60"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$61"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$62"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$63"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$64"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$65"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$66"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$67"], 
       TagBox[
        DiskBox[{2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$68"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$69"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$70"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$71"], 
       TagBox[
        DiskBox[{2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$72"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$73"], 
       TagBox[
        DiskBox[{2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$74"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$75"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$76"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$77"], 
       TagBox[
        DiskBox[{-1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$78"], 
       TagBox[
        DiskBox[{0., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$79"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$80"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$81"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$82"], 
       TagBox[
        DiskBox[{1., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$83"], 
       TagBox[
        DiskBox[{2., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$84"], 
       TagBox[
        DiskBox[{2., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$85"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$86"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$87"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$88"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$89"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$90"], 
       TagBox[
        DiskBox[{0., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$91"], 
       TagBox[
        DiskBox[{1., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$92"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$93"], 
       TagBox[
        DiskBox[{0., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$94"], 
       TagBox[
        DiskBox[{1., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$95"], 
       TagBox[
        DiskBox[{2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$96"], 
       TagBox[
        DiskBox[{3., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$97"], 
       TagBox[
        DiskBox[{2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$98"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$99"], 
       TagBox[
        DiskBox[{2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$100"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$101"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$102"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$103"], 
       TagBox[
        DiskBox[{0., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$104"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$105"], 
       TagBox[
        DiskBox[{0., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$106"], 
       TagBox[
        DiskBox[{-1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$107"], 
       TagBox[
        DiskBox[{0., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$108"], 
       TagBox[
        DiskBox[{-1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$109"], 
       TagBox[
        DiskBox[{0., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$110"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$111"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$112"], 
       TagBox[
        DiskBox[{1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$113"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$114"], 
       TagBox[
        DiskBox[{2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$115"], 
       TagBox[
        DiskBox[{2., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$116"], 
       TagBox[
        DiskBox[{3., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$117"], 
       TagBox[
        DiskBox[{4., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$118"], 
       TagBox[
        DiskBox[{4., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$119"], 
       TagBox[
        DiskBox[{4., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$120"], 
       TagBox[
        DiskBox[{5., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$121"], 
       TagBox[
        DiskBox[{5., 9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$122"], 
       TagBox[
        DiskBox[{5., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$123"], 
       TagBox[
        DiskBox[{6., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$124"], 
       TagBox[
        DiskBox[{5., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$125"], 
       TagBox[
        DiskBox[{6., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$126"], 
       TagBox[
        DiskBox[{5., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$127"], 
       TagBox[
        DiskBox[{5., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$128"], 
       TagBox[
        DiskBox[{6., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$129"], 
       TagBox[
        DiskBox[{6., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$130"], 
       TagBox[
        DiskBox[{5., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$131"], 
       TagBox[
        DiskBox[{4., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$132"], 
       TagBox[
        DiskBox[{4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$133"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$134"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$135"], 
       TagBox[
        DiskBox[{4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$136"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$137"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$138"], 
       TagBox[
        DiskBox[{1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$139"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$140"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$141"], 
       TagBox[
        DiskBox[{0., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$142"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$143"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$144"], 
       TagBox[
        DiskBox[{0., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$145"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$146"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$147"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$148"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$149"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$150"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$151"], 
       TagBox[
        DiskBox[{2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$152"], 
       TagBox[
        DiskBox[{2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$153"], 
       TagBox[
        DiskBox[{1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$154"], 
       TagBox[
        DiskBox[{1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$155"], 
       TagBox[
        DiskBox[{0., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$156"], 
       TagBox[
        DiskBox[{-1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$157"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$158"], 
       TagBox[
        DiskBox[{-2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$159"], 
       TagBox[
        DiskBox[{-1., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$160"], 
       TagBox[
        DiskBox[{-1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$161"], 
       TagBox[
        DiskBox[{-1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$162"], 
       TagBox[
        DiskBox[{-1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$163"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$164"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$165"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$166"], 
       TagBox[
        DiskBox[{-2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$167"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$168"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$169"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$170"], 
       TagBox[
        DiskBox[{-1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$171"], 
       TagBox[
        DiskBox[{0., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$172"], 
       TagBox[
        DiskBox[{1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$173"], 
       TagBox[
        DiskBox[{1., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$174"], 
       TagBox[
        DiskBox[{1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$175"], 
       TagBox[
        DiskBox[{1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$176"], 
       TagBox[
        DiskBox[{2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$177"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$178"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$179"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$180"], 
       TagBox[
        DiskBox[{4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$181"], 
       TagBox[
        DiskBox[{5., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$182"], 
       TagBox[
        DiskBox[{6., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$183"], 
       TagBox[
        DiskBox[{5., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$184"], 
       TagBox[
        DiskBox[{4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$185"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$186"], 
       TagBox[
        DiskBox[{2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$187"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$188"], 
       TagBox[
        DiskBox[{2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$189"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$190"], 
       TagBox[
        DiskBox[{2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$191"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$192"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$193"], 
       TagBox[
        DiskBox[{4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$194"], 
       TagBox[
        DiskBox[{5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$195"], 
       TagBox[
        DiskBox[{5., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$196"], 
       TagBox[
        DiskBox[{5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$197"], 
       TagBox[
        DiskBox[{5., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$198"], 
       TagBox[
        DiskBox[{5., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$199"], 
       TagBox[
        DiskBox[{5., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$200"], 
       TagBox[
        DiskBox[{6., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$201"], 
       TagBox[
        DiskBox[{6., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$202"], 
       TagBox[
        DiskBox[{5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$203"], 
       TagBox[
        DiskBox[{6., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$204"], 
       TagBox[
        DiskBox[{5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$205"], 
       TagBox[
        DiskBox[{6., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$206"], 
       TagBox[
        DiskBox[{5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$207"], 
       TagBox[
        DiskBox[{6., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$208"], 
       TagBox[
        DiskBox[{6., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$209"], 
       TagBox[
        DiskBox[{6., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$210"], 
       TagBox[
        DiskBox[{5., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$211"], 
       TagBox[
        DiskBox[{5., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$212"], 
       TagBox[
        DiskBox[{5., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$213"], 
       TagBox[
        DiskBox[{6., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$214"], 
       TagBox[
        DiskBox[{7., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$215"], 
       TagBox[
        DiskBox[{8., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$216"], 
       TagBox[
        DiskBox[{7., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$217"], 
       TagBox[
        DiskBox[{7., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$218"], 
       TagBox[
        DiskBox[{7., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$219"], 
       TagBox[
        DiskBox[{6., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$220"], 
       TagBox[
        DiskBox[{6., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$221"], 
       TagBox[
        DiskBox[{6., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$222"], 
       TagBox[
        DiskBox[{7., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$223"], 
       TagBox[
        DiskBox[{6., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$224"], 
       TagBox[
        DiskBox[{5., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$225"], 
       TagBox[
        DiskBox[{4., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$226"], 
       TagBox[
        DiskBox[{5., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$227"], 
       TagBox[
        DiskBox[{4., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$228"], 
       TagBox[
        DiskBox[{3., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$229"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$230"], 
       TagBox[
        DiskBox[{4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$231"], 
       TagBox[
        DiskBox[{3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$232"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$233"], 
       TagBox[
        DiskBox[{3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$234"], 
       TagBox[
        DiskBox[{3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$235"], 
       TagBox[
        DiskBox[{2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$236"], 
       TagBox[
        DiskBox[{1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$237"], 
       TagBox[
        DiskBox[{1., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$238"], 
       TagBox[
        DiskBox[{1., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$239"], 
       TagBox[
        DiskBox[{1., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$240"], 
       TagBox[
        DiskBox[{0., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$241"], 
       TagBox[
        DiskBox[{1., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$242"], 
       TagBox[
        DiskBox[{0., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$243"], 
       TagBox[
        DiskBox[{1., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$244"], 
       TagBox[
        DiskBox[{1., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$245"], 
       TagBox[
        DiskBox[{0., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$246"], 
       TagBox[
        DiskBox[{0., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$247"], 
       TagBox[
        DiskBox[{-1., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$248"], 
       TagBox[
        DiskBox[{-1., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$249"], 
       TagBox[
        DiskBox[{-2., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$250"], 
       TagBox[
        DiskBox[{-2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$251"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$252"], 
       TagBox[
        DiskBox[{-3., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$253"], 
       TagBox[
        DiskBox[{-3., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$254"], 
       TagBox[
        DiskBox[{-3., 8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$255"], 
       TagBox[
        DiskBox[{-3., 7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$256"], 
       TagBox[
        DiskBox[{-3., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$257"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$258"], 
       TagBox[
        DiskBox[{-2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$259"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$260"], 
       TagBox[
        DiskBox[{-4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$261"], 
       TagBox[
        DiskBox[{-4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$262"], 
       TagBox[
        DiskBox[{-4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$263"], 
       TagBox[
        DiskBox[{-4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$264"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$265"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$266"], 
       TagBox[
        DiskBox[{-4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$267"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$268"], 
       TagBox[
        DiskBox[{-4., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$269"], 
       TagBox[
        DiskBox[{-4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$270"], 
       TagBox[
        DiskBox[{-5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$271"], 
       TagBox[
        DiskBox[{-4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$272"], 
       TagBox[
        DiskBox[{-5., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$273"], 
       TagBox[
        DiskBox[{-4., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$274"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$275"], 
       TagBox[
        DiskBox[{-3., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$276"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$277"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$278"], 
       TagBox[
        DiskBox[{-1., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$279"], 
       TagBox[
        DiskBox[{-1., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$280"], 
       TagBox[
        DiskBox[{-1., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$281"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$282"], 
       TagBox[
        DiskBox[{-2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$283"], 
       TagBox[
        DiskBox[{-2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$284"], 
       TagBox[
        DiskBox[{-3., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$285"], 
       TagBox[
        DiskBox[{-3., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$286"], 
       TagBox[
        DiskBox[{-2., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$287"], 
       TagBox[
        DiskBox[{-2., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$288"], 
       TagBox[
        DiskBox[{-2., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$289"], 
       TagBox[
        DiskBox[{-2., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$290"], 
       TagBox[
        DiskBox[{-3., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$291"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$292"], 
       TagBox[
        DiskBox[{-3., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$293"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$294"], 
       TagBox[
        DiskBox[{-2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$295"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$296"], 
       TagBox[
        DiskBox[{-2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$297"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$298"], 
       TagBox[
        DiskBox[{-2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$299"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$300"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$301"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$302"], 
       TagBox[
        DiskBox[{-4., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$303"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$304"], 
       TagBox[
        DiskBox[{-4., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$305"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$306"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$307"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$308"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$309"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$310"], 
       TagBox[
        DiskBox[{-2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$311"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$312"], 
       TagBox[
        DiskBox[{-2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$313"], 
       TagBox[
        DiskBox[{-2., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$314"], 
       TagBox[
        DiskBox[{-2., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$315"], 
       TagBox[
        DiskBox[{-2., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$316"], 
       TagBox[
        DiskBox[{-3., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$317"], 
       TagBox[
        DiskBox[{-3., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$318"], 
       TagBox[
        DiskBox[{-3., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$319"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$320"], 
       TagBox[
        DiskBox[{-3., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$321"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$322"], 
       TagBox[
        DiskBox[{-3., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$323"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$324"], 
       TagBox[
        DiskBox[{-2., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$325"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$326"], 
       TagBox[
        DiskBox[{-2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$327"], 
       TagBox[
        DiskBox[{-2., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$328"], 
       TagBox[
        DiskBox[{-2., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$329"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$330"], 
       TagBox[
        DiskBox[{-4., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$331"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$332"], 
       TagBox[
        DiskBox[{-4., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$333"], 
       TagBox[
        DiskBox[{-4., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$334"], 
       TagBox[
        DiskBox[{-4., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$335"], 
       TagBox[
        DiskBox[{-3., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$336"], 
       TagBox[
        DiskBox[{-3., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$337"], 
       TagBox[
        DiskBox[{-4., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$338"], 
       TagBox[
        DiskBox[{-5., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$339"], 
       TagBox[
        DiskBox[{-5., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$340"], 
       TagBox[
        DiskBox[{-6., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$341"], 
       TagBox[
        DiskBox[{-7., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$342"], 
       TagBox[
        DiskBox[{-7., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$343"], 
       TagBox[
        DiskBox[{-8., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$344"], 
       TagBox[
        DiskBox[{-8., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$345"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$346"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$347"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$348"], 
       TagBox[
        DiskBox[{-9., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$349"], 
       TagBox[
        DiskBox[{-9., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$350"], 
       TagBox[
        DiskBox[{-10., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$351"], 
       TagBox[
        DiskBox[{-10., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$352"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$353"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$354"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$355"], 
       TagBox[
        DiskBox[{-9., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$356"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$357"], 
       TagBox[
        DiskBox[{-9., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$358"], 
       TagBox[
        DiskBox[{-8., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$359"], 
       TagBox[
        DiskBox[{-8., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$360"], 
       TagBox[
        DiskBox[{-8., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$361"], 
       TagBox[
        DiskBox[{-9., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$362"], 
       TagBox[
        DiskBox[{-8., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$363"], 
       TagBox[
        DiskBox[{-7., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$364"], 
       TagBox[
        DiskBox[{-8., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$365"], 
       TagBox[
        DiskBox[{-8., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$366"], 
       TagBox[
        DiskBox[{-9., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$367"], 
       TagBox[
        DiskBox[{-9., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$368"], 
       TagBox[
        DiskBox[{-8., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$369"], 
       TagBox[
        DiskBox[{-8., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$370"], 
       TagBox[
        DiskBox[{-8., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$371"], 
       TagBox[
        DiskBox[{-9., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$372"], 
       TagBox[
        DiskBox[{-8., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$373"], 
       TagBox[
        DiskBox[{-8., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$374"], 
       TagBox[
        DiskBox[{-9., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$375"], 
       TagBox[
        DiskBox[{-9., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$376"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$377"], 
       TagBox[
        DiskBox[{-9., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$378"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$379"], 
       TagBox[
        DiskBox[{-10., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$380"], 
       TagBox[
        DiskBox[{-11., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$381"], 
       TagBox[
        DiskBox[{-11., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$382"], 
       TagBox[
        DiskBox[{-12., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$383"], 
       TagBox[
        DiskBox[{-12., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$384"], 
       TagBox[
        DiskBox[{-12., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$385"], 
       TagBox[
        DiskBox[{-12., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$386"], 
       TagBox[
        DiskBox[{-11., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$387"], 
       TagBox[
        DiskBox[{-12., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$388"], 
       TagBox[
        DiskBox[{-11., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$389"], 
       TagBox[
        DiskBox[{-11., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$390"], 
       TagBox[
        DiskBox[{-10., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$391"], 
       TagBox[
        DiskBox[{-10., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$392"], 
       TagBox[
        DiskBox[{-10., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$393"], 
       TagBox[
        DiskBox[{-10., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$394"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$395"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$396"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$397"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$398"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$399"], 
       TagBox[
        DiskBox[{-10., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$400"], 
       TagBox[
        DiskBox[{-9., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$401"], 
       TagBox[
        DiskBox[{-9., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$402"], 
       TagBox[
        DiskBox[{-9., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$403"], 
       TagBox[
        DiskBox[{-10., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$404"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$405"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$406"], 
       TagBox[
        DiskBox[{-8., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$407"], 
       TagBox[
        DiskBox[{-8., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$408"], 
       TagBox[
        DiskBox[{-7., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$409"], 
       TagBox[
        DiskBox[{-7., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$410"], 
       TagBox[
        DiskBox[{-6., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$411"], 
       TagBox[
        DiskBox[{-6., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$412"], 
       TagBox[
        DiskBox[{-5., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$413"], 
       TagBox[
        DiskBox[{-5., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$414"], 
       TagBox[
        DiskBox[{-5., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$415"], 
       TagBox[
        DiskBox[{-5., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$416"], 
       TagBox[
        DiskBox[{-4., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$417"], 
       TagBox[
        DiskBox[{-5., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$418"], 
       TagBox[
        DiskBox[{-5., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$419"], 
       TagBox[
        DiskBox[{-6., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$420"], 
       TagBox[
        DiskBox[{-6., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$421"], 
       TagBox[
        DiskBox[{-7., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$422"], 
       TagBox[
        DiskBox[{-7., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$423"], 
       TagBox[
        DiskBox[{-7., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$424"], 
       TagBox[
        DiskBox[{-7., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$425"], 
       TagBox[
        DiskBox[{-8., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$426"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$427"], 
       TagBox[
        DiskBox[{-9., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$428"], 
       TagBox[
        DiskBox[{-9., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$429"], 
       TagBox[
        DiskBox[{-9., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$430"], 
       TagBox[
        DiskBox[{-10., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$431"], 
       TagBox[
        DiskBox[{-11., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$432"], 
       TagBox[
        DiskBox[{-10., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$433"], 
       TagBox[
        DiskBox[{-10., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$434"], 
       TagBox[
        DiskBox[{-10., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$435"], 
       TagBox[
        DiskBox[{-10., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$436"], 
       TagBox[
        DiskBox[{-11., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$437"], 
       TagBox[
        DiskBox[{-11., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$438"], 
       TagBox[
        DiskBox[{-12., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$439"], 
       TagBox[
        DiskBox[{-12., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$440"], 
       TagBox[
        DiskBox[{-13., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$441"], 
       TagBox[
        DiskBox[{-14., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$442"], 
       TagBox[
        DiskBox[{-14., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$443"], 
       TagBox[
        DiskBox[{-14., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$444"], 
       TagBox[
        DiskBox[{-14., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$445"], 
       TagBox[
        DiskBox[{-14., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$446"], 
       TagBox[
        DiskBox[{-15., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$447"], 
       TagBox[
        DiskBox[{-16., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$448"], 
       TagBox[
        DiskBox[{-17., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$449"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$450"], 
       TagBox[
        DiskBox[{-17., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$451"], 
       TagBox[
        DiskBox[{-17., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$452"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$453"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$454"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$455"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$456"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$457"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$458"], 
       TagBox[
        DiskBox[{-21., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$459"], 
       TagBox[
        DiskBox[{-22., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$460"], 
       TagBox[
        DiskBox[{-22., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$461"], 
       TagBox[
        DiskBox[{-22., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$462"], 
       TagBox[
        DiskBox[{-21., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$463"], 
       TagBox[
        DiskBox[{-20., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$464"], 
       TagBox[
        DiskBox[{-19., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$465"], 
       TagBox[
        DiskBox[{-19., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$466"], 
       TagBox[
        DiskBox[{-19., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$467"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$468"], 
       TagBox[
        DiskBox[{-20., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$469"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$470"], 
       TagBox[
        DiskBox[{-20., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$471"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$472"], 
       TagBox[
        DiskBox[{-19., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$473"], 
       TagBox[
        DiskBox[{-20., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$474"], 
       TagBox[
        DiskBox[{-19., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$475"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$476"], 
       TagBox[
        DiskBox[{-18., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$477"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$478"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$479"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$480"], 
       TagBox[
        DiskBox[{-17., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$481"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$482"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$483"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$484"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$485"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$486"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$487"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$488"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$489"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$490"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$491"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$492"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$493"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$494"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$495"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$496"], 
       TagBox[
        DiskBox[{-18., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$497"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$498"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$499"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$500"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$501"], 
       TagBox[
        DiskBox[{-17., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$502"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$503"], 
       TagBox[
        DiskBox[{-17., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$504"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$505"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$506"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$507"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$508"], 
       TagBox[
        DiskBox[{-18., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$509"], 
       TagBox[
        DiskBox[{-19., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$510"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$511"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$512"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$513"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$514"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$515"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$516"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$517"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$518"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$519"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$520"], 
       TagBox[
        DiskBox[{-22., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$521"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$522"], 
       TagBox[
        DiskBox[{-22., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$523"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$524"], 
       TagBox[
        DiskBox[{-22., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$525"], 
       TagBox[
        DiskBox[{-22., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$526"], 
       TagBox[
        DiskBox[{-23., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$527"], 
       TagBox[
        DiskBox[{-23., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$528"], 
       TagBox[
        DiskBox[{-23., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$529"], 
       TagBox[
        DiskBox[{-24., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$530"], 
       TagBox[
        DiskBox[{-23., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$531"], 
       TagBox[
        DiskBox[{-22., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$532"], 
       TagBox[
        DiskBox[{-22., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$533"], 
       TagBox[
        DiskBox[{-22., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$534"], 
       TagBox[
        DiskBox[{-21., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$535"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$536"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$537"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$538"], 
       TagBox[
        DiskBox[{-20., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$539"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$540"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$541"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$542"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$543"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$544"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$545"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$546"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$547"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$548"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$549"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$550"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$551"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$552"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$553"], 
       TagBox[
        DiskBox[{-18., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$554"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$555"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$556"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$557"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$558"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$559"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$560"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$561"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$562"], 
       TagBox[
        DiskBox[{-16., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$563"], 
       TagBox[
        DiskBox[{-16., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$564"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$565"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$566"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$567"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$568"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$569"], 
       TagBox[
        DiskBox[{-18., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$570"], 
       TagBox[
        DiskBox[{-18., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$571"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$572"], 
       TagBox[
        DiskBox[{-20., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$573"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$574"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$575"], 
       TagBox[
        DiskBox[{-18., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$576"], 
       TagBox[
        DiskBox[{-17., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$577"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$578"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$579"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$580"], 
       TagBox[
        DiskBox[{-17., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$581"], 
       TagBox[
        DiskBox[{-16., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$582"], 
       TagBox[
        DiskBox[{-16., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$583"], 
       TagBox[
        DiskBox[{-16., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$584"], 
       TagBox[
        DiskBox[{-16., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$585"], 
       TagBox[
        DiskBox[{-15., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$586"], 
       TagBox[
        DiskBox[{-15., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$587"], 
       TagBox[
        DiskBox[{-15., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$588"], 
       TagBox[
        DiskBox[{-14., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$589"], 
       TagBox[
        DiskBox[{-14., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$590"], 
       TagBox[
        DiskBox[{-14., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$591"], 
       TagBox[
        DiskBox[{-14., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$592"], 
       TagBox[
        DiskBox[{-15., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$593"], 
       TagBox[
        DiskBox[{-15., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$594"], 
       TagBox[
        DiskBox[{-14., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$595"], 
       TagBox[
        DiskBox[{-15., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$596"], 
       TagBox[
        DiskBox[{-15., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$597"], 
       TagBox[
        DiskBox[{-15., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$598"], 
       TagBox[
        DiskBox[{-15., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$599"], 
       TagBox[
        DiskBox[{-16., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$600"], 
       TagBox[
        DiskBox[{-16., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$601"], 
       TagBox[
        DiskBox[{-16., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$602"], 
       TagBox[
        DiskBox[{-17., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$603"], 
       TagBox[
        DiskBox[{-17., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$604"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$605"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$606"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$607"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$608"], 
       TagBox[
        DiskBox[{-17., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$609"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$610"], 
       TagBox[
        DiskBox[{-17., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$611"], 
       TagBox[
        DiskBox[{-17., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$612"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$613"], 
       TagBox[
        DiskBox[{-16., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$614"], 
       TagBox[
        DiskBox[{-16., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$615"], 
       TagBox[
        DiskBox[{-15., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$616"], 
       TagBox[
        DiskBox[{-16., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$617"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$618"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$619"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$620"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$621"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$622"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$623"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$624"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$625"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$626"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$627"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$628"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$629"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$630"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$631"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$632"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$633"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$634"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$635"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$636"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$637"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$638"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$639"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$640"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$641"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$642"], 
       TagBox[
        DiskBox[{-20., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$643"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$644"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$645"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$646"], 
       TagBox[
        DiskBox[{-20., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$647"], 
       TagBox[
        DiskBox[{-21., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$648"], 
       TagBox[
        DiskBox[{-22., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$649"], 
       TagBox[
        DiskBox[{-22., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$650"], 
       TagBox[
        DiskBox[{-21., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$651"], 
       TagBox[
        DiskBox[{-21., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$652"], 
       TagBox[
        DiskBox[{-22., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$653"], 
       TagBox[
        DiskBox[{-22., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$654"], 
       TagBox[
        DiskBox[{-21., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$655"], 
       TagBox[
        DiskBox[{-21., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$656"], 
       TagBox[
        DiskBox[{-21., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$657"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$658"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$659"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$660"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$661"], 
       TagBox[
        DiskBox[{-21., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$662"], 
       TagBox[
        DiskBox[{-22., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$663"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$664"], 
       TagBox[
        DiskBox[{-22., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$665"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$666"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$667"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$668"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$669"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$670"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$671"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$672"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$673"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$674"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$675"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$676"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$677"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$678"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$679"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$680"], 
       TagBox[
        DiskBox[{-20., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$681"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$682"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$683"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$684"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$685"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$686"], 
       TagBox[
        DiskBox[{-20., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$687"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$688"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$689"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$690"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$691"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$692"], 
       TagBox[
        DiskBox[{-21., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$693"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$694"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$695"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$696"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$697"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$698"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$699"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$700"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$701"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$702"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$703"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$704"], 
       TagBox[
        DiskBox[{-25., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$705"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$706"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$707"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$708"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$709"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$710"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$711"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$712"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$713"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$714"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$715"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$716"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$717"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$718"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$719"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$720"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$721"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$722"], 
       TagBox[
        DiskBox[{-25., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$723"], 
       TagBox[
        DiskBox[{-26., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$724"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$725"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$726"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$727"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$728"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$729"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$730"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$731"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$732"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$733"], 
       TagBox[
        DiskBox[{-23., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$734"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$735"], 
       TagBox[
        DiskBox[{-23., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$736"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$737"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$738"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$739"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$740"], 
       TagBox[
        DiskBox[{-22., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$741"], 
       TagBox[
        DiskBox[{-21., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$742"], 
       TagBox[
        DiskBox[{-21., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$743"], 
       TagBox[
        DiskBox[{-21., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$744"], 
       TagBox[
        DiskBox[{-21., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$745"], 
       TagBox[
        DiskBox[{-22., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$746"], 
       TagBox[
        DiskBox[{-22., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$747"], 
       TagBox[
        DiskBox[{-22., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$748"], 
       TagBox[
        DiskBox[{-22., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$749"], 
       TagBox[
        DiskBox[{-23., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$750"], 
       TagBox[
        DiskBox[{-23., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$751"], 
       TagBox[
        DiskBox[{-22., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$752"], 
       TagBox[
        DiskBox[{-21., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$753"], 
       TagBox[
        DiskBox[{-21., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$754"], 
       TagBox[
        DiskBox[{-22., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$755"], 
       TagBox[
        DiskBox[{-22., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$756"], 
       TagBox[
        DiskBox[{-21., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$757"], 
       TagBox[
        DiskBox[{-20., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$758"], 
       TagBox[
        DiskBox[{-20., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$759"], 
       TagBox[
        DiskBox[{-20., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$760"], 
       TagBox[
        DiskBox[{-21., 6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$761"], 
       TagBox[
        DiskBox[{-21., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$762"], 
       TagBox[
        DiskBox[{-22., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$763"], 
       TagBox[
        DiskBox[{-23., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$764"], 
       TagBox[
        DiskBox[{-23., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$765"], 
       TagBox[
        DiskBox[{-23., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$766"], 
       TagBox[
        DiskBox[{-22., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$767"], 
       TagBox[
        DiskBox[{-23., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$768"], 
       TagBox[
        DiskBox[{-23., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$769"], 
       TagBox[
        DiskBox[{-24., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$770"], 
       TagBox[
        DiskBox[{-23., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$771"], 
       TagBox[
        DiskBox[{-24., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$772"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$773"], 
       TagBox[
        DiskBox[{-23., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$774"], 
       TagBox[
        DiskBox[{-22., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$775"], 
       TagBox[
        DiskBox[{-23., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$776"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$777"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$778"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$779"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$780"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$781"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$782"], 
       TagBox[
        DiskBox[{-27., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$783"], 
       TagBox[
        DiskBox[{-27., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$784"], 
       TagBox[
        DiskBox[{-27., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$785"], 
       TagBox[
        DiskBox[{-28., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$786"], 
       TagBox[
        DiskBox[{-27., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$787"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$788"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$789"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$790"], 
       TagBox[
        DiskBox[{-27., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$791"], 
       TagBox[
        DiskBox[{-27., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$792"], 
       TagBox[
        DiskBox[{-27., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$793"], 
       TagBox[
        DiskBox[{-27., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$794"], 
       TagBox[
        DiskBox[{-27., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$795"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$796"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$797"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$798"], 
       TagBox[
        DiskBox[{-25., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$799"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$800"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$801"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$802"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$803"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$804"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$805"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$806"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$807"], 
       TagBox[
        DiskBox[{-27., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$808"], 
       TagBox[
        DiskBox[{-28., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$809"], 
       TagBox[
        DiskBox[{-27., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$810"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$811"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$812"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$813"], 
       TagBox[
        DiskBox[{-26., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$814"], 
       TagBox[
        DiskBox[{-26., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$815"], 
       TagBox[
        DiskBox[{-27., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$816"], 
       TagBox[
        DiskBox[{-27., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$817"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$818"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$819"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$820"], 
       TagBox[
        DiskBox[{-30., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$821"], 
       TagBox[
        DiskBox[{-30., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$822"], 
       TagBox[
        DiskBox[{-30., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$823"], 
       TagBox[
        DiskBox[{-30., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$824"], 
       TagBox[
        DiskBox[{-30., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$825"], 
       TagBox[
        DiskBox[{-31., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$826"], 
       TagBox[
        DiskBox[{-30., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$827"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$828"], 
       TagBox[
        DiskBox[{-29., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$829"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$830"], 
       TagBox[
        DiskBox[{-29., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$831"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$832"], 
       TagBox[
        DiskBox[{-29., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$833"], 
       TagBox[
        DiskBox[{-29., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$834"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$835"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$836"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$837"], 
       TagBox[
        DiskBox[{-29., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$838"], 
       TagBox[
        DiskBox[{-29., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$839"], 
       TagBox[
        DiskBox[{-29., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$840"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$841"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$842"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$843"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$844"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$845"], 
       TagBox[
        DiskBox[{-30., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$846"], 
       TagBox[
        DiskBox[{-29., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$847"], 
       TagBox[
        DiskBox[{-28., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$848"], 
       TagBox[
        DiskBox[{-27., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$849"], 
       TagBox[
        DiskBox[{-27., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$850"], 
       TagBox[
        DiskBox[{-28., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$851"], 
       TagBox[
        DiskBox[{-29., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$852"], 
       TagBox[
        DiskBox[{-29., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$853"], 
       TagBox[
        DiskBox[{-30., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$854"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$855"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$856"], 
       TagBox[
        DiskBox[{-31., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$857"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$858"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$859"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$860"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$861"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$862"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$863"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$864"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$865"], 
       TagBox[
        DiskBox[{-33., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$866"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$867"], 
       TagBox[
        DiskBox[{-33., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$868"], 
       TagBox[
        DiskBox[{-33., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$869"], 
       TagBox[
        DiskBox[{-34., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$870"], 
       TagBox[
        DiskBox[{-33., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$871"], 
       TagBox[
        DiskBox[{-32., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$872"], 
       TagBox[
        DiskBox[{-32., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$873"], 
       TagBox[
        DiskBox[{-33., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$874"], 
       TagBox[
        DiskBox[{-32., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$875"], 
       TagBox[
        DiskBox[{-32., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$876"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$877"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$878"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$879"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$880"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$881"], 
       TagBox[
        DiskBox[{-33., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$882"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$883"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$884"], 
       TagBox[
        DiskBox[{-32., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$885"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$886"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$887"], 
       TagBox[
        DiskBox[{-33., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$888"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$889"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$890"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$891"], 
       TagBox[
        DiskBox[{-32., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$892"], 
       TagBox[
        DiskBox[{-32., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$893"], 
       TagBox[
        DiskBox[{-32., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$894"], 
       TagBox[
        DiskBox[{-33., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$895"], 
       TagBox[
        DiskBox[{-33., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$896"], 
       TagBox[
        DiskBox[{-33., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$897"], 
       TagBox[
        DiskBox[{-33., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$898"], 
       TagBox[
        DiskBox[{-33., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$899"], 
       TagBox[
        DiskBox[{-33., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$900"], 
       TagBox[
        DiskBox[{-33., -10.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$901"], 
       TagBox[
        DiskBox[{-32., -10.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$902"], 
       TagBox[
        DiskBox[{-31., -10.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$903"], 
       TagBox[
        DiskBox[{-30., -10.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$904"], 
       TagBox[
        DiskBox[{-30., -9.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$905"], 
       TagBox[
        DiskBox[{-30., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$906"], 
       TagBox[
        DiskBox[{-31., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$907"], 
       TagBox[
        DiskBox[{-32., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$908"], 
       TagBox[
        DiskBox[{-31., -8.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$909"], 
       TagBox[
        DiskBox[{-31., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$910"], 
       TagBox[
        DiskBox[{-30., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$911"], 
       TagBox[
        DiskBox[{-31., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$912"], 
       TagBox[
        DiskBox[{-31., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$913"], 
       TagBox[
        DiskBox[{-32., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$914"], 
       TagBox[
        DiskBox[{-31., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$915"], 
       TagBox[
        DiskBox[{-32., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$916"], 
       TagBox[
        DiskBox[{-32., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$917"], 
       TagBox[
        DiskBox[{-33., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$918"], 
       TagBox[
        DiskBox[{-33., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$919"], 
       TagBox[
        DiskBox[{-32., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$920"], 
       TagBox[
        DiskBox[{-33., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$921"], 
       TagBox[
        DiskBox[{-33., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$922"], 
       TagBox[
        DiskBox[{-34., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$923"], 
       TagBox[
        DiskBox[{-33., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$924"], 
       TagBox[
        DiskBox[{-33., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$925"], 
       TagBox[
        DiskBox[{-34., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$926"], 
       TagBox[
        DiskBox[{-34., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$927"], 
       TagBox[
        DiskBox[{-34., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$928"], 
       TagBox[
        DiskBox[{-34., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$929"], 
       TagBox[
        DiskBox[{-35., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$930"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$931"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$932"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$933"], 
       TagBox[
        DiskBox[{-36., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$934"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$935"], 
       TagBox[
        DiskBox[{-35., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$936"], 
       TagBox[
        DiskBox[{-34., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$937"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$938"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$939"], 
       TagBox[
        DiskBox[{-36., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$940"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$941"], 
       TagBox[
        DiskBox[{-35., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$942"], 
       TagBox[
        DiskBox[{-36., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$943"], 
       TagBox[
        DiskBox[{-36., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$944"], 
       TagBox[
        DiskBox[{-36., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$945"], 
       TagBox[
        DiskBox[{-36., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$946"], 
       TagBox[
        DiskBox[{-36., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$947"], 
       TagBox[
        DiskBox[{-35., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$948"], 
       TagBox[
        DiskBox[{-34., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$949"], 
       TagBox[
        DiskBox[{-33., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$950"], 
       TagBox[
        DiskBox[{-34., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$951"], 
       TagBox[
        DiskBox[{-35., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$952"], 
       TagBox[
        DiskBox[{-35., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$953"], 
       TagBox[
        DiskBox[{-35., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$954"], 
       TagBox[
        DiskBox[{-35., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$955"], 
       TagBox[
        DiskBox[{-35., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$956"], 
       TagBox[
        DiskBox[{-35., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$957"], 
       TagBox[
        DiskBox[{-36., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$958"], 
       TagBox[
        DiskBox[{-36., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$959"], 
       TagBox[
        DiskBox[{-36., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$960"], 
       TagBox[
        DiskBox[{-35., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$961"], 
       TagBox[
        DiskBox[{-35., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$962"], 
       TagBox[
        DiskBox[{-35., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$963"], 
       TagBox[
        DiskBox[{-35., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$964"], 
       TagBox[
        DiskBox[{-34., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$965"], 
       TagBox[
        DiskBox[{-34., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$966"], 
       TagBox[
        DiskBox[{-34., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$967"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$968"], 
       TagBox[
        DiskBox[{-34., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$969"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$970"], 
       TagBox[
        DiskBox[{-34., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$971"], 
       TagBox[
        DiskBox[{-35., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$972"], 
       TagBox[
        DiskBox[{-34., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$973"], 
       TagBox[
        DiskBox[{-34., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$974"], 
       TagBox[
        DiskBox[{-33., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$975"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$976"], 
       TagBox[
        DiskBox[{-32., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$977"], 
       TagBox[
        DiskBox[{-31., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$978"], 
       TagBox[
        DiskBox[{-30., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$979"], 
       TagBox[
        DiskBox[{-30., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$980"], 
       TagBox[
        DiskBox[{-29., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$981"], 
       TagBox[
        DiskBox[{-28., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$982"], 
       TagBox[
        DiskBox[{-28., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$983"], 
       TagBox[
        DiskBox[{-28., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$984"], 
       TagBox[
        DiskBox[{-28., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$985"], 
       TagBox[
        DiskBox[{-28., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$986"], 
       TagBox[
        DiskBox[{-29., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$987"], 
       TagBox[
        DiskBox[{-30., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$988"], 
       TagBox[
        DiskBox[{-31., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$989"], 
       TagBox[
        DiskBox[{-31., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$990"], 
       TagBox[
        DiskBox[{-30., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$991"], 
       TagBox[
        DiskBox[{-31., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$992"], 
       TagBox[
        DiskBox[{-31., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$993"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$994"], 
       TagBox[
        DiskBox[{-31., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$995"], 
       TagBox[
        DiskBox[{-32., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$996"], 
       TagBox[
        DiskBox[{-31., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$997"], 
       TagBox[
        DiskBox[{-32., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$998"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$999"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1000"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1001"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1002"], 
       TagBox[
        DiskBox[{-32., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1003"], 
       TagBox[
        DiskBox[{-31., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1004"], 
       TagBox[
        DiskBox[{-31., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1005"], 
       TagBox[
        DiskBox[{-30., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1006"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1007"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1008"], 
       TagBox[
        DiskBox[{-31., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1009"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1010"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1011"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1012"], 
       TagBox[
        DiskBox[{-31., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1013"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1014"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1015"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1016"], 
       TagBox[
        DiskBox[{-30., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1017"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1018"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1019"], 
       TagBox[
        DiskBox[{-32., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1020"], 
       TagBox[
        DiskBox[{-32., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1021"], 
       TagBox[
        DiskBox[{-31., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1022"], 
       TagBox[
        DiskBox[{-31., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1023"], 
       TagBox[
        DiskBox[{-30., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1024"], 
       TagBox[
        DiskBox[{-29., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1025"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1026"], 
       TagBox[
        DiskBox[{-30., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1027"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1028"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1029"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1030"], 
       TagBox[
        DiskBox[{-28., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1031"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1032"], 
       TagBox[
        DiskBox[{-28., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1033"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1034"], 
       TagBox[
        DiskBox[{-28., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1035"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1036"], 
       TagBox[
        DiskBox[{-29., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1037"], 
       TagBox[
        DiskBox[{-30., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1038"], 
       TagBox[
        DiskBox[{-29., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1039"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1040"], 
       TagBox[
        DiskBox[{-27., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1041"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1042"], 
       TagBox[
        DiskBox[{-29., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1043"], 
       TagBox[
        DiskBox[{-28., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1044"], 
       TagBox[
        DiskBox[{-28., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1045"], 
       TagBox[
        DiskBox[{-27., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1046"], 
       TagBox[
        DiskBox[{-26., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1047"], 
       TagBox[
        DiskBox[{-27., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1048"], 
       TagBox[
        DiskBox[{-27., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1049"], 
       TagBox[
        DiskBox[{-27., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1050"], 
       TagBox[
        DiskBox[{-28., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1051"], 
       TagBox[
        DiskBox[{-27., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1052"], 
       TagBox[
        DiskBox[{-27., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1053"], 
       TagBox[
        DiskBox[{-27., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1054"], 
       TagBox[
        DiskBox[{-26., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1055"], 
       TagBox[
        DiskBox[{-25., -7.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1056"], 
       TagBox[
        DiskBox[{-25., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1057"], 
       TagBox[
        DiskBox[{-25., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1058"], 
       TagBox[
        DiskBox[{-25., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1059"], 
       TagBox[
        DiskBox[{-26., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1060"], 
       TagBox[
        DiskBox[{-27., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1061"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1062"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1063"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1064"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1065"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1066"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1067"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1068"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1069"], 
       TagBox[
        DiskBox[{-28., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1070"], 
       TagBox[
        DiskBox[{-27., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1071"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1072"], 
       TagBox[
        DiskBox[{-27., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1073"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1074"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1075"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1076"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1077"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1078"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1079"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1080"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1081"], 
       TagBox[
        DiskBox[{-30., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1082"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1083"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1084"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1085"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1086"], 
       TagBox[
        DiskBox[{-27., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1087"], 
       TagBox[
        DiskBox[{-27., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1088"], 
       TagBox[
        DiskBox[{-26., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1089"], 
       TagBox[
        DiskBox[{-27., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1090"], 
       TagBox[
        DiskBox[{-27., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1091"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1092"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1093"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1094"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1095"], 
       TagBox[
        DiskBox[{-28., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1096"], 
       TagBox[
        DiskBox[{-28., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1097"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1098"], 
       TagBox[
        DiskBox[{-29., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1099"], 
       TagBox[
        DiskBox[{-29., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1100"], 
       TagBox[
        DiskBox[{-29., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1101"], 
       TagBox[
        DiskBox[{-28., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1102"], 
       TagBox[
        DiskBox[{-27., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1103"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1104"], 
       TagBox[
        DiskBox[{-26., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1105"], 
       TagBox[
        DiskBox[{-26., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1106"], 
       TagBox[
        DiskBox[{-26., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1107"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1108"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1109"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1110"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1111"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1112"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1113"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1114"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1115"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1116"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1117"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1118"], 
       TagBox[
        DiskBox[{-22., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1119"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1120"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1121"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1122"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1123"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1124"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1125"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1126"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1127"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1128"], 
       TagBox[
        DiskBox[{-22., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1129"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1130"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1131"], 
       TagBox[
        DiskBox[{-20., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1132"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1133"], 
       TagBox[
        DiskBox[{-21., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1134"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1135"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1136"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1137"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1138"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1139"], 
       TagBox[
        DiskBox[{-22., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1140"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1141"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1142"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1143"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1144"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1145"], 
       TagBox[
        DiskBox[{-20., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1146"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1147"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1148"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1149"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1150"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1151"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1152"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1153"], 
       TagBox[
        DiskBox[{-22., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1154"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1155"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1156"], 
       TagBox[
        DiskBox[{-22., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1157"], 
       TagBox[
        DiskBox[{-22., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1158"], 
       TagBox[
        DiskBox[{-21., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1159"], 
       TagBox[
        DiskBox[{-21., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1160"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1161"], 
       TagBox[
        DiskBox[{-21., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1162"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1163"], 
       TagBox[
        DiskBox[{-20., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1164"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1165"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1166"], 
       TagBox[
        DiskBox[{-18., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1167"], 
       TagBox[
        DiskBox[{-18., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1168"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1169"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1170"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1171"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1172"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1173"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1174"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1175"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1176"], 
       TagBox[
        DiskBox[{-19., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1177"], 
       TagBox[
        DiskBox[{-19., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1178"], 
       TagBox[
        DiskBox[{-19., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1179"], 
       TagBox[
        DiskBox[{-18., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1180"], 
       TagBox[
        DiskBox[{-18., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1181"], 
       TagBox[
        DiskBox[{-18., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1182"], 
       TagBox[
        DiskBox[{-19., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1183"], 
       TagBox[
        DiskBox[{-19., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1184"], 
       TagBox[
        DiskBox[{-19., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1185"], 
       TagBox[
        DiskBox[{-19., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1186"], 
       TagBox[
        DiskBox[{-18., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1187"], 
       TagBox[
        DiskBox[{-17., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1188"], 
       TagBox[
        DiskBox[{-18., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1189"], 
       TagBox[
        DiskBox[{-18., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1190"], 
       TagBox[
        DiskBox[{-19., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1191"], 
       TagBox[
        DiskBox[{-19., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1192"], 
       TagBox[
        DiskBox[{-19., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1193"], 
       TagBox[
        DiskBox[{-18., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1194"], 
       TagBox[
        DiskBox[{-18., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1195"], 
       TagBox[
        DiskBox[{-19., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1196"], 
       TagBox[
        DiskBox[{-19., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1197"], 
       TagBox[
        DiskBox[{-19., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1198"], 
       TagBox[
        DiskBox[{-19., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1199"], 
       TagBox[
        DiskBox[{-19., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1200"], 
       TagBox[
        DiskBox[{-19., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1201"], 
       TagBox[
        DiskBox[{-19., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1202"], 
       TagBox[
        DiskBox[{-19., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1203"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1204"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1205"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1206"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1207"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1208"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1209"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1210"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1211"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1212"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1213"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1214"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1215"], 
       TagBox[
        DiskBox[{-21., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1216"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1217"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1218"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1219"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1220"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1221"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1222"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1223"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1224"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1225"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1226"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1227"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1228"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1229"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1230"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1231"], 
       TagBox[
        DiskBox[{-20., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1232"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1233"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1234"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1235"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1236"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1237"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1238"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1239"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1240"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1241"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1242"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1243"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1244"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1245"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1246"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1247"], 
       TagBox[
        DiskBox[{-23., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1248"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1249"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1250"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1251"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1252"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1253"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1254"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1255"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1256"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1257"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1258"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1259"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1260"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1261"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1262"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1263"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1264"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1265"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1266"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1267"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1268"], 
       TagBox[
        DiskBox[{-25., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1269"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1270"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1271"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1272"], 
       TagBox[
        DiskBox[{-26., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1273"], 
       TagBox[
        DiskBox[{-26., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1274"], 
       TagBox[
        DiskBox[{-26., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1275"], 
       TagBox[
        DiskBox[{-27., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1276"], 
       TagBox[
        DiskBox[{-26., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1277"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1278"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1279"], 
       TagBox[
        DiskBox[{-24., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1280"], 
       TagBox[
        DiskBox[{-24., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1281"], 
       TagBox[
        DiskBox[{-25., 5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1282"], 
       TagBox[
        DiskBox[{-25., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1283"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1284"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1285"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1286"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1287"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1288"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1289"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1290"], 
       TagBox[
        DiskBox[{-24., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1291"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1292"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1293"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1294"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1295"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1296"], 
       TagBox[
        DiskBox[{-25., 4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1297"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1298"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1299"], 
       TagBox[
        DiskBox[{-25., 3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1300"], 
       TagBox[
        DiskBox[{-25., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1301"], 
       TagBox[
        DiskBox[{-25., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1302"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1303"], 
       TagBox[
        DiskBox[{-24., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1304"], 
       TagBox[
        DiskBox[{-23., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1305"], 
       TagBox[
        DiskBox[{-22., 2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1306"], 
       TagBox[
        DiskBox[{-22., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1307"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1308"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1309"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1310"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1311"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1312"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1313"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1314"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1315"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1316"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1317"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1318"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1319"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1320"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1321"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1322"], 
       TagBox[
        DiskBox[{-25., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1323"], 
       TagBox[
        DiskBox[{-25., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1324"], 
       TagBox[
        DiskBox[{-24., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1325"], 
       TagBox[
        DiskBox[{-25., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1326"], 
       TagBox[
        DiskBox[{-25., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1327"], 
       TagBox[
        DiskBox[{-25., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1328"], 
       TagBox[
        DiskBox[{-25., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1329"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1330"], 
       TagBox[
        DiskBox[{-25., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1331"], 
       TagBox[
        DiskBox[{-26., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1332"], 
       TagBox[
        DiskBox[{-25., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1333"], 
       TagBox[
        DiskBox[{-26., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1334"], 
       TagBox[
        DiskBox[{-26., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1335"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1336"], 
       TagBox[
        DiskBox[{-26., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1337"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1338"], 
       TagBox[
        DiskBox[{-26., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1339"], 
       TagBox[
        DiskBox[{-27., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1340"], 
       TagBox[
        DiskBox[{-27., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1341"], 
       TagBox[
        DiskBox[{-26., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1342"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1343"], 
       TagBox[
        DiskBox[{-25., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1344"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1345"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1346"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1347"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1348"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1349"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1350"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1351"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1352"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1353"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1354"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1355"], 
       TagBox[
        DiskBox[{-20., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1356"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1357"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1358"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1359"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1360"], 
       TagBox[
        DiskBox[{-21., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1361"], 
       TagBox[
        DiskBox[{-21., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1362"], 
       TagBox[
        DiskBox[{-21., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1363"], 
       TagBox[
        DiskBox[{-22., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1364"], 
       TagBox[
        DiskBox[{-22., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1365"], 
       TagBox[
        DiskBox[{-22., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1366"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1367"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1368"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1369"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1370"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1371"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1372"], 
       TagBox[
        DiskBox[{-25., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1373"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1374"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1375"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1376"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1377"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1378"], 
       TagBox[
        DiskBox[{-23., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1379"], 
       TagBox[
        DiskBox[{-23., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1380"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1381"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1382"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1383"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1384"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1385"], 
       TagBox[
        DiskBox[{-25., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1386"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1387"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1388"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1389"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1390"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1391"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1392"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1393"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1394"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1395"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1396"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1397"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1398"], 
       TagBox[
        DiskBox[{-23., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1399"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1400"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1401"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1402"], 
       TagBox[
        DiskBox[{-24., 1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1403"], 
       TagBox[
        DiskBox[{-24., 0.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1404"], 
       TagBox[
        DiskBox[{-24., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1405"], 
       TagBox[
        DiskBox[{-24., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1406"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1407"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1408"], 
       TagBox[
        DiskBox[{-23., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1409"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1410"], 
       TagBox[
        DiskBox[{-24., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1411"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1412"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1413"], 
       TagBox[
        DiskBox[{-23., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1414"], 
       TagBox[
        DiskBox[{-22., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1415"], 
       TagBox[
        DiskBox[{-21., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1416"], 
       TagBox[
        DiskBox[{-20., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1417"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1418"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1419"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1420"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1421"], 
       TagBox[
        DiskBox[{-17., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1422"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1423"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1424"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1425"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1426"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1427"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1428"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1429"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1430"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1431"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1432"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1433"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1434"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1435"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1436"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1437"], 
       TagBox[
        DiskBox[{-17., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1438"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1439"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1440"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1441"], 
       TagBox[
        DiskBox[{-17., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1442"], 
       TagBox[
        DiskBox[{-17., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1443"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1444"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1445"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1446"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1447"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1448"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1449"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1450"], 
       TagBox[
        DiskBox[{-20., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1451"], 
       TagBox[
        DiskBox[{-20., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1452"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1453"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1454"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1455"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1456"], 
       TagBox[
        DiskBox[{-18., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1457"], 
       TagBox[
        DiskBox[{-18., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1458"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1459"], 
       TagBox[
        DiskBox[{-20., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1460"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1461"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1462"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1463"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1464"], 
       TagBox[
        DiskBox[{-19., -6.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1465"], 
       TagBox[
        DiskBox[{-19., -5.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1466"], 
       TagBox[
        DiskBox[{-19., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1467"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1468"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1469"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1470"], 
       TagBox[
        DiskBox[{-20., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1471"], 
       TagBox[
        DiskBox[{-19., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1472"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1473"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1474"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1475"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1476"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1477"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1478"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1479"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1480"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1481"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1482"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1483"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1484"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1485"], 
       TagBox[
        DiskBox[{-17., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1486"], 
       TagBox[
        DiskBox[{-18., -1.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1487"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1488"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1489"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1490"], 
       TagBox[
        DiskBox[{-19., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1491"], 
       TagBox[
        DiskBox[{-19., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1492"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1493"], 
       TagBox[
        DiskBox[{-18., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1494"], 
       TagBox[
        DiskBox[{-17., -4.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1495"], 
       TagBox[
        DiskBox[{-17., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1496"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1497"], 
       TagBox[
        DiskBox[{-17., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1498"], 
       TagBox[
        DiskBox[{-18., -3.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1499"], 
       TagBox[
        DiskBox[{-18., -2.}, 0.11533795493934142`], "DynamicName", BoxID -> 
        "VertexID$1500"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       Arrowheads[{{0.009582311168495804, 0.7}}], {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$9", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$10", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$11", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$12", Automatic, Center], 
          DynamicLocation["VertexID$13", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$13", Automatic, Center], 
          DynamicLocation["VertexID$14", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$14", Automatic, Center], 
          DynamicLocation["VertexID$15", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$15", Automatic, Center], 
          DynamicLocation["VertexID$16", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$16", Automatic, Center], 
          DynamicLocation["VertexID$17", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$17", Automatic, Center], 
          DynamicLocation["VertexID$18", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$18", Automatic, Center], 
          DynamicLocation["VertexID$19", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$19", Automatic, Center], 
          DynamicLocation["VertexID$20", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$20", Automatic, Center], 
          DynamicLocation["VertexID$21", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$21", Automatic, Center], 
          DynamicLocation["VertexID$22", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$22", Automatic, Center], 
          DynamicLocation["VertexID$23", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$23", Automatic, Center], 
          DynamicLocation["VertexID$24", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$24", Automatic, Center], 
          DynamicLocation["VertexID$25", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$25", Automatic, Center], 
          DynamicLocation["VertexID$26", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$26", Automatic, Center], 
          DynamicLocation["VertexID$27", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$27", Automatic, Center], 
          DynamicLocation["VertexID$28", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$28", Automatic, Center], 
          DynamicLocation["VertexID$29", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$29", Automatic, Center], 
          DynamicLocation["VertexID$30", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$30", Automatic, Center], 
          DynamicLocation["VertexID$31", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$31", Automatic, Center], 
          DynamicLocation["VertexID$32", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$32", Automatic, Center], 
          DynamicLocation["VertexID$33", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$33", Automatic, Center], 
          DynamicLocation["VertexID$34", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$34", Automatic, Center], 
          DynamicLocation["VertexID$35", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$35", Automatic, Center], 
          DynamicLocation["VertexID$36", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$36", Automatic, Center], 
          DynamicLocation["VertexID$37", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$37", Automatic, Center], 
          DynamicLocation["VertexID$38", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$38", Automatic, Center], 
          DynamicLocation["VertexID$39", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$39", Automatic, Center], 
          DynamicLocation["VertexID$40", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$40", Automatic, Center], 
          DynamicLocation["VertexID$41", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$41", Automatic, Center], 
          DynamicLocation["VertexID$42", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$42", Automatic, Center], 
          DynamicLocation["VertexID$43", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$43", Automatic, Center], 
          DynamicLocation["VertexID$44", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$44", Automatic, Center], 
          DynamicLocation["VertexID$45", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$45", Automatic, Center], 
          DynamicLocation["VertexID$46", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$46", Automatic, Center], 
          DynamicLocation["VertexID$47", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$47", Automatic, Center], 
          DynamicLocation["VertexID$48", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$48", Automatic, Center], 
          DynamicLocation["VertexID$49", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$49", Automatic, Center], 
          DynamicLocation["VertexID$50", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$50", Automatic, Center], 
          DynamicLocation["VertexID$51", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$51", Automatic, Center], 
          DynamicLocation["VertexID$52", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$52", Automatic, Center], 
          DynamicLocation["VertexID$53", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$53", Automatic, Center], 
          DynamicLocation["VertexID$54", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$54", Automatic, Center], 
          DynamicLocation["VertexID$55", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$55", Automatic, Center], 
          DynamicLocation["VertexID$56", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$56", Automatic, Center], 
          DynamicLocation["VertexID$57", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$57", Automatic, Center], 
          DynamicLocation["VertexID$58", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$58", Automatic, Center], 
          DynamicLocation["VertexID$59", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$59", Automatic, Center], 
          DynamicLocation["VertexID$60", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$60", Automatic, Center], 
          DynamicLocation["VertexID$61", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$61", Automatic, Center], 
          DynamicLocation["VertexID$62", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$62", Automatic, Center], 
          DynamicLocation["VertexID$63", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$63", Automatic, Center], 
          DynamicLocation["VertexID$64", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$64", Automatic, Center], 
          DynamicLocation["VertexID$65", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$65", Automatic, Center], 
          DynamicLocation["VertexID$66", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$66", Automatic, Center], 
          DynamicLocation["VertexID$67", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$67", Automatic, Center], 
          DynamicLocation["VertexID$68", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$68", Automatic, Center], 
          DynamicLocation["VertexID$69", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$69", Automatic, Center], 
          DynamicLocation["VertexID$70", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$70", Automatic, Center], 
          DynamicLocation["VertexID$71", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$71", Automatic, Center], 
          DynamicLocation["VertexID$72", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$72", Automatic, Center], 
          DynamicLocation["VertexID$73", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$73", Automatic, Center], 
          DynamicLocation["VertexID$74", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$74", Automatic, Center], 
          DynamicLocation["VertexID$75", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$75", Automatic, Center], 
          DynamicLocation["VertexID$76", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$76", Automatic, Center], 
          DynamicLocation["VertexID$77", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$77", Automatic, Center], 
          DynamicLocation["VertexID$78", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$78", Automatic, Center], 
          DynamicLocation["VertexID$79", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$79", Automatic, Center], 
          DynamicLocation["VertexID$80", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$80", Automatic, Center], 
          DynamicLocation["VertexID$81", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$81", Automatic, Center], 
          DynamicLocation["VertexID$82", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$82", Automatic, Center], 
          DynamicLocation["VertexID$83", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$83", Automatic, Center], 
          DynamicLocation["VertexID$84", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$84", Automatic, Center], 
          DynamicLocation["VertexID$85", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$85", Automatic, Center], 
          DynamicLocation["VertexID$86", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$86", Automatic, Center], 
          DynamicLocation["VertexID$87", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$87", Automatic, Center], 
          DynamicLocation["VertexID$88", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$88", Automatic, Center], 
          DynamicLocation["VertexID$89", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$89", Automatic, Center], 
          DynamicLocation["VertexID$90", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$90", Automatic, Center], 
          DynamicLocation["VertexID$91", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$91", Automatic, Center], 
          DynamicLocation["VertexID$92", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$92", Automatic, Center], 
          DynamicLocation["VertexID$93", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$93", Automatic, Center], 
          DynamicLocation["VertexID$94", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$94", Automatic, Center], 
          DynamicLocation["VertexID$95", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$95", Automatic, Center], 
          DynamicLocation["VertexID$96", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$96", Automatic, Center], 
          DynamicLocation["VertexID$97", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$97", Automatic, Center], 
          DynamicLocation["VertexID$98", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$98", Automatic, Center], 
          DynamicLocation["VertexID$99", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$99", Automatic, Center], 
          DynamicLocation["VertexID$100", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$100", Automatic, Center], 
          DynamicLocation["VertexID$101", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$101", Automatic, Center], 
          DynamicLocation["VertexID$102", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$102", Automatic, Center], 
          DynamicLocation["VertexID$103", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$103", Automatic, Center], 
          DynamicLocation["VertexID$104", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$104", Automatic, Center], 
          DynamicLocation["VertexID$105", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$105", Automatic, Center], 
          DynamicLocation["VertexID$106", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$106", Automatic, Center], 
          DynamicLocation["VertexID$107", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$107", Automatic, Center], 
          DynamicLocation["VertexID$108", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$108", Automatic, Center], 
          DynamicLocation["VertexID$109", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$109", Automatic, Center], 
          DynamicLocation["VertexID$110", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$110", Automatic, Center], 
          DynamicLocation["VertexID$111", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$111", Automatic, Center], 
          DynamicLocation["VertexID$112", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$112", Automatic, Center], 
          DynamicLocation["VertexID$113", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$113", Automatic, Center], 
          DynamicLocation["VertexID$114", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$114", Automatic, Center], 
          DynamicLocation["VertexID$115", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$115", Automatic, Center], 
          DynamicLocation["VertexID$116", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$116", Automatic, Center], 
          DynamicLocation["VertexID$117", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$117", Automatic, Center], 
          DynamicLocation["VertexID$118", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$118", Automatic, Center], 
          DynamicLocation["VertexID$119", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$119", Automatic, Center], 
          DynamicLocation["VertexID$120", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$120", Automatic, Center], 
          DynamicLocation["VertexID$121", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$121", Automatic, Center], 
          DynamicLocation["VertexID$122", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$122", Automatic, Center], 
          DynamicLocation["VertexID$123", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$123", Automatic, Center], 
          DynamicLocation["VertexID$124", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$124", Automatic, Center], 
          DynamicLocation["VertexID$125", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$125", Automatic, Center], 
          DynamicLocation["VertexID$126", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$126", Automatic, Center], 
          DynamicLocation["VertexID$127", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$127", Automatic, Center], 
          DynamicLocation["VertexID$128", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$128", Automatic, Center], 
          DynamicLocation["VertexID$129", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$129", Automatic, Center], 
          DynamicLocation["VertexID$130", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$130", Automatic, Center], 
          DynamicLocation["VertexID$131", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$131", Automatic, Center], 
          DynamicLocation["VertexID$132", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$132", Automatic, Center], 
          DynamicLocation["VertexID$133", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$133", Automatic, Center], 
          DynamicLocation["VertexID$134", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$134", Automatic, Center], 
          DynamicLocation["VertexID$135", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$135", Automatic, Center], 
          DynamicLocation["VertexID$136", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$136", Automatic, Center], 
          DynamicLocation["VertexID$137", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$137", Automatic, Center], 
          DynamicLocation["VertexID$138", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$138", Automatic, Center], 
          DynamicLocation["VertexID$139", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$139", Automatic, Center], 
          DynamicLocation["VertexID$140", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$140", Automatic, Center], 
          DynamicLocation["VertexID$141", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$141", Automatic, Center], 
          DynamicLocation["VertexID$142", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$142", Automatic, Center], 
          DynamicLocation["VertexID$143", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$143", Automatic, Center], 
          DynamicLocation["VertexID$144", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$144", Automatic, Center], 
          DynamicLocation["VertexID$145", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$145", Automatic, Center], 
          DynamicLocation["VertexID$146", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$146", Automatic, Center], 
          DynamicLocation["VertexID$147", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$147", Automatic, Center], 
          DynamicLocation["VertexID$148", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$148", Automatic, Center], 
          DynamicLocation["VertexID$149", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$149", Automatic, Center], 
          DynamicLocation["VertexID$150", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$150", Automatic, Center], 
          DynamicLocation["VertexID$151", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$151", Automatic, Center], 
          DynamicLocation["VertexID$152", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$152", Automatic, Center], 
          DynamicLocation["VertexID$153", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$153", Automatic, Center], 
          DynamicLocation["VertexID$154", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$154", Automatic, Center], 
          DynamicLocation["VertexID$155", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$155", Automatic, Center], 
          DynamicLocation["VertexID$156", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$156", Automatic, Center], 
          DynamicLocation["VertexID$157", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$157", Automatic, Center], 
          DynamicLocation["VertexID$158", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$158", Automatic, Center], 
          DynamicLocation["VertexID$159", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$159", Automatic, Center], 
          DynamicLocation["VertexID$160", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$160", Automatic, Center], 
          DynamicLocation["VertexID$161", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$161", Automatic, Center], 
          DynamicLocation["VertexID$162", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$162", Automatic, Center], 
          DynamicLocation["VertexID$163", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$163", Automatic, Center], 
          DynamicLocation["VertexID$164", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$164", Automatic, Center], 
          DynamicLocation["VertexID$165", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$165", Automatic, Center], 
          DynamicLocation["VertexID$166", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$166", Automatic, Center], 
          DynamicLocation["VertexID$167", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$167", Automatic, Center], 
          DynamicLocation["VertexID$168", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$168", Automatic, Center], 
          DynamicLocation["VertexID$169", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$169", Automatic, Center], 
          DynamicLocation["VertexID$170", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$170", Automatic, Center], 
          DynamicLocation["VertexID$171", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$171", Automatic, Center], 
          DynamicLocation["VertexID$172", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$172", Automatic, Center], 
          DynamicLocation["VertexID$173", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$173", Automatic, Center], 
          DynamicLocation["VertexID$174", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$174", Automatic, Center], 
          DynamicLocation["VertexID$175", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$175", Automatic, Center], 
          DynamicLocation["VertexID$176", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$176", Automatic, Center], 
          DynamicLocation["VertexID$177", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$177", Automatic, Center], 
          DynamicLocation["VertexID$178", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$178", Automatic, Center], 
          DynamicLocation["VertexID$179", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$179", Automatic, Center], 
          DynamicLocation["VertexID$180", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$180", Automatic, Center], 
          DynamicLocation["VertexID$181", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$181", Automatic, Center], 
          DynamicLocation["VertexID$182", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$182", Automatic, Center], 
          DynamicLocation["VertexID$183", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$183", Automatic, Center], 
          DynamicLocation["VertexID$184", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$184", Automatic, Center], 
          DynamicLocation["VertexID$185", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$185", Automatic, Center], 
          DynamicLocation["VertexID$186", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$186", Automatic, Center], 
          DynamicLocation["VertexID$187", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$187", Automatic, Center], 
          DynamicLocation["VertexID$188", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$188", Automatic, Center], 
          DynamicLocation["VertexID$189", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$189", Automatic, Center], 
          DynamicLocation["VertexID$190", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$190", Automatic, Center], 
          DynamicLocation["VertexID$191", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$191", Automatic, Center], 
          DynamicLocation["VertexID$192", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$192", Automatic, Center], 
          DynamicLocation["VertexID$193", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$193", Automatic, Center], 
          DynamicLocation["VertexID$194", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$194", Automatic, Center], 
          DynamicLocation["VertexID$195", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$195", Automatic, Center], 
          DynamicLocation["VertexID$196", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$196", Automatic, Center], 
          DynamicLocation["VertexID$197", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$197", Automatic, Center], 
          DynamicLocation["VertexID$198", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$198", Automatic, Center], 
          DynamicLocation["VertexID$199", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$199", Automatic, Center], 
          DynamicLocation["VertexID$200", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$200", Automatic, Center], 
          DynamicLocation["VertexID$201", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$201", Automatic, Center], 
          DynamicLocation["VertexID$202", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$202", Automatic, Center], 
          DynamicLocation["VertexID$203", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$203", Automatic, Center], 
          DynamicLocation["VertexID$204", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$204", Automatic, Center], 
          DynamicLocation["VertexID$205", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$205", Automatic, Center], 
          DynamicLocation["VertexID$206", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$206", Automatic, Center], 
          DynamicLocation["VertexID$207", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$207", Automatic, Center], 
          DynamicLocation["VertexID$208", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$208", Automatic, Center], 
          DynamicLocation["VertexID$209", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$209", Automatic, Center], 
          DynamicLocation["VertexID$210", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$210", Automatic, Center], 
          DynamicLocation["VertexID$211", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$211", Automatic, Center], 
          DynamicLocation["VertexID$212", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$212", Automatic, Center], 
          DynamicLocation["VertexID$213", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$213", Automatic, Center], 
          DynamicLocation["VertexID$214", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$214", Automatic, Center], 
          DynamicLocation["VertexID$215", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$215", Automatic, Center], 
          DynamicLocation["VertexID$216", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$216", Automatic, Center], 
          DynamicLocation["VertexID$217", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$217", Automatic, Center], 
          DynamicLocation["VertexID$218", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$218", Automatic, Center], 
          DynamicLocation["VertexID$219", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$219", Automatic, Center], 
          DynamicLocation["VertexID$220", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$220", Automatic, Center], 
          DynamicLocation["VertexID$221", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$221", Automatic, Center], 
          DynamicLocation["VertexID$222", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$222", Automatic, Center], 
          DynamicLocation["VertexID$223", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$223", Automatic, Center], 
          DynamicLocation["VertexID$224", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$224", Automatic, Center], 
          DynamicLocation["VertexID$225", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$225", Automatic, Center], 
          DynamicLocation["VertexID$226", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$226", Automatic, Center], 
          DynamicLocation["VertexID$227", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$227", Automatic, Center], 
          DynamicLocation["VertexID$228", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$228", Automatic, Center], 
          DynamicLocation["VertexID$229", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$229", Automatic, Center], 
          DynamicLocation["VertexID$230", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$230", Automatic, Center], 
          DynamicLocation["VertexID$231", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$231", Automatic, Center], 
          DynamicLocation["VertexID$232", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$232", Automatic, Center], 
          DynamicLocation["VertexID$233", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$233", Automatic, Center], 
          DynamicLocation["VertexID$234", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$234", Automatic, Center], 
          DynamicLocation["VertexID$235", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$235", Automatic, Center], 
          DynamicLocation["VertexID$236", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$236", Automatic, Center], 
          DynamicLocation["VertexID$237", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$237", Automatic, Center], 
          DynamicLocation["VertexID$238", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$238", Automatic, Center], 
          DynamicLocation["VertexID$239", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$239", Automatic, Center], 
          DynamicLocation["VertexID$240", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$240", Automatic, Center], 
          DynamicLocation["VertexID$241", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$241", Automatic, Center], 
          DynamicLocation["VertexID$242", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$242", Automatic, Center], 
          DynamicLocation["VertexID$243", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$243", Automatic, Center], 
          DynamicLocation["VertexID$244", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$244", Automatic, Center], 
          DynamicLocation["VertexID$245", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$245", Automatic, Center], 
          DynamicLocation["VertexID$246", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$246", Automatic, Center], 
          DynamicLocation["VertexID$247", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$247", Automatic, Center], 
          DynamicLocation["VertexID$248", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$248", Automatic, Center], 
          DynamicLocation["VertexID$249", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$249", Automatic, Center], 
          DynamicLocation["VertexID$250", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$250", Automatic, Center], 
          DynamicLocation["VertexID$251", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$251", Automatic, Center], 
          DynamicLocation["VertexID$252", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$252", Automatic, Center], 
          DynamicLocation["VertexID$253", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$253", Automatic, Center], 
          DynamicLocation["VertexID$254", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$254", Automatic, Center], 
          DynamicLocation["VertexID$255", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$255", Automatic, Center], 
          DynamicLocation["VertexID$256", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$256", Automatic, Center], 
          DynamicLocation["VertexID$257", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$257", Automatic, Center], 
          DynamicLocation["VertexID$258", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$258", Automatic, Center], 
          DynamicLocation["VertexID$259", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$259", Automatic, Center], 
          DynamicLocation["VertexID$260", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$260", Automatic, Center], 
          DynamicLocation["VertexID$261", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$261", Automatic, Center], 
          DynamicLocation["VertexID$262", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$262", Automatic, Center], 
          DynamicLocation["VertexID$263", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$263", Automatic, Center], 
          DynamicLocation["VertexID$264", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$264", Automatic, Center], 
          DynamicLocation["VertexID$265", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$265", Automatic, Center], 
          DynamicLocation["VertexID$266", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$266", Automatic, Center], 
          DynamicLocation["VertexID$267", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$267", Automatic, Center], 
          DynamicLocation["VertexID$268", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$268", Automatic, Center], 
          DynamicLocation["VertexID$269", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$269", Automatic, Center], 
          DynamicLocation["VertexID$270", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$270", Automatic, Center], 
          DynamicLocation["VertexID$271", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$271", Automatic, Center], 
          DynamicLocation["VertexID$272", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$272", Automatic, Center], 
          DynamicLocation["VertexID$273", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$273", Automatic, Center], 
          DynamicLocation["VertexID$274", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$274", Automatic, Center], 
          DynamicLocation["VertexID$275", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$275", Automatic, Center], 
          DynamicLocation["VertexID$276", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$276", Automatic, Center], 
          DynamicLocation["VertexID$277", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$277", Automatic, Center], 
          DynamicLocation["VertexID$278", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$278", Automatic, Center], 
          DynamicLocation["VertexID$279", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$279", Automatic, Center], 
          DynamicLocation["VertexID$280", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$280", Automatic, Center], 
          DynamicLocation["VertexID$281", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$281", Automatic, Center], 
          DynamicLocation["VertexID$282", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$282", Automatic, Center], 
          DynamicLocation["VertexID$283", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$283", Automatic, Center], 
          DynamicLocation["VertexID$284", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$284", Automatic, Center], 
          DynamicLocation["VertexID$285", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$285", Automatic, Center], 
          DynamicLocation["VertexID$286", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$286", Automatic, Center], 
          DynamicLocation["VertexID$287", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$287", Automatic, Center], 
          DynamicLocation["VertexID$288", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$288", Automatic, Center], 
          DynamicLocation["VertexID$289", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$289", Automatic, Center], 
          DynamicLocation["VertexID$290", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$290", Automatic, Center], 
          DynamicLocation["VertexID$291", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$291", Automatic, Center], 
          DynamicLocation["VertexID$292", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$292", Automatic, Center], 
          DynamicLocation["VertexID$293", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$293", Automatic, Center], 
          DynamicLocation["VertexID$294", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$294", Automatic, Center], 
          DynamicLocation["VertexID$295", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$295", Automatic, Center], 
          DynamicLocation["VertexID$296", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$296", Automatic, Center], 
          DynamicLocation["VertexID$297", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$297", Automatic, Center], 
          DynamicLocation["VertexID$298", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$298", Automatic, Center], 
          DynamicLocation["VertexID$299", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$299", Automatic, Center], 
          DynamicLocation["VertexID$300", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$300", Automatic, Center], 
          DynamicLocation["VertexID$301", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$301", Automatic, Center], 
          DynamicLocation["VertexID$302", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$302", Automatic, Center], 
          DynamicLocation["VertexID$303", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$303", Automatic, Center], 
          DynamicLocation["VertexID$304", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$304", Automatic, Center], 
          DynamicLocation["VertexID$305", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$305", Automatic, Center], 
          DynamicLocation["VertexID$306", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$306", Automatic, Center], 
          DynamicLocation["VertexID$307", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$307", Automatic, Center], 
          DynamicLocation["VertexID$308", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$308", Automatic, Center], 
          DynamicLocation["VertexID$309", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$309", Automatic, Center], 
          DynamicLocation["VertexID$310", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$310", Automatic, Center], 
          DynamicLocation["VertexID$311", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$311", Automatic, Center], 
          DynamicLocation["VertexID$312", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$312", Automatic, Center], 
          DynamicLocation["VertexID$313", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$313", Automatic, Center], 
          DynamicLocation["VertexID$314", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$314", Automatic, Center], 
          DynamicLocation["VertexID$315", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$315", Automatic, Center], 
          DynamicLocation["VertexID$316", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$316", Automatic, Center], 
          DynamicLocation["VertexID$317", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$317", Automatic, Center], 
          DynamicLocation["VertexID$318", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$318", Automatic, Center], 
          DynamicLocation["VertexID$319", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$319", Automatic, Center], 
          DynamicLocation["VertexID$320", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$320", Automatic, Center], 
          DynamicLocation["VertexID$321", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$321", Automatic, Center], 
          DynamicLocation["VertexID$322", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$322", Automatic, Center], 
          DynamicLocation["VertexID$323", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$323", Automatic, Center], 
          DynamicLocation["VertexID$324", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$324", Automatic, Center], 
          DynamicLocation["VertexID$325", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$325", Automatic, Center], 
          DynamicLocation["VertexID$326", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$326", Automatic, Center], 
          DynamicLocation["VertexID$327", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$327", Automatic, Center], 
          DynamicLocation["VertexID$328", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$328", Automatic, Center], 
          DynamicLocation["VertexID$329", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$329", Automatic, Center], 
          DynamicLocation["VertexID$330", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$330", Automatic, Center], 
          DynamicLocation["VertexID$331", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$331", Automatic, Center], 
          DynamicLocation["VertexID$332", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$332", Automatic, Center], 
          DynamicLocation["VertexID$333", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$333", Automatic, Center], 
          DynamicLocation["VertexID$334", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$334", Automatic, Center], 
          DynamicLocation["VertexID$335", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$335", Automatic, Center], 
          DynamicLocation["VertexID$336", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$336", Automatic, Center], 
          DynamicLocation["VertexID$337", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$337", Automatic, Center], 
          DynamicLocation["VertexID$338", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$338", Automatic, Center], 
          DynamicLocation["VertexID$339", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$339", Automatic, Center], 
          DynamicLocation["VertexID$340", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$340", Automatic, Center], 
          DynamicLocation["VertexID$341", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$341", Automatic, Center], 
          DynamicLocation["VertexID$342", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$342", Automatic, Center], 
          DynamicLocation["VertexID$343", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$343", Automatic, Center], 
          DynamicLocation["VertexID$344", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$344", Automatic, Center], 
          DynamicLocation["VertexID$345", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$345", Automatic, Center], 
          DynamicLocation["VertexID$346", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$346", Automatic, Center], 
          DynamicLocation["VertexID$347", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$347", Automatic, Center], 
          DynamicLocation["VertexID$348", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$348", Automatic, Center], 
          DynamicLocation["VertexID$349", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$349", Automatic, Center], 
          DynamicLocation["VertexID$350", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$350", Automatic, Center], 
          DynamicLocation["VertexID$351", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$351", Automatic, Center], 
          DynamicLocation["VertexID$352", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$352", Automatic, Center], 
          DynamicLocation["VertexID$353", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$353", Automatic, Center], 
          DynamicLocation["VertexID$354", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$354", Automatic, Center], 
          DynamicLocation["VertexID$355", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$355", Automatic, Center], 
          DynamicLocation["VertexID$356", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$356", Automatic, Center], 
          DynamicLocation["VertexID$357", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$357", Automatic, Center], 
          DynamicLocation["VertexID$358", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$358", Automatic, Center], 
          DynamicLocation["VertexID$359", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$359", Automatic, Center], 
          DynamicLocation["VertexID$360", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$360", Automatic, Center], 
          DynamicLocation["VertexID$361", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$361", Automatic, Center], 
          DynamicLocation["VertexID$362", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$362", Automatic, Center], 
          DynamicLocation["VertexID$363", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$363", Automatic, Center], 
          DynamicLocation["VertexID$364", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$364", Automatic, Center], 
          DynamicLocation["VertexID$365", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$365", Automatic, Center], 
          DynamicLocation["VertexID$366", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$366", Automatic, Center], 
          DynamicLocation["VertexID$367", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$367", Automatic, Center], 
          DynamicLocation["VertexID$368", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$368", Automatic, Center], 
          DynamicLocation["VertexID$369", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$369", Automatic, Center], 
          DynamicLocation["VertexID$370", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$370", Automatic, Center], 
          DynamicLocation["VertexID$371", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$371", Automatic, Center], 
          DynamicLocation["VertexID$372", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$372", Automatic, Center], 
          DynamicLocation["VertexID$373", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$373", Automatic, Center], 
          DynamicLocation["VertexID$374", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$374", Automatic, Center], 
          DynamicLocation["VertexID$375", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$375", Automatic, Center], 
          DynamicLocation["VertexID$376", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$376", Automatic, Center], 
          DynamicLocation["VertexID$377", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$377", Automatic, Center], 
          DynamicLocation["VertexID$378", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$378", Automatic, Center], 
          DynamicLocation["VertexID$379", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$379", Automatic, Center], 
          DynamicLocation["VertexID$380", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$380", Automatic, Center], 
          DynamicLocation["VertexID$381", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$381", Automatic, Center], 
          DynamicLocation["VertexID$382", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$382", Automatic, Center], 
          DynamicLocation["VertexID$383", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$383", Automatic, Center], 
          DynamicLocation["VertexID$384", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$384", Automatic, Center], 
          DynamicLocation["VertexID$385", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$385", Automatic, Center], 
          DynamicLocation["VertexID$386", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$386", Automatic, Center], 
          DynamicLocation["VertexID$387", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$387", Automatic, Center], 
          DynamicLocation["VertexID$388", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$388", Automatic, Center], 
          DynamicLocation["VertexID$389", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$389", Automatic, Center], 
          DynamicLocation["VertexID$390", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$390", Automatic, Center], 
          DynamicLocation["VertexID$391", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$391", Automatic, Center], 
          DynamicLocation["VertexID$392", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$392", Automatic, Center], 
          DynamicLocation["VertexID$393", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$393", Automatic, Center], 
          DynamicLocation["VertexID$394", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$394", Automatic, Center], 
          DynamicLocation["VertexID$395", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$395", Automatic, Center], 
          DynamicLocation["VertexID$396", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$396", Automatic, Center], 
          DynamicLocation["VertexID$397", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$397", Automatic, Center], 
          DynamicLocation["VertexID$398", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$398", Automatic, Center], 
          DynamicLocation["VertexID$399", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$399", Automatic, Center], 
          DynamicLocation["VertexID$400", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$400", Automatic, Center], 
          DynamicLocation["VertexID$401", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$401", Automatic, Center], 
          DynamicLocation["VertexID$402", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$402", Automatic, Center], 
          DynamicLocation["VertexID$403", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$403", Automatic, Center], 
          DynamicLocation["VertexID$404", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$404", Automatic, Center], 
          DynamicLocation["VertexID$405", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$405", Automatic, Center], 
          DynamicLocation["VertexID$406", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$406", Automatic, Center], 
          DynamicLocation["VertexID$407", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$407", Automatic, Center], 
          DynamicLocation["VertexID$408", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$408", Automatic, Center], 
          DynamicLocation["VertexID$409", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$409", Automatic, Center], 
          DynamicLocation["VertexID$410", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$410", Automatic, Center], 
          DynamicLocation["VertexID$411", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$411", Automatic, Center], 
          DynamicLocation["VertexID$412", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$412", Automatic, Center], 
          DynamicLocation["VertexID$413", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$413", Automatic, Center], 
          DynamicLocation["VertexID$414", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$414", Automatic, Center], 
          DynamicLocation["VertexID$415", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$415", Automatic, Center], 
          DynamicLocation["VertexID$416", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$416", Automatic, Center], 
          DynamicLocation["VertexID$417", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$417", Automatic, Center], 
          DynamicLocation["VertexID$418", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$418", Automatic, Center], 
          DynamicLocation["VertexID$419", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$419", Automatic, Center], 
          DynamicLocation["VertexID$420", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$420", Automatic, Center], 
          DynamicLocation["VertexID$421", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$421", Automatic, Center], 
          DynamicLocation["VertexID$422", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$422", Automatic, Center], 
          DynamicLocation["VertexID$423", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$423", Automatic, Center], 
          DynamicLocation["VertexID$424", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$424", Automatic, Center], 
          DynamicLocation["VertexID$425", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$425", Automatic, Center], 
          DynamicLocation["VertexID$426", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$426", Automatic, Center], 
          DynamicLocation["VertexID$427", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$427", Automatic, Center], 
          DynamicLocation["VertexID$428", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$428", Automatic, Center], 
          DynamicLocation["VertexID$429", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$429", Automatic, Center], 
          DynamicLocation["VertexID$430", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$430", Automatic, Center], 
          DynamicLocation["VertexID$431", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$431", Automatic, Center], 
          DynamicLocation["VertexID$432", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$432", Automatic, Center], 
          DynamicLocation["VertexID$433", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$433", Automatic, Center], 
          DynamicLocation["VertexID$434", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$434", Automatic, Center], 
          DynamicLocation["VertexID$435", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$435", Automatic, Center], 
          DynamicLocation["VertexID$436", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$436", Automatic, Center], 
          DynamicLocation["VertexID$437", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$437", Automatic, Center], 
          DynamicLocation["VertexID$438", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$438", Automatic, Center], 
          DynamicLocation["VertexID$439", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$439", Automatic, Center], 
          DynamicLocation["VertexID$440", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$440", Automatic, Center], 
          DynamicLocation["VertexID$441", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$441", Automatic, Center], 
          DynamicLocation["VertexID$442", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$442", Automatic, Center], 
          DynamicLocation["VertexID$443", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$443", Automatic, Center], 
          DynamicLocation["VertexID$444", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$444", Automatic, Center], 
          DynamicLocation["VertexID$445", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$445", Automatic, Center], 
          DynamicLocation["VertexID$446", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$446", Automatic, Center], 
          DynamicLocation["VertexID$447", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$447", Automatic, Center], 
          DynamicLocation["VertexID$448", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$448", Automatic, Center], 
          DynamicLocation["VertexID$449", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$449", Automatic, Center], 
          DynamicLocation["VertexID$450", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$450", Automatic, Center], 
          DynamicLocation["VertexID$451", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$451", Automatic, Center], 
          DynamicLocation["VertexID$452", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$452", Automatic, Center], 
          DynamicLocation["VertexID$453", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$453", Automatic, Center], 
          DynamicLocation["VertexID$454", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$454", Automatic, Center], 
          DynamicLocation["VertexID$455", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$455", Automatic, Center], 
          DynamicLocation["VertexID$456", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$456", Automatic, Center], 
          DynamicLocation["VertexID$457", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$457", Automatic, Center], 
          DynamicLocation["VertexID$458", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$458", Automatic, Center], 
          DynamicLocation["VertexID$459", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$459", Automatic, Center], 
          DynamicLocation["VertexID$460", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$460", Automatic, Center], 
          DynamicLocation["VertexID$461", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$461", Automatic, Center], 
          DynamicLocation["VertexID$462", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$462", Automatic, Center], 
          DynamicLocation["VertexID$463", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$463", Automatic, Center], 
          DynamicLocation["VertexID$464", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$464", Automatic, Center], 
          DynamicLocation["VertexID$465", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$465", Automatic, Center], 
          DynamicLocation["VertexID$466", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$466", Automatic, Center], 
          DynamicLocation["VertexID$467", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$467", Automatic, Center], 
          DynamicLocation["VertexID$468", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$468", Automatic, Center], 
          DynamicLocation["VertexID$469", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$469", Automatic, Center], 
          DynamicLocation["VertexID$470", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$470", Automatic, Center], 
          DynamicLocation["VertexID$471", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$471", Automatic, Center], 
          DynamicLocation["VertexID$472", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$472", Automatic, Center], 
          DynamicLocation["VertexID$473", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$473", Automatic, Center], 
          DynamicLocation["VertexID$474", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$474", Automatic, Center], 
          DynamicLocation["VertexID$475", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$475", Automatic, Center], 
          DynamicLocation["VertexID$476", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$476", Automatic, Center], 
          DynamicLocation["VertexID$477", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$477", Automatic, Center], 
          DynamicLocation["VertexID$478", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$478", Automatic, Center], 
          DynamicLocation["VertexID$479", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$479", Automatic, Center], 
          DynamicLocation["VertexID$480", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$480", Automatic, Center], 
          DynamicLocation["VertexID$481", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$481", Automatic, Center], 
          DynamicLocation["VertexID$482", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$482", Automatic, Center], 
          DynamicLocation["VertexID$483", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$483", Automatic, Center], 
          DynamicLocation["VertexID$484", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$484", Automatic, Center], 
          DynamicLocation["VertexID$485", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$485", Automatic, Center], 
          DynamicLocation["VertexID$486", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$486", Automatic, Center], 
          DynamicLocation["VertexID$487", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$487", Automatic, Center], 
          DynamicLocation["VertexID$488", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$488", Automatic, Center], 
          DynamicLocation["VertexID$489", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$489", Automatic, Center], 
          DynamicLocation["VertexID$490", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$490", Automatic, Center], 
          DynamicLocation["VertexID$491", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$491", Automatic, Center], 
          DynamicLocation["VertexID$492", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$492", Automatic, Center], 
          DynamicLocation["VertexID$493", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$493", Automatic, Center], 
          DynamicLocation["VertexID$494", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$494", Automatic, Center], 
          DynamicLocation["VertexID$495", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$495", Automatic, Center], 
          DynamicLocation["VertexID$496", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$496", Automatic, Center], 
          DynamicLocation["VertexID$497", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$497", Automatic, Center], 
          DynamicLocation["VertexID$498", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$498", Automatic, Center], 
          DynamicLocation["VertexID$499", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$499", Automatic, Center], 
          DynamicLocation["VertexID$500", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$500", Automatic, Center], 
          DynamicLocation["VertexID$501", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$501", Automatic, Center], 
          DynamicLocation["VertexID$502", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$502", Automatic, Center], 
          DynamicLocation["VertexID$503", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$503", Automatic, Center], 
          DynamicLocation["VertexID$504", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$504", Automatic, Center], 
          DynamicLocation["VertexID$505", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$505", Automatic, Center], 
          DynamicLocation["VertexID$506", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$506", Automatic, Center], 
          DynamicLocation["VertexID$507", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$507", Automatic, Center], 
          DynamicLocation["VertexID$508", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$508", Automatic, Center], 
          DynamicLocation["VertexID$509", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$509", Automatic, Center], 
          DynamicLocation["VertexID$510", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$510", Automatic, Center], 
          DynamicLocation["VertexID$511", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$511", Automatic, Center], 
          DynamicLocation["VertexID$512", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$512", Automatic, Center], 
          DynamicLocation["VertexID$513", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$513", Automatic, Center], 
          DynamicLocation["VertexID$514", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$514", Automatic, Center], 
          DynamicLocation["VertexID$515", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$515", Automatic, Center], 
          DynamicLocation["VertexID$516", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$516", Automatic, Center], 
          DynamicLocation["VertexID$517", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$517", Automatic, Center], 
          DynamicLocation["VertexID$518", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$518", Automatic, Center], 
          DynamicLocation["VertexID$519", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$519", Automatic, Center], 
          DynamicLocation["VertexID$520", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$520", Automatic, Center], 
          DynamicLocation["VertexID$521", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$521", Automatic, Center], 
          DynamicLocation["VertexID$522", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$522", Automatic, Center], 
          DynamicLocation["VertexID$523", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$523", Automatic, Center], 
          DynamicLocation["VertexID$524", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$524", Automatic, Center], 
          DynamicLocation["VertexID$525", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$525", Automatic, Center], 
          DynamicLocation["VertexID$526", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$526", Automatic, Center], 
          DynamicLocation["VertexID$527", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$527", Automatic, Center], 
          DynamicLocation["VertexID$528", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$528", Automatic, Center], 
          DynamicLocation["VertexID$529", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$529", Automatic, Center], 
          DynamicLocation["VertexID$530", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$530", Automatic, Center], 
          DynamicLocation["VertexID$531", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$531", Automatic, Center], 
          DynamicLocation["VertexID$532", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$532", Automatic, Center], 
          DynamicLocation["VertexID$533", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$533", Automatic, Center], 
          DynamicLocation["VertexID$534", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$534", Automatic, Center], 
          DynamicLocation["VertexID$535", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$535", Automatic, Center], 
          DynamicLocation["VertexID$536", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$536", Automatic, Center], 
          DynamicLocation["VertexID$537", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$537", Automatic, Center], 
          DynamicLocation["VertexID$538", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$538", Automatic, Center], 
          DynamicLocation["VertexID$539", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$539", Automatic, Center], 
          DynamicLocation["VertexID$540", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$540", Automatic, Center], 
          DynamicLocation["VertexID$541", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$541", Automatic, Center], 
          DynamicLocation["VertexID$542", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$542", Automatic, Center], 
          DynamicLocation["VertexID$543", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$543", Automatic, Center], 
          DynamicLocation["VertexID$544", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$544", Automatic, Center], 
          DynamicLocation["VertexID$545", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$545", Automatic, Center], 
          DynamicLocation["VertexID$546", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$546", Automatic, Center], 
          DynamicLocation["VertexID$547", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$547", Automatic, Center], 
          DynamicLocation["VertexID$548", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$548", Automatic, Center], 
          DynamicLocation["VertexID$549", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$549", Automatic, Center], 
          DynamicLocation["VertexID$550", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$550", Automatic, Center], 
          DynamicLocation["VertexID$551", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$551", Automatic, Center], 
          DynamicLocation["VertexID$552", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$552", Automatic, Center], 
          DynamicLocation["VertexID$553", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$553", Automatic, Center], 
          DynamicLocation["VertexID$554", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$554", Automatic, Center], 
          DynamicLocation["VertexID$555", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$555", Automatic, Center], 
          DynamicLocation["VertexID$556", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$556", Automatic, Center], 
          DynamicLocation["VertexID$557", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$557", Automatic, Center], 
          DynamicLocation["VertexID$558", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$558", Automatic, Center], 
          DynamicLocation["VertexID$559", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$559", Automatic, Center], 
          DynamicLocation["VertexID$560", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$560", Automatic, Center], 
          DynamicLocation["VertexID$561", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$561", Automatic, Center], 
          DynamicLocation["VertexID$562", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$562", Automatic, Center], 
          DynamicLocation["VertexID$563", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$563", Automatic, Center], 
          DynamicLocation["VertexID$564", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$564", Automatic, Center], 
          DynamicLocation["VertexID$565", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$565", Automatic, Center], 
          DynamicLocation["VertexID$566", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$566", Automatic, Center], 
          DynamicLocation["VertexID$567", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$567", Automatic, Center], 
          DynamicLocation["VertexID$568", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$568", Automatic, Center], 
          DynamicLocation["VertexID$569", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$569", Automatic, Center], 
          DynamicLocation["VertexID$570", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$570", Automatic, Center], 
          DynamicLocation["VertexID$571", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$571", Automatic, Center], 
          DynamicLocation["VertexID$572", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$572", Automatic, Center], 
          DynamicLocation["VertexID$573", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$573", Automatic, Center], 
          DynamicLocation["VertexID$574", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$574", Automatic, Center], 
          DynamicLocation["VertexID$575", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$575", Automatic, Center], 
          DynamicLocation["VertexID$576", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$576", Automatic, Center], 
          DynamicLocation["VertexID$577", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$577", Automatic, Center], 
          DynamicLocation["VertexID$578", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$578", Automatic, Center], 
          DynamicLocation["VertexID$579", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$579", Automatic, Center], 
          DynamicLocation["VertexID$580", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$580", Automatic, Center], 
          DynamicLocation["VertexID$581", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$581", Automatic, Center], 
          DynamicLocation["VertexID$582", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$582", Automatic, Center], 
          DynamicLocation["VertexID$583", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$583", Automatic, Center], 
          DynamicLocation["VertexID$584", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$584", Automatic, Center], 
          DynamicLocation["VertexID$585", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$585", Automatic, Center], 
          DynamicLocation["VertexID$586", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$586", Automatic, Center], 
          DynamicLocation["VertexID$587", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$587", Automatic, Center], 
          DynamicLocation["VertexID$588", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$588", Automatic, Center], 
          DynamicLocation["VertexID$589", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$589", Automatic, Center], 
          DynamicLocation["VertexID$590", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$590", Automatic, Center], 
          DynamicLocation["VertexID$591", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$591", Automatic, Center], 
          DynamicLocation["VertexID$592", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$592", Automatic, Center], 
          DynamicLocation["VertexID$593", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$593", Automatic, Center], 
          DynamicLocation["VertexID$594", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$594", Automatic, Center], 
          DynamicLocation["VertexID$595", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$595", Automatic, Center], 
          DynamicLocation["VertexID$596", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$596", Automatic, Center], 
          DynamicLocation["VertexID$597", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$597", Automatic, Center], 
          DynamicLocation["VertexID$598", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$598", Automatic, Center], 
          DynamicLocation["VertexID$599", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$599", Automatic, Center], 
          DynamicLocation["VertexID$600", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$600", Automatic, Center], 
          DynamicLocation["VertexID$601", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$601", Automatic, Center], 
          DynamicLocation["VertexID$602", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$602", Automatic, Center], 
          DynamicLocation["VertexID$603", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$603", Automatic, Center], 
          DynamicLocation["VertexID$604", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$604", Automatic, Center], 
          DynamicLocation["VertexID$605", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$605", Automatic, Center], 
          DynamicLocation["VertexID$606", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$606", Automatic, Center], 
          DynamicLocation["VertexID$607", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$607", Automatic, Center], 
          DynamicLocation["VertexID$608", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$608", Automatic, Center], 
          DynamicLocation["VertexID$609", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$609", Automatic, Center], 
          DynamicLocation["VertexID$610", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$610", Automatic, Center], 
          DynamicLocation["VertexID$611", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$611", Automatic, Center], 
          DynamicLocation["VertexID$612", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$612", Automatic, Center], 
          DynamicLocation["VertexID$613", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$613", Automatic, Center], 
          DynamicLocation["VertexID$614", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$614", Automatic, Center], 
          DynamicLocation["VertexID$615", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$615", Automatic, Center], 
          DynamicLocation["VertexID$616", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$616", Automatic, Center], 
          DynamicLocation["VertexID$617", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$617", Automatic, Center], 
          DynamicLocation["VertexID$618", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$618", Automatic, Center], 
          DynamicLocation["VertexID$619", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$619", Automatic, Center], 
          DynamicLocation["VertexID$620", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$620", Automatic, Center], 
          DynamicLocation["VertexID$621", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$621", Automatic, Center], 
          DynamicLocation["VertexID$622", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$622", Automatic, Center], 
          DynamicLocation["VertexID$623", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$623", Automatic, Center], 
          DynamicLocation["VertexID$624", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$624", Automatic, Center], 
          DynamicLocation["VertexID$625", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$625", Automatic, Center], 
          DynamicLocation["VertexID$626", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$626", Automatic, Center], 
          DynamicLocation["VertexID$627", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$627", Automatic, Center], 
          DynamicLocation["VertexID$628", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$628", Automatic, Center], 
          DynamicLocation["VertexID$629", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$629", Automatic, Center], 
          DynamicLocation["VertexID$630", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$630", Automatic, Center], 
          DynamicLocation["VertexID$631", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$631", Automatic, Center], 
          DynamicLocation["VertexID$632", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$632", Automatic, Center], 
          DynamicLocation["VertexID$633", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$633", Automatic, Center], 
          DynamicLocation["VertexID$634", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$634", Automatic, Center], 
          DynamicLocation["VertexID$635", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$635", Automatic, Center], 
          DynamicLocation["VertexID$636", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$636", Automatic, Center], 
          DynamicLocation["VertexID$637", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$637", Automatic, Center], 
          DynamicLocation["VertexID$638", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$638", Automatic, Center], 
          DynamicLocation["VertexID$639", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$639", Automatic, Center], 
          DynamicLocation["VertexID$640", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$640", Automatic, Center], 
          DynamicLocation["VertexID$641", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$641", Automatic, Center], 
          DynamicLocation["VertexID$642", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$642", Automatic, Center], 
          DynamicLocation["VertexID$643", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$643", Automatic, Center], 
          DynamicLocation["VertexID$644", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$644", Automatic, Center], 
          DynamicLocation["VertexID$645", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$645", Automatic, Center], 
          DynamicLocation["VertexID$646", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$646", Automatic, Center], 
          DynamicLocation["VertexID$647", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$647", Automatic, Center], 
          DynamicLocation["VertexID$648", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$648", Automatic, Center], 
          DynamicLocation["VertexID$649", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$649", Automatic, Center], 
          DynamicLocation["VertexID$650", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$650", Automatic, Center], 
          DynamicLocation["VertexID$651", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$651", Automatic, Center], 
          DynamicLocation["VertexID$652", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$652", Automatic, Center], 
          DynamicLocation["VertexID$653", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$653", Automatic, Center], 
          DynamicLocation["VertexID$654", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$654", Automatic, Center], 
          DynamicLocation["VertexID$655", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$655", Automatic, Center], 
          DynamicLocation["VertexID$656", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$656", Automatic, Center], 
          DynamicLocation["VertexID$657", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$657", Automatic, Center], 
          DynamicLocation["VertexID$658", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$658", Automatic, Center], 
          DynamicLocation["VertexID$659", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$659", Automatic, Center], 
          DynamicLocation["VertexID$660", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$660", Automatic, Center], 
          DynamicLocation["VertexID$661", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$661", Automatic, Center], 
          DynamicLocation["VertexID$662", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$662", Automatic, Center], 
          DynamicLocation["VertexID$663", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$663", Automatic, Center], 
          DynamicLocation["VertexID$664", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$664", Automatic, Center], 
          DynamicLocation["VertexID$665", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$665", Automatic, Center], 
          DynamicLocation["VertexID$666", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$666", Automatic, Center], 
          DynamicLocation["VertexID$667", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$667", Automatic, Center], 
          DynamicLocation["VertexID$668", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$668", Automatic, Center], 
          DynamicLocation["VertexID$669", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$669", Automatic, Center], 
          DynamicLocation["VertexID$670", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$670", Automatic, Center], 
          DynamicLocation["VertexID$671", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$671", Automatic, Center], 
          DynamicLocation["VertexID$672", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$672", Automatic, Center], 
          DynamicLocation["VertexID$673", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$673", Automatic, Center], 
          DynamicLocation["VertexID$674", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$674", Automatic, Center], 
          DynamicLocation["VertexID$675", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$675", Automatic, Center], 
          DynamicLocation["VertexID$676", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$676", Automatic, Center], 
          DynamicLocation["VertexID$677", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$677", Automatic, Center], 
          DynamicLocation["VertexID$678", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$678", Automatic, Center], 
          DynamicLocation["VertexID$679", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$679", Automatic, Center], 
          DynamicLocation["VertexID$680", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$680", Automatic, Center], 
          DynamicLocation["VertexID$681", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$681", Automatic, Center], 
          DynamicLocation["VertexID$682", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$682", Automatic, Center], 
          DynamicLocation["VertexID$683", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$683", Automatic, Center], 
          DynamicLocation["VertexID$684", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$684", Automatic, Center], 
          DynamicLocation["VertexID$685", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$685", Automatic, Center], 
          DynamicLocation["VertexID$686", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$686", Automatic, Center], 
          DynamicLocation["VertexID$687", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$687", Automatic, Center], 
          DynamicLocation["VertexID$688", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$688", Automatic, Center], 
          DynamicLocation["VertexID$689", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$689", Automatic, Center], 
          DynamicLocation["VertexID$690", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$690", Automatic, Center], 
          DynamicLocation["VertexID$691", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$691", Automatic, Center], 
          DynamicLocation["VertexID$692", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$692", Automatic, Center], 
          DynamicLocation["VertexID$693", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$693", Automatic, Center], 
          DynamicLocation["VertexID$694", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$694", Automatic, Center], 
          DynamicLocation["VertexID$695", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$695", Automatic, Center], 
          DynamicLocation["VertexID$696", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$696", Automatic, Center], 
          DynamicLocation["VertexID$697", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$697", Automatic, Center], 
          DynamicLocation["VertexID$698", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$698", Automatic, Center], 
          DynamicLocation["VertexID$699", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$699", Automatic, Center], 
          DynamicLocation["VertexID$700", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$700", Automatic, Center], 
          DynamicLocation["VertexID$701", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$701", Automatic, Center], 
          DynamicLocation["VertexID$702", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$702", Automatic, Center], 
          DynamicLocation["VertexID$703", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$703", Automatic, Center], 
          DynamicLocation["VertexID$704", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$704", Automatic, Center], 
          DynamicLocation["VertexID$705", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$705", Automatic, Center], 
          DynamicLocation["VertexID$706", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$706", Automatic, Center], 
          DynamicLocation["VertexID$707", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$707", Automatic, Center], 
          DynamicLocation["VertexID$708", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$708", Automatic, Center], 
          DynamicLocation["VertexID$709", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$709", Automatic, Center], 
          DynamicLocation["VertexID$710", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$710", Automatic, Center], 
          DynamicLocation["VertexID$711", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$711", Automatic, Center], 
          DynamicLocation["VertexID$712", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$712", Automatic, Center], 
          DynamicLocation["VertexID$713", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$713", Automatic, Center], 
          DynamicLocation["VertexID$714", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$714", Automatic, Center], 
          DynamicLocation["VertexID$715", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$715", Automatic, Center], 
          DynamicLocation["VertexID$716", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$716", Automatic, Center], 
          DynamicLocation["VertexID$717", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$717", Automatic, Center], 
          DynamicLocation["VertexID$718", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$718", Automatic, Center], 
          DynamicLocation["VertexID$719", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$719", Automatic, Center], 
          DynamicLocation["VertexID$720", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$720", Automatic, Center], 
          DynamicLocation["VertexID$721", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$721", Automatic, Center], 
          DynamicLocation["VertexID$722", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$722", Automatic, Center], 
          DynamicLocation["VertexID$723", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$723", Automatic, Center], 
          DynamicLocation["VertexID$724", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$724", Automatic, Center], 
          DynamicLocation["VertexID$725", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$725", Automatic, Center], 
          DynamicLocation["VertexID$726", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$726", Automatic, Center], 
          DynamicLocation["VertexID$727", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$727", Automatic, Center], 
          DynamicLocation["VertexID$728", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$728", Automatic, Center], 
          DynamicLocation["VertexID$729", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$729", Automatic, Center], 
          DynamicLocation["VertexID$730", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$730", Automatic, Center], 
          DynamicLocation["VertexID$731", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$731", Automatic, Center], 
          DynamicLocation["VertexID$732", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$732", Automatic, Center], 
          DynamicLocation["VertexID$733", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$733", Automatic, Center], 
          DynamicLocation["VertexID$734", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$734", Automatic, Center], 
          DynamicLocation["VertexID$735", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$735", Automatic, Center], 
          DynamicLocation["VertexID$736", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$736", Automatic, Center], 
          DynamicLocation["VertexID$737", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$737", Automatic, Center], 
          DynamicLocation["VertexID$738", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$738", Automatic, Center], 
          DynamicLocation["VertexID$739", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$739", Automatic, Center], 
          DynamicLocation["VertexID$740", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$740", Automatic, Center], 
          DynamicLocation["VertexID$741", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$741", Automatic, Center], 
          DynamicLocation["VertexID$742", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$742", Automatic, Center], 
          DynamicLocation["VertexID$743", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$743", Automatic, Center], 
          DynamicLocation["VertexID$744", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$744", Automatic, Center], 
          DynamicLocation["VertexID$745", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$745", Automatic, Center], 
          DynamicLocation["VertexID$746", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$746", Automatic, Center], 
          DynamicLocation["VertexID$747", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$747", Automatic, Center], 
          DynamicLocation["VertexID$748", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$748", Automatic, Center], 
          DynamicLocation["VertexID$749", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$749", Automatic, Center], 
          DynamicLocation["VertexID$750", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$750", Automatic, Center], 
          DynamicLocation["VertexID$751", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$751", Automatic, Center], 
          DynamicLocation["VertexID$752", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$752", Automatic, Center], 
          DynamicLocation["VertexID$753", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$753", Automatic, Center], 
          DynamicLocation["VertexID$754", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$754", Automatic, Center], 
          DynamicLocation["VertexID$755", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$755", Automatic, Center], 
          DynamicLocation["VertexID$756", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$756", Automatic, Center], 
          DynamicLocation["VertexID$757", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$757", Automatic, Center], 
          DynamicLocation["VertexID$758", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$758", Automatic, Center], 
          DynamicLocation["VertexID$759", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$759", Automatic, Center], 
          DynamicLocation["VertexID$760", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$760", Automatic, Center], 
          DynamicLocation["VertexID$761", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$761", Automatic, Center], 
          DynamicLocation["VertexID$762", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$762", Automatic, Center], 
          DynamicLocation["VertexID$763", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$763", Automatic, Center], 
          DynamicLocation["VertexID$764", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$764", Automatic, Center], 
          DynamicLocation["VertexID$765", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$765", Automatic, Center], 
          DynamicLocation["VertexID$766", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$766", Automatic, Center], 
          DynamicLocation["VertexID$767", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$767", Automatic, Center], 
          DynamicLocation["VertexID$768", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$768", Automatic, Center], 
          DynamicLocation["VertexID$769", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$769", Automatic, Center], 
          DynamicLocation["VertexID$770", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$770", Automatic, Center], 
          DynamicLocation["VertexID$771", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$771", Automatic, Center], 
          DynamicLocation["VertexID$772", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$772", Automatic, Center], 
          DynamicLocation["VertexID$773", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$773", Automatic, Center], 
          DynamicLocation["VertexID$774", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$774", Automatic, Center], 
          DynamicLocation["VertexID$775", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$775", Automatic, Center], 
          DynamicLocation["VertexID$776", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$776", Automatic, Center], 
          DynamicLocation["VertexID$777", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$777", Automatic, Center], 
          DynamicLocation["VertexID$778", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$778", Automatic, Center], 
          DynamicLocation["VertexID$779", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$779", Automatic, Center], 
          DynamicLocation["VertexID$780", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$780", Automatic, Center], 
          DynamicLocation["VertexID$781", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$781", Automatic, Center], 
          DynamicLocation["VertexID$782", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$782", Automatic, Center], 
          DynamicLocation["VertexID$783", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$783", Automatic, Center], 
          DynamicLocation["VertexID$784", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$784", Automatic, Center], 
          DynamicLocation["VertexID$785", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$785", Automatic, Center], 
          DynamicLocation["VertexID$786", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$786", Automatic, Center], 
          DynamicLocation["VertexID$787", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$787", Automatic, Center], 
          DynamicLocation["VertexID$788", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$788", Automatic, Center], 
          DynamicLocation["VertexID$789", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$789", Automatic, Center], 
          DynamicLocation["VertexID$790", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$790", Automatic, Center], 
          DynamicLocation["VertexID$791", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$791", Automatic, Center], 
          DynamicLocation["VertexID$792", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$792", Automatic, Center], 
          DynamicLocation["VertexID$793", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$793", Automatic, Center], 
          DynamicLocation["VertexID$794", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$794", Automatic, Center], 
          DynamicLocation["VertexID$795", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$795", Automatic, Center], 
          DynamicLocation["VertexID$796", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$796", Automatic, Center], 
          DynamicLocation["VertexID$797", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$797", Automatic, Center], 
          DynamicLocation["VertexID$798", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$798", Automatic, Center], 
          DynamicLocation["VertexID$799", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$799", Automatic, Center], 
          DynamicLocation["VertexID$800", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$800", Automatic, Center], 
          DynamicLocation["VertexID$801", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$801", Automatic, Center], 
          DynamicLocation["VertexID$802", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$802", Automatic, Center], 
          DynamicLocation["VertexID$803", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$803", Automatic, Center], 
          DynamicLocation["VertexID$804", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$804", Automatic, Center], 
          DynamicLocation["VertexID$805", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$805", Automatic, Center], 
          DynamicLocation["VertexID$806", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$806", Automatic, Center], 
          DynamicLocation["VertexID$807", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$807", Automatic, Center], 
          DynamicLocation["VertexID$808", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$808", Automatic, Center], 
          DynamicLocation["VertexID$809", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$809", Automatic, Center], 
          DynamicLocation["VertexID$810", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$810", Automatic, Center], 
          DynamicLocation["VertexID$811", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$811", Automatic, Center], 
          DynamicLocation["VertexID$812", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$812", Automatic, Center], 
          DynamicLocation["VertexID$813", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$813", Automatic, Center], 
          DynamicLocation["VertexID$814", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$814", Automatic, Center], 
          DynamicLocation["VertexID$815", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$815", Automatic, Center], 
          DynamicLocation["VertexID$816", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$816", Automatic, Center], 
          DynamicLocation["VertexID$817", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$817", Automatic, Center], 
          DynamicLocation["VertexID$818", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$818", Automatic, Center], 
          DynamicLocation["VertexID$819", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$819", Automatic, Center], 
          DynamicLocation["VertexID$820", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$820", Automatic, Center], 
          DynamicLocation["VertexID$821", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$821", Automatic, Center], 
          DynamicLocation["VertexID$822", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$822", Automatic, Center], 
          DynamicLocation["VertexID$823", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$823", Automatic, Center], 
          DynamicLocation["VertexID$824", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$824", Automatic, Center], 
          DynamicLocation["VertexID$825", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$825", Automatic, Center], 
          DynamicLocation["VertexID$826", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$826", Automatic, Center], 
          DynamicLocation["VertexID$827", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$827", Automatic, Center], 
          DynamicLocation["VertexID$828", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$828", Automatic, Center], 
          DynamicLocation["VertexID$829", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$829", Automatic, Center], 
          DynamicLocation["VertexID$830", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$830", Automatic, Center], 
          DynamicLocation["VertexID$831", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$831", Automatic, Center], 
          DynamicLocation["VertexID$832", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$832", Automatic, Center], 
          DynamicLocation["VertexID$833", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$833", Automatic, Center], 
          DynamicLocation["VertexID$834", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$834", Automatic, Center], 
          DynamicLocation["VertexID$835", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$835", Automatic, Center], 
          DynamicLocation["VertexID$836", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$836", Automatic, Center], 
          DynamicLocation["VertexID$837", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$837", Automatic, Center], 
          DynamicLocation["VertexID$838", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$838", Automatic, Center], 
          DynamicLocation["VertexID$839", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$839", Automatic, Center], 
          DynamicLocation["VertexID$840", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$840", Automatic, Center], 
          DynamicLocation["VertexID$841", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$841", Automatic, Center], 
          DynamicLocation["VertexID$842", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$842", Automatic, Center], 
          DynamicLocation["VertexID$843", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$843", Automatic, Center], 
          DynamicLocation["VertexID$844", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$844", Automatic, Center], 
          DynamicLocation["VertexID$845", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$845", Automatic, Center], 
          DynamicLocation["VertexID$846", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$846", Automatic, Center], 
          DynamicLocation["VertexID$847", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$847", Automatic, Center], 
          DynamicLocation["VertexID$848", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$848", Automatic, Center], 
          DynamicLocation["VertexID$849", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$849", Automatic, Center], 
          DynamicLocation["VertexID$850", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$850", Automatic, Center], 
          DynamicLocation["VertexID$851", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$851", Automatic, Center], 
          DynamicLocation["VertexID$852", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$852", Automatic, Center], 
          DynamicLocation["VertexID$853", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$853", Automatic, Center], 
          DynamicLocation["VertexID$854", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$854", Automatic, Center], 
          DynamicLocation["VertexID$855", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$855", Automatic, Center], 
          DynamicLocation["VertexID$856", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$856", Automatic, Center], 
          DynamicLocation["VertexID$857", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$857", Automatic, Center], 
          DynamicLocation["VertexID$858", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$858", Automatic, Center], 
          DynamicLocation["VertexID$859", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$859", Automatic, Center], 
          DynamicLocation["VertexID$860", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$860", Automatic, Center], 
          DynamicLocation["VertexID$861", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$861", Automatic, Center], 
          DynamicLocation["VertexID$862", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$862", Automatic, Center], 
          DynamicLocation["VertexID$863", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$863", Automatic, Center], 
          DynamicLocation["VertexID$864", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$864", Automatic, Center], 
          DynamicLocation["VertexID$865", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$865", Automatic, Center], 
          DynamicLocation["VertexID$866", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$866", Automatic, Center], 
          DynamicLocation["VertexID$867", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$867", Automatic, Center], 
          DynamicLocation["VertexID$868", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$868", Automatic, Center], 
          DynamicLocation["VertexID$869", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$869", Automatic, Center], 
          DynamicLocation["VertexID$870", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$870", Automatic, Center], 
          DynamicLocation["VertexID$871", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$871", Automatic, Center], 
          DynamicLocation["VertexID$872", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$872", Automatic, Center], 
          DynamicLocation["VertexID$873", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$873", Automatic, Center], 
          DynamicLocation["VertexID$874", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$874", Automatic, Center], 
          DynamicLocation["VertexID$875", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$875", Automatic, Center], 
          DynamicLocation["VertexID$876", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$876", Automatic, Center], 
          DynamicLocation["VertexID$877", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$877", Automatic, Center], 
          DynamicLocation["VertexID$878", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$878", Automatic, Center], 
          DynamicLocation["VertexID$879", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$879", Automatic, Center], 
          DynamicLocation["VertexID$880", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$880", Automatic, Center], 
          DynamicLocation["VertexID$881", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$881", Automatic, Center], 
          DynamicLocation["VertexID$882", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$882", Automatic, Center], 
          DynamicLocation["VertexID$883", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$883", Automatic, Center], 
          DynamicLocation["VertexID$884", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$884", Automatic, Center], 
          DynamicLocation["VertexID$885", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$885", Automatic, Center], 
          DynamicLocation["VertexID$886", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$886", Automatic, Center], 
          DynamicLocation["VertexID$887", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$887", Automatic, Center], 
          DynamicLocation["VertexID$888", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$888", Automatic, Center], 
          DynamicLocation["VertexID$889", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$889", Automatic, Center], 
          DynamicLocation["VertexID$890", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$890", Automatic, Center], 
          DynamicLocation["VertexID$891", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$891", Automatic, Center], 
          DynamicLocation["VertexID$892", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$892", Automatic, Center], 
          DynamicLocation["VertexID$893", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$893", Automatic, Center], 
          DynamicLocation["VertexID$894", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$894", Automatic, Center], 
          DynamicLocation["VertexID$895", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$895", Automatic, Center], 
          DynamicLocation["VertexID$896", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$896", Automatic, Center], 
          DynamicLocation["VertexID$897", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$897", Automatic, Center], 
          DynamicLocation["VertexID$898", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$898", Automatic, Center], 
          DynamicLocation["VertexID$899", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$899", Automatic, Center], 
          DynamicLocation["VertexID$900", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$900", Automatic, Center], 
          DynamicLocation["VertexID$901", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$901", Automatic, Center], 
          DynamicLocation["VertexID$902", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$902", Automatic, Center], 
          DynamicLocation["VertexID$903", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$903", Automatic, Center], 
          DynamicLocation["VertexID$904", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$904", Automatic, Center], 
          DynamicLocation["VertexID$905", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$905", Automatic, Center], 
          DynamicLocation["VertexID$906", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$906", Automatic, Center], 
          DynamicLocation["VertexID$907", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$907", Automatic, Center], 
          DynamicLocation["VertexID$908", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$908", Automatic, Center], 
          DynamicLocation["VertexID$909", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$909", Automatic, Center], 
          DynamicLocation["VertexID$910", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$910", Automatic, Center], 
          DynamicLocation["VertexID$911", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$911", Automatic, Center], 
          DynamicLocation["VertexID$912", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$912", Automatic, Center], 
          DynamicLocation["VertexID$913", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$913", Automatic, Center], 
          DynamicLocation["VertexID$914", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$914", Automatic, Center], 
          DynamicLocation["VertexID$915", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$915", Automatic, Center], 
          DynamicLocation["VertexID$916", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$916", Automatic, Center], 
          DynamicLocation["VertexID$917", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$917", Automatic, Center], 
          DynamicLocation["VertexID$918", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$918", Automatic, Center], 
          DynamicLocation["VertexID$919", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$919", Automatic, Center], 
          DynamicLocation["VertexID$920", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$920", Automatic, Center], 
          DynamicLocation["VertexID$921", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$921", Automatic, Center], 
          DynamicLocation["VertexID$922", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$922", Automatic, Center], 
          DynamicLocation["VertexID$923", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$923", Automatic, Center], 
          DynamicLocation["VertexID$924", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$924", Automatic, Center], 
          DynamicLocation["VertexID$925", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$925", Automatic, Center], 
          DynamicLocation["VertexID$926", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$926", Automatic, Center], 
          DynamicLocation["VertexID$927", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$927", Automatic, Center], 
          DynamicLocation["VertexID$928", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$928", Automatic, Center], 
          DynamicLocation["VertexID$929", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$929", Automatic, Center], 
          DynamicLocation["VertexID$930", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$930", Automatic, Center], 
          DynamicLocation["VertexID$931", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$931", Automatic, Center], 
          DynamicLocation["VertexID$932", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$932", Automatic, Center], 
          DynamicLocation["VertexID$933", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$933", Automatic, Center], 
          DynamicLocation["VertexID$934", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$934", Automatic, Center], 
          DynamicLocation["VertexID$935", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$935", Automatic, Center], 
          DynamicLocation["VertexID$936", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$936", Automatic, Center], 
          DynamicLocation["VertexID$937", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$937", Automatic, Center], 
          DynamicLocation["VertexID$938", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$938", Automatic, Center], 
          DynamicLocation["VertexID$939", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$939", Automatic, Center], 
          DynamicLocation["VertexID$940", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$940", Automatic, Center], 
          DynamicLocation["VertexID$941", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$941", Automatic, Center], 
          DynamicLocation["VertexID$942", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$942", Automatic, Center], 
          DynamicLocation["VertexID$943", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$943", Automatic, Center], 
          DynamicLocation["VertexID$944", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$944", Automatic, Center], 
          DynamicLocation["VertexID$945", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$945", Automatic, Center], 
          DynamicLocation["VertexID$946", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$946", Automatic, Center], 
          DynamicLocation["VertexID$947", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$947", Automatic, Center], 
          DynamicLocation["VertexID$948", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$948", Automatic, Center], 
          DynamicLocation["VertexID$949", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$949", Automatic, Center], 
          DynamicLocation["VertexID$950", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$950", Automatic, Center], 
          DynamicLocation["VertexID$951", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$951", Automatic, Center], 
          DynamicLocation["VertexID$952", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$952", Automatic, Center], 
          DynamicLocation["VertexID$953", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$953", Automatic, Center], 
          DynamicLocation["VertexID$954", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$954", Automatic, Center], 
          DynamicLocation["VertexID$955", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$955", Automatic, Center], 
          DynamicLocation["VertexID$956", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$956", Automatic, Center], 
          DynamicLocation["VertexID$957", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$957", Automatic, Center], 
          DynamicLocation["VertexID$958", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$958", Automatic, Center], 
          DynamicLocation["VertexID$959", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$959", Automatic, Center], 
          DynamicLocation["VertexID$960", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$960", Automatic, Center], 
          DynamicLocation["VertexID$961", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$961", Automatic, Center], 
          DynamicLocation["VertexID$962", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$962", Automatic, Center], 
          DynamicLocation["VertexID$963", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$963", Automatic, Center], 
          DynamicLocation["VertexID$964", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$964", Automatic, Center], 
          DynamicLocation["VertexID$965", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$965", Automatic, Center], 
          DynamicLocation["VertexID$966", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$966", Automatic, Center], 
          DynamicLocation["VertexID$967", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$967", Automatic, Center], 
          DynamicLocation["VertexID$968", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$968", Automatic, Center], 
          DynamicLocation["VertexID$969", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$969", Automatic, Center], 
          DynamicLocation["VertexID$970", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$970", Automatic, Center], 
          DynamicLocation["VertexID$971", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$971", Automatic, Center], 
          DynamicLocation["VertexID$972", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$972", Automatic, Center], 
          DynamicLocation["VertexID$973", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$973", Automatic, Center], 
          DynamicLocation["VertexID$974", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$974", Automatic, Center], 
          DynamicLocation["VertexID$975", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$975", Automatic, Center], 
          DynamicLocation["VertexID$976", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$976", Automatic, Center], 
          DynamicLocation["VertexID$977", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$977", Automatic, Center], 
          DynamicLocation["VertexID$978", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$978", Automatic, Center], 
          DynamicLocation["VertexID$979", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$979", Automatic, Center], 
          DynamicLocation["VertexID$980", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$980", Automatic, Center], 
          DynamicLocation["VertexID$981", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$981", Automatic, Center], 
          DynamicLocation["VertexID$982", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$982", Automatic, Center], 
          DynamicLocation["VertexID$983", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$983", Automatic, Center], 
          DynamicLocation["VertexID$984", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$984", Automatic, Center], 
          DynamicLocation["VertexID$985", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$985", Automatic, Center], 
          DynamicLocation["VertexID$986", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$986", Automatic, Center], 
          DynamicLocation["VertexID$987", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$987", Automatic, Center], 
          DynamicLocation["VertexID$988", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$988", Automatic, Center], 
          DynamicLocation["VertexID$989", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$989", Automatic, Center], 
          DynamicLocation["VertexID$990", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$990", Automatic, Center], 
          DynamicLocation["VertexID$991", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$991", Automatic, Center], 
          DynamicLocation["VertexID$992", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$992", Automatic, Center], 
          DynamicLocation["VertexID$993", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$993", Automatic, Center], 
          DynamicLocation["VertexID$994", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$994", Automatic, Center], 
          DynamicLocation["VertexID$995", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$995", Automatic, Center], 
          DynamicLocation["VertexID$996", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$996", Automatic, Center], 
          DynamicLocation["VertexID$997", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$997", Automatic, Center], 
          DynamicLocation["VertexID$998", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$998", Automatic, Center], 
          DynamicLocation["VertexID$999", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$999", Automatic, Center], 
          DynamicLocation["VertexID$1000", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1000", Automatic, Center], 
          DynamicLocation["VertexID$1001", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1001", Automatic, Center], 
          DynamicLocation["VertexID$1002", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1002", Automatic, Center], 
          DynamicLocation["VertexID$1003", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1003", Automatic, Center], 
          DynamicLocation["VertexID$1004", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1004", Automatic, Center], 
          DynamicLocation["VertexID$1005", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1005", Automatic, Center], 
          DynamicLocation["VertexID$1006", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1006", Automatic, Center], 
          DynamicLocation["VertexID$1007", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1007", Automatic, Center], 
          DynamicLocation["VertexID$1008", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1008", Automatic, Center], 
          DynamicLocation["VertexID$1009", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1009", Automatic, Center], 
          DynamicLocation["VertexID$1010", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1010", Automatic, Center], 
          DynamicLocation["VertexID$1011", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1011", Automatic, Center], 
          DynamicLocation["VertexID$1012", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1012", Automatic, Center], 
          DynamicLocation["VertexID$1013", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1013", Automatic, Center], 
          DynamicLocation["VertexID$1014", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1014", Automatic, Center], 
          DynamicLocation["VertexID$1015", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1015", Automatic, Center], 
          DynamicLocation["VertexID$1016", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1016", Automatic, Center], 
          DynamicLocation["VertexID$1017", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1017", Automatic, Center], 
          DynamicLocation["VertexID$1018", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1018", Automatic, Center], 
          DynamicLocation["VertexID$1019", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1019", Automatic, Center], 
          DynamicLocation["VertexID$1020", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1020", Automatic, Center], 
          DynamicLocation["VertexID$1021", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1021", Automatic, Center], 
          DynamicLocation["VertexID$1022", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1022", Automatic, Center], 
          DynamicLocation["VertexID$1023", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1023", Automatic, Center], 
          DynamicLocation["VertexID$1024", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1024", Automatic, Center], 
          DynamicLocation["VertexID$1025", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1025", Automatic, Center], 
          DynamicLocation["VertexID$1026", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1026", Automatic, Center], 
          DynamicLocation["VertexID$1027", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1027", Automatic, Center], 
          DynamicLocation["VertexID$1028", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1028", Automatic, Center], 
          DynamicLocation["VertexID$1029", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1029", Automatic, Center], 
          DynamicLocation["VertexID$1030", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1030", Automatic, Center], 
          DynamicLocation["VertexID$1031", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1031", Automatic, Center], 
          DynamicLocation["VertexID$1032", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1032", Automatic, Center], 
          DynamicLocation["VertexID$1033", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1033", Automatic, Center], 
          DynamicLocation["VertexID$1034", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1034", Automatic, Center], 
          DynamicLocation["VertexID$1035", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1035", Automatic, Center], 
          DynamicLocation["VertexID$1036", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1036", Automatic, Center], 
          DynamicLocation["VertexID$1037", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1037", Automatic, Center], 
          DynamicLocation["VertexID$1038", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1038", Automatic, Center], 
          DynamicLocation["VertexID$1039", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1039", Automatic, Center], 
          DynamicLocation["VertexID$1040", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1040", Automatic, Center], 
          DynamicLocation["VertexID$1041", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1041", Automatic, Center], 
          DynamicLocation["VertexID$1042", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1042", Automatic, Center], 
          DynamicLocation["VertexID$1043", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1043", Automatic, Center], 
          DynamicLocation["VertexID$1044", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1044", Automatic, Center], 
          DynamicLocation["VertexID$1045", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1045", Automatic, Center], 
          DynamicLocation["VertexID$1046", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1046", Automatic, Center], 
          DynamicLocation["VertexID$1047", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1047", Automatic, Center], 
          DynamicLocation["VertexID$1048", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1048", Automatic, Center], 
          DynamicLocation["VertexID$1049", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1049", Automatic, Center], 
          DynamicLocation["VertexID$1050", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1050", Automatic, Center], 
          DynamicLocation["VertexID$1051", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1051", Automatic, Center], 
          DynamicLocation["VertexID$1052", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1052", Automatic, Center], 
          DynamicLocation["VertexID$1053", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1053", Automatic, Center], 
          DynamicLocation["VertexID$1054", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1054", Automatic, Center], 
          DynamicLocation["VertexID$1055", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1055", Automatic, Center], 
          DynamicLocation["VertexID$1056", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1056", Automatic, Center], 
          DynamicLocation["VertexID$1057", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1057", Automatic, Center], 
          DynamicLocation["VertexID$1058", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1058", Automatic, Center], 
          DynamicLocation["VertexID$1059", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1059", Automatic, Center], 
          DynamicLocation["VertexID$1060", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1060", Automatic, Center], 
          DynamicLocation["VertexID$1061", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1061", Automatic, Center], 
          DynamicLocation["VertexID$1062", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1062", Automatic, Center], 
          DynamicLocation["VertexID$1063", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1063", Automatic, Center], 
          DynamicLocation["VertexID$1064", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1064", Automatic, Center], 
          DynamicLocation["VertexID$1065", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1065", Automatic, Center], 
          DynamicLocation["VertexID$1066", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1066", Automatic, Center], 
          DynamicLocation["VertexID$1067", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1067", Automatic, Center], 
          DynamicLocation["VertexID$1068", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1068", Automatic, Center], 
          DynamicLocation["VertexID$1069", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1069", Automatic, Center], 
          DynamicLocation["VertexID$1070", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1070", Automatic, Center], 
          DynamicLocation["VertexID$1071", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1071", Automatic, Center], 
          DynamicLocation["VertexID$1072", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1072", Automatic, Center], 
          DynamicLocation["VertexID$1073", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1073", Automatic, Center], 
          DynamicLocation["VertexID$1074", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1074", Automatic, Center], 
          DynamicLocation["VertexID$1075", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1075", Automatic, Center], 
          DynamicLocation["VertexID$1076", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1076", Automatic, Center], 
          DynamicLocation["VertexID$1077", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1077", Automatic, Center], 
          DynamicLocation["VertexID$1078", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1078", Automatic, Center], 
          DynamicLocation["VertexID$1079", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1079", Automatic, Center], 
          DynamicLocation["VertexID$1080", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1080", Automatic, Center], 
          DynamicLocation["VertexID$1081", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1081", Automatic, Center], 
          DynamicLocation["VertexID$1082", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1082", Automatic, Center], 
          DynamicLocation["VertexID$1083", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1083", Automatic, Center], 
          DynamicLocation["VertexID$1084", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1084", Automatic, Center], 
          DynamicLocation["VertexID$1085", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1085", Automatic, Center], 
          DynamicLocation["VertexID$1086", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1086", Automatic, Center], 
          DynamicLocation["VertexID$1087", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1087", Automatic, Center], 
          DynamicLocation["VertexID$1088", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1088", Automatic, Center], 
          DynamicLocation["VertexID$1089", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1089", Automatic, Center], 
          DynamicLocation["VertexID$1090", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1090", Automatic, Center], 
          DynamicLocation["VertexID$1091", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1091", Automatic, Center], 
          DynamicLocation["VertexID$1092", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1092", Automatic, Center], 
          DynamicLocation["VertexID$1093", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1093", Automatic, Center], 
          DynamicLocation["VertexID$1094", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1094", Automatic, Center], 
          DynamicLocation["VertexID$1095", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1095", Automatic, Center], 
          DynamicLocation["VertexID$1096", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1096", Automatic, Center], 
          DynamicLocation["VertexID$1097", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1097", Automatic, Center], 
          DynamicLocation["VertexID$1098", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1098", Automatic, Center], 
          DynamicLocation["VertexID$1099", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1099", Automatic, Center], 
          DynamicLocation["VertexID$1100", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1100", Automatic, Center], 
          DynamicLocation["VertexID$1101", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1101", Automatic, Center], 
          DynamicLocation["VertexID$1102", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1102", Automatic, Center], 
          DynamicLocation["VertexID$1103", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1103", Automatic, Center], 
          DynamicLocation["VertexID$1104", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1104", Automatic, Center], 
          DynamicLocation["VertexID$1105", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1105", Automatic, Center], 
          DynamicLocation["VertexID$1106", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1106", Automatic, Center], 
          DynamicLocation["VertexID$1107", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1107", Automatic, Center], 
          DynamicLocation["VertexID$1108", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1108", Automatic, Center], 
          DynamicLocation["VertexID$1109", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1109", Automatic, Center], 
          DynamicLocation["VertexID$1110", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1110", Automatic, Center], 
          DynamicLocation["VertexID$1111", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1111", Automatic, Center], 
          DynamicLocation["VertexID$1112", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1112", Automatic, Center], 
          DynamicLocation["VertexID$1113", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1113", Automatic, Center], 
          DynamicLocation["VertexID$1114", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1114", Automatic, Center], 
          DynamicLocation["VertexID$1115", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1115", Automatic, Center], 
          DynamicLocation["VertexID$1116", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1116", Automatic, Center], 
          DynamicLocation["VertexID$1117", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1117", Automatic, Center], 
          DynamicLocation["VertexID$1118", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1118", Automatic, Center], 
          DynamicLocation["VertexID$1119", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1119", Automatic, Center], 
          DynamicLocation["VertexID$1120", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1120", Automatic, Center], 
          DynamicLocation["VertexID$1121", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1121", Automatic, Center], 
          DynamicLocation["VertexID$1122", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1122", Automatic, Center], 
          DynamicLocation["VertexID$1123", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1123", Automatic, Center], 
          DynamicLocation["VertexID$1124", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1124", Automatic, Center], 
          DynamicLocation["VertexID$1125", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1125", Automatic, Center], 
          DynamicLocation["VertexID$1126", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1126", Automatic, Center], 
          DynamicLocation["VertexID$1127", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1127", Automatic, Center], 
          DynamicLocation["VertexID$1128", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1128", Automatic, Center], 
          DynamicLocation["VertexID$1129", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1129", Automatic, Center], 
          DynamicLocation["VertexID$1130", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1130", Automatic, Center], 
          DynamicLocation["VertexID$1131", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1131", Automatic, Center], 
          DynamicLocation["VertexID$1132", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1132", Automatic, Center], 
          DynamicLocation["VertexID$1133", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1133", Automatic, Center], 
          DynamicLocation["VertexID$1134", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1134", Automatic, Center], 
          DynamicLocation["VertexID$1135", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1135", Automatic, Center], 
          DynamicLocation["VertexID$1136", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1136", Automatic, Center], 
          DynamicLocation["VertexID$1137", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1137", Automatic, Center], 
          DynamicLocation["VertexID$1138", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1138", Automatic, Center], 
          DynamicLocation["VertexID$1139", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1139", Automatic, Center], 
          DynamicLocation["VertexID$1140", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1140", Automatic, Center], 
          DynamicLocation["VertexID$1141", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1141", Automatic, Center], 
          DynamicLocation["VertexID$1142", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1142", Automatic, Center], 
          DynamicLocation["VertexID$1143", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1143", Automatic, Center], 
          DynamicLocation["VertexID$1144", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1144", Automatic, Center], 
          DynamicLocation["VertexID$1145", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1145", Automatic, Center], 
          DynamicLocation["VertexID$1146", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1146", Automatic, Center], 
          DynamicLocation["VertexID$1147", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1147", Automatic, Center], 
          DynamicLocation["VertexID$1148", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1148", Automatic, Center], 
          DynamicLocation["VertexID$1149", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1149", Automatic, Center], 
          DynamicLocation["VertexID$1150", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1150", Automatic, Center], 
          DynamicLocation["VertexID$1151", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1151", Automatic, Center], 
          DynamicLocation["VertexID$1152", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1152", Automatic, Center], 
          DynamicLocation["VertexID$1153", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1153", Automatic, Center], 
          DynamicLocation["VertexID$1154", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1154", Automatic, Center], 
          DynamicLocation["VertexID$1155", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1155", Automatic, Center], 
          DynamicLocation["VertexID$1156", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1156", Automatic, Center], 
          DynamicLocation["VertexID$1157", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1157", Automatic, Center], 
          DynamicLocation["VertexID$1158", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1158", Automatic, Center], 
          DynamicLocation["VertexID$1159", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1159", Automatic, Center], 
          DynamicLocation["VertexID$1160", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1160", Automatic, Center], 
          DynamicLocation["VertexID$1161", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1161", Automatic, Center], 
          DynamicLocation["VertexID$1162", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1162", Automatic, Center], 
          DynamicLocation["VertexID$1163", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1163", Automatic, Center], 
          DynamicLocation["VertexID$1164", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1164", Automatic, Center], 
          DynamicLocation["VertexID$1165", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1165", Automatic, Center], 
          DynamicLocation["VertexID$1166", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1166", Automatic, Center], 
          DynamicLocation["VertexID$1167", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1167", Automatic, Center], 
          DynamicLocation["VertexID$1168", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1168", Automatic, Center], 
          DynamicLocation["VertexID$1169", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1169", Automatic, Center], 
          DynamicLocation["VertexID$1170", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1170", Automatic, Center], 
          DynamicLocation["VertexID$1171", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1171", Automatic, Center], 
          DynamicLocation["VertexID$1172", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1172", Automatic, Center], 
          DynamicLocation["VertexID$1173", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1173", Automatic, Center], 
          DynamicLocation["VertexID$1174", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1174", Automatic, Center], 
          DynamicLocation["VertexID$1175", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1175", Automatic, Center], 
          DynamicLocation["VertexID$1176", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1176", Automatic, Center], 
          DynamicLocation["VertexID$1177", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1177", Automatic, Center], 
          DynamicLocation["VertexID$1178", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1178", Automatic, Center], 
          DynamicLocation["VertexID$1179", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1179", Automatic, Center], 
          DynamicLocation["VertexID$1180", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1180", Automatic, Center], 
          DynamicLocation["VertexID$1181", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1181", Automatic, Center], 
          DynamicLocation["VertexID$1182", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1182", Automatic, Center], 
          DynamicLocation["VertexID$1183", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1183", Automatic, Center], 
          DynamicLocation["VertexID$1184", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1184", Automatic, Center], 
          DynamicLocation["VertexID$1185", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1185", Automatic, Center], 
          DynamicLocation["VertexID$1186", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1186", Automatic, Center], 
          DynamicLocation["VertexID$1187", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1187", Automatic, Center], 
          DynamicLocation["VertexID$1188", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1188", Automatic, Center], 
          DynamicLocation["VertexID$1189", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1189", Automatic, Center], 
          DynamicLocation["VertexID$1190", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1190", Automatic, Center], 
          DynamicLocation["VertexID$1191", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1191", Automatic, Center], 
          DynamicLocation["VertexID$1192", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1192", Automatic, Center], 
          DynamicLocation["VertexID$1193", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1193", Automatic, Center], 
          DynamicLocation["VertexID$1194", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1194", Automatic, Center], 
          DynamicLocation["VertexID$1195", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1195", Automatic, Center], 
          DynamicLocation["VertexID$1196", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1196", Automatic, Center], 
          DynamicLocation["VertexID$1197", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1197", Automatic, Center], 
          DynamicLocation["VertexID$1198", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1198", Automatic, Center], 
          DynamicLocation["VertexID$1199", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1199", Automatic, Center], 
          DynamicLocation["VertexID$1200", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1200", Automatic, Center], 
          DynamicLocation["VertexID$1201", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1201", Automatic, Center], 
          DynamicLocation["VertexID$1202", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1202", Automatic, Center], 
          DynamicLocation["VertexID$1203", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1203", Automatic, Center], 
          DynamicLocation["VertexID$1204", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1204", Automatic, Center], 
          DynamicLocation["VertexID$1205", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1205", Automatic, Center], 
          DynamicLocation["VertexID$1206", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1206", Automatic, Center], 
          DynamicLocation["VertexID$1207", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1207", Automatic, Center], 
          DynamicLocation["VertexID$1208", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1208", Automatic, Center], 
          DynamicLocation["VertexID$1209", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1209", Automatic, Center], 
          DynamicLocation["VertexID$1210", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1210", Automatic, Center], 
          DynamicLocation["VertexID$1211", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1211", Automatic, Center], 
          DynamicLocation["VertexID$1212", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1212", Automatic, Center], 
          DynamicLocation["VertexID$1213", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1213", Automatic, Center], 
          DynamicLocation["VertexID$1214", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1214", Automatic, Center], 
          DynamicLocation["VertexID$1215", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1215", Automatic, Center], 
          DynamicLocation["VertexID$1216", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1216", Automatic, Center], 
          DynamicLocation["VertexID$1217", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1217", Automatic, Center], 
          DynamicLocation["VertexID$1218", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1218", Automatic, Center], 
          DynamicLocation["VertexID$1219", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1219", Automatic, Center], 
          DynamicLocation["VertexID$1220", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1220", Automatic, Center], 
          DynamicLocation["VertexID$1221", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1221", Automatic, Center], 
          DynamicLocation["VertexID$1222", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1222", Automatic, Center], 
          DynamicLocation["VertexID$1223", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1223", Automatic, Center], 
          DynamicLocation["VertexID$1224", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1224", Automatic, Center], 
          DynamicLocation["VertexID$1225", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1225", Automatic, Center], 
          DynamicLocation["VertexID$1226", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1226", Automatic, Center], 
          DynamicLocation["VertexID$1227", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1227", Automatic, Center], 
          DynamicLocation["VertexID$1228", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1228", Automatic, Center], 
          DynamicLocation["VertexID$1229", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1229", Automatic, Center], 
          DynamicLocation["VertexID$1230", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1230", Automatic, Center], 
          DynamicLocation["VertexID$1231", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1231", Automatic, Center], 
          DynamicLocation["VertexID$1232", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1232", Automatic, Center], 
          DynamicLocation["VertexID$1233", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1233", Automatic, Center], 
          DynamicLocation["VertexID$1234", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1234", Automatic, Center], 
          DynamicLocation["VertexID$1235", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1235", Automatic, Center], 
          DynamicLocation["VertexID$1236", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1236", Automatic, Center], 
          DynamicLocation["VertexID$1237", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1237", Automatic, Center], 
          DynamicLocation["VertexID$1238", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1238", Automatic, Center], 
          DynamicLocation["VertexID$1239", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1239", Automatic, Center], 
          DynamicLocation["VertexID$1240", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1240", Automatic, Center], 
          DynamicLocation["VertexID$1241", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1241", Automatic, Center], 
          DynamicLocation["VertexID$1242", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1242", Automatic, Center], 
          DynamicLocation["VertexID$1243", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1243", Automatic, Center], 
          DynamicLocation["VertexID$1244", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1244", Automatic, Center], 
          DynamicLocation["VertexID$1245", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1245", Automatic, Center], 
          DynamicLocation["VertexID$1246", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1246", Automatic, Center], 
          DynamicLocation["VertexID$1247", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1247", Automatic, Center], 
          DynamicLocation["VertexID$1248", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1248", Automatic, Center], 
          DynamicLocation["VertexID$1249", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1249", Automatic, Center], 
          DynamicLocation["VertexID$1250", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1250", Automatic, Center], 
          DynamicLocation["VertexID$1251", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1251", Automatic, Center], 
          DynamicLocation["VertexID$1252", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1252", Automatic, Center], 
          DynamicLocation["VertexID$1253", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1253", Automatic, Center], 
          DynamicLocation["VertexID$1254", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1254", Automatic, Center], 
          DynamicLocation["VertexID$1255", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1255", Automatic, Center], 
          DynamicLocation["VertexID$1256", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1256", Automatic, Center], 
          DynamicLocation["VertexID$1257", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1257", Automatic, Center], 
          DynamicLocation["VertexID$1258", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1258", Automatic, Center], 
          DynamicLocation["VertexID$1259", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1259", Automatic, Center], 
          DynamicLocation["VertexID$1260", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1260", Automatic, Center], 
          DynamicLocation["VertexID$1261", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1261", Automatic, Center], 
          DynamicLocation["VertexID$1262", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1262", Automatic, Center], 
          DynamicLocation["VertexID$1263", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1263", Automatic, Center], 
          DynamicLocation["VertexID$1264", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1264", Automatic, Center], 
          DynamicLocation["VertexID$1265", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1265", Automatic, Center], 
          DynamicLocation["VertexID$1266", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1266", Automatic, Center], 
          DynamicLocation["VertexID$1267", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1267", Automatic, Center], 
          DynamicLocation["VertexID$1268", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1268", Automatic, Center], 
          DynamicLocation["VertexID$1269", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1269", Automatic, Center], 
          DynamicLocation["VertexID$1270", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1270", Automatic, Center], 
          DynamicLocation["VertexID$1271", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1271", Automatic, Center], 
          DynamicLocation["VertexID$1272", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1272", Automatic, Center], 
          DynamicLocation["VertexID$1273", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1273", Automatic, Center], 
          DynamicLocation["VertexID$1274", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1274", Automatic, Center], 
          DynamicLocation["VertexID$1275", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1275", Automatic, Center], 
          DynamicLocation["VertexID$1276", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1276", Automatic, Center], 
          DynamicLocation["VertexID$1277", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1277", Automatic, Center], 
          DynamicLocation["VertexID$1278", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1278", Automatic, Center], 
          DynamicLocation["VertexID$1279", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1279", Automatic, Center], 
          DynamicLocation["VertexID$1280", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1280", Automatic, Center], 
          DynamicLocation["VertexID$1281", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1281", Automatic, Center], 
          DynamicLocation["VertexID$1282", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1282", Automatic, Center], 
          DynamicLocation["VertexID$1283", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1283", Automatic, Center], 
          DynamicLocation["VertexID$1284", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1284", Automatic, Center], 
          DynamicLocation["VertexID$1285", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1285", Automatic, Center], 
          DynamicLocation["VertexID$1286", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1286", Automatic, Center], 
          DynamicLocation["VertexID$1287", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1287", Automatic, Center], 
          DynamicLocation["VertexID$1288", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1288", Automatic, Center], 
          DynamicLocation["VertexID$1289", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1289", Automatic, Center], 
          DynamicLocation["VertexID$1290", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1290", Automatic, Center], 
          DynamicLocation["VertexID$1291", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1291", Automatic, Center], 
          DynamicLocation["VertexID$1292", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1292", Automatic, Center], 
          DynamicLocation["VertexID$1293", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1293", Automatic, Center], 
          DynamicLocation["VertexID$1294", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1294", Automatic, Center], 
          DynamicLocation["VertexID$1295", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1295", Automatic, Center], 
          DynamicLocation["VertexID$1296", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1296", Automatic, Center], 
          DynamicLocation["VertexID$1297", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1297", Automatic, Center], 
          DynamicLocation["VertexID$1298", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1298", Automatic, Center], 
          DynamicLocation["VertexID$1299", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1299", Automatic, Center], 
          DynamicLocation["VertexID$1300", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1300", Automatic, Center], 
          DynamicLocation["VertexID$1301", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1301", Automatic, Center], 
          DynamicLocation["VertexID$1302", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1302", Automatic, Center], 
          DynamicLocation["VertexID$1303", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1303", Automatic, Center], 
          DynamicLocation["VertexID$1304", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1304", Automatic, Center], 
          DynamicLocation["VertexID$1305", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1305", Automatic, Center], 
          DynamicLocation["VertexID$1306", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1306", Automatic, Center], 
          DynamicLocation["VertexID$1307", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1307", Automatic, Center], 
          DynamicLocation["VertexID$1308", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1308", Automatic, Center], 
          DynamicLocation["VertexID$1309", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1309", Automatic, Center], 
          DynamicLocation["VertexID$1310", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1310", Automatic, Center], 
          DynamicLocation["VertexID$1311", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1311", Automatic, Center], 
          DynamicLocation["VertexID$1312", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1312", Automatic, Center], 
          DynamicLocation["VertexID$1313", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1313", Automatic, Center], 
          DynamicLocation["VertexID$1314", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1314", Automatic, Center], 
          DynamicLocation["VertexID$1315", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1315", Automatic, Center], 
          DynamicLocation["VertexID$1316", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1316", Automatic, Center], 
          DynamicLocation["VertexID$1317", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1317", Automatic, Center], 
          DynamicLocation["VertexID$1318", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1318", Automatic, Center], 
          DynamicLocation["VertexID$1319", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1319", Automatic, Center], 
          DynamicLocation["VertexID$1320", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1320", Automatic, Center], 
          DynamicLocation["VertexID$1321", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1321", Automatic, Center], 
          DynamicLocation["VertexID$1322", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1322", Automatic, Center], 
          DynamicLocation["VertexID$1323", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1323", Automatic, Center], 
          DynamicLocation["VertexID$1324", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1324", Automatic, Center], 
          DynamicLocation["VertexID$1325", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1325", Automatic, Center], 
          DynamicLocation["VertexID$1326", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1326", Automatic, Center], 
          DynamicLocation["VertexID$1327", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1327", Automatic, Center], 
          DynamicLocation["VertexID$1328", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1328", Automatic, Center], 
          DynamicLocation["VertexID$1329", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1329", Automatic, Center], 
          DynamicLocation["VertexID$1330", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1330", Automatic, Center], 
          DynamicLocation["VertexID$1331", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1331", Automatic, Center], 
          DynamicLocation["VertexID$1332", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1332", Automatic, Center], 
          DynamicLocation["VertexID$1333", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1333", Automatic, Center], 
          DynamicLocation["VertexID$1334", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1334", Automatic, Center], 
          DynamicLocation["VertexID$1335", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1335", Automatic, Center], 
          DynamicLocation["VertexID$1336", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1336", Automatic, Center], 
          DynamicLocation["VertexID$1337", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1337", Automatic, Center], 
          DynamicLocation["VertexID$1338", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1338", Automatic, Center], 
          DynamicLocation["VertexID$1339", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1339", Automatic, Center], 
          DynamicLocation["VertexID$1340", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1340", Automatic, Center], 
          DynamicLocation["VertexID$1341", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1341", Automatic, Center], 
          DynamicLocation["VertexID$1342", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1342", Automatic, Center], 
          DynamicLocation["VertexID$1343", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1343", Automatic, Center], 
          DynamicLocation["VertexID$1344", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1344", Automatic, Center], 
          DynamicLocation["VertexID$1345", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1345", Automatic, Center], 
          DynamicLocation["VertexID$1346", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1346", Automatic, Center], 
          DynamicLocation["VertexID$1347", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1347", Automatic, Center], 
          DynamicLocation["VertexID$1348", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1348", Automatic, Center], 
          DynamicLocation["VertexID$1349", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1349", Automatic, Center], 
          DynamicLocation["VertexID$1350", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1350", Automatic, Center], 
          DynamicLocation["VertexID$1351", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1351", Automatic, Center], 
          DynamicLocation["VertexID$1352", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1352", Automatic, Center], 
          DynamicLocation["VertexID$1353", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1353", Automatic, Center], 
          DynamicLocation["VertexID$1354", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1354", Automatic, Center], 
          DynamicLocation["VertexID$1355", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1355", Automatic, Center], 
          DynamicLocation["VertexID$1356", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1356", Automatic, Center], 
          DynamicLocation["VertexID$1357", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1357", Automatic, Center], 
          DynamicLocation["VertexID$1358", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1358", Automatic, Center], 
          DynamicLocation["VertexID$1359", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1359", Automatic, Center], 
          DynamicLocation["VertexID$1360", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1360", Automatic, Center], 
          DynamicLocation["VertexID$1361", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1361", Automatic, Center], 
          DynamicLocation["VertexID$1362", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1362", Automatic, Center], 
          DynamicLocation["VertexID$1363", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1363", Automatic, Center], 
          DynamicLocation["VertexID$1364", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1364", Automatic, Center], 
          DynamicLocation["VertexID$1365", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1365", Automatic, Center], 
          DynamicLocation["VertexID$1366", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1366", Automatic, Center], 
          DynamicLocation["VertexID$1367", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1367", Automatic, Center], 
          DynamicLocation["VertexID$1368", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1368", Automatic, Center], 
          DynamicLocation["VertexID$1369", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1369", Automatic, Center], 
          DynamicLocation["VertexID$1370", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1370", Automatic, Center], 
          DynamicLocation["VertexID$1371", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1371", Automatic, Center], 
          DynamicLocation["VertexID$1372", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1372", Automatic, Center], 
          DynamicLocation["VertexID$1373", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1373", Automatic, Center], 
          DynamicLocation["VertexID$1374", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1374", Automatic, Center], 
          DynamicLocation["VertexID$1375", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1375", Automatic, Center], 
          DynamicLocation["VertexID$1376", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1376", Automatic, Center], 
          DynamicLocation["VertexID$1377", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1377", Automatic, Center], 
          DynamicLocation["VertexID$1378", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1378", Automatic, Center], 
          DynamicLocation["VertexID$1379", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1379", Automatic, Center], 
          DynamicLocation["VertexID$1380", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1380", Automatic, Center], 
          DynamicLocation["VertexID$1381", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1381", Automatic, Center], 
          DynamicLocation["VertexID$1382", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1382", Automatic, Center], 
          DynamicLocation["VertexID$1383", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1383", Automatic, Center], 
          DynamicLocation["VertexID$1384", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1384", Automatic, Center], 
          DynamicLocation["VertexID$1385", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1385", Automatic, Center], 
          DynamicLocation["VertexID$1386", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1386", Automatic, Center], 
          DynamicLocation["VertexID$1387", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1387", Automatic, Center], 
          DynamicLocation["VertexID$1388", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1388", Automatic, Center], 
          DynamicLocation["VertexID$1389", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1389", Automatic, Center], 
          DynamicLocation["VertexID$1390", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1390", Automatic, Center], 
          DynamicLocation["VertexID$1391", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1391", Automatic, Center], 
          DynamicLocation["VertexID$1392", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1392", Automatic, Center], 
          DynamicLocation["VertexID$1393", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1393", Automatic, Center], 
          DynamicLocation["VertexID$1394", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1394", Automatic, Center], 
          DynamicLocation["VertexID$1395", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1395", Automatic, Center], 
          DynamicLocation["VertexID$1396", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1396", Automatic, Center], 
          DynamicLocation["VertexID$1397", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1397", Automatic, Center], 
          DynamicLocation["VertexID$1398", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1398", Automatic, Center], 
          DynamicLocation["VertexID$1399", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1399", Automatic, Center], 
          DynamicLocation["VertexID$1400", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1400", Automatic, Center], 
          DynamicLocation["VertexID$1401", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1401", Automatic, Center], 
          DynamicLocation["VertexID$1402", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1402", Automatic, Center], 
          DynamicLocation["VertexID$1403", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1403", Automatic, Center], 
          DynamicLocation["VertexID$1404", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1404", Automatic, Center], 
          DynamicLocation["VertexID$1405", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1405", Automatic, Center], 
          DynamicLocation["VertexID$1406", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1406", Automatic, Center], 
          DynamicLocation["VertexID$1407", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1407", Automatic, Center], 
          DynamicLocation["VertexID$1408", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1408", Automatic, Center], 
          DynamicLocation["VertexID$1409", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1409", Automatic, Center], 
          DynamicLocation["VertexID$1410", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1410", Automatic, Center], 
          DynamicLocation["VertexID$1411", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1411", Automatic, Center], 
          DynamicLocation["VertexID$1412", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1412", Automatic, Center], 
          DynamicLocation["VertexID$1413", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1413", Automatic, Center], 
          DynamicLocation["VertexID$1414", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1414", Automatic, Center], 
          DynamicLocation["VertexID$1415", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1415", Automatic, Center], 
          DynamicLocation["VertexID$1416", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1416", Automatic, Center], 
          DynamicLocation["VertexID$1417", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1417", Automatic, Center], 
          DynamicLocation["VertexID$1418", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1418", Automatic, Center], 
          DynamicLocation["VertexID$1419", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1419", Automatic, Center], 
          DynamicLocation["VertexID$1420", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1420", Automatic, Center], 
          DynamicLocation["VertexID$1421", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1421", Automatic, Center], 
          DynamicLocation["VertexID$1422", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1422", Automatic, Center], 
          DynamicLocation["VertexID$1423", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1423", Automatic, Center], 
          DynamicLocation["VertexID$1424", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1424", Automatic, Center], 
          DynamicLocation["VertexID$1425", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1425", Automatic, Center], 
          DynamicLocation["VertexID$1426", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1426", Automatic, Center], 
          DynamicLocation["VertexID$1427", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1427", Automatic, Center], 
          DynamicLocation["VertexID$1428", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1428", Automatic, Center], 
          DynamicLocation["VertexID$1429", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1429", Automatic, Center], 
          DynamicLocation["VertexID$1430", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1430", Automatic, Center], 
          DynamicLocation["VertexID$1431", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1431", Automatic, Center], 
          DynamicLocation["VertexID$1432", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1432", Automatic, Center], 
          DynamicLocation["VertexID$1433", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1433", Automatic, Center], 
          DynamicLocation["VertexID$1434", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1434", Automatic, Center], 
          DynamicLocation["VertexID$1435", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1435", Automatic, Center], 
          DynamicLocation["VertexID$1436", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1436", Automatic, Center], 
          DynamicLocation["VertexID$1437", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1437", Automatic, Center], 
          DynamicLocation["VertexID$1438", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1438", Automatic, Center], 
          DynamicLocation["VertexID$1439", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1439", Automatic, Center], 
          DynamicLocation["VertexID$1440", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1440", Automatic, Center], 
          DynamicLocation["VertexID$1441", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1441", Automatic, Center], 
          DynamicLocation["VertexID$1442", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1442", Automatic, Center], 
          DynamicLocation["VertexID$1443", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1443", Automatic, Center], 
          DynamicLocation["VertexID$1444", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1444", Automatic, Center], 
          DynamicLocation["VertexID$1445", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1445", Automatic, Center], 
          DynamicLocation["VertexID$1446", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1446", Automatic, Center], 
          DynamicLocation["VertexID$1447", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1447", Automatic, Center], 
          DynamicLocation["VertexID$1448", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1448", Automatic, Center], 
          DynamicLocation["VertexID$1449", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1449", Automatic, Center], 
          DynamicLocation["VertexID$1450", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1450", Automatic, Center], 
          DynamicLocation["VertexID$1451", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1451", Automatic, Center], 
          DynamicLocation["VertexID$1452", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1452", Automatic, Center], 
          DynamicLocation["VertexID$1453", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1453", Automatic, Center], 
          DynamicLocation["VertexID$1454", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1454", Automatic, Center], 
          DynamicLocation["VertexID$1455", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1455", Automatic, Center], 
          DynamicLocation["VertexID$1456", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1456", Automatic, Center], 
          DynamicLocation["VertexID$1457", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1457", Automatic, Center], 
          DynamicLocation["VertexID$1458", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1458", Automatic, Center], 
          DynamicLocation["VertexID$1459", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1459", Automatic, Center], 
          DynamicLocation["VertexID$1460", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1460", Automatic, Center], 
          DynamicLocation["VertexID$1461", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1461", Automatic, Center], 
          DynamicLocation["VertexID$1462", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1462", Automatic, Center], 
          DynamicLocation["VertexID$1463", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1463", Automatic, Center], 
          DynamicLocation["VertexID$1464", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1464", Automatic, Center], 
          DynamicLocation["VertexID$1465", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1465", Automatic, Center], 
          DynamicLocation["VertexID$1466", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1466", Automatic, Center], 
          DynamicLocation["VertexID$1467", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1467", Automatic, Center], 
          DynamicLocation["VertexID$1468", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1468", Automatic, Center], 
          DynamicLocation["VertexID$1469", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1469", Automatic, Center], 
          DynamicLocation["VertexID$1470", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1470", Automatic, Center], 
          DynamicLocation["VertexID$1471", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1471", Automatic, Center], 
          DynamicLocation["VertexID$1472", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1472", Automatic, Center], 
          DynamicLocation["VertexID$1473", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1473", Automatic, Center], 
          DynamicLocation["VertexID$1474", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1474", Automatic, Center], 
          DynamicLocation["VertexID$1475", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1475", Automatic, Center], 
          DynamicLocation["VertexID$1476", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1476", Automatic, Center], 
          DynamicLocation["VertexID$1477", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1477", Automatic, Center], 
          DynamicLocation["VertexID$1478", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1478", Automatic, Center], 
          DynamicLocation["VertexID$1479", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1479", Automatic, Center], 
          DynamicLocation["VertexID$1480", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1480", Automatic, Center], 
          DynamicLocation["VertexID$1481", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1481", Automatic, Center], 
          DynamicLocation["VertexID$1482", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1482", Automatic, Center], 
          DynamicLocation["VertexID$1483", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1483", Automatic, Center], 
          DynamicLocation["VertexID$1484", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1484", Automatic, Center], 
          DynamicLocation["VertexID$1485", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1485", Automatic, Center], 
          DynamicLocation["VertexID$1486", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1486", Automatic, Center], 
          DynamicLocation["VertexID$1487", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1487", Automatic, Center], 
          DynamicLocation["VertexID$1488", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1488", Automatic, Center], 
          DynamicLocation["VertexID$1489", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1489", Automatic, Center], 
          DynamicLocation["VertexID$1490", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1490", Automatic, Center], 
          DynamicLocation["VertexID$1491", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1491", Automatic, Center], 
          DynamicLocation["VertexID$1492", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1492", Automatic, Center], 
          DynamicLocation["VertexID$1493", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1493", Automatic, Center], 
          DynamicLocation["VertexID$1494", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1494", Automatic, Center], 
          DynamicLocation["VertexID$1495", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1495", Automatic, Center], 
          DynamicLocation["VertexID$1496", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1496", Automatic, Center], 
          DynamicLocation["VertexID$1497", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1497", Automatic, Center], 
          DynamicLocation["VertexID$1498", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1498", Automatic, Center], 
          DynamicLocation["VertexID$1499", Automatic, Center]}]}, {
        Arrowheads[0.009582311168495804], 
        ArrowBox[{
          DynamicLocation["VertexID$1499", Automatic, Center], 
          DynamicLocation["VertexID$1500", Automatic, Center]}]}}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{18.385786437626916`, 
       179.61421356237312`}, {-40.746213562373086`, 31.414213562373106`}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImagePadding->11,
  ImageSize->132]], "Output",
 CellTags->"13.1 Solutions",
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzFfGdwXWd6HizSK0paU9JKlCg2dKITHSB6JUCiXAAE0XvvvffeSIJNAElQ
YhMpkkuV1dZ4s7Itrco6tmdn4kziJE7s2R/5l5n88Ew8Hifz5n3e73wfzr2Q
Nz99ZiTw3nPOV976vOW7+Q3D7S09DcMdTQ0e2YMN/e0dTUMeWX2D/NW+P3Bz
c/uW/+v2cNvP/yb+p+1/3xJf/2p/Tsifg/S73/2OFteuUsf8B3T3k2+cPm/e
/fmeezdu3MDfO86j4NvYjBJKKF+knpUfyueozCpKqlik3OZVuZfI9zoXn8q9
5NRM/HUZ5du//A+U07hKvcsf0t//j/8p8127foOe/+xruaf//fVv/xu1zDyg
gpbVPWvZJ09gXl6124vy3X76s3/3X6h27H0617iCN96Rr1+0bwjf2D/zS2o4
+3ee8t33nN6z/TvPeSFYLojAJDQL+ef/839pcPoyxafl4S29EE0TULtn5TmV
da5pGpmF2OhmFoLvMFRm7TLV9q3r+y4LsW9BLwT0bZ19QOVda3aKgMzZDSvU
ufCIWmYfU9343T0UwTNn6pYhHk4Uwb5K+28Loc/yGMvbn7ksBJNieyxM1kL2
CWta5z6kxulHbkesVeC7ypG71L/2kfwbDNfv6VU8+zd/STFl61TYc9usAuN3
L/+QJq9+JvfrJh5Q59JTp1UcFAGBoEKsNdeHZzcpueYSlfZtUXFxMX36s89p
cONjEUUwxZDoIH388ScUHJtFvbO3Kez8CsWULJPfmQGKLVsRLfn2228praCJ
QgoXKaJ4kXwy+lnu1g64yA6oWDd6m1IK2vDKG9ZtvTgQvnbkNsXm92IxLluA
aEGnsDRcGDDsTAsF589RYO4UeXj70ZnCOqoevUcZLBuWXOgthIaG0jF3bzqZ
OUD+ufN08uwUeUYVkV/WAPWuPhcKeKe00cmcGb43TSeCkuioZ4DegpbEganL
FJo7Qj5JTXhFb0EvrnX4It8eJp9kue2yBew/j00DjIzmwpVrN2hp60e0cesj
Cs8bpunND4X/eNaSQr2FjRsPebnDlNeySYPrHwk3/DO6qar/uogBuFBYXEo1
I7eoqGODtzFDcaVLegvf/MVfU2rVEl1672fUPX+P/HinSVUbb7gw6e/+7u9p
fOMxBeZMkqPjuos4Y2kVLKZDFz8xYonvGqYeynfHtXY/+lOKvLBCqXWKW/Zn
9HvYQ0DePCTKTS/S9py5f6pw5S1tEHjYmDI2FLWX3VyI+9XX31Cyo4XuPP6p
KNHa7Z8Yg4V7qQXNlNN2lQq6b9LKrR/re/ut1z/99FMKjjlD4ecXKbRwjt4J
zKTKriU6VbRMSdUblFdUQRUD2/T+x1/bjYt6/ZCTeXz+/GPyT2mg/vnbrFCf
0NDqQ5FMrKyPV9YweJlORBaQX+4cBeXP0vH4BgovnKGoklU613xJRJWXY9Hp
ZeEIDA1E4tmzj8gvvZ1Kuq9Sav1VKh/ccV6Ks+k7YA0B0cgqrOXdLTNJ58gr
vZ8KWxZchzjrTFLs2SepkRWyh23TPbGSllqpe2mdIiax5RuUVWfuaZKGRCaQ
T3ofnTw3Tb6sUlA5n8xR4SmEz/NUKoWxsjROPaKcphWKyKzfff0Qza9epVNZ
3dQwsCFDeSXUM1nrRTzwml7Z+d7b5JvJn/m/k+dYe8/Nkm/WOPlmT/JUC6LN
HpGFIKsh6YJtbG0ZApKrKKp0jcKK5p13sk9sDh6v7183JIXB8Io5rwwGT4nd
ucc3MxedhnAh6erWcwrImaIzjZfFXMNx1PVvCNNuPfwxG49RcrRfk3s2E6BJ
2j1zS8gZ7Fig2AvzMnEAixFUBRbkfPEFGQavVw7dEUNok9Kbj39JpwrmKbft
BnVP3xTSRF5YEq3DymDZYIGHL7EE87A+Z8YovXqZ4kumySdrgkIcs3Shf0c4
eDJ73ElKYcUTFQahO/efUkBqE/XO7YjKfvrHv3GV0lsf/lu9FCcpLSouocGV
BxRfOi/TRxfPuw7hRNLDtHz1PpvFEYosXqLMpmt0ugzOqV9olFp7kTJZ9eDb
tMUFM+FqUmvXKSCllh0Wa3nhMkWwCvowE/1zZyni/JLIUmjhglpwkMAYkDaX
BR8LtQ/FDpnK+67JMjBcWNGCSHxIwQKlNVwlR9smBcU7qKB9k+onH5J/DujJ
GpEzK9Mcja4RVsIi4DsfFl34tMD8eRH7iaUbMk4Ju+pMy5I4Oq5RUM445bRe
lXvajfPaLJ68aJFmlK3MPCXVbNLslScuzzg7Z0heACt0vovdP8xKEibu8iT7
H0AQv8xe8kpuVQrHGgDvi5G1Z47JKGPWLZDf2Qk2E70iaX65iqWe8bXkmTEo
EgT7EBhz5g9lmjdlCD2UBtgxF1jWeUr/9A5eAiscE9k3a4xBRh8Tp4Ei2Wz6
ZY+Re1Ay+Wf2MRp6Rm+cTAURXwBVeVi10lmLthPkya/5ZE/J6n0zh8g9Io+i
WfUDmC+YHjQWL5/aSafzu5zu8dI0eUEUL94MNheUz9Anb1A/Ysi7BzikdVFu
YYULeaEw/hldIkTQ3dt3n9Cp0Egx8yvbzzXTjAxfvXadnv3k1zS28h7bxiRq
Ht9ipf2ESpsm6cTpOsqomKLx1fcoODIRSqoW87aAytjSVbEyWoYBXZ589iX9
8Bd/JdNiU0tX7lHXxBUGQIH07s3booATPJx/RidV9l2nT371WwrKm6IT8S0i
LyxjborWP6BzrVsiEV4ZwxSX107pNStsiicYPq/KODdZh7Ad+GTRp8IK+uLX
Xzvd47VpGsMvh4aGU+vEFq3s/IIu9LxLcY4eJxGG6KbVLAuyUSpaifsu0EXQ
c7lCz69a320//YKC2E6wchh0vnjz5xRcwCjAwJJDAq/aF56I98dlG4u//5A3
PCeoEhfsjig2f1czxgrIf6HYohq8STgIVlhr7H3ClLjKS9Q2/6HZEeZrm38i
4BrGme/xPE//0IaSascfCErSAcD2ky+sDeuQQmv2859/IxYijQ2e35lBKujY
tAjwOg0uM6ZkyY4tWxWJAPVvffBjeb5m9D2DaX75zX+iKNZnr9RuOtu4xlbn
BnvDDVuQ9H3qHFkmj4QmxpyC6di8z5Jnaq9gnKB8RRRfxqR+8ndaCcyLlhFU
Rg+aBLrBePaMrhgajax9IEYzvnLdmu51E/TWjt2lAY5bKhgGB8Xlsz1YFhTn
HppN65vbQqSKziV62zeeMqoXJL5Jq16i+om7bm+4kAqShOchSRpDRThTVSt0
UeuqZXomOHBop8CkCkNVODFgA0AuAUqJdQJZgPBCCw02oC//6r+yKRslb7aC
Pum97F/nGGd02mLgV+gtnzghi8CZ/AWhIPTJl12V+AvAHYYEbMuYUCDpfkNS
kNH33Iyi9D46ePAgWRcLkaKsbanGbehopm3kIlWzBPsz4PSMKgbEETWfYb74
sNmsm3zADO5Ry+PlIAK2QjRNWIWcOhlsrlL58PsSROuI3oWwmgd/+7f/XfSk
YeRdHnmCNXvdEBZ+PDq/TxyZhlIpNRddEYLoMAAMiDYyf13QhhXTGnEFwlBO
QeGn2OJpywnPUlrdFSOuEfkjcBau4or/vNn4h7GUHwnJpbW1NSOu8M+BuRPw
yUZc7fEVzAdrIQUmlFD75DbFliyKLwI/odtR5+eNv7KhQCOuEP34skVqn3uo
gn7GIIxN94rrK3vyPdv3P2PYMCZwQXsT52zHIcvmShBCHR0dtH//fvmLK6+0
lc1+M8UVDip4wUjrXMtluWd/DwYjomiOPJLbhTRq7Fed1pNQPArxFIqL5Uyp
Erfsd3acfvHVf5TY4kRiG1VXVwN4uGkWlA2+Z1ig59NBkw4kO6YAbyclRWHb
5wuy0bfNEkDtkt53OfQeEvvXNrjMGGVEhANXVOG44cTvSZ3ZP7upOfbZ71nO
5UXhft/kJeEq5i4bvM06sfJdnLMnyIBpTud3k2dYlhiVpplHVNntmjA7JFQ4
fjKS4VkPeabwf/F1YgQAvdyZkgA6oCjcAGBYUEy2ZJkCkmvouG+YJHWgN96Z
I3SMx2GLYY192J6Mo/0vvkyeic10IrlT9Ae22zOxUYEqfOZgwSOmnPVvii1E
P39mqJc9bT07TZ7JXSYk9IjIx7oV47zF2XuerhBTjnRcRfe65PtymlbF5uol
AI8Dp3kGxslfb0aW3ow03zxxirqYXG+H5HOY20uH/LMkVxie2SCkRLLnfNvu
OOKWra3NLl9hvMKhQGatkPWAi83X8/ZOXKK4NMdeK/aKMDarfkXCIHjtysGb
yqkyLmmefUQt0w+Mvu2Td34gCCC6ZIVOMldSq9fYdMwYoRP0kDNtPkcULQqk
L2VkiPFzWPf8GPUGO+ZfgP3gQY+EnIPKWbZI7eDXf/7vKVMlMKmuuZuORlVw
4CgRiPIaL1j/dGeO+klIO+O2a/KUm/HKGDFmCjY/t/Wym2abIFj2E0hGgW3N
vE8kLRDgNk3dN8oAuFIzfIviHV3i1QPz52RMRLPIiUYXsTvlSD6qcJKqRu5I
+hrmDnttnLrnNE7z9H1J5uJ+xdAO5Tat2rIeKrOLCNieb/tOr/6y6CJcnU6/
Ynhc4DYsbAsvjRGW1jMJkDkIDmSH/Plv/obx42WD+YAH4ysvms/wRSUDd6RI
gKExHFxhBTIqzTckRxFduu6mwN0Be5bX4NP4ysuU277FXF5SjDpIcRUXmYML
FFOxIe4rrV65LDAnhOGrnr5//bnE7GHFy0B1ml83n3wpoCypetNsGJvVuWeo
kB19Ns88pn/8p3+mC307bCEWGMqsy726ifsyDSjx/xunde4xy8aHhqgNU1Jk
cUr+VarkoowzsP4xbT35ItLOqnindJjmqg7EMxoR/6+wJLaJV7Dfi6+6JNDT
J2uSUioBR3e1Ksix6KRleA4GpaBmQKDw2YY1cg/PQT5AdopnvNmmBeUpTfXM
HDNYAkjIM33QjOULTMFjq/dmrJB5VmTEH/fZVkZfWKRwlnjBwPwdy8QLFpZD
aBuIlB0jaYbEGqO5ItbCrhsWkNe+1kOlZMoVQnbJ7FN1+4TsELMhcgnOE6go
n880buocvVAYtusUx66l/dt7xlH3RimmdEUkFrrmkrQCwwAlwYTJa5/R2aaL
5JfeSaW91wTIASEDjri8HmRne6CTDdY2G2ATUUkUMhIZveLC4AL1PWQgoEre
af3kHlnEhmXIws/TzL4JMa747J3WY+UDVD7mcEieYHVgc4+oQuWqTO6gUX2W
nN+uyIiBTG5XEPwN8mCv56ftZnIreXM4HM1LQdYCnhIZDNg53APdg1hlESx5
pfYpT2mlJnY98K4bahrcEAsCJOyM3T32YHe4M022Ay+9LFs1qRDmP+b34nX4
M5K2qhZCXmQSkaBF2hy5X1tJRe5hXqSfQN606mXX3K+9OgrwguqRR4SD/BmY
YNkYOphhaEzZhn2JTjz3FeHG3cWtHxlVxwYl9bH5qeS1UBHRqq7vwbilVy3Q
sYgL1Da0TKdyhhW0ZwVpY0uekN9Gx+MaKTKvh4Jyd3mIMKJn6qoUgjJqVqiW
jRtU/AQ/e6ZsiOcat5ziOxLGe2aNW/EXxlbyg5CkigkWmdsvshWYMyHrOdeo
TEhd/yVKKRmVZ6H+CTWbZozAxHKT1uVY0DBeF44QlsJIIgxyzuN5OMUXLgUk
Km+ZFLOE1CYKhDBr2BPW0T1/X3KNyP3hUrHLlOQaXcfR4VfTxJ1/KUNtL2Dv
PP+1eC+waPXaAxk6LG+YGsf2vO7EeFVSapp+tKdcBBvKzs36LsJ4J2BYXCA8
tA4+FRfuN05/IBYytW7TOEXXe2D8aXakCewjcLk+628lZvEZc1g2Wu7Juvjf
SHlgTCR4OxafmvVo7yhJc9uYeq18z15JQ/2SMaoV8h60qmBzSEd957KhgIAf
YhOl6rYKl2UfsmzoPaHkK5Y4qRXPi81xGdIt1M6IbMnSoXY1d/UpJddeoYLO
62KvIR1bj7+gtKp5OhZTLSuMKV2WQg0i25tPv6S6jgk6FJAp4V0QwzyYmeji
OeAoGTfR0U7hjEqSKhYYWg5JzNW19ExKoDA7Dp5rmzUnuaiX3g49L05ZJYqm
jbM9yRZafw4t4GAiqYMiHRN0qnBJxO5YXJN5FtJ/8JAnjY2NUUtLB4em3RSS
Py2Uhbn1zBilgKx+RlWzErCEFcxQbsc2Da08NAlYaFfn2EX6/KvfWhw6JDW5
kxldFF++Ks+3jG+JvQMkRmYzLr+DehbuUTJrelbDRQm2UMvVFg1RB3yj3vdH
P/mVBYn+yCnG/If//U+SYvE4XUkR5xcpu/GimQfXzs4OHQ/JcNNxAOA4LCNG
8rOz1cdU9kJzhiS5HZQ7aZXjhqhq9D55M35BGKwc3bTKrfMWzzP6k+QTO0sY
NzFc8CIceIF1uigGb+KdPkBHT3jRW94xYnSi8gYk+w2vkcdkgteDI+a/ymm+
ZKVcVDIJ9lCm4VAUuWSom68JSg4Zn4vS3oEDB+gN7yST84KqSUgaXydOVftr
nzPjgpvDeZtwdgA59h4TzVFgCGwZyY3TDNMQTvueYelgWKlLFPH5nUI64DOv
xCYKSnCufqDUHoktJzVRsqPN4ujrApxCsnqk9AiQ6xVfw064TcY/CdIy2TGP
3IurtiqouzXGwIQLbv7ObhIYDOnFysFtMQGoBEbl91Pz5B2JVBASICI/W7dA
TaNbUqbKqFun/M5tQ8a08inJjnomt1Ny+YJpKEB+EHFaY98yHY+uoIoOe7lw
WMpQ6fVXzTgxBVLYsdj0EivxTQZ7PdYWZjiumzCuD3boZPa0YSkgl+ASXiuU
NMwxaVyzo2tbsZDRe3RaMUUVqaKyf96slC7GNx5ZhdVNq6lqhS6//zPDUolP
U5ukfAHfA/ApFT6Op3XiW5chVOZxHJlHoQNi+eredfFpaI3wV/MYltpqmRKx
wbb6MDvh6gvbN808co8hiw9jv7zmNeEBMi4lPdc0S1WG78098L5lZJOO+UVT
eNGCDOGd0iHJbVwagqO1Bmk32DQJQMTZzADZ7pOg0UN0FsKP1aCEp02HU/sC
7zKlconKBnZkapilFDZLQP95nVsmpoE5dY2h/HM4hkG+KUeD4hkBXfCNvroe
t283P836vH83+/B9BZhUWkLsQzBzF2FBUdu61PdB2Qh2GUEMqsr7t1+1HJqu
PVeNiKOjhvEdSR6ytzL1aSQ+gcWiWcgQJqKpA1k/YJp8qXtOcXC75drQoRkA
yAPLhUDl2gd/wrBwXroMClrX6XTRAHlZsRQqR36WA+nqH5cULZr2eBxnHr9u
LA+C2ZpxNrpJzRxtnLey+bNi+Y4cESU3cByGG+HzwcP+IIilOgEqjDg7bSjr
GVvOMjBgwghYNG2dNIy3hwpw/4BmmAOhXsfCh3QkrFgaRXwt6wOx3Y2apiWB
6J01ZiKh4/HNVoViWgWytsjIx6j5axwCDZogGAz3TGoRodHRFyx2TPkGefOe
PNk6qn3NiPPg/Wum25ePSoRePj9imL4bqUxIqIGtefpHUUZBvaiMT2o7ntdM
19Rp5ACrwgqwNNWR/ED61CPSIWVnxA86eEN61ZNd4PGABHrtWLBEPaeyusSn
ODHdoWqVHC9t7PxU7Oj44nXeaAvHVyuUWbsqMoWQBxdEEz1hCJJRcoVceTJQ
Cme7GJ47KMSDxiGLFMK7eTs4j9IddVTWe1VcV8/sLRkHc6ZWL0lw7RomYA7d
NYJ8TcKFMRknsXjUzAG1Qe4mMrfHfA7JGRHvHcg6ATvumdhkwhhU6/2yBunN
wDxxaX6ZKhQ6yUJR0r9D2SUd9ML+71Hy+R6punimdFFG5bTYZRi1I8dOUG3f
JbHpeardQjP9u5bvHAmpNhJsaevBZ+Ia9DO64mwN6arpekhEKZrqoAhMrndq
J40tXKf04m7lddimoQ9JNJ01f2R0TIyQrjE5Md3DhAUwJLgk+abKzpIeRHgA
54dLUn756l5J/x1Brn5WyIBy8kkJb+ZljFNFjDFKJNMrO0UjFswlLhAztkw+
77cgIHwZ8m/Ix+F2QvUlymq5sWdoXOCTSifOiw+3Ry5J1bvZTkyLTNa59q09
42A+NMBtvP9L1yXJZ9t6GJMS6X5Z/Z0unUn1ff4Jx5NfyXt2cqLrAfkreB9c
9rVCZhG5+ectuAXbOaI6WgMTSjlOWJDmn1DHjNgsODW/HNXtJM7NSuFYMYby
U54izUG5EywbyhRilnq2QQhzkM+DzAARwAuAEshsL11hypwZ4gBt2Z7mMi4c
CA4+FnEh3vdid4DGH2iNNsGyHFXUVY7T7S2Vczy3W5REXlrCLYYIjpZ1DodG
jGtAN2P0hQUxXPkta+LVgpHFKVWNvDdZZbAOhhI+luxqOFAz9r4QXPdVSm6G
DRl6fdNqViRNiujwjNVutfngc5Fj+FVopL2SBmbBonum9kl+JQB9TuwFsupX
WThu2Xs3fex8C7b1FCqr680wC6Vo8EsVlKaVL7FVwA3hLPiIVBwiAfgWmB6I
Fiw7/Jmv1YSAMcHIOBZtMycjfVSSYNnr+taFcWg18Unt4OCmn3I6tuRd7+QO
cueohGXGFfDsFunftuph5vvd/DHbEw9ejjcHBcfjd60qtousIRKQaDiIsrJ/
6CpCr0iOtZQER6ebZp7dR6JhRGfx0I3kna7asuCOXRqcxNkhPPcMSZHPL/3g
hKiHODtNSpBdJ02FZKo1zJYpdGEeckD+jDoTK1dFb8/VTAlODi+clRSdhG7s
zyR4zx43lEFKQ4OFhLw2iUEQXSJhAAsNDOYelkM1jLfLui+Ke0a7Ee7pOc82
XRKcnsJhWcPEPWEeYhjB8g2bkhb0z1EdA9u32Pbpiv9L4l6RS9AKhpyDuDP+
K8XSrGnT/YTiD5T2yNFj4jBC88aM1CObiM5An4wBuWd3vTBxZjmNm5p//1JS
D58zGCXo/k8d9UXnqd4I8fpWVIO/ZyuGFHVzZyT2xl/4LSQ1kyuXedfjkkh3
ycq58A+z9k/tVl627v3I9BKgjQHhKdofcaGHEyoOuI1afsT5BcEkSEggLvI9
OylVD+wKPV26AK9rFm2zKkECQx0Umy2RijqGkG2ilpqOCek/SSmb5sDnb2Qt
JxJaqKioiAKyB1+wDCSuWBYbJV5TVNK2KGwOLVDuLNFqBNFe1h4MpZapLkH4
BRT6shpUG5/BD/sk4Qza1Y3ftfz+YadOiLy6SdETxDK40CaFKPtcvfJY9mdT
GRGhBzU4b0p0MDCxlF56y1fuX6hlMJrSTXHnx53gReae0kgRgoXIXFkonBx6
d4Jjsq17JeR1ulS6CBBIgLYekecFp0FvPOPYCLKRRHo7ko2aZ0CMSBEsSUxG
KQ3NbFLn4jMKTK41HQNi9NgioWQPg+me2CJlk92K/yS5oxsApRcrrcNKI7AH
XQlezDNVlplECYXeCcyWeuM7AWfYi3XSYf90WbscscoolxYq98RWcRkIFjIa
r9vXqhmDJkksGYeRNGNAyBOBCSKqvpbxezskVyCMZ1Irm5Gz5MFL2vrwC3nW
I6bU8hsTsrTdIt8MnWCTY5JgTL6XXn3biTEnTQEaeXutkpkFdXSh913Jkvqn
tVHn9K096qrFIiCxnC3GoigKPFQQ+sPYOFYP3zLPmi4/q0ie17Ypiob3AqU+
MkKtE9vKk+VLm90+W63fal9308riL835U6YSidyRN8cc2bULMnxmDfMsroGq
upaMsqBFI6Z0lU45ZskjqZ3B1KykpG3L/K7DCYpYr9HOvacMjIZ56jnVG8hT
x3FYgBULiGLanmJdhZ8u6rwiDcA6wXAstk5hsu/phIIJLfE51kVXdKH/noHi
urMT56cAvWPL18nRdUu1x70oSgjjivAL2wfIw2P8mgVPT5hytzTdj97l/+4J
qof70e+P8HQRF1b4v1U5wOKXM0/BBUvSjYLKPfxICHMW6bpStDdZqB/ldRxK
4CXJHJjbajx9wWWJ6I7FLSQ3gMqxxHBL7PE5mu+BpED2WEYeI2W8V9B9S03H
+AJbaJ55JO0OwKGo4Pyvf/hHKht4bzenw8/2LD+jUMaSUttwLLrQWB+3Kenb
FlT5lC2kdTxRrGVsyQJVDt9R6TM/k71BDhxs0eAY2oNXkCnVaRjJkTuaydFx
Q/pM3wlIo3KGAzAlwSx2R6MrJCjzs+E/v7OTJrMMOw4+JpdMmXI3uvR9WP6S
KqRDgtJ1n2z7pqnAdQwvsxoMSiUe79u01SqZHJYuajSrYx+6NS6hck2SX/45
uy09afVXKaNuQ44b6Rq4PoCXUrtpoA6SFqirWKBekeugTK1KMNsSSeF1HEpA
+u/3lNN/4MwjTIjUBnK4QI/243W2f2seOZWVccLOqtmil01nO5DHQqIfrhxD
I10GeOeViExJpwGOktOxaC9Zeg5G7PkfH8Hdl+jAKwelXK1xPXKeeFd13Y5L
hp6xueHRwVdfk/sYE6Gt7TCB4ZF9m+h0xxgnM/uEzqg6IDA6FlNL4cUrgvel
8JHeTmF5I+aEYfnwXfJK5z0mNCkAbMULx4NTNY80dRFbIeLFyQD07sEjO5e/
1+3lbycefU8yEQG5UwxAN83hYNPD+F39hX6/FzDqBIW+p/En8iQw66A/PAwU
P6dmmtzZLUcVzUhhVAchoRl1dCp/ykrhz4iNQ50PrQzhhdMCvwEFavovi3HB
GUXwyq5LOfULFt6aFQOD3nMQyq5LdgymThM1Us/sjqSaULWGTIQXTIldhafD
OUhAfYBgwXi9W1Q/9dAkkuMZ/+Hc3VHPANTJNJ/sFIZphd4kOdoEku9Wq3dc
cbETnw5a3elT6E4Xn4JCHBK3+Ovq1m0bU6O8I1G0bqvDhckj8gZEoSMgh5Yt
A6xFM7JKqiswWQsozUEhEIL9PVw4VhrsmMchX0P7iMJZg2HUYYQV6VTepf0x
pyWDt+7xjZRWMS1jOprXrOMu6lgW4D4y7XjWAaDLQUUYz2EK6DwX2nd/Dxl0
2s5ORYhn1bA5vyaii9Cb3cFbzrQXPJtQLZld5OVB92M+odLCEcIa5h1dROkF
TZRQdVliPydNe4eOHPMgr9RO8uDYH8V/SSJHnKNwNovLt/9Y8guemaNG/mFb
vBkeI7Mh9iiuSmwUlNmbbQ+MLy4c68Xp5OHZXbk/+OYRoc+xqHLxISi2WgG2
ob0YDv4OLZiCTzm8ORxaIGUFxI2eiQ2wM+L04x08f2iGvHPg5e8zfm1WeNQ0
2bazP6xC9XHP+Syndp2Xraig3EQFaHA9nVboVCZg0+FCezATBrGo67o0TraP
XxbhgDFFP2t0fj/1Lt6nWHRWVG44y/3LkurF8anUqhWBXbADGK6w8zq1Mn2i
OJj1SB9U+O6PTBkA2T7kx477n2bXsyT1oMDcSRq/+MhVtAzpJ2ZX6cTpWspt
WJQOQ0yV4Oi0if1rspt4R/vuURVmdXgBRymOBbYR89IMhj5AWGJ09SYy+fFO
Q+fELqh+iY5ElFKUY4Tx/XVZ1vkuFZTZf0JAkx0WOJJdgw7Z7VZPPb+C2MGJ
7N+3Tvw8k146aaeVlKtq44OhwncaFLJ9flNeOyQYEKY8p21b3zLQFdgR8DO6
dJ0q2L2dbb0hLhA9k4Ck+tnPf/OfBdqiD6B//SPTuWmS1tXK7KPzrGn6kYKf
R2U1yAdmt9wQmBnGQ8OSo8qEaYC6JJHM02VbCWkkiGARsSt0TiBnGMlIGMvF
klAKxHJx2X8YQdPW3kYLigA9IqrDhTHQQMffOdH2RVvLpMp2oscCDRDsY9zU
Ofx9BsKWDexYsx0X04OuWyTRIBTAf4hTJHrjVUJw4HuQquqbvy19G5Nr75uT
m3kWgHP5zRFJaQGXoPEUuPFs8xVdv3BTPVMnzeFupFqQy0YZ/83jwRRxfp7X
M2GwluRA+e/h0CIpssbwupAD8ZJaseqP8bXUF3EOsC5iLzTLBuTNSsomkJ/B
fmKKccJvUN6J5XgGnRSQZtAM/t0rcxh6O8eygWHc4+pFB1ENLVTVUBfC2wEm
iqH+6Z1y4JRBsiG8zRIZwrtmKncPqo6KiMA5nghOIe/ULqn/46S3X1orWw0G
Hez4VMFzVAIxex4FNSjkMHAUAflHgAoNJhXhX3c6Au5nHZf24LkF1Kb1WWB0
N8urciJTIsoeSW3sXHQB96g868XGHkHukaAsGQcBhz7uBWJL74AcoK2xktwz
VhtLM5UNvU/H2bHsHspVzIQvPOQRIceFQq2jZS6k31MAY7ylj9No0u81qsdF
q2w/52EdYu2mMo5pYCQK29ZlKSEcw0PW0SmT03zJJCvha9GiAuMCfcMvwGAe
dGDitytOly7JOAWdN/QcFulPOR0Vh6VQmHKGWc7ymavaTVCkA346lTsupIDM
o2oGQTz4xmGKLZ6jouZFiRuQlAMWRTLV+8wItQ8tU0KJajFB1gTryKxUbbno
D0MbCPQQoS5o1jO6Qh4JzawXc2LBgplVHokttLK6Zi8MWpSPt7w93kS4jfKQ
tktoitfJCXv7oPT2laxRav2VPc/KOLOP5NclcKmewd2WRBTCmmceh1mm0dZ5
aKbwz1+wvSoHOFVM8Yp8BZFFvsI+euj5ZbNKazhzgNW+Ot1cGV958Yh9/x7i
Uh58/Gc0Oqeaduon7upmCRl5bfMmK8GAuHsoGIrjdQOX5WcrctuumloTxrFR
mf7ki68EXaEZaOeHX9G19z+lFEcTFXXfYKh/TZ9cDbbocenqTdE1mUb6j6Yo
smBCNolKGpBDY9+yosdb0odXxQAAgQLkUP0mRyclVqxSfuctOlc9KfGh5CFg
FtL7aHjuGqXUXeG4eZXcw3MlrxXH3u5MwzoFxeVB15SquSXIH3djjBBhJ1cY
5RW6AOSe4MgULXq6L2z3DLsxVKKhOEBj/bKGCUtR4gOCkM+h6YJesSJ99lQT
Rs2TJFH8bneGbmyfkYTxOwFpmjCYDhUI75hiGRqFM4Bk2OLT5Rt0PKZ6Ny9s
LRt2DssGukJvPPAj5NIve1T/aocLYezmys50XBJ5HT1Gg3PX6Wz9qkBlVHNc
6yMQz9KB23JSS8CW1TKgSzH6M5qG7GdHNWHs86AbA2dBQgsmRRVSKlQLTFjh
nCaM6ylDVZTqYfm8KLgHEPJoVBnFscVBOQal28bBTVk2Imo4MVSOgHuyGjZ0
Z6dFmHM27AIzj/yTPqaxsHpFFh5nLRyxPrhd1P2uQlmrD02ZxpZ7UymGoyYN
h+FgqvWPX4D2+K0jTAXIArqF5I4Jro4pUaEKzLek5ZDC5c8pDPPtqS8kwNEx
h/QeZnvLeTeq4KAAAQ58glW6T1Pvxt4VhUsfZgYgsJ02fkFeOmqarZD/tf1W
gzmskFy5JJlP3TUk4IlFH90fwA86gQWV8IguVsE5kkSnMiVhGOLYVSGX3bj6
2K//4q+NP1W78bOigQEJhHHpmFn7GNs7po3o4p2fCtItxs8i5Hc7/arDs59+
5STMKNfVD16WxoLyzosirA0Dm6LlWknWrj+kUwyhgF/xazH4oRwbczYsOKBj
CUfXLQO4MRUcEKCwdlC1E+pHCvA8KgJnmq7rM9LaQ/ArpsVfDn2xqG3e/5XV
3GpmhOCG5IxCcM3ReIHxgzuSQUOiGP1OqHehuxEOKwRnDxiQAMhoZwYGfNfp
sdbZh1IDwDlCiA02/Y7zElStvx2dv2YJ+sft8KN3mbVL0iQt8FMO3c5J84Z1
KsksQZ+JhxfCpcUPKXI0Udt+LM91CSgRB7KBT6+7ZJ0XfNnpxIWCbuHUNql+
DwRt5haU07NLP0fVkqiuSNl3/AKhlkyX2SXwuYDc/XuWQCh69rOLwq+L4UJh
GzYfgY5diAHeXIZTGl5GcytXzHDa6wERNE4/IvfQs+SOnsjsKTEmSKBqGO4y
nH3hejj93aMffcma/VgO4aBhBa4ZgSXslcvqHlsaq0NjhLbRZRvSB26FwmxK
5NEnNrpEWxXg48637CGLyy37eq1b/7q/j2n9cfuD/weBTqmw\
\>"]]
}, Closed]],

Cell["\<\
One of the advantages of representing these random walks as graphs is that \
you have all the graph formatting and styling functions available to quickly \
modify your graph.\
\>", "SolutionText",
 CellTags->"13.1 Solutions"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"steps", "=", "1500"}], "}"}], ",", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"bonds", "[", "steps", "]"}], ",", 
     RowBox[{"DirectedEdges", "\[Rule]", "False"}], ",", 
     RowBox[{"EdgeStyle", "\[Rule]", "Gray"}], ",", 
     RowBox[{"VertexSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Scaled\>\"", ",", ".025"}], "}"}]}], ",", 
        RowBox[{"steps", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Scaled\>\"", ",", ".025"}], "}"}]}]}], "}"}]}], ",", 
     RowBox[{"VertexStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Opacity", "[", "0.4", "]"}], ",", "Green"}], "}"}]}], ",", 
        RowBox[{"steps", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Opacity", "[", "0.4", "]"}], ",", "Red"}], "}"}]}]}], 
       "}"}]}], ",", 
     RowBox[{"VertexCoordinates", "\[Rule]", 
      RowBox[{"RandomWalk", "[", 
       RowBox[{"steps", ",", 
        RowBox[{"LatticeWalk", "\[Rule]", "False"}]}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellTags->"13.1 Solutions"],

Cell[TextData[{
 "The disadvantage of this approach is that it is limited to two-dimensional \
walks. ",
 Cell[BoxData[
  ButtonBox["Graph",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Graph"]], "InlineFormula"],
 " does not support three-dimensional objects and it does not make much sense \
in one dimension."
}], "SolutionText",
 CellTags->"13.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Creating packages", "ExerciseSubsection",
 CounterAssignments->{{"Section", 3}, {"ExerciseItem", 0}}],

Cell[CellGroupData[{

Cell[TextData[{
 "The following set of exercises will walk you through the creation of a \
package ",
 StyleBox["Collatz", "ExerciseMR", "ExLinkj"],
 ", a package of functions for performing various operations related to the \
Collatz problem that we investigated earlier (Exercises ",
 StyleBox["3", "OsF"],
 " and ",
 StyleBox["4", "OsF"],
 " of Section ",
 StyleBox["4.1", "OsF"],
 ", Exercise ",
 StyleBox["6", "OsF"],
 " of Section ",
 StyleBox["6.2", "OsF"],
 ", and Exercise ",
 StyleBox["4", "OsF"],
 " of Section ",
 StyleBox["7.3", "OsF"],
 "). Recall that the Collatz function, for any integer ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", returns ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     StyleBox["3", "OsF"], "n"}], "+", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " for odd ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 " for even ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ". The (as yet unproven) Collatz Conjecture is the statement that, for any \
initial positive integer ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 ", the iterates of the Collatz function always reach the cycle ",
 StyleBox["4, 2, 1,", "OsF"],
 "\[Ellipsis]. Start by creating an auxiliary function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["collatz", "ExerciseMR"], 
   StyleBox["[", "ExerciseMR"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExerciseMR"]}]]],
 " that returns ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     StyleBox["3", "OsF"], "n"}], "+", 
    StyleBox["1", "OsF"]}], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " odd and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "/", 
    StyleBox["2", "OsF"]}], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " even."
}], "ExerciseItem",
 CellTags->{"13.4 Exercises", "i:49"}],

Cell[CellGroupData[{

Cell[TextData[{
 "Create the function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["CollatzSequence", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 " that lists the iterates of the auxiliary function ",
 Cell[BoxData[
  RowBox[{
   StyleBox["collatz", "ExLink"], 
   StyleBox["[", "ExLink"], 
   StyleBox["n", "ExerciseTI"], 
   StyleBox["]", "ExLink"]}]]],
 ". Here is some sample output of the ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "MR", "ExLink"]]],
 " function."
}], "ExerciseSubItem",
 CellTags->"13.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", "7", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "7", ",", "22", ",", "11", ",", "34", ",", "17", ",", "52", ",", "26", ",", 
   "13", ",", "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", 
   "4", ",", "2", ",", "1"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"13.4 Exercises"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Create a usage message for ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExLink"]]],
 " and warning messages for each of the following situations:"
}], "ExerciseSubItem",
 CellTags->"13.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  StyleBox["notint", "ExLink"]]],
 ": the argument to ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExLink"]]],
 " is not a positive integer"
}], "ExerciseText",
 CellTags->"13.4 Exercises"],

Cell[TextData[{
 Cell[BoxData[
  StyleBox["argx", "ExLink"]]],
 ": ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExLink"]]],
 " was called with the wrong number of arguments"
}], "ExerciseText",
 CellTags->"13.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "Modify the definition of ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExerciseMR"]]],
 " that you created in part a. above so that it does some error trapping and \
issues the appropriate warning message that you created in part b",
 StyleBox[".", "OsF"]
}], "ExerciseSubItem",
 CellTags->"13.4 Exercises"],

Cell[CellGroupData[{

Cell[TextData[{
 "Finally, put all the pieces together and write a package ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    StyleBox["Collatz", "ExLink"], "`"}]]]],
 " that includes the appropriate ",
 Cell[BoxData[
  ButtonBox["BeginPackage",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/BeginPackage"]]],
 " and ",
 Cell[BoxData[
  ButtonBox["Begin",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/Begin"]]],
 " statements, usage messages, warning messages, and function definitions. \
Make ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExerciseMR"]]],
 " a public function and ",
 Cell[BoxData[
  StyleBox["collatz", "ExerciseMR"]]],
 " a private function. Put your package in a directory where ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " can find it on its search path and then test it to see that it returns \
correct output such as in the examples below."
}], "ExerciseSubItem",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Quit", "[", "]"}], ";"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{"<<", "PwM`Collatz`"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CollatzSequence"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 StyleBox["\<\"CollatzSequence[\!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\)] \
computes the sequence of Collatz iterates starting with initial value \
\!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\). The sequence terminates as soon \
as it reaches the value 1.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->{"13.4 Exercises", "Info3560500981-5226863"}]
}, Closed]],

Cell[TextData[{
 "Here are various cases in which ",
 Cell[BoxData[
  StyleBox["CollatzSequence", "ExLink"]]],
 " is given bad input."
}], "ExerciseText",
 CellTags->"13.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", 
  RowBox[{"-", "5"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"CollatzSequence", "::", "notint"}], "MessageName"], ":", 
  " ", "\<\"First argument, \[NoBreak]\\!\\(-5\\)\[NoBreak], to \
CollatzSequence must be a positive integer.\"\>"}]], "Message", "MSG",
 CellTags->"13.4 Exercises"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", 
  RowBox[{"4", ",", "6"}], "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"CollatzSequence", "::", "argx"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(CollatzSequence\\)\[NoBreak] called with \
\[NoBreak]\\!\\(2\\)\[NoBreak] arguments; 1 argument is expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argx\\\", \
ButtonNote -> \\\"PwM`Collatz`CollatzSequence::argx\\\"]\\)\"\>"}]], "Message",\
 "MSG",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", 
  RowBox[{"4", ",", "6"}], "]"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"13.4 Exercises"]
}, Closed]],

Cell[TextData[{
 "And this computes the sequence for starting value ",
 StyleBox["27", "OsF"],
 "."
}], "ExerciseText",
 CellTags->"13.4 Exercises"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", "27", "]"}]], "ExerciseInput", "ExerciseMR",
 CellTags->"13.4 Exercises"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "27", ",", "82", ",", "41", ",", "124", ",", "62", ",", "31", ",", "94", 
   ",", "47", ",", "142", ",", "71", ",", "214", ",", "107", ",", "322", ",", 
   "161", ",", "484", ",", "242", ",", "121", ",", "364", ",", "182", ",", 
   "91", ",", "274", ",", "137", ",", "412", ",", "206", ",", "103", ",", 
   "310", ",", "155", ",", "466", ",", "233", ",", "700", ",", "350", ",", 
   "175", ",", "526", ",", "263", ",", "790", ",", "395", ",", "1186", ",", 
   "593", ",", "1780", ",", "890", ",", "445", ",", "1336", ",", "668", ",", 
   "334", ",", "167", ",", "502", ",", "251", ",", "754", ",", "377", ",", 
   "1132", ",", "566", ",", "283", ",", "850", ",", "425", ",", "1276", ",", 
   "638", ",", "319", ",", "958", ",", "479", ",", "1438", ",", "719", ",", 
   "2158", ",", "1079", ",", "3238", ",", "1619", ",", "4858", ",", "2429", 
   ",", "7288", ",", "3644", ",", "1822", ",", "911", ",", "2734", ",", 
   "1367", ",", "4102", ",", "2051", ",", "6154", ",", "3077", ",", "9232", 
   ",", "4616", ",", "2308", ",", "1154", ",", "577", ",", "1732", ",", "866",
    ",", "433", ",", "1300", ",", "650", ",", "325", ",", "976", ",", "488", 
   ",", "244", ",", "122", ",", "61", ",", "184", ",", "92", ",", "46", ",", 
   "23", ",", "70", ",", "35", ",", "106", ",", "53", ",", "160", ",", "80", 
   ",", "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", "4", 
   ",", "2", ",", "1"}], "}"}]], "ExerciseOutput", "ExerciseMR",
 CellTags->"13.4 Exercises"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[TextData[{
 "The square end-to-end distance of a two-dimensional walk is defined as ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["x", "f"], "-", 
       SubscriptBox["x", "i"]}], ")"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["y", "f"], "-", 
       SubscriptBox["y", "i"]}], ")"}], "2"]}], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "i"], ",", 
     SubscriptBox["y", "i"]}], "}"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "f"], ",", 
     SubscriptBox["y", "f"]}], "}"}], TraditionalForm]]],
 " are the initial and final locations of the walk, respectively. Assuming \
the initial point is the origin, then this simplifies to ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubsuperscriptBox["x", "f", "2"], "+", 
    SubsuperscriptBox["y", "f", "2"]}], TraditionalForm]]],
 ". Write a function ",
 Cell[BoxData[
  StyleBox["SquareDistance", "ExLink"]]],
 " that takes a two-dimensional walk as an argument and computes the square \
end-to-end distance. Write a usage message and include this function as a \
publicly exported function in the ",
 "RandomWalks",
 " package."
}], "ExerciseItem",
 CellTags->{"i:48", "13.4 Exercises"}],

Cell[CellGroupData[{

Cell["Solutions", "SolutionSubsection"],

Cell[CellGroupData[{

Cell[TextData[{
 "Here are the definitions for the auxiliary ",
 Cell[BoxData["collatz"]],
 " function."
}], "SolutionItem",
 CounterAssignments->{{"SolutionItem", 0}},
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  RowBox[{"n", "/", "2"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"3", "n"}], "+", "1"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[CellGroupData[{

Cell[TextData[{
 "This is essentially the definition given in the solution to Exercise ",
 StyleBox["5", "OsF"],
 " from Section ",
 StyleBox["6.2", "OsF"],
 "."
}], "SolutionSubItem",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CollatzSequence", "[", "n_", "]"}], ":=", 
  RowBox[{"NestWhileList", "[", 
   RowBox[{"collatz", ",", "n", ",", 
    RowBox[{
     RowBox[{"#", "\[NotEqual]", "1"}], "&"}]}], "]"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", "7", "]"}]], "Input",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "7", ",", "22", ",", "11", ",", "34", ",", "17", ",", "52", ",", "26", ",", 
   "13", ",", "40", ",", "20", ",", "10", ",", "5", ",", "16", ",", "8", ",", 
   "4", ",", "2", ",", "1"}], "}"}]], "Output",
 CellTags->"13.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "First we write the usage message for ",
 Cell[BoxData["CollatzSequence"]],
 ", our public function. Notice that we write no usage message for the \
private ",
 Cell[BoxData["collatz"]],
 " function."
}], "SolutionSubItem",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "usage"}], "=", 
   "\"\<CollatzSequence[n] computes the sequence of Collatz iterates starting \
with initial value n. The sequence terminates as soon as it reaches the value \
1.\>\""}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[TextData[{
 "Here is the warning message that will be issued whenever ",
 Cell[BoxData["CollatzSequence"]],
 " is passed an argument that is not a positive integer."
}], "SolutionText",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "notint"}], "=", 
   "\"\<First argument, `1`, to CollatzSequence must be a positive integer.\>\
\""}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Here is the modified definition which now issues the warning message \
created",
 " ",
 "above whenever the argument ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " is not a positive integer."
}], "SolutionSubItem",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CollatzSequence", "[", "n_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
     RowBox[{"n", "\[GreaterEqual]", "0"}]}], ",", 
    RowBox[{"NestWhileList", "[", 
     RowBox[{"collatz", ",", "n", ",", 
      RowBox[{
       RowBox[{"#", "\[NotEqual]", "1"}], "&"}]}], "]"}], ",", 
    RowBox[{"Message", "[", 
     RowBox[{
      StyleBox[
       RowBox[{"CollatzSequence", "::", "notint"}], "MessageName"], ",", 
      "n"}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[TextData[{
 "The following case covers the situation when ",
 Cell[BoxData["CollatzSequence"]],
 " is passed two or more arguments. Note that it uses the built-in ",
 Cell[BoxData["argx"]],
 " message, which is issued whenever built-in functions are passed the wrong \
number of arguments."
}], "SolutionText",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "[", 
    RowBox[{"_", ",", "args__"}], "]"}], "/;", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{
      StyleBox["CollatzSequence", "Color1"], "::", "argx"}], ",", 
     "CollatzSequence", ",", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"{", "args", "}"}], "]"}], "+", "1"}]}], "]"}]}], ":=", 
  "Null"}]], "InputOnly",
 CellTags->"13.4 Solutions"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "The package begins by giving ",
 StyleBox["usage messages", "TermDefinition"],
 " for every exported function. The functions to be exported are ",
 StyleBox["mentioned",
  FontSlant->"Italic"],
 " here \[Dash]",
 StyleBox[" before",
  FontSlant->"Italic"],
 " the subcontext ",
 Cell[BoxData["Private`"]],
 " is entered \[Dash] so that the symbol ",
 Cell[BoxData["CollatzSequence"]],
 " has context ",
 Cell[BoxData["Collatz`"]],
 ". Notice that ",
 Cell[BoxData["collatz"]],
 " is ",
 StyleBox["not",
  FontSlant->"Italic"],
 " mentioned here and hence will not be accessible to the user of this \
package."
}], "SolutionSubItem",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", "\"\<PwM`Collatz`\>\"", "]"}], 
  ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "usage"}], "=", 
   "\"\<CollatzSequence[n] computes the sequence of Collatz iterates starting \
with initial value n. The sequence terminates as soon as it reaches the value \
1.\>\""}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "notint"}], "=", 
   "\"\<First argument, `1`, to CollatzSequence must be a positive integer.\>\
\""}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[TextData[{
 "A new context ",
 Cell[BoxData["PwM`Collatz`Private`"]],
 " is then begun ",
 StyleBox["within",
  FontSlant->"Italic"],
 " ",
 Cell[BoxData["PwM`Collatz"]],
 ". All the definitions of this package are given within this new context. \
The context ",
 Cell[BoxData["PwM`Collatz`CollatzSequence"]],
 " is defined within the ",
 Cell[BoxData["System`"]],
 " context. The context of ",
 Cell[BoxData["collatz"]],
 ", on the other hand, is ",
 Cell[BoxData["PwM`Collatz`Private`"]],
 "."
}], "SolutionText",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  RowBox[{"n", "/", "2"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"3", "n"}], "+", "1"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CollatzSequence", "[", "n_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
     RowBox[{"n", "\[GreaterEqual]", "0"}]}], ",", 
    RowBox[{"NestWhileList", "[", 
     RowBox[{"collatz", ",", "n", ",", 
      RowBox[{
       RowBox[{"#", "\[NotEqual]", "1"}], "&"}]}], "]"}], ",", 
    RowBox[{"Message", "[", 
     RowBox[{
      StyleBox[
       RowBox[{"CollatzSequence", "::", "notint"}], "MessageName"], ",", 
      "n"}], "]"}]}], "]"}]}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "[", 
    RowBox[{"_", ",", "args__"}], "]"}], "/;", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{
      StyleBox["CollatzSequence", "Color1"], "::", "argx"}], ",", 
     "CollatzSequence", ",", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"{", "args", "}"}], "]"}], "+", "1"}]}], "]"}]}], ":=", 
  "Null"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "InputOnly",
 CellTags->"13.4 Solutions"],

Cell[TextData[{
 "After the ",
 Cell[BoxData[
  RowBox[{"End", "[", "]"}]]],
 " and ",
 Cell[BoxData[
  RowBox[{"EndPackage", "[", "]"}]]],
 " functions are evaluated, ",
 Cell[BoxData[
  ButtonBox["$Context",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/$Context"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["$ContextPath",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/$ContextPath"]], "InlineFormula"],
 " revert to whatever they were before, except that ",
 Cell[BoxData["PwM`Collatz`"]],
 " is added to ",
 Cell[BoxData[
  ButtonBox["$ContextPath",
   BaseStyle->"ExLink",
   ButtonData->"paclet:ref/$ContextPath"]], "InlineFormula"],
 ". Users can refer to ",
 Cell[BoxData["CollatzSequence"]],
 " using its short name, but they can only refer to the auxiliary function ",
 Cell[BoxData["collatz"]],
 " by its full name. The intent is to discourage clients from using ",
 Cell[BoxData["collatz"]],
 " at all, and doing so should definitely be avoided, since the author of the \
package may change or remove auxiliary definitions at a later time."
}], "SolutionText",
 CellTags->"13.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
},
ScreenStyleEnvironment->"Working",
WindowSize->{1074, 806},
WindowMargins->{{280, Automatic}, {Automatic, 60}},
WindowTitle->None,
DockedCells->{
  Cell[
   BoxData[
    TagBox[
     GridBox[{{
        ItemBox[
         StyleBox[
         "\"Exercises and solutions for\"", "Subsection", FontSize -> 28, 
          FontSlant -> "Plain", FontColor -> GrayLevel[1], FontWeight -> 
          "Bold", StripOnInput -> False], StripOnInput -> False]}, {
        ItemBox[
         TagBox[
          ButtonBox[
           
           PaneSelectorBox[{
            False -> StyleBox[
              "\"Programming with Mathematica: An Introduction\"", 
               "Subsection", FontSize -> 22, FontColor -> 
               CMYKColor[0.04, 0.44, 0.91, 0.11], FontWeight -> "Bold", 
               AutoSpacing -> False, StripOnInput -> False], True -> 
             StyleBox[
               StyleBox[
               "\"Programming with Mathematica: An Introduction\"", 
                "Subsection", FontSize -> 22, FontColor -> 
                CMYKColor[0.04, 0.44, 0.91, 0.11], FontWeight -> "Bold", 
                AutoSpacing -> False, StripOnInput -> False], {
               "HyperlinkActive"}]}, 
            Dynamic[
             CurrentValue["MouseOver"]], BaselinePosition -> Baseline, 
            BaseStyle -> {"Hyperlink"}, FrameMargins -> 0, ImageSize -> 
            Automatic], BaseStyle -> "Hyperlink", ButtonData -> {
             URL["http://www.cambridge.org/wellin"], None}, ButtonNote -> 
           "http://www.cambridge.org/wellin"], 
          Annotation[#, "http://www.cambridge.org/wellin", "Hyperlink"]& ], 
         StripOnInput -> False]}}, AutoDelete -> False, 
      GridBoxItemSize -> {
       "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"]], 
   "DockedCell", "Text", TextAlignment -> Center, CellSize -> {100, 56}, 
   Background -> GrayLevel[0.3], CellMargins -> {{0, 0}, {0, 0}}], 
  Cell[
   BoxData[
    TemplateBox[{
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"2  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["2  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"2.1 Expressions\"" :> NotebookLocate["2.1 Exercises"], 
         "\"2.2 Definitions\"" :> NotebookLocate["2.2 Exercises"], 
         "\"2.3 Predicates and Boolean operations\"" :> 
         NotebookLocate["2.3 Exercises"], "\"2.4 Attributes\"" :> 
         NotebookLocate["2.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"3  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["3  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"3.1 Creating and displaying lists\"" :> 
         NotebookLocate["3.1 Exercises"], "\"3.2 The structure of lists\"" :> 
         NotebookLocate["3.2 Exercises"], "\"3.3 Operations on lists\"" :> 
         NotebookLocate["3.3 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"4  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["4  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"4.1 Patterns\"" :> NotebookLocate["4.1 Exercises"], 
         "\"4.2 Transformation rules\"" :> NotebookLocate["4.2 Exercises"], 
         "\"4.3 Examples and applications\"" :> 
         NotebookLocate["4.3 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"5  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["5  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"5.2 Functions for manipulating expressions\"" :> 
         NotebookLocate["5.2 Exercises"], "\"5.3 Iterating functions\"" :> 
         NotebookLocate["5.3 Exercises"], "\"5.4 Programs as functions\"" :> 
         NotebookLocate["5.4 Exercises"], "\"5.5 Scoping constructs\"" :> 
         NotebookLocate["5.5 Exercises"], "\"5.6 Pure functions\"" :> 
         NotebookLocate["5.6 Exercises"], "\"5.7 Options and messages\"" :> 
         NotebookLocate["5.4 Exercises"], "\"5.8 Examples and applications\"" :> 
         NotebookLocate["5.8 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"6  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["6  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"6.1 Loops and iteration\"" :> NotebookLocate["6.1 Exercises"], 
         "\"6.2 Flow control\"" :> NotebookLocate["6.2 Exercises"], 
         "\"6.3 Examples and applications\"" :> 
         NotebookLocate["6.3 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"7  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["7  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"7.1 Fibonacci numbers\"" :> NotebookLocate["7.1 Exercises"], 
         "\"7.2 Thinking recursively\"" :> NotebookLocate["7.2 Exercises"], 
         "\"7.3 Dynamic programming\"" :> NotebookLocate["7.3 Exercises"], 
         "\"7.4 Classical examples\"" :> NotebookLocate["7.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"8  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["8  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"8.1 Numbers in \
\\!\\(\\*\\nStyleBox[\\\"Mathematica\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"" :> 
         NotebookLocate["8.1 Exercises"], "\"8.2 Numerical computation\"" :> 
         NotebookLocate["8.2 Exercises"], "\"8.3 Arrays of numbers\"" :> 
         NotebookLocate["8.3 Exercises"], "\"8.4 Examples and applications\"" :> 
         NotebookLocate["8.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"9  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["9  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"9.1 Structure and syntax\"" :> NotebookLocate["9.1 Exercises"], 
         "\"9.2 Operations on strings\"" :> NotebookLocate["9.2 Exercises"], 
         "\"9.3 String patterns\"" :> NotebookLocate["9.3 Exercises"], 
         "\"9.4 Regular expressions\"" :> NotebookLocate["9.4 Exercises"], 
         "\"9.5 Examples and applications\"" :> 
         NotebookLocate["9.5 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"10  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["10  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"10.1 Structure of graphics\"" :> NotebookLocate["10.1 Exercises"], 
         "\"10.2 Efficient structures\"" :> NotebookLocate["10.2 Exercises"], 
         "\"10.3 Sound\"" :> NotebookLocate["10.3 Exercises"], 
         "\"10.4 Examples and applications\"" :> 
         NotebookLocate["10.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"11  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["11  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"11.1 Manipulating expressions\"" :> 
         NotebookLocate["11.1 Exercises"], 
         "\"11.2 The structure of dynamic expressions\"" :> 
         NotebookLocate["11.2 Exercises"], 
         "\"11.3 Examples and applications\"" :> 
         NotebookLocate["11.3 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"12  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["12  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"12.2 Efficient programs\"" :> NotebookLocate["12.2 Exercises"], 
         "\"12.3 Parallel processing\"" :> NotebookLocate["12.3 Exercises"], 
         "\"12.4 Compiling\"" :> NotebookLocate["12.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False], "\"\"", 
      FrameBox[
       ActionMenuBox[
        StyleBox[
         InterpretationBox[
         "\"13  \\!\\(\\*StyleBox[\\\"\[FilledDownTriangle]\\\", \
List[Rule[FontColor, RGBColor[0.72624`, 0.42363999999999996`, \
0.06808499999999995`]], 15], Rule[StripOnInput, False]]\\)\"", 
          StringForm["13  `1`", 
           
           Style[$CellContext`\[FilledDownTriangle], {
            FontColor -> 
             RGBColor[0.72624, 0.42363999999999996`, 0.06808499999999995], 
             15}]], Editable -> False], {
         "Menu", 14, FontColor -> GrayLevel[0]}, StripOnInput -> False], {
        "\"13.1 Random walk application\"" :> 
         NotebookLocate["13.1 Exercises"], "\"13.4 Creating packages\"" :> 
         NotebookLocate["13.4 Exercises"]}, {
        Appearance -> None, ImageSize -> {45, 16}}], Background -> 
       CMYKColor[0, 0.1, 0.6, 0], StripOnInput -> False]}, "Row", 
     DisplayFunction -> (
      RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
        "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
        "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7, 
        "\[InvisibleSpace]", #8, "\[InvisibleSpace]", #9, 
        "\[InvisibleSpace]", #10, "\[InvisibleSpace]", #11, 
        "\[InvisibleSpace]", #12, "\[InvisibleSpace]", #13, 
        "\[InvisibleSpace]", #14, "\[InvisibleSpace]", #15, 
        "\[InvisibleSpace]", #16, "\[InvisibleSpace]", #17, 
        "\[InvisibleSpace]", #18, "\[InvisibleSpace]", #19, 
        "\[InvisibleSpace]", #20, "\[InvisibleSpace]", #21, 
        "\[InvisibleSpace]", #22, "\[InvisibleSpace]", #23}]& ), 
     InterpretationFunction -> (RowBox[{"Row", "[", 
        RowBox[{"{", 
          RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
            ",", #8, ",", #9, ",", #10, ",", #11, ",", #12, ",", #13, 
            ",", #14, ",", #15, ",", #16, ",", #17, ",", #18, ",", #19, 
            ",", #20, ",", #21, ",", #22, ",", #23}], "}"}], "]"}]& )]], 
   "DockedCell", CellMargins -> {{0, 0}, {0, -2}}, TextAlignment -> Center, 
   Background -> GrayLevel[0.97], CellFrame -> 0, 
   CellFrameMargins -> {{0, 0}, {0, -1}}], 
  Cell["", CellMargins -> {{0, 0}, {10, 0}}]},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, 
   Cell[
    TextData[
     StyleBox[
      RowBox[{"Solutions", " ", "to", " ", "exercises"}], "Header"]], 
    "Header", CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}, {
   Cell[
    TextData[{
      StyleBox[
       RowBox[{
         CounterBox["Chapter"], "\[ThickSpace]\[ThickSpace]"}], "HeaderOsF"], 
      
      Cell[
       BoxData[
        FormBox[
         DynamicBox[
          ToBoxes[
           FEPrivate`RunningText["Chapter", 5, "", " .,", {}, True, 0], 
           StandardForm], ImageSizeCache -> {109., {3., 9.}}], TextForm]]]}], 
    "Header", CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, 
   
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell["Environment names", "Section", ShowGroupOpener -> True], 
      Cell[
       StyleData[All, "Working"]], 
      Cell[
       StyleData[All, "Printout"], Magnification -> 1.]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Headings", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Title"], 
          CellMargins -> {{Inherited, Inherited}, {-1, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False, 
          CellGroupingRules -> {"SectionGrouping", 30}], 
         Cell[
          StyleData[
          "Title", "Printout", StyleDefinitions -> StyleData["ChapterTitle"]],
           CellMargins -> {{0, 0}, {16, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 12, "ClosedCellHeight" -> 19, 
            "ClosedGroupTopMargin" -> 4}, CellOpen -> True, TextAlignment -> 
          Center, FontSize -> 28]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subtitle"], 
          CellMargins -> {{Inherited, Inherited}, {-1, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False, 
          CellGroupingRules -> {"SectionGrouping", 30}], 
         Cell[
          StyleData["Subtitle", "Printout"], CellMargins -> {{0, 0}, {16, 0}},
           CellElementSpacings -> {
           "CellMinHeight" -> 12, "ClosedCellHeight" -> 19, 
            "ClosedGroupTopMargin" -> 4}, CellOpen -> True, TextAlignment -> 
          Center, FontFamily -> "Times", FontSize -> 22]}, Closed]], 
      Cell[
       StyleData["TitleFlourish"], CellMargins -> {{0, 0}, {26, 6}}, 
       CellGroupingRules -> {"SectionGrouping", 30}, TextAlignment -> Center, 
       Magnification -> 1], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ChapterN"], CellMargins -> {{0, 0}, {0, 0}}, 
          CellGroupingRules -> {"SectionGrouping", 30}, TextAlignment -> 
          Center, CounterIncrements -> {{"Chapter"}}, MenuSortingValue -> 
          1010, FontFamily -> "Times", FontSize -> 32, FontWeight -> "Bold"], 
         
         Cell[
          StyleData["ChapterN", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
          TextAlignment -> Center, FontFamily -> "Times", FontSize -> 24, 
          FontWeight -> "Plain"]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ChapterTitle"], WholeCellGroupOpener -> True, 
          CellMargins -> {{0, 0}, {12, 12}}, 
          CellGroupingRules -> {"SectionGrouping", 30}, TextAlignment -> 
          Center, CounterAssignments -> {{"Section", 0}, {"Figure", 0}, {
            "SolutionItem", 0}}, MenuSortingValue -> 1100, MenuCommandKey -> 
          "1", FontFamily -> "Times", FontSize -> 30, FontWeight -> "Bold"], 
         Cell[
          StyleData["ChapterTitle", "Printout"], WholeCellGroupOpener -> 
          False, TextAlignment -> Center, FontFamily -> "Times", FontSize -> 
          22]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Nonprint", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionNonPrint"], 
          CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, Evaluatable -> 
          False, FontWeight -> "Plain", FontColor -> RGBColor[1, 0, 0]], 
         Cell[
          StyleData["SolutionNonPrint", "Printout"], 
          CellMargins -> {{Inherited, Inherited}, {-1, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsectionSpacer"], CellDingbat -> 
          Cell["Subsection spacer", "Menu", FontColor -> GrayLevel[1], 
            FontSize -> 8, Background -> GrayLevel[0.67]], 
          CellBracketOptions -> {
           "Color" -> RGBColor[1, 0, 0], "Thickness" -> 0.55}], 
         Cell[
          StyleData["SubsectionSpacer", "Printout"], CellDingbat -> None, 
          CellMargins -> {{Inherited, Inherited}, {0, 0}}, 
          CellElementSpacings -> {"CellMinHeight" -> 0}, PageBreakAbove -> 
          False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["NonPrintSolutionLink"], CellMargins -> {{46, 0}, {0, 6}},
           CellBracketOptions -> {
           "Color" -> RGBColor[1, 0, 0], "Thickness" -> 0.55}, 
          CellGroupingRules -> {"SectionGrouping", 55}, FontFamily -> "Times",
           FontSize -> 14, FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["NonPrintSolutionLink", "Printout"], 
          CellMargins -> {{Inherited, Inherited}, {-1, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["NonPrintInput", StyleDefinitions -> StyleData["Input"]], 
          CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
          CellGroupingRules -> {"SectionGrouping", 55}, FontWeight -> "Plain",
           FontColor -> RGBColor[1, 0, 0]], 
         Cell[
          StyleData["NonPrintInput", "Printout"], 
          CellMargins -> {{Inherited, Inherited}, {-1, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Editorial"], CellMargins -> {{24, 10}, {6, 6}}, 
          CellBracketOptions -> {
           "Color" -> RGBColor[1, 0, 0], "Thickness" -> 0.55}, 
          CellFrameLabels -> {{
             Cell[
              TextData[{"Edit:"}], FontFamily -> "Helvetica", FontSize -> 10, 
              FontWeight -> "Bold", CellBaseline -> Baseline], None}, {
            None, None}}, FontColor -> RGBColor[1, 0, 0]], 
         Cell[
          StyleData["Editorial", "Printout"], 
          CellMargins -> {{Inherited, Inherited}, {0, 0}}, 
          CellElementSpacings -> {
           "CellMinHeight" -> 0, "ClosedCellHeight" -> 0, 
            "ClosedGroupTopMargin" -> 0}, CellOpen -> False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData[
          "NonPrintSection", StyleDefinitions -> StyleData["Section"]], 
          CellFrame -> None, 
          CellBracketOptions -> {
           "Color" -> RGBColor[1, 0, 0], "Thickness" -> 0.55}, 
          CellGroupingRules -> {"SectionGrouping", 30}, 
          CellFrameLabels -> {{None, None}, {None, None}}, FontColor -> 
          GrayLevel[0.45]], 
         Cell[
          StyleData["NonPrintSection", "Printout"], 
          CellElementSpacings -> {
           "CellMinHeight" -> 1, "ClosedCellHeight" -> 0}, CellOpen -> 
          False]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Input/Output", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseInput", StyleDefinitions -> StyleData["Input"]], 
          GeneratedCellStyles -> {
           "Output" -> {"ExerciseOutput", "ExerciseMR"}}], 
         Cell[
          StyleData["ExerciseInput", "Printout"], 
          CellMargins -> {{60, Inherited}, {5, 0}}, ShowSyntaxStyles -> 
          True]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData[
          "ExerciseOutput", StyleDefinitions -> StyleData["Output"]]], 
         Cell[
          StyleData["ExerciseOutput", "Printout"], 
          CellMargins -> {{60, 24}, {5, 0}}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Input"], 
          CellMargins -> {{90, Inherited}, {Inherited, 9}}], 
         Cell[
          StyleData["Input", "Printout"], CellMargins -> {{72, 0}, {5, 5}}, 
          ShowSyntaxStyles -> True, FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["InputOnly"], CellMargins -> {{90, Inherited}, {0, 9}}], 
         Cell[
          StyleData["InputOnly", "Printout", StyleDefintions -> None], 
          CellMargins -> {{72, 0}, {5, 5}}, ShowSyntaxStyles -> True, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Output"], 
          CellMargins -> {{90, Inherited}, {Inherited, Inherited}}], 
         Cell[
          StyleData["Output", "Printout"], CellMargins -> {{72, 0}, {5, 0}}, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Print"], 
          CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
          CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
          False, DefaultFormatType -> DefaultOutputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, FormatType -> InputForm, CounterIncrements -> 
          "Print", StyleMenuListing -> None], 
         Cell[
          StyleData["Print", "Printout"], 
          CellMargins -> {{42, Inherited}, {6, 3}}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["CellLabel"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontColor -> RGBColor[0, 0, 1]], 
         Cell[
          StyleData["CellLabel", "Printout"], FontColor -> 
          RGBColor[0.247, 0.24, 0.6]]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Exercises", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseSubsection"], CellFrame -> None, ShowGroupOpener -> 
          True, CellMargins -> {{0, 0}, {2, 12}}, 
          CellGroupingRules -> {"SectionGrouping", 40}, CellFrameLabels -> {{
             Cell[
              TextData[{
                StyleBox[
                 CounterBox["Chapter"]], 
                StyleBox["."], 
                StyleBox[
                 CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, 
              FontSlant -> "Plain"], None}, {None, None}}, 
          CellFrameLabelMargins -> 0, TabSpacings -> 1.25, CounterIncrements -> 
          "Section", CounterAssignments -> {{"ExerciseItem", 0}}, FontSize -> 
          16, FontWeight -> "Plain"], 
         Cell[
          StyleData["ExerciseSubsection", "Printout"], CellFrame -> None, 
          ShowGroupOpener -> True, CellFrameLabels -> {{
             Cell[
              TextData[{
                StyleBox[
                 CounterBox["Chapter"]], 
                StyleBox["."], 
                StyleBox[
                 CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, 
              FontFamily -> "Times", FontSlant -> "Plain"], None}, {
            None, None}}, CellFrameLabelMargins -> 0, TabSpacings -> 1.25, 
          FontFamily -> "Times"]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseItem"], CellMargins -> {{12, 6}, {6, 5}}, 
          CellGroupingRules -> {"SectionGrouping", 53}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["ExerciseItem"], ".", "\t"}], FontWeight -> "Bold",
               CellBaseline -> Baseline], None}, {None, None}}, 
          CellFrameLabelMargins -> 0, Hyphenation -> True, 
          LineSpacing -> {1, 3}, TabSpacings -> 1.4, CounterIncrements -> 
          "ExerciseItem", CounterAssignments -> {{"ExerciseSubItem", 0}}, 
          MenuSortingValue -> 1700], 
         Cell[
          StyleData["ExerciseItem", "Printout"], 
          CellMargins -> {{18, 24}, {7, 5}}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["ExerciseItem"], ".", "\t"}], CellBaseline -> 
              Baseline, FontWeight -> "Bold"], None}, {None, None}}, 
          CellFrameLabelMargins -> 0, LineSpacing -> {1, 3}, TabSpacings -> 2,
           FontFamily -> "Times", FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseSubItem"], CellMargins -> {{24, 4}, {2, 6}}, 
          CellGroupingRules -> {"SectionGrouping", 56}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["ExerciseSubItem", CounterFunction -> (Part[
                   CharacterRange["a", "z"], #]& )], "."}], CellBaseline -> 
              Baseline, FontWeight -> "Bold"], None}, {None, None}}, 
          Hyphenation -> True, LineSpacing -> {1, 2}, 
          ParagraphSpacing -> {0, 0}, CounterIncrements -> "ExerciseSubItem"], 
         Cell[
          StyleData["ExerciseSubItem", "Printout"], 
          CellMargins -> {{34, 24}, {6, 0}}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["ExerciseSubItem", CounterFunction -> (Part[
                   CharacterRange["a", "z"], #]& )], "."}], FontSize -> 9, 
              CellBaseline -> Baseline], None}, {None, None}}, 
          LineSpacing -> {1, 2}, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseSubItemR"], CellMargins -> {{28, 4}, {0, 8}}, 
          CellGroupingRules -> {"SectionGrouping", 46}, CellFrameLabels -> {{
             Cell[
              TextData[{"(", 
                CounterBox[
                "ExerciseSubItem", CounterFunction -> RomanNumeral], ".", 
                ")\t"}], CellBaseline -> Baseline, FontWeight -> "Bold"], 
             None}, {None, None}}, Hyphenation -> True, LineSpacing -> {1, 2},
           ParagraphSpacing -> {0, 8}, TabSpacings -> 1.1, CounterIncrements -> 
          "ExerciseSubItem"], 
         Cell[
          StyleData["ExerciseSubItemR", "Printout"], 
          CellMargins -> {{32, 24}, {6, 0}}, CellFrameLabels -> {{
             Cell[
              TextData[{"(", 
                CounterBox[
                "ExerciseSubItem", CounterFunction -> RomanNumeral], ".", 
                ")\t"}], CellBaseline -> Baseline, FontWeight -> "Bold"], 
             None}, {None, None}}, LineSpacing -> {1, 3}, TabSpacings -> 2.8, 
          FontFamily -> "Times", FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseText"], CellMargins -> {{28, 4}, {5, 5}}, 
          Hyphenation -> True, LineSpacing -> {1, 3}, 
          ParagraphSpacing -> {0, 8}, CounterStyleMenuListing -> None], 
         Cell[
          StyleData["ExerciseText", "Printout"], 
          CellMargins -> {{36, 24}, {6, 0}}, FontFamily -> "Times", FontSize -> 
          10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData[
          "ExerciseDisplayFormula", StyleDefinitions -> 
           StyleData["DisplayFormula"]], 
          CellMargins -> {{52, Inherited}, {Inherited, Inherited}}], 
         Cell[
          StyleData["ExerciseDisplayFormula", "Printout"], 
          CellMargins -> {{52, Inherited}, {6, 0}}, FontFamily -> "Text", 
          FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Solutions", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionSubsection"], ShowGroupOpener -> True, 
          CellMargins -> {{26, Inherited}, {2, 12}}, 
          CellGroupingRules -> {"SectionGrouping", 45}, CellFrameLabels -> {{
             Cell[
              TextData[{
                StyleBox[
                 CounterBox["Chapter"]], 
                StyleBox["."], 
                StyleBox[
                 CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, 
              FontSlant -> "Plain"], None}, {None, None}}, 
          CellFrameLabelMargins -> 0, TabSpacings -> 1.25, 
          CounterAssignments -> {{"SolutionItem", 0}}, FontSize -> 16, 
          FontWeight -> "Plain", FontColor -> RGBColor[0.2, 0.2, 0.7]], 
         Cell[
          StyleData["SolutionSubsection", "Printout"], CellFrame -> None, 
          CellMargins -> {{36, 24}, {6, 12}}, CellFrameLabels -> {{
             Cell[
              TextData[{
                StyleBox[
                 CounterBox["Chapter"]], 
                StyleBox["."], 
                StyleBox[
                 CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, 
              FontSlant -> "Plain"], None}, {None, None}}, 
          CellFrameLabelMargins -> 0, TabSpacings -> 1.25, FontFamily -> 
          "Times"]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionItem"], CellMargins -> {{24, 4}, {0, 8}}, 
          CellGroupingRules -> {"SectionGrouping", 55}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> 
              Baseline, FontWeight -> "Bold"], None}, {None, None}}, 
          Hyphenation -> True, LineSpacing -> {1, 3}, 
          ParagraphSpacing -> {0, 8}, TabSpacings -> 1.75, CounterIncrements -> 
          "SolutionItem", CounterAssignments -> {{"SolutionSubItem", 0}}, 
          MenuSortingValue -> 1300, MenuCommandKey -> "6"], 
         Cell[
          StyleData["SolutionItem", "Printout"], 
          CellMargins -> {{36, 0}, {2, 0}}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> 
              Baseline, FontWeight -> "Bold"], None}, {None, None}}, 
          TabSpacings -> 2.2, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionSubItem"], CellMargins -> {{48, 4}, {0, 8}}, 
          CellGroupingRules -> {"SectionGrouping", 60}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["SolutionSubItem"], "."}], CellBaseline -> 
              Baseline, FontWeight -> "Bold", 
              CounterBoxOptions -> {CounterFunction :> (Part[
                  CharacterRange["a", "z"], #]& )}], None}, {None, None}}, 
          Hyphenation -> True, LineSpacing -> {1, 3}, 
          ParagraphSpacing -> {0, 8}, CounterIncrements -> "SolutionSubItem", 
          MenuSortingValue -> 1410, MenuCommandKey -> "8"], 
         Cell[
          StyleData["SolutionSubItem", "Printout"], 
          CellMargins -> {{36, 0}, {5, 3}}, CellFrameLabels -> {{
             Cell[
              TextData[{
                CounterBox["SolutionSubItem"], "."}], CellBaseline -> 
              Baseline, CounterBoxOptions -> {CounterFunction :> (Part[
                  CharacterRange["a", "z"], #]& )}], None}, {None, None}}, 
          LineSpacing -> {1, 1}, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionText"], CellMargins -> {{48, 4}, {0, 8}}, 
          Hyphenation -> True, LineSpacing -> {1, 3}, 
          ParagraphSpacing -> {0, 8}, MenuSortingValue -> 1400, 
          MenuCommandKey -> "7", CounterStyleMenuListing -> None], 
         Cell[
          StyleData["SolutionText", "Printout"], 
          CellMargins -> {{48, 0}, {5, 2}}, FontFamily -> "Times", FontSize -> 
          10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SolutionsPageRef"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SolutionsPageRef", "Printout"], 
          CellMargins -> {{0, 0}, {4, 1}}, StyleMenuListing -> None, 
          FontFamily -> "Times", FontSize -> 10, FontSlant -> "Italic"]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Formulas and programs", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData[
          "ExerciseDisplayFormula", StyleDefinitions -> 
           StyleData["DisplayFormula"]]], 
         Cell[
          StyleData["ExerciseDisplayFormula", "Printout"], 
          CellMargins -> {{24, Inherited}, {10, 0}}, FontFamily -> "Times", 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["DisplayFormula"], 
          CellMargins -> {{36, Inherited}, {Inherited, Inherited}}, 
          CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultTraditionalFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           LanguageCategory -> "Formula", ScriptLevel -> 0, 
          SingleLetterItalics -> True, 
          UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
         Cell[
          StyleData["DisplayFormula", "Printout"], 
          CellMargins -> {{60, Inherited}, {7, 6}}, FontFamily -> "Times", 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Program"], CellFrame -> 0, 
          CellMargins -> {{90, 0}, {4, 12}}], 
         Cell[
          StyleData["Program", "Printout"], CellMargins -> {{48, 0}, {3, 1}}, 
          PageBreakBelow -> False, FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Styles for automatic numbering", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["NumberedFigure"], CellMargins -> {{36, 4}, {0, 12}}, 
          CellGroupingRules -> "InputGrouping", CellFrameLabels -> {{
             Cell[
              TextData[{"Figure ", 
                CounterBox["Chapter"], ".", 
                CounterBox["NumberedFigure"], "\t"}], CellBaseline -> 
              Baseline, FontFamily -> "Lucida Grande", FontSize -> 11], 
             None}, {None, None}}, TabSpacings -> 1.1, CounterIncrements -> 
          "NumberedFigure", MenuSortingValue -> 1670, FormatTypeAutoConvert -> 
          False, FontFamily -> "Times"], 
         Cell[
          StyleData["NumberedFigure", "Printout"], 
          CellMargins -> {{32, Inherited}, {6.5, 6.5}}, PageBreakBelow -> 
          False, GroupPageBreakWithin -> False, CellFrameLabels -> {{
             Cell[
              TextData[{"Figure ", 
                CounterBox["Chapter"], ".", 
                CounterBox["NumberedFigure"], ".", "\t"}], CellBaseline -> 
              Baseline, FontFamily -> "Lucida Grande", FontSize -> 9], 
             None}, {None, None}}, TabSpacings -> 0.25, FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Figure"], Deletable -> False, 
          CellMargins -> {{36, 10}, {10, 6}}, CellGroupingRules -> 
          "OutputGrouping", CellHorizontalScrolling -> True, 
          CellAutoOverwrite -> False, ShowCellLabel -> False, 
          ShowStringCharacters -> False, MenuSortingValue -> 1500, 
          MenuCommandKey -> None], 
         Cell[
          StyleData["Figure", "Printout"], CellMargins -> {{36, 10}, {13, 0}},
           PageBreakAbove -> False, GroupPageBreakWithin -> False]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["NumberedTable"], CellMargins -> {{36, 4}, {0, 14}}, 
          CellGroupingRules -> "InputGrouping", CellFrameLabels -> {{
             Cell[
              TextData[{"Table ", 
                CounterBox["Chapter"], ".", 
                CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> 
              Baseline], None}, {None, None}}, TabSpacings -> 1.1, 
          CounterIncrements -> "NumberedTable", MenuSortingValue -> 1660, 
          FormatTypeAutoConvert -> False, FontFamily -> "Lucida Grande", 
          FontSize -> 11], 
         Cell[
          StyleData["NumberedTable", "Printout"], 
          CellMargins -> {{12, 0}, {0, 13}}, PageBreakBelow -> False, 
          GroupPageBreakWithin -> False, CellFrameLabels -> {{
             Cell[
              TextData[{"Table ", 
                CounterBox["Chapter"], ".", 
                CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> 
              Baseline, FontFamily -> "DTL Albertina TOT Caps"], None}, {
            None, None}}, TabSpacings -> 0.25, FontFamily -> 
          "DTL Albertina TOT Italic", FontSize -> 11]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["DisplayTable"], Deletable -> False, 
          CellMargins -> {{36, Inherited}, {6, 12}}, CellGroupingRules -> 
          "OutputGrouping", CellHorizontalScrolling -> True, 
          DefaultFormatType -> DefaultTraditionalFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           LanguageCategory -> "Formula", ScriptLevel -> 0, 
          SingleLetterItalics -> True, 
          UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
         Cell[
          StyleData["DisplayTable", "Printout"], 
          CellMargins -> {{12, 0}, {21, 5}}, PageBreakAbove -> False, 
          GroupPageBreakWithin -> False]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Inline formatting", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["OsF"], FontColor -> GrayLevel[0]], 
         Cell[
          StyleData["OsF", "Printout"], StyleMenuListing -> None, FontFamily -> 
          "Times"]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseTI"], FontFamily -> "Times", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["ExerciseTI", "Printout"]]}, Closed]], 
      Cell[
       StyleData["TraditionalForm"], TextClipboardType -> "PlainText", 
       InputAutoReplacements -> {
        "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> "\[LessEqual]", 
         ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", "==" -> "\[Equal]",
          ParentList}, ShowSyntaxStyles -> False, 
       "TwoByteSyntaxCharacterAutoReplacement" -> True, 
       LineSpacing -> {1.25, 0, 2}, SingleLetterItalics -> True, 
       TraditionalFunctionNotation -> True, DelimiterMatching -> None, 
       StyleMenuListing -> None, FontFamily -> "Times"], 
      Cell[
       StyleData["StandardForm"]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ExerciseMR"], FontFamily -> "Courier"], 
         Cell[
          StyleData["ExerciseMR", "Printout"]]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Headers and footers", "Section", ShowGroupOpener -> True], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Header"], LineSpacing -> {1, 8}, MenuSortingValue -> 
          None, FontSlant -> "Plain"], 
         Cell[
          StyleData["Header", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
          FontFamily -> "Times", FontSize -> 10, FontSlant -> "Italic"]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 9], 
         Cell[
          StyleData["PageNumber", "Printout"], 
          CellMargins -> {{0, 0}, {0, 0}}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["HeaderOsF"], StyleMenuListing -> None, FontFamily -> 
          "Times", FontSize -> 9], 
         Cell[
          StyleData["HeaderOsF", "Printout"], FontSize -> 10]}, Closed]]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       TextData[{
         StyleBox["Mathematica", FontSlant -> "Italic"], 
         " system\[Hyphen]specific elements"}], "Section", ShowGroupOpener -> 
       True], 
      Cell[
       CellGroupData[{
         Cell[
         "Links", "Subsection", CellDingbat -> None, ShowGroupOpener -> True], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ExLink"], ContextMenu -> 
             FEPrivate`FrontEndResource["ContextMenus", "PacletLink"], 
             StyleMenuListing -> None, ButtonStyleMenuListing -> Automatic, 
             FontColor -> RGBColor[0.1, 0.1, 0.5], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonExpandable -> False, 
               ButtonFunction :> (FEPrivate`FrontEndExecute[
                 FrontEndToken["OpenHelpLink", {#, 
                   FEPrivate`If[
                    CurrentValue["ShiftKey"], Null, 
                    FEPrivate`ButtonNotebook[]]}]]& ), ButtonNote -> 
               ButtonData, Evaluator -> None, ImageSize -> Full, Method -> 
               "Preemptive"}], 
            Cell[
             StyleData["ExLink", "Printout"], FontFamily -> "Courier"]}, 
           Closed]]}, Closed]]}, Closed]]}, Visible -> False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, 2011)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Chapter.Number"->{
  Cell[1522, 49, 89, 2, 48, "ChapterN",
   CounterAssignments->{{"Chapter", 1}},
   CellTags->"Chapter.Number"]},
 "2.1 Exercises"->{
  Cell[1811, 66, 224, 8, 49, "ExerciseItem",
   CellTags->"2.1 Exercises"],
  Cell[2038, 76, 367, 13, 42, "ExerciseItem",
   CellTags->"2.1 Exercises"],
  Cell[2408, 91, 320, 12, 45, "ExerciseItem",
   CellTags->"2.1 Exercises"],
  Cell[2753, 107, 300, 8, 72, "ExerciseItem",
   CellTags->"2.1 Exercises"],
  Cell[3056, 117, 377, 13, 45, "ExerciseSubItem",
   CellTags->"2.1 Exercises"],
  Cell[3436, 132, 255, 9, 36, "ExerciseSubItem",
   CellTags->"2.1 Exercises"]},
 "2.1 Solutions"->{
  Cell[3770, 148, 348, 14, 27, "SolutionItem",
   CellTags->"2.1 Solutions"],
  Cell[4143, 166, 239, 8, 33, "SolutionItem",
   CellTags->"2.1 Solutions"],
  Cell[4407, 178, 278, 10, 45, "Input",
   CellTags->"2.1 Solutions"],
  Cell[4688, 190, 99, 3, 55, "Output",
   CellTags->"2.1 Solutions"],
  Cell[4836, 199, 193, 6, 27, "SolutionItem",
   CellTags->"2.1 Solutions"],
  Cell[5032, 207, 209, 7, 48, "Input",
   CellTags->"2.1 Solutions"],
  Cell[5266, 218, 92, 2, 45, "Input",
   CellTags->"2.1 Solutions"],
  Cell[5361, 222, 434, 15, 33, "Output",
   CellTags->"2.1 Solutions"],
  Cell[5810, 240, 281, 12, 37, "SolutionText",
   CellTags->"2.1 Solutions"],
  Cell[6116, 256, 108, 3, 45, "Input",
   CellTags->"2.1 Solutions"],
  Cell[6227, 261, 78, 2, 33, "Output",
   CellTags->"2.1 Solutions"],
  Cell[6342, 268, 132, 4, 82, "Input",
   CellTags->"2.1 Solutions"],
  Cell[6477, 274, 56, 1, 67, "Output",
   CellTags->"2.1 Solutions"],
  Cell[6582, 281, 296, 8, 67, "SolutionItem",
   CellTags->"2.1 Solutions"],
  Cell[6903, 293, 216, 8, 159, "Input",
   CellTags->"2.1 Solutions"],
  Cell[7122, 303, 457, 16, 103, "Output",
   CellTags->"2.1 Solutions"],
  Cell[7616, 324, 278, 9, 159, "Input",
   CellTags->"2.1 Solutions"],
  Cell[7897, 335, 56, 1, 67, "Output",
   CellTags->"2.1 Solutions"],
  Cell[7968, 339, 1124, 38, 168, "SolutionText",
   CellTags->"2.1 Solutions"],
  Cell[9117, 381, 112, 3, 82, "Input",
   CellTags->"2.1 Solutions"],
  Cell[9232, 386, 320, 12, 103, "Output",
   CellTags->"2.1 Solutions"],
  Cell[9589, 403, 176, 6, 82, "Input",
   CellTags->"2.1 Solutions"],
  Cell[9768, 411, 73, 2, 67, "Output",
   CellTags->"2.1 Solutions"]},
 "2.2 Exercises"->{
  Cell[9980, 425, 357, 11, 85, "ExerciseItem",
   CellTags->"2.2 Exercises"],
  Cell[10340, 438, 237, 7, 48, "ExerciseSubItem",
   CellTags->"2.2 Exercises"],
  Cell[10580, 447, 352, 12, 40, "ExerciseSubItem",
   CellTags->"2.2 Exercises"],
  Cell[10935, 461, 353, 12, 40, "ExerciseSubItem",
   CellTags->"2.2 Exercises"],
  Cell[11291, 475, 266, 8, 40, "ExerciseSubItem",
   CellTags->"2.2 Exercises"],
  Cell[11594, 488, 291, 8, 85, "ExerciseItem",
   CellTags->"2.2 Exercises"],
  Cell[11888, 498, 351, 12, 69, "ExerciseInput",
   CellTags->"2.2 Exercises"],
  Cell[12242, 512, 301, 10, 69, "Input",
   CellTags->"2.2 Exercises"],
  Cell[12546, 524, 203, 6, 49, "ExerciseText",
   CellTags->"2.2 Exercises"],
  Cell[12774, 534, 104, 2, 55, "ExerciseInput",
   CellTags->"2.2 Exercises"],
  Cell[12881, 538, 325, 12, 130, "ExerciseOutput",
   CellTags->"2.2 Exercises"],
  Cell[13243, 555, 104, 2, 40, "ExerciseInput",
   CellTags->"2.2 Exercises"],
  Cell[13350, 559, 183, 5, 76, "ExerciseOutput",
   CellTags->"2.2 Exercises"],
  Cell[13582, 570, 193, 5, 45, "ExerciseItem",
   CellTags->"2.2 Exercises"],
  Cell[13778, 577, 981, 34, 202, "ExerciseDisplayFormula",
   CellTags->"2.2 Exercises"],
  Cell[14796, 616, 388, 14, 45, "ExerciseItem",
   CellTags->{"i:30", "2.2 Exercises"}],
  Cell[15187, 632, 953, 32, 189, "ExerciseDisplayFormula",
   CellTags->"2.2 Exercises"]},
 "i:30"->{
  Cell[14796, 616, 388, 14, 45, "ExerciseItem",
   CellTags->{"i:30", "2.2 Exercises"}],
  Cell[957698, 21066, 464, 16, 123, "ExerciseItem",
   CellTags->{"i:30", "5.2 Exercises"}],
  Cell[7328487, 172059, 357, 8, 85, "ExerciseItem",
   CellTags->{"Ex.Random walk animate", "i:30", "11.1 Exercises"}]},
 "2.2 Solutions"->{
  Cell[16241, 673, 144, 4, 67, "SolutionItem",
   CellTags->"2.2 Solutions"],
  Cell[16410, 681, 170, 6, 67, "SolutionSubItem",
   CellTags->"2.2 Solutions"],
  Cell[16583, 689, 204, 6, 73, "InputOnly",
   CellTags->"2.2 Solutions"],
  Cell[16812, 699, 89, 2, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[16904, 703, 173, 5, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[17126, 714, 339, 11, 117, "SolutionSubItem",
   CellTags->"2.2 Solutions"],
  Cell[17468, 727, 312, 10, 73, "InputOnly",
   CellTags->"2.2 Solutions"],
  Cell[17805, 741, 89, 2, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[17897, 745, 172, 5, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[18106, 755, 89, 2, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[18198, 759, 172, 5, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[18419, 770, 266, 9, 117, "SolutionSubItem",
   CellTags->"2.2 Solutions"],
  Cell[18688, 781, 313, 10, 73, "InputOnly",
   CellTags->"2.2 Solutions"],
  Cell[19026, 795, 89, 2, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[19118, 799, 173, 5, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[19340, 810, 383, 11, 117, "SolutionSubItem",
   CellTags->"2.2 Solutions"],
  Cell[19748, 825, 228, 7, 87, "Input",
   CellTags->"2.2 Solutions"],
  Cell[19979, 834, 429, 9, 72, "Message",
   CellTags->"2.2 Solutions"],
  Cell[20411, 845, 167, 5, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[20593, 853, 86, 2, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[20728, 861, 835, 26, 270, "SolutionItem",
   CellTags->"2.2 Solutions"],
  Cell[21588, 891, 300, 10, 103, "Input",
   CellTags->"2.2 Solutions"],
  Cell[21891, 903, 300, 11, 123, "Output",
   CellTags->"2.2 Solutions"],
  Cell[22206, 917, 301, 10, 103, "Input",
   CellTags->"2.2 Solutions"],
  Cell[22532, 931, 115, 3, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[22650, 936, 135, 4, 76, "Output",
   CellTags->"2.2 Solutions"],
  Cell[22822, 945, 115, 3, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[22940, 950, 135, 4, 76, "Output",
   CellTags->"2.2 Solutions"],
  Cell[23124, 960, 298, 8, 117, "SolutionItem",
   CellTags->"2.2 Solutions"],
  Cell[23425, 970, 223, 7, 73, "InputOnly",
   CellTags->"2.2 Solutions"],
  Cell[23651, 979, 193, 6, 87, "InputOnly",
   CellTags->"2.2 Solutions"],
  Cell[23869, 989, 167, 5, 103, "Input",
   CellTags->"2.2 Solutions"],
  Cell[24039, 996, 226, 7, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[24302, 1008, 107, 3, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[24412, 1013, 138, 4, 67, "Output",
   CellTags->"2.2 Solutions"],
  Cell[24599, 1023, 211, 8, 67, "SolutionItem",
   CellTags->"2.2 Solutions"],
  Cell[24813, 1033, 703, 24, 135, "Input",
   CellTags->"2.2 Solutions"],
  Cell[25541, 1061, 217, 7, 82, "Input",
   CellTags->"2.2 Solutions"],
  Cell[25761, 1070, 8076, 140, 775, "Output",
   CellTags->"2.2 Solutions"]},
 "2.3 Exercises"->{
  Cell[33976, 1220, 308, 11, 49, "ExerciseItem",
   CellTags->"2.3 Exercises"],
  Cell[34287, 1233, 400, 13, 72, "ExerciseItem",
   CellTags->"2.3 Exercises"],
  Cell[34690, 1248, 824, 32, 72, "ExerciseItem",
   CellTags->{"i:47", "2.3 Exercises"}],
  Cell[35517, 1282, 1151, 44, 72, "ExerciseItem",
   CellTags->"2.3 Exercises"],
  Cell[36671, 1328, 218, 6, 42, "ExerciseItem",
   CellTags->{"i:48", "2.3 Exercises"}]},
 "i:47"->{
  Cell[34690, 1248, 824, 32, 72, "ExerciseItem",
   CellTags->{"i:47", "2.3 Exercises"}],
  Cell[1721600, 41577, 1085, 32, 271, "ExerciseItem",
   CellTags->{"i:47", "6.3 Exercises"}],
  Cell[7546156, 176964, 745, 25, 127, "ExerciseItem",
   CellTags->{"i:47", "12.3 Exercises"}]},
 "i:48"->{
  Cell[36671, 1328, 218, 6, 42, "ExerciseItem",
   CellTags->{"i:48", "2.3 Exercises"}],
  Cell[1635231, 38359, 1184, 41, 114, "ExerciseItem",
   CellTags->{"Ex.findRoot", "6.1 Exercises", "i:48"}],
  Cell[7546926, 176993, 849, 24, 148, "ExerciseItem",
   CellTags->{"i:48", "12.3 Exercises"}],
  Cell[11564368, 246797, 1391, 45, 223, "ExerciseItem",
   CellTags->{"i:48", "13.4 Exercises"}]},
 "2.3 Solutions"->{
  Cell[36978, 1342, 198, 4, 117, "SolutionItem",
   CellTags->"2.3 Solutions"],
  Cell[37179, 1348, 163, 5, 73, "InputOnly",
   CellTags->"2.3 Solutions"],
  Cell[37345, 1355, 165, 5, 73, "InputOnly",
   CellTags->"2.3 Solutions"],
  Cell[37535, 1364, 82, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[37620, 1368, 60, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[37717, 1374, 103, 3, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[37823, 1379, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[37931, 1386, 412, 13, 117, "SolutionItem",
   CellTags->"2.3 Solutions"],
  Cell[38346, 1401, 252, 8, 87, "Input",
   CellTags->"2.3 Solutions"],
  Cell[38623, 1413, 99, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[38725, 1417, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[38821, 1423, 100, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[38924, 1427, 60, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[39021, 1433, 92, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[39116, 1437, 60, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[39225, 1444, 428, 12, 168, "SolutionItem",
   CellTags->"2.3 Solutions"],
  Cell[39656, 1458, 216, 6, 73, "InputOnly",
   CellTags->"2.3 Solutions"],
  Cell[39897, 1468, 89, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[39989, 1472, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[40085, 1478, 107, 3, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[40195, 1483, 60, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[40304, 1490, 151, 4, 67, "SolutionItem",
   CellTags->"2.3 Solutions"],
  Cell[40458, 1496, 163, 5, 87, "Input",
   CellTags->"2.3 Solutions"],
  Cell[40624, 1503, 286, 13, 67, "SolutionText",
   CellTags->"2.3 Solutions"],
  Cell[40913, 1518, 242, 7, 87, "Input",
   CellTags->"2.3 Solutions"],
  Cell[41158, 1527, 309, 11, 136, "Input",
   CellTags->"2.3 Solutions"],
  Cell[41492, 1542, 111, 3, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[41606, 1547, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[41680, 1551, 292, 7, 117, "SolutionText",
   CellTags->"2.3 Solutions"],
  Cell[41975, 1560, 215, 6, 87, "Input",
   CellTags->"2.3 Solutions"],
  Cell[42215, 1570, 85, 2, 82, "Input",
   CellTags->"2.3 Solutions"],
  Cell[42303, 1574, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[42411, 1581, 178, 5, 67, "SolutionItem",
   CellTags->"2.3 Solutions"],
  Cell[42592, 1588, 281, 8, 73, "InputOnly",
   CellTags->"2.3 Solutions"],
  Cell[42898, 1600, 140, 4, 103, "Input",
   CellTags->"2.3 Solutions"],
  Cell[43041, 1606, 60, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[43138, 1612, 140, 4, 103, "Input",
   CellTags->"2.3 Solutions"],
  Cell[43281, 1618, 59, 1, 67, "Output",
   CellTags->"2.3 Solutions"],
  Cell[43355, 1622, 209, 8, 67, "SolutionText",
   CellTags->"2.3 Solutions"]},
 "2.4 Exercises"->{
  Cell[43690, 1641, 445, 14, 123, "ExerciseItem",
   CellTags->"2.4 Exercises"],
  Cell[44138, 1657, 219, 7, 96, "Input",
   CellTags->"2.4 Exercises"],
  Cell[44382, 1668, 119, 3, 82, "Input",
   CellTags->"2.4 Exercises"],
  Cell[44504, 1673, 97, 2, 67, "Output",
   CellTags->"2.4 Exercises"],
  Cell[44616, 1678, 353, 12, 123, "ExerciseText",
   CellTags->"2.4 Exercises"],
  Cell[44994, 1694, 145, 4, 82, "ExerciseInput",
   CellTags->"2.4 Exercises"],
  Cell[45142, 1700, 79, 1, 67, "ExerciseOutput",
   CellTags->"2.4 Exercises"],
  Cell[45248, 1705, 545, 16, 114, "ExerciseItem",
   CellTags->{"i:62", "2.4 Exercises"}]},
 "i:62"->{
  Cell[45248, 1705, 545, 16, 114, "ExerciseItem",
   CellTags->{"i:62", "2.4 Exercises"}]},
 "2.4 Solutions"->{
  Cell[45882, 1729, 167, 5, 27, "SolutionItem",
   CellTags->"2.4 Solutions"],
  Cell[46052, 1736, 93, 2, 45, "InputOnly",
   CellTags->"2.4 Solutions"],
  Cell[46148, 1740, 278, 8, 37, "SolutionText",
   CellTags->"2.4 Solutions"],
  Cell[46429, 1750, 127, 3, 45, "InputOnly",
   CellTags->"2.4 Solutions"],
  Cell[46559, 1755, 209, 7, 48, "InputOnly",
   CellTags->"2.4 Solutions"],
  Cell[46793, 1766, 105, 3, 45, "Input",
   CellTags->"2.4 Solutions"],
  Cell[46901, 1771, 126, 4, 37, "Output",
   CellTags->"2.4 Solutions"],
  Cell[47064, 1780, 105, 3, 45, "Input",
   CellTags->"2.4 Solutions"],
  Cell[47172, 1785, 57, 1, 33, "Output",
   CellTags->"2.4 Solutions"],
  Cell[47278, 1792, 98, 1, 27, "SolutionItem",
   CellTags->"2.4 Solutions"],
  Cell[47401, 1797, 214, 7, 45, "Input",
   CellTags->"2.4 Solutions"],
  Cell[47618, 1806, 451, 10, 63, "Output",
   CellTags->"2.4 Solutions"],
  Cell[48084, 1819, 139, 4, 37, "SolutionText",
   CellTags->"2.4 Solutions"],
  Cell[48226, 1825, 314, 10, 61, "InputOnly",
   CellTags->"2.4 Solutions"],
  Cell[48543, 1837, 110, 5, 37, "SolutionText",
   CellTags->"2.4 Solutions"],
  Cell[48656, 1844, 130, 3, 45, "InputOnly",
   CellTags->"2.4 Solutions"],
  Cell[48811, 1851, 111, 3, 45, "Input",
   CellTags->"2.4 Solutions"],
  Cell[48925, 1856, 514, 11, 63, "Output",
   CellTags->"2.4 Solutions"]},
 "c:1"->{
  Cell[50357, 1899, 47, 1, 67, "ChapterTitle",
   CellTags->"c:1"],
  Cell[939317, 20603, 64, 1, 67, "ChapterTitle",
   CellTags->"c:1"],
  Cell[1631109, 38218, 64, 1, 67, "ChapterTitle",
   CellTags->"c:1"]},
 "3.1 Exercises"->{
  Cell[50491, 1906, 678, 23, 57, "ExerciseItem",
   CellTags->"3.1 Exercises"],
  Cell[51172, 1931, 525, 22, 54, "ExerciseItem",
   CellTags->"3.1 Exercises"],
  Cell[51722, 1957, 785, 26, 76, "ExerciseItem",
   CellTags->{"Ex.Ten element list", "3.1 Exercises", "i:21"}],
  Cell[52510, 1985, 360, 7, 78, "ExerciseText",
   CellTags->"3.1 Exercises"],
  Cell[52907, 1997, 243, 8, 34, "ExerciseItem",
   CellTags->"3.1 Exercises"],
  Cell[53175, 2009, 131, 3, 37, "ExerciseInput",
   CellTags->"3.1 Exercises"],
  Cell[53309, 2014, 298, 8, 30, "ExerciseOutput",
   CellTags->"3.1 Exercises"],
  Cell[53644, 2027, 180, 5, 37, "ExerciseInput",
   CellTags->"3.1 Exercises"],
  Cell[53827, 2034, 1038, 34, 54, "ExerciseOutput",
   CellTags->"3.1 Exercises"],
  Cell[54914, 2074, 379, 6, 79, "ExerciseItem",
   CellTags->{"3.1 Exercises", "i:22"}],
  Cell[55318, 2084, 2020, 70, 107, "ExerciseInput",
   CellTags->"3.1 Exercises"],
  Cell[57341, 2156, 317, 7, 143, "ExerciseOutput",
   CellTags->"3.1 Exercises"],
  Cell[57685, 2167, 406, 14, 57, "ExerciseItem",
   CellTags->"3.1 Exercises"]},
 "Ex.Ten element list"->{
  Cell[51722, 1957, 785, 26, 76, "ExerciseItem",
   CellTags->{"Ex.Ten element list", "3.1 Exercises", "i:21"}]},
 "i:21"->{
  Cell[51722, 1957, 785, 26, 76, "ExerciseItem",
   CellTags->{"Ex.Ten element list", "3.1 Exercises", "i:21"}],
  Cell[10619468, 227999, 1358, 38, 216, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:21"}]},
 "i:22"->{
  Cell[54914, 2074, 379, 6, 79, "ExerciseItem",
   CellTags->{"3.1 Exercises", "i:22"}],
  Cell[10621026, 228045, 237, 6, 81, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:22"}]},
 "3.1 Solutions"->{
  Cell[58180, 2189, 207, 7, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[58412, 2200, 257, 7, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[58672, 2209, 414, 13, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[59123, 2227, 261, 8, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[59387, 2237, 414, 13, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[59850, 2256, 217, 9, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[60092, 2269, 212, 7, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[60307, 2278, 280, 9, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[60602, 2290, 209, 8, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[60836, 2302, 221, 7, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[61060, 2311, 219, 5, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[61328, 2322, 93, 1, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[61446, 2327, 193, 6, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[61642, 2335, 314, 10, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[61993, 2350, 210, 7, 41, "Input",
   CellTags->"3.1 Solutions"],
  Cell[62206, 2359, 238, 6, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[62459, 2368, 243, 8, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[62727, 2380, 211, 7, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[62941, 2389, 276, 8, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[63266, 2403, 266, 8, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[63557, 2415, 187, 6, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[63747, 2423, 276, 8, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[64060, 2436, 271, 9, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[64334, 2447, 1014, 33, 54, "Output",
   CellTags->"3.1 Solutions"],
  Cell[65397, 2486, 244, 8, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[65666, 2498, 574, 19, 61, "Input",
   CellTags->"3.1 Solutions"],
  Cell[66243, 2519, 691, 26, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[66971, 2550, 372, 12, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[67346, 2564, 1113, 42, 54, "Output",
   CellTags->"3.1 Solutions"],
  Cell[68474, 2609, 132, 3, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[68631, 2616, 200, 6, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[68834, 2624, 1723, 65, 54, "Output",
   CellTags->"3.1 Solutions"],
  Cell[70594, 2694, 124, 3, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[70721, 2699, 246, 5, 292, "Output",
   CellTags->"3.1 Solutions"],
  Cell[70982, 2707, 99, 1, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[71084, 2710, 1517, 46, 125, "InputOnly",
   CellTags->"3.1 Solutions"],
  Cell[72626, 2760, 251, 9, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[72880, 2771, 330, 6, 379, "Output",
   CellTags->"3.1 Solutions"],
  Cell[73259, 2783, 93, 1, 30, "SolutionItem",
   CellTags->"3.1 Solutions"],
  Cell[73377, 2788, 174, 5, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[73554, 2795, 612, 16, 54, "Output",
   CellTags->"3.1 Solutions"],
  Cell[74181, 2814, 776, 20, 84, "Input",
   CellTags->"3.1 Solutions"],
  Cell[74960, 2836, 73, 1, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[75058, 2841, 126, 3, 37, "Input",
   CellTags->"3.1 Solutions"],
  Cell[75187, 2846, 459, 15, 30, "Output",
   CellTags->"3.1 Solutions"],
  Cell[75661, 2864, 77, 1, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[75741, 2867, 1027, 34, 153, "Input",
   CellTags->"3.1 Solutions"],
  Cell[76771, 2903, 96, 1, 30, "SolutionText",
   CellTags->"3.1 Solutions"],
  Cell[76892, 2908, 613, 18, 107, "Input",
   CellTags->"3.1 Solutions"],
  Cell[77508, 2928, 639348, 10515, 170, "Output",
   CellTags->"3.1 Solutions"]},
 "3.2 Exercises"->{
  Cell[717006, 13455, 261, 7, 57, "ExerciseItem",
   CellTags->"3.2 Exercises"],
  Cell[717292, 13466, 264, 8, 37, "ExerciseInput",
   CellTags->"3.2 Exercises"],
  Cell[717559, 13476, 709, 20, 54, "ExerciseOutput",
   CellTags->"3.2 Exercises"],
  Cell[718295, 13500, 828, 29, 57, "ExerciseItem",
   CellTags->"3.2 Exercises"],
  Cell[719148, 13533, 270, 10, 31, "ExerciseItem",
   CellTags->"3.2 Exercises"],
  Cell[719421, 13545, 473, 15, 37, "ExerciseInput",
   Evaluatable->False,
   CellTags->"3.2 Exercises"]},
 "3.2 Solutions"->{
  Cell[719995, 13569, 88, 1, 30, "SolutionItem",
   CellTags->"3.2 Solutions"],
  Cell[720108, 13574, 218, 7, 37, "Input",
   CellTags->"3.2 Solutions"],
  Cell[720329, 13583, 685, 19, 54, "Output",
   CellTags->"3.2 Solutions"],
  Cell[721029, 13605, 126, 5, 30, "SolutionText",
   CellTags->"3.2 Solutions"],
  Cell[721180, 13614, 112, 3, 37, "Input",
   CellTags->"3.2 Solutions"],
  Cell[721295, 13619, 56, 1, 30, "Output",
   CellTags->"3.2 Solutions"],
  Cell[721366, 13623, 166, 7, 30, "SolutionText",
   CellTags->"3.2 Solutions"],
  Cell[721557, 13634, 146, 4, 37, "Input",
   CellTags->"3.2 Solutions"],
  Cell[721706, 13640, 57, 1, 30, "Output",
   CellTags->"3.2 Solutions"],
  Cell[721812, 13647, 178, 4, 30, "SolutionItem",
   CellTags->"3.2 Solutions"],
  Cell[722015, 13655, 590, 20, 37, "Input",
   CellTags->"3.2 Solutions"],
  Cell[722608, 13677, 111, 3, 30, "Output",
   CellTags->"3.2 Solutions"],
  Cell[722768, 13686, 350, 11, 30, "SolutionItem",
   CellTags->"3.2 Solutions"],
  Cell[723143, 13701, 512, 16, 37, "Input",
   CellTags->"3.2 Solutions"],
  Cell[723658, 13719, 199, 7, 30, "Output",
   CellTags->"3.2 Solutions"]},
 "3.3 Exercises"->{
  Cell[724004, 13738, 1810, 64, 36, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[725817, 13804, 593, 19, 32, "Output",
   CellTags->"3.3 Exercises"],
  Cell[726425, 13826, 1271, 43, 102, "ExerciseItem",
   CellTags->{"i:57", "3.3 Exercises"}],
  Cell[727699, 13871, 281, 9, 31, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[727983, 13882, 156, 3, 31, "ExerciseItem",
   CellTags->{"Ex.Row swapping", "i:61", "3.3 Exercises"}],
  Cell[728164, 13889, 658, 24, 54, "ExerciseItem",
   CellTags->{"i:58", "3.3 Exercises"}],
  Cell[728847, 13917, 306, 8, 61, "ExerciseInput",
   CellTags->"3.3 Exercises"],
  Cell[729156, 13927, 709, 20, 100, "ExerciseOutput",
   CellTags->"3.3 Exercises"],
  Cell[729902, 13952, 255, 7, 82, "ExerciseInput",
   CellTags->"3.3 Exercises"],
  Cell[730160, 13961, 729, 20, 261, "ExerciseOutput",
   CellTags->"3.3 Exercises"],
  Cell[730916, 13985, 1650, 64, 171, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[732569, 14051, 2219, 80, 211, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[734791, 14133, 630, 24, 67, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[735424, 14159, 469, 18, 67, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[735896, 14179, 520, 20, 67, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[736419, 14201, 582, 19, 117, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[737026, 14224, 836, 25, 256, "ExerciseItem",
   CellTags->{"i:59", "3.3 Exercises"}],
  Cell[737865, 14251, 519, 15, 127, "ExerciseText",
   CellTags->{"i:60", "3.3 Exercises"}],
  Cell[738409, 14270, 284, 6, 189, "ExerciseInput",
   CellTags->"3.3 Exercises"],
  Cell[738696, 14278, 290, 6, 67, "ExerciseOutput",
   CellTags->"3.3 Exercises"],
  Cell[739035, 14290, 555, 19, 123, "ExerciseItem",
   CellTags->"3.3 Exercises"],
  Cell[739615, 14313, 270, 7, 136, "ExerciseInput",
   CellTags->"3.3 Exercises"],
  Cell[739888, 14322, 764, 21, 172, "ExerciseOutput",
   CellTags->"3.3 Exercises"]},
 "i:57"->{
  Cell[726425, 13826, 1271, 43, 102, "ExerciseItem",
   CellTags->{"i:57", "3.3 Exercises"}],
  Cell[3164375, 71442, 440, 15, 117, "ExerciseItem",
   CellTags->{"9.3 Exercises", "i:57"}]},
 "Ex.Row swapping"->{
  Cell[727983, 13882, 156, 3, 31, "ExerciseItem",
   CellTags->{"Ex.Row swapping", "i:61", "3.3 Exercises"}]},
 "i:61"->{
  Cell[727983, 13882, 156, 3, 31, "ExerciseItem",
   CellTags->{"Ex.Row swapping", "i:61", "3.3 Exercises"}]},
 "i:58"->{
  Cell[728164, 13889, 658, 24, 54, "ExerciseItem",
   CellTags->{"i:58", "3.3 Exercises"}]},
 "i:59"->{
  Cell[737026, 14224, 836, 25, 256, "ExerciseItem",
   CellTags->{"i:59", "3.3 Exercises"}]},
 "i:60"->{
  Cell[737865, 14251, 519, 15, 127, "ExerciseText",
   CellTags->{"i:60", "3.3 Exercises"}]},
 "3.3 Solutions"->{
  Cell[740765, 14353, 242, 8, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[741032, 14365, 682, 24, 87, "Input",
   CellTags->"3.3 Solutions"],
  Cell[741717, 14391, 509, 17, 72, "Output",
   CellTags->"3.3 Solutions"],
  Cell[742275, 14414, 134, 3, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[742412, 14419, 425, 15, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[742840, 14436, 222, 7, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[743087, 14447, 144, 4, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[743234, 14453, 734, 26, 121, "Output",
   CellTags->"3.3 Solutions"],
  Cell[744017, 14485, 223, 5, 117, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[744265, 14494, 186, 5, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[744454, 14501, 144, 4, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[744635, 14510, 123, 3, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[744761, 14515, 183, 6, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[744981, 14526, 88, 2, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[745072, 14530, 111, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[745198, 14536, 568, 20, 117, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[745791, 14560, 268, 8, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[746062, 14570, 111, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[746222, 14579, 145, 4, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[746392, 14587, 284, 8, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[746679, 14597, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[747403, 14622, 532, 17, 240, "Input",
   CellTags->"3.3 Solutions"],
  Cell[747938, 14641, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[748640, 14664, 129, 3, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[748794, 14671, 284, 8, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[749081, 14681, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[749805, 14706, 501, 16, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[750309, 14724, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[751011, 14747, 97, 1, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[751133, 14752, 284, 8, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[751420, 14762, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[752144, 14787, 384, 13, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[752531, 14802, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[753233, 14825, 382, 9, 168, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[753652, 14839, 134, 3, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[753811, 14846, 284, 8, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[754098, 14856, 687, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[754822, 14881, 92, 2, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[754917, 14885, 397, 11, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[755329, 14899, 134, 3, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[755488, 14906, 268, 8, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[755759, 14916, 714, 21, 310, "Output",
   CellTags->"3.3 Solutions"],
  Cell[756510, 14942, 304, 9, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[756817, 14953, 707, 20, 261, "Output",
   CellTags->"3.3 Solutions"],
  Cell[757539, 14976, 231, 5, 117, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[757773, 14983, 442, 13, 139, "Input",
   CellTags->"3.3 Solutions"],
  Cell[758252, 15001, 173, 7, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[758428, 15010, 306, 10, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[758759, 15024, 176, 6, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[758938, 15032, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[759074, 15038, 71, 1, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[759170, 15043, 123, 3, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[759296, 15048, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[759466, 15057, 202, 7, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[759671, 15066, 306, 10, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[760002, 15080, 137, 4, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[760142, 15086, 317, 11, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[760496, 15102, 85, 2, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[760584, 15106, 317, 11, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[760938, 15122, 90, 2, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[761031, 15126, 239, 7, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[761307, 15138, 123, 3, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[761433, 15143, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[761569, 15149, 220, 8, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[761814, 15161, 233, 7, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[762050, 15170, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[762220, 15179, 208, 7, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[762453, 15190, 181, 6, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[762637, 15198, 111, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[762797, 15207, 381, 13, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[763203, 15224, 277, 8, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[763483, 15234, 167, 5, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[763687, 15244, 164, 5, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[763854, 15251, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[764024, 15260, 229, 8, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[764278, 15272, 248, 7, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[764529, 15281, 167, 5, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[764711, 15289, 152, 4, 67, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[764888, 15297, 282, 9, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[765173, 15308, 317, 11, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[765527, 15324, 88, 2, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[765618, 15328, 167, 5, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[765834, 15339, 178, 4, 117, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[766015, 15345, 312, 11, 123, "InputOnly",
   CellTags->"3.3 Solutions"],
  Cell[766352, 15360, 183, 5, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[766538, 15367, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[766696, 15375, 237, 7, 82, "Input",
   CellTags->"3.3 Solutions"],
  Cell[766936, 15384, 121, 3, 67, "Output",
   CellTags->"3.3 Solutions"],
  Cell[767106, 15393, 382, 14, 67, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[767513, 15411, 412, 12, 136, "Input",
   CellTags->"3.3 Solutions"],
  Cell[767928, 15425, 4535, 127, 170, "Output",
   CellTags->"3.3 Solutions"],
  Cell[772478, 15555, 300, 6, 53, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[772803, 15565, 390, 12, 61, "Input",
   CellTags->"3.3 Solutions"],
  Cell[773196, 15579, 2862, 103, 123, "Output",
   CellTags->"3.3 Solutions"],
  Cell[776073, 15685, 113, 2, 30, "SolutionText",
   CellTags->"3.3 Solutions"],
  Cell[776211, 15691, 179, 6, 37, "Input",
   CellTags->"3.3 Solutions"],
  Cell[776393, 15699, 3006, 108, 146, "Output",
   CellTags->"3.3 Solutions"],
  Cell[779448, 15813, 121, 3, 30, "SolutionItem",
   CellTags->"3.3 Solutions"],
  Cell[779572, 15818, 372, 10, 56, "InputOnly",
   CellTags->"3.3 Solutions"],
  Cell[779969, 15832, 260, 8, 61, "Input",
   CellTags->"3.3 Solutions"],
  Cell[780232, 15842, 742, 21, 54, "Output",
   CellTags->"3.3 Solutions"]},
 "4.1 Exercises"->{
  Cell[781970, 15899, 257, 10, 76, "ExerciseItem",
   CellTags->"4.1 Exercises"],
  Cell[782230, 15911, 300, 10, 67, "ExerciseItem",
   CellTags->"4.1 Exercises"],
  Cell[782533, 15923, 697, 28, 117, "ExerciseItem",
   CellTags->{"i:27", "4.1 Exercises"}],
  Cell[783233, 15953, 270, 8, 117, "ExerciseItem",
   CellTags->"4.1 Exercises"],
  Cell[783506, 15963, 1198, 49, 150, "ExerciseItem",
   CellTags->"4.1 Exercises"],
  Cell[784707, 16014, 1196, 40, 211, "ExerciseItem",
   CellTags->"4.1 Exercises"]},
 "i:27"->{
  Cell[782533, 15923, 697, 28, 117, "ExerciseItem",
   CellTags->{"i:27", "4.1 Exercises"}],
  Cell[7321246, 171878, 742, 23, 118, "ExerciseItem",
   CellTags->{"i:27", "11.1 Exercises"}],
  Cell[7529533, 176366, 709, 19, 153, "ExerciseItem",
   CellTags->{"i:27", "12.2 Exercises"}]},
 "4.1 Solutions"->{
  Cell[785992, 16062, 110, 2, 67, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[786127, 16068, 172, 5, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[786302, 16075, 334, 7, 121, "Output",
   CellTags->"4.1 Solutions"],
  Cell[786651, 16085, 518, 17, 117, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[787194, 16106, 369, 11, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[787566, 16119, 247, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[787828, 16128, 90, 1, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[787943, 16133, 462, 15, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[788408, 16150, 247, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[788670, 16159, 310, 12, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[789005, 16175, 456, 15, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[789464, 16192, 247, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[789760, 16204, 214, 7, 67, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[789999, 16215, 208, 7, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[790210, 16224, 313, 11, 103, "Output",
   CellTags->"4.1 Solutions"],
  Cell[790560, 16240, 322, 10, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[790885, 16252, 59, 1, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[790981, 16258, 422, 13, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[791406, 16273, 59, 1, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[791502, 16279, 353, 11, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[791858, 16292, 59, 1, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[791954, 16298, 351, 11, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[792308, 16311, 59, 1, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[792416, 16318, 474, 14, 117, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[792893, 16334, 182, 6, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[793078, 16342, 166, 5, 123, "InputOnly",
   CellTags->"4.1 Solutions"],
  Cell[793247, 16349, 184, 6, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[793456, 16359, 130, 3, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[793589, 16364, 265, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[793869, 16373, 177, 3, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[794071, 16380, 157, 3, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[794231, 16385, 92, 2, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[794372, 16393, 171, 4, 67, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[794546, 16399, 92, 2, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[794641, 16403, 276, 9, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[794920, 16414, 255, 8, 136, "Input",
   CellTags->"4.1 Solutions"],
  Cell[795200, 16426, 90, 2, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[795293, 16430, 92, 2, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[795422, 16437, 106, 3, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[795531, 16442, 107, 3, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[795675, 16450, 130, 3, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[795808, 16455, 263, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[796086, 16464, 151, 4, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[796240, 16470, 92, 2, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[796335, 16474, 278, 9, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[796616, 16485, 258, 8, 136, "Input",
   CellTags->"4.1 Solutions"],
  Cell[796899, 16497, 130, 3, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[797032, 16502, 263, 6, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[797344, 16514, 149, 4, 67, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[797496, 16520, 290, 8, 76, "InputOnly",
   CellTags->"4.1 Solutions"],
  Cell[797789, 16530, 97, 1, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[797889, 16533, 272, 9, 105, "InputOnly",
   CellTags->"4.1 Solutions"],
  Cell[798164, 16544, 121, 3, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[798310, 16551, 293, 10, 145, "Input",
   CellTags->"4.1 Solutions"],
  Cell[798606, 16563, 174, 5, 121, "Output",
   CellTags->"4.1 Solutions"],
  Cell[798829, 16574, 284, 6, 117, "SolutionItem",
   CellTags->"4.1 Solutions"],
  Cell[799116, 16582, 267, 9, 139, "Input",
   CellTags->"4.1 Solutions"],
  Cell[799386, 16593, 186, 5, 67, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[799575, 16600, 233, 7, 87, "Input",
   CellTags->"4.1 Solutions"],
  Cell[799833, 16611, 295, 10, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[800131, 16623, 223, 7, 67, "Output",
   CellTags->"4.1 Solutions"],
  Cell[800369, 16633, 263, 6, 117, "SolutionText",
   CellTags->"4.1 Solutions"],
  Cell[800635, 16641, 306, 9, 141, "Input",
   CellTags->"4.1 Solutions"],
  Cell[800966, 16654, 296, 10, 82, "Input",
   CellTags->"4.1 Solutions"],
  Cell[801265, 16666, 223, 7, 67, "Output",
   CellTags->"4.1 Solutions"]},
 "4.2 Exercises"->{
  Cell[801636, 16685, 205, 4, 123, "ExerciseItem",
   CellTags->"4.2 Exercises"],
  Cell[801866, 16693, 446, 15, 87, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[802315, 16710, 280, 9, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[802632, 16724, 385, 13, 87, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[803020, 16739, 221, 7, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[803256, 16749, 394, 13, 123, "ExerciseText",
   CellTags->"4.2 Exercises"],
  Cell[803687, 16767, 346, 10, 123, "ExerciseItem",
   CellTags->"4.2 Exercises"],
  Cell[804058, 16781, 312, 8, 189, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[804373, 16791, 79, 1, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[804467, 16795, 264, 9, 73, "ExerciseText",
   CellTags->"4.2 Exercises"],
  Cell[804746, 16807, 843, 16, 312, "ExerciseItem",
   CellTags->{"i:40", "4.2 Exercises"}],
  Cell[805614, 16827, 145, 4, 67, "ExerciseItem",
   CellTags->"4.2 Exercises"],
  Cell[805762, 16833, 635, 22, 76, "ExerciseDisplayFormula",
   CellTags->"4.2 Exercises"],
  Cell[806400, 16857, 130, 3, 73, "ExerciseText",
   CellTags->"4.2 Exercises"],
  Cell[806567, 16865, 207, 5, 76, "ExerciseItem",
   CellTags->"4.2 Exercises"],
  Cell[806799, 16874, 559, 16, 82, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[807361, 16892, 298, 7, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[807686, 16903, 158, 4, 76, "ExerciseItem",
   CellTags->"4.2 Exercises"],
  Cell[807869, 16911, 373, 11, 117, "ExerciseItem",
   CellTags->{"i:41", "4.2 Exercises"}],
  Cell[808267, 16926, 377, 13, 87, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[808647, 16941, 757, 27, 72, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[809453, 16974, 269, 5, 123, "ExerciseItem",
   CellTags->{"Ex.MultiplyCount", "i:42", "4.2 Exercises"}],
  Cell[809747, 16983, 140, 3, 103, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[809890, 16988, 78, 1, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[810005, 16994, 89, 1, 82, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[810097, 16997, 78, 1, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[810212, 17003, 233, 6, 103, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[810448, 17011, 78, 1, 67, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[810575, 17018, 396, 11, 123, "ExerciseItem",
   CellTags->{"Ex.Dice", "i:43", "4.2 Exercises"}],
  Cell[810996, 17033, 224, 7, 82, "ExerciseInput",
   CellTags->"4.2 Exercises"],
  Cell[811223, 17042, 20116, 525, 153, "ExerciseOutput",
   CellTags->"4.2 Exercises"],
  Cell[831354, 17570, 416, 7, 175, "ExerciseText",
   CellTags->"4.2 Exercises"],
  Cell[831773, 17579, 500, 14, 139, "ExerciseInput",
   Evaluatable->False,
   CellTags->"4.2 Exercises"]},
 "i:40"->{
  Cell[804746, 16807, 843, 16, 312, "ExerciseItem",
   CellTags->{"i:40", "4.2 Exercises"}],
  Cell[1980371, 48591, 1096, 27, 312, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:40"}],
  Cell[3296404, 75478, 641, 15, 211, "ExerciseItem",
   CellTags->{"10.1 Exercises", "i:40"}]},
 "i:41"->{
  Cell[807869, 16911, 373, 11, 117, "ExerciseItem",
   CellTags->{"i:41", "4.2 Exercises"}],
  Cell[1981492, 48622, 857, 24, 256, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:41"}],
  Cell[3130104, 70269, 667, 24, 123, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:41"}],
  Cell[3296075, 75466, 326, 10, 76, "ExerciseItem",
   CellTags->{"i:41", "10.1 Exercises"}]},
 "Ex.MultiplyCount"->{
  Cell[809453, 16974, 269, 5, 123, "ExerciseItem",
   CellTags->{"Ex.MultiplyCount", "i:42", "4.2 Exercises"}]},
 "i:42"->{
  Cell[809453, 16974, 269, 5, 123, "ExerciseItem",
   CellTags->{"Ex.MultiplyCount", "i:42", "4.2 Exercises"}],
  Cell[3132052, 70341, 1655, 59, 211, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:42"}]},
 "Ex.Dice"->{
  Cell[810575, 17018, 396, 11, 123, "ExerciseItem",
   CellTags->{"Ex.Dice", "i:43", "4.2 Exercises"}]},
 "i:43"->{
  Cell[810575, 17018, 396, 11, 123, "ExerciseItem",
   CellTags->{"Ex.Dice", "i:43", "4.2 Exercises"}],
  Cell[1716702, 41385, 877, 33, 127, "ExerciseItem",
   CellTags->{"6.3 Exercises", "i:43"}],
  Cell[3133710, 70402, 198, 4, 117, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:43"}]},
 "4.2 Solutions"->{
  Cell[832374, 17602, 570, 20, 172, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[832969, 17626, 375, 13, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[833347, 17641, 199, 7, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[833583, 17653, 436, 15, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[834022, 17670, 258, 9, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[834329, 17685, 270, 8, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[834624, 17697, 343, 9, 292, "Input",
   CellTags->"4.2 Solutions"],
  Cell[834970, 17708, 1643, 68, 172, "Output",
   CellTags->"4.2 Solutions"],
  Cell[836628, 17779, 182, 7, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[836813, 17788, 113, 3, 69, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[836951, 17795, 322, 9, 189, "Input",
   CellTags->"4.2 Solutions"],
  Cell[837276, 17806, 57, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[837348, 17810, 90, 2, 69, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[837475, 17817, 348, 11, 117, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[837848, 17832, 340, 11, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[838191, 17845, 157, 5, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[838363, 17853, 135, 3, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[838523, 17860, 991, 33, 141, "Input",
   CellTags->"4.2 Solutions"],
  Cell[839517, 17895, 647, 23, 72, "Output",
   CellTags->"4.2 Solutions"],
  Cell[840179, 17921, 92, 1, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[840274, 17924, 350, 13, 175, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[840627, 17939, 102, 1, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[840754, 17944, 563, 17, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[841320, 17963, 112, 3, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[841447, 17969, 131, 3, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[841603, 17976, 106, 3, 144, "Input",
   CellTags->"4.2 Solutions"],
  Cell[841712, 17981, 56, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[841783, 17985, 294, 9, 117, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[842080, 17996, 500, 15, 130, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[842605, 18015, 150, 4, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[842758, 18021, 56, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[842829, 18025, 123, 3, 69, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[842989, 18033, 96, 1, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[843110, 18038, 607, 19, 103, "Input",
   CellTags->"4.2 Solutions"],
  Cell[843720, 18059, 1283, 34, 172, "Output",
   CellTags->"4.2 Solutions"],
  Cell[845018, 18096, 349, 9, 117, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[845392, 18109, 201, 6, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[845596, 18117, 289, 9, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[845900, 18129, 100, 1, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[846025, 18134, 171, 5, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[846199, 18141, 539, 16, 121, "Output",
   CellTags->"4.2 Solutions"],
  Cell[846775, 18162, 184, 5, 73, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[846962, 18169, 539, 16, 121, "Output",
   CellTags->"4.2 Solutions"],
  Cell[847550, 18191, 104, 1, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[847657, 18194, 343, 11, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[848025, 18209, 462, 15, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[848490, 18226, 198, 5, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[848737, 18237, 204, 6, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[848944, 18245, 341, 10, 73, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[849310, 18259, 178, 5, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[849491, 18266, 57, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[849597, 18273, 190, 7, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[849790, 18282, 636, 19, 127, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[850429, 18303, 97, 1, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[850529, 18306, 162, 5, 69, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[850694, 18313, 156, 4, 69, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[850875, 18321, 238, 7, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[851116, 18330, 612, 21, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[851765, 18356, 115, 3, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[851883, 18361, 73, 2, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[852005, 18369, 369, 14, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[852399, 18387, 285, 9, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[852687, 18398, 78, 2, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[852780, 18403, 380, 11, 117, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[853185, 18418, 296, 8, 87, "Input",
   CellTags->"4.2 Solutions"],
  Cell[853484, 18428, 78, 2, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[853577, 18433, 562, 15, 168, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[854142, 18450, 715, 21, 181, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[854882, 18475, 182, 5, 103, "Input",
   CellTags->"4.2 Solutions"],
  Cell[855067, 18482, 56, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[855160, 18488, 199, 6, 103, "Input",
   CellTags->"4.2 Solutions"],
  Cell[855362, 18496, 621, 18, 76, "Output",
   CellTags->"4.2 Solutions"],
  Cell[856020, 18519, 97, 2, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[856120, 18523, 57, 1, 67, "Output",
   CellTags->"4.2 Solutions"],
  Cell[856226, 18530, 111, 2, 67, "SolutionItem",
   CellTags->"4.2 Solutions"],
  Cell[856362, 18536, 259, 8, 136, "Input",
   CellTags->"4.2 Solutions"],
  Cell[856624, 18546, 247, 9, 171, "Output",
   CellTags->"4.2 Solutions"],
  Cell[856886, 18558, 159, 4, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[857048, 18564, 334, 11, 123, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[857385, 18577, 82, 1, 67, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[857492, 18582, 901, 21, 240, "Input",
   CellTags->"4.2 Solutions"],
  Cell[858396, 18605, 1959, 41, 195, "Output",
   CellTags->"4.2 Solutions"],
  Cell[860370, 18649, 523, 16, 117, "SolutionText",
   CellTags->"4.2 Solutions"],
  Cell[860896, 18667, 4493, 109, 1057, "InputOnly",
   CellTags->"4.2 Solutions"],
  Cell[865414, 18780, 200, 6, 82, "Input",
   CellTags->"4.2 Solutions"],
  Cell[865617, 18788, 18096, 471, 166, "Output",
   CellTags->"4.2 Solutions"]},
 "i:51"->{
  Cell[883866, 19271, 497, 12, 171, "ExerciseItem",
   CellTags->{"i:51", "4.3 Exercises"}],
  Cell[1699418, 40695, 366, 14, 76, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:51"}],
  Cell[3633658, 83214, 485, 14, 126, "ExerciseText",
   CellTags->{"10.2 Exercises", "i:51"}]},
 "4.3 Exercises"->{
  Cell[883866, 19271, 497, 12, 171, "ExerciseItem",
   CellTags->{"i:51", "4.3 Exercises"}],
  Cell[884388, 19287, 167, 4, 103, "ExerciseInput",
   CellTags->"4.3 Exercises"],
  Cell[884558, 19293, 285, 5, 222, "ExerciseOutput",
   CellTags->"4.3 Exercises"],
  Cell[884880, 19303, 142, 3, 82, "ExerciseInput",
   CellTags->"4.3 Exercises"],
  Cell[885025, 19308, 289, 10, 67, "ExerciseOutput",
   CellTags->"4.3 Exercises"],
  Cell[885341, 19322, 586, 22, 123, "ExerciseItem",
   CellTags->"4.3 Exercises"],
  Cell[885952, 19348, 85, 1, 67, "ExerciseItem",
   CellTags->"4.3 Exercises"],
  Cell[886062, 19353, 437, 13, 136, "ExerciseInput",
   CellTags->"4.3 Exercises"],
  Cell[886502, 19368, 879, 22, 310, "ExerciseOutput",
   CellTags->"4.3 Exercises"],
  Cell[887396, 19393, 261, 5, 123, "ExerciseText",
   CellTags->"4.3 Exercises"],
  Cell[887660, 19400, 1037, 24, 274, "ExerciseOutput",
   CellTags->"4.3 Exercises"],
  Cell[888734, 19429, 540, 10, 217, "ExerciseItem",
   CellTags->{"i:52", "4.3 Exercises"}],
  Cell[889277, 19441, 841, 21, 249, "Input",
   CellTags->"4.3 Exercises"]},
 "i:52"->{
  Cell[888734, 19429, 540, 10, 217, "ExerciseItem",
   CellTags->{"i:52", "4.3 Exercises"}],
  Cell[3634180, 83233, 295, 7, 127, "ExerciseItem",
   CellTags->{"10.2 Exercises", "i:52"}]},
 "4.3 Solutions"->{
  Cell[890219, 19471, 151, 5, 67, "SolutionItem",
   CellTags->"4.3 Solutions"],
  Cell[890373, 19478, 848, 26, 231, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[891224, 19506, 277, 6, 117, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[891504, 19514, 571, 16, 229, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[892078, 19532, 164, 6, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[892245, 19540, 356, 11, 90, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[892604, 19553, 196, 6, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[892825, 19563, 123, 3, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[892951, 19568, 540, 17, 121, "Output",
   CellTags->"4.3 Solutions"],
  Cell[893540, 19591, 90, 1, 67, "SolutionItem",
   CellTags->"4.3 Solutions"],
  Cell[893655, 19596, 314, 10, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[893972, 19608, 15150, 256, 339, "Output",
   CellTags->"4.3 Solutions"],
  Cell[909137, 19867, 171, 4, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[909333, 19875, 535, 17, 139, "Input",
   CellTags->"4.3 Solutions"],
  Cell[909871, 19894, 15048, 254, 307, "Output",
   CellTags->"4.3 Solutions"],
  Cell[924934, 20151, 478, 10, 222, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[925449, 20166, 204, 4, 117, "SolutionItem",
   CellTags->"4.3 Solutions"],
  Cell[925678, 20174, 243, 8, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[925924, 20184, 865, 24, 172, "Output",
   CellTags->"4.3 Solutions"],
  Cell[926826, 20213, 360, 12, 87, "Input",
   CellTags->"4.3 Solutions"],
  Cell[927189, 20227, 1192, 24, 468, "Output",
   CellTags->"4.3 Solutions"],
  Cell[928430, 20257, 100, 1, 67, "SolutionItem",
   CellTags->"4.3 Solutions"],
  Cell[928533, 20260, 1257, 30, 285, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[929793, 20292, 103, 1, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[929921, 20297, 304, 10, 139, "Input",
   CellTags->"4.3 Solutions"],
  Cell[930228, 20309, 163, 5, 67, "Output",
   CellTags->"4.3 Solutions"],
  Cell[930406, 20317, 90, 1, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[930521, 20322, 175, 5, 87, "Input",
   CellTags->"4.3 Solutions"],
  Cell[930699, 20329, 74, 1, 67, "Output",
   CellTags->"4.3 Solutions"],
  Cell[930788, 20333, 92, 1, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[930905, 20338, 289, 9, 87, "Input",
   CellTags->"4.3 Solutions"],
  Cell[931197, 20349, 748, 23, 310, "Output",
   CellTags->"4.3 Solutions"],
  Cell[931960, 20375, 76, 1, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[932039, 20378, 509, 15, 180, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[932551, 20395, 142, 5, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[932718, 20404, 90, 2, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[932811, 20408, 192, 5, 67, "Output",
   CellTags->"4.3 Solutions"],
  Cell[933018, 20416, 94, 1, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[933137, 20421, 262, 8, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[933402, 20431, 1102, 26, 310, "Output",
   CellTags->"4.3 Solutions"],
  Cell[934519, 20460, 188, 4, 117, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[934732, 20468, 127, 3, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[934862, 20473, 1102, 26, 310, "Output",
   CellTags->"4.3 Solutions"],
  Cell[935979, 20502, 143, 5, 67, "SolutionText",
   CellTags->"4.3 Solutions"],
  Cell[936125, 20509, 1048, 29, 337, "InputOnly",
   CellTags->"4.3 Solutions"],
  Cell[937198, 20542, 126, 3, 82, "Input",
   CellTags->"4.3 Solutions"],
  Cell[937327, 20547, 1102, 26, 310, "Output",
   CellTags->"4.3 Solutions"]},
 "i:24"->{
  Cell[939537, 20611, 329, 12, 76, "ExerciseItem",
   CellTags->{"i:24", "5.2 Exercises"}]},
 "5.2 Exercises"->{
  Cell[939537, 20611, 329, 12, 76, "ExerciseItem",
   CellTags->{"i:24", "5.2 Exercises"}],
  Cell[939869, 20625, 333, 9, 117, "ExerciseItem",
   CellTags->{"Ex.Pointset diameter", "i:139", "5.2 Exercises"}],
  Cell[940227, 20638, 789, 32, 123, "ExerciseItem",
   CellTags->{"i:25", "5.2 Exercises"}],
  Cell[941041, 20674, 306, 8, 136, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[941350, 20684, 761, 21, 310, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[942148, 20710, 207, 5, 82, "ExerciseInput",
   CellTags->{"i:26", "5.2 Exercises"}],
  Cell[942358, 20717, 11998, 228, 351, "ExerciseOutput",
   CellTags->{"i:26", "5.2 Exercises"}],
  Cell[954371, 20948, 332, 6, 175, "ExerciseText",
   CellTags->"5.2 Exercises"],
  Cell[954706, 20956, 193, 6, 67, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[954936, 20967, 374, 11, 123, "ExerciseItem",
   CellTags->{"Ex.ToGraph", "5.2 Exercises"}],
  Cell[955335, 20982, 219, 7, 82, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[955557, 20991, 811, 27, 121, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[956405, 21023, 112, 2, 82, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[956520, 21027, 681, 16, 121, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[957216, 21046, 172, 4, 73, "ExerciseText",
   CellTags->"5.2 Exercises"],
  Cell[957413, 21054, 149, 4, 82, "Input",
   CellTags->"5.2 Exercises"],
  Cell[957565, 21060, 106, 2, 67, "Output",
   CellTags->"5.2 Exercises"],
  Cell[957698, 21066, 464, 16, 123, "ExerciseItem",
   CellTags->{"i:30", "5.2 Exercises"}],
  Cell[958165, 21084, 721, 23, 163, "ExerciseItem",
   CellTags->"5.2 Exercises"],
  Cell[958889, 21109, 421, 18, 67, "ExerciseItem",
   CellTags->"5.2 Exercises"],
  Cell[959335, 21131, 417, 13, 117, "ExerciseItem",
   CellTags->{"i:31", "5.2 Exercises"}],
  Cell[959777, 21148, 295, 10, 82, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[960075, 21160, 246, 8, 67, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[960336, 21171, 522, 22, 73, "ExerciseText",
   CellTags->"5.2 Exercises"],
  Cell[960895, 21198, 369, 12, 76, "ExerciseItem",
   CellTags->{"i:32", "5.2 Exercises"}],
  Cell[961289, 21214, 124, 3, 82, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[961416, 21219, 339, 11, 67, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[961770, 21233, 232, 8, 73, "ExerciseText",
   CellTags->"5.2 Exercises"],
  Cell[962017, 21244, 503, 18, 123, "ExerciseItem",
   CellTags->"5.2 Exercises"],
  Cell[962545, 21266, 377, 13, 117, "ExerciseItem",
   CellTags->"5.2 Exercises"],
  Cell[962947, 21283, 119, 2, 82, "ExerciseInput",
   CellTags->"5.2 Exercises"],
  Cell[963069, 21287, 191, 6, 76, "ExerciseOutput",
   CellTags->"5.2 Exercises"],
  Cell[963275, 21296, 351, 13, 73, "ExerciseText",
   CellTags->"5.2 Exercises"],
  Cell[963663, 21314, 331, 8, 123, "ExerciseItem",
   CellTags->{"i:155", "5.2 Exercises"}],
  Cell[963997, 21324, 1217, 32, 261, "ExerciseDisplayFormula",
   CellTags->"5.2 Exercises"],
  Cell[965251, 21361, 1911, 69, 171, "ExerciseItem",
   CellTags->{"i:33", "5.2 Exercises"}],
  Cell[967165, 21432, 590, 20, 130, "ExerciseDisplayFormula",
   CellTags->"5.2 Exercises"],
  Cell[967770, 21455, 867, 29, 171, "ExerciseItem",
   CellTags->{"i:34", "5.2 Exercises"}]},
 "Ex.Pointset diameter"->{
  Cell[939869, 20625, 333, 9, 117, "ExerciseItem",
   CellTags->{"Ex.Pointset diameter", "i:139", "5.2 Exercises"}]},
 "i:139"->{
  Cell[939869, 20625, 333, 9, 117, "ExerciseItem",
   CellTags->{"Ex.Pointset diameter", "i:139", "5.2 Exercises"}]},
 "i:25"->{
  Cell[940227, 20638, 789, 32, 123, "ExerciseItem",
   CellTags->{"i:25", "5.2 Exercises"}]},
 "i:26"->{
  Cell[942148, 20710, 207, 5, 82, "ExerciseInput",
   CellTags->{"i:26", "5.2 Exercises"}],
  Cell[942358, 20717, 11998, 228, 351, "ExerciseOutput",
   CellTags->{"i:26", "5.2 Exercises"}],
  Cell[7319180, 171816, 199, 4, 85, "ExerciseItem",
   CellTags->{"11.1 Exercises", "i:26"}]},
 "Ex.ToGraph"->{
  Cell[954936, 20967, 374, 11, 123, "ExerciseItem",
   CellTags->{"Ex.ToGraph", "5.2 Exercises"}]},
 "i:31"->{
  Cell[959335, 21131, 417, 13, 117, "ExerciseItem",
   CellTags->{"i:31", "5.2 Exercises"}],
  Cell[1694394, 40506, 1100, 43, 114, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:31"}],
  Cell[7328869, 172071, 370, 12, 81, "ExerciseItem",
   CellTags->{"i:31", "11.1 Exercises"}]},
 "i:32"->{
  Cell[960895, 21198, 369, 12, 76, "ExerciseItem",
   CellTags->{"i:32", "5.2 Exercises"}],
  Cell[1691564, 40410, 849, 27, 118, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:32"}],
  Cell[1964660, 48054, 583, 20, 130, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:32"}],
  Cell[7332004, 172153, 415, 9, 114, "ExerciseItem",
   CellTags->{"Ex.Epicycloids", "i:32", "11.1 Exercises"}]},
 "i:155"->{
  Cell[963663, 21314, 331, 8, 123, "ExerciseItem",
   CellTags->{"i:155", "5.2 Exercises"}]},
 "i:33"->{
  Cell[965251, 21361, 1911, 69, 171, "ExerciseItem",
   CellTags->{"i:33", "5.2 Exercises"}],
  Cell[1699787, 40711, 1164, 42, 171, "ExerciseItem",
   CellTags->{"6.2 Exercises", "Ex.Collatz", "i:33"}],
  Cell[1965268, 48078, 921, 34, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:33", "Ex.Convert"}],
  Cell[7333622, 172209, 1752, 43, 153, "ExerciseItem",
   CellTags->{"i:33", "11.1 Exercises"}]},
 "i:34"->{
  Cell[967770, 21455, 867, 29, 171, "ExerciseItem",
   CellTags->{"i:34", "5.2 Exercises"}],
  Cell[1970151, 48237, 542, 16, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:34"}],
  Cell[7335377, 172254, 265, 5, 81, "ExerciseItem",
   CellTags->{"i:34", "11.1 Exercises"}]},
 "5.2 Solutions"->{
  Cell[968726, 21492, 155, 7, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[968884, 21501, 375, 11, 126, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[969262, 21514, 587, 18, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[969852, 21534, 256, 7, 73, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[970145, 21546, 100, 1, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[970248, 21549, 218, 7, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[970469, 21558, 99, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[970571, 21561, 190, 6, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[970764, 21569, 336, 12, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[971103, 21583, 187, 5, 69, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[971293, 21590, 228, 8, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[971546, 21602, 84, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[971633, 21606, 72, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[971720, 21610, 97, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[971820, 21613, 366, 10, 126, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[972211, 21627, 102, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[972316, 21631, 72, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[972403, 21635, 178, 6, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[972606, 21645, 196, 6, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[972805, 21653, 750, 23, 172, "Output",
   CellTags->"5.2 Solutions"],
  Cell[973592, 21681, 104, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[973699, 21685, 74, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[973822, 21692, 74, 1, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[973921, 21697, 284, 8, 136, "Input",
   CellTags->"5.2 Solutions"],
  Cell[974208, 21707, 739, 21, 310, "Output",
   CellTags->"5.2 Solutions"],
  Cell[974962, 21731, 242, 6, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[975229, 21741, 177, 5, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[975409, 21748, 131, 3, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[975555, 21754, 99, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[975679, 21759, 198, 5, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[975880, 21766, 14109, 265, 375, "Output",
   CellTags->"5.2 Solutions"],
  Cell[990026, 22036, 94, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[990123, 22040, 131, 3, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[990303, 22049, 267, 10, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[990573, 22061, 348, 11, 73, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[990946, 22076, 285, 9, 136, "Input",
   CellTags->"5.2 Solutions"],
  Cell[991234, 22087, 657, 15, 121, "Output",
   CellTags->"5.2 Solutions"],
  Cell[991906, 22105, 153, 4, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[992084, 22113, 135, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[992222, 22119, 136, 4, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[992373, 22126, 90, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[992466, 22129, 258, 8, 87, "Input",
   CellTags->"5.2 Solutions"],
  Cell[992749, 22141, 135, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[992887, 22147, 92, 2, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[993028, 22155, 459, 16, 117, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[993490, 22173, 270, 8, 69, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[993763, 22183, 522, 18, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[994288, 22203, 377, 11, 126, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[994702, 22219, 95, 1, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[994822, 22224, 339, 11, 136, "Input",
   CellTags->"5.2 Solutions"],
  Cell[995164, 22237, 1501, 44, 328, "Output",
   CellTags->"5.2 Solutions"],
  Cell[996702, 22286, 167, 5, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[996872, 22293, 447, 9, 121, "Output",
   CellTags->"5.2 Solutions"],
  Cell[997334, 22305, 398, 12, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[997757, 22321, 272, 9, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[998032, 22332, 589, 17, 103, "Output",
   CellTags->"5.2 Solutions"],
  Cell[998658, 22354, 95, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[998756, 22358, 1045, 18, 1401, "Output",
   CellTags->"5.2 Solutions"],
  Cell[999816, 22379, 371, 13, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1000212, 22396, 332, 9, 87, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1000547, 22407, 2319, 50, 1401, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1002915, 22463, 222, 8, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1003162, 22475, 247, 7, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1003412, 22484, 278, 9, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1003705, 22496, 325, 12, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1004055, 22512, 288, 9, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1004346, 22523, 273, 9, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1004656, 22537, 109, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1004768, 22542, 278, 9, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1005095, 22557, 251, 8, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1005371, 22569, 315, 11, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1005689, 22582, 277, 10, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1006003, 22597, 86, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1006092, 22601, 224, 8, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1006353, 22614, 340, 11, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1006696, 22627, 224, 8, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1006969, 22641, 273, 9, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1007267, 22654, 126, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1007396, 22659, 317, 11, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1007750, 22675, 150, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1007903, 22681, 125, 3, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1008043, 22687, 238, 8, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1008306, 22699, 113, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1008422, 22704, 62, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1008499, 22708, 99, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1008601, 22711, 288, 8, 73, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[1008914, 22723, 135, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1009052, 22728, 739, 25, 121, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1009828, 22758, 94, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1009925, 22762, 94, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1010068, 22769, 124, 3, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1010217, 22776, 126, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1010346, 22781, 317, 11, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1010678, 22795, 421, 13, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1011124, 22812, 174, 5, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1011301, 22819, 239, 7, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1011577, 22831, 151, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1011731, 22837, 62, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1011808, 22841, 432, 14, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1012243, 22857, 278, 8, 126, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[1012546, 22869, 98, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1012647, 22873, 62, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1012758, 22880, 111, 2, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1012894, 22886, 139, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1013036, 22892, 317, 11, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1013368, 22906, 268, 10, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1013661, 22920, 155, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1013819, 22926, 289, 11, 87, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1014123, 22940, 224, 8, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1014372, 22952, 117, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1014492, 22957, 291, 10, 76, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1014798, 22970, 402, 15, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1015203, 22987, 261, 7, 73, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[1015489, 22998, 115, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1015607, 23003, 540, 18, 76, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1016162, 23024, 135, 3, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1016322, 23031, 96, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1016421, 23035, 131, 4, 85, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1016567, 23042, 98, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1016668, 23045, 269, 7, 126, "InputOnly",
   CellTags->"5.2 Solutions"],
  Cell[1016962, 23056, 96, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1017061, 23060, 94, 3, 76, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1017170, 23066, 235, 7, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1017430, 23077, 86, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1017519, 23081, 109, 1, 130, "Print",
   CellTags->{"5.2 Solutions", "Info3563802280-1903310"}],
  Cell[1017631, 23084, 1377, 36, 283, "Print",
   CellTags->{"5.2 Solutions", "Info3563802280-1903310"}],
  Cell[1019023, 23123, 307, 6, 168, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1019333, 23131, 673, 18, 168, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1020009, 23151, 633, 19, 243, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1020645, 23172, 160, 4, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1020830, 23180, 115, 3, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1020948, 23185, 471, 16, 76, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1021468, 23207, 242, 8, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1021713, 23217, 479, 14, 139, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1022217, 23235, 155, 4, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1022375, 23241, 1079, 32, 315, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1023503, 23279, 293, 7, 117, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1023821, 23290, 283, 9, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1024107, 23301, 250, 8, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1024372, 23312, 107, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1024482, 23315, 225, 6, 87, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1024710, 23323, 180, 4, 117, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1024915, 23331, 453, 15, 105, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1025371, 23348, 1140, 41, 154, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1026548, 23394, 89, 2, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1026640, 23398, 56, 1, 67, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1026711, 23402, 489, 10, 220, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1027237, 23417, 182, 5, 67, "SolutionItem",
   CellTags->"5.2 Solutions"],
  Cell[1027444, 23426, 234, 7, 82, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1027681, 23435, 686, 12, 222, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1028404, 23452, 288, 10, 100, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1028695, 23464, 355, 7, 222, "Output",
   CellTags->"5.2 Solutions"],
  Cell[1029065, 23474, 97, 1, 67, "SolutionText",
   CellTags->"5.2 Solutions"],
  Cell[1029187, 23479, 331, 11, 103, "Input",
   CellTags->"5.2 Solutions"],
  Cell[1029521, 23492, 355, 7, 222, "Output",
   CellTags->"5.2 Solutions"]},
 "Info3563802280-1903310"->{
  Cell[1017519, 23081, 109, 1, 130, "Print",
   CellTags->{"5.2 Solutions", "Info3563802280-1903310"}],
  Cell[1017631, 23084, 1377, 36, 283, "Print",
   CellTags->{"5.2 Solutions", "Info3563802280-1903310"}]},
 "Sec.Iterating functions"->{
  Cell[1029949, 23507, 87, 1, 45, "ExerciseSubsection",
   CellTags->"Sec.Iterating functions"]},
 "i:44"->{
  Cell[1030039, 23510, 360, 11, 123, "ExerciseItem",
   CellTags->{"i:44", "5.3 Exercises"}],
  Cell[1722710, 41613, 165, 4, 69, "ExerciseItem",
   CellTags->{"i:44", "6.3 Exercises"}],
  Cell[3135417, 70472, 915, 29, 180, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:44"}]},
 "5.3 Exercises"->{
  Cell[1030039, 23510, 360, 11, 123, "ExerciseItem",
   CellTags->{"i:44", "5.3 Exercises"}],
  Cell[1030402, 23523, 154, 4, 67, "ExerciseItem",
   CellTags->{"i:45", "5.3 Exercises"}],
  Cell[1030559, 23529, 931, 37, 117, "ExerciseItem",
   CellTags->"5.3 Exercises"],
  Cell[1031515, 23570, 325, 6, 163, "ExerciseItem",
   CellTags->{"i:150", "5.3 Exercises"}],
  Cell[1031843, 23578, 691, 21, 220, "ExerciseDisplayFormula",
   CellTags->"5.3 Exercises"],
  Cell[1032537, 23601, 164, 4, 73, "ExerciseText",
   CellTags->"5.3 Exercises"],
  Cell[1032704, 23607, 3060, 72, 222, "ExerciseDisplayFormula",
   CellTags->"5.3 Exercises"],
  Cell[1035767, 23681, 561, 15, 175, "ExerciseText",
   CellTags->"5.3 Exercises"]},
 "i:45"->{
  Cell[1030402, 23523, 154, 4, 67, "ExerciseItem",
   CellTags->{"i:45", "5.3 Exercises"}]},
 "i:150"->{
  Cell[1031515, 23570, 325, 6, 163, "ExerciseItem",
   CellTags->{"i:150", "5.3 Exercises"}]},
 "5.3 Solutions"->{
  Cell[1036429, 23705, 87, 1, 67, "SolutionItem",
   CellTags->"5.3 Solutions"],
  Cell[1036541, 23710, 246, 8, 103, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1036790, 23720, 314, 10, 67, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1037119, 23733, 80, 1, 67, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1037224, 23738, 219, 7, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1037446, 23747, 276, 8, 67, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1037737, 23758, 158, 5, 67, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1037920, 23767, 129, 3, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1038052, 23772, 362, 12, 67, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1038463, 23790, 154, 4, 67, "SolutionItem",
   CellTags->"5.3 Solutions"],
  Cell[1038642, 23798, 509, 17, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1039154, 23817, 713, 25, 121, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1039904, 23847, 178, 5, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1040085, 23854, 730, 25, 121, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1040864, 23885, 332, 13, 67, "SolutionItem",
   CellTags->"5.3 Solutions"],
  Cell[1041199, 23900, 216, 6, 73, "InputOnly",
   CellTags->"5.3 Solutions"],
  Cell[1041440, 23910, 85, 2, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1041528, 23914, 62, 1, 67, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1041639, 23921, 310, 10, 117, "SolutionItem",
   CellTags->"5.3 Solutions"],
  Cell[1041952, 23933, 389, 14, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1042344, 23949, 103, 1, 67, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1042472, 23954, 116, 3, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1042591, 23959, 274, 9, 67, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1042880, 23971, 260, 7, 117, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1043165, 23982, 523, 15, 240, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1043691, 23999, 309, 8, 364, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1044015, 24010, 243, 8, 67, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1044283, 24022, 593, 18, 240, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1044879, 24042, 724, 15, 364, "Output",
   CellTags->"5.3 Solutions"],
  Cell[1045618, 24060, 241, 5, 117, "SolutionText",
   CellTags->"5.3 Solutions"],
  Cell[1045862, 24067, 1511, 43, 397, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1047398, 24114, 164, 4, 82, "Input",
   CellTags->"5.3 Solutions"],
  Cell[1047565, 24120, 26557, 439, 634, 1818, 31, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"5.3 Solutions"]},
 "Exercise.Total ints"->{
  Cell[1074249, 24569, 329, 11, 76, "ExerciseItem",
   CellTags->{"Exercise.Total ints", "5.4 Exercises"}]},
 "5.4 Exercises"->{
  Cell[1074249, 24569, 329, 11, 76, "ExerciseItem",
   CellTags->{"Exercise.Total ints", "5.4 Exercises"}],
  Cell[1074581, 24582, 266, 10, 67, "ExerciseItem",
   CellTags->"5.4 Exercises"],
  Cell[1074850, 24594, 297, 8, 117, "ExerciseItem",
   CellTags->"5.4 Exercises"],
  Cell[1075172, 24606, 588, 15, 163, "ExerciseItem",
   CellTags->{"i:54", "5.4 Exercises"}],
  Cell[1075785, 24625, 198, 6, 82, "ExerciseInput",
   CellTags->"5.4 Exercises"],
  Cell[1075986, 24633, 156, 4, 67, "ExerciseOutput",
   CellTags->"5.4 Exercises"],
  Cell[1076157, 24640, 600, 19, 123, "ExerciseText",
   CellTags->"5.4 Exercises"],
  Cell[1076782, 24663, 259, 7, 82, "ExerciseInput",
   CellTags->"5.4 Exercises"],
  Cell[1077044, 24672, 232, 6, 67, "ExerciseOutput",
   CellTags->"5.4 Exercises"],
  Cell[1077303, 24682, 442, 15, 123, "ExerciseItem",
   CellTags->"5.4 Exercises"],
  Cell[1077748, 24699, 637, 23, 117, "ExerciseItem",
   CellTags->{"i:55", "5.4 Exercises"}],
  Cell[1078388, 24724, 944, 30, 163, "ExerciseItem",
   CellTags->{"Ex.interleave", "5.4 Exercises"}],
  Cell[1079335, 24756, 662, 23, 117, "ExerciseItem",
   CellTags->{"i:56", "5.4 Exercises"}]},
 "i:54"->{
  Cell[1075172, 24606, 588, 15, 163, "ExerciseItem",
   CellTags->{"i:54", "5.4 Exercises"}],
  Cell[3643639, 83467, 3289, 84, 307, "ExerciseItem",
   CellTags->{"i:54", "10.2 Exercises"}]},
 "i:55"->{
  Cell[1077748, 24699, 637, 23, 117, "ExerciseItem",
   CellTags->{"i:55", "5.4 Exercises"}],
  Cell[7501112, 175527, 291, 8, 51, "ExerciseItem",
   CellTags->{"11.2 Exercises", "i:55"}]},
 "Ex.interleave"->{
  Cell[1078388, 24724, 944, 30, 163, "ExerciseItem",
   CellTags->{"Ex.interleave", "5.4 Exercises"}]},
 "i:56"->{
  Cell[1079335, 24756, 662, 23, 117, "ExerciseItem",
   CellTags->{"i:56", "5.4 Exercises"}]},
 "5.4 Solutions"->{
  Cell[1080086, 24787, 201, 8, 67, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1080290, 24797, 182, 5, 73, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1080497, 24806, 90, 2, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1080590, 24810, 59, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1080686, 24816, 91, 2, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1080780, 24820, 61, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1080856, 24824, 246, 8, 117, "SolutionText",
   CellTags->"5.4 Solutions"],
  Cell[1081139, 24837, 815, 25, 168, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1081957, 24864, 243, 7, 73, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1082225, 24875, 171, 5, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1082399, 24882, 59, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1082495, 24888, 171, 5, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1082669, 24895, 60, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1082744, 24899, 342, 12, 67, "SolutionText",
   CellTags->"5.4 Solutions"],
  Cell[1083089, 24913, 306, 10, 73, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1083420, 24927, 171, 5, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1083594, 24934, 59, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1083690, 24940, 171, 5, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1083864, 24947, 60, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1083973, 24954, 435, 11, 168, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1084411, 24967, 553, 16, 139, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1084989, 24987, 158, 4, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1085150, 24993, 675, 11, 172, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1085874, 25010, 543, 17, 117, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1086420, 25029, 407, 12, 73, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1086852, 25045, 237, 7, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1087092, 25054, 208, 5, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1087349, 25065, 152, 4, 67, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1087504, 25071, 437, 12, 141, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1087944, 25085, 303, 9, 87, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1088272, 25098, 249, 7, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1088524, 25107, 8250, 332, 855, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1096811, 25444, 292, 8, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1097106, 25454, 5042, 172, 535, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1102197, 25632, 130, 5, 67, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1102330, 25639, 677, 17, 280, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1103032, 25660, 159, 4, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1103194, 25666, 79, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1103288, 25670, 291, 9, 73, "InputOnly",
   CellTags->"5.4 Solutions"],
  Cell[1103604, 25683, 146, 4, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1103753, 25689, 67, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1103835, 25693, 727, 24, 168, "SolutionText",
   CellTags->"5.4 Solutions"],
  Cell[1104599, 25722, 286, 10, 117, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1104888, 25734, 636, 20, 190, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1105549, 25758, 242, 7, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1105794, 25767, 154, 4, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1105963, 25774, 216, 8, 67, "SolutionText",
   CellTags->"5.4 Solutions"],
  Cell[1106204, 25786, 238, 7, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1106445, 25795, 154, 4, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1106648, 25805, 145, 5, 67, "SolutionItem",
   CellTags->"5.4 Solutions"],
  Cell[1106818, 25814, 324, 7, 189, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1107145, 25823, 82, 1, 67, "Output",
   CellTags->"5.4 Solutions"],
  Cell[1107242, 25827, 145, 5, 67, "SolutionText",
   CellTags->"5.4 Solutions"],
  Cell[1107412, 25836, 175, 4, 82, "Input",
   CellTags->"5.4 Solutions"],
  Cell[1107590, 25842, 82, 1, 67, "Output",
   CellTags->"5.4 Solutions"]},
 "Sec.Scoping constructs"->{
  Cell[1107745, 25851, 85, 1, 45, "ExerciseSubsection",
   CellTags->"Sec.Scoping constructs"]},
 "i:70"->{
  Cell[1107833, 25854, 725, 23, 171, "ExerciseItem",
   CellTags->{"i:70", "5.5 Exercises"}],
  Cell[3189118, 72227, 890, 22, 306, "ExerciseItem",
   CellTags->{"i:70", "9.4 Exercises"}],
  Cell[6333068, 154546, 263, 5, 81, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:70"}]},
 "5.5 Exercises"->{
  Cell[1107833, 25854, 725, 23, 171, "ExerciseItem",
   CellTags->{"i:70", "5.5 Exercises"}],
  Cell[1108561, 25879, 1326, 44, 256, "ExerciseItem",
   CellTags->{"Ex.Perfect numbers", "i:71", "5.5 Exercises"}],
  Cell[1109890, 25925, 988, 38, 163, "ExerciseItem",
   CellTags->"5.5 Exercises"],
  Cell[1110903, 25967, 1451, 47, 256, "ExerciseItem",
   CellTags->{"i:72", "5.5 Exercises"}],
  Cell[1112379, 26018, 125, 3, 82, "ExerciseInput",
   CellTags->"5.5 Exercises"],
  Cell[1112507, 26023, 139, 4, 67, "ExerciseOutput",
   CellTags->"5.5 Exercises"],
  Cell[1112673, 26031, 592, 21, 123, "ExerciseItem",
   CellTags->"5.5 Exercises"]},
 "Ex.Perfect numbers"->{
  Cell[1108561, 25879, 1326, 44, 256, "ExerciseItem",
   CellTags->{"Ex.Perfect numbers", "i:71", "5.5 Exercises"}]},
 "i:71"->{
  Cell[1108561, 25879, 1326, 44, 256, "ExerciseItem",
   CellTags->{"Ex.Perfect numbers", "i:71", "5.5 Exercises"}],
  Cell[7503449, 175619, 210, 4, 85, "ExerciseItem",
   CellTags->{"11.3 Exercises", "i:71"}]},
 "i:72"->{
  Cell[1110903, 25967, 1451, 47, 256, "ExerciseItem",
   CellTags->{"i:72", "5.5 Exercises"}],
  Cell[7506104, 175695, 489, 11, 114, "ExerciseItem",
   CellTags->{"i:72", "11.3 Exercises"}]},
 "5.5 Solutions"->{
  Cell[1113354, 26060, 261, 8, 67, "SolutionItem",
   CellTags->"5.5 Solutions"],
  Cell[1113618, 26070, 708, 22, 177, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1114351, 26096, 95, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1114449, 26100, 860, 32, 121, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1115358, 26138, 614, 21, 117, "SolutionItem",
   CellTags->"5.5 Solutions"],
  Cell[1115975, 26161, 645, 19, 180, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1116645, 26184, 121, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1116769, 26189, 127, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1116911, 26195, 535, 13, 175, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1117471, 26212, 121, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1117595, 26217, 73, 2, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1117683, 26222, 295, 8, 117, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1117981, 26232, 102, 2, 69, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1118086, 26236, 674, 20, 180, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1118763, 26258, 113, 2, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1118901, 26264, 121, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1119025, 26269, 127, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1119189, 26277, 120, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1119312, 26282, 121, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1119482, 26291, 92, 1, 67, "SolutionItem",
   CellTags->"5.5 Solutions"],
  Cell[1119577, 26294, 736, 21, 244, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1120316, 26317, 447, 10, 168, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1120788, 26331, 174, 5, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1120965, 26338, 201, 6, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1121181, 26347, 298, 11, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1121482, 26360, 801, 22, 231, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1122308, 26386, 182, 5, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1122493, 26393, 201, 6, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1122743, 26405, 369, 10, 117, "SolutionItem",
   CellTags->"5.5 Solutions"],
  Cell[1123137, 26419, 104, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1123244, 26423, 150, 4, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1123409, 26430, 320, 10, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1123754, 26444, 96, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1123853, 26448, 152, 4, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1124020, 26455, 104, 1, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1124149, 26460, 131, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1124283, 26465, 150, 4, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1124448, 26472, 91, 1, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1124564, 26477, 108, 3, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1124675, 26482, 115, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1124805, 26488, 104, 1, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1124912, 26491, 264, 8, 73, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1125201, 26503, 101, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1125305, 26507, 115, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1125435, 26513, 255, 8, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1125693, 26523, 778, 24, 177, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1126496, 26551, 102, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1126601, 26555, 143, 4, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1126759, 26562, 515, 15, 117, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1127277, 26579, 864, 26, 229, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1128166, 26609, 102, 2, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1128271, 26613, 115, 3, 67, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1128435, 26622, 249, 5, 117, "SolutionItem",
   CellTags->"5.5 Solutions"],
  Cell[1128709, 26631, 281, 8, 136, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1128993, 26641, 1241, 26, 310, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1130249, 26670, 94, 1, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1130346, 26673, 468, 14, 177, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1130817, 26689, 105, 1, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1130925, 26692, 552, 17, 177, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1131480, 26711, 166, 4, 67, "SolutionText",
   CellTags->"5.5 Solutions"],
  Cell[1131649, 26717, 516, 16, 177, "InputOnly",
   CellTags->"5.5 Solutions"],
  Cell[1132190, 26737, 151, 4, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1132344, 26743, 1146, 26, 310, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1133527, 26774, 177, 5, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1133707, 26781, 1057, 26, 310, "Output",
   CellTags->"5.5 Solutions"],
  Cell[1134801, 26812, 215, 7, 82, "Input",
   CellTags->"5.5 Solutions"],
  Cell[1135019, 26821, 928, 21, 310, "Output",
   CellTags->"5.5 Solutions"]},
 "5.6 Exercises"->{
  Cell[1136067, 26852, 130, 3, 49, "ExerciseItem",
   CellTags->"5.6 Exercises"],
  Cell[1136200, 26857, 687, 22, 100, "ExerciseItem",
   CellTags->{"i:85", "5.6 Exercises"}],
  Cell[1136890, 26881, 493, 16, 72, "ExerciseItem",
   CellTags->"5.6 Exercises"],
  Cell[1137386, 26899, 525, 19, 72, "ExerciseItem",
   CellTags->{"i:87", "5.6 Exercises", "Ex.Repunit"}],
  Cell[1137936, 26922, 196, 4, 72, "ExerciseItem",
   CellTags->{"i:86", "5.6 Exercises"}],
  Cell[1138135, 26928, 292, 9, 33, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1138442, 26940, 1224, 45, 136, "ExerciseItem",
   CellTags->{"5.6 Exercises", "i:156"}],
  Cell[1139691, 26989, 323, 10, 72, "ExerciseItem",
   CellTags->{"i:89", "5.6 Exercises"}],
  Cell[1140039, 27003, 256, 6, 63, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1140298, 27011, 737, 12, 118, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1141084, 27029, 1035, 31, 84, "ExerciseItem",
   CellTags->{"i:90", "5.6 Exercises"}],
  Cell[1142144, 27064, 290, 9, 42, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1142437, 27075, 78, 1, 33, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1142552, 27081, 331, 11, 33, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1142886, 27094, 78, 1, 24, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1142979, 27098, 201, 6, 27, "ExerciseText",
   CellTags->"5.6 Exercises"],
  Cell[1143205, 27108, 160, 5, 82, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1143368, 27115, 178, 5, 117, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1143561, 27123, 610, 18, 175, "ExerciseText",
   CellTags->"5.6 Exercises"],
  Cell[1144196, 27145, 204, 6, 82, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1144403, 27153, 284, 10, 67, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1144724, 27168, 109, 2, 82, "ExerciseInput",
   CellTags->"5.6 Exercises"],
  Cell[1144836, 27172, 239, 7, 76, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1145124, 27185, 614, 18, 171, "ExerciseItem",
   CellTags->{"i:91", "5.6 Exercises"}],
  Cell[1145763, 27207, 261, 8, 82, "Input",
   CellTags->"5.6 Exercises"],
  Cell[1146027, 27217, 7012, 163, 292, "Output",
   CellTags->"5.6 Exercises"],
  Cell[1153054, 27383, 303, 7, 123, "ExerciseText",
   CellTags->"5.6 Exercises"],
  Cell[1153360, 27392, 182, 6, 67, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1153545, 27400, 607, 20, 175, "ExerciseText",
   CellTags->"5.6 Exercises"],
  Cell[1154155, 27422, 1119, 38, 121, "ExerciseOutput",
   CellTags->"5.6 Exercises"],
  Cell[1155311, 27465, 606, 21, 127, "ExerciseItem",
   CellTags->"5.6 Exercises"],
  Cell[1155942, 27490, 304, 9, 87, "ExerciseInput",
   CellTags->{"i:92", "5.6 Exercises"}],
  Cell[1156249, 27501, 954, 33, 72, "ExerciseOutput",
   CellTags->{"i:92", "5.6 Exercises"}],
  Cell[1157230, 27538, 697, 21, 217, "ExerciseItem",
   CellTags->{"i:93", "5.6 Exercises"}]},
 "i:85"->{
  Cell[1136200, 26857, 687, 22, 100, "ExerciseItem",
   CellTags->{"i:85", "5.6 Exercises"}],
  Cell[2307193, 55137, 423, 14, 123, "ExerciseItem",
   CellTags->{"8.3 Exercises", "i:85"}]},
 "i:87"->{
  Cell[1137386, 26899, 525, 19, 72, "ExerciseItem",
   CellTags->{"i:87", "5.6 Exercises", "Ex.Repunit"}]},
 "Ex.Repunit"->{
  Cell[1137386, 26899, 525, 19, 72, "ExerciseItem",
   CellTags->{"i:87", "5.6 Exercises", "Ex.Repunit"}]},
 "i:86"->{
  Cell[1137936, 26922, 196, 4, 72, "ExerciseItem",
   CellTags->{"i:86", "5.6 Exercises"}],
  Cell[2307619, 55153, 763, 27, 117, "ExerciseItem",
   CellTags->{"8.3 Exercises", "i:86"}]},
 "i:156"->{
  Cell[1138442, 26940, 1224, 45, 136, "ExerciseItem",
   CellTags->{"5.6 Exercises", "i:156"}]},
 "i:89"->{
  Cell[1139691, 26989, 323, 10, 72, "ExerciseItem",
   CellTags->{"i:89", "5.6 Exercises"}]},
 "i:90"->{
  Cell[1141084, 27029, 1035, 31, 84, "ExerciseItem",
   CellTags->{"i:90", "5.6 Exercises"}],
  Cell[3237619, 73793, 412, 9, 171, "ExerciseItem",
   CellTags->{"9.5 Exercises", "i:90"}]},
 "i:91"->{
  Cell[1145124, 27185, 614, 18, 171, "ExerciseItem",
   CellTags->{"i:91", "5.6 Exercises"}],
  Cell[3239986, 73875, 886, 26, 217, "ExerciseItem",
   CellTags->{"9.5 Exercises", "Ex.Anagrams", "i:91"}]},
 "i:92"->{
  Cell[1155942, 27490, 304, 9, 87, "ExerciseInput",
   CellTags->{"i:92", "5.6 Exercises"}],
  Cell[1156249, 27501, 954, 33, 72, "ExerciseOutput",
   CellTags->{"i:92", "5.6 Exercises"}],
  Cell[3241106, 73911, 401, 10, 117, "ExerciseItem",
   CellTags->{"i:92", "9.5 Exercises"}]},
 "i:93"->{
  Cell[1157230, 27538, 697, 21, 217, "ExerciseItem",
   CellTags->{"i:93", "5.6 Exercises"}]},
 "5.6 Solutions"->{
  Cell[1158016, 27567, 111, 2, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1158130, 27571, 186, 5, 90, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1158341, 27580, 176, 5, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1158520, 27587, 58, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1158593, 27591, 88, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1158706, 27596, 286, 9, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1158995, 27607, 58, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1159068, 27611, 62, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1159155, 27616, 239, 8, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1159397, 27626, 58, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1159504, 27633, 389, 13, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1159918, 27650, 191, 6, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1160112, 27658, 475, 14, 121, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1160624, 27677, 220, 7, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1160847, 27686, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1160958, 27692, 233, 7, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1161194, 27701, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1161283, 27705, 153, 4, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1161461, 27713, 166, 5, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1161630, 27720, 1560, 48, 328, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1163205, 27771, 244, 8, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1163474, 27783, 227, 7, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1163704, 27792, 261, 6, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1164002, 27803, 84, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1164089, 27807, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1164178, 27811, 269, 8, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1164472, 27823, 247, 8, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1164722, 27833, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1164811, 27837, 349, 11, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1165163, 27850, 424, 13, 73, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1165612, 27867, 91, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1165706, 27871, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1165795, 27875, 289, 8, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1166109, 27887, 282, 8, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1166394, 27897, 74, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1166505, 27903, 581, 19, 136, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1167089, 27924, 137, 4, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1167263, 27933, 317, 9, 136, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1167583, 27944, 138, 4, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1167770, 27954, 181, 7, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1167954, 27963, 378, 12, 87, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1168335, 27977, 90, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1168450, 27982, 210, 6, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1168663, 27990, 59, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1168737, 27994, 94, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1168856, 27999, 171, 5, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1169030, 28006, 123, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1169190, 28014, 171, 5, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1169364, 28021, 122, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1169535, 28030, 101, 1, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1169639, 28033, 305, 10, 87, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1169969, 28047, 88, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1170060, 28051, 62, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1170159, 28057, 196, 6, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1170358, 28065, 278, 6, 121, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1170685, 28077, 113, 2, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1170801, 28081, 271, 8, 69, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1171075, 28091, 159, 4, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1171259, 28099, 1241, 36, 447, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1172503, 28137, 7791, 135, 760, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1180309, 28275, 152, 4, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1180464, 28281, 352, 12, 69, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1180819, 28295, 220, 6, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1181064, 28305, 181, 5, 153, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1181248, 28312, 61, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1181346, 28318, 960, 27, 292, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1182309, 28347, 5370, 95, 769, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1187728, 28448, 185, 4, 117, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1187938, 28456, 706, 22, 189, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1188647, 28480, 772, 27, 121, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1189434, 28510, 293, 8, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1189752, 28522, 581, 19, 136, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1190336, 28543, 713, 25, 121, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1191098, 28574, 170, 6, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1191271, 28582, 138, 4, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1191412, 28588, 160, 6, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1191597, 28598, 241, 6, 139, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1191841, 28606, 604, 10, 172, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1192460, 28619, 493, 18, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1192978, 28641, 285, 9, 87, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1193266, 28652, 965, 15, 222, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1194280, 28673, 312, 11, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1194595, 28686, 299, 10, 73, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1194919, 28700, 192, 6, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1195114, 28708, 358, 13, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1195509, 28726, 87, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1195599, 28730, 275, 9, 76, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1195923, 28745, 98, 1, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1196046, 28750, 333, 10, 136, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1196382, 28762, 7581, 171, 910, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1203978, 28936, 92, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1204095, 28941, 90, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1204188, 28945, 835, 18, 121, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1205060, 28968, 92, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1205155, 28972, 189, 5, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1205359, 28980, 239, 8, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1205623, 28992, 500, 15, 189, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1206126, 29009, 111, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1206252, 29015, 249, 8, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1206504, 29025, 819, 24, 294, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1207326, 29051, 153, 4, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1207482, 29057, 372, 11, 139, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1207879, 29072, 100, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1207982, 29076, 1300, 45, 172, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1209297, 29124, 98, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1209420, 29129, 576, 14, 136, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1209999, 29145, 7055, 140, 522, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1217091, 29290, 101, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1217195, 29294, 485, 17, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1217729, 29317, 278, 9, 67, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1218032, 29330, 374, 13, 87, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1218409, 29345, 920, 32, 72, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1219344, 29380, 323, 9, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1219670, 29391, 431, 13, 139, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1220126, 29408, 189, 6, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1220318, 29416, 630, 22, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1220997, 29444, 224, 6, 117, "SolutionItem",
   CellTags->"5.6 Solutions"],
  Cell[1221246, 29454, 122, 3, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1221371, 29459, 258, 9, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1221644, 29471, 89, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1221758, 29476, 114, 3, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1221875, 29481, 111, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1222001, 29487, 137, 5, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1222163, 29496, 107, 3, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1222273, 29501, 60, 1, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1222348, 29505, 164, 4, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1222537, 29513, 340, 11, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1222880, 29526, 1128, 17, 328, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1224023, 29546, 330, 11, 127, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1224378, 29561, 613, 19, 220, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1224994, 29582, 121, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1225130, 29588, 1679, 51, 117, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1226812, 29641, 1370, 39, 460, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1228185, 29682, 228, 7, 73, "InputOnly",
   CellTags->"5.6 Solutions"],
  Cell[1228438, 29693, 99, 2, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1228540, 29697, 307, 7, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1228884, 29709, 126, 3, 82, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1229013, 29714, 129, 3, 67, "Output",
   CellTags->"5.6 Solutions"],
  Cell[1229157, 29720, 96, 1, 67, "SolutionText",
   CellTags->"5.6 Solutions"],
  Cell[1229278, 29725, 149, 4, 103, "Input",
   CellTags->"5.6 Solutions"],
  Cell[1229430, 29731, 211, 6, 172, "Output",
   CellTags->"5.6 Solutions"]},
 "Ex.SwitchRows"->{
  Cell[1229789, 29749, 485, 13, 171, "ExerciseItem",
   CellTags->{"Ex.SwitchRows", "5.7 Exercises"}]},
 "5.7 Exercises"->{
  Cell[1229789, 29749, 485, 13, 171, "ExerciseItem",
   CellTags->{"Ex.SwitchRows", "5.7 Exercises"}],
  Cell[1230299, 29766, 359, 10, 136, "ExerciseInput",
   CellTags->"5.7 Exercises"],
  Cell[1230661, 29778, 709, 20, 261, "ExerciseOutput",
   CellTags->"5.7 Exercises"],
  Cell[1231407, 29803, 187, 5, 82, "ExerciseInput",
   CellTags->"5.7 Exercises"],
  Cell[1231597, 29810, 488, 10, 175, "Message",
   CellTags->"5.7 Exercises"],
  Cell[1232088, 29822, 422, 12, 67, "ExerciseOutput",
   CellTags->"5.7 Exercises"],
  Cell[1232525, 29837, 136, 5, 73, "ExerciseText",
   CellTags->"5.7 Exercises"],
  Cell[1232686, 29846, 187, 5, 82, "ExerciseInput",
   CellTags->"5.7 Exercises"],
  Cell[1232876, 29853, 488, 10, 175, "Message",
   CellTags->"5.7 Exercises"],
  Cell[1233367, 29865, 422, 12, 67, "ExerciseOutput",
   CellTags->"5.7 Exercises"],
  Cell[1233816, 29881, 250, 6, 123, "ExerciseItem",
   CellTags->"5.7 Exercises"]},
 "5.7 Solutions"->{
  Cell[1234155, 29895, 262, 6, 117, "SolutionItem",
   CellTags->"5.7 Solutions"],
  Cell[1234420, 29903, 281, 7, 226, "InputOnly",
   CellTags->"5.7 Solutions"],
  Cell[1234704, 29912, 251, 7, 117, "SolutionText",
   CellTags->"5.7 Solutions"],
  Cell[1234958, 29921, 1318, 39, 333, "InputOnly",
   CellTags->"5.7 Solutions"],
  Cell[1236301, 29964, 284, 8, 136, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1236588, 29974, 687, 20, 261, "Output",
   CellTags->"5.7 Solutions"],
  Cell[1237312, 29999, 165, 5, 82, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1237480, 30006, 439, 9, 175, "Message",
   CellTags->"5.7 Solutions"],
  Cell[1237922, 30017, 397, 11, 67, "Output",
   CellTags->"5.7 Solutions"],
  Cell[1238356, 30033, 165, 5, 82, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1238524, 30040, 439, 9, 175, "Message",
   CellTags->"5.7 Solutions"],
  Cell[1238966, 30051, 397, 11, 67, "Output",
   CellTags->"5.7 Solutions"],
  Cell[1239412, 30068, 139, 4, 67, "SolutionItem",
   CellTags->"5.7 Solutions"],
  Cell[1239576, 30076, 226, 7, 87, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1239805, 30085, 60, 1, 67, "Output",
   CellTags->"5.7 Solutions"],
  Cell[1239880, 30089, 72, 1, 67, "SolutionText",
   CellTags->"5.7 Solutions"],
  Cell[1239955, 30092, 207, 6, 123, "InputOnly",
   CellTags->"5.7 Solutions"],
  Cell[1240165, 30100, 183, 5, 69, "InputOnly",
   CellTags->"5.7 Solutions"],
  Cell[1240351, 30107, 704, 21, 283, "InputOnly",
   CellTags->"5.7 Solutions"],
  Cell[1241080, 30132, 89, 2, 82, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1241172, 30136, 225, 6, 72, "Message",
   CellTags->"5.7 Solutions"],
  Cell[1241434, 30147, 146, 4, 82, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1241583, 30153, 225, 6, 72, "Message",
   CellTags->"5.7 Solutions"],
  Cell[1241845, 30164, 169, 5, 82, "Input",
   CellTags->"5.7 Solutions"],
  Cell[1242017, 30171, 711, 17, 357, "Output",
   CellTags->"5.7 Solutions"]},
 "i:133"->{
  Cell[1242859, 30198, 361, 9, 85, "ExerciseItem",
   CellTags->{"i:133", "5.8 Exercises"}]},
 "5.8 Exercises"->{
  Cell[1242859, 30198, 361, 9, 85, "ExerciseItem",
   CellTags->{"i:133", "5.8 Exercises"}],
  Cell[1243223, 30209, 317, 9, 81, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1243543, 30220, 592, 20, 81, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1244138, 30242, 676, 22, 114, "ExerciseItem",
   CellTags->{"5.8 Exercises", "i:154"}],
  Cell[1244839, 30268, 436, 7, 148, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1245300, 30279, 131, 3, 45, "ExerciseSubItem",
   CellTags->"5.8 Exercises"],
  Cell[1245434, 30284, 398, 13, 87, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1245857, 30301, 210, 6, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1246070, 30309, 266, 9, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1246373, 30323, 224, 6, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1246600, 30331, 280, 9, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1246929, 30346, 148, 4, 36, "ExerciseSubItem",
   CellTags->"5.8 Exercises"],
  Cell[1247080, 30352, 722, 23, 190, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1247827, 30379, 238, 7, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1248068, 30388, 352, 11, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1248435, 30402, 126, 3, 73, "ExerciseText",
   CellTags->"5.8 Exercises"],
  Cell[1248564, 30407, 554, 17, 190, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1249145, 30428, 913, 31, 118, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1250061, 30461, 398, 10, 81, "ExerciseItem",
   CellTags->{"i:135", "5.8 Exercises"}],
  Cell[1250462, 30473, 299, 8, 81, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1250786, 30485, 400, 10, 81, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1251211, 30499, 178, 4, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1251392, 30505, 237, 5, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1251678, 30516, 746, 26, 81, "ExerciseItem",
   CellTags->{"Ex.TruthTable", "i:136", "5.8 Exercises"}],
  Cell[1252449, 30546, 190, 6, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1252642, 30554, 369, 12, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1253026, 30569, 370, 14, 73, "ExerciseText",
   CellTags->"5.8 Exercises"],
  Cell[1253433, 30588, 689, 27, 81, "ExerciseItem",
   CellTags->"5.8 Exercises"],
  Cell[1254147, 30619, 186, 5, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1254336, 30626, 597, 10, 121, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1254970, 30641, 156, 4, 82, "ExerciseInput",
   CellTags->"5.8 Exercises"],
  Cell[1255129, 30647, 187, 5, 67, "ExerciseOutput",
   CellTags->"5.8 Exercises"],
  Cell[1255331, 30655, 673, 27, 73, "ExerciseText",
   CellTags->"5.8 Exercises"],
  Cell[1256029, 30686, 170, 4, 82, "Input",
   CellTags->"5.8 Exercises"],
  Cell[1256202, 30692, 277, 6, 67, "Output",
   CellTags->"5.8 Exercises"],
  Cell[1256494, 30701, 446, 13, 123, "ExerciseText",
   CellTags->{"i:137", "5.8 Exercises"}],
  Cell[1256943, 30716, 883, 34, 123, "ExerciseText",
   CellTags->"5.8 Exercises"],
  Cell[1257841, 30753, 1066, 36, 153, "ExerciseItem",
   CellTags->"5.8 Exercises"]},
 "i:154"->{
  Cell[1244138, 30242, 676, 22, 114, "ExerciseItem",
   CellTags->{"5.8 Exercises", "i:154"}]},
 "i:135"->{
  Cell[1250061, 30461, 398, 10, 81, "ExerciseItem",
   CellTags->{"i:135", "5.8 Exercises"}]},
 "Ex.TruthTable"->{
  Cell[1251678, 30516, 746, 26, 81, "ExerciseItem",
   CellTags->{"Ex.TruthTable", "i:136", "5.8 Exercises"}]},
 "i:136"->{
  Cell[1251678, 30516, 746, 26, 81, "ExerciseItem",
   CellTags->{"Ex.TruthTable", "i:136", "5.8 Exercises"}]},
 "i:137"->{
  Cell[1256494, 30701, 446, 13, 123, "ExerciseText",
   CellTags->{"i:137", "5.8 Exercises"}]},
 "5.8 Solutions"->{
  Cell[1258996, 30797, 78, 1, 49, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1259077, 30800, 331, 11, 136, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1259411, 30813, 69, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1259505, 30818, 165, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1259673, 30825, 376, 13, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1260064, 30841, 270, 7, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1260359, 30852, 223, 7, 87, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1260585, 30861, 56, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1260656, 30865, 110, 2, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1260769, 30869, 461, 14, 127, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1261255, 30887, 122, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1261380, 30892, 56, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1261451, 30896, 565, 16, 168, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1262019, 30914, 254, 7, 73, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1262276, 30923, 224, 7, 90, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1262503, 30932, 224, 7, 90, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1262752, 30943, 162, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1262917, 30949, 126, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1263080, 30957, 162, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1263245, 30963, 123, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1263417, 30972, 295, 9, 117, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1263715, 30983, 277, 8, 73, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1263995, 30993, 358, 9, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1264356, 31004, 223, 7, 90, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1264582, 31013, 223, 7, 90, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1264808, 31022, 373, 11, 126, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1265206, 31037, 460, 14, 189, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1265669, 31053, 617, 18, 222, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1266335, 31077, 479, 13, 117, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1266817, 31092, 423, 13, 126, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1267265, 31109, 113, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1267381, 31114, 1227, 35, 222, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1268657, 31155, 161, 4, 67, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1268821, 31161, 409, 13, 139, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1269233, 31176, 138, 3, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1269374, 31181, 641, 20, 243, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1270018, 31203, 310, 9, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1270331, 31214, 174, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1270508, 31221, 174, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1270707, 31230, 120, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1270830, 31235, 124, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1270991, 31243, 120, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1271114, 31248, 123, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1271274, 31256, 120, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1271397, 31261, 123, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1271557, 31269, 120, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1271680, 31274, 124, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1271819, 31280, 270, 5, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1272092, 31287, 91, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1272186, 31291, 456, 15, 139, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1272645, 31308, 661, 21, 190, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1273343, 31334, 52, 1, 67, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1273420, 31339, 312, 12, 67, "SolutionSubItem",
   CellTags->"5.8 Solutions"],
  Cell[1273735, 31353, 571, 17, 193, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1274331, 31374, 208, 6, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1274542, 31382, 258, 9, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1274849, 31397, 144, 3, 67, "SolutionSubItem",
   CounterAssignments->{{"SolutionSubItem", 1}},
   CellTags->"5.8 Solutions"],
  Cell[1274996, 31402, 997, 30, 247, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1276018, 31436, 213, 6, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1276234, 31444, 328, 10, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1276577, 31457, 737, 22, 193, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1277339, 31483, 213, 6, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1277555, 31491, 328, 10, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1277932, 31507, 97, 2, 67, "SolutionSubItem",
   CellTags->"5.8 Solutions"],
  Cell[1278032, 31511, 1187, 35, 405, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1279244, 31550, 144, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1279391, 31556, 131, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1279537, 31562, 612, 18, 243, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1280174, 31584, 144, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1280321, 31590, 132, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1280514, 31600, 106, 1, 67, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1280623, 31603, 239, 7, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1280865, 31612, 88, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1280978, 31617, 259, 8, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1281240, 31627, 121, 3, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1281376, 31633, 135, 3, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1281536, 31640, 152, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1281691, 31646, 60, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1281766, 31650, 506, 15, 126, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1282297, 31669, 96, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1282396, 31673, 60, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1282471, 31677, 537, 15, 177, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1283033, 31696, 97, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1283133, 31700, 60, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1283208, 31704, 86, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1283319, 31709, 313, 9, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1283635, 31720, 332, 11, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1284004, 31736, 181, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1284188, 31743, 60, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1284263, 31747, 756, 21, 177, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1285044, 31772, 97, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1285144, 31776, 60, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1285253, 31783, 338, 11, 117, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1285594, 31796, 314, 10, 73, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1285911, 31808, 533, 17, 139, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1286447, 31827, 512, 19, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1286962, 31848, 1158, 35, 369, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1288123, 31885, 196, 4, 117, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1288344, 31893, 139, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1288486, 31898, 14568, 245, 402, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1303091, 32148, 139, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1303233, 32153, 134637, 2215, 402, 104360, 1717, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"5.8 Solutions"],
  Cell[1437907, 34373, 169, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1438079, 34379, 154704, 2538, 495, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1592832, 36923, 163, 5, 67, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1593020, 36932, 1213, 32, 343, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1594236, 36966, 781, 25, 310, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1595032, 36994, 426, 17, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1595483, 37015, 418, 13, 141, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1595904, 37030, 799, 25, 310, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1596718, 37058, 105, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1596848, 37063, 211, 6, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1597062, 37071, 117, 2, 73, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1597194, 37076, 353, 9, 168, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1597550, 37087, 474, 14, 127, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1598027, 37103, 461, 13, 126, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1598513, 37120, 249, 7, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1598765, 37129, 1185, 32, 310, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1599999, 37167, 138, 2, 67, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 8}},
   CellTags->"5.8 Solutions"],
  Cell[1600140, 37171, 109, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1600252, 37176, 183, 6, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1600438, 37184, 157, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1600598, 37191, 124, 3, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1600747, 37198, 235, 7, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1600985, 37207, 717, 19, 172, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1601717, 37229, 167, 4, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1601909, 37237, 236, 8, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1602148, 37247, 1485, 43, 222, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1603648, 37293, 106, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1603779, 37298, 85, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1603867, 37302, 195, 5, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1604077, 37310, 168, 4, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1604270, 37318, 274, 8, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1604547, 37328, 827, 20, 222, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1605389, 37351, 118, 5, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1605532, 37360, 187, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1605722, 37367, 276, 10, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1606013, 37380, 139, 7, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1606177, 37391, 118, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1606298, 37396, 1075, 29, 276, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1607388, 37428, 69, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1607482, 37433, 150, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1607635, 37439, 698, 22, 481, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1608348, 37464, 220, 11, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1608593, 37479, 324, 10, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1608920, 37491, 843, 22, 460, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1609778, 37516, 216, 8, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1610019, 37528, 1069, 32, 240, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1611091, 37562, 1093, 28, 540, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1612199, 37593, 76, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1612278, 37596, 2806, 78, 604, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1615109, 37678, 261, 8, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1615373, 37688, 1332, 37, 528, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1616754, 37731, 684, 25, 117, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1617441, 37758, 524, 16, 126, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1617968, 37776, 558, 17, 177, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1618529, 37795, 186, 5, 69, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1618740, 37804, 132, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1618875, 37809, 165, 5, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1619077, 37819, 156, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1619236, 37825, 277, 6, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1619528, 37834, 703, 20, 220, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1620234, 37856, 879, 25, 229, "InputOnly",
   CellTags->"5.8 Solutions"],
  Cell[1621138, 37885, 133, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1621274, 37890, 251, 5, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1621574, 37901, 254, 5, 117, "SolutionItem",
   CellTags->"5.8 Solutions"],
  Cell[1621831, 37908, 183, 5, 87, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1622017, 37915, 151, 4, 87, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1622171, 37921, 287, 9, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1622483, 37934, 121, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1622607, 37939, 259, 9, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1622903, 37953, 92, 2, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1622998, 37957, 220, 7, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1623233, 37967, 128, 3, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1623386, 37974, 200, 7, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1623589, 37983, 208, 7, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1623812, 37993, 68, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1623905, 37998, 120, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1624028, 38003, 57, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1624100, 38007, 126, 3, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1624251, 38014, 128, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1624382, 38019, 57, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1624454, 38023, 103, 1, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1624560, 38026, 705, 21, 190, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1625268, 38049, 130, 4, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1625423, 38057, 158, 5, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1625584, 38064, 149, 4, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1625748, 38071, 160, 6, 67, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1625933, 38081, 216, 7, 103, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1626152, 38090, 58, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1626225, 38094, 3230, 60, 168, "SolutionText",
   CellTags->"5.8 Solutions"],
  Cell[1629458, 38156, 305, 10, 87, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1629788, 38170, 122, 3, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1629913, 38175, 59, 1, 67, "Output",
   CellTags->"5.8 Solutions"],
  Cell[1630009, 38181, 150, 4, 82, "Input",
   CellTags->"5.8 Solutions"],
  Cell[1630162, 38187, 59, 1, 67, "Output",
   CellTags->"5.8 Solutions"]},
 "6.1 Exercises"->{
  Cell[1631250, 38225, 593, 22, 85, "ExerciseItem",
   CellTags->"6.1 Exercises"],
  Cell[1631846, 38249, 1054, 35, 114, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Do and Table", "i:14"}],
  Cell[1632903, 38286, 929, 29, 148, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Fibonacci", "i:15"}],
  Cell[1633835, 38317, 497, 12, 114, "ExerciseItem",
   CellTags->"6.1 Exercises"],
  Cell[1634335, 38331, 871, 24, 153, "ExerciseItem",
   CellTags->"6.1 Exercises"],
  Cell[1635231, 38359, 1184, 41, 114, "ExerciseItem",
   CellTags->{"Ex.findRoot", "6.1 Exercises", "i:48"}],
  Cell[1636418, 38402, 177, 5, 96, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1636620, 38411, 482, 13, 189, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1637105, 38426, 862, 25, 222, "ExerciseOutput",
   CellTags->"6.1 Exercises"],
  Cell[1637982, 38454, 463, 15, 123, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1638460, 38472, 367, 8, 114, "ExerciseItem",
   CellTags->"6.1 Exercises"],
  Cell[1638852, 38484, 1989, 77, 180, "ExerciseItem",
   CellTags->{"6.1 Exercises", "i:16"}],
  Cell[1640844, 38563, 1359, 51, 123, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1642218, 38617, 1372, 53, 114, "ExerciseItem",
   CellTags->{"Ex.GCD", "6.1 Exercises", "i:18"}],
  Cell[1643615, 38674, 444, 14, 81, "ExerciseItem",
   CellTags->"6.1 Exercises"],
  Cell[1644062, 38690, 996, 34, 117, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1645061, 38726, 1265, 36, 397, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1646329, 38764, 371, 12, 82, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1646725, 38780, 116, 2, 82, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1646844, 38784, 667, 19, 207, "ExerciseOutput",
   CellTags->"6.1 Exercises"],
  Cell[1647548, 38808, 156, 4, 82, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1647707, 38814, 667, 19, 207, "ExerciseOutput",
   CellTags->"6.1 Exercises"],
  Cell[1648389, 38836, 306, 11, 73, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1648698, 38849, 1154, 34, 294, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1649877, 38887, 156, 4, 82, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1650036, 38893, 667, 19, 207, "ExerciseOutput",
   CellTags->"6.1 Exercises"],
  Cell[1650718, 38915, 351, 13, 67, "ExerciseSubItem",
   CellTags->"6.1 Exercises"],
  Cell[1651072, 38930, 551, 21, 54, "ExerciseSubItem",
   CellTags->"6.1 Exercises"],
  Cell[1651648, 38955, 214, 6, 54, "ExerciseSubItem",
   CellTags->"6.1 Exercises"],
  Cell[1651865, 38963, 495, 15, 139, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1652363, 38980, 321, 13, 73, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1652721, 38998, 208, 6, 67, "ExerciseSubItem",
   CellTags->"6.1 Exercises"],
  Cell[1652932, 39006, 739, 23, 139, "ExerciseInput",
   CellTags->"6.1 Exercises"],
  Cell[1653674, 39031, 461, 18, 73, "ExerciseText",
   CellTags->"6.1 Exercises"],
  Cell[1654172, 39054, 2063, 83, 162, "ExerciseSubItem",
   CellTags->"6.1 Exercises"],
  Cell[1656238, 39139, 371, 11, 82, "ExerciseInput",
   Evaluatable->False,
   CellTags->"6.1 Exercises"]},
 "Ex.Do and Table"->{
  Cell[1631846, 38249, 1054, 35, 114, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Do and Table", "i:14"}]},
 "i:14"->{
  Cell[1631846, 38249, 1054, 35, 114, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Do and Table", "i:14"}]},
 "Ex.Fibonacci"->{
  Cell[1632903, 38286, 929, 29, 148, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Fibonacci", "i:15"}]},
 "i:15"->{
  Cell[1632903, 38286, 929, 29, 148, "ExerciseItem",
   CellTags->{"6.1 Exercises", "Ex.Fibonacci", "i:15"}]},
 "Ex.findRoot"->{
  Cell[1635231, 38359, 1184, 41, 114, "ExerciseItem",
   CellTags->{"Ex.findRoot", "6.1 Exercises", "i:48"}]},
 "i:16"->{
  Cell[1638852, 38484, 1989, 77, 180, "ExerciseItem",
   CellTags->{"6.1 Exercises", "i:16"}],
  Cell[1935241, 46984, 827, 24, 211, "ExerciseItem",
   CellTags->{"7.3 Exercises", "Ex.Collatz", "i:16"}]},
 "Ex.GCD"->{
  Cell[1642218, 38617, 1372, 53, 114, "ExerciseItem",
   CellTags->{"Ex.GCD", "6.1 Exercises", "i:18"}]},
 "i:18"->{
  Cell[1642218, 38617, 1372, 53, 114, "ExerciseItem",
   CellTags->{"Ex.GCD", "6.1 Exercises", "i:18"}],
  Cell[10576602, 227335, 340, 6, 118, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:18"}]},
 "6.1 Solutions"->{
  Cell[1656722, 39160, 196, 6, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1656943, 39170, 372, 12, 217, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1657318, 39184, 147, 5, 127, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1657480, 39192, 313, 9, 117, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1657796, 39203, 341, 12, 139, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1658162, 39219, 167, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1658332, 39226, 136, 2, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1658517, 39234, 358, 13, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1658878, 39249, 159, 5, 82, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1659062, 39258, 429, 14, 204, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1659494, 39274, 362, 8, 121, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1659871, 39285, 868, 25, 319, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1660764, 39314, 161, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1660928, 39321, 124, 3, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1661067, 39327, 93, 1, 67, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1661185, 39332, 171, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1661359, 39339, 125, 3, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1661533, 39348, 297, 8, 117, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1661833, 39358, 711, 20, 333, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1662569, 39382, 200, 6, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1662772, 39390, 192, 5, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1662979, 39398, 134, 3, 67, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1663116, 39403, 677, 21, 229, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1663818, 39428, 201, 6, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1664022, 39436, 192, 5, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1664229, 39444, 165, 4, 67, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1664419, 39452, 285, 9, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1664707, 39463, 243, 7, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1664999, 39476, 327, 10, 67, "SolutionItem",
   CellTags->{"6.1 Solutions", "Sol.findRoot"}],
  Cell[1665329, 39488, 93, 2, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1665425, 39492, 1104, 33, 549, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1666532, 39527, 154, 5, 87, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1666689, 39534, 177, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1666903, 39544, 211, 7, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1667117, 39553, 1131, 34, 459, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1668251, 39589, 160, 5, 82, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1668436, 39598, 177, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1668616, 39605, 124, 3, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1668789, 39614, 194, 6, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1668986, 39622, 1398, 40, 685, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1670387, 39664, 155, 5, 96, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1670545, 39671, 172, 5, 103, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1670720, 39678, 523, 13, 220, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1671280, 39696, 176, 5, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1671459, 39703, 1382, 40, 406, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1672866, 39747, 313, 11, 103, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1673182, 39760, 157, 5, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1673388, 39771, 153, 4, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1673544, 39777, 1373, 40, 532, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1674942, 39821, 315, 10, 148, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1675260, 39833, 122, 3, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1675431, 39842, 114, 2, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1675548, 39846, 753, 22, 333, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1676326, 39872, 298, 9, 136, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1676627, 39883, 57, 1, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1676699, 39887, 371, 12, 117, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1677073, 39901, 720, 22, 229, "InputOnly",
   CellTags->"6.1 Solutions"],
  Cell[1677818, 39927, 298, 9, 136, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1678119, 39938, 57, 1, 67, "Output",
   CellTags->"6.1 Solutions"],
  Cell[1678225, 39945, 128, 3, 67, "SolutionItem",
   CellTags->"6.1 Solutions"],
  Cell[1678378, 39952, 648, 24, 117, "SolutionSubItem",
   CellTags->"6.1 Solutions"],
  Cell[1679029, 39978, 158, 4, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1679190, 39984, 926, 26, 294, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1680119, 40012, 168, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1680290, 40019, 852, 26, 243, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1681145, 40047, 173, 5, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1681355, 40057, 1143, 39, 270, "SolutionSubItem",
   CellTags->"6.1 Solutions"],
  Cell[1682501, 40098, 1053, 31, 243, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1683557, 40131, 197, 6, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1683757, 40139, 1074, 31, 294, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1684834, 40172, 202, 6, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1685073, 40183, 255, 10, 67, "SolutionSubItem",
   CellTags->"6.1 Solutions"],
  Cell[1685331, 40195, 985, 28, 294, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1686319, 40225, 331, 10, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1686687, 40240, 101, 1, 67, "SolutionSubItem",
   CellTags->"6.1 Solutions"],
  Cell[1686791, 40243, 1109, 32, 294, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1687903, 40277, 424, 13, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1688364, 40295, 919, 33, 168, "SolutionSubItem",
   CounterAssignments->{{"SolutionItem", 1}},
   CellTags->"6.1 Solutions"],
  Cell[1689286, 40330, 1307, 38, 397, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1690596, 40370, 288, 8, 82, "Input",
   CellTags->"6.1 Solutions"],
  Cell[1690887, 40380, 246, 8, 67, "SolutionText",
   CellTags->"6.1 Solutions"],
  Cell[1691136, 40390, 288, 8, 82, "Input",
   CellTags->"6.1 Solutions"]},
 "Sol.findRoot"->{
  Cell[1664999, 39476, 327, 10, 67, "SolutionItem",
   CellTags->{"6.1 Solutions", "Sol.findRoot"}]},
 "6.2 Exercises"->{
  Cell[1691564, 40410, 849, 27, 118, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:32"}],
  Cell[1692438, 40441, 209, 6, 82, "ExerciseInput",
   CellTags->"6.2 Exercises"],
  Cell[1692650, 40449, 667, 19, 207, "ExerciseOutput",
   CellTags->"6.2 Exercises"],
  Cell[1693354, 40473, 241, 7, 82, "ExerciseInput",
   CellTags->"6.2 Exercises"],
  Cell[1693598, 40482, 769, 20, 261, "ExerciseOutput",
   CellTags->"6.2 Exercises"],
  Cell[1694394, 40506, 1100, 43, 114, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:31"}],
  Cell[1695519, 40553, 189, 4, 45, "ExerciseItem",
   CellTags->{"6.2 Exercises", "Ex.Absolute value"}],
  Cell[1695733, 40561, 148, 4, 82, "ExerciseInput",
   CellTags->"6.2 Exercises"],
  Cell[1695884, 40567, 464, 9, 72, "Message",
   CellTags->"6.2 Exercises"],
  Cell[1696351, 40578, 448, 9, 72, "Message",
   CellTags->"6.2 Exercises"],
  Cell[1696802, 40589, 164, 4, 67, "ExerciseOutput",
   CellTags->"6.2 Exercises"],
  Cell[1696981, 40596, 227, 6, 73, "ExerciseText",
   CellTags->"6.2 Exercises"],
  Cell[1697245, 40607, 428, 18, 45, "ExerciseItem",
   CellTags->"6.2 Exercises"],
  Cell[1697676, 40627, 157, 4, 45, "ExerciseSubItem",
   CellTags->"6.2 Exercises"],
  Cell[1697836, 40633, 666, 20, 150, "ExerciseSubItem",
   CellTags->"6.2 Exercises"],
  Cell[1698527, 40657, 181, 6, 55, "ExerciseSubItem",
   CellTags->"6.2 Exercises"],
  Cell[1698733, 40667, 244, 7, 82, "ExerciseInput",
   CellTags->"6.2 Exercises"],
  Cell[1698980, 40676, 78, 1, 67, "ExerciseOutput",
   CellTags->"6.2 Exercises"],
  Cell[1699073, 40680, 318, 11, 73, "ExerciseText",
   CellTags->"6.2 Exercises"],
  Cell[1699418, 40695, 366, 14, 76, "ExerciseItem",
   CellTags->{"6.2 Exercises", "i:51"}],
  Cell[1699787, 40711, 1164, 42, 171, "ExerciseItem",
   CellTags->{"6.2 Exercises", "Ex.Collatz", "i:33"}]},
 "Ex.Absolute value"->{
  Cell[1695519, 40553, 189, 4, 45, "ExerciseItem",
   CellTags->{"6.2 Exercises", "Ex.Absolute value"}]},
 "Ex.Collatz"->{
  Cell[1699787, 40711, 1164, 42, 171, "ExerciseItem",
   CellTags->{"6.2 Exercises", "Ex.Collatz", "i:33"}],
  Cell[1935241, 46984, 827, 24, 211, "ExerciseItem",
   CellTags->{"7.3 Exercises", "Ex.Collatz", "i:16"}]},
 "6.2 Solutions"->{
  Cell[1701040, 40761, 460, 18, 76, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1701503, 40781, 453, 14, 139, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1701959, 40797, 164, 4, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1702126, 40803, 514, 17, 126, "InputOnly",
   CellTags->"6.2 Solutions"],
  Cell[1702665, 40824, 220, 7, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1702888, 40833, 809, 21, 310, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1703746, 40860, 89, 1, 67, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1703838, 40863, 436, 14, 244, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1704277, 40879, 192, 6, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1704472, 40887, 224, 8, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1704699, 40897, 321, 11, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1705023, 40910, 194, 6, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1705220, 40918, 230, 8, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1705453, 40928, 290, 9, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1705746, 40939, 197, 6, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1705946, 40947, 247, 8, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1706196, 40957, 404, 14, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1706637, 40976, 756, 25, 202, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1707396, 41003, 742, 24, 249, "InputOnly",
   CellTags->"6.2 Solutions"],
  Cell[1708163, 41031, 126, 4, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1708292, 41037, 56, 1, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1708385, 41043, 102, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1708490, 41048, 56, 1, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1708561, 41052, 257, 7, 118, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1708821, 41061, 584, 18, 195, "InputOnly",
   CellTags->"6.2 Solutions"],
  Cell[1709430, 41083, 126, 4, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1709559, 41089, 56, 1, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1709652, 41095, 102, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1709757, 41100, 56, 1, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1709862, 41107, 94, 2, 67, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1709981, 41113, 129, 3, 67, "SolutionSubItem",
   CellTags->"6.2 Solutions"],
  Cell[1710113, 41118, 322, 11, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1710472, 41134, 55, 1, 67, "SolutionSubItem",
   CellTags->"6.2 Solutions"],
  Cell[1710530, 41137, 743, 20, 190, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1711310, 41162, 55, 1, 67, "SolutionSubItem",
   CellTags->"6.2 Solutions"],
  Cell[1711368, 41165, 364, 12, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1711781, 41183, 345, 13, 67, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1712129, 41198, 965, 29, 294, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1713097, 41229, 323, 9, 136, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1713445, 41242, 121, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1713569, 41247, 124, 3, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1713730, 41255, 120, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1713853, 41260, 124, 3, 67, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1714014, 41268, 121, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1714138, 41273, 147, 4, 118, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1714322, 41282, 120, 3, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1714445, 41287, 147, 4, 117, "Output",
   CellTags->"6.2 Solutions"],
  Cell[1714641, 41297, 126, 3, 67, "SolutionItem",
   CellTags->"6.2 Solutions"],
  Cell[1714770, 41302, 192, 6, 136, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1714965, 41310, 213, 7, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1715181, 41319, 201, 8, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1715385, 41329, 319, 10, 87, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1715707, 41341, 247, 11, 67, "SolutionText",
   CellTags->"6.2 Solutions"],
  Cell[1715957, 41354, 261, 7, 73, "InputOnly",
   CellTags->"6.2 Solutions"],
  Cell[1716243, 41365, 97, 2, 82, "Input",
   CellTags->"6.2 Solutions"],
  Cell[1716343, 41369, 228, 6, 67, "Output",
   CellTags->"6.2 Solutions"]},
 "6.3 Exercises"->{
  Cell[1716702, 41385, 877, 33, 127, "ExerciseItem",
   CellTags->{"6.3 Exercises", "i:43"}],
  Cell[1717582, 41420, 985, 32, 222, "ExerciseItem",
   CellTags->{"i:46", "6.3 Exercises"}],
  Cell[1718570, 41454, 273, 10, 69, "ExerciseItem",
   CellTags->"6.3 Exercises"],
  Cell[1718846, 41466, 962, 35, 171, "ExerciseItem",
   CellTags->{"Ex.pointLoc alternatives", "6.3 Exercises"}],
  Cell[1719811, 41503, 1786, 72, 222, "ExerciseItem",
   CellTags->"6.3 Exercises"],
  Cell[1721600, 41577, 1085, 32, 271, "ExerciseItem",
   CellTags->{"i:47", "6.3 Exercises"}],
  Cell[1722710, 41613, 165, 4, 69, "ExerciseItem",
   CellTags->{"i:44", "6.3 Exercises"}]},
 "i:46"->{
  Cell[1717582, 41420, 985, 32, 222, "ExerciseItem",
   CellTags->{"i:46", "6.3 Exercises"}]},
 "Ex.pointLoc alternatives"->{
  Cell[1718846, 41466, 962, 35, 171, "ExerciseItem",
   CellTags->{"Ex.pointLoc alternatives", "6.3 Exercises"}]},
 "6.3 Solutions"->{
  Cell[1722878, 41619, 58081, 997, 537, "Figure",
   CellTags->"6.3 Solutions"],
  Cell[1781060, 42625, 263, 10, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1781326, 42637, 92, 2, 69, "InputOnly",
   CellTags->"6.3 Solutions"],
  Cell[1781421, 42641, 470, 15, 73, "InputOnly",
   CellTags->"6.3 Solutions"],
  Cell[1781916, 42660, 281, 9, 136, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1782200, 42671, 57, 1, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1782306, 42678, 105, 1, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1782436, 42683, 129, 3, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1782568, 42688, 57, 1, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1782640, 42692, 264, 8, 67, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1782907, 42702, 710, 21, 294, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1783642, 42727, 93, 2, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1783738, 42731, 56, 1, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1783809, 42735, 113, 2, 67, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1783925, 42739, 367, 11, 87, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1784317, 42754, 112, 3, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1784432, 42759, 56, 1, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1784537, 42766, 234, 8, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1784774, 42776, 1001, 34, 136, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1785778, 42812, 1145, 38, 190, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1786926, 42852, 829, 28, 136, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1787792, 42885, 221, 9, 73, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1788016, 42896, 1021, 35, 297, "InputOnly",
   CellTags->"6.3 Solutions"],
  Cell[1789062, 42935, 138, 4, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1789203, 42941, 56, 1, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1789296, 42947, 136, 4, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1789435, 42953, 73, 2, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1789557, 42961, 122, 3, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1789682, 42966, 2245, 75, 517, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1791930, 43043, 335, 11, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1792302, 43059, 91, 1, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1792418, 43064, 148, 4, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1792569, 43070, 657, 11, 172, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1793241, 43084, 232, 9, 67, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1793498, 43097, 323, 10, 136, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1793824, 43109, 474, 9, 121, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1794313, 43121, 192, 7, 67, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1794530, 43132, 323, 10, 136, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1794856, 43144, 426, 8, 121, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1795297, 43155, 169, 5, 67, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1795491, 43164, 666, 20, 343, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1796160, 43186, 1992, 29, 586, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1798167, 43218, 439, 10, 168, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1798609, 43230, 1106, 32, 397, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1799740, 43266, 96, 2, 82, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1799839, 43270, 1992, 29, 586, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1801846, 43302, 271, 7, 118, "SolutionText",
   CellTags->"6.3 Solutions"],
  Cell[1802142, 43313, 183, 5, 103, "Input",
   CellTags->"6.3 Solutions"],
  Cell[1802328, 43320, 123, 3, 67, "Output",
   CellTags->"6.3 Solutions"],
  Cell[1802500, 43329, 128, 3, 67, "SolutionItem",
   CellTags->"6.3 Solutions"],
  Cell[1802631, 43334, 1795, 46, 436, "InputOnly",
   CellTags->"6.3 Solutions"],
  Cell[1804451, 43384, 386, 11, 175, "InputOnly",
   CellTags->"6.3 Solutions"],
  Cell[1804840, 43397, 58081, 997, 532, "Figure",
   CellTags->"6.3 Solutions"]},
 "7.1 Exercises"->{
  Cell[1863939, 44432, 255, 7, 85, "ExerciseItem",
   CellTags->"7.1 Exercises"],
  Cell[1864197, 44441, 733, 26, 82, "ExerciseSubItem",
   CellTags->"7.1 Exercises"],
  Cell[1864933, 44469, 976, 36, 76, "ExerciseSubItem",
   CellTags->"7.1 Exercises"],
  Cell[1865912, 44507, 909, 33, 76, "ExerciseSubItem",
   CellTags->"7.1 Exercises"],
  Cell[1866858, 44545, 522, 17, 85, "ExerciseItem",
   CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2"}],
  Cell[1867383, 44564, 1049, 36, 123, "ExerciseDisplayFormula",
   CellTags->"7.1 Exercises"],
  Cell[1868435, 44602, 519, 21, 73, "ExerciseText",
   CellTags->"7.1 Exercises"],
  Cell[1868991, 44628, 1827, 49, 114, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}],
  Cell[1870821, 44679, 440, 15, 123, "ExerciseDisplayFormula",
   CellTags->"7.1 Exercises"],
  Cell[1871264, 44696, 4058, 116, 180, "ExerciseDisplayFormula",
   CellTags->"7.1 Exercises"],
  Cell[1875325, 44814, 241, 8, 73, "ExerciseText",
   CellTags->"7.1 Exercises"],
  Cell[1875603, 44827, 2354, 45, 81, "ExerciseItem",
   CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}],
  Cell[1877960, 44874, 373, 15, 73, "ExerciseDisplayFormula",
   CellTags->"7.1 Exercises"],
  Cell[1878336, 44891, 76, 1, 73, "ExerciseText",
   CellTags->"7.1 Exercises"],
  Cell[1878415, 44894, 1426, 56, 123, "ExerciseDisplayFormula",
   CellTags->"7.1 Exercises"],
  Cell[1879844, 44952, 136, 3, 73, "ExerciseText",
   CellTags->"7.1 Exercises"]},
 "Exercise Fibonacci"->{
  Cell[1866858, 44545, 522, 17, 85, "ExerciseItem",
   CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2"}],
  Cell[1868991, 44628, 1827, 49, 114, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}],
  Cell[1875603, 44827, 2354, 45, 81, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}]},
 "Exercise 7.1-2"->{
  Cell[1866858, 44545, 522, 17, 85, "ExerciseItem",
   CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2"}],
  Cell[1868991, 44628, 1827, 49, 114, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}],
  Cell[1875603, 44827, 2354, 45, 81, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}]},
 "i:17"->{
  Cell[1868991, 44628, 1827, 49, 114, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}]},
 "i:2"->{
  Cell[1875603, 44827, 2354, 45, 81, "ExerciseItem",
   CellTags->{
    "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}]},
 "7.1 Solutions"->{
  Cell[1880081, 44964, 126, 3, 67, "SolutionItem",
   CellTags->"7.1 Solutions"],
  Cell[1880232, 44971, 154, 4, 67, "SolutionSubItem",
   CellTags->"7.1 Solutions"],
  Cell[1880389, 44977, 368, 12, 177, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1880782, 44993, 197, 6, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1880982, 45001, 187, 5, 67, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1881218, 45012, 142, 4, 67, "SolutionSubItem",
   CellTags->"7.1 Solutions"],
  Cell[1881363, 45018, 368, 12, 177, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1881756, 45034, 197, 6, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1881956, 45042, 249, 7, 67, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1882254, 45055, 93, 1, 67, "SolutionSubItem",
   CellTags->"7.1 Solutions"],
  Cell[1882350, 45058, 494, 16, 229, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1882869, 45078, 197, 6, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1883069, 45086, 182, 5, 67, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1883312, 45098, 105, 1, 67, "SolutionItem",
   CellTags->"7.1 Solutions"],
  Cell[1883420, 45101, 383, 12, 177, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1883828, 45117, 141, 4, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1883972, 45123, 181, 5, 67, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1884168, 45131, 364, 11, 117, "SolutionText",
   CellTags->"7.1 Solutions"],
  Cell[1884557, 45146, 118, 3, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1884678, 45151, 181, 5, 67, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1884908, 45162, 332, 6, 168, "SolutionItem",
   CellTags->"7.1 Solutions"],
  Cell[1885243, 45170, 334, 10, 175, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1885580, 45182, 1817, 55, 346, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1887422, 45241, 232, 7, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1887657, 45250, 738, 14, 276, "Output",
   CellTags->"7.1 Solutions"],
  Cell[1888444, 45270, 280, 9, 67, "SolutionItem",
   CellTags->"7.1 Solutions"],
  Cell[1888727, 45281, 323, 11, 82, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1889053, 45294, 247, 8, 123, "InputOnly",
   CellTags->"7.1 Solutions"],
  Cell[1889325, 45306, 249, 8, 82, "Input",
   CellTags->"7.1 Solutions"],
  Cell[1889577, 45316, 249, 7, 67, "Output",
   CellTags->"7.1 Solutions"]},
 "7.2 Exercises"->{
  Cell[1889952, 45333, 127, 3, 76, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1890082, 45338, 196, 4, 117, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1890281, 45344, 544, 18, 117, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1890828, 45364, 991, 38, 117, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1891822, 45404, 542, 18, 121, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1892389, 45426, 529, 16, 117, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1892943, 45446, 207, 5, 82, "ExerciseInput",
   CellTags->"7.2 Exercises"],
  Cell[1893153, 45453, 163, 4, 67, "ExerciseOutput",
   CellTags->"7.2 Exercises"],
  Cell[1893343, 45461, 421, 13, 123, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1893789, 45478, 381, 12, 67, "ExerciseItem",
   CellTags->{"7.2 Exercises", "i:5"}],
  Cell[1894173, 45492, 295, 9, 87, "ExerciseInput",
   CellTags->"7.2 Exercises"],
  Cell[1894493, 45505, 252, 8, 82, "ExerciseInput",
   CellTags->"7.2 Exercises"],
  Cell[1894748, 45515, 166, 4, 67, "ExerciseOutput",
   CellTags->"7.2 Exercises"],
  Cell[1894929, 45522, 134, 5, 73, "ExerciseText",
   CellTags->"7.2 Exercises"],
  Cell[1895100, 45532, 170, 4, 76, "ExerciseItem",
   CellTags->"7.2 Exercises"],
  Cell[1895273, 45538, 395, 13, 139, "ExerciseInput",
   Evaluatable->False,
   CellTags->"7.2 Exercises"],
  Cell[1895671, 45553, 1666, 60, 175, "ExerciseText",
   CellTags->"7.2 Exercises"],
  Cell[1897352, 45616, 436, 18, 76, "ExerciseItem",
   CellTags->{"7.2 Exercises", "i:6"}]},
 "i:5"->{
  Cell[1893789, 45478, 381, 12, 67, "ExerciseItem",
   CellTags->{"7.2 Exercises", "i:5"}]},
 "i:6"->{
  Cell[1897352, 45616, 436, 18, 76, "ExerciseItem",
   CellTags->{"7.2 Exercises", "i:6"}]},
 "7.2 Solutions"->{
  Cell[1897877, 45642, 234, 6, 117, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1898114, 45650, 306, 10, 87, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1898423, 45662, 160, 5, 87, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1898608, 45671, 218, 6, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1898829, 45679, 178, 4, 117, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1899056, 45689, 184, 7, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1899243, 45698, 563, 19, 139, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1899809, 45719, 289, 10, 87, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1900123, 45733, 343, 12, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1900469, 45747, 299, 11, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1900805, 45763, 90, 2, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1900898, 45767, 299, 11, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1901246, 45784, 77, 1, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1901326, 45787, 614, 19, 180, "InputOnly",
   CellTags->"7.2 Solutions"],
  Cell[1901965, 45810, 213, 6, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1902181, 45818, 57, 1, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1902287, 45825, 84, 1, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1902374, 45828, 493, 14, 244, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1902892, 45846, 227, 6, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1903122, 45854, 57, 1, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1903228, 45861, 170, 5, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1903401, 45868, 783, 26, 190, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1904209, 45898, 631, 21, 87, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1904843, 45921, 545, 19, 72, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1905437, 45946, 103, 1, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1905543, 45949, 608, 20, 193, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1906176, 45973, 185, 5, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1906364, 45980, 141, 4, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1906554, 45990, 103, 1, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1906660, 45993, 657, 23, 190, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1907342, 46020, 230, 7, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1907575, 46029, 111, 3, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1907735, 46038, 105, 1, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1907843, 46041, 617, 22, 139, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1908485, 46067, 228, 7, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1908716, 46076, 144, 4, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1908875, 46083, 97, 1, 67, "SolutionText",
   CellTags->"7.2 Solutions"],
  Cell[1908997, 46088, 228, 7, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1909228, 46097, 144, 4, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1909421, 46107, 135, 5, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1909559, 46114, 352, 12, 139, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1909914, 46128, 790, 27, 195, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1910741, 46160, 148, 5, 67, "SolutionItem",
   CellTags->"7.2 Solutions"],
  Cell[1910892, 46167, 469, 15, 141, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1911386, 46186, 203, 6, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1911592, 46194, 108, 2, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1911715, 46199, 594, 19, 141, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1912334, 46222, 159, 4, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1912496, 46228, 162, 5, 67, "Output",
   CellTags->"7.2 Solutions"],
  Cell[1912673, 46236, 113, 5, 67, "SolutionText",
   CellTags->"7.2 Solutions"],
  Cell[1912789, 46243, 492, 15, 141, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1913306, 46262, 131, 3, 82, "Input",
   CellTags->"7.2 Solutions"],
  Cell[1913440, 46267, 339, 9, 67, "Output",
   CellTags->"7.2 Solutions"]},
 "i:9"->{
  Cell[1913926, 46288, 1803, 68, 288, "ExerciseItem",
   CellTags->{"i:9", "7.3 Exercises"}]},
 "7.3 Exercises"->{
  Cell[1913926, 46288, 1803, 68, 288, "ExerciseItem",
   CellTags->{"i:9", "7.3 Exercises"}],
  Cell[1915754, 46360, 174, 5, 82, "ExerciseInput",
   CellTags->"7.3 Exercises"],
  Cell[1915931, 46367, 519, 16, 67, "ExerciseOutput",
   CellTags->"7.3 Exercises"],
  Cell[1916465, 46386, 2384, 48, 123, "ExerciseText",
   CellTags->"7.3 Exercises"],
  Cell[1918852, 46436, 2311, 81, 123, "ExerciseDisplayFormula",
   CellTags->"7.3 Exercises"],
  Cell[1921166, 46519, 2298, 70, 123, "ExerciseDisplayFormula",
   CellTags->"7.3 Exercises"],
  Cell[1923467, 46591, 580, 19, 123, "ExerciseText",
   CellTags->"7.3 Exercises"],
  Cell[1924072, 46614, 105, 1, 87, "NumberedTable",
   CellTags->{"Table.Eulerian numbers", "7.3 Exercises"}],
  Cell[1924180, 46617, 7610, 245, 645, "DisplayTable",
   CellTags->"7.3 Exercises"],
  Cell[1931805, 46865, 221, 5, 123, "ExerciseText",
   CellTags->"7.3 Exercises"],
  Cell[1932029, 46872, 180, 4, 123, "ExerciseText",
   CellTags->"7.3 Exercises"],
  Cell[1932212, 46878, 764, 26, 123, "ExerciseDisplayFormula",
   CellTags->"7.3 Exercises"],
  Cell[1933013, 46909, 269, 5, 123, "ExerciseItem",
   CellTags->"7.3 Exercises"],
  Cell[1933285, 46916, 1405, 49, 249, "ExerciseDisplayFormula",
   CellTags->"7.3 Exercises"],
  Cell[1934693, 46967, 130, 3, 73, "ExerciseText",
   CellTags->"7.3 Exercises"],
  Cell[1934838, 46973, 400, 9, 171, "ExerciseItem",
   CellTags->"7.3 Exercises"],
  Cell[1935241, 46984, 827, 24, 211, "ExerciseItem",
   CellTags->{"7.3 Exercises", "Ex.Collatz", "i:16"}]},
 "Table.Eulerian numbers"->{
  Cell[1924072, 46614, 105, 1, 87, "NumberedTable",
   CellTags->{"Table.Eulerian numbers", "7.3 Exercises"}]},
 "7.3 Solutions"->{
  Cell[1936157, 47016, 141, 4, 67, "SolutionItem",
   CellTags->"7.3 Solutions"],
  Cell[1936301, 47022, 534, 17, 181, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1936838, 47041, 545, 18, 126, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1937408, 47063, 346, 11, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1937757, 47076, 922, 23, 468, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1938694, 47102, 212, 4, 117, "SolutionText",
   CellTags->"7.3 Solutions"],
  Cell[1938931, 47110, 150, 4, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1939084, 47116, 133, 3, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1939232, 47122, 458, 14, 117, "SolutionText",
   CellTags->"7.3 Solutions"],
  Cell[1939693, 47138, 121, 3, 69, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1939817, 47143, 534, 17, 181, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1940354, 47162, 839, 26, 229, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1941218, 47192, 150, 4, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1941371, 47198, 147, 4, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1941555, 47207, 171, 5, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1941729, 47214, 122, 3, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1941888, 47222, 150, 4, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1942041, 47228, 134, 2, 76, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1942224, 47236, 187, 4, 117, "SolutionItem",
   CellTags->"7.3 Solutions"],
  Cell[1942414, 47242, 174, 5, 123, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1942591, 47249, 765, 27, 244, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1943381, 47280, 141, 4, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1943525, 47286, 192, 5, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1943754, 47296, 161, 5, 103, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1943918, 47303, 123, 3, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1944090, 47312, 150, 4, 67, "SolutionItem",
   CellTags->"7.3 Solutions"],
  Cell[1944243, 47318, 176, 5, 123, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1944422, 47325, 898, 31, 244, "InputOnly",
   CellTags->"7.3 Solutions"],
  Cell[1945345, 47360, 142, 4, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1945490, 47366, 192, 5, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1945719, 47376, 162, 5, 103, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1945884, 47383, 124, 3, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1946023, 47389, 344, 11, 117, "SolutionText",
   CellTags->"7.3 Solutions"],
  Cell[1946392, 47404, 169, 5, 103, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1946564, 47411, 125, 3, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1946738, 47420, 136, 5, 67, "SolutionItem",
   CellTags->"7.3 Solutions"],
  Cell[1946877, 47427, 137, 4, 87, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1947017, 47433, 516, 17, 199, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1947536, 47452, 542, 18, 139, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1948081, 47472, 151, 5, 67, "SolutionText",
   CellTags->"7.3 Solutions"],
  Cell[1948257, 47481, 112, 3, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1948372, 47486, 57, 1, 67, "Output",
   CellTags->"7.3 Solutions"],
  Cell[1948444, 47490, 276, 11, 67, "SolutionText",
   CellTags->"7.3 Solutions"],
  Cell[1948745, 47505, 231, 7, 82, "Input",
   CellTags->"7.3 Solutions"],
  Cell[1948979, 47514, 1526, 22, 481, "Output",
   CellTags->"7.3 Solutions"]},
 "7.4 Exercises"->{
  Cell[1950651, 47548, 326, 11, 123, "ExerciseItem",
   CellTags->"7.4 Exercises"],
  Cell[1951002, 47563, 295, 7, 82, "ExerciseInput",
   CellTags->"7.4 Exercises"],
  Cell[1951300, 47572, 407, 11, 67, "ExerciseOutput",
   CellTags->"7.4 Exercises"],
  Cell[1951756, 47589, 203, 6, 76, "ExerciseItem",
   CellTags->"7.4 Exercises"],
  Cell[1951962, 47597, 449, 13, 139, "ExerciseInput",
   Evaluatable->False,
   CellTags->"7.4 Exercises"],
  Cell[1952414, 47612, 1613, 52, 226, "ExerciseText",
   CellTags->"7.4 Exercises"],
  Cell[1954064, 47669, 274, 9, 123, "ExerciseItem",
   CellTags->"7.4 Exercises"],
  Cell[1954363, 47682, 385, 13, 82, "ExerciseInput",
   CellTags->"7.4 Exercises"],
  Cell[1954751, 47697, 274, 6, 67, "ExerciseOutput",
   CellTags->"7.4 Exercises"],
  Cell[1955052, 47707, 621, 17, 217, "ExerciseItem",
   CellTags->"7.4 Exercises"]},
 "7.4 Solutions"->{
  Cell[1955762, 47732, 377, 11, 117, "SolutionItem",
   CellTags->"7.4 Solutions"],
  Cell[1956142, 47745, 349, 11, 126, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1956494, 47758, 1206, 36, 280, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1957703, 47796, 380, 12, 117, "SolutionText",
   CellTags->"7.4 Solutions"],
  Cell[1958086, 47810, 410, 14, 73, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1958521, 47828, 293, 10, 82, "Input",
   CellTags->"7.4 Solutions"],
  Cell[1958817, 47840, 266, 9, 67, "Output",
   CellTags->"7.4 Solutions"],
  Cell[1959098, 47852, 185, 5, 73, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1959308, 47861, 287, 7, 82, "Input",
   CellTags->"7.4 Solutions"],
  Cell[1959598, 47870, 385, 11, 67, "Output",
   CellTags->"7.4 Solutions"],
  Cell[1959998, 47884, 88, 1, 67, "SolutionText",
   CellTags->"7.4 Solutions"],
  Cell[1960111, 47889, 287, 7, 82, "Input",
   CellTags->"7.4 Solutions"],
  Cell[1960401, 47898, 385, 11, 67, "Output",
   CellTags->"7.4 Solutions"],
  Cell[1960835, 47915, 222, 6, 67, "SolutionItem",
   CellTags->"7.4 Solutions"],
  Cell[1961060, 47923, 1249, 41, 288, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1962346, 47969, 77, 1, 67, "SolutionItem",
   CellTags->"7.4 Solutions"],
  Cell[1962426, 47972, 540, 18, 126, "InputOnly",
   CellTags->"7.4 Solutions"],
  Cell[1962991, 47994, 361, 12, 82, "Input",
   CellTags->"7.4 Solutions"],
  Cell[1963355, 48008, 252, 6, 67, "Output",
   CellTags->"7.4 Solutions"]},
 "8.1 Exercises"->{
  Cell[1964660, 48054, 583, 20, 130, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:32"}],
  Cell[1965268, 48078, 921, 34, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:33", "Ex.Convert"}],
  Cell[1966214, 48116, 205, 6, 82, "ExerciseInput",
   CellTags->"8.1 Exercises"],
  Cell[1966422, 48124, 79, 1, 67, "ExerciseOutput",
   CellTags->"8.1 Exercises"],
  Cell[1966528, 48129, 514, 13, 171, "ExerciseItem",
   CellTags->{"i:119", "8.1 Exercises"}],
  Cell[1967045, 48144, 1933, 48, 117, "ExerciseItem",
   CellTags->"8.1 Exercises"],
  Cell[1968981, 48194, 1145, 39, 216, "ExerciseItem",
   CellTags->"8.1 Exercises"],
  Cell[1970151, 48237, 542, 16, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:34"}],
  Cell[1970718, 48257, 140, 3, 82, "ExerciseInput",
   CellTags->"8.1 Exercises"],
  Cell[1970861, 48262, 156, 4, 67, "ExerciseOutput",
   CellTags->"8.1 Exercises"],
  Cell[1971032, 48269, 100, 1, 73, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1971157, 48274, 114, 2, 82, "ExerciseInput",
   CellTags->"8.1 Exercises"],
  Cell[1971274, 48278, 156, 4, 67, "ExerciseOutput",
   CellTags->"8.1 Exercises"],
  Cell[1971445, 48285, 174, 5, 73, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1971644, 48294, 136, 3, 82, "ExerciseInput",
   CellTags->"8.1 Exercises"],
  Cell[1971783, 48299, 79, 1, 67, "ExerciseOutput",
   CellTags->"8.1 Exercises"],
  Cell[1971877, 48303, 157, 4, 73, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1972049, 48310, 1313, 49, 249, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:35"}],
  Cell[1973365, 48361, 768, 25, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:36"}],
  Cell[1974136, 48388, 794, 26, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:37"}],
  Cell[1974955, 48418, 400, 8, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:38"}],
  Cell[1975358, 48428, 378, 16, 73, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1975739, 48446, 678, 28, 123, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1976442, 48478, 129, 3, 82, "ExerciseInput",
   CellTags->"8.1 Exercises"],
  Cell[1976574, 48483, 78, 1, 67, "ExerciseOutput",
   CellTags->"8.1 Exercises"],
  Cell[1976667, 48487, 2582, 55, 175, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1979286, 48547, 648, 23, 123, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:39"}],
  Cell[1979937, 48572, 419, 16, 91, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1980371, 48591, 1096, 27, 312, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:40"}],
  Cell[1981492, 48622, 857, 24, 256, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:41"}],
  Cell[1982352, 48648, 446, 16, 81, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1982801, 48666, 484, 17, 123, "ExerciseText",
   CellTags->"8.1 Exercises"],
  Cell[1983288, 48685, 271, 7, 82, "ExerciseInput",
   Evaluatable->False,
   CellTags->"8.1 Exercises"],
  Cell[1983562, 48694, 3722, 80, 175, "ExerciseText",
   CellTags->"8.1 Exercises"]},
 "Ex.Convert"->{
  Cell[1965268, 48078, 921, 34, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:33", "Ex.Convert"}]},
 "i:119"->{
  Cell[1966528, 48129, 514, 13, 171, "ExerciseItem",
   CellTags->{"i:119", "8.1 Exercises"}]},
 "i:35"->{
  Cell[1972049, 48310, 1313, 49, 249, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:35"}],
  Cell[7335645, 172261, 436, 10, 114, "ExerciseItem",
   CellTags->{"i:35", "11.1 Exercises"}]},
 "i:36"->{
  Cell[1973365, 48361, 768, 25, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:36"}],
  Cell[7336106, 172275, 481, 8, 148, "ExerciseItem",
   CellTags->{"i:36", "11.1 Exercises"}]},
 "i:37"->{
  Cell[1974136, 48388, 794, 26, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:37"}],
  Cell[7339056, 172337, 575, 16, 118, "ExerciseItem",
   CellTags->{"i:37", "11.1 Exercises"}]},
 "i:38"->{
  Cell[1974955, 48418, 400, 8, 163, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:38"}],
  Cell[3274456, 74993, 279, 9, 76, "ExerciseItem",
   CellTags->{"10.1 Exercises", "i:38"}]},
 "i:39"->{
  Cell[1979286, 48547, 648, 23, 123, "ExerciseItem",
   CellTags->{"8.1 Exercises", "i:39"}],
  Cell[3279259, 75158, 702, 21, 163, "ExerciseItem",
   CellTags->{"Ex.StandardDeviation", "i:39", "10.1 Exercises"}]},
 "8.1 Solutions"->{
  Cell[1987385, 48783, 155, 4, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1987543, 48789, 235, 7, 73, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[1987803, 48800, 154, 4, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1987960, 48806, 165, 6, 109, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1988162, 48817, 196, 5, 135, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1988361, 48824, 127, 4, 109, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1988537, 48834, 463, 15, 117, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1989003, 48851, 356, 12, 87, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1989362, 48865, 157, 7, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1989544, 48876, 117, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1989664, 48881, 121, 3, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1989800, 48887, 148, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1989973, 48896, 88, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1990064, 48900, 56, 1, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1990135, 48904, 270, 9, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1990430, 48917, 186, 6, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1990619, 48925, 56, 1, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1990690, 48929, 180, 4, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1990895, 48937, 193, 6, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1991091, 48945, 358, 13, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1991486, 48963, 87, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1991576, 48967, 275, 9, 76, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1991900, 48982, 183, 5, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1992086, 48989, 265, 8, 87, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1992376, 49001, 108, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1992487, 49006, 57, 1, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1992559, 49010, 174, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1992758, 49019, 163, 5, 103, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1992924, 49026, 57, 1, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1992996, 49030, 98, 1, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1993119, 49035, 178, 6, 103, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1993300, 49043, 57, 1, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[1993406, 49050, 125, 5, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1993534, 49057, 223, 6, 103, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1993794, 49068, 101, 1, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1993898, 49071, 233, 6, 87, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1994134, 49079, 139, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1994276, 49086, 115, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1994394, 49091, 113, 2, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1994510, 49095, 116, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1994629, 49100, 115, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1994747, 49105, 117, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1994901, 49113, 204, 6, 67, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 6}},
   CellTags->"8.1 Solutions"],
  Cell[1995108, 49121, 119, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1995230, 49126, 341, 10, 117, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1995574, 49138, 208, 6, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1995785, 49146, 233, 9, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1996021, 49157, 111, 3, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1996135, 49162, 160, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1996298, 49169, 602, 18, 190, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1996903, 49189, 91, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1996997, 49193, 187, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[1997187, 49200, 399, 12, 139, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1997589, 49214, 92, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1997718, 49221, 332, 13, 117, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[1998075, 49238, 255, 8, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[1998333, 49248, 6595, 179, 166, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2004943, 49430, 82, 1, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2005028, 49433, 364, 11, 69, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[2005417, 49448, 84, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2005504, 49452, 6961, 177, 208, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2012480, 49632, 159, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2012642, 49639, 231, 7, 73, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[2012898, 49650, 89, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2012990, 49654, 30334, 737, 213, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2043373, 50397, 159, 4, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[2043535, 50403, 429, 15, 69, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[2043967, 50420, 635, 20, 136, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2044605, 50442, 145, 4, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2044753, 50448, 221, 6, 73, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[2044977, 50456, 218, 6, 87, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2045198, 50464, 89, 1, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2045312, 50469, 201, 5, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2045516, 50476, 3293, 61, 594, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2048846, 50542, 159, 4, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2049008, 50548, 5821, 98, 411, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2054844, 50649, 172, 7, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2055053, 50661, 94, 1, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[2055150, 50664, 296, 9, 87, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2055449, 50675, 198, 7, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2055672, 50686, 242, 7, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2055917, 50695, 208, 5, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2056140, 50703, 148, 4, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2056291, 50709, 175, 7, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2056491, 50720, 386, 11, 136, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2056880, 50733, 824, 13, 222, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2057719, 50749, 472, 14, 117, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2058216, 50767, 194, 5, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2058413, 50774, 24643, 411, 310, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2083071, 51188, 229, 5, 117, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2083325, 51197, 261, 7, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2083589, 51206, 63053, 1040, 321, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2146657, 52249, 515, 14, 168, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2147197, 52267, 471, 13, 343, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2147671, 52282, 71608, 1181, 249, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2219316, 53468, 261, 7, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2219580, 53477, 63499, 1048, 249, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2283128, 54531, 434, 11, 117, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 11}},
   CellTags->"8.1 Solutions"],
  Cell[2283565, 54544, 1423, 37, 540, "InputOnly",
   CellTags->"8.1 Solutions"],
  Cell[2285013, 54585, 102, 2, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2285118, 54589, 162, 5, 67, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2285317, 54599, 240, 7, 136, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2285560, 54608, 321, 7, 172, "Output",
   CellTags->"8.1 Solutions"],
  Cell[2285930, 54621, 304, 13, 67, "SolutionItem",
   CellTags->"8.1 Solutions"],
  Cell[2286237, 54636, 523, 16, 240, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2286763, 54654, 166, 5, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2286932, 54661, 428, 14, 82, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2287363, 54677, 64, 1, 67, "SolutionText",
   CellTags->"8.1 Solutions"],
  Cell[2287452, 54682, 301, 7, 136, "Input",
   CellTags->"8.1 Solutions"],
  Cell[2287756, 54691, 14589, 247, 486, "Output",
   CellTags->"8.1 Solutions"]},
 "8.2 Exercises"->{
  Cell[2302494, 54950, 245, 8, 76, "ExerciseItem",
   CellTags->"8.2 Exercises"],
  Cell[2302764, 54962, 132, 3, 82, "ExerciseInput",
   CellTags->"8.2 Exercises"],
  Cell[2302899, 54967, 82, 1, 67, "ExerciseOutput",
   CellTags->"8.2 Exercises"],
  Cell[2303018, 54973, 112, 2, 82, "ExerciseInput",
   CellTags->"8.2 Exercises"],
  Cell[2303133, 54977, 93, 1, 67, "ExerciseOutput",
   CellTags->"8.2 Exercises"],
  Cell[2303253, 54982, 396, 13, 145, "ExerciseItem",
   CellTags->"8.2 Exercises"],
  Cell[2303674, 54999, 220, 6, 117, "ExerciseItem",
   CellTags->"8.2 Exercises"],
  Cell[2303919, 55009, 114, 2, 82, "ExerciseInput",
   CellTags->"8.2 Exercises"],
  Cell[2304036, 55013, 100, 1, 76, "ExerciseOutput",
   CellTags->"8.2 Exercises"],
  Cell[2304163, 55018, 428, 15, 94, "ExerciseItem",
   CellTags->"8.2 Exercises"]},
 "8.2 Solutions"->{
  Cell[2304680, 55041, 132, 5, 67, "SolutionItem",
   CellTags->"8.2 Solutions"],
  Cell[2304837, 55050, 93, 2, 82, "Input",
   CellTags->"8.2 Solutions"],
  Cell[2304933, 55054, 71, 1, 67, "Output",
   CellTags->"8.2 Solutions"],
  Cell[2305019, 55058, 412, 12, 168, "SolutionText",
   CellTags->"8.2 Solutions"],
  Cell[2305468, 55075, 188, 4, 117, "SolutionItem",
   CellTags->"8.2 Solutions"],
  Cell[2305681, 55083, 539, 18, 177, "Input",
   CellTags->"8.2 Solutions"],
  Cell[2306223, 55103, 847, 24, 514, "Output",
   CellTags->"8.2 Solutions"]},
 "8.3 Exercises"->{
  Cell[2307193, 55137, 423, 14, 123, "ExerciseItem",
   CellTags->{"8.3 Exercises", "i:85"}],
  Cell[2307619, 55153, 763, 27, 117, "ExerciseItem",
   CellTags->{"8.3 Exercises", "i:86"}],
  Cell[2308385, 55182, 957, 34, 211, "ExerciseItem",
   CellTags->"8.3 Exercises"],
  Cell[2309367, 55220, 632, 18, 177, "ExerciseItem",
   CellTags->{"i:120", "8.3 Exercises"}],
  Cell[2310024, 55242, 815, 18, 249, "ExerciseInput",
   CellTags->"8.3 Exercises"],
  Cell[2310842, 55262, 78, 1, 67, "ExerciseOutput",
   CellTags->"8.3 Exercises"],
  Cell[2310935, 55266, 474, 17, 123, "ExerciseText",
   CellTags->"8.3 Exercises"],
  Cell[2311446, 55288, 281, 5, 123, "ExerciseItem",
   CellTags->{"i:121", "8.3 Exercises"}],
  Cell[2311752, 55297, 791, 22, 199, "ExerciseInput",
   CellTags->"8.3 Exercises"],
  Cell[2312546, 55321, 152, 4, 76, "ExerciseOutput",
   CellTags->"8.3 Exercises"],
  Cell[2312735, 55330, 167, 5, 82, "ExerciseInput",
   CellTags->"8.3 Exercises"],
  Cell[2312905, 55337, 483, 18, 117, "ExerciseOutput",
   CellTags->"8.3 Exercises"],
  Cell[2313403, 55358, 223, 7, 73, "ExerciseText",
   CellTags->"8.3 Exercises"],
  Cell[2313629, 55367, 1469, 43, 123, "ExerciseDisplayFormula",
   CellTags->"8.3 Exercises"],
  Cell[2315101, 55412, 327, 9, 123, "ExerciseText",
   CellTags->"8.3 Exercises"]},
 "i:120"->{
  Cell[2309367, 55220, 632, 18, 177, "ExerciseItem",
   CellTags->{"i:120", "8.3 Exercises"}]},
 "i:121"->{
  Cell[2311446, 55288, 281, 5, 123, "ExerciseItem",
   CellTags->{"i:121", "8.3 Exercises"}]},
 "8.3 Solutions"->{
  Cell[2315529, 55430, 102, 1, 67, "SolutionItem",
   CellTags->"8.3 Solutions"],
  Cell[2315634, 55433, 435, 13, 139, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2316094, 55450, 168, 5, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2316265, 55457, 829, 21, 310, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2317143, 55484, 136, 5, 67, "SolutionItem",
   CellTags->"8.3 Solutions"],
  Cell[2317282, 55491, 726, 23, 177, "InputOnly",
   CellTags->"8.3 Solutions"],
  Cell[2318033, 55518, 144, 3, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2318180, 55523, 378, 13, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2318595, 55541, 120, 3, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2318718, 55546, 822, 21, 310, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2319589, 55573, 93, 1, 67, "SolutionItem",
   CellTags->"8.3 Solutions"],
  Cell[2319685, 55576, 297, 9, 90, "InputOnly",
   CellTags->"8.3 Solutions"],
  Cell[2320007, 55589, 105, 2, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2320115, 55593, 59, 1, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2320189, 55597, 202, 7, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2320394, 55606, 180, 5, 69, "InputOnly",
   CellTags->"8.3 Solutions"],
  Cell[2320599, 55615, 108, 2, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2320710, 55619, 60, 1, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2320785, 55623, 143, 4, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2320953, 55631, 171, 5, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2321127, 55638, 112, 3, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2321254, 55644, 149, 4, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2321428, 55652, 200, 6, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2321631, 55660, 123, 3, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2321791, 55668, 203, 6, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2321997, 55676, 122, 3, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2322134, 55682, 151, 4, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2322310, 55690, 138, 4, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2322451, 55696, 126, 3, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2322614, 55704, 141, 4, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2322758, 55710, 125, 3, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2322932, 55719, 489, 16, 117, "SolutionItem",
   CellTags->"8.3 Solutions"],
  Cell[2323424, 55737, 864, 28, 177, "InputOnly",
   CellTags->"8.3 Solutions"],
  Cell[2324291, 55767, 188, 6, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2324504, 55777, 203, 6, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2324710, 55785, 322, 7, 121, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2325047, 55795, 394, 13, 136, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2325466, 55812, 146, 4, 103, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2325615, 55818, 339, 8, 276, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2325991, 55831, 205, 6, 103, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2326199, 55839, 59, 1, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2326307, 55846, 437, 14, 117, "SolutionItem",
   CellTags->"8.3 Solutions"],
  Cell[2326747, 55862, 754, 23, 243, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2327504, 55887, 89, 1, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2327618, 55892, 204, 6, 82, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2327825, 55900, 192, 5, 67, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2328032, 55908, 101, 1, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2328158, 55913, 147, 4, 103, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2328308, 55919, 343, 8, 276, "Output",
   CellTags->"8.3 Solutions"],
  Cell[2328666, 55930, 192, 7, 67, "SolutionText",
   CellTags->"8.3 Solutions"],
  Cell[2328883, 55941, 383, 11, 220, "Input",
   CellTags->"8.3 Solutions"],
  Cell[2329269, 55954, 59, 1, 67, "Output",
   CellTags->"8.3 Solutions"]},
 "8.4 Exercises"->{
  Cell[2329459, 55965, 663, 17, 217, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:113"}],
  Cell[2330125, 55984, 539, 13, 211, "ExerciseItem",
   CellTags->"8.4 Exercises"],
  Cell[2330667, 55999, 761, 22, 211, "ExerciseItem",
   CellTags->"8.4 Exercises"],
  Cell[2331453, 56025, 600, 18, 163, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:112"}],
  Cell[2332078, 56047, 427, 12, 136, "ExerciseInput",
   CellTags->"8.4 Exercises"],
  Cell[2332508, 56061, 469, 9, 123, "Message",
   CellTags->"8.4 Exercises"],
  Cell[2332980, 56072, 673, 15, 222, "ExerciseOutput",
   CellTags->"8.4 Exercises"],
  Cell[2333668, 56090, 541, 17, 123, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2334212, 56109, 646, 20, 117, "ExerciseDisplayFormula",
   CellTags->"8.4 Exercises"],
  Cell[2334861, 56131, 143, 4, 73, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2335019, 56138, 698, 24, 123, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:114"}],
  Cell[2335720, 56164, 246, 9, 49, "ExerciseSubItemR",
   CellTags->"8.4 Exercises"],
  Cell[2335969, 56175, 322, 12, 49, "ExerciseSubItemR",
   CellTags->"8.4 Exercises"],
  Cell[2336294, 56189, 452, 15, 54, "ExerciseSubItemR",
   CellTags->"8.4 Exercises"],
  Cell[2336749, 56206, 449, 15, 49, "ExerciseSubItemR",
   CellTags->"8.4 Exercises"],
  Cell[2337223, 56225, 460, 15, 49, "ExerciseSubItemR",
   CellTags->"8.4 Exercises"],
  Cell[2337686, 56242, 307, 9, 123, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2337996, 56253, 462, 14, 73, "ExerciseDisplayFormula",
   CellTags->"8.4 Exercises"],
  Cell[2338461, 56269, 292, 9, 82, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2338756, 56280, 566, 19, 82, "ExerciseDisplayFormula",
   CellTags->"8.4 Exercises"],
  Cell[2339325, 56301, 424, 12, 126, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2339752, 56315, 961, 34, 126, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2340738, 56353, 900, 27, 189, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:115"}],
  Cell[2341641, 56382, 739, 25, 175, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2342417, 56412, 1194, 40, 217, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:116"}],
  Cell[2343636, 56456, 513, 15, 190, "ExerciseInput",
   CellTags->"8.4 Exercises"],
  Cell[2344152, 56473, 447, 13, 67, "ExerciseOutput",
   CellTags->"8.4 Exercises"],
  Cell[2344614, 56489, 148, 4, 73, "ExerciseText",
   CellTags->"8.4 Exercises"],
  Cell[2344765, 56495, 382, 11, 189, "ExerciseInput",
   CellTags->"8.4 Exercises"],
  Cell[2345184, 56511, 637, 19, 171, "ExerciseItem",
   CellTags->{"Ex.Autocorrelation", "8.4 Exercises"}],
  Cell[2345824, 56532, 475, 8, 226, "ExerciseText",
   CellTags->{"8.4 Exercises", "i:117"}],
  Cell[2346302, 56542, 420, 12, 82, "ExerciseInput",
   CellTags->"8.4 Exercises"],
  Cell[2346747, 56558, 845, 23, 240, "ExerciseInput",
   CellTags->"8.4 Exercises"],
  Cell[2347595, 56583, 7394, 127, 607, "ExerciseOutput",
   CellTags->"8.4 Exercises"],
  Cell[2355016, 56714, 3756, 99, 265, "ExerciseItem",
   CellTags->{"Ex.Walk pi", "i:118", "8.4 Exercises"}]},
 "i:113"->{
  Cell[2329459, 55965, 663, 17, 217, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:113"}],
  Cell[6463035, 156905, 366, 10, 121, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:113"}]},
 "i:112"->{
  Cell[2331453, 56025, 600, 18, 163, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:112"}],
  Cell[6461994, 156871, 1038, 32, 229, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:112"}]},
 "i:114"->{
  Cell[2335019, 56138, 698, 24, 123, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:114"}],
  Cell[6464394, 156953, 511, 10, 222, "ExerciseItem",
   CellTags->{"Ex.SimpleClosedPath", "10.4 Exercises", "i:114"}]},
 "i:115"->{
  Cell[2340738, 56353, 900, 27, 189, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:115"}],
  Cell[6465831, 156993, 550, 14, 171, "ExerciseItem",
   CellTags->{"10.4 Exercises", "Ex.ShowWalk", "i:115"}]},
 "i:116"->{
  Cell[2342417, 56412, 1194, 40, 217, "ExerciseItem",
   CellTags->{"8.4 Exercises", "i:116"}],
  Cell[6479746, 157283, 957, 33, 177, "ExerciseItem",
   CellTags->{"Ex.Mesh", "i:116", "10.4 Exercises"}]},
 "Ex.Autocorrelation"->{
  Cell[2345184, 56511, 637, 19, 171, "ExerciseItem",
   CellTags->{"Ex.Autocorrelation", "8.4 Exercises"}]},
 "i:117"->{
  Cell[2345824, 56532, 475, 8, 226, "ExerciseText",
   CellTags->{"8.4 Exercises", "i:117"}],
  Cell[6481449, 157341, 556, 13, 189, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:117"}]},
 "Ex.Walk pi"->{
  Cell[2355016, 56714, 3756, 99, 265, "ExerciseItem",
   CellTags->{"Ex.Walk pi", "i:118", "8.4 Exercises"}]},
 "i:118"->{
  Cell[2355016, 56714, 3756, 99, 265, "ExerciseItem",
   CellTags->{"Ex.Walk pi", "i:118", "8.4 Exercises"}]},
 "8.4 Solutions"->{
  Cell[2358873, 56822, 204, 6, 118, "SolutionItem",
   CellTags->"8.4 Solutions"],
  Cell[2359080, 56830, 481, 12, 279, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2359564, 56844, 2872, 81, 999, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2362439, 56927, 159, 5, 82, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2362623, 56936, 173, 5, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2362799, 56943, 125, 3, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2362961, 56951, 181, 5, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2363145, 56958, 198, 6, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2363380, 56969, 90, 2, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2363473, 56973, 59, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2363581, 56980, 131, 2, 67, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 4}},
   CellTags->"8.4 Solutions"],
  Cell[2363715, 56984, 177, 6, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2363895, 56992, 193, 7, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2364091, 57001, 259, 8, 73, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2364375, 57013, 87, 2, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2364465, 57017, 56, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2364536, 57021, 226, 8, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2364787, 57033, 117, 3, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2364907, 57038, 56, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2364978, 57042, 193, 8, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2365174, 57052, 368, 12, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2365545, 57066, 83, 1, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2365631, 57069, 371, 12, 126, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2366027, 57085, 87, 2, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2366117, 57089, 56, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2366188, 57093, 241, 8, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2366454, 57105, 117, 3, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2366574, 57110, 56, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2366645, 57114, 1033, 29, 274, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2367715, 57148, 230, 8, 67, "SolutionItem",
   CellTags->"8.4 Solutions"],
  Cell[2367948, 57158, 329, 10, 73, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2368302, 57172, 161, 4, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2368466, 57178, 73, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2368554, 57182, 112, 2, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2368691, 57188, 313, 9, 136, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2369007, 57199, 73, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2369095, 57203, 176, 4, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2369296, 57211, 123, 3, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2369422, 57216, 171, 5, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2369630, 57226, 140, 4, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2369773, 57232, 74, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2369862, 57236, 437, 13, 190, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2370324, 57253, 123, 3, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2370450, 57258, 73, 1, 67, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2370572, 57265, 155, 4, 67, "SolutionItem",
   CellTags->"8.4 Solutions"],
  Cell[2370730, 57271, 435, 14, 94, "Program",
   Evaluatable->False,
   CellTags->"8.4 Solutions"],
  Cell[2371168, 57287, 126, 5, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2371297, 57294, 579, 18, 139, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2371879, 57314, 288, 6, 118, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2372170, 57322, 653, 17, 343, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2372848, 57343, 285, 8, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2373136, 57353, 2840, 71, 649, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2375991, 57427, 208, 4, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2376202, 57433, 364, 11, 175, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2376591, 57448, 169, 4, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2376763, 57454, 1253, 28, 402, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2378065, 57488, 231, 9, 67, "SolutionItem",
   CellTags->"8.4 Solutions"],
  Cell[2378299, 57499, 319, 10, 69, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2378621, 57511, 2770, 74, 747, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2381394, 57587, 388, 12, 126, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2381785, 57601, 127, 3, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2381915, 57606, 607, 20, 123, "InputOnly",
   CellTags->"8.4 Solutions"],
  Cell[2382525, 57628, 81, 1, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2382631, 57633, 655, 19, 189, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2383289, 57654, 5195, 92, 418, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2388533, 57752, 392, 13, 67, "SolutionItem",
   CellTags->"8.4 Solutions"],
  Cell[2388950, 57769, 205, 6, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2389158, 57777, 504, 9, 121, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2389677, 57789, 184, 9, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2389886, 57802, 95, 3, 82, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2389984, 57807, 903, 26, 121, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2390902, 57836, 110, 2, 67, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2391037, 57842, 555, 15, 240, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2391595, 57859, 564840, 9266, 409, "Output",
   CellTags->"8.4 Solutions"],
  Cell[2956450, 67128, 327, 9, 118, "SolutionText",
   CellTags->"8.4 Solutions"],
  Cell[2956802, 67141, 1116, 34, 292, "Input",
   CellTags->"8.4 Solutions"],
  Cell[2957921, 67177, 160727, 2641, 753, "Output",
   CellTags->"8.4 Solutions"]},
 "Sec.Structure"->{
  Cell[3119592, 69852, 78, 1, 67, "ExerciseSubsection",
   CellTags->"Sec.Structure"]},
 "9.1 Exercises"->{
  Cell[3119673, 69855, 163, 4, 76, "ExerciseItem",
   CellTags->"9.1 Exercises"],
  Cell[3119839, 69861, 315, 9, 117, "ExerciseItem",
   CellTags->"9.1 Exercises"],
  Cell[3120157, 69872, 617, 21, 117, "ExerciseItem",
   CellTags->"9.1 Exercises"]},
 "9.1 Solutions"->{
  Cell[3120863, 69901, 104, 1, 67, "SolutionItem",
   CellTags->"9.1 Solutions"],
  Cell[3120992, 69906, 107, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3121102, 69910, 84, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3121201, 69914, 135, 5, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3121361, 69923, 116, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3121480, 69928, 64, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3121559, 69932, 79, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3121663, 69937, 96, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3121762, 69941, 80, 2, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3121857, 69946, 204, 5, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3122086, 69955, 78, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3122167, 69959, 79, 2, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3122261, 69964, 80, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3122366, 69969, 98, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3122467, 69973, 64, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3122546, 69977, 103, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3122674, 69982, 116, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3122793, 69987, 83, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3122891, 69991, 163, 6, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3123079, 70001, 115, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3123197, 70006, 84, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3123296, 70010, 488, 14, 118, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3123809, 70028, 155, 4, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3123967, 70034, 64, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3124068, 70040, 161, 5, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3124232, 70047, 83, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3124352, 70053, 291, 9, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3124646, 70064, 84, 1, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3124779, 70071, 104, 1, 67, "SolutionItem",
   CellTags->"9.1 Solutions"],
  Cell[3124886, 70074, 108, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3124997, 70078, 78, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3125078, 70082, 225, 7, 103, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3125306, 70091, 78, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3125387, 70095, 392, 13, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3125782, 70110, 279, 9, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3126064, 70121, 226, 8, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3126293, 70131, 105, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3126435, 70138, 112, 2, 67, "SolutionItem",
   CellTags->"9.1 Solutions"],
  Cell[3126572, 70144, 183, 4, 136, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3126758, 70150, 287, 5, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3127060, 70158, 173, 2, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3127258, 70164, 125, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3127386, 70169, 156, 4, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3127557, 70176, 358, 12, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3127940, 70192, 136, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3128079, 70197, 156, 4, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3128250, 70204, 78, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3128331, 70207, 217, 5, 73, "InputOnly",
   CellTags->"9.1 Solutions"],
  Cell[3128551, 70214, 93, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3128669, 70219, 134, 3, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3128806, 70224, 251, 4, 172, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3129094, 70233, 103, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3129200, 70237, 439, 7, 67, "Output",
   CellTags->"9.1 Solutions"],
  Cell[3129654, 70247, 89, 1, 67, "SolutionText",
   CellTags->"9.1 Solutions"],
  Cell[3129768, 70252, 104, 2, 82, "Input",
   CellTags->"9.1 Solutions"],
  Cell[3129875, 70256, 73, 2, 67, "Output",
   CellTags->"9.1 Solutions"]},
 "Sec.Operations"->{
  Cell[3130021, 70266, 80, 1, 45, "ExerciseSubsection",
   CellTags->"Sec.Operations"]},
 "9.2 Exercises"->{
  Cell[3130104, 70269, 667, 24, 123, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:41"}],
  Cell[3130796, 70297, 546, 19, 117, "ExerciseItem",
   CellTags->"9.2 Exercises"],
  Cell[3131367, 70320, 176, 4, 82, "ExerciseInput",
   CellTags->"9.2 Exercises"],
  Cell[3131546, 70326, 109, 1, 67, "ExerciseOutput",
   CellTags->"9.2 Exercises"],
  Cell[3131682, 70331, 367, 8, 171, "ExerciseItem",
   CellTags->"9.2 Exercises"],
  Cell[3132052, 70341, 1655, 59, 211, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:42"}],
  Cell[3133710, 70402, 198, 4, 117, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:43"}],
  Cell[3133933, 70410, 357, 8, 163, "ExerciseItem",
   CellTags->"9.2 Exercises"],
  Cell[3134293, 70420, 130, 2, 67, "ExerciseOutput",
   CellTags->"9.2 Exercises"],
  Cell[3134426, 70424, 438, 21, 73, "ExerciseText",
   CellTags->"9.2 Exercises"],
  Cell[3134867, 70447, 132, 6, 73, "ExerciseText",
   CellTags->"9.2 Exercises"],
  Cell[3135002, 70455, 76, 1, 73, "ExerciseText",
   CellTags->"9.2 Exercises"],
  Cell[3135081, 70458, 125, 5, 73, "ExerciseText",
   CellTags->"9.2 Exercises"],
  Cell[3135209, 70465, 193, 4, 126, "ExerciseText",
   CellTags->"9.2 Exercises"],
  Cell[3135417, 70472, 915, 29, 180, "ExerciseItem",
   CellTags->{"9.2 Exercises", "i:44"}]},
 "9.2 Solutions"->{
  Cell[3136421, 70509, 121, 3, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3136545, 70514, 198, 5, 73, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3136768, 70523, 103, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3136874, 70527, 60, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3136971, 70533, 102, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3137076, 70537, 59, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3137150, 70541, 153, 4, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3137306, 70547, 206, 5, 73, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3137537, 70556, 99, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3137639, 70560, 59, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3137713, 70564, 170, 6, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3137886, 70572, 203, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3138092, 70579, 136, 5, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3138253, 70588, 124, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3138380, 70593, 1626, 26, 328, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3140055, 70625, 228, 8, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3140286, 70635, 316, 10, 139, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3140627, 70649, 146, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3140776, 70654, 82, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3140907, 70661, 273, 8, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3141183, 70671, 201, 6, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3141387, 70679, 124, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3141514, 70684, 125, 3, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3141642, 70689, 96, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3141741, 70693, 568, 17, 139, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3142312, 70712, 166, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3142515, 70722, 293, 11, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3142811, 70735, 335, 10, 73, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3143171, 70749, 181, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3143355, 70756, 193, 7, 103, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3143563, 70766, 207, 7, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3143773, 70775, 212, 6, 123, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3143988, 70783, 701, 22, 229, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3144714, 70809, 156, 4, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3144873, 70815, 192, 7, 103, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3145102, 70827, 124, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3145229, 70832, 297, 7, 72, "Message",
   CellTags->"9.2 Solutions"],
  Cell[3145541, 70842, 135, 3, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3145679, 70847, 426, 12, 126, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3146130, 70863, 169, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3146302, 70870, 199, 7, 103, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3146516, 70880, 227, 8, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3146768, 70892, 250, 7, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3147021, 70901, 190, 7, 103, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3147226, 70911, 516, 15, 126, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3147767, 70930, 170, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3147940, 70937, 199, 7, 103, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3148188, 70950, 176, 4, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3148389, 70958, 104, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3148496, 70962, 79, 2, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3148612, 70969, 332, 9, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3148947, 70980, 591, 9, 121, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3149575, 70994, 253, 7, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3149831, 71003, 1593, 30, 172, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3151461, 71038, 180, 5, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3151644, 71045, 1593, 30, 172, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3153252, 71078, 292, 9, 73, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3153547, 71089, 296, 9, 126, "InputOnly",
   CellTags->"9.2 Solutions"],
  Cell[3153868, 71102, 136, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3154007, 71107, 82, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3154126, 71113, 112, 3, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3154241, 71118, 82, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3154372, 71125, 126, 3, 67, "SolutionItem",
   CellTags->"9.2 Solutions"],
  Cell[3154523, 71132, 170, 4, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3154696, 71138, 573, 9, 121, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3155284, 71150, 134, 6, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3155443, 71160, 92, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3155538, 71164, 69, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3155622, 71168, 111, 2, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3155758, 71174, 261, 7, 136, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3156022, 71183, 89, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3156126, 71187, 77, 1, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3156206, 71190, 538, 16, 139, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3156747, 71208, 78, 1, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3156850, 71213, 255, 7, 136, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3157108, 71222, 1537, 29, 172, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3158660, 71254, 123, 3, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3158786, 71259, 235, 7, 87, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3159046, 71270, 112, 2, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3159161, 71274, 81, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3159257, 71278, 248, 9, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3159508, 71289, 333, 10, 139, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3159866, 71303, 235, 6, 136, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3160104, 71311, 168, 4, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3160309, 71320, 311, 8, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3160623, 71330, 80, 1, 67, "Output",
   CellTags->"9.2 Solutions"],
  Cell[3160718, 71334, 97, 1, 67, "SolutionText",
   CellTags->"9.2 Solutions"],
  Cell[3160818, 71337, 2073, 53, 814, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3162916, 71394, 161, 4, 82, "Input",
   CellTags->"9.2 Solutions"],
  Cell[3163080, 71400, 82, 1, 67, "Output",
   CellTags->"9.2 Solutions"]},
 "Sec.String patterns"->{
  Cell[3163235, 71409, 79, 1, 45, "ExerciseSubsection",
   CellTags->"Sec.String patterns"]},
 "9.3 Exercises"->{
  Cell[3163317, 71412, 788, 21, 217, "ExerciseItem",
   CellTags->"9.3 Exercises"],
  Cell[3164108, 71435, 264, 5, 117, "ExerciseItem",
   CellTags->"9.3 Exercises"],
  Cell[3164375, 71442, 440, 15, 117, "ExerciseItem",
   CellTags->{"9.3 Exercises", "i:57"}],
  Cell[3164840, 71461, 188, 6, 69, "ExerciseItem",
   CellTags->"9.3 Exercises"],
  Cell[3165031, 71469, 228, 7, 82, "Input",
   CellTags->"9.3 Exercises"],
  Cell[3165262, 71478, 301, 10, 126, "ExerciseText",
   CellTags->"9.3 Exercises"],
  Cell[3165566, 71490, 2374, 47, 175, "ExerciseText",
   CellTags->{"i:94", "9.3 Exercises"}]},
 "i:94"->{
  Cell[3165566, 71490, 2374, 47, 175, "ExerciseText",
   CellTags->{"i:94", "9.3 Exercises"}]},
 "9.3 Solutions"->{
  Cell[3168041, 71546, 155, 7, 67, "SolutionItem",
   CellTags->"9.3 Solutions"],
  Cell[3168199, 71555, 208, 5, 87, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3168410, 71562, 676, 18, 168, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3169111, 71584, 299, 9, 139, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3169413, 71595, 501, 11, 121, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3169951, 71611, 239, 7, 136, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3170193, 71620, 521, 9, 121, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3170763, 71635, 122, 3, 67, "SolutionItem",
   CellTags->"9.3 Solutions"],
  Cell[3170910, 71642, 263, 7, 136, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3171176, 71651, 381, 7, 121, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3171572, 71661, 290, 8, 118, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3171887, 71673, 293, 9, 87, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3172183, 71684, 381, 7, 121, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3172613, 71697, 496, 14, 172, "SolutionItem",
   CellTags->"9.3 Solutions"],
  Cell[3173112, 71713, 485, 13, 193, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3173600, 71728, 178, 3, 67, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3173781, 71733, 409, 11, 73, "InputOnly",
   CellTags->"9.3 Solutions"],
  Cell[3174215, 71748, 92, 2, 82, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3174310, 71752, 156, 4, 67, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3174503, 71761, 157, 3, 82, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3174663, 71766, 1626, 26, 328, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3176338, 71798, 82, 1, 67, "SolutionItem",
   CellTags->"9.3 Solutions"],
  Cell[3176423, 71801, 228, 7, 82, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3176654, 71810, 154, 4, 67, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3176833, 71818, 346, 10, 136, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3177182, 71830, 542, 11, 157, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3177739, 71844, 94, 1, 67, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3177858, 71849, 91, 2, 82, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3177952, 71853, 59, 1, 67, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3178026, 71857, 83, 1, 67, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3178134, 71862, 234, 6, 136, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3178371, 71870, 542, 11, 157, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3178928, 71884, 94, 1, 67, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3179047, 71889, 135, 4, 82, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3179185, 71895, 59, 1, 67, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3179259, 71899, 276, 9, 118, "SolutionText",
   CellTags->"9.3 Solutions"],
  Cell[3179560, 71912, 295, 8, 136, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3179858, 71922, 59, 1, 67, "Output",
   CellTags->"9.3 Solutions"],
  Cell[3179954, 71928, 443, 13, 189, "Input",
   CellTags->"9.3 Solutions"],
  Cell[3180400, 71943, 59, 1, 67, "Output",
   CellTags->"9.3 Solutions"]},
 "9.4 Exercises"->{
  Cell[3180606, 71956, 505, 16, 123, "ExerciseItem",
   CellTags->"9.4 Exercises"],
  Cell[3181114, 71974, 175, 5, 82, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3181314, 71983, 196, 5, 87, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3181513, 71990, 236, 5, 67, "ExerciseOutput",
   CellTags->"9.4 Exercises"],
  Cell[3181776, 71999, 608, 22, 171, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:65"}],
  Cell[3182387, 72023, 411, 14, 117, "ExerciseItem",
   CellTags->"9.4 Exercises"],
  Cell[3182801, 72039, 633, 26, 117, "ExerciseItem",
   CellTags->"9.4 Exercises"],
  Cell[3183459, 72069, 2830, 79, 258, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:66"}],
  Cell[3186292, 72150, 374, 9, 136, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3186703, 72164, 1079, 27, 265, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:68"}],
  Cell[3187785, 72193, 692, 12, 654, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3188492, 72208, 601, 15, 217, "ExerciseItem",
   CellTags->{"i:69", "9.4 Exercises"}],
  Cell[3189118, 72227, 890, 22, 306, "ExerciseItem",
   CellTags->{"i:70", "9.4 Exercises"}],
  Cell[3190033, 72253, 347, 9, 136, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3190383, 72264, 391, 7, 121, "ExerciseOutput",
   CellTags->"9.4 Exercises"],
  Cell[3190789, 72274, 289, 6, 126, "ExerciseText",
   CellTags->"9.4 Exercises"],
  Cell[3191081, 72282, 295, 8, 136, "ExerciseInput",
   CellTags->"9.4 Exercises"],
  Cell[3191391, 72293, 211, 5, 123, "ExerciseItem",
   CellTags->"9.4 Exercises"]},
 "i:65"->{
  Cell[3181776, 71999, 608, 22, 171, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:65"}]},
 "i:66"->{
  Cell[3183459, 72069, 2830, 79, 258, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:66"}]},
 "i:68"->{
  Cell[3186703, 72164, 1079, 27, 265, "ExerciseItem",
   CellTags->{"9.4 Exercises", "i:68"}],
  Cell[6330048, 154422, 1034, 37, 114, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:68"}]},
 "i:69"->{
  Cell[3188492, 72208, 601, 15, 217, "ExerciseItem",
   CellTags->{"i:69", "9.4 Exercises"}],
  Cell[6332136, 154505, 907, 37, 81, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:69"}]},
 "9.4 Solutions"->{
  Cell[3191691, 72306, 459, 13, 172, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3192153, 72321, 156, 5, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3192334, 72330, 181, 5, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3192518, 72337, 214, 5, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3192781, 72348, 80, 1, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3192864, 72351, 235, 7, 123, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3193102, 72360, 637, 17, 220, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3193764, 72381, 272, 7, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3194039, 72390, 172, 4, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3194260, 72400, 622, 19, 220, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3194885, 72421, 393, 11, 177, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3195303, 72436, 97, 2, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3195403, 72440, 68, 1, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3195486, 72444, 94, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3195583, 72447, 391, 10, 180, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3195999, 72461, 96, 2, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3196098, 72465, 67, 1, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3196214, 72472, 156, 4, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3196395, 72480, 223, 5, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3196621, 72487, 305, 6, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3196963, 72498, 334, 9, 141, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3197300, 72509, 305, 6, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3197654, 72521, 110, 2, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3197767, 72525, 352, 9, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3198122, 72536, 141, 4, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3198266, 72542, 1665, 43, 486, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3199956, 72589, 125, 3, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3200084, 72594, 307, 6, 121, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3200406, 72603, 88, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3200519, 72608, 196, 6, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3200718, 72616, 126, 3, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3200893, 72625, 605, 16, 220, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3201501, 72643, 670, 12, 654, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3202174, 72657, 446, 11, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3202657, 72673, 215, 7, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3202875, 72682, 228, 7, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3203106, 72691, 426, 11, 118, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3203557, 72706, 162, 4, 90, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3203722, 72712, 58, 1, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3203795, 72716, 324, 6, 168, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3204122, 72724, 407, 11, 123, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3204554, 72739, 148, 4, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3204705, 72745, 269, 4, 225, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3204989, 72752, 91, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3205105, 72757, 327, 10, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3205435, 72769, 413, 10, 261, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3205863, 72782, 121, 3, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3205987, 72787, 234, 7, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3206224, 72796, 139, 4, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3206366, 72802, 237, 7, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3206606, 72811, 139, 4, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3206770, 72819, 101, 2, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3206874, 72823, 21425, 659, 472, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3228314, 73485, 101, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3228440, 73490, 292, 9, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3228735, 73501, 1434, 20, 1207, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3230218, 73527, 86, 1, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3230307, 73530, 270, 7, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3230580, 73539, 210, 4, 118, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3230815, 73547, 249, 7, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3231067, 73556, 187, 4, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3231269, 73563, 224, 7, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3231518, 73574, 128, 3, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3231649, 73579, 139, 3, 73, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3231803, 73585, 436, 17, 118, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3232264, 73606, 350, 10, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3232617, 73618, 124, 3, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3232756, 73624, 861, 23, 333, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3233620, 73649, 229, 7, 69, "InputOnly",
   CellTags->"9.4 Solutions"],
  Cell[3233874, 73660, 160, 4, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3234037, 73666, 126, 3, 67, "Output",
   CellTags->"9.4 Solutions"],
  Cell[3234212, 73675, 124, 3, 67, "SolutionItem",
   CellTags->"9.4 Solutions"],
  Cell[3234339, 73680, 225, 7, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3234567, 73689, 81, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3234651, 73692, 350, 10, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3235004, 73704, 69, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3235076, 73707, 208, 6, 82, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3235287, 73715, 70, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3235360, 73718, 257, 7, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3235620, 73727, 101, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3235724, 73730, 1108, 30, 450, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3236835, 73762, 232, 5, 136, "Input",
   CellTags->"9.4 Solutions"],
  Cell[3237070, 73769, 84, 1, 67, "SolutionText",
   CellTags->"9.4 Solutions"],
  Cell[3237157, 73772, 321, 10, 82, "Input",
   CellTags->"9.4 Solutions"]},
 "9.5 Exercises"->{
  Cell[3237619, 73793, 412, 9, 171, "ExerciseItem",
   CellTags->{"9.5 Exercises", "i:90"}],
  Cell[3238056, 73806, 374, 11, 82, "ExerciseInput",
   CellTags->"9.5 Exercises"],
  Cell[3238433, 73819, 115, 1, 67, "ExerciseOutput",
   CellTags->"9.5 Exercises"],
  Cell[3238585, 73825, 423, 13, 82, "ExerciseInput",
   CellTags->"9.5 Exercises"],
  Cell[3239011, 73840, 246, 5, 67, "ExerciseOutput",
   CellTags->"9.5 Exercises"],
  Cell[3239294, 73850, 400, 13, 82, "ExerciseInput",
   CellTags->"9.5 Exercises"],
  Cell[3239697, 73865, 262, 6, 126, "Message",
   CellTags->"9.5 Exercises"],
  Cell[3239986, 73875, 886, 26, 217, "ExerciseItem",
   CellTags->{"9.5 Exercises", "Ex.Anagrams", "i:91"}],
  Cell[3240875, 73903, 228, 6, 117, "ExerciseItem",
   CellTags->"9.5 Exercises"],
  Cell[3241106, 73911, 401, 10, 117, "ExerciseItem",
   CellTags->{"i:92", "9.5 Exercises"}],
  Cell[3241510, 73923, 506, 15, 163, "ExerciseItem",
   CellTags->"9.5 Exercises"],
  Cell[3242019, 73940, 1879, 66, 262, "ExerciseItem",
   CellTags->"9.5 Exercises"]},
 "Ex.Anagrams"->{
  Cell[3239986, 73875, 886, 26, 217, "ExerciseItem",
   CellTags->{"9.5 Exercises", "Ex.Anagrams", "i:91"}]},
 "9.5 Solutions"->{
  Cell[3243987, 74014, 149, 4, 67, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3244139, 74020, 104, 2, 69, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3244246, 74024, 227, 7, 69, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3244476, 74033, 309, 7, 175, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3244788, 74042, 1638, 40, 436, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3246429, 74084, 2016, 49, 436, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3248470, 74137, 219, 6, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3248692, 74145, 64, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3248793, 74151, 296, 8, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3249092, 74161, 73, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3249202, 74167, 367, 9, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3249572, 74178, 193, 4, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3249802, 74187, 642, 14, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3250447, 74203, 193, 4, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3250677, 74212, 348, 10, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3251028, 74224, 262, 6, 126, "Message",
   CellTags->"9.5 Solutions"],
  Cell[3251339, 74236, 274, 5, 118, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3251616, 74243, 513, 15, 193, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3252154, 74262, 136, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3252293, 74268, 277, 7, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3252585, 74278, 181, 4, 118, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3252769, 74284, 913, 26, 244, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3253707, 74314, 136, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3253846, 74320, 277, 7, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3254138, 74330, 303, 6, 168, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3254444, 74338, 953, 26, 294, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3255422, 74368, 136, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3255561, 74374, 278, 7, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3255888, 74387, 331, 9, 118, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3256244, 74400, 167, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3256414, 74406, 149, 4, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3256578, 74413, 476, 12, 168, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3257057, 74427, 229, 7, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3257289, 74436, 1670, 38, 747, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3258984, 74478, 111, 2, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3259098, 74482, 149, 4, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3259284, 74491, 185, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3259472, 74497, 311, 6, 121, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3259820, 74508, 188, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3260011, 74514, 761, 13, 276, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3260809, 74532, 192, 5, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3261004, 74539, 1035, 16, 328, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3262088, 74561, 89, 1, 67, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3262180, 74564, 228, 7, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3262411, 74573, 174, 5, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3262588, 74580, 96, 2, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3262687, 74584, 174, 5, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3262864, 74591, 345, 14, 118, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3263212, 74607, 291, 7, 189, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3263506, 74616, 118, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3263627, 74621, 135, 3, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3263765, 74626, 333, 10, 136, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3264101, 74638, 118, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3264222, 74643, 113, 2, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3264338, 74647, 773, 23, 343, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3265148, 74675, 98, 1, 67, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3265249, 74678, 407, 11, 190, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3265659, 74691, 243, 8, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3265905, 74701, 104, 2, 69, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3266012, 74705, 337, 10, 126, "InputOnly",
   CellTags->"9.5 Solutions"],
  Cell[3266374, 74719, 258, 8, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3266635, 74729, 83, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3266733, 74733, 404, 12, 118, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3267162, 74749, 170, 4, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3267335, 74755, 228, 5, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3267612, 74766, 163, 4, 67, "SolutionItem",
   CellTags->"9.5 Solutions"],
  Cell[3267800, 74774, 417, 12, 189, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3268220, 74788, 2031, 55, 172, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3270266, 74846, 107, 1, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3270376, 74849, 352, 11, 141, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3270753, 74864, 127, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3270883, 74869, 64, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3270962, 74873, 298, 6, 118, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3271263, 74881, 400, 11, 190, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3271666, 74894, 107, 1, 67, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3271776, 74897, 276, 8, 87, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3272077, 74909, 141, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3272221, 74914, 82, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3272340, 74920, 115, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3272458, 74925, 82, 1, 67, "Output",
   CellTags->"9.5 Solutions"],
  Cell[3272555, 74929, 189, 4, 118, "SolutionText",
   CellTags->"9.5 Solutions"],
  Cell[3272747, 74935, 440, 12, 190, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3273212, 74951, 141, 3, 82, "Input",
   CellTags->"9.5 Solutions"],
  Cell[3273356, 74956, 82, 1, 67, "Output",
   CellTags->"9.5 Solutions"]},
 "10.1 Exercises"->{
  Cell[3274456, 74993, 279, 9, 76, "ExerciseItem",
   CellTags->{"10.1 Exercises", "i:38"}],
  Cell[3274738, 75004, 198, 4, 117, "ExerciseItem",
   CellTags->"10.1 Exercises"],
  Cell[3274939, 75010, 331, 9, 117, "ExerciseItem",
   CellTags->"10.1 Exercises"],
  Cell[3275273, 75021, 397, 11, 117, "ExerciseItem",
   CellTags->"10.1 Exercises"],
  Cell[3275673, 75034, 509, 16, 163, "ExerciseItem",
   CellTags->"10.1 Exercises"],
  Cell[3276207, 75054, 1304, 42, 163, "ExerciseItem",
   CellTags->"10.1 Exercises"],
  Cell[3277514, 75098, 897, 30, 139, "ExerciseDisplayFormula",
   CellTags->"10.1 Exercises"],
  Cell[3278414, 75130, 337, 8, 126, "ExerciseText",
   CellTags->"10.1 Exercises"],
  Cell[3278766, 75141, 468, 13, 123, "ExerciseItem",
   CellTags->{"Sinplot exercise", "10.1 Exercises"}],
  Cell[3279259, 75158, 702, 21, 163, "ExerciseItem",
   CellTags->{"Ex.StandardDeviation", "i:39", "10.1 Exercises"}],
  Cell[3279964, 75181, 16096, 282, 580, "Figure",
   CellTags->"10.1 Exercises"],
  Cell[3296075, 75466, 326, 10, 76, "ExerciseItem",
   CellTags->{"i:41", "10.1 Exercises"}],
  Cell[3296404, 75478, 641, 15, 211, "ExerciseItem",
   CellTags->{"10.1 Exercises", "i:40"}]},
 "Sinplot exercise"->{
  Cell[3278766, 75141, 468, 13, 123, "ExerciseItem",
   CellTags->{"Sinplot exercise", "10.1 Exercises"}]},
 "Ex.StandardDeviation"->{
  Cell[3279259, 75158, 702, 21, 163, "ExerciseItem",
   CellTags->{"Ex.StandardDeviation", "i:39", "10.1 Exercises"}]},
 "10.1 Solutions"->{
  Cell[3297134, 75501, 531, 17, 118, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3297668, 75520, 832, 26, 243, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3298503, 75548, 158, 5, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3298686, 75557, 119, 3, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3298808, 75562, 101224, 3076, 240, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3400081, 78644, 125, 3, 67, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3400209, 78649, 211, 7, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3400423, 78658, 652, 19, 234, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3401078, 78679, 135, 3, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3401216, 78684, 472, 17, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3401691, 78703, 489, 13, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3402183, 78718, 85, 1, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3402271, 78721, 631, 22, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3402905, 78745, 519, 15, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3403427, 78762, 130, 3, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3403560, 78767, 206, 6, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3403803, 78778, 306, 8, 118, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3404134, 78790, 229, 7, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3404366, 78799, 426, 13, 121, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3404807, 78815, 310, 8, 118, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3405120, 78825, 292, 10, 69, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3405437, 78839, 183, 6, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3405623, 78847, 611, 11, 324, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3406283, 78864, 156, 4, 67, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3406464, 78872, 471, 14, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3406938, 78888, 200, 6, 364, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3407153, 78897, 333, 10, 118, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3407511, 78911, 714, 23, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3408228, 78936, 467, 9, 325, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3408710, 78948, 153, 4, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3408888, 78956, 694, 20, 240, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3409585, 78978, 1658, 34, 580, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3411292, 79018, 348, 12, 118, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3411643, 79032, 320, 9, 123, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3411966, 79043, 161, 4, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3412130, 79049, 220, 6, 69, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3412353, 79057, 311, 9, 118, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3412667, 79068, 206, 6, 69, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3412876, 79076, 189, 6, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3413068, 79084, 287, 9, 69, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3413358, 79095, 77, 1, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3413460, 79100, 92, 2, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3413555, 79104, 72639, 1004, 388, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3486243, 80114, 272, 10, 67, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3486518, 80126, 124, 3, 69, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3486667, 80133, 756, 25, 103, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3487426, 80160, 2019, 66, 469, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3489460, 80229, 306, 12, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3489791, 80245, 970, 27, 240, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3490764, 80274, 554, 21, 90, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3491333, 80298, 172, 6, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3491530, 80308, 198, 6, 87, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3491731, 80316, 296, 11, 90, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3492042, 80330, 280, 7, 118, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3492325, 80339, 226, 8, 117, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3492554, 80349, 125, 3, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3492682, 80354, 231, 9, 154, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3492938, 80367, 512, 17, 136, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3493453, 80386, 322, 7, 364, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3493790, 80396, 671, 20, 220, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3494464, 80418, 753, 27, 123, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3495242, 80449, 226, 6, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3495471, 80457, 384, 9, 364, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3495904, 80472, 89, 1, 67, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3496018, 80477, 263, 8, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3496284, 80487, 9397, 161, 301, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3505696, 80651, 102, 1, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3505823, 80656, 336, 10, 87, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3506162, 80668, 378, 11, 123, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3506555, 80682, 96, 1, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3506676, 80687, 466, 16, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3507145, 80705, 536, 16, 123, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3507696, 80724, 84, 1, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3507805, 80729, 252, 8, 82, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3508060, 80739, 48117, 998, 301, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3556226, 81743, 132, 3, 67, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3556361, 81748, 444, 12, 189, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3556808, 81762, 185, 4, 118, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3557018, 81770, 3589, 101, 499, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3560610, 81873, 16224, 283, 288, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3576849, 82159, 156, 4, 67, "SolutionText",
   CellTags->"10.1 Solutions"],
  Cell[3577008, 82165, 1039, 31, 190, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3578072, 82200, 1848, 51, 343, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3579923, 82253, 16262, 284, 288, "Output",
   CellTags->"10.1 Solutions"],
  Cell[3596234, 82543, 456, 17, 118, "SolutionItem",
   CellTags->"10.1 Solutions"],
  Cell[3596693, 82562, 652, 18, 177, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3597348, 82582, 285, 9, 123, "InputOnly",
   CellTags->"10.1 Solutions"],
  Cell[3597658, 82595, 462, 12, 189, "Input",
   CellTags->"10.1 Solutions"],
  Cell[3598123, 82609, 22512, 374, 397, "Output",
   CellTags->"10.1 Solutions"]},
 "10.2 Exercises"->{
  Cell[3620783, 82995, 118, 1, 76, "ExerciseItem",
   CellTags->{"10.2 Exercises", "i:50"}],
  Cell[3620904, 82998, 12751, 214, 366, "Picture",
   CellTags->"10.2 Exercises"],
  Cell[3633658, 83214, 485, 14, 126, "ExerciseText",
   CellTags->{"10.2 Exercises", "i:51"}],
  Cell[3634180, 83233, 295, 7, 127, "ExerciseItem",
   CellTags->{"10.2 Exercises", "i:52"}],
  Cell[3634478, 83242, 1899, 37, 607, "Picture",
   CellTags->"10.2 Exercises"],
  Cell[3636414, 83284, 1241, 25, 432, "ExerciseItem",
   CellTags->{"10.2 Exercises", "Ex.Convex hull", "i:53"}],
  Cell[3637658, 83311, 259, 8, 82, "ExerciseInput",
   CellTags->"10.2 Exercises"],
  Cell[3637920, 83321, 141, 3, 82, "ExerciseInput",
   CellTags->"10.2 Exercises"],
  Cell[3638086, 83328, 116, 2, 82, "ExerciseInput",
   CellTags->"10.2 Exercises"],
  Cell[3638205, 83332, 214, 5, 67, "ExerciseOutput",
   CellTags->"10.2 Exercises"],
  Cell[3638456, 83342, 120, 2, 82, "ExerciseInput",
   CellTags->"10.2 Exercises"],
  Cell[3638579, 83346, 5033, 117, 427, "ExerciseOutput",
   CellTags->"10.2 Exercises"],
  Cell[3643639, 83467, 3289, 84, 307, "ExerciseItem",
   CellTags->{"i:54", "10.2 Exercises"}]},
 "i:50"->{
  Cell[3620783, 82995, 118, 1, 76, "ExerciseItem",
   CellTags->{"10.2 Exercises", "i:50"}]},
 "Ex.Convex hull"->{
  Cell[3636414, 83284, 1241, 25, 432, "ExerciseItem",
   CellTags->{"10.2 Exercises", "Ex.Convex hull", "i:53"}]},
 "i:53"->{
  Cell[3636414, 83284, 1241, 25, 432, "ExerciseItem",
   CellTags->{"10.2 Exercises", "Ex.Convex hull", "i:53"}]},
 "10.2 Solutions"->{
  Cell[3647017, 83559, 252, 8, 67, "SolutionItem",
   CellTags->"10.2 Solutions"],
  Cell[3647272, 83569, 521, 17, 130, "InputOnly",
   CellTags->"10.2 Solutions"],
  Cell[3647818, 83590, 334, 10, 136, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3648155, 83602, 574, 12, 321, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3648766, 83619, 1090, 32, 571, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3649859, 83653, 25036, 444, 204, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3674910, 84100, 213, 8, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3675148, 84112, 1030, 31, 483, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3676181, 84145, 23081, 405, 204, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3699277, 84553, 238, 8, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3699540, 84565, 136, 3, 87, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3699679, 84570, 58, 1, 67, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3699752, 84574, 448, 11, 168, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3700203, 84587, 720, 24, 186, "InputOnly",
   CellTags->"10.2 Solutions",
   CellID->141910737],
  Cell[3700948, 84615, 1116, 33, 483, "Input",
   CellTags->"10.2 Solutions",
   CellID->16518451],
  Cell[3702067, 84650, 18182, 347, 204, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3720286, 85002, 136, 3, 87, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3720425, 85007, 57, 1, 67, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3720531, 85014, 366, 9, 118, "SolutionItem",
   CellTags->"10.2 Solutions"],
  Cell[3720922, 85027, 685, 20, 240, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3721610, 85049, 822, 27, 121, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3722447, 85079, 78, 1, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3722528, 85082, 1452, 46, 343, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3723983, 85130, 374, 13, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3724382, 85147, 657, 16, 292, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3725042, 85165, 1959, 28, 393, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3727038, 85198, 133, 3, 87, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3727174, 85203, 58, 1, 67, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3727247, 85207, 249, 8, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3727521, 85219, 545, 14, 292, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3728069, 85235, 1551, 28, 393, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3729657, 85268, 133, 3, 87, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3729793, 85273, 58, 1, 67, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3729900, 85280, 433, 11, 118, "SolutionItem",
   CellTags->"10.2 Solutions"],
  Cell[3730336, 85293, 120, 2, 69, "InputOnly",
   CellTags->"10.2 Solutions"],
  Cell[3730481, 85299, 310, 10, 136, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3730794, 85311, 157, 4, 67, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3730966, 85318, 255, 6, 118, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3731246, 85328, 409, 12, 87, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3731658, 85342, 700, 12, 324, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3732373, 85357, 70, 1, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3732468, 85362, 1162, 33, 294, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3733633, 85397, 4243, 109, 450, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3737891, 85509, 483, 14, 118, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3738377, 85525, 104, 2, 69, "InputOnly",
   CellTags->"10.2 Solutions"],
  Cell[3738484, 85529, 2070, 53, 658, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3740579, 85586, 98, 2, 82, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3740680, 85590, 4243, 109, 450, "Output",
   CellTags->"10.2 Solutions"],
  Cell[3744972, 85705, 148, 4, 67, "SolutionItem",
   CellTags->"10.2 Solutions"],
  Cell[3745123, 85711, 1603, 48, 346, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3746729, 85761, 276, 10, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3747030, 85775, 234, 6, 82, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3747267, 85783, 138428, 2278, 468, 113440, 1866, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"10.2 Solutions"],
  Cell[3885710, 88064, 221, 8, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[3885934, 88074, 281, 8, 123, "InputOnly",
   CellTags->"10.2 Solutions"],
  Cell[3886240, 88086, 411, 11, 189, "Input",
   CellTags->"10.2 Solutions"],
  Cell[3886654, 88099, 140216, 2303, 333, "Output",
   CellTags->"10.2 Solutions"],
  Cell[4026885, 90405, 126, 3, 67, "SolutionText",
   CellTags->"10.2 Solutions"],
  Cell[4027036, 90412, 809, 23, 325, "Input",
   CellTags->"10.2 Solutions"],
  Cell[4027848, 90437, 2030449, 59431, 333, 2009040, 59078, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"10.2 Solutions"]},
 "10.3 Exercises"->{
  Cell[6058408, 149878, 403, 13, 85, "ExerciseItem",
   CellTags->"10.3 Exercises"],
  Cell[6058836, 149895, 297, 9, 81, "ExerciseItem",
   CellTags->"10.3 Exercises"],
  Cell[6059158, 149908, 382, 11, 100, "ExerciseInput",
   CellTags->"10.3 Exercises"],
  Cell[6059543, 149921, 269756, 4474, 147, "ExerciseOutput",
   CellTags->"10.3 Exercises"],
  Cell[6329326, 154399, 105, 1, 51, "ExerciseItem",
   CellTags->"10.3 Exercises"],
  Cell[6329434, 154402, 611, 18, 114, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:67"}],
  Cell[6330048, 154422, 1034, 37, 114, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:68"}],
  Cell[6331085, 154461, 857, 36, 81, "ExerciseItem",
   CellTags->"10.3 Exercises"],
  Cell[6331945, 154499, 188, 4, 81, "ExerciseItem",
   CellTags->"10.3 Exercises"],
  Cell[6332136, 154505, 907, 37, 81, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:69"}],
  Cell[6333068, 154546, 263, 5, 81, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:70"}],
  Cell[6333334, 154553, 500, 18, 45, "ExerciseDisplayFormula",
   CellTags->"10.3 Exercises"],
  Cell[6333837, 154573, 471, 17, 82, "ExerciseText",
   CellTags->"10.3 Exercises"],
  Cell[6334311, 154592, 940, 25, 276, "ExerciseText",
   CellTags->"10.3 Exercises"]},
 "i:67"->{
  Cell[6329434, 154402, 611, 18, 114, "ExerciseItem",
   CellTags->{"10.3 Exercises", "i:67"}]},
 "10.3 Solutions"->{
  Cell[6335352, 154626, 1056, 34, 270, "SolutionItem",
   CellTags->"10.3 Solutions"],
  Cell[6336411, 154662, 246, 8, 144, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6336694, 154675, 564, 16, 168, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 2}},
   CellTags->"10.3 Solutions"],
  Cell[6337261, 154693, 267, 9, 100, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6337565, 154707, 222, 7, 67, "SolutionItem",
   CellTags->"10.3 Solutions"],
  Cell[6337790, 154716, 235, 7, 82, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6338028, 154725, 128, 5, 67, "SolutionText",
   CellTags->"10.3 Solutions"],
  Cell[6338159, 154732, 238, 8, 82, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6338400, 154742, 179, 5, 67, "SolutionText",
   CellTags->"10.3 Solutions"],
  Cell[6338582, 154749, 353, 11, 136, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6338938, 154762, 128, 3, 67, "SolutionText",
   CellTags->"10.3 Solutions"],
  Cell[6339069, 154767, 405, 13, 136, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6339511, 154785, 201, 5, 67, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 4}},
   CellTags->"10.3 Solutions"],
  Cell[6339715, 154792, 404, 13, 130, "InputOnly",
   CellTags->"10.3 Solutions"],
  Cell[6340144, 154809, 236, 7, 82, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6340383, 154818, 61254, 1011, 258, "Output",
   CellTags->"10.3 Solutions"],
  Cell[6401652, 155832, 103, 1, 67, "SolutionText",
   CellTags->"10.3 Solutions"],
  Cell[6401758, 155835, 275, 9, 82, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6402070, 155849, 236, 5, 118, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 7}},
   CellTags->"10.3 Solutions"],
  Cell[6402309, 155856, 392, 12, 130, "InputOnly",
   CellTags->"10.3 Solutions"],
  Cell[6402726, 155872, 238, 7, 82, "Input",
   CellTags->"10.3 Solutions"],
  Cell[6402967, 155881, 58513, 966, 258, "Output",
   CellTags->"10.3 Solutions"],
  Cell[6461495, 156850, 100, 1, 67, "SolutionText",
   CellTags->"10.3 Solutions"],
  Cell[6461598, 156853, 277, 9, 82, "Input",
   CellTags->"10.3 Solutions"]},
 "10.4 Exercises"->{
  Cell[6461994, 156871, 1038, 32, 229, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:112"}],
  Cell[6463035, 156905, 366, 10, 121, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:113"}],
  Cell[6463404, 156917, 712, 25, 171, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6464119, 156944, 272, 7, 121, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6464394, 156953, 511, 10, 222, "ExerciseItem",
   CellTags->{"Ex.SimpleClosedPath", "10.4 Exercises", "i:114"}],
  Cell[6464908, 156965, 400, 13, 121, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6465311, 156980, 495, 9, 222, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6465831, 156993, 550, 14, 171, "ExerciseItem",
   CellTags->{"10.4 Exercises", "Ex.ShowWalk", "i:115"}],
  Cell[6466384, 157009, 103, 2, 82, "Input",
   CellTags->"10.4 Exercises"],
  Cell[6466512, 157015, 354, 10, 136, "Input",
   CellTags->"10.4 Exercises"],
  Cell[6466869, 157027, 2335, 46, 375, "Output",
   CellTags->"10.4 Exercises"],
  Cell[6469241, 157078, 456, 13, 136, "Input",
   CellTags->"10.4 Exercises"],
  Cell[6469700, 157093, 3562, 66, 384, "Output",
   CellTags->"10.4 Exercises"],
  Cell[6473299, 157164, 418, 12, 136, "Input",
   CellTags->"10.4 Exercises"],
  Cell[6473720, 157178, 5999, 101, 423, "Output",
   CellTags->"10.4 Exercises"],
  Cell[6479746, 157283, 957, 33, 177, "ExerciseItem",
   CellTags->{"Ex.Mesh", "i:116", "10.4 Exercises"}],
  Cell[6480706, 157318, 288, 7, 121, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6480997, 157327, 449, 12, 121, "ExerciseItem",
   CellTags->{"Ex.PointInPolygon", "10.4 Exercises"}],
  Cell[6481449, 157341, 556, 13, 189, "ExerciseItem",
   CellTags->{"10.4 Exercises", "i:117"}],
  Cell[6482008, 157356, 989, 36, 240, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6483000, 157394, 411, 16, 87, "ExerciseItem",
   CellTags->"10.4 Exercises"],
  Cell[6483414, 157412, 1103, 32, 330, "ExerciseItem",
   CellTags->"10.4 Exercises"]},
 "Ex.SimpleClosedPath"->{
  Cell[6464394, 156953, 511, 10, 222, "ExerciseItem",
   CellTags->{"Ex.SimpleClosedPath", "10.4 Exercises", "i:114"}]},
 "Ex.ShowWalk"->{
  Cell[6465831, 156993, 550, 14, 171, "ExerciseItem",
   CellTags->{"10.4 Exercises", "Ex.ShowWalk", "i:115"}]},
 "Ex.Mesh"->{
  Cell[6479746, 157283, 957, 33, 177, "ExerciseItem",
   CellTags->{"Ex.Mesh", "i:116", "10.4 Exercises"}]},
 "Ex.PointInPolygon"->{
  Cell[6480997, 157327, 449, 12, 121, "ExerciseItem",
   CellTags->{"Ex.PointInPolygon", "10.4 Exercises"}]},
 "10.4 Solutions"->{
  Cell[6484606, 157452, 515, 14, 168, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[6485124, 157468, 191, 5, 69, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6485318, 157475, 1055, 31, 294, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6486376, 157508, 280, 9, 67, "SolutionText",
   CellTags->"10.4 Solutions"],
  Cell[6486681, 157521, 460, 15, 136, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6487144, 157538, 648, 19, 330, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6487841, 157563, 287, 7, 118, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[6488131, 157572, 480, 13, 177, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6488636, 157589, 240, 6, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6488879, 157597, 1411, 33, 411, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6490339, 157636, 89, 1, 67, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[6490431, 157639, 310, 9, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6490744, 157650, 723, 22, 168, "SolutionText",
   CellTags->"10.4 Solutions"],
  Cell[6491470, 157674, 1173, 33, 334, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6492646, 157709, 308, 9, 123, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6492979, 157722, 216, 5, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6493198, 157729, 1202, 21, 334, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6494449, 157756, 1089, 28, 321, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 4}},
   CellTags->"10.4 Solutions"],
  Cell[6495541, 157786, 1267, 36, 283, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6496811, 157824, 219, 7, 69, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6497033, 157833, 467, 13, 177, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6497525, 157850, 136, 3, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6497664, 157855, 1873, 35, 337, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6499586, 157896, 248, 8, 67, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[6499837, 157906, 1235, 36, 297, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6501075, 157944, 215, 7, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6501293, 157953, 136, 3, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6501466, 157961, 354, 8, 118, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 7}},
   CellTags->"10.4 Solutions"],
  Cell[6501845, 157973, 200, 6, 87, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6502048, 157981, 60, 1, 67, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6502145, 157987, 427, 15, 87, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6502575, 158004, 60, 1, 67, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6502672, 158010, 470, 16, 87, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6503145, 158028, 60, 1, 67, "Output",
   CellTags->"10.4 Solutions"],
  Cell[6503220, 158032, 142, 4, 67, "SolutionText",
   CellTags->"10.4 Solutions"],
  Cell[6503365, 158038, 501, 15, 190, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6503869, 158055, 157, 4, 67, "SolutionText",
   CellTags->"10.4 Solutions"],
  Cell[6504029, 158061, 797, 24, 294, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6504829, 158087, 148, 4, 67, "SolutionText",
   CellTags->"10.4 Solutions"],
  Cell[6504980, 158093, 747, 23, 243, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6505764, 158121, 529, 18, 118, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[6506296, 158141, 508, 18, 127, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[6506829, 158163, 1073, 33, 189, "Input",
   CellTags->"10.4 Solutions"],
  Cell[6507905, 158198, 577655, 9493, 324, 549947, 9037, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"10.4 Solutions"],
  Cell[7085609, 167697, 278, 8, 118, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[7085890, 167707, 268, 9, 94, "Program",
   CellTags->"10.4 Solutions"],
  Cell[7086161, 167718, 102, 2, 69, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7086266, 167722, 245, 6, 175, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7086514, 167730, 241, 6, 175, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7086758, 167738, 331, 10, 123, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7087092, 167750, 4262, 116, 1216, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7091357, 167868, 280, 8, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7091640, 167878, 629, 16, 240, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7092306, 167899, 400, 14, 118, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[7092709, 167915, 990, 34, 175, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7093702, 167951, 435, 14, 126, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7094140, 167967, 2522, 78, 496, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7096687, 168049, 1633, 48, 555, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7098323, 168099, 215440, 3540, 828, 155755, 2559, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"10.4 Solutions"],
  Cell[7313812, 171645, 108, 1, 67, "SolutionItem",
   CellTags->"10.4 Solutions"],
  Cell[7313923, 171648, 238, 7, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7314164, 171657, 1101, 31, 292, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7315302, 171693, 154, 3, 67, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 13}},
   CellTags->"10.4 Solutions"],
  Cell[7315459, 171698, 214, 6, 82, "Input",
   CellTags->"10.4 Solutions"],
  Cell[7315676, 171706, 1862, 52, 438, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7317541, 171760, 175, 5, 69, "InputOnly",
   CellTags->"10.4 Solutions"],
  Cell[7317719, 171767, 437, 12, 189, "Input",
   CellTags->"10.4 Solutions"]},
 "11.1 Exercises"->{
  Cell[7319180, 171816, 199, 4, 85, "ExerciseItem",
   CellTags->{"11.1 Exercises", "i:26"}],
  Cell[7319404, 171824, 135, 3, 55, "ExerciseInput",
   CellTags->"11.1 Exercises"],
  Cell[7319542, 171829, 672, 12, 148, "ExerciseOutput",
   CellTags->"11.1 Exercises"],
  Cell[7320229, 171844, 265, 8, 49, "ExerciseText",
   CellTags->"11.1 Exercises"],
  Cell[7320519, 171856, 365, 10, 94, "ExerciseInput",
   CellTags->"11.1 Exercises"],
  Cell[7320887, 171868, 332, 6, 81, "ExerciseOutput",
   CellTags->"11.1 Exercises"],
  Cell[7321246, 171878, 742, 23, 118, "ExerciseItem",
   CellTags->{"i:27", "11.1 Exercises"}],
  Cell[7322013, 171905, 351, 9, 81, "ExerciseItem",
   CellTags->{"i:28", "11.1 Exercises"}],
  Cell[7322367, 171916, 4913, 102, 492, "Figure",
   CellTags->"11.1 Exercises"],
  Cell[7327317, 172023, 357, 6, 118, "ExerciseItem",
   CellTags->{"i:29", "11.1 Exercises"}],
  Cell[7327677, 172031, 237, 6, 55, "ExerciseInput",
   CellTags->"11.1 Exercises"],
  Cell[7327939, 172041, 143, 3, 55, "ExerciseInput",
   CellTags->"11.1 Exercises"],
  Cell[7328085, 172046, 375, 9, 81, "ExerciseOutput",
   CellTags->"11.1 Exercises"],
  Cell[7328487, 172059, 357, 8, 85, "ExerciseItem",
   CellTags->{"Ex.Random walk animate", "i:30", "11.1 Exercises"}],
  Cell[7328869, 172071, 370, 12, 81, "ExerciseItem",
   CellTags->{"i:31", "11.1 Exercises"}],
  Cell[7329242, 172085, 2317, 51, 333, "Picture",
   CellTags->"11.1 Exercises"],
  Cell[7331574, 172139, 405, 10, 85, "ExerciseItem",
   CellTags->{"Ex.Hypocycloid", "11.1 Exercises"}],
  Cell[7332004, 172153, 415, 9, 114, "ExerciseItem",
   CellTags->{"Ex.Epicycloids", "i:32", "11.1 Exercises"}],
  Cell[7332422, 172164, 1014, 36, 127, "ExerciseText",
   CellTags->"11.1 Exercises"],
  Cell[7333439, 172202, 168, 4, 49, "ExerciseText",
   CellTags->"11.1 Exercises"],
  Cell[7333622, 172209, 1752, 43, 153, "ExerciseItem",
   CellTags->{"i:33", "11.1 Exercises"}],
  Cell[7335377, 172254, 265, 5, 81, "ExerciseItem",
   CellTags->{"i:34", "11.1 Exercises"}],
  Cell[7335645, 172261, 436, 10, 114, "ExerciseItem",
   CellTags->{"i:35", "11.1 Exercises"}],
  Cell[7336106, 172275, 481, 8, 148, "ExerciseItem",
   CellTags->{"i:36", "11.1 Exercises"}],
  Cell[7336590, 172285, 2451, 49, 375, "Picture",
   CellTags->"11.1 Exercises"],
  Cell[7339056, 172337, 575, 16, 118, "ExerciseItem",
   CellTags->{"i:37", "11.1 Exercises"}]},
 "i:28"->{
  Cell[7322013, 171905, 351, 9, 81, "ExerciseItem",
   CellTags->{"i:28", "11.1 Exercises"}],
  Cell[7526092, 176274, 644, 20, 114, "ExerciseItem",
   CellTags->{"i:28", "12.2 Exercises"}]},
 "i:29"->{
  Cell[7327317, 172023, 357, 6, 118, "ExerciseItem",
   CellTags->{"i:29", "11.1 Exercises"}]},
 "Ex.Random walk animate"->{
  Cell[7328487, 172059, 357, 8, 85, "ExerciseItem",
   CellTags->{"Ex.Random walk animate", "i:30", "11.1 Exercises"}]},
 "Ex.Hypocycloid"->{
  Cell[7331574, 172139, 405, 10, 85, "ExerciseItem",
   CellTags->{"Ex.Hypocycloid", "11.1 Exercises"}]},
 "Ex.Epicycloids"->{
  Cell[7332004, 172153, 415, 9, 114, "ExerciseItem",
   CellTags->{"Ex.Epicycloids", "i:32", "11.1 Exercises"}]},
 "11.1 Solutions"->{
  Cell[7339720, 172361, 682, 19, 147, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7340405, 172382, 657, 17, 118, "InputOnly",
   CellTags->"11.1 Solutions"],
  Cell[7341065, 172401, 109, 2, 55, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7341177, 172405, 982, 26, 264, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7342196, 172436, 311, 9, 78, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7342510, 172447, 125630, 2069, 367, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7468177, 174521, 223, 9, 45, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7468403, 174532, 2629, 75, 369, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7471035, 174609, 248, 8, 45, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7471286, 174619, 3512, 100, 585, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7474835, 174724, 537, 18, 78, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7475375, 174744, 215, 6, 55, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7475593, 174752, 1028, 25, 298, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7476658, 174782, 167, 4, 45, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7476828, 174788, 89, 2, 55, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7476920, 174792, 145, 5, 45, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7477068, 174799, 258, 7, 55, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7477329, 174808, 374, 10, 78, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7477706, 174820, 401, 12, 126, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7478110, 174834, 677, 22, 112, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7478790, 174858, 1268, 36, 229, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7480095, 174899, 316, 9, 78, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7480414, 174910, 1887, 50, 264, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7482338, 174965, 476, 14, 78, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 7}},
   CellTags->"11.1 Solutions"],
  Cell[7482817, 174981, 4236, 114, 601, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7487056, 175097, 82, 1, 45, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7487141, 175100, 152, 4, 55, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7487296, 175106, 85, 1, 45, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7487384, 175109, 901, 26, 160, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7488322, 175140, 169, 4, 45, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7488494, 175146, 961, 26, 229, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7489492, 175177, 1276, 40, 147, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7490771, 175219, 2847, 69, 643, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7493655, 175293, 305, 8, 78, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7493963, 175303, 1214, 33, 229, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7495214, 175341, 385, 13, 45, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7495602, 175356, 2143, 62, 367, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7497782, 175423, 221, 8, 45, "SolutionItem",
   CellTags->"11.1 Solutions"],
  Cell[7498006, 175433, 928, 24, 264, "Input",
   CellTags->"11.1 Solutions"],
  Cell[7498937, 175459, 878, 28, 112, "SolutionText",
   CellTags->"11.1 Solutions"],
  Cell[7499818, 175489, 1164, 29, 298, "Input",
   CellTags->"11.1 Solutions"]},
 "11.2 Exercises"->{
  Cell[7501112, 175527, 291, 8, 51, "ExerciseItem",
   CellTags->{"11.2 Exercises", "i:55"}],
  Cell[7501406, 175537, 145, 4, 45, "ExerciseItem",
   CellTags->"11.2 Exercises"],
  Cell[7501554, 175543, 136, 3, 45, "ExerciseItem",
   CellTags->"11.2 Exercises"]},
 "11.2 Solutions"->{
  Cell[7501779, 175554, 350, 13, 45, "SolutionItem",
   CellTags->"11.2 Solutions"],
  Cell[7502132, 175569, 235, 6, 55, "Input",
   CellTags->"11.2 Solutions"],
  Cell[7502404, 175580, 242, 7, 45, "SolutionItem",
   CellTags->"11.2 Solutions"],
  Cell[7502649, 175589, 659, 19, 160, "Input",
   CellTags->"11.2 Solutions"]},
 "11.3 Exercises"->{
  Cell[7503449, 175619, 210, 4, 85, "ExerciseItem",
   CellTags->{"11.3 Exercises", "i:71"}],
  Cell[7503662, 175625, 337, 9, 127, "ExerciseInput",
   CellTags->"11.3 Exercises"],
  Cell[7504024, 175638, 134, 3, 55, "ExerciseInput",
   CellTags->"11.3 Exercises"],
  Cell[7504161, 175643, 1003, 20, 222, "ExerciseOutput",
   CellTags->"11.3 Exercises"],
  Cell[7505179, 175666, 435, 11, 117, "ExerciseText",
   CellTags->"11.3 Exercises"],
  Cell[7505629, 175680, 472, 13, 118, "ExerciseItem",
   CellTags->"11.3 Exercises"],
  Cell[7506104, 175695, 489, 11, 114, "ExerciseItem",
   CellTags->{"i:72", "11.3 Exercises"}],
  Cell[7506596, 175708, 1187, 26, 216, "ExerciseItem",
   CellTags->"11.3 Exercises"]},
 "11.3 Solutions"->{
  Cell[7507872, 175742, 149, 4, 45, "SolutionItem",
   CellTags->"11.3 Solutions"],
  Cell[7508024, 175748, 425, 12, 118, "InputOnly",
   CellTags->"11.3 Solutions"],
  Cell[7508452, 175762, 179, 6, 55, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7508634, 175770, 390, 12, 93, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7509027, 175784, 493, 15, 118, "InputOnly",
   CellTags->"11.3 Solutions"],
  Cell[7509523, 175801, 711, 22, 121, "InputOnly",
   CellTags->"11.3 Solutions"],
  Cell[7510237, 175825, 691, 25, 117, "InputOnly",
   CellTags->"11.3 Solutions"],
  Cell[7510931, 175852, 788, 23, 196, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7511722, 175877, 1343, 38, 300, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7513102, 175920, 525, 16, 78, "SolutionItem",
   CellTags->"11.3 Solutions"],
  Cell[7513630, 175938, 1405, 35, 334, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7515038, 175975, 135, 5, 45, "SolutionText",
   CellTags->"11.3 Solutions"],
  Cell[7515176, 175982, 1499, 38, 369, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7516712, 176025, 291, 8, 45, "SolutionItem",
   CellTags->"11.3 Solutions"],
  Cell[7517006, 176035, 215, 7, 55, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7517224, 176044, 330, 9, 91, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7517557, 176055, 577, 16, 160, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7518137, 176073, 299, 8, 78, "SolutionText",
   CellTags->"11.3 Solutions"],
  Cell[7518439, 176083, 2278, 60, 471, "Input",
   CellTags->"11.3 Solutions"],
  Cell[7520720, 176145, 3720, 66, 112, "SolutionText",
   CellTags->"11.3 Solutions"]},
 "12.2 Exercises"->{
  Cell[7525455, 176249, 137, 2, 67, "ExerciseSubsection",
   CounterAssignments->{{"Section", 1}, {"ExerciseItem", 0}},
   CellTags->"12.2 Exercises"],
  Cell[7525595, 176253, 472, 17, 85, "ExerciseItem",
   CellTags->"12.2 Exercises"],
  Cell[7526092, 176274, 644, 20, 114, "ExerciseItem",
   CellTags->{"i:28", "12.2 Exercises"}],
  Cell[7526761, 176298, 156, 3, 54, "NumberedFigure",
   CellTags->{"12.2 Exercises", "Figure triangular numbers"}],
  Cell[7526920, 176303, 2564, 57, 129, "Figure",
   CellTags->"12.2 Exercises"],
  Cell[7529533, 176366, 709, 19, 153, "ExerciseItem",
   CellTags->{"i:27", "12.2 Exercises"}],
  Cell[7530245, 176387, 392, 11, 93, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7530640, 176400, 275, 8, 58, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7530918, 176410, 244, 8, 69, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7531165, 176420, 244, 8, 69, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7531434, 176432, 183, 4, 55, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7531620, 176438, 149, 4, 45, "ExerciseOutput",
   CellTags->"12.2 Exercises"],
  Cell[7531806, 176447, 183, 4, 55, "ExerciseInput",
   CellTags->"12.2 Exercises"],
  Cell[7531992, 176453, 151, 4, 45, "ExerciseOutput",
   CellTags->"12.2 Exercises"]},
 "Figure triangular numbers"->{
  Cell[7526761, 176298, 156, 3, 54, "NumberedFigure",
   CellTags->{"12.2 Exercises", "Figure triangular numbers"}]},
 "12.2 Solutions"->{
  Cell[7532256, 176467, 325, 9, 45, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 0}},
   CellTags->"12.2 Solutions"],
  Cell[7532584, 176478, 140, 3, 46, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7532727, 176483, 797, 23, 153, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7533549, 176510, 206, 6, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7533758, 176518, 539, 16, 115, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7534346, 176540, 842, 28, 115, "SolutionItem",
   CellTags->"12.2 Solutions"],
  Cell[7535191, 176570, 374, 11, 84, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7535568, 176583, 255, 7, 49, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7535826, 176592, 224, 7, 60, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7536053, 176601, 224, 7, 60, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7536280, 176610, 281, 9, 45, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7536586, 176623, 260, 9, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7536849, 176634, 124, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7537010, 176642, 146, 4, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7537159, 176648, 126, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7537300, 176654, 176, 4, 78, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7537501, 176662, 205, 4, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7537709, 176668, 481, 10, 115, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7538227, 176683, 223, 7, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7538453, 176692, 475, 9, 48, "Message",
   CellTags->"12.2 Solutions"],
  Cell[7538943, 176704, 802, 25, 112, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7539770, 176733, 97, 2, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7539870, 176737, 175, 5, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7540082, 176747, 100, 2, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7540185, 176751, 87, 2, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7540309, 176758, 200, 6, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7540512, 176766, 125, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7540652, 176772, 311, 10, 45, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7540988, 176786, 142, 4, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7541133, 176792, 125, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7541273, 176798, 108, 1, 45, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7541384, 176801, 229, 6, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7541650, 176812, 323, 11, 45, "SolutionItem",
   CellTags->"12.2 Solutions"],
  Cell[7541976, 176825, 192, 5, 49, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7542193, 176834, 215, 6, 55, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7542411, 176842, 1393, 21, 288, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7543841, 176868, 157, 4, 69, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7544001, 176874, 132, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7544148, 176880, 162, 4, 45, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7544313, 176886, 275, 8, 49, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7544613, 176898, 158, 4, 69, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7544774, 176904, 132, 3, 45, "Output",
   CellTags->"12.2 Solutions"],
  Cell[7544921, 176910, 541, 21, 118, "SolutionText",
   CellTags->"12.2 Solutions"],
  Cell[7545465, 176933, 212, 6, 49, "InputOnly",
   CellTags->"12.2 Solutions"],
  Cell[7545702, 176943, 158, 4, 69, "Input",
   CellTags->"12.2 Solutions"],
  Cell[7545863, 176949, 139, 4, 45, "Output",
   CellTags->"12.2 Solutions"]},
 "12.3 Exercises"->{
  Cell[7546075, 176961, 78, 1, 45, "ExerciseSubsection",
   CellTags->"12.3 Exercises"],
  Cell[7546156, 176964, 745, 25, 127, "ExerciseItem",
   CellTags->{"i:47", "12.3 Exercises"}],
  Cell[7546926, 176993, 849, 24, 148, "ExerciseItem",
   CellTags->{"i:48", "12.3 Exercises"}],
  Cell[7547778, 177019, 435, 13, 93, "ExerciseInput",
   CellTags->"12.3 Exercises"],
  Cell[7548216, 177034, 704, 22, 174, "ExerciseInput",
   CellTags->"12.3 Exercises"],
  Cell[7548945, 177060, 205, 5, 55, "ExerciseInput",
   CellTags->"12.3 Exercises"],
  Cell[7549153, 177067, 13255, 222, 283, "ExerciseOutput",
   CellTags->"12.3 Exercises"],
  Cell[7562423, 177292, 142, 4, 49, "ExerciseText",
   CellTags->"12.3 Exercises"]},
 "12.3 Solutions"->{
  Cell[7562666, 177305, 349, 12, 78, "SolutionItem",
   CellTags->"12.3 Solutions"],
  Cell[7563040, 177321, 90, 2, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7563133, 177325, 430, 11, 81, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7563600, 177341, 339, 11, 67, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7563942, 177354, 355, 7, 81, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7564312, 177364, 385, 14, 49, "SolutionText",
   CellTags->"12.3 Solutions"],
  Cell[7564700, 177380, 361, 13, 69, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7565064, 177395, 74, 1, 45, "SolutionText",
   CellTags->"12.3 Solutions"],
  Cell[7565141, 177398, 266, 8, 49, "InputOnly",
   CellTags->"12.3 Solutions"],
  Cell[7565432, 177410, 124, 3, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7565559, 177415, 386, 8, 81, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7565960, 177426, 107, 3, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7566070, 177431, 89, 1, 45, "SolutionText",
   CellTags->"12.3 Solutions"],
  Cell[7566184, 177436, 289, 11, 69, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7566476, 177449, 135, 2, 51, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7566660, 177457, 673, 22, 112, "SolutionItem",
   CellTags->"12.3 Solutions"],
  Cell[7567336, 177481, 417, 13, 84, "InputOnly",
   CellTags->"12.3 Solutions"],
  Cell[7567778, 177498, 90, 2, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7567871, 177502, 430, 11, 81, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7568338, 177518, 112, 2, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7568453, 177522, 112, 4, 45, "Output",
   CellTags->"12.3 Solutions"],
  Cell[7568580, 177529, 706, 22, 147, "InputOnly",
   CellTags->"12.3 Solutions"],
  Cell[7569311, 177555, 179, 5, 55, "Input",
   CellTags->"12.3 Solutions"],
  Cell[7569493, 177562, 221635, 3637, 265, "Output",
   CellTags->"12.3 Solutions"]},
 "12.4 Exercises"->{
  Cell[7791201, 181207, 68, 1, 45, "ExerciseSubsection",
   CellTags->"12.4 Exercises"],
  Cell[7791272, 181210, 849, 25, 153, "ExerciseItem",
   CellTags->"12.4 Exercises"],
  Cell[7792124, 181237, 179, 4, 81, "ExerciseItem",
   CellTags->"12.4 Exercises"],
  Cell[7792328, 181245, 486, 14, 81, "ExerciseItem",
   CellTags->{"i:63", "12.4 Exercises"}],
  Cell[7792817, 181261, 522, 20, 57, "ExerciseDisplayFormula",
   CellTags->{"i:63", "12.4 Exercises"}],
  Cell[7793342, 181283, 389, 13, 82, "ExerciseText",
   CellTags->{"i:63", "12.4 Exercises"}]},
 "i:63"->{
  Cell[7792328, 181245, 486, 14, 81, "ExerciseItem",
   CellTags->{"i:63", "12.4 Exercises"}],
  Cell[7792817, 181261, 522, 20, 57, "ExerciseDisplayFormula",
   CellTags->{"i:63", "12.4 Exercises"}],
  Cell[7793342, 181283, 389, 13, 82, "ExerciseText",
   CellTags->{"i:63", "12.4 Exercises"}]},
 "12.4 Solutions"->{
  Cell[7793832, 181305, 99, 1, 45, "SolutionItem",
   CellTags->"12.4 Solutions"],
  Cell[7793956, 181310, 165, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7794124, 181317, 142, 4, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7794281, 181324, 161, 4, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7794467, 181332, 561, 16, 112, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7795031, 181350, 558, 10, 120, "Message",
   CellTags->"12.4 Solutions"],
  Cell[7795592, 181362, 392, 14, 73, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7795999, 181379, 226, 7, 48, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7796250, 181390, 93, 2, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7796346, 181394, 57, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7796440, 181400, 571, 16, 112, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7797014, 181418, 392, 14, 73, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7797443, 181437, 91, 2, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7797537, 181441, 75, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7797627, 181445, 92, 1, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7797744, 181450, 87, 2, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7797834, 181454, 75, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7797924, 181458, 106, 1, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7798055, 181463, 192, 6, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7798250, 181471, 374, 11, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7798661, 181487, 92, 2, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7798756, 181491, 171, 5, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7798942, 181499, 372, 12, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7799339, 181515, 113, 3, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7799455, 181520, 173, 5, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7799665, 181530, 175, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7799843, 181537, 60, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7799918, 181541, 126, 3, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7800047, 181546, 251, 9, 60, "InputOnly",
   CellTags->"12.4 Solutions"],
  Cell[7800323, 181559, 152, 4, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7800478, 181565, 130, 3, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7800645, 181573, 175, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7800823, 181580, 130, 3, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7800990, 181588, 181, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7801174, 181595, 60, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7801249, 181599, 149, 4, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7801423, 181607, 638, 18, 147, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7802064, 181627, 392, 14, 73, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7802471, 181644, 510, 18, 45, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7803006, 181666, 690, 20, 147, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7803699, 181688, 474, 15, 73, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7804210, 181708, 153, 4, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7804366, 181714, 130, 3, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7804511, 181720, 186, 4, 78, "SolutionText",
   CellTags->"12.4 Solutions"],
  Cell[7804722, 181728, 335, 11, 88, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7805060, 181741, 75, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7805172, 181747, 118, 3, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7805293, 181752, 75, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7805417, 181759, 401, 10, 78, "SolutionItem",
   CellTags->"12.4 Solutions"],
  Cell[7805843, 181773, 651, 18, 147, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7806497, 181793, 387, 14, 73, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7806921, 181812, 169, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7807093, 181819, 416, 9, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7807546, 181833, 95, 2, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7807644, 181837, 174, 5, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7807855, 181847, 178, 5, 55, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7808036, 181854, 60, 1, 45, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7808145, 181861, 377, 14, 45, "SolutionItem",
   CellTags->"12.4 Solutions"],
  Cell[7808547, 181879, 1309, 37, 196, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7809859, 181918, 923, 30, 115, "Output",
   CellTags->"12.4 Solutions"],
  Cell[7810819, 181953, 1006, 31, 276, "Input",
   CellTags->"12.4 Solutions"],
  Cell[7811828, 181986, 2763733, 45311, 265, "Output",
   CellTags->"12.4 Solutions"]},
 "13.1 Exercises"->{
  Cell[10576602, 227335, 340, 6, 118, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:18"}],
  Cell[10576945, 227343, 40991, 601, 264, "Figure",
   CellTags->"13.1 Exercises"],
  Cell[10617939, 227946, 202, 6, 49, "ExerciseText",
   CellTags->"13.1 Exercises"],
  Cell[10618156, 227955, 378, 11, 97, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:19"}],
  Cell[10618537, 227968, 928, 29, 114, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:20"}],
  Cell[10619468, 227999, 1358, 38, 216, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:21"}],
  Cell[10620829, 228039, 194, 4, 81, "ExerciseItem",
   CellTags->"13.1 Exercises"],
  Cell[10621026, 228045, 237, 6, 81, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:22"}],
  Cell[10621266, 228053, 238, 5, 81, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:23"}]},
 "i:19"->{
  Cell[10618156, 227955, 378, 11, 97, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:19"}]},
 "i:20"->{
  Cell[10618537, 227968, 928, 29, 114, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:20"}]},
 "i:23"->{
  Cell[10621266, 228053, 238, 5, 81, "ExerciseItem",
   CellTags->{"13.1 Exercises", "i:23"}]},
 "13.1 Solutions"->{
  Cell[10621593, 228066, 283, 9, 45, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 2}},
   CellTags->"13.1 Solutions"],
  Cell[10621901, 228079, 87, 2, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[10621991, 228083, 963, 18, 126, "Print",
   CellTags->"13.1 Solutions"],
  Cell[10622969, 228104, 523, 13, 112, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[10623495, 228119, 114, 2, 46, "InputOnly",
   CellTags->"13.1 Solutions"],
  Cell[10623634, 228125, 340, 9, 91, "Input",
   CellTags->"13.1 Solutions"],
  Cell[10623977, 228136, 11742, 196, 136, "Output",
   CellTags->"13.1 Solutions"],
  Cell[10635756, 228337, 393, 10, 126, "Input",
   CellTags->"13.1 Solutions"],
  Cell[10636152, 228349, 16949, 281, 204, "Output",
   CellTags->"13.1 Solutions"],
  Cell[10653116, 228633, 318, 10, 78, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[10653437, 228645, 1026, 29, 187, "InputOnly",
   CellTags->"13.1 Solutions"],
  Cell[10654488, 228678, 132, 3, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[10654623, 228683, 9135, 153, 171, "Output",
   CellTags->"13.1 Solutions"],
  Cell[10663795, 228841, 250, 6, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[10664048, 228849, 395401, 6485, 265, "Output",
   CellTags->"13.1 Solutions"],
  Cell[11059464, 235337, 205, 5, 78, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[11059672, 235344, 269, 8, 46, "InputOnly",
   CellTags->"13.1 Solutions"],
  Cell[11059966, 235356, 171, 5, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11060140, 235363, 126, 3, 45, "Output",
   CellTags->"13.1 Solutions"],
  Cell[11060303, 235371, 169, 5, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11060475, 235378, 123, 3, 45, "Output",
   CellTags->"13.1 Solutions"],
  Cell[11060647, 235387, 262, 5, 78, "SolutionItem",
   CellTags->"13.1 Solutions"],
  Cell[11060934, 235396, 158, 4, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11061095, 235402, 614, 21, 45, "Output",
   CellTags->"13.1 Solutions"],
  Cell[11061724, 235426, 281, 10, 45, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[11062030, 235440, 155, 4, 55, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11062188, 235446, 515, 12, 45, "Output",
   CellTags->"13.1 Solutions"],
  Cell[11062718, 235461, 113, 2, 45, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[11062834, 235465, 407, 11, 93, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11063244, 235478, 470, 15, 78, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[11063717, 235495, 93, 2, 46, "InputOnly",
   CellTags->"13.1 Solutions"],
  Cell[11063835, 235501, 434, 13, 126, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11064272, 235516, 488859, 10910, 180, 474632, 10675, "CachedBoxData", 
  "BoxData", "Output",
   CellTags->"13.1 Solutions"],
  Cell[11553146, 246429, 235, 5, 78, "SolutionText",
   CellTags->"13.1 Solutions"],
  Cell[11553384, 246436, 1287, 36, 229, "Input",
   CellTags->"13.1 Solutions"],
  Cell[11554674, 246474, 367, 10, 78, "SolutionText",
   CellTags->"13.1 Solutions"]},
 "13.4 Exercises"->{
  Cell[11555234, 246496, 1982, 73, 220, "ExerciseItem",
   CellTags->{"13.4 Exercises", "i:49"}],
  Cell[11557241, 246573, 585, 20, 76, "ExerciseSubItem",
   CellTags->"13.4 Exercises"],
  Cell[11557851, 246597, 119, 2, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11557973, 246601, 296, 6, 45, "ExerciseOutput",
   CellTags->"13.4 Exercises"],
  Cell[11558318, 246613, 220, 6, 45, "ExerciseSubItem",
   CellTags->"13.4 Exercises"],
  Cell[11558541, 246621, 224, 8, 49, "ExerciseText",
   CellTags->"13.4 Exercises"],
  Cell[11558768, 246631, 226, 8, 49, "ExerciseText",
   CellTags->"13.4 Exercises"],
  Cell[11559009, 246642, 328, 8, 69, "ExerciseSubItem",
   CellTags->"13.4 Exercises"],
  Cell[11559362, 246654, 934, 29, 162, "ExerciseSubItem",
   CellTags->"13.4 Exercises"],
  Cell[11560299, 246685, 121, 3, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11560423, 246690, 107, 2, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11560555, 246696, 109, 2, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11560667, 246700, 362, 5, 126, "Print",
   CellTags->{"13.4 Exercises", "Info3560500981-5226863"}],
  Cell[11561044, 246708, 183, 6, 49, "ExerciseText",
   CellTags->"13.4 Exercises"],
  Cell[11561252, 246718, 137, 3, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11561392, 246723, 271, 6, 48, "Message",
   CellTags->"13.4 Exercises"],
  Cell[11561700, 246734, 142, 3, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11561845, 246739, 508, 10, 48, "Message",
   CellTags->"13.4 Exercises"],
  Cell[11562356, 246751, 143, 3, 45, "ExerciseOutput",
   CellTags->"13.4 Exercises"],
  Cell[11562514, 246757, 148, 5, 49, "ExerciseText",
   CellTags->"13.4 Exercises"],
  Cell[11562687, 246766, 120, 2, 55, "ExerciseInput",
   CellTags->"13.4 Exercises"],
  Cell[11562810, 246770, 1519, 22, 321, "ExerciseOutput",
   CellTags->"13.4 Exercises"],
  Cell[11564368, 246797, 1391, 45, 223, "ExerciseItem",
   CellTags->{"i:48", "13.4 Exercises"}]},
 "i:49"->{
  Cell[11555234, 246496, 1982, 73, 220, "ExerciseItem",
   CellTags->{"13.4 Exercises", "i:49"}]},
 "Info3560500981-5226863"->{
  Cell[11560667, 246700, 362, 5, 126, "Print",
   CellTags->{"13.4 Exercises", "Info3560500981-5226863"}]},
 "13.4 Solutions"->{
  Cell[11565848, 246850, 197, 6, 45, "SolutionItem",
   CounterAssignments->{{"SolutionItem", 0}},
   CellTags->"13.4 Solutions"],
  Cell[11566048, 246858, 169, 5, 49, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11566220, 246865, 187, 6, 49, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11566432, 246875, 213, 7, 45, "SolutionSubItem",
   CellTags->"13.4 Solutions"],
  Cell[11566648, 246884, 262, 7, 49, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11566935, 246895, 97, 2, 55, "Input",
   CellTags->"13.4 Solutions"],
  Cell[11567035, 246899, 274, 6, 45, "Output",
   CellTags->"13.4 Solutions"],
  Cell[11567358, 246911, 269, 8, 78, "SolutionSubItem",
   CellTags->"13.4 Solutions"],
  Cell[11567630, 246921, 308, 7, 151, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11567941, 246930, 219, 5, 78, "SolutionText",
   CellTags->"13.4 Solutions"],
  Cell[11568163, 246937, 224, 6, 117, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11568424, 246948, 270, 9, 78, "SolutionSubItem",
   CellTags->"13.4 Solutions"],
  Cell[11568697, 246959, 586, 17, 118, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11569286, 246978, 344, 8, 112, "SolutionText",
   CellTags->"13.4 Solutions"],
  Cell[11569633, 246988, 441, 14, 118, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11570111, 247007, 679, 23, 147, "SolutionSubItem",
   CellTags->"13.4 Solutions"],
  Cell[11570793, 247032, 85, 2, 46, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11570881, 247036, 138, 4, 46, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11571022, 247042, 308, 7, 151, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11571333, 247051, 224, 6, 117, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11571560, 247059, 549, 19, 147, "SolutionText",
   CellTags->"13.4 Solutions"],
  Cell[11572112, 247080, 125, 3, 46, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11572240, 247085, 169, 5, 49, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11572412, 247092, 187, 6, 49, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11572602, 247100, 586, 17, 118, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11573191, 247119, 441, 14, 118, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11573635, 247135, 102, 3, 46, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11573740, 247140, 91, 2, 46, "InputOnly",
   CellTags->"13.4 Solutions"],
  Cell[11573834, 247144, 1126, 33, 180, "SolutionText",
   CellTags->"13.4 Solutions"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Chapter.Number", 11621424, 248208},
 {"2.1 Exercises", 11621558, 248212},
 {"2.1 Solutions", 11622047, 248225},
 {"2.2 Exercises", 11623735, 248272},
 {"i:30", 11625126, 248307},
 {"2.2 Solutions", 11625449, 248314},
 {"2.3 Exercises", 11628364, 248393},
 {"i:47", 11628796, 248404},
 {"i:48", 11629089, 248411},
 {"2.3 Solutions", 11629503, 248420},
 {"2.4 Exercises", 11632410, 248499},
 {"i:62", 11633051, 248516},
 {"2.4 Solutions", 11633163, 248519},
 {"c:1", 11634529, 248556},
 {"3.1 Exercises", 11634759, 248563},
 {"Ex.Ten element list", 11635875, 248590},
 {"i:21", 11636000, 248593},
 {"i:22", 11636223, 248598},
 {"3.1 Solutions", 11636428, 248603},
 {"3.2 Exercises", 11640188, 248704},
 {"3.2 Solutions", 11640726, 248718},
 {"3.3 Exercises", 11641898, 248749},
 {"i:57", 11643880, 248796},
 {"Ex.Row swapping", 11644091, 248801},
 {"i:61", 11644213, 248804},
 {"i:58", 11644335, 248807},
 {"i:59", 11644439, 248810},
 {"i:60", 11644544, 248813},
 {"3.3 Solutions", 11644658, 248816},
 {"4.1 Exercises", 11652434, 249019},
 {"i:27", 11652953, 249032},
 {"4.1 Solutions", 11653259, 249039},
 {"4.2 Exercises", 11658249, 249170},
 {"i:40", 11661090, 249238},
 {"i:41", 11661385, 249245},
 {"Ex.MultiplyCount", 11661784, 249254},
 {"i:42", 11661908, 249257},
 {"Ex.Dice", 11662130, 249262},
 {"i:43", 11662246, 249265},
 {"4.2 Solutions", 11662558, 249272},
 {"i:51", 11669226, 249445},
 {"4.3 Exercises", 11669528, 249452},
 {"i:52", 11670635, 249479},
 {"4.3 Solutions", 11670843, 249484},
 {"i:24", 11674533, 249579},
 {"5.2 Exercises", 11674646, 249582},
 {"Ex.Pointset diameter", 11677980, 249659},
 {"i:139", 11678110, 249662},
 {"i:25", 11678239, 249665},
 {"i:26", 11678344, 249668},
 {"Ex.ToGraph", 11678646, 249675},
 {"i:31", 11678757, 249678},
 {"i:32", 11679052, 249685},
 {"i:155", 11679458, 249694},
 {"i:33", 11679563, 249697},
 {"i:34", 11679983, 249706},
 {"5.2 Solutions", 11680285, 249713},
 {"Info3563802280-1903310", 11692413, 250024},
 {"Sec.Iterating functions", 11692654, 250029},
 {"i:44", 11692763, 250032},
 {"5.3 Exercises", 11693064, 250039},
 {"i:45", 11693795, 250056},
 {"i:150", 11693900, 250059},
 {"5.3 Solutions", 11694015, 250062},
 {"Exercise.Total ints", 11696667, 250130},
 {"5.4 Exercises", 11696796, 250133},
 {"i:54", 11697969, 250160},
 {"i:55", 11698171, 250165},
 {"Ex.interleave", 11698380, 250170},
 {"i:56", 11698495, 250173},
 {"5.4 Solutions", 11698610, 250176},
 {"Sec.Scoping constructs", 11702917, 250287},
 {"i:70", 11703025, 250290},
 {"5.5 Exercises", 11703328, 250297},
 {"Ex.Perfect numbers", 11703995, 250312},
 {"i:71", 11704124, 250315},
 {"i:72", 11704347, 250320},
 {"5.5 Solutions", 11704559, 250325},
 {"5.6 Exercises", 11709842, 250460},
 {"i:85", 11712802, 250529},
 {"i:87", 11713002, 250534},
 {"Ex.Repunit", 11713127, 250537},
 {"i:86", 11713246, 250540},
 {"i:156", 11713445, 250545},
 {"i:89", 11713553, 250548},
 {"i:90", 11713658, 250551},
 {"i:91", 11713857, 250556},
 {"i:92", 11714072, 250561},
 {"i:93", 11714366, 250568},
 {"5.6 Solutions", 11714481, 250571},
 {"Ex.SwitchRows", 11725490, 250854},
 {"5.7 Exercises", 11725614, 250857},
 {"5.7 Solutions", 11726568, 250880},
 {"i:133", 11728532, 250931},
 {"5.8 Exercises", 11728646, 250934},
 {"i:154", 11731892, 251011},
 {"i:135", 11732000, 251014},
 {"Ex.TruthTable", 11732115, 251017},
 {"i:136", 11732239, 251020},
 {"i:137", 11732363, 251023},
 {"5.8 Solutions", 11732479, 251026},
 {"6.1 Exercises", 11747942, 251422},
 {"Ex.Do and Table", 11751142, 251496},
 {"i:14", 11751268, 251499},
 {"Ex.Fibonacci", 11751402, 251502},
 {"i:15", 11751524, 251505},
 {"Ex.findRoot", 11751653, 251508},
 {"i:16", 11751775, 251511},
 {"Ex.GCD", 11751992, 251516},
 {"i:18", 11752109, 251519},
 {"6.1 Solutions", 11752331, 251524},
 {"Sol.findRoot", 11758867, 251690},
 {"6.2 Exercises", 11758989, 251693},
 {"Ex.Absolute value", 11760840, 251736},
 {"Ex.Collatz", 11760963, 251739},
 {"6.2 Solutions", 11761201, 251744},
 {"6.3 Exercises", 11765591, 251857},
 {"i:46", 11766260, 251872},
 {"Ex.pointLoc alternatives", 11766386, 251875},
 {"6.3 Solutions", 11766521, 251878},
 {"7.1 Exercises", 11770698, 251985},
 {"Exercise Fibonacci", 11772263, 252019},
 {"Exercise 7.1-2", 11772688, 252028},
 {"i:17", 11773103, 252037},
 {"i:2", 11773254, 252041},
 {"7.1 Solutions", 11773413, 252045},
 {"7.2 Exercises", 11775803, 252106},
 {"i:5", 11777357, 252144},
 {"i:6", 11777460, 252147},
 {"7.2 Solutions", 11777573, 252150},
 {"i:9", 11781687, 252257},
 {"7.3 Exercises", 11781802, 252260},
 {"Table.Eulerian numbers", 11783361, 252295},
 {"7.3 Solutions", 11783493, 252298},
 {"7.4 Exercises", 11787033, 252389},
 {"7.4 Solutions", 11787916, 252411},
 {"8.1 Exercises", 11789442, 252450},
 {"Ex.Convert", 11792451, 252520},
 {"i:119", 11792572, 252523},
 {"i:35", 11792679, 252526},
 {"i:36", 11792882, 252531},
 {"i:37", 11793083, 252536},
 {"i:38", 11793285, 252541},
 {"i:39", 11793483, 252546},
 {"8.1 Solutions", 11793717, 252551},
 {"8.2 Exercises", 11802457, 252774},
 {"8.2 Solutions", 11803309, 252795},
 {"8.3 Exercises", 11803883, 252810},
 {"i:120", 11805207, 252841},
 {"i:121", 11805315, 252844},
 {"8.3 Solutions", 11805430, 252847},
 {"8.4 Exercises", 11809495, 252952},
 {"i:113", 11812604, 253023},
 {"i:112", 11812809, 253028},
 {"i:114", 11813015, 253033},
 {"i:115", 11813243, 253038},
 {"i:116", 11813463, 253043},
 {"Ex.Autocorrelation", 11813693, 253048},
 {"i:117", 11813814, 253051},
 {"Ex.Walk pi", 11814023, 253056},
 {"i:118", 11814146, 253059},
 {"8.4 Solutions", 11814277, 253062},
 {"Sec.Structure", 11820413, 253219},
 {"9.1 Exercises", 11820521, 253222},
 {"9.1 Solutions", 11820791, 253229},
 {"Sec.Operations", 11825138, 253342},
 {"9.2 Exercises", 11825247, 253345},
 {"9.2 Solutions", 11826556, 253376},
 {"Sec.String patterns", 11833560, 253557},
 {"9.3 Exercises", 11833674, 253560},
 {"i:94", 11834283, 253575},
 {"9.3 Solutions", 11834399, 253578},
 {"9.4 Exercises", 11837540, 253659},
 {"i:65", 11839114, 253696},
 {"i:66", 11839220, 253699},
 {"i:68", 11839327, 253702},
 {"i:69", 11839531, 253707},
 {"9.4 Solutions", 11839741, 253712},
 {"9.5 Exercises", 11846363, 253881},
 {"Ex.Anagrams", 11847428, 253906},
 {"9.5 Solutions", 11847558, 253909},
 {"10.1 Exercises", 11854113, 254078},
 {"Sinplot exercise", 11855330, 254105},
 {"Ex.StandardDeviation", 11855465, 254108},
 {"10.1 Solutions", 11855606, 254111},
 {"10.2 Exercises", 11862777, 254290},
 {"i:50", 11863955, 254317},
 {"Ex.Convex hull", 11864070, 254320},
 {"i:53", 11864196, 254323},
 {"10.2 Solutions", 11864332, 254326},
 {"10.3 Exercises", 11869301, 254451},
 {"i:67", 11870563, 254480},
 {"10.3 Solutions", 11870681, 254483},
 {"10.4 Exercises", 11872796, 254535},
 {"Ex.SimpleClosedPath", 11874807, 254580},
 {"Ex.ShowWalk", 11874946, 254583},
 {"Ex.Mesh", 11875073, 254586},
 {"Ex.PointInPolygon", 11875206, 254589},
 {"10.4 Solutions", 11875337, 254592},
 {"11.1 Exercises", 11881038, 254732},
 {"i:28", 11883442, 254785},
 {"i:29", 11883644, 254790},
 {"Ex.Random walk animate", 11883769, 254793},
 {"Ex.Hypocycloid", 11883911, 254796},
 {"Ex.Epicycloids", 11884038, 254799},
 {"11.1 Solutions", 11884173, 254802},
 {"11.2 Exercises", 11887596, 254886},
 {"11.2 Solutions", 11887880, 254893},
 {"11.3 Exercises", 11888227, 254902},
 {"11.3 Solutions", 11888958, 254919},
 {"12.2 Exercises", 11890607, 254960},
 {"Figure triangular numbers", 11891950, 254990},
 {"12.2 Solutions", 11892089, 254993},
 {"12.3 Exercises", 11895835, 255087},
 {"12.3 Solutions", 11896571, 255104},
 {"12.4 Exercises", 11898510, 255153},
 {"i:63", 11899076, 255166},
 {"12.4 Solutions", 11899393, 255173},
 {"13.1 Exercises", 11904328, 255298},
 {"i:19", 11905171, 255317},
 {"i:20", 11905279, 255320},
 {"i:23", 11905388, 255323},
 {"13.1 Solutions", 11905505, 255326},
 {"13.4 Exercises", 11908570, 255401},
 {"i:49", 11910607, 255448},
 {"Info3560500981-5226863", 11910735, 255451},
 {"13.4 Solutions", 11910864, 255454}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 120, 5, 0, "Title"],
Cell[698, 28, 42, 0, 0, "Subtitle"],
Cell[743, 30, 776, 17, 42, "TitleFlourish"],
Cell[1522, 49, 89, 2, 48, "ChapterN",
 CounterAssignments->{{"Chapter", 1}},
 CellTags->"Chapter.Number"],
Cell[CellGroupData[{
Cell[1636, 55, 106, 5, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[1767, 64, 41, 0, 45, "ExerciseSubsection"],
Cell[1811, 66, 224, 8, 49, "ExerciseItem",
 CellTags->"2.1 Exercises"],
Cell[2038, 76, 367, 13, 42, "ExerciseItem",
 CellTags->"2.1 Exercises"],
Cell[2408, 91, 320, 12, 45, "ExerciseItem",
 CellTags->"2.1 Exercises"],
Cell[CellGroupData[{
Cell[2753, 107, 300, 8, 72, "ExerciseItem",
 CellTags->"2.1 Exercises"],
Cell[3056, 117, 377, 13, 45, "ExerciseSubItem",
 CellTags->"2.1 Exercises"],
Cell[3436, 132, 255, 9, 36, "ExerciseSubItem",
 CellTags->"2.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3728, 146, 39, 0, 76, "SolutionSubsection"],
Cell[3770, 148, 348, 14, 27, "SolutionItem",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[4143, 166, 239, 8, 33, "SolutionItem",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[4407, 178, 278, 10, 45, "Input",
 CellTags->"2.1 Solutions"],
Cell[4688, 190, 99, 3, 55, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[4836, 199, 193, 6, 27, "SolutionItem",
 CellTags->"2.1 Solutions"],
Cell[5032, 207, 209, 7, 48, "Input",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[5266, 218, 92, 2, 45, "Input",
 CellTags->"2.1 Solutions"],
Cell[5361, 222, 434, 15, 33, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],
Cell[5810, 240, 281, 12, 37, "SolutionText",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[6116, 256, 108, 3, 45, "Input",
 CellTags->"2.1 Solutions"],
Cell[6227, 261, 78, 2, 33, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6342, 268, 132, 4, 82, "Input",
 CellTags->"2.1 Solutions"],
Cell[6477, 274, 56, 1, 67, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6582, 281, 296, 8, 67, "SolutionItem",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[6903, 293, 216, 8, 159, "Input",
 CellTags->"2.1 Solutions"],
Cell[7122, 303, 457, 16, 103, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7616, 324, 278, 9, 159, "Input",
 CellTags->"2.1 Solutions"],
Cell[7897, 335, 56, 1, 67, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],
Cell[7968, 339, 1124, 38, 168, "SolutionText",
 CellTags->"2.1 Solutions"],
Cell[CellGroupData[{
Cell[9117, 381, 112, 3, 82, "Input",
 CellTags->"2.1 Solutions"],
Cell[9232, 386, 320, 12, 103, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[9589, 403, 176, 6, 82, "Input",
 CellTags->"2.1 Solutions"],
Cell[9768, 411, 73, 2, 67, "Output",
 CellTags->"2.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[9914, 421, 41, 0, 31, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[9980, 425, 357, 11, 85, "ExerciseItem",
 CellTags->"2.2 Exercises"],
Cell[10340, 438, 237, 7, 48, "ExerciseSubItem",
 CellTags->"2.2 Exercises"],
Cell[10580, 447, 352, 12, 40, "ExerciseSubItem",
 CellTags->"2.2 Exercises"],
Cell[10935, 461, 353, 12, 40, "ExerciseSubItem",
 CellTags->"2.2 Exercises"],
Cell[11291, 475, 266, 8, 40, "ExerciseSubItem",
 CellTags->"2.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[11594, 488, 291, 8, 85, "ExerciseItem",
 CellTags->"2.2 Exercises"],
Cell[11888, 498, 351, 12, 69, "ExerciseInput",
 CellTags->"2.2 Exercises"],
Cell[12242, 512, 301, 10, 69, "Input",
 CellTags->"2.2 Exercises"],
Cell[12546, 524, 203, 6, 49, "ExerciseText",
 CellTags->"2.2 Exercises"],
Cell[CellGroupData[{
Cell[12774, 534, 104, 2, 55, "ExerciseInput",
 CellTags->"2.2 Exercises"],
Cell[12881, 538, 325, 12, 130, "ExerciseOutput",
 CellTags->"2.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[13243, 555, 104, 2, 40, "ExerciseInput",
 CellTags->"2.2 Exercises"],
Cell[13350, 559, 183, 5, 76, "ExerciseOutput",
 CellTags->"2.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13582, 570, 193, 5, 45, "ExerciseItem",
 CellTags->"2.2 Exercises"],
Cell[13778, 577, 981, 34, 202, "ExerciseDisplayFormula",
 CellTags->"2.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[14796, 616, 388, 14, 45, "ExerciseItem",
 CellTags->{"i:30", "2.2 Exercises"}],
Cell[15187, 632, 953, 32, 189, "ExerciseDisplayFormula",
 CellTags->"2.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[16177, 669, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[16241, 673, 144, 4, 67, "SolutionItem",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[16410, 681, 170, 6, 67, "SolutionSubItem",
 CellTags->"2.2 Solutions"],
Cell[16583, 689, 204, 6, 73, "InputOnly",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[16812, 699, 89, 2, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[16904, 703, 173, 5, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[17126, 714, 339, 11, 117, "SolutionSubItem",
 CellTags->"2.2 Solutions"],
Cell[17468, 727, 312, 10, 73, "InputOnly",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[17805, 741, 89, 2, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[17897, 745, 172, 5, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[18106, 755, 89, 2, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[18198, 759, 172, 5, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18419, 770, 266, 9, 117, "SolutionSubItem",
 CellTags->"2.2 Solutions"],
Cell[18688, 781, 313, 10, 73, "InputOnly",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[19026, 795, 89, 2, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[19118, 799, 173, 5, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[19340, 810, 383, 11, 117, "SolutionSubItem",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[19748, 825, 228, 7, 87, "Input",
 CellTags->"2.2 Solutions"],
Cell[19979, 834, 429, 9, 72, "Message",
 CellTags->"2.2 Solutions"],
Cell[20411, 845, 167, 5, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],
Cell[20593, 853, 86, 2, 82, "Input",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[20728, 861, 835, 26, 270, "SolutionItem",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[21588, 891, 300, 10, 103, "Input",
 CellTags->"2.2 Solutions"],
Cell[21891, 903, 300, 11, 123, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],
Cell[22206, 917, 301, 10, 103, "Input",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[22532, 931, 115, 3, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[22650, 936, 135, 4, 76, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[22822, 945, 115, 3, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[22940, 950, 135, 4, 76, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[23124, 960, 298, 8, 117, "SolutionItem",
 CellTags->"2.2 Solutions"],
Cell[23425, 970, 223, 7, 73, "InputOnly",
 CellTags->"2.2 Solutions"],
Cell[23651, 979, 193, 6, 87, "InputOnly",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[23869, 989, 167, 5, 103, "Input",
 CellTags->"2.2 Solutions"],
Cell[24039, 996, 226, 7, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[24302, 1008, 107, 3, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[24412, 1013, 138, 4, 67, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[24599, 1023, 211, 8, 67, "SolutionItem",
 CellTags->"2.2 Solutions"],
Cell[24813, 1033, 703, 24, 135, "Input",
 CellTags->"2.2 Solutions"],
Cell[CellGroupData[{
Cell[25541, 1061, 217, 7, 82, "Input",
 CellTags->"2.2 Solutions"],
Cell[25761, 1070, 8076, 140, 775, "Output",
 CellTags->"2.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33910, 1218, 63, 0, 31, "ExerciseSubsection"],
Cell[33976, 1220, 308, 11, 49, "ExerciseItem",
 CellTags->"2.3 Exercises"],
Cell[34287, 1233, 400, 13, 72, "ExerciseItem",
 CellTags->"2.3 Exercises"],
Cell[34690, 1248, 824, 32, 72, "ExerciseItem",
 CellTags->{"i:47", "2.3 Exercises"}],
Cell[35517, 1282, 1151, 44, 72, "ExerciseItem",
 CellTags->"2.3 Exercises"],
Cell[36671, 1328, 218, 6, 42, "ExerciseItem",
 CellTags->{"i:48", "2.3 Exercises"}],
Cell[CellGroupData[{
Cell[36914, 1338, 39, 0, 54, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[36978, 1342, 198, 4, 117, "SolutionItem",
 CellTags->"2.3 Solutions"],
Cell[37179, 1348, 163, 5, 73, "InputOnly",
 CellTags->"2.3 Solutions"],
Cell[37345, 1355, 165, 5, 73, "InputOnly",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[37535, 1364, 82, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[37620, 1368, 60, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[37717, 1374, 103, 3, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[37823, 1379, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[37931, 1386, 412, 13, 117, "SolutionItem",
 CellTags->"2.3 Solutions"],
Cell[38346, 1401, 252, 8, 87, "Input",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[38623, 1413, 99, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[38725, 1417, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[38821, 1423, 100, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[38924, 1427, 60, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[39021, 1433, 92, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[39116, 1437, 60, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[39225, 1444, 428, 12, 168, "SolutionItem",
 CellTags->"2.3 Solutions"],
Cell[39656, 1458, 216, 6, 73, "InputOnly",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[39897, 1468, 89, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[39989, 1472, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[40085, 1478, 107, 3, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[40195, 1483, 60, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[40304, 1490, 151, 4, 67, "SolutionItem",
 CellTags->"2.3 Solutions"],
Cell[40458, 1496, 163, 5, 87, "Input",
 CellTags->"2.3 Solutions"],
Cell[40624, 1503, 286, 13, 67, "SolutionText",
 CellTags->"2.3 Solutions"],
Cell[40913, 1518, 242, 7, 87, "Input",
 CellTags->"2.3 Solutions"],
Cell[41158, 1527, 309, 11, 136, "Input",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[41492, 1542, 111, 3, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[41606, 1547, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[41680, 1551, 292, 7, 117, "SolutionText",
 CellTags->"2.3 Solutions"],
Cell[41975, 1560, 215, 6, 87, "Input",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[42215, 1570, 85, 2, 82, "Input",
 CellTags->"2.3 Solutions"],
Cell[42303, 1574, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[42411, 1581, 178, 5, 67, "SolutionItem",
 CellTags->"2.3 Solutions"],
Cell[42592, 1588, 281, 8, 73, "InputOnly",
 CellTags->"2.3 Solutions"],
Cell[CellGroupData[{
Cell[42898, 1600, 140, 4, 103, "Input",
 CellTags->"2.3 Solutions"],
Cell[43041, 1606, 60, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[43138, 1612, 140, 4, 103, "Input",
 CellTags->"2.3 Solutions"],
Cell[43281, 1618, 59, 1, 67, "Output",
 CellTags->"2.3 Solutions"]
}, Closed]],
Cell[43355, 1622, 209, 8, 67, "SolutionText",
 CellTags->"2.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[43625, 1637, 40, 0, 31, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[43690, 1641, 445, 14, 123, "ExerciseItem",
 CellTags->"2.4 Exercises"],
Cell[44138, 1657, 219, 7, 96, "Input",
 CellTags->"2.4 Exercises"],
Cell[CellGroupData[{
Cell[44382, 1668, 119, 3, 82, "Input",
 CellTags->"2.4 Exercises"],
Cell[44504, 1673, 97, 2, 67, "Output",
 CellTags->"2.4 Exercises"]
}, Closed]],
Cell[44616, 1678, 353, 12, 123, "ExerciseText",
 CellTags->"2.4 Exercises"],
Cell[CellGroupData[{
Cell[44994, 1694, 145, 4, 82, "ExerciseInput",
 CellTags->"2.4 Exercises"],
Cell[45142, 1700, 79, 1, 67, "ExerciseOutput",
 CellTags->"2.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[45248, 1705, 545, 16, 114, "ExerciseItem",
 CellTags->{"i:62", "2.4 Exercises"}],
Cell[CellGroupData[{
Cell[45818, 1725, 39, 0, 54, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[45882, 1729, 167, 5, 27, "SolutionItem",
 CellTags->"2.4 Solutions"],
Cell[46052, 1736, 93, 2, 45, "InputOnly",
 CellTags->"2.4 Solutions"],
Cell[46148, 1740, 278, 8, 37, "SolutionText",
 CellTags->"2.4 Solutions"],
Cell[46429, 1750, 127, 3, 45, "InputOnly",
 CellTags->"2.4 Solutions"],
Cell[46559, 1755, 209, 7, 48, "InputOnly",
 CellTags->"2.4 Solutions"],
Cell[CellGroupData[{
Cell[46793, 1766, 105, 3, 45, "Input",
 CellTags->"2.4 Solutions"],
Cell[46901, 1771, 126, 4, 37, "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[47064, 1780, 105, 3, 45, "Input",
 CellTags->"2.4 Solutions"],
Cell[47172, 1785, 57, 1, 33, "Output",
 CellTags->"2.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[47278, 1792, 98, 1, 27, "SolutionItem",
 CellTags->"2.4 Solutions"],
Cell[CellGroupData[{
Cell[47401, 1797, 214, 7, 45, "Input",
 CellTags->"2.4 Solutions"],
Cell[47618, 1806, 451, 10, 63, "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],
Cell[48084, 1819, 139, 4, 37, "SolutionText",
 CellTags->"2.4 Solutions"],
Cell[48226, 1825, 314, 10, 61, "InputOnly",
 CellTags->"2.4 Solutions"],
Cell[48543, 1837, 110, 5, 37, "SolutionText",
 CellTags->"2.4 Solutions"],
Cell[48656, 1844, 130, 3, 45, "InputOnly",
 CellTags->"2.4 Solutions"],
Cell[CellGroupData[{
Cell[48811, 1851, 111, 3, 45, "Input",
 CellTags->"2.4 Solutions"],
Cell[48925, 1856, 514, 11, 63, "Output",
 CellTags->"2.4 Solutions"]
}, Closed]],
Cell[49454, 1870, 27, 0, 45, "Input"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[49532, 1876, 776, 17, 42, "TitleFlourish"],
Cell[50311, 1895, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[50357, 1899, 47, 1, 67, "ChapterTitle",
 CellTags->"c:1"],
Cell[CellGroupData[{
Cell[50429, 1904, 59, 0, 45, "ExerciseSubsection"],
Cell[50491, 1906, 678, 23, 57, "ExerciseItem",
 CellTags->"3.1 Exercises"],
Cell[51172, 1931, 525, 22, 54, "ExerciseItem",
 CellTags->"3.1 Exercises"],
Cell[CellGroupData[{
Cell[51722, 1957, 785, 26, 76, "ExerciseItem",
 CellTags->{"Ex.Ten element list", "3.1 Exercises", "i:21"}],
Cell[52510, 1985, 360, 7, 78, "ExerciseText",
 CellTags->"3.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[52907, 1997, 243, 8, 34, "ExerciseItem",
 CellTags->"3.1 Exercises"],
Cell[CellGroupData[{
Cell[53175, 2009, 131, 3, 37, "ExerciseInput",
 CellTags->"3.1 Exercises"],
Cell[53309, 2014, 298, 8, 30, "ExerciseOutput",
 CellTags->"3.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[53644, 2027, 180, 5, 37, "ExerciseInput",
 CellTags->"3.1 Exercises"],
Cell[53827, 2034, 1038, 34, 54, "ExerciseOutput",
 CellTags->"3.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54914, 2074, 379, 6, 79, "ExerciseItem",
 CellTags->{"3.1 Exercises", "i:22"}],
Cell[CellGroupData[{
Cell[55318, 2084, 2020, 70, 107, "ExerciseInput",
 CellTags->"3.1 Exercises"],
Cell[57341, 2156, 317, 7, 143, "ExerciseOutput",
 CellTags->"3.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[57685, 2167, 406, 14, 57, "ExerciseItem",
 CellTags->"3.1 Exercises"],
Cell[CellGroupData[{
Cell[58116, 2185, 39, 0, 31, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[58180, 2189, 207, 7, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[58412, 2200, 257, 7, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[58672, 2209, 414, 13, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[59123, 2227, 261, 8, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[59387, 2237, 414, 13, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[59850, 2256, 217, 9, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[60092, 2269, 212, 7, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[60307, 2278, 280, 9, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[60602, 2290, 209, 8, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[60836, 2302, 221, 7, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[61060, 2311, 219, 5, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61328, 2322, 93, 1, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[61446, 2327, 193, 6, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[61642, 2335, 314, 10, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[61993, 2350, 210, 7, 41, "Input",
 CellTags->"3.1 Solutions"],
Cell[62206, 2359, 238, 6, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[62459, 2368, 243, 8, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[62727, 2380, 211, 7, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[62941, 2389, 276, 8, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[63266, 2403, 266, 8, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[63557, 2415, 187, 6, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[63747, 2423, 276, 8, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[64060, 2436, 271, 9, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[64334, 2447, 1014, 33, 54, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[65397, 2486, 244, 8, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[65666, 2498, 574, 19, 61, "Input",
 CellTags->"3.1 Solutions"],
Cell[66243, 2519, 691, 26, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[66971, 2550, 372, 12, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[67346, 2564, 1113, 42, 54, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[68474, 2609, 132, 3, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[68631, 2616, 200, 6, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[68834, 2624, 1723, 65, 54, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[70594, 2694, 124, 3, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[70721, 2699, 246, 5, 292, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[70982, 2707, 99, 1, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[71084, 2710, 1517, 46, 125, "InputOnly",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[72626, 2760, 251, 9, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[72880, 2771, 330, 6, 379, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[73259, 2783, 93, 1, 30, "SolutionItem",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[73377, 2788, 174, 5, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[73554, 2795, 612, 16, 54, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[74181, 2814, 776, 20, 84, "Input",
 CellTags->"3.1 Solutions"],
Cell[74960, 2836, 73, 1, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[75058, 2841, 126, 3, 37, "Input",
 CellTags->"3.1 Solutions"],
Cell[75187, 2846, 459, 15, 30, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]],
Cell[75661, 2864, 77, 1, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[75741, 2867, 1027, 34, 153, "Input",
 CellTags->"3.1 Solutions"],
Cell[76771, 2903, 96, 1, 30, "SolutionText",
 CellTags->"3.1 Solutions"],
Cell[CellGroupData[{
Cell[76892, 2908, 613, 18, 107, "Input",
 CellTags->"3.1 Solutions"],
Cell[77508, 2928, 639348, 10515, 170, "Output",
 CellTags->"3.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[716929, 13451, 52, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[717006, 13455, 261, 7, 57, "ExerciseItem",
 CellTags->"3.2 Exercises"],
Cell[CellGroupData[{
Cell[717292, 13466, 264, 8, 37, "ExerciseInput",
 CellTags->"3.2 Exercises"],
Cell[717559, 13476, 709, 20, 54, "ExerciseOutput",
 CellTags->"3.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[718295, 13500, 828, 29, 57, "ExerciseItem",
 CellTags->"3.2 Exercises"],
Cell[CellGroupData[{
Cell[719148, 13533, 270, 10, 31, "ExerciseItem",
 CellTags->"3.2 Exercises"],
Cell[719421, 13545, 473, 15, 37, "ExerciseInput",
 Evaluatable->False,
 CellTags->"3.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[719931, 13565, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[719995, 13569, 88, 1, 30, "SolutionItem",
 CellTags->"3.2 Solutions"],
Cell[CellGroupData[{
Cell[720108, 13574, 218, 7, 37, "Input",
 CellTags->"3.2 Solutions"],
Cell[720329, 13583, 685, 19, 54, "Output",
 CellTags->"3.2 Solutions"]
}, Closed]],
Cell[721029, 13605, 126, 5, 30, "SolutionText",
 CellTags->"3.2 Solutions"],
Cell[CellGroupData[{
Cell[721180, 13614, 112, 3, 37, "Input",
 CellTags->"3.2 Solutions"],
Cell[721295, 13619, 56, 1, 30, "Output",
 CellTags->"3.2 Solutions"]
}, Closed]],
Cell[721366, 13623, 166, 7, 30, "SolutionText",
 CellTags->"3.2 Solutions"],
Cell[CellGroupData[{
Cell[721557, 13634, 146, 4, 37, "Input",
 CellTags->"3.2 Solutions"],
Cell[721706, 13640, 57, 1, 30, "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[721812, 13647, 178, 4, 30, "SolutionItem",
 CellTags->"3.2 Solutions"],
Cell[CellGroupData[{
Cell[722015, 13655, 590, 20, 37, "Input",
 CellTags->"3.2 Solutions"],
Cell[722608, 13677, 111, 3, 30, "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[722768, 13686, 350, 11, 30, "SolutionItem",
 CellTags->"3.2 Solutions"],
Cell[CellGroupData[{
Cell[723143, 13701, 512, 16, 37, "Input",
 CellTags->"3.2 Solutions"],
Cell[723658, 13719, 199, 7, 30, "Output",
 CellTags->"3.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[723930, 13734, 49, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[724004, 13738, 1810, 64, 36, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[725817, 13804, 593, 19, 32, "Output",
 CellTags->"3.3 Exercises"]
}, Closed]],
Cell[726425, 13826, 1271, 43, 102, "ExerciseItem",
 CellTags->{"i:57", "3.3 Exercises"}],
Cell[727699, 13871, 281, 9, 31, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[727983, 13882, 156, 3, 31, "ExerciseItem",
 CellTags->{"Ex.Row swapping", "i:61", "3.3 Exercises"}],
Cell[CellGroupData[{
Cell[728164, 13889, 658, 24, 54, "ExerciseItem",
 CellTags->{"i:58", "3.3 Exercises"}],
Cell[CellGroupData[{
Cell[728847, 13917, 306, 8, 61, "ExerciseInput",
 CellTags->"3.3 Exercises"],
Cell[729156, 13927, 709, 20, 100, "ExerciseOutput",
 CellTags->"3.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[729902, 13952, 255, 7, 82, "ExerciseInput",
 CellTags->"3.3 Exercises"],
Cell[730160, 13961, 729, 20, 261, "ExerciseOutput",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],
Cell[730916, 13985, 1650, 64, 171, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[732569, 14051, 2219, 80, 211, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[734791, 14133, 630, 24, 67, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[735424, 14159, 469, 18, 67, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[735896, 14179, 520, 20, 67, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[736419, 14201, 582, 19, 117, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[CellGroupData[{
Cell[737026, 14224, 836, 25, 256, "ExerciseItem",
 CellTags->{"i:59", "3.3 Exercises"}],
Cell[737865, 14251, 519, 15, 127, "ExerciseText",
 CellTags->{"i:60", "3.3 Exercises"}],
Cell[CellGroupData[{
Cell[738409, 14270, 284, 6, 189, "ExerciseInput",
 CellTags->"3.3 Exercises"],
Cell[738696, 14278, 290, 6, 67, "ExerciseOutput",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[739035, 14290, 555, 19, 123, "ExerciseItem",
 CellTags->"3.3 Exercises"],
Cell[CellGroupData[{
Cell[739615, 14313, 270, 7, 136, "ExerciseInput",
 CellTags->"3.3 Exercises"],
Cell[739888, 14322, 764, 21, 172, "ExerciseOutput",
 CellTags->"3.3 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[740701, 14349, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[740765, 14353, 242, 8, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[741032, 14365, 682, 24, 87, "Input",
 CellTags->"3.3 Solutions"],
Cell[741717, 14391, 509, 17, 72, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[742275, 14414, 134, 3, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[742412, 14419, 425, 15, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[742840, 14436, 222, 7, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[743087, 14447, 144, 4, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[743234, 14453, 734, 26, 121, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[744017, 14485, 223, 5, 117, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[744265, 14494, 186, 5, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[744454, 14501, 144, 4, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[744635, 14510, 123, 3, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[744761, 14515, 183, 6, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[744981, 14526, 88, 2, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[745072, 14530, 111, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[745198, 14536, 568, 20, 117, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[745791, 14560, 268, 8, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[746062, 14570, 111, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[746222, 14579, 145, 4, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[746392, 14587, 284, 8, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[746679, 14597, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[747403, 14622, 532, 17, 240, "Input",
 CellTags->"3.3 Solutions"],
Cell[747938, 14641, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[748640, 14664, 129, 3, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[748794, 14671, 284, 8, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[749081, 14681, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[749805, 14706, 501, 16, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[750309, 14724, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[751011, 14747, 97, 1, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[751133, 14752, 284, 8, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[751420, 14762, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[752144, 14787, 384, 13, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[752531, 14802, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[753233, 14825, 382, 9, 168, "SolutionText",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[753652, 14839, 134, 3, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[753811, 14846, 284, 8, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[754098, 14856, 687, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[754822, 14881, 92, 2, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[754917, 14885, 397, 11, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[755329, 14899, 134, 3, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[755488, 14906, 268, 8, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[755759, 14916, 714, 21, 310, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[756510, 14942, 304, 9, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[756817, 14953, 707, 20, 261, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[757539, 14976, 231, 5, 117, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[757773, 14983, 442, 13, 139, "Input",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[758252, 15001, 173, 7, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[758428, 15010, 306, 10, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[758759, 15024, 176, 6, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[758938, 15032, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[759074, 15038, 71, 1, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[759170, 15043, 123, 3, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[759296, 15048, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[759466, 15057, 202, 7, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[759671, 15066, 306, 10, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[760002, 15080, 137, 4, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[760142, 15086, 317, 11, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[760496, 15102, 85, 2, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[760584, 15106, 317, 11, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[760938, 15122, 90, 2, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[761031, 15126, 239, 7, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[761307, 15138, 123, 3, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[761433, 15143, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[761569, 15149, 220, 8, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[761814, 15161, 233, 7, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[762050, 15170, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[762220, 15179, 208, 7, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[762453, 15190, 181, 6, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[762637, 15198, 111, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[762797, 15207, 381, 13, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[763203, 15224, 277, 8, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[763483, 15234, 167, 5, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[763687, 15244, 164, 5, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[763854, 15251, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[764024, 15260, 229, 8, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[764278, 15272, 248, 7, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[764529, 15281, 167, 5, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[764711, 15289, 152, 4, 67, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[764888, 15297, 282, 9, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[765173, 15308, 317, 11, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[765527, 15324, 88, 2, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[765618, 15328, 167, 5, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[765834, 15339, 178, 4, 117, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[766015, 15345, 312, 11, 123, "InputOnly",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[766352, 15360, 183, 5, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[766538, 15367, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[766696, 15375, 237, 7, 82, "Input",
 CellTags->"3.3 Solutions"],
Cell[766936, 15384, 121, 3, 67, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[767106, 15393, 382, 14, 67, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[767513, 15411, 412, 12, 136, "Input",
 CellTags->"3.3 Solutions"],
Cell[767928, 15425, 4535, 127, 170, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[772478, 15555, 300, 6, 53, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[772803, 15565, 390, 12, 61, "Input",
 CellTags->"3.3 Solutions"],
Cell[773196, 15579, 2862, 103, 123, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]],
Cell[776073, 15685, 113, 2, 30, "SolutionText",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[776211, 15691, 179, 6, 37, "Input",
 CellTags->"3.3 Solutions"],
Cell[776393, 15699, 3006, 108, 146, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[779448, 15813, 121, 3, 30, "SolutionItem",
 CellTags->"3.3 Solutions"],
Cell[779572, 15818, 372, 10, 56, "InputOnly",
 CellTags->"3.3 Solutions"],
Cell[CellGroupData[{
Cell[779969, 15832, 260, 8, 61, "Input",
 CellTags->"3.3 Solutions"],
Cell[780232, 15842, 742, 21, 54, "Output",
 CellTags->"3.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[781037, 15870, 776, 17, 42, "TitleFlourish"],
Cell[781816, 15889, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[781862, 15893, 42, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[781929, 15897, 38, 0, 67, "ExerciseSubsection"],
Cell[781970, 15899, 257, 10, 76, "ExerciseItem",
 CellTags->"4.1 Exercises"],
Cell[782230, 15911, 300, 10, 67, "ExerciseItem",
 CellTags->"4.1 Exercises"],
Cell[782533, 15923, 697, 28, 117, "ExerciseItem",
 CellTags->{"i:27", "4.1 Exercises"}],
Cell[783233, 15953, 270, 8, 117, "ExerciseItem",
 CellTags->"4.1 Exercises"],
Cell[783506, 15963, 1198, 49, 150, "ExerciseItem",
 CellTags->"4.1 Exercises"],
Cell[784707, 16014, 1196, 40, 211, "ExerciseItem",
 CellTags->"4.1 Exercises"],
Cell[CellGroupData[{
Cell[785928, 16058, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[785992, 16062, 110, 2, 67, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[786127, 16068, 172, 5, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[786302, 16075, 334, 7, 121, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[786651, 16085, 518, 17, 117, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[787194, 16106, 369, 11, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[787566, 16119, 247, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[787828, 16128, 90, 1, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[787943, 16133, 462, 15, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[788408, 16150, 247, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[788670, 16159, 310, 12, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[789005, 16175, 456, 15, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[789464, 16192, 247, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[789760, 16204, 214, 7, 67, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[789999, 16215, 208, 7, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[790210, 16224, 313, 11, 103, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[790560, 16240, 322, 10, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[790885, 16252, 59, 1, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[790981, 16258, 422, 13, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[791406, 16273, 59, 1, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[791502, 16279, 353, 11, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[791858, 16292, 59, 1, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[791954, 16298, 351, 11, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[792308, 16311, 59, 1, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[792416, 16318, 474, 14, 117, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[792893, 16334, 182, 6, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[793078, 16342, 166, 5, 123, "InputOnly",
 CellTags->"4.1 Solutions"],
Cell[793247, 16349, 184, 6, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[793456, 16359, 130, 3, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[793589, 16364, 265, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[793869, 16373, 177, 3, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[794071, 16380, 157, 3, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[794231, 16385, 92, 2, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[794372, 16393, 171, 4, 67, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[794546, 16399, 92, 2, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[794641, 16403, 276, 9, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[794920, 16414, 255, 8, 136, "Input",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[795200, 16426, 90, 2, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[795293, 16430, 92, 2, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[795422, 16437, 106, 3, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[795531, 16442, 107, 3, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[795675, 16450, 130, 3, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[795808, 16455, 263, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[796086, 16464, 151, 4, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[796240, 16470, 92, 2, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[796335, 16474, 278, 9, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[796616, 16485, 258, 8, 136, "Input",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[796899, 16497, 130, 3, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[797032, 16502, 263, 6, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[797344, 16514, 149, 4, 67, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[797496, 16520, 290, 8, 76, "InputOnly",
 CellTags->"4.1 Solutions"],
Cell[797789, 16530, 97, 1, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[797889, 16533, 272, 9, 105, "InputOnly",
 CellTags->"4.1 Solutions"],
Cell[798164, 16544, 121, 3, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[798310, 16551, 293, 10, 145, "Input",
 CellTags->"4.1 Solutions"],
Cell[798606, 16563, 174, 5, 121, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[798829, 16574, 284, 6, 117, "SolutionItem",
 CellTags->"4.1 Solutions"],
Cell[799116, 16582, 267, 9, 139, "Input",
 CellTags->"4.1 Solutions"],
Cell[799386, 16593, 186, 5, 67, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[799575, 16600, 233, 7, 87, "Input",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[799833, 16611, 295, 10, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[800131, 16623, 223, 7, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]],
Cell[800369, 16633, 263, 6, 117, "SolutionText",
 CellTags->"4.1 Solutions"],
Cell[800635, 16641, 306, 9, 141, "Input",
 CellTags->"4.1 Solutions"],
Cell[CellGroupData[{
Cell[800966, 16654, 296, 10, 82, "Input",
 CellTags->"4.1 Solutions"],
Cell[801265, 16666, 223, 7, 67, "Output",
 CellTags->"4.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[801561, 16681, 50, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[801636, 16685, 205, 4, 123, "ExerciseItem",
 CellTags->"4.2 Exercises"],
Cell[CellGroupData[{
Cell[801866, 16693, 446, 15, 87, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[802315, 16710, 280, 9, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[802632, 16724, 385, 13, 87, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[803020, 16739, 221, 7, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[803256, 16749, 394, 13, 123, "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[803687, 16767, 346, 10, 123, "ExerciseItem",
 CellTags->"4.2 Exercises"],
Cell[CellGroupData[{
Cell[804058, 16781, 312, 8, 189, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[804373, 16791, 79, 1, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[804467, 16795, 264, 9, 73, "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[804746, 16807, 843, 16, 312, "ExerciseItem",
 CellTags->{"i:40", "4.2 Exercises"}],
Cell[CellGroupData[{
Cell[805614, 16827, 145, 4, 67, "ExerciseItem",
 CellTags->"4.2 Exercises"],
Cell[805762, 16833, 635, 22, 76, "ExerciseDisplayFormula",
 CellTags->"4.2 Exercises"],
Cell[806400, 16857, 130, 3, 73, "ExerciseText",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[806567, 16865, 207, 5, 76, "ExerciseItem",
 CellTags->"4.2 Exercises"],
Cell[CellGroupData[{
Cell[806799, 16874, 559, 16, 82, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[807361, 16892, 298, 7, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[807686, 16903, 158, 4, 76, "ExerciseItem",
 CellTags->"4.2 Exercises"],
Cell[CellGroupData[{
Cell[807869, 16911, 373, 11, 117, "ExerciseItem",
 CellTags->{"i:41", "4.2 Exercises"}],
Cell[CellGroupData[{
Cell[808267, 16926, 377, 13, 87, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[808647, 16941, 757, 27, 72, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[809453, 16974, 269, 5, 123, "ExerciseItem",
 CellTags->{"Ex.MultiplyCount", "i:42", "4.2 Exercises"}],
Cell[CellGroupData[{
Cell[809747, 16983, 140, 3, 103, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[809890, 16988, 78, 1, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[810005, 16994, 89, 1, 82, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[810097, 16997, 78, 1, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[810212, 17003, 233, 6, 103, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[810448, 17011, 78, 1, 67, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[810575, 17018, 396, 11, 123, "ExerciseItem",
 CellTags->{"Ex.Dice", "i:43", "4.2 Exercises"}],
Cell[CellGroupData[{
Cell[810996, 17033, 224, 7, 82, "ExerciseInput",
 CellTags->"4.2 Exercises"],
Cell[811223, 17042, 20116, 525, 153, "ExerciseOutput",
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[831354, 17570, 416, 7, 175, "ExerciseText",
 CellTags->"4.2 Exercises"],
Cell[831773, 17579, 500, 14, 139, "ExerciseInput",
 Evaluatable->False,
 CellTags->"4.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[832310, 17598, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[832374, 17602, 570, 20, 172, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[832969, 17626, 375, 13, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[833347, 17641, 199, 7, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[833583, 17653, 436, 15, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[834022, 17670, 258, 9, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[834329, 17685, 270, 8, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[834624, 17697, 343, 9, 292, "Input",
 CellTags->"4.2 Solutions"],
Cell[834970, 17708, 1643, 68, 172, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[836628, 17779, 182, 7, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[836813, 17788, 113, 3, 69, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[836951, 17795, 322, 9, 189, "Input",
 CellTags->"4.2 Solutions"],
Cell[837276, 17806, 57, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[837348, 17810, 90, 2, 69, "InputOnly",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[837475, 17817, 348, 11, 117, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[837848, 17832, 340, 11, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[838191, 17845, 157, 5, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[838363, 17853, 135, 3, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[838523, 17860, 991, 33, 141, "Input",
 CellTags->"4.2 Solutions"],
Cell[839517, 17895, 647, 23, 72, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[840179, 17921, 92, 1, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[840274, 17924, 350, 13, 175, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[840627, 17939, 102, 1, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[840754, 17944, 563, 17, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[841320, 17963, 112, 3, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[841447, 17969, 131, 3, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[841603, 17976, 106, 3, 144, "Input",
 CellTags->"4.2 Solutions"],
Cell[841712, 17981, 56, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[841783, 17985, 294, 9, 117, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[842080, 17996, 500, 15, 130, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[842605, 18015, 150, 4, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[842758, 18021, 56, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[842829, 18025, 123, 3, 69, "InputOnly",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[842989, 18033, 96, 1, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[843110, 18038, 607, 19, 103, "Input",
 CellTags->"4.2 Solutions"],
Cell[843720, 18059, 1283, 34, 172, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[845018, 18096, 349, 9, 117, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[845392, 18109, 201, 6, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[845596, 18117, 289, 9, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[845900, 18129, 100, 1, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[846025, 18134, 171, 5, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[846199, 18141, 539, 16, 121, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[846775, 18162, 184, 5, 73, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[846962, 18169, 539, 16, 121, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[847550, 18191, 104, 1, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[847657, 18194, 343, 11, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[848025, 18209, 462, 15, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[848490, 18226, 198, 5, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[848737, 18237, 204, 6, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[848944, 18245, 341, 10, 73, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[849310, 18259, 178, 5, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[849491, 18266, 57, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[849597, 18273, 190, 7, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[849790, 18282, 636, 19, 127, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[850429, 18303, 97, 1, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[850529, 18306, 162, 5, 69, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[850694, 18313, 156, 4, 69, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[850875, 18321, 238, 7, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[851116, 18330, 612, 21, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[851765, 18356, 115, 3, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[851883, 18361, 73, 2, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[852005, 18369, 369, 14, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[852399, 18387, 285, 9, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[852687, 18398, 78, 2, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[852780, 18403, 380, 11, 117, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[853185, 18418, 296, 8, 87, "Input",
 CellTags->"4.2 Solutions"],
Cell[853484, 18428, 78, 2, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[853577, 18433, 562, 15, 168, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[854142, 18450, 715, 21, 181, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[854882, 18475, 182, 5, 103, "Input",
 CellTags->"4.2 Solutions"],
Cell[855067, 18482, 56, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[855160, 18488, 199, 6, 103, "Input",
 CellTags->"4.2 Solutions"],
Cell[855362, 18496, 621, 18, 76, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[856020, 18519, 97, 2, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[856120, 18523, 57, 1, 67, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[856226, 18530, 111, 2, 67, "SolutionItem",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[856362, 18536, 259, 8, 136, "Input",
 CellTags->"4.2 Solutions"],
Cell[856624, 18546, 247, 9, 171, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[856886, 18558, 159, 4, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[857048, 18564, 334, 11, 123, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[857385, 18577, 82, 1, 67, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[857492, 18582, 901, 21, 240, "Input",
 CellTags->"4.2 Solutions"],
Cell[858396, 18605, 1959, 41, 195, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]],
Cell[860370, 18649, 523, 16, 117, "SolutionText",
 CellTags->"4.2 Solutions"],
Cell[860896, 18667, 4493, 109, 1057, "InputOnly",
 CellTags->"4.2 Solutions"],
Cell[CellGroupData[{
Cell[865414, 18780, 200, 6, 82, "Input",
 CellTags->"4.2 Solutions"],
Cell[865617, 18788, 18096, 471, 166, "Output",
 CellTags->"4.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[883786, 19267, 55, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[883866, 19271, 497, 12, 171, "ExerciseItem",
 CellTags->{"i:51", "4.3 Exercises"}],
Cell[CellGroupData[{
Cell[884388, 19287, 167, 4, 103, "ExerciseInput",
 CellTags->"4.3 Exercises"],
Cell[884558, 19293, 285, 5, 222, "ExerciseOutput",
 CellTags->"4.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[884880, 19303, 142, 3, 82, "ExerciseInput",
 CellTags->"4.3 Exercises"],
Cell[885025, 19308, 289, 10, 67, "ExerciseOutput",
 CellTags->"4.3 Exercises"]
}, Closed]]
}, Closed]],
Cell[885341, 19322, 586, 22, 123, "ExerciseItem",
 CellTags->"4.3 Exercises"],
Cell[CellGroupData[{
Cell[885952, 19348, 85, 1, 67, "ExerciseItem",
 CellTags->"4.3 Exercises"],
Cell[CellGroupData[{
Cell[886062, 19353, 437, 13, 136, "ExerciseInput",
 CellTags->"4.3 Exercises"],
Cell[886502, 19368, 879, 22, 310, "ExerciseOutput",
 CellTags->"4.3 Exercises"]
}, Closed]],
Cell[887396, 19393, 261, 5, 123, "ExerciseText",
 CellTags->"4.3 Exercises"],
Cell[887660, 19400, 1037, 24, 274, "ExerciseOutput",
 CellTags->"4.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[888734, 19429, 540, 10, 217, "ExerciseItem",
 CellTags->{"i:52", "4.3 Exercises"}],
Cell[889277, 19441, 841, 21, 249, "Input",
 CellTags->"4.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[890155, 19467, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[890219, 19471, 151, 5, 67, "SolutionItem",
 CellTags->"4.3 Solutions"],
Cell[890373, 19478, 848, 26, 231, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[891224, 19506, 277, 6, 117, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[891504, 19514, 571, 16, 229, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[892078, 19532, 164, 6, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[892245, 19540, 356, 11, 90, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[892604, 19553, 196, 6, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[892825, 19563, 123, 3, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[892951, 19568, 540, 17, 121, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[893540, 19591, 90, 1, 67, "SolutionItem",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[893655, 19596, 314, 10, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[893972, 19608, 15150, 256, 339, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[909137, 19867, 171, 4, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[909333, 19875, 535, 17, 139, "Input",
 CellTags->"4.3 Solutions"],
Cell[909871, 19894, 15048, 254, 307, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[924934, 20151, 478, 10, 222, "SolutionText",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[925449, 20166, 204, 4, 117, "SolutionItem",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[925678, 20174, 243, 8, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[925924, 20184, 865, 24, 172, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[926826, 20213, 360, 12, 87, "Input",
 CellTags->"4.3 Solutions"],
Cell[927189, 20227, 1192, 24, 468, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[928430, 20257, 100, 1, 67, "SolutionItem",
 CellTags->"4.3 Solutions"],
Cell[928533, 20260, 1257, 30, 285, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[929793, 20292, 103, 1, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[929921, 20297, 304, 10, 139, "Input",
 CellTags->"4.3 Solutions"],
Cell[930228, 20309, 163, 5, 67, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[930406, 20317, 90, 1, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[930521, 20322, 175, 5, 87, "Input",
 CellTags->"4.3 Solutions"],
Cell[930699, 20329, 74, 1, 67, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[930788, 20333, 92, 1, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[930905, 20338, 289, 9, 87, "Input",
 CellTags->"4.3 Solutions"],
Cell[931197, 20349, 748, 23, 310, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[931960, 20375, 76, 1, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[932039, 20378, 509, 15, 180, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[932551, 20395, 142, 5, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[932718, 20404, 90, 2, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[932811, 20408, 192, 5, 67, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[933018, 20416, 94, 1, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[933137, 20421, 262, 8, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[933402, 20431, 1102, 26, 310, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[934519, 20460, 188, 4, 117, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[934732, 20468, 127, 3, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[934862, 20473, 1102, 26, 310, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[935979, 20502, 143, 5, 67, "SolutionText",
 CellTags->"4.3 Solutions"],
Cell[936125, 20509, 1048, 29, 337, "InputOnly",
 CellTags->"4.3 Solutions"],
Cell[CellGroupData[{
Cell[937198, 20542, 126, 3, 82, "Input",
 CellTags->"4.3 Solutions"],
Cell[937327, 20547, 1102, 26, 310, "Output",
 CellTags->"4.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[938492, 20580, 776, 17, 42, "TitleFlourish"],
Cell[939271, 20599, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[939317, 20603, 64, 1, 67, "ChapterTitle",
 CellTags->"c:1"],
Cell[CellGroupData[{
Cell[939406, 20608, 128, 1, 67, "ExerciseSubsection",
 CounterAssignments->{{"Section", 1}, {"ExerciseItem", 0}}],
Cell[939537, 20611, 329, 12, 76, "ExerciseItem",
 CellTags->{"i:24", "5.2 Exercises"}],
Cell[939869, 20625, 333, 9, 117, "ExerciseItem",
 CellTags->{"Ex.Pointset diameter", "i:139", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[940227, 20638, 789, 32, 123, "ExerciseItem",
 CellTags->{"i:25", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[941041, 20674, 306, 8, 136, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[941350, 20684, 761, 21, 310, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[942148, 20710, 207, 5, 82, "ExerciseInput",
 CellTags->{"i:26", "5.2 Exercises"}],
Cell[942358, 20717, 11998, 228, 351, "ExerciseOutput",
 CellTags->{"i:26", "5.2 Exercises"}]
}, Closed]],
Cell[954371, 20948, 332, 6, 175, "ExerciseText",
 CellTags->"5.2 Exercises"],
Cell[954706, 20956, 193, 6, 67, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[954936, 20967, 374, 11, 123, "ExerciseItem",
 CellTags->{"Ex.ToGraph", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[955335, 20982, 219, 7, 82, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[955557, 20991, 811, 27, 121, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[956405, 21023, 112, 2, 82, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[956520, 21027, 681, 16, 121, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[957216, 21046, 172, 4, 73, "ExerciseText",
 CellTags->"5.2 Exercises"],
Cell[CellGroupData[{
Cell[957413, 21054, 149, 4, 82, "Input",
 CellTags->"5.2 Exercises"],
Cell[957565, 21060, 106, 2, 67, "Output",
 CellTags->"5.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[957698, 21066, 464, 16, 123, "ExerciseItem",
 CellTags->{"i:30", "5.2 Exercises"}],
Cell[958165, 21084, 721, 23, 163, "ExerciseItem",
 CellTags->"5.2 Exercises"],
Cell[958889, 21109, 421, 18, 67, "ExerciseItem",
 CellTags->"5.2 Exercises"],
Cell[CellGroupData[{
Cell[959335, 21131, 417, 13, 117, "ExerciseItem",
 CellTags->{"i:31", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[959777, 21148, 295, 10, 82, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[960075, 21160, 246, 8, 67, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[960336, 21171, 522, 22, 73, "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[960895, 21198, 369, 12, 76, "ExerciseItem",
 CellTags->{"i:32", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[961289, 21214, 124, 3, 82, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[961416, 21219, 339, 11, 67, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[961770, 21233, 232, 8, 73, "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[962017, 21244, 503, 18, 123, "ExerciseItem",
 CellTags->"5.2 Exercises"],
Cell[CellGroupData[{
Cell[962545, 21266, 377, 13, 117, "ExerciseItem",
 CellTags->"5.2 Exercises"],
Cell[CellGroupData[{
Cell[962947, 21283, 119, 2, 82, "ExerciseInput",
 CellTags->"5.2 Exercises"],
Cell[963069, 21287, 191, 6, 76, "ExerciseOutput",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[963275, 21296, 351, 13, 73, "ExerciseText",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[963663, 21314, 331, 8, 123, "ExerciseItem",
 CellTags->{"i:155", "5.2 Exercises"}],
Cell[963997, 21324, 1217, 32, 261, "ExerciseDisplayFormula",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[965251, 21361, 1911, 69, 171, "ExerciseItem",
 CellTags->{"i:33", "5.2 Exercises"}],
Cell[967165, 21432, 590, 20, 130, "ExerciseDisplayFormula",
 CellTags->"5.2 Exercises"]
}, Closed]],
Cell[967770, 21455, 867, 29, 171, "ExerciseItem",
 CellTags->{"i:34", "5.2 Exercises"}],
Cell[CellGroupData[{
Cell[968662, 21488, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[968726, 21492, 155, 7, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[968884, 21501, 375, 11, 126, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[969262, 21514, 587, 18, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[969852, 21534, 256, 7, 73, "InputOnly",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[970145, 21546, 100, 1, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[970248, 21549, 218, 7, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[970469, 21558, 99, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[970571, 21561, 190, 6, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[970764, 21569, 336, 12, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[971103, 21583, 187, 5, 69, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[971293, 21590, 228, 8, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[971546, 21602, 84, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[971633, 21606, 72, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[971720, 21610, 97, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[971820, 21613, 366, 10, 126, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[972211, 21627, 102, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[972316, 21631, 72, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[972403, 21635, 178, 6, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[972606, 21645, 196, 6, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[972805, 21653, 750, 23, 172, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[973592, 21681, 104, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[973699, 21685, 74, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[973822, 21692, 74, 1, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[973921, 21697, 284, 8, 136, "Input",
 CellTags->"5.2 Solutions"],
Cell[974208, 21707, 739, 21, 310, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[974962, 21731, 242, 6, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[975229, 21741, 177, 5, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[975409, 21748, 131, 3, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[975555, 21754, 99, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[975679, 21759, 198, 5, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[975880, 21766, 14109, 265, 375, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[990026, 22036, 94, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[990123, 22040, 131, 3, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[990303, 22049, 267, 10, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[990573, 22061, 348, 11, 73, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[990946, 22076, 285, 9, 136, "Input",
 CellTags->"5.2 Solutions"],
Cell[991234, 22087, 657, 15, 121, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[991906, 22105, 153, 4, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[992084, 22113, 135, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[992222, 22119, 136, 4, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[992373, 22126, 90, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[992466, 22129, 258, 8, 87, "Input",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[992749, 22141, 135, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[992887, 22147, 92, 2, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[993028, 22155, 459, 16, 117, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[993490, 22173, 270, 8, 69, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[993763, 22183, 522, 18, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[994288, 22203, 377, 11, 126, "InputOnly",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[994702, 22219, 95, 1, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[994822, 22224, 339, 11, 136, "Input",
 CellTags->"5.2 Solutions"],
Cell[995164, 22237, 1501, 44, 328, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[996702, 22286, 167, 5, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[996872, 22293, 447, 9, 121, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[997334, 22305, 398, 12, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[997757, 22321, 272, 9, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[998032, 22332, 589, 17, 103, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[998658, 22354, 95, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[998756, 22358, 1045, 18, 1401, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[999816, 22379, 371, 13, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1000212, 22396, 332, 9, 87, "Input",
 CellTags->"5.2 Solutions"],
Cell[1000547, 22407, 2319, 50, 1401, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1002915, 22463, 222, 8, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1003162, 22475, 247, 7, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1003412, 22484, 278, 9, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1003705, 22496, 325, 12, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1004055, 22512, 288, 9, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1004346, 22523, 273, 9, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1004656, 22537, 109, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1004768, 22542, 278, 9, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1005095, 22557, 251, 8, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1005371, 22569, 315, 11, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1005689, 22582, 277, 10, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1006003, 22597, 86, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1006092, 22601, 224, 8, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1006353, 22614, 340, 11, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1006696, 22627, 224, 8, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1006969, 22641, 273, 9, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1007267, 22654, 126, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1007396, 22659, 317, 11, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1007750, 22675, 150, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1007903, 22681, 125, 3, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1008043, 22687, 238, 8, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1008306, 22699, 113, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1008422, 22704, 62, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1008499, 22708, 99, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1008601, 22711, 288, 8, 73, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1008914, 22723, 135, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1009052, 22728, 739, 25, 121, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1009828, 22758, 94, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1009925, 22762, 94, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1010068, 22769, 124, 3, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1010217, 22776, 126, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1010346, 22781, 317, 11, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1010678, 22795, 421, 13, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1011124, 22812, 174, 5, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1011301, 22819, 239, 7, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1011577, 22831, 151, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1011731, 22837, 62, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1011808, 22841, 432, 14, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1012243, 22857, 278, 8, 126, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1012546, 22869, 98, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1012647, 22873, 62, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1012758, 22880, 111, 2, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1012894, 22886, 139, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1013036, 22892, 317, 11, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1013368, 22906, 268, 10, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1013661, 22920, 155, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1013819, 22926, 289, 11, 87, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1014123, 22940, 224, 8, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1014372, 22952, 117, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1014492, 22957, 291, 10, 76, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1014798, 22970, 402, 15, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1015203, 22987, 261, 7, 73, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1015489, 22998, 115, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1015607, 23003, 540, 18, 76, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1016162, 23024, 135, 3, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1016322, 23031, 96, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1016421, 23035, 131, 4, 85, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1016567, 23042, 98, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1016668, 23045, 269, 7, 126, "InputOnly",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1016962, 23056, 96, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1017061, 23060, 94, 3, 76, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1017170, 23066, 235, 7, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1017430, 23077, 86, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1017519, 23081, 109, 1, 130, "Print",
 CellTags->{"5.2 Solutions", "Info3563802280-1903310"}],
Cell[1017631, 23084, 1377, 36, 283, "Print",
 CellTags->{"5.2 Solutions", "Info3563802280-1903310"}]
}, Closed]],
Cell[1019023, 23123, 307, 6, 168, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1019333, 23131, 673, 18, 168, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1020009, 23151, 633, 19, 243, "Input",
 CellTags->"5.2 Solutions"],
Cell[1020645, 23172, 160, 4, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1020830, 23180, 115, 3, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1020948, 23185, 471, 16, 76, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1021468, 23207, 242, 8, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[1021713, 23217, 479, 14, 139, "Input",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1022217, 23235, 155, 4, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1022375, 23241, 1079, 32, 315, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1023503, 23279, 293, 7, 117, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1023821, 23290, 283, 9, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1024107, 23301, 250, 8, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1024372, 23312, 107, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[1024482, 23315, 225, 6, 87, "Input",
 CellTags->"5.2 Solutions"],
Cell[1024710, 23323, 180, 4, 117, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1024915, 23331, 453, 15, 105, "Input",
 CellTags->"5.2 Solutions"],
Cell[1025371, 23348, 1140, 41, 154, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1026548, 23394, 89, 2, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1026640, 23398, 56, 1, 67, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1026711, 23402, 489, 10, 220, "SolutionText",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1027237, 23417, 182, 5, 67, "SolutionItem",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1027444, 23426, 234, 7, 82, "Input",
 CellTags->"5.2 Solutions"],
Cell[1027681, 23435, 686, 12, 222, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1028404, 23452, 288, 10, 100, "Input",
 CellTags->"5.2 Solutions"],
Cell[1028695, 23464, 355, 7, 222, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]],
Cell[1029065, 23474, 97, 1, 67, "SolutionText",
 CellTags->"5.2 Solutions"],
Cell[CellGroupData[{
Cell[1029187, 23479, 331, 11, 103, "Input",
 CellTags->"5.2 Solutions"],
Cell[1029521, 23492, 355, 7, 222, "Output",
 CellTags->"5.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1029949, 23507, 87, 1, 45, "ExerciseSubsection",
 CellTags->"Sec.Iterating functions"],
Cell[1030039, 23510, 360, 11, 123, "ExerciseItem",
 CellTags->{"i:44", "5.3 Exercises"}],
Cell[1030402, 23523, 154, 4, 67, "ExerciseItem",
 CellTags->{"i:45", "5.3 Exercises"}],
Cell[1030559, 23529, 931, 37, 117, "ExerciseItem",
 CellTags->"5.3 Exercises"],
Cell[CellGroupData[{
Cell[1031515, 23570, 325, 6, 163, "ExerciseItem",
 CellTags->{"i:150", "5.3 Exercises"}],
Cell[1031843, 23578, 691, 21, 220, "ExerciseDisplayFormula",
 CellTags->"5.3 Exercises"],
Cell[1032537, 23601, 164, 4, 73, "ExerciseText",
 CellTags->"5.3 Exercises"],
Cell[1032704, 23607, 3060, 72, 222, "ExerciseDisplayFormula",
 CellTags->"5.3 Exercises"],
Cell[1035767, 23681, 561, 15, 175, "ExerciseText",
 CellTags->"5.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1036365, 23701, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1036429, 23705, 87, 1, 67, "SolutionItem",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1036541, 23710, 246, 8, 103, "Input",
 CellTags->"5.3 Solutions"],
Cell[1036790, 23720, 314, 10, 67, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[1037119, 23733, 80, 1, 67, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1037224, 23738, 219, 7, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1037446, 23747, 276, 8, 67, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[1037737, 23758, 158, 5, 67, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1037920, 23767, 129, 3, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1038052, 23772, 362, 12, 67, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1038463, 23790, 154, 4, 67, "SolutionItem",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1038642, 23798, 509, 17, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1039154, 23817, 713, 25, 121, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1039904, 23847, 178, 5, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1040085, 23854, 730, 25, 121, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1040864, 23885, 332, 13, 67, "SolutionItem",
 CellTags->"5.3 Solutions"],
Cell[1041199, 23900, 216, 6, 73, "InputOnly",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1041440, 23910, 85, 2, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1041528, 23914, 62, 1, 67, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1041639, 23921, 310, 10, 117, "SolutionItem",
 CellTags->"5.3 Solutions"],
Cell[1041952, 23933, 389, 14, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1042344, 23949, 103, 1, 67, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1042472, 23954, 116, 3, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1042591, 23959, 274, 9, 67, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[1042880, 23971, 260, 7, 117, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1043165, 23982, 523, 15, 240, "Input",
 CellTags->"5.3 Solutions"],
Cell[1043691, 23999, 309, 8, 364, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[1044015, 24010, 243, 8, 67, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1044283, 24022, 593, 18, 240, "Input",
 CellTags->"5.3 Solutions"],
Cell[1044879, 24042, 724, 15, 364, "Output",
 CellTags->"5.3 Solutions"]
}, Closed]],
Cell[1045618, 24060, 241, 5, 117, "SolutionText",
 CellTags->"5.3 Solutions"],
Cell[1045862, 24067, 1511, 43, 397, "Input",
 CellTags->"5.3 Solutions"],
Cell[CellGroupData[{
Cell[1047398, 24114, 164, 4, 82, "Input",
 CellTags->"5.3 Solutions"],
Cell[1047565, 24120, 26557, 439, 634, 1818, 31, "CachedBoxData", "BoxData", \
"Output",
 CellTags->"5.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1074195, 24567, 51, 0, 45, "ExerciseSubsection"],
Cell[1074249, 24569, 329, 11, 76, "ExerciseItem",
 CellTags->{"Exercise.Total ints", "5.4 Exercises"}],
Cell[1074581, 24582, 266, 10, 67, "ExerciseItem",
 CellTags->"5.4 Exercises"],
Cell[1074850, 24594, 297, 8, 117, "ExerciseItem",
 CellTags->"5.4 Exercises"],
Cell[CellGroupData[{
Cell[1075172, 24606, 588, 15, 163, "ExerciseItem",
 CellTags->{"i:54", "5.4 Exercises"}],
Cell[CellGroupData[{
Cell[1075785, 24625, 198, 6, 82, "ExerciseInput",
 CellTags->"5.4 Exercises"],
Cell[1075986, 24633, 156, 4, 67, "ExerciseOutput",
 CellTags->"5.4 Exercises"]
}, Closed]],
Cell[1076157, 24640, 600, 19, 123, "ExerciseText",
 CellTags->"5.4 Exercises"],
Cell[CellGroupData[{
Cell[1076782, 24663, 259, 7, 82, "ExerciseInput",
 CellTags->"5.4 Exercises"],
Cell[1077044, 24672, 232, 6, 67, "ExerciseOutput",
 CellTags->"5.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[1077303, 24682, 442, 15, 123, "ExerciseItem",
 CellTags->"5.4 Exercises"],
Cell[1077748, 24699, 637, 23, 117, "ExerciseItem",
 CellTags->{"i:55", "5.4 Exercises"}],
Cell[1078388, 24724, 944, 30, 163, "ExerciseItem",
 CellTags->{"Ex.interleave", "5.4 Exercises"}],
Cell[1079335, 24756, 662, 23, 117, "ExerciseItem",
 CellTags->{"i:56", "5.4 Exercises"}],
Cell[CellGroupData[{
Cell[1080022, 24783, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1080086, 24787, 201, 8, 67, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1080290, 24797, 182, 5, 73, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1080497, 24806, 90, 2, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1080590, 24810, 59, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1080686, 24816, 91, 2, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1080780, 24820, 61, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1080856, 24824, 246, 8, 117, "SolutionText",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1081139, 24837, 815, 25, 168, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1081957, 24864, 243, 7, 73, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1082225, 24875, 171, 5, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1082399, 24882, 59, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1082495, 24888, 171, 5, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1082669, 24895, 60, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1082744, 24899, 342, 12, 67, "SolutionText",
 CellTags->"5.4 Solutions"],
Cell[1083089, 24913, 306, 10, 73, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1083420, 24927, 171, 5, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1083594, 24934, 59, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1083690, 24940, 171, 5, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1083864, 24947, 60, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1083973, 24954, 435, 11, 168, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1084411, 24967, 553, 16, 139, "Input",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1084989, 24987, 158, 4, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1085150, 24993, 675, 11, 172, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1085874, 25010, 543, 17, 117, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1086420, 25029, 407, 12, 73, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1086852, 25045, 237, 7, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1087092, 25054, 208, 5, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1087349, 25065, 152, 4, 67, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1087504, 25071, 437, 12, 141, "Input",
 CellTags->"5.4 Solutions"],
Cell[1087944, 25085, 303, 9, 87, "Input",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1088272, 25098, 249, 7, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1088524, 25107, 8250, 332, 855, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1096811, 25444, 292, 8, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1097106, 25454, 5042, 172, 535, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1102197, 25632, 130, 5, 67, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1102330, 25639, 677, 17, 280, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1103032, 25660, 159, 4, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1103194, 25666, 79, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1103288, 25670, 291, 9, 73, "InputOnly",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1103604, 25683, 146, 4, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1103753, 25689, 67, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1103835, 25693, 727, 24, 168, "SolutionText",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1104599, 25722, 286, 10, 117, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[1104888, 25734, 636, 20, 190, "Input",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1105549, 25758, 242, 7, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1105794, 25767, 154, 4, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1105963, 25774, 216, 8, 67, "SolutionText",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1106204, 25786, 238, 7, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1106445, 25795, 154, 4, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1106648, 25805, 145, 5, 67, "SolutionItem",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1106818, 25814, 324, 7, 189, "Input",
 CellTags->"5.4 Solutions"],
Cell[1107145, 25823, 82, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]],
Cell[1107242, 25827, 145, 5, 67, "SolutionText",
 CellTags->"5.4 Solutions"],
Cell[CellGroupData[{
Cell[1107412, 25836, 175, 4, 82, "Input",
 CellTags->"5.4 Solutions"],
Cell[1107590, 25842, 82, 1, 67, "Output",
 CellTags->"5.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1107745, 25851, 85, 1, 45, "ExerciseSubsection",
 CellTags->"Sec.Scoping constructs"],
Cell[1107833, 25854, 725, 23, 171, "ExerciseItem",
 CellTags->{"i:70", "5.5 Exercises"}],
Cell[1108561, 25879, 1326, 44, 256, "ExerciseItem",
 CellTags->{"Ex.Perfect numbers", "i:71", "5.5 Exercises"}],
Cell[1109890, 25925, 988, 38, 163, "ExerciseItem",
 CellTags->"5.5 Exercises"],
Cell[CellGroupData[{
Cell[1110903, 25967, 1451, 47, 256, "ExerciseItem",
 CellTags->{"i:72", "5.5 Exercises"}],
Cell[CellGroupData[{
Cell[1112379, 26018, 125, 3, 82, "ExerciseInput",
 CellTags->"5.5 Exercises"],
Cell[1112507, 26023, 139, 4, 67, "ExerciseOutput",
 CellTags->"5.5 Exercises"]
}, Closed]]
}, Closed]],
Cell[1112673, 26031, 592, 21, 123, "ExerciseItem",
 CellTags->"5.5 Exercises"],
Cell[CellGroupData[{
Cell[1113290, 26056, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1113354, 26060, 261, 8, 67, "SolutionItem",
 CellTags->"5.5 Solutions"],
Cell[1113618, 26070, 708, 22, 177, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1114351, 26096, 95, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1114449, 26100, 860, 32, 121, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1115358, 26138, 614, 21, 117, "SolutionItem",
 CellTags->"5.5 Solutions"],
Cell[1115975, 26161, 645, 19, 180, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1116645, 26184, 121, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1116769, 26189, 127, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1116911, 26195, 535, 13, 175, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1117471, 26212, 121, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1117595, 26217, 73, 2, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1117683, 26222, 295, 8, 117, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1117981, 26232, 102, 2, 69, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[1118086, 26236, 674, 20, 180, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[1118763, 26258, 113, 2, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1118901, 26264, 121, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1119025, 26269, 127, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1119189, 26277, 120, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1119312, 26282, 121, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1119482, 26291, 92, 1, 67, "SolutionItem",
 CellTags->"5.5 Solutions"],
Cell[1119577, 26294, 736, 21, 244, "Input",
 CellTags->"5.5 Solutions"],
Cell[1120316, 26317, 447, 10, 168, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1120788, 26331, 174, 5, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1120965, 26338, 201, 6, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1121181, 26347, 298, 11, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1121482, 26360, 801, 22, 231, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1122308, 26386, 182, 5, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1122493, 26393, 201, 6, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1122743, 26405, 369, 10, 117, "SolutionItem",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1123137, 26419, 104, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1123244, 26423, 150, 4, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1123409, 26430, 320, 10, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1123754, 26444, 96, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1123853, 26448, 152, 4, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1124020, 26455, 104, 1, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1124149, 26460, 131, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1124283, 26465, 150, 4, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1124448, 26472, 91, 1, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1124564, 26477, 108, 3, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1124675, 26482, 115, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1124805, 26488, 104, 1, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1124912, 26491, 264, 8, 73, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1125201, 26503, 101, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1125305, 26507, 115, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1125435, 26513, 255, 8, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1125693, 26523, 778, 24, 177, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1126496, 26551, 102, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1126601, 26555, 143, 4, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1126759, 26562, 515, 15, 117, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1127277, 26579, 864, 26, 229, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1128166, 26609, 102, 2, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1128271, 26613, 115, 3, 67, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1128435, 26622, 249, 5, 117, "SolutionItem",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1128709, 26631, 281, 8, 136, "Input",
 CellTags->"5.5 Solutions"],
Cell[1128993, 26641, 1241, 26, 310, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[1130249, 26670, 94, 1, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1130346, 26673, 468, 14, 177, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[1130817, 26689, 105, 1, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1130925, 26692, 552, 17, 177, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[1131480, 26711, 166, 4, 67, "SolutionText",
 CellTags->"5.5 Solutions"],
Cell[1131649, 26717, 516, 16, 177, "InputOnly",
 CellTags->"5.5 Solutions"],
Cell[CellGroupData[{
Cell[1132190, 26737, 151, 4, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1132344, 26743, 1146, 26, 310, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1133527, 26774, 177, 5, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1133707, 26781, 1057, 26, 310, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1134801, 26812, 215, 7, 82, "Input",
 CellTags->"5.5 Solutions"],
Cell[1135019, 26821, 928, 21, 310, "Output",
 CellTags->"5.5 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1136020, 26850, 44, 0, 45, "ExerciseSubsection"],
Cell[1136067, 26852, 130, 3, 49, "ExerciseItem",
 CellTags->"5.6 Exercises"],
Cell[1136200, 26857, 687, 22, 100, "ExerciseItem",
 CellTags->{"i:85", "5.6 Exercises"}],
Cell[1136890, 26881, 493, 16, 72, "ExerciseItem",
 CellTags->"5.6 Exercises"],
Cell[1137386, 26899, 525, 19, 72, "ExerciseItem",
 CellTags->{"i:87", "5.6 Exercises", "Ex.Repunit"}],
Cell[CellGroupData[{
Cell[1137936, 26922, 196, 4, 72, "ExerciseItem",
 CellTags->{"i:86", "5.6 Exercises"}],
Cell[1138135, 26928, 292, 9, 33, "ExerciseInput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[1138442, 26940, 1224, 45, 136, "ExerciseItem",
 CellTags->{"5.6 Exercises", "i:156"}],
Cell[CellGroupData[{
Cell[1139691, 26989, 323, 10, 72, "ExerciseItem",
 CellTags->{"i:89", "5.6 Exercises"}],
Cell[CellGroupData[{
Cell[1140039, 27003, 256, 6, 63, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1140298, 27011, 737, 12, 118, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1141084, 27029, 1035, 31, 84, "ExerciseItem",
 CellTags->{"i:90", "5.6 Exercises"}],
Cell[CellGroupData[{
Cell[1142144, 27064, 290, 9, 42, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1142437, 27075, 78, 1, 33, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1142552, 27081, 331, 11, 33, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1142886, 27094, 78, 1, 24, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[1142979, 27098, 201, 6, 27, "ExerciseText",
 CellTags->"5.6 Exercises"],
Cell[CellGroupData[{
Cell[1143205, 27108, 160, 5, 82, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1143368, 27115, 178, 5, 117, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[1143561, 27123, 610, 18, 175, "ExerciseText",
 CellTags->"5.6 Exercises"],
Cell[CellGroupData[{
Cell[1144196, 27145, 204, 6, 82, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1144403, 27153, 284, 10, 67, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1144724, 27168, 109, 2, 82, "ExerciseInput",
 CellTags->"5.6 Exercises"],
Cell[1144836, 27172, 239, 7, 76, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1145124, 27185, 614, 18, 171, "ExerciseItem",
 CellTags->{"i:91", "5.6 Exercises"}],
Cell[CellGroupData[{
Cell[1145763, 27207, 261, 8, 82, "Input",
 CellTags->"5.6 Exercises"],
Cell[1146027, 27217, 7012, 163, 292, "Output",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[1153054, 27383, 303, 7, 123, "ExerciseText",
 CellTags->"5.6 Exercises"],
Cell[1153360, 27392, 182, 6, 67, "ExerciseOutput",
 CellTags->"5.6 Exercises"],
Cell[1153545, 27400, 607, 20, 175, "ExerciseText",
 CellTags->"5.6 Exercises"],
Cell[1154155, 27422, 1119, 38, 121, "ExerciseOutput",
 CellTags->"5.6 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1155311, 27465, 606, 21, 127, "ExerciseItem",
 CellTags->"5.6 Exercises"],
Cell[CellGroupData[{
Cell[1155942, 27490, 304, 9, 87, "ExerciseInput",
 CellTags->{"i:92", "5.6 Exercises"}],
Cell[1156249, 27501, 954, 33, 72, "ExerciseOutput",
 CellTags->{"i:92", "5.6 Exercises"}]
}, Closed]]
}, Closed]],
Cell[1157230, 27538, 697, 21, 217, "ExerciseItem",
 CellTags->{"i:93", "5.6 Exercises"}],
Cell[CellGroupData[{
Cell[1157952, 27563, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1158016, 27567, 111, 2, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1158130, 27571, 186, 5, 90, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1158341, 27580, 176, 5, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1158520, 27587, 58, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1158593, 27591, 88, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1158706, 27596, 286, 9, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1158995, 27607, 58, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1159068, 27611, 62, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1159155, 27616, 239, 8, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1159397, 27626, 58, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1159504, 27633, 389, 13, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1159918, 27650, 191, 6, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1160112, 27658, 475, 14, 121, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1160624, 27677, 220, 7, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1160847, 27686, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1160958, 27692, 233, 7, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1161194, 27701, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1161283, 27705, 153, 4, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1161461, 27713, 166, 5, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1161630, 27720, 1560, 48, 328, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1163205, 27771, 244, 8, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1163474, 27783, 227, 7, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1163704, 27792, 261, 6, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1164002, 27803, 84, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1164089, 27807, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1164178, 27811, 269, 8, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1164472, 27823, 247, 8, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1164722, 27833, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1164811, 27837, 349, 11, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1165163, 27850, 424, 13, 73, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1165612, 27867, 91, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1165706, 27871, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1165795, 27875, 289, 8, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1166109, 27887, 282, 8, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1166394, 27897, 74, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1166505, 27903, 581, 19, 136, "Input",
 CellTags->"5.6 Solutions"],
Cell[1167089, 27924, 137, 4, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1167263, 27933, 317, 9, 136, "Input",
 CellTags->"5.6 Solutions"],
Cell[1167583, 27944, 138, 4, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1167770, 27954, 181, 7, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1167954, 27963, 378, 12, 87, "Input",
 CellTags->"5.6 Solutions"],
Cell[1168335, 27977, 90, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1168450, 27982, 210, 6, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1168663, 27990, 59, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1168737, 27994, 94, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1168856, 27999, 171, 5, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1169030, 28006, 123, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1169190, 28014, 171, 5, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1169364, 28021, 122, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1169535, 28030, 101, 1, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1169639, 28033, 305, 10, 87, "Input",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1169969, 28047, 88, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1170060, 28051, 62, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1170159, 28057, 196, 6, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1170358, 28065, 278, 6, 121, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1170685, 28077, 113, 2, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1170801, 28081, 271, 8, 69, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[1171075, 28091, 159, 4, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1171259, 28099, 1241, 36, 447, "Input",
 CellTags->"5.6 Solutions"],
Cell[1172503, 28137, 7791, 135, 760, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1180309, 28275, 152, 4, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1180464, 28281, 352, 12, 69, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[1180819, 28295, 220, 6, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1181064, 28305, 181, 5, 153, "Input",
 CellTags->"5.6 Solutions"],
Cell[1181248, 28312, 61, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1181346, 28318, 960, 27, 292, "Input",
 CellTags->"5.6 Solutions"],
Cell[1182309, 28347, 5370, 95, 769, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1187728, 28448, 185, 4, 117, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1187938, 28456, 706, 22, 189, "Input",
 CellTags->"5.6 Solutions"],
Cell[1188647, 28480, 772, 27, 121, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1189434, 28510, 293, 8, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1189752, 28522, 581, 19, 136, "Input",
 CellTags->"5.6 Solutions"],
Cell[1190336, 28543, 713, 25, 121, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1191098, 28574, 170, 6, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1191271, 28582, 138, 4, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1191412, 28588, 160, 6, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1191597, 28598, 241, 6, 139, "Input",
 CellTags->"5.6 Solutions"],
Cell[1191841, 28606, 604, 10, 172, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1192460, 28619, 493, 18, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1192978, 28641, 285, 9, 87, "Input",
 CellTags->"5.6 Solutions"],
Cell[1193266, 28652, 965, 15, 222, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1194280, 28673, 312, 11, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[1194595, 28686, 299, 10, 73, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1194919, 28700, 192, 6, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1195114, 28708, 358, 13, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1195509, 28726, 87, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1195599, 28730, 275, 9, 76, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1195923, 28745, 98, 1, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1196046, 28750, 333, 10, 136, "Input",
 CellTags->"5.6 Solutions"],
Cell[1196382, 28762, 7581, 171, 910, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1203978, 28936, 92, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1204095, 28941, 90, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1204188, 28945, 835, 18, 121, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1205060, 28968, 92, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1205155, 28972, 189, 5, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1205359, 28980, 239, 8, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1205623, 28992, 500, 15, 189, "Input",
 CellTags->"5.6 Solutions"],
Cell[1206126, 29009, 111, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1206252, 29015, 249, 8, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1206504, 29025, 819, 24, 294, "Input",
 CellTags->"5.6 Solutions"],
Cell[1207326, 29051, 153, 4, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1207482, 29057, 372, 11, 139, "Input",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1207879, 29072, 100, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1207982, 29076, 1300, 45, 172, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1209297, 29124, 98, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1209420, 29129, 576, 14, 136, "Input",
 CellTags->"5.6 Solutions"],
Cell[1209999, 29145, 7055, 140, 522, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1217091, 29290, 101, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1217195, 29294, 485, 17, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1217729, 29317, 278, 9, 67, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1218032, 29330, 374, 13, 87, "Input",
 CellTags->"5.6 Solutions"],
Cell[1218409, 29345, 920, 32, 72, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1219344, 29380, 323, 9, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1219670, 29391, 431, 13, 139, "Input",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1220126, 29408, 189, 6, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1220318, 29416, 630, 22, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1220997, 29444, 224, 6, 117, "SolutionItem",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1221246, 29454, 122, 3, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1221371, 29459, 258, 9, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1221644, 29471, 89, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1221758, 29476, 114, 3, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1221875, 29481, 111, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1222001, 29487, 137, 5, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1222163, 29496, 107, 3, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1222273, 29501, 60, 1, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1222348, 29505, 164, 4, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1222537, 29513, 340, 11, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1222880, 29526, 1128, 17, 328, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1224023, 29546, 330, 11, 127, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1224378, 29561, 613, 19, 220, "Input",
 CellTags->"5.6 Solutions"],
Cell[1224994, 29582, 121, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1225130, 29588, 1679, 51, 117, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[1226812, 29641, 1370, 39, 460, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[1228185, 29682, 228, 7, 73, "InputOnly",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1228438, 29693, 99, 2, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1228540, 29697, 307, 7, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1228884, 29709, 126, 3, 82, "Input",
 CellTags->"5.6 Solutions"],
Cell[1229013, 29714, 129, 3, 67, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]],
Cell[1229157, 29720, 96, 1, 67, "SolutionText",
 CellTags->"5.6 Solutions"],
Cell[CellGroupData[{
Cell[1229278, 29725, 149, 4, 103, "Input",
 CellTags->"5.6 Solutions"],
Cell[1229430, 29731, 211, 6, 172, "Output",
 CellTags->"5.6 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1229714, 29745, 50, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[1229789, 29749, 485, 13, 171, "ExerciseItem",
 CellTags->{"Ex.SwitchRows", "5.7 Exercises"}],
Cell[CellGroupData[{
Cell[1230299, 29766, 359, 10, 136, "ExerciseInput",
 CellTags->"5.7 Exercises"],
Cell[1230661, 29778, 709, 20, 261, "ExerciseOutput",
 CellTags->"5.7 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1231407, 29803, 187, 5, 82, "ExerciseInput",
 CellTags->"5.7 Exercises"],
Cell[1231597, 29810, 488, 10, 175, "Message",
 CellTags->"5.7 Exercises"],
Cell[1232088, 29822, 422, 12, 67, "ExerciseOutput",
 CellTags->"5.7 Exercises"]
}, Closed]],
Cell[1232525, 29837, 136, 5, 73, "ExerciseText",
 CellTags->"5.7 Exercises"],
Cell[CellGroupData[{
Cell[1232686, 29846, 187, 5, 82, "ExerciseInput",
 CellTags->"5.7 Exercises"],
Cell[1232876, 29853, 488, 10, 175, "Message",
 CellTags->"5.7 Exercises"],
Cell[1233367, 29865, 422, 12, 67, "ExerciseOutput",
 CellTags->"5.7 Exercises"]
}, Closed]]
}, Closed]],
Cell[1233816, 29881, 250, 6, 123, "ExerciseItem",
 CellTags->"5.7 Exercises"],
Cell[CellGroupData[{
Cell[1234091, 29891, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1234155, 29895, 262, 6, 117, "SolutionItem",
 CellTags->"5.7 Solutions"],
Cell[1234420, 29903, 281, 7, 226, "InputOnly",
 CellTags->"5.7 Solutions"],
Cell[1234704, 29912, 251, 7, 117, "SolutionText",
 CellTags->"5.7 Solutions"],
Cell[1234958, 29921, 1318, 39, 333, "InputOnly",
 CellTags->"5.7 Solutions"],
Cell[CellGroupData[{
Cell[1236301, 29964, 284, 8, 136, "Input",
 CellTags->"5.7 Solutions"],
Cell[1236588, 29974, 687, 20, 261, "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1237312, 29999, 165, 5, 82, "Input",
 CellTags->"5.7 Solutions"],
Cell[1237480, 30006, 439, 9, 175, "Message",
 CellTags->"5.7 Solutions"],
Cell[1237922, 30017, 397, 11, 67, "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1238356, 30033, 165, 5, 82, "Input",
 CellTags->"5.7 Solutions"],
Cell[1238524, 30040, 439, 9, 175, "Message",
 CellTags->"5.7 Solutions"],
Cell[1238966, 30051, 397, 11, 67, "Output",
 CellTags->"5.7 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1239412, 30068, 139, 4, 67, "SolutionItem",
 CellTags->"5.7 Solutions"],
Cell[CellGroupData[{
Cell[1239576, 30076, 226, 7, 87, "Input",
 CellTags->"5.7 Solutions"],
Cell[1239805, 30085, 60, 1, 67, "Output",
 CellTags->"5.7 Solutions"]
}, Closed]],
Cell[1239880, 30089, 72, 1, 67, "SolutionText",
 CellTags->"5.7 Solutions"],
Cell[1239955, 30092, 207, 6, 123, "InputOnly",
 CellTags->"5.7 Solutions"],
Cell[1240165, 30100, 183, 5, 69, "InputOnly",
 CellTags->"5.7 Solutions"],
Cell[1240351, 30107, 704, 21, 283, "InputOnly",
 CellTags->"5.7 Solutions"],
Cell[CellGroupData[{
Cell[1241080, 30132, 89, 2, 82, "Input",
 CellTags->"5.7 Solutions"],
Cell[1241172, 30136, 225, 6, 72, "Message",
 CellTags->"5.7 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1241434, 30147, 146, 4, 82, "Input",
 CellTags->"5.7 Solutions"],
Cell[1241583, 30153, 225, 6, 72, "Message",
 CellTags->"5.7 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1241845, 30164, 169, 5, 82, "Input",
 CellTags->"5.7 Solutions"],
Cell[1242017, 30171, 711, 17, 357, "Output",
 CellTags->"5.7 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1242801, 30196, 55, 0, 45, "ExerciseSubsection"],
Cell[1242859, 30198, 361, 9, 85, "ExerciseItem",
 CellTags->{"i:133", "5.8 Exercises"}],
Cell[1243223, 30209, 317, 9, 81, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[1243543, 30220, 592, 20, 81, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[1244138, 30242, 676, 22, 114, "ExerciseItem",
 CellTags->{"5.8 Exercises", "i:154"}],
Cell[CellGroupData[{
Cell[1244839, 30268, 436, 7, 148, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1245300, 30279, 131, 3, 45, "ExerciseSubItem",
 CellTags->"5.8 Exercises"],
Cell[1245434, 30284, 398, 13, 87, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1245857, 30301, 210, 6, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1246070, 30309, 266, 9, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1246373, 30323, 224, 6, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1246600, 30331, 280, 9, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1246929, 30346, 148, 4, 36, "ExerciseSubItem",
 CellTags->"5.8 Exercises"],
Cell[1247080, 30352, 722, 23, 190, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1247827, 30379, 238, 7, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1248068, 30388, 352, 11, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[1248435, 30402, 126, 3, 73, "ExerciseText",
 CellTags->"5.8 Exercises"],
Cell[1248564, 30407, 554, 17, 190, "ExerciseInput",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],
Cell[1249145, 30428, 913, 31, 118, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[1250061, 30461, 398, 10, 81, "ExerciseItem",
 CellTags->{"i:135", "5.8 Exercises"}],
Cell[1250462, 30473, 299, 8, 81, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1250786, 30485, 400, 10, 81, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1251211, 30499, 178, 4, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1251392, 30505, 237, 5, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1251678, 30516, 746, 26, 81, "ExerciseItem",
 CellTags->{"Ex.TruthTable", "i:136", "5.8 Exercises"}],
Cell[CellGroupData[{
Cell[1252449, 30546, 190, 6, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1252642, 30554, 369, 12, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[1253026, 30569, 370, 14, 73, "ExerciseText",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1253433, 30588, 689, 27, 81, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1254147, 30619, 186, 5, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1254336, 30626, 597, 10, 121, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1254970, 30641, 156, 4, 82, "ExerciseInput",
 CellTags->"5.8 Exercises"],
Cell[1255129, 30647, 187, 5, 67, "ExerciseOutput",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[1255331, 30655, 673, 27, 73, "ExerciseText",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1256029, 30686, 170, 4, 82, "Input",
 CellTags->"5.8 Exercises"],
Cell[1256202, 30692, 277, 6, 67, "Output",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[1256494, 30701, 446, 13, 123, "ExerciseText",
 CellTags->{"i:137", "5.8 Exercises"}],
Cell[1256943, 30716, 883, 34, 123, "ExerciseText",
 CellTags->"5.8 Exercises"]
}, Closed]],
Cell[1257841, 30753, 1066, 36, 153, "ExerciseItem",
 CellTags->"5.8 Exercises"],
Cell[CellGroupData[{
Cell[1258932, 30793, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1258996, 30797, 78, 1, 49, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1259077, 30800, 331, 11, 136, "Input",
 CellTags->"5.8 Solutions"],
Cell[1259411, 30813, 69, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1259505, 30818, 165, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1259673, 30825, 376, 13, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1260064, 30841, 270, 7, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1260359, 30852, 223, 7, 87, "Input",
 CellTags->"5.8 Solutions"],
Cell[1260585, 30861, 56, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1260656, 30865, 110, 2, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1260769, 30869, 461, 14, 127, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1261255, 30887, 122, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1261380, 30892, 56, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1261451, 30896, 565, 16, 168, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1262019, 30914, 254, 7, 73, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1262276, 30923, 224, 7, 90, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1262503, 30932, 224, 7, 90, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1262752, 30943, 162, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1262917, 30949, 126, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1263080, 30957, 162, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1263245, 30963, 123, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1263417, 30972, 295, 9, 117, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1263715, 30983, 277, 8, 73, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1263995, 30993, 358, 9, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1264356, 31004, 223, 7, 90, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1264582, 31013, 223, 7, 90, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1264808, 31022, 373, 11, 126, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1265206, 31037, 460, 14, 189, "Input",
 CellTags->"5.8 Solutions"],
Cell[1265669, 31053, 617, 18, 222, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1266335, 31077, 479, 13, 117, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1266817, 31092, 423, 13, 126, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1267265, 31109, 113, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1267381, 31114, 1227, 35, 222, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1268657, 31155, 161, 4, 67, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1268821, 31161, 409, 13, 139, "Input",
 CellTags->"5.8 Solutions"],
Cell[1269233, 31176, 138, 3, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1269374, 31181, 641, 20, 243, "Input",
 CellTags->"5.8 Solutions"],
Cell[1270018, 31203, 310, 9, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1270331, 31214, 174, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1270508, 31221, 174, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1270707, 31230, 120, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1270830, 31235, 124, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1270991, 31243, 120, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1271114, 31248, 123, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1271274, 31256, 120, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1271397, 31261, 123, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1271557, 31269, 120, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1271680, 31274, 124, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1271819, 31280, 270, 5, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1272092, 31287, 91, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1272186, 31291, 456, 15, 139, "Input",
 CellTags->"5.8 Solutions"],
Cell[1272645, 31308, 661, 21, 190, "Input",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1273343, 31334, 52, 1, 67, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1273420, 31339, 312, 12, 67, "SolutionSubItem",
 CellTags->"5.8 Solutions"],
Cell[1273735, 31353, 571, 17, 193, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1274331, 31374, 208, 6, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1274542, 31382, 258, 9, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1274849, 31397, 144, 3, 67, "SolutionSubItem",
 CounterAssignments->{{"SolutionSubItem", 1}},
 CellTags->"5.8 Solutions"],
Cell[1274996, 31402, 997, 30, 247, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1276018, 31436, 213, 6, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1276234, 31444, 328, 10, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1276577, 31457, 737, 22, 193, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1277339, 31483, 213, 6, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1277555, 31491, 328, 10, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1277932, 31507, 97, 2, 67, "SolutionSubItem",
 CellTags->"5.8 Solutions"],
Cell[1278032, 31511, 1187, 35, 405, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1279244, 31550, 144, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1279391, 31556, 131, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1279537, 31562, 612, 18, 243, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1280174, 31584, 144, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1280321, 31590, 132, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1280514, 31600, 106, 1, 67, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1280623, 31603, 239, 7, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1280865, 31612, 88, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1280978, 31617, 259, 8, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1281240, 31627, 121, 3, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1281376, 31633, 135, 3, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1281536, 31640, 152, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1281691, 31646, 60, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1281766, 31650, 506, 15, 126, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1282297, 31669, 96, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1282396, 31673, 60, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1282471, 31677, 537, 15, 177, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1283033, 31696, 97, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1283133, 31700, 60, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1283208, 31704, 86, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1283319, 31709, 313, 9, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1283635, 31720, 332, 11, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1284004, 31736, 181, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1284188, 31743, 60, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1284263, 31747, 756, 21, 177, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1285044, 31772, 97, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1285144, 31776, 60, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1285253, 31783, 338, 11, 117, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1285594, 31796, 314, 10, 73, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1285911, 31808, 533, 17, 139, "Input",
 CellTags->"5.8 Solutions"],
Cell[1286447, 31827, 512, 19, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1286962, 31848, 1158, 35, 369, "Input",
 CellTags->"5.8 Solutions"],
Cell[1288123, 31885, 196, 4, 117, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1288344, 31893, 139, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1288486, 31898, 14568, 245, 402, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1303091, 32148, 139, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1303233, 32153, 134637, 2215, 402, 104360, 1717, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1437907, 34373, 169, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1438079, 34379, 154704, 2538, 495, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1592832, 36923, 163, 5, 67, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1593020, 36932, 1213, 32, 343, "Input",
 CellTags->"5.8 Solutions"],
Cell[1594236, 36966, 781, 25, 310, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1595032, 36994, 426, 17, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1595483, 37015, 418, 13, 141, "Input",
 CellTags->"5.8 Solutions"],
Cell[1595904, 37030, 799, 25, 310, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1596718, 37058, 105, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1596848, 37063, 211, 6, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1597062, 37071, 117, 2, 73, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1597194, 37076, 353, 9, 168, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1597550, 37087, 474, 14, 127, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1598027, 37103, 461, 13, 126, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1598513, 37120, 249, 7, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1598765, 37129, 1185, 32, 310, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1599999, 37167, 138, 2, 67, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 8}},
 CellTags->"5.8 Solutions"],
Cell[1600140, 37171, 109, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1600252, 37176, 183, 6, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1600438, 37184, 157, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1600598, 37191, 124, 3, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1600747, 37198, 235, 7, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1600985, 37207, 717, 19, 172, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1601717, 37229, 167, 4, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1601909, 37237, 236, 8, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1602148, 37247, 1485, 43, 222, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1603648, 37293, 106, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1603779, 37298, 85, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1603867, 37302, 195, 5, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1604077, 37310, 168, 4, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1604270, 37318, 274, 8, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1604547, 37328, 827, 20, 222, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1605389, 37351, 118, 5, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1605532, 37360, 187, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1605722, 37367, 276, 10, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1606013, 37380, 139, 7, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1606177, 37391, 118, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1606298, 37396, 1075, 29, 276, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1607388, 37428, 69, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1607482, 37433, 150, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1607635, 37439, 698, 22, 481, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1608348, 37464, 220, 11, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1608593, 37479, 324, 10, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1608920, 37491, 843, 22, 460, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1609778, 37516, 216, 8, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1610019, 37528, 1069, 32, 240, "Input",
 CellTags->"5.8 Solutions"],
Cell[1611091, 37562, 1093, 28, 540, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1612199, 37593, 76, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1612278, 37596, 2806, 78, 604, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1615109, 37678, 261, 8, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1615373, 37688, 1332, 37, 528, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1616754, 37731, 684, 25, 117, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1617441, 37758, 524, 16, 126, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1617968, 37776, 558, 17, 177, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[1618529, 37795, 186, 5, 69, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1618740, 37804, 132, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1618875, 37809, 165, 5, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1619077, 37819, 156, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1619236, 37825, 277, 6, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1619528, 37834, 703, 20, 220, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1620234, 37856, 879, 25, 229, "InputOnly",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1621138, 37885, 133, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1621274, 37890, 251, 5, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1621574, 37901, 254, 5, 117, "SolutionItem",
 CellTags->"5.8 Solutions"],
Cell[1621831, 37908, 183, 5, 87, "Input",
 CellTags->"5.8 Solutions"],
Cell[1622017, 37915, 151, 4, 87, "Input",
 CellTags->"5.8 Solutions"],
Cell[1622171, 37921, 287, 9, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1622483, 37934, 121, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1622607, 37939, 259, 9, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1622903, 37953, 92, 2, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1622998, 37957, 220, 7, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1623233, 37967, 128, 3, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1623386, 37974, 200, 7, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1623589, 37983, 208, 7, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1623812, 37993, 68, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1623905, 37998, 120, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1624028, 38003, 57, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1624100, 38007, 126, 3, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1624251, 38014, 128, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1624382, 38019, 57, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1624454, 38023, 103, 1, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1624560, 38026, 705, 21, 190, "Input",
 CellTags->"5.8 Solutions"],
Cell[1625268, 38049, 130, 4, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1625423, 38057, 158, 5, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1625584, 38064, 149, 4, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1625748, 38071, 160, 6, 67, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1625933, 38081, 216, 7, 103, "Input",
 CellTags->"5.8 Solutions"],
Cell[1626152, 38090, 58, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[1626225, 38094, 3230, 60, 168, "SolutionText",
 CellTags->"5.8 Solutions"],
Cell[1629458, 38156, 305, 10, 87, "Input",
 CellTags->"5.8 Solutions"],
Cell[CellGroupData[{
Cell[1629788, 38170, 122, 3, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1629913, 38175, 59, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1630009, 38181, 150, 4, 82, "Input",
 CellTags->"5.8 Solutions"],
Cell[1630162, 38187, 59, 1, 67, "Output",
 CellTags->"5.8 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[1630284, 38195, 776, 17, 42, "TitleFlourish"],
Cell[1631063, 38214, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[1631109, 38218, 64, 1, 67, "ChapterTitle",
 CellTags->"c:1"],
Cell[CellGroupData[{
Cell[1631198, 38223, 49, 0, 67, "ExerciseSubsection"],
Cell[1631250, 38225, 593, 22, 85, "ExerciseItem",
 CellTags->"6.1 Exercises"],
Cell[1631846, 38249, 1054, 35, 114, "ExerciseItem",
 CellTags->{"6.1 Exercises", "Ex.Do and Table", "i:14"}],
Cell[1632903, 38286, 929, 29, 148, "ExerciseItem",
 CellTags->{"6.1 Exercises", "Ex.Fibonacci", "i:15"}],
Cell[1633835, 38317, 497, 12, 114, "ExerciseItem",
 CellTags->"6.1 Exercises"],
Cell[1634335, 38331, 871, 24, 153, "ExerciseItem",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1635231, 38359, 1184, 41, 114, "ExerciseItem",
 CellTags->{"Ex.findRoot", "6.1 Exercises", "i:48"}],
Cell[1636418, 38402, 177, 5, 96, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1636620, 38411, 482, 13, 189, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1637105, 38426, 862, 25, 222, "ExerciseOutput",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[1637982, 38454, 463, 15, 123, "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[1638460, 38472, 367, 8, 114, "ExerciseItem",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1638852, 38484, 1989, 77, 180, "ExerciseItem",
 CellTags->{"6.1 Exercises", "i:16"}],
Cell[1640844, 38563, 1359, 51, 123, "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[1642218, 38617, 1372, 53, 114, "ExerciseItem",
 CellTags->{"Ex.GCD", "6.1 Exercises", "i:18"}],
Cell[CellGroupData[{
Cell[1643615, 38674, 444, 14, 81, "ExerciseItem",
 CellTags->"6.1 Exercises"],
Cell[1644062, 38690, 996, 34, 117, "ExerciseText",
 CellTags->"6.1 Exercises"],
Cell[1645061, 38726, 1265, 36, 397, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1646329, 38764, 371, 12, 82, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1646725, 38780, 116, 2, 82, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1646844, 38784, 667, 19, 207, "ExerciseOutput",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1647548, 38808, 156, 4, 82, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1647707, 38814, 667, 19, 207, "ExerciseOutput",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[1648389, 38836, 306, 11, 73, "ExerciseText",
 CellTags->"6.1 Exercises"],
Cell[1648698, 38849, 1154, 34, 294, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1649877, 38887, 156, 4, 82, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1650036, 38893, 667, 19, 207, "ExerciseOutput",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[1650718, 38915, 351, 13, 67, "ExerciseSubItem",
 CellTags->"6.1 Exercises"],
Cell[1651072, 38930, 551, 21, 54, "ExerciseSubItem",
 CellTags->"6.1 Exercises"],
Cell[CellGroupData[{
Cell[1651648, 38955, 214, 6, 54, "ExerciseSubItem",
 CellTags->"6.1 Exercises"],
Cell[1651865, 38963, 495, 15, 139, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1652363, 38980, 321, 13, 73, "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1652721, 38998, 208, 6, 67, "ExerciseSubItem",
 CellTags->"6.1 Exercises"],
Cell[1652932, 39006, 739, 23, 139, "ExerciseInput",
 CellTags->"6.1 Exercises"],
Cell[1653674, 39031, 461, 18, 73, "ExerciseText",
 CellTags->"6.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1654172, 39054, 2063, 83, 162, "ExerciseSubItem",
 CellTags->"6.1 Exercises"],
Cell[1656238, 39139, 371, 11, 82, "ExerciseInput",
 Evaluatable->False,
 CellTags->"6.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1656658, 39156, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1656722, 39160, 196, 6, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1656943, 39170, 372, 12, 217, "Input",
 CellTags->"6.1 Solutions"],
Cell[1657318, 39184, 147, 5, 127, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1657480, 39192, 313, 9, 117, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[1657796, 39203, 341, 12, 139, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1658162, 39219, 167, 5, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1658332, 39226, 136, 2, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1658517, 39234, 358, 13, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1658878, 39249, 159, 5, 82, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1659062, 39258, 429, 14, 204, "Input",
 CellTags->"6.1 Solutions"],
Cell[1659494, 39274, 362, 8, 121, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1659871, 39285, 868, 25, 319, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1660764, 39314, 161, 5, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1660928, 39321, 124, 3, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1661067, 39327, 93, 1, 67, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1661185, 39332, 171, 5, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1661359, 39339, 125, 3, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1661533, 39348, 297, 8, 117, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1661833, 39358, 711, 20, 333, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1662569, 39382, 200, 6, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1662772, 39390, 192, 5, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1662979, 39398, 134, 3, 67, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[1663116, 39403, 677, 21, 229, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1663818, 39428, 201, 6, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1664022, 39436, 192, 5, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1664229, 39444, 165, 4, 67, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1664419, 39452, 285, 9, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1664707, 39463, 243, 7, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1664999, 39476, 327, 10, 67, "SolutionItem",
 CellTags->{"6.1 Solutions", "Sol.findRoot"}],
Cell[1665329, 39488, 93, 2, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1665425, 39492, 1104, 33, 549, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[1666532, 39527, 154, 5, 87, "Input",
 CellTags->"6.1 Solutions"],
Cell[1666689, 39534, 177, 5, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1666903, 39544, 211, 7, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1667117, 39553, 1131, 34, 459, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[1668251, 39589, 160, 5, 82, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1668436, 39598, 177, 5, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1668616, 39605, 124, 3, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1668789, 39614, 194, 6, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1668986, 39622, 1398, 40, 685, "Input",
 CellTags->"6.1 Solutions"],
Cell[1670387, 39664, 155, 5, 96, "Input",
 CellTags->"6.1 Solutions"],
Cell[1670545, 39671, 172, 5, 103, "Input",
 CellTags->"6.1 Solutions"],
Cell[1670720, 39678, 523, 13, 220, "SolutionText",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1671280, 39696, 176, 5, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1671459, 39703, 1382, 40, 406, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1672866, 39747, 313, 11, 103, "Input",
 CellTags->"6.1 Solutions"],
Cell[1673182, 39760, 157, 5, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1673388, 39771, 153, 4, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1673544, 39777, 1373, 40, 532, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1674942, 39821, 315, 10, 148, "Input",
 CellTags->"6.1 Solutions"],
Cell[1675260, 39833, 122, 3, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1675431, 39842, 114, 2, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[1675548, 39846, 753, 22, 333, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1676326, 39872, 298, 9, 136, "Input",
 CellTags->"6.1 Solutions"],
Cell[1676627, 39883, 57, 1, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[1676699, 39887, 371, 12, 117, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[1677073, 39901, 720, 22, 229, "InputOnly",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1677818, 39927, 298, 9, 136, "Input",
 CellTags->"6.1 Solutions"],
Cell[1678119, 39938, 57, 1, 67, "Output",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1678225, 39945, 128, 3, 67, "SolutionItem",
 CellTags->"6.1 Solutions"],
Cell[CellGroupData[{
Cell[1678378, 39952, 648, 24, 117, "SolutionSubItem",
 CellTags->"6.1 Solutions"],
Cell[1679029, 39978, 158, 4, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1679190, 39984, 926, 26, 294, "Input",
 CellTags->"6.1 Solutions"],
Cell[1680119, 40012, 168, 5, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1680290, 40019, 852, 26, 243, "Input",
 CellTags->"6.1 Solutions"],
Cell[1681145, 40047, 173, 5, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1681355, 40057, 1143, 39, 270, "SolutionSubItem",
 CellTags->"6.1 Solutions"],
Cell[1682501, 40098, 1053, 31, 243, "Input",
 CellTags->"6.1 Solutions"],
Cell[1683557, 40131, 197, 6, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1683757, 40139, 1074, 31, 294, "Input",
 CellTags->"6.1 Solutions"],
Cell[1684834, 40172, 202, 6, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1685073, 40183, 255, 10, 67, "SolutionSubItem",
 CellTags->"6.1 Solutions"],
Cell[1685331, 40195, 985, 28, 294, "Input",
 CellTags->"6.1 Solutions"],
Cell[1686319, 40225, 331, 10, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1686687, 40240, 101, 1, 67, "SolutionSubItem",
 CellTags->"6.1 Solutions"],
Cell[1686791, 40243, 1109, 32, 294, "Input",
 CellTags->"6.1 Solutions"],
Cell[1687903, 40277, 424, 13, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1688364, 40295, 919, 33, 168, "SolutionSubItem",
 CounterAssignments->{{"SolutionItem", 1}},
 CellTags->"6.1 Solutions"],
Cell[1689286, 40330, 1307, 38, 397, "Input",
 CellTags->"6.1 Solutions"],
Cell[1690596, 40370, 288, 8, 82, "Input",
 CellTags->"6.1 Solutions"],
Cell[1690887, 40380, 246, 8, 67, "SolutionText",
 CellTags->"6.1 Solutions"],
Cell[1691136, 40390, 288, 8, 82, "Input",
 CellTags->"6.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1691497, 40406, 42, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[1691564, 40410, 849, 27, 118, "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:32"}],
Cell[CellGroupData[{
Cell[1692438, 40441, 209, 6, 82, "ExerciseInput",
 CellTags->"6.2 Exercises"],
Cell[1692650, 40449, 667, 19, 207, "ExerciseOutput",
 CellTags->"6.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1693354, 40473, 241, 7, 82, "ExerciseInput",
 CellTags->"6.2 Exercises"],
Cell[1693598, 40482, 769, 20, 261, "ExerciseOutput",
 CellTags->"6.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[1694394, 40506, 1100, 43, 114, "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:31"}],
Cell[CellGroupData[{
Cell[1695519, 40553, 189, 4, 45, "ExerciseItem",
 CellTags->{"6.2 Exercises", "Ex.Absolute value"}],
Cell[CellGroupData[{
Cell[1695733, 40561, 148, 4, 82, "ExerciseInput",
 CellTags->"6.2 Exercises"],
Cell[1695884, 40567, 464, 9, 72, "Message",
 CellTags->"6.2 Exercises"],
Cell[1696351, 40578, 448, 9, 72, "Message",
 CellTags->"6.2 Exercises"],
Cell[1696802, 40589, 164, 4, 67, "ExerciseOutput",
 CellTags->"6.2 Exercises"]
}, Closed]],
Cell[1696981, 40596, 227, 6, 73, "ExerciseText",
 CellTags->"6.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1697245, 40607, 428, 18, 45, "ExerciseItem",
 CellTags->"6.2 Exercises"],
Cell[1697676, 40627, 157, 4, 45, "ExerciseSubItem",
 CellTags->"6.2 Exercises"],
Cell[1697836, 40633, 666, 20, 150, "ExerciseSubItem",
 CellTags->"6.2 Exercises"],
Cell[CellGroupData[{
Cell[1698527, 40657, 181, 6, 55, "ExerciseSubItem",
 CellTags->"6.2 Exercises"],
Cell[CellGroupData[{
Cell[1698733, 40667, 244, 7, 82, "ExerciseInput",
 CellTags->"6.2 Exercises"],
Cell[1698980, 40676, 78, 1, 67, "ExerciseOutput",
 CellTags->"6.2 Exercises"]
}, Closed]],
Cell[1699073, 40680, 318, 11, 73, "ExerciseText",
 CellTags->"6.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[1699418, 40695, 366, 14, 76, "ExerciseItem",
 CellTags->{"6.2 Exercises", "i:51"}],
Cell[1699787, 40711, 1164, 42, 171, "ExerciseItem",
 CellTags->{"6.2 Exercises", "Ex.Collatz", "i:33"}],
Cell[CellGroupData[{
Cell[1700976, 40757, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1701040, 40761, 460, 18, 76, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[1701503, 40781, 453, 14, 139, "Input",
 CellTags->"6.2 Solutions"],
Cell[1701959, 40797, 164, 4, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1702126, 40803, 514, 17, 126, "InputOnly",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1702665, 40824, 220, 7, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1702888, 40833, 809, 21, 310, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1703746, 40860, 89, 1, 67, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[1703838, 40863, 436, 14, 244, "Input",
 CellTags->"6.2 Solutions"],
Cell[1704277, 40879, 192, 6, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1704472, 40887, 224, 8, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1704699, 40897, 321, 11, 87, "Input",
 CellTags->"6.2 Solutions"],
Cell[1705023, 40910, 194, 6, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1705220, 40918, 230, 8, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1705453, 40928, 290, 9, 87, "Input",
 CellTags->"6.2 Solutions"],
Cell[1705746, 40939, 197, 6, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1705946, 40947, 247, 8, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1706196, 40957, 404, 14, 82, "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1706637, 40976, 756, 25, 202, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[1707396, 41003, 742, 24, 249, "InputOnly",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1708163, 41031, 126, 4, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1708292, 41037, 56, 1, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1708385, 41043, 102, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1708490, 41048, 56, 1, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[1708561, 41052, 257, 7, 118, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1708821, 41061, 584, 18, 195, "InputOnly",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1709430, 41083, 126, 4, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1709559, 41089, 56, 1, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1709652, 41095, 102, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1709757, 41100, 56, 1, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1709862, 41107, 94, 2, 67, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1709981, 41113, 129, 3, 67, "SolutionSubItem",
 CellTags->"6.2 Solutions"],
Cell[1710113, 41118, 322, 11, 87, "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1710472, 41134, 55, 1, 67, "SolutionSubItem",
 CellTags->"6.2 Solutions"],
Cell[1710530, 41137, 743, 20, 190, "Input",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1711310, 41162, 55, 1, 67, "SolutionSubItem",
 CellTags->"6.2 Solutions"],
Cell[1711368, 41165, 364, 12, 87, "Input",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1711781, 41183, 345, 13, 67, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[1712129, 41198, 965, 29, 294, "Input",
 CellTags->"6.2 Solutions"],
Cell[1713097, 41229, 323, 9, 136, "Input",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1713445, 41242, 121, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1713569, 41247, 124, 3, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1713730, 41255, 120, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1713853, 41260, 124, 3, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1714014, 41268, 121, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1714138, 41273, 147, 4, 118, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1714322, 41282, 120, 3, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1714445, 41287, 147, 4, 117, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1714641, 41297, 126, 3, 67, "SolutionItem",
 CellTags->"6.2 Solutions"],
Cell[1714770, 41302, 192, 6, 136, "Input",
 CellTags->"6.2 Solutions"],
Cell[1714965, 41310, 213, 7, 87, "Input",
 CellTags->"6.2 Solutions"],
Cell[1715181, 41319, 201, 8, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1715385, 41329, 319, 10, 87, "Input",
 CellTags->"6.2 Solutions"],
Cell[1715707, 41341, 247, 11, 67, "SolutionText",
 CellTags->"6.2 Solutions"],
Cell[1715957, 41354, 261, 7, 73, "InputOnly",
 CellTags->"6.2 Solutions"],
Cell[CellGroupData[{
Cell[1716243, 41365, 97, 2, 82, "Input",
 CellTags->"6.2 Solutions"],
Cell[1716343, 41369, 228, 6, 67, "Output",
 CellTags->"6.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1716644, 41383, 55, 0, 45, "ExerciseSubsection"],
Cell[1716702, 41385, 877, 33, 127, "ExerciseItem",
 CellTags->{"6.3 Exercises", "i:43"}],
Cell[1717582, 41420, 985, 32, 222, "ExerciseItem",
 CellTags->{"i:46", "6.3 Exercises"}],
Cell[1718570, 41454, 273, 10, 69, "ExerciseItem",
 CellTags->"6.3 Exercises"],
Cell[1718846, 41466, 962, 35, 171, "ExerciseItem",
 CellTags->{"Ex.pointLoc alternatives", "6.3 Exercises"}],
Cell[1719811, 41503, 1786, 72, 222, "ExerciseItem",
 CellTags->"6.3 Exercises"],
Cell[1721600, 41577, 1085, 32, 271, "ExerciseItem",
 CellTags->{"i:47", "6.3 Exercises"}],
Cell[CellGroupData[{
Cell[1722710, 41613, 165, 4, 69, "ExerciseItem",
 CellTags->{"i:44", "6.3 Exercises"}],
Cell[1722878, 41619, 58081, 997, 537, "Figure",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1780996, 42621, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1781060, 42625, 263, 10, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[1781326, 42637, 92, 2, 69, "InputOnly",
 CellTags->"6.3 Solutions"],
Cell[1781421, 42641, 470, 15, 73, "InputOnly",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1781916, 42660, 281, 9, 136, "Input",
 CellTags->"6.3 Solutions"],
Cell[1782200, 42671, 57, 1, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1782306, 42678, 105, 1, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1782436, 42683, 129, 3, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1782568, 42688, 57, 1, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1782640, 42692, 264, 8, 67, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[1782907, 42702, 710, 21, 294, "Input",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1783642, 42727, 93, 2, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1783738, 42731, 56, 1, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1783809, 42735, 113, 2, 67, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[1783925, 42739, 367, 11, 87, "Input",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1784317, 42754, 112, 3, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1784432, 42759, 56, 1, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1784537, 42766, 234, 8, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[1784774, 42776, 1001, 34, 136, "Input",
 CellTags->"6.3 Solutions"],
Cell[1785778, 42812, 1145, 38, 190, "Input",
 CellTags->"6.3 Solutions"],
Cell[1786926, 42852, 829, 28, 136, "Input",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1787792, 42885, 221, 9, 73, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[1788016, 42896, 1021, 35, 297, "InputOnly",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1789062, 42935, 138, 4, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1789203, 42941, 56, 1, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1789296, 42947, 136, 4, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1789435, 42953, 73, 2, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1789557, 42961, 122, 3, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[1789682, 42966, 2245, 75, 517, "Input",
 CellTags->"6.3 Solutions"],
Cell[1791930, 43043, 335, 11, 82, "Input",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1792302, 43059, 91, 1, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1792418, 43064, 148, 4, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1792569, 43070, 657, 11, 172, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1793241, 43084, 232, 9, 67, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1793498, 43097, 323, 10, 136, "Input",
 CellTags->"6.3 Solutions"],
Cell[1793824, 43109, 474, 9, 121, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1794313, 43121, 192, 7, 67, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1794530, 43132, 323, 10, 136, "Input",
 CellTags->"6.3 Solutions"],
Cell[1794856, 43144, 426, 8, 121, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1795297, 43155, 169, 5, 67, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1795491, 43164, 666, 20, 343, "Input",
 CellTags->"6.3 Solutions"],
Cell[1796160, 43186, 1992, 29, 586, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1798167, 43218, 439, 10, 168, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[1798609, 43230, 1106, 32, 397, "Input",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1799740, 43266, 96, 2, 82, "Input",
 CellTags->"6.3 Solutions"],
Cell[1799839, 43270, 1992, 29, 586, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]],
Cell[1801846, 43302, 271, 7, 118, "SolutionText",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1802142, 43313, 183, 5, 103, "Input",
 CellTags->"6.3 Solutions"],
Cell[1802328, 43320, 123, 3, 67, "Output",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1802500, 43329, 128, 3, 67, "SolutionItem",
 CellTags->"6.3 Solutions"],
Cell[1802631, 43334, 1795, 46, 436, "InputOnly",
 CellTags->"6.3 Solutions"],
Cell[CellGroupData[{
Cell[1804451, 43384, 386, 11, 175, "InputOnly",
 CellTags->"6.3 Solutions"],
Cell[1804840, 43397, 58081, 997, 532, "Figure",
 CellTags->"6.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[1862984, 44401, 776, 17, 42, "TitleFlourish"],
Cell[1863763, 44420, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[1863809, 44424, 33, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[1863867, 44428, 47, 0, 67, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[1863939, 44432, 255, 7, 85, "ExerciseItem",
 CellTags->"7.1 Exercises"],
Cell[1864197, 44441, 733, 26, 82, "ExerciseSubItem",
 CellTags->"7.1 Exercises"],
Cell[1864933, 44469, 976, 36, 76, "ExerciseSubItem",
 CellTags->"7.1 Exercises"],
Cell[1865912, 44507, 909, 33, 76, "ExerciseSubItem",
 CellTags->"7.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1866858, 44545, 522, 17, 85, "ExerciseItem",
 CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2"}],
Cell[1867383, 44564, 1049, 36, 123, "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],
Cell[1868435, 44602, 519, 21, 73, "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1868991, 44628, 1827, 49, 114, "ExerciseItem",
 CellTags->{
  "Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:17"}],
Cell[1870821, 44679, 440, 15, 123, "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],
Cell[1871264, 44696, 4058, 116, 180, "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],
Cell[1875325, 44814, 241, 8, 73, "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1875603, 44827, 2354, 45, 81, "ExerciseItem",
 CellTags->{"Exercise Fibonacci", "7.1 Exercises", "Exercise 7.1-2", "i:2"}],
Cell[1877960, 44874, 373, 15, 73, "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],
Cell[1878336, 44891, 76, 1, 73, "ExerciseText",
 CellTags->"7.1 Exercises"],
Cell[1878415, 44894, 1426, 56, 123, "ExerciseDisplayFormula",
 CellTags->"7.1 Exercises"],
Cell[1879844, 44952, 136, 3, 73, "ExerciseText",
 CellTags->"7.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1880017, 44960, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1880081, 44964, 126, 3, 67, "SolutionItem",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1880232, 44971, 154, 4, 67, "SolutionSubItem",
 CellTags->"7.1 Solutions"],
Cell[1880389, 44977, 368, 12, 177, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1880782, 44993, 197, 6, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1880982, 45001, 187, 5, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1881218, 45012, 142, 4, 67, "SolutionSubItem",
 CellTags->"7.1 Solutions"],
Cell[1881363, 45018, 368, 12, 177, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1881756, 45034, 197, 6, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1881956, 45042, 249, 7, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1882254, 45055, 93, 1, 67, "SolutionSubItem",
 CellTags->"7.1 Solutions"],
Cell[1882350, 45058, 494, 16, 229, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1882869, 45078, 197, 6, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1883069, 45086, 182, 5, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1883312, 45098, 105, 1, 67, "SolutionItem",
 CellTags->"7.1 Solutions"],
Cell[1883420, 45101, 383, 12, 177, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1883828, 45117, 141, 4, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1883972, 45123, 181, 5, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]],
Cell[1884168, 45131, 364, 11, 117, "SolutionText",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1884557, 45146, 118, 3, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1884678, 45151, 181, 5, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1884908, 45162, 332, 6, 168, "SolutionItem",
 CellTags->"7.1 Solutions"],
Cell[1885243, 45170, 334, 10, 175, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[1885580, 45182, 1817, 55, 346, "Input",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1887422, 45241, 232, 7, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1887657, 45250, 738, 14, 276, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1888444, 45270, 280, 9, 67, "SolutionItem",
 CellTags->"7.1 Solutions"],
Cell[1888727, 45281, 323, 11, 82, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[1889053, 45294, 247, 8, 123, "InputOnly",
 CellTags->"7.1 Solutions"],
Cell[CellGroupData[{
Cell[1889325, 45306, 249, 8, 82, "Input",
 CellTags->"7.1 Solutions"],
Cell[1889577, 45316, 249, 7, 67, "Output",
 CellTags->"7.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1889899, 45331, 50, 0, 45, "ExerciseSubsection"],
Cell[1889952, 45333, 127, 3, 76, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[1890082, 45338, 196, 4, 117, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[1890281, 45344, 544, 18, 117, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[1890828, 45364, 991, 38, 117, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[1891822, 45404, 542, 18, 121, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[CellGroupData[{
Cell[1892389, 45426, 529, 16, 117, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[CellGroupData[{
Cell[1892943, 45446, 207, 5, 82, "ExerciseInput",
 CellTags->"7.2 Exercises"],
Cell[1893153, 45453, 163, 4, 67, "ExerciseOutput",
 CellTags->"7.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[1893343, 45461, 421, 13, 123, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[CellGroupData[{
Cell[1893789, 45478, 381, 12, 67, "ExerciseItem",
 CellTags->{"7.2 Exercises", "i:5"}],
Cell[1894173, 45492, 295, 9, 87, "ExerciseInput",
 CellTags->"7.2 Exercises"],
Cell[CellGroupData[{
Cell[1894493, 45505, 252, 8, 82, "ExerciseInput",
 CellTags->"7.2 Exercises"],
Cell[1894748, 45515, 166, 4, 67, "ExerciseOutput",
 CellTags->"7.2 Exercises"]
}, Closed]],
Cell[1894929, 45522, 134, 5, 73, "ExerciseText",
 CellTags->"7.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1895100, 45532, 170, 4, 76, "ExerciseItem",
 CellTags->"7.2 Exercises"],
Cell[1895273, 45538, 395, 13, 139, "ExerciseInput",
 Evaluatable->False,
 CellTags->"7.2 Exercises"],
Cell[1895671, 45553, 1666, 60, 175, "ExerciseText",
 CellTags->"7.2 Exercises"]
}, Closed]],
Cell[1897352, 45616, 436, 18, 76, "ExerciseItem",
 CellTags->{"7.2 Exercises", "i:6"}],
Cell[CellGroupData[{
Cell[1897813, 45638, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1897877, 45642, 234, 6, 117, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1898114, 45650, 306, 10, 87, "Input",
 CellTags->"7.2 Solutions"],
Cell[1898423, 45662, 160, 5, 87, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1898608, 45671, 218, 6, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1898829, 45679, 178, 4, 117, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1899056, 45689, 184, 7, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1899243, 45698, 563, 19, 139, "Input",
 CellTags->"7.2 Solutions"],
Cell[1899809, 45719, 289, 10, 87, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1900123, 45733, 343, 12, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1900469, 45747, 299, 11, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1900805, 45763, 90, 2, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1900898, 45767, 299, 11, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1901246, 45784, 77, 1, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1901326, 45787, 614, 19, 180, "InputOnly",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1901965, 45810, 213, 6, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1902181, 45818, 57, 1, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1902287, 45825, 84, 1, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1902374, 45828, 493, 14, 244, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1902892, 45846, 227, 6, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1903122, 45854, 57, 1, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1903228, 45861, 170, 5, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1903401, 45868, 783, 26, 190, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1904209, 45898, 631, 21, 87, "Input",
 CellTags->"7.2 Solutions"],
Cell[1904843, 45921, 545, 19, 72, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1905437, 45946, 103, 1, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1905543, 45949, 608, 20, 193, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1906176, 45973, 185, 5, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1906364, 45980, 141, 4, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1906554, 45990, 103, 1, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1906660, 45993, 657, 23, 190, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1907342, 46020, 230, 7, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1907575, 46029, 111, 3, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1907735, 46038, 105, 1, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1907843, 46041, 617, 22, 139, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1908485, 46067, 228, 7, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1908716, 46076, 144, 4, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],
Cell[1908875, 46083, 97, 1, 67, "SolutionText",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1908997, 46088, 228, 7, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1909228, 46097, 144, 4, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1909421, 46107, 135, 5, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1909559, 46114, 352, 12, 139, "Input",
 CellTags->"7.2 Solutions"],
Cell[1909914, 46128, 790, 27, 195, "Input",
 CellTags->"7.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1910741, 46160, 148, 5, 67, "SolutionItem",
 CellTags->"7.2 Solutions"],
Cell[1910892, 46167, 469, 15, 141, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1911386, 46186, 203, 6, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1911592, 46194, 108, 2, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],
Cell[1911715, 46199, 594, 19, 141, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1912334, 46222, 159, 4, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1912496, 46228, 162, 5, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]],
Cell[1912673, 46236, 113, 5, 67, "SolutionText",
 CellTags->"7.2 Solutions"],
Cell[1912789, 46243, 492, 15, 141, "Input",
 CellTags->"7.2 Solutions"],
Cell[CellGroupData[{
Cell[1913306, 46262, 131, 3, 82, "Input",
 CellTags->"7.2 Solutions"],
Cell[1913440, 46267, 339, 9, 67, "Output",
 CellTags->"7.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1913852, 46284, 49, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[1913926, 46288, 1803, 68, 288, "ExerciseItem",
 CellTags->{"i:9", "7.3 Exercises"}],
Cell[CellGroupData[{
Cell[1915754, 46360, 174, 5, 82, "ExerciseInput",
 CellTags->"7.3 Exercises"],
Cell[1915931, 46367, 519, 16, 67, "ExerciseOutput",
 CellTags->"7.3 Exercises"]
}, Closed]],
Cell[1916465, 46386, 2384, 48, 123, "ExerciseText",
 CellTags->"7.3 Exercises"],
Cell[1918852, 46436, 2311, 81, 123, "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"],
Cell[1921166, 46519, 2298, 70, 123, "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"],
Cell[1923467, 46591, 580, 19, 123, "ExerciseText",
 CellTags->"7.3 Exercises"],
Cell[CellGroupData[{
Cell[1924072, 46614, 105, 1, 87, "NumberedTable",
 CellTags->{"Table.Eulerian numbers", "7.3 Exercises"}],
Cell[1924180, 46617, 7610, 245, 645, "DisplayTable",
 CellTags->"7.3 Exercises"]
}, Closed]],
Cell[1931805, 46865, 221, 5, 123, "ExerciseText",
 CellTags->"7.3 Exercises"],
Cell[1932029, 46872, 180, 4, 123, "ExerciseText",
 CellTags->"7.3 Exercises"],
Cell[1932212, 46878, 764, 26, 123, "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1933013, 46909, 269, 5, 123, "ExerciseItem",
 CellTags->"7.3 Exercises"],
Cell[1933285, 46916, 1405, 49, 249, "ExerciseDisplayFormula",
 CellTags->"7.3 Exercises"],
Cell[1934693, 46967, 130, 3, 73, "ExerciseText",
 CellTags->"7.3 Exercises"]
}, Closed]],
Cell[1934838, 46973, 400, 9, 171, "ExerciseItem",
 CellTags->"7.3 Exercises"],
Cell[1935241, 46984, 827, 24, 211, "ExerciseItem",
 CellTags->{"7.3 Exercises", "Ex.Collatz", "i:16"}],
Cell[CellGroupData[{
Cell[1936093, 47012, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1936157, 47016, 141, 4, 67, "SolutionItem",
 CellTags->"7.3 Solutions"],
Cell[1936301, 47022, 534, 17, 181, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[1936838, 47041, 545, 18, 126, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1937408, 47063, 346, 11, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1937757, 47076, 922, 23, 468, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[1938694, 47102, 212, 4, 117, "SolutionText",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1938931, 47110, 150, 4, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1939084, 47116, 133, 3, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[1939232, 47122, 458, 14, 117, "SolutionText",
 CellTags->"7.3 Solutions"],
Cell[1939693, 47138, 121, 3, 69, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[1939817, 47143, 534, 17, 181, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[1940354, 47162, 839, 26, 229, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1941218, 47192, 150, 4, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1941371, 47198, 147, 4, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1941555, 47207, 171, 5, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1941729, 47214, 122, 3, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1941888, 47222, 150, 4, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1942041, 47228, 134, 2, 76, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1942224, 47236, 187, 4, 117, "SolutionItem",
 CellTags->"7.3 Solutions"],
Cell[1942414, 47242, 174, 5, 123, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[1942591, 47249, 765, 27, 244, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1943381, 47280, 141, 4, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1943525, 47286, 192, 5, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1943754, 47296, 161, 5, 103, "Input",
 CellTags->"7.3 Solutions"],
Cell[1943918, 47303, 123, 3, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1944090, 47312, 150, 4, 67, "SolutionItem",
 CellTags->"7.3 Solutions"],
Cell[1944243, 47318, 176, 5, 123, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[1944422, 47325, 898, 31, 244, "InputOnly",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1945345, 47360, 142, 4, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1945490, 47366, 192, 5, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1945719, 47376, 162, 5, 103, "Input",
 CellTags->"7.3 Solutions"],
Cell[1945884, 47383, 124, 3, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[1946023, 47389, 344, 11, 117, "SolutionText",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1946392, 47404, 169, 5, 103, "Input",
 CellTags->"7.3 Solutions"],
Cell[1946564, 47411, 125, 3, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1946738, 47420, 136, 5, 67, "SolutionItem",
 CellTags->"7.3 Solutions"],
Cell[1946877, 47427, 137, 4, 87, "Input",
 CellTags->"7.3 Solutions"],
Cell[1947017, 47433, 516, 17, 199, "Input",
 CellTags->"7.3 Solutions"],
Cell[1947536, 47452, 542, 18, 139, "Input",
 CellTags->"7.3 Solutions"],
Cell[1948081, 47472, 151, 5, 67, "SolutionText",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1948257, 47481, 112, 3, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1948372, 47486, 57, 1, 67, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]],
Cell[1948444, 47490, 276, 11, 67, "SolutionText",
 CellTags->"7.3 Solutions"],
Cell[CellGroupData[{
Cell[1948745, 47505, 231, 7, 82, "Input",
 CellTags->"7.3 Solutions"],
Cell[1948979, 47514, 1526, 22, 481, "Output",
 CellTags->"7.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1950578, 47544, 48, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[1950651, 47548, 326, 11, 123, "ExerciseItem",
 CellTags->"7.4 Exercises"],
Cell[CellGroupData[{
Cell[1951002, 47563, 295, 7, 82, "ExerciseInput",
 CellTags->"7.4 Exercises"],
Cell[1951300, 47572, 407, 11, 67, "ExerciseOutput",
 CellTags->"7.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1951756, 47589, 203, 6, 76, "ExerciseItem",
 CellTags->"7.4 Exercises"],
Cell[1951962, 47597, 449, 13, 139, "ExerciseInput",
 Evaluatable->False,
 CellTags->"7.4 Exercises"],
Cell[1952414, 47612, 1613, 52, 226, "ExerciseText",
 CellTags->"7.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1954064, 47669, 274, 9, 123, "ExerciseItem",
 CellTags->"7.4 Exercises"],
Cell[CellGroupData[{
Cell[1954363, 47682, 385, 13, 82, "ExerciseInput",
 CellTags->"7.4 Exercises"],
Cell[1954751, 47697, 274, 6, 67, "ExerciseOutput",
 CellTags->"7.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[1955052, 47707, 621, 17, 217, "ExerciseItem",
 CellTags->"7.4 Exercises"],
Cell[CellGroupData[{
Cell[1955698, 47728, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1955762, 47732, 377, 11, 117, "SolutionItem",
 CellTags->"7.4 Solutions"],
Cell[1956142, 47745, 349, 11, 126, "InputOnly",
 CellTags->"7.4 Solutions"],
Cell[1956494, 47758, 1206, 36, 280, "InputOnly",
 CellTags->"7.4 Solutions"],
Cell[1957703, 47796, 380, 12, 117, "SolutionText",
 CellTags->"7.4 Solutions"],
Cell[1958086, 47810, 410, 14, 73, "InputOnly",
 CellTags->"7.4 Solutions"],
Cell[CellGroupData[{
Cell[1958521, 47828, 293, 10, 82, "Input",
 CellTags->"7.4 Solutions"],
Cell[1958817, 47840, 266, 9, 67, "Output",
 CellTags->"7.4 Solutions"]
}, Closed]],
Cell[1959098, 47852, 185, 5, 73, "InputOnly",
 CellTags->"7.4 Solutions"],
Cell[CellGroupData[{
Cell[1959308, 47861, 287, 7, 82, "Input",
 CellTags->"7.4 Solutions"],
Cell[1959598, 47870, 385, 11, 67, "Output",
 CellTags->"7.4 Solutions"]
}, Closed]],
Cell[1959998, 47884, 88, 1, 67, "SolutionText",
 CellTags->"7.4 Solutions"],
Cell[CellGroupData[{
Cell[1960111, 47889, 287, 7, 82, "Input",
 CellTags->"7.4 Solutions"],
Cell[1960401, 47898, 385, 11, 67, "Output",
 CellTags->"7.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1960835, 47915, 222, 6, 67, "SolutionItem",
 CellTags->"7.4 Solutions"],
Cell[1961060, 47923, 1249, 41, 288, "InputOnly",
 CellTags->"7.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1962346, 47969, 77, 1, 67, "SolutionItem",
 CellTags->"7.4 Solutions"],
Cell[1962426, 47972, 540, 18, 126, "InputOnly",
 CellTags->"7.4 Solutions"],
Cell[CellGroupData[{
Cell[1962991, 47994, 361, 12, 82, "Input",
 CellTags->"7.4 Solutions"],
Cell[1963355, 48008, 252, 6, 67, "Output",
 CellTags->"7.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[1963670, 48021, 776, 17, 42, "TitleFlourish"],
Cell[1964449, 48040, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[1964495, 48044, 32, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[1964552, 48048, 105, 4, 67, "ExerciseSubsection"],
Cell[1964660, 48054, 583, 20, 130, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:32"}],
Cell[CellGroupData[{
Cell[1965268, 48078, 921, 34, 163, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:33", "Ex.Convert"}],
Cell[CellGroupData[{
Cell[1966214, 48116, 205, 6, 82, "ExerciseInput",
 CellTags->"8.1 Exercises"],
Cell[1966422, 48124, 79, 1, 67, "ExerciseOutput",
 CellTags->"8.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[1966528, 48129, 514, 13, 171, "ExerciseItem",
 CellTags->{"i:119", "8.1 Exercises"}],
Cell[1967045, 48144, 1933, 48, 117, "ExerciseItem",
 CellTags->"8.1 Exercises"],
Cell[1968981, 48194, 1145, 39, 216, "ExerciseItem",
 CellTags->"8.1 Exercises"],
Cell[CellGroupData[{
Cell[1970151, 48237, 542, 16, 163, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:34"}],
Cell[CellGroupData[{
Cell[1970718, 48257, 140, 3, 82, "ExerciseInput",
 CellTags->"8.1 Exercises"],
Cell[1970861, 48262, 156, 4, 67, "ExerciseOutput",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1971032, 48269, 100, 1, 73, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[CellGroupData[{
Cell[1971157, 48274, 114, 2, 82, "ExerciseInput",
 CellTags->"8.1 Exercises"],
Cell[1971274, 48278, 156, 4, 67, "ExerciseOutput",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1971445, 48285, 174, 5, 73, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[CellGroupData[{
Cell[1971644, 48294, 136, 3, 82, "ExerciseInput",
 CellTags->"8.1 Exercises"],
Cell[1971783, 48299, 79, 1, 67, "ExerciseOutput",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1971877, 48303, 157, 4, 73, "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1972049, 48310, 1313, 49, 249, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:35"}],
Cell[1973365, 48361, 768, 25, 163, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:36"}],
Cell[1974136, 48388, 794, 26, 163, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:37"}],
Cell[CellGroupData[{
Cell[1974955, 48418, 400, 8, 163, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:38"}],
Cell[1975358, 48428, 378, 16, 73, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[1975739, 48446, 678, 28, 123, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[CellGroupData[{
Cell[1976442, 48478, 129, 3, 82, "ExerciseInput",
 CellTags->"8.1 Exercises"],
Cell[1976574, 48483, 78, 1, 67, "ExerciseOutput",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1976667, 48487, 2582, 55, 175, "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1979286, 48547, 648, 23, 123, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:39"}],
Cell[1979937, 48572, 419, 16, 91, "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[1980371, 48591, 1096, 27, 312, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:40"}],
Cell[CellGroupData[{
Cell[1981492, 48622, 857, 24, 256, "ExerciseItem",
 CellTags->{"8.1 Exercises", "i:41"}],
Cell[1982352, 48648, 446, 16, 81, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[1982801, 48666, 484, 17, 123, "ExerciseText",
 CellTags->"8.1 Exercises"],
Cell[1983288, 48685, 271, 7, 82, "ExerciseInput",
 Evaluatable->False,
 CellTags->"8.1 Exercises"],
Cell[1983562, 48694, 3722, 80, 175, "ExerciseText",
 CellTags->"8.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[1987321, 48779, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[1987385, 48783, 155, 4, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[1987543, 48789, 235, 7, 73, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1987803, 48800, 154, 4, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1987960, 48806, 165, 6, 109, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1988162, 48817, 196, 5, 135, "Input",
 CellTags->"8.1 Solutions"],
Cell[1988361, 48824, 127, 4, 109, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1988537, 48834, 463, 15, 117, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[1989003, 48851, 356, 12, 87, "Input",
 CellTags->"8.1 Solutions"],
Cell[1989362, 48865, 157, 7, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1989544, 48876, 117, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1989664, 48881, 121, 3, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[1989800, 48887, 148, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1989973, 48896, 88, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1990064, 48900, 56, 1, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[1990135, 48904, 270, 9, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1990430, 48917, 186, 6, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1990619, 48925, 56, 1, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[1990690, 48929, 180, 4, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1990895, 48937, 193, 6, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1991091, 48945, 358, 13, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1991486, 48963, 87, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1991576, 48967, 275, 9, 76, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1991900, 48982, 183, 5, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[1992086, 48989, 265, 8, 87, "Input",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1992376, 49001, 108, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1992487, 49006, 57, 1, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[1992559, 49010, 174, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1992758, 49019, 163, 5, 103, "Input",
 CellTags->"8.1 Solutions"],
Cell[1992924, 49026, 57, 1, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[1992996, 49030, 98, 1, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1993119, 49035, 178, 6, 103, "Input",
 CellTags->"8.1 Solutions"],
Cell[1993300, 49043, 57, 1, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1993406, 49050, 125, 5, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[1993534, 49057, 223, 6, 103, "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1993794, 49068, 101, 1, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[1993898, 49071, 233, 6, 87, "Input",
 CellTags->"8.1 Solutions"],
Cell[1994134, 49079, 139, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1994276, 49086, 115, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1994394, 49091, 113, 2, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1994510, 49095, 116, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1994629, 49100, 115, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1994747, 49105, 117, 3, 82, "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1994901, 49113, 204, 6, 67, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 6}},
 CellTags->"8.1 Solutions"],
Cell[1995108, 49121, 119, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1995230, 49126, 341, 10, 117, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1995574, 49138, 208, 6, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1995785, 49146, 233, 9, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1996021, 49157, 111, 3, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1996135, 49162, 160, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1996298, 49169, 602, 18, 190, "Input",
 CellTags->"8.1 Solutions"],
Cell[1996903, 49189, 91, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1996997, 49193, 187, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[1997187, 49200, 399, 12, 139, "Input",
 CellTags->"8.1 Solutions"],
Cell[1997589, 49214, 92, 2, 82, "Input",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[1997718, 49221, 332, 13, 117, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[1998075, 49238, 255, 8, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[1998333, 49248, 6595, 179, 166, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2004943, 49430, 82, 1, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[2005028, 49433, 364, 11, 69, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2005417, 49448, 84, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2005504, 49452, 6961, 177, 208, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2012480, 49632, 159, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[2012642, 49639, 231, 7, 73, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2012898, 49650, 89, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2012990, 49654, 30334, 737, 213, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2043373, 50397, 159, 4, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[2043535, 50403, 429, 15, 69, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[2043967, 50420, 635, 20, 136, "Input",
 CellTags->"8.1 Solutions"],
Cell[2044605, 50442, 145, 4, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[2044753, 50448, 221, 6, 73, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[2044977, 50456, 218, 6, 87, "Input",
 CellTags->"8.1 Solutions"],
Cell[2045198, 50464, 89, 1, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2045312, 50469, 201, 5, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2045516, 50476, 3293, 61, 594, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2048846, 50542, 159, 4, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2049008, 50548, 5821, 98, 411, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2054844, 50649, 172, 7, 67, "SolutionText",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2055053, 50661, 94, 1, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[2055150, 50664, 296, 9, 87, "Input",
 CellTags->"8.1 Solutions"],
Cell[2055449, 50675, 198, 7, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2055672, 50686, 242, 7, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2055917, 50695, 208, 5, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2056140, 50703, 148, 4, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[2056291, 50709, 175, 7, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2056491, 50720, 386, 11, 136, "Input",
 CellTags->"8.1 Solutions"],
Cell[2056880, 50733, 824, 13, 222, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2057719, 50749, 472, 14, 117, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2058216, 50767, 194, 5, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2058413, 50774, 24643, 411, 310, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2083071, 51188, 229, 5, 117, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2083325, 51197, 261, 7, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2083589, 51206, 63053, 1040, 321, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[2146657, 52249, 515, 14, 168, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2147197, 52267, 471, 13, 343, "Input",
 CellTags->"8.1 Solutions"],
Cell[2147671, 52282, 71608, 1181, 249, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2219316, 53468, 261, 7, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2219580, 53477, 63499, 1048, 249, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2283128, 54531, 434, 11, 117, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 11}},
 CellTags->"8.1 Solutions"],
Cell[2283565, 54544, 1423, 37, 540, "InputOnly",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2285013, 54585, 102, 2, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2285118, 54589, 162, 5, 67, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2285317, 54599, 240, 7, 136, "Input",
 CellTags->"8.1 Solutions"],
Cell[2285560, 54608, 321, 7, 172, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2285930, 54621, 304, 13, 67, "SolutionItem",
 CellTags->"8.1 Solutions"],
Cell[2286237, 54636, 523, 16, 240, "Input",
 CellTags->"8.1 Solutions"],
Cell[2286763, 54654, 166, 5, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[2286932, 54661, 428, 14, 82, "Input",
 CellTags->"8.1 Solutions"],
Cell[2287363, 54677, 64, 1, 67, "SolutionText",
 CellTags->"8.1 Solutions"],
Cell[CellGroupData[{
Cell[2287452, 54682, 301, 7, 136, "Input",
 CellTags->"8.1 Solutions"],
Cell[2287756, 54691, 14589, 247, 486, "Output",
 CellTags->"8.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2302418, 54946, 51, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[2302494, 54950, 245, 8, 76, "ExerciseItem",
 CellTags->"8.2 Exercises"],
Cell[CellGroupData[{
Cell[2302764, 54962, 132, 3, 82, "ExerciseInput",
 CellTags->"8.2 Exercises"],
Cell[2302899, 54967, 82, 1, 67, "ExerciseOutput",
 CellTags->"8.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2303018, 54973, 112, 2, 82, "ExerciseInput",
 CellTags->"8.2 Exercises"],
Cell[2303133, 54977, 93, 1, 67, "ExerciseOutput",
 CellTags->"8.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[2303253, 54982, 396, 13, 145, "ExerciseItem",
 CellTags->"8.2 Exercises"],
Cell[CellGroupData[{
Cell[2303674, 54999, 220, 6, 117, "ExerciseItem",
 CellTags->"8.2 Exercises"],
Cell[CellGroupData[{
Cell[2303919, 55009, 114, 2, 82, "ExerciseInput",
 CellTags->"8.2 Exercises"],
Cell[2304036, 55013, 100, 1, 76, "ExerciseOutput",
 CellTags->"8.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[2304163, 55018, 428, 15, 94, "ExerciseItem",
 CellTags->"8.2 Exercises"],
Cell[CellGroupData[{
Cell[2304616, 55037, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[2304680, 55041, 132, 5, 67, "SolutionItem",
 CellTags->"8.2 Solutions"],
Cell[CellGroupData[{
Cell[2304837, 55050, 93, 2, 82, "Input",
 CellTags->"8.2 Solutions"],
Cell[2304933, 55054, 71, 1, 67, "Output",
 CellTags->"8.2 Solutions"]
}, Closed]],
Cell[2305019, 55058, 412, 12, 168, "SolutionText",
 CellTags->"8.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2305468, 55075, 188, 4, 117, "SolutionItem",
 CellTags->"8.2 Solutions"],
Cell[CellGroupData[{
Cell[2305681, 55083, 539, 18, 177, "Input",
 CellTags->"8.2 Solutions"],
Cell[2306223, 55103, 847, 24, 514, "Output",
 CellTags->"8.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2307143, 55135, 47, 0, 45, "ExerciseSubsection"],
Cell[2307193, 55137, 423, 14, 123, "ExerciseItem",
 CellTags->{"8.3 Exercises", "i:85"}],
Cell[2307619, 55153, 763, 27, 117, "ExerciseItem",
 CellTags->{"8.3 Exercises", "i:86"}],
Cell[2308385, 55182, 957, 34, 211, "ExerciseItem",
 CellTags->"8.3 Exercises"],
Cell[CellGroupData[{
Cell[2309367, 55220, 632, 18, 177, "ExerciseItem",
 CellTags->{"i:120", "8.3 Exercises"}],
Cell[CellGroupData[{
Cell[2310024, 55242, 815, 18, 249, "ExerciseInput",
 CellTags->"8.3 Exercises"],
Cell[2310842, 55262, 78, 1, 67, "ExerciseOutput",
 CellTags->"8.3 Exercises"]
}, Closed]],
Cell[2310935, 55266, 474, 17, 123, "ExerciseText",
 CellTags->"8.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2311446, 55288, 281, 5, 123, "ExerciseItem",
 CellTags->{"i:121", "8.3 Exercises"}],
Cell[CellGroupData[{
Cell[2311752, 55297, 791, 22, 199, "ExerciseInput",
 CellTags->"8.3 Exercises"],
Cell[2312546, 55321, 152, 4, 76, "ExerciseOutput",
 CellTags->"8.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2312735, 55330, 167, 5, 82, "ExerciseInput",
 CellTags->"8.3 Exercises"],
Cell[2312905, 55337, 483, 18, 117, "ExerciseOutput",
 CellTags->"8.3 Exercises"]
}, Closed]],
Cell[2313403, 55358, 223, 7, 73, "ExerciseText",
 CellTags->"8.3 Exercises"],
Cell[2313629, 55367, 1469, 43, 123, "ExerciseDisplayFormula",
 CellTags->"8.3 Exercises"],
Cell[2315101, 55412, 327, 9, 123, "ExerciseText",
 CellTags->"8.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2315465, 55426, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[2315529, 55430, 102, 1, 67, "SolutionItem",
 CellTags->"8.3 Solutions"],
Cell[2315634, 55433, 435, 13, 139, "Input",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2316094, 55450, 168, 5, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2316265, 55457, 829, 21, 310, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2317143, 55484, 136, 5, 67, "SolutionItem",
 CellTags->"8.3 Solutions"],
Cell[2317282, 55491, 726, 23, 177, "InputOnly",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2318033, 55518, 144, 3, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2318180, 55523, 378, 13, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2318595, 55541, 120, 3, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2318718, 55546, 822, 21, 310, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2319589, 55573, 93, 1, 67, "SolutionItem",
 CellTags->"8.3 Solutions"],
Cell[2319685, 55576, 297, 9, 90, "InputOnly",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2320007, 55589, 105, 2, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2320115, 55593, 59, 1, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2320189, 55597, 202, 7, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[2320394, 55606, 180, 5, 69, "InputOnly",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2320599, 55615, 108, 2, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2320710, 55619, 60, 1, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2320785, 55623, 143, 4, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2320953, 55631, 171, 5, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2321127, 55638, 112, 3, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2321254, 55644, 149, 4, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2321428, 55652, 200, 6, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2321631, 55660, 123, 3, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2321791, 55668, 203, 6, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2321997, 55676, 122, 3, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2322134, 55682, 151, 4, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2322310, 55690, 138, 4, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2322451, 55696, 126, 3, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2322614, 55704, 141, 4, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2322758, 55710, 125, 3, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2322932, 55719, 489, 16, 117, "SolutionItem",
 CellTags->"8.3 Solutions"],
Cell[2323424, 55737, 864, 28, 177, "InputOnly",
 CellTags->"8.3 Solutions"],
Cell[2324291, 55767, 188, 6, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2324504, 55777, 203, 6, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2324710, 55785, 322, 7, 121, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2325047, 55795, 394, 13, 136, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2325466, 55812, 146, 4, 103, "Input",
 CellTags->"8.3 Solutions"],
Cell[2325615, 55818, 339, 8, 276, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2325991, 55831, 205, 6, 103, "Input",
 CellTags->"8.3 Solutions"],
Cell[2326199, 55839, 59, 1, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2326307, 55846, 437, 14, 117, "SolutionItem",
 CellTags->"8.3 Solutions"],
Cell[2326747, 55862, 754, 23, 243, "Input",
 CellTags->"8.3 Solutions"],
Cell[2327504, 55887, 89, 1, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2327618, 55892, 204, 6, 82, "Input",
 CellTags->"8.3 Solutions"],
Cell[2327825, 55900, 192, 5, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2328032, 55908, 101, 1, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2328158, 55913, 147, 4, 103, "Input",
 CellTags->"8.3 Solutions"],
Cell[2328308, 55919, 343, 8, 276, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]],
Cell[2328666, 55930, 192, 7, 67, "SolutionText",
 CellTags->"8.3 Solutions"],
Cell[CellGroupData[{
Cell[2328883, 55941, 383, 11, 220, "Input",
 CellTags->"8.3 Solutions"],
Cell[2329269, 55954, 59, 1, 67, "Output",
 CellTags->"8.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2329401, 55963, 55, 0, 45, "ExerciseSubsection"],
Cell[2329459, 55965, 663, 17, 217, "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:113"}],
Cell[2330125, 55984, 539, 13, 211, "ExerciseItem",
 CellTags->"8.4 Exercises"],
Cell[2330667, 55999, 761, 22, 211, "ExerciseItem",
 CellTags->"8.4 Exercises"],
Cell[CellGroupData[{
Cell[2331453, 56025, 600, 18, 163, "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:112"}],
Cell[CellGroupData[{
Cell[2332078, 56047, 427, 12, 136, "ExerciseInput",
 CellTags->"8.4 Exercises"],
Cell[2332508, 56061, 469, 9, 123, "Message",
 CellTags->"8.4 Exercises"],
Cell[2332980, 56072, 673, 15, 222, "ExerciseOutput",
 CellTags->"8.4 Exercises"]
}, Closed]],
Cell[2333668, 56090, 541, 17, 123, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[2334212, 56109, 646, 20, 117, "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],
Cell[2334861, 56131, 143, 4, 73, "ExerciseText",
 CellTags->"8.4 Exercises"]
}, Closed]],
Cell[2335019, 56138, 698, 24, 123, "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:114"}],
Cell[2335720, 56164, 246, 9, 49, "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],
Cell[2335969, 56175, 322, 12, 49, "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],
Cell[2336294, 56189, 452, 15, 54, "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],
Cell[2336749, 56206, 449, 15, 49, "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],
Cell[CellGroupData[{
Cell[2337223, 56225, 460, 15, 49, "ExerciseSubItemR",
 CellTags->"8.4 Exercises"],
Cell[2337686, 56242, 307, 9, 123, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[2337996, 56253, 462, 14, 73, "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],
Cell[2338461, 56269, 292, 9, 82, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[2338756, 56280, 566, 19, 82, "ExerciseDisplayFormula",
 CellTags->"8.4 Exercises"],
Cell[2339325, 56301, 424, 12, 126, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[2339752, 56315, 961, 34, 126, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[CellGroupData[{
Cell[2340738, 56353, 900, 27, 189, "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:115"}],
Cell[2341641, 56382, 739, 25, 175, "ExerciseText",
 CellTags->"8.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2342417, 56412, 1194, 40, 217, "ExerciseItem",
 CellTags->{"8.4 Exercises", "i:116"}],
Cell[CellGroupData[{
Cell[2343636, 56456, 513, 15, 190, "ExerciseInput",
 CellTags->"8.4 Exercises"],
Cell[2344152, 56473, 447, 13, 67, "ExerciseOutput",
 CellTags->"8.4 Exercises"]
}, Closed]],
Cell[2344614, 56489, 148, 4, 73, "ExerciseText",
 CellTags->"8.4 Exercises"],
Cell[2344765, 56495, 382, 11, 189, "ExerciseInput",
 CellTags->"8.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[2345184, 56511, 637, 19, 171, "ExerciseItem",
 CellTags->{"Ex.Autocorrelation", "8.4 Exercises"}],
Cell[2345824, 56532, 475, 8, 226, "ExerciseText",
 CellTags->{"8.4 Exercises", "i:117"}],
Cell[2346302, 56542, 420, 12, 82, "ExerciseInput",
 CellTags->"8.4 Exercises"],
Cell[CellGroupData[{
Cell[2346747, 56558, 845, 23, 240, "ExerciseInput",
 CellTags->"8.4 Exercises"],
Cell[2347595, 56583, 7394, 127, 607, "ExerciseOutput",
 CellTags->"8.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[2355016, 56714, 3756, 99, 265, "ExerciseItem",
 CellTags->{"Ex.Walk pi", "i:118", "8.4 Exercises"}]
}, Closed]],
Cell[CellGroupData[{
Cell[2358809, 56818, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[2358873, 56822, 204, 6, 118, "SolutionItem",
 CellTags->"8.4 Solutions"],
Cell[2359080, 56830, 481, 12, 279, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2359564, 56844, 2872, 81, 999, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2362439, 56927, 159, 5, 82, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2362623, 56936, 173, 5, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2362799, 56943, 125, 3, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2362961, 56951, 181, 5, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2363145, 56958, 198, 6, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2363380, 56969, 90, 2, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2363473, 56973, 59, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2363581, 56980, 131, 2, 67, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"8.4 Solutions"],
Cell[2363715, 56984, 177, 6, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2363895, 56992, 193, 7, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2364091, 57001, 259, 8, 73, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2364375, 57013, 87, 2, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2364465, 57017, 56, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2364536, 57021, 226, 8, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2364787, 57033, 117, 3, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2364907, 57038, 56, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2364978, 57042, 193, 8, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2365174, 57052, 368, 12, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2365545, 57066, 83, 1, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2365631, 57069, 371, 12, 126, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2366027, 57085, 87, 2, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2366117, 57089, 56, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2366188, 57093, 241, 8, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2366454, 57105, 117, 3, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2366574, 57110, 56, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2366645, 57114, 1033, 29, 274, "SolutionText",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2367715, 57148, 230, 8, 67, "SolutionItem",
 CellTags->"8.4 Solutions"],
Cell[2367948, 57158, 329, 10, 73, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2368302, 57172, 161, 4, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2368466, 57178, 73, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2368554, 57182, 112, 2, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2368691, 57188, 313, 9, 136, "Input",
 CellTags->"8.4 Solutions"],
Cell[2369007, 57199, 73, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2369095, 57203, 176, 4, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2369296, 57211, 123, 3, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2369422, 57216, 171, 5, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[2369630, 57226, 140, 4, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2369773, 57232, 74, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2369862, 57236, 437, 13, 190, "Input",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2370324, 57253, 123, 3, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2370450, 57258, 73, 1, 67, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2370572, 57265, 155, 4, 67, "SolutionItem",
 CellTags->"8.4 Solutions"],
Cell[2370730, 57271, 435, 14, 94, "Program",
 Evaluatable->False,
 CellTags->"8.4 Solutions"],
Cell[2371168, 57287, 126, 5, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2371297, 57294, 579, 18, 139, "Input",
 CellTags->"8.4 Solutions"],
Cell[2371879, 57314, 288, 6, 118, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2372170, 57322, 653, 17, 343, "Input",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2372848, 57343, 285, 8, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2373136, 57353, 2840, 71, 649, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2375991, 57427, 208, 4, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2376202, 57433, 364, 11, 175, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2376591, 57448, 169, 4, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2376763, 57454, 1253, 28, 402, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2378065, 57488, 231, 9, 67, "SolutionItem",
 CellTags->"8.4 Solutions"],
Cell[2378299, 57499, 319, 10, 69, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2378621, 57511, 2770, 74, 747, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2381394, 57587, 388, 12, 126, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2381785, 57601, 127, 3, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[2381915, 57606, 607, 20, 123, "InputOnly",
 CellTags->"8.4 Solutions"],
Cell[2382525, 57628, 81, 1, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2382631, 57633, 655, 19, 189, "Input",
 CellTags->"8.4 Solutions"],
Cell[2383289, 57654, 5195, 92, 418, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2388533, 57752, 392, 13, 67, "SolutionItem",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2388950, 57769, 205, 6, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2389158, 57777, 504, 9, 121, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2389677, 57789, 184, 9, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2389886, 57802, 95, 3, 82, "Input",
 CellTags->"8.4 Solutions"],
Cell[2389984, 57807, 903, 26, 121, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2390902, 57836, 110, 2, 67, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2391037, 57842, 555, 15, 240, "Input",
 CellTags->"8.4 Solutions"],
Cell[2391595, 57859, 564840, 9266, 409, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]],
Cell[2956450, 67128, 327, 9, 118, "SolutionText",
 CellTags->"8.4 Solutions"],
Cell[CellGroupData[{
Cell[2956802, 67141, 1116, 34, 292, "Input",
 CellTags->"8.4 Solutions"],
Cell[2957921, 67177, 160727, 2641, 753, "Output",
 CellTags->"8.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[3118711, 69825, 776, 17, 42, "TitleFlourish"],
Cell[3119490, 69844, 21, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[3119536, 69848, 31, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[3119592, 69852, 78, 1, 67, "ExerciseSubsection",
 CellTags->"Sec.Structure"],
Cell[3119673, 69855, 163, 4, 76, "ExerciseItem",
 CellTags->"9.1 Exercises"],
Cell[3119839, 69861, 315, 9, 117, "ExerciseItem",
 CellTags->"9.1 Exercises"],
Cell[3120157, 69872, 617, 21, 117, "ExerciseItem",
 CellTags->"9.1 Exercises"],
Cell[CellGroupData[{
Cell[3120799, 69897, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3120863, 69901, 104, 1, 67, "SolutionItem",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3120992, 69906, 107, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3121102, 69910, 84, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3121201, 69914, 135, 5, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3121361, 69923, 116, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3121480, 69928, 64, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3121559, 69932, 79, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3121663, 69937, 96, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3121762, 69941, 80, 2, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3121857, 69946, 204, 5, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3122086, 69955, 78, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3122167, 69959, 79, 2, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3122261, 69964, 80, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3122366, 69969, 98, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3122467, 69973, 64, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3122546, 69977, 103, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3122674, 69982, 116, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3122793, 69987, 83, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3122891, 69991, 163, 6, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3123079, 70001, 115, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3123197, 70006, 84, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3123296, 70010, 488, 14, 118, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3123809, 70028, 155, 4, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3123967, 70034, 64, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3124068, 70040, 161, 5, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3124232, 70047, 83, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3124352, 70053, 291, 9, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3124646, 70064, 84, 1, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3124779, 70071, 104, 1, 67, "SolutionItem",
 CellTags->"9.1 Solutions"],
Cell[3124886, 70074, 108, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3124997, 70078, 78, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3125078, 70082, 225, 7, 103, "Input",
 CellTags->"9.1 Solutions"],
Cell[3125306, 70091, 78, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3125387, 70095, 392, 13, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[3125782, 70110, 279, 9, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3126064, 70121, 226, 8, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[3126293, 70131, 105, 2, 82, "Input",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3126435, 70138, 112, 2, 67, "SolutionItem",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3126572, 70144, 183, 4, 136, "Input",
 CellTags->"9.1 Solutions"],
Cell[3126758, 70150, 287, 5, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3127060, 70158, 173, 2, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3127258, 70164, 125, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3127386, 70169, 156, 4, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3127557, 70176, 358, 12, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3127940, 70192, 136, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3128079, 70197, 156, 4, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3128250, 70204, 78, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[3128331, 70207, 217, 5, 73, "InputOnly",
 CellTags->"9.1 Solutions"],
Cell[3128551, 70214, 93, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3128669, 70219, 134, 3, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3128806, 70224, 251, 4, 172, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3129094, 70233, 103, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3129200, 70237, 439, 7, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]],
Cell[3129654, 70247, 89, 1, 67, "SolutionText",
 CellTags->"9.1 Solutions"],
Cell[CellGroupData[{
Cell[3129768, 70252, 104, 2, 82, "Input",
 CellTags->"9.1 Solutions"],
Cell[3129875, 70256, 73, 2, 67, "Output",
 CellTags->"9.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3130021, 70266, 80, 1, 45, "ExerciseSubsection",
 CellTags->"Sec.Operations"],
Cell[3130104, 70269, 667, 24, 123, "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:41"}],
Cell[CellGroupData[{
Cell[3130796, 70297, 546, 19, 117, "ExerciseItem",
 CellTags->"9.2 Exercises"],
Cell[CellGroupData[{
Cell[3131367, 70320, 176, 4, 82, "ExerciseInput",
 CellTags->"9.2 Exercises"],
Cell[3131546, 70326, 109, 1, 67, "ExerciseOutput",
 CellTags->"9.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[3131682, 70331, 367, 8, 171, "ExerciseItem",
 CellTags->"9.2 Exercises"],
Cell[3132052, 70341, 1655, 59, 211, "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:42"}],
Cell[3133710, 70402, 198, 4, 117, "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:43"}],
Cell[CellGroupData[{
Cell[3133933, 70410, 357, 8, 163, "ExerciseItem",
 CellTags->"9.2 Exercises"],
Cell[3134293, 70420, 130, 2, 67, "ExerciseOutput",
 CellTags->"9.2 Exercises"],
Cell[3134426, 70424, 438, 21, 73, "ExerciseText",
 CellTags->"9.2 Exercises"],
Cell[3134867, 70447, 132, 6, 73, "ExerciseText",
 CellTags->"9.2 Exercises"],
Cell[3135002, 70455, 76, 1, 73, "ExerciseText",
 CellTags->"9.2 Exercises"],
Cell[3135081, 70458, 125, 5, 73, "ExerciseText",
 CellTags->"9.2 Exercises"],
Cell[3135209, 70465, 193, 4, 126, "ExerciseText",
 CellTags->"9.2 Exercises"]
}, Closed]],
Cell[3135417, 70472, 915, 29, 180, "ExerciseItem",
 CellTags->{"9.2 Exercises", "i:44"}],
Cell[CellGroupData[{
Cell[3136357, 70505, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3136421, 70509, 121, 3, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[3136545, 70514, 198, 5, 73, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3136768, 70523, 103, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3136874, 70527, 60, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3136971, 70533, 102, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3137076, 70537, 59, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3137150, 70541, 153, 4, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3137306, 70547, 206, 5, 73, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3137537, 70556, 99, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3137639, 70560, 59, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3137713, 70564, 170, 6, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3137886, 70572, 203, 5, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3138092, 70579, 136, 5, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3138253, 70588, 124, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3138380, 70593, 1626, 26, 328, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3140055, 70625, 228, 8, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[3140286, 70635, 316, 10, 139, "Input",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3140627, 70649, 146, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3140776, 70654, 82, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3140907, 70661, 273, 8, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[3141183, 70671, 201, 6, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3141387, 70679, 124, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3141514, 70684, 125, 3, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3141642, 70689, 96, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3141741, 70693, 568, 17, 139, "Input",
 CellTags->"9.2 Solutions"],
Cell[3142312, 70712, 166, 5, 82, "Input",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3142515, 70722, 293, 11, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[3142811, 70735, 335, 10, 73, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3143171, 70749, 181, 5, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3143355, 70756, 193, 7, 103, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3143563, 70766, 207, 7, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3143773, 70775, 212, 6, 123, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[3143988, 70783, 701, 22, 229, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3144714, 70809, 156, 4, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3144873, 70815, 192, 7, 103, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3145102, 70827, 124, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3145229, 70832, 297, 7, 72, "Message",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3145541, 70842, 135, 3, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3145679, 70847, 426, 12, 126, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3146130, 70863, 169, 5, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3146302, 70870, 199, 7, 103, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3146516, 70880, 227, 8, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3146768, 70892, 250, 7, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3147021, 70901, 190, 7, 103, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3147226, 70911, 516, 15, 126, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3147767, 70930, 170, 5, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3147940, 70937, 199, 7, 103, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3148188, 70950, 176, 4, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3148389, 70958, 104, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3148496, 70962, 79, 2, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3148612, 70969, 332, 9, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3148947, 70980, 591, 9, 121, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3149575, 70994, 253, 7, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3149831, 71003, 1593, 30, 172, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3151461, 71038, 180, 5, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3151644, 71045, 1593, 30, 172, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3153252, 71078, 292, 9, 73, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[3153547, 71089, 296, 9, 126, "InputOnly",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3153868, 71102, 136, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3154007, 71107, 82, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3154126, 71113, 112, 3, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3154241, 71118, 82, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3154372, 71125, 126, 3, 67, "SolutionItem",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3154523, 71132, 170, 4, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3154696, 71138, 573, 9, 121, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3155284, 71150, 134, 6, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3155443, 71160, 92, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3155538, 71164, 69, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3155622, 71168, 111, 2, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3155758, 71174, 261, 7, 136, "Input",
 CellTags->"9.2 Solutions"],
Cell[3156022, 71183, 89, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3156126, 71187, 77, 1, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3156206, 71190, 538, 16, 139, "Input",
 CellTags->"9.2 Solutions"],
Cell[3156747, 71208, 78, 1, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3156850, 71213, 255, 7, 136, "Input",
 CellTags->"9.2 Solutions"],
Cell[3157108, 71222, 1537, 29, 172, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3158660, 71254, 123, 3, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3158786, 71259, 235, 7, 87, "Input",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3159046, 71270, 112, 2, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3159161, 71274, 81, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3159257, 71278, 248, 9, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3159508, 71289, 333, 10, 139, "Input",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3159866, 71303, 235, 6, 136, "Input",
 CellTags->"9.2 Solutions"],
Cell[3160104, 71311, 168, 4, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3160309, 71320, 311, 8, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3160623, 71330, 80, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]],
Cell[3160718, 71334, 97, 1, 67, "SolutionText",
 CellTags->"9.2 Solutions"],
Cell[3160818, 71337, 2073, 53, 814, "Input",
 CellTags->"9.2 Solutions"],
Cell[CellGroupData[{
Cell[3162916, 71394, 161, 4, 82, "Input",
 CellTags->"9.2 Solutions"],
Cell[3163080, 71400, 82, 1, 67, "Output",
 CellTags->"9.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3163235, 71409, 79, 1, 45, "ExerciseSubsection",
 CellTags->"Sec.String patterns"],
Cell[3163317, 71412, 788, 21, 217, "ExerciseItem",
 CellTags->"9.3 Exercises"],
Cell[3164108, 71435, 264, 5, 117, "ExerciseItem",
 CellTags->"9.3 Exercises"],
Cell[3164375, 71442, 440, 15, 117, "ExerciseItem",
 CellTags->{"9.3 Exercises", "i:57"}],
Cell[CellGroupData[{
Cell[3164840, 71461, 188, 6, 69, "ExerciseItem",
 CellTags->"9.3 Exercises"],
Cell[3165031, 71469, 228, 7, 82, "Input",
 CellTags->"9.3 Exercises"],
Cell[3165262, 71478, 301, 10, 126, "ExerciseText",
 CellTags->"9.3 Exercises"],
Cell[3165566, 71490, 2374, 47, 175, "ExerciseText",
 CellTags->{"i:94", "9.3 Exercises"}]
}, Closed]],
Cell[CellGroupData[{
Cell[3167977, 71542, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3168041, 71546, 155, 7, 67, "SolutionItem",
 CellTags->"9.3 Solutions"],
Cell[3168199, 71555, 208, 5, 87, "Input",
 CellTags->"9.3 Solutions"],
Cell[3168410, 71562, 676, 18, 168, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3169111, 71584, 299, 9, 139, "Input",
 CellTags->"9.3 Solutions"],
Cell[3169413, 71595, 501, 11, 121, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3169951, 71611, 239, 7, 136, "Input",
 CellTags->"9.3 Solutions"],
Cell[3170193, 71620, 521, 9, 121, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3170763, 71635, 122, 3, 67, "SolutionItem",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3170910, 71642, 263, 7, 136, "Input",
 CellTags->"9.3 Solutions"],
Cell[3171176, 71651, 381, 7, 121, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[3171572, 71661, 290, 8, 118, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3171887, 71673, 293, 9, 87, "Input",
 CellTags->"9.3 Solutions"],
Cell[3172183, 71684, 381, 7, 121, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3172613, 71697, 496, 14, 172, "SolutionItem",
 CellTags->"9.3 Solutions"],
Cell[3173112, 71713, 485, 13, 193, "Input",
 CellTags->"9.3 Solutions"],
Cell[3173600, 71728, 178, 3, 67, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[3173781, 71733, 409, 11, 73, "InputOnly",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3174215, 71748, 92, 2, 82, "Input",
 CellTags->"9.3 Solutions"],
Cell[3174310, 71752, 156, 4, 67, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3174503, 71761, 157, 3, 82, "Input",
 CellTags->"9.3 Solutions"],
Cell[3174663, 71766, 1626, 26, 328, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3176338, 71798, 82, 1, 67, "SolutionItem",
 CellTags->"9.3 Solutions"],
Cell[3176423, 71801, 228, 7, 82, "Input",
 CellTags->"9.3 Solutions"],
Cell[3176654, 71810, 154, 4, 67, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3176833, 71818, 346, 10, 136, "Input",
 CellTags->"9.3 Solutions"],
Cell[3177182, 71830, 542, 11, 157, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[3177739, 71844, 94, 1, 67, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3177858, 71849, 91, 2, 82, "Input",
 CellTags->"9.3 Solutions"],
Cell[3177952, 71853, 59, 1, 67, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[3178026, 71857, 83, 1, 67, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3178134, 71862, 234, 6, 136, "Input",
 CellTags->"9.3 Solutions"],
Cell[3178371, 71870, 542, 11, 157, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[3178928, 71884, 94, 1, 67, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3179047, 71889, 135, 4, 82, "Input",
 CellTags->"9.3 Solutions"],
Cell[3179185, 71895, 59, 1, 67, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[3179259, 71899, 276, 9, 118, "SolutionText",
 CellTags->"9.3 Solutions"],
Cell[CellGroupData[{
Cell[3179560, 71912, 295, 8, 136, "Input",
 CellTags->"9.3 Solutions"],
Cell[3179858, 71922, 59, 1, 67, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3179954, 71928, 443, 13, 189, "Input",
 CellTags->"9.3 Solutions"],
Cell[3180400, 71943, 59, 1, 67, "Output",
 CellTags->"9.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3180532, 71952, 49, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[3180606, 71956, 505, 16, 123, "ExerciseItem",
 CellTags->"9.4 Exercises"],
Cell[3181114, 71974, 175, 5, 82, "ExerciseInput",
 CellTags->"9.4 Exercises"],
Cell[CellGroupData[{
Cell[3181314, 71983, 196, 5, 87, "ExerciseInput",
 CellTags->"9.4 Exercises"],
Cell[3181513, 71990, 236, 5, 67, "ExerciseOutput",
 CellTags->"9.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[3181776, 71999, 608, 22, 171, "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:65"}],
Cell[3182387, 72023, 411, 14, 117, "ExerciseItem",
 CellTags->"9.4 Exercises"],
Cell[3182801, 72039, 633, 26, 117, "ExerciseItem",
 CellTags->"9.4 Exercises"],
Cell[CellGroupData[{
Cell[3183459, 72069, 2830, 79, 258, "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:66"}],
Cell[3186292, 72150, 374, 9, 136, "ExerciseInput",
 CellTags->"9.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3186703, 72164, 1079, 27, 265, "ExerciseItem",
 CellTags->{"9.4 Exercises", "i:68"}],
Cell[3187785, 72193, 692, 12, 654, "ExerciseInput",
 CellTags->"9.4 Exercises"]
}, Closed]],
Cell[3188492, 72208, 601, 15, 217, "ExerciseItem",
 CellTags->{"i:69", "9.4 Exercises"}],
Cell[CellGroupData[{
Cell[3189118, 72227, 890, 22, 306, "ExerciseItem",
 CellTags->{"i:70", "9.4 Exercises"}],
Cell[CellGroupData[{
Cell[3190033, 72253, 347, 9, 136, "ExerciseInput",
 CellTags->"9.4 Exercises"],
Cell[3190383, 72264, 391, 7, 121, "ExerciseOutput",
 CellTags->"9.4 Exercises"]
}, Closed]],
Cell[3190789, 72274, 289, 6, 126, "ExerciseText",
 CellTags->"9.4 Exercises"],
Cell[3191081, 72282, 295, 8, 136, "ExerciseInput",
 CellTags->"9.4 Exercises"]
}, Closed]],
Cell[3191391, 72293, 211, 5, 123, "ExerciseItem",
 CellTags->"9.4 Exercises"],
Cell[CellGroupData[{
Cell[3191627, 72302, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3191691, 72306, 459, 13, 172, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3192153, 72321, 156, 5, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3192334, 72330, 181, 5, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3192518, 72337, 214, 5, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3192781, 72348, 80, 1, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3192864, 72351, 235, 7, 123, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[3193102, 72360, 637, 17, 220, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3193764, 72381, 272, 7, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3194039, 72390, 172, 4, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3194260, 72400, 622, 19, 220, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3194885, 72421, 393, 11, 177, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3195303, 72436, 97, 2, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3195403, 72440, 68, 1, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3195486, 72444, 94, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3195583, 72447, 391, 10, 180, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3195999, 72461, 96, 2, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3196098, 72465, 67, 1, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3196214, 72472, 156, 4, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3196395, 72480, 223, 5, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3196621, 72487, 305, 6, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3196963, 72498, 334, 9, 141, "Input",
 CellTags->"9.4 Solutions"],
Cell[3197300, 72509, 305, 6, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3197654, 72521, 110, 2, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3197767, 72525, 352, 9, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3198122, 72536, 141, 4, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3198266, 72542, 1665, 43, 486, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3199956, 72589, 125, 3, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3200084, 72594, 307, 6, 121, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3200406, 72603, 88, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3200519, 72608, 196, 6, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3200718, 72616, 126, 3, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3200893, 72625, 605, 16, 220, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3201501, 72643, 670, 12, 654, "Input",
 CellTags->"9.4 Solutions"],
Cell[3202174, 72657, 446, 11, 136, "Input",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3202657, 72673, 215, 7, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3202875, 72682, 228, 7, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[3203106, 72691, 426, 11, 118, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3203557, 72706, 162, 4, 90, "Input",
 CellTags->"9.4 Solutions"],
Cell[3203722, 72712, 58, 1, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3203795, 72716, 324, 6, 168, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3204122, 72724, 407, 11, 123, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3204554, 72739, 148, 4, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3204705, 72745, 269, 4, 225, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3204989, 72752, 91, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3205105, 72757, 327, 10, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3205435, 72769, 413, 10, 261, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3205863, 72782, 121, 3, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3205987, 72787, 234, 7, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[3206224, 72796, 139, 4, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3206366, 72802, 237, 7, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[3206606, 72811, 139, 4, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3206770, 72819, 101, 2, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3206874, 72823, 21425, 659, 472, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3228314, 73485, 101, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3228440, 73490, 292, 9, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3228735, 73501, 1434, 20, 1207, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3230218, 73527, 86, 1, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3230307, 73530, 270, 7, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3230580, 73539, 210, 4, 118, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3230815, 73547, 249, 7, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3231067, 73556, 187, 4, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3231269, 73563, 224, 7, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3231518, 73574, 128, 3, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3231649, 73579, 139, 3, 73, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3231803, 73585, 436, 17, 118, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3232264, 73606, 350, 10, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3232617, 73618, 124, 3, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]],
Cell[3232756, 73624, 861, 23, 333, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[3233620, 73649, 229, 7, 69, "InputOnly",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[3233874, 73660, 160, 4, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3234037, 73666, 126, 3, 67, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3234212, 73675, 124, 3, 67, "SolutionItem",
 CellTags->"9.4 Solutions"],
Cell[3234339, 73680, 225, 7, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3234567, 73689, 81, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3234651, 73692, 350, 10, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3235004, 73704, 69, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3235076, 73707, 208, 6, 82, "Input",
 CellTags->"9.4 Solutions"],
Cell[3235287, 73715, 70, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3235360, 73718, 257, 7, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3235620, 73727, 101, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3235724, 73730, 1108, 30, 450, "Input",
 CellTags->"9.4 Solutions"],
Cell[3236835, 73762, 232, 5, 136, "Input",
 CellTags->"9.4 Solutions"],
Cell[3237070, 73769, 84, 1, 67, "SolutionText",
 CellTags->"9.4 Solutions"],
Cell[3237157, 73772, 321, 10, 82, "Input",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3237539, 73789, 55, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[3237619, 73793, 412, 9, 171, "ExerciseItem",
 CellTags->{"9.5 Exercises", "i:90"}],
Cell[CellGroupData[{
Cell[3238056, 73806, 374, 11, 82, "ExerciseInput",
 CellTags->"9.5 Exercises"],
Cell[3238433, 73819, 115, 1, 67, "ExerciseOutput",
 CellTags->"9.5 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3238585, 73825, 423, 13, 82, "ExerciseInput",
 CellTags->"9.5 Exercises"],
Cell[3239011, 73840, 246, 5, 67, "ExerciseOutput",
 CellTags->"9.5 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3239294, 73850, 400, 13, 82, "ExerciseInput",
 CellTags->"9.5 Exercises"],
Cell[3239697, 73865, 262, 6, 126, "Message",
 CellTags->"9.5 Exercises"]
}, Closed]]
}, Closed]],
Cell[3239986, 73875, 886, 26, 217, "ExerciseItem",
 CellTags->{"9.5 Exercises", "Ex.Anagrams", "i:91"}],
Cell[3240875, 73903, 228, 6, 117, "ExerciseItem",
 CellTags->"9.5 Exercises"],
Cell[3241106, 73911, 401, 10, 117, "ExerciseItem",
 CellTags->{"i:92", "9.5 Exercises"}],
Cell[3241510, 73923, 506, 15, 163, "ExerciseItem",
 CellTags->"9.5 Exercises"],
Cell[3242019, 73940, 1879, 66, 262, "ExerciseItem",
 CellTags->"9.5 Exercises"],
Cell[CellGroupData[{
Cell[3243923, 74010, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3243987, 74014, 149, 4, 67, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[3244139, 74020, 104, 2, 69, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[3244246, 74024, 227, 7, 69, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[3244476, 74033, 309, 7, 175, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[3244788, 74042, 1638, 40, 436, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[3246429, 74084, 2016, 49, 436, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3248470, 74137, 219, 6, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3248692, 74145, 64, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3248793, 74151, 296, 8, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3249092, 74161, 73, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3249202, 74167, 367, 9, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3249572, 74178, 193, 4, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3249802, 74187, 642, 14, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3250447, 74203, 193, 4, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3250677, 74212, 348, 10, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3251028, 74224, 262, 6, 126, "Message",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3251339, 74236, 274, 5, 118, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[3251616, 74243, 513, 15, 193, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3252154, 74262, 136, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3252293, 74268, 277, 7, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3252585, 74278, 181, 4, 118, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3252769, 74284, 913, 26, 244, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3253707, 74314, 136, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3253846, 74320, 277, 7, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3254138, 74330, 303, 6, 168, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3254444, 74338, 953, 26, 294, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3255422, 74368, 136, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3255561, 74374, 278, 7, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3255888, 74387, 331, 9, 118, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3256244, 74400, 167, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3256414, 74406, 149, 4, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3256578, 74413, 476, 12, 168, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3257057, 74427, 229, 7, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3257289, 74436, 1670, 38, 747, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3258984, 74478, 111, 2, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3259098, 74482, 149, 4, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3259284, 74491, 185, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3259472, 74497, 311, 6, 121, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3259820, 74508, 188, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3260011, 74514, 761, 13, 276, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3260809, 74532, 192, 5, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3261004, 74539, 1035, 16, 328, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3262088, 74561, 89, 1, 67, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[3262180, 74564, 228, 7, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3262411, 74573, 174, 5, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3262588, 74580, 96, 2, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3262687, 74584, 174, 5, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3262864, 74591, 345, 14, 118, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3263212, 74607, 291, 7, 189, "Input",
 CellTags->"9.5 Solutions"],
Cell[3263506, 74616, 118, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3263627, 74621, 135, 3, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3263765, 74626, 333, 10, 136, "Input",
 CellTags->"9.5 Solutions"],
Cell[3264101, 74638, 118, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3264222, 74643, 113, 2, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3264338, 74647, 773, 23, 343, "Input",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3265148, 74675, 98, 1, 67, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[3265249, 74678, 407, 11, 190, "Input",
 CellTags->"9.5 Solutions"],
Cell[3265659, 74691, 243, 8, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3265905, 74701, 104, 2, 69, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[3266012, 74705, 337, 10, 126, "InputOnly",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3266374, 74719, 258, 8, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3266635, 74729, 83, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3266733, 74733, 404, 12, 118, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3267162, 74749, 170, 4, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3267335, 74755, 228, 5, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3267612, 74766, 163, 4, 67, "SolutionItem",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3267800, 74774, 417, 12, 189, "Input",
 CellTags->"9.5 Solutions"],
Cell[3268220, 74788, 2031, 55, 172, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3270266, 74846, 107, 1, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3270376, 74849, 352, 11, 141, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3270753, 74864, 127, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3270883, 74869, 64, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3270962, 74873, 298, 6, 118, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3271263, 74881, 400, 11, 190, "Input",
 CellTags->"9.5 Solutions"],
Cell[3271666, 74894, 107, 1, 67, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3271776, 74897, 276, 8, 87, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3272077, 74909, 141, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3272221, 74914, 82, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3272340, 74920, 115, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3272458, 74925, 82, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]],
Cell[3272555, 74929, 189, 4, 118, "SolutionText",
 CellTags->"9.5 Solutions"],
Cell[3272747, 74935, 440, 12, 190, "Input",
 CellTags->"9.5 Solutions"],
Cell[CellGroupData[{
Cell[3273212, 74951, 141, 3, 82, "Input",
 CellTags->"9.5 Solutions"],
Cell[3273356, 74956, 82, 1, 67, "Output",
 CellTags->"9.5 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[3273501, 74964, 776, 17, 42, "TitleFlourish"],
Cell[3274280, 74983, 22, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[3274327, 74987, 50, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[3274402, 74991, 51, 0, 67, "ExerciseSubsection"],
Cell[3274456, 74993, 279, 9, 76, "ExerciseItem",
 CellTags->{"10.1 Exercises", "i:38"}],
Cell[3274738, 75004, 198, 4, 117, "ExerciseItem",
 CellTags->"10.1 Exercises"],
Cell[3274939, 75010, 331, 9, 117, "ExerciseItem",
 CellTags->"10.1 Exercises"],
Cell[3275273, 75021, 397, 11, 117, "ExerciseItem",
 CellTags->"10.1 Exercises"],
Cell[3275673, 75034, 509, 16, 163, "ExerciseItem",
 CellTags->"10.1 Exercises"],
Cell[CellGroupData[{
Cell[3276207, 75054, 1304, 42, 163, "ExerciseItem",
 CellTags->"10.1 Exercises"],
Cell[3277514, 75098, 897, 30, 139, "ExerciseDisplayFormula",
 CellTags->"10.1 Exercises"],
Cell[3278414, 75130, 337, 8, 126, "ExerciseText",
 CellTags->"10.1 Exercises"]
}, Closed]],
Cell[3278766, 75141, 468, 13, 123, "ExerciseItem",
 CellTags->{"Sinplot exercise", "10.1 Exercises"}],
Cell[CellGroupData[{
Cell[3279259, 75158, 702, 21, 163, "ExerciseItem",
 CellTags->{"Ex.StandardDeviation", "i:39", "10.1 Exercises"}],
Cell[3279964, 75181, 16096, 282, 580, "Figure",
 CellTags->"10.1 Exercises"]
}, Closed]],
Cell[3296075, 75466, 326, 10, 76, "ExerciseItem",
 CellTags->{"i:41", "10.1 Exercises"}],
Cell[3296404, 75478, 641, 15, 211, "ExerciseItem",
 CellTags->{"10.1 Exercises", "i:40"}],
Cell[CellGroupData[{
Cell[3297070, 75497, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3297134, 75501, 531, 17, 118, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3297668, 75520, 832, 26, 243, "Input",
 CellTags->"10.1 Solutions"],
Cell[3298503, 75548, 158, 5, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3298686, 75557, 119, 3, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3298808, 75562, 101224, 3076, 240, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3400081, 78644, 125, 3, 67, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3400209, 78649, 211, 7, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3400423, 78658, 652, 19, 234, "Input",
 CellTags->"10.1 Solutions"],
Cell[3401078, 78679, 135, 3, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3401216, 78684, 472, 17, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3401691, 78703, 489, 13, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3402183, 78718, 85, 1, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3402271, 78721, 631, 22, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3402905, 78745, 519, 15, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3403427, 78762, 130, 3, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3403560, 78767, 206, 6, 82, "Input",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3403803, 78778, 306, 8, 118, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3404134, 78790, 229, 7, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3404366, 78799, 426, 13, 121, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3404807, 78815, 310, 8, 118, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3405120, 78825, 292, 10, 69, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3405437, 78839, 183, 6, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3405623, 78847, 611, 11, 324, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3406283, 78864, 156, 4, 67, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3406464, 78872, 471, 14, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3406938, 78888, 200, 6, 364, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3407153, 78897, 333, 10, 118, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3407511, 78911, 714, 23, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3408228, 78936, 467, 9, 325, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3408710, 78948, 153, 4, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3408888, 78956, 694, 20, 240, "Input",
 CellTags->"10.1 Solutions"],
Cell[3409585, 78978, 1658, 34, 580, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3411292, 79018, 348, 12, 118, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3411643, 79032, 320, 9, 123, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[3411966, 79043, 161, 4, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3412130, 79049, 220, 6, 69, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[3412353, 79057, 311, 9, 118, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3412667, 79068, 206, 6, 69, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[3412876, 79076, 189, 6, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3413068, 79084, 287, 9, 69, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[3413358, 79095, 77, 1, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3413460, 79100, 92, 2, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3413555, 79104, 72639, 1004, 388, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3486243, 80114, 272, 10, 67, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3486518, 80126, 124, 3, 69, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3486667, 80133, 756, 25, 103, "Input",
 CellTags->"10.1 Solutions"],
Cell[3487426, 80160, 2019, 66, 469, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3489460, 80229, 306, 12, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3489791, 80245, 970, 27, 240, "Input",
 CellTags->"10.1 Solutions"],
Cell[3490764, 80274, 554, 21, 90, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3491333, 80298, 172, 6, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3491530, 80308, 198, 6, 87, "Input",
 CellTags->"10.1 Solutions"],
Cell[3491731, 80316, 296, 11, 90, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3492042, 80330, 280, 7, 118, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3492325, 80339, 226, 8, 117, "Input",
 CellTags->"10.1 Solutions"],
Cell[3492554, 80349, 125, 3, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3492682, 80354, 231, 9, 154, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3492938, 80367, 512, 17, 136, "Input",
 CellTags->"10.1 Solutions"],
Cell[3493453, 80386, 322, 7, 364, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3493790, 80396, 671, 20, 220, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3494464, 80418, 753, 27, 123, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3495242, 80449, 226, 6, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3495471, 80457, 384, 9, 364, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3495904, 80472, 89, 1, 67, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3496018, 80477, 263, 8, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3496284, 80487, 9397, 161, 301, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3505696, 80651, 102, 1, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3505823, 80656, 336, 10, 87, "Input",
 CellTags->"10.1 Solutions"],
Cell[3506162, 80668, 378, 11, 123, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3506555, 80682, 96, 1, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3506676, 80687, 466, 16, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3507145, 80705, 536, 16, 123, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3507696, 80724, 84, 1, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3507805, 80729, 252, 8, 82, "Input",
 CellTags->"10.1 Solutions"],
Cell[3508060, 80739, 48117, 998, 301, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3556226, 81743, 132, 3, 67, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3556361, 81748, 444, 12, 189, "Input",
 CellTags->"10.1 Solutions"],
Cell[3556808, 81762, 185, 4, 118, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3557018, 81770, 3589, 101, 499, "Input",
 CellTags->"10.1 Solutions"],
Cell[3560610, 81873, 16224, 283, 288, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]],
Cell[3576849, 82159, 156, 4, 67, "SolutionText",
 CellTags->"10.1 Solutions"],
Cell[3577008, 82165, 1039, 31, 190, "Input",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3578072, 82200, 1848, 51, 343, "Input",
 CellTags->"10.1 Solutions"],
Cell[3579923, 82253, 16262, 284, 288, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3596234, 82543, 456, 17, 118, "SolutionItem",
 CellTags->"10.1 Solutions"],
Cell[3596693, 82562, 652, 18, 177, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[3597348, 82582, 285, 9, 123, "InputOnly",
 CellTags->"10.1 Solutions"],
Cell[CellGroupData[{
Cell[3597658, 82595, 462, 12, 189, "Input",
 CellTags->"10.1 Solutions"],
Cell[3598123, 82609, 22512, 374, 397, "Output",
 CellTags->"10.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3620708, 82991, 50, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[3620783, 82995, 118, 1, 76, "ExerciseItem",
 CellTags->{"10.2 Exercises", "i:50"}],
Cell[3620904, 82998, 12751, 214, 366, "Picture",
 CellTags->"10.2 Exercises"],
Cell[3633658, 83214, 485, 14, 126, "ExerciseText",
 CellTags->{"10.2 Exercises", "i:51"}]
}, Closed]],
Cell[CellGroupData[{
Cell[3634180, 83233, 295, 7, 127, "ExerciseItem",
 CellTags->{"10.2 Exercises", "i:52"}],
Cell[3634478, 83242, 1899, 37, 607, "Picture",
 CellTags->"10.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3636414, 83284, 1241, 25, 432, "ExerciseItem",
 CellTags->{"10.2 Exercises", "Ex.Convex hull", "i:53"}],
Cell[3637658, 83311, 259, 8, 82, "ExerciseInput",
 CellTags->"10.2 Exercises"],
Cell[3637920, 83321, 141, 3, 82, "ExerciseInput",
 CellTags->"10.2 Exercises"],
Cell[CellGroupData[{
Cell[3638086, 83328, 116, 2, 82, "ExerciseInput",
 CellTags->"10.2 Exercises"],
Cell[3638205, 83332, 214, 5, 67, "ExerciseOutput",
 CellTags->"10.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[3638456, 83342, 120, 2, 82, "ExerciseInput",
 CellTags->"10.2 Exercises"],
Cell[3638579, 83346, 5033, 117, 427, "ExerciseOutput",
 CellTags->"10.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[3643639, 83467, 3289, 84, 307, "ExerciseItem",
 CellTags->{"i:54", "10.2 Exercises"}],
Cell[CellGroupData[{
Cell[3646953, 83555, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[3647017, 83559, 252, 8, 67, "SolutionItem",
 CellTags->"10.2 Solutions"],
Cell[3647272, 83569, 521, 17, 130, "InputOnly",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3647818, 83590, 334, 10, 136, "Input",
 CellTags->"10.2 Solutions"],
Cell[3648155, 83602, 574, 12, 321, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3648766, 83619, 1090, 32, 571, "Input",
 CellTags->"10.2 Solutions"],
Cell[3649859, 83653, 25036, 444, 204, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3674910, 84100, 213, 8, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3675148, 84112, 1030, 31, 483, "Input",
 CellTags->"10.2 Solutions"],
Cell[3676181, 84145, 23081, 405, 204, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3699277, 84553, 238, 8, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3699540, 84565, 136, 3, 87, "Input",
 CellTags->"10.2 Solutions"],
Cell[3699679, 84570, 58, 1, 67, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3699752, 84574, 448, 11, 168, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[3700203, 84587, 720, 24, 186, "InputOnly",
 CellTags->"10.2 Solutions",
 CellID->141910737],
Cell[CellGroupData[{
Cell[3700948, 84615, 1116, 33, 483, "Input",
 CellTags->"10.2 Solutions",
 CellID->16518451],
Cell[3702067, 84650, 18182, 347, 204, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3720286, 85002, 136, 3, 87, "Input",
 CellTags->"10.2 Solutions"],
Cell[3720425, 85007, 57, 1, 67, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3720531, 85014, 366, 9, 118, "SolutionItem",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3720922, 85027, 685, 20, 240, "Input",
 CellTags->"10.2 Solutions"],
Cell[3721610, 85049, 822, 27, 121, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3722447, 85079, 78, 1, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[3722528, 85082, 1452, 46, 343, "Input",
 CellTags->"10.2 Solutions"],
Cell[3723983, 85130, 374, 13, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3724382, 85147, 657, 16, 292, "Input",
 CellTags->"10.2 Solutions"],
Cell[3725042, 85165, 1959, 28, 393, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3727038, 85198, 133, 3, 87, "Input",
 CellTags->"10.2 Solutions"],
Cell[3727174, 85203, 58, 1, 67, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3727247, 85207, 249, 8, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3727521, 85219, 545, 14, 292, "Input",
 CellTags->"10.2 Solutions"],
Cell[3728069, 85235, 1551, 28, 393, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[3729657, 85268, 133, 3, 87, "Input",
 CellTags->"10.2 Solutions"],
Cell[3729793, 85273, 58, 1, 67, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3729900, 85280, 433, 11, 118, "SolutionItem",
 CellTags->"10.2 Solutions"],
Cell[3730336, 85293, 120, 2, 69, "InputOnly",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3730481, 85299, 310, 10, 136, "Input",
 CellTags->"10.2 Solutions"],
Cell[3730794, 85311, 157, 4, 67, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3730966, 85318, 255, 6, 118, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3731246, 85328, 409, 12, 87, "Input",
 CellTags->"10.2 Solutions"],
Cell[3731658, 85342, 700, 12, 324, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3732373, 85357, 70, 1, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3732468, 85362, 1162, 33, 294, "Input",
 CellTags->"10.2 Solutions"],
Cell[3733633, 85397, 4243, 109, 450, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3737891, 85509, 483, 14, 118, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[3738377, 85525, 104, 2, 69, "InputOnly",
 CellTags->"10.2 Solutions"],
Cell[3738484, 85529, 2070, 53, 658, "Input",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3740579, 85586, 98, 2, 82, "Input",
 CellTags->"10.2 Solutions"],
Cell[3740680, 85590, 4243, 109, 450, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3744972, 85705, 148, 4, 67, "SolutionItem",
 CellTags->"10.2 Solutions"],
Cell[3745123, 85711, 1603, 48, 346, "Input",
 CellTags->"10.2 Solutions"],
Cell[3746729, 85761, 276, 10, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3747030, 85775, 234, 6, 82, "Input",
 CellTags->"10.2 Solutions"],
Cell[3747267, 85783, 138428, 2278, 468, 113440, 1866, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[3885710, 88064, 221, 8, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[3885934, 88074, 281, 8, 123, "InputOnly",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[3886240, 88086, 411, 11, 189, "Input",
 CellTags->"10.2 Solutions"],
Cell[3886654, 88099, 140216, 2303, 333, "Output",
 CellTags->"10.2 Solutions"]
}, Closed]],
Cell[4026885, 90405, 126, 3, 67, "SolutionText",
 CellTags->"10.2 Solutions"],
Cell[CellGroupData[{
Cell[4027036, 90412, 809, 23, 325, "Input",
 CellTags->"10.2 Solutions"],
Cell[4027848, 90437, 2030449, 59431, 333, 2009040, 59078, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"10.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6058370, 149876, 35, 0, 45, "ExerciseSubsection"],
Cell[6058408, 149878, 403, 13, 85, "ExerciseItem",
 CellTags->"10.3 Exercises"],
Cell[CellGroupData[{
Cell[6058836, 149895, 297, 9, 81, "ExerciseItem",
 CellTags->"10.3 Exercises"],
Cell[CellGroupData[{
Cell[6059158, 149908, 382, 11, 100, "ExerciseInput",
 CellTags->"10.3 Exercises"],
Cell[6059543, 149921, 269756, 4474, 147, "ExerciseOutput",
 CellTags->"10.3 Exercises"]
}, Closed]]
}, Closed]],
Cell[6329326, 154399, 105, 1, 51, "ExerciseItem",
 CellTags->"10.3 Exercises"],
Cell[6329434, 154402, 611, 18, 114, "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:67"}],
Cell[6330048, 154422, 1034, 37, 114, "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:68"}],
Cell[6331085, 154461, 857, 36, 81, "ExerciseItem",
 CellTags->"10.3 Exercises"],
Cell[6331945, 154499, 188, 4, 81, "ExerciseItem",
 CellTags->"10.3 Exercises"],
Cell[6332136, 154505, 907, 37, 81, "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:69"}],
Cell[CellGroupData[{
Cell[6333068, 154546, 263, 5, 81, "ExerciseItem",
 CellTags->{"10.3 Exercises", "i:70"}],
Cell[6333334, 154553, 500, 18, 45, "ExerciseDisplayFormula",
 CellTags->"10.3 Exercises"],
Cell[6333837, 154573, 471, 17, 82, "ExerciseText",
 CellTags->"10.3 Exercises"],
Cell[6334311, 154592, 940, 25, 276, "ExerciseText",
 CellTags->"10.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[6335288, 154622, 39, 0, 100, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[6335352, 154626, 1056, 34, 270, "SolutionItem",
 CellTags->"10.3 Solutions"],
Cell[6336411, 154662, 246, 8, 144, "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6336694, 154675, 564, 16, 168, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 2}},
 CellTags->"10.3 Solutions"],
Cell[6337261, 154693, 267, 9, 100, "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6337565, 154707, 222, 7, 67, "SolutionItem",
 CellTags->"10.3 Solutions"],
Cell[6337790, 154716, 235, 7, 82, "Input",
 CellTags->"10.3 Solutions"],
Cell[6338028, 154725, 128, 5, 67, "SolutionText",
 CellTags->"10.3 Solutions"],
Cell[6338159, 154732, 238, 8, 82, "Input",
 CellTags->"10.3 Solutions"],
Cell[6338400, 154742, 179, 5, 67, "SolutionText",
 CellTags->"10.3 Solutions"],
Cell[6338582, 154749, 353, 11, 136, "Input",
 CellTags->"10.3 Solutions"],
Cell[6338938, 154762, 128, 3, 67, "SolutionText",
 CellTags->"10.3 Solutions"],
Cell[6339069, 154767, 405, 13, 136, "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6339511, 154785, 201, 5, 67, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"10.3 Solutions"],
Cell[6339715, 154792, 404, 13, 130, "InputOnly",
 CellTags->"10.3 Solutions"],
Cell[CellGroupData[{
Cell[6340144, 154809, 236, 7, 82, "Input",
 CellTags->"10.3 Solutions"],
Cell[6340383, 154818, 61254, 1011, 258, "Output",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[6401652, 155832, 103, 1, 67, "SolutionText",
 CellTags->"10.3 Solutions"],
Cell[6401758, 155835, 275, 9, 82, "Input",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6402070, 155849, 236, 5, 118, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"10.3 Solutions"],
Cell[6402309, 155856, 392, 12, 130, "InputOnly",
 CellTags->"10.3 Solutions"],
Cell[CellGroupData[{
Cell[6402726, 155872, 238, 7, 82, "Input",
 CellTags->"10.3 Solutions"],
Cell[6402967, 155881, 58513, 966, 258, "Output",
 CellTags->"10.3 Solutions"]
}, Closed]],
Cell[6461495, 156850, 100, 1, 67, "SolutionText",
 CellTags->"10.3 Solutions"],
Cell[6461598, 156853, 277, 9, 82, "Input",
 CellTags->"10.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6461936, 156869, 55, 0, 45, "ExerciseSubsection"],
Cell[6461994, 156871, 1038, 32, 229, "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:112"}],
Cell[6463035, 156905, 366, 10, 121, "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:113"}],
Cell[6463404, 156917, 712, 25, 171, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6464119, 156944, 272, 7, 121, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6464394, 156953, 511, 10, 222, "ExerciseItem",
 CellTags->{"Ex.SimpleClosedPath", "10.4 Exercises", "i:114"}],
Cell[6464908, 156965, 400, 13, 121, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6465311, 156980, 495, 9, 222, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[CellGroupData[{
Cell[6465831, 156993, 550, 14, 171, "ExerciseItem",
 CellTags->{"10.4 Exercises", "Ex.ShowWalk", "i:115"}],
Cell[6466384, 157009, 103, 2, 82, "Input",
 CellTags->"10.4 Exercises"],
Cell[CellGroupData[{
Cell[6466512, 157015, 354, 10, 136, "Input",
 CellTags->"10.4 Exercises"],
Cell[6466869, 157027, 2335, 46, 375, "Output",
 CellTags->"10.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[6469241, 157078, 456, 13, 136, "Input",
 CellTags->"10.4 Exercises"],
Cell[6469700, 157093, 3562, 66, 384, "Output",
 CellTags->"10.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[6473299, 157164, 418, 12, 136, "Input",
 CellTags->"10.4 Exercises"],
Cell[6473720, 157178, 5999, 101, 423, "Output",
 CellTags->"10.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[6479746, 157283, 957, 33, 177, "ExerciseItem",
 CellTags->{"Ex.Mesh", "i:116", "10.4 Exercises"}],
Cell[6480706, 157318, 288, 7, 121, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6480997, 157327, 449, 12, 121, "ExerciseItem",
 CellTags->{"Ex.PointInPolygon", "10.4 Exercises"}],
Cell[6481449, 157341, 556, 13, 189, "ExerciseItem",
 CellTags->{"10.4 Exercises", "i:117"}],
Cell[6482008, 157356, 989, 36, 240, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6483000, 157394, 411, 16, 87, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[6483414, 157412, 1103, 32, 330, "ExerciseItem",
 CellTags->"10.4 Exercises"],
Cell[CellGroupData[{
Cell[6484542, 157448, 39, 0, 69, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[6484606, 157452, 515, 14, 168, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[6485124, 157468, 191, 5, 69, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[6485318, 157475, 1055, 31, 294, "Input",
 CellTags->"10.4 Solutions"],
Cell[6486376, 157508, 280, 9, 67, "SolutionText",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6486681, 157521, 460, 15, 136, "Input",
 CellTags->"10.4 Solutions"],
Cell[6487144, 157538, 648, 19, 330, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6487841, 157563, 287, 7, 118, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[6488131, 157572, 480, 13, 177, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6488636, 157589, 240, 6, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[6488879, 157597, 1411, 33, 411, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6490339, 157636, 89, 1, 67, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[6490431, 157639, 310, 9, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[6490744, 157650, 723, 22, 168, "SolutionText",
 CellTags->"10.4 Solutions"],
Cell[6491470, 157674, 1173, 33, 334, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[6492646, 157709, 308, 9, 123, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6492979, 157722, 216, 5, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[6493198, 157729, 1202, 21, 334, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6494449, 157756, 1089, 28, 321, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 4}},
 CellTags->"10.4 Solutions"],
Cell[6495541, 157786, 1267, 36, 283, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[6496811, 157824, 219, 7, 69, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[6497033, 157833, 467, 13, 177, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6497525, 157850, 136, 3, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[6497664, 157855, 1873, 35, 337, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6499586, 157896, 248, 8, 67, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[6499837, 157906, 1235, 36, 297, "Input",
 CellTags->"10.4 Solutions"],
Cell[6501075, 157944, 215, 7, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[6501293, 157953, 136, 3, 82, "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6501466, 157961, 354, 8, 118, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6501845, 157973, 200, 6, 87, "Input",
 CellTags->"10.4 Solutions"],
Cell[6502048, 157981, 60, 1, 67, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6502145, 157987, 427, 15, 87, "Input",
 CellTags->"10.4 Solutions"],
Cell[6502575, 158004, 60, 1, 67, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6502672, 158010, 470, 16, 87, "Input",
 CellTags->"10.4 Solutions"],
Cell[6503145, 158028, 60, 1, 67, "Output",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[6503220, 158032, 142, 4, 67, "SolutionText",
 CellTags->"10.4 Solutions"],
Cell[6503365, 158038, 501, 15, 190, "Input",
 CellTags->"10.4 Solutions"],
Cell[6503869, 158055, 157, 4, 67, "SolutionText",
 CellTags->"10.4 Solutions"],
Cell[6504029, 158061, 797, 24, 294, "Input",
 CellTags->"10.4 Solutions"],
Cell[6504829, 158087, 148, 4, 67, "SolutionText",
 CellTags->"10.4 Solutions"],
Cell[6504980, 158093, 747, 23, 243, "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[6505764, 158121, 529, 18, 118, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[6506296, 158141, 508, 18, 127, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[6506829, 158163, 1073, 33, 189, "Input",
 CellTags->"10.4 Solutions"],
Cell[6507905, 158198, 577655, 9493, 324, 549947, 9037, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7085609, 167697, 278, 8, 118, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[7085890, 167707, 268, 9, 94, "Program",
 CellTags->"10.4 Solutions"],
Cell[7086161, 167718, 102, 2, 69, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7086266, 167722, 245, 6, 175, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7086514, 167730, 241, 6, 175, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7086758, 167738, 331, 10, 123, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7087092, 167750, 4262, 116, 1216, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7091357, 167868, 280, 8, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[7091640, 167878, 629, 16, 240, "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7092306, 167899, 400, 14, 118, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[7092709, 167915, 990, 34, 175, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7093702, 167951, 435, 14, 126, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7094140, 167967, 2522, 78, 496, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[CellGroupData[{
Cell[7096687, 168049, 1633, 48, 555, "Input",
 CellTags->"10.4 Solutions"],
Cell[7098323, 168099, 215440, 3540, 828, 155755, 2559, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7313812, 171645, 108, 1, 67, "SolutionItem",
 CellTags->"10.4 Solutions"],
Cell[7313923, 171648, 238, 7, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[7314164, 171657, 1101, 31, 292, "Input",
 CellTags->"10.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7315302, 171693, 154, 3, 67, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 13}},
 CellTags->"10.4 Solutions"],
Cell[7315459, 171698, 214, 6, 82, "Input",
 CellTags->"10.4 Solutions"],
Cell[7315676, 171706, 1862, 52, 438, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7317541, 171760, 175, 5, 69, "InputOnly",
 CellTags->"10.4 Solutions"],
Cell[7317719, 171767, 437, 12, 189, "Input",
 CellTags->"10.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[7318207, 171785, 776, 17, 42, "TitleFlourish"],
Cell[7318986, 171804, 22, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[7319033, 171808, 43, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[7319101, 171812, 54, 0, 67, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[7319180, 171816, 199, 4, 85, "ExerciseItem",
 CellTags->{"11.1 Exercises", "i:26"}],
Cell[CellGroupData[{
Cell[7319404, 171824, 135, 3, 55, "ExerciseInput",
 CellTags->"11.1 Exercises"],
Cell[7319542, 171829, 672, 12, 148, "ExerciseOutput",
 CellTags->"11.1 Exercises"]
}, Closed]],
Cell[7320229, 171844, 265, 8, 49, "ExerciseText",
 CellTags->"11.1 Exercises"],
Cell[CellGroupData[{
Cell[7320519, 171856, 365, 10, 94, "ExerciseInput",
 CellTags->"11.1 Exercises"],
Cell[7320887, 171868, 332, 6, 81, "ExerciseOutput",
 CellTags->"11.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[7321246, 171878, 742, 23, 118, "ExerciseItem",
 CellTags->{"i:27", "11.1 Exercises"}],
Cell[CellGroupData[{
Cell[7322013, 171905, 351, 9, 81, "ExerciseItem",
 CellTags->{"i:28", "11.1 Exercises"}],
Cell[7322367, 171916, 4913, 102, 492, "Figure",
 CellTags->"11.1 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[7327317, 172023, 357, 6, 118, "ExerciseItem",
 CellTags->{"i:29", "11.1 Exercises"}],
Cell[7327677, 172031, 237, 6, 55, "ExerciseInput",
 CellTags->"11.1 Exercises"],
Cell[CellGroupData[{
Cell[7327939, 172041, 143, 3, 55, "ExerciseInput",
 CellTags->"11.1 Exercises"],
Cell[7328085, 172046, 375, 9, 81, "ExerciseOutput",
 CellTags->"11.1 Exercises"]
}, Closed]]
}, Closed]],
Cell[7328487, 172059, 357, 8, 85, "ExerciseItem",
 CellTags->{"Ex.Random walk animate", "i:30", "11.1 Exercises"}],
Cell[CellGroupData[{
Cell[7328869, 172071, 370, 12, 81, "ExerciseItem",
 CellTags->{"i:31", "11.1 Exercises"}],
Cell[7329242, 172085, 2317, 51, 333, "Picture",
 CellTags->"11.1 Exercises"]
}, Closed]],
Cell[7331574, 172139, 405, 10, 85, "ExerciseItem",
 CellTags->{"Ex.Hypocycloid", "11.1 Exercises"}],
Cell[CellGroupData[{
Cell[7332004, 172153, 415, 9, 114, "ExerciseItem",
 CellTags->{"Ex.Epicycloids", "i:32", "11.1 Exercises"}],
Cell[7332422, 172164, 1014, 36, 127, "ExerciseText",
 CellTags->"11.1 Exercises"],
Cell[7333439, 172202, 168, 4, 49, "ExerciseText",
 CellTags->"11.1 Exercises"]
}, Closed]],
Cell[7333622, 172209, 1752, 43, 153, "ExerciseItem",
 CellTags->{"i:33", "11.1 Exercises"}],
Cell[7335377, 172254, 265, 5, 81, "ExerciseItem",
 CellTags->{"i:34", "11.1 Exercises"}],
Cell[7335645, 172261, 436, 10, 114, "ExerciseItem",
 CellTags->{"i:35", "11.1 Exercises"}],
Cell[CellGroupData[{
Cell[7336106, 172275, 481, 8, 148, "ExerciseItem",
 CellTags->{"i:36", "11.1 Exercises"}],
Cell[7336590, 172285, 2451, 49, 375, "Picture",
 CellTags->"11.1 Exercises"]
}, Closed]],
Cell[7339056, 172337, 575, 16, 118, "ExerciseItem",
 CellTags->{"i:37", "11.1 Exercises"}],
Cell[CellGroupData[{
Cell[7339656, 172357, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7339720, 172361, 682, 19, 147, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7340405, 172382, 657, 17, 118, "InputOnly",
 CellTags->"11.1 Solutions"],
Cell[7341065, 172401, 109, 2, 55, "Input",
 CellTags->"11.1 Solutions"],
Cell[7341177, 172405, 982, 26, 264, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7342196, 172436, 311, 9, 78, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7342510, 172447, 125630, 2069, 367, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7468177, 174521, 223, 9, 45, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7468403, 174532, 2629, 75, 369, "Input",
 CellTags->"11.1 Solutions"],
Cell[7471035, 174609, 248, 8, 45, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7471286, 174619, 3512, 100, 585, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7474835, 174724, 537, 18, 78, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7475375, 174744, 215, 6, 55, "Input",
 CellTags->"11.1 Solutions"],
Cell[7475593, 174752, 1028, 25, 298, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7476658, 174782, 167, 4, 45, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7476828, 174788, 89, 2, 55, "Input",
 CellTags->"11.1 Solutions"],
Cell[7476920, 174792, 145, 5, 45, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7477068, 174799, 258, 7, 55, "Input",
 CellTags->"11.1 Solutions"],
Cell[7477329, 174808, 374, 10, 78, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7477706, 174820, 401, 12, 126, "Input",
 CellTags->"11.1 Solutions"],
Cell[7478110, 174834, 677, 22, 112, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7478790, 174858, 1268, 36, 229, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7480095, 174899, 316, 9, 78, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7480414, 174910, 1887, 50, 264, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7482338, 174965, 476, 14, 78, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 7}},
 CellTags->"11.1 Solutions"],
Cell[7482817, 174981, 4236, 114, 601, "Input",
 CellTags->"11.1 Solutions"],
Cell[7487056, 175097, 82, 1, 45, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7487141, 175100, 152, 4, 55, "Input",
 CellTags->"11.1 Solutions"],
Cell[7487296, 175106, 85, 1, 45, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7487384, 175109, 901, 26, 160, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7488322, 175140, 169, 4, 45, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7488494, 175146, 961, 26, 229, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7489492, 175177, 1276, 40, 147, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7490771, 175219, 2847, 69, 643, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7493655, 175293, 305, 8, 78, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7493963, 175303, 1214, 33, 229, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7495214, 175341, 385, 13, 45, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7495602, 175356, 2143, 62, 367, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7497782, 175423, 221, 8, 45, "SolutionItem",
 CellTags->"11.1 Solutions"],
Cell[7498006, 175433, 928, 24, 264, "Input",
 CellTags->"11.1 Solutions"],
Cell[7498937, 175459, 878, 28, 112, "SolutionText",
 CellTags->"11.1 Solutions"],
Cell[7499818, 175489, 1164, 29, 298, "Input",
 CellTags->"11.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7501043, 175525, 66, 0, 45, "ExerciseSubsection"],
Cell[7501112, 175527, 291, 8, 51, "ExerciseItem",
 CellTags->{"11.2 Exercises", "i:55"}],
Cell[7501406, 175537, 145, 4, 45, "ExerciseItem",
 CellTags->"11.2 Exercises"],
Cell[7501554, 175543, 136, 3, 45, "ExerciseItem",
 CellTags->"11.2 Exercises"],
Cell[CellGroupData[{
Cell[7501715, 175550, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7501779, 175554, 350, 13, 45, "SolutionItem",
 CellTags->"11.2 Solutions"],
Cell[7502132, 175569, 235, 6, 55, "Input",
 CellTags->"11.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7502404, 175580, 242, 7, 45, "SolutionItem",
 CellTags->"11.2 Solutions"],
Cell[7502649, 175589, 659, 19, 160, "Input",
 CellTags->"11.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7503369, 175615, 55, 0, 45, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[7503449, 175619, 210, 4, 85, "ExerciseItem",
 CellTags->{"11.3 Exercises", "i:71"}],
Cell[7503662, 175625, 337, 9, 127, "ExerciseInput",
 CellTags->"11.3 Exercises"],
Cell[CellGroupData[{
Cell[7504024, 175638, 134, 3, 55, "ExerciseInput",
 CellTags->"11.3 Exercises"],
Cell[7504161, 175643, 1003, 20, 222, "ExerciseOutput",
 CellTags->"11.3 Exercises"]
}, Closed]],
Cell[7505179, 175666, 435, 11, 117, "ExerciseText",
 CellTags->"11.3 Exercises"]
}, Closed]],
Cell[7505629, 175680, 472, 13, 118, "ExerciseItem",
 CellTags->"11.3 Exercises"],
Cell[7506104, 175695, 489, 11, 114, "ExerciseItem",
 CellTags->{"i:72", "11.3 Exercises"}],
Cell[7506596, 175708, 1187, 26, 216, "ExerciseItem",
 CellTags->"11.3 Exercises"],
Cell[CellGroupData[{
Cell[7507808, 175738, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7507872, 175742, 149, 4, 45, "SolutionItem",
 CellTags->"11.3 Solutions"],
Cell[7508024, 175748, 425, 12, 118, "InputOnly",
 CellTags->"11.3 Solutions"],
Cell[7508452, 175762, 179, 6, 55, "Input",
 CellTags->"11.3 Solutions"],
Cell[7508634, 175770, 390, 12, 93, "Input",
 CellTags->"11.3 Solutions"],
Cell[7509027, 175784, 493, 15, 118, "InputOnly",
 CellTags->"11.3 Solutions"],
Cell[7509523, 175801, 711, 22, 121, "InputOnly",
 CellTags->"11.3 Solutions"],
Cell[7510237, 175825, 691, 25, 117, "InputOnly",
 CellTags->"11.3 Solutions"],
Cell[7510931, 175852, 788, 23, 196, "Input",
 CellTags->"11.3 Solutions"],
Cell[7511722, 175877, 1343, 38, 300, "Input",
 CellTags->"11.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7513102, 175920, 525, 16, 78, "SolutionItem",
 CellTags->"11.3 Solutions"],
Cell[7513630, 175938, 1405, 35, 334, "Input",
 CellTags->"11.3 Solutions"],
Cell[7515038, 175975, 135, 5, 45, "SolutionText",
 CellTags->"11.3 Solutions"],
Cell[7515176, 175982, 1499, 38, 369, "Input",
 CellTags->"11.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7516712, 176025, 291, 8, 45, "SolutionItem",
 CellTags->"11.3 Solutions"],
Cell[7517006, 176035, 215, 7, 55, "Input",
 CellTags->"11.3 Solutions"],
Cell[7517224, 176044, 330, 9, 91, "Input",
 CellTags->"11.3 Solutions"],
Cell[7517557, 176055, 577, 16, 160, "Input",
 CellTags->"11.3 Solutions"],
Cell[7518137, 176073, 299, 8, 78, "SolutionText",
 CellTags->"11.3 Solutions"],
Cell[7518439, 176083, 2278, 60, 471, "Input",
 CellTags->"11.3 Solutions"],
Cell[7520720, 176145, 3720, 66, 112, "SolutionText",
 CellTags->"11.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[7524491, 176217, 776, 17, 42, "TitleFlourish"],
Cell[7525270, 176236, 22, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[7525317, 176240, 113, 5, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[7525455, 176249, 137, 2, 67, "ExerciseSubsection",
 CounterAssignments->{{"Section", 1}, {"ExerciseItem", 0}},
 CellTags->"12.2 Exercises"],
Cell[7525595, 176253, 472, 17, 85, "ExerciseItem",
 CellTags->"12.2 Exercises"],
Cell[CellGroupData[{
Cell[7526092, 176274, 644, 20, 114, "ExerciseItem",
 CellTags->{"i:28", "12.2 Exercises"}],
Cell[CellGroupData[{
Cell[7526761, 176298, 156, 3, 54, "NumberedFigure",
 CellTags->{"12.2 Exercises", "Figure triangular numbers"}],
Cell[7526920, 176303, 2564, 57, 129, "Figure",
 CellTags->"12.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7529533, 176366, 709, 19, 153, "ExerciseItem",
 CellTags->{"i:27", "12.2 Exercises"}],
Cell[7530245, 176387, 392, 11, 93, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[7530640, 176400, 275, 8, 58, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[7530918, 176410, 244, 8, 69, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[7531165, 176420, 244, 8, 69, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[CellGroupData[{
Cell[7531434, 176432, 183, 4, 55, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[7531620, 176438, 149, 4, 45, "ExerciseOutput",
 CellTags->"12.2 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[7531806, 176447, 183, 4, 55, "ExerciseInput",
 CellTags->"12.2 Exercises"],
Cell[7531992, 176453, 151, 4, 45, "ExerciseOutput",
 CellTags->"12.2 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7532192, 176463, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7532256, 176467, 325, 9, 45, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 0}},
 CellTags->"12.2 Solutions"],
Cell[7532584, 176478, 140, 3, 46, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[7532727, 176483, 797, 23, 153, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7533549, 176510, 206, 6, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7533758, 176518, 539, 16, 115, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7534346, 176540, 842, 28, 115, "SolutionItem",
 CellTags->"12.2 Solutions"],
Cell[7535191, 176570, 374, 11, 84, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[7535568, 176583, 255, 7, 49, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[7535826, 176592, 224, 7, 60, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[7536053, 176601, 224, 7, 60, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[7536280, 176610, 281, 9, 45, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7536586, 176623, 260, 9, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7536849, 176634, 124, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7537010, 176642, 146, 4, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7537159, 176648, 126, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7537300, 176654, 176, 4, 78, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7537501, 176662, 205, 4, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7537709, 176668, 481, 10, 115, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7538227, 176683, 223, 7, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7538453, 176692, 475, 9, 48, "Message",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7538943, 176704, 802, 25, 112, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7539770, 176733, 97, 2, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7539870, 176737, 175, 5, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7540082, 176747, 100, 2, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7540185, 176751, 87, 2, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7540309, 176758, 200, 6, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7540512, 176766, 125, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7540652, 176772, 311, 10, 45, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7540988, 176786, 142, 4, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7541133, 176792, 125, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7541273, 176798, 108, 1, 45, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[7541384, 176801, 229, 6, 55, "Input",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7541650, 176812, 323, 11, 45, "SolutionItem",
 CellTags->"12.2 Solutions"],
Cell[7541976, 176825, 192, 5, 49, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7542193, 176834, 215, 6, 55, "Input",
 CellTags->"12.2 Solutions"],
Cell[7542411, 176842, 1393, 21, 288, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7543841, 176868, 157, 4, 69, "Input",
 CellTags->"12.2 Solutions"],
Cell[7544001, 176874, 132, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7544148, 176880, 162, 4, 45, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[7544313, 176886, 275, 8, 49, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7544613, 176898, 158, 4, 69, "Input",
 CellTags->"12.2 Solutions"],
Cell[7544774, 176904, 132, 3, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]],
Cell[7544921, 176910, 541, 21, 118, "SolutionText",
 CellTags->"12.2 Solutions"],
Cell[7545465, 176933, 212, 6, 49, "InputOnly",
 CellTags->"12.2 Solutions"],
Cell[CellGroupData[{
Cell[7545702, 176943, 158, 4, 69, "Input",
 CellTags->"12.2 Solutions"],
Cell[7545863, 176949, 139, 4, 45, "Output",
 CellTags->"12.2 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7546075, 176961, 78, 1, 45, "ExerciseSubsection",
 CellTags->"12.3 Exercises"],
Cell[7546156, 176964, 745, 25, 127, "ExerciseItem",
 CellTags->{"i:47", "12.3 Exercises"}],
Cell[CellGroupData[{
Cell[7546926, 176993, 849, 24, 148, "ExerciseItem",
 CellTags->{"i:48", "12.3 Exercises"}],
Cell[7547778, 177019, 435, 13, 93, "ExerciseInput",
 CellTags->"12.3 Exercises"],
Cell[7548216, 177034, 704, 22, 174, "ExerciseInput",
 CellTags->"12.3 Exercises"],
Cell[CellGroupData[{
Cell[7548945, 177060, 205, 5, 55, "ExerciseInput",
 CellTags->"12.3 Exercises"],
Cell[7549153, 177067, 13255, 222, 283, "ExerciseOutput",
 CellTags->"12.3 Exercises"]
}, Closed]],
Cell[7562423, 177292, 142, 4, 49, "ExerciseText",
 CellTags->"12.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[7562602, 177301, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7562666, 177305, 349, 12, 78, "SolutionItem",
 CellTags->"12.3 Solutions"],
Cell[CellGroupData[{
Cell[7563040, 177321, 90, 2, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7563133, 177325, 430, 11, 81, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7563600, 177341, 339, 11, 67, "Input",
 CellTags->"12.3 Solutions"],
Cell[7563942, 177354, 355, 7, 81, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],
Cell[7564312, 177364, 385, 14, 49, "SolutionText",
 CellTags->"12.3 Solutions"],
Cell[7564700, 177380, 361, 13, 69, "Input",
 CellTags->"12.3 Solutions"],
Cell[7565064, 177395, 74, 1, 45, "SolutionText",
 CellTags->"12.3 Solutions"],
Cell[7565141, 177398, 266, 8, 49, "InputOnly",
 CellTags->"12.3 Solutions"],
Cell[CellGroupData[{
Cell[7565432, 177410, 124, 3, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7565559, 177415, 386, 8, 81, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],
Cell[7565960, 177426, 107, 3, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7566070, 177431, 89, 1, 45, "SolutionText",
 CellTags->"12.3 Solutions"],
Cell[CellGroupData[{
Cell[7566184, 177436, 289, 11, 69, "Input",
 CellTags->"12.3 Solutions"],
Cell[7566476, 177449, 135, 2, 51, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7566660, 177457, 673, 22, 112, "SolutionItem",
 CellTags->"12.3 Solutions"],
Cell[7567336, 177481, 417, 13, 84, "InputOnly",
 CellTags->"12.3 Solutions"],
Cell[CellGroupData[{
Cell[7567778, 177498, 90, 2, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7567871, 177502, 430, 11, 81, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7568338, 177518, 112, 2, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7568453, 177522, 112, 4, 45, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]],
Cell[7568580, 177529, 706, 22, 147, "InputOnly",
 CellTags->"12.3 Solutions"],
Cell[CellGroupData[{
Cell[7569311, 177555, 179, 5, 55, "Input",
 CellTags->"12.3 Solutions"],
Cell[7569493, 177562, 221635, 3637, 265, "Output",
 CellTags->"12.3 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7791201, 181207, 68, 1, 45, "ExerciseSubsection",
 CellTags->"12.4 Exercises"],
Cell[7791272, 181210, 849, 25, 153, "ExerciseItem",
 CellTags->"12.4 Exercises"],
Cell[7792124, 181237, 179, 4, 81, "ExerciseItem",
 CellTags->"12.4 Exercises"],
Cell[CellGroupData[{
Cell[7792328, 181245, 486, 14, 81, "ExerciseItem",
 CellTags->{"i:63", "12.4 Exercises"}],
Cell[7792817, 181261, 522, 20, 57, "ExerciseDisplayFormula",
 CellTags->{"i:63", "12.4 Exercises"}],
Cell[7793342, 181283, 389, 13, 82, "ExerciseText",
 CellTags->{"i:63", "12.4 Exercises"}]
}, Closed]],
Cell[CellGroupData[{
Cell[7793768, 181301, 39, 0, 67, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[7793832, 181305, 99, 1, 45, "SolutionItem",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7793956, 181310, 165, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7794124, 181317, 142, 4, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7794281, 181324, 161, 4, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7794467, 181332, 561, 16, 112, "Input",
 CellTags->"12.4 Solutions"],
Cell[7795031, 181350, 558, 10, 120, "Message",
 CellTags->"12.4 Solutions"],
Cell[7795592, 181362, 392, 14, 73, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7795999, 181379, 226, 7, 48, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7796250, 181390, 93, 2, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7796346, 181394, 57, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7796440, 181400, 571, 16, 112, "Input",
 CellTags->"12.4 Solutions"],
Cell[7797014, 181418, 392, 14, 73, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7797443, 181437, 91, 2, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7797537, 181441, 75, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7797627, 181445, 92, 1, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7797744, 181450, 87, 2, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7797834, 181454, 75, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7797924, 181458, 106, 1, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7798055, 181463, 192, 6, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7798250, 181471, 374, 11, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7798661, 181487, 92, 2, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7798756, 181491, 171, 5, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7798942, 181499, 372, 12, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7799339, 181515, 113, 3, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7799455, 181520, 173, 5, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7799665, 181530, 175, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7799843, 181537, 60, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7799918, 181541, 126, 3, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[7800047, 181546, 251, 9, 60, "InputOnly",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7800323, 181559, 152, 4, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7800478, 181565, 130, 3, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7800645, 181573, 175, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7800823, 181580, 130, 3, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7800990, 181588, 181, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7801174, 181595, 60, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7801249, 181599, 149, 4, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7801423, 181607, 638, 18, 147, "Input",
 CellTags->"12.4 Solutions"],
Cell[7802064, 181627, 392, 14, 73, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7802471, 181644, 510, 18, 45, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7803006, 181666, 690, 20, 147, "Input",
 CellTags->"12.4 Solutions"],
Cell[7803699, 181688, 474, 15, 73, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7804210, 181708, 153, 4, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7804366, 181714, 130, 3, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[7804511, 181720, 186, 4, 78, "SolutionText",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7804722, 181728, 335, 11, 88, "Input",
 CellTags->"12.4 Solutions"],
Cell[7805060, 181741, 75, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7805172, 181747, 118, 3, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7805293, 181752, 75, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7805417, 181759, 401, 10, 78, "SolutionItem",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7805843, 181773, 651, 18, 147, "Input",
 CellTags->"12.4 Solutions"],
Cell[7806497, 181793, 387, 14, 73, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7806921, 181812, 169, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7807093, 181819, 416, 9, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7807546, 181833, 95, 2, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7807644, 181837, 174, 5, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7807855, 181847, 178, 5, 55, "Input",
 CellTags->"12.4 Solutions"],
Cell[7808036, 181854, 60, 1, 45, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7808145, 181861, 377, 14, 45, "SolutionItem",
 CellTags->"12.4 Solutions"],
Cell[CellGroupData[{
Cell[7808547, 181879, 1309, 37, 196, "Input",
 CellTags->"12.4 Solutions"],
Cell[7809859, 181918, 923, 30, 115, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[7810819, 181953, 1006, 31, 276, "Input",
 CellTags->"12.4 Solutions"],
Cell[7811828, 181986, 2763733, 45311, 265, "Output",
 CellTags->"12.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[10575624, 227304, 776, 17, 42, "TitleFlourish"],
Cell[10576403, 227323, 22, 0, 48, "ChapterN"],
Cell[CellGroupData[{
Cell[10576450, 227327, 49, 0, 67, "ChapterTitle"],
Cell[CellGroupData[{
Cell[10576524, 227331, 53, 0, 67, "ExerciseSubsection"],
Cell[CellGroupData[{
Cell[10576602, 227335, 340, 6, 118, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:18"}],
Cell[10576945, 227343, 40991, 601, 264, "Figure",
 CellTags->"13.1 Exercises"],
Cell[10617939, 227946, 202, 6, 49, "ExerciseText",
 CellTags->"13.1 Exercises"]
}, Closed]],
Cell[10618156, 227955, 378, 11, 97, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:19"}],
Cell[10618537, 227968, 928, 29, 114, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:20"}],
Cell[10619468, 227999, 1358, 38, 216, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:21"}],
Cell[10620829, 228039, 194, 4, 81, "ExerciseItem",
 CellTags->"13.1 Exercises"],
Cell[10621026, 228045, 237, 6, 81, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:22"}],
Cell[10621266, 228053, 238, 5, 81, "ExerciseItem",
 CellTags->{"13.1 Exercises", "i:23"}],
Cell[CellGroupData[{
Cell[10621529, 228062, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[10621593, 228066, 283, 9, 45, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 2}},
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[10621901, 228079, 87, 2, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[10621991, 228083, 963, 18, 126, "Print",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[10622969, 228104, 523, 13, 112, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[10623495, 228119, 114, 2, 46, "InputOnly",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[10623634, 228125, 340, 9, 91, "Input",
 CellTags->"13.1 Solutions"],
Cell[10623977, 228136, 11742, 196, 136, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[10635756, 228337, 393, 10, 126, "Input",
 CellTags->"13.1 Solutions"],
Cell[10636152, 228349, 16949, 281, 204, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[10653116, 228633, 318, 10, 78, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[10653437, 228645, 1026, 29, 187, "InputOnly",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[10654488, 228678, 132, 3, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[10654623, 228683, 9135, 153, 171, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[10663795, 228841, 250, 6, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[10664048, 228849, 395401, 6485, 265, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[11059464, 235337, 205, 5, 78, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[11059672, 235344, 269, 8, 46, "InputOnly",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[11059966, 235356, 171, 5, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[11060140, 235363, 126, 3, 45, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[11060303, 235371, 169, 5, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[11060475, 235378, 123, 3, 45, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[11060647, 235387, 262, 5, 78, "SolutionItem",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[11060934, 235396, 158, 4, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[11061095, 235402, 614, 21, 45, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[11061724, 235426, 281, 10, 45, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[11062030, 235440, 155, 4, 55, "Input",
 CellTags->"13.1 Solutions"],
Cell[11062188, 235446, 515, 12, 45, "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[11062718, 235461, 113, 2, 45, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[11062834, 235465, 407, 11, 93, "Input",
 CellTags->"13.1 Solutions"],
Cell[11063244, 235478, 470, 15, 78, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[11063717, 235495, 93, 2, 46, "InputOnly",
 CellTags->"13.1 Solutions"],
Cell[CellGroupData[{
Cell[11063835, 235501, 434, 13, 126, "Input",
 CellTags->"13.1 Solutions"],
Cell[11064272, 235516, 488859, 10910, 180, 474632, 10675, "CachedBoxData", \
"BoxData", "Output",
 CellTags->"13.1 Solutions"]
}, Closed]],
Cell[11553146, 246429, 235, 5, 78, "SolutionText",
 CellTags->"13.1 Solutions"],
Cell[11553384, 246436, 1287, 36, 229, "Input",
 CellTags->"13.1 Solutions"],
Cell[11554674, 246474, 367, 10, 78, "SolutionText",
 CellTags->"13.1 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[11555102, 246491, 107, 1, 45, "ExerciseSubsection",
 CounterAssignments->{{"Section", 3}, {"ExerciseItem", 0}}],
Cell[CellGroupData[{
Cell[11555234, 246496, 1982, 73, 220, "ExerciseItem",
 CellTags->{"13.4 Exercises", "i:49"}],
Cell[CellGroupData[{
Cell[11557241, 246573, 585, 20, 76, "ExerciseSubItem",
 CellTags->"13.4 Exercises"],
Cell[CellGroupData[{
Cell[11557851, 246597, 119, 2, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11557973, 246601, 296, 6, 45, "ExerciseOutput",
 CellTags->"13.4 Exercises"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[11558318, 246613, 220, 6, 45, "ExerciseSubItem",
 CellTags->"13.4 Exercises"],
Cell[11558541, 246621, 224, 8, 49, "ExerciseText",
 CellTags->"13.4 Exercises"],
Cell[11558768, 246631, 226, 8, 49, "ExerciseText",
 CellTags->"13.4 Exercises"]
}, Closed]],
Cell[11559009, 246642, 328, 8, 69, "ExerciseSubItem",
 CellTags->"13.4 Exercises"],
Cell[CellGroupData[{
Cell[11559362, 246654, 934, 29, 162, "ExerciseSubItem",
 CellTags->"13.4 Exercises"],
Cell[11560299, 246685, 121, 3, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11560423, 246690, 107, 2, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[CellGroupData[{
Cell[11560555, 246696, 109, 2, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11560667, 246700, 362, 5, 126, "Print",
 CellTags->{"13.4 Exercises", "Info3560500981-5226863"}]
}, Closed]],
Cell[11561044, 246708, 183, 6, 49, "ExerciseText",
 CellTags->"13.4 Exercises"],
Cell[CellGroupData[{
Cell[11561252, 246718, 137, 3, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11561392, 246723, 271, 6, 48, "Message",
 CellTags->"13.4 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[11561700, 246734, 142, 3, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11561845, 246739, 508, 10, 48, "Message",
 CellTags->"13.4 Exercises"],
Cell[11562356, 246751, 143, 3, 45, "ExerciseOutput",
 CellTags->"13.4 Exercises"]
}, Closed]],
Cell[11562514, 246757, 148, 5, 49, "ExerciseText",
 CellTags->"13.4 Exercises"],
Cell[CellGroupData[{
Cell[11562687, 246766, 120, 2, 55, "ExerciseInput",
 CellTags->"13.4 Exercises"],
Cell[11562810, 246770, 1519, 22, 321, "ExerciseOutput",
 CellTags->"13.4 Exercises"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[11564368, 246797, 1391, 45, 223, "ExerciseItem",
 CellTags->{"i:48", "13.4 Exercises"}],
Cell[CellGroupData[{
Cell[11565784, 246846, 39, 0, 45, "SolutionSubsection"],
Cell[CellGroupData[{
Cell[11565848, 246850, 197, 6, 45, "SolutionItem",
 CounterAssignments->{{"SolutionItem", 0}},
 CellTags->"13.4 Solutions"],
Cell[11566048, 246858, 169, 5, 49, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11566220, 246865, 187, 6, 49, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[CellGroupData[{
Cell[11566432, 246875, 213, 7, 45, "SolutionSubItem",
 CellTags->"13.4 Solutions"],
Cell[11566648, 246884, 262, 7, 49, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[CellGroupData[{
Cell[11566935, 246895, 97, 2, 55, "Input",
 CellTags->"13.4 Solutions"],
Cell[11567035, 246899, 274, 6, 45, "Output",
 CellTags->"13.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[11567358, 246911, 269, 8, 78, "SolutionSubItem",
 CellTags->"13.4 Solutions"],
Cell[11567630, 246921, 308, 7, 151, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11567941, 246930, 219, 5, 78, "SolutionText",
 CellTags->"13.4 Solutions"],
Cell[11568163, 246937, 224, 6, 117, "InputOnly",
 CellTags->"13.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[11568424, 246948, 270, 9, 78, "SolutionSubItem",
 CellTags->"13.4 Solutions"],
Cell[11568697, 246959, 586, 17, 118, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11569286, 246978, 344, 8, 112, "SolutionText",
 CellTags->"13.4 Solutions"],
Cell[11569633, 246988, 441, 14, 118, "InputOnly",
 CellTags->"13.4 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[11570111, 247007, 679, 23, 147, "SolutionSubItem",
 CellTags->"13.4 Solutions"],
Cell[11570793, 247032, 85, 2, 46, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11570881, 247036, 138, 4, 46, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11571022, 247042, 308, 7, 151, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11571333, 247051, 224, 6, 117, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11571560, 247059, 549, 19, 147, "SolutionText",
 CellTags->"13.4 Solutions"],
Cell[11572112, 247080, 125, 3, 46, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11572240, 247085, 169, 5, 49, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11572412, 247092, 187, 6, 49, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11572602, 247100, 586, 17, 118, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11573191, 247119, 441, 14, 118, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11573635, 247135, 102, 3, 46, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11573740, 247140, 91, 2, 46, "InputOnly",
 CellTags->"13.4 Solutions"],
Cell[11573834, 247144, 1126, 33, 180, "SolutionText",
 CellTags->"13.4 Solutions"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
